/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(O){for(var t=[],T=0,D=O.length;T<D;T++)t[T]=ie[O[T]];return t};const We=this,Ce=typeof global=="object"?global:{};var fe;(function(O){O.global=We;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}O.Environment=t})(fe||(fe={}));var fe;(function(O){class t{constructor(f,N,h){this.type=f,this.detail=N,this.timestamp=h}}O.LoaderEvent=t;class T{constructor(f){this._events=[new t(1,"",f)]}record(f,N){this._events.push(new t(f,N,O.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}O.LoaderEventRecorder=T;class D{record(f,N){}getEvents(){return[]}}D.INSTANCE=new D,O.NullLoaderEventRecorder=D})(fe||(fe={}));var fe;(function(O){class t{static fileUriToFilePath(D,r){if(r=decodeURI(r).replace(/%23/g,"#"),D){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(D,r){return D.length>=r.length&&D.substr(0,r.length)===r}static endsWith(D,r){return D.length>=r.length&&D.substr(D.length-r.length)===r}static containsQueryString(D){return/^[^\#]*\?/gi.test(D)}static isAbsolutePath(D){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(D)}static forEachProperty(D,r){if(D){let f;for(f in D)D.hasOwnProperty(f)&&r(f,D[f])}}static isEmpty(D){let r=!0;return t.forEachProperty(D,()=>{r=!1}),r}static recursiveClone(D){if(!D||typeof D!="object"||D instanceof RegExp||!Array.isArray(D)&&Object.getPrototypeOf(D)!==Object.prototype)return D;let r=Array.isArray(D)?[]:{};return t.forEachProperty(D,(f,N)=>{N&&typeof N=="object"?r[f]=t.recursiveClone(N):r[f]=N}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(D){return t.startsWith(D,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,O.Utilities=t})(fe||(fe={}));var fe;(function(O){function t(r){if(r instanceof Error)return r;const f=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(f.stack=r.stack),f}O.ensureError=t;class T{static validateConfigurationOptions(f){function N(h){if(h.phase==="loading"){console.error('Loading "'+h.moduleId+'" failed'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}if(h.phase==="factory"){console.error('The factory function of "'+h.moduleId+'" has thrown an exception'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}}if(f=f||{},typeof f.baseUrl!="string"&&(f.baseUrl=""),typeof f.isBuild!="boolean"&&(f.isBuild=!1),typeof f.paths!="object"&&(f.paths={}),typeof f.config!="object"&&(f.config={}),typeof f.catchError>"u"&&(f.catchError=!1),typeof f.recordStats>"u"&&(f.recordStats=!1),typeof f.urlArgs!="string"&&(f.urlArgs=""),typeof f.onError!="function"&&(f.onError=N),Array.isArray(f.ignoreDuplicateModules)||(f.ignoreDuplicateModules=[]),f.baseUrl.length>0&&(O.Utilities.endsWith(f.baseUrl,"/")||(f.baseUrl+="/")),typeof f.cspNonce!="string"&&(f.cspNonce=""),typeof f.preferScriptTags>"u"&&(f.preferScriptTags=!1),f.nodeCachedData&&typeof f.nodeCachedData=="object"&&(typeof f.nodeCachedData.seed!="string"&&(f.nodeCachedData.seed="seed"),(typeof f.nodeCachedData.writeDelay!="number"||f.nodeCachedData.writeDelay<0)&&(f.nodeCachedData.writeDelay=1e3*7),!f.nodeCachedData.path||typeof f.nodeCachedData.path!="string")){const h=t(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",f.onError(h),f.nodeCachedData=void 0}return f}static mergeConfigurationOptions(f=null,N=null){let h=O.Utilities.recursiveClone(N||{});return O.Utilities.forEachProperty(f,(a,s)=>{a==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules<"u"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(s):a==="paths"&&typeof h.paths<"u"?O.Utilities.forEachProperty(s,(m,E)=>h.paths[m]=E):a==="config"&&typeof h.config<"u"?O.Utilities.forEachProperty(s,(m,E)=>h.config[m]=E):h[a]=O.Utilities.recursiveClone(s)}),T.validateConfigurationOptions(h)}}O.ConfigurationOptionsUtil=T;class D{constructor(f,N){if(this._env=f,this.options=T.mergeConfigurationOptions(N),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let h=this.options.nodeRequire.main.filename,a=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let f=0;f<this.options.ignoreDuplicateModules.length;f++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[f]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,(f,N)=>{Array.isArray(N)?this.sortedPathsRules.push({from:f,to:N}):this.sortedPathsRules.push({from:f,to:[N]})}),this.sortedPathsRules.sort((f,N)=>N.from.length-f.from.length)}cloneAndMerge(f){return new D(this._env,T.mergeConfigurationOptions(f,this.options))}getOptionsLiteral(){return this.options}_applyPaths(f){let N;for(let h=0,a=this.sortedPathsRules.length;h<a;h++)if(N=this.sortedPathsRules[h],O.Utilities.startsWith(f,N.from)){let s=[];for(let m=0,E=N.to.length;m<E;m++)s.push(N.to[m]+f.substr(N.from.length));return s}return[f]}_addUrlArgsToUrl(f){return O.Utilities.containsQueryString(f)?f+"&"+this.options.urlArgs:f+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(f){return this.options.urlArgs?this._addUrlArgsToUrl(f):f}_addUrlArgsIfNecessaryToUrls(f){if(this.options.urlArgs)for(let N=0,h=f.length;N<h;N++)f[N]=this._addUrlArgsToUrl(f[N]);return f}moduleIdToPaths(f){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(f))return this.isBuild()?["empty:"]:["node|"+f];let N=f,h;if(!O.Utilities.endsWith(N,".js")&&!O.Utilities.isAbsolutePath(N)){h=this._applyPaths(N);for(let a=0,s=h.length;a<s;a++)this.isBuild()&&h[a]==="empty:"||(O.Utilities.isAbsolutePath(h[a])||(h[a]=this.options.baseUrl+h[a]),!O.Utilities.endsWith(h[a],".js")&&!O.Utilities.containsQueryString(h[a])&&(h[a]=h[a]+".js"))}else!O.Utilities.endsWith(N,".js")&&!O.Utilities.containsQueryString(N)&&(N=N+".js"),h=[N];return this._addUrlArgsIfNecessaryToUrls(h)}requireToUrl(f){let N=f;return O.Utilities.isAbsolutePath(N)||(N=this._applyPaths(N)[0],O.Utilities.isAbsolutePath(N)||(N=this.options.baseUrl+N)),this._addUrlArgsIfNecessaryToUrl(N)}isBuild(){return this.options.isBuild}shouldInvokeFactory(f){return!!(!this.options.isBuild||O.Utilities.isAnonymousModule(f)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[f])}isDuplicateMessageIgnoredFor(f){return this.ignoreDuplicateModulesMap.hasOwnProperty(f)}getConfigForModule(f){if(this.options.config)return this.options.config[f]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(f){this.options.onError(f)}}O.Configuration=D})(fe||(fe={}));var fe;(function(O){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,m,E,$){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new T:this._scriptLoader=new f(this._env)}else this._env.isNode?this._scriptLoader=new f(this._env):this._scriptLoader=new T;let b={callback:E,errorback:$};if(this._callbackMap.hasOwnProperty(m)){this._callbackMap[m].push(b);return}this._callbackMap[m]=[b],this._scriptLoader.load(s,m,()=>this.triggerCallback(m),e=>this.triggerErrorback(m,e))}triggerCallback(s){let m=this._callbackMap[s];delete this._callbackMap[s];for(let E=0;E<m.length;E++)m[E].callback()}triggerErrorback(s,m){let E=this._callbackMap[s];delete this._callbackMap[s];for(let $=0;$<E.length;$++)E[$].errorback(m)}}class T{attachListeners(s,m,E){let $=()=>{s.removeEventListener("load",b),s.removeEventListener("error",e)},b=v=>{$(),m()},e=v=>{$(),E(v)};s.addEventListener("load",b),s.addEventListener("error",e)}load(s,m,E,$){if(/^node\|/.test(m)){let b=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),b.nodeRequire||O.global.nodeRequire),v=m.split("|"),R=null;try{R=e(v[1])}catch(L){$(L);return}s.enqueueDefineAnonymousModule([],()=>R),E()}else{let b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript"),this.attachListeners(b,E,$);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(m=e.createScriptURL(m)),b.setAttribute("src",m);const{cspNonce:v}=s.getConfig().getOptionsLiteral();v&&b.setAttribute("nonce",v),document.getElementsByTagName("head")[0].appendChild(b)}}}function D(a){const{trustedTypesPolicy:s}=a.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=D(s)),this._cachedCanUseEval}load(s,m,E,$){if(/^node\|/.test(m)){const b=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),b.nodeRequire||O.global.nodeRequire),v=m.split("|");let R=null;try{R=e(v[1])}catch(L){$(L);return}s.enqueueDefineAnonymousModule([],function(){return R}),E()}else{const{trustedTypesPolicy:b}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(m)&&m.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(m).then(v=>{if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(v=>{v=`${v}
//# sourceURL=${m}`,(b?self.eval(b.createScript("",v)):new Function(v)).call(self),E()}).then(void 0,$);return}try{b&&(m=b.createScriptURL(m)),importScripts(m),E()}catch(v){$(v)}}}}class f{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,m){const{nodeCachedData:E}=m.getConfig().getOptionsLiteral();if(!E||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const $=this,b=s("module");function e(v){const R=v.constructor;let L=function(l){try{return v.require(l)}finally{}};return L.resolve=function(l,o){return R._resolveFilename(l,v,!1,o)},L.resolve.paths=function(l){return R._resolveLookupPaths(l,v)},L.main=process.mainModule,L.extensions=R._extensions,L.cache=R._cache,L}b.prototype._compile=function(v,R){const L=b.wrap(v.replace(/^#!.*/,"")),d=m.getRecorder(),l=$._getCachedDataPath(E,R),o={filename:R};let u;try{const p=$._fs.readFileSync(l);u=p.slice(0,16),o.cachedData=p.slice(16),d.record(60,l)}catch{d.record(61,l)}const i=new $._vm.Script(L,o),c=i.runInThisContext(o),A=$._path.dirname(R),g=e(this),w=[this.exports,g,this,R,A,process,Ce,Buffer],M=c.apply(this.exports,w);return $._handleCachedData(i,L,l,!o.cachedData,m),$._verifyCachedData(i,L,l,u,m),M}}load(s,m,E,$){const b=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),b.nodeRequire||O.global.nodeRequire),v=b.nodeInstrumenter||function(L){return L};this._init(e),this._initNodeRequire(e,s);let R=s.getRecorder();if(/^node\|/.test(m)){let L=m.split("|"),d=null;try{d=e(L[1])}catch(l){$(l);return}s.enqueueDefineAnonymousModule([],()=>d),E()}else{m=O.Utilities.fileUriToFilePath(this._env.isWindows,m);const L=this._path.normalize(m),d=this._getElectronRendererScriptPathOrUri(L),l=!!b.nodeCachedData,o=l?this._getCachedDataPath(b.nodeCachedData,m):void 0;this._readSourceAndCachedData(L,o,R,(u,i,c,A)=>{if(u){$(u);return}let g;i.charCodeAt(0)===f._BOM?g=f._PREFIX+i.substring(1)+f._SUFFIX:g=f._PREFIX+i+f._SUFFIX,g=v(g,L);const w={filename:d,cachedData:c},M=this._createAndEvalScript(s,g,w,E,$);this._handleCachedData(M,g,o,l&&!c,s),this._verifyCachedData(M,g,o,A,s)})}}_createAndEvalScript(s,m,E,$,b){const e=s.getRecorder();e.record(31,E.filename);const v=new this._vm.Script(m,E),R=v.runInThisContext(E),L=s.getGlobalAMDDefineFunc();let d=!1;const l=function(){return d=!0,L.apply(null,arguments)};return l.amd=L.amd,R.call(O.global,s.getGlobalAMDRequireFunc(),l,E.filename,this._path.dirname(E.filename)),e.record(32,E.filename),d?$():b(new Error(`Didn't receive define call in ${E.filename}!`)),v}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let m=s.match(/^([a-z])\:(.*)/i);return m?`file:///${(m[1].toUpperCase()+":"+m[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,m){const E=this._crypto.createHash("md5").update(m,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),$=this._path.basename(m).replace(/\.js$/,"");return this._path.join(s.path,`${$}-${E}.code`)}_handleCachedData(s,m,E,$,b){s.cachedDataRejected?this._fs.unlink(E,e=>{b.getRecorder().record(62,E),this._createAndWriteCachedData(s,m,E,b),e&&b.getConfig().onError(e)}):$&&this._createAndWriteCachedData(s,m,E,b)}_createAndWriteCachedData(s,m,E,$){let b=Math.ceil($.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,v=0,R;const L=()=>{setTimeout(()=>{R||(R=this._crypto.createHash("md5").update(m,"utf8").digest());const d=s.createCachedData();if(!(d.length===0||d.length===e||v>=5)){if(d.length<e){L();return}e=d.length,this._fs.writeFile(E,Buffer.concat([R,d]),l=>{l&&$.getConfig().onError(l),$.getRecorder().record(63,E),L()})}},b*Math.pow(4,v++))};L()}_readSourceAndCachedData(s,m,E,$){if(!m)this._fs.readFile(s,{encoding:"utf8"},$);else{let b,e,v,R=2;const L=d=>{d?$(d):--R===0&&$(void 0,b,e,v)};this._fs.readFile(s,{encoding:"utf8"},(d,l)=>{b=l,L(d)}),this._fs.readFile(m,(d,l)=>{!d&&l&&l.length>0?(v=l.slice(0,16),e=l.slice(16),E.record(60,m)):E.record(61,m),L()})}}_verifyCachedData(s,m,E,$,b){$&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(m,"utf8").digest();$.equals(e)||(b.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${E}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(E,v=>{v&&b.getConfig().onError(v)}))},Math.ceil(5e3*(1+Math.random()))))}}f._BOM=65279,f._PREFIX="(function (require, define, __filename, __dirname) { ",f._SUFFIX=`
});`;function N(a,s){if(s.__$__isRecorded)return s;const m=function($){a.record(33,$);try{return s($)}finally{a.record(34,$)}};return m.__$__isRecorded=!0,m}O.ensureRecordedNodeRequire=N;function h(a){return new t(a)}O.createScriptLoader=h})(fe||(fe={}));var fe;(function(O){class t{constructor(a){let s=a.lastIndexOf("/");s!==-1?this.fromModulePath=a.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(a){let s=a,m;for(m=/\/\.\//;m.test(s);)s=s.replace(m,"/");for(s=s.replace(/^\.\//g,""),m=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;m.test(s);)s=s.replace(m,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(a){let s=a;return O.Utilities.isAbsolutePath(s)||(O.Utilities.startsWith(s,"./")||O.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),O.ModuleIdResolver=t;class T{constructor(a,s,m,E,$,b){this.id=a,this.strId=s,this.dependencies=m,this._callback=E,this._errorback=$,this.moduleIdResolver=b,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,s){try{return{returnedValue:a.apply(O.global,s),producedError:null}}catch(m){return{returnedValue:null,producedError:m}}}static _invokeFactory(a,s,m,E){return a.shouldInvokeFactory(s)?a.shouldCatchError()?this._safeInvokeFunction(m,E):{returnedValue:m.apply(O.global,E),producedError:null}:{returnedValue:null,producedError:null}}complete(a,s,m,E){this._isComplete=!0;let $=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let b=T._invokeFactory(s,this.strId,this._callback,m);$=b.producedError,a.record(22,this.strId),!$&&typeof b.returnedValue<"u"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=b.returnedValue)}else this.exports=this._callback;if($){let b=O.ensureError($);b.phase="factory",b.moduleId=this.strId,b.neededBy=E(this.id),this.error=b,s.onError(b)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}O.Module=T;class D{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let s=this._strModuleIdToIntModuleId.get(a);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(a,s),this._intModuleIdToStrModuleId[s]=a),s}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class r{constructor(a){this.id=a}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),O.RegularDependency=r;class f{constructor(a,s,m){this.id=a,this.pluginId=s,this.pluginParam=m}}O.PluginDependency=f;class N{constructor(a,s,m,E,$=0){this._env=a,this._scriptLoader=s,this._loaderAvailableTimestamp=$,this._defineFunc=m,this._requireFunc=E,this._moduleIdProvider=new D,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new N(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,s){let m=b=>b.replace(/\\/g,"/"),E=m(a),$=s.split(/\n/);for(let b=0;b<$.length;b++){let e=$[b].match(/(.*):(\d+):(\d+)\)?$/);if(e){let v=e[1],R=e[2],L=e[3],d=Math.max(v.lastIndexOf(" ")+1,v.lastIndexOf("(")+1);if(v=v.substr(d),v=m(v),v===E){let l={line:parseInt(R,10),col:parseInt(L,10)};return l.line===1&&(l.col-=53),l}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],s=0;for(let m=0,E=this._modules2.length;m<E;m++){let $=this._modules2[m];if(!$)continue;let b=this._buildInfoPath[$.id]||null,e=this._buildInfoDefineStack[$.id]||null,v=this._buildInfoDependencies[$.id];a[s++]={id:$.strId,path:b,defineLocation:b&&e?N._findRelevantLocationInStack(b,e):null,dependencies:v,shim:null,exports:$.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let m=null;this._config.isBuild()&&(m=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:m,dependencies:a,callback:s}}defineModule(a,s,m,E,$,b=new t(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let v=new T(e,a,this._normalizeDependencies(s,b),m,E,b);this._modules2[e]=v,this._config.isBuild()&&(this._buildInfoDefineStack[e]=$,this._buildInfoDependencies[e]=(v.dependencies||[]).map(R=>this._moduleIdProvider.getStrModuleId(R.id))),this._resolve(v)}_normalizeDependency(a,s){if(a==="exports")return r.EXPORTS;if(a==="module")return r.MODULE;if(a==="require")return r.REQUIRE;let m=a.indexOf("!");if(m>=0){let E=s.resolveModule(a.substr(0,m)),$=s.resolveModule(a.substr(m+1)),b=this._moduleIdProvider.getModuleId(E+"!"+$),e=this._moduleIdProvider.getModuleId(E);return new f(b,e,$)}return new r(this._moduleIdProvider.getModuleId(s.resolveModule(a)))}_normalizeDependencies(a,s){let m=[],E=0;for(let $=0,b=a.length;$<b;$++)m[E++]=this._normalizeDependency(a[$],s);return m}_relativeRequire(a,s,m,E){if(typeof s=="string")return this.synchronousRequire(s,a);this.defineModule(O.Utilities.generateAnonymousModule(),s,m,E,null,a)}synchronousRequire(a,s=new t(a)){let m=this._normalizeDependency(a,s),E=this._modules2[m.id];if(!E)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!E.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(E.error)throw E.error;return E.exports}configure(a,s){let m=this._config.shouldRecordStats();s?this._config=new O.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!m&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),s.dependencies,s.callback,null,s.stack)}}_createLoadError(a,s){let m=this._moduleIdProvider.getStrModuleId(a),E=(this._inverseDependencies2[a]||[]).map(b=>this._moduleIdProvider.getStrModuleId(b));const $=O.ensureError(s);return $.phase="loading",$.moduleId=m,$.neededBy=E,$}_onLoadError(a,s){const m=this._createLoadError(a,s);this._modules2[a]||(this._modules2[a]=new T(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let E=[];for(let e=0,v=this._moduleIdProvider.getMaxModuleId();e<v;e++)E[e]=!1;let $=!1,b=[];for(b.push(a),E[a]=!0;b.length>0;){let e=b.shift(),v=this._modules2[e];v&&($=v.onDependencyError(m)||$);let R=this._inverseDependencies2[e];if(R)for(let L=0,d=R.length;L<d;L++){let l=R[L];E[l]||(b.push(l),E[l]=!0)}}$||this._config.onError(m)}_hasDependencyPath(a,s){let m=this._modules2[a];if(!m)return!1;let E=[];for(let b=0,e=this._moduleIdProvider.getMaxModuleId();b<e;b++)E[b]=!1;let $=[];for($.push(m),E[a]=!0;$.length>0;){let e=$.shift().dependencies;if(e)for(let v=0,R=e.length;v<R;v++){let L=e[v];if(L.id===s)return!0;let d=this._modules2[L.id];d&&!E[L.id]&&(E[L.id]=!0,$.push(d))}}return!1}_findCyclePath(a,s,m){if(a===s||m===50)return[a];let E=this._modules2[a];if(!E)return null;let $=E.dependencies;if($)for(let b=0,e=$.length;b<e;b++){let v=this._findCyclePath($[b].id,s,m+1);if(v!==null)return v.push(a),v}return null}_createRequire(a){let s=(m,E,$)=>this._relativeRequire(a,m,E,$);return s.toUrl=m=>this._config.requireToUrl(a.resolveModule(m)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(m,E=!1)=>{this.configure(m,E)},s.__$__nodeRequire=O.global.nodeRequire,s}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let s=this._moduleIdProvider.getStrModuleId(a),m=this._config.moduleIdToPaths(s),E=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||E.test(s))&&m.push("node|"+s);let $=-1,b=e=>{if($++,$>=m.length)this._onLoadError(a,e);else{let v=m[$],R=this.getRecorder();if(this._config.isBuild()&&v==="empty:"){this._buildInfoPath[a]=v,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}R.record(10,v),this._scriptLoader.load(this,v,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=v),R.record(11,v),this._onLoad(a)},L=>{R.record(12,v),b(L)})}};b(null)}_loadPluginDependency(a,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let m=E=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],E,null,null)};m.error=E=>{this._config.onError(this._createLoadError(s.id,E))},a.load(s.pluginParam,this._createRequire(t.ROOT),m,this._config.getOptionsLiteral())}_resolve(a){let s=a.dependencies;if(s)for(let m=0,E=s.length;m<E;m++){let $=s[m];if($===r.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if($===r.MODULE){a.unresolvedDependenciesCount--;continue}if($===r.REQUIRE){a.unresolvedDependenciesCount--;continue}let b=this._modules2[$.id];if(b&&b.isComplete()){if(b.error){a.onDependencyError(b.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath($.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId($.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath($.id,a.id,0)||[];e.reverse(),e.push($.id),console.warn(e.map(v=>this._moduleIdProvider.getStrModuleId(v)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[$.id]=this._inverseDependencies2[$.id]||[],this._inverseDependencies2[$.id].push(a.id),$ instanceof f){let e=this._modules2[$.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,$);continue}let v=this._inversePluginDependencies2.get($.pluginId);v||(v=[],this._inversePluginDependencies2.set($.pluginId,v)),v.push($),this._loadModule($.pluginId);continue}this._loadModule($.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let s=this.getRecorder();if(a.isComplete())return;let m=a.dependencies,E=[];if(m)for(let v=0,R=m.length;v<R;v++){let L=m[v];if(L===r.EXPORTS){E[v]=a.exports;continue}if(L===r.MODULE){E[v]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(L===r.REQUIRE){E[v]=this._createRequire(a.moduleIdResolver);continue}let d=this._modules2[L.id];if(d){E[v]=d.exports;continue}E[v]=null}const $=v=>(this._inverseDependencies2[v]||[]).map(R=>this._moduleIdProvider.getStrModuleId(R));a.complete(s,this._config,E,$);let b=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,b)for(let v=0,R=b.length;v<R;v++){let L=b[v],d=this._modules2[L];d.unresolvedDependenciesCount--,d.unresolvedDependenciesCount===0&&this._onModuleComplete(d)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let v=0,R=e.length;v<R;v++)this._loadPluginDependency(a.exports,e[v])}}}O.ModuleManager=N})(fe||(fe={}));var ne,fe;(function(O){const t=new O.Environment;let T=null;const D=function(h,a,s){typeof h!="string"&&(s=a,a=h,h=null),(typeof a!="object"||!Array.isArray(a))&&(s=a,a=null),a||(a=["require","exports","module"]),h?T.defineModule(h,a,s,null,null):T.enqueueDefineAnonymousModule(a,s)};D.amd={jQuery:!0};const r=function(h,a=!1){T.configure(h,a)},f=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return T.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){T.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};f.config=r,f.getConfig=function(){return T.getConfig().getOptionsLiteral()},f.reset=function(){T=T.reset()},f.getBuildInfo=function(){return T.getBuildInfo()},f.getStats=function(){return T.getLoaderEvents()},f.define=D;function N(){if(typeof O.global.require<"u"||typeof require<"u"){const h=O.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){const a=O.ensureRecordedNodeRequire(T.getRecorder(),h);O.global.nodeRequire=a,f.nodeRequire=a,f.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=f:(t.isElectronRenderer||(O.global.define=D),O.global.require=f)}O.init=N,(typeof O.global.define!="function"||!O.global.define.amd)&&(T=new O.ModuleManager(t,O.createScriptLoader(t),D,f,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require<"u"&&typeof O.global.require!="function"&&f.config(O.global.require),ne=function(){return D.apply(null,arguments)},ne.amd=D.amd,typeof doNotInitLoader>"u"&&N())})(fe||(fe={})),ne(ie[69],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function T(h,a,s,m){if(m=m||{},(m["vs/css"]||{}).disabled){s({});return}const $=a.toUrl(h+".css");D(h,$,()=>{s({})},b=>{typeof s.error=="function"&&s.error("Could not find "+$+".")})}t.load=T;function D(h,a,s,m){if(r(h,a)){s();return}f(h,a,s,m)}function r(h,a){const s=window.document.getElementsByTagName("link");for(let m=0,E=s.length;m<E;m++){const $=s[m].getAttribute("data-name"),b=s[m].getAttribute("href");if($===h||b===a)return!0}return!1}function f(h,a,s,m){const E=document.createElement("link");E.setAttribute("rel","stylesheet"),E.setAttribute("type","text/css"),E.setAttribute("data-name",h),N(h,E,s,m),E.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(E)}function N(h,a,s,m){const E=()=>{a.removeEventListener("load",$),a.removeEventListener("error",b)},$=e=>{E(),s()},b=e=>{E(),m(e)};a.addEventListener("load",$),a.addEventListener("error",b)}}),ne("vs/nls",["require","exports"],function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize2=t.localize=void 0;let T=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const D="i-default";function r(R,L){let d;return L.length===0?d=R:d=R.replace(/\{(\d+)\}/g,(l,o)=>{const u=o[0],i=L[u];let c=l;return typeof i=="string"?c=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(c=String(i)),c}),T&&(d="\uFF3B"+d.replace(/[aouei]/g,"$&$&")+"\uFF3D"),d}function f(R,L){let d=R[L];return d||(d=R["*"],d)?d:null}function N(R){return R.charAt(R.length-1)==="/"?R:R+"/"}async function h(R,L,d){const l=N(R)+N(L)+"vscode/"+N(d),o=await fetch(l);if(o.ok)return await o.json();throw new Error(`${o.status} - ${o.statusText}`)}function a(R){return function(L,d){const l=Array.prototype.slice.call(arguments,2);return r(R[L],l)}}function s(R){return(L,d,...l)=>({value:r(R[L],l),original:r(d,l)})}function m(R,L,...d){return r(L,d)}t.localize=m;function E(R,L,...d){const l=r(L,d);return{value:l,original:l}}t.localize2=E;function $(R){}t.getConfiguredDefaultLocale=$;function b(R){T=R}t.setPseudoTranslation=b;function e(R,L){return{localize:a(L[R]),localize2:s(L[R]),getConfiguredDefaultLocale:L.getConfiguredDefaultLocale??(d=>{})}}t.create=e;function v(R,L,d,l){const o=l["vs/nls"]??{};if(!R||R.length===0)return d({localize:m,localize2:E,getConfiguredDefaultLocale:()=>o.availableLanguages?.["*"]});const u=o.availableLanguages?f(o.availableLanguages,R):null,i=u===null||u===D;let c=".nls";i||(c=c+"."+u);const A=g=>{Array.isArray(g)?(g.localize=a(g),g.localize2=s(g)):(g.localize=a(g[R]),g.localize2=s(g[R])),g.getConfiguredDefaultLocale=()=>o.availableLanguages?.["*"],d(g)};typeof o.loadBundle=="function"?o.loadBundle(R,u,(g,w)=>{g?L([R+".nls"],A):A(w)}):o.translationServiceUrl&&!i?(async()=>{try{const g=await h(o.translationServiceUrl,u,R);return A(g)}catch(g){if(!u.includes("-"))return console.error(g),L([R+".nls"],A);try{const w=u.split("-")[0],M=await h(o.translationServiceUrl,w,R);return o.availableLanguages??={},o.availableLanguages["*"]=w,A(M)}catch(w){return console.error(w),L([R+".nls"],A)}}})():L([R+c],A,g=>{if(c===".nls"){console.error("Failed trying to load default language strings",g);return}console.error(`Failed to load message bundle for language ${u}. Falling back to the default language:`,g),L([R+".nls"],A)})}t.load=v}),function(){const O=globalThis.MonacoEnvironment,t=O&&O.baseUrl?O.baseUrl:"../../../";function T(m,E){if(O?.createTrustedTypesPolicy)try{return O.createTrustedTypesPolicy(m,E)}catch($){console.warn($);return}try{return self.trustedTypes?.createPolicy(m,E)}catch($){console.warn($);return}}const D=T("amdLoader",{createScriptURL:m=>m,createScript:(m,...E)=>{const $=E.slice(0,-1).join(","),b=E.pop().toString();return`(function anonymous(${$}) { ${b}
})`}});function r(){try{return(D?globalThis.eval(D.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function f(){return new Promise((m,E)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return m();const $=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test($)&&$.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch($).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${$}`,(D?globalThis.eval(D.createScript("",e)):new Function(e)).call(globalThis),m()}).then(void 0,E);return}D?importScripts(D.createScriptURL($)):importScripts($),m()})}function N(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//})}function h(m){f().then(()=>{N(),require([m],function(E){setTimeout(function(){const $=E.create((b,e)=>{globalThis.postMessage(b,e)},null);for(globalThis.onmessage=b=>$.onmessage(b.data,b.ports);s.length>0;){const b=s.shift();$.onmessage(b.data,b.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&N();let a=!0;const s=[];globalThis.onmessage=m=>{if(!a){s.push(m);return}a=!1,h(m.data)}}(),ne(ie[9],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=void 0;function T(v,R,L){const d=D(v,R);if(d!==-1)return v[d]}t.$eb=T;function D(v,R,L=v.length-1){for(let d=L;d>=0;d--){const l=v[d];if(R(l))return d}return-1}t.$fb=D;function r(v,R){const L=f(v,R);return L===-1?void 0:v[L]}t.$gb=r;function f(v,R,L=0,d=v.length){let l=L,o=d;for(;l<o;){const u=Math.floor((l+o)/2);R(v[u])?l=u+1:o=u}return l-1}t.$hb=f;function N(v,R){const L=h(v,R);return L===v.length?void 0:v[L]}t.$ib=N;function h(v,R,L=0,d=v.length){let l=L,o=d;for(;l<o;){const u=Math.floor((l+o)/2);R(v[u])?o=u:l=u+1}return l}t.$jb=h;function a(v,R,L=0,d=v.length){const l=h(v,R,L,d);return l===v.length?-1:l}t.$kb=a;class s{static{this.assertInvariants=!1}constructor(R){this.e=R,this.c=0}findLastMonotonous(R){if(s.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!R(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=R}const L=f(this.e,R,this.c);return this.c=L+1,L===-1?void 0:this.e[L]}}t.$lb=s;function m(v,R){if(v.length===0)return;let L=v[0];for(let d=1;d<v.length;d++){const l=v[d];R(l,L)>0&&(L=l)}return L}t.$mb=m;function E(v,R){if(v.length===0)return;let L=v[0];for(let d=1;d<v.length;d++){const l=v[d];R(l,L)>=0&&(L=l)}return L}t.$nb=E;function $(v,R){return m(v,(L,d)=>-R(L,d))}t.$ob=$;function b(v,R){if(v.length===0)return-1;let L=0;for(let d=1;d<v.length;d++){const l=v[d];R(l,v[L])>0&&(L=d)}return L}t.$pb=b;function e(v,R){for(const L of v){const d=R(L);if(d!==void 0)return d}}t.$qb=e}),ne(ie[34],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$M=t.$L=t.$K=t.$J=void 0;function T(N,h){const a=Object.create(null);for(const s of N){const m=h(s);let E=a[m];E||(E=a[m]=[]),E.push(s)}return a}t.$J=T;function D(N,h){const a=[],s=[];for(const m of N)h.has(m)||a.push(m);for(const m of h)N.has(m)||s.push(m);return{removed:a,added:s}}t.$K=D;function r(N,h){const a=[],s=[];for(const[m,E]of N)h.has(m)||a.push(E);for(const[m,E]of h)N.has(m)||s.push(E);return{removed:a,added:s}}t.$L=r;function f(N,h){const a=new Set;for(const s of h)N.has(s)&&a.add(s);return a}t.$M=f}),ne(ie[35],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1s=t.$Zs=t.$Ys=t.$Xs=void 0;function T(h,a){const s=Math.pow(10,a);return Math.round(h*s)/s}class D{constructor(a,s,m,E=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,m))|0,this.a=T(Math.max(Math.min(1,E),0),3)}static equals(a,s){return a.r===s.r&&a.g===s.g&&a.b===s.b&&a.a===s.a}}t.$Xs=D;class r{constructor(a,s,m,E){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=T(Math.max(Math.min(1,s),0),3),this.l=T(Math.max(Math.min(1,m),0),3),this.a=T(Math.max(Math.min(1,E),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.l===s.l&&a.a===s.a}static fromRGBA(a){const s=a.r/255,m=a.g/255,E=a.b/255,$=a.a,b=Math.max(s,m,E),e=Math.min(s,m,E);let v=0,R=0;const L=(e+b)/2,d=b-e;if(d>0){switch(R=Math.min(L<=.5?d/(2*L):d/(2-2*L),1),b){case s:v=(m-E)/d+(m<E?6:0);break;case m:v=(E-s)/d+2;break;case E:v=(s-m)/d+4;break}v*=60,v=Math.round(v)}return new r(v,R,L,$)}static i(a,s,m){return m<0&&(m+=1),m>1&&(m-=1),m<1/6?a+(s-a)*6*m:m<1/2?s:m<2/3?a+(s-a)*(2/3-m)*6:a}static toRGBA(a){const s=a.h/360,{s:m,l:E,a:$}=a;let b,e,v;if(m===0)b=e=v=E;else{const R=E<.5?E*(1+m):E+m-E*m,L=2*E-R;b=r.i(L,R,s+1/3),e=r.i(L,R,s),v=r.i(L,R,s-1/3)}return new D(Math.round(b*255),Math.round(e*255),Math.round(v*255),$)}}t.$Ys=r;class f{constructor(a,s,m,E){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=T(Math.max(Math.min(1,s),0),3),this.v=T(Math.max(Math.min(1,m),0),3),this.a=T(Math.max(Math.min(1,E),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.v===s.v&&a.a===s.a}static fromRGBA(a){const s=a.r/255,m=a.g/255,E=a.b/255,$=Math.max(s,m,E),b=Math.min(s,m,E),e=$-b,v=$===0?0:e/$;let R;return e===0?R=0:$===s?R=((m-E)/e%6+6)%6:$===m?R=(E-s)/e+2:R=(s-m)/e+4,new f(Math.round(R*60),v,$,a.a)}static toRGBA(a){const{h:s,s:m,v:E,a:$}=a,b=E*m,e=b*(1-Math.abs(s/60%2-1)),v=E-b;let[R,L,d]=[0,0,0];return s<60?(R=b,L=e):s<120?(R=e,L=b):s<180?(L=b,d=e):s<240?(L=e,d=b):s<300?(R=e,d=b):s<=360&&(R=b,d=e),R=Math.round((R+v)*255),L=Math.round((L+v)*255),d=Math.round((d+v)*255),new D(R,L,d,$)}}t.$Zs=f;class N{static fromHex(a){return N.Format.CSS.parseHex(a)||N.red}static equals(a,s){return!a&&!s?!0:!a||!s?!1:a.equals(s)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:f.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof D)this.rgba=a;else if(a instanceof r)this.i=a,this.rgba=r.toRGBA(a);else if(a instanceof f)this.j=a,this.rgba=f.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&D.equals(this.rgba,a.rgba)&&r.equals(this.hsla,a.hsla)&&f.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=N.k(this.rgba.r),s=N.k(this.rgba.g),m=N.k(this.rgba.b),E=.2126*a+.7152*s+.0722*m;return T(E,4)}static k(a){const s=a/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(a){const s=this.getRelativeLuminance(),m=a.getRelativeLuminance();return s>m?(s+.05)/(m+.05):(m+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const s=this.getRelativeLuminance(),m=a.getRelativeLuminance();return s>m}isDarkerThan(a){const s=this.getRelativeLuminance(),m=a.getRelativeLuminance();return s<m}lighten(a){return new N(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new N(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:s,g:m,b:E,a:$}=this.rgba;return new N(new D(s,m,E,$*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new N(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const s=a.rgba,m=this.rgba.a,E=s.a,$=m+E*(1-m);if($<1e-6)return N.transparent;const b=this.rgba.r*m/$+s.r*E*(1-m)/$,e=this.rgba.g*m/$+s.g*E*(1-m)/$,v=this.rgba.b*m/$+s.b*E*(1-m)/$;return new N(new D(b,e,v,$))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:s,g:m,b:E,a:$}=this.rgba;return new N(new D(a.rgba.r-$*(a.rgba.r-s),a.rgba.g-$*(a.rgba.g-m),a.rgba.b-$*(a.rgba.b-E),1))}flatten(...a){const s=a.reduceRight((m,E)=>N.o(E,m));return N.o(this,s)}static o(a,s){const m=1-a.rgba.a;return new N(new D(m*s.rgba.r+a.rgba.a*a.rgba.r,m*s.rgba.g+a.rgba.a*a.rgba.g,m*s.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=N.Format.CSS.format(this)),this.u}static getLighterColor(a,s,m){if(a.isLighterThan(s))return a;m=m||.5;const E=a.getRelativeLuminance(),$=s.getRelativeLuminance();return m=m*($-E)/$,a.lighten(m)}static getDarkerColor(a,s,m){if(a.isDarkerThan(s))return a;m=m||.5;const E=a.getRelativeLuminance(),$=s.getRelativeLuminance();return m=m*(E-$)/E,a.darken(m)}static{this.white=new N(new D(255,255,255,1))}static{this.black=new N(new D(0,0,0,1))}static{this.red=new N(new D(255,0,0,1))}static{this.blue=new N(new D(0,0,255,1))}static{this.green=new N(new D(0,255,0,1))}static{this.cyan=new N(new D(0,255,255,1))}static{this.lightgrey=new N(new D(211,211,211,1))}static{this.transparent=new N(new D(0,0,0,0))}}t.$1s=N,function(h){let a;(function(s){let m;(function(E){function $(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:h.Format.CSS.formatRGBA(i)}E.formatRGB=$;function b(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}E.formatRGBA=b;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:h.Format.CSS.formatHSLA(i)}E.formatHSL=e;function v(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}E.formatHSLA=v;function R(i){const c=i.toString(16);return c.length!==2?"0"+c:c}function L(i){return`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}`}E.formatHex=L;function d(i,c=!1){return c&&i.rgba.a===1?h.Format.CSS.formatHex(i):`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}${R(Math.round(i.rgba.a*255))}`}E.formatHexA=d;function l(i){return i.isOpaque()?h.Format.CSS.formatHex(i):h.Format.CSS.formatRGBA(i)}E.format=l;function o(i){const c=i.length;if(c===0||i.charCodeAt(0)!==35)return null;if(c===7){const A=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),g=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),w=16*u(i.charCodeAt(5))+u(i.charCodeAt(6));return new h(new D(A,g,w,1))}if(c===9){const A=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),g=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),w=16*u(i.charCodeAt(5))+u(i.charCodeAt(6)),M=16*u(i.charCodeAt(7))+u(i.charCodeAt(8));return new h(new D(A,g,w,M/255))}if(c===4){const A=u(i.charCodeAt(1)),g=u(i.charCodeAt(2)),w=u(i.charCodeAt(3));return new h(new D(16*A+A,16*g+g,16*w+w))}if(c===5){const A=u(i.charCodeAt(1)),g=u(i.charCodeAt(2)),w=u(i.charCodeAt(3)),M=u(i.charCodeAt(4));return new h(new D(16*A+A,16*g+g,16*w+w,(16*M+M)/255))}return null}E.parseHex=o;function u(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(m=s.CSS||(s.CSS={}))})(a=h.Format||(h.Format={}))}(N||(t.$1s=N={}))}),ne(ie[36],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zs=void 0;class T{constructor(r,f,N,h){this.originalStart=r,this.originalLength=f,this.modifiedStart=N,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$zs=T}),ne(ie[3],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.setUnexpectedErrorHandler=t.$W=t.$V=void 0;class T{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?l.isErrorNoTelemetry(i)?new l(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(c=>{c(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}t.$V=T,t.$W=new T;function D(u){t.$W.setUnexpectedErrorHandler(u)}t.setUnexpectedErrorHandler=D;function r(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}t.$Y=r;function f(u){s(u)||t.$W.onUnexpectedError(u)}t.$Z=f;function N(u){s(u)||t.$W.onUnexpectedExternalError(u)}t.$1=N;function h(u){if(u instanceof Error){const{name:i,message:c}=u,A=u.stacktrace||u.stack;return{$isError:!0,name:i,message:c,stack:A,noTelemetry:l.isErrorNoTelemetry(u)}}return u}t.$2=h;const a="Canceled";function s(u){return u instanceof m?!0:u instanceof Error&&u.name===a&&u.message===a}t.$3=s;class m extends Error{constructor(){super(a),this.name=this.message}}t.$4=m;function E(){const u=new Error(a);return u.name=u.message,u}t.$5=E;function $(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}t.$6=$;function b(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}t.$7=b;class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$8=e;function v(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}t.$9=v;class R extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.$0=R;class L extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.$$=L;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=d;class l extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof l)return i;const c=new l;return c.message=i.message,c.stack=i.stack,c}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.$ab=l;class o extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}t.$bb=o}),ne(ie[6],re([0,1,3,9]),function(O,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.CompareResult=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.top=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=void 0;function r(U,C=0){return U[U.length-(1+C)]}t.$rb=r;function f(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}t.$sb=f;function N(U,C,V=(X,ee)=>X===ee){if(U===C)return!0;if(!U||!C||U.length!==C.length)return!1;for(let X=0,ee=U.length;X<ee;X++)if(!V(U[X],C[X]))return!1;return!0}t.$tb=N;function h(U,C){const V=U.length-1;C<V&&(U[C]=U[V]),U.pop()}t.$ub=h;function a(U,C,V){return s(U.length,X=>V(U[X],C))}t.$vb=a;function s(U,C){let V=0,X=U-1;for(;V<=X;){const ee=(V+X)/2|0,G=C(ee);if(G<0)V=ee+1;else if(G>0)X=ee-1;else return ee}return-(V+1)}t.$wb=s;function m(U,C,V){if(U=U|0,U>=C.length)throw new TypeError("invalid index");const X=C[Math.floor(C.length*Math.random())],ee=[],G=[],Z=[];for(const K of C){const Q=V(K,X);Q<0?ee.push(K):Q>0?G.push(K):Z.push(K)}return U<ee.length?m(U,ee,V):U<ee.length+Z.length?Z[0]:m(U-(ee.length+Z.length),G,V)}t.$xb=m;function E(U,C){const V=[];let X;for(const ee of U.slice(0).sort(C))!X||C(X[0],ee)!==0?(X=[ee],V.push(X)):X.push(ee);return V}t.$yb=E;function*$(U,C){let V,X;for(const ee of U)X!==void 0&&C(X,ee)?V.push(ee):(V&&(yield V),V=[ee]),X=ee;V&&(yield V)}t.$zb=$;function b(U,C){for(let V=0;V<=U.length;V++)C(V===0?void 0:U[V-1],V===U.length?void 0:U[V])}t.$Ab=b;function e(U,C){for(let V=0;V<U.length;V++)C(V===0?void 0:U[V-1],U[V],V+1===U.length?void 0:U[V+1])}t.$Bb=e;function v(U,C,V){const X=[];function ee(K,Q,se){if(Q===0&&se.length===0)return;const le=X[X.length-1];le&&le.start+le.deleteCount===K?(le.deleteCount+=Q,le.toInsert.push(...se)):X.push({start:K,deleteCount:Q,toInsert:se})}let G=0,Z=0;for(;;){if(G===U.length){ee(G,0,C.slice(Z));break}if(Z===C.length){ee(G,U.length-G,[]);break}const K=U[G],Q=C[Z],se=V(K,Q);se===0?(G+=1,Z+=1):se<0?(ee(G,1,[]),G+=1):se>0&&(ee(G,0,[Q]),Z+=1)}return X}t.$Cb=v;function R(U,C,V){const X=v(U,C,V),ee=[],G=[];for(const Z of X)ee.push(...U.slice(Z.start,Z.start+Z.deleteCount)),G.push(...Z.toInsert);return{removed:ee,added:G}}t.$Db=R;function L(U,C,V){if(V===0)return[];const X=U.slice(0,V).sort(C);return l(U,C,X,V,U.length),X}t.top=L;function d(U,C,V,X,ee){return V===0?Promise.resolve([]):new Promise((G,Z)=>{(async()=>{const K=U.length,Q=U.slice(0,V).sort(C);for(let se=V,le=Math.min(V+X,K);se<K;se=le,le=Math.min(le+X,K)){if(se>V&&await new Promise(oe=>setTimeout(oe)),ee&&ee.isCancellationRequested)throw new T.$4;l(U,C,Q,se,le)}return Q})().then(G,Z)})}t.$Fb=d;function l(U,C,V,X,ee){for(const G=V.length;X<ee;X++){const Z=U[X];if(C(Z,V[G-1])<0){V.pop();const K=(0,D.$jb)(V,Q=>C(Z,Q)<0);V.splice(K,0,Z)}}}function o(U){return U.filter(C=>!!C)}t.$Gb=o;function u(U){let C=0;for(let V=0;V<U.length;V++)U[V]&&(U[C]=U[V],C+=1);U.length=C}t.$Hb=u;function i(U,C,V){U.splice(V,0,U.splice(C,1)[0])}t.$Ib=i;function c(U){return!Array.isArray(U)||U.length===0}t.$Jb=c;function A(U){return Array.isArray(U)&&U.length>0}t.$Kb=A;function g(U,C=V=>V){const V=new Set;return U.filter(X=>{const ee=C(X);return V.has(ee)?!1:(V.add(ee),!0)})}t.$Lb=g;function w(U){const C=new Set;return V=>{const X=U(V);return C.has(X)?!1:(C.add(X),!0)}}t.$Mb=w;function M(U,C){return U.length>0?U[0]:C}t.$Nb=M;function p(U,C){return U.length>0?U[U.length-1]:C}t.$Ob=p;function k(U,C,V=(X,ee)=>X===ee){let X=0;for(let ee=0,G=Math.min(U.length,C.length);ee<G&&V(U[ee],C[ee]);ee++)X++;return X}t.$Pb=k;function y(U){return[].concat(...U)}t.$Qb=y;function F(U,C){let V=typeof C=="number"?U:0;typeof C=="number"?V=U:(V=0,C=U);const X=[];if(V<=C)for(let ee=V;ee<C;ee++)X.push(ee);else for(let ee=V;ee>C;ee--)X.push(ee);return X}t.$Rb=F;function P(U,C,V){return U.reduce((X,ee)=>(X[C(ee)]=V?V(ee):ee,X),Object.create(null))}t.$Sb=P;function I(U,C){return U.push(C),()=>q(U,C)}t.$Tb=I;function q(U,C){const V=U.indexOf(C);if(V>-1)return U.splice(V,1),C}t.$Ub=q;function x(U,C,V){const X=U.slice(0,C),ee=U.slice(C);return X.concat(V,ee)}t.$Vb=x;function _(U,C){let V;if(typeof C=="number"){let X=C;V=()=>{const ee=Math.sin(X++)*179426549;return ee-Math.floor(ee)}}else V=Math.random;for(let X=U.length-1;X>0;X-=1){const ee=Math.floor(V()*(X+1)),G=U[X];U[X]=U[ee],U[ee]=G}}t.$Wb=_;function j(U,C){const V=U.indexOf(C);V>-1&&(U.splice(V,1),U.unshift(C))}t.$Xb=j;function H(U,C){const V=U.indexOf(C);V>-1&&(U.splice(V,1),U.push(C))}t.$Yb=H;function W(U,C){for(const V of C)U.push(V)}t.$Zb=W;function J(U,C){return Array.isArray(U)?U.map(C):C(U)}t.$1b=J;function n(U){return Array.isArray(U)?U:[U]}t.$2b=n;function te(U){return U[Math.floor(Math.random()*U.length)]}t.$3b=te;function ce(U,C,V){const X=Le(U,C),ee=U.length,G=V.length;U.length=ee+G;for(let Z=ee-1;Z>=X;Z--)U[Z+G]=U[Z];for(let Z=0;Z<G;Z++)U[Z+X]=V[Z]}t.$4b=ce;function ge(U,C,V,X){const ee=Le(U,C);let G=U.splice(ee,V);return G===void 0&&(G=[]),ce(U,ee,X),G}t.$5b=ge;function Le(U,C){return C<0?Math.max(C+U.length,0):Math.min(C,U.length)}var ve;(function(U){function C(G){return G<0}U.isLessThan=C;function V(G){return G<=0}U.isLessThanOrEqual=V;function X(G){return G>0}U.isGreaterThan=X;function ee(G){return G===0}U.isNeitherLessOrGreaterThan=ee,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(ve||(t.CompareResult=ve={}));function $e(U,C){return(V,X)=>C(U(V),U(X))}t.$6b=$e;function Ne(...U){return(C,V)=>{for(const X of U){const ee=X(C,V);if(!ve.isNeitherLessOrGreaterThan(ee))return ee}return ve.neitherLessOrGreaterThan}}t.$7b=Ne;const _e=(U,C)=>U-C;t.$8b=_e;const Te=(U,C)=>(0,t.$8b)(U?1:0,C?1:0);t.$9b=Te;function Se(U){return(C,V)=>-U(C,V)}t.$0b=Se;class Ie{constructor(C){this.g=C,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(C){let V=this.c;for(;V<this.g.length&&C(this.g[V]);)V++;const X=V===this.c?null:this.g.slice(this.c,V);return this.c=V,X}takeFromEndWhile(C){let V=this.d;for(;V>=0&&C(this.g[V]);)V--;const X=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,X}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const C=this.g[this.c];return this.c++,C}removeLast(){const C=this.g[this.d];return this.d--,C}takeCount(C){const V=this.g.slice(this.c,this.c+C);return this.c+=C,V}}t.$$b=Ie;class Me{static{this.empty=new Me(C=>{})}constructor(C){this.iterate=C}forEach(C){this.iterate(V=>(C(V),!0))}toArray(){const C=[];return this.iterate(V=>(C.push(V),!0)),C}filter(C){return new Me(V=>this.iterate(X=>C(X)?V(X):!0))}map(C){return new Me(V=>this.iterate(X=>V(C(X))))}some(C){let V=!1;return this.iterate(X=>(V=C(X),!V)),V}findFirst(C){let V;return this.iterate(X=>C(X)?(V=X,!1):!0),V}findLast(C){let V;return this.iterate(X=>(C(X)&&(V=X),!0)),V}findLastMaxBy(C){let V,X=!0;return this.iterate(ee=>((X||ve.isGreaterThan(C(ee,V)))&&(X=!1,V=ee),!0)),V}}t.$_b=Me}),ne(ie[13],re([0,1,3]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=t.$5c=t.$4c=t.$3c=t.ok=void 0;function D(a,s){if(!a)throw new Error(s?`Assertion failed (${s})`:"Assertion Failed")}t.ok=D;function r(a,s="Unreachable"){throw new Error(s)}t.$3c=r;function f(a){if(!a)throw new T.$bb("Assertion Failed")}t.$4c=f;function N(a){if(!a()){debugger;a(),(0,T.$Z)(new T.$bb("Assertion Failed"))}}t.$5c=N;function h(a,s){let m=0;for(;m<a.length-1;){const E=a[m],$=a[m+1];if(!s(E,$))return!1;m++}return!0}t.$6c=h}),ne(ie[19],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=void 0;function T(D){const r=this;let f=!1,N;return function(){return f||(f=!0,N=D.apply(r,arguments)),N}}t.$cb=T}),ne(ie[20],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var T;(function(D){function r(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}D.is=r;const f=Object.freeze([]);function N(){return f}D.empty=N;function*h(u){yield u}D.single=h;function a(u){return r(u)?u:h(u)}D.wrap=a;function s(u){return u||f}D.from=s;function*m(u){for(let i=u.length-1;i>=0;i--)yield u[i]}D.reverse=m;function E(u){return!u||u[Symbol.iterator]().next().done===!0}D.isEmpty=E;function $(u){return u[Symbol.iterator]().next().value}D.first=$;function b(u,i){for(const c of u)if(i(c))return!0;return!1}D.some=b;function e(u,i){for(const c of u)if(i(c))return c}D.find=e;function*v(u,i){for(const c of u)i(c)&&(yield c)}D.filter=v;function*R(u,i){let c=0;for(const A of u)yield i(A,c++)}D.map=R;function*L(...u){for(const i of u)for(const c of i)yield c}D.concat=L;function d(u,i,c){let A=c;for(const g of u)A=i(A,g);return A}D.reduce=d;function*l(u,i,c=u.length){for(i<0&&(i+=u.length),c<0?c+=u.length:c>u.length&&(c=u.length);i<c;i++)yield u[i]}D.slice=l;function o(u,i=Number.POSITIVE_INFINITY){const c=[];if(i===0)return[c,u];const A=u[Symbol.iterator]();for(let g=0;g<i;g++){const w=A.next();if(w.done)return[c,D.empty()];c.push(w.value)}return[c,{[Symbol.iterator](){return A}}]}D.consume=o})(T||(t.Iterable=T={}))}),ne(ie[37],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Iq=t.KeyMod=t.KeyCodeUtils=t.$Hq=t.$Gq=t.$Fq=t.$Eq=t.$Dq=t.ScanCode=t.KeyCode=void 0;var T;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(T||(t.KeyCode=T={}));var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(D||(t.ScanCode=D={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(v,R){this._keyCodeToStr[v]=R,this._strToKeyCode[R.toLowerCase()]=v}keyCodeToStr(v){return this._keyCodeToStr[v]}strToKeyCode(v){return this._strToKeyCode[v.toLowerCase()]||0}}const f=new r,N=new r,h=new r;t.$Dq=new Array(230),t.$Eq={};const a=[],s=Object.create(null),m=Object.create(null);t.$Fq={lowerCaseToEnum:e=>m[e]||0,toEnum:e=>s[e]||0,toString:e=>a[e]||"None"},t.$Gq=[],t.$Hq=[];for(let e=0;e<=193;e++)t.$Gq[e]=-1;for(let e=0;e<=132;e++)t.$Hq[e]=-1;(function(){const e="",v=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],R=[],L=[];for(const d of v){const[l,o,u,i,c,A,g,w,M]=d;if(L[o]||(L[o]=!0,a[o]=u,s[u]=o,m[u.toLowerCase()]=o,l&&(t.$Gq[o]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.$Hq[i]=o))),!R[i]){if(R[i]=!0,!c)throw new Error(`String representation missing for key code ${i} around scan code ${u}`);f.define(i,c),N.define(i,w||c),h.define(i,M||w||c)}A&&(t.$Dq[A]=i),g&&(t.$Eq[g]=i)}t.$Hq[3]=46})();var E;(function(e){function v(u){return f.keyCodeToStr(u)}e.toString=v;function R(u){return f.strToKeyCode(u)}e.fromString=R;function L(u){return N.keyCodeToStr(u)}e.toUserSettingsUS=L;function d(u){return h.keyCodeToStr(u)}e.toUserSettingsGeneral=d;function l(u){return N.strToKeyCode(u)||h.strToKeyCode(u)}e.fromUserSettings=l;function o(u){if(u>=98&&u<=113)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return f.keyCodeToStr(u)}e.toElectronAccelerator=o})(E||(t.KeyCodeUtils=E={}));var $;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})($||(t.KeyMod=$={}));function b(e,v){const R=(v&65535)<<16>>>0;return(e|R)>>>0}t.$Iq=b}),ne(ie[38],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U=void 0;class T{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$U=T}),ne(ie[21],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1c=void 0;class T{static{this.Undefined=new T(void 0)}constructor(f){this.element=f,this.next=T.Undefined,this.prev=T.Undefined}}class D{constructor(){this.a=T.Undefined,this.b=T.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===T.Undefined}clear(){let f=this.a;for(;f!==T.Undefined;){const N=f.next;f.prev=T.Undefined,f.next=T.Undefined,f=N}this.a=T.Undefined,this.b=T.Undefined,this.c=0}unshift(f){return this.d(f,!1)}push(f){return this.d(f,!0)}d(f,N){const h=new T(f);if(this.a===T.Undefined)this.a=h,this.b=h;else if(N){const s=this.b;this.b=h,h.prev=s,s.next=h}else{const s=this.a;this.a=h,h.next=s,s.prev=h}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(h))}}shift(){if(this.a!==T.Undefined){const f=this.a.element;return this.e(this.a),f}}pop(){if(this.b!==T.Undefined){const f=this.b.element;return this.e(this.b),f}}e(f){if(f.prev!==T.Undefined&&f.next!==T.Undefined){const N=f.prev;N.next=f.next,f.next.prev=N}else f.prev===T.Undefined&&f.next===T.Undefined?(this.a=T.Undefined,this.b=T.Undefined):f.next===T.Undefined?(this.b=this.b.prev,this.b.next=T.Undefined):f.prev===T.Undefined&&(this.a=this.a.next,this.a.prev=T.Undefined);this.c-=1}*[Symbol.iterator](){let f=this.a;for(;f!==T.Undefined;)yield f.element,f=f.next}}t.$1c=D}),ne(ie[22],re([0,1]),function(O,t){"use strict";var T,D,r;Object.defineProperty(t,"__esModule",{value:!0}),t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.Touch=t.$Ac=t.$zc=t.$yc=t.$xc=t.$wc=void 0;function f(d,l,o){let u=d.get(l);return u===void 0&&(u=o,d.set(l,u)),u}t.$wc=f;function N(d){const l=[];return d.forEach((o,u)=>{l.push(`${u} => ${o}`)}),`Map(${d.size}) {${l.join(", ")}}`}t.$xc=N;function h(d){const l=[];return d.forEach(o=>{l.push(o)}),`Set(${d.size}) {${l.join(", ")}}`}t.$yc=h;class a{constructor(l,o){this.uri=l,this.value=o}}function s(d){return Array.isArray(d)}class m{static{this.a=l=>l.toString()}constructor(l,o){if(this[T]="ResourceMap",l instanceof m)this.b=new Map(l.b),this.c=o??m.a;else if(s(l)){this.b=new Map,this.c=o??m.a;for(const[u,i]of l)this.set(u,i)}else this.b=new Map,this.c=l??m.a}set(l,o){return this.b.set(this.c(l),new a(l,o)),this}get(l){return this.b.get(this.c(l))?.value}has(l){return this.b.has(this.c(l))}get size(){return this.b.size}clear(){this.b.clear()}delete(l){return this.b.delete(this.c(l))}forEach(l,o){typeof o<"u"&&(l=l.bind(o));for(const[u,i]of this.b)l(i.value,i.uri,this)}*values(){for(const l of this.b.values())yield l.value}*keys(){for(const l of this.b.values())yield l.uri}*entries(){for(const l of this.b.values())yield[l.uri,l.value]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.b)yield[l.uri,l.value]}}t.$zc=m;class E{constructor(l,o){this[D]="ResourceSet",!l||typeof l=="function"?this.a=new m(l):(this.a=new m(o),l.forEach(this.add,this))}get size(){return this.a.size}add(l){return this.a.set(l,l),this}clear(){this.a.clear()}delete(l){return this.a.delete(l)}forEach(l,o){this.a.forEach((u,i)=>l.call(o,i,i,this))}has(l){return this.a.has(l)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ac=E;var $;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})($||(t.Touch=$={}));class b{constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(l){return this.a.has(l)}get(l,o=0){const u=this.a.get(l);if(u)return o!==0&&this.j(u,o),u.value}set(l,o,u=0){let i=this.a.get(l);if(i)i.value=o,u!==0&&this.j(i,u);else{switch(i={key:l,value:o,next:void 0,previous:void 0},u){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(l,i),this.d++}return this}delete(l){return!!this.remove(l)}remove(l){const o=this.a.get(l);if(o)return this.a.delete(l),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const l=this.b;return this.a.delete(l.key),this.i(l),this.d--,l.value}forEach(l,o){const u=this.e;let i=this.b;for(;i;){if(o?l.bind(o)(i.value,i.key,this):l(i.value,i.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const l=this,o=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.key,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return i}values(){const l=this,o=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.value,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return i}entries(){const l=this,o=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:[u.key,u.value],done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return i}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(l){if(l>=this.size)return;if(l===0){this.clear();return}let o=this.b,u=this.size;for(;o&&u>l;)this.a.delete(o.key),o=o.next,u--;this.b=o,this.d=u,o&&(o.previous=void 0),this.e++}g(l){if(!this.b&&!this.c)this.c=l;else if(this.b)l.next=this.b,this.b.previous=l;else throw new Error("Invalid list");this.b=l,this.e++}h(l){if(!this.b&&!this.c)this.b=l;else if(this.c)l.previous=this.c,this.c.next=l;else throw new Error("Invalid list");this.c=l,this.e++}i(l){if(l===this.b&&l===this.c)this.b=void 0,this.c=void 0;else if(l===this.b){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.b=l.next}else if(l===this.c){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.c=l.previous}else{const o=l.next,u=l.previous;if(!o||!u)throw new Error("Invalid list");o.previous=u,u.next=o}l.next=void 0,l.previous=void 0,this.e++}j(l,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(l===this.b)return;const u=l.next,i=l.previous;l===this.c?(i.next=void 0,this.c=i):(u.previous=i,i.next=u),l.previous=void 0,l.next=this.b,this.b.previous=l,this.b=l,this.e++}else if(o===2){if(l===this.c)return;const u=l.next,i=l.previous;l===this.b?(u.previous=void 0,this.b=u):(u.previous=i,i.next=u),l.next=void 0,l.previous=this.c,this.c.next=l,this.c=l,this.e++}}}toJSON(){const l=[];return this.forEach((o,u)=>{l.push([u,o])}),l}fromJSON(l){this.clear();for(const[o,u]of l)this.set(o,u)}}t.$Bc=b;class e extends b{constructor(l,o=1){super(),this.k=l,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(l){this.k=l,this.m()}get ratio(){return this.l}set ratio(l){this.l=Math.min(Math.max(0,l),1),this.m()}get(l,o=2){return super.get(l,o)}peek(l){return super.get(l,0)}set(l,o){return super.set(l,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Cc=e;class v{constructor(){this.a=new Map}add(l){return this.a.set(l,(this.a.get(l)||0)+1),this}delete(l){let o=this.a.get(l)||0;return o===0?!1:(o--,o===0?this.a.delete(l):this.a.set(l,o),!0)}has(l){return this.a.has(l)}}t.$Dc=v;class R{constructor(l){if(this.a=new Map,this.b=new Map,l)for(const[o,u]of l)this.set(o,u)}clear(){this.a.clear(),this.b.clear()}set(l,o){this.a.set(l,o),this.b.set(o,l)}get(l){return this.a.get(l)}getKey(l){return this.b.get(l)}delete(l){const o=this.a.get(l);return o===void 0?!1:(this.a.delete(l),this.b.delete(o),!0)}forEach(l,o){this.a.forEach((u,i)=>{l.call(o,u,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Ec=R;class L{constructor(){this.a=new Map}add(l,o){let u=this.a.get(l);u||(u=new Set,this.a.set(l,u)),u.add(o)}delete(l,o){const u=this.a.get(l);u&&(u.delete(o),u.size===0&&this.a.delete(l))}forEach(l,o){const u=this.a.get(l);u&&u.forEach(o)}get(l){const o=this.a.get(l);return o||new Set}}t.$Fc=L}),ne(ie[10],re([0,1,6,34,22,19,20]),function(O,t,T,D,r,f,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=void 0;const h=!1;let a=null;class s{constructor(){this.b=new Map}static{this.a=0}c(P){let I=this.b.get(P);return I||(I={parent:null,source:null,isSingleton:!1,value:P,idx:s.a++},this.b.set(P,I)),I}trackDisposable(P){const I=this.c(P);I.source||(I.source=new Error().stack)}setParent(P,I){const q=this.c(P);q.parent=I}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,I){const q=I.get(P);if(q)return q;const x=P.parent?this.f(this.c(P.parent),I):P;return I.set(P,x),x}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,q])=>q.source!==null&&!this.f(q,P).isSingleton).flatMap(([q])=>q)}computeLeakingDisposables(P=10,I){let q;if(I)q=I;else{const W=new Map,J=[...this.b.values()].filter(te=>te.source!==null&&!this.f(te,W).isSingleton);if(J.length===0)return;const n=new Set(J.map(te=>te.value));if(q=J.filter(te=>!(te.parent&&n.has(te.parent))),q.length===0)throw new Error("There are cyclic diposable chains!")}if(!q)return;function x(W){function J(te,ce){for(;te.length>0&&ce.some(ge=>typeof ge=="string"?ge===te[0]:te[0].match(ge));)te.shift()}const n=W.source.split(`
`).map(te=>te.trim().replace("at ","")).filter(te=>te!=="");return J(n,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),n.reverse()}const _=new r.$Fc;for(const W of q){const J=x(W);for(let n=0;n<=J.length;n++)_.add(J.slice(0,n).join(`
`),W)}q.sort((0,T.$6b)(W=>W.idx,T.$8b));let j="",H=0;for(const W of q.slice(0,P)){H++;const J=x(W),n=[];for(let te=0;te<J.length;te++){let ce=J[te];ce=`(shared with ${_.get(J.slice(0,te+1).join(`
`)).size}/${q.length} leaks) at ${ce}`;const Le=_.get(J.slice(0,te).join(`
`)),ve=(0,D.$J)([...Le].map($e=>x($e)[te]),$e=>$e);delete ve[J[te]];for(const[$e,Ne]of Object.entries(ve))n.unshift(`    - stacktraces of ${Ne.length} other leaks continue with ${$e}`);n.unshift(ce)}j+=`


==================== Leaking disposable ${H}/${q.length}: ${W.value.constructor.name} ====================
${n.join(`
`)}
============================================================

`}return q.length>P&&(j+=`


... and ${q.length-P} more leaking disposables

`),{leaks:q,details:j}}}t.$Gc=s;function m(F){a=F}if(t.$Hc=m,h){const F="__is_disposable_tracked__";m(new class{trackDisposable(P){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[F]||console.log(I)},3e3)}setParent(P,I){if(P&&P!==i.None)try{P[F]=!0}catch{}}markAsDisposed(P){if(P&&P!==i.None)try{P[F]=!0}catch{}}markAsSingleton(P){}})}function E(F){return a?.trackDisposable(F),F}t.$Ic=E;function $(F){a?.markAsDisposed(F)}t.$Jc=$;function b(F,P){a?.setParent(F,P)}function e(F,P){if(a)for(const I of F)a.setParent(I,P)}function v(F){return a?.markAsSingleton(F),F}t.$Kc=v;function R(F){return typeof F.dispose=="function"&&F.dispose.length===0}t.$Lc=R;function L(F){if(N.Iterable.is(F)){const P=[];for(const I of F)if(I)try{I.dispose()}catch(q){P.push(q)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(F)?[]:F}else if(F)return F.dispose(),F}t.$Mc=L;function d(F){for(const P of F)R(P)&&P.dispose();return[]}t.$Nc=d;function l(...F){const P=o(()=>L(F));return e(F,P),P}t.$Oc=l;function o(F){const P=E({dispose:(0,f.$cb)(()=>{$(P),F()})});return P}t.$Pc=o;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{L(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return b(P,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),b(P,null))}}t.$Qc=u;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,E(this),b(this.q,this)}dispose(){$(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}t.$Rc=i;class c{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&b(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&b(P,null),P}}t.$Sc=c;class A{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Tc=A;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(P){let I=P;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,$(this))},this}}t.$Uc=g;class w{constructor(){this.a=new Map}acquire(P,...I){let q=this.a.get(P);q||(q={counter:0,object:this.b(P,...I)},this.a.set(P,q));const{object:x}=q,_=(0,f.$cb)(()=>{--q.counter===0&&(this.c(P,q.object),this.a.delete(P))});return q.counter++,{object:x,dispose:_}}}t.$Vc=w;class M{constructor(P){this.a=P}async acquire(P,...I){const q=this.a.acquire(P,...I);try{return{object:await q.object,dispose:()=>q.dispose()}}catch(x){throw q.dispose(),x}}}t.$Wc=M;class p{constructor(P){this.object=P}dispose(){}}t.$Xc=p;function k(F){const P=new u;try{F(P)}finally{P.dispose()}}t.$Yc=k;class y{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{L(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,I,q=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),q||this.a.get(P)?.dispose(),this.a.set(P,I)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$Zc=y}),ne(ie[23],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kd=void 0;const T=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(f){return new D(f)}constructor(f){this.c=T&&f===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Kd=D}),ne(ie[11],re([0,1,3,19,10,21,23]),function(O,t,T,D,r,f,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.Event=void 0;const h=!1,a=!1;var s;(function(y){y.None=()=>r.$Rc.None;function F(G){if(a){const{onDidAddListener:Z}=G,K=e.create();let Q=0;G.onDidAddListener=()=>{++Q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),K.print()),Z?.()}}}function P(G,Z){return te(G,()=>{},0,void 0,!0,void 0,Z)}y.defer=P;function I(G){return(Z,K=null,Q)=>{let se=!1,le;return le=G(oe=>{if(!se)return le?le.dispose():se=!0,Z.call(K,oe)},null,Q),se&&le.dispose(),le}}y.once=I;function q(G,Z,K){return J((Q,se=null,le)=>G(oe=>Q.call(se,Z(oe)),null,le),K)}y.map=q;function x(G,Z,K){return J((Q,se=null,le)=>G(oe=>{Z(oe),Q.call(se,oe)},null,le),K)}y.forEach=x;function _(G,Z,K){return J((Q,se=null,le)=>G(oe=>Z(oe)&&Q.call(se,oe),null,le),K)}y.filter=_;function j(G){return G}y.signal=j;function H(...G){return(Z,K=null,Q)=>{const se=(0,r.$Oc)(...G.map(le=>le(oe=>Z.call(K,oe))));return n(se,Q)}}y.any=H;function W(G,Z,K,Q){let se=K;return q(G,le=>(se=Z(se,le),se),Q)}y.reduce=W;function J(G,Z){let K;const Q={onWillAddFirstListener(){K=G(se.fire,se)},onDidRemoveLastListener(){K?.dispose()}};Z||F(Q);const se=new l(Q);return Z?.add(se),se.event}function n(G,Z){return Z instanceof Array?Z.push(G):Z&&Z.add(G),G}function te(G,Z,K=100,Q=!1,se=!1,le,oe){let me,he,pe,we=0,ye;const Ue={leakWarningThreshold:le,onWillAddFirstListener(){me=G(je=>{we++,he=Z(he,je),Q&&!pe&&(ke.fire(he),he=void 0),ye=()=>{const Be=he;he=void 0,pe=void 0,(!Q||we>1)&&ke.fire(Be),we=0},typeof K=="number"?(clearTimeout(pe),pe=setTimeout(ye,K)):pe===void 0&&(pe=0,queueMicrotask(ye))})},onWillRemoveListener(){se&&we>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,me.dispose()}};oe||F(Ue);const ke=new l(Ue);return oe?.add(ke),ke.event}y.debounce=te;function ce(G,Z=0,K){return y.debounce(G,(Q,se)=>Q?(Q.push(se),Q):[se],Z,void 0,!0,void 0,K)}y.accumulate=ce;function ge(G,Z=(Q,se)=>Q===se,K){let Q=!0,se;return _(G,le=>{const oe=Q||!Z(le,se);return Q=!1,se=le,oe},K)}y.latch=ge;function Le(G,Z,K){return[y.filter(G,Z,K),y.filter(G,Q=>!Z(Q),K)]}y.split=Le;function ve(G,Z=!1,K=[],Q){let se=K.slice(),le=G(he=>{se?se.push(he):me.fire(he)});Q&&Q.add(le);const oe=()=>{se?.forEach(he=>me.fire(he)),se=null},me=new l({onWillAddFirstListener(){le||(le=G(he=>me.fire(he)),Q&&Q.add(le))},onDidAddFirstListener(){se&&(Z?setTimeout(oe):oe())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return Q&&Q.add(me),me.event}y.buffer=ve;function $e(G,Z){return(Q,se,le)=>{const oe=Z(new _e);return G(function(me){const he=oe.evaluate(me);he!==Ne&&Q.call(se,he)},void 0,le)}}y.chain=$e;const Ne=Symbol("HaltChainable");class _e{constructor(){this.f=[]}map(Z){return this.f.push(Z),this}forEach(Z){return this.f.push(K=>(Z(K),K)),this}filter(Z){return this.f.push(K=>Z(K)?K:Ne),this}reduce(Z,K){let Q=K;return this.f.push(se=>(Q=Z(Q,se),Q)),this}latch(Z=(K,Q)=>K===Q){let K=!0,Q;return this.f.push(se=>{const le=K||!Z(se,Q);return K=!1,Q=se,le?se:Ne}),this}evaluate(Z){for(const K of this.f)if(Z=K(Z),Z===Ne)break;return Z}}function Te(G,Z,K=Q=>Q){const Q=(...me)=>oe.fire(K(...me)),se=()=>G.on(Z,Q),le=()=>G.removeListener(Z,Q),oe=new l({onWillAddFirstListener:se,onDidRemoveLastListener:le});return oe.event}y.fromNodeEventEmitter=Te;function Se(G,Z,K=Q=>Q){const Q=(...me)=>oe.fire(K(...me)),se=()=>G.addEventListener(Z,Q),le=()=>G.removeEventListener(Z,Q),oe=new l({onWillAddFirstListener:se,onDidRemoveLastListener:le});return oe.event}y.fromDOMEventEmitter=Se;function Ie(G){return new Promise(Z=>I(G)(Z))}y.toPromise=Ie;function Me(G){const Z=new l;return G.then(K=>{Z.fire(K)},()=>{Z.fire(void 0)}).finally(()=>{Z.dispose()}),Z.event}y.fromPromise=Me;function U(G,Z,K){return Z(K),G(Q=>Z(Q))}y.runAndSubscribe=U;function C(G,Z){let K=null;function Q(le){K?.dispose(),K=new r.$Qc,Z(le,K)}Q(void 0);const se=G(le=>Q(le));return(0,r.$Pc)(()=>{se.dispose(),K?.dispose()})}y.runAndSubscribeWithStore=C;class V{constructor(Z,K){this._observable=Z,this.f=0,this.g=!1;const Q={onWillAddFirstListener:()=>{Z.addObserver(this)},onDidRemoveLastListener:()=>{Z.removeObserver(this)}};K||F(Q),this.emitter=new l(Q),K&&K.add(this.emitter)}beginUpdate(Z){this.f++}handlePossibleChange(Z){}handleChange(Z,K){this.g=!0}endUpdate(Z){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function X(G,Z){return new V(G,Z).emitter.event}y.fromObservable=X;function ee(G){return Z=>{let K=0,Q=!1;const se={beginUpdate(){K++},endUpdate(){K--,K===0&&(G.reportChanges(),Q&&(Q=!1,Z()))},handlePossibleChange(){},handleChange(){Q=!0}};return G.addObserver(se),G.reportChanges(),{dispose(){G.removeObserver(se)}}}}y.fromObservableLight=ee})(s||(t.Event=s={}));class m{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${m.f++}`,m.all.add(this)}start(F){this.g=new N.$Kd,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}t.$Md=m;let E=-1;function $(y){const F=E;return E=y,{dispose(){E=F}}}t.$Nd=$;class b{constructor(F,P=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=P,this.g=0}dispose(){this.f?.clear()}check(F,P){const I=this.threshold;if(I<=0||P<I)return;this.f||(this.f=new Map);const q=this.f.get(F.value)||0;if(this.f.set(F.value,q+1),this.g-=1,this.g<=0){this.g=I*.5;let x,_=0;for(const[j,H]of this.f)(!x||_<H)&&(x=j,_=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${_}):`),console.warn(x)}return()=>{const x=this.f.get(F.value)||0;this.f.set(F.value,x-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class R{constructor(F){this.value=F,this.id=v++}}const L=2,d=(y,F)=>{if(y instanceof R)F(y);else for(let P=0;P<y.length;P++){const I=y[P];I&&F(I)}};class l{constructor(F){this.w=0,this.f=F,this.g=E>0||this.f?.leakWarningThreshold?new b(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new m(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const F=this.t;queueMicrotask(()=>{d(F,P=>P.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,P,I)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Rc.None;if(this.m)return r.$Rc.None;P&&(F=F.bind(P));const q=new R(F);let x,_;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(q.stack=e.create(),x=this.g.check(q.stack,this.w+1)),h&&(q.stack=_??e.create()),this.t?this.t instanceof R?(this.u??=new u,this.t=[this.t,q]):this.t.push(q):(this.f?.onWillAddFirstListener?.(this),this.t=q,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,r.$Pc)(()=>{x?.(),this.x(q)});return I instanceof r.$Qc?I.add(j):Array.isArray(I)&&I.push(j),j},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const P=this.t,I=P.indexOf(F);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,P[I]=void 0;const q=this.u.current===this;if(this.w*L<=P.length){let x=0;for(let _=0;_<P.length;_++)P[_]?P[x++]=P[_]:q&&(this.u.end--,x<this.u.i&&this.u.i--);P.length=x}}y(F,P){if(!F)return;const I=this.f?.onListenerError||T.$Z;if(!I){F.value(P);return}try{F.value(P)}catch(q){I(q)}}z(F){const P=F.current.t;for(;F.i<F.end;)this.y(P[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof R)this.y(this.t,F);else{const P=this.u;P.enqueue(this,F,this.t.length),this.z(P)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Od=l;const o=()=>new u;t.$Pd=o;class u{constructor(){this.i=-1,this.end=0}enqueue(F,P,I){this.i=0,this.end=I,this.current=F,this.value=P}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends l{async fireAsync(F,P,I){if(this.t)for(this.h||(this.h=new f.$1c),d(this.t,q=>this.h.push([q.value,F]));this.h.size>0&&!P.isCancellationRequested;){const[q,x]=this.h.shift(),_=[],j={...x,token:P,waitUntil:H=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");I&&(H=I(H,q)),_.push(H)}};try{q(j)}catch(H){(0,T.$Z)(H);continue}Object.freeze(_),await Promise.allSettled(_).then(H=>{for(const W of H)W.status==="rejected"&&(0,T.$Z)(W.reason)})}}}t.$Qd=i;class c extends l{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new f.$1c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}t.$Rd=c;class A extends c{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}t.$Sd=A;class g extends l{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(P=>super.fire(P)),this.h=[]}))}}t.$Td=g;class w{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const P={event:F,listener:null};this.h.push(P),this.g&&this.m(P);const I=()=>{this.g&&this.o(P);const q=this.h.indexOf(P);this.h.splice(q,1)};return(0,r.$Pc)((0,D.$cb)(I))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(P=>this.f.fire(P))}o(F){F.listener&&F.listener.dispose(),F.listener=null}dispose(){this.f.dispose()}}t.$Ud=w;class M{constructor(F,P,I,q){this.f=new r.$Qc;const x=this.f.add(new w),_=this.f.add(new r.$Zc);function j(H){_.set(H,x.add(q(H)))}for(const H of F)j(H);this.f.add(P(H=>{j(H)})),this.f.add(I(H=>{_.deleteAndDispose(H)})),this.event=x.event}dispose(){this.f.dispose()}}t.$Vd=M;class p{constructor(){this.f=[]}wrapEvent(F){return(P,I,q)=>F(x=>{const _=this.f[this.f.length-1];_?_.push(()=>P.call(I,x)):P.call(I,x)},void 0,q)}bufferEvents(F){const P=[];this.f.push(P);const I=F();return this.f.pop(),P.forEach(q=>q()),I}}t.$Wd=p;class k{constructor(){this.f=!1,this.g=s.None,this.h=r.$Rc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$Xd=k}),ne(ie[24],re([0,1,11]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yd=t.CancellationToken=void 0;const D=Object.freeze(function(h,a){const s=setTimeout(h.bind(a),0);return{dispose(){clearTimeout(s)}}});var r;(function(h){function a(s){return s===h.None||s===h.Cancelled||s instanceof f?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}h.isCancellationToken=a,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:T.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(r||(t.CancellationToken=r={}));class f{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?D:(this.b||(this.b=new T.$Od),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(a){this.f=void 0,this.g=void 0,this.g=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new f),this.f}cancel(){this.f?this.f instanceof f&&this.f.cancel():this.f=r.Cancelled}dispose(a=!1){a&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof f&&this.f.dispose():this.f=r.None}}t.$Yd=N}),ne(ie[39],re([0,1,24]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=t.$ye=t.$xe=void 0;class D{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new T.$Yd,a=this.b(h.token);return this.a={promise:a,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}t.$xe=D;class r{constructor(h){this.c=h,this.a=void 0,this.b=void 0}get(h){const a=JSON.stringify(h);return this.b!==a&&(this.b=a,this.a=this.c(h)),this.a}}t.$ye=r;class f{get cachedValues(){return this.a}constructor(h){this.b=h,this.a=new Map}get(h){if(this.a.has(h))return this.a.get(h);const a=this.b(h);return this.a.set(h,a),a}}t.$ze=f}),ne(ie[7],re([0,1,39,38]),function(O,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yf=t.$xf=t.$wf=t.$vf=t.GraphemeBreakType=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=void 0;function r(S){return!S||typeof S!="string"?!0:S.trim().length===0}t.$Ce=r;const f=/{(\d+)}/g;function N(S,...B){return B.length===0?S:S.replace(f,function(z,Y){const ue=parseInt(Y,10);return isNaN(ue)||ue<0||ue>=B.length?z:B[ue]})}t.$De=N;const h=/{([^}]+)}/g;function a(S,B){return Object.keys(B).length===0?S:S.replace(h,(z,Y)=>B[Y]??z)}t.$Ee=a;function s(S){return S.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.$Fe=s;function m(S){return S.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Ge=m;function E(S,B){let z=0;const Y=B.charCodeAt(0);for(let ue=S.length-1;ue>=0;ue--)S.charCodeAt(ue)===Y&&z++;return z}t.$He=E;function $(S,B,z="\u2026"){return S.length<=B?S:`${S.substr(0,B)}${z}`}t.$Ie=$;function b(S,B=" "){const z=e(S,B);return v(z,B)}t.$Je=b;function e(S,B){if(!S||!B)return S;const z=B.length;if(z===0||S.length===0)return S;let Y=0;for(;S.indexOf(B,Y)===Y;)Y=Y+z;return S.substring(Y)}t.$Ke=e;function v(S,B){if(!S||!B)return S;const z=B.length,Y=S.length;if(z===0||Y===0)return S;let ue=Y,ae=-1;for(;ae=S.lastIndexOf(B,ue-1),!(ae===-1||ae+z!==ue);){if(ae===0)return"";ue=ae}return S.substring(0,ue)}t.$Le=v;function R(S){return S.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Me=R;function L(S){return S.replace(/\*/g,"")}t.$Ne=L;function d(S,B,z={}){if(!S)throw new Error("Cannot create regex from empty string");B||(S=m(S)),z.wholeWord&&(/\B/.test(S.charAt(0))||(S="\\b"+S),/\B/.test(S.charAt(S.length-1))||(S=S+"\\b"));let Y="";return z.global&&(Y+="g"),z.matchCase||(Y+="i"),z.multiline&&(Y+="m"),z.unicode&&(Y+="u"),new RegExp(S,Y)}t.$Oe=d;function l(S){return S.source==="^"||S.source==="^$"||S.source==="$"||S.source==="^\\s*$"?!1:!!(S.exec("")&&S.lastIndex===0)}t.$Pe=l;function o(S){return S.split(/\r\n|\r|\n/)}t.$Qe=o;function u(S){for(let B=0,z=S.length;B<z;B++){const Y=S.charCodeAt(B);if(Y!==32&&Y!==9)return B}return-1}t.$Re=u;function i(S,B=0,z=S.length){for(let Y=B;Y<z;Y++){const ue=S.charCodeAt(Y);if(ue!==32&&ue!==9)return S.substring(B,Y)}return S.substring(B,z)}t.$Se=i;function c(S,B=S.length-1){for(let z=B;z>=0;z--){const Y=S.charCodeAt(z);if(Y!==32&&Y!==9)return z}return-1}t.$Te=c;function A(S,B,z){const Y=[];let ue=0;for(const ae of S.matchAll(B)){if(Y.push(S.slice(ue,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");ue=ae.index+ae[0].length,Y.push(z(ae[0],...ae.slice(1),ae.index,S,ae.groups))}return Y.push(S.slice(ue)),Promise.all(Y).then(ae=>ae.join(""))}t.$Ue=A;function g(S,B){return S<B?-1:S>B?1:0}t.$Ve=g;function w(S,B,z=0,Y=S.length,ue=0,ae=B.length){for(;z<Y&&ue<ae;z++,ue++){const Ae=S.charCodeAt(z),Ee=B.charCodeAt(ue);if(Ae<Ee)return-1;if(Ae>Ee)return 1}const de=Y-z,Fe=ae-ue;return de<Fe?-1:de>Fe?1:0}t.$We=w;function M(S,B){return p(S,B,0,S.length,0,B.length)}t.$Xe=M;function p(S,B,z=0,Y=S.length,ue=0,ae=B.length){for(;z<Y&&ue<ae;z++,ue++){let Ae=S.charCodeAt(z),Ee=B.charCodeAt(ue);if(Ae===Ee)continue;if(Ae>=128||Ee>=128)return w(S.toLowerCase(),B.toLowerCase(),z,Y,ue,ae);y(Ae)&&(Ae-=32),y(Ee)&&(Ee-=32);const be=Ae-Ee;if(be!==0)return be}const de=Y-z,Fe=ae-ue;return de<Fe?-1:de>Fe?1:0}t.$Ye=p;function k(S){return S>=48&&S<=57}t.$Ze=k;function y(S){return S>=97&&S<=122}t.$1e=y;function F(S){return S>=65&&S<=90}t.$2e=F;function P(S,B){return S.length===B.length&&p(S,B)===0}t.$3e=P;function I(S,B){const z=B.length;return B.length>S.length?!1:p(S,B,0,z)===0}t.$4e=I;function q(S,B){const z=Math.min(S.length,B.length);let Y;for(Y=0;Y<z;Y++)if(S.charCodeAt(Y)!==B.charCodeAt(Y))return Y;return z}t.$5e=q;function x(S,B){const z=Math.min(S.length,B.length);let Y;const ue=S.length-1,ae=B.length-1;for(Y=0;Y<z;Y++)if(S.charCodeAt(ue-Y)!==B.charCodeAt(ae-Y))return Y;return z}t.$6e=x;function _(S){return 55296<=S&&S<=56319}t.$7e=_;function j(S){return 56320<=S&&S<=57343}t.$8e=j;function H(S,B){return(S-55296<<10)+(B-56320)+65536}t.$9e=H;function W(S,B,z){const Y=S.charCodeAt(z);if(_(Y)&&z+1<B){const ue=S.charCodeAt(z+1);if(j(ue))return H(Y,ue)}return Y}t.$0e=W;function J(S,B){const z=S.charCodeAt(B-1);if(j(z)&&B>1){const Y=S.charCodeAt(B-2);if(_(Y))return H(Y,z)}return z}class n{get offset(){return this.e}constructor(B,z=0){this.c=B,this.d=B.length,this.e=z}setOffset(B){this.e=B}prevCodePoint(){const B=J(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=W(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.$$e=n;class te{get offset(){return this.c.offset}constructor(B,z=0){this.c=new n(B,z)}nextGraphemeLength(){const B=we.getInstance(),z=this.c,Y=z.offset;let ue=B.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const ae=z.offset,de=B.getGraphemeBreakType(z.nextCodePoint());if(he(ue,de)){z.setOffset(ae);break}ue=de}return z.offset-Y}prevGraphemeLength(){const B=we.getInstance(),z=this.c,Y=z.offset;let ue=B.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const ae=z.offset,de=B.getGraphemeBreakType(z.prevCodePoint());if(he(de,ue)){z.setOffset(ae);break}ue=de}return Y-z.offset}eol(){return this.c.eol()}}t.$_e=te;function ce(S,B){return new te(S,B).nextGraphemeLength()}t.$af=ce;function ge(S,B){return new te(S,B).prevGraphemeLength()}t.$bf=ge;function Le(S,B){B>0&&j(S.charCodeAt(B))&&B--;const z=B+ce(S,B);return[z-ge(S,z),z]}t.$cf=Le;function ve(S){const B=new te(S);let z=0;for(;!B.eol();)z++,B.nextGraphemeLength();return z}t.$df=ve;let $e;function Ne(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _e(S){return $e||($e=Ne()),$e.test(S)}t.$ef=_e;const Te=/^[\t\n\r\x20-\x7E]*$/;function Se(S){return Te.test(S)}t.$ff=Se,t.$gf=/[\u2028\u2029]/;function Ie(S){return t.$gf.test(S)}t.$hf=Ie;function Me(S){return S>=11904&&S<=55215||S>=63744&&S<=64255||S>=65281&&S<=65374}t.$if=Me;function U(S){return S>=127462&&S<=127487||S===8986||S===8987||S===9200||S===9203||S>=9728&&S<=10175||S===11088||S===11093||S>=127744&&S<=128591||S>=128640&&S<=128764||S>=128992&&S<=129008||S>=129280&&S<=129535||S>=129648&&S<=129782}t.$jf=U;function C(S,B){if(S.length<B)return S;const z=/\b/g;let Y=0;for(;z.test(S)&&!(S.length-z.lastIndex<B);)Y=z.lastIndex,z.lastIndex+=1;return S.substring(Y).replace(/^\s/,"")}t.$kf=C;const V=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,X=/\x1b\].*?\x07/g;function ee(S){return S&&(S=S.replace(V,"").replace(X,"")),S}t.$lf=ee,t.$mf=String.fromCharCode(65279);function G(S){return!!(S&&S.length>0&&S.charCodeAt(0)===65279)}t.$nf=G;function Z(S){return G(S)?S.substr(1):S}t.$of=Z;function K(S,B){if(!S||!B||S.length<B.length)return!1;const z=B.length,Y=S.toLowerCase();let ue=0,ae=-1;for(;ue<z;){const de=Y.indexOf(B[ue],ae+1);if(de<0)return!1;ae=de,ue++}return!0}t.$pf=K;function Q(S,B=!1){return S?(B&&(S=S.replace(/\\./g,"")),S.toLowerCase()!==S):!1}t.$qf=Q;function se(S){return S.charAt(0).toUpperCase()+S.slice(1)}t.$rf=se;function le(S,B=1){if(B===0)return"";let z=-1;do z=S.indexOf(`
`,z+1),B--;while(B>0&&z>=0);return z===-1?S:(S[z-1]==="\r"&&z--,S.substr(0,z))}t.$sf=le;function oe(S){return S=S%(2*26),S<26?String.fromCharCode(97+S):String.fromCharCode(65+S-26)}t.$tf=oe;function me(S){return we.getInstance().getGraphemeBreakType(S)}t.$uf=me;function he(S,B){return S===0?B!==5&&B!==7:S===2&&B===3?!1:S===4||S===2||S===3||B===4||B===2||B===3?!0:!(S===8&&(B===8||B===9||B===11||B===12)||(S===11||S===9)&&(B===9||B===10)||(S===12||S===10)&&B===10||B===5||B===13||B===7||S===1||S===13&&B===14||S===6&&B===6)}var pe;(function(S){S[S.Other=0]="Other",S[S.Prepend=1]="Prepend",S[S.CR=2]="CR",S[S.LF=3]="LF",S[S.Control=4]="Control",S[S.Extend=5]="Extend",S[S.Regional_Indicator=6]="Regional_Indicator",S[S.SpacingMark=7]="SpacingMark",S[S.L=8]="L",S[S.V=9]="V",S[S.T=10]="T",S[S.LV=11]="LV",S[S.LVT=12]="LVT",S[S.ZWJ=13]="ZWJ",S[S.Extended_Pictographic=14]="Extended_Pictographic"})(pe||(t.GraphemeBreakType=pe={}));class we{static{this.c=null}static getInstance(){return we.c||(we.c=new we),we.c}constructor(){this.d=ye()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const z=this.d,Y=z.length/3;let ue=1;for(;ue<=Y;)if(B<z[3*ue])ue=2*ue;else if(B>z[3*ue+1])ue=2*ue+1;else return z[3*ue+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(S,B){if(S===0)return 0;const z=ke(S,B);if(z!==void 0)return z;const Y=new n(B,S);return Y.prevCodePoint(),Y.offset}t.$vf=Ue;function ke(S,B){const z=new n(B,S);let Y=z.prevCodePoint();for(;je(Y)||Y===65039||Y===8419;){if(z.offset===0)return;Y=z.prevCodePoint()}if(!U(Y))return;let ue=z.offset;return ue>0&&z.prevCodePoint()===8205&&(ue=z.offset),ue}function je(S){return 127995<=S&&S<=127999}var Be;(function(S){S[S.zwj=8205]="zwj",S[S.emojiVariantSelector=65039]="emojiVariantSelector",S[S.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),t.$wf="\xA0";class De{static{this.c=new D.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new T.$ye(B=>{function z(be){const Pe=new Map;for(let Re=0;Re<be.length;Re+=2)Pe.set(be[Re],be[Re+1]);return Pe}function Y(be,Pe){const Re=new Map(be);for(const[Oe,Ve]of Pe)Re.set(Oe,Ve);return Re}function ue(be,Pe){if(!be)return Pe;const Re=new Map;for(const[Oe,Ve]of be)Pe.has(Oe)&&Re.set(Oe,Ve);return Re}const ae=this.c.value;let de=B.filter(be=>!be.startsWith("_")&&be in ae);de.length===0&&(de=["_default"]);let Fe;for(const be of de){const Pe=z(ae[be]);Fe=ue(Fe,Pe)}const Ae=z(ae._common),Ee=Y(Ae,Fe);return new De(Ee)})}static getInstance(B){return De.d.get(Array.from(B))}static{this.e=new D.$U(()=>Object.keys(De.c.value).filter(B=>!B.startsWith("_")))}static getLocales(){return De.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$xf=De;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter(B){return qe.e().has(B)}static get codePoints(){return qe.e()}}t.$yf=qe}),ne(ie[40],re([0,1,7]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mi=t.$Li=t.$Ki=t.$Ji=t.$Ii=t.$Hi=t.$Gi=void 0;function D(L){return r(L,0)}t.$Gi=D;function r(L,d){switch(typeof L){case"object":return L===null?f(349,d):Array.isArray(L)?a(L,d):s(L,d);case"string":return h(L,d);case"boolean":return N(L,d);case"number":return f(L,d);case"undefined":return f(937,d);default:return f(617,d)}}t.$Hi=r;function f(L,d){return(d<<5)-d+L|0}t.$Ii=f;function N(L,d){return f(L?433:863,d)}function h(L,d){d=f(149417,d);for(let l=0,o=L.length;l<o;l++)d=f(L.charCodeAt(l),d);return d}t.$Ji=h;function a(L,d){return d=f(104579,d),L.reduce((l,o)=>r(o,l),d)}function s(L,d){return d=f(181387,d),Object.keys(L).sort().reduce((l,o)=>(l=h(o,l),r(L[o],l)),d)}class m{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=r(d,this.g),this.g}}t.$Ki=m;var E;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function $(L,d,l=32){const o=l-d,u=~((1<<o)-1);return(L<<d|(u&L)>>>o)>>>0}function b(L,d=0,l=L.byteLength,o=0){for(let u=0;u<l;u++)L[d+u]=o}function e(L,d,l="0"){for(;L.length<d;)L=l+L;return L}function v(L,d=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(l=>l.toString(16).padStart(2,"0")).join(""):e((L>>>0).toString(16),d/4)}t.$Li=v;class R{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const l=d.length;if(l===0)return;const o=this.p;let u=this.r,i=this.u,c,A;for(i!==0?(c=i,A=-1,i=0):(c=d.charCodeAt(0),A=0);;){let g=c;if(T.$7e(c))if(A+1<l){const w=d.charCodeAt(A+1);T.$8e(w)?(A++,g=T.$9e(c,w)):g=65533}else{i=c;break}else T.$8e(c)&&(g=65533);if(u=this.w(o,u,g),A++,A<l)c=d.charCodeAt(A);else break}this.r=u,this.u=i}w(d,l,o){return o<128?d[l++]=o:o<2048?(d[l++]=192|(o&1984)>>>6,d[l++]=128|(o&63)>>>0):o<65536?(d[l++]=224|(o&61440)>>>12,d[l++]=128|(o&4032)>>>6,d[l++]=128|(o&63)>>>0):(d[l++]=240|(o&1835008)>>>18,d[l++]=128|(o&258048)>>>12,d[l++]=128|(o&4032)>>>6,d[l++]=128|(o&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,b(this.p,this.r),this.r>56&&(this.y(),b(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=R.g,l=this.q;for(let p=0;p<64;p+=4)d.setUint32(p,l.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)d.setUint32(p,$(d.getUint32(p-12,!1)^d.getUint32(p-32,!1)^d.getUint32(p-56,!1)^d.getUint32(p-64,!1),1),!1);let o=this.h,u=this.l,i=this.m,c=this.n,A=this.o,g,w,M;for(let p=0;p<80;p++)p<20?(g=u&i|~u&c,w=1518500249):p<40?(g=u^i^c,w=1859775393):p<60?(g=u&i|u&c|i&c,w=2400959708):(g=u^i^c,w=3395469782),M=$(o,5)+g+A+w+d.getUint32(p*4,!1)&4294967295,A=c,c=i,i=$(u,30),u=o,o=M;this.h=this.h+o&4294967295,this.l=this.l+u&4294967295,this.m=this.m+i&4294967295,this.n=this.n+c&4294967295,this.o=this.o+A&4294967295}}t.$Mi=R}),ne(ie[25],re([0,1,36,40]),function(O,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cs=t.$Bs=t.$As=void 0;class r{constructor($){this.a=$}getElements(){const $=this.a,b=new Int32Array($.length);for(let e=0,v=$.length;e<v;e++)b[e]=$.charCodeAt(e);return b}}t.$As=r;function f(E,$,b){return new m(new r(E),new r($)).ComputeDiff(b).changes}t.$Bs=f;class N{static Assert($,b){if(!$)throw new Error(b)}}class h{static Copy($,b,e,v,R){for(let L=0;L<R;L++)e[v+L]=$[b+L]}static Copy2($,b,e,v,R){for(let L=0;L<R;L++)e[v+L]=$[b+L]}}var a;(function(E){E[E.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class s{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new T.$zs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement($,b){this.b=Math.min(this.b,$),this.c=Math.min(this.c,b),this.d++}AddModifiedElement($,b){this.b=Math.min(this.b,$),this.c=Math.min(this.c,b),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class m{constructor($,b,e=null){this.a=e,this.b=$,this.c=b;const[v,R,L]=m.o($),[d,l,o]=m.o(b);this.d=L&&o,this.e=v,this.f=R,this.g=d,this.h=l,this.k=[],this.m=[]}static n($){return $.length>0&&typeof $[0]=="string"}static o($){const b=$.getElements();if(m.n(b)){const e=new Int32Array(b.length);for(let v=0,R=b.length;v<R;v++)e[v]=(0,D.$Ji)(b[v],0);return[b,e,!0]}return b instanceof Int32Array?[[],b,!1]:[[],new Int32Array(b),!1]}p($,b){return this.f[$]!==this.h[b]?!1:this.d?this.e[$]===this.g[b]:!0}q($,b){if(!this.p($,b))return!1;const e=m.r(this.b,$),v=m.r(this.c,b);return e===v}static r($,b){return typeof $.getStrictElement=="function"?$.getStrictElement(b):null}s($,b){return this.f[$]!==this.f[b]?!1:this.d?this.e[$]===this.e[b]:!0}u($,b){return this.h[$]!==this.h[b]?!1:this.d?this.g[$]===this.g[b]:!0}ComputeDiff($){return this.v(0,this.f.length-1,0,this.h.length-1,$)}v($,b,e,v,R){const L=[!1];let d=this.w($,b,e,v,L);return R&&(d=this.z(d)),{quitEarly:L[0],changes:d}}w($,b,e,v,R){for(R[0]=!1;$<=b&&e<=v&&this.p($,e);)$++,e++;for(;b>=$&&v>=e&&this.p(b,v);)b--,v--;if($>b||e>v){let i;return e<=v?(N.Assert($===b+1,"originalStart should only be one more than originalEnd"),i=[new T.$zs($,0,e,v-e+1)]):$<=b?(N.Assert(e===v+1,"modifiedStart should only be one more than modifiedEnd"),i=[new T.$zs($,b-$+1,e,0)]):(N.Assert($===b+1,"originalStart should only be one more than originalEnd"),N.Assert(e===v+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const L=[0],d=[0],l=this.y($,b,e,v,L,d,R),o=L[0],u=d[0];if(l!==null)return l;if(!R[0]){const i=this.w($,o,e,u,R);let c=[];return R[0]?c=[new T.$zs(o+1,b-(o+1)+1,u+1,v-(u+1)+1)]:c=this.w(o+1,b,u+1,v,R),this.H(i,c)}return[new T.$zs($,b-$+1,e,v-e+1)]}x($,b,e,v,R,L,d,l,o,u,i,c,A,g,w,M,p,k){let y=null,F=null,P=new s,I=b,q=e,x=A[0]-M[0]-v,_=-1073741824,j=this.k.length-1;do{const H=x+$;H===I||H<q&&o[H-1]<o[H+1]?(i=o[H+1],g=i-x-v,i<_&&P.MarkNextChange(),_=i,P.AddModifiedElement(i+1,g),x=H+1-$):(i=o[H-1]+1,g=i-x-v,i<_&&P.MarkNextChange(),_=i-1,P.AddOriginalElement(i,g+1),x=H-1-$),j>=0&&(o=this.k[j],$=o[0],I=1,q=o.length-1)}while(--j>=-1);if(y=P.getReverseChanges(),k[0]){let H=A[0]+1,W=M[0]+1;if(y!==null&&y.length>0){const J=y[y.length-1];H=Math.max(H,J.getOriginalEnd()),W=Math.max(W,J.getModifiedEnd())}F=[new T.$zs(H,c-H+1,W,w-W+1)]}else{P=new s,I=L,q=d,x=A[0]-M[0]-l,_=1073741824,j=p?this.m.length-1:this.m.length-2;do{const H=x+R;H===I||H<q&&u[H-1]>=u[H+1]?(i=u[H+1]-1,g=i-x-l,i>_&&P.MarkNextChange(),_=i+1,P.AddOriginalElement(i+1,g+1),x=H+1-R):(i=u[H-1],g=i-x-l,i>_&&P.MarkNextChange(),_=i,P.AddModifiedElement(i+1,g+1),x=H-1-R),j>=0&&(u=this.m[j],R=u[0],I=1,q=u.length-1)}while(--j>=-1);F=P.getChanges()}return this.H(y,F)}y($,b,e,v,R,L,d){let l=0,o=0,u=0,i=0,c=0,A=0;$--,e--,R[0]=0,L[0]=0,this.k=[],this.m=[];const g=b-$+(v-e),w=g+1,M=new Int32Array(w),p=new Int32Array(w),k=v-e,y=b-$,F=$-e,P=b-v,q=(y-k)%2===0;M[k]=$,p[y]=b,d[0]=!1;for(let x=1;x<=g/2+1;x++){let _=0,j=0;u=this.J(k-x,x,k,w),i=this.J(k+x,x,k,w);for(let W=u;W<=i;W+=2){W===u||W<i&&M[W-1]<M[W+1]?l=M[W+1]:l=M[W-1]+1,o=l-(W-k)-F;const J=l;for(;l<b&&o<v&&this.p(l+1,o+1);)l++,o++;if(M[W]=l,l+o>_+j&&(_=l,j=o),!q&&Math.abs(W-y)<=x-1&&l>=p[W])return R[0]=l,L[0]=o,J<=p[W]&&1447>0&&x<=1447+1?this.x(k,u,i,F,y,c,A,P,M,p,l,b,R,o,v,L,q,d):null}const H=(_-$+(j-e)-x)/2;if(this.a!==null&&!this.a(_,H))return d[0]=!0,R[0]=_,L[0]=j,H>0&&1447>0&&x<=1447+1?this.x(k,u,i,F,y,c,A,P,M,p,l,b,R,o,v,L,q,d):($++,e++,[new T.$zs($,b-$+1,e,v-e+1)]);c=this.J(y-x,x,y,w),A=this.J(y+x,x,y,w);for(let W=c;W<=A;W+=2){W===c||W<A&&p[W-1]>=p[W+1]?l=p[W+1]-1:l=p[W-1],o=l-(W-y)-P;const J=l;for(;l>$&&o>e&&this.p(l,o);)l--,o--;if(p[W]=l,q&&Math.abs(W-k)<=x&&l<=M[W])return R[0]=l,L[0]=o,J>=M[W]&&1447>0&&x<=1447+1?this.x(k,u,i,F,y,c,A,P,M,p,l,b,R,o,v,L,q,d):null}if(x<=1447){let W=new Int32Array(i-u+2);W[0]=k-u+1,h.Copy2(M,u,W,1,i-u+1),this.k.push(W),W=new Int32Array(A-c+2),W[0]=y-c+1,h.Copy2(p,c,W,1,A-c+1),this.m.push(W)}}return this.x(k,u,i,F,y,c,A,P,M,p,l,b,R,o,v,L,q,d)}z($){for(let b=0;b<$.length;b++){const e=$[b],v=b<$.length-1?$[b+1].originalStart:this.f.length,R=b<$.length-1?$[b+1].modifiedStart:this.h.length,L=e.originalLength>0,d=e.modifiedLength>0;for(;e.originalStart+e.originalLength<v&&e.modifiedStart+e.modifiedLength<R&&(!L||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!d||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const o=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!o)break;e.originalStart++,e.modifiedStart++}const l=[null];if(b<$.length-1&&this.I($[b],$[b+1],l)){$[b]=l[0],$.splice(b+1,1),b--;continue}}for(let b=$.length-1;b>=0;b--){const e=$[b];let v=0,R=0;if(b>0){const i=$[b-1];v=i.originalStart+i.originalLength,R=i.modifiedStart+i.modifiedLength}const L=e.originalLength>0,d=e.modifiedLength>0;let l=0,o=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const c=e.originalStart-i,A=e.modifiedStart-i;if(c<v||A<R||L&&!this.s(c,c+e.originalLength)||d&&!this.u(A,A+e.modifiedLength))break;const w=(c===v&&A===R?5:0)+this.G(c,e.originalLength,A,e.modifiedLength);w>o&&(o=w,l=i)}e.originalStart-=l,e.modifiedStart-=l;const u=[null];if(b>0&&this.I($[b-1],$[b],u)){$[b-1]=u[0],$.splice(b,1),b++;continue}}if(this.d)for(let b=1,e=$.length;b<e;b++){const v=$[b-1],R=$[b],L=R.originalStart-v.originalStart-v.originalLength,d=v.originalStart,l=R.originalStart+R.originalLength,o=l-d,u=v.modifiedStart,i=R.modifiedStart+R.modifiedLength,c=i-u;if(L<5&&o<20&&c<20){const A=this.A(d,o,u,c,L);if(A){const[g,w]=A;(g!==v.originalStart+v.originalLength||w!==v.modifiedStart+v.modifiedLength)&&(v.originalLength=g-v.originalStart,v.modifiedLength=w-v.modifiedStart,R.originalStart=g+L,R.modifiedStart=w+L,R.originalLength=l-R.originalStart,R.modifiedLength=i-R.modifiedStart)}}}return $}A($,b,e,v,R){if(b<R||v<R)return null;const L=$+b-R+1,d=e+v-R+1;let l=0,o=0,u=0;for(let i=$;i<L;i++)for(let c=e;c<d;c++){const A=this.B(i,c,R);A>0&&A>l&&(l=A,o=i,u=c)}return l>0?[o,u]:null}B($,b,e){let v=0;for(let R=0;R<e;R++){if(!this.p($+R,b+R))return 0;v+=this.e[$+R].length}return v}C($){return $<=0||$>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[$])}D($,b){if(this.C($)||this.C($-1))return!0;if(b>0){const e=$+b;if(this.C(e-1)||this.C(e))return!0}return!1}E($){return $<=0||$>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[$])}F($,b){if(this.E($)||this.E($-1))return!0;if(b>0){const e=$+b;if(this.E(e-1)||this.E(e))return!0}return!1}G($,b,e,v){const R=this.D($,b)?1:0,L=this.F(e,v)?1:0;return R+L}H($,b){const e=[];if($.length===0||b.length===0)return b.length>0?b:$;if(this.I($[$.length-1],b[0],e)){const v=new Array($.length+b.length-1);return h.Copy($,0,v,0,$.length-1),v[$.length-1]=e[0],h.Copy(b,1,v,$.length,b.length-1),v}else{const v=new Array($.length+b.length);return h.Copy($,0,v,0,$.length),h.Copy(b,0,v,$.length,b.length),v}}I($,b,e){if(N.Assert($.originalStart<=b.originalStart,"Left change is not less than or equal to right change"),N.Assert($.modifiedStart<=b.modifiedStart,"Left change is not less than or equal to right change"),$.originalStart+$.originalLength>=b.originalStart||$.modifiedStart+$.modifiedLength>=b.modifiedStart){const v=$.originalStart;let R=$.originalLength;const L=$.modifiedStart;let d=$.modifiedLength;return $.originalStart+$.originalLength>=b.originalStart&&(R=b.originalStart+b.originalLength-$.originalStart),$.modifiedStart+$.modifiedLength>=b.modifiedStart&&(d=b.modifiedStart+b.modifiedLength-$.modifiedStart),e[0]=new T.$zs(v,R,L,d),!0}else return e[0]=null,!1}J($,b,e,v){if($>=0&&$<v)return $;const R=e,L=v-e-1,d=b%2===0;if($<0){const l=R%2===0;return d===l?0:1}else{const l=L%2===0;return d===l?v-1:v-2}}}t.$Cs=m}),ne(ie[26],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=void 0;function T(u){return typeof u=="string"}t.$zf=T;function D(u){return Array.isArray(u)&&u.every(i=>T(i))}t.$Af=D;function r(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}t.$Bf=r;function f(u){const i=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof i}t.$Cf=f;function N(u){return typeof u=="number"&&!isNaN(u)}t.$Df=N;function h(u){return!!u&&typeof u[Symbol.iterator]=="function"}t.$Ef=h;function a(u){return u===!0||u===!1}t.$Ff=a;function s(u){return typeof u>"u"}t.$Gf=s;function m(u){return!E(u)}t.$Hf=m;function E(u){return s(u)||u===null}t.$If=E;function $(u,i){if(!u)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}t.$Jf=$;function b(u){if(E(u))throw new Error("Assertion Failed: argument is undefined or null");return u}t.$Kf=b;function e(...u){const i=[];for(let c=0;c<u.length;c++){const A=u[c];if(E(A))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);i.push(A)}return i}t.$Lf=e;const v=Object.prototype.hasOwnProperty;function R(u){if(!r(u))return!1;for(const i in u)if(v.call(u,i))return!1;return!0}t.$Mf=R;function L(u){return typeof u=="function"}t.$Nf=L;function d(...u){return u.length>0&&u.every(L)}t.$Of=d;function l(u,i){const c=Math.min(u.length,i.length);for(let A=0;A<c;A++)o(u[A],i[A])}t.$Pf=l;function o(u,i){if(T(i)){if(typeof u!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(L(i)){try{if(u instanceof i)return}catch{}if(!E(u)&&u.constructor===i||i.length===1&&i.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Qf=o}),ne(ie[41],re([0,1,26]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xj=t.$Wj=t.$Vj=void 0;const D=Object.create(null);function r(h,a){if((0,T.$zf)(a)){const s=D[a];if(s===void 0)throw new Error(`${h} references an unknown codicon: ${a}`);a=s}return D[h]=a,{id:h}}function f(){return D}t.$Vj=f;function N(){return Object.values(t.$Xj)}t.$Wj=N,t.$Xj={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),ne(ie[14],re([0,1,26]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$in=t.$hn=t.$gn=t.$fn=t.$en=t.$dn=t.$cn=t.$bn=t.$an=t.$_m=t.$$m=t.$0m=void 0;function D(L){if(!L||typeof L!="object"||L instanceof RegExp)return L;const d=Array.isArray(L)?[]:{};return Object.entries(L).forEach(([l,o])=>{d[l]=o&&typeof o=="object"?D(o):o}),d}t.$0m=D;function r(L){if(!L||typeof L!="object")return L;const d=[L];for(;d.length>0;){const l=d.shift();Object.freeze(l);for(const o in l)if(f.call(l,o)){const u=l[o];typeof u=="object"&&!Object.isFrozen(u)&&!(0,T.$Cf)(u)&&d.push(u)}}return L}t.$$m=r;const f=Object.prototype.hasOwnProperty;function N(L,d){return h(L,d,new Set)}t.$_m=N;function h(L,d,l){if((0,T.$If)(L))return L;const o=d(L);if(typeof o<"u")return o;if(Array.isArray(L)){const u=[];for(const i of L)u.push(h(i,d,l));return u}if((0,T.$Bf)(L)){if(l.has(L))throw new Error("Cannot clone recursive data-structure");l.add(L);const u={};for(const i in L)f.call(L,i)&&(u[i]=h(L[i],d,l));return l.delete(L),u}return L}function a(L,d,l=!0){return(0,T.$Bf)(L)?((0,T.$Bf)(d)&&Object.keys(d).forEach(o=>{o in L?l&&((0,T.$Bf)(L[o])&&(0,T.$Bf)(d[o])?a(L[o],d[o],l):L[o]=d[o]):L[o]=d[o]}),L):d}t.$an=a;function s(L,d){if(L===d)return!0;if(L==null||d===null||d===void 0||typeof L!=typeof d||typeof L!="object"||Array.isArray(L)!==Array.isArray(d))return!1;let l,o;if(Array.isArray(L)){if(L.length!==d.length)return!1;for(l=0;l<L.length;l++)if(!s(L[l],d[l]))return!1}else{const u=[];for(o in L)u.push(o);u.sort();const i=[];for(o in d)i.push(o);if(i.sort(),!s(u,i))return!1;for(l=0;l<u.length;l++)if(!s(L[u[l]],d[u[l]]))return!1}return!0}t.$bn=s;function m(L){const d=new Set;return JSON.stringify(L,(l,o)=>{if((0,T.$Bf)(o)||Array.isArray(o)){if(d.has(o))return"[Circular]";d.add(o)}return o})}t.$cn=m;function E(L,d){const l=Object.create(null);return!L||!d||Object.keys(d).forEach(u=>{const i=L[u],c=d[u];s(i,c)||(l[u]=c)}),l}t.$dn=E;function $(L,d){const l=d.toLowerCase(),o=Object.keys(L).find(u=>u.toLowerCase()===l);return o?L[o]:L[d]}t.$en=$;function b(L,d){const l=Object.create(null);for(const[o,u]of Object.entries(L))d(o,u)&&(l[o]=u);return l}t.$fn=b;function e(L){let d=[];for(;Object.prototype!==L;)d=d.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return d}t.$gn=e;function v(L){const d=[];for(const l of e(L))typeof L[l]=="function"&&d.push(l);return d}t.$hn=v;function R(L,d){const l=u=>function(){const i=Array.prototype.slice.call(arguments,0);return d(u,i)},o={};for(const u of L)o[u]=l(u);return o}t.$in=R}),ne(ie[27],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Be=t.$Ae=t.Constants=void 0;var T;(function(f){f[f.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",f[f.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",f[f.MAX_UINT_8=255]="MAX_UINT_8",f[f.MAX_UINT_16=65535]="MAX_UINT_16",f[f.MAX_UINT_32=4294967295]="MAX_UINT_32",f[f.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(T||(t.Constants=T={}));function D(f){return f<0?0:f>255?255:f|0}t.$Ae=D;function r(f){return f<0?0:f>4294967295?4294967295:f|0}t.$Be=r}),ne(ie[28],re([0,1,27]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Us=t.$Ts=void 0;class D{constructor(h){const a=(0,T.$Ae)(h);this.c=a,this.a=D.d(a),this.b=new Map}static d(h){const a=new Uint8Array(256);return a.fill(h),a}set(h,a){const s=(0,T.$Ae)(a);h>=0&&h<256?this.a[h]=s:this.b.set(h,s)}get(h){return h>=0&&h<256?this.a[h]:this.b.get(h)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$Ts=D;var r;(function(N){N[N.False=0]="False",N[N.True=1]="True"})(r||(r={}));class f{constructor(){this.a=new D(0)}add(h){this.a.set(h,1)}has(h){return this.a.get(h)===1}clear(){return this.a.clear()}}t.$Us=f}),ne(ie[4],re([0,1,3]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Es=t.$Ds=void 0;class D{static addRange(N,h){let a=0;for(;a<h.length&&h[a].endExclusive<N.start;)a++;let s=a;for(;s<h.length&&h[s].start<=N.endExclusive;)s++;if(a===s)h.splice(a,0,N);else{const m=Math.min(N.start,h[a].start),E=Math.max(N.endExclusive,h[s-1].endExclusive);h.splice(a,s-a,new D(m,E))}}static tryCreate(N,h){if(!(N>h))return new D(N,h)}static ofLength(N){return new D(0,N)}constructor(N,h){if(this.start=N,this.endExclusive=h,N>h)throw new T.$bb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(N){return new D(this.start+N,this.endExclusive+N)}deltaStart(N){return new D(this.start+N,this.endExclusive)}deltaEnd(N){return new D(this.start,this.endExclusive+N)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(N){return this.start===N.start&&this.endExclusive===N.endExclusive}containsRange(N){return this.start<=N.start&&N.endExclusive<=this.endExclusive}contains(N){return this.start<=N&&N<this.endExclusive}join(N){return new D(Math.min(this.start,N.start),Math.max(this.endExclusive,N.endExclusive))}intersect(N){const h=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);if(h<=a)return new D(h,a)}intersectsOrTouches(N){const h=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);return h<=a}slice(N){return N.slice(this.start,this.endExclusive)}clip(N){if(this.isEmpty)throw new T.$bb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,N))}clipCyclic(N){if(this.isEmpty)throw new T.$bb(`Invalid clipping range: ${this.toString()}`);return N<this.start?this.endExclusive-(this.start-N)%this.length:N>=this.endExclusive?this.start+(N-this.start)%this.length:N}map(N){const h=[];for(let a=this.start;a<this.endExclusive;a++)h.push(N(a));return h}forEach(N){for(let h=this.start;h<this.endExclusive;h++)N(h)}}t.$Ds=D;class r{constructor(){this.a=[]}addRange(N){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<N.start;)h++;let a=h;for(;a<this.a.length&&this.a[a].start<=N.endExclusive;)a++;if(h===a)this.a.splice(h,0,N);else{const s=Math.min(N.start,this.a[h].start),m=Math.max(N.endExclusive,this.a[a-1].endExclusive);this.a.splice(h,a-h,new D(s,m))}}toString(){return this.a.map(N=>N.toString()).join(", ")}intersectsStrict(N){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<=N.start;)h++;return h<this.a.length&&this.a[h].start<N.endExclusive}intersectWithRange(N){const h=new r;for(const a of this.a){const s=a.intersect(N);s&&h.addRange(s)}return h}intersectWithRangeLength(N){return this.intersectWithRange(N).length}get length(){return this.a.reduce((N,h)=>N+h.length,0)}}t.$Es=r}),ne(ie[5],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vs=void 0;class T{constructor(r,f){this.lineNumber=r,this.column=f}with(r=this.lineNumber,f=this.column){return r===this.lineNumber&&f===this.column?this:new T(r,f)}delta(r=0,f=0){return this.with(this.lineNumber+r,this.column+f)}equals(r){return T.equals(this,r)}static equals(r,f){return!r&&!f?!0:!!r&&!!f&&r.lineNumber===f.lineNumber&&r.column===f.column}isBefore(r){return T.isBefore(this,r)}static isBefore(r,f){return r.lineNumber<f.lineNumber?!0:f.lineNumber<r.lineNumber?!1:r.column<f.column}isBeforeOrEqual(r){return T.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,f){return r.lineNumber<f.lineNumber?!0:f.lineNumber<r.lineNumber?!1:r.column<=f.column}static compare(r,f){const N=r.lineNumber|0,h=f.lineNumber|0;if(N===h){const a=r.column|0,s=f.column|0;return a-s}return N-h}clone(){return new T(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new T(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}}t.$vs=T}),ne(ie[2],re([0,1,5]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ws=void 0;class D{constructor(f,N,h,a){f>h||f===h&&N>a?(this.startLineNumber=h,this.startColumn=a,this.endLineNumber=f,this.endColumn=N):(this.startLineNumber=f,this.startColumn=N,this.endLineNumber=h,this.endColumn=a)}isEmpty(){return D.isEmpty(this)}static isEmpty(f){return f.startLineNumber===f.endLineNumber&&f.startColumn===f.endColumn}containsPosition(f){return D.containsPosition(this,f)}static containsPosition(f,N){return!(N.lineNumber<f.startLineNumber||N.lineNumber>f.endLineNumber||N.lineNumber===f.startLineNumber&&N.column<f.startColumn||N.lineNumber===f.endLineNumber&&N.column>f.endColumn)}static strictContainsPosition(f,N){return!(N.lineNumber<f.startLineNumber||N.lineNumber>f.endLineNumber||N.lineNumber===f.startLineNumber&&N.column<=f.startColumn||N.lineNumber===f.endLineNumber&&N.column>=f.endColumn)}containsRange(f){return D.containsRange(this,f)}static containsRange(f,N){return!(N.startLineNumber<f.startLineNumber||N.endLineNumber<f.startLineNumber||N.startLineNumber>f.endLineNumber||N.endLineNumber>f.endLineNumber||N.startLineNumber===f.startLineNumber&&N.startColumn<f.startColumn||N.endLineNumber===f.endLineNumber&&N.endColumn>f.endColumn)}strictContainsRange(f){return D.strictContainsRange(this,f)}static strictContainsRange(f,N){return!(N.startLineNumber<f.startLineNumber||N.endLineNumber<f.startLineNumber||N.startLineNumber>f.endLineNumber||N.endLineNumber>f.endLineNumber||N.startLineNumber===f.startLineNumber&&N.startColumn<=f.startColumn||N.endLineNumber===f.endLineNumber&&N.endColumn>=f.endColumn)}plusRange(f){return D.plusRange(this,f)}static plusRange(f,N){let h,a,s,m;return N.startLineNumber<f.startLineNumber?(h=N.startLineNumber,a=N.startColumn):N.startLineNumber===f.startLineNumber?(h=N.startLineNumber,a=Math.min(N.startColumn,f.startColumn)):(h=f.startLineNumber,a=f.startColumn),N.endLineNumber>f.endLineNumber?(s=N.endLineNumber,m=N.endColumn):N.endLineNumber===f.endLineNumber?(s=N.endLineNumber,m=Math.max(N.endColumn,f.endColumn)):(s=f.endLineNumber,m=f.endColumn),new D(h,a,s,m)}intersectRanges(f){return D.intersectRanges(this,f)}static intersectRanges(f,N){let h=f.startLineNumber,a=f.startColumn,s=f.endLineNumber,m=f.endColumn;const E=N.startLineNumber,$=N.startColumn,b=N.endLineNumber,e=N.endColumn;return h<E?(h=E,a=$):h===E&&(a=Math.max(a,$)),s>b?(s=b,m=e):s===b&&(m=Math.min(m,e)),h>s||h===s&&a>m?null:new D(h,a,s,m)}equalsRange(f){return D.equalsRange(this,f)}static equalsRange(f,N){return!f&&!N?!0:!!f&&!!N&&f.startLineNumber===N.startLineNumber&&f.startColumn===N.startColumn&&f.endLineNumber===N.endLineNumber&&f.endColumn===N.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(f){return new T.$vs(f.endLineNumber,f.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(f){return new T.$vs(f.startLineNumber,f.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(f,N){return new D(this.startLineNumber,this.startColumn,f,N)}setStartPosition(f,N){return new D(f,N,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(f){return new D(f.startLineNumber,f.startColumn,f.startLineNumber,f.startColumn)}collapseToEnd(){return D.collapseToEnd(this)}static collapseToEnd(f){return new D(f.endLineNumber,f.endColumn,f.endLineNumber,f.endColumn)}delta(f){return new D(this.startLineNumber+f,this.startColumn,this.endLineNumber+f,this.endColumn)}static fromPositions(f,N=f){return new D(f.lineNumber,f.column,N.lineNumber,N.column)}static lift(f){return f?new D(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):null}static isIRange(f){return f&&typeof f.startLineNumber=="number"&&typeof f.startColumn=="number"&&typeof f.endLineNumber=="number"&&typeof f.endColumn=="number"}static areIntersectingOrTouching(f,N){return!(f.endLineNumber<N.startLineNumber||f.endLineNumber===N.startLineNumber&&f.endColumn<N.startColumn||N.endLineNumber<f.startLineNumber||N.endLineNumber===f.startLineNumber&&N.endColumn<f.startColumn)}static areIntersecting(f,N){return!(f.endLineNumber<N.startLineNumber||f.endLineNumber===N.startLineNumber&&f.endColumn<=N.startColumn||N.endLineNumber<f.startLineNumber||N.endLineNumber===f.startLineNumber&&N.endColumn<=f.startColumn)}static compareRangesUsingStarts(f,N){if(f&&N){const s=f.startLineNumber|0,m=N.startLineNumber|0;if(s===m){const E=f.startColumn|0,$=N.startColumn|0;if(E===$){const b=f.endLineNumber|0,e=N.endLineNumber|0;if(b===e){const v=f.endColumn|0,R=N.endColumn|0;return v-R}return b-e}return E-$}return s-m}return(f?1:0)-(N?1:0)}static compareRangesUsingEnds(f,N){return f.endLineNumber===N.endLineNumber?f.endColumn===N.endColumn?f.startLineNumber===N.startLineNumber?f.startColumn-N.startColumn:f.startLineNumber-N.startLineNumber:f.endColumn-N.endColumn:f.endLineNumber-N.endLineNumber}static spansMultipleLines(f){return f.endLineNumber>f.startLineNumber}toJSON(){return this}}t.$ws=D}),ne(ie[42],re([0,1,2]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xs=void 0;class D{static insert(f,N){return{range:new T.$ws(f.lineNumber,f.column,f.lineNumber,f.column),text:N,forceMoveMarkers:!0}}static delete(f){return{range:f,text:null}}static replace(f,N){return{range:f,text:N}}static replaceMove(f,N){return{range:f,text:N,forceMoveMarkers:!0}}}t.$xs=D}),ne(ie[12],re([0,1,3,4,2,9]),function(O,t,T,D,r,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gs=t.$Fs=void 0;class N{static fromRange(s){return new N(s.startLineNumber,s.endLineNumber)}static subtract(s,m){return m?s.startLineNumber<m.startLineNumber&&m.endLineNumberExclusive<s.endLineNumberExclusive?[new N(s.startLineNumber,m.startLineNumber),new N(m.endLineNumberExclusive,s.endLineNumberExclusive)]:m.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=m.endLineNumberExclusive?[]:m.endLineNumberExclusive<s.endLineNumberExclusive?[new N(Math.max(m.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new N(s.startLineNumber,Math.min(m.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let m=new h(s[0].slice());for(let E=1;E<s.length;E++)m=m.getUnion(new h(s[E].slice()));return m.ranges}static ofLength(s,m){return new N(s,s+m)}static deserialize(s){return new N(s[0],s[1])}constructor(s,m){if(s>m)throw new T.$bb(`startLineNumber ${s} cannot be after endLineNumberExclusive ${m}`);this.startLineNumber=s,this.endLineNumberExclusive=m}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new N(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new N(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new N(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const m=Math.max(this.startLineNumber,s.startLineNumber),E=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(m<=E)return new N(m,E)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.$ws(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.$ws(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const m=[];for(let E=this.startLineNumber;E<this.endLineNumberExclusive;E++)m.push(s(E));return m}forEach(s){for(let m=this.startLineNumber;m<this.endLineNumberExclusive;m++)s(m)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new D.$Ds(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$Fs=N;class h{constructor(s=[]){this.c=s}get ranges(){return this.c}addRange(s){if(s.length===0)return;const m=(0,f.$jb)(this.c,$=>$.endLineNumberExclusive>=s.startLineNumber),E=(0,f.$hb)(this.c,$=>$.startLineNumber<=s.endLineNumberExclusive)+1;if(m===E)this.c.splice(m,0,s);else if(m===E-1){const $=this.c[m];this.c[m]=$.join(s)}else{const $=this.c[m].join(this.c[E-1]).join(s);this.c.splice(m,E-m,$)}}contains(s){const m=(0,f.$gb)(this.c,E=>E.startLineNumber<=s);return!!m&&m.endLineNumberExclusive>s}intersects(s){const m=(0,f.$gb)(this.c,E=>E.startLineNumber<s.endLineNumberExclusive);return!!m&&m.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this.c.length===0)return s;if(s.c.length===0)return this;const m=[];let E=0,$=0,b=null;for(;E<this.c.length||$<s.c.length;){let e=null;if(E<this.c.length&&$<s.c.length){const v=this.c[E],R=s.c[$];v.startLineNumber<R.startLineNumber?(e=v,E++):(e=R,$++)}else E<this.c.length?(e=this.c[E],E++):(e=s.c[$],$++);b===null?b=e:b.endLineNumberExclusive>=e.startLineNumber?b=new N(b.startLineNumber,Math.max(b.endLineNumberExclusive,e.endLineNumberExclusive)):(m.push(b),b=e)}return b!==null&&m.push(b),new h(m)}subtractFrom(s){const m=(0,f.$jb)(this.c,e=>e.endLineNumberExclusive>=s.startLineNumber),E=(0,f.$hb)(this.c,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(m===E)return new h([s]);const $=[];let b=s.startLineNumber;for(let e=m;e<E;e++){const v=this.c[e];v.startLineNumber>b&&$.push(new N(b,v.startLineNumber)),b=v.endLineNumberExclusive}return b<s.endLineNumberExclusive&&$.push(new N(b,s.endLineNumberExclusive)),new h($)}toString(){return this.c.map(s=>s.toString()).join(", ")}getIntersection(s){const m=[];let E=0,$=0;for(;E<this.c.length&&$<s.c.length;){const b=this.c[E],e=s.c[$],v=b.intersect(e);v&&!v.isEmpty&&m.push(v),b.endLineNumberExclusive<e.endLineNumberExclusive?E++:$++}return new h(m)}getWithDelta(s){return new h(this.c.map(m=>m.delta(s)))}}t.$Gs=h}),ne(ie[43],re([0,1,5,2]),function(O,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ys=t.SelectionDirection=void 0;var r;(function(N){N[N.LTR=0]="LTR",N[N.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class f extends D.$ws{constructor(h,a,s,m){super(h,a,s,m),this.selectionStartLineNumber=h,this.selectionStartColumn=a,this.positionLineNumber=s,this.positionColumn=m}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return f.selectionsEqual(this,h)}static selectionsEqual(h,a){return h.selectionStartLineNumber===a.selectionStartLineNumber&&h.selectionStartColumn===a.selectionStartColumn&&h.positionLineNumber===a.positionLineNumber&&h.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,a){return this.getDirection()===0?new f(this.startLineNumber,this.startColumn,h,a):new f(h,a,this.startLineNumber,this.startColumn)}getPosition(){return new T.$vs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new T.$vs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,a){return this.getDirection()===0?new f(h,a,this.endLineNumber,this.endColumn):new f(this.endLineNumber,this.endColumn,h,a)}static fromPositions(h,a=h){return new f(h.lineNumber,h.column,a.lineNumber,a.column)}static fromRange(h,a){return a===0?new f(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new f(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new f(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,a){if(h&&!a||!h&&a)return!1;if(!h&&!a)return!0;if(h.length!==a.length)return!1;for(let s=0,m=h.length;s<m;s++)if(!this.selectionsEqual(h[s],a[s]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,a,s,m,E){return E===0?new f(h,a,s,m):new f(s,m,h,a)}}t.$ys=f}),ne(ie[44],re([0,1,28]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ws=t.$Vs=t.WordCharacterClass=void 0;var D;(function(N){N[N.Regular=0]="Regular",N[N.Whitespace=1]="Whitespace",N[N.WordSeparator=2]="WordSeparator"})(D||(t.WordCharacterClass=D={}));class r extends T.$Ts{constructor(h){super(0);for(let a=0,s=h.length;a<s;a++)this.set(h.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}t.$Vs=r;function f(N){const h={};return a=>(h.hasOwnProperty(a)||(h[a]=N(a)),h[a])}t.$Ws=f(N=>new r(N))}),ne(ie[29],re([0,1,20,10,21]),function(O,t,T,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$r=t.$0r=t.$9r=t.$8r=t.$7r=void 0,t.$7r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(E=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const b of t.$7r)E.indexOf(b)>=0||($+="\\"+b);return $+="\\s]+)",new RegExp($,"g")}t.$8r=f();function N(E){let $=t.$8r;if(E&&E instanceof RegExp)if(E.global)$=E;else{let b="g";E.ignoreCase&&(b+="i"),E.multiline&&(b+="m"),E.unicode&&(b+="u"),$=new RegExp(E.source,b)}return $.lastIndex=0,$}t.$9r=N;const h=new r.$1c;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(E){const $=h.unshift(E);return(0,D.$Pc)($)}t.$0r=a;function s(E,$,b,e,v){if(v||(v=T.Iterable.first(h)),b.length>v.maxLen){let o=E-v.maxLen/2;return o<0?o=0:e+=o,b=b.substring(o,E+v.maxLen/2),s(E,$,b,e,v)}const R=Date.now(),L=E-1-e;let d=-1,l=null;for(let o=1;!(Date.now()-R>=v.timeBudget);o++){const u=L-v.windowSize*o;$.lastIndex=Math.max(0,u);const i=m($,b,L,d);if(!i&&l||(l=i,u<=0))break;d=u}if(l){const o={word:l[0],startColumn:e+1+l.index,endColumn:e+1+l.index+l[0].length};return $.lastIndex=0,o}return null}t.$$r=s;function m(E,$,b,e){let v;for(;v=E.exec($);){const R=v.index||0;if(R<=b&&E.lastIndex>=b)return v;if(e>0&&R>e)return null}return null}}),ne(ie[8],re([0,1,6,3,4]),function(O,t,T,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LZ=t.$KZ=t.$JZ=t.$IZ=t.$HZ=void 0;class f{static trivial(E,$){return new f([new N(r.$Ds.ofLength(E.length),r.$Ds.ofLength($.length))],!1)}static trivialTimedOut(E,$){return new f([new N(r.$Ds.ofLength(E.length),r.$Ds.ofLength($.length))],!0)}constructor(E,$){this.diffs=E,this.hitTimeout=$}}t.$HZ=f;class N{static invert(E,$){const b=[];return(0,T.$Ab)(E,(e,v)=>{b.push(N.fromOffsetPairs(e?e.getEndExclusives():h.zero,v?v.getStarts():new h($,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+$)))}),b}static fromOffsetPairs(E,$){return new N(new r.$Ds(E.offset1,$.offset1),new r.$Ds(E.offset2,$.offset2))}constructor(E,$){this.seq1Range=E,this.seq2Range=$}swap(){return new N(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(E){return new N(this.seq1Range.join(E.seq1Range),this.seq2Range.join(E.seq2Range))}delta(E){return E===0?this:new N(this.seq1Range.delta(E),this.seq2Range.delta(E))}deltaStart(E){return E===0?this:new N(this.seq1Range.deltaStart(E),this.seq2Range.deltaStart(E))}deltaEnd(E){return E===0?this:new N(this.seq1Range.deltaEnd(E),this.seq2Range.deltaEnd(E))}intersectsOrTouches(E){return this.seq1Range.intersectsOrTouches(E.seq1Range)||this.seq2Range.intersectsOrTouches(E.seq2Range)}intersect(E){const $=this.seq1Range.intersect(E.seq1Range),b=this.seq2Range.intersect(E.seq2Range);if(!(!$||!b))return new N($,b)}getStarts(){return new h(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new h(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$IZ=N;class h{static{this.zero=new h(0,0)}static{this.max=new h(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(E,$){this.offset1=E,this.offset2=$}toString(){return`${this.offset1} <-> ${this.offset2}`}}t.$JZ=h;class a{static{this.instance=new a}isValid(){return!0}}t.$KZ=a;class s{constructor(E){if(this.e=E,this.c=Date.now(),this.d=!0,E<=0)throw new D.$bb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$LZ=s}),ne(ie[30],re([0,1,4,8]),function(O,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QZ=void 0;class r{compute(s,m,E=D.$KZ.instance){if(s.length===0||m.length===0)return D.$HZ.trivial(s,m);const $=s,b=m;function e(c,A){for(;c<$.length&&A<b.length&&$.getElement(c)===b.getElement(A);)c++,A++;return c}let v=0;const R=new N;R.set(0,e(0,0));const L=new h;L.set(0,R.get(0)===0?null:new f(null,0,0,R.get(0)));let d=0;e:for(;;){if(v++,!E.isValid())return D.$HZ.trivialTimedOut($,b);const c=-Math.min(v,b.length+v%2),A=Math.min(v,$.length+v%2);for(d=c;d<=A;d+=2){let g=0;const w=d===A?-1:R.get(d+1),M=d===c?-1:R.get(d-1)+1;g++;const p=Math.min(Math.max(w,M),$.length),k=p-d;if(g++,p>$.length||k>b.length)continue;const y=e(p,k);R.set(d,y);const F=p===w?L.get(d+1):L.get(d-1);if(L.set(d,y!==p?new f(F,p,k,y-p):F),R.get(d)===$.length&&R.get(d)-d===b.length)break e}}let l=L.get(d);const o=[];let u=$.length,i=b.length;for(;;){const c=l?l.x+l.length:0,A=l?l.y+l.length:0;if((c!==u||A!==i)&&o.push(new D.$IZ(new T.$Ds(c,u),new T.$Ds(A,i))),!l)break;u=l.x,i=l.y,l=l.prev}return o.reverse(),new D.$HZ(o,!1)}}t.$QZ=r;class f{constructor(s,m,E,$){this.prev=s,this.x=m,this.y=E,this.length=$}}class N{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,m){if(s<0){if(s=-s-1,s>=this.b.length){const E=this.b;this.b=new Int32Array(E.length*2),this.b.set(E)}this.b[s]=m}else{if(s>=this.a.length){const E=this.a;this.a=new Int32Array(E.length*2),this.a.set(E)}this.a[s]=m}}}class h{constructor(){this.a=[],this.b=[]}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,m){s<0?(s=-s-1,this.b[s]=m):this.a[s]=m}}}),ne(ie[45],re([0,1,6,4,8]),function(O,t,T,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YZ=t.$XZ=t.$WZ=t.$VZ=t.$UZ=void 0;function f(e,v,R){let L=R;return L=N(e,v,L),L=N(e,v,L),L=h(e,v,L),L}t.$UZ=f;function N(e,v,R){if(R.length===0)return R;const L=[];L.push(R[0]);for(let l=1;l<R.length;l++){const o=L[L.length-1];let u=R[l];if(u.seq1Range.isEmpty||u.seq2Range.isEmpty){const i=u.seq1Range.start-o.seq1Range.endExclusive;let c;for(c=1;c<=i&&!(e.getElement(u.seq1Range.start-c)!==e.getElement(u.seq1Range.endExclusive-c)||v.getElement(u.seq2Range.start-c)!==v.getElement(u.seq2Range.endExclusive-c));c++);if(c--,c===i){L[L.length-1]=new r.$IZ(new D.$Ds(o.seq1Range.start,u.seq1Range.endExclusive-i),new D.$Ds(o.seq2Range.start,u.seq2Range.endExclusive-i));continue}u=u.delta(-c)}L.push(u)}const d=[];for(let l=0;l<L.length-1;l++){const o=L[l+1];let u=L[l];if(u.seq1Range.isEmpty||u.seq2Range.isEmpty){const i=o.seq1Range.start-u.seq1Range.endExclusive;let c;for(c=0;c<i&&!(!e.isStronglyEqual(u.seq1Range.start+c,u.seq1Range.endExclusive+c)||!v.isStronglyEqual(u.seq2Range.start+c,u.seq2Range.endExclusive+c));c++);if(c===i){L[l+1]=new r.$IZ(new D.$Ds(u.seq1Range.start+i,o.seq1Range.endExclusive),new D.$Ds(u.seq2Range.start+i,o.seq2Range.endExclusive));continue}c>0&&(u=u.delta(c))}d.push(u)}return L.length>0&&d.push(L[L.length-1]),d}function h(e,v,R){if(!e.getBoundaryScore||!v.getBoundaryScore)return R;for(let L=0;L<R.length;L++){const d=L>0?R[L-1]:void 0,l=R[L],o=L+1<R.length?R[L+1]:void 0,u=new D.$Ds(d?d.seq1Range.start+1:0,o?o.seq1Range.endExclusive-1:e.length),i=new D.$Ds(d?d.seq2Range.start+1:0,o?o.seq2Range.endExclusive-1:v.length);l.seq1Range.isEmpty?R[L]=a(l,e,v,u,i):l.seq2Range.isEmpty&&(R[L]=a(l.swap(),v,e,i,u).swap())}return R}function a(e,v,R,L,d){let o=1;for(;e.seq1Range.start-o>=L.start&&e.seq2Range.start-o>=d.start&&R.isStronglyEqual(e.seq2Range.start-o,e.seq2Range.endExclusive-o)&&o<100;)o++;o--;let u=0;for(;e.seq1Range.start+u<L.endExclusive&&e.seq2Range.endExclusive+u<d.endExclusive&&R.isStronglyEqual(e.seq2Range.start+u,e.seq2Range.endExclusive+u)&&u<100;)u++;if(o===0&&u===0)return e;let i=0,c=-1;for(let A=-o;A<=u;A++){const g=e.seq2Range.start+A,w=e.seq2Range.endExclusive+A,M=e.seq1Range.start+A,p=v.getBoundaryScore(M)+R.getBoundaryScore(g)+R.getBoundaryScore(w);p>c&&(c=p,i=A)}return e.delta(i)}function s(e,v,R){const L=[];for(const d of R){const l=L[L.length-1];if(!l){L.push(d);continue}d.seq1Range.start-l.seq1Range.endExclusive<=2||d.seq2Range.start-l.seq2Range.endExclusive<=2?L[L.length-1]=new r.$IZ(l.seq1Range.join(d.seq1Range),l.seq2Range.join(d.seq2Range)):L.push(d)}return L}t.$VZ=s;function m(e,v,R){const L=[];let d;function l(){if(!d)return;const u=d.s1Range.length-d.deleted,i=d.s2Range.length-d.added;Math.max(d.deleted,d.added)+(d.count-1)>u&&L.push(new r.$IZ(d.s1Range,d.s2Range)),d=void 0}for(const u of R){let i=function(M,p){if(!d||!d.s1Range.containsRange(M)||!d.s2Range.containsRange(p))if(d&&!(d.s1Range.endExclusive<M.start&&d.s2Range.endExclusive<p.start)){const F=D.$Ds.tryCreate(d.s1Range.endExclusive,M.start),P=D.$Ds.tryCreate(d.s2Range.endExclusive,p.start);d.deleted+=F?.length??0,d.added+=P?.length??0,d.s1Range=d.s1Range.join(M),d.s2Range=d.s2Range.join(p)}else l(),d={added:0,deleted:0,count:0,s1Range:M,s2Range:p};const k=M.intersect(u.seq1Range),y=p.intersect(u.seq2Range);d.count++,d.deleted+=k?.length??0,d.added+=y?.length??0};const c=e.findWordContaining(u.seq1Range.start-1),A=v.findWordContaining(u.seq2Range.start-1),g=e.findWordContaining(u.seq1Range.endExclusive),w=v.findWordContaining(u.seq2Range.endExclusive);c&&g&&A&&w&&c.equals(g)&&A.equals(w)?i(c,A):(c&&A&&i(c,A),g&&w&&i(g,w))}return l(),E(R,L)}t.$WZ=m;function E(e,v){const R=[];for(;e.length>0||v.length>0;){const L=e[0],d=v[0];let l;L&&(!d||L.seq1Range.start<d.seq1Range.start)?l=e.shift():l=v.shift(),R.length>0&&R[R.length-1].seq1Range.endExclusive>=l.seq1Range.start?R[R.length-1]=R[R.length-1].join(l):R.push(l)}return R}function $(e,v,R){let L=R;if(L.length===0)return L;let d=0,l;do{l=!1;const o=[L[0]];for(let u=1;u<L.length;u++){let A=function(w,M){const p=new D.$Ds(c.seq1Range.endExclusive,i.seq1Range.start);return e.getText(p).replace(/\s/g,"").length<=4&&(w.seq1Range.length+w.seq2Range.length>5||M.seq1Range.length+M.seq2Range.length>5)};const i=L[u],c=o[o.length-1];A(c,i)?(l=!0,o[o.length-1]=o[o.length-1].join(i)):o.push(i)}L=o}while(d++<10&&l);return L}t.$XZ=$;function b(e,v,R){let L=R;if(L.length===0)return L;let d=0,l;do{l=!1;const u=[L[0]];for(let i=1;i<L.length;i++){let g=function(M,p){const k=new D.$Ds(A.seq1Range.endExclusive,c.seq1Range.start);if(e.countLinesIn(k)>5||k.length>500)return!1;const F=e.getText(k).trim();if(F.length>20||F.split(/\r\n|\r|\n/).length>1)return!1;const P=e.countLinesIn(M.seq1Range),I=M.seq1Range.length,q=v.countLinesIn(M.seq2Range),x=M.seq2Range.length,_=e.countLinesIn(p.seq1Range),j=p.seq1Range.length,H=v.countLinesIn(p.seq2Range),W=p.seq2Range.length,J=2*40+50;function n(te){return Math.min(te,J)}return Math.pow(Math.pow(n(P*40+I),1.5)+Math.pow(n(q*40+x),1.5),1.5)+Math.pow(Math.pow(n(_*40+j),1.5)+Math.pow(n(H*40+W),1.5),1.5)>(J**1.5)**1.5*1.3};const c=L[i],A=u[u.length-1];g(A,c)?(l=!0,u[u.length-1]=u[u.length-1].join(c)):u.push(c)}L=u}while(d++<10&&l);const o=[];return(0,T.$Bb)(L,(u,i,c)=>{let A=i;function g(F){return F.length>0&&F.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const w=e.extendToFullLines(i.seq1Range),M=e.getText(new D.$Ds(w.start,i.seq1Range.start));g(M)&&(A=A.deltaStart(-M.length));const p=e.getText(new D.$Ds(i.seq1Range.endExclusive,w.endExclusive));g(p)&&(A=A.deltaEnd(p.length));const k=r.$IZ.fromOffsetPairs(u?u.getEndExclusives():r.$JZ.zero,c?c.getStarts():r.$JZ.max),y=A.intersect(k);o.push(y)}),o}t.$YZ=b}),ne(ie[46],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TZ=void 0;class T{constructor(f,N){this.a=f,this.b=N}getElement(f){return this.a[f]}get length(){return this.a.length}getBoundaryScore(f){const N=f===0?0:D(this.b[f-1]),h=f===this.b.length?0:D(this.b[f]);return 1e3-(N+h)}getText(f){return this.b.slice(f.start,f.endExclusive).join(`
`)}isStronglyEqual(f,N){return this.b[f]===this.b[N]}}t.$TZ=T;function D(r){let f=0;for(;f<r.length&&(r.charCodeAt(f)===32||r.charCodeAt(f)===9);)f++;return f}}),ne(ie[15],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OZ=t.$NZ=t.$MZ=void 0;class T{constructor(N,h){this.width=N,this.height=h,this.a=[],this.a=new Array(N*h)}get(N,h){return this.a[N+h*this.width]}set(N,h,a){this.a[N+h*this.width]=a}}t.$MZ=T;function D(f){return f===32||f===9}t.$NZ=D;class r{static{this.a=new Map}static b(N){let h=this.a.get(N);return h===void 0&&(h=this.a.size,this.a.set(N,h)),h}constructor(N,h,a){this.range=N,this.lines=h,this.source=a,this.d=[];let s=0;for(let m=N.startLineNumber-1;m<N.endLineNumberExclusive-1;m++){const E=h[m];for(let b=0;b<E.length;b++){s++;const e=E[b],v=r.b(e);this.d[v]=(this.d[v]||0)+1}s++;const $=r.b(`
`);this.d[$]=(this.d[$]||0)+1}this.c=s}computeSimilarity(N){let h=0;const a=Math.max(this.d.length,N.d.length);for(let s=0;s<a;s++)h+=Math.abs((this.d[s]??0)-(N.d[s]??0));return 1-h/(this.c+N.c)}}t.$OZ=r}),ne(ie[47],re([0,1,4,8,15]),function(O,t,T,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PZ=void 0;class f{compute(h,a,s=D.$KZ.instance,m){if(h.length===0||a.length===0)return D.$HZ.trivial(h,a);const E=new r.$MZ(h.length,a.length),$=new r.$MZ(h.length,a.length),b=new r.$MZ(h.length,a.length);for(let o=0;o<h.length;o++)for(let u=0;u<a.length;u++){if(!s.isValid())return D.$HZ.trivialTimedOut(h,a);const i=o===0?0:E.get(o-1,u),c=u===0?0:E.get(o,u-1);let A;h.getElement(o)===a.getElement(u)?(o===0||u===0?A=0:A=E.get(o-1,u-1),o>0&&u>0&&$.get(o-1,u-1)===3&&(A+=b.get(o-1,u-1)),A+=m?m(o,u):1):A=-1;const g=Math.max(i,c,A);if(g===A){const w=o>0&&u>0?b.get(o-1,u-1):0;b.set(o,u,w+1),$.set(o,u,3)}else g===i?(b.set(o,u,0),$.set(o,u,1)):g===c&&(b.set(o,u,0),$.set(o,u,2));E.set(o,u,g)}const e=[];let v=h.length,R=a.length;function L(o,u){(o+1!==v||u+1!==R)&&e.push(new D.$IZ(new T.$Ds(o+1,v),new T.$Ds(u+1,R))),v=o,R=u}let d=h.length-1,l=a.length-1;for(;d>=0&&l>=0;)$.get(d,l)===3?(L(d,l),d--,l--):$.get(d,l)===1?d--:l--;return L(-1,-1),e.reverse(),new D.$HZ(e,!1)}}t.$PZ=f}),ne(ie[31],re([0,1,9,4,5,2,15]),function(O,t,T,D,r,f,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RZ=void 0;class h{constructor(e,v,R){this.lines=e,this.considerWhitespaceChanges=R,this.b=[],this.c=[],this.d=[];let L=!1;v.start>0&&v.endExclusive>=e.length&&(v=new D.$Ds(v.start-1,v.endExclusive),L=!0),this.lineRange=v,this.c[0]=0;for(let d=this.lineRange.start;d<this.lineRange.endExclusive;d++){let l=e[d],o=0;if(L)o=l.length,l="",L=!1;else if(!R){const u=l.trimStart();o=l.length-u.length,l=u.trimEnd()}this.d.push(o);for(let u=0;u<l.length;u++)this.b.push(l.charCodeAt(u));d<e.length-1&&(this.b.push(`
`.charCodeAt(0)),this.c[d-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new D.$Ds(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(v=>String.fromCharCode(v)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const v=$(e>0?this.b[e-1]:-1),R=$(e<this.b.length?this.b[e]:-1);if(v===7&&R===8)return 0;let L=0;return v!==R&&(L+=10,v===0&&R===1&&(L+=1)),L+=E(v),L+=E(R),L}translateOffset(e){if(this.lineRange.isEmpty)return new r.$vs(this.lineRange.start+1,1);const v=(0,T.$hb)(this.c,R=>R<=e);return new r.$vs(this.lineRange.start+v+1,e-this.c[v]+this.d[v]+1)}translateRange(e){return f.$ws.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!a(this.b[e]))return;let v=e;for(;v>0&&a(this.b[v-1]);)v--;let R=e;for(;R<this.b.length&&a(this.b[R]);)R++;return new D.$Ds(v,R)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,v){return this.b[e]===this.b[v]}extendToFullLines(e){const v=(0,T.$gb)(this.c,L=>L<=e.start)??0,R=(0,T.$ib)(this.c,L=>e.endExclusive<=L)??this.b.length;return new D.$Ds(v,R)}}t.$RZ=h;function a(b){return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57}var s;(function(b){b[b.WordLower=0]="WordLower",b[b.WordUpper=1]="WordUpper",b[b.WordNumber=2]="WordNumber",b[b.End=3]="End",b[b.Other=4]="Other",b[b.Separator=5]="Separator",b[b.Space=6]="Space",b[b.LineBreakCR=7]="LineBreakCR",b[b.LineBreakLF=8]="LineBreakLF"})(s||(s={}));const m={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:3,[7]:10,[8]:10};function E(b){return m[b]}function $(b){return b===10?8:b===13?7:(0,N.$NZ)(b)?6:b>=97&&b<=122?0:b>=65&&b<=90?1:b>=48&&b<=57?2:b===-1?3:b===44||b===59?5:4}}),ne(ie[32],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ls=t.$Ks=void 0;class T{constructor(f,N,h){this.changes=f,this.moves=N,this.hitTimeout=h}}t.$Ks=T;class D{constructor(f,N){this.lineRangeMapping=f,this.changes=N}flip(){return new D(this.lineRangeMapping.flip(),this.changes.map(f=>f.flip()))}}t.$Ls=D}),ne(ie[16],re([0,1,12]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Js=t.$Is=t.$Hs=void 0;class D{static inverse(h,a,s){const m=[];let E=1,$=1;for(const e of h){const v=new r(new T.$Fs(E,e.original.startLineNumber),new T.$Fs($,e.modified.startLineNumber),void 0);v.modified.isEmpty||m.push(v),E=e.original.endLineNumberExclusive,$=e.modified.endLineNumberExclusive}const b=new r(new T.$Fs(E,a+1),new T.$Fs($,s+1),void 0);return b.modified.isEmpty||m.push(b),m}constructor(h,a){this.original=h,this.modified=a}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new D(this.modified,this.original)}join(h){return new D(this.original.join(h.original),this.modified.join(h.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$Hs=D;class r extends D{constructor(h,a,s){super(h,a),this.innerChanges=s}flip(){return new r(this.modified,this.original,this.innerChanges?.map(h=>h.flip()))}}t.$Is=r;class f{constructor(h,a){this.originalRange=h,this.modifiedRange=a}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new f(this.modifiedRange,this.originalRange)}}t.$Js=f}),ne(ie[48],re([0,1,8,16,6,9,22,12,4,31,15,30]),function(O,t,T,D,r,f,N,h,a,s,m,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SZ=void 0;function $(l,o,u,i,c,A){let{moves:g,excludedChanges:w}=e(l,o,u,A);if(!A.isValid())return[];const M=l.filter(k=>!w.has(k)),p=v(M,i,c,o,u,A);return(0,r.$Zb)(g,p),g=L(g),g=g.filter(k=>{const y=k.original.toOffsetRange().slice(o).map(P=>P.trim());return y.join(`
`).length>=15&&b(y,P=>P.length>=2)>=2}),g=d(l,g),g}t.$SZ=$;function b(l,o){let u=0;for(const i of l)o(i)&&u++;return u}function e(l,o,u,i){const c=[],A=l.filter(M=>M.modified.isEmpty&&M.original.length>=3).map(M=>new m.$OZ(M.original,o,M)),g=new Set(l.filter(M=>M.original.isEmpty&&M.modified.length>=3).map(M=>new m.$OZ(M.modified,u,M))),w=new Set;for(const M of A){let p=-1,k;for(const y of g){const F=M.computeSimilarity(y);F>p&&(p=F,k=y)}if(p>.9&&k&&(g.delete(k),c.push(new D.$Hs(M.range,k.range)),w.add(M.source),w.add(k.source)),!i.isValid())return{moves:c,excludedChanges:w}}return{moves:c,excludedChanges:w}}function v(l,o,u,i,c,A){const g=[],w=new N.$Fc;for(const F of l)for(let P=F.original.startLineNumber;P<F.original.endLineNumberExclusive-2;P++){const I=`${o[P-1]}:${o[P+1-1]}:${o[P+2-1]}`;w.add(I,{range:new h.$Fs(P,P+3)})}const M=[];l.sort((0,r.$6b)(F=>F.modified.startLineNumber,r.$8b));for(const F of l){let P=[];for(let I=F.modified.startLineNumber;I<F.modified.endLineNumberExclusive-2;I++){const q=`${u[I-1]}:${u[I+1-1]}:${u[I+2-1]}`,x=new h.$Fs(I,I+3),_=[];w.forEach(q,({range:j})=>{for(const W of P)if(W.originalLineRange.endLineNumberExclusive+1===j.endLineNumberExclusive&&W.modifiedLineRange.endLineNumberExclusive+1===x.endLineNumberExclusive){W.originalLineRange=new h.$Fs(W.originalLineRange.startLineNumber,j.endLineNumberExclusive),W.modifiedLineRange=new h.$Fs(W.modifiedLineRange.startLineNumber,x.endLineNumberExclusive),_.push(W);return}const H={modifiedLineRange:x,originalLineRange:j};M.push(H),_.push(H)}),P=_}if(!A.isValid())return[]}M.sort((0,r.$0b)((0,r.$6b)(F=>F.modifiedLineRange.length,r.$8b)));const p=new h.$Gs,k=new h.$Gs;for(const F of M){const P=F.modifiedLineRange.startLineNumber-F.originalLineRange.startLineNumber,I=p.subtractFrom(F.modifiedLineRange),q=k.subtractFrom(F.originalLineRange).getWithDelta(P),x=I.getIntersection(q);for(const _ of x.ranges){if(_.length<3)continue;const j=_,H=_.delta(-P);g.push(new D.$Hs(H,j)),p.addRange(j),k.addRange(H)}}g.sort((0,r.$6b)(F=>F.original.startLineNumber,r.$8b));const y=new f.$lb(l);for(let F=0;F<g.length;F++){const P=g[F],I=y.findLastMonotonous(n=>n.original.startLineNumber<=P.original.startLineNumber),q=(0,f.$gb)(l,n=>n.modified.startLineNumber<=P.modified.startLineNumber),x=Math.max(P.original.startLineNumber-I.original.startLineNumber,P.modified.startLineNumber-q.modified.startLineNumber),_=y.findLastMonotonous(n=>n.original.startLineNumber<P.original.endLineNumberExclusive),j=(0,f.$gb)(l,n=>n.modified.startLineNumber<P.modified.endLineNumberExclusive),H=Math.max(_.original.endLineNumberExclusive-P.original.endLineNumberExclusive,j.modified.endLineNumberExclusive-P.modified.endLineNumberExclusive);let W;for(W=0;W<x;W++){const n=P.original.startLineNumber-W-1,te=P.modified.startLineNumber-W-1;if(n>i.length||te>c.length||p.contains(te)||k.contains(n)||!R(i[n-1],c[te-1],A))break}W>0&&(k.addRange(new h.$Fs(P.original.startLineNumber-W,P.original.startLineNumber)),p.addRange(new h.$Fs(P.modified.startLineNumber-W,P.modified.startLineNumber)));let J;for(J=0;J<H;J++){const n=P.original.endLineNumberExclusive+J,te=P.modified.endLineNumberExclusive+J;if(n>i.length||te>c.length||p.contains(te)||k.contains(n)||!R(i[n-1],c[te-1],A))break}J>0&&(k.addRange(new h.$Fs(P.original.endLineNumberExclusive,P.original.endLineNumberExclusive+J)),p.addRange(new h.$Fs(P.modified.endLineNumberExclusive,P.modified.endLineNumberExclusive+J))),(W>0||J>0)&&(g[F]=new D.$Hs(new h.$Fs(P.original.startLineNumber-W,P.original.endLineNumberExclusive+J),new h.$Fs(P.modified.startLineNumber-W,P.modified.endLineNumberExclusive+J)))}return g}function R(l,o,u){if(l.trim()===o.trim())return!0;if(l.length>300&&o.length>300)return!1;const c=new E.$QZ().compute(new s.$RZ([l],new a.$Ds(0,1),!1),new s.$RZ([o],new a.$Ds(0,1),!1),u);let A=0;const g=T.$IZ.invert(c.diffs,l.length);for(const k of g)k.seq1Range.forEach(y=>{(0,m.$NZ)(l.charCodeAt(y))||A++});function w(k){let y=0;for(let F=0;F<l.length;F++)(0,m.$NZ)(k.charCodeAt(F))||y++;return y}const M=w(l.length>o.length?l:o);return A/M>.6&&M>10}function L(l){if(l.length===0)return l;l.sort((0,r.$6b)(u=>u.original.startLineNumber,r.$8b));const o=[l[0]];for(let u=1;u<l.length;u++){const i=o[o.length-1],c=l[u],A=c.original.startLineNumber-i.original.endLineNumberExclusive,g=c.modified.startLineNumber-i.modified.endLineNumberExclusive;if(A>=0&&g>=0&&A+g<=2){o[o.length-1]=i.join(c);continue}o.push(c)}return o}function d(l,o){const u=new f.$lb(l);return o=o.filter(i=>{const c=u.findLastMonotonous(w=>w.original.startLineNumber<i.original.endLineNumberExclusive)||new D.$Hs(new h.$Fs(1,1),new h.$Fs(1,1)),A=(0,f.$gb)(l,w=>w.modified.startLineNumber<i.modified.endLineNumberExclusive);return c!==A}),o}}),ne(ie[49],re([0,1,6,13,12,4,2,8,47,30,48,45,32,16,31,46]),function(O,t,T,D,r,f,N,h,a,s,m,E,$,b,e,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2Z=t.$1Z=t.$ZZ=void 0;class R{constructor(){this.e=new a.$PZ,this.f=new s.$QZ}computeDiff(o,u,i){if(o.length<=1&&(0,T.$tb)(o,u,(J,n)=>J===n))return new $.$Ks([],[],!1);if(o.length===1&&o[0].length===0||u.length===1&&u[0].length===0)return new $.$Ks([new b.$Is(new r.$Fs(1,o.length+1),new r.$Fs(1,u.length+1),[new b.$Js(new N.$ws(1,1,o.length,o[0].length+1),new N.$ws(1,1,u.length,u[0].length+1))])],[],!1);const c=i.maxComputationTimeMs===0?h.$KZ.instance:new h.$LZ(i.maxComputationTimeMs),A=!i.ignoreTrimWhitespace,g=new Map;function w(J){let n=g.get(J);return n===void 0&&(n=g.size,g.set(J,n)),n}const M=o.map(J=>w(J.trim())),p=u.map(J=>w(J.trim())),k=new v.$TZ(M,o),y=new v.$TZ(p,u),F=(()=>k.length+y.length<1700?this.e.compute(k,y,c,(J,n)=>o[J]===u[n]?u[n].length===0?.1:1+Math.log(1+u[n].length):.99):this.f.compute(k,y))();let P=F.diffs,I=F.hitTimeout;P=(0,E.$UZ)(k,y,P),P=(0,E.$XZ)(k,y,P);const q=[],x=J=>{if(A)for(let n=0;n<J;n++){const te=_+n,ce=j+n;if(o[te]!==u[ce]){const ge=this.j(o,u,new h.$IZ(new f.$Ds(te,te+1),new f.$Ds(ce,ce+1)),c,A);for(const Le of ge.mappings)q.push(Le);ge.hitTimeout&&(I=!0)}}};let _=0,j=0;for(const J of P){(0,D.$5c)(()=>J.seq1Range.start-_===J.seq2Range.start-j);const n=J.seq1Range.start-_;x(n),_=J.seq1Range.endExclusive,j=J.seq2Range.endExclusive;const te=this.j(o,u,J,c,A);te.hitTimeout&&(I=!0);for(const ce of te.mappings)q.push(ce)}x(o.length-_);const H=L(q,o,u);let W=[];return i.computeMoves&&(W=this.h(H,o,u,M,p,c,A)),(0,D.$5c)(()=>{function J(te,ce){if(te.lineNumber<1||te.lineNumber>ce.length)return!1;const ge=ce[te.lineNumber-1];return!(te.column<1||te.column>ge.length+1)}function n(te,ce){return!(te.startLineNumber<1||te.startLineNumber>ce.length+1||te.endLineNumberExclusive<1||te.endLineNumberExclusive>ce.length+1)}for(const te of H){if(!te.innerChanges)return!1;for(const ce of te.innerChanges)if(!(J(ce.modifiedRange.getStartPosition(),u)&&J(ce.modifiedRange.getEndPosition(),u)&&J(ce.originalRange.getStartPosition(),o)&&J(ce.originalRange.getEndPosition(),o)))return!1;if(!n(te.modified,u)||!n(te.original,o))return!1}return!0}),new $.$Ks(H,W,I)}h(o,u,i,c,A,g,w){return(0,m.$SZ)(o,u,i,c,A,g).map(k=>{const y=this.j(u,i,new h.$IZ(k.original.toOffsetRange(),k.modified.toOffsetRange()),g,w),F=L(y.mappings,u,i,!0);return new $.$Ls(k,F)})}j(o,u,i,c,A){const g=new e.$RZ(o,i.seq1Range,A),w=new e.$RZ(u,i.seq2Range,A),M=g.length+w.length<500?this.e.compute(g,w,c):this.f.compute(g,w,c);let p=M.diffs;return p=(0,E.$UZ)(g,w,p),p=(0,E.$WZ)(g,w,p),p=(0,E.$VZ)(g,w,p),p=(0,E.$YZ)(g,w,p),{mappings:p.map(y=>new b.$Js(g.translateRange(y.seq1Range),w.translateRange(y.seq2Range))),hitTimeout:M.hitTimeout}}}t.$ZZ=R;function L(l,o,u,i=!1){const c=[];for(const A of(0,T.$zb)(l.map(g=>d(g,o,u)),(g,w)=>g.original.overlapOrTouch(w.original)||g.modified.overlapOrTouch(w.modified))){const g=A[0],w=A[A.length-1];c.push(new b.$Is(g.original.join(w.original),g.modified.join(w.modified),A.map(M=>M.innerChanges[0])))}return(0,D.$5c)(()=>!i&&c.length>0&&c[0].original.startLineNumber!==c[0].modified.startLineNumber?!1:(0,D.$6c)(c,(A,g)=>g.original.startLineNumber-A.original.endLineNumberExclusive===g.modified.startLineNumber-A.modified.endLineNumberExclusive&&A.original.endLineNumberExclusive<g.original.startLineNumber&&A.modified.endLineNumberExclusive<g.modified.startLineNumber)),c}t.$1Z=L;function d(l,o,u){let i=0,c=0;l.modifiedRange.endColumn===1&&l.originalRange.endColumn===1&&l.originalRange.startLineNumber+i<=l.originalRange.endLineNumber&&l.modifiedRange.startLineNumber+i<=l.modifiedRange.endLineNumber&&(c=-1),l.modifiedRange.startColumn-1>=u[l.modifiedRange.startLineNumber-1].length&&l.originalRange.startColumn-1>=o[l.originalRange.startLineNumber-1].length&&l.originalRange.startLineNumber<=l.originalRange.endLineNumber+c&&l.modifiedRange.startLineNumber<=l.modifiedRange.endLineNumber+c&&(i=1);const A=new r.$Fs(l.originalRange.startLineNumber+i,l.originalRange.endLineNumber+1+c),g=new r.$Fs(l.modifiedRange.startLineNumber+i,l.modifiedRange.endLineNumber+1+c);return new b.$Is(A,g,[l])}t.$2Z=d}),ne(ie[33],re([0,1,25,32,16,7,2,13,12]),function(O,t,T,D,r,f,N,h,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ns=t.$Ms=void 0;const s=3;class m{computeDiff(i,c,A){const w=new L(i,c,{maxComputationTime:A.maxComputationTimeMs,shouldIgnoreTrimWhitespace:A.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),M=[];let p=null;for(const k of w.changes){let y;k.originalEndLineNumber===0?y=new a.$Fs(k.originalStartLineNumber+1,k.originalStartLineNumber+1):y=new a.$Fs(k.originalStartLineNumber,k.originalEndLineNumber+1);let F;k.modifiedEndLineNumber===0?F=new a.$Fs(k.modifiedStartLineNumber+1,k.modifiedStartLineNumber+1):F=new a.$Fs(k.modifiedStartLineNumber,k.modifiedEndLineNumber+1);let P=new r.$Is(y,F,k.charChanges?.map(I=>new r.$Js(new N.$ws(I.originalStartLineNumber,I.originalStartColumn,I.originalEndLineNumber,I.originalEndColumn),new N.$ws(I.modifiedStartLineNumber,I.modifiedStartColumn,I.modifiedEndLineNumber,I.modifiedEndColumn))));p&&(p.modified.endLineNumberExclusive===P.modified.startLineNumber||p.original.endLineNumberExclusive===P.original.startLineNumber)&&(P=new r.$Is(p.original.join(P.original),p.modified.join(P.modified),p.innerChanges&&P.innerChanges?p.innerChanges.concat(P.innerChanges):void 0),M.pop()),M.push(P),p=P}return(0,h.$5c)(()=>(0,h.$6c)(M,(k,y)=>y.original.startLineNumber-k.original.endLineNumberExclusive===y.modified.startLineNumber-k.modified.endLineNumberExclusive&&k.original.endLineNumberExclusive<y.original.startLineNumber&&k.modified.endLineNumberExclusive<y.modified.startLineNumber)),new D.$Ks(M,[],w.quitEarly)}}t.$Ms=m;function E(u,i,c,A){return new T.$Cs(u,i,c).ComputeDiff(A)}class ${constructor(i){const c=[],A=[];for(let g=0,w=i.length;g<w;g++)c[g]=d(i[g],1),A[g]=l(i[g],1);this.lines=i,this.a=c,this.b=A}getElements(){const i=[];for(let c=0,A=this.lines.length;c<A;c++)i[c]=this.lines[c].substring(this.a[c]-1,this.b[c]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,c,A){const g=[],w=[],M=[];let p=0;for(let k=c;k<=A;k++){const y=this.lines[k],F=i?this.a[k]:1,P=i?this.b[k]:y.length+1;for(let I=F;I<P;I++)g[p]=y.charCodeAt(I-1),w[p]=k+1,M[p]=I,p++;!i&&k<A&&(g[p]=10,w[p]=k+1,M[p]=y.length+1,p++)}return new b(g,w,M)}}class b{constructor(i,c,A){this.a=i,this.b=c,this.d=A}toString(){return"["+this.a.map((i,c)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this.b[c]},${this.d[c]})`).join(", ")+"]"}e(i,c){if(i<0||i>=c.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(i){return i>0&&i===this.b.length?this.getEndLineNumber(i-1):(this.e(i,this.b),this.b[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this.e(i,this.b),this.a[i]===10?this.b[i]+1:this.b[i])}getStartColumn(i){return i>0&&i===this.d.length?this.getEndColumn(i-1):(this.e(i,this.d),this.d[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this.e(i,this.d),this.a[i]===10?1:this.d[i]+1)}}class e{constructor(i,c,A,g,w,M,p,k){this.originalStartLineNumber=i,this.originalStartColumn=c,this.originalEndLineNumber=A,this.originalEndColumn=g,this.modifiedStartLineNumber=w,this.modifiedStartColumn=M,this.modifiedEndLineNumber=p,this.modifiedEndColumn=k}static createFromDiffChange(i,c,A){const g=c.getStartLineNumber(i.originalStart),w=c.getStartColumn(i.originalStart),M=c.getEndLineNumber(i.originalStart+i.originalLength-1),p=c.getEndColumn(i.originalStart+i.originalLength-1),k=A.getStartLineNumber(i.modifiedStart),y=A.getStartColumn(i.modifiedStart),F=A.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),P=A.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e(g,w,M,p,k,y,F,P)}}function v(u){if(u.length<=1)return u;const i=[u[0]];let c=i[0];for(let A=1,g=u.length;A<g;A++){const w=u[A],M=w.originalStart-(c.originalStart+c.originalLength),p=w.modifiedStart-(c.modifiedStart+c.modifiedLength);Math.min(M,p)<s?(c.originalLength=w.originalStart+w.originalLength-c.originalStart,c.modifiedLength=w.modifiedStart+w.modifiedLength-c.modifiedStart):(i.push(w),c=w)}return i}class R{constructor(i,c,A,g,w){this.originalStartLineNumber=i,this.originalEndLineNumber=c,this.modifiedStartLineNumber=A,this.modifiedEndLineNumber=g,this.charChanges=w}static createFromDiffResult(i,c,A,g,w,M,p){let k,y,F,P,I;if(c.originalLength===0?(k=A.getStartLineNumber(c.originalStart)-1,y=0):(k=A.getStartLineNumber(c.originalStart),y=A.getEndLineNumber(c.originalStart+c.originalLength-1)),c.modifiedLength===0?(F=g.getStartLineNumber(c.modifiedStart)-1,P=0):(F=g.getStartLineNumber(c.modifiedStart),P=g.getEndLineNumber(c.modifiedStart+c.modifiedLength-1)),M&&c.originalLength>0&&c.originalLength<20&&c.modifiedLength>0&&c.modifiedLength<20&&w()){const q=A.createCharSequence(i,c.originalStart,c.originalStart+c.originalLength-1),x=g.createCharSequence(i,c.modifiedStart,c.modifiedStart+c.modifiedLength-1);if(q.getElements().length>0&&x.getElements().length>0){let _=E(q,x,w,!0).changes;p&&(_=v(_)),I=[];for(let j=0,H=_.length;j<H;j++)I.push(e.createFromDiffChange(_[j],q,x))}}return new R(k,y,F,P,I)}}class L{constructor(i,c,A){this.a=A.shouldComputeCharChanges,this.b=A.shouldPostProcessCharChanges,this.d=A.shouldIgnoreTrimWhitespace,this.e=A.shouldMakePrettyDiff,this.f=i,this.g=c,this.h=new $(i),this.j=new $(c),this.k=o(A.maxComputationTime),this.l=o(A.maxComputationTime===0?0:Math.min(A.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=E(this.h,this.j,this.k,this.e),c=i.changes,A=i.quitEarly;if(this.d){const p=[];for(let k=0,y=c.length;k<y;k++)p.push(R.createFromDiffResult(this.d,c[k],this.h,this.j,this.l,this.a,this.b));return{quitEarly:A,changes:p}}const g=[];let w=0,M=0;for(let p=-1,k=c.length;p<k;p++){const y=p+1<k?c[p+1]:null,F=y?y.originalStart:this.f.length,P=y?y.modifiedStart:this.g.length;for(;w<F&&M<P;){const I=this.f[w],q=this.g[M];if(I!==q){{let x=d(I,1),_=d(q,1);for(;x>1&&_>1;){const j=I.charCodeAt(x-2),H=q.charCodeAt(_-2);if(j!==H)break;x--,_--}(x>1||_>1)&&this.m(g,w+1,1,x,M+1,1,_)}{let x=l(I,1),_=l(q,1);const j=I.length+1,H=q.length+1;for(;x<j&&_<H;){const W=I.charCodeAt(x-1),J=I.charCodeAt(_-1);if(W!==J)break;x++,_++}(x<j||_<H)&&this.m(g,w+1,x,j,M+1,_,H)}}w++,M++}y&&(g.push(R.createFromDiffResult(this.d,y,this.h,this.j,this.l,this.a,this.b)),w+=y.originalLength,M+=y.modifiedLength)}return{quitEarly:A,changes:g}}m(i,c,A,g,w,M,p){if(this.n(i,c,A,g,w,M,p))return;let k;this.a&&(k=[new e(c,A,c,g,w,M,w,p)]),i.push(new R(c,c,w,w,k))}n(i,c,A,g,w,M,p){const k=i.length;if(k===0)return!1;const y=i[k-1];return y.originalEndLineNumber===0||y.modifiedEndLineNumber===0?!1:y.originalEndLineNumber===c&&y.modifiedEndLineNumber===w?(this.a&&y.charChanges&&y.charChanges.push(new e(c,A,c,g,w,M,w,p)),!0):y.originalEndLineNumber+1===c&&y.modifiedEndLineNumber+1===w?(y.originalEndLineNumber=c,y.modifiedEndLineNumber=w,this.a&&y.charChanges&&y.charChanges.push(new e(c,A,c,g,w,M,w,p)),!0):!1}}t.$Ns=L;function d(u,i){const c=f.$Re(u);return c===-1?i:c+1}function l(u,i){const c=f.$Te(u);return c===-1?i:c+2}function o(u){if(u===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<u}}),ne(ie[50],re([0,1,33,49]),function(O,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3Z=void 0,t.$3Z={getLegacy:()=>new T.$Ms,getDefault:()=>new D.$ZZ}}),ne(ie[51],re([0,1,35]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4Z=void 0;function D($){const b=[];for(const e of $){const v=Number(e);(v||v===0&&e.replace(/\s/g,"")!=="")&&b.push(v)}return b}function r($,b,e,v){return{red:$/255,blue:e/255,green:b/255,alpha:v}}function f($,b){const e=b.index,v=b[0].length;if(!e)return;const R=$.positionAt(e);return{startLineNumber:R.lineNumber,startColumn:R.column,endLineNumber:R.lineNumber,endColumn:R.column+v}}function N($,b){if(!$)return;const e=T.$1s.Format.CSS.parseHex(b);if(e)return{range:$,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function h($,b,e){if(!$||b.length!==1)return;const R=b[0].values(),L=D(R);return{range:$,color:r(L[0],L[1],L[2],e?L[3]:1)}}function a($,b,e){if(!$||b.length!==1)return;const R=b[0].values(),L=D(R),d=new T.$1s(new T.$Ys(L[0],L[1]/100,L[2]/100,e?L[3]:1));return{range:$,color:r(d.rgba.r,d.rgba.g,d.rgba.b,d.rgba.a)}}function s($,b){return typeof $=="string"?[...$.matchAll(b)]:$.findMatches(b)}function m($){const b=[],v=s($,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(v.length>0)for(const R of v){const L=R.filter(u=>u!==void 0),d=L[1],l=L[2];if(!l)continue;let o;if(d==="rgb"){const u=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;o=h(f($,R),s(l,u),!1)}else if(d==="rgba"){const u=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;o=h(f($,R),s(l,u),!0)}else if(d==="hsl"){const u=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;o=a(f($,R),s(l,u),!1)}else if(d==="hsla"){const u=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;o=a(f($,R),s(l,u),!0)}else d==="#"&&(o=N(f($,R),d+l));o&&b.push(o)}return b}function E($){return!$||typeof $.getValue!="function"||typeof $.positionAt!="function"?[]:m($)}t.$4Z=E}),ne(ie[52],re([0,1,28]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DZ=t.$CZ=t.$BZ=t.State=void 0;var D;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(D||(t.State=D={}));class r{constructor(e,v,R){const L=new Uint8Array(e*v);for(let d=0,l=e*v;d<l;d++)L[d]=R;this.a=L,this.rows=e,this.cols=v}get(e,v){return this.a[e*this.cols+v]}set(e,v,R){this.a[e*this.cols+v]=R}}class f{constructor(e){let v=0,R=0;for(let d=0,l=e.length;d<l;d++){const[o,u,i]=e[d];u>v&&(v=u),o>R&&(R=o),i>R&&(R=i)}v++,R++;const L=new r(R,v,0);for(let d=0,l=e.length;d<l;d++){const[o,u,i]=e[d];L.set(o,u,i)}this.a=L,this.b=v}nextState(e,v){return v<0||v>=this.b?0:this.a.get(e,v)}}t.$BZ=f;let N=null;function h(){return N===null&&(N=new f([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),N}var a;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let s=null;function m(){if(s===null){s=new T.$Ts(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<b.length;v++)s.set(b.charCodeAt(v),1);const e=".,;:";for(let v=0;v<e.length;v++)s.set(e.charCodeAt(v),2)}return s}class E{static a(e,v,R,L,d){let l=d-1;do{const o=v.charCodeAt(l);if(e.get(o)!==2)break;l--}while(l>L);if(L>0){const o=v.charCodeAt(L-1),u=v.charCodeAt(l);(o===40&&u===41||o===91&&u===93||o===123&&u===125)&&l--}return{range:{startLineNumber:R,startColumn:L+1,endLineNumber:R,endColumn:l+2},url:v.substring(L,l+1)}}static computeLinks(e,v=h()){const R=m(),L=[];for(let d=1,l=e.getLineCount();d<=l;d++){const o=e.getLineContent(d),u=o.length;let i=0,c=0,A=0,g=1,w=!1,M=!1,p=!1,k=!1;for(;i<u;){let y=!1;const F=o.charCodeAt(i);if(g===13){let P;switch(F){case 40:w=!0,P=0;break;case 41:P=w?0:1;break;case 91:p=!0,M=!0,P=0;break;case 93:p=!1,P=M?0:1;break;case 123:k=!0,P=0;break;case 125:P=k?0:1;break;case 39:case 34:case 96:A===F?P=1:A===39||A===34||A===96?P=0:P=1;break;case 42:P=A===42?1:0;break;case 124:P=A===124?1:0;break;case 32:P=p?0:1;break;default:P=R.get(F)}P===1&&(L.push(E.a(R,o,d,c,i)),y=!0)}else if(g===12){let P;F===91?(M=!0,P=0):P=R.get(F),P===1?y=!0:g=13}else g=v.nextState(g,F),g===0&&(y=!0);y&&(g=1,w=!1,M=!1,k=!1,c=i+1,A=F),i++}g===13&&L.push(E.a(R,o,d,c,u))}return L}}t.$CZ=E;function $(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:E.computeLinks(b)}t.$DZ=$}),ne(ie[53],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EZ=void 0;class T{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new T}navigateValueSet(r,f,N,h,a){if(r&&f){const s=this.a(f,a);if(s)return{range:r,value:s}}if(N&&h){const s=this.a(h,a);if(s)return{range:N,value:s}}return null}a(r,f){const N=this.b(r,f);return N!==null?N:this.d(r,f)}b(r,f){const N=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let h=Number(r);const a=parseFloat(r);return!isNaN(h)&&!isNaN(a)&&h===a?h===0&&!f?null:(h=Math.floor(h*N),h+=f?N:-N,String(h/N)):null}d(r,f){return this.e(this.c,r,f)}e(r,f,N){let h=null;for(let a=0,s=r.length;h===null&&a<s;a++)h=this.f(r[a],f,N);return h}f(r,f,N){let h=r.indexOf(f);return h>=0?(h+=N?1:-1,h<0?h=r.length-1:h%=r.length,r[h]):null}}t.$EZ=T}),ne(ie[54],re([0,1,14]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Su=t.$Ru=t.$Qu=t.$Pu=t.ModelConstants=t.PositionAffinity=t.$Ou=t.TrackedRangeStickiness=t.$Nu=t.$Mu=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var D;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(D||(t.OverviewRulerLane=D={}));var r;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(r||(t.GlyphMarginLane=r={}));var f;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(f||(t.MinimapPosition=f={}));var N;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(N||(t.InjectedTextCursorStops=N={}));var h;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(h||(t.EndOfLinePreference=h={}));var a;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(a||(t.DefaultEndOfLine=a={}));var s;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class m{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(u){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,u.tabSize|0),u.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,u.indentSize|0),this.a=!1),this.insertSpaces=!!u.insertSpaces,this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=!!u.trimAutoWhitespace,this.bracketPairColorizationOptions=u.bracketPairColorizationOptions}equals(u){return this.tabSize===u.tabSize&&this.a===u.a&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace&&(0,T.$bn)(this.bracketPairColorizationOptions,u.bracketPairColorizationOptions)}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}t.$Mu=m;class E{constructor(u,i){this._findMatchBrand=void 0,this.range=u,this.matches=i}}t.$Nu=E;var $;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($||(t.TrackedRangeStickiness=$={}));function b(o){return o&&typeof o.read=="function"}t.$Ou=b;var e;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var v;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v||(t.ModelConstants=v={}));class R{constructor(u,i,c,A,g,w){this.identifier=u,this.range=i,this.text=c,this.forceMoveMarkers=A,this.isAutoWhitespaceEdit=g,this._isTracked=w}}t.$Pu=R;class L{constructor(u,i,c){this.regex=u,this.wordSeparators=i,this.simpleSearch=c}}t.$Qu=L;class d{constructor(u,i,c){this.reverseEdits=u,this.changes=i,this.trimAutoWhitespaceLineNumbers=c}}t.$Ru=d;function l(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}t.$Su=l}),ne(ie[55],re([0,1,6,27]),function(O,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xu=t.$Wu=t.$Vu=void 0;class r{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,s){a=(0,D.$Be)(a);const m=this.a,E=this.b,$=s.length;return $===0?!1:(this.a=new Uint32Array(m.length+$),this.a.set(m.subarray(0,a),0),this.a.set(m.subarray(a),a+$),this.a.set(s,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue(a,s){return a=(0,D.$Be)(a),s=(0,D.$Be)(s),this.a[a]===s?!1:(this.a[a]=s,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,s){a=(0,D.$Be)(a),s=(0,D.$Be)(s);const m=this.a,E=this.b;if(a>=m.length)return!1;const $=m.length-a;return s>=$&&(s=$),s===0?!1:(this.a=new Uint32Array(m.length-s),this.a.set(m.subarray(0,a),0),this.a.set(m.subarray(a+s),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,D.$Be)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let s=this.c[0]+1;s===0&&(this.b[0]=this.a[0],s++),a>=this.a.length&&(a=this.a.length-1);for(let m=s;m<=a;m++)this.b[m]=this.b[m-1]+this.a[m];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let s=0,m=this.a.length-1,E=0,$=0,b=0;for(;s<=m;)if(E=s+(m-s)/2|0,$=this.b[E],b=$-this.a[E],a<b)m=E-1;else if(a>=$)s=E+1;else break;return new N(E,a-b)}}t.$Vu=r;class f{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const s=this.e[a],m=s>0?this.d[s-1]:0;return new N(s,a-m)}removeValues(a,s){this.a.splice(a,s),this.f(a)}insertValues(a,s){this.a=(0,T.$Vb)(this.a,a,s),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,s=this.a.length;a<s;a++){const m=this.a[a],E=a>0?this.d[a-1]:0;this.d[a]=E+m;for(let $=0;$<m;$++)this.e[E+$]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,s){this.a[a]!==s&&(this.a[a]=s,this.f(a))}}t.$Wu=f;class N{constructor(a,s){this.index=a,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=s}}t.$Xu=N}),ne(ie[56],re([0,1,7,5,55]),function(O,t,T,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yu=void 0;class f{constructor(h,a,s,m){this.d=h,this.f=a,this.g=s,this.h=m,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(h){h.eol&&h.eol!==this.g&&(this.g=h.eol,this.j=null);const a=h.changes;for(const s of a)this.o(s.range),this.p(new D.$vs(s.range.startLineNumber,s.range.startColumn),s.text);this.h=h.versionId,this.k=null}l(){if(!this.j){const h=this.g.length,a=this.f.length,s=new Uint32Array(a);for(let m=0;m<a;m++)s[m]=this.f[m].length+h;this.j=new r.$Vu(s)}}n(h,a){this.f[h]=a,this.j&&this.j.setValue(h,this.f[h].length+this.g.length)}o(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.startLineNumber-1].substring(h.endColumn-1));return}this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.endLineNumber-1].substring(h.endColumn-1)),this.f.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this.j&&this.j.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}p(h,a){if(a.length===0)return;const s=(0,T.$Qe)(a);if(s.length===1){this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+s[0]+this.f[h.lineNumber-1].substring(h.column-1));return}s[s.length-1]+=this.f[h.lineNumber-1].substring(h.column-1),this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+s[0]);const m=new Uint32Array(s.length-1);for(let E=1;E<s.length;E++)this.f.splice(h.lineNumber+E-1,0,s[E]),m[E-1]=s[E].length+this.g.length;this.j&&this.j.insertValues(h.lineNumber,m)}}t.$Yu=f}),ne(ie[57],re([0,1,7,44,5,2,54]),function(O,t,T,D,r,f,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CB=t.$BB=t.$AB=t.$zB=t.$yB=t.$xB=void 0;const h=999;class a{constructor(d,l,o,u){this.searchString=d,this.isRegex=l,this.matchCase=o,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=s(this.searchString):d=this.searchString.indexOf(`
`)>=0;let l=null;try{l=T.$Oe(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch{return null}if(!l)return null;let o=!this.isRegex&&!d;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new N.$Qu(l,this.wordSeparators?(0,D.$Ws)(this.wordSeparators):null,o?this.searchString:null)}}t.$xB=a;function s(L){if(!L||L.length===0)return!1;for(let d=0,l=L.length;d<l;d++){const o=L.charCodeAt(d);if(o===10)return!0;if(o===92){if(d++,d>=l)break;const u=L.charCodeAt(d);if(u===110||u===114||u===87)return!0}}return!1}t.$yB=s;function m(L,d,l){if(!l)return new N.$Nu(L,null);const o=[];for(let u=0,i=d.length;u<i;u++)o[u]=d[u];return new N.$Nu(L,o)}t.$zB=m;class E{constructor(d){const l=[];let o=0;for(let u=0,i=d.length;u<i;u++)d.charCodeAt(u)===10&&(l[o++]=u);this.a=l}findLineFeedCountBeforeOffset(d){const l=this.a;let o=0,u=l.length-1;if(u===-1||d<=l[0])return 0;for(;o<u;){const i=o+((u-o)/2>>0);l[i]>=d?u=i-1:l[i+1]>=d?(o=i,u=i):o=i+1}return o+1}}class ${static findMatches(d,l,o,u,i){const c=l.parseSearchRequest();return c?c.regex.multiline?this.b(d,o,new R(c.wordSeparators,c.regex),u,i):this.c(d,o,c,u,i):[]}static a(d,l,o,u,i,c){let A,g=0;u?(g=u.findLineFeedCountBeforeOffset(i),A=l+i+g):A=l+i;let w;if(u){const y=u.findLineFeedCountBeforeOffset(i+c.length)-g;w=A+c.length+y}else w=A+c.length;const M=d.getPositionAt(A),p=d.getPositionAt(w);return new f.$ws(M.lineNumber,M.column,p.lineNumber,p.column)}static b(d,l,o,u,i){const c=d.getOffsetAt(l.getStartPosition()),A=d.getValueInRange(l,1),g=d.getEOL()===`\r
`?new E(A):null,w=[];let M=0,p;for(o.reset(0);p=o.next(A);)if(w[M++]=m(this.a(d,c,A,g,p.index,p[0]),p,u),M>=i)return w;return w}static c(d,l,o,u,i){const c=[];let A=0;if(l.startLineNumber===l.endLineNumber){const w=d.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return A=this.d(o,w,l.startLineNumber,l.startColumn-1,A,c,u,i),c}const g=d.getLineContent(l.startLineNumber).substring(l.startColumn-1);A=this.d(o,g,l.startLineNumber,l.startColumn-1,A,c,u,i);for(let w=l.startLineNumber+1;w<l.endLineNumber&&A<i;w++)A=this.d(o,d.getLineContent(w),w,0,A,c,u,i);if(A<i){const w=d.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);A=this.d(o,w,l.endLineNumber,0,A,c,u,i)}return c}static d(d,l,o,u,i,c,A,g){const w=d.wordSeparators;if(!A&&d.simpleSearch){const k=d.simpleSearch,y=k.length,F=l.length;let P=-y;for(;(P=l.indexOf(k,P+y))!==-1;)if((!w||v(w,l,F,P,y))&&(c[i++]=new N.$Nu(new f.$ws(o,P+1+u,o,P+1+y+u),null),i>=g))return i;return i}const M=new R(d.wordSeparators,d.regex);let p;M.reset(0);do if(p=M.next(l),p&&(c[i++]=m(new f.$ws(o,p.index+1+u,o,p.index+1+p[0].length+u),p,A),i>=g))return i;while(p);return i}static findNextMatch(d,l,o,u){const i=l.parseSearchRequest();if(!i)return null;const c=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.e(d,o,c,u):this.f(d,o,c,u)}static e(d,l,o,u){const i=new r.$vs(l.lineNumber,1),c=d.getOffsetAt(i),A=d.getLineCount(),g=d.getValueInRange(new f.$ws(i.lineNumber,i.column,A,d.getLineMaxColumn(A)),1),w=d.getEOL()===`\r
`?new E(g):null;o.reset(l.column-1);const M=o.next(g);return M?m(this.a(d,c,g,w,M.index,M[0]),M,u):l.lineNumber!==1||l.column!==1?this.e(d,new r.$vs(1,1),o,u):null}static f(d,l,o,u){const i=d.getLineCount(),c=l.lineNumber,A=d.getLineContent(c),g=this.g(o,A,c,l.column,u);if(g)return g;for(let w=1;w<=i;w++){const M=(c+w-1)%i,p=d.getLineContent(M+1),k=this.g(o,p,M+1,1,u);if(k)return k}return null}static g(d,l,o,u,i){d.reset(u-1);const c=d.next(l);return c?m(new f.$ws(o,c.index+1,o,c.index+1+c[0].length),c,i):null}static findPreviousMatch(d,l,o,u){const i=l.parseSearchRequest();if(!i)return null;const c=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.h(d,o,c,u):this.j(d,o,c,u)}static h(d,l,o,u){const i=this.b(d,new f.$ws(1,1,l.lineNumber,l.column),o,u,10*h);if(i.length>0)return i[i.length-1];const c=d.getLineCount();return l.lineNumber!==c||l.column!==d.getLineMaxColumn(c)?this.h(d,new r.$vs(c,d.getLineMaxColumn(c)),o,u):null}static j(d,l,o,u){const i=d.getLineCount(),c=l.lineNumber,A=d.getLineContent(c).substring(0,l.column-1),g=this.k(o,A,c,u);if(g)return g;for(let w=1;w<=i;w++){const M=(i+c-w-1)%i,p=d.getLineContent(M+1),k=this.k(o,p,M+1,u);if(k)return k}return null}static k(d,l,o,u){let i=null,c;for(d.reset(0);c=d.next(l);)i=m(new f.$ws(o,c.index+1,o,c.index+1+c[0].length),c,u);return i}}t.$AB=$;function b(L,d,l,o,u){if(o===0)return!0;const i=d.charCodeAt(o-1);if(L.get(i)!==0||i===13||i===10)return!0;if(u>0){const c=d.charCodeAt(o);if(L.get(c)!==0)return!0}return!1}function e(L,d,l,o,u){if(o+u===l)return!0;const i=d.charCodeAt(o+u);if(L.get(i)!==0||i===13||i===10)return!0;if(u>0){const c=d.charCodeAt(o+u-1);if(L.get(c)!==0)return!0}return!1}function v(L,d,l,o,u){return b(L,d,l,o,u)&&e(L,d,l,o,u)}t.$BB=v;class R{constructor(d,l){this._wordSeparators=d,this.a=l,this.b=-1,this.c=0}reset(d){this.a.lastIndex=d,this.b=-1,this.c=0}next(d){const l=d.length;let o;do{if(this.b+this.c===l||(o=this.a.exec(d),!o))return null;const u=o.index,i=o[0].length;if(u===this.b&&i===this.c){if(i===0){T.$0e(d,l,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=u,this.c=i,!this._wordSeparators||v(this._wordSeparators,d,l,u,i))return o}while(o);return null}}t.$CB=R}),ne(ie[58],re([0,1,2,57,7,13,29]),function(O,t,T,D,r,f,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$AZ=void 0;class h{static computeUnicodeHighlights(e,v,R){const L=R?R.startLineNumber:1,d=R?R.endLineNumber:e.getLineCount(),l=new m(v),o=l.getCandidateCodePoints();let u;o==="allNonBasicAscii"?u=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):u=new RegExp(`${a(Array.from(o))}`,"g");const i=new D.$CB(null,u),c=[];let A=!1,g,w=0,M=0,p=0;e:for(let k=L,y=d;k<=y;k++){const F=e.getLineContent(k),P=F.length;i.reset(0);do if(g=i.next(F),g){let I=g.index,q=g.index+g[0].length;if(I>0){const H=F.charCodeAt(I-1);r.$7e(H)&&I--}if(q+1<P){const H=F.charCodeAt(q-1);r.$7e(H)&&q++}const x=F.substring(I,q);let _=(0,N.$$r)(I+1,N.$8r,F,0);_&&_.endColumn<=I+1&&(_=null);const j=l.shouldHighlightNonBasicASCII(x,_?_.word:null);if(j!==0){j===3?w++:j===2?M++:j===1?p++:(0,f.$3c)(j);const H=1e3;if(c.length>=H){A=!0;break e}c.push(new T.$ws(k,I+1,k,q+1))}}while(g)}return{ranges:c,hasMore:A,ambiguousCharacterCount:w,invisibleCharacterCount:M,nonBasicAsciiCharacterCount:p}}static computeUnicodeHighlightReason(e,v){const R=new m(v);switch(R.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const d=e.codePointAt(0),l=R.ambiguousCharacters.getPrimaryConfusable(d),o=r.$xf.getLocales().filter(u=>!r.$xf.getInstance(new Set([...v.allowedLocales,u])).isAmbiguous(d));return{kind:0,confusableWith:String.fromCodePoint(l),notAmbiguousInLocales:o}}case 1:return{kind:2}}}}t.$AZ=h;function a(b,e){return`[${r.$Ge(b.map(R=>String.fromCodePoint(R)).join(""))}]`}var s;(function(b){b[b.Ambiguous=0]="Ambiguous",b[b.Invisible=1]="Invisible",b[b.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class m{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.$xf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const v of r.$yf.codePoints)E(String.fromCodePoint(v))||e.add(v);if(this.b.ambiguousCharacters)for(const v of this.ambiguousCharacters.getConfusableCodePoints())e.add(v);for(const v of this.a)e.delete(v);return e}shouldHighlightNonBasicASCII(e,v){const R=e.codePointAt(0);if(this.a.has(R))return 0;if(this.b.nonBasicASCII)return 1;let L=!1,d=!1;if(v)for(const l of v){const o=l.codePointAt(0),u=r.$ff(l);L=L||u,!u&&!this.ambiguousCharacters.isAmbiguous(o)&&!r.$yf.isInvisibleCharacter(o)&&(d=!0)}return!L&&d?0:this.b.invisibleCharacters&&!E(e)&&r.$yf.isInvisibleCharacter(R)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(R)?3:0}}function E(b){return b===" "||b===`
`||b==="	"}var $;(function(b){b[b.None=0]="None",b[b.NonBasicASCII=1]="NonBasicASCII",b[b.Invisible=2]="Invisible",b[b.Ambiguous=3]="Ambiguous"})($||($={}))}),ne(ie[59],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var T;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(T||(t.AccessibilitySupport=T={}));var D;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(D||(t.CodeActionTriggerType=D={}));var r;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var f;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(f||(t.CompletionItemKind=f={}));var N;(function(n){n[n.Deprecated=1]="Deprecated"})(N||(t.CompletionItemTag=N={}));var h;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(t.CompletionTriggerKind=h={}));var a;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(a||(t.ContentWidgetPositionPreference=a={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var m;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(m||(t.DefaultEndOfLine=m={}));var E;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(E||(t.DocumentHighlightKind=E={}));var $;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})($||(t.EditorAutoIndentStrategy=$={}));var b;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.letterSpacing=63]="letterSpacing",n[n.lightbulb=64]="lightbulb",n[n.lineDecorationsWidth=65]="lineDecorationsWidth",n[n.lineHeight=66]="lineHeight",n[n.lineNumbers=67]="lineNumbers",n[n.lineNumbersMinChars=68]="lineNumbersMinChars",n[n.linkedEditing=69]="linkedEditing",n[n.links=70]="links",n[n.matchBrackets=71]="matchBrackets",n[n.minimap=72]="minimap",n[n.mouseStyle=73]="mouseStyle",n[n.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=75]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",n[n.multiCursorModifier=77]="multiCursorModifier",n[n.multiCursorPaste=78]="multiCursorPaste",n[n.multiCursorLimit=79]="multiCursorLimit",n[n.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",n[n.occurrencesHighlight=81]="occurrencesHighlight",n[n.overviewRulerBorder=82]="overviewRulerBorder",n[n.overviewRulerLanes=83]="overviewRulerLanes",n[n.padding=84]="padding",n[n.pasteAs=85]="pasteAs",n[n.parameterHints=86]="parameterHints",n[n.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",n[n.quickSuggestions=89]="quickSuggestions",n[n.quickSuggestionsDelay=90]="quickSuggestionsDelay",n[n.readOnly=91]="readOnly",n[n.readOnlyMessage=92]="readOnlyMessage",n[n.renameOnType=93]="renameOnType",n[n.renderControlCharacters=94]="renderControlCharacters",n[n.renderFinalNewline=95]="renderFinalNewline",n[n.renderLineHighlight=96]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=98]="renderValidationDecorations",n[n.renderWhitespace=99]="renderWhitespace",n[n.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",n[n.roundedSelection=101]="roundedSelection",n[n.rulers=102]="rulers",n[n.scrollbar=103]="scrollbar",n[n.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=105]="scrollBeyondLastLine",n[n.scrollPredominantAxis=106]="scrollPredominantAxis",n[n.selectionClipboard=107]="selectionClipboard",n[n.selectionHighlight=108]="selectionHighlight",n[n.selectOnLineNumbers=109]="selectOnLineNumbers",n[n.showFoldingControls=110]="showFoldingControls",n[n.showUnused=111]="showUnused",n[n.snippetSuggestions=112]="snippetSuggestions",n[n.smartSelect=113]="smartSelect",n[n.smoothScrolling=114]="smoothScrolling",n[n.stickyScroll=115]="stickyScroll",n[n.stickyTabStops=116]="stickyTabStops",n[n.stopRenderingLineAfter=117]="stopRenderingLineAfter",n[n.suggest=118]="suggest",n[n.suggestFontSize=119]="suggestFontSize",n[n.suggestLineHeight=120]="suggestLineHeight",n[n.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",n[n.suggestSelection=122]="suggestSelection",n[n.tabCompletion=123]="tabCompletion",n[n.tabIndex=124]="tabIndex",n[n.unicodeHighlighting=125]="unicodeHighlighting",n[n.unusualLineTerminators=126]="unusualLineTerminators",n[n.useShadowDOM=127]="useShadowDOM",n[n.useTabStops=128]="useTabStops",n[n.wordBreak=129]="wordBreak",n[n.wordSeparators=130]="wordSeparators",n[n.wordWrap=131]="wordWrap",n[n.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=134]="wordWrapColumn",n[n.wordWrapOverride1=135]="wordWrapOverride1",n[n.wordWrapOverride2=136]="wordWrapOverride2",n[n.wrappingIndent=137]="wrappingIndent",n[n.wrappingStrategy=138]="wrappingStrategy",n[n.showDeprecated=139]="showDeprecated",n[n.inlayHints=140]="inlayHints",n[n.editorClassName=141]="editorClassName",n[n.pixelRatio=142]="pixelRatio",n[n.tabFocusMode=143]="tabFocusMode",n[n.layoutInfo=144]="layoutInfo",n[n.wrappingInfo=145]="wrappingInfo",n[n.defaultColorDecorators=146]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(b||(t.EditorOption=b={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var v;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(v||(t.EndOfLineSequence=v={}));var R;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(R||(t.GlyphMarginLane=R={}));var L;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(L||(t.IndentAction=L={}));var d;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(d||(t.InjectedTextCursorStops=d={}));var l;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(l||(t.InlayHintKind=l={}));var o;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(o||(t.InlineCompletionTriggerKind=o={}));var u;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(u||(t.KeyCode=u={}));var i;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(i||(t.MarkerSeverity=i={}));var c;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(c||(t.MarkerTag=c={}));var A;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(A||(t.MinimapPosition=A={}));var g;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(g||(t.MouseTargetType=g={}));var w;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(w||(t.OverlayWidgetPositionPreference=w={}));var M;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(M||(t.OverviewRulerLane=M={}));var p;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(p||(t.PositionAffinity=p={}));var k;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(k||(t.RenderLineNumbersType=k={}));var y;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(y||(t.RenderMinimap=y={}));var F;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(F||(t.ScrollType=F={}));var P;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(P||(t.ScrollbarVisibility=P={}));var I;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(I||(t.SelectionDirection=I={}));var q;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(q||(t.SignatureHelpTriggerKind=q={}));var x;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(x||(t.SymbolKind=x={}));var _;(function(n){n[n.Deprecated=1]="Deprecated"})(_||(t.SymbolTag=_={}));var j;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(j||(t.TextEditorCursorBlinkingStyle=j={}));var H;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(H||(t.TextEditorCursorStyle=H={}));var W;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(W||(t.TrackedRangeStickiness=W={}));var J;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(J||(t.WrappingIndent=J={}))}),ne(ie[60],re([0,1,11,10]),function(O,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8s=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new T.$Od,this.onDidChange=this.c.event,this.d=null}handleChange(h){this.c.fire({changedLanguages:h,changedColorMap:!1})}register(h,a){return this.a.set(h,a),this.handleChange([h]),(0,D.$Pc)(()=>{this.a.get(h)===a&&(this.a.delete(h),this.handleChange([h]))})}get(h){return this.a.get(h)||null}registerFactory(h,a){this.b.get(h)?.dispose();const s=new f(this,h,a);return this.b.set(h,s),(0,D.$Pc)(()=>{const m=this.b.get(h);!m||m!==s||(this.b.delete(h),m.dispose())})}async getOrCreate(h){const a=this.get(h);if(a)return a;const s=this.b.get(h);return!s||s.isResolved?null:(await s.resolve(),this.get(h))}isResolved(h){if(this.get(h))return!0;const s=this.b.get(h);return!!(!s||s.isResolved)}setColorMap(h){this.d=h,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$8s=r;class f extends D.$Rc{get isResolved(){return this.c}constructor(h,a,s){super(),this.f=h,this.g=a,this.h=s,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const h=await this.h.tokenizationSupport;this.c=!0,h&&!this.a&&this.B(this.f.register(this.g,h))}}}),ne(ie[61],re([62,63]),function(O,t){return O.create("vs/base/common/platform",t)}),ne(ie[17],re([0,1,61]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let D=!1,r=!1,f=!1,N=!1,h=!1,a=!1,s=!1,m=!1,E=!1,$=!1,b,e=t.$g,v=t.$g,R,L;const d=globalThis;let l;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?l=d.vscode.process:typeof process<"u"&&(l=process);const o=typeof l?.versions?.electron=="string",u=o&&l?.type==="renderer";if(typeof navigator=="object"&&!u)L=navigator.userAgent,D=L.indexOf("Windows")>=0,r=L.indexOf("Macintosh")>=0,m=(L.indexOf("Macintosh")>=0||L.indexOf("iPad")>=0||L.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,f=L.indexOf("Linux")>=0,$=L?.indexOf("Mobi")>=0,a=!0,b=T.getConfiguredDefaultLocale(T.localize(0,null))||t.$g,e=b,v=navigator.language;else if(typeof l=="object"){D=l.platform==="win32",r=l.platform==="darwin",f=l.platform==="linux",N=f&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,s=o,E=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=t.$g,e=t.$g;const y=l.env.VSCODE_NLS_CONFIG;if(y)try{const F=JSON.parse(y),P=F.availableLanguages["*"];b=F.locale,v=F.osLocale,e=P||t.$g,R=F._translationsConfigFile}catch{}h=!0}else console.error("Unable to resolve platform.");var i;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(i||(t.Platform=i={}));function c(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=c;let A=0;r?A=1:D?A=3:f&&(A=2),t.$i=D,t.$j=r,t.$k=f,t.$l=N,t.$m=h,t.$n=s,t.$o=a,t.$p=a&&typeof d.importScripts=="function",t.$q=t.$p?d.origin:void 0,t.$r=m,t.$s=$,t.$t=E,t.$u=A,t.$v=L,t.$w=e;var g;(function(y){function F(){return t.$w}y.value=F;function P(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}y.isDefaultVariant=P;function I(){return t.$w==="en"}y.isDefault=I})(g||(t.Language=g={})),t.$x=b,t.$y=v,t.$z=R,t.$A=typeof d.postMessage=="function"&&!d.importScripts,t.$B=(()=>{if(t.$A){const y=[];d.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let I=0,q=y.length;I<q;I++){const x=y[I];if(x.id===P.data.vscodeScheduleAsyncWork){y.splice(I,1),x.callback();return}}});let F=0;return P=>{const I=++F;y.push({id:I,callback:P}),d.postMessage({vscodeScheduleAsyncWork:I},"*")}}return y=>setTimeout(y)})();var w;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(w||(t.OperatingSystem=w={})),t.OS=r||m?2:D?1:3;let M=!0,p=!1;function k(){if(!p){p=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,M=new Uint16Array(y.buffer)[0]===(2<<8)+1}return M}t.$D=k,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0)}),ne(ie[64],re([0,1,17]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dc=t.$cc=t.env=t.cwd=void 0;let D;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.process<"u"){const f=r.process;D={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return T.$i?"win32":T.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=D.cwd,t.env=D.env,t.$cc=D.platform,t.$dc=D.arch}),ne(ie[65],re([0,1,64]),function(O,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=t.sep=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=void 0;const D=65,r=97,f=90,N=122,h=46,a=47,s=92,m=58,E=63;class $ extends Error{constructor(c,A,g){let w;typeof A=="string"&&A.indexOf("not ")===0?(w="must not be",A=A.replace(/^not /,"")):w="must be";const M=c.indexOf(".")!==-1?"property":"argument";let p=`The "${c}" ${M} ${w} of type ${A}`;p+=`. Received type ${typeof g}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function b(i,c){if(i===null||typeof i!="object")throw new $(c,"Object",i)}function e(i,c){if(typeof i!="string")throw new $(c,"string",i)}const v=T.$cc==="win32";function R(i){return i===a||i===s}function L(i){return i===a}function d(i){return i>=D&&i<=f||i>=r&&i<=N}function l(i,c,A,g){let w="",M=0,p=-1,k=0,y=0;for(let F=0;F<=i.length;++F){if(F<i.length)y=i.charCodeAt(F);else{if(g(y))break;y=a}if(g(y)){if(!(p===F-1||k===1))if(k===2){if(w.length<2||M!==2||w.charCodeAt(w.length-1)!==h||w.charCodeAt(w.length-2)!==h){if(w.length>2){const P=w.lastIndexOf(A);P===-1?(w="",M=0):(w=w.slice(0,P),M=w.length-1-w.lastIndexOf(A)),p=F,k=0;continue}else if(w.length!==0){w="",M=0,p=F,k=0;continue}}c&&(w+=w.length>0?`${A}..`:"..",M=2)}else w.length>0?w+=`${A}${i.slice(p+1,F)}`:w=i.slice(p+1,F),M=F-p-1;p=F,k=0}else y===h&&k!==-1?++k:k=-1}return w}function o(i,c){b(c,"pathObject");const A=c.dir||c.root,g=c.base||`${c.name||""}${c.ext||""}`;return A?A===c.root?`${A}${g}`:`${A}${i}${g}`:g}t.$ec={resolve(...i){let c="",A="",g=!1;for(let w=i.length-1;w>=-1;w--){let M;if(w>=0){if(M=i[w],e(M,"path"),M.length===0)continue}else c.length===0?M=T.cwd():(M=T.env[`=${c}`]||T.cwd(),(M===void 0||M.slice(0,2).toLowerCase()!==c.toLowerCase()&&M.charCodeAt(2)===s)&&(M=`${c}\\`));const p=M.length;let k=0,y="",F=!1;const P=M.charCodeAt(0);if(p===1)R(P)&&(k=1,F=!0);else if(R(P))if(F=!0,R(M.charCodeAt(1))){let I=2,q=I;for(;I<p&&!R(M.charCodeAt(I));)I++;if(I<p&&I!==q){const x=M.slice(q,I);for(q=I;I<p&&R(M.charCodeAt(I));)I++;if(I<p&&I!==q){for(q=I;I<p&&!R(M.charCodeAt(I));)I++;(I===p||I!==q)&&(y=`\\\\${x}\\${M.slice(q,I)}`,k=I)}}}else k=1;else d(P)&&M.charCodeAt(1)===m&&(y=M.slice(0,2),k=2,p>2&&R(M.charCodeAt(2))&&(F=!0,k=3));if(y.length>0)if(c.length>0){if(y.toLowerCase()!==c.toLowerCase())continue}else c=y;if(g){if(c.length>0)break}else if(A=`${M.slice(k)}\\${A}`,g=F,F&&c.length>0)break}return A=l(A,!g,"\\",R),g?`${c}\\${A}`:`${c}${A}`||"."},normalize(i){e(i,"path");const c=i.length;if(c===0)return".";let A=0,g,w=!1;const M=i.charCodeAt(0);if(c===1)return L(M)?"\\":i;if(R(M))if(w=!0,R(i.charCodeAt(1))){let k=2,y=k;for(;k<c&&!R(i.charCodeAt(k));)k++;if(k<c&&k!==y){const F=i.slice(y,k);for(y=k;k<c&&R(i.charCodeAt(k));)k++;if(k<c&&k!==y){for(y=k;k<c&&!R(i.charCodeAt(k));)k++;if(k===c)return`\\\\${F}\\${i.slice(y)}\\`;k!==y&&(g=`\\\\${F}\\${i.slice(y,k)}`,A=k)}}}else A=1;else d(M)&&i.charCodeAt(1)===m&&(g=i.slice(0,2),A=2,c>2&&R(i.charCodeAt(2))&&(w=!0,A=3));let p=A<c?l(i.slice(A),!w,"\\",R):"";return p.length===0&&!w&&(p="."),p.length>0&&R(i.charCodeAt(c-1))&&(p+="\\"),g===void 0?w?`\\${p}`:p:w?`${g}\\${p}`:`${g}${p}`},isAbsolute(i){e(i,"path");const c=i.length;if(c===0)return!1;const A=i.charCodeAt(0);return R(A)||c>2&&d(A)&&i.charCodeAt(1)===m&&R(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let c,A;for(let M=0;M<i.length;++M){const p=i[M];e(p,"path"),p.length>0&&(c===void 0?c=A=p:c+=`\\${p}`)}if(c===void 0)return".";let g=!0,w=0;if(typeof A=="string"&&R(A.charCodeAt(0))){++w;const M=A.length;M>1&&R(A.charCodeAt(1))&&(++w,M>2&&(R(A.charCodeAt(2))?++w:g=!1))}if(g){for(;w<c.length&&R(c.charCodeAt(w));)w++;w>=2&&(c=`\\${c.slice(w)}`)}return t.$ec.normalize(c)},relative(i,c){if(e(i,"from"),e(c,"to"),i===c)return"";const A=t.$ec.resolve(i),g=t.$ec.resolve(c);if(A===g||(i=A.toLowerCase(),c=g.toLowerCase(),i===c))return"";let w=0;for(;w<i.length&&i.charCodeAt(w)===s;)w++;let M=i.length;for(;M-1>w&&i.charCodeAt(M-1)===s;)M--;const p=M-w;let k=0;for(;k<c.length&&c.charCodeAt(k)===s;)k++;let y=c.length;for(;y-1>k&&c.charCodeAt(y-1)===s;)y--;const F=y-k,P=p<F?p:F;let I=-1,q=0;for(;q<P;q++){const _=i.charCodeAt(w+q);if(_!==c.charCodeAt(k+q))break;_===s&&(I=q)}if(q!==P){if(I===-1)return g}else{if(F>P){if(c.charCodeAt(k+q)===s)return g.slice(k+q+1);if(q===2)return g.slice(k+q)}p>P&&(i.charCodeAt(w+q)===s?I=q:q===2&&(I=3)),I===-1&&(I=0)}let x="";for(q=w+I+1;q<=M;++q)(q===M||i.charCodeAt(q)===s)&&(x+=x.length===0?"..":"\\..");return k+=I,x.length>0?`${x}${g.slice(k,y)}`:(g.charCodeAt(k)===s&&++k,g.slice(k,y))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const c=t.$ec.resolve(i);if(c.length<=2)return i;if(c.charCodeAt(0)===s){if(c.charCodeAt(1)===s){const A=c.charCodeAt(2);if(A!==E&&A!==h)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(d(c.charCodeAt(0))&&c.charCodeAt(1)===m&&c.charCodeAt(2)===s)return`\\\\?\\${c}`;return i},dirname(i){e(i,"path");const c=i.length;if(c===0)return".";let A=-1,g=0;const w=i.charCodeAt(0);if(c===1)return R(w)?i:".";if(R(w)){if(A=g=1,R(i.charCodeAt(1))){let k=2,y=k;for(;k<c&&!R(i.charCodeAt(k));)k++;if(k<c&&k!==y){for(y=k;k<c&&R(i.charCodeAt(k));)k++;if(k<c&&k!==y){for(y=k;k<c&&!R(i.charCodeAt(k));)k++;if(k===c)return i;k!==y&&(A=g=k+1)}}}}else d(w)&&i.charCodeAt(1)===m&&(A=c>2&&R(i.charCodeAt(2))?3:2,g=A);let M=-1,p=!0;for(let k=c-1;k>=g;--k)if(R(i.charCodeAt(k))){if(!p){M=k;break}}else p=!1;if(M===-1){if(A===-1)return".";M=A}return i.slice(0,M)},basename(i,c){c!==void 0&&e(c,"ext"),e(i,"path");let A=0,g=-1,w=!0,M;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===m&&(A=2),c!==void 0&&c.length>0&&c.length<=i.length){if(c===i)return"";let p=c.length-1,k=-1;for(M=i.length-1;M>=A;--M){const y=i.charCodeAt(M);if(R(y)){if(!w){A=M+1;break}}else k===-1&&(w=!1,k=M+1),p>=0&&(y===c.charCodeAt(p)?--p===-1&&(g=M):(p=-1,g=k))}return A===g?g=k:g===-1&&(g=i.length),i.slice(A,g)}for(M=i.length-1;M>=A;--M)if(R(i.charCodeAt(M))){if(!w){A=M+1;break}}else g===-1&&(w=!1,g=M+1);return g===-1?"":i.slice(A,g)},extname(i){e(i,"path");let c=0,A=-1,g=0,w=-1,M=!0,p=0;i.length>=2&&i.charCodeAt(1)===m&&d(i.charCodeAt(0))&&(c=g=2);for(let k=i.length-1;k>=c;--k){const y=i.charCodeAt(k);if(R(y)){if(!M){g=k+1;break}continue}w===-1&&(M=!1,w=k+1),y===h?A===-1?A=k:p!==1&&(p=1):A!==-1&&(p=-1)}return A===-1||w===-1||p===0||p===1&&A===w-1&&A===g+1?"":i.slice(A,w)},format:o.bind(null,"\\"),parse(i){e(i,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return c;const A=i.length;let g=0,w=i.charCodeAt(0);if(A===1)return R(w)?(c.root=c.dir=i,c):(c.base=c.name=i,c);if(R(w)){if(g=1,R(i.charCodeAt(1))){let I=2,q=I;for(;I<A&&!R(i.charCodeAt(I));)I++;if(I<A&&I!==q){for(q=I;I<A&&R(i.charCodeAt(I));)I++;if(I<A&&I!==q){for(q=I;I<A&&!R(i.charCodeAt(I));)I++;I===A?g=I:I!==q&&(g=I+1)}}}}else if(d(w)&&i.charCodeAt(1)===m){if(A<=2)return c.root=c.dir=i,c;if(g=2,R(i.charCodeAt(2))){if(A===3)return c.root=c.dir=i,c;g=3}}g>0&&(c.root=i.slice(0,g));let M=-1,p=g,k=-1,y=!0,F=i.length-1,P=0;for(;F>=g;--F){if(w=i.charCodeAt(F),R(w)){if(!y){p=F+1;break}continue}k===-1&&(y=!1,k=F+1),w===h?M===-1?M=F:P!==1&&(P=1):M!==-1&&(P=-1)}return k!==-1&&(M===-1||P===0||P===1&&M===k-1&&M===p+1?c.base=c.name=i.slice(p,k):(c.name=i.slice(p,M),c.base=i.slice(p,k),c.ext=i.slice(M,k))),p>0&&p!==g?c.dir=i.slice(0,p-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(v){const i=/\\/g;return()=>{const c=T.cwd().replace(i,"/");return c.slice(c.indexOf("/"))}}return()=>T.cwd()})();t.$fc={resolve(...i){let c="",A=!1;for(let g=i.length-1;g>=-1&&!A;g--){const w=g>=0?i[g]:u();e(w,"path"),w.length!==0&&(c=`${w}/${c}`,A=w.charCodeAt(0)===a)}return c=l(c,!A,"/",L),A?`/${c}`:c.length>0?c:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const c=i.charCodeAt(0)===a,A=i.charCodeAt(i.length-1)===a;return i=l(i,!c,"/",L),i.length===0?c?"/":A?"./":".":(A&&(i+="/"),c?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===a},join(...i){if(i.length===0)return".";let c;for(let A=0;A<i.length;++A){const g=i[A];e(g,"path"),g.length>0&&(c===void 0?c=g:c+=`/${g}`)}return c===void 0?".":t.$fc.normalize(c)},relative(i,c){if(e(i,"from"),e(c,"to"),i===c||(i=t.$fc.resolve(i),c=t.$fc.resolve(c),i===c))return"";const A=1,g=i.length,w=g-A,M=1,p=c.length-M,k=w<p?w:p;let y=-1,F=0;for(;F<k;F++){const I=i.charCodeAt(A+F);if(I!==c.charCodeAt(M+F))break;I===a&&(y=F)}if(F===k)if(p>k){if(c.charCodeAt(M+F)===a)return c.slice(M+F+1);if(F===0)return c.slice(M+F)}else w>k&&(i.charCodeAt(A+F)===a?y=F:F===0&&(y=0));let P="";for(F=A+y+1;F<=g;++F)(F===g||i.charCodeAt(F)===a)&&(P+=P.length===0?"..":"/..");return`${P}${c.slice(M+y)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const c=i.charCodeAt(0)===a;let A=-1,g=!0;for(let w=i.length-1;w>=1;--w)if(i.charCodeAt(w)===a){if(!g){A=w;break}}else g=!1;return A===-1?c?"/":".":c&&A===1?"//":i.slice(0,A)},basename(i,c){c!==void 0&&e(c,"ext"),e(i,"path");let A=0,g=-1,w=!0,M;if(c!==void 0&&c.length>0&&c.length<=i.length){if(c===i)return"";let p=c.length-1,k=-1;for(M=i.length-1;M>=0;--M){const y=i.charCodeAt(M);if(y===a){if(!w){A=M+1;break}}else k===-1&&(w=!1,k=M+1),p>=0&&(y===c.charCodeAt(p)?--p===-1&&(g=M):(p=-1,g=k))}return A===g?g=k:g===-1&&(g=i.length),i.slice(A,g)}for(M=i.length-1;M>=0;--M)if(i.charCodeAt(M)===a){if(!w){A=M+1;break}}else g===-1&&(w=!1,g=M+1);return g===-1?"":i.slice(A,g)},extname(i){e(i,"path");let c=-1,A=0,g=-1,w=!0,M=0;for(let p=i.length-1;p>=0;--p){const k=i.charCodeAt(p);if(k===a){if(!w){A=p+1;break}continue}g===-1&&(w=!1,g=p+1),k===h?c===-1?c=p:M!==1&&(M=1):c!==-1&&(M=-1)}return c===-1||g===-1||M===0||M===1&&c===g-1&&c===A+1?"":i.slice(c,g)},format:o.bind(null,"/"),parse(i){e(i,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return c;const A=i.charCodeAt(0)===a;let g;A?(c.root="/",g=1):g=0;let w=-1,M=0,p=-1,k=!0,y=i.length-1,F=0;for(;y>=g;--y){const P=i.charCodeAt(y);if(P===a){if(!k){M=y+1;break}continue}p===-1&&(k=!1,p=y+1),P===h?w===-1?w=y:F!==1&&(F=1):w!==-1&&(F=-1)}if(p!==-1){const P=M===0&&A?1:M;w===-1||F===0||F===1&&w===p-1&&w===M+1?c.base=c.name=i.slice(P,p):(c.name=i.slice(P,w),c.base=i.slice(P,p),c.ext=i.slice(w,p))}return M>0?c.dir=i.slice(0,M-1):A&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},t.$fc.win32=t.$ec.win32=t.$ec,t.$fc.posix=t.$ec.posix=t.$fc,t.$gc=v?t.$ec.normalize:t.$fc.normalize,t.$hc=v?t.$ec.isAbsolute:t.$fc.isAbsolute,t.$ic=v?t.$ec.join:t.$fc.join,t.$jc=v?t.$ec.resolve:t.$fc.resolve,t.$kc=v?t.$ec.relative:t.$fc.relative,t.$lc=v?t.$ec.dirname:t.$fc.dirname,t.$mc=v?t.$ec.basename:t.$fc.basename,t.$nc=v?t.$ec.extname:t.$fc.extname,t.$oc=v?t.$ec.format:t.$fc.format,t.$pc=v?t.$ec.parse:t.$fc.parse,t.$qc=v?t.$ec.toNamespacedPath:t.$fc.toNamespacedPath,t.sep=v?t.$ec.sep:t.$fc.sep,t.$sc=v?t.$ec.delimiter:t.$fc.delimiter}),ne(ie[18],re([0,1,65,17]),function(O,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vc=t.$uc=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,f=/^\//,N=/^\/\//;function h(g,w){if(!g.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${g.authority}", path: "${g.path}", query: "${g.query}", fragment: "${g.fragment}"}`);if(g.scheme&&!r.test(g.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(g.path){if(g.authority){if(!f.test(g.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(g.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(g,w){return!g&&!w?"file":g}function s(g,w){switch(g){case"https":case"http":case"file":w?w[0]!==E&&(w=E+w):w=E;break}return w}const m="",E="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{static isUri(w){return w instanceof b?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,M,p,k,y,F=!1){typeof w=="object"?(this.scheme=w.scheme||m,this.authority=w.authority||m,this.path=w.path||m,this.query=w.query||m,this.fragment=w.fragment||m):(this.scheme=a(w,F),this.authority=M||m,this.path=s(this.scheme,p||m),this.query=k||m,this.fragment=y||m,h(this,F))}get fsPath(){return o(this,!1)}with(w){if(!w)return this;let{scheme:M,authority:p,path:k,query:y,fragment:F}=w;return M===void 0?M=this.scheme:M===null&&(M=m),p===void 0?p=this.authority:p===null&&(p=m),k===void 0?k=this.path:k===null&&(k=m),y===void 0?y=this.query:y===null&&(y=m),F===void 0?F=this.fragment:F===null&&(F=m),M===this.scheme&&p===this.authority&&k===this.path&&y===this.query&&F===this.fragment?this:new R(M,p,k,y,F)}static parse(w,M=!1){const p=$.exec(w);return p?new R(p[2]||m,A(p[4]||m),A(p[5]||m),A(p[7]||m),A(p[9]||m),M):new R(m,m,m,m,m)}static file(w){let M=m;if(D.$i&&(w=w.replace(/\\/g,E)),w[0]===E&&w[1]===E){const p=w.indexOf(E,2);p===-1?(M=w.substring(2),w=E):(M=w.substring(2,p),w=w.substring(p)||E)}return new R("file",M,w,m,m)}static from(w,M){return new R(w.scheme,w.authority,w.path,w.query,w.fragment,M)}static joinPath(w,...M){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return D.$i&&w.scheme==="file"?p=b.file(T.$ec.join(o(w,!0),...M)).path:p=T.$fc.join(w.path,...M),w.with({path:p})}toString(w=!1){return u(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof b)return w;{const M=new R(w);return M._formatted=w.external??null,M._fsPath=w._sep===v?w.fsPath??null:null,M}}else return w}}t.URI=b;function e(g){return!g||typeof g!="object"?!1:typeof g.scheme=="string"&&(typeof g.authority=="string"||typeof g.authority>"u")&&(typeof g.path=="string"||typeof g.path>"u")&&(typeof g.query=="string"||typeof g.query>"u")&&(typeof g.fragment=="string"||typeof g.fragment>"u")}t.$uc=e;const v=D.$i?1:void 0;class R extends b{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(w=!1){return w?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=v),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const L={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(g,w,M){let p,k=-1;for(let y=0;y<g.length;y++){const F=g.charCodeAt(y);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||w&&F===47||M&&F===91||M&&F===93||M&&F===58)k!==-1&&(p+=encodeURIComponent(g.substring(k,y)),k=-1),p!==void 0&&(p+=g.charAt(y));else{p===void 0&&(p=g.substr(0,y));const P=L[F];P!==void 0?(k!==-1&&(p+=encodeURIComponent(g.substring(k,y)),k=-1),p+=P):k===-1&&(k=y)}}return k!==-1&&(p+=encodeURIComponent(g.substring(k))),p!==void 0?p:g}function l(g){let w;for(let M=0;M<g.length;M++){const p=g.charCodeAt(M);p===35||p===63?(w===void 0&&(w=g.substr(0,M)),w+=L[p]):w!==void 0&&(w+=g[M])}return w!==void 0?w:g}function o(g,w){let M;return g.authority&&g.path.length>1&&g.scheme==="file"?M=`//${g.authority}${g.path}`:g.path.charCodeAt(0)===47&&(g.path.charCodeAt(1)>=65&&g.path.charCodeAt(1)<=90||g.path.charCodeAt(1)>=97&&g.path.charCodeAt(1)<=122)&&g.path.charCodeAt(2)===58?w?M=g.path.substr(1):M=g.path[1].toLowerCase()+g.path.substr(2):M=g.path,D.$i&&(M=M.replace(/\//g,"\\")),M}t.$vc=o;function u(g,w){const M=w?l:d;let p="",{scheme:k,authority:y,path:F,query:P,fragment:I}=g;if(k&&(p+=k,p+=":"),(y||k==="file")&&(p+=E,p+=E),y){let q=y.indexOf("@");if(q!==-1){const x=y.substr(0,q);y=y.substr(q+1),q=x.lastIndexOf(":"),q===-1?p+=M(x,!1,!1):(p+=M(x.substr(0,q),!1,!1),p+=":",p+=M(x.substr(q+1),!1,!0)),p+="@"}y=y.toLowerCase(),q=y.lastIndexOf(":"),q===-1?p+=M(y,!1,!0):(p+=M(y.substr(0,q),!1,!0),p+=y.substr(q))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const q=F.charCodeAt(1);q>=65&&q<=90&&(F=`/${String.fromCharCode(q+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const q=F.charCodeAt(0);q>=65&&q<=90&&(F=`${String.fromCharCode(q+32)}:${F.substr(2)}`)}p+=M(F,!0,!1)}return P&&(p+="?",p+=M(P,!1,!1)),I&&(p+="#",p+=w?I:d(I,!1,!1)),p}function i(g){try{return decodeURIComponent(g)}catch{return g.length>3?g.substr(0,3)+i(g.substr(3)):g}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function A(g){return g.match(c)?g.replace(c,w=>i(w)):g}}),ne(ie[70],re([0,1,3,11,10,14,17,7]),function(O,t,T,D,r,f,N,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const a="$initialize";let s=!1;function m(A){N.$o&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(A.message))}t.logOnceWebWorkerWarning=m;var E;(function(A){A[A.Request=0]="Request",A[A.Reply=1]="Reply",A[A.SubscribeEvent=2]="SubscribeEvent",A[A.Event=3]="Event",A[A.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class ${constructor(g,w,M,p){this.vsWorker=g,this.req=w,this.method=M,this.args=p,this.type=0}}class b{constructor(g,w,M,p){this.vsWorker=g,this.seq=w,this.res=M,this.err=p,this.type=1}}class e{constructor(g,w,M,p){this.vsWorker=g,this.req=w,this.eventName=M,this.arg=p,this.type=2}}class v{constructor(g,w,M){this.vsWorker=g,this.req=w,this.event=M,this.type=3}}class R{constructor(g,w){this.vsWorker=g,this.req=w,this.type=4}}class L{constructor(g){this.a=-1,this.g=g,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(g){this.a=g}sendMessage(g,w){const M=String(++this.b);return new Promise((p,k)=>{this.c[M]={resolve:p,reject:k},this.o(new $(this.a,M,g,w))})}listen(g,w){let M=null;const p=new D.$Od({onWillAddFirstListener:()=>{M=String(++this.b),this.d.set(M,p),this.o(new e(this.a,M,g,w))},onDidRemoveLastListener:()=>{this.d.delete(M),this.o(new R(this.a,M)),M=null}});return p.event}handleMessage(g){!g||!g.vsWorker||this.a!==-1&&g.vsWorker!==this.a||this.h(g)}h(g){switch(g.type){case 1:return this.j(g);case 0:return this.k(g);case 2:return this.l(g);case 3:return this.m(g);case 4:return this.n(g)}}j(g){if(!this.c[g.seq]){console.warn("Got reply to unknown seq");return}const w=this.c[g.seq];if(delete this.c[g.seq],g.err){let M=g.err;g.err.$isError&&(M=new Error,M.name=g.err.name,M.message=g.err.message,M.stack=g.err.stack),w.reject(M);return}w.resolve(g.res)}k(g){const w=g.req;this.g.handleMessage(g.method,g.args).then(p=>{this.o(new b(this.a,w,p,void 0))},p=>{p.detail instanceof Error&&(p.detail=(0,T.$2)(p.detail)),this.o(new b(this.a,w,void 0,(0,T.$2)(p)))})}l(g){const w=g.req,M=this.g.handleEvent(g.eventName,g.arg)(p=>{this.o(new v(this.a,w,p))});this.f.set(w,M)}m(g){if(!this.d.has(g.req)){console.warn("Got event for unknown req");return}this.d.get(g.req).fire(g.event)}n(g){if(!this.f.has(g.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(g.req).dispose(),this.f.delete(g.req)}o(g){const w=[];if(g.type===0)for(let M=0;M<g.args.length;M++)g.args[M]instanceof ArrayBuffer&&w.push(g.args[M]);else g.type===1&&g.res instanceof ArrayBuffer&&w.push(g.res);this.g.sendMessage(g,w)}}class d extends r.$Rc{constructor(g,w,M){super();let p=null;this.a=this.B(g.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{p?.(q)})),this.c=new L({sendMessage:(q,x)=>{this.a.postMessage(q,x)},handleMessage:(q,x)=>{if(typeof M[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(M[q].apply(M,x))}catch(_){return Promise.reject(_)}},handleEvent:(q,x)=>{if(o(q)){const _=M[q].call(M,x);if(typeof _!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return _}if(l(q)){const _=M[q];if(typeof _!="function")throw new Error(`Missing event ${q} on main thread host.`);return _}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let k=null;const y=globalThis.require;typeof y<"u"&&typeof y.getConfig=="function"?k=y.getConfig():typeof globalThis.requirejs<"u"&&(k=globalThis.requirejs.s.contexts._.config);const F=(0,f.$hn)(M);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(k)),w,F]);const P=(q,x)=>this.g(q,x),I=(q,x)=>this.c.listen(q,x);this.f=new Promise((q,x)=>{p=x,this.b.then(_=>{q(u(_,P,I))},_=>{x(_),this.h("Worker failed to load "+w,_)})})}getProxyObject(){return this.f}g(g,w){return new Promise((M,p)=>{this.b.then(()=>{this.c.sendMessage(g,w).then(M,p)},p)})}h(g,w){console.error(g),console.info(w)}}t.SimpleWorkerClient=d;function l(A){return A[0]==="o"&&A[1]==="n"&&h.$2e(A.charCodeAt(2))}function o(A){return/^onDynamic/.test(A)&&h.$2e(A.charCodeAt(9))}function u(A,g,w){const M=y=>function(){const F=Array.prototype.slice.call(arguments,0);return g(y,F)},p=y=>function(F){return w(y,F)},k={};for(const y of A){if(o(y)){k[y]=p(y);continue}if(l(y)){k[y]=w(y,void 0);continue}k[y]=M(y)}return k}class i{constructor(g,w){this.a=w,this.b=null,this.c=new L({sendMessage:(M,p)=>{g(M,p)},handleMessage:(M,p)=>this.d(M,p),handleEvent:(M,p)=>this.f(M,p)})}onmessage(g){this.c.handleMessage(g)}d(g,w){if(g===a)return this.g(w[0],w[1],w[2],w[3]);if(!this.b||typeof this.b[g]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+g));try{return Promise.resolve(this.b[g].apply(this.b,w))}catch(M){return Promise.reject(M)}}f(g,w){if(!this.b)throw new Error("Missing requestHandler");if(o(g)){const M=this.b[g].call(this.b,w);if(typeof M!="function")throw new Error(`Missing dynamic event ${g} on request handler.`);return M}if(l(g)){const M=this.b[g];if(typeof M!="function")throw new Error(`Missing event ${g} on request handler.`);return M}throw new Error(`Malformed event name ${g}`)}g(g,w,M,p){this.c.setWorkerId(g);const F=u(p,(P,I)=>this.c.sendMessage(P,I),(P,I)=>this.c.listen(P,I));return this.a?(this.b=this.a(F),Promise.resolve((0,f.$hn)(this.b))):(w&&(typeof w.baseUrl<"u"&&delete w.baseUrl,typeof w.paths<"u"&&typeof w.paths.vs<"u"&&delete w.paths.vs,typeof w.trustedTypesPolicy!==void 0&&delete w.trustedTypesPolicy,w.catchError=!0,globalThis.require.config(w)),new Promise((P,I)=>{(globalThis.require||O)([M],x=>{if(this.b=x.create(F),!this.b){I(new Error("No RequestHandler!"));return}P((0,f.$hn)(this.b))},I)}))}}t.SimpleWorkerServer=i;function c(A){return new i(A,null)}t.create=c}),ne(ie[66],re([62,63]),function(O,t){return O.create("vs/editor/common/languages",t)}),ne(ie[67],re([0,1,41,18,42,2,60,66]),function(O,t,T,D,r,f,N,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$nt=t.$mt=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.$lt=t.$kt=t.SymbolKinds=t.SymbolTag=t.$jt=t.$it=t.SymbolKind=t.$ht=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$gt=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$ft=t.$et=t.$dt=void 0;class a{constructor(j,H,W){this.offset=j,this.type=H,this.language=W,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$dt=a;class s{constructor(j,H){this.tokens=j,this.endState=H,this._tokenizationResultBrand=void 0}}t.$et=s;class m{constructor(j,H){this.tokens=j,this.endState=H,this._encodedTokenizationResultBrand=void 0}}t.$ft=m;var E;(function(_){_[_.Method=0]="Method",_[_.Function=1]="Function",_[_.Constructor=2]="Constructor",_[_.Field=3]="Field",_[_.Variable=4]="Variable",_[_.Class=5]="Class",_[_.Struct=6]="Struct",_[_.Interface=7]="Interface",_[_.Module=8]="Module",_[_.Property=9]="Property",_[_.Event=10]="Event",_[_.Operator=11]="Operator",_[_.Unit=12]="Unit",_[_.Value=13]="Value",_[_.Constant=14]="Constant",_[_.Enum=15]="Enum",_[_.EnumMember=16]="EnumMember",_[_.Keyword=17]="Keyword",_[_.Text=18]="Text",_[_.Color=19]="Color",_[_.File=20]="File",_[_.Reference=21]="Reference",_[_.Customcolor=22]="Customcolor",_[_.Folder=23]="Folder",_[_.TypeParameter=24]="TypeParameter",_[_.User=25]="User",_[_.Issue=26]="Issue",_[_.Snippet=27]="Snippet"})(E||(t.CompletionItemKind=E={}));var $;(function(_){const j=new Map;j.set(0,T.$Xj.symbolMethod),j.set(1,T.$Xj.symbolFunction),j.set(2,T.$Xj.symbolConstructor),j.set(3,T.$Xj.symbolField),j.set(4,T.$Xj.symbolVariable),j.set(5,T.$Xj.symbolClass),j.set(6,T.$Xj.symbolStruct),j.set(7,T.$Xj.symbolInterface),j.set(8,T.$Xj.symbolModule),j.set(9,T.$Xj.symbolProperty),j.set(10,T.$Xj.symbolEvent),j.set(11,T.$Xj.symbolOperator),j.set(12,T.$Xj.symbolUnit),j.set(13,T.$Xj.symbolValue),j.set(15,T.$Xj.symbolEnum),j.set(14,T.$Xj.symbolConstant),j.set(15,T.$Xj.symbolEnum),j.set(16,T.$Xj.symbolEnumMember),j.set(17,T.$Xj.symbolKeyword),j.set(27,T.$Xj.symbolSnippet),j.set(18,T.$Xj.symbolText),j.set(19,T.$Xj.symbolColor),j.set(20,T.$Xj.symbolFile),j.set(21,T.$Xj.symbolReference),j.set(22,T.$Xj.symbolCustomColor),j.set(23,T.$Xj.symbolFolder),j.set(24,T.$Xj.symbolTypeParameter),j.set(25,T.$Xj.account),j.set(26,T.$Xj.issues);function H(n){let te=j.get(n);return te||(console.info("No codicon found for CompletionItemKind "+n),te=T.$Xj.symbolProperty),te}_.toIcon=H;const W=new Map;W.set("method",0),W.set("function",1),W.set("constructor",2),W.set("field",3),W.set("variable",4),W.set("class",5),W.set("struct",6),W.set("interface",7),W.set("module",8),W.set("property",9),W.set("event",10),W.set("operator",11),W.set("unit",12),W.set("value",13),W.set("constant",14),W.set("enum",15),W.set("enum-member",16),W.set("enumMember",16),W.set("keyword",17),W.set("snippet",27),W.set("text",18),W.set("color",19),W.set("file",20),W.set("reference",21),W.set("customcolor",22),W.set("folder",23),W.set("type-parameter",24),W.set("typeParameter",24),W.set("account",25),W.set("issue",26);function J(n,te){let ce=W.get(n);return typeof ce>"u"&&!te&&(ce=9),ce}_.fromString=J})($||(t.CompletionItemKinds=$={}));var b;(function(_){_[_.Deprecated=1]="Deprecated"})(b||(t.CompletionItemTag=b={}));var e;(function(_){_[_.None=0]="None",_[_.KeepWhitespace=1]="KeepWhitespace",_[_.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var v;(function(_){_[_.Invoke=0]="Invoke",_[_.TriggerCharacter=1]="TriggerCharacter",_[_.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v||(t.CompletionTriggerKind=v={}));var R;(function(_){_[_.Automatic=0]="Automatic",_[_.Explicit=1]="Explicit"})(R||(t.InlineCompletionTriggerKind=R={}));class L{constructor(j,H,W,J){this.range=j,this.text=H,this.completionKind=W,this.isSnippetText=J}equals(j){return f.$ws.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}t.$gt=L;var d;(function(_){_[_.Invoke=1]="Invoke",_[_.Auto=2]="Auto"})(d||(t.CodeActionTriggerType=d={}));var l;(function(_){_[_.Invoke=1]="Invoke",_[_.TriggerCharacter=2]="TriggerCharacter",_[_.ContentChange=3]="ContentChange"})(l||(t.SignatureHelpTriggerKind=l={}));var o;(function(_){_[_.Text=0]="Text",_[_.Read=1]="Read",_[_.Write=2]="Write"})(o||(t.DocumentHighlightKind=o={}));function u(_){return _&&D.URI.isUri(_.uri)&&f.$ws.isIRange(_.range)&&(f.$ws.isIRange(_.originSelectionRange)||f.$ws.isIRange(_.targetSelectionRange))}t.$ht=u;var i;(function(_){_[_.File=0]="File",_[_.Module=1]="Module",_[_.Namespace=2]="Namespace",_[_.Package=3]="Package",_[_.Class=4]="Class",_[_.Method=5]="Method",_[_.Property=6]="Property",_[_.Field=7]="Field",_[_.Constructor=8]="Constructor",_[_.Enum=9]="Enum",_[_.Interface=10]="Interface",_[_.Function=11]="Function",_[_.Variable=12]="Variable",_[_.Constant=13]="Constant",_[_.String=14]="String",_[_.Number=15]="Number",_[_.Boolean=16]="Boolean",_[_.Array=17]="Array",_[_.Object=18]="Object",_[_.Key=19]="Key",_[_.Null=20]="Null",_[_.EnumMember=21]="EnumMember",_[_.Struct=22]="Struct",_[_.Event=23]="Event",_[_.Operator=24]="Operator",_[_.TypeParameter=25]="TypeParameter"})(i||(t.SymbolKind=i={})),t.$it={[17]:(0,h.localize)(0,null),[16]:(0,h.localize)(1,null),[4]:(0,h.localize)(2,null),[13]:(0,h.localize)(3,null),[8]:(0,h.localize)(4,null),[9]:(0,h.localize)(5,null),[21]:(0,h.localize)(6,null),[23]:(0,h.localize)(7,null),[7]:(0,h.localize)(8,null),[0]:(0,h.localize)(9,null),[11]:(0,h.localize)(10,null),[10]:(0,h.localize)(11,null),[19]:(0,h.localize)(12,null),[5]:(0,h.localize)(13,null),[1]:(0,h.localize)(14,null),[2]:(0,h.localize)(15,null),[20]:(0,h.localize)(16,null),[15]:(0,h.localize)(17,null),[18]:(0,h.localize)(18,null),[24]:(0,h.localize)(19,null),[3]:(0,h.localize)(20,null),[6]:(0,h.localize)(21,null),[14]:(0,h.localize)(22,null),[22]:(0,h.localize)(23,null),[25]:(0,h.localize)(24,null),[12]:(0,h.localize)(25,null)};function c(_,j){return(0,h.localize)(26,null,_,t.$it[j])}t.$jt=c;var A;(function(_){_[_.Deprecated=1]="Deprecated"})(A||(t.SymbolTag=A={}));var g;(function(_){const j=new Map;j.set(0,T.$Xj.symbolFile),j.set(1,T.$Xj.symbolModule),j.set(2,T.$Xj.symbolNamespace),j.set(3,T.$Xj.symbolPackage),j.set(4,T.$Xj.symbolClass),j.set(5,T.$Xj.symbolMethod),j.set(6,T.$Xj.symbolProperty),j.set(7,T.$Xj.symbolField),j.set(8,T.$Xj.symbolConstructor),j.set(9,T.$Xj.symbolEnum),j.set(10,T.$Xj.symbolInterface),j.set(11,T.$Xj.symbolFunction),j.set(12,T.$Xj.symbolVariable),j.set(13,T.$Xj.symbolConstant),j.set(14,T.$Xj.symbolString),j.set(15,T.$Xj.symbolNumber),j.set(16,T.$Xj.symbolBoolean),j.set(17,T.$Xj.symbolArray),j.set(18,T.$Xj.symbolObject),j.set(19,T.$Xj.symbolKey),j.set(20,T.$Xj.symbolNull),j.set(21,T.$Xj.symbolEnumMember),j.set(22,T.$Xj.symbolStruct),j.set(23,T.$Xj.symbolEvent),j.set(24,T.$Xj.symbolOperator),j.set(25,T.$Xj.symbolTypeParameter);function H(W){let J=j.get(W);return J||(console.info("No codicon found for SymbolKind "+W),J=T.$Xj.symbolProperty),J}_.toIcon=H})(g||(t.SymbolKinds=g={}));class w{static asEditOperation(j){return r.$xs.replace(f.$ws.lift(j.range),j.text)}}t.$kt=w;class M{static{this.Comment=new M("comment")}static{this.Imports=new M("imports")}static{this.Region=new M("region")}static fromValue(j){switch(j){case"comment":return M.Comment;case"imports":return M.Imports;case"region":return M.Region}return new M(j)}constructor(j){this.value=j}}t.$lt=M;var p;(function(_){function j(H){return!H||typeof H!="object"?!1:typeof H.id=="string"&&typeof H.title=="string"}_.is=j})(p||(t.Command=p={}));var k;(function(_){_[_.Collapsed=0]="Collapsed",_[_.Expanded=1]="Expanded"})(k||(t.CommentThreadCollapsibleState=k={}));var y;(function(_){_[_.Unresolved=0]="Unresolved",_[_.Resolved=1]="Resolved"})(y||(t.CommentThreadState=y={}));var F;(function(_){_[_.Editing=0]="Editing",_[_.Preview=1]="Preview"})(F||(t.CommentMode=F={}));var P;(function(_){_[_.Published=0]="Published",_[_.Draft=1]="Draft"})(P||(t.CommentState=P={}));var I;(function(_){_[_.Type=1]="Type",_[_.Parameter=2]="Parameter"})(I||(t.InlayHintKind=I={}));class q{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$mt=q,t.$nt=new N.$8s;var x;(function(_){_[_.None=0]="None",_[_.Option=1]="Option",_[_.Default=2]="Default",_[_.Preferred=3]="Preferred"})(x||(t.ExternalUriOpenerPriority=x={}))}),ne(ie[68],re([0,1,24,11,37,18,5,2,43,67,59]),function(O,t,T,D,r,f,N,h,a,s,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GZ=t.$FZ=void 0;class E{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,v){return(0,r.$Iq)(e,v)}}t.$FZ=E;function $(){return{editor:void 0,languages:void 0,CancellationTokenSource:T.$Yd,Emitter:D.$Od,KeyCode:m.KeyCode,KeyMod:E,Position:N.$vs,Range:h.$ws,Selection:a.$ys,SelectionDirection:m.SelectionDirection,MarkerSeverity:m.MarkerSeverity,MarkerTag:m.MarkerTag,Uri:f.URI,Token:s.$dt}}t.$GZ=$}),ne(ie[71],re([0,1,25,18,5,2,56,29,52,53,68,23,58,33,50,14,3,51]),function(O,t,T,D,r,f,N,h,a,s,m,E,$,b,e,v,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class d extends N.$Yu{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(i){const c=[];for(let A=0;A<this.f.length;A++){const g=this.f[A],w=this.offsetAt(new r.$vs(A+1,1)),M=g.matchAll(i);for(const p of M)(p.index||p.index===0)&&(p.index=p.index+w),c.push(p)}return c}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(i){return this.f[i-1]}getWordAtPosition(i,c){const A=(0,h.$$r)(i.column,(0,h.$9r)(c),this.f[i.lineNumber-1],0);return A?new f.$ws(i.lineNumber,A.startColumn,i.lineNumber,A.endColumn):null}getWordUntilPosition(i,c){const A=this.getWordAtPosition(i,c);return A?{word:this.f[i.lineNumber-1].substring(A.startColumn-1,i.column-1),startColumn:A.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const c=this.f,A=this.q.bind(this);let g=0,w="",M=0,p=[];return{*[Symbol.iterator](){for(;;)if(M<p.length){const k=w.substring(p[M].start,p[M].end);M+=1,yield k}else if(g<c.length)w=c[g],p=A(w,i),M=0,g+=1;else break}}}getLineWords(i,c){const A=this.f[i-1],g=this.q(A,c),w=[];for(const M of g)w.push({word:A.substring(M.start,M.end),startColumn:M.start+1,endColumn:M.end+1});return w}q(i,c){const A=[];let g;for(c.lastIndex=0;(g=c.exec(i))&&g[0].length!==0;)A.push({start:g.index,end:g.index+g[0].length});return A}getValueInRange(i){if(i=this.r(i),i.startLineNumber===i.endLineNumber)return this.f[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const c=this.g,A=i.startLineNumber-1,g=i.endLineNumber-1,w=[];w.push(this.f[A].substring(i.startColumn-1));for(let M=A+1;M<g;M++)w.push(this.f[M]);return w.push(this.f[g].substring(0,i.endColumn-1)),w.join(c)}offsetAt(i){return i=this.s(i),this.l(),this.j.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this.l();const c=this.j.getIndexOf(i),A=this.f[c.index].length;return{lineNumber:1+c.index,column:1+Math.min(c.remainder,A)}}r(i){const c=this.s({lineNumber:i.startLineNumber,column:i.startColumn}),A=this.s({lineNumber:i.endLineNumber,column:i.endColumn});return c.lineNumber!==i.startLineNumber||c.column!==i.startColumn||A.lineNumber!==i.endLineNumber||A.column!==i.endColumn?{startLineNumber:c.lineNumber,startColumn:c.column,endLineNumber:A.lineNumber,endColumn:A.column}:i}s(i){if(!r.$vs.isIPosition(i))throw new Error("bad position");let{lineNumber:c,column:A}=i,g=!1;if(c<1)c=1,A=1,g=!0;else if(c>this.f.length)c=this.f.length,A=this.f[c-1].length+1,g=!0;else{const w=this.f[c-1].length+1;A<1?(A=1,g=!0):A>w&&(A=w,g=!0)}return g?{lineNumber:c,column:A}:i}}class l{constructor(i,c){this.d=i,this.f=Object.create(null),this.g=c,this.h=null}dispose(){this.f=Object.create(null)}j(i){return this.f[i]}k(){const i=[];return Object.keys(this.f).forEach(c=>i.push(this.f[c])),i}acceptNewModel(i){this.f[i.url]=new d(D.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,c){if(!this.f[i])return;this.f[i].onEvents(c)}acceptRemovedModel(i){this.f[i]&&delete this.f[i]}async computeUnicodeHighlights(i,c,A){const g=this.j(i);return g?$.$AZ.computeUnicodeHighlights(g,c,A):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,c,A,g){const w=this.j(i),M=this.j(c);return!w||!M?null:l.l(w,M,A,g)}static l(i,c,A,g){const w=g==="advanced"?e.$3Z.getDefault():e.$3Z.getLegacy(),M=i.getLinesContent(),p=c.getLinesContent(),k=w.computeDiff(M,p,A),y=k.changes.length>0?!1:this.n(i,c);function F(P){return P.map(I=>[I.original.startLineNumber,I.original.endLineNumberExclusive,I.modified.startLineNumber,I.modified.endLineNumberExclusive,I.innerChanges?.map(q=>[q.originalRange.startLineNumber,q.originalRange.startColumn,q.originalRange.endLineNumber,q.originalRange.endColumn,q.modifiedRange.startLineNumber,q.modifiedRange.startColumn,q.modifiedRange.endLineNumber,q.modifiedRange.endColumn])])}return{identical:y,quitEarly:k.hitTimeout,changes:F(k.changes),moves:k.moves.map(P=>[P.lineRangeMapping.original.startLineNumber,P.lineRangeMapping.original.endLineNumberExclusive,P.lineRangeMapping.modified.startLineNumber,P.lineRangeMapping.modified.endLineNumberExclusive,F(P.changes)])}}static n(i,c){const A=i.getLineCount(),g=c.getLineCount();if(A!==g)return!1;for(let w=1;w<=A;w++){const M=i.getLineContent(w),p=c.getLineContent(w);if(M!==p)return!1}return!0}async computeDirtyDiff(i,c,A){const g=this.j(i),w=this.j(c);if(!g||!w)return null;const M=g.getLinesContent(),p=w.getLinesContent();return new b.$Ns(M,p,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:A,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(i,c,A){const g=this.j(i);if(!g)return c;const w=[];let M;c=c.slice(0).sort((k,y)=>{if(k.range&&y.range)return f.$ws.compareRangesUsingStarts(k.range,y.range);const F=k.range?0:1,P=y.range?0:1;return F-P});let p=0;for(let k=1;k<c.length;k++)f.$ws.getEndPosition(c[p].range).equals(f.$ws.getStartPosition(c[k].range))?(c[p].range=f.$ws.fromPositions(f.$ws.getStartPosition(c[p].range),f.$ws.getEndPosition(c[k].range)),c[p].text+=c[k].text):(p++,c[p]=c[k]);c.length=p+1;for(let{range:k,text:y,eol:F}of c){if(typeof F=="number"&&(M=F),f.$ws.isEmpty(k)&&!y)continue;const P=g.getValueInRange(k);if(y=y.replace(/\r\n|\n|\r/g,g.eol),P===y)continue;if(Math.max(y.length,P.length)>l.o){w.push({range:k,text:y});continue}const I=(0,T.$Bs)(P,y,A),q=g.offsetAt(f.$ws.lift(k).getStartPosition());for(const x of I){const _=g.positionAt(q+x.originalStart),j=g.positionAt(q+x.originalStart+x.originalLength),H={text:y.substr(x.modifiedStart,x.modifiedLength),range:{startLineNumber:_.lineNumber,startColumn:_.column,endLineNumber:j.lineNumber,endColumn:j.column}};g.getValueInRange(H.range)!==H.text&&w.push(H)}}return typeof M=="number"&&w.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}computeHumanReadableDiff(i,c,A){const g=this.j(i);if(!g)return c;const w=[];let M;c=c.slice(0).sort((p,k)=>{if(p.range&&k.range)return f.$ws.compareRangesUsingStarts(p.range,k.range);const y=p.range?0:1,F=k.range?0:1;return y-F});for(let{range:p,text:k,eol:y}of c){let _=function(H,W){return new r.$vs(H.lineNumber+W.lineNumber-1,W.lineNumber===1?H.column+W.column-1:W.column)},j=function(H,W){const J=[];for(let n=W.startLineNumber;n<=W.endLineNumber;n++){const te=H[n-1];n===W.startLineNumber&&n===W.endLineNumber?J.push(te.substring(W.startColumn-1,W.endColumn-1)):n===W.startLineNumber?J.push(te.substring(W.startColumn-1)):n===W.endLineNumber?J.push(te.substring(0,W.endColumn-1)):J.push(te)}return J};if(typeof y=="number"&&(M=y),f.$ws.isEmpty(p)&&!k)continue;const F=g.getValueInRange(p);if(k=k.replace(/\r\n|\n|\r/g,g.eol),F===k)continue;if(Math.max(k.length,F.length)>l.o){w.push({range:p,text:k});continue}const P=F.split(/\r\n|\n|\r/),I=k.split(/\r\n|\n|\r/),q=e.$3Z.getDefault().computeDiff(P,I,A),x=f.$ws.lift(p).getStartPosition();for(const H of q.changes)if(H.innerChanges)for(const W of H.innerChanges)w.push({range:f.$ws.fromPositions(_(x,W.originalRange.getStartPosition()),_(x,W.originalRange.getEndPosition())),text:j(I,W.modifiedRange).join(g.eol)});else throw new R.$bb("The experimental diff algorithm always produces inner changes")}return typeof M=="number"&&w.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeLinks(i){const c=this.j(i);return c?(0,a.$DZ)(c):null}async computeDefaultDocumentColors(i){const c=this.j(i);return c?(0,L.$4Z)(c):null}static{this.p=1e4}async textualSuggest(i,c,A,g){const w=new E.$Kd,M=new RegExp(A,g),p=new Set;e:for(const k of i){const y=this.j(k);if(y){for(const F of y.words(M))if(!(F===c||!isNaN(Number(F)))&&(p.add(F),p.size>l.p))break e}}return{words:Array.from(p),duration:w.elapsed()}}async computeWordRanges(i,c,A,g){const w=this.j(i);if(!w)return Object.create(null);const M=new RegExp(A,g),p=Object.create(null);for(let k=c.startLineNumber;k<c.endLineNumber;k++){const y=w.getLineWords(k,M);for(const F of y){if(!isNaN(Number(F.word)))continue;let P=p[F.word];P||(P=[],p[F.word]=P),P.push({startLineNumber:k,startColumn:F.startColumn,endLineNumber:k,endColumn:F.endColumn})}}return p}async navigateValueSet(i,c,A,g,w){const M=this.j(i);if(!M)return null;const p=new RegExp(g,w);c.startColumn===c.endColumn&&(c={startLineNumber:c.startLineNumber,startColumn:c.startColumn,endLineNumber:c.endLineNumber,endColumn:c.endColumn+1});const k=M.getValueInRange(c),y=M.getWordAtPosition({lineNumber:c.startLineNumber,column:c.startColumn},p);if(!y)return null;const F=M.getValueInRange(y);return s.$EZ.INSTANCE.navigateValueSet(c,k,y,F,A)}loadForeignModule(i,c,A){const g=(p,k)=>this.d.fhr(p,k),M={host:(0,v.$in)(A,g),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(M,c),Promise.resolve((0,v.$hn)(this.h))):new Promise((p,k)=>{O([i],y=>{this.h=y.create(M,c),p((0,v.$hn)(this.h))},k)})}fmr(i,c){if(!this.h||typeof this.h[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this.h[i].apply(this.h,c))}catch(A){return Promise.reject(A)}}}t.EditorSimpleWorker=l;function o(u){return new l(u,null)}t.create=o,typeof importScripts=="function"&&(globalThis.monaco=(0,m.$GZ)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8d99999f3f8664f290bb4b98f99603b4c4e545d2/core/vs/base/worker/workerMain.js.map
