/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var $e=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/nls","vs/base/browser/window","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/browser/iframe","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],we=function(ae){for(var t=[],v=0,T=ae.length;v<T;v++)t[v]=$e[ae[v]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:jt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:it,seal:ut,create:ri}=Object,{apply:Ft,construct:Nt}=typeof Reflect<"u"&&Reflect;Ft||(Ft=function(t,v,T){return t.apply(v,T)}),it||(it=function(t){return t}),ut||(ut=function(t){return t}),Nt||(Nt=function(t,v){return new t(...v)});const oi=at(Array.prototype.forEach),Ht=at(Array.prototype.pop),bt=at(Array.prototype.push),Dt=at(String.prototype.toLowerCase),Ot=at(String.prototype.toString),li=at(String.prototype.match),ct=at(String.prototype.replace),ai=at(String.prototype.indexOf),hi=at(String.prototype.trim),lt=at(RegExp.prototype.test),$t=ui(TypeError);function at(ae){return function(t){for(var v=arguments.length,T=new Array(v>1?v-1:0),i=1;i<v;i++)T[i-1]=arguments[i];return Ft(ae,t,T)}}function ui(ae){return function(){for(var t=arguments.length,v=new Array(t),T=0;T<t;T++)v[T]=arguments[T];return Nt(ae,v)}}function je(ae,t,v){var T;v=(T=v)!==null&&T!==void 0?T:Dt,jt&&jt(ae,null);let i=t.length;for(;i--;){let H=t[i];if(typeof H=="string"){const w=v(H);w!==H&&(ii(t)||(t[i]=w),H=w)}ae[H]=!0}return ae}function gt(ae){const t=ri(null);for(const[v,T]of zt(ae))t[v]=T;return t}function yt(ae,t){for(;ae!==null;){const T=si(ae,t);if(T){if(T.get)return at(T.get);if(typeof T.value=="function")return at(T.value)}ae=ni(ae)}function v(T){return console.warn("fallback value for",T),null}return v}const Ut=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Tt=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=it(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Rt=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=it(["#text"]),qt=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),It=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),_t=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Et=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ut(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ut(/<%[\w\W]*|[\w\W]*%>/gm),mi=ut(/\${[\w\W]*}/gm),bi=ut(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ut(/^aria-[\-\w]+$/),Qt=ut(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ut(/^(?:\w+script|data):/i),wi=ut(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Vt=ut(/^html$/i);var Kt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:Qt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Vt});const vi=()=>typeof window>"u"?null:window,Di=function(t,v){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let T=null;const i="data-tt-policy-suffix";v&&v.hasAttribute(i)&&(T=v.getAttribute(i));const H="dompurify"+(T?"#"+T:"");try{return t.createPolicy(H,{createHTML(w){return w},createScriptURL(w){return w}})}catch{return console.warn("TrustedTypes policy "+H+" could not be created."),null}};function xt(){let ae=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Ie=>xt(Ie);if(t.version="3.0.5",t.removed=[],!ae||!ae.document||ae.document.nodeType!==9)return t.isSupported=!1,t;const v=ae.document,T=v.currentScript;let{document:i}=ae;const{DocumentFragment:H,HTMLTemplateElement:w,Node:A,Element:f,NodeFilter:g,NamedNodeMap:c=ae.NamedNodeMap||ae.MozNamedAttrMap,HTMLFormElement:L,DOMParser:s,trustedTypes:h}=ae,e=f.prototype,o=yt(e,"cloneNode"),a=yt(e,"nextSibling"),m=yt(e,"childNodes"),n=yt(e,"parentNode");if(typeof w=="function"){const Ie=i.createElement("template");Ie.content&&Ie.content.ownerDocument&&(i=Ie.content.ownerDocument)}let r,b="";const{implementation:u,createNodeIterator:l,createDocumentFragment:N,getElementsByTagName:z}=i,{importNode:R}=v;let d={};t.isSupported=typeof zt=="function"&&typeof n=="function"&&u&&u.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:D,ERB_EXPR:B,TMPLIT_EXPR:_,DATA_ATTR:x,ARIA_ATTR:P,IS_SCRIPT_OR_DATA:O,ATTR_WHITESPACE:K}=Kt;let{IS_ALLOWED_URI:te}=Kt,se=null;const fe=je({},[...Ut,...Tt,...Lt,...Rt,...Wt]);let le=null;const oe=je({},[...qt,...It,..._t,...Et]);let be=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Ce=null,Ae=null,Pe=!0,de=!0,ie=!1,ce=!0,Z=!1,W=!1,Y=!1,S=!1,q=!1,$=!1,U=!1,Q=!0,p=!1;const E="user-content-";let y=!0,M=!1,k={},I=null;const C=je({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let F=null;const j=je({},["audio","video","img","source","image","track"]);let X=null;const ee=je({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),ne="http://www.w3.org/1998/Math/MathML",me="http://www.w3.org/2000/svg",ve="http://www.w3.org/1999/xhtml";let Ne=ve,Se=!1,De=null;const Le=je({},[ne,me,ve],Ot);let Te;const We=["application/xhtml+xml","text/html"],He="text/html";let Me,Ye=null;const J=i.createElement("form"),he=function(ue){return ue instanceof RegExp||ue instanceof Function},pe=function(ue){if(!(Ye&&Ye===ue)){if((!ue||typeof ue!="object")&&(ue={}),ue=gt(ue),Te=We.indexOf(ue.PARSER_MEDIA_TYPE)===-1?Te=He:Te=ue.PARSER_MEDIA_TYPE,Me=Te==="application/xhtml+xml"?Ot:Dt,se="ALLOWED_TAGS"in ue?je({},ue.ALLOWED_TAGS,Me):fe,le="ALLOWED_ATTR"in ue?je({},ue.ALLOWED_ATTR,Me):oe,De="ALLOWED_NAMESPACES"in ue?je({},ue.ALLOWED_NAMESPACES,Ot):Le,X="ADD_URI_SAFE_ATTR"in ue?je(gt(ee),ue.ADD_URI_SAFE_ATTR,Me):ee,F="ADD_DATA_URI_TAGS"in ue?je(gt(j),ue.ADD_DATA_URI_TAGS,Me):j,I="FORBID_CONTENTS"in ue?je({},ue.FORBID_CONTENTS,Me):C,Ce="FORBID_TAGS"in ue?je({},ue.FORBID_TAGS,Me):{},Ae="FORBID_ATTR"in ue?je({},ue.FORBID_ATTR,Me):{},k="USE_PROFILES"in ue?ue.USE_PROFILES:!1,Pe=ue.ALLOW_ARIA_ATTR!==!1,de=ue.ALLOW_DATA_ATTR!==!1,ie=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,ce=ue.ALLOW_SELF_CLOSE_IN_ATTR!==!1,Z=ue.SAFE_FOR_TEMPLATES||!1,W=ue.WHOLE_DOCUMENT||!1,q=ue.RETURN_DOM||!1,$=ue.RETURN_DOM_FRAGMENT||!1,U=ue.RETURN_TRUSTED_TYPE||!1,S=ue.FORCE_BODY||!1,Q=ue.SANITIZE_DOM!==!1,p=ue.SANITIZE_NAMED_PROPS||!1,y=ue.KEEP_CONTENT!==!1,M=ue.IN_PLACE||!1,te=ue.ALLOWED_URI_REGEXP||Qt,Ne=ue.NAMESPACE||ve,be=ue.CUSTOM_ELEMENT_HANDLING||{},ue.CUSTOM_ELEMENT_HANDLING&&he(ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(be.tagNameCheck=ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&he(ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(be.attributeNameCheck=ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&typeof ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(be.allowCustomizedBuiltInElements=ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),Z&&(de=!1),$&&(q=!0),k&&(se=je({},[...Wt]),le=[],k.html===!0&&(je(se,Ut),je(le,qt)),k.svg===!0&&(je(se,Tt),je(le,It),je(le,Et)),k.svgFilters===!0&&(je(se,Lt),je(le,It),je(le,Et)),k.mathMl===!0&&(je(se,Rt),je(le,_t),je(le,Et))),ue.ADD_TAGS&&(se===fe&&(se=gt(se)),je(se,ue.ADD_TAGS,Me)),ue.ADD_ATTR&&(le===oe&&(le=gt(le)),je(le,ue.ADD_ATTR,Me)),ue.ADD_URI_SAFE_ATTR&&je(X,ue.ADD_URI_SAFE_ATTR,Me),ue.FORBID_CONTENTS&&(I===C&&(I=gt(I)),je(I,ue.FORBID_CONTENTS,Me)),y&&(se["#text"]=!0),W&&je(se,["html","head","body"]),se.table&&(je(se,["tbody"]),delete Ce.tbody),ue.TRUSTED_TYPES_POLICY){if(typeof ue.TRUSTED_TYPES_POLICY.createHTML!="function")throw $t('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ue.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw $t('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');r=ue.TRUSTED_TYPES_POLICY,b=r.createHTML("")}else r===void 0&&(r=Di(h,T)),r!==null&&typeof b=="string"&&(b=r.createHTML(""));it&&it(ue),Ye=ue}},Ee=je({},["mi","mo","mn","ms","mtext"]),Fe=je({},["foreignobject","desc","title","annotation-xml"]),Be=je({},["title","style","font","a","script"]),Ue=je({},Tt);je(Ue,Lt),je(Ue,ci);const Ze=je({},Rt);je(Ze,fi);const Je=function(ue){let ke=n(ue);(!ke||!ke.tagName)&&(ke={namespaceURI:Ne,tagName:"template"});const Oe=Dt(ue.tagName),qe=Dt(ke.tagName);return De[ue.namespaceURI]?ue.namespaceURI===me?ke.namespaceURI===ve?Oe==="svg":ke.namespaceURI===ne?Oe==="svg"&&(qe==="annotation-xml"||Ee[qe]):!!Ue[Oe]:ue.namespaceURI===ne?ke.namespaceURI===ve?Oe==="math":ke.namespaceURI===me?Oe==="math"&&Fe[qe]:!!Ze[Oe]:ue.namespaceURI===ve?ke.namespaceURI===me&&!Fe[qe]||ke.namespaceURI===ne&&!Ee[qe]?!1:!Ze[Oe]&&(Be[Oe]||!Ue[Oe]):!!(Te==="application/xhtml+xml"&&De[ue.namespaceURI]):!1},Ke=function(ue){bt(t.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{ue.remove()}},_e=function(ue,ke){try{bt(t.removed,{attribute:ke.getAttributeNode(ue),from:ke})}catch{bt(t.removed,{attribute:null,from:ke})}if(ke.removeAttribute(ue),ue==="is"&&!le[ue])if(q||$)try{Ke(ke)}catch{}else try{ke.setAttribute(ue,"")}catch{}},tt=function(ue){let ke,Oe;if(S)ue="<remove></remove>"+ue;else{const st=li(ue,/^[\r\n\t ]+/);Oe=st&&st[0]}Te==="application/xhtml+xml"&&Ne===ve&&(ue='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ue+"</body></html>");const qe=r?r.createHTML(ue):ue;if(Ne===ve)try{ke=new s().parseFromString(qe,Te)}catch{}if(!ke||!ke.documentElement){ke=u.createDocument(Ne,"template",null);try{ke.documentElement.innerHTML=Se?b:qe}catch{}}const et=ke.body||ke.documentElement;return ue&&Oe&&et.insertBefore(i.createTextNode(Oe),et.childNodes[0]||null),Ne===ve?z.call(ke,W?"html":"body")[0]:W?ke.documentElement:et},nt=function(ue){return l.call(ue.ownerDocument||ue,ue,g.SHOW_ELEMENT|g.SHOW_COMMENT|g.SHOW_TEXT,null,!1)},dt=function(ue){return ue instanceof L&&(typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof c)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"||typeof ue.hasChildNodes!="function")},ft=function(ue){return typeof A=="object"?ue instanceof A:ue&&typeof ue=="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},ot=function(ue,ke,Oe){d[ue]&&oi(d[ue],qe=>{qe.call(t,ke,Oe,Ye)})},At=function(ue){let ke;if(ot("beforeSanitizeElements",ue,null),dt(ue))return Ke(ue),!0;const Oe=Me(ue.nodeName);if(ot("uponSanitizeElement",ue,{tagName:Oe,allowedTags:se}),ue.hasChildNodes()&&!ft(ue.firstElementChild)&&(!ft(ue.content)||!ft(ue.content.firstElementChild))&&lt(/<[/\w]/g,ue.innerHTML)&&lt(/<[/\w]/g,ue.textContent))return Ke(ue),!0;if(!se[Oe]||Ce[Oe]){if(!Ce[Oe]&&pt(Oe)&&(be.tagNameCheck instanceof RegExp&&lt(be.tagNameCheck,Oe)||be.tagNameCheck instanceof Function&&be.tagNameCheck(Oe)))return!1;if(y&&!I[Oe]){const qe=n(ue)||ue.parentNode,et=m(ue)||ue.childNodes;if(et&&qe){const st=et.length;for(let Ve=st-1;Ve>=0;--Ve)qe.insertBefore(o(et[Ve],!0),a(ue))}}return Ke(ue),!0}return ue instanceof f&&!Je(ue)||(Oe==="noscript"||Oe==="noembed"||Oe==="noframes")&&lt(/<\/no(script|embed|frames)/i,ue.innerHTML)?(Ke(ue),!0):(Z&&ue.nodeType===3&&(ke=ue.textContent,ke=ct(ke,D," "),ke=ct(ke,B," "),ke=ct(ke,_," "),ue.textContent!==ke&&(bt(t.removed,{element:ue.cloneNode()}),ue.textContent=ke)),ot("afterSanitizeElements",ue,null),!1)},kt=function(ue,ke,Oe){if(Q&&(ke==="id"||ke==="name")&&(Oe in i||Oe in J))return!1;if(!(de&&!Ae[ke]&&lt(x,ke))){if(!(Pe&&lt(P,ke))){if(!le[ke]||Ae[ke]){if(!(pt(ue)&&(be.tagNameCheck instanceof RegExp&&lt(be.tagNameCheck,ue)||be.tagNameCheck instanceof Function&&be.tagNameCheck(ue))&&(be.attributeNameCheck instanceof RegExp&&lt(be.attributeNameCheck,ke)||be.attributeNameCheck instanceof Function&&be.attributeNameCheck(ke))||ke==="is"&&be.allowCustomizedBuiltInElements&&(be.tagNameCheck instanceof RegExp&&lt(be.tagNameCheck,Oe)||be.tagNameCheck instanceof Function&&be.tagNameCheck(Oe))))return!1}else if(!X[ke]){if(!lt(te,ct(Oe,K,""))){if(!((ke==="src"||ke==="xlink:href"||ke==="href")&&ue!=="script"&&ai(Oe,"data:")===0&&F[ue])){if(!(ie&&!lt(O,ct(Oe,K,"")))){if(Oe)return!1}}}}}}return!0},pt=function(ue){return ue.indexOf("-")>0},St=function(ue){let ke,Oe,qe,et;ot("beforeSanitizeAttributes",ue,null);const{attributes:st}=ue;if(!st)return;const Ve={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:le};for(et=st.length;et--;){ke=st[et];const{name:ht,namespaceURI:wt}=ke;if(Oe=ht==="value"?ke.value:hi(ke.value),qe=Me(ht),Ve.attrName=qe,Ve.attrValue=Oe,Ve.keepAttr=!0,Ve.forceKeepAttr=void 0,ot("uponSanitizeAttribute",ue,Ve),Oe=Ve.attrValue,Ve.forceKeepAttr||(_e(ht,ue),!Ve.keepAttr))continue;if(!ce&&lt(/\/>/i,Oe)){_e(ht,ue);continue}Z&&(Oe=ct(Oe,D," "),Oe=ct(Oe,B," "),Oe=ct(Oe,_," "));const Ct=Me(ue.nodeName);if(kt(Ct,qe,Oe)){if(p&&(qe==="id"||qe==="name")&&(_e(ht,ue),Oe=E+Oe),r&&typeof h=="object"&&typeof h.getAttributeType=="function"&&!wt)switch(h.getAttributeType(Ct,qe)){case"TrustedHTML":{Oe=r.createHTML(Oe);break}case"TrustedScriptURL":{Oe=r.createScriptURL(Oe);break}}try{wt?ue.setAttributeNS(wt,ht,Oe):ue.setAttribute(ht,Oe),Ht(t.removed)}catch{}}}ot("afterSanitizeAttributes",ue,null)},Mt=function Ie(ue){let ke;const Oe=nt(ue);for(ot("beforeSanitizeShadowDOM",ue,null);ke=Oe.nextNode();)ot("uponSanitizeShadowNode",ke,null),!At(ke)&&(ke.content instanceof H&&Ie(ke.content),St(ke));ot("afterSanitizeShadowDOM",ue,null)};return t.sanitize=function(Ie){let ue=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ke,Oe,qe,et;if(Se=!Ie,Se&&(Ie="<!-->"),typeof Ie!="string"&&!ft(Ie))if(typeof Ie.toString=="function"){if(Ie=Ie.toString(),typeof Ie!="string")throw $t("dirty is not a string, aborting")}else throw $t("toString is not a function");if(!t.isSupported)return Ie;if(Y||pe(ue),t.removed=[],typeof Ie=="string"&&(M=!1),M){if(Ie.nodeName){const ht=Me(Ie.nodeName);if(!se[ht]||Ce[ht])throw $t("root node is forbidden and cannot be sanitized in-place")}}else if(Ie instanceof A)ke=tt("<!---->"),Oe=ke.ownerDocument.importNode(Ie,!0),Oe.nodeType===1&&Oe.nodeName==="BODY"||Oe.nodeName==="HTML"?ke=Oe:ke.appendChild(Oe);else{if(!q&&!Z&&!W&&Ie.indexOf("<")===-1)return r&&U?r.createHTML(Ie):Ie;if(ke=tt(Ie),!ke)return q?null:U?b:""}ke&&S&&Ke(ke.firstChild);const st=nt(M?Ie:ke);for(;qe=st.nextNode();)At(qe)||(qe.content instanceof H&&Mt(qe.content),St(qe));if(M)return Ie;if(q){if($)for(et=N.call(ke.ownerDocument);ke.firstChild;)et.appendChild(ke.firstChild);else et=ke;return(le.shadowroot||le.shadowrootmode)&&(et=R.call(v,et,!0)),et}let Ve=W?ke.outerHTML:ke.innerHTML;return W&&se["!doctype"]&&ke.ownerDocument&&ke.ownerDocument.doctype&&ke.ownerDocument.doctype.name&&lt(Vt,ke.ownerDocument.doctype.name)&&(Ve="<!DOCTYPE "+ke.ownerDocument.doctype.name+`>
`+Ve),Z&&(Ve=ct(Ve,D," "),Ve=ct(Ve,B," "),Ve=ct(Ve,_," ")),r&&U?r.createHTML(Ve):Ve},t.setConfig=function(Ie){pe(Ie),Y=!0},t.clearConfig=function(){Ye=null,Y=!1},t.isValidAttribute=function(Ie,ue,ke){Ye||pe({});const Oe=Me(Ie),qe=Me(ue);return kt(Oe,qe,ke)},t.addHook=function(Ie,ue){typeof ue=="function"&&(d[Ie]=d[Ie]||[],bt(d[Ie],ue))},t.removeHook=function(Ie){if(d[Ie])return Ht(d[Ie])},t.removeHooks=function(Ie){d[Ie]&&(d[Ie]=[])},t.removeAllHooks=function(){d={}},t}var yi=xt();define("vs/base/browser/dompurify/dompurify",function(){return yi}),define($e[41],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wQ=t.$vQ=void 0;class v{constructor(w){this.domNode=w,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(w){const A=T(w);this.a!==A&&(this.a=A,this.domNode.style.maxWidth=this.a)}setWidth(w){const A=T(w);this.b!==A&&(this.b=A,this.domNode.style.width=this.b)}setHeight(w){const A=T(w);this.c!==A&&(this.c=A,this.domNode.style.height=this.c)}setTop(w){const A=T(w);this.d!==A&&(this.d=A,this.domNode.style.top=this.d)}setLeft(w){const A=T(w);this.e!==A&&(this.e=A,this.domNode.style.left=this.e)}setBottom(w){const A=T(w);this.f!==A&&(this.f=A,this.domNode.style.bottom=this.f)}setRight(w){const A=T(w);this.g!==A&&(this.g=A,this.domNode.style.right=this.g)}setPaddingTop(w){const A=T(w);this.h!==A&&(this.h=A,this.domNode.style.paddingTop=this.h)}setPaddingLeft(w){const A=T(w);this.i!==A&&(this.i=A,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(w){const A=T(w);this.j!==A&&(this.j=A,this.domNode.style.paddingBottom=this.j)}setPaddingRight(w){const A=T(w);this.k!==A&&(this.k=A,this.domNode.style.paddingRight=this.k)}setFontFamily(w){this.l!==w&&(this.l=w,this.domNode.style.fontFamily=this.l)}setFontWeight(w){this.m!==w&&(this.m=w,this.domNode.style.fontWeight=this.m)}setFontSize(w){const A=T(w);this.n!==A&&(this.n=A,this.domNode.style.fontSize=this.n)}setFontStyle(w){this.o!==w&&(this.o=w,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(w){this.p!==w&&(this.p=w,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(w){this.q!==w&&(this.q=w,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(w){this.r!==w&&(this.r=w,this.domNode.style.textDecoration=this.r)}setLineHeight(w){const A=T(w);this.s!==A&&(this.s=A,this.domNode.style.lineHeight=this.s)}setLetterSpacing(w){const A=T(w);this.t!==A&&(this.t=A,this.domNode.style.letterSpacing=this.t)}setClassName(w){this.u!==w&&(this.u=w,this.domNode.className=this.u)}toggleClassName(w,A){this.domNode.classList.toggle(w,A),this.u=this.domNode.className}setDisplay(w){this.v!==w&&(this.v=w,this.domNode.style.display=this.v)}setPosition(w){this.w!==w&&(this.w=w,this.domNode.style.position=this.w)}setVisibility(w){this.x!==w&&(this.x=w,this.domNode.style.visibility=this.x)}setColor(w){this.y!==w&&(this.y=w,this.domNode.style.color=this.y)}setBackgroundColor(w){this.z!==w&&(this.z=w,this.domNode.style.backgroundColor=this.z)}setLayerHinting(w){this.A!==w&&(this.A=w,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(w){this.C!==w&&(this.C=w,this.domNode.style.boxShadow=w)}setContain(w){this.B!==w&&(this.B=w,this.domNode.style.contain=this.B)}setAttribute(w,A){this.domNode.setAttribute(w,A)}removeAttribute(w){this.domNode.removeAttribute(w)}appendChild(w){this.domNode.appendChild(w.domNode)}removeChild(w){this.domNode.removeChild(w.domNode)}}t.$vQ=v;function T(H){return typeof H=="number"?`${H}px`:H}function i(H){return new v(H)}t.$wQ=i}),define($e[69],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6Q=t.$5Q=t.$4Q=t.ListDragOverEffect=void 0;var v;(function(H){H[H.Copy=0]="Copy",H[H.Move=1]="Move"})(v||(t.ListDragOverEffect=v={})),t.$4Q={reject(){return{accept:!1}},accept(){return{accept:!0}}};class T extends Error{constructor(w,A){super(`ListError [${w}] ${A}`)}}t.$5Q=T;class i{constructor(){this.c=new WeakMap}getHeight(w){return this.c.get(w)??this.d(w)}setDynamicHeight(w,A){A>0&&this.c.set(w,A)}}t.$6Q=i}),define($e[70],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3Q=void 0;class v{constructor(i){this.a=i}splice(i,H,w){this.a.forEach(A=>A.splice(i,H,w))}}t.$3Q=v}),define($e[42],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BQ=void 0;const v=20;class T{constructor(H,w,A,f,g,c){this.a=Math.round(w),this.b=Math.round(A),this.c=Math.round(H),this.d=f,this.e=g,this.f=c,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new T(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(H){const w=Math.round(H);return this.d!==w?(this.d=w,this.m(),!0):!1}setScrollSize(H){const w=Math.round(H);return this.e!==w?(this.e=w,this.m(),!0):!1}setScrollPosition(H){const w=Math.round(H);return this.f!==w?(this.f=w,this.m(),!0):!1}setScrollbarSize(H){this.a=Math.round(H)}setOppositeScrollbarSize(H){this.b=Math.round(H)}static l(H,w,A,f,g){const c=Math.max(0,A-H),L=Math.max(0,c-2*w),s=f>0&&f>A;if(!s)return{computedAvailableSize:Math.round(c),computedIsNeeded:s,computedSliderSize:Math.round(L),computedSliderRatio:0,computedSliderPosition:0};const h=Math.round(Math.max(v,Math.floor(A*L/f))),e=(L-h)/(f-A),o=g*e;return{computedAvailableSize:Math.round(c),computedIsNeeded:s,computedSliderSize:Math.round(h),computedSliderRatio:e,computedSliderPosition:Math.round(o)}}m(){const H=T.l(this.b,this.c,this.d,this.e,this.f);this.g=H.computedAvailableSize,this.h=H.computedIsNeeded,this.i=H.computedSliderSize,this.j=H.computedSliderRatio,this.k=H.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(H){if(!this.h)return 0;const w=H-this.c-this.i/2;return Math.round(w/this.j)}getDesiredScrollPositionFromOffsetPaged(H){if(!this.h)return 0;const w=H-this.c;let A=this.f;return w<this.k?A-=this.d:A+=this.d,A}getDesiredScrollPositionFromDelta(H){if(!this.h)return 0;const w=this.k+H;return Math.round(w/this.j)}}t.$BQ=T}),define($e[25],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZS=t.$YS=t.$XS=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var v;(function(f){f[f.Hidden=0]="Hidden",f[f.Visible=1]="Visible",f[f.Recurse=2]="Recurse"})(v||(t.TreeVisibility=v={}));var T;(function(f){f[f.Expanded=0]="Expanded",f[f.Collapsed=1]="Collapsed",f[f.PreserveOrExpanded=2]="PreserveOrExpanded",f[f.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(T||(t.ObjectTreeElementCollapseState=T={}));var i;(function(f){f[f.Unknown=0]="Unknown",f[f.Twistie=1]="Twistie",f[f.Element=2]="Element",f[f.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var H;(function(f){f[f.Down=0]="Down",f[f.Up=1]="Up"})(H||(t.TreeDragOverBubble=H={})),t.$XS={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(f=!1){return{accept:!0,bubble:0,autoExpand:f}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(f=!1){return{accept:!0,bubble:0,effect:0,autoExpand:f}}};class w extends Error{constructor(g,c){super(`TreeError [${g}] ${c}`)}}t.$YS=w;class A{constructor(g){this.a=g,this.b=new WeakMap}map(g){let c=this.b.get(g);return c||(c=this.a(g),this.b.set(g,c)),c}}t.$ZS=A}),define($e[14],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$window=t.$rO=void 0,t.$rO=window,t.$window=t.$rO}),define($e[71],we([1,0,14]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OO=t.$NO=void 0;let T=!1,i=null;function H(g){if(!g.parent||g.parent===g)return null;try{const c=g.location,L=g.parent.location;if(c.origin!=="null"&&L.origin!=="null"&&c.origin!==L.origin)return T=!0,null}catch{return T=!0,null}return g.parent}class w{static getSameOriginWindowChain(){if(!i){i=[];let c=v.$window,L;do L=H(c),L?i.push({window:c,iframeElement:c.frameElement||null}):i.push({window:c,iframeElement:null}),c=L;while(c)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),T}static getPositionOfChildWindowRelativeToAncestorWindow(c,L){if(!L||c===L)return{top:0,left:0};let s=0,h=0;const e=this.getSameOriginWindowChain();for(const o of e){if(s+=o.window.scrollY,h+=o.window.scrollX,o.window===L||!o.iframeElement)break;const a=o.iframeElement.getBoundingClientRect();s+=a.top,h+=a.left}return{top:s,left:h}}}t.$NO=w;async function A(g,c){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const L=JSON.stringify({parentOrigin:g,salt:c}),h=new TextEncoder().encode(L),e=await crypto.subtle.digest("sha-256",h);return f(e)}t.$OO=A;function f(g){const L=Array.from(new Uint8Array(g)).map(s=>s.toString(16).padStart(2,"0")).join("");return BigInt(`0x${L}`).toString(32).padStart(52,"0")}}),define($e[72],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=void 0;function v(o,a,m){const n=T(o,a);if(n!==-1)return o[n]}t.$eb=v;function T(o,a,m=o.length-1){for(let n=m;n>=0;n--){const r=o[n];if(a(r))return n}return-1}t.$fb=T;function i(o,a){const m=H(o,a);return m===-1?void 0:o[m]}t.$gb=i;function H(o,a,m=0,n=o.length){let r=m,b=n;for(;r<b;){const u=Math.floor((r+b)/2);a(o[u])?r=u+1:b=u}return r-1}t.$hb=H;function w(o,a){const m=A(o,a);return m===o.length?void 0:o[m]}t.$ib=w;function A(o,a,m=0,n=o.length){let r=m,b=n;for(;r<b;){const u=Math.floor((r+b)/2);a(o[u])?b=u:r=u+1}return r}t.$jb=A;function f(o,a,m=0,n=o.length){const r=A(o,a,m,n);return r===o.length?-1:r}t.$kb=f;class g{static{this.assertInvariants=!1}constructor(a){this.e=a,this.c=0}findLastMonotonous(a){if(g.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!a(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=a}const m=H(this.e,a,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}t.$lb=g;function c(o,a){if(o.length===0)return;let m=o[0];for(let n=1;n<o.length;n++){const r=o[n];a(r,m)>0&&(m=r)}return m}t.$mb=c;function L(o,a){if(o.length===0)return;let m=o[0];for(let n=1;n<o.length;n++){const r=o[n];a(r,m)>=0&&(m=r)}return m}t.$nb=L;function s(o,a){return c(o,(m,n)=>-a(m,n))}t.$ob=s;function h(o,a){if(o.length===0)return-1;let m=0;for(let n=1;n<o.length;n++){const r=o[n];a(r,o[m])>0&&(m=n)}return m}t.$pb=h;function e(o,a){for(const m of o){const n=a(m);if(n!==void 0)return n}}t.$qb=e}),define($e[73],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$M=t.$L=t.$K=t.$J=void 0;function v(w,A){const f=Object.create(null);for(const g of w){const c=A(g);let L=f[c];L||(L=f[c]=[]),L.push(g)}return f}t.$J=v;function T(w,A){const f=[],g=[];for(const c of w)A.has(c)||f.push(c);for(const c of A)w.has(c)||g.push(c);return{removed:f,added:g}}t.$K=T;function i(w,A){const f=[],g=[];for(const[c,L]of w)A.has(c)||f.push(L);for(const[c,L]of A)w.has(c)||g.push(L);return{removed:f,added:g}}t.$L=i;function H(w,A){const f=new Set;for(const g of A)w.has(g)&&f.add(g);return f}t.$M=H}),define($e[74],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1s=t.$Zs=t.$Ys=t.$Xs=void 0;function v(A,f){const g=Math.pow(10,f);return Math.round(A*g)/g}class T{constructor(f,g,c,L=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,c))|0,this.a=v(Math.max(Math.min(1,L),0),3)}static equals(f,g){return f.r===g.r&&f.g===g.g&&f.b===g.b&&f.a===g.a}}t.$Xs=T;class i{constructor(f,g,c,L){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=v(Math.max(Math.min(1,g),0),3),this.l=v(Math.max(Math.min(1,c),0),3),this.a=v(Math.max(Math.min(1,L),0),3)}static equals(f,g){return f.h===g.h&&f.s===g.s&&f.l===g.l&&f.a===g.a}static fromRGBA(f){const g=f.r/255,c=f.g/255,L=f.b/255,s=f.a,h=Math.max(g,c,L),e=Math.min(g,c,L);let o=0,a=0;const m=(e+h)/2,n=h-e;if(n>0){switch(a=Math.min(m<=.5?n/(2*m):n/(2-2*m),1),h){case g:o=(c-L)/n+(c<L?6:0);break;case c:o=(L-g)/n+2;break;case L:o=(g-c)/n+4;break}o*=60,o=Math.round(o)}return new i(o,a,m,s)}static i(f,g,c){return c<0&&(c+=1),c>1&&(c-=1),c<1/6?f+(g-f)*6*c:c<1/2?g:c<2/3?f+(g-f)*(2/3-c)*6:f}static toRGBA(f){const g=f.h/360,{s:c,l:L,a:s}=f;let h,e,o;if(c===0)h=e=o=L;else{const a=L<.5?L*(1+c):L+c-L*c,m=2*L-a;h=i.i(m,a,g+1/3),e=i.i(m,a,g),o=i.i(m,a,g-1/3)}return new T(Math.round(h*255),Math.round(e*255),Math.round(o*255),s)}}t.$Ys=i;class H{constructor(f,g,c,L){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=v(Math.max(Math.min(1,g),0),3),this.v=v(Math.max(Math.min(1,c),0),3),this.a=v(Math.max(Math.min(1,L),0),3)}static equals(f,g){return f.h===g.h&&f.s===g.s&&f.v===g.v&&f.a===g.a}static fromRGBA(f){const g=f.r/255,c=f.g/255,L=f.b/255,s=Math.max(g,c,L),h=Math.min(g,c,L),e=s-h,o=s===0?0:e/s;let a;return e===0?a=0:s===g?a=((c-L)/e%6+6)%6:s===c?a=(L-g)/e+2:a=(g-c)/e+4,new H(Math.round(a*60),o,s,f.a)}static toRGBA(f){const{h:g,s:c,v:L,a:s}=f,h=L*c,e=h*(1-Math.abs(g/60%2-1)),o=L-h;let[a,m,n]=[0,0,0];return g<60?(a=h,m=e):g<120?(a=e,m=h):g<180?(m=h,n=e):g<240?(m=e,n=h):g<300?(a=e,n=h):g<=360&&(a=h,n=e),a=Math.round((a+o)*255),m=Math.round((m+o)*255),n=Math.round((n+o)*255),new T(a,m,n,s)}}t.$Zs=H;class w{static fromHex(f){return w.Format.CSS.parseHex(f)||w.red}static equals(f,g){return!f&&!g?!0:!f||!g?!1:f.equals(g)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:H.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof T)this.rgba=f;else if(f instanceof i)this.i=f,this.rgba=i.toRGBA(f);else if(f instanceof H)this.j=f,this.rgba=H.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&T.equals(this.rgba,f.rgba)&&i.equals(this.hsla,f.hsla)&&H.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=w.k(this.rgba.r),g=w.k(this.rgba.g),c=w.k(this.rgba.b),L=.2126*f+.7152*g+.0722*c;return v(L,4)}static k(f){const g=f/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(f){const g=this.getRelativeLuminance(),c=f.getRelativeLuminance();return g>c?(g+.05)/(c+.05):(c+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const g=this.getRelativeLuminance(),c=f.getRelativeLuminance();return g>c}isDarkerThan(f){const g=this.getRelativeLuminance(),c=f.getRelativeLuminance();return g<c}lighten(f){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:g,g:c,b:L,a:s}=this.rgba;return new w(new T(g,c,L,s*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new T(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const g=f.rgba,c=this.rgba.a,L=g.a,s=c+L*(1-c);if(s<1e-6)return w.transparent;const h=this.rgba.r*c/s+g.r*L*(1-c)/s,e=this.rgba.g*c/s+g.g*L*(1-c)/s,o=this.rgba.b*c/s+g.b*L*(1-c)/s;return new w(new T(h,e,o,s))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:g,g:c,b:L,a:s}=this.rgba;return new w(new T(f.rgba.r-s*(f.rgba.r-g),f.rgba.g-s*(f.rgba.g-c),f.rgba.b-s*(f.rgba.b-L),1))}flatten(...f){const g=f.reduceRight((c,L)=>w.o(L,c));return w.o(this,g)}static o(f,g){const c=1-f.rgba.a;return new w(new T(c*g.rgba.r+f.rgba.a*f.rgba.r,c*g.rgba.g+f.rgba.a*f.rgba.g,c*g.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=w.Format.CSS.format(this)),this.u}static getLighterColor(f,g,c){if(f.isLighterThan(g))return f;c=c||.5;const L=f.getRelativeLuminance(),s=g.getRelativeLuminance();return c=c*(s-L)/s,f.lighten(c)}static getDarkerColor(f,g,c){if(f.isDarkerThan(g))return f;c=c||.5;const L=f.getRelativeLuminance(),s=g.getRelativeLuminance();return c=c*(L-s)/L,f.darken(c)}static{this.white=new w(new T(255,255,255,1))}static{this.black=new w(new T(0,0,0,1))}static{this.red=new w(new T(255,0,0,1))}static{this.blue=new w(new T(0,0,255,1))}static{this.green=new w(new T(0,255,0,1))}static{this.cyan=new w(new T(0,255,255,1))}static{this.lightgrey=new w(new T(211,211,211,1))}static{this.transparent=new w(new T(0,0,0,0))}}t.$1s=w,function(A){let f;(function(g){let c;(function(L){function s(l){return l.rgba.a===1?`rgb(${l.rgba.r}, ${l.rgba.g}, ${l.rgba.b})`:A.Format.CSS.formatRGBA(l)}L.formatRGB=s;function h(l){return`rgba(${l.rgba.r}, ${l.rgba.g}, ${l.rgba.b}, ${+l.rgba.a.toFixed(2)})`}L.formatRGBA=h;function e(l){return l.hsla.a===1?`hsl(${l.hsla.h}, ${(l.hsla.s*100).toFixed(2)}%, ${(l.hsla.l*100).toFixed(2)}%)`:A.Format.CSS.formatHSLA(l)}L.formatHSL=e;function o(l){return`hsla(${l.hsla.h}, ${(l.hsla.s*100).toFixed(2)}%, ${(l.hsla.l*100).toFixed(2)}%, ${l.hsla.a.toFixed(2)})`}L.formatHSLA=o;function a(l){const N=l.toString(16);return N.length!==2?"0"+N:N}function m(l){return`#${a(l.rgba.r)}${a(l.rgba.g)}${a(l.rgba.b)}`}L.formatHex=m;function n(l,N=!1){return N&&l.rgba.a===1?A.Format.CSS.formatHex(l):`#${a(l.rgba.r)}${a(l.rgba.g)}${a(l.rgba.b)}${a(Math.round(l.rgba.a*255))}`}L.formatHexA=n;function r(l){return l.isOpaque()?A.Format.CSS.formatHex(l):A.Format.CSS.formatRGBA(l)}L.format=r;function b(l){const N=l.length;if(N===0||l.charCodeAt(0)!==35)return null;if(N===7){const z=16*u(l.charCodeAt(1))+u(l.charCodeAt(2)),R=16*u(l.charCodeAt(3))+u(l.charCodeAt(4)),d=16*u(l.charCodeAt(5))+u(l.charCodeAt(6));return new A(new T(z,R,d,1))}if(N===9){const z=16*u(l.charCodeAt(1))+u(l.charCodeAt(2)),R=16*u(l.charCodeAt(3))+u(l.charCodeAt(4)),d=16*u(l.charCodeAt(5))+u(l.charCodeAt(6)),D=16*u(l.charCodeAt(7))+u(l.charCodeAt(8));return new A(new T(z,R,d,D/255))}if(N===4){const z=u(l.charCodeAt(1)),R=u(l.charCodeAt(2)),d=u(l.charCodeAt(3));return new A(new T(16*z+z,16*R+R,16*d+d))}if(N===5){const z=u(l.charCodeAt(1)),R=u(l.charCodeAt(2)),d=u(l.charCodeAt(3)),D=u(l.charCodeAt(4));return new A(new T(16*z+z,16*R+R,16*d+d,(16*D+D)/255))}return null}L.parseHex=b;function u(l){switch(l){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(c=g.CSS||(g.CSS={}))})(f=A.Format||(A.Format={}))}(w||(t.$1s=w={}))}),define($e[26],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mh=t.$lh=t.$kh=void 0;function v(w){return(A,f,g)=>{let c=null,L=null;if(typeof g.value=="function"?(c="value",L=g.value):typeof g.get=="function"&&(c="get",L=g.get),!L)throw new Error("not supported");g[c]=w(L,f)}}function T(w,A,f){let g=null,c=null;if(typeof f.value=="function"?(g="value",c=f.value,c.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(g="get",c=f.get),!c)throw new Error("not supported");const L=`$memoize$${A}`;f[g]=function(...s){return this.hasOwnProperty(L)||Object.defineProperty(this,L,{configurable:!1,enumerable:!1,writable:!1,value:c.apply(this,s)}),this[L]}}t.$kh=T;function i(w,A,f){return v((g,c)=>{const L=`$debounce$${c}`,s=`$debounce$result$${c}`;return function(...h){this[s]||(this[s]=f?f():void 0),clearTimeout(this[L]),A&&(this[s]=A(this[s],...h),h=[this[s]]),this[L]=setTimeout(()=>{g.apply(this,h),this[s]=f?f():void 0},w)}})}t.$lh=i;function H(w,A,f){return v((g,c)=>{const L=`$throttle$timer$${c}`,s=`$throttle$result$${c}`,h=`$throttle$lastRun$${c}`,e=`$throttle$pending$${c}`;return function(...o){if(this[s]||(this[s]=f?f():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),A&&(this[s]=A(this[s],...o)),this[e])return;const a=this[h]+w;a<=Date.now()?(this[h]=Date.now(),g.apply(this,[this[s]]),this[s]=f?f():void 0):(this[e]=!0,this[L]=setTimeout(()=>{this[e]=!1,this[h]=Date.now(),g.apply(this,[this[s]]),this[s]=f?f():void 0},a-Date.now()))}})}t.$mh=H}),define($e[75],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zs=void 0;class v{constructor(i,H,w,A){this.originalStart=i,this.originalLength=H,this.modifiedStart=w,this.modifiedLength=A}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$zs=v}),define($e[6],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.setUnexpectedErrorHandler=t.$W=t.$V=void 0;class v{constructor(){this.b=[],this.a=function(l){setTimeout(()=>{throw l.stack?r.isErrorNoTelemetry(l)?new r(l.message+`

`+l.stack):new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.b.push(l),()=>{this.d(l)}}c(l){this.b.forEach(N=>{N(l)})}d(l){this.b.splice(this.b.indexOf(l),1)}setUnexpectedErrorHandler(l){this.a=l}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(l){this.a(l),this.c(l)}onUnexpectedExternalError(l){this.a(l)}}t.$V=v,t.$W=new v;function T(u){t.$W.setUnexpectedErrorHandler(u)}t.setUnexpectedErrorHandler=T;function i(u){if(!u||typeof u!="object")return!1;const l=u;return l.code==="EPIPE"&&l.syscall?.toUpperCase()==="WRITE"}t.$Y=i;function H(u){g(u)||t.$W.onUnexpectedError(u)}t.$Z=H;function w(u){g(u)||t.$W.onUnexpectedExternalError(u)}t.$1=w;function A(u){if(u instanceof Error){const{name:l,message:N}=u,z=u.stacktrace||u.stack;return{$isError:!0,name:l,message:N,stack:z,noTelemetry:r.isErrorNoTelemetry(u)}}return u}t.$2=A;const f="Canceled";function g(u){return u instanceof c?!0:u instanceof Error&&u.name===f&&u.message===f}t.$3=g;class c extends Error{constructor(){super(f),this.name=this.message}}t.$4=c;function L(){const u=new Error(f);return u.name=u.message,u}t.$5=L;function s(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}t.$6=s;function h(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}t.$7=h;class e extends TypeError{constructor(l){super(l?`${l} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$8=e;function o(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}t.$9=o;class a extends Error{constructor(l){super("NotImplemented"),l&&(this.message=l)}}t.$0=a;class m extends Error{constructor(l){super("NotSupported"),l&&(this.message=l)}}t.$$=m;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=n;class r extends Error{constructor(l){super(l),this.name="CodeExpectedError"}static fromError(l){if(l instanceof r)return l;const N=new r;return N.message=l.message,N.stack=l.stack,N}static isErrorNoTelemetry(l){return l.name==="CodeExpectedError"}}t.$ab=r;class b extends Error{constructor(l){super(l||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}t.$bb=b}),define($e[11],we([1,0,6,72]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.CompareResult=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.top=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=void 0;function i(p,E=0){return p[p.length-(1+E)]}t.$rb=i;function H(p){if(p.length===0)throw new Error("Invalid tail call");return[p.slice(0,p.length-1),p[p.length-1]]}t.$sb=H;function w(p,E,y=(M,k)=>M===k){if(p===E)return!0;if(!p||!E||p.length!==E.length)return!1;for(let M=0,k=p.length;M<k;M++)if(!y(p[M],E[M]))return!1;return!0}t.$tb=w;function A(p,E){const y=p.length-1;E<y&&(p[E]=p[y]),p.pop()}t.$ub=A;function f(p,E,y){return g(p.length,M=>y(p[M],E))}t.$vb=f;function g(p,E){let y=0,M=p-1;for(;y<=M;){const k=(y+M)/2|0,I=E(k);if(I<0)y=k+1;else if(I>0)M=k-1;else return k}return-(y+1)}t.$wb=g;function c(p,E,y){if(p=p|0,p>=E.length)throw new TypeError("invalid index");const M=E[Math.floor(E.length*Math.random())],k=[],I=[],C=[];for(const F of E){const j=y(F,M);j<0?k.push(F):j>0?I.push(F):C.push(F)}return p<k.length?c(p,k,y):p<k.length+C.length?C[0]:c(p-(k.length+C.length),I,y)}t.$xb=c;function L(p,E){const y=[];let M;for(const k of p.slice(0).sort(E))!M||E(M[0],k)!==0?(M=[k],y.push(M)):M.push(k);return y}t.$yb=L;function*s(p,E){let y,M;for(const k of p)M!==void 0&&E(M,k)?y.push(k):(y&&(yield y),y=[k]),M=k;y&&(yield y)}t.$zb=s;function h(p,E){for(let y=0;y<=p.length;y++)E(y===0?void 0:p[y-1],y===p.length?void 0:p[y])}t.$Ab=h;function e(p,E){for(let y=0;y<p.length;y++)E(y===0?void 0:p[y-1],p[y],y+1===p.length?void 0:p[y+1])}t.$Bb=e;function o(p,E,y){const M=[];function k(F,j,X){if(j===0&&X.length===0)return;const ee=M[M.length-1];ee&&ee.start+ee.deleteCount===F?(ee.deleteCount+=j,ee.toInsert.push(...X)):M.push({start:F,deleteCount:j,toInsert:X})}let I=0,C=0;for(;;){if(I===p.length){k(I,0,E.slice(C));break}if(C===E.length){k(I,p.length-I,[]);break}const F=p[I],j=E[C],X=y(F,j);X===0?(I+=1,C+=1):X<0?(k(I,1,[]),I+=1):X>0&&(k(I,0,[j]),C+=1)}return M}t.$Cb=o;function a(p,E,y){const M=o(p,E,y),k=[],I=[];for(const C of M)k.push(...p.slice(C.start,C.start+C.deleteCount)),I.push(...C.toInsert);return{removed:k,added:I}}t.$Db=a;function m(p,E,y){if(y===0)return[];const M=p.slice(0,y).sort(E);return r(p,E,M,y,p.length),M}t.top=m;function n(p,E,y,M,k){return y===0?Promise.resolve([]):new Promise((I,C)=>{(async()=>{const F=p.length,j=p.slice(0,y).sort(E);for(let X=y,ee=Math.min(y+M,F);X<F;X=ee,ee=Math.min(ee+M,F)){if(X>y&&await new Promise(ne=>setTimeout(ne)),k&&k.isCancellationRequested)throw new v.$4;r(p,E,j,X,ee)}return j})().then(I,C)})}t.$Fb=n;function r(p,E,y,M,k){for(const I=y.length;M<k;M++){const C=p[M];if(E(C,y[I-1])<0){y.pop();const F=(0,T.$jb)(y,j=>E(C,j)<0);y.splice(F,0,C)}}}function b(p){return p.filter(E=>!!E)}t.$Gb=b;function u(p){let E=0;for(let y=0;y<p.length;y++)p[y]&&(p[E]=p[y],E+=1);p.length=E}t.$Hb=u;function l(p,E,y){p.splice(y,0,p.splice(E,1)[0])}t.$Ib=l;function N(p){return!Array.isArray(p)||p.length===0}t.$Jb=N;function z(p){return Array.isArray(p)&&p.length>0}t.$Kb=z;function R(p,E=y=>y){const y=new Set;return p.filter(M=>{const k=E(M);return y.has(k)?!1:(y.add(k),!0)})}t.$Lb=R;function d(p){const E=new Set;return y=>{const M=p(y);return E.has(M)?!1:(E.add(M),!0)}}t.$Mb=d;function D(p,E){return p.length>0?p[0]:E}t.$Nb=D;function B(p,E){return p.length>0?p[p.length-1]:E}t.$Ob=B;function _(p,E,y=(M,k)=>M===k){let M=0;for(let k=0,I=Math.min(p.length,E.length);k<I&&y(p[k],E[k]);k++)M++;return M}t.$Pb=_;function x(p){return[].concat(...p)}t.$Qb=x;function P(p,E){let y=typeof E=="number"?p:0;typeof E=="number"?y=p:(y=0,E=p);const M=[];if(y<=E)for(let k=y;k<E;k++)M.push(k);else for(let k=y;k>E;k--)M.push(k);return M}t.$Rb=P;function O(p,E,y){return p.reduce((M,k)=>(M[E(k)]=y?y(k):k,M),Object.create(null))}t.$Sb=O;function K(p,E){return p.push(E),()=>te(p,E)}t.$Tb=K;function te(p,E){const y=p.indexOf(E);if(y>-1)return p.splice(y,1),E}t.$Ub=te;function se(p,E,y){const M=p.slice(0,E),k=p.slice(E);return M.concat(y,k)}t.$Vb=se;function fe(p,E){let y;if(typeof E=="number"){let M=E;y=()=>{const k=Math.sin(M++)*179426549;return k-Math.floor(k)}}else y=Math.random;for(let M=p.length-1;M>0;M-=1){const k=Math.floor(y()*(M+1)),I=p[M];p[M]=p[k],p[k]=I}}t.$Wb=fe;function le(p,E){const y=p.indexOf(E);y>-1&&(p.splice(y,1),p.unshift(E))}t.$Xb=le;function oe(p,E){const y=p.indexOf(E);y>-1&&(p.splice(y,1),p.push(E))}t.$Yb=oe;function be(p,E){for(const y of E)p.push(y)}t.$Zb=be;function Ce(p,E){return Array.isArray(p)?p.map(E):E(p)}t.$1b=Ce;function Ae(p){return Array.isArray(p)?p:[p]}t.$2b=Ae;function Pe(p){return p[Math.floor(Math.random()*p.length)]}t.$3b=Pe;function de(p,E,y){const M=ce(p,E),k=p.length,I=y.length;p.length=k+I;for(let C=k-1;C>=M;C--)p[C+I]=p[C];for(let C=0;C<I;C++)p[C+M]=y[C]}t.$4b=de;function ie(p,E,y,M){const k=ce(p,E);let I=p.splice(k,y);return I===void 0&&(I=[]),de(p,k,M),I}t.$5b=ie;function ce(p,E){return E<0?Math.max(E+p.length,0):Math.min(E,p.length)}var Z;(function(p){function E(I){return I<0}p.isLessThan=E;function y(I){return I<=0}p.isLessThanOrEqual=y;function M(I){return I>0}p.isGreaterThan=M;function k(I){return I===0}p.isNeitherLessOrGreaterThan=k,p.greaterThan=1,p.lessThan=-1,p.neitherLessOrGreaterThan=0})(Z||(t.CompareResult=Z={}));function W(p,E){return(y,M)=>E(p(y),p(M))}t.$6b=W;function Y(...p){return(E,y)=>{for(const M of p){const k=M(E,y);if(!Z.isNeitherLessOrGreaterThan(k))return k}return Z.neitherLessOrGreaterThan}}t.$7b=Y;const S=(p,E)=>p-E;t.$8b=S;const q=(p,E)=>(0,t.$8b)(p?1:0,E?1:0);t.$9b=q;function $(p){return(E,y)=>-p(E,y)}t.$0b=$;class U{constructor(E){this.g=E,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(E){let y=this.c;for(;y<this.g.length&&E(this.g[y]);)y++;const M=y===this.c?null:this.g.slice(this.c,y);return this.c=y,M}takeFromEndWhile(E){let y=this.d;for(;y>=0&&E(this.g[y]);)y--;const M=y===this.d?null:this.g.slice(y+1,this.d+1);return this.d=y,M}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const E=this.g[this.c];return this.c++,E}removeLast(){const E=this.g[this.d];return this.d--,E}takeCount(E){const y=this.g.slice(this.c,this.c+E);return this.c+=E,y}}t.$$b=U;class Q{static{this.empty=new Q(E=>{})}constructor(E){this.iterate=E}forEach(E){this.iterate(y=>(E(y),!0))}toArray(){const E=[];return this.iterate(y=>(E.push(y),!0)),E}filter(E){return new Q(y=>this.iterate(M=>E(M)?y(M):!0))}map(E){return new Q(y=>this.iterate(M=>y(E(M))))}some(E){let y=!1;return this.iterate(M=>(y=E(M),!y)),y}findFirst(E){let y;return this.iterate(M=>E(M)?(y=M,!1):!0),y}findLast(E){let y;return this.iterate(M=>(E(M)&&(y=M),!0)),y}findLastMaxBy(E){let y,M=!0;return this.iterate(k=>((M||Z.isGreaterThan(E(k,y)))&&(M=!1,y=k),!0)),y}}t.$_b=Q}),define($e[76],we([1,0,6]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=t.$5c=t.$4c=t.$3c=t.ok=void 0;function T(f,g){if(!f)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}t.ok=T;function i(f,g="Unreachable"){throw new Error(g)}t.$3c=i;function H(f){if(!f)throw new v.$bb("Assertion Failed")}t.$4c=H;function w(f){if(!f()){debugger;f(),(0,v.$Z)(new v.$bb("Assertion Failed"))}}t.$5c=w;function A(f,g){let c=0;for(;c<f.length-1;){const L=f[c],s=f[c+1];if(!g(L,s))return!1;c++}return!0}t.$6c=A}),define($e[43],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=void 0;function v(T){const i=this;let H=!1,w;return function(){return H||(H=!0,w=T.apply(i,arguments)),w}}t.$cb=v}),define($e[77],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CM=t.$BM=void 0;class v{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.$BM=v,t.$CM=new v("id#")}),define($e[27],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var v;(function(T){function i(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}T.is=i;const H=Object.freeze([]);function w(){return H}T.empty=w;function*A(u){yield u}T.single=A;function f(u){return i(u)?u:A(u)}T.wrap=f;function g(u){return u||H}T.from=g;function*c(u){for(let l=u.length-1;l>=0;l--)yield u[l]}T.reverse=c;function L(u){return!u||u[Symbol.iterator]().next().done===!0}T.isEmpty=L;function s(u){return u[Symbol.iterator]().next().value}T.first=s;function h(u,l){for(const N of u)if(l(N))return!0;return!1}T.some=h;function e(u,l){for(const N of u)if(l(N))return N}T.find=e;function*o(u,l){for(const N of u)l(N)&&(yield N)}T.filter=o;function*a(u,l){let N=0;for(const z of u)yield l(z,N++)}T.map=a;function*m(...u){for(const l of u)for(const N of l)yield N}T.concat=m;function n(u,l,N){let z=N;for(const R of u)z=l(z,R);return z}T.reduce=n;function*r(u,l,N=u.length){for(l<0&&(l+=u.length),N<0?N+=u.length:N>u.length&&(N=u.length);l<N;l++)yield u[l]}T.slice=r;function b(u,l=Number.POSITIVE_INFINITY){const N=[];if(l===0)return[N,u];const z=u[Symbol.iterator]();for(let R=0;R<l;R++){const d=z.next();if(d.done)return[N,T.empty()];N.push(d.value)}return[N,{[Symbol.iterator](){return z}}]}T.consume=b})(v||(t.Iterable=v={}))}),define($e[44],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Iq=t.KeyMod=t.KeyCodeUtils=t.$Hq=t.$Gq=t.$Fq=t.$Eq=t.$Dq=t.ScanCode=t.KeyCode=void 0;var v;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(v||(t.KeyCode=v={}));var T;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(T||(t.ScanCode=T={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(o,a){this._keyCodeToStr[o]=a,this._strToKeyCode[a.toLowerCase()]=o}keyCodeToStr(o){return this._keyCodeToStr[o]}strToKeyCode(o){return this._strToKeyCode[o.toLowerCase()]||0}}const H=new i,w=new i,A=new i;t.$Dq=new Array(230),t.$Eq={};const f=[],g=Object.create(null),c=Object.create(null);t.$Fq={lowerCaseToEnum:e=>c[e]||0,toEnum:e=>g[e]||0,toString:e=>f[e]||"None"},t.$Gq=[],t.$Hq=[];for(let e=0;e<=193;e++)t.$Gq[e]=-1;for(let e=0;e<=132;e++)t.$Hq[e]=-1;(function(){const e="",o=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],a=[],m=[];for(const n of o){const[r,b,u,l,N,z,R,d,D]=n;if(m[b]||(m[b]=!0,f[b]=u,g[u]=b,c[u.toLowerCase()]=b,r&&(t.$Gq[b]=l,l!==0&&l!==3&&l!==5&&l!==4&&l!==6&&l!==57&&(t.$Hq[l]=b))),!a[l]){if(a[l]=!0,!N)throw new Error(`String representation missing for key code ${l} around scan code ${u}`);H.define(l,N),w.define(l,d||N),A.define(l,D||d||N)}z&&(t.$Dq[z]=l),R&&(t.$Eq[R]=l)}t.$Hq[3]=46})();var L;(function(e){function o(u){return H.keyCodeToStr(u)}e.toString=o;function a(u){return H.strToKeyCode(u)}e.fromString=a;function m(u){return w.keyCodeToStr(u)}e.toUserSettingsUS=m;function n(u){return A.keyCodeToStr(u)}e.toUserSettingsGeneral=n;function r(u){return w.strToKeyCode(u)||A.strToKeyCode(u)}e.fromUserSettings=r;function b(u){if(u>=98&&u<=113)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return H.keyCodeToStr(u)}e.toElectronAccelerator=b})(L||(t.KeyCodeUtils=L={}));var s;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(s||(t.KeyMod=s={}));function h(e,o){const a=(o&65535)<<16>>>0;return(e|a)>>>0}t.$Iq=h}),define($e[78],we([1,0,6]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pq=t.$Oq=t.$Nq=t.$Mq=t.$Lq=t.$Kq=t.$Jq=void 0;var T;(function(L){L[L.CtrlCmd=2048]="CtrlCmd",L[L.Shift=1024]="Shift",L[L.Alt=512]="Alt",L[L.WinCtrl=256]="WinCtrl",L[L.KeyCode=255]="KeyCode"})(T||(T={}));function i(L,s){if(typeof L=="number"){if(L===0)return null;const h=(L&65535)>>>0,e=(L&4294901760)>>>16;return e!==0?new f([H(h,s),H(e,s)]):new f([H(h,s)])}else{const h=[];for(let e=0;e<L.length;e++)h.push(H(L[e],s));return new f(h)}}t.$Jq=i;function H(L,s){const h=!!(L&2048),e=!!(L&256),o=s===2?e:h,a=!!(L&1024),m=!!(L&512),n=s===2?h:e,r=L&255;return new w(o,a,m,n,r)}t.$Kq=H;class w{constructor(s,h,e,o,a){this.ctrlKey=s,this.shiftKey=h,this.altKey=e,this.metaKey=o,this.keyCode=a}equals(s){return s instanceof w&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.keyCode===s.keyCode}getHashCode(){const s=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",e=this.altKey?"1":"0",o=this.metaKey?"1":"0";return`K${s}${h}${e}${o}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new f([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Lq=w;class A{constructor(s,h,e,o,a){this.ctrlKey=s,this.shiftKey=h,this.altKey=e,this.metaKey=o,this.scanCode=a}equals(s){return s instanceof A&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.scanCode===s.scanCode}getHashCode(){const s=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",e=this.altKey?"1":"0",o=this.metaKey?"1":"0";return`S${s}${h}${e}${o}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Mq=A;class f{constructor(s){if(s.length===0)throw(0,v.$6)("chords");this.chords=s}getHashCode(){let s="";for(let h=0,e=this.chords.length;h<e;h++)h!==0&&(s+=";"),s+=this.chords[h].getHashCode();return s}equals(s){if(s===null||this.chords.length!==s.chords.length)return!1;for(let h=0;h<this.chords.length;h++)if(!this.chords[h].equals(s.chords[h]))return!1;return!0}}t.$Nq=f;class g{constructor(s,h,e,o,a,m){this.ctrlKey=s,this.shiftKey=h,this.altKey=e,this.metaKey=o,this.keyLabel=a,this.keyAriaLabel=m}}t.$Oq=g;class c{}t.$Pq=c}),define($e[28],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U=void 0;class v{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$U=v}),define($e[45],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1c=void 0;class v{static{this.Undefined=new v(void 0)}constructor(H){this.element=H,this.next=v.Undefined,this.prev=v.Undefined}}class T{constructor(){this.a=v.Undefined,this.b=v.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===v.Undefined}clear(){let H=this.a;for(;H!==v.Undefined;){const w=H.next;H.prev=v.Undefined,H.next=v.Undefined,H=w}this.a=v.Undefined,this.b=v.Undefined,this.c=0}unshift(H){return this.d(H,!1)}push(H){return this.d(H,!0)}d(H,w){const A=new v(H);if(this.a===v.Undefined)this.a=A,this.b=A;else if(w){const g=this.b;this.b=A,A.prev=g,g.next=A}else{const g=this.a;this.a=A,A.next=g,g.prev=A}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(A))}}shift(){if(this.a!==v.Undefined){const H=this.a.element;return this.e(this.a),H}}pop(){if(this.b!==v.Undefined){const H=this.b.element;return this.e(this.b),H}}e(H){if(H.prev!==v.Undefined&&H.next!==v.Undefined){const w=H.prev;w.next=H.next,H.next.prev=w}else H.prev===v.Undefined&&H.next===v.Undefined?(this.a=v.Undefined,this.b=v.Undefined):H.next===v.Undefined?(this.b=this.b.prev,this.b.next=v.Undefined):H.prev===v.Undefined&&(this.a=this.a.next,this.a.prev=v.Undefined);this.c-=1}*[Symbol.iterator](){let H=this.a;for(;H!==v.Undefined;)yield H.element,H=H.next}}t.$1c=T}),define($e[32],we([1,0]),function(ae,t){"use strict";var v,T,i;Object.defineProperty(t,"__esModule",{value:!0}),t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.Touch=t.$Ac=t.$zc=t.$yc=t.$xc=t.$wc=void 0;function H(n,r,b){let u=n.get(r);return u===void 0&&(u=b,n.set(r,u)),u}t.$wc=H;function w(n){const r=[];return n.forEach((b,u)=>{r.push(`${u} => ${b}`)}),`Map(${n.size}) {${r.join(", ")}}`}t.$xc=w;function A(n){const r=[];return n.forEach(b=>{r.push(b)}),`Set(${n.size}) {${r.join(", ")}}`}t.$yc=A;class f{constructor(r,b){this.uri=r,this.value=b}}function g(n){return Array.isArray(n)}class c{static{this.a=r=>r.toString()}constructor(r,b){if(this[v]="ResourceMap",r instanceof c)this.b=new Map(r.b),this.c=b??c.a;else if(g(r)){this.b=new Map,this.c=b??c.a;for(const[u,l]of r)this.set(u,l)}else this.b=new Map,this.c=r??c.a}set(r,b){return this.b.set(this.c(r),new f(r,b)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,b){typeof b<"u"&&(r=r.bind(b));for(const[u,l]of this.b)r(l.value,l.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}t.$zc=c;class L{constructor(r,b){this[T]="ResourceSet",!r||typeof r=="function"?this.a=new c(r):(this.a=new c(b),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,b){this.a.forEach((u,l)=>r.call(b,l,l,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ac=L;var s;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(s||(t.Touch=s={}));class h{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,b=0){const u=this.a.get(r);if(u)return b!==0&&this.j(u,b),u.value}set(r,b,u=0){let l=this.a.get(r);if(l)l.value=b,u!==0&&this.j(l,u);else{switch(l={key:r,value:b,next:void 0,previous:void 0},u){case 0:this.h(l);break;case 1:this.g(l);break;case 2:this.h(l);break;default:this.h(l);break}this.a.set(r,l),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const b=this.a.get(r);if(b)return this.a.delete(r),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,b){const u=this.e;let l=this.b;for(;l;){if(b?r.bind(b)(l.value,l.key,this):r(l.value,l.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const r=this,b=this.e;let u=this.b;const l={[Symbol.iterator](){return l},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const N={value:u.key,done:!1};return u=u.next,N}else return{value:void 0,done:!0}}};return l}values(){const r=this,b=this.e;let u=this.b;const l={[Symbol.iterator](){return l},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const N={value:u.value,done:!1};return u=u.next,N}else return{value:void 0,done:!0}}};return l}entries(){const r=this,b=this.e;let u=this.b;const l={[Symbol.iterator](){return l},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const N={value:[u.key,u.value],done:!1};return u=u.next,N}else return{value:void 0,done:!0}}};return l}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let b=this.b,u=this.size;for(;b&&u>r;)this.a.delete(b.key),b=b.next,u--;this.b=b,this.d=u,b&&(b.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const b=r.next,u=r.previous;if(!b||!u)throw new Error("Invalid list");b.previous=u,u.next=b}r.next=void 0,r.previous=void 0,this.e++}j(r,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(r===this.b)return;const u=r.next,l=r.previous;r===this.c?(l.next=void 0,this.c=l):(u.previous=l,l.next=u),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(b===2){if(r===this.c)return;const u=r.next,l=r.previous;r===this.b?(u.previous=void 0,this.b=u):(u.previous=l,l.next=u),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((b,u)=>{r.push([u,b])}),r}fromJSON(r){this.clear();for(const[b,u]of r)this.set(b,u)}}t.$Bc=h;class e extends h{constructor(r,b=1){super(),this.k=r,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,b=2){return super.get(r,b)}peek(r){return super.get(r,0)}set(r,b){return super.set(r,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Cc=e;class o{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let b=this.a.get(r)||0;return b===0?!1:(b--,b===0?this.a.delete(r):this.a.set(r,b),!0)}has(r){return this.a.has(r)}}t.$Dc=o;class a{constructor(r){if(this.a=new Map,this.b=new Map,r)for(const[b,u]of r)this.set(b,u)}clear(){this.a.clear(),this.b.clear()}set(r,b){this.a.set(r,b),this.b.set(b,r)}get(r){return this.a.get(r)}getKey(r){return this.b.get(r)}delete(r){const b=this.a.get(r);return b===void 0?!1:(this.a.delete(r),this.b.delete(b),!0)}forEach(r,b){this.a.forEach((u,l)=>{r.call(b,u,l,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Ec=a;class m{constructor(){this.a=new Map}add(r,b){let u=this.a.get(r);u||(u=new Set,this.a.set(r,u)),u.add(b)}delete(r,b){const u=this.a.get(r);u&&(u.delete(b),u.size===0&&this.a.delete(r))}forEach(r,b){const u=this.a.get(r);u&&u.forEach(b)}get(r){const b=this.a.get(r);return b||new Set}}t.$Fc=m}),define($e[2],we([1,0,11,73,32,43,27]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=void 0;const A=!1;let f=null;class g{constructor(){this.b=new Map}static{this.a=0}c(O){let K=this.b.get(O);return K||(K={parent:null,source:null,isSingleton:!1,value:O,idx:g.a++},this.b.set(O,K)),K}trackDisposable(O){const K=this.c(O);K.source||(K.source=new Error().stack)}setParent(O,K){const te=this.c(O);te.parent=K}markAsDisposed(O){this.b.delete(O)}markAsSingleton(O){this.c(O).isSingleton=!0}f(O,K){const te=K.get(O);if(te)return te;const se=O.parent?this.f(this.c(O.parent),K):O;return K.set(O,se),se}getTrackedDisposables(){const O=new Map;return[...this.b.entries()].filter(([,te])=>te.source!==null&&!this.f(te,O).isSingleton).flatMap(([te])=>te)}computeLeakingDisposables(O=10,K){let te;if(K)te=K;else{const be=new Map,Ce=[...this.b.values()].filter(Pe=>Pe.source!==null&&!this.f(Pe,be).isSingleton);if(Ce.length===0)return;const Ae=new Set(Ce.map(Pe=>Pe.value));if(te=Ce.filter(Pe=>!(Pe.parent&&Ae.has(Pe.parent))),te.length===0)throw new Error("There are cyclic diposable chains!")}if(!te)return;function se(be){function Ce(Pe,de){for(;Pe.length>0&&de.some(ie=>typeof ie=="string"?ie===Pe[0]:Pe[0].match(ie));)Pe.shift()}const Ae=be.source.split(`
`).map(Pe=>Pe.trim().replace("at ","")).filter(Pe=>Pe!=="");return Ce(Ae,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Ae.reverse()}const fe=new i.$Fc;for(const be of te){const Ce=se(be);for(let Ae=0;Ae<=Ce.length;Ae++)fe.add(Ce.slice(0,Ae).join(`
`),be)}te.sort((0,v.$6b)(be=>be.idx,v.$8b));let le="",oe=0;for(const be of te.slice(0,O)){oe++;const Ce=se(be),Ae=[];for(let Pe=0;Pe<Ce.length;Pe++){let de=Ce[Pe];de=`(shared with ${fe.get(Ce.slice(0,Pe+1).join(`
`)).size}/${te.length} leaks) at ${de}`;const ce=fe.get(Ce.slice(0,Pe).join(`
`)),Z=(0,T.$J)([...ce].map(W=>se(W)[Pe]),W=>W);delete Z[Ce[Pe]];for(const[W,Y]of Object.entries(Z))Ae.unshift(`    - stacktraces of ${Y.length} other leaks continue with ${W}`);Ae.unshift(de)}le+=`


==================== Leaking disposable ${oe}/${te.length}: ${be.value.constructor.name} ====================
${Ae.join(`
`)}
============================================================

`}return te.length>O&&(le+=`


... and ${te.length-O} more leaking disposables

`),{leaks:te,details:le}}}t.$Gc=g;function c(P){f=P}if(t.$Hc=c,A){const P="__is_disposable_tracked__";c(new class{trackDisposable(O){const K=new Error("Potentially leaked disposable").stack;setTimeout(()=>{O[P]||console.log(K)},3e3)}setParent(O,K){if(O&&O!==l.None)try{O[P]=!0}catch{}}markAsDisposed(O){if(O&&O!==l.None)try{O[P]=!0}catch{}}markAsSingleton(O){}})}function L(P){return f?.trackDisposable(P),P}t.$Ic=L;function s(P){f?.markAsDisposed(P)}t.$Jc=s;function h(P,O){f?.setParent(P,O)}function e(P,O){if(f)for(const K of P)f.setParent(K,O)}function o(P){return f?.markAsSingleton(P),P}t.$Kc=o;function a(P){return typeof P.dispose=="function"&&P.dispose.length===0}t.$Lc=a;function m(P){if(w.Iterable.is(P)){const O=[];for(const K of P)if(K)try{K.dispose()}catch(te){O.push(te)}if(O.length===1)throw O[0];if(O.length>1)throw new AggregateError(O,"Encountered errors while disposing of store");return Array.isArray(P)?[]:P}else if(P)return P.dispose(),P}t.$Mc=m;function n(P){for(const O of P)a(O)&&O.dispose();return[]}t.$Nc=n;function r(...P){const O=b(()=>m(P));return e(P,O),O}t.$Oc=r;function b(P){const O=L({dispose:(0,H.$cb)(()=>{s(O),P()})});return O}t.$Pc=b;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,L(this)}dispose(){this.g||(s(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(O){if(!O)return O;if(O===this)throw new Error("Cannot register a disposable on itself!");return h(O,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(O),O}delete(O){if(O){if(O===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(O),O.dispose()}}deleteAndLeak(O){O&&this.f.has(O)&&(this.f.delete(O),h(O,null))}}t.$Qc=u;class l{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,L(this),h(this.q,this)}dispose(){s(this),this.q.dispose()}B(O){if(O===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(O)}}t.$Rc=l;class N{constructor(){this.b=!1,L(this)}get value(){return this.b?void 0:this.a}set value(O){this.b||O===this.a||(this.a?.dispose(),O&&h(O,this),this.a=O)}clear(){this.value=void 0}dispose(){this.b=!0,s(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const O=this.a;return this.a=void 0,O&&h(O,null),O}}t.$Sc=N;class z{constructor(O){this.b=O,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Tc=z;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,L(this)}set(O){let K=O;return this.unset=()=>K=void 0,this.isset=()=>K!==void 0,this.dispose=()=>{K&&(K(),K=void 0,s(this))},this}}t.$Uc=R;class d{constructor(){this.a=new Map}acquire(O,...K){let te=this.a.get(O);te||(te={counter:0,object:this.b(O,...K)},this.a.set(O,te));const{object:se}=te,fe=(0,H.$cb)(()=>{--te.counter===0&&(this.c(O,te.object),this.a.delete(O))});return te.counter++,{object:se,dispose:fe}}}t.$Vc=d;class D{constructor(O){this.a=O}async acquire(O,...K){const te=this.a.acquire(O,...K);try{return{object:await te.object,dispose:()=>te.dispose()}}catch(se){throw te.dispose(),se}}}t.$Wc=D;class B{constructor(O){this.object=O}dispose(){}}t.$Xc=B;function _(P){const O=new u;try{P(O)}finally{O.dispose()}}t.$Yc=_;class x{constructor(){this.a=new Map,this.b=!1,L(this)}dispose(){s(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(O){return this.a.has(O)}get size(){return this.a.size}get(O){return this.a.get(O)}set(O,K,te=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),te||this.a.get(O)?.dispose(),this.a.set(O,K)}deleteAndDispose(O){this.a.get(O)?.dispose(),this.a.delete(O)}keys(){return this.a.keys()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$Zc=x}),function(ae,t){typeof define=="function"&&define.amd?define($e[79],we([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ae=typeof globalThis<"u"?globalThis:ae||self,t(ae.marked={}))}(this,function(ae){"use strict";function t(E,y){for(var M=0;M<y.length;M++){var k=y[M];k.enumerable=k.enumerable||!1,k.configurable=!0,"value"in k&&(k.writable=!0),Object.defineProperty(E,k.key,k)}}function v(E,y,M){return y&&t(E.prototype,y),M&&t(E,M),Object.defineProperty(E,"prototype",{writable:!1}),E}function T(E,y){if(E){if(typeof E=="string")return i(E,y);var M=Object.prototype.toString.call(E).slice(8,-1);if(M==="Object"&&E.constructor&&(M=E.constructor.name),M==="Map"||M==="Set")return Array.from(E);if(M==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(M))return i(E,y)}}function i(E,y){(y==null||y>E.length)&&(y=E.length);for(var M=0,k=new Array(y);M<y;M++)k[M]=E[M];return k}function H(E,y){var M=typeof Symbol<"u"&&E[Symbol.iterator]||E["@@iterator"];if(M)return(M=M.call(E)).next.bind(M);if(Array.isArray(E)||(M=T(E))||y&&E&&typeof E.length=="number"){M&&(E=M);var k=0;return function(){return k>=E.length?{done:!0}:{done:!1,value:E[k++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function w(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ae.defaults=w();function A(E){ae.defaults=E}var f=/[&<>"']/,g=/[&<>"']/g,c=/[<>"']|&(?!#?\w+;)/,L=/[<>"']|&(?!#?\w+;)/g,s={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(y){return s[y]};function e(E,y){if(y){if(f.test(E))return E.replace(g,h)}else if(c.test(E))return E.replace(L,h);return E}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(E){return E.replace(o,function(y,M){return M=M.toLowerCase(),M==="colon"?":":M.charAt(0)==="#"?M.charAt(1)==="x"?String.fromCharCode(parseInt(M.substring(2),16)):String.fromCharCode(+M.substring(1)):""})}var m=/(^|[^\[])\^/g;function n(E,y){E=typeof E=="string"?E:E.source,y=y||"";var M={replace:function(I,C){return C=C.source||C,C=C.replace(m,"$1"),E=E.replace(I,C),M},getRegex:function(){return new RegExp(E,y)}};return M}var r=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(E,y,M){if(E){var k;try{k=decodeURIComponent(a(M)).replace(r,"").toLowerCase()}catch{return null}if(k.indexOf("javascript:")===0||k.indexOf("vbscript:")===0||k.indexOf("data:")===0)return null}y&&!b.test(M)&&(M=d(y,M));try{M=encodeURI(M).replace(/%25/g,"%")}catch{return null}return M}var l={},N=/^[^:]+:\/*[^/]*$/,z=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function d(E,y){l[" "+E]||(N.test(E)?l[" "+E]=E+"/":l[" "+E]=x(E,"/",!0)),E=l[" "+E];var M=E.indexOf(":")===-1;return y.substring(0,2)==="//"?M?y:E.replace(z,"$1")+y:y.charAt(0)==="/"?M?y:E.replace(R,"$1")+y:E+y}var D={exec:function(){}};function B(E){for(var y=1,M,k;y<arguments.length;y++){M=arguments[y];for(k in M)Object.prototype.hasOwnProperty.call(M,k)&&(E[k]=M[k])}return E}function _(E,y){var M=E.replace(/\|/g,function(C,F,j){for(var X=!1,ee=F;--ee>=0&&j[ee]==="\\";)X=!X;return X?"|":" |"}),k=M.split(/ \|/),I=0;if(k[0].trim()||k.shift(),k.length>0&&!k[k.length-1].trim()&&k.pop(),k.length>y)k.splice(y);else for(;k.length<y;)k.push("");for(;I<k.length;I++)k[I]=k[I].trim().replace(/\\\|/g,"|");return k}function x(E,y,M){var k=E.length;if(k===0)return"";for(var I=0;I<k;){var C=E.charAt(k-I-1);if(C===y&&!M)I++;else if(C!==y&&M)I++;else break}return E.slice(0,k-I)}function P(E,y){if(E.indexOf(y[1])===-1)return-1;for(var M=E.length,k=0,I=0;I<M;I++)if(E[I]==="\\")I++;else if(E[I]===y[0])k++;else if(E[I]===y[1]&&(k--,k<0))return I;return-1}function O(E){E&&E.sanitize&&!E.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function K(E,y){if(y<1)return"";for(var M="";y>1;)y&1&&(M+=E),y>>=1,E+=E;return M+E}function te(E,y,M,k){var I=y.href,C=y.title?e(y.title):null,F=E[1].replace(/\\([\[\]])/g,"$1");if(E[0].charAt(0)!=="!"){k.state.inLink=!0;var j={type:"link",raw:M,href:I,title:C,text:F,tokens:k.inlineTokens(F)};return k.state.inLink=!1,j}return{type:"image",raw:M,href:I,title:C,text:e(F)}}function se(E,y){var M=E.match(/^(\s+)(?:```)/);if(M===null)return y;var k=M[1];return y.split(`
`).map(function(I){var C=I.match(/^\s+/);if(C===null)return I;var F=C[0];return F.length>=k.length?I.slice(k.length):I}).join(`
`)}var fe=function(){function E(M){this.options=M||ae.defaults}var y=E.prototype;return y.space=function(k){var I=this.rules.block.newline.exec(k);if(I&&I[0].length>0)return{type:"space",raw:I[0]}},y.code=function(k){var I=this.rules.block.code.exec(k);if(I){var C=I[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:I[0],codeBlockStyle:"indented",text:this.options.pedantic?C:x(C,`
`)}}},y.fences=function(k){var I=this.rules.block.fences.exec(k);if(I){var C=I[0],F=se(C,I[3]||"");return{type:"code",raw:C,lang:I[2]?I[2].trim():I[2],text:F}}},y.heading=function(k){var I=this.rules.block.heading.exec(k);if(I){var C=I[2].trim();if(/#$/.test(C)){var F=x(C,"#");(this.options.pedantic||!F||/ $/.test(F))&&(C=F.trim())}return{type:"heading",raw:I[0],depth:I[1].length,text:C,tokens:this.lexer.inline(C)}}},y.hr=function(k){var I=this.rules.block.hr.exec(k);if(I)return{type:"hr",raw:I[0]}},y.blockquote=function(k){var I=this.rules.block.blockquote.exec(k);if(I){var C=I[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:I[0],tokens:this.lexer.blockTokens(C,[]),text:C}}},y.list=function(k){var I=this.rules.block.list.exec(k);if(I){var C,F,j,X,ee,ne,me,ve,Ne,Se,De,Le,Te=I[1].trim(),We=Te.length>1,He={type:"list",raw:"",ordered:We,start:We?+Te.slice(0,-1):"",loose:!1,items:[]};Te=We?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=We?Te:"[*+-]");for(var Me=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");k&&(Le=!1,!(!(I=Me.exec(k))||this.rules.block.hr.test(k)));){if(C=I[0],k=k.substring(C.length),ve=I[2].split(`
`,1)[0],Ne=k.split(`
`,1)[0],this.options.pedantic?(X=2,De=ve.trimLeft()):(X=I[2].search(/[^ ]/),X=X>4?1:X,De=ve.slice(X),X+=I[1].length),ne=!1,!ve&&/^ *$/.test(Ne)&&(C+=Ne+`
`,k=k.substring(Ne.length+1),Le=!0),!Le)for(var Ye=new RegExp("^ {0,"+Math.min(3,X-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),J=new RegExp("^ {0,"+Math.min(3,X-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),he=new RegExp("^ {0,"+Math.min(3,X-1)+"}(?:```|~~~)"),pe=new RegExp("^ {0,"+Math.min(3,X-1)+"}#");k&&(Se=k.split(`
`,1)[0],ve=Se,this.options.pedantic&&(ve=ve.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(he.test(ve)||pe.test(ve)||Ye.test(ve)||J.test(k)));){if(ve.search(/[^ ]/)>=X||!ve.trim())De+=`
`+ve.slice(X);else if(!ne)De+=`
`+ve;else break;!ne&&!ve.trim()&&(ne=!0),C+=Se+`
`,k=k.substring(Se.length+1)}He.loose||(me?He.loose=!0:/\n *\n *$/.test(C)&&(me=!0)),this.options.gfm&&(F=/^\[[ xX]\] /.exec(De),F&&(j=F[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:C,task:!!F,checked:j,loose:!1,text:De}),He.raw+=C}He.items[He.items.length-1].raw=C.trimRight(),He.items[He.items.length-1].text=De.trimRight(),He.raw=He.raw.trimRight();var Ee=He.items.length;for(ee=0;ee<Ee;ee++){this.lexer.state.top=!1,He.items[ee].tokens=this.lexer.blockTokens(He.items[ee].text,[]);var Fe=He.items[ee].tokens.filter(function(Ue){return Ue.type==="space"}),Be=Fe.every(function(Ue){for(var Ze=Ue.raw.split(""),Je=0,Ke=H(Ze),_e;!(_e=Ke()).done;){var tt=_e.value;if(tt===`
`&&(Je+=1),Je>1)return!0}return!1});!He.loose&&Fe.length&&Be&&(He.loose=!0,He.items[ee].loose=!0)}return He}},y.html=function(k){var I=this.rules.block.html.exec(k);if(I){var C={type:"html",raw:I[0],pre:!this.options.sanitizer&&(I[1]==="pre"||I[1]==="script"||I[1]==="style"),text:I[0]};if(this.options.sanitize){var F=this.options.sanitizer?this.options.sanitizer(I[0]):e(I[0]);C.type="paragraph",C.text=F,C.tokens=this.lexer.inline(F)}return C}},y.def=function(k){var I=this.rules.block.def.exec(k);if(I){I[3]&&(I[3]=I[3].substring(1,I[3].length-1));var C=I[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:C,raw:I[0],href:I[2],title:I[3]}}},y.table=function(k){var I=this.rules.block.table.exec(k);if(I){var C={type:"table",header:_(I[1]).map(function(me){return{text:me}}),align:I[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:I[3]&&I[3].trim()?I[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(C.header.length===C.align.length){C.raw=I[0];var F=C.align.length,j,X,ee,ne;for(j=0;j<F;j++)/^ *-+: *$/.test(C.align[j])?C.align[j]="right":/^ *:-+: *$/.test(C.align[j])?C.align[j]="center":/^ *:-+ *$/.test(C.align[j])?C.align[j]="left":C.align[j]=null;for(F=C.rows.length,j=0;j<F;j++)C.rows[j]=_(C.rows[j],C.header.length).map(function(me){return{text:me}});for(F=C.header.length,X=0;X<F;X++)C.header[X].tokens=this.lexer.inline(C.header[X].text);for(F=C.rows.length,X=0;X<F;X++)for(ne=C.rows[X],ee=0;ee<ne.length;ee++)ne[ee].tokens=this.lexer.inline(ne[ee].text);return C}}},y.lheading=function(k){var I=this.rules.block.lheading.exec(k);if(I)return{type:"heading",raw:I[0],depth:I[2].charAt(0)==="="?1:2,text:I[1],tokens:this.lexer.inline(I[1])}},y.paragraph=function(k){var I=this.rules.block.paragraph.exec(k);if(I){var C=I[1].charAt(I[1].length-1)===`
`?I[1].slice(0,-1):I[1];return{type:"paragraph",raw:I[0],text:C,tokens:this.lexer.inline(C)}}},y.text=function(k){var I=this.rules.block.text.exec(k);if(I)return{type:"text",raw:I[0],text:I[0],tokens:this.lexer.inline(I[0])}},y.escape=function(k){var I=this.rules.inline.escape.exec(k);if(I)return{type:"escape",raw:I[0],text:e(I[1])}},y.tag=function(k){var I=this.rules.inline.tag.exec(k);if(I)return!this.lexer.state.inLink&&/^<a /i.test(I[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(I[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(I[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(I[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:I[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(I[0]):e(I[0]):I[0]}},y.link=function(k){var I=this.rules.inline.link.exec(k);if(I){var C=I[2].trim();if(!this.options.pedantic&&/^</.test(C)){if(!/>$/.test(C))return;var F=x(C.slice(0,-1),"\\");if((C.length-F.length)%2===0)return}else{var j=P(I[2],"()");if(j>-1){var X=I[0].indexOf("!")===0?5:4,ee=X+I[1].length+j;I[2]=I[2].substring(0,j),I[0]=I[0].substring(0,ee).trim(),I[3]=""}}var ne=I[2],me="";if(this.options.pedantic){var ve=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ne);ve&&(ne=ve[1],me=ve[3])}else me=I[3]?I[3].slice(1,-1):"";return ne=ne.trim(),/^</.test(ne)&&(this.options.pedantic&&!/>$/.test(C)?ne=ne.slice(1):ne=ne.slice(1,-1)),te(I,{href:ne&&ne.replace(this.rules.inline._escapes,"$1"),title:me&&me.replace(this.rules.inline._escapes,"$1")},I[0],this.lexer)}},y.reflink=function(k,I){var C;if((C=this.rules.inline.reflink.exec(k))||(C=this.rules.inline.nolink.exec(k))){var F=(C[2]||C[1]).replace(/\s+/g," ");if(F=I[F.toLowerCase()],!F||!F.href){var j=C[0].charAt(0);return{type:"text",raw:j,text:j}}return te(C,F,C[0],this.lexer)}},y.emStrong=function(k,I,C){C===void 0&&(C="");var F=this.rules.inline.emStrong.lDelim.exec(k);if(F&&!(F[3]&&C.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var j=F[1]||F[2]||"";if(!j||j&&(C===""||this.rules.inline.punctuation.exec(C))){var X=F[0].length-1,ee,ne,me=X,ve=0,Ne=F[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ne.lastIndex=0,I=I.slice(-1*k.length+X);(F=Ne.exec(I))!=null;)if(ee=F[1]||F[2]||F[3]||F[4]||F[5]||F[6],!!ee){if(ne=ee.length,F[3]||F[4]){me+=ne;continue}else if((F[5]||F[6])&&X%3&&!((X+ne)%3)){ve+=ne;continue}if(me-=ne,!(me>0)){if(ne=Math.min(ne,ne+me+ve),Math.min(X,ne)%2){var Se=k.slice(1,X+F.index+ne);return{type:"em",raw:k.slice(0,X+F.index+ne+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var De=k.slice(2,X+F.index+ne-1);return{type:"strong",raw:k.slice(0,X+F.index+ne+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},y.codespan=function(k){var I=this.rules.inline.code.exec(k);if(I){var C=I[2].replace(/\n/g," "),F=/[^ ]/.test(C),j=/^ /.test(C)&&/ $/.test(C);return F&&j&&(C=C.substring(1,C.length-1)),C=e(C,!0),{type:"codespan",raw:I[0],text:C}}},y.br=function(k){var I=this.rules.inline.br.exec(k);if(I)return{type:"br",raw:I[0]}},y.del=function(k){var I=this.rules.inline.del.exec(k);if(I)return{type:"del",raw:I[0],text:I[2],tokens:this.lexer.inlineTokens(I[2])}},y.autolink=function(k,I){var C=this.rules.inline.autolink.exec(k);if(C){var F,j;return C[2]==="@"?(F=e(this.options.mangle?I(C[1]):C[1]),j="mailto:"+F):(F=e(C[1]),j=F),{type:"link",raw:C[0],text:F,href:j,tokens:[{type:"text",raw:F,text:F}]}}},y.url=function(k,I){var C;if(C=this.rules.inline.url.exec(k)){var F,j;if(C[2]==="@")F=e(this.options.mangle?I(C[0]):C[0]),j="mailto:"+F;else{var X;do X=C[0],C[0]=this.rules.inline._backpedal.exec(C[0])[0];while(X!==C[0]);F=e(C[0]),C[1]==="www."?j="http://"+F:j=F}return{type:"link",raw:C[0],text:F,href:j,tokens:[{type:"text",raw:F,text:F}]}}},y.inlineText=function(k,I){var C=this.rules.inline.text.exec(k);if(C){var F;return this.lexer.state.inRawBlock?F=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(C[0]):e(C[0]):C[0]:F=e(this.options.smartypants?I(C[0]):C[0]),{type:"text",raw:C[0],text:F}}},E}(),le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:D,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=n(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=n(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=n(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=n(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=n(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=n(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=B({},le),le.gfm=B({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=n(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.gfm.paragraph=n(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",le.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=B({},le.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:D,paragraph:n(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:D,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:D,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=n(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=n(le._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=n(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=n(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=n(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=n(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=n(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=n(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=n(oe.reflink).replace("label",oe._label).replace("ref",le._label).getRegex(),oe.nolink=n(oe.nolink).replace("ref",le._label).getRegex(),oe.reflinkSearch=n(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=B({},oe),oe.pedantic=B({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=B({},oe.normal,{escape:n(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=n(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=B({},oe.gfm,{br:n(oe.br).replace("{2,}","*").getRegex(),text:n(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function be(E){return E.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ce(E){var y="",M,k,I=E.length;for(M=0;M<I;M++)k=E.charCodeAt(M),Math.random()>.5&&(k="x"+k.toString(16)),y+="&#"+k+";";return y}var Ae=function(){function E(M){this.tokens=[],this.tokens.links=Object.create(null),this.options=M||ae.defaults,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var k={block:le.normal,inline:oe.normal};this.options.pedantic?(k.block=le.pedantic,k.inline=oe.pedantic):this.options.gfm&&(k.block=le.gfm,this.options.breaks?k.inline=oe.breaks:k.inline=oe.gfm),this.tokenizer.rules=k}E.lex=function(k,I){var C=new E(I);return C.lex(k)},E.lexInline=function(k,I){var C=new E(I);return C.inlineTokens(k)};var y=E.prototype;return y.lex=function(k){k=k.replace(/\r\n|\r/g,`
`),this.blockTokens(k,this.tokens);for(var I;I=this.inlineQueue.shift();)this.inlineTokens(I.src,I.tokens);return this.tokens},y.blockTokens=function(k,I){var C=this;I===void 0&&(I=[]),this.options.pedantic?k=k.replace(/\t/g,"    ").replace(/^ +$/gm,""):k=k.replace(/^( *)(\t+)/gm,function(me,ve,Ne){return ve+"    ".repeat(Ne.length)});for(var F,j,X,ee;k;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(me){return(F=me.call({lexer:C},k,I))?(k=k.substring(F.raw.length),I.push(F),!0):!1}))){if(F=this.tokenizer.space(k)){k=k.substring(F.raw.length),F.raw.length===1&&I.length>0?I[I.length-1].raw+=`
`:I.push(F);continue}if(F=this.tokenizer.code(k)){k=k.substring(F.raw.length),j=I[I.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+F.raw,j.text+=`
`+F.text,this.inlineQueue[this.inlineQueue.length-1].src=j.text):I.push(F);continue}if(F=this.tokenizer.fences(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.heading(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.hr(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.blockquote(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.list(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.html(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.def(k)){k=k.substring(F.raw.length),j=I[I.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+F.raw,j.text+=`
`+F.raw,this.inlineQueue[this.inlineQueue.length-1].src=j.text):this.tokens.links[F.tag]||(this.tokens.links[F.tag]={href:F.href,title:F.title});continue}if(F=this.tokenizer.table(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.lheading(k)){k=k.substring(F.raw.length),I.push(F);continue}if(X=k,this.options.extensions&&this.options.extensions.startBlock&&function(){var me=1/0,ve=k.slice(1),Ne=void 0;C.options.extensions.startBlock.forEach(function(Se){Ne=Se.call({lexer:this},ve),typeof Ne=="number"&&Ne>=0&&(me=Math.min(me,Ne))}),me<1/0&&me>=0&&(X=k.substring(0,me+1))}(),this.state.top&&(F=this.tokenizer.paragraph(X))){j=I[I.length-1],ee&&j.type==="paragraph"?(j.raw+=`
`+F.raw,j.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):I.push(F),ee=X.length!==k.length,k=k.substring(F.raw.length);continue}if(F=this.tokenizer.text(k)){k=k.substring(F.raw.length),j=I[I.length-1],j&&j.type==="text"?(j.raw+=`
`+F.raw,j.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):I.push(F);continue}if(k){var ne="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(ne);break}else throw new Error(ne)}}return this.state.top=!0,I},y.inline=function(k,I){return I===void 0&&(I=[]),this.inlineQueue.push({src:k,tokens:I}),I},y.inlineTokens=function(k,I){var C=this;I===void 0&&(I=[]);var F,j,X,ee=k,ne,me,ve;if(this.tokens.links){var Ne=Object.keys(this.tokens.links);if(Ne.length>0)for(;(ne=this.tokenizer.rules.inline.reflinkSearch.exec(ee))!=null;)Ne.includes(ne[0].slice(ne[0].lastIndexOf("[")+1,-1))&&(ee=ee.slice(0,ne.index)+"["+K("a",ne[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ne=this.tokenizer.rules.inline.blockSkip.exec(ee))!=null;)ee=ee.slice(0,ne.index)+"["+K("a",ne[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ne=this.tokenizer.rules.inline.escapedEmSt.exec(ee))!=null;)ee=ee.slice(0,ne.index)+"++"+ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;k;)if(me||(ve=""),me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(F=De.call({lexer:C},k,I))?(k=k.substring(F.raw.length),I.push(F),!0):!1}))){if(F=this.tokenizer.escape(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.tag(k)){k=k.substring(F.raw.length),j=I[I.length-1],j&&F.type==="text"&&j.type==="text"?(j.raw+=F.raw,j.text+=F.text):I.push(F);continue}if(F=this.tokenizer.link(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.reflink(k,this.tokens.links)){k=k.substring(F.raw.length),j=I[I.length-1],j&&F.type==="text"&&j.type==="text"?(j.raw+=F.raw,j.text+=F.text):I.push(F);continue}if(F=this.tokenizer.emStrong(k,ee,ve)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.codespan(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.br(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.del(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.autolink(k,Ce)){k=k.substring(F.raw.length),I.push(F);continue}if(!this.state.inLink&&(F=this.tokenizer.url(k,Ce))){k=k.substring(F.raw.length),I.push(F);continue}if(X=k,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Le=k.slice(1),Te=void 0;C.options.extensions.startInline.forEach(function(We){Te=We.call({lexer:this},Le),typeof Te=="number"&&Te>=0&&(De=Math.min(De,Te))}),De<1/0&&De>=0&&(X=k.substring(0,De+1))}(),F=this.tokenizer.inlineText(X,be)){k=k.substring(F.raw.length),F.raw.slice(-1)!=="_"&&(ve=F.raw.slice(-1)),me=!0,j=I[I.length-1],j&&j.type==="text"?(j.raw+=F.raw,j.text+=F.text):I.push(F);continue}if(k){var Se="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return I},v(E,null,[{key:"rules",get:function(){return{block:le,inline:oe}}}]),E}(),Pe=function(){function E(M){this.options=M||ae.defaults}var y=E.prototype;return y.code=function(k,I,C){var F=(I||"").match(/\S*/)[0];if(this.options.highlight){var j=this.options.highlight(k,F);j!=null&&j!==k&&(C=!0,k=j)}return k=k.replace(/\n$/,"")+`
`,F?'<pre><code class="'+this.options.langPrefix+e(F,!0)+'">'+(C?k:e(k,!0))+`</code></pre>
`:"<pre><code>"+(C?k:e(k,!0))+`</code></pre>
`},y.blockquote=function(k){return`<blockquote>
`+k+`</blockquote>
`},y.html=function(k){return k},y.heading=function(k,I,C,F){if(this.options.headerIds){var j=this.options.headerPrefix+F.slug(C);return"<h"+I+' id="'+j+'">'+k+"</h"+I+`>
`}return"<h"+I+">"+k+"</h"+I+`>
`},y.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},y.list=function(k,I,C){var F=I?"ol":"ul",j=I&&C!==1?' start="'+C+'"':"";return"<"+F+j+`>
`+k+"</"+F+`>
`},y.listitem=function(k){return"<li>"+k+`</li>
`},y.checkbox=function(k){return"<input "+(k?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},y.paragraph=function(k){return"<p>"+k+`</p>
`},y.table=function(k,I){return I&&(I="<tbody>"+I+"</tbody>"),`<table>
<thead>
`+k+`</thead>
`+I+`</table>
`},y.tablerow=function(k){return`<tr>
`+k+`</tr>
`},y.tablecell=function(k,I){var C=I.header?"th":"td",F=I.align?"<"+C+' align="'+I.align+'">':"<"+C+">";return F+k+("</"+C+`>
`)},y.strong=function(k){return"<strong>"+k+"</strong>"},y.em=function(k){return"<em>"+k+"</em>"},y.codespan=function(k){return"<code>"+k+"</code>"},y.br=function(){return this.options.xhtml?"<br/>":"<br>"},y.del=function(k){return"<del>"+k+"</del>"},y.link=function(k,I,C){if(k=u(this.options.sanitize,this.options.baseUrl,k),k===null)return C;var F='<a href="'+e(k)+'"';return I&&(F+=' title="'+I+'"'),F+=">"+C+"</a>",F},y.image=function(k,I,C){if(k=u(this.options.sanitize,this.options.baseUrl,k),k===null)return C;var F='<img src="'+k+'" alt="'+C+'"';return I&&(F+=' title="'+I+'"'),F+=this.options.xhtml?"/>":">",F},y.text=function(k){return k},E}(),de=function(){function E(){}var y=E.prototype;return y.strong=function(k){return k},y.em=function(k){return k},y.codespan=function(k){return k},y.del=function(k){return k},y.html=function(k){return k},y.text=function(k){return k},y.link=function(k,I,C){return""+C},y.image=function(k,I,C){return""+C},y.br=function(){return""},E}(),ie=function(){function E(){this.seen={}}var y=E.prototype;return y.serialize=function(k){return k.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},y.getNextSafeSlug=function(k,I){var C=k,F=0;if(this.seen.hasOwnProperty(C)){F=this.seen[k];do F++,C=k+"-"+F;while(this.seen.hasOwnProperty(C))}return I||(this.seen[k]=F,this.seen[C]=0),C},y.slug=function(k,I){I===void 0&&(I={});var C=this.serialize(k);return this.getNextSafeSlug(C,I.dryrun)},E}(),ce=function(){function E(M){this.options=M||ae.defaults,this.options.renderer=this.options.renderer||new Pe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new ie}E.parse=function(k,I){var C=new E(I);return C.parse(k)},E.parseInline=function(k,I){var C=new E(I);return C.parseInline(k)};var y=E.prototype;return y.parse=function(k,I){I===void 0&&(I=!0);var C="",F,j,X,ee,ne,me,ve,Ne,Se,De,Le,Te,We,He,Me,Ye,J,he,pe,Ee=k.length;for(F=0;F<Ee;F++){if(De=k[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(pe=this.options.extensions.renderers[De.type].call({parser:this},De),pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){C+=pe||"";continue}switch(De.type){case"space":continue;case"hr":{C+=this.renderer.hr();continue}case"heading":{C+=this.renderer.heading(this.parseInline(De.tokens),De.depth,a(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{C+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(Ne="",ve="",ee=De.header.length,j=0;j<ee;j++)ve+=this.renderer.tablecell(this.parseInline(De.header[j].tokens),{header:!0,align:De.align[j]});for(Ne+=this.renderer.tablerow(ve),Se="",ee=De.rows.length,j=0;j<ee;j++){for(me=De.rows[j],ve="",ne=me.length,X=0;X<ne;X++)ve+=this.renderer.tablecell(this.parseInline(me[X].tokens),{header:!1,align:De.align[X]});Se+=this.renderer.tablerow(ve)}C+=this.renderer.table(Ne,Se);continue}case"blockquote":{Se=this.parse(De.tokens),C+=this.renderer.blockquote(Se);continue}case"list":{for(Le=De.ordered,Te=De.start,We=De.loose,ee=De.items.length,Se="",j=0;j<ee;j++)Me=De.items[j],Ye=Me.checked,J=Me.task,He="",Me.task&&(he=this.renderer.checkbox(Ye),We?Me.tokens.length>0&&Me.tokens[0].type==="paragraph"?(Me.tokens[0].text=he+" "+Me.tokens[0].text,Me.tokens[0].tokens&&Me.tokens[0].tokens.length>0&&Me.tokens[0].tokens[0].type==="text"&&(Me.tokens[0].tokens[0].text=he+" "+Me.tokens[0].tokens[0].text)):Me.tokens.unshift({type:"text",text:he}):He+=he),He+=this.parse(Me.tokens,We),Se+=this.renderer.listitem(He,J,Ye);C+=this.renderer.list(Se,Le,Te);continue}case"html":{C+=this.renderer.html(De.text);continue}case"paragraph":{C+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Se=De.tokens?this.parseInline(De.tokens):De.text;F+1<Ee&&k[F+1].type==="text";)De=k[++F],Se+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);C+=I?this.renderer.paragraph(Se):Se;continue}default:{var Fe='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}}return C},y.parseInline=function(k,I){I=I||this.renderer;var C="",F,j,X,ee=k.length;for(F=0;F<ee;F++){if(j=k[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[j.type]&&(X=this.options.extensions.renderers[j.type].call({parser:this},j),X!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(j.type))){C+=X||"";continue}switch(j.type){case"escape":{C+=I.text(j.text);break}case"html":{C+=I.html(j.text);break}case"link":{C+=I.link(j.href,j.title,this.parseInline(j.tokens,I));break}case"image":{C+=I.image(j.href,j.title,j.text);break}case"strong":{C+=I.strong(this.parseInline(j.tokens,I));break}case"em":{C+=I.em(this.parseInline(j.tokens,I));break}case"codespan":{C+=I.codespan(j.text);break}case"br":{C+=I.br();break}case"del":{C+=I.del(this.parseInline(j.tokens,I));break}case"text":{C+=I.text(j.text);break}default:{var ne='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(ne);return}else throw new Error(ne)}}}return C},E}();function Z(E,y,M){if(typeof E>"u"||E===null)throw new Error("marked(): input parameter is undefined or null");if(typeof E!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(E)+", string expected");if(typeof y=="function"&&(M=y,y=null),y=B({},Z.defaults,y||{}),O(y),M){var k=y.highlight,I;try{I=Ae.lex(E,y)}catch(ee){return M(ee)}var C=function(ne){var me;if(!ne)try{y.walkTokens&&Z.walkTokens(I,y.walkTokens),me=ce.parse(I,y)}catch(ve){ne=ve}return y.highlight=k,ne?M(ne):M(null,me)};if(!k||k.length<3||(delete y.highlight,!I.length))return C();var F=0;Z.walkTokens(I,function(ee){ee.type==="code"&&(F++,setTimeout(function(){k(ee.text,ee.lang,function(ne,me){if(ne)return C(ne);me!=null&&me!==ee.text&&(ee.text=me,ee.escaped=!0),F--,F===0&&C()})},0))}),F===0&&C();return}function j(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,y.silent)return"<p>An error occurred:</p><pre>"+e(ee.message+"",!0)+"</pre>";throw ee}try{var X=Ae.lex(E,y);if(y.walkTokens){if(y.async)return Promise.all(Z.walkTokens(X,y.walkTokens)).then(function(){return ce.parse(X,y)}).catch(j);Z.walkTokens(X,y.walkTokens)}return ce.parse(X,y)}catch(ee){j(ee)}}Z.options=Z.setOptions=function(E){return B(Z.defaults,E),A(Z.defaults),Z},Z.getDefaults=w,Z.defaults=ae.defaults,Z.use=function(){for(var E=arguments.length,y=new Array(E),M=0;M<E;M++)y[M]=arguments[M];var k=B.apply(void 0,[{}].concat(y)),I=Z.defaults.extensions||{renderers:{},childTokens:{}},C;y.forEach(function(F){if(F.extensions&&(C=!0,F.extensions.forEach(function(X){if(!X.name)throw new Error("extension name required");if(X.renderer){var ee=I.renderers?I.renderers[X.name]:null;ee?I.renderers[X.name]=function(){for(var ne=arguments.length,me=new Array(ne),ve=0;ve<ne;ve++)me[ve]=arguments[ve];var Ne=X.renderer.apply(this,me);return Ne===!1&&(Ne=ee.apply(this,me)),Ne}:I.renderers[X.name]=X.renderer}if(X.tokenizer){if(!X.level||X.level!=="block"&&X.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");I[X.level]?I[X.level].unshift(X.tokenizer):I[X.level]=[X.tokenizer],X.start&&(X.level==="block"?I.startBlock?I.startBlock.push(X.start):I.startBlock=[X.start]:X.level==="inline"&&(I.startInline?I.startInline.push(X.start):I.startInline=[X.start]))}X.childTokens&&(I.childTokens[X.name]=X.childTokens)})),F.renderer&&function(){var X=Z.defaults.renderer||new Pe,ee=function(ve){var Ne=X[ve];X[ve]=function(){for(var Se=arguments.length,De=new Array(Se),Le=0;Le<Se;Le++)De[Le]=arguments[Le];var Te=F.renderer[ve].apply(X,De);return Te===!1&&(Te=Ne.apply(X,De)),Te}};for(var ne in F.renderer)ee(ne);k.renderer=X}(),F.tokenizer&&function(){var X=Z.defaults.tokenizer||new fe,ee=function(ve){var Ne=X[ve];X[ve]=function(){for(var Se=arguments.length,De=new Array(Se),Le=0;Le<Se;Le++)De[Le]=arguments[Le];var Te=F.tokenizer[ve].apply(X,De);return Te===!1&&(Te=Ne.apply(X,De)),Te}};for(var ne in F.tokenizer)ee(ne);k.tokenizer=X}(),F.walkTokens){var j=Z.defaults.walkTokens;k.walkTokens=function(X){var ee=[];return ee.push(F.walkTokens.call(this,X)),j&&(ee=ee.concat(j.call(this,X))),ee}}C&&(k.extensions=I),Z.setOptions(k)})},Z.walkTokens=function(E,y){for(var M=[],k=function(){var j=C.value;switch(M=M.concat(y.call(Z,j)),j.type){case"table":{for(var X=H(j.header),ee;!(ee=X()).done;){var ne=ee.value;M=M.concat(Z.walkTokens(ne.tokens,y))}for(var me=H(j.rows),ve;!(ve=me()).done;)for(var Ne=ve.value,Se=H(Ne),De;!(De=Se()).done;){var Le=De.value;M=M.concat(Z.walkTokens(Le.tokens,y))}break}case"list":{M=M.concat(Z.walkTokens(j.items,y));break}default:Z.defaults.extensions&&Z.defaults.extensions.childTokens&&Z.defaults.extensions.childTokens[j.type]?Z.defaults.extensions.childTokens[j.type].forEach(function(Te){M=M.concat(Z.walkTokens(j[Te],y))}):j.tokens&&(M=M.concat(Z.walkTokens(j.tokens,y)))}},I=H(E),C;!(C=I()).done;)k();return M},Z.parseInline=function(E,y){if(typeof E>"u"||E===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof E!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(E)+", string expected");y=B({},Z.defaults,y||{}),O(y);try{var M=Ae.lexInline(E,y);return y.walkTokens&&Z.walkTokens(M,y.walkTokens),ce.parseInline(M,y)}catch(k){if(k.message+=`
Please report this to https://github.com/markedjs/marked.`,y.silent)return"<p>An error occurred:</p><pre>"+e(k.message+"",!0)+"</pre>";throw k}},Z.Parser=ce,Z.parser=ce.parse,Z.Renderer=Pe,Z.TextRenderer=de,Z.Lexer=Ae,Z.lexer=Ae.lex,Z.Tokenizer=fe,Z.Slugger=ie,Z.parse=Z;var W=Z.options,Y=Z.setOptions,S=Z.use,q=Z.walkTokens,$=Z.parseInline,U=Z,Q=ce.parse,p=Ae.lex;ae.Lexer=Ae,ae.Parser=ce,ae.Renderer=Pe,ae.Slugger=ie,ae.TextRenderer=de,ae.Tokenizer=fe,ae.getDefaults=w,ae.lexer=p,ae.marked=Z,ae.options=W,ae.parse=U,ae.parseInline=$,ae.parser=Q,ae.setOptions=Y,ae.use=S,ae.walkTokens=q,Object.defineProperty(ae,"__esModule",{value:!0})}),define($e[80],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eS=void 0;class v{constructor(i,H=0,w=i.length,A=H-1){this.a=i,this.b=H,this.c=w,this.d=A}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$eS=v}),define($e[81],we([1,0,80]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gS=t.$fS=void 0;class T{constructor(w=[],A=10){this.h(w),this.b=A,this.d()}getHistory(){return this.j}add(w){this.a.delete(w),this.a.add(w),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(w){return this.a.has(w)}clear(){this.h([]),this.d()}d(){this.f();const w=this.j;this.c=new v.$eS(w,0,w.length,w.length)}f(){const w=this.j;w.length>this.b&&this.h(w.slice(w.length-this.b))}g(){const w=this.c.current();return w?this.j.indexOf(w):-1}h(w){this.a=new Set;for(const A of w)this.a.add(A)}get j(){const w=[];return this.a.forEach(A=>w.push(A)),w}}t.$fS=T;class i{get size(){return this.f}constructor(w,A=10){if(this.g=A,w.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:w[0],previous:void 0,next:void 0},this.a=new Set([w[0]]);for(let f=1;f<w.length;f++)this.add(w[f])}add(w){const A={value:w,previous:this.c,next:void 0};for(this.c.next=A,this.c=A,this.d=this.c,this.f++,this.a.has(w)?this.h(w):this.a.add(w);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(w){if(this.c.value===w)return w;const A=this.c.value;return this.a.delete(A),this.c.value=w,this.a.has(w)?this.h(w):this.a.add(w),A}prepend(w){if(this.f===this.g||this.a.has(w))return;const A={value:w,previous:void 0,next:this.b};this.b.previous=A,this.b=A,this.f++,this.a.add(w)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(w){return this.a.has(w)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let w=this.b;for(;w;)yield w.value,w=w.next}h(w){let A=this.b;for(;A!==this.c;)A.value===w&&(A===this.b?(this.b=this.b.next,this.b.previous=void 0):(A.previous.next=A.next,A.next.previous=A.previous),this.f--),A=A.next}}t.$gS=i}),define($e[46],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vl=t.$Ul=t.$Tl=t.rot=t.$Rl=void 0;function v(A,f,g){return Math.min(Math.max(A,f),g)}t.$Rl=v;function T(A,f){return(f+A%f)%f}t.rot=T;class i{constructor(){this.a=0}getNext(){return this.a++}}t.$Tl=i;class H{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Ul=H;class w{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const g=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Vl=w}),define($e[47],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var v;(function(T){function i(f,g){if(f.start>=g.end||g.start>=f.end)return{start:0,end:0};const c=Math.max(f.start,g.start),L=Math.min(f.end,g.end);return L-c<=0?{start:0,end:0}:{start:c,end:L}}T.intersect=i;function H(f){return f.end-f.start<=0}T.isEmpty=H;function w(f,g){return!H(i(f,g))}T.intersects=w;function A(f,g){const c=[],L={start:f.start,end:Math.min(g.start,f.end)},s={start:Math.max(g.end,f.start),end:f.end};return H(L)||c.push(L),H(s)||c.push(s),c}T.relativeComplement=A})(v||(t.Range=v={}))}),define($e[82],we([1,0,47]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0Q=t.$9Q=t.$8Q=t.$7Q=void 0;function T(f,g){const c=[];for(const L of g){if(f.start>=L.range.end)continue;if(f.end<L.range.start)break;const s=v.Range.intersect(f,L.range);v.Range.isEmpty(s)||c.push({range:s,size:L.size})}return c}t.$7Q=T;function i({start:f,end:g},c){return{start:f+c,end:g+c}}t.$8Q=i;function H(f){const g=[];let c=null;for(const L of f){const s=L.range.start,h=L.range.end,e=L.size;if(c&&e===c.size){c.range.end=h;continue}c={range:{start:s,end:h},size:e},g.push(c)}return g}t.$9Q=H;function w(...f){return H(f.reduce((g,c)=>g.concat(c),[]))}class A{get paddingTop(){return this.c}set paddingTop(g){this.b=this.b+g-this.c,this.c=g}constructor(g){this.a=[],this.b=0,this.c=0,this.c=g??0,this.b=this.c}splice(g,c,L=[]){const s=L.length-c,h=T({start:0,end:g},this.a),e=T({start:g+c,end:Number.POSITIVE_INFINITY},this.a).map(a=>({range:i(a.range,s),size:a.size})),o=L.map((a,m)=>({range:{start:g+m,end:g+m+1},size:a.size}));this.a=w(h,o,e),this.b=this.c+this.a.reduce((a,m)=>a+m.size*(m.range.end-m.range.start),0)}get count(){const g=this.a.length;return g?this.a[g-1].range.end:0}get size(){return this.b}indexAt(g){if(g<0)return-1;if(g<this.c)return 0;let c=0,L=this.c;for(const s of this.a){const h=s.range.end-s.range.start,e=L+h*s.size;if(g<e)return c+Math.floor((g-L)/s.size);c+=h,L=e}return c}indexAfter(g){return Math.min(this.indexAt(g)+1,this.count)}positionAt(g){if(g<0)return-1;let c=0,L=0;for(const s of this.a){const h=s.range.end-s.range.start,e=L+h;if(g<e)return this.c+c+(g-L)*s.size;c+=h*s.size,L=e}return-1}}t.$0Q=A}),define($e[83],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kd=void 0;const v=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(H){return new T(H)}constructor(H){this.c=v&&H===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Kd=T}),define($e[4],we([1,0,6,43,2,45,83]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.Event=void 0;const A=!1,f=!1;var g;(function(x){x.None=()=>i.$Rc.None;function P(I){if(f){const{onDidAddListener:C}=I,F=e.create();let j=0;I.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),F.print()),C?.()}}}function O(I,C){return Pe(I,()=>{},0,void 0,!0,void 0,C)}x.defer=O;function K(I){return(C,F=null,j)=>{let X=!1,ee;return ee=I(ne=>{if(!X)return ee?ee.dispose():X=!0,C.call(F,ne)},null,j),X&&ee.dispose(),ee}}x.once=K;function te(I,C,F){return Ce((j,X=null,ee)=>I(ne=>j.call(X,C(ne)),null,ee),F)}x.map=te;function se(I,C,F){return Ce((j,X=null,ee)=>I(ne=>{C(ne),j.call(X,ne)},null,ee),F)}x.forEach=se;function fe(I,C,F){return Ce((j,X=null,ee)=>I(ne=>C(ne)&&j.call(X,ne),null,ee),F)}x.filter=fe;function le(I){return I}x.signal=le;function oe(...I){return(C,F=null,j)=>{const X=(0,i.$Oc)(...I.map(ee=>ee(ne=>C.call(F,ne))));return Ae(X,j)}}x.any=oe;function be(I,C,F,j){let X=F;return te(I,ee=>(X=C(X,ee),X),j)}x.reduce=be;function Ce(I,C){let F;const j={onWillAddFirstListener(){F=I(X.fire,X)},onDidRemoveLastListener(){F?.dispose()}};C||P(j);const X=new r(j);return C?.add(X),X.event}function Ae(I,C){return C instanceof Array?C.push(I):C&&C.add(I),I}function Pe(I,C,F=100,j=!1,X=!1,ee,ne){let me,ve,Ne,Se=0,De;const Le={leakWarningThreshold:ee,onWillAddFirstListener(){me=I(We=>{Se++,ve=C(ve,We),j&&!Ne&&(Te.fire(ve),ve=void 0),De=()=>{const He=ve;ve=void 0,Ne=void 0,(!j||Se>1)&&Te.fire(He),Se=0},typeof F=="number"?(clearTimeout(Ne),Ne=setTimeout(De,F)):Ne===void 0&&(Ne=0,queueMicrotask(De))})},onWillRemoveListener(){X&&Se>0&&De?.()},onDidRemoveLastListener(){De=void 0,me.dispose()}};ne||P(Le);const Te=new r(Le);return ne?.add(Te),Te.event}x.debounce=Pe;function de(I,C=0,F){return x.debounce(I,(j,X)=>j?(j.push(X),j):[X],C,void 0,!0,void 0,F)}x.accumulate=de;function ie(I,C=(j,X)=>j===X,F){let j=!0,X;return fe(I,ee=>{const ne=j||!C(ee,X);return j=!1,X=ee,ne},F)}x.latch=ie;function ce(I,C,F){return[x.filter(I,C,F),x.filter(I,j=>!C(j),F)]}x.split=ce;function Z(I,C=!1,F=[],j){let X=F.slice(),ee=I(ve=>{X?X.push(ve):me.fire(ve)});j&&j.add(ee);const ne=()=>{X?.forEach(ve=>me.fire(ve)),X=null},me=new r({onWillAddFirstListener(){ee||(ee=I(ve=>me.fire(ve)),j&&j.add(ee))},onDidAddFirstListener(){X&&(C?setTimeout(ne):ne())},onDidRemoveLastListener(){ee&&ee.dispose(),ee=null}});return j&&j.add(me),me.event}x.buffer=Z;function W(I,C){return(j,X,ee)=>{const ne=C(new S);return I(function(me){const ve=ne.evaluate(me);ve!==Y&&j.call(X,ve)},void 0,ee)}}x.chain=W;const Y=Symbol("HaltChainable");class S{constructor(){this.f=[]}map(C){return this.f.push(C),this}forEach(C){return this.f.push(F=>(C(F),F)),this}filter(C){return this.f.push(F=>C(F)?F:Y),this}reduce(C,F){let j=F;return this.f.push(X=>(j=C(j,X),j)),this}latch(C=(F,j)=>F===j){let F=!0,j;return this.f.push(X=>{const ee=F||!C(X,j);return F=!1,j=X,ee?X:Y}),this}evaluate(C){for(const F of this.f)if(C=F(C),C===Y)break;return C}}function q(I,C,F=j=>j){const j=(...me)=>ne.fire(F(...me)),X=()=>I.on(C,j),ee=()=>I.removeListener(C,j),ne=new r({onWillAddFirstListener:X,onDidRemoveLastListener:ee});return ne.event}x.fromNodeEventEmitter=q;function $(I,C,F=j=>j){const j=(...me)=>ne.fire(F(...me)),X=()=>I.addEventListener(C,j),ee=()=>I.removeEventListener(C,j),ne=new r({onWillAddFirstListener:X,onDidRemoveLastListener:ee});return ne.event}x.fromDOMEventEmitter=$;function U(I){return new Promise(C=>K(I)(C))}x.toPromise=U;function Q(I){const C=new r;return I.then(F=>{C.fire(F)},()=>{C.fire(void 0)}).finally(()=>{C.dispose()}),C.event}x.fromPromise=Q;function p(I,C,F){return C(F),I(j=>C(j))}x.runAndSubscribe=p;function E(I,C){let F=null;function j(ee){F?.dispose(),F=new i.$Qc,C(ee,F)}j(void 0);const X=I(ee=>j(ee));return(0,i.$Pc)(()=>{X.dispose(),F?.dispose()})}x.runAndSubscribeWithStore=E;class y{constructor(C,F){this._observable=C,this.f=0,this.g=!1;const j={onWillAddFirstListener:()=>{C.addObserver(this)},onDidRemoveLastListener:()=>{C.removeObserver(this)}};F||P(j),this.emitter=new r(j),F&&F.add(this.emitter)}beginUpdate(C){this.f++}handlePossibleChange(C){}handleChange(C,F){this.g=!0}endUpdate(C){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function M(I,C){return new y(I,C).emitter.event}x.fromObservable=M;function k(I){return C=>{let F=0,j=!1;const X={beginUpdate(){F++},endUpdate(){F--,F===0&&(I.reportChanges(),j&&(j=!1,C()))},handlePossibleChange(){},handleChange(){j=!0}};return I.addObserver(X),I.reportChanges(),{dispose(){I.removeObserver(X)}}}}x.fromObservableLight=k})(g||(t.Event=g={}));class c{static{this.all=new Set}static{this.f=0}constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${c.f++}`,c.all.add(this)}start(P){this.g=new w.$Kd,this.listenerCount=P}stop(){if(this.g){const P=this.g.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this.g=void 0}}}t.$Md=c;let L=-1;function s(x){const P=L;return L=x,{dispose(){L=P}}}t.$Nd=s;class h{constructor(P,O=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=O,this.g=0}dispose(){this.f?.clear()}check(P,O){const K=this.threshold;if(K<=0||O<K)return;this.f||(this.f=new Map);const te=this.f.get(P.value)||0;if(this.f.set(P.value,te+1),this.g-=1,this.g<=0){this.g=K*.5;let se,fe=0;for(const[le,oe]of this.f)(!se||fe<oe)&&(se=le,fe=oe);console.warn(`[${this.name}] potential listener LEAK detected, having ${O} listeners already. MOST frequent listener (${fe}):`),console.warn(se)}return()=>{const se=this.f.get(P.value)||0;this.f.set(P.value,se-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let o=0;class a{constructor(P){this.value=P,this.id=o++}}const m=2,n=(x,P)=>{if(x instanceof a)P(x);else for(let O=0;O<x.length;O++){const K=x[O];K&&P(K)}};class r{constructor(P){this.w=0,this.f=P,this.g=L>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??L):void 0,this.j=this.f?._profName?new c(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(A){const P=this.t;queueMicrotask(()=>{n(P,O=>O.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(P,O,K)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$Rc.None;if(this.m)return i.$Rc.None;O&&(P=P.bind(O));const te=new a(P);let se,fe;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(te.stack=e.create(),se=this.g.check(te.stack,this.w+1)),A&&(te.stack=fe??e.create()),this.t?this.t instanceof a?(this.u??=new u,this.t=[this.t,te]):this.t.push(te):(this.f?.onWillAddFirstListener?.(this),this.t=te,this.f?.onDidAddFirstListener?.(this)),this.w++;const le=(0,i.$Pc)(()=>{se?.(),this.x(te)});return K instanceof i.$Qc?K.add(le):Array.isArray(K)&&K.push(le),le},this.q}x(P){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const O=this.t,K=O.indexOf(P);if(K===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,O[K]=void 0;const te=this.u.current===this;if(this.w*m<=O.length){let se=0;for(let fe=0;fe<O.length;fe++)O[fe]?O[se++]=O[fe]:te&&(this.u.end--,se<this.u.i&&this.u.i--);O.length=se}}y(P,O){if(!P)return;const K=this.f?.onListenerError||v.$Z;if(!K){P.value(O);return}try{P.value(O)}catch(te){K(te)}}z(P){const O=P.current.t;for(;P.i<P.end;)this.y(O[P.i++],P.value);P.reset()}fire(P){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof a)this.y(this.t,P);else{const O=this.u;O.enqueue(this,P,this.t.length),this.z(O)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Od=r;const b=()=>new u;t.$Pd=b;class u{constructor(){this.i=-1,this.end=0}enqueue(P,O,K){this.i=0,this.end=K,this.current=P,this.value=O}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class l extends r{async fireAsync(P,O,K){if(this.t)for(this.h||(this.h=new H.$1c),n(this.t,te=>this.h.push([te.value,P]));this.h.size>0&&!O.isCancellationRequested;){const[te,se]=this.h.shift(),fe=[],le={...se,token:O,waitUntil:oe=>{if(Object.isFrozen(fe))throw new Error("waitUntil can NOT be called asynchronous");K&&(oe=K(oe,te)),fe.push(oe)}};try{te(le)}catch(oe){(0,v.$Z)(oe);continue}Object.freeze(fe),await Promise.allSettled(fe).then(oe=>{for(const be of oe)be.status==="rejected"&&(0,v.$Z)(be.reason)})}}}t.$Qd=l;class N extends r{get isPaused(){return this.h!==0}constructor(P){super(P),this.h=0,this.s=new H.$1c,this.A=P?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const P=Array.from(this.s);this.s.clear(),super.fire(this.A(P))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(P){this.w&&(this.h!==0?this.s.push(P):super.fire(P))}}t.$Rd=N;class z extends N{constructor(P){super(P),this.k=P.delay??100}fire(P){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(P)}}t.$Sd=z;class R extends r{constructor(P){super(P),this.h=[],this.k=P?.merge}fire(P){this.hasListeners()&&(this.h.push(P),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(O=>super.fire(O)),this.h=[]}))}}t.$Td=R;class d{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(P){const O={event:P,listener:null};this.h.push(O),this.g&&this.m(O);const K=()=>{this.g&&this.o(O);const te=this.h.indexOf(O);this.h.splice(te,1)};return(0,i.$Pc)((0,T.$cb)(K))}j(){this.g=!0,this.h.forEach(P=>this.m(P))}k(){this.g=!1,this.h.forEach(P=>this.o(P))}m(P){P.listener=P.event(O=>this.f.fire(O))}o(P){P.listener&&P.listener.dispose(),P.listener=null}dispose(){this.f.dispose()}}t.$Ud=d;class D{constructor(P,O,K,te){this.f=new i.$Qc;const se=this.f.add(new d),fe=this.f.add(new i.$Zc);function le(oe){fe.set(oe,se.add(te(oe)))}for(const oe of P)le(oe);this.f.add(O(oe=>{le(oe)})),this.f.add(K(oe=>{fe.deleteAndDispose(oe)})),this.event=se.event}dispose(){this.f.dispose()}}t.$Vd=D;class B{constructor(){this.f=[]}wrapEvent(P){return(O,K,te)=>P(se=>{const fe=this.f[this.f.length-1];fe?fe.push(()=>O.call(K,se)):O.call(K,se)},void 0,te)}bufferEvents(P){const O=[];this.f.push(O);const K=P();return this.f.pop(),O.forEach(te=>te()),K}}t.$Wd=B;class _{constructor(){this.f=!1,this.g=g.None,this.h=i.$Rc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(P){this.g=P,this.f&&(this.h.dispose(),this.h=P(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$Xd=_}),define($e[17],we([1,0,14,4,2]),function(ae,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LO=t.$KO=t.$JO=t.$IO=t.$HO=t.$GO=t.$FO=t.$EO=t.$DO=t.$CO=t.$BO=t.$AO=t.$zO=t.$yO=t.$xO=t.$wO=t.$vO=t.$uO=void 0;class H{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new T.$Od,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new H}getZoomLevel(){return this.a}setZoomLevel(u){this.a!==u&&(this.a=u)}getZoomFactor(){return this.b}setZoomFactor(u){this.b=u}setFullscreen(u){this.c!==u&&(this.c=u,this.d.fire())}isFullscreen(){return this.c}}class w extends i.$Rc{constructor(){super(),this.a=this.B(new T.$Od),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(u){this.c?.removeEventListener("change",this.b),this.c=v.$window.matchMedia(`(resolution: ${v.$window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),u&&this.a.fire()}}class A extends i.$Rc{get value(){return this.b}constructor(){super(),this.a=this.B(new T.$Od),this.onDidChange=this.a.event,this.b=this.c();const u=this.B(new w);this.B(u.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const u=document.createElement("canvas").getContext("2d"),l=v.$window.devicePixelRatio||1,N=u.webkitBackingStorePixelRatio||u.mozBackingStorePixelRatio||u.msBackingStorePixelRatio||u.oBackingStorePixelRatio||u.backingStorePixelRatio||1;return l/N}}class f{constructor(){this.a=null}b(){return this.a||(this.a=(0,i.$Kc)(new A)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function g(b,u){typeof b=="string"&&(b=v.$window.matchMedia(b)),b.addEventListener("change",u)}t.$uO=g,t.$vO=new f;function c(b){H.INSTANCE.setZoomLevel(b)}t.$wO=c;function L(){return H.INSTANCE.getZoomLevel()}t.$xO=L;function s(){return H.INSTANCE.getZoomFactor()}t.$yO=s;function h(b){H.INSTANCE.setZoomFactor(b)}t.$zO=h;function e(b){H.INSTANCE.setFullscreen(b)}t.$AO=e;function o(){return H.INSTANCE.isFullscreen()}t.$BO=o,t.$CO=H.INSTANCE.onDidChangeFullscreen;const a=navigator.userAgent;t.$DO=a.indexOf("Firefox")>=0,t.$EO=a.indexOf("AppleWebKit")>=0,t.$FO=a.indexOf("Chrome")>=0,t.$GO=!t.$FO&&a.indexOf("Safari")>=0,t.$HO=!t.$FO&&!t.$GO&&t.$EO,t.$IO=a.indexOf("Electron/")>=0,t.$JO=a.indexOf("Android")>=0;let m=!1;if(v.$window.matchMedia){const b=v.$window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),u=v.$window.matchMedia("(display-mode: fullscreen)");m=b.matches,g(b,({matches:l})=>{m&&u.matches||(m=l)})}function n(){return m}t.$KO=n;function r(){return navigator?.windowControlsOverlay?.visible}t.$LO=r}),define($e[22],we([1,0,4]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YQ=void 0;class T{get event(){return this.a.event}constructor(H,w,A){const f=g=>this.a.fire(g);this.a=new v.$Od({onWillAddFirstListener:()=>H.addEventListener(w,f,A),onDidRemoveLastListener:()=>H.removeEventListener(w,f,A)})}dispose(){this.a.dispose()}}t.$YQ=T}),define($e[29],we([1,0,4]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yd=t.CancellationToken=void 0;const T=Object.freeze(function(A,f){const g=setTimeout(A.bind(f),0);return{dispose(){clearTimeout(g)}}});var i;(function(A){function f(g){return g===A.None||g===A.Cancelled||g instanceof H?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}A.isCancellationToken=f,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(i||(t.CancellationToken=i={}));class H{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new v.$Od),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class w{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new H),this.f}cancel(){this.f?this.f instanceof H&&this.f.cancel():this.f=i.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof H&&this.f.dispose():this.f=i.None}}t.$Yd=w}),define($e[84],we([1,0,29]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=t.$ye=t.$xe=void 0;class T{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new v.$Yd,f=this.b(A.token);return this.a={promise:f,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}t.$xe=T;class i{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const f=JSON.stringify(A);return this.b!==f&&(this.b=f,this.a=this.c(A)),this.a}}t.$ye=i;class H{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const f=this.b(A);return this.a.set(A,f),f}}t.$ze=H}),define($e[48],we([1,0,4,2]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1r=t.$Zr=t.$Yr=t.$Xr=t.ScrollbarVisibility=void 0;var i;(function(h){h[h.Auto=1]="Auto",h[h.Hidden=2]="Hidden",h[h.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class H{constructor(e,o,a,m,n,r,b){this.c=e,this._scrollStateBrand=void 0,this.c&&(o=o|0,a=a|0,m=m|0,n=n|0,r=r|0,b=b|0),this.rawScrollLeft=m,this.rawScrollTop=b,o<0&&(o=0),m+o>a&&(m=a-o),m<0&&(m=0),n<0&&(n=0),b+n>r&&(b=r-n),b<0&&(b=0),this.width=o,this.scrollWidth=a,this.scrollLeft=m,this.height=n,this.scrollHeight=r,this.scrollTop=b}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,o){return new H(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,o?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,o?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new H(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,o){const a=this.width!==e.width,m=this.scrollWidth!==e.scrollWidth,n=this.scrollLeft!==e.scrollLeft,r=this.height!==e.height,b=this.scrollHeight!==e.scrollHeight,u=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:o,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:a,scrollWidthChanged:m,scrollLeftChanged:n,heightChanged:r,scrollHeightChanged:b,scrollTopChanged:u}}}t.$Xr=H;class w extends T.$Rc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$Od),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new H(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,o){const a=this.g.withScrollDimensions(e,o);this.n(a,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const o=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(o,!1)}setScrollPositionSmooth(e,o){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const a=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===a.scrollLeft&&this.h.to.scrollTop===a.scrollTop)return;let m;o?m=new c(this.h.from,a,this.h.startTime,this.h.duration):m=this.h.combine(this.g,a,this.c),this.h.dispose(),this.h=m}else{const a=this.g.withScrollPosition(e);this.h=c.start(this.g,a,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),o=this.g.withScrollPosition(e);if(this.n(o,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,o){const a=this.g;a.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(a,o)))}}t.$Yr=w;class A{constructor(e,o,a){this.scrollLeft=e,this.scrollTop=o,this.isDone=a}}t.$Zr=A;function f(h,e){const o=e-h;return function(a){return h+o*s(a)}}function g(h,e,o){return function(a){return a<o?h(a/o):e((a-o)/(1-o))}}class c{constructor(e,o,a,m){this.from=e,this.to=o,this.duration=m,this.startTime=a,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,o,a){if(Math.abs(e-o)>2.5*a){let n,r;return e<o?(n=e+.75*a,r=o-.75*a):(n=e-.75*a,r=o+.75*a),g(f(e,n),f(r,o),.33)}return f(e,o)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const o=(e-this.startTime)/this.duration;if(o<1){const a=this.c(o),m=this.d(o);return new A(a,m,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,o,a){return c.start(e,o,a)}static start(e,o,a){a=a+10;const m=Date.now()-10;return new c(e,o,m,a)}}t.$1r=c;function L(h){return Math.pow(h,3)}function s(h){return 1-L(1-h)}}),define($e[85],we([1,0,6,2]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=void 0;function i(b){const u=b;return u?typeof u.read=="function":!1}t.$Zd=i;function H(b){const u=b;return u?[u.on,u.pause,u.resume,u.destroy].every(l=>typeof l=="function"):!1}t.$1d=H;function w(b){const u=b;return u?H(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}t.$2d=w;function A(b,u){return new f(b,u)}t.$3d=A;class f{constructor(u,l){this.e=u,this.f=l,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(l=>this.d.push(l))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(l=>l(u))}h(u){this.c.error.length===0?(0,v.$Z)(u):this.c.error.slice(0).forEach(l=>l(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,l){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(l),this.resume();break;case"end":this.c.end.push(l),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(l),this.a.flowing&&this.k();break}}removeListener(u,l){if(this.a.destroyed)return;let N;switch(u){case"data":N=this.c.data;break;case"end":N=this.c.end;break;case"error":N=this.c.error;break}if(N){const z=N.indexOf(l);z>=0&&N.splice(z,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const l=[...this.d];this.d.length=0,l.forEach(N=>N())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(b,u){const l=[];let N;for(;(N=b.read())!==null;)l.push(N);return u(l)}t.$4d=g;function c(b,u,l){const N=[];let z;for(;(z=b.read())!==null&&N.length<l;)N.push(z);return z===null&&N.length>0?u(N):{read:()=>{if(N.length>0)return N.shift();if(typeof z<"u"){const R=z;return z=void 0,R}return b.read()}}}t.$5d=c;function L(b,u){return new Promise((l,N)=>{const z=[];s(b,{onData:R=>{u&&z.push(R)},onError:R=>{u?N(R):l(void 0)},onEnd:()=>{l(u?u(z):void 0)}})})}t.$6d=L;function s(b,u,l){b.on("error",N=>{l?.isCancellationRequested||u.onError(N)}),b.on("end",()=>{l?.isCancellationRequested||u.onEnd()}),b.on("data",N=>{l?.isCancellationRequested||u.onData(N)})}t.$7d=s;function h(b,u){return new Promise((l,N)=>{const z=new T.$Qc,R=[],d=_=>{if(R.push(_),R.length>u)return z.dispose(),b.pause(),l({stream:b,buffer:R,ended:!1})},D=_=>(z.dispose(),N(_)),B=()=>(z.dispose(),l({stream:b,buffer:R,ended:!0}));z.add((0,T.$Pc)(()=>b.removeListener("error",D))),b.on("error",D),z.add((0,T.$Pc)(()=>b.removeListener("end",B))),b.on("end",B),z.add((0,T.$Pc)(()=>b.removeListener("data",d))),b.on("data",d)})}t.$8d=h;function e(b,u){const l=A(u);return l.end(b),l}t.$9d=e;function o(){const b=A(()=>{throw new Error("not supported")});return b.end(),b}t.$0d=o;function a(b){let u=!1;return{read:()=>u?null:(u=!0,b)}}t.$$d=a;function m(b,u,l){const N=A(l);return s(b,{onData:z=>N.write(u.data(z)),onError:z=>N.error(u.error?u.error(z):z),onEnd:()=>N.end()}),N}t.$_d=m;function n(b,u,l){let N=!1;return{read:()=>{const z=u.read();return N?z:(N=!0,z!==null?l([b,z]):b)}}}t.$ae=n;function r(b,u,l){let N=!1;const z=A(l);return s(u,{onData:R=>N?z.write(R):(N=!0,z.write(l([b,R]))),onError:R=>z.error(R),onEnd:()=>{N||(N=!0,z.write(b)),z.end()}}),z}t.$be=r}),define($e[33],we([1,0,28,85]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=void 0;const i=typeof Buffer<"u",H=new v.$U(()=>new Uint8Array(256));let w,A;class f{static alloc(O){return i?new f(Buffer.allocUnsafe(O)):new f(new Uint8Array(O))}static wrap(O){return i&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new f(O)}static fromString(O,K){return!(K?.dontUseNodeBuffer||!1)&&i?new f(Buffer.from(O)):(w||(w=new TextEncoder),new f(w.encode(O)))}static fromByteArray(O){const K=f.alloc(O.length);for(let te=0,se=O.length;te<se;te++)K.buffer[te]=O[te];return K}static concat(O,K){if(typeof K>"u"){K=0;for(let fe=0,le=O.length;fe<le;fe++)K+=O[fe].byteLength}const te=f.alloc(K);let se=0;for(let fe=0,le=O.length;fe<le;fe++){const oe=O[fe];te.set(oe,se),se+=oe.byteLength}return te}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=f.alloc(this.byteLength);return O.set(this),O}toString(){return i?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(O,K){return new f(this.buffer.subarray(O,K))}set(O,K){if(O instanceof f)this.buffer.set(O.buffer,K);else if(O instanceof Uint8Array)this.buffer.set(O,K);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),K);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),K);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return s(this.buffer,O)}writeUInt32BE(O,K){h(this.buffer,O,K)}readUInt32LE(O){return e(this.buffer,O)}writeUInt32LE(O,K){o(this.buffer,O,K)}readUInt8(O){return a(this.buffer,O)}writeUInt8(O,K){m(this.buffer,O,K)}indexOf(O,K=0){return g(this.buffer,O instanceof f?O.buffer:O,K)}}t.$ce=f;function g(P,O,K=0){const te=O.byteLength,se=P.byteLength;if(te===0)return 0;if(te===1)return P.indexOf(O[0]);if(te>se-K)return-1;const fe=H.value;fe.fill(O.length);for(let Ce=0;Ce<O.length;Ce++)fe[O[Ce]]=O.length-Ce-1;let le=K+O.length-1,oe=le,be=-1;for(;le<se;)if(P[le]===O[oe]){if(oe===0){be=le;break}le--,oe--}else le+=Math.max(O.length-oe,fe[P[le]]),oe=O.length-1;return be}t.$de=g;function c(P,O){return P[O+0]<<0>>>0|P[O+1]<<8>>>0}t.$ee=c;function L(P,O,K){P[K+0]=O&255,O=O>>>8,P[K+1]=O&255}t.$fe=L;function s(P,O){return P[O]*2**24+P[O+1]*2**16+P[O+2]*2**8+P[O+3]}t.$ge=s;function h(P,O,K){P[K+3]=O,O=O>>>8,P[K+2]=O,O=O>>>8,P[K+1]=O,O=O>>>8,P[K]=O}t.$he=h;function e(P,O){return P[O+0]<<0>>>0|P[O+1]<<8>>>0|P[O+2]<<16>>>0|P[O+3]<<24>>>0}t.$ie=e;function o(P,O,K){P[K+0]=O&255,O=O>>>8,P[K+1]=O&255,O=O>>>8,P[K+2]=O&255,O=O>>>8,P[K+3]=O&255}t.$je=o;function a(P,O){return P[O]}t.$ke=a;function m(P,O,K){P[K]=O}t.$le=m;function n(P){return T.$4d(P,O=>f.concat(O))}t.$me=n;function r(P){return T.$$d(P)}t.$ne=r;function b(P){return T.$6d(P,O=>f.concat(O))}t.$oe=b;async function u(P){return P.ended?f.concat(P.buffer):f.concat([...P.buffer,await b(P.stream)])}t.$pe=u;function l(P){return T.$9d(P,O=>f.concat(O))}t.$qe=l;function N(P){return T.$_d(P,{data:O=>typeof O=="string"?f.fromString(O):f.wrap(O)},O=>f.concat(O))}t.$re=N;function z(P){return T.$3d(O=>f.concat(O),P)}t.$se=z;function R(P,O){return T.$ae(P,O,K=>f.concat(K))}t.$te=R;function d(P,O){return T.$be(P,O,K=>f.concat(K))}t.$ue=d;function D(P){let O=0,K=0,te=0;const se=new Uint8Array(Math.floor(P.length/4*3)),fe=oe=>{switch(K){case 3:se[te++]=O|oe,K=0;break;case 2:se[te++]=O|oe>>>2,O=oe<<6,K=3;break;case 1:se[te++]=O|oe>>>4,O=oe<<4,K=2;break;default:O=oe<<2,K=1}};for(let oe=0;oe<P.length;oe++){const be=P.charCodeAt(oe);if(be>=65&&be<=90)fe(be-65);else if(be>=97&&be<=122)fe(be-97+26);else if(be>=48&&be<=57)fe(be-48+52);else if(be===43||be===45)fe(62);else if(be===47||be===95)fe(63);else{if(be===61)break;throw new SyntaxError(`Unexpected base64 character ${P[oe]}`)}}const le=te;for(;K>0;)fe(0);return f.wrap(se).slice(0,le)}t.$ve=D;const B="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",_="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function x({buffer:P},O=!0,K=!1){const te=K?_:B;let se="";const fe=P.byteLength%3;let le=0;for(;le<P.byteLength-fe;le+=3){const oe=P[le+0],be=P[le+1],Ce=P[le+2];se+=te[oe>>>2],se+=te[(oe<<4|be>>>4)&63],se+=te[(be<<2|Ce>>>6)&63],se+=te[Ce&63]}if(fe===1){const oe=P[le+0];se+=te[oe>>>2],se+=te[oe<<4&63],O&&(se+="==")}else if(fe===2){const oe=P[le+0],be=P[le+1];se+=te[oe>>>2],se+=te[(oe<<4|be>>>4)&63],se+=te[be<<2&63],O&&(se+="=")}return se}t.$we=x}),define($e[12],we([1,0,84,28]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yf=t.$xf=t.$wf=t.$vf=t.GraphemeBreakType=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=void 0;function i(J){return!J||typeof J!="string"?!0:J.trim().length===0}t.$Ce=i;const H=/{(\d+)}/g;function w(J,...he){return he.length===0?J:J.replace(H,function(pe,Ee){const Fe=parseInt(Ee,10);return isNaN(Fe)||Fe<0||Fe>=he.length?pe:he[Fe]})}t.$De=w;const A=/{([^}]+)}/g;function f(J,he){return Object.keys(he).length===0?J:J.replace(A,(pe,Ee)=>he[Ee]??pe)}t.$Ee=f;function g(J){return J.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}t.$Fe=g;function c(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Ge=c;function L(J,he){let pe=0;const Ee=he.charCodeAt(0);for(let Fe=J.length-1;Fe>=0;Fe--)J.charCodeAt(Fe)===Ee&&pe++;return pe}t.$He=L;function s(J,he,pe="\u2026"){return J.length<=he?J:`${J.substr(0,he)}${pe}`}t.$Ie=s;function h(J,he=" "){const pe=e(J,he);return o(pe,he)}t.$Je=h;function e(J,he){if(!J||!he)return J;const pe=he.length;if(pe===0||J.length===0)return J;let Ee=0;for(;J.indexOf(he,Ee)===Ee;)Ee=Ee+pe;return J.substring(Ee)}t.$Ke=e;function o(J,he){if(!J||!he)return J;const pe=he.length,Ee=J.length;if(pe===0||Ee===0)return J;let Fe=Ee,Be=-1;for(;Be=J.lastIndexOf(he,Fe-1),!(Be===-1||Be+pe!==Fe);){if(Be===0)return"";Fe=Be}return J.substring(0,Fe)}t.$Le=o;function a(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Me=a;function m(J){return J.replace(/\*/g,"")}t.$Ne=m;function n(J,he,pe={}){if(!J)throw new Error("Cannot create regex from empty string");he||(J=c(J)),pe.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let Ee="";return pe.global&&(Ee+="g"),pe.matchCase||(Ee+="i"),pe.multiline&&(Ee+="m"),pe.unicode&&(Ee+="u"),new RegExp(J,Ee)}t.$Oe=n;function r(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}t.$Pe=r;function b(J){return J.split(/\r\n|\r|\n/)}t.$Qe=b;function u(J){for(let he=0,pe=J.length;he<pe;he++){const Ee=J.charCodeAt(he);if(Ee!==32&&Ee!==9)return he}return-1}t.$Re=u;function l(J,he=0,pe=J.length){for(let Ee=he;Ee<pe;Ee++){const Fe=J.charCodeAt(Ee);if(Fe!==32&&Fe!==9)return J.substring(he,Ee)}return J.substring(he,pe)}t.$Se=l;function N(J,he=J.length-1){for(let pe=he;pe>=0;pe--){const Ee=J.charCodeAt(pe);if(Ee!==32&&Ee!==9)return pe}return-1}t.$Te=N;function z(J,he,pe){const Ee=[];let Fe=0;for(const Be of J.matchAll(he)){if(Ee.push(J.slice(Fe,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");Fe=Be.index+Be[0].length,Ee.push(pe(Be[0],...Be.slice(1),Be.index,J,Be.groups))}return Ee.push(J.slice(Fe)),Promise.all(Ee).then(Be=>Be.join(""))}t.$Ue=z;function R(J,he){return J<he?-1:J>he?1:0}t.$Ve=R;function d(J,he,pe=0,Ee=J.length,Fe=0,Be=he.length){for(;pe<Ee&&Fe<Be;pe++,Fe++){const Je=J.charCodeAt(pe),Ke=he.charCodeAt(Fe);if(Je<Ke)return-1;if(Je>Ke)return 1}const Ue=Ee-pe,Ze=Be-Fe;return Ue<Ze?-1:Ue>Ze?1:0}t.$We=d;function D(J,he){return B(J,he,0,J.length,0,he.length)}t.$Xe=D;function B(J,he,pe=0,Ee=J.length,Fe=0,Be=he.length){for(;pe<Ee&&Fe<Be;pe++,Fe++){let Je=J.charCodeAt(pe),Ke=he.charCodeAt(Fe);if(Je===Ke)continue;if(Je>=128||Ke>=128)return d(J.toLowerCase(),he.toLowerCase(),pe,Ee,Fe,Be);x(Je)&&(Je-=32),x(Ke)&&(Ke-=32);const _e=Je-Ke;if(_e!==0)return _e}const Ue=Ee-pe,Ze=Be-Fe;return Ue<Ze?-1:Ue>Ze?1:0}t.$Ye=B;function _(J){return J>=48&&J<=57}t.$Ze=_;function x(J){return J>=97&&J<=122}t.$1e=x;function P(J){return J>=65&&J<=90}t.$2e=P;function O(J,he){return J.length===he.length&&B(J,he)===0}t.$3e=O;function K(J,he){const pe=he.length;return he.length>J.length?!1:B(J,he,0,pe)===0}t.$4e=K;function te(J,he){const pe=Math.min(J.length,he.length);let Ee;for(Ee=0;Ee<pe;Ee++)if(J.charCodeAt(Ee)!==he.charCodeAt(Ee))return Ee;return pe}t.$5e=te;function se(J,he){const pe=Math.min(J.length,he.length);let Ee;const Fe=J.length-1,Be=he.length-1;for(Ee=0;Ee<pe;Ee++)if(J.charCodeAt(Fe-Ee)!==he.charCodeAt(Be-Ee))return Ee;return pe}t.$6e=se;function fe(J){return 55296<=J&&J<=56319}t.$7e=fe;function le(J){return 56320<=J&&J<=57343}t.$8e=le;function oe(J,he){return(J-55296<<10)+(he-56320)+65536}t.$9e=oe;function be(J,he,pe){const Ee=J.charCodeAt(pe);if(fe(Ee)&&pe+1<he){const Fe=J.charCodeAt(pe+1);if(le(Fe))return oe(Ee,Fe)}return Ee}t.$0e=be;function Ce(J,he){const pe=J.charCodeAt(he-1);if(le(pe)&&he>1){const Ee=J.charCodeAt(he-2);if(fe(Ee))return oe(Ee,pe)}return pe}class Ae{get offset(){return this.e}constructor(he,pe=0){this.c=he,this.d=he.length,this.e=pe}setOffset(he){this.e=he}prevCodePoint(){const he=Ce(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=be(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}t.$$e=Ae;class Pe{get offset(){return this.c.offset}constructor(he,pe=0){this.c=new Ae(he,pe)}nextGraphemeLength(){const he=Se.getInstance(),pe=this.c,Ee=pe.offset;let Fe=he.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Be=pe.offset,Ue=he.getGraphemeBreakType(pe.nextCodePoint());if(ve(Fe,Ue)){pe.setOffset(Be);break}Fe=Ue}return pe.offset-Ee}prevGraphemeLength(){const he=Se.getInstance(),pe=this.c,Ee=pe.offset;let Fe=he.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Be=pe.offset,Ue=he.getGraphemeBreakType(pe.prevCodePoint());if(ve(Ue,Fe)){pe.setOffset(Be);break}Fe=Ue}return Ee-pe.offset}eol(){return this.c.eol()}}t.$_e=Pe;function de(J,he){return new Pe(J,he).nextGraphemeLength()}t.$af=de;function ie(J,he){return new Pe(J,he).prevGraphemeLength()}t.$bf=ie;function ce(J,he){he>0&&le(J.charCodeAt(he))&&he--;const pe=he+de(J,he);return[pe-ie(J,pe),pe]}t.$cf=ce;function Z(J){const he=new Pe(J);let pe=0;for(;!he.eol();)pe++,he.nextGraphemeLength();return pe}t.$df=Z;let W;function Y(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function S(J){return W||(W=Y()),W.test(J)}t.$ef=S;const q=/^[\t\n\r\x20-\x7E]*$/;function $(J){return q.test(J)}t.$ff=$,t.$gf=/[\u2028\u2029]/;function U(J){return t.$gf.test(J)}t.$hf=U;function Q(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}t.$if=Q;function p(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}t.$jf=p;function E(J,he){if(J.length<he)return J;const pe=/\b/g;let Ee=0;for(;pe.test(J)&&!(J.length-pe.lastIndex<he);)Ee=pe.lastIndex,pe.lastIndex+=1;return J.substring(Ee).replace(/^\s/,"")}t.$kf=E;const y=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,M=/\x1b\].*?\x07/g;function k(J){return J&&(J=J.replace(y,"").replace(M,"")),J}t.$lf=k,t.$mf=String.fromCharCode(65279);function I(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}t.$nf=I;function C(J){return I(J)?J.substr(1):J}t.$of=C;function F(J,he){if(!J||!he||J.length<he.length)return!1;const pe=he.length,Ee=J.toLowerCase();let Fe=0,Be=-1;for(;Fe<pe;){const Ue=Ee.indexOf(he[Fe],Be+1);if(Ue<0)return!1;Be=Ue,Fe++}return!0}t.$pf=F;function j(J,he=!1){return J?(he&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}t.$qf=j;function X(J){return J.charAt(0).toUpperCase()+J.slice(1)}t.$rf=X;function ee(J,he=1){if(he===0)return"";let pe=-1;do pe=J.indexOf(`
`,pe+1),he--;while(he>0&&pe>=0);return pe===-1?J:(J[pe-1]==="\r"&&pe--,J.substr(0,pe))}t.$sf=ee;function ne(J){return J=J%(2*26),J<26?String.fromCharCode(97+J):String.fromCharCode(65+J-26)}t.$tf=ne;function me(J){return Se.getInstance().getGraphemeBreakType(J)}t.$uf=me;function ve(J,he){return J===0?he!==5&&he!==7:J===2&&he===3?!1:J===4||J===2||J===3||he===4||he===2||he===3?!0:!(J===8&&(he===8||he===9||he===11||he===12)||(J===11||J===9)&&(he===9||he===10)||(J===12||J===10)&&he===10||he===5||he===13||he===7||J===1||J===13&&he===14||J===6&&he===6)}var Ne;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(Ne||(t.GraphemeBreakType=Ne={}));class Se{static{this.c=null}static getInstance(){return Se.c||(Se.c=new Se),Se.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const pe=this.d,Ee=pe.length/3;let Fe=1;for(;Fe<=Ee;)if(he<pe[3*Fe])Fe=2*Fe;else if(he>pe[3*Fe+1])Fe=2*Fe+1;else return pe[3*Fe+2];return 0}}function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Le(J,he){if(J===0)return 0;const pe=Te(J,he);if(pe!==void 0)return pe;const Ee=new Ae(he,J);return Ee.prevCodePoint(),Ee.offset}t.$vf=Le;function Te(J,he){const pe=new Ae(he,J);let Ee=pe.prevCodePoint();for(;We(Ee)||Ee===65039||Ee===8419;){if(pe.offset===0)return;Ee=pe.prevCodePoint()}if(!p(Ee))return;let Fe=pe.offset;return Fe>0&&pe.prevCodePoint()===8205&&(Fe=pe.offset),Fe}function We(J){return 127995<=J&&J<=127999}var He;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),t.$wf="\xA0";class Me{static{this.c=new T.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new v.$ye(he=>{function pe(_e){const tt=new Map;for(let nt=0;nt<_e.length;nt+=2)tt.set(_e[nt],_e[nt+1]);return tt}function Ee(_e,tt){const nt=new Map(_e);for(const[dt,ft]of tt)nt.set(dt,ft);return nt}function Fe(_e,tt){if(!_e)return tt;const nt=new Map;for(const[dt,ft]of _e)tt.has(dt)&&nt.set(dt,ft);return nt}const Be=this.c.value;let Ue=he.filter(_e=>!_e.startsWith("_")&&_e in Be);Ue.length===0&&(Ue=["_default"]);let Ze;for(const _e of Ue){const tt=pe(Be[_e]);Ze=Fe(Ze,tt)}const Je=pe(Be._common),Ke=Ee(Je,Ze);return new Me(Ke)})}static getInstance(he){return Me.d.get(Array.from(he))}static{this.e=new T.$U(()=>Object.keys(Me.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return Me.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$xf=Me;class Ye{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ye.c())),this.d}static isInvisibleCharacter(he){return Ye.e().has(he)}static get codePoints(){return Ye.e()}}t.$yf=Ye}),define($e[34],we([1,0,32,12]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uj=t.$Tj=t.$Sj=t.$Rj=t.FuzzyScore=t.$Qj=t.$Pj=t.$Oj=t.$Nj=t.$Mj=t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.$Gj=t.$Fj=t.or=void 0;function i(...C){return function(F,j){for(let X=0,ee=C.length;X<ee;X++){const ne=C[X](F,j);if(ne)return ne}return null}}t.or=i,t.$Fj=H.bind(void 0,!1),t.$Gj=H.bind(void 0,!0);function H(C,F,j){if(!j||j.length<F.length)return null;let X;return C?X=T.$4e(j,F):X=j.indexOf(F)===0,X?F.length>0?[{start:0,end:F.length}]:[]:null}function w(C,F){const j=F.toLowerCase().indexOf(C.toLowerCase());return j===-1?null:[{start:j,end:j+C.length}]}t.$Hj=w;function A(C,F){return f(C.toLowerCase(),F.toLowerCase(),0,0)}t.$Ij=A;function f(C,F,j,X){if(j===C.length)return[];if(X===F.length)return null;if(C[j]===F[X]){let ee=null;return(ee=f(C,F,j+1,X+1))?m({start:X,end:X+1},ee):null}return f(C,F,j,X+1)}function g(C){return 97<=C&&C<=122}function c(C){return 65<=C&&C<=90}t.$Jj=c;function L(C){return 48<=C&&C<=57}function s(C){return C===32||C===9||C===10||C===13}const h=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(C=>h.add(C.charCodeAt(0)));function e(C){return s(C)||h.has(C)}function o(C,F){return C===F||e(C)&&e(F)}function a(C){return g(C)||c(C)||L(C)}function m(C,F){return F.length===0?F=[C]:C.end===F[0].start?F[0].start=C.start:F.unshift(C),F}function n(C,F){for(let j=F;j<C.length;j++){const X=C.charCodeAt(j);if(c(X)||L(X)||j>0&&!a(C.charCodeAt(j-1)))return j}return C.length}function r(C,F,j,X){if(j===C.length)return[];if(X===F.length)return null;if(C[j]!==F[X].toLowerCase())return null;{let ee=null,ne=X+1;for(ee=r(C,F,j+1,X+1);!ee&&(ne=n(F,ne))<F.length;)ee=r(C,F,j+1,ne),ne++;return ee===null?null:m({start:X,end:X+1},ee)}}function b(C){let F=0,j=0,X=0,ee=0,ne=0;for(let De=0;De<C.length;De++)ne=C.charCodeAt(De),c(ne)&&F++,g(ne)&&j++,a(ne)&&X++,L(ne)&&ee++;const me=F/C.length,ve=j/C.length,Ne=X/C.length,Se=ee/C.length;return{upperPercent:me,lowerPercent:ve,alphaPercent:Ne,numericPercent:Se}}function u(C){const{upperPercent:F,lowerPercent:j}=C;return j===0&&F>.6}function l(C){const{upperPercent:F,lowerPercent:j,alphaPercent:X,numericPercent:ee}=C;return j>.2&&F<.8&&X>.6&&ee<.2}function N(C){let F=0,j=0,X=0,ee=0;for(let ne=0;ne<C.length;ne++)X=C.charCodeAt(ne),c(X)&&F++,g(X)&&j++,s(X)&&ee++;return(F===0||j===0)&&ee===0?C.length<=30:F<=5}function z(C,F){if(!F||(F=F.trim(),F.length===0)||!N(C)||F.length>60)return null;const j=b(F);if(!l(j)){if(!u(j))return null;F=F.toLowerCase()}let X=null,ee=0;for(C=C.toLowerCase();ee<F.length&&(X=r(C,F,0,ee))===null;)ee=n(F,ee+1);return X}t.$Kj=z;function R(C,F,j=!1){if(!F||F.length===0)return null;let X=null,ee=0;for(C=C.toLowerCase(),F=F.toLowerCase();ee<F.length&&(X=d(C,F,0,ee,j))===null;)ee=D(F,ee+1);return X}t.$Lj=R;function d(C,F,j,X,ee){if(j===C.length)return[];if(X===F.length)return null;if(o(C.charCodeAt(j),F.charCodeAt(X))){let ne=null,me=X+1;if(ne=d(C,F,j+1,X+1,ee),!ee)for(;!ne&&(me=D(F,me))<F.length;)ne=d(C,F,j+1,me,ee),me++;return ne?C.charCodeAt(j)!==F.charCodeAt(X)?ne:m({start:X,end:X+1},ne):null}else return null}function D(C,F){for(let j=F;j<C.length;j++)if(e(C.charCodeAt(j))||j>0&&e(C.charCodeAt(j-1)))return j;return C.length}const B=i(t.$Gj,z,w),_=i(t.$Gj,z,A),x=new v.$Cc(1e4);function P(C,F,j=!1){if(typeof C!="string"||typeof F!="string")return null;let X=x.get(C);X||(X=new RegExp(T.$Me(C),"i"),x.set(C,X));const ee=X.exec(F);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:j?_(C,F):B(C,F)}t.$Mj=P;function O(C,F){const j=Q(C,C.toLowerCase(),0,F,F.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?te(j):null}t.$Nj=O;function K(C,F,j,X,ee,ne){const me=Math.min(13,C.length);for(;j<me;j++){const ve=Q(C,F,j,X,ee,ne,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ve)return ve}return[0,ne]}t.$Oj=K;function te(C){if(typeof C>"u")return[];const F=[],j=C[1];for(let X=C.length-1;X>1;X--){const ee=C[X]+j,ne=F[F.length-1];ne&&ne.end===ee?ne.end=ee+1:F.push({start:ee,end:ee+1})}return F}t.$Pj=te;const se=128;function fe(){const C=[],F=[];for(let j=0;j<=se;j++)F[j]=0;for(let j=0;j<=se;j++)C.push(F.slice(0));return C}function le(C){const F=[];for(let j=0;j<=C;j++)F[j]=0;return F}const oe=le(2*se),be=le(2*se),Ce=fe(),Ae=fe(),Pe=fe(),de=!1;function ie(C,F,j,X,ee){function ne(ve,Ne,Se=" "){for(;ve.length<Ne;)ve=Se+ve;return ve}let me=` |   |${X.split("").map(ve=>ne(ve,3)).join("|")}
`;for(let ve=0;ve<=j;ve++)ve===0?me+=" |":me+=`${F[ve-1]}|`,me+=C[ve].slice(0,ee+1).map(Ne=>ne(Ne.toString(),3)).join("|")+`
`;return me}function ce(C,F,j,X){C=C.substr(F),j=j.substr(X),console.log(ie(Ae,C,C.length,j,j.length)),console.log(ie(Pe,C,C.length,j,j.length)),console.log(ie(Ce,C,C.length,j,j.length))}function Z(C,F){if(F<0||F>=C.length)return!1;const j=C.codePointAt(F);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$jf(j)}}function W(C,F){if(F<0||F>=C.length)return!1;switch(C.charCodeAt(F)){case 32:case 9:return!0;default:return!1}}function Y(C,F,j){return F[C]!==j[C]}function S(C,F,j,X,ee,ne,me=!1){for(;F<j&&ee<ne;)C[F]===X[ee]&&(me&&(oe[F]=ee),F+=1),ee+=1;return F===j}t.$Qj=S;var q;(function(C){C[C.Diag=1]="Diag",C[C.Left=2]="Left",C[C.LeftLeft=3]="LeftLeft"})(q||(q={}));var $;(function(C){C.Default=[-100,0];function F(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}C.isDefault=F})($||(t.FuzzyScore=$={}));class U{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(F,j){this.firstMatchCanBeWeak=F,this.boostFullMatch=j}}t.$Rj=U;function Q(C,F,j,X,ee,ne,me=U.default){const ve=C.length>se?se:C.length,Ne=X.length>se?se:X.length;if(j>=ve||ne>=Ne||ve-j>Ne-ne||!S(F,j,ve,ee,ne,Ne,!0))return;p(ve,Ne,j,ne,F,ee);let Se=1,De=1,Le=j,Te=ne;const We=[!1];for(Se=1,Le=j;Le<ve;Se++,Le++){const he=oe[Le],pe=be[Le],Ee=Le+1<ve?be[Le+1]:Ne;for(De=he-ne+1,Te=he;Te<Ee;De++,Te++){let Fe=Number.MIN_SAFE_INTEGER,Be=!1;Te<=pe&&(Fe=E(C,F,Le,j,X,ee,Te,Ne,ne,Ce[Se-1][De-1]===0,We));let Ue=0;Fe!==Number.MAX_SAFE_INTEGER&&(Be=!0,Ue=Fe+Ae[Se-1][De-1]);const Ze=Te>he,Je=Ze?Ae[Se][De-1]+(Ce[Se][De-1]>0?-5:0):0,Ke=Te>he+1&&Ce[Se][De-1]>0,_e=Ke?Ae[Se][De-2]+(Ce[Se][De-2]>0?-5:0):0;if(Ke&&(!Ze||_e>=Je)&&(!Be||_e>=Ue))Ae[Se][De]=_e,Pe[Se][De]=3,Ce[Se][De]=0;else if(Ze&&(!Be||Je>=Ue))Ae[Se][De]=Je,Pe[Se][De]=2,Ce[Se][De]=0;else if(Be)Ae[Se][De]=Ue,Pe[Se][De]=1,Ce[Se][De]=Ce[Se-1][De-1]+1;else throw new Error("not possible")}}if(de&&ce(C,j,X,ne),!We[0]&&!me.firstMatchCanBeWeak)return;Se--,De--;const He=[Ae[Se][De],ne];let Me=0,Ye=0;for(;Se>=1;){let he=De;do{const pe=Pe[Se][he];if(pe===3)he=he-2;else if(pe===2)he=he-1;else break}while(he>=1);Me>1&&F[j+Se-1]===ee[ne+De-1]&&!Y(he+ne-1,X,ee)&&Me+1>Ce[Se][he]&&(he=De),he===De?Me++:Me=1,Ye||(Ye=he),Se--,De=he-1,He.push(De)}Ne===ve&&me.boostFullMatch&&(He[0]+=2);const J=Ye-ve;return He[0]-=J,He}t.$Sj=Q;function p(C,F,j,X,ee,ne){let me=C-1,ve=F-1;for(;me>=j&&ve>=X;)ee[me]===ne[ve]&&(be[me]=ve,me--),ve--}function E(C,F,j,X,ee,ne,me,ve,Ne,Se,De){if(F[j]!==ne[me])return Number.MIN_SAFE_INTEGER;let Le=1,Te=!1;return me===j-X?Le=C[j]===ee[me]?7:5:Y(me,ee,ne)&&(me===0||!Y(me-1,ee,ne))?(Le=C[j]===ee[me]?7:5,Te=!0):Z(ne,me)&&(me===0||!Z(ne,me-1))?Le=5:(Z(ne,me-1)||W(ne,me-1))&&(Le=5,Te=!0),Le>1&&j===X&&(De[0]=!0),Te||(Te=Y(me,ee,ne)||Z(ne,me-1)||W(ne,me-1)),j===X?me>Ne&&(Le-=Te?3:5):Se?Le+=Te?2:0:Le+=Te?0:1,me+1===ve&&(Le-=Te?3:5),Le}function y(C,F,j,X,ee,ne,me){return k(C,F,j,X,ee,ne,!0,me)}t.$Tj=y;function M(C,F,j,X,ee,ne,me){return k(C,F,j,X,ee,ne,!1,me)}t.$Uj=M;function k(C,F,j,X,ee,ne,me,ve){let Ne=Q(C,F,j,X,ee,ne,ve);if(Ne&&!me)return Ne;if(C.length>=3){const Se=Math.min(7,C.length-1);for(let De=j+1;De<Se;De++){const Le=I(C,De);if(Le){const Te=Q(Le,Le.toLowerCase(),j,X,ee,ne,ve);Te&&(Te[0]-=3,(!Ne||Te[0]>Ne[0])&&(Ne=Te))}}}return Ne}function I(C,F){if(F+1>=C.length)return;const j=C[F],X=C[F+1];if(j!==X)return C.slice(0,F)+X+j+C.slice(F+2)}}),define($e[49],we([1,0,12]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mi=t.$Li=t.$Ki=t.$Ji=t.$Ii=t.$Hi=t.$Gi=void 0;function T(m){return i(m,0)}t.$Gi=T;function i(m,n){switch(typeof m){case"object":return m===null?H(349,n):Array.isArray(m)?f(m,n):g(m,n);case"string":return A(m,n);case"boolean":return w(m,n);case"number":return H(m,n);case"undefined":return H(937,n);default:return H(617,n)}}t.$Hi=i;function H(m,n){return(n<<5)-n+m|0}t.$Ii=H;function w(m,n){return H(m?433:863,n)}function A(m,n){n=H(149417,n);for(let r=0,b=m.length;r<b;r++)n=H(m.charCodeAt(r),n);return n}t.$Ji=A;function f(m,n){return n=H(104579,n),m.reduce((r,b)=>i(b,r),n)}function g(m,n){return n=H(181387,n),Object.keys(m).sort().reduce((r,b)=>(r=A(b,r),i(m[b],r)),n)}class c{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=i(n,this.g),this.g}}t.$Ki=c;var L;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(L||(L={}));function s(m,n,r=32){const b=r-n,u=~((1<<b)-1);return(m<<n|(u&m)>>>b)>>>0}function h(m,n=0,r=m.byteLength,b=0){for(let u=0;u<r;u++)m[n+u]=b}function e(m,n,r="0"){for(;m.length<n;)m=r+m;return m}function o(m,n=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(r=>r.toString(16).padStart(2,"0")).join(""):e((m>>>0).toString(16),n/4)}t.$Li=o;class a{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const r=n.length;if(r===0)return;const b=this.p;let u=this.r,l=this.u,N,z;for(l!==0?(N=l,z=-1,l=0):(N=n.charCodeAt(0),z=0);;){let R=N;if(v.$7e(N))if(z+1<r){const d=n.charCodeAt(z+1);v.$8e(d)?(z++,R=v.$9e(N,d)):R=65533}else{l=N;break}else v.$8e(N)&&(R=65533);if(u=this.w(b,u,R),z++,z<r)N=n.charCodeAt(z);else break}this.r=u,this.u=l}w(n,r,b){return b<128?n[r++]=b:b<2048?(n[r++]=192|(b&1984)>>>6,n[r++]=128|(b&63)>>>0):b<65536?(n[r++]=224|(b&61440)>>>12,n[r++]=128|(b&4032)>>>6,n[r++]=128|(b&63)>>>0):(n[r++]=240|(b&1835008)>>>18,n[r++]=128|(b&258048)>>>12,n[r++]=128|(b&4032)>>>6,n[r++]=128|(b&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),o(this.h)+o(this.l)+o(this.m)+o(this.n)+o(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=a.g,r=this.q;for(let B=0;B<64;B+=4)n.setUint32(B,r.getUint32(B,!1),!1);for(let B=64;B<320;B+=4)n.setUint32(B,s(n.getUint32(B-12,!1)^n.getUint32(B-32,!1)^n.getUint32(B-56,!1)^n.getUint32(B-64,!1),1),!1);let b=this.h,u=this.l,l=this.m,N=this.n,z=this.o,R,d,D;for(let B=0;B<80;B++)B<20?(R=u&l|~u&N,d=1518500249):B<40?(R=u^l^N,d=1859775393):B<60?(R=u&l|u&N|l&N,d=2400959708):(R=u^l^N,d=3395469782),D=s(b,5)+R+z+d+n.getUint32(B*4,!1)&4294967295,z=N,N=l,l=s(u,30),u=b,b=D;this.h=this.h+b&4294967295,this.l=this.l+u&4294967295,this.m=this.m+l&4294967295,this.n=this.n+N&4294967295,this.o=this.o+z&4294967295}}t.$Mi=a}),define($e[86],we([1,0,75,49]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cs=t.$Bs=t.$As=void 0;class i{constructor(s){this.a=s}getElements(){const s=this.a,h=new Int32Array(s.length);for(let e=0,o=s.length;e<o;e++)h[e]=s.charCodeAt(e);return h}}t.$As=i;function H(L,s,h){return new c(new i(L),new i(s)).ComputeDiff(h).changes}t.$Bs=H;class w{static Assert(s,h){if(!s)throw new Error(h)}}class A{static Copy(s,h,e,o,a){for(let m=0;m<a;m++)e[o+m]=s[h+m]}static Copy2(s,h,e,o,a){for(let m=0;m<a;m++)e[o+m]=s[h+m]}}var f;(function(L){L[L.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(f||(f={}));class g{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new v.$zs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(s,h){this.b=Math.min(this.b,s),this.c=Math.min(this.c,h),this.d++}AddModifiedElement(s,h){this.b=Math.min(this.b,s),this.c=Math.min(this.c,h),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class c{constructor(s,h,e=null){this.a=e,this.b=s,this.c=h;const[o,a,m]=c.o(s),[n,r,b]=c.o(h);this.d=m&&b,this.e=o,this.f=a,this.g=n,this.h=r,this.k=[],this.m=[]}static n(s){return s.length>0&&typeof s[0]=="string"}static o(s){const h=s.getElements();if(c.n(h)){const e=new Int32Array(h.length);for(let o=0,a=h.length;o<a;o++)e[o]=(0,T.$Ji)(h[o],0);return[h,e,!0]}return h instanceof Int32Array?[[],h,!1]:[[],new Int32Array(h),!1]}p(s,h){return this.f[s]!==this.h[h]?!1:this.d?this.e[s]===this.g[h]:!0}q(s,h){if(!this.p(s,h))return!1;const e=c.r(this.b,s),o=c.r(this.c,h);return e===o}static r(s,h){return typeof s.getStrictElement=="function"?s.getStrictElement(h):null}s(s,h){return this.f[s]!==this.f[h]?!1:this.d?this.e[s]===this.e[h]:!0}u(s,h){return this.h[s]!==this.h[h]?!1:this.d?this.g[s]===this.g[h]:!0}ComputeDiff(s){return this.v(0,this.f.length-1,0,this.h.length-1,s)}v(s,h,e,o,a){const m=[!1];let n=this.w(s,h,e,o,m);return a&&(n=this.z(n)),{quitEarly:m[0],changes:n}}w(s,h,e,o,a){for(a[0]=!1;s<=h&&e<=o&&this.p(s,e);)s++,e++;for(;h>=s&&o>=e&&this.p(h,o);)h--,o--;if(s>h||e>o){let l;return e<=o?(w.Assert(s===h+1,"originalStart should only be one more than originalEnd"),l=[new v.$zs(s,0,e,o-e+1)]):s<=h?(w.Assert(e===o+1,"modifiedStart should only be one more than modifiedEnd"),l=[new v.$zs(s,h-s+1,e,0)]):(w.Assert(s===h+1,"originalStart should only be one more than originalEnd"),w.Assert(e===o+1,"modifiedStart should only be one more than modifiedEnd"),l=[]),l}const m=[0],n=[0],r=this.y(s,h,e,o,m,n,a),b=m[0],u=n[0];if(r!==null)return r;if(!a[0]){const l=this.w(s,b,e,u,a);let N=[];return a[0]?N=[new v.$zs(b+1,h-(b+1)+1,u+1,o-(u+1)+1)]:N=this.w(b+1,h,u+1,o,a),this.H(l,N)}return[new v.$zs(s,h-s+1,e,o-e+1)]}x(s,h,e,o,a,m,n,r,b,u,l,N,z,R,d,D,B,_){let x=null,P=null,O=new g,K=h,te=e,se=z[0]-D[0]-o,fe=-1073741824,le=this.k.length-1;do{const oe=se+s;oe===K||oe<te&&b[oe-1]<b[oe+1]?(l=b[oe+1],R=l-se-o,l<fe&&O.MarkNextChange(),fe=l,O.AddModifiedElement(l+1,R),se=oe+1-s):(l=b[oe-1]+1,R=l-se-o,l<fe&&O.MarkNextChange(),fe=l-1,O.AddOriginalElement(l,R+1),se=oe-1-s),le>=0&&(b=this.k[le],s=b[0],K=1,te=b.length-1)}while(--le>=-1);if(x=O.getReverseChanges(),_[0]){let oe=z[0]+1,be=D[0]+1;if(x!==null&&x.length>0){const Ce=x[x.length-1];oe=Math.max(oe,Ce.getOriginalEnd()),be=Math.max(be,Ce.getModifiedEnd())}P=[new v.$zs(oe,N-oe+1,be,d-be+1)]}else{O=new g,K=m,te=n,se=z[0]-D[0]-r,fe=1073741824,le=B?this.m.length-1:this.m.length-2;do{const oe=se+a;oe===K||oe<te&&u[oe-1]>=u[oe+1]?(l=u[oe+1]-1,R=l-se-r,l>fe&&O.MarkNextChange(),fe=l+1,O.AddOriginalElement(l+1,R+1),se=oe+1-a):(l=u[oe-1],R=l-se-r,l>fe&&O.MarkNextChange(),fe=l,O.AddModifiedElement(l+1,R+1),se=oe-1-a),le>=0&&(u=this.m[le],a=u[0],K=1,te=u.length-1)}while(--le>=-1);P=O.getChanges()}return this.H(x,P)}y(s,h,e,o,a,m,n){let r=0,b=0,u=0,l=0,N=0,z=0;s--,e--,a[0]=0,m[0]=0,this.k=[],this.m=[];const R=h-s+(o-e),d=R+1,D=new Int32Array(d),B=new Int32Array(d),_=o-e,x=h-s,P=s-e,O=h-o,te=(x-_)%2===0;D[_]=s,B[x]=h,n[0]=!1;for(let se=1;se<=R/2+1;se++){let fe=0,le=0;u=this.J(_-se,se,_,d),l=this.J(_+se,se,_,d);for(let be=u;be<=l;be+=2){be===u||be<l&&D[be-1]<D[be+1]?r=D[be+1]:r=D[be-1]+1,b=r-(be-_)-P;const Ce=r;for(;r<h&&b<o&&this.p(r+1,b+1);)r++,b++;if(D[be]=r,r+b>fe+le&&(fe=r,le=b),!te&&Math.abs(be-x)<=se-1&&r>=B[be])return a[0]=r,m[0]=b,Ce<=B[be]&&1447>0&&se<=1447+1?this.x(_,u,l,P,x,N,z,O,D,B,r,h,a,b,o,m,te,n):null}const oe=(fe-s+(le-e)-se)/2;if(this.a!==null&&!this.a(fe,oe))return n[0]=!0,a[0]=fe,m[0]=le,oe>0&&1447>0&&se<=1447+1?this.x(_,u,l,P,x,N,z,O,D,B,r,h,a,b,o,m,te,n):(s++,e++,[new v.$zs(s,h-s+1,e,o-e+1)]);N=this.J(x-se,se,x,d),z=this.J(x+se,se,x,d);for(let be=N;be<=z;be+=2){be===N||be<z&&B[be-1]>=B[be+1]?r=B[be+1]-1:r=B[be-1],b=r-(be-x)-O;const Ce=r;for(;r>s&&b>e&&this.p(r,b);)r--,b--;if(B[be]=r,te&&Math.abs(be-_)<=se&&r<=D[be])return a[0]=r,m[0]=b,Ce>=D[be]&&1447>0&&se<=1447+1?this.x(_,u,l,P,x,N,z,O,D,B,r,h,a,b,o,m,te,n):null}if(se<=1447){let be=new Int32Array(l-u+2);be[0]=_-u+1,A.Copy2(D,u,be,1,l-u+1),this.k.push(be),be=new Int32Array(z-N+2),be[0]=x-N+1,A.Copy2(B,N,be,1,z-N+1),this.m.push(be)}}return this.x(_,u,l,P,x,N,z,O,D,B,r,h,a,b,o,m,te,n)}z(s){for(let h=0;h<s.length;h++){const e=s[h],o=h<s.length-1?s[h+1].originalStart:this.f.length,a=h<s.length-1?s[h+1].modifiedStart:this.h.length,m=e.originalLength>0,n=e.modifiedLength>0;for(;e.originalStart+e.originalLength<o&&e.modifiedStart+e.modifiedLength<a&&(!m||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!n||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const b=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!b)break;e.originalStart++,e.modifiedStart++}const r=[null];if(h<s.length-1&&this.I(s[h],s[h+1],r)){s[h]=r[0],s.splice(h+1,1),h--;continue}}for(let h=s.length-1;h>=0;h--){const e=s[h];let o=0,a=0;if(h>0){const l=s[h-1];o=l.originalStart+l.originalLength,a=l.modifiedStart+l.modifiedLength}const m=e.originalLength>0,n=e.modifiedLength>0;let r=0,b=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let l=1;;l++){const N=e.originalStart-l,z=e.modifiedStart-l;if(N<o||z<a||m&&!this.s(N,N+e.originalLength)||n&&!this.u(z,z+e.modifiedLength))break;const d=(N===o&&z===a?5:0)+this.G(N,e.originalLength,z,e.modifiedLength);d>b&&(b=d,r=l)}e.originalStart-=r,e.modifiedStart-=r;const u=[null];if(h>0&&this.I(s[h-1],s[h],u)){s[h-1]=u[0],s.splice(h,1),h++;continue}}if(this.d)for(let h=1,e=s.length;h<e;h++){const o=s[h-1],a=s[h],m=a.originalStart-o.originalStart-o.originalLength,n=o.originalStart,r=a.originalStart+a.originalLength,b=r-n,u=o.modifiedStart,l=a.modifiedStart+a.modifiedLength,N=l-u;if(m<5&&b<20&&N<20){const z=this.A(n,b,u,N,m);if(z){const[R,d]=z;(R!==o.originalStart+o.originalLength||d!==o.modifiedStart+o.modifiedLength)&&(o.originalLength=R-o.originalStart,o.modifiedLength=d-o.modifiedStart,a.originalStart=R+m,a.modifiedStart=d+m,a.originalLength=r-a.originalStart,a.modifiedLength=l-a.modifiedStart)}}}return s}A(s,h,e,o,a){if(h<a||o<a)return null;const m=s+h-a+1,n=e+o-a+1;let r=0,b=0,u=0;for(let l=s;l<m;l++)for(let N=e;N<n;N++){const z=this.B(l,N,a);z>0&&z>r&&(r=z,b=l,u=N)}return r>0?[b,u]:null}B(s,h,e){let o=0;for(let a=0;a<e;a++){if(!this.p(s+a,h+a))return 0;o+=this.e[s+a].length}return o}C(s){return s<=0||s>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[s])}D(s,h){if(this.C(s)||this.C(s-1))return!0;if(h>0){const e=s+h;if(this.C(e-1)||this.C(e))return!0}return!1}E(s){return s<=0||s>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[s])}F(s,h){if(this.E(s)||this.E(s-1))return!0;if(h>0){const e=s+h;if(this.E(e-1)||this.E(e))return!0}return!1}G(s,h,e,o){const a=this.D(s,h)?1:0,m=this.F(e,o)?1:0;return a+m}H(s,h){const e=[];if(s.length===0||h.length===0)return h.length>0?h:s;if(this.I(s[s.length-1],h[0],e)){const o=new Array(s.length+h.length-1);return A.Copy(s,0,o,0,s.length-1),o[s.length-1]=e[0],A.Copy(h,1,o,s.length,h.length-1),o}else{const o=new Array(s.length+h.length);return A.Copy(s,0,o,0,s.length),A.Copy(h,0,o,s.length,h.length),o}}I(s,h,e){if(w.Assert(s.originalStart<=h.originalStart,"Left change is not less than or equal to right change"),w.Assert(s.modifiedStart<=h.modifiedStart,"Left change is not less than or equal to right change"),s.originalStart+s.originalLength>=h.originalStart||s.modifiedStart+s.modifiedLength>=h.modifiedStart){const o=s.originalStart;let a=s.originalLength;const m=s.modifiedStart;let n=s.modifiedLength;return s.originalStart+s.originalLength>=h.originalStart&&(a=h.originalStart+h.originalLength-s.originalStart),s.modifiedStart+s.modifiedLength>=h.modifiedStart&&(n=h.modifiedStart+h.modifiedLength-s.modifiedStart),e[0]=new v.$zs(o,a,m,n),!0}else return e[0]=null,!1}J(s,h,e,o){if(s>=0&&s<o)return s;const a=e,m=o-e-1,n=h%2===0;if(s<0){const r=a%2===0;return n===r?0:1}else{const r=m%2===0;return n===r?o-1:o-2}}}t.$Cs=c}),define($e[50],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ld=void 0,t.$Ld=Symbol("MicrotaskDelay")}),define($e[87],we([1,0,11,12]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yh=t.$Xh=t.$Wh=t.$Vh=t.$Uh=void 0;class i{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const e=h.charCodeAt(0),o=this.b.charCodeAt(this.c);return e-o}value(){return this.b[this.c]}}t.$Uh=i;class H{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,T.$We)(h,this.b,0,h.length,this.c,this.d):(0,T.$Ye)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Vh=H;class w{constructor(h=!0,e=!0){this.f=h,this.g=e}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let e=h.length-1;e>=0;e--,this.c--){const o=this.b.charCodeAt(e);if(!(o===47||this.f&&o===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,T.$We)(h,this.b,0,h.length,this.d,this.e):(0,T.$Ye)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Wh=w;var A;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(A||(A={}));class f{constructor(h,e){this.f=h,this.g=e,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new w(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,T.$Xe)(h,this.c.scheme);if(this.d[this.e]===2)return(0,T.$Xe)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,T.$Ve)(h,this.c.query);if(this.d[this.e]===5)return(0,T.$Ve)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$Xh=f;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var c;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(c||(c={}));class L{static forUris(h=()=>!1,e=()=>!1){return new L(new f(h,e))}static forPaths(h=!1){return new L(new w(void 0,!h))}static forStrings(){return new L(new i)}static forConfigKeys(){return new L(new H)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,e){if(e){const o=e.slice(0);(0,v.$Wb)(o);for(const a of o)this.set(a,h)}else{const o=h.slice(0);(0,v.$Wb)(o);for(const a of o)this.set(a[0],a[1])}}set(h,e){const o=this.b.reset(h);let a;this.c||(this.c=new g,this.c.segment=o.value());const m=[];for(a=this.c;;){const r=o.cmp(a.segment);if(r>0)a.left||(a.left=new g,a.left.segment=o.value()),m.push([-1,a]),a=a.left;else if(r<0)a.right||(a.right=new g,a.right.segment=o.value()),m.push([1,a]),a=a.right;else if(o.hasNext())o.next(),a.mid||(a.mid=new g,a.mid.segment=o.value()),m.push([0,a]),a=a.mid;else break}const n=a.value;a.value=e,a.key=h;for(let r=m.length-1;r>=0;r--){const b=m[r][1];b.updateHeight();const u=b.balanceFactor();if(u<-1||u>1){const l=m[r][0],N=m[r+1][0];if(l===1&&N===1)m[r][1]=b.rotateLeft();else if(l===-1&&N===-1)m[r][1]=b.rotateRight();else if(l===1&&N===-1)b.right=m[r+1][1]=m[r+1][1].rotateRight(),m[r][1]=b.rotateLeft();else if(l===-1&&N===1)b.left=m[r+1][1]=m[r+1][1].rotateLeft(),m[r][1]=b.rotateRight();else throw new Error;if(r>0)switch(m[r-1][0]){case-1:m[r-1][1].left=m[r][1];break;case 1:m[r-1][1].right=m[r][1];break;case 0:m[r-1][1].mid=m[r][1];break}else this.c=m[0][1]}}return n}get(h){return this.d(h)?.value}d(h){const e=this.b.reset(h);let o=this.c;for(;o;){const a=e.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(e.hasNext())e.next(),o=o.mid;else break}return o}has(h){const e=this.d(h);return!(e?.value===void 0&&e?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,e){const o=this.b.reset(h),a=[];let m=this.c;for(;m;){const n=o.cmp(m.segment);if(n>0)a.push([-1,m]),m=m.left;else if(n<0)a.push([1,m]),m=m.right;else if(o.hasNext())o.next(),a.push([0,m]),m=m.mid;else break}if(m){if(e?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const n=this.f(m.right);if(n.key){const{key:r,value:b,segment:u}=n;this.e(n.key,!1),m.key=r,m.value=b,m.segment=u}}else{const n=m.left??m.right;if(a.length>0){const[r,b]=a[a.length-1];switch(r){case-1:b.left=n;break;case 0:b.mid=n;break;case 1:b.right=n;break}}else this.c=n}for(let n=a.length-1;n>=0;n--){const r=a[n][1];r.updateHeight();const b=r.balanceFactor();if(b>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),a[n][1]=r.rotateLeft()):b<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),a[n][1]=r.rotateRight()),n>0)switch(a[n-1][0]){case-1:a[n-1][1].left=a[n][1];break;case 1:a[n-1][1].right=a[n][1];break;case 0:a[n-1][1].mid=a[n][1];break}else this.c=a[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const e=this.b.reset(h);let o=this.c,a;for(;o;){const m=e.cmp(o.segment);if(m>0)o=o.left;else if(m<0)o=o.right;else if(e.hasNext())e.next(),a=o.value||a,o=o.mid;else break}return o&&o.value||a}findSuperstr(h){return this.g(h,!1)}g(h,e){const o=this.b.reset(h);let a=this.c;for(;a;){const m=o.cmp(a.segment);if(m>0)a=a.left;else if(m<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else return a.mid?this.h(a.mid):e?a.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[e,o]of this)h(o,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const e=[];return this.j(h,e),e[Symbol.iterator]()}j(h,e){h&&(h.left&&this.j(h.left,e),h.value&&e.push([h.key,h.value]),h.mid&&this.j(h.mid,e),h.right&&this.j(h.right,e))}_isBalanced(){const h=e=>{if(!e)return!0;const o=e.balanceFactor();return o<-1||o>1?!1:h(e.left)&&h(e.right)};return h(this.c)}}t.$Yh=L}),define($e[7],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=void 0;function v(u){return typeof u=="string"}t.$zf=v;function T(u){return Array.isArray(u)&&u.every(l=>v(l))}t.$Af=T;function i(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}t.$Bf=i;function H(u){const l=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof l}t.$Cf=H;function w(u){return typeof u=="number"&&!isNaN(u)}t.$Df=w;function A(u){return!!u&&typeof u[Symbol.iterator]=="function"}t.$Ef=A;function f(u){return u===!0||u===!1}t.$Ff=f;function g(u){return typeof u>"u"}t.$Gf=g;function c(u){return!L(u)}t.$Hf=c;function L(u){return g(u)||u===null}t.$If=L;function s(u,l){if(!u)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}t.$Jf=s;function h(u){if(L(u))throw new Error("Assertion Failed: argument is undefined or null");return u}t.$Kf=h;function e(...u){const l=[];for(let N=0;N<u.length;N++){const z=u[N];if(L(z))throw new Error(`Assertion Failed: argument at index ${N} is undefined or null`);l.push(z)}return l}t.$Lf=e;const o=Object.prototype.hasOwnProperty;function a(u){if(!i(u))return!1;for(const l in u)if(o.call(u,l))return!1;return!0}t.$Mf=a;function m(u){return typeof u=="function"}t.$Nf=m;function n(...u){return u.length>0&&u.every(m)}t.$Of=n;function r(u,l){const N=Math.min(u.length,l.length);for(let z=0;z<N;z++)b(u[z],l[z])}t.$Pf=r;function b(u,l){if(v(l)){if(typeof u!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(m(l)){try{if(u instanceof l)return}catch{}if(!L(u)&&u.constructor===l||l.length===1&&l.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Qf=b}),define($e[18],we([1,0,7]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xj=t.$Wj=t.$Vj=void 0;const T=Object.create(null);function i(A,f){if((0,v.$zf)(f)){const g=T[f];if(g===void 0)throw new Error(`${A} references an unknown codicon: ${f}`);f=g}return T[A]=f,{id:A}}function H(){return T}t.$Vj=H;function w(){return Object.values(t.$Xj)}t.$Wj=w,t.$Xj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),thumbsDownFilled:i("thumbsdown-filled",60435),thumbsUpFilled:i("thumbsup-filled",60436),coffee:i("coffee",60437),snake:i("snake",60438),game:i("game",60439),vr:i("vr",60440),chip:i("chip",60441),piano:i("piano",60442),music:i("music",60443),micFilled:i("mic-filled",60444),gitFetch:i("git-fetch",60445),copilot:i("copilot",60446),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define($e[51],we([1,0,7]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$in=t.$hn=t.$gn=t.$fn=t.$en=t.$dn=t.$cn=t.$bn=t.$an=t.$_m=t.$$m=t.$0m=void 0;function T(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const n=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([r,b])=>{n[r]=b&&typeof b=="object"?T(b):b}),n}t.$0m=T;function i(m){if(!m||typeof m!="object")return m;const n=[m];for(;n.length>0;){const r=n.shift();Object.freeze(r);for(const b in r)if(H.call(r,b)){const u=r[b];typeof u=="object"&&!Object.isFrozen(u)&&!(0,v.$Cf)(u)&&n.push(u)}}return m}t.$$m=i;const H=Object.prototype.hasOwnProperty;function w(m,n){return A(m,n,new Set)}t.$_m=w;function A(m,n,r){if((0,v.$If)(m))return m;const b=n(m);if(typeof b<"u")return b;if(Array.isArray(m)){const u=[];for(const l of m)u.push(A(l,n,r));return u}if((0,v.$Bf)(m)){if(r.has(m))throw new Error("Cannot clone recursive data-structure");r.add(m);const u={};for(const l in m)H.call(m,l)&&(u[l]=A(m[l],n,r));return r.delete(m),u}return m}function f(m,n,r=!0){return(0,v.$Bf)(m)?((0,v.$Bf)(n)&&Object.keys(n).forEach(b=>{b in m?r&&((0,v.$Bf)(m[b])&&(0,v.$Bf)(n[b])?f(m[b],n[b],r):m[b]=n[b]):m[b]=n[b]}),m):n}t.$an=f;function g(m,n){if(m===n)return!0;if(m==null||n===null||n===void 0||typeof m!=typeof n||typeof m!="object"||Array.isArray(m)!==Array.isArray(n))return!1;let r,b;if(Array.isArray(m)){if(m.length!==n.length)return!1;for(r=0;r<m.length;r++)if(!g(m[r],n[r]))return!1}else{const u=[];for(b in m)u.push(b);u.sort();const l=[];for(b in n)l.push(b);if(l.sort(),!g(u,l))return!1;for(r=0;r<u.length;r++)if(!g(m[u[r]],n[u[r]]))return!1}return!0}t.$bn=g;function c(m){const n=new Set;return JSON.stringify(m,(r,b)=>{if((0,v.$Bf)(b)||Array.isArray(b)){if(n.has(b))return"[Circular]";n.add(b)}return b})}t.$cn=c;function L(m,n){const r=Object.create(null);return!m||!n||Object.keys(n).forEach(u=>{const l=m[u],N=n[u];g(l,N)||(r[u]=N)}),r}t.$dn=L;function s(m,n){const r=n.toLowerCase(),b=Object.keys(m).find(u=>u.toLowerCase()===r);return b?m[b]:m[n]}t.$en=s;function h(m,n){const r=Object.create(null);for(const[b,u]of Object.entries(m))n(b,u)&&(r[b]=u);return r}t.$fn=h;function e(m){let n=[];for(;Object.prototype!==m;)n=n.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return n}t.$gn=e;function o(m){const n=[];for(const r of e(m))typeof m[r]=="function"&&n.push(r);return n}t.$hn=o;function a(m,n){const r=u=>function(){const l=Array.prototype.slice.call(arguments,0);return n(u,l)},b={};for(const u of m)b[u]=r(u);return b}t.$in=a}),define($e[19],we([1,0,18]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$Yj=t.ThemeColor=void 0;var T;(function(w){function A(f){return f&&typeof f=="object"&&typeof f.id=="string"}w.isThemeColor=A})(T||(t.ThemeColor=T={}));function i(w){return{id:w}}t.$Yj=i;var H;(function(w){w.iconNameSegment="[A-Za-z0-9]+",w.iconNameExpression="[A-Za-z0-9-]+",w.iconModifierExpression="~[A-Za-z]+",w.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${w.iconNameExpression})(${w.iconModifierExpression})?$`);function f(n){const r=A.exec(n.id);if(!r)return f(v.$Xj.error);const[,b,u]=r,l=["codicon","codicon-"+b];return u&&l.push("codicon-modifier-"+u.substring(1)),l}w.asClassNameArray=f;function g(n){return f(n).join(" ")}w.asClassName=g;function c(n){return"."+f(n).join(".")}w.asCSSSelector=c;function L(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}w.isThemeIcon=L;const s=new RegExp(`^\\$\\((${w.iconNameExpression}(?:${w.iconModifierExpression})?)\\)$`);function h(n){const r=s.exec(n);if(!r)return;const[,b]=r;return{id:b}}w.fromString=h;function e(n){return{id:n}}w.fromId=e;function o(n,r){let b=n.id;const u=b.lastIndexOf("~");return u!==-1&&(b=b.substring(0,u)),r&&(b=`${b}~${r}`),{id:b}}w.modify=o;function a(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}w.getModifier=a;function m(n,r){return n.id===r.id&&n.color?.id===r.color?.id}w.isEqual=m})(H||(t.ThemeIcon=H={}))}),define($e[35],we([1,0,34,12,19]),function(ae,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5j=t.$4j=t.$3j=t.$2j=t.$1j=t.$Zj=void 0;const H="$(",w=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${w.source}`,"g");function f(m){return m.replace(A,(n,r)=>r?n:`\\${n}`)}t.$Zj=f;const g=new RegExp(`\\\\${w.source}`,"g");function c(m){return m.replace(g,n=>`\\${n}`)}t.$1j=c;const L=new RegExp(`(\\s)?(\\\\)?${w.source}(\\s)?`,"g");function s(m){return m.indexOf(H)===-1?m:m.replace(L,(n,r,b,u)=>b?n:r||u||"")}t.$2j=s;function h(m){return m?m.replace(/\$\((.*?)\)/g,(n,r)=>` ${r} `).trim():""}t.$3j=h;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function o(m){e.lastIndex=0;let n="";const r=[];let b=0;for(;;){const u=e.lastIndex,l=e.exec(m),N=m.substring(u,l?.index);if(N.length>0){n+=N;for(let z=0;z<N.length;z++)r.push(b)}if(!l)break;b+=l[0].length}return{text:n,iconOffsets:r}}t.$4j=o;function a(m,n,r=!1){const{text:b,iconOffsets:u}=n;if(!u||u.length===0)return(0,v.$Mj)(m,b,r);const l=(0,T.$Ke)(b," "),N=b.length-l.length,z=(0,v.$Mj)(m,l,r);if(z)for(const R of z){const d=u[R.start+N]+N;R.start+=d,R.end+=d}return z}t.$5j=a}),define($e[88],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OT=t.$NT=void 0,t.$NT="vscode:contextmenu",t.$OT="vscode:onCloseContextMenu"}),define($e[89],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VT=void 0;class v{constructor(i,H){this.a=i,this.onMessage=H}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$VT=v}),define($e[30],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$R=t.$Q=t.$P=t.$O=t.$N=void 0;const v=globalThis.vscode;t.$N=v.ipcRenderer,t.$O=v.ipcMessagePort,t.$P=v.webFrame,t.$Q=v.process,t.$R=v.context}),define($e[90],we([1,0,88,30]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RT=void 0;let i=0;function H(A,f,g){const c=[],L=i++,s=`vscode:onContextMenu${L}`,h=(e,o,a)=>{c[o].click?.(a)};T.$N.once(s,h),T.$N.once(v.$OT,(e,o)=>{o===L&&(T.$N.removeListener(s,h),g?.())}),T.$N.send(v.$NT,L,A.map(e=>w(e,c)),s,f)}t.$RT=H;function w(A,f){const g={id:f.length,label:A.label,type:A.type,accelerator:A.accelerator,checked:A.checked,enabled:typeof A.enabled=="boolean"?A.enabled:!0,visible:typeof A.visible=="boolean"?A.visible:!0};return f.push(A),Array.isArray(A.submenu)&&(g.submenu=A.submenu.map(c=>w(c,f))),g}}),define($e[52],we([8]),{}),define($e[91],we([8]),{}),define($e[92],we([8]),{}),define($e[93],we([8]),{}),define($e[94],we([1,0,92,93]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define($e[95],we([8]),{}),define($e[96],we([8]),{}),define($e[97],we([8]),{}),define($e[98],we([8]),{}),define($e[99],we([8]),{}),define($e[100],we([8]),{}),define($e[101],we([8]),{}),define($e[102],we([8]),{}),define($e[103],we([8]),{}),define($e[104],we([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define($e[105],we([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/findinput/findInput",t)}),define($e[106],we([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define($e[107],we([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define($e[108],we([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/inputbox/inputBox",t)}),define($e[109],we([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define($e[110],we([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/tree/abstractTree",t)}),define($e[111],we([13,10]),function(ae,t){return ae.create("vs/base/common/actions",t)}),define($e[36],we([1,0,4,2,111]),function(ae,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ci=t.$Bi=t.$Ai=t.$zi=t.$yi=t.$xi=void 0;class H extends T.$Rc{constructor(s,h="",e="",o=!0,a){super(),this.h=this.B(new v.$Od),this.onDidChange=this.h.event,this.w=!0,this.j=s,this.m=h,this.u=e,this.w=o,this.C=a}get id(){return this.j}get label(){return this.m}set label(s){this.D(s)}D(s){this.m!==s&&(this.m=s,this.h.fire({label:s}))}get tooltip(){return this.n||""}set tooltip(s){this.F(s)}F(s){this.n!==s&&(this.n=s,this.h.fire({tooltip:s}))}get class(){return this.u}set class(s){this.G(s)}G(s){this.u!==s&&(this.u=s,this.h.fire({class:s}))}get enabled(){return this.w}set enabled(s){this.H(s)}H(s){this.w!==s&&(this.w=s,this.h.fire({enabled:s}))}get checked(){return this.z}set checked(s){this.I(s)}I(s){this.z!==s&&(this.z=s,this.h.fire({checked:s}))}async run(s,h){this.C&&await this.C(s)}}t.$xi=H;class w extends T.$Rc{constructor(){super(...arguments),this.f=this.B(new v.$Od),this.onWillRun=this.f.event,this.m=this.B(new v.$Od),this.onDidRun=this.m.event}async run(s,h){if(!s.enabled)return;this.f.fire({action:s});let e;try{await this.u(s,h)}catch(o){e=o}this.m.fire({action:s,error:e})}async u(s,h){await s.run(h)}}t.$yi=w;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...s){let h=[];for(const e of s)e.length&&(h.length?h=[...h,new A,...e]:h=e);return h}static{this.ID="vs.actions.separator"}async run(){}}t.$zi=A;class f{get actions(){return this.a}constructor(s,h,e,o){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=s,this.label=h,this.class=o,this.a=e}async run(){}}t.$Ai=f;class g extends H{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,i.localize(0,null),void 0,!1)}}t.$Bi=g;function c(L){return{id:L.id,label:L.label,class:void 0,enabled:L.enabled??!0,checked:L.checked??!1,run:async(...s)=>L.run(...s),tooltip:L.label}}t.$Ci=c}),define($e[112],we([13,10]),function(ae,t){return ae.create("vs/base/common/platform",t)}),define($e[5],we([1,0,112]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let T=!1,i=!1,H=!1,w=!1,A=!1,f=!1,g=!1,c=!1,L=!1,s=!1,h,e=t.$g,o=t.$g,a,m;const n=globalThis;let r;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?r=n.vscode.process:typeof process<"u"&&(r=process);const b=typeof r?.versions?.electron=="string",u=b&&r?.type==="renderer";if(typeof navigator=="object"&&!u)m=navigator.userAgent,T=m.indexOf("Windows")>=0,i=m.indexOf("Macintosh")>=0,c=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,H=m.indexOf("Linux")>=0,s=m?.indexOf("Mobi")>=0,f=!0,h=v.getConfiguredDefaultLocale(v.localize(0,null))||t.$g,e=h,o=navigator.language;else if(typeof r=="object"){T=r.platform==="win32",i=r.platform==="darwin",H=r.platform==="linux",w=H&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,g=b,L=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=t.$g,e=t.$g;const x=r.env.VSCODE_NLS_CONFIG;if(x)try{const P=JSON.parse(x),O=P.availableLanguages["*"];h=P.locale,o=P.osLocale,e=O||t.$g,a=P._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var l;(function(x){x[x.Web=0]="Web",x[x.Mac=1]="Mac",x[x.Linux=2]="Linux",x[x.Windows=3]="Windows"})(l||(t.Platform=l={}));function N(x){switch(x){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=N;let z=0;i?z=1:T?z=3:H&&(z=2),t.$i=T,t.$j=i,t.$k=H,t.$l=w,t.$m=A,t.$n=g,t.$o=f,t.$p=f&&typeof n.importScripts=="function",t.$q=t.$p?n.origin:void 0,t.$r=c,t.$s=s,t.$t=L,t.$u=z,t.$v=m,t.$w=e;var R;(function(x){function P(){return t.$w}x.value=P;function O(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}x.isDefaultVariant=O;function K(){return t.$w==="en"}x.isDefault=K})(R||(t.Language=R={})),t.$x=h,t.$y=o,t.$z=a,t.$A=typeof n.postMessage=="function"&&!n.importScripts,t.$B=(()=>{if(t.$A){const x=[];n.addEventListener("message",O=>{if(O.data&&O.data.vscodeScheduleAsyncWork)for(let K=0,te=x.length;K<te;K++){const se=x[K];if(se.id===O.data.vscodeScheduleAsyncWork){x.splice(K,1),se.callback();return}}});let P=0;return O=>{const K=++P;x.push({id:K,callback:O}),n.postMessage({vscodeScheduleAsyncWork:K},"*")}}return x=>setTimeout(x)})();var d;(function(x){x[x.Windows=1]="Windows",x[x.Macintosh=2]="Macintosh",x[x.Linux=3]="Linux"})(d||(t.OperatingSystem=d={})),t.OS=i||c?2:T?1:3;let D=!0,B=!1;function _(){if(!B){B=!0;const x=new Uint8Array(2);x[0]=1,x[1]=2,D=new Uint16Array(x.buffer)[0]===(2<<8)+1}return D}t.$D=_,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0)}),define($e[113],we([1,0,17,14,5]),function(ae,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MO=t.KeyboardSupport=void 0;var H;(function(w){w[w.Always=0]="Always",w[w.FullScreen=1]="FullScreen",w[w.None=2]="None"})(H||(t.KeyboardSupport=H={})),t.$MO={clipboard:{writeText:i.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.$m||v.$KO()?0:navigator.keyboard||v.$GO?1:2)(),touch:"ontouchstart"in T.$rO||navigator.maxTouchPoints>0,pointerEvents:T.$rO.PointerEvent&&("ontouchstart"in T.$rO||navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define($e[15],we([1,0,17,44,78,5]),function(ae,t,v,T,i,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UO=t.$TO=t.$SO=void 0;function w(e){if(e.charCode){const a=String.fromCharCode(e.charCode).toUpperCase();return T.KeyCodeUtils.fromString(a)}const o=e.keyCode;if(o===3)return 7;if(v.$DO)switch(o){case 59:return 85;case 60:if(H.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(H.$j)return 57;break}else if(v.$EO){if(H.$j&&o===93)return 57;if(!H.$j&&o===92)return 57}return T.$Dq[o]||0}const A=H.$j?256:2048,f=512,g=1024,c=H.$j?2048:256;function L(e){const o=[];return e.ctrlKey&&o.push("ctrl"),e.shiftKey&&o.push("shift"),e.altKey&&o.push("alt"),e.metaKey&&o.push("meta"),`modifiers: [${o.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$SO=L;function s(e){const o=[];return e.ctrlKey&&o.push("ctrl"),e.shiftKey&&o.push("shift"),e.altKey&&o.push("alt"),e.metaKey&&o.push("meta"),`modifiers: [${o.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${T.KeyCodeUtils.toString(e.keyCode)}')`}t.$TO=s;class h{constructor(o){this._standardKeyboardEventBrand=!0;const a=o;this.browserEvent=a,this.target=a.target,this.ctrlKey=a.ctrlKey,this.shiftKey=a.shiftKey,this.altKey=a.altKey,this.metaKey=a.metaKey,this.altGraphKey=a.getModifierState("AltGraph"),this.keyCode=w(a),this.code=a.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(o){return this.a===o}c(){let o=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(o=this.keyCode);let a=0;return this.ctrlKey&&(a|=A),this.altKey&&(a|=f),this.shiftKey&&(a|=g),this.metaKey&&(a|=c),a|=o,a}d(){let o=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(o=this.keyCode),new i.$Lq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,o)}}t.$UO=h}),define($e[20],we([1,0,17,71,14,5]),function(ae,t,v,T,i,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RO=t.$QO=t.$PO=void 0;class w{constructor(c){this.timestamp=Date.now(),this.browserEvent=c,this.leftButton=c.button===0,this.middleButton=c.button===1,this.rightButton=c.button===2,this.buttons=c.buttons,this.target=c.target,this.detail=c.detail||1,c.type==="dblclick"&&(this.detail=2),this.ctrlKey=c.ctrlKey,this.shiftKey=c.shiftKey,this.altKey=c.altKey,this.metaKey=c.metaKey,typeof c.pageX=="number"?(this.posx=c.pageX,this.posy=c.pageY):(this.posx=c.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=c.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const L=T.$NO.getPositionOfChildWindowRelativeToAncestorWindow(i.$window,c.view);this.posx-=L.left,this.posy-=L.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$PO=w;class A extends w{constructor(c){super(c),this.dataTransfer=c.dataTransfer}}t.$QO=A;class f{constructor(c,L=0,s=0){if(this.browserEvent=c||null,this.target=c?c.target||c.targetNode||c.srcElement:null,this.deltaY=s,this.deltaX=L,c){const h=c,e=c;if(typeof h.wheelDeltaY<"u")this.deltaY=h.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(c.type==="wheel"){const o=c;o.deltaMode===o.DOM_DELTA_LINE?v.$DO&&!H.$j?this.deltaY=-c.deltaY/3:this.deltaY=-c.deltaY:this.deltaY=-c.deltaY/40}if(typeof h.wheelDeltaX<"u")v.$GO&&H.$i?this.deltaX=-(h.wheelDeltaX/120):this.deltaX=h.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-c.detail/3;else if(c.type==="wheel"){const o=c;o.deltaMode===o.DOM_DELTA_LINE?v.$DO&&!H.$j?this.deltaX=-c.deltaX/3:this.deltaX=-c.deltaX:this.deltaX=-c.deltaX/40}this.deltaY===0&&this.deltaX===0&&c.wheelDelta&&(this.deltaY=c.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$RO=f}),define($e[114],we([1,0,5]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dc=t.$cc=t.env=t.cwd=void 0;let T;const i=globalThis.vscode;if(typeof i<"u"&&typeof i.process<"u"){const H=i.process;T={get platform(){return H.platform},get arch(){return H.arch},get env(){return H.env},cwd(){return H.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return v.$i?"win32":v.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=T.cwd,t.env=T.env,t.$cc=T.platform,t.$dc=T.arch}),define($e[23],we([1,0,114]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=t.sep=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=void 0;const T=65,i=97,H=90,w=122,A=46,f=47,g=92,c=58,L=63;class s extends Error{constructor(N,z,R){let d;typeof z=="string"&&z.indexOf("not ")===0?(d="must not be",z=z.replace(/^not /,"")):d="must be";const D=N.indexOf(".")!==-1?"property":"argument";let B=`The "${N}" ${D} ${d} of type ${z}`;B+=`. Received type ${typeof R}`,super(B),this.code="ERR_INVALID_ARG_TYPE"}}function h(l,N){if(l===null||typeof l!="object")throw new s(N,"Object",l)}function e(l,N){if(typeof l!="string")throw new s(N,"string",l)}const o=v.$cc==="win32";function a(l){return l===f||l===g}function m(l){return l===f}function n(l){return l>=T&&l<=H||l>=i&&l<=w}function r(l,N,z,R){let d="",D=0,B=-1,_=0,x=0;for(let P=0;P<=l.length;++P){if(P<l.length)x=l.charCodeAt(P);else{if(R(x))break;x=f}if(R(x)){if(!(B===P-1||_===1))if(_===2){if(d.length<2||D!==2||d.charCodeAt(d.length-1)!==A||d.charCodeAt(d.length-2)!==A){if(d.length>2){const O=d.lastIndexOf(z);O===-1?(d="",D=0):(d=d.slice(0,O),D=d.length-1-d.lastIndexOf(z)),B=P,_=0;continue}else if(d.length!==0){d="",D=0,B=P,_=0;continue}}N&&(d+=d.length>0?`${z}..`:"..",D=2)}else d.length>0?d+=`${z}${l.slice(B+1,P)}`:d=l.slice(B+1,P),D=P-B-1;B=P,_=0}else x===A&&_!==-1?++_:_=-1}return d}function b(l,N){h(N,"pathObject");const z=N.dir||N.root,R=N.base||`${N.name||""}${N.ext||""}`;return z?z===N.root?`${z}${R}`:`${z}${l}${R}`:R}t.$ec={resolve(...l){let N="",z="",R=!1;for(let d=l.length-1;d>=-1;d--){let D;if(d>=0){if(D=l[d],e(D,"path"),D.length===0)continue}else N.length===0?D=v.cwd():(D=v.env[`=${N}`]||v.cwd(),(D===void 0||D.slice(0,2).toLowerCase()!==N.toLowerCase()&&D.charCodeAt(2)===g)&&(D=`${N}\\`));const B=D.length;let _=0,x="",P=!1;const O=D.charCodeAt(0);if(B===1)a(O)&&(_=1,P=!0);else if(a(O))if(P=!0,a(D.charCodeAt(1))){let K=2,te=K;for(;K<B&&!a(D.charCodeAt(K));)K++;if(K<B&&K!==te){const se=D.slice(te,K);for(te=K;K<B&&a(D.charCodeAt(K));)K++;if(K<B&&K!==te){for(te=K;K<B&&!a(D.charCodeAt(K));)K++;(K===B||K!==te)&&(x=`\\\\${se}\\${D.slice(te,K)}`,_=K)}}}else _=1;else n(O)&&D.charCodeAt(1)===c&&(x=D.slice(0,2),_=2,B>2&&a(D.charCodeAt(2))&&(P=!0,_=3));if(x.length>0)if(N.length>0){if(x.toLowerCase()!==N.toLowerCase())continue}else N=x;if(R){if(N.length>0)break}else if(z=`${D.slice(_)}\\${z}`,R=P,P&&N.length>0)break}return z=r(z,!R,"\\",a),R?`${N}\\${z}`:`${N}${z}`||"."},normalize(l){e(l,"path");const N=l.length;if(N===0)return".";let z=0,R,d=!1;const D=l.charCodeAt(0);if(N===1)return m(D)?"\\":l;if(a(D))if(d=!0,a(l.charCodeAt(1))){let _=2,x=_;for(;_<N&&!a(l.charCodeAt(_));)_++;if(_<N&&_!==x){const P=l.slice(x,_);for(x=_;_<N&&a(l.charCodeAt(_));)_++;if(_<N&&_!==x){for(x=_;_<N&&!a(l.charCodeAt(_));)_++;if(_===N)return`\\\\${P}\\${l.slice(x)}\\`;_!==x&&(R=`\\\\${P}\\${l.slice(x,_)}`,z=_)}}}else z=1;else n(D)&&l.charCodeAt(1)===c&&(R=l.slice(0,2),z=2,N>2&&a(l.charCodeAt(2))&&(d=!0,z=3));let B=z<N?r(l.slice(z),!d,"\\",a):"";return B.length===0&&!d&&(B="."),B.length>0&&a(l.charCodeAt(N-1))&&(B+="\\"),R===void 0?d?`\\${B}`:B:d?`${R}\\${B}`:`${R}${B}`},isAbsolute(l){e(l,"path");const N=l.length;if(N===0)return!1;const z=l.charCodeAt(0);return a(z)||N>2&&n(z)&&l.charCodeAt(1)===c&&a(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let N,z;for(let D=0;D<l.length;++D){const B=l[D];e(B,"path"),B.length>0&&(N===void 0?N=z=B:N+=`\\${B}`)}if(N===void 0)return".";let R=!0,d=0;if(typeof z=="string"&&a(z.charCodeAt(0))){++d;const D=z.length;D>1&&a(z.charCodeAt(1))&&(++d,D>2&&(a(z.charCodeAt(2))?++d:R=!1))}if(R){for(;d<N.length&&a(N.charCodeAt(d));)d++;d>=2&&(N=`\\${N.slice(d)}`)}return t.$ec.normalize(N)},relative(l,N){if(e(l,"from"),e(N,"to"),l===N)return"";const z=t.$ec.resolve(l),R=t.$ec.resolve(N);if(z===R||(l=z.toLowerCase(),N=R.toLowerCase(),l===N))return"";let d=0;for(;d<l.length&&l.charCodeAt(d)===g;)d++;let D=l.length;for(;D-1>d&&l.charCodeAt(D-1)===g;)D--;const B=D-d;let _=0;for(;_<N.length&&N.charCodeAt(_)===g;)_++;let x=N.length;for(;x-1>_&&N.charCodeAt(x-1)===g;)x--;const P=x-_,O=B<P?B:P;let K=-1,te=0;for(;te<O;te++){const fe=l.charCodeAt(d+te);if(fe!==N.charCodeAt(_+te))break;fe===g&&(K=te)}if(te!==O){if(K===-1)return R}else{if(P>O){if(N.charCodeAt(_+te)===g)return R.slice(_+te+1);if(te===2)return R.slice(_+te)}B>O&&(l.charCodeAt(d+te)===g?K=te:te===2&&(K=3)),K===-1&&(K=0)}let se="";for(te=d+K+1;te<=D;++te)(te===D||l.charCodeAt(te)===g)&&(se+=se.length===0?"..":"\\..");return _+=K,se.length>0?`${se}${R.slice(_,x)}`:(R.charCodeAt(_)===g&&++_,R.slice(_,x))},toNamespacedPath(l){if(typeof l!="string"||l.length===0)return l;const N=t.$ec.resolve(l);if(N.length<=2)return l;if(N.charCodeAt(0)===g){if(N.charCodeAt(1)===g){const z=N.charCodeAt(2);if(z!==L&&z!==A)return`\\\\?\\UNC\\${N.slice(2)}`}}else if(n(N.charCodeAt(0))&&N.charCodeAt(1)===c&&N.charCodeAt(2)===g)return`\\\\?\\${N}`;return l},dirname(l){e(l,"path");const N=l.length;if(N===0)return".";let z=-1,R=0;const d=l.charCodeAt(0);if(N===1)return a(d)?l:".";if(a(d)){if(z=R=1,a(l.charCodeAt(1))){let _=2,x=_;for(;_<N&&!a(l.charCodeAt(_));)_++;if(_<N&&_!==x){for(x=_;_<N&&a(l.charCodeAt(_));)_++;if(_<N&&_!==x){for(x=_;_<N&&!a(l.charCodeAt(_));)_++;if(_===N)return l;_!==x&&(z=R=_+1)}}}}else n(d)&&l.charCodeAt(1)===c&&(z=N>2&&a(l.charCodeAt(2))?3:2,R=z);let D=-1,B=!0;for(let _=N-1;_>=R;--_)if(a(l.charCodeAt(_))){if(!B){D=_;break}}else B=!1;if(D===-1){if(z===-1)return".";D=z}return l.slice(0,D)},basename(l,N){N!==void 0&&e(N,"ext"),e(l,"path");let z=0,R=-1,d=!0,D;if(l.length>=2&&n(l.charCodeAt(0))&&l.charCodeAt(1)===c&&(z=2),N!==void 0&&N.length>0&&N.length<=l.length){if(N===l)return"";let B=N.length-1,_=-1;for(D=l.length-1;D>=z;--D){const x=l.charCodeAt(D);if(a(x)){if(!d){z=D+1;break}}else _===-1&&(d=!1,_=D+1),B>=0&&(x===N.charCodeAt(B)?--B===-1&&(R=D):(B=-1,R=_))}return z===R?R=_:R===-1&&(R=l.length),l.slice(z,R)}for(D=l.length-1;D>=z;--D)if(a(l.charCodeAt(D))){if(!d){z=D+1;break}}else R===-1&&(d=!1,R=D+1);return R===-1?"":l.slice(z,R)},extname(l){e(l,"path");let N=0,z=-1,R=0,d=-1,D=!0,B=0;l.length>=2&&l.charCodeAt(1)===c&&n(l.charCodeAt(0))&&(N=R=2);for(let _=l.length-1;_>=N;--_){const x=l.charCodeAt(_);if(a(x)){if(!D){R=_+1;break}continue}d===-1&&(D=!1,d=_+1),x===A?z===-1?z=_:B!==1&&(B=1):z!==-1&&(B=-1)}return z===-1||d===-1||B===0||B===1&&z===d-1&&z===R+1?"":l.slice(z,d)},format:b.bind(null,"\\"),parse(l){e(l,"path");const N={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return N;const z=l.length;let R=0,d=l.charCodeAt(0);if(z===1)return a(d)?(N.root=N.dir=l,N):(N.base=N.name=l,N);if(a(d)){if(R=1,a(l.charCodeAt(1))){let K=2,te=K;for(;K<z&&!a(l.charCodeAt(K));)K++;if(K<z&&K!==te){for(te=K;K<z&&a(l.charCodeAt(K));)K++;if(K<z&&K!==te){for(te=K;K<z&&!a(l.charCodeAt(K));)K++;K===z?R=K:K!==te&&(R=K+1)}}}}else if(n(d)&&l.charCodeAt(1)===c){if(z<=2)return N.root=N.dir=l,N;if(R=2,a(l.charCodeAt(2))){if(z===3)return N.root=N.dir=l,N;R=3}}R>0&&(N.root=l.slice(0,R));let D=-1,B=R,_=-1,x=!0,P=l.length-1,O=0;for(;P>=R;--P){if(d=l.charCodeAt(P),a(d)){if(!x){B=P+1;break}continue}_===-1&&(x=!1,_=P+1),d===A?D===-1?D=P:O!==1&&(O=1):D!==-1&&(O=-1)}return _!==-1&&(D===-1||O===0||O===1&&D===_-1&&D===B+1?N.base=N.name=l.slice(B,_):(N.name=l.slice(B,D),N.base=l.slice(B,_),N.ext=l.slice(D,_))),B>0&&B!==R?N.dir=l.slice(0,B-1):N.dir=N.root,N},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(o){const l=/\\/g;return()=>{const N=v.cwd().replace(l,"/");return N.slice(N.indexOf("/"))}}return()=>v.cwd()})();t.$fc={resolve(...l){let N="",z=!1;for(let R=l.length-1;R>=-1&&!z;R--){const d=R>=0?l[R]:u();e(d,"path"),d.length!==0&&(N=`${d}/${N}`,z=d.charCodeAt(0)===f)}return N=r(N,!z,"/",m),z?`/${N}`:N.length>0?N:"."},normalize(l){if(e(l,"path"),l.length===0)return".";const N=l.charCodeAt(0)===f,z=l.charCodeAt(l.length-1)===f;return l=r(l,!N,"/",m),l.length===0?N?"/":z?"./":".":(z&&(l+="/"),N?`/${l}`:l)},isAbsolute(l){return e(l,"path"),l.length>0&&l.charCodeAt(0)===f},join(...l){if(l.length===0)return".";let N;for(let z=0;z<l.length;++z){const R=l[z];e(R,"path"),R.length>0&&(N===void 0?N=R:N+=`/${R}`)}return N===void 0?".":t.$fc.normalize(N)},relative(l,N){if(e(l,"from"),e(N,"to"),l===N||(l=t.$fc.resolve(l),N=t.$fc.resolve(N),l===N))return"";const z=1,R=l.length,d=R-z,D=1,B=N.length-D,_=d<B?d:B;let x=-1,P=0;for(;P<_;P++){const K=l.charCodeAt(z+P);if(K!==N.charCodeAt(D+P))break;K===f&&(x=P)}if(P===_)if(B>_){if(N.charCodeAt(D+P)===f)return N.slice(D+P+1);if(P===0)return N.slice(D+P)}else d>_&&(l.charCodeAt(z+P)===f?x=P:P===0&&(x=0));let O="";for(P=z+x+1;P<=R;++P)(P===R||l.charCodeAt(P)===f)&&(O+=O.length===0?"..":"/..");return`${O}${N.slice(D+x)}`},toNamespacedPath(l){return l},dirname(l){if(e(l,"path"),l.length===0)return".";const N=l.charCodeAt(0)===f;let z=-1,R=!0;for(let d=l.length-1;d>=1;--d)if(l.charCodeAt(d)===f){if(!R){z=d;break}}else R=!1;return z===-1?N?"/":".":N&&z===1?"//":l.slice(0,z)},basename(l,N){N!==void 0&&e(N,"ext"),e(l,"path");let z=0,R=-1,d=!0,D;if(N!==void 0&&N.length>0&&N.length<=l.length){if(N===l)return"";let B=N.length-1,_=-1;for(D=l.length-1;D>=0;--D){const x=l.charCodeAt(D);if(x===f){if(!d){z=D+1;break}}else _===-1&&(d=!1,_=D+1),B>=0&&(x===N.charCodeAt(B)?--B===-1&&(R=D):(B=-1,R=_))}return z===R?R=_:R===-1&&(R=l.length),l.slice(z,R)}for(D=l.length-1;D>=0;--D)if(l.charCodeAt(D)===f){if(!d){z=D+1;break}}else R===-1&&(d=!1,R=D+1);return R===-1?"":l.slice(z,R)},extname(l){e(l,"path");let N=-1,z=0,R=-1,d=!0,D=0;for(let B=l.length-1;B>=0;--B){const _=l.charCodeAt(B);if(_===f){if(!d){z=B+1;break}continue}R===-1&&(d=!1,R=B+1),_===A?N===-1?N=B:D!==1&&(D=1):N!==-1&&(D=-1)}return N===-1||R===-1||D===0||D===1&&N===R-1&&N===z+1?"":l.slice(N,R)},format:b.bind(null,"/"),parse(l){e(l,"path");const N={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return N;const z=l.charCodeAt(0)===f;let R;z?(N.root="/",R=1):R=0;let d=-1,D=0,B=-1,_=!0,x=l.length-1,P=0;for(;x>=R;--x){const O=l.charCodeAt(x);if(O===f){if(!_){D=x+1;break}continue}B===-1&&(_=!1,B=x+1),O===A?d===-1?d=x:P!==1&&(P=1):d!==-1&&(P=-1)}if(B!==-1){const O=D===0&&z?1:D;d===-1||P===0||P===1&&d===B-1&&d===D+1?N.base=N.name=l.slice(O,B):(N.name=l.slice(O,d),N.base=l.slice(O,B),N.ext=l.slice(d,B))}return D>0?N.dir=l.slice(0,D-1):z&&(N.dir="/"),N},sep:"/",delimiter:":",win32:null,posix:null},t.$fc.win32=t.$ec.win32=t.$ec,t.$fc.posix=t.$ec.posix=t.$fc,t.$gc=o?t.$ec.normalize:t.$fc.normalize,t.$hc=o?t.$ec.isAbsolute:t.$fc.isAbsolute,t.$ic=o?t.$ec.join:t.$fc.join,t.$jc=o?t.$ec.resolve:t.$fc.resolve,t.$kc=o?t.$ec.relative:t.$fc.relative,t.$lc=o?t.$ec.dirname:t.$fc.dirname,t.$mc=o?t.$ec.basename:t.$fc.basename,t.$nc=o?t.$ec.extname:t.$fc.extname,t.$oc=o?t.$ec.format:t.$fc.format,t.$pc=o?t.$ec.parse:t.$fc.parse,t.$qc=o?t.$ec.toNamespacedPath:t.$fc.toNamespacedPath,t.sep=o?t.$ec.sep:t.$fc.sep,t.$sc=o?t.$ec.delimiter:t.$fc.delimiter}),define($e[115],we([1,0,23,5,12,7]),function(ae,t,v,T,i,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=void 0;function w(D){return D===47||D===92}t.$Rf=w;function A(D){return D.replace(/[\\/]/g,v.$fc.sep)}t.$Sf=A;function f(D){return D.indexOf("/")===-1&&(D=A(D)),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D),D}t.$Tf=f;function g(D,B=v.$fc.sep){if(!D)return"";const _=D.length,x=D.charCodeAt(0);if(w(x)){if(w(D.charCodeAt(1))&&!w(D.charCodeAt(2))){let O=3;const K=O;for(;O<_&&!w(D.charCodeAt(O));O++);if(K!==O&&!w(D.charCodeAt(O+1))){for(O+=1;O<_;O++)if(w(D.charCodeAt(O)))return D.slice(0,O+1).replace(/[\\/]/g,B)}}return B}else if(m(x)&&D.charCodeAt(1)===58)return w(D.charCodeAt(2))?D.slice(0,2)+B:D.slice(0,2);let P=D.indexOf("://");if(P!==-1){for(P+=3;P<_;P++)if(w(D.charCodeAt(P)))return D.slice(0,P+1)}return""}t.$Uf=g;function c(D){if(!T.$i||!D||D.length<5)return!1;let B=D.charCodeAt(0);if(B!==92||(B=D.charCodeAt(1),B!==92))return!1;let _=2;const x=_;for(;_<D.length&&(B=D.charCodeAt(_),B!==92);_++);return!(x===_||(B=D.charCodeAt(_+1),isNaN(B)||B===92))}t.$Vf=c;const L=/[\\/:\*\?"<>\|]/g,s=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(D,B=T.$i){const _=B?L:s;return!(!D||D.length===0||/^\s+$/.test(D)||(_.lastIndex=0,_.test(D))||B&&h.test(D)||D==="."||D===".."||B&&D[D.length-1]==="."||B&&D.length!==D.trim().length||D.length>255)}t.$Wf=e;function o(D,B,_){const x=D===B;return!_||x?x:!D||!B?!1:(0,i.$3e)(D,B)}t.$Xf=o;function a(D,B,_,x=v.sep){if(D===B)return!0;if(!D||!B||B.length>D.length)return!1;if(_){if(!(0,i.$4e)(D,B))return!1;if(B.length===D.length)return!0;let O=B.length;return B.charAt(B.length-1)===x&&O--,D.charAt(O)===x}return B.charAt(B.length-1)!==x&&(B+=x),D.indexOf(B)===0}t.$Yf=a;function m(D){return D>=65&&D<=90||D>=97&&D<=122}t.$Zf=m;function n(D,B){return T.$i&&D.endsWith(":")&&(D+=v.sep),(0,v.$hc)(D)||(D=(0,v.$ic)(B,D)),D=(0,v.$gc)(D),T.$i?(D=(0,i.$Le)(D,v.sep),D.endsWith(":")&&(D+=v.sep)):(D=(0,i.$Le)(D,v.sep),D||(D=v.sep)),D}t.$1f=n;function r(D){const B=(0,v.$gc)(D);return T.$i?D.length>3?!1:b(B)&&(D.length===2||B.charCodeAt(2)===92):B===v.$fc.sep}t.$2f=r;function b(D,B=T.$i){return B?m(D.charCodeAt(0))&&D.charCodeAt(1)===58:!1}t.$3f=b;function u(D,B=T.$i){return b(D,B)?D[0]:void 0}t.$4f=u;function l(D,B,_){return B.length>D.length?-1:D===B?0:(_&&(D=D.toLowerCase(),B=B.toLowerCase()),D.indexOf(B))}t.$5f=l;function N(D){const B=D.split(":");let _,x,P;for(const O of B){const K=Number(O);(0,H.$Df)(K)?x===void 0?x=K:P===void 0&&(P=K):_=_?[_,O].join(":"):O}if(!_)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:_,line:x!==void 0?x:void 0,column:P!==void 0?P:x!==void 0?1:void 0}}t.$6f=N;const z="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function d(D,B,_=8){let x="";for(let O=0;O<_;O++){let K;O===0&&T.$i&&!B&&(_===3||_===4)?K=R:K=z,x+=K.charAt(Math.floor(Math.random()*K.length))}let P;return B?P=`${B}-${x}`:P=x,D?(0,v.$ic)(D,P):P}t.$7f=d}),define($e[116],we([1,0,23]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wr=t.$Vr=t.$Ur=t.$Tr=t.$Sr=void 0,t.$Sr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function H(c){const L=(0,v.$nc)(c),s=T[L.toLowerCase()];return s!==void 0?s:w(c)}t.$Tr=H;function w(c){const L=(0,v.$nc)(c);return i[L.toLowerCase()]}t.$Ur=w;function A(c){for(const L in i)if(i[L]===c)return L}t.$Vr=A;const f=/^(.+)\/(.+?)(;.+)?$/;function g(c,L){const s=f.exec(c);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:L?void 0:c}t.$Wr=g}),define($e[16],we([1,0,23,5]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vc=t.$uc=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,H=/^\//,w=/^\/\//;function A(R,d){if(!R.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!i.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!H.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(R,d){return!R&&!d?"file":R}function g(R,d){switch(R){case"https":case"http":case"file":d?d[0]!==L&&(d=L+d):d=L;break}return d}const c="",L="/",s=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(d){return d instanceof h?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}constructor(d,D,B,_,x,P=!1){typeof d=="object"?(this.scheme=d.scheme||c,this.authority=d.authority||c,this.path=d.path||c,this.query=d.query||c,this.fragment=d.fragment||c):(this.scheme=f(d,P),this.authority=D||c,this.path=g(this.scheme,B||c),this.query=_||c,this.fragment=x||c,A(this,P))}get fsPath(){return b(this,!1)}with(d){if(!d)return this;let{scheme:D,authority:B,path:_,query:x,fragment:P}=d;return D===void 0?D=this.scheme:D===null&&(D=c),B===void 0?B=this.authority:B===null&&(B=c),_===void 0?_=this.path:_===null&&(_=c),x===void 0?x=this.query:x===null&&(x=c),P===void 0?P=this.fragment:P===null&&(P=c),D===this.scheme&&B===this.authority&&_===this.path&&x===this.query&&P===this.fragment?this:new a(D,B,_,x,P)}static parse(d,D=!1){const B=s.exec(d);return B?new a(B[2]||c,z(B[4]||c),z(B[5]||c),z(B[7]||c),z(B[9]||c),D):new a(c,c,c,c,c)}static file(d){let D=c;if(T.$i&&(d=d.replace(/\\/g,L)),d[0]===L&&d[1]===L){const B=d.indexOf(L,2);B===-1?(D=d.substring(2),d=L):(D=d.substring(2,B),d=d.substring(B)||L)}return new a("file",D,d,c,c)}static from(d,D){return new a(d.scheme,d.authority,d.path,d.query,d.fragment,D)}static joinPath(d,...D){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let B;return T.$i&&d.scheme==="file"?B=h.file(v.$ec.join(b(d,!0),...D)).path:B=v.$fc.join(d.path,...D),d.with({path:B})}toString(d=!1){return u(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof h)return d;{const D=new a(d);return D._formatted=d.external??null,D._fsPath=d._sep===o?d.fsPath??null:null,D}}else return d}}t.URI=h;function e(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}t.$uc=e;const o=T.$i?1:void 0;class a extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(d=!1){return d?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const d={$mid:1};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=o),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function n(R,d,D){let B,_=-1;for(let x=0;x<R.length;x++){const P=R.charCodeAt(x);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||d&&P===47||D&&P===91||D&&P===93||D&&P===58)_!==-1&&(B+=encodeURIComponent(R.substring(_,x)),_=-1),B!==void 0&&(B+=R.charAt(x));else{B===void 0&&(B=R.substr(0,x));const O=m[P];O!==void 0?(_!==-1&&(B+=encodeURIComponent(R.substring(_,x)),_=-1),B+=O):_===-1&&(_=x)}}return _!==-1&&(B+=encodeURIComponent(R.substring(_))),B!==void 0?B:R}function r(R){let d;for(let D=0;D<R.length;D++){const B=R.charCodeAt(D);B===35||B===63?(d===void 0&&(d=R.substr(0,D)),d+=m[B]):d!==void 0&&(d+=R[D])}return d!==void 0?d:R}function b(R,d){let D;return R.authority&&R.path.length>1&&R.scheme==="file"?D=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===47&&(R.path.charCodeAt(1)>=65&&R.path.charCodeAt(1)<=90||R.path.charCodeAt(1)>=97&&R.path.charCodeAt(1)<=122)&&R.path.charCodeAt(2)===58?d?D=R.path.substr(1):D=R.path[1].toLowerCase()+R.path.substr(2):D=R.path,T.$i&&(D=D.replace(/\//g,"\\")),D}t.$vc=b;function u(R,d){const D=d?r:n;let B="",{scheme:_,authority:x,path:P,query:O,fragment:K}=R;if(_&&(B+=_,B+=":"),(x||_==="file")&&(B+=L,B+=L),x){let te=x.indexOf("@");if(te!==-1){const se=x.substr(0,te);x=x.substr(te+1),te=se.lastIndexOf(":"),te===-1?B+=D(se,!1,!1):(B+=D(se.substr(0,te),!1,!1),B+=":",B+=D(se.substr(te+1),!1,!0)),B+="@"}x=x.toLowerCase(),te=x.lastIndexOf(":"),te===-1?B+=D(x,!1,!0):(B+=D(x.substr(0,te),!1,!0),B+=x.substr(te))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const te=P.charCodeAt(1);te>=65&&te<=90&&(P=`/${String.fromCharCode(te+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const te=P.charCodeAt(0);te>=65&&te<=90&&(P=`${String.fromCharCode(te+32)}:${P.substr(2)}`)}B+=D(P,!0,!1)}return O&&(B+="?",B+=D(O,!1,!1)),K&&(B+="#",B+=d?K:n(K,!1,!1)),B}function l(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+l(R.substr(3)):R}}const N=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function z(R){return R.match(N)?R.replace(N,d=>l(d)):R}}),define($e[53],we([1,0,33,16]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ph=t.$oh=t.$nh=void 0;function i(f){return JSON.stringify(f,w)}t.$nh=i;function H(f){let g=JSON.parse(f);return g=A(g),g}t.$oh=H;function w(f,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function A(f,g=0){if(!f||g>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return T.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof v.$ce||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let c=0;c<f.length;++c)f[c]=A(f[c],g+1);else for(const c in f)Object.hasOwnProperty.call(f,c)&&(f[c]=A(f[c],g+1))}return f}t.$ph=A}),define($e[31],we([1,0,6,5,16]),function(ae,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$dg=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.Schemas=void 0;var H;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(H||(t.Schemas=H={})),t.$8f="vscode-tkn",t.$9f="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${H.vscodeRemoteResource}`}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c){this.f=`${c}/${H.vscodeRemoteResource}`}set(c,L,s){this.a[c]=L,this.b[c]=s}setConnectionToken(c,L){this.c[c]=L}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(a){return v.$Z(a),c}const L=c.authority;let s=this.a[L];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const h=this.b[L],e=this.c[L];let o=`path=${encodeURIComponent(c.path)}`;return typeof e=="string"&&(o+=`&${t.$9f}=${encodeURIComponent(e)}`),i.URI.from({scheme:T.$o?this.d:H.vscodeRemoteResource,authority:`${s}:${h}`,path:this.f,query:o})}}t.$0f=new w,t.$$f="vs/../../extensions",t.$_f="vs/../../node_modules",t.$ag="vs/../../node_modules.asar",t.$bg="vs/../../node_modules.asar.unpacked",t.$cg="vscode-app";class A{static{this.a=t.$cg}asBrowserUri(c){const L=this.b(c,ae);return this.uriToBrowserUri(L)}uriToBrowserUri(c){return c.scheme===H.vscodeRemote?t.$0f.rewrite(c):c.scheme===H.file&&(T.$m||T.$q===`${H.vscodeFileResource}://${A.a}`)?c.with({scheme:H.vscodeFileResource,authority:c.authority||A.a,query:null,fragment:null}):c}asFileUri(c){const L=this.b(c,ae);return this.uriToFileUri(L)}uriToFileUri(c){return c.scheme===H.vscodeFileResource?c.with({scheme:H.file,authority:c.authority!==A.a?c.authority:null,query:null,fragment:null}):c}b(c,L){return i.URI.isUri(c)?c:i.URI.parse(L.toUrl(c))}}t.$dg=new A;var f;(function(g){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(c.get("3"));const L="vscode-coi";function s(e){let o;typeof e=="string"?o=new URL(e).searchParams:e instanceof URL?o=e.searchParams:i.URI.isUri(e)&&(o=new URL(e.toString(!0)).searchParams);const a=o?.get(L);if(a)return c.get(a)}g.getHeadersFromQuery=s;function h(e,o,a){if(!globalThis.crossOriginIsolated)return;const m=o&&a?"3":a?"2":"1";e instanceof URLSearchParams?e.set(L,m):e[L]=m}g.addSearchParam=h})(f||(t.COI=f={}))}),define($e[37],we([1,0,115,31,23,5,12,16]),function(ae,t,v,T,i,H,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gg=t.DataUri=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=t.$rg=t.$qg=t.$pg=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=void 0;function f(h){return(0,A.$vc)(h,!0)}t.$kg=f;class g{constructor(e){this.a=e}compare(e,o,a=!1){return e===o?0:(0,w.$Ve)(this.getComparisonKey(e,a),this.getComparisonKey(o,a))}isEqual(e,o,a=!1){return e===o?!0:!e||!o?!1:this.getComparisonKey(e,a)===this.getComparisonKey(o,a)}getComparisonKey(e,o=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,o,a=!1){if(e.scheme===o.scheme){if(e.scheme===T.Schemas.file)return v.$Yf(f(e),f(o),this.a(e))&&e.query===o.query&&(a||e.fragment===o.fragment);if((0,t.$Bg)(e.authority,o.authority))return v.$Yf(e.path,o.path,this.a(e),"/")&&e.query===o.query&&(a||e.fragment===o.fragment)}return!1}joinPath(e,...o){return A.URI.joinPath(e,...o)}basenameOrAuthority(e){return(0,t.$tg)(e)||e.authority}basename(e){return i.$fc.basename(e.path)}extname(e){return i.$fc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let o;return e.scheme===T.Schemas.file?o=A.URI.file(i.$lc(f(e))).path:(o=i.$fc.dirname(e.path),e.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),o="/")),e.with({path:o})}normalizePath(e){if(!e.path.length)return e;let o;return e.scheme===T.Schemas.file?o=A.URI.file(i.$gc(f(e))).path:o=i.$fc.normalize(e.path),e.with({path:o})}relativePath(e,o){if(e.scheme!==o.scheme||!(0,t.$Bg)(e.authority,o.authority))return;if(e.scheme===T.Schemas.file){const n=i.$kc(f(e),f(o));return H.$i?v.$Sf(n):n}let a=e.path||"/";const m=o.path||"/";if(this.a(e)){let n=0;for(const r=Math.min(a.length,m.length);n<r&&!(a.charCodeAt(n)!==m.charCodeAt(n)&&a.charAt(n).toLowerCase()!==m.charAt(n).toLowerCase());n++);a=m.substr(0,n)+a.substr(n)}return i.$fc.relative(a,m)}resolvePath(e,o){if(e.scheme===T.Schemas.file){const a=A.URI.file(i.$jc(f(e),o));return e.with({authority:a.authority,path:a.path})}return o=v.$Tf(o),e.with({path:i.$fc.resolve(e.path,o)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,o){return e===o||e!==void 0&&o!==void 0&&(0,w.$3e)(e,o)}hasTrailingPathSeparator(e,o=i.sep){if(e.scheme===T.Schemas.file){const a=f(e);return a.length>v.$Uf(a).length&&a[a.length-1]===o}else{const a=e.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,o=i.sep){return(0,t.$Cg)(e,o)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,o=i.sep){let a=!1;if(e.scheme===T.Schemas.file){const m=f(e);a=m!==void 0&&m.length===v.$Uf(m).length&&m[m.length-1]===o}else{o="/";const m=e.path;a=m.length===1&&m.charCodeAt(m.length-1)===47}return!a&&!(0,t.$Cg)(e,o)?e.with({path:e.path+"/"}):e}}t.$lg=g,t.$mg=new g(()=>!1),t.$ng=new g(h=>h.scheme===T.Schemas.file?!H.$k:!0),t.$og=new g(h=>!0),t.$pg=t.$mg.isEqual.bind(t.$mg),t.$qg=t.$mg.isEqualOrParent.bind(t.$mg),t.$rg=t.$mg.getComparisonKey.bind(t.$mg),t.$sg=t.$mg.basenameOrAuthority.bind(t.$mg),t.$tg=t.$mg.basename.bind(t.$mg),t.$ug=t.$mg.extname.bind(t.$mg),t.$vg=t.$mg.dirname.bind(t.$mg),t.$wg=t.$mg.joinPath.bind(t.$mg),t.$xg=t.$mg.normalizePath.bind(t.$mg),t.$yg=t.$mg.relativePath.bind(t.$mg),t.$zg=t.$mg.resolvePath.bind(t.$mg),t.$Ag=t.$mg.isAbsolutePath.bind(t.$mg),t.$Bg=t.$mg.isEqualAuthority.bind(t.$mg),t.$Cg=t.$mg.hasTrailingPathSeparator.bind(t.$mg),t.$Dg=t.$mg.removeTrailingPathSeparator.bind(t.$mg),t.$Eg=t.$mg.addTrailingPathSeparator.bind(t.$mg);function c(h,e){const o=[];for(let a=0;a<h.length;a++){const m=e(h[a]);h.some((n,r)=>r===a?!1:(0,t.$qg)(m,e(n)))||o.push(h[a])}return o}t.$Fg=c;var L;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function e(o){const a=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(r=>{const[b,u]=r.split(":");b&&u&&a.set(b,u)});const n=o.path.substring(0,o.path.indexOf(";"));return n&&a.set(h.META_DATA_MIME,n),a}h.parseMetaData=e})(L||(t.DataUri=L={}));function s(h,e,o){if(e){let a=h.path;return a&&a[0]!==i.$fc.sep&&(a=i.$fc.sep+a),h.with({scheme:o,authority:e,path:a})}return h.with({scheme:o})}t.$Gg=s}),define($e[9],we([1,0,29,6,4,2,37,5,50]),function(ae,t,v,T,i,H,w,A,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jh=t.$ih=t.$hh=t.$gh=t.Promises=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=void 0;function g(Q){return!!Q&&typeof Q.then=="function"}t.$Hg=g;function c(Q){const p=new v.$Yd,E=Q(p.token),y=new Promise((M,k)=>{const I=p.token.onCancellationRequested(()=>{I.dispose(),p.dispose(),k(new T.$4)});Promise.resolve(E).then(C=>{I.dispose(),p.dispose(),M(C)},C=>{I.dispose(),p.dispose(),k(C)})});return new class{cancel(){p.cancel()}then(M,k){return y.then(M,k)}catch(M){return this.then(void 0,M)}finally(M){return y.finally(M)}}}t.$Ig=c;function L(Q,p,E){return new Promise((y,M)=>{const k=p.onCancellationRequested(()=>{k.dispose(),y(E)});Q.then(y,M).finally(()=>k.dispose())})}t.$Jg=L;function s(Q,p){return new Promise((E,y)=>{const M=p.onCancellationRequested(()=>{M.dispose(),y(new T.$4)});Q.then(E,y).finally(()=>M.dispose())})}t.$Kg=s;async function h(Q){let p=-1;const E=Q.map((y,M)=>y.then(k=>(p=M,k)));try{return await Promise.race(E)}finally{Q.forEach((y,M)=>{M!==p&&y.cancel()})}}t.$Lg=h;function e(Q,p,E){let y;const M=setTimeout(()=>{y?.(void 0),E?.()},p);return Promise.race([Q.finally(()=>clearTimeout(M)),new Promise(k=>y=k)])}t.$Mg=e;function o(Q){return new Promise((p,E)=>{const y=Q();g(y)?y.then(p,E):p(y)})}t.$Ng=o;class a{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(p){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=p,!this.b){const E=()=>{if(this.b=null,this.f)return;const y=this.queue(this.d);return this.d=null,y};this.b=new Promise(y=>{this.a.then(E,E).then(y)})}return new Promise((E,y)=>{this.b.then(E,y)})}return this.a=p(),new Promise((E,y)=>{this.a.then(M=>{this.a=null,E(M)},M=>{this.a=null,y(M)})})}dispose(){this.f=!0}}t.$Og=a;class m{constructor(){this.a=Promise.resolve(null)}queue(p){return this.a=this.a.then(()=>p(),()=>p())}}t.$Pg=m;class n{constructor(){this.a=new Map}queue(p,E){const M=(this.a.get(p)??Promise.resolve()).catch(()=>{}).then(E).finally(()=>{this.a.get(p)===M&&this.a.delete(p)});return this.a.set(p,M),M}}t.$Qg=n;const r=(Q,p)=>{let E=!0;const y=setTimeout(()=>{E=!1,p()},Q);return{isTriggered:()=>E,dispose:()=>{clearTimeout(y),E=!1}}},b=Q=>{let p=!0;return queueMicrotask(()=>{p&&(p=!1,Q())}),{isTriggered:()=>p,dispose:()=>{p=!1}}};class u{constructor(p){this.defaultDelay=p,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(p,E=this.defaultDelay){this.g=p,this.h(),this.b||(this.b=new Promise((M,k)=>{this.d=M,this.f=k}).then(()=>{if(this.b=null,this.d=null,this.g){const M=this.g;return this.g=null,M()}}));const y=()=>{this.a=null,this.d?.(null)};return this.a=E===f.$Ld?b(y):r(E,y),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Rg=u;class l{constructor(p){this.a=new u(p),this.b=new a}trigger(p,E){return this.a.trigger(()=>this.b.queue(p),E)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Sg=l;class N{constructor(){this.a=!1,this.b=new Promise((p,E)=>{this.d=p})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Tg=N;class z extends N{constructor(p){super(),this.f=setTimeout(()=>this.open(),p)}open(){clearTimeout(this.f),super.open()}}t.$Ug=z;function R(Q,p){return p?new Promise((E,y)=>{const M=setTimeout(()=>{k.dispose(),E()},Q),k=p.onCancellationRequested(()=>{clearTimeout(M),k.dispose(),y(new T.$4)})}):c(E=>R(Q,E))}t.$Vg=R;function d(Q,p=0,E){const y=setTimeout(()=>{Q(),E&&M.dispose()},p),M=(0,H.$Pc)(()=>{clearTimeout(y),E?.deleteAndLeak(M)});return E?.add(M),M}t.$Wg=d;function D(Q){const p=[];let E=0;const y=Q.length;function M(){return E<y?Q[E++]():null}function k(I){I!=null&&p.push(I);const C=M();return C?C.then(k):Promise.resolve(p)}return Promise.resolve(null).then(k)}t.$Xg=D;function B(Q,p=y=>!!y,E=null){let y=0;const M=Q.length,k=()=>{if(y>=M)return Promise.resolve(E);const I=Q[y++];return Promise.resolve(I()).then(F=>p(F)?Promise.resolve(F):k())};return k()}t.$Yg=B;function _(Q,p=y=>!!y,E=null){if(Q.length===0)return Promise.resolve(E);let y=Q.length;const M=()=>{y=-1;for(const k of Q)k.cancel?.()};return new Promise((k,I)=>{for(const C of Q)C.then(F=>{--y>=0&&p(F)?(M(),k(F)):y===0&&k(E)}).catch(F=>{--y>=0&&(M(),I(F))})})}t.$Zg=_;class x{constructor(p){this.a=0,this.d=p,this.f=[],this.b=0,this.g=new i.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue(p){return this.a++,new Promise((E,y)=>{this.f.push({factory:p,c:E,e:y}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const p=this.f.shift();this.b++;const E=p.factory();E.then(p.c,p.e),E.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$1g=x;class P extends x{constructor(){super(1)}}t.$2g=P;class O{constructor(){this.a=new de,this.b=0}queue(p){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,p())):this.a.run(this.b++,p())}}t.$3g=O;class K{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const p=new Z;return this.b.add(p),p.p}g(){for(const[,p]of this.a)if(p.size>0)return!1;return!0}queueFor(p,E=w.$mg){const y=E.getComparisonKey(p);let M=this.a.get(y);if(!M){M=new P;const k=this.f++,I=i.Event.once(M.onDrained)(()=>{M?.dispose(),this.a.delete(y),this.h(),this.d?.deleteAndDispose(k),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new H.$Zc),this.d.set(k,I),this.a.set(y,M)}return M}h(){this.g()&&this.j()}j(){for(const p of this.b)p.complete();this.b.clear()}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$4g=K;class te{constructor(p,E){this.a=-1,typeof p=="function"&&typeof E=="number"&&this.setIfNotSet(p,E)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(p,E){this.cancel(),this.a=setTimeout(()=>{this.a=-1,p()},E)}setIfNotSet(p,E){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,p()},E))}}t.$5g=te;class se{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(p,E,y=globalThis){this.cancel();const M=y.setInterval(()=>{p()},E);this.d=(0,H.$Pc)(()=>{y.clearInterval(M),this.d=void 0})}dispose(){this.cancel()}}t.$6g=se;class fe{constructor(p,E){this.b=-1,this.a=p,this.d=E,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(p=this.d){this.cancel(),this.b=setTimeout(this.f,p)}get delay(){return this.d}set delay(p){this.d=p}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$7g=fe;class le{constructor(p,E){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.a=p,this.b=E,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(p=this.b){p%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${p}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(p/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$8g=le;class oe extends fe{constructor(p,E){super(p,E),this.j=[]}work(p){this.j.push(p),this.isScheduled()||this.schedule()}h(){const p=this.j;this.j=[],this.a?.(p)}dispose(){this.j=[],super.dispose()}}t.$9g=oe;class be extends H.$Rc{constructor(p,E){super(),this.g=p,this.h=E,this.a=[],this.b=this.B(new H.$Sc),this.f=!1}get pending(){return this.a.length}work(p){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+p.length>this.g.maxBufferedWork)return!1}else if(this.pending+p.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const E of p)this.a.push(E);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new fe(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$0g=be,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$_g=(Q,p)=>{(0,A.$B)(()=>{if(E)return;const y=Date.now()+15;p(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,y-Date.now())}}))});let E=!1;return{dispose(){E||(E=!0)}}}:t.$_g=(Q,p,E)=>{const y=Q.requestIdleCallback(p,typeof E=="number"?{timeout:E}:void 0);let M=!1;return{dispose(){M||(M=!0,Q.cancelIdleCallback(y))}}},t.$$g=Q=>(0,t.$_g)(globalThis,Q)}();class Ce{constructor(p,E){this.g=!1,this.d=()=>{try{this.j=E()}catch(y){this.l=y}finally{this.g=!0}},this.f=(0,t.$_g)(p,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$ah=Ce;class Ae extends Ce{constructor(p){super(globalThis,p)}}t.$bh=Ae;async function Pe(Q,p,E){let y;for(let M=0;M<E;M++)try{return await Q()}catch(k){y=k,await R(p)}throw y}t.$ch=Pe;class de{isRunning(p){return typeof p=="number"?this.a?.taskId===p:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(p,E,y){return this.a={taskId:p,cancel:()=>y?.(),promise:E},E.then(()=>this.d(p),()=>this.d(p)),E}d(p){this.a&&p===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const p=this.b;this.b=void 0,p.run().then(p.promiseResolve,p.promiseReject)}}queue(p){if(this.b)this.b.run=p;else{let E,y;const M=new Promise((k,I)=>{E=k,y=I});this.b={run:p,promise:M,promiseResolve:E,promiseReject:y}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$dh=de;class ie{constructor(p,E=()=>Date.now()){this.d=p,this.f=E,this.a=0,this.b=0}increment(){const p=this.f();return p-this.a>this.d&&(this.a=p,this.b=0),this.b++,this.b}}t.$eh=ie;var ce;(function(Q){Q[Q.Resolved=0]="Resolved",Q[Q.Rejected=1]="Rejected"})(ce||(ce={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((p,E)=>{this.a=p,this.b=E})}complete(p){return new Promise(E=>{this.a(p),this.d={outcome:0,value:p},E()})}error(p){return new Promise(E=>{this.b(p),this.d={outcome:1,value:p},E()})}cancel(){return this.error(new T.$4)}}t.$fh=Z;var W;(function(Q){async function p(y){let M;const k=await Promise.all(y.map(I=>I.then(C=>C,C=>{M||(M=C)})));if(typeof M<"u")throw M;return k}Q.settled=p;function E(y){return new Promise(async(M,k)=>{try{await y(M,k)}catch(I){k(I)}})}Q.withAsyncBody=E})(W||(t.Promises=W={}));var Y;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(Y||(Y={}));class S{static fromArray(p){return new S(E=>{E.emitMany(p)})}static fromPromise(p){return new S(async E=>{E.emitMany(await p)})}static fromPromises(p){return new S(async E=>{await Promise.all(p.map(async y=>E.emitOne(await y)))})}static merge(p){return new S(async E=>{await Promise.all(p.map(async y=>{for await(const M of y)E.emitOne(M)}))})}static{this.EMPTY=S.fromArray([])}constructor(p){this.a=0,this.b=[],this.d=null,this.f=new i.$Od,queueMicrotask(async()=>{const E={emitOne:y=>this.g(y),emitMany:y=>this.h(y),reject:y=>this.k(y)};try{await Promise.resolve(p(E)),this.j()}catch(y){this.k(y)}finally{E.emitOne=void 0,E.emitMany=void 0,E.reject=void 0}})}[Symbol.asyncIterator](){let p=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(p<this.b.length)return{done:!1,value:this.b[p++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(p,E){return new S(async y=>{for await(const M of p)y.emitOne(E(M))})}map(p){return S.map(this,p)}static filter(p,E){return new S(async y=>{for await(const M of p)E(M)&&y.emitOne(M)})}filter(p){return S.filter(this,p)}static coalesce(p){return S.filter(p,E=>!!E)}coalesce(){return S.coalesce(this)}static async toPromise(p){const E=[];for await(const y of p)E.push(y);return E}toPromise(){return S.toPromise(this)}g(p){this.a===0&&(this.b.push(p),this.f.fire())}h(p){this.a===0&&(this.b=this.b.concat(p),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(p){this.a===0&&(this.a=2,this.d=p,this.f.fire())}}t.$gh=S;class q extends S{constructor(p,E){super(E),this.l=p}cancel(){this.l.cancel()}}t.$hh=q;function $(Q){const p=new v.$Yd,E=Q(p.token);return new q(p,async y=>{const M=p.token.onCancellationRequested(()=>{M.dispose(),p.dispose(),y.reject(new T.$4)});try{for await(const k of E){if(p.token.isCancellationRequested)return;y.emitOne(k)}M.dispose(),p.dispose()}catch(k){M.dispose(),p.dispose(),y.reject(k)}})}t.$ih=$;class U{constructor(){this.a=new Z,this.b=new S(y=>{if(p){y.reject(p);return}return E&&y.emitMany(E),this.d=M=>y.reject(M),this.f=M=>y.emitOne(M),this.a.p});let p,E;this.f=y=>{E||(E=[]),E.push(y)},this.d=y=>{p||(p=y)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(p){this.d(p),this.a.complete()}emitOne(p){this.f(p)}}t.$jh=U}),define($e[3],we([1,0,17,113,15,20,9,6,4,117,2,31,5,16,49,14]),function(ae,t,v,T,i,H,w,A,f,g,c,L,s,h,e,o){"use strict";var a;Object.defineProperty(t,"__esModule",{value:!0}),t.$qQ=t.$pQ=t.h=t.$nQ=t.$mQ=t.$lQ=t.$kQ=t.$jQ=t.$iQ=t.$hQ=t.$gQ=t.DetectedFullscreenMode=t.$fQ=t.$eQ=t.$dQ=t.$cQ=t.$bQ=t.$aQ=t.$_P=t.$$P=t.$0P=t.$9P=t.$8P=t.$7P=t.$6P=t.$5P=t.$4P=t.$3P=t.$2P=t.$=t.Namespace=t.$ZP=t.$YP=t.$XP=t.$WP=t.$VP=t.$UP=t.$TP=t.$SP=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.$wP=t.$vP=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.$3O=t.$2O=t.$1O=t.$ZO=t.$YO=t.$XO=t.$WO=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.getWindowId=t.getWindowsCount=t.getWindows=t.registerWindow=void 0,a=function(){const V=new Map;typeof o.$rO.vscodeWindowId!="number"&&Object.defineProperty(o.$rO,"vscodeWindowId",{get:()=>1}),V.set(o.$rO.vscodeWindowId,{window:o.$rO,disposables:new c.$Qc});const G=new f.$Od,re=new f.$Od,ge=new f.$Od;return{onDidRegisterWindow:G.event,onWillUnregisterWindow:ge.event,onDidUnregisterWindow:re.event,registerWindow(ye){if(V.has(ye.vscodeWindowId))return c.$Rc.None;const Re=new c.$Qc,ze={window:ye,disposables:Re.add(new c.$Qc)};return V.set(ye.vscodeWindowId,ze),Re.add((0,c.$Pc)(()=>{V.delete(ye.vscodeWindowId),re.fire(ye)})),Re.add(r(ye,t.$QP.BEFORE_UNLOAD,()=>{ge.fire(ye)})),G.fire(ze),Re},getWindows(){return V.values()},getWindowsCount(){return V.size},getWindowId(ye){return ye.vscodeWindowId}}}(),t.registerWindow=a.registerWindow,t.getWindows=a.getWindows,t.getWindowsCount=a.getWindowsCount,t.getWindowId=a.getWindowId,t.onDidRegisterWindow=a.onDidRegisterWindow,t.onWillUnregisterWindow=a.onWillUnregisterWindow,t.onDidUnregisterWindow=a.onDidUnregisterWindow;function m(V){for(;V.firstChild;)V.firstChild.remove()}t.$WO=m;class n{constructor(G,re,ge,ye){this.f=G,this.g=re,this.d=ge,this.j=ye||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function r(V,G,re,ge){return new n(V,G,re,ge)}t.$XO=r;function b(V){return function(G){return V(new H.$PO(G))}}function u(V){return function(G){return V(new i.$UO(G))}}const l=function(G,re,ge,ye){let Re=ge;return re==="click"||re==="mousedown"?Re=b(ge):(re==="keydown"||re==="keypress"||re==="keyup")&&(Re=u(ge)),r(G,re,Re,ye)};t.$YO=l;const N=function(G,re,ge){const ye=b(re);return R(G,ye,ge)};t.$ZO=N;const z=function(G,re,ge){const ye=b(re);return D(G,ye,ge)};t.$1O=z;function R(V,G,re){return r(V,s.$r&&T.$MO.pointerEvents?t.$QP.POINTER_DOWN:t.$QP.MOUSE_DOWN,G,re)}t.$2O=R;function d(V,G,re){return r(V,s.$r&&T.$MO.pointerEvents?t.$QP.POINTER_MOVE:t.$QP.MOUSE_MOVE,G,re)}t.$3O=d;function D(V,G,re){return r(V,s.$r&&T.$MO.pointerEvents?t.$QP.POINTER_UP:t.$QP.MOUSE_UP,G,re)}t.$4O=D;function B(V,G,re){return(0,w.$_g)(V,G,re)}t.$5O=B;class _ extends w.$ah{constructor(G,re){super(G,re)}}t.$6O=_;function x(V,G,re,ge){let ye=0;const Re=V.setInterval(()=>{ye++,(typeof ge=="number"&&ye>=ge||G()===!0)&&ze.dispose()},re),ze=(0,c.$Pc)(()=>{V.clearInterval(Re)});return ze}t.$9O=x;class P extends w.$6g{cancelAndSet(G,re,ge){return super.cancelAndSet(G,re,ge)}}t.$0O=P;class O{constructor(G,re=0){this.d=G,this.priority=re,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(G){(0,A.$Z)(G)}}static sort(G,re){return re.priority-G.priority}}(function(){const V=new Map,G=new Map,re=new Map,ge=new Map,ye=Re=>{re.set(Re,!1);const ze=V.get(Re)??[];for(G.set(Re,ze),V.set(Re,[]),ge.set(Re,!0);ze.length>0;)ze.sort(O.sort),ze.shift().execute();ge.set(Re,!1)};t.$8O=(Re,ze,xe=0)=>{const Xe=(0,t.getWindowId)(Re),Qe=new O(ze,xe);let rt=V.get(Xe);return rt||(rt=[],V.set(Xe,rt)),rt.push(Qe),re.get(Xe)||(re.set(Xe,!0),Re.requestAnimationFrame(()=>ye(Xe))),Qe},t.$7O=(Re,ze,xe)=>{const Xe=(0,t.getWindowId)(Re);if(ge.get(Xe)){const Qe=new O(ze,xe);let rt=G.get(Xe);return rt||(rt=[],G.set(Xe,rt)),rt.push(Qe),Qe}else return(0,t.$8O)(Re,ze,xe)}})();function K(V,G){return(0,t.$8O)(V,G,1e4)}t.$$O=K;function te(V,G){return(0,t.$8O)(V,G,-1e4)}t.$_O=te;const se=8,fe=function(V,G){return G};class le extends c.$Rc{constructor(G,re,ge,ye=fe,Re=se){super();let ze=null,xe=0;const Xe=this.B(new w.$5g),Qe=()=>{xe=new Date().getTime(),ge(ze),ze=null};this.B(r(G,re,rt=>{ze=ye(ze,rt);const Pt=new Date().getTime()-xe;Pt>=Re?(Xe.cancel(),Qe()):Xe.setIfNotSet(Qe,Re-Pt)}))}}function oe(V,G,re,ge,ye){return new le(V,G,re,ge,ye)}t.$aP=oe;function be(V){return V.ownerDocument.defaultView.getComputedStyle(V,null)}t.$bP=be;function Ce(V){const G=V.ownerDocument,re=G.defaultView?.window;if(V!==G.body)return new Pe(V.clientWidth,V.clientHeight);if(s.$r&&re?.visualViewport)return new Pe(re.visualViewport.width,re.visualViewport.height);if(re?.innerWidth&&re.innerHeight)return new Pe(re.innerWidth,re.innerHeight);if(G.body&&G.body.clientWidth&&G.body.clientHeight)return new Pe(G.body.clientWidth,G.body.clientHeight);if(G.documentElement&&G.documentElement.clientWidth&&G.documentElement.clientHeight)return new Pe(G.documentElement.clientWidth,G.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$cP=Ce;class Ae{static d(G,re){return parseFloat(re)||0}static f(G,re,ge){const ye=be(G),Re=ye?ye.getPropertyValue(re):"0";return Ae.d(G,Re)}static getBorderLeftWidth(G){return Ae.f(G,"border-left-width","borderLeftWidth")}static getBorderRightWidth(G){return Ae.f(G,"border-right-width","borderRightWidth")}static getBorderTopWidth(G){return Ae.f(G,"border-top-width","borderTopWidth")}static getBorderBottomWidth(G){return Ae.f(G,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(G){return Ae.f(G,"padding-left","paddingLeft")}static getPaddingRight(G){return Ae.f(G,"padding-right","paddingRight")}static getPaddingTop(G){return Ae.f(G,"padding-top","paddingTop")}static getPaddingBottom(G){return Ae.f(G,"padding-bottom","paddingBottom")}static getMarginLeft(G){return Ae.f(G,"margin-left","marginLeft")}static getMarginTop(G){return Ae.f(G,"margin-top","marginTop")}static getMarginRight(G){return Ae.f(G,"margin-right","marginRight")}static getMarginBottom(G){return Ae.f(G,"margin-bottom","marginBottom")}}class Pe{static{this.None=new Pe(0,0)}constructor(G,re){this.width=G,this.height=re}with(G=this.width,re=this.height){return G!==this.width||re!==this.height?new Pe(G,re):this}static is(G){return typeof G=="object"&&typeof G.height=="number"&&typeof G.width=="number"}static lift(G){return G instanceof Pe?G:new Pe(G.width,G.height)}static equals(G,re){return G===re?!0:!G||!re?!1:G.width===re.width&&G.height===re.height}}t.$dP=Pe;function de(V){let G=V.offsetParent,re=V.offsetTop,ge=V.offsetLeft;for(;(V=V.parentNode)!==null&&V!==V.ownerDocument.body&&V!==V.ownerDocument.documentElement;){re-=V.scrollTop;const ye=j(V)?null:be(V);ye&&(ge-=ye.direction!=="rtl"?V.scrollLeft:-V.scrollLeft),V===G&&(ge+=Ae.getBorderLeftWidth(V),re+=Ae.getBorderTopWidth(V),re+=V.offsetTop,ge+=V.offsetLeft,G=V.offsetParent)}return{left:ge,top:re}}t.$eP=de;function ie(V,G,re){typeof G=="number"&&(V.style.width=`${G}px`),typeof re=="number"&&(V.style.height=`${re}px`)}t.$fP=ie;function ce(V,G,re,ge,ye,Re="absolute"){typeof G=="number"&&(V.style.top=`${G}px`),typeof re=="number"&&(V.style.right=`${re}px`),typeof ge=="number"&&(V.style.bottom=`${ge}px`),typeof ye=="number"&&(V.style.left=`${ye}px`),V.style.position=Re}t.$gP=ce;function Z(V){const G=V.getBoundingClientRect();return{left:G.left+(V.ownerDocument.defaultView?.scrollX??0),top:G.top+(V.ownerDocument.defaultView?.scrollY??0),width:G.width,height:G.height}}t.$hP=Z;function W(V){let G=V,re=1;do{const ge=be(G).zoom;ge!=null&&ge!=="1"&&(re*=ge),G=G.parentElement}while(G!==null&&G!==G.ownerDocument.documentElement);return re}t.$iP=W;function Y(V){const G=Ae.getMarginLeft(V)+Ae.getMarginRight(V);return V.offsetWidth+G}t.$jP=Y;function S(V){const G=Ae.getBorderLeftWidth(V)+Ae.getBorderRightWidth(V),re=Ae.getPaddingLeft(V)+Ae.getPaddingRight(V);return V.offsetWidth-G-re}t.$kP=S;function q(V){const G=Ae.getMarginLeft(V)+Ae.getMarginRight(V);return V.scrollWidth+G}t.$lP=q;function $(V){const G=Ae.getBorderTopWidth(V)+Ae.getBorderBottomWidth(V),re=Ae.getPaddingTop(V)+Ae.getPaddingBottom(V);return V.offsetHeight-G-re}t.$mP=$;function U(V){const G=Ae.getMarginTop(V)+Ae.getMarginBottom(V);return V.offsetHeight+G}t.$nP=U;function Q(V,G){if(V===null)return 0;const re=de(V),ge=de(G);return re.left-ge.left}function p(V,G){const re=G.map(ye=>Math.max(q(ye),Y(ye))+Q(ye,V)||0);return Math.max(...re)}t.$oP=p;function E(V,G){return!!G?.contains(V)}t.$pP=E;const y="parentFlowToElementId";function M(V,G){V.dataset[y]=G.id}t.$qP=M;function k(V){const G=V.dataset[y];return typeof G=="string"?V.ownerDocument.getElementById(G):null}function I(V,G){let re=V;for(;re;){if(re===G)return!0;if(re instanceof HTMLElement){const ge=k(re);if(ge){re=ge;continue}}re=re.parentNode}return!1}t.$rP=I;function C(V,G,re){for(;V&&V.nodeType===V.ELEMENT_NODE;){if(V.classList.contains(G))return V;if(re){if(typeof re=="string"){if(V.classList.contains(re))return null}else if(V===re)return null}V=V.parentNode}return null}t.$sP=C;function F(V,G,re){return!!C(V,G,re)}t.$tP=F;function j(V){return V&&!!V.host&&!!V.mode}t.$uP=j;function X(V){return!!ee(V)}t.$vP=X;function ee(V){for(;V.parentNode;){if(V===V.ownerDocument?.body)return null;V=V.parentNode}return j(V)?V:null}t.$wP=ee;function ne(){let V=Se().activeElement;for(;V?.shadowRoot;)V=V.shadowRoot.activeElement;return V}t.$xP=ne;function me(V){return V.ownerDocument.activeElement===V}t.$yP=me;function ve(V){return E(V.ownerDocument.activeElement,V)}t.$zP=ve;function Ne(V){return V.ownerDocument===Se()}t.$AP=Ne;function Se(){return(0,t.getWindowsCount)()<=1?document:Array.from((0,t.getWindows)()).map(({window:G})=>G.document).find(G=>G.hasFocus())??document}t.$BP=Se;function De(){return Se().defaultView?.window??o.$rO}t.$CP=De;function Le(V){const G=V;if(G?.ownerDocument?.defaultView)return G.ownerDocument.defaultView.window;const re=V;return re?.view?re.view.window:o.$rO}t.$DP=Le;function Te(V){const G=Le(V);G!==De()&&G.focus()}t.$EP=Te;const We=new Map;function He(V){return We.has(V)}t.$FP=He;function Me(V=o.$rO.document.head,G,re){const ge=document.createElement("style");if(ge.type="text/css",ge.media="screen",G?.(ge),V.appendChild(ge),re&&re.add((0,c.$Pc)(()=>V.removeChild(ge))),V===o.$rO.document.head){const ye=new Set;We.set(ge,ye);for(const{window:Re,disposables:ze}of(0,t.getWindows)()){if(Re===o.$rO)continue;const xe=ze.add(J(ge,ye,Re));re?.add(xe)}}return ge}t.$GP=Me;function Ye(V){const G=new c.$Qc;for(const[re,ge]of We)G.add(J(re,ge,V));return G}t.$HP=Ye;function J(V,G,re){const ge=new c.$Qc,ye=V.cloneNode(!0);re.document.head.appendChild(ye),ge.add((0,c.$Pc)(()=>re.document.head.removeChild(ye)));for(const Re of Fe(V))ye.sheet?.insertRule(Re.cssText,ye.sheet?.cssRules.length);return ge.add(t.$IP.observe(V,ge,{childList:!0})(()=>{ye.textContent=V.textContent})),G.add(ye),ge.add((0,c.$Pc)(()=>G.delete(ye))),ge}t.$IP=new class{constructor(){this.mutationObservers=new Map}observe(V,G,re){let ge=this.mutationObservers.get(V);ge||(ge=new Map,this.mutationObservers.set(V,ge));const ye=(0,e.$Gi)(re);let Re=ge.get(ye);if(Re)Re.users+=1;else{const ze=new f.$Od,xe=new MutationObserver(Qe=>ze.fire(Qe));xe.observe(V,re);const Xe=Re={users:1,observer:xe,onDidMutate:ze.event};G.add((0,c.$Pc)(()=>{Xe.users-=1,Xe.users===0&&(ze.dispose(),xe.disconnect(),ge?.delete(ye),ge?.size===0&&this.mutationObservers.delete(V))})),ge.set(ye,Re)}return Re.onDidMutate}};function he(V=o.$rO.document.head){const G=document.createElement("meta");return V.appendChild(G),G}t.$JP=he;let pe=null;function Ee(){return pe||(pe=Me()),pe}function Fe(V){return V?.sheet?.rules?V.sheet.rules:V?.sheet?.cssRules?V.sheet.cssRules:[]}function Be(V,G,re=Ee()){if(!(!re||!G)){re.sheet?.insertRule(`${V} {${G}}`,0);for(const ge of We.get(re)??[])Be(V,G,ge)}}t.$KP=Be;function Ue(V,G=Ee()){if(!G)return;const re=Fe(G),ge=[];for(let ye=0;ye<re.length;ye++){const Re=re[ye];Ze(Re)&&Re.selectorText.indexOf(V)!==-1&&ge.push(ye)}for(let ye=ge.length-1;ye>=0;ye--)G.sheet?.deleteRule(ge[ye]);for(const ye of We.get(G)??[])Ue(V,ye)}t.$LP=Ue;function Ze(V){return typeof V.selectorText=="string"}function Je(V){return V instanceof MouseEvent||V instanceof Le(V).MouseEvent}t.$MP=Je;function Ke(V){return V instanceof KeyboardEvent||V instanceof Le(V).KeyboardEvent}t.$NP=Ke;function _e(V){return V instanceof PointerEvent||V instanceof Le(V).PointerEvent}t.$OP=_e;function tt(V){return V instanceof DragEvent||V instanceof Le(V).DragEvent}t.$PP=tt,t.$QP={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:v.$EO?"webkitAnimationStart":"animationstart",ANIMATION_END:v.$EO?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:v.$EO?"webkitAnimationIteration":"animationiteration"};function nt(V){const G=V;return!!(G&&typeof G.preventDefault=="function"&&typeof G.stopPropagation=="function")}t.$RP=nt,t.$SP={stop:(V,G)=>(V.preventDefault(),G&&V.stopPropagation(),V)};function dt(V){const G=[];for(let re=0;V&&V.nodeType===V.ELEMENT_NODE;re++)G[re]=V.scrollTop,V=V.parentNode;return G}t.$TP=dt;function ft(V,G){for(let re=0;V&&V.nodeType===V.ELEMENT_NODE;re++)V.scrollTop!==G[re]&&(V.scrollTop=G[re]),V=V.parentNode}t.$UP=ft;class ot extends c.$Rc{static m(G){if(G instanceof HTMLElement){const re=ee(G),ge=re?re.activeElement:G.ownerDocument.activeElement;return E(ge,G)}else{const re=G;return E(re.document.activeElement,re.document)}}constructor(G){super(),this.f=this.B(new f.$Od),this.onDidFocus=this.f.event,this.g=this.B(new f.$Od),this.onDidBlur=this.g.event;let re=ot.m(G),ge=!1;const ye=()=>{ge=!1,re||(re=!0,this.f.fire())},Re=()=>{re&&(ge=!0,(G instanceof HTMLElement?Le(G):G).setTimeout(()=>{ge&&(ge=!1,re=!1,this.g.fire())},0))};this.j=()=>{ot.m(G)!==re&&(re?Re():ye())},this.B(r(G,t.$QP.FOCUS,ye,!0)),this.B(r(G,t.$QP.BLUR,Re,!0)),G instanceof HTMLElement&&(this.B(r(G,t.$QP.FOCUS_IN,()=>this.j())),this.B(r(G,t.$QP.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function At(V){return new ot(V)}t.$VP=At;function kt(V,G){return V.after(G),G}t.$WP=kt;function pt(V,...G){if(V.append(...G),G.length===1&&typeof G[0]!="string")return G[0]}t.$XP=pt;function St(V,G){return V.insertBefore(G,V.firstChild),G}t.$YP=St;function Mt(V,...G){V.innerText="",pt(V,...G)}t.$ZP=Mt;const Ie=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var ue;(function(V){V.HTML="http://www.w3.org/1999/xhtml",V.SVG="http://www.w3.org/2000/svg"})(ue||(t.Namespace=ue={}));function ke(V,G,re,...ge){const ye=Ie.exec(G);if(!ye)throw new Error("Bad use of emmet");const Re=ye[1]||"div";let ze;return V!==ue.HTML?ze=document.createElementNS(V,Re):ze=document.createElement(Re),ye[3]&&(ze.id=ye[3]),ye[4]&&(ze.className=ye[4].replace(/\./g," ").trim()),re&&Object.entries(re).forEach(([xe,Xe])=>{typeof Xe>"u"||(/^on\w+$/.test(xe)?ze[xe]=Xe:xe==="selected"?Xe&&ze.setAttribute(xe,"true"):ze.setAttribute(xe,Xe))}),ze.append(...ge),ze}function Oe(V,G,...re){return ke(ue.HTML,V,G,...re)}t.$=Oe,Oe.SVG=function(V,G,...re){return ke(ue.SVG,V,G,...re)};function qe(V,G){const re=[];return V.forEach((ge,ye)=>{ye>0&&(G instanceof Node?re.push(G.cloneNode()):re.push(document.createTextNode(G))),re.push(ge)}),re}t.$2P=qe;function et(V,...G){V?st(...G):Ve(...G)}t.$3P=et;function st(...V){for(const G of V)G.style.display="",G.removeAttribute("aria-hidden")}t.$4P=st;function Ve(...V){for(const G of V)G.style.display="none",G.setAttribute("aria-hidden","true")}t.$5P=Ve;function ht(V,G){for(;V&&V.nodeType===V.ELEMENT_NODE;){if(V instanceof HTMLElement&&V.hasAttribute(G))return V;V=V.parentNode}return null}function wt(V){!V||!V.hasAttribute("tabIndex")||(V.ownerDocument.activeElement===V&&ht(V.parentElement,"tabIndex")?.focus(),V.removeAttribute("tabindex"))}t.$6P=wt;function Ct(V){return G=>{G.preventDefault(),G.stopPropagation(),V(G)}}t.$7P=Ct;function Xt(V){return new Promise(G=>{if(V.document.readyState==="complete"||V.document&&V.document.body!==null)G(void 0);else{const ge=()=>{V.window.removeEventListener("DOMContentLoaded",ge,!1),G()};V.window.addEventListener("DOMContentLoaded",ge,!1)}})}t.$8P=Xt;function Ai(V,G){const re=V.devicePixelRatio*G;return Math.max(1,Math.floor(re))/V.devicePixelRatio}t.$9P=Ai;function ki(V){o.$window.open(V,"_blank","noopener")}t.$0P=ki;const Gt=780,Yt=640;function Si(V){const G=Math.floor(o.$window.screenLeft+o.$window.innerWidth/2-Gt/2),re=Math.floor(o.$window.screenTop+o.$window.innerHeight/2-Yt/2);o.$window.open(V,"_blank",`width=${Gt},height=${Yt},top=${re},left=${G}`)}t.$$P=Si;function Ci(V,G=!0){const re=o.$window.open();return re?(G&&(re.opener=null),re.location.href=V,!0):!1}t.$_P=Ci;function Pi(V,G){const re=()=>{G(),ge=(0,t.$8O)(V,re)};let ge=(0,t.$8O)(V,re);return(0,c.$Pc)(()=>ge.dispose())}t.$aQ=Pi,L.$0f.setPreferredWebSchema(/^https:/.test(o.$rO.location.href)?"https":"http");function Fi(V){return V?`url('${L.$dg.uriToBrowserUri(V).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$bQ=Fi;function Ni(V){return`'${V.replace(/'/g,"%27")}'`}t.$cQ=Ni;function Zt(V,G){if(V!==void 0){const re=V.match(/^\s*var\((.+)\)$/);if(re){const ge=re[1].split(",",2);return ge.length===2&&(G=Zt(ge[1].trim(),G)),`var(${ge[0]}, ${G})`}return V}return G}t.$dQ=Zt;function Oi(V,G){let re;if(h.URI.isUri(V))re=V.toString(!0);else{const Re=new Blob([V]);re=URL.createObjectURL(Re),setTimeout(()=>URL.revokeObjectURL(re))}const ge=De(),ye=document.createElement("a");ge.document.body.appendChild(ye),ye.download=G,ye.href=re,ye.click(),setTimeout(()=>ge.document.body.removeChild(ye))}t.$eQ=Oi;function Ti(){return new Promise(V=>{const G=De(),re=document.createElement("input");G.document.body.appendChild(re),re.type="file",re.multiple=!0,f.Event.once(f.Event.fromDOMEventEmitter(re,"input"))(()=>{V(re.files??void 0)}),re.click(),setTimeout(()=>G.document.body.removeChild(re))})}t.$fQ=Ti;var vt;(function(V){V[V.DOCUMENT=1]="DOCUMENT",V[V.BROWSER=2]="BROWSER"})(vt||(t.DetectedFullscreenMode=vt={}));function Li(){return o.$window.document.fullscreenElement||o.$window.document.webkitFullscreenElement||o.$window.document.webkitIsFullScreen?{mode:vt.DOCUMENT,guess:!1}:o.$window.innerHeight===o.$window.screen.height?{mode:vt.BROWSER,guess:!1}:(s.$j||s.$k)&&o.$window.outerHeight===o.$window.screen.height&&o.$window.outerWidth===o.$window.screen.width?{mode:vt.BROWSER,guess:!0}:null}t.$gQ=Li;function Jt(V,G=!1){const re=document.createElement("a");return g.addHook("afterSanitizeAttributes",ge=>{for(const ye of["href","src"])if(ge.hasAttribute(ye)){const Re=ge.getAttribute(ye);if(ye==="href"&&Re.startsWith("#"))continue;if(re.href=Re,!V.includes(re.protocol.replace(/:$/,""))){if(G&&ye==="src"&&re.href.startsWith("data:"))continue;ge.removeAttribute(ye)}}}),(0,c.$Pc)(()=>{g.removeHook("afterSanitizeAttributes")})}t.$hQ=Jt;const Ri=[L.Schemas.http,L.Schemas.https,L.Schemas.command];t.$iQ=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Ii=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Mi(V,G){const re=Jt(Ri);try{const ge=g.sanitize(G,Ii);V.innerHTML=ge}finally{re.dispose()}}t.$jQ=Mi;function Bi(V){const G=new Uint16Array(V.length);for(let ye=0;ye<G.length;ye++)G[ye]=V.charCodeAt(ye);let re="";const ge=new Uint8Array(G.buffer);for(let ye=0;ye<ge.length;ye++)re+=String.fromCharCode(ge[ye]);return re}function zi(V){return btoa(Bi(V))}t.$kQ=zi;class mt extends f.$Od{constructor(){super(),this.o=new c.$Qc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(f.Event.runAndSubscribe(t.onDidRegisterWindow,({window:G,disposables:re})=>this.B(G,re),{window:o.$rO,disposables:this.o}))}B(G,re){re.add(r(G,"keydown",ge=>{if(ge.defaultPrevented)return;const ye=new i.$UO(ge);if(!(ye.keyCode===6&&ge.repeat)){if(ge.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(ge.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(ge.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(ge.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(ye.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=ge.altKey,this.s.ctrlKey=ge.ctrlKey,this.s.metaKey=ge.metaKey,this.s.shiftKey=ge.shiftKey,this.s.lastKeyPressed&&(this.s.event=ge,this.fire(this.s))}},!0)),re.add(r(G,"keyup",ge=>{ge.defaultPrevented||(!ge.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!ge.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!ge.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!ge.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=ge.altKey,this.s.ctrlKey=ge.ctrlKey,this.s.metaKey=ge.metaKey,this.s.shiftKey=ge.shiftKey,this.s.lastKeyReleased&&(this.s.event=ge,this.fire(this.s)))},!0)),re.add(r(G.document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),re.add(r(G.document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),re.add(r(G.document.body,"mousemove",ge=>{ge.buttons&&(this.s.lastKeyPressed=void 0)},!0)),re.add(r(G,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.C(),this.fire(this.s)}C(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return mt.A||(mt.A=new mt),mt.A}dispose(){super.dispose(),this.o.dispose()}}t.$lQ=mt;function ji(V){const G=document.cookie.match("(^|[^;]+)\\s*"+V+"\\s*=\\s*([^;]+)");return G?G.pop():void 0}t.$mQ=ji;class Hi extends c.$Rc{constructor(G,re){super(),this.j=G,this.m=re,this.f=0,this.g=0,this.n()}n(){this.B(r(this.j,t.$QP.DRAG_ENTER,G=>{this.f++,this.g=G.timeStamp,this.m.onDragEnter(G)})),this.B(r(this.j,t.$QP.DRAG_OVER,G=>{G.preventDefault(),this.m.onDragOver?.(G,G.timeStamp-this.g)})),this.B(r(this.j,t.$QP.DRAG_LEAVE,G=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave(G))})),this.B(r(this.j,t.$QP.DRAG_END,G=>{this.f=0,this.g=0,this.m.onDragEnd(G)})),this.B(r(this.j,t.$QP.DROP,G=>{this.f=0,this.g=0,this.m.onDrop(G)}))}}t.$nQ=Hi;const Ui=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Wi(V,...G){let re,ge;Array.isArray(G[0])?(re={},ge=G[0]):(re=G[0]||{},ge=G[1]);const ye=Ui.exec(V);if(!ye||!ye.groups)throw new Error("Bad use of h");const Re=ye.groups.tag||"div",ze=document.createElement(Re);ye.groups.id&&(ze.id=ye.groups.id);const xe=[];if(ye.groups.class)for(const Qe of ye.groups.class.split("."))Qe!==""&&xe.push(Qe);if(re.className!==void 0)for(const Qe of re.className.split("."))Qe!==""&&xe.push(Qe);xe.length>0&&(ze.className=xe.join(" "));const Xe={};if(ye.groups.name&&(Xe[ye.groups.name]=ze),ge)for(const Qe of ge)Qe instanceof HTMLElement?ze.appendChild(Qe):typeof Qe=="string"?ze.append(Qe):"root"in Qe&&(Object.assign(Xe,Qe),ze.appendChild(Qe.root));for(const[Qe,rt]of Object.entries(re))if(Qe!=="className")if(Qe==="style")for(const[Pt,Bt]of Object.entries(rt))ze.style.setProperty(ei(Pt),typeof Bt=="number"?Bt+"px":""+Bt);else Qe==="tabIndex"?ze.tabIndex=rt:ze.setAttribute(ei(Qe),rt.toString());return Xe.root=ze,Xe}t.h=Wi;function ei(V){return V.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(V,G){for(const{name:re,value:ge}of V.attributes)G.setAttribute(re,ge)}t.$pQ=ti;function qi(V,G,re){const ge=V.getAttribute(re);ge?G.setAttribute(re,ge):G.removeAttribute(re)}function _i(V,G,re){ti(V,G);const ge=new c.$Qc;return ge.add(t.$IP.observe(V,ge,{attributes:!0,attributeFilter:re})(ye=>{for(const Re of ye)Re.type==="attributes"&&Re.attributeName&&qi(V,G,Re.attributeName)})),ge}t.$qQ=_i}),define($e[54],we([1,0,3,2,116]),function(ae,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tQ=t.$sQ=t.$rQ=void 0;class H extends T.$Rc{constructor(f,g){super(),this.B((0,v.$XO)(f,"dragover",c=>{c.preventDefault(),this.a||(this.a=setTimeout(()=>{g(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(c=>{this.B((0,v.$XO)(f,c,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$rQ=H,t.$sQ={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.$Sr.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function w(A,f,g,c,L){const s=document.createElement("div");if(s.className=g,s.textContent=f,L&&(s.style.color=L),c&&(s.style.background=c),A.dataTransfer){const h=(0,v.$DP)(A).document;h.body.appendChild(s),A.dataTransfer.setDragImage(s,-10,-10),setTimeout(()=>h.body.removeChild(s),0)}}t.$tQ=w}),define($e[55],we([1,0,3]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XQ=t.$WQ=t.$VQ=void 0;function T(s,h={}){const e=H(h);return e.textContent=s,e}t.$VQ=T;function i(s,h={}){const e=H(h);return f(e,g(s,!!h.renderCodeSegments),h.actionHandler,h.renderCodeSegments),e}t.$WQ=i;function H(s){const h=s.inline?"span":"div",e=document.createElement(h);return s.className&&(e.className=s.className),e}t.$XQ=H;class w{constructor(h){this.b=h,this.c=0}eos(){return this.c>=this.b.length}next(){const h=this.peek();return this.advance(),h}peek(){return this.b[this.c]}advance(){this.c++}}var A;(function(s){s[s.Invalid=0]="Invalid",s[s.Root=1]="Root",s[s.Text=2]="Text",s[s.Bold=3]="Bold",s[s.Italics=4]="Italics",s[s.Action=5]="Action",s[s.ActionClose=6]="ActionClose",s[s.Code=7]="Code",s[s.NewLine=8]="NewLine"})(A||(A={}));function f(s,h,e,o){let a;if(h.type===2)a=document.createTextNode(h.content||"");else if(h.type===3)a=document.createElement("b");else if(h.type===4)a=document.createElement("i");else if(h.type===7&&o)a=document.createElement("code");else if(h.type===5&&e){const m=document.createElement("a");e.disposables.add(v.$YO(m,"click",n=>{e.callback(String(h.index),n)})),a=m}else h.type===8?a=document.createElement("br"):h.type===1&&(a=s);a&&s!==a&&s.appendChild(a),a&&Array.isArray(h.children)&&h.children.forEach(m=>{f(a,m,e,o)})}function g(s,h){const e={type:1,children:[]};let o=0,a=e;const m=[],n=new w(s);for(;!n.eos();){let r=n.next();const b=r==="\\"&&L(n.peek(),h)!==0;if(b&&(r=n.next()),!b&&c(r,h)&&r===n.peek()){n.advance(),a.type===2&&(a=m.pop());const u=L(r,h);if(a.type===u||a.type===5&&u===6)a=m.pop();else{const l={type:u,children:[]};u===5&&(l.index=o,o++),a.children.push(l),m.push(a),a=l}}else if(r===`
`)a.type===2&&(a=m.pop()),a.children.push({type:8});else if(a.type!==2){const u={type:2,content:r};a.children.push(u),m.push(a),a=u}else a.content+=r}return a.type===2&&(a=m.pop()),m.length,e}function c(s,h){return L(s,h)!==0}function L(s,h){switch(s){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return h?7:0;default:return 0}}}),define($e[56],we([1,0,3,2]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xQ=void 0;class i{constructor(){this.a=new T.$Qc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(w,A){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const f=this.c;this.c=null,w&&f&&f(A)}isMonitoring(){return!!this.b}startMonitoring(w,A,f,g,c){this.isMonitoring()&&this.stopMonitoring(!1),this.b=g,this.c=c;let L=w;try{w.setPointerCapture(A),this.a.add((0,T.$Pc)(()=>{try{w.releasePointerCapture(A)}catch{}}))}catch{L=v.$DP(w)}this.a.add(v.$XO(L,v.$QP.POINTER_MOVE,s=>{if(s.buttons!==f){this.stopMonitoring(!0);return}s.preventDefault(),this.b(s)})),this.a.add(v.$XO(L,v.$QP.POINTER_UP,s=>this.stopMonitoring(!0)))}}t.$xQ=i});var Ge=this&&this.__decorate||function(ae,t,v,T){var i=arguments.length,H=i<3?t:T===null?T=Object.getOwnPropertyDescriptor(t,v):T,w;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")H=Reflect.decorate(ae,t,v,T);else for(var A=ae.length-1;A>=0;A--)(w=ae[A])&&(H=(i<3?w(H):i>3?w(t,v,H):w(t,v))||H);return i>3&&H&&Object.defineProperty(t,v,H),H};define($e[24],we([1,0,3,14,11,26,4,2,45]),function(ae,t,v,T,i,H,w,A,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uQ=t.EventType=void 0;var g;(function(L){L.Tap="-monaco-gesturetap",L.Change="-monaco-gesturechange",L.Start="-monaco-gesturestart",L.End="-monaco-gesturesend",L.Contextmenu="-monaco-gesturecontextmenu"})(g||(t.EventType=g={}));class c extends A.$Rc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new f.$1c,this.h=new f.$1c,this.m={},this.j=null,this.n=0,this.B(w.Event.runAndSubscribe(v.onDidRegisterWindow,({window:s,disposables:h})=>{h.add(v.$XO(s.document,"touchstart",e=>this.s(e),{passive:!1})),h.add(v.$XO(s.document,"touchend",e=>this.u(s,e))),h.add(v.$XO(s.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:T.$rO,disposables:this.q}))}static addTarget(s){if(!c.isTouchDevice())return A.$Rc.None;c.b||(c.b=(0,A.$Kc)(new c));const h=c.b.g.push(s);return(0,A.$Pc)(h)}static ignoreTarget(s){if(!c.isTouchDevice())return A.$Rc.None;c.b||(c.b=(0,A.$Kc)(new c));const h=c.b.h.push(s);return(0,A.$Pc)(h)}static isTouchDevice(){return"ontouchstart"in T.$rO||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(s){const h=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,o=s.targetTouches.length;e<o;e++){const a=s.targetTouches.item(e);this.m[a.identifier]={id:a.identifier,initialTarget:a.target,initialTimeStamp:h,initialPageX:a.pageX,initialPageY:a.pageY,rollingTimestamps:[h],rollingPageX:[a.pageX],rollingPageY:[a.pageY]};const m=this.w(g.Start,a.target);m.pageX=a.pageX,m.pageY=a.pageY,this.z(m)}this.f&&(s.preventDefault(),s.stopPropagation(),this.f=!1)}u(s,h){const e=Date.now(),o=Object.keys(this.m).length;for(let a=0,m=h.changedTouches.length;a<m;a++){const n=h.changedTouches.item(a);if(!this.m.hasOwnProperty(String(n.identifier))){console.warn("move of an UNKNOWN touch",n);continue}const r=this.m[n.identifier],b=Date.now()-r.initialTimeStamp;if(b<c.c&&Math.abs(r.initialPageX-i.$rb(r.rollingPageX))<30&&Math.abs(r.initialPageY-i.$rb(r.rollingPageY))<30){const u=this.w(g.Tap,r.initialTarget);u.pageX=i.$rb(r.rollingPageX),u.pageY=i.$rb(r.rollingPageY),this.z(u)}else if(b>=c.c&&Math.abs(r.initialPageX-i.$rb(r.rollingPageX))<30&&Math.abs(r.initialPageY-i.$rb(r.rollingPageY))<30){const u=this.w(g.Contextmenu,r.initialTarget);u.pageX=i.$rb(r.rollingPageX),u.pageY=i.$rb(r.rollingPageY),this.z(u)}else if(o===1){const u=i.$rb(r.rollingPageX),l=i.$rb(r.rollingPageY),N=i.$rb(r.rollingTimestamps)-r.rollingTimestamps[0],z=u-r.rollingPageX[0],R=l-r.rollingPageY[0],d=[...this.g].filter(D=>r.initialTarget instanceof Node&&D.contains(r.initialTarget));this.C(s,d,e,Math.abs(z)/N,z>0?1:-1,u,Math.abs(R)/N,R>0?1:-1,l)}this.z(this.w(g.End,r.initialTarget)),delete this.m[n.identifier]}this.f&&(h.preventDefault(),h.stopPropagation(),this.f=!1)}w(s,h){const e=document.createEvent("CustomEvent");return e.initEvent(s,!1,!0),e.initialTarget=h,e.tapCount=0,e}z(s){if(s.type===g.Tap){const h=new Date().getTime();let e=0;h-this.n>c.r?e=1:e=2,this.n=h,s.tapCount=e}else(s.type===g.Change||s.type===g.Contextmenu)&&(this.n=0);if(s.initialTarget instanceof Node){for(const h of this.h)if(h.contains(s.initialTarget))return;for(const h of this.g)h.contains(s.initialTarget)&&(h.dispatchEvent(s),this.f=!0)}}C(s,h,e,o,a,m,n,r,b){this.j=v.$8O(s,()=>{const u=Date.now(),l=u-e;let N=0,z=0,R=!0;o+=c.a*l,n+=c.a*l,o>0&&(R=!1,N=a*o*l),n>0&&(R=!1,z=r*n*l);const d=this.w(g.Change);d.translationX=N,d.translationY=z,h.forEach(D=>D.dispatchEvent(d)),R||this.C(s,h,u,o,a,m+N,n,r,b+z)})}D(s){const h=Date.now();for(let e=0,o=s.changedTouches.length;e<o;e++){const a=s.changedTouches.item(e);if(!this.m.hasOwnProperty(String(a.identifier))){console.warn("end of an UNKNOWN touch",a);continue}const m=this.m[a.identifier],n=this.w(g.Change,m.initialTarget);n.translationX=a.pageX-i.$rb(m.rollingPageX),n.translationY=a.pageY-i.$rb(m.rollingPageY),n.pageX=a.pageX,n.pageY=a.pageY,this.z(n),m.rollingPageX.length>3&&(m.rollingPageX.shift(),m.rollingPageY.shift(),m.rollingTimestamps.shift()),m.rollingPageX.push(a.pageX),m.rollingPageY.push(a.pageY),m.rollingTimestamps.push(h)}this.f&&(s.preventDefault(),s.stopPropagation(),this.f=!1)}}t.$uQ=c,Ge([H.$kh],c,"isTouchDevice",null)}),define($e[57],we([1,0,3,91]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2Q=t.$1Q=t.$ZQ=void 0;const T=2e4;let i,H,w,A,f;function g(h){i=document.createElement("div"),i.className="monaco-aria-container";const e=()=>{const a=document.createElement("div");return a.className="monaco-alert",a.setAttribute("role","alert"),a.setAttribute("aria-atomic","true"),i.appendChild(a),a};H=e(),w=e();const o=()=>{const a=document.createElement("div");return a.className="monaco-status",a.setAttribute("aria-live","polite"),a.setAttribute("aria-atomic","true"),i.appendChild(a),a};A=o(),f=o(),h.appendChild(i)}t.$ZQ=g;function c(h){i&&(H.textContent!==h?(v.$WO(w),s(H,h)):(v.$WO(H),s(w,h)))}t.$1Q=c;function L(h){i&&(A.textContent!==h?(v.$WO(f),s(A,h)):(v.$WO(A),s(f,h)))}t.$2Q=L;function s(h,e){v.$WO(h),e.length>T&&(e=e.substr(0,T)),h.textContent=e,h.style.visibility="hidden",h.style.visibility="visible"}}),define($e[118],we([1,0,3,19]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oR=t.$nR=void 0;const i=new RegExp(`(\\\\)?\\$\\((${T.ThemeIcon.iconNameExpression}(?:${T.ThemeIcon.iconModifierExpression})?)\\)`,"g");function H(A){const f=new Array;let g,c=0,L=0;for(;(g=i.exec(A))!==null;){L=g.index||0,c<L&&f.push(A.substring(c,L)),c=(g.index||0)+g[0].length;const[,s,h]=g;f.push(s?`$(${h})`:w({id:h}))}return c<A.length&&f.push(A.substring(c)),f}t.$nR=H;function w(A){const f=v.$("span");return f.classList.add(...T.ThemeIcon.asClassNameArray(A)),f}t.$oR=w}),define($e[119],we([1,0,3]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$Q=void 0;function T(H){try{H.parentElement?.removeChild(H)}catch{}}class i{constructor(w){this.d=w,this.a=new Map,this.b=new Set,this.c=!1}alloc(w){let A=this.h(w).pop(),f=!1;if(A)f=this.b.has(A.domNode),f&&this.b.delete(A.domNode);else{const g=(0,v.$)(".monaco-list-row"),L=this.i(w).renderTemplate(g);A={domNode:g,templateId:w,templateData:L}}return{row:A,isReusingConnectedDomNode:f}}release(w){w&&this.f(w)}transact(w){if(this.c)throw new Error("Already in transaction");this.c=!0;try{w()}finally{for(const A of this.b)this.g(A);this.b.clear(),this.c=!1}}f(w){const{domNode:A,templateId:f}=w;A&&(this.c?this.b.add(A):this.g(A)),this.h(f).push(w)}g(w){w.classList.remove("scrolling"),T(w)}h(w){let A=this.a.get(w);return A||(A=[],this.a.set(w,A)),A}dispose(){this.a.forEach((w,A)=>{for(const f of w)this.i(A).disposeTemplate(f.templateData),f.templateData=null}),this.a.clear(),this.b.clear()}i(w){const A=this.d.get(w);if(!A)throw new Error(`No renderer found for ${w}`);return A}}t.$$Q=i}),define($e[120],we([1,0,9,2]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CQ=void 0;class i extends T.$Rc{constructor(w,A,f){super(),this.a=w,this.b=A,this.c=f,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new v.$5g)}setVisibility(w){this.a!==w&&(this.a=w,this.s())}setShouldBeVisible(w){this.g=w,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const w=this.r();this.h!==w&&(this.h=w,this.ensureVisibility())}setIsNeeded(w){this.j!==w&&(this.j=w,this.ensureVisibility())}setDomNode(w){this.f=w,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(w){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(w?" fade":"")))}}t.$CQ=i}),define($e[121],we([1,0,3,24,11,4,2,5]),function(ae,t,v,T,i,H,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vR=void 0;class f extends w.$Rc{constructor(c,L,s,h){super(),this.f=0,this.b=h||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new H.$Od),this.h=s,this.j(),this.setOptions(c,L)}j(){this.B(T.$uQ.addTarget(this.a)),[T.EventType.Tap].forEach(c=>{this.B(v.$XO(this.a,c,L=>{this.a.focus()}))}),this.B(v.$YO(this.a,"click",c=>{v.$SP.stop(c,!0)})),this.B(v.$YO(this.a,"change",c=>{this.a.title=c.target.value,this.g.fire({index:c.target.selectedIndex,selected:c.target.value})})),this.B(v.$YO(this.a,"keydown",c=>{let L=!1;A.$j?(c.keyCode===18||c.keyCode===16||c.keyCode===10)&&(L=!0):(c.keyCode===18&&c.altKey||c.keyCode===10||c.keyCode===3)&&(L=!0),L&&c.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(c,L){(!this.c||!i.$tb(this.c,c))&&(this.c=c,this.a.options.length=0,this.c.forEach((s,h)=>{this.a.add(this.m(s.text,h,s.isDisabled))})),L!==void 0&&this.select(L)}select(c){this.c.length===0?this.f=0:c>=0&&c<this.c.length?this.f=c:c>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(c){this.b.ariaLabel=c,this.a.setAttribute("aria-label",c)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(c){this.a.tabIndex=c?0:-1}render(c){c.classList.add("select-container"),c.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(c){this.h=c,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(c,L,s){const h=document.createElement("option");return h.value=c,h.text=c,h.disabled=!!s,h}}t.$vR=f}),define($e[58],we([1,0,25,11,9,50,86,4,27]),function(ae,t,v,T,i,H,w,A,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3S=t.$2S=t.$1S=void 0;function g(h){return typeof h=="object"&&"visibility"in h&&"data"in h}t.$1S=g;function c(h){switch(h){case!0:return 1;case!1:return 0;default:return h}}t.$2S=c;function L(h){return typeof h.collapsible=="boolean"}class s{constructor(e,o,a,m={}){this.o=e,this.p=o,this.rootRef=[],this.d=new A.$Wd,this.f=new A.$Od,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new A.$Od,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new A.$Od,this.onDidSplice=this.l.event,this.m=new i.$Rg(H.$Ld),this.h=typeof m.collapseByDefault>"u"?!1:m.collapseByDefault,this.j=m.filter,this.k=typeof m.autoExpandSingleChildren>"u"?!1:m.autoExpandSingleChildren,this.c={parent:void 0,element:a,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,o,a=f.Iterable.empty(),m={}){if(e.length===0)throw new v.$YS(this.o,"Invalid tree location");m.diffIdentityProvider?this.q(m.diffIdentityProvider,e,o,a,m):this.s(e,o,a,m)}q(e,o,a,m=f.Iterable.empty(),n,r=n.diffDepth??0){const{parentNode:b}=this.G(o);if(!b.lastDiffIds)return this.s(o,a,m,n);const u=[...m],l=o[o.length-1],N=new w.$Cs({getElements:()=>b.lastDiffIds},{getElements:()=>[...b.children.slice(0,l),...u,...b.children.slice(l+a)].map(B=>e.getId(B.element).toString())}).ComputeDiff(!1);if(N.quitEarly)return b.lastDiffIds=void 0,this.s(o,a,u,n);const z=o.slice(0,-1),R=(B,_,x)=>{if(r>0)for(let P=0;P<x;P++)B--,_--,this.q(e,[...z,B,0],Number.MAX_SAFE_INTEGER,u[_].children,n,r-1)};let d=Math.min(b.children.length,l+a),D=u.length;for(const B of N.changes.sort((_,x)=>x.originalStart-_.originalStart))R(d,D,d-(B.originalStart+B.originalLength)),d=B.originalStart,D=B.modifiedStart-l,this.s([...z,d],B.originalLength,f.Iterable.slice(u,D,D+B.modifiedLength),n);R(d,D,d)}s(e,o,a=f.Iterable.empty(),{onDidCreateNode:m,onDidDeleteNode:n,diffIdentityProvider:r}){const{parentNode:b,listIndex:u,revealed:l,visible:N}=this.G(e),z=[],R=f.Iterable.map(a,fe=>this.w(fe,b,b.visible?1:0,l,z,m)),d=e[e.length-1],D=b.children.length>0;let B=0;for(let fe=d;fe>=0&&fe<b.children.length;fe--){const le=b.children[fe];if(le.visible){B=le.visibleChildIndex;break}}const _=[];let x=0,P=0;for(const fe of R)_.push(fe),P+=fe.renderNodeCount,fe.visible&&(fe.visibleChildIndex=B+x++);const O=(0,T.$5b)(b.children,d,o,_);r?b.lastDiffIds?(0,T.$5b)(b.lastDiffIds,d,o,_.map(fe=>r.getId(fe.element).toString())):b.lastDiffIds=b.children.map(fe=>r.getId(fe.element).toString()):b.lastDiffIds=void 0;let K=0;for(const fe of O)fe.visible&&K++;if(K!==0)for(let fe=d+_.length;fe<b.children.length;fe++){const le=b.children[fe];le.visible&&(le.visibleChildIndex-=K)}if(b.visibleChildrenCount+=x-K,l&&N){const fe=O.reduce((le,oe)=>le+(oe.visible?oe.renderNodeCount:0),0);this.B(b,P-fe),this.p.splice(u,fe,z)}if(O.length>0&&n){const fe=le=>{n(le),le.children.forEach(fe)};O.forEach(fe)}this.l.fire({insertedNodes:_,deletedNodes:O});const te=b.children.length>0;D!==te&&this.setCollapsible(e.slice(0,-1),te);let se=b;for(;se;){if(se.visibility===2){this.m.trigger(()=>this.refilter());break}se=se.parent}}rerender(e){if(e.length===0)throw new v.$YS(this.o,"Invalid tree location");const{node:o,listIndex:a,revealed:m}=this.F(e);o.visible&&m&&this.p.splice(a,1,[o])}updateElementHeight(e,o){if(e.length===0)throw new v.$YS(this.o,"Invalid tree location");const{listIndex:a}=this.F(e);this.p.updateElementHeight(a,o)}has(e){return this.D(e)}getListIndex(e){const{listIndex:o,visible:a,revealed:m}=this.F(e);return a&&m?o:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,o){const a=this.E(e);typeof o>"u"&&(o=!a.collapsible);const m={collapsible:o};return this.d.bufferEvents(()=>this.t(e,m))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,o,a){const m=this.E(e);typeof o>"u"&&(o=!m.collapsed);const n={collapsed:o,recursive:a||!1};return this.d.bufferEvents(()=>this.t(e,n))}t(e,o){const{node:a,listIndex:m,revealed:n}=this.F(e),r=this.u(a,m,n,o);if(a!==this.c&&this.k&&r&&!L(o)&&a.collapsible&&!a.collapsed&&!o.recursive){let b=-1;for(let u=0;u<a.children.length;u++)if(a.children[u].visible)if(b>-1){b=-1;break}else b=u;b>-1&&this.t([...e,b],o)}return r}u(e,o,a,m){const n=this.v(e,m,!1);if(!a||!e.visible||!n)return n;const r=e.renderNodeCount,b=this.x(e),u=r-(o===-1?0:1);return this.p.splice(o+1,u,b.slice(1)),n}v(e,o,a){let m;if(e===this.c?m=!1:(L(o)?(m=e.collapsible!==o.collapsible,e.collapsible=o.collapsible):e.collapsible?(m=e.collapsed!==o.collapsed,e.collapsed=o.collapsed):m=!1,m&&this.f.fire({node:e,deep:a})),!L(o)&&o.recursive)for(const n of e.children)m=this.v(n,o,!0)||m;return m}expandTo(e){this.d.bufferEvents(()=>{let o=this.E(e);for(;o.parent;)o=o.parent,e=e.slice(0,e.length-1),o.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,o=this.z(this.c);this.p.splice(0,e,o),this.m.cancel()}w(e,o,a,m,n,r){const b={parent:o,element:e.element,children:[],depth:o.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},u=this.C(b,a);b.visibility=u,m&&n.push(b);const l=e.children||f.Iterable.empty(),N=m&&u!==0&&!b.collapsed;let z=0,R=1;for(const d of l){const D=this.w(d,b,u,N,n,r);b.children.push(D),R+=D.renderNodeCount,D.visible&&(D.visibleChildIndex=z++)}return b.collapsible=b.collapsible||b.children.length>0,b.visibleChildrenCount=z,b.visible=u===2?z>0:u===1,b.visible?b.collapsed||(b.renderNodeCount=R):(b.renderNodeCount=0,m&&n.pop()),r?.(b),b}x(e){const o=e.renderNodeCount,a=[];return this.y(e,a),this.B(e.parent,a.length-o),a}y(e,o){if(e.visible===!1)return 0;if(o.push(e),e.renderNodeCount=1,!e.collapsed)for(const a of e.children)e.renderNodeCount+=this.y(a,o);return this.g.fire(e),e.renderNodeCount}z(e){const o=e.renderNodeCount,a=[];return this.A(e,e.visible?1:0,a),this.B(e.parent,a.length-o),a}A(e,o,a,m=!0){let n;if(e!==this.c){if(n=this.C(e,o),n===0)return e.visible=!1,e.renderNodeCount=0,!1;m&&a.push(e)}const r=a.length;e.renderNodeCount=e===this.c?0:1;let b=!1;if(!e.collapsed||n!==0){let u=0;for(const l of e.children)b=this.A(l,n,a,m&&!e.collapsed)||b,l.visible&&(l.visibleChildIndex=u++);e.visibleChildrenCount=u}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=n===2?b:n===1,e.visibility=n),e.visible?e.collapsed||(e.renderNodeCount+=a.length-r):(e.renderNodeCount=0,m&&a.pop()),this.g.fire(e),e.visible}B(e,o){if(o!==0)for(;e;)e.renderNodeCount+=o,this.g.fire(e),e=e.parent}C(e,o){const a=this.j?this.j.filter(e.element,o):1;return typeof a=="boolean"?(e.filterData=void 0,a?1:0):g(a)?(e.filterData=a.data,c(a.visibility)):(e.filterData=void 0,c(a))}D(e,o=this.c){if(!e||e.length===0)return!0;const[a,...m]=e;return a<0||a>o.children.length?!1:this.D(m,o.children[a])}E(e,o=this.c){if(!e||e.length===0)return o;const[a,...m]=e;if(a<0||a>o.children.length)throw new v.$YS(this.o,"Invalid tree location");return this.E(m,o.children[a])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:o,listIndex:a,revealed:m,visible:n}=this.G(e),r=e[e.length-1];if(r<0||r>o.children.length)throw new v.$YS(this.o,"Invalid tree location");const b=o.children[r];return{node:b,listIndex:a,revealed:m,visible:n&&b.visible}}G(e,o=this.c,a=0,m=!0,n=!0){const[r,...b]=e;if(r<0||r>o.children.length)throw new v.$YS(this.o,"Invalid tree location");for(let u=0;u<r;u++)a+=o.children[u].renderNodeCount;return m=m&&!o.collapsed,n=n&&o.visible,b.length===0?{parentNode:o,listIndex:a,revealed:m,visible:n}:this.G(b,o.children[r],a+1,m,n)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const o=[];let a=e;for(;a.parent;)o.push(a.parent.children.indexOf(a)),a=a.parent;return o.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,T.$sb)(e)[0]}getFirstElementChild(e){const o=this.E(e);if(o.children.length!==0)return o.children[0].element}getLastElementAncestor(e=[]){const o=this.E(e);if(o.children.length!==0)return this.H(o)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$3S=s}),define($e[122],we([1,0,58,25,27]),function(ae,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9S=void 0;class H{get size(){return this.d.size}constructor(A,f,g={}){this.k=A,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new v.$3S(A,f,null,g),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,g.sorter&&(this.j={compare(c,L){return g.sorter.compare(c.element,L.element)}}),this.h=g.identityProvider}setChildren(A,f=i.Iterable.empty(),g={}){const c=this.o(A);this.l(c,this.m(f),g)}l(A,f=i.Iterable.empty(),g){const c=new Set,L=new Set,s=e=>{if(e.element===null)return;const o=e;if(c.add(o.element),this.d.set(o.element,o),this.h){const a=this.h.getId(o.element).toString();L.add(a),this.f.set(a,o)}g.onDidCreateNode?.(o)},h=e=>{if(e.element===null)return;const o=e;if(c.has(o.element)||this.d.delete(o.element),this.h){const a=this.h.getId(o.element).toString();L.has(a)||this.f.delete(a)}g.onDidDeleteNode?.(o)};this.c.splice([...A,0],Number.MAX_VALUE,f,{...g,onDidCreateNode:s,onDidDeleteNode:h})}m(A=i.Iterable.empty()){return this.j&&(A=[...A].sort(this.j.compare.bind(this.j))),i.Iterable.map(A,f=>{let g=this.d.get(f.element);if(!g&&this.h){const s=this.h.getId(f.element).toString();g=this.f.get(s)}if(!g){let s;return typeof f.collapsed>"u"?s=void 0:f.collapsed===T.ObjectTreeElementCollapseState.Collapsed||f.collapsed===T.ObjectTreeElementCollapseState.PreserveOrCollapsed?s=!0:f.collapsed===T.ObjectTreeElementCollapseState.Expanded||f.collapsed===T.ObjectTreeElementCollapseState.PreserveOrExpanded?s=!1:s=!!f.collapsed,{...f,children:this.m(f.children),collapsed:s}}const c=typeof f.collapsible=="boolean"?f.collapsible:g.collapsible;let L;return typeof f.collapsed>"u"||f.collapsed===T.ObjectTreeElementCollapseState.PreserveOrCollapsed||f.collapsed===T.ObjectTreeElementCollapseState.PreserveOrExpanded?L=g.collapsed:f.collapsed===T.ObjectTreeElementCollapseState.Collapsed?L=!0:f.collapsed===T.ObjectTreeElementCollapseState.Expanded?L=!1:L=!!f.collapsed,{...f,collapsible:c,collapsed:L,children:this.m(f.children)}})}rerender(A){const f=this.o(A);this.c.rerender(f)}updateElementHeight(A,f){const g=this.o(A);this.c.updateElementHeight(g,f)}resort(A=null,f=!0){if(!this.j)return;const g=this.o(A),c=this.c.getNode(g);this.l(g,this.n(c,f),{})}n(A,f,g=!0){let c=[...A.children];return(f||g)&&(c=c.sort(this.j.compare.bind(this.j))),i.Iterable.map(c,L=>({element:L.element,collapsible:L.collapsible,collapsed:L.collapsed,children:this.n(L,f,!1)}))}getFirstElementChild(A=null){const f=this.o(A);return this.c.getFirstElementChild(f)}getLastElementAncestor(A=null){const f=this.o(A);return this.c.getLastElementAncestor(f)}has(A){return this.d.has(A)}getListIndex(A){const f=this.o(A);return this.c.getListIndex(f)}getListRenderCount(A){const f=this.o(A);return this.c.getListRenderCount(f)}isCollapsible(A){const f=this.o(A);return this.c.isCollapsible(f)}setCollapsible(A,f){const g=this.o(A);return this.c.setCollapsible(g,f)}isCollapsed(A){const f=this.o(A);return this.c.isCollapsed(f)}setCollapsed(A,f,g){const c=this.o(A);return this.c.setCollapsed(c,f,g)}expandTo(A){const f=this.o(A);this.c.expandTo(f)}refilter(){this.c.refilter()}getNode(A=null){if(A===null)return this.c.getNode(this.c.rootRef);const f=this.d.get(A);if(!f)throw new T.$YS(this.k,`Tree element not found: ${A}`);return f}getNodeLocation(A){return A.element}getParentNodeLocation(A){if(A===null)throw new T.$YS(this.k,"Invalid getParentNodeLocation call");const f=this.d.get(A);if(!f)throw new T.$YS(this.k,`Tree element not found: ${A}`);const g=this.c.getNodeLocation(f),c=this.c.getParentNodeLocation(g);return this.c.getNode(c).element}o(A){if(A===null)return[];const f=this.d.get(A);if(!f)throw new T.$YS(this.k,`Tree element not found: ${A}`);return this.c.getNodeLocation(f)}}t.$9S=H}),define($e[21],we([1,0,3,15,20,24,2]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yQ=void 0;class A extends w.$Rc{f(g,c){this.B(v.$XO(g,v.$QP.CLICK,L=>c(new i.$PO(L))))}j(g,c){this.B(v.$XO(g,v.$QP.MOUSE_DOWN,L=>c(new i.$PO(L))))}m(g,c){this.B(v.$XO(g,v.$QP.MOUSE_OVER,L=>c(new i.$PO(L))))}u(g,c){this.B(v.$XO(g,v.$QP.MOUSE_LEAVE,L=>c(new i.$PO(L))))}z(g,c){this.B(v.$XO(g,v.$QP.KEY_DOWN,L=>c(new T.$UO(L))))}C(g,c){this.B(v.$XO(g,v.$QP.KEY_UP,L=>c(new T.$UO(L))))}D(g,c){this.B(v.$XO(g,v.$QP.INPUT,c))}F(g,c){this.B(v.$XO(g,v.$QP.BLUR,c))}G(g,c){this.B(v.$XO(g,v.$QP.FOCUS,c))}H(g,c){this.B(v.$XO(g,v.$QP.CHANGE,c))}I(g){return H.$uQ.ignoreTarget(g)}}t.$yQ=A}),define($e[38],we([1,0,56,21,9,19,3]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AQ=t.$zQ=void 0,t.$zQ=11;class A extends T.$yQ{constructor(g){super(),this.a=g.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=g.bgWidth+"px",this.bgDomNode.style.height=g.bgHeight+"px",typeof g.top<"u"&&(this.bgDomNode.style.top="0px"),typeof g.left<"u"&&(this.bgDomNode.style.left="0px"),typeof g.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof g.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=g.className,this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(g.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$zQ+"px",this.domNode.style.height=t.$zQ+"px",typeof g.top<"u"&&(this.domNode.style.top=g.top+"px"),typeof g.left<"u"&&(this.domNode.style.left=g.left+"px"),typeof g.bottom<"u"&&(this.domNode.style.bottom=g.bottom+"px"),typeof g.right<"u"&&(this.domNode.style.right=g.right+"px"),this.g=this.B(new v.$xQ),this.B(w.$YO(this.bgDomNode,w.$QP.POINTER_DOWN,c=>this.h(c))),this.B(w.$YO(this.domNode,w.$QP.POINTER_DOWN,c=>this.h(c))),this.b=this.B(new w.$0O),this.c=this.B(new i.$5g)}h(g){if(!g.target||!(g.target instanceof Element))return;const c=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,w.$DP(g))};this.a(),this.b.cancel(),this.c.cancelAndSet(c,200),this.g.startMonitoring(g.target,g.pointerId,g.buttons,L=>{},()=>{this.b.cancel(),this.c.cancel()}),g.preventDefault()}}t.$AQ=A}),define($e[59],we([1,0,3,41,56,38,120,21,5]),function(ae,t,v,T,i,H,w,A,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DQ=void 0;const g=140;class c extends A.$yQ{constructor(s){super(),this.g=s.lazyRender,this.a=s.host,this.b=s.scrollable,this.c=s.scrollByPage,this.h=s.scrollbarState,this.n=this.B(new w.$CQ(s.visibility,"visible scrollbar "+s.extraScrollbarClassName,"invisible scrollbar "+s.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new i.$xQ),this.s=!0,this.domNode=(0,T.$wQ)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(v.$XO(this.domNode.domNode,v.$QP.POINTER_DOWN,h=>this.M(h)))}t(s){const h=this.B(new H.$AQ(s));this.domNode.domNode.appendChild(h.bgDomNode),this.domNode.domNode.appendChild(h.domNode)}w(s,h,e,o){this.slider=(0,T.$wQ)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(s),this.slider.setLeft(h),typeof e=="number"&&this.slider.setWidth(e),typeof o=="number"&&this.slider.setHeight(o),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(v.$XO(this.slider.domNode,v.$QP.POINTER_DOWN,a=>{a.button===0&&(a.preventDefault(),this.O(a))})),this.f(this.slider.domNode,a=>{a.leftButton&&a.stopPropagation()})}y(s){return this.h.setVisibleSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(s){return this.h.setScrollSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(s){return this.h.setScrollPosition(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(s){s.target===this.domNode.domNode&&this.N(s)}delegatePointerDown(s){const h=this.domNode.domNode.getClientRects()[0].top,e=h+this.h.getSliderPosition(),o=h+this.h.getSliderPosition()+this.h.getSliderSize(),a=this.U(s);e<=a&&a<=o?s.button===0&&(s.preventDefault(),this.O(s)):this.N(s)}N(s){let h,e;if(s.target===this.domNode.domNode&&typeof s.offsetX=="number"&&typeof s.offsetY=="number")h=s.offsetX,e=s.offsetY;else{const a=v.$hP(this.domNode.domNode);h=s.pageX-a.left,e=s.pageY-a.top}const o=this.S(h,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(o):this.h.getDesiredScrollPositionFromOffset(o)),s.button===0&&(s.preventDefault(),this.O(s))}O(s){if(!s.target||!(s.target instanceof Element))return;const h=this.U(s),e=this.W(s),o=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(s.target,s.pointerId,s.buttons,a=>{const m=this.W(a),n=Math.abs(m-e);if(f.$i&&n>g){this.P(o.getScrollPosition());return}const b=this.U(a)-h;this.P(o.getDesiredScrollPositionFromDelta(b))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(s){const h={};this.writeScrollPosition(h,s),this.b.setScrollPositionNow(h)}updateScrollbarSize(s){this.X(s),this.h.setScrollbarSize(s),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$DQ=c}),define($e[123],we([1,0,20,59,38,42,18]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EQ=void 0;class A extends T.$DQ{constructor(g,c,L){const s=g.getScrollDimensions(),h=g.getCurrentScrollPosition();if(super({lazyRender:c.lazyRender,host:L,scrollbarState:new H.$BQ(c.horizontalHasArrows?c.arrowSize:0,c.horizontal===2?0:c.horizontalScrollbarSize,c.vertical===2?0:c.verticalScrollbarSize,s.width,s.scrollWidth,h.scrollLeft),visibility:c.horizontal,extraScrollbarClassName:"horizontal",scrollable:g,scrollByPage:c.scrollByPage}),c.horizontalHasArrows){const e=(c.arrowSize-i.$zQ)/2,o=(c.horizontalScrollbarSize-i.$zQ)/2;this.t({className:"scra",icon:w.$Xj.scrollbarButtonLeft,top:o,left:e,bottom:void 0,right:void 0,bgWidth:c.arrowSize,bgHeight:c.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.$RO(null,1,0))}),this.t({className:"scra",icon:w.$Xj.scrollbarButtonRight,top:o,left:void 0,bottom:void 0,right:e,bgWidth:c.arrowSize,bgHeight:c.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.$RO(null,-1,0))})}this.w(Math.floor((c.horizontalScrollbarSize-c.horizontalSliderSize)/2),0,void 0,c.horizontalSliderSize)}R(g,c){this.slider.setWidth(g),this.slider.setLeft(c)}Q(g,c){this.domNode.setWidth(g),this.domNode.setHeight(c),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(g){return this.s=this.J(g.scrollWidth)||this.s,this.s=this.L(g.scrollLeft)||this.s,this.s=this.y(g.width)||this.s,this.s}S(g,c){return g}U(g){return g.pageX}W(g){return g.pageY}X(g){this.slider.setHeight(g)}writeScrollPosition(g,c){g.scrollLeft=c}updateOptions(g){this.updateScrollbarSize(g.horizontal===2?0:g.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.n.setVisibility(g.horizontal),this.c=g.scrollByPage}}t.$EQ=A}),define($e[124],we([1,0,20,59,38,42,18]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FQ=void 0;class A extends T.$DQ{constructor(g,c,L){const s=g.getScrollDimensions(),h=g.getCurrentScrollPosition();if(super({lazyRender:c.lazyRender,host:L,scrollbarState:new H.$BQ(c.verticalHasArrows?c.arrowSize:0,c.vertical===2?0:c.verticalScrollbarSize,0,s.height,s.scrollHeight,h.scrollTop),visibility:c.vertical,extraScrollbarClassName:"vertical",scrollable:g,scrollByPage:c.scrollByPage}),c.verticalHasArrows){const e=(c.arrowSize-i.$zQ)/2,o=(c.verticalScrollbarSize-i.$zQ)/2;this.t({className:"scra",icon:w.$Xj.scrollbarButtonUp,top:e,left:o,bottom:void 0,right:void 0,bgWidth:c.verticalScrollbarSize,bgHeight:c.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.$RO(null,0,1))}),this.t({className:"scra",icon:w.$Xj.scrollbarButtonDown,top:void 0,left:o,bottom:e,right:void 0,bgWidth:c.verticalScrollbarSize,bgHeight:c.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.$RO(null,0,-1))})}this.w(0,Math.floor((c.verticalScrollbarSize-c.verticalSliderSize)/2),c.verticalSliderSize,void 0)}R(g,c){this.slider.setHeight(g),this.slider.setTop(c)}Q(g,c){this.domNode.setWidth(c),this.domNode.setHeight(g),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(g){return this.s=this.J(g.scrollHeight)||this.s,this.s=this.L(g.scrollTop)||this.s,this.s=this.y(g.height)||this.s,this.s}S(g,c){return c}U(g){return g.pageY}W(g){return g.pageX}X(g){this.slider.setWidth(g)}writeScrollPosition(g,c){g.scrollTop=c}updateOptions(g){this.updateScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(g.vertical),this.c=g.scrollByPage}}t.$FQ=A}),define($e[60],we([1,0,17,3,41,20,123,124,21,9,4,2,5,48,98]),function(ae,t,v,T,i,H,w,A,f,g,c,L,s,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KQ=t.$JQ=t.$IQ=t.$HQ=t.$GQ=void 0;const e=500,o=50,a=!0;class m{constructor(R,d,D){this.timestamp=R,this.deltaX=d,this.deltaY=D,this.score=0}}class n{static{this.INSTANCE=new n}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let R=1,d=0,D=1,B=this.d;do{const _=B===this.c?R:Math.pow(2,-D);if(R-=_,d+=this.b[B].score*_,B===this.c)break;B=(this.a+B-1)%this.a,D++}while(!0);return d<=.5}acceptStandardWheelEvent(R){const d=T.$DP(R.browserEvent).devicePixelRatio/(0,v.$yO)();s.$i||s.$k?this.accept(Date.now(),R.deltaX/d,R.deltaY/d):this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,d,D){const B=new m(R,d,D);B.score=this.f(B),this.c===-1&&this.d===-1?(this.b[0]=B,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=B)}f(R){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let d=.5;const D=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(R.deltaX)||!this.g(R.deltaY))&&(d+=.25),Math.min(Math.max(d,0),1)}g(R){return Math.abs(Math.round(R)-R)<.01}}t.$GQ=n;class r extends f.$yQ{get options(){return this.a}constructor(R,d,D){super(),this.O=this.B(new c.$Od),this.onScroll=this.O.event,this.P=this.B(new c.$Od),this.onWillScroll=this.P.event,R.style.overflow="hidden",this.a=N(d),this.b=D,this.B(this.b.onScroll(_=>{this.P.fire(_),this.S(_),this.O.fire(_)}));const B={onMouseWheel:_=>this.R(_),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new A.$FQ(this.b,this.a,B)),this.g=this.B(new w.$EQ(this.b,this.a,B)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(R),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,i.$wQ)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,i.$wQ)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,i.$wQ)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,_=>this.Z(_)),this.u(this.t,_=>this.Y(_)),this.L=this.B(new g.$5g),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,L.$Mc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this.c.delegatePointerDown(R)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(R){this.b.setScrollDimensions(R,!1)}updateClassName(R){this.a.className=R,s.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this.a.handleMouseWheel=R.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this.a.horizontal=R.horizontal),typeof R.vertical<"u"&&(this.a.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this.a.scrollByPage=R.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(R){this.N=R}delegateScrollFromMouseWheelEvent(R){this.R(new H.$RO(R))}Q(R){if(this.w.length>0!==R&&(this.w=(0,L.$Mc)(this.w),R)){const D=B=>{this.R(new H.$RO(B))};this.w.push(T.$XO(this.t,T.$QP.MOUSE_WHEEL,D,{passive:!1}))}}R(R){if(R.browserEvent?.defaultPrevented)return;const d=n.INSTANCE;a&&d.acceptStandardWheelEvent(R);let D=!1;if(R.deltaY||R.deltaX){let _=R.deltaY*this.a.mouseWheelScrollSensitivity,x=R.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&x+_===0?x=_=0:Math.abs(_)>=Math.abs(x)?x=0:_=0),this.a.flipAxes&&([_,x]=[x,_]);const P=!s.$j&&R.browserEvent&&R.browserEvent.shiftKey;(this.a.scrollYToX||P)&&!x&&(x=_,_=0),R.browserEvent&&R.browserEvent.altKey&&(x=x*this.a.fastScrollSensitivity,_=_*this.a.fastScrollSensitivity);const O=this.b.getFutureScrollPosition();let K={};if(_){const te=o*_,se=O.scrollTop-(te<0?Math.floor(te):Math.ceil(te));this.c.writeScrollPosition(K,se)}if(x){const te=o*x,se=O.scrollLeft-(te<0?Math.floor(te):Math.ceil(te));this.g.writeScrollPosition(K,se)}K=this.b.validateScrollPosition(K),(O.scrollLeft!==K.scrollLeft||O.scrollTop!==K.scrollTop)&&(a&&this.a.mouseWheelSmoothScroll&&d.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(K):this.b.setScrollPositionNow(K),D=!0)}let B=D;!B&&this.a.alwaysConsumeMouseWheel&&(B=!0),!B&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(B=!0),B&&(R.preventDefault(),R.stopPropagation())}S(R){this.M=this.g.onDidScroll(R)||this.M,this.M=this.c.onDidScroll(R)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const R=this.b.getCurrentScrollPosition(),d=R.scrollTop>0,D=R.scrollLeft>0,B=D?" left":"",_=d?" top":"",x=D||d?" top-left-corner":"";this.n.setClassName(`shadow${B}`),this.r.setClassName(`shadow${_}`),this.s.setClassName(`shadow${x}${_}${B}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(R){this.J=!1,this.ab()}Z(R){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$HQ=r;class b extends r{constructor(R,d){d=d||{},d.mouseWheelSmoothScroll=!1;const D=new h.$Yr({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:B=>T.$8O(T.$DP(R),B)});super(R,d,D),this.B(D)}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$IQ=b;class u extends r{constructor(R,d,D){super(R,d,D)}setScrollPosition(R){R.reuseAnimation?this.b.setScrollPositionSmooth(R,R.reuseAnimation):this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$JQ=u;class l extends r{constructor(R,d){d=d||{},d.mouseWheelSmoothScroll=!1;const D=new h.$Yr({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:B=>T.$8O(T.$DP(R),B)});super(R,d,D),this.B(D),this.cb=R,this.B(this.onScroll(B=>{B.scrollTopChanged&&(this.cb.scrollTop=B.scrollTop),B.scrollLeftChanged&&(this.cb.scrollLeft=B.scrollLeft)})),this.scanDomNode()}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$KQ=l;function N(z){const R={lazyRender:typeof z.lazyRender<"u"?z.lazyRender:!1,className:typeof z.className<"u"?z.className:"",useShadows:typeof z.useShadows<"u"?z.useShadows:!0,handleMouseWheel:typeof z.handleMouseWheel<"u"?z.handleMouseWheel:!0,flipAxes:typeof z.flipAxes<"u"?z.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof z.consumeMouseWheelIfScrollbarIsNeeded<"u"?z.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof z.alwaysConsumeMouseWheel<"u"?z.alwaysConsumeMouseWheel:!1,scrollYToX:typeof z.scrollYToX<"u"?z.scrollYToX:!1,mouseWheelScrollSensitivity:typeof z.mouseWheelScrollSensitivity<"u"?z.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof z.fastScrollSensitivity<"u"?z.fastScrollSensitivity:5,scrollPredominantAxis:typeof z.scrollPredominantAxis<"u"?z.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof z.mouseWheelSmoothScroll<"u"?z.mouseWheelSmoothScroll:!0,arrowSize:typeof z.arrowSize<"u"?z.arrowSize:11,listenOnDomNode:typeof z.listenOnDomNode<"u"?z.listenOnDomNode:null,horizontal:typeof z.horizontal<"u"?z.horizontal:1,horizontalScrollbarSize:typeof z.horizontalScrollbarSize<"u"?z.horizontalScrollbarSize:10,horizontalSliderSize:typeof z.horizontalSliderSize<"u"?z.horizontalSliderSize:0,horizontalHasArrows:typeof z.horizontalHasArrows<"u"?z.horizontalHasArrows:!1,vertical:typeof z.vertical<"u"?z.vertical:1,verticalScrollbarSize:typeof z.verticalScrollbarSize<"u"?z.verticalScrollbarSize:10,verticalHasArrows:typeof z.verticalHasArrows<"u"?z.verticalHasArrows:!1,verticalSliderSize:typeof z.verticalSliderSize<"u"?z.verticalSliderSize:0,scrollByPage:typeof z.scrollByPage<"u"?z.scrollByPage:!1};return R.horizontalSliderSize=typeof z.horizontalSliderSize<"u"?z.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof z.verticalSliderSize<"u"?z.verticalSliderSize:R.verticalScrollbarSize,s.$j&&(R.className+=" mac"),R}}),define($e[61],we([1,0,54,3,22,24,60,11,9,26,4,2,47,48,82,119,6]),function(ae,t,v,T,i,H,w,A,f,g,c,L,s,h,e,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cR=t.$bR=t.$aR=t.$_Q=void 0;const m={CurrentDragAndDropData:void 0},n={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(R){return[R]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(d){this.d=d}constructor(d){this.elements=d}update(){}getData(){return this.elements}}t.$_Q=r;class b{constructor(d){this.elements=d}update(){}getData(){return this.elements}}t.$aR=b;class u{constructor(){this.types=[],this.files=[]}update(d){if(d.types&&this.types.splice(0,this.types.length,...d.types),d.files){this.files.splice(0,this.files.length);for(let D=0;D<d.files.length;D++){const B=d.files.item(D);B&&(B.size||B.type)&&this.files.push(B)}}}getData(){return{types:this.types,files:this.files}}}t.$bR=u;function l(R,d){return Array.isArray(R)&&Array.isArray(d)?(0,A.$tb)(R,d):R===d}class N{constructor(d){d?.getSetSize?this.getSetSize=d.getSetSize.bind(d):this.getSetSize=(D,B,_)=>_,d?.getPosInSet?this.getPosInSet=d.getPosInSet.bind(d):this.getPosInSet=(D,B)=>B+1,d?.getRole?this.getRole=d.getRole.bind(d):this.getRole=D=>"listitem",d?.isChecked?this.isChecked=d.isChecked.bind(d):this.isChecked=D=>{}}}class z{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(d){if(d!==this.O){if(d&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=d,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const D of this.d)this.Y(D);this.V(),this.q.setScrollDimensions({width:(0,T.$kP)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(d,D,B,_=n){if(this.Q=D,this.domId=`list_id_${++z.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new f.$Rg(50),this.v=!1,this.x=L.$Rc.None,this.y=0,this.G=!1,this.J=L.$Rc.None,this.K=L.$Rc.None,this.L=new L.$Qc,this.M=new c.$Od,this.N=new c.$Od,this.onDidChangeContentHeight=c.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=c.Event.latch(this.N.event,void 0,this.L),this.O=!1,_.horizontalScrolling&&_.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$0Q(_.paddingTop??0);for(const P of B)this.j.set(P.templateId,P);this.h=this.L.add(new o.$$Q(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof _.mouseSupport=="boolean"?_.mouseSupport:!0),this.O=_.horizontalScrolling??n.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof _.paddingBottom>"u"?0:_.paddingBottom,this.D=new N(_.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(_.transformOptimization??n.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(H.$uQ.addTarget(this.o)),this.p=this.L.add(new h.$Yr({forceIntegerValues:!0,smoothScrollDuration:_.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:P=>(0,T.$8O)((0,T.$DP)(this.domNode),P)})),this.q=this.L.add(new w.$JQ(this.o,{alwaysConsumeMouseWheel:_.alwaysConsumeMouseWheel??n.alwaysConsumeMouseWheel,horizontal:1,vertical:_.verticalScrollMode??n.verticalScrollMode,useShadows:_.useShadows??n.useShadows,mouseWheelScrollSensitivity:_.mouseWheelScrollSensitivity,fastScrollSensitivity:_.fastScrollSensitivity,scrollByPage:_.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),d.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,T.$XO)(this.o,H.EventType.Change,P=>this.hb(P))),this.L.add((0,T.$XO)(this.q.getDomNode(),"scroll",P=>P.target.scrollTop=0)),this.L.add((0,T.$XO)(this.domNode,"dragover",P=>this.jb(this.fb(P)))),this.L.add((0,T.$XO)(this.domNode,"drop",P=>this.lb(this.fb(P)))),this.L.add((0,T.$XO)(this.domNode,"dragleave",P=>this.kb(this.fb(P)))),this.L.add((0,T.$XO)(this.domNode,"dragend",P=>this.mb(P))),this.z=_.setRowLineHeight??n.setRowLineHeight,this.A=_.setRowHeight??n.setRowHeight,this.B=_.supportDynamicHeights??n.supportDynamicHeights,this.F=_.dnd??this.L.add(n.dnd),this.layout(_.initialSize?.height,_.initialSize?.width)}updateOptions(d){d.paddingBottom!==void 0&&(this.C=d.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),d.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(d.smoothScrolling?125:0),d.horizontalScrolling!==void 0&&(this.P=d.horizontalScrolling);let D;if(d.scrollByPage!==void 0&&(D={...D??{},scrollByPage:d.scrollByPage}),d.mouseWheelScrollSensitivity!==void 0&&(D={...D??{},mouseWheelScrollSensitivity:d.mouseWheelScrollSensitivity}),d.fastScrollSensitivity!==void 0&&(D={...D??{},fastScrollSensitivity:d.fastScrollSensitivity}),D&&this.q.updateOptions(D),d.paddingTop!==void 0&&d.paddingTop!==this.g.paddingTop){const B=this.sb(this.k,this.m),_=d.paddingTop-this.g.paddingTop;this.g.paddingTop=d.paddingTop,this.W(B,Math.max(0,this.k+_),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(d){this.q.delegateScrollFromMouseWheelEvent(d)}delegateVerticalScrollbarPointerDown(d){this.q.delegateVerticalScrollbarPointerDown(d)}updateElementHeight(d,D,B){if(d<0||d>=this.d.length)return;const _=this.d[d].size;if(typeof D>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[d].lastDynamicHeightWidth=void 0,D=_+this.ub(d)}if(_===D)return;const x=this.sb(this.k,this.m);let P=0;d<x.start||B!==null&&B>d&&B<x.end?P=D-_:P=0,this.g.splice(d,1,[{size:D}]),this.d[d].size=D,this.W(x,Math.max(0,this.k+P),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(d,D,B=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(d,D,B)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(d,D,B=[]){const _=this.sb(this.k,this.m),x={start:d,end:d+D},P=s.Range.intersect(_,x),O=new Map;for(let W=P.end-1;W>=P.start;W--){const Y=this.d[W];if(Y.dragStartDisposable.dispose(),Y.checkedDisposable.dispose(),Y.row){let S=O.get(Y.templateId);S||(S=[],O.set(Y.templateId,S));const q=this.j.get(Y.templateId);q&&q.disposeElement&&q.disposeElement(Y.element,W,Y.row.templateData,Y.size),S.push(Y.row)}Y.row=null}const K={start:d+D,end:this.d.length},te=s.Range.intersect(K,_),se=s.Range.relativeComplement(K,_),fe=B.map(W=>({id:String(this.f++),element:W,templateId:this.Q.getTemplateId(W),size:this.Q.getHeight(W),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(W),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:L.$Rc.None,checkedDisposable:L.$Rc.None}));let le;d===0&&D>=this.d.length?(this.g=new e.$0Q(this.g.paddingTop),this.g.splice(0,0,fe),le=this.d,this.d=fe):(this.g.splice(d,D,fe),le=this.d.splice(d,D,...fe));const oe=B.length-D,be=this.sb(this.k,this.m),Ce=(0,e.$8Q)(te,oe),Ae=s.Range.intersect(be,Ce);for(let W=Ae.start;W<Ae.end;W++)this.Z(this.d[W],W);const Pe=s.Range.relativeComplement(Ce,be);for(const W of Pe)for(let Y=W.start;Y<W.end;Y++)this.ab(Y);const de=se.map(W=>(0,e.$8Q)(W,oe)),ce=[{start:d,end:d+B.length},...de].map(W=>s.Range.intersect(be,W)),Z=this.vb(ce);for(const W of ce)for(let Y=W.start;Y<W.end;Y++){const S=this.d[Y],$=O.get(S.templateId)?.pop();this.X(Y,Z,$)}for(const W of O.values())for(const Y of W)this.h.release(Y);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),le.map(W=>W.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,T.$8O)((0,T.$DP)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let d=0;for(const D of this.d)typeof D.width<"u"&&(d=Math.max(d,D.width));this.E=d,this.q.setScrollDimensions({scrollWidth:d===0?0:d+10}),this.N.fire(this.E)}updateWidth(d){if(!this.P||typeof this.E>"u")return;const D=this.d[d];this.Y(D),typeof D.width<"u"&&D.width>this.E&&(this.E=D.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const d of this.d)d.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const d=this.sb(this.k,this.m),D=this.g.positionAt(d.start),B=this.g.positionAt(d.start+1);return B!==-1&&(B-D)/2+D<this.scrollTop?d.start+1:d.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(d){return this.d[d].element}indexOf(d){return this.d.findIndex(D=>D.element===d)}domElement(d){const D=this.d[d].row;return D&&D.domNode}elementHeight(d){return this.d[d].size}elementTop(d){return this.g.positionAt(d)}indexAt(d){return this.g.indexAt(d)}indexAfter(d){return this.g.indexAfter(d)}layout(d,D){const B={height:typeof d=="number"?d:(0,T.$mP)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,B.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(B),typeof D<"u"&&(this.n=D,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof D=="number"?D:(0,T.$kP)(this.domNode)})}W(d,D,B,_,x,P=!1){const O=this.sb(D,B),K=s.Range.relativeComplement(O,d),te=s.Range.relativeComplement(d,O),se=this.vb(K);if(P){const fe=s.Range.intersect(d,O);for(let le=fe.start;le<fe.end;le++)this.Z(this.d[le],le)}this.h.transact(()=>{for(const fe of te)for(let le=fe.start;le<fe.end;le++)this.ab(le);for(const fe of K)for(let le=fe.start;le<fe.end;le++)this.X(le,se)}),_!==void 0&&(this.o.style.left=`-${_}px`),this.o.style.top=`-${D}px`,this.P&&x!==void 0&&(this.o.style.width=`${Math.max(x,this.n)}px`),this.k=D,this.m=B}X(d,D,B){const _=this.d[d];let x=!1;if(!_.row)if(B)_.row=B;else{const se=this.h.alloc(_.templateId);_.row=se.row,x=se.isReusingConnectedDomNode}const P=this.D.getRole(_.element)||"listitem";_.row.domNode.setAttribute("role",P);const O=this.D.isChecked(_.element);if(typeof O=="boolean")_.row.domNode.setAttribute("aria-checked",String(!!O));else if(O){const se=fe=>_.row.domNode.setAttribute("aria-checked",String(!!fe));se(O.value),_.checkedDisposable=O.onDidChange(se)}(x||!_.row.domNode.parentElement)&&(D?this.o.insertBefore(_.row.domNode,D):this.o.appendChild(_.row.domNode)),this.Z(_,d);const K=this.j.get(_.templateId);if(!K)throw new Error(`No renderer found for template id ${_.templateId}`);K?.renderElement(_.element,d,_.row.templateData,_.size);const te=this.F.getDragURI(_.element);_.dragStartDisposable.dispose(),_.row.domNode.draggable=!!te,te&&(_.dragStartDisposable=(0,T.$XO)(_.row.domNode,"dragstart",se=>this.ib(_.element,te,se))),this.P&&(this.Y(_),this.U())}Y(d){if(!d.row||!d.row.domNode)return;d.row.domNode.style.width="fit-content",d.width=(0,T.$kP)(d.row.domNode);const D=(0,T.$DP)(d.row.domNode).getComputedStyle(d.row.domNode);D.paddingLeft&&(d.width+=parseFloat(D.paddingLeft)),D.paddingRight&&(d.width+=parseFloat(D.paddingRight)),d.row.domNode.style.width=""}Z(d,D){d.row.domNode.style.top=`${this.elementTop(D)}px`,this.A&&(d.row.domNode.style.height=`${d.size}px`),this.z&&(d.row.domNode.style.lineHeight=`${d.size}px`),d.row.domNode.setAttribute("data-index",`${D}`),d.row.domNode.setAttribute("data-last-element",D===this.length-1?"true":"false"),d.row.domNode.setAttribute("data-parity",D%2===0?"even":"odd"),d.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(d.element,D,this.length))),d.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(d.element,D))),d.row.domNode.setAttribute("id",this.getElementDomId(D)),d.row.domNode.classList.toggle("drop-target",d.dropTarget)}ab(d){const D=this.d[d];if(D.dragStartDisposable.dispose(),D.checkedDisposable.dispose(),D.row){const B=this.j.get(D.templateId);B&&B.disposeElement&&B.disposeElement(D.element,d,D.row.templateData,D.size),this.h.release(D.row),D.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(d,D){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:d,reuseAnimation:D})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(d){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:d})}get scrollTop(){return this.getScrollTop()}set scrollTop(d){this.setScrollTop(d)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return c.Event.map(this.L.add(new i.$YQ(this.domNode,"click")).event,d=>this.bb(d),this.L)}get onMouseDblClick(){return c.Event.map(this.L.add(new i.$YQ(this.domNode,"dblclick")).event,d=>this.bb(d),this.L)}get onMouseMiddleClick(){return c.Event.filter(c.Event.map(this.L.add(new i.$YQ(this.domNode,"auxclick")).event,d=>this.bb(d),this.L),d=>d.browserEvent.button===1,this.L)}get onMouseUp(){return c.Event.map(this.L.add(new i.$YQ(this.domNode,"mouseup")).event,d=>this.bb(d),this.L)}get onMouseDown(){return c.Event.map(this.L.add(new i.$YQ(this.domNode,"mousedown")).event,d=>this.bb(d),this.L)}get onMouseOver(){return c.Event.map(this.L.add(new i.$YQ(this.domNode,"mouseover")).event,d=>this.bb(d),this.L)}get onMouseMove(){return c.Event.map(this.L.add(new i.$YQ(this.domNode,"mousemove")).event,d=>this.bb(d),this.L)}get onMouseOut(){return c.Event.map(this.L.add(new i.$YQ(this.domNode,"mouseout")).event,d=>this.bb(d),this.L)}get onContextMenu(){return c.Event.any(c.Event.map(this.L.add(new i.$YQ(this.domNode,"contextmenu")).event,d=>this.bb(d),this.L),c.Event.map(this.L.add(new i.$YQ(this.domNode,H.EventType.Contextmenu)).event,d=>this.eb(d),this.L))}get onTouchStart(){return c.Event.map(this.L.add(new i.$YQ(this.domNode,"touchstart")).event,d=>this.db(d),this.L)}get onTap(){return c.Event.map(this.L.add(new i.$YQ(this.o,H.EventType.Tap)).event,d=>this.eb(d),this.L)}bb(d){const D=this.rb(d.target||null),B=typeof D>"u"?void 0:this.d[D],_=B&&B.element;return{browserEvent:d,index:D,element:_}}db(d){const D=this.rb(d.target||null),B=typeof D>"u"?void 0:this.d[D],_=B&&B.element;return{browserEvent:d,index:D,element:_}}eb(d){const D=this.rb(d.initialTarget||null),B=typeof D>"u"?void 0:this.d[D],_=B&&B.element;return{browserEvent:d,index:D,element:_}}fb(d){const D=this.rb(d.target||null),B=typeof D>"u"?void 0:this.d[D],_=B&&B.element;return{browserEvent:d,index:D,element:_}}gb(d){try{const D=this.sb(this.k,this.m);this.W(D,d.scrollTop,d.height,d.scrollLeft,d.scrollWidth),this.B&&this.tb(d.scrollTop,d.height,d.inSmoothScrolling)}catch(D){throw console.error("Got bad scroll event:",d),D}}hb(d){d.preventDefault(),d.stopPropagation(),this.scrollTop-=d.translationY}ib(d,D,B){if(!B.dataTransfer)return;const _=this.F.getDragElements(d);if(B.dataTransfer.effectAllowed="copyMove",B.dataTransfer.setData(v.$sQ.TEXT,D),B.dataTransfer.setDragImage){let x;this.F.getDragLabel&&(x=this.F.getDragLabel(_,B)),typeof x>"u"&&(x=String(_.length));const P=(0,T.$)(".monaco-drag-image");P.textContent=x;const K=(te=>{for(;te&&!te.classList.contains("monaco-workbench");)te=te.parentElement;return te||this.domNode.ownerDocument})(this.domNode);K.appendChild(P),B.dataTransfer.setDragImage(P,-10,-10),setTimeout(()=>K.removeChild(P),0)}this.domNode.classList.add("dragging"),this.H=new r(_),m.CurrentDragAndDropData=new b(_),this.F.onDragStart?.(this.H,B)}jb(d){if(d.browserEvent.preventDefault(),this.K.dispose(),m.CurrentDragAndDropData&&m.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(d.browserEvent),!d.browserEvent.dataTransfer))return!1;if(!this.H)if(m.CurrentDragAndDropData)this.H=m.CurrentDragAndDropData;else{if(!d.browserEvent.dataTransfer.types)return!1;this.H=new u}const D=this.F.onDragOver(this.H,d.element,d.index,d.browserEvent);if(this.G=typeof D=="boolean"?D:D.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;d.browserEvent.dataTransfer.dropEffect=typeof D!="boolean"&&D.effect===0?"copy":"move";let B;if(typeof D!="boolean"&&D.feedback?B=D.feedback:typeof d.index>"u"?B=[-1]:B=[d.index],B=(0,A.$Lb)(B).filter(_=>_>=-1&&_<this.length).sort((_,x)=>_-x),B=B[0]===-1?[-1]:B,l(this.I,B))return!0;if(this.I=B,this.J.dispose(),B[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,L.$Pc)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const _ of B){const x=this.d[_];x.dropTarget=!0,x.row?.domNode.classList.add("drop-target")}this.J=(0,L.$Pc)(()=>{for(const _ of B){const x=this.d[_];x.dropTarget=!1,x.row?.domNode.classList.remove("drop-target")}})}return!0}kb(d){this.K.dispose(),this.K=(0,f.$Wg)(()=>this.nb(),100,this.L),this.H&&this.F.onDragLeave?.(this.H,d.element,d.index,d.browserEvent)}lb(d){if(!this.G)return;const D=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,!(!D||!d.browserEvent.dataTransfer)&&(d.browserEvent.preventDefault(),D.update(d.browserEvent.dataTransfer),this.F.drop(D,d.element,d.index,d.browserEvent))}mb(d){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(d)}nb(){this.I=void 0,this.J.dispose(),this.J=L.$Rc.None}ob(d){if(!this.w){const D=(0,T.$eP)(this.domNode).top;this.w=(0,T.$aQ)((0,T.$DP)(this.domNode),this.pb.bind(this,D))}this.x.dispose(),this.x=(0,f.$Wg)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.L),this.y=d.pageY}pb(d){if(this.y===void 0)return;const D=this.y-d,B=this.renderHeight-35;D<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(D-35))):D>B&&(this.scrollTop+=Math.min(14,Math.floor(.3*(D-B))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(d){const D=this.q.getDomNode();let B=d;for(;B instanceof HTMLElement&&B!==this.o&&D.contains(B);){const _=B.getAttribute("data-index");if(_){const x=Number(_);if(!isNaN(x))return x}B=B.parentElement}}sb(d,D){return{start:this.g.indexAt(d),end:this.g.indexAfter(d+D-1)}}tb(d,D,B){const _=this.sb(d,D);let x,P;d===this.elementTop(_.start)?(x=_.start,P=0):_.end-_.start>1&&(x=_.start+1,P=this.elementTop(x)-d);let O=0;for(;;){const K=this.sb(d,D);let te=!1;for(let se=K.start;se<K.end;se++){const fe=this.ub(se);fe!==0&&this.g.splice(se,1,[this.d[se]]),O+=fe,te=te||fe!==0}if(!te){O!==0&&this.S();const se=s.Range.relativeComplement(_,K);for(const le of se)for(let oe=le.start;oe<le.end;oe++)this.d[oe].row&&this.ab(oe);const fe=s.Range.relativeComplement(K,_);for(const le of fe)for(let oe=le.start;oe<le.end;oe++){const be=oe+1,Ce=be<this.d.length?this.d[be].row:null,Ae=Ce?Ce.domNode:null;this.X(oe,Ae)}for(let le=K.start;le<K.end;le++)this.d[le].row&&this.Z(this.d[le],le);if(typeof x=="number"){const le=this.p.getFutureScrollPosition().scrollTop-d,oe=this.elementTop(x)-P+le;this.setScrollTop(oe,B)}this.M.fire(this.contentHeight);return}}}ub(d){const D=this.d[d];if(this.Q.getDynamicHeight){const P=this.Q.getDynamicHeight(D.element);if(P!==null){const O=D.size;return D.size=P,D.lastDynamicHeightWidth=this.n,P-O}}if(!D.hasDynamicHeight||D.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(D.element))return 0;const B=D.size;if(D.row)return D.row.domNode.style.height="",D.size=D.row.domNode.offsetHeight,D.lastDynamicHeightWidth=this.n,D.size-B;const{row:_}=this.h.alloc(D.templateId);_.domNode.style.height="",this.o.appendChild(_.domNode);const x=this.j.get(D.templateId);if(!x)throw new a.$bb("Missing renderer for templateId: "+D.templateId);return x.renderElement(D.element,d,_.templateData,void 0),D.size=_.domNode.offsetHeight,x.disposeElement?.(D.element,d,_.templateData,void 0),this.Q.setDynamicHeight?.(D.element,D.size),D.lastDynamicHeightWidth=this.n,this.o.removeChild(_.domNode),this.h.release(_),D.size-B}vb(d){const D=d[d.length-1];if(!D)return null;const B=this.d[D.end];return!B||!B.row?null:B.row.domNode}getElementDomId(d){return`${this.domId}_${d}`}dispose(){for(const d of this.d)if(d.dragStartDisposable.dispose(),d.checkedDisposable.dispose(),d.row){const D=this.j.get(d.row.templateId);D&&(D.disposeElement?.(d.element,-1,d.row.templateData,void 0),D.disposeTemplate(d.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.L.dispose()}}t.$cR=z,Ge([g.$kh],z.prototype,"onMouseClick",null),Ge([g.$kh],z.prototype,"onMouseDblClick",null),Ge([g.$kh],z.prototype,"onMouseMiddleClick",null),Ge([g.$kh],z.prototype,"onMouseUp",null),Ge([g.$kh],z.prototype,"onMouseDown",null),Ge([g.$kh],z.prototype,"onMouseOver",null),Ge([g.$kh],z.prototype,"onMouseMove",null),Ge([g.$kh],z.prototype,"onMouseOut",null),Ge([g.$kh],z.prototype,"onContextMenu",null),Ge([g.$kh],z.prototype,"onTouchStart",null),Ge([g.$kh],z.prototype,"onTap",null)}),define($e[39],we([1,0,3,22,15,24,57,70,11,9,74,26,4,34,2,46,5,7,69,61,20,97]),function(ae,t,v,T,i,H,w,A,f,g,c,L,s,h,e,o,a,m,n,r,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mR=t.$lR=t.$kR=t.$jR=t.$iR=t.$hR=t.$gR=t.TypeNavigationMode=t.$fR=t.$eR=t.$dR=void 0;class u{constructor(S){this.d=S,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(S){return S}renderElement(S,q,$){const U=this.c.findIndex(Q=>Q.templateData===$);if(U>=0){const Q=this.c[U];this.d.unrender($),Q.index=q}else{const Q={index:q,templateData:$};this.c.push(Q)}this.d.renderIndex(q,$)}splice(S,q,$){const U=[];for(const Q of this.c)Q.index<S?U.push(Q):Q.index>=S+q&&U.push({index:Q.index+$-q,templateData:Q.templateData});this.c=U}renderIndexes(S){for(const{index:q,templateData:$}of this.c)S.indexOf(q)>-1&&this.d.renderIndex(q,$)}disposeTemplate(S){const q=this.c.findIndex($=>$.templateData===S);q<0||this.c.splice(q,1)}}class l{get name(){return this.h}get renderer(){return new u(this)}constructor(S){this.h=S,this.c=0,this.d=[],this.f=[],this.g=new s.$Od,this.onChange=this.g.event}splice(S,q,$){q=Math.max(0,Math.min(q,this.c-S));const U=$.length-q,Q=S+q,p=[];let E=0;for(;E<this.f.length&&this.f[E]<S;)p.push(this.f[E++]);for(let M=0;M<$.length;M++)$[M]&&p.push(M+S);for(;E<this.f.length&&this.f[E]>=Q;)p.push(this.f[E++]+U);const y=this.c+U;if(this.f.length>0&&p.length===0&&y>0){const M=this.f.find(k=>k>=S)??y-1;p.push(Math.min(M,y-1))}this.renderer.splice(S,q,$.length),this.k(p,p),this.c=y}renderIndex(S,q){q.classList.toggle(this.h,this.contains(S))}unrender(S){S.classList.remove(this.h)}set(S,q){return this.k(S,[...S].sort(de),q)}k(S,q,$){const U=this.d,Q=this.f;this.d=S,this.f=q;const p=Ae(Q,S);return this.renderer.renderIndexes(p),this.g.fire({indexes:S,browserEvent:$}),U}get(){return this.d}contains(S){return(0,f.$vb)(this.f,S,de)>=0}dispose(){(0,e.$Mc)(this.g)}}Ge([L.$kh],l.prototype,"renderer",null);class N extends l{constructor(S){super("selected"),this.l=S}renderIndex(S,q){super.renderIndex(S,q),this.l&&(this.contains(S)?q.setAttribute("aria-selected","true"):q.setAttribute("aria-selected","false"))}}class z{constructor(S,q,$){this.c=S,this.d=q,this.f=$}splice(S,q,$){if(!this.f)return this.c.splice(S,q,new Array($.length).fill(!1));const U=this.c.get().map(E=>this.f.getId(this.d.element(E)).toString());if(U.length===0)return this.c.splice(S,q,new Array($.length).fill(!1));const Q=new Set(U),p=$.map(E=>Q.has(this.f.getId(E).toString()));this.c.splice(S,q,p)}}function R(Y){return Y.tagName==="INPUT"||Y.tagName==="TEXTAREA"}t.$dR=R;function d(Y){return Y.classList.contains("monaco-editor")?!0:Y.classList.contains("monaco-list")||!Y.parentElement?!1:d(Y.parentElement)}t.$eR=d;function D(Y){return Y.tagName==="A"&&Y.classList.contains("monaco-button")||Y.tagName==="DIV"&&Y.classList.contains("monaco-button-dropdown")?!0:Y.classList.contains("monaco-list")||!Y.parentElement?!1:D(Y.parentElement)}t.$fR=D;class B{get g(){return s.Event.chain(this.c.add(new T.$YQ(this.k.domNode,"keydown")).event,S=>S.filter(q=>!R(q.target)).map(q=>new i.$UO(q)))}constructor(S,q,$){this.h=S,this.k=q,this.c=new e.$Qc,this.d=new e.$Qc,this.f=$.multipleSelectionSupport,this.c.add(this.g(U=>{switch(U.keyCode){case 3:return this.l(U);case 16:return this.o(U);case 18:return this.p(U);case 11:return this.q(U);case 12:return this.s(U);case 9:return this.u(U);case 31:this.f&&(a.$j?U.metaKey:U.ctrlKey)&&this.t(U)}}))}updateOptions(S){S.multipleSelectionSupport!==void 0&&(this.f=S.multipleSelectionSupport)}l(S){S.preventDefault(),S.stopPropagation(),this.h.setSelection(this.h.getFocus(),S.browserEvent)}o(S){S.preventDefault(),S.stopPropagation(),this.h.focusPrevious(1,!1,S.browserEvent);const q=this.h.getFocus()[0];this.h.setAnchor(q),this.h.reveal(q),this.k.domNode.focus()}p(S){S.preventDefault(),S.stopPropagation(),this.h.focusNext(1,!1,S.browserEvent);const q=this.h.getFocus()[0];this.h.setAnchor(q),this.h.reveal(q),this.k.domNode.focus()}q(S){S.preventDefault(),S.stopPropagation(),this.h.focusPreviousPage(S.browserEvent);const q=this.h.getFocus()[0];this.h.setAnchor(q),this.h.reveal(q),this.k.domNode.focus()}s(S){S.preventDefault(),S.stopPropagation(),this.h.focusNextPage(S.browserEvent);const q=this.h.getFocus()[0];this.h.setAnchor(q),this.h.reveal(q),this.k.domNode.focus()}t(S){S.preventDefault(),S.stopPropagation(),this.h.setSelection((0,f.$Rb)(this.h.length),S.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(S){this.h.getSelection().length&&(S.preventDefault(),S.stopPropagation(),this.h.setSelection([],S.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ge([L.$kh],B.prototype,"g",null);var _;(function(Y){Y[Y.Automatic=0]="Automatic",Y[Y.Trigger=1]="Trigger"})(_||(t.TypeNavigationMode=_={}));var x;(function(Y){Y[Y.Idle=0]="Idle",Y[Y.Typing=1]="Typing"})(x||(x={})),t.$gR=new class{mightProducePrintableCharacter(Y){return Y.ctrlKey||Y.metaKey||Y.altKey?!1:Y.keyCode>=31&&Y.keyCode<=56||Y.keyCode>=21&&Y.keyCode<=30||Y.keyCode>=98&&Y.keyCode<=107||Y.keyCode>=85&&Y.keyCode<=95}};class P{constructor(S,q,$,U,Q){this.o=S,this.p=q,this.q=$,this.s=U,this.t=Q,this.c=!1,this.d=x.Idle,this.f=_.Automatic,this.g=!1,this.h=-1,this.k=new e.$Qc,this.l=new e.$Qc,this.updateOptions(S.options)}updateOptions(S){S.typeNavigationEnabled??!0?this.u():this.v(),this.f=S.typeNavigationMode??_.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let S=!1;const q=s.Event.chain(this.k.add(new T.$YQ(this.p.domNode,"keydown")).event,Q=>Q.filter(p=>!R(p.target)).filter(()=>this.f===_.Automatic||this.g).map(p=>new i.$UO(p)).filter(p=>S||this.s(p)).filter(p=>this.t.mightProducePrintableCharacter(p)).forEach(p=>v.$SP.stop(p,!0)).map(p=>p.browserEvent.key)),$=s.Event.debounce(q,()=>null,800,void 0,void 0,void 0,this.k);s.Event.reduce(s.Event.any(q,$),(Q,p)=>p===null?null:(Q||"")+p,void 0,this.k)(this.x,this,this.k),$(this.w,this,this.k),q(()=>S=!0,void 0,this.k),$(()=>S=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const S=this.o.getFocus();if(S.length>0&&S[0]===this.h){const q=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(S[0]));q&&(0,w.$1Q)(q)}this.h=-1}x(S){if(!S){this.d=x.Idle,this.g=!1;return}const q=this.o.getFocus(),$=q.length>0?q[0]:0,U=this.d===x.Idle?1:0;this.d=x.Typing;for(let Q=0;Q<this.o.length;Q++){const p=($+Q+U)%this.o.length,E=this.q.getKeyboardNavigationLabel(this.p.element(p)),y=E&&E.toString();if(this.o.options.typeNavigationEnabled){if(typeof y<"u"){if((0,h.$Gj)(S,y)){this.h=$,this.o.setFocus([p]),this.o.reveal(p);return}const M=(0,h.$Nj)(S,y);if(M&&M[0].end-M[0].start>1&&M.length===1){this.h=$,this.o.setFocus([p]),this.o.reveal(p);return}}}else if(typeof y>"u"||(0,h.$Gj)(S,y)){this.h=$,this.o.setFocus([p]),this.o.reveal(p);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class O{constructor(S,q){this.d=S,this.f=q,this.c=new e.$Qc;const $=s.Event.chain(this.c.add(new T.$YQ(q.domNode,"keydown")).event,Q=>Q.filter(p=>!R(p.target)).map(p=>new i.$UO(p)));s.Event.chain($,Q=>Q.filter(p=>p.keyCode===2&&!p.ctrlKey&&!p.metaKey&&!p.shiftKey&&!p.altKey))(this.g,this,this.c)}g(S){if(S.target!==this.f.domNode)return;const q=this.d.getFocus();if(q.length===0)return;const $=this.f.domElement(q[0]);if(!$)return;const U=$.querySelector("[tabIndex]");if(!U||!(U instanceof HTMLElement)||U.tabIndex===-1)return;const Q=(0,v.$DP)(U).getComputedStyle(U);Q.visibility==="hidden"||Q.display==="none"||(S.preventDefault(),S.stopPropagation(),U.focus())}dispose(){this.c.dispose()}}function K(Y){return a.$j?Y.browserEvent.metaKey:Y.browserEvent.ctrlKey}t.$hR=K;function te(Y){return Y.browserEvent.shiftKey}t.$iR=te;function se(Y){return(0,v.$MP)(Y)&&Y.button===2}const fe={isSelectionSingleChangeEvent:K,isSelectionRangeChangeEvent:te};class le{constructor(S){this.k=S,this.f=new e.$Qc,this.g=new s.$Od,this.onPointer=this.g.event,S.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||fe),this.d=typeof S.options.mouseSupport>"u"||!!S.options.mouseSupport,this.d&&(S.onMouseDown(this.s,this,this.f),S.onContextMenu(this.t,this,this.f),S.onMouseDblClick(this.v,this,this.f),S.onTouchStart(this.s,this,this.f),this.f.add(H.$uQ.addTarget(S.getHTMLElement()))),s.Event.any(S.onMouseClick,S.onMouseMiddleClick,S.onTap)(this.u,this,this.f)}updateOptions(S){S.multipleSelectionSupport!==void 0&&(this.c=void 0,S.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||fe))}o(S){return this.c?this.c.isSelectionSingleChangeEvent(S):!1}p(S){return this.c?this.c.isSelectionRangeChangeEvent(S):!1}q(S){return this.o(S)||this.p(S)}s(S){d(S.browserEvent.target)||(0,v.$xP)()!==S.browserEvent.target&&this.k.domFocus()}t(S){if(R(S.browserEvent.target)||d(S.browserEvent.target))return;const q=typeof S.index>"u"?[]:[S.index];this.k.setFocus(q,S.browserEvent)}u(S){if(!this.d||R(S.browserEvent.target)||d(S.browserEvent.target)||S.browserEvent.isHandledByList)return;S.browserEvent.isHandledByList=!0;const q=S.index;if(typeof q>"u"){this.k.setFocus([],S.browserEvent),this.k.setSelection([],S.browserEvent),this.k.setAnchor(void 0);return}if(this.q(S))return this.w(S);this.k.setFocus([q],S.browserEvent),this.k.setAnchor(q),se(S.browserEvent)||this.k.setSelection([q],S.browserEvent),this.g.fire(S)}v(S){if(R(S.browserEvent.target)||d(S.browserEvent.target)||this.q(S)||S.browserEvent.isHandledByList)return;S.browserEvent.isHandledByList=!0;const q=this.k.getFocus();this.k.setSelection(q,S.browserEvent)}w(S){const q=S.index;let $=this.k.getAnchor();if(this.p(S)){typeof $>"u"&&($=this.k.getFocus()[0]??q,this.k.setAnchor($));const U=Math.min($,q),Q=Math.max($,q),p=(0,f.$Rb)(U,Q+1),E=this.k.getSelection(),y=Ce(Ae(E,[$]),$);if(y.length===0)return;const M=Ae(p,Pe(E,y));this.k.setSelection(M,S.browserEvent),this.k.setFocus([q],S.browserEvent)}else if(this.o(S)){const U=this.k.getSelection(),Q=U.filter(p=>p!==q);this.k.setFocus([q]),this.k.setAnchor(q),U.length===Q.length?this.k.setSelection([...Q,q],S.browserEvent):this.k.setSelection(Q,S.browserEvent)}}dispose(){this.f.dispose()}}t.$jR=le;class oe{constructor(S,q){this.c=S,this.d=q}style(S){const q=this.d&&`.${this.d}`,$=[];S.listBackground&&$.push(`.monaco-list${q} .monaco-list-rows { background: ${S.listBackground}; }`),S.listFocusBackground&&($.push(`.monaco-list${q}:focus .monaco-list-row.focused { background-color: ${S.listFocusBackground}; }`),$.push(`.monaco-list${q}:focus .monaco-list-row.focused:hover { background-color: ${S.listFocusBackground}; }`)),S.listFocusForeground&&$.push(`.monaco-list${q}:focus .monaco-list-row.focused { color: ${S.listFocusForeground}; }`),S.listActiveSelectionBackground&&($.push(`.monaco-list${q}:focus .monaco-list-row.selected { background-color: ${S.listActiveSelectionBackground}; }`),$.push(`.monaco-list${q}:focus .monaco-list-row.selected:hover { background-color: ${S.listActiveSelectionBackground}; }`)),S.listActiveSelectionForeground&&$.push(`.monaco-list${q}:focus .monaco-list-row.selected { color: ${S.listActiveSelectionForeground}; }`),S.listActiveSelectionIconForeground&&$.push(`.monaco-list${q}:focus .monaco-list-row.selected .codicon { color: ${S.listActiveSelectionIconForeground}; }`),S.listFocusAndSelectionBackground&&$.push(`
				.monaco-drag-image,
				.monaco-list${q}:focus .monaco-list-row.selected.focused { background-color: ${S.listFocusAndSelectionBackground}; }
			`),S.listFocusAndSelectionForeground&&$.push(`
				.monaco-drag-image,
				.monaco-list${q}:focus .monaco-list-row.selected.focused { color: ${S.listFocusAndSelectionForeground}; }
			`),S.listInactiveFocusForeground&&($.push(`.monaco-list${q} .monaco-list-row.focused { color:  ${S.listInactiveFocusForeground}; }`),$.push(`.monaco-list${q} .monaco-list-row.focused:hover { color:  ${S.listInactiveFocusForeground}; }`)),S.listInactiveSelectionIconForeground&&$.push(`.monaco-list${q} .monaco-list-row.focused .codicon { color:  ${S.listInactiveSelectionIconForeground}; }`),S.listInactiveFocusBackground&&($.push(`.monaco-list${q} .monaco-list-row.focused { background-color:  ${S.listInactiveFocusBackground}; }`),$.push(`.monaco-list${q} .monaco-list-row.focused:hover { background-color:  ${S.listInactiveFocusBackground}; }`)),S.listInactiveSelectionBackground&&($.push(`.monaco-list${q} .monaco-list-row.selected { background-color:  ${S.listInactiveSelectionBackground}; }`),$.push(`.monaco-list${q} .monaco-list-row.selected:hover { background-color:  ${S.listInactiveSelectionBackground}; }`)),S.listInactiveSelectionForeground&&$.push(`.monaco-list${q} .monaco-list-row.selected { color: ${S.listInactiveSelectionForeground}; }`),S.listHoverBackground&&$.push(`.monaco-list${q}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${S.listHoverBackground}; }`),S.listHoverForeground&&$.push(`.monaco-list${q}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${S.listHoverForeground}; }`);const U=(0,v.$dQ)(S.listFocusAndSelectionOutline,(0,v.$dQ)(S.listSelectionOutline,S.listFocusOutline??""));U&&$.push(`.monaco-list${q}:focus .monaco-list-row.focused.selected { outline: 1px solid ${U}; outline-offset: -1px;}`),S.listFocusOutline&&$.push(`
				.monaco-drag-image,
				.monaco-list${q}:focus .monaco-list-row.focused { outline: 1px solid ${S.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${q}.last-focused .monaco-list-row.focused { outline: 1px solid ${S.listFocusOutline}; outline-offset: -1px; }
			`);const Q=(0,v.$dQ)(S.listSelectionOutline,S.listInactiveFocusOutline??"");Q&&$.push(`.monaco-list${q} .monaco-list-row.focused.selected { outline: 1px dotted ${Q}; outline-offset: -1px; }`),S.listSelectionOutline&&$.push(`.monaco-list${q} .monaco-list-row.selected { outline: 1px dotted ${S.listSelectionOutline}; outline-offset: -1px; }`),S.listInactiveFocusOutline&&$.push(`.monaco-list${q} .monaco-list-row.focused { outline: 1px dotted ${S.listInactiveFocusOutline}; outline-offset: -1px; }`),S.listHoverOutline&&$.push(`.monaco-list${q} .monaco-list-row:hover { outline: 1px dashed ${S.listHoverOutline}; outline-offset: -1px; }`),S.listDropBackground&&$.push(`
				.monaco-list${q}.drop-target,
				.monaco-list${q} .monaco-list-rows.drop-target,
				.monaco-list${q} .monaco-list-row.drop-target { background-color: ${S.listDropBackground} !important; color: inherit !important; }
			`),S.tableColumnsBorder&&$.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${S.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),S.tableOddRowsBackgroundColor&&$.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${S.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=$.join(`
`)}}t.$kR=oe,t.$lR={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:c.$1s.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:c.$1s.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:c.$1s.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const be={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Ce(Y,S){const q=Y.indexOf(S);if(q===-1)return[];const $=[];let U=q-1;for(;U>=0&&Y[U]===S-(q-U);)$.push(Y[U--]);for($.reverse(),U=q;U<Y.length&&Y[U]===S+(U-q);)$.push(Y[U++]);return $}function Ae(Y,S){const q=[];let $=0,U=0;for(;$<Y.length||U<S.length;)if($>=Y.length)q.push(S[U++]);else if(U>=S.length)q.push(Y[$++]);else if(Y[$]===S[U]){q.push(Y[$]),$++,U++;continue}else Y[$]<S[U]?q.push(Y[$++]):q.push(S[U++]);return q}function Pe(Y,S){const q=[];let $=0,U=0;for(;$<Y.length||U<S.length;)if($>=Y.length)q.push(S[U++]);else if(U>=S.length)q.push(Y[$++]);else if(Y[$]===S[U]){$++,U++;continue}else Y[$]<S[U]?q.push(Y[$++]):U++;return q}const de=(Y,S)=>Y-S;class ie{constructor(S,q){this.c=S,this.d=q}get templateId(){return this.c}renderTemplate(S){return this.d.map(q=>q.renderTemplate(S))}renderElement(S,q,$,U){let Q=0;for(const p of this.d)p.renderElement(S,q,$[Q++],U)}disposeElement(S,q,$,U){let Q=0;for(const p of this.d)p.disposeElement?.(S,q,$[Q],U),Q+=1}disposeTemplate(S){let q=0;for(const $ of this.d)$.disposeTemplate(S[q++])}}class ce{constructor(S){this.c=S,this.templateId="a18n"}renderTemplate(S){return S}renderElement(S,q,$){const U=this.c.getAriaLabel(S);U?$.setAttribute("aria-label",U):$.removeAttribute("aria-label");const Q=this.c.getAriaLevel&&this.c.getAriaLevel(S);typeof Q=="number"?$.setAttribute("aria-level",`${Q}`):$.removeAttribute("aria-level")}disposeTemplate(S){}}class Z{constructor(S,q){this.c=S,this.d=q}getDragElements(S){const q=this.c.getSelectedElements();return q.indexOf(S)>-1?q:[S]}getDragURI(S){return this.d.getDragURI(S)}getDragLabel(S,q){if(this.d.getDragLabel)return this.d.getDragLabel(S,q)}onDragStart(S,q){this.d.onDragStart?.(S,q)}onDragOver(S,q,$,U){return this.d.onDragOver(S,q,$,U)}onDragLeave(S,q,$,U){this.d.onDragLeave?.(S,q,$,U)}onDragEnd(S){this.d.onDragEnd?.(S)}drop(S,q,$,U){this.d.drop(S,q,$,U)}dispose(){this.d.dispose()}}class W{get onDidChangeFocus(){return s.Event.map(this.g.wrapEvent(this.c.onChange),S=>this.G(S),this.y)}get onDidChangeSelection(){return s.Event.map(this.g.wrapEvent(this.d.onChange),S=>this.G(S),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let S=!1;const q=s.Event.chain(this.y.add(new T.$YQ(this.k.domNode,"keydown")).event,Q=>Q.map(p=>new i.$UO(p)).filter(p=>S=p.keyCode===58||p.shiftKey&&p.keyCode===68).map(p=>v.$SP.stop(p,!0)).filter(()=>!1)),$=s.Event.chain(this.y.add(new T.$YQ(this.k.domNode,"keyup")).event,Q=>Q.forEach(()=>S=!1).map(p=>new i.$UO(p)).filter(p=>p.keyCode===58||p.shiftKey&&p.keyCode===68).map(p=>v.$SP.stop(p,!0)).map(({browserEvent:p})=>{const E=this.getFocus(),y=E.length?E[0]:void 0,M=typeof y<"u"?this.k.element(y):void 0,k=typeof y<"u"?this.k.domElement(y):this.k.domNode;return{index:y,element:M,anchor:k,browserEvent:p}})),U=s.Event.chain(this.k.onContextMenu,Q=>Q.filter(p=>!S).map(({element:p,index:E,browserEvent:y})=>({element:p,index:E,anchor:new b.$PO(y),browserEvent:y})));return s.Event.any(q,$,U)}get onKeyDown(){return this.y.add(new T.$YQ(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new T.$YQ(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new T.$YQ(this.k.domNode,"keypress")).event}get onDidFocus(){return s.Event.signal(this.y.add(new T.$YQ(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return s.Event.signal(this.y.add(new T.$YQ(this.k.domNode,"blur",!0)).event)}constructor(S,q,$,U,Q=be){this.A=S,this.B=Q,this.c=new l("focused"),this.f=new l("anchor"),this.g=new s.$Wd,this.x="",this.y=new e.$Qc,this.z=new s.$Od,this.onDidDispose=this.z.event;const p=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new N(p!=="listbox");const E=[this.c.renderer,this.d.renderer];this.u=Q.accessibilityProvider,this.u&&(E.push(new ce(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),U=U.map(M=>new ie(M.templateId,[...E,M]));const y={...Q,dnd:Q.dnd&&new Z(this,Q.dnd)};if(this.k=this.C(q,$,U,y),this.k.domNode.setAttribute("role",p),Q.styleController)this.q=Q.styleController(this.k.domId);else{const M=(0,v.$GP)(this.k.domNode);this.q=new oe(M,this.k.domId)}if(this.o=new A.$3Q([new z(this.c,this.k,Q.identityProvider),new z(this.d,this.k,Q.identityProvider),new z(this.f,this.k,Q.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new O(this,this.k)),(typeof Q.keyboardSupport!="boolean"||Q.keyboardSupport)&&(this.v=new B(this,this.k,Q),this.y.add(this.v)),Q.keyboardNavigationLabelProvider){const M=Q.keyboardNavigationDelegate||t.$gR;this.t=new P(this,this.k,Q.keyboardNavigationLabelProvider,Q.keyboardNavigationEventFilter??(()=>!0),M),this.y.add(this.t)}this.w=this.D(Q),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(S,q,$,U){return new r.$cR(S,q,$,U)}D(S){return new le(this)}updateOptions(S={}){this.B={...this.B,...S},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(S),this.v?.updateOptions(S),this.k.updateOptions(S)}get options(){return this.B}splice(S,q,$=[]){if(S<0||S>this.k.length)throw new n.$5Q(this.A,`Invalid start index: ${S}`);if(q<0)throw new n.$5Q(this.A,`Invalid delete count: ${q}`);q===0&&$.length===0||this.g.bufferEvents(()=>this.o.splice(S,q,$))}updateWidth(S){this.k.updateWidth(S)}updateElementHeight(S,q){this.k.updateElementHeight(S,q,null)}rerender(){this.k.rerender()}element(S){return this.k.element(S)}indexOf(S){return this.k.indexOf(S)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(S){this.k.setScrollTop(S)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(S){this.k.setScrollLeft(S)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(S){this.x=S,this.k.domNode.setAttribute("aria-label",S)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(S,q){this.k.layout(S,q)}triggerTypeNavigation(){this.t?.trigger()}setSelection(S,q){for(const $ of S)if($<0||$>=this.length)throw new n.$5Q(this.A,`Invalid index ${$}`);this.d.set(S,q)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(S=>this.k.element(S))}setAnchor(S){if(typeof S>"u"){this.f.set([]);return}if(S<0||S>=this.length)throw new n.$5Q(this.A,`Invalid index ${S}`);this.f.set([S])}getAnchor(){return(0,f.$Nb)(this.f.get(),void 0)}getAnchorElement(){const S=this.getAnchor();return typeof S>"u"?void 0:this.element(S)}setFocus(S,q){for(const $ of S)if($<0||$>=this.length)throw new n.$5Q(this.A,`Invalid index ${$}`);this.c.set(S,q)}focusNext(S=1,q=!1,$,U){if(this.length===0)return;const Q=this.c.get(),p=this.E(Q.length>0?Q[0]+S:0,q,U);p>-1&&this.setFocus([p],$)}focusPrevious(S=1,q=!1,$,U){if(this.length===0)return;const Q=this.c.get(),p=this.F(Q.length>0?Q[0]-S:0,q,U);p>-1&&this.setFocus([p],$)}async focusNextPage(S,q){let $=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);$=$===0?0:$-1;const U=this.getFocus()[0];if(U!==$&&(U===void 0||$>U)){const Q=this.F($,!1,q);Q>-1&&U!==Q?this.setFocus([Q],S):this.setFocus([$],S)}else{const Q=this.k.getScrollTop();let p=Q+this.k.renderHeight;$>U&&(p-=this.k.elementHeight($)),this.k.setScrollTop(p),this.k.getScrollTop()!==Q&&(this.setFocus([]),await(0,g.$Vg)(0),await this.focusNextPage(S,q))}}async focusPreviousPage(S,q){let $;const U=this.k.getScrollTop();U===0?$=this.k.indexAt(U):$=this.k.indexAfter(U-1);const Q=this.getFocus()[0];if(Q!==$&&(Q===void 0||Q>=$)){const p=this.E($,!1,q);p>-1&&Q!==p?this.setFocus([p],S):this.setFocus([$],S)}else{const p=U;this.k.setScrollTop(U-this.k.renderHeight),this.k.getScrollTop()!==p&&(this.setFocus([]),await(0,g.$Vg)(0),await this.focusPreviousPage(S,q))}}focusLast(S,q){if(this.length===0)return;const $=this.F(this.length-1,!1,q);$>-1&&this.setFocus([$],S)}focusFirst(S,q){this.focusNth(0,S,q)}focusNth(S,q,$){if(this.length===0)return;const U=this.E(S,!1,$);U>-1&&this.setFocus([U],q)}E(S,q=!1,$){for(let U=0;U<this.length;U++){if(S>=this.length&&!q)return-1;if(S=S%this.length,!$||$(this.element(S)))return S;S++}return-1}F(S,q=!1,$){for(let U=0;U<this.length;U++){if(S<0&&!q)return-1;if(S=(this.length+S%this.length)%this.length,!$||$(this.element(S)))return S;S--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(S=>this.k.element(S))}reveal(S,q){if(S<0||S>=this.length)throw new n.$5Q(this.A,`Invalid index ${S}`);const $=this.k.getScrollTop(),U=this.k.elementTop(S),Q=this.k.elementHeight(S);if((0,m.$Df)(q)){const p=Q-this.k.renderHeight;this.k.setScrollTop(p*(0,o.$Rl)(q,0,1)+U)}else{const p=U+Q,E=$+this.k.renderHeight;U<$&&p>=E||(U<$||p>=E&&Q>=this.k.renderHeight?this.k.setScrollTop(U):p>=E&&this.k.setScrollTop(p-this.k.renderHeight))}}getRelativeTop(S){if(S<0||S>=this.length)throw new n.$5Q(this.A,`Invalid index ${S}`);const q=this.k.getScrollTop(),$=this.k.elementTop(S),U=this.k.elementHeight(S);if($<q||$+U>q+this.k.renderHeight)return null;const Q=U-this.k.renderHeight;return Math.abs((q-$)/Q)}isDOMFocused(){return(0,v.$yP)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getElementID(S){return this.k.getElementDomId(S)}style(S){this.q.style(S)}G({indexes:S,browserEvent:q}){return{indexes:S,elements:S.map($=>this.k.element($)),browserEvent:q}}H(){const S=this.c.get();this.k.domNode.classList.toggle("element-focused",S.length>0),this.I()}I(){const S=this.c.get();if(S.length>0){let q;this.u?.getActiveDescendantId&&(q=this.u.getActiveDescendantId(this.k.element(S[0]))),this.k.domNode.setAttribute("aria-activedescendant",q||this.k.getElementDomId(S[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const S=this.d.get();this.k.domNode.classList.toggle("selection-none",S.length===0),this.k.domNode.classList.toggle("selection-single",S.length===1),this.k.domNode.classList.toggle("selection-multiple",S.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$mR=W,Ge([L.$kh],W.prototype,"onDidChangeFocus",null),Ge([L.$kh],W.prototype,"onDidChangeSelection",null),Ge([L.$kh],W.prototype,"onContextMenu",null),Ge([L.$kh],W.prototype,"onKeyDown",null),Ge([L.$kh],W.prototype,"onKeyUp",null),Ge([L.$kh],W.prototype,"onKeyPress",null),Ge([L.$kh],W.prototype,"onDidFocus",null),Ge([L.$kh],W.prototype,"onDidBlur",null)}),define($e[62],we([1,0,6,35,37,12,16]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ak=t.$_j=t.$$j=t.$0j=t.$9j=t.$8j=t.$7j=t.$6j=t.MarkdownStringTextNewlineStyle=void 0;var A;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(A||(t.MarkdownStringTextNewlineStyle=A={}));class f{constructor(m="",n=!1){if(this.value=m,typeof this.value!="string")throw(0,v.$6)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(m,n=0){return this.value+=s(this.supportThemeIcons?(0,T.$Zj)(m):m).replace(/([ \t]+)/g,(r,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,n){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(m,n,r){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(m),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(m,n){const r=new RegExp((0,H.$Ge)(n),"g");return m.replace(r,(b,u)=>m.charAt(u-1)!=="\\"?`\\${b}`:b)}}t.$6j=f;function g(a){return c(a)?!a.value:Array.isArray(a)?a.every(g):!0}t.$7j=g;function c(a){return a instanceof f?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}t.$8j=c;function L(a,m){return a===m?!0:!a||!m?!1:a.value===m.value&&a.isTrusted===m.isTrusted&&a.supportThemeIcons===m.supportThemeIcons&&a.supportHtml===m.supportHtml&&(a.baseUri===m.baseUri||!!a.baseUri&&!!m.baseUri&&(0,i.$pg)(w.URI.from(a.baseUri),w.URI.from(m.baseUri)))}t.$9j=L;function s(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$0j=s;function h(a){return a.replace(/"/g,"&quot;")}t.$$j=h;function e(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$_j=e;function o(a){const m=[],n=a.split("|").map(b=>b.trim());a=n[0];const r=n[1];if(r){const b=/height=(\d+)/.exec(r),u=/width=(\d+)/.exec(r),l=b?b[1]:"",N=u?u[1]:"",z=isFinite(parseInt(N)),R=isFinite(parseInt(l));z&&m.push(`width="${N}"`),R&&m.push(`height="${l}"`)}return{href:a,dimensions:m}}t.$ak=o}),define($e[125],we([1,0,3,117,22,55,15,20,118,6,4,62,35,77,28,2,79,53,31,51,37,12,16]),function(ae,t,v,T,i,H,w,A,f,g,c,L,s,h,e,o,a,m,n,r,b,u,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tR=t.$sR=t.$rR=t.$qR=t.$pR=void 0;const N=Object.freeze({image:(Z,W,Y)=>{let S=[],q=[];return Z&&({href:Z,dimensions:S}=(0,L.$ak)(Z),q.push(`src="${(0,L.$$j)(Z)}"`)),Y&&q.push(`alt="${(0,L.$$j)(Y)}"`),W&&q.push(`title="${(0,L.$$j)(W)}"`),S.length&&(q=q.concat(S)),"<img "+q.join(" ")+">"},paragraph:Z=>`<p>${Z}</p>`,link:(Z,W,Y)=>typeof Z!="string"?"":(Z===Y&&(Y=(0,L.$_j)(Y)),W=typeof W=="string"?(0,L.$$j)((0,L.$_j)(W)):"",Z=(0,L.$_j)(Z),Z=Z.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Z}" title="${W||Z}">${Y}</a>`)});function z(Z,W={},Y={}){const S=new o.$Qc;let q=!1;const $=(0,H.$XQ)(W),U=function(F){let j;try{j=(0,m.$oh)(decodeURIComponent(F))}catch{}return j?(j=(0,r.$_m)(j,X=>{if(Z.uris&&Z.uris[X])return l.URI.revive(Z.uris[X])}),encodeURIComponent(JSON.stringify(j))):F},Q=function(F,j){const X=Z.uris&&Z.uris[F];let ee=l.URI.revive(X);return j?F.startsWith(n.Schemas.data+":")?F:(ee||(ee=l.URI.parse(F)),n.$dg.uriToBrowserUri(ee).toString(!0)):!ee||l.URI.parse(F).toString()===ee.toString()?F:(ee.query&&(ee=ee.with({query:U(ee.query)})),ee.toString())},p=new a.marked.Renderer;p.image=N.image,p.link=N.link,p.paragraph=N.paragraph;const E=[],y=[];if(W.codeBlockRendererSync?p.code=(F,j)=>{const X=h.$CM.nextId(),ee=W.codeBlockRendererSync(R(j),F);return y.push([X,ee]),`<div class="code" data-code="${X}">${(0,u.$Fe)(F)}</div>`}:W.codeBlockRenderer&&(p.code=(F,j)=>{const X=h.$CM.nextId(),ee=W.codeBlockRenderer(R(j),F);return E.push(ee.then(ne=>[X,ne])),`<div class="code" data-code="${X}">${(0,u.$Fe)(F)}</div>`}),W.actionHandler){const F=function(ee){let ne=ee.target;if(!(ne.tagName!=="A"&&(ne=ne.parentElement,!ne||ne.tagName!=="A")))try{let me=ne.dataset.href;me&&(Z.baseUri&&(me=d(l.URI.from(Z.baseUri),me)),W.actionHandler.callback(me,ee))}catch(me){(0,g.$Z)(me)}finally{ee.preventDefault()}},j=W.actionHandler.disposables.add(new i.$YQ($,"click")),X=W.actionHandler.disposables.add(new i.$YQ($,"auxclick"));W.actionHandler.disposables.add(c.Event.any(j.event,X.event)(ee=>{const ne=new A.$PO(ee);!ne.leftButton&&!ne.middleButton||F(ne)})),W.actionHandler.disposables.add(v.$XO($,"keydown",ee=>{const ne=new w.$UO(ee);!ne.equals(10)&&!ne.equals(3)||F(ne)}))}Z.supportHtml||(Y.sanitizer=F=>(Z.isTrusted?F.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?F:"",Y.sanitize=!0,Y.silent=!0),Y.renderer=p;let M=Z.value??"";M.length>1e5&&(M=`${M.substr(0,1e5)}\u2026`),Z.supportThemeIcons&&(M=(0,s.$1j)(M));let k;if(W.fillInIncompleteTokens){const F={...a.marked.defaults,...Y},j=a.marked.lexer(M,F),X=se(j);k=a.marked.parser(X,F)}else k=a.marked.parse(M,Y);Z.supportThemeIcons&&(k=(0,f.$nR)(k).map(j=>typeof j=="string"?j:j.outerHTML).join(""));const C=new DOMParser().parseFromString(D(Z,k),"text/html");if(C.body.querySelectorAll("img").forEach(F=>{const j=F.getAttribute("src");if(j){let X=j;try{Z.baseUri&&(X=d(l.URI.from(Z.baseUri),X))}catch{}F.src=Q(X,!0)}}),C.body.querySelectorAll("a").forEach(F=>{const j=F.getAttribute("href");if(F.setAttribute("href",""),!j||/^data:|javascript:/i.test(j)||/^command:/i.test(j)&&!Z.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(j))F.replaceWith(...F.childNodes);else{let X=Q(j,!1);Z.baseUri&&(X=d(l.URI.from(Z.baseUri),j)),F.dataset.href=X}}),$.innerHTML=D(Z,C.body.innerHTML),E.length>0)Promise.all(E).then(F=>{if(q)return;const j=new Map(F),X=$.querySelectorAll("div[data-code]");for(const ee of X){const ne=j.get(ee.dataset.code??"");ne&&v.$ZP(ee,ne)}W.asyncRenderCallback?.()});else if(y.length>0){const F=new Map(y),j=$.querySelectorAll("div[data-code]");for(const X of j){const ee=F.get(X.dataset.code??"");ee&&v.$ZP(X,ee)}}if(W.asyncRenderCallback)for(const F of $.getElementsByTagName("img")){const j=S.add(v.$XO(F,"load",()=>{j.dispose(),W.asyncRenderCallback()}))}return{element:$,dispose:()=>{q=!0,S.dispose()}}}t.$pR=z;function R(Z){if(!Z)return"";const W=Z.split(/[\s+|:|,|\{|\?]/,1);return W.length?W[0]:Z}function d(Z,W){return/^\w[\w\d+.-]*:/.test(W)?W:Z.path.endsWith("/")?(0,b.$zg)(Z,W).toString():(0,b.$zg)((0,b.$vg)(Z),W).toString()}function D(Z,W){const{config:Y,allowedSchemes:S}=B(Z);T.addHook("uponSanitizeAttribute",($,U)=>{if(U.attrName==="style"||U.attrName==="class"){if($.tagName==="SPAN"){if(U.attrName==="style"){U.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(U.attrValue);return}else if(U.attrName==="class"){U.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(U.attrValue);return}}U.keepAttr=!1;return}});const q=v.$hQ(S);try{return T.sanitize(W,{...Y,RETURN_TRUSTED_TYPE:!0})}finally{T.removeHook("uponSanitizeAttribute"),q.dispose()}}t.$qR=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function B(Z){const W=[n.Schemas.http,n.Schemas.https,n.Schemas.mailto,n.Schemas.data,n.Schemas.file,n.Schemas.vscodeFileResource,n.Schemas.vscodeRemote,n.Schemas.vscodeRemoteResource];return Z.isTrusted&&W.push(n.Schemas.command),{config:{ALLOWED_TAGS:[...v.$iQ],ALLOWED_ATTR:t.$qR,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:W}}function _(Z){return typeof Z=="string"?Z:x(Z)}t.$rR=_;function x(Z){let W=Z.value??"";W.length>1e5&&(W=`${W.substr(0,1e5)}\u2026`);const Y=a.marked.parse(W,{renderer:O.value}).replace(/&(#\d+|[a-zA-Z]+);/g,S=>P.get(S)??S);return D({isTrusted:!1},Y).toString()}t.$sR=x;const P=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),O=new e.$U(()=>{const Z=new a.marked.Renderer;return Z.code=W=>W,Z.blockquote=W=>W,Z.html=W=>"",Z.heading=(W,Y,S)=>W+`
`,Z.hr=()=>"",Z.list=(W,Y)=>W,Z.listitem=W=>W+`
`,Z.paragraph=W=>W+`
`,Z.table=(W,Y)=>W+Y+`
`,Z.tablerow=W=>W,Z.tablecell=(W,Y)=>W+" ",Z.strong=W=>W,Z.em=W=>W,Z.codespan=W=>W,Z.br=()=>`
`,Z.del=W=>W,Z.image=(W,Y,S)=>"",Z.text=W=>W,Z.link=(W,Y,S)=>S,Z});function K(Z){let W="";return Z.forEach(Y=>{W+=Y.raw}),W}function te(Z){for(const W of Z.tokens)if(W.type==="text"){const Y=W.raw.split(`
`),S=Y[Y.length-1];if(S.includes("`"))return le(Z);if(S.includes("**"))return Pe(Z);if(S.match(/\*\w/))return oe(Z);if(S.match(/(^|\s)__\w/))return de(Z);if(S.match(/(^|\s)_\w/))return be(Z);if(S.match(/(^|\s)\[.*\]\(\w*/))return Ce(Z);if(S.match(/(^|\s)\[\w/))return Ae(Z)}}function se(Z){let W,Y;for(W=0;W<Z.length;W++){const S=Z[W];if(S.type==="paragraph"&&S.raw.match(/(\n|^)```/)){Y=fe(Z.slice(W));break}if(S.type==="paragraph"&&S.raw.match(/(\n|^)\|/)){Y=ce(Z.slice(W));break}if(W===Z.length-1&&S.type==="paragraph"){const q=te(S);if(q){Y=[q];break}}}if(Y){const S=[...Z.slice(0,W),...Y];return S.links=Z.links,S}return Z}t.$tR=se;function fe(Z){const W=K(Z);return a.marked.lexer(W+"\n```")}function le(Z){return ie(Z,"`")}function oe(Z){return ie(Z,"*")}function be(Z){return ie(Z,"_")}function Ce(Z){return ie(Z,")")}function Ae(Z){return ie(Z,"](about:blank)")}function Pe(Z){return ie(Z,"**")}function de(Z){return ie(Z,"__")}function ie(Z,W){const Y=K(Array.isArray(Z)?Z:[Z]);return a.marked.lexer(Y+W)[0]}function ce(Z){const W=K(Z),Y=W.split(`
`);let S,q=!1;for(let $=0;$<Y.length;$++){const U=Y[$].trim();if(typeof S>"u"&&U.match(/^\s*\|/)){const Q=U.match(/(\|[^\|]+)(?=\||$)/g);Q&&(S=Q.length)}else if(typeof S=="number")if(U.match(/^\s*\|/)){if($!==Y.length-1)return;q=!0}else return}if(typeof S=="number"&&S>0){const $=q?Y.slice(0,-1).join(`
`):W,U=!!$.match(/\|\s*$/),Q=$+(U?"":"|")+`
|${" --- |".repeat(S)}`;return a.marked.lexer(Q)}}}),define($e[126],we([1,0,3,9,29,62,35,2,7,107]),function(ae,t,v,T,i,H,w,A,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PQ=t.$OQ=void 0;function c(h,e){(0,f.$zf)(e)?h.title=(0,w.$2j)(e):e?.markdownNotSupportedFallback?h.title=e.markdownNotSupportedFallback:h.removeAttribute("title")}t.$OQ=c;class L{constructor(e,o,a){this.c=e,this.d=o,this.f=a}async update(e,o,a){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let m;if(e===void 0||(0,f.$zf)(e)||e instanceof HTMLElement)m=e;else if(!(0,f.$Nf)(e.markdown))m=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,g.localize)(0,null),o),this.b=new i.$Yd;const n=this.b.token;if(m=await e.markdown(n),m===void 0&&(m=e.markdownNotSupportedFallback),this.isDisposed||n.isCancellationRequested)return}this.g(m,o,a)}g(e,o,a){const m=this.a;if(this.h(e)){const n={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!m,...a};this.a=this.c.showHover(n,o)}m?.dispose()}h(e){return e?(0,H.$8j)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function s(h,e,o,a){let m,n;const r=(z,R)=>{const d=n!==void 0;z&&(n?.dispose(),n=void 0),R&&(m?.dispose(),m=void 0),d&&h.onDidHideHover?.()},b=(z,R,d)=>new T.$5g(async()=>{(!n||n.isDisposed)&&(n=new L(h,d||e,z>0),await n.update(o,R,a))},z),u=()=>{if(m)return;const z=new A.$Qc,R=B=>r(!1,B.fromElement===e);z.add(v.$XO(e,v.$QP.MOUSE_LEAVE,R,!0));const d=()=>r(!0,!0);z.add(v.$XO(e,v.$QP.MOUSE_DOWN,d,!0));const D={targetElements:[e],dispose:()=>{}};if(h.placement===void 0||h.placement==="mouse"){const B=_=>{D.x=_.x+10,_.target instanceof HTMLElement&&_.target.classList.contains("action-label")&&r(!0,!0)};z.add(v.$XO(e,v.$QP.MOUSE_MOVE,B,!0))}z.add(b(h.delay,!1,D)),m=z},l=v.$XO(e,v.$QP.MOUSE_OVER,u,!0);return{show:z=>{r(!1,!0),b(0,z)},hide:()=>{r(!0,!0)},update:async(z,R)=>{o=z,await n?.update(o,void 0,R)},dispose:()=>{l.dispose(),r(!0,!0)}}}t.$PQ=s}),define($e[127],we([1,0,3,22,15,125,39,11,4,44,2,5,109,100]),function(ae,t,v,T,i,H,w,A,f,g,c,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uR=void 0;const h=v.$,e="selectOption.entry.template";class o{get templateId(){return e}renderTemplate(n){const r=Object.create(null);return r.root=n,r.text=v.$XP(n,h(".option-text")),r.detail=v.$XP(n,h(".option-detail")),r.decoratorRight=v.$XP(n,h(".option-decorator-right")),r}renderElement(n,r,b){const u=b,l=n.text,N=n.detail,z=n.decoratorRight,R=n.isDisabled;u.text.textContent=l,u.detail.textContent=N||"",u.decoratorRight.innerText=z||"",R?u.root.classList.add("option-disabled"):u.root.classList.remove("option-disabled")}disposeTemplate(n){}}class a extends c.$Rc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(n,r,b,u,l){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=u,this.g=l||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=a.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new f.$Od,this.B(this.r),this.O(),this.N(b),this.n=r||0,n&&this.setOptions(n,r),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(n){this.u=n,this.w=v.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=v.$XP(this.w,h(".select-box-details-pane"));const r=v.$XP(this.w,h(".select-box-dropdown-container-width-control")),b=v.$XP(r,h(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",v.$XP(b,this.D),this.G=0,this.y=v.$GP(this.w),this.w.setAttribute("draggable","true"),this.B(v.$XO(this.w,v.$QP.DRAG_START,u=>{v.$SP.stop(u,!0)}))}O(){this.B(v.$YO(this.h,"change",r=>{this.n=r.target.selectedIndex,this.r.fire({index:r.target.selectedIndex,selected:r.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(v.$XO(this.h,v.$QP.CLICK,r=>{v.$SP.stop(r),this.f?this.X(!0):this.W()})),this.B(v.$XO(this.h,v.$QP.MOUSE_DOWN,r=>{v.$SP.stop(r)}));let n;this.B(v.$XO(this.h,"touchstart",r=>{n=this.f})),this.B(v.$XO(this.h,"touchend",r=>{v.$SP.stop(r),n?this.X(!0):this.W()})),this.B(v.$XO(this.h,v.$QP.KEY_DOWN,r=>{const b=new i.$UO(r);let u=!1;L.$j?(b.keyCode===18||b.keyCode===16||b.keyCode===10||b.keyCode===3)&&(u=!0):(b.keyCode===18&&b.altKey||b.keyCode===16&&b.altKey||b.keyCode===10||b.keyCode===3)&&(u=!0),u&&(this.W(),v.$SP.stop(r,!0))}))}get onDidSelect(){return this.r.event}setOptions(n,r){A.$tb(this.m,n)||(this.m=n,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((b,u)=>{this.h.add(this.U(b.text,u,b.isDisabled)),typeof b.description=="string"&&(this.H=!0)})),r!==void 0&&(this.select(r),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(n){n>=0&&n<this.m.length?this.n=n:n>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(n){this.g.ariaLabel=n,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(n){this.h.tabIndex=n?0:-1}render(n){this.j=n,n.classList.add("select-container"),n.appendChild(this.h),this.R()}Q(){const n=[];this.s.listFocusBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(n.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=n.join(`
`)}R(){const n=this.s.selectBackground??"",r=this.s.selectForeground??"",b=this.s.selectBorder??"";this.h.style.backgroundColor=n,this.h.style.color=r,this.h.style.borderColor=b}S(){const n=this.s.selectBackground??"",r=v.$dQ(this.s.selectListBackground,n);this.C.style.backgroundColor=r,this.I.style.backgroundColor=r;const b=this.s.focusBorder??"";this.w.style.outlineColor=b,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(n,r,b){const u=document.createElement("option");return u.value=n,u.text=n,u.disabled=!!b,u}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(n){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),n&&this.h.focus(),this.u.hideContextView())}Y(n,r){return n.appendChild(this.w),this.ab(r),{dispose:()=>{try{n.removeChild(this.w)}catch{}}}}Z(){let n=0;return this.m.forEach((r,b)=>{this.hb(b),this.I.offsetHeight>n&&(n=this.I.offsetHeight)}),n}ab(n){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const r=v.$DP(this.h),b=v.$hP(this.h),u=v.$DP(this.h).getComputedStyle(this.h),l=parseFloat(u.getPropertyValue("--dropdown-padding-top"))+parseFloat(u.getPropertyValue("--dropdown-padding-bottom")),N=r.innerHeight-b.top-b.height-(this.g.minBottomMargin||0),z=b.top-a.b,R=this.h.offsetWidth,d=this.bb(this.D),D=Math.max(d,Math.round(R)).toString()+"px";this.w.style.width=D,this.z.getHTMLElement().style.height="",this.z.layout();let B=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const _=this.H?this.L:0,x=B+l+_,P=Math.floor((N-l-_)/this.getHeight()),O=Math.floor((z-l-_)/this.getHeight());if(n)return b.top+b.height>r.innerHeight-22||b.top<a.b||P<1&&O<1?!1:(P<a.c&&O>P&&this.m.length>P?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(b.top+b.height>r.innerHeight-22||b.top<a.b||this.G===0&&P<1||this.G===1&&O<1)return this.X(!0),!1;if(this.G===0){if(this.f&&P+O<1)return this.X(!0),!1;x>N&&(B=P*this.getHeight())}else x>z&&(B=O*this.getHeight());return this.z.layout(B),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=B+l+"px",this.w.style.height=""):this.w.style.height=B+l+"px",this.hb(this.n),this.w.style.width=D,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(n){let r=0;if(n){let b=0,u=0;this.m.forEach((l,N)=>{const z=l.detail?l.detail.length:0,R=l.decoratorRight?l.decoratorRight.length:0,d=l.text.length+z+R;d>u&&(b=N,u=d)}),n.textContent=this.m[b].text+(this.m[b].decoratorRight?this.m[b].decoratorRight+" ":""),r=v.$jP(n)}return r}cb(n){if(this.z)return;this.C=v.$XP(n,h(".select-box-dropdown-list-container")),this.t=new o,this.z=new w.$mR("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:u=>{let l=u.text;return u.detail&&(l+=`. ${u.detail}`),u.decoratorRight&&(l+=`. ${u.decoratorRight}`),u.description&&(l+=`. ${u.description}`),l},getWidgetAriaLabel:()=>(0,s.localize)(0,null),getRole:()=>L.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const r=this.B(new T.$YQ(this.C,"keydown")),b=f.Event.chain(r.event,u=>u.filter(()=>this.z.length>0).map(l=>new i.$UO(l)));this.B(f.Event.chain(b,u=>u.filter(l=>l.keyCode===3))(this.jb,this)),this.B(f.Event.chain(b,u=>u.filter(l=>l.keyCode===2))(this.jb,this)),this.B(f.Event.chain(b,u=>u.filter(l=>l.keyCode===9))(this.ib,this)),this.B(f.Event.chain(b,u=>u.filter(l=>l.keyCode===16))(this.lb,this)),this.B(f.Event.chain(b,u=>u.filter(l=>l.keyCode===18))(this.kb,this)),this.B(f.Event.chain(b,u=>u.filter(l=>l.keyCode===12))(this.nb,this)),this.B(f.Event.chain(b,u=>u.filter(l=>l.keyCode===11))(this.mb,this)),this.B(f.Event.chain(b,u=>u.filter(l=>l.keyCode===14))(this.ob,this)),this.B(f.Event.chain(b,u=>u.filter(l=>l.keyCode===13))(this.pb,this)),this.B(f.Event.chain(b,u=>u.filter(l=>l.keyCode>=21&&l.keyCode<=56||l.keyCode>=85&&l.keyCode<=113))(this.qb,this)),this.B(v.$XO(this.z.getHTMLElement(),v.$QP.POINTER_UP,u=>this.db(u))),this.B(this.z.onMouseOver(u=>typeof u.index<"u"&&this.z.setFocus([u.index]))),this.B(this.z.onDidChangeFocus(u=>this.gb(u))),this.B(v.$XO(this.w,v.$QP.FOCUS_OUT,u=>{!this.f||v.$pP(u.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(n){if(!this.z.length)return;v.$SP.stop(n);const r=n.target;if(!r||r.classList.contains("slider"))return;const b=r.closest(".monaco-list-row");if(!b)return;const u=Number(b.getAttribute("data-index")),l=b.classList.contains("option-disabled");u>=0&&u<this.m.length&&!l&&(this.n=u,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(n,r){const b=l=>{for(let N=0;N<l.childNodes.length;N++){const z=l.childNodes.item(N);(z.tagName&&z.tagName.toLowerCase())==="img"?l.removeChild(z):b(z)}},u=(0,H.$pR)({value:n,supportThemeIcons:!0},{actionHandler:r});return u.element.classList.add("select-box-description-markdown"),b(u.element),u.element}gb(n){!this.f||!this.H||this.hb(n.indexes[0])}hb(n){this.I.innerText="";const r=this.m[n],b=r?.description??"",u=r?.descriptionIsMarkdown??!1;if(b){if(u){const l=r.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(b,l))}else this.I.innerText=b;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(n){v.$SP.stop(n),this.select(this.F),this.X(!0)}jb(n){v.$SP.stop(n),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(n){if(this.n<this.m.length-1){v.$SP.stop(n,!0);const r=this.m[this.n+1].isDisabled;if(r&&this.m.length>this.n+2)this.n+=2;else{if(r)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(n){this.n>0&&(v.$SP.stop(n,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(n){v.$SP.stop(n),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(n){v.$SP.stop(n),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(n){v.$SP.stop(n),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(n){v.$SP.stop(n),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(n){const r=g.KeyCodeUtils.toString(n.keyCode);let b=-1;for(let u=0;u<this.m.length-1;u++)if(b=(u+this.n+1)%this.m.length,this.m[b].text.charAt(0).toUpperCase()===r&&!this.m[b].isDisabled){this.select(b),this.z.setFocus([b]),this.z.reveal(this.z.getFocus()[0]),v.$SP.stop(n);break}}dispose(){this.X(!1),super.dispose()}}t.$uR=a}),define($e[128],we([1,0,39,127,121,21,5,99]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xR=t.$wR=void 0,t.$wR={...v.$lR,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class A extends H.$yQ{constructor(g,c,L,s,h){super(),w.$j&&!h?.useCustomDrawn?this.a=new i.$vR(g,c,s,h):this.a=new T.$uR(g,c,L,s,h),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(g,c){this.a.setOptions(g,c)}select(g){this.a.select(g)}setAriaLabel(g){this.a.setAriaLabel(g)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(g){this.a.setFocusable(g)}render(g){this.a.render(g)}}t.$xR=A}),define($e[63],we([1,0,17,54,3,24,126,128,36,2,5,7,104,52]),function(ae,t,v,T,i,H,w,A,f,g,c,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ER=t.$DR=t.$CR=void 0;class h extends g.$Rc{get action(){return this._action}constructor(m,n,r={}){super(),this.m=r,this._context=m||this,this._action=n,n instanceof f.$xi&&this.B(n.onDidChange(b=>{this.element&&this.t(b)}))}t(m){m.enabled!==void 0&&this.u(),m.checked!==void 0&&this.G(),m.class!==void 0&&this.F(),m.label!==void 0&&(this.w(),this.C()),m.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new f.$yi)),this.j}set actionRunner(m){this.j=m}isEnabled(){return this._action.enabled}setActionContext(m){this._context=m}render(m){const n=this.element=m;this.B(H.$uQ.addTarget(m));const r=this.m&&this.m.draggable;r&&(m.draggable=!0,v.$DO&&this.B((0,i.$XO)(m,i.$QP.DRAG_START,b=>b.dataTransfer?.setData(T.$sQ.TEXT,this._action.label)))),this.B((0,i.$XO)(n,H.EventType.Tap,b=>this.onClick(b,!0))),this.B((0,i.$XO)(n,i.$QP.MOUSE_DOWN,b=>{r||i.$SP.stop(b,!0),this._action.enabled&&b.button===0&&n.classList.add("active")})),c.$j&&this.B((0,i.$XO)(n,i.$QP.CONTEXT_MENU,b=>{b.button===0&&b.ctrlKey===!0&&this.onClick(b)})),this.B((0,i.$XO)(n,i.$QP.CLICK,b=>{i.$SP.stop(b,!0),this.m&&this.m.isMenu||this.onClick(b)})),this.B((0,i.$XO)(n,i.$QP.DBLCLICK,b=>{i.$SP.stop(b,!0)})),[i.$QP.MOUSE_UP,i.$QP.MOUSE_OUT].forEach(b=>{this.B((0,i.$XO)(n,b,u=>{i.$SP.stop(u),n.classList.remove("active")}))})}onClick(m,n=!1){i.$SP.stop(m,!0);const r=L.$If(this._context)?this.m?.useEventAsContext?m:{preserveFocus:n}:this._context;this.actionRunner.run(this._action,r)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(m){this.element&&(this.element.tabIndex=m?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const m=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(m):(this.f=(0,w.$PQ)(this.m.hoverDelegate,this.element,m),this.q.add(this.f))):this.element.title=m}D(){if(this.element){const m=this.z()??"";this.element.setAttribute("aria-label",m)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$CR=h;class e extends h{constructor(m,n,r){super(m,n,r),this.m=r,this.m.icon=r.icon!==void 0?r.icon:!1,this.m.label=r.label!==void 0?r.label:!0,this.J=""}render(m){super.render(m),L.$Jf(this.element);const n=document.createElement("a");if(n.classList.add("action-label"),n.setAttribute("role",this.L()),this.H=n,this.element.appendChild(n),this.m.label&&this.m.keybinding){const r=document.createElement("span");r.classList.add("keybinding"),r.textContent=this.m.keybinding,this.element.appendChild(r)}this.F(),this.w(),this.C(),this.u(),this.G()}L(){return this._action.id===f.$zi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.H&&(this.H.tabIndex=0,this.H.focus())}isFocused(){return!!this.H&&this.H?.tabIndex===0}blur(){this.H&&(this.H.tabIndex=-1)}setFocusable(m){this.H&&(this.H.tabIndex=m?0:-1)}w(){this.m.label&&this.H&&(this.H.textContent=this.action.label)}z(){let m=null;return this.action.tooltip?m=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(m=this.action.label,this.m.keybinding&&(m=s.localize(0,null,m,this.m.keybinding))),m??void 0}F(){this.J&&this.H&&this.H.classList.remove(...this.J.split(" ")),this.m.icon?(this.J=this.action.class,this.H&&(this.H.classList.add("codicon"),this.J&&this.H.classList.add(...this.J.split(" "))),this.u()):this.H?.classList.remove("codicon")}u(){this.action.enabled?(this.H&&(this.H.removeAttribute("aria-disabled"),this.H.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.H&&(this.H.setAttribute("aria-disabled","true"),this.H.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.H){const m=this.z()??"";this.H.setAttribute("aria-label",m)}}G(){this.H&&(this.action.checked!==void 0?(this.H.classList.toggle("checked",this.action.checked),this.H.setAttribute("aria-checked",this.action.checked?"true":"false"),this.H.setAttribute("role","checkbox")):(this.H.classList.remove("checked"),this.H.setAttribute("aria-checked",""),this.H.setAttribute("role",this.L())))}}t.$DR=e;class o extends h{constructor(m,n,r,b,u,l,N){super(m,n),this.b=new A.$xR(r,b,u,l,N),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(m,n){this.b.setOptions(m,n)}select(m){this.b.select(m)}g(){this.B(this.b.onDidSelect(m=>this.n(m.selected,m.index)))}n(m,n){this.actionRunner.run(this._action,this.r(m,n))}r(m,n){return m}setFocusable(m){this.b.setFocusable(m)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(m){this.b.render(m)}}t.$ER=o}),define($e[64],we([1,0,3,15,63,36,4,2,7,52]),function(ae,t,v,T,i,H,w,A,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RQ=t.$QQ=t.ActionsOrientation=void 0;var g;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})(g||(t.ActionsOrientation=g={}));class c extends A.$Rc{constructor(h,e={}){super(),this.g=this.B(new A.$Qc),this.r=this.B(new A.$Zc),this.w=!1,this.y=!0,this.C=this.B(new w.$Od),this.onDidBlur=this.C.event,this.D=this.B(new w.$Od({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new w.$Od),this.onDidRun=this.G.event,this.H=this.B(new w.$Od),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new H.$yi,this.g.add(this.f)),this.g.add(this.f.onDidRun(m=>this.G.fire(m))),this.g.add(this.f.onWillRun(m=>this.H.fire(m))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let o,a;switch(this.m){case 0:o=[15],a=[17];break;case 1:o=[16],a=[18],this.domNode.className+=" vertical";break}this.B(v.$XO(this.domNode,v.$QP.KEY_DOWN,m=>{const n=new T.$UO(m);let r=!0;const b=typeof this.t=="number"?this.viewItems[this.t]:void 0;o&&(n.equals(o[0])||n.equals(o[1]))?r=this.P():a&&(n.equals(a[0])||n.equals(a[1]))?r=this.O():n.equals(9)&&this.F?this.D.fire():n.equals(14)?r=this.M():n.equals(13)?r=this.N():n.equals(2)&&b instanceof i.$CR&&b.trapsArrowNavigation?r=this.O():this.J(n)?this.n.keyDown?this.R(n):this.w=!0:r=!1,r&&(n.preventDefault(),n.stopPropagation())})),this.B(v.$XO(this.domNode,v.$QP.KEY_UP,m=>{const n=new T.$UO(m);this.J(n)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(n)),n.preventDefault(),n.stopPropagation()):(n.equals(2)||n.equals(1026))&&this.L()})),this.u=this.B(v.$VP(this.domNode)),this.B(this.u.onDidBlur(()=>{(v.$xP()===this.domNode||!v.$pP(v.$xP(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),h.appendChild(this.domNode)}I(){this.length()>=2?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(h){h?this.z.setAttribute("aria-label",h):this.z.removeAttribute("aria-label")}setFocusable(h){if(this.y=h,this.y){const e=this.viewItems.find(o=>o instanceof i.$CR&&o.isEnabled());e instanceof i.$CR&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.$CR&&e.setFocusable(!1)})}J(h){let e=!1;return this.n.keys.forEach(o=>{e=e||h.equals(o)}),e}L(){for(let h=0;h<this.z.children.length;h++){const e=this.z.children[h];if(v.$pP(v.$xP(),e)){this.t=h,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(h){this.j=h,this.viewItems.forEach(e=>e.setActionContext(h))}get actionRunner(){return this.f}set actionRunner(h){this.f=h,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=h)}getContainer(){return this.domNode}hasAction(h){return this.viewItems.findIndex(e=>e.action.id===h.id)!==-1}getAction(h){if(typeof h=="number")return this.viewItems[h]?.action;if(h instanceof HTMLElement){for(;h.parentElement!==this.z;){if(!h.parentElement)return;h=h.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===h)return this.viewItems[e].action}}push(h,e={}){const o=Array.isArray(h)?h:[h];let a=f.$Df(e.index)?e.index:null;o.forEach(m=>{const n=document.createElement("li");n.className="action-item",n.setAttribute("role","presentation");let r;const b={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(r=this.b.actionViewItemProvider(m,b)),r||(r=new i.$DR(this.context,m,b)),this.b.allowContextMenu||this.r.set(r,v.$XO(n,v.$QP.CONTEXT_MENU,u=>{v.$SP.stop(u,!0)})),r.actionRunner=this.f,r.setActionContext(this.context),r.render(n),this.y&&r instanceof i.$CR&&this.viewItems.length===0&&r.setFocusable(!0),a===null||a<0||a>=this.z.children.length?(this.z.appendChild(n),this.viewItems.push(r)):(this.z.insertBefore(n,this.z.children[a]),this.viewItems.splice(a,0,r),a++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(h){if(h>=0&&h<this.z.children.length){const e=this.z.children.item(h);if(e)return e.clientWidth}return 0}getHeight(h){if(h>=0&&h<this.z.children.length){const e=this.z.children.item(h);if(e)return e.clientHeight}return 0}pull(h){h>=0&&h<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[h]),this.r.deleteAndDispose(this.viewItems[h]),(0,A.$Mc)(this.viewItems.splice(h,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,A.$Mc)(this.viewItems),this.r.clearAndDisposeAll(),v.$WO(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(h){let e=!1,o;if(h===void 0?e=!0:typeof h=="number"?o=h:typeof h=="boolean"&&(e=h),e&&typeof this.t>"u"){const a=this.viewItems.findIndex(m=>m.isEnabled());this.t=a===-1?void 0:a,this.Q(void 0,void 0,!0)}else o!==void 0&&(this.t=o),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(h){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let o;do{if(!h&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,o=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===H.$zi.ID));return this.Q(),!0}P(h){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let o;do{if(this.t=this.t-1,this.t<0){if(!h&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}o=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===H.$zi.ID));return this.Q(!0),!0}Q(h,e,o=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const a=this.t!==void 0?this.viewItems[this.t]:void 0;if(a){let m=!0;f.$Nf(a.focus)||(m=!1),this.b.focusOnlyEnabledItems&&f.$Nf(a.isEnabled)&&!a.isEnabled()&&(m=!1),a.action.id===H.$zi.ID&&(m=!1),m&&a.showHover?.(),m?(o||this.s!==this.t)&&(a.focus(h),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0)}}R(h){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof i.$CR){const o=e._context===null||e._context===void 0?h:e._context;this.run(e._action,o)}}async run(h,e){await this.f.run(h,e)}dispose(){this.j=void 0,this.viewItems=(0,A.$Mc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$QQ=c;function L(s){if(!s.length)return s;let h=-1;for(let o=0;o<s.length;o++)if(s[o].id!==H.$zi.ID){h=o;break}if(h===-1)return[];s=s.slice(h);for(let o=s.length-1;o>=0&&s[o].id===H.$zi.ID;o--)s.splice(o,1);let e=!1;for(let o=s.length-1;o>=0;o--){const a=s[o].id===H.$zi.ID;a&&!e?s.splice(o,1):a?a&&(e=!1):e=!0}return s}t.$RQ=L}),define($e[65],we([1,0,3,22,55,64,57,60,21,4,81,51,108,96]),function(ae,t,v,T,i,H,w,A,f,g,c,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jS=t.$iS=t.$hS=t.MessageType=void 0;const h=v.$;var e;(function(m){m[m.INFO=1]="INFO",m[m.WARNING=2]="WARNING",m[m.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$hS={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class o extends f.$yQ{constructor(n,r,b){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new g.$Od),this.onDidChange=this.O.event,this.P=this.B(new g.$Od),this.onDidHeightChange=this.P.event,this.a=r,this.g=b,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=v.$XP(n,h(".monaco-inputbox.idle"));const u=this.g.flexibleHeight?"textarea":"input",l=v.$XP(this.element,h(".ibwrapper"));if(this.b=v.$XP(l,h(u+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=v.$XP(l,h("div.mirror")),this.y.innerText="\xA0",this.N=new A.$IQ(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),v.$XP(n,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(R=>this.b.scrollTop=R.scrollTop));const N=this.B(new T.$YQ(n.ownerDocument,"selectionchange")),z=g.Event.filter(N.event,()=>n.ownerDocument.getSelection()?.anchorNode===l);this.B(z(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new H.$QQ(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(n){this.n=n,this.b.setAttribute("placeholder",n)}setTooltip(n){this.r=n,this.b.title=n}setAriaLabel(n){this.s=n,n?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(n){this.b.value!==n&&(this.b.value=n,this.Y())}get step(){return this.b.step}set step(n){this.b.step=n}get height(){return typeof this.J=="number"?this.J:v.$nP(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return v.$yP(this.b)}select(n=null){this.b.select(),n&&(this.b.setSelectionRange(n.start,n.end),n.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(n){n?this.enable():this.disable()}get width(){return v.$jP(this.b)}set width(n){if(this.g.flexibleHeight&&this.g.flexibleWidth){let r=0;if(this.y){const b=parseFloat(this.y.style.paddingLeft||"")||0,u=parseFloat(this.y.style.paddingRight||"")||0;r=b+u}this.b.style.width=n-r+"px"}else this.b.style.width=n+"px";this.y&&(this.y.style.width=n+"px")}set paddingRight(n){this.b.style.width=`calc(100% - ${n}px)`,this.y&&(this.y.style.paddingRight=n+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const n=this.L,r=this.J,b=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:n,height:r}),this.N.setScrollPosition({scrollTop:b})}showMessage(n,r){if(this.w==="open"&&(0,L.$bn)(this.h,n))return;this.h=n,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(n.type));const b=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${v.$dQ(b.border,"transparent")}`,this.h.content&&(this.hasFocus()||r)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let n=null;return this.t&&(n=this.t(this.value),n?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(n)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),n?.type}stylesForType(n){const r=this.g.inputBoxStyles;switch(n){case 1:return{border:r.inputValidationInfoBorder,background:r.inputValidationInfoBackground,foreground:r.inputValidationInfoForeground};case 2:return{border:r.inputValidationWarningBorder,background:r.inputValidationWarningBackground,foreground:r.inputValidationWarningForeground};default:return{border:r.inputValidationErrorBorder,background:r.inputValidationErrorBackground,foreground:r.inputValidationErrorForeground}}}U(n){switch(n){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let n;const r=()=>n.style.width=v.$jP(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:u=>{if(!this.h)return null;n=v.$XP(u,h(".monaco-inputbox-container")),r();const l={inline:!0,className:"monaco-inputbox-message"},N=this.h.formatContent?(0,i.$WQ)(this.h.content,l):(0,i.$VQ)(this.h.content,l);N.classList.add(this.U(this.h.type));const z=this.stylesForType(this.h.type);return N.style.backgroundColor=z.background??"",N.style.color=z.foreground??"",N.style.border=z.border?`1px solid ${z.border}`:"",v.$XP(n,N),null},onHide:()=>{this.w="closed"},layout:r});let b;this.h.type===3?b=s.localize(0,null,this.h.content):this.h.type===2?b=s.localize(1,null,this.h.content):b=s.localize(2,null,this.h.content),w.$1Q(b),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const n=this.value,b=n.charCodeAt(n.length-1)===10?" ":"";(n+b).replace(/\u000c/g,"")?this.y.textContent=n+b:this.y.innerText="\xA0",this.layout()}ab(){const n=this.g.inputBoxStyles,r=n.inputBackground??"",b=n.inputForeground??"",u=n.inputBorder??"";this.element.style.backgroundColor=r,this.element.style.color=b,this.b.style.backgroundColor="inherit",this.b.style.color=b,this.element.style.border=`1px solid ${v.$dQ(u,"transparent")}`}layout(){if(!this.y)return;const n=this.L;this.L=v.$nP(this.y),n!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(n){const r=this.inputElement,b=r.selectionStart,u=r.selectionEnd,l=r.value;b!==null&&u!==null&&(this.value=l.substr(0,b)+n+l.substr(u),r.setSelectionRange(b+1,b+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$iS=o;class a extends o{constructor(n,r,b){const u=s.localize(3,null,"\u21C5"),l=s.localize(4,null,"\u21C5");super(n,r,b),this.db=this.B(new g.$Od),this.onDidFocus=this.db.event,this.eb=this.B(new g.$Od),this.onDidBlur=this.eb.event,this.bb=new c.$fS(b.history,100);const N=()=>{if(b.showHistoryHint&&b.showHistoryHint()&&!this.n.endsWith(u)&&!this.n.endsWith(l)&&this.bb.getHistory().length){const z=this.n.endsWith(")")?u:l,R=this.n+z;b.showPlaceholderOnFocus&&!v.$yP(this.b)?this.n=R:this.setPlaceHolder(R)}};this.cb=new MutationObserver((z,R)=>{z.forEach(d=>{d.target.textContent||N()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>N()),this.F(this.b,()=>{const z=R=>{if(this.n.endsWith(R)){const d=this.n.slice(0,this.n.length-R.length);return b.showPlaceholderOnFocus?this.n=d:this.setPlaceHolder(d),!0}else return!1};z(l)||z(u)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(n){this.value&&(n||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(n){const r=this.getHistory();this.clearHistory(),n.forEach(b=>{this.bb.add(b)}),r.forEach(b=>{this.bb.add(b)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let n=this.jb();n&&(n=n===this.value?this.jb():n),this.value=n??"",w.$2Q(this.value?this.value:s.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let n=this.ib();n&&(n=n===this.value?this.ib():n),n&&(this.value=n,w.$2Q(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(n){super.setPlaceHolder(n),this.setTooltip(n)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let n=this.bb.current();return n||(n=this.bb.last(),this.bb.next()),n}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$jS=a}),define($e[66],we([1,0,63,21,18,19,4,3,101]),function(ae,t,v,T,i,H,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BR=t.$AR=t.$zR=t.$yR=void 0,t.$yR={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class f extends v.$CR{constructor(s,h,e){super(s,h,e),this.a=this.B(new g({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:e.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:e.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:e.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(s){this.element=s,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(s){this.a.domNode.tabIndex=s?0:-1}}t.$zR=f;class g extends T.$yQ{constructor(s){super(),this.a=this.B(new w.$Od),this.onChange=this.a.event,this.b=this.B(new w.$Od),this.onKeyDown=this.b.event,this.c=s,this.s=this.c.isChecked;const h=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,h.push(...H.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&h.push(...this.c.actionClassName.split(" ")),this.s&&h.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...h),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,e=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),e.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this.s,this.a.fire(!0),e.preventDefault(),e.stopPropagation();return}this.b.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(s){this.s=s,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(s){this.g&&this.domNode.classList.remove(...H.ThemeIcon.asClassNameArray(this.g)),this.g=s,this.g&&this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(s){this.domNode.title=s,this.domNode.setAttribute("aria-label",s)}}t.$AR=g;class c extends T.$yQ{constructor(s,h,e){super(),this.c=s,this.g=h,this.a=new g({title:this.c,isChecked:this.g,icon:i.$Xj.check,actionClassName:"monaco-checkbox",...t.$yR}),this.domNode=this.a.domNode,this.b=e,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(s){this.a.checked=s,this.h()}focus(){this.domNode.focus()}hasFocus(){return(0,A.$yP)(this.domNode)}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.$BR=c}),define($e[129],we([1,0,66,18,106]),function(ae,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wS=t.$vS=t.$uS=void 0;const H=i.localize(0,null),w=i.localize(1,null),A=i.localize(2,null);class f extends v.$AR{constructor(s){super({icon:T.$Xj.caseSensitive,title:H+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$uS=f;class g extends v.$AR{constructor(s){super({icon:T.$Xj.wholeWord,title:w+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$vS=g;class c extends v.$AR{constructor(s){super({icon:T.$Xj.regex,title:A+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$wS=c}),define($e[130],we([1,0,3,129,65,21,4,105,2,95]),function(ae,t,v,T,i,H,w,A,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xS=void 0;const g=A.localize(0,null);class c extends H.$yQ{static{this.OPTION_CHANGE="optionChange"}constructor(s,h,e){super(),this.n=!0,this.s=!1,this.w=this.B(new f.$Sc),this.N=[],this.O=this.B(new w.$Od),this.onDidOptionChange=this.O.event,this.P=this.B(new w.$Od),this.onKeyDown=this.P.event,this.Q=this.B(new w.$Od),this.onMouseDown=this.Q.event,this.R=this.B(new w.$Od),this.onInput=this.R.event,this.S=this.B(new w.$Od),this.onKeyUp=this.S.event,this.U=this.B(new w.$Od),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new w.$Od),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||g,this.h=!!e.showCommonFindToggles;const o=e.appendCaseSensitiveLabel||"",a=e.appendWholeWordsLabel||"",m=e.appendRegexLabel||"",n=e.history||[],r=!!e.flexibleHeight,b=!!e.flexibleWidth,u=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.$jS(this.domNode,h,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:n,showHistoryHint:e.showHistoryHint,flexibleHeight:r,flexibleWidth:b,flexibleMaxHeight:u,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new T.$wS({appendTitle:m,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(N=>{this.W.fire(N)})),this.L=this.B(new T.$vS({appendTitle:a,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new T.$uS({appendTitle:o,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(N=>{this.U.fire(N)}));const l=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,N=>{if(N.equals(15)||N.equals(17)||N.equals(9)){const z=l.indexOf(this.domNode.ownerDocument.activeElement);if(z>=0){let R=-1;N.equals(17)?R=(z+1)%l.length:N.equals(15)&&(z===0?R=l.length-1:R=z-1),N.equals(9)?(l[z].blur(),this.inputBox.focus()):R>=0&&l[R].focus(),v.$SP.stop(N,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),s?.appendChild(this.domNode),this.B(v.$XO(this.inputBox.inputElement,"compositionstart",l=>{this.s=!0})),this.B(v.$XO(this.inputBox.inputElement,"compositionend",l=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,l=>this.P.fire(l)),this.C(this.inputBox.inputElement,l=>this.S.fire(l)),this.D(this.inputBox.inputElement,l=>this.R.fire()),this.j(this.inputBox.inputElement,l=>this.Q.fire(l))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(s){this.inputBox.layout(),this.X(s.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const s of this.N)s.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const s of this.N)s.disable()}setFocusInputOnOptionClick(s){this.n=s}setEnabled(s){s?this.enable():this.disable()}setAdditionalToggles(s){for(const h of this.N)h.domNode.remove();this.N=[],this.w.value=new f.$Qc;for(const h of s??[])this.w.value.add(h),this.y.appendChild(h.domNode),this.w.value.add(h.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(h);this.N.length>0&&(this.y.style.display=""),this.X()}X(s=!1){s?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((h,e)=>h+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(s){this.inputBox.value!==s&&(this.inputBox.value=s)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(s){this.M&&(this.M.checked=s)}getWholeWords(){return this.L?.checked??!1}setWholeWords(s){this.L&&(this.L.checked=s)}getRegex(){return this.J?.checked??!1}setRegex(s){this.J&&(this.J.checked=s,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(s){this.inputBox.showMessage(s)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$xS=c}),define($e[131],we([1,0,3,22,15,64,130,65,61,39,66,58,25,36,11,9,18,19,32,4,34,2,46,7,110,102]),function(ae,t,v,T,i,H,w,A,f,g,c,L,s,h,e,o,a,m,n,r,b,u,l,N,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8S=t.TreeFindMatchType=t.TreeFindMode=t.$7S=t.$6S=t.RenderIndentGuides=t.$5S=t.$4S=void 0;class R extends f.$_Q{set context($){this.c.context=$}get context(){return this.c.context}constructor($){super($.elements.map(U=>U.element)),this.c=$}}function d(q){return q instanceof f.$_Q?new R(q):q}class D{constructor($,U){this.d=$,this.f=U,this.b=u.$Rc.None,this.c=new u.$Qc}getDragURI($){return this.f.getDragURI($.element)}getDragLabel($,U){if(this.f.getDragLabel)return this.f.getDragLabel($.map(Q=>Q.element),U)}onDragStart($,U){this.f.onDragStart?.(d($),U)}onDragOver($,U,Q,p,E=!0){const y=this.f.onDragOver(d($),U&&U.element,Q,p),M=this.a!==U;if(M&&(this.b.dispose(),this.a=U),typeof U>"u")return y;if(M&&typeof y!="boolean"&&y.autoExpand&&(this.b=(0,o.$Wg)(()=>{const j=this.d(),X=j.getNodeLocation(U);j.isCollapsed(X)&&j.setCollapsed(X,!1),this.a=void 0},500,this.c)),typeof y=="boolean"||!y.accept||typeof y.bubble>"u"||y.feedback){if(!E){const j=typeof y=="boolean"?y:y.accept,X=typeof y=="boolean"?void 0:y.effect;return{accept:j,effect:X,feedback:[Q]}}return y}if(y.bubble===1){const j=this.d(),X=j.getNodeLocation(U),ee=j.getParentNodeLocation(X),ne=j.getNode(ee),me=ee&&j.getListIndex(ee);return this.onDragOver($,ne,me,p,!1)}const k=this.d(),I=k.getNodeLocation(U),C=k.getListIndex(I),F=k.getListRenderCount(I);return{...y,feedback:(0,e.$Rb)(C,C+F)}}drop($,U,Q,p){this.b.dispose(),this.a=void 0,this.f.drop(d($),U&&U.element,Q,p)}onDragEnd($){this.f.onDragEnd?.($)}dispose(){this.c.dispose(),this.f.dispose()}}function B(q,$){return $&&{...$,identityProvider:$.identityProvider&&{getId(U){return $.identityProvider.getId(U.element)}},dnd:$.dnd&&new D(q,$.dnd),multipleSelectionController:$.multipleSelectionController&&{isSelectionSingleChangeEvent(U){return $.multipleSelectionController.isSelectionSingleChangeEvent({...U,element:U.element})},isSelectionRangeChangeEvent(U){return $.multipleSelectionController.isSelectionRangeChangeEvent({...U,element:U.element})}},accessibilityProvider:$.accessibilityProvider&&{...$.accessibilityProvider,getSetSize(U){const Q=q(),p=Q.getNodeLocation(U),E=Q.getParentNodeLocation(p);return Q.getNode(E).visibleChildrenCount},getPosInSet(U){return U.visibleChildIndex+1},isChecked:$.accessibilityProvider&&$.accessibilityProvider.isChecked?U=>$.accessibilityProvider.isChecked(U.element):void 0,getRole:$.accessibilityProvider&&$.accessibilityProvider.getRole?U=>$.accessibilityProvider.getRole(U.element):()=>"treeitem",getAriaLabel(U){return $.accessibilityProvider.getAriaLabel(U.element)},getWidgetAriaLabel(){return $.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:$.accessibilityProvider&&$.accessibilityProvider.getWidgetRole?()=>$.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:$.accessibilityProvider&&$.accessibilityProvider.getAriaLevel?U=>$.accessibilityProvider.getAriaLevel(U.element):U=>U.depth,getActiveDescendantId:$.accessibilityProvider.getActiveDescendantId&&(U=>$.accessibilityProvider.getActiveDescendantId(U.element))},keyboardNavigationLabelProvider:$.keyboardNavigationLabelProvider&&{...$.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(U){return $.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(U.element)}}}}class _{constructor($){this.a=$}getHeight($){return this.a.getHeight($.element)}getTemplateId($){return this.a.getTemplateId($.element)}hasDynamicHeight($){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight($.element)}setDynamicHeight($,U){this.a.setDynamicHeight?.($.element,U)}}t.$4S=_;class x{static lift($){return $ instanceof x?$:new x($)}static empty($=0){return new x({focus:[],selection:[],expanded:Object.create(null),scrollTop:$})}constructor($){if(this.focus=new Set($.focus),this.selection=new Set($.selection),$.expanded instanceof Array){this.expanded=Object.create(null);for(const U of $.expanded)this.expanded[U]=1}else this.expanded=$.expanded;this.expanded=$.expanded,this.scrollTop=$.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$5S=x;var P;(function(q){q.None="none",q.OnHover="onHover",q.Always="always"})(P||(t.RenderIndentGuides=P={}));class O{get elements(){return this.b}constructor($,U=[]){this.b=U,this.a=new u.$Qc,this.onDidChange=r.Event.forEach($,Q=>this.b=Q,this.a)}dispose(){this.a.dispose()}}class K{static{this.a=8}constructor($,U,Q,p,E,y={}){this.o=$,this.p=U,this.q=p,this.s=E,this.b=new Map,this.c=new Map,this.d=K.a,this.f=!1,this.g=!1,this.j=new Set,this.k=u.$Rc.None,this.m=new u.$Qc,this.templateId=$.templateId,this.updateOptions(y),r.Event.map(Q,M=>M.node)(this.u,this,this.m),$.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions($={}){if(typeof $.indent<"u"){const U=(0,l.$Rl)($.indent,0,40);if(U!==this.d){this.d=U;for(const[Q,p]of this.c)this.v(Q,p)}}if(typeof $.renderIndentGuides<"u"){const U=$.renderIndentGuides!==P.None;if(U!==this.g){this.g=U;for(const[Q,p]of this.c)this.w(Q,p);if(this.k.dispose(),U){const Q=new u.$Qc;this.q.onDidChange(this.x,this,Q),this.k=Q,this.x(this.q.elements)}}}typeof $.hideTwistiesOfChildlessElements<"u"&&(this.f=$.hideTwistiesOfChildlessElements)}renderTemplate($){const U=(0,v.$XP)($,(0,v.$)(".monaco-tl-row")),Q=(0,v.$XP)(U,(0,v.$)(".monaco-tl-indent")),p=(0,v.$XP)(U,(0,v.$)(".monaco-tl-twistie")),E=(0,v.$XP)(U,(0,v.$)(".monaco-tl-contents")),y=this.o.renderTemplate(E);return{container:$,indent:Q,twistie:p,indentGuidesDisposable:u.$Rc.None,templateData:y}}renderElement($,U,Q,p){this.c.set($,Q),this.b.set($.element,$),this.v($,Q),this.o.renderElement($,U,Q.templateData,p)}disposeElement($,U,Q,p){Q.indentGuidesDisposable.dispose(),this.o.disposeElement?.($,U,Q.templateData,p),typeof p=="number"&&(this.c.delete($),this.b.delete($.element))}disposeTemplate($){this.o.disposeTemplate($.templateData)}t($){const U=this.b.get($);U&&this.u(U)}u($){const U=this.c.get($);U&&(this.x(this.q.elements),this.v($,U))}v($,U){const Q=K.a+($.depth-1)*this.d;U.twistie.style.paddingLeft=`${Q}px`,U.indent.style.width=`${Q+this.d-16}px`,$.collapsible?U.container.setAttribute("aria-expanded",String(!$.collapsed)):U.container.removeAttribute("aria-expanded"),U.twistie.classList.remove(...m.ThemeIcon.asClassNameArray(a.$Xj.treeItemExpanded));let p=!1;this.o.renderTwistie&&(p=this.o.renderTwistie($.element,U.twistie)),$.collapsible&&(!this.f||$.visibleChildrenCount>0)?(p||U.twistie.classList.add(...m.ThemeIcon.asClassNameArray(a.$Xj.treeItemExpanded)),U.twistie.classList.add("collapsible"),U.twistie.classList.toggle("collapsed",$.collapsed)):U.twistie.classList.remove("collapsible","collapsed"),this.w($,U)}w($,U){if((0,v.$WO)(U.indent),U.indentGuidesDisposable.dispose(),!this.g)return;const Q=new u.$Qc,p=this.p();for(;;){const E=p.getNodeLocation($),y=p.getParentNodeLocation(E);if(!y)break;const M=p.getNode(y),k=(0,v.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(M)&&k.classList.add("active"),U.indent.childElementCount===0?U.indent.appendChild(k):U.indent.insertBefore(k,U.indent.firstElementChild),this.s.add(M,k),Q.add((0,u.$Pc)(()=>this.s.delete(M,k))),$=M}U.indentGuidesDisposable=Q}x($){if(!this.g)return;const U=new Set,Q=this.p();$.forEach(p=>{const E=Q.getNodeLocation(p);try{const y=Q.getParentNodeLocation(E);p.collapsible&&p.children.length>0&&!p.collapsed?U.add(p):y&&U.add(Q.getNode(y))}catch{}}),this.j.forEach(p=>{U.has(p)||this.s.forEach(p,E=>E.classList.remove("active"))}),U.forEach(p=>{this.j.has(p)||this.s.forEach(p,E=>E.classList.add("active"))}),this.j=U}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,u.$Mc)(this.m)}}class te{get totalCount(){return this.a}get matchCount(){return this.b}set pattern($){this.c=$,this.d=$.toLowerCase()}constructor($,U,Q){this.g=$,this.j=U,this.k=Q,this.a=0,this.b=0,this.c="",this.d="",this.f=new u.$Qc,$.onWillRefilter(this.m,this,this.f)}filter($,U){let Q=1;if(this.k){const y=this.k.filter($,U);if(typeof y=="boolean"?Q=y?1:0:(0,L.$1S)(y)?Q=(0,L.$2S)(y.visibility):Q=y,Q===0)return!1}if(this.a++,!this.c)return this.b++,{data:b.FuzzyScore.Default,visibility:Q};const p=this.j.getKeyboardNavigationLabel($),E=Array.isArray(p)?p:[p];for(const y of E){const M=y&&y.toString();if(typeof M>"u")return{data:b.FuzzyScore.Default,visibility:Q};let k;if(this.g.findMatchType===be.Contiguous){const I=M.toLowerCase().indexOf(this.d);if(I>-1){k=[Number.MAX_SAFE_INTEGER,0];for(let C=this.d.length;C>0;C--)k.push(I+C-1)}}else k=(0,b.$Sj)(this.c,this.d,0,M,M.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(k)return this.b++,E.length===1?{data:k,visibility:Q}:{data:{label:M,score:k},visibility:Q}}return this.g.findMode===oe.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility($):2:{data:b.FuzzyScore.Default,visibility:Q}}m(){this.a=0,this.b=0}dispose(){(0,u.$Mc)(this.f)}}class se extends c.$AR{constructor($){super({icon:a.$Xj.listFilter,title:(0,z.localize)(0,null),isChecked:$.isChecked??!1,inputActiveOptionBorder:$.inputActiveOptionBorder,inputActiveOptionForeground:$.inputActiveOptionForeground,inputActiveOptionBackground:$.inputActiveOptionBackground})}}t.$6S=se;class fe extends c.$AR{constructor($){super({icon:a.$Xj.searchFuzzy,title:(0,z.localize)(1,null),isChecked:$.isChecked??!1,inputActiveOptionBorder:$.inputActiveOptionBorder,inputActiveOptionForeground:$.inputActiveOptionForeground,inputActiveOptionBackground:$.inputActiveOptionBackground})}}t.$7S=fe;const le={inputBoxStyles:A.$hS,toggleStyles:c.$yR,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var oe;(function(q){q[q.Highlight=0]="Highlight",q[q.Filter=1]="Filter"})(oe||(t.TreeFindMode=oe={}));var be;(function(q){q[q.Fuzzy=0]="Fuzzy",q[q.Contiguous=1]="Contiguous"})(be||(t.TreeFindMatchType=be={}));class Ce extends u.$Rc{set mode($){this.b.checked=$===oe.Filter,this.f.inputBox.setPlaceHolder($===oe.Filter?(0,z.localize)(2,null):(0,z.localize)(3,null))}set matchType($){this.c.checked=$===be.Fuzzy}get value(){return this.f.inputBox.value}set value($){this.f.inputBox.value=$}constructor($,U,Q,p,E,y){super(),this.t=U,this.a=(0,v.h)(".monaco-tree-type-filter",[(0,v.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,v.h)(".monaco-tree-type-filter-input@findInput"),(0,v.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new r.$Od,this.onDidDisable=this._onDidDisable.event,$.appendChild(this.a.root),this.B((0,u.$Pc)(()=>$.removeChild(this.a.root)));const M=y?.styles??le;M.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=M.listFilterWidgetBackground),M.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${M.listFilterWidgetShadow}`),this.b=this.B(new se({...M.toggleStyles,isChecked:p===oe.Filter})),this.c=this.B(new fe({...M.toggleStyles,isChecked:E===be.Fuzzy})),this.onDidChangeMode=r.Event.map(this.b.onChange,()=>this.b.checked?oe.Filter:oe.Highlight,this.q),this.onDidChangeMatchType=r.Event.map(this.c.onChange,()=>this.c.checked?be.Fuzzy:be.Contiguous,this.q),this.f=this.B(new w.$xS(this.a.findInput,Q,{label:(0,z.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:M.inputBoxStyles,toggleStyles:M.toggleStyles,history:y?.history})),this.g=this.B(new H.$QQ(this.a.actionbar)),this.mode=p;const k=this.B(new T.$YQ(this.f.inputBox.inputElement,"keydown")),I=r.Event.chain(k.event,X=>X.map(ee=>new i.$UO(ee)));this.B(I(X=>{if(X.equals(3)){X.preventDefault(),X.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(X.equals(18)){X.preventDefault(),X.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(X.equals(16)){X.preventDefault(),X.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const C=this.B(new h.$xi("close",(0,z.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(C,{icon:!0,label:!1});const F=this.B(new T.$YQ(this.a.grab,"mousedown"));this.B(F.event(X=>{const ee=new u.$Qc,ne=ee.add(new T.$YQ((0,v.$DP)(X),"mousemove")),me=ee.add(new T.$YQ((0,v.$DP)(X),"mouseup")),ve=this.m,Ne=X.pageX,Se=this.s,De=X.pageY;this.a.grab.classList.add("grabbing");const Le=this.a.root.style.transition;this.a.root.style.transition="unset";const Te=We=>{const He=We.pageX-Ne;this.m=ve-He;const Me=We.pageY-De;this.s=Se+Me,this.layout()};ee.add(ne.event(Te)),ee.add(me.event(We=>{Te(We),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Le,ee.dispose()}))}));const j=r.Event.chain(this.B(new T.$YQ(this.a.grab,"keydown")).event,X=>X.map(ee=>new i.$UO(ee)));this.B(j(X=>{let ee,ne;if(X.keyCode===15?ee=Number.POSITIVE_INFINITY:X.keyCode===17?ee=0:X.keyCode===10&&(ee=this.m===0?Number.POSITIVE_INFINITY:0),X.keyCode===16?ne=0:X.keyCode===18&&(ne=Number.POSITIVE_INFINITY),ee!==void 0&&(X.preventDefault(),X.stopPropagation(),this.m=ee,this.layout()),ne!==void 0){X.preventDefault(),X.stopPropagation(),this.s=ne;const me=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=me},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout($=this.j){this.j=$,this.m=(0,l.$Rl)(this.m,0,Math.max(0,$-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,l.$Rl)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage($){this.f.showMessage($)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,o.$Vg)(300),super.dispose()}}class Ae{get pattern(){return this.b}get mode(){return this.d}set mode($){$!==this.d&&(this.d=$,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire($))}get matchType(){return this.f}set matchType($){$!==this.f&&(this.f=$,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire($))}constructor($,U,Q,p,E,y={}){this.t=$,this.u=Q,this.v=p,this.w=E,this.x=y,this.b="",this.c="",this.j=0,this.k=new r.$Od,this.onDidChangeMode=this.k.event,this.m=new r.$Od,this.onDidChangeMatchType=this.m.event,this.o=new r.$Od,this.onDidChangePattern=this.o.event,this.p=new r.$Od,this.onDidChangeOpenState=this.p.event,this.q=new u.$Qc,this.s=new u.$Qc,this.d=$.options.defaultFindMode??oe.Highlight,this.f=$.options.defaultFindMatchType??be.Fuzzy,U.onDidSplice(this.z,this,this.s)}updateOptions($={}){$.defaultFindMode!==void 0&&(this.mode=$.defaultFindMode),$.defaultFindMatchType!==void 0&&(this.matchType=$.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Ce(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode($=>this.mode=$,void 0,this.q),this.g.onDidChangeMatchType($=>this.matchType=$,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y($){this.b=$,this.o.fire($),this.v.pattern=$,this.t.refilter(),$&&this.t.focusNext(0,!0,void 0,Q=>!b.FuzzyScore.isDefault(Q.filterData));const U=this.t.getFocus();if(U.length>0){const Q=U[0];this.t.getRelativeTop(Q)===null&&this.t.reveal(Q,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const $=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&$?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,z.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus($){return!this.g||!this.pattern||this.d===oe.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!b.FuzzyScore.isDefault($.filterData)}layout($){this.j=$,this.g?.layout($)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Pe(q){let $=s.TreeMouseEventTarget.Unknown;return(0,v.$tP)(q.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?$=s.TreeMouseEventTarget.Twistie:(0,v.$tP)(q.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?$=s.TreeMouseEventTarget.Element:(0,v.$tP)(q.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&($=s.TreeMouseEventTarget.Filter),{browserEvent:q.browserEvent,element:q.element?q.element.element:null,target:$}}function de(q){return{element:q.element?q.element.element:null,browserEvent:q.browserEvent,anchor:q.anchor}}function ie(q,$){$(q),q.children.forEach(U=>ie(U,$))}class ce{get f(){return this.d||(this.d=this.m()),this.d}constructor($,U){this.g=$,this.j=U,this.a=[],this.c=new r.$Od,this.onDidChange=this.c.event}set($,U){!U?.__forceEvent&&(0,e.$tb)(this.a,$)||this.k($,!1,U)}k($,U,Q){if(this.a=[...$],this.b=void 0,this.d=void 0,!U){const p=this;this.c.fire({get elements(){return p.get()},browserEvent:Q})}}get(){return this.b||(this.b=this.a.map($=>$.element)),[...this.b]}getNodes(){return this.a}has($){return this.f.has($)}onDidModelSplice({insertedNodes:$,deletedNodes:U}){if(!this.j){const k=this.m(),I=C=>k.delete(C);U.forEach(C=>ie(C,I)),this.set([...k.values()]);return}const Q=new Set,p=k=>Q.add(this.j.getId(k.element).toString());U.forEach(k=>ie(k,p));const E=new Map,y=k=>E.set(this.j.getId(k.element).toString(),k);$.forEach(k=>ie(k,y));const M=[];for(const k of this.a){const I=this.j.getId(k.element).toString();if(!Q.has(I))M.push(k);else{const F=E.get(I);F&&F.visible&&M.push(F)}}if(this.a.length>0&&M.length===0){const k=this.g();k&&M.push(k)}this.k(M,!0)}m(){const $=new Set;for(const U of this.a)$.add(U);return $}}class Z extends g.$jR{constructor($,U){super($),this.x=U}u($){if((0,g.$fR)($.browserEvent.target)||(0,g.$dR)($.browserEvent.target)||(0,g.$eR)($.browserEvent.target)||$.browserEvent.isHandledByList)return;const U=$.element;if(!U)return super.u($);if(this.p($)||this.o($))return super.u($);const Q=$.browserEvent.target,p=Q.classList.contains("monaco-tl-twistie")||Q.classList.contains("monaco-icon-label")&&Q.classList.contains("folder-icon")&&$.browserEvent.offsetX<16;let E=!1;if(typeof this.x.expandOnlyOnTwistieClick=="function"?E=this.x.expandOnlyOnTwistieClick(U.element):E=!!this.x.expandOnlyOnTwistieClick,E&&!p&&$.browserEvent.detail!==2)return super.u($);if(!this.x.expandOnDoubleClick&&$.browserEvent.detail===2)return super.u($);if(U.collapsible){const y=this.x.getNodeLocation(U),M=$.browserEvent.altKey;if(this.x.setFocus([y]),this.x.toggleCollapsed(y,M),E&&p){$.browserEvent.isHandledByList=!0;return}}super.u($)}v($){$.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||$.browserEvent.isHandledByList||super.v($)}}class W extends g.$mR{constructor($,U,Q,p,E,y,M,k){super($,U,Q,p,k),this.p=E,this.s=y,this.K=M}D($){return new Z(this,$.tree)}splice($,U,Q=[]){if(super.splice($,U,Q),Q.length===0)return;const p=[],E=[];let y;Q.forEach((M,k)=>{this.p.has(M)&&p.push($+k),this.s.has(M)&&E.push($+k),this.K.has(M)&&(y=$+k)}),p.length>0&&super.setFocus((0,e.$Lb)([...super.getFocus(),...p])),E.length>0&&super.setSelection((0,e.$Lb)([...super.getSelection(),...E])),typeof y=="number"&&super.setAnchor(y)}setFocus($,U,Q=!1){super.setFocus($,U),Q||this.p.set($.map(p=>this.element(p)),U)}setSelection($,U,Q=!1){super.setSelection($,U),Q||this.s.set($.map(p=>this.element(p)),U)}setAnchor($,U=!1){super.setAnchor($),U||(typeof $>"u"?this.K.set([]):this.K.set([this.element($)]))}}class Y{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return r.Event.map(this.j.onMouseClick,Pe)}get onMouseDblClick(){return r.Event.filter(r.Event.map(this.j.onMouseDblClick,Pe),$=>$.target!==s.TreeMouseEventTarget.Filter)}get onContextMenu(){return r.Event.map(this.j.onContextMenu,de)}get onTap(){return r.Event.map(this.j.onTap,Pe)}get onPointer(){return r.Event.map(this.j.onPointer,Pe)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return r.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??oe.Highlight}set findMode($){this.x&&(this.x.mode=$)}get findMatchType(){return this.x?.matchType??be.Fuzzy}set findMatchType($){this.x&&(this.x.matchType=$)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:r.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor($,U,Q,p,E={}){this.D=$,this.E=E,this.w=new r.$Wd,this.onDidChangeFindOpenState=r.Event.None,this.A=new u.$Qc,this.B=new r.$Od,this.onWillRefilter=this.B.event,this.C=new r.$Od,this.onDidUpdateOptions=this.C.event;const y=new _(Q),M=new r.$Xd,k=new r.$Xd,I=this.A.add(new O(k.event)),C=new n.$Fc;this.k=p.map(ne=>new K(ne,()=>this.o,M.event,I,C,E));for(const ne of this.k)this.A.add(ne);let F;E.keyboardNavigationLabelProvider&&(F=new te(this,E.keyboardNavigationLabelProvider,E.filter),E={...E,filter:F},this.A.add(F)),this.p=new ce(()=>this.j.getFocusedElements()[0],E.identityProvider),this.q=new ce(()=>this.j.getSelectedElements()[0],E.identityProvider),this.u=new ce(()=>this.j.getAnchorElement(),E.identityProvider),this.j=new W($,U,y,this.k,this.p,this.q,this.u,{...B(()=>this.o,E),tree:this}),this.o=this.I($,this.j,E),M.input=this.o.onDidChangeCollapseState;const j=r.Event.forEach(this.o.onDidSplice,ne=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(ne),this.q.onDidModelSplice(ne)})},this.A);j(()=>null,null,this.A);const X=this.A.add(new r.$Od),ee=this.A.add(new o.$Rg(0));if(this.A.add(r.Event.any(j,this.p.onDidChange,this.q.onDidChange)(()=>{ee.trigger(()=>{const ne=new Set;for(const me of this.p.getNodes())ne.add(me);for(const me of this.q.getNodes())ne.add(me);X.fire([...ne.values()])})})),k.input=X.event,E.keyboardSupport!==!1){const ne=r.Event.chain(this.j.onKeyDown,me=>me.filter(ve=>!(0,g.$dR)(ve.target)).map(ve=>new i.$UO(ve)));r.Event.chain(ne,me=>me.filter(ve=>ve.keyCode===15))(this.F,this,this.A),r.Event.chain(ne,me=>me.filter(ve=>ve.keyCode===17))(this.G,this,this.A),r.Event.chain(ne,me=>me.filter(ve=>ve.keyCode===10))(this.H,this,this.A)}if((E.findWidgetEnabled??!0)&&E.keyboardNavigationLabelProvider&&E.contextViewProvider){const ne=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Ae(this,this.o,this.j,F,E.contextViewProvider,ne),this.y=me=>this.x.shouldAllowFocus(me),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=r.Event.None,this.onDidChangeFindMatchType=r.Event.None;this.z=(0,v.$GP)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===P.Always)}updateOptions($={}){this.E={...this.E,...$};for(const U of this.k)U.updateOptions($);this.j.updateOptions(this.E),this.x?.updateOptions($),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===P.Always)}get options(){return this.E}updateWidth($){const U=this.o.getListIndex($);U!==-1&&this.j.updateWidth(U)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop($){this.j.scrollTop=$}get scrollLeft(){return this.j.scrollLeft}set scrollLeft($){this.j.scrollLeft=$}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const $=this.j.firstVisibleIndex;return $<0||$>=this.j.length?void 0:this.j.element($).element}get lastVisibleElement(){const $=this.j.lastVisibleIndex;return this.j.element($).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel($){this.j.ariaLabel=$}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return(0,v.$yP)(this.getHTMLElement())}layout($,U){this.j.layout($,U),(0,N.$Df)(U)&&this.x?.layout(U)}style($){const U=`.${this.j.domId}`,Q=[];$.treeIndentGuidesStroke&&(Q.push(`.monaco-list${U}:hover .monaco-tl-indent > .indent-guide, .monaco-list${U}.always .monaco-tl-indent > .indent-guide  { border-color: ${$.treeInactiveIndentGuidesStroke}; }`),Q.push(`.monaco-list${U} .monaco-tl-indent > .indent-guide.active { border-color: ${$.treeIndentGuidesStroke}; }`)),this.z.textContent=Q.join(`
`),this.j.style($)}getParentElement($){const U=this.o.getParentNodeLocation($);return this.o.getNode(U).element}getFirstElementChild($){return this.o.getFirstElementChild($)}getNode($){return this.o.getNode($)}getNodeLocation($){return this.o.getNodeLocation($)}collapse($,U=!1){return this.o.setCollapsed($,!0,U)}expand($,U=!1){return this.o.setCollapsed($,!1,U)}toggleCollapsed($,U=!1){return this.o.setCollapsed($,void 0,U)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible($){return this.o.isCollapsible($)}setCollapsible($,U){return this.o.setCollapsible($,U)}isCollapsed($){return this.o.isCollapsed($)}expandTo($){this.o.expandTo($)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor($){if(typeof $>"u")return this.j.setAnchor(void 0);const U=this.o.getNode($);this.u.set([U]);const Q=this.o.getListIndex($);Q>-1&&this.j.setAnchor(Q,!0)}getAnchor(){return(0,e.$Nb)(this.u.get(),void 0)}setSelection($,U){const Q=$.map(E=>this.o.getNode(E));this.q.set(Q,U);const p=$.map(E=>this.o.getListIndex(E)).filter(E=>E>-1);this.j.setSelection(p,U,!0)}getSelection(){return this.q.get()}setFocus($,U){const Q=$.map(E=>this.o.getNode(E));this.p.set(Q,U);const p=$.map(E=>this.o.getListIndex(E)).filter(E=>E>-1);this.j.setFocus(p,U,!0)}focusNext($=1,U=!1,Q,p=this.y){this.j.focusNext($,U,Q,p)}focusPrevious($=1,U=!1,Q,p=this.y){this.j.focusPrevious($,U,Q,p)}focusNextPage($,U=this.y){return this.j.focusNextPage($,U)}focusPreviousPage($,U=this.y){return this.j.focusPreviousPage($,U)}focusLast($,U=this.y){this.j.focusLast($,U)}focusFirst($,U=this.y){this.j.focusFirst($,U)}getFocus(){return this.p.get()}reveal($,U){this.o.expandTo($);const Q=this.o.getListIndex($);Q!==-1&&this.j.reveal(Q,U)}getRelativeTop($){const U=this.o.getListIndex($);return U===-1?null:this.j.getRelativeTop(U)}getViewState($=this.options.identityProvider){if(!$)throw new s.$YS(this.D,"Can't get tree view state without an identity provider");const U=y=>$.getId(y).toString(),Q=x.empty(this.scrollTop);for(const y of this.getFocus())Q.focus.add(U(y));for(const y of this.getSelection())Q.selection.add(U(y));const p=this.o.getNode(),E=[p];for(;E.length>0;){const y=E.shift();y!==p&&y.collapsible&&(Q.expanded[U(y.element)]=y.collapsed?0:1),E.push(...y.children)}return Q}F($){$.preventDefault(),$.stopPropagation();const U=this.j.getFocusedElements();if(U.length===0)return;const Q=U[0],p=this.o.getNodeLocation(Q);if(!this.o.setCollapsed(p,!0)){const y=this.o.getParentNodeLocation(p);if(!y)return;const M=this.o.getListIndex(y);this.j.reveal(M),this.j.setFocus([M])}}G($){$.preventDefault(),$.stopPropagation();const U=this.j.getFocusedElements();if(U.length===0)return;const Q=U[0],p=this.o.getNodeLocation(Q);if(!this.o.setCollapsed(p,!1)){if(!Q.children.some(k=>k.visible))return;const[y]=this.j.getFocus(),M=y+1;this.j.reveal(M),this.j.setFocus([M])}}H($){$.preventDefault(),$.stopPropagation();const U=this.j.getFocusedElements();if(U.length===0)return;const Q=U[0],p=this.o.getNodeLocation(Q),E=$.browserEvent.altKey;this.o.setCollapsed(p,void 0,E)}navigate($){return new S(this.j,this.o,$)}dispose(){(0,u.$Mc)(this.A),this.j.dispose()}}t.$8S=Y;class S{constructor($,U,Q){this.b=$,this.c=U,Q?this.a=this.c.getListIndex(Q):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define($e[132],we([1,0,131,122,25,27]),function(ae,t,v,T,i,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gT=void 0;class w extends v.$8S{constructor(f,g,c,L,s,h={}){super(f,g,c,L,h),this.f=f,this.g=s,this.d=new Map,this.c=h.identityProvider}getInput(){return this.b}setInput(f,g){if(g&&!this.c)throw new i.$YS(this.f,"Can't restore tree view state without an identity provider");if(this.b=f,!f){this.d.clear(),this.o.setChildren(null,H.Iterable.empty());return}if(!g){this.m(f);return}const c=[],L=[],s=e=>{const o=this.c.getId(e).toString();return!g.expanded[o]},h=e=>{const o=this.c.getId(e.element).toString();g.focus.has(o)&&c.push(e.element),g.selection.has(o)&&L.push(e.element)};this.m(f,s,h),this.setFocus(c),this.setSelection(L),g&&typeof g.scrollTop=="number"&&(this.scrollTop=g.scrollTop)}updateChildren(f=this.b){if(typeof this.b>"u")throw new i.$YS(this.f,"Tree input not set");let g;this.c&&(g=c=>{const L=this.c.getId(c).toString(),s=this.d.get(L);if(s)return s.collapsed}),this.m(f,g)}resort(f=this.b,g=!0){this.o.resort(f===this.b?null:f,g)}refresh(f){if(f===void 0){this.j.rerender();return}this.o.rerender(f)}m(f,g,c){let L;if(this.c){const s=new Set,h=c;c=e=>{const o=this.c.getId(e.element).toString();s.add(o),this.d.set(o,e),h?.(e)},L=e=>{const o=this.c.getId(e.element).toString();s.has(o)||this.d.delete(o)}}this.o.setChildren(f===this.b?null:f,this.s(f,g).elements,{onDidCreateNode:c,onDidDeleteNode:L})}s(f,g){const c=[...this.g.getChildren(f)];return{elements:H.Iterable.map(c,s=>{const{elements:h,size:e}=this.s(s,g),o=this.g.hasChildren?this.g.hasChildren(s):void 0,a=e===0?void 0:g&&g(s);return{element:s,children:h,collapsible:o,collapsed:a}}),size:c.length}}I(f,g,c){return new T.$9S(f,g,c)}}t.$gT=w}),define($e[67],we([1,0,11,9,33,29,26,6,4,2,53,12,7]),function(ae,t,v,T,i,H,w,A,f,g,c,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bh=t.ProxyChannel=t.$Ah=t.$zh=t.$yh=t.$xh=t.$wh=t.$vh=t.RequestInitiator=t.$uh=t.$th=t.$sh=t.$rh=t.$qh=void 0;var h;(function(de){de[de.Promise=100]="Promise",de[de.PromiseCancel=101]="PromiseCancel",de[de.EventListen=102]="EventListen",de[de.EventDispose=103]="EventDispose"})(h||(h={}));function e(de){switch(de){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var o;(function(de){de[de.Initialize=200]="Initialize",de[de.PromiseSuccess=201]="PromiseSuccess",de[de.PromiseError=202]="PromiseError",de[de.PromiseErrorObj=203]="PromiseErrorObj",de[de.EventFire=204]="EventFire"})(o||(o={}));function a(de){switch(de){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(de){de[de.Uninitialized=0]="Uninitialized",de[de.Idle=1]="Idle"})(m||(m={}));function n(de){let ie=0;for(let ce=0;;ce+=7){const Z=de.read(1);if(ie|=(Z.buffer[0]&127)<<ce,!(Z.buffer[0]&128))return ie}}const r=z(0);function b(de,ie){if(ie===0){de.write(r);return}let ce=0;for(let W=ie;W!==0;W=W>>>7)ce++;const Z=i.$ce.alloc(ce);for(let W=0;ie!==0;W++)Z.buffer[W]=ie&127,ie=ie>>>7,ie>0&&(Z.buffer[W]|=128);de.write(Z)}class u{constructor(ie){this.b=ie,this.a=0}read(ie){const ce=this.b.slice(this.a,this.a+ie);return this.a+=ce.byteLength,ce}}t.$qh=u;class l{constructor(){this.a=[]}get buffer(){return i.$ce.concat(this.a)}write(ie){this.a.push(ie)}}t.$rh=l;var N;(function(de){de[de.Undefined=0]="Undefined",de[de.String=1]="String",de[de.Buffer=2]="Buffer",de[de.VSBuffer=3]="VSBuffer",de[de.Array=4]="Array",de[de.Object=5]="Object",de[de.Int=6]="Int"})(N||(N={}));function z(de){const ie=i.$ce.alloc(1);return ie.writeUInt8(de,0),ie}const R={Undefined:z(N.Undefined),String:z(N.String),Buffer:z(N.Buffer),VSBuffer:z(N.VSBuffer),Array:z(N.Array),Object:z(N.Object),Uint:z(N.Int)},d=typeof Buffer<"u";function D(de,ie){if(typeof ie>"u")de.write(R.Undefined);else if(typeof ie=="string"){const ce=i.$ce.fromString(ie);de.write(R.String),b(de,ce.byteLength),de.write(ce)}else if(d&&Buffer.isBuffer(ie)){const ce=i.$ce.wrap(ie);de.write(R.Buffer),b(de,ce.byteLength),de.write(ce)}else if(ie instanceof i.$ce)de.write(R.VSBuffer),b(de,ie.byteLength),de.write(ie);else if(Array.isArray(ie)){de.write(R.Array),b(de,ie.length);for(const ce of ie)D(de,ce)}else if(typeof ie=="number"&&(ie|0)===ie)de.write(R.Uint),b(de,ie);else{const ce=i.$ce.fromString(JSON.stringify(ie));de.write(R.Object),b(de,ce.byteLength),de.write(ce)}}t.$sh=D;function B(de){switch(de.read(1).readUInt8(0)){case N.Undefined:return;case N.String:return de.read(n(de)).toString();case N.Buffer:return de.read(n(de)).buffer;case N.VSBuffer:return de.read(n(de));case N.Array:{const ce=n(de),Z=[];for(let W=0;W<ce;W++)Z.push(B(de));return Z}case N.Object:return JSON.parse(de.read(n(de)).toString());case N.Int:return n(de)}}t.$th=B;class _{constructor(ie,ce,Z=null,W=1e3){this.h=ie,this.j=ce,this.k=Z,this.l=W,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Y=>this.q(Y)),this.m({type:200})}registerChannel(ie,ce){this.b.set(ie,ce),setTimeout(()=>this.w(ie),0)}m(ie){switch(ie.type){case 200:{const ce=this.o([ie.type]);this.k?.logOutgoing(ce,0,1,a(ie.type));return}case 201:case 202:case 204:case 203:{const ce=this.o([ie.type,ie.id],ie.data);this.k?.logOutgoing(ce,ie.id,1,a(ie.type),ie.data);return}}}o(ie,ce=void 0){const Z=new l;return D(Z,ie),D(Z,ce),this.p(Z.buffer)}p(ie){try{return this.h.send(ie),ie.byteLength}catch{return 0}}q(ie){const ce=new u(ie),Z=B(ce),W=B(ce),Y=Z[0];switch(Y){case 100:return this.k?.logIncoming(ie.byteLength,Z[1],1,`${e(Y)}: ${Z[2]}.${Z[3]}`,W),this.s({type:Y,id:Z[1],channelName:Z[2],name:Z[3],arg:W});case 102:return this.k?.logIncoming(ie.byteLength,Z[1],1,`${e(Y)}: ${Z[2]}.${Z[3]}`,W),this.t({type:Y,id:Z[1],channelName:Z[2],name:Z[3],arg:W});case 101:return this.k?.logIncoming(ie.byteLength,Z[1],1,`${e(Y)}`),this.u({type:Y,id:Z[1]});case 103:return this.k?.logIncoming(ie.byteLength,Z[1],1,`${e(Y)}`),this.u({type:Y,id:Z[1]})}}s(ie){const ce=this.b.get(ie.channelName);if(!ce){this.v(ie);return}const Z=new H.$Yd;let W;try{W=ce.call(this.j,ie.name,ie.arg,Z.token)}catch(q){W=Promise.reject(q)}const Y=ie.id;W.then(q=>{this.m({id:Y,data:q,type:201})},q=>{q instanceof Error?this.m({id:Y,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:Y,data:q,type:203})}).finally(()=>{S.dispose(),this.d.delete(ie.id)});const S=(0,g.$Pc)(()=>Z.cancel());this.d.set(ie.id,S)}t(ie){const ce=this.b.get(ie.channelName);if(!ce){this.v(ie);return}const Z=ie.id,Y=ce.listen(this.j,ie.name,ie.arg)(S=>this.m({id:Z,data:S,type:204}));this.d.set(ie.id,Y)}u(ie){const ce=this.d.get(ie.id);ce&&(ce.dispose(),this.d.delete(ie.id))}v(ie){let ce=this.g.get(ie.channelName);ce||(ce=[],this.g.set(ie.channelName,ce));const Z=setTimeout(()=>{console.error(`Unknown channel: ${ie.channelName}`),ie.type===100&&this.m({id:ie.id,data:{name:"Unknown channel",message:`Channel name '${ie.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ce.push({request:ie,timeoutTimer:Z})}w(ie){const ce=this.g.get(ie);if(ce){for(const Z of ce)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(ie)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}t.$uh=_;var x;(function(de){de[de.LocalSide=0]="LocalSide",de[de.OtherSide=1]="OtherSide"})(x||(t.RequestInitiator=x={}));class P{constructor(ie,ce=null){this.l=ie,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$Od,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=ce}getChannel(ie){const ce=this;return{call(Z,W,Y){return ce.a?Promise.reject(new A.$4):ce.m(ie,Z,W,Y)},listen(Z,W){return ce.a?f.Event.None:ce.o(ie,Z,W)}}}m(ie,ce,Z,W=H.CancellationToken.None){const Y=this.g++,q={id:Y,type:100,channelName:ie,name:ce,arg:Z};if(W.isCancellationRequested)return Promise.reject(new A.$4);let $;return new Promise((Q,p)=>{if(W.isCancellationRequested)return p(new A.$4);const E=()=>{const I=C=>{switch(C.type){case 201:this.f.delete(Y),Q(C.data);break;case 202:{this.f.delete(Y);const F=new Error(C.data.message);F.stack=Array.isArray(C.data.stack)?C.data.stack.join(`
`):C.data.stack,F.name=C.data.name,p(F);break}case 203:this.f.delete(Y),p(C.data);break}};this.f.set(Y,I),this.p(q)};let y=null;this.b===m.Idle?E():(y=(0,T.$Ig)(I=>this.u()),y.then(()=>{y=null,E()}));const M=()=>{y?(y.cancel(),y=null):this.p({id:Y,type:101}),p(new A.$4)},k=W.onCancellationRequested(M);$=(0,g.$Oc)((0,g.$Pc)(M),k),this.d.add($)}).finally(()=>{$.dispose(),this.d.delete($)})}o(ie,ce,Z){const W=this.g++,S={id:W,type:102,channelName:ie,name:ce,arg:Z};let q=null;const $=new f.$Od({onWillAddFirstListener:()=>{q=(0,T.$Ig)(Q=>this.u()),q.then(()=>{q=null,this.d.add($),this.p(S)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete($),this.p({id:W,type:103}))}}),U=Q=>$.fire(Q.data);return this.f.set(W,U),$.event}p(ie){switch(ie.type){case 100:case 102:{const ce=this.q([ie.type,ie.id,ie.channelName,ie.name],ie.arg);this.j?.logOutgoing(ce,ie.id,0,`${e(ie.type)}: ${ie.channelName}.${ie.name}`,ie.arg);return}case 101:case 103:{const ce=this.q([ie.type,ie.id]);this.j?.logOutgoing(ce,ie.id,0,e(ie.type));return}}}q(ie,ce=void 0){const Z=new l;return D(Z,ie),D(Z,ce),this.r(Z.buffer)}r(ie){try{return this.l.send(ie),ie.byteLength}catch{return 0}}s(ie){const ce=new u(ie),Z=B(ce),W=B(ce),Y=Z[0];switch(Y){case 200:return this.j?.logIncoming(ie.byteLength,0,0,a(Y)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ie.byteLength,Z[1],0,a(Y),W),this.t({type:Z[0],id:Z[1],data:W})}}t(ie){if(ie.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(ie.id)?.(ie)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}t.$vh=P,Ge([w.$kh],P.prototype,"onDidInitializePromise",null);class O{get connections(){const ie=[];return this.f.forEach(ce=>ie.push(ce)),ie}constructor(ie){this.a=new Map,this.f=new Set,this.g=new f.$Od,this.onDidAddConnection=this.g.event,this.h=new f.$Od,this.onDidRemoveConnection=this.h.event,this.j=new g.$Qc,this.j.add(ie(({protocol:ce,onDidClientDisconnect:Z})=>{const W=f.Event.once(ce.onMessage);this.j.add(W(Y=>{const S=new u(Y),q=B(S),$=new _(ce,q),U=new P(ce);this.a.forEach((p,E)=>$.registerChannel(E,p));const Q={channelServer:$,channelClient:U,ctx:q};this.f.add(Q),this.g.fire(Q),this.j.add(Z(()=>{$.dispose(),U.dispose(),this.f.delete(Q),this.h.fire(Q)}))}))}))}getChannel(ie,ce){const Z=this;return{call(W,Y,S){let q;if((0,s.$Nf)(ce)){const U=(0,v.$3b)(Z.connections.filter(ce));q=U?Promise.resolve(U):f.Event.toPromise(f.Event.filter(Z.onDidAddConnection,ce))}else q=ce.routeCall(Z,W,Y);const $=q.then(U=>U.channelClient.getChannel(ie));return te($).call(W,Y,S)},listen(W,Y){if((0,s.$Nf)(ce))return Z.k(ie,ce,W,Y);const S=ce.routeEvent(Z,W,Y).then(q=>q.channelClient.getChannel(ie));return te(S).listen(W,Y)}}}k(ie,ce,Z,W){const Y=this;let S;const q=new f.$Od({onWillAddFirstListener:()=>{S=new g.$Qc;const $=new f.$Ud,U=new Map,Q=E=>{const M=E.channelClient.getChannel(ie).listen(Z,W),k=$.add(M);U.set(E,k)},p=E=>{const y=U.get(E);y&&(y.dispose(),U.delete(E))};Y.connections.filter(ce).forEach(Q),f.Event.filter(Y.onDidAddConnection,ce)(Q,void 0,S),Y.onDidRemoveConnection(p,void 0,S),$.event(q.fire,q,S),S.add($)},onDidRemoveLastListener:()=>{S?.dispose(),S=void 0}});return q.event}registerChannel(ie,ce){this.a.set(ie,ce);for(const Z of this.f)Z.channelServer.registerChannel(ie,ce)}dispose(){this.j.dispose();for(const ie of this.f)ie.channelClient.dispose(),ie.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$wh=O;class K{constructor(ie,ce,Z=null){const W=new l;D(W,ce),ie.send(W.buffer),this.a=new P(ie,Z),this.d=new _(ie,ce,Z)}getChannel(ie){return this.a.getChannel(ie)}registerChannel(ie,ce){this.d.registerChannel(ie,ce)}dispose(){this.a.dispose(),this.d.dispose()}}t.$xh=K;function te(de){return{call(ie,ce,Z){return de.then(W=>W.call(ie,ce,Z))},listen(ie,ce){const Z=new f.$Xd;return de.then(W=>Z.input=W.listen(ie,ce)),Z.event}}}t.$yh=te;function se(de){let ie=!1;return{call(ce,Z,W){return ie?de.call(ce,Z,W):(0,T.$Vg)(0).then(()=>ie=!0).then(()=>de.call(ce,Z,W))},listen(ce,Z){if(ie)return de.listen(ce,Z);const W=new f.$Xd;return(0,T.$Vg)(0).then(()=>ie=!0).then(()=>W.input=de.listen(ce,Z)),W.event}}}t.$zh=se;class fe{constructor(ie){this.a=ie}routeCall(ie){return this.b(ie)}routeEvent(ie){return this.b(ie)}async b(ie){for(const ce of ie.connections)if(await Promise.resolve(this.a(ce.ctx)))return Promise.resolve(ce);return await f.Event.toPromise(ie.onDidAddConnection),await this.b(ie)}}t.$Ah=fe;var le;(function(de){function ie(Y,S,q){const $=Y,U=q&&q.disableMarshalling,Q=new Map;for(const p in $)Z(p)&&Q.set(p,f.Event.buffer($[p],!0,void 0,S));return new class{listen(p,E,y){const M=Q.get(E);if(M)return M;if(W(E)){const k=$[E];if(typeof k=="function")return k.call($,y)}throw new A.$ab(`Event not found: ${E}`)}call(p,E,y){const M=$[E];if(typeof M=="function"){if(!U&&Array.isArray(y))for(let I=0;I<y.length;I++)y[I]=(0,c.$ph)(y[I]);let k=M.apply($,y);return k instanceof Promise||(k=Promise.resolve(k)),k}throw new A.$ab(`Method not found: ${E}`)}}}de.fromService=ie;function ce(Y,S){const q=S&&S.disableMarshalling;return new Proxy({},{get($,U){if(typeof U=="string")return S?.properties?.has(U)?S.properties.get(U):W(U)?function(Q){return Y.listen(U,Q)}:Z(U)?Y.listen(U):async function(...Q){let p;S&&!(0,s.$If)(S.context)?p=[S.context,...Q]:p=Q;const E=await Y.call(U,p);return q?E:(0,c.$ph)(E)};throw new A.$ab(`Property not found: ${String(U)}`)}})}de.toService=ce;function Z(Y){return Y[0]==="o"&&Y[1]==="n"&&L.$2e(Y.charCodeAt(2))}function W(Y){return/^onDynamic/.test(Y)&&L.$2e(Y.charCodeAt(9))}})(le||(t.ProxyChannel=le={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function be(de){if(Array.isArray(de))return de;if(de&&typeof de=="object"&&typeof de.toString=="function"){const ie=de.toString();if(ie!=="[object Object]")return ie}return de}function Ce(de){return Array.isArray(de)?de.map(be):be(de)}function Ae(de,ie,ce,Z,W,Y,S){S=Ce(S);const q=oe[W],$=q[Z%q.length];let U=[`%c[${de}]%c[${String(ie).padStart(7," ")}]%c[len: ${String(ce).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(Y)?(U=U.concat(S),U.push(")")):U.push(S),console.log.apply(console,U)}class Pe{constructor(ie,ce){this.d=ie,this.f=ce,this.a=0,this.b=0}logOutgoing(ie,ce,Z,W,Y){this.b+=ie,Ae(this.d,this.b,ie,ce,Z,W,Y)}logIncoming(ie,ce,Z,W,Y){this.a+=ie,Ae(this.f,this.a,ie,ce,Z,W,Y)}}t.$Bh=Pe}),define($e[133],we([1,0,33,4,67,89,30]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZT=void 0;class A extends i.$xh{static f(){const g=T.Event.fromNodeEventEmitter(w.$N,"vscode:message",(c,L)=>v.$ce.wrap(L));return w.$N.send("vscode:hello"),new H.$VT(w.$N,g)}constructor(g){const c=A.f();super(c,g),this.b=c}dispose(){this.b.disconnect()}}t.$ZT=A}),define($e[134],we([13,10]),function(ae,t){return ae.create("vs/platform/files/common/files",t)}),define($e[135],we([13,10]),function(ae,t){return ae.create("vs/platform/theme/common/iconRegistry",t)}),define($e[40],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Th=t.$Sh=t.$Rh=t._util=void 0;var v;(function(w){w.serviceIds=new Map,w.DI_TARGET="$di$target",w.DI_DEPENDENCIES="$di$dependencies";function A(f){return f[w.DI_DEPENDENCIES]||[]}w.getServiceDependencies=A})(v||(t._util=v={})),t.$Rh=i("instantiationService");function T(w,A,f){A[v.DI_TARGET]===A?A[v.DI_DEPENDENCIES].push({id:w,index:f}):(A[v.DI_DEPENDENCIES]=[{id:w,index:f}],A[v.DI_TARGET]=A)}function i(w){if(v.serviceIds.has(w))return v.serviceIds.get(w);const A=function(f,g,c){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(A,f,c)};return A.toString=()=>w,v.serviceIds.set(w,A),A}t.$Sh=i;function H(w){return w}t.$Th=H}),define($e[136],we([1,0,40]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vm=t.$um=t.$tm=t.ID=void 0,t.ID="diagnosticsService",t.$tm=(0,v.$Sh)(t.ID);function T(H){return!!H.hostName&&!!H.errorMessage}t.$um=T;class i{async getPerformanceInfo(w,A){return{}}async getSystemInfo(w,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(w,A){return""}async getWorkspaceFileExtensions(w){return{extensions:[]}}async reportWorkspaceStats(w){}}t.$vm=i}),define($e[137],we([1,0,87,23,12,7,16,134,40,5,31,28]),function(ae,t,v,T,i,H,w,A,f,g,c,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kk=t.$Jk=t.$Ik=t.$Hk=t.$Gk=t.FileKind=t.$Fk=t.$Ek=t.$Dk=t.$Ck=t.$Bk=t.$Ak=t.$zk=t.FileOperationResult=t.$yk=t.$xk=t.$wk=t.$vk=t.$uk=t.FileChangeType=t.$tk=t.FileOperation=t.$sk=t.$rk=t.$qk=t.$pk=t.$ok=t.$nk=t.FileSystemProviderErrorCode=t.$mk=t.$lk=t.$kk=t.$jk=t.$ik=t.$hk=t.$gk=t.$fk=t.$ek=t.FileSystemProviderCapabilities=t.$dk=t.FilePermission=t.FileType=t.$ck=t.$bk=void 0,t.$bk=(0,f.$Sh)("fileService");function s(W){return W.create===!0}t.$ck=s;var h;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(h||(t.FileType=h={}));var e;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function o(W){const Y=W;return!!Y&&typeof Y.onDidChange=="function"}t.$dk=o;var a;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(a||(t.FileSystemProviderCapabilities=a={}));function m(W){return!!(W.capabilities&2)}t.$ek=m;function n(W){return!!(W.capabilities&8)}t.$fk=n;function r(W){return!!(W.capabilities&131072)}t.$gk=r;function b(W){return!!(W.capabilities&4)}t.$hk=b;function u(W){return!!(W.capabilities&16)}t.$ik=u;function l(W){return m(W)?!!(W.capabilities&16384):!1}t.$jk=l;function N(W){return m(W)?!!(W.capabilities&32768):!1}t.$kk=N;function z(W){return!!(W.capabilities&65536)}t.$lk=z;function R(W){return!!(W.capabilities&2048)}t.$mk=R;var d;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(d||(t.FileSystemProviderErrorCode=d={}));class D extends Error{static create(Y,S){const q=new D(Y.toString(),S);return x(q,S),q}constructor(Y,S){super(Y),this.code=S}}t.$nk=D;function B(W,Y){return D.create(W,Y)}t.$ok=B;function _(W){return W||B((0,A.localize)(0,null),d.Unknown)}t.$pk=_;function x(W,Y){return W.name=Y?`${Y} (FileSystemError)`:"FileSystemError",W}t.$qk=x;function P(W){if(!W)return d.Unknown;if(W instanceof D)return W.code;const Y=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!Y)return d.Unknown;switch(Y[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}t.$rk=P;function O(W){if(W instanceof oe)return W.fileOperationResult;switch(P(W)){case d.FileNotFound:return 1;case d.FileIsADirectory:return 0;case d.FileNotADirectory:return 9;case d.FileWriteLocked:return 5;case d.NoPermissions:return 6;case d.FileExists:return 4;case d.FileTooLarge:return 7;default:return 10}}t.$sk=O;var K;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(K||(t.FileOperation=K={}));class te{constructor(Y,S,q){this.resource=Y,this.operation=S,this.target=q}isOperation(Y){return this.operation===Y}}t.$tk=te;var se;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(se||(t.FileChangeType=se={}));class fe{static{this.a=null}constructor(Y,S){this.c=S,this.b=void 0,this.d=new L.$U(()=>{const q=v.$Yh.forUris(()=>this.c);return q.fill(this.rawAdded.map($=>[$,!0])),q}),this.f=new L.$U(()=>{const q=v.$Yh.forUris(()=>this.c);return q.fill(this.rawUpdated.map($=>[$,!0])),q}),this.g=new L.$U(()=>{const q=v.$Yh.forUris(()=>this.c);return q.fill(this.rawDeleted.map($=>[$,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of Y){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==fe.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=fe.a):this.b!==void 0&&(this.b=fe.a))}}contains(Y,...S){return this.h(Y,{includeChildren:!1},...S)}affects(Y,...S){return this.h(Y,{includeChildren:!0},...S)}h(Y,S,...q){if(!Y)return!1;const $=q.length>0;return!!((!$||q.includes(1))&&(this.d.value.get(Y)||S.includeChildren&&this.d.value.findSuperstr(Y))||(!$||q.includes(0))&&(this.f.value.get(Y)||S.includeChildren&&this.f.value.findSuperstr(Y))||(!$||q.includes(2))&&(this.g.value.findSubstr(Y)||S.includeChildren&&this.g.value.findSuperstr(Y)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Y){return this.b===Y}hasCorrelation(){return typeof this.b=="number"}}t.$uk=fe;function le(W,Y,S){return!W||!Y||W===Y||Y.length>W.length?!1:(Y.charAt(Y.length-1)!==T.sep&&(Y+=T.sep),S?(0,i.$4e)(W,Y):W.indexOf(Y)===0)}t.$vk=le;class oe extends Error{constructor(Y,S,q){super(Y),this.fileOperationResult=S,this.options=q}}t.$wk=oe;class be extends oe{constructor(Y,S,q,$){super(Y,S,$),this.fileOperationResult=S,this.size=q}}t.$xk=be;class Ce extends oe{constructor(Y,S,q){super(Y,2,q),this.stat=S}}t.$yk=Ce;var Ae;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Ae||(t.FileOperationResult=Ae={})),t.$zk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$Ak={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$Bk="files.associations",t.$Ck="files.exclude",t.$Dk="files.readonlyInclude",t.$Ek="files.readonlyExclude",t.$Fk="files.readonlyFromPermissions";var Pe;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(Pe||(t.FileKind=Pe={})),t.$Gk="";function de(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}t.$Hk=de;async function ie(W,Y){if(!Y.hasProvider(w.URI.from({scheme:W.scheme})))return new Promise(S=>{const q=Y.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===W.scheme&&$.added&&(q.dispose(),S())})})}t.$Ik=ie;class ce{static{this.KB=1024}static{this.MB=ce.KB*ce.KB}static{this.GB=ce.MB*ce.KB}static{this.TB=ce.GB*ce.KB}static formatSize(Y){return(0,H.$Df)(Y)||(Y=0),Y<ce.KB?(0,A.localize)(1,null,Y.toFixed(0)):Y<ce.MB?(0,A.localize)(2,null,(Y/ce.KB).toFixed(2)):Y<ce.GB?(0,A.localize)(3,null,(Y/ce.MB).toFixed(2)):Y<ce.TB?(0,A.localize)(4,null,(Y/ce.GB).toFixed(2)):(0,A.localize)(5,null,(Y/ce.TB).toFixed(2))}}t.$Jk=ce;function Z(W){const Y=typeof W=="string"||W?.scheme===c.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===c.Schemas.file?1024*ce.MB:Y?10*ce.MB:g.$o?50*ce.MB:1024*ce.MB}t.$Kk=Z}),define($e[138],we([1,0,40]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$o9b=t.$n9b=void 0,t.$n9b=(0,v.$Sh)("mainProcessService");class T{constructor(H,w){this.a=H,this.b=w}getChannel(H){return this.a.getChannel(H,this.b)}registerChannel(H,w){this.a.registerChannel(H,w)}}t.$o9b=T}),define($e[139],we([1,0,2,133]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$p9b=void 0;class i extends v.$Rc{constructor(w){super(),this.a=this.B(new T.$ZT(`window:${w}`))}getChannel(w){return this.a.getChannel(w)}registerChannel(w,A){this.a.registerChannel(w,A)}}t.$p9b=i});var Ei=this&&this.__param||function(ae,t){return function(v,T){t(v,T,ae)}};define($e[140],we([1,0,67,138]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$t9b=void 0;let i=class{constructor(w,A){return this.windowId=w,v.ProxyChannel.toService(A.getChannel("nativeHost"),{context:w,properties:(()=>{const f=new Map;return f.set("windowId",w),f})()})}};t.$t9b=i,t.$t9b=i=Ge([Ei(1,T.$n9b)],i)}),define($e[68],we([1,0,76,7]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jn=void 0;class i{constructor(){this.a=new Map}add(w,A){v.ok(T.$zf(w)),v.ok(T.$Bf(A)),v.ok(!this.a.has(w),"There is already an extension with this id"),this.a.set(w,A)}knows(w){return this.a.has(w)}as(w){return this.a.get(w)||null}}t.$jn=new i}),define($e[141],we([1,0,4,68]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kn=void 0,t.$kn={JSONContribution:"base.contributions.json"};function i(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class H{constructor(){this.b=new v.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,g){this.a[i(f)]=g,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const w=new H;T.$jn.add(t.$kn.JSONContribution,w)}),define($e[142],we([1,0,9,18,19,4,7,16,135,141,68]),function(ae,t,v,T,i,H,w,A,f,g,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dw=t.$cw=t.$bw=t.$aw=t.$_v=t.$$v=t.$0v=t.$9v=t.IconFontDefinition=t.IconContribution=t.$8v=void 0,t.$8v={IconContribution:"base.contributions.icons"};var L;(function(b){function u(l,N){let z=l.defaults;for(;i.ThemeIcon.isThemeIcon(z);){const R=e.getIcon(z.id);if(!R)return;z=R.defaults}return z}b.getDefinition=u})(L||(t.IconContribution=L={}));var s;(function(b){function u(N){return{weight:N.weight,style:N.style,src:N.src.map(z=>({format:z.format,location:z.location.toString()}))}}b.toJSONObject=u;function l(N){const z=R=>(0,w.$zf)(R)?R:void 0;if(N&&Array.isArray(N.src)&&N.src.every(R=>(0,w.$zf)(R.format)&&(0,w.$zf)(R.location)))return{weight:z(N.weight),style:z(N.style),src:N.src.map(R=>({format:R.format,location:A.URI.parse(R.location)}))}}b.fromJSONObject=l})(s||(t.IconFontDefinition=s={}));class h{constructor(){this.a=new H.$Od,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,f.localize)(0,null)},fontCharacter:{type:"string",description:(0,f.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(u,l,N,z){const R=this.b[u];if(R){if(N&&!R.description){R.description=N,this.d.properties[u].markdownDescription=`${N} $(${u})`;const B=this.e.enum.indexOf(u);B!==-1&&(this.e.enumDescriptions[B]=N),this.a.fire()}return R}const d={id:u,description:N,defaults:l,deprecationMessage:z};this.b[u]=d;const D={$ref:"#/definitions/icons"};return z&&(D.deprecationMessage=z),N&&(D.markdownDescription=`${N}: $(${u})`),this.d.properties[u]=D,this.e.enum.push(u),this.e.enumDescriptions.push(N||""),this.a.fire(),{id:u}}deregisterIcon(u){delete this.b[u],delete this.d.properties[u];const l=this.e.enum.indexOf(u);l!==-1&&(this.e.enum.splice(l,1),this.e.enumDescriptions.splice(l,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(u=>this.b[u])}getIcon(u){return this.b[u]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(u,l){const N=this.f[u];return N||(this.f[u]=l,this.a.fire(),l)}deregisterIconFont(u){delete this.f[u]}getIconFont(u){return this.f[u]}toString(){const u=(R,d)=>R.id.localeCompare(d.id),l=R=>{for(;i.ThemeIcon.isThemeIcon(R.defaults);)R=this.b[R.defaults.id];return`codicon codicon-${R?R.id:""}`},N=[];N.push("| preview     | identifier                        | default codicon ID                | description"),N.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const z=Object.keys(this.b).map(R=>this.b[R]);for(const R of z.filter(d=>!!d.description).sort(u))N.push(`|<i class="${l(R)}"></i>|${R.id}|${i.ThemeIcon.isThemeIcon(R.defaults)?R.defaults.id:R.id}|${R.description||""}|`);N.push("| preview     | identifier                        "),N.push("| ----------- | --------------------------------- |");for(const R of z.filter(d=>!i.ThemeIcon.isThemeIcon(d.defaults)).sort(u))N.push(`|<i class="${l(R)}"></i>|${R.id}|`);return N.join(`
`)}}const e=new h;c.$jn.add(t.$8v.IconContribution,e);function o(b,u,l,N){return e.registerIcon(b,u,l,N)}t.$9v=o;function a(){return e}t.$0v=a;function m(){const b=(0,T.$Vj)();for(const u in b){const l="\\"+b[u].toString(16);e.registerIcon(u,{fontCharacter:l})}}m(),t.$$v="vscode://schemas/icons";const n=c.$jn.as(g.$kn.JSONContribution);n.registerSchema(t.$$v,e.getIconSchema());const r=new v.$7g(()=>n.notifySchemaChanged(t.$$v),200);e.onDidChange(()=>{r.isScheduled()||r.schedule()}),t.$_v=o("widget-close",T.$Xj.close,(0,f.localize)(2,null)),t.$aw=o("goto-previous-location",T.$Xj.arrowUp,(0,f.localize)(3,null)),t.$bw=o("goto-next-location",T.$Xj.arrowDown,(0,f.localize)(4,null)),t.$cw=i.ThemeIcon.modify(T.$Xj.sync,"spin"),t.$dw=i.ThemeIcon.modify(T.$Xj.loading,"spin")}),define($e[143],we([1,0,3,4,2,19,142]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mDb=t.$lDb=void 0;function A(g){const c=new i.$Qc,L=c.add(new T.$Od),s=(0,w.$0v)();return c.add(s.onDidChange(()=>L.fire())),g&&c.add(g.onDidProductIconThemeChange(()=>L.fire())),{dispose:()=>c.dispose(),onDidChange:L.event,getCSS(){const h=g?g.getProductIconTheme():new f,e={},o=m=>{const n=h.getIcon(m);if(!n)return;const r=n.font;return r?(e[r.id]=r.definition,`.codicon-${m.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,v.$cQ)(r.id)}; }`):`.codicon-${m.id}:before { content: '${n.fontCharacter}'; }`},a=[];for(const m of s.getIcons()){const n=o(m);n&&a.push(n)}for(const m in e){const n=e[m],r=n.weight?`font-weight: ${n.weight};`:"",b=n.style?`font-style: ${n.style};`:"",u=n.src.map(l=>`${(0,v.$bQ)(l.location)} format('${l.format}')`).join(", ");a.push(`@font-face { src: ${u}; font-family: ${(0,v.$cQ)(m)};${r}${b} font-display: block; }`)}return a.join(`
`)}}}t.$lDb=A;class f{getIcon(c){const L=(0,w.$0v)();let s=c.defaults;for(;H.ThemeIcon.isThemeIcon(s);){const h=L.getIcon(s.id);if(!h)return;s=h.defaults}return s}}t.$mDb=f}),define($e[144],we([1,0,5]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qC=t.$pC=t.$oC=t.$nC=t.$mC=t.$lC=t.$kC=t.$jC=t.$iC=void 0,t.$iC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function T(L){return typeof L.parentId=="number"}t.$jC=T;function i(L){return!!L.workspaceUri}t.$kC=i;function H(L){return!!L.folderUri}t.$lC=H;function w(L){return!!L.fileUri}t.$mC=w;function A(L){const s=f(L),h=L.getValue("window.menuBarVisibility");return h==="default"||s==="native"&&h==="compact"||v.$j&&v.$m?"classic":h}t.$nC=A;function f(L){if(v.$o)return"custom";const s=L.getValue("window");if(s){if(v.$j&&s.nativeTabs===!0||v.$j&&s.nativeFullScreen===!1)return"native";const o=s.titleBarStyle;if(o==="native"||o==="custom")return o}return v.$k?"native":"custom"}t.$oC=f;function g(L){return!(!v.$i||v.$o||f(L)==="native")}t.$pC=g;function c(L=0){return Math.pow(1.2,L)}t.$qC=c}),define($e[145],we([1,0,17,3,14,30,144]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$x9b=t.$w9b=t.$v9b=void 0;function A(L){for(const{window:s}of(0,T.getWindows)())f(s)?.webFrame?.setZoomLevel(L);(0,v.$zO)((0,w.$qC)(L)),(0,v.$wO)(L)}t.$v9b=A;function f(L){if(L===i.$rO)return{ipcRenderer:H.$N,webFrame:H.$P};{const s=L;if(s?.vscode?.ipcRenderer&&s?.vscode?.webFrame)return s.vscode}}function g(){A((0,v.$xO)()+1)}t.$w9b=g;function c(){A((0,v.$xO)()-1)}t.$x9b=c}),define($e[146],we([1,0,10,3,132,9,90,30,136,137,139,140,143,145,15,14,103,94]),function(ae,t,v,T,i,H,w,A,f,g,c,L,s,h,e,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const a=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,m=/\s--inspect-port=(?<port>\d+)/;class n{getHeight(P){return 22}getTemplateId(P){return d(P)?"process":z(P)?"machine":(0,f.$um)(P)?"error":R(P)?"header":""}}class r{hasChildren(P){return(0,f.$um)(P)?!1:d(P)?!!P.children?.length:!0}getChildren(P){return d(P)?P.children?P.children:[]:(0,f.$um)(P)?[]:R(P)?P.processRoots.length>1?P.processRoots:[P.processRoots[0].rootProcess]:z(P)?[P.rootProcess]:[P.processes]}}class b{constructor(){this.templateId="header"}renderTemplate(P){const O=(0,T.$XP)(P,(0,T.$)(".row")),K=(0,T.$XP)(O,(0,T.$)(".nameLabel")),te=(0,T.$XP)(O,(0,T.$)(".cpu")),se=(0,T.$XP)(O,(0,T.$)(".memory")),fe=(0,T.$XP)(O,(0,T.$)(".pid"));return{name:K,CPU:te,memory:se,PID:fe}}renderElement(P,O,K,te){K.name.textContent=(0,v.localize)(0,null),K.CPU.textContent=(0,v.localize)(1,null),K.PID.textContent=(0,v.localize)(2,null),K.memory.textContent=(0,v.localize)(3,null)}disposeTemplate(P){}}class u{constructor(){this.templateId="machine"}renderTemplate(P){const O=Object.create(null),K=(0,T.$XP)(P,(0,T.$)(".row"));return O.name=(0,T.$XP)(K,(0,T.$)(".nameLabel")),O}renderElement(P,O,K,te){K.name.textContent=P.element.name}disposeTemplate(P){}}class l{constructor(){this.templateId="error"}renderTemplate(P){const O=Object.create(null),K=(0,T.$XP)(P,(0,T.$)(".row"));return O.name=(0,T.$XP)(K,(0,T.$)(".nameLabel")),O}renderElement(P,O,K,te){K.name.textContent=P.element.errorMessage}disposeTemplate(P){}}class N{constructor(P,O,K){this.a=P,this.b=O,this.c=K,this.templateId="process"}renderTemplate(P){const O=(0,T.$XP)(P,(0,T.$)(".row")),K=(0,T.$XP)(O,(0,T.$)(".nameLabel")),te=(0,T.$XP)(O,(0,T.$)(".cpu")),se=(0,T.$XP)(O,(0,T.$)(".memory")),fe=(0,T.$XP)(O,(0,T.$)(".pid"));return{name:K,CPU:te,PID:fe,memory:se}}renderElement(P,O,K,te){const{element:se}=P,fe=se.pid.toFixed(0);let le=se.name;this.c.has(se.pid)&&(le=this.c.get(se.pid)),K.name.textContent=le,K.name.title=se.cmd,K.CPU.textContent=se.load.toFixed(0),K.PID.textContent=fe,K.PID.parentElement.id=`pid-${fe}`;const oe=this.a==="win32"?se.mem:this.b*(se.mem/100);K.memory.textContent=(oe/g.$Jk.MB).toFixed(0)}disposeTemplate(P){}}function z(x){return!!x.name&&!!x.rootProcess}function R(x){return!!x.processRoots}function d(x){return!!x.pid}class D{constructor(P,O){this.f=O,this.b=new Map;const K=new c.$p9b(P);this.c=new L.$t9b(P,K),this.k(O.styles),this.g(O),A.$N.on("vscode:pidToNameResponse",(te,se)=>{this.b=new Map;for(const[fe,le]of se)this.b.set(fe,le)}),A.$N.on("vscode:listProcessesResponse",async(te,se)=>{se.forEach((fe,le)=>{d(fe.rootProcess)&&(fe.rootProcess.name=le===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:se}}),this.d.layout(o.$rO.innerHeight,o.$rO.innerWidth)):await this.h(se),this.m(0)}),this.a=Date.now(),A.$N.send("vscode:pidToNameRequest"),A.$N.send("vscode:listProcesses")}g(P){o.$rO.document.onkeydown=O=>{const K=P.platform==="darwin"?O.metaKey:O.ctrlKey;K&&O.keyCode===87&&(O.stopPropagation(),O.preventDefault(),A.$N.send("vscode:closeProcessExplorer")),K&&O.keyCode===187&&(0,h.$w9b)(),K&&O.keyCode===189&&(0,h.$x9b)()}}async h(P){const O=o.$rO.document.getElementById("process-list");if(!O)return;const{totalmem:K}=await this.c.getOSStatistics(),te=[new N(this.f.platform,K,this.b),new b,new u,new l];this.d=new i.$gT("processExplorer",O,new n,te,new r,{identityProvider:{getId:se=>d(se)?se.pid.toString():(0,f.$um)(se)?se.hostName:R(se)?"processes":z(se)?se.name:"header"}}),this.d.setInput({processes:{processRoots:P}}),this.d.layout(o.$rO.innerHeight,o.$rO.innerWidth),this.d.onKeyDown(se=>{const fe=new e.$UO(se);if(fe.keyCode===35&&fe.altKey){const le=this.n();Promise.all(le.map(oe=>this.c.killProcess(oe,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(se=>{d(se.element)&&this.l(se.element,!0)}),O.style.height=`${o.$rO.innerHeight}px`,o.$rO.addEventListener("resize",()=>{O.style.height=`${o.$rO.innerHeight}px`,this.d?.layout(o.$rO.innerHeight,o.$rO.innerWidth)})}i(P){const O=a.exec(P);return O&&O.groups.port!=="0"||P.indexOf("node ")>=0||P.indexOf("node.exe")>=0}j(P){const O={type:"node",request:"attach",name:`process ${P.pid}`};let K=a.exec(P.cmd);K?O.port=Number(K.groups.port):O.processId=String(P.pid),K=m.exec(P.cmd),K&&(O.port=Number(K.groups.port)),A.$N.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[O]})}k(P){const O=(0,T.$GP)(),K=[];P.listFocusBackground&&(K.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${P.listFocusBackground}; }`),K.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${P.listFocusBackground}; }`)),P.listFocusForeground&&K.push(`.monaco-list:focus .monaco-list-row.focused { color: ${P.listFocusForeground}; }`),P.listActiveSelectionBackground&&(K.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${P.listActiveSelectionBackground}; }`),K.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${P.listActiveSelectionBackground}; }`)),P.listActiveSelectionForeground&&K.push(`.monaco-list:focus .monaco-list-row.selected { color: ${P.listActiveSelectionForeground}; }`),P.listHoverBackground&&K.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${P.listHoverBackground}; }`),P.listHoverForeground&&K.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${P.listHoverForeground}; }`),P.listFocusOutline&&K.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${P.listFocusOutline}; outline-offset: -1px; }`),P.listHoverOutline&&K.push(`.monaco-list-row:hover { outline: 1px dashed ${P.listHoverOutline}; outline-offset: -1px; }`),P.scrollbarShadowColor&&K.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${P.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${P.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${P.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),P.scrollbarSliderBackgroundColor&&K.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${P.scrollbarSliderBackgroundColor};
				}
			`),P.scrollbarSliderHoverBackgroundColor&&K.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${P.scrollbarSliderHoverBackgroundColor};
				}
			`),P.scrollbarSliderActiveBackgroundColor&&K.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${P.scrollbarSliderActiveBackgroundColor};
				}
			`),O.textContent=K.join(`
`),P.color&&(o.$rO.document.body.style.color=P.color)}l(P,O){const K=[],te=Number(P.pid);O&&(K.push({accelerator:"Alt+E",label:(0,v.localize)(4,null),click:()=>{this.c.killProcess(te,"SIGTERM")}}),K.push({label:(0,v.localize)(5,null),click:()=>{this.c.killProcess(te,"SIGKILL")}}),K.push({type:"separator"})),K.push({label:(0,v.localize)(6,null),click:()=>{const se=this.n();se?.includes(te)||(se.length=0,se.push(te));const fe=se?.map(le=>o.$rO.document.getElementById(`pid-${le}`)).filter(le=>!!le);if(fe){const le=fe.map(oe=>oe.innerText).filter(oe=>!!oe);this.c.writeClipboardText(le.join(`
`))}}}),K.push({label:(0,v.localize)(7,null),click:()=>{const se=o.$rO.document.getElementById("process-list");se&&this.c.writeClipboardText(se.innerText)}}),P&&O&&this.i(P.cmd)&&(K.push({type:"separator"}),K.push({label:(0,v.localize)(8,null),click:()=>{this.j(P)}})),(0,w.$RT)(K)}m(P){setTimeout(()=>{const O=Date.now(),K=P+O-this.a;this.a=O,K>1e3?(A.$N.send("vscode:pidToNameRequest"),A.$N.send("vscode:listProcesses")):this.m(K)},200)}n(){return this.d?.getSelection()?.map(P=>{if(!(!P||!("pid"in P)))return P.pid}).filter(P=>!!P)}}function B(){const x=(0,T.$GP)();x.id="codiconStyles";const P=(0,s.$lDb)(void 0);function O(){x.textContent=P.getCSS()}const K=new H.$7g(O,0);P.onDidChange(()=>K.schedule()),K.schedule()}function _(x){const P=x.data.platform==="win32"?"windows":x.data.platform==="linux"?"linux":"mac";o.$rO.document.body.classList.add(P),B(),(0,h.$v9b)(x.data.zoomLevel),new D(x.windowId,x.data)}t.startup=_})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8d99999f3f8664f290bb4b98f99603b4c4e545d2/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
