/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ce=function(ie){for(var e=[],I=0,A=ie.length;I<A;I++)e[I]=ae[ie[I]];return e};define(ae[123],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class I{static get(){const L=new Map,j=new Map,O=new Map,R=new Map;function S(l,g){l.has(g.detail)||l.set(g.detail,-g.timestamp)}function d(l,g){const y=l.get(g.detail);y&&(y>=0||l.set(g.detail,y+g.timestamp))}let C=[];typeof ie=="function"&&typeof ie.getStats=="function"&&(C=ie.getStats().slice(0).sort((l,g)=>l.timestamp-g.timestamp));for(const l of C)switch(l.type){case 10:S(L,l);break;case 11:case 12:d(L,l);break;case 21:S(j,l);break;case 22:d(j,l);break;case 33:S(O,l);break;case 34:d(O,l);break;case 31:S(R,l);break;case 32:d(R,l);break}let E=0;O.forEach(l=>E+=l);function w(l){const g=[];return l.forEach((y,p)=>g.push([p,y])),g}return{amdLoad:w(L),amdInvoke:w(j),nodeRequire:w(O),nodeEval:w(R),nodeRequireTotal:E}}static toMarkdownTable(L,j){let O="";const R=[];return L.forEach((S,d)=>{R[d]=S.length}),j.forEach(S=>{S.forEach((d,C)=>{typeof d>"u"&&(d=S[C]="-");const E=d.toString().length;R[C]=Math.max(E,R[C])})}),L.forEach((S,d)=>{O+=`| ${S+" ".repeat(R[d]-S.toString().length)} `}),O+=`|
`,L.forEach((S,d)=>{O+=`| ${"-".repeat(R[d])} `}),O+=`|
`,j.forEach(S=>{S.forEach((d,C)=>{typeof d<"u"&&(O+=`| ${d+" ".repeat(R[C]-d.toString().length)} `)}),O+=`|
`}),O}}e.$T=I}),define(ae[124],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function I(y,p,c){const f=A(y,p);if(f!==-1)return y[f]}e.$eb=I;function A(y,p,c=y.length-1){for(let f=c;f>=0;f--){const u=y[f];if(p(u))return f}return-1}e.$fb=A;function L(y,p){const c=j(y,p);return c===-1?void 0:y[c]}e.$gb=L;function j(y,p,c=0,f=y.length){let u=c,b=f;for(;u<b;){const k=Math.floor((u+b)/2);p(y[k])?u=k+1:b=k}return u-1}e.$hb=j;function O(y,p){const c=R(y,p);return c===y.length?void 0:y[c]}e.$ib=O;function R(y,p,c=0,f=y.length){let u=c,b=f;for(;u<b;){const k=Math.floor((u+b)/2);p(y[k])?b=k:u=k+1}return u}e.$jb=R;function S(y,p,c=0,f=y.length){const u=R(y,p,c,f);return u===y.length?-1:u}e.$kb=S;class d{static{this.assertInvariants=!1}constructor(p){this.e=p,this.c=0}findLastMonotonous(p){if(d.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!p(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=p}const c=j(this.e,p,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$lb=d;function C(y,p){if(y.length===0)return;let c=y[0];for(let f=1;f<y.length;f++){const u=y[f];p(u,c)>0&&(c=u)}return c}e.$mb=C;function E(y,p){if(y.length===0)return;let c=y[0];for(let f=1;f<y.length;f++){const u=y[f];p(u,c)>=0&&(c=u)}return c}e.$nb=E;function w(y,p){return C(y,(c,f)=>-p(c,f))}e.$ob=w;function l(y,p){if(y.length===0)return-1;let c=0;for(let f=1;f<y.length;f++){const u=y[f];p(u,y[c])>0&&(c=f)}return c}e.$pb=l;function g(y,p){for(const c of y){const f=p(c);if(f!==void 0)return f}}e.$qb=g}),define(ae[125],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function I(O,R){const S=Object.create(null);for(const d of O){const C=R(d);let E=S[C];E||(E=S[C]=[]),E.push(d)}return S}e.$J=I;function A(O,R){const S=[],d=[];for(const C of O)R.has(C)||S.push(C);for(const C of R)O.has(C)||d.push(C);return{removed:S,added:d}}e.$K=A;function L(O,R){const S=[],d=[];for(const[C,E]of O)R.has(C)||S.push(E);for(const[C,E]of R)O.has(C)||d.push(E);return{removed:S,added:d}}e.$L=L;function j(O,R){const S=new Set;for(const d of R)O.has(d)&&S.add(d);return S}e.$M=j}),define(ae[84],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function I(O){return(R,S,d)=>{let C=null,E=null;if(typeof d.value=="function"?(C="value",E=d.value):typeof d.get=="function"&&(C="get",E=d.get),!E)throw new Error("not supported");d[C]=O(E,S)}}function A(O,R,S){let d=null,C=null;if(typeof S.value=="function"?(d="value",C=S.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(d="get",C=S.get),!C)throw new Error("not supported");const E=`$memoize$${R}`;S[d]=function(...w){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,w)}),this[E]}}e.$kh=A;function L(O,R,S){return I((d,C)=>{const E=`$debounce$${C}`,w=`$debounce$result$${C}`;return function(...l){this[w]||(this[w]=S?S():void 0),clearTimeout(this[E]),R&&(this[w]=R(this[w],...l),l=[this[w]]),this[E]=setTimeout(()=>{d.apply(this,l),this[w]=S?S():void 0},O)}})}e.$lh=L;function j(O,R,S){return I((d,C)=>{const E=`$throttle$timer$${C}`,w=`$throttle$result$${C}`,l=`$throttle$lastRun$${C}`,g=`$throttle$pending$${C}`;return function(...y){if(this[w]||(this[w]=S?S():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),R&&(this[w]=R(this[w],...y)),this[g])return;const p=this[l]+O;p<=Date.now()?(this[l]=Date.now(),d.apply(this,[this[w]]),this[w]=S?S():void 0):(this[g]=!0,this[E]=setTimeout(()=>{this[g]=!1,this[l]=Date.now(),d.apply(this,[this[w]]),this[w]=S?S():void 0},p-Date.now()))}})}e.$mh=j}),define(ae[7],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class I{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?u.isErrorNoTelemetry(s)?new u(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(a=>{a(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.$V=I,e.$W=new I;function A(k){e.$W.setUnexpectedErrorHandler(k)}e.setUnexpectedErrorHandler=A;function L(k){if(!k||typeof k!="object")return!1;const s=k;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.$Y=L;function j(k){d(k)||e.$W.onUnexpectedError(k)}e.$Z=j;function O(k){d(k)||e.$W.onUnexpectedExternalError(k)}e.$1=O;function R(k){if(k instanceof Error){const{name:s,message:a}=k,n=k.stacktrace||k.stack;return{$isError:!0,name:s,message:a,stack:n,noTelemetry:u.isErrorNoTelemetry(k)}}return k}e.$2=R;const S="Canceled";function d(k){return k instanceof C?!0:k instanceof Error&&k.name===S&&k.message===S}e.$3=d;class C extends Error{constructor(){super(S),this.name=this.message}}e.$4=C;function E(){const k=new Error(S);return k.name=k.message,k}e.$5=E;function w(k){return k?new Error(`Illegal argument: ${k}`):new Error("Illegal argument")}e.$6=w;function l(k){return k?new Error(`Illegal state: ${k}`):new Error("Illegal state")}e.$7=l;class g extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=g;function y(k){return k?k.message?k.message:k.stack?k.stack.split(`
`)[0]:String(k):"Error"}e.$9=y;class p extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.$0=p;class c extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.$$=c;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=f;class u extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof u)return s;const a=new u;return a.message=s.message,a.stack=s.stack,a}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.$ab=u;class b extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}e.$bb=b}),define(ae[18],ce([0,1,7,124]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function L(N,V=0){return N[N.length-(1+V)]}e.$rb=L;function j(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.$sb=j;function O(N,V,G=(te,oe)=>te===oe){if(N===V)return!0;if(!N||!V||N.length!==V.length)return!1;for(let te=0,oe=N.length;te<oe;te++)if(!G(N[te],V[te]))return!1;return!0}e.$tb=O;function R(N,V){const G=N.length-1;V<G&&(N[V]=N[G]),N.pop()}e.$ub=R;function S(N,V,G){return d(N.length,te=>G(N[te],V))}e.$vb=S;function d(N,V){let G=0,te=N-1;for(;G<=te;){const oe=(G+te)/2|0,ue=V(oe);if(ue<0)G=oe+1;else if(ue>0)te=oe-1;else return oe}return-(G+1)}e.$wb=d;function C(N,V,G){if(N=N|0,N>=V.length)throw new TypeError("invalid index");const te=V[Math.floor(V.length*Math.random())],oe=[],ue=[],he=[];for(const ge of V){const de=G(ge,te);de<0?oe.push(ge):de>0?ue.push(ge):he.push(ge)}return N<oe.length?C(N,oe,G):N<oe.length+he.length?he[0]:C(N-(oe.length+he.length),ue,G)}e.$xb=C;function E(N,V){const G=[];let te;for(const oe of N.slice(0).sort(V))!te||V(te[0],oe)!==0?(te=[oe],G.push(te)):te.push(oe);return G}e.$yb=E;function*w(N,V){let G,te;for(const oe of N)te!==void 0&&V(te,oe)?G.push(oe):(G&&(yield G),G=[oe]),te=oe;G&&(yield G)}e.$zb=w;function l(N,V){for(let G=0;G<=N.length;G++)V(G===0?void 0:N[G-1],G===N.length?void 0:N[G])}e.$Ab=l;function g(N,V){for(let G=0;G<N.length;G++)V(G===0?void 0:N[G-1],N[G],G+1===N.length?void 0:N[G+1])}e.$Bb=g;function y(N,V,G){const te=[];function oe(ge,de,we){if(de===0&&we.length===0)return;const ve=te[te.length-1];ve&&ve.start+ve.deleteCount===ge?(ve.deleteCount+=de,ve.toInsert.push(...we)):te.push({start:ge,deleteCount:de,toInsert:we})}let ue=0,he=0;for(;;){if(ue===N.length){oe(ue,0,V.slice(he));break}if(he===V.length){oe(ue,N.length-ue,[]);break}const ge=N[ue],de=V[he],we=G(ge,de);we===0?(ue+=1,he+=1):we<0?(oe(ue,1,[]),ue+=1):we>0&&(oe(ue,0,[de]),he+=1)}return te}e.$Cb=y;function p(N,V,G){const te=y(N,V,G),oe=[],ue=[];for(const he of te)oe.push(...N.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:oe,added:ue}}e.$Db=p;function c(N,V,G){if(G===0)return[];const te=N.slice(0,G).sort(V);return u(N,V,te,G,N.length),te}e.top=c;function f(N,V,G,te,oe){return G===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const ge=N.length,de=N.slice(0,G).sort(V);for(let we=G,ve=Math.min(G+te,ge);we<ge;we=ve,ve=Math.min(ve+te,ge)){if(we>G&&await new Promise(Oe=>setTimeout(Oe)),oe&&oe.isCancellationRequested)throw new I.$4;u(N,V,de,we,ve)}return de})().then(ue,he)})}e.$Fb=f;function u(N,V,G,te,oe){for(const ue=G.length;te<oe;te++){const he=N[te];if(V(he,G[ue-1])<0){G.pop();const ge=(0,A.$jb)(G,de=>V(he,de)<0);G.splice(ge,0,he)}}}function b(N){return N.filter(V=>!!V)}e.$Gb=b;function k(N){let V=0;for(let G=0;G<N.length;G++)N[G]&&(N[V]=N[G],V+=1);N.length=V}e.$Hb=k;function s(N,V,G){N.splice(G,0,N.splice(V,1)[0])}e.$Ib=s;function a(N){return!Array.isArray(N)||N.length===0}e.$Jb=a;function n(N){return Array.isArray(N)&&N.length>0}e.$Kb=n;function i(N,V=G=>G){const G=new Set;return N.filter(te=>{const oe=V(te);return G.has(oe)?!1:(G.add(oe),!0)})}e.$Lb=i;function t(N){const V=new Set;return G=>{const te=N(G);return V.has(te)?!1:(V.add(te),!0)}}e.$Mb=t;function r(N,V){return N.length>0?N[0]:V}e.$Nb=r;function o(N,V){return N.length>0?N[N.length-1]:V}e.$Ob=o;function v(N,V,G=(te,oe)=>te===oe){let te=0;for(let oe=0,ue=Math.min(N.length,V.length);oe<ue&&G(N[oe],V[oe]);oe++)te++;return te}e.$Pb=v;function m(N){return[].concat(...N)}e.$Qb=m;function h(N,V){let G=typeof V=="number"?N:0;typeof V=="number"?G=N:(G=0,V=N);const te=[];if(G<=V)for(let oe=G;oe<V;oe++)te.push(oe);else for(let oe=G;oe>V;oe--)te.push(oe);return te}e.$Rb=h;function $(N,V,G){return N.reduce((te,oe)=>(te[V(oe)]=G?G(oe):oe,te),Object.create(null))}e.$Sb=$;function D(N,V){return N.push(V),()=>F(N,V)}e.$Tb=D;function F(N,V){const G=N.indexOf(V);if(G>-1)return N.splice(G,1),V}e.$Ub=F;function M(N,V,G){const te=N.slice(0,V),oe=N.slice(V);return te.concat(G,oe)}e.$Vb=M;function U(N,V){let G;if(typeof V=="number"){let te=V;G=()=>{const oe=Math.sin(te++)*179426549;return oe-Math.floor(oe)}}else G=Math.random;for(let te=N.length-1;te>0;te-=1){const oe=Math.floor(G()*(te+1)),ue=N[te];N[te]=N[oe],N[oe]=ue}}e.$Wb=U;function q(N,V){const G=N.indexOf(V);G>-1&&(N.splice(G,1),N.unshift(V))}e.$Xb=q;function Y(N,V){const G=N.indexOf(V);G>-1&&(N.splice(G,1),N.push(V))}e.$Yb=Y;function K(N,V){for(const G of V)N.push(G)}e.$Zb=K;function x(N,V){return Array.isArray(N)?N.map(V):V(N)}e.$1b=x;function H(N){return Array.isArray(N)?N:[N]}e.$2b=H;function Q(N){return N[Math.floor(Math.random()*N.length)]}e.$3b=Q;function J(N,V,G){const te=ee(N,V),oe=N.length,ue=G.length;N.length=oe+ue;for(let he=oe-1;he>=te;he--)N[he+ue]=N[he];for(let he=0;he<ue;he++)N[he+te]=G[he]}e.$4b=J;function W(N,V,G,te){const oe=ee(N,V);let ue=N.splice(oe,G);return ue===void 0&&(ue=[]),J(N,oe,te),ue}e.$5b=W;function ee(N,V){return V<0?Math.max(V+N.length,0):Math.min(V,N.length)}var ne;(function(N){function V(ue){return ue<0}N.isLessThan=V;function G(ue){return ue<=0}N.isLessThanOrEqual=G;function te(ue){return ue>0}N.isGreaterThan=te;function oe(ue){return ue===0}N.isNeitherLessOrGreaterThan=oe,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function _(N,V){return(G,te)=>V(N(G),N(te))}e.$6b=_;function se(...N){return(V,G)=>{for(const te of N){const oe=te(V,G);if(!ne.isNeitherLessOrGreaterThan(oe))return oe}return ne.neitherLessOrGreaterThan}}e.$7b=se;const Z=(N,V)=>N-V;e.$8b=Z;const z=(N,V)=>(0,e.$8b)(N?1:0,V?1:0);e.$9b=z;function P(N){return(V,G)=>-N(V,G)}e.$0b=P;class T{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let G=this.c;for(;G<this.g.length&&V(this.g[G]);)G++;const te=G===this.c?null:this.g.slice(this.c,G);return this.c=G,te}takeFromEndWhile(V){let G=this.d;for(;G>=0&&V(this.g[G]);)G--;const te=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,te}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const G=this.g.slice(this.c,this.c+V);return this.c+=V,G}}e.$$b=T;class B{static{this.empty=new B(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(G=>(V(G),!0))}toArray(){const V=[];return this.iterate(G=>(V.push(G),!0)),V}filter(V){return new B(G=>this.iterate(te=>V(te)?G(te):!0))}map(V){return new B(G=>this.iterate(te=>G(V(te))))}some(V){let G=!1;return this.iterate(te=>(G=V(te),!G)),G}findFirst(V){let G;return this.iterate(te=>V(te)?(G=te,!1):!0),G}findLast(V){let G;return this.iterate(te=>(V(te)&&(G=te),!0)),G}findLastMaxBy(V){let G,te=!0;return this.iterate(oe=>((te||ne.isGreaterThan(V(oe,G)))&&(te=!1,G=oe),!0)),G}}e.$_b=B}),define(ae[126],ce([0,1,7]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function A(S,d){if(!S)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}e.ok=A;function L(S,d="Unreachable"){throw new Error(d)}e.$3c=L;function j(S){if(!S)throw new I.$bb("Assertion Failed")}e.$4c=j;function O(S){if(!S()){debugger;S(),(0,I.$Z)(new I.$bb("Assertion Failed"))}}e.$5c=O;function R(S,d){let C=0;for(;C<S.length-1;){const E=S[C],w=S[C+1];if(!d(E,w))return!1;C++}return!0}e.$6c=R}),define(ae[85],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function I(A){const L=this;let j=!1,O;return function(){return j||(j=!0,O=A.apply(L,arguments)),O}}e.$cb=I}),define(ae[60],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(A){function L(k){return k&&typeof k=="object"&&typeof k[Symbol.iterator]=="function"}A.is=L;const j=Object.freeze([]);function O(){return j}A.empty=O;function*R(k){yield k}A.single=R;function S(k){return L(k)?k:R(k)}A.wrap=S;function d(k){return k||j}A.from=d;function*C(k){for(let s=k.length-1;s>=0;s--)yield k[s]}A.reverse=C;function E(k){return!k||k[Symbol.iterator]().next().done===!0}A.isEmpty=E;function w(k){return k[Symbol.iterator]().next().value}A.first=w;function l(k,s){for(const a of k)if(s(a))return!0;return!1}A.some=l;function g(k,s){for(const a of k)if(s(a))return a}A.find=g;function*y(k,s){for(const a of k)s(a)&&(yield a)}A.filter=y;function*p(k,s){let a=0;for(const n of k)yield s(n,a++)}A.map=p;function*c(...k){for(const s of k)for(const a of s)yield a}A.concat=c;function f(k,s,a){let n=a;for(const i of k)n=s(n,i);return n}A.reduce=f;function*u(k,s,a=k.length){for(s<0&&(s+=k.length),a<0?a+=k.length:a>k.length&&(a=k.length);s<a;s++)yield k[s]}A.slice=u;function b(k,s=Number.POSITIVE_INFINITY){const a=[];if(s===0)return[a,k];const n=k[Symbol.iterator]();for(let i=0;i<s;i++){const t=n.next();if(t.done)return[a,A.empty()];a.push(t.value)}return[a,{[Symbol.iterator](){return n}}]}A.consume=b})(I||(e.Iterable=I={}))}),define(ae[35],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var A;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var L;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var j;(function(s){s.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function O(s,a=!1){let n=0;const i=s.length;let t="",r=0,o=16,v=0;function m(q){let Y=0,K=0;for(;Y<q;){const x=s.charCodeAt(n);if(x>=48&&x<=57)K=K*16+x-48;else if(x>=65&&x<=70)K=K*16+x-65+10;else if(x>=97&&x<=102)K=K*16+x-97+10;else break;n++,Y++}return Y<q&&(K=-1),K}function h(q){n=q,t="",r=0,o=16,v=0}function $(){const q=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&d(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&d(s.charCodeAt(n)))for(n++;n<s.length&&d(s.charCodeAt(n));)n++;else return v=3,s.substring(q,n);let Y=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&d(s.charCodeAt(n))){for(n++;n<s.length&&d(s.charCodeAt(n));)n++;Y=n}else v=3;return s.substring(q,Y)}function D(){let q="",Y=n;for(;;){if(n>=i){q+=s.substring(Y,n),v=2;break}const K=s.charCodeAt(n);if(K===34){q+=s.substring(Y,n),n++;break}if(K===92){if(q+=s.substring(Y,n),n++,n>=i){v=2;break}switch(s.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const H=m(4);H>=0?q+=String.fromCharCode(H):v=4;break}default:v=5}Y=n;continue}if(K>=0&&K<=31)if(S(K)){q+=s.substring(Y,n),v=2;break}else v=6;n++}return q}function F(){if(t="",v=0,r=n,n>=i)return r=i,o=17;let q=s.charCodeAt(n);if(R(q)){do n++,t+=String.fromCharCode(q),q=s.charCodeAt(n);while(R(q));return o=15}if(S(q))return n++,t+=String.fromCharCode(q),q===13&&s.charCodeAt(n)===10&&(n++,t+=`
`),o=14;switch(q){case 123:return n++,o=1;case 125:return n++,o=2;case 91:return n++,o=3;case 93:return n++,o=4;case 58:return n++,o=6;case 44:return n++,o=5;case 34:return n++,t=D(),o=10;case 47:{const Y=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!S(s.charCodeAt(n));)n++;return t=s.substring(Y,n),o=12}if(s.charCodeAt(n+1)===42){n+=2;const K=i-1;let x=!1;for(;n<K;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,v=1),t=s.substring(Y,n),o=13}return t+=String.fromCharCode(q),n++,o=16}case 45:if(t+=String.fromCharCode(q),n++,n===i||!d(s.charCodeAt(n)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=$(),o=11;default:for(;n<i&&M(q);)n++,q=s.charCodeAt(n);if(r!==n){switch(t=s.substring(r,n),t){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return t+=String.fromCharCode(q),n++,o=16}}function M(q){if(R(q)||S(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let q;do q=F();while(q>=12&&q<=15);return q}return{setPosition:h,getPosition:()=>n,scan:a?U:F,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}e.$Xm=O;function R(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function d(s){return s>=48&&s<=57}var C;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(C||(C={}));function E(s,a){const n=[],i=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function v(m,h,$,D){r.value=m,r.offset=h,r.length=$,r.type=D,r.colonOffset=void 0,t=r}try{u(s,{onObjectBegin:(m,h)=>{if(a<=m)throw i;t=void 0,o=a>m,n.push("")},onObjectProperty:(m,h,$)=>{if(a<h||(v(m,h,$,"property"),n[n.length-1]=m,a<=h+$))throw i},onObjectEnd:(m,h)=>{if(a<=m)throw i;t=void 0,n.pop()},onArrayBegin:(m,h)=>{if(a<=m)throw i;t=void 0,n.push(0)},onArrayEnd:(m,h)=>{if(a<=m)throw i;t=void 0,n.pop()},onLiteralValue:(m,h,$)=>{if(a<h||(v(m,h,$,k(m)),a<=h+$))throw i},onSeparator:(m,h,$)=>{if(a<=h)throw i;if(m===":"&&t&&t.type==="property")t.colonOffset=h,o=!1,t=void 0;else if(m===","){const D=n[n.length-1];typeof D=="number"?n[n.length-1]=D+1:(o=!0,n[n.length-1]=""),t=void 0}}})}catch(m){if(m!==i)throw m}return{path:n,previousNode:t,isAtPropertyKey:o,matches:m=>{let h=0;for(let $=0;h<m.length&&$<n.length;$++)if(m[h]===n[$]||m[h]==="*")h++;else if(m[h]!=="**")return!1;return h===m.length}}}e.$Ym=E;function w(s,a=[],n=j.DEFAULT){let i=null,t=[];const r=[];function o(m){Array.isArray(t)?t.push(m):i!==null&&(t[i]=m)}return u(s,{onObjectBegin:()=>{const m={};o(m),r.push(t),t=m,i=null},onObjectProperty:m=>{i=m},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const m=[];o(m),r.push(t),t=m,i=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:o,onError:(m,h,$)=>{a.push({error:m,offset:h,length:$})}},n),t[0]}e.$Zm=w;function l(s,a=[],n=j.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(m){i.type==="property"&&(i.length=m-i.offset,i=i.parent)}function r(m){return i.children.push(m),m}u(s,{onObjectBegin:m=>{i=r({type:"object",offset:m,length:-1,parent:i,children:[]})},onObjectProperty:(m,h,$)=>{i=r({type:"property",offset:h,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:m,offset:h,length:$,parent:i})},onObjectEnd:(m,h)=>{i.length=m+h-i.offset,i=i.parent,t(m+h)},onArrayBegin:(m,h)=>{i=r({type:"array",offset:m,length:-1,parent:i,children:[]})},onArrayEnd:(m,h)=>{i.length=m+h-i.offset,i=i.parent,t(m+h)},onLiteralValue:(m,h,$)=>{r({type:k(m),offset:h,length:$,parent:i,value:m}),t(h+$)},onSeparator:(m,h,$)=>{i.type==="property"&&(m===":"?i.colonOffset=h:m===","&&t(h))},onError:(m,h,$)=>{a.push({error:m,offset:h,length:$})}},n);const v=i.children[0];return v&&delete v.parent,v}e.$1m=l;function g(s,a){if(!s)return;let n=s;for(const i of a)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===i){n=r.children[1],t=!0;break}if(!t)return}else{const t=i;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$2m=g;function y(s){if(!s.parent||!s.parent.children)return[];const a=y(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;a.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&a.push(n)}return a}e.$3m=y;function p(s){switch(s.type){case"array":return s.children.map(p);case"object":{const a=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(a[n.children[0].value]=p(i))}return a}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$4m=p;function c(s,a,n=!1){return a>=s.offset&&a<s.offset+s.length||n&&a===s.offset+s.length}e.$5m=c;function f(s,a,n=!1){if(c(s,a,n)){const i=s.children;if(Array.isArray(i))for(let t=0;t<i.length&&i[t].offset<=a;t++){const r=f(i[t],a,n);if(r)return r}return s}}e.$6m=f;function u(s,a,n=j.DEFAULT){const i=O(s,!1);function t(_){return _?()=>_(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(_){return _?se=>_(se,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=t(a.onObjectBegin),v=r(a.onObjectProperty),m=t(a.onObjectEnd),h=t(a.onArrayBegin),$=t(a.onArrayEnd),D=r(a.onLiteralValue),F=r(a.onSeparator),M=t(a.onComment),U=r(a.onError),q=n&&n.disallowComments,Y=n&&n.allowTrailingComma;function K(){for(;;){const _=i.scan();switch(i.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:q||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(_){case 12:case 13:q?x(10):M();break;case 16:x(1);break;case 15:case 14:break;default:return _}}}function x(_,se=[],Z=[]){if(U(_),se.length+Z.length>0){let z=i.getToken();for(;z!==17;){if(se.indexOf(z)!==-1){K();break}else if(Z.indexOf(z)!==-1)break;z=K()}}}function H(_){const se=i.getTokenValue();return _?D(se):v(se),K(),!0}function Q(){switch(i.getToken()){case 11:{let _=0;try{_=JSON.parse(i.getTokenValue()),typeof _!="number"&&(x(2),_=0)}catch{x(2)}D(_);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return K(),!0}function J(){return i.getToken()!==10?(x(3,[],[2,5]),!1):(H(!1),i.getToken()===6?(F(":"),K(),ne()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function W(){o(),K();let _=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),F(","),K(),i.getToken()===2&&Y)break}else _&&x(6,[],[]);J()||x(4,[],[2,5]),_=!0}return m(),i.getToken()!==2?x(7,[2],[]):K(),!0}function ee(){h(),K();let _=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),F(","),K(),i.getToken()===4&&Y)break}else _&&x(6,[],[]);ne()||x(4,[],[4,5]),_=!0}return $(),i.getToken()!==4?x(8,[4],[]):K(),!0}function ne(){switch(i.getToken()){case 3:return ee();case 1:return W();case 10:return H(!0);default:return Q()}}return K(),i.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):ne()?(i.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$7m=u;function b(s,a){const n=O(s),i=[];let t,r=0,o;do switch(o=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==o&&i.push(s.substring(r,o)),a!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,a)),r=n.getPosition();break}while(t!==17);return i.join("")}e.$8m=b;function k(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$9m=k}),define(ae[42],ce([0,1,35]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qT=e.$pT=e.$oT=e.$nT=void 0;function A(d,C,E){let w,l,g,y,p;if(C){for(y=C.offset,p=y+C.length,g=y;g>0&&!S(d,g-1);)g--;let o=p;for(;o<d.length&&!S(d,o);)o++;l=d.substring(g,o),w=O(l,E)}else l=d,w=0,g=0,y=0,p=d.length;const c=R(E,d);let f=!1,u=0,b;E.insertSpaces?b=j(" ",E.tabSize||4):b="	";const k=(0,I.$Xm)(l,!1);let s=!1;function a(){return c+j(b,w+u)}function n(){let o=k.scan();for(f=!1;o===15||o===14;)f=f||o===14,o=k.scan();return s=o===16||k.getTokenError()!==0,o}const i=[];function t(o,v,m){!s&&v<p&&m>y&&d.substring(v,m)!==o&&i.push({offset:v,length:m-v,content:o})}let r=n();if(r!==17){const o=k.getTokenOffset()+g,v=j(b,w);t(v,g,o)}for(;r!==17;){let o=k.getTokenOffset()+k.getTokenLength()+g,v=n(),m="";for(;!f&&(v===12||v===13);){const $=k.getTokenOffset()+g;t(" ",o,$),o=k.getTokenOffset()+k.getTokenLength()+g,m=v===12?a():"",v=n()}if(v===2)r!==1&&(u--,m=a());else if(v===4)r!==3&&(u--,m=a());else{switch(r){case 3:case 1:u++,m=a();break;case 5:case 12:m=a();break;case 13:f?m=a():m=" ";break;case 6:m=" ";break;case 10:if(v===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?m=" ":v!==5&&v!==17&&(s=!0);break;case 16:s=!0;break}f&&(v===12||v===13)&&(m=a())}const h=k.getTokenOffset()+g;t(m,o,h),r=v}return i}e.$nT=A;function L(d,C){const E=JSON.stringify(d,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?E.replace(/\r\n|\r|\n/g,C.eol):E}e.$oT=L;function j(d,C){let E="";for(let w=0;w<C;w++)E+=d;return E}function O(d,C){let E=0,w=0;const l=C.tabSize||4;for(;E<d.length;){const g=d.charAt(E);if(g===" ")w++;else if(g==="	")w+=l;else break;E++}return Math.floor(w/l)}function R(d,C){for(let E=0;E<C.length;E++){const w=C.charAt(E);if(w==="\r")return E+1<C.length&&C.charAt(E+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return d&&d.eol||`
`}e.$pT=R;function S(d,C){return`\r
`.indexOf(d.charAt(C))!==-1}e.$qT=S}),define(ae[86],ce([0,1,35,42]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vT=e.$uT=e.$tT=e.$sT=e.$rT=void 0;function L(d,C,E){return j(d,C,void 0,E)}e.$rT=L;function j(d,C,E,w,l){const g=C.slice(),y=[],p=(0,I.$1m)(d,y);let c,f;for(;g.length>0&&(f=g.pop(),c=(0,I.$2m)(p,g),c===void 0&&E!==void 0);)typeof f=="string"?E={[f]:E}:E=[E];if(c)if(c.type==="object"&&typeof f=="string"&&Array.isArray(c.children)){const u=(0,I.$2m)(c,[f]);if(u!==void 0)if(E===void 0){if(!u.parent)throw new Error("Malformed AST");const b=c.children.indexOf(u.parent);let k,s=u.parent.offset+u.parent.length;if(b>0){const a=c.children[b-1];k=a.offset+a.length}else k=c.offset+1,c.children.length>1&&(s=c.children[1].offset);return O(d,{offset:k,length:s-k,content:""},w)}else return O(d,{offset:u.offset,length:u.length,content:JSON.stringify(E)},w);else{if(E===void 0)return[];const b=`${JSON.stringify(f)}: ${JSON.stringify(E)}`,k=l?l(c.children.map(a=>a.children[0].value)):c.children.length;let s;if(k>0){const a=c.children[k-1];s={offset:a.offset+a.length,length:0,content:","+b}}else c.children.length===0?s={offset:c.offset+1,length:0,content:b}:s={offset:c.offset+1,length:0,content:b+","};return O(d,s,w)}}else if(c.type==="array"&&typeof f=="number"&&Array.isArray(c.children))if(E!==void 0){const u=`${JSON.stringify(E)}`;let b;if(c.children.length===0||f===0)b={offset:c.offset+1,length:0,content:c.children.length===0?u:u+","};else{const k=f===-1||f>c.children.length?c.children.length:f,s=c.children[k-1];b={offset:s.offset+s.length,length:0,content:","+u}}return O(d,b,w)}else{const u=f,b=c.children[u];let k;if(c.children.length===1)k={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===u){const s=c.children[u-1],a=s.offset+s.length,n=c.offset+c.length;k={offset:a,length:n-2-a,content:""}}else k={offset:b.offset,length:c.children[u+1].offset-b.offset,content:""};return O(d,k,w)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${c.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return O(d,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(E)},w)}}e.$sT=j;function O(d,C,E){let w=R(d,C),l=C.offset,g=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;l>0&&!(0,A.$qT)(w,l-1);)l--;for(;g<w.length&&!(0,A.$qT)(w,g);)g++}const y=(0,A.$nT)(w,{offset:l,length:g-l},E);for(let c=y.length-1;c>=0;c--){const f=y[c];w=R(w,f),l=Math.min(l,f.offset),g=Math.max(g,f.offset+f.length),g+=f.content.length-f.length}const p=d.length-(w.length-g)-l;return[{offset:l,length:p,content:w.substring(l,g)}]}e.$tT=O;function R(d,C){return d.substring(0,C.offset)+C.content+d.substring(C.offset+C.length)}e.$uT=R;function S(d,C){const E=C.slice(0).sort((l,g)=>{const y=l.offset-g.offset;return y===0?l.length-g.length:y});let w=d.length;for(let l=E.length-1;l>=0;l--){const g=E[l];if(g.offset+g.length<=w)d=R(d,g);else throw new Error("Overlapping edit");w=g.offset}return d}e.$vT=S}),define(ae[61],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class I{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=I}),define(ae[87],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(j){this.element=j,this.next=I.Undefined,this.prev=I.Undefined}}class A{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let j=this.a;for(;j!==I.Undefined;){const O=j.next;j.prev=I.Undefined,j.next=I.Undefined,j=O}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,O){const R=new I(j);if(this.a===I.Undefined)this.a=R,this.b=R;else if(O){const d=this.b;this.b=R,R.prev=d,d.next=R}else{const d=this.a;this.a=R,R.next=d,d.prev=R}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(R))}}shift(){if(this.a!==I.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==I.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==I.Undefined&&j.next!==I.Undefined){const O=j.prev;O.next=j.next,j.next.prev=O}else j.prev===I.Undefined&&j.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):j.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):j.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==I.Undefined;)yield j.element,j=j.next}}e.$1c=A}),define(ae[34],ce([0,1]),function(ie,e){"use strict";var I,A,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function j(f,u,b){let k=f.get(u);return k===void 0&&(k=b,f.set(u,k)),k}e.$wc=j;function O(f){const u=[];return f.forEach((b,k)=>{u.push(`${k} => ${b}`)}),`Map(${f.size}) {${u.join(", ")}}`}e.$xc=O;function R(f){const u=[];return f.forEach(b=>{u.push(b)}),`Set(${f.size}) {${u.join(", ")}}`}e.$yc=R;class S{constructor(u,b){this.uri=u,this.value=b}}function d(f){return Array.isArray(f)}class C{static{this.a=u=>u.toString()}constructor(u,b){if(this[I]="ResourceMap",u instanceof C)this.b=new Map(u.b),this.c=b??C.a;else if(d(u)){this.b=new Map,this.c=b??C.a;for(const[k,s]of u)this.set(k,s)}else this.b=new Map,this.c=u??C.a}set(u,b){return this.b.set(this.c(u),new S(u,b)),this}get(u){return this.b.get(this.c(u))?.value}has(u){return this.b.has(this.c(u))}get size(){return this.b.size}clear(){this.b.clear()}delete(u){return this.b.delete(this.c(u))}forEach(u,b){typeof b<"u"&&(u=u.bind(b));for(const[k,s]of this.b)u(s.value,s.uri,this)}*values(){for(const u of this.b.values())yield u.value}*keys(){for(const u of this.b.values())yield u.uri}*entries(){for(const u of this.b.values())yield[u.uri,u.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.b)yield[u.uri,u.value]}}e.$zc=C;class E{constructor(u,b){this[A]="ResourceSet",!u||typeof u=="function"?this.a=new C(u):(this.a=new C(b),u.forEach(this.add,this))}get size(){return this.a.size}add(u){return this.a.set(u,u),this}clear(){this.a.clear()}delete(u){return this.a.delete(u)}forEach(u,b){this.a.forEach((k,s)=>u.call(b,s,s,this))}has(u){return this.a.has(u)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=E;var w;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class l{constructor(){this[L]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(u){return this.a.has(u)}get(u,b=0){const k=this.a.get(u);if(k)return b!==0&&this.j(k,b),k.value}set(u,b,k=0){let s=this.a.get(u);if(s)s.value=b,k!==0&&this.j(s,k);else{switch(s={key:u,value:b,next:void 0,previous:void 0},k){case 0:this.h(s);break;case 1:this.g(s);break;case 2:this.h(s);break;default:this.h(s);break}this.a.set(u,s),this.d++}return this}delete(u){return!!this.remove(u)}remove(u){const b=this.a.get(u);if(b)return this.a.delete(u),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const u=this.b;return this.a.delete(u.key),this.i(u),this.d--,u.value}forEach(u,b){const k=this.e;let s=this.b;for(;s;){if(b?u.bind(b)(s.value,s.key,this):u(s.value,s.key,this),this.e!==k)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const u=this,b=this.e;let k=this.b;const s={[Symbol.iterator](){return s},next(){if(u.e!==b)throw new Error("LinkedMap got modified during iteration.");if(k){const a={value:k.key,done:!1};return k=k.next,a}else return{value:void 0,done:!0}}};return s}values(){const u=this,b=this.e;let k=this.b;const s={[Symbol.iterator](){return s},next(){if(u.e!==b)throw new Error("LinkedMap got modified during iteration.");if(k){const a={value:k.value,done:!1};return k=k.next,a}else return{value:void 0,done:!0}}};return s}entries(){const u=this,b=this.e;let k=this.b;const s={[Symbol.iterator](){return s},next(){if(u.e!==b)throw new Error("LinkedMap got modified during iteration.");if(k){const a={value:[k.key,k.value],done:!1};return k=k.next,a}else return{value:void 0,done:!0}}};return s}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(u){if(u>=this.size)return;if(u===0){this.clear();return}let b=this.b,k=this.size;for(;b&&k>u;)this.a.delete(b.key),b=b.next,k--;this.b=b,this.d=k,b&&(b.previous=void 0),this.e++}g(u){if(!this.b&&!this.c)this.c=u;else if(this.b)u.next=this.b,this.b.previous=u;else throw new Error("Invalid list");this.b=u,this.e++}h(u){if(!this.b&&!this.c)this.b=u;else if(this.c)u.previous=this.c,this.c.next=u;else throw new Error("Invalid list");this.c=u,this.e++}i(u){if(u===this.b&&u===this.c)this.b=void 0,this.c=void 0;else if(u===this.b){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.b=u.next}else if(u===this.c){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.c=u.previous}else{const b=u.next,k=u.previous;if(!b||!k)throw new Error("Invalid list");b.previous=k,k.next=b}u.next=void 0,u.previous=void 0,this.e++}j(u,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(u===this.b)return;const k=u.next,s=u.previous;u===this.c?(s.next=void 0,this.c=s):(k.previous=s,s.next=k),u.previous=void 0,u.next=this.b,this.b.previous=u,this.b=u,this.e++}else if(b===2){if(u===this.c)return;const k=u.next,s=u.previous;u===this.b?(k.previous=void 0,this.b=k):(k.previous=s,s.next=k),u.next=void 0,u.previous=this.c,this.c.next=u,this.c=u,this.e++}}}toJSON(){const u=[];return this.forEach((b,k)=>{u.push([k,b])}),u}fromJSON(u){this.clear();for(const[b,k]of u)this.set(b,k)}}e.$Bc=l;class g extends l{constructor(u,b=1){super(),this.k=u,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(u){this.k=u,this.m()}get ratio(){return this.l}set ratio(u){this.l=Math.min(Math.max(0,u),1),this.m()}get(u,b=2){return super.get(u,b)}peek(u){return super.get(u,0)}set(u,b){return super.set(u,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=g;class y{constructor(){this.a=new Map}add(u){return this.a.set(u,(this.a.get(u)||0)+1),this}delete(u){let b=this.a.get(u)||0;return b===0?!1:(b--,b===0?this.a.delete(u):this.a.set(u,b),!0)}has(u){return this.a.has(u)}}e.$Dc=y;class p{constructor(u){if(this.a=new Map,this.b=new Map,u)for(const[b,k]of u)this.set(b,k)}clear(){this.a.clear(),this.b.clear()}set(u,b){this.a.set(u,b),this.b.set(b,u)}get(u){return this.a.get(u)}getKey(u){return this.b.get(u)}delete(u){const b=this.a.get(u);return b===void 0?!1:(this.a.delete(u),this.b.delete(b),!0)}forEach(u,b){this.a.forEach((k,s)=>{u.call(b,k,s,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=p;class c{constructor(){this.a=new Map}add(u,b){let k=this.a.get(u);k||(k=new Set,this.a.set(u,k)),k.add(b)}delete(u,b){const k=this.a.get(u);k&&(k.delete(b),k.size===0&&this.a.delete(u))}forEach(u,b){const k=this.a.get(u);k&&k.forEach(b)}get(u){const b=this.a.get(u);return b||new Set}}e.$Fc=c}),define(ae[2],ce([0,1,18,125,34,85,60]),function(ie,e,I,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const R=!1;let S=null;class d{constructor(){this.b=new Map}static{this.a=0}c($){let D=this.b.get($);return D||(D={parent:null,source:null,isSingleton:!1,value:$,idx:d.a++},this.b.set($,D)),D}trackDisposable($){const D=this.c($);D.source||(D.source=new Error().stack)}setParent($,D){const F=this.c($);F.parent=D}markAsDisposed($){this.b.delete($)}markAsSingleton($){this.c($).isSingleton=!0}f($,D){const F=D.get($);if(F)return F;const M=$.parent?this.f(this.c($.parent),D):$;return D.set($,M),M}getTrackedDisposables(){const $=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,$).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables($=10,D){let F;if(D)F=D;else{const K=new Map,x=[...this.b.values()].filter(Q=>Q.source!==null&&!this.f(Q,K).isSingleton);if(x.length===0)return;const H=new Set(x.map(Q=>Q.value));if(F=x.filter(Q=>!(Q.parent&&H.has(Q.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function M(K){function x(Q,J){for(;Q.length>0&&J.some(W=>typeof W=="string"?W===Q[0]:Q[0].match(W));)Q.shift()}const H=K.source.split(`
`).map(Q=>Q.trim().replace("at ","")).filter(Q=>Q!=="");return x(H,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),H.reverse()}const U=new L.$Fc;for(const K of F){const x=M(K);for(let H=0;H<=x.length;H++)U.add(x.slice(0,H).join(`
`),K)}F.sort((0,I.$6b)(K=>K.idx,I.$8b));let q="",Y=0;for(const K of F.slice(0,$)){Y++;const x=M(K),H=[];for(let Q=0;Q<x.length;Q++){let J=x[Q];J=`(shared with ${U.get(x.slice(0,Q+1).join(`
`)).size}/${F.length} leaks) at ${J}`;const ee=U.get(x.slice(0,Q).join(`
`)),ne=(0,A.$J)([...ee].map(_=>M(_)[Q]),_=>_);delete ne[x[Q]];for(const[_,se]of Object.entries(ne))H.unshift(`    - stacktraces of ${se.length} other leaks continue with ${_}`);H.unshift(J)}q+=`


==================== Leaking disposable ${Y}/${F.length}: ${K.value.constructor.name} ====================
${H.join(`
`)}
============================================================

`}return F.length>$&&(q+=`


... and ${F.length-$} more leaking disposables

`),{leaks:F,details:q}}}e.$Gc=d;function C(h){S=h}if(e.$Hc=C,R){const h="__is_disposable_tracked__";C(new class{trackDisposable($){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{$[h]||console.log(D)},3e3)}setParent($,D){if($&&$!==s.None)try{$[h]=!0}catch{}}markAsDisposed($){if($&&$!==s.None)try{$[h]=!0}catch{}}markAsSingleton($){}})}function E(h){return S?.trackDisposable(h),h}e.$Ic=E;function w(h){S?.markAsDisposed(h)}e.$Jc=w;function l(h,$){S?.setParent(h,$)}function g(h,$){if(S)for(const D of h)S.setParent(D,$)}function y(h){return S?.markAsSingleton(h),h}e.$Kc=y;function p(h){return typeof h.dispose=="function"&&h.dispose.length===0}e.$Lc=p;function c(h){if(O.Iterable.is(h)){const $=[];for(const D of h)if(D)try{D.dispose()}catch(F){$.push(F)}if($.length===1)throw $[0];if($.length>1)throw new AggregateError($,"Encountered errors while disposing of store");return Array.isArray(h)?[]:h}else if(h)return h.dispose(),h}e.$Mc=c;function f(h){for(const $ of h)p($)&&$.dispose();return[]}e.$Nc=f;function u(...h){const $=b(()=>c(h));return g(h,$),$}e.$Oc=u;function b(h){const $=E({dispose:(0,j.$cb)(()=>{w($),h()})});return $}e.$Pc=b;class k{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add($){if(!$)return $;if($===this)throw new Error("Cannot register a disposable on itself!");return l($,this),this.g?k.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add($),$}delete($){if($){if($===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete($),$.dispose()}}deleteAndLeak($){$&&this.f.has($)&&(this.f.delete($),l($,null))}}e.$Qc=k;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new k,E(this),l(this.q,this)}dispose(){w(this),this.q.dispose()}B($){if($===this)throw new Error("Cannot register a disposable on itself!");return this.q.add($)}}e.$Rc=s;class a{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value($){this.b||$===this.a||(this.a?.dispose(),$&&l($,this),this.a=$)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const $=this.a;return this.a=void 0,$&&l($,null),$}}e.$Sc=a;class n{constructor($){this.b=$,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=n;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set($){let D=$;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,w(this))},this}}e.$Uc=i;class t{constructor(){this.a=new Map}acquire($,...D){let F=this.a.get($);F||(F={counter:0,object:this.b($,...D)},this.a.set($,F));const{object:M}=F,U=(0,j.$cb)(()=>{--F.counter===0&&(this.c($,F.object),this.a.delete($))});return F.counter++,{object:M,dispose:U}}}e.$Vc=t;class r{constructor($){this.a=$}async acquire($,...D){const F=this.a.acquire($,...D);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(M){throw F.dispose(),M}}}e.$Wc=r;class o{constructor($){this.object=$}dispose(){}}e.$Xc=o;function v(h){const $=new k;try{h($)}finally{$.dispose()}}e.$Yc=v;class m{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has($){return this.a.has($)}get size(){return this.a.size}get($){return this.a.get($)}set($,D,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get($)?.dispose(),this.a.set($,D)}deleteAndDispose($){this.a.get($)?.dispose(),this.a.delete($)}keys(){return this.a.keys()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=m}),define(ae[88],ce([0,1,34]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.$rl=void 0;const A=new I.$Cc(1e4);function L(d){return S(d,"NFC",A)}e.$rl=L;const j=new I.$Cc(1e4);function O(d){return S(d,"NFD",j)}e.$sl=O;const R=/[^\u0000-\u0080]/;function S(d,C,E){if(!d)return d;const w=E.get(d);if(w)return w;let l;return R.test(d)?l=d.normalize(C):l=d,E.set(d,l),l}e.$tl=function(){const d=/[\u0300-\u036f]/g;return function(C){return O(C).replace(d,"")}}()}),function(){function ie(L){const j=[];typeof L=="number"&&j.push("code/timeOrigin",L);function O(S){j.push(S,Date.now())}function R(){const S=[];for(let d=0;d<j.length;d+=2)S.push({name:j[d],startTime:j[d+1]});return S}return{mark:O,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const O of performance.getEntriesByType("mark"))j.push({name:O.name,startTime:Math.round(L+O.startTime)});return j}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function I(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=I(A))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var A in I)(typeof exports=="object"?exports:ie)[A]=I[A]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function I(A){if(e[A])return e[A].exports;var L=e[A]={i:A,l:!1,exports:{}};return ie[A].call(L.exports,L,L.exports,I),L.l=!0,L.exports}return I.m=ie,I.c=e,I.d=function(A,L,j){I.o(A,L)||Object.defineProperty(A,L,{enumerable:!0,get:j})},I.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},I.t=function(A,L){if(1&L&&(A=I(A)),8&L||4&L&&typeof A=="object"&&A&&A.__esModule)return A;var j=Object.create(null);if(I.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:A}),2&L&&typeof A!="string")for(var O in A)I.d(j,O,function(R){return A[R]}.bind(null,O));return j},I.n=function(A){var L=A&&A.__esModule?function(){return A.default}:function(){return A};return I.d(L,"a",L),L},I.o=function(A,L){return Object.prototype.hasOwnProperty.call(A,L)},I.p="",I(I.s=0)}([function(ie,e,I){(function(A){var L;e=ie.exports=Z,L=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],d=0,C=d++;S[C]="0|[1-9]\\d*";var E=d++;S[E]="[0-9]+";var w=d++;S[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=d++;S[l]="("+S[C]+")\\.("+S[C]+")\\.("+S[C]+")";var g=d++;S[g]="("+S[E]+")\\.("+S[E]+")\\.("+S[E]+")";var y=d++;S[y]="(?:"+S[C]+"|"+S[w]+")";var p=d++;S[p]="(?:"+S[E]+"|"+S[w]+")";var c=d++;S[c]="(?:-("+S[y]+"(?:\\."+S[y]+")*))";var f=d++;S[f]="(?:-?("+S[p]+"(?:\\."+S[p]+")*))";var u=d++;S[u]="[0-9A-Za-z-]+";var b=d++;S[b]="(?:\\+("+S[u]+"(?:\\."+S[u]+")*))";var k=d++,s="v?"+S[l]+S[c]+"?"+S[b]+"?";S[k]="^"+s+"$";var a="[v=\\s]*"+S[g]+S[f]+"?"+S[b]+"?",n=d++;S[n]="^"+a+"$";var i=d++;S[i]="((?:<|>)?=?)";var t=d++;S[t]=S[E]+"|x|X|\\*";var r=d++;S[r]=S[C]+"|x|X|\\*";var o=d++;S[o]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[c]+")?"+S[b]+"?)?)?";var v=d++;S[v]="[v=\\s]*("+S[t]+")(?:\\.("+S[t]+")(?:\\.("+S[t]+")(?:"+S[f]+")?"+S[b]+"?)?)?";var m=d++;S[m]="^"+S[i]+"\\s*"+S[o]+"$";var h=d++;S[h]="^"+S[i]+"\\s*"+S[v]+"$";var $=d++;S[$]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=d++;S[D]="(?:~>?)";var F=d++;S[F]="(\\s*)"+S[D]+"\\s+",R[F]=new RegExp(S[F],"g");var M=d++;S[M]="^"+S[D]+S[o]+"$";var U=d++;S[U]="^"+S[D]+S[v]+"$";var q=d++;S[q]="(?:\\^)";var Y=d++;S[Y]="(\\s*)"+S[q]+"\\s+",R[Y]=new RegExp(S[Y],"g");var K=d++;S[K]="^"+S[q]+S[o]+"$";var x=d++;S[x]="^"+S[q]+S[v]+"$";var H=d++;S[H]="^"+S[i]+"\\s*("+a+")$|^$";var Q=d++;S[Q]="^"+S[i]+"\\s*("+s+")$|^$";var J=d++;S[J]="(\\s*)"+S[i]+"\\s*("+a+"|"+S[o]+")",R[J]=new RegExp(S[J],"g");var W=d++;S[W]="^\\s*("+S[o]+")\\s+-\\s+("+S[o]+")\\s*$";var ee=d++;S[ee]="^\\s*("+S[v]+")\\s+-\\s+("+S[v]+")\\s*$";var ne=d++;S[ne]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)L(_,S[_]),R[_]||(R[_]=new RegExp(S[_]));function se(le,$e){if(le instanceof Z)return le;if(typeof le!="string"||le.length>j||!($e?R[n]:R[k]).test(le))return null;try{return new Z(le,$e)}catch{return null}}function Z(le,$e){if(le instanceof Z){if(le.loose===$e)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof Z))return new Z(le,$e);L("SemVer",le,$e),this.loose=$e;var be=le.trim().match($e?R[n]:R[k]);if(!be)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Pe=+Se;if(Pe>=0&&Pe<O)return Pe}return Se}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=se,e.valid=function(le,$e){var be=se(le,$e);return be?be.version:null},e.clean=function(le,$e){var be=se(le.trim().replace(/^[=v]+/,""),$e);return be?be.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(le){return L("SemVer.compare",this.version,this.loose,le),le instanceof Z||(le=new Z(le,this.loose)),this.compareMain(le)||this.comparePre(le)},Z.prototype.compareMain=function(le){return le instanceof Z||(le=new Z(le,this.loose)),P(this.major,le.major)||P(this.minor,le.minor)||P(this.patch,le.patch)},Z.prototype.comparePre=function(le){if(le instanceof Z||(le=new Z(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var $e=0;do{var be=this.prerelease[$e],Se=le.prerelease[$e];if(L("prerelease compare",$e,be,Se),be===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(be===void 0)return-1;if(be!==Se)return P(be,Se)}while(++$e)},Z.prototype.inc=function(le,$e){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",$e);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",$e);break;case"prepatch":this.prerelease.length=0,this.inc("patch",$e),this.inc("pre",$e);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",$e),this.inc("pre",$e);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}$e&&(this.prerelease[0]===$e?isNaN(this.prerelease[1])&&(this.prerelease=[$e,0]):this.prerelease=[$e,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,$e,be,Se){typeof be=="string"&&(Se=be,be=void 0);try{return new Z(le,be).inc($e,Se).version}catch{return null}},e.diff=function(le,$e){if(V(le,$e))return null;var be=se(le),Se=se($e);if(be.prerelease.length||Se.prerelease.length){for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==Se[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==Se[Pe])return Pe},e.compareIdentifiers=P;var z=/^[0-9]+$/;function P(le,$e){var be=z.test(le),Se=z.test($e);return be&&Se&&(le=+le,$e=+$e),be&&!Se?-1:Se&&!be?1:le<$e?-1:le>$e?1:0}function T(le,$e,be){return new Z(le,be).compare(new Z($e,be))}function B(le,$e,be){return T(le,$e,be)>0}function N(le,$e,be){return T(le,$e,be)<0}function V(le,$e,be){return T(le,$e,be)===0}function G(le,$e,be){return T(le,$e,be)!==0}function te(le,$e,be){return T(le,$e,be)>=0}function oe(le,$e,be){return T(le,$e,be)<=0}function ue(le,$e,be,Se){var Pe;switch($e){case"===":typeof le=="object"&&(le=le.version),typeof be=="object"&&(be=be.version),Pe=le===be;break;case"!==":typeof le=="object"&&(le=le.version),typeof be=="object"&&(be=be.version),Pe=le!==be;break;case"":case"=":case"==":Pe=V(le,be,Se);break;case"!=":Pe=G(le,be,Se);break;case">":Pe=B(le,be,Se);break;case">=":Pe=te(le,be,Se);break;case"<":Pe=N(le,be,Se);break;case"<=":Pe=oe(le,be,Se);break;default:throw new TypeError("Invalid operator: "+$e)}return Pe}function he(le,$e){if(le instanceof he){if(le.loose===$e)return le;le=le.value}if(!(this instanceof he))return new he(le,$e);L("comparator",le,$e),this.loose=$e,this.parse(le),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(le,$e){return P($e,le)},e.major=function(le,$e){return new Z(le,$e).major},e.minor=function(le,$e){return new Z(le,$e).minor},e.patch=function(le,$e){return new Z(le,$e).patch},e.compare=T,e.compareLoose=function(le,$e){return T(le,$e,!0)},e.rcompare=function(le,$e,be){return T($e,le,be)},e.sort=function(le,$e){return le.sort(function(be,Se){return e.compare(be,Se,$e)})},e.rsort=function(le,$e){return le.sort(function(be,Se){return e.rcompare(be,Se,$e)})},e.gt=B,e.lt=N,e.eq=V,e.neq=G,e.gte=te,e.lte=oe,e.cmp=ue,e.Comparator=he;var ge={};function de(le,$e){if(le instanceof de)return le.loose===$e?le:new de(le.raw,$e);if(le instanceof he)return new de(le.value,$e);if(!(this instanceof de))return new de(le,$e);if(this.loose=$e,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function we(le){return!le||le.toLowerCase()==="x"||le==="*"}function ve(le,$e,be,Se,Pe,Ue,je,ze,Fe,re,fe,me,ye){return(($e=we(be)?"":we(Se)?">="+be+".0.0":we(Pe)?">="+be+"."+Se+".0":">="+$e)+" "+(ze=we(Fe)?"":we(re)?"<"+(+Fe+1)+".0.0":we(fe)?"<"+Fe+"."+(+re+1)+".0":me?"<="+Fe+"."+re+"."+fe+"-"+me:"<="+ze)).trim()}function Oe(le,$e){for(var be=0;be<le.length;be++)if(!le[be].test($e))return!1;if($e.prerelease.length){for(be=0;be<le.length;be++)if(L(le[be].semver),le[be].semver!==ge&&le[be].semver.prerelease.length>0){var Se=le[be].semver;if(Se.major===$e.major&&Se.minor===$e.minor&&Se.patch===$e.patch)return!0}return!1}return!0}function Ne(le,$e,be){try{$e=new de($e,be)}catch{return!1}return $e.test(le)}function Me(le,$e,be,Se){var Pe,Ue,je,ze,Fe;switch(le=new Z(le,Se),$e=new de($e,Se),be){case">":Pe=B,Ue=oe,je=N,ze=">",Fe=">=";break;case"<":Pe=N,Ue=te,je=B,ze="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(le,$e,Se))return!1;for(var re=0;re<$e.set.length;++re){var fe=$e.set[re],me=null,ye=null;if(fe.forEach(function(ke){ke.semver===ge&&(ke=new he(">=0.0.0")),me=me||ke,ye=ye||ke,Pe(ke.semver,me.semver,Se)?me=ke:je(ke.semver,ye.semver,Se)&&(ye=ke)}),me.operator===ze||me.operator===Fe||(!ye.operator||ye.operator===ze)&&Ue(le,ye.semver)||ye.operator===Fe&&je(le,ye.semver))return!1}return!0}he.prototype.parse=function(le){var $e=this.loose?R[H]:R[Q],be=le.match($e);if(!be)throw new TypeError("Invalid comparator: "+le);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new Z(be[2],this.loose):this.semver=ge},he.prototype.toString=function(){return this.value},he.prototype.test=function(le){return L("Comparator.test",le,this.loose),this.semver===ge||(typeof le=="string"&&(le=new Z(le,this.loose)),ue(le,this.operator,this.semver,this.loose))},he.prototype.intersects=function(le,$e){if(!(le instanceof he))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(le.value,$e),Ne(this.value,be,$e);if(le.operator==="")return be=new de(this.value,$e),Ne(le.semver,be,$e);var Se=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Ue=this.semver.version===le.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),ze=ue(this.semver,"<",le.semver,$e)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Fe=ue(this.semver,">",le.semver,$e)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Se||Pe||Ue&&je||ze||Fe},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(le){var $e=this.loose;le=le.trim(),L("range",le,$e);var be=$e?R[ee]:R[W];le=le.replace(be,ve),L("hyphen replace",le),le=le.replace(R[J],"$1$2$3"),L("comparator trim",le,R[J]),le=(le=(le=le.replace(R[F],"$1~")).replace(R[Y],"$1^")).split(/\s+/).join(" ");var Se=$e?R[H]:R[Q],Pe=le.split(" ").map(function(Ue){return function(je,ze){return L("comp",je),je=function(Fe,re){return Fe.trim().split(/\s+/).map(function(fe){return function(me,ye){L("caret",me,ye);var ke=ye?R[x]:R[K];return me.replace(ke,function(Re,Ce,Ie,De,Ae){var Te;return L("caret",me,Re,Ce,Ie,De,Ae),we(Ce)?Te="":we(Ie)?Te=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(De)?Te=Ce==="0"?">="+Ce+"."+Ie+".0 <"+Ce+"."+(+Ie+1)+".0":">="+Ce+"."+Ie+".0 <"+(+Ce+1)+".0.0":Ae?(L("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=Ce==="0"?Ie==="0"?">="+Ce+"."+Ie+"."+De+Ae+" <"+Ce+"."+Ie+"."+(+De+1):">="+Ce+"."+Ie+"."+De+Ae+" <"+Ce+"."+(+Ie+1)+".0":">="+Ce+"."+Ie+"."+De+Ae+" <"+(+Ce+1)+".0.0"):(L("no pr"),Te=Ce==="0"?Ie==="0"?">="+Ce+"."+Ie+"."+De+" <"+Ce+"."+Ie+"."+(+De+1):">="+Ce+"."+Ie+"."+De+" <"+Ce+"."+(+Ie+1)+".0":">="+Ce+"."+Ie+"."+De+" <"+(+Ce+1)+".0.0"),L("caret return",Te),Te})}(fe,re)}).join(" ")}(je,ze),L("caret",je),je=function(Fe,re){return Fe.trim().split(/\s+/).map(function(fe){return function(me,ye){var ke=ye?R[U]:R[M];return me.replace(ke,function(Re,Ce,Ie,De,Ae){var Te;return L("tilde",me,Re,Ce,Ie,De,Ae),we(Ce)?Te="":we(Ie)?Te=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(De)?Te=">="+Ce+"."+Ie+".0 <"+Ce+"."+(+Ie+1)+".0":Ae?(L("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=">="+Ce+"."+Ie+"."+De+Ae+" <"+Ce+"."+(+Ie+1)+".0"):Te=">="+Ce+"."+Ie+"."+De+" <"+Ce+"."+(+Ie+1)+".0",L("tilde return",Te),Te})}(fe,re)}).join(" ")}(je,ze),L("tildes",je),je=function(Fe,re){return L("replaceXRanges",Fe,re),Fe.split(/\s+/).map(function(fe){return function(me,ye){me=me.trim();var ke=ye?R[h]:R[m];return me.replace(ke,function(Re,Ce,Ie,De,Ae,Te){L("xRange",me,Re,Ce,Ie,De,Ae,Te);var Be=we(Ie),qe=Be||we(De),We=qe||we(Ae);return Ce==="="&&We&&(Ce=""),Be?Re=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&We?(qe&&(De=0),We&&(Ae=0),Ce===">"?(Ce=">=",qe?(Ie=+Ie+1,De=0,Ae=0):We&&(De=+De+1,Ae=0)):Ce==="<="&&(Ce="<",qe?Ie=+Ie+1:De=+De+1),Re=Ce+Ie+"."+De+"."+Ae):qe?Re=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":We&&(Re=">="+Ie+"."+De+".0 <"+Ie+"."+(+De+1)+".0"),L("xRange return",Re),Re})}(fe,re)}).join(" ")}(je,ze),L("xrange",je),je=function(Fe,re){return L("replaceStars",Fe,re),Fe.trim().replace(R[ne],"")}(je,ze),L("stars",je),je}(Ue,$e)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ue){return!!Ue.match(Se)})),Pe=Pe.map(function(Ue){return new he(Ue,$e)})},de.prototype.intersects=function(le,$e){if(!(le instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Se){return le.set.some(function(Pe){return Pe.every(function(Ue){return Se.intersects(Ue,$e)})})})})},e.toComparators=function(le,$e){return new de(le,$e).set.map(function(be){return be.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},de.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new Z(le,this.loose));for(var $e=0;$e<this.set.length;$e++)if(Oe(this.set[$e],le))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(le,$e,be){var Se=null,Pe=null;try{var Ue=new de($e,be)}catch{return null}return le.forEach(function(je){Ue.test(je)&&(Se&&Pe.compare(je)!==-1||(Pe=new Z(Se=je,be)))}),Se},e.minSatisfying=function(le,$e,be){var Se=null,Pe=null;try{var Ue=new de($e,be)}catch{return null}return le.forEach(function(je){Ue.test(je)&&(Se&&Pe.compare(je)!==1||(Pe=new Z(Se=je,be)))}),Se},e.validRange=function(le,$e){try{return new de(le,$e).range||"*"}catch{return null}},e.ltr=function(le,$e,be){return Me(le,$e,"<",be)},e.gtr=function(le,$e,be){return Me(le,$e,">",be)},e.outside=Me,e.prerelease=function(le,$e){var be=se(le,$e);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(le,$e,be){return le=new de(le,be),$e=new de($e,be),le.intersects($e)},e.coerce=function(le){if(le instanceof Z)return le;if(typeof le!="string")return null;var $e=le.match(R[$]);return $e==null?null:se(($e[1]||"0")+"."+($e[2]||"0")+"."+($e[3]||"0"))}}).call(this,I(1))},function(ie,e){var I,A,L=ie.exports={};function j(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function R(p){if(I===setTimeout)return setTimeout(p,0);if((I===j||!I)&&setTimeout)return I=setTimeout,setTimeout(p,0);try{return I(p,0)}catch{try{return I.call(null,p,0)}catch{return I.call(this,p,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:j}catch{I=j}try{A=typeof clearTimeout=="function"?clearTimeout:O}catch{A=O}})();var S,d=[],C=!1,E=-1;function w(){C&&S&&(C=!1,S.length?d=S.concat(d):E=-1,d.length&&l())}function l(){if(!C){var p=R(w);C=!0;for(var c=d.length;c;){for(S=d,d=[];++E<c;)S&&S[E].run();E=-1,c=d.length}S=null,C=!1,function(f){if(A===clearTimeout)return clearTimeout(f);if((A===O||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(f);try{A(f)}catch{try{return A.call(null,f)}catch{return A.call(this,f)}}}(p)}}function g(p,c){this.fun=p,this.array=c}function y(){}L.nextTick=function(p){var c=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)c[f-1]=arguments[f];d.push(new g(p,c)),d.length!==1||C||R(l)},g.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=y,L.addListener=y,L.once=y,L.off=y,L.removeListener=y,L.removeAllListeners=y,L.emit=y,L.prependListener=y,L.prependOnceListener=y,L.listeners=function(p){return[]},L.binding=function(p){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(p){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ae[127],ce([0,1]),function(ie,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;class A{constructor(R,S,d){this.level=R,this.key=S,this.value=d,this.forward=[]}}const L=void 0;class j{constructor(R,S=2**16){this.comparator=R,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(S)|0),this.e=new A(this.c,L,L)}get size(){return this.f}clear(){this.e=new A(this.c,L,L),this.f=0}has(R){return!!j.g(this,R,this.comparator)}get(R){return j.g(this,R,this.comparator)?.value}set(R,S){return j.h(this,R,S,this.comparator)&&(this.f+=1),this}delete(R){const S=j.k(this,R,this.comparator);return S&&(this.f-=1),S}forEach(R,S){let d=this.e.forward[0];for(;d;)R.call(S,d.value,d.key,this),d=d.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",S=this.e.forward[0];for(;S;)R+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return R}static g(R,S,d){let C=R.e;for(let E=R.d-1;E>=0;E--)for(;C.forward[E]&&d(C.forward[E].key,S)<0;)C=C.forward[E];if(C=C.forward[0],C&&d(C.key,S)===0)return C}static h(R,S,d,C){const E=[];let w=R.e;for(let l=R.d-1;l>=0;l--){for(;w.forward[l]&&C(w.forward[l].key,S)<0;)w=w.forward[l];E[l]=w}if(w=w.forward[0],w&&C(w.key,S)===0)return w.value=d,!1;{const l=j.j(R);if(l>R.d){for(let g=R.d;g<l;g++)E[g]=R.e;R.d=l}w=new A(l,S,d);for(let g=0;g<l;g++)w.forward[g]=E[g].forward[g],E[g].forward[g]=w;return!0}}static j(R,S=.5){let d=1;for(;Math.random()<S&&d<R.c;)d+=1;return d}static k(R,S,d){const C=[];let E=R.e;for(let w=R.d-1;w>=0;w--){for(;E.forward[w]&&d(E.forward[w].key,S)<0;)E=E.forward[w];C[w]=E}if(E=E.forward[0],!E||d(E.key,S)!==0)return!1;for(let w=0;w<R.d&&C[w].forward[w]===E;w++)C[w].forward[w]=E.forward[w];for(;R.d>0&&R.e.forward[R.d-1]===L;)R.d-=1;return!0}}e.$Br=j}),define(ae[62],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(j){return new A(j)}constructor(j){this.c=I&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Kd=A}),define(ae[3],ce([0,1,7,85,2,87,62]),function(ie,e,I,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.Event=void 0;const R=!1,S=!1;var d;(function(m){m.None=()=>L.$Rc.None;function h(ue){if(S){const{onDidAddListener:he}=ue,ge=g.create();let de=0;ue.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ge.print()),he?.()}}}function $(ue,he){return Q(ue,()=>{},0,void 0,!0,void 0,he)}m.defer=$;function D(ue){return(he,ge=null,de)=>{let we=!1,ve;return ve=ue(Oe=>{if(!we)return ve?ve.dispose():we=!0,he.call(ge,Oe)},null,de),we&&ve.dispose(),ve}}m.once=D;function F(ue,he,ge){return x((de,we=null,ve)=>ue(Oe=>de.call(we,he(Oe)),null,ve),ge)}m.map=F;function M(ue,he,ge){return x((de,we=null,ve)=>ue(Oe=>{he(Oe),de.call(we,Oe)},null,ve),ge)}m.forEach=M;function U(ue,he,ge){return x((de,we=null,ve)=>ue(Oe=>he(Oe)&&de.call(we,Oe),null,ve),ge)}m.filter=U;function q(ue){return ue}m.signal=q;function Y(...ue){return(he,ge=null,de)=>{const we=(0,L.$Oc)(...ue.map(ve=>ve(Oe=>he.call(ge,Oe))));return H(we,de)}}m.any=Y;function K(ue,he,ge,de){let we=ge;return F(ue,ve=>(we=he(we,ve),we),de)}m.reduce=K;function x(ue,he){let ge;const de={onWillAddFirstListener(){ge=ue(we.fire,we)},onDidRemoveLastListener(){ge?.dispose()}};he||h(de);const we=new u(de);return he?.add(we),we.event}function H(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function Q(ue,he,ge=100,de=!1,we=!1,ve,Oe){let Ne,Me,le,$e=0,be;const Se={leakWarningThreshold:ve,onWillAddFirstListener(){Ne=ue(Ue=>{$e++,Me=he(Me,Ue),de&&!le&&(Pe.fire(Me),Me=void 0),be=()=>{const je=Me;Me=void 0,le=void 0,(!de||$e>1)&&Pe.fire(je),$e=0},typeof ge=="number"?(clearTimeout(le),le=setTimeout(be,ge)):le===void 0&&(le=0,queueMicrotask(be))})},onWillRemoveListener(){we&&$e>0&&be?.()},onDidRemoveLastListener(){be=void 0,Ne.dispose()}};Oe||h(Se);const Pe=new u(Se);return Oe?.add(Pe),Pe.event}m.debounce=Q;function J(ue,he=0,ge){return m.debounce(ue,(de,we)=>de?(de.push(we),de):[we],he,void 0,!0,void 0,ge)}m.accumulate=J;function W(ue,he=(de,we)=>de===we,ge){let de=!0,we;return U(ue,ve=>{const Oe=de||!he(ve,we);return de=!1,we=ve,Oe},ge)}m.latch=W;function ee(ue,he,ge){return[m.filter(ue,he,ge),m.filter(ue,de=>!he(de),ge)]}m.split=ee;function ne(ue,he=!1,ge=[],de){let we=ge.slice(),ve=ue(Me=>{we?we.push(Me):Ne.fire(Me)});de&&de.add(ve);const Oe=()=>{we?.forEach(Me=>Ne.fire(Me)),we=null},Ne=new u({onWillAddFirstListener(){ve||(ve=ue(Me=>Ne.fire(Me)),de&&de.add(ve))},onDidAddFirstListener(){we&&(he?setTimeout(Oe):Oe())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return de&&de.add(Ne),Ne.event}m.buffer=ne;function _(ue,he){return(de,we,ve)=>{const Oe=he(new Z);return ue(function(Ne){const Me=Oe.evaluate(Ne);Me!==se&&de.call(we,Me)},void 0,ve)}}m.chain=_;const se=Symbol("HaltChainable");class Z{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push(ge=>(he(ge),ge)),this}filter(he){return this.f.push(ge=>he(ge)?ge:se),this}reduce(he,ge){let de=ge;return this.f.push(we=>(de=he(de,we),de)),this}latch(he=(ge,de)=>ge===de){let ge=!0,de;return this.f.push(we=>{const ve=ge||!he(we,de);return ge=!1,de=we,ve?we:se}),this}evaluate(he){for(const ge of this.f)if(he=ge(he),he===se)break;return he}}function z(ue,he,ge=de=>de){const de=(...Ne)=>Oe.fire(ge(...Ne)),we=()=>ue.on(he,de),ve=()=>ue.removeListener(he,de),Oe=new u({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Oe.event}m.fromNodeEventEmitter=z;function P(ue,he,ge=de=>de){const de=(...Ne)=>Oe.fire(ge(...Ne)),we=()=>ue.addEventListener(he,de),ve=()=>ue.removeEventListener(he,de),Oe=new u({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Oe.event}m.fromDOMEventEmitter=P;function T(ue){return new Promise(he=>D(ue)(he))}m.toPromise=T;function B(ue){const he=new u;return ue.then(ge=>{he.fire(ge)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}m.fromPromise=B;function N(ue,he,ge){return he(ge),ue(de=>he(de))}m.runAndSubscribe=N;function V(ue,he){let ge=null;function de(ve){ge?.dispose(),ge=new L.$Qc,he(ve,ge)}de(void 0);const we=ue(ve=>de(ve));return(0,L.$Pc)(()=>{we.dispose(),ge?.dispose()})}m.runAndSubscribeWithStore=V;class G{constructor(he,ge){this._observable=he,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};ge||h(de),this.emitter=new u(de),ge&&ge.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,ge){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function te(ue,he){return new G(ue,he).emitter.event}m.fromObservable=te;function oe(ue){return he=>{let ge=0,de=!1;const we={beginUpdate(){ge++},endUpdate(){ge--,ge===0&&(ue.reportChanges(),de&&(de=!1,he()))},handlePossibleChange(){},handleChange(){de=!0}};return ue.addObserver(we),ue.reportChanges(),{dispose(){ue.removeObserver(we)}}}}m.fromObservableLight=oe})(d||(e.Event=d={}));class C{static{this.all=new Set}static{this.f=0}constructor(h){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${h}_${C.f++}`,C.all.add(this)}start(h){this.g=new O.$Kd,this.listenerCount=h}stop(){if(this.g){const h=this.g.elapsed();this.durations.push(h),this.elapsedOverall+=h,this.invocationCount+=1,this.g=void 0}}}e.$Md=C;let E=-1;function w(m){const h=E;return E=m,{dispose(){E=h}}}e.$Nd=w;class l{constructor(h,$=Math.random().toString(18).slice(2,5)){this.threshold=h,this.name=$,this.g=0}dispose(){this.f?.clear()}check(h,$){const D=this.threshold;if(D<=0||$<D)return;this.f||(this.f=new Map);const F=this.f.get(h.value)||0;if(this.f.set(h.value,F+1),this.g-=1,this.g<=0){this.g=D*.5;let M,U=0;for(const[q,Y]of this.f)(!M||U<Y)&&(M=q,U=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${$} listeners already. MOST frequent listener (${U}):`),console.warn(M)}return()=>{const M=this.f.get(h.value)||0;this.f.set(h.value,M-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(h){this.value=h}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class p{constructor(h){this.value=h,this.id=y++}}const c=2,f=(m,h)=>{if(m instanceof p)h(m);else for(let $=0;$<m.length;$++){const D=m[$];D&&h(D)}};class u{constructor(h){this.w=0,this.f=h,this.g=E>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const h=this.t;queueMicrotask(()=>{f(h,$=>$.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(h,$,D)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Rc.None;if(this.m)return L.$Rc.None;$&&(h=h.bind($));const F=new p(h);let M,U;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=g.create(),M=this.g.check(F.stack,this.w+1)),R&&(F.stack=U??g.create()),this.t?this.t instanceof p?(this.u??=new k,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const q=(0,L.$Pc)(()=>{M?.(),this.x(F)});return D instanceof L.$Qc?D.add(q):Array.isArray(D)&&D.push(q),q},this.q}x(h){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const $=this.t,D=$.indexOf(h);if(D===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,$[D]=void 0;const F=this.u.current===this;if(this.w*c<=$.length){let M=0;for(let U=0;U<$.length;U++)$[U]?$[M++]=$[U]:F&&(this.u.end--,M<this.u.i&&this.u.i--);$.length=M}}y(h,$){if(!h)return;const D=this.f?.onListenerError||I.$Z;if(!D){h.value($);return}try{h.value($)}catch(F){D(F)}}z(h){const $=h.current.t;for(;h.i<h.end;)this.y($[h.i++],h.value);h.reset()}fire(h){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof p)this.y(this.t,h);else{const $=this.u;$.enqueue(this,h,this.t.length),this.z($)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Od=u;const b=()=>new k;e.$Pd=b;class k{constructor(){this.i=-1,this.end=0}enqueue(h,$,D){this.i=0,this.end=D,this.current=h,this.value=$}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends u{async fireAsync(h,$,D){if(this.t)for(this.h||(this.h=new j.$1c),f(this.t,F=>this.h.push([F.value,h]));this.h.size>0&&!$.isCancellationRequested;){const[F,M]=this.h.shift(),U=[],q={...M,token:$,waitUntil:Y=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");D&&(Y=D(Y,F)),U.push(Y)}};try{F(q)}catch(Y){(0,I.$Z)(Y);continue}Object.freeze(U),await Promise.allSettled(U).then(Y=>{for(const K of Y)K.status==="rejected"&&(0,I.$Z)(K.reason)})}}}e.$Qd=s;class a extends u{get isPaused(){return this.h!==0}constructor(h){super(h),this.h=0,this.s=new j.$1c,this.A=h?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const h=Array.from(this.s);this.s.clear(),super.fire(this.A(h))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(h){this.w&&(this.h!==0?this.s.push(h):super.fire(h))}}e.$Rd=a;class n extends a{constructor(h){super(h),this.k=h.delay??100}fire(h){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(h)}}e.$Sd=n;class i extends u{constructor(h){super(h),this.h=[],this.k=h?.merge}fire(h){this.hasListeners()&&(this.h.push(h),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach($=>super.fire($)),this.h=[]}))}}e.$Td=i;class t{constructor(){this.g=!1,this.h=[],this.f=new u({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(h){const $={event:h,listener:null};this.h.push($),this.g&&this.m($);const D=()=>{this.g&&this.o($);const F=this.h.indexOf($);this.h.splice(F,1)};return(0,L.$Pc)((0,A.$cb)(D))}j(){this.g=!0,this.h.forEach(h=>this.m(h))}k(){this.g=!1,this.h.forEach(h=>this.o(h))}m(h){h.listener=h.event($=>this.f.fire($))}o(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.f.dispose()}}e.$Ud=t;class r{constructor(h,$,D,F){this.f=new L.$Qc;const M=this.f.add(new t),U=this.f.add(new L.$Zc);function q(Y){U.set(Y,M.add(F(Y)))}for(const Y of h)q(Y);this.f.add($(Y=>{q(Y)})),this.f.add(D(Y=>{U.deleteAndDispose(Y)})),this.event=M.event}dispose(){this.f.dispose()}}e.$Vd=r;class o{constructor(){this.f=[]}wrapEvent(h){return($,D,F)=>h(M=>{const U=this.f[this.f.length-1];U?U.push(()=>$.call(D,M)):$.call(D,M)},void 0,F)}bufferEvents(h){const $=[];this.f.push($);const D=h();return this.f.pop(),$.forEach(F=>F()),D}}e.$Wd=o;class v{constructor(){this.f=!1,this.g=d.None,this.h=L.$Rc.None,this.j=new u({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(h){this.g=h,this.f&&(this.h.dispose(),this.h=h(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Xd=v}),define(ae[26],ce([0,1,3]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.CancellationToken=void 0;const A=Object.freeze(function(R,S){const d=setTimeout(R.bind(S),0);return{dispose(){clearTimeout(d)}}});var L;(function(R){function S(d){return d===R.None||d===R.Cancelled||d instanceof j?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}R.isCancellationToken=S,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(L||(e.CancellationToken=L={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new I.$Od),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(S){this.f=void 0,this.g=void 0,this.g=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=L.Cancelled}dispose(S=!1){S&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=L.None}}e.$Yd=O}),define(ae[128],ce([0,1,26]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=void 0;class A{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new I.$Yd,S=this.b(R.token);return this.a={promise:S,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$xe=A;class L{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const S=JSON.stringify(R);return this.b!==S&&(this.b=S,this.a=this.c(R)),this.a}}e.$ye=L;class j{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const S=this.b(R);return this.a.set(R,S),S}}e.$ze=j}),define(ae[46],ce([0,1,7,2]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=void 0;function L(b){const k=b;return k?typeof k.read=="function":!1}e.$Zd=L;function j(b){const k=b;return k?[k.on,k.pause,k.resume,k.destroy].every(s=>typeof s=="function"):!1}e.$1d=j;function O(b){const k=b;return k?j(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.$2d=O;function R(b,k){return new S(b,k)}e.$3d=R;class S{constructor(k,s){this.e=k,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(s=>s(k))}h(k){this.c.error.length===0?(0,I.$Z)(k):this.c.error.slice(0).forEach(s=>s(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,s){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(k,s){if(this.a.destroyed)return;let a;switch(k){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const n=a.indexOf(s);n>=0&&a.splice(n,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(b,k){const s=[];let a;for(;(a=b.read())!==null;)s.push(a);return k(s)}e.$4d=d;function C(b,k,s){const a=[];let n;for(;(n=b.read())!==null&&a.length<s;)a.push(n);return n===null&&a.length>0?k(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return b.read()}}}e.$5d=C;function E(b,k){return new Promise((s,a)=>{const n=[];w(b,{onData:i=>{k&&n.push(i)},onError:i=>{k?a(i):s(void 0)},onEnd:()=>{s(k?k(n):void 0)}})})}e.$6d=E;function w(b,k,s){b.on("error",a=>{s?.isCancellationRequested||k.onError(a)}),b.on("end",()=>{s?.isCancellationRequested||k.onEnd()}),b.on("data",a=>{s?.isCancellationRequested||k.onData(a)})}e.$7d=w;function l(b,k){return new Promise((s,a)=>{const n=new A.$Qc,i=[],t=v=>{if(i.push(v),i.length>k)return n.dispose(),b.pause(),s({stream:b,buffer:i,ended:!1})},r=v=>(n.dispose(),a(v)),o=()=>(n.dispose(),s({stream:b,buffer:i,ended:!0}));n.add((0,A.$Pc)(()=>b.removeListener("error",r))),b.on("error",r),n.add((0,A.$Pc)(()=>b.removeListener("end",o))),b.on("end",o),n.add((0,A.$Pc)(()=>b.removeListener("data",t))),b.on("data",t)})}e.$8d=l;function g(b,k){const s=R(k);return s.end(b),s}e.$9d=g;function y(){const b=R(()=>{throw new Error("not supported")});return b.end(),b}e.$0d=y;function p(b){let k=!1;return{read:()=>k?null:(k=!0,b)}}e.$$d=p;function c(b,k,s){const a=R(s);return w(b,{onData:n=>a.write(k.data(n)),onError:n=>a.error(k.error?k.error(n):n),onEnd:()=>a.end()}),a}e.$_d=c;function f(b,k,s){let a=!1;return{read:()=>{const n=k.read();return a?n:(a=!0,n!==null?s([b,n]):b)}}}e.$ae=f;function u(b,k,s){let a=!1;const n=R(s);return w(k,{onData:i=>a?n.write(i):(a=!0,n.write(s([b,i]))),onError:i=>n.error(i),onEnd:()=>{a||(a=!0,n.write(b)),n.end()}}),n}e.$be=u}),define(ae[15],ce([0,1,61,46]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=void 0;const L=typeof Buffer<"u",j=new I.$U(()=>new Uint8Array(256));let O,R;class S{static alloc($){return L?new S(Buffer.allocUnsafe($)):new S(new Uint8Array($))}static wrap($){return L&&!Buffer.isBuffer($)&&($=Buffer.from($.buffer,$.byteOffset,$.byteLength)),new S($)}static fromString($,D){return!(D?.dontUseNodeBuffer||!1)&&L?new S(Buffer.from($)):(O||(O=new TextEncoder),new S(O.encode($)))}static fromByteArray($){const D=S.alloc($.length);for(let F=0,M=$.length;F<M;F++)D.buffer[F]=$[F];return D}static concat($,D){if(typeof D>"u"){D=0;for(let U=0,q=$.length;U<q;U++)D+=$[U].byteLength}const F=S.alloc(D);let M=0;for(let U=0,q=$.length;U<q;U++){const Y=$[U];F.set(Y,M),M+=Y.byteLength}return F}constructor($){this.buffer=$,this.byteLength=this.buffer.byteLength}clone(){const $=S.alloc(this.byteLength);return $.set(this),$}toString(){return L?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice($,D){return new S(this.buffer.subarray($,D))}set($,D){if($ instanceof S)this.buffer.set($.buffer,D);else if($ instanceof Uint8Array)this.buffer.set($,D);else if($ instanceof ArrayBuffer)this.buffer.set(new Uint8Array($),D);else if(ArrayBuffer.isView($))this.buffer.set(new Uint8Array($.buffer,$.byteOffset,$.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE($){return w(this.buffer,$)}writeUInt32BE($,D){l(this.buffer,$,D)}readUInt32LE($){return g(this.buffer,$)}writeUInt32LE($,D){y(this.buffer,$,D)}readUInt8($){return p(this.buffer,$)}writeUInt8($,D){c(this.buffer,$,D)}indexOf($,D=0){return d(this.buffer,$ instanceof S?$.buffer:$,D)}}e.$ce=S;function d(h,$,D=0){const F=$.byteLength,M=h.byteLength;if(F===0)return 0;if(F===1)return h.indexOf($[0]);if(F>M-D)return-1;const U=j.value;U.fill($.length);for(let x=0;x<$.length;x++)U[$[x]]=$.length-x-1;let q=D+$.length-1,Y=q,K=-1;for(;q<M;)if(h[q]===$[Y]){if(Y===0){K=q;break}q--,Y--}else q+=Math.max($.length-Y,U[h[q]]),Y=$.length-1;return K}e.$de=d;function C(h,$){return h[$+0]<<0>>>0|h[$+1]<<8>>>0}e.$ee=C;function E(h,$,D){h[D+0]=$&255,$=$>>>8,h[D+1]=$&255}e.$fe=E;function w(h,$){return h[$]*2**24+h[$+1]*2**16+h[$+2]*2**8+h[$+3]}e.$ge=w;function l(h,$,D){h[D+3]=$,$=$>>>8,h[D+2]=$,$=$>>>8,h[D+1]=$,$=$>>>8,h[D]=$}e.$he=l;function g(h,$){return h[$+0]<<0>>>0|h[$+1]<<8>>>0|h[$+2]<<16>>>0|h[$+3]<<24>>>0}e.$ie=g;function y(h,$,D){h[D+0]=$&255,$=$>>>8,h[D+1]=$&255,$=$>>>8,h[D+2]=$&255,$=$>>>8,h[D+3]=$&255}e.$je=y;function p(h,$){return h[$]}e.$ke=p;function c(h,$,D){h[D]=$}e.$le=c;function f(h){return A.$4d(h,$=>S.concat($))}e.$me=f;function u(h){return A.$$d(h)}e.$ne=u;function b(h){return A.$6d(h,$=>S.concat($))}e.$oe=b;async function k(h){return h.ended?S.concat(h.buffer):S.concat([...h.buffer,await b(h.stream)])}e.$pe=k;function s(h){return A.$9d(h,$=>S.concat($))}e.$qe=s;function a(h){return A.$_d(h,{data:$=>typeof $=="string"?S.fromString($):S.wrap($)},$=>S.concat($))}e.$re=a;function n(h){return A.$3d($=>S.concat($),h)}e.$se=n;function i(h,$){return A.$ae(h,$,D=>S.concat(D))}e.$te=i;function t(h,$){return A.$be(h,$,D=>S.concat(D))}e.$ue=t;function r(h){let $=0,D=0,F=0;const M=new Uint8Array(Math.floor(h.length/4*3)),U=Y=>{switch(D){case 3:M[F++]=$|Y,D=0;break;case 2:M[F++]=$|Y>>>2,$=Y<<6,D=3;break;case 1:M[F++]=$|Y>>>4,$=Y<<4,D=2;break;default:$=Y<<2,D=1}};for(let Y=0;Y<h.length;Y++){const K=h.charCodeAt(Y);if(K>=65&&K<=90)U(K-65);else if(K>=97&&K<=122)U(K-97+26);else if(K>=48&&K<=57)U(K-48+52);else if(K===43||K===45)U(62);else if(K===47||K===95)U(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${h[Y]}`)}}const q=F;for(;D>0;)U(0);return S.wrap(M).slice(0,q)}e.$ve=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:h},$=!0,D=!1){const F=D?v:o;let M="";const U=h.byteLength%3;let q=0;for(;q<h.byteLength-U;q+=3){const Y=h[q+0],K=h[q+1],x=h[q+2];M+=F[Y>>>2],M+=F[(Y<<4|K>>>4)&63],M+=F[(K<<2|x>>>6)&63],M+=F[x&63]}if(U===1){const Y=h[q+0];M+=F[Y>>>2],M+=F[Y<<4&63],$&&(M+="==")}else if(U===2){const Y=h[q+0],K=h[q+1];M+=F[Y>>>2],M+=F[(Y<<4|K>>>4)&63],M+=F[K<<2&63],$&&(M+="=")}return M}e.$we=m}),define(ae[27],ce([0,1,128,61]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yf=e.$xf=e.$wf=e.$vf=e.GraphemeBreakType=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=void 0;function L(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.$Ce=L;const j=/{(\d+)}/g;function O(re,...fe){return fe.length===0?re:re.replace(j,function(me,ye){const ke=parseInt(ye,10);return isNaN(ke)||ke<0||ke>=fe.length?me:fe[ke]})}e.$De=O;const R=/{([^}]+)}/g;function S(re,fe){return Object.keys(fe).length===0?re:re.replace(R,(me,ye)=>fe[ye]??me)}e.$Ee=S;function d(re){return re.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$Fe=d;function C(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ge=C;function E(re,fe){let me=0;const ye=fe.charCodeAt(0);for(let ke=re.length-1;ke>=0;ke--)re.charCodeAt(ke)===ye&&me++;return me}e.$He=E;function w(re,fe,me="\u2026"){return re.length<=fe?re:`${re.substr(0,fe)}${me}`}e.$Ie=w;function l(re,fe=" "){const me=g(re,fe);return y(me,fe)}e.$Je=l;function g(re,fe){if(!re||!fe)return re;const me=fe.length;if(me===0||re.length===0)return re;let ye=0;for(;re.indexOf(fe,ye)===ye;)ye=ye+me;return re.substring(ye)}e.$Ke=g;function y(re,fe){if(!re||!fe)return re;const me=fe.length,ye=re.length;if(me===0||ye===0)return re;let ke=ye,Re=-1;for(;Re=re.lastIndexOf(fe,ke-1),!(Re===-1||Re+me!==ke);){if(Re===0)return"";ke=Re}return re.substring(0,ke)}e.$Le=y;function p(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Me=p;function c(re){return re.replace(/\*/g,"")}e.$Ne=c;function f(re,fe,me={}){if(!re)throw new Error("Cannot create regex from empty string");fe||(re=C(re)),me.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let ye="";return me.global&&(ye+="g"),me.matchCase||(ye+="i"),me.multiline&&(ye+="m"),me.unicode&&(ye+="u"),new RegExp(re,ye)}e.$Oe=f;function u(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.$Pe=u;function b(re){return re.split(/\r\n|\r|\n/)}e.$Qe=b;function k(re){for(let fe=0,me=re.length;fe<me;fe++){const ye=re.charCodeAt(fe);if(ye!==32&&ye!==9)return fe}return-1}e.$Re=k;function s(re,fe=0,me=re.length){for(let ye=fe;ye<me;ye++){const ke=re.charCodeAt(ye);if(ke!==32&&ke!==9)return re.substring(fe,ye)}return re.substring(fe,me)}e.$Se=s;function a(re,fe=re.length-1){for(let me=fe;me>=0;me--){const ye=re.charCodeAt(me);if(ye!==32&&ye!==9)return me}return-1}e.$Te=a;function n(re,fe,me){const ye=[];let ke=0;for(const Re of re.matchAll(fe)){if(ye.push(re.slice(ke,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ke=Re.index+Re[0].length,ye.push(me(Re[0],...Re.slice(1),Re.index,re,Re.groups))}return ye.push(re.slice(ke)),Promise.all(ye).then(Re=>Re.join(""))}e.$Ue=n;function i(re,fe){return re<fe?-1:re>fe?1:0}e.$Ve=i;function t(re,fe,me=0,ye=re.length,ke=0,Re=fe.length){for(;me<ye&&ke<Re;me++,ke++){const De=re.charCodeAt(me),Ae=fe.charCodeAt(ke);if(De<Ae)return-1;if(De>Ae)return 1}const Ce=ye-me,Ie=Re-ke;return Ce<Ie?-1:Ce>Ie?1:0}e.$We=t;function r(re,fe){return o(re,fe,0,re.length,0,fe.length)}e.$Xe=r;function o(re,fe,me=0,ye=re.length,ke=0,Re=fe.length){for(;me<ye&&ke<Re;me++,ke++){let De=re.charCodeAt(me),Ae=fe.charCodeAt(ke);if(De===Ae)continue;if(De>=128||Ae>=128)return t(re.toLowerCase(),fe.toLowerCase(),me,ye,ke,Re);m(De)&&(De-=32),m(Ae)&&(Ae-=32);const Te=De-Ae;if(Te!==0)return Te}const Ce=ye-me,Ie=Re-ke;return Ce<Ie?-1:Ce>Ie?1:0}e.$Ye=o;function v(re){return re>=48&&re<=57}e.$Ze=v;function m(re){return re>=97&&re<=122}e.$1e=m;function h(re){return re>=65&&re<=90}e.$2e=h;function $(re,fe){return re.length===fe.length&&o(re,fe)===0}e.$3e=$;function D(re,fe){const me=fe.length;return fe.length>re.length?!1:o(re,fe,0,me)===0}e.$4e=D;function F(re,fe){const me=Math.min(re.length,fe.length);let ye;for(ye=0;ye<me;ye++)if(re.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return me}e.$5e=F;function M(re,fe){const me=Math.min(re.length,fe.length);let ye;const ke=re.length-1,Re=fe.length-1;for(ye=0;ye<me;ye++)if(re.charCodeAt(ke-ye)!==fe.charCodeAt(Re-ye))return ye;return me}e.$6e=M;function U(re){return 55296<=re&&re<=56319}e.$7e=U;function q(re){return 56320<=re&&re<=57343}e.$8e=q;function Y(re,fe){return(re-55296<<10)+(fe-56320)+65536}e.$9e=Y;function K(re,fe,me){const ye=re.charCodeAt(me);if(U(ye)&&me+1<fe){const ke=re.charCodeAt(me+1);if(q(ke))return Y(ye,ke)}return ye}e.$0e=K;function x(re,fe){const me=re.charCodeAt(fe-1);if(q(me)&&fe>1){const ye=re.charCodeAt(fe-2);if(U(ye))return Y(ye,me)}return me}class H{get offset(){return this.e}constructor(fe,me=0){this.c=fe,this.d=fe.length,this.e=me}setOffset(fe){this.e=fe}prevCodePoint(){const fe=x(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=K(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$$e=H;class Q{get offset(){return this.c.offset}constructor(fe,me=0){this.c=new H(fe,me)}nextGraphemeLength(){const fe=$e.getInstance(),me=this.c,ye=me.offset;let ke=fe.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.nextCodePoint());if(Me(ke,Ce)){me.setOffset(Re);break}ke=Ce}return me.offset-ye}prevGraphemeLength(){const fe=$e.getInstance(),me=this.c,ye=me.offset;let ke=fe.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.prevCodePoint());if(Me(Ce,ke)){me.setOffset(Re);break}ke=Ce}return ye-me.offset}eol(){return this.c.eol()}}e.$_e=Q;function J(re,fe){return new Q(re,fe).nextGraphemeLength()}e.$af=J;function W(re,fe){return new Q(re,fe).prevGraphemeLength()}e.$bf=W;function ee(re,fe){fe>0&&q(re.charCodeAt(fe))&&fe--;const me=fe+J(re,fe);return[me-W(re,me),me]}e.$cf=ee;function ne(re){const fe=new Q(re);let me=0;for(;!fe.eol();)me++,fe.nextGraphemeLength();return me}e.$df=ne;let _;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Z(re){return _||(_=se()),_.test(re)}e.$ef=Z;const z=/^[\t\n\r\x20-\x7E]*$/;function P(re){return z.test(re)}e.$ff=P,e.$gf=/[\u2028\u2029]/;function T(re){return e.$gf.test(re)}e.$hf=T;function B(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.$if=B;function N(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.$jf=N;function V(re,fe){if(re.length<fe)return re;const me=/\b/g;let ye=0;for(;me.test(re)&&!(re.length-me.lastIndex<fe);)ye=me.lastIndex,me.lastIndex+=1;return re.substring(ye).replace(/^\s/,"")}e.$kf=V;const G=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,te=/\x1b\].*?\x07/g;function oe(re){return re&&(re=re.replace(G,"").replace(te,"")),re}e.$lf=oe,e.$mf=String.fromCharCode(65279);function ue(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.$nf=ue;function he(re){return ue(re)?re.substr(1):re}e.$of=he;function ge(re,fe){if(!re||!fe||re.length<fe.length)return!1;const me=fe.length,ye=re.toLowerCase();let ke=0,Re=-1;for(;ke<me;){const Ce=ye.indexOf(fe[ke],Re+1);if(Ce<0)return!1;Re=Ce,ke++}return!0}e.$pf=ge;function de(re,fe=!1){return re?(fe&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.$qf=de;function we(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.$rf=we;function ve(re,fe=1){if(fe===0)return"";let me=-1;do me=re.indexOf(`
`,me+1),fe--;while(fe>0&&me>=0);return me===-1?re:(re[me-1]==="\r"&&me--,re.substr(0,me))}e.$sf=ve;function Oe(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}e.$tf=Oe;function Ne(re){return $e.getInstance().getGraphemeBreakType(re)}e.$uf=Ne;function Me(re,fe){return re===0?fe!==5&&fe!==7:re===2&&fe===3?!1:re===4||re===2||re===3||fe===4||fe===2||fe===3?!0:!(re===8&&(fe===8||fe===9||fe===11||fe===12)||(re===11||re===9)&&(fe===9||fe===10)||(re===12||re===10)&&fe===10||fe===5||fe===13||fe===7||re===1||re===13&&fe===14||re===6&&fe===6)}var le;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(le||(e.GraphemeBreakType=le={}));class $e{static{this.c=null}static getInstance(){return $e.c||($e.c=new $e),$e.c}constructor(){this.d=be()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const me=this.d,ye=me.length/3;let ke=1;for(;ke<=ye;)if(fe<me[3*ke])ke=2*ke;else if(fe>me[3*ke+1])ke=2*ke+1;else return me[3*ke+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(re,fe){if(re===0)return 0;const me=Pe(re,fe);if(me!==void 0)return me;const ye=new H(fe,re);return ye.prevCodePoint(),ye.offset}e.$vf=Se;function Pe(re,fe){const me=new H(fe,re);let ye=me.prevCodePoint();for(;Ue(ye)||ye===65039||ye===8419;){if(me.offset===0)return;ye=me.prevCodePoint()}if(!N(ye))return;let ke=me.offset;return ke>0&&me.prevCodePoint()===8205&&(ke=me.offset),ke}function Ue(re){return 127995<=re&&re<=127999}var je;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.$wf="\xA0";class ze{static{this.c=new A.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$ye(fe=>{function me(Te){const Be=new Map;for(let qe=0;qe<Te.length;qe+=2)Be.set(Te[qe],Te[qe+1]);return Be}function ye(Te,Be){const qe=new Map(Te);for(const[We,_e]of Be)qe.set(We,_e);return qe}function ke(Te,Be){if(!Te)return Be;const qe=new Map;for(const[We,_e]of Te)Be.has(We)&&qe.set(We,_e);return qe}const Re=this.c.value;let Ce=fe.filter(Te=>!Te.startsWith("_")&&Te in Re);Ce.length===0&&(Ce=["_default"]);let Ie;for(const Te of Ce){const Be=me(Re[Te]);Ie=ke(Ie,Be)}const De=me(Re._common),Ae=ye(De,Ie);return new ze(Ae)})}static getInstance(fe){return ze.d.get(Array.from(fe))}static{this.e=new A.$U(()=>Object.keys(ze.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return ze.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$xf=ze;class Fe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Fe.c())),this.d}static isInvisibleCharacter(fe){return Fe.e().has(fe)}static get codePoints(){return Fe.e()}}e.$yf=Fe}),define(ae[52],ce([0,1,27]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;function A(c){return L(c,0)}e.$Gi=A;function L(c,f){switch(typeof c){case"object":return c===null?j(349,f):Array.isArray(c)?S(c,f):d(c,f);case"string":return R(c,f);case"boolean":return O(c,f);case"number":return j(c,f);case"undefined":return j(937,f);default:return j(617,f)}}e.$Hi=L;function j(c,f){return(f<<5)-f+c|0}e.$Ii=j;function O(c,f){return j(c?433:863,f)}function R(c,f){f=j(149417,f);for(let u=0,b=c.length;u<b;u++)f=j(c.charCodeAt(u),f);return f}e.$Ji=R;function S(c,f){return f=j(104579,f),c.reduce((u,b)=>L(b,u),f)}function d(c,f){return f=j(181387,f),Object.keys(c).sort().reduce((u,b)=>(u=R(b,u),L(c[b],u)),f)}class C{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=L(f,this.g),this.g}}e.$Ki=C;var E;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function w(c,f,u=32){const b=u-f,k=~((1<<b)-1);return(c<<f|(k&c)>>>b)>>>0}function l(c,f=0,u=c.byteLength,b=0){for(let k=0;k<u;k++)c[f+k]=b}function g(c,f,u="0"){for(;c.length<f;)c=u+c;return c}function y(c,f=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(u=>u.toString(16).padStart(2,"0")).join(""):g((c>>>0).toString(16),f/4)}e.$Li=y;class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const u=f.length;if(u===0)return;const b=this.p;let k=this.r,s=this.u,a,n;for(s!==0?(a=s,n=-1,s=0):(a=f.charCodeAt(0),n=0);;){let i=a;if(I.$7e(a))if(n+1<u){const t=f.charCodeAt(n+1);I.$8e(t)?(n++,i=I.$9e(a,t)):i=65533}else{s=a;break}else I.$8e(a)&&(i=65533);if(k=this.w(b,k,i),n++,n<u)a=f.charCodeAt(n);else break}this.r=k,this.u=s}w(f,u,b){return b<128?f[u++]=b:b<2048?(f[u++]=192|(b&1984)>>>6,f[u++]=128|(b&63)>>>0):b<65536?(f[u++]=224|(b&61440)>>>12,f[u++]=128|(b&4032)>>>6,f[u++]=128|(b&63)>>>0):(f[u++]=240|(b&1835008)>>>18,f[u++]=128|(b&258048)>>>12,f[u++]=128|(b&4032)>>>6,f[u++]=128|(b&63)>>>0),u>=64&&(this.y(),u-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),u}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=p.g,u=this.q;for(let o=0;o<64;o+=4)f.setUint32(o,u.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)f.setUint32(o,w(f.getUint32(o-12,!1)^f.getUint32(o-32,!1)^f.getUint32(o-56,!1)^f.getUint32(o-64,!1),1),!1);let b=this.h,k=this.l,s=this.m,a=this.n,n=this.o,i,t,r;for(let o=0;o<80;o++)o<20?(i=k&s|~k&a,t=1518500249):o<40?(i=k^s^a,t=1859775393):o<60?(i=k&s|k&a|s&a,t=2400959708):(i=k^s^a,t=3395469782),r=w(b,5)+i+n+t+f.getUint32(o*4,!1)&4294967295,n=a,a=s,s=w(k,30),k=b,b=r;this.h=this.h+b&4294967295,this.l=this.l+k&4294967295,this.m=this.m+s&4294967295,this.n=this.n+a&4294967295,this.o=this.o+n&4294967295}}e.$Mi=p}),define(ae[89],ce([0,1,27]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(A||(A={})),function(L){const j="error",O="warning",R="warn",S="info",d="ignore";function C(w){return w?I.$3e(j,w)?L.Error:I.$3e(O,w)||I.$3e(R,w)?L.Warning:I.$3e(S,w)?L.Info:L.Ignore:L.Ignore}L.fromValue=C;function E(w){switch(w){case L.Error:return j;case L.Warning:return O;case L.Info:return S;default:return d}}L.toString=E}(A||(A={})),e.default=A}),define(ae[129],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Ld=Symbol("MicrotaskDelay")}),define(ae[47],ce([0,1,18,27]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=void 0;class L{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const g=l.charCodeAt(0),y=this.b.charCodeAt(this.c);return g-y}value(){return this.b[this.c]}}e.$Uh=L;class j{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,A.$We)(l,this.b,0,l.length,this.c,this.d):(0,A.$Ye)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Vh=j;class O{constructor(l=!0,g=!0){this.f=l,this.g=g}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let g=l.length-1;g>=0;g--,this.c--){const y=this.b.charCodeAt(g);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,A.$We)(l,this.b,0,l.length,this.d,this.e):(0,A.$Ye)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Wh=O;var R;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(R||(R={}));class S{constructor(l,g){this.f=l,this.g=g,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,A.$Xe)(l,this.c.scheme);if(this.d[this.e]===2)return(0,A.$Xe)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,A.$Ve)(l,this.c.query);if(this.d[this.e]===5)return(0,A.$Ve)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Xh=S;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(C||(C={}));class E{static forUris(l=()=>!1,g=()=>!1){return new E(new S(l,g))}static forPaths(l=!1){return new E(new O(void 0,!l))}static forStrings(){return new E(new L)}static forConfigKeys(){return new E(new j)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,g){if(g){const y=g.slice(0);(0,I.$Wb)(y);for(const p of y)this.set(p,l)}else{const y=l.slice(0);(0,I.$Wb)(y);for(const p of y)this.set(p[0],p[1])}}set(l,g){const y=this.b.reset(l);let p;this.c||(this.c=new d,this.c.segment=y.value());const c=[];for(p=this.c;;){const u=y.cmp(p.segment);if(u>0)p.left||(p.left=new d,p.left.segment=y.value()),c.push([-1,p]),p=p.left;else if(u<0)p.right||(p.right=new d,p.right.segment=y.value()),c.push([1,p]),p=p.right;else if(y.hasNext())y.next(),p.mid||(p.mid=new d,p.mid.segment=y.value()),c.push([0,p]),p=p.mid;else break}const f=p.value;p.value=g,p.key=l;for(let u=c.length-1;u>=0;u--){const b=c[u][1];b.updateHeight();const k=b.balanceFactor();if(k<-1||k>1){const s=c[u][0],a=c[u+1][0];if(s===1&&a===1)c[u][1]=b.rotateLeft();else if(s===-1&&a===-1)c[u][1]=b.rotateRight();else if(s===1&&a===-1)b.right=c[u+1][1]=c[u+1][1].rotateRight(),c[u][1]=b.rotateLeft();else if(s===-1&&a===1)b.left=c[u+1][1]=c[u+1][1].rotateLeft(),c[u][1]=b.rotateRight();else throw new Error;if(u>0)switch(c[u-1][0]){case-1:c[u-1][1].left=c[u][1];break;case 1:c[u-1][1].right=c[u][1];break;case 0:c[u-1][1].mid=c[u][1];break}else this.c=c[0][1]}}return f}get(l){return this.d(l)?.value}d(l){const g=this.b.reset(l);let y=this.c;for(;y;){const p=g.cmp(y.segment);if(p>0)y=y.left;else if(p<0)y=y.right;else if(g.hasNext())g.next(),y=y.mid;else break}return y}has(l){const g=this.d(l);return!(g?.value===void 0&&g?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,g){const y=this.b.reset(l),p=[];let c=this.c;for(;c;){const f=y.cmp(c.segment);if(f>0)p.push([-1,c]),c=c.left;else if(f<0)p.push([1,c]),c=c.right;else if(y.hasNext())y.next(),p.push([0,c]),c=c.mid;else break}if(c){if(g?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const f=this.f(c.right);if(f.key){const{key:u,value:b,segment:k}=f;this.e(f.key,!1),c.key=u,c.value=b,c.segment=k}}else{const f=c.left??c.right;if(p.length>0){const[u,b]=p[p.length-1];switch(u){case-1:b.left=f;break;case 0:b.mid=f;break;case 1:b.right=f;break}}else this.c=f}for(let f=p.length-1;f>=0;f--){const u=p[f][1];u.updateHeight();const b=u.balanceFactor();if(b>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),p[f][1]=u.rotateLeft()):b<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),p[f][1]=u.rotateRight()),f>0)switch(p[f-1][0]){case-1:p[f-1][1].left=p[f][1];break;case 1:p[f-1][1].right=p[f][1];break;case 0:p[f-1][1].mid=p[f][1];break}else this.c=p[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const g=this.b.reset(l);let y=this.c,p;for(;y;){const c=g.cmp(y.segment);if(c>0)y=y.left;else if(c<0)y=y.right;else if(g.hasNext())g.next(),p=y.value||p,y=y.mid;else break}return y&&y.value||p}findSuperstr(l){return this.g(l,!1)}g(l,g){const y=this.b.reset(l);let p=this.c;for(;p;){const c=y.cmp(p.segment);if(c>0)p=p.left;else if(c<0)p=p.right;else if(y.hasNext())y.next(),p=p.mid;else return p.mid?this.h(p.mid):g?p.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[g,y]of this)l(y,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const g=[];return this.j(l,g),g[Symbol.iterator]()}j(l,g){l&&(l.left&&this.j(l.left,g),l.value&&g.push([l.key,l.value]),l.mid&&this.j(l.mid,g),l.right&&this.j(l.right,g))}_isBalanced(){const l=g=>{if(!g)return!0;const y=g.balanceFactor();return y<-1||y>1?!1:l(g.left)&&l(g.right)};return l(this.c)}}e.$Yh=E}),define(ae[12],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=void 0;function I(k){return typeof k=="string"}e.$zf=I;function A(k){return Array.isArray(k)&&k.every(s=>I(s))}e.$Af=A;function L(k){return typeof k=="object"&&k!==null&&!Array.isArray(k)&&!(k instanceof RegExp)&&!(k instanceof Date)}e.$Bf=L;function j(k){const s=Object.getPrototypeOf(Uint8Array);return typeof k=="object"&&k instanceof s}e.$Cf=j;function O(k){return typeof k=="number"&&!isNaN(k)}e.$Df=O;function R(k){return!!k&&typeof k[Symbol.iterator]=="function"}e.$Ef=R;function S(k){return k===!0||k===!1}e.$Ff=S;function d(k){return typeof k>"u"}e.$Gf=d;function C(k){return!E(k)}e.$Hf=C;function E(k){return d(k)||k===null}e.$If=E;function w(k,s){if(!k)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.$Jf=w;function l(k){if(E(k))throw new Error("Assertion Failed: argument is undefined or null");return k}e.$Kf=l;function g(...k){const s=[];for(let a=0;a<k.length;a++){const n=k[a];if(E(n))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);s.push(n)}return s}e.$Lf=g;const y=Object.prototype.hasOwnProperty;function p(k){if(!L(k))return!1;for(const s in k)if(y.call(k,s))return!1;return!0}e.$Mf=p;function c(k){return typeof k=="function"}e.$Nf=c;function f(...k){return k.length>0&&k.every(c)}e.$Of=f;function u(k,s){const a=Math.min(k.length,s.length);for(let n=0;n<a;n++)b(k[n],s[n])}e.$Pf=u;function b(k,s){if(I(s)){if(typeof k!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(c(s)){try{if(k instanceof s)return}catch{}if(!E(k)&&k.constructor===s||s.length===1&&s.call(void 0,k)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Qf=b}),define(ae[30],ce([0,1,12]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=void 0;function A(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const f=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([u,b])=>{f[u]=b&&typeof b=="object"?A(b):b}),f}e.$0m=A;function L(c){if(!c||typeof c!="object")return c;const f=[c];for(;f.length>0;){const u=f.shift();Object.freeze(u);for(const b in u)if(j.call(u,b)){const k=u[b];typeof k=="object"&&!Object.isFrozen(k)&&!(0,I.$Cf)(k)&&f.push(k)}}return c}e.$$m=L;const j=Object.prototype.hasOwnProperty;function O(c,f){return R(c,f,new Set)}e.$_m=O;function R(c,f,u){if((0,I.$If)(c))return c;const b=f(c);if(typeof b<"u")return b;if(Array.isArray(c)){const k=[];for(const s of c)k.push(R(s,f,u));return k}if((0,I.$Bf)(c)){if(u.has(c))throw new Error("Cannot clone recursive data-structure");u.add(c);const k={};for(const s in c)j.call(c,s)&&(k[s]=R(c[s],f,u));return u.delete(c),k}return c}function S(c,f,u=!0){return(0,I.$Bf)(c)?((0,I.$Bf)(f)&&Object.keys(f).forEach(b=>{b in c?u&&((0,I.$Bf)(c[b])&&(0,I.$Bf)(f[b])?S(c[b],f[b],u):c[b]=f[b]):c[b]=f[b]}),c):f}e.$an=S;function d(c,f){if(c===f)return!0;if(c==null||f===null||f===void 0||typeof c!=typeof f||typeof c!="object"||Array.isArray(c)!==Array.isArray(f))return!1;let u,b;if(Array.isArray(c)){if(c.length!==f.length)return!1;for(u=0;u<c.length;u++)if(!d(c[u],f[u]))return!1}else{const k=[];for(b in c)k.push(b);k.sort();const s=[];for(b in f)s.push(b);if(s.sort(),!d(k,s))return!1;for(u=0;u<k.length;u++)if(!d(c[k[u]],f[k[u]]))return!1}return!0}e.$bn=d;function C(c){const f=new Set;return JSON.stringify(c,(u,b)=>{if((0,I.$Bf)(b)||Array.isArray(b)){if(f.has(b))return"[Circular]";f.add(b)}return b})}e.$cn=C;function E(c,f){const u=Object.create(null);return!c||!f||Object.keys(f).forEach(k=>{const s=c[k],a=f[k];d(s,a)||(u[k]=a)}),u}e.$dn=E;function w(c,f){const u=f.toLowerCase(),b=Object.keys(c).find(k=>k.toLowerCase()===u);return b?c[b]:c[f]}e.$en=w;function l(c,f){const u=Object.create(null);for(const[b,k]of Object.entries(c))f(b,k)&&(u[b]=k);return u}e.$fn=l;function g(c){let f=[];for(;Object.prototype!==c;)f=f.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return f}e.$gn=g;function y(c){const f=[];for(const u of g(c))typeof c[u]=="function"&&f.push(u);return f}e.$hn=y;function p(c,f){const u=k=>function(){const s=Array.prototype.slice.call(arguments,0);return f(k,s)},b={};for(const k of c)b[k]=u(k);return b}e.$in=p}),define(ae[32],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(L){return I.test(L)}e.$eg=A,e.$fg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(R){for(let S=0;S<R.length;S++)R[S]=Math.floor(Math.random()*256);return R};const j=new Uint8Array(16),O=[];for(let R=0;R<256;R++)O.push(R.toString(16).padStart(2,"0"));return function(){L(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let S=0,d="";return d+=O[j[S++]],d+=O[j[S++]],d+=O[j[S++]],d+=O[j[S++]],d+="-",d+=O[j[S++]],d+=O[j[S++]],d+="-",d+=O[j[S++]],d+=O[j[S++]],d+="-",d+=O[j[S++]],d+=O[j[S++]],d+="-",d+=O[j[S++]],d+=O[j[S++]],d+=O[j[S++]],d+=O[j[S++]],d+=O[j[S++]],d+=O[j[S++]],d}}()}),define(ae[130],ce([0,1,36]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(O){const R=O.replace(/\-/g,":").toLowerCase();return!A.has(R)}function j(){const O=(0,I.networkInterfaces)();for(const R in O){const S=O[R];if(S){for(const{mac:d}of S)if(L(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Tm=j}),define(ae[131],ce([0,1,267,15]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LT=void 0;class L extends I.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const R=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(O,R,S){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let d=0;for(;d<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,d):(0,A.$de)(this.a,this.b,d);if(C===-1)break;this.push(this.a.slice(d,C+this.c)),d=C+this.c}this.a=d===this.a.length?void 0:this.a.slice(d),S()}_flush(O){this.a&&this.push(this.a),O()}}e.$LT=L}),define(ae[132],ce([0,1,63]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=e.$ig=e.$hg=void 0;function A(R,S,d,C=1){let E=!1;return new Promise(w=>{const l=setTimeout(()=>{if(!E)return E=!0,w(0)},d);L(R,S,C,g=>{if(!E)return E=!0,clearTimeout(l),w(g)})})}e.$hg=A;function L(R,S,d,C){if(S===0)return C(0);const E=new I.Socket;E.once("connect",()=>(O(E),L(R+d,S-1,d,C))),E.once("data",()=>{}),E.once("error",w=>(O(E),w.code!=="ECONNREFUSED"?L(R+d,S-1,d,C):C(R))),E.connect(R,"127.0.0.1")}e.$ig={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(R,S,d,C="127.0.0.1"){let E=!1,w,l=1;const g=I.createServer({pauseOnConnect:!0});function y(p,c){E||(E=!0,g.removeAllListeners(),g.close(),w&&clearTimeout(w),c(p))}return new Promise(p=>{w=setTimeout(()=>{y(0,p)},d),g.on("listening",()=>{y(R,p)}),g.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&l<S?(R++,l++,g.listen(R,C)):y(0,p)}),g.on("close",()=>{y(0,p)}),g.listen(R,C)})}e.$jg=j;function O(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(S){console.error(S)}}}),define(ae[133],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2T=void 0;function I(A){return!!A.parentPort}e.$2T=I}),define(ae[134],ce([13,9]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(ae[64],ce([0,1,134]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=e.$gm=void 0;const A=60,L=A*60,j=L*24,O=j*7,R=j*30,S=j*365;function d(E,w,l,g){typeof E!="number"&&(E=E.getTime());const y=Math.round((new Date().getTime()-E)/1e3);if(y<-30)return(0,I.localize)(0,null,d(new Date().getTime()+y*1e3,!1));if(!g&&y<30)return(0,I.localize)(1,null);let p;return y<A?(p=y,w?p===1?l?(0,I.localize)(2,null,p):(0,I.localize)(3,null,p):l?(0,I.localize)(4,null,p):(0,I.localize)(5,null,p):p===1?l?(0,I.localize)(6,null,p):(0,I.localize)(7,null,p):l?(0,I.localize)(8,null,p):(0,I.localize)(9,null,p)):y<L?(p=Math.floor(y/A),w?p===1?l?(0,I.localize)(10,null,p):(0,I.localize)(11,null,p):l?(0,I.localize)(12,null,p):(0,I.localize)(13,null,p):p===1?l?(0,I.localize)(14,null,p):(0,I.localize)(15,null,p):l?(0,I.localize)(16,null,p):(0,I.localize)(17,null,p)):y<j?(p=Math.floor(y/L),w?p===1?l?(0,I.localize)(18,null,p):(0,I.localize)(19,null,p):l?(0,I.localize)(20,null,p):(0,I.localize)(21,null,p):p===1?l?(0,I.localize)(22,null,p):(0,I.localize)(23,null,p):l?(0,I.localize)(24,null,p):(0,I.localize)(25,null,p)):y<O?(p=Math.floor(y/j),w?p===1?(0,I.localize)(26,null,p):(0,I.localize)(27,null,p):p===1?(0,I.localize)(28,null,p):(0,I.localize)(29,null,p)):y<R?(p=Math.floor(y/O),w?p===1?l?(0,I.localize)(30,null,p):(0,I.localize)(31,null,p):l?(0,I.localize)(32,null,p):(0,I.localize)(33,null,p):p===1?l?(0,I.localize)(34,null,p):(0,I.localize)(35,null,p):l?(0,I.localize)(36,null,p):(0,I.localize)(37,null,p)):y<S?(p=Math.floor(y/R),w?p===1?l?(0,I.localize)(38,null,p):(0,I.localize)(39,null,p):l?(0,I.localize)(40,null,p):(0,I.localize)(41,null,p):p===1?l?(0,I.localize)(42,null,p):(0,I.localize)(43,null,p):l?(0,I.localize)(44,null,p):(0,I.localize)(45,null,p)):(p=Math.floor(y/S),w?p===1?l?(0,I.localize)(46,null,p):(0,I.localize)(47,null,p):l?(0,I.localize)(48,null,p):(0,I.localize)(49,null,p):p===1?l?(0,I.localize)(50,null,p):(0,I.localize)(51,null,p):l?(0,I.localize)(52,null,p):(0,I.localize)(53,null,p))}e.$gm=d;function C(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$hm=C}),define(ae[135],ce([13,9]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(ae[38],ce([0,1,18,12,135]),function(ie,e,I,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=void 0;function j(E,w){return w&&(E.stack||E.stacktrace)?L.localize(0,null,R(E),O(E.stack)||O(E.stacktrace)):R(E)}function O(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?L.localize(1,null,E.message):E.message||L.localize(2,null)}function S(E=null,w=!1){if(!E)return L.localize(3,null);if(Array.isArray(E)){const l=I.$Gb(E),g=S(l[0],w);return l.length>1?L.localize(4,null,g,l.length):g}if(A.$zf(E))return E;if(E.detail){const l=E.detail;if(l.error)return j(l.error,w);if(l.exception)return j(l.exception,w)}return E.stack?j(E,w):E.message?E.message:L.localize(5,null)}e.$Di=S;function d(E){const w=E;return w instanceof Error&&Array.isArray(w.actions)}e.$Ei=d;function C(E,w){let l;return typeof E=="string"?l=new Error(E):l=E,l.actions=w,l}e.$Fi=C}),define(ae[136],ce([13,9]),function(ie,e){return ie.create("vs/base/common/jsonErrorMessages",e)}),define(ae[137],ce([0,1,136]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;function A(L){switch(L){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.$zp=A}),define(ae[138],ce([13,9]),function(ie,e){return ie.create("vs/base/common/platform",e)}),define(ae[5],ce([0,1,138]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let A=!1,L=!1,j=!1,O=!1,R=!1,S=!1,d=!1,C=!1,E=!1,w=!1,l,g=e.$g,y=e.$g,p,c;const f=globalThis;let u;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?u=f.vscode.process:typeof process<"u"&&(u=process);const b=typeof u?.versions?.electron=="string",k=b&&u?.type==="renderer";if(typeof navigator=="object"&&!k)c=navigator.userAgent,A=c.indexOf("Windows")>=0,L=c.indexOf("Macintosh")>=0,C=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=c.indexOf("Linux")>=0,w=c?.indexOf("Mobi")>=0,S=!0,l=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,g=l,y=navigator.language;else if(typeof u=="object"){A=u.platform==="win32",L=u.platform==="darwin",j=u.platform==="linux",O=j&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,d=b,E=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.$g,g=e.$g;const m=u.env.VSCODE_NLS_CONFIG;if(m)try{const h=JSON.parse(m),$=h.availableLanguages["*"];l=h.locale,y=h.osLocale,g=$||e.$g,p=h._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var s;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(s||(e.Platform=s={}));function a(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=a;let n=0;L?n=1:A?n=3:j&&(n=2),e.$i=A,e.$j=L,e.$k=j,e.$l=O,e.$m=R,e.$n=d,e.$o=S,e.$p=S&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=C,e.$s=w,e.$t=E,e.$u=n,e.$v=c,e.$w=g;var i;(function(m){function h(){return e.$w}m.value=h;function $(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}m.isDefaultVariant=$;function D(){return e.$w==="en"}m.isDefault=D})(i||(e.Language=i={})),e.$x=l,e.$y=y,e.$z=p,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const m=[];f.addEventListener("message",$=>{if($.data&&$.data.vscodeScheduleAsyncWork)for(let D=0,F=m.length;D<F;D++){const M=m[D];if(M.id===$.data.vscodeScheduleAsyncWork){m.splice(D,1),M.callback();return}}});let h=0;return $=>{const D=++h;m.push({id:D,callback:$}),f.postMessage({vscodeScheduleAsyncWork:D},"*")}}return m=>setTimeout(m)})();var t;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=L||C?2:A?1:3;let r=!0,o=!1;function v(){if(!o){o=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,r=new Uint16Array(m.buffer)[0]===(2<<8)+1}return r}e.$D=v,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ae[37],ce([0,1,5]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let A;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const j=L.process;A={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return I.$i?"win32":I.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$cc=A.platform,e.$dc=A.arch}),define(ae[16],ce([0,1,37]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const A=65,L=97,j=90,O=122,R=46,S=47,d=92,C=58,E=63;class w extends Error{constructor(a,n,i){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${r} ${t} of type ${n}`;o+=`. Received type ${typeof i}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function l(s,a){if(s===null||typeof s!="object")throw new w(a,"Object",s)}function g(s,a){if(typeof s!="string")throw new w(a,"string",s)}const y=I.$cc==="win32";function p(s){return s===S||s===d}function c(s){return s===S}function f(s){return s>=A&&s<=j||s>=L&&s<=O}function u(s,a,n,i){let t="",r=0,o=-1,v=0,m=0;for(let h=0;h<=s.length;++h){if(h<s.length)m=s.charCodeAt(h);else{if(i(m))break;m=S}if(i(m)){if(!(o===h-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const $=t.lastIndexOf(n);$===-1?(t="",r=0):(t=t.slice(0,$),r=t.length-1-t.lastIndexOf(n)),o=h,v=0;continue}else if(t.length!==0){t="",r=0,o=h,v=0;continue}}a&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${s.slice(o+1,h)}`:t=s.slice(o+1,h),r=h-o-1;o=h,v=0}else m===R&&v!==-1?++v:v=-1}return t}function b(s,a){l(a,"pathObject");const n=a.dir||a.root,i=a.base||`${a.name||""}${a.ext||""}`;return n?n===a.root?`${n}${i}`:`${n}${s}${i}`:i}e.$ec={resolve(...s){let a="",n="",i=!1;for(let t=s.length-1;t>=-1;t--){let r;if(t>=0){if(r=s[t],g(r,"path"),r.length===0)continue}else a.length===0?r=I.cwd():(r=I.env[`=${a}`]||I.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===d)&&(r=`${a}\\`));const o=r.length;let v=0,m="",h=!1;const $=r.charCodeAt(0);if(o===1)p($)&&(v=1,h=!0);else if(p($))if(h=!0,p(r.charCodeAt(1))){let D=2,F=D;for(;D<o&&!p(r.charCodeAt(D));)D++;if(D<o&&D!==F){const M=r.slice(F,D);for(F=D;D<o&&p(r.charCodeAt(D));)D++;if(D<o&&D!==F){for(F=D;D<o&&!p(r.charCodeAt(D));)D++;(D===o||D!==F)&&(m=`\\\\${M}\\${r.slice(F,D)}`,v=D)}}}else v=1;else f($)&&r.charCodeAt(1)===C&&(m=r.slice(0,2),v=2,o>2&&p(r.charCodeAt(2))&&(h=!0,v=3));if(m.length>0)if(a.length>0){if(m.toLowerCase()!==a.toLowerCase())continue}else a=m;if(i){if(a.length>0)break}else if(n=`${r.slice(v)}\\${n}`,i=h,h&&a.length>0)break}return n=u(n,!i,"\\",p),i?`${a}\\${n}`:`${a}${n}`||"."},normalize(s){g(s,"path");const a=s.length;if(a===0)return".";let n=0,i,t=!1;const r=s.charCodeAt(0);if(a===1)return c(r)?"\\":s;if(p(r))if(t=!0,p(s.charCodeAt(1))){let v=2,m=v;for(;v<a&&!p(s.charCodeAt(v));)v++;if(v<a&&v!==m){const h=s.slice(m,v);for(m=v;v<a&&p(s.charCodeAt(v));)v++;if(v<a&&v!==m){for(m=v;v<a&&!p(s.charCodeAt(v));)v++;if(v===a)return`\\\\${h}\\${s.slice(m)}\\`;v!==m&&(i=`\\\\${h}\\${s.slice(m,v)}`,n=v)}}}else n=1;else f(r)&&s.charCodeAt(1)===C&&(i=s.slice(0,2),n=2,a>2&&p(s.charCodeAt(2))&&(t=!0,n=3));let o=n<a?u(s.slice(n),!t,"\\",p):"";return o.length===0&&!t&&(o="."),o.length>0&&p(s.charCodeAt(a-1))&&(o+="\\"),i===void 0?t?`\\${o}`:o:t?`${i}\\${o}`:`${i}${o}`},isAbsolute(s){g(s,"path");const a=s.length;if(a===0)return!1;const n=s.charCodeAt(0);return p(n)||a>2&&f(n)&&s.charCodeAt(1)===C&&p(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let a,n;for(let r=0;r<s.length;++r){const o=s[r];g(o,"path"),o.length>0&&(a===void 0?a=n=o:a+=`\\${o}`)}if(a===void 0)return".";let i=!0,t=0;if(typeof n=="string"&&p(n.charCodeAt(0))){++t;const r=n.length;r>1&&p(n.charCodeAt(1))&&(++t,r>2&&(p(n.charCodeAt(2))?++t:i=!1))}if(i){for(;t<a.length&&p(a.charCodeAt(t));)t++;t>=2&&(a=`\\${a.slice(t)}`)}return e.$ec.normalize(a)},relative(s,a){if(g(s,"from"),g(a,"to"),s===a)return"";const n=e.$ec.resolve(s),i=e.$ec.resolve(a);if(n===i||(s=n.toLowerCase(),a=i.toLowerCase(),s===a))return"";let t=0;for(;t<s.length&&s.charCodeAt(t)===d;)t++;let r=s.length;for(;r-1>t&&s.charCodeAt(r-1)===d;)r--;const o=r-t;let v=0;for(;v<a.length&&a.charCodeAt(v)===d;)v++;let m=a.length;for(;m-1>v&&a.charCodeAt(m-1)===d;)m--;const h=m-v,$=o<h?o:h;let D=-1,F=0;for(;F<$;F++){const U=s.charCodeAt(t+F);if(U!==a.charCodeAt(v+F))break;U===d&&(D=F)}if(F!==$){if(D===-1)return i}else{if(h>$){if(a.charCodeAt(v+F)===d)return i.slice(v+F+1);if(F===2)return i.slice(v+F)}o>$&&(s.charCodeAt(t+F)===d?D=F:F===2&&(D=3)),D===-1&&(D=0)}let M="";for(F=t+D+1;F<=r;++F)(F===r||s.charCodeAt(F)===d)&&(M+=M.length===0?"..":"\\..");return v+=D,M.length>0?`${M}${i.slice(v,m)}`:(i.charCodeAt(v)===d&&++v,i.slice(v,m))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const a=e.$ec.resolve(s);if(a.length<=2)return s;if(a.charCodeAt(0)===d){if(a.charCodeAt(1)===d){const n=a.charCodeAt(2);if(n!==E&&n!==R)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(f(a.charCodeAt(0))&&a.charCodeAt(1)===C&&a.charCodeAt(2)===d)return`\\\\?\\${a}`;return s},dirname(s){g(s,"path");const a=s.length;if(a===0)return".";let n=-1,i=0;const t=s.charCodeAt(0);if(a===1)return p(t)?s:".";if(p(t)){if(n=i=1,p(s.charCodeAt(1))){let v=2,m=v;for(;v<a&&!p(s.charCodeAt(v));)v++;if(v<a&&v!==m){for(m=v;v<a&&p(s.charCodeAt(v));)v++;if(v<a&&v!==m){for(m=v;v<a&&!p(s.charCodeAt(v));)v++;if(v===a)return s;v!==m&&(n=i=v+1)}}}}else f(t)&&s.charCodeAt(1)===C&&(n=a>2&&p(s.charCodeAt(2))?3:2,i=n);let r=-1,o=!0;for(let v=a-1;v>=i;--v)if(p(s.charCodeAt(v))){if(!o){r=v;break}}else o=!1;if(r===-1){if(n===-1)return".";r=n}return s.slice(0,r)},basename(s,a){a!==void 0&&g(a,"ext"),g(s,"path");let n=0,i=-1,t=!0,r;if(s.length>=2&&f(s.charCodeAt(0))&&s.charCodeAt(1)===C&&(n=2),a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let o=a.length-1,v=-1;for(r=s.length-1;r>=n;--r){const m=s.charCodeAt(r);if(p(m)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),o>=0&&(m===a.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=n;--r)if(p(s.charCodeAt(r))){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){g(s,"path");let a=0,n=-1,i=0,t=-1,r=!0,o=0;s.length>=2&&s.charCodeAt(1)===C&&f(s.charCodeAt(0))&&(a=i=2);for(let v=s.length-1;v>=a;--v){const m=s.charCodeAt(v);if(p(m)){if(!r){i=v+1;break}continue}t===-1&&(r=!1,t=v+1),m===R?n===-1?n=v:o!==1&&(o=1):n!==-1&&(o=-1)}return n===-1||t===-1||o===0||o===1&&n===t-1&&n===i+1?"":s.slice(n,t)},format:b.bind(null,"\\"),parse(s){g(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const n=s.length;let i=0,t=s.charCodeAt(0);if(n===1)return p(t)?(a.root=a.dir=s,a):(a.base=a.name=s,a);if(p(t)){if(i=1,p(s.charCodeAt(1))){let D=2,F=D;for(;D<n&&!p(s.charCodeAt(D));)D++;if(D<n&&D!==F){for(F=D;D<n&&p(s.charCodeAt(D));)D++;if(D<n&&D!==F){for(F=D;D<n&&!p(s.charCodeAt(D));)D++;D===n?i=D:D!==F&&(i=D+1)}}}}else if(f(t)&&s.charCodeAt(1)===C){if(n<=2)return a.root=a.dir=s,a;if(i=2,p(s.charCodeAt(2))){if(n===3)return a.root=a.dir=s,a;i=3}}i>0&&(a.root=s.slice(0,i));let r=-1,o=i,v=-1,m=!0,h=s.length-1,$=0;for(;h>=i;--h){if(t=s.charCodeAt(h),p(t)){if(!m){o=h+1;break}continue}v===-1&&(m=!1,v=h+1),t===R?r===-1?r=h:$!==1&&($=1):r!==-1&&($=-1)}return v!==-1&&(r===-1||$===0||$===1&&r===v-1&&r===o+1?a.base=a.name=s.slice(o,v):(a.name=s.slice(o,r),a.base=s.slice(o,v),a.ext=s.slice(r,v))),o>0&&o!==i?a.dir=s.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const k=(()=>{if(y){const s=/\\/g;return()=>{const a=I.cwd().replace(s,"/");return a.slice(a.indexOf("/"))}}return()=>I.cwd()})();e.$fc={resolve(...s){let a="",n=!1;for(let i=s.length-1;i>=-1&&!n;i--){const t=i>=0?s[i]:k();g(t,"path"),t.length!==0&&(a=`${t}/${a}`,n=t.charCodeAt(0)===S)}return a=u(a,!n,"/",c),n?`/${a}`:a.length>0?a:"."},normalize(s){if(g(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===S,n=s.charCodeAt(s.length-1)===S;return s=u(s,!a,"/",c),s.length===0?a?"/":n?"./":".":(n&&(s+="/"),a?`/${s}`:s)},isAbsolute(s){return g(s,"path"),s.length>0&&s.charCodeAt(0)===S},join(...s){if(s.length===0)return".";let a;for(let n=0;n<s.length;++n){const i=s[n];g(i,"path"),i.length>0&&(a===void 0?a=i:a+=`/${i}`)}return a===void 0?".":e.$fc.normalize(a)},relative(s,a){if(g(s,"from"),g(a,"to"),s===a||(s=e.$fc.resolve(s),a=e.$fc.resolve(a),s===a))return"";const n=1,i=s.length,t=i-n,r=1,o=a.length-r,v=t<o?t:o;let m=-1,h=0;for(;h<v;h++){const D=s.charCodeAt(n+h);if(D!==a.charCodeAt(r+h))break;D===S&&(m=h)}if(h===v)if(o>v){if(a.charCodeAt(r+h)===S)return a.slice(r+h+1);if(h===0)return a.slice(r+h)}else t>v&&(s.charCodeAt(n+h)===S?m=h:h===0&&(m=0));let $="";for(h=n+m+1;h<=i;++h)(h===i||s.charCodeAt(h)===S)&&($+=$.length===0?"..":"/..");return`${$}${a.slice(r+m)}`},toNamespacedPath(s){return s},dirname(s){if(g(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===S;let n=-1,i=!0;for(let t=s.length-1;t>=1;--t)if(s.charCodeAt(t)===S){if(!i){n=t;break}}else i=!1;return n===-1?a?"/":".":a&&n===1?"//":s.slice(0,n)},basename(s,a){a!==void 0&&g(a,"ext"),g(s,"path");let n=0,i=-1,t=!0,r;if(a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let o=a.length-1,v=-1;for(r=s.length-1;r>=0;--r){const m=s.charCodeAt(r);if(m===S){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),o>=0&&(m===a.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===S){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){g(s,"path");let a=-1,n=0,i=-1,t=!0,r=0;for(let o=s.length-1;o>=0;--o){const v=s.charCodeAt(o);if(v===S){if(!t){n=o+1;break}continue}i===-1&&(t=!1,i=o+1),v===R?a===-1?a=o:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||i===-1||r===0||r===1&&a===i-1&&a===n+1?"":s.slice(a,i)},format:b.bind(null,"/"),parse(s){g(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const n=s.charCodeAt(0)===S;let i;n?(a.root="/",i=1):i=0;let t=-1,r=0,o=-1,v=!0,m=s.length-1,h=0;for(;m>=i;--m){const $=s.charCodeAt(m);if($===S){if(!v){r=m+1;break}continue}o===-1&&(v=!1,o=m+1),$===R?t===-1?t=m:h!==1&&(h=1):t!==-1&&(h=-1)}if(o!==-1){const $=r===0&&n?1:r;t===-1||h===0||h===1&&t===o-1&&t===r+1?a.base=a.name=s.slice($,o):(a.name=s.slice($,t),a.base=s.slice($,o),a.ext=s.slice(t,o))}return r>0?a.dir=s.slice(0,r-1):n&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=y?e.$ec.normalize:e.$fc.normalize,e.$hc=y?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=y?e.$ec.join:e.$fc.join,e.$jc=y?e.$ec.resolve:e.$fc.resolve,e.$kc=y?e.$ec.relative:e.$fc.relative,e.$lc=y?e.$ec.dirname:e.$fc.dirname,e.$mc=y?e.$ec.basename:e.$fc.basename,e.$nc=y?e.$ec.extname:e.$fc.extname,e.$oc=y?e.$ec.format:e.$fc.format,e.$pc=y?e.$ec.parse:e.$fc.parse,e.$qc=y?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=y?e.$ec.sep:e.$fc.sep,e.$sc=y?e.$ec.delimiter:e.$fc.delimiter}),define(ae[48],ce([0,1,16,5,27,12]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=void 0;function O(r){return r===47||r===92}e.$Rf=O;function R(r){return r.replace(/[\\/]/g,I.$fc.sep)}e.$Sf=R;function S(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Tf=S;function d(r,o=I.$fc.sep){if(!r)return"";const v=r.length,m=r.charCodeAt(0);if(O(m)){if(O(r.charCodeAt(1))&&!O(r.charCodeAt(2))){let $=3;const D=$;for(;$<v&&!O(r.charCodeAt($));$++);if(D!==$&&!O(r.charCodeAt($+1))){for($+=1;$<v;$++)if(O(r.charCodeAt($)))return r.slice(0,$+1).replace(/[\\/]/g,o)}}return o}else if(c(m)&&r.charCodeAt(1)===58)return O(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let h=r.indexOf("://");if(h!==-1){for(h+=3;h<v;h++)if(O(r.charCodeAt(h)))return r.slice(0,h+1)}return""}e.$Uf=d;function C(r){if(!A.$i||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let v=2;const m=v;for(;v<r.length&&(o=r.charCodeAt(v),o!==92);v++);return!(m===v||(o=r.charCodeAt(v+1),isNaN(o)||o===92))}e.$Vf=C;const E=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,o=A.$i){const v=o?E:w;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||o&&l.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.$Wf=g;function y(r,o,v){const m=r===o;return!v||m?m:!r||!o?!1:(0,L.$3e)(r,o)}e.$Xf=y;function p(r,o,v,m=I.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(v){if(!(0,L.$4e)(r,o))return!1;if(o.length===r.length)return!0;let $=o.length;return o.charAt(o.length-1)===m&&$--,r.charAt($)===m}return o.charAt(o.length-1)!==m&&(o+=m),r.indexOf(o)===0}e.$Yf=p;function c(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Zf=c;function f(r,o){return A.$i&&r.endsWith(":")&&(r+=I.sep),(0,I.$hc)(r)||(r=(0,I.$ic)(o,r)),r=(0,I.$gc)(r),A.$i?(r=(0,L.$Le)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,L.$Le)(r,I.sep),r||(r=I.sep)),r}e.$1f=f;function u(r){const o=(0,I.$gc)(r);return A.$i?r.length>3?!1:b(o)&&(r.length===2||o.charCodeAt(2)===92):o===I.$fc.sep}e.$2f=u;function b(r,o=A.$i){return o?c(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$3f=b;function k(r,o=A.$i){return b(r,o)?r[0]:void 0}e.$4f=k;function s(r,o,v){return o.length>r.length?-1:r===o?0:(v&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.$5f=s;function a(r){const o=r.split(":");let v,m,h;for(const $ of o){const D=Number($);(0,j.$Df)(D)?m===void 0?m=D:h===void 0&&(h=D):v=v?[v,$].join(":"):$}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:m!==void 0?m:void 0,column:h!==void 0?h:m!==void 0?1:void 0}}e.$6f=a;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,o,v=8){let m="";for(let $=0;$<v;$++){let D;$===0&&A.$i&&!o&&(v===3||v===4)?D=i:D=n,m+=D.charAt(Math.floor(Math.random()*D.length))}let h;return o?h=`${o}-${m}`:h=m,r?(0,I.$ic)(r,h):h}e.$7f=t}),define(ae[139],ce([0,1,16]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=e.$Ur=e.$Tr=e.$Sr=void 0,e.$Sr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(C){const E=(0,I.$nc)(C),w=A[E.toLowerCase()];return w!==void 0?w:O(C)}e.$Tr=j;function O(C){const E=(0,I.$nc)(C);return L[E.toLowerCase()]}e.$Ur=O;function R(C){for(const E in L)if(L[E]===C)return E}e.$Vr=R;const S=/^(.+)\/(.+?)(;.+)?$/;function d(C,E){const w=S.exec(C);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:E?void 0:C}e.$Wr=d}),define(ae[90],ce([0,1,5]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=e.$Cl=e.TerminateResponseCode=e.Source=void 0;var A;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(A||(e.Source=A={}));var L;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function j(R,...S){const d=S.reduce((w,l)=>(w[l]=!0,w),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(w=>!d[w]).forEach(w=>{for(let l=0;l<C.length;l++)if(w.search(C[l])!==-1){delete R[w];break}})}e.$Cl=j;function O(R){R&&(delete R.DEBUG,I.$j&&delete R.DYLD_LIBRARY_PATH,I.$k&&delete R.LD_PRELOAD)}e.$Dl=O}),define(ae[10],ce([0,1,16,5]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,j=/^\//,O=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!j.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(i,t){return!i&&!t?"file":i}function d(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const C="",E="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(t){return t instanceof l?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,o,v,m,h=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=S(t,h),this.authority=r||C,this.path=d(this.scheme,o||C),this.query=v||C,this.fragment=m||C,R(this,h))}get fsPath(){return b(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:o,path:v,query:m,fragment:h}=t;return r===void 0?r=this.scheme:r===null&&(r=C),o===void 0?o=this.authority:o===null&&(o=C),v===void 0?v=this.path:v===null&&(v=C),m===void 0?m=this.query:m===null&&(m=C),h===void 0?h=this.fragment:h===null&&(h=C),r===this.scheme&&o===this.authority&&v===this.path&&m===this.query&&h===this.fragment?this:new p(r,o,v,m,h)}static parse(t,r=!1){const o=w.exec(t);return o?new p(o[2]||C,n(o[4]||C),n(o[5]||C),n(o[7]||C),n(o[9]||C),r):new p(C,C,C,C,C)}static file(t){let r=C;if(A.$i&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const o=t.indexOf(E,2);o===-1?(r=t.substring(2),t=E):(r=t.substring(2,o),t=t.substring(o)||E)}return new p("file",r,t,C,C)}static from(t,r){return new p(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return A.$i&&t.scheme==="file"?o=l.file(I.$ec.join(b(t,!0),...r)).path:o=I.$fc.join(t.path,...r),t.with({path:o})}toString(t=!1){return k(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof l)return t;{const r=new p(t);return r._formatted=t.external??null,r._fsPath=t._sep===y?t.fsPath??null:null,r}}else return t}}e.URI=l;function g(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$uc=g;const y=A.$i?1:void 0;class p extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(t=!1){return t?k(this,!0):(this._formatted||(this._formatted=k(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=y),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(i,t,r){let o,v=-1;for(let m=0;m<i.length;m++){const h=i.charCodeAt(m);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47||r&&h===91||r&&h===93||r&&h===58)v!==-1&&(o+=encodeURIComponent(i.substring(v,m)),v=-1),o!==void 0&&(o+=i.charAt(m));else{o===void 0&&(o=i.substr(0,m));const $=c[h];$!==void 0?(v!==-1&&(o+=encodeURIComponent(i.substring(v,m)),v=-1),o+=$):v===-1&&(v=m)}}return v!==-1&&(o+=encodeURIComponent(i.substring(v))),o!==void 0?o:i}function u(i){let t;for(let r=0;r<i.length;r++){const o=i.charCodeAt(r);o===35||o===63?(t===void 0&&(t=i.substr(0,r)),t+=c[o]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function b(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,A.$i&&(r=r.replace(/\//g,"\\")),r}e.$vc=b;function k(i,t){const r=t?u:f;let o="",{scheme:v,authority:m,path:h,query:$,fragment:D}=i;if(v&&(o+=v,o+=":"),(m||v==="file")&&(o+=E,o+=E),m){let F=m.indexOf("@");if(F!==-1){const M=m.substr(0,F);m=m.substr(F+1),F=M.lastIndexOf(":"),F===-1?o+=r(M,!1,!1):(o+=r(M.substr(0,F),!1,!1),o+=":",o+=r(M.substr(F+1),!1,!0)),o+="@"}m=m.toLowerCase(),F=m.lastIndexOf(":"),F===-1?o+=r(m,!1,!0):(o+=r(m.substr(0,F),!1,!0),o+=m.substr(F))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const F=h.charCodeAt(1);F>=65&&F<=90&&(h=`/${String.fromCharCode(F+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const F=h.charCodeAt(0);F>=65&&F<=90&&(h=`${String.fromCharCode(F+32)}:${h.substr(2)}`)}o+=r(h,!0,!1)}return $&&(o+="?",o+=r($,!1,!1)),D&&(o+="#",o+=t?D:f(D,!1,!1)),o}function s(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(a)?i.replace(a,t=>s(t)):i}}),define(ae[140],ce([0,1,10]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$3p=e.$2p=e.$1p=void 0;function A(d){const C=d;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$1p=A;function L(d){const C=[];let E;try{const w=JSON.parse(d.arguments),l=w[w.length-1];l&&l.__$stack&&(w.pop(),E=l.__$stack),C.push(...w)}catch{C.push("Unable to log remote console arguments",d.arguments)}return{args:C,stack:E}}e.$2p=L;function j(d){if(typeof d!="string")return j(L(d).stack);const C=d;if(C){const E=O(C),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(w&&w.length===4)return{uri:I.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.$3p=j;function O(d){if(!d)return d;const C=d.indexOf(`
`);return C===-1?d:d.substring(0,C)}function R(d,C){const{args:E,stack:w}=L(d),l=typeof E[0]=="string"&&E.length===1;let g=O(w);g&&(g=`(${g.trim()})`);let y=[];if(typeof E[0]=="string"?g&&l?y=[`%c[${C}] %c${E[0]} %c${g}`,S("blue"),S(""),S("grey")]:y=[`%c[${C}] %c${E[0]}`,S("blue"),S(""),...E.slice(1)]:y=[`%c[${C}]%`,S("blue"),...E],g&&!l&&y.push(g),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,y)}e.log=R;function S(d){return`color: ${d}`}}),define(ae[65],ce([0,1,15,10]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=void 0;function L(S){return JSON.stringify(S,O)}e.$nh=L;function j(S){let d=JSON.parse(S);return d=R(d),d}e.$oh=j;function O(S,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function R(S,d=0){if(!S||d>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return A.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 17:return new Date(S.source)}if(S instanceof I.$ce||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let C=0;C<S.length;++C)S[C]=R(S[C],d+1);else for(const C in S)Object.hasOwnProperty.call(S,C)&&(S[C]=R(S[C],d+1))}return S}e.$ph=R}),define(ae[23],ce([0,1,7,5,10]),function(ie,e,I,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.Schemas=void 0;var j;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(j||(e.Schemas=j={})),e.$8f="vscode-tkn",e.$9f="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${j.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${j.vscodeRemoteResource}`}set(C,E,w){this.a[C]=E,this.b[C]=w}setConnectionToken(C,E){this.c[C]=E}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(p){return I.$Z(p),C}const E=C.authority;let w=this.a[E];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const l=this.b[E],g=this.c[E];let y=`path=${encodeURIComponent(C.path)}`;return typeof g=="string"&&(y+=`&${e.$9f}=${encodeURIComponent(g)}`),L.URI.from({scheme:A.$o?this.d:j.vscodeRemoteResource,authority:`${w}:${l}`,path:this.f,query:y})}}e.$0f=new O,e.$$f="vs/../../extensions",e.$_f="vs/../../node_modules",e.$ag="vs/../../node_modules.asar",e.$bg="vs/../../node_modules.asar.unpacked",e.$cg="vscode-app";class R{static{this.a=e.$cg}asBrowserUri(C){const E=this.b(C,ie);return this.uriToBrowserUri(E)}uriToBrowserUri(C){return C.scheme===j.vscodeRemote?e.$0f.rewrite(C):C.scheme===j.file&&(A.$m||A.$q===`${j.vscodeFileResource}://${R.a}`)?C.with({scheme:j.vscodeFileResource,authority:C.authority||R.a,query:null,fragment:null}):C}asFileUri(C){const E=this.b(C,ie);return this.uriToFileUri(E)}uriToFileUri(C){return C.scheme===j.vscodeFileResource?C.with({scheme:j.file,authority:C.authority!==R.a?C.authority:null,query:null,fragment:null}):C}b(C,E){return L.URI.isUri(C)?C:L.URI.parse(E.toUrl(C))}}e.$dg=new R;var S;(function(d){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(C.get("3"));const E="vscode-coi";function w(g){let y;typeof g=="string"?y=new URL(g).searchParams:g instanceof URL?y=g.searchParams:L.URI.isUri(g)&&(y=new URL(g.toString(!0)).searchParams);const p=y?.get(E);if(p)return C.get(p)}d.getHeadersFromQuery=w;function l(g,y,p){if(!globalThis.crossOriginIsolated)return;const c=y&&p?"3":p?"2":"1";g instanceof URLSearchParams?g.set(E,c):g[E]=c}d.addSearchParam=l})(S||(e.COI=S={}))}),define(ae[141],ce([0,1,123,23,5,10]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=void 0;class O{constructor(w,l,g){this.id=w,this.dependencies=l,this.callback=g}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,l,g)=>{typeof w!="string"&&(g=l,l=w,w=null),(typeof l!="object"||!Array.isArray(l))&&(g=l,l=null),this.c.push(new O(w,l,g))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const l=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!l)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h(w){return new Promise((l,g)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const p=()=>{y.removeEventListener("load",c),y.removeEventListener("error",f)},c=u=>{p(),l(this.c.pop())},f=u=>{p(),g(u)};y.addEventListener("load",c),y.addEventListener("error",f),this.f&&(w=this.f.createScriptURL(w)),y.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(y)})}i(w){return new Promise((l,g)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),l(this.c.pop())}catch(y){g(y)}})}async j(w){try{const l=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,p=j.URI.parse(w).fsPath,c=l.readFileSync(p).toString(),f=y.wrap(c.replace(/^#!.*/,""));return new g.Script(f).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}const S=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function C(E,w,l){if(I.$S){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[E]&&(E=d[E]);const g=`${E}/${w}`;if(S.has(g))return S.get(g);let y;if(/^\w[\w\d+.-]*:\/\//.test(g))y=g;else{const u=`${l&&!L.$o?A.$ag:A.$_f}/${g}`;y=A.$dg.asBrowserUri(u).toString(!0)}const p=R.INSTANCE.load(y);return S.set(g,p),p}else return await new Promise((g,y)=>{ie([E],g,y)})}e.$KC=C}),define(ae[19],ce([0,1,48,23,16,5,27,10]),function(ie,e,I,A,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.DataUri=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=void 0;function S(l){return(0,R.$vc)(l,!0)}e.$kg=S;class d{constructor(g){this.a=g}compare(g,y,p=!1){return g===y?0:(0,O.$Ve)(this.getComparisonKey(g,p),this.getComparisonKey(y,p))}isEqual(g,y,p=!1){return g===y?!0:!g||!y?!1:this.getComparisonKey(g,p)===this.getComparisonKey(y,p)}getComparisonKey(g,y=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,y,p=!1){if(g.scheme===y.scheme){if(g.scheme===A.Schemas.file)return I.$Yf(S(g),S(y),this.a(g))&&g.query===y.query&&(p||g.fragment===y.fragment);if((0,e.$Bg)(g.authority,y.authority))return I.$Yf(g.path,y.path,this.a(g),"/")&&g.query===y.query&&(p||g.fragment===y.fragment)}return!1}joinPath(g,...y){return R.URI.joinPath(g,...y)}basenameOrAuthority(g){return(0,e.$tg)(g)||g.authority}basename(g){return L.$fc.basename(g.path)}extname(g){return L.$fc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let y;return g.scheme===A.Schemas.file?y=R.URI.file(L.$lc(S(g))).path:(y=L.$fc.dirname(g.path),g.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),y="/")),g.with({path:y})}normalizePath(g){if(!g.path.length)return g;let y;return g.scheme===A.Schemas.file?y=R.URI.file(L.$gc(S(g))).path:y=L.$fc.normalize(g.path),g.with({path:y})}relativePath(g,y){if(g.scheme!==y.scheme||!(0,e.$Bg)(g.authority,y.authority))return;if(g.scheme===A.Schemas.file){const f=L.$kc(S(g),S(y));return j.$i?I.$Sf(f):f}let p=g.path||"/";const c=y.path||"/";if(this.a(g)){let f=0;for(const u=Math.min(p.length,c.length);f<u&&!(p.charCodeAt(f)!==c.charCodeAt(f)&&p.charAt(f).toLowerCase()!==c.charAt(f).toLowerCase());f++);p=c.substr(0,f)+p.substr(f)}return L.$fc.relative(p,c)}resolvePath(g,y){if(g.scheme===A.Schemas.file){const p=R.URI.file(L.$jc(S(g),y));return g.with({authority:p.authority,path:p.path})}return y=I.$Tf(y),g.with({path:L.$fc.resolve(g.path,y)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,y){return g===y||g!==void 0&&y!==void 0&&(0,O.$3e)(g,y)}hasTrailingPathSeparator(g,y=L.sep){if(g.scheme===A.Schemas.file){const p=S(g);return p.length>I.$Uf(p).length&&p[p.length-1]===y}else{const p=g.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,y=L.sep){return(0,e.$Cg)(g,y)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,y=L.sep){let p=!1;if(g.scheme===A.Schemas.file){const c=S(g);p=c!==void 0&&c.length===I.$Uf(c).length&&c[c.length-1]===y}else{y="/";const c=g.path;p=c.length===1&&c.charCodeAt(c.length-1)===47}return!p&&!(0,e.$Cg)(g,y)?g.with({path:g.path+"/"}):g}}e.$lg=d,e.$mg=new d(()=>!1),e.$ng=new d(l=>l.scheme===A.Schemas.file?!j.$k:!0),e.$og=new d(l=>!0),e.$pg=e.$mg.isEqual.bind(e.$mg),e.$qg=e.$mg.isEqualOrParent.bind(e.$mg),e.$rg=e.$mg.getComparisonKey.bind(e.$mg),e.$sg=e.$mg.basenameOrAuthority.bind(e.$mg),e.$tg=e.$mg.basename.bind(e.$mg),e.$ug=e.$mg.extname.bind(e.$mg),e.$vg=e.$mg.dirname.bind(e.$mg),e.$wg=e.$mg.joinPath.bind(e.$mg),e.$xg=e.$mg.normalizePath.bind(e.$mg),e.$yg=e.$mg.relativePath.bind(e.$mg),e.$zg=e.$mg.resolvePath.bind(e.$mg),e.$Ag=e.$mg.isAbsolutePath.bind(e.$mg),e.$Bg=e.$mg.isEqualAuthority.bind(e.$mg),e.$Cg=e.$mg.hasTrailingPathSeparator.bind(e.$mg),e.$Dg=e.$mg.removeTrailingPathSeparator.bind(e.$mg),e.$Eg=e.$mg.addTrailingPathSeparator.bind(e.$mg);function C(l,g){const y=[];for(let p=0;p<l.length;p++){const c=g(l[p]);l.some((f,u)=>u===p?!1:(0,e.$qg)(c,g(f)))||y.push(l[p])}return y}e.$Fg=C;var E;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function g(y){const p=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(u=>{const[b,k]=u.split(":");b&&k&&p.set(b,k)});const f=y.path.substring(0,y.path.indexOf(";"));return f&&p.set(l.META_DATA_MIME,f),p}l.parseMetaData=g})(E||(e.DataUri=E={}));function w(l,g,y){if(g){let p=l.path;return p&&p[0]!==L.$fc.sep&&(p=L.$fc.sep+p),l.with({scheme:y,authority:g,path:p})}return l.with({scheme:y})}e.$Gg=w}),define(ae[6],ce([0,1,26,7,3,2,19,5,129]),function(ie,e,I,A,L,j,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=e.$gh=e.Promises=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function d(B){return!!B&&typeof B.then=="function"}e.$Hg=d;function C(B){const N=new I.$Yd,V=B(N.token),G=new Promise((te,oe)=>{const ue=N.token.onCancellationRequested(()=>{ue.dispose(),N.dispose(),oe(new A.$4)});Promise.resolve(V).then(he=>{ue.dispose(),N.dispose(),te(he)},he=>{ue.dispose(),N.dispose(),oe(he)})});return new class{cancel(){N.cancel()}then(te,oe){return G.then(te,oe)}catch(te){return this.then(void 0,te)}finally(te){return G.finally(te)}}}e.$Ig=C;function E(B,N,V){return new Promise((G,te)=>{const oe=N.onCancellationRequested(()=>{oe.dispose(),G(V)});B.then(G,te).finally(()=>oe.dispose())})}e.$Jg=E;function w(B,N){return new Promise((V,G)=>{const te=N.onCancellationRequested(()=>{te.dispose(),G(new A.$4)});B.then(V,G).finally(()=>te.dispose())})}e.$Kg=w;async function l(B){let N=-1;const V=B.map((G,te)=>G.then(oe=>(N=te,oe)));try{return await Promise.race(V)}finally{B.forEach((G,te)=>{te!==N&&G.cancel()})}}e.$Lg=l;function g(B,N,V){let G;const te=setTimeout(()=>{G?.(void 0),V?.()},N);return Promise.race([B.finally(()=>clearTimeout(te)),new Promise(oe=>G=oe)])}e.$Mg=g;function y(B){return new Promise((N,V)=>{const G=B();d(G)?G.then(N,V):N(G)})}e.$Ng=y;class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(N){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=N,!this.b){const V=()=>{if(this.b=null,this.f)return;const G=this.queue(this.d);return this.d=null,G};this.b=new Promise(G=>{this.a.then(V,V).then(G)})}return new Promise((V,G)=>{this.b.then(V,G)})}return this.a=N(),new Promise((V,G)=>{this.a.then(te=>{this.a=null,V(te)},te=>{this.a=null,G(te)})})}dispose(){this.f=!0}}e.$Og=p;class c{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.$Pg=c;class f{constructor(){this.a=new Map}queue(N,V){const te=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.a.get(N)===te&&this.a.delete(N)});return this.a.set(N,te),te}}e.$Qg=f;const u=(B,N)=>{let V=!0;const G=setTimeout(()=>{V=!1,N()},B);return{isTriggered:()=>V,dispose:()=>{clearTimeout(G),V=!1}}},b=B=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,B())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class k{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,V=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((te,oe)=>{this.d=te,this.f=oe}).then(()=>{if(this.b=null,this.d=null,this.g){const te=this.g;return this.g=null,te()}}));const G=()=>{this.a=null,this.d?.(null)};return this.a=V===S.$Ld?b(G):u(V,G),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Rg=k;class s{constructor(N){this.a=new k(N),this.b=new p}trigger(N,V){return this.a.trigger(()=>this.b.queue(N),V)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Sg=s;class a{constructor(){this.a=!1,this.b=new Promise((N,V)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Tg=a;class n extends a{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.$Ug=n;function i(B,N){return N?new Promise((V,G)=>{const te=setTimeout(()=>{oe.dispose(),V()},B),oe=N.onCancellationRequested(()=>{clearTimeout(te),oe.dispose(),G(new A.$4)})}):C(V=>i(B,V))}e.$Vg=i;function t(B,N=0,V){const G=setTimeout(()=>{B(),V&&te.dispose()},N),te=(0,j.$Pc)(()=>{clearTimeout(G),V?.deleteAndLeak(te)});return V?.add(te),te}e.$Wg=t;function r(B){const N=[];let V=0;const G=B.length;function te(){return V<G?B[V++]():null}function oe(ue){ue!=null&&N.push(ue);const he=te();return he?he.then(oe):Promise.resolve(N)}return Promise.resolve(null).then(oe)}e.$Xg=r;function o(B,N=G=>!!G,V=null){let G=0;const te=B.length,oe=()=>{if(G>=te)return Promise.resolve(V);const ue=B[G++];return Promise.resolve(ue()).then(ge=>N(ge)?Promise.resolve(ge):oe())};return oe()}e.$Yg=o;function v(B,N=G=>!!G,V=null){if(B.length===0)return Promise.resolve(V);let G=B.length;const te=()=>{G=-1;for(const oe of B)oe.cancel?.()};return new Promise((oe,ue)=>{for(const he of B)he.then(ge=>{--G>=0&&N(ge)?(te(),oe(ge)):G===0&&oe(V)}).catch(ge=>{--G>=0&&(te(),ue(ge))})})}e.$Zg=v;class m{constructor(N){this.a=0,this.d=N,this.f=[],this.b=0,this.g=new L.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue(N){return this.a++,new Promise((V,G)=>{this.f.push({factory:N,c:V,e:G}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const N=this.f.shift();this.b++;const V=N.factory();V.then(N.c,N.e),V.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$1g=m;class h extends m{constructor(){super(1)}}e.$2g=h;class ${constructor(){this.a=new J,this.b=0}queue(N){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,N())):this.a.run(this.b++,N())}}e.$3g=$;class D{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const N=new ne;return this.b.add(N),N.p}g(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueFor(N,V=O.$mg){const G=V.getComparisonKey(N);let te=this.a.get(G);if(!te){te=new h;const oe=this.f++,ue=L.Event.once(te.onDrained)(()=>{te?.dispose(),this.a.delete(G),this.h(),this.d?.deleteAndDispose(oe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$Zc),this.d.set(oe,ue),this.a.set(G,te)}return te}h(){this.g()&&this.j()}j(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$4g=D;class F{constructor(N,V){this.a=-1,typeof N=="function"&&typeof V=="number"&&this.setIfNotSet(N,V)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,V){this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},V)}setIfNotSet(N,V){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},V))}}e.$5g=F;class M{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(N,V,G=globalThis){this.cancel();const te=G.setInterval(()=>{N()},V);this.d=(0,j.$Pc)(()=>{G.clearInterval(te),this.d=void 0})}dispose(){this.cancel()}}e.$6g=M;class U{constructor(N,V){this.b=-1,this.a=N,this.d=V,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$7g=U;class q{constructor(N,V){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.a=N,this.b=V,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$8g=q;class Y extends U{constructor(N,V){super(N,V),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.$9g=Y;class K extends j.$Rc{constructor(N,V){super(),this.g=N,this.h=V,this.a=[],this.b=this.B(new j.$Sc),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const V of N)this.a.push(V);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$0g=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$_g=(B,N)=>{(0,R.$B)(()=>{if(V)return;const G=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,G-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.$_g=(B,N,V)=>{const G=B.requestIdleCallback(N,typeof V=="number"?{timeout:V}:void 0);let te=!1;return{dispose(){te||(te=!0,B.cancelIdleCallback(G))}}},e.$$g=B=>(0,e.$_g)(globalThis,B)}();class x{constructor(N,V){this.g=!1,this.d=()=>{try{this.j=V()}catch(G){this.l=G}finally{this.g=!0}},this.f=(0,e.$_g)(N,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$ah=x;class H extends x{constructor(N){super(globalThis,N)}}e.$bh=H;async function Q(B,N,V){let G;for(let te=0;te<V;te++)try{return await B()}catch(oe){G=oe,await i(N)}throw G}e.$ch=Q;class J{isRunning(N){return typeof N=="number"?this.a?.taskId===N:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(N,V,G){return this.a={taskId:N,cancel:()=>G?.(),promise:V},V.then(()=>this.d(N),()=>this.d(N)),V}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}queue(N){if(this.b)this.b.run=N;else{let V,G;const te=new Promise((oe,ue)=>{V=oe,G=ue});this.b={run:N,promise:te,promiseResolve:V,promiseReject:G}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$dh=J;class W{constructor(N,V=()=>Date.now()){this.d=N,this.f=V,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.$eh=W;var ee;(function(B){B[B.Resolved=0]="Resolved",B[B.Rejected=1]="Rejected"})(ee||(ee={}));class ne{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((N,V)=>{this.a=N,this.b=V})}complete(N){return new Promise(V=>{this.a(N),this.d={outcome:0,value:N},V()})}error(N){return new Promise(V=>{this.b(N),this.d={outcome:1,value:N},V()})}cancel(){return this.error(new A.$4)}}e.$fh=ne;var _;(function(B){async function N(G){let te;const oe=await Promise.all(G.map(ue=>ue.then(he=>he,he=>{te||(te=he)})));if(typeof te<"u")throw te;return oe}B.settled=N;function V(G){return new Promise(async(te,oe)=>{try{await G(te,oe)}catch(ue){oe(ue)}})}B.withAsyncBody=V})(_||(e.Promises=_={}));var se;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(se||(se={}));class Z{static fromArray(N){return new Z(V=>{V.emitMany(N)})}static fromPromise(N){return new Z(async V=>{V.emitMany(await N)})}static fromPromises(N){return new Z(async V=>{await Promise.all(N.map(async G=>V.emitOne(await G)))})}static merge(N){return new Z(async V=>{await Promise.all(N.map(async G=>{for await(const te of G)V.emitOne(te)}))})}static{this.EMPTY=Z.fromArray([])}constructor(N){this.a=0,this.b=[],this.d=null,this.f=new L.$Od,queueMicrotask(async()=>{const V={emitOne:G=>this.g(G),emitMany:G=>this.h(G),reject:G=>this.k(G)};try{await Promise.resolve(N(V)),this.j()}catch(G){this.k(G)}finally{V.emitOne=void 0,V.emitMany=void 0,V.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.f.event)}while(!0)}}}static map(N,V){return new Z(async G=>{for await(const te of N)G.emitOne(V(te))})}map(N){return Z.map(this,N)}static filter(N,V){return new Z(async G=>{for await(const te of N)V(te)&&G.emitOne(te)})}filter(N){return Z.filter(this,N)}static coalesce(N){return Z.filter(N,V=>!!V)}coalesce(){return Z.coalesce(this)}static async toPromise(N){const V=[];for await(const G of N)V.push(G);return V}toPromise(){return Z.toPromise(this)}g(N){this.a===0&&(this.b.push(N),this.f.fire())}h(N){this.a===0&&(this.b=this.b.concat(N),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(N){this.a===0&&(this.a=2,this.d=N,this.f.fire())}}e.$gh=Z;class z extends Z{constructor(N,V){super(V),this.l=N}cancel(){this.l.cancel()}}e.$hh=z;function P(B){const N=new I.$Yd,V=B(N.token);return new z(N,async G=>{const te=N.token.onCancellationRequested(()=>{te.dispose(),N.dispose(),G.reject(new A.$4)});try{for await(const oe of V){if(N.token.isCancellationRequested)return;G.emitOne(oe)}te.dispose(),N.dispose()}catch(oe){te.dispose(),N.dispose(),G.reject(oe)}})}e.$ih=P;class T{constructor(){this.a=new ne,this.b=new Z(G=>{if(N){G.reject(N);return}return V&&G.emitMany(V),this.d=te=>G.reject(te),this.f=te=>G.emitOne(te),this.a.p});let N,V;this.f=G=>{V||(V=[]),V.push(G)},this.d=G=>{N||(N=G)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(N){this.d(N),this.a.complete()}emitOne(N){this.f(N)}}e.$jh=T}),define(ae[91],ce([0,1,18,6,48,34,16,5,27]),function(ie,e,I,A,L,j,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=void 0;function d(){return Object.create(null)}e.$uj=d,e.$vj="**",e.$wj="/";const C="[/\\\\]",E="[^/\\\\]",w=/\//g;function l(Q,J){switch(Q){case 0:return"";case 1:return`${E}*?`;default:return`(?:${C}|${E}+${C}${J?`|${C}${E}+`:""})*?`}}function g(Q,J){if(!Q)return[];const W=[];let ee=!1,ne=!1,_="";for(const se of Q){switch(se){case J:if(!ee&&!ne){W.push(_),_="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}_+=se}return _&&W.push(_),W}e.$xj=g;function y(Q){if(!Q)return"";let J="";const W=g(Q,e.$wj);if(W.every(ee=>ee===e.$vj))J=".*";else{let ee=!1;W.forEach((ne,_)=>{if(ne===e.$vj){if(ee)return;J+=l(2,_===W.length-1)}else{let se=!1,Z="",z=!1,P="";for(const T of ne){if(T!=="}"&&se){Z+=T;continue}if(z&&(T!=="]"||!P)){let B;T==="-"?B=T:(T==="^"||T==="!")&&!P?B="^":T===e.$wj?B="":B=(0,S.$Ge)(T),P+=B;continue}switch(T){case"{":se=!0;continue;case"[":z=!0;continue;case"}":{const N=`(?:${g(Z,",").map(V=>y(V)).join("|")})`;J+=N,se=!1,Z="";break}case"]":{J+="["+P+"]",z=!1,P="";break}case"?":J+=E;continue;case"*":J+=l(1);continue;default:J+=(0,S.$Ge)(T)}}_<W.length-1&&(W[_+1]!==e.$vj||_+2<W.length)&&(J+=C)}ee=ne===e.$vj})}return J}const p=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new j.$Cc(1e4),a=function(){return!1},n=function(){return null};function i(Q,J){if(!Q)return n;let W;typeof Q!="string"?W=Q.pattern:W=Q,W=W.trim();const ee=`${W}_${!!J.trimForExclusions}`;let ne=s.get(ee);if(ne)return t(ne,Q);let _;return p.test(W)?ne=o(W.substr(4),W):(_=c.exec(r(W,J)))?ne=v(_[1],W):(J.trimForExclusions?u:f).test(W)?ne=m(W,J):(_=b.exec(r(W,J)))?ne=h(_[1].substr(1),W,!0):(_=k.exec(r(W,J)))?ne=h(_[1],W,!1):ne=$(W),s.set(ee,ne),t(ne,Q)}function t(Q,J){if(typeof J=="string")return Q;const W=function(ee,ne){return(0,L.$Yf)(ee,J.base,!R.$k)?Q((0,S.$Ke)(ee.substr(J.base.length),O.sep),ne):null};return W.allBasenames=Q.allBasenames,W.allPaths=Q.allPaths,W.basenames=Q.basenames,W.patterns=Q.patterns,W}function r(Q,J){return J.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function o(Q,J){return function(W,ee){return typeof W=="string"&&W.endsWith(Q)?J:null}}function v(Q,J){const W=`/${Q}`,ee=`\\${Q}`,ne=function(se,Z){return typeof se!="string"?null:Z?Z===Q?J:null:se===Q||se.endsWith(W)||se.endsWith(ee)?J:null},_=[Q];return ne.basenames=_,ne.patterns=[J],ne.allBasenames=_,ne}function m(Q,J){const W=x(Q.slice(1,-1).split(",").map(Z=>i(Z,J)).filter(Z=>Z!==n),Q),ee=W.length;if(!ee)return n;if(ee===1)return W[0];const ne=function(Z,z){for(let P=0,T=W.length;P<T;P++)if(W[P](Z,z))return Q;return null},_=W.find(Z=>!!Z.allBasenames);_&&(ne.allBasenames=_.allBasenames);const se=W.reduce((Z,z)=>z.allPaths?Z.concat(z.allPaths):Z,[]);return se.length&&(ne.allPaths=se),ne}function h(Q,J,W){const ee=O.sep===O.$fc.sep,ne=ee?Q:Q.replace(w,O.sep),_=O.sep+ne,se=O.$fc.sep+Q;let Z;return W?Z=function(z,P){return typeof z=="string"&&(z===ne||z.endsWith(_)||!ee&&(z===Q||z.endsWith(se)))?J:null}:Z=function(z,P){return typeof z=="string"&&(z===ne||!ee&&z===Q)?J:null},Z.allPaths=[(W?"*/":"./")+Q],Z}function $(Q){try{const J=new RegExp(`^${y(Q)}$`);return function(W){return J.lastIndex=0,typeof W=="string"&&J.test(W)?Q:null}}catch{return n}}function D(Q,J,W){return!Q||typeof J!="string"?!1:F(Q)(J,void 0,W)}e.$yj=D;function F(Q,J={}){if(!Q)return a;if(typeof Q=="string"||M(Q)){const W=i(Q,J);if(W===n)return a;const ee=function(ne,_){return!!W(ne,_)};return W.allBasenames&&(ee.allBasenames=W.allBasenames),W.allPaths&&(ee.allPaths=W.allPaths),ee}return Y(Q,J)}e.$zj=F;function M(Q){const J=Q;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.$Aj=M;function U(Q){return Q.allBasenames||[]}e.$Bj=U;function q(Q){return Q.allPaths||[]}e.$Cj=q;function Y(Q,J){const W=x(Object.getOwnPropertyNames(Q).map(Z=>K(Z,Q[Z],J)).filter(Z=>Z!==n)),ee=W.length;if(!ee)return n;if(!W.some(Z=>!!Z.requiresSiblings)){if(ee===1)return W[0];const Z=function(T,B){let N;for(let V=0,G=W.length;V<G;V++){const te=W[V](T,B);if(typeof te=="string")return te;(0,A.$Hg)(te)&&(N||(N=[]),N.push(te))}return N?(async()=>{for(const V of N){const G=await V;if(typeof G=="string")return G}return null})():null},z=W.find(T=>!!T.allBasenames);z&&(Z.allBasenames=z.allBasenames);const P=W.reduce((T,B)=>B.allPaths?T.concat(B.allPaths):T,[]);return P.length&&(Z.allPaths=P),Z}const ne=function(Z,z,P){let T,B;for(let N=0,V=W.length;N<V;N++){const G=W[N];G.requiresSiblings&&P&&(z||(z=(0,O.$mc)(Z)),T||(T=z.substr(0,z.length-(0,O.$nc)(Z).length)));const te=G(Z,z,T,P);if(typeof te=="string")return te;(0,A.$Hg)(te)&&(B||(B=[]),B.push(te))}return B?(async()=>{for(const N of B){const V=await N;if(typeof V=="string")return V}return null})():null},_=W.find(Z=>!!Z.allBasenames);_&&(ne.allBasenames=_.allBasenames);const se=W.reduce((Z,z)=>z.allPaths?Z.concat(z.allPaths):Z,[]);return se.length&&(ne.allPaths=se),ne}function K(Q,J,W){if(J===!1)return n;const ee=i(Q,W);if(ee===n)return n;if(typeof J=="boolean")return ee;if(J){const ne=J.when;if(typeof ne=="string"){const _=(se,Z,z,P)=>{if(!P||!ee(se,Z))return null;const T=ne.replace("$(basename)",()=>z),B=P(T);return(0,A.$Hg)(B)?B.then(N=>N?Q:null):B?Q:null};return _.requiresSiblings=!0,_}}return ee}function x(Q,J){const W=Q.filter(Z=>!!Z.basenames);if(W.length<2)return Q;const ee=W.reduce((Z,z)=>{const P=z.basenames;return P?Z.concat(P):Z},[]);let ne;if(J){ne=[];for(let Z=0,z=ee.length;Z<z;Z++)ne.push(J)}else ne=W.reduce((Z,z)=>{const P=z.patterns;return P?Z.concat(P):Z},[]);const _=function(Z,z){if(typeof Z!="string")return null;if(!z){let T;for(T=Z.length;T>0;T--){const B=Z.charCodeAt(T-1);if(B===47||B===92)break}z=Z.substr(T)}const P=ee.indexOf(z);return P!==-1?ne[P]:null};_.basenames=ee,_.patterns=ne,_.allBasenames=ee;const se=Q.filter(Z=>!Z.basenames);return se.push(_),se}function H(Q,J){return(0,I.$tb)(Q,J,(W,ee)=>typeof W=="string"&&typeof ee=="string"?W===ee:typeof W!="string"&&typeof ee!="string"?W.base===ee.base&&W.pattern===ee.pattern:!1)}e.$Dj=H}),define(ae[92],ce([0,1,15,10]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=void 0;function L(E){return E.toJSON()}class j{constructor(w){this.a=w}transformIncoming(w){const l=this.a.transformIncoming(w);return l===w?w:L(A.URI.from(l))}transformOutgoing(w){const l=this.a.transformOutgoing(w);return l===w?w:L(A.URI.from(l))}transformOutgoingURI(w){const l=this.a.transformOutgoing(w);return l===w?w:A.URI.from(l)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$Om=j,e.$Pm=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function O(E,w,l){if(!E||l>200)return null;if(typeof E=="object"){if(E instanceof A.URI)return w.transformOutgoing(E);for(const g in E)if(Object.hasOwnProperty.call(E,g)){const y=O(E[g],w,l+1);y!==null&&(E[g]=y)}}return null}function R(E,w){const l=O(E,w,0);return l===null?E:l}e.$Qm=R;function S(E,w,l,g){if(!E||g>200)return null;if(typeof E=="object"){if(E.$mid===1)return l?A.URI.revive(w.transformIncoming(E)):w.transformIncoming(E);if(E instanceof I.$ce)return null;for(const y in E)if(Object.hasOwnProperty.call(E,y)){const p=S(E[y],w,l,g+1);p!==null&&(E[y]=p)}}return null}function d(E,w){const l=S(E,w,!1,0);return l===null?E:l}e.$Rm=d;function C(E,w){const l=S(E,w,!0,0);return l===null?E:l}e.$Sm=C}),define(ae[142],ce([0,1,36,47,32,130,5]),function(ie,e,I,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=e.$Um=void 0,e.$Um=new class{c(w){return this.a||(this.a=A.$Yh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,l=0;const g=(0,I.networkInterfaces)();for(const y in g){const p=g[y];if(p)for(const{mac:c,internal:f}of p)f||(l+=1,this.c(c.toUpperCase())&&(w+=1))}this.b=l>0?w/l:0}return this.b}};let R;async function S(w){return R||(R=(async()=>await d(w)||L.$fg())()),R}e.$Vm=S;async function d(w){try{const l=await new Promise((y,p)=>{ie(["crypto"],y,p)}),g=(0,j.$Tm)();return l.createHash("sha256").update(g,"utf8").digest("hex")}catch(l){w(l);return}}const C="Software\\Microsoft\\SQMClient";async function E(w){if(O.$i){const l=await new Promise((g,y)=>{ie(["@vscode/windows-registry"],g,y)});try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch(g){return w(g),""}}return""}e.$Wm=E}),define(ae[31],ce([0,1,53,36,268,6,48,88,16,5,19,10]),function(ie,e,I,A,L,j,O,R,S,d,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function l(K,x=w.UNLINK,H){if((0,O.$2f)(K))throw new Error("rimraf - will refuse to recursively delete root");return x===w.UNLINK?y(K):g(K,H)}async function g(K,x=(0,O.$7f)((0,A.tmpdir)())){try{try{await I.promises.rename(K,x)}catch(H){return H.code==="ENOENT"?void 0:y(K)}y(x).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function y(K){return(0,L.promisify)(I.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function p(K){if((0,O.$2f)(K))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function c(K,x){return b(await(x?f(K):(0,L.promisify)(I.readdir)(K)))}async function f(K){try{return await(0,L.promisify)(I.readdir)(K,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const x=[],H=await c(K);for(const Q of H){let J=!1,W=!1,ee=!1;try{const ne=await e.Promises.lstat((0,S.$ic)(K,Q));J=ne.isFile(),W=ne.isDirectory(),ee=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:Q,isFile:()=>J,isDirectory:()=>W,isSymbolicLink:()=>ee})}return x}function u(K){return b(I.readdirSync(K))}e.readdirSync=u;function b(K){return K.map(x=>typeof x=="string"?d.$j?(0,R.$rl)(x):x:(x.name=d.$j?(0,R.$rl)(x.name):x.name,x))}async function k(K){const x=await c(K),H=[];for(const Q of x)await a.existsDirectory((0,S.$ic)(K,Q))&&H.push(Q);return H}function s(K,x=1e3){return new Promise(H=>{let Q=!1;const J=setInterval(()=>{Q||(Q=!0,I.access(K,W=>{Q=!1,W&&(clearInterval(J),H(void 0))}))},x)})}e.whenDeleted=s;var a;(function(K){async function x(J){let W;try{if(W=await e.Promises.lstat(J),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(d.$i&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw ne}throw ee}}K.stat=x;async function H(J){try{const{stat:W,symbolicLink:ee}=await K.stat(J);return W.isFile()&&ee?.dangling!==!0}catch{}return!1}K.existsFile=H;async function Q(J){try{const{stat:W,symbolicLink:ee}=await K.stat(J);return W.isDirectory()&&ee?.dangling!==!0}catch{}return!1}K.existsDirectory=Q})(a||(e.SymlinkSupport=a={}));const n=new j.$4g;function i(K,x,H){return n.queueFor(E.URI.file(K),C.$ng).queue(()=>{const Q=m(H);return new Promise((J,W)=>o(K,x,Q,ee=>ee?W(ee):J()))})}let t=!0;function r(K){t=K}e.configureFlushOnWrite=r;function o(K,x,H,Q){if(!t)return I.writeFile(K,x,{mode:H.mode,flag:H.flag},Q);I.open(K,H.flag,H.mode,(J,W)=>{if(J)return Q(J);I.writeFile(W,x,ee=>{if(ee)return I.close(W,()=>Q(ee));I.fdatasync(W,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),I.close(W,_=>Q(_))))})})}function v(K,x,H){const Q=m(H);if(!t)return I.writeFileSync(K,x,{mode:Q.mode,flag:Q.flag});const J=I.openSync(K,Q.flag,Q.mode);try{I.writeFileSync(J,x);try{I.fdatasyncSync(J)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),r(!1)}}finally{I.closeSync(J)}}e.writeFileSync=v;function m(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function h(K,x,H=6e4){if(K!==x)try{d.$i&&typeof H=="number"?await $(K,x,Date.now(),H):await(0,L.promisify)(I.rename)(K,x)}catch(Q){if(K.toLowerCase()!==x.toLowerCase()&&Q.code==="EXDEV"||K.endsWith("."))await D(K,x,{preserveSymlinks:!1}),await l(K,w.MOVE);else throw Q}}async function $(K,x,H,Q,J=0){try{return await(0,L.promisify)(I.rename)(K,x)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-H>=Q)throw console.error(`[node.js fs] rename failed after ${J} retries with error: ${W}`),W;if(J===0){let ee=!1;try{const{stat:ne}=await a.stat(x);ne.isFile()||(ee=!0)}catch{}if(ee)throw W}return await(0,j.$Vg)(Math.min(100,J*10)),$(K,x,H,Q,J+1)}}async function D(K,x,H){return M(K,x,{root:{source:K,target:x},options:H,handledSourcePaths:new Set})}const F=511;async function M(K,x,H){if(H.handledSourcePaths.has(K))return;H.handledSourcePaths.add(K);const{stat:Q,symbolicLink:J}=await a.stat(K);if(J){if(H.options.preserveSymlinks)try{return await Y(K,x,H)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(J.dangling)return}return Q.isDirectory()?U(K,x,Q.mode&F,H):q(K,x,Q.mode&F)}async function U(K,x,H,Q){await e.Promises.mkdir(x,{recursive:!0,mode:H});const J=await c(K);for(const W of J)await M((0,S.$ic)(K,W),(0,S.$ic)(x,W),Q)}async function q(K,x,H){await e.Promises.copyFile(K,x),await e.Promises.chmod(x,H)}async function Y(K,x,H){let Q=await e.Promises.readlink(K);(0,O.$Yf)(Q,H.root.source,!d.$k)&&(Q=(0,S.$ic)(H.root.target,Q.substr(H.root.source.length+1))),await e.Promises.symlink(Q,x)}e.Promises=new class{get access(){return(0,L.promisify)(I.access)}get stat(){return(0,L.promisify)(I.stat)}get lstat(){return(0,L.promisify)(I.lstat)}get utimes(){return(0,L.promisify)(I.utimes)}get read(){return(K,x,H,Q,J)=>new Promise((W,ee)=>{I.read(K,x,H,Q,J,(ne,_,se)=>ne?ee(ne):W({bytesRead:_,buffer:se}))})}get readFile(){return(0,L.promisify)(I.readFile)}get write(){return(K,x,H,Q,J)=>new Promise((W,ee)=>{I.write(K,x,H,Q,J,(ne,_,se)=>ne?ee(ne):W({bytesWritten:_,buffer:se}))})}get appendFile(){return(0,L.promisify)(I.appendFile)}get fdatasync(){return(0,L.promisify)(I.fdatasync)}get truncate(){return(0,L.promisify)(I.truncate)}get copyFile(){return(0,L.promisify)(I.copyFile)}get open(){return(0,L.promisify)(I.open)}get close(){return(0,L.promisify)(I.close)}get symlink(){return(0,L.promisify)(I.symlink)}get readlink(){return(0,L.promisify)(I.readlink)}get chmod(){return(0,L.promisify)(I.chmod)}get mkdir(){return(0,L.promisify)(I.mkdir)}get unlink(){return(0,L.promisify)(I.unlink)}get rmdir(){return(0,L.promisify)(I.rmdir)}get realpath(){return(0,L.promisify)(I.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return k}get writeFile(){return i}get rm(){return l}get rename(){return h}get copy(){return D}}}),define(ae[143],ce([0,1,53,16,5,27,31]),function(ie,e,I,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.$9p=e.$8p=void 0;function R(w){if(L.$k)return w;const l=(0,A.$lc)(w);if(w===l)return w;const g=((0,A.$mc)(w)||w).toLowerCase();try{const p=(0,O.readdirSync)(l).filter(c=>c.toLowerCase()===g);if(p.length===1){const c=R(l);if(c)return(0,A.$ic)(c,p[0])}else if(p.length>1){const c=p.indexOf(g);if(c>=0){const f=R(l);if(f)return(0,A.$ic)(f,p[c])}}}catch{}return null}e.$8p=R;async function S(w){if(L.$k)return w;const l=(0,A.$lc)(w);if(w===l)return w;const g=((0,A.$mc)(w)||w).toLowerCase();try{const p=(await O.Promises.readdir(l)).filter(c=>c.toLowerCase()===g);if(p.length===1){const c=await S(l);if(c)return(0,A.$ic)(c,p[0])}else if(p.length>1){const c=p.indexOf(g);if(c>=0){const f=await S(l);if(f)return(0,A.$ic)(f,p[c])}}}catch{}return null}e.$9p=S;async function d(w){try{return await O.Promises.realpath(w)}catch{const g=E(w);return await O.Promises.access(g,I.constants.R_OK),g}}e.$0p=d;function C(w){try{return I.realpathSync(w)}catch{const g=E(w);return I.accessSync(g,I.constants.R_OK),g}}e.$$p=C;function E(w){return(0,j.$Le)((0,A.$gc)(w),A.sep)}}),define(ae[144],ce([0,1,16,5,37,90,12,31]),function(ie,e,I,A,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Fl=e.$El=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function S(E=L.env){return E.comspec||"cmd.exe"}e.$El=S;function d(E){let w=[],l=!1;const g=function(y){if(l){w.push(y);return}(!E.send(y,c=>{if(c&&console.error(c),l=!1,w.length>0){const f=w.slice(0);w=[],f.forEach(u=>g(u))}})||A.$i)&&(l=!0)};return{send:g}}e.$Fl=d;var C;(function(E){async function w(l,g,y){if(I.$hc(l))return l;if(g===void 0&&(g=L.cwd()),I.$lc(l)!=="."||(y===void 0&&O.$zf(L.env.PATH)&&(y=L.env.PATH.split(I.$sc)),y===void 0||y.length===0))return I.$ic(g,l);async function c(f){if(await R.Promises.exists(f)){let u;try{u=await R.Promises.stat(f)}catch(b){b.message.startsWith("EACCES")&&(u=await R.Promises.lstat(f))}return u?!u.isDirectory():!1}return!1}for(const f of y){let u;if(I.$hc(f)?u=I.$ic(f,l):u=I.$ic(g,f,l),await c(u))return u;let b=u+".com";if(await c(b)||(b=u+".exe",await c(b)))return b}return I.$ic(g,l)}E.findExecutable=w})(C||(e.win32=C={}))}),define(ae[145],ce([0,1,66,23]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;function L(O){return new Promise((R,S)=>{let d;const C=new Map;function E(l,g,y,p,c){const f=C.get(g);if(l===O||f){const u={name:w(y),cmd:y,pid:l,ppid:g,load:p,mem:c};C.set(l,u),l===O&&(d=u),f&&(f.children||(f.children=[]),f.children.push(u),f.children.length>1&&(f.children=f.children.sort((b,k)=>b.pid-k.pid)))}}function w(l){const g=/--utility-sub-type=network/i,y=/--ms-enable-electron-run-as-node/i,p=/--crashes-directory/i,c=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(p.exec(l))return"electron-crash-reporter";if(c.exec(l))return"winpty-agent";if(f.exec(l))return"conpty-agent";let b=u.exec(l);if(b&&b.length===2)return b[1]==="renderer"?"window":b[1]==="utility"?g.exec(l)?"utility-network-service":"utility-process":b[1]==="extensionHost"?"extension-host":b[1];const k=/[a-zA-Z-]+\.js/g;let s="";do b=k.exec(l),b&&(s+=b+" ");while(b);return s&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${s})`:y.exec(l)?`electron-nodejs (${l})`:l}if(process.platform==="win32"){const l=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,y)=>{ie(["@vscode/windows-process-tree"],g,y)}).then(g=>{g.getProcessList(O,y=>{if(!y){S(new Error(`Root process ${O} not found`));return}g.getProcessCpuUsage(y,p=>{const c=new Map;p.forEach(f=>{const u=l(f.commandLine||"");c.set(f.pid,{name:w(u),cmd:u,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),d=c.get(O),d?(c.forEach(f=>{const u=c.get(f.ppid);u&&(u.children||(u.children=[]),u.children.push(f))}),c.forEach(f=>{f.children&&(f.children=f.children.sort((u,b)=>u.pid-b.pid))}),R(d)):S(new Error(`Root process ${O} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let l=function(){let g=[d];const y=[];for(;g.length;){const c=g.shift();c&&(y.push(c.pid),c.children&&(g=g.concat(c.children)))}let p=JSON.stringify(A.$dg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+y.join(" "),(0,I.exec)(p,{},(c,f,u)=>{if(c||u)S(c||new Error(u.toString()));else{const b=f.toString().split(`
`);for(let k=0;k<y.length;k++){const s=C.get(y[k]);s.load=parseFloat(b[k])}if(!d){S(new Error(`Root process ${O} not found`));return}R(d)}})};(0,I.exec)("which ps",{},(g,y,p)=>{if(g||p)if(process.platform!=="linux")S(g||new Error(p.toString()));else{const c=JSON.stringify(A.$dg.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(c,{},(f,u,b)=>{f||b?S(f||new Error(b.toString())):(j(u,E),l())})}else{const c=y.toString().trim(),f="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${c} ${f}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,b,k)=>{u||k&&!k.includes("screen size is bogus")?S(u||new Error(k.toString())):(j(b,E),process.platform==="linux"?l():d?R(d):S(new Error(`Root process ${O} not found`)))})}})}})}e.$Fr=L;function j(O,R){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=O.toString().split(`
`);for(const C of d){const E=S.exec(C.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var pe=this&&this.__decorate||function(ie,e,I,A){var L=arguments.length,j=L<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,I):A,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(ie,e,I,A);else for(var R=ie.length-1;R>=0;R--)(O=ie[R])&&(j=(L<3?O(j):L>3?O(e,I,j):O(e,I))||j);return L>3&&j&&Object.defineProperty(e,I,j),j};define(ae[40],ce([0,1,18,6,15,26,84,7,3,2,65,27,12]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.ProxyChannel=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.RequestInitiator=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0;var l;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(l||(l={}));function g(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(y||(y={}));function p(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(c||(c={}));function f(J){let W=0;for(let ee=0;;ee+=7){const ne=J.read(1);if(W|=(ne.buffer[0]&127)<<ee,!(ne.buffer[0]&128))return W}}const u=n(0);function b(J,W){if(W===0){J.write(u);return}let ee=0;for(let _=W;_!==0;_=_>>>7)ee++;const ne=L.$ce.alloc(ee);for(let _=0;W!==0;_++)ne.buffer[_]=W&127,W=W>>>7,W>0&&(ne.buffer[_]|=128);J.write(ne)}class k{constructor(W){this.b=W,this.a=0}read(W){const ee=this.b.slice(this.a,this.a+W);return this.a+=ee.byteLength,ee}}e.$qh=k;class s{constructor(){this.a=[]}get buffer(){return L.$ce.concat(this.a)}write(W){this.a.push(W)}}e.$rh=s;var a;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(a||(a={}));function n(J){const W=L.$ce.alloc(1);return W.writeUInt8(J,0),W}const i={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object),Uint:n(a.Int)},t=typeof Buffer<"u";function r(J,W){if(typeof W>"u")J.write(i.Undefined);else if(typeof W=="string"){const ee=L.$ce.fromString(W);J.write(i.String),b(J,ee.byteLength),J.write(ee)}else if(t&&Buffer.isBuffer(W)){const ee=L.$ce.wrap(W);J.write(i.Buffer),b(J,ee.byteLength),J.write(ee)}else if(W instanceof L.$ce)J.write(i.VSBuffer),b(J,W.byteLength),J.write(W);else if(Array.isArray(W)){J.write(i.Array),b(J,W.length);for(const ee of W)r(J,ee)}else if(typeof W=="number"&&(W|0)===W)J.write(i.Uint),b(J,W);else{const ee=L.$ce.fromString(JSON.stringify(W));J.write(i.Object),b(J,ee.byteLength),J.write(ee)}}e.$sh=r;function o(J){switch(J.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return J.read(f(J)).toString();case a.Buffer:return J.read(f(J)).buffer;case a.VSBuffer:return J.read(f(J));case a.Array:{const ee=f(J),ne=[];for(let _=0;_<ee;_++)ne.push(o(J));return ne}case a.Object:return JSON.parse(J.read(f(J)).toString());case a.Int:return f(J)}}e.$th=o;class v{constructor(W,ee,ne=null,_=1e3){this.h=W,this.j=ee,this.k=ne,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:200})}registerChannel(W,ee){this.b.set(W,ee),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const ee=this.o([W.type]);this.k?.logOutgoing(ee,0,1,p(W.type));return}case 201:case 202:case 204:case 203:{const ee=this.o([W.type,W.id],W.data);this.k?.logOutgoing(ee,W.id,1,p(W.type),W.data);return}}}o(W,ee=void 0){const ne=new s;return r(ne,W),r(ne,ee),this.p(ne.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const ee=new k(W),ne=o(ee),_=o(ee),se=ne[0];switch(se){case 100:return this.k?.logIncoming(W.byteLength,ne[1],1,`${g(se)}: ${ne[2]}.${ne[3]}`,_),this.s({type:se,id:ne[1],channelName:ne[2],name:ne[3],arg:_});case 102:return this.k?.logIncoming(W.byteLength,ne[1],1,`${g(se)}: ${ne[2]}.${ne[3]}`,_),this.t({type:se,id:ne[1],channelName:ne[2],name:ne[3],arg:_});case 101:return this.k?.logIncoming(W.byteLength,ne[1],1,`${g(se)}`),this.u({type:se,id:ne[1]});case 103:return this.k?.logIncoming(W.byteLength,ne[1],1,`${g(se)}`),this.u({type:se,id:ne[1]})}}s(W){const ee=this.b.get(W.channelName);if(!ee){this.v(W);return}const ne=new j.$Yd;let _;try{_=ee.call(this.j,W.name,W.arg,ne.token)}catch(z){_=Promise.reject(z)}const se=W.id;_.then(z=>{this.m({id:se,data:z,type:201})},z=>{z instanceof Error?this.m({id:se,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:se,data:z,type:203})}).finally(()=>{Z.dispose(),this.d.delete(W.id)});const Z=(0,d.$Pc)(()=>ne.cancel());this.d.set(W.id,Z)}t(W){const ee=this.b.get(W.channelName);if(!ee){this.v(W);return}const ne=W.id,se=ee.listen(this.j,W.name,W.arg)(Z=>this.m({id:ne,data:Z,type:204}));this.d.set(W.id,se)}u(W){const ee=this.d.get(W.id);ee&&(ee.dispose(),this.d.delete(W.id))}v(W){let ee=this.g.get(W.channelName);ee||(ee=[],this.g.set(W.channelName,ee));const ne=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ee.push({request:W,timeoutTimer:ne})}w(W){const ee=this.g.get(W);if(ee){for(const ne of ee)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.$Mc)(this.d.values()),this.d.clear()}}e.$uh=v;var m;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class h{constructor(W,ee=null){this.l=W,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$Od,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=ee}getChannel(W){const ee=this;return{call(ne,_,se){return ee.a?Promise.reject(new R.$4):ee.m(W,ne,_,se)},listen(ne,_){return ee.a?S.Event.None:ee.o(W,ne,_)}}}m(W,ee,ne,_=j.CancellationToken.None){const se=this.g++,z={id:se,type:100,channelName:W,name:ee,arg:ne};if(_.isCancellationRequested)return Promise.reject(new R.$4);let P;return new Promise((B,N)=>{if(_.isCancellationRequested)return N(new R.$4);const V=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(se),B(he.data);break;case 202:{this.f.delete(se);const ge=new Error(he.data.message);ge.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,ge.name=he.data.name,N(ge);break}case 203:this.f.delete(se),N(he.data);break}};this.f.set(se,ue),this.p(z)};let G=null;this.b===c.Idle?V():(G=(0,A.$Ig)(ue=>this.u()),G.then(()=>{G=null,V()}));const te=()=>{G?(G.cancel(),G=null):this.p({id:se,type:101}),N(new R.$4)},oe=_.onCancellationRequested(te);P=(0,d.$Oc)((0,d.$Pc)(te),oe),this.d.add(P)}).finally(()=>{P.dispose(),this.d.delete(P)})}o(W,ee,ne){const _=this.g++,Z={id:_,type:102,channelName:W,name:ee,arg:ne};let z=null;const P=new S.$Od({onWillAddFirstListener:()=>{z=(0,A.$Ig)(B=>this.u()),z.then(()=>{z=null,this.d.add(P),this.p(Z)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(P),this.p({id:_,type:103}))}}),T=B=>P.fire(B.data);return this.f.set(_,T),P.event}p(W){switch(W.type){case 100:case 102:{const ee=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(ee,W.id,0,`${g(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const ee=this.q([W.type,W.id]);this.j?.logOutgoing(ee,W.id,0,g(W.type));return}}}q(W,ee=void 0){const ne=new s;return r(ne,W),r(ne,ee),this.r(ne.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const ee=new k(W),ne=o(ee),_=o(ee),se=ne[0];switch(se){case 200:return this.j?.logIncoming(W.byteLength,0,0,p(se)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,ne[1],0,p(se),_),this.t({type:ne[0],id:ne[1],data:_})}}t(W){if(W.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.$Mc)(this.d.values()),this.d.clear()}}e.$vh=h,pe([O.$kh],h.prototype,"onDidInitializePromise",null);class ${get connections(){const W=[];return this.f.forEach(ee=>W.push(ee)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new S.$Od,this.onDidAddConnection=this.g.event,this.h=new S.$Od,this.onDidRemoveConnection=this.h.event,this.j=new d.$Qc,this.j.add(W(({protocol:ee,onDidClientDisconnect:ne})=>{const _=S.Event.once(ee.onMessage);this.j.add(_(se=>{const Z=new k(se),z=o(Z),P=new v(ee,z),T=new h(ee);this.a.forEach((N,V)=>P.registerChannel(V,N));const B={channelServer:P,channelClient:T,ctx:z};this.f.add(B),this.g.fire(B),this.j.add(ne(()=>{P.dispose(),T.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(W,ee){const ne=this;return{call(_,se,Z){let z;if((0,w.$Nf)(ee)){const T=(0,I.$3b)(ne.connections.filter(ee));z=T?Promise.resolve(T):S.Event.toPromise(S.Event.filter(ne.onDidAddConnection,ee))}else z=ee.routeCall(ne,_,se);const P=z.then(T=>T.channelClient.getChannel(W));return F(P).call(_,se,Z)},listen(_,se){if((0,w.$Nf)(ee))return ne.k(W,ee,_,se);const Z=ee.routeEvent(ne,_,se).then(z=>z.channelClient.getChannel(W));return F(Z).listen(_,se)}}}k(W,ee,ne,_){const se=this;let Z;const z=new S.$Od({onWillAddFirstListener:()=>{Z=new d.$Qc;const P=new S.$Ud,T=new Map,B=V=>{const te=V.channelClient.getChannel(W).listen(ne,_),oe=P.add(te);T.set(V,oe)},N=V=>{const G=T.get(V);G&&(G.dispose(),T.delete(V))};se.connections.filter(ee).forEach(B),S.Event.filter(se.onDidAddConnection,ee)(B,void 0,Z),se.onDidRemoveConnection(N,void 0,Z),P.event(z.fire,z,Z),Z.add(P)},onDidRemoveLastListener:()=>{Z?.dispose(),Z=void 0}});return z.event}registerChannel(W,ee){this.a.set(W,ee);for(const ne of this.f)ne.channelServer.registerChannel(W,ee)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$wh=$;class D{constructor(W,ee,ne=null){const _=new s;r(_,ee),W.send(_.buffer),this.a=new h(W,ne),this.d=new v(W,ee,ne)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,ee){this.d.registerChannel(W,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$xh=D;function F(J){return{call(W,ee,ne){return J.then(_=>_.call(W,ee,ne))},listen(W,ee){const ne=new S.$Xd;return J.then(_=>ne.input=_.listen(W,ee)),ne.event}}}e.$yh=F;function M(J){let W=!1;return{call(ee,ne,_){return W?J.call(ee,ne,_):(0,A.$Vg)(0).then(()=>W=!0).then(()=>J.call(ee,ne,_))},listen(ee,ne){if(W)return J.listen(ee,ne);const _=new S.$Xd;return(0,A.$Vg)(0).then(()=>W=!0).then(()=>_.input=J.listen(ee,ne)),_.event}}}e.$zh=M;class U{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const ee of W.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await S.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$Ah=U;var q;(function(J){function W(se,Z,z){const P=se,T=z&&z.disableMarshalling,B=new Map;for(const N in P)ne(N)&&B.set(N,S.Event.buffer(P[N],!0,void 0,Z));return new class{listen(N,V,G){const te=B.get(V);if(te)return te;if(_(V)){const oe=P[V];if(typeof oe=="function")return oe.call(P,G)}throw new R.$ab(`Event not found: ${V}`)}call(N,V,G){const te=P[V];if(typeof te=="function"){if(!T&&Array.isArray(G))for(let ue=0;ue<G.length;ue++)G[ue]=(0,C.$ph)(G[ue]);let oe=te.apply(P,G);return oe instanceof Promise||(oe=Promise.resolve(oe)),oe}throw new R.$ab(`Method not found: ${V}`)}}}J.fromService=W;function ee(se,Z){const z=Z&&Z.disableMarshalling;return new Proxy({},{get(P,T){if(typeof T=="string")return Z?.properties?.has(T)?Z.properties.get(T):_(T)?function(B){return se.listen(T,B)}:ne(T)?se.listen(T):async function(...B){let N;Z&&!(0,w.$If)(Z.context)?N=[Z.context,...B]:N=B;const V=await se.call(T,N);return z?V:(0,C.$ph)(V)};throw new R.$ab(`Property not found: ${String(T)}`)}})}J.toService=ee;function ne(se){return se[0]==="o"&&se[1]==="n"&&E.$2e(se.charCodeAt(2))}function _(se){return/^onDynamic/.test(se)&&E.$2e(se.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const W=J.toString();if(W!=="[object Object]")return W}return J}function x(J){return Array.isArray(J)?J.map(K):K(J)}function H(J,W,ee,ne,_,se,Z){Z=x(Z);const z=Y[_],P=z[ne%z.length];let T=[`%c[${J}]%c[${String(W).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(se)?(T=T.concat(Z),T.push(")")):T.push(Z),console.log.apply(console,T)}class Q{constructor(W,ee){this.d=W,this.f=ee,this.a=0,this.b=0}logOutgoing(W,ee,ne,_,se){this.b+=W,H(this.d,this.b,W,ee,ne,_,se)}logIncoming(W,ee,ne,_,se){this.a+=W,H(this.f,this.a,W,ee,ne,_,se)}}e.$Bh=Q}),define(ae[67],ce([0,1,15,3,2,40]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.ProtocolConstants=e.$Ch=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var R;(function(i){i.enableDiagnostics=!1,i.records=[];const t=new WeakMap;let r=0;function o(m,h){if(!t.has(m)){const $=String(++r);t.set(m,$)}return t.get(m)}function v(m,h,$,D){if(!i.enableDiagnostics)return;const F=o(m,h);if(D instanceof I.$ce||D instanceof Uint8Array||D instanceof ArrayBuffer||ArrayBuffer.isView(D)){const M=I.$ce.alloc(D.byteLength);M.set(D),i.records.push({timestamp:Date.now(),id:F,label:h,type:$,buff:M})}else i.records.push({timestamp:Date.now(),id:F,label:h,type:$,data:D})}i.traceSocketEvent=v})(R||(e.SocketDiagnostics=R={}));var S;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let d=null;function C(){return d||(d=I.$ce.alloc(0)),d}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const h=this.a[0];return r&&(this.a.shift(),this.b-=t),h}if(this.a[0].byteLength>t){const h=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),h}const o=I.$ce.alloc(t);let v=0,m=0;for(;t>0;){const h=this.a[m];if(h.byteLength>t){const $=h.slice(0,t);o.set($,v),v+=t,r&&(this.a[m]=h.slice(t),this.b-=t),t-=t}else o.set(h,v),v+=h.byteLength,r?(this.a.shift(),this.b-=h.byteLength):m++,t-=h.byteLength}return o}}e.$Ch=E;var w;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(w||(w={}));function l(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class y{constructor(t,r,o,v){this.type=t,this.id=r,this.ack=o,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends L.$Rc{constructor(t){super(),this.f=this.B(new A.$Od),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new E,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,v=this.g.id,m=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new y(o,v,m,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.$ce.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const o=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,o}h(){const t=I.$ce.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class f extends L.$Rc{constructor(t){super(),this.f=new A.$Od,this.onMessage=this.f.event,this.g=new A.$Od,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new c(this.a)),this.c=this.B(new p(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new y(1,0,0,t))}}e.$Dh=f;class u extends j.$xh{static fromSocket(t,r){return new u(new f(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,o=null){super(t,r,o),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Eh=u;class b{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$Od({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Fh=b;class k{constructor(t){this.data=t,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,o=this.a;for(;o;)t[r++]=o.data,o=o.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new k(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class a{static{this.a=10}static{this.b=null}static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<a.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=a.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+a.a)*1e3;let o=0;for(let v=0;v<a.a;v++)t-this.c[v]<=r&&o++;return 1-o/a.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new b,this.onControlMessage=this.u.event,this.v=new b,this.onMessage=this.v.event,this.w=new b,this.onDidDispose=this.w.event,this.x=new b,this.onSocketClose=this.x.event,this.y=new b,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??a.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Qc,this.o=t.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new y(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new y(7,0,0,C());this.p.write(t)}sendResume(){const t=new y(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new L.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new y(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new y(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let o=0,v=r.length;o<v;o++)this.p.write(r[o]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const o=new y(1,r,this.h,t);this.b.push(o),this.a||(this.p.write(o),this.B())}sendControl(t){const r=new y(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,o=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&o>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:o});return}const m=Math.max(2e4-r,2e4-o,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},m)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new y(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new y(9,0,this.h,C());this.p.write(t)}}e.$Gh=n}),define(ae[93],ce([0,1,66,6,15,26,140,7,3,2,30,144,90,40]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0;class g extends l.$uh{constructor(c){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",f=>L.$ce.wrap(Buffer.from(f,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$5p=g;class y{constructor(c,f){this.i=c,this.j=f,this.c=new Set,this.g=new Map,this.h=new S.$Od,this.onDidProcessExit=this.h.event;const u=f&&f.timeout?f.timeout:6e4;this.b=new A.$Rg(u),this.d=null,this.f=null}getChannel(c){const f=this;return{call(u,b,k){return f.k(c,u,b,k)},listen(u,b){return f.l(c,u,b)}}}k(c,f,u,b=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(R.$5());this.b.cancel();const k=this.n(c),s=(0,A.$Ig)(i=>k.call(f,u,i)),a=b.onCancellationRequested(()=>s.cancel()),n=(0,d.$Pc)(()=>s.cancel());return this.c.add(n),s.finally(()=>{a.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(c,f,u){if(!this.b)return S.Event.None;this.b.cancel();let b;const k=new S.$Od({onWillAddFirstListener:()=>{b=this.n(c).listen(f,u)(k.fire,k),this.c.add(b)},onDidRemoveLastListener:()=>{this.c.delete(b),b.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return k.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,C.$0m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,w.$Dl)(f.env),this.d=(0,I.fork)(this.i,c,f);const u=new S.$Od;S.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,O.$1p)(t)){(0,O.log)(t,`IPC Library: ${this.j.serverName}`);return}u.fire(L.$ce.wrap(Buffer.from(t,"base64")))});const k=this.j.useQueue?(0,E.$Fl)(this.d):this.d,s=t=>this.d&&this.d.connected&&k.send(t.buffer.toString("base64")),a=u.event,n={send:s,onMessage:a};this.f=new l.$vh(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",i),this.c.forEach(o=>(0,d.$Mc)(o)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(c){let f=this.g.get(c);return f||(f=this.m.getChannel(c),this.g.set(c,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$6p=y}),define(ae[146],ce([0,1,133,15,40,3,12,18]),function(ie,e,I,A,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4T=e.$3T=void 0;class S{constructor(w){this.a=w,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",l=>A.$ce.wrap(l.data)),w.start()}send(w){this.a.postMessage(w.buffer)}disconnect(){this.a.close()}}class d extends L.$wh{static b(w){(0,O.$Jf)((0,I.$2T)(process),"Electron Utility Process");const l=new j.$Od;return process.parentPort.on("message",g=>{if(w?.handledClientConnection(g))return;const y=(0,R.$Nb)(g.ports);y&&l.fire(y)}),j.Event.map(l.event,g=>({protocol:new S(g),onDidClientDisconnect:j.Event.fromNodeEventEmitter(g,"close")}))}constructor(w){super(d.b(w))}}e.$3T=d;function C(E,w,l){const g=y=>{y.data===w&&(E.removeListener("message",g),l())};E.on("message",g)}e.$4T=C}),define(ae[68],ce([0,1,6,3,2,65,12]),function(ie,e,I,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.StorageState=e.$4o=e.StorageHint=void 0;var R;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function S(w){const l=w;return l?.changed instanceof Map||l?.deleted instanceof Set}e.$4o=S;var d;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(d||(e.StorageState=d={}));class C extends L.$Rc{static{this.a=100}constructor(l,g=Object.create(null)){super(),this.r=l,this.s=g,this.b=this.B(new A.$Rd),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=this.B(new I.$Sg(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(l=>this.u(l)))}u(l){this.b.pause();try{l.changed?.forEach((g,y)=>this.w(y,g)),l.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(l,g){if(this.c===d.Closed)return;let y=!1;(0,O.$If)(g)?y=this.f.delete(l):this.f.get(l)!==g&&(this.f.set(l,g),y=!0),y&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(l,g){const y=this.f.get(l);return(0,O.$If)(y)?g:y}getBoolean(l,g){const y=this.get(l);return(0,O.$If)(y)?g:y==="true"}getNumber(l,g){const y=this.get(l);return(0,O.$If)(y)?g:parseInt(y,10)}getObject(l,g){const y=this.get(l);return(0,O.$If)(y)?g:(0,j.$oh)(y)}async set(l,g,y=!1){if(this.c===d.Closed)return;if((0,O.$If)(g))return this.delete(l,y);const p=(0,O.$Bf)(g)||Array.isArray(g)?(0,j.$nh)(g):String(g);if(this.f.get(l)!==p)return this.f.set(l,p),this.j.set(l,p),this.h.delete(l),this.b.fire({key:l,external:y}),this.D()}async delete(l,g=!1){if(!(this.c===d.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:g}),this.D()}async optimize(){if(this.c!==d.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=d.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(l).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(l){if(this.z)return this.D(l)}async D(l){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),l)}async whenFlushed(){if(this.z)return new Promise(l=>this.n.push(l))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$5o=C;class E{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach((g,y)=>this.a.set(y,g)),l.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$6o=E}),define(ae[147],ce([13,9]),function(ie,e){return ie.create("vs/base/node/zip",e)}),define(ae[148],ce([13,9]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[149],ce([13,9]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[150],ce([13,9]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(ae[151],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ae[152],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[153],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[154],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[155],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ae[156],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ae[157],ce([13,9]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[158],ce([13,9]),function(ie,e){return ie.create("vs/platform/files/common/fileService",e)}),define(ae[159],ce([13,9]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(ae[160],ce([13,9]),function(ie,e){return ie.create("vs/platform/files/common/io",e)}),define(ae[161],ce([13,9]),function(ie,e){return ie.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[162],ce([13,9]),function(ie,e){return ie.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ae[163],ce([13,9]),function(ie,e){return ie.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ae[164],ce([13,9]),function(ie,e){return ie.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ae[165],ce([13,9]),function(ie,e){return ie.create("vs/platform/request/common/request",e)}),define(ae[166],ce([13,9]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ae[167],ce([13,9]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[168],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[169],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ae[170],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ae[171],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ae[172],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ae[173],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ae[174],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ae[175],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ae[176],ce([13,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ae[177],ce([13,9]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(ae[178],ce([0,1,7,150]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.TokenType=void 0;var L;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(L||(e.TokenType=L={}));function j(...d){switch(d.length){case 1:return(0,A.localize)(0,null,d[0]);case 2:return(0,A.localize)(1,null,d[0],d[1]);case 3:return(0,A.localize)(2,null,d[0],d[1],d[2]);default:return}}const O=(0,A.localize)(3,null),R=(0,A.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,I.$7)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const E=this.d,w=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:w};this.g.push({offset:E,lexeme:w,additionalInfo:C}),this.f.push(l)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const E=this.c.substring(this.d,this.e),w=S.b.get(E);w?this.k(w):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,E=!1,w=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(R);return}const g=this.c.charCodeAt(C);if(E)E=!1;else if(g===47&&!w){C++;break}else g===91?w=!0:g===92?E=!0:g===93&&(w=!1);C++}for(;C<this.c.length&&S.a.has(this.c.charCodeAt(C));)C++;this.e=C;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ni=S}),define(ae[179],ce([0,1,64,84,23,16,37,19,10]),function(ie,e,I,A,L,j,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=e.$km=e.$jm=e.$im=void 0,e.$im=/^([^.]+\..+):(.+)$/;class d{get appRoot(){return(0,j.$lc)(L.$dg.asFileUri("").fsPath)}get userHome(){return S.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return S.URI.file((0,j.$ic)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.b.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get stateResource(){return(0,R.$wg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$wg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,I.$hm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$ic)(this.userDataPath,"logs",l)}return S.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$wg)(S.URI.file((0,j.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$wg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$wg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$wg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=O.env.VSCODE_PORTABLE;return l?S.URI.file((0,j.$ic)(l,"argv.json")):(0,R.$wg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,j.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,j.$jc)(l):(0,j.$gc)((0,j.$ic)(L.$dg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?S.URI.file((0,j.$jc)(l)):S.URI.file((0,j.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,j.$jc)(l);const g=O.env.VSCODE_EXTENSIONS;if(g)return g;const y=O.env.VSCODE_PORTABLE;return y?(0,j.$ic)(y,"extensions"):(0,R.$wg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(g=>/^[^:/?#]+?:\/\//.test(g)?S.URI.parse(g):S.URI.file((0,j.$gc)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?S.URI.parse(l):S.URI.file((0,j.$gc)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$im.test(l))}get extensionLogLevel(){const l=[];for(const g of this.args.log||[]){const y=e.$im.exec(g);y&&y[1]&&y[2]&&l.push([y[1],y[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,R.$wg)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=O.env.VSCODE_PORTABLE;return l?S.URI.file((0,j.$ic)(l,"policy.json")):(0,R.$wg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,g,y){this.a=l,this.b=g,this.c=y,this.editSessionId=this.args.editSessionId}}e.$jm=d,pe([A.$kh],d.prototype,"appRoot",null),pe([A.$kh],d.prototype,"userHome",null),pe([A.$kh],d.prototype,"userDataPath",null),pe([A.$kh],d.prototype,"appSettingsHome",null),pe([A.$kh],d.prototype,"tmpDir",null),pe([A.$kh],d.prototype,"cacheHome",null),pe([A.$kh],d.prototype,"stateResource",null),pe([A.$kh],d.prototype,"userRoamingDataHome",null),pe([A.$kh],d.prototype,"userDataSyncHome",null),pe([A.$kh],d.prototype,"sync",null),pe([A.$kh],d.prototype,"machineSettingsResource",null),pe([A.$kh],d.prototype,"workspaceStorageHome",null),pe([A.$kh],d.prototype,"localHistoryHome",null),pe([A.$kh],d.prototype,"keyboardLayoutResource",null),pe([A.$kh],d.prototype,"argvResource",null),pe([A.$kh],d.prototype,"isExtensionDevelopment",null),pe([A.$kh],d.prototype,"untitledWorkspacesHome",null),pe([A.$kh],d.prototype,"builtinExtensionsPath",null),pe([A.$kh],d.prototype,"extensionsPath",null),pe([A.$kh],d.prototype,"extensionDevelopmentLocationURI",null),pe([A.$kh],d.prototype,"extensionDevelopmentKind",null),pe([A.$kh],d.prototype,"extensionTestsLocationURI",null),pe([A.$kh],d.prototype,"debugExtensionHost",null),pe([A.$kh],d.prototype,"logLevel",null),pe([A.$kh],d.prototype,"extensionLogLevel",null),pe([A.$kh],d.prototype,"serviceMachineIdResource",null),pe([A.$kh],d.prototype,"disableTelemetry",null),pe([A.$kh],d.prototype,"disableWorkspaceTrust",null),pe([A.$kh],d.prototype,"useInMemorySecretStorage",null),pe([A.$kh],d.prototype,"policyFile",null);function C(w,l){return E(w["inspect-extensions"],w["inspect-brk-extensions"],5870,l,w.debugId,w.extensionEnvironment)}e.$km=C;function E(w,l,g,y,p,c){const u=Number(l||w)||(y?null:g),b=u?!!l:!1;let k;if(c)try{k=JSON.parse(c)}catch{}return{port:u,break:b,debugId:p,env:k}}e.$lm=E}),function(){"use strict";function ie(e,I,A){function L(O,R){const S=j(O,R),d=[S];return e.isAbsolute(S)||d.unshift(A),e.resolve(...d)}function j(O,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,R);const C=O["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(E,"AppData","Roaming")}break;case"darwin":d=e.join(I.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,R)}return{getUserDataPath:L}}if(typeof define=="function")define(ae[180],ce([269,36,37]),function(e,I,A){return ie(e,I,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=ie(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[181],ce([0,1,36,179,180]),function(ie,e,I,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=e.$mm=void 0;class j extends A.$jm{constructor(d,C){super(d,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,L.getUserDataPath)(d,C.nameShort)},C)}}e.$mm=j;function O(S,d){return(0,A.$lm)(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,d,S.extensionEnvironment)}e.$nm=O;function R(S,d){return(0,A.$lm)(S["inspect-sharedprocess"],S["inspect-brk-sharedprocess"],5879,d,S.extensionEnvironment)}e.$om=R}),define(ae[182],ce([0,1,12,153]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;function L(O,R,S,d){try{j(O,R,S,d)}catch(C){O.error(C?.message??C)}return R}e.$Ap=L;function j(O,R,S,d){const C=(E,w,l)=>{const g=E[w];if((0,I.$zf)(g)){const y=g,p=y.length;if(p>1&&y[0]==="%"&&y[p-1]==="%"){const c=y.substr(1,p-2);let f=S[c];f===void 0&&d&&(f=d[c]);const u=typeof f=="string"?f:f?.message,b=d?.[c],k=typeof b=="string"?b:b?.message;if(!u){k||O.warn(`[${R.name}]: ${(0,A.localize)(0,null,c)}`);return}if(l&&(w==="title"||w==="category")&&k&&k!==u){const s={value:u,original:k};E[w]=s}else E[w]=u}}else if((0,I.$Bf)(g))for(const y in g)g.hasOwnProperty(y)&&(y==="commands"?C(g,y,!0):C(g,y,l));else if(Array.isArray(g))for(let y=0;y<g.length;y++)C(g,y,l)};for(const E in R)R.hasOwnProperty(E)&&C(R,E)}}),define(ae[183],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h0b=e.$g0b=void 0;class I{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$g0b=I;class A{constructor(j){this.a=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,R){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${O}`)}}e.$h0b=A}),define(ae[69],ce([0,1,19,89,157,54]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function S(c){return c=c.trim(),c==="*"||O.test(c)}e.$Oo=S;function d(c){if(!S(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=c.match(O);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$Po=d;function C(c){if(!c)return null;const f=c.majorBase,u=c.majorMustEqual,b=c.minorBase;let k=c.minorMustEqual;const s=c.patchBase;let a=c.patchMustEqual;c.hasCaret&&(f===0||(k=!1),a=!1);let n=0;if(c.preRelease){const i=R.exec(c.preRelease);if(i){const[,t,r,o]=i;n=Date.UTC(Number(t),Number(r)-1,Number(o))}}return{majorBase:f,majorMustEqual:u,minorBase:b,minorMustEqual:k,patchBase:s,patchMustEqual:a,isMinimum:c.hasGreaterEquals,notBefore:n}}e.$Qo=C;function E(c,f,u){let b;typeof c=="string"?b=C(d(c)):b=c;let k;f instanceof Date?k=f.getTime():typeof f=="string"&&(k=new Date(f).getTime());let s;if(typeof u=="string"?s=C(d(u)):s=u,!b||!s)return!1;const a=b.majorBase,n=b.minorBase,i=b.patchBase;let t=s.majorBase,r=s.minorBase,o=s.patchBase;const v=s.notBefore;let m=s.majorMustEqual,h=s.minorMustEqual,$=s.patchMustEqual;return s.isMinimum?a>t?!0:a<t?!1:n>r?!0:n<r||k&&k<v?!1:i>=o:(a===1&&t===0&&(!m||!h||!$)&&(t=1,r=0,o=0,m=!0,h=!1,$=!1),a<t?!1:a>t?!m:n<r?!1:n>r?!h:i<o?!1:i>o?!$:!(k&&k<v))}e.$Ro=E;function w(c,f,u,b,k){const s=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return s.push([A.default.Error,L.localize(0,null)]),s;if(typeof b.name!="string")return s.push([A.default.Error,L.localize(1,null,"name")]),s;if(typeof b.version!="string")return s.push([A.default.Error,L.localize(2,null,"version")]),s;if(!b.engines)return s.push([A.default.Error,L.localize(3,null,"engines")]),s;if(typeof b.engines.vscode!="string")return s.push([A.default.Error,L.localize(4,null,"engines.vscode")]),s;if(typeof b.extensionDependencies<"u"&&!p(b.extensionDependencies))return s.push([A.default.Error,L.localize(5,null,"extensionDependencies")]),s;if(typeof b.activationEvents<"u"){if(!p(b.activationEvents))return s.push([A.default.Error,L.localize(6,null,"activationEvents")]),s;if(typeof b.main>"u"&&typeof b.browser>"u")return s.push([A.default.Error,L.localize(7,null,"activationEvents","main","browser")]),s}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&s.push([A.default.Warning,L.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return s.push([A.default.Error,L.localize(9,null,"main")]),s;{const i=(0,I.$wg)(u,b.main);(0,I.$qg)(i,u)||s.push([A.default.Warning,L.localize(10,null,i.path,u.path)])}}if(typeof b.browser<"u"){if(typeof b.browser!="string")return s.push([A.default.Error,L.localize(11,null,"browser")]),s;{const i=(0,I.$wg)(u,b.browser);(0,I.$qg)(i,u)||s.push([A.default.Warning,L.localize(12,null,i.path,u.path)])}}if(!j.valid(b.version))return s.push([A.default.Error,L.localize(13,null)]),s;const a=[];if(!l(c,f,b,k,a))for(const i of a)s.push([A.default.Error,i]);return s}e.$So=w;function l(c,f,u,b,k){return b||typeof u.main>"u"&&typeof u.browser>"u"?!0:y(c,f,u.engines.vscode,k)}e.$To=l;function g(c,f,u){return c==="*"||y(f,u,c)}e.$Uo=g;function y(c,f,u,b=[]){const k=C(d(u));if(!k)return b.push(L.localize(14,null,u)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return b.push(L.localize(15,null,u)),!1}else if(!k.majorMustEqual)return b.push(L.localize(16,null,u)),!1;return E(c,f,k)?!0:(b.push(L.localize(17,null,c,u)),!1)}function p(c){if(!Array.isArray(c))return!1;for(let f=0,u=c.length;f<u;f++)if(typeof c[f]!="string")return!1;return!0}}),define(ae[43],ce([0,1,15,32]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=void 0;async function L(j,O,R){let S=R&&R.get("storage.serviceMachineId",-1)||null;if(S)return S;try{const C=(await O.readFile(j.serviceMachineIdResource)).value.toString();S=(0,A.$eg)(C)?C:null}catch{S=null}if(!S){S=(0,A.$fg)();try{await O.writeFile(j.serviceMachineIdResource,I.$ce.fromString(S))}catch{}}return R?.store("storage.serviceMachineId",S,-1,1),S}e.$cp=L}),define(ae[70],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=void 0;class I{constructor(L,j=[],O=!1){this.ctor=L,this.staticArguments=j,this.supportsDelayedInstantiation=O}}e.$Ph=I}),define(ae[184],ce([0,1,70]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=e.InstantiationType=void 0;const A=[];var L;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function j(R,S,d){S instanceof I.$Ph||(S=new I.$Ph(S,[],!!d)),A.push([R,S])}e.$zr=j;function O(){return A}e.$Ar=O}),define(ae[185],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;class I{constructor(j,O){this.key=j,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$eq=I;class A{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const O of this.a.values())O.outgoing.size===0&&j.push(O);return j}insertEdge(j,O){const R=this.lookupOrInsertNode(j),S=this.lookupOrInsertNode(O);R.outgoing.set(S.key,S),S.incoming.set(R.key,R)}removeNode(j){const O=this.b(j);this.a.delete(O);for(const R of this.a.values())R.outgoing.delete(O),R.incoming.delete(O)}lookupOrInsertNode(j){const O=this.b(j);let R=this.a.get(O);return R||(R=new I(O,j),this.a.set(O,R)),R}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[O,R]of this.a)j.push(`${O}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,O]of this.a){const R=new Set([j]),S=this.c(O,R);if(S)return S}}c(j,O){for(const[R,S]of j.outgoing){if(O.has(R))return[...O,R].join(" -> ");O.add(R);const d=this.c(S,O);if(d)return d;O.delete(R)}}}e.$fq=A}),define(ae[4],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e._util=void 0;var I;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function R(S){return S[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=R})(I||(e._util=I={})),e.$Rh=L("instantiationService");function A(O,R,S){R[I.DI_TARGET]===R?R[I.DI_DEPENDENCIES].push({id:O,index:S}):(R[I.DI_DEPENDENCIES]=[{id:O,index:S}],R[I.DI_TARGET]=R)}function L(O){if(I.serviceIds.has(O))return I.serviceIds.get(O);const R=function(S,d,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(R,S,C)};return R.toString=()=>O,I.serviceIds.set(O,R),R}e.$Sh=L;function j(O){return O}e.$Th=j}),define(ae[186],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P9b=void 0,e.$P9b=(0,I.$Sh)("checksumService")}),define(ae[20],ce([0,1,12,10,4]),function(ie,e,I,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.ConfigurationTarget=e.$oi=e.$ni=e.$mi=void 0,e.$mi=(0,L.$Sh)("configurationService");function j(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof A.URI)}e.$ni=j;function O(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof A.URI)}e.$oi=O;var R;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function S(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$pi=S;function d(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$qi=d;function C(c,f){const u=Object.create(null);for(const b in c)E(u,b,c[b],f);return u}e.$ri=C;function E(c,f,u,b){const k=f.split("."),s=k.pop();let a=c;for(let n=0;n<k.length;n++){const i=k[n];let t=a[i];switch(typeof t){case"undefined":t=a[i]=Object.create(null);break;case"object":break;default:b(`Ignoring ${f} as ${k.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}a=t}if(typeof a=="object"&&a!==null)try{a[s]=u}catch{b(`Ignoring ${f} as ${k.join(".")} is ${JSON.stringify(a)}`)}else b(`Ignoring ${f} as ${k.join(".")} is ${JSON.stringify(a)}`)}e.$si=E;function w(c,f){const u=f.split(".");l(c,u)}e.$ti=w;function l(c,f){const u=f.shift();if(f.length===0){delete c[u];return}if(Object.keys(c).indexOf(u)!==-1){const b=c[u];typeof b=="object"&&!Array.isArray(b)&&(l(b,f),Object.keys(b).length===0&&delete c[u])}}function g(c,f,u){function b(a,n){let i=a;for(const t of n){if(typeof i!="object"||i===null)return;i=i[t]}return i}const k=f.split("."),s=b(c,k);return typeof s>"u"?u:s}e.$ui=g;function y(c,f,u){Object.keys(f).forEach(b=>{b!=="__proto__"&&(b in c?I.$Bf(c[b])&&I.$Bf(f[b])?y(c[b],f[b],u):u&&(c[b]=f[b]):c[b]=f[b])})}e.$vi=y;function p(c){return c.replace(/[\[\]]/g,"")}e.$wi=p}),define(ae[94],ce([0,1,5,27,178,4,149,7]),function(ie,e,I,A,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.ContextKeyExprType=e.$Oi=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",I.$j),S.set("isLinux",I.$k),S.set("isWindows",I.$i),S.set("isWeb",I.$o),S.set("isMacNative",I.$j&&!I.$o),S.set("isEdge",I.$H),S.set("isFirefox",I.$F),S.set("isChrome",I.$E),S.set("isSafari",I.$G);function d(z,P){if(S.get(z)!==void 0)throw(0,R.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(z,P)}e.$Oi=d;const C=Object.prototype.hasOwnProperty;var E;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const w={regexParsingWithErrorRecovery:!0},l=(0,O.localize)(0,null),g=(0,O.localize)(1,null),y=(0,O.localize)(2,null),p=(0,O.localize)(3,null),c=(0,O.localize)(4,null),f=(0,O.localize)(5,null),u=(0,O.localize)(6,null),b=(0,O.localize)(7,null);class k{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(P=w){this.k=P,this.d=new L.$Ni,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(P){if(P===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(P).scan(),this.g=0,this.h=[];try{const T=this.l();if(!this.E()){const B=this.D(),N=B.type===17?f:void 0;throw this.h.push({message:c,offset:B.offset,lexeme:L.$Ni.getLexeme(B),additionalInfo:N}),k.c}return T}catch(T){if(T!==k.c)throw T;return}}l(){return this.m()}m(){const P=[this.o()];for(;this.y(16);){const T=this.o();P.push(T)}return P.length===1?P[0]:s.or(...P)}o(){const P=[this.s()];for(;this.y(15);){const T=this.s();P.push(T)}return P.length===1?P[0]:s.and(...P)}s(){if(this.y(2)){const P=this.D();switch(P.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const T=this.l();return this.A(1,p),T?.negate()}case 17:return this.z(),D.create(P.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",P)}}return this.t()}t(){const P=this.D();switch(P.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const T=this.l();return this.A(1,p),T}case 17:{const T=P.lexeme;if(this.z(),this.y(9)){const N=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),N.type!==10)throw this.B("REGEX",N);const V=N.lexeme,G=V.lastIndexOf("/"),te=G===V.length-1?void 0:this.w(V.substring(G+1));let oe;try{oe=new RegExp(V.substring(1,G),te)}catch{throw this.B("REGEX",N)}return K.create(T,oe)}switch(N.type){case 10:case 19:{const V=[N.lexeme];this.z();let G=this.D(),te=0;for(let de=0;de<N.lexeme.length;de++)N.lexeme.charCodeAt(de)===40?te++:N.lexeme.charCodeAt(de)===41&&te--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let de=0;de<G.lexeme.length;de++)G.lexeme.charCodeAt(de)===40?te++:N.lexeme.charCodeAt(de)===41&&te--}if(te<0)break;V.push(L.$Ni.getLexeme(G)),this.z(),G=this.D()}const oe=V.join(""),ue=oe.lastIndexOf("/"),he=ue===oe.length-1?void 0:this.w(oe.substring(ue+1));let ge;try{ge=new RegExp(oe.substring(1,ue),he)}catch{throw this.B("REGEX",N)}return s.regex(T,ge)}case 18:{const V=N.lexeme;this.z();let G=null;if(!(0,A.$Ce)(V)){const te=V.indexOf("/"),oe=V.lastIndexOf("/");if(te!==oe&&te>=0){const ue=V.slice(te+1,oe),he=V[oe+1]==="i"?"i":"";try{G=new RegExp(ue,he)}catch{throw this.B("REGEX",N)}}}if(G===null)throw this.B("REGEX",N);return K.create(T,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const N=this.u();return s.notIn(T,N)}switch(this.D().type){case 3:{this.z();const N=this.u();if(this.x().type===18)return s.equals(T,N);switch(N){case"true":return s.has(T);case"false":return s.not(T);default:return s.equals(T,N)}}case 4:{this.z();const N=this.u();if(this.x().type===18)return s.notEquals(T,N);switch(N){case"true":return s.not(T);case"false":return s.has(T);default:return s.notEquals(T,N)}}case 5:return this.z(),q.create(T,this.u());case 6:return this.z(),Y.create(T,this.u());case 7:return this.z(),M.create(T,this.u());case 8:return this.z(),U.create(T,this.u());case 13:return this.z(),s.in(T,this.u());default:return s.has(T)}}case 20:throw this.h.push({message:u,offset:P.offset,lexeme:"",additionalInfo:b}),k.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const P=this.D();switch(P.type){case 17:case 18:return this.z(),P.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(P){return P.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(P){return this.C(P)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(P,T){if(this.C(P))return this.z();throw this.B(T,this.D())}B(P,T,B){const N=(0,O.localize)(8,null,P,L.$Ni.getLexeme(T)),V=T.offset,G=L.$Ni.getLexeme(T);return this.h.push({message:N,offset:V,lexeme:G,additionalInfo:B}),k.c}C(P){return this.D().type===P}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Pi=k;class s{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(P){return o.create(P)}static equals(P,T){return v.create(P,T)}static notEquals(P,T){return $.create(P,T)}static regex(P,T){return K.create(P,T)}static in(P,T){return m.create(P,T)}static notIn(P,T){return h.create(P,T)}static not(P){return D.create(P)}static and(...P){return Q.create(P,null,!0)}static or(...P){return J.create(P,null,!0)}static greater(P,T){return M.create(P,T)}static greaterEquals(P,T){return U.create(P,T)}static smaller(P,T){return q.create(P,T)}static smallerEquals(P,T){return Y.create(P,T)}static{this.c=new k({regexParsingWithErrorRecovery:!1})}static deserialize(P){return P==null?void 0:this.c.parse(P)}}e.$Qi=s;function a(z){const P=new k({regexParsingWithErrorRecovery:!1});return z.map(T=>(P.parse(T),P.lexingErrors.length>0?P.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,O.localize)(9,null,B.additionalInfo):(0,O.localize)(10,null),offset:B.offset,length:B.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.$Ri=a;function n(z,P){const T=z?z.substituteConstants():void 0,B=P?P.substituteConstants():void 0;return!T&&!B?!0:!T||!B?!1:T.equals(B)}e.$Si=n;function i(z,P){return z.cmp(P)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return r.INSTANCE}}e.$Ti=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return t.INSTANCE}}e.$Ui=r;class o{static create(P,T=null){const B=S.get(P);return typeof B=="boolean"?B?r.INSTANCE:t.INSTANCE:new o(P,T)}constructor(P,T){this.key=P,this.c=T,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=S.get(this.key);return typeof P=="boolean"?P?r.INSTANCE:t.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=D.create(this.key,this)),this.c}}e.$Vi=o;class v{static create(P,T,B=null){if(typeof T=="boolean")return T?o.create(P,B):D.create(P,B);const N=S.get(P);return typeof N=="boolean"?T===(N?"true":"false")?r.INSTANCE:t.INSTANCE:new v(P,T,B)}constructor(P,T,B){this.c=P,this.d=T,this.f=B,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=S.get(this.c);if(typeof P=="boolean"){const T=P?"true":"false";return this.d===T?r.INSTANCE:t.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=$.create(this.c,this.d,this)),this.f}}e.$Wi=v;class m{static create(P,T){return new m(P,T)}constructor(P,T){this.d=P,this.f=T,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const T=P.getValue(this.f),B=P.getValue(this.d);return Array.isArray(T)?T.includes(B):typeof B=="string"&&typeof T=="object"&&T!==null?C.call(T,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=h.create(this.d,this.f)),this.c}}e.$Xi=m;class h{static create(P,T){return new h(P,T)}constructor(P,T){this.d=P,this.f=T,this.type=11,this.c=m.create(P,T)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Yi=h;class ${static create(P,T,B=null){if(typeof T=="boolean")return T?D.create(P,B):o.create(P,B);const N=S.get(P);return typeof N=="boolean"?T===(N?"true":"false")?t.INSTANCE:r.INSTANCE:new $(P,T,B)}constructor(P,T,B){this.c=P,this.d=T,this.f=B,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=S.get(this.c);if(typeof P=="boolean"){const T=P?"true":"false";return this.d===T?t.INSTANCE:r.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Zi=$;class D{static create(P,T=null){const B=S.get(P);return typeof B=="boolean"?B?t.INSTANCE:r.INSTANCE:new D(P,T)}constructor(P,T){this.c=P,this.d=T,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=S.get(this.c);return typeof P=="boolean"?P?t.INSTANCE:r.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=o.create(this.c,this)),this.d}}e.$1i=D;function F(z,P){if(typeof z=="string"){const T=parseFloat(z);isNaN(T)||(z=T)}return typeof z=="string"||typeof z=="number"?P(z):t.INSTANCE}class M{static create(P,T,B=null){return F(T,N=>new M(P,N,B))}constructor(P,T,B){this.c=P,this.d=T,this.f=B,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$2i=M;class U{static create(P,T,B=null){return F(T,N=>new U(P,N,B))}constructor(P,T,B){this.c=P,this.d=T,this.f=B,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$3i=U;class q{static create(P,T,B=null){return F(T,N=>new q(P,N,B))}constructor(P,T,B){this.c=P,this.d=T,this.f=B,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$4i=q;class Y{static create(P,T,B=null){return F(T,N=>new Y(P,N,B))}constructor(P,T,B){this.c=P,this.d=T,this.f=B,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$5i=Y;class K{static create(P,T){return new K(P,T)}constructor(P,T){this.d=P,this.f=T,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const T=this.f?this.f.source:"",B=P.f?P.f.source:"";return T<B?-1:T>B?1:0}equals(P){if(P.type===this.type){const T=this.f?this.f.source:"",B=P.f?P.f.source:"";return this.d===P.d&&T===B}return!1}substituteConstants(){return this}evaluate(P){const T=P.getValue(this.d);return this.f?this.f.test(T):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$6i=K;class x{static create(P){return new x(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(P){return new x(this.c.map(P))}negate(){return this.c}}e.$7i=x;function H(z){let P=null;for(let T=0,B=z.length;T<B;T++){const N=z[T].substituteConstants();if(z[T]!==N&&P===null){P=[];for(let V=0;V<T;V++)P[V]=z[V]}P!==null&&(P[T]=N)}return P===null?z:P}class Q{static create(P,T,B){return Q.d(P,T,B)}constructor(P,T){this.expr=P,this.c=T,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let T=0,B=this.expr.length;T<B;T++){const N=i(this.expr[T],P.expr[T]);if(N!==0)return N}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let T=0,B=this.expr.length;T<B;T++)if(!this.expr[T].equals(P.expr[T]))return!1;return!0}return!1}substituteConstants(){const P=H(this.expr);return P===this.expr?this:Q.create(P,this.c,!1)}evaluate(P){for(let T=0,B=this.expr.length;T<B;T++)if(!this.expr[T].evaluate(P))return!1;return!0}static d(P,T,B){const N=[];let V=!1;for(const G of P)if(G){if(G.type===1){V=!0;continue}if(G.type===0)return t.INSTANCE;if(G.type===6){N.push(...G.expr);continue}N.push(G)}if(N.length===0&&V)return r.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(i);for(let G=1;G<N.length;G++)N[G-1].equals(N[G])&&(N.splice(G,1),G--);if(N.length===1)return N[0];for(;N.length>1;){const G=N[N.length-1];if(G.type!==9)break;N.pop();const te=N.pop(),oe=N.length===0,ue=J.create(G.expr.map(he=>Q.create([he,te],null,B)),null,oe);ue&&(N.push(ue),N.sort(i))}if(N.length===1)return N[0];if(B){for(let G=0;G<N.length;G++)for(let te=G+1;te<N.length;te++)if(N[G].negate().equals(N[te]))return t.INSTANCE;if(N.length===1)return N[0]}return new Q(N,T)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const T of this.expr)P.push(...T.keys());return P}map(P){return new Q(this.expr.map(T=>T.map(P)),null)}negate(){if(!this.c){const P=[];for(const T of this.expr)P.push(T.negate());this.c=J.create(P,this,!0)}return this.c}}e.$8i=Q;class J{static create(P,T,B){return J.d(P,T,B)}constructor(P,T){this.expr=P,this.c=T,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let T=0,B=this.expr.length;T<B;T++){const N=i(this.expr[T],P.expr[T]);if(N!==0)return N}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let T=0,B=this.expr.length;T<B;T++)if(!this.expr[T].equals(P.expr[T]))return!1;return!0}return!1}substituteConstants(){const P=H(this.expr);return P===this.expr?this:J.create(P,this.c,!1)}evaluate(P){for(let T=0,B=this.expr.length;T<B;T++)if(this.expr[T].evaluate(P))return!0;return!1}static d(P,T,B){let N=[],V=!1;if(P){for(let G=0,te=P.length;G<te;G++){const oe=P[G];if(oe){if(oe.type===0){V=!0;continue}if(oe.type===1)return r.INSTANCE;if(oe.type===9){N=N.concat(oe.expr);continue}N.push(oe)}}if(N.length===0&&V)return t.INSTANCE;N.sort(i)}if(N.length!==0){if(N.length===1)return N[0];for(let G=1;G<N.length;G++)N[G-1].equals(N[G])&&(N.splice(G,1),G--);if(N.length===1)return N[0];if(B){for(let G=0;G<N.length;G++)for(let te=G+1;te<N.length;te++)if(N[G].negate().equals(N[te]))return r.INSTANCE;if(N.length===1)return N[0]}return new J(N,T)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const T of this.expr)P.push(...T.keys());return P}map(P){return new J(this.expr.map(T=>T.map(P)),null)}negate(){if(!this.c){const P=[];for(const T of this.expr)P.push(T.negate());for(;P.length>1;){const T=P.shift(),B=P.shift(),N=[];for(const V of Z(T))for(const G of Z(B))N.push(Q.create([V,G],null,!1));P.unshift(J.create(N,null,!1))}this.c=J.create(P,this,!0)}return this.c}}e.$9i=J;class W extends o{static{this.d=[]}static all(){return W.d.values()}constructor(P,T,B){super(P,null),this.f=T,typeof B=="object"?W.d.push({...B,key:P}):B!==!0&&W.d.push({key:P,description:B,type:T!=null?typeof T:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return v.create(this.key,P)}notEqualsTo(P){return $.create(this.key,P)}}e.$0i=W,e.$$i=(0,j.$Sh)("contextKeyService");function ee(z,P){return z<P?-1:z>P?1:0}function ne(z,P,T,B){return z<T?-1:z>T?1:P<B?-1:P>B?1:0}function _(z,P){if(z.type===0||P.type===1)return!0;if(z.type===9)return P.type===9?se(z.expr,P.expr):!1;if(P.type===9){for(const T of P.expr)if(_(z,T))return!0;return!1}if(z.type===6){if(P.type===6)return se(P.expr,z.expr);for(const T of z.expr)if(_(T,P))return!0;return!1}return z.equals(P)}e.$_i=_;function se(z,P){let T=0,B=0;for(;T<z.length&&B<P.length;){const N=z[T].cmp(P[B]);if(N<0)return!1;N===0&&T++,B++}return T===z.length}function Z(z){return z.type===9?z.expr:[z]}}),define(ae[95],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=e.$tm=e.ID=void 0,e.ID="diagnosticsService",e.$tm=(0,I.$Sh)(e.ID);function A(j){return!!j.hostName&&!!j.errorMessage}e.$um=A;class L{async getPerformanceInfo(O,R){return{}}async getSystemInfo(O,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,R){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$vm=L}),define(ae[96],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=void 0,e.$Rn=(0,I.$Sh)("downloadService")}),define(ae[14],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.$Zh=void 0,e.$Zh=(0,I.$Sh)("environmentService"),e.$1h=(0,I.$Th)(e.$Zh)}),define(ae[29],ce([0,1,152,4]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ao=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=void 0,e.$1n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$2n=new RegExp(e.$1n),e.$3n="__web_extension",e.$4n="skipWalkthrough",e.$5n="extensionsSync",e.$6n="dependecyOrPackExtensionInstall";function L(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$7n=L;function j(c){switch(c){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$8n=j;function O(c,f){switch(c){case 3:return f==="x64"?"win32-x64":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$9n=O;function R(c,f){return f==="web"&&!c.includes("web")}e.$0n=R;function S(c,f,u){return R(f,u)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===u}e.$$n=S;function d(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$_n=d;var C;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var E;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var w;(function(c){c.Install="install",c.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var l;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(l||(e.InstallOperation=l={})),e.$ao=(0,A.$Sh)("extensionGalleryService");var g;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));var y;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class p extends Error{constructor(f,u){super(f),this.code=u,this.name=u}}e.$bo=p,e.$co=(0,A.$Sh)("extensionManagementService"),e.$do="extensionsIdentifiers/disabled",e.$eo="extensionsIdentifiers/enabled",e.$fo=(0,A.$Sh)("IGlobalExtensionEnablementService"),e.$go=(0,A.$Sh)("IExtensionTipsService"),e.$ho=(0,I.localize)(0,null),e.$io={value:e.$ho,original:"Extensions"},e.$jo={value:(0,I.localize)(1,null),original:"Preferences"}}),define(ae[187],ce([0,1,3,2,30,10,92,29]),function(ie,e,I,A,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=e.$lp=e.$kp=void 0;function S(p,c){return p?j.URI.revive(c?c.transformIncoming(p):p):void 0}function d(p,c){return c?c.transformOutgoingURI(p):p}function C(p,c){c=c||O.$Pm;const f=p.manifest;return{...(0,O.$Sm)({...p,manifest:void 0},c),manifest:f}}function E(p,c){return p?.profileLocation?(0,O.$Sm)(p,c??O.$Pm):p}function w(p,c){return c?(0,L.$_m)(p,f=>f instanceof j.URI?c.transformOutgoingURI(f):void 0):p}class l{constructor(c,f){this.a=c,this.b=f,this.onInstallExtension=I.Event.buffer(c.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(c.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(c.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(c.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=I.Event.buffer(c.onDidUpdateExtensionMetadata,!0)}listen(c,f){const u=this.b(c);switch(f){case"onInstallExtension":return I.Event.map(this.onInstallExtension,b=>({...b,profileLocation:b.profileLocation?d(b.profileLocation,u):b.profileLocation}));case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,b=>b.map(k=>({...k,local:k.local?w(k.local,u):k.local,profileLocation:k.profileLocation?d(k.profileLocation,u):k.profileLocation})));case"onUninstallExtension":return I.Event.map(this.onUninstallExtension,b=>({...b,profileLocation:b.profileLocation?d(b.profileLocation,u):b.profileLocation}));case"onDidUninstallExtension":return I.Event.map(this.onDidUninstallExtension,b=>({...b,profileLocation:b.profileLocation?d(b.profileLocation,u):b.profileLocation}));case"onDidUpdateExtensionMetadata":return I.Event.map(this.onDidUpdateExtensionMetadata,b=>w(b,u))}throw new Error("Invalid listen")}async call(c,f,u){const b=this.b(c);switch(f){case"zip":{const k=C(u[0],b),s=await this.a.zip(k);return d(s,b)}case"unzip":return this.a.unzip(S(u[0],b));case"install":return this.a.install(S(u[0],b),E(u[1],b));case"installFromLocation":return this.a.installFromLocation(S(u[0],b),S(u[1],b));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(u[0],S(u[1],b),S(u[2],b));case"getManifest":return this.a.getManifest(S(u[0],b));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(u[0]);case"installFromGallery":return this.a.installFromGallery(u[0],E(u[1],b));case"installGalleryExtensions":{const k=u[0];return this.a.installGalleryExtensions(k.map(({extension:s,options:a})=>({extension:s,options:E(a,b)??{}})))}case"uninstall":return this.a.uninstall(C(u[0],b),E(u[1],b));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(u[0],b));case"getInstalled":return(await this.a.getInstalled(u[0],S(u[1],b))).map(s=>w(s,b));case"toggleAppliationScope":{const k=await this.a.toggleAppliationScope(C(u[0],b),S(u[1],b));return w(k,b)}case"copyExtensions":return this.a.copyExtensions(S(u[0],b),S(u[1],b));case"updateMetadata":{const k=await this.a.updateMetadata(C(u[0],b),u[1],S(u[2],b));return w(k,b)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(u[0],u[1],u[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$kp=l;class g extends A.$Rc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(c){super(),this.m=c,this.c=this.B(new I.$Od),this.f=this.B(new I.$Od),this.g=this.B(new I.$Od),this.h=this.B(new I.$Od),this.j=this.B(new I.$Od),this.B(this.m.listen("onInstallExtension")(f=>this.n(this.c,{...f,source:this.r(f.source)?j.URI.revive(f.source):f.source,profileLocation:j.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(f=>this.n(this.f,f.map(u=>({...u,local:u.local?C(u.local,null):u.local,source:this.r(u.source)?j.URI.revive(u.source):u.source,profileLocation:j.URI.revive(u.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(f=>this.n(this.g,{...f,profileLocation:j.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(f=>this.n(this.h,{...f,profileLocation:j.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(f=>this.j.fire(C(f,null))))}n(c,f){c.fire(f)}r(c){return c?typeof c.path=="string"&&typeof c.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(c){const f=await this.getTargetPlatform();return c.allTargetPlatforms.some(u=>(0,R.$$n)(u,c.allTargetPlatforms,f))}zip(c){return Promise.resolve(this.m.call("zip",[c]).then(f=>j.URI.revive(f)))}unzip(c){return Promise.resolve(this.m.call("unzip",[c]))}install(c,f){return Promise.resolve(this.m.call("install",[c,f])).then(u=>C(u,null))}installFromLocation(c,f){return Promise.resolve(this.m.call("installFromLocation",[c,f])).then(u=>C(u,null))}async installExtensionsFromProfile(c,f,u){return(await this.m.call("installExtensionsFromProfile",[c,f,u])).map(k=>C(k,null))}getManifest(c){return Promise.resolve(this.m.call("getManifest",[c]))}installFromGallery(c,f){return Promise.resolve(this.m.call("installFromGallery",[c,f])).then(u=>C(u,null))}async installGalleryExtensions(c){return(await this.m.call("installGalleryExtensions",[c])).map(u=>({...u,local:u.local?C(u.local,null):u.local,source:this.r(u.source)?j.URI.revive(u.source):u.source,profileLocation:j.URI.revive(u.profileLocation)}))}uninstall(c,f){return Promise.resolve(this.m.call("uninstall",[c,f]))}reinstallFromGallery(c){return Promise.resolve(this.m.call("reinstallFromGallery",[c])).then(f=>C(f,null))}getInstalled(c=null,f){return Promise.resolve(this.m.call("getInstalled",[c,f])).then(u=>u.map(b=>C(b,null)))}updateMetadata(c,f,u){return Promise.resolve(this.m.call("updateMetadata",[c,f,u])).then(b=>C(b,null))}toggleAppliationScope(c,f){return this.m.call("toggleAppliationScope",[c,f]).then(u=>C(u,null))}copyExtensions(c,f){return this.m.call("copyExtensions",[c,f])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(c,f,u){const b=await this.m.call("download",[c,f,u]);return j.URI.revive(b)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$lp=g;class y{constructor(c){this.a=c}listen(c,f){throw new Error("Invalid listen")}call(c,f,u){switch(f){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$mp=y}),define(ae[97],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=void 0,e.$hp=(0,I.$Sh)("IExtensionSignatureVerificationService");class A{b(){return this.a||(this.a=new Promise((j,O)=>ie(["node-vsce-sign"],async R=>j(R),O))),this.a}async verify(j,O,R){let S;try{S=await this.b()}catch{return!1}return S.verify(j,O,R)}}e.$ip=A}),define(ae[98],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DWb=e.RecommendationsNotificationResult=e.$CWb=e.RecommendationSource=void 0;var A;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(A||(e.RecommendationSource=A={}));function L(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$CWb=L;var j;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$DWb=(0,I.$Sh)("IExtensionRecommendationNotificationService")}),define(ae[11],ce([0,1,47,16,27,12,10,159,4,5,23,61]),function(ie,e,I,A,L,j,O,R,S,d,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.FileKind=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.FileOperationResult=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileChangeType=e.$tk=e.FileOperation=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.FileSystemProviderErrorCode=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.FileSystemProviderCapabilities=e.$dk=e.FilePermission=e.FileType=e.$ck=e.$bk=void 0,e.$bk=(0,S.$Sh)("fileService");function w(_){return _.create===!0}e.$ck=w;var l;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var g;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(g||(e.FilePermission=g={}));function y(_){const se=_;return!!se&&typeof se.onDidChange=="function"}e.$dk=y;var p;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function c(_){return!!(_.capabilities&2)}e.$ek=c;function f(_){return!!(_.capabilities&8)}e.$fk=f;function u(_){return!!(_.capabilities&131072)}e.$gk=u;function b(_){return!!(_.capabilities&4)}e.$hk=b;function k(_){return!!(_.capabilities&16)}e.$ik=k;function s(_){return c(_)?!!(_.capabilities&16384):!1}e.$jk=s;function a(_){return c(_)?!!(_.capabilities&32768):!1}e.$kk=a;function n(_){return!!(_.capabilities&65536)}e.$lk=n;function i(_){return!!(_.capabilities&2048)}e.$mk=i;var t;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(se,Z){const z=new r(se.toString(),Z);return m(z,Z),z}constructor(se,Z){super(se),this.code=Z}}e.$nk=r;function o(_,se){return r.create(_,se)}e.$ok=o;function v(_){return _||o((0,R.localize)(0,null),t.Unknown)}e.$pk=v;function m(_,se){return _.name=se?`${se} (FileSystemError)`:"FileSystemError",_}e.$qk=m;function h(_){if(!_)return t.Unknown;if(_ instanceof r)return _.code;const se=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!se)return t.Unknown;switch(se[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$rk=h;function $(_){if(_ instanceof Y)return _.fileOperationResult;switch(h(_)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$sk=$;var D;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(D||(e.FileOperation=D={}));class F{constructor(se,Z,z){this.resource=se,this.operation=Z,this.target=z}isOperation(se){return this.operation===se}}e.$tk=F;var M;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class U{static{this.a=null}constructor(se,Z){this.c=Z,this.b=void 0,this.d=new E.$U(()=>{const z=I.$Yh.forUris(()=>this.c);return z.fill(this.rawAdded.map(P=>[P,!0])),z}),this.f=new E.$U(()=>{const z=I.$Yh.forUris(()=>this.c);return z.fill(this.rawUpdated.map(P=>[P,!0])),z}),this.g=new E.$U(()=>{const z=I.$Yh.forUris(()=>this.c);return z.fill(this.rawDeleted.map(P=>[P,!0])),z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const z of se){switch(z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}this.b!==U.a&&(typeof z.cId=="number"?this.b===void 0?this.b=z.cId:this.b!==z.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(se,...Z){return this.h(se,{includeChildren:!1},...Z)}affects(se,...Z){return this.h(se,{includeChildren:!0},...Z)}h(se,Z,...z){if(!se)return!1;const P=z.length>0;return!!((!P||z.includes(1))&&(this.d.value.get(se)||Z.includeChildren&&this.d.value.findSuperstr(se))||(!P||z.includes(0))&&(this.f.value.get(se)||Z.includeChildren&&this.f.value.findSuperstr(se))||(!P||z.includes(2))&&(this.g.value.findSubstr(se)||Z.includeChildren&&this.g.value.findSuperstr(se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(se){return this.b===se}hasCorrelation(){return typeof this.b=="number"}}e.$uk=U;function q(_,se,Z){return!_||!se||_===se||se.length>_.length?!1:(se.charAt(se.length-1)!==A.sep&&(se+=A.sep),Z?(0,L.$4e)(_,se):_.indexOf(se)===0)}e.$vk=q;class Y extends Error{constructor(se,Z,z){super(se),this.fileOperationResult=Z,this.options=z}}e.$wk=Y;class K extends Y{constructor(se,Z,z,P){super(se,Z,P),this.fileOperationResult=Z,this.size=z}}e.$xk=K;class x extends Y{constructor(se,Z,z){super(se,2,z),this.stat=Z}}e.$yk=x;var H;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(H||(e.FileOperationResult=H={})),e.$zk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Ak={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Bk="files.associations",e.$Ck="files.exclude",e.$Dk="files.readonlyInclude",e.$Ek="files.readonlyExclude",e.$Fk="files.readonlyFromPermissions";var Q;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$Gk="";function J(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Hk=J;async function W(_,se){if(!se.hasProvider(O.URI.from({scheme:_.scheme})))return new Promise(Z=>{const z=se.onDidChangeFileSystemProviderRegistrations(P=>{P.scheme===_.scheme&&P.added&&(z.dispose(),Z())})})}e.$Ik=W;class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(se){return(0,j.$Df)(se)||(se=0),se<ee.KB?(0,R.localize)(1,null,se.toFixed(0)):se<ee.MB?(0,R.localize)(2,null,(se/ee.KB).toFixed(2)):se<ee.GB?(0,R.localize)(3,null,(se/ee.MB).toFixed(2)):se<ee.TB?(0,R.localize)(4,null,(se/ee.GB).toFixed(2)):(0,R.localize)(5,null,(se/ee.TB).toFixed(2))}}e.$Jk=ee;function ne(_){const se=typeof _=="string"||_?.scheme===C.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===C.Schemas.file?1024*ee.MB:se?10*ee.MB:d.$o?50*ee.MB:1024*ee.MB}e.$Kk=ne});var X=this&&this.__param||function(ie,e){return function(I,A){e(I,A,ie)}};define(ae[188],ce([0,1,71,46,11]),function(ie,e,I,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q9b=void 0;let j=class{constructor(R){this.a=R}async checksum(R){const S=(await this.a.readFileStream(R)).value;return new Promise((d,C)=>{const E=(0,I.createHash)("md5");(0,A.$7d)(S,{onData:w=>E.update(w.buffer),onError:w=>C(w),onEnd:()=>d(E.digest("base64").replace(/=+$/,""))})})}};e.$Q9b=j,e.$Q9b=j=pe([X(0,L.$bk)],j)}),define(ae[99],ce([0,1,15,7,160,11]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;async function O(C,E,w,l,g,y){let p;try{await R(C,E,w,l,g,y)}catch(c){p=c}finally{p&&g.errorTransformer&&(p=g.errorTransformer(p)),typeof p<"u"&&w.error(p),w.end()}}e.$Pp=O;async function R(C,E,w,l,g,y){S(y);const p=await C.open(E,{create:!1});try{S(y);let c=0,f=0,u=g&&typeof g.length=="number"?g.length:void 0,b=I.$ce.alloc(Math.min(g.bufferSize,typeof u=="number"?u:g.bufferSize)),k=g&&typeof g.position=="number"?g.position:0,s=0;do f=await C.read(p,k,b.buffer,s,b.byteLength-s),k+=f,s+=f,c+=f,typeof u=="number"&&(u-=f),s===b.byteLength&&(await w.write(l(b)),b=I.$ce.alloc(Math.min(g.bufferSize,typeof u=="number"?u:g.bufferSize)),s=0);while(f>0&&(typeof u!="number"||u>0)&&S(y)&&d(c,g));if(s>0){let a=s;typeof u=="number"&&(a=Math.min(s,u)),w.write(l(b.slice(0,a)))}}catch(c){throw(0,j.$pk)(c)}finally{await C.close(p)}}function S(C){if(C.isCancellationRequested)throw(0,A.$5)();return!0}function d(C,E){if(typeof E?.limits?.size=="number"&&C>E.limits.size)throw(0,j.$ok)((0,L.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[49],ce([0,1,91,2,16,5,10,11]),function(ie,e,I,A,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=e.$Tp=e.$Sp=e.$Rp=void 0;function S(c){return c.recursive===!0}e.$Rp=S;class d extends A.$Rc{static{this.a=5}constructor(f,u,b,k){super(),this.h=f,this.j=u,this.m=b,this.n=k,this.c=this.B(new A.$Sc),this.f=void 0,this.g=0}s(){const f=new A.$Qc;this.c.value=f,this.b=this.r(f),this.b.setVerboseLogging(this.m),f.add(this.b.onDidChangeFile(u=>this.h(u))),f.add(this.b.onDidLogMessage(u=>this.j(u))),f.add(this.b.onDidError(u=>this.t(u)))}t(f){this.n.restartOnError?this.g<d.a&&this.f?(this.w(`restarting watcher after error: ${f}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${f}`):this.w(f)}u(f){this.g++,this.s(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.m=f,await this.b?.setVerboseLogging(f)}w(f){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${f}`})}y(f){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Sp=d;class C extends d{constructor(f,u,b){super(f,u,b,{type:"node.js",restartOnError:!1})}}e.$Tp=C;class E extends d{constructor(f,u,b){super(f,u,b,{type:"universal",restartOnError:!0})}}e.$Up=E;function w(c){return c.map(f=>({type:f.type,resource:O.URI.revive(f.resource),cId:f.cId}))}e.$Vp=w;function l(c){const f=new p;for(const u of c)f.processEvent(u);return f.coalesce()}e.$Wp=l;function g(c,f){return typeof f=="string"&&!f.startsWith(I.$vj)&&!(0,L.$hc)(f)?{base:c,pattern:f}:f}e.$Xp=g;function y(c,f){const u=[];for(const b of f)u.push((0,I.$zj)(g(c,b)));return u}e.$Yp=y;class p{constructor(){this.a=new Set,this.b=new Map}c(f){return j.$k?f.resource.fsPath:f.resource.fsPath.toLowerCase()}processEvent(f){const u=this.b.get(this.c(f));let b=!1;if(u){const k=u.type,s=f.type;u.resource.fsPath!==f.resource.fsPath&&(f.type===2||f.type===1)?b=!0:k===1&&s===2?(this.b.delete(this.c(f)),this.a.delete(u)):k===2&&s===1?u.type=0:k===1&&s===0||(u.type=s)}else b=!0;b&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],u=[];return Array.from(this.a).filter(b=>b.type!==2?(f.push(b),!1):!0).sort((b,k)=>b.resource.fsPath.length-k.resource.fsPath.length).filter(b=>u.some(k=>(0,R.$vk)(b.resource.fsPath,k,!j.$k))?!1:(u.push(b.resource.fsPath),!0)).concat(f)}}}),define(ae[189],ce([0,1,15,38,7,3,2,46,32,11,49]),function(ie,e,I,A,L,j,O,R,S,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=e.$BN=void 0,e.$BN="localFilesystem";class E extends O.$Rc{constructor(l,g){super(),this.a=l,this.b=g,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$Od),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$Od),this.onDidWatchError=this.g.event,this.h=(0,S.$fg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,g){const{buffer:y}=await this.a.call("readFile",[l,g]);return y}readFileStream(l,g,y){const p=(0,R.$3d)(f=>I.$ce.concat(f.map(u=>I.$ce.wrap(u))).buffer),c=new O.$Qc;return c.add(this.a.listen("readFileStream",[l,g])(f=>{if(f instanceof I.$ce)p.write(f.buffer);else{if(f==="end")p.end();else{let u;if(f instanceof Error)u=f;else{const b=f;u=(0,d.$ok)(b.message??(0,A.$Di)(b),b.code??d.FileSystemProviderErrorCode.Unknown)}p.error(u),p.end()}c.dispose()}})),c.add(y.onCancellationRequested(()=>{p.error((0,L.$5)()),p.end(),c.dispose()})),p}writeFile(l,g,y){return this.a.call("writeFile",[l,I.$ce.wrap(g),y])}open(l,g){return this.a.call("open",[l,g])}close(l){return this.a.call("close",[l])}async read(l,g,y,p,c){const[f,u]=await this.a.call("read",[l,g,c]);return y.set(f.buffer.slice(0,u),p),u}write(l,g,y,p,c){return this.a.call("write",[l,g,I.$ce.wrap(y),p,c])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,g){return this.a.call("delete",[l,g])}rename(l,g,y){return this.a.call("rename",[l,g,y])}copy(l,g,y){return this.a.call("copy",[l,g,y])}cloneFile(l,g){return this.a.call("cloneFile",[l,g])}j(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const g=l;this.f.fire((0,C.$Vp)(g))}else{const g=l;this.g.fire(g)}}))}watch(l,g){const y=(0,S.$fg)();return this.a.call("watch",[this.h,y,l,g]),(0,O.$Pc)(()=>this.a.call("unwatch",[this.h,y]))}}e.$CN=E}),define(ae[190],ce([0,1,53,6,26,48,2,88,16,5,19,10,143,31,49]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;class y extends O.$Rc{static{this.a=100}static{this.b=75}constructor(f,u,b,k){super(),this.m=f,this.n=u,this.r=b,this.s=k,this.c=this.B(new A.$0g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.n(s))),this.f=this.B(new A.$9g(s=>this.z(s),y.b)),this.g=(0,g.$Yp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,g.$Yp)(this.m.path,this.m.includes):void 0,this.j=new L.$Yd,this.ready=this.t()}async t(){try{const f=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const u=await l.Promises.stat(f);this.B(await this.w(f,u.isDirectory()))}catch(f){f.code!=="ENOENT"?this.D(f):this.G(f)}}async u(f){let u=f.path;try{u=await l.Promises.realpath(f.path),f.path===u&&(u=await(0,w.$9p)(f.path)??f.path),f.path!==u&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${u})`)}catch{}return u}async w(f,u){if(d.$j&&(0,j.$Yf)(f,"/Volumes/",!0))return this.D(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.$Rc.None;const b=new L.$Yd(this.j.token),k=new O.$Qc;try{const s=E.URI.file(this.m.path),a=(0,S.$mc)(f),n=(0,I.watch)(f);k.add((0,O.$Pc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${f}'`);const i=new Set;if(u)try{for(const r of await l.Promises.readdir(f))i.add(r)}catch(r){this.D(r)}const t=new Map;k.add((0,O.$Pc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,o)=>{this.D(`Failed to watch ${f} for changes using fs.watch() (${r}, ${o})`),this.dispose()}),n.on("change",(r,o)=>{if(b.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${o}`);let v="";if(o&&(v=o.toString(),d.$j&&(v=(0,R.$rl)(v))),!(!v||r!=="change"&&r!=="rename"))if(u)if(r==="rename"){t.get(v)?.dispose();const m=setTimeout(async()=>{if(t.delete(v),v===a&&!await l.Promises.exists(f)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const h=await this.C((0,S.$ic)(f,v));if(b.token.isCancellationRequested)return;let $;h?i.has(v)?$=0:($=1,i.add(v)):(i.delete(v),$=2),this.y({resource:(0,C.$wg)(s,v),type:$,cId:this.m.correlationId})},y.a);t.set(v,(0,O.$Pc)(()=>clearTimeout(m)))}else{let m;i.has(v)?m=0:(m=1,i.add(v)),this.y({resource:(0,C.$wg)(s,v),type:m,cId:this.m.correlationId})}else if(r==="rename"||v!==a){const m=setTimeout(async()=>{const h=await l.Promises.exists(f);b.token.isCancellationRequested||(h?(this.y({resource:s,type:0,cId:this.m.correlationId},!0),k.add(await this.w(f,!1))):(this.y({resource:s,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},y.a);k.clear(),k.add((0,O.$Pc)(()=>clearTimeout(m)))}else this.y({resource:s,type:0,cId:this.m.correlationId},!0)})}catch(s){await l.Promises.exists(f)&&!b.token.isCancellationRequested&&this.D(`Failed to watch ${f} for changes using fs.watch() (${s.toString()})`)}return(0,O.$Pc)(()=>{b.dispose(!0),k.dispose()})}y(f,u=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!u&&this.g.some(b=>b(f.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${f.resource.fsPath}`):!u&&this.h&&this.h.length>0&&!this.h.some(b=>b(f.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}z(f){const u=(0,g.$Wp)(f);if(u.length>0){if(this.s)for(const k of u)this.G(` >> normalized ${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(f){if(d.$k)return l.Promises.exists(f);try{const u=(0,S.$mc)(f);return(await l.Promises.readdir((0,S.$lc)(f))).some(k=>k===u)}catch(u){return this.G(u),!1}}setVerboseLogging(f){this.s=f}D(f){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}F(f){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}G(f){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$_p=y;async function p(c,f,u,b,k=512){const s=await l.Promises.open(c,"r"),a=Buffer.allocUnsafe(k),n=new L.$Yd(b);let i,t=!1;const r={path:c,excludes:[],recursive:!1},o=new y(r,v=>{(async()=>{for(const{type:m}of v)if(m===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:h}=await l.Promises.read(s,a,0,k,null);if(!h||n.token.isCancellationRequested)break;f(a.slice(0,h))}}catch(h){i=new Error(h),n.dispose(!0)}finally{t=!1}}})()});return await o.ready,u(),new Promise((v,m)=>{n.token.onCancellationRequested(async()=>{o.dispose();try{await l.Promises.close(s)}catch(h){i=new Error(h)}i?m(i):v()})})}e.$aq=p}),define(ae[191],ce([0,1,3,91,2,5,190]),function(ie,e,I,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;class R extends L.$Rc{constructor(){super(...arguments),this.a=this.B(new I.$Od),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$Od),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(d){const C=this.j(d),E=C.filter(l=>{const g=this.c.get(l.path);return g?!(0,A.$Dj)(g.request.excludes,l.excludes)||!(0,A.$Dj)(g.request.includes,l.includes):!0}),w=Array.from(this.c.values()).filter(({request:l})=>!C.find(g=>g.path===l.path&&(0,A.$Dj)(g.excludes,l.excludes)&&(0,A.$Dj)(g.includes,l.includes))).map(({request:l})=>l.path);E.length&&this.m(`Request to start watching: ${E.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"}, correlationId: ${typeof l.correlationId=="number"?l.correlationId:"<none>"})`).join(",")}`),w.length&&this.m(`Request to stop watching: ${w.join(",")}`);for(const l of w)this.h(l);for(const l of E)this.g(l)}g(d){const C=new O.$_p(d,w=>this.a.fire(w),w=>this.b.fire(w),this.f),E={request:d,instance:C};this.c.set(d.path,E)}async stop(){for(const[d]of this.c)this.h(d);this.c.clear()}h(d){const C=this.c.get(d);C&&(this.c.delete(d),C.instance.dispose())}j(d){const C=new Map;for(const E of d){const w=j.$k?E.path:E.path.toLowerCase();let l=C.get(E.correlationId);l||(l=new Map,C.set(E.correlationId,l)),l.set(w,E)}return Array.from(C.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(d){this.f=d;for(const[,C]of this.c)C.instance.setVerboseLogging(d)}m(d){this.f&&this.b.fire({type:"trace",message:this.n(d)})}n(d,C){return C?`[File Watcher (node.js)] ${d} (path: ${C.request.path})`:`[File Watcher (node.js)] ${d}`}}e.$bq=R}),define(ae[192],ce([0,1,49,191]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;class L extends I.$Tp{constructor(O,R,S){super(O,R,S),this.s()}r(O){return O.add(new A.$bq)}}e.$cq=L}),define(ae[193],ce([0,1,23,40,93,49]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;class O extends j.$Up{constructor(S,d,C){super(S,d,C),this.s()}r(S){const d=S.add(new L.$6p(I.$dg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(d.onDidProcessExit(({code:C,signal:E})=>this.t(`terminated by itself with code ${C}, signal: ${E}`))),A.ProxyChannel.toService((0,A.$zh)(d.getChannel("watcher")))}}e.$7p=O}),define(ae[72],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=void 0;class I{constructor(...L){this.a=new Map;for(const[j,O]of L)this.set(j,O)}set(L,j){const O=this.a.get(L);return this.a.set(L,j),O}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$Qh=I}),define(ae[194],ce([0,1,6,7,2,70,185,4,72,87]),function(ie,e,I,A,L,j,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;const C=!1;class E extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class w{constructor(p=new S.$Qh,c=!1,f,u=C){this.f=p,this.g=c,this.h=f,this.i=u,this.o=new Set,this.f.set(R.$Rh,this),this._globalGraph=u?f?._globalGraph??new O.$fq(b=>b):void 0}createChild(p){return new w(p,this.g,this,this.i)}invokeFunction(p,...c){const f=g.traceInvocation(this.i,p);let u=!1;try{return p({get:k=>{if(u)throw(0,A.$7)("service accessor is only valid during the invocation of its target method");const s=this.m(k,f);if(!s)throw new Error(`[invokeFunction] unknown service '${k}'`);return s}},...c)}finally{u=!0,f.stop()}}createInstance(p,...c){let f,u;return p instanceof j.$Ph?(f=g.traceCreation(this.i,p.ctor),u=this.j(p.ctor,p.staticArguments.concat(c),f)):(f=g.traceCreation(this.i,p),u=this.j(p,c,f)),f.stop(),u}j(p,c=[],f){const u=R._util.getServiceDependencies(p).sort((s,a)=>s.index-a.index),b=[];for(const s of u){const a=this.m(s.id,f);a||this.u(`[createInstance] ${p.name} depends on UNKNOWN service ${s.id}.`,!1),b.push(a)}const k=u.length>0?u[0].index:c.length;if(c.length!==k){console.trace(`[createInstance] First service dependency of ${p.name} at position ${k+1} conflicts with ${c.length} static arguments`);const s=k-c.length;s>0?c=c.concat(new Array(s)):c=c.slice(0,k)}return Reflect.construct(p,c.concat(b))}k(p,c){if(this.f.get(p)instanceof j.$Ph)this.f.set(p,c);else if(this.h)this.h.k(p,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(p){const c=this.f.get(p);return!c&&this.h?this.h.l(p):c}m(p,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const f=this.l(p);return f instanceof j.$Ph?this.q(p,f,c.branch(p,!0)):(c.branch(p,!1),f)}q(p,c,f){if(this.o.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.o.add(p);try{return this.r(p,c,f)}finally{this.o.delete(p)}}r(p,c,f){const u=new O.$fq(s=>s.id.toString());let b=0;const k=[{id:p,desc:c,_trace:f}];for(;k.length;){const s=k.pop();if(u.lookupOrInsertNode(s),b++>1e3)throw new E(u);for(const a of R._util.getServiceDependencies(s.desc.ctor)){const n=this.l(a.id);if(n||this.u(`[createInstance] ${p} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(a.id)),n instanceof j.$Ph){const i={id:a.id,desc:n,_trace:s._trace.branch(a.id,!0)};u.insertEdge(s,i),k.push(i)}}}for(;;){const s=u.roots();if(s.length===0){if(!u.isEmpty())throw new E(u);break}for(const{data:a}of s){if(this.l(a.id)instanceof j.$Ph){const i=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,i)}u.removeNode(a)}}return this.l(p)}s(p,c,f=[],u,b){if(this.f.get(p)instanceof j.$Ph)return this.t(p,c,f,u,b);if(this.h)return this.h.s(p,c,f,u,b);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(p,c,f=[],u,b){if(u){const k=new w(void 0,this.g,this,this.i);k.c=String(p);const s=new Map,a=new I.$bh(()=>{const n=k.j(c,f,b);for(const[i,t]of s){const r=n[i];if(typeof r=="function")for(const o of t)r.apply(n,o)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!a.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let o=s.get(i);return o||(o=new d.$1c,s.set(i,o)),(m,h,$)=>{const D=o.push([m,h,$]);return(0,L.$Pc)(D)}}if(i in n)return n[i];const t=a.value;let r=t[i];return typeof r!="function"||(r=r.bind(t),n[i]=r),r},set(n,i,t){return a.value[i]=t,!0},getPrototypeOf(n){return c.prototype}})}else return this.j(c,f,b)}u(p,c){if(c&&console.warn(p),this.g)throw new Error(p)}}e.$gq=w;var l;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(l||(l={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,c){return p?new g(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(p,c){return p?new g(1,c.name):g.c}static{this.f=0}constructor(p,c){this.type=p,this.name=c,this.g=Date.now(),this.h=[]}branch(p,c){const f=new g(3,p.toString());return this.h.push([p,c,f]),f}stop(){const p=Date.now()-this.g;g.f+=p;let c=!1;function f(b,k){const s=[],a=new Array(b+1).join("	");for(const[n,i,t]of k.h)if(i&&t){c=!0,s.push(`${a}CREATES -> ${n}`);const r=f(b+1,t);r&&s.push(r)}else s.push(`${a}uses -> ${n}`);return s.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(p>2||c)&&g.all.add(u.join(`
`))}}e.$hq=g}),define(ae[55],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o9b=e.$n9b=void 0,e.$n9b=(0,I.$Sh)("mainProcessService");class A{constructor(j,O){this.a=j,this.b=O}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,O){this.a.registerChannel(j,O)}}e.$o9b=A}),define(ae[73],ce([0,1,26,2,5,162,29,4]),function(ie,e,I,A,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=void 0;function S(C){return C.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$Uq=S,e.$Vq=(0,R.$Sh)("languagePackService");let d=class extends A.$Rc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new I.$Yd;setTimeout(()=>E.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const g=w.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(p=>p.startsWith("lp-"))).map(y=>{const p=y.properties.localizedLanguages?.[0],c=S(y);return{...this.f(c,p,y),extensionId:y.identifier.id,galleryExtension:y}});return g.push(this.f("en","English")),g}f(E,w,l){const g=w??E;let y;if(g!==E&&(y=`(${E})`),E.toLowerCase()===L.$w.toLowerCase()&&(y??="",y+=(0,j.localize)(0,null)),l?.installCount){y??="";const p=l.installCount;let c;p>1e6?c=`${Math.floor(p/1e5)/10}M`:p>1e3?c=`${Math.floor(p/1e3)}K`:c=String(p),y+=` $(cloud-download) ${c}`}return{id:E,label:g,description:y}}};e.$Wq=d,e.$Wq=d=pe([X(0,O.$ao)],d)}),define(ae[195],ce([0,1,2,73]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M9b=void 0;let L=class extends I.$Rc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$M9b=L,e.$M9b=L=pe([X(0,A.$Vq)],L)}),define(ae[8],ce([0,1,38,3,52,2,34,5,19,12,10,94,4]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.log=e.$dj=e.LogLevel=e.$cj=e.$bj=e.$aj=void 0,e.$aj=(0,w.$Sh)("logService"),e.$bj=(0,w.$Sh)("loggerService");function l(){return new Date().toISOString()}function g(m){return(0,d.$Df)(m)}e.$cj=g;var y;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$dj=y.Info;function p(m,h,$){switch(h){case y.Trace:m.trace($);break;case y.Debug:m.debug($);break;case y.Info:m.info($);break;case y.Warning:m.warn($);break;case y.Error:m.error($);break;case y.Off:break;default:throw new Error(`Invalid log level ${h}`)}}e.log=p;function c(m,h=!1){let $="";for(let D=0;D<m.length;D++){let F=m[D];if(F instanceof Error&&(F=(0,I.$Di)(F,h)),typeof F=="object")try{F=JSON.stringify(F)}catch{}$+=(D>0?" ":"")+F}return $}class f extends j.$Rc{constructor(){super(...arguments),this.b=e.$dj,this.c=this.B(new A.$Od),this.onDidChangeLogLevel=this.c.event}setLevel(h){this.b!==h&&(this.b=h,this.c.fire(this.b))}getLevel(){return this.b}f(h){return this.b!==y.Off&&this.b<=h}}e.$fj=f;class u extends f{constructor(h){super(),this.h=h}f(h){return this.h||super.f(h)}trace(h,...$){this.f(y.Trace)&&this.g(y.Trace,c([h,...$],!0))}debug(h,...$){this.f(y.Debug)&&this.g(y.Debug,c([h,...$]))}info(h,...$){this.f(y.Info)&&this.g(y.Info,c([h,...$]))}warn(h,...$){this.f(y.Warning)&&this.g(y.Warning,c([h,...$]))}error(h,...$){if(this.f(y.Error))if(h instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=h.stack,this.g(y.Error,c(D))}else this.g(y.Error,c([h,...$]))}flush(){}}e.$gj=u;class b extends f{constructor(h=e.$dj){super(),this.setLevel(h),this.g=!R.$i}trace(h,...$){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,h,...$):console.log(`[main ${l()}]`,h,...$))}debug(h,...$){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,h,...$):console.log(`[main ${l()}]`,h,...$))}info(h,...$){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,h,...$):console.log(`[main ${l()}]`,h,...$))}warn(h,...$){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,h,...$):console.warn(`[main ${l()}]`,h,...$))}error(h,...$){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,h,...$):console.error(`[main ${l()}]`,h,...$))}dispose(){}flush(){}}e.$hj=b;class k extends f{constructor(h=e.$dj,$=!0){super(),this.g=$,this.setLevel(h)}trace(h,...$){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",h,...$):console.log(h,...$))}debug(h,...$){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",h,...$):console.log(h,...$))}info(h,...$){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",h,...$):console.log(h,...$))}warn(h,...$){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",h,...$):console.log(h,...$))}error(h,...$){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",h,...$):console.error(h,...$))}dispose(){}flush(){}}e.$ij=k;class s extends f{constructor(h,$=e.$dj){super(),this.g=h,this.setLevel($)}trace(h,...$){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(h),...$])}debug(h,...$){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(h),...$])}info(h,...$){this.f(y.Info)&&this.g.log(y.Info,[this.h(h),...$])}warn(h,...$){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(h),...$])}error(h,...$){this.f(y.Error)&&this.g.log(y.Error,[this.h(h),...$])}h(h){return typeof h=="string"?h:(0,I.$Di)(h,this.f(y.Trace))}dispose(){}flush(){}}e.$jj=s;class a extends f{constructor(h){super(),this.g=h,h.length&&this.setLevel(h[0].getLevel())}setLevel(h){for(const $ of this.g)$.setLevel(h);super.setLevel(h)}trace(h,...$){for(const D of this.g)D.trace(h,...$)}debug(h,...$){for(const D of this.g)D.debug(h,...$)}info(h,...$){for(const D of this.g)D.info(h,...$)}warn(h,...$){for(const D of this.g)D.warn(h,...$)}error(h,...$){for(const D of this.g)D.error(h,...$)}flush(){for(const h of this.g)h.flush()}dispose(){for(const h of this.g)h.dispose()}}e.$kj=a;class n extends j.$Rc{constructor(h,$,D){if(super(),this.h=h,this.j=$,this.b=new O.$zc,this.c=this.B(new A.$Od),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$Od),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$Od),this.onDidChangeVisibility=this.g.event,D)for(const F of D)this.b.set(F.resource,{logger:void 0,info:F})}m(h){return(0,d.$zf)(h)?[...this.b.values()].find($=>$.info.id===h):this.b.get(h)}getLogger(h){return this.m(h)?.logger}createLogger(h,$){const D=this.n(h),F=(0,d.$zf)(h)?h:$?.id??(0,L.$Gi)(D.toString()).toString(16);let M=this.b.get(D)?.logger;const U=$?.logLevel==="always"?y.Trace:$?.logLevel;M||(M=this.s(D,U??this.getLogLevel(D)??this.h,{...$,id:F}));const q={logger:M,info:{resource:D,id:F,logLevel:U,name:$?.name,hidden:$?.hidden,extensionId:$?.extensionId,when:$?.when}};return this.registerLogger(q.info),this.b.set(D,q),M}n(h){return(0,d.$zf)(h)?(0,S.$wg)(this.j,`${h}.log`):h}setLogLevel(h,$){if(C.URI.isUri(h)){const D=h,F=$,M=this.b.get(D);M&&F!==M.info.logLevel&&(M.info.logLevel=F===this.h?void 0:F,M.logger?.setLevel(F),this.b.set(M.info.resource,M),this.f.fire([D,F]))}else{this.h=h;for(const[D,F]of this.b.entries())this.b.get(D)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(h,$){const D=this.m(h);D&&$!==!D.info.hidden&&(D.info.hidden=!$,this.b.set(D.info.resource,D),this.g.fire([D.info.resource,$]))}getLogLevel(h){let $;return h&&($=this.b.get(h)?.info.logLevel),$??this.h}registerLogger(h){const $=this.b.get(h.resource);$?$.info.hidden!==h.hidden&&this.setVisibility(h.resource,!h.hidden):(this.b.set(h.resource,{info:h,logger:void 0}),this.c.fire({added:[h],removed:[]}))}deregisterLogger(h){const $=this.b.get(h);$&&($.logger&&$.logger.dispose(),this.b.delete(h),this.c.fire({added:[],removed:[$.info]}))}*getRegisteredLoggers(){for(const h of this.b.values())yield h.info}getRegisteredLogger(h){return this.b.get(h)?.info}dispose(){this.b.forEach(h=>h.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lj=n;class i{constructor(){this.onDidChangeLogLevel=new A.$Od().event}setLevel(h){}getLevel(){return y.Info}trace(h,...$){}debug(h,...$){}info(h,...$){}warn(h,...$){}error(h,...$){}critical(h,...$){}dispose(){}flush(){}}e.$mj=i;class t extends i{}e.$nj=t;function r(m){if(m.verbose)return y.Trace;if(typeof m.logLevel=="string"){const h=v(m.logLevel.toLowerCase());if(h!==void 0)return h}return e.$dj}e.$oj=r;function o(m){switch(m){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$pj=o;function v(m){switch(m){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$qj=v,e.$rj=new E.$0i("logLevel",o(y.Info))}),define(ae[196],ce([0,1,6,7,2,23,16,19,31,14,8]),function(ie,e,I,A,L,j,O,R,S,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N9b=void 0;let E=class extends L.$Rc{constructor(l,g){super(),this.a=l,this.b=g,this.B(new I.$7g(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const l=(0,R.$tg)(this.a.logsHome),g=(0,R.$vg)(this.a.logsHome.with({scheme:j.Schemas.file})).fsPath,c=(await S.Promises.readdir(g)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==l),f=c.slice(0,Math.max(0,c.length-9));f.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(u=>S.Promises.rm((0,O.$ic)(g,u)))))}catch(l){(0,A.$Z)(l)}}};e.$N9b=E,e.$N9b=E=pe([X(0,d.$Zh),X(1,C.$aj)],E)}),define(ae[197],ce([0,1,18,6,7,3,2,16,49,8]),function(ie,e,I,A,L,j,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;class C extends O.$Rc{constructor(w,l){super(),this.a=w,this.b=l,this.c=this.B(new j.$Od),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$Od),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$Sg(0)),this.w=[],this.y=this.B(new A.$Sg(0))}watch(w,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(w,l):this.z(w,l)}n(w,l){const g={path:this.H(w),excludes:l.excludes,includes:l.includes,recursive:l.recursive,correlationId:l.correlationId},y=(0,I.$Tb)(this.j,g);return this.r(),(0,O.$Pc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,L.$Z)(w))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,S.$Vp)(l)),l=>this.G(l),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const l of this.j)(0,S.$Rp)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const l of this.j)(0,S.$Rp)(l)&&w.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,l){const g={path:this.H(w),excludes:l.excludes,includes:l.includes,recursive:!1,correlationId:l.correlationId},y=(0,I.$Tb)(this.w,g);return this.C(),(0,O.$Pc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,L.$Z)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,S.$Vp)(w)),w=>this.G(w),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,R.$gc)(w.fsPath)}}e.$Zp=C}),define(ae[198],ce([0,1,18,6,15,26,3,52,60,2,47,23,100,19,46,158,11,99,8,7]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;let k=class extends d.$Rc{static{b=this}constructor(a){super(),this.b=a,this.a=256*1024,this.c=this.B(new O.$Od),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$Od),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$Od),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$Od),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$Od),this.Y=this.B(new O.$Od),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$Od),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$4g)}registerProvider(a,n){if(this.h.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${a}`);const i=new d.$Qc;return this.h.set(a,n),this.c.fire({added:!0,scheme:a,provider:n}),i.add(n.onDidChangeFile(t=>{const r=new p.$uk(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&i.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),i.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:a}))),(0,d.$Pc)(()=>{this.c.fire({added:!1,scheme:a,provider:n}),this.h.delete(a),(0,d.$Mc)(i)})}getProvider(a){return this.h.get(a)}async activateProvider(a){const n=[];this.f.fire({scheme:a,join(i){n.push(i)}}),!this.h.has(a)&&await A.Promises.settled(n)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.h.has(a.scheme)}hasCapability(a,n){const i=this.h.get(a.scheme);return!!(i&&i.capabilities&n)}listCapabilities(){return S.Iterable.map(this.h,([a,n])=>({scheme:a,capabilities:n.capabilities}))}async j(a){if(!(0,l.$Ag)(a))throw new p.$wk((0,y.localize)(0,null,this.sb(a)),8);await this.activateProvider(a.scheme);const n=this.h.get(a.scheme);if(!n){const i=new u.$ab;throw i.message=(0,y.localize)(1,null,a.toString()),i}return n}async m(a){const n=await this.j(a);if((0,p.$hk)(n)||(0,p.$ek)(n)||(0,p.$ik)(n))return n;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(a){const n=await this.j(a);if((0,p.$hk)(n)||(0,p.$ek)(n))return n;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,n){try{return await this.s(a,n)}catch(i){throw(0,p.$rk)(i)===p.FileSystemProviderErrorCode.FileNotFound?new p.$wk((0,y.localize)(2,null,this.sb(a)),1):(0,p.$pk)(i)}}async s(a,n){const i=await this.j(a),t=this.S(i),r=n?.resolveTo,o=n?.resolveSingleChildDescendants,v=n?.resolveMetadata,m=await i.stat(a);let h;return this.t(i,a,m,void 0,!!v,($,D)=>(h||(h=C.$Yh.forUris(()=>!t),h.set(a,!0),r&&h.fill(!0,r)),h.get($.resource)||h.findSuperstr($.resource.with({query:null,fragment:null}))?!0:$.isDirectory&&o?D===1:!1))}async t(a,n,i,t,r,o){const{providerExtUri:v}=this.R(a),m={resource:n,name:v.basename(n),isFile:(i.type&p.FileType.File)!==0,isDirectory:(i.type&p.FileType.Directory)!==0,isSymbolicLink:(i.type&p.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&p.FilePermission.Readonly)||!!(a.capabilities&2048),locked:!!((i.permissions??0)&p.FilePermission.Locked),etag:(0,p.$Hk)({mtime:i.mtime,size:i.size}),children:void 0};if(m.isDirectory&&o(m,t)){try{const h=await a.readdir(n),$=await A.Promises.settled(h.map(async([D,F])=>{try{const M=v.joinPath(n,D),U=r?await a.stat(M):{type:F};return await this.t(a,M,U,h.length,r,o)}catch(M){return this.b.trace(M),null}}));m.children=(0,I.$Gb)($)}catch(h){this.b.trace(h),m.children=[]}return m}return m}async resolveAll(a){return A.Promises.settled(a.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(a){const n=await this.j(a),i=await n.stat(a);return this.t(n,a,i,void 0,!0,()=>!1)}async exists(a){const n=await this.j(a);try{return!!await n.stat(a)}catch{return!1}}async canCreateFile(a,n){try{await this.u(a,n)}catch(i){return i}return!0}async u(a,n){if(!n?.overwrite&&await this.exists(a))throw new p.$wk((0,y.localize)(3,null,this.sb(a)),3,n)}async createFile(a,n=L.$ce.fromString(""),i){await this.u(a,i);const t=await this.writeFile(a,n);return this.r.fire(new p.$tk(a,0,t)),t}async writeFile(a,n,i){const t=this.qb(await this.n(a),a),{providerExtUri:r}=this.R(t);let o=i;if((0,p.$kk)(t)&&!o?.atomic){const v=t.enforceAtomicWriteFile?.(a);v&&(o={...i,atomic:v})}try{await this.w(t,a,o)||await this.U(t,r.dirname(a));let m;if((0,p.$ek)(t)&&!(n instanceof L.$ce))if((0,g.$1d)(n)){const h=await(0,g.$8d)(n,3);h.ended?m=L.$ce.concat(h.buffer):m=h}else m=(0,g.$5d)(n,h=>L.$ce.concat(h),3);else m=n;!(0,p.$hk)(t)||(0,p.$ek)(t)&&m instanceof L.$ce||(0,p.$ek)(t)&&(0,p.$kk)(t)&&o?.atomic?await this.hb(t,a,o,m):await this.db(t,a,o,m instanceof L.$ce?(0,L.$ne)(m):m),this.r.fire(new p.$tk(a,4))}catch(v){throw new p.$wk((0,y.localize)(4,null,this.sb(a),(0,p.$pk)(v).toString()),(0,p.$sk)(v),o)}return this.resolve(a,{resolveMetadata:!0})}async w(a,n,i){const t=!!i?.unlock;if(t&&!(a.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(n)));if(!!i?.atomic){if(!(a.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(n)));if(!(a.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(n)));if(t)throw new Error((0,y.localize)(8,null,this.sb(n)))}let o;try{o=await a.stat(n)}catch{return}if(o.type&p.FileType.Directory)throw new p.$wk((0,y.localize)(9,null,this.sb(n)),0,i);if(this.rb(n,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==p.$Gk&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,p.$Hk)({mtime:i.mtime,size:o.size}))throw new p.$wk((0,y.localize)(10,null),3,i);return o}async readFile(a,n,i){const t=await this.m(a);return n?.atomic?this.z(t,a,n,i):this.C(t,a,n,i)}async z(a,n,i,t){return new Promise((r,o)=>{this.cb.queueFor(n,this.R(a).providerExtUri).queue(async()=>{try{const v=await this.C(a,n,i,t);r(v)}catch(v){o(v)}})})}async C(a,n,i,t){const r=await this.D(a,n,{...i,preferUnbuffered:!0},t);return{...r,value:await(0,L.$oe)(r.value)}}async readFileStream(a,n,i){const t=await this.m(a);return this.D(t,a,n,i)}async D(a,n,i,t){const r=new j.$Yd(t);let o=i;(0,p.$jk)(a)&&a.enforceAtomicReadFile?.(n)&&(o={...i,atomic:!0});const v=this.J(n,o).then(h=>h,h=>{throw r.dispose(!0),h});let m;try{return typeof o?.etag=="string"&&o.etag!==p.$Gk&&await v,o?.atomic&&(0,p.$jk)(a)||!((0,p.$hk)(a)||(0,p.$ik)(a))||(0,p.$ek)(a)&&o?.preferUnbuffered?m=this.I(a,n,o):(0,p.$ik)(a)?m=this.G(a,n,r.token,o):m=this.H(a,n,r.token,o),m.on("end",()=>r.dispose()),m.on("error",()=>r.dispose()),{...await v,value:m}}catch(h){throw m&&await(0,g.$6d)(m),this.F(h,n,o)}}F(a,n,i){const t=(0,y.localize)(11,null,this.sb(n),(0,p.$pk)(a).toString());return a instanceof p.$yk?new p.$yk(t,a.stat,i):a instanceof p.$xk?new p.$xk(t,a.fileOperationResult,a.size,a.options):new p.$wk(t,(0,p.$sk)(a),i)}G(a,n,i,t=Object.create(null)){const r=a.readFileStream(n,t,i);return(0,g.$_d)(r,{data:o=>o instanceof L.$ce?o:L.$ce.wrap(o),error:o=>this.F(o,n,t)},o=>L.$ce.concat(o))}H(a,n,i,t=Object.create(null)){const r=(0,L.$se)();return(0,c.$Pp)(a,n,r,o=>o,{...t,bufferSize:this.a,errorTransformer:o=>this.F(o,n,t)},i),r}I(a,n,i){const t=(0,g.$3d)(r=>L.$ce.concat(r));return(async()=>{try{let r;i?.atomic&&(0,p.$jk)(a)?r=await a.readFile(n,{atomic:!0}):r=await a.readFile(n),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(n,r.byteLength,i),t.end(L.$ce.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(a,n){const i=await this.resolve(a,{resolveMetadata:!0});if(i.isDirectory)throw new p.$wk((0,y.localize)(12,null,this.sb(a)),0,n);if(typeof n?.etag=="string"&&n.etag!==p.$Gk&&n.etag===i.etag)throw new p.$yk((0,y.localize)(13,null),i,n);return this.L(a,i.size,n),i}L(a,n,i){if(typeof i?.limits?.size=="number"&&n>i.limits.size)throw new p.$xk((0,y.localize)(14,null,this.sb(a)),7,n,i)}async canMove(a,n,i){return this.M(a,n,"move",i)}async canCopy(a,n,i){return this.M(a,n,"copy",i)}async M(a,n,i,t){if(a.toString()!==n.toString())try{const r=i==="move"?this.qb(await this.n(a),a):await this.m(a),o=this.qb(await this.n(n),n);await this.Q(r,a,o,n,i,t)}catch(r){return r}return!0}async move(a,n,i){const t=this.qb(await this.n(a),a),r=this.qb(await this.n(n),n),o=await this.N(t,a,r,n,"move",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new p.$tk(a,o==="move"?2:3,v)),v}async copy(a,n,i){const t=await this.m(a),r=this.qb(await this.n(n),n),o=await this.N(t,a,r,n,"copy",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new p.$tk(a,o==="copy"?3:2,v)),v}async N(a,n,i,t,r,o){if(n.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:m}=await this.Q(a,n,i,t,r,o);if(v&&!m&&o&&await this.del(t,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(t)),r==="copy"){if(a===i&&(0,p.$fk)(a))await a.copy(n,t,{overwrite:o});else{const h=await this.resolve(n);h.isDirectory?await this.P(a,h,i,t):await this.O(a,n,i,t)}return r}else return a===i?(await a.rename(n,t,{overwrite:o}),r):(await this.N(a,n,i,t,"copy",o),await this.del(n,{recursive:!0}),"copy")}async O(a,n,i,t){if((0,p.$hk)(a)&&(0,p.$hk)(i))return this.jb(a,n,i,t);if((0,p.$hk)(a)&&(0,p.$ek)(i))return this.pb(a,n,i,t);if((0,p.$ek)(a)&&(0,p.$hk)(i))return this.nb(a,n,i,t);if((0,p.$ek)(a)&&(0,p.$ek)(i))return this.lb(a,n,i,t)}async P(a,n,i,t){await i.mkdir(t),Array.isArray(n.children)&&await A.Promises.settled(n.children.map(async r=>{const o=this.R(i).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(a,await this.resolve(r.resource),i,o):this.O(a,r.resource,i,o)}))}async Q(a,n,i,t,r,o){let v=!1;if(a===i){const{providerExtUri:h,isPathCaseSensitive:$}=this.R(a);if($||(v=h.isEqual(n,t)),v&&r==="copy")throw new Error((0,y.localize)(15,null,this.sb(n),this.sb(t)));if(!v&&h.isEqualOrParent(t,n))throw new Error((0,y.localize)(16,null,this.sb(n),this.sb(t)))}const m=await this.exists(t);if(m&&!v){if(!o)throw new p.$wk((0,y.localize)(17,null,this.sb(n),this.sb(t)),4);if(a===i){const{providerExtUri:h}=this.R(a);if(h.isEqualOrParent(n,t))throw new Error((0,y.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:m,isSameResourceWithDifferentPathCase:v}}R(a){const n=this.S(a);return{providerExtUri:n?l.$mg:l.$og,isPathCaseSensitive:n}}S(a){return!!(a.capabilities&1024)}async createFolder(a){const n=this.qb(await this.j(a),a);await this.U(n,a);const i=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new p.$tk(a,0,i)),i}async U(a,n){const i=[],{providerExtUri:t}=this.R(a);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await a.stat(n)).type&p.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(n)));break}catch(r){if((0,p.$rk)(r)!==p.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(t.basename(n)),n=t.dirname(n)}for(let r=i.length-1;r>=0;r--){n=t.joinPath(n,i[r]);try{await a.mkdir(n)}catch(o){if((0,p.$rk)(o)!==p.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(a,n){try{await this.W(a,n)}catch(i){return i}return!0}async W(a,n){const i=this.qb(await this.j(a),a),t=!!n?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(a)));const r=n?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(a)));if(t&&r)throw new Error((0,y.localize)(22,null,this.sb(a)));let o;try{o=await i.stat(a)}catch{}if(o)this.rb(a,o);else throw new p.$wk((0,y.localize)(23,null,this.sb(a)),1);if(!!!n?.recursive){const m=await this.resolve(a);if(m.isDirectory&&Array.isArray(m.children)&&m.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(a)))}return i}async del(a,n){const i=await this.W(a,n);let t=n;if((0,p.$lk)(i)&&!t?.atomic){const m=i.enforceAtomicDelete?.(a);m&&(t={...n,atomic:m})}const r=!!t?.useTrash,o=!!t?.recursive,v=t?.atomic??!1;await i.delete(a,{recursive:o,useTrash:r,atomic:v}),this.r.fire(new p.$tk(a,1))}async cloneFile(a,n){const i=await this.j(a),t=this.qb(await this.n(n),n);if(i===t&&this.R(i).providerExtUri.isEqual(a,n))return;if(i===t&&(0,p.$gk)(i))return i.cloneFile(a,n);await this.U(t,this.R(t).providerExtUri.dirname(n));const r=this.cb.queueFor(a,this.R(i).providerExtUri);return i===t&&(0,p.$fk)(i)?r.queue(()=>i.copy(a,n,{overwrite:!0})):r.queue(()=>this.O(i,a,t,n))}static{this.ab=0}createWatcher(a,n){return this.watch(a,{...n,correlationId:b.ab++})}watch(a,n={recursive:!1,excludes:[]}){const i=new d.$Qc;let t=!1,r=()=>{t=!0};i.add((0,d.$Pc)(()=>r())),(async()=>{try{const v=await this.bb(a,n);t?(0,d.$Mc)(v):r=()=>(0,d.$Mc)(v)}catch(v){this.b.error(v)}})();const o=n.correlationId;if(typeof o=="number"){const v=i.add(new O.$Od);return i.add(this.X.event(h=>{h.correlates(o)&&v.fire(h)})),{onDidChange:v.event,dispose:()=>i.dispose()}}return i}async bb(a,n){const i=await this.j(a),t=(0,R.$Gi)([this.R(i).providerExtUri.getComparisonKey(a),n]);let r=this.$.get(t);return r||(r={count:0,disposable:i.watch(a,n)},this.$.set(t,r)),r.count+=1,(0,d.$Pc)(()=>{r&&(r.count--,r.count===0&&((0,d.$Mc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,a]of this.$)(0,d.$Mc)(a.disposable);this.$.clear()}async db(a,n,i,t){return this.cb.queueFor(n,this.R(a).providerExtUri).queue(async()=>{const r=await a.open(n,{create:!0,unlock:i?.unlock??!1});try{(0,g.$1d)(t)||(0,g.$2d)(t)?await this.eb(a,r,t):await this.fb(a,r,t)}catch(o){throw(0,p.$pk)(o)}finally{await a.close(r)}})}async eb(a,n,i){let t=0,r;if((0,g.$2d)(i)){if(i.buffer.length>0){const o=L.$ce.concat(i.buffer);await this.gb(a,n,o,o.byteLength,t,0),t+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((o,v)=>{(0,g.$7d)(r,{onData:async m=>{r.pause();try{await this.gb(a,n,m,m.byteLength,t,0)}catch(h){return v(h)}t+=m.byteLength,setTimeout(()=>r.resume())},onError:m=>v(m),onEnd:()=>o()})})}async fb(a,n,i){let t=0,r;for(;(r=i.read())!==null;)await this.gb(a,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(a,n,i,t,r,o){let v=0;for(;v<t;){const m=await a.write(n,r+v,i.buffer,o+v,t-v);v+=m}}async hb(a,n,i,t){return this.cb.queueFor(n,this.R(a).providerExtUri).queue(()=>this.ib(a,n,i,t))}async ib(a,n,i,t){let r;t instanceof L.$ce?r=t:(0,g.$1d)(t)?r=await(0,L.$oe)(t):(0,g.$2d)(t)?r=await(0,L.$pe)(t):r=(0,L.$me)(t),await a.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.kb(a,n,i,t))}async kb(a,n,i,t){let r,o;try{r=await a.open(n,{create:!1}),o=await i.open(t,{create:!0,unlock:!1});const v=L.$ce.alloc(this.a);let m=0,h=0,$=0;do $=await a.read(r,m,v.buffer,h,v.byteLength-h),await this.gb(i,o,v,$,m,h),m+=$,h+=$,h===v.byteLength&&(h=0);while($>0)}catch(v){throw(0,p.$pk)(v)}finally{await A.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async lb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.mb(a,n,i,t))}async mb(a,n,i,t){return i.writeFile(t,await a.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(a,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.ob(a,n,i,t))}async ob(a,n,i,t){const r=await i.open(t,{create:!0,unlock:!1});try{const o=await a.readFile(n);await this.gb(i,r,L.$ce.wrap(o),o.byteLength,0,0)}catch(o){throw(0,p.$pk)(o)}finally{await i.close(r)}}async pb(a,n,i,t){const r=await(0,L.$oe)(this.H(a,n,j.CancellationToken.None));await this.hb(i,t,void 0,r)}qb(a,n){if(a.capabilities&2048)throw new p.$wk((0,y.localize)(25,null,this.sb(n)),6);return a}rb(a,n){if((n.permissions??0)&p.FilePermission.Readonly)throw new p.$wk((0,y.localize)(26,null,this.sb(a)),6)}sb(a){return a.scheme===E.Schemas.file?a.fsPath:a.toString(!0)}};e.$Qp=k,e.$Qp=k=b=pe([X(0,f.$aj)],k)}),define(ae[199],ce([0,1,53,270,6,34,15,3,48,2,16,5,19,46,31,161,11,99,197,38,193,192]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f,u,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0,(()=>{try{(0,A.gracefulify)(I)}catch(a){console.error(`Error enabling graceful-fs: ${(0,u.$Di)(a)}`)}})();class s extends f.$Zp{static{this.I=!1}constructor(n,i){super(n,i),this.onDidChangeCapabilities=R.Event.None,this.N=new j.$zc(t=>w.$ng.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:i,symbolicLink:t}=await g.SymlinkSupport.stat(this.H(n));return{type:this.M(i,t),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:p.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await g.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(i.map(async r=>{try{let o;r.isSymbolicLink()?o=(await this.stat((0,w.$wg)(n,r.name))).type:o=this.M(r),t.push([r.name,o])}catch(o){this.a.trace(o)}})),t}catch(i){throw this.fb(i)}}M(n,i){let t;return i?.dangling?t=p.FileType.Unknown:n.isFile()?t=p.FileType.File:n.isDirectory()?t=p.FileType.Directory:t=p.FileType.Unknown,i&&(t|=p.FileType.SymbolicLink),t}async O(n){const i=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await t.wait();const r=new L.$Tg;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,d.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(n,i){let t;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await g.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){s.I&&this.a.trace(n)}readFileStream(n,i,t){const r=(0,l.$3d)(o=>O.$ce.concat(o.map(v=>O.$ce.wrap(v))).buffer);return(0,c.$Pp)(this,n,r,o=>o.buffer,{...i,bufferSize:256*1024},t),r}async writeFile(n,i,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,w.$wg)((0,w.$vg)(n),`${(0,w.$tg)(n)}${t.atomic.postfix}`),i,t):this.S(n,i,t)}async Q(n){try{const i=this.H(n),{symbolicLink:t}=await g.SymlinkSupport.stat(i);if(t)return!1}catch{}return!0}async R(n,i,t,r){const o=new d.$Qc;try{o.add(await this.O(n)),o.add(await this.O(i)),await this.S(i,t,r,!0);try{await this.rename(i,n,{overwrite:!0})}catch(v){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{o.dispose()}}async S(n,i,t,r){let o;try{const v=this.H(n);if(!t.create||!t.overwrite){if(await g.Promises.exists(v)){if(!t.overwrite)throw(0,p.$ok)((0,y.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,p.$ok)((0,y.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(o,0,i,0,i.byteLength)}catch(v){throw await this.gb(n,v)}finally{typeof o=="number"&&await this.close(o)}}static{this.Y=!0}static configureFlushOnWrite(n){s.Y=n}async open(n,i,t){const r=this.H(n);let o;(0,p.$ck)(i)&&!t&&(o=await this.O(n));let v;try{if((0,p.$ck)(i)&&i.unlock)try{const{stat:h}=await g.SymlinkSupport.stat(r);h.mode&128||await g.Promises.chmod(r,h.mode|128)}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}let m;if((0,p.$ck)(i)){if(E.$i)try{await g.Promises.truncate(r,0),m="r+"}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}m||(m="w")}else m="r";v=await g.Promises.open(r,m)}catch(m){throw o?.dispose(),(0,p.$ck)(i)?await this.gb(n,m):this.fb(m)}if(this.U.set(v,0),(0,p.$ck)(i)&&this.X.set(v,n),o){const m=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,o),m&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),m.dispose())}return v}async close(n){const i=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&s.Y)try{await g.Promises.fdatasync(n)}catch(t){s.configureFlushOnWrite(!1),this.a.error(t)}return await g.Promises.close(n)}catch(t){throw this.fb(t)}finally{i&&(this.W.get(n)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,t,r,o){const v=this.Z(n,i);let m=null;try{m=(await g.Promises.read(n,t,r,o,v)).bytesRead}catch(h){throw this.fb(h)}finally{this.$(n,v,m)}return m}Z(n,i){return i===this.U.get(n)?null:i}$(n,i,t){const r=this.U.get(n);typeof r=="number"&&(typeof i=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,i,t,r,o){return(0,L.$ch)(()=>this.ab(n,i,t,r,o),100,3)}async ab(n,i,t,r,o){const v=this.Z(n,i);let m=null;try{m=(await g.Promises.write(n,t,r,o,v)).bytesWritten}catch(h){throw await this.gb(this.X.get(n),h)}finally{this.$(n,v,m)}return m}async mkdir(n){try{await g.Promises.mkdir(this.H(n))}catch(i){throw this.fb(i)}}async delete(n,i){try{const t=this.H(n);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,C.$ic)((0,C.$lc)(t),`${(0,C.$mc)(t)}${i.atomic.postfix}`)),await g.Promises.rm(t,g.RimRafMode.MOVE,r)}else try{await g.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let o=!1;try{const{stat:v,symbolicLink:m}=await g.SymlinkSupport.stat(t);o=v.isDirectory()&&!m}catch{}if(o)await g.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,i,t){const r=this.H(n),o=this.H(i);if(r!==o)try{await this.bb(n,i,"move",t.overwrite),await g.Promises.rename(r,o)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,y.localize)(2,null,(0,C.$mc)(r),(0,C.$mc)((0,C.$lc)(o)),v.toString()))),this.fb(v)}}async copy(n,i,t){const r=this.H(n),o=this.H(i);if(r!==o)try{await this.bb(n,i,"copy",t.overwrite),await g.Promises.copy(r,o,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,y.localize)(3,null,(0,C.$mc)(r),(0,C.$mc)((0,C.$lc)(o)),v.toString()))),this.fb(v)}}async bb(n,i,t,r){const o=this.H(n),v=this.H(i);let m=!1;if(!!(this.capabilities&1024)||(m=(0,S.$Xf)(o,v,!0)),m){if(t==="copy")throw(0,p.$ok)((0,y.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const $=await this.L(n);if(!$)throw(0,p.$ok)((0,y.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const D=await this.L(i);if(D){if(!r)throw(0,p.$ok)((0,y.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);$.type&p.FileType.File&&D.type&p.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.cb(n,i,!1)}async cb(n,i,t){const r=this.H(n),o=this.H(i),v=!!(this.capabilities&1024);if((0,S.$Xf)(r,o,!v))return;const m=new d.$Qc;try{m.add(await this.O(n)),m.add(await this.O(i)),t&&await g.Promises.mkdir((0,C.$lc)(o),{recursive:!0}),await g.Promises.copyFile(r,o)}catch(h){if(h.code==="ENOENT"&&!t)return this.cb(n,i,!0);throw this.fb(h)}finally{m.dispose()}}t(n,i,t){return new b.$7p(r=>n(r),r=>i(r),t)}F(n,i,t){return new k.$cq(r=>n(r),r=>i(r),t)}fb(n){if(n instanceof p.$nk)return n;let i=n,t;switch(n.code){case"ENOENT":t=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=p.FileSystemProviderErrorCode.Unknown;break;default:t=p.FileSystemProviderErrorCode.Unknown}return(0,p.$ok)(i,t)}async gb(n,i){let t=this.fb(i);if(n&&t.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await g.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,p.$ok)(i,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$dq=s}),define(ae[101],ce([0,1,3,2,4,8]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e0b=e.$d0b=void 0,e.$d0b=(0,L.$Sh)("sharedProcessLifecycleService");let O=class extends A.$Rc{constructor(S){super(),this.b=S,this.a=this.B(new I.$Od),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$e0b=O,e.$e0b=O=pe([X(0,j.$aj)],O)}),define(ae[200],ce([0,1,10,3,8,2]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=void 0;class O extends L.$lj{constructor(E,w,l,g,y){super(w,l,g),this.r=E,this.t=y,this.B(y.listen("onDidChangeLogLevel",E)(p=>{(0,L.$cj)(p)?super.setLogLevel(p):super.setLogLevel(I.URI.revive(p[0]),p[1])})),this.B(y.listen("onDidChangeVisibility",E)(([p,c])=>super.setVisibility(I.URI.revive(p),c))),this.B(y.listen("onDidChangeLoggers",E)(({added:p,removed:c})=>{for(const f of p)super.registerLogger({...f,resource:I.URI.revive(f.resource)});for(const f of c)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new L.$jj({log:(E,w)=>{this.t.call("consoleLog",[E,w])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,w){super.setLogLevel(E,w),this.t.call("setLogLevel",[E,w])}setVisibility(E,w){super.setVisibility(E,w),this.t.call("setVisibility",[this.n(E),w])}s(E,w,l){return new R(this.t,E,w,l,this.r)}static setLogLevel(E,w,l){return E.call("setLogLevel",[w,l])}}e.$br=O;class R extends L.$gj{constructor(E,w,l,g,y){super(g?.logLevel==="always"),this.r=E,this.s=w,this.m=!1,this.n=[],this.setLevel(l),this.r.call("createLogger",[w,g,y]).then(()=>{this.u(this.n),this.m=!0})}g(E,w){const l=[[E,w]];this.m?this.u(l):this.n.push(...l)}u(E){this.r.call("log",[this.s,E])}}class S{constructor(E,w){this.a=E,this.b=w}listen(E,w){const l=this.b(E);switch(w){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(y=>this.c(y,l)),removed:[...g.removed].map(y=>this.c(y,l))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,g=>[l.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,g=>(0,L.$cj)(g)?g:[l.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${w}`)}async call(E,w,l){const g=this.b(E);switch(w){case"setLogLevel":return(0,L.$cj)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(I.URI.revive(g.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,g)))}throw new Error(`Call not found: ${w}`)}c(E,w){return{...E,resource:w.transformOutgoingURI(E.resource)}}}e.$cr=S;class d extends j.$Rc{constructor(E,w){super(),w.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(l=>w.call("setLogLevel",[l]))),w.call("getRegisteredLoggers").then(l=>{for(const g of l)E.registerLogger({...g,resource:I.URI.revive(g.resource)})}),this.B(w.listen("onDidChangeVisibility")(([l,g])=>E.setVisibility(I.URI.revive(l),g))),this.B(w.listen("onDidChangeLoggers")(({added:l,removed:g})=>{for(const y of l)E.registerLogger({...y,resource:I.URI.revive(y.resource)});for(const y of g)E.deregisterLogger(y.resource)}))}}e.$dr=d}),define(ae[201],ce([0,1,2,8]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=void 0;class L extends I.$Rc{constructor(O,R=[]){super(),this.a=new A.$kj([O,...R]),this.B(O.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...R){this.a.trace(O,...R)}debug(O,...R){this.a.debug(O,...R)}info(O,...R){this.a.info(O,...R)}warn(O,...R){this.a.warn(O,...R)}error(O,...R){this.a.error(O,...R)}flush(){this.a.flush()}}e.$TN=L}),define(ae[56],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_7b=void 0,e.$_7b=(0,I.$Sh)("nativeHostService")}),define(ae[202],ce([0,1,40,55]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t9b=void 0;let L=class{constructor(O,R){return this.windowId=O,I.ProxyChannel.toService(R.getChannel("nativeHost"),{context:O,properties:(()=>{const S=new Map;return S.set("windowId",O),S})()})}};e.$t9b=L,e.$t9b=L=pe([X(1,A.$n9b)],L)}),define(ae[57],ce([0,1,3,60,2,4]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=void 0,e.$ln=(0,j.$Sh)("policy");class O extends L.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.$Od),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const C=Object.keys(this.f).length;return this.f={...d,...this.f},C!==Object.keys(this.f).length&&await this.j(d),A.Iterable.reduce(this.g.entries(),(E,[w,l])=>({...E,[w]:l}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(d,[C,E])=>({...d,[C]:{definition:E,value:this.g.get(C)}}),{})}}e.$mn=O;class R{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$nn=R}),define(ae[203],ce([0,1,3,2,57]),function(ie,e,I,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W8b=e.$V8b=void 0;class j{constructor(S){this.b=S,this.a=new A.$Qc}listen(S,d){switch(d){case"onDidChange":return I.Event.map(this.b.onDidChange,C=>C.reduce((E,w)=>({...E,[w]:this.b.getPolicyValue(w)??null}),{}),this.a)}throw new Error(`Event not found: ${d}`)}call(S,d,C){switch(d){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${d}`)}dispose(){this.a.dispose()}}e.$V8b=j;class O extends L.$mn{constructor(S,d){super(),this.a=d;for(const C in S){const{definition:E,value:w}=S[C];this.f[C]=E,w!==void 0&&this.g.set(C,w)}this.a.listen("onDidChange")(C=>{for(const E in C){const w=C[E];w===null?this.g.delete(E):this.g.set(E,w)}this.h.fire(Object.keys(C))})}async j(S){const d=await this.a.call("updatePolicyDefinitions",S);for(const C in d)this.g.set(C,d[C])}}e.$W8b=O}),define(ae[102],ce([0,1,37]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const j=L.context.configuration();if(j)A=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,I.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:j.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(ae[25],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=void 0,e.$sj=(0,I.$Sh)("productService"),e.$tj="vscode://schemas/vscode-product"}),define(ae[204],ce([0,1,6,7,2,16,31,8,25]),function(ie,e,I,A,L,j,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K9b=void 0;let d=class extends L.$Rc{constructor(E,w,l){super(),this.b=w,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new I.$7g(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const w=Date.now(),l=(0,j.$lc)(E),g=(0,j.$mc)(E),y=await O.Promises.readdir(l);await Promise.all(y.map(async p=>{if(p===g)return;const c=(0,j.$ic)(l,p),f=await O.Promises.stat(c);if(f.isDirectory()&&w-f.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${p}.`),O.Promises.rm(c)}))}catch(w){(0,A.$Z)(w)}}};e.$K9b=d,e.$K9b=d=pe([X(1,S.$sj),X(2,R.$aj)],d)}),define(ae[205],ce([0,1,6,7,2,16,31,14,8,25]),function(ie,e,I,A,L,j,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L9b=void 0;let C=class extends L.$Rc{constructor(w,l,g){super(),this.b=w,this.c=l,this.f=g,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new I.$7g(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const w=Object.create(null),l=JSON.parse(await O.Promises.readFile((0,j.$ic)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const f of Object.keys(l)){const u=l[f];w[`${u.hash}.${f}`]=!0}const g=(0,j.$ic)(this.b.userDataPath,"clp");if(!await O.Promises.exists(g))return;const p=await O.Promises.readdir(g);for(const f of p){if(w[f]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${f}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${f}`),await O.Promises.rm((0,j.$ic)(g,f))}const c=Date.now();for(const f of Object.keys(w)){const u=(0,j.$ic)(g,f),b=await O.Promises.readdir(u);for(const k of b){if(k==="tcf.json")continue;const s=(0,j.$ic)(u,k),a=await O.Promises.stat(s);a.isDirectory()&&c-a.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$ic)(f,k)}`),await O.Promises.rm(s))}}}catch(w){(0,A.$Z)(w)}}};e.$L9b=C,e.$L9b=C=pe([X(0,R.$1h),X(1,S.$aj),X(2,d.$sj)],C)}),define(ae[206],ce([0,1,16,4]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$aF=void 0,e.$aF=(0,A.$Sh)("IV8InspectProfilingService");var L;(function(j){function O(S){return!!(S.samples&&S.timeDeltas)}j.isValidProfile=O;function R(S,d="noAbsolutePaths"){for(const C of S.nodes)C.callFrame&&C.callFrame.url&&((0,I.$hc)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,I.$ic)(d,(0,I.$mc)(C.callFrame.url)));return S}j.rewriteAbsolutePaths=R})(L||(e.Utils=L={}))}),define(ae[207],ce([0,1,32]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$69b=void 0;class A{constructor(){this.a=new Map}async startProfiling(j){const R=await(await new Promise((d,C)=>{ie(["v8-inspect-profiler"],d,C)})).startProfiling({port:j.port,checkForPaused:!0}),S=(0,I.$fg)();return this.a.set(S,R),S}async stopProfiling(j){const O=this.a.get(j);if(!O)throw new Error(`UNKNOWN session '${j}'`);const R=await O.stop();return this.a.delete(j),R.profile}}e.$69b=A}),define(ae[41],ce([0,1,126,12]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=void 0;class L{constructor(){this.a=new Map}add(O,R){I.ok(A.$zf(O)),I.ok(A.$Bf(R)),I.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,R)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$jn=new L}),define(ae[103],ce([0,1,3,41]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0,e.$kn={JSONContribution:"base.contributions.json"};function L(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class j{constructor(){this.b=new I.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,d){this.a[L(S)]=d,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const O=new j;A.$jn.add(e.$kn.JSONContribution,O)}),define(ae[50],ce([0,1,18,3,12,148,20,103,41]),function(ie,e,I,A,L,j,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.ConfigurationScope=e.$on=e.EditPresentationTypes=void 0;var d;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.$on={Configuration:"base.contributions.configuration"};var C;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn="vscode://schemas/settings/resourceLanguage",e.$wn="vscode://schemas/settings/configurationDefaults";const E=S.$jn.as(R.$kn.JSONContribution);class w{constructor(){this.h=new Set,this.i=new A.$Od,this.onDidSchemaChange=this.i.event,this.j=new A.$Od,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$vn,this.g),this.v()}registerConfiguration(s,a=!0){this.registerConfigurations([s],a)}registerConfigurations(s,a=!0){const n=new Set;this.n(s,a,n),E.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(s){const a=new Set;this.o(s,a),E.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:s,remove:a}){const n=new Set;this.o(a,n),this.n(s,!1,n),E.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(s){const a=new Set;this.k(s,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(s,a){const n=[];for(const{overrides:i,source:t}of s)for(const r in i)if(a.add(r),e.$yn.test(r)){const o=this.a.get(r),v=o?.valuesSources??new Map;if(t)for(const D of Object.keys(i[r]))v.set(D,t);const m={...o?.value||{},...i[r]};this.a.set(r,{source:t,value:m,valuesSources:v});const h=(0,O.$wi)(r),$={type:"object",default:m,description:j.localize(1,null,h),$ref:e.$vn,defaultDefaultValue:m,source:L.$zf(t)?void 0:t,defaultValueSource:t};n.push(...y(r)),this.d[r]=$,this.b.properties[r]=$}else{this.a.set(r,{value:i[r],source:t});const o=this.d[r];o&&(this.w(r,o),this.r(r,o))}this.m(n)}deregisterDefaultConfigurations(s){const a=new Set;this.l(s,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(s,a){for(const{overrides:n,source:i}of s)for(const t in n){const r=this.a.get(t),o=L.$zf(i)?i:i?.id,v=L.$zf(r?.source)?r?.source:r?.source?.id;if(o===v)if(a.add(t),this.a.delete(t),e.$yn.test(t))delete this.d[t],delete this.b.properties[t];else{const m=this.d[t];m&&(this.w(t,m),this.r(t,m))}}this.u()}deltaConfiguration(s){let a=!1;const n=new Set;s.removedDefaults&&(this.l(s.removedDefaults,n),a=!0),s.addedDefaults&&(this.k(s.addedDefaults,n),a=!0),s.removedConfigurations&&this.o(s.removedConfigurations,n),s.addedConfigurations&&this.n(s.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const a of s)this.h.add(a);this.u()}n(s,a,n){s.forEach(i=>{this.p(i,a,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(s,a){const n=i=>{if(i.properties)for(const t in i.properties){a.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,i.properties[t])}i.allOf?.forEach(t=>n(t))};for(const i of s){n(i);const t=this.c.indexOf(i);t!==-1&&this.c.splice(t,1)}}p(s,a=!0,n,i,t=3,r){t=L.$If(s.scope)?t:s.scope;const o=s.properties;if(o)for(const m in o){const h=o[m];if(a&&u(m,h)){delete o[m];continue}if(h.source=n,h.defaultDefaultValue=o[m].default,this.w(m,h),e.$yn.test(m)?h.scope=void 0:(h.scope=L.$If(h.scope)?t:h.scope,h.restricted=L.$If(h.restricted)?!!i?.includes(m):h.restricted),o[m].hasOwnProperty("included")&&!o[m].included){this.f[m]=o[m],delete o[m];continue}else this.d[m]=o[m],o[m].policy?.name&&this.e.set(o[m].policy.name,m);!o[m].deprecationMessage&&o[m].markdownDeprecationMessage&&(o[m].deprecationMessage=o[m].markdownDeprecationMessage),r.add(m)}const v=s.allOf;if(v)for(const m of v)this.p(m,a,n,i,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const a=n=>{const i=n.properties;if(i)for(const r in i)this.r(r,i[r]);n.allOf?.forEach(a)};a(s)}r(s,a){switch(e.$pn.properties[s]=a,a.scope){case 1:e.$qn.properties[s]=a;break;case 2:e.$rn.properties[s]=a;break;case 6:e.$sn.properties[s]=a;break;case 3:e.$tn.properties[s]=a;break;case 4:e.$un.properties[s]=a;break;case 5:e.$un.properties[s]=a,this.g.properties[s]=a;break}}s(s,a){switch(delete e.$pn.properties[s],a.scope){case 1:delete e.$qn.properties[s];break;case 2:delete e.$rn.properties[s];break;case 6:delete e.$sn.properties[s];break;case 3:delete e.$tn.properties[s];break;case 4:case 5:delete e.$un.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const a=`[${s}]`,n={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$vn};this.w(a,n),e.$pn.properties[a]=n,e.$qn.properties[a]=n,e.$rn.properties[a]=n,e.$sn.properties[a]=n,e.$tn.properties[a]=n,e.$un.properties[a]=n}}v(){const s={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$vn};e.$pn.patternProperties[e.$xn]=s,e.$qn.patternProperties[e.$xn]=s,e.$rn.patternProperties[e.$xn]=s,e.$sn.patternProperties[e.$xn]=s,e.$tn.patternProperties[e.$xn]=s,e.$un.patternProperties[e.$xn]=s,this.i.fire()}w(s,a){const n=this.a.get(s);let i=n?.value,t=n?.source;L.$Gf(i)&&(i=a.defaultDefaultValue,t=void 0),L.$Gf(i)&&(i=c(a.type)),a.default=i,a.defaultValueSource=t}}const l="\\[([^\\]]+)\\]",g=new RegExp(l,"g");e.$xn=`^(${l})+$`,e.$yn=new RegExp(e.$xn);function y(k){const s=[];if(e.$yn.test(k)){let a=g.exec(k);for(;a?.length;){const n=a[1].trim();n&&s.push(n),a=g.exec(k)}}return(0,I.$Lb)(s)}e.$zn=y;function p(k){return k.reduce((s,a)=>`${s}[${a}]`,"")}e.$An=p;function c(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Bn=c;const f=new w;S.$jn.add(e.$on.Configuration,f);function u(k,s){return k.trim()?e.$yn.test(k)?j.localize(7,null,k):f.getConfigurationProperties()[k]!==void 0?j.localize(8,null,k):s.policy?.name&&f.getPolicyConfigurations().get(s.policy?.name)!==void 0?j.localize(9,null,k,s.policy?.name,f.getPolicyConfigurations().get(s.policy?.name)):null:j.localize(6,null)}e.$Cn=u;function b(){const k=[],s=f.getConfigurationProperties();for(const a of Object.keys(s))k.push([a,s[a].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.$Dn=b}),define(ae[74],ce([0,1,18,3,35,2,34,30,12,10,20,50,41]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=void 0;function l(a){return Object.isFrozen(a)?a:R.$$m(a)}class g{constructor(n={},i=[],t=[],r){this.b=n,this.c=i,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof g)return i;const t=new y("");return t.parseRaw(i),t.configurationModel});this.f=n.reduce((i,t)=>t===i?t:i.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$ui)(this.contents,n):this.contents}inspect(n,i){const t=this.rawConfiguration.getValue(n),r=i?this.rawConfiguration.getOverrideValue(n,i):void 0,o=i?this.rawConfiguration.override(i).getValue(n):t;return{value:t,override:r,merged:o}}getOverrideValue(n,i){const t=this.i(i);return t?n?(0,C.$ui)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const t of this.overrides)t.identifiers.includes(n)&&i.push(...t.keys);return I.$Lb(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return I.$Lb(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=R.$0m(this.contents),t=R.$0m(this.overrides),r=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const v of n)if(o.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(i,v.contents);for(const m of v.overrides){const[h]=t.filter($=>I.$tb($.identifiers,m.identifiers));h?(this.h(h.contents,m.contents),h.keys.push(...m.keys),h.keys=I.$Lb(h.keys)):t.push(R.$0m(m))}for(const m of v.keys)r.indexOf(m)===-1&&r.push(m)}return new g(i,r,t,o.every(v=>v instanceof g)?void 0:o)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const t={};for(const r of I.$Lb([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[r];const v=i[r];v&&(typeof o=="object"&&typeof v=="object"?(o=R.$0m(o),this.h(o,v)):o=v),t[r]=o}return new g(t,this.keys,this.overrides)}h(n,i){for(const t of Object.keys(i)){if(t in n&&S.$Bf(n[t])&&S.$Bf(i[t])){this.h(n[t],i[t]);continue}n[t]=R.$0m(i[t])}}i(n){let i=null,t=null;const r=o=>{o&&(t?this.h(t,o):t=R.$0m(o))};for(const o of this.overrides)o.identifiers.length===1&&o.identifiers[0]===n?i=o.contents:o.identifiers.includes(n)&&r(o.contents);return r(i),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,C.$ti)(this.contents,n),E.$yn.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>I.$tb(t.identifiers,(0,E.$zn)(n))),1))}j(n,i,t){(0,C.$si)(this.contents,n,i,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),E.$yn.test(n)&&this.overrides.push({identifiers:(0,E.$zn)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$ri)(this.contents[n],r=>console.error(r))})}}e.$En=g;class y{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!S.$If(n)){const t=this.g(n);this.parseRaw(t,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:t,keys:r,overrides:o,restricted:v,hasExcludedProperties:m}=this.h(n,i);this.b=new g(t,r,o,m?[n]:void 0),this.c=v||[]}g(n){let i={},t=null,r=[];const o=[],v=[];function m($){Array.isArray(r)?r.push($):t!==null&&(r[t]=$)}const h={onObjectBegin:()=>{const $={};m($),o.push(r),r=$,t=null},onObjectProperty:$=>{t=$},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const $=[];m($),o.push(r),r=$,t=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:m,onError:($,D,F)=>{v.push({error:$,offset:D,length:F})}};if(n)try{L.$7m(n,h),i=r[0]||{}}catch($){console.error(`Error while parsing settings file ${this.f}: ${$}`),this.d=[$]}return i}h(n,i){const t=w.$jn.as(E.$on.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,i);n=r.raw;const o=(0,C.$ri)(n,h=>console.error(`Conflict in settings file ${this.f}: ${h}`)),v=Object.keys(n),m=this.j(n,h=>console.error(`Conflict in settings file ${this.f}: ${h}`));return{contents:o,keys:v,overrides:m,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,i,t,r){let o=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:o};const v={},m=[];for(const h in n)if(E.$yn.test(h)&&t){const $=this.i(n[h],i,!1,r);v[h]=$.raw,o=o||$.hasExcludedProperties,m.push(...$.restricted)}else{const $=i[h],D=$?typeof $.scope<"u"?$.scope:3:void 0;$?.restricted&&m.push(h),!r.exclude?.includes(h)&&(r.include?.includes(h)||(D===void 0||r.scopes===void 0||r.scopes.includes(D))&&!(r.skipRestricted&&$?.restricted))?v[h]=n[h]:o=!0}return{raw:v,restricted:m,hasExcludedProperties:o}}j(n,i){const t=[];for(const r of Object.keys(n))if(E.$yn.test(r)){const o={};for(const v in n[r])o[v]=n[r][v];t.push({identifiers:(0,E.$zn)(r),keys:Object.keys(o),contents:(0,C.$ri)(o,i)})}return t}}e.$Fn=y;class p extends j.$Rc{constructor(n,i,t,r){super(),this.c=n,this.f=i,this.g=r,this.b=this.B(new A.$Od),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,o=>o.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new g}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Gn=p;class c{constructor(n,i,t,r,o,v,m,h,$,D,F,M,U){this.a=n,this.b=i,this.c=t,this.overrideIdentifiers=r,this.d=o,this.f=v,this.g=m,this.h=h,this.i=$,this.j=D,this.k=F,this.l=M,this.m=U}get value(){return l(this.c)}n(n,i,t){const r=n.inspect(i,t);return{get value(){return l(r.value)},get override(){return l(r.override)},get merged(){return l(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(n,i,t,r,o=new g,v=new g,m=new O.$zc,h=new g,$=new O.$zc){this.c=n,this.d=i,this.f=t,this.g=r,this.h=o,this.i=v,this.j=m,this.l=h,this.m=$,this.a=null,this.b=new O.$zc,this.n=null}getValue(n,i,t){return this.q(n,i,t).getValue(n)}updateValue(n,i,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new g,this.m.set(t.resource,r))):r=this.l,i===void 0?r.removeValue(n):r.setValue(n,i),t.resource||(this.a=null)}inspect(n,i,t){const r=this.q(n,i,t),o=this.u(i.resource,t),v=i.resource?this.m.get(i.resource)||this.l:this.l,m=new Set;for(const h of r.overrides)for(const $ of h.identifiers)r.getOverrideValue(n,$)!==void 0&&m.add($);return new c(n,i,r.getValue(n),m.size?[...m]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,o||void 0,v)}keys(n){const i=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const t=[];if(!i){const{added:r,updated:o,removed:v}=k(this.c,n);i=[...r,...o,...v]}for(const r of i)for(const o of(0,E.$zn)(r)){const v=this.c.getKeysForOverrideIdentifier(o),m=n.getKeysForOverrideIdentifier(o),h=[...m.filter($=>v.indexOf($)===-1),...v.filter($=>m.indexOf($)===-1),...v.filter($=>!R.$bn(this.c.override(o).getValue($),n.override(o).getValue($)))];t.push([o,h])}return this.updateDefaultConfiguration(n),{keys:i,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:t,removed:r}=k(this.d,n),o=[...i,...t,...r];return o.length&&this.updatePolicyConfiguration(n),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=k(this.applicationConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:o}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=k(this.localUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:o}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=k(this.remoteUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:o}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:t,removed:r,overrides:o}=k(this.workspaceConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:o}}compareAndUpdateFolderConfiguration(n,i){const t=this.p.get(n),{added:r,updated:o,removed:v,overrides:m}=k(t,i),h=[...r,...o,...v];return(h.length||!t)&&this.updateFolderConfiguration(n,i),{keys:h,overrides:m}}compareAndDeleteFolderConfiguration(n){const i=this.p.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:o,overrides:v}=k(i,void 0);return{keys:[...t,...r,...o],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,i,t){let r=this.r(i,t);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}r({resource:n},i){let t=this.s();if(i&&n){const r=i.getFolder(n);r&&(t=this.t(r.uri)||t);const o=this.m.get(n);o&&(t=t.merge(o))}return t}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let i=this.b.get(n);if(!i){const t=this.s(),r=this.j.get(n);r?(i=t.merge(r),this.b.set(n,i)):i=t}return i}u(n,i){if(i&&n){const t=i.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:t,overrides:r,keys:o}=this.j.get(i);return n.push([i,{contents:t,overrides:r,keys:o}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(t=>n.add(t))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}w(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r))),[...i.values()]}static parse(n){const i=this.x(n.defaults),t=this.x(n.policy),r=this.x(n.application),o=this.x(n.user),v=this.x(n.workspace),m=n.folders.reduce((h,$)=>(h.set(d.URI.revive($[0]),this.x($[1])),h),new O.$zc);return new f(i,t,r,o,new g,v,m,new g,new O.$zc)}static x(n){return new g(n.contents,n.keys,n.overrides)}}e.$Hn=f;function u(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,i=new Map;for(const r of a)r.keys.forEach(o=>n.add(o)),r.overrides.forEach(([o,v])=>{const m=(0,O.$wc)(i,o,new Set);v.forEach(h=>m.add(h))});const t=[];return i.forEach((r,o)=>t.push([o,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$In=u;class b{constructor(n,i,t,r){this.change=n,this.f=i,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of n.keys)this.affectedKeys.add(o);for(const[,o]of n.overrides)for(const v of o)this.affectedKeys.add(v);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(n,i){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const o=r+t.length;if(o>=this.d.length)return!1;const v=this.d.charCodeAt(o);if(v!==this.b&&v!==this.c)return!1;if(i){const m=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,h=this.g.getValue(n,i,this.h);return!R.$bn(m,h)}return!0}}e.$Jn=b;function k(a,n){const{added:i,removed:t,updated:r}=s(n?.rawConfiguration,a?.rawConfiguration),o=[],v=a?.getAllOverrideIdentifiers()||[],m=n?.getAllOverrideIdentifiers()||[];if(n){const h=m.filter($=>!v.includes($));for(const $ of h)o.push([$,n.getKeysForOverrideIdentifier($)])}if(a){const h=v.filter($=>!m.includes($));for(const $ of h)o.push([$,a.getKeysForOverrideIdentifier($)])}if(n&&a){for(const h of v)if(m.includes(h)){const $=s({contents:a.getOverrideValue(void 0,h)||{},keys:a.getKeysForOverrideIdentifier(h)},{contents:n.getOverrideValue(void 0,h)||{},keys:n.getKeysForOverrideIdentifier(h)});o.push([h,[...$.added,...$.removed,...$.updated]])}}return{added:i,removed:t,updated:r,overrides:o}}function s(a,n){const i=a?n?a.keys.filter(o=>n.keys.indexOf(o)===-1):[...a.keys]:[],t=n?a?n.keys.filter(o=>a.keys.indexOf(o)===-1):[...n.keys]:[],r=[];if(a&&n){for(const o of n.keys)if(a.keys.indexOf(o)!==-1){const v=(0,C.$ui)(n.contents,o),m=(0,C.$ui)(a.contents,o);R.$bn(v,m)||r.push(o)}}return{added:i,removed:t,updated:r}}}),define(ae[208],ce([0,1,18,3,2,30,12,74,50,8,57,41]),function(ie,e,I,A,L,j,O,R,S,d,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=void 0;class w extends L.$Rc{constructor(){super(...arguments),this.a=this.B(new A.$Od),this.onDidChangeConfiguration=this.a.event,this.b=new R.$En}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$jn.as(S.$on.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:c})=>this.c(Array.from(p),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(p,c){this.h(p,E.$jn.as(S.$on.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}f(){return{}}g(){this.b=new R.$En;const p=E.$jn.as(S.$on.Configuration).getConfigurationProperties();this.h(Object.keys(p),p)}h(p,c){const f=this.f();for(const u of p){const b=f[u],k=c[u];b!==void 0?this.b.addValue(u,b):k?this.b.addValue(u,k.default):this.b.removeValue(u)}}}e.$Kn=w;class l{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new R.$En}async initialize(){return this.configurationModel}}e.$Ln=l;let g=class extends L.$Rc{get configurationModel(){return this.b}constructor(p,c,f){super(),this.c=p,this.f=c,this.g=f,this.a=this.B(new A.$Od),this.onDidChangeConfiguration=this.a.event,this.b=new R.$En}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const c={},f=[],u=E.$jn.as(S.$on.Configuration).getConfigurationProperties();for(const b of p){const k=u[b];if(!k){f.push(b);continue}if(k.policy){if(k.type!=="string"&&k.type!=="number"){this.g.warn(`Policy ${k.policy.name} has unsupported type ${k.type}`);continue}f.push(b),c[k.policy.name]={type:k.type}}}return(0,O.$Mf)(c)||await this.f.updatePolicyDefinitions(c),f}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const c=E.$jn.as(S.$on.Configuration).getPolicyConfigurations(),f=(0,I.$Gb)(p.map(u=>c.get(u)));this.m(f,!0)}m(p,c){this.g.trace("PolicyConfiguration#update",p);const f=E.$jn.as(S.$on.Configuration).getConfigurationProperties(),u=[],b=this.b.isEmpty();for(const k of p){const s=f[k]?.policy?.name;if(s){const a=this.f.getPolicyValue(s);(b?a!==void 0:!(0,j.$bn)(this.b.getValue(k),a))&&u.push([k,a])}else this.b.getValue(k)!==void 0&&u.push([k,void 0])}if(u.length){this.g.trace("PolicyConfiguration#changed",u);const k=this.b;this.b=new R.$En;for(const s of k.keys)this.b.setValue(s,k.getValue(s));for(const[s,a]of u)a===void 0?this.b.removeValue(s):this.b.setValue(s,a);c&&this.a.fire(this.b)}}};e.$Mn=g,e.$Mn=g=pe([X(1,C.$ln),X(2,d.$aj)],g)}),define(ae[209],ce([0,1,6,3,2,19,20,74,208,57]),function(ie,e,I,A,L,j,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=void 0;class C extends L.$Rc{constructor(w,l,g,y){super(),this.j=w,this.h=this.B(new A.$Od),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new S.$Kn),this.c=g instanceof d.$nn?new S.$Ln:this.B(new S.$Mn(this.b,g,y)),this.f=this.B(new R.$Gn(this.j,{},j.$ng,l)),this.a=new R.$Hn(this.b.configurationModel,this.c.configurationModel,new R.$En,new R.$En),this.g=this.B(new I.$7g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:p,properties:c})=>this.n(p,c))),this.B(this.c.onDidChangeConfiguration(p=>this.r(p))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[w,l,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.$Hn(w,l,new R.$En,g)}getConfigurationData(){return this.a.toData()}getValue(w,l){const g=typeof w=="string"?w:void 0,y=(0,O.$ni)(w)?w:(0,O.$ni)(l)?l:{};return this.a.getValue(g,y,void 0)}updateValue(w,l,g,y){return Promise.reject(new Error("not supported"))}inspect(w){return this.a.inspect(w,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const w=await this.f.loadConfiguration();this.m(w)}m(w){const l=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration(w);this.s(g,l,2)}n(w,l){const g=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(w,l);this.s(y,g,7)}r(w){const l=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration(w);this.s(g,l,7)}s(w,l,g){const y=new R.$Jn(w,{data:l},this.a);y.source=g,y.sourceConfig=this.t(g),this.h.fire(y)}t(w){switch(w){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Nn=C}),define(ae[210],ce([0,1,15,3,2,67]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4pb=e.$3pb=e.$2pb=e.$1pb=void 0;const O=(d,C,E)=>{const w=new Uint8Array(16);for(let y=0;y<16;y++)w[y]=Math.round(Math.random()*256);const l=(0,I.$we)(I.$ce.wrap(w));return[`GET ws://localhost${d}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${l}`].join(`\r
`)+`\r
\r
`};e.$1pb=O,e.$2pb=I.$ce.fromString(`\r
\r
`);async function R(d,C,E,w,l){d.write(I.$ce.fromString((0,e.$1pb)(C,E,w)));const g=new L.$Qc;try{return await new Promise((y,p)=>{let c;g.add(d.onData(f=>{c?c=I.$ce.concat([c,f],c.byteLength+f.byteLength):c=f;const u=c.indexOf(e.$2pb);if(u===-1)return;y(d),d.pauseData();const b=c.slice(u+e.$2pb.byteLength);b.byteLength&&l.onData.fire(b)})),g.add(d.onClose(f=>p(f??new Error("socket closed")))),g.add(d.onEnd(()=>p(new Error("socket ended"))))})}catch(y){throw d.dispose(),y}finally{g.dispose()}}e.$3pb=R;class S extends L.$Rc{constructor(C,E){super(),this.g=C,this.a=this.B(new A.$Rd),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new A.$Od),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(w=>this.a.fire(w))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,E){j.SocketDiagnostics.traceSocketEvent(this,this.g,C,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$4pb=S}),define(ae[211],ce([0,1,7,4]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=e.RemoteAuthorityResolverErrorCode=e.$Uk=e.$Tk=e.RemoteConnectionType=e.$Sk=void 0,e.$Sk=(0,A.$Sh)("remoteAuthorityResolverService");var L;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class j{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$Tk=j;class O{constructor(E,w){this.host=E,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Uk=O;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class S extends I.$ab{static isNotAvailable(E){return E instanceof S&&E._code===R.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof S&&E._code===R.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof S&&E._code===R.NoResolverFound}static isInvalidAuthority(E){return E instanceof S&&E._code===R.InvalidAuthority}static isHandled(E){return E instanceof S&&E.isHandled}constructor(E,w=R.Unknown,l){super(E),this._message=E,this._code=w,this._detail=l,this.isHandled=w===R.NotAvailable&&l===!0,Object.setPrototypeOf(this,S.prototype)}}e.$Vk=S;function d(C){const E=C.indexOf("+");return E===-1?C:C.substring(0,E)}e.$Wk=d}),define(ae[75],ce([0,1,23]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=void 0;function A(d){return d.scheme===I.Schemas.vscodeRemote?d.authority:void 0}e.$Xk=A;function L(d){if(!d)return;const C=d.indexOf("+");return C<0?d:d.substr(0,C)}e.$Yk=L;function j(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.$Zk=j;function O(d){const{host:C,port:E}=S(d);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:E}}e.$1k=O;function R(d,C){let{host:E,port:w}=S(d);return typeof w>"u"&&(w=C),{host:E,port:w}}e.$2k=R;function S(d){const C=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const E=d.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const w=d.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:d,port:void 0}}}),define(ae[44],ce([0,1,27,4,75]),function(ie,e,I,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.TargetPlatform=e.ExtensionType=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=void 0,e.$3l="extensions.user.cache",e.$4l="extensions.builtin.cache",e.$5l="undefined_publisher",e.$6l=["ui","workspace","web"];function j(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$7l=j,e.$8l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(O||(e.ExtensionType=O={}));var R;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class S{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,c){if(typeof p>"u"||p===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof p=="string"||typeof c=="string"){const f=typeof p=="string"?p:p.value,u=typeof c=="string"?c:c.value;return I.$3e(f,u)}return p._lower===c._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$9l=S;class d{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const c of p)this.add(c)}add(p){this.c.add(S.toKey(p))}delete(p){return this.c.delete(S.toKey(p))}has(p){return this.c.has(S.toKey(p))}}e.$0l=d;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(S.toKey(p))}get(p){return this.c.get(S.toKey(p))}has(p){return this.c.has(S.toKey(p))}set(p,c){this.c.set(S.toKey(p),c)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$$l=C;function E(y){return w(y)}e.$_l=E;function w(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$am=w;function l(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$bm=l;function g(y,p){if(p){const c=`onResolveRemoteAuthority:${(0,L.$Yk)(p)}`;return!!y.activationEvents?.includes(c)}return!1}e.$cm=g,e.$dm=(0,A.$Sh)("IBuiltinExtensionsScannerService")}),define(ae[212],ce([0,1,2,44,11]),function(ie,e,I,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;class j extends I.$Rc{constructor(R,S,d,C,E){super(),this.a=R,this.b=S,this.c=d,this.f=E,this.B(C.onDidInstallExtensions(w=>this.g(w))),this.B(C.onDidUninstallExtension(w=>this.h(w)))}g(R){for(const S of R)S.local&&this.invalidate(S.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const S of this.a.profiles)this.c.extUri.isEqual(S.extensionsResource,R)&&await this.j(S);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,A.$3l))}catch(S){(0,L.$sk)(S)!==1&&this.f.error(S)}}}e.$Jp=j}),define(ae[213],ce([0,1,6,15,26,7,3,2,100,62,32,67,211,75]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.PersistentConnectionEventType=e.$9k=e.$8k=e.$7k=e.ConnectionType=void 0;const g=30*1e3;var y;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function p(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(z){const P=new L.$Yd;return setTimeout(()=>P.cancel(),z),P.token}function f(z,P){if(z.isCancellationRequested||P.isCancellationRequested)return L.CancellationToken.Cancelled;const T=new L.$Yd;return z.onCancellationRequested(()=>T.cancel()),P.onCancellationRequested(()=>T.cancel()),T.token}class u{get didTimeout(){return this.c==="timedout"}constructor(P){this.c="pending",this.d=new R.$Qc,this.promise=new Promise((T,B)=>{this.f=T,this.g=B}),P.isCancellationRequested?this.h():this.d.add(P.onCancellationRequested(()=>this.h()))}registerDisposable(P){this.c==="pending"?this.d.add(P):P.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const P=new Error("Time limit reached");return P.code="ETIMEDOUT",P.syscall="connect",P}resolve(P){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(P))}reject(P){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(P))}}function b(z,P){const T=new u(P);return T.registerDisposable(z.onControlMessage(B=>{const N=JSON.parse(B.toString()),V=W(N);V?T.reject(V):T.resolve(N)})),T.promise}function k(z,P,T,B,N,V,G,te){const oe=new u(te),ue=d.$Kd.create(!1);return z.info(`Creating a socket (${G})...`),S.mark(`code/willCreateSocket/${V}`),P.connect(T,B,N,G).then(he=>{oe.didTimeout?(S.mark(`code/didCreateSocketError/${V}`),z.info(`Creating a socket (${G}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(S.mark(`code/didCreateSocketOK/${V}`),z.info(`Creating a socket (${G}) was successful after ${ue.elapsed()} ms.`),oe.resolve(he))},he=>{S.mark(`code/didCreateSocketError/${V}`),z.info(`Creating a socket (${G}) returned an error after ${ue.elapsed()} ms.`),z.error(he),oe.reject(he)}),oe.promise}function s(z,P){const T=new u(P);return z.then(B=>{T.didTimeout||T.resolve(B)},B=>{T.didTimeout||T.reject(B)}),T.promise}async function a(z,P,T,B){const N=se(z,P);z.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let V;try{V=await k(z.logService,z.remoteSocketFactoryService,z.connectTo,(0,l.$Zk)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,p(P),`renderer-${p(P)}-${z.reconnectionToken}`,B)}catch(he){throw z.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),z.logService.error(he),he}z.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let G,te;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(V,null),G=z.reconnectionProtocol,te=!1):(G=new E.$Gh({socket:V}),te=!0),z.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const oe=await s(z.signService.createNewMessage((0,C.$fg)()),B),ue={type:"auth",auth:z.connectionToken||"00000000000000000000",data:oe.data};G.sendControl(A.$ce.fromString(JSON.stringify(ue)));try{const he=await b(G,f(B,c(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}if(z.logService.trace(`${N} 4/6. received SignRequest control message.`),!await s(z.signService.validate(oe,he.signedData),B)){const ve=new Error("Refused to connect to unsupported server");throw ve.code="VSCODE_CONNECTION_ERROR",ve}const de=await s(z.signService.sign(he.data),B),we={type:"connectionType",commit:z.commit,signedData:de,desiredConnectionType:P};return T&&(we.args=T),z.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(A.$ce.fromString(JSON.stringify(we))),{protocol:G,ownsProtocol:te}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(z.logService.error(`${N} the handshake timed out. Error:`),z.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${N} received error control message when negotiating connection. Error:`),z.logService.error(he)),te&&J(G),he}}async function n(z,P,T,B){const N=Date.now(),V=se(z,P),{protocol:G,ownsProtocol:te}=await a(z,P,T,B),oe=new u(B);return oe.registerDisposable(G.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),ge=W(he);ge?(z.logService.error(`${V} received error control message when negotiating connection. Error:`),z.logService.error(ge),te&&J(G),oe.reject(ge)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${Z(N)}!`),oe.resolve({protocol:G,firstMessage:he}))})),oe.promise}async function i(z,P){const{protocol:T}=await n(z,1,void 0,P);return{protocol:T}}async function t(z,P,T){const{protocol:B,firstMessage:N}=await n(z,2,P,T),V=N&&N.debugPort;return{protocol:B,debugPort:V}}async function r(z,P,T){const B=Date.now(),N=se(z,3),{protocol:V}=await a(z,3,P,T);return z.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${Z(B)}!`),V}async function o(z,P,T){const{connectTo:B,connectionToken:N}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,connectTo:B,connectionToken:N,reconnectionToken:P,reconnectionProtocol:T,remoteSocketFactoryService:z.remoteSocketFactoryService,signService:z.signService,logService:z.logService}}async function v(z,P,T){return h(z,async B=>{const{protocol:N}=await i(B,L.CancellationToken.None);return new H(z,P,T,B.reconnectionToken,N)})}e.$7k=v;async function m(z,P){return h(z,async T=>{const{protocol:B,debugPort:N}=await t(T,P,L.CancellationToken.None);return new Q(z,P,T.reconnectionToken,B,N)})}e.$8k=m;async function h(z,P){for(let B=1;;B++)try{const N=(0,C.$fg)(),V=await o(z,N,null);return await P(V)}catch(N){if(B<5)z.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(N);else throw z.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(N),x.triggerPermanentFailure(0,0,w.$Vk.isHandled(N)),N}}async function $(z,P,T){const B=await o(z,(0,C.$fg)(),null);return await r(B,{host:P,port:T},L.CancellationToken.None)}e.$9k=$;function D(z){return(0,I.$Ig)(P=>new Promise((T,B)=>{const N=setTimeout(T,z*1e3);P.onCancellationRequested(()=>{clearTimeout(N),T()})}))}var F;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class M{constructor(P,T){this.reconnectionToken=P,this.millisSinceLastIncomingData=T,this.type=0}}e.$0k=M;class U{constructor(P,T,B,N){this.reconnectionToken=P,this.millisSinceLastIncomingData=T,this.durationSeconds=B,this.c=N,this.type=1}skipWait(){this.c.cancel()}}e.$$k=U;class q{constructor(P,T,B){this.reconnectionToken=P,this.millisSinceLastIncomingData=T,this.attempt=B,this.type=2}}e.$_k=q;class Y{constructor(P,T,B){this.reconnectionToken=P,this.millisSinceLastIncomingData=T,this.attempt=B,this.type=4}}e.$al=Y;class K{constructor(P,T,B,N){this.reconnectionToken=P,this.millisSinceLastIncomingData=T,this.attempt=B,this.handled=N,this.type=3}}e.$bl=K;class x extends R.$Rc{static triggerPermanentFailure(P,T,B){this._permanentFailure=!0,this.f=P,this.g=T,this.h=B,this.j.forEach(N=>N.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(P=>P.y())}static debugPauseSocketWriting(){this.j.forEach(P=>P.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(P,T,B,N,V){super(),this.t=P,this.u=T,this.reconnectionToken=B,this.protocol=N,this.w=V,this.m=this.B(new O.$Od),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Y(this.reconnectionToken,0,0)),this.B(N.onSocketClose(G=>{const te=_(this.t,this.reconnectionToken,!0);G?G.type===0?(this.u.logService.info(`${te} received socket close event (hadError: ${G.hadError}).`),G.error&&this.u.logService.error(G.error)):(this.u.logService.info(`${te} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this.u.logService.error(G.event)):this.u.logService.info(`${te} received socket close event.`),this.y()})),this.B(N.onSocketTimeout(G=>{const te=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${te} received socket timeout event (unacknowledgedMsgCount: ${G.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${G.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${G.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,R.$Pc)(()=>{const G=x.j.indexOf(this);G>=0&&x.j.splice(G,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const P=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${P} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const N=B<T.length?T[B]:T[T.length-1];try{if(N>0){const G=D(N);this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,G)),this.u.logService.info(`${P} waiting for ${N} seconds before reconnecting...`);try{await G}catch{}}if(this.n){this.u.logService.error(`${P} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${P} resolving connection...`);const V=await o(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${P} connecting to ${V.connectTo}...`),await this.G(V,c(g)),this.u.logService.info(`${P} reconnected!`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${P} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${P} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(w.$Vk.isTemporarilyNotAvailable(V)){this.u.logService.info(`${P} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this.u.logService.info(`${P} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if((0,j.$3)(V)){this.u.logService.info(`${P} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(V);continue}if(V instanceof w.$Vk){this.u.logService.error(`${P} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,w.$Vk.isHandled(V));break}this.u.logService.error(`${P} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(V),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(P,T,B){this.w?x.triggerPermanentFailure(P,T,B):this.D(P,T,B)}D(P,T,B){this.m.fire(new K(this.reconnectionToken,P,T,B)),J(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$cl=x;class H extends x{constructor(P,T,B,N,V){super(1,P,N,V,!0),this.client=this.B(new E.$Eh(V,{remoteAuthority:T,clientId:B},P.ipcLogger))}async G(P,T){await i(P,T)}}e.$dl=H;class Q extends x{constructor(P,T,B,N,V){super(2,P,B,N,!1),this.H=T,this.debugPort=V}async G(P,T){await t(P,this.H,T)}}e.$el=Q;function J(z){try{z.acceptDisconnect();const P=z.getSocket();z.dispose(),P.dispose()}catch(P){(0,j.$Z)(P)}}function W(z){if(z&&z.type==="error"){const P=new Error(`Connection error: ${z.reason}`);return P.code="VSCODE_CONNECTION_ERROR",P}return null}function ee(z,P){for(;z.length<P;)z+=" ";return z}function ne(z,P){return`[remote-connection][${ee(p(z),13)}][${P.substr(0,5)}\u2026]`}function _(z,P,T){return`${ne(z,P)}[${T?"reconnect":"initial"}]`}function se(z,P){return`${_(P,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.connectTo}]`}function Z(z){return`${Date.now()-z} ms`}}),define(ae[104],ce([0,1,2,4]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=void 0,e.$3k=(0,A.$Sh)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(O,R){return this.a[O]??=[],this.a[O].push(R),(0,I.$Pc)(()=>{const S=this.a[O]?.indexOf(R);typeof S=="number"&&S>=0&&this.a[O]?.splice(S,1)})}b(O){return(this.a[O.type]||[]).find(S=>S.supports(O))}connect(O,R,S,d){const C=this.b(O);if(!C)throw new Error(`No socket factory found for ${O}`);return C.connect(O,R,S,d)}}e.$4k=L}),define(ae[214],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$49b=e.$39b=void 0,e.$39b=(0,I.$Sh)("sharedProcessTunnelService"),e.$49b="sharedProcessTunnel"}),define(ae[105],ce([0,1,4,163]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b0b=e.$a0b=e.$_9b=e.$$9b=e.$09b=e.TunnelStates=e.$99b=e.$89b=void 0,e.$89b=(0,I.$Sh)("IRemoteTunnelService"),e.$99b={active:!1};var L;(function(j){j.disconnected=O=>({type:"disconnected",onTokenFailed:O}),j.connected=(O,R)=>({type:"connected",info:O,serviceInstallFailed:R}),j.connecting=O=>({type:"connecting",progress:O}),j.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.$09b="remote.tunnels.access",e.$$9b=e.$09b+".hostNameOverride",e.$_9b=e.$09b+".preventSleep",e.$a0b="remoteTunnelService",e.$b0b=(0,A.localize)(0,null)}),define(ae[58],ce([0,1,15,7,2,165,50,4,8,41]),function(ie,e,I,A,L,j,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=void 0,e.$Vo=(0,R.$Sh)("requestService");class C{constructor(k){this.b=k}toJSON(){if(!this.a){const k=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?k[s]="*****":k[s]=this.b[s];this.a=k}return this.a}}class E extends L.$Rc{constructor(k){super(),this.b=0,this.a=k.createLogger("network",{name:(0,j.localize)(0,null),when:S.$rj.isEqualTo((0,S.$pj)(S.LogLevel.Trace)).serialize()})}async c(k,s,a){const n=`${k} #${++this.b}: ${s.url}`;this.a.trace(`${n} - begin`,s.type,new C(s.headers??{}));try{const i=await a();return this.a.trace(`${n} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,s.type,(0,A.$9)(i)),i}}}e.$Wo=E;function w(b){return b.res.statusCode&&b.res.statusCode>=200&&b.res.statusCode<300||b.res.statusCode===1223}e.$Xo=w;function l(b){return b.res.statusCode===204}e.$Yo=l;async function g(b){return l(b)?null:(await(0,I.$oe)(b.stream)).toString()}e.$Zo=g;async function y(b){if(!w(b))throw new Error("Server returned "+b.res.statusCode);return g(b)}e.$1o=y;async function p(b){if(!w(b))throw new Error("Server returned "+b.res.statusCode);if(l(b))return null;const s=(await(0,I.$oe)(b.stream)).toString();try{return JSON.parse(s)}catch(a){throw a.message+=`:
`+s,a}}e.$2o=p;function c(b){u(b)}e.$3o=c;let f;function u(b){const k=d.$jn.as(O.$on.Configuration),s=f;f={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:b,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},k.updateConfigurations({add:[f],remove:s?[s]:[]})}u(1)}),define(ae[215],ce([0,1,26,23,11,58]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9N=void 0;let O=class{constructor(S,d){this.a=S,this.b=d}async download(S,d,C=I.CancellationToken.None){if(S.scheme===A.Schemas.file||S.scheme===A.Schemas.vscodeRemote){await this.b.copy(S,d);return}const E={type:"GET",url:S.toString(!0)},w=await this.a.request(E,C);if(w.res.statusCode===200)await this.b.writeFile(d,w.stream);else{const l=await(0,j.$1o)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${l}`)}}};e.$9N=O,e.$9N=O=pe([X(0,j.$Vo),X(1,L.$bk)],O)}),define(ae[216],ce([0,1,15,26]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;class L{constructor(R){this.a=R}listen(R,S){throw new Error("Invalid listen")}call(R,S,d,C=A.CancellationToken.None){switch(S){case"request":return this.a.request(d[0],C).then(async({res:E,stream:w})=>{const l=await(0,I.$oe)(w);return[{statusCode:E.statusCode,headers:E.headers},l]});case"resolveProxy":return this.a.resolveProxy(d[0])}throw new Error("Invalid call")}}e.$Yq=L;class j{constructor(R){this.a=R}async request(R,S){const[d,C]=await this.a.call("request",[R],S);return{res:d,stream:(0,I.$qe)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.$Zq=j}),define(ae[217],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v8b=e.$u8b=e.$t8b=void 0,e.$t8b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$u8b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$v8b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[218],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n4b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const j=await this.c();if(j){const O=String(I.a++);return this.b.set(O,j),{id:O,data:j.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,j){if(!L.id)return!0;const O=this.b.get(L.id);if(!O)return!1;this.b.delete(L.id);try{return O.validate(j)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$n4b=I}),define(ae[106],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=e.$5k=void 0,e.$5k="signService",e.$6k=(0,I.$Sh)(e.$5k)}),define(ae[219],ce([0,1,218]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j9b=void 0;class A extends I.$n4b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(O=>new O.signer().sign(j))}h(){return new Promise((j,O)=>ie(["vsda"],j,O))}}e.$j9b=A}),define(ae[76],ce([0,1,3,2]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3Db=e.$2Db=e.$1Db=e.$ZDb=void 0;class L extends A.$Rc{constructor(E,w,l){super(),this.a=E,this.b=w,this.c=l}async getItems(){const E={profile:this.b,workspace:this.c},w=await this.a.call("getItems",E);return new Map(w)}updateItems(E){const w={profile:this.b,workspace:this.c};return E.insert&&(w.insert=Array.from(E.insert.entries())),E.delete&&(w.delete=Array.from(E.delete.values())),this.a.call("updateItems",w)}optimize(){const E={profile:this.b,workspace:this.c};return this.a.call("optimize",E)}}class j extends L{constructor(E,w){super(E,w,void 0),this.f=this.B(new I.$Od),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class O extends j{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.$ZDb=O;class R extends j{constructor(E,w){super(E,w)}async close(){this.dispose()}}e.$1Db=R;class S extends L{constructor(E,w){super(E,void 0,w),this.onDidChangeItemsExternal=I.Event.None}async close(){this.dispose()}}e.$2Db=S;class d{constructor(E){this.a=E}isUsed(E){const w={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",w)}}e.$3Db=d}),define(ae[107],ce([0,1,5,37,32]),function(ie,e,I,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=void 0;function j(S){if(I.$u===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function O(S,d,C,E,w,l,g,y,p){const c=Object.create(null);c["common.machineId"]=l,c["common.sqmId"]=g,c.sessionID=(0,L.$fg)()+Date.now(),c.commitHash=E,c.version=w,c["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,I.$h)(I.$u),c["common.nodePlatform"]=A.$cc,c["common.nodeArch"]=C,c["common.product"]=p||"desktop",y&&(c["common.msftInternal"]=y);let f=0;const u=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),I.$l&&(c["common.snap"]="true");const b=j(d);return b&&(c["common.platformDetail"]=b),c}e.$ko=O;function R(S){const d=A.env.USERDNSDOMAIN;if(!d)return!1;const C=d.toLowerCase();return S.some(E=>C===E)}e.$lo=R}),define(ae[22],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=void 0,e.$fl=(0,I.$Sh)("telemetryService"),e.$gl=(0,I.$Sh)("customEndpointTelemetryService"),e.$hl="telemetry.currentSessionDate",e.$il="telemetry.firstSessionDate",e.$jl="telemetry.lastSessionDate",e.$kl="telemetry.machineId",e.$ll="telemetry.sqmId",e.$ml="telemetry",e.$nl="telemetry.telemetryLevel",e.$ol="telemetry.enableCrashReporter",e.$pl="telemetry.enableTelemetry";var A;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var L;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ae[220],ce([0,1,36,6,35,23,16,5,10,142,31,145,95,11,25,22]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=e.$Ir=e.$Hr=e.$Gr=void 0;const p=new Map;async function c(s,a){const n=`${s}::${a.join(":")}`,i=p.get(n);if(i)return i;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,o=new Map,v=2e4;function m($,D,F,M){const U=D.substring($.length+1);return A.Promises.withAsyncBody(async q=>{let Y;try{Y=await C.Promises.readdir(D,{withFileTypes:!0})}catch{q();return}if(M.count>=v){M.count+=Y.length,M.maxReached=!0,q();return}let K=Y.length;if(K===0){q();return}let x=Y;M.count+Y.length>v&&(M.maxReached=!0,K=v-M.count,x=Y.slice(0,K)),M.count+=Y.length;for(const H of x)if(H.isDirectory()){if(F.includes(H.name)||await m($,(0,O.$ic)(D,H.name),F,M),--K===0){q();return}}else{const Q=H.name.lastIndexOf(".");if(Q>=0){const J=H.name.substring(Q+1);J&&r.set(J,(r.get(J)??0)+1)}for(const J of t)J.relativePathPattern?.test(U)!==!1&&J.filePattern.test(H.name)&&o.set(J.tag,(o.get(J.tag)??0)+1);if(--K===0){q();return}}})}const h=A.Promises.withAsyncBody(async $=>{const D={count:0,maxReached:!1};await m(s,s,a,D);const F=await b(s);$({configFiles:f(o),fileTypes:f(r),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:F})});return p.set(n,h),h}e.$Gr=c;function f(s){return Array.from(s.entries(),([a,n])=>({name:a,count:n})).sort((a,n)=>n.count-a.count)}function u(){const s={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/l.$Jk.GB).toFixed(2)}GB (${(I.freemem()/l.$Jk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.$Um.value()*100)}%`},a=I.cpus();return a&&a.length>0&&(s.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),s}e.$Hr=u;async function b(s){try{const a=new Map,n=(0,O.$ic)(s,".vscode","launch.json"),i=await C.Promises.readFile(n),t=[],r=(0,L.$Zm)(i.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,L.$9m)(r)==="object"&&r.configurations)for(const o of r.configurations){const v=o.type;v&&(a.has(v)?a.set(v,a.get(v)+1):a.set(v,1))}return f(a)}catch{return[]}}e.$Ir=b;let k=class{constructor(a,n){this.c=a,this.d=n}f(a){const n=[];return n.push(`OS Version:       ${a.os}`),n.push(`CPUs:             ${a.cpus}`),n.push(`Memory (System):  ${a.memory}`),n.push(`VM:               ${a.vmHint}`),n.join(`
`)}g(a){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const i=I.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(I.totalmem()/l.$Jk.GB).toFixed(2)}GB (${(I.freemem()/l.$Jk.GB).toFixed(2)}GB free)`),R.$i||n.push(`Load (avg):       ${I.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(d.$Um.value()*100)}%`),n.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${a.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(a,n){return Promise.all([(0,E.$Fr)(a.mainPID),this.k(a)]).then(async i=>{let[t,r]=i,o=this.m(a,t);return n.forEach(v=>{if((0,w.$um)(v))o+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(o+=`

Remote: ${v.hostName}`,v.processes&&(o+=`
${this.m(a,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const m of Object.keys(v.workspaceMetadata)){const h=v.workspaceMetadata[m];let $=`${h.fileCount} files`;h.maxFilesReached&&($=`more than ${$}`),r+=`|    Folder (${m}): ${$}`,r+=this.h(h)}}}),{processInfo:o,workspaceInfo:r}})}async getSystemInfo(a,n){const{memory:i,vmHint:t,os:r,cpus:o}=u(),v={os:r,memory:i,cpus:o,vmHint:t,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:n};return R.$i||(v.load=`${I.loadavg().map(m=>Math.round(m)).join(", ")}`),R.$k&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(a,n){const i=[];return(0,E.$Fr)(a.mainPID).then(async t=>(i.push(""),i.push(this.g(a)),i.push(""),i.push(this.m(a,t)),a.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(a))),n.forEach(r=>{if((0,w.$um)(r))i.push(`
${r.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${r.hostName}`),i.push(this.f(r.machineInfo)),r.processes&&i.push(this.m(a,r.processes)),r.workspaceMetadata)for(const o of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[o];let m=`${v.fileCount} files`;v.maxFilesReached&&(m=`more than ${m}`),i.push(`Folder (${o}): ${m}`),i.push(this.h(v))}}),i.push(""),i.push(""),i.join(`
`)))}h(a){const n=[];let t=0;const r=(h,$)=>{const D=` ${h}(${$})`;t+D.length>60?(n.push(o),o="|                 ",t=o.length):t+=D.length,o+=D};let o="|      File types:";const v=10,m=a.fileTypes.length>v?v:a.fileTypes.length;for(let h=0;h<m;h++){const $=a.fileTypes[h];r($.name,$.count)}if(n.push(o),a.configFiles.length>=0&&(o="|      Conf files:",t=0,a.configFiles.forEach(h=>{r(h.name,h.count)}),n.push(o)),a.launchConfigFiles.length>0){let h="|      Launch Configs:";a.launchConfigFiles.forEach($=>{const D=$.count>1?` ${$.name}(${$.count})`:` ${$.name}`;h+=D}),n.push(h)}return n.join(`
`)}j(a){const n=Math.max(...Object.keys(a).map(i=>i.length));return Object.keys(a).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${a[i]}`).join(`
                  `)}k(a){const n=[],i=[];return a.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const o=S.URI.revive(r);if(o.scheme===j.Schemas.file){const v=o.fsPath;i.push(c(v,["node_modules",".git"]).then(m=>{let h=`${m.fileCount} files`;m.maxFilesReached&&(h=`more than ${h}`),n.push(`|    Folder (${(0,O.$mc)(v)}): ${h}`),n.push(this.h(m))}).catch(m=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${m.toString()})`)}))}else n.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(a,n){const i=new Map;a.windows.forEach(r=>i.set(r.pid,`window [${r.id}] (${r.title})`)),a.pidToNames.forEach(({pid:r,name:o})=>i.set(r,o));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(a.mainPID,i,t,n,0),t.join(`
`)}n(a,n,i,t,r){const o=r===0;let v;o?v=t.pid===a?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const m=process.platform==="win32"?t.mem:I.totalmem()*(t.mem/100);i.push(`${t.load.toFixed(0).padStart(5," ")}	${(m/l.$Jk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(h=>this.n(a,n,i,h,r+1))}async getWorkspaceFileExtensions(a){const n=new Set;for(const{uri:i}of a.folders){const t=S.URI.revive(i);if(t.scheme!==j.Schemas.file)continue;const r=t.fsPath;try{(await c(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(a){for(const{uri:n}of a.folders){const i=S.URI.revive(n);if(i.scheme!==j.Schemas.file)continue;const t=i.fsPath;try{const r=await c(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),r.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})}),r.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};e.$Jr=k,e.$Jr=k=pe([X(0,y.$fl),X(1,g.$sj)],k)}),define(ae[108],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z8b=e.$y8b=void 0;class I{constructor(j){this.b=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,{eventName:R,data:S}){return this.b.forEach(d=>d.log(R,S)),Promise.resolve(null)}}e.$y8b=I;class A{constructor(j){this.b=j}log(j,O){return this.b.call("log",{eventName:j,data:O}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$z8b=A}),define(ae[45],ce([0,1,30,12,3,20,75,107,22]),function(ie,e,I,A,L,j,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0;class d{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$mo=d;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$no=C,e.$oo=new C;class E{async publicLog(t,r,o){}async publicLogError(t,r,o){}}e.$po=E,e.$qo="telemetry",e.$ro="extensionTelemetryLog",e.$so={log:()=>null,flush:()=>Promise.resolve(null)};function w(i,t){return L.Event.debounce(t.onDidChangeConfiguration,(o,v)=>{const m=o?new Set([...o.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:m}},1e3,!0)(o=>{o.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,j.$pi)(o.source),configurationKeys:Array.from(o.affectedKeys)})})}e.$to=w;function l(i,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!i.enableTelemetry)}e.$uo=l;function g(i,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$vo=g;function y(i){const t=i.getValue(S.$nl),r=i.getValue(S.$ol);if(i.getValue(S.$pl)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$wo=y;function p(i){const t={},r={},o={};u(i,o);for(let v in o){v=v.length>150?v.substr(v.length-149):v;const m=o[v];typeof m=="number"?r[v]=m:typeof m=="boolean"?r[v]=m?1:0:typeof m=="string"?(m.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${m.length}`),t[v]=m.substring(0,8191)):typeof m<"u"&&m!==null&&(t[v]=m)}return{properties:t,measurements:r}}e.$xo=p;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(i){if(!i)return"none";const t=(0,O.$Yk)(i);return c.has(t)?t:"other"}e.$yo=f;function u(i,t,r=0,o){if(i)for(const v of Object.getOwnPropertyNames(i)){const m=i[v],h=o?o+v:v;Array.isArray(m)?t[h]=(0,I.$cn)(m):m instanceof Date?t[h]=m.toISOString():(0,A.$Bf)(m)?r<2?u(m,t,r+1,h+"."):t[h]=(0,I.$cn)(m):t[h]=m}}function b(i,t){const r=i.msftInternalDomains||[],o=t.getValue("telemetry.internalTesting");return(0,R.$lo)(r)||o}e.$zo=b;function k(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Ao=k;function s(i,t){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const o=[];for(const $ of t)for(;;){const D=$.exec(i);if(!D)break;o.push([D.index,$.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(r="";;){const $=m.exec(i);if(!$)break;const D=o.some(([F,M])=>$.index<M&&F<m.lastIndex);!v.test($[0])&&!D&&(r+=i.substring(h,$.index)+"<REDACTED: user-file-path>",h=m.lastIndex)}return h<i.length&&(r+=i.substr(h)),r}function a(i){if(!i)return i;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function n(i,t){return(0,I.$_m)(i,r=>{if(r instanceof d||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let o=r.replaceAll("%20"," ");o=s(o,t);for(const v of t)o=o.replace(v,"");return o=a(o),o}})}e.$Bo=n}),define(ae[33],ce([0,1,27,29,44,5,10,7,37,45]),function(ie,e,I,A,L,j,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0;function C(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,I.$Xe)(n.id,i.id)===0}e.$Co=C;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(i){const t=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new w(i.identifier,t,r)}static parse(i){const t=E.exec(i);return t&&t[1]&&t[2]?new w({id:t[1]},t[2],t[4]||void 0):null}constructor(i,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof w?C(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Do=w;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(n){const i=l.exec(n);return i&&i[1]?[p(i[1]),i[2]]:[p(n),void 0]}e.$Eo=g;function y(n,i){return`${n}.${i}`}e.$Fo=y;function p(n){return n.toLowerCase()}e.$Go=p;function c(n,i){return p(y(n??L.$5l,i))}e.$Ho=c;function f(n,i){const t=[],r=o=>{for(const v of t)if(v.some(m=>C(i(m),i(o))))return v;return null};for(const o of n){const v=r(o);v?v.push(o):t.push([o])}return t}e.$Io=f;function u(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$Jo=u;function b(n){return{id:new d.$mo(n.identifier.id),name:new d.$mo(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Ko=b,e.$Lo=new L.$9l("pprice.better-merge");function k(n,i){const t=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const o=r.shift();if(o&&t.every(v=>!C(v.identifier,{id:o}))){const v=n.filter(m=>C(m.identifier,{id:o}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$Mo=k;async function s(n,i){if(!j.$k)return!1;let t;try{t=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){i.debug("Error while getting the os-release file.",(0,R.$9)(o))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(n,i){const t=await s(n,i),r=(0,A.$9n)(t?"alpine":j.$u,S.$dc);return i.debug("ComputeTargetPlatform:",r),r}e.$No=a}),define(ae[221],ce([0,1,18,2,19,10,11,25,6,3,16,5,37,33]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u6b=e.$t6b=void 0;let g=class extends A.$Rc{constructor(u,b){super(),this.b=u,this.c=b,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,k])=>this.a.set(k.configPath,k))}getConfigBasedTips(u){return this.f(u)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(u){const b=[];for(const[k,s]of this.a)if(!(s.configScheme&&s.configScheme!==u.scheme))try{const a=(await this.b.readFile((0,L.$wg)(u,k))).value.toString();for(const[n,i]of Object.entries(s.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(a))&&b.push({extensionId:n,extensionName:i.name,configName:s.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return b}};e.$t6b=g,e.$t6b=g=pe([X(0,O.$bk),X(1,R.$sj)],g);const y="extensionTips/promptedExecutableTips",p="extensionTips/lastPromptedMediumImpExeTime";class c extends g{constructor(u,b,k,s,a,n,i,t){super(i,t),this.r=u,this.s=b,this.t=k,this.u=s,this.w=a,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,o])=>{const v=[],m=[],h=[];Object.entries(o.recommendations).forEach(([$,D])=>{D.important?o.important?v.push({extensionId:$,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):m.push({extensionId:$,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):h.push({extensionId:$,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:v}),m.length&&this.h.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:m}),h.length&&this.j.set(r,{exeFriendlyName:o.friendlyName,windowsPath:o.windowsPath,recommendations:h})}),(0,S.$Wg)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const u=await this.O(this.g),b=await this.O(this.h);return[...u,...b]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const u=await this.O(this.g),b=await this.O(this.h),k=await this.u.getInstalled();this.m=this.D(u,k),this.n=this.D(b,k)}D(u,b){const k=new Map;u.forEach(t=>k.set(t.extensionId.toLowerCase(),t));const{installed:s,uninstalled:a}=this.N([...k.keys()],b);for(const t of s){const r=k.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of a){const r=k.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),i=new Map;for(const t of a){const r=k.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let o=i.get(r.exeName);o||(o=[],i.set(r.exeName,o)),o.push(r)}}return i}F(){if(this.m.size===0)return;const[u,b]=[...this.m.entries()][0];this.H(b).then(k=>{switch(k){case"reacted":this.M(b[0].exeName,b);break;case"ignored":this.m.delete(u);break;case"incompatibleWindow":{const s=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.F()));break}case"toomany":{const s=this.B(new A.$Sc);s.value=(0,S.$Wg)(()=>{s.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const u=this.I(),b=Date.now()-u,k=7*24*60*60*1e3;if(b<k){const n=this.B(new A.$Sc);n.value=(0,S.$Wg)(()=>{n.dispose(),this.G()},k-b);return}const[s,a]=[...this.n.entries()][0];this.H(a).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(s),this.M(a[0].exeName,a);const i=this.B(new A.$Sc);i.value=(0,S.$Wg)(()=>{i.dispose(),this.G()},k);break}case"ignored":this.n.delete(s),this.G();break;case"incompatibleWindow":{const i=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.G()));break}case"toomany":{const i=this.B(new A.$Sc);i.value=(0,S.$Wg)(()=>{i.dispose(),this.G()},60*60*1e3);break}}})}async H(u){const b=await this.u.getInstalled(1),k=u.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(a=>b.every(n=>!(0,l.$Co)(n.identifier,{id:a})))).map(({extensionId:s})=>s.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:k,source:3,name:u[0].exeFriendlyName,searchValue:`@exe:"${u[0].exeName}"`})}I(){let u=this.w.getNumber(p,-1);return u||(u=Date.now(),this.J(u)),u}J(u){this.w.store(p,u,-1,1)}L(){return JSON.parse(this.w.get(y,-1,"{}"))}M(u,b){const k=this.L();k[u]=b.map(({extensionId:s})=>s.toLowerCase()),this.w.store(y,JSON.stringify(k),-1,0)}N(u,b){const k=[],s=[],a=b.reduce((n,i)=>(n.add(i.identifier.id.toLowerCase()),n),new Set);return u.forEach(n=>{a.has(n.toLowerCase())?k.push(n):s.push(n)}),{installed:k,uninstalled:s}}async O(u){const b=[],k=new Map;for(const s of u.keys()){const a=u.get(s);if(!a||!(0,I.$Kb)(a.recommendations))continue;const n=[];E.$i?a.windowsPath&&n.push(a.windowsPath.replace("%USERPROFILE%",()=>w.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>w.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>w.env.ProgramFiles).replace("%APPDATA%",()=>w.env.APPDATA).replace("%WINDIR%",()=>w.env.WINDIR)):(n.push((0,C.$ic)("/usr/local/bin",s)),n.push((0,C.$ic)("/usr/bin",s)),n.push((0,C.$ic)(this.r.fsPath,s)));for(const i of n){let t=k.get(i);if(t===void 0&&(t=await this.b.exists(j.URI.file(i)),k.set(i,t)),t)for(const{extensionId:r,extensionName:o,isExtensionPack:v,whenNotInstalled:m}of a.recommendations)b.push({extensionId:r,extensionName:o,isExtensionPack:v,exeName:s,exeFriendlyName:a.exeFriendlyName,windowsPath:a.windowsPath,whenNotInstalled:m})}}return b}}e.$u6b=c}),define(ae[222],ce([0,1,26,33]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TWb=void 0;async function L(j,O,R,S,d){try{const C=await j.getExtensionsControlManifest();if(!C.deprecated)return;const E=await j.getInstalled(1);for(const[w,l]of Object.entries(C.deprecated)){if(!l?.extension)continue;const{id:g,autoMigrate:y,preRelease:p}=l.extension;if(!y)continue;const c=E.find(u=>(0,A.$Co)(u.identifier,{id:w}));if(!c)continue;const f=(await O.getExtensions([{id:g,preRelease:p}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},I.CancellationToken.None))[0];if(!f){d.info(`Skipping migrating '${c.identifier.id}' extension because, the comaptible target '${g}' extension is not found`);continue}try{d.info(`Migrating '${c.identifier.id}' extension to '${g}' extension...`);const u=!S.getDisabledExtensions().some(k=>(0,A.$Co)(k,c.identifier));await j.uninstall(c),d.info(`Uninstalled the unsupported extension '${c.identifier.id}'`);let b=E.find(k=>(0,A.$Co)(k.identifier,{id:g}));(!b||!b.isPreReleaseVersion&&u)&&(b=await j.installFromGallery(f,{installPreReleaseVersion:!0,isMachineScoped:c.isMachineScoped,operation:4}),d.info(`Installed the pre-release extension '${b.identifier.id}'`),u||(await S.disableExtension(b.identifier),d.info(`Disabled the pre-release extension '${b.identifier.id}' because the unsupported extension '${c.identifier.id}' is disabled`)),y.storage&&(R.addToMigrationList((0,A.$Fo)(c.manifest.publisher,c.manifest.name),(0,A.$Fo)(b.manifest.publisher,b.manifest.name)),d.info("Added pre-release extension to the storage migration list"))),d.info(`Migrated '${c.identifier.id}' extension to '${g}' extension.`)}catch(u){d.error(u)}}}catch(C){d.error(C)}}e.$TWb=L}),define(ae[223],ce([0,1,3,2,34,33,44]),function(ie,e,I,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;class R extends A.$Rc{constructor(d,C,E,w,l,g,y){super(),this.f=d,this.g=C,this.h=E,this.j=w,this.m=l,this.n=g,this.r=y,this.a=this.B(new I.$Od),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.$Zc),this.s().then(null,p=>y.error(p))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(d=>this.u(d.added))),this.B(this.j.onAddExtensions(d=>this.w(d))),this.B(this.j.onDidAddExtensions(d=>this.y(d))),this.B(this.j.onRemoveExtensions(d=>this.z(d))),this.B(this.j.onDidRemoveExtensions(d=>this.C(d))),this.B(this.n.onDidFilesChange(d=>this.D(d)))}async u(d){try{d.length&&await Promise.all(d.map(C=>(this.c.set(C.id,(0,A.$Oc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(d){for(const C of d.extensions)this.I(this.L(C.identifier,C.version),d.profileLocation)}async y(d){for(const C of d.extensions){const E=this.L(C.identifier,C.version);d.error?this.J(E,d.profileLocation):this.I(E,d.profileLocation)}}async z(d){for(const C of d.extensions)this.J(this.L(C.identifier,C.version),d.profileLocation)}async C(d){const C=[],E=[];for(const w of d.extensions){const l=this.L(w.identifier,w.version);d.error?this.I(l,d.profileLocation):(this.J(l,d.profileLocation),this.b.has(l)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),E.push(this.f.scanInstalledExtensionAtLocation(w.location).then(g=>{g?C.push(g):this.r.info("Extension not found at the location",w.location.toString())},g=>this.r.error(g)))))}try{await Promise.all(E),C.length&&await this.H(C)}catch(w){this.r.error(w)}}D(d){for(const C of this.h.profiles)d.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(d){const C=[],E=[],w=await this.j.scanProfileExtensions(d),l=new Set,g=new Set;for(const[y,p]of this.b)p.has(d)&&g.add(y);for(const y of w){const p=this.L(y.identifier,y.version);l.add(p),g.has(p)||(C.push(y.identifier),this.I(p,d))}for(const y of g)if(!l.has(y)){const p=this.M(y);p&&(E.push(p.identifier),this.J(y,d))}(C.length||E.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:d}:void 0,removed:E.length?{extensions:E,profileLocation:d}:void 0})}async G(d){const C=await this.j.scanProfileExtensions(d);for(const E of C)this.I(this.L(E.identifier,E.version),d)}async H(d){d||(d=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),d.length&&await this.f.markAsUninstalled(...d)}I(d,C){let E=this.b.get(d);E||this.b.set(d,E=new L.$Ac(w=>this.m.extUri.getComparisonKey(w))),E.add(C)}J(d,C){const E=this.b.get(d);E&&E.delete(C),E?.size||this.b.delete(d)}L(d,C){return`${O.$9l.toKey(d.id)}@${C}`}M(d){const[C,E]=(0,j.$Eo)(d);return E?{identifier:{id:C},version:E}:void 0}}e.$Kp=R}),define(ae[224],ce([0,1,43,45]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0;async function L(j,O,R,S,d,C,E){const w={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${O.nameShort})`};if((0,A.$uo)(O,R)&&(0,A.$wo)(S)===3){const l=await(0,I.$cp)(R,d,C);w["X-Market-User-Id"]=l,w["VSCode-SessionId"]=E.machineId||l}return w}e.$dp=L}),define(ae[225],ce([0,1,71,18,6,2,23,16,31,14,29,33,8,73,10]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;let y=class extends l.$Wq{constructor(u,b,k,s){super(k),this.h=u,this.j=s,this.g=this.B(new p(b,s)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(u,b){const s=(await this.g.getLanguagePacks())[b];if(!s){this.j.warn(`No language pack found for ${b}`);return}const a=s.translations[u];return a?g.URI.file(a):void 0}async getInstalledLanguages(){const u=await this.g.getLanguagePacks(),b=Object.keys(u).map(k=>{const s=u[k];return{...this.f(k,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return b.push(this.f("en","English")),b.sort((k,s)=>k.label.localeCompare(s.label)),b}async m(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",u.identifier.id),await this.update())}async n(u){const b=await this.g.getLanguagePacks();Object.keys(b).some(k=>b[k]&&b[k].extensions.some(s=>(0,E.$Co)(s.extensionIdentifier,u.identifier)))&&(this.j.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,b]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),k=await this.g.update(b);return!(0,A.$tb)(Object.keys(u),Object.keys(k))}};e.$Xq=y,e.$Xq=y=pe([X(0,C.$co),X(1,d.$1h),X(2,C.$ao),X(3,w.$aj)],y);let p=class extends j.$Rc{constructor(u,b){super(),this.j=b,this.c={},this.f=(0,R.$ic)(u.userDataPath,"languagepacks.json"),this.g=new L.$2g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(u){return this.s(b=>{Object.keys(b).forEach(k=>delete b[k]),this.m(b,...u)}).then(()=>this.c)}m(u,...b){for(const k of b)k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&this.n(u,k);Object.keys(u).forEach(k=>this.r(u[k]))}n(u,b){const k=b.identifier,s=b.manifest.contributes&&b.manifest.contributes.localizations?b.manifest.contributes.localizations:[];for(const a of s)if(b.location.scheme===O.Schemas.file&&c(a)){let n=u[a.languageId];n||(n={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},u[a.languageId]=n);const i=n.extensions.filter(t=>(0,E.$Co)(t.extensionIdentifier,k))[0];i?i.version=b.manifest.version:n.extensions.push({extensionIdentifier:k,version:b.manifest.version});for(const t of a.translations)n.translations[t.id]=(0,R.$ic)(b.location.fsPath,t.path)}}r(u){if(u){const b=(0,I.createHash)("md5");for(const k of u.extensions)b.update(k.extensionIdentifier.uuid||k.extensionIdentifier.id).update(k.version);u.hash=b.digest("hex")}}s(u=()=>null){return this.g.queue(()=>{let b=null;return S.Promises.readFile(this.f,"utf8").then(void 0,k=>k.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(k)).then(k=>{try{return JSON.parse(k)}catch{return{}}}).then(k=>(b=u(k),k)).then(k=>{for(const a of Object.keys(k))k[a]||delete k[a];this.c=k,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),S.Promises.writeFile(this.f,s)}).then(()=>b,k=>this.j.error(k))})}};p=pe([X(0,d.$1h),X(1,w.$aj)],p);function c(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const u of f.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ae[226],ce([0,1,141,7,30,45]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GN=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function S(C,E,w){const l=await(0,I.$KC)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,I.$KC)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new l.AppInsightsCore,p=new g.PostChannel,c={instrumentationKey:C,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(w){c.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:w};c.extensionConfig[p.identifier]=f}return y.initialize(c,[]),y.addTelemetryInitializer(f=>{E&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),y}class d{constructor(E,w,l,g,y){this.e=E,this.f=w,this.g=l,this.h=y,this.c=O,this.d=R,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(w=>{E(w)},w=>{(0,A.$Z)(w),console.error(w)})}}log(E,w){if(!this.a)return;w=(0,L.$an)(w,this.g),w=(0,j.$xo)(w);const l=this.f+"/"+E;try{this.i(g=>{g.pluginVersionString=w?.properties.version??"Unknown",g.track({name:l,baseData:{name:l,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$GN=d}),define(ae[109],ce([0,1,2,166,14,8,25,45]),function(ie,e,I,A,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U5b=void 0;let S=class extends I.$Rc{constructor(C,E,w,l,g=""){super(),this.b=g;const y=E.getLogger(R.$qo);if(y)this.a=this.B(y);else{const c=(0,R.$vo)(l,w)?" (Not Sent)":"",f=()=>(0,R.$uo)(l,w)&&C.getLevel()===j.LogLevel.Trace;this.a=this.B(E.createLogger(R.$qo,{name:(0,A.localize)(0,null,c),hidden:!f()})),this.B(C.onDidChangeLogLevel(()=>E.setVisibility(R.$qo,f()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,E){this.a.trace(`${this.b}telemetry/${C}`,(0,R.$xo)(E))}};e.$U5b=S,e.$U5b=S=pe([X(0,j.$aj),X(1,j.$bj),X(2,L.$Zh),X(3,O.$sj)],S)}),define(ae[110],ce([0,1,2,30,5,27,167,20,50,102,25,41,22,45]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,f,u){this.k=f,this.l=u,this.d={},this.i=new I.$Qc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const b of this.f)this.j.push(new RegExp((0,j.$Ge)(b),"gi")),b.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$Ge)(b.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(b=>{(b.affectsConfiguration(w.$nl)||b.affectsConfiguration(w.$pl)||b.affectsConfiguration(w.$ol))&&this.m()}))}setExperimentProperty(c,f){this.d[c]=f}m(){let c=(0,l.$wo)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const u=f.usage?3:f.error?2:0;c=Math.min(c,u)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,f,u){this.g<f||(u=(0,A.$an)(u,this.d),u=(0,l.$Bo)(u,this.j),u=(0,A.$an)(u,this.c),this.b.forEach(b=>b.log(c,u)))}publicLog(c,f){this.n(c,3,f)}publicLog2(c,f){this.publicLog(c,f)}publicLogError(c,f){this.h&&this.n(c,2,f)}publicLogError2(c,f){this.publicLogError(c,f)}};e.$4q=g,e.$4q=g=pe([X(1,R.$mi),X(2,C.$sj)],g);function y(){const p=(0,O.localize)(0,null,d.default.nameLong),c=d.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=L.$o?"":(0,O.localize)(3,null),u=(0,O.localize)(4,null),b=(0,O.localize)(5,null),k=(0,O.localize)(6,null),s=(0,O.localize)(7,null),a=`
|       | ${u} | ${b} | ${k} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${p} ${c} ${f}

&nbsp;

${s}
${a}

&nbsp;

${n}
`}E.$jn.as(S.$on.Configuration).registerConfiguration({id:w.$ml,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[w.$nl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$jn.as(S.$on.Configuration).registerConfiguration({id:w.$ml,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[w.$pl]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,O.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,O.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${w.$nl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[227],ce([0,1,15,26,271,226]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=void 0;async function O(C,E){const w=await E.request(C,A.CancellationToken.None),l=(await(0,I.$oe)(w.stream)).toString(),g=w.res.statusCode??200;return{headers:w.res.headers,statusCode:g,responseData:l}}async function R(C){const E={method:C.type,headers:C.headers};return new Promise((l,g)=>{const y=L.request(C.url??"",E,p=>{p.on("data",function(c){l({headers:p.headers,statusCode:p.statusCode??200,responseData:c.toString()})}),p.on("error",function(c){g(c)})});y.write(C.data,p=>{p&&g(p)}),y.end()})}async function S(C,E,w){const l=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),g={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:l};try{const y=C?await O(g,C):await R(g);w(y.statusCode,y.headers,y.responseData)}catch{w(0,{})}}class d extends j.$GN{constructor(E,w,l,g,y){const p={sendPOST:(c,f)=>{S(E,c,f)}};super(w,l,g,y,p)}}e.$HN=d}),define(ae[228],ce([0,1,23,93,20,14,8,25,22,108,109,110]),function(ie,e,I,A,L,j,O,R,S,d,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R9b=void 0;let w=class{constructor(g,y,p,c,f,u){this.b=g,this.c=y,this.d=p,this.e=c,this.f=f,this.g=u,this.a=new Map}h(g){if(!this.a.has(g.id)){const y=Object.create(null);y["common.vscodemachineid"]=this.c.machineId,y["common.vscodesessionid"]=this.c.sessionId;const p=[g.id,JSON.stringify(y),g.aiKey],f=new A.$6p(I.$dg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:p,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),u=[new d.$z8b(f),new C.$U5b(this.d,this.e,this.f,this.g,`[${g.id}] `)];this.a.set(g.id,new E.$4q({appenders:u,sendErrorTelemetry:g.sendErrorTelemetry},this.b,this.g))}return this.a.get(g.id)}publicLog(g,y,p){this.h(g).publicLog(y,p)}publicLogError(g,y,p){this.h(g).publicLogError(y,p)}};e.$R9b=w,e.$R9b=w=pe([X(0,L.$mi),X(1,S.$fl),X(2,O.$aj),X(3,O.$bj),X(4,j.$Zh),X(5,R.$sj)],w)}),define(ae[77],ce([0,1,3,20,4,8]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.ProvidedOnAutoForward=e.$cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$bv=e.$av=void 0,e.$av=(0,L.$Sh)("tunnelService"),e.$bv=(0,L.$Sh)("sharedTunnelsService");var O;(function(p){p.Http="http",p.Https="https"})(O||(e.TunnelProtocol=O={}));var R;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(R||(e.TunnelPrivacyId=R={}));function S(p){return!!p.forwardPort}e.$cv=S;var d;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function C(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(c)return{address:c[1],port:+c[2]}}e.$dv=C,e.$ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(p){return e.$ev.indexOf(p)>=0}e.$fv=E,e.$gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(p){return e.$gv.indexOf(p)>=0}e.$hv=w;function l(p,c,f,u){if(f===1)return!1;if(f===2&&w(c)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(b?.length===4&&parseInt(b[1])>=18)return!1}return p<1024}e.$iv=l;class g{constructor(c,f,u){this.remoteAddress=c,this.localAddress=f,this.b=u,this.a=new I.$Od,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$jv=g;let y=class{constructor(c,f){this.j=c,this.k=f,this.a=new I.$Od,this.onTunnelOpened=this.a.event,this.b=new I.$Od,this.onTunnelClosed=this.b.event,this.c=new I.$Od,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const c=this.k.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.f=c,c?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.g=c.elevation,this.h=c.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const c=[],f=Array.from(this.e.values());for(const u of f){const b=Array.from(u.values());for(const k of b){const s=await k.value;s&&typeof s!="string"&&c.push(s)}}return c}async dispose(){for(const c of this.e.values()){for(const{value:f}of c.values())await f.then(u=>typeof u!="string"?u?.dispose():void 0);c.clear()}this.e.clear()}setEnvironmentTunnel(c,f,u,b,k){this.p(c,f,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:f,localAddress:u,privacy:b,protocol:k,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,f){(w(c)||E(c))&&(c=e.$ev[0]);const u=this.r(c,f);if(u)return++u.refcount,u.value}openTunnel(c,f,u,b,k,s=!1,a,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${u} on local port ${k}.`);const i=this.f??c;if(!i)return;if(f||(f="localhost"),b||(b=this.l),this.f&&this.i.has(u)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.s(i,f,u,b,k,s,a,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(f,u),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(f,u);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.n(r);return(r.tunnelRemoteHost!==f||r.tunnelRemotePort!==u)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&r.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(o),o}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}n(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const f=this.e.get(c.tunnelRemoteHost);if(f){const u=f.get(c.tunnelRemotePort);u&&(u.refcount--,await this.o(c.tunnelRemoteHost,c.tunnelRemotePort,u))}}}}async o(c,f,u){if(u.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${f}.`);const b=u.value.then(async k=>{k&&typeof k!="string"&&(await k.dispose(!0),this.b.fire({host:k.tunnelRemoteHost,port:k.tunnelRemotePort}))});return this.e.has(c)&&this.e.get(c).delete(f),b}}async closeTunnel(c,f){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${f} `);const u=this.e.get(c);if(u&&u.has(f)){const b=u.get(f);b.refcount=0,await this.o(c,f,b)}}p(c,f,u){this.e.has(c)||this.e.set(c,new Map),this.e.get(c).set(f,{refcount:1,value:u})}async q(c,f){const u=this.e.get(c);if(u){const b=u.get(f),k=b?await b.value:void 0;(!k||typeof k=="string")&&u.delete(f),u.size===0&&this.e.delete(c)}}r(c,f){const u=[c];E(c)?(u.push(...e.$ev),u.push(...e.$gv)):w(c)&&u.push(...e.$gv);const b=u.map(k=>this.e.get(k));for(const k of b){const s=k?.get(f);if(s)return s}}canTunnel(c){return!!C(c)}t(c,f,u,b,k,s,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${u} on local port ${b}.`);const n=u;this.i.add(n);const i=b===void 0?u:b,t={elevationRequired:k?this.isPortPrivileged(i):!1},r={remoteAddress:{host:f,port:u},localAddressPort:b,privacy:s,public:s?s!==R.Private:void 0,protocol:a},o=c.forwardPort(r,t);return o?(this.p(f,u,o),o.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),o}};e.$kv=y,e.$kv=y=pe([X(0,j.$aj),X(1,A.$mi)],y)}),define(ae[229],ce([0,1,8,77,2,7,6]),function(ie,e,I,A,L,j,O){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$59b=void 0;class S extends L.$Rc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$fh),this.b.p)}setAddress(E){this.a=E,this.b&&(this.b.complete(E),this.b=null)}setTunnel(E){this.B(E)}}let d=class extends L.$Rc{static{R=this}static{this.a=0}constructor(E,w){super(),this.f=E,this.g=w,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(E,w,l,g,y,p,c){const f=new S,u=await Promise.resolve(this.f.openTunnel(E,f,l,g,y,p,c));if(!u||typeof u=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${l}:${g} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this.c.has(w))throw this.c.delete(w),f.dispose(),await u.dispose(),(0,j.$5)();return f.setTunnel(u),this.b.set(w,f),this.g.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${u.localAddress} (local) to ${l}:${g} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(E,w){const l=this.b.get(E);l&&l.setAddress(w)}async destroyTunnel(E){const w=this.b.get(E);if(w){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this.b.delete(E),await w.dispose();return}this.c.add(E)}};e.$59b=d,e.$59b=d=R=pe([X(0,A.$bv),X(1,I.$aj)],d)}),define(ae[28],ce([0,1,4]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=void 0,e.$Lk=(0,I.$Sh)("IUriIdentityService")}),define(ae[230],ce([0,1,28,184,11,19,127,3,2]),function(ie,e,I,A,L,j,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;class d{static{this._clock=0}constructor(w){this.uri=w,this.time=d._clock++}touch(){return this.time=d._clock++,this}}let C=class{constructor(w){this.g=w,this.c=new S.$Qc,this.f=2**16;const l=new Map,g=y=>{let p=l.get(y.scheme);return p===void 0&&(p=w.hasProvider(y)&&!this.g.hasCapability(y,1024),l.set(y.scheme,p)),p};this.c.add(R.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(y=>{l.delete(y.scheme)})),this.extUri=new j.$lg(g),this.d=new O.$Br((y,p)=>this.extUri.compare(y,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,j.$xg)(w));const l=this.d.get(w);return l?l.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new d(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((g,y)=>g[1].time<y[1].time?1:g[1].time>y[1].time?-1:0);d._clock=0,this.d.clear();const l=this.f*.5;for(let g=0;g<l;g++)this.d.set(w[g][0],w[g][1].touch())}};e.$Cr=C,e.$Cr=C=pe([X(0,L.$bk)],C),(0,A.$zr)(I.$Lk,C,1)}),define(ae[231],ce([0,1,3,2,11,47,34]),function(ie,e,I,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m9b=void 0;class R extends A.$Rc{constructor(d,C,E,w,l,g){super(),this.f=d,this.g=C,this.h=E,this.j=w,this.m=l,this.n=g,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new I.$Od),this.onDidChangeFile=this.a.event,this.b=j.$Yh.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Ac(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B(w.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const d of this.j.profiles)this.c.add(d.settingsResource),this.c.add(d.keybindingsResource),this.c.add(d.tasksResource),this.c.add(d.extensionsResource)}open(d,C){return this.g.open(this.t(d),C)}close(d){return this.g.close(d)}read(d,C,E,w,l){return this.g.read(d,C,E,w,l)}write(d,C,E,w,l){return this.g.write(d,C,E,w,l)}watch(d,C){this.b.set(d,d);const E=this.g.watch(this.t(d),C);return(0,A.$Pc)(()=>{this.b.delete(d),E.dispose()})}stat(d){return this.g.stat(this.t(d))}mkdir(d){return this.g.mkdir(this.t(d))}rename(d,C,E){return this.g.rename(this.t(d),this.t(C),E)}readFile(d,C){return this.g.readFile(this.t(d),C)}readFileStream(d,C,E){return this.g.readFileStream(this.t(d),C,E)}readdir(d){return this.g.readdir(this.t(d))}enforceAtomicReadFile(d){return this.c.has(d)}writeFile(d,C,E){return this.g.writeFile(this.t(d),C,E)}enforceAtomicWriteFile(d){return this.c.has(d)?{postfix:".vsctmp"}:!1}delete(d,C){return this.g.delete(this.t(d),C)}copy(d,C,E){if((0,L.$fk)(this.g))return this.g.copy(this.t(d),this.t(C),E);throw new Error("copy not supported")}cloneFile(d,C){if((0,L.$gk)(this.g))return this.g.cloneFile(this.t(d),this.t(C));throw new Error("clone not supported")}s(d){const C=[];for(const E of d){if(E.resource.scheme!==this.f)continue;const w=this.u(E.resource);this.b.findSubstr(w)&&C.push({resource:w,type:E.type,cId:E.cId})}C.length&&(this.n.debug("User data changed"),this.a.fire(C))}t(d){return d.with({scheme:this.f})}u(d){return d.with({scheme:this.h})}}e.$m9b=R}),define(ae[78],ce([0,1,86]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GDb=e.$FDb=e.edit=void 0;function A(O,R,S,d){const C=(0,I.$sT)(O,R,S,d)[0];return C&&(O=O.substring(0,C.offset)+C.content+O.substring(C.offset+C.length)),O}e.edit=A;function L(O,R,S){let d=S;for(;d>=0;){if(O.charAt(d)===R.charAt(R.length-1)&&R.length===1)return d+1;if(d--,R.length===2&&d>=0&&O.charAt(d)===R.charAt(0))return d+2}return 0}e.$FDb=L;function j(O,R,S){let d=S;for(;d>=0;)if(O.charAt(d)===R.charAt(R.length-1)&&R.length===1||(d++,R.length===2&&d>=0&&O.charAt(d)===R.charAt(1)))return d;return O.length-1}e.$GDb=j}),define(ae[232],ce([0,1,30,54,12]),function(ie,e,I,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B4b=void 0;function j(l,g,y,p,c,f){const u=[],b=[],k=[];if(!g){const q=l.filter(({identifier:Y})=>c.every(K=>K.toLowerCase()!==Y.id.toLowerCase()));return{local:{added:u,removed:b,updated:k},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}l=l.map(E),g=g.map(E),y=y?y.map(E):null;const s=new Map,a=q=>{q.uuid&&s.set(q.id.toLowerCase(),q.uuid)};l.forEach(({identifier:q})=>a(q)),g.forEach(({identifier:q})=>a(q)),y?.forEach(({identifier:q})=>a(q)),p?.forEach(({identifier:q})=>a(q)),f?.forEach(q=>a(q));const n=q=>{const Y=q.identifier.uuid||s.get(q.identifier.id.toLowerCase());return Y?`uuid:${Y}`:`id:${q.identifier.id.toLowerCase()}`},i=(q,Y)=>(q.set(n(Y),Y),q),t=l.reduce(i,new Map),r=g.reduce(i,new Map),o=g.reduce((q,Y)=>i(q,(0,I.$0m)(Y)),new Map),v=y?y.reduce(i,new Map):null,m=p.reduce(i,new Map),h=c.reduce((q,Y)=>{const K=s.get(Y.toLowerCase());return q.add(K?`uuid:${K}`:`id:${Y.toLowerCase()}`)},new Set),$=f?f.reduce((q,{id:Y,uuid:K})=>(K=K??s.get(Y.toLowerCase()),q.add(K?`uuid:${K}`:`id:${Y.toLowerCase()}`)),new Set):null,D=O(t,r,h,!1);if(D.added.size>0||D.removed.size>0||D.updated.size>0){const q=O(v,t,h,!1),Y=O(v,r,h,!0),K=(x,H,Q,J)=>{let W,ee,ne;return H.installed?(W=J.pinned,ne=J.preRelease,W&&(ee=J.version)):(W=Q.pinned,ne=Q.preRelease,W&&(ee=Q.version)),W===void 0&&(W=H.pinned,W&&(ee=H.version)),ne===void 0&&(ne=H.preRelease),{...J,installed:H.installed||Q.installed,pinned:W,preRelease:ne,version:ee??(Q.version&&(!H.installed||A.gt(Q.version,H.version))?Q.version:H.version),state:S(H,Q,v?.get(x))}};for(const x of Y.removed.values()){const H=t.get(x);if(!H)continue;const Q=(0,L.$Kf)(v?.get(x)),J=$&&!$.has(x)&&Q.installed;H.installed&&J?b.push(H.identifier):o.set(x,H)}for(const x of Y.added.values()){const H=(0,L.$Kf)(r.get(x)),Q=t.get(x);if(Q){if(D.updated.has(x)){const J=K(x,Q,H,H);R(Q,H,!1,!1)||k.push(w(J,x)),o.set(x,J)}}else H.installed&&u.push(w(H,x))}for(const x of Y.updated.values()){const H=(0,L.$Kf)(r.get(x)),Q=(0,L.$Kf)(v?.get(x)),J=t.get(x);if(J)if($&&!$.has(x)&&Q.installed&&J.installed&&!H.installed)b.push(J.identifier);else{const ee=K(x,J,H,H);k.push(w(ee,x)),o.set(x,ee)}else H.installed&&u.push(w(H,x))}for(const x of q.added.values())Y.added.has(x)||o.set(x,(0,L.$Kf)(t.get(x)));for(const x of q.updated.values()){if(Y.removed.has(x)||Y.updated.has(x))continue;const H=(0,L.$Kf)(t.get(x)),Q=(0,L.$Kf)(r.get(x));o.set(x,K(x,H,Q,H))}for(const x of q.removed.values())Y.updated.has(x)||Y.removed.has(x)||m.has(x)||(0,L.$Kf)(r.get(x)).installed&&$&&($.has(x)||!(0,L.$Kf)(v?.get(x)).installed||o.delete(x))}const F=[],M=O(r,o,new Set,!0),U=M.added.size>0||M.updated.size>0||M.removed.size>0;return U&&o.forEach((q,Y)=>F.push(w(q,Y))),{local:{added:u,removed:b,updated:k},remote:U?{added:[...M.added].map(q=>o.get(q)),updated:[...M.updated].map(q=>o.get(q)),removed:[...M.removed].map(q=>r.get(q)),all:F}:null}}e.$B4b=j;function O(l,g,y,p){const c=l?[...l.keys()].filter(s=>!y.has(s)):[],f=[...g.keys()].filter(s=>!y.has(s)),u=f.filter(s=>!c.includes(s)).reduce((s,a)=>(s.add(a),s),new Set),b=c.filter(s=>!f.includes(s)).reduce((s,a)=>(s.add(a),s),new Set),k=new Set;for(const s of c){if(b.has(s))continue;const a=l.get(s),n=g.get(s);(!n||!R(a,n,p,!0))&&k.add(s)}return{added:u,removed:b,updated:k}}function R(l,g,y,p){return!(l.disabled!==g.disabled||!!l.isApplicationScoped!=!!g.isApplicationScoped||p&&l.installed!==g.installed||l.installed&&g.installed&&(l.preRelease!==g.preRelease||l.pinned!==g.pinned||g.pinned&&l.version!==g.version)||!C(l.state,g.state)||y&&l.version!==g.version)}function S(l,g,y){const p=l.state,c=g.state,f=y?.state;if(!g.version||p&&A.gt(l.version,g.version))return p;if(c&&A.gt(g.version,l.version)||!p)return c;if(!c)return p;const u=(0,I.$0m)(p),b=f?d(f,c):{added:Object.keys(c).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set},k=f?d(f,p):{added:Object.keys(p).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set};for(const s of[...b.added.values(),...b.updated.values()])u[s]=c[s];for(const s of b.removed.values())k.updated.has(s)||delete u[s];return u}function d(l,g){const y=Object.keys(l),p=Object.keys(g),c=p.filter(b=>!y.includes(b)).reduce((b,k)=>(b.add(k),b),new Set),f=y.filter(b=>!p.includes(b)).reduce((b,k)=>(b.add(k),b),new Set),u=new Set;for(const b of y){if(f.has(b))continue;const k=l[b],s=g[b];(0,I.$bn)(k,s)||u.add(b)}return{added:c,removed:f,updated:u}}function C(l={},g={}){const{added:y,removed:p,updated:c}=d(l,g);return y.size===0&&p.size===0&&c.size===0}function E(l){return{...l,disabled:!!l.disabled,installed:!!l.installed}}function w(l,g){const y={...l,identifier:{id:l.identifier.id,uuid:g.startsWith("uuid:")?g.substring(5):void 0},preRelease:!!l.preRelease,pinned:!!l.pinned};return l.disabled||delete y.disabled,l.installed||delete y.installed,l.state||delete y.state,l.isApplicationScoped||delete y.isApplicationScoped,y}}),define(ae[111],ce([0,1,18,20,4]),function(ie,e,I,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DFb=e.$CFb=void 0,e.$CFb=(0,L.$Sh)("IIgnoredExtensionsManagementService");let j=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,S){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return d=d.filter(C=>C!==R&&C!==`-${R}`),S&&d.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}updateSynchronizedExtensions(R,S){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return d=d.filter(C=>C!==R&&C!==`-${R}`),S&&d.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}getIgnoredExtensions(R){const S=R.filter(w=>w.isMachineScoped).map(w=>w.identifier.id.toLowerCase()),d=this.b().map(w=>w.toLowerCase()),C=[],E=[];if(Array.isArray(d))for(const w of d)w.startsWith("-")?E.push(w.substring(1)):C.push(w);return(0,I.$Lb)([...S,...C].filter(w=>!E.includes(w)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};e.$DFb=j,e.$DFb=j=pe([X(0,A.$mi)],j)}),define(ae[233],ce([0,1,18,35,30,94,78]),function(ie,e,I,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H4b=void 0;function R(b){return(0,A.$Zm)(b)||[]}async function S(b,k,s,a,n){const i=R(b),t=R(k),r=s?R(s):null,o=[...i,...t,...r||[]].map(K=>K.key),v=await n.resolveUserBindings(o),m=C(i,t,r,v);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:b,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:k,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:b,hasChanges:!0,hasConflicts:!1};const h=w(i),$=w(t),D=r?w(r):null,F=g(h,$,v),M=D?g(D,h,v):{added:[...h.keys()].reduce((K,x)=>(K.add(x),K),new Set),removed:new Set,updated:new Set},U=D?g(D,$,v):{added:[...$.keys()].reduce((K,x)=>(K.add(x),K),new Set),removed:new Set,updated:new Set},q=d(F,M,U);let Y=b;for(const K of q.removed.values())q.conflicts.has(K)||(Y=f(Y,K,a));for(const K of q.added.values()){if(q.conflicts.has(K))continue;const x=$.get(K);if(x.some(H=>H.command!==`-${K}`&&m.conflicts.has(v[H.key]))){q.conflicts.add(K);continue}Y=c(Y,x,a)}for(const K of q.updated.values()){if(q.conflicts.has(K))continue;const x=$.get(K);if(x.some(H=>H.command!==`-${K}`&&m.conflicts.has(v[H.key]))){q.conflicts.add(K);continue}Y=u(Y,K,x,a)}return{mergeContent:Y,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.$H4b=S;function d(b,k,s){const a=new Set,n=new Set,i=new Set,t=new Set;for(const r of k.removed.values())s.updated.has(r)&&t.add(r);for(const r of s.removed.values())t.has(r)||(k.updated.has(r)?t.add(r):n.add(r));for(const r of k.added.values())t.has(r)||s.added.has(r)&&b.updated.has(r)&&t.add(r);for(const r of s.added.values())t.has(r)||(k.added.has(r)?b.updated.has(r)&&t.add(r):a.add(r));for(const r of k.updated.values())t.has(r)||s.updated.has(r)&&b.updated.has(r)&&t.add(r);for(const r of s.updated.values())t.has(r)||(k.updated.has(r)?b.updated.has(r)&&t.add(r):i.add(r));return{added:a,removed:n,updated:i,conflicts:t}}function C(b,k,s,a){const n=new Set,i=E(b,a),t=E(k,a),r=s?E(s,a):null,o=l(i,t);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?l(r,i):{added:[...i.keys()].reduce((M,U)=>(M.add(U),M),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const m=r?l(r,t):{added:[...t.keys()].reduce((M,U)=>(M.add(U),M),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:h,removed:$,updated:D,conflicts:F}=d(o,v,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:h,removed:$,updated:D,conflicts:F}}function E(b,k){const s=new Map;for(const a of b){const n=k[a.key];let i=s.get(n);i||(i=[],s.set(n,i)),i.push(a)}return s}function w(b){const k=new Map;for(const s of b){const a=s.command[0]==="-"?s.command.substring(1):s.command;let n=k.get(a);n||(n=[],k.set(a,n)),n.push(s)}return k}function l(b,k){const s=[...b.keys()],a=[...k.keys()],n=a.filter(r=>!s.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),i=s.filter(r=>!a.includes(r)).reduce((r,o)=>(r.add(o),r),new Set),t=new Set;for(const r of s){if(i.has(r))continue;const o=b.get(r).map(m=>({...m,key:r})),v=k.get(r).map(m=>({...m,key:r}));(0,I.$tb)(o,v,(m,h)=>p(m,h))||t.add(r)}return{added:n,removed:i,updated:t}}function g(b,k,s){const a=[...b.keys()],n=[...k.keys()],i=n.filter(o=>!a.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),t=a.filter(o=>!n.includes(o)).reduce((o,v)=>(o.add(v),o),new Set),r=new Set;for(const o of a){if(t.has(o))continue;const v=b.get(o).map(h=>({...h,key:s[h.key]})),m=k.get(o).map(h=>({...h,key:s[h.key]}));y(v,m)||r.add(o)}return{added:i,removed:t,updated:r}}function y(b,k){return!(!(0,I.$tb)(b.filter(({command:s})=>s[0]!=="-"),k.filter(({command:s})=>s[0]!=="-"),(s,a)=>p(s,a))||!(0,I.$tb)(b.filter(({command:s})=>s[0]==="-"),k.filter(({command:s})=>s[0]==="-"),(s,a)=>p(s,a)))}function p(b,k){if(b.command!==k.command||b.key!==k.key)return!1;const s=j.$Qi.deserialize(b.when),a=j.$Qi.deserialize(k.when);return!(s&&!a||!s&&a||s&&a&&!s.equals(a)||!L.$bn(b.args,k.args))}function c(b,k,s){for(const a of k)b=O.edit(b,[-1],a,s);return b}function f(b,k,s){const a=R(b);for(let n=a.length-1;n>=0;n--)(a[n].command===k||a[n].command===`-${k}`)&&(b=O.edit(b,[n],void 0,s));return b}function u(b,k,s,a){const n=R(b),i=n.findIndex(t=>t.command===k||t.command===`-${k}`);for(let t=n.length-1;t>=0;t--)(n[t].command===k||n[t].command===`-${k}`)&&(b=O.edit(b,[t],void 0,a));for(let t=s.length-1;t>=0;t--)b=O.edit(b,[i],s[t],a);return b}}),define(ae[234],ce([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P4b=e.$O4b=void 0;function I(j,O,R){const S={},d={},C=new Set;if(!O)return{local:{added:S,updated:d,removed:[...C.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const E=A(j,O);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:S,updated:d,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const w=A(R,j),l=A(R,O),g={},y={},p=new Set,c=new Set;for(const f of w.removed.values())l.updated.has(f)?S[f]=O[f]:p.add(f);for(const f of l.removed.values())c.has(f)||(w.updated.has(f)?c.add(f):C.add(f));for(const f of w.updated.values())c.has(f)||(l.updated.has(f)?E.updated.has(f)&&c.add(f):y[f]=j[f]);for(const f of l.updated.values())c.has(f)||(w.updated.has(f)?E.updated.has(f)&&c.add(f):j[f]!==void 0&&(d[f]=O[f]));for(const f of w.added.values())c.has(f)||(l.added.has(f)?E.updated.has(f)&&c.add(f):g[f]=j[f]);for(const f of l.added.values())c.has(f)||(w.added.has(f)?E.updated.has(f)&&c.add(f):S[f]=O[f]);return{local:{added:S,removed:[...C.values()],updated:d},remote:{added:g,removed:[...p.values()],updated:y},conflicts:[...c.values()]}}e.$O4b=I;function A(j,O){const R=j?Object.keys(j):[],S=O?Object.keys(O):[],d=S.filter(w=>!R.includes(w)).reduce((w,l)=>(w.add(l),w),new Set),C=R.filter(w=>!S.includes(w)).reduce((w,l)=>(w.add(l),w),new Set),E=new Set;for(const w of R){if(C.has(w))continue;const l=j[w],g=O[w];l!==g&&E.add(w)}return{added:d,removed:C,updated:E}}function L(j,O){const{added:R,removed:S,updated:d}=A(j,O);return R.size===0&&S.size===0&&d.size===0}e.$P4b=L}),define(ae[235],ce([0,1,30]),function(ie,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x6b=void 0;function A(j,O,R,S){const d={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!O){const w=j.filter(({id:l})=>!S.includes(l));return w.length?C.added=w:C=null,{local:d,remote:C}}const E=L(j,O,S);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const w=L(R,j,S),l=L(R,O,S);for(const g of l.removed){const y=j.find(p=>p.id===g);y&&d.removed.push(y)}for(const g of l.added){const y=O.find(p=>p.id===g);w.added.includes(g)?E.updated.includes(g)&&d.updated.push(y):d.added.push(y)}for(const g of l.updated)d.updated.push(O.find(y=>y.id===g));for(const g of w.added)l.added.includes(g)||C.added.push(j.find(y=>y.id===g));for(const g of w.updated)l.removed.includes(g)||l.updated.includes(g)||C.updated.push(j.find(y=>y.id===g));for(const g of w.removed){const y=O.find(p=>p.id===g);y&&C.removed.push(y)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:d,remote:C}}e.$x6b=A;function L(j,O,R){j=j?j.filter(({id:l})=>!R.includes(l)):[],O=O.filter(({id:l})=>!R.includes(l));const S=j.map(({id:l})=>l),d=O.map(({id:l})=>l),C=d.filter(l=>!S.includes(l)),E=S.filter(l=>!d.includes(l)),w=[];for(const{id:l,name:g,shortName:y,icon:p,useDefaultFlags:c}of j){if(E.includes(l))continue;const f=O.find(u=>u.id===l);(!f||f.name!==g||f.shortName!==y||f.icon!==p||!(0,I.$bn)(f.useDefaultFlags,c))&&w.push(l)}return{added:C,removed:E,updated:w}}}),define(ae[24],ce([0,1,18,12,173,50,29,4,103,41]),function(ie,e,I,A,L,j,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahb=e.$_gb=e.$$gb=e.$0gb=e.$9gb=e.$8gb=e.$7gb=e.$6gb=e.$5gb=e.$4gb=e.$3gb=e.MergeState=e.Change=e.SyncStatus=e.$2gb=e.$1gb=e.$Zgb=e.UserDataSyncErrorCode=e.$Ygb=e.$Xgb=e.$Wgb=e.$Vgb=e.$Ugb=e.$Tgb=e.$Sgb=e.$Rgb=e.$Qgb=e.SyncResource=e.$Pgb=e.$Ogb=e.$Ngb=e.$Mgb=e.$Lgb=e.$Kgb=void 0;function C(){const t=d.$jn.as(j.$on.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$Kgb=C;function E(){const t=d.$jn.as(j.$on.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(m=>!!t[m].ignoreSync),o=Object.keys(t).filter(m=>t[m].scope===2||t[m].scope===6),v=C();return(0,I.$Lb)([...r,...o,...v])}e.$Lgb=E,e.$Mgb="settingsSync",e.$Ngb="settingsSync.keybindingsPerPlatform";function w(){const t="vscode://schemas/ignoredSettings",r=d.$jn.as(j.$on.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{[e.$Ngb]:{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:O.$1n,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=d.$jn.as(S.$kn.JSONContribution),v=()=>{const m=C(),h=E(),$=Object.keys(j.$pn.properties).filter(M=>!h.includes(M)),D=h.filter(M=>!m.includes(M)),F={items:{type:"string",enum:[...$,...D.map(M=>`-${M}`)]}};o.registerSchema(t,F)};return r.onDidUpdateConfiguration(()=>v())}e.$Ogb=w;function l(t){return t&&(0,A.$Bf)(t)&&(0,A.$zf)(t.id)&&Array.isArray(t.scopes)}e.$Pgb=l;var g;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(g||(e.SyncResource=g={})),e.$Qgb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(t,...r){return t?[t,...r]:r}e.$Rgb=y;function p(t,r,o,v){return v.joinPath(o.userDataSyncHome,...y(t,r,`lastSync${r}.json`))}e.$Sgb=p,e.$Tgb=(0,R.$Sh)("IUserDataSyncStoreManagementService"),e.$Ugb=(0,R.$Sh)("IUserDataSyncStoreService"),e.$Vgb=(0,R.$Sh)("IUserDataSyncLocalStoreService"),e.$Wgb="x-operation-id",e.$Xgb="X-Execution-Id";function c(t){const r={};return r[e.$Xgb]=t,r}e.$Ygb=c;var f;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(f||(e.UserDataSyncErrorCode=f={}));class u extends Error{constructor(r,o,v,m){super(r),this.code=o,this.resource=v,this.operationId=m,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Zgb=u;class b extends u{constructor(r,o,v,m,h){super(r,v,void 0,h),this.url=o,this.serverCode=m}}e.$1gb=b;class k extends u{constructor(r,o){super(r,o)}}e.$2gb=k,function(t){function r(o){if(o instanceof t)return o;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(v&&v[1]){const m=v[2]==="unknown"?void 0:v[2],h=v[3]==="unknown"?void 0:v[3];return new t(o.message,v[1],m,h)}return new t(o.message,"Unknown")}t.toUserDataSyncError=r}(u||(e.$Zgb=u={}));var s;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(s||(e.SyncStatus=s={}));var a;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(a||(e.Change=a={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$3gb="sync.store.url.type";function i(t){return`sync.enable.${t}`}e.$4gb=i,e.$5gb=(0,R.$Sh)("IUserDataSyncEnablementService"),e.$6gb=(0,R.$Sh)("IUserDataSyncService"),e.$7gb=(0,R.$Sh)("IUserDataSyncResourceProviderService"),e.$8gb=(0,R.$Sh)("IUserDataAutoSyncService"),e.$9gb=(0,R.$Sh)("IUserDataSyncUtilService"),e.$0gb=(0,R.$Sh)("IUserDataSyncLogService"),e.$$gb="userDataSync",e.$_gb="vscode-userdata-sync",e.$ahb="preview"}),define(ae[236],ce([0,1,30,24]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YEb=void 0;function L(O,R,S,d,C){if(!R)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const E=j(O,R);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const w=S?j(S,R):{added:Object.keys(R).reduce((f,u)=>(f.add(u),f),new Set),removed:new Set,updated:new Set},l=S?j(S,O):{added:Object.keys(O).reduce((f,u)=>(f.add(u),f),new Set),removed:new Set,updated:new Set},g={added:{},removed:[],updated:{}},y=I.$0m(R),p=!S;for(const f of l.added.values())f!==A.$3gb&&p&&w.added.has(f)||(y[f]=O[f]);for(const f of l.updated.values())y[f]=O[f];for(const f of l.removed.values())d.unregistered.includes(f)||delete y[f];for(const f of w.added.values()){const u=R[f];if(d.machine.includes(f)){C.info(`GlobalState: Skipped adding ${f} in local storage because it is declared as machine scoped.`);continue}if(S&&l.added.has(f))continue;const b=O[f];b&&b.value===u.value||f===A.$3gb&&p&&l.added.has(f)||(b?g.updated[f]=u:g.added[f]=u)}for(const f of w.updated.values()){const u=R[f];if(d.machine.includes(f)){C.info(`GlobalState: Skipped updating ${f} in local storage because it is declared as machine scoped.`);continue}if(l.updated.has(f)||l.removed.has(f))continue;const b=O[f];b&&b.value===u.value||(g.updated[f]=u)}for(const f of w.removed.values()){if(d.machine.includes(f)){C.trace(`GlobalState: Skipped removing ${f} in local storage because it is declared as machine scoped.`);continue}l.updated.has(f)||l.removed.has(f)||g.removed.push(f)}const c=j(R,y);return{local:g,remote:{added:[...c.added],updated:[...c.updated],removed:[...c.removed],all:c.added.size===0&&c.removed.size===0&&c.updated.size===0?null:y}}}e.$YEb=L;function j(O,R){const S=Object.keys(O),d=Object.keys(R),C=d.filter(l=>!S.includes(l)).reduce((l,g)=>(l.add(g),l),new Set),E=S.filter(l=>!d.includes(l)).reduce((l,g)=>(l.add(g),l),new Set),w=new Set;for(const l of S){if(E.has(l))continue;const g=O[l],y=R[l];I.$bn(g,y)||w.add(l)}return{added:C,removed:E,updated:w}}}),define(ae[237],ce([0,1,18,35,86,42,30,78,24]),function(ie,e,I,A,L,j,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MDb=e.$LDb=e.$KDb=e.$JDb=e.$IDb=e.$HDb=void 0;function d(o,v,m){let h=[];m?h=E(m):h=C(v);const $=[],D=[...(0,S.$Kgb)()];if(Array.isArray(h))for(const F of h)F.startsWith("-")?D.push(F.substring(1)):$.push(F);return(0,I.$Lb)([...o,...$].filter(F=>!D.includes(F)))}e.$HDb=d;function C(o){let v=o.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=o.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const v=(0,A.$Zm)(o);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function w(o,v){const m=(0,A.$Zm)(o)||{};let h="{}";for(const $ of Object.keys(m)){const D=(0,L.$sT)(h,[$],m[$],v);h=(0,L.$vT)(h,D)}return h}e.$IDb=w;function l(o,v,m,h){if(m.length){const $=r(v),D=(0,A.$Zm)(v)||{},F=(0,A.$Zm)(o);if(!F)return o;const M=[];for(const U of m){const q=D[U],Y=F[U];q===void 0?o=R.edit(o,[U],void 0,h):Y!==void 0?o=R.edit(o,[U],q,h):M.push(s(U,$))}M.sort((U,q)=>U.startOffset-q.startOffset),M.forEach(U=>o=f(U.setting.key,v,o,h))}return o}e.$JDb=l;function g(o,v,m,h,$,D){const F=l(o,v,h,D),M=m!==F,U=m!==v;if(!M&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!U)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(U&&!M)return{conflictsSettings:[],localContent:l(v,o,h,D),remoteContent:null,hasConflicts:!1};if(m===null&&p(o)){const T=y(o,v,h)?null:l(v,o,h,D);return{conflictsSettings:[],localContent:T,remoteContent:null,hasConflicts:!1}}let q=o,Y=v;const K=(0,A.$Zm)(o),x=(0,A.$Zm)(v),H=m?(0,A.$Zm)(m):null,Q=h.reduce((T,B)=>(T.add(B),T),new Set),J=c(K,x,Q),W=c(H,K,Q),ee=c(H,x,Q),ne=new Map,_=new Set,se=T=>{_.add(T);const B=$.filter(({key:N})=>N===T)[0];B?(q=R.edit(q,[T],B.value,D),Y=R.edit(Y,[T],B.value,D)):ne.set(T,{key:T,localValue:K[T],remoteValue:x[T]})};for(const T of W.removed.values())ee.updated.has(T)?se(T):Y=R.edit(Y,[T],void 0,D);for(const T of ee.removed.values())_.has(T)||(W.updated.has(T)?se(T):q=R.edit(q,[T],void 0,D));for(const T of W.updated.values())_.has(T)||(ee.updated.has(T)?J.updated.has(T)&&se(T):Y=R.edit(Y,[T],K[T],D));for(const T of ee.updated.values())_.has(T)||(W.updated.has(T)?J.updated.has(T)&&se(T):q=R.edit(q,[T],x[T],D));for(const T of W.added.values())_.has(T)||(ee.added.has(T)?J.updated.has(T)&&se(T):Y=f(T,q,Y,D));for(const T of ee.added.values())_.has(T)||(W.added.has(T)?J.updated.has(T)&&se(T):q=f(T,Y,q,D));const Z=ne.size>0||!y(q,Y,h),z=Z||!y(q,o,[]),P=Z||!y(Y,v,[]);return{localContent:z?q:null,remoteContent:P?Y:null,conflictsSettings:[...ne.values()],hasConflicts:Z}}e.$KDb=g;function y(o,v,m){if(o===v)return!0;const h=(0,A.$Zm)(o),$=(0,A.$Zm)(v),D=m.reduce((U,q)=>(U.add(q),U),new Set),F=r(o).filter(U=>!(U.setting&&D.has(U.setting.key))),M=r(v).filter(U=>!(U.setting&&D.has(U.setting.key)));if(F.length!==M.length)return!1;for(let U=0;U<F.length;U++){const q=F[U],Y=M[U];if(q.setting&&Y.setting){if(q.setting.key!==Y.setting.key||!O.$bn(h[q.setting.key],$[q.setting.key]))return!1}else if(!q.setting&&!Y.setting){if(q.value!==Y.value)return!1}else return!1}return!0}function p(o){return o?r(o).length===0:!0}e.$LDb=p;function c(o,v,m){const h=o?Object.keys(o).filter(U=>!m.has(U)):[],$=Object.keys(v).filter(U=>!m.has(U)),D=$.filter(U=>!h.includes(U)).reduce((U,q)=>(U.add(q),U),new Set),F=h.filter(U=>!$.includes(U)).reduce((U,q)=>(U.add(q),U),new Set),M=new Set;if(o)for(const U of h){if(F.has(U))continue;const q=o[U],Y=v[U];O.$bn(q,Y)||M.add(U)}return{added:D,removed:F,updated:M}}function f(o,v,m,h){const $=(0,A.$Zm)(v),D=r(v),F=r(m),M=u(o,D,F);return b(m,o,$[o],M,F,h)}e.$MDb=f;function u(o,v,m){const h=v.findIndex(D=>D.setting?.key===o),$=v[h-1];if($){if($.setting){const F=s($.setting.key,m);if(F)return{index:m.indexOf(F),insertAfter:!0}}else{const F=a(h,v);if(F){const M=s(F.setting.key,m);if(M){const U=n(m.indexOf(M),m),q=i(v,F,v[h]);if(U){const Y=i(m,M,U),K=t(q,Y);return K?{index:m.indexOf(K),insertAfter:!0}:{index:m.indexOf(U),insertAfter:!1}}else{const Y=i(m,M,m[m.length-1]),K=t(q,Y);return K?{index:m.indexOf(K),insertAfter:!0}:{index:m.length-1,insertAfter:!0}}}}}const D=v[h+1];if(D)if(D.setting){const F=s(D.setting.key,m);if(F)return{index:m.indexOf(F),insertAfter:!1}}else{const F=n(h,v);if(F){const M=s(F.setting.key,m);if(M){const U=a(m.indexOf(M),m),q=i(v,v[h],F);if(U){const Y=i(m,U,M),K=t(q.reverse(),Y.reverse());return K?{index:m.indexOf(K),insertAfter:!1}:{index:m.indexOf(U),insertAfter:!0}}else{const Y=i(m,m[0],M),K=t(q.reverse(),Y.reverse());return K?{index:m.indexOf(K),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:m.length-1,insertAfter:!0}}function b(o,v,m,h,$,D){let F;return h.index===-1?F=(0,L.$sT)(o,[v],m,D):F=k(o,v,m,h,$,D).map(M=>(0,L.$tT)(o,M,D)[0]),(0,L.$vT)(o,F)}function k(o,v,m,h,$,D){const F=`${JSON.stringify(v)}: ${JSON.stringify(m)}`,M=(0,j.$pT)(D,o),U=$[h.index];if(h.insertAfter){const q=[];if(U.setting)q.push({offset:U.endOffset,length:0,content:","+F});else{const Y=n(h.index,$),K=a(h.index,$),x=K?.setting?.commaOffset;K&&x===void 0&&q.push({offset:K.endOffset,length:0,content:","});const H=x!==void 0&&x>U.endOffset;q.push({offset:H?x+1:U.endOffset,length:0,content:Y?M+F+",":M+F})}return q}else{if(U.setting)return[{offset:U.startOffset,length:0,content:F+","}];const q=($[h.index-1]&&!$[h.index-1].setting?M:"")+F+(n(h.index,$)?",":"")+M;return[{offset:U.startOffset,length:0,content:q}]}}function s(o,v){return v.filter(m=>m.setting?.key===o)[0]}function a(o,v){for(let m=o-1;m>=0;m--)if(v[m].setting)return v[m]}function n(o,v){for(let m=o+1;m<v.length;m++)if(v[m].setting)return v[m]}function i(o,v,m){const h=o.indexOf(v),$=o.indexOf(m);return o.filter((D,F)=>h<F&&F<$)}function t(o,v){if(o.length&&v.length){let m=0;for(;m<v.length&&m<o.length;m++)if(o[m].value!==v[m].value)return v[m-1];return v[m-1]}}function r(o){const v=[];let m=-1,h,$;const D={onObjectBegin:F=>{m++},onObjectProperty:(F,M,U)=>{m===0&&(h=M,$=F)},onObjectEnd:(F,M)=>{m--,m===0&&v.push({startOffset:h,endOffset:F+M,value:o.substring(h,F+M),setting:{key:$,commaOffset:void 0}})},onArrayBegin:(F,M)=>{m++},onArrayEnd:(F,M)=>{m--,m===0&&v.push({startOffset:h,endOffset:F+M,value:o.substring(h,F+M),setting:{key:$,commaOffset:void 0}})},onLiteralValue:(F,M,U)=>{m===0&&v.push({startOffset:h,endOffset:M+U,value:o.substring(h,M+U),setting:{key:$,commaOffset:void 0}})},onSeparator:(F,M,U)=>{if(m===0&&F===","){let q=v.length-1;for(;q>=0&&!v[q].setting;q--);const Y=v[q];Y&&v.splice(q,1,{startOffset:Y.startOffset,endOffset:Y.endOffset,value:Y.value,setting:{key:Y.setting.key,commaOffset:M}})}},onComment:(F,M)=>{m===0&&v.push({startOffset:F,endOffset:F+M,value:o.substring(F,F+M)})}};return(0,A.$7m)(o,D),v}}),define(ae[79],ce([0,1,3,2,4,24]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sDb=e.$rDb=void 0,e.$rDb=(0,L.$Sh)("IUserDataSyncAccountService");let O=class extends A.$Rc{get account(){return this.a}constructor(S,d){super(),this.g=S,this.h=d,this.b=this.B(new I.$Od),this.onDidChangeAccount=this.b.event,this.c=this.B(new I.$Od),this.onTokenFailed=this.c.event,this.f=!1,this.B(S.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(S.onTokenSucceed(()=>this.f=!1))}async updateAccount(S){(S&&this.a?S.token!==this.a.token||S.authenticationProviderId!==this.a.authenticationProviderId:S!==this.a)&&(this.a=S,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(S))}};e.$sDb=O,e.$sDb=O=pe([X(0,j.$Ugb),X(1,j.$0gb)],O)}),define(ae[238],ce([0,1,2,10]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y9b=e.$X9b=e.$W9b=e.$V9b=e.$U9b=e.$T9b=e.$S9b=void 0;class L{constructor(w){this.a=w}listen(w,l){switch(l){case"onError":return this.a.onError}throw new Error(`Event not found: ${l}`)}call(w,l,g){switch(l){case"triggerSync":return this.a.triggerSync(g[0],g[1],g[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(g[0])}throw new Error("Invalid call")}}e.$S9b=L;class j{constructor(w){this.a=w}listen(w,l){throw new Error(`Event not found: ${l}`)}call(w,l,g){switch(l){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(g[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(A.URI.revive(g[0]))}throw new Error("Invalid call")}}e.$T9b=j;class O{constructor(w){this.a=w}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(w){return this.a.call("resolveUserKeybindings",[w])}async resolveFormattingOptions(w){return this.a.call("resolveFormattingOptions",[w])}}e.$U9b=O;class R{constructor(w){this.a=w}listen(w,l){switch(l){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${l}`)}async call(w,l,g){switch(l){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(g[0],g[1]);case"setEnablements":return this.a.setEnablements(g)}throw new Error("Invalid call")}}e.$V9b=R;class S{constructor(w){this.a=w}listen(w,l){switch(l){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${l}`)}call(w,l,g){switch(l){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(g)}throw new Error("Invalid call")}}e.$W9b=S;class d{constructor(w){this.a=w}listen(w,l){switch(l){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${l}`)}call(w,l,g){switch(l){case"switch":return this.a.switch(g[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$X9b=d;class C extends I.$Rc{constructor(w){super(),this.a=w,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(w){return this.a.call("switch",[w])}async getPreviousUserDataSyncStore(){const w=await this.a.call("getPreviousUserDataSyncStore");return this.b(w)}b(w){return{url:A.URI.revive(w.url),type:w.type,defaultUrl:A.URI.revive(w.defaultUrl),insidersUrl:A.URI.revive(w.insidersUrl),stableUrl:A.URI.revive(w.stableUrl),canSwitch:w.canSwitch,authenticationProviders:w.authenticationProviders}}}e.$Y9b=C}),define(ae[239],ce([0,1,19,174,14,8,24]),function(ie,e,I,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EFb=void 0;let R=class extends j.$fj{constructor(d,C){super(),this.g=this.B(d.createLogger((0,I.$wg)(C.logsHome,`${O.$$gb}.log`),{id:O.$$gb,name:(0,A.localize)(0,null)}))}trace(d,...C){this.g.trace(d,...C)}debug(d,...C){this.g.debug(d,...C)}info(d,...C){this.g.info(d,...C)}warn(d,...C){this.g.warn(d,...C)}error(d,...C){this.g.error(d,...C)}flush(){this.g.flush()}};e.$EFb=R,e.$EFb=R=pe([X(0,j.$bj),X(1,L.$Zh)],R)}),define(ae[240],ce([0,1,6,3,2]),function(ie,e,I,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T8b=void 0;class j extends L.$Rc{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:S,getActiveWindowId:d}){super(),this.a=this.B(new L.$Qc),A.Event.latch(A.Event.any(R,S))(this.f,this,this.a),this.b=(0,I.$Ig)(()=>d()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$T8b=j}),define(ae[112],ce([0,1,177,16,47,19,10,4,23]),function(ie,e,I,A,L,j,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.WorkbenchState=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=void 0,e.$2h=(0,R.$Sh)("contextService");function d(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}e.$3h=d;function C(i){return typeof i?.id=="string"&&!d(i)&&!w(i)}e.$4h=C,e.$5h={id:"ext-dev"},e.$6h={id:"empty-window"};function E(i,t){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,A.$mc)(i)}:t?e.$5h:e.$6h;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$7h=E;function w(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}e.$8h=w;function l(i){const t=i;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$9h=l;var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function y(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$0h=y;function p(i){const t=i;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$$h=p;class c{constructor(t,r,o,v,m){this.h=t,this.j=o,this.k=v,this.l=m,this.c=L.$Yh.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=L.$Yh.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$_h=c;class f{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,j.$wg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ai=f;function u(i){return new f({uri:i,index:0,name:(0,j.$sg)(i)},{uri:i.toString()})}e.$bi=u,e.$ci="code-workspace",e.$di=`.${e.$ci}`,e.$ei=[{name:(0,I.localize)(0,null),extensions:[e.$ci]}],e.$fi="workspace.json";function b(i,t){return j.$ng.isEqualOrParent(i,t.untitledWorkspacesHome)}e.$gi=b;function k(i){let t;return O.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===S.Schemas.tmp}e.$hi=k,e.$ii="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$ii}e.$ji=s;function a(i,t){return!b(i,t)&&!k(i)}e.$ki=a;function n(i){return(typeof i=="string"?(0,A.$nc)(i):(0,j.$ug)(i))===e.$di}e.$li=n}),define(ae[17],ce([0,1,52,3,2,19,10,168,14,11,4,8,112,34,28,6,32,27,12]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.ProfileResourceType=void 0;var u;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(u||(e.ProfileResourceType=u={}));function b(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&O.URI.isUri(t.location)&&O.URI.isUri(t.globalStorageHome)&&O.URI.isUri(t.settingsResource)&&O.URI.isUri(t.keybindingsResource)&&O.URI.isUri(t.tasksResource)&&O.URI.isUri(t.snippetsHome)&&O.URI.isUri(t.extensionsResource))}e.$Mk=b,e.$Nk=(0,C.$Sh)("IUserDataProfilesService");function k(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:O.URI.revive(i.location).with({scheme:t}),globalStorageHome:O.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:O.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:O.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:O.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:O.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:O.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:O.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Ok=k;function s(i,t,r,o,v,m){return{id:i,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:m&&v?.useDefaultFlags?.globalState?m.globalStorageHome:(0,j.$wg)(r,"globalStorage"),settingsResource:m&&v?.useDefaultFlags?.settings?m.settingsResource:(0,j.$wg)(r,"settings.json"),keybindingsResource:m&&v?.useDefaultFlags?.keybindings?m.keybindingsResource:(0,j.$wg)(r,"keybindings.json"),tasksResource:m&&v?.useDefaultFlags?.tasks?m.tasksResource:(0,j.$wg)(r,"tasks.json"),snippetsHome:m&&v?.useDefaultFlags?.snippets?m.snippetsHome:(0,j.$wg)(r,"snippets"),extensionsResource:m&&v?.useDefaultFlags?.extensions?m.extensionsResource:(0,j.$wg)(r,"extensions.json"),cacheHome:(0,j.$wg)(o,i),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Pk=s;let a=class extends L.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,o,v){super(),this.t=t,this.u=r,this.w=o,this.y=v,this.f=!0,this.h=this.B(new A.$Od),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$Od),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$Od),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$Od),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new l.$zc,emptyWindows:new Map},this.profilesHome=(0,j.$wg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$wg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const m of this.O()){if(!m.name||!(0,f.$zf)(m.name)||!m.location){this.y.warn("Skipping the invalid stored profile",m.location||m.name);continue}r.push(s((0,j.$tg)(m.location),m.name,m.location,this.g,{shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags},t))}}catch(m){this.y.error(m)}const o=new l.$zc,v=new Map;if(r.length)try{const m=this.Q();if(m.workspaces)for(const[h,$]of Object.entries(m.workspaces)){const D=O.URI.parse(h),F=r.find(M=>M.id===$);F&&o.set(D,F)}if(m.emptyWindows)for(const[h,$]of Object.entries(m.emptyWindows)){const D=r.find(F=>F.id===$);D&&v.set(h,D)}}catch(m){this.y.error(m)}this.z={profiles:r,workspaces:o,emptyWindows:v}}return this.z}D(){const t=s("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,c.$Ge)(r)}\\s(\\d+)`);let v=0;for(const h of this.profiles){const $=o.exec(h.name),D=$?parseInt($[1]):0;v=D>v?D:v}const m=`${r} ${v+1}`;return this.createProfile((0,I.$Gi)((0,p.$fg)()).toString(16),m,{transient:!0},t)}async createNamedProfile(t,r,o){return this.createProfile((0,I.$Gi)((0,p.$fg)()).toString(16),t,r,o)}async createProfile(t,r,o,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.F(t,r,o);return v&&await this.setProfileForWorkspace(v,m),m}async F(t,r,o){if(!(0,f.$zf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const m=this.profiles.find(D=>D.name===r||D.id===t);if(m)return m;const h=s(t,r,(0,j.$wg)(this.profilesHome,t),this.g,o,this.defaultProfile);await this.u.createFolder(h.location);const $=[];return this.j.fire({profile:h,join(D){$.push(D)}}),await y.Promises.settled($),this.I([h],[],[]),h}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(v=>v.id===t.id);if(!o)throw new Error(`Profile '${t.name}' does not exist`);return o=s(o.id,r.name??o.name,o.location,this.g,{shortName:r.shortName??o.shortName,icon:r.icon===null?void 0:r.icon??o.icon,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags},this.defaultProfile),this.I([],[],[o]),o}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this.m.fire({profile:r,join(v){o.push(v)}});try{await Promise.allSettled(o)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,d.$sk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(v=>v.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,o)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.w.extUri.isEqual(o.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return O.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,w.$3h)(t)?t.uri:(0,w.$8h)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,o){const v=[...this.profiles,...t],m=[];this.s.profiles=[];for(let h of v)h.isDefault||r.some($=>h.id===$.id)||(h=o.find($=>h.id===$.id)??h,h.isTransient?this.s.profiles.push(h):m.push({location:h.location,name:h.name,shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags}));this.P(m),this.z=void 0,this.J(t,r,o)}J(t,r,o){this.h.fire({added:t,removed:r,updated:o,all:this.profiles})}L(t,r,o){o=r?.isTransient?!0:o,o||this.L(t,void 0,!0);const v=this.G(t),m=o?this.s:this.C;O.URI.isUri(v)?(m.workspaces.delete(v),r&&m.workspaces.set(v,r)):(m.emptyWindows.delete(v),r&&m.emptyWindows.set(v,r)),o||this.M()}M(){const t={};for(const[o,v]of this.C.workspaces.entries())t[o.toString()]=v.id;const r={};for(const[o,v]of this.C.emptyWindows.entries())r[o.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},o=this.D();if(t.workspaces)for(const[m,h]of Object.entries(t.workspaces)){const $=O.URI.parse(h);r[m]=this.w.extUri.isEqual($,o.location)?o.id:this.w.extUri.basename($)}const v={};if(t.emptyWindows)for(const[m,h]of Object.entries(t.emptyWindows)){const $=O.URI.parse(h);v[m]=this.w.extUri.isEqual($,o.location)?o.id:this.w.extUri.basename($)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$Qk=a,e.$Qk=a=pe([X(0,S.$Zh),X(1,d.$bk),X(2,g.$Lk),X(3,E.$aj)],a);class n extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Rk=n}),define(ae[241],ce([0,1,6,2,17]),function(ie,e,I,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$79b=void 0;let j=class extends A.$Rc{constructor(R){super(),this.B(new I.$7g(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$79b=j,e.$79b=j=pe([X(0,L.$Nk)],j)}),define(ae[242],ce([0,1,18,6,26,7,3,2,5,12,10,151,29,33,44,8,25,22,28,17]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.$sp=void 0;let b=class extends R.$Rc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,o,v,m,h){super(),this.z=t,this.C=r,this.D=o,this.F=v,this.G=m,this.H=h,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$Od),this.s=this.B(new O.$Od),this.t=this.B(new O.$Od),this.u=this.B(new O.$Od),this.w=this.B(new O.$Od),this.y=[],this.B((0,R.$Pc)(()=>{this.j.forEach(({task:$})=>$.cancel()),this.m.forEach($=>$.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,w.$$n)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:m})=>(0,l.$Co)(m,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:s(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(o){throw s(o)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new w.$bo(E.localize(0,null),w.ExtensionManagementErrorCode.Internal);const r=[],o=[];await Promise.allSettled(t.map(async({extension:v,options:m})=>{try{const h=await this.O(v,!!m?.installGivenVersion,!!m?.installPreReleaseVersion);o.push({...h,options:m})}catch(h){r.push({identifier:v.identifier,operation:2,source:v,error:h})}})),o.length&&r.push(...await this.I(o));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!C.URI.isUri(v.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,l.$Ko)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,g.$_l)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let o=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(o=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const m=(await this.getInstalled(1,v.extensionsResource)).find(h=>(0,l.$Co)(h.identifier,t.identifier));m?this.w.fire(m):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async o=>{try{const v=await this.J(o,(m,h)=>t.some($=>(0,l.$Go)(h.identifier.id)===(0,l.$Ho)($.manifest.publisher,$.manifest.name))?!1:this.L(m,h));r.push(...v)}catch(v){r.push({identifier:{id:(0,l.$Ho)(o.manifest.publisher,o.manifest.name)},operation:2,source:o.extension,error:v})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:o},v){const m=o.isApplicationScoped||o.isBuiltin||(0,g.$_l)(t),h={...o,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:m,profileLocation:m?this.H.defaultProfile.extensionsResource:o.profileLocation??this.Y()},$=Y=>`${l.$Do.create(Y).toString()}${h.profileLocation?`-${h.profileLocation.toString()}`:""}`;if(!C.URI.isUri(r)){const Y=this.j.get($(r));if(Y)return this.F.info("Extensions is already requested to install",r.identifier.id),await Y.task.waitUntilTaskIsFinished(),[]}const D=[],F=[],M=[],U=this.Z(t,r,h);C.URI.isUri(r)||this.j.set($(r),{task:U,waitingTasks:[]}),this.n.fire({identifier:U.identifier,source:r,profileLocation:h.profileLocation}),this.F.info("Installing extension:",U.identifier.id),D.push({task:U,manifest:t});let q=!1;try{if(h.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",U.identifier.id);else try{const K=await this.N(U.identifier,t,!!h.installOnlyNewlyAddedFromExtensionPack,!!h.installPreReleaseVersion,h.profileLocation),x=await this.getInstalled(void 0,h.profileLocation),H={...h,donotIncludePackAndDependencies:!0,context:{...h.context,[w.$6n]:!0}};for(const{gallery:Q,manifest:J}of(0,I.$Lb)(K,({gallery:W})=>W.identifier.id)){q=q||!!J.extensionDependencies?.some(ne=>(0,l.$Co)({id:ne},U.identifier));const W=$(Q),ee=this.j.get(W);if(ee){if(v(U,ee.task)){const ne=ee.task.identifier;this.F.info("Waiting for already requested installing extension",ne.id,U.identifier.id),ee.waitingTasks.push(U),F.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,_=>_.some(se=>(0,l.$Co)(se.identifier,ne)))).then(_=>{if(this.F.info("Finished waiting for already requested installing extension",ne.id,U.identifier.id),!_.find(Z=>(0,l.$Co)(Z.identifier,ne))?.local)throw new Error(`Extension ${ne.id} is not installed`)}))}}else if(!x.some(({identifier:ne})=>(0,l.$Co)(ne,Q.identifier))){const ne=this.Z(J,Q,H);this.j.set(W,{task:ne,waitingTasks:[U]}),this.n.fire({identifier:ne.identifier,source:Q,profileLocation:h.profileLocation}),this.F.info("Installing extension:",ne.identifier.id,U.identifier.id),D.push({task:ne,manifest:J})}}}catch(K){if(C.URI.isUri(U.source))(0,I.$Kb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",U.identifier.id,K.message),(0,I.$Kb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",U.identifier.id,K.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",U.identifier.id),K}const Y=D.reduce((K,{task:x,manifest:H})=>(K.set(x.identifier.id.toLowerCase(),{task:x,manifest:H}),K),new Map);for(;Y.size;){let K;const x=[...Y.values()].filter(({manifest:H})=>!H.extensionDependencies?.some(Q=>Y.has(Q.toLowerCase())));x.length?K=Y.size===1?x:x.filter(({task:H})=>!(H===U&&!q)):(this.F.info("Found extensions with circular dependencies",x.map(({task:H})=>H.identifier.id)),K=[...Y.values()]),await this.M(K.map(async({task:H})=>{const Q=new Date().getTime();try{const J=await H.run();if(await this.M(this.y.map(W=>W.postInstall(J,H.source,h,L.CancellationToken.None))),!C.URI.isUri(H.source)){const W=H.operation===3,ee=W?void 0:(new Date().getTime()-H.source.lastUpdated)/1e3;if(a(this.C,W?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Ko)(H.source),verificationStatus:H.verificationStatus,duration:new Date().getTime()-Q,durationSinceUpdate:ee}),S.$o&&H.operation!==3)try{await this.z.reportStatistic(J.manifest.publisher,J.manifest.name,J.manifest.version,"install")}catch{}}M.push({local:J,identifier:H.identifier,operation:H.operation,source:H.source,context:H.options.context,profileLocation:H.profileLocation,applicationScoped:J.isApplicationScoped})}catch(J){throw C.URI.isUri(H.source)||a(this.C,H.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Ko)(H.source),verificationStatus:H.verificationStatus,duration:new Date().getTime()-Q,error:J}),this.F.error("Error while installing the extension:",H.identifier.id),J}finally{Y.delete(H.identifier.id.toLowerCase())}}))}return F.length&&await this.M(F),M.forEach(({identifier:K})=>this.F.info("Extension installed successfully:",K.id)),M}catch(Y){if(D.forEach(({task:K})=>K.cancel()),M.length)try{const K=await Promise.allSettled(M.map(({local:x})=>this.$(x,{versionOnly:!0,profileLocation:h.profileLocation}).run()));for(let x=0;x<K.length;x++){const H=K[x],{identifier:Q}=M[x];H.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",Q.id):this.F.warn("Rollback: Error while uninstalling extension",Q.id,(0,j.$9)(H.reason))}}catch(K){this.F.warn("Error while rolling back extensions",(0,j.$9)(K),M.map(({identifier:x})=>x.id))}return D.map(({task:K})=>({identifier:K.identifier,operation:2,source:K.source,context:h.context,profileLocation:h.profileLocation,error:Y}))}finally{for(const{task:Y}of D)Y.source&&!C.URI.isUri(Y.source)&&this.j.delete($(Y.source))}}L(t,r){for(const[,{task:o,waitingTasks:v}]of this.j.entries())if(o===t&&(v.includes(r)||v.some(m=>this.L(m,r)))||o===r&&v[0]&&!this.L(t,v[0]))return!1;return!0}async M(t){const r=[],o=[],v=await Promise.allSettled(t);for(const m of v)m.status==="fulfilled"?r.push(m.value):o.push(m.reason);if(o.length)throw k(o);return r}async N(t,r,o,v,m){if(!this.z.isEnabled())return[];const h=await this.getInstalled(void 0,m),$=[],D=[],F=async(M,U)=>{$.push(M);const q=U.extensionDependencies||[],Y=[...q];if(U.extensionPack){const K=o?h.find(x=>(0,l.$Co)(x.identifier,M)):void 0;for(const x of U.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(H=>(0,l.$Co)({id:H},{id:x}))||Y.every(H=>!(0,l.$Co)({id:H},{id:x}))&&Y.push(x)}if(Y.length){const K=Y.filter(x=>$.every(H=>!(0,l.$Co)(H,{id:x})));if(K.length){const x=await this.z.getExtensions(K.map(H=>({id:H,preRelease:v})),L.CancellationToken.None);for(const H of x){if($.find(W=>(0,l.$Co)(W,H.identifier)))continue;const Q=q.some(W=>(0,l.$Co)({id:W},H.identifier));let J;try{J=await this.O(H,!1,v)}catch(W){if(Q)throw W;this.F.info("Skipping the packed extension as it cannot be installed",H.identifier.id,(0,j.$9)(W));continue}D.push({gallery:J.extension,manifest:J.manifest}),await F(J.extension.identifier,J.manifest)}}}};return await F(t,r),D}async O(t,r,o){let v;const m=await this.getExtensionsControlManifest();if(m.malicious.some(D=>(0,l.$Co)(t.identifier,D)))throw new w.$bo(E.localize(1,null,t.identifier.id),w.ExtensionManagementErrorCode.Malicious);const h=m.deprecated[t.identifier.id.toLowerCase()];if(h?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${h.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:h.extension.id,preRelease:h.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0],!v)throw new w.$bo(E.localize(2,null,t.identifier.id,h.extension.id),w.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const D=await this.getTargetPlatform();throw new w.$bo(E.localize(3,null,t.identifier.id,this.G.nameLong,(0,w.$7n)(D)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(t,r,o),!v)throw!o&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],L.CancellationToken.None))[0]?new w.$bo(E.localize(4,null,t.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.$bo(E.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),w.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const $=await this.z.getManifest(v,L.CancellationToken.None);if($===null)throw new w.$bo(`Missing manifest for extension ${v.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if($.version!==v.version)throw new w.$bo(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:$}}async P(t,r,o){const v=await this.getTargetPlatform();let m=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(m=(await this.z.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:v,compatible:!0},L.CancellationToken.None))[0]||null),!m&&await this.z.isExtensionCompatible(t,o,v)&&(m=t),m||(r?m=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},L.CancellationToken.None))[0]||null:m=await this.z.getCompatibleExtension(t,o,v)),m}async Q(t,r){const o={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=M=>`${M.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,m=this.m.get(v(t.identifier));if(m)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),m.waitUntilTaskIsFinished();const h=M=>{const U=this.$(M,o);return this.m.set(v(U.extension.identifier),U),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.t.fire({identifier:M.identifier,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped}),U},$=(M,U)=>{U?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString(),U.message):this.F.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,U.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$Jo)(M),error:U}),this.u.fire({identifier:M.identifier,error:U?.code,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped})},D=[],F=[];try{D.push(h(t));const M=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const U=this.U(t,M);for(const q of U)this.m.has(v(q.identifier))?this.F.info("Extensions is already requested to uninstall",q.identifier.id):D.push(h(q))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(D.map(U=>U.extension),M,t),await this.M(D.map(async U=>{try{if(await U.run(),await this.M(this.y.map(q=>q.postUninstall(U.extension,o,L.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,"uninstall")}catch{}$(U.extension)}catch(q){const Y=q instanceof w.$bo?q:new w.$bo((0,j.$9)(q),w.ExtensionManagementErrorCode.Internal);throw $(U.extension,Y),Y}finally{F.push(U)}}))}catch(M){const U=M instanceof w.$bo?M:new w.$bo((0,j.$9)(M),w.ExtensionManagementErrorCode.Internal);for(const q of D){try{q.cancel()}catch{}F.includes(q)||$(q.extension,U)}throw U}finally{for(const M of D)this.m.delete(v(M.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}R(t,r,o){for(const v of t){const m=this.W(v,r);if(m.length){const h=m.filter($=>!t.some(D=>(0,l.$Co)(D.identifier,$.identifier)));if(h.length)throw new Error(this.S(v,h,o))}}}S(t,r,o){return o===t?r.length===1?E.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const m=r.filter($=>!$.isBuiltin&&v.some(D=>(0,l.$Co)({id:D},$.identifier))),h=[];for(const $ of m)h.push(...this.U($,r,o));return[...m,...h]}return[]}W(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(v=>(0,l.$Co)({id:v},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$sp=b,e.$sp=b=pe([X(0,w.$ao),X(1,c.$fl),X(2,f.$Lk),X(3,y.$aj),X(4,p.$sj),X(5,u.$Nk)],b);function k(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.$tp=k;function s(i){if(i instanceof w.$bo)return i;const t=new w.$bo(i.message,w.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.$up=s;function a(i,t,{extensionData:r,verificationStatus:o,duration:v,error:m,durationSinceUpdate:h}){let $,D;(0,d.$Hf)(o)&&(o===!0?o="Verified":(o===!1||($=w.ExtensionManagementErrorCode.Signature,D=o),o="Unverified")),m&&(m instanceof w.$bo?($=m.code,m.code===w.ExtensionManagementErrorCode.Signature&&(D=m.message)):$=w.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...r,verificationStatus:o,success:!m,duration:v,errorcode:$,errorcodeDetail:D,durationSinceUpdate:h})}class n{constructor(){this.d=new A.$Tg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.$Ig)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.$Ig)(t=>new Promise((r,o)=>{const v=t.onCancellationRequested(()=>{v.dispose(),o(new j.$4)})})),this.d.open()),this.g.cancel()}}e.$vp=n}),define(ae[51],ce([0,1,6,15,2,3,34,10,29,33,11,4,8,17,28,12,7,22]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class u extends Error{constructor(n,i){super(n),this.code=i}}e.$wp=u,e.$xp=(0,E.$Sh)("IExtensionsProfileScannerService");let b=class extends L.$Rc{constructor(n,i,t,r,o,v){super(),this.j=n,this.m=i,this.n=t,this.r=r,this.s=o,this.t=v,this.b=this.B(new j.$Od),this.onAddExtensions=this.b.event,this.c=this.B(new j.$Od),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$Od),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$Od),this.onDidRemoveExtensions=this.g.event,this.h=new O.$zc}scanProfileExtensions(n,i){return this.u(n,void 0,i)}async addExtensionsToProfile(n,i){const t=[],r=[];try{return await this.u(i,o=>{const v=[];for(const m of o)n.some(([h])=>(0,d.$Co)(h.identifier,m.identifier)&&h.manifest.version!==m.version)?t.push(m):v.push(m);for(const[m,h]of n){const $=v.findIndex(F=>(0,d.$Co)(F.identifier,m.identifier)&&F.version===m.manifest.version),D={identifier:m.identifier,version:m.manifest.version,location:m.location,metadata:h};$===-1?(r.push(D),v.push(D)):v.splice($,1,D)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),t.length&&this.f.fire({extensions:t,profileLocation:i}),v}),r.length&&this.c.fire({extensions:r,profileLocation:i}),t.length&&this.g.fire({extensions:t,profileLocation:i}),r}catch(o){throw r.length&&this.c.fire({extensions:r,error:o,profileLocation:i}),t.length&&this.g.fire({extensions:t,error:o,profileLocation:i}),o}}async updateMetadata(n,i){const t=[];return await this.u(i,r=>{const o=[];for(const v of r){const m=n.find(([h])=>(0,d.$Co)(h.identifier,v.identifier)&&h.manifest.version===v.version);m&&(v.metadata={...v.metadata,...m[1]},t.push(v)),o.push(v)}return o}),t}async removeExtensionFromProfile(n,i){const t=[];try{await this.u(i,r=>{const o=[];for(const v of r)(0,d.$Co)(v.identifier,n.identifier)?t.push(v):o.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:i}),o}),t.length&&this.g.fire({extensions:t,profileLocation:i})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:i}),r}}async u(n,i,t){return this.F(n).queue(async()=>{let r=[],o;try{const v=await this.m.readFile(n);o=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,C.$sk)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(o=await this.D()),!o&&t?.bailOutWhenFileNotFound)throw new u((0,p.$9)(v),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.w(n);let v=!1;for(const m of o){k(m)||this.w(n);let h;if((0,y.$zf)(m.relativeLocation)&&m.relativeLocation)h=this.z(m.relativeLocation);else if((0,y.$zf)(m.location))h=this.z(m.location),v=!0,m.relativeLocation=m.location,m.location=h.toJSON();else{h=R.URI.revive(m.location);const $=this.y(h);$&&(v=!0,m.relativeLocation=$)}r.push({identifier:m.identifier,location:h,version:m.version,metadata:m.metadata})}v&&await this.m.writeFile(n,A.$ce.fromString(JSON.stringify(o)))}if(i){r=i(r);const v=r.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),relativeLocation:this.y(m.location),metadata:m.metadata}));await this.m.writeFile(n,A.$ce.fromString(JSON.stringify(v)))}return r})}w(n){const i=new u(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(o){if((0,C.$sk)(o)===1)return;throw o}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const o=JSON.parse(t);Array.isArray(o)&&o.every(v=>k(v))?r=o:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.t.error(o)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$ce.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(o){if((0,C.$sk)(o)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw o}try{await this.m.del(n)}catch(o){(0,C.$sk)(o)!==1&&this.t.error(o)}try{await this.m.del(i)}catch(o){(0,C.$sk)(o)!==1&&this.t.error(o)}return r})()),this.C}F(n){let i=this.h.get(n);return i||(i=new I.$2g,this.h.set(n,i)),i}};e.$yp=b,e.$yp=b=pe([X(1,C.$bk),X(2,l.$Nk),X(3,g.$Lk),X(4,c.$fl),X(5,w.$aj)],b);function k(a){return(0,y.$Bf)(a)&&(0,S.$_n)(a.identifier)&&(s(a.location)||(0,y.$zf)(a.location)&&a.location)&&((0,y.$Gf)(a.relativeLocation)||(0,y.$zf)(a.relativeLocation))&&a.version&&(0,y.$zf)(a.version)}function s(a){return a?(0,y.$zf)(a.path)&&(0,y.$zf)(a.scheme):!1}}),define(ae[80],ce([0,1,18,6,30,15,7,35,137,2,23,16,5,19,54,89,12,10,154,14,33,44,69,11,4,8,25,3,65,51,17,28,182]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f,u,b,k,s,a,n,i,t,r,o,v,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=e.Translations=void 0;var D;(function(x){function H(Q,J){if(Q===J)return!0;const W=Object.keys(Q),ee=new Set;for(const ne of Object.keys(J))ee.add(ne);if(W.length!==ee.size)return!1;for(const ne of W){if(Q[ne]!==J[ne])return!1;ee.delete(ne)}return ee.size===0}x.equals=H})(D||(e.Translations=D={})),e.$Bp=(0,n.$Sh)("IExtensionsScannerService");let F=class extends d.$Rc{constructor(H,Q,J,W,ee,ne,_,se,Z,z,P,T){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=Q,this.r=J,this.s=W,this.t=ee,this.u=ne,this.w=_,this.y=se,this.z=Z,this.C=z,this.D=P,this.F=T,this.g=this.B(new r.$Od),this.onDidChangeCache=this.g.event,this.h=(0,l.$wg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(U,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,b.$No)(this.w,this.y)),this.G}async scanAllExtensions(H,Q,J){const[W,ee]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(Q)]),ne=J?await this.scanExtensionsUnderDevelopment(H,[...W,...ee]):[];return this.L(W,ee,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const Q=[];Q.push(this.M(!!H.useCache,H.language)),Q.push(this.N(H.language,!!H.checkControlFile));const[J,W]=await Promise.all(Q);return this.J([...J,...W],0,H,!1)}async scanUserExtensions(H){const Q=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const J=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(Q,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,J),ee=H.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let ne;try{ne=await ee.scanExtensions(W)}catch(_){if(_ instanceof v.$wp&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ne=await ee.scanExtensions(W);else throw _}return ne=await this.J(ne,1,H,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(H,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const J=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===C.Schemas.file).map(async W=>{const ee=await this.P(W,!1,1,!0,H.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(ee)).map(_=>(_.type=Q.find(se=>(0,b.$Co)(se.identifier,_.identifier))?.type??_.type,this.n.validate(_,ee)))}))).flat();return this.J(J,"development",H,!0)}return[]}async scanExistingExtension(H,Q,J){const W=await this.P(H,!1,Q,!0,J.language,!0,void 0),ee=await this.n.scanExtension(W);return!ee||!J.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(H,Q,J){const W=await this.P(H,!1,Q,!0,J.language,!0,void 0),ee=await this.n.scanOneOrMultipleExtensions(W);return this.J(ee,Q,J,!0)}async scanMetadata(H){const Q=(0,l.$wg)(H,"package.json"),J=(await this.w.readFile(Q)).value.toString();return JSON.parse(J).__metadata}async updateMetadata(H,Q){const J=(0,l.$wg)(H,"package.json"),W=(await this.w.readFile(J)).value.toString(),ee=JSON.parse(W);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,ee.__metadata={...ee.__metadata,...Q},await this.w.writeFile((0,l.$wg)(H,"package.json"),j.$ce.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof v.$wp&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$ce.fromString(JSON.stringify([])))}catch(Q){(0,a.$sk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$9)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,Q,J,W){return J.includeAllVersions||(H=this.L(Q===0?H:void 0,Q===1?H:void 0,Q==="development"?H:void 0,await this.getTargetPlatform(),W)),J.includeInvalid||(H=H.filter(ee=>ee.isValid)),H.sort((ee,ne)=>{const _=E.$mc(ee.location.fsPath),se=E.$mc(ne.location.fsPath);return _<se?-1:_>se?1:0})}L(H,Q,J,W,ee){const ne=(se,Z,z)=>{if(se.isValid&&!Z.isValid)return!1;if(se.isValid===Z.isValid){if(ee&&g.gt(se.manifest.version,Z.manifest.version))return this.y.debug(`Skipping extension ${Z.location.path} with lower version ${Z.manifest.version} in favour of ${se.location.path} with version ${se.manifest.version}`),!1;if(g.eq(se.manifest.version,Z.manifest.version)){if(se.type===0)return this.y.debug(`Skipping extension ${Z.location.path} in favour of system extension ${se.location.path} with same version`),!1;if(se.targetPlatform===W)return this.y.debug(`Skipping extension ${Z.location.path} from different target platform ${Z.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${se.location.path} with ${Z.location.path}.`):this.y.debug(`Overwriting user extension ${se.location.path} with ${Z.location.path}.`),!0},_=new k.$$l;return H?.forEach(se=>{const Z=_.get(se.identifier.id);(!Z||ne(Z,se,!1))&&_.set(se.identifier.id,se)}),Q?.forEach(se=>{const Z=_.get(se.identifier.id);if(!Z&&H&&se.type===0){this.y.debug(`Skipping obsolete system extension ${se.location.path}.`);return}(!Z||ne(Z,se,!1))&&_.set(se.identifier.id,se)}),J?.forEach(se=>{const Z=_.get(se.identifier.id);(!Z||ne(Z,se,!0))&&_.set(se.identifier.id,se),_.set(se.identifier.id,se)}),[..._.values()]}async M(H,Q){this.y.trace("Started scanning system extensions");const J=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),ee=await(H&&!J.devMode?this.j:this.n).scanExtensions(J);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(H,Q){const J=this.z.isBuilt?[]:this.C.builtInExtensions;if(!J?.length)return[];this.y.trace("Started scanning dev system extensions");const W=Q?await this.O():{},ee=[],ne=c.URI.file(E.$gc(E.$ic(C.$dg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const se of J){const Z=W[se.name]||"marketplace";switch(Z){case"disabled":break;case"marketplace":ee.push((0,l.$wg)(ne,se.name));break;default:ee.push(c.URI.file(Z));break}}const _=await Promise.all(ee.map(async se=>this.n.scanExtension(await this.P(se,!1,0,!0,H,!0,void 0))));return this.y.trace("Scanned dev system extensions:",_.length),(0,I.$Gb)(_)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,Q,J,W,ee,ne,_){const se=await this.f(ee??w.$w),Z=await this.Q(H),z=Q&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,P=z?await this.Q(z):void 0;return new M(H,Z,z,P,Q,_,J,W,ne,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,ee,se)}async Q(H){try{const Q=await this.w.stat(H);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$Cp=F,e.$Cp=F=pe([X(4,m.$Nk),X(5,v.$xp),X(6,a.$bk),X(7,i.$aj),X(8,u.$Zh),X(9,t.$sj),X(10,h.$Lk),X(11,n.$Rh)],F);class M{constructor(H,Q,J,W,ee,ne,_,se,Z,z,P,T,B,N,V){this.location=H,this.mtime=Q,this.applicationExtensionslocation=J,this.applicationExtensionslocationMtime=W,this.profile=ee,this.profileScanOptions=ne,this.type=_,this.excludeObsolete=se,this.validate=Z,this.productVersion=z,this.productDate=P,this.productCommit=T,this.devMode=B,this.language=N,this.translations=V}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,Q){return(0,l.$pg)(H.location,Q.location)&&H.mtime===Q.mtime&&(0,l.$pg)(H.applicationExtensionslocation,Q.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&H.profile===Q.profile&&L.$bn(H.profileScanOptions,Q.profileScanOptions)&&H.type===Q.type&&H.excludeObsolete===Q.excludeObsolete&&H.validate===Q.validate&&H.productVersion===Q.productVersion&&H.productDate===Q.productDate&&H.productCommit===Q.productCommit&&H.devMode===Q.devMode&&H.language===Q.language&&D.equals(H.translations,Q.translations)}}e.$Dp=M;let U=class extends d.$Rc{constructor(H,Q,J,W,ee){super(),this.f=H,this.g=Q,this.h=J,this.j=W,this.m=ee}async scanExtensions(H){const Q=H.profile?await this.r(H):await this.n(H);let J={};if(H.excludeObsolete&&H.type===1)try{const W=(await this.j.readFile(this.f)).value.toString();J=JSON.parse(W)}catch{}return(0,p.$Mf)(J)?Q:Q.filter(W=>!J[b.$Do.create(W).toString()])}async n(H){const Q=await this.j.resolve(H.location);if(!Q.children?.length)return[];const J=await Promise.all(Q.children.map(async W=>{if(!W.isDirectory||H.type===1&&(0,l.$tg)(W.resource).indexOf(".")===0)return null;const ee=new M(W.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ee)}));return(0,I.$Gb)(J).sort((W,ee)=>W.location.path<ee.location.path?-1:1)}async r(H){let Q=await this.s(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){Q=Q.filter(W=>!W.metadata?.isApplicationScoped);const J=await this.s(H.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,H);Q.push(...J)}return Q}async s(H,Q,J){const W=await this.g.scanProfileExtensions(H,J.profileScanOptions);if(!W.length)return[];const ee=await Promise.all(W.map(async ne=>{if(Q(ne)){const _=new M(ne.location,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(_,ne.metadata)}return null}));return(0,I.$Gb)(ee)}async scanOneOrMultipleExtensions(H){try{if(await this.j.exists((0,l.$wg)(H.location,"package.json"))){const Q=await this.scanExtension(H);return Q?[Q]:[]}else return await this.scanExtensions(H)}catch(Q){return this.m.error(`Error scanning extensions at ${H.location.path}:`,(0,O.$9)(Q)),[]}}async scanExtension(H,Q){try{let J=await this.scanExtensionManifest(H.location);if(J){J.publisher||(J.publisher=k.$5l),Q=Q??J.__metadata,delete J.__metadata;const W=(0,b.$Ho)(J.publisher,J.name),ee=Q?.id?{id:W,uuid:Q.id}:{id:W},ne=Q?.isSystem?0:H.type,_=ne===0||!!Q?.isBuiltin;J=await this.t(H.location,J,M.createNlsConfiguration(H));const se={type:ne,identifier:ee,manifest:J,location:H.location,isBuiltin:_,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return H.validate?this.validate(se,H):se}}catch(J){H.type!==0&&this.m.error(J)}return null}validate(H,Q){let J=!0;const W=(0,s.$So)(Q.productVersion,Q.productDate,Q.location,H.manifest,H.isBuiltin);for(const[ee,ne]of W)ee===y.default.Error&&(J=!1,this.m.error(this.z(Q.location,ne)));return H.isValid=J,H.validations=W,H}async scanExtensionManifest(H){const Q=(0,l.$wg)(H,"package.json");let J;try{J=(await this.j.readFile(Q)).value.toString()}catch(ee){return(0,a.$sk)(ee)!==1&&this.m.error(this.z(H,(0,f.localize)(0,null,Q.path,ee.message))),null}let W;try{W=JSON.parse(J)}catch{const ne=[];(0,R.$Zm)(J,ne);for(const _ of ne)this.m.error(this.z(H,(0,f.localize)(1,null,Q.path,_.offset,_.length,(0,S.$zp)(_.error))));return null}return(0,R.$9m)(W)!=="object"?(this.m.error(this.z(H,(0,f.localize)(2,null,Q.path))),null):W}async t(H,Q,J){const W=await this.u(H,Q,J);if(W)try{const ee=[],ne=await this.w(W.default,ee);if(ee.length>0)return ee.forEach(se=>{this.m.error(this.z(H,(0,f.localize)(3,null,W.default?.path,(0,S.$zp)(se.error))))}),Q;if((0,R.$9m)(W)!=="object")return this.m.error(this.z(H,(0,f.localize)(4,null,W.default?.path))),Q;const _=W.values||Object.create(null);return(0,$.$Ap)(this.m,Q,_,ne)}catch{}return Q}async u(H,Q,J){const W=(0,l.$wg)(H,"package.nls.json"),ee=(Z,z)=>{z.forEach(P=>{this.m.error(this.z(H,(0,f.localize)(5,null,Z?.path,(0,S.$zp)(P.error))))})},ne=Z=>{this.m.error(this.z(H,(0,f.localize)(6,null,Z?.path)))},_=`${Q.publisher}.${Q.name}`,se=J.translations[_];if(se)try{const Z=c.URI.file(se),z=(await this.j.readFile(Z)).value.toString(),P=[],T=(0,R.$Zm)(z,P);return P.length>0?(ee(Z,P),{values:void 0,default:W}):(0,R.$9m)(T)!=="object"?(ne(Z),{values:void 0,default:W}):{values:T.contents?T.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.j.exists(W))return;let z;try{z=await this.y(H,J)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const P=(await this.j.readFile(z.localized)).value.toString(),T=[],B=(0,R.$Zm)(P,T);return T.length>0?(ee(z.localized,T),{values:void 0,default:z.original}):(0,R.$9m)(B)!=="object"?(ne(z.localized),{values:void 0,default:z.original}):{values:B,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(H,Q){if(H)try{const J=(await this.j.readFile(H)).value.toString();return(0,R.$Zm)(J,Q)}catch{}}y(H,Q){return new Promise((J,W)=>{const ee=ne=>{const _=(0,l.$wg)(H,`package.nls.${ne}.json`);this.j.exists(_).then(se=>{se&&J({localized:_,original:(0,l.$wg)(H,"package.nls.json")});const Z=ne.lastIndexOf("-");Z===-1?J({localized:(0,l.$wg)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,Z),ee(ne))})};if(Q.devMode||Q.pseudo||!Q.language)return J({localized:(0,l.$wg)(H,"package.nls.json"),original:null});ee(Q.language)})}z(H,Q){return`[${H.path}]: ${Q}`}};U=pe([X(1,v.$xp),X(2,h.$Lk),X(3,a.$bk),X(4,i.$aj)],U);let q=class extends U{constructor(H,Q,J,W,ee,ne,_){super(Q,W,ee,ne,_),this.G=H,this.H=J,this.D=this.B(new A.$Sg(3e3)),this.F=this.B(new r.$Od),this.onDidChangeCache=this.F.event}async scanExtensions(H){const Q=this.M(H),J=await this.I(Q);if(this.C=H,J&&J.input&&M.equals(J.input,this.C))return this.m.debug("Using cached extensions scan result",H.location.toString()),this.D.trigger(()=>this.L()),J.result.map(ee=>(ee.location=c.URI.revive(ee.location),ee));const W=await super.scanExtensions(H);return await this.J(Q,{input:H,result:W}),W}async I(H){try{const Q=await this.j.readFile(H),J=JSON.parse(Q.value.toString());return{result:J.result,input:(0,o.$ph)(J.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",H.path,(0,O.$9)(Q))}return null}async J(H,Q){try{await this.j.writeFile(H,j.$ce.fromString(JSON.stringify(Q)))}catch(J){this.m.debug("Error while writing the extension cache file:",H.path,(0,O.$9)(J))}}async L(){if(!this.C)return;const H=this.M(this.C),Q=await this.I(H);if(!Q)return;const J=Q.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!L.$bn(W,J))try{this.m.info("Invalidating Cache",J,W),await this.j.del(H),this.F.fire()}catch(ee){this.m.error(ee)}}M(H){const Q=this.N(H);return this.h.extUri.joinPath(Q.cacheHome,H.type===0?k.$4l:k.$3l)}N(H){return H.type===0?this.H.defaultProfile:H.profile?this.h.extUri.isEqual(H.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(H.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};q=pe([X(2,m.$Nk),X(3,v.$xp),X(4,h.$Lk),X(5,a.$bk),X(6,i.$aj)],q);function Y(x,H){const Q=(0,b.$Fo)(x.manifest.publisher,x.manifest.name);return{id:Q,identifier:new k.$9l(Q),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:H,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$Ep=Y;class K extends F{constructor(H,Q,J,W,ee,ne,_,se,Z,z,P,T){super(H,Q,(0,l.$wg)(J,".vscode-oss-dev","extensions","control.json"),W,ee,ne,_,se,Z,z,P,T),this.R=(async()=>{if(w.$z)try{const B=await this.w.readFile(c.URI.file(w.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(H){return this.R}}e.$Fp=K}),define(ae[243],ce([0,1,66,6,38,3,2,23,16,31,8,17]),function(ie,e,I,A,L,j,O,R,S,d,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;let w=class extends O.$Rc{constructor(g,y){super(),this.b=g,this.f=y,this.a=new A.$1g(5)}async postUninstall(g){const y=this.g(g,"uninstall");y&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(p){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(p)}}));try{await d.Promises.rm(this.m(g))}catch(p){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(p)}}g(g,y){const p=`vscode:${y}`;if(g.location.scheme===R.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[p]=="string"){const c=g.manifest.scripts[p].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${p} should be a node script`),null):{script:(0,S.$ic)(g.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(g,y,p,c,f){return new Promise((u,b)=>{const k=this.j(g,y,p,f);let s;const a=n=>{s&&(clearTimeout(s),s=null),n?b(n):u(void 0)};k.on("error",n=>{a((0,L.$Di)(n)||"Unknown")}),k.on("exit",(n,i)=>{a(n?`post-${y} process exited with code ${n}`:void 0)}),c&&(s=setTimeout(()=>{s=null,k.kill(),b("timed out")},5e3))})}j(g,y,p,c){const f={silent:!0,execArgv:void 0},u=(0,I.fork)(g,[`--type=extension-post-${y}`,...p],f);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const b=j.Event.fromNodeEventEmitter(u.stdout,"data"),k=j.Event.fromNodeEventEmitter(u.stderr,"data");b(n=>this.f.info(c.identifier.id,c.manifest.version,`post-${y}`,n)),k(n=>this.f.error(c.identifier.id,c.manifest.version,`post-${y}`,n));const s=j.Event.any(j.Event.map(b,n=>({data:`%c${n}`,format:[""]})),j.Event.map(k,n=>({data:`%c${n}`,format:["color: red"]})));return j.Event.debounce(s,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(c.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),u}m(g){return(0,S.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.$Hp=w,e.$Hp=w=pe([X(0,E.$Nk),X(1,C.$aj)],w)}),define(ae[244],ce([0,1,8,17,28,22,51,11,14,10]),function(ie,e,I,A,L,j,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SN=void 0;let C=class extends O.$yp{constructor(w,l,g,y,p,c){super(d.URI.file(w.extensionsPath),l,g,y,p,c)}};e.$SN=C,e.$SN=C=pe([X(0,S.$1h),X(1,R.$bk),X(2,A.$Nk),X(3,L.$Lk),X(4,j.$fl),X(5,I.$aj)],C)}),define(ae[245],ce([0,1,10,14,51,80,11,4,8,25,28,17]),function(ie,e,I,A,L,j,O,R,S,d,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X8b=void 0;let w=class extends j.$Fp{constructor(g,y,p,c,f,u,b,k){super(I.URI.file(f.builtinExtensionsPath),I.URI.file(f.extensionsPath),f.userHome,g.defaultProfile,g,y,p,c,f,u,b,k)}};e.$X8b=w,e.$X8b=w=pe([X(0,E.$Nk),X(1,L.$xp),X(2,O.$bk),X(3,S.$aj),X(4,A.$1h),X(5,d.$sj),X(6,C.$Lk),X(7,R.$Rh)],w)}),define(ae[21],ce([0,1,6,3,2,100,12,68,4,17]),function(ie,e,I,A,L,j,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$9o=e.$8o=e.$7o=void 0,e.$7o="__$__isNewStorageMarker",e.$8o="__$__targetStorageMarker",e.$9o=(0,S.$Sh)("storageService");var C;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var E;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var w;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function l(f){const u=f.get(e.$8o);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}e.$0o=l;class g extends L.$Rc{static{this.a=60*1e3}constructor(u={flushInterval:g.a}){super(),this.m=u,this.b=this.B(new A.$Rd),this.c=this.B(new A.$Rd),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$Od),this.onWillSaveState=this.f.event,this.h=this.B(new I.$7g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(u,b,k){return A.Event.filter(this.b.event,s=>s.scope===u&&(b===void 0||s.key===b),k)}n(){this.j.value=(0,I.$$g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(u,b){const{key:k,external:s}=b;if(k===e.$8o){switch(u){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:u})}else this.b.fire({scope:u,key:k,target:this.J(u)[k],external:s})}w(u){this.f.fire({reason:u})}get(u,b,k){return this.P(b)?.get(u,k)}getBoolean(u,b,k){return this.P(b)?.getBoolean(u,k)}getNumber(u,b,k){return this.P(b)?.getNumber(u,k)}getObject(u,b,k){return this.P(b)?.getObject(u,k)}storeAll(u,b){this.y(()=>{for(const k of u)this.store(k.key,k.value,k.scope,k.target,b)})}store(u,b,k,s,a=!1){if((0,O.$If)(b)){this.remove(u,k,a);return}this.y(()=>{this.z(u,k,s),this.P(k)?.set(u,b,a)})}remove(u,b,k=!1){this.y(()=>{this.z(u,b,void 0),this.P(b)?.delete(u,k)})}y(u){this.b.pause(),this.c.pause();try{u()}finally{this.b.resume(),this.c.resume()}}keys(u,b){const k=[],s=this.J(u);for(const a of Object.keys(s))s[a]===b&&k.push(a);return k}z(u,b,k,s=!1){const a=this.J(b);typeof k=="number"?a[u]!==k&&(a[u]=k,this.P(b)?.set(e.$8o,JSON.stringify(a),s)):typeof a[u]=="number"&&(delete a[u],this.P(b)?.set(e.$8o,JSON.stringify(a),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(u){switch(u){case-1:return this.I;case 0:return this.G;default:return this.D}}L(u){const b=this.P(u);return b?l(b):Object.create(null)}isNew(u){return this.getBoolean(e.$7o,u)===!0}async flush(u=C.NONE){this.f.fire({reason:u});const b=this.P(-1),k=this.P(0),s=this.P(1);switch(u){case C.NONE:await I.Promises.settled([b?.whenFlushed()??Promise.resolve(),k?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await I.Promises.settled([b?.flush(0)??Promise.resolve(),k?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.P(-1)?.items??new Map,b=this.P(0)?.items??new Map,k=this.P(1)?.items??new Map;return c(u,b,k,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(u){return await this.flush(),this.P(u)?.optimize()}async switch(u,b){return this.w(C.NONE),(0,d.$Mk)(u)?this.R(u,b):this.S(u,b)}M(u,b){return!(u.id===b.id||y(b)&&y(u))}N(u,b,k){this.y(()=>{const s=new Set;for(const[a,n]of u)s.add(a),b.get(a)!==n&&this.u(k,{key:a,external:!0});for(const[a]of b.items)s.has(a)||this.u(k,{key:a,external:!0})})}}e.$$o=g;function y(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$_o=y;class p extends g{constructor(){super(),this.U=this.B(new R.$5o(new R.$6o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$5o(new R.$6o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$5o(new R.$6o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(u=>this.u(1,u))),this.B(this.W.onDidChangeStorage(u=>this.u(0,u))),this.B(this.U.onDidChangeStorage(u=>this.u(-1,u)))}P(u){switch(u){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(u){return!1}}e.$ap=p;async function c(f,u,b,k,s,a){const n=D=>{try{return JSON.parse(D)}catch{return D}},i=new Map,t=new Map;f.forEach((D,F)=>{i.set(F,D),t.set(F,n(D))});const r=new Map,o=new Map;u.forEach((D,F)=>{r.set(F,D),o.set(F,n(D))});const v=new Map,m=new Map;b.forEach((D,F)=>{v.set(F,D),m.set(F,n(D))}),console.group(k!==s?`Storage: Application (path: ${k})`:`Storage: Application & Profile (path: ${k}, default profile)`);const h=[];if(i.forEach((D,F)=>{h.push({key:F,value:D})}),console.table(h),console.groupEnd(),console.log(t),k!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const D=[];r.forEach((F,M)=>{D.push({key:M,value:F})}),console.table(D),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${a})`);const $=[];v.forEach((D,F)=>{$.push({key:F,value:D})}),console.table($),console.groupEnd(),console.log(m)}e.$bp=c}),define(ae[113],ce([0,1,3,2,12,29,33,21]),function(ie,e,I,A,L,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qDb=e.$pDb=void 0;let S=class extends A.$Rc{constructor(E,w){super(),this.a=new I.$Od,this.onDidChangeEnablement=this.a.event,this.b=this.B(new d(E)),this.B(this.b.onDidChange(l=>this.a.fire({extensions:l,source:"storage"}))),this.B(w.onDidInstallExtensions(l=>l.forEach(({local:g,operation:y})=>{g&&y===4&&this.f(g.identifier)})))}async enableExtension(E,w){return this.f(E)?(this.a.fire({extensions:[E],source:w}),!0):!1}async disableExtension(E,w){return this.c(E)?(this.a.fire({extensions:[E],source:w}),!0):!1}getDisabledExtensions(){return this.h(j.$do)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const w=this.getDisabledExtensions();return w.every(l=>!(0,O.$Co)(l,E))?(w.push(E),this.g(w),!0):!1}f(E){const w=this.getDisabledExtensions();for(let l=0;l<w.length;l++){const g=w[l];if((0,O.$Co)(g,E))return w.splice(l,1),this.g(w),!0}return!1}g(E){this.j(j.$do,E)}h(E){return this.b.get(E,0)}j(E,w){this.b.set(E,w,0)}};e.$pDb=S,e.$pDb=S=pe([X(0,R.$9o),X(1,j.$co)],S);class d extends A.$Rc{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new I.$Od),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(0,void 0,this.B(new A.$Qc))(w=>this.f(w)))}get(E,w){let l;return w===0?((0,L.$If)(this.a[E])&&(this.a[E]=this.g(E,w)),l=this.a[E]):l=this.g(E,w),JSON.parse(l)}set(E,w,l){const g=JSON.stringify(w.map(({id:p,uuid:c})=>({id:p,uuid:c})));this.g(E,l)!==g&&(l===0&&(w.length?this.a[E]=g:delete this.a[E]),this.h(E,w.length?g:void 0,l))}f(E){if(!(0,L.$If)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const l=this.get(E.key,E.scope);delete this.a[E.key];const g=this.get(E.key,E.scope),y=l.filter(c=>!g.some(f=>(0,O.$Co)(c,f))),p=g.filter(c=>!l.some(f=>(0,O.$Co)(f,c)));(y.length||p.length)&&this.b.fire([...y,...p])}}g(E,w){return this.c.get(E,w,"[]")}h(E,w,l){w?this.c.store(E,w,l,1):this.c.remove(E,l)}}e.$qDb=d}),define(ae[246],ce([0,1,18,26,7,5,37,12,10,20,14,29,33,69,11,8,25,58,224,21,22,62]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f,u,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=void 0;const s=j.$o?"web":(0,E.$9n)(j.$u,O.$dc),a="X-Market-Search-Activity-Id";var n;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function i(...P){return String(P.reduce((T,B)=>T|B,0))}var t;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},m={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class h{constructor(T=m){this.d=T}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(T,B=this.d.pageSize){return new h({...this.d,pageNumber:T,pageSize:B})}withFilter(T,...B){const N=[...this.d.criteria,...B.length?B.map(V=>({filterType:T,value:V})):[{filterType:T}]];return new h({...this.d,criteria:N})}withSortBy(T){return new h({...this.d,sortBy:T})}withSortOrder(T){return new h({...this.d,sortOrder:T})}withFlags(...T){return new h({...this.d,flags:T.reduce((B,N)=>B|N,0)})}withAssetTypes(...T){return new h({...this.d,assetTypes:T})}withSource(T){return new h({...this.d,source:T})}get raw(){const{criteria:T,pageNumber:B,pageSize:N,sortBy:V,sortOrder:G,flags:te,assetTypes:oe}=this.d;return{filters:[{criteria:T,pageNumber:B,pageSize:N,sortBy:V,sortOrder:G}],assetTypes:oe,flags:te}}get searchText(){const T=this.d.criteria.filter(B=>B.filterType===t.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(T=>String(T.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function $(P,T){const B=(P||[]).filter(N=>N.statisticName===T)[0];return B?B.value:0}function D(P){const T="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(N=>N.assetType.indexOf(T)===0).reduce((N,V)=>{const G=U(P,V.assetType);return G&&N.push([V.assetType.substring(T.length),G]),N},[])}function F(P){if(P.properties){const T=P.properties.filter(V=>V.key===r.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),N=T.filter(V=>B.test(V.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return U(P,r.Repository)}function M(P){return{uri:`${P.fallbackAssetUri}/${r.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${r.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function U(P,T){return P.files.filter(N=>N.assetType===T)[0]?{uri:`${P.assetUri}/${T}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${T}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function q(P,T){const B=P.properties?P.properties.filter(V=>V.key===T):[],N=B.length>0&&B[0].value;return N?N.split(",").map(V=>(0,w.$Go)(V)):[]}function Y(P){const T=P.properties?P.properties.filter(B=>B.key===o.Engine):[];return T.length>0&&T[0].value||""}function K(P){const T=P.properties?P.properties.filter(B=>B.key===o.PreRelease):[];return T.length>0&&T[0].value==="true"}function x(P){const T=P.properties?P.properties.filter(N=>N.key===o.LocalizedLanguages):[],B=T.length>0&&T[0].value||"";return B?B.split(","):[]}function H(P){return P.properties?.find(T=>T.key===o.SponsorLink)?.value}function Q(P){return P.indexOf("preview")!==-1}function J(P){return P.targetPlatform?(0,E.$8n)(P.targetPlatform):"undefined"}function W(P){const T=(0,I.$Lb)(P.versions.map(J)),B=!!P.tags?.includes(E.$3n),N=T.indexOf("web");return B?N===-1&&T.push("web"):N!==-1&&T.splice(N,1),T}function ee(P,T){for(let B=0;B<P.length;B++){const N=P[B];if(N.version===P[B-1]?.version){let V=B;if(J(N)===T)for(;V>0&&P[V-1].version===N.version;)V--;V!==B&&(P.splice(B,1),P.splice(V,0,N))}}return P}e.$ep=ee;function ne(P,T,B){P.telemetryData={index:T,querySource:B,queryActivityId:P.queryContext?.[a]}}function _(P,T,B,N){const V=P.versions[0],G={manifest:U(T,r.Manifest),readme:U(T,r.Details),changelog:U(T,r.Changelog),license:U(T,r.License),repository:F(T),download:M(T),icon:U(T,r.Icon),signature:U(T,r.Signature),coreTranslations:D(T)};return{identifier:{id:(0,w.$Ho)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:T.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(V),description:P.shortDescription||"",installCount:$(P.statistics,"install"),rating:$(P.statistics,"averagerating"),ratingCount:$(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:B,assets:G,properties:{dependencies:q(T,o.Dependency),extensionPack:q(T,o.ExtensionPack),engine:Y(T),localizedLanguages:x(T),targetPlatform:J(T),isPreReleaseVersion:K(T)},hasPreReleaseVersion:K(V),hasReleaseVersion:!0,preview:Q(P.flags),isSigned:!!G.signature,queryContext:N}}let se=class{constructor(T,B,N,V,G,te,oe,ue){this.k=B,this.l=N,this.n=V,this.o=G,this.q=te,this.u=oe,this.w=ue;const he=oe.extensionsGallery,ge=he?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=ge?he.servicePPEUrl:he?.serviceUrl,this.g=ge?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,f.$dp)(oe.version,oe,this.n,this.w,this.q,T,this.o)}x(T=""){return`${this.d}${T}`}isEnabled(){return!!this.d}async getExtensions(T,B,N){const V=A.CancellationToken.isCancellationToken(B)?{}:B,G=A.CancellationToken.isCancellationToken(B)?B:N,te=[],oe=[],ue=[],he=[];let ge=!0;for(const ve of T){ve.uuid?oe.push(ve.uuid):te.push(ve.id);const Oe=!!(ve.version||ve.preRelease);ue.push({id:ve.id,uuid:ve.uuid,includePreRelease:Oe}),ve.version&&he.push({id:ve.id,uuid:ve.uuid,version:ve.version}),ge=ge&&!!ve.hasPreRelease&&!Oe}if(!oe.length&&!te.length)return[];let de=new h().withPage(1,T.length);oe.length&&(de=de.withFilter(t.ExtensionId,...oe)),te.length&&(de=de.withFilter(t.ExtensionName,...te)),(V.queryAllVersions||ge)&&(de=de.withFlags(de.flags,n.IncludeVersions)),V.source&&(de=de.withSource(V.source));const{extensions:we}=await this.z(de,{targetPlatform:V.targetPlatform??s,includePreRelease:ue,versions:he,compatible:!!V.compatible},G);return V.source&&we.forEach((ve,Oe)=>ne(ve,Oe,V.source)),we}async getCompatibleExtension(T,B,N){if((0,E.$0n)(T.allTargetPlatforms,N))return null;if(await this.isExtensionCompatible(T,B,N))return T;const V=new h().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,T.identifier.uuid),{extensions:G}=await this.z(V,{targetPlatform:N,compatible:!0,includePreRelease:B},A.CancellationToken.None);return G[0]||null}async isExtensionCompatible(T,B,N){if(!(0,E.$$n)(T.properties.targetPlatform,T.allTargetPlatforms,N)||!B&&T.properties.isPreReleaseVersion)return!1;let V=T.properties.engine;if(!V){const G=await this.getManifest(T,A.CancellationToken.None);if(!G)throw new Error("Manifest was not found");V=G.engines.vscode}return(0,l.$Uo)(V,this.u.version,this.u.date)}async y(T,B,N,V,G){if(!(0,E.$$n)(J(T),V,G)||B!=="any"&&K(T)!==(B==="prerelease"))return!1;if(N)try{const te=await this.E(T);if(!(0,l.$Uo)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${T.version}.`,(0,L.$9)(te)),!1}return!0}async query(T,B){let N=T.text||"";const V=T.pageSize??50;let G=new h().withPage(1,V);N?(N=N.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,de,we)=>(G=G.withFilter(t.Category,we||de),"")),N=N.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,de,we)=>(G=G.withFilter(t.Tag,we||de),"")),N=N.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(t.Featured),"")),N=N.trim(),N&&(N=N.length<200?N:N.substring(0,200),G=G.withFilter(t.SearchText,N)),G=G.withSortBy(0)):T.ids?G=G.withFilter(t.ExtensionId,...T.ids):T.names?G=G.withFilter(t.ExtensionName,...T.names):G=G.withSortBy(4),typeof T.sortBy=="number"&&(G=G.withSortBy(T.sortBy)),typeof T.sortOrder=="number"&&(G=G.withSortOrder(T.sortOrder)),T.source&&(G=G.withSource(T.source));const te=async(ge,de)=>{const{extensions:we,total:ve}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!T.includePreRelease},de);return we.forEach((Oe,Ne)=>ne(Oe,(ge.pageNumber-1)*ge.pageSize+Ne,T.source)),{extensions:we,total:ve}},{extensions:oe,total:ue}=await te(G,B),he=async(ge,de)=>{if(de.isCancellationRequested)throw new L.$4;const{extensions:we}=await te(G.withPage(ge+1),de);return we};return{firstPage:oe,total:ue,pageSize:G.pageSize,getPage:he}}async z(T,B,N){const V=T.flags;T.flags&n.IncludeLatestVersionOnly&&T.flags&n.IncludeVersions&&(T=T.withFlags(T.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(T.flags&n.IncludeLatestVersionOnly)&&!(T.flags&n.IncludeVersions)&&(T=T.withFlags(T.flags,n.IncludeLatestVersionOnly)),B.versions?.length&&(T=T.withFlags(T.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),T=T.withFlags(T.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:G,total:te,context:oe}=await this.B(T,N);if(!(T.flags&n.IncludeLatestVersionOnly)){const de=[];for(const we of G){const ve=await this.A(we,B,oe);ve&&de.push(ve)}return{extensions:de,total:te}}const he=[],ge=new Map;for(let de=0;de<G.length;de++){const we=G[de],ve={id:(0,w.$Ho)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Oe=(0,R.$Ff)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(Me=>(0,w.$Co)(Me,ve))?.includePreRelease;if(B.compatible&&(0,E.$0n)(W(we),B.targetPlatform))continue;const Ne=await this.A(we,B,oe);!Ne||Ne.properties.isPreReleaseVersion&&(!Oe||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==B.targetPlatform&&Ne.hasPreReleaseVersion?ge.set(we.extensionId,de):he.push([de,Ne])}if(ge.size){const de=new k.$Kd,we=new h().withFlags(V&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,ge.size).withFilter(t.ExtensionId,...ge.keys()),{extensions:ve}=await this.z(we,B,N);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:ge.size});for(const Oe of ve){const Ne=ge.get(Oe.identifier.uuid);he.push([Ne,Oe])}}return{extensions:he.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:te}}async A(T,B,N){const V={id:(0,w.$Ho)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},G=B.versions?.find(he=>(0,w.$Co)(he,V))?.version,te=(0,R.$Ff)(B.includePreRelease)?B.includePreRelease:!!B.includePreRelease.find(he=>(0,w.$Co)(he,V))?.includePreRelease,oe=W(T),ue=ee(T.versions,B.targetPlatform);if(B.compatible&&(0,E.$0n)(oe,B.targetPlatform))return null;for(let he=0;he<ue.length;he++){const ge=ue[he];if(!(G&&ge.version!==G)){if(await this.y(ge,te?"any":"release",B.compatible,oe,B.targetPlatform))return _(T,ge,oe,N);if(G&&ge.version===G)return null}}return G||B.compatible?null:_(T,T.versions[0],oe)}async B(T,B){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(n.Unpublished));const N=await this.j,V=JSON.stringify(T.raw),G={...N,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)},te=new k.$Kd;let oe,ue,he=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&T.criteria.some(de=>de.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:V,headers:G},B),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:he};const ge=await(0,c.$2o)(oe);if(ge){const de=ge.results[0],we=de.extensions,ve=de.resultMetadata&&de.resultMetadata.filter(Oe=>Oe.metadataType==="ResultCount")[0];return he=ve&&ve.metadataItems.filter(Oe=>Oe.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:he,context:{[a]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(ge){throw ue=ge,ge}finally{this.o.publicLog2("galleryService:query",{...T.telemetryData,requestBodySize:String(V.length),duration:te.elapsed(),success:!!oe&&(0,c.$Xo)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:ue?(0,L.$3)(ue)?"canceled":(0,L.$9)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(T,B,N,V){if(!this.isEnabled())return;const G=j.$o?this.x(`/itemName/${T}.${B}/version/${N}/statType/${V==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${T}/extensions/${B}/${N}/stats?statType=${V}`),te=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:G,headers:ue},A.CancellationToken.None)}catch{}}async download(T,B,N){this.l.trace("ExtensionGalleryService#download",T.identifier.id);const V=(0,w.$Ko)(T),G=new Date().getTime(),te=de=>this.o.publicLog("galleryService:downloadVSIX",{...V,duration:de}),oe=N===2?"install":N===3?"update":"",ue=oe?{uri:`${T.assets.download.uri}${S.URI.parse(T.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${T.assets.download.fallbackUri}${S.URI.parse(T.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:T.assets.download,he=T.queryContext?.[a]?{[a]:T.queryContext[a]}:void 0,ge=await this.D(ue,he?{headers:he}:void 0);await this.q.writeFile(B,ge.stream),te(new Date().getTime()-G)}async downloadSignatureArchive(T,B){if(!T.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",T.identifier.id);const N=await this.D(T.assets.signature);await this.q.writeFile(B,N.stream)}async getReadme(T,B){if(T.assets.readme){const N=await this.D(T.assets.readme,{},B);return await(0,c.$1o)(N)||""}return""}async getManifest(T,B){if(T.assets.manifest){const N=await this.D(T.assets.manifest,{},B),V=await(0,c.$1o)(N);return V?JSON.parse(V):null}return null}async C(T,B){const N=U(T,r.Manifest);if(!N)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},G=await this.D(N,{headers:V});return await(0,c.$2o)(G)}async getCoreTranslation(T,B){const N=T.assets.coreTranslations.filter(V=>V[0]===B.toUpperCase())[0];if(N){const V=await this.D(N[1]),G=await(0,c.$1o)(V);return G?JSON.parse(G):null}return null}async getChangelog(T,B){if(T.assets.changelog){const N=await this.D(T.assets.changelog,{},B);return await(0,c.$1o)(N)||""}return""}async getAllCompatibleVersions(T,B,N){let V=new h().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);T.identifier.uuid?V=V.withFilter(t.ExtensionId,T.identifier.uuid):V=V.withFilter(t.ExtensionName,T.identifier.id);const{galleryExtensions:G}=await this.B(V,A.CancellationToken.None);if(!G.length)return[];const te=W(G[0]);if((0,E.$0n)(te,N))return[];const oe=[];await Promise.all(G[0].versions.map(async ge=>{try{await this.y(ge,B?"any":"release",!0,te,N)&&oe.push(ge)}catch{}}));const ue=[],he=new Set;for(const ge of ee(oe,N))he.has(ge.version)||(he.add(ge.version),ue.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:K(ge)}));return ue}async D(T,B={},N=A.CancellationToken.None){const V=await this.j,G={type:"GET"},te={...V,...B.headers||{}};B={...B,...G,headers:te};const oe=T.uri,ue=T.fallbackUri,he={...B,url:oe};try{const ge=await this.k.request(he,N);if(ge.res.statusCode===200)return ge;const de=await(0,c.$1o)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${de}`)}catch(ge){if((0,L.$3)(ge))throw ge;const de=(0,L.$9)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:de});const we={...B,url:ue};return this.k.request(we,N)}}async E(T){let B=Y(T);if(!B){const N=await this.C(T,A.CancellationToken.None);if(!N)throw new Error("Manifest was not found");B=N.engines.vscode}return B}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const T=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,c.$2o)(T),N=[],V={},G=[];if(B){for(const te of B.malicious)N.push({id:te});if(B.migrateToPreRelease)for(const[te,oe]of Object.entries(B.migrateToPreRelease))(!oe.engine||(0,l.$Uo)(oe.engine,this.u.version,this.u.date))&&(V[te.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(B.deprecated)for(const[te,oe]of Object.entries(B.deprecated))oe&&(V[te.toLowerCase()]=(0,R.$Ff)(oe)?{}:oe);if(B.search)for(const te of B.search)G.push(te)}return{malicious:N,deprecated:V,search:G}}};se=pe([X(1,c.$Vo),X(2,y.$aj),X(3,C.$Zh),X(4,b.$fl),X(5,g.$bk),X(6,p.$sj),X(7,d.$mi)],se);let Z=class extends se{constructor(T,B,N,V,G,te,oe,ue){super(T,B,N,V,G,te,oe,ue)}};e.$fp=Z,e.$fp=Z=pe([X(0,u.$9o),X(1,c.$Vo),X(2,y.$aj),X(3,C.$Zh),X(4,b.$fl),X(5,g.$bk),X(6,p.$sj),X(7,d.$mi)],Z);let z=class extends se{constructor(T,B,N,V,G,te,oe){super(void 0,T,B,N,V,G,te,oe)}};e.$gp=z,e.$gp=z=pe([X(0,c.$Vo),X(1,y.$aj),X(2,C.$Zh),X(3,b.$fl),X(4,g.$bk),X(5,p.$sj),X(6,d.$mi)],z)}),define(ae[81],ce([0,1,4,3,2,21,33,25,18,8,12]),function(ie,e,I,A,L,j,O,R,S,d,C){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$1u=e.$Zu=void 0,e.$Zu=(0,I.$Sh)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let l=class extends L.$Rc{static{E=this}static{this.a=512*1024}static b(y){return`extensionKeys/${(0,O.$Go)(y.id)}@${y.version}`}static c(y){const p=w.exec(y);if(p&&p[1])return{id:p[1],version:p[2]}}static async removeOutdatedExtensionVersions(y,p){const c=await y.getInstalled(),f=[];for(const[u,b]of E.f(p)){const k=c.find(s=>(0,O.$Co)(s.identifier,{id:u}))?.manifest.version;for(const s of b)k!==s&&f.push(E.b({id:u,version:s}))}for(const u of f)p.remove(u,0)}static f(y){const p=new Map,c=y.keys(0,1);for(const f of c){const u=E.c(f);if(u){let b=p.get(u.id.toLowerCase());b||p.set(u.id.toLowerCase(),b=[]),b.push(u.version)}}return p}constructor(y,p,c){super(),this.j=y,this.m=p,this.n=c,this.g=this.B(new A.$Od),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=E.f(y),this.B(this.j.onDidChangeValue(0,void 0,this.B(new L.$Qc))(f=>this.r(f)))}r(y){if(this.h.has(y.key.toLowerCase())){this.g.fire();return}const p=E.c(y.key);if(p){if(this.j.get(y.key,0)===void 0)this.h.delete(p.id.toLowerCase());else{let c=this.h.get(p.id.toLowerCase());c||this.h.set(p.id.toLowerCase(),c=[]),c.push(p.version),this.g.fire()}return}}s(y){if((0,C.$zf)(y))return y;const p=y.manifest?y.manifest.publisher:y.publisher,c=y.manifest?y.manifest.name:y.name;return(0,O.$Fo)(p,c)}getExtensionState(y,p){const c=this.s(y),f=this.getExtensionStateRaw(y,p);if(f)try{return JSON.parse(f)}catch(u){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${c}, global: ${p}): ${u}`)}}getExtensionStateRaw(y,p){const c=this.s(y),f=this.j.get(c,p?0:1);return f&&f?.length>E.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${c}, global: ${p}): ${f.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),f}setExtensionState(y,p,c){const f=this.s(y);p===void 0?this.j.remove(f,c?0:1):this.j.store(f,JSON.stringify(p),c?0:1,1)}setKeysForSync(y,p){this.j.store(E.b(y),JSON.stringify(p),0,1)}getKeysForSync(y){const p=this.m.extensionSyncedKeys?.[y.id.toLowerCase()],c=this.j.get(E.b(y),0),f=c?JSON.parse(c):void 0;return f&&p?(0,S.$Lb)([...f,...p]):f||p}addToMigrationList(y,p){if(y!==p){const c=this.t.filter(f=>!f.includes(y)&&!f.includes(p));c.push([y,p]),this.t=c}}getSourceExtensionToMigrate(y){const p=this.t.find(([,c])=>y===c);return p?p[0]:void 0}get t(){const y=this.j.get("extensionStorage.migrationList",-1,"[]");try{const p=JSON.parse(y);if(Array.isArray(p))return p}catch{}return[]}set t(y){y.length?this.j.store("extensionStorage.migrationList",JSON.stringify(y),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$1u=l,e.$1u=l=E=pe([X(0,j.$9o),X(1,R.$sj),X(2,d.$aj)],l)}),define(ae[247],ce([0,1,29,11,25,14,98,56,21,22,221]),function(ie,e,I,A,L,j,O,R,S,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j0b=void 0;let E=class extends C.$u6b{constructor(l,g,y,p,c,f,u,b){super(l.userHome,c,g,y,p,f,u,b)}};e.$j0b=E,e.$j0b=E=pe([X(0,j.$1h),X(1,d.$fl),X(2,I.$co),X(3,S.$9o),X(4,R.$_7b),X(5,O.$DWb),X(6,A.$bk),X(7,L.$sj)],E)}),define(ae[248],ce([0,1,105,3,22,14,2,8,16,66,25,5,6,101,20,164,36,21,12,131,19]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f0b=void 0;const k=[I.$$9b,I.$_9b],s="remoteTunnelSession",a="remoteTunnelIsService";let n=class extends O.$Rc{constructor(o,v,m,h,$,D,F){super(),this.y=o,this.z=v,this.C=m,this.D=D,this.F=F,this.f=new A.$Od,this.onDidTokenFailed=this.f.event,this.g=new A.$Od,this.onDidChangeTunnelStatus=this.g.event,this.h=new A.$Od,this.onDidChangeMode=this.h.event,this.n=I.$99b,this.w=!1,this.I=(M,U)=>{U?this.j.error(M):this.j.info(M)},this.j=this.B(h.createLogger((0,b.$wg)(m.logsHome,`${I.$a0b}.log`),{id:I.$a0b,name:I.$b0b})),this.t=new w.$Rg(100),this.B(this.j.onDidChangeLogLevel(M=>this.j.info("Log level changed to "+(0,R.$pj)(M)))),this.B($.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(D.onDidChangeConfiguration(M=>{k.some(U=>M.affectsConfiguration(U))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=I.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(o){this.s=o,this.g.fire(o)}H(o){t(this.n,o)||(this.n=o,this.S(o),this.h.fire(this.n),o.active?(this.j.info(`Session updated: ${o.session.accountLabel} (${o.session.providerId}) (service=${o.asService})`),o.session.token&&this.j.info(`Session token updated: ${o.session.accountLabel} (${o.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(o){if(this.w)return this.s;this.w=!0,this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let o;E.$j?o=this.C.appRoot:o=(0,S.$lc)((0,S.$lc)(this.C.appRoot)),this.u=(0,S.$ic)(o,"bin",`${this.z.tunnelApplicationName}${E.$i?".exe":""}`)}return this.u}async startTunnel(o){if(t(this.n,o)&&this.s.type!=="disconnected")return this.s;this.H(o);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const o=this.n.asService;this.H(I.$99b);try{o&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}try{await this.O("stop",["kill"])}catch(v){this.j.error(v)}this.G(I.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let o="",v=!1;const m=(U,q)=>{q?this.j.error(U):o+=U,!this.C.isBuilt&&U.startsWith("   Compiling")&&this.G(I.TunnelStates.connecting((0,y.localize)(0,null)))},h=this.O("status",["status"],m);this.r=h;try{if(await h,this.r!==h)return;let U;try{U=JSON.parse(o.trim().split(`
`).find(q=>q.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(o.trim())}`),this.G(I.TunnelStates.disconnected());return}if(v=U.service_installed,this.j.info(U.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!U.tunnel&&!this.n.active){this.G(I.TunnelStates.disconnected());return}}catch(U){this.j.error(U),this.G(I.TunnelStates.disconnected());return}finally{this.r===h&&(this.r=void 0)}const $=this.n.active?this.n.session:void 0;if($&&$.token){const U=$.token;this.G(I.TunnelStates.connecting((0,y.localize)(1,null,$.accountLabel,$.providerId)));const q=(K,x)=>{K=K.replaceAll(U,"*".repeat(4)),m(K,x)},Y=this.O("login",["user","login","--provider",$.providerId,"--access-token",U,"--log",(0,R.$pj)(this.j.getLevel())],q);this.r=Y;try{if(await Y,this.r!==Y)return}catch(K){this.j.error(K),this.r=void 0,this.f.fire($),this.G(I.TunnelStates.disconnected($));return}}const D=this.Q();D?this.G(I.TunnelStates.connecting((0,y.localize)(2,null,D))):this.G(I.TunnelStates.connecting((0,y.localize)(3,null)));const F=["--accept-server-license-terms","--log",(0,R.$pj)(this.j.getLevel())];D?F.push("--name",D):F.push("--random-name");let M=!1;return this.n.active&&this.n.asService&&!v&&(M=await this.M(F)===!1),this.N($,F,M)}async M(o){let v;try{v=await this.O("serviceInstall",["service","install",...o])}catch(m){this.j.error(m),v=1}if(v!==0){const m=(0,y.localize)(4,null);return this.j.warn(m),this.G(I.TunnelStates.connecting(m)),!1}return!0}async N(o,v,m){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let h=!1;const $=this.O("tunnel",v,(D,F)=>{F?this.j.error(D):this.j.info(D),D.includes("Connected to an existing tunnel process")&&(h=!0);const M=D.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(M){const U={link:M[1],domain:M[2],tunnelName:M[4],isAttached:h};this.G(I.TunnelStates.connected(U,m))}else D.match(/error refreshing token/)&&($.cancel(),this.f.fire(o),this.G(I.TunnelStates.disconnected(o)))});this.r=$,$.finally(()=>{$===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=I.$99b,this.G(I.TunnelStates.disconnected()))})}O(o,v,m=this.I){return(0,w.$Ig)(h=>new Promise(($,D)=>{h.isCancellationRequested&&$(-1);let F;const M=["ignore","pipe","pipe"];if(h.onCancellationRequested(()=>{F&&(this.j.info(`${o} terminating(${F.pid})`),F.kill())}),!this.C.isBuilt)m(`Building tunnel CLI from sources and run
`,!1),m(`${o} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),F=(0,d.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,S.$ic)(this.C.appRoot,"cli"),stdio:M});else{m(`Running tunnel CLI
`,!1);const U=this.J();m(`${o} Spawning: ${U} tunnel ${v.join(" ")}
`,!1),F=(0,d.spawn)(U,["tunnel",...v],{cwd:(0,p.homedir)(),stdio:M})}F.stdout.pipe(new u.$LT(`
`)).on("data",U=>{if(F){const q=U.toString();m(q,!1)}}),F.stderr.pipe(new u.$LT(`
`)).on("data",U=>{if(F){const q=U.toString();m(q,!0)}}),F.on("exit",U=>{F&&(m(`${o} exit(${F.pid}): + ${U} `,!1),F=void 0,$(U||0))}),F.on("error",U=>{F&&(m(`${o} error(${F.pid}): + ${U} `,!0),F=void 0,D())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(I.$_9b)}Q(){let o=this.D.getValue(I.$$9b)||(0,p.hostname)();return o=o.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),o||void 0}R(){try{const o=this.F.get(s,-1),v=this.F.getBoolean(a,-1,!1);if(o){const m=JSON.parse(o);if(m&&(0,f.$zf)(m.accountLabel)&&(0,f.$zf)(m.sessionId)&&(0,f.$zf)(m.providerId))return{active:!0,session:m,asService:v};this.j.error("Problems restoring session from storage, invalid format",m)}}catch(o){this.j.error("Problems restoring session from storage",o)}return I.$99b}S(o){if(o.active){const v={providerId:o.session.providerId,sessionId:o.session.sessionId,accountLabel:o.session.accountLabel};this.F.store(s,JSON.stringify(v),-1,1),this.F.store(a,o.asService,-1,1)}else this.F.remove(s,-1),this.F.remove(a,-1)}};e.$f0b=n,e.$f0b=n=pe([X(0,L.$fl),X(1,C.$sj),X(2,j.$1h),X(3,R.$bj),X(4,l.$d0b),X(5,g.$mi),X(6,c.$9o)],n);function i(r,o){return r&&o?r.sessionId===o.sessionId&&r.providerId===o.providerId&&r.token===o.token:r===o}const t=(r,o)=>r.active!==o.active?!1:r.active&&o.active?r.asService===o.asService&&i(r.session,o.session):!0}),define(ae[249],ce([0,1,6,2,23,19,68,21,76,17]),function(ie,e,I,A,L,j,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k0b=void 0;class C extends R.$$o{constructor(w,l,g,y){super(),this.bb=w,this.cb=l,this.db=g,this.eb=y,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new A.$Qc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new A.$Qc),this.ab=this.hb(this.bb)}fb(){const w=this.B(new S.$ZDb(this.db.getChannel("storage"))),l=this.B(new O.$5o(w));return this.B(l.onDidChangeStorage(g=>this.u(-1,g))),l}gb(w){this.X.clear(),this.W=w;let l;if((0,R.$_o)(w))l=this.U;else{const g=this.X.add(new S.$1Db(this.db.getChannel("storage"),w));l=this.X.add(new O.$5o(g))}return this.X.add(l.onDidChangeStorage(g=>this.u(0,g))),l}hb(w){this.$.clear(),this.Z=w?.id;let l;if(w){const g=this.$.add(new S.$2Db(this.db.getChannel("storage"),w));l=this.$.add(new O.$5o(g)),this.$.add(l.onDidChangeStorage(y=>this.u(1,y)))}return l}async O(){await I.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(w){switch(w){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(w){switch(w){case-1:return this.s.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;default:return this.Z?`${(0,j.$wg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:L.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await I.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(w){if(!this.M(this.W,w))return;const l=this.Y,g=l.items;l!==this.U&&await l.close(),this.Y=this.gb(w),await this.Y.init(),this.N(g,this.Y,0)}async S(w,l){const g=this.ab,y=g?.items??new Map;await g?.close(),this.ab=this.hb(w),await this.ab.init(),this.N(y,this.ab,1)}hasScope(w){return(0,d.$Mk)(w)?this.W.id===w.id:this.Z===w.id}}e.$k0b=C}),define(ae[250],ce([0,1,3,2,17,92]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1N=e.$ZN=void 0;class O{constructor(d,C){this.a=d,this.b=C}listen(d,C){const E=this.b(d);switch(C){case"onDidChangeProfiles":return I.Event.map(this.a.onDidChangeProfiles,w=>({all:w.all.map(l=>(0,j.$Qm)({...l},E)),added:w.added.map(l=>(0,j.$Qm)({...l},E)),removed:w.removed.map(l=>(0,j.$Qm)({...l},E)),updated:w.updated.map(l=>(0,j.$Qm)({...l},E))}))}throw new Error(`Invalid listen ${C}`)}async call(d,C,E){const w=this.b(d);switch(C){case"createProfile":{const l=await this.a.createProfile(E[0],E[1],E[2]);return(0,j.$Qm)({...l},w)}case"updateProfile":{let l=(0,L.$Ok)((0,j.$Rm)(E[0],w),this.a.profilesHome.scheme);return l=await this.a.updateProfile(l,E[1]),(0,j.$Qm)({...l},w)}case"removeProfile":{const l=(0,L.$Ok)((0,j.$Rm)(E[0],w),this.a.profilesHome.scheme);return this.a.removeProfile(l)}}throw new Error(`Invalid call ${C}`)}}e.$ZN=O;class R extends A.$Rc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(d,C,E){super(),this.profilesHome=C,this.f=E,this.a=[],this.b=this.B(new I.$Od),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=d.map(w=>(0,L.$Ok)(w,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(w=>{const l=w.added.map(p=>(0,L.$Ok)(p,this.profilesHome.scheme)),g=w.removed.map(p=>(0,L.$Ok)(p,this.profilesHome.scheme)),y=w.updated.map(p=>(0,L.$Ok)(p,this.profilesHome.scheme));this.a=w.all.map(p=>(0,L.$Ok)(p,this.profilesHome.scheme)),this.b.fire({added:l,removed:g,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(d){this.c=d}isEnabled(){return this.c}async createNamedProfile(d,C,E){const w=await this.f.call("createNamedProfile",[d,C,E]);return(0,L.$Ok)(w,this.profilesHome.scheme)}async createProfile(d,C,E,w){const l=await this.f.call("createProfile",[d,C,E,w]);return(0,L.$Ok)(l,this.profilesHome.scheme)}async createTransientProfile(d){const C=await this.f.call("createTransientProfile",[d]);return(0,L.$Ok)(C,this.profilesHome.scheme)}async setProfileForWorkspace(d,C){await this.f.call("setProfileForWorkspace",[d,C])}removeProfile(d){return this.f.call("removeProfile",[d])}async updateProfile(d,C){const E=await this.f.call("updateProfile",[d,C]);return(0,L.$Ok)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$1N=R}),define(ae[59],ce([0,1,2,68,4,21,3,76,17]),function(ie,e,I,A,L,j,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Db=e.$5Db=e.$4Db=void 0,e.$4Db=(0,L.$Sh)("IUserDataProfileStorageService");let d=class extends I.$Rc{constructor(l){super(),this.a=l}async readStorageData(l){return this.withProfileScopedStorageService(l,async g=>this.b(g))}async updateStorageData(l,g,y){return this.withProfileScopedStorageService(l,async p=>this.c(p,g,y))}async withProfileScopedStorageService(l,g){if(this.a.hasScope(l))return g(this.a);const y=await this.g(l),p=new E(y);try{await p.initialize();const c=await g(p);return await p.flush(),c}finally{p.dispose(),await this.f(y)}}b(l){const g=new Map,y=p=>{for(const c of l.keys(0,p))g.set(c,{value:l.get(c,0),target:p})};return y(0),y(1),g}c(l,g,y){l.storeAll(Array.from(g.entries()).map(([p,c])=>({key:p,value:c,scope:0,target:y})),!0)}async f(l){try{await l.close()}finally{(0,I.$Lc)(l)&&l.dispose()}}};e.$5Db=d,e.$5Db=d=pe([X(0,j.$9o)],d);class C extends d{constructor(l,g,y,p){super(y),this.j=l;const c=l.getChannel("profileStorageListener"),f=this.B(new I.$Sc);this.h=this.B(new O.$Od({onWillAddFirstListener:()=>{f.value=c.listen("onDidChange")(u=>{p.trace("profile storage changes",u),this.h.fire({targetChanges:u.targetChanges.map(b=>(0,S.$Ok)(b,g.profilesHome.scheme)),valueChanges:u.valueChanges.map(b=>({...b,profile:(0,S.$Ok)(b.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>f.value=void 0})),this.onDidChange=this.h.event}async g(l){const g=this.j.getChannel("storage");return(0,j.$_o)(l)?new R.$ZDb(g):new R.$1Db(g,l)}}e.$6Db=C;class E extends j.$$o{constructor(l){super({flushInterval:100}),this.s=this.B(new A.$5o(l))}O(){return this.s.init()}P(l){return l===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ae[251],ce([0,1,21,8,17,55,59]),function(ie,e,I,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$29b=void 0;let R=class extends O.$6Db{constructor(d,C,E,w){super(d,C,E,w)}};e.$29b=R,e.$29b=R=pe([X(0,j.$n9b),X(1,L.$Nk),X(2,I.$9o),X(3,A.$aj)],R)}),define(ae[39],ce([0,1,18,6,15,26,3,35,2,27,12,169,20,14,11,8,43,21,22,28,24,17]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f,u,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XEb=e.$WEb=e.$VEb=e.$UEb=e.$TEb=e.$SEb=e.$REb=void 0;function s(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||a(v.syncData)))}e.$REb=s;function a(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$SEb=a;function n(v,m){return`${(0,d.$rf)(v)}${m.isDefault?"":` (${m.name})`}`}e.$TEb=n;let i=class extends S.$Rc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(m,h,$,D,F,M,U,q,Y,K,x,H){super(),this.syncResource=m,this.collection=h,this.G=$,this.H=D,this.I=F,this.J=M,this.L=U,this.M=q,this.N=Y,this.O=K,this.P=x,this.c=null,this.m="idle",this.n=this.B(new O.$Od),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$Od),this.onDidChangeConflicts=this.t.event,this.u=this.B(new A.$Sg(50)),this.w=this.B(new O.$Od),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(m.syncResource,m.profile),this.h=H.extUri,this.f=this.h.joinPath(D.userDataSyncHome,...(0,b.$Rgb)(m.profile.isDefault?void 0:m.profile.id,m.syncResource)),this.g=this.h.joinPath(this.f,b.$ahb),this.y=(0,b.$Sgb)(m.profile.isDefault?void 0:m.profile.id,m.syncResource,D,this.h),this.j=(0,p.$cp)(D,$,F)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const m=await this.c;this.c=null;const h=await this.Y(m.remoteUserData,m.lastSyncUserData,!0,this.ob());this.S(h)}else{this.O.trace(`${this.D}: Checking for local changes...`);const m=await this.getLastSyncUserData();(m?await this.ub(m):!0)&&this.w.fire()}}S(m){this.m!==m&&(this.m=m,this.n.fire(m))}async sync(m,h={}){await this.U(m,!0,this.ob(),h)}async preview(m,h,$={}){return this.U(m,!1,h,$)}async apply(m,h={}){try{this.F={...h};const $=await this.ab(m);return this.S($),this.c}finally{this.F={}}}async U(m,h,$,D){try{if(this.F={...D},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let F="idle";try{const M=await this.getLastSyncUserData(),U=await this.X(m,M);return F=await this.Y(U,M,h,$),F==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(F)}}finally{this.F={}}}async replace(m){const h=this.kb(m);if(!h)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const $=await this.getLastSyncUserData(),D=await this.X(null,$),F=await this.W(D),M=await this.qb({ref:D.ref,syncData:h},$,F,this.ob(),j.CancellationToken.None),U=[];for(const q of M){const Y=await this.sb(q,q.remoteResource,void 0,j.CancellationToken.None),{remoteChange:K}=await this.sb(q,q.previewResource,q.remoteContent,j.CancellationToken.None);U.push([q,{...Y,remoteChange:K!==0?K:2}])}await this.tb(D,$,U,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(m){const h=await this.j;return!!m.syncData?.machineId&&m.syncData.machineId===h}async X(m,h){if(h){const $=m?m[this.resource]:void 0;if(h.ref===$||$===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async Y(m,h,$,D){if(m.syncData&&m.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new b.$Zgb((0,E.localize)(0,null,this.resource,this.pb,m.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(m,h,$,D)}catch(F){if(F instanceof b.$Zgb)switch(F.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(m,h,$,D);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),m=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.Y(m,h,$,D)}throw F}}async Z(m,h,$,D){try{const F=await this.W(m),M=!F&&h===null&&this.gb()!==void 0,U=$&&!M;this.c||(this.c=(0,A.$Ig)(Y=>this.eb(m,h,F,U,D,Y)));let q=await this.c;if($&&M){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Y of q.resourcePreviews)q=await this.accept(Y.remoteResource)||q}return this.cb(q.resourcePreviews),q.resourcePreviews.some(({mergeState:Y})=>Y==="conflict")?"hasConflicts":$?await this.ab(!1):"syncing"}catch(F){throw this.c=null,F}}async merge(m){return await this.$(m,async h=>{const $=await this.rb(h,j.CancellationToken.None);await this.G.writeFile(h.previewResource,L.$ce.fromString($?.content||""));const D=$&&!$.hasConflicts?await this.sb(h,h.previewResource,void 0,j.CancellationToken.None):void 0;return h.acceptResult=D,h.mergeState=$.hasConflicts?"conflict":D?"accepted":"preview",h.localChange=D?D.localChange:$.localChange,h.remoteChange=D?D.remoteChange:$.remoteChange,h}),this.c}async accept(m,h){return await this.$(m,async $=>{const D=await this.sb($,m,h,j.CancellationToken.None);return $.acceptResult=D,$.mergeState="accepted",$.localChange=D.localChange,$.remoteChange=D.remoteChange,$}),this.c}async discard(m){return await this.$(m,async h=>{const $=await this.rb(h,j.CancellationToken.None);return await this.G.writeFile(h.previewResource,L.$ce.fromString($.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=$.localChange,h.remoteChange=$.remoteChange,h}),this.c}async $(m,h){if(!this.c)return;let $=await this.c;const D=$.resourcePreviews.findIndex(({localResource:F,remoteResource:M,previewResource:U})=>this.h.isEqual(F,m)||this.h.isEqual(M,m)||this.h.isEqual(U,m));D!==-1&&(this.c=(0,A.$Ig)(async F=>{const M=[...$.resourcePreviews];return M[D]=await h(M[D]),{...$,resourcePreviews:M}}),$=await this.c,this.cb($.resourcePreviews),$.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(m){if(!this.c)return"idle";const h=await this.c;return h.resourcePreviews.some(({mergeState:$})=>$==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:$})=>$!=="accepted")?"syncing":(await this.tb(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map($=>[$,$.acceptResult]),m),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(m){const h=m.filter(({mergeState:$})=>$==="conflict");(0,I.$tb)(this.s,h,($,D)=>this.h.isEqual($.previewResource,D.previewResource))||(this.s=h,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const m=await this.getLastSyncUserData();return!!m&&m.syncData!==null}async db(m){const h=this.c?await this.c:null;if(h)for(const $ of h.resourcePreviews){if(this.h.isEqual($.acceptedResource,m))return $.acceptResult?$.acceptResult.content:null;if(this.h.isEqual($.remoteResource,m))return $.remoteContent;if(this.h.isEqual($.localResource,m))return $.localContent;if(this.h.isEqual($.baseResource,m))return $.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(m){(0,g.$sk)(m)!==1&&this.O.error(m)}}async eb(m,h,$,D,F,M){const U=await this.qb(m,h,$,F,M),q=[];for(const Y of U){const K=Y.previewResource.with({scheme:b.$_gb,authority:"accepted"});if(Y.localChange===0&&Y.remoteChange===0)q.push({...Y,acceptedResource:K,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=D?await this.rb(Y,M):void 0;if(M.isCancellationRequested)break;await this.G.writeFile(Y.previewResource,L.$ce.fromString(x?.content||""));const H=x&&!x.hasConflicts?await this.sb(Y,Y.previewResource,void 0,M):void 0;q.push({...Y,acceptResult:H,mergeState:x?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:x?x.localChange:Y.localChange,remoteChange:H?H.remoteChange:x?x.remoteChange:Y.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:m,lastSyncUserData:h,resourcePreviews:q,isLastSyncFromCurrentMachine:$}}async getLastSyncUserData(){let m=this.gb();if(m||(m=await this.jb()),!m)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const h=JSON.parse(m),$=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!h.version&&!!$&&h.version!==$,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${$}.`),await this.resetLocal(),null;let D,F=1;for(;D===void 0&&F++<6;)try{const M=await this.hb();M&&(M.ref===h.ref?D=M.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof g.$wk&&M.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(M instanceof b.$Zgb)throw M;this.O.error(M,F)}}if(D===void 0)try{const M=await this.J.resolveResourceContent(this.resource,h.ref,this.collection,this.F);D=M===null?null:this.kb(M),await this.ib({ref:h.ref,syncData:D})}catch(M){if(M instanceof b.$Zgb&&M.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw M}return D===void 0?null:{...h,syncData:D}}async fb(m,h={}){if(h.ref||h.version)throw new Error("Cannot have core properties as additional");const $=this.M.getResourceSyncStateVersion(this.resource),D={ref:m.ref,version:$,...h};this.I.store(this.z,JSON.stringify(D),-1,1),await this.ib(m)}gb(){return this.I.get(this.z,-1)}async hb(){const m=(await this.G.readFile(this.y)).value.toString();try{const h=m?JSON.parse(m):void 0;if(s(h))return h}catch(h){this.O.error(h)}}async ib(m){await this.G.writeFile(this.y,L.$ce.fromString(JSON.stringify(m)))}async jb(){try{const m=await this.G.readFile(this.y),h=JSON.parse(m.value.toString());await this.G.del(this.y),h.ref&&h.content!==void 0?(this.I.store(this.z,JSON.stringify({...h,content:void 0}),-1,1),await this.ib({ref:h.ref,syncData:h.content===null?null:JSON.parse(h.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,h)}catch(m){m instanceof g.$wk&&m.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(m)}return this.I.get(this.z,-1)}async getRemoteUserData(m){const{ref:h,content:$}=await this.lb(m);let D=null;return $!==null&&(D=this.kb($)),{ref:h,syncData:D}}kb(m){try{const h=JSON.parse(m);if(a(h))return h}catch(h){this.O.error(h)}throw new b.$Zgb((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(m){const h=m?{ref:m.ref,content:m.syncData?JSON.stringify(m.syncData):null}:null;return this.J.readResource(this.resource,h,this.collection,this.F)}async mb(m,h){const $=await this.j,D={version:this.pb,machineId:$,content:m};try{return h=await this.J.writeResource(this.resource,JSON.stringify(D),h,this.collection,this.F),{ref:h,syncData:D}}catch(F){throw F instanceof b.$Zgb&&F.code==="TooLarge"&&(F=new b.$Zgb(F.message,F.code,this.resource)),F}}async nb(m){const h={version:this.pb,content:m};return this.L.writeResource(this.resource,JSON.stringify(h),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(b.$Mgb)}};e.$UEb=i,e.$UEb=i=pe([X(2,g.$bk),X(3,l.$Zh),X(4,c.$9o),X(5,b.$Ugb),X(6,b.$Vgb),X(7,b.$5gb),X(8,f.$fl),X(9,b.$0gb),X(10,w.$mi),X(11,u.$Lk)],i);let t=class extends i{constructor(m,h,$,D,F,M,U,q,Y,K,x,H,Q){super(h,$,D,F,M,U,q,Y,K,x,H,Q),this.r=m,this.B(this.G.watch(this.h.dirname(m))),this.B(this.G.onDidFilesChange(J=>this.yb(J)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(m,h,$){try{h?await this.G.writeFile(this.r,L.$ce.fromString(m),$?void 0:h):await this.G.createFile(this.r,L.$ce.fromString(m),{overwrite:$})}catch(D){throw D instanceof g.$wk&&D.fileOperationResult===1||D instanceof g.$wk&&D.fileOperationResult===3?new b.$Zgb(D.message,"LocalPreconditionFailed"):D}}async xb(){try{await this.G.del(this.r)}catch(m){if(!(m instanceof g.$wk&&m.fileOperationResult===1))throw m}}yb(m){m.contains(this.r)&&this.Q()}};e.$VEb=t,e.$VEb=t=pe([X(3,g.$bk),X(4,l.$Zh),X(5,c.$9o),X(6,b.$Ugb),X(7,b.$Vgb),X(8,b.$5gb),X(9,f.$fl),X(10,b.$0gb),X(11,w.$mi),X(12,u.$Lk)],t);let r=class extends t{constructor(m,h,$,D,F,M,U,q,Y,K,x,H,Q,J){super(m,h,$,D,F,M,U,q,Y,K,x,Q,J),this.zb=H,this.Bb=void 0}Ab(m,h){const $=[],D=(0,R.$Zm)(m,$,{allowEmptyContent:!0,allowTrailingComma:!0});return $.length>0||!(0,C.$Gf)(D)&&h!==Array.isArray(D)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$WEb=r,e.$WEb=r=pe([X(3,g.$bk),X(4,l.$Zh),X(5,c.$9o),X(6,b.$Ugb),X(7,b.$Vgb),X(8,b.$5gb),X(9,f.$fl),X(10,b.$0gb),X(11,b.$9gb),X(12,w.$mi),X(13,u.$Lk)],r);let o=class{constructor(m,h,$,D,F,M,U){this.resource=m,this.g=h,this.h=$,this.j=D,this.k=F,this.l=M,this.d=U.extUri,this.f=(0,b.$Sgb)(void 0,this.resource,$,this.d)}async initialize({ref:m,content:h}){if(!h){this.j.info("Remote content does not exist.",this.resource);return}const $=this.m(h);if($)try{await this.o({ref:m,syncData:$})}catch(D){this.j.error(D)}}m(m){try{const h=JSON.parse(m);if(a(h))return h}catch(h){this.j.error(h)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(m,h={}){if(h.ref||h.version)throw new Error("Cannot have core properties as additional");const $={ref:m.ref,version:void 0,...h};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify($),-1,1),await this.k.writeFile(this.f,L.$ce.fromString(JSON.stringify(m)))}};e.$XEb=o,e.$XEb=o=pe([X(1,k.$Nk),X(2,l.$Zh),X(3,y.$aj),X(4,g.$bk),X(5,c.$9o),X(6,u.$Lk)],o)}),define(ae[114],ce([0,1,6,26,7,3,42,2,27,20,14,113,29,33,81,44,11,4,72,8,21,22,28,17,39,232,111,24,59]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f,u,b,k,s,a,n,i,t,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G4b=e.$F4b=e.$E4b=e.$D4b=e.$C4b=void 0;async function v(M,U){const q=JSON.parse(M.content);if(M.version===1||M.version===2){const Y=(await U.getInstalled(0)).filter(K=>K.isBuiltin);for(const K of q)M.version===1&&(K.enabled===!1&&(K.disabled=!0),delete K.enabled),M.version===2&&Y.every(x=>!(0,l.$Co)(x.identifier,K.identifier))&&(K.installed=!0)}return q}function m(M){return JSON.parse(M.content)}e.$C4b=m;function h(M,U){return M.sort((q,Y)=>!q.identifier.uuid&&Y.identifier.uuid?-1:q.identifier.uuid&&!Y.identifier.uuid?1:(0,S.$Ve)(q.identifier.id,Y.identifier.id)),U?(0,O.$oT)(M,{}):JSON.stringify(M)}e.$D4b=h;let $=class extends n.$UEb{constructor(U,q,Y,K,x,H,Q,J,W,ee,ne,_,se,Z,z,P,T){super({syncResource:"extensions",profile:U},q,K,Y,x,H,Q,_,se,ee,ne,z),this.Cb=J,this.Db=W,this.Eb=T,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$_gb,authority:"base"}),this.yb=this.wb.with({scheme:r.$_gb,authority:"local"}),this.zb=this.wb.with({scheme:r.$_gb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$_gb,authority:"accepted"}),this.Bb=this.Eb.createInstance(D),this.B(j.Event.any(j.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:N})=>!!N)),j.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),j.Event.filter(P.onDidChange,B=>B.valueChanges.some(({profile:N,changes:V})=>this.syncResource.profile.id===N.id&&V.some(G=>G.key===w.$do))),Z.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(U,q){const Y=U.syncData?await v(U.syncData,this.Cb):null,K=q?.skippedExtensions??[],x=q?.builtinExtensions??null,H=q?.syncData?await v(q.syncData,this.Cb):null,{localExtensions:Q,ignoredExtensions:J}=await this.Bb.getLocalExtensions(this.syncResource.profile);Y?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:W,remote:ee}=(0,i.$B4b)(Q,Y,H,K,J,x),ne={local:W,remote:ee,content:this.Hb(Q,W.added,W.updated,W.removed),localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:ee!==null?2:0},_=this.Ob(Q,!1);return[{skippedExtensions:K,builtinExtensions:x,baseResource:this.xb,baseContent:H?this.Ob(H,!1):_,localResource:this.yb,localContent:_,localExtensions:Q,remoteResource:this.zb,remoteExtensions:Y,remoteContent:Y?this.Ob(Y,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(U){const q=U.syncData?await v(U.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:K}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,i.$B4b)(Y,q,q,U.skippedExtensions||[],K,U.builtinExtensions||[]);return x!==null}Hb(U,q,Y,K){const x=[...q,...Y],H=new Set,Q=J=>{H.add(J.id.toLowerCase()),J.uuid&&H.add(J.uuid)};x.forEach(({identifier:J})=>Q(J)),K.forEach(Q);for(const J of U)H.has(J.identifier.id.toLowerCase())||J.identifier.uuid&&H.has(J.identifier.uuid)||x.push(J);return this.Ob(x,!1)}async rb(U,q){return{...U.previewResult,hasConflicts:!1}}async sb(U,q,Y,K){if(this.h.isEqual(q,this.yb))return this.Kb(U);if(this.h.isEqual(q,this.zb))return this.Lb(U);if(this.h.isEqual(q,this.wb))return U.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Kb(U){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),K=(0,i.$B4b)(U.localExtensions,null,null,U.skippedExtensions,Y,U.builtinExtensions),{local:x,remote:H}=K;return{content:U.localContent,local:x,remote:H,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:H!==null?2:0}}async Lb(U){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),K=U.remoteContent?JSON.parse(U.remoteContent):null;if(K!==null){const x=(0,i.$B4b)(U.localExtensions,K,U.localExtensions,[],Y,U.builtinExtensions),{local:H,remote:Q}=x;return{content:U.remoteContent,local:H,remote:Q,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:Q!==null?2:0}}else return{content:U.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(U,q,Y,K){let{skippedExtensions:x,builtinExtensions:H,localExtensions:Q}=Y[0][0];const{local:J,remote:W,localChange:ee,remoteChange:ne}=Y[0][1];if(ee===0&&ne===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==0&&(await this.nb(JSON.stringify(Q)),x=await this.Bb.updateLocalExtensions(J.added,J.removed,J.updated,x,this.syncResource.profile)),W){this.O.trace(`${this.D}: Updating remote extensions...`);const _=JSON.stringify(W.all);U=await this.mb(_,K?null:U.ref),this.O.info(`${this.D}: Updated remote extensions.${W.added.length?` Added: ${JSON.stringify(W.added.map(se=>se.identifier.id))}.`:""}${W.updated.length?` Updated: ${JSON.stringify(W.updated.map(se=>se.identifier.id))}.`:""}${W.removed.length?` Removed: ${JSON.stringify(W.removed.map(se=>se.identifier.id))}.`:""}`)}q?.ref!==U.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(Q,H),await this.fb(U,{skippedExtensions:x,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(_=>_.identifier.id))}.`:""}`))}Nb(U,q){const Y=new Set,K=[];for(const x of U)Y.add(x.identifier.id.toLowerCase()),x.installed||K.push(x.identifier);if(q)for(const x of q)Y.has(x.id.toLowerCase())||K.push(x);return K}async resolveContent(U){if(this.h.isEqual(this.zb,U)||this.h.isEqual(this.xb,U)||this.h.isEqual(this.yb,U)||this.h.isEqual(this.Ab,U)){const q=await this.db(U);return q&&this.Ob(JSON.parse(q),!0)}return null}Ob(U,q){return h(U,q)}async hasLocalData(){try{const{localExtensions:U}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(U.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$E4b=$,e.$E4b=$=pe([X(2,C.$Zh),X(3,p.$bk),X(4,b.$9o),X(5,r.$Ugb),X(6,r.$Vgb),X(7,w.$co),X(8,t.$CFb),X(9,r.$0gb),X(10,d.$mi),X(11,r.$5gb),X(12,k.$fl),X(13,g.$Zu),X(14,s.$Lk),X(15,o.$4Db),X(16,c.$Rh)],$);let D=class{constructor(U,q,Y,K,x,H){this.a=U,this.b=q,this.c=Y,this.d=K,this.f=x,this.g=H}async getLocalExtensions(U){const q=await this.a.getInstalled(void 0,U.extensionsResource),Y=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(U,async(x,H)=>{const Q=x.getDisabledExtensions();return q.map(J=>{const{identifier:W,isBuiltin:ee,manifest:ne,preRelease:_,pinned:se,isApplicationScoped:Z}=J,z={identifier:W,preRelease:_,version:ne.version,pinned:!!se};Z&&!(0,y.$_l)(ne)&&(z.isApplicationScoped=Z),Q.some(P=>(0,l.$Co)(P,W))&&(z.disabled=!0),ee||(z.installed=!0);try{const P=H.getKeysForSync({id:W.id,version:ne.version});if(P){const T=H.getExtensionState(J,!0)||{};z.state=Object.keys(T).reduce((B,N)=>(P.includes(N)&&(B[N]=T[N]),B),{})}}catch(P){this.g.info(`${(0,n.$TEb)("extensions",U)}: Error while parsing extension state`,(0,L.$9)(P))}return z})}),ignoredExtensions:Y}}async updateLocalExtensions(U,q,Y,K,x){const H=(0,n.$TEb)("extensions",x),Q=[],J=new Map,W=[],ee=[],ne=await this.a.getInstalled(void 0,x.extensionsResource);if((U.length||Y.length)&&await this.j(x,async(Z,z)=>{await I.Promises.settled([...U,...Y].map(async P=>{const T=ne.find(V=>(0,l.$Co)(V.identifier,P.identifier));if(T&&T.isBuiltin){P.state&&T.manifest.version===P.version&&this.h(P.state,T,T.manifest.version,z),Z.getDisabledExtensions().some(G=>(0,l.$Co)(G,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${H}: Disabling extension...`,P.identifier.id),await Z.disableExtension(P.identifier),this.g.info(`${H}: Disabled extension`,P.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,P.identifier.id),await Z.enableExtension(P.identifier),this.g.info(`${H}: Enabled extension`,P.identifier.id))),W.push(P.identifier);return}const B=P.pinned?P.version:void 0,N=(await this.c.getExtensions([{...P.identifier,version:B,preRelease:B?void 0:P.preRelease}],A.CancellationToken.None))[0];if(P.state&&(T?T.manifest.version===P.version:N)&&this.h(P.state,T||N,T?.manifest.version,z),N)try{Z.getDisabledExtensions().some(G=>(0,l.$Co)(G,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${H}: Disabling extension...`,P.identifier.id,N.version),await Z.disableExtension(N.identifier),this.g.info(`${H}: Disabled extension`,P.identifier.id,N.version)):(this.g.trace(`${H}: Enabling extension...`,P.identifier.id,N.version),await Z.enableExtension(N.identifier),this.g.info(`${H}: Enabled extension`,P.identifier.id,N.version))),(!T||T.preRelease!==P.preRelease||T.pinned!==P.pinned||B&&T.manifest.version!==B)&&(await this.a.canInstall(N)?(Q.push({extension:N,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:P.pinned&&!!P.version,installPreReleaseVersion:P.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:P.isApplicationScoped,context:{[w.$4n]:!0,[w.$5n]:!0}}}),J.set(N.identifier.id.toLowerCase(),P)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,N.displayName||N.identifier.id),ee.push(P)))}catch(V){ee.push(P),this.g.error(V),this.g.info(`${H}: Skipped synchronizing extension`,N.displayName||N.identifier.id)}else ee.push(P),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,P.identifier.id)}))}),q.length){const Z=ne.filter(({identifier:z,isBuiltin:P})=>!P&&q.some(T=>(0,l.$Co)(z,T)));await I.Promises.settled(Z.map(async z=>{this.g.trace(`${H}: Uninstalling local extension...`,z.identifier.id),await this.a.uninstall(z,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,z.identifier.id),W.push(z.identifier)}))}const _=await this.a.installGalleryExtensions(Q);for(const{identifier:Z,local:z,error:P,source:T}of _){const B=T;if(z)this.g.info(`${H}: Installed extension.`,Z.id,B.version),W.push(Z);else{const N=J.get(Z.id.toLowerCase());N&&(ee.push(N),this.g.info(`${H}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),P instanceof w.$bo&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(P.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):P&&this.g.error(P)}}const se=[];for(const Z of K)W.some(z=>(0,l.$Co)(z,Z.identifier))||se.push(Z);for(const Z of ee)se.some(z=>(0,l.$Co)(z.identifier,Z.identifier))||se.push(Z);return se}h(U,q,Y,K){const x=K.getExtensionState(q,!0)||{},H=Y?K.getKeysForSync({id:q.identifier.id,version:Y}):void 0;H?H.forEach(Q=>{x[Q]=U[Q]}):Object.keys(U).forEach(Q=>x[Q]=U[Q]),K.setExtensionState(q,x,!0)}async j(U,q){return this.b.withProfileScopedStorageService(U,async Y=>{const K=new R.$Qc,x=this.f.createChild(new f.$Qh([b.$9o,Y])),H=K.add(x.createInstance(E.$pDb)),Q=K.add(x.createInstance(g.$1u));try{return await q(H,Q)}finally{K.dispose()}})}};e.$F4b=D,e.$F4b=D=pe([X(0,w.$co),X(1,o.$4Db),X(2,w.$ao),X(3,t.$CFb),X(4,c.$Rh),X(5,r.$0gb)],D);let F=class extends n.$XEb{constructor(U,q,Y,K,x,H,Q,J){super("extensions",K,x,H,Y,Q,J),this.p=U,this.q=q}async t(U){return U.syncData?await v(U.syncData,this.p):null}u(U,q){const Y=[],K=[],x=[];for(const H of U){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const Q=q.find(J=>(0,l.$Co)(J.identifier,H.identifier));Q?(Y.push(Q),H.disabled&&x.push(H.identifier)):H.installed&&(K.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&x.push(H.identifier))}return{installedExtensions:Y,newExtensions:K,disabledExtensions:x,remoteExtensions:U}}};e.$G4b=F,e.$G4b=F=pe([X(0,w.$co),X(1,t.$CFb),X(2,p.$bk),X(3,a.$Nk),X(4,C.$Zh),X(5,u.$aj),X(6,b.$9o),X(7,s.$Lk)],F)}),define(ae[115],ce([0,1,15,7,3,35,42,5,32,20,14,11,8,43,21,22,28,39,78,236,24,17,59,4]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f,u,b,k,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Eb=e.$3Eb=e.$2Eb=e.$1Eb=e.$ZEb=void 0;const n="globalState.argv.",i=["locale"];function t($,D){const F=$.storage?Object.keys($.storage).sort():[],M={};return F.forEach(U=>M[U]=$.storage[U]),$.storage=M,D?(0,O.$oT)($,{}):JSON.stringify($)}e.$ZEb=t;const r=1;let o=class extends c.$UEb{constructor(D,F,M,U,q,Y,K,x,H,Q,J,W,ee,ne){super({syncResource:"globalState",profile:D},F,U,x,W,q,Y,H,Q,K,J,ee),this.Bb=M,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:b.$_gb,authority:"base"}),this.xb=this.vb.with({scheme:b.$_gb,authority:"local"}),this.yb=this.vb.with({scheme:b.$_gb,authority:"remote"}),this.zb=this.vb.with({scheme:b.$_gb,authority:"accepted"}),this.Ab=ne.createInstance(v),this.B(U.watch(this.h.dirname(this.H.argvResource))),this.B(L.Event.any(L.Event.filter(U.onDidFilesChange,_=>_.contains(this.H.argvResource)),L.Event.filter(M.onDidChange,_=>!!(_.targetChanges.some(se=>this.syncResource.profile.id===se.id)||_.valueChanges.some(({profile:se,changes:Z})=>this.syncResource.profile.id===se.id&&Z.some(z=>z.target===0)))))(()=>this.Q()))}async qb(D,F,M){const U=D.syncData?JSON.parse(D.syncData.content):null;F=F===null&&M?D:F;const q=F&&F.syncData?JSON.parse(F.syncData.content):null,Y=await this.Ab.getLocalGlobalState(this.syncResource.profile);U?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const K=await this.Jb(q),{local:x,remote:H}=(0,u.$YEb)(Y.storage,U?U.storage:null,q?q.storage:null,K,this.O),Q={content:null,local:x,remote:H,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:H.all!==null?2:0},J=t(Y,!1);return[{baseResource:this.wb,baseContent:q?t(q,!1):J,localResource:this.xb,localContent:J,localUserData:Y,remoteResource:this.yb,remoteContent:U?t(U,!1):null,previewResource:this.vb,previewResult:Q,localChange:Q.localChange,remoteChange:Q.remoteChange,acceptedResource:this.zb,storageKeys:K}]}async ub(D){const F=D.syncData?JSON.parse(D.syncData.content):null;if(F===null)return!0;const M=await this.Ab.getLocalGlobalState(this.syncResource.profile),U=await this.Jb(F),{remote:q}=(0,u.$YEb)(M.storage,F.storage,F.storage,U,this.O);return q.all!==null}async rb(D,F){return{...D.previewResult,hasConflicts:!1}}async sb(D,F,M,U){if(this.h.isEqual(F,this.xb))return this.Gb(D);if(this.h.isEqual(F,this.yb))return this.Hb(D);if(this.h.isEqual(F,this.vb))return D.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Gb(D){return{content:D.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(D.localUserData.storage),removed:[],updated:[],all:D.localUserData.storage},localChange:0,remoteChange:2}}async Hb(D){if(D.remoteContent!==null){const F=JSON.parse(D.remoteContent),{local:M,remote:U}=(0,u.$YEb)(D.localUserData.storage,F.storage,null,D.storageKeys,this.O);return{content:D.remoteContent,local:M,remote:U,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:D.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(D,F,M,U){const{localUserData:q}=M[0][0],{local:Y,remote:K,localChange:x,remoteChange:H}=M[0][1];if(x===0&&H===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(q)),await this.Ab.writeLocalGlobalState(Y,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Q=JSON.stringify({storage:K.all});D=await this.mb(Q,U?null:D.ref),this.O.info(`${this.D}: Updated remote ui state.${K.added.length?` Added: ${K.added}.`:""}${K.updated.length?` Updated: ${K.updated}.`:""}${K.removed.length?` Removed: ${K.removed}.`:""}`)}F?.ref!==D.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(D),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(D){if(this.h.isEqual(this.yb,D)||this.h.isEqual(this.wb,D)||this.h.isEqual(this.xb,D)||this.h.isEqual(this.zb,D)){const F=await this.db(D);return F&&t(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:D}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(D).length>1||D[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(D){const F=await this.Bb.readStorageData(this.syncResource.profile),M=[],U=[];for(const[K,x]of F)x.target===0?M.push(K):x.target===1&&U.push(K);const q=[...M,...U],Y=D?.storage?Object.keys(D.storage).filter(K=>!K.startsWith(n)&&!q.includes(K)&&F.get(K)!==void 0):[];if(!R.$o){const K=[...b.$Qgb.map(x=>(0,b.$4gb)(x)),b.$3gb];Y.push(...K),U.push(...K)}return{user:M,machine:U,unregistered:Y}}};e.$1Eb=o,e.$1Eb=o=pe([X(2,s.$4Db),X(3,E.$bk),X(4,b.$Ugb),X(5,b.$Vgb),X(6,b.$0gb),X(7,C.$Zh),X(8,b.$5gb),X(9,y.$fl),X(10,d.$mi),X(11,g.$9o),X(12,p.$Lk),X(13,a.$Rh)],o);let v=class{constructor(D,F,M,U){this.a=D,this.b=F,this.c=M,this.d=U}async getLocalGlobalState(D){const F={};if(D.isDefault){const U=await this.f(),q=(0,j.$Zm)(U);for(const Y of i)q[Y]!==void 0&&(F[`${n}${Y}`]={version:1,value:q[Y]})}const M=await this.c.readStorageData(D);for(const[U,q]of M)q.value&&q.target===0&&(F[U]={version:1,value:q.value});return{storage:F}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const D=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),D.value.toString()}catch(D){this.d.debug((0,A.$9)(D))}return"{}"}async writeLocalGlobalState({added:D,removed:F,updated:M},U){const q=(0,c.$TEb)("globalState",U),Y={},K=new Map,x=await this.c.readStorageData(U),H=(Q,J)=>{for(const W of Q){if(W.startsWith(n)){Y[W.substring(n.length)]=J?J[W].value:void 0;continue}if(J){const ee=J[W];ee.value!==x.get(W)?.value&&K.set(W,ee.value)}else x.get(W)!==void 0&&K.set(W,void 0)}};if(H(Object.keys(D),D),H(Object.keys(M),M),H(F),Object.keys(Y).length){this.d.trace(`${q}: Updating locale...`);const Q=await this.f();let J=Q;for(const W of Object.keys(Y))J=(0,f.edit)(J,[W],Y[W],{});Q!==J&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,I.$ce.fromString(J)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}K.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(U,K,0),this.d.info(`${q}: Updated global state`,[...K.keys()]))}};e.$2Eb=v,e.$2Eb=v=pe([X(0,E.$bk),X(1,C.$Zh),X(2,s.$4Db),X(3,b.$0gb)],v);let m=class extends c.$XEb{constructor(D,F,M,U,q,Y){super("globalState",M,U,q,F,D,Y)}async o(D){const F=D.syncData?JSON.parse(D.syncData.content):null;if(!F){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const M={},U={};for(const q of Object.keys(F.storage))q.startsWith(n)?M[q.substring(n.length)]=F.storage[q].value:this.l.get(q,0)===void 0&&(U[q]=F.storage[q].value);if(Object.keys(M).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Y of Object.keys(M))q=(0,f.edit)(q,[Y],M[Y],{});await this.k.writeFile(this.h.argvResource,I.$ce.fromString(q))}if(Object.keys(U).length){const q=[];for(const Y of Object.keys(U))q.push({key:Y,value:U[Y],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$3Eb=m,e.$3Eb=m=pe([X(0,g.$9o),X(1,E.$bk),X(2,k.$Nk),X(3,C.$Zh),X(4,b.$0gb),X(5,p.$Lk)],m);let h=class{constructor(D,F,M,U,q){this.a=D,this.b=F,this.c=M,this.d=U,this.f=q}getSyncStoreType(D){return this.h(D)?.storage[b.$3gb]?.value}async sync(D){const F=(0,b.$Ygb)((0,S.$fg)());try{return await this.g(D,F)}catch(M){if(M instanceof b.$Zgb)switch(M.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(D,F)}throw M}}async g(D,F){const M=await this.a.readResource("globalState",null,void 0,F),U=this.h(M)||{storage:{}};U.storage[b.$3gb]={value:D,version:r};const q=await(0,l.$cp)(this.c,this.d,this.b),Y={version:r,machineId:q,content:t(U,!1)};await this.a.writeResource("globalState",JSON.stringify(Y),M.ref,void 0,F)}h({content:D}){if(!D)return null;const F=JSON.parse(D);if((0,c.$SEb)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};e.$4Eb=h,e.$4Eb=h=pe([X(1,g.$9o),X(2,C.$Zh),X(3,E.$bk),X(4,w.$aj)],h)}),define(ae[116],ce([0,1,18,15,3,35,5,12,170,20,14,11,21,22,28,17,39,233,24]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K4b=e.$J4b=e.$I4b=void 0;function u(s,a,n){try{const i=JSON.parse(s);if(!a)return(0,R.$Gf)(i.all)?null:i.all;switch(O.OS){case 2:return(0,R.$Gf)(i.mac)?null:i.mac;case 3:return(0,R.$Gf)(i.linux)?null:i.linux;case 1:return(0,R.$Gf)(i.windows)?null:i.windows}}catch(i){return n.error(i),null}}e.$I4b=u;let b=class extends p.$WEb{constructor(a,n,i,t,r,o,v,m,h,$,D,F,M){super(a.keybindingsResource,{syncResource:"keybindings",profile:a},n,m,h,$,i,t,v,F,r,D,o,M),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:f.$_gb,authority:"base"}),this.Gb=this.Eb.with({scheme:f.$_gb,authority:"local"}),this.Hb=this.Eb.with({scheme:f.$_gb,authority:"remote"}),this.Ib=this.Eb.with({scheme:f.$_gb,authority:"accepted"}),this.B(L.Event.filter(o.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(a,n,i,t){const r=a.syncData?u(a.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&i?a:n;const o=n?this.Ob(n):null,v=await this.vb(),m=await this.Cb();let h=null,$=!1,D=!1,F=!1;if(r){let q=v?v.value.toString():"[]";if(q=q||"[]",this.Ab(q,!0))throw new f.$Zgb((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==q||o!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Y=await(0,c.$H4b)(q,r,o,m,this.zb);Y.hasChanges&&(h=Y.mergeContent,F=Y.hasConflicts,$=F||Y.mergeContent!==q,D=F||Y.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),h=v.value.toString(),D=!0);const M={content:F?o:h,localChange:$?v?2:1:0,remoteChange:D?2:0,hasConflicts:F},U=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:o,localResource:this.Gb,localContent:U,localChange:M.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:M.remoteChange,previewResource:this.Eb,previewResult:M,acceptedResource:this.Ib}]}async ub(a){const n=this.Ob(a);if(n===null)return!0;const i=await this.vb(),t=i?i.value.toString():"",r=await this.Cb(),o=await(0,c.$H4b)(t||"[]",n,n,r,this.zb);return o.hasConflicts||o.mergeContent!==n}async rb(a,n){return a.previewResult}async sb(a,n,i,t){if(this.h.isEqual(n,this.Gb))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return i===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(a,n,i,t){const{fileContent:r}=i[0][0];let{content:o,localChange:v,remoteChange:m}=i[0][1];if(v===0&&m===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.Ab(o,!0)))throw new f.$Zgb((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(o||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),m!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const h=this.Pb(o||"[]",a.syncData?.content);a=await this.mb(h,t?null:a.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==a.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(a,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.vb();if(a){const n=(0,j.$Zm)(a.value.toString());if((0,I.$Kb)(n))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async resolveContent(a){return this.h.isEqual(this.Hb,a)||this.h.isEqual(this.Fb,a)||this.h.isEqual(this.Gb,a)||this.h.isEqual(this.Ib,a)?this.db(a):null}Ob(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.Qb()?null:u(a.syncData.content,this.Qb(),this.O)}Pb(a,n){let i={};try{i=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete i.all:i.all=a,O.OS){case 2:i.mac=a;break;case 3:i.linux=a;break;case 1:i.windows=a;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(f.$Ngb)}};e.$J4b=b,e.$J4b=b=pe([X(2,f.$Ugb),X(3,f.$Vgb),X(4,f.$0gb),X(5,d.$mi),X(6,f.$5gb),X(7,E.$bk),X(8,C.$Zh),X(9,w.$9o),X(10,f.$9gb),X(11,l.$fl),X(12,g.$Lk)],b);let k=class extends p.$XEb{constructor(a,n,i,t,r,o){super("keybindings",n,i,t,a,r,o)}async o(a){const n=a.syncData?this.p(a.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,A.$ce.fromString(n)),await this.n(a)}async i(){try{const a=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,j.$Zm)(a.value.toString());return!(0,I.$Kb)(n)}catch(a){return a.fileOperationResult===1}}p(a){try{return u(a,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$K4b=k,e.$K4b=k=pe([X(0,E.$bk),X(1,y.$Nk),X(2,C.$Zh),X(3,f.$0gb),X(4,w.$9o),X(5,g.$Lk)],k)}),define(ae[117],ce([0,1,15,3,171,20,74,14,29,11,21,22,28,17,39,237,24]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N4b=e.$M4b=e.$L4b=void 0;function c(k){return k&&k.settings&&typeof k.settings=="string"&&Object.keys(k).length===1}function f(k){const s=JSON.parse(k);return c(s)?s:{settings:k}}e.$L4b=f;let u=class extends g.$WEb{constructor(s,a,n,i,t,r,o,v,m,h,$,D,F,M){super(s.settingsResource,{syncResource:"settings",profile:s},a,n,i,t,r,o,$,D,v,m,h,M),this.Eb=F,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:p.$_gb,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.$_gb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.$_gb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.$_gb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(s){const a=await this.getLastSyncUserData(),n=await this.X(s,a),i=this.Lb(n),t=new O.$Fn(p.$Mgb);return i?.settings&&t.parse(i.settings),t.configurationModel.getValue(p.$Mgb)||{}}async qb(s,a,n){const i=await this.vb(),t=await this.Cb(),r=this.Lb(s);a=a===null&&n?s:a;const o=a?this.Lb(a):null,v=await this.Pb();let m=null,h=!1,$=!1,D=!1;if(r){let q=i?i.value.toString().trim():"{}";q=q||"{}",this.Qb(q),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Y=(0,y.$KDb)(q,r.settings,o?o.settings:null,v,[],t);m=Y.localContent||Y.remoteContent,h=Y.localContent!==null,$=Y.remoteContent!==null,D=Y.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),m=i.value.toString().trim()||"{}",this.Qb(m),$=!0);const F=i?i.value.toString():null,M=o?.settings??null,U={content:D?M:m,localChange:h?2:0,remoteChange:$?2:0,hasConflicts:D};return[{fileContent:i,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:F,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async ub(s){const a=this.Lb(s);if(a===null)return!0;const n=await this.vb(),i=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,y.$KDb)(i||"{}",a.settings,a.settings,t,[],r).remoteContent!==null}async rb(s,a){const n=await this.Cb(),i=await this.Pb();return{...s.previewResult,content:s.previewResult.content?(0,y.$JDb)(s.previewResult.content,"{}",i,n):null}}async sb(s,a,n,i){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(a,this.localResource))return{content:s.fileContent?(0,y.$JDb)(s.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(a,this.remoteResource))return{content:s.remoteContent!==null?(0,y.$JDb)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(a,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,y.$JDb)(n,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async tb(s,a,n,i){const{fileContent:t}=n[0][0];let{content:r,localChange:o,remoteChange:v}=n[0][1];if(o===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),o!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,i),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const m=await this.Cb(),h=this.Lb(s),$=await this.Pb(r);r=(0,y.$JDb)(r,h?h.settings:"{}",$,m),this.O.trace(`${this.D}: Updating remote settings...`),s=await this.mb(JSON.stringify(this.Nb(r)),i?null:s.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}a?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(s),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.vb();if(s)return!(0,y.$LDb)(s.value.toString())}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.remoteResource,s)||this.h.isEqual(this.localResource,s)||this.h.isEqual(this.acceptedResource,s)||this.h.isEqual(this.baseResource,s)?this.db(s):null}async db(s){let a=await super.db(s);if(a){const n=await this.Cb(),i=await this.Pb();a=(0,y.$JDb)(a,"{}",i,n)}return a}Lb(s){return s.syncData?this.Mb(s.syncData.content):null}Mb(s){try{return f(s)}catch(a){this.O.error(a)}return null}Nb(s){return{settings:s}}async Pb(s){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(A.Event.any(A.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:t})=>!!t)),A.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{n.dispose(),this.Ob=void 0}))}const a=await this.Ob;return(0,y.$HDb)(a,this.P,s)}Qb(s){if(this.Ab(s,!1))throw new p.$Zgb((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$M4b=u,e.$M4b=u=pe([X(2,d.$bk),X(3,R.$Zh),X(4,C.$9o),X(5,p.$Ugb),X(6,p.$Vgb),X(7,p.$0gb),X(8,p.$9gb),X(9,j.$mi),X(10,p.$5gb),X(11,E.$fl),X(12,S.$co),X(13,w.$Lk)],u);let b=class extends g.$XEb{constructor(s,a,n,i,t,r){super("settings",a,n,i,s,t,r)}async o(s){const a=s.syncData?this.p(s.syncData.content):null;if(!a){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,I.$ce.fromString(a.settings)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,y.$LDb)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}p(s){try{return f(s)}catch(a){this.j.error(a)}return null}};e.$N4b=b,e.$N4b=b=pe([X(0,d.$bk),X(1,l.$Nk),X(2,R.$Zh),X(3,p.$0gb),X(4,C.$9o),X(5,w.$Lk)],b)}),define(ae[118],ce([0,1,15,3,30,20,14,11,21,22,28,17,39,234,24]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S4b=e.$R4b=e.$Q4b=void 0;function y(f){return JSON.parse(f.content)}e.$Q4b=y;let p=class extends w.$UEb{constructor(u,b,k,s,a,n,i,t,r,o,v,m){super({syncResource:"snippets",profile:u},b,s,k,a,n,i,o,v,t,r,m),this.pb=1,this.vb=u.snippetsHome,this.B(this.G.watch(k.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(A.Event.filter(this.G.onDidFilesChange,h=>h.affects(this.vb))(()=>this.Q()))}async qb(u,b,k){const s=await this.Hb(),a=this.Gb(s),n=u.syncData?this.Fb(u.syncData):null;b=b===null&&k?u:b;const i=b&&b.syncData?this.Fb(b.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,l.$O4b)(a,n,i);return this.Bb(t,s,n||{},i||{})}async ub(u){const b=u.syncData?this.Fb(u.syncData):null;if(b===null)return!0;const k=await this.Hb(),s=this.Gb(k),a=(0,l.$O4b)(s,b,b);return Object.keys(a.remote.added).length>0||Object.keys(a.remote.updated).length>0||a.remote.removed.length>0||a.conflicts.length>0}async rb(u,b){return u.previewResult}async sb(u,b,k,s){if(this.h.isEqualOrParent(b,this.g.with({scheme:g.$_gb,authority:"local"})))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:u.fileContent?u.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(b,this.g.with({scheme:g.$_gb,authority:"remote"})))return{content:u.remoteContent,localChange:u.remoteContent!==null?u.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(b,this.g))return k===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:k,localChange:k===null?u.fileContent!==null?3:0:2,remoteChange:k===null?u.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async tb(u,b,k,s){const a=k.map(([n,i])=>({...n,acceptResult:i}));a.every(({localChange:n,remoteChange:i})=>n===0&&i===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),a.some(({localChange:n})=>n!==0)&&(await this.Cb(a),await this.Db(a,s)),a.some(({remoteChange:n})=>n!==0)&&(u=await this.Eb(a,u,s)),b?.ref!==u.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(u),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of a)try{await this.G.del(n)}catch{}}Bb(u,b,k,s){const a=new Map;for(const n of Object.keys(u.local.added)){const i={content:u.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"accepted"})})}for(const n of Object.keys(u.local.updated)){const i={content:u.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=b[n]?b[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"local"}),fileContent:b[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"accepted"})})}for(const n of u.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=b[n]?b[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"local"}),fileContent:b[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"accepted"})})}for(const n of Object.keys(u.remote.added)){const i={content:u.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=b[n]?b[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"local"}),fileContent:b[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"accepted"})})}for(const n of Object.keys(u.remote.updated)){const i={content:u.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=b[n]?b[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"local"}),fileContent:b[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"accepted"})})}for(const n of u.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"remote"}),remoteContent:k[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"accepted"})})}for(const n of u.conflicts){const i={content:s[n]??null,hasConflicts:!0,localChange:b[n]?2:1,remoteChange:k[n]?2:1},t=b[n]?b[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"local"}),fileContent:b[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"remote"}),remoteContent:k[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"accepted"})})}for(const n of Object.keys(b))if(!a.has(n)){const i={content:b[n]?b[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=b[n]?b[n].value.toString():null;a.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"local"}),fileContent:b[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"remote"}),remoteContent:k[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$_gb,authority:"accepted"})})}return[...a.values()]}async resolveContent(u){return this.h.isEqualOrParent(u,this.g.with({scheme:g.$_gb,authority:"remote"}))||this.h.isEqualOrParent(u,this.g.with({scheme:g.$_gb,authority:"local"}))||this.h.isEqualOrParent(u,this.g.with({scheme:g.$_gb,authority:"base"}))||this.h.isEqualOrParent(u,this.g.with({scheme:g.$_gb,authority:"accepted"}))?this.db(u):null}async hasLocalData(){try{const u=await this.Hb();if(Object.keys(u).length)return!0}catch{}return!1}async Cb(u){const b={};for(const k of u)k.fileContent&&(b[this.h.basename(k.localResource)]=k.fileContent);await this.nb(JSON.stringify(this.Gb(b)))}async Db(u,b){for(const{fileContent:k,acceptResult:s,localResource:a,remoteResource:n,localChange:i}of u)if(i!==0){const t=n?this.h.basename(n):this.h.basename(a),r=this.h.joinPath(this.vb,t);i===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):i===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,I.$ce.fromString(s.content),{overwrite:b}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,I.$ce.fromString(s.content),b?void 0:k),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(u,b,k){const s=b.syncData?this.Fb(b.syncData):{},a=(0,L.$0m)(s);for(const{acceptResult:n,localResource:i,remoteResource:t,remoteChange:r}of u)if(r!==0){const o=i?this.h.basename(i):this.h.basename(t);r===3?delete a[o]:a[o]=n.content}return(0,l.$P4b)(s,a)||(this.O.trace(`${this.D}: Updating remote snippets...`),b=await this.mb(JSON.stringify(a),k?null:b.ref),this.O.info(`${this.D}: Updated remote snippets`)),b}Fb(u){return y(u)}Gb(u){const b={};for(const k of Object.keys(u))b[k]=u[k].value.toString();return b}async Hb(){const u={};let b;try{b=await this.G.resolve(this.vb)}catch(k){if(k instanceof R.$wk&&k.fileOperationResult===1)return u;throw k}for(const k of b.children||[]){const s=k.resource,a=this.h.extname(s);if(a===".json"||a===".code-snippets"){const n=this.h.relativePath(this.vb,s),i=await this.G.readFile(s);u[n]=i}}return u}};e.$R4b=p,e.$R4b=p=pe([X(2,O.$Zh),X(3,R.$bk),X(4,S.$9o),X(5,g.$Ugb),X(6,g.$Vgb),X(7,g.$0gb),X(8,j.$mi),X(9,g.$5gb),X(10,d.$fl),X(11,C.$Lk)],p);let c=class extends w.$XEb{constructor(u,b,k,s,a,n){super("snippets",b,k,s,u,a,n)}async o(u){const b=u.syncData?JSON.parse(u.syncData.content):null;if(!b){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const s of Object.keys(b)){const a=b[s];if(a){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,s);await this.k.createFile(n,I.$ce.fromString(a)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(u)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(u){return u.fileOperationResult===1}}};e.$S4b=c,e.$S4b=c=pe([X(0,R.$bk),X(1,E.$Nk),X(2,O.$Zh),X(3,g.$0gb),X(4,S.$9o),X(5,C.$Lk)],c)}),define(ae[119],ce([0,1,15,20,14,11,21,22,28,17,39,24]),function(ie,e,I,A,L,j,O,R,S,d,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V4b=e.$U4b=e.$T4b=void 0;function w(p,c){try{return JSON.parse(p).tasks??null}catch(f){return c.error(f),null}}e.$T4b=w;let l=class extends C.$VEb{constructor(c,f,u,b,k,s,a,n,i,t,r,o){super(c.tasksResource,{syncResource:"tasks",profile:c},f,n,i,t,u,b,a,r,k,s,o),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:E.$_gb,authority:"base"}),this.Cb=this.Ab.with({scheme:E.$_gb,authority:"local"}),this.Db=this.Ab.with({scheme:E.$_gb,authority:"remote"}),this.Eb=this.Ab.with({scheme:E.$_gb,authority:"accepted"})}async qb(c,f,u,b){const k=c.syncData?w(c.syncData.content,this.O):null;f=f===null&&u?c:f;const s=f?.syncData?w(f.syncData.content,this.O):null,a=await this.vb();let n=null,i=!1,t=!1,r=!1;if(c.syncData){const m=a?a.value.toString():null;if(!s||s!==m||s!==k){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const h=y(m,k,s);n=h.content,r=h.hasConflicts,i=h.hasLocalChanged,t=h.hasRemoteChanged}}else a&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=a.value.toString(),t=!0);const o={content:r?s:n,localChange:i?a?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=a?a.value.toString():null;return[{fileContent:a,baseResource:this.Bb,baseContent:s,localResource:this.Cb,localContent:v,localChange:o.localChange,remoteResource:this.Db,remoteContent:k,remoteChange:o.remoteChange,previewResource:this.Ab,previewResult:o,acceptedResource:this.Eb}]}async ub(c){const f=c?.syncData?w(c.syncData.content,this.O):null;if(f===null)return!0;const u=await this.vb(),b=u?u.value.toString():null,k=y(b,f,f);return k.hasLocalChanged||k.hasRemoteChanged}async rb(c,f){return c.previewResult}async sb(c,f,u,b){if(this.h.isEqual(f,this.Cb))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(f,this.Db))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(f,this.Ab))return u===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:u,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${f.toString()}`)}async tb(c,f,u,b){const{fileContent:k}=u[0][0],{content:s,localChange:a,remoteChange:n}=u[0][1];if(a===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),a!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),k&&await this.nb(JSON.stringify(this.Kb(k.value.toString()))),s?await this.wb(s,k,b):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(s));c=await this.mb(i,b?null:c.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}f?.ref!==c.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(c),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(c){return this.h.isEqual(this.Db,c)||this.h.isEqual(this.Bb,c)||this.h.isEqual(this.Cb,c)||this.h.isEqual(this.Eb,c)?this.db(c):null}Kb(c){return c?{tasks:c}:{}}};e.$U4b=l,e.$U4b=l=pe([X(2,E.$Ugb),X(3,E.$Vgb),X(4,E.$0gb),X(5,A.$mi),X(6,E.$5gb),X(7,j.$bk),X(8,L.$Zh),X(9,O.$9o),X(10,R.$fl),X(11,S.$Lk)],l);let g=class extends C.$XEb{constructor(c,f,u,b,k,s){super("tasks",f,u,b,c,k,s),this.c=this.g.defaultProfile.tasksResource}async o(c){const f=c.syncData?w(c.syncData.content,this.j):null;if(!f){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,I.$ce.fromString(f)),await this.n(c)}async p(){return this.k.exists(this.c)}};e.$V4b=g,e.$V4b=g=pe([X(0,j.$bk),X(1,d.$Nk),X(2,L.$Zh),X(3,E.$0gb),X(4,O.$9o),X(5,S.$Lk)],g);function y(p,c,f){if(p===null&&c===null&&f===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(p===c)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const u=f!==p,b=f!==c;return!u&&!b?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:u&&!b?{content:p,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:b&&!u?{content:c,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:p,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ae[120],ce([0,1,42,20,14,11,21,22,28,17,39,235,24]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=e.$z6b=e.$y6b=void 0;let l=class extends C.$UEb{constructor(c,f,u,b,k,s,a,n,i,t,r,o,v){super({syncResource:"profiles",profile:c},f,b,k,s,a,n,r,o,i,t,v),this.vb=u,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:w.$_gb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$_gb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$_gb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$_gb,authority:"accepted"}),this.B(u.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const c=await this.getLastSyncUserData();return c?.syncData?y(c.syncData):null}async getRemoteSyncedProfiles(c){const f=await this.getLastSyncUserData(),u=await this.X(c,f);return u?.syncData?y(u.syncData):null}async qb(c,f,u){if(!this.vb.isEnabled())throw new w.$Zgb("Cannot sync profiles because they are disabled","LocalError");const b=c.syncData?y(c.syncData):null,k=f?.syncData?y(f.syncData):null,s=this.Db(),{local:a,remote:n}=(0,E.$x6b)(s,b,k,[]),i={local:a,remote:n,content:k?this.Eb(k):null,localChange:a.added.length>0||a.removed.length>0||a.updated.length>0?2:0,remoteChange:n!==null?2:0},t=g(s,!1);return[{baseResource:this.baseResource,baseContent:k?this.Eb(k):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:b?this.Eb(b):null,remoteProfiles:b,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(c){const f=c?.syncData?y(c.syncData):null,u=this.Db(),{remote:b}=(0,E.$x6b)(u,f,f,[]);return!!b?.added.length||!!b?.removed.length||!!b?.updated.length}async rb(c,f){return{...c.previewResult,hasConflicts:!1}}async sb(c,f,u,b){if(this.h.isEqual(f,this.localResource))return this.Ab(c);if(this.h.isEqual(f,this.remoteResource))return this.Bb(c);if(this.h.isEqual(f,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async Ab(c){const f=this.Db(),u=(0,E.$x6b)(f,null,null,[]),{local:b,remote:k}=u;return{content:c.localContent,local:b,remote:k,localChange:b.added.length>0||b.removed.length>0||b.updated.length>0?2:0,remoteChange:k!==null?2:0}}async Bb(c){const f=c.remoteContent?JSON.parse(c.remoteContent):null,u=[],b=[];for(const k of this.Db()){const s=f?.find(a=>a.id===k.id);s&&(u.push({id:k.id,name:k.name,collection:s.collection}),b.push(k))}if(f!==null){const k=(0,E.$x6b)(b,f,u,[]),{local:s,remote:a}=k;return{content:c.remoteContent,local:s,remote:a,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:a!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(c,f,u,b){const{local:k,remote:s,localChange:a,remoteChange:n}=u[0][1];a===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=u[0][0].remoteProfiles||[];if(i.length+(s?.added.length??0)-(s?.removed.length??0)>20)throw new w.$Zgb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(a!==0){await this.nb(g(this.Db(),!1));const t=[];for(const r of k.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of k.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of k.updated){const o=this.vb.profiles.find(v=>v.id===r.id);o?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(o,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=i.length+(s?.added.length??0)<=20;if(r)for(const o of s?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),i.push({id:o.id,name:o.name,collection:v,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const o of s?.removed||[])i.splice(i.findIndex(({id:v})=>o.id===v),1);for(const o of s?.updated||[]){const v=i.find(({id:m})=>o.id===m);v&&i.splice(i.indexOf(v),1,{...v,id:o.id,name:o.name,shortName:o.shortName,icon:o.icon,useDefaultFlags:o.useDefaultFlags})}try{c=await this.updateRemoteProfiles(i,b?null:c.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&s?.added.length?` Added: ${JSON.stringify(s.added.map(o=>o.name))}.`:""}${s?.updated.length?` Updated: ${JSON.stringify(s.updated.map(o=>o.name))}.`:""}${s?.removed.length?` Removed: ${JSON.stringify(s.removed.map(o=>o.name))}.`:""}`)}catch(o){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw o}for(const o of s?.removed||[])await this.J.deleteCollection(o.collection,this.F)}f?.ref!==c.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(c),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(c,f){return this.mb(this.Eb(c),f)}async hasLocalData(){return this.Db().length>0}async resolveContent(c){if(this.h.isEqual(this.remoteResource,c)||this.h.isEqual(this.baseResource,c)||this.h.isEqual(this.localResource,c)||this.h.isEqual(this.acceptedResource,c)){const f=await this.db(c);return f&&(0,I.$oT)(JSON.parse(f),{})}return null}Db(){return this.vb.profiles.filter(c=>!c.isDefault&&!c.isTransient)}Eb(c){return JSON.stringify([...c].sort((f,u)=>f.name.localeCompare(u.name)))}};e.$y6b=l,e.$y6b=l=pe([X(2,d.$Nk),X(3,j.$bk),X(4,L.$Zh),X(5,O.$9o),X(6,w.$Ugb),X(7,w.$Vgb),X(8,w.$0gb),X(9,A.$mi),X(10,w.$5gb),X(11,R.$fl),X(12,S.$Lk)],l);function g(p,c){const f=[...p].sort((u,b)=>u.name.localeCompare(b.name)).map(u=>({id:u.id,name:u.name}));return c?(0,I.$oT)(f,{}):JSON.stringify(f)}e.$z6b=g;function y(p){return JSON.parse(p.content)}e.$A6b=y}),define(ae[252],ce([0,1,3,2,5,14,21,22,24]),function(ie,e,I,A,L,j,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=void 0;const d="sync.enable";let C=class extends A.$Rc{constructor(w,l,g,y){super(),this.c=w,this.f=l,this.g=g,this.h=y,this.a=new I.$Od,this.onDidChangeEnablement=this.a.event,this.b=new I.$Od,this.onDidChangeResourceEnablement=this.b.event,this.B(w.onDidChangeValue(-1,void 0,this.B(new A.$Qc))(p=>this.m(p)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(d,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(w){w&&!this.canToggleEnablement()||(this.f.publicLog2(d,{enabled:w}),this.c.store(d,w,-1,1))}isResourceEnabled(w){return this.c.getBoolean((0,S.$4gb)(w),-1,!0)}setResourceEnablement(w,l){if(this.isResourceEnabled(w)!==l){const g=(0,S.$4gb)(w);this.j(g,l)}}getResourceSyncStateVersion(w){}j(w,l){this.c.store(w,l,-1,L.$o?0:1)}m(w){if(d===w.key){this.a.fire(this.isEnabled());return}const l=S.$Qgb.filter(g=>(0,S.$4gb)(g)===w.key)[0];if(l){this.b.fire([l,this.isResourceEnabled(l)]);return}}};e.$l6b=C,e.$l6b=C=pe([X(0,O.$9o),X(1,R.$fl),X(2,j.$Zh),X(3,S.$Tgb)],C)}),define(ae[253],ce([0,1,6,15,64,2,19,20,14,11,17,24]),function(ie,e,I,A,L,j,O,R,S,d,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w6b=void 0;let w=class extends j.$Rc{constructor(g,y,p,c,f){super(),this.a=g,this.b=y,this.c=p,this.f=c,this.g=f,this.h()}async h(){for(const y of this.g.profiles)for(const p of E.$Qgb)try{await this.m(this.j(p,y.isDefault?void 0:y.id))}catch(c){this.f.error(c)}let g;try{g=await this.b.resolve(this.a.userDataSyncHome)}catch(y){(0,d.$sk)(y)!==1&&this.f.error(y);return}if(g.children){for(const y of g.children)if(y.isDirectory&&!this.g.profiles.some(p=>p.id===y.name))try{this.f.info("Deleting non existing profile from backup",y.resource.path),await this.b.del(y.resource,{recursive:!0})}catch(p){this.f.error(p)}}}async getAllResourceRefs(g,y,p){const c=this.j(g,y,p);try{const f=await this.b.resolve(c);if(f.children)return f.children.filter(b=>b.isFile&&!b.name.startsWith("lastSync")).sort().reverse().map(b=>({ref:b.name,created:this.n(b)}))}catch(f){if((0,d.$sk)(f)!==1)throw f}return[]}async resolveResourceContent(g,y,p,c){const f=this.j(g,p,c),u=(0,O.$wg)(f,y);try{return(await this.b.readFile(u)).value.toString()}catch(b){return this.f.error(b),null}}async writeResource(g,y,p,c,f){const u=this.j(g,c,f),b=(0,O.$wg)(u,`${(0,L.$hm)(p).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(b,A.$ce.fromString(y))}catch(k){this.f.error(k)}}j(g,y,p=this.a.userDataSyncHome){return(0,O.$wg)(p,...y?[y,g]:[g])}async m(g){try{try{if(!await this.b.exists(g))return}catch{return}const y=await this.b.resolve(g);if(y.children){const p=y.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort(),c=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let f=p.filter(b=>Date.now()-this.n(b)>c);const u=p.length-f.length;u<10&&(f=f.slice(10-u)),await I.Promises.settled(f.map(async b=>{this.f.info("Deleting from backup",b.resource.path),await this.b.del(b.resource)}))}}catch(y){this.f.error(y)}}n(g){return new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};e.$w6b=w,e.$w6b=w=pe([X(0,S.$Zh),X(1,d.$bk),X(2,R.$mi),X(3,E.$0gb),X(4,C.$Nk)],w)}),define(ae[82],ce([0,1,3,2,5,27,175,14,11,4,25,43,21,24]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgb=e.$Igb=e.$Hgb=void 0,e.$Hgb=(0,d.$Sh)("IUserDataSyncMachinesService");const y="sync.currentMachineName",p="Safari",c="Chrome",f="Edge",u="Firefox",b="Android";function k(n){switch(n){case p:case c:case f:case u:case b:case(0,L.$h)(0):return!0}return!1}e.$Igb=k;function s(){return L.$G?p:L.$E?c:L.$H?f:L.$F?u:L.$I?b:(0,L.$h)(L.$o?0:L.$u)}let a=class extends A.$Rc{static{g=this}static{this.a=1}static{this.b="machines"}constructor(i,t,r,o,v,m){super(),this.h=r,this.j=o,this.m=v,this.n=m,this.c=this.B(new I.$Od),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.$cp)(i,t,r)}async getMachines(i){const t=await this.f;return(await this.s(i)).machines.map(o=>({...o,isCurrent:o.id===t}))}async addCurrentMachine(i){const t=await this.f,r=await this.s(i);r.machines.some(({id:o})=>o===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:s()}),await this.t(r))}async removeCurrentMachine(i){const t=await this.f,r=await this.s(i),o=r.machines.filter(({id:v})=>v!==t);o.length!==r.machines.length&&(r.machines=o,await this.t(r))}async renameMachine(i,t,r){const o=await this.s(r),v=o.machines.find(({id:m})=>m===i);if(v){v.name=t,await this.t(o);const m=await this.f;i===m&&this.h.store(y,t,-1,1)}}async setEnablements(i){const t=await this.s();for(const[r,o]of i){const v=t.machines.find(m=>m.id===r);v&&(v.disabled=o?void 0:!0)}await this.t(t)}r(i){const t=this.h.get(y,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${s()} (${this.n.nameShort})`,o=new RegExp(`${(0,j.$Ge)(r)}\\s#(\\d+)`);let v=0;for(const m of i){const h=o.exec(m.name),$=h?parseInt(h[1]):0;v=$>v?$:v}return`${r} #${v+1}`}async s(i){this.g=await this.u(i);const t=this.w(this.g);if(t.version!==g.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return t}async t(i){const t=JSON.stringify(i),r=await this.j.writeResource(g.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(i){if(this.g){const t=i&&i.latest?i.latest[g.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(g.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.m.error(t)}return{version:g.a,machines:[]}}};e.$Jgb=a,e.$Jgb=a=g=pe([X(0,R.$Zh),X(1,S.$bk),X(2,w.$9o),X(3,l.$Ugb),X(4,l.$0gb),X(5,C.$sj)],a)}),define(ae[254],ce([0,1,6,64,38,7,3,2,5,19,10,172,25,21,22,24,79,82]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C6b=void 0;const f="sync.disableMachineEventually",u="sync.sessionId",b="sync.storeUrl",k="sync.productQuality";let s=class extends R.$Rc{get n(){const i=this.H.get(b,-1);return i?C.URI.parse(i):void 0}set n(i){i?this.H.store(b,i.toString(),-1,1):this.H.remove(b,-1)}get s(){return this.H.get(k,-1)}set s(i){i?this.H.store(k,i,-1,1):this.H.remove(k,-1)}constructor(i,t,r,o,v,m,h,$,D,F){super(),this.u=t,this.w=r,this.y=o,this.z=v,this.C=m,this.D=h,this.F=$,this.G=D,this.H=F,this.a=this.B(new R.$Sc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$Od),this.onError=this.h.event,this.S=[],this.f=this.B(new I.$Sg(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,d.$pg)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(h.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:t}=this.L();i?this.a.value===void 0&&(this.a.value=new a(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,A.$hm)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(u,-1),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(o){if(this.C.error(o),t)this.M(!1);else throw o}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const t=y.$Zgb.toUserDataSyncError(i);t instanceof y.$2gb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?S.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(f,!0,-1,1),await(0,I.$Vg)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(f,-1,!1)}R(){this.H.remove(f,-1)}async triggerSync(i,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const o=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:o}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$C6b=s,e.$C6b=s=pe([X(0,w.$sj),X(1,y.$Tgb),X(2,y.$Ugb),X(3,y.$5gb),X(4,y.$6gb),X(5,y.$0gb),X(6,p.$rDb),X(7,g.$fl),X(8,c.$Hgb),X(9,l.$9o)],s);class a extends R.$Rc{static{this.a="Interval"}constructor(i,t,r,o,v,m,h,$,D){super(),this.m=i,this.n=t,this.r=r,this.s=o,this.u=v,this.w=m,this.y=h,this.z=$,this.C=D,this.b=this.B(new R.$Sc),this.c=this.B(new O.$Od),this.onDidStartSync=this.c.event,this.f=this.B(new O.$Od),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Pc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(a.a,!1)}D(){this.b.value=(0,I.$Wg)(()=>{this.sync(a.a,!1),this.b.value=void 0},this.n)}sync(i,t){const r=(0,I.$Ig)(async o=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,j.$3)(v))return}return this.H(i,t,o)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,d.$pg)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!i&&(!(0,d.$pg)(t.defaultUrl,i.defaultUrl)||!(0,d.$pg)(t.insidersUrl,i.insidersUrl)||!(0,d.$pg)(t.stableUrl,i.stableUrl))}async H(i,t,r){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let o;try{await this.I(t,r)}catch(v){if(this.y.error(v),o=v,y.$Zgb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),o=void 0}catch(m){this.y.error(m),o=m}}this.f.fire(o)}async I(i,t){if(this.h=await this.u.createSyncTask(this.g,i),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new y.$2gb((0,E.localize)(0,null),"DefaultServiceChanged"):new y.$2gb((0,E.localize)(1,null),"ServiceChanged"):new y.$2gb((0,E.localize)(2,null),"TurnedOff");const r=this.C.get(u,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new y.$2gb((0,E.localize)(3,null),"DefaultServiceChanged"):new y.$2gb((0,E.localize)(4,null),"ServiceChanged"):new y.$2gb((0,E.localize)(5,null),"SessionExpired");const o=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=o.find(h=>h.isCurrent);if(v?.disabled)throw new y.$2gb((0,E.localize)(6,null),"TurnedOff");const m=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-m}),this.g===null)try{this.g=await this.s.manifest(null)}catch(h){throw new y.$2gb((0,L.$Di)(h),h instanceof y.$Zgb?h.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(u,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(ae[255],ce([0,1,10,176,14,11,43,21,28,24,17,39,118,117,116,20,119,114,115,4,120,42,27]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f,u,b,k,s){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$a7b=void 0;let n=class{static{a=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,o,v,m,h,$,D,F,M){this.e=t,this.f=r,this.g=o,this.h=m,this.i=h,this.j=$,this.k=D,this.l=F,this.n=M,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,b.$A6b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const o=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(o){const v=this.L(o,"profiles");return(0,b.$A6b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const o=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(o)return JSON.parse(o).machines.map(m=>({...m,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:m})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:m,node:void 0})}))}async getLocalSyncResourceHandles(t,r,o){return(await this.f.getAllResourceRefs(t,r?.collection,o)).map(({created:m,ref:h})=>({created:m,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:h,node:void 0,location:o})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),o=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const o=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,o);case"keybindings":return this.u(t,o);case"tasks":return this.w(t,o);case"snippets":return this.y(t,o);case"globalState":return this.D(t,o);case"extensions":return this.A(t,o);case"profiles":return this.G(t,o);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:o}=await this.M(r.syncResource,r.ref,r.collection);if(o)return this.L(o,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const o=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(o)return this.L(o,r.syncResource)?.machineId}return}return(0,O.$cp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===a.a)return null;if(r.ref){const o=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&o?this.q(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,o,v,m){if(t){const{content:h}=await this.M(r,v,o);return h}return this.f.resolveResourceContent(r,v,o,m)}q(t,r,o){const v=this.L(r,t);switch(t){case"settings":return this.t(v,o);case"keybindings":return this.v(v,o);case"tasks":return this.x(v,o);case"snippets":return this.z(v,o);case"globalState":return this.E(v,o);case"extensions":return this.B(v,o);case"profiles":return this.H(v,o);case"workspaceState":return null}}async r(t,r){const o=this.k.profiles.find(v=>v.id===r);if(!o)return null;switch(t){case"globalState":return this.F(o);case"extensions":return this.C(o);case"profiles":return this.I(o);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const o=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,l.$L4b)(t.content).settings}return null}u(t,r){const o=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,g.$I4b)(t.content,!!this.l.getValue(d.$Ngb),this.g)}return null}w(t,r){const o=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,p.$T4b)(t.content,this.g)}return null}async y(t,r){const o=await this.resolveContent(t);if(o){const v=this.L(o,"snippets");if(v){const m=(0,w.$Q4b)(v),h=[];for(const $ of Object.keys(m)){const D=this.d.joinPath(t,$),F=r?this.d.joinPath(r.snippetsHome,$):this.d.joinPath(t,a.a);h.push({resource:D,comparableResource:F})}return h}}return[]}z(t,r){return(0,w.$Q4b)(t)[r]||null}A(t,r){const o=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,c.$D4b)((0,c.$C4b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(c.$F4b).getLocalExtensions(t);return(0,c.$D4b)(r,!0)}D(t,r){const o=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,a.a);return[{resource:o,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,f.$ZEb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(f.$2Eb).getLocalGlobalState(t);return(0,f.$ZEb)(r,!0)}G(t,r){const o=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,k.$oT)(JSON.parse(t.content),{})}return null}async I(t){return(0,b.$z6b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?a.b:a.c,o=[];return t.location&&(o.push(`scheme:${t.location.scheme}`),o.push(`authority:${t.location.authority}`),o.push((0,s.$Je)(t.location.path,"/"))),o.push(`syncResource:${t.syncResource}`),o.push(`profile:${t.profile}`),t.collection&&o.push(`collection:${t.collection}`),t.ref&&o.push(`ref:${t.ref}`),t.node&&o.push(t.node),this.d.joinPath(I.URI.from({scheme:d.$_gb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...o)}K(t){if(t.scheme!==d.$_gb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const o=t.authority===a.b;let v,m;const h=[];let $,D,F,M,U;for(;r.length;){const q=r.shift();q.startsWith("scheme:")?v=q.substring(7):q.startsWith("authority:")?m=q.substring(10):q.startsWith("syncResource:")?$=q.substring(13):q.startsWith("profile:")?D=q.substring(8):q.startsWith("collection:")?F=q.substring(11):q.startsWith("ref:")?M=q.substring(4):$?U=q:h.push(q)}return{remote:o,syncResource:$,profile:D,collection:F,ref:M,node:U,location:v&&m!==void 0?this.d.joinPath(I.URI.from({scheme:v,authority:m,query:t.query,fragment:t.fragment,path:"/"}),...h):void 0}}L(t,r){try{const o=JSON.parse(t);if((0,E.$SEb)(o))return o}catch(o){this.g.error(o)}throw new d.$Zgb((0,A.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,o){const v=await this.e.resolveResourceContent(t,r,o);return{ref:r,content:v}}};e.$a7b=n,e.$a7b=n=a=pe([X(0,d.$Ugb),X(1,d.$Vgb),X(2,d.$0gb),X(3,S.$Lk),X(4,L.$Zh),X(5,R.$9o),X(6,j.$bk),X(7,C.$Nk),X(8,y.$mi),X(9,u.$Rh)],n)}),define(ae[256],ce([0,1,18,6,26,38,3,2,19,12,32,20,29,11,4,21,22,17,114,115,116,117,118,119,120,24]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f,u,b,k,s,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B6b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Rc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor($,D,F,M,U,q,Y,K,x,H,Q){super(),this.C=$,this.D=D,this.F=F,this.G=M,this.H=U,this.I=q,this.J=Y,this.L=K,this.M=x,this.N=H,this.O=Q,this.f="uninitialized",this.g=this.B(new O.$Od),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$Od),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$Od),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$Od),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$Od),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$Od),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$Od),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=F.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Pc)(()=>this.bb()))}async createSyncTask($,D){this.cb(),this.H.info("Sync started.");const F=new Date().getTime(),M=(0,C.$fg)();try{const K=(0,i.$Ygb)(M);D&&(K["Cache-Control"]="no-cache"),$=await this.D.manifest($,K)}catch(K){const x=i.$Zgb.toUserDataSyncError(K);throw m(x,M,this.F,this.I),x}const U=!1,q=this;let Y;return{manifest:$,async run(){if(U)throw new Error("Can run a task only once");Y=(0,A.$Ig)(K=>q.P($,!1,M,K)),await Y.finally(()=>Y=void 0),q.H.info(`Sync done. Took ${new Date().getTime()-F}ms`),q.$()},stop(){return Y?.cancel(),q.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new i.$Zgb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const $=new Date().getTime(),D=(0,C.$fg)(),F=(0,i.$Ygb)(D);let M;try{M=await this.D.manifest(null,F)}catch(Y){const K=i.$Zgb.toUserDataSyncError(Y);throw m(K,D,this.F,this.I),K}await this.resetLocal();const U=this,q=new L.$Yd;return{id:D,async merge(){return U.P(M,!0,D,q.token)},async apply(){try{try{await U.R(M,D,q.token)}catch(Y){if(i.$Zgb.toUserDataSyncError(Y).code==="MethodNotFound")U.H.info("Client is making invalid requests. Cleaning up data..."),await U.cleanUpRemoteData(),U.H.info("Applying manual sync again..."),await U.R(M,D,q.token);else throw Y}}catch(Y){throw U.H.error(Y),Y}U.H.info(`Sync done. Took ${new Date().getTime()-$}ms`),U.$()},async stop(){q.cancel(),await U.U(),await U.resetLocal()}}}async P($,D,F,M){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const U=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(U,$,D,F,M));const q=U.enabled.find(Y=>Y.resource==="profiles");if(q){const Y=await q.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.Q(Y,$,D,F,M)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q($,D,F,M,U){for(const q of $){if(U.isCancellationRequested)return;const Y=this.M.profiles.find(x=>x.id===q.id);if(!Y){this.H.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",q.name);const K=this.getOrCreateActiveProfileSynchronizer(Y,q);this.n.push(...await this.S(K,D,F,M,U))}for(const[q,Y]of this.z.entries())this.M.profiles.some(K=>K.id===Y[0].profile.id)||(Y[1].dispose(),this.z.delete(q))}async R($,D,F){const M=this.ab();for(const x of M){if(F.isCancellationRequested)return;await x.apply(D,F)}const U=M.find(x=>x.profile.isDefault);if(!U)return;const q=U.enabled.find(x=>x.resource==="profiles");if(!q)return;const K=(await q.getRemoteSyncedProfiles($?.latest??null)||[]).filter(x=>M.every(H=>H.profile.id!==x.id));K.length&&await this.Q(K,$,!1,D,F)}async S($,D,F,M,U){return(await $.sync(D,F,M,U)).map(([Y,K])=>({profile:$.profile,syncResource:Y,error:K}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map($=>$.stop()))}async resolveContent($){const D=await this.N.resolveContent($);if(D)return D;for(const F of this.ab())for(const M of F.enabled){const U=await M.resolveContent($);if(U)return U}return null}async replace($){this.cb();const D=this.N.resolveUserDataSyncResource($);if(!D)return;const F=await this.resolveContent($.uri);F&&await this.W(D.profile,async M=>{if(D.syncResource===M.resource)return await M.replace(F),!0})}async accept($,D,F,M){this.cb(),await this.W($.profile,async U=>{if($.syncResource===U.resource)return await U.accept(D,F),M&&await U.apply((0,d.$Ff)(M)?!1:M.force,(0,i.$Ygb)((0,C.$fg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async D=>{if(D.resource!=="globalState"&&await D.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async D=>{if(await D.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch($){this.H.error($)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[$]of this.z.values())try{await $.resetLocal()}catch(D){this.H.error(D)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const $=await this.N.getRemoteSyncedProfiles(),D=$.map(q=>q.collection),F=await this.D.getAllCollections(),M=F.filter(q=>!D.includes(q));M.length&&(this.H.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(q=>this.D.deleteCollection(q))),this.H.info("Deleted redundant collections on server"));const U=$.filter(q=>F.includes(q.collection));if(U.length!==$.length){const q=this.G.createInstance(n.$y6b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(U,null),this.H.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData($){this.cb();const D=await this.D.getActivityData();await this.C.writeFile($,D)}async extractActivityData($,D){const F=(await this.C.readFile($)).value.toString(),M=JSON.parse(F);if(M.resources)for(const U in M.resources)for(const q of M.resources[U])await this.O.writeResource(U,q.content,new Date(q.created*1e3),void 0,D);if(M.collections)for(const U in M.collections)for(const q in M.collections[U].resources)for(const Y of M.collections[U].resources?.[q]??[])await this.O.writeResource(q,Y.content,new Date(Y.created*1e3),U,D)}async W($,D){const F=new R.$Qc;try{const M=this.z.get($.id);if(M){const x=await this.X(M[0],D,F);return(0,d.$Gf)(x)?null:x}if($.isDefault){const x=F.add(this.G.createInstance(o,$,void 0)),H=await this.X(x,D,F);return(0,d.$Gf)(H)?null:H}if(this.M.isEnabled())return null;const U=F.add(this.G.createInstance(n.$y6b,$,void 0)),q=await this.D.manifest(null),K=(await U.getRemoteSyncedProfiles(q?.latest??null)||[]).find(x=>x.id===$.id);if(K){const x=F.add(this.G.createInstance(o,$,K.collection)),H=await this.X(x,D,F);return(0,d.$Gf)(H)?null:H}return null}finally{F.dispose()}}async X($,D,F){const M=[...$.enabled,...$.disabled.reduce((U,q)=>(q!=="workspaceState"&&U.push(F.add($.createSynchronizer(q))),U),[])];for(const U of M){const q=await D(U);if(!(0,d.$Gf)(q))return q}}Y($){const D=this.f;this.f!==$&&(this.f=$,this.g.fire($),D==="hasConflicts"&&this.$())}Z(){const $=this.ab().map(D=>D.conflicts).flat();(0,I.$tb)(this.j,$,(D,F)=>D.profile.id===F.profile.id&&D.syncResource===F.syncResource&&(0,I.$tb)(D.conflicts,F.conflicts,(M,U)=>(0,S.$pg)(M.previewResource,U.previewResource)))||(this.j=$,this.m.fire($))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer($,D){let F=this.z.get($.id);if(F&&F[0].collection!==D?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),F[1].dispose(),F=void 0,this.z.delete($.id)),!F){const M=new R.$Qc,U=M.add(this.G.createInstance(o,$,D?.collection));M.add(U.onDidChangeStatus(q=>this.Y(q))),M.add(U.onDidChangeConflicts(q=>this.Z())),M.add(U.onDidChangeLocal(q=>this.h.fire(q))),this.z.set($.id,F=[U,M])}return F[0]}ab(){const $=[];for(const[D]of this.z.values())$.push(D);return $}bb(){this.z.forEach(([,$])=>$.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$B6b=r,e.$B6b=r=pe([X(0,l.$bk),X(1,i.$Ugb),X(2,i.$Tgb),X(3,g.$Rh),X(4,i.$0gb),X(5,p.$fl),X(6,y.$9o),X(7,i.$5gb),X(8,c.$Nk),X(9,i.$7gb),X(10,i.$Vgb)],r);let o=class extends R.$Rc{get enabled(){return this.f.sort(($,D)=>$[1]-D[1]).map(([$])=>$)}get disabled(){return i.$Qgb.filter($=>!this.r.isResourceEnabled($))}get status(){return this.g}get conflicts(){return this.m}constructor($,D,F,M,U,q,Y,K,x,H){super(),this.profile=$,this.collection=D,this.r=F,this.t=M,this.u=U,this.w=q,this.y=Y,this.z=K,this.C=x,this.D=H,this.f=[],this.g="idle",this.h=this.B(new O.$Od),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$Od),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$Od),this.onDidChangeConflicts=this.n.event,this.B(F.onDidChangeResourceEnablement(([Q,J])=>this.F(Q,J))),this.B((0,R.$Pc)(()=>this.f.splice(0,this.f.length).forEach(([,,Q])=>Q.dispose())));for(const Q of i.$Qgb)F.isResourceEnabled(Q)&&this.G(Q)}F($,D){D?this.G($):this.H($)}G($){if(this.f.some(([U])=>U.resource===$))return;if($==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if($==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||$==="workspaceState")return;if($!=="profiles"&&this.profile.useDefaultFlags?.[$]){this.z.debug(`Skipping syncing ${$} in ${this.profile.name} because it is already synced by default profile`);return}const D=new R.$Qc,F=D.add(this.createSynchronizer($));D.add(F.onDidChangeStatus(()=>this.L())),D.add(F.onDidChangeConflicts(()=>this.M())),D.add(F.onDidChangeLocal(()=>this.j.fire($)));const M=this.N($);this.f.push([F,M,D])}H($){const D=this.f.findIndex(([F])=>F.resource===$);if(D!==-1){const[[F,,M]]=this.f.splice(D,1);M.dispose(),this.L(),Promise.allSettled([F.stop(),F.resetLocal()]).then(null,U=>this.z.error(U))}}createSynchronizer($){switch($){case"settings":return this.t.createInstance(k.$M4b,this.profile,this.collection);case"keybindings":return this.t.createInstance(b.$J4b,this.profile,this.collection);case"snippets":return this.t.createInstance(s.$R4b,this.profile,this.collection);case"tasks":return this.t.createInstance(a.$U4b,this.profile,this.collection);case"globalState":return this.t.createInstance(u.$1Eb,this.profile,this.collection);case"extensions":return this.t.createInstance(f.$E4b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$y6b,this.profile,this.collection)}}async sync($,D,F,M){if(M.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const q=[],Y=(0,i.$Ygb)(F),K=(this.collection?$?.collections?.[this.collection]?.latest:$?.latest)??null,x=D?await this.I(K):{};for(const H of U){if(M.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(D){const Q=await H.preview(K,x,Y);if(Q)for(const J of Q.resourcePreviews)(J.localChange!==0||J.remoteChange!==0)&&J.mergeState==="preview"&&await H.merge(J.previewResource)}else await H.sync(K,Y)}catch(Q){const J=i.$Zgb.toUserDataSyncError(Q);if(m(J,F,this.w,this.y),v(Q))throw J;this.z.error(Q),this.z.error(`${H.resource}: ${(0,j.$Di)(Q)}`),q.push([H.resource,J])}}return q}finally{this.L()}}async apply($,D){const F=(0,i.$Ygb)($);for(const M of this.enabled){if(D.isCancellationRequested)return;try{await M.apply(!1,F)}catch(U){const q=i.$Zgb.toUserDataSyncError(U);if(m(q,$,this.w,this.y),v(U))throw q;this.z.error(U),this.z.error(`${M.resource}: ${(0,j.$Di)(U)}`)}}}async stop(){for(const $ of this.enabled)try{$.status!=="idle"&&await $.stop()}catch(D){this.z.error(D)}}async resetLocal(){for(const $ of this.enabled)try{await $.resetLocal()}catch(D){this.z.error(`${$.resource}: ${(0,j.$Di)(D)}`),this.z.error(D)}}async I($){if(!this.profile.isDefault)return{};const D=this.D.getValue(i.$Mgb),F=this.enabled.find(M=>M instanceof k.$M4b);if(F){const M=await F.getRemoteUserDataSyncConfiguration($);return{...D,...M}}return D}J($){this.g!==$&&(this.g=$,this.h.fire($))}L(){return this.M(),this.enabled.some($=>$.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some($=>$.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const $=this.enabled.filter(D=>D.status==="hasConflicts").filter(D=>D.conflicts.conflicts.length>0).map(D=>D.conflicts);(0,I.$tb)(this.m,$,(D,F)=>D.syncResource===F.syncResource&&(0,I.$tb)(D.conflicts,F.conflicts,(M,U)=>(0,S.$pg)(M.previewResource,U.previewResource)))||(this.m=$,this.n.fire($))}N($){switch($){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};o=pe([X(2,i.$5gb),X(3,g.$Rh),X(4,w.$ao),X(5,i.$Tgb),X(6,p.$fl),X(7,i.$0gb),X(8,c.$Nk),X(9,E.$mi)],o);function v(h){if(h instanceof i.$Zgb)switch(h.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function m(h,$,D,F){F.publicLog2("sync/error",{code:h.code,serverCode:h instanceof i.$1gb?String(h.serverCode):void 0,url:h instanceof i.$1gb?h.url:void 0,resource:h.resource,executionId:$,service:D.userDataSyncStore.url.toString()})}}),define(ae[257],ce([0,1,3,2,10,17,24]),function(ie,e,I,A,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$19b=e.$Z9b=void 0;function R(w,l){return{...w,profile:(0,j.$Ok)(w.profile,l.profilesHome.scheme)}}function S(w){return{created:w.created,uri:L.URI.revive(w.uri)}}class d{constructor(l,g,y){this.c=l,this.d=g,this.f=y,this.a=new Map,this.b=new I.$Od}listen(l,g){switch(g){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${g}`)}async call(l,g,y){try{return await this.g(l,g,y)}catch(p){throw this.f.error(p),p}}async g(l,g,y){switch(g){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(L.URI.revive(y[0]));case"accept":return this.c.accept(R(y[0],this.d),L.URI.revive(y[1]),y[2],y[3]);case"replace":return this.c.replace(S(y[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(L.URI.revive(y[0]));case"extractActivityData":return this.c.extractActivityData(L.URI.revive(y[0]),L.URI.revive(y[1]));case"createManualSyncTask":return this.i()}if(g.startsWith("manualSync/")){const p=g.substring(11),c=y[0],f=this.h(c);switch(y=y.slice(1),p){case"merge":return f.merge();case"apply":return f.apply().then(()=>this.a.delete(this.j(f.id)));case"stop":return f.stop().finally(()=>this.a.delete(this.j(f.id)))}}throw new Error("Invalid call")}h(l){const g=this.a.get(this.j(l));if(!g)throw new Error(`Manual sync taks not found: ${l}`);return g}async i(){const l=await this.c.createManualSyncTask();return this.a.set(this.j(l.id),l),l.id}j(l){return`manualSyncTask-${l}`}}e.$Z9b=d;let C=class extends A.$Rc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(l,g){super(),this.n=g,this.b="uninitialized",this.c=this.B(new I.$Od),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new I.$Od),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new I.$Od),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new I.$Od),this.onSyncErrors=this.m.event,this.a={call(y,p,c){return l.call(y,p,c).then(null,f=>{throw O.$Zgb.toUserDataSyncError(f)})},listen(y,p){return l.listen(y,p)}},this.a.call("_getInitialData").then(([y,p,c])=>{this.s(y),this.t(p),c&&this.u(c),this.B(this.a.listen("onDidChangeStatus")(f=>this.s(f))),this.B(this.a.listen("onDidChangeLastSyncTime")(f=>this.u(f)))}),this.B(this.a.listen("onDidChangeConflicts")(y=>this.t(y))),this.B(this.a.listen("onSyncErrors")(y=>this.m.fire(y.map(p=>({...p,error:O.$Zgb.toUserDataSyncError(p.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const l=await this.a.call("createManualSyncTask"),g=this;return new E(l,{async call(p,c,f){return g.a.call(`manualSync/${p}`,[l,...Array.isArray(c)?c:[c]],f)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(l,g,y,p){return this.a.call("accept",[l,g,y,p])}resolveContent(l){return this.a.call("resolveContent",[l])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(l){return this.a.call("replace",[l])}saveRemoteActivityData(l){return this.a.call("getRemoteActivityData",[l])}extractActivityData(l,g){return this.a.call("extractActivityData",[l,g])}async s(l){this.b=l,this.c.fire(l)}async t(l){this.f=l.map(g=>({syncResource:g.syncResource,profile:(0,j.$Ok)(g.profile,this.n.profilesHome.scheme),conflicts:g.conflicts.map(y=>({...y,baseResource:L.URI.revive(y.baseResource),localResource:L.URI.revive(y.localResource),remoteResource:L.URI.revive(y.remoteResource),previewResource:L.URI.revive(y.previewResource)}))})),this.g.fire(this.f)}u(l){this.h!==l&&(this.h=l,this.j.fire(l))}};e.$19b=C,e.$19b=C=pe([X(1,j.$Nk)],C);class E extends A.$Rc{constructor(l,g){super(),this.id=l,this.a=g}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(ae[258],ce([0,1,6,26,7,3,2,139,5,19,12,10,32,20,14,11,25,58,43,21,24]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QEb=e.$PEb=e.$OEb=e.$NEb=e.$MEb=void 0;const k="configurationSync.store",s="sync.previous.store",a="sync.donot-make-requests-until",n="sync.user-session-id",i="sync.machine-session-id",t=100,r=1e3*60*5;let o=class extends O.$Rc{get userDataSyncStore(){return this.b}get c(){return this.h.get(b.$3gb,-1)}set c(F){this.h.store(b.$3gb,F,-1,S.$o?0:1)}constructor(F,M,U){super(),this.f=F,this.g=M,this.h=U,this.a=this.B(new j.$Od),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const q=this.B(new O.$Qc);this.B(j.Event.filter(U.onDidChangeValue(-1,b.$3gb,q),()=>this.c!==this.userDataSyncStore?.type,q)(()=>this.j()))}j(){this.b=this.m(this.f[k]),this.a.fire()}m(F){if(F&&(F=S.$o&&F.web?{...F,...F.web}:F,(0,C.$zf)(F.url)&&(0,C.$Bf)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(M=>Array.isArray(F.authenticationProviders[M].scopes)))){const M=F,U=!!M.canSwitch,q=M.url===M.insidersUrl?"insiders":"stable",Y=(U?this.c:void 0)||q,K=Y==="insiders"?M.insidersUrl:Y==="stable"?M.stableUrl:M.url;return{url:E.URI.parse(K),type:Y,defaultType:q,defaultUrl:E.URI.parse(M.url),stableUrl:E.URI.parse(M.stableUrl),insidersUrl:E.URI.parse(M.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(M.authenticationProviders).reduce((x,H)=>(x.push({id:H,scopes:M.authenticationProviders[H].scopes}),x),[])}}}};e.$MEb=o,e.$MEb=o=pe([X(0,p.$sj),X(1,l.$mi),X(2,u.$9o)],o);let v=class extends o{constructor(F,M,U){super(F,M,U);const q=this.h.get(s,-1);q&&(this.n=JSON.parse(q));const Y=this.f[k];Y?this.h.store(s,JSON.stringify(Y),-1,1):this.h.remove(s,-1)}async switch(F){F!==this.c&&(this.c=F,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$NEb=v,e.$NEb=v=pe([X(0,p.$sj),X(1,l.$mi),X(2,u.$9o)],v);let m=class extends O.$Rc{get donotMakeRequestsUntil(){return this.j}constructor(F,M,U,q,Y,K,x){super(),this.n=U,this.r=q,this.s=x,this.g=this.B(new j.$Od),this.onTokenFailed=this.g.event,this.h=this.B(new j.$Od),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new j.$Od),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(F),this.c=(0,f.$cp)(Y,K,x).then(H=>{const Q={"X-Client-Name":`${M.applicationName}${S.$o?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(Q["X-Client-Commit"]=M.commit),Q}),this.f=new $(t,r,this.n,this.r),this.u(),this.B((0,O.$Pc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(F,M){this.b={token:F,type:M}}t(F){this.a=F?(0,d.$wg)(F,"v1"):void 0}u(){const F=this.s.getNumber(a,-1);F&&Date.now()<F&&this.y(new Date(F))}y(F){this.j?.getTime()!==F?.getTime()&&(this.j=F,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(a,this.j.getTime(),-1,1),this.w=(0,I.$Ig)(M=>(0,I.$Vg)(this.j.getTime()-Date.now(),M).then(()=>this.y(void 0))),this.w.then(null,M=>null)):this.s.remove(a,-1),this.m.fire())}async getAllCollections(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$wg)(this.a,"collection").toString();F={...F},F["Content-Type"]="application/json";const U=await this.D(M,{type:"GET",headers:F},[],A.CancellationToken.None);return(await(0,c.$2o)(U))?.map(({id:q})=>q)||[]}async createCollection(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$wg)(this.a,"collection").toString();F={...F},F["Content-Type"]=R.$Sr.text;const U=await this.D(M,{type:"POST",headers:F},[],A.CancellationToken.None),q=await(0,c.$1o)(U);if(!q)throw new b.$1gb("Server did not return the collection id",M,"NoCollection",U.res.statusCode,U.res.headers[b.$Wgb]);return q}async deleteCollection(F,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=F?(0,d.$wg)(this.a,"collection",F).toString():(0,d.$wg)(this.a,"collection").toString();M={...M},await this.D(U,{type:"DELETE",headers:M},[],A.CancellationToken.None)}async getAllResourceRefs(F,M){if(!this.a)throw new Error("No settings sync store url configured.");const U=this.z(this.a,M,F),q={},Y=await this.D(U.toString(),{type:"GET",headers:q},[],A.CancellationToken.None);return(await(0,c.$2o)(Y)||[]).map(({url:x,created:H})=>({ref:(0,d.$yg)(U,U.with({path:x})),created:H*1e3}))}async resolveResourceContent(F,M,U,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,d.$wg)(this.z(this.a,U,F),M).toString();q={...q},q["Cache-Control"]="no-cache";const K=await this.D(Y,{type:"GET",headers:q},[],A.CancellationToken.None);return await(0,c.$1o)(K)}async deleteResource(F,M,U){if(!this.a)throw new Error("No settings sync store url configured.");const q=M!==null?(0,d.$wg)(this.z(this.a,U,F),M).toString():this.z(this.a,U,F).toString(),Y={};await this.D(q,{type:"DELETE",headers:Y},[],A.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,d.$wg)(this.a,"resource").toString(),M={"Content-Type":R.$Sr.text};await this.D(F,{type:"DELETE",headers:M},[],A.CancellationToken.None)}async readResource(F,M,U,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,d.$wg)(this.z(this.a,U,F),"latest").toString();q={...q},q["Cache-Control"]="no-cache",M&&(q["If-None-Match"]=M.ref);const K=await this.D(Y,{type:"GET",headers:q},[304],A.CancellationToken.None);let x=null;if(K.res.statusCode===304&&(x=M),x===null){const H=K.res.headers.etag;if(!H)throw new b.$1gb("Server did not return the ref",Y,"NoRef",K.res.statusCode,K.res.headers[b.$Wgb]);const Q=await(0,c.$1o)(K);if(!Q&&K.res.statusCode===304)throw new b.$1gb("Empty response",Y,"EmptyResponse",K.res.statusCode,K.res.headers[b.$Wgb]);x={ref:H,content:Q}}return x}async writeResource(F,M,U,q,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=this.z(this.a,q,F).toString();Y={...Y},Y["Content-Type"]=R.$Sr.text,U&&(Y["If-Match"]=U);const x=await this.D(K,{type:"POST",data:M,headers:Y},[],A.CancellationToken.None),H=x.res.headers.etag;if(!H)throw new b.$1gb("Server did not return the ref",K,"NoRef",x.res.statusCode,x.res.headers[b.$Wgb]);return H}async manifest(F,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,d.$wg)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",F&&(M["If-None-Match"]=F.ref);const q=await this.D(U,{type:"GET",headers:M},[304],A.CancellationToken.None);let Y=null;if(q.res.statusCode===304&&(Y=F),!Y){const x=q.res.headers.etag;if(!x)throw new b.$1gb("Server did not return the ref",U,"NoRef",q.res.statusCode,q.res.headers[b.$Wgb]);const H=await(0,c.$1o)(q);if(!H&&q.res.statusCode===304)throw new b.$1gb("Empty response",U,"EmptyResponse",q.res.statusCode,q.res.headers[b.$Wgb]);H&&(Y={...JSON.parse(H),ref:x})}const K=this.s.get(n,-1);return K&&Y&&K!==Y.session&&this.C(),Y===null&&K&&this.C(),Y&&this.s.store(n,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,d.$wg)(this.a,"download").toString(),M={},U=await this.D(F,{type:"GET",headers:M},[],A.CancellationToken.None);if(!(0,c.$Xo)(U))throw new b.$1gb("Server returned "+U.res.statusCode,F,"EmptyResponse",U.res.statusCode,U.res.headers[b.$Wgb]);if((0,c.$Yo)(U))throw new b.$1gb("Empty response",F,"EmptyResponse",U.res.statusCode,U.res.headers[b.$Wgb]);return U.stream}z(F,M,U){return M?(0,d.$wg)(F,"collection",M,"resource",U):(0,d.$wg)(F,"resource",U)}C(){this.s.remove(n,-1),this.s.remove(i,-1)}async D(F,M,U,q){if(!this.b)throw new b.$1gb("No Auth Token Available",F,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new b.$1gb(`${M.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Y=await this.c;M.headers={...M.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(M.headers),this.r.trace("Sending request to server",{url:F,type:M.type,headers:{...M.headers,authorization:void 0}});let K;try{K=await this.f.request(F,M,q)}catch(W){if(!(W instanceof b.$1gb)){let ee="RequestFailed";const ne=(0,L.$9)(W).toLowerCase();ne.includes("xhr timeout")?ee="RequestTimeout":ne.includes("protocol")&&ne.includes("not supported")?ee="RequestProtocolNotSupported":ne.includes("request path contains unescaped characters")?ee="RequestPathNotEscaped":ne.includes("headers must be an object")?ee="RequestHeadersNotObject":(0,L.$3)(W)&&(ee="RequestCanceled"),W=new b.$1gb(`Connection refused for the request '${F}'.`,F,ee,void 0,void 0)}throw this.r.info("Request failed",F),W}const x=K.res.headers[b.$Wgb],H={url:F,status:K.res.statusCode,"execution-id":M.headers[b.$Xgb],"operation-id":x},Q=(0,c.$Xo)(K)||K.res.statusCode&&U.includes(K.res.statusCode);let J="";if(Q?this.r.trace("Request succeeded",H):(J=await(0,c.$Zo)(K)||"",this.r.info("Request failed",H,J)),K.res.statusCode===401||K.res.statusCode===403){if(this.b=void 0,K.res.statusCode===401)throw this.g.fire("Unauthorized"),new b.$1gb(`${M.type} request '${F}' failed because of Unauthorized (401).`,F,"Unauthorized",K.res.statusCode,x);if(K.res.statusCode===403)throw this.g.fire("Forbidden"),new b.$1gb(`${M.type} request '${F}' failed because the access is forbidden (403).`,F,"Forbidden",K.res.statusCode,x)}if(this.h.fire(),K.res.statusCode===404)throw new b.$1gb(`${M.type} request '${F}' failed because the requested resource is not found (404).`,F,"NotFound",K.res.statusCode,x);if(K.res.statusCode===405)throw new b.$1gb(`${M.type} request '${F}' failed because the requested endpoint is not found (405). ${J}`,F,"MethodNotFound",K.res.statusCode,x);if(K.res.statusCode===409)throw new b.$1gb(`${M.type} request '${F}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,F,"Conflict",K.res.statusCode,x);if(K.res.statusCode===410)throw new b.$1gb(`${M.type} request '${F}' failed because the requested resource is not longer available (410).`,F,"Gone",K.res.statusCode,x);if(K.res.statusCode===412)throw new b.$1gb(`${M.type} request '${F}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,F,"PreconditionFailed",K.res.statusCode,x);if(K.res.statusCode===413)throw new b.$1gb(`${M.type} request '${F}' failed because of too large payload (413).`,F,"TooLarge",K.res.statusCode,x);if(K.res.statusCode===426)throw new b.$1gb(`${M.type} request '${F}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,F,"UpgradeRequired",K.res.statusCode,x);if(K.res.statusCode===429){const W=K.res.headers["retry-after"];throw W?(this.y(new Date(Date.now()+parseInt(W)*1e3)),new b.$1gb(`${M.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",K.res.statusCode,x)):new b.$1gb(`${M.type} request '${F}' failed because of too many requests (429).`,F,"RemoteTooManyRequests",K.res.statusCode,x)}if(!Q)throw new b.$1gb("Server returned "+K.res.statusCode,F,"Unknown",K.res.statusCode,x);return K}F(F){let M=this.s.get(i,-1);M===void 0&&(M=(0,w.$fg)(),this.s.store(i,M,-1,1)),F["X-Machine-Session-Id"]=M;const U=this.s.get(n,-1);U!==void 0&&(F["X-User-Session-Id"]=U)}};e.$OEb=m,e.$OEb=m=pe([X(1,p.$sj),X(2,c.$Vo),X(3,b.$0gb),X(4,g.$Zh),X(5,y.$bk),X(6,u.$9o)],m);let h=class extends m{constructor(F,M,U,q,Y,K,x){super(F.userDataSyncStore?.url,M,U,q,Y,K,x),this.B(F.onDidChangeUserDataSyncStore(()=>this.t(F.userDataSyncStore?.url)))}};e.$PEb=h,e.$PEb=h=pe([X(0,b.$Tgb),X(1,p.$sj),X(2,c.$Vo),X(3,b.$0gb),X(4,g.$Zh),X(5,y.$bk),X(6,u.$9o)],h);class ${constructor(F,M,U,q){this.c=F,this.d=M,this.f=U,this.g=q,this.a=[],this.b=void 0}request(F,M,U){if(this.h()&&this.i(),M.url=F,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new b.$1gb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,F,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(F),this.f.request(M,U)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$QEb=$}),define(ae[259],ce([0,1,3,56,25,21,22,254,24,79,82]),function(ie,e,I,A,L,j,O,R,S,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i0b=void 0;let E=class extends R.$C6b{constructor(l,g,y,p,c,f,u,b,k,s,a){super(l,g,y,p,c,u,b,k,s,a),this.B(I.Event.debounce(I.Event.any(I.Event.map(f.onDidFocusMainWindow,()=>"windowFocus"),I.Event.map(f.onDidOpenMainWindow,()=>"windowOpen")),(n,i)=>n?[...n,i]:[i],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$i0b=E,e.$i0b=E=pe([X(0,L.$sj),X(1,S.$Tgb),X(2,S.$Ugb),X(3,S.$5gb),X(4,S.$6gb),X(5,A.$_7b),X(6,S.$0gb),X(7,d.$rDb),X(8,O.$fl),X(9,C.$Hgb),X(10,j.$9o)],E)}),define(ae[260],ce([0,1,71,23,5,19]),function(ie,e,I,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G7b=e.$F7b=e.$E7b=e.$D7b=void 0,e.$D7b=128/4;function O(d){function C(){let E=d.scheme===A.Schemas.file?(0,j.$kg)(d):d.toString();return L.$k||(E=E.toLowerCase()),(0,I.createHash)("md5").update(E).digest("hex")}return{id:C(),configPath:d}}e.$E7b=O;function R(d,C){function E(){if(d.scheme!==A.Schemas.file)return(0,I.createHash)("md5").update(d.toString()).digest("hex");if(!C)return;let l;return L.$k?l=C.ino:L.$j?l=C.birthtime.getTime():L.$i&&(typeof C.birthtimeMs=="number"?l=Math.floor(C.birthtimeMs):l=C.birthtime.getTime()),(0,I.createHash)("md5").update(d.fsPath).update(l?String(l):"").digest("hex")}const w=E();if(typeof w=="string")return{id:w,uri:d}}e.$F7b=R;function S(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$G7b=S}),define(ae[261],ce([0,1,6,7,2,16,31,14,8,76,112,260,56,55,23]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O9b=void 0;let y=class extends L.$Rc{constructor(c,f,u,b){super(),this.a=c,this.b=f,this.c=u,this.f=b,this.B(new I.$7g(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const c=this.a.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,f=await O.Promises.readdir(c),u=new d.$3Db(this.f.getChannel("storage"));await Promise.all(f.map(async b=>{const k=(0,j.$ic)(c,b);b.length===E.$D7b||b===C.$5h.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===b)||await u.isUsed(k)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${b} as it seems to be an unused empty workspace.`),await O.Promises.rm(k))}))}catch(c){(0,A.$Z)(c)}}};e.$O9b=y,e.$O9b=y=pe([X(0,R.$1h),X(1,S.$aj),X(2,w.$_7b),X(3,l.$n9b)],y)}),define(ae[83],ce([0,1,53,6,16,12,31,147,272,273]),function(ie,e,I,A,L,j,O,R,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.zip=e.$op=e.$np=void 0,e.$np="end of central directory record signature not found";const C=new RegExp(e.$np);class E extends Error{constructor(a,n){let i=n.message;switch(a){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=a,this.cause=n}}e.$op=E;function w(s){const a=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>a&n).reduce((n,i)=>n+i,a&61440)}function l(s){if(s instanceof E)return s;let a;return C.test(s.message)&&(a="CorruptZip"),new E(a,s)}function g(s,a,n,i,t,r){const o=L.$lc(a),v=L.$ic(i,o);if(!v.startsWith(i))return Promise.reject(new Error(R.localize(0,null,a)));const m=L.$ic(i,a);let h;return r.onCancellationRequested(()=>{h?.destroy()}),Promise.resolve(O.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise(($,D)=>{if(!r.isCancellationRequested)try{h=(0,I.createWriteStream)(m,{mode:n}),h.once("close",()=>$()),h.once("error",D),s.once("error",D),s.pipe(h)}catch(F){D(F)}}))}function y(s,a,n,i){let t=(0,A.$Ig)(()=>Promise.resolve()),r=0;const o=i.onCancellationRequested(()=>{t.cancel(),s.close()});return new Promise((v,m)=>{const h=new A.$Pg,$=D=>{D.isCancellationRequested||(r++,s.readEntry())};s.once("error",m),s.once("close",()=>t.then(()=>{i.isCancellationRequested||s.entryCount===r?v():m(new E("Incomplete",new Error(R.localize(1,null,r,s.entryCount))))},m)),s.readEntry(),s.on("entry",D=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(D.fileName)){$(i);return}const F=D.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(F)){const q=L.$ic(a,F);t=(0,A.$Ig)(Y=>O.Promises.mkdir(q,{recursive:!0}).then(()=>$(Y)).then(void 0,m));return}const M=c(s,D),U=w(D);t=(0,A.$Ig)(q=>h.queue(()=>M.then(Y=>g(Y,F,U,a,n,q).then(()=>$(q)))).then(null,m))})}).finally(()=>o.dispose())}function p(s,a=!1){return new Promise((n,i)=>{(0,S.open)(s,a?{lazyEntries:!0}:void 0,(t,r)=>{t?i(l(t)):n((0,j.$Kf)(r))})})}function c(s,a){return new Promise((n,i)=>{s.openReadStream(a,(t,r)=>{t?i(l(t)):n((0,j.$Kf)(r))})})}function f(s,a){return new Promise((n,i)=>{const t=new d.ZipFile;a.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const r=(0,I.createWriteStream)(s);t.outputStream.pipe(r),t.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>n(s))})}e.zip=f;function u(s,a,n={},i){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=p(s,!0);return n.overwrite&&(r=r.then(o=>O.Promises.rm(a).then(()=>o))),r.then(o=>y(o,a,{sourcePathRegex:t},i))}e.$qp=u;function b(s,a){return p(s).then(n=>new Promise((i,t)=>{n.on("entry",r=>{r.fileName===a&&c(n,r).then(o=>i(o),o=>t(o))}),n.once("close",()=>t(new Error(R.localize(2,null,a))))}))}function k(s,a){return b(s,a).then(n=>new Promise((i,t)=>{const r=[];n.once("error",t),n.on("data",o=>r.push(o)),n.on("end",()=>i(Buffer.concat(r)))}))}e.$rp=k}),define(ae[262],ce([0,1,6,7,2,23,19,54,12,32,31,83,20,14,29,33,97,11,8]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=void 0;let b=class extends L.$Rc{static{u=this}static{this.c=".sigzip"}constructor(s,a,n,i,t,r){super(),this.h=a,this.j=n,this.m=i,this.n=t,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,a,n){await this.g;const i=(0,O.$wg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,a))}catch(r){throw new g.$bo(r.message,g.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(s)){const r=await this.u(s);try{t=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===f.LogLevel.Trace)}catch(o){const v=o;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${v.output}`),t===g.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===g.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new g.$bo(E.$np,g.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(o){this.r.error(o)}}}return t===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${s.identifier.id}`),{location:i,verificationStatus:t}}t(s){if(!s.isSigned)return!1;const a=this.m.getValue("extensions.verifySignature");return(0,S.$Ff)(a)?a:!0}async u(s){await this.g;const a=(0,O.$wg)(this.extensionsDownloadDir,`${this.z(s)}${u.c}`);return await this.w(s,a,n=>this.j.downloadSignatureArchive(s,n)),a}async w(s,a,n){if(await this.h.exists(a))return;if(a.scheme!==j.Schemas.file){await n(a);return}const i=(0,O.$wg)(this.extensionsDownloadDir,`.${(0,d.$fg)()}`);await this.h.exists(i)||await n(i);try{await C.Promises.rename(i.fsPath,a.fsPath,2*60*1e3)}catch(t){try{await this.h.del(i)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,A.$9)(t)}. Deleted the file from downloaded location`,i.path),t}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const a=[],n=[],i=[];for(const o of s.children)if(o.name.endsWith(u.c))i.push(o.resource);else{const v=y.$Do.parse(o.name);v&&n.push([v,o])}const t=(0,y.$Io)(n,([o])=>o),r=[];for(const o of t)o.sort((v,m)=>R.rcompare(v[0].version,m[0].version)),a.push(...o.slice(1).map(v=>v[1].resource)),r.push(o[0][1]);r.sort((o,v)=>o.mtime-v.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.f)).map(o=>o.resource)),a.push(...i),await I.Promises.settled(a.map(o=>(this.r.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(s){this.r.error(s)}}z(s){return this.f?y.$Do.create(s).toString().toLowerCase():(0,d.$fg)()}};e.$Gp=b,e.$Gp=b=u=pe([X(0,l.$1h),X(1,c.$bk),X(2,g.$ao),X(3,w.$mi),X(4,p.$hp),X(5,f.$aj)],b)}),define(ae[263],ce([0,1,83,156]),function(ie,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;function L(j){return(0,I.$rp)(j,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}e.$Ip=L}),define(ae[121],ce([0,1,6,15,26,38,7,3,52,2,34,23,16,19,54,12,10,32,31,83,155,96,14,242,29,33,51,80,262,243,263,212,223,69,11,4,8,25,22,28,17]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f,u,b,k,s,a,n,i,t,r,o,v,m,h,$,D,F,M,U,q,Y,K,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.$Mp=e.$Lp=void 0,e.$Lp=(0,M.$Th)(n.$co);const H=".vsctmp";let Q=class extends a.$sp{constructor(Z,z,P,T,B,N,V,G,te,oe,ue,he){super(Z,z,ue,P,oe,he),this.fb=B,this.gb=N,this.hb=V,this.ib=te,this.eb=new Map,this.rb=new C.$Ac;const ge=this.B(G.createInstance(v.$Hp));this.bb=this.B(G.createInstance(J,we=>ge.postUninstall(we))),this.cb=this.B(new h.$Jp(he,te,ue,this,this.F)),this.db=this.B(G.createInstance(o.$Gp));const de=this.B(new $.$Kp(this,this.fb,he,N,ue,te,P));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$No)(this.ib,this.F)),this.jb}async zip(Z){this.F.trace("ExtensionManagementService#zip",Z.identifier.id);const z=await this.pb(Z),P=await(0,u.zip)((0,l.$wg)(this.db.extensionsDownloadDir,(0,c.$fg)()).fsPath,z);return p.URI.file(P)}async unzip(Z){return this.F.trace("ExtensionManagementService#unzip",Z.toString()),(await this.install(Z)).identifier}async getManifest(Z){const{location:z,cleanup:P}=await this.lb(Z),T=w.$jc(z.fsPath);try{return await(0,m.$Ip)(T)}finally{await P()}}getInstalled(Z,z=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(Z??null,z)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Z){return this.bb.scanUserExtensionAtLocation(Z)}async install(Z,z={}){this.F.trace("ExtensionManagementService#install",Z.toString());const{location:P,cleanup:T}=await this.lb(Z);try{const B=await(0,m.$Ip)(w.$jc(P.fsPath)),N=(0,i.$Ho)(B.publisher,B.name);if(B.engines&&B.engines.vscode&&!(0,D.$Uo)(B.engines.vscode,this.G.version,this.G.date))throw new Error(b.localize(0,null,N,this.G.version));const G=(await this.I([{manifest:B,extension:P,options:z}])).find(({identifier:te})=>(0,i.$Co)(te,{id:N}));if(G?.local)return G.local;throw G?.error?G.error:(0,a.$up)(new Error(`Unknown error while installing extension ${N}`))}finally{await T()}}async installFromLocation(Z,z){this.F.trace("ExtensionManagementService#installFromLocation",Z.toString());const P=await this.bb.scanUserExtensionAtLocation(Z);if(!P)throw new Error(`Cannot find a valid extension from the location ${Z.toString()}`);return await this.ub([[P,void 0]],z),this.F.info("Successfully installed extension",P.identifier.id,z.toString()),P}async installExtensionsFromProfile(Z,z,P){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",Z,z.toString(),P.toString());const T=(await this.bb.scanExtensions(1,z)).filter(B=>Z.some(N=>(0,i.$Co)(N,B.identifier)));if(T.length){const B=await Promise.all(T.map(N=>this.bb.scanMetadata(N,z)));await this.ub(T.map((N,V)=>[N,B[V]]),P),this.F.info("Successfully installed extensions",T.map(N=>N.identifier.id),P.toString())}return T}async updateMetadata(Z,z,P=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",Z.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),Z=await this.bb.updateMetadata(Z,z,P),this.cb.invalidate(P),this.w.fire(Z),Z}async reinstallFromGallery(Z){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",Z.identifier.id),!this.z.isEnabled())throw new Error(b.localize(1,null));const z=await this.getTargetPlatform(),[P]=await this.z.getExtensions([{...Z.identifier,preRelease:Z.preRelease}],{targetPlatform:z,compatible:!0},L.CancellationToken.None);if(!P)throw new Error(b.localize(2,null));await this.bb.setUninstalled(Z);try{await this.bb.removeUninstalledExtension(Z)}catch(T){throw new Error(b.localize(3,null,(0,j.$Di)(T)))}return this.installFromGallery(P)}ab(Z,z,P,T){return this.bb.copyExtension(Z,z,P,T)}copyExtensions(Z,z){return this.bb.copyExtensions(Z,z)}markAsUninstalled(...Z){return this.bb.setUninstalled(...Z)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(Z){this.F.error(Z)}}async download(Z,z,P){const{location:T}=await this.db.download(Z,z,!P);return T}async lb(Z){if(Z.scheme===E.Schemas.file)return{location:Z,async cleanup(){}};this.F.trace("Downloading extension from",Z.toString());const z=(0,l.$wg)(this.db.extensionsDownloadDir,(0,c.$fg)());return await this.hb.download(Z,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(T){this.F.error(T)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(Z,z,P){if(p.URI.isUri(z))return new ne(Z,z,P,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const T=i.$Do.create(z).toString();let B=this.eb.get(T);return B||(this.eb.set(T,B=new ee(Z,z,P,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),B.waitUntilTaskIsFinished().finally(()=>this.eb.delete(T))),B}$(Z,z){return new _(Z,z.profileLocation,this.gb)}async pb(Z){const z=async T=>{let B=await f.Promises.readdir(T);B=B.map(G=>w.$ic(T,G));const N=await Promise.all(B.map(G=>f.Promises.stat(G)));let V=Promise.resolve([]);return N.forEach((G,te)=>{const oe=B[te];G.isFile()&&(V=V.then(ue=>[...ue,oe])),G.isDirectory()&&(V=V.then(ue=>z(oe).then(he=>[...ue,...he])))}),V};return(await z(Z.location.fsPath)).map(T=>({path:`extension/${w.$kc(Z.location.fsPath,T)}`,localPath:T}))}async qb({added:Z,removed:z}){if(z){const P=Z&&this.D.extUri.isEqual(z.profileLocation,Z.profileLocation)?z.extensions.filter(T=>Z.extensions.every(B=>!(0,i.$Co)(B,T))):z.extensions;for(const T of P)this.F.info("Extensions removed from another source",T.id,z.profileLocation.toString()),this.u.fire({identifier:T,profileLocation:z.profileLocation})}if(Z){const T=(await this.bb.scanExtensions(1,Z.profileLocation)).filter(B=>Z.extensions.some(N=>(0,i.$Co)(N,B.identifier)));this.s.fire(T.map(B=>(this.F.info("Extensions added from another source",B.identifier.id,Z.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:Z.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(z=>this.rb.add(z)));const Z=await this.ib.resolve(this.fb.userExtensionsLocation);for(const z of Z.children??[])z.isDirectory&&this.rb.add(z.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.tb(z)))}async tb(Z){if(!Z.affects(this.fb.userExtensionsLocation,1))return;const z=[];for(const P of Z.rawAdded){if(this.rb.has(P)||!this.D.extUri.isEqual(this.D.extUri.dirname(P),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(P,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(P).startsWith(".")||!(await this.ib.stat(P)).isDirectory)continue;const T=await this.bb.scanUserExtensionAtLocation(P);T&&T.installedTimestamp===void 0&&(this.rb.add(P),z.push(T))}z.length&&(await this.ub(z.map(P=>[P,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(P=>P.identifier.id)))}async ub(Z,z){const P=Z.map(T=>T[0]);await this.vb(P),await this.gb.addExtensionsToProfile(Z,z),this.s.fire(P.map(T=>({local:T,identifier:T.identifier,operation:1,profileLocation:z})))}async vb(Z){const z=await this.bb.getUninstalledExtensions();for(const P of Z){const T=i.$Do.create(P);z[T.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",T.id),await this.bb.setInstalled(T),this.F.info("Removed the extension from uninstalled list:",T.id))}}};e.$Mp=Q,e.$Mp=Q=pe([X(0,n.$ao),X(1,Y.$fl),X(2,U.$aj),X(3,s.$1h),X(4,r.$Bp),X(5,t.$xp),X(6,k.$Rn),X(7,M.$Rh),X(8,F.$bk),X(9,q.$sj),X(10,K.$Lk),X(11,x.$Nk)],Q);let J=class extends d.$Rc{constructor(Z,z,P,T,B,N){super(),this.j=Z,this.m=z,this.n=P,this.s=T,this.t=B,this.u=N,this.h=this.B(new R.$Od),this.onExtract=this.h.event,this.c=(0,l.$wg)(this.n.userExtensionsLocation,".obsolete"),this.g=new I.$2g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(Z,z){const P={includeInvalid:!0,profileLocation:z};let T=[];return Z===null||Z===0?T.push(...await this.n.scanAllExtensions({includeInvalid:!0},P,!1)):Z===1&&T.push(...await this.n.scanUserExtensions(P)),T=Z!==null?T.filter(B=>B.type===Z):T,Promise.all(T.map(B=>this.F(B)))}async scanAllUserExtensions(Z){const z=await this.n.scanUserExtensions({includeAllVersions:!Z,includeInvalid:!0});return Promise.all(z.map(P=>this.F(P)))}async scanUserExtensionAtLocation(Z){try{const z=await this.n.scanExistingExtension(Z,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(Z,z,P,T,B){const N=Z.toString(),V=p.URI.file(w.$ic(this.n.userExtensionsLocation.fsPath,`.${(0,c.$fg)()}`)),G=p.URI.file(w.$ic(this.n.userExtensionsLocation.fsPath,N));let te=await this.m.exists(G);if(te&&T){try{await this.y(Z.id,G,"removeExisting")}catch{throw new n.$bo(b.localize(4,null,G.fsPath,Z.id),n.ExtensionManagementErrorCode.Delete)}te=!1}if(!te)try{try{this.u.trace(`Started extracting the extension from ${z} to ${G.fsPath}`),await(0,u.$qp)(z,V.fsPath,{sourcePath:"extension",overwrite:!0},B),this.u.info(`Extracted extension to ${G}:`,Z.id)}catch(oe){let ue=n.ExtensionManagementErrorCode.Extract;throw oe instanceof u.$op&&(oe.type==="CorruptZip"?ue=n.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(ue=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$bo(oe.message,ue)}await this.n.updateMetadata(V,P);try{this.u.trace(`Started renaming the extension from ${V.fsPath} to ${G.fsPath}`),await this.C(V.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(oe){if(oe.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",Z.id);else throw this.u.info(`Rename failed because of ${(0,O.$9)(oe)}. Deleted from extracted location`,V),oe}this.h.fire(G)}catch(oe){try{await this.m.del(V,{recursive:!0})}catch{}throw oe}return this.D(G,1)}async scanMetadata(Z,z){return z?(await this.w(Z,z))?.metadata:this.n.scanMetadata(Z.location)}async w(Z,z){return(await this.s.scanProfileExtensions(z)).find(T=>(0,i.$Co)(T.identifier,Z.identifier))}async updateMetadata(Z,z,P){return P?await this.s.updateMetadata([[Z,z]],P):await this.n.updateMetadata(Z.location,z),this.D(Z.location,Z.type,P)}getUninstalledExtensions(){return this.z()}async setUninstalled(...Z){const z=Z.map(P=>i.$Do.create(P));await this.z(P=>z.forEach(T=>{P[T.toString()]=!0,this.u.info("Marked extension as uninstalled",T.toString())}))}async setInstalled(Z){await this.z(z=>delete z[Z.toString()])}async removeExtension(Z,z){if(this.t.extUri.isEqualOrParent(Z.location,this.n.userExtensionsLocation))return this.y(Z.identifier.id,Z.location,z)}async removeUninstalledExtension(Z){await this.removeExtension(Z,"uninstalled"),await this.z(z=>delete z[i.$Do.create(Z).toString()])}async copyExtension(Z,z,P,T){const B=await this.w(Z,z),N=await this.w(Z,P);return T={...B?.metadata,...T},N?await this.s.updateMetadata([[Z,{...N.metadata,...T}]],P):await this.s.addExtensionsToProfile([[Z,T]],P),this.D(Z.location,Z.type,P)}async copyExtensions(Z,z){const P=await this.scanExtensions(1,Z),T=await Promise.all(P.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,Z)]));await this.s.addExtensionsToProfile(T,z)}async y(Z,z,P){this.u.trace(`Deleting ${P} extension from disk`,Z,z.fsPath);const T=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,S.$Gi)((0,c.$fg)()).toString(16)}${H}`);await this.C(z.fsPath,T.fsPath),await this.m.del(T,{recursive:!0}),this.u.info(`Deleted ${P} extension from disk`,Z,z.fsPath)}async z(Z){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(T){if((0,F.$sk)(T)!==1)throw T}let P={};if(z)try{P=JSON.parse(z)}catch{}return Z&&(Z(P),Object.keys(P).length?await this.m.writeFile(this.c,A.$ce.fromString(JSON.stringify(P))):await this.m.del(this.c)),P})}async C(Z,z){try{await f.Promises.rename(Z,z,2*60*1e3)}catch(P){throw new n.$bo(P.message||b.localize(5,null,Z,z),P.code||n.ExtensionManagementErrorCode.Rename)}}async D(Z,z,P){if(P){const B=(await this.n.scanUserExtensions({profileLocation:P})).find(N=>this.t.extUri.isEqual(N.location,Z));if(B)return this.F(B)}else{const T=await this.n.scanExistingExtension(Z,z,{includeInvalid:!0});if(T)return this.F(T)}throw new Error(b.localize(6,null,Z.path))}async F(Z){const z=await this.m.resolve(Z.location);let P,T;return z.children&&(P=z.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,T=z.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:Z.identifier,type:Z.type,isBuiltin:Z.isBuiltin||!!Z.metadata?.isBuiltin,location:Z.location,manifest:Z.manifest,targetPlatform:Z.targetPlatform,validations:Z.validations,isValid:Z.isValid,readmeUrl:P,changelogUrl:T,publisherDisplayName:Z.metadata?.publisherDisplayName||null,publisherId:Z.metadata?.publisherId||null,isApplicationScoped:!!Z.metadata?.isApplicationScoped,isMachineScoped:!!Z.metadata?.isMachineScoped,isPreReleaseVersion:!!Z.metadata?.isPreReleaseVersion,preRelease:!!Z.metadata?.preRelease,installedTimestamp:Z.metadata?.installedTimestamp,updated:!!Z.metadata?.updated,pinned:!!Z.metadata?.pinned}}async G(){const Z=await this.getUninstalledExtensions();if(Object.keys(Z).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(Z));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),P=new Set;for(const B of z)Z[i.$Do.create(B).toString()]||P.add(B.identifier.id.toLowerCase());try{const B=(0,i.$Io)(z,N=>N.identifier);await I.Promises.settled(B.map(async N=>{const V=N.sort((G,te)=>g.rcompare(G.manifest.version,te.manifest.version))[0];P.has(V.identifier.id.toLowerCase())||await this.j(await this.F(V))}))}catch(B){this.u.error(B)}const T=z.filter(B=>B.metadata&&Z[i.$Do.create(B).toString()]);await Promise.allSettled(T.map(B=>this.removeUninstalledExtension(B)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let Z;try{Z=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,F.$sk)(z)!==1&&this.u.error(z);return}if(Z?.children)try{await Promise.allSettled(Z.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(H))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(P){(0,F.$sk)(P)!==1&&this.u.error(P)}}}))}catch{}}};e.$Np=J,e.$Np=J=pe([X(1,F.$bk),X(2,r.$Bp),X(3,t.$xp),X(4,K.$Lk),X(5,U.$aj)],J);class W extends a.$vp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,y.$Gf)(this.options.operation)?this.l:this.options.operation}constructor(Z,z,P,T,B,N,V,G,te){super(),this.identifier=Z,this.source=z,this.options=P,this.m=T,this.n=B,this.o=N,this.p=V,this.q=G,this.s=te,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(Z){const[z,P]=await this.x(Z);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,P]],this.j),z}async u({zipPath:Z,key:z,metadata:P},T,B){let N=await this.v(z);return N||(this.s.trace("Extracting extension...",z.id),N=await this.m.extractUserExtension(z,Z,P,T,B),this.s.info("Extracting extension completed.",z.id)),N}async v(Z){return await this.w(Z)?(this.s.trace("Removing the extension from uninstalled list:",Z.id),await this.m.setInstalled(Z),this.s.info("Removed the extension from uninstalled list:",Z.id),(await this.m.scanAllUserExtensions(!0)).find(T=>i.$Do.create(T).equals(Z))):void 0}async w(Z){return!!(await this.m.getUninstalledExtensions())[Z.toString()]}}class ee extends W{constructor(Z,z,P,T,B,N,V,G,te,oe){super(z.identifier,z,P,B,N,V,G,te,oe),this.y=z,this.z=T}async x(Z){const P=(await this.m.scanExtensions(null,this.options.profileLocation)).find(V=>(0,i.$Co)(V.identifier,this.y.identifier));P&&(this.l=3);const T={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,isSystem:P?.type===0?!0:void 0,updated:!!P,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,y.$Ff)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:P?.preRelease)};if(P?.manifest.version===this.y.version)return[await this.m.updateMetadata(P,T),T];const{location:B,verificationStatus:N}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=N,this.B(B.fsPath),[await this.u({zipPath:B.fsPath,key:i.$Do.create(this.y),metadata:T},!1,Z),T]}catch(V){try{await this.z.delete(B)}catch(G){this.s.warn("Error while deleting the downloaded file",B.toString(),(0,O.$9)(G))}throw V}}async B(Z){try{await(0,m.$Ip)(Z)}catch(z){throw new n.$bo((0,a.$tp)(z).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Op=ee;class ne extends W{constructor(Z,z,P,T,B,N,V,G,te,oe){super({id:(0,i.$Ho)(Z.publisher,Z.name)},z,P,B,N,V,G,te,oe),this.y=Z,this.z=z,this.A=T}async h(Z){const z=await super.h(Z);return this.D(z,Z),z}async x(Z){const z=new i.$Do(this.identifier,this.y.version),T=(await this.m.scanExtensions(1,this.options.profileLocation)).find(V=>(0,i.$Co)(this.identifier,V.identifier)),B={isApplicationScoped:this.options.isApplicationScoped||T?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||T?.isMachineScoped,isBuiltin:this.options.isBuiltin||T?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(T)if(this.l=3,z.equals(new i.$Do(T.identifier,T.manifest.version)))try{await this.m.removeExtension(T,"existing")}catch{throw new Error(b.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&g.gt(T.manifest.version,this.y.version)&&await this.m.setUninstalled(T);else{const V=await this.v(z);if(V)try{await this.m.removeExtension(V,"existing")}catch{throw new Error(b.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:w.$jc(this.z.fsPath),key:z,metadata:B},!0,Z),B]}async D(Z,z){try{let[P]=await this.A.getExtensions([{id:Z.identifier.id,version:Z.manifest.version}],z);if(P||([P]=await this.A.getExtensions([{id:Z.identifier.id}],z)),P){const T={id:P.identifier.uuid,publisherDisplayName:P.publisherDisplayName,publisherId:P.publisherId,isPreReleaseVersion:P.properties.isPreReleaseVersion,preRelease:P.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(Z,T,this.options.profileLocation)}}catch{}}}class _ extends a.$vp{constructor(Z,z,P){super(),this.extension=Z,this.j=z,this.k=P}async h(Z){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ae[264],ce([0,1,2,29,81,222,121,8,21]),function(ie,e,I,A,L,j,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c0b=void 0;let d=class extends I.$Rc{constructor(E,w,l,g,y,p){super(),E.cleanUp(),(0,j.$TWb)(E,w,l,g,p),L.$1u.removeOutdatedExtensionVersions(E,y)}};e.$c0b=d,e.$c0b=d=pe([X(0,O.$Lp),X(1,A.$ao),X(2,L.$Zu),X(3,A.$fo),X(4,S.$9o),X(5,R.$aj)],d)}),define(ae[122],ce([0,1,71,63,36,274,15,7,3,2,16,5,32,40,67]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=void 0;class y{traceSocketEvent(h,$){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,h,$)}constructor(h,$=""){this.f=!0,this.debugLabel=$,this.socket=h,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,R.$Z)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(h){const $=D=>{this.traceSocketEvent("read",D),h(O.$ce.wrap(D))};return this.socket.on("data",$),{dispose:()=>this.socket.off("data",$)}}onClose(h){const $=D=>{h({type:0,hadError:D,error:void 0})};return this.socket.on("close",$),{dispose:()=>this.socket.off("close",$)}}onEnd(h){const $=()=>{h()};return this.socket.on("end",$),{dispose:()=>this.socket.off("end",$)}}write(h){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",h),this.socket.write(h.buffer,$=>{if($){if($.code==="EPIPE")return;(0,R.$Z)($)}})}catch($){if($.code==="EPIPE")return;(0,R.$Z)($)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((h,$)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),h();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),h()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.$Hh=y;var p;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var c;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(c||(c={}));class f extends d.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(h,$){this.socket.traceSocketEvent(h,$)}constructor(h,$,D,F){super(),this.f=this.B(new S.$Od),this.g=this.B(new S.$Od),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=h,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:$,inflateBytesLength:D?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new u(this,$,D,F,this.f,(M,U)=>this.m(M,U))),this.B(this.a.onError(M=>{console.error(M),(0,R.$Z)(M),this.g.fire({type:0,hadError:!0,error:M})})),this.b=new g.$Ch,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this.f.event(h)}onClose(h){return this.g.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){let $=0;for(;$<h.byteLength;)this.a.writeMessage(h.slice($,Math.min($+262144,h.byteLength)),{compressed:!0,opcode:2}),$+=262144}m(h,{compressed:$,opcode:D}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",h);let F=2;h.byteLength<126?F+=0:h.byteLength<2**16?F+=2:F+=8;const M=O.$ce.alloc(F),U=$?64:0,q=D&15;if(M.writeUInt8(128|U|q,0),h.byteLength<126)M.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){M.writeUInt8(126,1);let Y=1;M.writeUInt8(h.byteLength>>>8&255,++Y),M.writeUInt8(h.byteLength>>>0&255,++Y)}else{M.writeUInt8(127,1);let Y=1;M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(h.byteLength>>>24&255,++Y),M.writeUInt8(h.byteLength>>>16&255,++Y),M.writeUInt8(h.byteLength>>>8&255,++Y),M.writeUInt8(h.byteLength>>>0&255,++Y)}this.socket.write(O.$ce.concat([M,h]))}end(){this.h=!0,this.socket.end()}n(h){if(h.byteLength!==0){for(this.b.acceptChunk(h);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const $=this.b.peek(this.j.readLen),D=$.readUInt8(0),F=(D&128)>>>7,M=(D&64)>>>6,U=D&15,q=$.readUInt8(1),Y=(q&128)>>>7,K=q&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(K===126?2:0)+(K===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const $=this.b.read(this.j.readLen),D=$.readUInt8(1),F=(D&128)>>>7;let M=D&127,U=1;M===126?M=$.readUInt8(++U)*2**8+$.readUInt8(++U):M===127&&(M=$.readUInt8(++U)*0+$.readUInt8(++U)*0+$.readUInt8(++U)*0+$.readUInt8(++U)*0+$.readUInt8(++U)*2**24+$.readUInt8(++U)*2**16+$.readUInt8(++U)*2**8+$.readUInt8(++U));let q=0;F&&(q=$.readUInt8(++U)*2**24+$.readUInt8(++U)*2**16+$.readUInt8(++U)*2**8+$.readUInt8(++U)),this.j.state=3,this.j.readLen=M,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const $=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",$),s($,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",$),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame($,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage($,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Ih=f;class u extends d.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$ce.alloc(0)}constructor(h,$,D,F,M,U){super(),this.n=h,this.r=M,this.s=U,this.a=this.B(new S.$Od),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$Od),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new S.$Od),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,$?(this.b=this.B(new b(this.n,F,D,{windowBits:15})),this.f=this.B(new k(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(h,$){this.g.push({data:h,options:$}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:h,options:$}=this.g.shift();if(this.f&&$.compressed){const D=await this.w(this.f,h);this.s(D,$)}else this.s(h,{...$,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(h,$){return new Promise((D,F)=>{h.write($),h.flush(M=>D(M))})}acceptFrame(h,$,D){this.h.push({data:h,isCompressed:$,isLastFrameOfMessage:D}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const h=this.h.shift();if(this.b&&h.isCompressed){const $=await this.C(this.b,h.data,h.isLastFrameOfMessage);this.r.fire($)}else this.r.fire(h.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(h,$,D){return new Promise((F,M)=>{h.write($),D&&h.write(O.$ce.fromByteArray([0,0,255,255])),h.flush(U=>F(U))})}}class b extends d.$Rc{get recordedInflateBytes(){return this.j?O.$ce.concat(this.f):O.$ce.alloc(0)}constructor(h,$,D,F){super(),this.h=h,this.j=$,this.a=this.B(new S.$Od),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(F),this.b.on("error",M=>{this.h.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent("zlibInflateData",M),this.g.push(O.$ce.wrap(M))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(h){this.j&&this.f.push(h.clone()),this.h.traceSocketEvent("zlibInflateWrite",h),this.b.write(h.buffer)}flush(h){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const $=O.$ce.concat(this.g);this.g.length=0,h($)})}}class k extends d.$Rc{constructor(h,$){super(),this.g=h,this.a=this.B(new S.$Od),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(O.$ce.wrap(D))})}write(h){this.g.traceSocketEvent("zlibDeflateWrite",h.buffer),this.b.write(h.buffer)}flush(h){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let $=O.$ce.concat(this.f);this.f.length=0,$=$.slice(0,$.byteLength-4),h($)})}}function s(m,h){if(h===0)return;const $=m.byteLength>>>2;for(let Y=0;Y<$;Y++){const K=m.readUInt32BE(Y*4);m.writeUInt32BE(K^h,Y*4)}const D=$*4,F=m.byteLength-D,M=h>>>24&255,U=h>>>16&255,q=h>>>8&255;F>=1&&m.writeUInt8(m.readUInt8(D)^M,D),F>=2&&m.writeUInt8(m.readUInt8(D+1)^U,D+1),F>=3&&m.writeUInt8(m.readUInt8(D+2)^q,D+2)}e.$Jh=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const m=(0,w.$fg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const h=process.platform!=="darwin"&&e.$Jh?e.$Jh:(0,L.tmpdir)(),$=(0,C.$ic)(h,`vscode-ipc-${m}.sock`);return t($),$}e.$Kh=n;function i(m,h,$){const D=(0,I.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${$}-${h}-sock`;const F=$.substr(0,4),M=h.substr(0,6),U=D.substr(0,8);let q;return process.platform!=="darwin"&&e.$Jh&&!process.env.VSCODE_PORTABLE?q=(0,C.$ic)(e.$Jh,`vscode-${U}-${F}-${M}.sock`):q=(0,C.$ic)(m,`${F}-${M}.sock`),t(q),q}e.$Lh=i;function t(m){const h=a[E.$u];typeof h=="number"&&m.length>=h&&console.warn(`WARNING: IPC handle "${m}" is longer than ${h} chars, try a shorter --user-data-dir`)}class r extends l.$wh{static b(h){const $=S.Event.fromNodeEventEmitter(h,"connection");return S.Event.map($,D=>({protocol:new g.$Dh(new y(D,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(D,"close"))}))}constructor(h){super(r.b(h)),this.d=h}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Mh=r;function o(m){return new Promise((h,$)=>{const D=(0,A.createServer)();D.on("error",$),D.listen(m,()=>{D.removeListener("error",$),h(new r(D))})})}e.$Nh=o;function v(m,h){return new Promise(($,D)=>{const F=(0,A.createConnection)(m,()=>{F.removeListener("error",D),$(g.$Eh.fromSocket(new y(F,`ipc-client${h}`),h))});F.once("error",D)})}e.$Oh=v}),define(ae[265],ce([0,1,63,122,210]),function(ie,e,I,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l0b=void 0,e.$l0b=new class{supports(j){return!0}connect({host:j,port:O},R,S,d){return new Promise((C,E)=>{const w=I.createConnection({host:j,port:O},()=>{w.removeListener("error",E),w.write((0,L.$1pb)(R,S,d));const l=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",l),C(new A.$Hh(w,d)))};w.on("data",l)});w.setNoDelay(!0),w.once("error",E)})}}}),define(ae[266],ce([0,1,63,36,132,122,6,2,5,20,8,25,213,104,106,77,15]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h9b=e.$g9b=e.$f9b=e.$e9b=void 0;async function c(s,a,n,i,t){let r;for(let o=3;o&&(r?.dispose(),r=await new f(s,a,n,i,t).waitForReady(),!(t&&L.$ig[t]||!L.$ig[r.tunnelLocalPort]));o--);return r}class f extends R.$Rc{constructor(a,n,i,t,r){super(),this.m=n,this.n=r,this.privacy=y.TunnelPrivacyId.Private,this.j=new Map,this.a=a,this.b=I.createServer(),this.c=new O.$Tg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.r(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const a=this.n??this.tunnelRemotePort,n=(0,y.$hv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,L.$jg)(a,2,1e3,n),t=null;return this.b.listen(i,this.m),await this.c.wait(),t=this.b.address(),t||(i=0,this.b.listen(i,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(a){a.pause();const n=(0,y.$fv)(this.tunnelRemoteHost)||(0,y.$hv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,w.$9k)(this.a,n,this.tunnelRemotePort),t=i.getSocket(),r=i.readEntireBuffer();i.dispose(),r.byteLength>0&&a.write(r.buffer),a.on("end",()=>{a.localAddress&&this.j.delete(a.localAddress),t.end()}),a.on("close",()=>t.end()),a.on("error",()=>{a.localAddress&&this.j.delete(a.localAddress),t instanceof j.$Hh?t.socket.destroy():t.end()}),t instanceof j.$Hh?this.t(a,t):this.s(a,t),a.localAddress&&this.j.set(a.localAddress,()=>{a.end(),t.end()})}s(a,n){n.onClose(()=>a.destroy()),n.onEnd(()=>a.end()),n.onData(i=>a.write(i.buffer)),a.on("data",i=>n.write(p.$ce.wrap(i))),a.resume()}t(a,n){const i=n.socket;i.on("end",()=>a.end()),i.on("close",()=>a.end()),i.on("error",()=>{a.destroy()}),i.pipe(a),a.pipe(i)}}e.$e9b=f;let u=class extends y.$kv{constructor(a,n,i,t,r){super(n,r),this.u=a,this.v=i,this.w=t}isPortPrivileged(a){return(0,y.$iv)(a,this.l,S.OS,A.release())}s(a,n,i,t,r,o,v,m){const h=this.r(n,i);if(h)return++h.refcount,h.value;if((0,y.$cv)(a))return this.t(a,n,i,r,o,v,m);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${i} on local port ${r}.`);const $={commit:this.w.commit,quality:this.w.quality,addressProvider:a,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},D=c($,t,n,i,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(n,i,D),D}}};e.$f9b=u,e.$f9b=u=pe([X(0,l.$3k),X(1,C.$aj),X(2,g.$6k),X(3,E.$sj),X(4,d.$mi)],u);let b=class extends u{constructor(a,n,i,t,r){super(a,n,i,t,r)}};e.$g9b=b,e.$g9b=b=pe([X(0,l.$3k),X(1,C.$aj),X(2,g.$6k),X(3,E.$sj),X(4,d.$mi)],b);let k=class extends R.$Rc{constructor(a,n,i,t,r){super(),this.b=a,this.c=n,this.f=i,this.g=t,this.h=r,this.a=new Map}async openTunnel(a,n,i,t,r,o,v,m,h){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${t} on local port ${o}.`),!this.a.has(a)){const $=new b(this.b,this.c,this.g,this.f,this.h);this.B($),this.a.set(a,$),$.onTunnelClosed(async()=>{(await $.tunnels).length===0&&($.dispose(),this.a.delete(a))})}return this.a.get(a).openTunnel(n,i,t,r,o,v,m,h)}};e.$h9b=k,e.$h9b=k=pe([X(0,l.$3k),X(1,C.$aj),X(2,E.$sj),X(3,g.$6k),X(4,d.$mi)],k)}),define(ae[275],ce([0,1,36,38,7,2,23,10,18,3,40,146,204,205,195,196,261,186,188,20,209,95,220,96,215,14,113,246,29,97,187,121,98,11,198,199,70,4,194,72,73,225,8,200,102,25,58,21,107,22,108,109,110,45,228,81,111,24,79,253,238,239,82,252,256,257,258,59,251,240,106,219,77,266,214,229,28,230,5,231,189,207,206,80,245,17,51,203,57,250,227,241,105,255,264,9,201,101,248,244,216,183,56,202,259,247,55,249,104,265,181,217]),function(ie,e,I,A,L,j,O,R,S,d,C,E,w,l,g,y,p,c,f,u,b,k,s,a,n,i,t,r,o,v,m,h,$,D,F,M,U,q,Y,K,x,H,Q,J,W,ee,ne,_,se,Z,z,P,T,B,N,V,G,te,oe,ue,he,ge,de,we,ve,Oe,Ne,Me,le,$e,be,Se,Pe,Ue,je,ze,Fe,re,fe,me,ye,ke,Re,Ce,Ie,De,Ae,Te,Be,qe,We,_e,ut,yt,vt,Et,kt,ft,St,Ct,Pt,Rt,Ot,It,Dt,jt,dt,Lt,gt,At,Nt,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Tt extends j.$Rc{constructor(Ee){super(),this.f=Ee,this.a=this.B(new E.$3T(this)),this.b=void 0,this.c=this.B(new d.$Od),this.g()}g(){let Ee=!1;const Le=()=>{Ee||(Ee=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Le),(0,E.$4T)(process.parentPort,it.$t8b.exit,Le)}async init(){const Ee=await this.h();(0,te.$Ogb)(),Ee.invokeFunction(Le=>{const Ze=Le.get(Q.$aj),Ve=Le.get(Z.$fl),Ke=Le.get(De.$Nk);Ze.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Le),this.m(Ze),this.n(Ve,Ke),this.B(Ke.onDidChangeProfiles(()=>this.n(Ve,Ke)))}),this.B((0,j.$Oc)(Ee.createInstance(w.$K9b,this.f.codeCachePath),Ee.createInstance(l.$L9b),Ee.createInstance(p.$O9b),Ee.createInstance(y.$N9b),Ee.createInstance(g.$M9b),Ee.createInstance(vt.$c0b),Ee.createInstance(_e.$79b)))}async h(){const Ee=new K.$Qh,Le={_serviceBrand:void 0,...W.default};Ee.set(ee.$sj,Le);const Ze=new C.$Ah(He=>He==="main"),Ve=new dt.$o9b(this.a,Ze);Ee.set(dt.$n9b,Ve);const Ke=this.f.policiesData?new Te.$W8b(this.f.policiesData,Ve.getChannel("policy")):new Be.$nn;Ee.set(Be.$ln,Ke);const Ge=new Nt.$mm(this.f.args,Le);Ee.set(i.$1h,Ge);const xe=new J.$br(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(He=>({...He,resource:R.URI.revive(He.resource)})),Ve.getChannel("logger"));Ee.set(Q.$bj,xe);const st=this.B(xe.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),ct=this.B(new Q.$ij(st.getLevel())),Je=this.B(new kt.$TN(st,[ct]));Ee.set(Q.$aj,Je),this.b=this.B(new ft.$e0b(Je)),Ee.set(ft.$d0b,this.b);const Qe=this.B(new F.$Qp(Je));Ee.set(D.$bk,Qe);const lt=this.B(new M.$dq(Je));Qe.registerProvider(O.Schemas.file,lt);const rt=new re.$Cr(Qe);Ee.set(Fe.$Lk,rt);const Xe=this.B(new qe.$1N(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));Ee.set(De.$Nk,Xe);const ht=this.B(new me.$m9b(O.Schemas.file,this.B(new ye.$CN(Ve.getChannel(ye.$BN),{pathCaseSensitive:fe.$k})),O.Schemas.vscodeUserData,Xe,rt,Je));Qe.registerProvider(O.Schemas.vscodeUserData,ht);const Ye=this.B(new b.$Nn(Xe.defaultProfile.settingsResource,Qe,Ke,Je));Ee.set(u.$mi,Ye);const et=new Lt.$k0b(void 0,{defaultProfile:Xe.defaultProfile,currentProfile:Xe.defaultProfile},Ve,Ge);Ee.set(_.$9o,et),this.B((0,j.$Pc)(()=>et.flush())),await Promise.all([Ye.initialize(),et.initialize()]);const mt=new Pt.$Zq(Ve.getChannel("request"));Ee.set(ne.$Vo,mt),Ee.set(c.$P9b,new U.$Ph(f.$Q9b,void 0,!1)),Ee.set(Re.$aF,new U.$Ph(ke.$69b,void 0,!1));const bt=new It.$t9b(-1,Ve);Ee.set(Ot.$_7b,bt),Ee.set(a.$Rn,new U.$Ph(n.$9N,void 0,!0));const Ft=this.B(new $e.$T8b(bt)),Mt=new C.$Ah(He=>Ft.getActiveClientId().then(at=>He===at));Ee.set($.$DWb,new Rt.$g0b(this.a.getChannel("extensionRecommendationNotification",Mt)));let ot;const tt=[],wt=(0,B.$zo)(Le,Ye);if((0,B.$uo)(Le,Ge)){const He=new P.$U5b(Je,xe,Ge,Le);if(tt.push(He),!(0,B.$vo)(Le,Ge)&&Le.aiConfig?.ariaKey){const at=new We.$HN(mt,wt,"monacoworkbench",null,Le.aiConfig.ariaKey);this.B((0,j.$Pc)(()=>at.flush())),tt.push(at)}ot=new T.$4q({appenders:tt,commonProperties:(0,se.$ko)((0,I.release)(),(0,I.hostname)(),process.arch,Le.commit,Le.version,this.f.machineId,this.f.sqmId,wt),sendErrorTelemetry:!0,piiPaths:(0,B.$Ao)(Ge)},Ye,Le)}else{ot=B.$oo;const He=B.$so;tt.push(He)}this.a.registerChannel("telemetryAppender",new z.$y8b(tt)),Ee.set(Z.$fl,ot);const Ut=new N.$R9b(Ye,ot,Je,xe,Ge,Le);Ee.set(Z.$gl,Ut),Ee.set(Ae.$xp,new U.$Ph(Ct.$SN,void 0,!0)),Ee.set(Ce.$Bp,new U.$Ph(Ie.$X8b,void 0,!0)),Ee.set(v.$hp,new U.$Ph(v.$ip,void 0,!0)),Ee.set(h.$Lp,new U.$Ph(h.$Mp,void 0,!0)),Ee.set(o.$ao,new U.$Ph(r.$fp,void 0,!0)),Ee.set(o.$go,new U.$Ph(jt.$j0b,void 0,!1)),Ee.set(x.$Vq,new U.$Ph(H.$Xq,void 0,!1)),Ee.set(k.$tm,new U.$Ph(s.$Jr,void 0,!1)),Ee.set(oe.$rDb,new U.$Ph(oe.$sDb,void 0,!0)),Ee.set(te.$0gb,new U.$Ph(ge.$EFb,void 0,!0)),Ee.set(te.$9gb,new he.$U9b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),Ee.set(o.$fo,new U.$Ph(t.$pDb,void 0,!1)),Ee.set(G.$CFb,new U.$Ph(G.$DFb,void 0,!0)),Ee.set(V.$Zu,new U.$Ph(V.$1u)),Ee.set(te.$Tgb,new U.$Ph(Ne.$NEb,void 0,!0)),Ee.set(te.$Ugb,new U.$Ph(Ne.$PEb,void 0,!0)),Ee.set(de.$Hgb,new U.$Ph(de.$Jgb,void 0,!0)),Ee.set(te.$Vgb,new U.$Ph(ue.$w6b,void 0,!1)),Ee.set(te.$5gb,new U.$Ph(we.$l6b,void 0,!0)),Ee.set(te.$6gb,new U.$Ph(ve.$B6b,void 0,!1)),Ee.set(Me.$4Db,new U.$Ph(le.$29b,void 0,!0)),Ee.set(te.$7gb,new U.$Ph(yt.$a7b,void 0,!0)),Ee.set(be.$6k,new U.$Ph(Se.$j9b,void 0,!1));const pt=new gt.$4k;return Ee.set(gt.$3k,pt),pt.register(0,At.$l0b),Ee.set(Pe.$bv,new U.$Ph(Ue.$h9b)),Ee.set(je.$39b,new U.$Ph(ze.$59b)),Ee.set(ut.$89b,new U.$Ph(St.$f0b)),new Y.$gq(Ee)}j(Ee){const Le=this.B(new j.$Qc),Ze=new m.$kp(Ee.get(o.$co),()=>null);this.a.registerChannel("extensions",Ze);const Ve=C.ProxyChannel.fromService(Ee.get(x.$Vq),Le);this.a.registerChannel("languagePacks",Ve);const Ke=C.ProxyChannel.fromService(Ee.get(k.$tm),Le);this.a.registerChannel("diagnostics",Ke);const Ge=new m.$mp(Ee.get(o.$go));this.a.registerChannel("extensionTipsService",Ge);const xe=C.ProxyChannel.fromService(Ee.get(c.$P9b),Le);this.a.registerChannel("checksum",xe);const st=C.ProxyChannel.fromService(Ee.get(Re.$aF),Le);this.a.registerChannel("v8InspectProfiling",st);const ct=new he.$V9b(Ee.get(de.$Hgb));this.a.registerChannel("userDataSyncMachines",ct);const Je=C.ProxyChannel.fromService(Ee.get(Z.$gl),Le);this.a.registerChannel("customEndpointTelemetry",Je);const Qe=new he.$W9b(Ee.get(oe.$rDb));this.a.registerChannel("userDataSyncAccount",Qe);const lt=new he.$X9b(Ee.get(te.$Tgb));this.a.registerChannel("userDataSyncStoreManagement",lt);const rt=new Oe.$Z9b(Ee.get(te.$6gb),Ee.get(De.$Nk),Ee.get(Q.$aj));this.a.registerChannel("userDataSync",rt);const Xe=this.B(Ee.get(q.$Rh).createInstance(Dt.$i0b)),ht=new he.$S9b(Xe);this.a.registerChannel("userDataAutoSync",ht),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(Ee.get(te.$7gb),Le));const Ye=C.ProxyChannel.fromService(Ee.get(je.$39b),Le);this.a.registerChannel(je.$49b,Ye);const et=C.ProxyChannel.fromService(Ee.get(ut.$89b),Le);this.a.registerChannel("remoteTunnel",et)}m(Ee){process.on("uncaughtException",Le=>(0,L.$Z)(Le)),process.on("unhandledRejection",Le=>(0,L.$Z)(Le)),(0,L.setUnexpectedErrorHandler)(Le=>{const Ze=(0,A.$Di)(Le,!0);Ze&&Ee.error(`[uncaught exception in sharedProcess]: ${Ze}`)})}n(Ee,Le){Ee.publicLog2("profilesInfo",{count:Le.profiles.length})}handledClientConnection(Ee){if(Ee.data!==it.$v8b.response)return!1;const Le=(0,S.$Nb)(Ee.ports);return Le?(this.c.fire(Le),!0):!1}}async function $t(nt){const Ee=new Tt(nt);process.parentPort.postMessage(it.$t8b.ipcReady),await Ee.init(),process.parentPort.postMessage(it.$t8b.initDone)}e.main=$t,process.parentPort.once("message",nt=>{$t(nt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8d99999f3f8664f290bb4b98f99603b4c4e545d2/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
