/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/base/common/errors","vs/base/common/platform","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/platform/registry/common/platform","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/process","child_process","vs/base/common/iterator","vs/base/common/hash","vs/editor/common/core/position","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(me){for(var e=[],I=0,F=me.length;I<F;I++)e[I]=ke[me[I]];return e};define(ke[159],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class I{static get(){const m=new Map,L=new Map,R=new Map,w=new Map;function E(y,S){y.has(S.detail)||y.set(S.detail,-S.timestamp)}function g(y,S){const p=y.get(S.detail);p&&(p>=0||y.set(S.detail,p+S.timestamp))}let A=[];typeof me=="function"&&typeof me.getStats=="function"&&(A=me.getStats().slice(0).sort((y,S)=>y.timestamp-S.timestamp));for(const y of A)switch(y.type){case 10:E(m,y);break;case 11:case 12:g(m,y);break;case 21:E(L,y);break;case 22:g(L,y);break;case 33:E(R,y);break;case 34:g(R,y);break;case 31:E(w,y);break;case 32:g(w,y);break}let P=0;R.forEach(y=>P+=y);function f(y){const S=[];return y.forEach((p,c)=>S.push([c,p])),S}return{amdLoad:f(m),amdInvoke:f(L),nodeRequire:f(R),nodeEval:f(w),nodeRequireTotal:P}}static toMarkdownTable(m,L){let R="";const w=[];return m.forEach((E,g)=>{w[g]=E.length}),L.forEach(E=>{E.forEach((g,A)=>{typeof g>"u"&&(g=E[A]="-");const P=g.toString().length;w[A]=Math.max(P,w[A])})}),m.forEach((E,g)=>{R+=`| ${E+" ".repeat(w[g]-E.toString().length)} `}),R+=`|
`,m.forEach((E,g)=>{R+=`| ${"-".repeat(w[g])} `}),R+=`|
`,L.forEach(E=>{E.forEach((g,A)=>{typeof g<"u"&&(R+=`| ${g+" ".repeat(w[A]-g.toString().length)} `)}),R+=`|
`}),R}}e.$T=I}),define(ke[121],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function I(p,c,s){const i=F(p,c);if(i!==-1)return p[i]}e.$eb=I;function F(p,c,s=p.length-1){for(let i=s;i>=0;i--){const n=p[i];if(c(n))return i}return-1}e.$fb=F;function m(p,c){const s=L(p,c);return s===-1?void 0:p[s]}e.$gb=m;function L(p,c,s=0,i=p.length){let n=s,o=i;for(;n<o;){const a=Math.floor((n+o)/2);c(p[a])?n=a+1:o=a}return n-1}e.$hb=L;function R(p,c){const s=w(p,c);return s===p.length?void 0:p[s]}e.$ib=R;function w(p,c,s=0,i=p.length){let n=s,o=i;for(;n<o;){const a=Math.floor((n+o)/2);c(p[a])?o=a:n=a+1}return n}e.$jb=w;function E(p,c,s=0,i=p.length){const n=w(p,c,s,i);return n===p.length?-1:n}e.$kb=E;class g{static{this.assertInvariants=!1}constructor(c){this.e=c,this.c=0}findLastMonotonous(c){if(g.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!c(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=c}const s=L(this.e,c,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$lb=g;function A(p,c){if(p.length===0)return;let s=p[0];for(let i=1;i<p.length;i++){const n=p[i];c(n,s)>0&&(s=n)}return s}e.$mb=A;function P(p,c){if(p.length===0)return;let s=p[0];for(let i=1;i<p.length;i++){const n=p[i];c(n,s)>=0&&(s=n)}return s}e.$nb=P;function f(p,c){return A(p,(s,i)=>-c(s,i))}e.$ob=f;function y(p,c){if(p.length===0)return-1;let s=0;for(let i=1;i<p.length;i++){const n=p[i];c(n,p[s])>0&&(s=i)}return s}e.$pb=y;function S(p,c){for(const s of p){const i=c(s);if(i!==void 0)return i}}e.$qb=S}),define(ke[74],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function I(R,w){const E=Object.create(null);for(const g of R){const A=w(g);let P=E[A];P||(P=E[A]=[]),P.push(g)}return E}e.$J=I;function F(R,w){const E=[],g=[];for(const A of R)w.has(A)||E.push(A);for(const A of w)R.has(A)||g.push(A);return{removed:E,added:g}}e.$K=F;function m(R,w){const E=[],g=[];for(const[A,P]of R)w.has(A)||E.push(P);for(const[A,P]of w)R.has(A)||g.push(P);return{removed:E,added:g}}e.$L=m;function L(R,w){const E=new Set;for(const g of w)R.has(g)&&E.add(g);return E}e.$M=L}),define(ke[59],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function I(R){return(w,E,g)=>{let A=null,P=null;if(typeof g.value=="function"?(A="value",P=g.value):typeof g.get=="function"&&(A="get",P=g.get),!P)throw new Error("not supported");g[A]=R(P,E)}}function F(R,w,E){let g=null,A=null;if(typeof E.value=="function"?(g="value",A=E.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(g="get",A=E.get),!A)throw new Error("not supported");const P=`$memoize$${w}`;E[g]=function(...f){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,f)}),this[P]}}e.$kh=F;function m(R,w,E){return I((g,A)=>{const P=`$debounce$${A}`,f=`$debounce$result$${A}`;return function(...y){this[f]||(this[f]=E?E():void 0),clearTimeout(this[P]),w&&(this[f]=w(this[f],...y),y=[this[f]]),this[P]=setTimeout(()=>{g.apply(this,y),this[f]=E?E():void 0},R)}})}e.$lh=m;function L(R,w,E){return I((g,A)=>{const P=`$throttle$timer$${A}`,f=`$throttle$result$${A}`,y=`$throttle$lastRun$${A}`,S=`$throttle$pending$${A}`;return function(...p){if(this[f]||(this[f]=E?E():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),w&&(this[f]=w(this[f],...p)),this[S])return;const c=this[y]+R;c<=Date.now()?(this[y]=Date.now(),g.apply(this,[this[f]]),this[f]=E?E():void 0):(this[S]=!0,this[P]=setTimeout(()=>{this[S]=!1,this[y]=Date.now(),g.apply(this,[this[f]]),this[f]=E?E():void 0},c-Date.now()))}})}e.$mh=L}),define(ke[11],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class I{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$V=I,e.$W=new I;function F(a){e.$W.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=F;function m(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Y=m;function L(a){g(a)||e.$W.onUnexpectedError(a)}e.$Z=L;function R(a){g(a)||e.$W.onUnexpectedExternalError(a)}e.$1=R;function w(a){if(a instanceof Error){const{name:t,message:r}=a,d=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:d,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.$2=w;const E="Canceled";function g(a){return a instanceof A?!0:a instanceof Error&&a.name===E&&a.message===E}e.$3=g;class A extends Error{constructor(){super(E),this.name=this.message}}e.$4=A;function P(){const a=new Error(E);return a.name=a.message,a}e.$5=P;function f(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$6=f;function y(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$7=y;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=S;function p(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$9=p;class c extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$0=c;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$$=s;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const r=new n;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$ab=n;class o extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$bb=o}),define(ke[19],Se([1,0,11,121]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function m(H,Z=0){return H[H.length-(1+Z)]}e.$rb=m;function L(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.$sb=L;function R(H,Z,Y=($e,ne)=>$e===ne){if(H===Z)return!0;if(!H||!Z||H.length!==Z.length)return!1;for(let $e=0,ne=H.length;$e<ne;$e++)if(!Y(H[$e],Z[$e]))return!1;return!0}e.$tb=R;function w(H,Z){const Y=H.length-1;Z<Y&&(H[Z]=H[Y]),H.pop()}e.$ub=w;function E(H,Z,Y){return g(H.length,$e=>Y(H[$e],Z))}e.$vb=E;function g(H,Z){let Y=0,$e=H-1;for(;Y<=$e;){const ne=(Y+$e)/2|0,fe=Z(ne);if(fe<0)Y=ne+1;else if(fe>0)$e=ne-1;else return ne}return-(Y+1)}e.$wb=g;function A(H,Z,Y){if(H=H|0,H>=Z.length)throw new TypeError("invalid index");const $e=Z[Math.floor(Z.length*Math.random())],ne=[],fe=[],te=[];for(const he of Z){const we=Y(he,$e);we<0?ne.push(he):we>0?fe.push(he):te.push(he)}return H<ne.length?A(H,ne,Y):H<ne.length+te.length?te[0]:A(H-(ne.length+te.length),fe,Y)}e.$xb=A;function P(H,Z){const Y=[];let $e;for(const ne of H.slice(0).sort(Z))!$e||Z($e[0],ne)!==0?($e=[ne],Y.push($e)):$e.push(ne);return Y}e.$yb=P;function*f(H,Z){let Y,$e;for(const ne of H)$e!==void 0&&Z($e,ne)?Y.push(ne):(Y&&(yield Y),Y=[ne]),$e=ne;Y&&(yield Y)}e.$zb=f;function y(H,Z){for(let Y=0;Y<=H.length;Y++)Z(Y===0?void 0:H[Y-1],Y===H.length?void 0:H[Y])}e.$Ab=y;function S(H,Z){for(let Y=0;Y<H.length;Y++)Z(Y===0?void 0:H[Y-1],H[Y],Y+1===H.length?void 0:H[Y+1])}e.$Bb=S;function p(H,Z,Y){const $e=[];function ne(he,we,Pe){if(we===0&&Pe.length===0)return;const B=$e[$e.length-1];B&&B.start+B.deleteCount===he?(B.deleteCount+=we,B.toInsert.push(...Pe)):$e.push({start:he,deleteCount:we,toInsert:Pe})}let fe=0,te=0;for(;;){if(fe===H.length){ne(fe,0,Z.slice(te));break}if(te===Z.length){ne(fe,H.length-fe,[]);break}const he=H[fe],we=Z[te],Pe=Y(he,we);Pe===0?(fe+=1,te+=1):Pe<0?(ne(fe,1,[]),fe+=1):Pe>0&&(ne(fe,0,[we]),te+=1)}return $e}e.$Cb=p;function c(H,Z,Y){const $e=p(H,Z,Y),ne=[],fe=[];for(const te of $e)ne.push(...H.slice(te.start,te.start+te.deleteCount)),fe.push(...te.toInsert);return{removed:ne,added:fe}}e.$Db=c;function s(H,Z,Y){if(Y===0)return[];const $e=H.slice(0,Y).sort(Z);return n(H,Z,$e,Y,H.length),$e}e.top=s;function i(H,Z,Y,$e,ne){return Y===0?Promise.resolve([]):new Promise((fe,te)=>{(async()=>{const he=H.length,we=H.slice(0,Y).sort(Z);for(let Pe=Y,B=Math.min(Y+$e,he);Pe<he;Pe=B,B=Math.min(B+$e,he)){if(Pe>Y&&await new Promise(J=>setTimeout(J)),ne&&ne.isCancellationRequested)throw new I.$4;n(H,Z,we,Pe,B)}return we})().then(fe,te)})}e.$Fb=i;function n(H,Z,Y,$e,ne){for(const fe=Y.length;$e<ne;$e++){const te=H[$e];if(Z(te,Y[fe-1])<0){Y.pop();const he=(0,F.$jb)(Y,we=>Z(te,we)<0);Y.splice(he,0,te)}}}function o(H){return H.filter(Z=>!!Z)}e.$Gb=o;function a(H){let Z=0;for(let Y=0;Y<H.length;Y++)H[Y]&&(H[Z]=H[Y],Z+=1);H.length=Z}e.$Hb=a;function t(H,Z,Y){H.splice(Y,0,H.splice(Z,1)[0])}e.$Ib=t;function r(H){return!Array.isArray(H)||H.length===0}e.$Jb=r;function d(H){return Array.isArray(H)&&H.length>0}e.$Kb=d;function u(H,Z=Y=>Y){const Y=new Set;return H.filter($e=>{const ne=Z($e);return Y.has(ne)?!1:(Y.add(ne),!0)})}e.$Lb=u;function l(H){const Z=new Set;return Y=>{const $e=H(Y);return Z.has($e)?!1:(Z.add($e),!0)}}e.$Mb=l;function h(H,Z){return H.length>0?H[0]:Z}e.$Nb=h;function k(H,Z){return H.length>0?H[H.length-1]:Z}e.$Ob=k;function D(H,Z,Y=($e,ne)=>$e===ne){let $e=0;for(let ne=0,fe=Math.min(H.length,Z.length);ne<fe&&Y(H[ne],Z[ne]);ne++)$e++;return $e}e.$Pb=D;function $(H){return[].concat(...H)}e.$Qb=$;function b(H,Z){let Y=typeof Z=="number"?H:0;typeof Z=="number"?Y=H:(Y=0,Z=H);const $e=[];if(Y<=Z)for(let ne=Y;ne<Z;ne++)$e.push(ne);else for(let ne=Y;ne>Z;ne--)$e.push(ne);return $e}e.$Rb=b;function v(H,Z,Y){return H.reduce(($e,ne)=>($e[Z(ne)]=Y?Y(ne):ne,$e),Object.create(null))}e.$Sb=v;function C(H,Z){return H.push(Z),()=>N(H,Z)}e.$Tb=C;function N(H,Z){const Y=H.indexOf(Z);if(Y>-1)return H.splice(Y,1),Z}e.$Ub=N;function z(H,Z,Y){const $e=H.slice(0,Z),ne=H.slice(Z);return $e.concat(Y,ne)}e.$Vb=z;function M(H,Z){let Y;if(typeof Z=="number"){let $e=Z;Y=()=>{const ne=Math.sin($e++)*179426549;return ne-Math.floor(ne)}}else Y=Math.random;for(let $e=H.length-1;$e>0;$e-=1){const ne=Math.floor(Y()*($e+1)),fe=H[$e];H[$e]=H[ne],H[ne]=fe}}e.$Wb=M;function T(H,Z){const Y=H.indexOf(Z);Y>-1&&(H.splice(Y,1),H.unshift(Z))}e.$Xb=T;function j(H,Z){const Y=H.indexOf(Z);Y>-1&&(H.splice(Y,1),H.push(Z))}e.$Yb=j;function O(H,Z){for(const Y of Z)H.push(Y)}e.$Zb=O;function q(H,Z){return Array.isArray(H)?H.map(Z):Z(H)}e.$1b=q;function V(H){return Array.isArray(H)?H:[H]}e.$2b=V;function de(H){return H[Math.floor(Math.random()*H.length)]}e.$3b=de;function ee(H,Z,Y){const $e=Q(H,Z),ne=H.length,fe=Y.length;H.length=ne+fe;for(let te=ne-1;te>=$e;te--)H[te+fe]=H[te];for(let te=0;te<fe;te++)H[te+$e]=Y[te]}e.$4b=ee;function X(H,Z,Y,$e){const ne=Q(H,Z);let fe=H.splice(ne,Y);return fe===void 0&&(fe=[]),ee(H,ne,$e),fe}e.$5b=X;function Q(H,Z){return Z<0?Math.max(Z+H.length,0):Math.min(Z,H.length)}var ae;(function(H){function Z(fe){return fe<0}H.isLessThan=Z;function Y(fe){return fe<=0}H.isLessThanOrEqual=Y;function $e(fe){return fe>0}H.isGreaterThan=$e;function ne(fe){return fe===0}H.isNeitherLessOrGreaterThan=ne,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(ae||(e.CompareResult=ae={}));function x(H,Z){return(Y,$e)=>Z(H(Y),H($e))}e.$6b=x;function se(...H){return(Z,Y)=>{for(const $e of H){const ne=$e(Z,Y);if(!ae.isNeitherLessOrGreaterThan(ne))return ne}return ae.neitherLessOrGreaterThan}}e.$7b=se;const pe=(H,Z)=>H-Z;e.$8b=pe;const G=(H,Z)=>(0,e.$8b)(H?1:0,Z?1:0);e.$9b=G;function U(H){return(Z,Y)=>-H(Z,Y)}e.$0b=U;class ce{constructor(Z){this.g=Z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let Y=this.c;for(;Y<this.g.length&&Z(this.g[Y]);)Y++;const $e=Y===this.c?null:this.g.slice(this.c,Y);return this.c=Y,$e}takeFromEndWhile(Z){let Y=this.d;for(;Y>=0&&Z(this.g[Y]);)Y--;const $e=Y===this.d?null:this.g.slice(Y+1,this.d+1);return this.d=Y,$e}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Z=this.g[this.c];return this.c++,Z}removeLast(){const Z=this.g[this.d];return this.d--,Z}takeCount(Z){const Y=this.g.slice(this.c,this.c+Z);return this.c+=Z,Y}}e.$$b=ce;class be{static{this.empty=new be(Z=>{})}constructor(Z){this.iterate=Z}forEach(Z){this.iterate(Y=>(Z(Y),!0))}toArray(){const Z=[];return this.iterate(Y=>(Z.push(Y),!0)),Z}filter(Z){return new be(Y=>this.iterate($e=>Z($e)?Y($e):!0))}map(Z){return new be(Y=>this.iterate($e=>Y(Z($e))))}some(Z){let Y=!1;return this.iterate($e=>(Y=Z($e),!Y)),Y}findFirst(Z){let Y;return this.iterate($e=>Z($e)?(Y=$e,!1):!0),Y}findLast(Z){let Y;return this.iterate($e=>(Z($e)&&(Y=$e),!0)),Y}findLastMaxBy(Z){let Y,$e=!0;return this.iterate(ne=>(($e||ae.isGreaterThan(Z(ne,Y)))&&($e=!1,Y=ne),!0)),Y}}e.$_b=be}),define(ke[60],Se([1,0,11]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function F(E,g){if(!E)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=F;function m(E,g="Unreachable"){throw new Error(g)}e.$3c=m;function L(E){if(!E)throw new I.$bb("Assertion Failed")}e.$4c=L;function R(E){if(!E()){debugger;E(),(0,I.$Z)(new I.$bb("Assertion Failed"))}}e.$5c=R;function w(E,g){let A=0;for(;A<E.length-1;){const P=E[A],f=E[A+1];if(!g(P,f))return!1;A++}return!0}e.$6c=w}),define(ke[75],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function I(F){const m=this;let L=!1,R;return function(){return L||(L=!0,R=F.apply(m,arguments)),R}}e.$cb=I}),define(ke[122],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CM=e.$BM=void 0;class I{constructor(m){this.a=m,this.b=0}nextId(){return this.a+ ++this.b}}e.$BM=I,e.$CM=new I("id#")}),define(ke[51],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(F){function m(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}F.is=m;const L=Object.freeze([]);function R(){return L}F.empty=R;function*w(a){yield a}F.single=w;function E(a){return m(a)?a:w(a)}F.wrap=E;function g(a){return a||L}F.from=g;function*A(a){for(let t=a.length-1;t>=0;t--)yield a[t]}F.reverse=A;function P(a){return!a||a[Symbol.iterator]().next().done===!0}F.isEmpty=P;function f(a){return a[Symbol.iterator]().next().value}F.first=f;function y(a,t){for(const r of a)if(t(r))return!0;return!1}F.some=y;function S(a,t){for(const r of a)if(t(r))return r}F.find=S;function*p(a,t){for(const r of a)t(r)&&(yield r)}F.filter=p;function*c(a,t){let r=0;for(const d of a)yield t(d,r++)}F.map=c;function*s(...a){for(const t of a)for(const r of t)yield r}F.concat=s;function i(a,t,r){let d=r;for(const u of a)d=t(d,u);return d}F.reduce=i;function*n(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}F.slice=n;function o(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const d=a[Symbol.iterator]();for(let u=0;u<t;u++){const l=d.next();if(l.done)return[r,F.empty()];r.push(l.value)}return[r,{[Symbol.iterator](){return d}}]}F.consume=o})(I||(e.Iterable=I={}))}),define(ke[160],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var m;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(m||(e.ParseErrorCode=m={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(t,r=!1){let d=0;const u=t.length;let l="",h=0,k=16,D=0;function $(T){let j=0,O=0;for(;j<T;){const q=t.charCodeAt(d);if(q>=48&&q<=57)O=O*16+q-48;else if(q>=65&&q<=70)O=O*16+q-65+10;else if(q>=97&&q<=102)O=O*16+q-97+10;else break;d++,j++}return j<T&&(O=-1),O}function b(T){d=T,l="",h=0,k=16,D=0}function v(){const T=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&g(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&g(t.charCodeAt(d)))for(d++;d<t.length&&g(t.charCodeAt(d));)d++;else return D=3,t.substring(T,d);let j=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&g(t.charCodeAt(d))){for(d++;d<t.length&&g(t.charCodeAt(d));)d++;j=d}else D=3;return t.substring(T,j)}function C(){let T="",j=d;for(;;){if(d>=u){T+=t.substring(j,d),D=2;break}const O=t.charCodeAt(d);if(O===34){T+=t.substring(j,d),d++;break}if(O===92){if(T+=t.substring(j,d),d++,d>=u){D=2;break}switch(t.charCodeAt(d++)){case 34:T+='"';break;case 92:T+="\\";break;case 47:T+="/";break;case 98:T+="\b";break;case 102:T+="\f";break;case 110:T+=`
`;break;case 114:T+="\r";break;case 116:T+="	";break;case 117:{const V=$(4);V>=0?T+=String.fromCharCode(V):D=4;break}default:D=5}j=d;continue}if(O>=0&&O<=31)if(E(O)){T+=t.substring(j,d),D=2;break}else D=6;d++}return T}function N(){if(l="",D=0,h=d,d>=u)return h=u,k=17;let T=t.charCodeAt(d);if(w(T)){do d++,l+=String.fromCharCode(T),T=t.charCodeAt(d);while(w(T));return k=15}if(E(T))return d++,l+=String.fromCharCode(T),T===13&&t.charCodeAt(d)===10&&(d++,l+=`
`),k=14;switch(T){case 123:return d++,k=1;case 125:return d++,k=2;case 91:return d++,k=3;case 93:return d++,k=4;case 58:return d++,k=6;case 44:return d++,k=5;case 34:return d++,l=C(),k=10;case 47:{const j=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<u&&!E(t.charCodeAt(d));)d++;return l=t.substring(j,d),k=12}if(t.charCodeAt(d+1)===42){d+=2;const O=u-1;let q=!1;for(;d<O;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,q=!0;break}d++}return q||(d++,D=1),l=t.substring(j,d),k=13}return l+=String.fromCharCode(T),d++,k=16}case 45:if(l+=String.fromCharCode(T),d++,d===u||!g(t.charCodeAt(d)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=v(),k=11;default:for(;d<u&&z(T);)d++,T=t.charCodeAt(d);if(h!==d){switch(l=t.substring(h,d),l){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return l+=String.fromCharCode(T),d++,k=16}}function z(T){if(w(T)||E(T))return!1;switch(T){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let T;do T=N();while(T>=12&&T<=15);return T}return{setPosition:b,getPosition:()=>d,scan:r?M:N,getToken:()=>k,getTokenValue:()=>l,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>D}}e.$Xm=R;function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function P(t,r){const d=[],u=new Object;let l;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function D($,b,v,C){h.value=$,h.offset=b,h.length=v,h.type=C,h.colonOffset=void 0,l=h}try{n(t,{onObjectBegin:($,b)=>{if(r<=$)throw u;l=void 0,k=r>$,d.push("")},onObjectProperty:($,b,v)=>{if(r<b||(D($,b,v,"property"),d[d.length-1]=$,r<=b+v))throw u},onObjectEnd:($,b)=>{if(r<=$)throw u;l=void 0,d.pop()},onArrayBegin:($,b)=>{if(r<=$)throw u;l=void 0,d.push(0)},onArrayEnd:($,b)=>{if(r<=$)throw u;l=void 0,d.pop()},onLiteralValue:($,b,v)=>{if(r<b||(D($,b,v,a($)),r<=b+v))throw u},onSeparator:($,b,v)=>{if(r<=b)throw u;if($===":"&&l&&l.type==="property")l.colonOffset=b,k=!1,l=void 0;else if($===","){const C=d[d.length-1];typeof C=="number"?d[d.length-1]=C+1:(k=!0,d[d.length-1]=""),l=void 0}}})}catch($){if($!==u)throw $}return{path:d,previousNode:l,isAtPropertyKey:k,matches:$=>{let b=0;for(let v=0;b<$.length&&v<d.length;v++)if($[b]===d[v]||$[b]==="*")b++;else if($[b]!=="**")return!1;return b===$.length}}}e.$Ym=P;function f(t,r=[],d=L.DEFAULT){let u=null,l=[];const h=[];function k($){Array.isArray(l)?l.push($):u!==null&&(l[u]=$)}return n(t,{onObjectBegin:()=>{const $={};k($),h.push(l),l=$,u=null},onObjectProperty:$=>{u=$},onObjectEnd:()=>{l=h.pop()},onArrayBegin:()=>{const $=[];k($),h.push(l),l=$,u=null},onArrayEnd:()=>{l=h.pop()},onLiteralValue:k,onError:($,b,v)=>{r.push({error:$,offset:b,length:v})}},d),l[0]}e.$Zm=f;function y(t,r=[],d=L.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l($){u.type==="property"&&(u.length=$-u.offset,u=u.parent)}function h($){return u.children.push($),$}n(t,{onObjectBegin:$=>{u=h({type:"object",offset:$,length:-1,parent:u,children:[]})},onObjectProperty:($,b,v)=>{u=h({type:"property",offset:b,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:$,offset:b,length:v,parent:u})},onObjectEnd:($,b)=>{u.length=$+b-u.offset,u=u.parent,l($+b)},onArrayBegin:($,b)=>{u=h({type:"array",offset:$,length:-1,parent:u,children:[]})},onArrayEnd:($,b)=>{u.length=$+b-u.offset,u=u.parent,l($+b)},onLiteralValue:($,b,v)=>{h({type:a($),offset:b,length:v,parent:u,value:$}),l(b+v)},onSeparator:($,b,v)=>{u.type==="property"&&($===":"?u.colonOffset=b:$===","&&l(b))},onError:($,b,v)=>{r.push({error:$,offset:b,length:v})}},d);const D=u.children[0];return D&&delete D.parent,D}e.$1m=y;function S(t,r){if(!t)return;let d=t;for(const u of r)if(typeof u=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let l=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===u){d=h.children[1],l=!0;break}if(!l)return}else{const l=u;if(d.type!=="array"||l<0||!Array.isArray(d.children)||l>=d.children.length)return;d=d.children[l]}return d}e.$2m=S;function p(t){if(!t.parent||!t.parent.children)return[];const r=p(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;r.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&r.push(d)}return r}e.$3m=p;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const r=Object.create(null);for(const d of t.children){const u=d.children[1];u&&(r[d.children[0].value]=c(u))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$4m=c;function s(t,r,d=!1){return r>=t.offset&&r<t.offset+t.length||d&&r===t.offset+t.length}e.$5m=s;function i(t,r,d=!1){if(s(t,r,d)){const u=t.children;if(Array.isArray(u))for(let l=0;l<u.length&&u[l].offset<=r;l++){const h=i(u[l],r,d);if(h)return h}return t}}e.$6m=i;function n(t,r,d=L.DEFAULT){const u=R(t,!1);function l(x){return x?()=>x(u.getTokenOffset(),u.getTokenLength()):()=>!0}function h(x){return x?se=>x(se,u.getTokenOffset(),u.getTokenLength()):()=>!0}const k=l(r.onObjectBegin),D=h(r.onObjectProperty),$=l(r.onObjectEnd),b=l(r.onArrayBegin),v=l(r.onArrayEnd),C=h(r.onLiteralValue),N=h(r.onSeparator),z=l(r.onComment),M=h(r.onError),T=d&&d.disallowComments,j=d&&d.allowTrailingComma;function O(){for(;;){const x=u.scan();switch(u.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:T||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(x){case 12:case 13:T?q(10):z();break;case 16:q(1);break;case 15:case 14:break;default:return x}}}function q(x,se=[],pe=[]){if(M(x),se.length+pe.length>0){let G=u.getToken();for(;G!==17;){if(se.indexOf(G)!==-1){O();break}else if(pe.indexOf(G)!==-1)break;G=O()}}}function V(x){const se=u.getTokenValue();return x?C(se):D(se),O(),!0}function de(){switch(u.getToken()){case 11:{let x=0;try{x=JSON.parse(u.getTokenValue()),typeof x!="number"&&(q(2),x=0)}catch{q(2)}C(x);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return O(),!0}function ee(){return u.getToken()!==10?(q(3,[],[2,5]),!1):(V(!1),u.getToken()===6?(N(":"),O(),ae()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function X(){k(),O();let x=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(x||q(4,[],[]),N(","),O(),u.getToken()===2&&j)break}else x&&q(6,[],[]);ee()||q(4,[],[2,5]),x=!0}return $(),u.getToken()!==2?q(7,[2],[]):O(),!0}function Q(){b(),O();let x=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(x||q(4,[],[]),N(","),O(),u.getToken()===4&&j)break}else x&&q(6,[],[]);ae()||q(4,[],[4,5]),x=!0}return v(),u.getToken()!==4?q(8,[4],[]):O(),!0}function ae(){switch(u.getToken()){case 3:return Q();case 1:return X();case 10:return V(!0);default:return de()}}return O(),u.getToken()===17?d.allowEmptyContent?!0:(q(4,[],[]),!1):ae()?(u.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.$7m=n;function o(t,r){const d=R(t),u=[];let l,h=0,k;do switch(k=d.getPosition(),l=d.scan(),l){case 12:case 13:case 17:h!==k&&u.push(t.substring(h,k)),r!==void 0&&u.push(d.getTokenValue().replace(/[^\r\n]/g,r)),h=d.getPosition();break}while(l!==17);return u.join("")}e.$8m=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$9m=a}),define(ke[48],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class I{constructor(m){this.d=m,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(m){this.c=m}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=I}),define(ke[76],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(L){this.element=L,this.next=I.Undefined,this.prev=I.Undefined}}class F{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let L=this.a;for(;L!==I.Undefined;){const R=L.next;L.prev=I.Undefined,L.next=I.Undefined,L=R}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,R){const w=new I(L);if(this.a===I.Undefined)this.a=w,this.b=w;else if(R){const g=this.b;this.b=w,w.prev=g,g.next=w}else{const g=this.a;this.a=w,w.next=g,g.prev=w}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e(w))}}shift(){if(this.a!==I.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==I.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==I.Undefined&&L.next!==I.Undefined){const R=L.prev;R.next=L.next,L.next.prev=R}else L.prev===I.Undefined&&L.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):L.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):L.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==I.Undefined;)yield L.element,L=L.next}}e.$1c=F}),define(ke[28],Se([1,0]),function(me,e){"use strict";var I,F,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function L(i,n,o){let a=i.get(n);return a===void 0&&(a=o,i.set(n,a)),a}e.$wc=L;function R(i){const n=[];return i.forEach((o,a)=>{n.push(`${a} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.$xc=R;function w(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.$yc=w;class E{constructor(n,o){this.uri=n,this.value=o}}function g(i){return Array.isArray(i)}class A{static{this.a=n=>n.toString()}constructor(n,o){if(this[I]="ResourceMap",n instanceof A)this.b=new Map(n.b),this.c=o??A.a;else if(g(n)){this.b=new Map,this.c=o??A.a;for(const[a,t]of n)this.set(a,t)}else this.b=new Map,this.c=n??A.a}set(n,o){return this.b.set(this.c(n),new E(n,o)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[a,t]of this.b)n(t.value,t.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$zc=A;class P{constructor(n,o){this[F]="ResourceSet",!n||typeof n=="function"?this.a=new A(n):(this.a=new A(o),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,o){this.a.forEach((a,t)=>n.call(o,t,t,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=P;var f;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(f||(e.Touch=f={}));class y{constructor(){this[m]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,o=0){const a=this.a.get(n);if(a)return o!==0&&this.j(a,o),a.value}set(n,o,a=0){let t=this.a.get(n);if(t)t.value=o,a!==0&&this.j(t,a);else{switch(t={key:n,value:o,next:void 0,previous:void 0},a){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(n,t),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this.a.get(n);if(o)return this.a.delete(n),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,o){const a=this.e;let t=this.b;for(;t;){if(o?n.bind(o)(t.value,t.key,this):n(t.value,t.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.key,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}values(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.value,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}entries(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:[a.key,a.value],done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}[(m=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this.b,a=this.size;for(;o&&a>n;)this.a.delete(o.key),o=o.next,a--;this.b=o,this.d=a,o&&(o.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const o=n.next,a=n.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}n.next=void 0,n.previous=void 0,this.e++}j(n,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this.b)return;const a=n.next,t=n.previous;n===this.c?(t.next=void 0,this.c=t):(a.previous=t,t.next=a),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(o===2){if(n===this.c)return;const a=n.next,t=n.previous;n===this.b?(a.previous=void 0,this.b=a):(a.previous=t,t.next=a),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((o,a)=>{n.push([a,o])}),n}fromJSON(n){this.clear();for(const[o,a]of n)this.set(o,a)}}e.$Bc=y;class S extends y{constructor(n,o=1){super(),this.k=n,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=S;class p{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let o=this.a.get(n)||0;return o===0?!1:(o--,o===0?this.a.delete(n):this.a.set(n,o),!0)}has(n){return this.a.has(n)}}e.$Dc=p;class c{constructor(n){if(this.a=new Map,this.b=new Map,n)for(const[o,a]of n)this.set(o,a)}clear(){this.a.clear(),this.b.clear()}set(n,o){this.a.set(n,o),this.b.set(o,n)}get(n){return this.a.get(n)}getKey(n){return this.b.get(n)}delete(n){const o=this.a.get(n);return o===void 0?!1:(this.a.delete(n),this.b.delete(o),!0)}forEach(n,o){this.a.forEach((a,t)=>{n.call(o,a,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=c;class s{constructor(){this.a=new Map}add(n,o){let a=this.a.get(n);a||(a=new Set,this.a.set(n,a)),a.add(o)}delete(n,o){const a=this.a.get(n);a&&(a.delete(o),a.size===0&&this.a.delete(n))}forEach(n,o){const a=this.a.get(n);a&&a.forEach(o)}get(n){const o=this.a.get(n);return o||new Set}}e.$Fc=s}),define(ke[3],Se([1,0,19,74,28,75,51]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const w=!1;let E=null;class g{constructor(){this.b=new Map}static{this.a=0}c(v){let C=this.b.get(v);return C||(C={parent:null,source:null,isSingleton:!1,value:v,idx:g.a++},this.b.set(v,C)),C}trackDisposable(v){const C=this.c(v);C.source||(C.source=new Error().stack)}setParent(v,C){const N=this.c(v);N.parent=C}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,C){const N=C.get(v);if(N)return N;const z=v.parent?this.f(this.c(v.parent),C):v;return C.set(v,z),z}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,v).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(v=10,C){let N;if(C)N=C;else{const O=new Map,q=[...this.b.values()].filter(de=>de.source!==null&&!this.f(de,O).isSingleton);if(q.length===0)return;const V=new Set(q.map(de=>de.value));if(N=q.filter(de=>!(de.parent&&V.has(de.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function z(O){function q(de,ee){for(;de.length>0&&ee.some(X=>typeof X=="string"?X===de[0]:de[0].match(X));)de.shift()}const V=O.source.split(`
`).map(de=>de.trim().replace("at ","")).filter(de=>de!=="");return q(V,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),V.reverse()}const M=new m.$Fc;for(const O of N){const q=z(O);for(let V=0;V<=q.length;V++)M.add(q.slice(0,V).join(`
`),O)}N.sort((0,I.$6b)(O=>O.idx,I.$8b));let T="",j=0;for(const O of N.slice(0,v)){j++;const q=z(O),V=[];for(let de=0;de<q.length;de++){let ee=q[de];ee=`(shared with ${M.get(q.slice(0,de+1).join(`
`)).size}/${N.length} leaks) at ${ee}`;const Q=M.get(q.slice(0,de).join(`
`)),ae=(0,F.$J)([...Q].map(x=>z(x)[de]),x=>x);delete ae[q[de]];for(const[x,se]of Object.entries(ae))V.unshift(`    - stacktraces of ${se.length} other leaks continue with ${x}`);V.unshift(ee)}T+=`


==================== Leaking disposable ${j}/${N.length}: ${O.value.constructor.name} ====================
${V.join(`
`)}
============================================================

`}return N.length>v&&(T+=`


... and ${N.length-v} more leaking disposables

`),{leaks:N,details:T}}}e.$Gc=g;function A(b){E=b}if(e.$Hc=A,w){const b="__is_disposable_tracked__";A(new class{trackDisposable(v){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[b]||console.log(C)},3e3)}setParent(v,C){if(v&&v!==t.None)try{v[b]=!0}catch{}}markAsDisposed(v){if(v&&v!==t.None)try{v[b]=!0}catch{}}markAsSingleton(v){}})}function P(b){return E?.trackDisposable(b),b}e.$Ic=P;function f(b){E?.markAsDisposed(b)}e.$Jc=f;function y(b,v){E?.setParent(b,v)}function S(b,v){if(E)for(const C of b)E.setParent(C,v)}function p(b){return E?.markAsSingleton(b),b}e.$Kc=p;function c(b){return typeof b.dispose=="function"&&b.dispose.length===0}e.$Lc=c;function s(b){if(R.Iterable.is(b)){const v=[];for(const C of b)if(C)try{C.dispose()}catch(N){v.push(N)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}e.$Mc=s;function i(b){for(const v of b)c(v)&&v.dispose();return[]}e.$Nc=i;function n(...b){const v=o(()=>s(b));return S(b,v),v}e.$Oc=n;function o(b){const v=P({dispose:(0,L.$cb)(()=>{f(v),b()})});return v}e.$Pc=o;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(f(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{s(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return y(v,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),y(v,null))}}e.$Qc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,P(this),y(this.q,this)}dispose(){f(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Rc=t;class r{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&y(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&y(v,null),v}}e.$Sc=r;class d{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=d;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(v){let C=v;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,f(this))},this}}e.$Uc=u;class l{constructor(){this.a=new Map}acquire(v,...C){let N=this.a.get(v);N||(N={counter:0,object:this.b(v,...C)},this.a.set(v,N));const{object:z}=N,M=(0,L.$cb)(()=>{--N.counter===0&&(this.c(v,N.object),this.a.delete(v))});return N.counter++,{object:z,dispose:M}}}e.$Vc=l;class h{constructor(v){this.a=v}async acquire(v,...C){const N=this.a.acquire(v,...C);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(z){throw N.dispose(),z}}}e.$Wc=h;class k{constructor(v){this.object=v}dispose(){}}e.$Xc=k;function D(b){const v=new a;try{b(v)}finally{v.dispose()}}e.$Yc=D;class ${constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{s(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,C,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(v)?.dispose(),this.a.set(v,C)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}keys(){return this.a.keys()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=$}),function(me,e){typeof define=="function"&&define.amd?define(ke[161],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(Z,Y){for(var $e=0;$e<Y.length;$e++){var ne=Y[$e];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Z,ne.key,ne)}}function I(Z,Y,$e){return Y&&e(Z.prototype,Y),$e&&e(Z,$e),Object.defineProperty(Z,"prototype",{writable:!1}),Z}function F(Z,Y){if(Z){if(typeof Z=="string")return m(Z,Y);var $e=Object.prototype.toString.call(Z).slice(8,-1);if($e==="Object"&&Z.constructor&&($e=Z.constructor.name),$e==="Map"||$e==="Set")return Array.from(Z);if($e==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test($e))return m(Z,Y)}}function m(Z,Y){(Y==null||Y>Z.length)&&(Y=Z.length);for(var $e=0,ne=new Array(Y);$e<Y;$e++)ne[$e]=Z[$e];return ne}function L(Z,Y){var $e=typeof Symbol<"u"&&Z[Symbol.iterator]||Z["@@iterator"];if($e)return($e=$e.call(Z)).next.bind($e);if(Array.isArray(Z)||($e=F(Z))||Y&&Z&&typeof Z.length=="number"){$e&&(Z=$e);var ne=0;return function(){return ne>=Z.length?{done:!0}:{done:!1,value:Z[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=R();function w(Z){me.defaults=Z}var E=/[&<>"']/,g=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(Y){return f[Y]};function S(Z,Y){if(Y){if(E.test(Z))return Z.replace(g,y)}else if(A.test(Z))return Z.replace(P,y);return Z}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(Z){return Z.replace(p,function(Y,$e){return $e=$e.toLowerCase(),$e==="colon"?":":$e.charAt(0)==="#"?$e.charAt(1)==="x"?String.fromCharCode(parseInt($e.substring(2),16)):String.fromCharCode(+$e.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(Z,Y){Z=typeof Z=="string"?Z:Z.source,Y=Y||"";var $e={replace:function(fe,te){return te=te.source||te,te=te.replace(s,"$1"),Z=Z.replace(fe,te),$e},getRegex:function(){return new RegExp(Z,Y)}};return $e}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(Z,Y,$e){if(Z){var ne;try{ne=decodeURIComponent(c($e)).replace(n,"").toLowerCase()}catch{return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}Y&&!o.test($e)&&($e=l(Y,$e));try{$e=encodeURI($e).replace(/%25/g,"%")}catch{return null}return $e}var t={},r=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(Z,Y){t[" "+Z]||(r.test(Z)?t[" "+Z]=Z+"/":t[" "+Z]=$(Z,"/",!0)),Z=t[" "+Z];var $e=Z.indexOf(":")===-1;return Y.substring(0,2)==="//"?$e?Y:Z.replace(d,"$1")+Y:Y.charAt(0)==="/"?$e?Y:Z.replace(u,"$1")+Y:Z+Y}var h={exec:function(){}};function k(Z){for(var Y=1,$e,ne;Y<arguments.length;Y++){$e=arguments[Y];for(ne in $e)Object.prototype.hasOwnProperty.call($e,ne)&&(Z[ne]=$e[ne])}return Z}function D(Z,Y){var $e=Z.replace(/\|/g,function(te,he,we){for(var Pe=!1,B=he;--B>=0&&we[B]==="\\";)Pe=!Pe;return Pe?"|":" |"}),ne=$e.split(/ \|/),fe=0;if(ne[0].trim()||ne.shift(),ne.length>0&&!ne[ne.length-1].trim()&&ne.pop(),ne.length>Y)ne.splice(Y);else for(;ne.length<Y;)ne.push("");for(;fe<ne.length;fe++)ne[fe]=ne[fe].trim().replace(/\\\|/g,"|");return ne}function $(Z,Y,$e){var ne=Z.length;if(ne===0)return"";for(var fe=0;fe<ne;){var te=Z.charAt(ne-fe-1);if(te===Y&&!$e)fe++;else if(te!==Y&&$e)fe++;else break}return Z.slice(0,ne-fe)}function b(Z,Y){if(Z.indexOf(Y[1])===-1)return-1;for(var $e=Z.length,ne=0,fe=0;fe<$e;fe++)if(Z[fe]==="\\")fe++;else if(Z[fe]===Y[0])ne++;else if(Z[fe]===Y[1]&&(ne--,ne<0))return fe;return-1}function v(Z){Z&&Z.sanitize&&!Z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(Z,Y){if(Y<1)return"";for(var $e="";Y>1;)Y&1&&($e+=Z),Y>>=1,Z+=Z;return $e+Z}function N(Z,Y,$e,ne){var fe=Y.href,te=Y.title?S(Y.title):null,he=Z[1].replace(/\\([\[\]])/g,"$1");if(Z[0].charAt(0)!=="!"){ne.state.inLink=!0;var we={type:"link",raw:$e,href:fe,title:te,text:he,tokens:ne.inlineTokens(he)};return ne.state.inLink=!1,we}return{type:"image",raw:$e,href:fe,title:te,text:S(he)}}function z(Z,Y){var $e=Z.match(/^(\s+)(?:```)/);if($e===null)return Y;var ne=$e[1];return Y.split(`
`).map(function(fe){var te=fe.match(/^\s+/);if(te===null)return fe;var he=te[0];return he.length>=ne.length?fe.slice(ne.length):fe}).join(`
`)}var M=function(){function Z($e){this.options=$e||me.defaults}var Y=Z.prototype;return Y.space=function(ne){var fe=this.rules.block.newline.exec(ne);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},Y.code=function(ne){var fe=this.rules.block.code.exec(ne);if(fe){var te=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?te:$(te,`
`)}}},Y.fences=function(ne){var fe=this.rules.block.fences.exec(ne);if(fe){var te=fe[0],he=z(te,fe[3]||"");return{type:"code",raw:te,lang:fe[2]?fe[2].trim():fe[2],text:he}}},Y.heading=function(ne){var fe=this.rules.block.heading.exec(ne);if(fe){var te=fe[2].trim();if(/#$/.test(te)){var he=$(te,"#");(this.options.pedantic||!he||/ $/.test(he))&&(te=he.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:te,tokens:this.lexer.inline(te)}}},Y.hr=function(ne){var fe=this.rules.block.hr.exec(ne);if(fe)return{type:"hr",raw:fe[0]}},Y.blockquote=function(ne){var fe=this.rules.block.blockquote.exec(ne);if(fe){var te=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},Y.list=function(ne){var fe=this.rules.block.list.exec(ne);if(fe){var te,he,we,Pe,B,J,re,oe,_,ge,Ee,ze,We=fe[1].trim(),_e=We.length>1,Xe={type:"list",raw:"",ordered:_e,start:_e?+We.slice(0,-1):"",loose:!1,items:[]};We=_e?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=_e?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");ne&&(ze=!1,!(!(fe=it.exec(ne))||this.rules.block.hr.test(ne)));){if(te=fe[0],ne=ne.substring(te.length),oe=fe[2].split(`
`,1)[0],_=ne.split(`
`,1)[0],this.options.pedantic?(Pe=2,Ee=oe.trimLeft()):(Pe=fe[2].search(/[^ ]/),Pe=Pe>4?1:Pe,Ee=oe.slice(Pe),Pe+=fe[1].length),J=!1,!oe&&/^ *$/.test(_)&&(te+=_+`
`,ne=ne.substring(_.length+1),ze=!0),!ze)for(var tt=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Te=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");ne&&(ge=ne.split(`
`,1)[0],oe=ge,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Te.test(oe)||qe.test(oe)||tt.test(oe)||Ae.test(ne)));){if(oe.search(/[^ ]/)>=Pe||!oe.trim())Ee+=`
`+oe.slice(Pe);else if(!J)Ee+=`
`+oe;else break;!J&&!oe.trim()&&(J=!0),te+=ge+`
`,ne=ne.substring(ge.length+1)}Xe.loose||(re?Xe.loose=!0:/\n *\n *$/.test(te)&&(re=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(Ee),he&&(we=he[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:te,task:!!he,checked:we,loose:!1,text:Ee}),Xe.raw+=te}Xe.items[Xe.items.length-1].raw=te.trimRight(),Xe.items[Xe.items.length-1].text=Ee.trimRight(),Xe.raw=Xe.raw.trimRight();var Re=Xe.items.length;for(B=0;B<Re;B++){this.lexer.state.top=!1,Xe.items[B].tokens=this.lexer.blockTokens(Xe.items[B].text,[]);var Ye=Xe.items[B].tokens.filter(function(ue){return ue.type==="space"}),le=Ye.every(function(ue){for(var Ie=ue.raw.split(""),Ke=0,Ue=L(Ie),Ze;!(Ze=Ue()).done;){var nt=Ze.value;if(nt===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Xe.loose&&Ye.length&&le&&(Xe.loose=!0,Xe.items[B].loose=!0)}return Xe}},Y.html=function(ne){var fe=this.rules.block.html.exec(ne);if(fe){var te={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var he=this.options.sanitizer?this.options.sanitizer(fe[0]):S(fe[0]);te.type="paragraph",te.text=he,te.tokens=this.lexer.inline(he)}return te}},Y.def=function(ne){var fe=this.rules.block.def.exec(ne);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var te=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:fe[0],href:fe[2],title:fe[3]}}},Y.table=function(ne){var fe=this.rules.block.table.exec(ne);if(fe){var te={type:"table",header:D(fe[1]).map(function(re){return{text:re}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=fe[0];var he=te.align.length,we,Pe,B,J;for(we=0;we<he;we++)/^ *-+: *$/.test(te.align[we])?te.align[we]="right":/^ *:-+: *$/.test(te.align[we])?te.align[we]="center":/^ *:-+ *$/.test(te.align[we])?te.align[we]="left":te.align[we]=null;for(he=te.rows.length,we=0;we<he;we++)te.rows[we]=D(te.rows[we],te.header.length).map(function(re){return{text:re}});for(he=te.header.length,Pe=0;Pe<he;Pe++)te.header[Pe].tokens=this.lexer.inline(te.header[Pe].text);for(he=te.rows.length,Pe=0;Pe<he;Pe++)for(J=te.rows[Pe],B=0;B<J.length;B++)J[B].tokens=this.lexer.inline(J[B].text);return te}}},Y.lheading=function(ne){var fe=this.rules.block.lheading.exec(ne);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},Y.paragraph=function(ne){var fe=this.rules.block.paragraph.exec(ne);if(fe){var te=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:te,tokens:this.lexer.inline(te)}}},Y.text=function(ne){var fe=this.rules.block.text.exec(ne);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},Y.escape=function(ne){var fe=this.rules.inline.escape.exec(ne);if(fe)return{type:"escape",raw:fe[0],text:S(fe[1])}},Y.tag=function(ne){var fe=this.rules.inline.tag.exec(ne);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):S(fe[0]):fe[0]}},Y.link=function(ne){var fe=this.rules.inline.link.exec(ne);if(fe){var te=fe[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var he=$(te.slice(0,-1),"\\");if((te.length-he.length)%2===0)return}else{var we=b(fe[2],"()");if(we>-1){var Pe=fe[0].indexOf("!")===0?5:4,B=Pe+fe[1].length+we;fe[2]=fe[2].substring(0,we),fe[0]=fe[0].substring(0,B).trim(),fe[3]=""}}var J=fe[2],re="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(J);oe&&(J=oe[1],re=oe[3])}else re=fe[3]?fe[3].slice(1,-1):"";return J=J.trim(),/^</.test(J)&&(this.options.pedantic&&!/>$/.test(te)?J=J.slice(1):J=J.slice(1,-1)),N(fe,{href:J&&J.replace(this.rules.inline._escapes,"$1"),title:re&&re.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},Y.reflink=function(ne,fe){var te;if((te=this.rules.inline.reflink.exec(ne))||(te=this.rules.inline.nolink.exec(ne))){var he=(te[2]||te[1]).replace(/\s+/g," ");if(he=fe[he.toLowerCase()],!he||!he.href){var we=te[0].charAt(0);return{type:"text",raw:we,text:we}}return N(te,he,te[0],this.lexer)}},Y.emStrong=function(ne,fe,te){te===void 0&&(te="");var he=this.rules.inline.emStrong.lDelim.exec(ne);if(he&&!(he[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var we=he[1]||he[2]||"";if(!we||we&&(te===""||this.rules.inline.punctuation.exec(te))){var Pe=he[0].length-1,B,J,re=Pe,oe=0,_=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(_.lastIndex=0,fe=fe.slice(-1*ne.length+Pe);(he=_.exec(fe))!=null;)if(B=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!B){if(J=B.length,he[3]||he[4]){re+=J;continue}else if((he[5]||he[6])&&Pe%3&&!((Pe+J)%3)){oe+=J;continue}if(re-=J,!(re>0)){if(J=Math.min(J,J+re+oe),Math.min(Pe,J)%2){var ge=ne.slice(1,Pe+he.index+J);return{type:"em",raw:ne.slice(0,Pe+he.index+J+1),text:ge,tokens:this.lexer.inlineTokens(ge)}}var Ee=ne.slice(2,Pe+he.index+J-1);return{type:"strong",raw:ne.slice(0,Pe+he.index+J+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},Y.codespan=function(ne){var fe=this.rules.inline.code.exec(ne);if(fe){var te=fe[2].replace(/\n/g," "),he=/[^ ]/.test(te),we=/^ /.test(te)&&/ $/.test(te);return he&&we&&(te=te.substring(1,te.length-1)),te=S(te,!0),{type:"codespan",raw:fe[0],text:te}}},Y.br=function(ne){var fe=this.rules.inline.br.exec(ne);if(fe)return{type:"br",raw:fe[0]}},Y.del=function(ne){var fe=this.rules.inline.del.exec(ne);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},Y.autolink=function(ne,fe){var te=this.rules.inline.autolink.exec(ne);if(te){var he,we;return te[2]==="@"?(he=S(this.options.mangle?fe(te[1]):te[1]),we="mailto:"+he):(he=S(te[1]),we=he),{type:"link",raw:te[0],text:he,href:we,tokens:[{type:"text",raw:he,text:he}]}}},Y.url=function(ne,fe){var te;if(te=this.rules.inline.url.exec(ne)){var he,we;if(te[2]==="@")he=S(this.options.mangle?fe(te[0]):te[0]),we="mailto:"+he;else{var Pe;do Pe=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(Pe!==te[0]);he=S(te[0]),te[1]==="www."?we="http://"+he:we=he}return{type:"link",raw:te[0],text:he,href:we,tokens:[{type:"text",raw:he,text:he}]}}},Y.inlineText=function(ne,fe){var te=this.rules.inline.text.exec(ne);if(te){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):S(te[0]):te[0]:he=S(this.options.smartypants?fe(te[0]):te[0]),{type:"text",raw:te[0],text:he}}},Z}(),T={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};T._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,T._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,T.def=i(T.def).replace("label",T._label).replace("title",T._title).getRegex(),T.bullet=/(?:[*+-]|\d{1,9}[.)])/,T.listItemStart=i(/^( *)(bull) */).replace("bull",T.bullet).getRegex(),T.list=i(T.list).replace(/bull/g,T.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+T.def.source+")").getRegex(),T._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",T._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,T.html=i(T.html,"i").replace("comment",T._comment).replace("tag",T._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),T.paragraph=i(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.blockquote=i(T.blockquote).replace("paragraph",T.paragraph).getRegex(),T.normal=k({},T),T.gfm=k({},T.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),T.gfm.table=i(T.gfm.table).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.gfm.paragraph=i(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",T.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.pedantic=k({},T.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",T._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:i(T.normal._paragraph).replace("hr",T.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",T.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=i(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=i(T._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=i(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=i(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=i(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=i(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=i(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=i(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=i(j.reflink).replace("label",j._label).replace("ref",T._label).getRegex(),j.nolink=i(j.nolink).replace("ref",T._label).getRegex(),j.reflinkSearch=i(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=k({},j),j.pedantic=k({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=k({},j.normal,{escape:i(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=i(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=k({},j.gfm,{br:i(j.br).replace("{2,}","*").getRegex(),text:i(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(Z){return Z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(Z){var Y="",$e,ne,fe=Z.length;for($e=0;$e<fe;$e++)ne=Z.charCodeAt($e),Math.random()>.5&&(ne="x"+ne.toString(16)),Y+="&#"+ne+";";return Y}var V=function(){function Z($e){this.tokens=[],this.tokens.links=Object.create(null),this.options=$e||me.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:T.normal,inline:j.normal};this.options.pedantic?(ne.block=T.pedantic,ne.inline=j.pedantic):this.options.gfm&&(ne.block=T.gfm,this.options.breaks?ne.inline=j.breaks:ne.inline=j.gfm),this.tokenizer.rules=ne}Z.lex=function(ne,fe){var te=new Z(fe);return te.lex(ne)},Z.lexInline=function(ne,fe){var te=new Z(fe);return te.inlineTokens(ne)};var Y=Z.prototype;return Y.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`),this.blockTokens(ne,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},Y.blockTokens=function(ne,fe){var te=this;fe===void 0&&(fe=[]),this.options.pedantic?ne=ne.replace(/\t/g,"    ").replace(/^ +$/gm,""):ne=ne.replace(/^( *)(\t+)/gm,function(re,oe,_){return oe+"    ".repeat(_.length)});for(var he,we,Pe,B;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(re){return(he=re.call({lexer:te},ne,fe))?(ne=ne.substring(he.raw.length),fe.push(he),!0):!1}))){if(he=this.tokenizer.space(ne)){ne=ne.substring(he.raw.length),he.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(he);continue}if(he=this.tokenizer.code(ne)){ne=ne.substring(he.raw.length),we=fe[fe.length-1],we&&(we.type==="paragraph"||we.type==="text")?(we.raw+=`
`+he.raw,we.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=we.text):fe.push(he);continue}if(he=this.tokenizer.fences(ne)){ne=ne.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.heading(ne)){ne=ne.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.hr(ne)){ne=ne.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.blockquote(ne)){ne=ne.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.list(ne)){ne=ne.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.html(ne)){ne=ne.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.def(ne)){ne=ne.substring(he.raw.length),we=fe[fe.length-1],we&&(we.type==="paragraph"||we.type==="text")?(we.raw+=`
`+he.raw,we.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=we.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(ne)){ne=ne.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.lheading(ne)){ne=ne.substring(he.raw.length),fe.push(he);continue}if(Pe=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var re=1/0,oe=ne.slice(1),_=void 0;te.options.extensions.startBlock.forEach(function(ge){_=ge.call({lexer:this},oe),typeof _=="number"&&_>=0&&(re=Math.min(re,_))}),re<1/0&&re>=0&&(Pe=ne.substring(0,re+1))}(),this.state.top&&(he=this.tokenizer.paragraph(Pe))){we=fe[fe.length-1],B&&we.type==="paragraph"?(we.raw+=`
`+he.raw,we.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=we.text):fe.push(he),B=Pe.length!==ne.length,ne=ne.substring(he.raw.length);continue}if(he=this.tokenizer.text(ne)){ne=ne.substring(he.raw.length),we=fe[fe.length-1],we&&we.type==="text"?(we.raw+=`
`+he.raw,we.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=we.text):fe.push(he);continue}if(ne){var J="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return this.state.top=!0,fe},Y.inline=function(ne,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:ne,tokens:fe}),fe},Y.inlineTokens=function(ne,fe){var te=this;fe===void 0&&(fe=[]);var he,we,Pe,B=ne,J,re,oe;if(this.tokens.links){var _=Object.keys(this.tokens.links);if(_.length>0)for(;(J=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)_.includes(J[0].slice(J[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,J.index)+"["+C("a",J[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(J=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,J.index)+"["+C("a",J[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(J=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,J.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(re||(oe=""),re=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(he=Ee.call({lexer:te},ne,fe))?(ne=ne.substring(he.raw.length),fe.push(he),!0):!1}))){if(he=this.tokenizer.escape(ne)){ne=ne.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.tag(ne)){ne=ne.substring(he.raw.length),we=fe[fe.length-1],we&&he.type==="text"&&we.type==="text"?(we.raw+=he.raw,we.text+=he.text):fe.push(he);continue}if(he=this.tokenizer.link(ne)){ne=ne.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(he.raw.length),we=fe[fe.length-1],we&&he.type==="text"&&we.type==="text"?(we.raw+=he.raw,we.text+=he.text):fe.push(he);continue}if(he=this.tokenizer.emStrong(ne,B,oe)){ne=ne.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.codespan(ne)){ne=ne.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.br(ne)){ne=ne.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.del(ne)){ne=ne.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.autolink(ne,q)){ne=ne.substring(he.raw.length),fe.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(ne,q))){ne=ne.substring(he.raw.length),fe.push(he);continue}if(Pe=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,ze=ne.slice(1),We=void 0;te.options.extensions.startInline.forEach(function(_e){We=_e.call({lexer:this},ze),typeof We=="number"&&We>=0&&(Ee=Math.min(Ee,We))}),Ee<1/0&&Ee>=0&&(Pe=ne.substring(0,Ee+1))}(),he=this.tokenizer.inlineText(Pe,O)){ne=ne.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(oe=he.raw.slice(-1)),re=!0,we=fe[fe.length-1],we&&we.type==="text"?(we.raw+=he.raw,we.text+=he.text):fe.push(he);continue}if(ne){var ge="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return fe},I(Z,null,[{key:"rules",get:function(){return{block:T,inline:j}}}]),Z}(),de=function(){function Z($e){this.options=$e||me.defaults}var Y=Z.prototype;return Y.code=function(ne,fe,te){var he=(fe||"").match(/\S*/)[0];if(this.options.highlight){var we=this.options.highlight(ne,he);we!=null&&we!==ne&&(te=!0,ne=we)}return ne=ne.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+S(he,!0)+'">'+(te?ne:S(ne,!0))+`</code></pre>
`:"<pre><code>"+(te?ne:S(ne,!0))+`</code></pre>
`},Y.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},Y.html=function(ne){return ne},Y.heading=function(ne,fe,te,he){if(this.options.headerIds){var we=this.options.headerPrefix+he.slug(te);return"<h"+fe+' id="'+we+'">'+ne+"</h"+fe+`>
`}return"<h"+fe+">"+ne+"</h"+fe+`>
`},Y.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Y.list=function(ne,fe,te){var he=fe?"ol":"ul",we=fe&&te!==1?' start="'+te+'"':"";return"<"+he+we+`>
`+ne+"</"+he+`>
`},Y.listitem=function(ne){return"<li>"+ne+`</li>
`},Y.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Y.paragraph=function(ne){return"<p>"+ne+`</p>
`},Y.table=function(ne,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+fe+`</table>
`},Y.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},Y.tablecell=function(ne,fe){var te=fe.header?"th":"td",he=fe.align?"<"+te+' align="'+fe.align+'">':"<"+te+">";return he+ne+("</"+te+`>
`)},Y.strong=function(ne){return"<strong>"+ne+"</strong>"},Y.em=function(ne){return"<em>"+ne+"</em>"},Y.codespan=function(ne){return"<code>"+ne+"</code>"},Y.br=function(){return this.options.xhtml?"<br/>":"<br>"},Y.del=function(ne){return"<del>"+ne+"</del>"},Y.link=function(ne,fe,te){if(ne=a(this.options.sanitize,this.options.baseUrl,ne),ne===null)return te;var he='<a href="'+S(ne)+'"';return fe&&(he+=' title="'+fe+'"'),he+=">"+te+"</a>",he},Y.image=function(ne,fe,te){if(ne=a(this.options.sanitize,this.options.baseUrl,ne),ne===null)return te;var he='<img src="'+ne+'" alt="'+te+'"';return fe&&(he+=' title="'+fe+'"'),he+=this.options.xhtml?"/>":">",he},Y.text=function(ne){return ne},Z}(),ee=function(){function Z(){}var Y=Z.prototype;return Y.strong=function(ne){return ne},Y.em=function(ne){return ne},Y.codespan=function(ne){return ne},Y.del=function(ne){return ne},Y.html=function(ne){return ne},Y.text=function(ne){return ne},Y.link=function(ne,fe,te){return""+te},Y.image=function(ne,fe,te){return""+te},Y.br=function(){return""},Z}(),X=function(){function Z(){this.seen={}}var Y=Z.prototype;return Y.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Y.getNextSafeSlug=function(ne,fe){var te=ne,he=0;if(this.seen.hasOwnProperty(te)){he=this.seen[ne];do he++,te=ne+"-"+he;while(this.seen.hasOwnProperty(te))}return fe||(this.seen[ne]=he,this.seen[te]=0),te},Y.slug=function(ne,fe){fe===void 0&&(fe={});var te=this.serialize(ne);return this.getNextSafeSlug(te,fe.dryrun)},Z}(),Q=function(){function Z($e){this.options=$e||me.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ee,this.slugger=new X}Z.parse=function(ne,fe){var te=new Z(fe);return te.parse(ne)},Z.parseInline=function(ne,fe){var te=new Z(fe);return te.parseInline(ne)};var Y=Z.prototype;return Y.parse=function(ne,fe){fe===void 0&&(fe=!0);var te="",he,we,Pe,B,J,re,oe,_,ge,Ee,ze,We,_e,Xe,it,tt,Ae,Te,qe,Re=ne.length;for(he=0;he<Re;he++){if(Ee=ne[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(qe=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){te+=qe||"";continue}switch(Ee.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,c(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(_="",oe="",B=Ee.header.length,we=0;we<B;we++)oe+=this.renderer.tablecell(this.parseInline(Ee.header[we].tokens),{header:!0,align:Ee.align[we]});for(_+=this.renderer.tablerow(oe),ge="",B=Ee.rows.length,we=0;we<B;we++){for(re=Ee.rows[we],oe="",J=re.length,Pe=0;Pe<J;Pe++)oe+=this.renderer.tablecell(this.parseInline(re[Pe].tokens),{header:!1,align:Ee.align[Pe]});ge+=this.renderer.tablerow(oe)}te+=this.renderer.table(_,ge);continue}case"blockquote":{ge=this.parse(Ee.tokens),te+=this.renderer.blockquote(ge);continue}case"list":{for(ze=Ee.ordered,We=Ee.start,_e=Ee.loose,B=Ee.items.length,ge="",we=0;we<B;we++)it=Ee.items[we],tt=it.checked,Ae=it.task,Xe="",it.task&&(Te=this.renderer.checkbox(tt),_e?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Te+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Te+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Te}):Xe+=Te),Xe+=this.parse(it.tokens,_e),ge+=this.renderer.listitem(Xe,Ae,tt);te+=this.renderer.list(ge,ze,We);continue}case"html":{te+=this.renderer.html(Ee.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(ge=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;he+1<Re&&ne[he+1].type==="text";)Ee=ne[++he],ge+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);te+=fe?this.renderer.paragraph(ge):ge;continue}default:{var Ye='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return te},Y.parseInline=function(ne,fe){fe=fe||this.renderer;var te="",he,we,Pe,B=ne.length;for(he=0;he<B;he++){if(we=ne[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(Pe=this.options.extensions.renderers[we.type].call({parser:this},we),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(we.type))){te+=Pe||"";continue}switch(we.type){case"escape":{te+=fe.text(we.text);break}case"html":{te+=fe.html(we.text);break}case"link":{te+=fe.link(we.href,we.title,this.parseInline(we.tokens,fe));break}case"image":{te+=fe.image(we.href,we.title,we.text);break}case"strong":{te+=fe.strong(this.parseInline(we.tokens,fe));break}case"em":{te+=fe.em(this.parseInline(we.tokens,fe));break}case"codespan":{te+=fe.codespan(we.text);break}case"br":{te+=fe.br();break}case"del":{te+=fe.del(this.parseInline(we.tokens,fe));break}case"text":{te+=fe.text(we.text);break}default:{var J='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return te},Z}();function ae(Z,Y,$e){if(typeof Z>"u"||Z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Z)+", string expected");if(typeof Y=="function"&&($e=Y,Y=null),Y=k({},ae.defaults,Y||{}),v(Y),$e){var ne=Y.highlight,fe;try{fe=V.lex(Z,Y)}catch(B){return $e(B)}var te=function(J){var re;if(!J)try{Y.walkTokens&&ae.walkTokens(fe,Y.walkTokens),re=Q.parse(fe,Y)}catch(oe){J=oe}return Y.highlight=ne,J?$e(J):$e(null,re)};if(!ne||ne.length<3||(delete Y.highlight,!fe.length))return te();var he=0;ae.walkTokens(fe,function(B){B.type==="code"&&(he++,setTimeout(function(){ne(B.text,B.lang,function(J,re){if(J)return te(J);re!=null&&re!==B.text&&(B.text=re,B.escaped=!0),he--,he===0&&te()})},0))}),he===0&&te();return}function we(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,Y.silent)return"<p>An error occurred:</p><pre>"+S(B.message+"",!0)+"</pre>";throw B}try{var Pe=V.lex(Z,Y);if(Y.walkTokens){if(Y.async)return Promise.all(ae.walkTokens(Pe,Y.walkTokens)).then(function(){return Q.parse(Pe,Y)}).catch(we);ae.walkTokens(Pe,Y.walkTokens)}return Q.parse(Pe,Y)}catch(B){we(B)}}ae.options=ae.setOptions=function(Z){return k(ae.defaults,Z),w(ae.defaults),ae},ae.getDefaults=R,ae.defaults=me.defaults,ae.use=function(){for(var Z=arguments.length,Y=new Array(Z),$e=0;$e<Z;$e++)Y[$e]=arguments[$e];var ne=k.apply(void 0,[{}].concat(Y)),fe=ae.defaults.extensions||{renderers:{},childTokens:{}},te;Y.forEach(function(he){if(he.extensions&&(te=!0,he.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var B=fe.renderers?fe.renderers[Pe.name]:null;B?fe.renderers[Pe.name]=function(){for(var J=arguments.length,re=new Array(J),oe=0;oe<J;oe++)re[oe]=arguments[oe];var _=Pe.renderer.apply(this,re);return _===!1&&(_=B.apply(this,re)),_}:fe.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Pe.level]?fe[Pe.level].unshift(Pe.tokenizer):fe[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?fe.startBlock?fe.startBlock.push(Pe.start):fe.startBlock=[Pe.start]:Pe.level==="inline"&&(fe.startInline?fe.startInline.push(Pe.start):fe.startInline=[Pe.start]))}Pe.childTokens&&(fe.childTokens[Pe.name]=Pe.childTokens)})),he.renderer&&function(){var Pe=ae.defaults.renderer||new de,B=function(oe){var _=Pe[oe];Pe[oe]=function(){for(var ge=arguments.length,Ee=new Array(ge),ze=0;ze<ge;ze++)Ee[ze]=arguments[ze];var We=he.renderer[oe].apply(Pe,Ee);return We===!1&&(We=_.apply(Pe,Ee)),We}};for(var J in he.renderer)B(J);ne.renderer=Pe}(),he.tokenizer&&function(){var Pe=ae.defaults.tokenizer||new M,B=function(oe){var _=Pe[oe];Pe[oe]=function(){for(var ge=arguments.length,Ee=new Array(ge),ze=0;ze<ge;ze++)Ee[ze]=arguments[ze];var We=he.tokenizer[oe].apply(Pe,Ee);return We===!1&&(We=_.apply(Pe,Ee)),We}};for(var J in he.tokenizer)B(J);ne.tokenizer=Pe}(),he.walkTokens){var we=ae.defaults.walkTokens;ne.walkTokens=function(Pe){var B=[];return B.push(he.walkTokens.call(this,Pe)),we&&(B=B.concat(we.call(this,Pe))),B}}te&&(ne.extensions=fe),ae.setOptions(ne)})},ae.walkTokens=function(Z,Y){for(var $e=[],ne=function(){var we=te.value;switch($e=$e.concat(Y.call(ae,we)),we.type){case"table":{for(var Pe=L(we.header),B;!(B=Pe()).done;){var J=B.value;$e=$e.concat(ae.walkTokens(J.tokens,Y))}for(var re=L(we.rows),oe;!(oe=re()).done;)for(var _=oe.value,ge=L(_),Ee;!(Ee=ge()).done;){var ze=Ee.value;$e=$e.concat(ae.walkTokens(ze.tokens,Y))}break}case"list":{$e=$e.concat(ae.walkTokens(we.items,Y));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[we.type]?ae.defaults.extensions.childTokens[we.type].forEach(function(We){$e=$e.concat(ae.walkTokens(we[We],Y))}):we.tokens&&($e=$e.concat(ae.walkTokens(we.tokens,Y)))}},fe=L(Z),te;!(te=fe()).done;)ne();return $e},ae.parseInline=function(Z,Y){if(typeof Z>"u"||Z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Z)+", string expected");Y=k({},ae.defaults,Y||{}),v(Y);try{var $e=V.lexInline(Z,Y);return Y.walkTokens&&ae.walkTokens($e,Y.walkTokens),Q.parseInline($e,Y)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,Y.silent)return"<p>An error occurred:</p><pre>"+S(ne.message+"",!0)+"</pre>";throw ne}},ae.Parser=Q,ae.parser=Q.parse,ae.Renderer=de,ae.TextRenderer=ee,ae.Lexer=V,ae.lexer=V.lex,ae.Tokenizer=M,ae.Slugger=X,ae.parse=ae;var x=ae.options,se=ae.setOptions,pe=ae.use,G=ae.walkTokens,U=ae.parseInline,ce=ae,be=Q.parse,H=V.lex;me.Lexer=V,me.Parser=Q,me.Renderer=de,me.Slugger=X,me.TextRenderer=ee,me.Tokenizer=M,me.getDefaults=R,me.lexer=H,me.marked=ae,me.options=x,me.parse=ce,me.parseInline=U,me.parser=be,me.setOptions=se,me.use=pe,me.walkTokens=G,Object.defineProperty(me,"__esModule",{value:!0})}),define(ke[77],Se([1,0,28]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.$rl=void 0;const F=new I.$Cc(1e4);function m(g){return E(g,"NFC",F)}e.$rl=m;const L=new I.$Cc(1e4);function R(g){return E(g,"NFD",L)}e.$sl=R;const w=/[^\u0000-\u0080]/;function E(g,A,P){if(!g)return g;const f=P.get(g);if(f)return f;let y;return w.test(g)?y=g.normalize(A):y=g,P.set(g,y),y}e.$tl=function(){const g=/[\u0300-\u036f]/g;return function(A){return R(A).replace(g,"")}}()}),define(ke[123],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Tl=e.rot=e.$Rl=void 0;function I(w,E,g){return Math.min(Math.max(w,E),g)}e.$Rl=I;function F(w,E){return(E+w%E)%E}e.rot=F;class m{constructor(){this.a=0}getNext(){return this.a++}}e.$Tl=m;class L{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Ul=L;class R{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const g=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Vl=R}),function(){function me(m){const L=[];typeof m=="number"&&L.push("code/timeOrigin",m);function R(E){L.push(E,Date.now())}function w(){const E=[];for(let g=0;g<L.length;g+=2)E.push({name:L[g],startTime:L[g+1]});return E}return{mark:R,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(m){performance.mark(m)},getMarks(){let m=performance.timeOrigin;typeof m!="number"&&(m=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(m)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(m+R.startTime)});return L}};if(typeof process=="object"){const m=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(m)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function I(m){return m.MonacoPerformanceMarks||(m.MonacoPerformanceMarks=e()),m.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=I(F))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var F in I)(typeof exports=="object"?exports:me)[F]=I[F]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function I(F){if(e[F])return e[F].exports;var m=e[F]={i:F,l:!1,exports:{}};return me[F].call(m.exports,m,m.exports,I),m.l=!0,m.exports}return I.m=me,I.c=e,I.d=function(F,m,L){I.o(F,m)||Object.defineProperty(F,m,{enumerable:!0,get:L})},I.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},I.t=function(F,m){if(1&m&&(F=I(F)),8&m||4&m&&typeof F=="object"&&F&&F.__esModule)return F;var L=Object.create(null);if(I.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:F}),2&m&&typeof F!="string")for(var R in F)I.d(L,R,function(w){return F[w]}.bind(null,R));return L},I.n=function(F){var m=F&&F.__esModule?function(){return F.default}:function(){return F};return I.d(m,"a",m),m},I.o=function(F,m){return Object.prototype.hasOwnProperty.call(F,m)},I.p="",I(I.s=0)}([function(me,e,I){(function(F){var m;e=me.exports=pe,m=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],E=e.src=[],g=0,A=g++;E[A]="0|[1-9]\\d*";var P=g++;E[P]="[0-9]+";var f=g++;E[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=g++;E[y]="("+E[A]+")\\.("+E[A]+")\\.("+E[A]+")";var S=g++;E[S]="("+E[P]+")\\.("+E[P]+")\\.("+E[P]+")";var p=g++;E[p]="(?:"+E[A]+"|"+E[f]+")";var c=g++;E[c]="(?:"+E[P]+"|"+E[f]+")";var s=g++;E[s]="(?:-("+E[p]+"(?:\\."+E[p]+")*))";var i=g++;E[i]="(?:-?("+E[c]+"(?:\\."+E[c]+")*))";var n=g++;E[n]="[0-9A-Za-z-]+";var o=g++;E[o]="(?:\\+("+E[n]+"(?:\\."+E[n]+")*))";var a=g++,t="v?"+E[y]+E[s]+"?"+E[o]+"?";E[a]="^"+t+"$";var r="[v=\\s]*"+E[S]+E[i]+"?"+E[o]+"?",d=g++;E[d]="^"+r+"$";var u=g++;E[u]="((?:<|>)?=?)";var l=g++;E[l]=E[P]+"|x|X|\\*";var h=g++;E[h]=E[A]+"|x|X|\\*";var k=g++;E[k]="[v=\\s]*("+E[h]+")(?:\\.("+E[h]+")(?:\\.("+E[h]+")(?:"+E[s]+")?"+E[o]+"?)?)?";var D=g++;E[D]="[v=\\s]*("+E[l]+")(?:\\.("+E[l]+")(?:\\.("+E[l]+")(?:"+E[i]+")?"+E[o]+"?)?)?";var $=g++;E[$]="^"+E[u]+"\\s*"+E[k]+"$";var b=g++;E[b]="^"+E[u]+"\\s*"+E[D]+"$";var v=g++;E[v]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=g++;E[C]="(?:~>?)";var N=g++;E[N]="(\\s*)"+E[C]+"\\s+",w[N]=new RegExp(E[N],"g");var z=g++;E[z]="^"+E[C]+E[k]+"$";var M=g++;E[M]="^"+E[C]+E[D]+"$";var T=g++;E[T]="(?:\\^)";var j=g++;E[j]="(\\s*)"+E[T]+"\\s+",w[j]=new RegExp(E[j],"g");var O=g++;E[O]="^"+E[T]+E[k]+"$";var q=g++;E[q]="^"+E[T]+E[D]+"$";var V=g++;E[V]="^"+E[u]+"\\s*("+r+")$|^$";var de=g++;E[de]="^"+E[u]+"\\s*("+t+")$|^$";var ee=g++;E[ee]="(\\s*)"+E[u]+"\\s*("+r+"|"+E[k]+")",w[ee]=new RegExp(E[ee],"g");var X=g++;E[X]="^\\s*("+E[k]+")\\s+-\\s+("+E[k]+")\\s*$";var Q=g++;E[Q]="^\\s*("+E[D]+")\\s+-\\s+("+E[D]+")\\s*$";var ae=g++;E[ae]="(<|>)?=?\\s*\\*";for(var x=0;x<35;x++)m(x,E[x]),w[x]||(w[x]=new RegExp(E[x]));function se(_,ge){if(_ instanceof pe)return _;if(typeof _!="string"||_.length>L||!(ge?w[d]:w[a]).test(_))return null;try{return new pe(_,ge)}catch{return null}}function pe(_,ge){if(_ instanceof pe){if(_.loose===ge)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof pe))return new pe(_,ge);m("SemVer",_,ge),this.loose=ge;var Ee=_.trim().match(ge?w[d]:w[a]);if(!Ee)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var We=+ze;if(We>=0&&We<R)return We}return ze}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=se,e.valid=function(_,ge){var Ee=se(_,ge);return Ee?Ee.version:null},e.clean=function(_,ge){var Ee=se(_.trim().replace(/^[=v]+/,""),ge);return Ee?Ee.version:null},e.SemVer=pe,pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},pe.prototype.toString=function(){return this.version},pe.prototype.compare=function(_){return m("SemVer.compare",this.version,this.loose,_),_ instanceof pe||(_=new pe(_,this.loose)),this.compareMain(_)||this.comparePre(_)},pe.prototype.compareMain=function(_){return _ instanceof pe||(_=new pe(_,this.loose)),U(this.major,_.major)||U(this.minor,_.minor)||U(this.patch,_.patch)},pe.prototype.comparePre=function(_){if(_ instanceof pe||(_=new pe(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var ge=0;do{var Ee=this.prerelease[ge],ze=_.prerelease[ge];if(m("prerelease compare",ge,Ee,ze),Ee===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==ze)return U(Ee,ze)}while(++ge)},pe.prototype.inc=function(_,ge){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,ge,Ee,ze){typeof Ee=="string"&&(ze=Ee,Ee=void 0);try{return new pe(_,Ee).inc(ge,ze).version}catch{return null}},e.diff=function(_,ge){if(Z(_,ge))return null;var Ee=se(_),ze=se(ge);if(Ee.prerelease.length||ze.prerelease.length){for(var We in Ee)if((We==="major"||We==="minor"||We==="patch")&&Ee[We]!==ze[We])return"pre"+We;return"prerelease"}for(var We in Ee)if((We==="major"||We==="minor"||We==="patch")&&Ee[We]!==ze[We])return We},e.compareIdentifiers=U;var G=/^[0-9]+$/;function U(_,ge){var Ee=G.test(_),ze=G.test(ge);return Ee&&ze&&(_=+_,ge=+ge),Ee&&!ze?-1:ze&&!Ee?1:_<ge?-1:_>ge?1:0}function ce(_,ge,Ee){return new pe(_,Ee).compare(new pe(ge,Ee))}function be(_,ge,Ee){return ce(_,ge,Ee)>0}function H(_,ge,Ee){return ce(_,ge,Ee)<0}function Z(_,ge,Ee){return ce(_,ge,Ee)===0}function Y(_,ge,Ee){return ce(_,ge,Ee)!==0}function $e(_,ge,Ee){return ce(_,ge,Ee)>=0}function ne(_,ge,Ee){return ce(_,ge,Ee)<=0}function fe(_,ge,Ee,ze){var We;switch(ge){case"===":typeof _=="object"&&(_=_.version),typeof Ee=="object"&&(Ee=Ee.version),We=_===Ee;break;case"!==":typeof _=="object"&&(_=_.version),typeof Ee=="object"&&(Ee=Ee.version),We=_!==Ee;break;case"":case"=":case"==":We=Z(_,Ee,ze);break;case"!=":We=Y(_,Ee,ze);break;case">":We=be(_,Ee,ze);break;case">=":We=$e(_,Ee,ze);break;case"<":We=H(_,Ee,ze);break;case"<=":We=ne(_,Ee,ze);break;default:throw new TypeError("Invalid operator: "+ge)}return We}function te(_,ge){if(_ instanceof te){if(_.loose===ge)return _;_=_.value}if(!(this instanceof te))return new te(_,ge);m("comparator",_,ge),this.loose=ge,this.parse(_),this.semver===he?this.value="":this.value=this.operator+this.semver.version,m("comp",this)}e.rcompareIdentifiers=function(_,ge){return U(ge,_)},e.major=function(_,ge){return new pe(_,ge).major},e.minor=function(_,ge){return new pe(_,ge).minor},e.patch=function(_,ge){return new pe(_,ge).patch},e.compare=ce,e.compareLoose=function(_,ge){return ce(_,ge,!0)},e.rcompare=function(_,ge,Ee){return ce(ge,_,Ee)},e.sort=function(_,ge){return _.sort(function(Ee,ze){return e.compare(Ee,ze,ge)})},e.rsort=function(_,ge){return _.sort(function(Ee,ze){return e.rcompare(Ee,ze,ge)})},e.gt=be,e.lt=H,e.eq=Z,e.neq=Y,e.gte=$e,e.lte=ne,e.cmp=fe,e.Comparator=te;var he={};function we(_,ge){if(_ instanceof we)return _.loose===ge?_:new we(_.raw,ge);if(_ instanceof te)return new we(_.value,ge);if(!(this instanceof we))return new we(_,ge);if(this.loose=ge,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function Pe(_){return!_||_.toLowerCase()==="x"||_==="*"}function B(_,ge,Ee,ze,We,_e,Xe,it,tt,Ae,Te,qe,Re){return((ge=Pe(Ee)?"":Pe(ze)?">="+Ee+".0.0":Pe(We)?">="+Ee+"."+ze+".0":">="+ge)+" "+(it=Pe(tt)?"":Pe(Ae)?"<"+(+tt+1)+".0.0":Pe(Te)?"<"+tt+"."+(+Ae+1)+".0":qe?"<="+tt+"."+Ae+"."+Te+"-"+qe:"<="+it)).trim()}function J(_,ge){for(var Ee=0;Ee<_.length;Ee++)if(!_[Ee].test(ge))return!1;if(ge.prerelease.length){for(Ee=0;Ee<_.length;Ee++)if(m(_[Ee].semver),_[Ee].semver!==he&&_[Ee].semver.prerelease.length>0){var ze=_[Ee].semver;if(ze.major===ge.major&&ze.minor===ge.minor&&ze.patch===ge.patch)return!0}return!1}return!0}function re(_,ge,Ee){try{ge=new we(ge,Ee)}catch{return!1}return ge.test(_)}function oe(_,ge,Ee,ze){var We,_e,Xe,it,tt;switch(_=new pe(_,ze),ge=new we(ge,ze),Ee){case">":We=be,_e=ne,Xe=H,it=">",tt=">=";break;case"<":We=H,_e=$e,Xe=be,it="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(re(_,ge,ze))return!1;for(var Ae=0;Ae<ge.set.length;++Ae){var Te=ge.set[Ae],qe=null,Re=null;if(Te.forEach(function(Ye){Ye.semver===he&&(Ye=new te(">=0.0.0")),qe=qe||Ye,Re=Re||Ye,We(Ye.semver,qe.semver,ze)?qe=Ye:Xe(Ye.semver,Re.semver,ze)&&(Re=Ye)}),qe.operator===it||qe.operator===tt||(!Re.operator||Re.operator===it)&&_e(_,Re.semver)||Re.operator===tt&&Xe(_,Re.semver))return!1}return!0}te.prototype.parse=function(_){var ge=this.loose?w[V]:w[de],Ee=_.match(ge);if(!Ee)throw new TypeError("Invalid comparator: "+_);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new pe(Ee[2],this.loose):this.semver=he},te.prototype.toString=function(){return this.value},te.prototype.test=function(_){return m("Comparator.test",_,this.loose),this.semver===he||(typeof _=="string"&&(_=new pe(_,this.loose)),fe(_,this.operator,this.semver,this.loose))},te.prototype.intersects=function(_,ge){if(!(_ instanceof te))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new we(_.value,ge),re(this.value,Ee,ge);if(_.operator==="")return Ee=new we(this.value,ge),re(_.semver,Ee,ge);var ze=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),_e=this.semver.version===_.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),it=fe(this.semver,"<",_.semver,ge)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),tt=fe(this.semver,">",_.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return ze||We||_e&&Xe||it||tt},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(_){var ge=this.loose;_=_.trim(),m("range",_,ge);var Ee=ge?w[Q]:w[X];_=_.replace(Ee,B),m("hyphen replace",_),_=_.replace(w[ee],"$1$2$3"),m("comparator trim",_,w[ee]),_=(_=(_=_.replace(w[N],"$1~")).replace(w[j],"$1^")).split(/\s+/).join(" ");var ze=ge?w[V]:w[de],We=_.split(" ").map(function(_e){return function(Xe,it){return m("comp",Xe),Xe=function(tt,Ae){return tt.trim().split(/\s+/).map(function(Te){return function(qe,Re){m("caret",qe,Re);var Ye=Re?w[q]:w[O];return qe.replace(Ye,function(le,ue,Ie,Ke,Ue){var Ze;return m("caret",qe,le,ue,Ie,Ke,Ue),Pe(ue)?Ze="":Pe(Ie)?Ze=">="+ue+".0.0 <"+(+ue+1)+".0.0":Pe(Ke)?Ze=ue==="0"?">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+".0 <"+(+ue+1)+".0.0":Ue?(m("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ze=ue==="0"?Ie==="0"?">="+ue+"."+Ie+"."+Ke+Ue+" <"+ue+"."+Ie+"."+(+Ke+1):">="+ue+"."+Ie+"."+Ke+Ue+" <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+"."+Ke+Ue+" <"+(+ue+1)+".0.0"):(m("no pr"),Ze=ue==="0"?Ie==="0"?">="+ue+"."+Ie+"."+Ke+" <"+ue+"."+Ie+"."+(+Ke+1):">="+ue+"."+Ie+"."+Ke+" <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+"."+Ke+" <"+(+ue+1)+".0.0"),m("caret return",Ze),Ze})}(Te,Ae)}).join(" ")}(Xe,it),m("caret",Xe),Xe=function(tt,Ae){return tt.trim().split(/\s+/).map(function(Te){return function(qe,Re){var Ye=Re?w[M]:w[z];return qe.replace(Ye,function(le,ue,Ie,Ke,Ue){var Ze;return m("tilde",qe,le,ue,Ie,Ke,Ue),Pe(ue)?Ze="":Pe(Ie)?Ze=">="+ue+".0.0 <"+(+ue+1)+".0.0":Pe(Ke)?Ze=">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0":Ue?(m("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ze=">="+ue+"."+Ie+"."+Ke+Ue+" <"+ue+"."+(+Ie+1)+".0"):Ze=">="+ue+"."+Ie+"."+Ke+" <"+ue+"."+(+Ie+1)+".0",m("tilde return",Ze),Ze})}(Te,Ae)}).join(" ")}(Xe,it),m("tildes",Xe),Xe=function(tt,Ae){return m("replaceXRanges",tt,Ae),tt.split(/\s+/).map(function(Te){return function(qe,Re){qe=qe.trim();var Ye=Re?w[b]:w[$];return qe.replace(Ye,function(le,ue,Ie,Ke,Ue,Ze){m("xRange",qe,le,ue,Ie,Ke,Ue,Ze);var nt=Pe(Ie),ct=nt||Pe(Ke),bt=ct||Pe(Ue);return ue==="="&&bt&&(ue=""),nt?le=ue===">"||ue==="<"?"<0.0.0":"*":ue&&bt?(ct&&(Ke=0),bt&&(Ue=0),ue===">"?(ue=">=",ct?(Ie=+Ie+1,Ke=0,Ue=0):bt&&(Ke=+Ke+1,Ue=0)):ue==="<="&&(ue="<",ct?Ie=+Ie+1:Ke=+Ke+1),le=ue+Ie+"."+Ke+"."+Ue):ct?le=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":bt&&(le=">="+Ie+"."+Ke+".0 <"+Ie+"."+(+Ke+1)+".0"),m("xRange return",le),le})}(Te,Ae)}).join(" ")}(Xe,it),m("xrange",Xe),Xe=function(tt,Ae){return m("replaceStars",tt,Ae),tt.trim().replace(w[ae],"")}(Xe,it),m("stars",Xe),Xe}(_e,ge)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(_e){return!!_e.match(ze)})),We=We.map(function(_e){return new te(_e,ge)})},we.prototype.intersects=function(_,ge){if(!(_ instanceof we))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(ze){return _.set.some(function(We){return We.every(function(_e){return ze.intersects(_e,ge)})})})})},e.toComparators=function(_,ge){return new we(_,ge).set.map(function(Ee){return Ee.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},we.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new pe(_,this.loose));for(var ge=0;ge<this.set.length;ge++)if(J(this.set[ge],_))return!0;return!1},e.satisfies=re,e.maxSatisfying=function(_,ge,Ee){var ze=null,We=null;try{var _e=new we(ge,Ee)}catch{return null}return _.forEach(function(Xe){_e.test(Xe)&&(ze&&We.compare(Xe)!==-1||(We=new pe(ze=Xe,Ee)))}),ze},e.minSatisfying=function(_,ge,Ee){var ze=null,We=null;try{var _e=new we(ge,Ee)}catch{return null}return _.forEach(function(Xe){_e.test(Xe)&&(ze&&We.compare(Xe)!==1||(We=new pe(ze=Xe,Ee)))}),ze},e.validRange=function(_,ge){try{return new we(_,ge).range||"*"}catch{return null}},e.ltr=function(_,ge,Ee){return oe(_,ge,"<",Ee)},e.gtr=function(_,ge,Ee){return oe(_,ge,">",Ee)},e.outside=oe,e.prerelease=function(_,ge){var Ee=se(_,ge);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(_,ge,Ee){return _=new we(_,Ee),ge=new we(ge,Ee),_.intersects(ge)},e.coerce=function(_){if(_ instanceof pe)return _;if(typeof _!="string")return null;var ge=_.match(w[v]);return ge==null?null:se((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,I(1))},function(me,e){var I,F,m=me.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function w(c){if(I===setTimeout)return setTimeout(c,0);if((I===L||!I)&&setTimeout)return I=setTimeout,setTimeout(c,0);try{return I(c,0)}catch{try{return I.call(null,c,0)}catch{return I.call(this,c,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:L}catch{I=L}try{F=typeof clearTimeout=="function"?clearTimeout:R}catch{F=R}})();var E,g=[],A=!1,P=-1;function f(){A&&E&&(A=!1,E.length?g=E.concat(g):P=-1,g.length&&y())}function y(){if(!A){var c=w(f);A=!0;for(var s=g.length;s;){for(E=g,g=[];++P<s;)E&&E[P].run();P=-1,s=g.length}E=null,A=!1,function(i){if(F===clearTimeout)return clearTimeout(i);if((F===R||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(i);try{F(i)}catch{try{return F.call(null,i)}catch{return F.call(this,i)}}}(c)}}function S(c,s){this.fun=c,this.array=s}function p(){}m.nextTick=function(c){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];g.push(new S(c,s)),g.length!==1||A||w(y)},S.prototype.run=function(){this.fun.apply(null,this.array)},m.title="browser",m.browser=!0,m.env={},m.argv=[],m.version="",m.versions={},m.on=p,m.addListener=p,m.once=p,m.off=p,m.removeListener=p,m.removeAllListeners=p,m.emit=p,m.prependListener=p,m.prependOnceListener=p,m.listeners=function(c){return[]},m.binding=function(c){throw new Error("process.binding is not supported")},m.cwd=function(){return"/"},m.chdir=function(c){throw new Error("process.chdir is not supported")},m.umask=function(){return 0}}])}),define(ke[37],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(L){return new F(L)}constructor(L){this.c=I&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Kd=F}),define(ke[4],Se([1,0,11,75,3,76,37]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.Event=void 0;const w=!1,E=!1;var g;(function($){$.None=()=>m.$Rc.None;function b(fe){if(E){const{onDidAddListener:te}=fe,he=S.create();let we=0;fe.onDidAddListener=()=>{++we===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),he.print()),te?.()}}}function v(fe,te){return de(fe,()=>{},0,void 0,!0,void 0,te)}$.defer=v;function C(fe){return(te,he=null,we)=>{let Pe=!1,B;return B=fe(J=>{if(!Pe)return B?B.dispose():Pe=!0,te.call(he,J)},null,we),Pe&&B.dispose(),B}}$.once=C;function N(fe,te,he){return q((we,Pe=null,B)=>fe(J=>we.call(Pe,te(J)),null,B),he)}$.map=N;function z(fe,te,he){return q((we,Pe=null,B)=>fe(J=>{te(J),we.call(Pe,J)},null,B),he)}$.forEach=z;function M(fe,te,he){return q((we,Pe=null,B)=>fe(J=>te(J)&&we.call(Pe,J),null,B),he)}$.filter=M;function T(fe){return fe}$.signal=T;function j(...fe){return(te,he=null,we)=>{const Pe=(0,m.$Oc)(...fe.map(B=>B(J=>te.call(he,J))));return V(Pe,we)}}$.any=j;function O(fe,te,he,we){let Pe=he;return N(fe,B=>(Pe=te(Pe,B),Pe),we)}$.reduce=O;function q(fe,te){let he;const we={onWillAddFirstListener(){he=fe(Pe.fire,Pe)},onDidRemoveLastListener(){he?.dispose()}};te||b(we);const Pe=new n(we);return te?.add(Pe),Pe.event}function V(fe,te){return te instanceof Array?te.push(fe):te&&te.add(fe),fe}function de(fe,te,he=100,we=!1,Pe=!1,B,J){let re,oe,_,ge=0,Ee;const ze={leakWarningThreshold:B,onWillAddFirstListener(){re=fe(_e=>{ge++,oe=te(oe,_e),we&&!_&&(We.fire(oe),oe=void 0),Ee=()=>{const Xe=oe;oe=void 0,_=void 0,(!we||ge>1)&&We.fire(Xe),ge=0},typeof he=="number"?(clearTimeout(_),_=setTimeout(Ee,he)):_===void 0&&(_=0,queueMicrotask(Ee))})},onWillRemoveListener(){Pe&&ge>0&&Ee?.()},onDidRemoveLastListener(){Ee=void 0,re.dispose()}};J||b(ze);const We=new n(ze);return J?.add(We),We.event}$.debounce=de;function ee(fe,te=0,he){return $.debounce(fe,(we,Pe)=>we?(we.push(Pe),we):[Pe],te,void 0,!0,void 0,he)}$.accumulate=ee;function X(fe,te=(we,Pe)=>we===Pe,he){let we=!0,Pe;return M(fe,B=>{const J=we||!te(B,Pe);return we=!1,Pe=B,J},he)}$.latch=X;function Q(fe,te,he){return[$.filter(fe,te,he),$.filter(fe,we=>!te(we),he)]}$.split=Q;function ae(fe,te=!1,he=[],we){let Pe=he.slice(),B=fe(oe=>{Pe?Pe.push(oe):re.fire(oe)});we&&we.add(B);const J=()=>{Pe?.forEach(oe=>re.fire(oe)),Pe=null},re=new n({onWillAddFirstListener(){B||(B=fe(oe=>re.fire(oe)),we&&we.add(B))},onDidAddFirstListener(){Pe&&(te?setTimeout(J):J())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return we&&we.add(re),re.event}$.buffer=ae;function x(fe,te){return(we,Pe,B)=>{const J=te(new pe);return fe(function(re){const oe=J.evaluate(re);oe!==se&&we.call(Pe,oe)},void 0,B)}}$.chain=x;const se=Symbol("HaltChainable");class pe{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(he=>(te(he),he)),this}filter(te){return this.f.push(he=>te(he)?he:se),this}reduce(te,he){let we=he;return this.f.push(Pe=>(we=te(we,Pe),we)),this}latch(te=(he,we)=>he===we){let he=!0,we;return this.f.push(Pe=>{const B=he||!te(Pe,we);return he=!1,we=Pe,B?Pe:se}),this}evaluate(te){for(const he of this.f)if(te=he(te),te===se)break;return te}}function G(fe,te,he=we=>we){const we=(...re)=>J.fire(he(...re)),Pe=()=>fe.on(te,we),B=()=>fe.removeListener(te,we),J=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return J.event}$.fromNodeEventEmitter=G;function U(fe,te,he=we=>we){const we=(...re)=>J.fire(he(...re)),Pe=()=>fe.addEventListener(te,we),B=()=>fe.removeEventListener(te,we),J=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return J.event}$.fromDOMEventEmitter=U;function ce(fe){return new Promise(te=>C(fe)(te))}$.toPromise=ce;function be(fe){const te=new n;return fe.then(he=>{te.fire(he)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}$.fromPromise=be;function H(fe,te,he){return te(he),fe(we=>te(we))}$.runAndSubscribe=H;function Z(fe,te){let he=null;function we(B){he?.dispose(),he=new m.$Qc,te(B,he)}we(void 0);const Pe=fe(B=>we(B));return(0,m.$Pc)(()=>{Pe.dispose(),he?.dispose()})}$.runAndSubscribeWithStore=Z;class Y{constructor(te,he){this._observable=te,this.f=0,this.g=!1;const we={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};he||b(we),this.emitter=new n(we),he&&he.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,he){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(fe,te){return new Y(fe,te).emitter.event}$.fromObservable=$e;function ne(fe){return te=>{let he=0,we=!1;const Pe={beginUpdate(){he++},endUpdate(){he--,he===0&&(fe.reportChanges(),we&&(we=!1,te()))},handlePossibleChange(){},handleChange(){we=!0}};return fe.addObserver(Pe),fe.reportChanges(),{dispose(){fe.removeObserver(Pe)}}}}$.fromObservableLight=ne})(g||(e.Event=g={}));class A{static{this.all=new Set}static{this.f=0}constructor(b){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${b}_${A.f++}`,A.all.add(this)}start(b){this.g=new R.$Kd,this.listenerCount=b}stop(){if(this.g){const b=this.g.elapsed();this.durations.push(b),this.elapsedOverall+=b,this.invocationCount+=1,this.g=void 0}}}e.$Md=A;let P=-1;function f($){const b=P;return P=$,{dispose(){P=b}}}e.$Nd=f;class y{constructor(b,v=Math.random().toString(18).slice(2,5)){this.threshold=b,this.name=v,this.g=0}dispose(){this.f?.clear()}check(b,v){const C=this.threshold;if(C<=0||v<C)return;this.f||(this.f=new Map);const N=this.f.get(b.value)||0;if(this.f.set(b.value,N+1),this.g-=1,this.g<=0){this.g=C*.5;let z,M=0;for(const[T,j]of this.f)(!z||M<j)&&(z=T,M=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${M}):`),console.warn(z)}return()=>{const z=this.f.get(b.value)||0;this.f.set(b.value,z-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(b){this.value=b}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class c{constructor(b){this.value=b,this.id=p++}}const s=2,i=($,b)=>{if($ instanceof c)b($);else for(let v=0;v<$.length;v++){const C=$[v];C&&b(C)}};class n{constructor(b){this.w=0,this.f=b,this.g=P>0||this.f?.leakWarningThreshold?new y(this.f?.leakWarningThreshold??P):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(w){const b=this.t;queueMicrotask(()=>{i(b,v=>v.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(b,v,C)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),m.$Rc.None;if(this.m)return m.$Rc.None;v&&(b=b.bind(v));const N=new c(b);let z,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=S.create(),z=this.g.check(N.stack,this.w+1)),w&&(N.stack=M??S.create()),this.t?this.t instanceof c?(this.u??=new a,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const T=(0,m.$Pc)(()=>{z?.(),this.x(N)});return C instanceof m.$Qc?C.add(T):Array.isArray(C)&&C.push(T),T},this.q}x(b){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const v=this.t,C=v.indexOf(b);if(C===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,v[C]=void 0;const N=this.u.current===this;if(this.w*s<=v.length){let z=0;for(let M=0;M<v.length;M++)v[M]?v[z++]=v[M]:N&&(this.u.end--,z<this.u.i&&this.u.i--);v.length=z}}y(b,v){if(!b)return;const C=this.f?.onListenerError||I.$Z;if(!C){b.value(v);return}try{b.value(v)}catch(N){C(N)}}z(b){const v=b.current.t;for(;b.i<b.end;)this.y(v[b.i++],b.value);b.reset()}fire(b){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof c)this.y(this.t,b);else{const v=this.u;v.enqueue(this,b,this.t.length),this.z(v)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Od=n;const o=()=>new a;e.$Pd=o;class a{constructor(){this.i=-1,this.end=0}enqueue(b,v,C){this.i=0,this.end=C,this.current=b,this.value=v}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(b,v,C){if(this.t)for(this.h||(this.h=new L.$1c),i(this.t,N=>this.h.push([N.value,b]));this.h.size>0&&!v.isCancellationRequested;){const[N,z]=this.h.shift(),M=[],T={...z,token:v,waitUntil:j=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");C&&(j=C(j,N)),M.push(j)}};try{N(T)}catch(j){(0,I.$Z)(j);continue}Object.freeze(M),await Promise.allSettled(M).then(j=>{for(const O of j)O.status==="rejected"&&(0,I.$Z)(O.reason)})}}}e.$Qd=t;class r extends n{get isPaused(){return this.h!==0}constructor(b){super(b),this.h=0,this.s=new L.$1c,this.A=b?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const b=Array.from(this.s);this.s.clear(),super.fire(this.A(b))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(b){this.w&&(this.h!==0?this.s.push(b):super.fire(b))}}e.$Rd=r;class d extends r{constructor(b){super(b),this.k=b.delay??100}fire(b){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(b)}}e.$Sd=d;class u extends n{constructor(b){super(b),this.h=[],this.k=b?.merge}fire(b){this.hasListeners()&&(this.h.push(b),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(v=>super.fire(v)),this.h=[]}))}}e.$Td=u;class l{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(b){const v={event:b,listener:null};this.h.push(v),this.g&&this.m(v);const C=()=>{this.g&&this.o(v);const N=this.h.indexOf(v);this.h.splice(N,1)};return(0,m.$Pc)((0,F.$cb)(C))}j(){this.g=!0,this.h.forEach(b=>this.m(b))}k(){this.g=!1,this.h.forEach(b=>this.o(b))}m(b){b.listener=b.event(v=>this.f.fire(v))}o(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.f.dispose()}}e.$Ud=l;class h{constructor(b,v,C,N){this.f=new m.$Qc;const z=this.f.add(new l),M=this.f.add(new m.$Zc);function T(j){M.set(j,z.add(N(j)))}for(const j of b)T(j);this.f.add(v(j=>{T(j)})),this.f.add(C(j=>{M.deleteAndDispose(j)})),this.event=z.event}dispose(){this.f.dispose()}}e.$Vd=h;class k{constructor(){this.f=[]}wrapEvent(b){return(v,C,N)=>b(z=>{const M=this.f[this.f.length-1];M?M.push(()=>v.call(C,z)):v.call(C,z)},void 0,N)}bufferEvents(b){const v=[];this.f.push(v);const C=b();return this.f.pop(),v.forEach(N=>N()),C}}e.$Wd=k;class D{constructor(){this.f=!1,this.g=g.None,this.h=m.$Rc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(b){this.g=b,this.f&&(this.h.dispose(),this.h=b(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Xd=D}),define(ke[21],Se([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.CancellationToken=void 0;const F=Object.freeze(function(w,E){const g=setTimeout(w.bind(E),0);return{dispose(){clearTimeout(g)}}});var m;(function(w){function E(g){return g===w.None||g===w.Cancelled||g instanceof L?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}w.isCancellationToken=E,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(m||(e.CancellationToken=m={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new I.$Od),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=m.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=m.None}}e.$Yd=R}),define(ke[162],Se([1,0,21]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=void 0;class F{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new I.$Yd,E=this.b(w.token);return this.a={promise:E,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}e.$xe=F;class m{constructor(w){this.c=w,this.a=void 0,this.b=void 0}get(w){const E=JSON.stringify(w);return this.b!==E&&(this.b=E,this.a=this.c(w)),this.a}}e.$ye=m;class L{get cachedValues(){return this.a}constructor(w){this.b=w,this.a=new Map}get(w){if(this.a.has(w))return this.a.get(w);const E=this.b(w);return this.a.set(w,E),E}}e.$ze=L}),define(ke[98],Se([1,0,11,3]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=void 0;function m(o){const a=o;return a?typeof a.read=="function":!1}e.$Zd=m;function L(o){const a=o;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$1d=L;function R(o){const a=o;return a?L(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$2d=R;function w(o,a){return new E(o,a)}e.$3d=w;class E{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,I.$Z)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let r;switch(a){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const d=r.indexOf(t);d>=0&&r.splice(d,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(o,a){const t=[];let r;for(;(r=o.read())!==null;)t.push(r);return a(t)}e.$4d=g;function A(o,a,t){const r=[];let d;for(;(d=o.read())!==null&&r.length<t;)r.push(d);return d===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof d<"u"){const u=d;return d=void 0,u}return o.read()}}}e.$5d=A;function P(o,a){return new Promise((t,r)=>{const d=[];f(o,{onData:u=>{a&&d.push(u)},onError:u=>{a?r(u):t(void 0)},onEnd:()=>{t(a?a(d):void 0)}})})}e.$6d=P;function f(o,a,t){o.on("error",r=>{t?.isCancellationRequested||a.onError(r)}),o.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),o.on("data",r=>{t?.isCancellationRequested||a.onData(r)})}e.$7d=f;function y(o,a){return new Promise((t,r)=>{const d=new F.$Qc,u=[],l=D=>{if(u.push(D),u.length>a)return d.dispose(),o.pause(),t({stream:o,buffer:u,ended:!1})},h=D=>(d.dispose(),r(D)),k=()=>(d.dispose(),t({stream:o,buffer:u,ended:!0}));d.add((0,F.$Pc)(()=>o.removeListener("error",h))),o.on("error",h),d.add((0,F.$Pc)(()=>o.removeListener("end",k))),o.on("end",k),d.add((0,F.$Pc)(()=>o.removeListener("data",l))),o.on("data",l)})}e.$8d=y;function S(o,a){const t=w(a);return t.end(o),t}e.$9d=S;function p(){const o=w(()=>{throw new Error("not supported")});return o.end(),o}e.$0d=p;function c(o){let a=!1;return{read:()=>a?null:(a=!0,o)}}e.$$d=c;function s(o,a,t){const r=w(t);return f(o,{onData:d=>r.write(a.data(d)),onError:d=>r.error(a.error?a.error(d):d),onEnd:()=>r.end()}),r}e.$_d=s;function i(o,a,t){let r=!1;return{read:()=>{const d=a.read();return r?d:(r=!0,d!==null?t([o,d]):o)}}}e.$ae=i;function n(o,a,t){let r=!1;const d=w(t);return f(a,{onData:u=>r?d.write(u):(r=!0,d.write(t([o,u]))),onError:u=>d.error(u),onEnd:()=>{r||(r=!0,d.write(o)),d.end()}}),d}e.$be=n}),define(ke[22],Se([1,0,48,98]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=void 0;const m=typeof Buffer<"u",L=new I.$U(()=>new Uint8Array(256));let R,w;class E{static alloc(v){return m?new E(Buffer.allocUnsafe(v)):new E(new Uint8Array(v))}static wrap(v){return m&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new E(v)}static fromString(v,C){return!(C?.dontUseNodeBuffer||!1)&&m?new E(Buffer.from(v)):(R||(R=new TextEncoder),new E(R.encode(v)))}static fromByteArray(v){const C=E.alloc(v.length);for(let N=0,z=v.length;N<z;N++)C.buffer[N]=v[N];return C}static concat(v,C){if(typeof C>"u"){C=0;for(let M=0,T=v.length;M<T;M++)C+=v[M].byteLength}const N=E.alloc(C);let z=0;for(let M=0,T=v.length;M<T;M++){const j=v[M];N.set(j,z),z+=j.byteLength}return N}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=E.alloc(this.byteLength);return v.set(this),v}toString(){return m?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(v,C){return new E(this.buffer.subarray(v,C))}set(v,C){if(v instanceof E)this.buffer.set(v.buffer,C);else if(v instanceof Uint8Array)this.buffer.set(v,C);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),C);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return f(this.buffer,v)}writeUInt32BE(v,C){y(this.buffer,v,C)}readUInt32LE(v){return S(this.buffer,v)}writeUInt32LE(v,C){p(this.buffer,v,C)}readUInt8(v){return c(this.buffer,v)}writeUInt8(v,C){s(this.buffer,v,C)}indexOf(v,C=0){return g(this.buffer,v instanceof E?v.buffer:v,C)}}e.$ce=E;function g(b,v,C=0){const N=v.byteLength,z=b.byteLength;if(N===0)return 0;if(N===1)return b.indexOf(v[0]);if(N>z-C)return-1;const M=L.value;M.fill(v.length);for(let q=0;q<v.length;q++)M[v[q]]=v.length-q-1;let T=C+v.length-1,j=T,O=-1;for(;T<z;)if(b[T]===v[j]){if(j===0){O=T;break}T--,j--}else T+=Math.max(v.length-j,M[b[T]]),j=v.length-1;return O}e.$de=g;function A(b,v){return b[v+0]<<0>>>0|b[v+1]<<8>>>0}e.$ee=A;function P(b,v,C){b[C+0]=v&255,v=v>>>8,b[C+1]=v&255}e.$fe=P;function f(b,v){return b[v]*2**24+b[v+1]*2**16+b[v+2]*2**8+b[v+3]}e.$ge=f;function y(b,v,C){b[C+3]=v,v=v>>>8,b[C+2]=v,v=v>>>8,b[C+1]=v,v=v>>>8,b[C]=v}e.$he=y;function S(b,v){return b[v+0]<<0>>>0|b[v+1]<<8>>>0|b[v+2]<<16>>>0|b[v+3]<<24>>>0}e.$ie=S;function p(b,v,C){b[C+0]=v&255,v=v>>>8,b[C+1]=v&255,v=v>>>8,b[C+2]=v&255,v=v>>>8,b[C+3]=v&255}e.$je=p;function c(b,v){return b[v]}e.$ke=c;function s(b,v,C){b[C]=v}e.$le=s;function i(b){return F.$4d(b,v=>E.concat(v))}e.$me=i;function n(b){return F.$$d(b)}e.$ne=n;function o(b){return F.$6d(b,v=>E.concat(v))}e.$oe=o;async function a(b){return b.ended?E.concat(b.buffer):E.concat([...b.buffer,await o(b.stream)])}e.$pe=a;function t(b){return F.$9d(b,v=>E.concat(v))}e.$qe=t;function r(b){return F.$_d(b,{data:v=>typeof v=="string"?E.fromString(v):E.wrap(v)},v=>E.concat(v))}e.$re=r;function d(b){return F.$3d(v=>E.concat(v),b)}e.$se=d;function u(b,v){return F.$ae(b,v,C=>E.concat(C))}e.$te=u;function l(b,v){return F.$be(b,v,C=>E.concat(C))}e.$ue=l;function h(b){let v=0,C=0,N=0;const z=new Uint8Array(Math.floor(b.length/4*3)),M=j=>{switch(C){case 3:z[N++]=v|j,C=0;break;case 2:z[N++]=v|j>>>2,v=j<<6,C=3;break;case 1:z[N++]=v|j>>>4,v=j<<4,C=2;break;default:v=j<<2,C=1}};for(let j=0;j<b.length;j++){const O=b.charCodeAt(j);if(O>=65&&O<=90)M(O-65);else if(O>=97&&O<=122)M(O-97+26);else if(O>=48&&O<=57)M(O-48+52);else if(O===43||O===45)M(62);else if(O===47||O===95)M(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${b[j]}`)}}const T=N;for(;C>0;)M(0);return E.wrap(z).slice(0,T)}e.$ve=h;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:b},v=!0,C=!1){const N=C?D:k;let z="";const M=b.byteLength%3;let T=0;for(;T<b.byteLength-M;T+=3){const j=b[T+0],O=b[T+1],q=b[T+2];z+=N[j>>>2],z+=N[(j<<4|O>>>4)&63],z+=N[(O<<2|q>>>6)&63],z+=N[q&63]}if(M===1){const j=b[T+0];z+=N[j>>>2],z+=N[j<<4&63],v&&(z+="==")}else if(M===2){const j=b[T+0],O=b[T+1];z+=N[j>>>2],z+=N[(j<<4|O>>>4)&63],z+=N[O<<2&63],v&&(z+="=")}return z}e.$we=$}),define(ke[13],Se([1,0,162,48]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yf=e.$xf=e.$wf=e.$vf=e.GraphemeBreakType=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=void 0;function m(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Ce=m;const L=/{(\d+)}/g;function R(Ae,...Te){return Te.length===0?Ae:Ae.replace(L,function(qe,Re){const Ye=parseInt(Re,10);return isNaN(Ye)||Ye<0||Ye>=Te.length?qe:Te[Ye]})}e.$De=R;const w=/{([^}]+)}/g;function E(Ae,Te){return Object.keys(Te).length===0?Ae:Ae.replace(w,(qe,Re)=>Te[Re]??qe)}e.$Ee=E;function g(Ae){return Ae.replace(/[<>&]/g,function(Te){switch(Te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Te}})}e.$Fe=g;function A(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ge=A;function P(Ae,Te){let qe=0;const Re=Te.charCodeAt(0);for(let Ye=Ae.length-1;Ye>=0;Ye--)Ae.charCodeAt(Ye)===Re&&qe++;return qe}e.$He=P;function f(Ae,Te,qe="\u2026"){return Ae.length<=Te?Ae:`${Ae.substr(0,Te)}${qe}`}e.$Ie=f;function y(Ae,Te=" "){const qe=S(Ae,Te);return p(qe,Te)}e.$Je=y;function S(Ae,Te){if(!Ae||!Te)return Ae;const qe=Te.length;if(qe===0||Ae.length===0)return Ae;let Re=0;for(;Ae.indexOf(Te,Re)===Re;)Re=Re+qe;return Ae.substring(Re)}e.$Ke=S;function p(Ae,Te){if(!Ae||!Te)return Ae;const qe=Te.length,Re=Ae.length;if(qe===0||Re===0)return Ae;let Ye=Re,le=-1;for(;le=Ae.lastIndexOf(Te,Ye-1),!(le===-1||le+qe!==Ye);){if(le===0)return"";Ye=le}return Ae.substring(0,Ye)}e.$Le=p;function c(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Me=c;function s(Ae){return Ae.replace(/\*/g,"")}e.$Ne=s;function i(Ae,Te,qe={}){if(!Ae)throw new Error("Cannot create regex from empty string");Te||(Ae=A(Ae)),qe.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Re="";return qe.global&&(Re+="g"),qe.matchCase||(Re+="i"),qe.multiline&&(Re+="m"),qe.unicode&&(Re+="u"),new RegExp(Ae,Re)}e.$Oe=i;function n(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Pe=n;function o(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Qe=o;function a(Ae){for(let Te=0,qe=Ae.length;Te<qe;Te++){const Re=Ae.charCodeAt(Te);if(Re!==32&&Re!==9)return Te}return-1}e.$Re=a;function t(Ae,Te=0,qe=Ae.length){for(let Re=Te;Re<qe;Re++){const Ye=Ae.charCodeAt(Re);if(Ye!==32&&Ye!==9)return Ae.substring(Te,Re)}return Ae.substring(Te,qe)}e.$Se=t;function r(Ae,Te=Ae.length-1){for(let qe=Te;qe>=0;qe--){const Re=Ae.charCodeAt(qe);if(Re!==32&&Re!==9)return qe}return-1}e.$Te=r;function d(Ae,Te,qe){const Re=[];let Ye=0;for(const le of Ae.matchAll(Te)){if(Re.push(Ae.slice(Ye,le.index)),le.index===void 0)throw new Error("match.index should be defined");Ye=le.index+le[0].length,Re.push(qe(le[0],...le.slice(1),le.index,Ae,le.groups))}return Re.push(Ae.slice(Ye)),Promise.all(Re).then(le=>le.join(""))}e.$Ue=d;function u(Ae,Te){return Ae<Te?-1:Ae>Te?1:0}e.$Ve=u;function l(Ae,Te,qe=0,Re=Ae.length,Ye=0,le=Te.length){for(;qe<Re&&Ye<le;qe++,Ye++){const Ke=Ae.charCodeAt(qe),Ue=Te.charCodeAt(Ye);if(Ke<Ue)return-1;if(Ke>Ue)return 1}const ue=Re-qe,Ie=le-Ye;return ue<Ie?-1:ue>Ie?1:0}e.$We=l;function h(Ae,Te){return k(Ae,Te,0,Ae.length,0,Te.length)}e.$Xe=h;function k(Ae,Te,qe=0,Re=Ae.length,Ye=0,le=Te.length){for(;qe<Re&&Ye<le;qe++,Ye++){let Ke=Ae.charCodeAt(qe),Ue=Te.charCodeAt(Ye);if(Ke===Ue)continue;if(Ke>=128||Ue>=128)return l(Ae.toLowerCase(),Te.toLowerCase(),qe,Re,Ye,le);$(Ke)&&(Ke-=32),$(Ue)&&(Ue-=32);const Ze=Ke-Ue;if(Ze!==0)return Ze}const ue=Re-qe,Ie=le-Ye;return ue<Ie?-1:ue>Ie?1:0}e.$Ye=k;function D(Ae){return Ae>=48&&Ae<=57}e.$Ze=D;function $(Ae){return Ae>=97&&Ae<=122}e.$1e=$;function b(Ae){return Ae>=65&&Ae<=90}e.$2e=b;function v(Ae,Te){return Ae.length===Te.length&&k(Ae,Te)===0}e.$3e=v;function C(Ae,Te){const qe=Te.length;return Te.length>Ae.length?!1:k(Ae,Te,0,qe)===0}e.$4e=C;function N(Ae,Te){const qe=Math.min(Ae.length,Te.length);let Re;for(Re=0;Re<qe;Re++)if(Ae.charCodeAt(Re)!==Te.charCodeAt(Re))return Re;return qe}e.$5e=N;function z(Ae,Te){const qe=Math.min(Ae.length,Te.length);let Re;const Ye=Ae.length-1,le=Te.length-1;for(Re=0;Re<qe;Re++)if(Ae.charCodeAt(Ye-Re)!==Te.charCodeAt(le-Re))return Re;return qe}e.$6e=z;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$7e=M;function T(Ae){return 56320<=Ae&&Ae<=57343}e.$8e=T;function j(Ae,Te){return(Ae-55296<<10)+(Te-56320)+65536}e.$9e=j;function O(Ae,Te,qe){const Re=Ae.charCodeAt(qe);if(M(Re)&&qe+1<Te){const Ye=Ae.charCodeAt(qe+1);if(T(Ye))return j(Re,Ye)}return Re}e.$0e=O;function q(Ae,Te){const qe=Ae.charCodeAt(Te-1);if(T(qe)&&Te>1){const Re=Ae.charCodeAt(Te-2);if(M(Re))return j(Re,qe)}return qe}class V{get offset(){return this.e}constructor(Te,qe=0){this.c=Te,this.d=Te.length,this.e=qe}setOffset(Te){this.e=Te}prevCodePoint(){const Te=q(this.c,this.e);return this.e-=Te>=65536?2:1,Te}nextCodePoint(){const Te=O(this.c,this.d,this.e);return this.e+=Te>=65536?2:1,Te}eol(){return this.e>=this.d}}e.$$e=V;class de{get offset(){return this.c.offset}constructor(Te,qe=0){this.c=new V(Te,qe)}nextGraphemeLength(){const Te=ge.getInstance(),qe=this.c,Re=qe.offset;let Ye=Te.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const le=qe.offset,ue=Te.getGraphemeBreakType(qe.nextCodePoint());if(oe(Ye,ue)){qe.setOffset(le);break}Ye=ue}return qe.offset-Re}prevGraphemeLength(){const Te=ge.getInstance(),qe=this.c,Re=qe.offset;let Ye=Te.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const le=qe.offset,ue=Te.getGraphemeBreakType(qe.prevCodePoint());if(oe(ue,Ye)){qe.setOffset(le);break}Ye=ue}return Re-qe.offset}eol(){return this.c.eol()}}e.$_e=de;function ee(Ae,Te){return new de(Ae,Te).nextGraphemeLength()}e.$af=ee;function X(Ae,Te){return new de(Ae,Te).prevGraphemeLength()}e.$bf=X;function Q(Ae,Te){Te>0&&T(Ae.charCodeAt(Te))&&Te--;const qe=Te+ee(Ae,Te);return[qe-X(Ae,qe),qe]}e.$cf=Q;function ae(Ae){const Te=new de(Ae);let qe=0;for(;!Te.eol();)qe++,Te.nextGraphemeLength();return qe}e.$df=ae;let x;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function pe(Ae){return x||(x=se()),x.test(Ae)}e.$ef=pe;const G=/^[\t\n\r\x20-\x7E]*$/;function U(Ae){return G.test(Ae)}e.$ff=U,e.$gf=/[\u2028\u2029]/;function ce(Ae){return e.$gf.test(Ae)}e.$hf=ce;function be(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$if=be;function H(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$jf=H;function Z(Ae,Te){if(Ae.length<Te)return Ae;const qe=/\b/g;let Re=0;for(;qe.test(Ae)&&!(Ae.length-qe.lastIndex<Te);)Re=qe.lastIndex,qe.lastIndex+=1;return Ae.substring(Re).replace(/^\s/,"")}e.$kf=Z;const Y=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,$e=/\x1b\].*?\x07/g;function ne(Ae){return Ae&&(Ae=Ae.replace(Y,"").replace($e,"")),Ae}e.$lf=ne,e.$mf=String.fromCharCode(65279);function fe(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$nf=fe;function te(Ae){return fe(Ae)?Ae.substr(1):Ae}e.$of=te;function he(Ae,Te){if(!Ae||!Te||Ae.length<Te.length)return!1;const qe=Te.length,Re=Ae.toLowerCase();let Ye=0,le=-1;for(;Ye<qe;){const ue=Re.indexOf(Te[Ye],le+1);if(ue<0)return!1;le=ue,Ye++}return!0}e.$pf=he;function we(Ae,Te=!1){return Ae?(Te&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$qf=we;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$rf=Pe;function B(Ae,Te=1){if(Te===0)return"";let qe=-1;do qe=Ae.indexOf(`
`,qe+1),Te--;while(Te>0&&qe>=0);return qe===-1?Ae:(Ae[qe-1]==="\r"&&qe--,Ae.substr(0,qe))}e.$sf=B;function J(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$tf=J;function re(Ae){return ge.getInstance().getGraphemeBreakType(Ae)}e.$uf=re;function oe(Ae,Te){return Ae===0?Te!==5&&Te!==7:Ae===2&&Te===3?!1:Ae===4||Ae===2||Ae===3||Te===4||Te===2||Te===3?!0:!(Ae===8&&(Te===8||Te===9||Te===11||Te===12)||(Ae===11||Ae===9)&&(Te===9||Te===10)||(Ae===12||Ae===10)&&Te===10||Te===5||Te===13||Te===7||Ae===1||Ae===13&&Te===14||Ae===6&&Te===6)}var _;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(_||(e.GraphemeBreakType=_={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=Ee()}getGraphemeBreakType(Te){if(Te<32)return Te===10?3:Te===13?2:4;if(Te<127)return 0;const qe=this.d,Re=qe.length/3;let Ye=1;for(;Ye<=Re;)if(Te<qe[3*Ye])Ye=2*Ye;else if(Te>qe[3*Ye+1])Ye=2*Ye+1;else return qe[3*Ye+2];return 0}}function Ee(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(Ae,Te){if(Ae===0)return 0;const qe=We(Ae,Te);if(qe!==void 0)return qe;const Re=new V(Te,Ae);return Re.prevCodePoint(),Re.offset}e.$vf=ze;function We(Ae,Te){const qe=new V(Te,Ae);let Re=qe.prevCodePoint();for(;_e(Re)||Re===65039||Re===8419;){if(qe.offset===0)return;Re=qe.prevCodePoint()}if(!H(Re))return;let Ye=qe.offset;return Ye>0&&qe.prevCodePoint()===8205&&(Ye=qe.offset),Ye}function _e(Ae){return 127995<=Ae&&Ae<=127999}var Xe;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.$wf="\xA0";class it{static{this.c=new F.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$ye(Te=>{function qe(Ze){const nt=new Map;for(let ct=0;ct<Ze.length;ct+=2)nt.set(Ze[ct],Ze[ct+1]);return nt}function Re(Ze,nt){const ct=new Map(Ze);for(const[bt,Et]of nt)ct.set(bt,Et);return ct}function Ye(Ze,nt){if(!Ze)return nt;const ct=new Map;for(const[bt,Et]of Ze)nt.has(bt)&&ct.set(bt,Et);return ct}const le=this.c.value;let ue=Te.filter(Ze=>!Ze.startsWith("_")&&Ze in le);ue.length===0&&(ue=["_default"]);let Ie;for(const Ze of ue){const nt=qe(le[Ze]);Ie=Ye(Ie,nt)}const Ke=qe(le._common),Ue=Re(Ke,Ie);return new it(Ue)})}static getInstance(Te){return it.d.get(Array.from(Te))}static{this.e=new F.$U(()=>Object.keys(it.c.value).filter(Te=>!Te.startsWith("_")))}static getLocales(){return it.e.value}constructor(Te){this.f=Te}isAmbiguous(Te){return this.f.has(Te)}getPrimaryConfusable(Te){return this.f.get(Te)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$xf=it;class tt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(tt.c())),this.d}static isInvisibleCharacter(Te){return tt.e().has(Te)}static get codePoints(){return tt.e()}}e.$yf=tt}),define(ke[124],Se([1,0,28,13]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.FuzzyScore=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.or=void 0;function m(...te){return function(he,we){for(let Pe=0,B=te.length;Pe<B;Pe++){const J=te[Pe](he,we);if(J)return J}return null}}e.or=m,e.$Fj=L.bind(void 0,!1),e.$Gj=L.bind(void 0,!0);function L(te,he,we){if(!we||we.length<he.length)return null;let Pe;return te?Pe=F.$4e(we,he):Pe=we.indexOf(he)===0,Pe?he.length>0?[{start:0,end:he.length}]:[]:null}function R(te,he){const we=he.toLowerCase().indexOf(te.toLowerCase());return we===-1?null:[{start:we,end:we+te.length}]}e.$Hj=R;function w(te,he){return E(te.toLowerCase(),he.toLowerCase(),0,0)}e.$Ij=w;function E(te,he,we,Pe){if(we===te.length)return[];if(Pe===he.length)return null;if(te[we]===he[Pe]){let B=null;return(B=E(te,he,we+1,Pe+1))?s({start:Pe,end:Pe+1},B):null}return E(te,he,we,Pe+1)}function g(te){return 97<=te&&te<=122}function A(te){return 65<=te&&te<=90}e.$Jj=A;function P(te){return 48<=te&&te<=57}function f(te){return te===32||te===9||te===10||te===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>y.add(te.charCodeAt(0)));function S(te){return f(te)||y.has(te)}function p(te,he){return te===he||S(te)&&S(he)}function c(te){return g(te)||A(te)||P(te)}function s(te,he){return he.length===0?he=[te]:te.end===he[0].start?he[0].start=te.start:he.unshift(te),he}function i(te,he){for(let we=he;we<te.length;we++){const Pe=te.charCodeAt(we);if(A(Pe)||P(Pe)||we>0&&!c(te.charCodeAt(we-1)))return we}return te.length}function n(te,he,we,Pe){if(we===te.length)return[];if(Pe===he.length)return null;if(te[we]!==he[Pe].toLowerCase())return null;{let B=null,J=Pe+1;for(B=n(te,he,we+1,Pe+1);!B&&(J=i(he,J))<he.length;)B=n(te,he,we+1,J),J++;return B===null?null:s({start:Pe,end:Pe+1},B)}}function o(te){let he=0,we=0,Pe=0,B=0,J=0;for(let Ee=0;Ee<te.length;Ee++)J=te.charCodeAt(Ee),A(J)&&he++,g(J)&&we++,c(J)&&Pe++,P(J)&&B++;const re=he/te.length,oe=we/te.length,_=Pe/te.length,ge=B/te.length;return{upperPercent:re,lowerPercent:oe,alphaPercent:_,numericPercent:ge}}function a(te){const{upperPercent:he,lowerPercent:we}=te;return we===0&&he>.6}function t(te){const{upperPercent:he,lowerPercent:we,alphaPercent:Pe,numericPercent:B}=te;return we>.2&&he<.8&&Pe>.6&&B<.2}function r(te){let he=0,we=0,Pe=0,B=0;for(let J=0;J<te.length;J++)Pe=te.charCodeAt(J),A(Pe)&&he++,g(Pe)&&we++,f(Pe)&&B++;return(he===0||we===0)&&B===0?te.length<=30:he<=5}function d(te,he){if(!he||(he=he.trim(),he.length===0)||!r(te)||he.length>60)return null;const we=o(he);if(!t(we)){if(!a(we))return null;he=he.toLowerCase()}let Pe=null,B=0;for(te=te.toLowerCase();B<he.length&&(Pe=n(te,he,0,B))===null;)B=i(he,B+1);return Pe}e.$Kj=d;function u(te,he,we=!1){if(!he||he.length===0)return null;let Pe=null,B=0;for(te=te.toLowerCase(),he=he.toLowerCase();B<he.length&&(Pe=l(te,he,0,B,we))===null;)B=h(he,B+1);return Pe}e.$Lj=u;function l(te,he,we,Pe,B){if(we===te.length)return[];if(Pe===he.length)return null;if(p(te.charCodeAt(we),he.charCodeAt(Pe))){let J=null,re=Pe+1;if(J=l(te,he,we+1,Pe+1,B),!B)for(;!J&&(re=h(he,re))<he.length;)J=l(te,he,we+1,re,B),re++;return J?te.charCodeAt(we)!==he.charCodeAt(Pe)?J:s({start:Pe,end:Pe+1},J):null}else return null}function h(te,he){for(let we=he;we<te.length;we++)if(S(te.charCodeAt(we))||we>0&&S(te.charCodeAt(we-1)))return we;return te.length}const k=m(e.$Gj,d,R),D=m(e.$Gj,d,w),$=new I.$Cc(1e4);function b(te,he,we=!1){if(typeof te!="string"||typeof he!="string")return null;let Pe=$.get(te);Pe||(Pe=new RegExp(F.$Me(te),"i"),$.set(te,Pe));const B=Pe.exec(he);return B?[{start:B.index,end:B.index+B[0].length}]:we?D(te,he):k(te,he)}e.$Mj=b;function v(te,he){const we=be(te,te.toLowerCase(),0,he,he.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return we?N(we):null}e.$Nj=v;function C(te,he,we,Pe,B,J){const re=Math.min(13,te.length);for(;we<re;we++){const oe=be(te,he,we,Pe,B,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,J]}e.$Oj=C;function N(te){if(typeof te>"u")return[];const he=[],we=te[1];for(let Pe=te.length-1;Pe>1;Pe--){const B=te[Pe]+we,J=he[he.length-1];J&&J.end===B?J.end=B+1:he.push({start:B,end:B+1})}return he}e.$Pj=N;const z=128;function M(){const te=[],he=[];for(let we=0;we<=z;we++)he[we]=0;for(let we=0;we<=z;we++)te.push(he.slice(0));return te}function T(te){const he=[];for(let we=0;we<=te;we++)he[we]=0;return he}const j=T(2*z),O=T(2*z),q=M(),V=M(),de=M(),ee=!1;function X(te,he,we,Pe,B){function J(oe,_,ge=" "){for(;oe.length<_;)oe=ge+oe;return oe}let re=` |   |${Pe.split("").map(oe=>J(oe,3)).join("|")}
`;for(let oe=0;oe<=we;oe++)oe===0?re+=" |":re+=`${he[oe-1]}|`,re+=te[oe].slice(0,B+1).map(_=>J(_.toString(),3)).join("|")+`
`;return re}function Q(te,he,we,Pe){te=te.substr(he),we=we.substr(Pe),console.log(X(V,te,te.length,we,we.length)),console.log(X(de,te,te.length,we,we.length)),console.log(X(q,te,te.length,we,we.length))}function ae(te,he){if(he<0||he>=te.length)return!1;const we=te.codePointAt(he);switch(we){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$jf(we)}}function x(te,he){if(he<0||he>=te.length)return!1;switch(te.charCodeAt(he)){case 32:case 9:return!0;default:return!1}}function se(te,he,we){return he[te]!==we[te]}function pe(te,he,we,Pe,B,J,re=!1){for(;he<we&&B<J;)te[he]===Pe[B]&&(re&&(j[he]=B),he+=1),B+=1;return he===we}e.$Qj=pe;var G;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(G||(G={}));var U;(function(te){te.Default=[-100,0];function he(we){return!we||we.length===2&&we[0]===-100&&we[1]===0}te.isDefault=he})(U||(e.FuzzyScore=U={}));class ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(he,we){this.firstMatchCanBeWeak=he,this.boostFullMatch=we}}e.$Rj=ce;function be(te,he,we,Pe,B,J,re=ce.default){const oe=te.length>z?z:te.length,_=Pe.length>z?z:Pe.length;if(we>=oe||J>=_||oe-we>_-J||!pe(he,we,oe,B,J,_,!0))return;H(oe,_,we,J,he,B);let ge=1,Ee=1,ze=we,We=J;const _e=[!1];for(ge=1,ze=we;ze<oe;ge++,ze++){const Te=j[ze],qe=O[ze],Re=ze+1<oe?O[ze+1]:_;for(Ee=Te-J+1,We=Te;We<Re;Ee++,We++){let Ye=Number.MIN_SAFE_INTEGER,le=!1;We<=qe&&(Ye=Z(te,he,ze,we,Pe,B,We,_,J,q[ge-1][Ee-1]===0,_e));let ue=0;Ye!==Number.MAX_SAFE_INTEGER&&(le=!0,ue=Ye+V[ge-1][Ee-1]);const Ie=We>Te,Ke=Ie?V[ge][Ee-1]+(q[ge][Ee-1]>0?-5:0):0,Ue=We>Te+1&&q[ge][Ee-1]>0,Ze=Ue?V[ge][Ee-2]+(q[ge][Ee-2]>0?-5:0):0;if(Ue&&(!Ie||Ze>=Ke)&&(!le||Ze>=ue))V[ge][Ee]=Ze,de[ge][Ee]=3,q[ge][Ee]=0;else if(Ie&&(!le||Ke>=ue))V[ge][Ee]=Ke,de[ge][Ee]=2,q[ge][Ee]=0;else if(le)V[ge][Ee]=ue,de[ge][Ee]=1,q[ge][Ee]=q[ge-1][Ee-1]+1;else throw new Error("not possible")}}if(ee&&Q(te,we,Pe,J),!_e[0]&&!re.firstMatchCanBeWeak)return;ge--,Ee--;const Xe=[V[ge][Ee],J];let it=0,tt=0;for(;ge>=1;){let Te=Ee;do{const qe=de[ge][Te];if(qe===3)Te=Te-2;else if(qe===2)Te=Te-1;else break}while(Te>=1);it>1&&he[we+ge-1]===B[J+Ee-1]&&!se(Te+J-1,Pe,B)&&it+1>q[ge][Te]&&(Te=Ee),Te===Ee?it++:it=1,tt||(tt=Te),ge--,Ee=Te-1,Xe.push(Ee)}_===oe&&re.boostFullMatch&&(Xe[0]+=2);const Ae=tt-oe;return Xe[0]-=Ae,Xe}e.$Sj=be;function H(te,he,we,Pe,B,J){let re=te-1,oe=he-1;for(;re>=we&&oe>=Pe;)B[re]===J[oe]&&(O[re]=oe,re--),oe--}function Z(te,he,we,Pe,B,J,re,oe,_,ge,Ee){if(he[we]!==J[re])return Number.MIN_SAFE_INTEGER;let ze=1,We=!1;return re===we-Pe?ze=te[we]===B[re]?7:5:se(re,B,J)&&(re===0||!se(re-1,B,J))?(ze=te[we]===B[re]?7:5,We=!0):ae(J,re)&&(re===0||!ae(J,re-1))?ze=5:(ae(J,re-1)||x(J,re-1))&&(ze=5,We=!0),ze>1&&we===Pe&&(Ee[0]=!0),We||(We=se(re,B,J)||ae(J,re-1)||x(J,re-1)),we===Pe?re>_&&(ze-=We?3:5):ge?ze+=We?2:0:ze+=We?0:1,re+1===oe&&(ze-=We?3:5),ze}function Y(te,he,we,Pe,B,J,re){return ne(te,he,we,Pe,B,J,!0,re)}e.$Tj=Y;function $e(te,he,we,Pe,B,J,re){return ne(te,he,we,Pe,B,J,!1,re)}e.$Uj=$e;function ne(te,he,we,Pe,B,J,re,oe){let _=be(te,he,we,Pe,B,J,oe);if(_&&!re)return _;if(te.length>=3){const ge=Math.min(7,te.length-1);for(let Ee=we+1;Ee<ge;Ee++){const ze=fe(te,Ee);if(ze){const We=be(ze,ze.toLowerCase(),we,Pe,B,J,oe);We&&(We[0]-=3,(!_||We[0]>_[0])&&(_=We))}}}return _}function fe(te,he){if(he+1>=te.length)return;const we=te[he],Pe=te[he+1];if(we!==Pe)return te.slice(0,he)+Pe+we+te.slice(he+2)}}),define(ke[52],Se([1,0,13]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;function F(s){return m(s,0)}e.$Gi=F;function m(s,i){switch(typeof s){case"object":return s===null?L(349,i):Array.isArray(s)?E(s,i):g(s,i);case"string":return w(s,i);case"boolean":return R(s,i);case"number":return L(s,i);case"undefined":return L(937,i);default:return L(617,i)}}e.$Hi=m;function L(s,i){return(i<<5)-i+s|0}e.$Ii=L;function R(s,i){return L(s?433:863,i)}function w(s,i){i=L(149417,i);for(let n=0,o=s.length;n<o;n++)i=L(s.charCodeAt(n),i);return i}e.$Ji=w;function E(s,i){return i=L(104579,i),s.reduce((n,o)=>m(o,n),i)}function g(s,i){return i=L(181387,i),Object.keys(s).sort().reduce((n,o)=>(n=w(o,n),m(s[o],n)),i)}class A{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=m(i,this.g),this.g}}e.$Ki=A;var P;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function f(s,i,n=32){const o=n-i,a=~((1<<o)-1);return(s<<i|(a&s)>>>o)>>>0}function y(s,i=0,n=s.byteLength,o=0){for(let a=0;a<n;a++)s[i+a]=o}function S(s,i,n="0"){for(;s.length<i;)s=n+s;return s}function p(s,i=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(n=>n.toString(16).padStart(2,"0")).join(""):S((s>>>0).toString(16),i/4)}e.$Li=p;class c{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const o=this.p;let a=this.r,t=this.u,r,d;for(t!==0?(r=t,d=-1,t=0):(r=i.charCodeAt(0),d=0);;){let u=r;if(I.$7e(r))if(d+1<n){const l=i.charCodeAt(d+1);I.$8e(l)?(d++,u=I.$9e(r,l)):u=65533}else{t=r;break}else I.$8e(r)&&(u=65533);if(a=this.w(o,a,u),d++,d<n)r=i.charCodeAt(d);else break}this.r=a,this.u=t}w(i,n,o){return o<128?i[n++]=o:o<2048?(i[n++]=192|(o&1984)>>>6,i[n++]=128|(o&63)>>>0):o<65536?(i[n++]=224|(o&61440)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0):(i[n++]=240|(o&1835008)>>>18,i[n++]=128|(o&258048)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=c.g,n=this.q;for(let k=0;k<64;k+=4)i.setUint32(k,n.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)i.setUint32(k,f(i.getUint32(k-12,!1)^i.getUint32(k-32,!1)^i.getUint32(k-56,!1)^i.getUint32(k-64,!1),1),!1);let o=this.h,a=this.l,t=this.m,r=this.n,d=this.o,u,l,h;for(let k=0;k<80;k++)k<20?(u=a&t|~a&r,l=1518500249):k<40?(u=a^t^r,l=1859775393):k<60?(u=a&t|a&r|t&r,l=2400959708):(u=a^t^r,l=3395469782),h=f(o,5)+u+d+l+i.getUint32(k*4,!1)&4294967295,d=r,r=t,t=f(a,30),a=o,o=h;this.h=this.h+o&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+d&4294967295}}e.$Mi=c}),define(ke[39],Se([1,0,13]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(m){m[m.Ignore=0]="Ignore",m[m.Info=1]="Info",m[m.Warning=2]="Warning",m[m.Error=3]="Error"})(F||(F={})),function(m){const L="error",R="warning",w="warn",E="info",g="ignore";function A(f){return f?I.$3e(L,f)?m.Error:I.$3e(R,f)||I.$3e(w,f)?m.Warning:I.$3e(E,f)?m.Info:m.Ignore:m.Ignore}m.fromValue=A;function P(f){switch(f){case m.Error:return L;case m.Warning:return R;case m.Info:return E;default:return g}}m.toString=P}(F||(F={})),e.default=F}),define(ke[163],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Ld=Symbol("MicrotaskDelay")}),define(ke[78],Se([1,0,19,13]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=void 0;class m{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const S=y.charCodeAt(0),p=this.b.charCodeAt(this.c);return S-p}value(){return this.b[this.c]}}e.$Uh=m;class L{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,F.$We)(y,this.b,0,y.length,this.c,this.d):(0,F.$Ye)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Vh=L;class R{constructor(y=!0,S=!0){this.f=y,this.g=S}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let S=y.length-1;S>=0;S--,this.c--){const p=this.b.charCodeAt(S);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,F.$We)(y,this.b,0,y.length,this.d,this.e):(0,F.$Ye)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Wh=R;var w;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(w||(w={}));class E{constructor(y,S){this.f=y,this.g=S,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,F.$Xe)(y,this.c.scheme);if(this.d[this.e]===2)return(0,F.$Xe)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,F.$Ve)(y,this.c.query);if(this.d[this.e]===5)return(0,F.$Ve)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Xh=E;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(A||(A={}));class P{static forUris(y=()=>!1,S=()=>!1){return new P(new E(y,S))}static forPaths(y=!1){return new P(new R(void 0,!y))}static forStrings(){return new P(new m)}static forConfigKeys(){return new P(new L)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,S){if(S){const p=S.slice(0);(0,I.$Wb)(p);for(const c of p)this.set(c,y)}else{const p=y.slice(0);(0,I.$Wb)(p);for(const c of p)this.set(c[0],c[1])}}set(y,S){const p=this.b.reset(y);let c;this.c||(this.c=new g,this.c.segment=p.value());const s=[];for(c=this.c;;){const n=p.cmp(c.segment);if(n>0)c.left||(c.left=new g,c.left.segment=p.value()),s.push([-1,c]),c=c.left;else if(n<0)c.right||(c.right=new g,c.right.segment=p.value()),s.push([1,c]),c=c.right;else if(p.hasNext())p.next(),c.mid||(c.mid=new g,c.mid.segment=p.value()),s.push([0,c]),c=c.mid;else break}const i=c.value;c.value=S,c.key=y;for(let n=s.length-1;n>=0;n--){const o=s[n][1];o.updateHeight();const a=o.balanceFactor();if(a<-1||a>1){const t=s[n][0],r=s[n+1][0];if(t===1&&r===1)s[n][1]=o.rotateLeft();else if(t===-1&&r===-1)s[n][1]=o.rotateRight();else if(t===1&&r===-1)o.right=s[n+1][1]=s[n+1][1].rotateRight(),s[n][1]=o.rotateLeft();else if(t===-1&&r===1)o.left=s[n+1][1]=s[n+1][1].rotateLeft(),s[n][1]=o.rotateRight();else throw new Error;if(n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}return i}get(y){return this.d(y)?.value}d(y){const S=this.b.reset(y);let p=this.c;for(;p;){const c=S.cmp(p.segment);if(c>0)p=p.left;else if(c<0)p=p.right;else if(S.hasNext())S.next(),p=p.mid;else break}return p}has(y){const S=this.d(y);return!(S?.value===void 0&&S?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,S){const p=this.b.reset(y),c=[];let s=this.c;for(;s;){const i=p.cmp(s.segment);if(i>0)c.push([-1,s]),s=s.left;else if(i<0)c.push([1,s]),s=s.right;else if(p.hasNext())p.next(),c.push([0,s]),s=s.mid;else break}if(s){if(S?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this.f(s.right);if(i.key){const{key:n,value:o,segment:a}=i;this.e(i.key,!1),s.key=n,s.value=o,s.segment=a}}else{const i=s.left??s.right;if(c.length>0){const[n,o]=c[c.length-1];switch(n){case-1:o.left=i;break;case 0:o.mid=i;break;case 1:o.right=i;break}}else this.c=i}for(let i=c.length-1;i>=0;i--){const n=c[i][1];n.updateHeight();const o=n.balanceFactor();if(o>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),c[i][1]=n.rotateLeft()):o<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),c[i][1]=n.rotateRight()),i>0)switch(c[i-1][0]){case-1:c[i-1][1].left=c[i][1];break;case 1:c[i-1][1].right=c[i][1];break;case 0:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const S=this.b.reset(y);let p=this.c,c;for(;p;){const s=S.cmp(p.segment);if(s>0)p=p.left;else if(s<0)p=p.right;else if(S.hasNext())S.next(),c=p.value||c,p=p.mid;else break}return p&&p.value||c}findSuperstr(y){return this.g(y,!1)}g(y,S){const p=this.b.reset(y);let c=this.c;for(;c;){const s=p.cmp(c.segment);if(s>0)c=c.left;else if(s<0)c=c.right;else if(p.hasNext())p.next(),c=c.mid;else return c.mid?this.h(c.mid):S?c.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[S,p]of this)y(p,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const S=[];return this.j(y,S),S[Symbol.iterator]()}j(y,S){y&&(y.left&&this.j(y.left,S),y.value&&S.push([y.key,y.value]),y.mid&&this.j(y.mid,S),y.right&&this.j(y.right,S))}_isBalanced(){const y=S=>{if(!S)return!0;const p=S.balanceFactor();return p<-1||p>1?!1:y(S.left)&&y(S.right)};return y(this.c)}}e.$Yh=P}),define(ke[18],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=void 0;function I(a){return typeof a=="string"}e.$zf=I;function F(a){return Array.isArray(a)&&a.every(t=>I(t))}e.$Af=F;function m(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Bf=m;function L(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Cf=L;function R(a){return typeof a=="number"&&!isNaN(a)}e.$Df=R;function w(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Ef=w;function E(a){return a===!0||a===!1}e.$Ff=E;function g(a){return typeof a>"u"}e.$Gf=g;function A(a){return!P(a)}e.$Hf=A;function P(a){return g(a)||a===null}e.$If=P;function f(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Jf=f;function y(a){if(P(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Kf=y;function S(...a){const t=[];for(let r=0;r<a.length;r++){const d=a[r];if(P(d))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(d)}return t}e.$Lf=S;const p=Object.prototype.hasOwnProperty;function c(a){if(!m(a))return!1;for(const t in a)if(p.call(a,t))return!1;return!0}e.$Mf=c;function s(a){return typeof a=="function"}e.$Nf=s;function i(...a){return a.length>0&&a.every(s)}e.$Of=i;function n(a,t){const r=Math.min(a.length,t.length);for(let d=0;d<r;d++)o(a[d],t[d])}e.$Pf=n;function o(a,t){if(I(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(a instanceof t)return}catch{}if(!P(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Qf=o}),define(ke[79],Se([1,0,18]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=void 0;const F=Object.create(null);function m(w,E){if((0,I.$zf)(E)){const g=F[E];if(g===void 0)throw new Error(`${w} references an unknown codicon: ${E}`);E=g}return F[w]=E,{id:w}}function L(){return F}e.$Vj=L;function R(){return Object.values(e.$Xj)}e.$Wj=R,e.$Xj={add:m("add",6e4),plus:m("plus",6e4),gistNew:m("gist-new",6e4),repoCreate:m("repo-create",6e4),lightbulb:m("lightbulb",60001),lightBulb:m("light-bulb",60001),repo:m("repo",60002),repoDelete:m("repo-delete",60002),gistFork:m("gist-fork",60003),repoForked:m("repo-forked",60003),gitPullRequest:m("git-pull-request",60004),gitPullRequestAbandoned:m("git-pull-request-abandoned",60004),recordKeys:m("record-keys",60005),keyboard:m("keyboard",60005),tag:m("tag",60006),tagAdd:m("tag-add",60006),tagRemove:m("tag-remove",60006),gitPullRequestLabel:m("git-pull-request-label",60006),person:m("person",60007),personFollow:m("person-follow",60007),personOutline:m("person-outline",60007),personFilled:m("person-filled",60007),gitBranch:m("git-branch",60008),gitBranchCreate:m("git-branch-create",60008),gitBranchDelete:m("git-branch-delete",60008),sourceControl:m("source-control",60008),mirror:m("mirror",60009),mirrorPublic:m("mirror-public",60009),star:m("star",60010),starAdd:m("star-add",60010),starDelete:m("star-delete",60010),starEmpty:m("star-empty",60010),comment:m("comment",60011),commentAdd:m("comment-add",60011),alert:m("alert",60012),warning:m("warning",60012),search:m("search",60013),searchSave:m("search-save",60013),logOut:m("log-out",60014),signOut:m("sign-out",60014),logIn:m("log-in",60015),signIn:m("sign-in",60015),eye:m("eye",60016),eyeUnwatch:m("eye-unwatch",60016),eyeWatch:m("eye-watch",60016),circleFilled:m("circle-filled",60017),primitiveDot:m("primitive-dot",60017),closeDirty:m("close-dirty",60017),debugBreakpoint:m("debug-breakpoint",60017),debugBreakpointDisabled:m("debug-breakpoint-disabled",60017),debugHint:m("debug-hint",60017),primitiveSquare:m("primitive-square",60018),edit:m("edit",60019),pencil:m("pencil",60019),info:m("info",60020),issueOpened:m("issue-opened",60020),gistPrivate:m("gist-private",60021),gitForkPrivate:m("git-fork-private",60021),lock:m("lock",60021),mirrorPrivate:m("mirror-private",60021),close:m("close",60022),removeClose:m("remove-close",60022),x:m("x",60022),repoSync:m("repo-sync",60023),sync:m("sync",60023),clone:m("clone",60024),desktopDownload:m("desktop-download",60024),beaker:m("beaker",60025),microscope:m("microscope",60025),vm:m("vm",60026),deviceDesktop:m("device-desktop",60026),file:m("file",60027),fileText:m("file-text",60027),more:m("more",60028),ellipsis:m("ellipsis",60028),kebabHorizontal:m("kebab-horizontal",60028),mailReply:m("mail-reply",60029),reply:m("reply",60029),organization:m("organization",60030),organizationFilled:m("organization-filled",60030),organizationOutline:m("organization-outline",60030),newFile:m("new-file",60031),fileAdd:m("file-add",60031),newFolder:m("new-folder",60032),fileDirectoryCreate:m("file-directory-create",60032),trash:m("trash",60033),trashcan:m("trashcan",60033),history:m("history",60034),clock:m("clock",60034),folder:m("folder",60035),fileDirectory:m("file-directory",60035),symbolFolder:m("symbol-folder",60035),logoGithub:m("logo-github",60036),markGithub:m("mark-github",60036),github:m("github",60036),terminal:m("terminal",60037),console:m("console",60037),repl:m("repl",60037),zap:m("zap",60038),symbolEvent:m("symbol-event",60038),error:m("error",60039),stop:m("stop",60039),variable:m("variable",60040),symbolVariable:m("symbol-variable",60040),array:m("array",60042),symbolArray:m("symbol-array",60042),symbolModule:m("symbol-module",60043),symbolPackage:m("symbol-package",60043),symbolNamespace:m("symbol-namespace",60043),symbolObject:m("symbol-object",60043),symbolMethod:m("symbol-method",60044),symbolFunction:m("symbol-function",60044),symbolConstructor:m("symbol-constructor",60044),symbolBoolean:m("symbol-boolean",60047),symbolNull:m("symbol-null",60047),symbolNumeric:m("symbol-numeric",60048),symbolNumber:m("symbol-number",60048),symbolStructure:m("symbol-structure",60049),symbolStruct:m("symbol-struct",60049),symbolParameter:m("symbol-parameter",60050),symbolTypeParameter:m("symbol-type-parameter",60050),symbolKey:m("symbol-key",60051),symbolText:m("symbol-text",60051),symbolReference:m("symbol-reference",60052),goToFile:m("go-to-file",60052),symbolEnum:m("symbol-enum",60053),symbolValue:m("symbol-value",60053),symbolRuler:m("symbol-ruler",60054),symbolUnit:m("symbol-unit",60054),activateBreakpoints:m("activate-breakpoints",60055),archive:m("archive",60056),arrowBoth:m("arrow-both",60057),arrowDown:m("arrow-down",60058),arrowLeft:m("arrow-left",60059),arrowRight:m("arrow-right",60060),arrowSmallDown:m("arrow-small-down",60061),arrowSmallLeft:m("arrow-small-left",60062),arrowSmallRight:m("arrow-small-right",60063),arrowSmallUp:m("arrow-small-up",60064),arrowUp:m("arrow-up",60065),bell:m("bell",60066),bold:m("bold",60067),book:m("book",60068),bookmark:m("bookmark",60069),debugBreakpointConditionalUnverified:m("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:m("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:m("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:m("debug-breakpoint-data-unverified",60072),debugBreakpointData:m("debug-breakpoint-data",60073),debugBreakpointDataDisabled:m("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:m("debug-breakpoint-log-unverified",60074),debugBreakpointLog:m("debug-breakpoint-log",60075),debugBreakpointLogDisabled:m("debug-breakpoint-log-disabled",60075),briefcase:m("briefcase",60076),broadcast:m("broadcast",60077),browser:m("browser",60078),bug:m("bug",60079),calendar:m("calendar",60080),caseSensitive:m("case-sensitive",60081),check:m("check",60082),checklist:m("checklist",60083),chevronDown:m("chevron-down",60084),dropDownButton:m("drop-down-button",60084),chevronLeft:m("chevron-left",60085),chevronRight:m("chevron-right",60086),chevronUp:m("chevron-up",60087),chromeClose:m("chrome-close",60088),chromeMaximize:m("chrome-maximize",60089),chromeMinimize:m("chrome-minimize",60090),chromeRestore:m("chrome-restore",60091),circle:m("circle",60092),circleOutline:m("circle-outline",60092),debugBreakpointUnverified:m("debug-breakpoint-unverified",60092),circleSlash:m("circle-slash",60093),circuitBoard:m("circuit-board",60094),clearAll:m("clear-all",60095),clippy:m("clippy",60096),closeAll:m("close-all",60097),cloudDownload:m("cloud-download",60098),cloudUpload:m("cloud-upload",60099),code:m("code",60100),collapseAll:m("collapse-all",60101),colorMode:m("color-mode",60102),commentDiscussion:m("comment-discussion",60103),compareChanges:m("compare-changes",60157),creditCard:m("credit-card",60105),dash:m("dash",60108),dashboard:m("dashboard",60109),database:m("database",60110),debugContinue:m("debug-continue",60111),debugDisconnect:m("debug-disconnect",60112),debugPause:m("debug-pause",60113),debugRestart:m("debug-restart",60114),debugStart:m("debug-start",60115),debugStepInto:m("debug-step-into",60116),debugStepOut:m("debug-step-out",60117),debugStepOver:m("debug-step-over",60118),debugStop:m("debug-stop",60119),debug:m("debug",60120),deviceCameraVideo:m("device-camera-video",60121),deviceCamera:m("device-camera",60122),deviceMobile:m("device-mobile",60123),diffAdded:m("diff-added",60124),diffIgnored:m("diff-ignored",60125),diffModified:m("diff-modified",60126),diffRemoved:m("diff-removed",60127),diffRenamed:m("diff-renamed",60128),diff:m("diff",60129),discard:m("discard",60130),editorLayout:m("editor-layout",60131),emptyWindow:m("empty-window",60132),exclude:m("exclude",60133),extensions:m("extensions",60134),eyeClosed:m("eye-closed",60135),fileBinary:m("file-binary",60136),fileCode:m("file-code",60137),fileMedia:m("file-media",60138),filePdf:m("file-pdf",60139),fileSubmodule:m("file-submodule",60140),fileSymlinkDirectory:m("file-symlink-directory",60141),fileSymlinkFile:m("file-symlink-file",60142),fileZip:m("file-zip",60143),files:m("files",60144),filter:m("filter",60145),flame:m("flame",60146),foldDown:m("fold-down",60147),foldUp:m("fold-up",60148),fold:m("fold",60149),folderActive:m("folder-active",60150),folderOpened:m("folder-opened",60151),gear:m("gear",60152),gift:m("gift",60153),gistSecret:m("gist-secret",60154),gist:m("gist",60155),gitCommit:m("git-commit",60156),gitCompare:m("git-compare",60157),gitMerge:m("git-merge",60158),githubAction:m("github-action",60159),githubAlt:m("github-alt",60160),globe:m("globe",60161),grabber:m("grabber",60162),graph:m("graph",60163),gripper:m("gripper",60164),heart:m("heart",60165),home:m("home",60166),horizontalRule:m("horizontal-rule",60167),hubot:m("hubot",60168),inbox:m("inbox",60169),issueClosed:m("issue-closed",60324),issueReopened:m("issue-reopened",60171),issues:m("issues",60172),italic:m("italic",60173),jersey:m("jersey",60174),json:m("json",60175),bracket:m("bracket",60175),kebabVertical:m("kebab-vertical",60176),key:m("key",60177),law:m("law",60178),lightbulbAutofix:m("lightbulb-autofix",60179),linkExternal:m("link-external",60180),link:m("link",60181),listOrdered:m("list-ordered",60182),listUnordered:m("list-unordered",60183),liveShare:m("live-share",60184),loading:m("loading",60185),location:m("location",60186),mailRead:m("mail-read",60187),mail:m("mail",60188),markdown:m("markdown",60189),megaphone:m("megaphone",60190),mention:m("mention",60191),milestone:m("milestone",60192),gitPullRequestMilestone:m("git-pull-request-milestone",60192),mortarBoard:m("mortar-board",60193),move:m("move",60194),multipleWindows:m("multiple-windows",60195),mute:m("mute",60196),noNewline:m("no-newline",60197),note:m("note",60198),octoface:m("octoface",60199),openPreview:m("open-preview",60200),package:m("package",60201),paintcan:m("paintcan",60202),pin:m("pin",60203),play:m("play",60204),run:m("run",60204),plug:m("plug",60205),preserveCase:m("preserve-case",60206),preview:m("preview",60207),project:m("project",60208),pulse:m("pulse",60209),question:m("question",60210),quote:m("quote",60211),radioTower:m("radio-tower",60212),reactions:m("reactions",60213),references:m("references",60214),refresh:m("refresh",60215),regex:m("regex",60216),remoteExplorer:m("remote-explorer",60217),remote:m("remote",60218),remove:m("remove",60219),replaceAll:m("replace-all",60220),replace:m("replace",60221),repoClone:m("repo-clone",60222),repoForcePush:m("repo-force-push",60223),repoPull:m("repo-pull",60224),repoPush:m("repo-push",60225),report:m("report",60226),requestChanges:m("request-changes",60227),rocket:m("rocket",60228),rootFolderOpened:m("root-folder-opened",60229),rootFolder:m("root-folder",60230),rss:m("rss",60231),ruby:m("ruby",60232),saveAll:m("save-all",60233),saveAs:m("save-as",60234),save:m("save",60235),screenFull:m("screen-full",60236),screenNormal:m("screen-normal",60237),searchStop:m("search-stop",60238),server:m("server",60240),settingsGear:m("settings-gear",60241),settings:m("settings",60242),shield:m("shield",60243),smiley:m("smiley",60244),sortPrecedence:m("sort-precedence",60245),splitHorizontal:m("split-horizontal",60246),splitVertical:m("split-vertical",60247),squirrel:m("squirrel",60248),starFull:m("star-full",60249),starHalf:m("star-half",60250),symbolClass:m("symbol-class",60251),symbolColor:m("symbol-color",60252),symbolCustomColor:m("symbol-customcolor",60252),symbolConstant:m("symbol-constant",60253),symbolEnumMember:m("symbol-enum-member",60254),symbolField:m("symbol-field",60255),symbolFile:m("symbol-file",60256),symbolInterface:m("symbol-interface",60257),symbolKeyword:m("symbol-keyword",60258),symbolMisc:m("symbol-misc",60259),symbolOperator:m("symbol-operator",60260),symbolProperty:m("symbol-property",60261),wrench:m("wrench",60261),wrenchSubaction:m("wrench-subaction",60261),symbolSnippet:m("symbol-snippet",60262),tasklist:m("tasklist",60263),telescope:m("telescope",60264),textSize:m("text-size",60265),threeBars:m("three-bars",60266),thumbsdown:m("thumbsdown",60267),thumbsup:m("thumbsup",60268),tools:m("tools",60269),triangleDown:m("triangle-down",60270),triangleLeft:m("triangle-left",60271),triangleRight:m("triangle-right",60272),triangleUp:m("triangle-up",60273),twitter:m("twitter",60274),unfold:m("unfold",60275),unlock:m("unlock",60276),unmute:m("unmute",60277),unverified:m("unverified",60278),verified:m("verified",60279),versions:m("versions",60280),vmActive:m("vm-active",60281),vmOutline:m("vm-outline",60282),vmRunning:m("vm-running",60283),watch:m("watch",60284),whitespace:m("whitespace",60285),wholeWord:m("whole-word",60286),window:m("window",60287),wordWrap:m("word-wrap",60288),zoomIn:m("zoom-in",60289),zoomOut:m("zoom-out",60290),listFilter:m("list-filter",60291),listFlat:m("list-flat",60292),listSelection:m("list-selection",60293),selection:m("selection",60293),listTree:m("list-tree",60294),debugBreakpointFunctionUnverified:m("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:m("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:m("debug-breakpoint-function-disabled",60296),debugStackframeActive:m("debug-stackframe-active",60297),circleSmallFilled:m("circle-small-filled",60298),debugStackframeDot:m("debug-stackframe-dot",60298),debugStackframe:m("debug-stackframe",60299),debugStackframeFocused:m("debug-stackframe-focused",60299),debugBreakpointUnsupported:m("debug-breakpoint-unsupported",60300),symbolString:m("symbol-string",60301),debugReverseContinue:m("debug-reverse-continue",60302),debugStepBack:m("debug-step-back",60303),debugRestartFrame:m("debug-restart-frame",60304),callIncoming:m("call-incoming",60306),callOutgoing:m("call-outgoing",60307),menu:m("menu",60308),expandAll:m("expand-all",60309),feedback:m("feedback",60310),gitPullRequestReviewer:m("git-pull-request-reviewer",60310),groupByRefType:m("group-by-ref-type",60311),ungroupByRefType:m("ungroup-by-ref-type",60312),account:m("account",60313),gitPullRequestAssignee:m("git-pull-request-assignee",60313),bellDot:m("bell-dot",60314),debugConsole:m("debug-console",60315),library:m("library",60316),output:m("output",60317),runAll:m("run-all",60318),syncIgnored:m("sync-ignored",60319),pinned:m("pinned",60320),githubInverted:m("github-inverted",60321),debugAlt:m("debug-alt",60305),serverProcess:m("server-process",60322),serverEnvironment:m("server-environment",60323),pass:m("pass",60324),stopCircle:m("stop-circle",60325),playCircle:m("play-circle",60326),record:m("record",60327),debugAltSmall:m("debug-alt-small",60328),vmConnect:m("vm-connect",60329),cloud:m("cloud",60330),merge:m("merge",60331),exportIcon:m("export",60332),graphLeft:m("graph-left",60333),magnet:m("magnet",60334),notebook:m("notebook",60335),redo:m("redo",60336),checkAll:m("check-all",60337),pinnedDirty:m("pinned-dirty",60338),passFilled:m("pass-filled",60339),circleLargeFilled:m("circle-large-filled",60340),circleLarge:m("circle-large",60341),circleLargeOutline:m("circle-large-outline",60341),combine:m("combine",60342),gather:m("gather",60342),table:m("table",60343),variableGroup:m("variable-group",60344),typeHierarchy:m("type-hierarchy",60345),typeHierarchySub:m("type-hierarchy-sub",60346),typeHierarchySuper:m("type-hierarchy-super",60347),gitPullRequestCreate:m("git-pull-request-create",60348),runAbove:m("run-above",60349),runBelow:m("run-below",60350),notebookTemplate:m("notebook-template",60351),debugRerun:m("debug-rerun",60352),workspaceTrusted:m("workspace-trusted",60353),workspaceUntrusted:m("workspace-untrusted",60354),workspaceUnspecified:m("workspace-unspecified",60355),terminalCmd:m("terminal-cmd",60356),terminalDebian:m("terminal-debian",60357),terminalLinux:m("terminal-linux",60358),terminalPowershell:m("terminal-powershell",60359),terminalTmux:m("terminal-tmux",60360),terminalUbuntu:m("terminal-ubuntu",60361),terminalBash:m("terminal-bash",60362),arrowSwap:m("arrow-swap",60363),copy:m("copy",60364),personAdd:m("person-add",60365),filterFilled:m("filter-filled",60366),wand:m("wand",60367),debugLineByLine:m("debug-line-by-line",60368),inspect:m("inspect",60369),layers:m("layers",60370),layersDot:m("layers-dot",60371),layersActive:m("layers-active",60372),compass:m("compass",60373),compassDot:m("compass-dot",60374),compassActive:m("compass-active",60375),azure:m("azure",60376),issueDraft:m("issue-draft",60377),gitPullRequestClosed:m("git-pull-request-closed",60378),gitPullRequestDraft:m("git-pull-request-draft",60379),debugAll:m("debug-all",60380),debugCoverage:m("debug-coverage",60381),runErrors:m("run-errors",60382),folderLibrary:m("folder-library",60383),debugContinueSmall:m("debug-continue-small",60384),beakerStop:m("beaker-stop",60385),graphLine:m("graph-line",60386),graphScatter:m("graph-scatter",60387),pieChart:m("pie-chart",60388),bracketDot:m("bracket-dot",60389),bracketError:m("bracket-error",60390),lockSmall:m("lock-small",60391),azureDevops:m("azure-devops",60392),verifiedFilled:m("verified-filled",60393),newLine:m("newline",60394),layout:m("layout",60395),layoutActivitybarLeft:m("layout-activitybar-left",60396),layoutActivitybarRight:m("layout-activitybar-right",60397),layoutPanelLeft:m("layout-panel-left",60398),layoutPanelCenter:m("layout-panel-center",60399),layoutPanelJustify:m("layout-panel-justify",60400),layoutPanelRight:m("layout-panel-right",60401),layoutPanel:m("layout-panel",60402),layoutSidebarLeft:m("layout-sidebar-left",60403),layoutSidebarRight:m("layout-sidebar-right",60404),layoutStatusbar:m("layout-statusbar",60405),layoutMenubar:m("layout-menubar",60406),layoutCentered:m("layout-centered",60407),layoutSidebarRightOff:m("layout-sidebar-right-off",60416),layoutPanelOff:m("layout-panel-off",60417),layoutSidebarLeftOff:m("layout-sidebar-left-off",60418),target:m("target",60408),indent:m("indent",60409),recordSmall:m("record-small",60410),errorSmall:m("error-small",60411),arrowCircleDown:m("arrow-circle-down",60412),arrowCircleLeft:m("arrow-circle-left",60413),arrowCircleRight:m("arrow-circle-right",60414),arrowCircleUp:m("arrow-circle-up",60415),heartFilled:m("heart-filled",60420),map:m("map",60421),mapFilled:m("map-filled",60422),circleSmall:m("circle-small",60423),bellSlash:m("bell-slash",60424),bellSlashDot:m("bell-slash-dot",60425),commentUnresolved:m("comment-unresolved",60426),gitPullRequestGoToChanges:m("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:m("git-pull-request-new-changes",60428),searchFuzzy:m("search-fuzzy",60429),commentDraft:m("comment-draft",60430),send:m("send",60431),sparkle:m("sparkle",60432),insert:m("insert",60433),mic:m("mic",60434),thumbsDownFilled:m("thumbsdown-filled",60435),thumbsUpFilled:m("thumbsup-filled",60436),coffee:m("coffee",60437),snake:m("snake",60438),game:m("game",60439),vr:m("vr",60440),chip:m("chip",60441),piano:m("piano",60442),music:m("music",60443),micFilled:m("mic-filled",60444),gitFetch:m("git-fetch",60445),copilot:m("copilot",60446),dialogError:m("dialog-error","error"),dialogWarning:m("dialog-warning","warning"),dialogInfo:m("dialog-info","info"),dialogClose:m("dialog-close","close"),treeItemExpanded:m("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:m("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:m("tree-filter-on-type-off","list-selection"),treeFilterClear:m("tree-filter-clear","close"),treeItemLoading:m("tree-item-loading","loading"),menuSelection:m("menu-selection","check"),menuSubmenu:m("menu-submenu","chevron-right"),menuBarMore:m("menubar-more","more"),scrollbarButtonLeft:m("scrollbar-button-left","triangle-left"),scrollbarButtonRight:m("scrollbar-button-right","triangle-right"),scrollbarButtonUp:m("scrollbar-button-up","triangle-up"),scrollbarButtonDown:m("scrollbar-button-down","triangle-down"),toolBarMore:m("toolbar-more","more"),quickInputBack:m("quick-input-back","arrow-left")}}),define(ke[24],Se([1,0,18]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=void 0;function F(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const i=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([n,o])=>{i[n]=o&&typeof o=="object"?F(o):o}),i}e.$0m=F;function m(s){if(!s||typeof s!="object")return s;const i=[s];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const o in n)if(L.call(n,o)){const a=n[o];typeof a=="object"&&!Object.isFrozen(a)&&!(0,I.$Cf)(a)&&i.push(a)}}return s}e.$$m=m;const L=Object.prototype.hasOwnProperty;function R(s,i){return w(s,i,new Set)}e.$_m=R;function w(s,i,n){if((0,I.$If)(s))return s;const o=i(s);if(typeof o<"u")return o;if(Array.isArray(s)){const a=[];for(const t of s)a.push(w(t,i,n));return a}if((0,I.$Bf)(s)){if(n.has(s))throw new Error("Cannot clone recursive data-structure");n.add(s);const a={};for(const t in s)L.call(s,t)&&(a[t]=w(s[t],i,n));return n.delete(s),a}return s}function E(s,i,n=!0){return(0,I.$Bf)(s)?((0,I.$Bf)(i)&&Object.keys(i).forEach(o=>{o in s?n&&((0,I.$Bf)(s[o])&&(0,I.$Bf)(i[o])?E(s[o],i[o],n):s[o]=i[o]):s[o]=i[o]}),s):i}e.$an=E;function g(s,i){if(s===i)return!0;if(s==null||i===null||i===void 0||typeof s!=typeof i||typeof s!="object"||Array.isArray(s)!==Array.isArray(i))return!1;let n,o;if(Array.isArray(s)){if(s.length!==i.length)return!1;for(n=0;n<s.length;n++)if(!g(s[n],i[n]))return!1}else{const a=[];for(o in s)a.push(o);a.sort();const t=[];for(o in i)t.push(o);if(t.sort(),!g(a,t))return!1;for(n=0;n<a.length;n++)if(!g(s[a[n]],i[a[n]]))return!1}return!0}e.$bn=g;function A(s){const i=new Set;return JSON.stringify(s,(n,o)=>{if((0,I.$Bf)(o)||Array.isArray(o)){if(i.has(o))return"[Circular]";i.add(o)}return o})}e.$cn=A;function P(s,i){const n=Object.create(null);return!s||!i||Object.keys(i).forEach(a=>{const t=s[a],r=i[a];g(t,r)||(n[a]=r)}),n}e.$dn=P;function f(s,i){const n=i.toLowerCase(),o=Object.keys(s).find(a=>a.toLowerCase()===n);return o?s[o]:s[i]}e.$en=f;function y(s,i){const n=Object.create(null);for(const[o,a]of Object.entries(s))i(o,a)&&(n[o]=a);return n}e.$fn=y;function S(s){let i=[];for(;Object.prototype!==s;)i=i.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return i}e.$gn=S;function p(s){const i=[];for(const n of S(s))typeof s[n]=="function"&&i.push(n);return i}e.$hn=p;function c(s,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},o={};for(const a of s)o[a]=n(a);return o}e.$in=c}),define(ke[61],Se([1,0,79]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Yj=e.ThemeColor=void 0;var F;(function(R){function w(E){return E&&typeof E=="object"&&typeof E.id=="string"}R.isThemeColor=w})(F||(e.ThemeColor=F={}));function m(R){return{id:R}}e.$Yj=m;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function E(i){const n=w.exec(i.id);if(!n)return E(I.$Xj.error);const[,o,a]=n,t=["codicon","codicon-"+o];return a&&t.push("codicon-modifier-"+a.substring(1)),t}R.asClassNameArray=E;function g(i){return E(i).join(" ")}R.asClassName=g;function A(i){return"."+E(i).join(".")}R.asCSSSelector=A;function P(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||F.isThemeColor(i.color))}R.isThemeIcon=P;const f=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function y(i){const n=f.exec(i);if(!n)return;const[,o]=n;return{id:o}}R.fromString=y;function S(i){return{id:i}}R.fromId=S;function p(i,n){let o=i.id;const a=o.lastIndexOf("~");return a!==-1&&(o=o.substring(0,a)),n&&(o=`${o}~${n}`),{id:o}}R.modify=p;function c(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=c;function s(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=s})(L||(e.ThemeIcon=L={}))}),define(ke[164],Se([1,0,124,13,61]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=void 0;const L="$(",R=new RegExp(`\\$\\(${m.ThemeIcon.iconNameExpression}(?:${m.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${R.source}`,"g");function E(s){return s.replace(w,(i,n)=>n?i:`\\${i}`)}e.$Zj=E;const g=new RegExp(`\\\\${R.source}`,"g");function A(s){return s.replace(g,i=>`\\${i}`)}e.$1j=A;const P=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function f(s){return s.indexOf(L)===-1?s:s.replace(P,(i,n,o,a)=>o?i:n||a||"")}e.$2j=f;function y(s){return s?s.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$3j=y;const S=new RegExp(`\\$\\(${m.ThemeIcon.iconNameCharacter}+\\)`,"g");function p(s){S.lastIndex=0;let i="";const n=[];let o=0;for(;;){const a=S.lastIndex,t=S.exec(s),r=s.substring(a,t?.index);if(r.length>0){i+=r;for(let d=0;d<r.length;d++)n.push(o)}if(!t)break;o+=t[0].length}return{text:i,iconOffsets:n}}e.$4j=p;function c(s,i,n=!1){const{text:o,iconOffsets:a}=i;if(!a||a.length===0)return(0,I.$Mj)(s,o,n);const t=(0,F.$Ke)(o," "),r=o.length-t.length,d=(0,I.$Mj)(s,t,n);if(d)for(const u of d){const l=a[u.start+r]+r;u.start+=l,u.end+=l}return d}e.$5j=c}),define(ke[125],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.$Ae=e.Constants=void 0;var I;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(I||(e.Constants=I={}));function F(L){return L<0?0:L>255?255:L|0}e.$Ae=F;function m(L){return L<0?0:L>4294967295?4294967295:L|0}e.$Be=m}),define(ke[32],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(m){return I.test(m)}e.$eg=F,e.$fg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let m;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?m=crypto.getRandomValues.bind(crypto):m=function(w){for(let E=0;E<w.length;E++)w[E]=Math.floor(Math.random()*256);return w};const L=new Uint8Array(16),R=[];for(let w=0;w<256;w++)R.push(w.toString(16).padStart(2,"0"));return function(){m(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,g="";return g+=R[L[E++]],g+=R[L[E++]],g+=R[L[E++]],g+=R[L[E++]],g+="-",g+=R[L[E++]],g+=R[L[E++]],g+="-",g+=R[L[E++]],g+=R[L[E++]],g+="-",g+=R[L[E++]],g+=R[L[E++]],g+="-",g+=R[L[E++]],g+=R[L[E++]],g+=R[L[E++]],g+=R[L[E++]],g+=R[L[E++]],g+=R[L[E++]],g}}()}),define(ke[165],Se([1,0,19,51,32]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=e.$5s=e.$4s=e.$3s=e.$2s=void 0;function L(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.$2s=L;function R(P,f,y){const S={id:(0,m.$fg)(),name:P,uri:f,data:y};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$3s=R;class w{constructor(){this.a=new Map}get size(){let f=0;for(const y of this.a)f++;return f}has(f){return this.a.has(this.b(f))}matches(f){const y=[...this.a.keys()];return F.Iterable.some(this,([S,p])=>p.asFile())&&y.push("files"),A(E(f),y)}get(f){return this.a.get(this.b(f))?.[0]}append(f,y){const S=this.a.get(f);S?S.push(y):this.a.set(this.b(f),[y])}replace(f,y){this.a.set(this.b(f),[y])}delete(f){this.a.delete(this.b(f))}*[Symbol.iterator](){for(const[f,y]of this.a)for(const S of y)yield[f,S]}b(f){return E(f)}}e.$4s=w;function E(P){return P.toLowerCase()}function g(P,f){return A(E(P),f.map(E))}e.$5s=g;function A(P,f){if(P==="*/*")return f.length>0;if(f.includes(P))return!0;const y=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[S,p,c]=y;return c==="*"?f.some(s=>s.startsWith(p+"/")):!1}e.$6s=Object.freeze({create:P=>(0,I.$Lb)(P.map(f=>f.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$6s.split(P).filter(f=>!f.startsWith("#"))})}),define(ke[166],Se([1,0,62]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=e.$ig=e.$hg=void 0;function F(w,E,g,A=1){let P=!1;return new Promise(f=>{const y=setTimeout(()=>{if(!P)return P=!0,f(0)},g);m(w,E,A,S=>{if(!P)return P=!0,clearTimeout(y),f(S)})})}e.$hg=F;function m(w,E,g,A){if(E===0)return A(0);const P=new I.Socket;P.once("connect",()=>(R(P),m(w+g,E-1,g,A))),P.once("data",()=>{}),P.once("error",f=>(R(P),f.code!=="ECONNREFUSED"?m(w+g,E-1,g,A):A(w))),P.connect(w,"127.0.0.1")}e.$ig={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(w,E,g,A="127.0.0.1"){let P=!1,f,y=1;const S=I.createServer({pauseOnConnect:!0});function p(c,s){P||(P=!0,S.removeAllListeners(),S.close(),f&&clearTimeout(f),s(c))}return new Promise(c=>{f=setTimeout(()=>{p(0,c)},g),S.on("listening",()=>{p(w,c)}),S.on("error",s=>{s&&(s.code==="EADDRINUSE"||s.code==="EACCES")&&y<E?(w++,y++,S.listen(w,A)):p(0,c)}),S.on("close",()=>{p(0,c)}),S.listen(w,A)})}e.$jg=L;function R(w){try{w.removeAllListeners("connect"),w.removeAllListeners("error"),w.end(),w.destroy(),w.unref()}catch(E){console.error(E)}}}),define(ke[126],Se([1,0,125]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=e.$Ts=void 0;class F{constructor(w){const E=(0,I.$Ae)(w);this.c=E,this.a=F.d(E),this.b=new Map}static d(w){const E=new Uint8Array(256);return E.fill(w),E}set(w,E){const g=(0,I.$Ae)(E);w>=0&&w<256?this.a[w]=g:this.b.set(w,g)}get(w){return w>=0&&w<256?this.a[w]:this.b.get(w)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Ts=F;var m;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(m||(m={}));class L{constructor(){this.a=new F(0)}add(w){this.a.set(w,1)}has(w){return this.a.get(w)===1}clear(){return this.a.clear()}}e.$Us=L}),define(ke[167],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.StringEOL=void 0;var I;(function(m){m[m.Unknown=0]="Unknown",m[m.Invalid=3]="Invalid",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function F(m){let L=0,R=0,w=0,E=0;for(let g=0,A=m.length;g<A;g++){const P=m.charCodeAt(g);P===13?(L===0&&(R=g),L++,g+1<A&&m.charCodeAt(g+1)===10?(E|=2,g++):E|=3,w=g+1):P===10&&(E|=1,L===0&&(R=g),L++,w=g+1)}return L===0&&(R=m.length),[L,R,m.length-w,E]}e.$9s=F}),define(ke[53],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0;class I{constructor(m,L){this.lineNumber=m,this.column=L}with(m=this.lineNumber,L=this.column){return m===this.lineNumber&&L===this.column?this:new I(m,L)}delta(m=0,L=0){return this.with(this.lineNumber+m,this.column+L)}equals(m){return I.equals(this,m)}static equals(m,L){return!m&&!L?!0:!!m&&!!L&&m.lineNumber===L.lineNumber&&m.column===L.column}isBefore(m){return I.isBefore(this,m)}static isBefore(m,L){return m.lineNumber<L.lineNumber?!0:L.lineNumber<m.lineNumber?!1:m.column<L.column}isBeforeOrEqual(m){return I.isBeforeOrEqual(this,m)}static isBeforeOrEqual(m,L){return m.lineNumber<L.lineNumber?!0:L.lineNumber<m.lineNumber?!1:m.column<=L.column}static compare(m,L){const R=m.lineNumber|0,w=L.lineNumber|0;if(R===w){const E=m.column|0,g=L.column|0;return E-g}return R-w}clone(){return new I(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(m){return new I(m.lineNumber,m.column)}static isIPosition(m){return m&&typeof m.lineNumber=="number"&&typeof m.column=="number"}}e.$vs=I}),define(ke[29],Se([1,0,53]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=void 0;class F{constructor(L,R,w,E){L>w||L===w&&R>E?(this.startLineNumber=w,this.startColumn=E,this.endLineNumber=L,this.endColumn=R):(this.startLineNumber=L,this.startColumn=R,this.endLineNumber=w,this.endColumn=E)}isEmpty(){return F.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return F.containsPosition(this,L)}static containsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<L.startColumn||R.lineNumber===L.endLineNumber&&R.column>L.endColumn)}static strictContainsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<=L.startColumn||R.lineNumber===L.endLineNumber&&R.column>=L.endColumn)}containsRange(L){return F.containsRange(this,L)}static containsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>L.endColumn)}strictContainsRange(L){return F.strictContainsRange(this,L)}static strictContainsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<=L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>=L.endColumn)}plusRange(L){return F.plusRange(this,L)}static plusRange(L,R){let w,E,g,A;return R.startLineNumber<L.startLineNumber?(w=R.startLineNumber,E=R.startColumn):R.startLineNumber===L.startLineNumber?(w=R.startLineNumber,E=Math.min(R.startColumn,L.startColumn)):(w=L.startLineNumber,E=L.startColumn),R.endLineNumber>L.endLineNumber?(g=R.endLineNumber,A=R.endColumn):R.endLineNumber===L.endLineNumber?(g=R.endLineNumber,A=Math.max(R.endColumn,L.endColumn)):(g=L.endLineNumber,A=L.endColumn),new F(w,E,g,A)}intersectRanges(L){return F.intersectRanges(this,L)}static intersectRanges(L,R){let w=L.startLineNumber,E=L.startColumn,g=L.endLineNumber,A=L.endColumn;const P=R.startLineNumber,f=R.startColumn,y=R.endLineNumber,S=R.endColumn;return w<P?(w=P,E=f):w===P&&(E=Math.max(E,f)),g>y?(g=y,A=S):g===y&&(A=Math.min(A,S)),w>g||w===g&&E>A?null:new F(w,E,g,A)}equalsRange(L){return F.equalsRange(this,L)}static equalsRange(L,R){return!L&&!R?!0:!!L&&!!R&&L.startLineNumber===R.startLineNumber&&L.startColumn===R.startColumn&&L.endLineNumber===R.endLineNumber&&L.endColumn===R.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(L){return new I.$vs(L.endLineNumber,L.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(L){return new I.$vs(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,R){return new F(this.startLineNumber,this.startColumn,L,R)}setStartPosition(L,R){return new F(L,R,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(L){return new F(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(L){return new F(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new F(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,R=L){return new F(L.lineNumber,L.column,R.lineNumber,R.column)}static lift(L){return L?new F(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn)}static areIntersecting(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,R){if(L&&R){const g=L.startLineNumber|0,A=R.startLineNumber|0;if(g===A){const P=L.startColumn|0,f=R.startColumn|0;if(P===f){const y=L.endLineNumber|0,S=R.endLineNumber|0;if(y===S){const p=L.endColumn|0,c=R.endColumn|0;return p-c}return y-S}return P-f}return g-A}return(L?1:0)-(R?1:0)}static compareRangesUsingEnds(L,R){return L.endLineNumber===R.endLineNumber?L.endColumn===R.endColumn?L.startLineNumber===R.startLineNumber?L.startColumn-R.startColumn:L.startLineNumber-R.startLineNumber:L.endColumn-R.endColumn:L.endLineNumber-R.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$ws=F}),define(ke[168],Se([1,0,29]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0;class F{static insert(L,R){return{range:new I.$ws(L.lineNumber,L.column,L.lineNumber,L.column),text:R,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,R){return{range:L,text:R}}static replaceMove(L,R){return{range:L,text:R,forceMoveMarkers:!0}}}e.$xs=F}),define(ke[169],Se([1,0,53,29]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.SelectionDirection=void 0;var m;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(m||(e.SelectionDirection=m={}));class L extends F.$ws{constructor(w,E,g,A){super(w,E,g,A),this.selectionStartLineNumber=w,this.selectionStartColumn=E,this.positionLineNumber=g,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(w){return L.selectionsEqual(this,w)}static selectionsEqual(w,E){return w.selectionStartLineNumber===E.selectionStartLineNumber&&w.selectionStartColumn===E.selectionStartColumn&&w.positionLineNumber===E.positionLineNumber&&w.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(w,E){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,w,E):new L(w,E,this.startLineNumber,this.startColumn)}getPosition(){return new I.$vs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new I.$vs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(w,E){return this.getDirection()===0?new L(w,E,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,w,E)}static fromPositions(w,E=w){return new L(w.lineNumber,w.column,E.lineNumber,E.column)}static fromRange(w,E){return E===0?new L(w.startLineNumber,w.startColumn,w.endLineNumber,w.endColumn):new L(w.endLineNumber,w.endColumn,w.startLineNumber,w.startColumn)}static liftSelection(w){return new L(w.selectionStartLineNumber,w.selectionStartColumn,w.positionLineNumber,w.positionColumn)}static selectionsArrEqual(w,E){if(w&&!E||!w&&E)return!1;if(!w&&!E)return!0;if(w.length!==E.length)return!1;for(let g=0,A=w.length;g<A;g++)if(!this.selectionsEqual(w[g],E[g]))return!1;return!0}static isISelection(w){return w&&typeof w.selectionStartLineNumber=="number"&&typeof w.selectionStartColumn=="number"&&typeof w.positionLineNumber=="number"&&typeof w.positionColumn=="number"}static createWithDirection(w,E,g,A,P){return P===0?new L(w,E,g,A):new L(g,A,w,E)}}e.$ys=L}),define(ke[170],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=void 0,e.$6r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[171],Se([1,0,126]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.$Vs=e.WordCharacterClass=void 0;var F;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class m extends I.$Ts{constructor(w){super(0);for(let E=0,g=w.length;E<g;E++)this.set(w.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.$Vs=m;function L(R){const w={};return E=>(w.hasOwnProperty(E)||(w[E]=R(E)),w[E])}e.$Ws=L(R=>new m(R))}),define(ke[127],Se([1,0,51,3,76]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.$9r=e.$8r=e.$7r=void 0,e.$7r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(P=""){let f="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$7r)P.indexOf(y)>=0||(f+="\\"+y);return f+="\\s]+)",new RegExp(f,"g")}e.$8r=L();function R(P){let f=e.$8r;if(P&&P instanceof RegExp)if(P.global)f=P;else{let y="g";P.ignoreCase&&(y+="i"),P.multiline&&(y+="m"),P.unicode&&(y+="u"),f=new RegExp(P.source,y)}return f.lastIndex=0,f}e.$9r=R;const w=new m.$1c;w.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(P){const f=w.unshift(P);return(0,F.$Pc)(f)}e.$0r=E;function g(P,f,y,S,p){if(p||(p=I.Iterable.first(w)),y.length>p.maxLen){let o=P-p.maxLen/2;return o<0?o=0:S+=o,y=y.substring(o,P+p.maxLen/2),g(P,f,y,S,p)}const c=Date.now(),s=P-1-S;let i=-1,n=null;for(let o=1;!(Date.now()-c>=p.timeBudget);o++){const a=s-p.windowSize*o;f.lastIndex=Math.max(0,a);const t=A(f,y,s,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const o={word:n[0],startColumn:S+1+n.index,endColumn:S+1+n.index+n[0].length};return f.lastIndex=0,o}return null}e.$$r=g;function A(P,f,y,S){let p;for(;p=P.exec(f);){const c=p.index||0;if(c<=y&&P.lastIndex>=y)return p;if(S>0&&c>S)return null}return null}}),define(ke[172],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=e.IndentAction=void 0;var I;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class F{constructor(w){if(this.e=null,this.f=!1,this.open=w.open,this.close=w.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(w.notIn))for(let E=0,g=w.notIn.length;E<g;E++)switch(w.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(w){switch(w){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(w,E){if(w.getTokenCount()===0)return!0;const g=w.findTokenIndexAtOffset(E-2),A=w.getStandardTokenType(g);return this.isOK(A)}g(w,E){for(let g=w;g<=E;g++){const A=String.fromCharCode(g);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$st=F;class m{constructor(w){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of w)L(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),L(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),L(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),L(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&L(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$tt=m;function L(R,w,E){R.has(w)?R.get(w).push(E):R.set(w,[E])}}),define(ke[173],Se([1,0,126]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DZ=e.$CZ=e.$BZ=e.State=void 0;var F;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class m{constructor(S,p,c){const s=new Uint8Array(S*p);for(let i=0,n=S*p;i<n;i++)s[i]=c;this.a=s,this.rows=S,this.cols=p}get(S,p){return this.a[S*this.cols+p]}set(S,p,c){this.a[S*this.cols+p]=c}}class L{constructor(S){let p=0,c=0;for(let i=0,n=S.length;i<n;i++){const[o,a,t]=S[i];a>p&&(p=a),o>c&&(c=o),t>c&&(c=t)}p++,c++;const s=new m(c,p,0);for(let i=0,n=S.length;i<n;i++){const[o,a,t]=S[i];s.set(o,a,t)}this.a=s,this.b=p}nextState(S,p){return p<0||p>=this.b?0:this.a.get(S,p)}}e.$BZ=L;let R=null;function w(){return R===null&&(R=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var E;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let g=null;function A(){if(g===null){g=new I.$Ts(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<y.length;p++)g.set(y.charCodeAt(p),1);const S=".,;:";for(let p=0;p<S.length;p++)g.set(S.charCodeAt(p),2)}return g}class P{static a(S,p,c,s,i){let n=i-1;do{const o=p.charCodeAt(n);if(S.get(o)!==2)break;n--}while(n>s);if(s>0){const o=p.charCodeAt(s-1),a=p.charCodeAt(n);(o===40&&a===41||o===91&&a===93||o===123&&a===125)&&n--}return{range:{startLineNumber:c,startColumn:s+1,endLineNumber:c,endColumn:n+2},url:p.substring(s,n+1)}}static computeLinks(S,p=w()){const c=A(),s=[];for(let i=1,n=S.getLineCount();i<=n;i++){const o=S.getLineContent(i),a=o.length;let t=0,r=0,d=0,u=1,l=!1,h=!1,k=!1,D=!1;for(;t<a;){let $=!1;const b=o.charCodeAt(t);if(u===13){let v;switch(b){case 40:l=!0,v=0;break;case 41:v=l?0:1;break;case 91:k=!0,h=!0,v=0;break;case 93:k=!1,v=h?0:1;break;case 123:D=!0,v=0;break;case 125:v=D?0:1;break;case 39:case 34:case 96:d===b?v=1:d===39||d===34||d===96?v=0:v=1;break;case 42:v=d===42?1:0;break;case 124:v=d===124?1:0;break;case 32:v=k?0:1;break;default:v=c.get(b)}v===1&&(s.push(P.a(c,o,i,r,t)),$=!0)}else if(u===12){let v;b===91?(h=!0,v=0):v=c.get(b),v===1?$=!0:u=13}else u=p.nextState(u,b),u===0&&($=!0);$&&(u=1,l=!1,h=!1,D=!1,r=t+1,d=b),t++}u===13&&s.push(P.a(c,o,i,r,a))}return s}}e.$CZ=P;function f(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:P.computeLinks(y)}e.$DZ=f}),define(ke[80],Se([1,0,24]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Su=e.$Ru=e.$Qu=e.$Pu=e.ModelConstants=e.PositionAffinity=e.$Ou=e.TrackedRangeStickiness=e.$Nu=e.$Mu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var m;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(m||(e.GlyphMarginLane=m={}));var L;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var R;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var w;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(w||(e.EndOfLinePreference=w={}));var E;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var g;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(g||(e.EndOfLineSequence=g={}));class A{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,I.$bn)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$Mu=A;class P{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$Nu=P;var f;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(f||(e.TrackedRangeStickiness=f={}));function y(o){return o&&typeof o.read=="function"}e.$Ou=y;var S;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var p;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(p||(e.ModelConstants=p={}));class c{constructor(a,t,r,d,u,l){this.identifier=a,this.range=t,this.text=r,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=u,this._isTracked=l}}e.$Pu=c;class s{constructor(a,t,r){this.regex=a,this.wordSeparators=t,this.simpleSearch=r}}e.$Qu=s;class i{constructor(a,t,r){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=r}}e.$Ru=i;function n(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}e.$Su=n}),define(ke[174],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.$rB=e.$qB=e.$pB=e.$oB=e.NodeColor=e.$nB=void 0;class I{constructor(c,s){this.piece=c,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$oB)return m(this.right);let c=this;for(;c.parent!==e.$oB&&c.parent.left!==c;)c=c.parent;return c.parent===e.$oB?e.$oB:c.parent}prev(){if(this.left!==e.$oB)return L(this.left);let c=this;for(;c.parent!==e.$oB&&c.parent.right!==c;)c=c.parent;return c.parent===e.$oB?e.$oB:c.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$nB=I;var F;(function(p){p[p.Black=0]="Black",p[p.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$oB=new I(null,0),e.$oB.parent=e.$oB,e.$oB.left=e.$oB,e.$oB.right=e.$oB,e.$oB.color=0;function m(p){for(;p.left!==e.$oB;)p=p.left;return p}e.$pB=m;function L(p){for(;p.right!==e.$oB;)p=p.right;return p}e.$qB=L;function R(p){return p===e.$oB?0:p.size_left+p.piece.length+R(p.right)}function w(p){return p===e.$oB?0:p.lf_left+p.piece.lineFeedCnt+w(p.right)}function E(){e.$oB.parent=e.$oB}function g(p,c){const s=c.right;s.size_left+=c.size_left+(c.piece?c.piece.length:0),s.lf_left+=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),c.right=s.left,s.left!==e.$oB&&(s.left.parent=c),s.parent=c.parent,c.parent===e.$oB?p.root=s:c.parent.left===c?c.parent.left=s:c.parent.right=s,s.left=c,c.parent=s}e.$rB=g;function A(p,c){const s=c.left;c.left=s.right,s.right!==e.$oB&&(s.right.parent=c),s.parent=c.parent,c.size_left-=s.size_left+(s.piece?s.piece.length:0),c.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),c.parent===e.$oB?p.root=s:c===c.parent.right?c.parent.right=s:c.parent.left=s,s.right=c,c.parent=s}e.$sB=A;function P(p,c){let s,i;if(c.left===e.$oB?(i=c,s=i.right):c.right===e.$oB?(i=c,s=i.left):(i=m(c.right),s=i.right),i===p.root){p.root=s,s.color=0,c.detach(),E(),p.root.parent=e.$oB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===c?(s.parent=i.parent,S(p,s)):(i.parent===c?s.parent=i:s.parent=i.parent,S(p,s),i.left=c.left,i.right=c.right,i.parent=c.parent,i.color=c.color,c===p.root?p.root=i:c===c.parent.left?c.parent.left=i:c.parent.right=i,i.left!==e.$oB&&(i.left.parent=i),i.right!==e.$oB&&(i.right.parent=i),i.size_left=c.size_left,i.lf_left=c.lf_left,S(p,i)),c.detach(),s.parent.left===s){const a=R(s),t=w(s);if(a!==s.parent.size_left||t!==s.parent.lf_left){const r=a-s.parent.size_left,d=t-s.parent.lf_left;s.parent.size_left=a,s.parent.lf_left=t,y(p,s.parent,r,d)}}if(S(p,s.parent),n){E();return}let o;for(;s!==p.root&&s.color===0;)s===s.parent.left?(o=s.parent.right,o.color===1&&(o.color=0,s.parent.color=1,g(p,s.parent),o=s.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.right.color===0&&(o.left.color=0,o.color=1,A(p,o),o=s.parent.right),o.color=s.parent.color,s.parent.color=0,o.right.color=0,g(p,s.parent),s=p.root)):(o=s.parent.left,o.color===1&&(o.color=0,s.parent.color=1,A(p,s.parent),o=s.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.left.color===0&&(o.right.color=0,o.color=1,g(p,o),o=s.parent.left),o.color=s.parent.color,s.parent.color=0,o.left.color=0,A(p,s.parent),s=p.root));s.color=0,E()}e.$tB=P;function f(p,c){for(S(p,c);c!==p.root&&c.parent.color===1;)if(c.parent===c.parent.parent.left){const s=c.parent.parent.right;s.color===1?(c.parent.color=0,s.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.right&&(c=c.parent,g(p,c)),c.parent.color=0,c.parent.parent.color=1,A(p,c.parent.parent))}else{const s=c.parent.parent.left;s.color===1?(c.parent.color=0,s.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.left&&(c=c.parent,A(p,c)),c.parent.color=0,c.parent.parent.color=1,g(p,c.parent.parent))}p.root.color=0}e.$uB=f;function y(p,c,s,i){for(;c!==p.root&&c!==e.$oB;)c.parent.left===c&&(c.parent.size_left+=s,c.parent.lf_left+=i),c=c.parent}e.$vB=y;function S(p,c){let s=0,i=0;if(c!==p.root){for(;c!==p.root&&c===c.parent.right;)c=c.parent;if(c!==p.root)for(c=c.parent,s=R(c.left)-c.size_left,i=w(c.left)-c.lf_left,c.size_left+=s,c.lf_left+=i;c!==p.root&&(s!==0||i!==0);)c.parent.left===c&&(c.parent.size_left+=s,c.parent.lf_left+=i),c=c.parent}}e.$wB=S}),define(ke[175],Se([1,0,19,125]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xu=e.$Wu=e.$Vu=void 0;class m{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,g){E=(0,F.$Be)(E);const A=this.a,P=this.b,f=g.length;return f===0?!1:(this.a=new Uint32Array(A.length+f),this.a.set(A.subarray(0,E),0),this.a.set(A.subarray(E),E+f),this.a.set(g,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(E,g){return E=(0,F.$Be)(E),g=(0,F.$Be)(g),this.a[E]===g?!1:(this.a[E]=g,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,g){E=(0,F.$Be)(E),g=(0,F.$Be)(g);const A=this.a,P=this.b;if(E>=A.length)return!1;const f=A.length-E;return g>=f&&(g=f),g===0?!1:(this.a=new Uint32Array(A.length-g),this.a.set(A.subarray(0,E),0),this.a.set(A.subarray(E+g),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,F.$Be)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let g=this.c[0]+1;g===0&&(this.b[0]=this.a[0],g++),E>=this.a.length&&(E=this.a.length-1);for(let A=g;A<=E;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let g=0,A=this.a.length-1,P=0,f=0,y=0;for(;g<=A;)if(P=g+(A-g)/2|0,f=this.b[P],y=f-this.a[P],E<y)A=P-1;else if(E>=f)g=P+1;else break;return new R(P,E-y)}}e.$Vu=m;class L{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const g=this.e[E],A=g>0?this.d[g-1]:0;return new R(g,E-A)}removeValues(E,g){this.a.splice(E,g),this.f(E)}insertValues(E,g){this.a=(0,I.$Vb)(this.a,E,g),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,g=this.a.length;E<g;E++){const A=this.a[E],P=E>0?this.d[E-1]:0;this.d[E]=P+A;for(let f=0;f<A;f++)this.e[P+f]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,g){this.a[E]!==g&&(this.a[E]=g,this.f(E))}}e.$Wu=L;class R{constructor(E,g){this.index=E,this.remainder=g,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=g}}e.$Xu=R}),define(ke[176],Se([1,0,13,53,175]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yu=void 0;class L{constructor(w,E,g,A){this.d=w,this.f=E,this.g=g,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(w){w.eol&&w.eol!==this.g&&(this.g=w.eol,this.j=null);const E=w.changes;for(const g of E)this.o(g.range),this.p(new F.$vs(g.range.startLineNumber,g.range.startColumn),g.text);this.h=w.versionId,this.k=null}l(){if(!this.j){const w=this.g.length,E=this.f.length,g=new Uint32Array(E);for(let A=0;A<E;A++)g[A]=this.f[A].length+w;this.j=new m.$Vu(g)}}n(w,E){this.f[w]=E,this.j&&this.j.setValue(w,this.f[w].length+this.g.length)}o(w){if(w.startLineNumber===w.endLineNumber){if(w.startColumn===w.endColumn)return;this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.startLineNumber-1].substring(w.endColumn-1));return}this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.endLineNumber-1].substring(w.endColumn-1)),this.f.splice(w.startLineNumber,w.endLineNumber-w.startLineNumber),this.j&&this.j.removeValues(w.startLineNumber,w.endLineNumber-w.startLineNumber)}p(w,E){if(E.length===0)return;const g=(0,I.$Qe)(E);if(g.length===1){this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+g[0]+this.f[w.lineNumber-1].substring(w.column-1));return}g[g.length-1]+=this.f[w.lineNumber-1].substring(w.column-1),this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+g[0]);const A=new Uint32Array(g.length-1);for(let P=1;P<g.length;P++)this.f.splice(w.lineNumber+P-1,0,g[P]),A[P-1]=g[P].length+this.g.length;this.j&&this.j.insertValues(w.lineNumber,A)}}e.$Yu=L}),define(ke[99],Se([1,0,13,171,53,29,80]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CB=e.$BB=e.$AB=e.$zB=e.$yB=e.$xB=void 0;const w=999;class E{constructor(i,n,o,a){this.searchString=i,this.isRegex=n,this.matchCase=o,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=g(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=I.$Oe(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let o=!this.isRegex&&!i;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new R.$Qu(n,this.wordSeparators?(0,F.$Ws)(this.wordSeparators):null,o?this.searchString:null)}}e.$xB=E;function g(s){if(!s||s.length===0)return!1;for(let i=0,n=s.length;i<n;i++){const o=s.charCodeAt(i);if(o===10)return!0;if(o===92){if(i++,i>=n)break;const a=s.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$yB=g;function A(s,i,n){if(!n)return new R.$Nu(s,null);const o=[];for(let a=0,t=i.length;a<t;a++)o[a]=i[a];return new R.$Nu(s,o)}e.$zB=A;class P{constructor(i){const n=[];let o=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[o++]=a);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let o=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;o<a;){const t=o+((a-o)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(o=t,a=t):o=t+1}return o+1}}class f{static findMatches(i,n,o,a,t){const r=n.parseSearchRequest();return r?r.regex.multiline?this.b(i,o,new c(r.wordSeparators,r.regex),a,t):this.c(i,o,r,a,t):[]}static a(i,n,o,a,t,r){let d,u=0;a?(u=a.findLineFeedCountBeforeOffset(t),d=n+t+u):d=n+t;let l;if(a){const $=a.findLineFeedCountBeforeOffset(t+r.length)-u;l=d+r.length+$}else l=d+r.length;const h=i.getPositionAt(d),k=i.getPositionAt(l);return new L.$ws(h.lineNumber,h.column,k.lineNumber,k.column)}static b(i,n,o,a,t){const r=i.getOffsetAt(n.getStartPosition()),d=i.getValueInRange(n,1),u=i.getEOL()===`\r
`?new P(d):null,l=[];let h=0,k;for(o.reset(0);k=o.next(d);)if(l[h++]=A(this.a(i,r,d,u,k.index,k[0]),k,a),h>=t)return l;return l}static c(i,n,o,a,t){const r=[];let d=0;if(n.startLineNumber===n.endLineNumber){const l=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return d=this.d(o,l,n.startLineNumber,n.startColumn-1,d,r,a,t),r}const u=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);d=this.d(o,u,n.startLineNumber,n.startColumn-1,d,r,a,t);for(let l=n.startLineNumber+1;l<n.endLineNumber&&d<t;l++)d=this.d(o,i.getLineContent(l),l,0,d,r,a,t);if(d<t){const l=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);d=this.d(o,l,n.endLineNumber,0,d,r,a,t)}return r}static d(i,n,o,a,t,r,d,u){const l=i.wordSeparators;if(!d&&i.simpleSearch){const D=i.simpleSearch,$=D.length,b=n.length;let v=-$;for(;(v=n.indexOf(D,v+$))!==-1;)if((!l||p(l,n,b,v,$))&&(r[t++]=new R.$Nu(new L.$ws(o,v+1+a,o,v+1+$+a),null),t>=u))return t;return t}const h=new c(i.wordSeparators,i.regex);let k;h.reset(0);do if(k=h.next(n),k&&(r[t++]=A(new L.$ws(o,k.index+1+a,o,k.index+1+k[0].length+a),k,d),t>=u))return t;while(k);return t}static findNextMatch(i,n,o,a){const t=n.parseSearchRequest();if(!t)return null;const r=new c(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,o,r,a):this.f(i,o,r,a)}static e(i,n,o,a){const t=new m.$vs(n.lineNumber,1),r=i.getOffsetAt(t),d=i.getLineCount(),u=i.getValueInRange(new L.$ws(t.lineNumber,t.column,d,i.getLineMaxColumn(d)),1),l=i.getEOL()===`\r
`?new P(u):null;o.reset(n.column-1);const h=o.next(u);return h?A(this.a(i,r,u,l,h.index,h[0]),h,a):n.lineNumber!==1||n.column!==1?this.e(i,new m.$vs(1,1),o,a):null}static f(i,n,o,a){const t=i.getLineCount(),r=n.lineNumber,d=i.getLineContent(r),u=this.g(o,d,r,n.column,a);if(u)return u;for(let l=1;l<=t;l++){const h=(r+l-1)%t,k=i.getLineContent(h+1),D=this.g(o,k,h+1,1,a);if(D)return D}return null}static g(i,n,o,a,t){i.reset(a-1);const r=i.next(n);return r?A(new L.$ws(o,r.index+1,o,r.index+1+r[0].length),r,t):null}static findPreviousMatch(i,n,o,a){const t=n.parseSearchRequest();if(!t)return null;const r=new c(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,o,r,a):this.j(i,o,r,a)}static h(i,n,o,a){const t=this.b(i,new L.$ws(1,1,n.lineNumber,n.column),o,a,10*w);if(t.length>0)return t[t.length-1];const r=i.getLineCount();return n.lineNumber!==r||n.column!==i.getLineMaxColumn(r)?this.h(i,new m.$vs(r,i.getLineMaxColumn(r)),o,a):null}static j(i,n,o,a){const t=i.getLineCount(),r=n.lineNumber,d=i.getLineContent(r).substring(0,n.column-1),u=this.k(o,d,r,a);if(u)return u;for(let l=1;l<=t;l++){const h=(t+r-l-1)%t,k=i.getLineContent(h+1),D=this.k(o,k,h+1,a);if(D)return D}return null}static k(i,n,o,a){let t=null,r;for(i.reset(0);r=i.next(n);)t=A(new L.$ws(o,r.index+1,o,r.index+1+r[0].length),r,a);return t}}e.$AB=f;function y(s,i,n,o,a){if(o===0)return!0;const t=i.charCodeAt(o-1);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(o);if(s.get(r)!==0)return!0}return!1}function S(s,i,n,o,a){if(o+a===n)return!0;const t=i.charCodeAt(o+a);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(o+a-1);if(s.get(r)!==0)return!0}return!1}function p(s,i,n,o,a){return y(s,i,n,o,a)&&S(s,i,n,o,a)}e.$BB=p;class c{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let o;do{if(this.b+this.c===n||(o=this.a.exec(i),!o))return null;const a=o.index,t=o[0].length;if(a===this.b&&t===this.c){if(t===0){I.$0e(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||p(this._wordSeparators,i,n,a,t))return o}while(o);return null}}e.$CB=c}),define(ke[128],Se([1,0,53,29,80,174,99]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HB=e.$GB=e.$FB=e.$EB=e.$DB=void 0;const w=65535;function E(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class g{constructor(i,n,o,a,t){this.lineStarts=i,this.cr=n,this.lf=o,this.crlf=a,this.isBasicASCII=t}}function A(s,i=!0){const n=[0];let o=1;for(let a=0,t=s.length;a<t;a++){const r=s.charCodeAt(a);r===13?a+1<t&&s.charCodeAt(a+1)===10?(n[o++]=a+2,a++):n[o++]=a+1:r===10&&(n[o++]=a+1)}return i?E(n):n}e.$DB=A;function P(s,i){s.length=0,s[0]=0;let n=1,o=0,a=0,t=0,r=!0;for(let u=0,l=i.length;u<l;u++){const h=i.charCodeAt(u);h===13?u+1<l&&i.charCodeAt(u+1)===10?(t++,s[n++]=u+2,u++):(o++,s[n++]=u+1):h===10?(a++,s[n++]=u+1):r&&h!==9&&(h<32||h>126)&&(r=!1)}const d=new g(E(s),o,a,t,r);return s.length=0,d}e.$EB=P;class f{constructor(i,n,o,a,t){this.bufferIndex=i,this.start=n,this.end=o,this.lineFeedCnt=a,this.length=t}}e.$FB=f;class y{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$GB=y;class S{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==L.$oB&&i.iterate(i.root,o=>(o!==L.$oB&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class p{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartOffset<=i&&o.nodeStartOffset+o.node.piece.length>=i)return o}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<i&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=i)return o}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const o=this.b;for(let a=0;a<o.length;a++){const t=o[a];if(t.node.parent===null||t.nodeStartOffset>=i){o[a]=null,n=!0;continue}}if(n){const a=[];for(const t of o)t!==null&&a.push(t);this.b=a}}}class c{constructor(i,n,o){this.create(i,n,o)}create(i,n,o){this.a=[new y("",[0])],this.g={line:0,column:0},this.root=L.$oB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=o;let a=null;for(let t=0,r=i.length;t<r;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const d=new f(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,d)}this.h=new p(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=w,o=n-Math.floor(n/3),a=o*2;let t="",r=0;const d=[];if(this.iterate(this.root,u=>{const l=this.R(u),h=l.length;if(r<=o||r+h<a)return t+=l,r+=h,!0;const k=t.replace(/\r\n|\r|\n/g,i);return d.push(new y(k,A(k))),t=l,r=h,!0}),r>0){const u=t.replace(/\r\n|\r|\n/g,i);d.push(new y(u,A(u)))}this.create(d,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===L.$oB)return!0;const t=this.R(a),r=t.length,d=i.G(n),u=i.G(n+r),l=i.getValueInRange2(d,u);return n+=r,t===l})}getOffsetAt(i,n){let o=0,a=this.root;for(;a!==L.$oB;)if(a.left!==L.$oB&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){o+=a.size_left;const t=this.B(a,i-a.lf_left-2);return o+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,o+=a.size_left+a.piece.length,a=a.right;return o}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,o=0;const a=i;for(;n!==L.$oB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(o+=n.lf_left+t.index,t.index===0){const r=this.getOffsetAt(o+1,1),d=a-r;return new I.$vs(o+1,d+1)}return new I.$vs(o+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,o+=n.lf_left+n.piece.lineFeedCnt,n.right===L.$oB){const t=this.getOffsetAt(o+1,1),r=a-i-t;return new I.$vs(o+1,r+1)}else n=n.right;return new I.$vs(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const o=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(o,a);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const d=i.node,u=this.a[d.piece.bufferIndex].buffer,l=this.u(d.piece.bufferIndex,d.piece.start);return u.substring(l+i.remainder,l+n.remainder)}let o=i.node;const a=this.a[o.piece.bufferIndex].buffer,t=this.u(o.piece.bufferIndex,o.piece.start);let r=a.substring(t+i.remainder,t+o.piece.length);for(o=o.next();o!==L.$oB;){const d=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(o===n.node){r+=d.substring(u,u+n.remainder);break}else r+=d.substr(u,o.piece.length);o=o.next()}return r}getLinesContent(){const i=[];let n=0,o="",a=!1;return this.iterate(this.root,t=>{if(t===L.$oB)return!0;const r=t.piece;let d=r.length;if(d===0)return!0;const u=this.a[r.bufferIndex].buffer,l=this.a[r.bufferIndex].lineStarts,h=r.start.line,k=r.end.line;let D=l[h]+r.start.column;if(a&&(u.charCodeAt(D)===10&&(D++,d--),i[n++]=o,o="",a=!1,d===0))return!0;if(h===k)return!this.f&&u.charCodeAt(D+d-1)===13?(a=!0,o+=u.substr(D,d-1)):o+=u.substr(D,d),!0;o+=this.f?u.substring(D,Math.max(D,l[h+1]-this.e)):u.substring(D,l[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;for(let $=h+1;$<k;$++)o=this.f?u.substring(l[$],l[$+1]-this.e):u.substring(l[$],l[$+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;return!this.f&&u.charCodeAt(l[k]+r.end.column-1)===13?(a=!0,r.end.column===0?n--:o=u.substr(l[k],r.end.column-1)):o=u.substr(l[k],r.end.column),!0}),a&&(i[n++]=o,o=""),i[n++]=o,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const o=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start);return o.buffer.charCodeAt(a)}else{const n=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const o=this.H(i,n+1);return this.l(o)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,o,a,t,r,d,u,l,h,k){const D=this.a[i.piece.bufferIndex],$=this.u(i.piece.bufferIndex,i.piece.start),b=this.u(i.piece.bufferIndex,t),v=this.u(i.piece.bufferIndex,r);let C;const N={line:0,column:0};let z,M;n._wordSeparators?(z=D.buffer.substring(b,v),M=T=>T+b,n.reset(0)):(z=D.buffer,M=T=>T,n.reset(b));do if(C=n.next(z),C){if(M(C.index)>=v)return h;this.s(i,M(C.index)-$,N);const T=this.t(i.piece.bufferIndex,t,N),j=N.line===t.line?N.column-t.column+a:N.column+1,O=j+C[0].length;if(k[h++]=(0,R.$zB)(new F.$ws(o+T,j,o+T,O),C,u),M(C.index)+C[0].length>=v||h>=l)return h}while(C);return h}findMatchesLineByLine(i,n,o,a){const t=[];let r=0;const d=new R.$CB(n.wordSeparators,n.regex);let u=this.H(i.startLineNumber,i.startColumn);if(u===null)return[];const l=this.H(i.endLineNumber,i.endColumn);if(l===null)return[];let h=this.s(u.node,u.remainder);const k=this.s(l.node,l.remainder);if(u.node===l.node)return this.findMatchesInNode(u.node,d,i.startLineNumber,i.startColumn,h,k,n,o,a,r,t),t;let D=i.startLineNumber,$=u.node;for(;$!==l.node;){const v=this.t($.piece.bufferIndex,h,$.piece.end);if(v>=1){const N=this.a[$.piece.bufferIndex].lineStarts,z=this.u($.piece.bufferIndex,$.piece.start),M=N[h.line+v],T=D===i.startLineNumber?i.startColumn:1;if(r=this.findMatchesInNode($,d,D,T,h,this.s($,M-z),n,o,a,r,t),r>=a)return t;D+=v}const C=D===i.startLineNumber?i.startColumn-1:0;if(D===i.endLineNumber){const N=this.getLineContent(D).substring(C,i.endColumn-1);return r=this.n(n,d,N,i.endLineNumber,C,r,t,o,a),t}if(r=this.n(n,d,this.getLineContent(D).substr(C),D,C,r,t,o,a),r>=a)return t;D++,u=this.H(D,1),$=u.node,h=this.s(u.node,u.remainder)}if(D===i.endLineNumber){const v=D===i.startLineNumber?i.startColumn-1:0,C=this.getLineContent(D).substring(v,i.endColumn-1);return r=this.n(n,d,C,i.endLineNumber,v,r,t,o,a),t}const b=D===i.startLineNumber?i.startColumn:1;return r=this.findMatchesInNode(l.node,d,D,b,h,k,n,o,a,r,t),t}n(i,n,o,a,t,r,d,u,l){const h=i.wordSeparators;if(!u&&i.simpleSearch){const D=i.simpleSearch,$=D.length,b=o.length;let v=-$;for(;(v=o.indexOf(D,v+$))!==-1;)if((!h||(0,R.$BB)(h,o,b,v,$))&&(d[r++]=new m.$Nu(new F.$ws(a,v+1+t,a,v+1+$+t),null),r>=l))return r;return r}let k;n.reset(0);do if(k=n.next(o),k&&(d[r++]=(0,R.$zB)(new F.$ws(a,k.index+1+t,a,k.index+1+k[0].length+t),k,u),r>=l))return r;while(k);return r}insert(i,n,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==L.$oB){const{node:a,remainder:t,nodeStartOffset:r}=this.G(i),d=a.piece,u=d.bufferIndex,l=this.s(a,t);if(a.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&r+d.length===i&&n.length<w){this.F(a,n),this.y();return}if(r===i)this.o(n,a),this.h.validate(i);else if(r+a.piece.length>i){const h=[];let k=new f(d.bufferIndex,l,d.end,this.t(d.bufferIndex,l,d.end),this.u(u,d.end)-this.u(u,l));if(this.K()&&this.M(n)&&this.I(a,t)===10){const v={line:k.start.line+1,column:0};k=new f(k.bufferIndex,v,k.end,this.t(k.bufferIndex,v,k.end),k.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(a,t-1)===13){const v=this.s(a,t-1);this.C(a,v),n="\r"+n,a.piece.length===0&&h.push(a)}else this.C(a,l);else this.C(a,l);const D=this.w(n);k.length>0&&this.S(a,k);let $=a;for(let b=0;b<D.length;b++)$=this.S($,D[b]);this.v(h)}else this.q(n,a)}else{const a=this.w(n);let t=this.T(null,a[0]);for(let r=1;r<a.length;r++)t=this.S(t,a[r])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===L.$oB)return;const o=this.G(i),a=this.G(i+n),t=o.node,r=a.node;if(t===r){const D=this.s(t,o.remainder),$=this.s(t,a.remainder);if(o.nodeStartOffset===i){if(n===t.piece.length){const b=t.next();(0,L.$tB)(this,t),this.N(b),this.y();return}this.D(t,$),this.h.validate(i),this.N(t),this.y();return}if(o.nodeStartOffset+t.piece.length===i+n){this.C(t,D),this.O(t),this.y();return}this.E(t,D,$),this.y();return}const d=[],u=this.s(t,o.remainder);this.C(t,u),this.h.validate(i),t.piece.length===0&&d.push(t);const l=this.s(r,a.remainder);this.D(r,l),r.piece.length===0&&d.push(r);const h=t.next();for(let D=h;D!==L.$oB&&D!==r;D=D.next())d.push(D);const k=t.piece.length===0?t.prev():t;this.v(d),this.O(k),this.y()}o(i,n){const o=[];if(this.K()&&this.M(i)&&this.L(n)){const r=n.piece,d={line:r.start.line+1,column:0},u=new f(r.bufferIndex,d,r.end,this.t(r.bufferIndex,d,r.end),r.length-1);n.piece=u,i+=`
`,(0,L.$vB)(this,n,-1,-1),n.piece.length===0&&o.push(n)}const a=this.w(i);let t=this.T(n,a[a.length-1]);for(let r=a.length-2;r>=0;r--)t=this.T(t,a[r]);this.N(t),this.v(o)}q(i,n){this.Q(i,n)&&(i+=`
`);const o=this.w(i),a=this.S(n,o[0]);let t=a;for(let r=1;r<o.length;r++)t=this.S(t,o[r]);this.N(a)}s(i,n,o){const a=i.piece,t=i.piece.bufferIndex,r=this.a[t].lineStarts,u=r[a.start.line]+a.start.column+n;let l=a.start.line,h=a.end.line,k=0,D=0,$=0;for(;l<=h&&(k=l+(h-l)/2|0,$=r[k],k!==h);)if(D=r[k+1],u<$)h=k-1;else if(u>=D)l=k+1;else break;return o?(o.line=k,o.column=u-$,null):{line:k,column:u-$}}t(i,n,o){if(o.column===0)return o.line-n.line;const a=this.a[i].lineStarts;if(o.line===a.length-1)return o.line-n.line;const t=a[o.line+1],r=a[o.line]+o.column;if(t>r+1)return o.line-n.line;const d=r-1;return this.a[i].buffer.charCodeAt(d)===13?o.line-n.line+1:o.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,L.$tB)(this,i[n])}w(i){if(i.length>w){const h=[];for(;i.length>w;){const D=i.charCodeAt(w-1);let $;D===13||D>=55296&&D<=56319?($=i.substring(0,w-1),i=i.substring(w-1)):($=i.substring(0,w),i=i.substring(w));const b=A($);h.push(new f(this.a.length,{line:0,column:0},{line:b.length-1,column:$.length-b[b.length-1]},b.length-1,$.length)),this.a.push(new y($,b))}const k=A(i);return h.push(new f(this.a.length,{line:0,column:0},{line:k.length-1,column:i.length-k[k.length-1]},k.length-1,i.length)),this.a.push(new y(i,k)),h}let n=this.a[0].buffer.length;const o=A(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let h=0;h<o.length;h++)o[h]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let h=0;h<o.length;h++)o[h]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,r=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[r],u={line:r,column:d},l=new f(0,a,u,this.t(0,a,u),t-n);return this.g=u,[l]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let o=this.root,a="";const t=this.h.get2(i);if(t){o=t.node;const r=this.B(o,i-t.nodeStartLineNumber-1),d=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(t.nodeStartLineNumber+o.piece.lineFeedCnt===i)a=d.substring(u+r,u+o.piece.length);else{const l=this.B(o,i-t.nodeStartLineNumber);return d.substring(u+r,u+l-n)}}else{let r=0;const d=i;for(;o!==L.$oB;)if(o.left!==L.$oB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const u=this.B(o,i-o.lf_left-2),l=this.B(o,i-o.lf_left-1),h=this.a[o.piece.bufferIndex].buffer,k=this.u(o.piece.bufferIndex,o.piece.start);return r+=o.size_left,this.h.set({node:o,nodeStartOffset:r,nodeStartLineNumber:d-(i-1-o.lf_left)}),h.substring(k+u,k+l-n)}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const u=this.B(o,i-o.lf_left-2),l=this.a[o.piece.bufferIndex].buffer,h=this.u(o.piece.bufferIndex,o.piece.start);a=l.substring(h+u,h+o.piece.length);break}else i-=o.lf_left+o.piece.lineFeedCnt,r+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==L.$oB;){const r=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const d=this.B(o,0),u=this.u(o.piece.bufferIndex,o.piece.start);return a+=r.substring(u,u+d-n),a}else{const d=this.u(o.piece.bufferIndex,o.piece.start);a+=r.substr(d,o.piece.length)}o=o.next()}return a}y(){let i=this.root,n=1,o=0;for(;i!==L.$oB;)n+=i.lf_left+i.piece.lineFeedCnt,o+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=o,this.h.validate(this.c)}A(i,n){const o=i.piece,a=this.s(i,n),t=a.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===n){const r=this.t(i.piece.bufferIndex,o.start,a);if(r!==t)return{index:r,remainder:0}}return{index:t,remainder:a.column}}B(i,n){if(n<0)return 0;const o=i.piece,a=this.a[o.bufferIndex].lineStarts,t=o.start.line+n+1;return t>o.end.line?a[o.end.line]+o.end.column-a[o.start.line]-o.start.column:a[t]-a[o.start.line]-o.start.column}C(i,n){const o=i.piece,a=o.lineFeedCnt,t=this.u(o.bufferIndex,o.end),r=n,d=this.u(o.bufferIndex,r),u=this.t(o.bufferIndex,o.start,r),l=u-a,h=d-t,k=o.length+h;i.piece=new f(o.bufferIndex,o.start,r,u,k),(0,L.$vB)(this,i,h,l)}D(i,n){const o=i.piece,a=o.lineFeedCnt,t=this.u(o.bufferIndex,o.start),r=n,d=this.t(o.bufferIndex,r,o.end),u=this.u(o.bufferIndex,r),l=d-a,h=t-u,k=o.length+h;i.piece=new f(o.bufferIndex,r,o.end,d,k),(0,L.$vB)(this,i,h,l)}E(i,n,o){const a=i.piece,t=a.start,r=a.end,d=a.length,u=a.lineFeedCnt,l=n,h=this.t(a.bufferIndex,a.start,l),k=this.u(a.bufferIndex,n)-this.u(a.bufferIndex,t);i.piece=new f(a.bufferIndex,a.start,l,h,k),(0,L.$vB)(this,i,k-d,h-u);const D=new f(a.bufferIndex,o,r,this.t(a.bufferIndex,o,r),this.u(a.bufferIndex,r)-this.u(a.bufferIndex,o)),$=this.S(i,D);this.N($)}F(i,n){this.Q(n,i)&&(n+=`
`);const o=this.K()&&this.L(n)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=n;const t=A(n,!1);for(let $=0;$<t.length;$++)t[$]+=a;if(o){const $=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-$}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const r=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[r],u={line:r,column:d},l=i.piece.length+n.length,h=i.piece.lineFeedCnt,k=this.t(0,i.piece.start,u),D=k-h;i.piece=new f(i.piece.bufferIndex,i.piece.start,u,k,l),this.g=u,(0,L.$vB)(this,i,n.length,D)}G(i){let n=this.root;const o=this.h.get(i);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:i-o.nodeStartOffset};let a=0;for(;n!==L.$oB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let o=this.root,a=0;for(;o!==L.$oB;)if(o.left!==L.$oB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const t=this.B(o,i-o.lf_left-2),r=this.B(o,i-o.lf_left-1);return a+=o.size_left,{node:o,remainder:Math.min(t+n-1,r),nodeStartOffset:a}}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const t=this.B(o,i-o.lf_left-2);if(t+n-1<=o.piece.length)return{node:o,remainder:t+n-1,nodeStartOffset:a};n-=o.piece.length-t;break}else i-=o.lf_left+o.piece.lineFeedCnt,a+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==L.$oB;){if(o.piece.lineFeedCnt>0){const t=this.B(o,0),r=this.J(o);return{node:o,remainder:Math.min(n-1,t),nodeStartOffset:r}}else if(o.piece.length>=n-1){const t=this.J(o);return{node:o,remainder:n-1,nodeStartOffset:t}}else n-=o.piece.length;o=o.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const o=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+n;return o.buffer.charCodeAt(a)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===L.$oB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,o=this.a[n.bufferIndex].lineStarts,a=n.start.line,t=o[a]+n.start.column;return a===o.length-1||o[a+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===L.$oB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const o=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const r=i.piece.length-1,d=i.piece.lineFeedCnt-1;i.piece=new f(i.piece.bufferIndex,i.piece.start,t,d,r),(0,L.$vB)(this,i,-1,-1),i.piece.length===0&&o.push(i);const u={line:n.piece.start.line+1,column:0},l=n.piece.length-1,h=this.t(n.piece.bufferIndex,u,n.piece.end);n.piece=new f(n.piece.bufferIndex,u,n.piece.end,h,l),(0,L.$vB)(this,n,-1,-1),n.piece.length===0&&o.push(n);const k=this.w(`\r
`);this.S(i,k[0]);for(let D=0;D<o.length;D++)(0,L.$tB)(this,o[D])}Q(i,n){if(this.K()&&this.M(i)){const o=n.next();if(this.L(o)){if(i+=`
`,o.piece.length===1)(0,L.$tB)(this,o);else{const a=o.piece,t={line:a.start.line+1,column:0},r=a.length-1,d=this.t(a.bufferIndex,t,a.end);o.piece=new f(a.bufferIndex,t,a.end,d,r),(0,L.$vB)(this,o,-1,-1)}return!0}}return!1}iterate(i,n){if(i===L.$oB)return n(L.$oB);const o=this.iterate(i.left,n);return o&&n(i)&&this.iterate(i.right,n)}R(i){if(i===L.$oB)return"";const n=this.a[i.piece.bufferIndex],o=i.piece,a=this.u(o.bufferIndex,o.start),t=this.u(o.bufferIndex,o.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this.a[i.bufferIndex],o=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return n.buffer.substring(o,a)}S(i,n){const o=new L.$nB(n,1);if(o.left=L.$oB,o.right=L.$oB,o.parent=L.$oB,o.size_left=0,o.lf_left=0,this.root===L.$oB)this.root=o,o.color=0;else if(i.right===L.$oB)i.right=o,o.parent=i;else{const t=(0,L.$pB)(i.right);t.left=o,o.parent=t}return(0,L.$uB)(this,o),o}T(i,n){const o=new L.$nB(n,1);if(o.left=L.$oB,o.right=L.$oB,o.parent=L.$oB,o.size_left=0,o.lf_left=0,this.root===L.$oB)this.root=o,o.color=0;else if(i.left===L.$oB)i.left=o,o.parent=i;else{const a=(0,L.$qB)(i.left);a.right=o,o.parent=a}return(0,L.$uB)(this,o),o}U(i){let n="";return this.iterate(i,o=>(n+=this.R(o),!0)),n}}e.$HB=c}),define(ke[177],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p8=e.$o8=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.$o8=I;class F{constructor(L){this.identifier=L}}e.$p8=F}),define(ke[178],Se([1,0,4,3]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0;class m{constructor(){this.a=new Map,this.b=new Map,this.c=new I.$Od,this.onDidChange=this.c.event,this.d=null}handleChange(w){this.c.fire({changedLanguages:w,changedColorMap:!1})}register(w,E){return this.a.set(w,E),this.handleChange([w]),(0,F.$Pc)(()=>{this.a.get(w)===E&&(this.a.delete(w),this.handleChange([w]))})}get(w){return this.a.get(w)||null}registerFactory(w,E){this.b.get(w)?.dispose();const g=new L(this,w,E);return this.b.set(w,g),(0,F.$Pc)(()=>{const A=this.b.get(w);!A||A!==g||(this.b.delete(w),A.dispose())})}async getOrCreate(w){const E=this.get(w);if(E)return E;const g=this.b.get(w);return!g||g.isResolved?null:(await g.resolve(),this.get(w))}isResolved(w){if(this.get(w))return!0;const g=this.b.get(w);return!!(!g||g.isResolved)}setColorMap(w){this.d=w,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$8s=m;class L extends F.$Rc{get isResolved(){return this.c}constructor(w,E,g){super(),this.f=w,this.g=E,this.h=g,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const w=await this.h.tokenizationSupport;this.c=!0,w&&!this.a&&this.B(this.f.register(this.g,w))}}}),define(ke[179],Se([8,9]),function(me,e){return me.create("vs/base/common/actions",e)}),define(ke[180],Se([1,0,4,3,179]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=void 0;class L extends F.$Rc{constructor(f,y="",S="",p=!0,c){super(),this.h=this.B(new I.$Od),this.onDidChange=this.h.event,this.w=!0,this.j=f,this.m=y,this.u=S,this.w=p,this.C=c}get id(){return this.j}get label(){return this.m}set label(f){this.D(f)}D(f){this.m!==f&&(this.m=f,this.h.fire({label:f}))}get tooltip(){return this.n||""}set tooltip(f){this.F(f)}F(f){this.n!==f&&(this.n=f,this.h.fire({tooltip:f}))}get class(){return this.u}set class(f){this.G(f)}G(f){this.u!==f&&(this.u=f,this.h.fire({class:f}))}get enabled(){return this.w}set enabled(f){this.H(f)}H(f){this.w!==f&&(this.w=f,this.h.fire({enabled:f}))}get checked(){return this.z}set checked(f){this.I(f)}I(f){this.z!==f&&(this.z=f,this.h.fire({checked:f}))}async run(f,y){this.C&&await this.C(f)}}e.$xi=L;class R extends F.$Rc{constructor(){super(...arguments),this.f=this.B(new I.$Od),this.onWillRun=this.f.event,this.m=this.B(new I.$Od),this.onDidRun=this.m.event}async run(f,y){if(!f.enabled)return;this.f.fire({action:f});let S;try{await this.u(f,y)}catch(p){S=p}this.m.fire({action:f,error:S})}async u(f,y){await f.run(y)}}e.$yi=R;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...f){let y=[];for(const S of f)S.length&&(y.length?y=[...y,new w,...S]:y=S);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$zi=w;class E{get actions(){return this.a}constructor(f,y,S,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=f,this.label=y,this.class=p,this.a=S}async run(){}}e.$Ai=E;class g extends L{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,m.localize(0,null),void 0,!1)}}e.$Bi=g;function A(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async(...f)=>P.run(...f),tooltip:P.label}}e.$Ci=A}),define(ke[181],Se([8,9]),function(me,e){return me.create("vs/base/common/date",e)}),define(ke[182],Se([1,0,181]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=e.$gm=void 0;const F=60,m=F*60,L=m*24,R=L*7,w=L*30,E=L*365;function g(P,f,y,S){typeof P!="number"&&(P=P.getTime());const p=Math.round((new Date().getTime()-P)/1e3);if(p<-30)return(0,I.localize)(0,null,g(new Date().getTime()+p*1e3,!1));if(!S&&p<30)return(0,I.localize)(1,null);let c;return p<F?(c=p,f?c===1?y?(0,I.localize)(2,null,c):(0,I.localize)(3,null,c):y?(0,I.localize)(4,null,c):(0,I.localize)(5,null,c):c===1?y?(0,I.localize)(6,null,c):(0,I.localize)(7,null,c):y?(0,I.localize)(8,null,c):(0,I.localize)(9,null,c)):p<m?(c=Math.floor(p/F),f?c===1?y?(0,I.localize)(10,null,c):(0,I.localize)(11,null,c):y?(0,I.localize)(12,null,c):(0,I.localize)(13,null,c):c===1?y?(0,I.localize)(14,null,c):(0,I.localize)(15,null,c):y?(0,I.localize)(16,null,c):(0,I.localize)(17,null,c)):p<L?(c=Math.floor(p/m),f?c===1?y?(0,I.localize)(18,null,c):(0,I.localize)(19,null,c):y?(0,I.localize)(20,null,c):(0,I.localize)(21,null,c):c===1?y?(0,I.localize)(22,null,c):(0,I.localize)(23,null,c):y?(0,I.localize)(24,null,c):(0,I.localize)(25,null,c)):p<R?(c=Math.floor(p/L),f?c===1?(0,I.localize)(26,null,c):(0,I.localize)(27,null,c):c===1?(0,I.localize)(28,null,c):(0,I.localize)(29,null,c)):p<w?(c=Math.floor(p/R),f?c===1?y?(0,I.localize)(30,null,c):(0,I.localize)(31,null,c):y?(0,I.localize)(32,null,c):(0,I.localize)(33,null,c):c===1?y?(0,I.localize)(34,null,c):(0,I.localize)(35,null,c):y?(0,I.localize)(36,null,c):(0,I.localize)(37,null,c)):p<E?(c=Math.floor(p/w),f?c===1?y?(0,I.localize)(38,null,c):(0,I.localize)(39,null,c):y?(0,I.localize)(40,null,c):(0,I.localize)(41,null,c):c===1?y?(0,I.localize)(42,null,c):(0,I.localize)(43,null,c):y?(0,I.localize)(44,null,c):(0,I.localize)(45,null,c)):(c=Math.floor(p/E),f?c===1?y?(0,I.localize)(46,null,c):(0,I.localize)(47,null,c):y?(0,I.localize)(48,null,c):(0,I.localize)(49,null,c):c===1?y?(0,I.localize)(50,null,c):(0,I.localize)(51,null,c):y?(0,I.localize)(52,null,c):(0,I.localize)(53,null,c))}e.$gm=g;function A(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$hm=A}),define(ke[183],Se([8,9]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(ke[43],Se([1,0,19,18,183]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=void 0;function L(P,f){return f&&(P.stack||P.stacktrace)?m.localize(0,null,w(P),R(P.stack)||R(P.stacktrace)):w(P)}function R(P){return Array.isArray(P)?P.join(`
`):P}function w(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?m.localize(1,null,P.message):P.message||m.localize(2,null)}function E(P=null,f=!1){if(!P)return m.localize(3,null);if(Array.isArray(P)){const y=I.$Gb(P),S=E(y[0],f);return y.length>1?m.localize(4,null,S,y.length):S}if(F.$zf(P))return P;if(P.detail){const y=P.detail;if(y.error)return L(y.error,f);if(y.exception)return L(y.exception,f)}return P.stack?L(P,f):P.message?P.message:m.localize(5,null)}e.$Di=E;function g(P){const f=P;return f instanceof Error&&Array.isArray(f.actions)}e.$Ei=g;function A(P,f){let y;return typeof P=="string"?y=new Error(P):y=P,y.actions=f,y}e.$Fi=A}),define(ke[184],Se([8,9]),function(me,e){return me.create("vs/base/common/platform",e)}),define(ke[12],Se([1,0,184]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let F=!1,m=!1,L=!1,R=!1,w=!1,E=!1,g=!1,A=!1,P=!1,f=!1,y,S=e.$g,p=e.$g,c,s;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const o=typeof n?.versions?.electron=="string",a=o&&n?.type==="renderer";if(typeof navigator=="object"&&!a)s=navigator.userAgent,F=s.indexOf("Windows")>=0,m=s.indexOf("Macintosh")>=0,A=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=s.indexOf("Linux")>=0,f=s?.indexOf("Mobi")>=0,E=!0,y=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,S=y,p=navigator.language;else if(typeof n=="object"){F=n.platform==="win32",m=n.platform==="darwin",L=n.platform==="linux",R=L&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,g=o,P=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,S=e.$g;const $=n.env.VSCODE_NLS_CONFIG;if($)try{const b=JSON.parse($),v=b.availableLanguages["*"];y=b.locale,p=b.osLocale,S=v||e.$g,c=b._translationsConfigFile}catch{}w=!0}else console.error("Unable to resolve platform.");var t;(function($){$[$.Web=0]="Web",$[$.Mac=1]="Mac",$[$.Linux=2]="Linux",$[$.Windows=3]="Windows"})(t||(e.Platform=t={}));function r($){switch($){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=r;let d=0;m?d=1:F?d=3:L&&(d=2),e.$i=F,e.$j=m,e.$k=L,e.$l=R,e.$m=w,e.$n=g,e.$o=E,e.$p=E&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=A,e.$s=f,e.$t=P,e.$u=d,e.$v=s,e.$w=S;var u;(function($){function b(){return e.$w}$.value=b;function v(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}$.isDefaultVariant=v;function C(){return e.$w==="en"}$.isDefault=C})(u||(e.Language=u={})),e.$x=y,e.$y=p,e.$z=c,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const $=[];i.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let C=0,N=$.length;C<N;C++){const z=$[C];if(z.id===v.data.vscodeScheduleAsyncWork){$.splice(C,1),z.callback();return}}});let b=0;return v=>{const C=++b;$.push({id:C,callback:v}),i.postMessage({vscodeScheduleAsyncWork:C},"*")}}return $=>setTimeout($)})();var l;(function($){$[$.Windows=1]="Windows",$[$.Macintosh=2]="Macintosh",$[$.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=m||A?2:F?1:3;let h=!0,k=!1;function D(){if(!k){k=!0;const $=new Uint8Array(2);$[0]=1,$[1]=2,h=new Uint16Array($.buffer)[0]===(2<<8)+1}return h}e.$D=D,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ke[49],Se([1,0,12]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let F;const m=globalThis.vscode;if(typeof m<"u"&&typeof m.process<"u"){const L=m.process;F={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return I.$i?"win32":I.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$cc=F.platform,e.$dc=F.arch}),define(ke[16],Se([1,0,49]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const F=65,m=97,L=90,R=122,w=46,E=47,g=92,A=58,P=63;class f extends Error{constructor(r,d,u){let l;typeof d=="string"&&d.indexOf("not ")===0?(l="must not be",d=d.replace(/^not /,"")):l="must be";const h=r.indexOf(".")!==-1?"property":"argument";let k=`The "${r}" ${h} ${l} of type ${d}`;k+=`. Received type ${typeof u}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,r){if(t===null||typeof t!="object")throw new f(r,"Object",t)}function S(t,r){if(typeof t!="string")throw new f(r,"string",t)}const p=I.$cc==="win32";function c(t){return t===E||t===g}function s(t){return t===E}function i(t){return t>=F&&t<=L||t>=m&&t<=R}function n(t,r,d,u){let l="",h=0,k=-1,D=0,$=0;for(let b=0;b<=t.length;++b){if(b<t.length)$=t.charCodeAt(b);else{if(u($))break;$=E}if(u($)){if(!(k===b-1||D===1))if(D===2){if(l.length<2||h!==2||l.charCodeAt(l.length-1)!==w||l.charCodeAt(l.length-2)!==w){if(l.length>2){const v=l.lastIndexOf(d);v===-1?(l="",h=0):(l=l.slice(0,v),h=l.length-1-l.lastIndexOf(d)),k=b,D=0;continue}else if(l.length!==0){l="",h=0,k=b,D=0;continue}}r&&(l+=l.length>0?`${d}..`:"..",h=2)}else l.length>0?l+=`${d}${t.slice(k+1,b)}`:l=t.slice(k+1,b),h=b-k-1;k=b,D=0}else $===w&&D!==-1?++D:D=-1}return l}function o(t,r){y(r,"pathObject");const d=r.dir||r.root,u=r.base||`${r.name||""}${r.ext||""}`;return d?d===r.root?`${d}${u}`:`${d}${t}${u}`:u}e.$ec={resolve(...t){let r="",d="",u=!1;for(let l=t.length-1;l>=-1;l--){let h;if(l>=0){if(h=t[l],S(h,"path"),h.length===0)continue}else r.length===0?h=I.cwd():(h=I.env[`=${r}`]||I.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==r.toLowerCase()&&h.charCodeAt(2)===g)&&(h=`${r}\\`));const k=h.length;let D=0,$="",b=!1;const v=h.charCodeAt(0);if(k===1)c(v)&&(D=1,b=!0);else if(c(v))if(b=!0,c(h.charCodeAt(1))){let C=2,N=C;for(;C<k&&!c(h.charCodeAt(C));)C++;if(C<k&&C!==N){const z=h.slice(N,C);for(N=C;C<k&&c(h.charCodeAt(C));)C++;if(C<k&&C!==N){for(N=C;C<k&&!c(h.charCodeAt(C));)C++;(C===k||C!==N)&&($=`\\\\${z}\\${h.slice(N,C)}`,D=C)}}}else D=1;else i(v)&&h.charCodeAt(1)===A&&($=h.slice(0,2),D=2,k>2&&c(h.charCodeAt(2))&&(b=!0,D=3));if($.length>0)if(r.length>0){if($.toLowerCase()!==r.toLowerCase())continue}else r=$;if(u){if(r.length>0)break}else if(d=`${h.slice(D)}\\${d}`,u=b,b&&r.length>0)break}return d=n(d,!u,"\\",c),u?`${r}\\${d}`:`${r}${d}`||"."},normalize(t){S(t,"path");const r=t.length;if(r===0)return".";let d=0,u,l=!1;const h=t.charCodeAt(0);if(r===1)return s(h)?"\\":t;if(c(h))if(l=!0,c(t.charCodeAt(1))){let D=2,$=D;for(;D<r&&!c(t.charCodeAt(D));)D++;if(D<r&&D!==$){const b=t.slice($,D);for($=D;D<r&&c(t.charCodeAt(D));)D++;if(D<r&&D!==$){for($=D;D<r&&!c(t.charCodeAt(D));)D++;if(D===r)return`\\\\${b}\\${t.slice($)}\\`;D!==$&&(u=`\\\\${b}\\${t.slice($,D)}`,d=D)}}}else d=1;else i(h)&&t.charCodeAt(1)===A&&(u=t.slice(0,2),d=2,r>2&&c(t.charCodeAt(2))&&(l=!0,d=3));let k=d<r?n(t.slice(d),!l,"\\",c):"";return k.length===0&&!l&&(k="."),k.length>0&&c(t.charCodeAt(r-1))&&(k+="\\"),u===void 0?l?`\\${k}`:k:l?`${u}\\${k}`:`${u}${k}`},isAbsolute(t){S(t,"path");const r=t.length;if(r===0)return!1;const d=t.charCodeAt(0);return c(d)||r>2&&i(d)&&t.charCodeAt(1)===A&&c(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,d;for(let h=0;h<t.length;++h){const k=t[h];S(k,"path"),k.length>0&&(r===void 0?r=d=k:r+=`\\${k}`)}if(r===void 0)return".";let u=!0,l=0;if(typeof d=="string"&&c(d.charCodeAt(0))){++l;const h=d.length;h>1&&c(d.charCodeAt(1))&&(++l,h>2&&(c(d.charCodeAt(2))?++l:u=!1))}if(u){for(;l<r.length&&c(r.charCodeAt(l));)l++;l>=2&&(r=`\\${r.slice(l)}`)}return e.$ec.normalize(r)},relative(t,r){if(S(t,"from"),S(r,"to"),t===r)return"";const d=e.$ec.resolve(t),u=e.$ec.resolve(r);if(d===u||(t=d.toLowerCase(),r=u.toLowerCase(),t===r))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===g;)l++;let h=t.length;for(;h-1>l&&t.charCodeAt(h-1)===g;)h--;const k=h-l;let D=0;for(;D<r.length&&r.charCodeAt(D)===g;)D++;let $=r.length;for(;$-1>D&&r.charCodeAt($-1)===g;)$--;const b=$-D,v=k<b?k:b;let C=-1,N=0;for(;N<v;N++){const M=t.charCodeAt(l+N);if(M!==r.charCodeAt(D+N))break;M===g&&(C=N)}if(N!==v){if(C===-1)return u}else{if(b>v){if(r.charCodeAt(D+N)===g)return u.slice(D+N+1);if(N===2)return u.slice(D+N)}k>v&&(t.charCodeAt(l+N)===g?C=N:N===2&&(C=3)),C===-1&&(C=0)}let z="";for(N=l+C+1;N<=h;++N)(N===h||t.charCodeAt(N)===g)&&(z+=z.length===0?"..":"\\..");return D+=C,z.length>0?`${z}${u.slice(D,$)}`:(u.charCodeAt(D)===g&&++D,u.slice(D,$))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$ec.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===g){if(r.charCodeAt(1)===g){const d=r.charCodeAt(2);if(d!==P&&d!==w)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(i(r.charCodeAt(0))&&r.charCodeAt(1)===A&&r.charCodeAt(2)===g)return`\\\\?\\${r}`;return t},dirname(t){S(t,"path");const r=t.length;if(r===0)return".";let d=-1,u=0;const l=t.charCodeAt(0);if(r===1)return c(l)?t:".";if(c(l)){if(d=u=1,c(t.charCodeAt(1))){let D=2,$=D;for(;D<r&&!c(t.charCodeAt(D));)D++;if(D<r&&D!==$){for($=D;D<r&&c(t.charCodeAt(D));)D++;if(D<r&&D!==$){for($=D;D<r&&!c(t.charCodeAt(D));)D++;if(D===r)return t;D!==$&&(d=u=D+1)}}}}else i(l)&&t.charCodeAt(1)===A&&(d=r>2&&c(t.charCodeAt(2))?3:2,u=d);let h=-1,k=!0;for(let D=r-1;D>=u;--D)if(c(t.charCodeAt(D))){if(!k){h=D;break}}else k=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,r){r!==void 0&&S(r,"ext"),S(t,"path");let d=0,u=-1,l=!0,h;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(d=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let k=r.length-1,D=-1;for(h=t.length-1;h>=d;--h){const $=t.charCodeAt(h);if(c($)){if(!l){d=h+1;break}}else D===-1&&(l=!1,D=h+1),k>=0&&($===r.charCodeAt(k)?--k===-1&&(u=h):(k=-1,u=D))}return d===u?u=D:u===-1&&(u=t.length),t.slice(d,u)}for(h=t.length-1;h>=d;--h)if(c(t.charCodeAt(h))){if(!l){d=h+1;break}}else u===-1&&(l=!1,u=h+1);return u===-1?"":t.slice(d,u)},extname(t){S(t,"path");let r=0,d=-1,u=0,l=-1,h=!0,k=0;t.length>=2&&t.charCodeAt(1)===A&&i(t.charCodeAt(0))&&(r=u=2);for(let D=t.length-1;D>=r;--D){const $=t.charCodeAt(D);if(c($)){if(!h){u=D+1;break}continue}l===-1&&(h=!1,l=D+1),$===w?d===-1?d=D:k!==1&&(k=1):d!==-1&&(k=-1)}return d===-1||l===-1||k===0||k===1&&d===l-1&&d===u+1?"":t.slice(d,l)},format:o.bind(null,"\\"),parse(t){S(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const d=t.length;let u=0,l=t.charCodeAt(0);if(d===1)return c(l)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(c(l)){if(u=1,c(t.charCodeAt(1))){let C=2,N=C;for(;C<d&&!c(t.charCodeAt(C));)C++;if(C<d&&C!==N){for(N=C;C<d&&c(t.charCodeAt(C));)C++;if(C<d&&C!==N){for(N=C;C<d&&!c(t.charCodeAt(C));)C++;C===d?u=C:C!==N&&(u=C+1)}}}}else if(i(l)&&t.charCodeAt(1)===A){if(d<=2)return r.root=r.dir=t,r;if(u=2,c(t.charCodeAt(2))){if(d===3)return r.root=r.dir=t,r;u=3}}u>0&&(r.root=t.slice(0,u));let h=-1,k=u,D=-1,$=!0,b=t.length-1,v=0;for(;b>=u;--b){if(l=t.charCodeAt(b),c(l)){if(!$){k=b+1;break}continue}D===-1&&($=!1,D=b+1),l===w?h===-1?h=b:v!==1&&(v=1):h!==-1&&(v=-1)}return D!==-1&&(h===-1||v===0||v===1&&h===D-1&&h===k+1?r.base=r.name=t.slice(k,D):(r.name=t.slice(k,h),r.base=t.slice(k,D),r.ext=t.slice(h,D))),k>0&&k!==u?r.dir=t.slice(0,k-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(p){const t=/\\/g;return()=>{const r=I.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>I.cwd()})();e.$fc={resolve(...t){let r="",d=!1;for(let u=t.length-1;u>=-1&&!d;u--){const l=u>=0?t[u]:a();S(l,"path"),l.length!==0&&(r=`${l}/${r}`,d=l.charCodeAt(0)===E)}return r=n(r,!d,"/",s),d?`/${r}`:r.length>0?r:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===E,d=t.charCodeAt(t.length-1)===E;return t=n(t,!r,"/",s),t.length===0?r?"/":d?"./":".":(d&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===E},join(...t){if(t.length===0)return".";let r;for(let d=0;d<t.length;++d){const u=t[d];S(u,"path"),u.length>0&&(r===void 0?r=u:r+=`/${u}`)}return r===void 0?".":e.$fc.normalize(r)},relative(t,r){if(S(t,"from"),S(r,"to"),t===r||(t=e.$fc.resolve(t),r=e.$fc.resolve(r),t===r))return"";const d=1,u=t.length,l=u-d,h=1,k=r.length-h,D=l<k?l:k;let $=-1,b=0;for(;b<D;b++){const C=t.charCodeAt(d+b);if(C!==r.charCodeAt(h+b))break;C===E&&($=b)}if(b===D)if(k>D){if(r.charCodeAt(h+b)===E)return r.slice(h+b+1);if(b===0)return r.slice(h+b)}else l>D&&(t.charCodeAt(d+b)===E?$=b:b===0&&($=0));let v="";for(b=d+$+1;b<=u;++b)(b===u||t.charCodeAt(b)===E)&&(v+=v.length===0?"..":"/..");return`${v}${r.slice(h+$)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===E;let d=-1,u=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===E){if(!u){d=l;break}}else u=!1;return d===-1?r?"/":".":r&&d===1?"//":t.slice(0,d)},basename(t,r){r!==void 0&&S(r,"ext"),S(t,"path");let d=0,u=-1,l=!0,h;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let k=r.length-1,D=-1;for(h=t.length-1;h>=0;--h){const $=t.charCodeAt(h);if($===E){if(!l){d=h+1;break}}else D===-1&&(l=!1,D=h+1),k>=0&&($===r.charCodeAt(k)?--k===-1&&(u=h):(k=-1,u=D))}return d===u?u=D:u===-1&&(u=t.length),t.slice(d,u)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===E){if(!l){d=h+1;break}}else u===-1&&(l=!1,u=h+1);return u===-1?"":t.slice(d,u)},extname(t){S(t,"path");let r=-1,d=0,u=-1,l=!0,h=0;for(let k=t.length-1;k>=0;--k){const D=t.charCodeAt(k);if(D===E){if(!l){d=k+1;break}continue}u===-1&&(l=!1,u=k+1),D===w?r===-1?r=k:h!==1&&(h=1):r!==-1&&(h=-1)}return r===-1||u===-1||h===0||h===1&&r===u-1&&r===d+1?"":t.slice(r,u)},format:o.bind(null,"/"),parse(t){S(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const d=t.charCodeAt(0)===E;let u;d?(r.root="/",u=1):u=0;let l=-1,h=0,k=-1,D=!0,$=t.length-1,b=0;for(;$>=u;--$){const v=t.charCodeAt($);if(v===E){if(!D){h=$+1;break}continue}k===-1&&(D=!1,k=$+1),v===w?l===-1?l=$:b!==1&&(b=1):l!==-1&&(b=-1)}if(k!==-1){const v=h===0&&d?1:h;l===-1||b===0||b===1&&l===k-1&&l===h+1?r.base=r.name=t.slice(v,k):(r.name=t.slice(v,l),r.base=t.slice(v,k),r.ext=t.slice(l,k))}return h>0?r.dir=t.slice(0,h-1):d&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=p?e.$ec.normalize:e.$fc.normalize,e.$hc=p?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=p?e.$ec.join:e.$fc.join,e.$jc=p?e.$ec.resolve:e.$fc.resolve,e.$kc=p?e.$ec.relative:e.$fc.relative,e.$lc=p?e.$ec.dirname:e.$fc.dirname,e.$mc=p?e.$ec.basename:e.$fc.basename,e.$nc=p?e.$ec.extname:e.$fc.extname,e.$oc=p?e.$ec.format:e.$fc.format,e.$pc=p?e.$ec.parse:e.$fc.parse,e.$qc=p?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=p?e.$ec.sep:e.$fc.sep,e.$sc=p?e.$ec.delimiter:e.$fc.delimiter}),define(ke[129],Se([1,0,48,16]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=void 0;const m=new I.$U(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),L=new I.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new I.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function w(D,$,b=!1){const v=D||"",C=$||"",N=m.value.collator.compare(v,C);return m.value.collatorIsNumeric&&N===0&&v!==C?v<C?-1:1:N}e.$kq=w;function E(D,$){const b=L.value.collator;return D=D||"",$=$||"",o(b,D,$)}e.$lq=E;function g(D,$){const b=L.value.collator;return D=D||"",$=$||"",d(D,$)||o(b,D,$)}e.$mq=g;function A(D,$){const b=L.value.collator;return D=D||"",$=$||"",r(D,$)||o(b,D,$)}e.$nq=A;function P(D,$){return D=D||"",$=$||"",D===$?0:D<$?-1:1}e.$oq=P;function f(D,$){const[b,v]=i(D),[C,N]=i($);let z=m.value.collator.compare(v,N);if(z===0){if(m.value.collatorIsNumeric&&v!==N)return v<N?-1:1;if(z=m.value.collator.compare(b,C),m.value.collatorIsNumeric&&z===0&&b!==C)return b<C?-1:1}return z}e.$pq=f;function y(D,$){D=D||"",$=$||"";const b=n(D),v=n($),C=L.value.collator,N=R.value.collator;return o(N,b,v)||o(C,D,$)}e.$qq=y;function S(D,$){D=D||"",$=$||"";const b=n(D),v=n($),C=L.value.collator,N=R.value.collator;return o(N,b,v)||d(D,$)||o(C,D,$)}e.$rq=S;function p(D,$){D=D||"",$=$||"";const b=n(D),v=n($),C=L.value.collator,N=R.value.collator;return o(N,b,v)||r(D,$)||o(C,D,$)}e.$sq=p;function c(D,$){D=D||"",$=$||"";const b=n(D).toLowerCase(),v=n($).toLowerCase();return b!==v?b<v?-1:1:D!==$?D<$?-1:1:0}e.$tq=c;const s=/^(.*?)(\.([^.]*))?$/;function i(D,$=!1){const b=D?s.exec(D):[];let v=[b&&b[1]||"",b&&b[3]||""];return $&&(!v[0]&&v[1]||v[0]&&v[0].charAt(0)===".")&&(v=[v[0]+"."+v[1],""]),v}function n(D){const $=D?s.exec(D):[];return $&&$[1]&&$[1].charAt(0)!=="."&&$[3]||""}function o(D,$,b){const v=D.compare($,b);return v!==0?v:$.length!==b.length?$.length<b.length?-1:1:0}function a(D){const $=D.charAt(0);return $.toLocaleUpperCase()!==$}function t(D){const $=D.charAt(0);return $.toLocaleLowerCase()!==$}function r(D,$){return a(D)&&t($)?-1:t(D)&&a($)?1:0}function d(D,$){return t(D)&&a($)?-1:a(D)&&t($)?1:0}function u(D,$,b=!1){return b||(D=D&&D.toLowerCase(),$=$&&$.toLowerCase()),D===$?0:D<$?-1:1}function l(D,$,b=!1){const v=D.split(F.sep),C=$.split(F.sep),N=v.length-1,z=C.length-1;let M,T;for(let j=0;;j++){if(M=N===j,T=z===j,M&&T)return w(v[j],C[j],b);if(M)return-1;if(T)return 1;const O=u(v[j],C[j],b);if(O!==0)return O}}e.$uq=l;function h(D,$,b){const v=D.toLowerCase(),C=$.toLowerCase(),N=k(D,$,b);if(N)return N;const z=v.endsWith(b),M=C.endsWith(b);if(z!==M)return z?-1:1;const T=w(v,C);return T!==0?T:v.localeCompare(C)}e.$vq=h;function k(D,$,b){const v=D.toLowerCase(),C=$.toLowerCase(),N=v.startsWith(b),z=C.startsWith(b);if(N!==z)return N?-1:1;if(N&&z){if(v.length<C.length)return-1;if(v.length>C.length)return 1}return 0}e.$wq=k}),define(ke[33],Se([1,0,16,12,13,18]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=void 0;function R(h){return h===47||h===92}e.$Rf=R;function w(h){return h.replace(/[\\/]/g,I.$fc.sep)}e.$Sf=w;function E(h){return h.indexOf("/")===-1&&(h=w(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Tf=E;function g(h,k=I.$fc.sep){if(!h)return"";const D=h.length,$=h.charCodeAt(0);if(R($)){if(R(h.charCodeAt(1))&&!R(h.charCodeAt(2))){let v=3;const C=v;for(;v<D&&!R(h.charCodeAt(v));v++);if(C!==v&&!R(h.charCodeAt(v+1))){for(v+=1;v<D;v++)if(R(h.charCodeAt(v)))return h.slice(0,v+1).replace(/[\\/]/g,k)}}return k}else if(s($)&&h.charCodeAt(1)===58)return R(h.charCodeAt(2))?h.slice(0,2)+k:h.slice(0,2);let b=h.indexOf("://");if(b!==-1){for(b+=3;b<D;b++)if(R(h.charCodeAt(b)))return h.slice(0,b+1)}return""}e.$Uf=g;function A(h){if(!F.$i||!h||h.length<5)return!1;let k=h.charCodeAt(0);if(k!==92||(k=h.charCodeAt(1),k!==92))return!1;let D=2;const $=D;for(;D<h.length&&(k=h.charCodeAt(D),k!==92);D++);return!($===D||(k=h.charCodeAt(D+1),isNaN(k)||k===92))}e.$Vf=A;const P=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(h,k=F.$i){const D=k?P:f;return!(!h||h.length===0||/^\s+$/.test(h)||(D.lastIndex=0,D.test(h))||k&&y.test(h)||h==="."||h===".."||k&&h[h.length-1]==="."||k&&h.length!==h.trim().length||h.length>255)}e.$Wf=S;function p(h,k,D){const $=h===k;return!D||$?$:!h||!k?!1:(0,m.$3e)(h,k)}e.$Xf=p;function c(h,k,D,$=I.sep){if(h===k)return!0;if(!h||!k||k.length>h.length)return!1;if(D){if(!(0,m.$4e)(h,k))return!1;if(k.length===h.length)return!0;let v=k.length;return k.charAt(k.length-1)===$&&v--,h.charAt(v)===$}return k.charAt(k.length-1)!==$&&(k+=$),h.indexOf(k)===0}e.$Yf=c;function s(h){return h>=65&&h<=90||h>=97&&h<=122}e.$Zf=s;function i(h,k){return F.$i&&h.endsWith(":")&&(h+=I.sep),(0,I.$hc)(h)||(h=(0,I.$ic)(k,h)),h=(0,I.$gc)(h),F.$i?(h=(0,m.$Le)(h,I.sep),h.endsWith(":")&&(h+=I.sep)):(h=(0,m.$Le)(h,I.sep),h||(h=I.sep)),h}e.$1f=i;function n(h){const k=(0,I.$gc)(h);return F.$i?h.length>3?!1:o(k)&&(h.length===2||k.charCodeAt(2)===92):k===I.$fc.sep}e.$2f=n;function o(h,k=F.$i){return k?s(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$3f=o;function a(h,k=F.$i){return o(h,k)?h[0]:void 0}e.$4f=a;function t(h,k,D){return k.length>h.length?-1:h===k?0:(D&&(h=h.toLowerCase(),k=k.toLowerCase()),h.indexOf(k))}e.$5f=t;function r(h){const k=h.split(":");let D,$,b;for(const v of k){const C=Number(v);(0,L.$Df)(C)?$===void 0?$=C:b===void 0&&(b=C):D=D?[D,v].join(":"):v}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:$!==void 0?$:void 0,column:b!==void 0?b:$!==void 0?1:void 0}}e.$6f=r;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(h,k,D=8){let $="";for(let v=0;v<D;v++){let C;v===0&&F.$i&&!k&&(D===3||D===4)?C=u:C=d,$+=C.charAt(Math.floor(Math.random()*C.length))}let b;return k?b=`${k}-${$}`:b=$,h?(0,I.$ic)(h,b):b}e.$7f=l}),define(ke[130],Se([1,0,129,124,52,16,12,13]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=void 0;const E=0,g=[E,[]];function A(q,V,de,ee){if(!q||!V)return g;const X=q.length,Q=V.length;if(X<Q)return g;const ae=q.toLowerCase();return P(V,de,Q,q,ae,X,ee)}e.$xq=A;function P(q,V,de,ee,X,Q,ae){const x=[],se=[];for(let ce=0;ce<de;ce++){const be=ce*Q,H=be-Q,Z=ce>0,Y=q[ce],$e=V[ce];for(let ne=0;ne<Q;ne++){const fe=ne>0,te=be+ne,he=te-1,we=H+ne-1,Pe=fe?x[he]:0,B=Z&&fe?x[we]:0,J=Z&&fe?se[we]:0;let re;!B&&Z?re=0:re=f(Y,$e,ee,X,ne,J),re&&B+re>=Pe&&(ae||Z||X.startsWith(V,ne))?(se[te]=J+1,x[te]=B+re):(se[te]=E,x[te]=Pe)}}const pe=[];let G=de-1,U=Q-1;for(;G>=0&&U>=0;){const ce=G*Q+U;se[ce]===E||(pe.push(U),G--),U--}return[x[de*Q-1],pe.reverse()]}function f(q,V,de,ee,X,Q){let ae=0;if(!y(V,ee[X]))return ae;if(ae+=1,Q>0&&(ae+=Q*5),q===de[X]&&(ae+=1),X===0)ae+=8;else{const x=S(de.charCodeAt(X-1));x?ae+=x:(0,F.$Jj)(de.charCodeAt(X))&&Q===0&&(ae+=2)}return ae}function y(q,V){return q===V?!0:q==="/"||q==="\\"?V==="/"||V==="\\":!1}function S(q){switch(q){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function c(q,V,de=0,ee=0){const X=V;return X.values&&X.values.length>1?s(q,X.values,de,ee):i(q,V,de,ee)}e.$yq=c;function s(q,V,de,ee){let X=0;const Q=[];for(const ae of V){const[x,se]=i(q,ae,de,ee);if(typeof x!="number")return p;X+=x,Q.push(...se)}return[X,D(Q)]}function i(q,V,de,ee){const X=(0,F.$Sj)(V.original,V.originalLowercase,de,q,q.toLowerCase(),ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?[X[0],(0,F.$Pj)(X)]:p}const n=Object.freeze({score:0}),o=1<<18,a=1<<17,t=1<<16;function r(q,V,de,ee){const X=ee.values?ee.values:[ee];return(0,m.$Gi)({[ee.normalized]:{values:X.map(ae=>({value:ae.normalized,expectContiguousMatch:ae.expectContiguousMatch})),label:q,description:V,allowNonContiguousMatches:de}})}function d(q,V,de,ee,X){if(!q||!V.normalized)return n;const Q=ee.getItemLabel(q);if(!Q)return n;const ae=ee.getItemDescription(q),x=r(Q,ae,de,V),se=X[x];if(se)return se;const pe=u(Q,ae,ee.getItemPath(q),V,de);return X[x]=pe,pe}e.$zq=d;function u(q,V,de,ee,X){const Q=!de||!ee.containsPathSeparator;return de&&(R.$k?ee.pathNormalized===de:(0,w.$3e)(ee.pathNormalized,de))?{score:o,labelMatch:[{start:0,end:q.length}],descriptionMatch:V?[{start:0,end:V.length}]:void 0}:ee.values&&ee.values.length>1?l(q,V,de,ee.values,Q,X):h(q,V,de,ee,Q,X)}function l(q,V,de,ee,X,Q){let ae=0;const x=[],se=[];for(const pe of ee){const{score:G,labelMatch:U,descriptionMatch:ce}=h(q,V,de,pe,X,Q);if(G===E)return n;ae+=G,U&&x.push(...U),ce&&se.push(...ce)}return{score:ae,labelMatch:D(x),descriptionMatch:D(se)}}function h(q,V,de,ee,X,Q){if(X||!V){const[ae,x]=A(q,ee.normalized,ee.normalizedLowercase,Q&&!ee.expectContiguousMatch);if(ae){const se=(0,F.$Gj)(ee.normalized,q);let pe;if(se){pe=a;const G=Math.round(ee.normalized.length/q.length*100);pe+=G}else pe=t;return{score:pe+ae,labelMatch:se||k(x)}}}if(V){let ae=V;de&&(ae=`${V}${L.sep}`);const x=ae.length,se=`${ae}${q}`,[pe,G]=A(se,ee.normalized,ee.normalizedLowercase,Q&&!ee.expectContiguousMatch);if(pe){const U=k(G),ce=[],be=[];return U.forEach(H=>{H.start<x&&H.end>x?(ce.push({start:0,end:H.end-x}),be.push({start:H.start,end:x})):H.start>=x?ce.push({start:H.start-x,end:H.end-x}):be.push(H)}),{score:pe,labelMatch:ce,descriptionMatch:be}}}return n}function k(q){const V=[];if(!q)return V;let de;for(const ee of q)de&&de.end===ee?de.end+=1:(de={start:ee,end:ee+1},V.push(de));return V}function D(q){const V=q.sort((X,Q)=>X.start-Q.start),de=[];let ee;for(const X of V)!ee||!$(ee,X)?(ee=X,de.push(X)):(ee.start=Math.min(ee.start,X.start),ee.end=Math.max(ee.end,X.end));return de}function $(q,V){return!(q.end<V.start||V.end<q.start)}function b(q,V,de,ee,X,Q){const ae=d(q,de,ee,X,Q),x=d(V,de,ee,X,Q),se=ae.score,pe=x.score;if((se===o||pe===o)&&se!==pe)return se===o?-1:1;if(se>t||pe>t){if(se!==pe)return se>pe?-1:1;if(se<a&&pe<a){const Y=C(ae.labelMatch,x.labelMatch);if(Y!==0)return Y}const H=X.getItemLabel(q)||"",Z=X.getItemLabel(V)||"";if(H.length!==Z.length)return H.length-Z.length}if(se!==pe)return se>pe?-1:1;const G=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0,U=Array.isArray(x.labelMatch)&&x.labelMatch.length>0;if(G&&!U)return-1;if(U&&!G)return 1;const ce=v(q,ae,X),be=v(V,x,X);return ce&&be&&ce!==be?be>ce?-1:1:N(q,V,de,X)}e.$Aq=b;function v(q,V,de){let ee=-1,X=-1;if(V.descriptionMatch&&V.descriptionMatch.length?ee=V.descriptionMatch[0].start:V.labelMatch&&V.labelMatch.length&&(ee=V.labelMatch[0].start),V.labelMatch&&V.labelMatch.length){if(X=V.labelMatch[V.labelMatch.length-1].end,V.descriptionMatch&&V.descriptionMatch.length){const Q=de.getItemDescription(q);Q&&(X+=Q.length)}}else V.descriptionMatch&&V.descriptionMatch.length&&(X=V.descriptionMatch[V.descriptionMatch.length-1].end);return X-ee}function C(q,V){if(!q&&!V||(!q||!q.length)&&(!V||!V.length))return 0;if(!V||!V.length)return-1;if(!q||!q.length)return 1;const de=q[0].start,X=q[q.length-1].end-de,Q=V[0].start,x=V[V.length-1].end-Q;return X===x?0:x<X?1:-1}function N(q,V,de,ee){const X=ee.getItemLabel(q)||"",Q=ee.getItemLabel(V)||"",ae=ee.getItemDescription(q),x=ee.getItemDescription(V),se=X.length+(ae?ae.length:0),pe=Q.length+(x?x.length:0);if(se!==pe)return se-pe;const G=ee.getItemPath(q),U=ee.getItemPath(V);return G&&U&&G.length!==U.length?G.length-U.length:X!==Q?(0,I.$vq)(X,Q,de.normalized):ae&&x&&ae!==x?(0,I.$vq)(ae,x,de.normalized):G&&U&&G!==U?(0,I.$vq)(G,U,de.normalized):0}function z(q){return q.startsWith('"')&&q.endsWith('"')}const M=" ";function T(q){typeof q!="string"&&(q="");const V=q.toLowerCase(),{pathNormalized:de,normalized:ee,normalizedLowercase:X}=j(q),Q=de.indexOf(L.sep)>=0,ae=z(q);let x;const se=q.split(M);if(se.length>1)for(const pe of se){const G=z(pe),{pathNormalized:U,normalized:ce,normalizedLowercase:be}=j(pe);ce&&(x||(x=[]),x.push({original:pe,originalLowercase:pe.toLowerCase(),pathNormalized:U,normalized:ce,normalizedLowercase:be,expectContiguousMatch:G}))}return{original:q,originalLowercase:V,pathNormalized:de,normalized:ee,normalizedLowercase:X,values:x,containsPathSeparator:Q,expectContiguousMatch:ae}}e.$Bq=T;function j(q){let V;R.$i?V=q.replace(/\//g,L.sep):V=q.replace(/\\/g,L.sep);const de=(0,w.$Ne)(V).replace(/\s|"/g,"");return{pathNormalized:V,normalized:de,normalizedLowercase:de.toLowerCase()}}function O(q){return Array.isArray(q)?T(q.map(V=>V.original).join(M)):T(q.original)}e.$Cq=O}),define(ke[100],Se([1,0,16]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=e.$Ur=e.$Tr=e.$Sr=void 0,e.$Sr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},m={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(A){const P=(0,I.$nc)(A),f=F[P.toLowerCase()];return f!==void 0?f:R(A)}e.$Tr=L;function R(A){const P=(0,I.$nc)(A);return m[P.toLowerCase()]}e.$Ur=R;function w(A){for(const P in m)if(m[P]===A)return P}e.$Vr=w;const E=/^(.+)\/(.+?)(;.+)?$/;function g(A,P){const f=E.exec(A);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:P?void 0:A}e.$Wr=g}),define(ke[101],Se([1,0,12]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=e.$Cl=e.TerminateResponseCode=e.Source=void 0;var F;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(F||(e.Source=F={}));var m;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(m||(e.TerminateResponseCode=m={}));function L(w,...E){const g=E.reduce((f,y)=>(f[y]=!0,f),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter(f=>!g[f]).forEach(f=>{for(let y=0;y<A.length;y++)if(f.search(A[y])!==-1){delete w[f];break}})}e.$Cl=L;function R(w){w&&(delete w.DEBUG,I.$j&&delete w.DYLD_LIBRARY_PATH,I.$k&&delete w.LD_PRELOAD)}e.$Dl=R}),define(ke[2],Se([1,0,16,12]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const m=/^\w[\w\d+.-]*$/,L=/^\//,R=/^\/\//;function w(u,l){if(!u.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!m.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!L.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(u,l){return!u&&!l?"file":u}function g(u,l){switch(u){case"https":case"http":case"file":l?l[0]!==P&&(l=P+l):l=P;break}return l}const A="",P="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(l){return l instanceof y?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,h,k,D,$,b=!1){typeof l=="object"?(this.scheme=l.scheme||A,this.authority=l.authority||A,this.path=l.path||A,this.query=l.query||A,this.fragment=l.fragment||A):(this.scheme=E(l,b),this.authority=h||A,this.path=g(this.scheme,k||A),this.query=D||A,this.fragment=$||A,w(this,b))}get fsPath(){return o(this,!1)}with(l){if(!l)return this;let{scheme:h,authority:k,path:D,query:$,fragment:b}=l;return h===void 0?h=this.scheme:h===null&&(h=A),k===void 0?k=this.authority:k===null&&(k=A),D===void 0?D=this.path:D===null&&(D=A),$===void 0?$=this.query:$===null&&($=A),b===void 0?b=this.fragment:b===null&&(b=A),h===this.scheme&&k===this.authority&&D===this.path&&$===this.query&&b===this.fragment?this:new c(h,k,D,$,b)}static parse(l,h=!1){const k=f.exec(l);return k?new c(k[2]||A,d(k[4]||A),d(k[5]||A),d(k[7]||A),d(k[9]||A),h):new c(A,A,A,A,A)}static file(l){let h=A;if(F.$i&&(l=l.replace(/\\/g,P)),l[0]===P&&l[1]===P){const k=l.indexOf(P,2);k===-1?(h=l.substring(2),l=P):(h=l.substring(2,k),l=l.substring(k)||P)}return new c("file",h,l,A,A)}static from(l,h){return new c(l.scheme,l.authority,l.path,l.query,l.fragment,h)}static joinPath(l,...h){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return F.$i&&l.scheme==="file"?k=y.file(I.$ec.join(o(l,!0),...h)).path:k=I.$fc.join(l.path,...h),l.with({path:k})}toString(l=!1){return a(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof y)return l;{const h=new c(l);return h._formatted=l.external??null,h._fsPath=l._sep===p?l.fsPath??null:null,h}}else return l}}e.URI=y;function S(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}e.$uc=S;const p=F.$i?1:void 0;class c extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(l=!1){return l?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=p),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(u,l,h){let k,D=-1;for(let $=0;$<u.length;$++){const b=u.charCodeAt($);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||l&&b===47||h&&b===91||h&&b===93||h&&b===58)D!==-1&&(k+=encodeURIComponent(u.substring(D,$)),D=-1),k!==void 0&&(k+=u.charAt($));else{k===void 0&&(k=u.substr(0,$));const v=s[b];v!==void 0?(D!==-1&&(k+=encodeURIComponent(u.substring(D,$)),D=-1),k+=v):D===-1&&(D=$)}}return D!==-1&&(k+=encodeURIComponent(u.substring(D))),k!==void 0?k:u}function n(u){let l;for(let h=0;h<u.length;h++){const k=u.charCodeAt(h);k===35||k===63?(l===void 0&&(l=u.substr(0,h)),l+=s[k]):l!==void 0&&(l+=u[h])}return l!==void 0?l:u}function o(u,l){let h;return u.authority&&u.path.length>1&&u.scheme==="file"?h=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?l?h=u.path.substr(1):h=u.path[1].toLowerCase()+u.path.substr(2):h=u.path,F.$i&&(h=h.replace(/\//g,"\\")),h}e.$vc=o;function a(u,l){const h=l?n:i;let k="",{scheme:D,authority:$,path:b,query:v,fragment:C}=u;if(D&&(k+=D,k+=":"),($||D==="file")&&(k+=P,k+=P),$){let N=$.indexOf("@");if(N!==-1){const z=$.substr(0,N);$=$.substr(N+1),N=z.lastIndexOf(":"),N===-1?k+=h(z,!1,!1):(k+=h(z.substr(0,N),!1,!1),k+=":",k+=h(z.substr(N+1),!1,!0)),k+="@"}$=$.toLowerCase(),N=$.lastIndexOf(":"),N===-1?k+=h($,!1,!0):(k+=h($.substr(0,N),!1,!0),k+=$.substr(N))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const N=b.charCodeAt(1);N>=65&&N<=90&&(b=`/${String.fromCharCode(N+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const N=b.charCodeAt(0);N>=65&&N<=90&&(b=`${String.fromCharCode(N+32)}:${b.substr(2)}`)}k+=h(b,!0,!1)}return v&&(k+="?",k+=h(v,!1,!1)),C&&(k+="#",k+=l?C:i(C,!1,!1)),k}function t(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+t(u.substr(3)):u}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(u){return u.match(r)?u.replace(r,l=>t(l)):u}}),define(ke[185],Se([1,0,2]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$3p=e.$2p=e.$1p=void 0;function F(g){const A=g;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$1p=F;function m(g){const A=[];let P;try{const f=JSON.parse(g.arguments),y=f[f.length-1];y&&y.__$stack&&(f.pop(),P=y.__$stack),A.push(...f)}catch{A.push("Unable to log remote console arguments",g.arguments)}return{args:A,stack:P}}e.$2p=m;function L(g){if(typeof g!="string")return L(m(g).stack);const A=g;if(A){const P=R(A),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(f&&f.length===4)return{uri:I.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.$3p=L;function R(g){if(!g)return g;const A=g.indexOf(`
`);return A===-1?g:g.substring(0,A)}function w(g,A){const{args:P,stack:f}=m(g),y=typeof P[0]=="string"&&P.length===1;let S=R(f);S&&(S=`(${S.trim()})`);let p=[];if(typeof P[0]=="string"?S&&y?p=[`%c[${A}] %c${P[0]} %c${S}`,E("blue"),E(""),E("grey")]:p=[`%c[${A}] %c${P[0]}`,E("blue"),E(""),...P.slice(1)]:p=[`%c[${A}]%`,E("blue"),...P],S&&!y&&p.push(S),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,p)}e.log=w;function E(g){return`color: ${g}`}}),define(ke[54],Se([1,0,22,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=void 0;function m(E){return JSON.stringify(E,R)}e.$nh=m;function L(E){let g=JSON.parse(E);return g=w(g),g}e.$oh=L;function R(E,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function w(E,g=0){if(!E||g>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return F.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof I.$ce||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let A=0;A<E.length;++A)E[A]=w(E[A],g+1);else for(const A in E)Object.hasOwnProperty.call(E,A)&&(E[A]=w(E[A],g+1))}return E}e.$ph=w}),define(ke[17],Se([1,0,11,12,2]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.Schemas=void 0;var L;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$8f="vscode-tkn",e.$9f="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${L.vscodeRemoteResource}`}set(A,P,f){this.a[A]=P,this.b[A]=f}setConnectionToken(A,P){this.c[A]=P}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(c){return I.$Z(c),A}const P=A.authority;let f=this.a[P];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const y=this.b[P],S=this.c[P];let p=`path=${encodeURIComponent(A.path)}`;return typeof S=="string"&&(p+=`&${e.$9f}=${encodeURIComponent(S)}`),m.URI.from({scheme:F.$o?this.d:L.vscodeRemoteResource,authority:`${f}:${y}`,path:this.f,query:p})}}e.$0f=new R,e.$$f="vs/../../extensions",e.$_f="vs/../../node_modules",e.$ag="vs/../../node_modules.asar",e.$bg="vs/../../node_modules.asar.unpacked",e.$cg="vscode-app";class w{static{this.a=e.$cg}asBrowserUri(A){const P=this.b(A,me);return this.uriToBrowserUri(P)}uriToBrowserUri(A){return A.scheme===L.vscodeRemote?e.$0f.rewrite(A):A.scheme===L.file&&(F.$m||F.$q===`${L.vscodeFileResource}://${w.a}`)?A.with({scheme:L.vscodeFileResource,authority:A.authority||w.a,query:null,fragment:null}):A}asFileUri(A){const P=this.b(A,me);return this.uriToFileUri(P)}uriToFileUri(A){return A.scheme===L.vscodeFileResource?A.with({scheme:L.file,authority:A.authority!==w.a?A.authority:null,query:null,fragment:null}):A}b(A,P){return m.URI.isUri(A)?A:m.URI.parse(P.toUrl(A))}}e.$dg=new w;var E;(function(g){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(A.get("3"));const P="vscode-coi";function f(S){let p;typeof S=="string"?p=new URL(S).searchParams:S instanceof URL?p=S.searchParams:m.URI.isUri(S)&&(p=new URL(S.toString(!0)).searchParams);const c=p?.get(P);if(c)return A.get(c)}g.getHeadersFromQuery=f;function y(S,p,c){if(!globalThis.crossOriginIsolated)return;const s=p&&c?"3":c?"2":"1";S instanceof URLSearchParams?S.set(P,s):S[P]=s}g.addSearchParam=y})(E||(e.COI=E={}))}),define(ke[186],Se([1,0,159,17,12,2]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=void 0;class R{constructor(f,y,S){this.id=f,this.dependencies=y,this.callback=S}}class w{static{this.INSTANCE=new w}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(f,y,S)=>{typeof f!="string"&&(S=y,y=f,f=null),(typeof y!="object"||!Array.isArray(y))&&(S=y,y=null),this.c.push(new R(f,y,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){if(f.startsWith(window.location.origin)||f.startsWith("vscode-file://vscode-app"))return f;throw new Error(`[trusted_script_src] Invalid script url: ${f}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){return f}})))}async load(f){this.g();const y=await(this.a?this.i(f):this.b?this.h(f):this.j(f));if(!y)throw new Error(`Did not receive a define call from script ${f}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${f}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(f){return new Promise((y,S)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const c=()=>{p.removeEventListener("load",s),p.removeEventListener("error",i)},s=n=>{c(),y(this.c.pop())},i=n=>{c(),S(n)};p.addEventListener("load",s),p.addEventListener("error",i),this.f&&(f=this.f.createScriptURL(f)),p.setAttribute("src",f),window.document.getElementsByTagName("head")[0].appendChild(p)})}i(f){return new Promise((y,S)=>{try{this.f&&(f=this.f.createScriptURL(f)),importScripts(f),y(this.c.pop())}catch(p){S(p)}})}async j(f){try{const y=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,c=L.URI.parse(f).fsPath,s=y.readFileSync(c).toString(),i=p.wrap(s.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const E=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function A(P,f,y){if(I.$S){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[P]&&(P=g[P]);const S=`${P}/${f}`;if(E.has(S))return E.get(S);let p;if(/^\w[\w\d+.-]*:\/\//.test(S))p=S;else{const n=`${y&&!m.$o?F.$ag:F.$_f}/${S}`;p=F.$dg.asBrowserUri(n).toString(!0)}const c=w.INSTANCE.load(p);return E.set(S,c),c}else return await new Promise((S,p)=>{me([P],S,p)})}e.$KC=A}),define(ke[23],Se([1,0,33,17,16,12,13,2]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.DataUri=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=void 0;function E(y){return(0,w.$vc)(y,!0)}e.$kg=E;class g{constructor(S){this.a=S}compare(S,p,c=!1){return S===p?0:(0,R.$Ve)(this.getComparisonKey(S,c),this.getComparisonKey(p,c))}isEqual(S,p,c=!1){return S===p?!0:!S||!p?!1:this.getComparisonKey(S,c)===this.getComparisonKey(p,c)}getComparisonKey(S,p=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,p,c=!1){if(S.scheme===p.scheme){if(S.scheme===F.Schemas.file)return I.$Yf(E(S),E(p),this.a(S))&&S.query===p.query&&(c||S.fragment===p.fragment);if((0,e.$Bg)(S.authority,p.authority))return I.$Yf(S.path,p.path,this.a(S),"/")&&S.query===p.query&&(c||S.fragment===p.fragment)}return!1}joinPath(S,...p){return w.URI.joinPath(S,...p)}basenameOrAuthority(S){return(0,e.$tg)(S)||S.authority}basename(S){return m.$fc.basename(S.path)}extname(S){return m.$fc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let p;return S.scheme===F.Schemas.file?p=w.URI.file(m.$lc(E(S))).path:(p=m.$fc.dirname(S.path),S.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),p="/")),S.with({path:p})}normalizePath(S){if(!S.path.length)return S;let p;return S.scheme===F.Schemas.file?p=w.URI.file(m.$gc(E(S))).path:p=m.$fc.normalize(S.path),S.with({path:p})}relativePath(S,p){if(S.scheme!==p.scheme||!(0,e.$Bg)(S.authority,p.authority))return;if(S.scheme===F.Schemas.file){const i=m.$kc(E(S),E(p));return L.$i?I.$Sf(i):i}let c=S.path||"/";const s=p.path||"/";if(this.a(S)){let i=0;for(const n=Math.min(c.length,s.length);i<n&&!(c.charCodeAt(i)!==s.charCodeAt(i)&&c.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);c=s.substr(0,i)+c.substr(i)}return m.$fc.relative(c,s)}resolvePath(S,p){if(S.scheme===F.Schemas.file){const c=w.URI.file(m.$jc(E(S),p));return S.with({authority:c.authority,path:c.path})}return p=I.$Tf(p),S.with({path:m.$fc.resolve(S.path,p)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,p){return S===p||S!==void 0&&p!==void 0&&(0,R.$3e)(S,p)}hasTrailingPathSeparator(S,p=m.sep){if(S.scheme===F.Schemas.file){const c=E(S);return c.length>I.$Uf(c).length&&c[c.length-1]===p}else{const c=S.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,p=m.sep){return(0,e.$Cg)(S,p)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,p=m.sep){let c=!1;if(S.scheme===F.Schemas.file){const s=E(S);c=s!==void 0&&s.length===I.$Uf(s).length&&s[s.length-1]===p}else{p="/";const s=S.path;c=s.length===1&&s.charCodeAt(s.length-1)===47}return!c&&!(0,e.$Cg)(S,p)?S.with({path:S.path+"/"}):S}}e.$lg=g,e.$mg=new g(()=>!1),e.$ng=new g(y=>y.scheme===F.Schemas.file?!L.$k:!0),e.$og=new g(y=>!0),e.$pg=e.$mg.isEqual.bind(e.$mg),e.$qg=e.$mg.isEqualOrParent.bind(e.$mg),e.$rg=e.$mg.getComparisonKey.bind(e.$mg),e.$sg=e.$mg.basenameOrAuthority.bind(e.$mg),e.$tg=e.$mg.basename.bind(e.$mg),e.$ug=e.$mg.extname.bind(e.$mg),e.$vg=e.$mg.dirname.bind(e.$mg),e.$wg=e.$mg.joinPath.bind(e.$mg),e.$xg=e.$mg.normalizePath.bind(e.$mg),e.$yg=e.$mg.relativePath.bind(e.$mg),e.$zg=e.$mg.resolvePath.bind(e.$mg),e.$Ag=e.$mg.isAbsolutePath.bind(e.$mg),e.$Bg=e.$mg.isEqualAuthority.bind(e.$mg),e.$Cg=e.$mg.hasTrailingPathSeparator.bind(e.$mg),e.$Dg=e.$mg.removeTrailingPathSeparator.bind(e.$mg),e.$Eg=e.$mg.addTrailingPathSeparator.bind(e.$mg);function A(y,S){const p=[];for(let c=0;c<y.length;c++){const s=S(y[c]);y.some((i,n)=>n===c?!1:(0,e.$qg)(s,S(i)))||p.push(y[c])}return p}e.$Fg=A;var P;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function S(p){const c=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(n=>{const[o,a]=n.split(":");o&&a&&c.set(o,a)});const i=p.path.substring(0,p.path.indexOf(";"));return i&&c.set(y.META_DATA_MIME,i),c}y.parseMetaData=S})(P||(e.DataUri=P={}));function f(y,S,p){if(S){let c=y.path;return c&&c[0]!==m.$fc.sep&&(c=m.$fc.sep+c),y.with({scheme:p,authority:S,path:c})}return y.with({scheme:p})}e.$Gg=f}),define(ke[10],Se([1,0,21,11,4,3,23,12,163]),function(me,e,I,F,m,L,R,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=e.$gh=e.Promises=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function g(be){return!!be&&typeof be.then=="function"}e.$Hg=g;function A(be){const H=new I.$Yd,Z=be(H.token),Y=new Promise(($e,ne)=>{const fe=H.token.onCancellationRequested(()=>{fe.dispose(),H.dispose(),ne(new F.$4)});Promise.resolve(Z).then(te=>{fe.dispose(),H.dispose(),$e(te)},te=>{fe.dispose(),H.dispose(),ne(te)})});return new class{cancel(){H.cancel()}then($e,ne){return Y.then($e,ne)}catch($e){return this.then(void 0,$e)}finally($e){return Y.finally($e)}}}e.$Ig=A;function P(be,H,Z){return new Promise((Y,$e)=>{const ne=H.onCancellationRequested(()=>{ne.dispose(),Y(Z)});be.then(Y,$e).finally(()=>ne.dispose())})}e.$Jg=P;function f(be,H){return new Promise((Z,Y)=>{const $e=H.onCancellationRequested(()=>{$e.dispose(),Y(new F.$4)});be.then(Z,Y).finally(()=>$e.dispose())})}e.$Kg=f;async function y(be){let H=-1;const Z=be.map((Y,$e)=>Y.then(ne=>(H=$e,ne)));try{return await Promise.race(Z)}finally{be.forEach((Y,$e)=>{$e!==H&&Y.cancel()})}}e.$Lg=y;function S(be,H,Z){let Y;const $e=setTimeout(()=>{Y?.(void 0),Z?.()},H);return Promise.race([be.finally(()=>clearTimeout($e)),new Promise(ne=>Y=ne)])}e.$Mg=S;function p(be){return new Promise((H,Z)=>{const Y=be();g(Y)?Y.then(H,Z):H(Y)})}e.$Ng=p;class c{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const Z=()=>{if(this.b=null,this.f)return;const Y=this.queue(this.d);return this.d=null,Y};this.b=new Promise(Y=>{this.a.then(Z,Z).then(Y)})}return new Promise((Z,Y)=>{this.b.then(Z,Y)})}return this.a=H(),new Promise((Z,Y)=>{this.a.then($e=>{this.a=null,Z($e)},$e=>{this.a=null,Y($e)})})}dispose(){this.f=!0}}e.$Og=c;class s{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$Pg=s;class i{constructor(){this.a=new Map}queue(H,Z){const $e=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.a.get(H)===$e&&this.a.delete(H)});return this.a.set(H,$e),$e}}e.$Qg=i;const n=(be,H)=>{let Z=!0;const Y=setTimeout(()=>{Z=!1,H()},be);return{isTriggered:()=>Z,dispose:()=>{clearTimeout(Y),Z=!1}}},o=be=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,be())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class a{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,Z=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise(($e,ne)=>{this.d=$e,this.f=ne}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const Y=()=>{this.a=null,this.d?.(null)};return this.a=Z===E.$Ld?o(Y):n(Z,Y),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Rg=a;class t{constructor(H){this.a=new a(H),this.b=new c}trigger(H,Z){return this.a.trigger(()=>this.b.queue(H),Z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Sg=t;class r{constructor(){this.a=!1,this.b=new Promise((H,Z)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Tg=r;class d extends r{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$Ug=d;function u(be,H){return H?new Promise((Z,Y)=>{const $e=setTimeout(()=>{ne.dispose(),Z()},be),ne=H.onCancellationRequested(()=>{clearTimeout($e),ne.dispose(),Y(new F.$4)})}):A(Z=>u(be,Z))}e.$Vg=u;function l(be,H=0,Z){const Y=setTimeout(()=>{be(),Z&&$e.dispose()},H),$e=(0,L.$Pc)(()=>{clearTimeout(Y),Z?.deleteAndLeak($e)});return Z?.add($e),$e}e.$Wg=l;function h(be){const H=[];let Z=0;const Y=be.length;function $e(){return Z<Y?be[Z++]():null}function ne(fe){fe!=null&&H.push(fe);const te=$e();return te?te.then(ne):Promise.resolve(H)}return Promise.resolve(null).then(ne)}e.$Xg=h;function k(be,H=Y=>!!Y,Z=null){let Y=0;const $e=be.length,ne=()=>{if(Y>=$e)return Promise.resolve(Z);const fe=be[Y++];return Promise.resolve(fe()).then(he=>H(he)?Promise.resolve(he):ne())};return ne()}e.$Yg=k;function D(be,H=Y=>!!Y,Z=null){if(be.length===0)return Promise.resolve(Z);let Y=be.length;const $e=()=>{Y=-1;for(const ne of be)ne.cancel?.()};return new Promise((ne,fe)=>{for(const te of be)te.then(he=>{--Y>=0&&H(he)?($e(),ne(he)):Y===0&&ne(Z)}).catch(he=>{--Y>=0&&($e(),fe(he))})})}e.$Zg=D;class ${constructor(H){this.a=0,this.d=H,this.f=[],this.b=0,this.g=new m.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue(H){return this.a++,new Promise((Z,Y)=>{this.f.push({factory:H,c:Z,e:Y}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const H=this.f.shift();this.b++;const Z=H.factory();Z.then(H.c,H.e),Z.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$1g=$;class b extends ${constructor(){super(1)}}e.$2g=b;class v{constructor(){this.a=new ee,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$3g=v;class C{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new ae;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueFor(H,Z=R.$mg){const Y=Z.getComparisonKey(H);let $e=this.a.get(Y);if(!$e){$e=new b;const ne=this.f++,fe=m.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(Y),this.h(),this.d?.deleteAndDispose(ne),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$Zc),this.d.set(ne,fe),this.a.set(Y,$e)}return $e}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$4g=C;class N{constructor(H,Z){this.a=-1,typeof H=="function"&&typeof Z=="number"&&this.setIfNotSet(H,Z)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,Z){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},Z)}setIfNotSet(H,Z){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},Z))}}e.$5g=N;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(H,Z,Y=globalThis){this.cancel();const $e=Y.setInterval(()=>{H()},Z);this.d=(0,L.$Pc)(()=>{Y.clearInterval($e),this.d=void 0})}dispose(){this.cancel()}}e.$6g=z;class M{constructor(H,Z){this.b=-1,this.a=H,this.d=Z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$7g=M;class T{constructor(H,Z){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.a=H,this.b=Z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$8g=T;class j extends M{constructor(H,Z){super(H,Z),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$9g=j;class O extends L.$Rc{constructor(H,Z){super(),this.g=H,this.h=Z,this.a=[],this.b=this.B(new L.$Sc),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Z of H)this.a.push(Z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$0g=O,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$_g=(be,H)=>{(0,w.$B)(()=>{if(Z)return;const Y=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Y-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.$_g=(be,H,Z)=>{const Y=be.requestIdleCallback(H,typeof Z=="number"?{timeout:Z}:void 0);let $e=!1;return{dispose(){$e||($e=!0,be.cancelIdleCallback(Y))}}},e.$$g=be=>(0,e.$_g)(globalThis,be)}();class q{constructor(H,Z){this.g=!1,this.d=()=>{try{this.j=Z()}catch(Y){this.l=Y}finally{this.g=!0}},this.f=(0,e.$_g)(H,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$ah=q;class V extends q{constructor(H){super(globalThis,H)}}e.$bh=V;async function de(be,H,Z){let Y;for(let $e=0;$e<Z;$e++)try{return await be()}catch(ne){Y=ne,await u(H)}throw Y}e.$ch=de;class ee{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,Z,Y){return this.a={taskId:H,cancel:()=>Y?.(),promise:Z},Z.then(()=>this.d(H),()=>this.d(H)),Z}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{let Z,Y;const $e=new Promise((ne,fe)=>{Z=ne,Y=fe});this.b={run:H,promise:$e,promiseResolve:Z,promiseReject:Y}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$dh=ee;class X{constructor(H,Z=()=>Date.now()){this.d=H,this.f=Z,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$eh=X;var Q;(function(be){be[be.Resolved=0]="Resolved",be[be.Rejected=1]="Rejected"})(Q||(Q={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((H,Z)=>{this.a=H,this.b=Z})}complete(H){return new Promise(Z=>{this.a(H),this.d={outcome:0,value:H},Z()})}error(H){return new Promise(Z=>{this.b(H),this.d={outcome:1,value:H},Z()})}cancel(){return this.error(new F.$4)}}e.$fh=ae;var x;(function(be){async function H(Y){let $e;const ne=await Promise.all(Y.map(fe=>fe.then(te=>te,te=>{$e||($e=te)})));if(typeof $e<"u")throw $e;return ne}be.settled=H;function Z(Y){return new Promise(async($e,ne)=>{try{await Y($e,ne)}catch(fe){ne(fe)}})}be.withAsyncBody=Z})(x||(e.Promises=x={}));var se;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(se||(se={}));class pe{static fromArray(H){return new pe(Z=>{Z.emitMany(H)})}static fromPromise(H){return new pe(async Z=>{Z.emitMany(await H)})}static fromPromises(H){return new pe(async Z=>{await Promise.all(H.map(async Y=>Z.emitOne(await Y)))})}static merge(H){return new pe(async Z=>{await Promise.all(H.map(async Y=>{for await(const $e of Y)Z.emitOne($e)}))})}static{this.EMPTY=pe.fromArray([])}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new m.$Od,queueMicrotask(async()=>{const Z={emitOne:Y=>this.g(Y),emitMany:Y=>this.h(Y),reject:Y=>this.k(Y)};try{await Promise.resolve(H(Z)),this.j()}catch(Y){this.k(Y)}finally{Z.emitOne=void 0,Z.emitMany=void 0,Z.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await m.Event.toPromise(this.f.event)}while(!0)}}}static map(H,Z){return new pe(async Y=>{for await(const $e of H)Y.emitOne(Z($e))})}map(H){return pe.map(this,H)}static filter(H,Z){return new pe(async Y=>{for await(const $e of H)Z($e)&&Y.emitOne($e)})}filter(H){return pe.filter(this,H)}static coalesce(H){return pe.filter(H,Z=>!!Z)}coalesce(){return pe.coalesce(this)}static async toPromise(H){const Z=[];for await(const Y of H)Z.push(Y);return Z}toPromise(){return pe.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.$gh=pe;class G extends pe{constructor(H,Z){super(Z),this.l=H}cancel(){this.l.cancel()}}e.$hh=G;function U(be){const H=new I.$Yd,Z=be(H.token);return new G(H,async Y=>{const $e=H.token.onCancellationRequested(()=>{$e.dispose(),H.dispose(),Y.reject(new F.$4)});try{for await(const ne of Z){if(H.token.isCancellationRequested)return;Y.emitOne(ne)}$e.dispose(),H.dispose()}catch(ne){$e.dispose(),H.dispose(),Y.reject(ne)}})}e.$ih=U;class ce{constructor(){this.a=new ae,this.b=new pe(Y=>{if(H){Y.reject(H);return}return Z&&Y.emitMany(Z),this.d=$e=>Y.reject($e),this.f=$e=>Y.emitOne($e),this.a.p});let H,Z;this.f=Y=>{Z||(Z=[]),Z.push(Y)},this.d=Y=>{H||(H=Y)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(H){this.d(H),this.a.complete()}emitOne(H){this.f(H)}}e.$jh=ce}),define(ke[34],Se([1,0,19,10,33,28,16,12,13]),function(me,e,I,F,m,L,R,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=void 0;function g(){return Object.create(null)}e.$uj=g,e.$vj="**",e.$wj="/";const A="[/\\\\]",P="[^/\\\\]",f=/\//g;function y(de,ee){switch(de){case 0:return"";case 1:return`${P}*?`;default:return`(?:${A}|${P}+${A}${ee?`|${A}${P}+`:""})*?`}}function S(de,ee){if(!de)return[];const X=[];let Q=!1,ae=!1,x="";for(const se of de){switch(se){case ee:if(!Q&&!ae){X.push(x),x="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}x+=se}return x&&X.push(x),X}e.$xj=S;function p(de){if(!de)return"";let ee="";const X=S(de,e.$wj);if(X.every(Q=>Q===e.$vj))ee=".*";else{let Q=!1;X.forEach((ae,x)=>{if(ae===e.$vj){if(Q)return;ee+=y(2,x===X.length-1)}else{let se=!1,pe="",G=!1,U="";for(const ce of ae){if(ce!=="}"&&se){pe+=ce;continue}if(G&&(ce!=="]"||!U)){let be;ce==="-"?be=ce:(ce==="^"||ce==="!")&&!U?be="^":ce===e.$wj?be="":be=(0,E.$Ge)(ce),U+=be;continue}switch(ce){case"{":se=!0;continue;case"[":G=!0;continue;case"}":{const H=`(?:${S(pe,",").map(Z=>p(Z)).join("|")})`;ee+=H,se=!1,pe="";break}case"]":{ee+="["+U+"]",G=!1,U="";break}case"?":ee+=P;continue;case"*":ee+=y(1);continue;default:ee+=(0,E.$Ge)(ce)}}x<X.length-1&&(X[x+1]!==e.$vj||x+2<X.length)&&(ee+=A)}Q=ae===e.$vj})}return ee}const c=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Cc(1e4),r=function(){return!1},d=function(){return null};function u(de,ee){if(!de)return d;let X;typeof de!="string"?X=de.pattern:X=de,X=X.trim();const Q=`${X}_${!!ee.trimForExclusions}`;let ae=t.get(Q);if(ae)return l(ae,de);let x;return c.test(X)?ae=k(X.substr(4),X):(x=s.exec(h(X,ee)))?ae=D(x[1],X):(ee.trimForExclusions?n:i).test(X)?ae=$(X,ee):(x=o.exec(h(X,ee)))?ae=b(x[1].substr(1),X,!0):(x=a.exec(h(X,ee)))?ae=b(x[1],X,!1):ae=v(X),t.set(Q,ae),l(ae,de)}function l(de,ee){if(typeof ee=="string")return de;const X=function(Q,ae){return(0,m.$Yf)(Q,ee.base,!w.$k)?de((0,E.$Ke)(Q.substr(ee.base.length),R.sep),ae):null};return X.allBasenames=de.allBasenames,X.allPaths=de.allPaths,X.basenames=de.basenames,X.patterns=de.patterns,X}function h(de,ee){return ee.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function k(de,ee){return function(X,Q){return typeof X=="string"&&X.endsWith(de)?ee:null}}function D(de,ee){const X=`/${de}`,Q=`\\${de}`,ae=function(se,pe){return typeof se!="string"?null:pe?pe===de?ee:null:se===de||se.endsWith(X)||se.endsWith(Q)?ee:null},x=[de];return ae.basenames=x,ae.patterns=[ee],ae.allBasenames=x,ae}function $(de,ee){const X=q(de.slice(1,-1).split(",").map(pe=>u(pe,ee)).filter(pe=>pe!==d),de),Q=X.length;if(!Q)return d;if(Q===1)return X[0];const ae=function(pe,G){for(let U=0,ce=X.length;U<ce;U++)if(X[U](pe,G))return de;return null},x=X.find(pe=>!!pe.allBasenames);x&&(ae.allBasenames=x.allBasenames);const se=X.reduce((pe,G)=>G.allPaths?pe.concat(G.allPaths):pe,[]);return se.length&&(ae.allPaths=se),ae}function b(de,ee,X){const Q=R.sep===R.$fc.sep,ae=Q?de:de.replace(f,R.sep),x=R.sep+ae,se=R.$fc.sep+de;let pe;return X?pe=function(G,U){return typeof G=="string"&&(G===ae||G.endsWith(x)||!Q&&(G===de||G.endsWith(se)))?ee:null}:pe=function(G,U){return typeof G=="string"&&(G===ae||!Q&&G===de)?ee:null},pe.allPaths=[(X?"*/":"./")+de],pe}function v(de){try{const ee=new RegExp(`^${p(de)}$`);return function(X){return ee.lastIndex=0,typeof X=="string"&&ee.test(X)?de:null}}catch{return d}}function C(de,ee,X){return!de||typeof ee!="string"?!1:N(de)(ee,void 0,X)}e.$yj=C;function N(de,ee={}){if(!de)return r;if(typeof de=="string"||z(de)){const X=u(de,ee);if(X===d)return r;const Q=function(ae,x){return!!X(ae,x)};return X.allBasenames&&(Q.allBasenames=X.allBasenames),X.allPaths&&(Q.allPaths=X.allPaths),Q}return j(de,ee)}e.$zj=N;function z(de){const ee=de;return ee?typeof ee.base=="string"&&typeof ee.pattern=="string":!1}e.$Aj=z;function M(de){return de.allBasenames||[]}e.$Bj=M;function T(de){return de.allPaths||[]}e.$Cj=T;function j(de,ee){const X=q(Object.getOwnPropertyNames(de).map(pe=>O(pe,de[pe],ee)).filter(pe=>pe!==d)),Q=X.length;if(!Q)return d;if(!X.some(pe=>!!pe.requiresSiblings)){if(Q===1)return X[0];const pe=function(ce,be){let H;for(let Z=0,Y=X.length;Z<Y;Z++){const $e=X[Z](ce,be);if(typeof $e=="string")return $e;(0,F.$Hg)($e)&&(H||(H=[]),H.push($e))}return H?(async()=>{for(const Z of H){const Y=await Z;if(typeof Y=="string")return Y}return null})():null},G=X.find(ce=>!!ce.allBasenames);G&&(pe.allBasenames=G.allBasenames);const U=X.reduce((ce,be)=>be.allPaths?ce.concat(be.allPaths):ce,[]);return U.length&&(pe.allPaths=U),pe}const ae=function(pe,G,U){let ce,be;for(let H=0,Z=X.length;H<Z;H++){const Y=X[H];Y.requiresSiblings&&U&&(G||(G=(0,R.$mc)(pe)),ce||(ce=G.substr(0,G.length-(0,R.$nc)(pe).length)));const $e=Y(pe,G,ce,U);if(typeof $e=="string")return $e;(0,F.$Hg)($e)&&(be||(be=[]),be.push($e))}return be?(async()=>{for(const H of be){const Z=await H;if(typeof Z=="string")return Z}return null})():null},x=X.find(pe=>!!pe.allBasenames);x&&(ae.allBasenames=x.allBasenames);const se=X.reduce((pe,G)=>G.allPaths?pe.concat(G.allPaths):pe,[]);return se.length&&(ae.allPaths=se),ae}function O(de,ee,X){if(ee===!1)return d;const Q=u(de,X);if(Q===d)return d;if(typeof ee=="boolean")return Q;if(ee){const ae=ee.when;if(typeof ae=="string"){const x=(se,pe,G,U)=>{if(!U||!Q(se,pe))return null;const ce=ae.replace("$(basename)",()=>G),be=U(ce);return(0,F.$Hg)(be)?be.then(H=>H?de:null):be?de:null};return x.requiresSiblings=!0,x}}return Q}function q(de,ee){const X=de.filter(pe=>!!pe.basenames);if(X.length<2)return de;const Q=X.reduce((pe,G)=>{const U=G.basenames;return U?pe.concat(U):pe},[]);let ae;if(ee){ae=[];for(let pe=0,G=Q.length;pe<G;pe++)ae.push(ee)}else ae=X.reduce((pe,G)=>{const U=G.patterns;return U?pe.concat(U):pe},[]);const x=function(pe,G){if(typeof pe!="string")return null;if(!G){let ce;for(ce=pe.length;ce>0;ce--){const be=pe.charCodeAt(ce-1);if(be===47||be===92)break}G=pe.substr(ce)}const U=Q.indexOf(G);return U!==-1?ae[U]:null};x.basenames=Q,x.patterns=ae,x.allBasenames=Q;const se=de.filter(pe=>!pe.basenames);return se.push(x),se}function V(de,ee){return(0,I.$tb)(de,ee,(X,Q)=>typeof X=="string"&&typeof Q=="string"?X===Q:typeof X!="string"&&typeof Q!="string"?X.base===Q.base&&X.pattern===Q.pattern:!1)}e.$Dj=V}),define(ke[81],Se([1,0,11,164,23,13,2]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(w||(e.MarkdownStringTextNewlineStyle=w={}));class E{constructor(s="",i=!1){if(this.value=s,typeof this.value!="string")throw(0,I.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(s,i=0){return this.value+=f(this.supportThemeIcons?(0,F.$Zj)(s):s).replace(/([ \t]+)/g,(n,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,i){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=i,this.value+="\n```\n",this}appendLink(s,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(s),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(s,i){const n=new RegExp((0,L.$Ge)(i),"g");return s.replace(n,(o,a)=>s.charAt(a-1)!=="\\"?`\\${o}`:o)}}e.$6j=E;function g(c){return A(c)?!c.value:Array.isArray(c)?c.every(g):!0}e.$7j=g;function A(c){return c instanceof E?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.$8j=A;function P(c,s){return c===s?!0:!c||!s?!1:c.value===s.value&&c.isTrusted===s.isTrusted&&c.supportThemeIcons===s.supportThemeIcons&&c.supportHtml===s.supportHtml&&(c.baseUri===s.baseUri||!!c.baseUri&&!!s.baseUri&&(0,m.$pg)(R.URI.from(c.baseUri),R.URI.from(s.baseUri)))}e.$9j=P;function f(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$0j=f;function y(c){return c.replace(/"/g,"&quot;")}e.$$j=y;function S(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$_j=S;function p(c){const s=[],i=c.split("|").map(o=>o.trim());c=i[0];const n=i[1];if(n){const o=/height=(\d+)/.exec(n),a=/width=(\d+)/.exec(n),t=o?o[1]:"",r=a?a[1]:"",d=isFinite(parseInt(r)),u=isFinite(parseInt(t));d&&s.push(`width="${r}"`),u&&s.push(`height="${t}"`)}return{href:c,dimensions:s}}e.$ak=p}),define(ke[102],Se([1,0,19,33,16,12,23,13]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=void 0;function E(u,l){const{os:h,tildify:k,relative:D}=l;if(D){const v=g(u,D,h);if(typeof v=="string")return v}let $=u.fsPath;if(h===1&&!L.$i?$=$.replace(/\//g,"\\"):h!==1&&L.$i&&($=$.replace(/\\/g,"/")),h!==1&&k?.userHome){const v=k.userHome.fsPath;let C;u.scheme!==k.userHome.scheme&&u.path[0]===m.$fc.sep&&u.path[1]!==m.$fc.sep?C=k.userHome.with({path:u.path}).fsPath:C=$,$=f(C,v,h)}return(h===1?m.$ec:m.$fc).normalize(A($,h===1))}e.$uv=E;function g(u,l,h){const k=h===1?m.$ec:m.$fc,D=h===3?R.$mg:R.$og,$=l.getWorkspace(),b=(0,I.$Nb)($.folders);if(!b)return;u.scheme!==b.uri.scheme&&u.path[0]===m.$fc.sep&&u.path[1]!==m.$fc.sep&&(u=b.uri.with({path:u.path}));const v=l.getWorkspaceFolder(u);if(!v)return;let C;if(D.isEqual(v.uri,u)?C="":C=D.relativePath(v.uri,u)??"",C&&(C=k.normalize(C)),$.folders.length>1&&!l.noPrefix){const N=v.name?v.name:D.basenameOrAuthority(v.uri);C=C?`${N} \u2022 ${C}`:N}return C}function A(u,l=L.$i){return(0,F.$3f)(u,l)?u.charAt(0).toUpperCase()+u.slice(1):u}e.$vv=A;let P=Object.create(null);function f(u,l,h=L.OS){if(h===1||!u||!l)return u;let k=P.original===l?P.normalized:void 0;k||(k=l,L.$i&&(k=(0,F.$Sf)(k)),k=`${(0,w.$Le)(k,m.$fc.sep)}${m.$fc.sep}`,P={original:l,normalized:k});let D=u;return L.$i&&(D=(0,F.$Sf)(D)),(h===3?D.startsWith(k):(0,w.$4e)(D,k))?`~/${D.substr(k.length)}`:u}e.$wv=f;function y(u,l){return u.replace(/^~($|\/|\\)/,`${l}$1`)}e.$xv=y;const S="\u2026",p="\\\\",c="~";function s(u,l=m.sep){const h=new Array(u.length);let k=!1;for(let D=0;D<u.length;D++){const $=u[D];if($===""){h[D]=`.${l}`;continue}if(!$){h[D]=$;continue}k=!0;let b="",v=$;v.indexOf(p)===0?(b=v.substr(0,v.indexOf(p)+p.length),v=v.substr(v.indexOf(p)+p.length)):v.indexOf(l)===0?(b=v.substr(0,v.indexOf(l)+l.length),v=v.substr(v.indexOf(l)+l.length)):v.indexOf(c)===0&&(b=v.substr(0,v.indexOf(c)+c.length),v=v.substr(v.indexOf(c)+c.length));const C=v.split(l);for(let N=1;k&&N<=C.length;N++)for(let z=C.length-N;k&&z>=0;z--){k=!1;let M=C.slice(z,z+N).join(l);for(let T=0;!k&&T<u.length;T++)if(T!==D&&u[T]&&u[T].indexOf(M)>-1){const j=z+N===C.length,O=z>0&&u[T].indexOf(l)>-1?l+M:M,q=u[T].endsWith(O);k=!j||q}if(!k){let T="";(C[0].endsWith(":")||b!=="")&&(z===1&&(z=0,N++,M=C[0]+l+M),z>0&&(T=C[0]+l),T=b+T),z>0&&(T=T+S+l),T=T+M,z+N<C.length&&(T=T+l+S),h[D]=T}}k&&(h[D]=$)}return h}e.$yv=s;var i;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(u,l=Object.create(null)){const h=[];let k=!1,D="";for(const $ of u)if($==="$"||k&&$==="{")D&&h.push({value:D,type:i.TEXT}),D="",k=!0;else if($==="}"&&k){const b=l[D];if(typeof b=="string")b.length&&h.push({value:b,type:i.VARIABLE});else if(b){const v=h[h.length-1];(!v||v.type!==i.SEPARATOR)&&h.push({value:b.label,type:i.SEPARATOR})}D="",k=!1}else D+=$;return D&&!k&&h.push({value:D,type:i.TEXT}),h.filter(($,b)=>{if($.type===i.SEPARATOR){const v=h[b-1],C=h[b+1];return[v,C].every(N=>N&&(N.type===i.VARIABLE||N.type===i.TEXT)&&N.value.length>0)}return!0}).map($=>$.value).join("")}e.$zv=n;function o(u,l){return L.$j||l?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):u.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$Av=o;function a(u,l){return L.$j||l?u.replace(/\(&&\w\)|&&/g,""):L.$i?u.replace(/&&|&/g,h=>h==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.$Bv=a;function t(u){return u.replace(/&/g,"&&")}e.$Cv=t;function r(u){if(u.endsWith("]")){const l=u.lastIndexOf(" [",u.length-2);if(l!==-1){const h=d(u.substring(0,l));return{name:h.name,parentPath:h.parentPath+u.substring(l)}}}return d(u)}e.$Dv=r;function d(u){const l=u.indexOf("/")!==-1?m.$fc:m.$ec,h=l.basename(u),k=l.dirname(u);return h.length?{name:h,parentPath:k}:{name:k,parentPath:""}}}),define(ke[131],Se([1,0,22,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=void 0;function m(P){return P.toJSON()}class L{constructor(f){this.a=f}transformIncoming(f){const y=this.a.transformIncoming(f);return y===f?f:m(F.URI.from(y))}transformOutgoing(f){const y=this.a.transformOutgoing(f);return y===f?f:m(F.URI.from(y))}transformOutgoingURI(f){const y=this.a.transformOutgoing(f);return y===f?f:F.URI.from(y)}transformOutgoingScheme(f){return this.a.transformOutgoingScheme(f)}}e.$Om=L,e.$Pm=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function R(P,f,y){if(!P||y>200)return null;if(typeof P=="object"){if(P instanceof F.URI)return f.transformOutgoing(P);for(const S in P)if(Object.hasOwnProperty.call(P,S)){const p=R(P[S],f,y+1);p!==null&&(P[S]=p)}}return null}function w(P,f){const y=R(P,f,0);return y===null?P:y}e.$Qm=w;function E(P,f,y,S){if(!P||S>200)return null;if(typeof P=="object"){if(P.$mid===1)return y?F.URI.revive(f.transformIncoming(P)):f.transformIncoming(P);if(P instanceof I.$ce)return null;for(const p in P)if(Object.hasOwnProperty.call(P,p)){const c=E(P[p],f,y,S+1);c!==null&&(P[p]=c)}}return null}function g(P,f){const y=E(P,f,!1,0);return y===null?P:y}e.$Rm=g;function A(P,f){const y=E(P,f,!0,0);return y===null?P:y}e.$Sm=A}),define(ke[30],Se([1,0,55,63,387,10,33,77,16,12,23,2]),function(me,e,I,F,m,L,R,w,E,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(f||(e.RimRafMode=f={}));async function y(O,q=f.UNLINK,V){if((0,R.$2f)(O))throw new Error("rimraf - will refuse to recursively delete root");return q===f.UNLINK?p(O):S(O,V)}async function S(O,q=(0,R.$7f)((0,F.tmpdir)())){try{try{await I.promises.rename(O,q)}catch(V){return V.code==="ENOENT"?void 0:p(O)}p(q).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function p(O){return(0,m.promisify)(I.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function c(O){if((0,R.$2f)(O))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function s(O,q){return o(await(q?i(O):(0,m.promisify)(I.readdir)(O)))}async function i(O){try{return await(0,m.promisify)(I.readdir)(O,{withFileTypes:!0})}catch(de){console.warn("[node.js fs] readdir with filetypes failed with error: ",de)}const q=[],V=await s(O);for(const de of V){let ee=!1,X=!1,Q=!1;try{const ae=await e.Promises.lstat((0,E.$ic)(O,de));ee=ae.isFile(),X=ae.isDirectory(),Q=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}q.push({name:de,isFile:()=>ee,isDirectory:()=>X,isSymbolicLink:()=>Q})}return q}function n(O){return o(I.readdirSync(O))}e.readdirSync=n;function o(O){return O.map(q=>typeof q=="string"?g.$j?(0,w.$rl)(q):q:(q.name=g.$j?(0,w.$rl)(q.name):q.name,q))}async function a(O){const q=await s(O),V=[];for(const de of q)await r.existsDirectory((0,E.$ic)(O,de))&&V.push(de);return V}function t(O,q=1e3){return new Promise(V=>{let de=!1;const ee=setInterval(()=>{de||(de=!0,I.access(O,X=>{de=!1,X&&(clearInterval(ee),V(void 0))}))},q)})}e.whenDeleted=t;var r;(function(O){async function q(ee){let X;try{if(X=await e.Promises.lstat(ee),!X.isSymbolicLink())return{stat:X}}catch{}try{return{stat:await e.Promises.stat(ee),symbolicLink:X?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};if(g.$i&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ee)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};throw ae}throw Q}}O.stat=q;async function V(ee){try{const{stat:X,symbolicLink:Q}=await O.stat(ee);return X.isFile()&&Q?.dangling!==!0}catch{}return!1}O.existsFile=V;async function de(ee){try{const{stat:X,symbolicLink:Q}=await O.stat(ee);return X.isDirectory()&&Q?.dangling!==!0}catch{}return!1}O.existsDirectory=de})(r||(e.SymlinkSupport=r={}));const d=new L.$4g;function u(O,q,V){return d.queueFor(P.URI.file(O),A.$ng).queue(()=>{const de=$(V);return new Promise((ee,X)=>k(O,q,de,Q=>Q?X(Q):ee()))})}let l=!0;function h(O){l=O}e.configureFlushOnWrite=h;function k(O,q,V,de){if(!l)return I.writeFile(O,q,{mode:V.mode,flag:V.flag},de);I.open(O,V.flag,V.mode,(ee,X)=>{if(ee)return de(ee);I.writeFile(X,q,Q=>{if(Q)return I.close(X,()=>de(Q));I.fdatasync(X,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),h(!1)),I.close(X,x=>de(x))))})})}function D(O,q,V){const de=$(V);if(!l)return I.writeFileSync(O,q,{mode:de.mode,flag:de.flag});const ee=I.openSync(O,de.flag,de.mode);try{I.writeFileSync(ee,q);try{I.fdatasyncSync(ee)}catch(X){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",X),h(!1)}}finally{I.closeSync(ee)}}e.writeFileSync=D;function $(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function b(O,q,V=6e4){if(O!==q)try{g.$i&&typeof V=="number"?await v(O,q,Date.now(),V):await(0,m.promisify)(I.rename)(O,q)}catch(de){if(O.toLowerCase()!==q.toLowerCase()&&de.code==="EXDEV"||O.endsWith("."))await C(O,q,{preserveSymlinks:!1}),await y(O,f.MOVE);else throw de}}async function v(O,q,V,de,ee=0){try{return await(0,m.promisify)(I.rename)(O,q)}catch(X){if(X.code!=="EACCES"&&X.code!=="EPERM"&&X.code!=="EBUSY")throw X;if(Date.now()-V>=de)throw console.error(`[node.js fs] rename failed after ${ee} retries with error: ${X}`),X;if(ee===0){let Q=!1;try{const{stat:ae}=await r.stat(q);ae.isFile()||(Q=!0)}catch{}if(Q)throw X}return await(0,L.$Vg)(Math.min(100,ee*10)),v(O,q,V,de,ee+1)}}async function C(O,q,V){return z(O,q,{root:{source:O,target:q},options:V,handledSourcePaths:new Set})}const N=511;async function z(O,q,V){if(V.handledSourcePaths.has(O))return;V.handledSourcePaths.add(O);const{stat:de,symbolicLink:ee}=await r.stat(O);if(ee){if(V.options.preserveSymlinks)try{return await j(O,q,V)}catch(X){console.warn("[node.js fs] copy of symlink failed: ",X)}if(ee.dangling)return}return de.isDirectory()?M(O,q,de.mode&N,V):T(O,q,de.mode&N)}async function M(O,q,V,de){await e.Promises.mkdir(q,{recursive:!0,mode:V});const ee=await s(O);for(const X of ee)await z((0,E.$ic)(O,X),(0,E.$ic)(q,X),de)}async function T(O,q,V){await e.Promises.copyFile(O,q),await e.Promises.chmod(q,V)}async function j(O,q,V){let de=await e.Promises.readlink(O);(0,R.$Yf)(de,V.root.source,!g.$k)&&(de=(0,E.$ic)(V.root.target,de.substr(V.root.source.length+1))),await e.Promises.symlink(de,q)}e.Promises=new class{get access(){return(0,m.promisify)(I.access)}get stat(){return(0,m.promisify)(I.stat)}get lstat(){return(0,m.promisify)(I.lstat)}get utimes(){return(0,m.promisify)(I.utimes)}get read(){return(O,q,V,de,ee)=>new Promise((X,Q)=>{I.read(O,q,V,de,ee,(ae,x,se)=>ae?Q(ae):X({bytesRead:x,buffer:se}))})}get readFile(){return(0,m.promisify)(I.readFile)}get write(){return(O,q,V,de,ee)=>new Promise((X,Q)=>{I.write(O,q,V,de,ee,(ae,x,se)=>ae?Q(ae):X({bytesWritten:x,buffer:se}))})}get appendFile(){return(0,m.promisify)(I.appendFile)}get fdatasync(){return(0,m.promisify)(I.fdatasync)}get truncate(){return(0,m.promisify)(I.truncate)}get copyFile(){return(0,m.promisify)(I.copyFile)}get open(){return(0,m.promisify)(I.open)}get close(){return(0,m.promisify)(I.close)}get symlink(){return(0,m.promisify)(I.symlink)}get readlink(){return(0,m.promisify)(I.readlink)}get chmod(){return(0,m.promisify)(I.chmod)}get mkdir(){return(0,m.promisify)(I.mkdir)}get unlink(){return(0,m.promisify)(I.unlink)}get rmdir(){return(0,m.promisify)(I.rmdir)}get realpath(){return(0,m.promisify)(I.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return a}get writeFile(){return u}get rm(){return y}get rename(){return b}get copy(){return C}}}),define(ke[103],Se([1,0,55,16,12,13,30]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.$9p=e.$8p=void 0;function w(f){if(m.$k)return f;const y=(0,F.$lc)(f);if(f===y)return f;const S=((0,F.$mc)(f)||f).toLowerCase();try{const c=(0,R.readdirSync)(y).filter(s=>s.toLowerCase()===S);if(c.length===1){const s=w(y);if(s)return(0,F.$ic)(s,c[0])}else if(c.length>1){const s=c.indexOf(S);if(s>=0){const i=w(y);if(i)return(0,F.$ic)(i,c[s])}}}catch{}return null}e.$8p=w;async function E(f){if(m.$k)return f;const y=(0,F.$lc)(f);if(f===y)return f;const S=((0,F.$mc)(f)||f).toLowerCase();try{const c=(await R.Promises.readdir(y)).filter(s=>s.toLowerCase()===S);if(c.length===1){const s=await E(y);if(s)return(0,F.$ic)(s,c[0])}else if(c.length>1){const s=c.indexOf(S);if(s>=0){const i=await E(y);if(i)return(0,F.$ic)(i,c[s])}}}catch{}return null}e.$9p=E;async function g(f){try{return await R.Promises.realpath(f)}catch{const S=P(f);return await R.Promises.access(S,I.constants.R_OK),S}}e.$0p=g;function A(f){try{return I.realpathSync(f)}catch{const S=P(f);return I.accessSync(S,I.constants.R_OK),S}}e.$$p=A;function P(f){return(0,L.$Le)((0,F.$gc)(f),F.sep)}}),define(ke[104],Se([1,0,16,12,49,101,18,30]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Fl=e.$El=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function E(P=m.env){return P.comspec||"cmd.exe"}e.$El=E;function g(P){let f=[],y=!1;const S=function(p){if(y){f.push(p);return}(!P.send(p,s=>{if(s&&console.error(s),y=!1,f.length>0){const i=f.slice(0);f=[],i.forEach(n=>S(n))}})||F.$i)&&(y=!0)};return{send:S}}e.$Fl=g;var A;(function(P){async function f(y,S,p){if(I.$hc(y))return y;if(S===void 0&&(S=m.cwd()),I.$lc(y)!=="."||(p===void 0&&R.$zf(m.env.PATH)&&(p=m.env.PATH.split(I.$sc)),p===void 0||p.length===0))return I.$ic(S,y);async function s(i){if(await w.Promises.exists(i)){let n;try{n=await w.Promises.stat(i)}catch(o){o.message.startsWith("EACCES")&&(n=await w.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of p){let n;if(I.$hc(i)?n=I.$ic(i,y):n=I.$ic(S,i,y),await s(n))return n;let o=n+".com";if(await s(o)||(o=n+".exe",await s(o)))return o}return I.$ic(S,y)}P.findExecutable=f})(A||(e.win32=A={}))});var He=this&&this.__decorate||function(me,e,I,F){var m=arguments.length,L=m<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,I):F,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(me,e,I,F);else for(var w=me.length-1;w>=0;w--)(R=me[w])&&(L=(m<3?R(L):m>3?R(e,I,L):R(e,I))||L);return m>3&&L&&Object.defineProperty(e,I,L),L};define(ke[82],Se([1,0,19,10,22,21,59,11,4,3,54,13,18]),function(me,e,I,F,m,L,R,w,E,g,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.ProxyChannel=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.RequestInitiator=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0;var y;(function(ee){ee[ee.Promise=100]="Promise",ee[ee.PromiseCancel=101]="PromiseCancel",ee[ee.EventListen=102]="EventListen",ee[ee.EventDispose=103]="EventDispose"})(y||(y={}));function S(ee){switch(ee){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(ee){ee[ee.Initialize=200]="Initialize",ee[ee.PromiseSuccess=201]="PromiseSuccess",ee[ee.PromiseError=202]="PromiseError",ee[ee.PromiseErrorObj=203]="PromiseErrorObj",ee[ee.EventFire=204]="EventFire"})(p||(p={}));function c(ee){switch(ee){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(ee){ee[ee.Uninitialized=0]="Uninitialized",ee[ee.Idle=1]="Idle"})(s||(s={}));function i(ee){let X=0;for(let Q=0;;Q+=7){const ae=ee.read(1);if(X|=(ae.buffer[0]&127)<<Q,!(ae.buffer[0]&128))return X}}const n=d(0);function o(ee,X){if(X===0){ee.write(n);return}let Q=0;for(let x=X;x!==0;x=x>>>7)Q++;const ae=m.$ce.alloc(Q);for(let x=0;X!==0;x++)ae.buffer[x]=X&127,X=X>>>7,X>0&&(ae.buffer[x]|=128);ee.write(ae)}class a{constructor(X){this.b=X,this.a=0}read(X){const Q=this.b.slice(this.a,this.a+X);return this.a+=Q.byteLength,Q}}e.$qh=a;class t{constructor(){this.a=[]}get buffer(){return m.$ce.concat(this.a)}write(X){this.a.push(X)}}e.$rh=t;var r;(function(ee){ee[ee.Undefined=0]="Undefined",ee[ee.String=1]="String",ee[ee.Buffer=2]="Buffer",ee[ee.VSBuffer=3]="VSBuffer",ee[ee.Array=4]="Array",ee[ee.Object=5]="Object",ee[ee.Int=6]="Int"})(r||(r={}));function d(ee){const X=m.$ce.alloc(1);return X.writeUInt8(ee,0),X}const u={Undefined:d(r.Undefined),String:d(r.String),Buffer:d(r.Buffer),VSBuffer:d(r.VSBuffer),Array:d(r.Array),Object:d(r.Object),Uint:d(r.Int)},l=typeof Buffer<"u";function h(ee,X){if(typeof X>"u")ee.write(u.Undefined);else if(typeof X=="string"){const Q=m.$ce.fromString(X);ee.write(u.String),o(ee,Q.byteLength),ee.write(Q)}else if(l&&Buffer.isBuffer(X)){const Q=m.$ce.wrap(X);ee.write(u.Buffer),o(ee,Q.byteLength),ee.write(Q)}else if(X instanceof m.$ce)ee.write(u.VSBuffer),o(ee,X.byteLength),ee.write(X);else if(Array.isArray(X)){ee.write(u.Array),o(ee,X.length);for(const Q of X)h(ee,Q)}else if(typeof X=="number"&&(X|0)===X)ee.write(u.Uint),o(ee,X);else{const Q=m.$ce.fromString(JSON.stringify(X));ee.write(u.Object),o(ee,Q.byteLength),ee.write(Q)}}e.$sh=h;function k(ee){switch(ee.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return ee.read(i(ee)).toString();case r.Buffer:return ee.read(i(ee)).buffer;case r.VSBuffer:return ee.read(i(ee));case r.Array:{const Q=i(ee),ae=[];for(let x=0;x<Q;x++)ae.push(k(ee));return ae}case r.Object:return JSON.parse(ee.read(i(ee)).toString());case r.Int:return i(ee)}}e.$th=k;class D{constructor(X,Q,ae=null,x=1e3){this.h=X,this.j=Q,this.k=ae,this.l=x,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:200})}registerChannel(X,Q){this.b.set(X,Q),setTimeout(()=>this.w(X),0)}m(X){switch(X.type){case 200:{const Q=this.o([X.type]);this.k?.logOutgoing(Q,0,1,c(X.type));return}case 201:case 202:case 204:case 203:{const Q=this.o([X.type,X.id],X.data);this.k?.logOutgoing(Q,X.id,1,c(X.type),X.data);return}}}o(X,Q=void 0){const ae=new t;return h(ae,X),h(ae,Q),this.p(ae.buffer)}p(X){try{return this.h.send(X),X.byteLength}catch{return 0}}q(X){const Q=new a(X),ae=k(Q),x=k(Q),se=ae[0];switch(se){case 100:return this.k?.logIncoming(X.byteLength,ae[1],1,`${S(se)}: ${ae[2]}.${ae[3]}`,x),this.s({type:se,id:ae[1],channelName:ae[2],name:ae[3],arg:x});case 102:return this.k?.logIncoming(X.byteLength,ae[1],1,`${S(se)}: ${ae[2]}.${ae[3]}`,x),this.t({type:se,id:ae[1],channelName:ae[2],name:ae[3],arg:x});case 101:return this.k?.logIncoming(X.byteLength,ae[1],1,`${S(se)}`),this.u({type:se,id:ae[1]});case 103:return this.k?.logIncoming(X.byteLength,ae[1],1,`${S(se)}`),this.u({type:se,id:ae[1]})}}s(X){const Q=this.b.get(X.channelName);if(!Q){this.v(X);return}const ae=new L.$Yd;let x;try{x=Q.call(this.j,X.name,X.arg,ae.token)}catch(G){x=Promise.reject(G)}const se=X.id;x.then(G=>{this.m({id:se,data:G,type:201})},G=>{G instanceof Error?this.m({id:se,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.m({id:se,data:G,type:203})}).finally(()=>{pe.dispose(),this.d.delete(X.id)});const pe=(0,g.$Pc)(()=>ae.cancel());this.d.set(X.id,pe)}t(X){const Q=this.b.get(X.channelName);if(!Q){this.v(X);return}const ae=X.id,se=Q.listen(this.j,X.name,X.arg)(pe=>this.m({id:ae,data:pe,type:204}));this.d.set(X.id,se)}u(X){const Q=this.d.get(X.id);Q&&(Q.dispose(),this.d.delete(X.id))}v(X){let Q=this.g.get(X.channelName);Q||(Q=[],this.g.set(X.channelName,Q));const ae=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.m({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:X,timeoutTimer:ae})}w(X){const Q=this.g.get(X);if(Q){for(const ae of Q)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.s(ae.request);break;case 102:this.t(ae.request);break}this.g.delete(X)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}e.$uh=D;var $;(function(ee){ee[ee.LocalSide=0]="LocalSide",ee[ee.OtherSide=1]="OtherSide"})($||(e.RequestInitiator=$={}));class b{constructor(X,Q=null){this.l=X,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$Od,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ae=>this.s(ae)),this.j=Q}getChannel(X){const Q=this;return{call(ae,x,se){return Q.a?Promise.reject(new w.$4):Q.m(X,ae,x,se)},listen(ae,x){return Q.a?E.Event.None:Q.o(X,ae,x)}}}m(X,Q,ae,x=L.CancellationToken.None){const se=this.g++,G={id:se,type:100,channelName:X,name:Q,arg:ae};if(x.isCancellationRequested)return Promise.reject(new w.$4);let U;return new Promise((be,H)=>{if(x.isCancellationRequested)return H(new w.$4);const Z=()=>{const fe=te=>{switch(te.type){case 201:this.f.delete(se),be(te.data);break;case 202:{this.f.delete(se);const he=new Error(te.data.message);he.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,he.name=te.data.name,H(he);break}case 203:this.f.delete(se),H(te.data);break}};this.f.set(se,fe),this.p(G)};let Y=null;this.b===s.Idle?Z():(Y=(0,F.$Ig)(fe=>this.u()),Y.then(()=>{Y=null,Z()}));const $e=()=>{Y?(Y.cancel(),Y=null):this.p({id:se,type:101}),H(new w.$4)},ne=x.onCancellationRequested($e);U=(0,g.$Oc)((0,g.$Pc)($e),ne),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(X,Q,ae){const x=this.g++,pe={id:x,type:102,channelName:X,name:Q,arg:ae};let G=null;const U=new E.$Od({onWillAddFirstListener:()=>{G=(0,F.$Ig)(be=>this.u()),G.then(()=>{G=null,this.d.add(U),this.p(pe)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(U),this.p({id:x,type:103}))}}),ce=be=>U.fire(be.data);return this.f.set(x,ce),U.event}p(X){switch(X.type){case 100:case 102:{const Q=this.q([X.type,X.id,X.channelName,X.name],X.arg);this.j?.logOutgoing(Q,X.id,0,`${S(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const Q=this.q([X.type,X.id]);this.j?.logOutgoing(Q,X.id,0,S(X.type));return}}}q(X,Q=void 0){const ae=new t;return h(ae,X),h(ae,Q),this.r(ae.buffer)}r(X){try{return this.l.send(X),X.byteLength}catch{return 0}}s(X){const Q=new a(X),ae=k(Q),x=k(Q),se=ae[0];switch(se){case 200:return this.j?.logIncoming(X.byteLength,0,0,c(se)),this.t({type:ae[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(X.byteLength,ae[1],0,c(se),x),this.t({type:ae[0],id:ae[1],data:x})}}t(X){if(X.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(X.id)?.(X)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}e.$vh=b,He([R.$kh],b.prototype,"onDidInitializePromise",null);class v{get connections(){const X=[];return this.f.forEach(Q=>X.push(Q)),X}constructor(X){this.a=new Map,this.f=new Set,this.g=new E.$Od,this.onDidAddConnection=this.g.event,this.h=new E.$Od,this.onDidRemoveConnection=this.h.event,this.j=new g.$Qc,this.j.add(X(({protocol:Q,onDidClientDisconnect:ae})=>{const x=E.Event.once(Q.onMessage);this.j.add(x(se=>{const pe=new a(se),G=k(pe),U=new D(Q,G),ce=new b(Q);this.a.forEach((H,Z)=>U.registerChannel(Z,H));const be={channelServer:U,channelClient:ce,ctx:G};this.f.add(be),this.g.fire(be),this.j.add(ae(()=>{U.dispose(),ce.dispose(),this.f.delete(be),this.h.fire(be)}))}))}))}getChannel(X,Q){const ae=this;return{call(x,se,pe){let G;if((0,f.$Nf)(Q)){const ce=(0,I.$3b)(ae.connections.filter(Q));G=ce?Promise.resolve(ce):E.Event.toPromise(E.Event.filter(ae.onDidAddConnection,Q))}else G=Q.routeCall(ae,x,se);const U=G.then(ce=>ce.channelClient.getChannel(X));return N(U).call(x,se,pe)},listen(x,se){if((0,f.$Nf)(Q))return ae.k(X,Q,x,se);const pe=Q.routeEvent(ae,x,se).then(G=>G.channelClient.getChannel(X));return N(pe).listen(x,se)}}}k(X,Q,ae,x){const se=this;let pe;const G=new E.$Od({onWillAddFirstListener:()=>{pe=new g.$Qc;const U=new E.$Ud,ce=new Map,be=Z=>{const $e=Z.channelClient.getChannel(X).listen(ae,x),ne=U.add($e);ce.set(Z,ne)},H=Z=>{const Y=ce.get(Z);Y&&(Y.dispose(),ce.delete(Z))};se.connections.filter(Q).forEach(be),E.Event.filter(se.onDidAddConnection,Q)(be,void 0,pe),se.onDidRemoveConnection(H,void 0,pe),U.event(G.fire,G,pe),pe.add(U)},onDidRemoveLastListener:()=>{pe?.dispose(),pe=void 0}});return G.event}registerChannel(X,Q){this.a.set(X,Q);for(const ae of this.f)ae.channelServer.registerChannel(X,Q)}dispose(){this.j.dispose();for(const X of this.f)X.channelClient.dispose(),X.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$wh=v;class C{constructor(X,Q,ae=null){const x=new t;h(x,Q),X.send(x.buffer),this.a=new b(X,ae),this.d=new D(X,Q,ae)}getChannel(X){return this.a.getChannel(X)}registerChannel(X,Q){this.d.registerChannel(X,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$xh=C;function N(ee){return{call(X,Q,ae){return ee.then(x=>x.call(X,Q,ae))},listen(X,Q){const ae=new E.$Xd;return ee.then(x=>ae.input=x.listen(X,Q)),ae.event}}}e.$yh=N;function z(ee){let X=!1;return{call(Q,ae,x){return X?ee.call(Q,ae,x):(0,F.$Vg)(0).then(()=>X=!0).then(()=>ee.call(Q,ae,x))},listen(Q,ae){if(X)return ee.listen(Q,ae);const x=new E.$Xd;return(0,F.$Vg)(0).then(()=>X=!0).then(()=>x.input=ee.listen(Q,ae)),x.event}}}e.$zh=z;class M{constructor(X){this.a=X}routeCall(X){return this.b(X)}routeEvent(X){return this.b(X)}async b(X){for(const Q of X.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await E.Event.toPromise(X.onDidAddConnection),await this.b(X)}}e.$Ah=M;var T;(function(ee){function X(se,pe,G){const U=se,ce=G&&G.disableMarshalling,be=new Map;for(const H in U)ae(H)&&be.set(H,E.Event.buffer(U[H],!0,void 0,pe));return new class{listen(H,Z,Y){const $e=be.get(Z);if($e)return $e;if(x(Z)){const ne=U[Z];if(typeof ne=="function")return ne.call(U,Y)}throw new w.$ab(`Event not found: ${Z}`)}call(H,Z,Y){const $e=U[Z];if(typeof $e=="function"){if(!ce&&Array.isArray(Y))for(let fe=0;fe<Y.length;fe++)Y[fe]=(0,A.$ph)(Y[fe]);let ne=$e.apply(U,Y);return ne instanceof Promise||(ne=Promise.resolve(ne)),ne}throw new w.$ab(`Method not found: ${Z}`)}}}ee.fromService=X;function Q(se,pe){const G=pe&&pe.disableMarshalling;return new Proxy({},{get(U,ce){if(typeof ce=="string")return pe?.properties?.has(ce)?pe.properties.get(ce):x(ce)?function(be){return se.listen(ce,be)}:ae(ce)?se.listen(ce):async function(...be){let H;pe&&!(0,f.$If)(pe.context)?H=[pe.context,...be]:H=be;const Z=await se.call(ce,H);return G?Z:(0,A.$ph)(Z)};throw new w.$ab(`Property not found: ${String(ce)}`)}})}ee.toService=Q;function ae(se){return se[0]==="o"&&se[1]==="n"&&P.$2e(se.charCodeAt(2))}function x(se){return/^onDynamic/.test(se)&&P.$2e(se.charCodeAt(9))}})(T||(e.ProxyChannel=T={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(ee){if(Array.isArray(ee))return ee;if(ee&&typeof ee=="object"&&typeof ee.toString=="function"){const X=ee.toString();if(X!=="[object Object]")return X}return ee}function q(ee){return Array.isArray(ee)?ee.map(O):O(ee)}function V(ee,X,Q,ae,x,se,pe){pe=q(pe);const G=j[x],U=G[ae%G.length];let ce=[`%c[${ee}]%c[${String(X).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(se)?(ce=ce.concat(pe),ce.push(")")):ce.push(pe),console.log.apply(console,ce)}class de{constructor(X,Q){this.d=X,this.f=Q,this.a=0,this.b=0}logOutgoing(X,Q,ae,x,se){this.b+=X,V(this.d,this.b,X,Q,ae,x,se)}logIncoming(X,Q,ae,x,se){this.a+=X,V(this.f,this.a,X,Q,ae,x,se)}}e.$Bh=de}),define(ke[83],Se([1,0,22,4,3,82]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.ProtocolConstants=e.$Ch=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var w;(function(u){u.enableDiagnostics=!1,u.records=[];const l=new WeakMap;let h=0;function k($,b){if(!l.has($)){const v=String(++h);l.set($,v)}return l.get($)}function D($,b,v,C){if(!u.enableDiagnostics)return;const N=k($,b);if(C instanceof I.$ce||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const z=I.$ce.alloc(C.byteLength);z.set(C),u.records.push({timestamp:Date.now(),id:N,label:b,type:v,buff:z})}else u.records.push({timestamp:Date.now(),id:N,label:b,type:v,data:C})}u.traceSocketEvent=D})(w||(e.SocketDiagnostics=w={}));var E;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let g=null;function A(){return g||(g=I.$ce.alloc(0)),g}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(l){this.a.push(l),this.b+=l.byteLength}read(l){return this.c(l,!0)}peek(l){return this.c(l,!1)}c(l,h){if(l===0)return A();if(l>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===l){const b=this.a[0];return h&&(this.a.shift(),this.b-=l),b}if(this.a[0].byteLength>l){const b=this.a[0].slice(0,l);return h&&(this.a[0]=this.a[0].slice(l),this.b-=l),b}const k=I.$ce.alloc(l);let D=0,$=0;for(;l>0;){const b=this.a[$];if(b.byteLength>l){const v=b.slice(0,l);k.set(v,D),D+=l,h&&(this.a[$]=b.slice(l),this.b-=l),l-=l}else k.set(b,D),D+=b.byteLength,h?(this.a.shift(),this.b-=b.byteLength):$++,l-=b.byteLength}return k}}e.$Ch=P;var f;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(f||(f={}));function y(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",u[u.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class p{constructor(l,h,k,D){this.type=l,this.id=h,this.ack=k,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends m.$Rc{constructor(l){super(),this.f=this.B(new F.$Od),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=l,this.b=!1,this.c=new P,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(l);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,D=this.g.id,$=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new p(k,D,$,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class s{constructor(l){this.k=null,this.a=!1,this.b=!1,this.c=l,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(l){if(this.a)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=I.$ce.alloc(13);h.writeUInt8(l.type,0),h.writeUInt32BE(l.id,1),h.writeUInt32BE(l.ack,5),h.writeUInt32BE(l.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",l.data),this.j(h,l.data)}g(l,h){const k=this.f===0;return this.d.push(l,h),this.f+=l.byteLength+h.byteLength,k}h(){const l=I.$ce.concat(this.d,this.f);return this.d.length=0,this.f=0,l}j(l,h){this.g(l,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const l=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:l.byteLength}),this.c.write(l)}}class i extends m.$Rc{constructor(l){super(),this.f=new F.$Od,this.onMessage=this.f.event,this.g=new F.$Od,this.onDidDispose=this.g.event,this.a=l,this.b=this.B(new s(this.a)),this.c=this.B(new c(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(l){this.b.write(new p(1,0,0,l))}}e.$Dh=i;class n extends L.$xh{static fromSocket(l,h){return new n(new i(l),h)}get onDidDispose(){return this.b.onDidDispose}constructor(l,h,k=null){super(l,h,k),this.b=l}dispose(){super.dispose();const l=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),l.end()}}e.$Eh=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$Od({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(l){this.b?this.d.length>0?this.d.push(l):this.a.fire(l):this.d.push(l)}flushBuffer(){this.d=[]}}e.$Fh=o;class a{constructor(l){this.data=l,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let l=0,h=this.a;for(;h;)h=h.next,l++;return l}peek(){return this.a?this.a.data:null}toArray(){const l=[];let h=0,k=this.a;for(;k;)l[h++]=k.data,k=k.next;return l}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(l){const h=new a(l);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const l=Date.now();for(let h=0;h<r.a;h++)this.c[h]=l-1e3*h;setInterval(()=>{for(let h=r.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const l=Date.now(),h=(1+r.a)*1e3;let k=0;for(let D=0;D<r.a;D++)l-this.c[D]<=h&&k++;return 1-k/r.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(l){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=l.loadEstimator??r.getInstance(),this.t=l.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new m.$Qc,this.o=l.socket,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),l.initialChunk&&this.q.acceptChunk(l.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const l=new p(5,0,0,A());this.p.write(l),this.p.flush()}sendPause(){const l=new p(7,0,0,A());this.p.write(l)}sendResume(){const l=new p(8,0,0,A());this.p.write(l)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(l,h){this.a=!0,this.r.dispose(),this.r=new m.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=l,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const l=new p(3,0,this.h,A());this.p.write(l);const h=this.b.toArray();for(let k=0,D=h.length;k<D;k++)this.p.write(h[k]);this.B()}acceptDisconnect(){this.w.fire()}z(l){if(l.ack>this.d){this.d=l.ack;do{const h=this.b.peek();if(h&&h.id<=l.ack)this.b.pop();else break}while(!0)}switch(l.type){case 0:break;case 1:{if(l.id>this.g)if(l.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new p(6,0,0,A())))}else this.g=l.id,this.j=Date.now(),this.A(),this.v.fire(l.data);break}case 2:{this.u.fire(l.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let k=0,D=h.length;k<D;k++)this.p.write(h[k]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(l){const h=++this.c;this.h=this.g;const k=new p(1,h,this.h,l);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(l){const h=new p(2,0,0,l);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const l=Date.now()-this.j;if(l>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-l+5)}B(){if(this.c<=this.d||this.f||this.a)return;const l=this.b.peek(),h=Date.now()-l.writtenTime,k=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(h>=2e4&&k>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:k});return}const $=Math.max(2e4-h,2e4-k,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},$)}C(){if(this.g<=this.h)return;this.h=this.g;const l=new p(3,0,this.h,A());this.p.write(l)}D(){this.h=this.g;const l=new p(9,0,this.h,A());this.p.write(l)}}e.$Gh=d}),define(ke[187],Se([1,0,50,10,22,21,185,11,4,3,24,104,101,82]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0;class S extends y.$uh{constructor(s){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",i=>m.$ce.wrap(Buffer.from(i,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$5p=S;class p{constructor(s,i){this.i=s,this.j=i,this.c=new Set,this.g=new Map,this.h=new E.$Od,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new F.$Rg(n),this.d=null,this.f=null}getChannel(s){const i=this;return{call(n,o,a){return i.k(s,n,o,a)},listen(n,o){return i.l(s,n,o)}}}k(s,i,n,o=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(w.$5());this.b.cancel();const a=this.n(s),t=(0,F.$Ig)(u=>a.call(i,n,u)),r=o.onCancellationRequested(()=>t.cancel()),d=(0,g.$Pc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{r.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,i,n){if(!this.b)return E.Event.None;this.b.cancel();let o;const a=new E.$Od({onWillAddFirstListener:()=>{o=this.n(s).listen(i,n)(a.fire,a),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,A.$0m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,f.$Dl)(i.env),this.d=(0,I.fork)(this.i,s,i);const n=new E.$Od;E.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,R.$1p)(l)){(0,R.log)(l,`IPC Library: ${this.j.serverName}`);return}n.fire(m.$ce.wrap(Buffer.from(l,"base64")))});const a=this.j.useQueue?(0,P.$Fl)(this.d):this.d,t=l=>this.d&&this.d.connected&&a.send(l.buffer.toString("base64")),r=n.event,d={send:t,onMessage:r};this.f=new y.$vh(d);const u=()=>this.o();process.once("exit",u),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,h)=>{process.removeListener("exit",u),this.c.forEach(k=>(0,g.$Mc)(k)),this.c.clear(),l!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:h})})}return this.f}n(s){let i=this.g.get(s);return i||(i=this.m.getChannel(s),this.g.set(s,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$6p=p}),define(ke[188],Se([1,0,10,4,3,54,18]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.StorageState=e.$4o=e.StorageHint=void 0;var w;(function(f){f[f.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",f[f.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(w||(e.StorageHint=w={}));function E(f){const y=f;return y?.changed instanceof Map||y?.deleted instanceof Set}e.$4o=E;var g;(function(f){f[f.None=0]="None",f[f.Initialized=1]="Initialized",f[f.Closed=2]="Closed"})(g||(e.StorageState=g={}));class A extends m.$Rc{static{this.a=100}constructor(y,S=Object.create(null)){super(),this.r=y,this.s=S,this.b=this.B(new F.$Rd),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new I.$Sg(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((S,p)=>this.w(p,S)),y.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(y,S){if(this.c===g.Closed)return;let p=!1;(0,R.$If)(S)?p=this.f.delete(y):this.f.get(y)!==S&&(this.f.set(y,S),p=!0),p&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==w.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,S){const p=this.f.get(y);return(0,R.$If)(p)?S:p}getBoolean(y,S){const p=this.get(y);return(0,R.$If)(p)?S:p==="true"}getNumber(y,S){const p=this.get(y);return(0,R.$If)(p)?S:parseInt(p,10)}getObject(y,S){const p=this.get(y);return(0,R.$If)(p)?S:(0,L.$oh)(p)}async set(y,S,p=!1){if(this.c===g.Closed)return;if((0,R.$If)(S))return this.delete(y,p);const c=(0,R.$Bf)(S)||Array.isArray(S)?(0,L.$nh)(S):String(S);if(this.f.get(y)!==c)return this.f.set(y,c),this.j.set(y,c),this.h.delete(y),this.b.fire({key:y,external:p}),this.D()}async delete(y,S=!1){if(!(this.c===g.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:S}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===w.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===w.STORAGE_IN_MEMORY}}e.$5o=A;class P{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((S,p)=>this.a.set(p,S)),y.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$6o=P}),define(ke[189],Se([1,0,13,12,22]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=e.$Ps=e.$Os=void 0;let L;function R(){return L||(L=new TextDecoder("UTF-16LE")),L}let w;function E(){return w||(w=new TextDecoder("UTF-16BE")),w}let g;function A(){return g||(g=F.$D()?R():E()),g}e.$Os=A;function P(S,p,c){const s=new Uint16Array(S.buffer,p,c);return c>0&&(s[0]===65279||s[0]===65534)?f(S,p,c):R().decode(s)}e.$Ps=P;function f(S,p,c){const s=[];let i=0;for(let n=0;n<c;n++){const o=m.$ee(S,p);p+=2,s[i++]=String.fromCharCode(o)}return s.join("")}class y{constructor(p){this.a=p|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const p=new Uint16Array(this.b.buffer,0,this.d);return A().decode(p)}f(){const p=this.e();this.d=0,this.c===null?this.c=[p]:this.c[this.c.length]=p}appendCharCode(p){const c=this.a-this.d;c<=1&&(c===0||I.$7e(p))&&this.f(),this.b[this.d++]=p}appendASCIICharCode(p){this.d===this.a&&this.f(),this.b[this.d++]=p}appendString(p){const c=p.length;if(this.d+c>=this.a){this.f(),this.c[this.c.length]=p;return}for(let s=0;s<c;s++)this.b[this.d++]=p.charCodeAt(s)}}e.$Qs=y}),define(ke[190],Se([1,0,22,189]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=e.$Rs=void 0;function m(E){return E.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(g,A,P,f){this.oldPosition=g,this.oldText=A,this.newPosition=P,this.newText=f}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${m(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${m(this.oldText)}")`:`(replace@${this.oldPosition} "${m(this.oldText)}" with "${m(this.newText)}")`}static a(g){return 4+2*g.length}static c(g,A,P){const f=A.length;I.$he(g,f,P),P+=4;for(let y=0;y<f;y++)I.$fe(g,A.charCodeAt(y),P),P+=2;return P}static d(g,A){const P=I.$ge(g,A);return A+=4,(0,F.$Ps)(g,A,P)}writeSize(){return 4+4+L.a(this.oldText)+L.a(this.newText)}write(g,A){return I.$he(g,this.oldPosition,A),A+=4,I.$he(g,this.newPosition,A),A+=4,A=L.c(g,this.oldText,A),A=L.c(g,this.newText,A),A}static read(g,A,P){const f=I.$ge(g,A);A+=4;const y=I.$ge(g,A);A+=4;const S=L.d(g,A);A+=L.a(S);const p=L.d(g,A);return A+=L.a(p),P.push(new L(f,S,y,p)),A}}e.$Rs=L;function R(E,g){return E===null||E.length===0?g:new w(E,g).compress()}e.$Ss=R;class w{constructor(g,A){this.a=g,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let g=0,A=0,P=this.n(g),f=this.l(A);for(;g<this.f||A<this.h;){if(P===null){this.k(f),f=this.l(++A);continue}if(f===null){this.m(P),P=this.n(++g);continue}if(f.oldEnd<=P.newPosition){this.k(f),f=this.l(++A);continue}if(P.newEnd<=f.oldPosition){this.m(P),P=this.n(++g);continue}if(f.oldPosition<P.newPosition){const[s,i]=w.r(f,P.newPosition-f.oldPosition);this.k(s),f=i;continue}if(P.newPosition<f.oldPosition){const[s,i]=w.q(P,f.oldPosition-P.newPosition);this.m(s),P=i;continue}let p,c;if(f.oldEnd===P.newEnd)p=P,c=f,P=this.n(++g),f=this.l(++A);else if(f.oldEnd<P.newEnd){const[s,i]=w.q(P,f.oldLength);p=s,c=f,P=i,f=this.l(++A)}else{const[s,i]=w.r(f,P.newLength);p=P,c=s,P=this.n(++g),f=i}this.d[this.e++]=new L(p.oldPosition,p.oldText,c.newPosition,c.newText),this.g+=p.newLength-p.oldLength,this.j+=c.newLength-c.oldLength}const y=w.s(this.d);return w.t(y)}k(g){this.d[this.e++]=w.o(this.g,g),this.j+=g.newLength-g.oldLength}l(g){return g<this.h?this.c[g]:null}m(g){this.d[this.e++]=w.p(this.j,g),this.g+=g.newLength-g.oldLength}n(g){return g<this.f?this.a[g]:null}static o(g,A){return new L(A.oldPosition-g,A.oldText,A.newPosition,A.newText)}static p(g,A){return new L(A.oldPosition,A.oldText,A.newPosition+g,A.newText)}static q(g,A){const P=g.newText.substr(0,A),f=g.newText.substr(A);return[new L(g.oldPosition,g.oldText,g.newPosition,P),new L(g.oldEnd,"",g.newPosition+A,f)]}static r(g,A){const P=g.oldText.substr(0,A),f=g.oldText.substr(A);return[new L(g.oldPosition,P,g.newPosition,g.newText),new L(g.oldPosition+A,f,g.newEnd,"")]}static s(g){if(g.length===0)return g;const A=[];let P=0,f=g[0];for(let y=1;y<g.length;y++){const S=g[y];f.oldEnd===S.oldPosition?f=new L(f.oldPosition,f.oldText+S.oldText,f.newPosition,f.newText+S.newText):(A[P++]=f,f=S)}return A[P++]=f,A}static t(g){if(g.length===0)return g;const A=[];let P=0;for(let f=0;f<g.length;f++){const y=g[f];y.oldText!==y.newText&&(A[P++]=y)}return A}}}),define(ke[191],Se([1,0,34,16]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GE=void 0;function m(L,R,w,E,g,A){if(Array.isArray(L)){let P=0;for(const f of L){const y=m(f,R,w,E,g,A);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof L=="string")return E?L==="*"?5:L===w?10:0:0;if(L){const{language:P,pattern:f,scheme:y,hasAccessToAllModels:S,notebookType:p}=L;if(!E&&!S)return 0;p&&g&&(R=g);let c=0;if(y)if(y===R.scheme)c=10;else if(y==="*")c=5;else return 0;if(P)if(P===w)c=10;else if(P==="*")c=Math.max(c,5);else return 0;if(p)if(p===A)c=10;else if(p==="*"&&A!==void 0)c=Math.max(c,5);else return 0;if(f){let s;if(typeof f=="string"?s=f:s={...f,base:(0,F.$gc)(f.base)},s===R.fsPath||(0,I.$yj)(s,R.fsPath))c=10;else return 0}return c}else return 0}}e.$GE=m}),define(ke[192],Se([1,0,4,13,29,80,128,167,190,3]),function(me,e,I,F,m,L,R,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IB=void 0;class A extends g.$Rc{constructor(f,y,S,p,c,s,i){super(),this.m=this.B(new I.$Od),this.onDidChangeContent=this.m.event,this.f=y,this.j=!s,this.g=p,this.h=c,this.c=new R.$HB(f,S,i)}equals(f){return!(f instanceof A)||this.f!==f.f||this.getEOL()!==f.getEOL()?!1:this.c.equal(f.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(f){return this.c.createSnapshot(f?this.f:"")}getOffsetAt(f,y){return this.c.getOffsetAt(f,y)}getPositionAt(f){return this.c.getPositionAt(f)}getRangeAt(f,y){const S=f+y,p=this.getPositionAt(f),c=this.getPositionAt(S);return new m.$ws(p.lineNumber,p.column,c.lineNumber,c.column)}getValueInRange(f,y=0){if(f.isEmpty())return"";const S=this.n(y);return this.c.getValueInRange(f,S)}getValueLengthInRange(f,y=0){if(f.isEmpty())return 0;if(f.startLineNumber===f.endLineNumber)return f.endColumn-f.startColumn;const S=this.getOffsetAt(f.startLineNumber,f.startColumn),p=this.getOffsetAt(f.endLineNumber,f.endColumn);let c=0;const s=this.n(y),i=this.getEOL();if(s.length!==i.length){const n=s.length-i.length,o=f.endLineNumber-f.startLineNumber;c=n*o}return p-S+c}getCharacterCountInRange(f,y=0){if(this.j){let S=0;const p=f.startLineNumber,c=f.endLineNumber;for(let s=p;s<=c;s++){const i=this.getLineContent(s),n=s===p?f.startColumn-1:0,o=s===c?f.endColumn-1:i.length;for(let a=n;a<o;a++)F.$7e(i.charCodeAt(a))?(S=S+1,a=a+1):S=S+1}return S+=this.n(y).length*(c-p),S}return this.getValueLengthInRange(f,y)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(f){return this.c.getLineContent(f)}getLineCharCode(f,y){return this.c.getLineCharCode(f,y)}getCharCode(f){return this.c.getCharCode(f)}getLineLength(f){return this.c.getLineLength(f)}getLineMinColumn(f){return 1}getLineMaxColumn(f){return this.getLineLength(f)+1}getLineFirstNonWhitespaceColumn(f){const y=F.$Re(this.getLineContent(f));return y===-1?0:y+1}getLineLastNonWhitespaceColumn(f){const y=F.$Te(this.getLineContent(f));return y===-1?0:y+2}n(f){switch(f){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(f){this.c.setEOL(f)}applyEdits(f,y,S){let p=this.g,c=this.h,s=this.j,i=!0,n=[];for(let l=0;l<f.length;l++){const h=f[l];i&&h._isTracked&&(i=!1);const k=h.range;if(h.text){let C=!0;s||(C=!F.$ff(h.text),s=C),!p&&C&&(p=F.$ef(h.text)),!c&&C&&(c=F.$hf(h.text))}let D="",$=0,b=0,v=0;if(h.text){let C;[$,b,v,C]=(0,w.$9s)(h.text);const N=this.getEOL();C===0||C===(N===`\r
`?2:1)?D=h.text:D=h.text.replace(/\r\n|\r|\n/g,N)}n[l]={sortIndex:l,identifier:h.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:D,eolCount:$,firstLineLength:b,lastLineLength:v,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}n.sort(A.u);let o=!1;for(let l=0,h=n.length-1;l<h;l++){const k=n[l].range.getEndPosition(),D=n[l+1].range.getStartPosition();if(D.isBeforeOrEqual(k)){if(D.isBefore(k))throw new Error("Overlapping ranges are not allowed!");o=!0}}i&&(n=this.s(n));const a=S||y?A._getInverseEditRanges(n):[],t=[];if(y)for(let l=0;l<n.length;l++){const h=n[l],k=a[l];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let D=k.startLineNumber;D<=k.endLineNumber;D++){let $="";D===k.startLineNumber&&($=this.getLineContent(h.range.startLineNumber),F.$Re($)!==-1)||t.push({lineNumber:D,oldContent:$})}}let r=null;if(S){let l=0;r=[];for(let h=0;h<n.length;h++){const k=n[h],D=a[h],$=this.getValueInRange(k.range),b=k.rangeOffset+l;l+=k.text.length-$.length,r[h]={sortIndex:k.sortIndex,identifier:k.identifier,range:D,text:$,textChange:new E.$Rs(k.rangeOffset,$,b,k.text)}}o||r.sort((h,k)=>h.sortIndex-k.sortIndex)}this.g=p,this.h=c,this.j=s;const d=this.t(n);let u=null;if(y&&t.length>0){t.sort((l,h)=>h.lineNumber-l.lineNumber),u=[];for(let l=0,h=t.length;l<h;l++){const k=t[l].lineNumber;if(l>0&&t[l-1].lineNumber===k)continue;const D=t[l].oldContent,$=this.getLineContent(k);$.length===0||$===D||F.$Re($)!==-1||u.push(k)}}return this.m.fire(),new L.$Ru(r,d,u)}s(f){return f.length<1e3?f:[this._toSingleEditOperation(f)]}_toSingleEditOperation(f){let y=!1;const S=f[0].range,p=f[f.length-1].range,c=new m.$ws(S.startLineNumber,S.startColumn,p.endLineNumber,p.endColumn);let s=S.startLineNumber,i=S.startColumn;const n=[];for(let d=0,u=f.length;d<u;d++){const l=f[d],h=l.range;y=y||l.forceMoveMarkers,n.push(this.getValueInRange(new m.$ws(s,i,h.startLineNumber,h.startColumn))),l.text.length>0&&n.push(l.text),s=h.endLineNumber,i=h.endColumn}const o=n.join(""),[a,t,r]=(0,w.$9s)(o);return{sortIndex:0,identifier:f[0].identifier,range:c,rangeOffset:this.getOffsetAt(c.startLineNumber,c.startColumn),rangeLength:this.getValueLengthInRange(c,0),text:o,eolCount:a,firstLineLength:t,lastLineLength:r,forceMoveMarkers:y,isAutoWhitespaceEdit:!1}}t(f){f.sort(A.w);const y=[];for(let S=0;S<f.length;S++){const p=f[S],c=p.range.startLineNumber,s=p.range.startColumn,i=p.range.endLineNumber,n=p.range.endColumn;if(c===i&&s===n&&p.text.length===0)continue;p.text?(this.c.delete(p.rangeOffset,p.rangeLength),this.c.insert(p.rangeOffset,p.text,!0)):this.c.delete(p.rangeOffset,p.rangeLength);const o=new m.$ws(c,s,i,n);y.push({range:o,rangeLength:p.rangeLength,text:p.text,rangeOffset:p.rangeOffset,forceMoveMarkers:p.forceMoveMarkers})}return y}findMatchesLineByLine(f,y,S,p){return this.c.findMatchesLineByLine(f,y,S,p)}getPieceTree(){return this.c}static _getInverseEditRange(f,y){const S=f.startLineNumber,p=f.startColumn,[c,s,i]=(0,w.$9s)(y);let n;if(y.length>0){const o=c+1;o===1?n=new m.$ws(S,p,S,p+s):n=new m.$ws(S,p,S+o-1,i+1)}else n=new m.$ws(S,p,S,p);return n}static _getInverseEditRanges(f){const y=[];let S=0,p=0,c=null;for(let s=0,i=f.length;s<i;s++){const n=f[s];let o,a;c?c.range.endLineNumber===n.range.startLineNumber?(o=S,a=p+(n.range.startColumn-c.range.endColumn)):(o=S+(n.range.startLineNumber-c.range.endLineNumber),a=n.range.startColumn):(o=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const r=n.eolCount+1;r===1?t=new m.$ws(o,a,o,a+n.firstLineLength):t=new m.$ws(o,a,o+r-1,n.lastLineLength+1)}else t=new m.$ws(o,a,o,a);S=t.endLineNumber,p=t.endColumn,y.push(t),c=n}return y}static u(f,y){const S=m.$ws.compareRangesUsingEnds(f.range,y.range);return S===0?f.sortIndex-y.sortIndex:S}static w(f,y){const S=m.$ws.compareRangesUsingEnds(f.range,y.range);return S===0?y.sortIndex-f.sortIndex:-S}}e.$IB=A}),define(ke[193],Se([1,0,13,128,192]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JB=void 0;class L{constructor(E,g,A,P,f,y,S,p,c){this.a=E,this.b=g,this.c=A,this.d=P,this.e=f,this.f=y,this.g=S,this.h=p,this.j=c}k(E){const g=this.c+this.d+this.e,A=this.c+this.e;return g===0?E===1?`
`:`\r
`:A>g/2?`\r
`:`
`}create(E){const g=this.k(E),A=this.a;if(this.j&&(g===`\r
`&&(this.c>0||this.d>0)||g===`
`&&(this.c>0||this.e>0)))for(let f=0,y=A.length;f<y;f++){const S=A[f].buffer.replace(/\r\n|\r|\n/g,g),p=(0,F.$DB)(S);A[f]=new F.$GB(S,p)}const P=new m.$IB(A,this.b,g,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(E){return this.a[0].buffer.substr(0,E).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(E){if(E.length===0)return;this.a.length===0&&I.$nf(E)&&(this.b=I.$mf,E=E.substr(1));const g=E.charCodeAt(E.length-1);g===13||g>=55296&&g<=56319?(this.m(E.substr(0,E.length-1),!1),this.c=!0,this.d=g):(this.m(E,!1),this.c=!1,this.d=g)}m(E,g){!g&&E.length===0||(this.c?this.n(String.fromCharCode(this.d)+E):this.n(E))}n(E){const g=(0,F.$EB)(this.e,E);this.a.push(new F.$GB(E,g.lineStarts)),this.f+=g.cr,this.g+=g.lf,this.h+=g.crlf,g.isBasicASCII||(this.l=!1,this.j||(this.j=I.$ef(E)),this.k||(this.k=I.$hf(E)))}finish(E=!0){return this.o(),new L(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,E)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const E=this.a[this.a.length-1];E.buffer+=String.fromCharCode(this.d);const g=(0,F.$DB)(E.buffer);E.lineStarts=g,this.d===13&&this.f++}}}e.$JB=R}),define(ke[132],Se([1,0,22,12]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y$=e.$x$=void 0;var m;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(m||(m={}));function L(P){for(let f=0,y=P.length;f<y;f+=4){const S=P[f+0],p=P[f+1],c=P[f+2],s=P[f+3];P[f+0]=s,P[f+1]=c,P[f+2]=p,P[f+3]=S}}function R(P){const f=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return F.$D()||L(f),I.$ce.wrap(f)}function w(P){const f=P.buffer;if(F.$D()||L(f),f.byteOffset%4===0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const y=new Uint8Array(f.byteLength);return y.set(f),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function E(P){const f=new Uint32Array(g(P));let y=0;if(f[y++]=P.id,P.type==="full")f[y++]=1,f[y++]=P.data.length,f.set(P.data,y),y+=P.data.length;else{f[y++]=2,f[y++]=P.deltas.length;for(const S of P.deltas)f[y++]=S.start,f[y++]=S.deleteCount,S.data?(f[y++]=S.data.length,f.set(S.data,y),y+=S.data.length):f[y++]=0}return R(f)}e.$x$=E;function g(P){let f=0;if(f+=1+1,P.type==="full")f+=1+P.data.length;else{f+=1,f+=(1+1+1)*P.deltas.length;for(const y of P.deltas)y.data&&(f+=y.data.length)}return f}function A(P){const f=w(P);let y=0;const S=f[y++];if(f[y++]===1){const i=f[y++],n=f.subarray(y,y+i);return y+=i,{id:S,type:"full",data:n}}const c=f[y++],s=[];for(let i=0;i<c;i++){const n=f[y++],o=f[y++],a=f[y++];let t;a>0&&(t=f.subarray(y,y+a),y+=a),s[i]={start:n,deleteCount:o,data:t}}return{id:S,type:"delta",deltas:s}}e.$y$=A}),define(ke[194],Se([8,9]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(ke[133],Se([1,0,19,24,12,170,127,194]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(le){le[le.None=0]="None",le[le.Keep=1]="Keep",le[le.Brackets=2]="Brackets",le[le.Advanced=3]="Advanced",le[le.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=g;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class P{constructor(ue,Ie,Ke,Ue){this.id=ue,this.name=Ie,this.defaultValue=Ke,this.schema=Ue}applyUpdate(ue,Ie){return y(ue,Ie)}compute(ue,Ie,Ke){return Ke}}class f{constructor(ue,Ie){this.newValue=ue,this.didChange=Ie}}e.ApplyUpdateResult=f;function y(le,ue){if(typeof le!="object"||typeof ue!="object"||!le||!ue)return new f(ue,le!==ue);if(Array.isArray(le)||Array.isArray(ue)){const Ke=Array.isArray(le)&&Array.isArray(ue)&&I.$tb(le,ue);return new f(ue,!Ke)}let Ie=!1;for(const Ke in ue)if(ue.hasOwnProperty(Ke)){const Ue=y(le[Ke],ue[Ke]);Ue.didChange&&(le[Ke]=Ue.newValue,Ie=!0)}return new f(le,Ie)}class S{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Ie){return y(ue,Ie)}validate(ue){return this.defaultValue}}class p{constructor(ue,Ie,Ke,Ue){this.id=ue,this.name=Ie,this.defaultValue=Ke,this.schema=Ue}applyUpdate(ue,Ie){return y(ue,Ie)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Ie,Ke){return Ke}}function c(le,ue){return typeof le>"u"?ue:le==="false"?!1:!!le}e.boolean=c;class s extends p{constructor(ue,Ie,Ke,Ue=void 0){typeof Ue<"u"&&(Ue.type="boolean",Ue.default=Ke),super(ue,Ie,Ke,Ue)}validate(ue){return c(ue,this.defaultValue)}}function i(le,ue,Ie,Ke){if(typeof le>"u")return ue;let Ue=parseInt(le,10);return isNaN(Ue)?ue:(Ue=Math.max(Ie,Ue),Ue=Math.min(Ke,Ue),Ue|0)}e.clampedInt=i;class n extends p{static clampedInt(ue,Ie,Ke,Ue){return i(ue,Ie,Ke,Ue)}constructor(ue,Ie,Ke,Ue,Ze,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Ke,nt.minimum=Ue,nt.maximum=Ze),super(ue,Ie,Ke,nt),this.minimum=Ue,this.maximum=Ze}validate(ue){return n.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function o(le,ue,Ie,Ke){if(typeof le>"u")return ue;const Ue=a.float(le,ue);return a.clamp(Ue,Ie,Ke)}e.clampedFloat=o;class a extends p{static clamp(ue,Ie,Ke){return ue<Ie?Ie:ue>Ke?Ke:ue}static float(ue,Ie){if(typeof ue=="number")return ue;if(typeof ue>"u")return Ie;const Ke=parseFloat(ue);return isNaN(Ke)?Ie:Ke}constructor(ue,Ie,Ke,Ue,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Ke),super(ue,Ie,Ke,Ze),this.validationFn=Ue}validate(ue){return this.validationFn(a.float(ue,this.defaultValue))}}class t extends p{static string(ue,Ie){return typeof ue!="string"?Ie:ue}constructor(ue,Ie,Ke,Ue=void 0){typeof Ue<"u"&&(Ue.type="string",Ue.default=Ke),super(ue,Ie,Ke,Ue)}validate(ue){return t.string(ue,this.defaultValue)}}function r(le,ue,Ie,Ke){return typeof le!="string"?ue:Ke&&le in Ke?Ke[le]:Ie.indexOf(le)===-1?ue:le}e.stringSet=r;class d extends p{constructor(ue,Ie,Ke,Ue,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Ue,Ze.default=Ke),super(ue,Ie,Ke,Ze),this.c=Ue}validate(ue){return r(ue,this.defaultValue,this.c)}}class u extends P{constructor(ue,Ie,Ke,Ue,Ze,nt,ct=void 0){typeof ct<"u"&&(ct.type="string",ct.enum=Ze,ct.default=Ue),super(ue,Ie,Ke,ct),this.c=Ze,this.d=nt}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function l(le){switch(le){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",tags:["accessibility"],description:w.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Ie,Ke){return Ke===0?ue.accessibilitySupport:Ke}}class k extends P{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:w.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertSpace:c(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(le){le[le.Hidden=0]="Hidden",le[le.Blink=1]="Blink",le[le.Smooth=2]="Smooth",le[le.Phase=3]="Phase",le[le.Expand=4]="Expand",le[le.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function $(le){switch(le){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var b;(function(le){le[le.Line=1]="Line",le[le.Block=2]="Block",le[le.Underline=3]="Underline",le[le.LineThin=4]="LineThin",le[le.BlockOutline=5]="BlockOutline",le[le.UnderlineThin=6]="UnderlineThin"})(b||(e.TextEditorCursorStyle=b={}));function v(le){switch(le){case b.Line:return"line";case b.Block:return"block";case b.Underline:return"underline";case b.LineThin:return"line-thin";case b.BlockOutline:return"block-outline";case b.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=v;function C(le){switch(le){case"line":return b.Line;case"block":return b.Block;case"underline":return b.Underline;case"line-thin":return b.LineThin;case"block-outline":return b.BlockOutline;case"underline-thin":return b.UnderlineThin}}class N extends S{constructor(){super(141)}compute(ue,Ie,Ke){const Ue=["monaco-editor"];return Ie.get(39)&&Ue.push(Ie.get(39)),ue.extraEditorClassName&&Ue.push(ue.extraEditorClassName),Ie.get(73)==="default"?Ue.push("mouse-default"):Ie.get(73)==="copy"&&Ue.push("mouse-copy"),Ie.get(111)&&Ue.push("showUnused"),Ie.get(139)&&Ue.push("showDeprecated"),Ue.join(" ")}}class z extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(ue,Ie,Ke){return Ke&&ue.emptySelectionClipboard}}class M extends P{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[w.localize(8,null),w.localize(9,null),w.localize(10,null)],description:w.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[w.localize(12,null),w.localize(13,null),w.localize(14,null)],description:w.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:w.localize(16,null),included:m.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:w.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:w.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{cursorMoveOnType:c(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":r(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":r(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(Ie.loop,this.defaultValue.loop)}}}class T extends P{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:w.localize(19,null)},{type:"string",description:w.localize(20,null)}],description:w.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?T.OFF:ue==="true"?T.ON:ue:ue?T.ON:T.OFF}}e.EditorFontLigatures=T;class j extends P{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:w.localize(22,null)},{type:"string",description:w.localize(23,null)}],description:w.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?j.OFF:ue==="true"?j.TRANSLATE:ue:ue?j.TRANSLATE:j.OFF}compute(ue,Ie,Ke){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=j;class O extends S{constructor(){super(50)}compute(ue,Ie,Ke){return ue.fontInfo}}class q extends p{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(25,null)})}validate(ue){const Ie=a.float(ue,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ie,6,100)}compute(ue,Ie,Ke){return ue.fontInfo.fontSize}}class V extends P{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:w.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(n.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}class de extends P{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[w.localize(28,null),w.localize(29,null),w.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:w.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:w.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:w.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:w.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:w.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ke,description:w.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ke,description:w.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ke,description:w.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ke,description:w.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ke,description:w.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{multiple:r(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??r(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??r(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??r(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??r(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??r(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends P{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:w.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:w.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:w.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:w.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:w.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:c(Ie.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:c(Ie.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:c(Ie.above,this.defaultValue.above)}}}var X;(function(le){le[le.None=0]="None",le[le.Text=1]="Text",le[le.Blocks=2]="Blocks"})(X||(e.RenderMinimap=X={}));class Q extends S{constructor(){super(144)}compute(ue,Ie,Ke){return Q.computeLayout(Ie,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Ie=ue.height/ue.lineHeight,Ke=Math.floor(ue.paddingTop/ue.lineHeight);let Ue=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(Ue=Math.max(Ue,Ie-1));const Ze=(Ke+ue.viewLineCount+Ue)/(ue.pixelRatio*ue.height),nt=Math.floor(ue.viewLineCount/Ze);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Ue,desiredRatio:Ze,minimapLineCount:nt}}static c(ue,Ie){const Ke=ue.outerWidth,Ue=ue.outerHeight,Ze=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const nt=Ie.stableMinimapLayoutInput,ct=nt&&ue.outerHeight===nt.outerHeight&&ue.lineHeight===nt.lineHeight&&ue.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&ue.pixelRatio===nt.pixelRatio&&ue.scrollBeyondLastLine===nt.scrollBeyondLastLine&&ue.paddingTop===nt.paddingTop&&ue.paddingBottom===nt.paddingBottom&&ue.minimap.enabled===nt.minimap.enabled&&ue.minimap.side===nt.minimap.side&&ue.minimap.size===nt.minimap.size&&ue.minimap.showSlider===nt.minimap.showSlider&&ue.minimap.renderCharacters===nt.minimap.renderCharacters&&ue.minimap.maxColumn===nt.minimap.maxColumn&&ue.minimap.scale===nt.minimap.scale&&ue.verticalScrollbarWidth===nt.verticalScrollbarWidth&&ue.isViewportWrapping===nt.isViewportWrapping,bt=ue.lineHeight,Et=ue.typicalHalfwidthCharacterWidth,Kt=ue.scrollBeyondLastLine,Ht=ue.minimap.renderCharacters;let pt=Ze>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const zt=ue.minimap.maxColumn,Tt=ue.minimap.size,Gt=ue.minimap.side,Ut=ue.verticalScrollbarWidth,Dt=ue.viewLineCount,Ft=ue.remainingWidth,Bt=ue.isViewportWrapping,Jt=Ht?2:3;let Wt=Math.floor(Ze*Ue);const qt=Wt/Ze;let Nt=!1,ut=!1,ft=Jt*pt,At=pt/Ze,Vt=1;if(Tt==="fill"||Tt==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:Oe,desiredRatio:Ce,minimapLineCount:ie}=Q.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Kt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:Ue,lineHeight:bt,pixelRatio:Ze});if(Dt/ie>1)Nt=!0,ut=!0,pt=1,ft=1,At=pt/Ze;else{let Ve=!1,xe=pt+1;if(Tt==="fit"){const Je=Math.ceil((Me+Dt+Oe)*ft);Bt&&ct&&Ft<=Ie.stableFitRemainingWidth?(Ve=!0,xe=Ie.stableFitMaxMinimapScale):Ve=Je>Wt}if(Tt==="fill"||Ve){Nt=!0;const Je=pt;ft=Math.min(bt*Ze,Math.max(1,Math.floor(1/Ce))),Bt&&ct&&Ft<=Ie.stableFitRemainingWidth&&(xe=Ie.stableFitMaxMinimapScale),pt=Math.min(xe,Math.max(1,Math.floor(ft/Jt))),pt>Je&&(Vt=Math.min(2,pt/Je)),At=pt/Ze/Vt,Wt=Math.ceil(Math.max(Qt,Me+Dt+Oe)*ft),Bt?(Ie.stableMinimapLayoutInput=ue,Ie.stableFitRemainingWidth=Ft,Ie.stableFitMaxMinimapScale=pt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Lt=Math.floor(zt*At),at=Math.min(Lt,Math.max(0,Math.floor((Ft-Ut-2)*At/(Et+At)))+e.MINIMAP_GUTTER_WIDTH);let vt=Math.floor(Ze*at);const Ot=vt/Ze;vt=Math.floor(vt*Vt);const Pt=Ht?1:2,Ge=Gt==="left"?0:Ke-at-Ut;return{renderMinimap:Pt,minimapLeft:Ge,minimapWidth:at,minimapHeightIsEditorHeight:Nt,minimapIsSampling:ut,minimapScale:pt,minimapLineHeight:ft,minimapCanvasInnerWidth:vt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Ot,minimapCanvasOuterHeight:qt}}static computeLayout(ue,Ie){const Ke=Ie.outerWidth|0,Ue=Ie.outerHeight|0,Ze=Ie.lineHeight|0,nt=Ie.lineNumbersDigitCount|0,ct=Ie.typicalHalfwidthCharacterWidth,bt=Ie.maxDigitWidth,Et=Ie.pixelRatio,Kt=Ie.viewLineCount,Ht=ue.get(136),pt=Ht==="inherit"?ue.get(135):Ht,zt=pt==="inherit"?ue.get(131):pt,Tt=ue.get(134),Gt=Ie.isDominatedByLongLines,Ut=ue.get(57),Dt=ue.get(67).renderType!==0,Ft=ue.get(68),Bt=ue.get(105),Jt=ue.get(84),Wt=ue.get(72),qt=ue.get(103),Nt=qt.verticalScrollbarSize,ut=qt.verticalHasArrows,ft=qt.arrowSize,At=qt.horizontalScrollbarSize,Vt=ue.get(43),Lt=ue.get(110)!=="never";let at=ue.get(65);Vt&&Lt&&(at+=16);let vt=0;if(Dt){const kt=Math.max(nt,Ft);vt=Math.round(kt*bt)}let Ot=0;Ut&&(Ot=Ze*Ie.glyphMarginDecorationLaneCount);let Pt=0,Ge=Pt+Ot,Qt=Ge+vt,Me=Qt+at;const Oe=Ke-Ot-vt-at;let Ce=!1,ie=!1,Fe=-1;pt==="inherit"&&Gt?(Ce=!0,ie=!0):zt==="on"||zt==="bounded"?ie=!0:zt==="wordWrapColumn"&&(Fe=Tt);const Ve=Q.c({outerWidth:Ke,outerHeight:Ue,lineHeight:Ze,typicalHalfwidthCharacterWidth:ct,pixelRatio:Et,scrollBeyondLastLine:Bt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Wt,verticalScrollbarWidth:Nt,viewLineCount:Kt,remainingWidth:Oe,isViewportWrapping:ie},Ie.memory||new A);Ve.renderMinimap!==0&&Ve.minimapLeft===0&&(Pt+=Ve.minimapWidth,Ge+=Ve.minimapWidth,Qt+=Ve.minimapWidth,Me+=Ve.minimapWidth);const xe=Oe-Ve.minimapWidth,Je=Math.max(1,Math.floor((xe-Nt-2)/ct)),rt=ut?ft:0;return ie&&(Fe=Math.max(1,Je),zt==="bounded"&&(Fe=Math.min(Fe,Tt))),{width:Ke,height:Ue,glyphMarginLeft:Pt,glyphMarginWidth:Ot,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Ge,lineNumbersWidth:vt,decorationsLeft:Qt,decorationsWidth:at,contentLeft:Me,contentWidth:xe,minimap:Ve,viewportColumn:Je,isWordWrapMinified:Ce,isViewportWrapping:ie,wrappingColumn:Fe,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:At,overviewRuler:{top:rt,width:Nt,height:Ue-2*rt,right:0}}}}e.EditorLayoutInfoComputer=Q;class ae extends P{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[w.localize(47,null),w.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:w.localize(49,null)}})}validate(ue){return r(ue,"simple",["simple","advanced"])}compute(ue,Ie,Ke){return Ie.get(2)===2?"advanced":Ke}}class x extends P{constructor(){const ue={enabled:!0};super(64,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"boolean",default:ue.enabled,description:w.localize(50,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:c(ue.enabled,this.defaultValue.enabled)}}}class se extends P{constructor(){const ue={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:w.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:10,description:w.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:w.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:w.localize(54,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:c(Ie.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:c(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class pe extends P{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:w.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[w.localize(56,null),w.localize(57,null,m.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(58,null,m.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:w.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:w.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:w.localize(62,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:r(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:c(Ie.padding,this.defaultValue.padding)}}}class G extends P{constructor(){super(65,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):n.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Ie,Ke){return Ke<0?n.clampedInt(-Ke*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class U extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>a.clamp(ue,0,150),{markdownDescription:w.localize(63,null)})}compute(ue,Ie,Ke){return ue.fontInfo.lineHeight}}class ce extends P{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:w.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:w.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)],default:ue.size,description:w.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:w.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:w.localize(71,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:w.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:w.localize(74,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:c(Ie.enabled,this.defaultValue.enabled),autohide:c(Ie.autohide,this.defaultValue.autohide),size:r(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Ie.side,this.defaultValue.side,["right","left"]),showSlider:r(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ie.scale,1,1,3),maxColumn:n.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function be(le){return le==="ctrlCmd"?m.$j?"metaKey":"ctrlKey":"altKey"}class H extends P{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(76,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{top:n.clampedInt(Ie.top,0,0,1e3),bottom:n.clampedInt(Ie.bottom,0,0,1e3)}}}class Z extends P{constructor(){const ue={enabled:!0,cycle:!0};super(86,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:w.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:w.localize(78,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:c(Ie.enabled,this.defaultValue.enabled),cycle:c(Ie.cycle,this.defaultValue.cycle)}}}class Y extends S{constructor(){super(142)}compute(ue,Ie,Ke){return ue.pixelRatio}}class $e extends P{constructor(){const ue={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[w.localize(79,null),w.localize(80,null),w.localize(81,null)]}];super(89,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ue.strings,description:w.localize(82,null)},comments:{anyOf:Ie,default:ue.comments,description:w.localize(83,null)},other:{anyOf:Ie,default:ue.other,description:w.localize(84,null)}},default:ue,markdownDescription:w.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const Et=ue?"on":"off";return{comments:Et,strings:Et,other:Et}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Ie,comments:Ke,strings:Ue}=ue,Ze=["on","inline","off"];let nt,ct,bt;return typeof Ie=="boolean"?nt=Ie?"on":"off":nt=r(Ie,this.defaultValue.other,Ze),typeof Ke=="boolean"?ct=Ke?"on":"off":ct=r(Ke,this.defaultValue.comments,Ze),typeof Ue=="boolean"?bt=Ue?"on":"off":bt=r(Ue,this.defaultValue.strings,Ze),{other:nt,comments:ct,strings:bt}}}var ne;(function(le){le[le.Off=0]="Off",le[le.On=1]="On",le[le.Relative=2]="Relative",le[le.Interval=3]="Interval",le[le.Custom=4]="Custom"})(ne||(e.RenderLineNumbersType=ne={}));class fe extends P{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(86,null),w.localize(87,null),w.localize(88,null),w.localize(89,null)],default:"on",description:w.localize(90,null)})}validate(ue){let Ie=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Ie=4,Ke=ue):ue==="interval"?Ie=3:ue==="relative"?Ie=2:ue==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ke}}}function te(le){const ue=le.get(98);return ue==="editable"?le.get(91):ue!=="on"}e.filterValidationDecorations=te;class he extends P{constructor(){const ue=[],Ie={type:"number",description:w.localize(91,null)};super(102,"rulers",ue,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:w.localize(92,null),format:"color-hex"}}}]},default:ue,description:w.localize(93,null)})}validate(ue){if(Array.isArray(ue)){const Ie=[];for(const Ke of ue)if(typeof Ke=="number")Ie.push({column:n.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Ue=Ke;Ie.push({column:n.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return Ie.sort((Ke,Ue)=>Ke.column-Ue.column),Ie}return this.defaultValue}}class we extends P{constructor(){super(92,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Pe(le,ue){if(typeof le!="string")return ue;switch(le){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends P{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(94,null),w.localize(95,null),w.localize(96,null)],default:"auto",description:w.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(98,null),w.localize(99,null),w.localize(100,null)],default:"auto",description:w.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:w.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:w.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:w.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:w.localize(105,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue,Ke=n.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=n.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:c(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:n.clampedInt(Ie.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:n.clampedInt(Ie.verticalSliderSize,Ue,0,1e3),scrollByPage:c(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:c(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends P{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:w.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:w.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:w.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:w.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:w.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:w.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:w.localize(112,null)}})}applyUpdate(ue,Ie){let Ke=!1;Ie.allowedCharacters&&ue&&(F.$bn(ue.allowedCharacters,Ie.allowedCharacters)||(ue={...ue,allowedCharacters:Ie.allowedCharacters},Ke=!0)),Ie.allowedLocales&&ue&&(F.$bn(ue.allowedLocales,Ie.allowedLocales)||(ue={...ue,allowedLocales:Ie.allowedLocales},Ke=!0));const Ue=super.applyUpdate(ue,Ie);return Ke?new f(Ue.newValue,!0):Ue}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{nonBasicASCII:ge(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:c(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:c(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ge(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ge(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Ie){if(typeof ue!="object"||!ue)return Ie;const Ke={};for(const[Ue,Ze]of Object.entries(ue))Ze===!0&&(Ke[Ue]=!0);return Ke}}class re extends P{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:w.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover"],enumDescriptions:[w.localize(114,null),w.localize(115,null)],description:w.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:w.localize(117,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:c(Ie.enabled,this.defaultValue.enabled),mode:r(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:c(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:c(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class oe extends P{constructor(){const ue={enabled:L.$6r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$6r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:w.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:w.localize(119,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:c(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:c(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class _ extends P{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(120,null),w.localize(121,null),w.localize(122,null)],default:ue.bracketPairs,description:w.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(124,null),w.localize(125,null),w.localize(126,null)],default:ue.bracketPairsHorizontal,description:w.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:w.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:w.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[w.localize(130,null),w.localize(131,null),w.localize(132,null)],default:ue.highlightActiveIndentation,description:w.localize(133,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{bracketPairs:ge(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ge(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:ge(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ge(le,ue,Ie){const Ke=Ie.indexOf(le);return Ke===-1?ue:Ie[Ke]}class Ee extends P{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(134,null),w.localize(135,null)],default:ue.insertMode,description:w.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:w.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:w.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:w.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[w.localize(140,null),w.localize(141,null),w.localize(142,null),w.localize(143,null)],default:ue.selectionMode,markdownDescription:w.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:w.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:w.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:w.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:w.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:w.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:w.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:w.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(181,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertMode:r(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:c(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:c(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:c(Ie.preview,this.defaultValue.preview),previewMode:r(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(Ie.showMethods,this.defaultValue.showMethods),showFunctions:c(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:c(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:c(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:c(Ie.showFields,this.defaultValue.showFields),showVariables:c(Ie.showVariables,this.defaultValue.showVariables),showClasses:c(Ie.showClasses,this.defaultValue.showClasses),showStructs:c(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:c(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:c(Ie.showModules,this.defaultValue.showModules),showProperties:c(Ie.showProperties,this.defaultValue.showProperties),showEvents:c(Ie.showEvents,this.defaultValue.showEvents),showOperators:c(Ie.showOperators,this.defaultValue.showOperators),showUnits:c(Ie.showUnits,this.defaultValue.showUnits),showValues:c(Ie.showValues,this.defaultValue.showValues),showConstants:c(Ie.showConstants,this.defaultValue.showConstants),showEnums:c(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:c(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(Ie.showKeywords,this.defaultValue.showKeywords),showWords:c(Ie.showWords,this.defaultValue.showWords),showColors:c(Ie.showColors,this.defaultValue.showColors),showFiles:c(Ie.showFiles,this.defaultValue.showFiles),showReferences:c(Ie.showReferences,this.defaultValue.showReferences),showFolders:c(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:c(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:c(Ie.showUsers,this.defaultValue.showUsers),showIssues:c(Ie.showIssues,this.defaultValue.showIssues)}}}class ze extends P{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:w.localize(183,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:c(ue.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(le){le[le.None=0]="None",le[le.Same=1]="Same",le[le.Indent=2]="Indent",le[le.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class _e extends P{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[w.localize(184,null),w.localize(185,null),w.localize(186,null),w.localize(187,null)],description:w.localize(188,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Ie,Ke){return Ie.get(2)===2?0:Ke}}class Xe extends S{constructor(){super(145)}compute(ue,Ie,Ke){const Ue=Ie.get(144);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}class it extends P{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:w.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:w.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[w.localize(191,null),w.localize(192,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:c(Ie.enabled,this.defaultValue.enabled),showDropSelector:r(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends P{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:w.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:w.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[w.localize(195,null),w.localize(196,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:c(Ie.enabled,this.defaultValue.enabled),showPasteSelector:r(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Te="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:m.$j?Te:m.$k?qe:Ae,fontWeight:"normal",fontSize:m.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(le){return e.editorOptionsRegistry[le.id]=le,le}var Ye;(function(le){le[le.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",le[le.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",le[le.accessibilitySupport=2]="accessibilitySupport",le[le.accessibilityPageSize=3]="accessibilityPageSize",le[le.ariaLabel=4]="ariaLabel",le[le.ariaRequired=5]="ariaRequired",le[le.autoClosingBrackets=6]="autoClosingBrackets",le[le.autoClosingComments=7]="autoClosingComments",le[le.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",le[le.autoClosingDelete=9]="autoClosingDelete",le[le.autoClosingOvertype=10]="autoClosingOvertype",le[le.autoClosingQuotes=11]="autoClosingQuotes",le[le.autoIndent=12]="autoIndent",le[le.automaticLayout=13]="automaticLayout",le[le.autoSurround=14]="autoSurround",le[le.bracketPairColorization=15]="bracketPairColorization",le[le.guides=16]="guides",le[le.codeLens=17]="codeLens",le[le.codeLensFontFamily=18]="codeLensFontFamily",le[le.codeLensFontSize=19]="codeLensFontSize",le[le.colorDecorators=20]="colorDecorators",le[le.colorDecoratorsLimit=21]="colorDecoratorsLimit",le[le.columnSelection=22]="columnSelection",le[le.comments=23]="comments",le[le.contextmenu=24]="contextmenu",le[le.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",le[le.cursorBlinking=26]="cursorBlinking",le[le.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",le[le.cursorStyle=28]="cursorStyle",le[le.cursorSurroundingLines=29]="cursorSurroundingLines",le[le.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",le[le.cursorWidth=31]="cursorWidth",le[le.disableLayerHinting=32]="disableLayerHinting",le[le.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",le[le.domReadOnly=34]="domReadOnly",le[le.dragAndDrop=35]="dragAndDrop",le[le.dropIntoEditor=36]="dropIntoEditor",le[le.emptySelectionClipboard=37]="emptySelectionClipboard",le[le.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",le[le.extraEditorClassName=39]="extraEditorClassName",le[le.fastScrollSensitivity=40]="fastScrollSensitivity",le[le.find=41]="find",le[le.fixedOverflowWidgets=42]="fixedOverflowWidgets",le[le.folding=43]="folding",le[le.foldingStrategy=44]="foldingStrategy",le[le.foldingHighlight=45]="foldingHighlight",le[le.foldingImportsByDefault=46]="foldingImportsByDefault",le[le.foldingMaximumRegions=47]="foldingMaximumRegions",le[le.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",le[le.fontFamily=49]="fontFamily",le[le.fontInfo=50]="fontInfo",le[le.fontLigatures=51]="fontLigatures",le[le.fontSize=52]="fontSize",le[le.fontWeight=53]="fontWeight",le[le.fontVariations=54]="fontVariations",le[le.formatOnPaste=55]="formatOnPaste",le[le.formatOnType=56]="formatOnType",le[le.glyphMargin=57]="glyphMargin",le[le.gotoLocation=58]="gotoLocation",le[le.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",le[le.hover=60]="hover",le[le.inDiffEditor=61]="inDiffEditor",le[le.inlineSuggest=62]="inlineSuggest",le[le.letterSpacing=63]="letterSpacing",le[le.lightbulb=64]="lightbulb",le[le.lineDecorationsWidth=65]="lineDecorationsWidth",le[le.lineHeight=66]="lineHeight",le[le.lineNumbers=67]="lineNumbers",le[le.lineNumbersMinChars=68]="lineNumbersMinChars",le[le.linkedEditing=69]="linkedEditing",le[le.links=70]="links",le[le.matchBrackets=71]="matchBrackets",le[le.minimap=72]="minimap",le[le.mouseStyle=73]="mouseStyle",le[le.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",le[le.mouseWheelZoom=75]="mouseWheelZoom",le[le.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",le[le.multiCursorModifier=77]="multiCursorModifier",le[le.multiCursorPaste=78]="multiCursorPaste",le[le.multiCursorLimit=79]="multiCursorLimit",le[le.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",le[le.occurrencesHighlight=81]="occurrencesHighlight",le[le.overviewRulerBorder=82]="overviewRulerBorder",le[le.overviewRulerLanes=83]="overviewRulerLanes",le[le.padding=84]="padding",le[le.pasteAs=85]="pasteAs",le[le.parameterHints=86]="parameterHints",le[le.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",le[le.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",le[le.quickSuggestions=89]="quickSuggestions",le[le.quickSuggestionsDelay=90]="quickSuggestionsDelay",le[le.readOnly=91]="readOnly",le[le.readOnlyMessage=92]="readOnlyMessage",le[le.renameOnType=93]="renameOnType",le[le.renderControlCharacters=94]="renderControlCharacters",le[le.renderFinalNewline=95]="renderFinalNewline",le[le.renderLineHighlight=96]="renderLineHighlight",le[le.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",le[le.renderValidationDecorations=98]="renderValidationDecorations",le[le.renderWhitespace=99]="renderWhitespace",le[le.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",le[le.roundedSelection=101]="roundedSelection",le[le.rulers=102]="rulers",le[le.scrollbar=103]="scrollbar",le[le.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",le[le.scrollBeyondLastLine=105]="scrollBeyondLastLine",le[le.scrollPredominantAxis=106]="scrollPredominantAxis",le[le.selectionClipboard=107]="selectionClipboard",le[le.selectionHighlight=108]="selectionHighlight",le[le.selectOnLineNumbers=109]="selectOnLineNumbers",le[le.showFoldingControls=110]="showFoldingControls",le[le.showUnused=111]="showUnused",le[le.snippetSuggestions=112]="snippetSuggestions",le[le.smartSelect=113]="smartSelect",le[le.smoothScrolling=114]="smoothScrolling",le[le.stickyScroll=115]="stickyScroll",le[le.stickyTabStops=116]="stickyTabStops",le[le.stopRenderingLineAfter=117]="stopRenderingLineAfter",le[le.suggest=118]="suggest",le[le.suggestFontSize=119]="suggestFontSize",le[le.suggestLineHeight=120]="suggestLineHeight",le[le.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",le[le.suggestSelection=122]="suggestSelection",le[le.tabCompletion=123]="tabCompletion",le[le.tabIndex=124]="tabIndex",le[le.unicodeHighlighting=125]="unicodeHighlighting",le[le.unusualLineTerminators=126]="unusualLineTerminators",le[le.useShadowDOM=127]="useShadowDOM",le[le.useTabStops=128]="useTabStops",le[le.wordBreak=129]="wordBreak",le[le.wordSeparators=130]="wordSeparators",le[le.wordWrap=131]="wordWrap",le[le.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",le[le.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",le[le.wordWrapColumn=134]="wordWrapColumn",le[le.wordWrapOverride1=135]="wordWrapOverride1",le[le.wordWrapOverride2=136]="wordWrapOverride2",le[le.wrappingIndent=137]="wrappingIndent",le[le.wrappingStrategy=138]="wrappingStrategy",le[le.showDeprecated=139]="showDeprecated",le[le.inlayHints=140]="inlayHints",le[le.editorClassName=141]="editorClassName",le[le.pixelRatio=142]="pixelRatio",le[le.tabFocusMode=143]="tabFocusMode",le[le.layoutInfo=144]="layoutInfo",le[le.wrappingInfo=145]="wrappingInfo",le[le.defaultColorDecorators=146]="defaultColorDecorators",le[le.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",le[le.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(Ye||(e.EditorOption=Ye={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(197,null)})),acceptSuggestionOnEnter:Re(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(198,null),""],markdownDescription:w.localize(199,null)})),accessibilitySupport:Re(new h),accessibilityPageSize:Re(new n(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(200,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",w.localize(201,null))),ariaRequired:Re(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:w.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:Re(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(203,null),w.localize(204,null),""],description:w.localize(205,null)})),autoClosingComments:Re(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(206,null),w.localize(207,null),""],description:w.localize(208,null)})),autoClosingDelete:Re(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(209,null),""],description:w.localize(210,null)})),autoClosingOvertype:Re(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(211,null),""],description:w.localize(212,null)})),autoClosingQuotes:Re(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(213,null),w.localize(214,null),""],description:w.localize(215,null)})),autoIndent:Re(new u(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[w.localize(216,null),w.localize(217,null),w.localize(218,null),w.localize(219,null),w.localize(220,null)],description:w.localize(221,null)})),automaticLayout:Re(new s(13,"automaticLayout",!1)),autoSurround:Re(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(222,null),w.localize(223,null),w.localize(224,null),""],description:w.localize(225,null)})),bracketPairColorization:Re(new oe),bracketPairGuides:Re(new _),stickyTabStops:Re(new s(116,"stickyTabStops",!1,{description:w.localize(226,null)})),codeLens:Re(new s(17,"codeLens",!0,{description:w.localize(227,null)})),codeLensFontFamily:Re(new t(18,"codeLensFontFamily","",{description:w.localize(228,null)})),codeLensFontSize:Re(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:w.localize(229,null)})),colorDecorators:Re(new s(20,"colorDecorators",!0,{description:w.localize(230,null)})),colorDecoratorActivatedOn:Re(new d(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[w.localize(231,null),w.localize(232,null),w.localize(233,null)],description:w.localize(234,null)})),colorDecoratorsLimit:Re(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:w.localize(235,null)})),columnSelection:Re(new s(22,"columnSelection",!1,{description:w.localize(236,null)})),comments:Re(new k),contextmenu:Re(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new s(25,"copyWithSyntaxHighlighting",!0,{description:w.localize(237,null)})),cursorBlinking:Re(new u(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],$,{description:w.localize(238,null)})),cursorSmoothCaretAnimation:Re(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[w.localize(239,null),w.localize(240,null),w.localize(241,null)],description:w.localize(242,null)})),cursorStyle:Re(new u(28,"cursorStyle",b.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:w.localize(243,null)})),cursorSurroundingLines:Re(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(244,null)})),cursorSurroundingLinesStyle:Re(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(245,null),w.localize(246,null)],markdownDescription:w.localize(247,null)})),cursorWidth:Re(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(248,null)})),disableLayerHinting:Re(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new s(34,"domReadOnly",!1)),dragAndDrop:Re(new s(35,"dragAndDrop",!0,{description:w.localize(249,null)})),emptySelectionClipboard:Re(new z),dropIntoEditor:Re(new it),stickyScroll:Re(new se),experimentalWhitespaceRendering:Re(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[w.localize(250,null),w.localize(251,null),w.localize(252,null)],description:w.localize(253,null)})),extraEditorClassName:Re(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Re(new a(40,"fastScrollSensitivity",5,le=>le<=0?5:le,{markdownDescription:w.localize(254,null)})),find:Re(new M),fixedOverflowWidgets:Re(new s(42,"fixedOverflowWidgets",!1)),folding:Re(new s(43,"folding",!0,{description:w.localize(255,null)})),foldingStrategy:Re(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(256,null),w.localize(257,null)],description:w.localize(258,null)})),foldingHighlight:Re(new s(45,"foldingHighlight",!0,{description:w.localize(259,null)})),foldingImportsByDefault:Re(new s(46,"foldingImportsByDefault",!1,{description:w.localize(260,null)})),foldingMaximumRegions:Re(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:w.localize(261,null)})),unfoldOnClickAfterEndOfLine:Re(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(262,null)})),fontFamily:Re(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(263,null)})),fontInfo:Re(new O),fontLigatures2:Re(new T),fontSize:Re(new q),fontWeight:Re(new V),fontVariations:Re(new j),formatOnPaste:Re(new s(55,"formatOnPaste",!1,{description:w.localize(264,null)})),formatOnType:Re(new s(56,"formatOnType",!1,{description:w.localize(265,null)})),glyphMargin:Re(new s(57,"glyphMargin",!0,{description:w.localize(266,null)})),gotoLocation:Re(new de),hideCursorInOverviewRuler:Re(new s(59,"hideCursorInOverviewRuler",!1,{description:w.localize(267,null)})),hover:Re(new ee),inDiffEditor:Re(new s(61,"inDiffEditor",!1)),letterSpacing:Re(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,le=>a.clamp(le,-5,20),{description:w.localize(268,null)})),lightbulb:Re(new x),lineDecorationsWidth:Re(new G),lineHeight:Re(new U),lineNumbers:Re(new fe),lineNumbersMinChars:Re(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new s(69,"linkedEditing",!1,{description:w.localize(269,null)})),links:Re(new s(70,"links",!0,{description:w.localize(270,null)})),matchBrackets:Re(new d(71,"matchBrackets","always",["always","near","never"],{description:w.localize(271,null)})),minimap:Re(new ce),mouseStyle:Re(new d(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new a(74,"mouseWheelScrollSensitivity",1,le=>le===0?1:le,{markdownDescription:w.localize(272,null)})),mouseWheelZoom:Re(new s(75,"mouseWheelZoom",!1,{markdownDescription:w.localize(273,null)})),multiCursorMergeOverlapping:Re(new s(76,"multiCursorMergeOverlapping",!0,{description:w.localize(274,null)})),multiCursorModifier:Re(new u(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],be,{markdownEnumDescriptions:[w.localize(275,null),w.localize(276,null)],markdownDescription:w.localize(277,null)})),multiCursorPaste:Re(new d(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(278,null),w.localize(279,null)],markdownDescription:w.localize(280,null)})),multiCursorLimit:Re(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:w.localize(281,null)})),occurrencesHighlight:Re(new s(81,"occurrencesHighlight",!0,{description:w.localize(282,null)})),multiDocumentOccurrencesHighlight:Re(new s(80,"multiDocumentOccurrencesHighlight",!1,{description:w.localize(283,null)})),overviewRulerBorder:Re(new s(82,"overviewRulerBorder",!0,{description:w.localize(284,null)})),overviewRulerLanes:Re(new n(83,"overviewRulerLanes",3,0,3)),padding:Re(new H),pasteAs:Re(new tt),parameterHints:Re(new Z),peekWidgetDefaultFocus:Re(new d(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(285,null),w.localize(286,null)],description:w.localize(287,null)})),definitionLinkOpensInPeek:Re(new s(88,"definitionLinkOpensInPeek",!1,{description:w.localize(288,null)})),quickSuggestions:Re(new $e),quickSuggestionsDelay:Re(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(289,null)})),readOnly:Re(new s(91,"readOnly",!1)),readOnlyMessage:Re(new we),renameOnType:Re(new s(93,"renameOnType",!1,{description:w.localize(290,null),markdownDeprecationMessage:w.localize(291,null)})),renderControlCharacters:Re(new s(94,"renderControlCharacters",!0,{description:w.localize(292,null),restricted:!0})),renderFinalNewline:Re(new d(95,"renderFinalNewline",m.$k?"dimmed":"on",["off","on","dimmed"],{description:w.localize(293,null)})),renderLineHighlight:Re(new d(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(294,null)],description:w.localize(295,null)})),renderLineHighlightOnlyWhenFocus:Re(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(296,null)})),renderValidationDecorations:Re(new d(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new d(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(297,null),w.localize(298,null),w.localize(299,null),""],description:w.localize(300,null)})),revealHorizontalRightPadding:Re(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new s(101,"roundedSelection",!0,{description:w.localize(301,null)})),rulers:Re(new he),scrollbar:Re(new B),scrollBeyondLastColumn:Re(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:w.localize(302,null)})),scrollBeyondLastLine:Re(new s(105,"scrollBeyondLastLine",!0,{description:w.localize(303,null)})),scrollPredominantAxis:Re(new s(106,"scrollPredominantAxis",!0,{description:w.localize(304,null)})),selectionClipboard:Re(new s(107,"selectionClipboard",!0,{description:w.localize(305,null),included:m.$k})),selectionHighlight:Re(new s(108,"selectionHighlight",!0,{description:w.localize(306,null)})),selectOnLineNumbers:Re(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:Re(new d(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[w.localize(307,null),w.localize(308,null),w.localize(309,null)],description:w.localize(310,null)})),showUnused:Re(new s(111,"showUnused",!0,{description:w.localize(311,null)})),showDeprecated:Re(new s(139,"showDeprecated",!0,{description:w.localize(312,null)})),inlayHints:Re(new pe),snippetSuggestions:Re(new d(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(313,null),w.localize(314,null),w.localize(315,null),w.localize(316,null)],description:w.localize(317,null)})),smartSelect:Re(new ze),smoothScrolling:Re(new s(114,"smoothScrolling",!1,{description:w.localize(318,null)})),stopRenderingLineAfter:Re(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new Ee),inlineSuggest:Re(new re),inlineCompletionsAccessibilityVerbose:Re(new s(148,"inlineCompletionsAccessibilityVerbose",!1,{description:w.localize(319,null)})),suggestFontSize:Re(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(320,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(321,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new s(121,"suggestOnTriggerCharacters",!0,{description:w.localize(322,null)})),suggestSelection:Re(new d(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(323,null),w.localize(324,null),w.localize(325,null)],description:w.localize(326,null)})),tabCompletion:Re(new d(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(327,null),w.localize(328,null),w.localize(329,null)],description:w.localize(330,null)})),tabIndex:Re(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new J),unusualLineTerminators:Re(new d(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(331,null),w.localize(332,null),w.localize(333,null)],description:w.localize(334,null)})),useShadowDOM:Re(new s(127,"useShadowDOM",!0)),useTabStops:Re(new s(128,"useTabStops",!0,{description:w.localize(335,null)})),wordBreak:Re(new d(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[w.localize(336,null),w.localize(337,null)],description:w.localize(338,null)})),wordSeparators:Re(new t(130,"wordSeparators",R.$7r,{description:w.localize(339,null)})),wordWrap:Re(new d(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(340,null),w.localize(341,null),w.localize(342,null),w.localize(343,null)],description:w.localize(344,null)})),wordWrapBreakAfterCharacters:Re(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new n(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(345,null)})),wordWrapOverride1:Re(new d(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new d(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new N),defaultColorDecorators:Re(new s(146,"defaultColorDecorators",!1,{markdownDescription:w.localize(346,null)})),pixelRatio:Re(new Y),tabFocusMode:Re(new s(143,"tabFocusMode",!1,{markdownDescription:w.localize(347,null)})),layoutInfo:Re(new Q),wrappingInfo:Re(new Xe),wrappingIndent:Re(new _e),wrappingStrategy:Re(new ae)}}),define(ke[195],Se([8,9]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(ke[84],Se([1,0,79,2,168,29,178,195]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$nt=e.$mt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$lt=e.$kt=e.SymbolKinds=e.SymbolTag=e.$jt=e.$it=e.SymbolKind=e.$ht=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$gt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$ft=e.$et=e.$dt=void 0;class E{constructor(T,j,O){this.offset=T,this.type=j,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$dt=E;class g{constructor(T,j){this.tokens=T,this.endState=j,this._tokenizationResultBrand=void 0}}e.$et=g;class A{constructor(T,j){this.tokens=T,this.endState=j,this._encodedTokenizationResultBrand=void 0}}e.$ft=A;var P;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(P||(e.CompletionItemKind=P={}));var f;(function(M){const T=new Map;T.set(0,I.$Xj.symbolMethod),T.set(1,I.$Xj.symbolFunction),T.set(2,I.$Xj.symbolConstructor),T.set(3,I.$Xj.symbolField),T.set(4,I.$Xj.symbolVariable),T.set(5,I.$Xj.symbolClass),T.set(6,I.$Xj.symbolStruct),T.set(7,I.$Xj.symbolInterface),T.set(8,I.$Xj.symbolModule),T.set(9,I.$Xj.symbolProperty),T.set(10,I.$Xj.symbolEvent),T.set(11,I.$Xj.symbolOperator),T.set(12,I.$Xj.symbolUnit),T.set(13,I.$Xj.symbolValue),T.set(15,I.$Xj.symbolEnum),T.set(14,I.$Xj.symbolConstant),T.set(15,I.$Xj.symbolEnum),T.set(16,I.$Xj.symbolEnumMember),T.set(17,I.$Xj.symbolKeyword),T.set(27,I.$Xj.symbolSnippet),T.set(18,I.$Xj.symbolText),T.set(19,I.$Xj.symbolColor),T.set(20,I.$Xj.symbolFile),T.set(21,I.$Xj.symbolReference),T.set(22,I.$Xj.symbolCustomColor),T.set(23,I.$Xj.symbolFolder),T.set(24,I.$Xj.symbolTypeParameter),T.set(25,I.$Xj.account),T.set(26,I.$Xj.issues);function j(V){let de=T.get(V);return de||(console.info("No codicon found for CompletionItemKind "+V),de=I.$Xj.symbolProperty),de}M.toIcon=j;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function q(V,de){let ee=O.get(V);return typeof ee>"u"&&!de&&(ee=9),ee}M.fromString=q})(f||(e.CompletionItemKinds=f={}));var y;(function(M){M[M.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var S;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var p;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(e.CompletionTriggerKind=p={}));var c;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(c||(e.InlineCompletionTriggerKind=c={}));class s{constructor(T,j,O,q){this.range=T,this.text=j,this.completionKind=O,this.isSnippetText=q}equals(T){return L.$ws.lift(this.range).equalsRange(T.range)&&this.text===T.text&&this.completionKind===T.completionKind&&this.isSnippetText===T.isSnippetText}}e.$gt=s;var i;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var o;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(o||(e.DocumentHighlightKind=o={}));function a(M){return M&&F.URI.isUri(M.uri)&&L.$ws.isIRange(M.range)&&(L.$ws.isIRange(M.originSelectionRange)||L.$ws.isIRange(M.targetSelectionRange))}e.$ht=a;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$it={[17]:(0,w.localize)(0,null),[16]:(0,w.localize)(1,null),[4]:(0,w.localize)(2,null),[13]:(0,w.localize)(3,null),[8]:(0,w.localize)(4,null),[9]:(0,w.localize)(5,null),[21]:(0,w.localize)(6,null),[23]:(0,w.localize)(7,null),[7]:(0,w.localize)(8,null),[0]:(0,w.localize)(9,null),[11]:(0,w.localize)(10,null),[10]:(0,w.localize)(11,null),[19]:(0,w.localize)(12,null),[5]:(0,w.localize)(13,null),[1]:(0,w.localize)(14,null),[2]:(0,w.localize)(15,null),[20]:(0,w.localize)(16,null),[15]:(0,w.localize)(17,null),[18]:(0,w.localize)(18,null),[24]:(0,w.localize)(19,null),[3]:(0,w.localize)(20,null),[6]:(0,w.localize)(21,null),[14]:(0,w.localize)(22,null),[22]:(0,w.localize)(23,null),[25]:(0,w.localize)(24,null),[12]:(0,w.localize)(25,null)};function r(M,T){return(0,w.localize)(26,null,M,e.$it[T])}e.$jt=r;var d;(function(M){M[M.Deprecated=1]="Deprecated"})(d||(e.SymbolTag=d={}));var u;(function(M){const T=new Map;T.set(0,I.$Xj.symbolFile),T.set(1,I.$Xj.symbolModule),T.set(2,I.$Xj.symbolNamespace),T.set(3,I.$Xj.symbolPackage),T.set(4,I.$Xj.symbolClass),T.set(5,I.$Xj.symbolMethod),T.set(6,I.$Xj.symbolProperty),T.set(7,I.$Xj.symbolField),T.set(8,I.$Xj.symbolConstructor),T.set(9,I.$Xj.symbolEnum),T.set(10,I.$Xj.symbolInterface),T.set(11,I.$Xj.symbolFunction),T.set(12,I.$Xj.symbolVariable),T.set(13,I.$Xj.symbolConstant),T.set(14,I.$Xj.symbolString),T.set(15,I.$Xj.symbolNumber),T.set(16,I.$Xj.symbolBoolean),T.set(17,I.$Xj.symbolArray),T.set(18,I.$Xj.symbolObject),T.set(19,I.$Xj.symbolKey),T.set(20,I.$Xj.symbolNull),T.set(21,I.$Xj.symbolEnumMember),T.set(22,I.$Xj.symbolStruct),T.set(23,I.$Xj.symbolEvent),T.set(24,I.$Xj.symbolOperator),T.set(25,I.$Xj.symbolTypeParameter);function j(O){let q=T.get(O);return q||(console.info("No codicon found for SymbolKind "+O),q=I.$Xj.symbolProperty),q}M.toIcon=j})(u||(e.SymbolKinds=u={}));class l{static asEditOperation(T){return m.$xs.replace(L.$ws.lift(T.range),T.text)}}e.$kt=l;class h{static{this.Comment=new h("comment")}static{this.Imports=new h("imports")}static{this.Region=new h("region")}static fromValue(T){switch(T){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(T)}constructor(T){this.value=T}}e.$lt=h;var k;(function(M){function T(j){return!j||typeof j!="object"?!1:typeof j.id=="string"&&typeof j.title=="string"}M.is=T})(k||(e.Command=k={}));var D;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(D||(e.CommentThreadCollapsibleState=D={}));var $;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})($||(e.CommentThreadState=$={}));var b;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(b||(e.CommentMode=b={}));var v;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(v||(e.CommentState=v={}));var C;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(C||(e.InlayHintKind=C={}));class N{constructor(T){this.b=T,this.a=null}dispose(){this.a&&this.a.then(T=>{T&&T.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$mt=N,e.$nt=new R.$8s;var z;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}))}),define(ke[196],Se([8,9]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[197],Se([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[198],Se([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(ke[199],Se([8,9]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[200],Se([8,9]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[201],Se([8,9]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[202],Se([8,9]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[203],Se([8,9]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(ke[204],Se([8,9]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(ke[205],Se([8,9]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[206],Se([8,9]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(ke[207],Se([8,9]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[208],Se([8,9]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[209],Se([8,9]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(ke[210],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostChat",e)}),define(ke[211],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[212],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[213],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[214],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[215],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[216],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[217],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(ke[218],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[219],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[220],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[221],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[222],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[223],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[224],Se([8,9]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[225],Se([8,9]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(ke[226],Se([8,9]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(ke[227],Se([8,9]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(ke[228],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[229],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[230],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[231],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[232],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[233],Se([8,9]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[234],Se([8,9]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[235],Se([8,9]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[236],Se([8,9]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[237],Se([8,9]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[238],Se([1,0,11,198]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.TokenType=void 0;var m;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(m||(e.TokenType=m={}));function L(...g){switch(g.length){case 1:return(0,F.localize)(0,null,g[0]);case 2:return(0,F.localize)(1,null,g[0],g[1]);case 3:return(0,F.localize)(2,null,g[0],g[1],g[2]);default:return}}const R=(0,F.localize)(3,null),w=(0,F.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,I.$7)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const P=this.d,f=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:f};this.g.push({offset:P,lexeme:f,additionalInfo:A}),this.f.push(y)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const P=this.c.substring(this.d,this.e),f=E.b.get(P);f?this.k(f):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,P=!1,f=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(w);return}const S=this.c.charCodeAt(A);if(P)P=!1;else if(S===47&&!f){A++;break}else S===91?f=!0:S===92?P=!0:S===93&&(f=!1);A++}for(;A<this.c.length&&E.a.has(this.c.charCodeAt(A));)A++;this.e=A;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ni=E}),define(ke[239],Se([1,0,23,39,201,388]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function E(s){return s=s.trim(),s==="*"||R.test(s)}e.$Oo=E;function g(s){if(!E(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$Po=g;function A(s){if(!s)return null;const i=s.majorBase,n=s.majorMustEqual,o=s.minorBase;let a=s.minorMustEqual;const t=s.patchBase;let r=s.patchMustEqual;s.hasCaret&&(i===0||(a=!1),r=!1);let d=0;if(s.preRelease){const u=w.exec(s.preRelease);if(u){const[,l,h,k]=u;d=Date.UTC(Number(l),Number(h)-1,Number(k))}}return{majorBase:i,majorMustEqual:n,minorBase:o,minorMustEqual:a,patchBase:t,patchMustEqual:r,isMinimum:s.hasGreaterEquals,notBefore:d}}e.$Qo=A;function P(s,i,n){let o;typeof s=="string"?o=A(g(s)):o=s;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=A(g(n)):t=n,!o||!t)return!1;const r=o.majorBase,d=o.minorBase,u=o.patchBase;let l=t.majorBase,h=t.minorBase,k=t.patchBase;const D=t.notBefore;let $=t.majorMustEqual,b=t.minorMustEqual,v=t.patchMustEqual;return t.isMinimum?r>l?!0:r<l?!1:d>h?!0:d<h||a&&a<D?!1:u>=k:(r===1&&l===0&&(!$||!b||!v)&&(l=1,h=0,k=0,$=!0,b=!1,v=!1),r<l?!1:r>l?!$:d<h?!1:d>h?!b:u<k?!1:u>k?!v:!(a&&a<D))}e.$Ro=P;function f(s,i,n,o,a){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([F.default.Error,m.localize(0,null)]),t;if(typeof o.name!="string")return t.push([F.default.Error,m.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([F.default.Error,m.localize(2,null,"version")]),t;if(!o.engines)return t.push([F.default.Error,m.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([F.default.Error,m.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!c(o.extensionDependencies))return t.push([F.default.Error,m.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!c(o.activationEvents))return t.push([F.default.Error,m.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([F.default.Error,m.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([F.default.Warning,m.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([F.default.Error,m.localize(9,null,"main")]),t;{const u=(0,I.$wg)(n,o.main);(0,I.$qg)(u,n)||t.push([F.default.Warning,m.localize(10,null,u.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([F.default.Error,m.localize(11,null,"browser")]),t;{const u=(0,I.$wg)(n,o.browser);(0,I.$qg)(u,n)||t.push([F.default.Warning,m.localize(12,null,u.path,n.path)])}}if(!L.valid(o.version))return t.push([F.default.Error,m.localize(13,null)]),t;const r=[];if(!y(s,i,o,a,r))for(const u of r)t.push([F.default.Error,u]);return t}e.$So=f;function y(s,i,n,o,a){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:p(s,i,n.engines.vscode,a)}e.$To=y;function S(s,i,n){return s==="*"||p(i,n,s)}e.$Uo=S;function p(s,i,n,o=[]){const a=A(g(n));if(!a)return o.push(m.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return o.push(m.localize(15,null,n)),!1}else if(!a.majorMustEqual)return o.push(m.localize(16,null,n)),!1;return P(s,i,a)?!0:(o.push(m.localize(17,null,s,n)),!1)}function c(s){if(!Array.isArray(s))return!1;for(let i=0,n=s.length;i<n;i++)if(typeof s[i]!="string")return!1;return!0}}),define(ke[105],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=void 0;class I{constructor(m,L=[],R=!1){this.ctor=m,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.$Ph=I}),define(ke[106],Se([1,0,105]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=e.InstantiationType=void 0;const F=[];var m;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(m||(e.InstantiationType=m={}));function L(w,E,g){E instanceof I.$Ph||(E=new I.$Ph(E,[],!!g)),F.push([w,E])}e.$zr=L;function R(){return F}e.$Ar=R}),define(ke[240],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;class I{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$eq=I;class F{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const w=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(R);w.outgoing.set(E.key,E),E.incoming.set(w.key,w)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const w of this.a.values())w.outgoing.delete(R),w.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let w=this.a.get(R);return w||(w=new I(R,L),this.a.set(R,w)),w}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,w]of this.a)L.push(`${R}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const w=new Set([L]),E=this.c(R,w);if(E)return E}}c(L,R){for(const[w,E]of L.outgoing){if(R.has(w))return[...R,w].join(" -> ");R.add(w);const g=this.c(E,R);if(g)return g;R.delete(w)}}}e.$fq=F}),define(ke[5],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e._util=void 0;var I;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function w(E){return E[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=w})(I||(e._util=I={})),e.$Rh=m("instantiationService");function F(R,w,E){w[I.DI_TARGET]===w?w[I.DI_DEPENDENCIES].push({id:R,index:E}):(w[I.DI_DEPENDENCIES]=[{id:R,index:E}],w[I.DI_TARGET]=w)}function m(R){if(I.serviceIds.has(R))return I.serviceIds.get(R);const w=function(E,g,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(w,E,A)};return w.toString=()=>R,I.serviceIds.set(R,w),w}e.$Sh=m;function L(R){return R}e.$Th=L}),define(ke[44],Se([1,0,18,2,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.ConfigurationTarget=e.$oi=e.$ni=e.$mi=void 0,e.$mi=(0,m.$Sh)("configurationService");function L(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof F.URI)}e.$ni=L;function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof F.URI)}e.$oi=R;var w;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(w||(e.ConfigurationTarget=w={}));function E(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$pi=E;function g(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$qi=g;function A(s,i){const n=Object.create(null);for(const o in s)P(n,o,s[o],i);return n}e.$ri=A;function P(s,i,n,o){const a=i.split("."),t=a.pop();let r=s;for(let d=0;d<a.length;d++){const u=a[d];let l=r[u];switch(typeof l){case"undefined":l=r[u]=Object.create(null);break;case"object":break;default:o(`Ignoring ${i} as ${a.slice(0,d+1).join(".")} is ${JSON.stringify(l)}`);return}r=l}if(typeof r=="object"&&r!==null)try{r[t]=n}catch{o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}else o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}e.$si=P;function f(s,i){const n=i.split(".");y(s,n)}e.$ti=f;function y(s,i){const n=i.shift();if(i.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const o=s[n];typeof o=="object"&&!Array.isArray(o)&&(y(o,i),Object.keys(o).length===0&&delete s[n])}}function S(s,i,n){function o(r,d){let u=r;for(const l of d){if(typeof u!="object"||u===null)return;u=u[l]}return u}const a=i.split("."),t=o(s,a);return typeof t>"u"?n:t}e.$ui=S;function p(s,i,n){Object.keys(i).forEach(o=>{o!=="__proto__"&&(o in s?I.$Bf(s[o])&&I.$Bf(i[o])?p(s[o],i[o],n):n&&(s[o]=i[o]):s[o]=i[o])})}e.$vi=p;function c(s){return s.replace(/[\[\]]/g,"")}e.$wi=c}),define(ke[45],Se([1,0,12,13,238,5,197,11]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.ContextKeyExprType=e.$Oi=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",I.$j),E.set("isLinux",I.$k),E.set("isWindows",I.$i),E.set("isWeb",I.$o),E.set("isMacNative",I.$j&&!I.$o),E.set("isEdge",I.$H),E.set("isFirefox",I.$F),E.set("isChrome",I.$E),E.set("isSafari",I.$G);function g(G,U){if(E.get(G)!==void 0)throw(0,w.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(G,U)}e.$Oi=g;const A=Object.prototype.hasOwnProperty;var P;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const f={regexParsingWithErrorRecovery:!0},y=(0,R.localize)(0,null),S=(0,R.localize)(1,null),p=(0,R.localize)(2,null),c=(0,R.localize)(3,null),s=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),o=(0,R.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=f){this.k=U,this.d=new m.$Ni,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ce=this.l();if(!this.E()){const be=this.D(),H=be.type===17?i:void 0;throw this.h.push({message:s,offset:be.offset,lexeme:m.$Ni.getLexeme(be),additionalInfo:H}),a.c}return ce}catch(ce){if(ce!==a.c)throw ce;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ce=this.o();U.push(ce)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ce=this.s();U.push(ce)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),l.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ce=this.l();return this.A(1,c),ce?.negate()}case 17:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ce=this.l();return this.A(1,c),ce}case 17:{const ce=U.lexeme;if(this.z(),this.y(9)){const H=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),H.type!==10)throw this.B("REGEX",H);const Z=H.lexeme,Y=Z.lastIndexOf("/"),$e=Y===Z.length-1?void 0:this.w(Z.substring(Y+1));let ne;try{ne=new RegExp(Z.substring(1,Y),$e)}catch{throw this.B("REGEX",H)}return O.create(ce,ne)}switch(H.type){case 10:case 19:{const Z=[H.lexeme];this.z();let Y=this.D(),$e=0;for(let we=0;we<H.lexeme.length;we++)H.lexeme.charCodeAt(we)===40?$e++:H.lexeme.charCodeAt(we)===41&&$e--;for(;!this.E()&&Y.type!==15&&Y.type!==16;){switch(Y.type){case 0:$e++;break;case 1:$e--;break;case 10:case 18:for(let we=0;we<Y.lexeme.length;we++)Y.lexeme.charCodeAt(we)===40?$e++:H.lexeme.charCodeAt(we)===41&&$e--}if($e<0)break;Z.push(m.$Ni.getLexeme(Y)),this.z(),Y=this.D()}const ne=Z.join(""),fe=ne.lastIndexOf("/"),te=fe===ne.length-1?void 0:this.w(ne.substring(fe+1));let he;try{he=new RegExp(ne.substring(1,fe),te)}catch{throw this.B("REGEX",H)}return t.regex(ce,he)}case 18:{const Z=H.lexeme;this.z();let Y=null;if(!(0,F.$Ce)(Z)){const $e=Z.indexOf("/"),ne=Z.lastIndexOf("/");if($e!==ne&&$e>=0){const fe=Z.slice($e+1,ne),te=Z[ne+1]==="i"?"i":"";try{Y=new RegExp(fe,te)}catch{throw this.B("REGEX",H)}}}if(Y===null)throw this.B("REGEX",H);return O.create(ce,Y)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const H=this.u();return t.notIn(ce,H)}switch(this.D().type){case 3:{this.z();const H=this.u();if(this.x().type===18)return t.equals(ce,H);switch(H){case"true":return t.has(ce);case"false":return t.not(ce);default:return t.equals(ce,H)}}case 4:{this.z();const H=this.u();if(this.x().type===18)return t.notEquals(ce,H);switch(H){case"true":return t.not(ce);case"false":return t.has(ce);default:return t.notEquals(ce,H)}}case 5:return this.z(),T.create(ce,this.u());case 6:return this.z(),j.create(ce,this.u());case 7:return this.z(),z.create(ce,this.u());case 8:return this.z(),M.create(ce,this.u());case 13:return this.z(),t.in(ce,this.u());default:return t.has(ce)}}case 20:throw this.h.push({message:n,offset:U.offset,lexeme:"",additionalInfo:o}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ce){if(this.C(U))return this.z();throw this.B(ce,this.D())}B(U,ce,be){const H=(0,R.localize)(8,null,U,m.$Ni.getLexeme(ce)),Z=ce.offset,Y=m.$Ni.getLexeme(ce);return this.h.push({message:H,offset:Z,lexeme:Y,additionalInfo:be}),a.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Pi=a;class t{static false(){return l.INSTANCE}static true(){return h.INSTANCE}static has(U){return k.create(U)}static equals(U,ce){return D.create(U,ce)}static notEquals(U,ce){return v.create(U,ce)}static regex(U,ce){return O.create(U,ce)}static in(U,ce){return $.create(U,ce)}static notIn(U,ce){return b.create(U,ce)}static not(U){return C.create(U)}static and(...U){return de.create(U,null,!0)}static or(...U){return ee.create(U,null,!0)}static greater(U,ce){return z.create(U,ce)}static greaterEquals(U,ce){return M.create(U,ce)}static smaller(U,ce){return T.create(U,ce)}static smallerEquals(U,ce){return j.create(U,ce)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Qi=t;function r(G){const U=new a({regexParsingWithErrorRecovery:!1});return G.map(ce=>(U.parse(ce),U.lexingErrors.length>0?U.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,R.localize)(9,null,be.additionalInfo):(0,R.localize)(10,null),offset:be.offset,length:be.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}e.$Ri=r;function d(G,U){const ce=G?G.substituteConstants():void 0,be=U?U.substituteConstants():void 0;return!ce&&!be?!0:!ce||!be?!1:ce.equals(be)}e.$Si=d;function u(G,U){return G.cmp(U)}class l{static{this.INSTANCE=new l}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$Ti=l;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return l.INSTANCE}}e.$Ui=h;class k{static create(U,ce=null){const be=E.get(U);return typeof be=="boolean"?be?h.INSTANCE:l.INSTANCE:new k(U,ce)}constructor(U,ce){this.key=U,this.c=ce,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:Q(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=E.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:l.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Vi=k;class D{static create(U,ce,be=null){if(typeof ce=="boolean")return ce?k.create(U,be):C.create(U,be);const H=E.get(U);return typeof H=="boolean"?ce===(H?"true":"false")?h.INSTANCE:l.INSTANCE:new D(U,ce,be)}constructor(U,ce,be){this.c=U,this.d=ce,this.f=be,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=E.get(this.c);if(typeof U=="boolean"){const ce=U?"true":"false";return this.d===ce?h.INSTANCE:l.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Wi=D;class ${static create(U,ce){return new $(U,ce)}constructor(U,ce){this.d=U,this.f=ce,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ce=U.getValue(this.f),be=U.getValue(this.d);return Array.isArray(ce)?ce.includes(be):typeof be=="string"&&typeof ce=="object"&&ce!==null?A.call(ce,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.$Xi=$;class b{static create(U,ce){return new b(U,ce)}constructor(U,ce){this.d=U,this.f=ce,this.type=11,this.c=$.create(U,ce)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Yi=b;class v{static create(U,ce,be=null){if(typeof ce=="boolean")return ce?C.create(U,be):k.create(U,be);const H=E.get(U);return typeof H=="boolean"?ce===(H?"true":"false")?l.INSTANCE:h.INSTANCE:new v(U,ce,be)}constructor(U,ce,be){this.c=U,this.d=ce,this.f=be,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=E.get(this.c);if(typeof U=="boolean"){const ce=U?"true":"false";return this.d===ce?l.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Zi=v;class C{static create(U,ce=null){const be=E.get(U);return typeof be=="boolean"?be?l.INSTANCE:h.INSTANCE:new C(U,ce)}constructor(U,ce){this.c=U,this.d=ce,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:Q(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=E.get(this.c);return typeof U=="boolean"?U?l.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$1i=C;function N(G,U){if(typeof G=="string"){const ce=parseFloat(G);isNaN(ce)||(G=ce)}return typeof G=="string"||typeof G=="number"?U(G):l.INSTANCE}class z{static create(U,ce,be=null){return N(ce,H=>new z(U,H,be))}constructor(U,ce,be){this.c=U,this.d=ce,this.f=be,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$2i=z;class M{static create(U,ce,be=null){return N(ce,H=>new M(U,H,be))}constructor(U,ce,be){this.c=U,this.d=ce,this.f=be,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$3i=M;class T{static create(U,ce,be=null){return N(ce,H=>new T(U,H,be))}constructor(U,ce,be){this.c=U,this.d=ce,this.f=be,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$4i=T;class j{static create(U,ce,be=null){return N(ce,H=>new j(U,H,be))}constructor(U,ce,be){this.c=U,this.d=ce,this.f=be,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$5i=j;class O{static create(U,ce){return new O(U,ce)}constructor(U,ce){this.d=U,this.f=ce,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ce=this.f?this.f.source:"",be=U.f?U.f.source:"";return ce<be?-1:ce>be?1:0}equals(U){if(U.type===this.type){const ce=this.f?this.f.source:"",be=U.f?U.f.source:"";return this.d===U.d&&ce===be}return!1}substituteConstants(){return this}evaluate(U){const ce=U.getValue(this.d);return this.f?this.f.test(ce):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=q.create(this)),this.c}}e.$6i=O;class q{static create(U){return new q(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new q(this.c.map(U))}negate(){return this.c}}e.$7i=q;function V(G){let U=null;for(let ce=0,be=G.length;ce<be;ce++){const H=G[ce].substituteConstants();if(G[ce]!==H&&U===null){U=[];for(let Z=0;Z<ce;Z++)U[Z]=G[Z]}U!==null&&(U[ce]=H)}return U===null?G:U}class de{static create(U,ce,be){return de.d(U,ce,be)}constructor(U,ce){this.expr=U,this.c=ce,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ce=0,be=this.expr.length;ce<be;ce++){const H=u(this.expr[ce],U.expr[ce]);if(H!==0)return H}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ce=0,be=this.expr.length;ce<be;ce++)if(!this.expr[ce].equals(U.expr[ce]))return!1;return!0}return!1}substituteConstants(){const U=V(this.expr);return U===this.expr?this:de.create(U,this.c,!1)}evaluate(U){for(let ce=0,be=this.expr.length;ce<be;ce++)if(!this.expr[ce].evaluate(U))return!1;return!0}static d(U,ce,be){const H=[];let Z=!1;for(const Y of U)if(Y){if(Y.type===1){Z=!0;continue}if(Y.type===0)return l.INSTANCE;if(Y.type===6){H.push(...Y.expr);continue}H.push(Y)}if(H.length===0&&Z)return h.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(u);for(let Y=1;Y<H.length;Y++)H[Y-1].equals(H[Y])&&(H.splice(Y,1),Y--);if(H.length===1)return H[0];for(;H.length>1;){const Y=H[H.length-1];if(Y.type!==9)break;H.pop();const $e=H.pop(),ne=H.length===0,fe=ee.create(Y.expr.map(te=>de.create([te,$e],null,be)),null,ne);fe&&(H.push(fe),H.sort(u))}if(H.length===1)return H[0];if(be){for(let Y=0;Y<H.length;Y++)for(let $e=Y+1;$e<H.length;$e++)if(H[Y].negate().equals(H[$e]))return l.INSTANCE;if(H.length===1)return H[0]}return new de(H,ce)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ce of this.expr)U.push(...ce.keys());return U}map(U){return new de(this.expr.map(ce=>ce.map(U)),null)}negate(){if(!this.c){const U=[];for(const ce of this.expr)U.push(ce.negate());this.c=ee.create(U,this,!0)}return this.c}}e.$8i=de;class ee{static create(U,ce,be){return ee.d(U,ce,be)}constructor(U,ce){this.expr=U,this.c=ce,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ce=0,be=this.expr.length;ce<be;ce++){const H=u(this.expr[ce],U.expr[ce]);if(H!==0)return H}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ce=0,be=this.expr.length;ce<be;ce++)if(!this.expr[ce].equals(U.expr[ce]))return!1;return!0}return!1}substituteConstants(){const U=V(this.expr);return U===this.expr?this:ee.create(U,this.c,!1)}evaluate(U){for(let ce=0,be=this.expr.length;ce<be;ce++)if(this.expr[ce].evaluate(U))return!0;return!1}static d(U,ce,be){let H=[],Z=!1;if(U){for(let Y=0,$e=U.length;Y<$e;Y++){const ne=U[Y];if(ne){if(ne.type===0){Z=!0;continue}if(ne.type===1)return h.INSTANCE;if(ne.type===9){H=H.concat(ne.expr);continue}H.push(ne)}}if(H.length===0&&Z)return l.INSTANCE;H.sort(u)}if(H.length!==0){if(H.length===1)return H[0];for(let Y=1;Y<H.length;Y++)H[Y-1].equals(H[Y])&&(H.splice(Y,1),Y--);if(H.length===1)return H[0];if(be){for(let Y=0;Y<H.length;Y++)for(let $e=Y+1;$e<H.length;$e++)if(H[Y].negate().equals(H[$e]))return h.INSTANCE;if(H.length===1)return H[0]}return new ee(H,ce)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ce of this.expr)U.push(...ce.keys());return U}map(U){return new ee(this.expr.map(ce=>ce.map(U)),null)}negate(){if(!this.c){const U=[];for(const ce of this.expr)U.push(ce.negate());for(;U.length>1;){const ce=U.shift(),be=U.shift(),H=[];for(const Z of pe(ce))for(const Y of pe(be))H.push(de.create([Z,Y],null,!1));U.unshift(ee.create(H,null,!1))}this.c=ee.create(U,this,!0)}return this.c}}e.$9i=ee;class X extends k{static{this.d=[]}static all(){return X.d.values()}constructor(U,ce,be){super(U,null),this.f=ce,typeof be=="object"?X.d.push({...be,key:U}):be!==!0&&X.d.push({key:U,description:be,type:ce!=null?typeof ce:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return D.create(this.key,U)}notEqualsTo(U){return v.create(this.key,U)}}e.$0i=X,e.$$i=(0,L.$Sh)("contextKeyService");function Q(G,U){return G<U?-1:G>U?1:0}function ae(G,U,ce,be){return G<ce?-1:G>ce?1:U<be?-1:U>be?1:0}function x(G,U){if(G.type===0||U.type===1)return!0;if(G.type===9)return U.type===9?se(G.expr,U.expr):!1;if(U.type===9){for(const ce of U.expr)if(x(G,ce))return!0;return!1}if(G.type===6){if(U.type===6)return se(U.expr,G.expr);for(const ce of G.expr)if(x(ce,U))return!0;return!1}return G.equals(U)}e.$_i=x;function se(G,U){let ce=0,be=0;for(;ce<G.length&&be<U.length;){const H=G[ce].cmp(U[be]);if(H<0)return!1;H===0&&ce++,be++}return ce===G.length}function pe(G){return G.type===9?G.expr:[G]}}),define(ke[241],Se([1,0,23,39,199,5,102,12,24]),function(me,e,I,F,m,L,R,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iv=e.$Hv=e.ConfirmResult=e.$Gv=e.$Fv=e.$Ev=void 0,e.$Ev=(0,L.$Sh)("dialogService");var g;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(g||(g={}));class A{a(c){return this.d(c,g.Confirmation)}b(c){return this.d(c,g.Prompt)}c(c){return this.d(c,g.Input)}d(c,s){const i=[];switch(s){case g.Confirmation:{const n=c;n.primaryButton?i.push(n.primaryButton):i.push((0,m.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,m.localize)(1,null));break}case g.Prompt:{const n=c;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,m.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,m.localize)(3,null))),i.length===0&&i.push((0,m.localize)(4,null));break}case g.Input:{const n=c;n.primaryButton?i.push(n.primaryButton):i.push((0,m.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,m.localize)(6,null));break}}return i}e(c){if(typeof c=="string")return c;if(typeof c=="number")return c===F.default.Info?"info":c===F.default.Error?"error":c===F.default.Warning?"warning":"none"}f(c,s,i){const n=[...c.buttons??[]];c.cancelButton&&typeof c.cancelButton!="string"&&typeof c.cancelButton!="boolean"&&n.push(c.cancelButton);let o=n[s]?.run({checkboxChecked:i});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:i}}}e.$Fv=A,e.$Gv=(0,L.$Sh)("fileDialogService");var P;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const f=10;function y(p){const c=[];return c.push(...p.slice(0,f).map(s=>typeof s=="string"?s:(0,I.$tg)(s))),p.length>f&&(p.length-f===1?c.push((0,m.localize)(7,null)):c.push((0,m.localize)(8,null,p.length-f))),c.push(""),c.join(`
`)}e.$Hv=y;function S(p,c){const s=(0,E.$0m)(p);let i=(s.buttons??[]).map(t=>(0,R.$Bv)(t)),n=(p.buttons||[]).map((t,r)=>r),o=0,a=s.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(w.$k||w.$j){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const r=n[a];n.splice(a,1),n.splice(1,0,r),a=1}w.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),o=i.length-1,typeof t=="string"&&(a=o-1))}else if(w.$i&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const r=n[a];n.splice(a,1),n.push(r),a=i.length-1}}return s.buttons=i,s.defaultId=o,s.cancelId=a,s.noLink=!0,s.title=s.title||c.nameLong,{options:s,buttonIndeces:n}}e.$Iv=S}),define(ke[134],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.$Zh=void 0,e.$Zh=(0,I.$Sh)("environmentService"),e.$1h=(0,I.$Th)(e.$Zh)}),define(ke[135],Se([1,0,200,5]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ao=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=void 0,e.$1n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$2n=new RegExp(e.$1n),e.$3n="__web_extension",e.$4n="skipWalkthrough",e.$5n="extensionsSync",e.$6n="dependecyOrPackExtensionInstall";function m(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$7n=m;function L(s){switch(s){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$8n=L;function R(s,i){switch(s){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$9n=R;function w(s,i){return i==="web"&&!s.includes("web")}e.$0n=w;function E(s,i,n){return w(i,n)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===n}e.$$n=E;function g(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.$_n=g;var A;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var P;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var f;(function(s){s.Install="install",s.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var y;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$ao=(0,F.$Sh)("extensionGalleryService");var S;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var p;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class c extends Error{constructor(i,n){super(i),this.code=n,this.name=n}}e.$bo=c,e.$co=(0,F.$Sh)("extensionManagementService"),e.$do="extensionsIdentifiers/disabled",e.$eo="extensionsIdentifiers/enabled",e.$fo=(0,F.$Sh)("IGlobalExtensionEnablementService"),e.$go=(0,F.$Sh)("IExtensionTipsService"),e.$ho=(0,I.localize)(0,null),e.$io={value:e.$ho,original:"Extensions"},e.$jo={value:(0,I.localize)(1,null),original:"Preferences"}}),define(ke[242],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Yb=e.$$Yb=void 0,e.$$Yb=(0,I.$Sh)("externalTerminal"),e.$_Yb="Terminal.app"}),define(ke[243],Se([1,0,50,17,16,12,101,30,104,202,242]),function(me,e,I,F,m,L,R,w,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$07b=e.$97b=e.$87b=void 0;const P=g.localize(0,null);class f{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends f{static{this.b="cmd.exe"}openTerminal(o,a){return this.spawnTerminal(I,o,E.$El(),a)}spawnTerminal(o,a,t,r){const d=a.windowsExec||y.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const u=m.$mc(d,".exe").toLowerCase();if(u==="cmder")return o.spawn(d,r?[r]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return d.indexOf(" ")>=0&&l.push('""'),l.push(d),u==="wt"&&l.push("-d ."),new Promise((h,k)=>{const D=c(process),$=o.spawn(t,l,{cwd:r,env:D});$.on("error",k),$.on("exit",()=>h())})}runInTerminal(o,a,t,r,d){const u="windowsExec"in d&&d.windowsExec?d.windowsExec:y.getDefaultTerminalWindows();return new Promise((l,h)=>{const k=`"${a} - ${P}"`,D=`""${t.join('" "')}" & pause"`,$=Object.assign({},c(process),r);Object.keys($).filter(z=>$[z]===null).forEach(z=>delete $[z]);const b={cwd:a,env:$,windowsVerbatimArguments:!0};let v,C;m.$mc(u,".exe")==="wt"?(v=u,C=["-d",".",y.b,"/c",D]):(v=y.b,C=["/c","start",k,"/wait",u,"/c",D]),I.spawn(v,C,b).on("error",z=>{h(s(z))}),l(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.$87b=y;class S extends f{static{this.b="/usr/bin/osascript"}openTerminal(o,a){return this.spawnTerminal(I,o,a)}runInTerminal(o,a,t,r,d){const u=d.osxExec||A.$_Yb;return new Promise((l,h)=>{if(u===A.$_Yb||u==="iTerm.app"){const k=u===A.$_Yb?"TerminalHelper":"iTermHelper",$=[F.$dg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",o||P,"-w",a];for(const C of t)$.push("-a"),$.push(C);if(r){const C=Object.assign({},c(process),r);for(const N in C){const z=C[N];z===null?($.push("-u"),$.push(N)):($.push("-e"),$.push(`${N}=${z}`))}}let b="";const v=I.spawn(S.b,$);v.on("error",C=>{h(s(C))}),v.stderr.on("data",C=>{b+=C.toString()}),v.on("exit",C=>{if(C===0)l(void 0);else if(b){const N=b.split(`
`,1);h(new Error(N[0]))}else h(new Error(g.localize(1,null,k,C)))})}else h(new Error(g.localize(2,null,u)))})}spawnTerminal(o,a,t){const r=a.osxExec||A.$_Yb;return new Promise((d,u)=>{const l=["-a",r];t&&l.push(t);const h=c(process),k=o.spawn("/usr/bin/open",l,{cwd:t,env:h});k.on("error",u),k.on("exit",()=>d())})}}e.$97b=S;class p extends f{static{this.b=g.localize(3,null)}openTerminal(o,a){return this.spawnTerminal(I,o,a)}runInTerminal(o,a,t,r,d){const u=d.linuxExec?Promise.resolve(d.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((l,h)=>{const k=[];u.then(D=>{D.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const $=`${i(t)}; echo; read -p "${p.b}" -n1;`;k.push(`''${$}''`);const b=Object.assign({},c(process),r);Object.keys(b).filter(z=>b[z]===null).forEach(z=>delete b[z]);const v={cwd:a,env:b};let C="";const N=I.spawn(D,k,v);N.on("error",z=>{h(s(z))}),N.stderr.on("data",z=>{C+=z.toString()}),N.on("exit",z=>{if(z===0)l(void 0);else if(C){const M=C.split(`
`,1);h(new Error(M[0]))}else h(new Error(g.localize(4,null,D,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!L.$k)p.d=Promise.resolve("xterm");else{const o=await w.Promises.exists("/etc/debian_version");p.d=new Promise(a=>{o?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return p.d}spawnTerminal(o,a,t){const r=a.linuxExec?Promise.resolve(a.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((d,u)=>{r.then(l=>{const h=c(process),k=o.spawn(l,[],{cwd:t,env:h});k.on("error",u),k.on("exit",()=>d())})})}}e.$07b=p;function c(n){const o={...n.env};return(0,R.$Cl)(o),o}function s(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(g.localize(5,null,n.path)):n}function i(n){let o="";for(const a of n)a.indexOf(" ")>=0?o+='"'+a+'"':o+=a,o+=" ";return o}}),define(ke[31],Se([1,0,78,16,13,18,2,203,5,12,17,48]),function(me,e,I,F,m,L,R,w,E,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.FileKind=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.FileOperationResult=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileChangeType=e.$tk=e.FileOperation=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.FileSystemProviderErrorCode=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.FileSystemProviderCapabilities=e.$dk=e.FilePermission=e.FileType=e.$ck=e.$bk=void 0,e.$bk=(0,E.$Sh)("fileService");function f(x){return x.create===!0}e.$ck=f;var y;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var S;(function(x){x[x.Readonly=1]="Readonly",x[x.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function p(x){const se=x;return!!se&&typeof se.onDidChange=="function"}e.$dk=p;var c;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileAtomicWrite=32768]="FileAtomicWrite",x[x.FileAtomicDelete=65536]="FileAtomicDelete",x[x.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function s(x){return!!(x.capabilities&2)}e.$ek=s;function i(x){return!!(x.capabilities&8)}e.$fk=i;function n(x){return!!(x.capabilities&131072)}e.$gk=n;function o(x){return!!(x.capabilities&4)}e.$hk=o;function a(x){return!!(x.capabilities&16)}e.$ik=a;function t(x){return s(x)?!!(x.capabilities&16384):!1}e.$jk=t;function r(x){return s(x)?!!(x.capabilities&32768):!1}e.$kk=r;function d(x){return!!(x.capabilities&65536)}e.$lk=d;function u(x){return!!(x.capabilities&2048)}e.$mk=u;var l;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsStorageQuota="EntryExceedsStorageQuota",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class h extends Error{static create(se,pe){const G=new h(se.toString(),pe);return $(G,pe),G}constructor(se,pe){super(se),this.code=pe}}e.$nk=h;function k(x,se){return h.create(x,se)}e.$ok=k;function D(x){return x||k((0,w.localize)(0,null),l.Unknown)}e.$pk=D;function $(x,se){return x.name=se?`${se} (FileSystemError)`:"FileSystemError",x}e.$qk=$;function b(x){if(!x)return l.Unknown;if(x instanceof h)return x.code;const se=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!se)return l.Unknown;switch(se[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.$rk=b;function v(x){if(x instanceof j)return x.fileOperationResult;switch(b(x)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}e.$sk=v;var C;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class N{constructor(se,pe,G){this.resource=se,this.operation=pe,this.target=G}isOperation(se){return this.operation===se}}e.$tk=N;var z;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class M{static{this.a=null}constructor(se,pe){this.c=pe,this.b=void 0,this.d=new P.$U(()=>{const G=I.$Yh.forUris(()=>this.c);return G.fill(this.rawAdded.map(U=>[U,!0])),G}),this.f=new P.$U(()=>{const G=I.$Yh.forUris(()=>this.c);return G.fill(this.rawUpdated.map(U=>[U,!0])),G}),this.g=new P.$U(()=>{const G=I.$Yh.forUris(()=>this.c);return G.fill(this.rawDeleted.map(U=>[U,!0])),G}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const G of se){switch(G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}this.b!==M.a&&(typeof G.cId=="number"?this.b===void 0?this.b=G.cId:this.b!==G.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(se,...pe){return this.h(se,{includeChildren:!1},...pe)}affects(se,...pe){return this.h(se,{includeChildren:!0},...pe)}h(se,pe,...G){if(!se)return!1;const U=G.length>0;return!!((!U||G.includes(1))&&(this.d.value.get(se)||pe.includeChildren&&this.d.value.findSuperstr(se))||(!U||G.includes(0))&&(this.f.value.get(se)||pe.includeChildren&&this.f.value.findSuperstr(se))||(!U||G.includes(2))&&(this.g.value.findSubstr(se)||pe.includeChildren&&this.g.value.findSuperstr(se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(se){return this.b===se}hasCorrelation(){return typeof this.b=="number"}}e.$uk=M;function T(x,se,pe){return!x||!se||x===se||se.length>x.length?!1:(se.charAt(se.length-1)!==F.sep&&(se+=F.sep),pe?(0,m.$4e)(x,se):x.indexOf(se)===0)}e.$vk=T;class j extends Error{constructor(se,pe,G){super(se),this.fileOperationResult=pe,this.options=G}}e.$wk=j;class O extends j{constructor(se,pe,G,U){super(se,pe,U),this.fileOperationResult=pe,this.size=G}}e.$xk=O;class q extends j{constructor(se,pe,G){super(se,2,G),this.stat=pe}}e.$yk=q;var V;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.$zk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Ak={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Bk="files.associations",e.$Ck="files.exclude",e.$Dk="files.readonlyInclude",e.$Ek="files.readonlyExclude",e.$Fk="files.readonlyFromPermissions";var de;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(de||(e.FileKind=de={})),e.$Gk="";function ee(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.$Hk=ee;async function X(x,se){if(!se.hasProvider(R.URI.from({scheme:x.scheme})))return new Promise(pe=>{const G=se.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===x.scheme&&U.added&&(G.dispose(),pe())})})}e.$Ik=X;class Q{static{this.KB=1024}static{this.MB=Q.KB*Q.KB}static{this.GB=Q.MB*Q.KB}static{this.TB=Q.GB*Q.KB}static formatSize(se){return(0,L.$Df)(se)||(se=0),se<Q.KB?(0,w.localize)(1,null,se.toFixed(0)):se<Q.MB?(0,w.localize)(2,null,(se/Q.KB).toFixed(2)):se<Q.GB?(0,w.localize)(3,null,(se/Q.MB).toFixed(2)):se<Q.TB?(0,w.localize)(4,null,(se/Q.GB).toFixed(2)):(0,w.localize)(5,null,(se/Q.TB).toFixed(2))}}e.$Jk=Q;function ae(x){const se=typeof x=="string"||x?.scheme===A.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===A.Schemas.file?1024*Q.MB:se?10*Q.MB:g.$o?50*Q.MB:1024*Q.MB}e.$Kk=ae}),define(ke[244],Se([1,0,22,11,204,31]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;async function R(A,P,f,y,S,p){let c;try{await w(A,P,f,y,S,p)}catch(s){c=s}finally{c&&S.errorTransformer&&(c=S.errorTransformer(c)),typeof c<"u"&&f.error(c),f.end()}}e.$Pp=R;async function w(A,P,f,y,S,p){E(p);const c=await A.open(P,{create:!1});try{E(p);let s=0,i=0,n=S&&typeof S.length=="number"?S.length:void 0,o=I.$ce.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),a=S&&typeof S.position=="number"?S.position:0,t=0;do i=await A.read(c,a,o.buffer,t,o.byteLength-t),a+=i,t+=i,s+=i,typeof n=="number"&&(n-=i),t===o.byteLength&&(await f.write(y(o)),o=I.$ce.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&E(p)&&g(s,S));if(t>0){let r=t;typeof n=="number"&&(r=Math.min(t,n)),f.write(y(o.slice(0,r)))}}catch(s){throw(0,L.$pk)(s)}finally{await A.close(c)}}function E(A){if(A.isCancellationRequested)throw(0,F.$5)();return!0}function g(A,P){if(typeof P?.limits?.size=="number"&&A>P.limits.size)throw(0,L.$ok)((0,m.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[85],Se([1,0,34,3,16,12,2,31]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=e.$Tp=e.$Sp=e.$Rp=void 0;function E(s){return s.recursive===!0}e.$Rp=E;class g extends F.$Rc{static{this.a=5}constructor(i,n,o,a){super(),this.h=i,this.j=n,this.m=o,this.n=a,this.c=this.B(new F.$Sc),this.f=void 0,this.g=0}s(){const i=new F.$Qc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Sp=g;class A extends g{constructor(i,n,o){super(i,n,o,{type:"node.js",restartOnError:!1})}}e.$Tp=A;class P extends g{constructor(i,n,o){super(i,n,o,{type:"universal",restartOnError:!0})}}e.$Up=P;function f(s){return s.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}e.$Vp=f;function y(s){const i=new c;for(const n of s)i.processEvent(n);return i.coalesce()}e.$Wp=y;function S(s,i){return typeof i=="string"&&!i.startsWith(I.$vj)&&!(0,m.$hc)(i)?{base:s,pattern:i}:i}e.$Xp=S;function p(s,i){const n=[];for(const o of i)n.push((0,I.$zj)(S(s,o)));return n}e.$Yp=p;class c{constructor(){this.a=new Set,this.b=new Map}c(i){return L.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let o=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?o=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else o=!0;o&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(o=>o.type!==2?(i.push(o),!1):!0).sort((o,a)=>o.resource.fsPath.length-a.resource.fsPath.length).filter(o=>n.some(a=>(0,w.$vk)(o.resource.fsPath,a,!L.$k))?!1:(n.push(o.resource.fsPath),!0)).concat(i)}}}),define(ke[245],Se([1,0,55,10,21,33,3,77,16,12,23,2,103,30,85]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;class p extends R.$Rc{static{this.a=100}static{this.b=75}constructor(i,n,o,a){super(),this.m=i,this.n=n,this.r=o,this.s=a,this.c=this.B(new F.$0g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new F.$9g(t=>this.z(t),p.b)),this.g=(0,S.$Yp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$Yp)(this.m.path,this.m.includes):void 0,this.j=new m.$Yd,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await y.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await y.Promises.realpath(i.path),i.path===n&&(n=await(0,f.$9p)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(g.$j&&(0,L.$Yf)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$Rc.None;const o=new m.$Yd(this.j.token),a=new R.$Qc;try{const t=P.URI.file(this.m.path),r=(0,E.$mc)(i),d=(0,I.watch)(i);a.add((0,R.$Pc)(()=>{d.removeAllListeners(),d.close()})),this.G(`Started watching: '${i}'`);const u=new Set;if(n)try{for(const h of await y.Promises.readdir(i))u.add(h)}catch(h){this.D(h)}const l=new Map;a.add((0,R.$Pc)(()=>{for(const[,h]of l)h.dispose();l.clear()})),d.on("error",(h,k)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${h}, ${k})`),this.dispose()}),d.on("change",(h,k)=>{if(o.token.isCancellationRequested)return;this.G(`[raw] ["${h}"] ${k}`);let D="";if(k&&(D=k.toString(),g.$j&&(D=(0,w.$rl)(D))),!(!D||h!=="change"&&h!=="rename"))if(n)if(h==="rename"){l.get(D)?.dispose();const $=setTimeout(async()=>{if(l.delete(D),D===r&&!await y.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const b=await this.C((0,E.$ic)(i,D));if(o.token.isCancellationRequested)return;let v;b?u.has(D)?v=0:(v=1,u.add(D)):(u.delete(D),v=2),this.y({resource:(0,A.$wg)(t,D),type:v,cId:this.m.correlationId})},p.a);l.set(D,(0,R.$Pc)(()=>clearTimeout($)))}else{let $;u.has(D)?$=0:($=1,u.add(D)),this.y({resource:(0,A.$wg)(t,D),type:$,cId:this.m.correlationId})}else if(h==="rename"||D!==r){const $=setTimeout(async()=>{const b=await y.Promises.exists(i);o.token.isCancellationRequested||(b?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);a.clear(),a.add((0,R.$Pc)(()=>clearTimeout($)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await y.Promises.exists(i)&&!o.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,R.$Pc)(()=>{o.dispose(!0),a.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,S.$Wp)(i);if(n.length>0){if(this.s)for(const a of n)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(g.$k)return y.Promises.exists(i);try{const n=(0,E.$mc)(i);return(await y.Promises.readdir((0,E.$lc)(i))).some(a=>a===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$_p=p;async function c(s,i,n,o,a=512){const t=await y.Promises.open(s,"r"),r=Buffer.allocUnsafe(a),d=new m.$Yd(o);let u,l=!1;const h={path:s,excludes:[],recursive:!1},k=new p(h,D=>{(async()=>{for(const{type:$}of D)if($===0){if(l)return;l=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:b}=await y.Promises.read(t,r,0,a,null);if(!b||d.token.isCancellationRequested)break;i(r.slice(0,b))}}catch(b){u=new Error(b),d.dispose(!0)}finally{l=!1}}})()});return await k.ready,n(),new Promise((D,$)=>{d.token.onCancellationRequested(async()=>{k.dispose();try{await y.Promises.close(t)}catch(b){u=new Error(b)}u?$(u):D()})})}e.$aq=c}),define(ke[246],Se([1,0,4,34,3,12,245]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;class w extends m.$Rc{constructor(){super(...arguments),this.a=this.B(new I.$Od),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$Od),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(g){const A=this.j(g),P=A.filter(y=>{const S=this.c.get(y.path);return S?!(0,F.$Dj)(S.request.excludes,y.excludes)||!(0,F.$Dj)(S.request.includes,y.includes):!0}),f=Array.from(this.c.values()).filter(({request:y})=>!A.find(S=>S.path===y.path&&(0,F.$Dj)(S.excludes,y.excludes)&&(0,F.$Dj)(S.includes,y.includes))).map(({request:y})=>y.path);P.length&&this.m(`Request to start watching: ${P.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`).join(",")}`),f.length&&this.m(`Request to stop watching: ${f.join(",")}`);for(const y of f)this.h(y);for(const y of P)this.g(y)}g(g){const A=new R.$_p(g,f=>this.a.fire(f),f=>this.b.fire(f),this.f),P={request:g,instance:A};this.c.set(g.path,P)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const A=this.c.get(g);A&&(this.c.delete(g),A.instance.dispose())}j(g){const A=new Map;for(const P of g){const f=L.$k?P.path:P.path.toLowerCase();let y=A.get(P.correlationId);y||(y=new Map,A.set(P.correlationId,y)),y.set(f,P)}return Array.from(A.values()).map(P=>Array.from(P.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,A]of this.c)A.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,A){return A?`[File Watcher (node.js)] ${g} (path: ${A.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$bq=w}),define(ke[247],Se([1,0,85,246]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;class m extends I.$Tp{constructor(R,w,E){super(R,w,E),this.s()}r(R){return R.add(new F.$bq)}}e.$cq=m}),define(ke[248],Se([1,0,17,82,187,85]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;class R extends L.$Up{constructor(E,g,A){super(E,g,A),this.s()}r(E){const g=E.add(new m.$6p(I.$dg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(g.onDidProcessExit(({code:A,signal:P})=>this.t(`terminated by itself with code ${A}, signal: ${P}`))),F.ProxyChannel.toService((0,F.$zh)(g.getChannel("watcher")))}}e.$7p=R}),define(ke[107],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=void 0;class I{constructor(...m){this.a=new Map;for(const[L,R]of m)this.set(L,R)}set(m,L){const R=this.a.get(m);return this.a.set(m,L),R}has(m){return this.a.has(m)}get(m){return this.a.get(m)}}e.$Qh=I}),define(ke[249],Se([1,0,10,11,3,105,240,5,107,76]),function(me,e,I,F,m,L,R,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;const A=!1;class P extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class f{constructor(c=new E.$Qh,s=!1,i,n=A){this.f=c,this.g=s,this.h=i,this.i=n,this.o=new Set,this.f.set(w.$Rh,this),this._globalGraph=n?i?._globalGraph??new R.$fq(o=>o):void 0}createChild(c){return new f(c,this.g,this,this.i)}invokeFunction(c,...s){const i=S.traceInvocation(this.i,c);let n=!1;try{return c({get:a=>{if(n)throw(0,F.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...s)}finally{n=!0,i.stop()}}createInstance(c,...s){let i,n;return c instanceof L.$Ph?(i=S.traceCreation(this.i,c.ctor),n=this.j(c.ctor,c.staticArguments.concat(s),i)):(i=S.traceCreation(this.i,c),n=this.j(c,s,i)),i.stop(),n}j(c,s=[],i){const n=w._util.getServiceDependencies(c).sort((t,r)=>t.index-r.index),o=[];for(const t of n){const r=this.m(t.id,i);r||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(r)}const a=n.length>0?n[0].index:s.length;if(s.length!==a){console.trace(`[createInstance] First service dependency of ${c.name} at position ${a+1} conflicts with ${s.length} static arguments`);const t=a-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,a)}return Reflect.construct(c,s.concat(o))}k(c,s){if(this.f.get(c)instanceof L.$Ph)this.f.set(c,s);else if(this.h)this.h.k(c,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const s=this.f.get(c);return!s&&this.h?this.h.l(c):s}m(c,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const i=this.l(c);return i instanceof L.$Ph?this.q(c,i,s.branch(c,!0)):(s.branch(c,!1),i)}q(c,s,i){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,s,i)}finally{this.o.delete(c)}}r(c,s,i){const n=new R.$fq(t=>t.id.toString());let o=0;const a=[{id:c,desc:s,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),o++>1e3)throw new P(n);for(const r of w._util.getServiceDependencies(t.desc.ctor)){const d=this.l(r.id);if(d||this.u(`[createInstance] ${c} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),d instanceof L.$Ph){const u={id:r.id,desc:d,_trace:t._trace.branch(r.id,!0)};n.insertEdge(t,u),a.push(u)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new P(n);break}for(const{data:r}of t){if(this.l(r.id)instanceof L.$Ph){const u=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,u)}n.removeNode(r)}}return this.l(c)}s(c,s,i=[],n,o){if(this.f.get(c)instanceof L.$Ph)return this.t(c,s,i,n,o);if(this.h)return this.h.s(c,s,i,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(c,s,i=[],n,o){if(n){const a=new f(void 0,this.g,this,this.i);a.c=String(c);const t=new Map,r=new I.$bh(()=>{const d=a.j(s,i,o);for(const[u,l]of t){const h=d[u];if(typeof h=="function")for(const k of l)h.apply(d,k)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,u){if(!r.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let k=t.get(u);return k||(k=new g.$1c,t.set(u,k)),($,b,v)=>{const C=k.push([$,b,v]);return(0,m.$Pc)(C)}}if(u in d)return d[u];const l=r.value;let h=l[u];return typeof h!="function"||(h=h.bind(l),d[u]=h),h},set(d,u,l){return r.value[u]=l,!0},getPrototypeOf(d){return s.prototype}})}else return this.j(s,i,o)}u(c,s){if(s&&console.warn(c),this.g)throw new Error(c)}}e.$gq=f;var y;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(y||(y={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,s){return c?new S(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(c,s){return c?new S(1,s.name):S.c}static{this.f=0}constructor(c,s){this.type=c,this.name=s,this.g=Date.now(),this.h=[]}branch(c,s){const i=new S(3,c.toString());return this.h.push([c,s,i]),i}stop(){const c=Date.now()-this.g;S.f+=c;let s=!1;function i(o,a){const t=[],r=new Array(o+1).join("	");for(const[d,u,l]of a.h)if(u&&l){s=!0,t.push(`${r}CREATES -> ${d}`);const h=i(o+1,l);h&&t.push(h)}else t.push(`${r}uses -> ${d}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(c>2||s)&&S.all.add(n.join(`
`))}}e.$hq=S}),define(ke[15],Se([1,0,43,4,52,3,28,12,23,18,2,45,5]),function(me,e,I,F,m,L,R,w,E,g,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.log=e.$dj=e.LogLevel=e.$cj=e.$bj=e.$aj=void 0,e.$aj=(0,f.$Sh)("logService"),e.$bj=(0,f.$Sh)("loggerService");function y(){return new Date().toISOString()}function S($){return(0,g.$Df)($)}e.$cj=S;var p;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$dj=p.Info;function c($,b,v){switch(b){case p.Trace:$.trace(v);break;case p.Debug:$.debug(v);break;case p.Info:$.info(v);break;case p.Warning:$.warn(v);break;case p.Error:$.error(v);break;case p.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=c;function s($,b=!1){let v="";for(let C=0;C<$.length;C++){let N=$[C];if(N instanceof Error&&(N=(0,I.$Di)(N,b)),typeof N=="object")try{N=JSON.stringify(N)}catch{}v+=(C>0?" ":"")+N}return v}class i extends L.$Rc{constructor(){super(...arguments),this.b=e.$dj,this.c=this.B(new F.$Od),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==p.Off&&this.b<=b}}e.$fj=i;class n extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...v){this.f(p.Trace)&&this.g(p.Trace,s([b,...v],!0))}debug(b,...v){this.f(p.Debug)&&this.g(p.Debug,s([b,...v]))}info(b,...v){this.f(p.Info)&&this.g(p.Info,s([b,...v]))}warn(b,...v){this.f(p.Warning)&&this.g(p.Warning,s([b,...v]))}error(b,...v){if(this.f(p.Error))if(b instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=b.stack,this.g(p.Error,s(C))}else this.g(p.Error,s([b,...v]))}flush(){}}e.$gj=n;class o extends i{constructor(b=e.$dj){super(),this.setLevel(b),this.g=!w.$i}trace(b,...v){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,b,...v):console.log(`[main ${y()}]`,b,...v))}debug(b,...v){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,b,...v):console.log(`[main ${y()}]`,b,...v))}info(b,...v){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,b,...v):console.log(`[main ${y()}]`,b,...v))}warn(b,...v){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,b,...v):console.warn(`[main ${y()}]`,b,...v))}error(b,...v){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,b,...v):console.error(`[main ${y()}]`,b,...v))}dispose(){}flush(){}}e.$hj=o;class a extends i{constructor(b=e.$dj,v=!0){super(),this.g=v,this.setLevel(b)}trace(b,...v){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...v):console.log(b,...v))}debug(b,...v){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...v):console.log(b,...v))}info(b,...v){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...v):console.log(b,...v))}warn(b,...v){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...v):console.log(b,...v))}error(b,...v){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...v):console.error(b,...v))}dispose(){}flush(){}}e.$ij=a;class t extends i{constructor(b,v=e.$dj){super(),this.g=b,this.setLevel(v)}trace(b,...v){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(b),...v])}debug(b,...v){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(b),...v])}info(b,...v){this.f(p.Info)&&this.g.log(p.Info,[this.h(b),...v])}warn(b,...v){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(b),...v])}error(b,...v){this.f(p.Error)&&this.g.log(p.Error,[this.h(b),...v])}h(b){return typeof b=="string"?b:(0,I.$Di)(b,this.f(p.Trace))}dispose(){}flush(){}}e.$jj=t;class r extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const v of this.g)v.setLevel(b);super.setLevel(b)}trace(b,...v){for(const C of this.g)C.trace(b,...v)}debug(b,...v){for(const C of this.g)C.debug(b,...v)}info(b,...v){for(const C of this.g)C.info(b,...v)}warn(b,...v){for(const C of this.g)C.warn(b,...v)}error(b,...v){for(const C of this.g)C.error(b,...v)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose()}}e.$kj=r;class d extends L.$Rc{constructor(b,v,C){if(super(),this.h=b,this.j=v,this.b=new R.$zc,this.c=this.B(new F.$Od),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$Od),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$Od),this.onDidChangeVisibility=this.g.event,C)for(const N of C)this.b.set(N.resource,{logger:void 0,info:N})}m(b){return(0,g.$zf)(b)?[...this.b.values()].find(v=>v.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,v){const C=this.n(b),N=(0,g.$zf)(b)?b:v?.id??(0,m.$Gi)(C.toString()).toString(16);let z=this.b.get(C)?.logger;const M=v?.logLevel==="always"?p.Trace:v?.logLevel;z||(z=this.s(C,M??this.getLogLevel(C)??this.h,{...v,id:N}));const T={logger:z,info:{resource:C,id:N,logLevel:M,name:v?.name,hidden:v?.hidden,extensionId:v?.extensionId,when:v?.when}};return this.registerLogger(T.info),this.b.set(C,T),z}n(b){return(0,g.$zf)(b)?(0,E.$wg)(this.j,`${b}.log`):b}setLogLevel(b,v){if(A.URI.isUri(b)){const C=b,N=v,z=this.b.get(C);z&&N!==z.info.logLevel&&(z.info.logLevel=N===this.h?void 0:N,z.logger?.setLevel(N),this.b.set(z.info.resource,z),this.f.fire([C,N]))}else{this.h=b;for(const[C,N]of this.b.entries())this.b.get(C)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,v){const C=this.m(b);C&&v!==!C.info.hidden&&(C.info.hidden=!v,this.b.set(C.info.resource,C),this.g.fire([C.info.resource,v]))}getLogLevel(b){let v;return b&&(v=this.b.get(b)?.info.logLevel),v??this.h}registerLogger(b){const v=this.b.get(b.resource);v?v.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const v=this.b.get(b);v&&(v.logger&&v.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[v.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lj=d;class u{constructor(){this.onDidChangeLogLevel=new F.$Od().event}setLevel(b){}getLevel(){return p.Info}trace(b,...v){}debug(b,...v){}info(b,...v){}warn(b,...v){}error(b,...v){}critical(b,...v){}dispose(){}flush(){}}e.$mj=u;class l extends u{}e.$nj=l;function h($){if($.verbose)return p.Trace;if(typeof $.logLevel=="string"){const b=D($.logLevel.toLowerCase());if(b!==void 0)return b}return e.$dj}e.$oj=h;function k($){switch($){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$pj=k;function D($){switch($){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$qj=D,e.$rj=new P.$0i("logLevel",k(p.Info))}),define(ke[250],Se([1,0,19,10,11,4,3,16,85,15]),function(me,e,I,F,m,L,R,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;class A extends R.$Rc{constructor(f,y){super(),this.a=f,this.b=y,this.c=this.B(new L.$Od),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Od),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new F.$Sg(0)),this.w=[],this.y=this.B(new F.$Sg(0))}watch(f,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n(f,y):this.z(f,y)}n(f,y){const S={path:this.H(f),excludes:y.excludes,includes:y.includes,recursive:y.recursive,correlationId:y.correlationId},p=(0,I.$Tb)(this.j,S);return this.r(),(0,R.$Pc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(f=>(0,m.$Z)(f))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,E.$Vp)(y)),y=>this.G(y),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const f=this.b?.watcher?.recursive?.usePolling;if(f===!0)for(const y of this.j)(0,E.$Rp)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const y of this.j)(0,E.$Rp)(y)&&f.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(f,y){const S={path:this.H(f),excludes:y.excludes,includes:y.includes,recursive:!1,correlationId:y.correlationId},p=(0,I.$Tb)(this.w,S);return this.C(),(0,R.$Pc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(f=>(0,m.$Z)(f))}D(){return this.u||(this.u=this.B(this.F(f=>this.c.fire((0,E.$Vp)(f)),f=>this.G(f),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(f){f.type==="error"&&this.g.fire(f.message),this.a[f.type](f.message)}H(f){return(0,w.$gc)(f.fsPath)}}e.$Zp=A}),define(ke[251],Se([1,0,55,389,10,28,22,4,33,3,16,12,23,98,30,205,31,244,250,43,248,247]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0,(()=>{try{(0,F.gracefulify)(I)}catch(r){console.error(`Error enabling graceful-fs: ${(0,n.$Di)(r)}`)}})();class t extends i.$Zp{static{this.I=!1}constructor(d,u){super(d,u),this.onDidChangeCapabilities=w.Event.None,this.N=new L.$zc(l=>f.$ng.getComparisonKey(l)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,P.$k&&(this.J|=1024)),this.J}async stat(d){try{const{stat:u,symbolicLink:l}=await S.SymlinkSupport.stat(this.H(d));return{type:this.M(u,l),ctime:u.birthtime.getTime(),mtime:u.mtime.getTime(),size:u.size,permissions:u.mode&128?void 0:c.FilePermission.Locked}}catch(u){throw this.fb(u)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const u=await S.Promises.readdir(this.H(d),{withFileTypes:!0}),l=[];return await Promise.all(u.map(async h=>{try{let k;h.isSymbolicLink()?k=(await this.stat((0,f.$wg)(d,h.name))).type:k=this.M(h),l.push([h.name,k])}catch(k){this.a.trace(k)}})),l}catch(u){throw this.fb(u)}}M(d,u){let l;return u?.dangling?l=c.FileType.Unknown:d.isFile()?l=c.FileType.File:d.isDirectory()?l=c.FileType.Directory:l=c.FileType.Unknown,u&&(l|=c.FileType.SymbolicLink),l}async O(d){const u=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${u})`);let l;for(;l=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${u})`),await l.wait();const h=new m.$Tg;return this.N.set(d,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${u})`),(0,g.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${u})`),this.N.get(d)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${u})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${u})`),h.open()})}async readFile(d,u){let l;try{u?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),l=await this.O(d));const h=this.H(d);return await S.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{l?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,u,l){const h=(0,y.$3d)(k=>R.$ce.concat(k.map(D=>R.$ce.wrap(D))).buffer);return(0,s.$Pp)(this,d,h,k=>k.buffer,{...u,bufferSize:256*1024},l),h}async writeFile(d,u,l){return l?.atomic!==!1&&l?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,f.$wg)((0,f.$vg)(d),`${(0,f.$tg)(d)}${l.atomic.postfix}`),u,l):this.S(d,u,l)}async Q(d){try{const u=this.H(d),{symbolicLink:l}=await S.SymlinkSupport.stat(u);if(l)return!1}catch{}return!0}async R(d,u,l,h){const k=new g.$Qc;try{k.add(await this.O(d)),k.add(await this.O(u)),await this.S(u,l,h,!0);try{await this.rename(u,d,{overwrite:!0})}catch(D){try{await this.delete(u,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{k.dispose()}}async S(d,u,l,h){let k;try{const D=this.H(d);if(!l.create||!l.overwrite){if(await S.Promises.exists(D)){if(!l.overwrite)throw(0,c.$ok)((0,p.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,c.$ok)((0,p.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}k=await this.open(d,{create:!0,unlock:l.unlock},h),await this.write(k,0,u,0,u.byteLength)}catch(D){throw await this.gb(d,D)}finally{typeof k=="number"&&await this.close(k)}}static{this.Y=!0}static configureFlushOnWrite(d){t.Y=d}async open(d,u,l){const h=this.H(d);let k;(0,c.$ck)(u)&&!l&&(k=await this.O(d));let D;try{if((0,c.$ck)(u)&&u.unlock)try{const{stat:b}=await S.SymlinkSupport.stat(h);b.mode&128||await S.Promises.chmod(h,b.mode|128)}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}let $;if((0,c.$ck)(u)){if(P.$i)try{await S.Promises.truncate(h,0),$="r+"}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}$||($="w")}else $="r";D=await S.Promises.open(h,$)}catch($){throw k?.dispose(),(0,c.$ck)(u)?await this.gb(d,$):this.fb($)}if(this.U.set(D,0),(0,c.$ck)(u)&&this.X.set(D,d),k){const $=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${h})`),this.W.set(D,k),$&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${h})`),$.dispose())}return D}async close(d){const u=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await S.Promises.fdatasync(d)}catch(l){t.configureFlushOnWrite(!1),this.a.error(l)}return await S.Promises.close(d)}catch(l){throw this.fb(l)}finally{u&&(this.W.get(d)===u&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),u.dispose())}}async read(d,u,l,h,k){const D=this.Z(d,u);let $=null;try{$=(await S.Promises.read(d,l,h,k,D)).bytesRead}catch(b){throw this.fb(b)}finally{this.$(d,D,$)}return $}Z(d,u){return u===this.U.get(d)?null:u}$(d,u,l){const h=this.U.get(d);typeof h=="number"&&(typeof u=="number"||(typeof l=="number"?this.U.set(d,h+l):this.U.delete(d)))}async write(d,u,l,h,k){return(0,m.$ch)(()=>this.ab(d,u,l,h,k),100,3)}async ab(d,u,l,h,k){const D=this.Z(d,u);let $=null;try{$=(await S.Promises.write(d,l,h,k,D)).bytesWritten}catch(b){throw await this.gb(this.X.get(d),b)}finally{this.$(d,D,$)}return $}async mkdir(d){try{await S.Promises.mkdir(this.H(d))}catch(u){throw this.fb(u)}}async delete(d,u){try{const l=this.H(d);if(u.recursive){let h;u?.atomic!==!1&&u.atomic.postfix&&(h=(0,A.$ic)((0,A.$lc)(l),`${(0,A.$mc)(l)}${u.atomic.postfix}`)),await S.Promises.rm(l,S.RimRafMode.MOVE,h)}else try{await S.Promises.unlink(l)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let k=!1;try{const{stat:D,symbolicLink:$}=await S.SymlinkSupport.stat(l);k=D.isDirectory()&&!$}catch{}if(k)await S.Promises.rmdir(l);else throw h}else throw h}}catch(l){throw this.fb(l)}}async rename(d,u,l){const h=this.H(d),k=this.H(u);if(h!==k)try{await this.bb(d,u,"move",l.overwrite),await S.Promises.rename(h,k)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,p.localize)(2,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(k)),D.toString()))),this.fb(D)}}async copy(d,u,l){const h=this.H(d),k=this.H(u);if(h!==k)try{await this.bb(d,u,"copy",l.overwrite),await S.Promises.copy(h,k,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,p.localize)(3,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(k)),D.toString()))),this.fb(D)}}async bb(d,u,l,h){const k=this.H(d),D=this.H(u);let $=!1;if(!!(this.capabilities&1024)||($=(0,E.$Xf)(k,D,!0)),$){if(l==="copy")throw(0,c.$ok)((0,p.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(l==="move")return}const v=await this.L(d);if(!v)throw(0,c.$ok)((0,p.localize)(5,null),c.FileSystemProviderErrorCode.FileNotFound);const C=await this.L(u);if(C){if(!h)throw(0,c.$ok)((0,p.localize)(6,null),c.FileSystemProviderErrorCode.FileExists);v.type&c.FileType.File&&C.type&c.FileType.File||await this.delete(u,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,u){return this.cb(d,u,!1)}async cb(d,u,l){const h=this.H(d),k=this.H(u),D=!!(this.capabilities&1024);if((0,E.$Xf)(h,k,!D))return;const $=new g.$Qc;try{$.add(await this.O(d)),$.add(await this.O(u)),l&&await S.Promises.mkdir((0,A.$lc)(k),{recursive:!0}),await S.Promises.copyFile(h,k)}catch(b){if(b.code==="ENOENT"&&!l)return this.cb(d,u,!0);throw this.fb(b)}finally{$.dispose()}}t(d,u,l){return new o.$7p(h=>d(h),h=>u(h),l)}F(d,u,l){return new a.$cq(h=>d(h),h=>u(h),l)}fb(d){if(d instanceof c.$nk)return d;let u=d,l;switch(d.code){case"ENOENT":l=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":u=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,l=c.FileSystemProviderErrorCode.Unknown;break;default:l=c.FileSystemProviderErrorCode.Unknown}return(0,c.$ok)(u,l)}async gb(d,u){let l=this.fb(u);if(d&&l.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await S.SymlinkSupport.stat(this.H(d));h.mode&128||(l=(0,c.$ok)(u,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return l}}e.$dq=t}),define(ke[252],Se([1,0,3,15]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=void 0;class m extends I.$Rc{constructor(R,w=[]){super(),this.a=new F.$kj([R,...w]),this.B(R.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...w){this.a.trace(R,...w)}debug(R,...w){this.a.debug(R,...w)}info(R,...w){this.a.info(R,...w)}warn(R,...w){this.a.warn(R,...w)}error(R,...w){this.a.error(R,...w)}flush(){this.a.flush()}}e.$TN=m}),define(ke[253],Se([1,0,31,15]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=void 0;var m;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(m||(m={}));async function L(g,A,P,f,y){try{const S=await new Promise((c,s)=>{me(["@vscode/spdlog"],c,s)});S.setFlushOn(m.Trace);const p=await S.createAsyncRotatingLogger(g,A,P,f);return y?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(S){console.error(S)}return null}function R(g,A,P){switch(A){case F.LogLevel.Trace:g.trace(P);break;case F.LogLevel.Debug:g.debug(P);break;case F.LogLevel.Info:g.info(P);break;case F.LogLevel.Warning:g.warn(P);break;case F.LogLevel.Error:g.error(P);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function w(g,A){switch(A){case F.LogLevel.Trace:g.setLevel(m.Trace);break;case F.LogLevel.Debug:g.setLevel(m.Debug);break;case F.LogLevel.Info:g.setLevel(m.Info);break;case F.LogLevel.Warning:g.setLevel(m.Warning);break;case F.LogLevel.Error:g.setLevel(m.Error);break;case F.LogLevel.Off:g.setLevel(m.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class E extends F.$gj{constructor(A,P,f,y,S){super(),this.m=[],this.setLevel(S),this.n=this.s(A,P,f,y),this.B(this.onDidChangeLogLevel(p=>{this.r&&w(this.r,p)}))}async s(A,P,f,y){const S=f?6:1,p=30/S*I.$Jk.MB,c=await L(A,P,p,S,y);if(c){this.r=c,w(this.r,this.getLevel());for(const{level:s,message:i}of this.m)R(this.r,s,i);this.m=[]}}g(A,P){this.r?R(this.r,A,P):this.getLevel()<=A&&this.m.push({level:A,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$IN=E}),define(ke[136],Se([1,0,39,206,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(E){function g(S,p){return p-S}E.compare=g;const A=Object.create(null);A[E.Error]=(0,F.localize)(0,null),A[E.Warning]=(0,F.localize)(1,null),A[E.Info]=(0,F.localize)(2,null);function P(S){return A[S]||""}E.toString=P;function f(S){switch(S){case I.default.Error:return E.Error;case I.default.Warning:return E.Warning;case I.default.Info:return E.Info;case I.default.Ignore:return E.Hint}}E.fromSeverity=f;function y(S){switch(S){case E.Error:return I.default.Error;case E.Warning:return I.default.Warning;case E.Info:return I.default.Info;case E.Hint:return I.default.Ignore}}E.toSeverity=y}(R||(e.MarkerSeverity=R={}));var w;(function(E){const g="";function A(f){return P(f,!0)}E.makeKey=A;function P(f,y){const S=[g];return f.source?S.push(f.source.replace("\xA6","\\\xA6")):S.push(g),f.code?typeof f.code=="string"?S.push(f.code.replace("\xA6","\\\xA6")):S.push(f.code.value.replace("\xA6","\\\xA6")):S.push(g),f.severity!==void 0&&f.severity!==null?S.push(R.toString(f.severity)):S.push(g),f.message&&y?S.push(f.message.replace("\xA6","\\\xA6")):S.push(g),f.startLineNumber!==void 0&&f.startLineNumber!==null?S.push(f.startLineNumber.toString()):S.push(g),f.startColumn!==void 0&&f.startColumn!==null?S.push(f.startColumn.toString()):S.push(g),f.endLineNumber!==void 0&&f.endLineNumber!==null?S.push(f.endLineNumber.toString()):S.push(g),f.endColumn!==void 0&&f.endColumn!==null?S.push(f.endColumn.toString()):S.push(g),S.push(g),S.join("\xA6")}E.makeKeyOptionalMessage=P})(w||(e.IMarkerData=w={})),e.$ct=(0,m.$Sh)("markerService")}),define(ke[254],Se([1,0,4,39,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5u=e.$4u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$3u=e.Severity=void 0,e.Severity=F.default,e.$3u=(0,m.$Sh)("notificationService");var L;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var w;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(w||(e.NotificationsFilter=w={}));class E{constructor(){this.progress=new g,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(P){}updateMessage(P){}updateActions(P){}close(){}}e.$4u=E;class g{infinite(){}done(){}total(P){}worked(P){}}e.$5u=g}),define(ke[137],Se([1,0,13,2,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MU=e.$LU=e.$KU=e.$JU=e.$IU=void 0,e.$IU=(0,m.$Sh)("openerService");function L(g,A){return F.URI.isUri(g)?(0,I.$3e)(g.scheme,A):(0,I.$4e)(g,A+":")}e.$JU=L;function R(g,...A){return A.some(P=>L(g,P))}e.$KU=R;function w(g,A){return g.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$LU=w;function E(g){let A;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return P&&(A={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},g=g.with({fragment:""})),{selection:A,uri:g}}e.$MU=E}),define(ke[255],Se([1,0,49]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let F;const m=globalThis.vscode;if(typeof m<"u"&&typeof m.context<"u"){const L=m.context.configuration();if(L)F=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(F=globalThis._VSCODE_PRODUCT_JSON,I.env.VSCODE_DEV&&Object.assign(F,{nameShort:`${F.nameShort} Dev`,nameLong:`${F.nameLong} Dev`,dataFolderName:`${F.dataFolderName}-dev`,serverDataFolderName:F.serverDataFolderName?`${F.serverDataFolderName}-dev`:void 0}),!F.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(F,{version:L.version})}}else F={},Object.keys(F).length===0&&Object.assign(F,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=F}),define(ke[138],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=void 0,e.$sj=(0,I.$Sh)("productService"),e.$tj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function(me,e){return function(I,F){e(I,F,me)}};define(ke[64],Se([1,0,10,21,3,5]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.ProgressLocation=e.$6u=void 0,e.$6u=(0,L.$Sh)("progressService");var R;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$7u=Object.freeze({total(){},worked(){},done(){}});class w{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(f){this.b=f}report(f){this.a=f,this.b(this.a)}}e.$8u=w;class E{get value(){return this.a}constructor(f){this.e=f}report(f){this.b?this.b.push(f):this.b=[f],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const f=this.b.shift();this.a=f,await this.e(this.a)}}finally{this.c=!1;const f=this.d;this.d=void 0,f?.()}}drain(){return this.c?new Promise(f=>{const y=this.d;this.d=()=>{y?.(),f()}}):Promise.resolve()}}e.$9u=E;let g=class extends m.$Rc{constructor(f,y){super(),this.a=new I.$fh,y.withProgress(f,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,m.$Pc)(()=>this.a.complete()))}report(f){this.b?this.b.report(f):this.c=f}};e.$0u=g,e.$0u=g=He([Be(1,e.$6u)],g);class A extends m.$Rc{constructor(f){super(),this.g=f,this.a=0,this.b=this.B(new m.$Qc)}start(f){this.stop();const y=++this.a,S=new F.$Yd;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},f),this.b.add((0,m.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,m.$Pc)(()=>S.cancel())),this.b.add((0,m.$Pc)(()=>this.c?this.c.done():void 0)),{id:y,token:S.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h(f){this.a===f&&this.b.clear()}}e.$$u=A,e.$_u=(0,L.$Sh)("editorProgressService")}),define(ke[38],Se([1,0,60,18]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=void 0;class m{constructor(){this.a=new Map}add(R,w){I.ok(F.$zf(R)),I.ok(F.$Bf(w)),I.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,w)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$jn=new m}),define(ke[108],Se([1,0,4,38]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0,e.$kn={JSONContribution:"base.contributions.json"};function m(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class L{constructor(){this.b=new I.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,g){this.a[m(E)]=g,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const R=new L;F.$jn.add(e.$kn.JSONContribution,R)}),define(ke[86],Se([1,0,19,4,18,196,44,108,38]),function(me,e,I,F,m,L,R,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.ConfigurationScope=e.$on=e.EditPresentationTypes=void 0;var g;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$on={Configuration:"base.contributions.configuration"};var A;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn="vscode://schemas/settings/resourceLanguage",e.$wn="vscode://schemas/settings/configurationDefaults";const P=E.$jn.as(w.$kn.JSONContribution);class f{constructor(){this.h=new Set,this.i=new F.$Od,this.onDidSchemaChange=this.i.event,this.j=new F.$Od,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$vn,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const d=new Set;this.n(t,r,d),P.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const r=new Set;this.o(t,r),P.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const d=new Set;this.o(r,d),this.n(t,!1,d),P.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const d=[];for(const{overrides:u,source:l}of t)for(const h in u)if(r.add(h),e.$yn.test(h)){const k=this.a.get(h),D=k?.valuesSources??new Map;if(l)for(const C of Object.keys(u[h]))D.set(C,l);const $={...k?.value||{},...u[h]};this.a.set(h,{source:l,value:$,valuesSources:D});const b=(0,R.$wi)(h),v={type:"object",default:$,description:L.localize(1,null,b),$ref:e.$vn,defaultDefaultValue:$,source:m.$zf(l)?void 0:l,defaultValueSource:l};d.push(...p(h)),this.d[h]=v,this.b.properties[h]=v}else{this.a.set(h,{value:u[h],source:l});const k=this.d[h];k&&(this.w(h,k),this.r(h,k))}this.m(d)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:d,source:u}of t)for(const l in d){const h=this.a.get(l),k=m.$zf(u)?u:u?.id,D=m.$zf(h?.source)?h?.source:h?.source?.id;if(k===D)if(r.add(l),this.a.delete(l),e.$yn.test(l))delete this.d[l],delete this.b.properties[l];else{const $=this.d[l];$&&(this.w(l,$),this.r(l,$))}}this.u()}deltaConfiguration(t){let r=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,d){t.forEach(u=>{this.p(u,r,u.extensionInfo,u.restrictedProperties,void 0,d),this.c.push(u),this.q(u)})}o(t,r){const d=u=>{if(u.properties)for(const l in u.properties){r.add(l);const h=this.d[l];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[l],this.s(l,u.properties[l])}u.allOf?.forEach(l=>d(l))};for(const u of t){d(u);const l=this.c.indexOf(u);l!==-1&&this.c.splice(l,1)}}p(t,r=!0,d,u,l=3,h){l=m.$If(t.scope)?l:t.scope;const k=t.properties;if(k)for(const $ in k){const b=k[$];if(r&&n($,b)){delete k[$];continue}if(b.source=d,b.defaultDefaultValue=k[$].default,this.w($,b),e.$yn.test($)?b.scope=void 0:(b.scope=m.$If(b.scope)?l:b.scope,b.restricted=m.$If(b.restricted)?!!u?.includes($):b.restricted),k[$].hasOwnProperty("included")&&!k[$].included){this.f[$]=k[$],delete k[$];continue}else this.d[$]=k[$],k[$].policy?.name&&this.e.set(k[$].policy.name,$);!k[$].deprecationMessage&&k[$].markdownDeprecationMessage&&(k[$].deprecationMessage=k[$].markdownDeprecationMessage),h.add($)}const D=t.allOf;if(D)for(const $ of D)this.p($,r,d,u,l,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=d=>{const u=d.properties;if(u)for(const h in u)this.r(h,u[h]);d.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$pn.properties[t]=r,r.scope){case 1:e.$qn.properties[t]=r;break;case 2:e.$rn.properties[t]=r;break;case 6:e.$sn.properties[t]=r;break;case 3:e.$tn.properties[t]=r;break;case 4:e.$un.properties[t]=r;break;case 5:e.$un.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$pn.properties[t],r.scope){case 1:delete e.$qn.properties[t];break;case 2:delete e.$rn.properties[t];break;case 6:delete e.$sn.properties[t];break;case 3:delete e.$tn.properties[t];break;case 4:case 5:delete e.$un.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,d={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$vn};this.w(r,d),e.$pn.properties[r]=d,e.$qn.properties[r]=d,e.$rn.properties[r]=d,e.$sn.properties[r]=d,e.$tn.properties[r]=d,e.$un.properties[r]=d}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$vn};e.$pn.patternProperties[e.$xn]=t,e.$qn.patternProperties[e.$xn]=t,e.$rn.patternProperties[e.$xn]=t,e.$sn.patternProperties[e.$xn]=t,e.$tn.patternProperties[e.$xn]=t,e.$un.patternProperties[e.$xn]=t,this.i.fire()}w(t,r){const d=this.a.get(t);let u=d?.value,l=d?.source;m.$Gf(u)&&(u=r.defaultDefaultValue,l=void 0),m.$Gf(u)&&(u=s(r.type)),r.default=u,r.defaultValueSource=l}}const y="\\[([^\\]]+)\\]",S=new RegExp(y,"g");e.$xn=`^(${y})+$`,e.$yn=new RegExp(e.$xn);function p(a){const t=[];if(e.$yn.test(a)){let r=S.exec(a);for(;r?.length;){const d=r[1].trim();d&&t.push(d),r=S.exec(a)}}return(0,I.$Lb)(t)}e.$zn=p;function c(a){return a.reduce((t,r)=>`${t}[${r}]`,"")}e.$An=c;function s(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Bn=s;const i=new f;E.$jn.add(e.$on.Configuration,i);function n(a,t){return a.trim()?e.$yn.test(a)?L.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?L.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$Cn=n;function o(){const a=[],t=i.getConfigurationProperties();for(const r of Object.keys(t))a.push([r,t[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$Dn=o}),define(ke[256],Se([1,0,19,4,160,3,28,24,18,2,44,86,38]),function(me,e,I,F,m,L,R,w,E,g,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=void 0;function y(r){return Object.isFrozen(r)?r:w.$$m(r)}class S{constructor(d={},u=[],l=[],h){this.b=d,this.c=u,this.d=l,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(u=>{if(u instanceof S)return u;const l=new p("");return l.parseRaw(u),l.configurationModel});this.f=d.reduce((u,l)=>l===u?l:u.merge(l),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,A.$ui)(this.contents,d):this.contents}inspect(d,u){const l=this.rawConfiguration.getValue(d),h=u?this.rawConfiguration.getOverrideValue(d,u):void 0,k=u?this.rawConfiguration.override(u).getValue(d):l;return{value:l,override:h,merged:k}}getOverrideValue(d,u){const l=this.i(u);return l?d?(0,A.$ui)(l,d):l:void 0}getKeysForOverrideIdentifier(d){const u=[];for(const l of this.overrides)l.identifiers.includes(d)&&u.push(...l.keys);return I.$Lb(u)}getAllOverrideIdentifiers(){const d=[];for(const u of this.overrides)d.push(...u.identifiers);return I.$Lb(d)}override(d){let u=this.a.get(d);return u||(u=this.g(d),this.a.set(d,u)),u}merge(...d){const u=w.$0m(this.contents),l=w.$0m(this.overrides),h=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const D of d)if(k.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(u,D.contents);for(const $ of D.overrides){const[b]=l.filter(v=>I.$tb(v.identifiers,$.identifiers));b?(this.h(b.contents,$.contents),b.keys.push(...$.keys),b.keys=I.$Lb(b.keys)):l.push(w.$0m($))}for(const $ of D.keys)h.indexOf($)===-1&&h.push($)}return new S(u,h,l,k.every(D=>D instanceof S)?void 0:k)}g(d){const u=this.i(d);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const l={};for(const h of I.$Lb([...Object.keys(this.contents),...Object.keys(u)])){let k=this.contents[h];const D=u[h];D&&(typeof k=="object"&&typeof D=="object"?(k=w.$0m(k),this.h(k,D)):k=D),l[h]=k}return new S(l,this.keys,this.overrides)}h(d,u){for(const l of Object.keys(u)){if(l in d&&E.$Bf(d[l])&&E.$Bf(u[l])){this.h(d[l],u[l]);continue}d[l]=w.$0m(u[l])}}i(d){let u=null,l=null;const h=k=>{k&&(l?this.h(l,k):l=w.$0m(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===d?u=k.contents:k.identifiers.includes(d)&&h(k.contents);return h(u),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,u){this.j(d,u,!0)}setValue(d,u){this.j(d,u,!1)}removeValue(d){const u=this.keys.indexOf(d);u!==-1&&(this.keys.splice(u,1),(0,A.$ti)(this.contents,d),P.$yn.test(d)&&this.overrides.splice(this.overrides.findIndex(l=>I.$tb(l.identifiers,(0,P.$zn)(d))),1))}j(d,u,l){(0,A.$si)(this.contents,d,u,h=>console.error(h)),l=l||this.keys.indexOf(d)===-1,l&&this.keys.push(d),P.$yn.test(d)&&this.overrides.push({identifiers:(0,P.$zn)(d),keys:Object.keys(this.contents[d]),contents:(0,A.$ri)(this.contents[d],h=>console.error(h))})}}e.$En=S;class p{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,u){if(!E.$If(d)){const l=this.g(d);this.parseRaw(l,u)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,u){this.a=d;const{contents:l,keys:h,overrides:k,restricted:D,hasExcludedProperties:$}=this.h(d,u);this.b=new S(l,h,k,$?[d]:void 0),this.c=D||[]}g(d){let u={},l=null,h=[];const k=[],D=[];function $(v){Array.isArray(h)?h.push(v):l!==null&&(h[l]=v)}const b={onObjectBegin:()=>{const v={};$(v),k.push(h),h=v,l=null},onObjectProperty:v=>{l=v},onObjectEnd:()=>{h=k.pop()},onArrayBegin:()=>{const v=[];$(v),k.push(h),h=v,l=null},onArrayEnd:()=>{h=k.pop()},onLiteralValue:$,onError:(v,C,N)=>{D.push({error:v,offset:C,length:N})}};if(d)try{m.$7m(d,b),u=h[0]||{}}catch(v){console.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return u}h(d,u){const l=f.$jn.as(P.$on.Configuration).getConfigurationProperties(),h=this.i(d,l,!0,u);d=h.raw;const k=(0,A.$ri)(d,b=>console.error(`Conflict in settings file ${this.f}: ${b}`)),D=Object.keys(d),$=this.j(d,b=>console.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:k,keys:D,overrides:$,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,u,l,h){let k=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:k};const D={},$=[];for(const b in d)if(P.$yn.test(b)&&l){const v=this.i(d[b],u,!1,h);D[b]=v.raw,k=k||v.hasExcludedProperties,$.push(...v.restricted)}else{const v=u[b],C=v?typeof v.scope<"u"?v.scope:3:void 0;v?.restricted&&$.push(b),!h.exclude?.includes(b)&&(h.include?.includes(b)||(C===void 0||h.scopes===void 0||h.scopes.includes(C))&&!(h.skipRestricted&&v?.restricted))?D[b]=d[b]:k=!0}return{raw:D,restricted:$,hasExcludedProperties:k}}j(d,u){const l=[];for(const h of Object.keys(d))if(P.$yn.test(h)){const k={};for(const D in d[h])k[D]=d[h][D];l.push({identifiers:(0,P.$zn)(h),keys:Object.keys(k),contents:(0,A.$ri)(k,u)})}return l}}e.$Fn=p;class c extends L.$Rc{constructor(d,u,l,h){super(),this.c=d,this.f=u,this.g=h,this.b=this.B(new F.$Od),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&l.isEqual(k.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Gn=c;class s{constructor(d,u,l,h,k,D,$,b,v,C,N,z,M){this.a=d,this.b=u,this.c=l,this.overrideIdentifiers=h,this.d=k,this.f=D,this.g=$,this.h=b,this.i=v,this.j=C,this.k=N,this.l=z,this.m=M}get value(){return y(this.c)}n(d,u,l){const h=d.inspect(u,l);return{get value(){return y(h.value)},get override(){return y(h.override)},get merged(){return y(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(d,u,l,h,k=new S,D=new S,$=new R.$zc,b=new S,v=new R.$zc){this.c=d,this.d=u,this.f=l,this.g=h,this.h=k,this.i=D,this.j=$,this.l=b,this.m=v,this.a=null,this.b=new R.$zc,this.n=null}getValue(d,u,l){return this.q(d,u,l).getValue(d)}updateValue(d,u,l={}){let h;l.resource?(h=this.m.get(l.resource),h||(h=new S,this.m.set(l.resource,h))):h=this.l,u===void 0?h.removeValue(d):h.setValue(d,u),l.resource||(this.a=null)}inspect(d,u,l){const h=this.q(d,u,l),k=this.u(u.resource,l),D=u.resource?this.m.get(u.resource)||this.l:this.l,$=new Set;for(const b of h.overrides)for(const v of b.identifiers)h.getOverrideValue(d,v)!==void 0&&$.add(v);return new s(d,u,h.getValue(d),$.size?[...$]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.i:void 0,k||void 0,D)}keys(d){const u=this.u(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,u){this.j.set(d,u),this.b.delete(d)}deleteFolderConfiguration(d){this.p.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,u){const l=[];if(!u){const{added:h,updated:k,removed:D}=a(this.c,d);u=[...h,...k,...D]}for(const h of u)for(const k of(0,P.$zn)(h)){const D=this.c.getKeysForOverrideIdentifier(k),$=d.getKeysForOverrideIdentifier(k),b=[...$.filter(v=>D.indexOf(v)===-1),...D.filter(v=>$.indexOf(v)===-1),...D.filter(v=>!w.$bn(this.c.override(k).getValue(v),d.override(k).getValue(v)))];l.push([k,b])}return this.updateDefaultConfiguration(d),{keys:u,overrides:l}}compareAndUpdatePolicyConfiguration(d){const{added:u,updated:l,removed:h}=a(this.d,d),k=[...u,...l,...h];return k.length&&this.updatePolicyConfiguration(d),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:u,updated:l,removed:h,overrides:k}=a(this.applicationConfiguration,d),D=[...u,...l,...h];return D.length&&this.updateApplicationConfiguration(d),{keys:D,overrides:k}}compareAndUpdateLocalUserConfiguration(d){const{added:u,updated:l,removed:h,overrides:k}=a(this.localUserConfiguration,d),D=[...u,...l,...h];return D.length&&this.updateLocalUserConfiguration(d),{keys:D,overrides:k}}compareAndUpdateRemoteUserConfiguration(d){const{added:u,updated:l,removed:h,overrides:k}=a(this.remoteUserConfiguration,d),D=[...u,...l,...h];return D.length&&this.updateRemoteUserConfiguration(d),{keys:D,overrides:k}}compareAndUpdateWorkspaceConfiguration(d){const{added:u,updated:l,removed:h,overrides:k}=a(this.workspaceConfiguration,d),D=[...u,...l,...h];return D.length&&this.updateWorkspaceConfiguration(d),{keys:D,overrides:k}}compareAndUpdateFolderConfiguration(d,u){const l=this.p.get(d),{added:h,updated:k,removed:D,overrides:$}=a(l,u),b=[...h,...k,...D];return(b.length||!l)&&this.updateFolderConfiguration(d,u),{keys:b,overrides:$}}compareAndDeleteFolderConfiguration(d){const u=this.p.get(d);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:l,updated:h,removed:k,overrides:D}=a(u,void 0);return{keys:[...l,...h,...k],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(d,u,l){let h=this.r(u,l);return u.overrideIdentifier&&(h=h.override(u.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}r({resource:d},u){let l=this.s();if(u&&d){const h=u.getFolder(d);h&&(l=this.t(h.uri)||l);const k=this.m.get(d);k&&(l=l.merge(k))}return l}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(d){let u=this.b.get(d);if(!u){const l=this.s(),h=this.j.get(d);h?(u=l.merge(h),this.b.set(d,u)):u=l}return u}u(d,u){if(u&&d){const l=u.getFolder(d);if(l)return this.j.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,u)=>{const{contents:l,overrides:h,keys:k}=this.j.get(u);return d.push([u,{contents:l,overrides:h,keys:k}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(u=>d.add(u)),this.userConfiguration.keys.forEach(u=>d.add(u)),this.i.keys.forEach(u=>d.add(u)),this.j.forEach(u=>u.keys.forEach(l=>d.add(l))),[...d.values()]}v(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.i.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.j.forEach(u=>u.getAllOverrideIdentifiers().forEach(l=>d.add(l))),[...d.values()]}w(d){const u=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(l=>u.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(l=>u.add(l)),this.i.getKeysForOverrideIdentifier(d).forEach(l=>u.add(l)),this.j.forEach(l=>l.getKeysForOverrideIdentifier(d).forEach(h=>u.add(h))),[...u.values()]}static parse(d){const u=this.x(d.defaults),l=this.x(d.policy),h=this.x(d.application),k=this.x(d.user),D=this.x(d.workspace),$=d.folders.reduce((b,v)=>(b.set(g.URI.revive(v[0]),this.x(v[1])),b),new R.$zc);return new i(u,l,h,k,new S,D,$,new S,new R.$zc)}static x(d){return new S(d.contents,d.keys,d.overrides)}}e.$Hn=i;function n(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const d=new Set,u=new Map;for(const h of r)h.keys.forEach(k=>d.add(k)),h.overrides.forEach(([k,D])=>{const $=(0,R.$wc)(u,k,new Set);D.forEach(b=>$.add(b))});const l=[];return u.forEach((h,k)=>l.push([k,[...h.values()]])),{keys:[...d.values()],overrides:l}}e.$In=n;class o{constructor(d,u,l,h){this.change=d,this.f=u,this.g=l,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of d.keys)this.affectedKeys.add(k);for(const[,k]of d.overrides)for(const D of k)this.affectedKeys.add(D);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(d,u){const l=this.a+d,h=this.d.indexOf(l);if(h<0)return!1;const k=h+l.length;if(k>=this.d.length)return!1;const D=this.d.charCodeAt(k);if(D!==this.b&&D!==this.c)return!1;if(u){const $=this.previousConfiguration?this.previousConfiguration.getValue(d,u,this.f?.workspace):void 0,b=this.g.getValue(d,u,this.h);return!w.$bn($,b)}return!0}}e.$Jn=o;function a(r,d){const{added:u,removed:l,updated:h}=t(d?.rawConfiguration,r?.rawConfiguration),k=[],D=r?.getAllOverrideIdentifiers()||[],$=d?.getAllOverrideIdentifiers()||[];if(d){const b=$.filter(v=>!D.includes(v));for(const v of b)k.push([v,d.getKeysForOverrideIdentifier(v)])}if(r){const b=D.filter(v=>!$.includes(v));for(const v of b)k.push([v,r.getKeysForOverrideIdentifier(v)])}if(d&&r){for(const b of D)if($.includes(b)){const v=t({contents:r.getOverrideValue(void 0,b)||{},keys:r.getKeysForOverrideIdentifier(b)},{contents:d.getOverrideValue(void 0,b)||{},keys:d.getKeysForOverrideIdentifier(b)});k.push([b,[...v.added,...v.removed,...v.updated]])}}return{added:u,removed:l,updated:h,overrides:k}}function t(r,d){const u=r?d?r.keys.filter(k=>d.keys.indexOf(k)===-1):[...r.keys]:[],l=d?r?d.keys.filter(k=>r.keys.indexOf(k)===-1):[...d.keys]:[],h=[];if(r&&d){for(const k of d.keys)if(r.keys.indexOf(k)!==-1){const D=(0,A.$ui)(d.contents,k),$=(0,A.$ui)(r.contents,k);w.$bn(D,$)||h.push(k)}}return{added:u,removed:l,updated:h}}}),define(ke[257],Se([1,0,22,4,3,83]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4pb=e.$3pb=e.$2pb=e.$1pb=void 0;const R=(g,A,P)=>{const f=new Uint8Array(16);for(let p=0;p<16;p++)f[p]=Math.round(Math.random()*256);const y=(0,I.$we)(I.$ce.wrap(f));return[`GET ws://localhost${g}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$1pb=R,e.$2pb=I.$ce.fromString(`\r
\r
`);async function w(g,A,P,f,y){g.write(I.$ce.fromString((0,e.$1pb)(A,P,f)));const S=new m.$Qc;try{return await new Promise((p,c)=>{let s;S.add(g.onData(i=>{s?s=I.$ce.concat([s,i],s.byteLength+i.byteLength):s=i;const n=s.indexOf(e.$2pb);if(n===-1)return;p(g),g.pauseData();const o=s.slice(n+e.$2pb.byteLength);o.byteLength&&y.onData.fire(o)})),S.add(g.onClose(i=>c(i??new Error("socket closed")))),S.add(g.onEnd(()=>c(new Error("socket ended"))))})}catch(p){throw g.dispose(),p}finally{S.dispose()}}e.$3pb=w;class E extends m.$Rc{constructor(A,P){super(),this.g=A,this.a=this.B(new F.$Rd),this.onData=(...f)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...f)),this.b=this.B(new F.$Od),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event(f=>this.a.fire(f))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,P){L.SocketDiagnostics.traceSocketEvent(this,this.g,A,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$4pb=E}),define(ke[65],Se([1,0,11,5]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=e.RemoteAuthorityResolverErrorCode=e.$Uk=e.$Tk=e.RemoteConnectionType=e.$Sk=void 0,e.$Sk=(0,F.$Sh)("remoteAuthorityResolverService");var m;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(m||(e.RemoteConnectionType=m={}));class L{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$Tk=L;class R{constructor(P,f){this.host=P,this.port=f,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Uk=R;var w;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(w||(e.RemoteAuthorityResolverErrorCode=w={}));class E extends I.$ab{static isNotAvailable(P){return P instanceof E&&P._code===w.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof E&&P._code===w.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof E&&P._code===w.NoResolverFound}static isInvalidAuthority(P){return P instanceof E&&P._code===w.InvalidAuthority}static isHandled(P){return P instanceof E&&P.isHandled}constructor(P,f=w.Unknown,y){super(P),this._message=P,this._code=f,this._detail=y,this.isHandled=f===w.NotAvailable&&y===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Vk=E;function g(A){const P=A.indexOf("+");return P===-1?A:A.substring(0,P)}e.$Wk=g}),define(ke[66],Se([1,0,17]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=void 0;function F(g){return g.scheme===I.Schemas.vscodeRemote?g.authority:void 0}e.$Xk=F;function m(g){if(!g)return;const A=g.indexOf("+");return A<0?g:g.substr(0,A)}e.$Yk=m;function L(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Zk=L;function R(g){const{host:A,port:P}=E(g);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:P}}e.$1k=R;function w(g,A){let{host:P,port:f}=E(g);return typeof f>"u"&&(f=A),{host:P,port:f}}e.$2k=w;function E(g){const A=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const P=g.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const f=g.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:g,port:void 0}}}),define(ke[26],Se([1,0,13,5,66]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.TargetPlatform=e.ExtensionType=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=void 0,e.$3l="extensions.user.cache",e.$4l="extensions.builtin.cache",e.$5l="undefined_publisher",e.$6l=["ui","workspace","web"];function L(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$7l=L,e.$8l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(R||(e.ExtensionType=R={}));var w;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(w||(e.TargetPlatform=w={}));class E{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,s){if(typeof c>"u"||c===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof c=="string"||typeof s=="string"){const i=typeof c=="string"?c:c.value,n=typeof s=="string"?s:s.value;return I.$3e(i,n)}return c._lower===s._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$9l=E;class g{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const s of c)this.add(s)}add(c){this.c.add(E.toKey(c))}delete(c){return this.c.delete(E.toKey(c))}has(c){return this.c.has(E.toKey(c))}}e.$0l=g;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(E.toKey(c))}get(c){return this.c.get(E.toKey(c))}has(c){return this.c.has(E.toKey(c))}set(c,s){this.c.set(E.toKey(c),s)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$$l=A;function P(p){return f(p)}e.$_l=P;function f(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$am=f;function y(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$bm=y;function S(p,c){if(c){const s=`onResolveRemoteAuthority:${(0,m.$Yk)(c)}`;return!!p.activationEvents?.includes(s)}return!1}e.$cm=S,e.$dm=(0,F.$Sh)("IBuiltinExtensionsScannerService")}),define(ke[139],Se([1,0,11,26]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_E=e.$$E=void 0;class m{constructor(){this.a=new Map,this.b=new WeakMap}register(R,w){this.a.set(R,w)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const w=Object.create(null);for(const E of R){const g=this.readActivationEvents(E);g.length>0&&(w[F.$9l.toKey(E.identifier)]=g)}return w}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const w=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let E=0;E<w.length;E++)w[E]==="onUri"&&(w[E]=`onUri:${F.$9l.toKey(R.identifier)}`);if(!R.contributes)return w;for(const E in R.contributes){const g=this.a.get(E);if(!g)continue;const A=R.contributes[E],P=Array.isArray(A)?A:[A];try{g(P,w)}catch(f){(0,I.$Z)(f)}}return w}}e.$$E=m,e.$_E=new m}),define(ke[258],Se([1,0,10,22,21,11,4,3,56,37,32,83,65,66]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.PersistentConnectionEventType=e.$9k=e.$8k=e.$7k=e.ConnectionType=void 0;const S=30*1e3;var p;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function c(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function s(G){const U=new m.$Yd;return setTimeout(()=>U.cancel(),G),U.token}function i(G,U){if(G.isCancellationRequested||U.isCancellationRequested)return m.CancellationToken.Cancelled;const ce=new m.$Yd;return G.onCancellationRequested(()=>ce.cancel()),U.onCancellationRequested(()=>ce.cancel()),ce.token}class n{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new w.$Qc,this.promise=new Promise((ce,be)=>{this.f=ce,this.g=be}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function o(G,U){const ce=new n(U);return ce.registerDisposable(G.onControlMessage(be=>{const H=JSON.parse(be.toString()),Z=X(H);Z?ce.reject(Z):ce.resolve(H)})),ce.promise}function a(G,U,ce,be,H,Z,Y,$e){const ne=new n($e),fe=g.$Kd.create(!1);return G.info(`Creating a socket (${Y})...`),E.mark(`code/willCreateSocket/${Z}`),U.connect(ce,be,H,Y).then(te=>{ne.didTimeout?(E.mark(`code/didCreateSocketError/${Z}`),G.info(`Creating a socket (${Y}) finished after ${fe.elapsed()} ms, but this is too late and has timed out already.`),te?.dispose()):(E.mark(`code/didCreateSocketOK/${Z}`),G.info(`Creating a socket (${Y}) was successful after ${fe.elapsed()} ms.`),ne.resolve(te))},te=>{E.mark(`code/didCreateSocketError/${Z}`),G.info(`Creating a socket (${Y}) returned an error after ${fe.elapsed()} ms.`),G.error(te),ne.reject(te)}),ne.promise}function t(G,U){const ce=new n(U);return G.then(be=>{ce.didTimeout||ce.resolve(be)},be=>{ce.didTimeout||ce.reject(be)}),ce.promise}async function r(G,U,ce,be){const H=se(G,U);G.logService.trace(`${H} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await a(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,y.$Zk)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,c(U),`renderer-${c(U)}-${G.reconnectionToken}`,be)}catch(te){throw G.logService.error(`${H} socketFactory.connect() failed or timed out. Error:`),G.logService.error(te),te}G.logService.trace(`${H} 2/6. socketFactory.connect() was successful.`);let Y,$e;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(Z,null),Y=G.reconnectionProtocol,$e=!1):(Y=new P.$Gh({socket:Z}),$e=!0),G.logService.trace(`${H} 3/6. sending AuthRequest control message.`);const ne=await t(G.signService.createNewMessage((0,A.$fg)()),be),fe={type:"auth",auth:G.connectionToken||"00000000000000000000",data:ne.data};Y.sendControl(F.$ce.fromString(JSON.stringify(fe)));try{const te=await o(Y,i(be,s(1e4)));if(te.type!=="sign"||typeof te.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(G.logService.trace(`${H} 4/6. received SignRequest control message.`),!await t(G.signService.validate(ne,te.signedData),be)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const we=await t(G.signService.sign(te.data),be),Pe={type:"connectionType",commit:G.commit,signedData:we,desiredConnectionType:U};return ce&&(Pe.args=ce),G.logService.trace(`${H} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(F.$ce.fromString(JSON.stringify(Pe))),{protocol:Y,ownsProtocol:$e}}catch(te){throw te&&te.code==="ETIMEDOUT"&&(G.logService.error(`${H} the handshake timed out. Error:`),G.logService.error(te)),te&&te.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${H} received error control message when negotiating connection. Error:`),G.logService.error(te)),$e&&ee(Y),te}}async function d(G,U,ce,be){const H=Date.now(),Z=se(G,U),{protocol:Y,ownsProtocol:$e}=await r(G,U,ce,be),ne=new n(be);return ne.registerDisposable(Y.onControlMessage(fe=>{const te=JSON.parse(fe.toString()),he=X(te);he?(G.logService.error(`${Z} received error control message when negotiating connection. Error:`),G.logService.error(he),$e&&ee(Y),ne.reject(he)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${pe(H)}!`),ne.resolve({protocol:Y,firstMessage:te}))})),ne.promise}async function u(G,U){const{protocol:ce}=await d(G,1,void 0,U);return{protocol:ce}}async function l(G,U,ce){const{protocol:be,firstMessage:H}=await d(G,2,U,ce),Z=H&&H.debugPort;return{protocol:be,debugPort:Z}}async function h(G,U,ce){const be=Date.now(),H=se(G,3),{protocol:Z}=await r(G,3,U,ce);return G.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${pe(be)}!`),Z}async function k(G,U,ce){const{connectTo:be,connectionToken:H}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:be,connectionToken:H,reconnectionToken:U,reconnectionProtocol:ce,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function D(G,U,ce){return b(G,async be=>{const{protocol:H}=await u(be,m.CancellationToken.None);return new V(G,U,ce,be.reconnectionToken,H)})}e.$7k=D;async function $(G,U){return b(G,async ce=>{const{protocol:be,debugPort:H}=await l(ce,U,m.CancellationToken.None);return new de(G,U,ce.reconnectionToken,be,H)})}e.$8k=$;async function b(G,U){for(let be=1;;be++)try{const H=(0,A.$fg)(),Z=await k(G,H,null);return await U(Z)}catch(H){if(be<5)G.logService.error(`[remote-connection][attempt ${be}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(H);else throw G.logService.error(`[remote-connection][attempt ${be}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(H),q.triggerPermanentFailure(0,0,f.$Vk.isHandled(H)),H}}async function v(G,U,ce){const be=await k(G,(0,A.$fg)(),null);return await h(be,{host:U,port:ce},m.CancellationToken.None)}e.$9k=v;function C(G){return(0,I.$Ig)(U=>new Promise((ce,be)=>{const H=setTimeout(ce,G*1e3);U.onCancellationRequested(()=>{clearTimeout(H),ce()})}))}var N;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class z{constructor(U,ce){this.reconnectionToken=U,this.millisSinceLastIncomingData=ce,this.type=0}}e.$0k=z;class M{constructor(U,ce,be,H){this.reconnectionToken=U,this.millisSinceLastIncomingData=ce,this.durationSeconds=be,this.c=H,this.type=1}skipWait(){this.c.cancel()}}e.$$k=M;class T{constructor(U,ce,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ce,this.attempt=be,this.type=2}}e.$_k=T;class j{constructor(U,ce,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ce,this.attempt=be,this.type=4}}e.$al=j;class O{constructor(U,ce,be,H){this.reconnectionToken=U,this.millisSinceLastIncomingData=ce,this.attempt=be,this.handled=H,this.type=3}}e.$bl=O;class q extends w.$Rc{static triggerPermanentFailure(U,ce,be){this._permanentFailure=!0,this.f=U,this.g=ce,this.h=be,this.j.forEach(H=>H.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||q._permanentFailure}constructor(U,ce,be,H,Z){super(),this.t=U,this.u=ce,this.reconnectionToken=be,this.protocol=H,this.w=Z,this.m=this.B(new R.$Od),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new j(this.reconnectionToken,0,0)),this.B(H.onSocketClose(Y=>{const $e=x(this.t,this.reconnectionToken,!0);Y?Y.type===0?(this.u.logService.info(`${$e} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this.u.logService.error(Y.error)):(this.u.logService.info(`${$e} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this.u.logService.error(Y.event)):this.u.logService.info(`${$e} received socket close event.`),this.y()})),this.B(H.onSocketTimeout(Y=>{const $e=x(this.t,this.reconnectionToken,!0);this.u.logService.info(`${$e} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this.y()})),q.j.push(this),this.B((0,w.$Pc)(()=>{const Y=q.j.indexOf(this);Y>=0&&q.j.splice(Y,1)})),this.n&&this.D(q.f,q.g,q.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=x(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ce=[0,5,5,10,10,10,10,10,30];let be=-1;do{be++;const H=be<ce.length?ce[be]:ce[ce.length-1];try{if(H>0){const Y=C(H);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H,Y)),this.u.logService.info(`${U} waiting for ${H} seconds before reconnecting...`);try{await Y}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1)),this.u.logService.info(`${U} resolving connection...`);const Z=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${Z.connectTo}...`),await this.G(Z,s(S)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(be>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(f.$Vk.isTemporarilyNotAvailable(Z)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((0,L.$3)(Z)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if(Z instanceof f.$Vk){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,f.$Vk.isHandled(Z));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}}while(!this.n&&!this.s)}C(U,ce,be){this.w?q.triggerPermanentFailure(U,ce,be):this.D(U,ce,be)}D(U,ce,be){this.m.fire(new O(this.reconnectionToken,U,ce,be)),ee(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$cl=q;class V extends q{constructor(U,ce,be,H,Z){super(1,U,H,Z,!0),this.client=this.B(new P.$Eh(Z,{remoteAuthority:ce,clientId:be},U.ipcLogger))}async G(U,ce){await u(U,ce)}}e.$dl=V;class de extends q{constructor(U,ce,be,H,Z){super(2,U,be,H,!1),this.H=ce,this.debugPort=Z}async G(U,ce){await l(U,this.H,ce)}}e.$el=de;function ee(G){try{G.acceptDisconnect();const U=G.getSocket();G.dispose(),U.dispose()}catch(U){(0,L.$Z)(U)}}function X(G){if(G&&G.type==="error"){const U=new Error(`Connection error: ${G.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function Q(G,U){for(;G.length<U;)G+=" ";return G}function ae(G,U){return`[remote-connection][${Q(c(G),13)}][${U.substr(0,5)}\u2026]`}function x(G,U,ce){return`${ae(G,U)}[${ce?"reconnect":"initial"}]`}function se(G,U){return`${x(U,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function pe(G){return`${Date.now()-G} ms`}}),define(ke[259],Se([1,0,3,5]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=void 0,e.$3k=(0,F.$Sh)("remoteSocketFactoryService");class m{constructor(){this.a={}}register(R,w){return this.a[R]??=[],this.a[R].push(w),(0,I.$Pc)(()=>{const E=this.a[R]?.indexOf(w);typeof E=="number"&&E>=0&&this.a[R]?.splice(E,1)})}b(R){return(this.a[R.type]||[]).find(E=>E.supports(R))}connect(R,w,E,g){const A=this.b(R);if(!A)throw new Error(`No socket factory found for ${R}`);return A.connect(R,w,E,g)}}e.$4k=m}),define(ke[260],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n4b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(m){try{const L=await this.c();if(L){const R=String(I.a++);return this.b.set(R,L),{id:R,data:L.createNewMessage(m)}}}catch{}return{id:"",data:m}}async validate(m,L){if(!m.id)return!0;const R=this.b.get(m.id);if(!R)return!1;this.b.delete(m.id);try{return R.validate(L)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(m){try{return await this.d(m)}catch{}return m}}e.$n4b=I}),define(ke[109],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=e.$5k=void 0,e.$5k="signService",e.$6k=(0,I.$Sh)(e.$5k)}),define(ke[140],Se([1,0,260]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j9b=void 0;class F extends I.$n4b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(R=>new R.signer().sign(L))}h(){return new Promise((L,R)=>me(["vsda"],L,R))}}e.$j9b=F}),define(ke[261],Se([1,0,12,49,32]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=void 0;function L(E){if(I.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function R(E,g,A,P,f,y,S,p,c){const s=Object.create(null);s["common.machineId"]=y,s["common.sqmId"]=S,s.sessionID=(0,m.$fg)()+Date.now(),s.commitHash=P,s.version=f,s["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,I.$h)(I.$u),s["common.nodePlatform"]=F.$cc,s["common.nodeArch"]=A,s["common.product"]=c||"desktop",p&&(s["common.msftInternal"]=p);let i=0;const n=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),I.$l&&(s["common.snap"]="true");const o=L(g);return o&&(s["common.platformDetail"]=o),s}e.$ko=R;function w(E){const g=F.env.USERDNSDOMAIN;if(!g)return!1;const A=g.toLowerCase();return E.some(P=>A===P)}e.$lo=w}),define(ke[262],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=void 0,e.$fl=(0,I.$Sh)("telemetryService"),e.$gl=(0,I.$Sh)("customEndpointTelemetryService"),e.$hl="telemetry.currentSessionDate",e.$il="telemetry.firstSessionDate",e.$jl="telemetry.lastSessionDate",e.$kl="telemetry.machineId",e.$ll="telemetry.sqmId",e.$ml="telemetry",e.$nl="telemetry.telemetryLevel",e.$ol="telemetry.enableCrashReporter",e.$pl="telemetry.enableTelemetry";var F;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var m;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(m||(e.TelemetryConfiguration=m={}))}),define(ke[87],Se([1,0,24,18,4,44,66,261,262]),function(me,e,I,F,m,L,R,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0;class g{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$mo=g;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$no=A,e.$oo=new A;class P{async publicLog(l,h,k){}async publicLogError(l,h,k){}}e.$po=P,e.$qo="telemetry",e.$ro="extensionTelemetryLog",e.$so={log:()=>null,flush:()=>Promise.resolve(null)};function f(u,l){return m.Event.debounce(l.onDidChangeConfiguration,(k,D)=>{const $=k?new Set([...k.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:$}},1e3,!0)(k=>{k.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,L.$pi)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$to=f;function y(u,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!u.enableTelemetry)}e.$uo=y;function S(u,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.$vo=S;function p(u){const l=u.getValue(E.$nl),h=u.getValue(E.$ol);if(u.getValue(E.$pl)===!1||h===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$wo=p;function c(u){const l={},h={},k={};n(u,k);for(let D in k){D=D.length>150?D.substr(D.length-149):D;const $=k[D];typeof $=="number"?h[D]=$:typeof $=="boolean"?h[D]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${$.length}`),l[D]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(l[D]=$)}return{properties:l,measurements:h}}e.$xo=c;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(u){if(!u)return"none";const l=(0,R.$Yk)(u);return s.has(l)?l:"other"}e.$yo=i;function n(u,l,h=0,k){if(u)for(const D of Object.getOwnPropertyNames(u)){const $=u[D],b=k?k+D:D;Array.isArray($)?l[b]=(0,I.$cn)($):$ instanceof Date?l[b]=$.toISOString():(0,F.$Bf)($)?h<2?n($,l,h+1,b+"."):l[b]=(0,I.$cn)($):l[b]=$}}function o(u,l){const h=u.msftInternalDomains||[],k=l.getValue("telemetry.internalTesting");return(0,w.$lo)(h)||k}e.$zo=o;function a(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.$Ao=a;function t(u,l){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let h=u;const k=[];for(const v of l)for(;;){const C=v.exec(u);if(!C)break;k.push([C.index,v.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(h="";;){const v=$.exec(u);if(!v)break;const C=k.some(([N,z])=>v.index<z&&N<$.lastIndex);!D.test(v[0])&&!C&&(h+=u.substring(b,v.index)+"<REDACTED: user-file-path>",b=$.lastIndex)}return b<u.length&&(h+=u.substr(b)),h}function r(u){if(!u)return u;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of l)if(h.regex.test(u))return`<REDACTED: ${h.label}>`;return u}function d(u,l){return(0,I.$_m)(u,h=>{if(h instanceof g||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let k=h.replaceAll("%20"," ");k=t(k,l);for(const D of l)k=k.replace(D,"");return k=r(k),k}})}e.$Bo=d}),define(ke[263],Se([1,0,13,135,26,12,2,11,49,87]),function(me,e,I,F,m,L,R,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0;function A(d,u){return d.uuid&&u.uuid?d.uuid===u.uuid:d.id===u.id?!0:(0,I.$Xe)(d.id,u.id)===0}e.$Co=A;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(u){const l=u.manifest?u.manifest.version:u.version,h=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new f(u.identifier,l,h)}static parse(u){const l=P.exec(u);return l&&l[1]&&l[2]?new f({id:l[1]},l[2],l[4]||void 0):null}constructor(u,l,h="undefined"){this.version=l,this.targetPlatform=h,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof f?A(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.$Do=f;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(d){const u=y.exec(d);return u&&u[1]?[c(u[1]),u[2]]:[c(d),void 0]}e.$Eo=S;function p(d,u){return`${d}.${u}`}e.$Fo=p;function c(d){return d.toLowerCase()}e.$Go=c;function s(d,u){return c(p(d??m.$5l,u))}e.$Ho=s;function i(d,u){const l=[],h=k=>{for(const D of l)if(D.some($=>A(u($),u(k))))return D;return null};for(const k of d){const D=h(k);D?D.push(k):l.push([k])}return l}e.$Io=i;function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.$Jo=n;function o(d){return{id:new g.$mo(d.identifier.id),name:new g.$mo(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Ko=o,e.$Lo=new m.$9l("pprice.better-merge");function a(d,u){const l=[],h=u.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const k=h.shift();if(k&&l.every(D=>!A(D.identifier,{id:k}))){const D=d.filter($=>A($.identifier,{id:k}));D.length===1&&(l.push(D[0]),h.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.$Mo=a;async function t(d,u){if(!L.$k)return!1;let l;try{l=(await d.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await d.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){u.debug("Error while getting the os-release file.",(0,w.$9)(k))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(d,u){const l=await t(d,u),h=(0,F.$9n)(l?"alpine":L.$u,E.$dc);return u.debug("ComputeTargetPlatform:",h),h}e.$No=r}),define(ke[264],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=e.$qr=e.$pr=e.$or=e.$nr=void 0;function I(E){return[...E.entries()]}e.$nr=I;function F(E){return E?[...E.entries()]:[]}e.$or=F;function m(E){return new Map(E)}e.$pr=m;function L(E){return new Map(E??[])}e.$qr=L;function R(E){return Array.from(E.entries()).map(g=>[g[0],I(g[1].map),F(g[1].descriptionMap)])}e.$rr=R;function w(E){return new Map(E.map(g=>[g[0],{map:m(g[1]),descriptionMap:L(g[2])}]))}e.$sr=w}),define(ke[265],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iqb=void 0;class I{constructor(m){this.b=m,this.a=new Map}dispose(){for(const m of this.a.values())m.dispose()}startBuffering(m,L,R=5){const w=L(E=>{const g=typeof E=="string"?E:E.data;let A=this.a.get(m);if(A){A.data.push(g);return}const P=setTimeout(()=>this.flushBuffer(m),R);A={data:[g],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(m),w.dispose()}},this.a.set(m,A)});return w}stopBuffering(m){this.a.get(m)?.dispose()}flushBuffer(m){const L=this.a.get(m);L&&(this.a.delete(m),this.b(m,L.data.join("")))}}e.$iqb=I}),define(ke[266],Se([1,0,10,79,61,4,18,2,207,108,38]),function(me,e,I,F,m,L,R,w,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.IconFontDefinition=e.IconContribution=e.$8v=void 0,e.$8v={IconContribution:"base.contributions.icons"};var P;(function(o){function a(t,r){let d=t.defaults;for(;m.ThemeIcon.isThemeIcon(d);){const u=S.getIcon(d.id);if(!u)return;d=u.defaults}return d}o.getDefinition=a})(P||(e.IconContribution=P={}));var f;(function(o){function a(r){return{weight:r.weight,style:r.style,src:r.src.map(d=>({format:d.format,location:d.location.toString()}))}}o.toJSONObject=a;function t(r){const d=u=>(0,R.$zf)(u)?u:void 0;if(r&&Array.isArray(r.src)&&r.src.every(u=>(0,R.$zf)(u.format)&&(0,R.$zf)(u.location)))return{weight:d(r.weight),style:d(r.style),src:r.src.map(u=>({format:u.format,location:w.URI.parse(u.location)}))}}o.fromJSONObject=t})(f||(e.IconFontDefinition=f={}));class y{constructor(){this.a=new L.$Od,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${m.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,r,d){const u=this.b[a];if(u){if(r&&!u.description){u.description=r,this.d.properties[a].markdownDescription=`${r} $(${a})`;const k=this.e.enum.indexOf(a);k!==-1&&(this.e.enumDescriptions[k]=r),this.a.fire()}return u}const l={id:a,description:r,defaults:t,deprecationMessage:d};this.b[a]=l;const h={$ref:"#/definitions/icons"};return d&&(h.deprecationMessage=d),r&&(h.markdownDescription=`${r}: $(${a})`),this.d.properties[a]=h,this.e.enum.push(a),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const r=this.f[a];return r||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(u,l)=>u.id.localeCompare(l.id),t=u=>{for(;m.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map(u=>this.b[u]);for(const u of d.filter(l=>!!l.description).sort(a))r.push(`|<i class="${t(u)}"></i>|${u.id}|${m.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const u of d.filter(l=>!m.ThemeIcon.isThemeIcon(l.defaults)).sort(a))r.push(`|<i class="${t(u)}"></i>|${u.id}|`);return r.join(`
`)}}const S=new y;A.$jn.add(e.$8v.IconContribution,S);function p(o,a,t,r){return S.registerIcon(o,a,t,r)}e.$9v=p;function c(){return S}e.$0v=c;function s(){const o=(0,F.$Vj)();for(const a in o){const t="\\"+o[a].toString(16);S.registerIcon(a,{fontCharacter:t})}}s(),e.$$v="vscode://schemas/icons";const i=A.$jn.as(g.$kn.JSONContribution);i.registerSchema(e.$$v,S.getIconSchema());const n=new I.$7g(()=>i.notifySchemaChanged(e.$$v),200);S.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$_v=p("widget-close",F.$Xj.close,(0,E.localize)(2,null)),e.$aw=p("goto-previous-location",F.$Xj.arrowUp,(0,E.localize)(3,null)),e.$bw=p("goto-next-location",F.$Xj.arrowDown,(0,E.localize)(4,null)),e.$cw=m.ThemeIcon.modify(F.$Xj.sync,"spin"),e.$dw=m.ThemeIcon.modify(F.$Xj.loading,"spin")}),define(ke[88],Se([1,0,4,44,5,15]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.ProvidedOnAutoForward=e.$cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$bv=e.$av=void 0,e.$av=(0,m.$Sh)("tunnelService"),e.$bv=(0,m.$Sh)("sharedTunnelsService");var R;(function(c){c.Http="http",c.Https="https"})(R||(e.TunnelProtocol=R={}));var w;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(w||(e.TunnelPrivacyId=w={}));function E(c){return!!c.forwardPort}e.$cv=E;var g;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function A(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(s)return{address:s[1],port:+s[2]}}e.$dv=A,e.$ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(c){return e.$ev.indexOf(c)>=0}e.$fv=P,e.$gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(c){return e.$gv.indexOf(c)>=0}e.$hv=f;function y(c,s,i,n){if(i===1)return!1;if(i===2&&f(s)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(o?.length===4&&parseInt(o[1])>=18)return!1}return c<1024}e.$iv=y;class S{constructor(s,i,n){this.remoteAddress=s,this.localAddress=i,this.b=n,this.a=new I.$Od,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$jv=S;let p=class{constructor(s,i){this.j=s,this.k=i,this.a=new I.$Od,this.onTunnelOpened=this.a.event,this.b=new I.$Od,this.onTunnelClosed=this.b.event,this.c=new I.$Od,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const s=this.k.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.h=s.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const s=[],i=Array.from(this.e.values());for(const n of i){const o=Array.from(n.values());for(const a of o){const t=await a.value;t&&typeof t!="string"&&s.push(t)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:i}of s.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,i,n,o,a){this.p(s,i,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:i,localAddress:n,privacy:o,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,i){(f(s)||P(s))&&(s=e.$ev[0]);const n=this.r(s,i);if(n)return++n.refcount,n.value}openTunnel(s,i,n,o,a,t=!1,r,d){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${a}.`);const u=this.f??s;if(!u)return;if(i||(i="localhost"),o||(o=this.l),this.f&&this.i.has(n)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.s(u,i,n,o,a,t,r,d);return l?l.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(i,n),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(i,n);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(h);return(h.tunnelRemoteHost!==i||h.tunnelRemotePort!==n)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&h.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}n(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const i=this.e.get(s.tunnelRemoteHost);if(i){const n=i.get(s.tunnelRemotePort);n&&(n.refcount--,await this.o(s.tunnelRemoteHost,s.tunnelRemotePort,n))}}}}async o(s,i,n){if(n.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${i}.`);const o=n.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(i),o}}async closeTunnel(s,i){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${i} `);const n=this.e.get(s);if(n&&n.has(i)){const o=n.get(i);o.refcount=0,await this.o(s,i,o)}}p(s,i,n){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(i,{refcount:1,value:n})}async q(s,i){const n=this.e.get(s);if(n){const o=n.get(i),a=o?await o.value:void 0;(!a||typeof a=="string")&&n.delete(i),n.size===0&&this.e.delete(s)}}r(s,i){const n=[s];P(s)?(n.push(...e.$ev),n.push(...e.$gv)):f(s)&&n.push(...e.$gv);const o=n.map(a=>this.e.get(a));for(const a of o){const t=a?.get(i);if(t)return t}}canTunnel(s){return!!A(s)}t(s,i,n,o,a,t,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${o}.`);const d=n;this.i.add(d);const u=o===void 0?n:o,l={elevationRequired:a?this.isPortPrivileged(u):!1},h={remoteAddress:{host:i,port:n},localAddressPort:o,privacy:t,public:t?t!==w.Private:void 0,protocol:r},k=s.forwardPort(h,l);return k?(this.p(i,n,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(d)})):this.i.delete(d),k}};e.$kv=p,e.$kv=p=He([Be(0,L.$aj),Be(1,F.$mi)],p)}),define(ke[267],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=void 0,e.$Lk=(0,I.$Sh)("IUriIdentityService")}),define(ke[268],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$lv=void 0,e.$lv=(0,I.$Sh)("editSessionIdentityService");var F;(function(m){m[m.Complete=100]="Complete",m[m.Partial=50]="Partial",m[m.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(ke[269],Se([1,0,17]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=void 0;function F(E){return E.scheme!==I.Schemas.file&&E.scheme!==I.Schemas.vscodeRemote}e.$1J=F;function m(E){if(E.folders.length)return E.folders.every(g=>F(g.uri))?E.folders[0].uri:void 0;if(E.configuration&&F(E.configuration))return E.configuration}e.$2J=m;function L(E){return m(E)?.scheme}e.$3J=L;function R(E){return m(E)?.authority}e.$4J=R;function w(E){return m(E)!==void 0}e.$5J=w}),define(ke[40],Se([1,0,209,16,78,23,2,5,17]),function(me,e,I,F,m,L,R,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.WorkbenchState=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=void 0,e.$2h=(0,w.$Sh)("contextService");function g(u){const l=u;return typeof l?.id=="string"&&R.URI.isUri(l.uri)}e.$3h=g;function A(u){return typeof u?.id=="string"&&!g(u)&&!f(u)}e.$4h=A,e.$5h={id:"ext-dev"},e.$6h={id:"empty-window"};function P(u,l){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,F.$mc)(u)}:l?e.$5h:e.$6h;const h=u;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$7h=P;function f(u){const l=u;return typeof l?.id=="string"&&R.URI.isUri(l.configPath)}e.$8h=f;function y(u){const l=u;if(l?.uri)return{id:l.id,uri:R.URI.revive(l.uri)};const h=u;if(h?.configPath)return{id:h.id,configPath:R.URI.revive(h.configPath)};if(u?.id)return{id:u.id}}e.$9h=y;var S;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function p(u){const l=u;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.$0h=p;function c(u){const l=u;return!!(l&&typeof l=="object"&&R.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.$$h=c;class s{constructor(l,h,k,D,$){this.h=l,this.j=k,this.k=D,this.l=$,this.c=m.$Yh.forUris(this.l,()=>!0),this.folders=h}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=m.$Yh.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$_h=s;class i{constructor(l,h){this.raw=h,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,L.$wg)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ai=i;function n(u){return new i({uri:u,index:0,name:(0,L.$sg)(u)},{uri:u.toString()})}e.$bi=n,e.$ci="code-workspace",e.$di=`.${e.$ci}`,e.$ei=[{name:(0,I.localize)(0,null),extensions:[e.$ci]}],e.$fi="workspace.json";function o(u,l){return L.$ng.isEqualOrParent(u,l.untitledWorkspacesHome)}e.$gi=o;function a(u){let l;return R.URI.isUri(u)?l=u:l=u.configuration,l?.scheme===E.Schemas.tmp}e.$hi=a,e.$ii="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(u){return u.id===e.$ii}e.$ji=t;function r(u,l){return!o(u,l)&&!a(u)}e.$ki=r;function d(u){return(typeof u=="string"?(0,F.$nc)(u):(0,L.$ug)(u))===e.$di}e.$li=d}),define(ke[270],Se([1,0,52,4,3,23,2,208,134,31,5,15,40,28,267,10,32,13,18]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.ProfileResourceType=void 0;var n;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(u){const l=u;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&R.URI.isUri(l.location)&&R.URI.isUri(l.globalStorageHome)&&R.URI.isUri(l.settingsResource)&&R.URI.isUri(l.keybindingsResource)&&R.URI.isUri(l.tasksResource)&&R.URI.isUri(l.snippetsHome)&&R.URI.isUri(l.extensionsResource))}e.$Mk=o,e.$Nk=(0,A.$Sh)("IUserDataProfilesService");function a(u,l){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:R.URI.revive(u.location).with({scheme:l}),globalStorageHome:R.URI.revive(u.globalStorageHome).with({scheme:l}),settingsResource:R.URI.revive(u.settingsResource).with({scheme:l}),keybindingsResource:R.URI.revive(u.keybindingsResource).with({scheme:l}),tasksResource:R.URI.revive(u.tasksResource).with({scheme:l}),snippetsHome:R.URI.revive(u.snippetsHome).with({scheme:l}),extensionsResource:R.URI.revive(u.extensionsResource).with({scheme:l}),cacheHome:R.URI.revive(u.cacheHome).with({scheme:l}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}e.$Ok=a;function t(u,l,h,k,D,$){return{id:u,name:l,location:h,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:$&&D?.useDefaultFlags?.globalState?$.globalStorageHome:(0,L.$wg)(h,"globalStorage"),settingsResource:$&&D?.useDefaultFlags?.settings?$.settingsResource:(0,L.$wg)(h,"settings.json"),keybindingsResource:$&&D?.useDefaultFlags?.keybindings?$.keybindingsResource:(0,L.$wg)(h,"keybindings.json"),tasksResource:$&&D?.useDefaultFlags?.tasks?$.tasksResource:(0,L.$wg)(h,"tasks.json"),snippetsHome:$&&D?.useDefaultFlags?.snippets?$.snippetsHome:(0,L.$wg)(h,"snippets"),extensionsResource:$&&D?.useDefaultFlags?.extensions?$.extensionsResource:(0,L.$wg)(h,"extensions.json"),cacheHome:(0,L.$wg)(k,u),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.$Pk=t;let r=class extends m.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(l,h,k,D){super(),this.t=l,this.u=h,this.w=k,this.y=D,this.f=!0,this.h=this.B(new F.$Od),this.onDidChangeProfiles=this.h.event,this.j=this.B(new F.$Od),this.onWillCreateProfile=this.j.event,this.m=this.B(new F.$Od),this.onWillRemoveProfile=this.m.event,this.n=this.B(new F.$Od),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$zc,emptyWindows:new Map},this.profilesHome=(0,L.$wg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$wg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(l){this.f!==l&&(this.z=void 0,this.f=l)}isEnabled(){return this.f}get C(){if(!this.z){const l=this.D(),h=[l];if(this.f)try{for(const $ of this.O()){if(!$.name||!(0,i.$zf)($.name)||!$.location){this.y.warn("Skipping the invalid stored profile",$.location||$.name);continue}h.push(t((0,L.$tg)($.location),$.name,$.location,this.g,{shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags},l))}}catch($){this.y.error($)}const k=new y.$zc,D=new Map;if(h.length)try{const $=this.Q();if($.workspaces)for(const[b,v]of Object.entries($.workspaces)){const C=R.URI.parse(b),N=h.find(z=>z.id===v);N&&k.set(C,N)}if($.emptyWindows)for(const[b,v]of Object.entries($.emptyWindows)){const C=h.find(N=>N.id===v);C&&D.set(b,C)}}catch($){this.y.error($)}this.z={profiles:h,workspaces:k,emptyWindows:D}}return this.z}D(){const l=t("__default__profile__",(0,w.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...l,extensionsResource:this.S()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const h="Temp",k=new RegExp(`${(0,s.$Ge)(h)}\\s(\\d+)`);let D=0;for(const b of this.profiles){const v=k.exec(b.name),C=v?parseInt(v[1]):0;D=C>D?C:D}const $=`${h} ${D+1}`;return this.createProfile((0,I.$Gi)((0,c.$fg)()).toString(16),$,{transient:!0},l)}async createNamedProfile(l,h,k){return this.createProfile((0,I.$Gi)((0,c.$fg)()).toString(16),l,h,k)}async createProfile(l,h,k,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=await this.F(l,h,k);return D&&await this.setProfileForWorkspace(D,$),$}async F(l,h,k){if(!(0,i.$zf)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(h);return D||(D=(async()=>{try{const $=this.profiles.find(C=>C.name===h||C.id===l);if($)return $;const b=t(l,h,(0,L.$wg)(this.profilesHome,l),this.g,k,this.defaultProfile);await this.u.createFolder(b.location);const v=[];return this.j.fire({profile:b,join(C){v.push(C)}}),await p.Promises.settled(v),this.I([b],[],[]),b}finally{this.r.delete(h)}})(),this.r.set(h,D)),D}async updateProfile(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(D=>D.id===l.id);if(!k)throw new Error(`Profile '${l.name}' does not exist`);return k=t(k.id,h.name??k.name,k.location,this.g,{shortName:h.shortName??k.shortName,icon:h.icon===null?void 0:h.icon??k.icon,transient:h.transient??k.isTransient,useDefaultFlags:h.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(D=>D.id===l.id);if(!h)throw new Error(`Profile '${l.name}' does not exist`);const k=[];this.m.fire({profile:h,join(D){k.push(D)}});try{await Promise.allSettled(k)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(D){(0,g.$sk)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(D=>D.id===h.id);if(!k)throw new Error(`Profile '${h.name}' does not exist`);this.L(l,k)}unsetWorkspace(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(l,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const l=await this.u.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(h=>h.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const l=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(l.map(h=>this.removeProfile(h)))}getProfileForWorkspace(l){const h=this.G(l);return R.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(l){return(0,f.$3h)(l)?l.uri:(0,f.$8h)(l)?l.configPath:l.id}H(l){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,l.location)))}I(l,h,k){const D=[...this.profiles,...l],$=[];this.s.profiles=[];for(let b of D)b.isDefault||h.some(v=>b.id===v.id)||(b=k.find(v=>b.id===v.id)??b,b.isTransient?this.s.profiles.push(b):$.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags}));this.P($),this.z=void 0,this.J(l,h,k)}J(l,h,k){this.h.fire({added:l,removed:h,updated:k,all:this.profiles})}L(l,h,k){k=h?.isTransient?!0:k,k||this.L(l,void 0,!0);const D=this.G(l),$=k?this.s:this.C;R.URI.isUri(D)?($.workspaces.delete(D),h&&$.workspaces.set(D,h)):($.emptyWindows.delete(D),h&&$.emptyWindows.set(D,h)),k||this.M()}M(){const l={};for(const[k,D]of this.C.workspaces.entries())l[k.toString()]=D.id;const h={};for(const[k,D]of this.C.emptyWindows.entries())h[k.toString()]=D.id;this.R({workspaces:l,emptyWindows:h}),this.z=void 0}N(l){const h={},k=this.D();if(l.workspaces)for(const[$,b]of Object.entries(l.workspaces)){const v=R.URI.parse(b);h[$]=this.w.extUri.isEqual(v,k.location)?k.id:this.w.extUri.basename(v)}const D={};if(l.emptyWindows)for(const[$,b]of Object.entries(l.emptyWindows)){const v=R.URI.parse(b);D[$]=this.w.extUri.isEqual(v,k.location)?k.id:this.w.extUri.basename(v)}return{workspaces:h,emptyWindows:D}}O(){return[]}P(l){throw new Error("not implemented")}Q(){return{}}R(l){throw new Error("not implemented")}S(){}};e.$Qk=r,e.$Qk=r=He([Be(0,E.$Zh),Be(1,g.$bk),Be(2,S.$Lk),Be(3,P.$aj)],r);class d extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(l){this.a=l}Q(){return this.X}R(l){this.X=l}}e.$Rk=d}),define(ke[271],Se([1,0,10,4,3,56,18,188,5,270]),function(me,e,I,F,m,L,R,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$9o=e.$8o=e.$7o=void 0,e.$7o="__$__isNewStorageMarker",e.$8o="__$__targetStorageMarker",e.$9o=(0,E.$Sh)("storageService");var A;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var P;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var f;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(f||(e.StorageTarget=f={}));function y(i){const n=i.get(e.$8o);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$0o=y;class S extends m.$Rc{static{this.a=60*1e3}constructor(n={flushInterval:S.a}){super(),this.m=n,this.b=this.B(new F.$Rd),this.c=this.B(new F.$Rd),this.onDidChangeTarget=this.c.event,this.f=this.B(new F.$Od),this.onWillSaveState=this.f.event,this.h=this.B(new I.$7g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new m.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,a){return F.Event.filter(this.b.event,t=>t.scope===n&&(o===void 0||t.key===o),a)}n(){this.j.value=(0,I.$$g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,m.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:a,external:t}=o;if(a===e.$8o){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:a,target:this.J(n)[a],external:t})}w(n){this.f.fire({reason:n})}get(n,o,a){return this.P(o)?.get(n,a)}getBoolean(n,o,a){return this.P(o)?.getBoolean(n,a)}getNumber(n,o,a){return this.P(o)?.getNumber(n,a)}getObject(n,o,a){return this.P(o)?.getObject(n,a)}storeAll(n,o){this.y(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,o)})}store(n,o,a,t,r=!1){if((0,R.$If)(o)){this.remove(n,a,r);return}this.y(()=>{this.z(n,a,t),this.P(a)?.set(n,o,r)})}remove(n,o,a=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,a)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const a=[],t=this.J(n);for(const r of Object.keys(t))t[r]===o&&a.push(r);return a}z(n,o,a,t=!1){const r=this.J(o);typeof a=="number"?r[n]!==a&&(r[n]=a,this.P(o)?.set(e.$8o,JSON.stringify(r),t)):typeof r[n]=="number"&&(delete r[n],this.P(o)?.set(e.$8o,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?y(o):Object.create(null)}isNew(n){return this.getBoolean(e.$7o,n)===!0}async flush(n=A.NONE){this.f.fire({reason:n});const o=this.P(-1),a=this.P(0),t=this.P(1);switch(n){case A.NONE:await I.Promises.settled([o?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await I.Promises.settled([o?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,o=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return s(n,o,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(A.NONE),(0,g.$Mk)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||p(o)&&p(n))}N(n,o,a){this.y(()=>{const t=new Set;for(const[r,d]of n)t.add(r),o.get(r)!==d&&this.u(a,{key:r,external:!0});for(const[r]of o.items)t.has(r)||this.u(a,{key:r,external:!0})})}}e.$$o=S;function p(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$_o=p;class c extends S{constructor(){super(),this.U=this.B(new w.$5o(new w.$6o,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new w.$5o(new w.$6o,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new w.$5o(new w.$6o,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$ap=c;async function s(i,n,o,a,t,r){const d=C=>{try{return JSON.parse(C)}catch{return C}},u=new Map,l=new Map;i.forEach((C,N)=>{u.set(N,C),l.set(N,d(C))});const h=new Map,k=new Map;n.forEach((C,N)=>{h.set(N,C),k.set(N,d(C))});const D=new Map,$=new Map;o.forEach((C,N)=>{D.set(N,C),$.set(N,d(C))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const b=[];if(u.forEach((C,N)=>{b.push({key:N,value:C})}),console.table(b),console.groupEnd(),console.log(l),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];h.forEach((N,z)=>{C.push({key:z,value:N})}),console.table(C),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${r})`);const v=[];D.forEach((C,N)=>{v.push({key:N,value:C})}),console.table(v),console.groupEnd(),console.log($)}e.$bp=s}),define(ke[110],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;class I{static{this.a=!1}constructor(m){this.d=m,this.b=new Map,this.c=1}add(m){const L=this.c++;return this.b.set(L,m),this.e(),L}get(m,L){return this.b.has(m)?this.b.get(m)[L]:void 0}delete(m){this.b.delete(m),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$0cc=I}),define(ke[57],Se([1,0,17,23,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.$_cc=void 0;class L{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new F.$lg(w=>{const E=this.b.get(w.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(w,E){E===null?this.b.delete(w.scheme):this.b.set(w.scheme,E)}isFreeScheme(w){return!this.b.has(w)&&!this.a.has(w)}getCapabilities(w){return this.b.get(w)}}e.$_cc=L,e.$adc=(0,m.$Sh)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=void 0,e.$MM=(0,I.$Sh)("IExtHostInitDataService")}),define(ke[272],Se([1,0,215,15,252,27]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=void 0;let R=class extends m.$TN{constructor(E,g,A){const P=A.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",f=A.remote.isRemote?(0,I.localize)(0,null):E?(0,I.localize)(1,null):(0,I.localize)(2,null);super(g.createLogger(P,{name:f}))}};e.$ifc=R,e.$ifc=R=He([Be(1,F.$bj),Be(2,L.$MM)],R)}),define(ke[273],Se([1,0,10]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=e.$Cdc=void 0;class F{constructor(R,w,E){this.h=new Map,this.a=R,this.b=w,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new I.$7g(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of g.values())A.complete()}catch(A){for(const P of g.values())P.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,w){let E=this.f[R];return typeof E>"u"&&(E=w),E}update(R,w){this.f[R]=w;const E=this.h.get(R);if(E!==void 0)return E.p;const g=new I.$fh;return this.h.set(R,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$Cdc=F;class m extends F{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,w){super(R.identifier.value,!0,w),this.j=R}}e.$Ddc=m}),define(ke[274],Se([1,0,4,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=void 0;class m{constructor(R){this.c=R,this.a=new I.$Od,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$Od,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,w,E,g){const P=this.c.getNotebookDocument(F.URI.revive(R)).acceptModelChanged(w.value,E,g);this.b.fire(P)}$acceptDirtyStateChanged(R,w){this.c.getNotebookDocument(F.URI.revive(R)).acceptDirty(w)}$acceptModelSaved(R){const w=this.c.getNotebookDocument(F.URI.revive(R));this.a.fire(w.apiNotebook)}}e.$2ec=m}),define(ke[20],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=void 0,e.$wM=(0,I.$Sh)("IExtHostRpcService");class F{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$xM=F}),define(ke[275],Se([1,0,26,4]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class m{#e;constructor(R,w){this.b=new F.$Od,this.onDidChange=this.b.event,this.a=I.$9l.toKey(R.identifier),this.#e=w,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(R){return this.#e.get(this.a,R)}store(R,w){return this.#e.store(this.a,R,w)}delete(R){return this.#e.delete(this.a,R)}}e.$Odc=m}),define(ke[67],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=e.$kdc=void 0,e.$kdc=(0,I.$Sh)("IURITransformerService");class F{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$ldc=F}),define(ke[276],Se([1,0,22]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdb=e.$bdb=void 0;class F{constructor(){this.buffers=[]}add(E){let g=this.buffers.indexOf(E);return g<0&&(g=this.buffers.length,this.buffers.push(E)),g}}function m(w,E){if(E.serializeBuffersForPostMessage){const g=new F,P=JSON.stringify(w,(y,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(S)};if(ArrayBuffer.isView(S)){const p=L(S);if(p)return{$$vscode_array_buffer_reference$$:!0,index:g.add(S.buffer),view:{type:p,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),f=g.buffers.map(y=>{const S=new Uint8Array(y);return I.$ce.wrap(S)});return{message:P,buffers:f}}else return{message:JSON.stringify(w),buffers:[]}}e.$bdb=m;function L(w){switch(w.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(w,E){const g=E.map(f=>{const y=new ArrayBuffer(f.byteLength);return new Uint8Array(y).set(f.buffer),y}),A=E.length?(f,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const S=y,{index:p}=S,c=g[p];if(S.view)switch(S.view.type){case 1:return new Int8Array(c,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(c,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(c,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(c,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(c,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(c,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(c,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(c,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(c,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(c,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(c,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return y}:void 0;return{message:JSON.parse(w,A),arrayBuffers:g}}e.$cdb=R}),define(ke[277],Se([1,0,278,390,391,62,2,15,392]),function(me,e,I,F,m,L,R,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=void 0;const g=!1;function A(n,o,a,t,r,d){const u=d.environment.useHostProxy,l=typeof u=="boolean"?u:!d.remote.isRemote,h={resolveProxy:$=>n.resolveProxy($),lookupProxyAuthorization:c.bind(void 0,t,r,o,{},d.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>f(o),getSystemCertificatesV2:()=>y(o),log:($,b,...v)=>{switch($){case E.LogLevel.Trace:t.trace(b,...v);break;case E.LogLevel.Debug:t.debug(b,...v);break;case E.LogLevel.Info:t.info(b,...v);break;case E.LogLevel.Warning:t.warn(b,...v);break;case E.LogLevel.Error:t.error(b,...v);break;case E.LogLevel.Critical:t.error(b,...v);break;case E.LogLevel.Off:break;default:C($,b,v);break}function C(N,z,...M){t.error("Unknown log level",N),t.error(z,...M)}},getLogLevel:()=>{const $=t.getLevel();switch($){case w.LogLevel.Trace:return E.LogLevel.Trace;case w.LogLevel.Debug:return E.LogLevel.Debug;case w.LogLevel.Info:return E.LogLevel.Info;case w.LogLevel.Warning:return E.LogLevel.Warning;case w.LogLevel.Error:return E.LogLevel.Error;case w.LogLevel.Off:return E.LogLevel.Off;default:return b($)}function b(v){return t.error("Unknown log level",v),E.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:l,addCertificates:[],env:process.env},k=(0,E.createProxyResolver)(h),D=P(h,k);return p(a,D)}e.$Qfc=A;function P(n,o){return{http:Object.assign(I,(0,E.createHttpPatch)(n,I,o)),https:Object.assign(F,(0,E.createHttpPatch)(n,F,o)),net:Object.assign(L,(0,E.createNetPatch)(n,L)),tls:Object.assign(m,(0,E.createTlsPatch)(n,m))}}function f(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",g)&&!!o.get("systemCertificates")}function y(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",g)&&!!o.get("systemCertificates")}const S=new Map;function p(n,o){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,r=t._load;t._load=function(u,l,h){if(u==="net")return o.net;if(u==="tls")return o.tls;if(u!=="http"&&u!=="https")return r.apply(this,arguments);const k=a.findSubstr(R.URI.file(l.filename));let D=S.get(k);if(D||S.set(k,D={}),!D[u]){const $=o[u];D[u]={...$}}return D[u]}})}async function c(n,o,a,t,r,d,u,l){const h=t[d];u&&(t[d]=u),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${u}`,`proxyAuthenticateCache:${h}`);const k=u||h,D=Array.isArray(k)?k:typeof k=="string"?[k]:[];if(i(o,D,r),D.some($=>/^(Negotiate|Kerberos)( |$)/i.test($))&&!l.kerberosRequested)try{l.kerberosRequested=!0;const $=await new Promise((z,M)=>{me(["kerberos"],z,M)}),b=new URL(d),v=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${b.hostname}`:`HTTP@${b.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${v}`),"Negotiate "+await(await $.initializeClient(v)).step("")}catch($){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",$)}}let s=!1;function i(n,o,a){s||!o.length||(s=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(ke[279],Se([1,0,131]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;function F(L){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:L,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function m(L){return new I.$Om(F(L))}e.$Dr=m}),define(ke[141],Se([1,0,226,18,2,3,5,38,31,17,43,180,39]),function(me,e,I,F,m,L,R,w,E,g,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wE=e.$vE=e.$uE=e.EditorsOrder=e.$tE=e.CloseDirection=e.$sE=e.$rE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$qE=e.$pE=e.$oE=e.$nE=e.$mE=e.$lE=e.$kE=e.$jE=e.EditorInputCapabilities=e.$iE=e.SaveReason=e.Verbosity=e.$hE=e.$gE=e.$fE=e.$eE=e.$dE=e.$cE=e.$bE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$aE=e.$_D=e.$$D=e.$0D=e.$9D=void 0,e.$9D={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$0D={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$$D="workbench.editor.sidebysideEditor",e.$_D="workbench.editors.textDiffEditor",e.$aE="workbench.editors.binaryResourceDiffEditor";var y;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var S;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function p(se){const pe=se;return!!pe&&typeof pe.getSelection=="function"&&!!pe.onDidChangeSelection}e.$bE=p;function c(se,pe,G){for(const U of G.visibleEditorPanes)if(U.group.id===pe&&se.matches(U.input))return U.getViewState()}e.$cE=c;function s(se){if(h(se))return!1;const pe=se;return m.URI.isUri(pe?.resource)}e.$dE=s;function i(se){if(h(se))return!1;const pe=se;return pe?.original!==void 0&&pe.modified!==void 0}e.$eE=i;function n(se){if(h(se)||i(se))return!1;const pe=se;return pe?.primary!==void 0&&pe.secondary!==void 0}e.$fE=n;function o(se){if(h(se))return!1;const pe=se;return pe?pe.resource===void 0||pe.resource.scheme===g.Schemas.untitled||pe.forceUntitled===!0:!1}e.$gE=o;function a(se){if(h(se))return!1;const pe=se;return m.URI.isUri(pe?.base?.resource)&&m.URI.isUri(pe?.input1?.resource)&&m.URI.isUri(pe?.input2?.resource)&&m.URI.isUri(pe?.result?.resource)}e.$hE=a;var t;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var r;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class d{constructor(){this.a=new Map}registerSource(pe,G){let U=this.a.get(pe);return U||(U={source:pe,label:G},this.a.set(pe,U)),U.source}getSourceLabel(pe){return this.a.get(pe)?.label??pe}}e.$iE=new d;var u;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad",se[se.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(u||(e.EditorInputCapabilities=u={}));class l extends L.$Rc{}e.$jE=l;function h(se){return se instanceof l}e.$kE=h;function k(se){const pe=se;return m.URI.isUri(pe?.preferredResource)}function D(se){const pe=se;return h(pe?.primary)&&h(pe?.secondary)}e.$lE=D;function $(se){const pe=se;return h(pe?.modified)&&h(pe?.original)}e.$mE=$;function b(se,pe,G,U,ce){return x(U,[(0,P.$Ci)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const be={...G,limits:{size:Number.MAX_VALUE}};se.openEditor(pe,be)}}),(0,P.$Ci)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>ce.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:f.default.Warning})}e.$nE=b;function v(se){return h(se?.editor)}e.$oE=v;function C(se){const pe=se;return v(se)&&pe?.group!==void 0}e.$pE=C;function N(se){const pe=se;return typeof pe?.groupId=="number"&&h(pe.editor)}e.$qE=N;var z;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var M;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LABEL=2]="GROUP_LABEL",se[se.GROUP_LOCKED=3]="GROUP_LOCKED",se[se.EDITOR_OPEN=4]="EDITOR_OPEN",se[se.EDITOR_CLOSE=5]="EDITOR_CLOSE",se[se.EDITOR_MOVE=6]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=8]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=10]="EDITOR_PIN",se[se.EDITOR_STICKY=11]="EDITOR_STICKY",se[se.EDITOR_DIRTY=12]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var T;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class j{getOriginalUri(pe,G){if(!pe)return;if(a(pe))return e.$sE.getOriginalUri(pe.result,G);if(G?.supportSideBySide){const{primary:ce,secondary:be}=this.a(pe);if(ce&&be){if(G?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(ce,{filterByScheme:G.filterByScheme}),secondary:this.getOriginalUri(be,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===T.ANY)return this.getOriginalUri(ce,{filterByScheme:G.filterByScheme})??this.getOriginalUri(be,{filterByScheme:G.filterByScheme});pe=G.supportSideBySide===T.PRIMARY?ce:be}}if(i(pe)||n(pe)||a(pe))return;const U=k(pe)?pe.preferredResource:pe.resource;return!U||!G||!G.filterByScheme?U:this.b(U,G.filterByScheme)}a(pe){return D(pe)||n(pe)?{primary:pe.primary,secondary:pe.secondary}:$(pe)||i(pe)?{primary:pe.modified,secondary:pe.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(pe,G){if(!pe)return;if(a(pe))return e.$sE.getCanonicalUri(pe.result,G);if(G?.supportSideBySide){const{primary:ce,secondary:be}=this.a(pe);if(ce&&be){if(G?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(ce,{filterByScheme:G.filterByScheme}),secondary:this.getCanonicalUri(be,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===T.ANY)return this.getCanonicalUri(ce,{filterByScheme:G.filterByScheme})??this.getCanonicalUri(be,{filterByScheme:G.filterByScheme});pe=G.supportSideBySide===T.PRIMARY?ce:be}}if(i(pe)||n(pe)||a(pe))return;const U=pe.resource;return!U||!G||!G.filterByScheme?U:this.b(U,G.filterByScheme)}b(pe,G){if(Array.isArray(G)){if(G.some(U=>pe.scheme===U))return pe}else if(G===pe.scheme)return pe}}var O;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(O||(e.EditorCloseMethod=O={}));function q(se,pe,G,U){if(!se.isSticky(pe))return!1;switch(U.preventPinnedEditorClose){case"keyboardAndMouse":return G===O.MOUSE||G===O.KEYBOARD;case"mouse":return G===O.MOUSE;case"keyboard":return G===O.KEYBOARD}return!1}e.$rE=q,e.$sE=new j;var V;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(V||(e.CloseDirection=V={}));class de{constructor(){this.c=new Map,this.d=new Map}start(pe){const G=this.a=pe.get(R.$Rh);for(const[U,ce]of this.c)this.e(U,ce,G);this.c.clear()}e(pe,G,U){const ce=U.createInstance(G);this.d.set(pe,ce)}registerFileEditorFactory(pe){if(this.b)throw new Error("Can only register one file editor factory.");this.b=pe}getFileEditorFactory(){return(0,F.$Kf)(this.b)}registerEditorSerializer(pe,G){if(this.c.has(pe)||this.d.has(pe))throw new Error(`A editor serializer with type ID '${pe}' was already registered.`);return this.a?this.e(pe,G,this.a):this.c.set(pe,G),(0,L.$Pc)(()=>{this.c.delete(pe),this.d.delete(pe)})}getEditorSerializer(pe){return this.d.get(typeof pe=="string"?pe:pe.typeId)}}w.$jn.add(e.$9D.EditorFactory,new de);async function ee(se,pe,G){return!se||!se.length?[]:await Promise.all(se.map(async U=>{const ce=m.URI.revive(U.fileUri);if(!ce){G.info("Cannot resolve the path because it is not valid.",U);return}if(!await pe.canHandleResource(ce)){G.info("Cannot resolve the path because it cannot be handled",U);return}let H=U.exists,Z=U.type;if(typeof H!="boolean"||typeof Z!="number")try{Z=(await pe.stat(ce)).isDirectory?E.FileType.Directory:E.FileType.Unknown,H=!0}catch($e){G.error($e),H=!1}if(!H&&U.openOnlyIfExists){G.info("Cannot resolve the path because it does not exist",U);return}if(Z===E.FileType.Directory){G.info("Cannot resolve the path because it is a directory",U);return}const Y={...U.options,pinned:!0};return H?{resource:ce,options:Y}:{resource:ce,options:Y,forceUntitled:!0}}))}e.$tE=ee;var X;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(X||(e.EditorsOrder=X={}));function Q(se){const pe=se;if(!pe)return!1;const G=pe;if(G.modified)return Q(G.modified);const U=pe;return!!(U.contributionsState&&U.viewState&&Array.isArray(U.cursorState))}e.$uE=Q;function ae(se){return(0,A.$Ei)(se)}e.$vE=ae;function x(se,pe,G){const U=(0,A.$Fi)(se,pe);return U.forceMessage=G?.forceMessage,U.forceSeverity=G?.forceSeverity,U.allowDialog=G?.allowDialog,U}e.$wE=x}),define(ke[280],Se([1,0,4,227,5,3,28,38,19,24,79,266]),function(me,e,I,F,m,L,R,w,E,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FE=e.$EE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$DE=e.$CE=e.ViewContentGroups=e.$BE=e.$AE=e.ViewContainerLocation=e.Extensions=e.$zE=e.$yE=e.$xE=void 0,e.$xE="views",e.$yE=(0,F.localize)(0,null),e.$zE=(0,P.$9v)("default-view-icon",A.$Xj.window,(0,F.localize)(1,null));var f;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(f||(e.Extensions=f={}));var y;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$AE=[0,1,2];function S(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$BE=S;class p extends L.$Rc{constructor(){super(...arguments),this.c=this.B(new I.$Od),this.onDidRegister=this.c.event,this.f=this.B(new I.$Od),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Qb)([...this.g.values()])}registerViewContainer(d,u,l){const h=this.get(d.id);if(h)return h;const k=d;return k.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,R.$wc)(this.g,u,[]).push(k),l?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:u}),k}deregisterViewContainer(d){for(const u of this.g.keys()){const l=this.g.get(u),h=l?.indexOf(d);if(h!==-1){l?.splice(h,1),l.length===0&&this.g.delete(u),this.f.fire({viewContainer:d,viewContainerLocation:u});return}}}get(d){return this.all.filter(u=>u.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(u=>this.getViewContainers(u).filter(l=>l?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(u=>this.getViewContainerLocation(u)===d)}}w.$jn.add(f.ViewContainersRegistry,new p);var c;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(c||(e.ViewContentGroups=c={}));function s(r,d){const u=r.group??c.More,l=d.group??c.More;return u!==l?u.localeCompare(l):(r.order??5)-(d.order??5)}class i extends L.$Rc{constructor(){super(...arguments),this.c=this.B(new I.$Od),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$Od),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$Od),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$Od),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Fc}registerViews(d,u){this.registerViews2([{views:d,viewContainer:u}])}registerViews2(d){d.forEach(({views:u,viewContainer:l})=>this.r(u,l)),this.c.fire(d)}deregisterViews(d,u){const l=this.s(d,u);l.length&&this.f.fire({views:l,viewContainer:u})}moveViews(d,u){for(const l of this.m.keys())if(l!==u){const h=this.s(d,l);h.length&&(this.r(h,u),this.g.fire({views:h,from:l,to:u}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const u of this.j){const l=(this.m.get(u)||[]).filter(h=>h.id===d)[0];if(l)return l}return null}getViewContainer(d){for(const u of this.j)if((this.m.get(u)||[]).filter(h=>h.id===d)[0])return u;return null}registerViewWelcomeContent(d,u){return this.n.add(d,u),this.h.fire(d),(0,L.$Pc)(()=>{this.n.delete(d,u),this.h.fire(d)})}registerViewWelcomeContent2(d,u){const l=new Map;for(const[h,k]of u)this.n.add(d,k),l.set(h,(0,L.$Pc)(()=>{this.n.delete(d,k),this.h.fire(d)}));return this.h.fire(d),l}getViewWelcomeContent(d){const u=[];return this.n.forEach(d,l=>u.push(l)),u.sort(s)}r(d,u){let l=this.m.get(u);l||(l=[],this.m.set(u,l),this.j.push(u));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,F.localize)(2,null,h.id));l.push(h)}}s(d,u){const l=this.m.get(u);if(!l)return[];const h=[],k=[];for(const D of l)d.includes(D)?h.push(D):k.push(D);return h.length&&(k.length?this.m.set(u,k):(this.m.delete(u),this.j.splice(this.j.indexOf(u),1))),h}}w.$jn.add(f.ViewsRegistry,new i),e.$CE=(0,m.$Sh)("viewsService"),e.$DE=(0,m.$Sh)("viewDescriptorService");var n;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var o;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class a{constructor(d,u){this.c=!1,this.d=!1,(0,g.$an)(this,d),this.d=!!u,this.resolve=async l=>{if(u&&!this.c){const h=await u(l);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$EE=a;class t extends Error{constructor(d){super((0,F.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$FE=t}),define(ke[281],Se([1,0,2,29,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8E=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$7E=e.$6E=void 0;function L(g){return!!g&&typeof g=="object"&&"uri"in g&&g.uri instanceof I.URI&&"version"in g&&typeof g.version=="number"&&"ranges"in g&&Array.isArray(g.ranges)&&g.ranges.every(F.$ws.isIRange)}e.$6E=L;function R(g){return!!g&&typeof g=="object"&&"documents"in g&&Array.isArray(g.documents)&&g.documents.every(L)}e.$7E=R;var w;(function(g){g[g.Down=0]="Down",g[g.Up=1]="Up"})(w||(e.InteractiveSessionVoteDirection=w={}));var E;(function(g){g[g.Action=1]="Action",g[g.Toolbar=2]="Toolbar"})(E||(e.InteractiveSessionCopyKind=E={})),e.$8E=(0,m.$Sh)("IChatService")}),define(ke[142],Se([1,0,4,10,228]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new I.$Od,this.n=new I.$Od,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(w){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=w}onEvent(w){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=w}onRequest(w){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=w}sendResponse(w){w.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${w.command}`)):this.s("response",w)}sendRequest(w,E,g,A){const P={command:w};if(E&&Object.keys(E).length>0&&(P.arguments=E),this.s("request",P),typeof A=="number"){const f=setTimeout(()=>{clearTimeout(f);const y=this.f.get(P.seq);if(y){this.f.delete(P.seq);const S={type:"response",seq:0,request_seq:P.seq,success:!1,command:w,message:(0,m.localize)(0,null,A,w)};y(S)}},A)}return g&&this.f.set(P.seq,g),P.seq}acceptMessage(w){this.j?this.j(w):(this.k.push(w),this.k.length===1&&this.q())}o(w,E){return w.type!=="event"||E.type!=="event"}async q(){let w;for(;this.k.length;){if((!w||this.o(this.k[0],w))&&await(0,F.$Vg)(0),w=this.k.shift(),!w)return;switch(w.type){case"event":this.i?.(w);break;case"request":this.g?.(w);break;case"response":{const E=w,g=this.f.get(E.request_seq);g&&(this.f.delete(E.request_seq),g(E));break}}}}s(w,E){E.type=w,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const w=new Map;this.f.forEach((E,g)=>w.set(g,E)),await(0,F.$Vg)(500),w.forEach((E,g)=>{E({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Hdb=L}),define(ke[282],Se([1,0,229,45,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$iH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$hH=e.MemoryRangeType=e.$gH=e.State=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=void 0,e.$dG="workbench.view.debug",e.$eG="workbench.debug.variablesView",e.$fG="workbench.debug.watchExpressionsView",e.$gG="workbench.debug.callStackView",e.$hG="workbench.debug.loadedScriptsView",e.$iG="workbench.debug.breakPointsView",e.$jG="workbench.debug.disassemblyView",e.$kG="workbench.panel.repl",e.$lG="workbench.panel.repl.view",e.$mG=new F.$0i("debugType",void 0,{type:"string",description:I.localize(0,null)}),e.$nG=new F.$0i("debugConfigurationType",void 0,{type:"string",description:I.localize(1,null)}),e.$oG=new F.$0i("debugState","inactive",{type:"string",description:I.localize(2,null)}),e.$pG="debugUx",e.$qG=new F.$0i(e.$pG,"default",{type:"string",description:I.localize(3,null)}),e.$rG=new F.$0i("hasDebugged",!1,{type:"boolean",description:I.localize(4,null)}),e.$sG=new F.$0i("inDebugMode",!1,{type:"boolean",description:I.localize(5,null)}),e.$tG=new F.$0i("inDebugRepl",!1,{type:"boolean",description:I.localize(6,null)}),e.$uG=new F.$0i("breakpointWidgetVisible",!1,{type:"boolean",description:I.localize(7,null)}),e.$vG=new F.$0i("inBreakpointWidget",!1,{type:"boolean",description:I.localize(8,null)}),e.$wG=new F.$0i("breakpointsFocused",!0,{type:"boolean",description:I.localize(9,null)}),e.$xG=new F.$0i("watchExpressionsFocused",!0,{type:"boolean",description:I.localize(10,null)}),e.$yG=new F.$0i("watchExpressionsExist",!1,{type:"boolean",description:I.localize(11,null)}),e.$zG=new F.$0i("variablesFocused",!0,{type:"boolean",description:I.localize(12,null)}),e.$AG=new F.$0i("expressionSelected",!1,{type:"boolean",description:I.localize(13,null)}),e.$BG=new F.$0i("breakpointInputFocused",!1,{type:"boolean",description:I.localize(14,null)}),e.$CG=new F.$0i("callStackItemType",void 0,{type:"string",description:I.localize(15,null)}),e.$DG=new F.$0i("callStackSessionIsAttach",!1,{type:"boolean",description:I.localize(16,null)}),e.$EG=new F.$0i("callStackItemStopped",!1,{type:"boolean",description:I.localize(17,null)}),e.$FG=new F.$0i("callStackSessionHasOneThread",!1,{type:"boolean",description:I.localize(18,null)}),e.$GG=new F.$0i("watchItemType",void 0,{type:"string",description:I.localize(19,null)}),e.$HG=new F.$0i("canViewMemory",void 0,{type:"boolean",description:I.localize(20,null)}),e.$IG=new F.$0i("breakpointItemType",void 0,{type:"string",description:I.localize(21,null)}),e.$JG=new F.$0i("breakpointSupportsCondition",!1,{type:"boolean",description:I.localize(22,null)}),e.$KG=new F.$0i("loadedScriptsSupported",!1,{type:"boolean",description:I.localize(23,null)}),e.$LG=new F.$0i("loadedScriptsItemType",void 0,{type:"string",description:I.localize(24,null)}),e.$MG=new F.$0i("focusedSessionIsAttach",!1,{type:"boolean",description:I.localize(25,null)}),e.$NG=new F.$0i("focusedSessionIsNoDebug",!1,{type:"boolean",description:I.localize(26,null)}),e.$OG=new F.$0i("stepBackSupported",!1,{type:"boolean",description:I.localize(27,null)}),e.$PG=new F.$0i("restartFrameSupported",!1,{type:"boolean",description:I.localize(28,null)}),e.$QG=new F.$0i("stackFrameSupportsRestart",!1,{type:"boolean",description:I.localize(29,null)}),e.$RG=new F.$0i("jumpToCursorSupported",!1,{type:"boolean",description:I.localize(30,null)}),e.$SG=new F.$0i("stepIntoTargetsSupported",!1,{type:"boolean",description:I.localize(31,null)}),e.$TG=new F.$0i("breakpointsExist",!1,{type:"boolean",description:I.localize(32,null)}),e.$UG=new F.$0i("debuggersAvailable",!1,{type:"boolean",description:I.localize(33,null)}),e.$VG=new F.$0i("debugExtensionAvailable",!0,{type:"boolean",description:I.localize(34,null)}),e.$WG=new F.$0i("debugProtocolVariableMenuContext",void 0,{type:"string",description:I.localize(35,null)}),e.$XG=new F.$0i("debugSetVariableSupported",!1,{type:"boolean",description:I.localize(36,null)}),e.$YG=new F.$0i("debugSetExpressionSupported",!1,{type:"boolean",description:I.localize(37,null)}),e.$ZG=new F.$0i("breakWhenValueChangesSupported",!1,{type:"boolean",description:I.localize(38,null)}),e.$1G=new F.$0i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:I.localize(39,null)}),e.$2G=new F.$0i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:I.localize(40,null)}),e.$3G=new F.$0i("terminateDebuggeeSupported",!1,{type:"boolean",description:I.localize(41,null)}),e.$4G=new F.$0i("suspendDebuggeeSupported",!1,{type:"boolean",description:I.localize(42,null)}),e.$5G=new F.$0i("variableEvaluateNamePresent",!1,{type:"boolean",description:I.localize(43,null)}),e.$6G=new F.$0i("variableIsReadonly",!1,{type:"boolean",description:I.localize(44,null)}),e.$7G=new F.$0i("exceptionWidgetVisible",!1,{type:"boolean",description:I.localize(45,null)}),e.$8G=new F.$0i("multiSessionRepl",!1,{type:"boolean",description:I.localize(46,null)}),e.$9G=new F.$0i("multiSessionDebug",!1,{type:"boolean",description:I.localize(47,null)}),e.$0G=new F.$0i("disassembleRequestSupported",!1,{type:"boolean",description:I.localize(48,null)}),e.$$G=new F.$0i("disassemblyViewFocus",!1,{type:"boolean",description:I.localize(49,null)}),e.$_G=new F.$0i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:I.localize(50,null)}),e.$aH=new F.$0i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:I.localize(51,null)});const L=f=>I.localize(52,null,f);e.$bH=L,e.$cH="editor.contrib.debug",e.$dH="editor.contrib.breakpoint",e.$eH="debug",e.$fH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:I.localize(53,null)};var R;(function(f){f[f.Inactive=0]="Inactive",f[f.Initializing=1]="Initializing",f[f.Stopped=2]="Stopped",f[f.Running=3]="Running"})(R||(e.State=R={}));function w(f){switch(f){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$gH=w;var E;(function(f){f[f.Valid=0]="Valid",f[f.Unreadable=1]="Unreadable",f[f.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$hH="vscode-debug-memory";var g;(function(f){f[f.Initial=1]="Initial",f[f.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var A;(function(f){f.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$iH=(0,m.$Sh)("debugService");var P;(function(f){f[f.CONDITION=0]="CONDITION",f[f.HIT_COUNT=1]="HIT_COUNT",f[f.LOG_MESSAGE=2]="LOG_MESSAGE"})(P||(e.BreakpointWidgetContext=P={}))}),define(ke[283],Se([1,0,13,2,16,24,17,29,21,19]),function(me,e,I,F,m,L,R,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.$IF=e.$HF=e.$GF=e.$FF=e.$EF=void 0;const A=/{([^}]+)}/g;function P(D,$,b){return D.replace(A,function(v,C){return $&&C.length>0&&C[0]!=="_"?v:b&&b.hasOwnProperty(C)?b[C]:v})}e.$EF=P;function f(D){const $={};for(const b of Object.keys(D))b.startsWith("!")||($[b]=D[b]);return $}e.$FF=f;function y(D){return D.configuration.request==="attach"&&!S(D)&&(!D.parentSession||y(D.parentSession))}e.$GF=y;function S(D){let $=D.configuration.type;if($)return $==="vslsShare"&&($=D.configuration.adapterProxy.configuration.type),(0,I.$3e)($,"extensionhost")||(0,I.$3e)($,"pwa-extensionhost")?D:D.parentSession?S(D.parentSession):void 0}e.$HF=S;function p(D){return D.type&&(D.label||D.program||D.runtime)}e.$IF=p;function c(D,$,b){let v,C=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=N.exec(D);){const M=z.index+1,T=M+z[0].length;if(M<=$&&T>=b){v=z[0],C=M;break}}if(v){const M=/\w+/g;let T=null;for(;(T=M.exec(v))&&!(T.index+1+C+T[0].length>=b););T&&(v=v.substring(0,M.lastIndex))}return v?{start:C,end:C+v.length-1}:{start:0,end:0}}e.$JF=c;async function s(D,$,b,v){if(D.evaluatableExpressionProvider.has($)){const C=D.evaluatableExpressionProvider.ordered($),N=(0,g.$Gb)(await Promise.all(C.map(async z=>{try{return await z.provideEvaluatableExpression($,b,v??E.CancellationToken.None)}catch{return}})));if(N.length>0){let z=N[0].expression;const M=N[0].range;return z||(z=$.getLineContent(b.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:z}}}else{const C=$.getLineContent(b.lineNumber),{start:N,end:z}=c(C,b.column,b.column),M=C.substring(N-1,z);return{matchingExpression:M,range:new w.$ws(b.lineNumber,N,b.lineNumber,N+M.length)}}return null}e.$KF=s;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(i))}e.$LF=n;function o(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return F.URI.parse(D.path);if((0,m.$hc)(D.path))return F.URI.file(D.path)}return D.path}function a(D){if(typeof D.path=="object"){const $=F.URI.revive(D.path);if($)return $.scheme===R.Schemas.file?$.fsPath:$.toString()}return D.path}function t(D,$){const b=$?o:a,v=(0,L.$0m)(D);return d(v,(C,N)=>{C&&N&&(N.path=b(N))}),v}e.$MF=t;function r(D,$){const b=$?o:a,v=(0,L.$0m)(D);return d(v,(C,N)=>{!C&&N&&(N.path=b(N))}),v}e.$NF=r;function d(D,$){switch(D.type){case"event":{const b=D;switch(b.event){case"output":$(!1,b.body.source);break;case"loadedSource":$(!1,b.body.source);break;case"breakpoint":$(!1,b.body.breakpoint.source);break;default:break}break}case"request":{const b=D;switch(b.command){case"setBreakpoints":$(!0,b.arguments.source);break;case"breakpointLocations":$(!0,b.arguments.source);break;case"source":$(!0,b.arguments.source);break;case"gotoTargets":$(!0,b.arguments.source);break;case"launchVSCode":b.arguments.args.forEach(v=>$(!1,v));break;default:break}break}case"response":{const b=D;if(b.success&&b.body)switch(b.command){case"stackTrace":b.body.stackFrames.forEach(v=>$(!1,v.source));break;case"loadedSources":b.body.sources.forEach(v=>$(!1,v));break;case"scopes":b.body.scopes.forEach(v=>$(!1,v.source));break;case"setFunctionBreakpoints":b.body.breakpoints.forEach(v=>$(!1,v.source));break;case"setBreakpoints":b.body.breakpoints.forEach(v=>$(!1,v.source));break;case"disassemble":b.body?.instructions.forEach(C=>$(!1,C.location));break;default:break}break}}}function u(D){return D.filter($=>!$.presentation?.hidden).sort(($,b)=>$.presentation?b.presentation?$.presentation.group?b.presentation.group?$.presentation.group!==b.presentation.group?$.presentation.group.localeCompare(b.presentation.group):l($.presentation.order,b.presentation.order):-1:b.presentation.group?1:l($.presentation.order,b.presentation.order):-1:b.presentation?1:0)}e.$OF=u;function l(D,$){return typeof D!="number"?typeof $!="number"?0:1:typeof $!="number"?-1:D-$}async function h(D,$){const b=D.getValue("debug.saveBeforeStart",{overrideIdentifier:$.activeTextEditorLanguageId});if(b!=="none"&&(await $.saveAll(),b==="allEditorsInActiveGroup")){const v=$.activeEditorPane;v&&v.input.resource?.scheme===R.Schemas.untitled&&await $.save({editor:v.input,groupId:v.group.id})}await D.reloadConfiguration()}e.$PF=h;const k=(D,$)=>!D||!$?D===$:D.name===$.name&&D.path===$.path&&D.sourceReference===$.sourceReference;e.$QF=k}),define(ke[284],Se([1,0,50,62,24,16,12,13,30,230,142]),function(me,e,I,F,m,L,R,w,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=e.$rfc=e.$qfc=e.$pfc=e.$ofc=void 0;class P extends A.$Hdb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(s,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,s.on("data",n=>this.w(n))}sendMessage(s){if(this.p){const i=JSON.stringify(s);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${P.a}${i}`,"utf8")}}w(s){for(this.r=Buffer.concat([this.r,s]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.m.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.r.indexOf(P.a);if(i!==-1){const o=this.r.toString("utf8",0,i).split(P.b);for(const a of o){const t=a.split(P.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+P.a.length);continue}}break}}}e.$ofc=P;class f extends P{startSession(){return new Promise((s,i)=>{let n=!1;this.x=this.y(()=>{this.v(this.x,this.x),s(),n=!0}),this.x.on("close",()=>{n?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",o=>{n?this.m.fire(o):i(o)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$pfc=f;class y extends f{constructor(s){super(),this.z=s}y(s){return F.createConnection(this.z.port,this.z.host||"127.0.0.1",s)}}e.$qfc=y;class S extends f{constructor(s){super(),this.z=s}y(s){return F.createConnection(this.z.path,s)}}e.$rfc=S;class p extends P{constructor(s,i){super(),this.y=s,this.z=i}async startSession(){const s=this.y.command,i=this.y.args,n=this.y.options||{};try{if(s)if(L.$hc(s)){if(!await E.Promises.exists(s))throw new Error(g.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(g.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=m.$an(m.$0m(process.env),n.env)),s==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:o,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const r=I.fork(i[0],i.slice(1),t);if(!r.pid)throw new Error(g.localize(2,null,i[0]));this.x=r}else throw new Error(g.localize(3,null));else{const a={env:o};n.cwd&&(a.cwd=n.cwd),this.x=I.spawn(s,i,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(o){this.m.fire(o)}}async stopSession(){return this.x?(await this.u(),R.$i?new Promise((s,i)=>{const n=I.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,a,t){if(o)return i(o)});n.on("exit",s),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(s,i){if(!s)return;const n=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?n.runtime=L.$ic(i,s.runtime):n.runtime=s.runtime),s.runtimeArgs&&(n.runtimeArgs=s.runtimeArgs),s.program&&(L.$hc(s.program)?n.program=s.program:n.program=L.$ic(i,s.program)),s.args&&(n.args=s.args);const o=s;return o.win&&(n.win=p.A(o.win,i)),o.winx86&&(n.winx86=p.A(o.winx86,i)),o.windows&&(n.windows=p.A(o.windows,i)),o.osx&&(n.osx=p.A(o.osx,i)),o.linux&&(n.linux=p.A(o.linux,i)),n}static platformAdapterExecutable(s,i){let n=Object.create(null);i=i.toLowerCase();for(const u of s)if(u.contributes){const l=u.contributes.debuggers;l&&l.length>0&&l.filter(h=>typeof h.type=="string"&&w.$3e(h.type,i)).forEach(h=>{const k=p.A(h,u.extensionLocation.fsPath);n=m.$an(n,k,u.isBuiltin)})}let o;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:R.$i?o=n.win||n.windows:R.$j?o=n.osx:R.$k&&(o=n.linux),o=o||n;const a=o.program||n.program,t=o.args||n.args,r=o.runtime||n.runtime,d=o.runtimeArgs||n.runtimeArgs;if(r)return{type:"executable",command:r,args:(d||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$sfc=p}),define(ke[285],Se([1,0,50,33,12]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=e.$tfc=void 0;function L(g,A){return new Promise((P,f)=>{let y="";const S=I.spawn(g,A);S.pid&&S.stdout.on("data",p=>{y+=p.toString()}),S.on("error",p=>{f(p)}),S.on("close",p=>{P(y)})})}async function R(g){if(g)if(m.$i){const A=await new Promise((P,f)=>{me(["@vscode/windows-process-tree"],P,f)});return new Promise(P=>{A.getProcessTree(g,f=>{P(!!f&&f.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(g)]).then(A=>{const P=A.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.$tfc=R;var w;(function(g){g[g.cmd=0]="cmd",g[g.powershell=1]="powershell",g[g.bash=2]="bash"})(w||(w={}));function E(g,A,P,f,y){g=g.trim().toLowerCase();let S;g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0?S=1:g.indexOf("cmd.exe")>=0?S=0:g.indexOf("bash")>=0?S=2:m.$i?S=0:S=2;let p,c=" ";switch(S){case 1:if(p=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),f){const s=(0,F.$4f)(f);s&&(c+=`${s}:; `),c+=`cd ${p(f)}; `}if(y)for(const s in y){const i=y[s];i===null?c+=`Remove-Item env:${s}; `:c+=`\${env:${s}}='${i}'; `}if(A.length>0){const s=A.shift(),i=P?s:p(s);c+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of A)c+=n==="<"||n===">"||P?n:p(n),c+=" "}break;case 0:if(p=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>s.includes(i))||s.length===0?`"${s}"`:s),f){const s=(0,F.$4f)(f);s&&(c+=`${s}: && `),c+=`cd ${p(f)} && `}if(y){c+='cmd /C "';for(const s in y){let i=y[s];i===null?c+=`set "${s}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),c+=`set "${s}=${i}" && `)}}for(const s of A)c+=s==="<"||s===">"||P?s:p(s),c+=" ";y&&(c+='"');break;case 2:{p=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const s=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(f&&(c+=`cd ${p(f)} ; `),y){c+="/usr/bin/env";for(const i in y){const n=y[i];n===null?c+=` -u ${s(i)}`:c+=` ${s(`${i}=${n}`)}`}c+=" "}for(const i of A)c+=i==="<"||i===">"||P?i:p(i),c+=" ";break}}return c}e.$ufc=E}),define(ke[111],Se([1,0,22,34,51,100,17,16,12,45]),function(me,e,I,F,m,L,R,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BI=e.$AI=e.$zI=e.$yI=e.CellStatusbarAlignment=e.$xI=e.$wI=e.$vI=e.NotebookEditorPriority=e.$uI=e.$tI=e.$sI=e.$rI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$qI=e.$pI=e.$oI=e.$nI=e.CellKind=e.$mI=e.$lI=e.$kI=void 0,e.$kI="workbench.editor.notebook",e.$lI="workbench.editor.notebookTextDiffEditor",e.$mI="workbench.editor.interactive";var A;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(A||(e.CellKind=A={})),e.$nI=["application/json","application/javascript","text/html","image/svg+xml",L.$Sr.latex,L.$Sr.markdown,"image/png","image/jpeg",L.$Sr.text],e.$oI=[L.$Sr.latex,L.$Sr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Sr.text],e.$pI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$qI="_notAvailable";var P;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(P||(e.NotebookRunState=P={}));var f;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(f||(e.NotebookCellExecutionState=f={}));var y;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var S;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(S||(e.NotebookRendererMatch=S={}));var p;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(p||(e.RendererMessagingSpec=p={}));var c;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var s;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var i;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(O){O.scheme=R.Schemas.vscodeNotebookCell;const q=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${q.join("")}]+`),de=7;function ee(pe,G){const U=G.toString(de),be=`${U.length<q.length?q[U.length-1]:"z"}${U}s${(0,I.$we)(I.$ce.fromString(pe.scheme),!0,!0)}`;return pe.with({scheme:O.scheme,fragment:be})}O.generate=ee;function X(pe){if(pe.scheme!==O.scheme)return;const G=pe.fragment.indexOf("s");if(G<0)return;const U=parseInt(pe.fragment.substring(0,G).replace(V,""),de),ce=(0,I.$ve)(pe.fragment.substring(G+1)).toString();if(!isNaN(U))return{handle:U,notebook:pe.with({scheme:ce,fragment:null})}}O.parse=X;function Q(pe,G){return pe.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${G??""},${pe.scheme!==R.Schemas.file?pe.scheme:""}`})}O.generateCellOutputUri=Q;function ae(pe){if(pe.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const G=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(pe.fragment);if(!G)return;const U=G[1]&&G[1]!==""?G[1]:void 0,ce=G[2];return{outputId:U,notebook:pe.with({scheme:ce||R.Schemas.file,fragment:null})}}O.parseCellOutputUri=ae;function x(pe,G,U){return O.generate(pe,G).with({scheme:U})}O.generateCellPropertyUri=x;function se(pe,G){if(pe.scheme===G)return O.parse(pe.with({scheme:O.scheme}))}O.parseCellPropertyUri=se})(n||(e.CellUri=n={}));const o=O=>E.$i?O.replace(/\//g,"\\"):O;class a{constructor(q=[],V=e.$nI){this.e=V,this.d=[...new Set(q)].map(de=>({pattern:de,matches:F.$zj(o(de))}))}sort(q){const V=new Map(m.Iterable.map(q,ee=>[ee,o(ee)]));let de=[];for(const{matches:ee}of this.d)for(const[X,Q]of V)if(ee(Q)){de.push(X),V.delete(X);break}return V.size&&(de=de.concat([...V.keys()].sort((ee,X)=>this.e.indexOf(ee)-this.e.indexOf(X)))),de}prioritize(q,V){const de=this.f(q);if(de===-1){this.d.unshift({pattern:q,matches:F.$zj(o(q))});return}const ee=new Set(V.map(Q=>this.f(Q,de)));ee.delete(-1);const X=Array.from(ee).sort();this.d.splice(de+1,0,...X.map(Q=>this.d[Q]));for(let Q=X.length-1;Q>=0;Q--)this.d.splice(X[Q],1)}toArray(){return this.d.map(q=>q.pattern)}f(q,V=this.d.length){const de=o(q);for(let ee=0;ee<V;ee++)if(this.d[ee].matches(de))return ee;return-1}}e.$rI=a;function t(O,q,V,de=(ee,X)=>ee===X){const ee=[];function X(x,se,pe){if(se===0&&pe.length===0)return;const G=ee[ee.length-1];G&&G.start+G.deleteCount===x?(G.deleteCount+=se,G.toInsert.push(...pe)):ee.push({start:x,deleteCount:se,toInsert:pe})}let Q=0,ae=0;for(;;){if(Q===O.length){X(Q,0,q.slice(ae));break}if(ae===q.length){X(Q,O.length-Q,[]);break}const x=O[Q],se=q[ae];if(de(x,se)){Q+=1,ae+=1;continue}V(se)?(X(Q,1,[]),Q+=1):(X(Q,0,[se]),ae+=1)}return ee}e.$sI=t,e.$tI=new g.$0i("notebookEditorCursorAtBoundary","none"),e.$uI=new g.$0i("notebookEditorCursorAtLineBoundary","none");var r;(function(O){O.default="default",O.option="option"})(r||(e.NotebookEditorPriority=r={}));function d(O){const q=O;return!!((typeof q.include=="string"||F.$Aj(q.include))&&(typeof q.exclude=="string"||F.$Aj(q.exclude)))}e.$vI=d;function u(O,q,V){if(Array.isArray(O.viewType)&&O.viewType.indexOf(q)>=0||O.viewType===q)return!0;if(O.filenamePattern){const de=d(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,ee=d(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(F.$yj(de,(0,w.$mc)(V.fsPath).toLowerCase()))return!(ee&&F.$yj(ee,(0,w.$mc)(V.fsPath).toLowerCase()))}return!1}e.$wI=u,e.$xI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var l;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(l||(e.CellStatusbarAlignment=l={}));class h{static{this.d="notebook/"}static create(q){return`${h.d}${q}`}static parse(q){if(q.startsWith(h.d))return q.substring(h.d.length)}}e.$yI=h;function k(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$zI=k;const D=new TextDecoder;function $(O){const q=[];let V=!1;for(const Q of O)(q.length===0||V)&&(q.push(Q),V=!0);let de=C(q);const ee=I.$ce.concat(q.map(Q=>I.$ce.wrap(Q))),X=j(ee);return de=de||X.byteLength!==ee.byteLength,{data:X,didCompression:de}}e.$AI=$,e.$BI=`${String.fromCharCode(27)}[A`;const b=e.$BI.split("").map(O=>O.charCodeAt(0)),v=10;function C(O){let q=!1;return O.forEach((V,de)=>{if(de===0||V.length<e.$BI.length)return;const ee=O[de-1],X=V.subarray(0,e.$BI.length);if(X[0]===b[0]&&X[1]===b[1]&&X[2]===b[2]){const Q=ee.lastIndexOf(v);if(Q===-1)return;q=!0,O[de-1]=ee.subarray(0,Q),O[de]=V.subarray(e.$BI.length)}}),q}function N(O){let q=O;do O=q,q=O.replace(/[^\n]\x08/gm,"");while(q.length<O.length);return O}function z(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const q=O.match(/^(.*)\r+/m)[1];let V=O.match(/\r+(.*)$/m)[1];V=V+q.slice(V.length,q.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return O}const M="\b".charCodeAt(0),T="\r".charCodeAt(0);function j(O){return!O.buffer.includes(M)&&!O.buffer.includes(T)?O:I.$ce.fromString(z(N(D.decode(O.buffer))))}}),define(ke[7],Se([1,0,19,11,81,28,100,13,18,2,32,26,31,65,111]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S){"use strict";var p,c,s,i,n,o,a,t,r,d,u,l,h,k,D,$,b,v;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$lM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.TestRunProfileKind=e.TestResultState=e.$4L=e.$3L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$2L=e.$1L=e.$ZL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$YL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.ColorThemeKind=e.$SL=e.$RL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$QL=e.DebugConsoleMode=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$KL=e.$JL=e.FileChangeType=e.$IL=e.$HL=e.$GL=e.$FL=e.InlineCompletionTriggerKind=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.ConfigurationTarget=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$iL=e.ViewBadge=e.ProgressLocation=e.$hL=e.$gL=e.TaskScope=e.ShellQuoting=e.$fL=e.$eL=e.$dL=e.TaskPanelKind=e.TaskRevealKind=e.$cL=e.TerminalLocation=e.$bL=e.$aL=e.$_K=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$$K=e.$0K=e.$9K=e.$8K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$7K=e.StatusBarAlignment=e.ViewColumn=e.$6K=e.$5K=e.$4K=e.$3K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$2K=e.$1K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.LanguageStatusSeverity=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.CodeActionTriggerKind=e.$OK=e.$NK=e.SymbolTag=e.SymbolKind=e.$MK=e.DocumentHighlightKind=e.$LK=e.$KK=e.$JK=e.$IK=e.DiagnosticSeverity=e.DiagnosticTag=e.$HK=e.$GK=e.FileEditType=e.$FK=e.$EK=e.$DK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function C(K){return Object.assign(K,{apply:function(...ye){if(ye.length===0)return Reflect.construct(K,[]);{const Le=ye.length===1?[]:ye[1];return Reflect.construct(K,Le,ye[0].constructor)}},call:function(...ye){if(ye.length===0)return Reflect.construct(K,[]);{const[Le,...Qe]=ye;return Reflect.construct(K,Qe,Le.constructor)}}})}var N;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var z;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(z||(e.TerminalQuickFixType=z={}));let M=p=class{static from(...W){let ye=W;return new p(function(){if(ye){for(const Le of ye)Le&&typeof Le.dispose=="function"&&Le.dispose();ye=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$wK=M,e.$wK=M=p=He([C],M);let T=c=class{static Min(...W){if(W.length===0)throw new TypeError;let ye=W[0];for(let Le=1;Le<W.length;Le++){const Qe=W[Le];Qe.isBefore(ye)&&(ye=Qe)}return ye}static Max(...W){if(W.length===0)throw new TypeError;let ye=W[0];for(let Le=1;Le<W.length;Le++){const Qe=W[Le];Qe.isAfter(ye)&&(ye=Qe)}return ye}static isPosition(W){if(!W)return!1;if(W instanceof c)return!0;const{line:ye,character:Le}=W;return typeof ye=="number"&&typeof Le=="number"}static of(W){if(W instanceof c)return W;if(this.isPosition(W))return new c(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,ye){if(W<0)throw(0,F.$6)("line must be non-negative");if(ye<0)throw(0,F.$6)("character must be non-negative");this.c=W,this.e=ye}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,ye=0){if(W===null||ye===null)throw(0,F.$6)();let Le;return typeof W>"u"?Le=0:typeof W=="number"?Le=W:(Le=typeof W.lineDelta=="number"?W.lineDelta:0,ye=typeof W.characterDelta=="number"?W.characterDelta:0),Le===0&&ye===0?this:new c(this.line+Le,this.character+ye)}with(W,ye=this.character){if(W===null||ye===null)throw(0,F.$6)();let Le;return typeof W>"u"?Le=this.line:typeof W=="number"?Le=W:(Le=typeof W.line=="number"?W.line:this.line,ye=typeof W.character=="number"?W.character:this.character),Le===this.line&&ye===this.character?this:new c(Le,ye)}toJSON(){return{line:this.line,character:this.character}}};e.$xK=T,e.$xK=T=c=He([C],T);let j=s=class{static isRange(W){return W instanceof s?!0:W?T.isPosition(W.start)&&T.isPosition(W.end):!1}static of(W){if(W instanceof s)return W;if(this.isRange(W))return new s(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,ye,Le,Qe){let et,ot;if(typeof W=="number"&&typeof ye=="number"&&typeof Le=="number"&&typeof Qe=="number"?(et=new T(W,ye),ot=new T(Le,Qe)):T.isPosition(W)&&T.isPosition(ye)&&(et=T.of(W),ot=T.of(ye)),!et||!ot)throw new Error("Invalid arguments");et.isBefore(ot)?(this.c=et,this.e=ot):(this.c=ot,this.e=et)}contains(W){return s.isRange(W)?this.contains(W.start)&&this.contains(W.end):T.isPosition(W)?!(T.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const ye=T.Max(W.start,this.c),Le=T.Min(W.end,this.e);if(!ye.isAfter(Le))return new s(ye,Le)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ye=T.Min(W.start,this.c),Le=T.Max(W.end,this.end);return new s(ye,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,ye=this.end){if(W===null||ye===null)throw(0,F.$6)();let Le;return W?T.isPosition(W)?Le=W:(Le=W.start||this.start,ye=W.end||this.end):Le=this.start,Le.isEqual(this.c)&&ye.isEqual(this.end)?this:new s(Le,ye)}toJSON(){return[this.start,this.end]}};e.$yK=j,e.$yK=j=s=He([C],j);let O=i=class extends j{static isSelection(W){return W instanceof i?!0:W?j.isRange(W)&&T.isPosition(W.anchor)&&T.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,ye,Le,Qe){let et,ot;if(typeof W=="number"&&typeof ye=="number"&&typeof Le=="number"&&typeof Qe=="number"?(et=new T(W,ye),ot=new T(Le,Qe)):T.isPosition(W)&&T.isPosition(ye)&&(et=T.of(W),ot=T.of(ye)),!et||!ot)throw new Error("Invalid arguments");super(et,ot),this.f=et,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$zK=O,e.$zK=O=i=He([C],O);const q=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,F.$6)("connectionToken")};class V{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ye,Le){if(typeof W!="string"||W.length===0)throw(0,F.$6)("host");if(typeof ye!="number"||ye===0||Math.round(ye)!==ye)throw(0,F.$6)("port");typeof Le<"u"&&q(Le),this.host=W,this.port=Math.round(ye),this.connectionToken=Le}}e.$AK=V;class de{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ye){this.makeConnection=W,this.connectionToken=ye,typeof ye<"u"&&q(ye)}}e.$BK=de;class ee extends Error{static NotAvailable(W,ye){return new ee(W,y.RemoteAuthorityResolverErrorCode.NotAvailable,ye)}static TemporarilyNotAvailable(W){return new ee(W,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ye=y.RemoteAuthorityResolverErrorCode.Unknown,Le){super(W),this._message=W,this._code=ye,this._detail=Le,Object.setPrototypeOf(this,ee.prototype)}}e.$CK=ee;var X;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(X||(e.EndOfLine=X={}));var Q;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(Q||(e.EnvironmentVariableMutatorType=Q={}));let ae=n=class{static isTextEdit(W){return W instanceof n?!0:W?j.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ye){return new n(W,ye)}static insert(W,ye){return n.replace(new j(W,W),ye)}static delete(W){return n.replace(W,"")}static setEndOfLine(W){const ye=new n(new j(new T(0,0),new T(0,0)),"");return ye.newEol=W,ye}get range(){return this.c}set range(W){if(W&&!j.isRange(W))throw(0,F.$6)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,F.$6)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,F.$6)("newEol");this.f=W}constructor(W,ye){this.c=W,this.e=ye}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$DK=ae,e.$DK=ae=n=He([C],ae);let x=o=class{static isNotebookCellEdit(W){return W instanceof o?!0:W?xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ye){return new o(W,ye)}static insertCells(W,ye){return new o(new xt(W,W),ye)}static deleteCells(W){return new o(W,[])}static updateCellMetadata(W,ye){const Le=new o(new xt(W,W),[]);return Le.newCellMetadata=ye,Le}static updateNotebookMetadata(W){const ye=new o(new xt(0,0),[]);return ye.newNotebookMetadata=W,ye}constructor(W,ye){this.range=W,this.newCells=ye}};e.$EK=x,e.$EK=x=o=He([C],x);class se{static isSnippetTextEdit(W){return W instanceof se?!0:W?j.isRange(W.range)&&U.isSnippetString(W.snippet):!1}static replace(W,ye){return new se(W,ye)}static insert(W,ye){return se.replace(new j(W,W),ye)}constructor(W,ye){this.range=W,this.snippet=ye}}e.$FK=se;var pe;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(pe||(e.FileEditType=pe={}));let G=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,ye,Le,Qe){this.c.push({_type:1,from:W,to:ye,options:Le,metadata:Qe})}createFile(W,ye,Le){this.c.push({_type:1,from:void 0,to:W,options:ye,metadata:Le})}deleteFile(W,ye,Le){this.c.push({_type:1,from:W,to:void 0,options:ye,metadata:Le})}e(W,ye,Le){this.c.push({_type:3,metadata:Le,uri:W,edit:{editType:5,metadata:ye},notebookMetadata:ye})}f(W,ye,Le,Qe){const et=ye.start,ot=ye.end;(et!==ot||Le.length>0)&&this.c.push({_type:5,uri:W,index:et,count:ot-et,cells:Le,metadata:Qe})}g(W,ye,Le,Qe){this.c.push({_type:3,metadata:Qe,uri:W,edit:{editType:3,index:ye,metadata:Le}})}replace(W,ye,Le,Qe){this.c.push({_type:2,uri:W,edit:new ae(ye,Le),metadata:Qe})}insert(W,ye,Le,Qe){this.replace(W,new j(ye,ye),Le,Qe)}delete(W,ye,Le){this.replace(W,ye,"",Le)}has(W){return this.c.some(ye=>ye._type===2&&ye.uri.toString()===W.toString())}set(W,ye){if(ye)for(const Le of ye){if(!Le)continue;let Qe,et;Array.isArray(Le)?(Qe=Le[0],et=Le[1]):Qe=Le,x.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(W,Qe.range.start,Qe.newCellMetadata,et):Qe.newNotebookMetadata?this.e(W,Qe.newNotebookMetadata,et):this.f(W,Qe.range,Qe.newCells,et):se.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:W,range:Qe.range,edit:Qe.snippet,metadata:et}):this.c.push({_type:2,uri:W,edit:Qe,metadata:et})}else{for(let Le=0;Le<this.c.length;Le++){const Qe=this.c[Le];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===W.toString()&&(this.c[Le]=void 0);break}}(0,I.$Hb)(this.c)}}get(W){const ye=[];for(const Le of this.c)Le._type===2&&Le.uri.toString()===W.toString()&&ye.push(Le.edit);return ye}entries(){const W=new L.$zc;for(const ye of this.c)if(ye._type===2){let Le=W.get(ye.uri);Le||(Le=[ye.uri,[]],W.set(ye.uri,Le)),Le[1].push(ye.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$GK=G,e.$GK=G=He([C],G);let U=a=class{static isSnippetString(W){return W instanceof a?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=a.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ye=this.e++){if(typeof W=="function"){const Le=new a;Le.e=this.e,W(Le),this.e=Le.e,W=Le.value}else W=a.c(W);return this.value+="${",this.value+=ye,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ye=this.e++){const Le=W.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ye,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(W,ye){if(typeof ye=="function"){const Le=new a;Le.e=this.e,ye(Le),this.e=Le.e,ye=Le.value}else typeof ye=="string"&&(ye=ye.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ye&&(this.value+=":",this.value+=ye),this.value+="}",this}};e.$HK=U,e.$HK=U=a=He([C],U);var ce;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(ce||(e.DiagnosticTag=ce={}));var be;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(be||(e.DiagnosticSeverity=be={}));let H=t=class{static isLocation(W){return W instanceof t?!0:W?j.isRange(W.range)&&g.URI.isUri(W.uri):!1}constructor(W,ye){if(this.uri=W,ye)if(j.isRange(ye))this.range=j.of(ye);else if(T.isPosition(ye))this.range=new j(ye,ye);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$IK=H,e.$IK=H=t=He([C],H);let Z=class{static is(W){return W?typeof W.message=="string"&&W.location&&j.isRange(W.location.range)&&g.URI.isUri(W.location.uri):!1}constructor(W,ye){this.location=W,this.message=ye}static isEqual(W,ye){return W===ye?!0:!W||!ye?!1:W.message===ye.message&&W.location.range.isEqual(ye.location.range)&&W.location.uri.toString()===ye.location.uri.toString()}};e.$JK=Z,e.$JK=Z=He([C],Z);let Y=class{constructor(W,ye,Le=be.Error){if(!j.isRange(W))throw new TypeError("range must be set");if(!ye)throw new TypeError("message must be set");this.range=W,this.message=ye,this.severity=Le}toJSON(){return{severity:be[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ye){return W===ye?!0:!W||!ye?!1:W.message===ye.message&&W.severity===ye.severity&&W.code===ye.code&&W.severity===ye.severity&&W.source===ye.source&&W.range.isEqual(ye.range)&&(0,I.$tb)(W.tags,ye.tags)&&(0,I.$tb)(W.relatedInformation,ye.relatedInformation,Z.isEqual)}};e.$KK=Y,e.$KK=Y=He([C],Y);let $e=class{constructor(W,ye){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ye}};e.$LK=$e,e.$LK=$e=He([C],$e);var ne;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(ne||(e.DocumentHighlightKind=ne={}));let fe=class{constructor(W,ye=ne.Text){this.range=W,this.kind=ye}toJSON(){return{range:this.range,kind:ne[this.kind]}}};e.$MK=fe,e.$MK=fe=He([C],fe);var te;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(te||(e.SymbolKind=te={}));var he;(function(K){K[K.Deprecated=1]="Deprecated"})(he||(e.SymbolTag=he={}));let we=r=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ye,Le,Qe,et){this.name=W,this.kind=ye,this.containerName=et,typeof Le=="string"&&(this.containerName=Le),Qe instanceof H?this.location=Qe:Le instanceof j&&(this.location=new H(Qe,Le)),r.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};e.$NK=we,e.$NK=we=r=He([C],we);let Pe=d=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(d.validate)}constructor(W,ye,Le,Qe,et){this.name=W,this.detail=ye,this.kind=Le,this.range=Qe,this.selectionRange=et,this.children=[],d.validate(this)}};e.$OK=Pe,e.$OK=Pe=d=He([C],Pe);var B;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let J=class{constructor(W,ye){this.title=W,this.kind=ye}};e.$PK=J,e.$PK=J=He([C],J);let re=class{static{u=this}static{this.c="."}constructor(W){this.value=W}append(W){return new u(this.value?this.value+u.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+u.c)}};e.$QK=re,e.$QK=re=u=He([C],re),re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorMove=re.Refactor.append("move"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll"),re.Notebook=re.Empty.append("notebook");let oe=class{constructor(W,ye){if(this.range=W,this.parent=ye,ye&&!ye.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$RK=oe,e.$RK=oe=He([C],oe);class _{constructor(W,ye,Le,Qe,et,ot){this.kind=W,this.name=ye,this.detail=Le,this.uri=Qe,this.range=et,this.selectionRange=ot}}e.$SK=_;class ge{constructor(W,ye){this.fromRanges=ye,this.from=W}}e.$TK=ge;class Ee{constructor(W,ye){this.fromRanges=ye,this.to=W}}e.$UK=Ee;var ze;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(ze||(e.LanguageStatusSeverity=ze={}));let We=class{constructor(W,ye){this.range=W,this.command=ye}get isResolved(){return!!this.command}};e.$VK=We,e.$VK=We=He([C],We);let _e=l=class{#e;static isMarkdownString(W){return W instanceof l?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ye=!1){this.#e=new m.$6j(W,{supportThemeIcons:ye})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,ye){return this.#e.appendCodeblock(ye??"",W),this}};e.$WK=_e,e.$WK=_e=l=He([C],_e);let Xe=class{constructor(W,ye){this.label=W,this.documentation=ye}};e.$XK=Xe,e.$XK=Xe=He([C],Xe);let it=class{constructor(W,ye){this.label=W,this.documentation=ye,this.parameters=[]}};e.$YK=it,e.$YK=it=He([C],it);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$ZK=tt,e.$ZK=tt=He([C],tt);var Ae;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Te;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(Te||(e.InlayHintKind=Te={}));let qe=class{constructor(W){this.value=W}};e.$1K=qe,e.$1K=qe=He([C],qe);let Re=class{constructor(W,ye,Le){this.position=W,this.label=ye,this.kind=Le}};e.$2K=Re,e.$2K=Re=He([C],Re);var Ye;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye||(e.CompletionTriggerKind=Ye={}));var le;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(le||(e.CompletionItemKind=le={}));var ue;(function(K){K[K.Deprecated=1]="Deprecated"})(ue||(e.CompletionItemTag=ue={}));let Ie=class{constructor(W,ye){this.label=W,this.kind=ye}toJSON(){return{label:this.label,kind:this.kind&&le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$3K=Ie,e.$3K=Ie=He([C],Ie);let Ke=class{constructor(W=[],ye=!1){this.items=W,this.isIncomplete=ye}};e.$4K=Ke,e.$4K=Ke=He([C],Ke);let Ue=class{constructor(W,ye,Le){this.insertText=W,this.range=ye,this.command=Le}};e.$5K=Ue,e.$5K=Ue=He([C],Ue);let Ze=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$6K=Ze,e.$6K=Ze=He([C],Ze);var nt;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var ct;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(ct||(e.StatusBarAlignment=ct={}));function bt(K,W){return`${P.$9l.toKey(K)}.${W}`}e.$7K=bt;var Et;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(Et||(e.TextEditorLineNumbersStyle=Et={}));var Kt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var pt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(pt||(e.TextEditorSelectionChangeKind=pt={}));var zt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(zt||(e.TextDocumentChangeReason=zt={}));var Tt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Tt||(e.DecorationRangeBehavior=Tt={})),function(K){function W(ye){switch(ye){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=W}(pt||(e.TextEditorSelectionChangeKind=pt={}));var Gt;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(K){function W(ye){switch(ye){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=W}(Gt||(e.SyntaxTokenType=Gt={}));let Ut=class{constructor(W,ye){if(ye&&!g.URI.isUri(ye))throw(0,F.$6)("target");if(!j.isRange(W)||W.isEmpty)throw(0,F.$6)("range");this.range=W,this.target=ye}};e.$8K=Ut,e.$8K=Ut=He([C],Ut);let Dt=class{constructor(W,ye,Le,Qe){this.red=W,this.green=ye,this.blue=Le,this.alpha=Qe}};e.$9K=Dt,e.$9K=Dt=He([C],Dt);let Ft=class{constructor(W,ye){if(ye&&!(ye instanceof Dt))throw(0,F.$6)("color");if(!j.isRange(W)||W.isEmpty)throw(0,F.$6)("range");this.range=W,this.color=ye}};e.$0K=Ft,e.$0K=Ft=He([C],Ft);let Bt=class{constructor(W){if(!W||typeof W!="string")throw(0,F.$6)("label");this.label=W}};e.$$K=Bt,e.$$K=Bt=He([C],Bt);var Jt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Wt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var qt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class Nt{constructor(W,ye,Le){if(this.startIndex=W,this.length=ye,this.tooltip=Le,typeof W!="number"||W<0)throw(0,F.$6)("startIndex");if(typeof ye!="number"||ye<1)throw(0,F.$6)("length");if(Le!==void 0&&typeof Le!="string")throw(0,F.$6)("tooltip")}}e.$_K=Nt;class ut{constructor(W){this.uri=W}}e.$aL=ut;class ft{constructor(W){this.terminalCommand=W}}e.$bL=ft;var At;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(At||(e.TerminalLocation=At={}));class Vt{constructor(W){if(this.options=W,typeof W!="object")throw(0,F.$6)("options")}}e.$cL=Vt;var Lt;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(Lt||(e.TaskRevealKind=Lt={}));var at;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(at||(e.TaskPanelKind=at={}));let vt=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(W){switch(W){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(W,ye){if(this.label=ye,typeof W!="string"||typeof ye!="string")throw(0,F.$6)("name");this.c=W}get id(){return this.c}};e.$dL=vt,e.$dL=vt=h=He([C],vt);function Ot(K){let W="";for(let ye=0;ye<K.length;ye++)W+=K[ye].replace(/,/g,",,")+",";return W}let Pt=class{constructor(W,ye,Le){if(typeof W!="string")throw(0,F.$6)("process");this.e=[],this.c=W,ye!==void 0&&(Array.isArray(ye)?(this.e=ye,this.f=Le):this.f=ye)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,F.$6)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const ye of this.e)W.push(ye);return Ot(W)}};e.$eL=Pt,e.$eL=Pt=He([C],Pt);let Ge=class{constructor(W,ye,Le){if(this.f=[],Array.isArray(ye)){if(!W)throw(0,F.$6)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$6)("command");this.e=W,this.f=ye,this.g=Le}else{if(typeof W!="string")throw(0,F.$6)("commandLine");this.c=W,this.g=ye}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,F.$6)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$6)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ye of this.f)W.push(typeof ye=="string"?ye:ye.value);return Ot(W)}};e.$fL=Ge,e.$fL=Ge=He([C],Ge);var Qt;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var Me;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(Me||(e.TaskScope=Me={}));class Oe{constructor(W){this.c=W}computeId(){return"customExecution"+(0,A.$fg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$gL=Oe;let Ce=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,ye,Le,Qe,et,ot){this.j=!1,this.k=this.definition=W;let ht;typeof ye=="string"?(this.m=this.name=ye,this.t=this.source=Le,this.execution=Qe,ht=et,this.j=!0):ye===Me.Global||ye===Me.Workspace?(this.target=ye,this.m=this.name=Le,this.t=this.source=Qe,this.execution=et,ht=ot):(this.target=ye,this.m=this.name=Le,this.t=this.source=Qe,this.execution=et,ht=ot),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Pt?this.k={type:k.e,id:this.n.computeId()}:this.n instanceof Ge?this.k={type:k.f,id:this.n.computeId()}:this.n instanceof Oe?this.k={type:k.c,id:this.n.computeId()}:this.k={type:k.g,id:(0,A.$fg)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,F.$6)("Kind can't be undefined or null");this.z(),this.k=W}get scope(){return this.l}set target(W){this.z(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,F.$6)("name");this.z(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.z(),this.n=W;const ye=this.k.type;(k.g===ye||k.e===ye||k.f===ye||k.c===ye)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.z(),this.o=W,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.z(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,F.$6)("source must be a string of length > 0");this.z(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.z(),this.u=W}get detail(){return this.y}set detail(W){W===null&&(W=void 0),this.y=W}get presentationOptions(){return this.w}set presentationOptions(W){W==null&&(W=Object.create(null)),this.z(),this.w=W}get runOptions(){return this.x}set runOptions(W){W==null&&(W=Object.create(null)),this.z(),this.x=W}};e.$hL=Ce,e.$hL=Ce=k=He([C],Ce);var ie;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(ie||(e.ProgressLocation=ie={}));var Fe;(function(K){function W(ye){const Le=ye;return(0,E.$Df)(Le.value)?Le.tooltip&&!(0,E.$zf)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}K.isViewBadge=W})(Fe||(e.ViewBadge=Fe={}));let Ve=D=class{static isTreeItem(W,ye){const Le=W;if(Le.checkboxState!==void 0){const Qe=(0,E.$Df)(Le.checkboxState)?Le.checkboxState:(0,E.$Bf)(Le.checkboxState)&&(0,E.$Df)(Le.checkboxState.state)?Le.checkboxState.state:void 0,et=!(0,E.$Df)(Le.checkboxState)&&(0,E.$Bf)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==Je.Checked&&Qe!==Je.Unchecked||et!==void 0&&!(0,E.$zf)(et))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(W instanceof D)return!0;if(Le.label!==void 0&&!(0,E.$zf)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,E.$zf)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,E.$zf)(Le.iconPath)&&!g.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,E.$zf)(Le.iconPath.id))){const Qe=Le.iconPath;if(!Qe||!(0,E.$zf)(Qe.light)&&!g.URI.isUri(Qe.light)&&!(0,E.$zf)(Qe.dark)&&!g.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,E.$zf)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!g.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,E.$zf)(Le.tooltip)&&!(Le.tooltip instanceof _e)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<xe.None&&Le.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,E.$zf)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(W,ye=xe.None){this.collapsibleState=ye,g.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$iL=Ve,e.$iL=Ve=D=He([C],Ve);var xe;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var Je;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(Je||(e.TreeItemCheckboxState=Je={}));let rt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$jL=rt,e.$jL=rt=He([C],rt);class kt extends rt{}e.$kL=kt;class St extends kt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$lL=St;class mt{constructor(W,ye,Le,Qe){this.name=W,this.uri=ye,this._itemId=Le,this.c=Qe}data(){return this.c()}}e.$mL=mt;let dt=class{#e=new Map;constructor(W){for(const[ye,Le]of W??[]){const Qe=this.#e.get(this.#t(ye));Qe?Qe.push(Le):this.#e.set(this.#t(ye),[Le])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,ye){this.#e.set(this.#t(W),[ye])}forEach(W,ye){for(const[Le,Qe]of this.#e)for(const et of Qe)W.call(ye,et,Le,this)}*[Symbol.iterator](){for(const[W,ye]of this.#e)for(const Le of ye)yield[W,Le]}#t(W){return W.toLowerCase()}};e.$nL=dt,e.$nL=dt=He([C],dt);let gt=class{constructor(W){this.insertText=W}};e.$oL=gt,e.$oL=gt=He([C],gt);let ui=class{constructor(W,ye){this.label=ye,this.insertText=W}};e.$pL=ui,e.$pL=ui=He([C],ui);let Ct=class{constructor(W,ye){this.id=W,this.color=ye}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$qL=Ct,e.$qL=Ct=He([C],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Di=class{constructor(W){this.id=W}};e.$rL=Di,e.$rL=Di=He([C],Di);var li;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(li||(e.ConfigurationTarget=li={}));let $i=class{get base(){return this.c}set base(W){this.c=W,this.e=g.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,ye){if(typeof W!="string"&&(!W||!g.URI.isUri(W)&&!g.URI.isUri(W.uri)))throw(0,F.$6)("base");if(typeof ye!="string")throw(0,F.$6)("pattern");typeof W=="string"?this.baseUri=g.URI.file(W):g.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ye}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$sL=$i,e.$sL=$i=He([C],$i);const It=new WeakMap;function gn(K,W){It.set(K,W)}e.$tL=gn;let ri=class{constructor(W,ye,Le,Qe){this.enabled=typeof W=="boolean"?W:!0,typeof ye=="string"&&(this.condition=ye),typeof Le=="string"&&(this.hitCondition=Le),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this.c||(this.c=It.get(this)??(0,A.$fg)()),this.c}};e.$uL=ri,e.$uL=ri=He([C],ri);let yt=class extends ri{constructor(W,ye,Le,Qe,et){if(super(ye,Le,Qe,et),W===null)throw(0,F.$6)("location");this.location=W}};e.$vL=yt,e.$vL=yt=He([C],yt);let bi=class extends ri{constructor(W,ye,Le,Qe,et){super(ye,Le,Qe,et),this.functionName=W}};e.$wL=bi,e.$wL=bi=He([C],bi);let wi=class extends ri{constructor(W,ye,Le,Qe,et,ot,ht){if(super(Qe,et,ot,ht),!ye)throw(0,F.$6)("dataId");this.label=W,this.dataId=ye,this.canPersist=Le}};e.$xL=wi,e.$xL=wi=He([C],wi);let si=class{constructor(W,ye,Le){this.command=W,this.args=ye||[],this.options=Le}};e.$yL=si,e.$yL=si=He([C],si);let Ci=class{constructor(W,ye){this.port=W,this.host=ye}};e.$zL=Ci,e.$zL=Ci=He([C],Ci);let Ii=class{constructor(W){this.path=W}};e.$AL=Ii,e.$AL=Ii=He([C],Ii);let Rt=class{constructor(W){this.implementation=W}};e.$BL=Rt,e.$BL=Rt=He([C],Rt);let pi=class{constructor(W,ye,Le){this.session=W,this.threadId=ye,this.frameId=Le}};e.$CL=pi,e.$CL=pi=He([C],pi);let Pi=class{constructor(W,ye){this.session=W,this.threadId=ye}};e.$DL=Pi,e.$DL=Pi=He([C],Pi);let oi=class{constructor(W,ye){this.range=W,this.expression=ye}};e.$EL=oi,e.$EL=oi=He([C],oi);var hi;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(hi||(e.InlineCompletionTriggerKind=hi={}));let lt=class{constructor(W,ye){this.range=W,this.text=ye}};e.$FL=lt,e.$FL=lt=He([C],lt);let Ai=class{constructor(W,ye,Le=!0){this.range=W,this.variableName=ye,this.caseSensitiveLookup=Le}};e.$GL=Ai,e.$GL=Ai=He([C],Ai);let Zt=class{constructor(W,ye){this.range=W,this.expression=ye}};e.$HL=Zt,e.$HL=Zt=He([C],Zt);let ii=class{constructor(W,ye){this.frameId=W,this.stoppedLocation=ye}};e.$IL=ii,e.$IL=ii=He([C],ii);var Li;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Li||(e.FileChangeType=Li={}));let Ri=$=class extends Error{static FileExists(W){return new $(W,f.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(W){return new $(W,f.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(W){return new $(W,f.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(W){return new $(W,f.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(W){return new $(W,f.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(W){return new $(W,f.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(W,ye=f.FileSystemProviderErrorCode.Unknown,Le){super(g.URI.isUri(W)?W.toString(!0):W),this.code=Le?.name??"Unknown",(0,f.$qk)(this,ye),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$JL=Ri,e.$JL=Ri=$=He([C],Ri);let Mi=class{constructor(W,ye,Le){this.start=W,this.end=ye,this.kind=Le}};e.$KL=Mi,e.$KL=Mi=He([C],Mi);var Xi;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Fi;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(Fi||(e.CommentThreadCollapsibleState=Fi={}));var Yi;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(Yi||(e.CommentMode=Yi={}));var Oi;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(Oi||(e.CommentState=Oi={}));var ai;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class mn{constructor(W,ye=[]){this.tokenTypes=W,this.tokenModifiers=ye}}e.$LL=mn;function Ti(K){return typeof K>"u"||(0,E.$Af)(K)}class di{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let ye=0,Le=W.tokenTypes.length;ye<Le;ye++)this.j.set(W.tokenTypes[ye],ye);for(let ye=0,Le=W.tokenModifiers.length;ye<Le;ye++)this.k.set(W.tokenModifiers[ye],ye)}}push(W,ye,Le,Qe,et){if(typeof W=="number"&&typeof ye=="number"&&typeof Le=="number"&&typeof Qe=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.n(W,ye,Le,Qe,et);if(j.isRange(W)&&typeof ye=="string"&&Ti(Le))return this.m(W,ye,Le);throw(0,F.$6)()}m(W,ye,Le){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ye))throw new Error("`tokenType` is not in the provided legend");const Qe=W.start.line,et=W.start.character,ot=W.end.character-W.start.character,ht=this.j.get(ye);let jt=0;if(Le)for(const Yt of Le){if(!this.k.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Yt);jt|=1<<ei>>>0}this.n(Qe,et,ot,ht,jt)}n(W,ye,Le,Qe,et){if(this.f&&(W<this.c||W===this.c&&ye<this.e)){this.f=!1;const jt=this.g.length/5|0;let Yt=0,ei=0;for(let ti=0;ti<jt;ti++){let ni=this.g[5*ti],Ji=this.g[5*ti+1];ni===0?(ni=Yt,Ji+=ei):ni+=Yt,this.g[5*ti]=ni,this.g[5*ti+1]=Ji,Yt=ni,ei=Ji}}let ot=W,ht=ye;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ht-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ht,this.g[this.h++]=Le,this.g[this.h++]=Qe,this.g[this.h++]=et,this.c=W,this.e=ye}static o(W){const ye=[],Le=W.length/5|0;for(let ht=0;ht<Le;ht++)ye[ht]=ht;ye.sort((ht,jt)=>{const Yt=W[5*ht],ei=W[5*jt];if(Yt===ei){const ti=W[5*ht+1],ni=W[5*jt+1];return ti-ni}return Yt-ei});const Qe=new Uint32Array(W.length);let et=0,ot=0;for(let ht=0;ht<Le;ht++){const jt=5*ye[ht],Yt=W[jt+0],ei=W[jt+1],ti=W[jt+2],ni=W[jt+3],Ji=W[jt+4],In=Yt-et,On=In===0?ei-ot:ei,Qi=5*ht;Qe[Qi+0]=In,Qe[Qi+1]=On,Qe[Qi+2]=ti,Qe[Qi+3]=ni,Qe[Qi+4]=Ji,et=Yt,ot=ei}return Qe}build(W){return this.f?new Ni(new Uint32Array(this.g),W):new Ni(di.o(this.g),W)}}e.$ML=di;class Ni{constructor(W,ye){this.resultId=ye,this.data=W}}e.$NL=Ni;class $n{constructor(W,ye,Le){this.start=W,this.deleteCount=ye,this.data=Le}}e.$OL=$n;class fi{constructor(W,ye){this.resultId=ye,this.edits=W}}e.$PL=fi;var Zi;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let ji=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.$QL=ji,e.$QL=ji=He([C],ji);var xi;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var gi;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(gi||(e.InputBoxValidationSeverity=gi={}));var _i;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class bn{static validate(W){if(typeof W.badge=="string"){let ye=(0,w.$af)(W.badge,0);if(ye<W.badge.length&&(ye+=(0,w.$af)(W.badge,ye)),W.badge.length>ye)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Ct.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ye,Le){this.badge=W,this.tooltip=ye,this.color=Le}}e.$RL=bn;let zi=class{constructor(W){this.kind=W}};e.$SL=zi,e.$SL=zi=He([C],zi);var mi;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(mi||(e.ColorThemeKind=mi={}));class xt{static isNotebookRange(W){return W instanceof xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,ye){if(W<0)throw(0,F.$6)("start must be positive");if(ye<0)throw(0,F.$6)("end must be positive");W<=ye?(this.c=W,this.e=ye):(this.c=ye,this.e=W)}with(W){let ye=this.c,Le=this.e;return W.start!==void 0&&(ye=W.start),W.end!==void 0&&(Le=W.end),ye===this.c&&Le===this.e?this:new xt(ye,Le)}}e.$TL=xt;class vi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ye=>vi.isNotebookCellData(ye))}static isNotebookCellData(W){return!0}constructor(W,ye,Le,Qe,et,ot,ht){this.kind=W,this.value=ye,this.languageId=Le,this.mime=Qe,this.outputs=et??[],this.metadata=ot,this.executionSummary=ht,vi.validate(this)}}e.$UL=vi;class en{constructor(W){this.cells=W}}e.$VL=en;class Xt{static isNotebookCellOutputItem(W){return W instanceof Xt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ye={name:W.name,message:W.message,stack:W.stack};return Xt.json(ye,"application/vnd.code.notebook.error")}static stdout(W){return Xt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Xt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ye="application/octet-stream"){return new Xt(W,ye)}static#e=new TextEncoder;static text(W,ye=R.$Sr.text){const Le=Xt.#e.encode(String(W));return new Xt(Le,ye)}static json(W,ye="text/x-json"){const Le=JSON.stringify(W,void 0,"	");return Xt.text(Le,ye)}constructor(W,ye){this.data=W,this.mime=ye;const Le=(0,R.$Wr)(ye,!0);if(!Le)throw new Error(`INVALID mime type: ${ye}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$WL=Xt;class yi{static isNotebookCellOutput(W){return W instanceof yi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ye=!1){const Le=new Set,Qe=new Set;for(let et=0;et<W.length;et++){const ot=W[et],ht=(0,R.$Wr)(ot.mime);if(!Le.has(ht)||(0,S.$zI)(ht)){Le.add(ht);continue}Qe.add(et),ye&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Qe.size===0?W:W.filter((et,ot)=>!Qe.has(ot))}constructor(W,ye,Le){this.items=yi.ensureUniqueMimeTypes(W,!0),typeof ye=="string"?(this.id=ye,this.metadata=Le):(this.id=(0,A.$fg)(),this.metadata=ye??Le)}}e.$XL=yi;var tn;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var Ei;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class sn{constructor(W,ye){this.text=W,this.alignment=ye}}e.$YL=sn;var je;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(je||(e.NotebookControllerAffinity=je={}));var _t;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class on{constructor(W,ye=[]){this.uri=W,this.provides=(0,I.$2b)(ye)}}e.$ZL=on;class $t{constructor(W){this.label=W}}e.$1L=$t;let Ui=class{constructor(W,ye){this.label=W,this.timestamp=ye}};e.$2L=Ui,e.$2L=Ui=He([C],Ui);var an;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var Bi;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var cn;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class ki{constructor(W,ye){this.ranges=W,this.wordPattern=ye}}e.$3L=ki;class wn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$4L=wn;var un;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let Si=class{constructor(W=void 0,ye=void 0,Le=void 0,Qe=!1){this.include=W,this.exclude=ye,this.profile=Le,this.continuous=Qe}};e.$5L=Si,e.$5L=Si=He([C],Si);let Wi=b=class{static diff(W,ye,Le){const Qe=new b(W);return Qe.expectedOutput=ye,Qe.actualOutput=Le,Qe}constructor(W){this.message=W}};e.$6L=Wi,e.$6L=Wi=b=He([C],Wi);let qi=class{constructor(W){this.id=W}};e.$7L=qi,e.$7L=qi=He([C],qi);let ci=class{constructor(W,ye){this.covered=W,this.total=ye}};e.$8L=ci,e.$8L=ci=He([C],ci);let Vi=v=class{static fromDetails(W,ye){const Le=new ci(0,0),Qe=new ci(0,0),et=new ci(0,0);for(const ht of ye)if("branches"in ht){Le.total+=1,Le.covered+=ht.executionCount>0?1:0;for(const jt of ht.branches)Qe.total+=1,Qe.covered+=jt.executionCount>0?1:0}else et.total+=1,et.covered+=ht.executionCount>0?1:0;const ot=new v(W,Le,Qe.total>0?Qe:void 0,et.total>0?et:void 0);return ot.detailedCoverage=ye,ot}constructor(W,ye,Le,Qe){this.uri=W,this.statementCoverage=ye,this.branchCoverage=Le,this.functionCoverage=Qe}};e.$9L=Vi,e.$9L=Vi=v=He([C],Vi);let Ki=class{constructor(W,ye,Le=[]){this.executionCount=W,this.location=ye,this.branches=Le}};e.$0L=Ki,e.$0L=Ki=He([C],Ki);let Hi=class{constructor(W,ye){this.executionCount=W,this.location=ye}};e.$$L=Hi,e.$$L=Hi=He([C],Hi);let Gi=class{constructor(W,ye){this.executionCount=W,this.location=ye}};e.$_L=Gi,e.$_L=Gi=He([C],Gi);var hn;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(hn||(e.ExternalUriOpenerPriority=hn={}));var dn;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(dn||(e.WorkspaceTrustState=dn={}));var fn;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(fn||(e.PortAutoForwardAction=fn={}));class ve{constructor(W,ye,Le,Qe,et,ot){this.kind=W,this.name=ye,this.detail=Le,this.uri=Qe,this.range=et,this.selectionRange=ot}}e.$aM=ve;class De{constructor(W){this.uri=W}}e.$bM=De;class Ne{constructor(W,ye){this.original=W,this.modified=ye}}e.$cM=Ne;class st{constructor(W,ye,Le,Qe){this.base=W,this.input1=ye,this.input2=Le,this.result=Qe}}e.$dM=st;class wt{constructor(W,ye){this.uri=W,this.viewType=ye}}e.$eM=wt;class Mt{constructor(W){this.viewType=W}}e.$fM=Mt;class Pn{constructor(W,ye){this.uri=W,this.notebookType=ye}}e.$gM=Pn;class An{constructor(W,ye,Le){this.original=W,this.modified=ye,this.notebookType=Le}}e.$hM=An;class Ln{constructor(){}}e.$iM=Ln;class Rn{constructor(W,ye){this.uri=W,this.inputBoxUri=ye}}e.$jM=Rn;class Mn{constructor(W){this.providerId=W}}e.$kM=Mn;var pn;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var vn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(vn||(e.InteractiveSessionCopyKind=vn={}));var yn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(K){K[K.System=0]="System",K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var kn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(kn||(e.ChatVariableLevel=kn={}));class Fn{constructor(W,ye){this.role=W,this.content=ye}}e.$lM=Fn;var Sn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(Sn||(e.ChatAgentResultFeedbackKind=Sn={}));var Dn;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var Cn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped"})(Cn||(e.SpeechToTextStatus=Cn={}))}),define(ke[143],Se([1,0,60,17,13,176,127,7,19]),function(me,e,I,F,m,L,R,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=e.$zM=e.$yM=void 0;const g=new Map;function A(S,p){p?g.set(S,p):g.delete(S)}e.$yM=A;function P(S){return g.get(S)}class f extends L.$Yu{constructor(p,c,s,i,n,o,a,t){super(c,s,i,n),this.c=p,this.m=o,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(p){return(0,E.$tb)(this.f,p)}get document(){if(!this.a){const p=this;this.a={get uri(){return p.d},get fileName(){return p.d.fsPath},get isUntitled(){return p.d.scheme===F.Schemas.untitled},get languageId(){return p.m},get version(){return p.h},get isClosed(){return p.b},get isDirty(){return p.q},save(){return p.r()},getText(c){return c?p.s(c):p.getText()},get eol(){return p.g===`
`?w.EndOfLine.LF:w.EndOfLine.CRLF},get lineCount(){return p.f.length},lineAt(c){return p.t(c)},offsetAt(c){return p.u(c)},positionAt(c){return p.v(c)},validateRange(c){return p.w(c)},validatePosition(c){return p.x(c)},getWordRangeAtPosition(c,s){return p.y(c,s)}}}return Object.freeze(this.a)}_acceptLanguageId(p){(0,I.ok)(!this.b),this.m=p}_acceptIsDirty(p){(0,I.ok)(!this.b),this.q=p}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(p){const c=this.w(p);if(c.isEmpty)return"";if(c.isSingleLine)return this.f[c.start.line].substring(c.start.character,c.end.character);const s=this.g,i=c.start.line,n=c.end.line,o=[];o.push(this.f[i].substring(c.start.character));for(let a=i+1;a<n;a++)o.push(this.f[a]);return o.push(this.f[n].substring(0,c.end.character)),o.join(s)}t(p){let c;if(p instanceof w.$xK?c=p.line:typeof p=="number"&&(c=p),typeof c!="number"||c<0||c>=this.f.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new y(c,this.f[c],c===this.f.length-1)}u(p){return p=this.x(p),this.l(),this.j.getPrefixSum(p.line-1)+p.character}v(p){p=Math.floor(p),p=Math.max(0,p),this.l();const c=this.j.getIndexOf(p),s=this.f[c.index].length;return new w.$xK(c.index,Math.min(c.remainder,s))}w(p){if(!(p instanceof w.$yK))throw new Error("Invalid argument");const c=this.x(p.start),s=this.x(p.end);return c===p.start&&s===p.end?p:new w.$yK(c.line,c.character,s.line,s.character)}x(p){if(!(p instanceof w.$xK))throw new Error("Invalid argument");if(this.f.length===0)return p.with(0,0);let{line:c,character:s}=p,i=!1;if(c<0)c=0,s=0,i=!0;else if(c>=this.f.length)c=this.f.length-1,s=this.f[c].length,i=!0;else{const n=this.f[c].length;s<0?(s=0,i=!0):s>n&&(s=n,i=!0)}return i?new w.$xK(c,s):p}y(p,c){const s=this.x(p);if(!c)c=P(this.m);else if((0,m.$Pe)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const i=(0,R.$$r)(s.character+1,(0,R.$9r)(c),this.f[s.line],0);if(i)return new w.$yK(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.$zM=f;class y{constructor(p,c,s){this.a=p,this.b=c,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new w.$yK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new w.$yK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$AM=y}),define(ke[286],Se([1,0,7,20,4]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=void 0;let L=class{constructor(w){this.a=new I.$SL(I.ColorThemeKind.Dark),this.b=new m.$Od}get activeColorTheme(){return this.a}$onColorThemeChange(w){let E;switch(w){case"light":E=I.ColorThemeKind.Light;break;case"hcDark":E=I.ColorThemeKind.HighContrast;break;case"hcLight":E=I.ColorThemeKind.HighContrastLight;break;default:E=I.ColorThemeKind.Dark}this.a=new I.$SL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Kec=L,e.$Kec=L=He([Be(0,F.$wM)],L)}),define(ke[287],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DI=e.CellExecutionUpdateType=void 0;var F;(function(m){m[m.Output=1]="Output",m[m.OutputItems=2]="OutputItems",m[m.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$DI=(0,I.$Sh)("INotebookExecutionService")}),define(ke[288],Se([1,0,3,29,193,99]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DOb=void 0;class R extends I.$Rc{constructor(E,g,A){super(),this._source=E,this.b=g,this.c=A,this.a=void 0}f(E){const g=E.getLineCount();return new F.$ws(1,1,g,this.g(E,g))}g(E,g){if(g<1||g>E.getLineCount())throw new Error("Illegal value for lineNumber");return E.getLineLength(g)+1}get inputTextBuffer(){if(!this.b){const E=new m.$JB;E.acceptChunk(this._source);const g=E.finish(!0),{textBuffer:A,disposable:P}=g.create(1);this.b=A,this.B(P)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(E=>{const g=new m.$JB;g.acceptChunk(E);const A=g.finish(!0),{textBuffer:P,disposable:f}=A.create(1);return this.B(f),P})),this.a}findInInputs(E){const A=new L.$xB(E,!1,!1,null).parseSearchRequest();if(!A)return[];const P=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(P,A,!0,5e3)}findInOutputs(E){const A=new L.$xB(E,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(P=>{const f=P.findMatchesLineByLine(this.f(P),A,!0,5e3);if(f.length!==0)return{textBuffer:P,matches:f}}).filter(P=>!!P):[]}}e.$DOb=R}),define(ke[68],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kJ=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(L){L.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var F;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class m{static fromExtHostTestItem(R,w,E=R.parent){if(R._isRoot)return new m([w]);const g=[R.id];for(let A=E;A&&A.id!==w;A=A.parent)g.push(A.id);return g.push(w),new m(g.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const w=R.indexOf("\0");return w===-1?R:R.slice(0,w)}static fromString(R){return new m(R.split("\0"))}static join(R,w){return new m([...R.path,w])}static joinToString(R,w){return R.toString()+"\0"+w}static parentId(R){const w=R.lastIndexOf("\0");return w===-1?void 0:R.slice(0,w)}static localId(R){const w=R.lastIndexOf("\0");return w===-1?R:R.slice(w+1)}static isChild(R,w){return w.startsWith(R)&&w[R.length]==="\0"}static compare(R,w){return R===w?0:m.isChild(R,w)?2:m.isChild(w,R)?3:1}constructor(R,w=R.length){if(this.path=R,this.d=w,R.length===0||w<1)throw new Error("cannot create test with empty path")}get rootId(){return new m(this.path,1)}get parentId(){return this.d>1?new m(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new m(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new m(this.path,R)}compare(R){if(typeof R=="string")return m.compare(this.toString(),R);for(let w=0;w<R.d&&w<this.d;w++)if(R.path[w]!==this.path[w])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$kJ=m}),define(ke[89],Se([1,0,2,29,68]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$qJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$pJ=e.$oJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$nJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$mJ=e.$lJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(D){D[D.Unset=0]="Unset",D[D.Queued=1]="Queued",D[D.Running=2]="Running",D[D.Passed=3]="Passed",D[D.Failed=4]="Failed",D[D.Skipped=5]="Skipped",D[D.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var R;(function(D){D[D.Run=1]="Run",D[D.Debug=2]="Debug",D[D.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var w;(function(D){D[D.Run=2]="Run",D[D.Debug=4]="Debug",D[D.Coverage=8]="Coverage",D[D.HasNonDefaultProfile=16]="HasNonDefaultProfile",D[D.HasConfigurable=32]="HasConfigurable",D[D.SupportsContinuousRun=64]="SupportsContinuousRun"})(w||(e.TestRunProfileBitset=w={})),e.$lJ=[2,4,8,16,32,64];const E=D=>"runId"in D;e.$mJ=E;var g;(function(D){D.serialize=$=>({range:$.range.toJSON(),uri:$.uri.toJSON()}),D.deserialize=$=>({range:F.$ws.lift($.range),uri:I.URI.revive($.uri)})})(g||(e.IRichLocation=g={}));var A;(function(D){D[D.Error=0]="Error",D[D.Output=1]="Output"})(A||(e.TestMessageType=A={}));var P;(function(D){D.serialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&g.serialize($.location)}),D.deserialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&g.deserialize($.location)})})(P||(e.ITestErrorMessage=P={}));const f=(D,$)=>`${$?"s":"e"}${D}`;e.$nJ=f;var y;(function(D){D.serialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&g.serialize($.location)}),D.deserialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&g.deserialize($.location)})})(y||(e.ITestOutputMessage=y={}));var S;(function(D){D.serialize=$=>$.type===0?P.serialize($):y.serialize($),D.deserialize=$=>$.type===0?P.deserialize($):y.deserialize($)})(S||(e.ITestMessage=S={}));var p;(function(D){D.serializeWithoutMessages=$=>({state:$.state,duration:$.duration,messages:[]}),D.serialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(S.serialize)}),D.deserialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(S.deserialize)})})(p||(e.ITestTaskState=p={}));const c="\0",s=(D,$)=>D+c+$;e.$oJ=s;const i=D=>{const $=D.indexOf(c);return{ctrlId:D.slice(0,$),tagId:D.slice($+1)}};e.$pJ=i;var n;(function(D){D.serialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?.toJSON(),range:$.range?.toJSON()||null,description:$.description,error:$.error,sortText:$.sortText}),D.deserialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?I.URI.revive($.uri):void 0,range:$.range?F.$ws.lift($.range):null,description:$.description,error:$.error,sortText:$.sortText})})(n||(e.ITestItem=n={}));var o;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var a;(function(D){D.serialize=$=>({expand:$.expand,item:n.serialize($.item)}),D.deserialize=$=>({controllerId:m.$kJ.root($.item.extId),expand:$.expand,item:n.deserialize($.item)})})(a||(e.InternalTestItem=a={}));var t;(function(D){D.serialize=$=>{let b;return $.item&&(b={},$.item.label!==void 0&&(b.label=$.item.label),$.item.tags!==void 0&&(b.tags=$.item.tags),$.item.busy!==void 0&&(b.busy=$.item.busy),$.item.uri!==void 0&&(b.uri=$.item.uri?.toJSON()),$.item.range!==void 0&&(b.range=$.item.range?.toJSON()),$.item.description!==void 0&&(b.description=$.item.description),$.item.error!==void 0&&(b.error=$.item.error),$.item.sortText!==void 0&&(b.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:b}},D.deserialize=$=>{let b;return $.item&&(b={},$.item.label!==void 0&&(b.label=$.item.label),$.item.tags!==void 0&&(b.tags=$.item.tags),$.item.busy!==void 0&&(b.busy=$.item.busy),$.item.range!==void 0&&(b.range=$.item.range?F.$ws.lift($.item.range):null),$.item.description!==void 0&&(b.description=$.item.description),$.item.error!==void 0&&(b.error=$.item.error),$.item.sortText!==void 0&&(b.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:b}}})(t||(e.ITestItemUpdate=t={}));const r=(D,$)=>{$.expand!==void 0&&(D.expand=$.expand),$.item!==void 0&&(D.item=D.item?Object.assign(D.item,$.item):$.item)};e.$qJ=r;var d;(function(D){D.serializeWithoutMessages=$=>({...a.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(p.serializeWithoutMessages)}),D.serialize=$=>({...a.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(p.serialize)}),D.deserialize=$=>({...a.deserialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(p.deserialize),retired:!0})})(d||(e.TestResultItem=d={}));var u;(function(D){D[D.Function=0]="Function",D[D.Statement=1]="Statement"})(u||(e.DetailType=u={}));var l;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.DocumentSynced=2]="DocumentSynced",D[D.Remove=3]="Remove",D[D.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",D[D.Retire=5]="Retire",D[D.AddTag=6]="AddTag",D[D.RemoveTag=7]="RemoveTag"})(l||(e.TestDiffOpType=l={}));var h;(function(D){D.deserialize=$=>$.op===0?{op:$.op,item:a.deserialize($.item)}:$.op===1?{op:$.op,item:t.deserialize($.item)}:$.op===2?{op:$.op,uri:I.URI.revive($.uri),docv:$.docv}:$,D.serialize=$=>$.op===0?{op:$.op,item:a.serialize($.item)}:$.op===1?{op:$.op,item:t.serialize($.item)}:$})(h||(e.TestsDiffOp=h={}));class k{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply($){const b=this.o();for(const v of $)switch(v.op){case 0:this.j(a.deserialize(v.item),b);break;case 1:this.k(t.deserialize(v.item),b);break;case 3:this.l(v.itemId,b);break;case 5:this.m(v.itemId);break;case 4:this.updatePendingRoots(v.amount);break;case 6:this.c.set(v.tag.id,v.tag);break;case 7:this.c.delete(v.id);break}b.complete?.()}j($,b){const v=m.$kJ.parentId($.item.extId)?.toString();let C;if(!v)C=this.p($),this.f.add(C),this.d.set($.item.extId,C);else if(this.d.has(v)){const N=this.d.get(v);N.children.add($.item.extId),C=this.p($,N),this.d.set($.item.extId,C)}else{console.error(`Test with unknown parent ID: ${JSON.stringify($)}`);return}return b.add?.(C),$.expand===2&&this.g++,C}k($,b){const v=this.d.get($.extId);if(v)return $.expand!==void 0&&(v.expand===2&&this.g--,$.expand===2&&this.g++),(0,e.$qJ)(v,$),b.update?.(v),v}l($,b){const v=this.d.get($);if(!v)return;const C=m.$kJ.parentId(v.item.extId)?.toString();C?this.d.get(C).children.delete(v.item.extId):this.f.delete(v);const N=[[$]];for(;N.length;)for(const z of N.pop()){const M=this.d.get(z);M&&(N.push(M.children),this.d.delete(z),b.remove?.(M,M!==v),M.expand===2&&this.g--)}}m($){}updatePendingRoots($){this.h+=$}o(){return{}}}e.$rJ=k}),define(ke[112],Se([1,0,10,4,3,60,89,68]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.TestItemEventOp=void 0;var E;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const g=(i,n)=>i===n,P=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:g,label:g,description:g,error:g,sortText:g,tags:(i,n)=>!(i.length!==n.length||i.some(o=>!n.includes(o)))}),f=(i,n)=>{let o;for(const[a,t]of P)t(i[a],n[a])||(o?o[a]=n[a]:o={[a]:n[a]});return o};class y extends m.$Rc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new I.$7g(()=>this.flushDiff(),200)),this.g=this.B(new F.$Od),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.I(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===n.uri){o.docv=n.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===n.item.extId){(0,R.$qJ)(o.item,n.item);return}if(o.op===0&&o.item.item.extId===n.item.extId){(0,R.$qJ)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||o>a.expandLevels)&&(a.expandLevels=o),a.expand===1){const t=this.L(a);return t.isOpen()?this.J(a,o-1):t.wait().then(()=>this.J(a,o-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.J(a,o-1)):this.J(a,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(n,o){switch(o.op){case 3:this.N(w.$kJ.joinToString(n.fullId,o.id));break;case 0:this.y(o.item,n);break;case 5:for(const a of o.ops)this.u(n,a);break;case 1:this.z(o.new,o.old,n.fullId.toString());break;case 2:this.I(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:o.update}});break;case 6:this.w(n.actual.uri);break;default:(0,L.$3c)(o)}}w(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}y(n,o){const a=w.$kJ.fromExtHostTestItem(n,this.root.id,o?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==o?.actual&&this.s.getChildren(t.parent).delete(n.id);let r=this.tree.get(a.toString());if(!r){r={fullId:a,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},n.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(n,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(n)}}),this.H(n,r,o);return}if(r.actual===n){this.G(n,r,o);return}if(r.actual.uri?.toString()!==n.uri?.toString())return this.N(a.toString()),this.y(n,o);const d=this.s.getChildren(r.actual),u=r.actual,l=f(this.s.toITestItem(u),this.s.toITestItem(n));this.s.getApiFor(u).listener=void 0,r.actual=n,r.expand=0,l&&(l.hasOwnProperty("tags")&&(this.z(n.tags,u.tags,a.toString()),delete l.tags),this.u(r,{op:4,update:l})),this.H(n,r,o);for(const[h,k]of d)this.s.getChildren(n).get(k.id)||this.N(w.$kJ.joinToString(a,k.id));this.w(r.actual.uri)}z(n,o,a){const t=new Set(o.map(r=>r.id));for(const r of n)t.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(r=>(0,R.$oJ)(this.s.controllerId,r.id))}}}),t.forEach(this.D,this)}C(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$oJ)(this.s.controllerId,n.id)}}))}D(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$oJ)(this.s.controllerId,n)}))}F(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}G(n,o,a){this.F(n,a);const t=this.s.getApiFor(n);t.parent=a?.actual,t.listener=r=>this.u(o,r),this.I(o)}H(n,o,a){this.G(n,o,a);for(const[t,r]of this.s.getChildren(n))this.y(r,o)}I(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?3:2:o=n.actual.canResolveChildren?1:0:o=0,o!==n.expand&&(n.expand=o,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:o}}),o===1&&n.expandLevels!==void 0&&this.L(n))}J(n,o){if(o<0)return;const a=[];for(const[t,r]of this.s.getChildren(n.actual)){const d=this.expand(w.$kJ.joinToString(n.fullId,r.id),o);(0,I.$Hg)(d)&&a.push(d)}if(a.length)return Promise.all(a).then(()=>{})}L(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const r=new I.$Tg;return r.open(),r}n.expand=2,this.M(n);const o=n.resolveBarrier=new I.$Tg,a=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(r){a(r)}return(0,I.$Hg)(t)?t.catch(a).then(()=>{o.open(),this.I(n)}):(o.open(),this.I(n)),n.resolveBarrier}M(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}N(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[o];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.D(r.id);this.tree.delete(t.fullId.toString());for(const[r,d]of this.s.getChildren(t.actual))a.push(this.tree.get(w.$kJ.joinToString(t.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$mM=y;class S extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$nM=S;class p extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$oM=p;class c extends Error{constructor(n,o,a){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${a}".`)}}e.$pM=c;const s=(i,n,o)=>{let a=new Map;return{get size(){return a.size},forEach(t,r){for(const d of a.values())t.call(r,d,this)},[Symbol.iterator](){return a.entries()},replace(t){const r=new Map,d=new Set(a.keys()),u={op:5,ops:[]};for(const l of t){if(!(l instanceof o))throw new p(l.id);const h=n(l).controllerId;if(h!==i.controllerId)throw new c(l.id,h,i.controllerId);if(r.has(l.id))throw new S(l.id);r.set(l.id,l),d.delete(l.id),u.ops.push({op:0,item:l})}for(const l of d.keys())u.ops.push({op:3,id:l});i.listener?.(u),a=r},add(t){if(!(t instanceof o))throw new p(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$qM=s}),define(ke[144],Se([1,0,112]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0;const F=new WeakMap,m=(R,w)=>{const E={controllerId:w};return F.set(R,E),E};e.$rM=m;const L=R=>{const w=F.get(R);if(!w)throw new I.$oM(R?.id||"<unknown>");return w};e.$sM=L}),define(ke[113],Se([1,0,17,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7tb=e.$6tb=e.$5tb=e.$4tb=e.$3tb=void 0,e.$3tb="vscode-cdn.net",e.$4tb=`vscode-resource.${e.$3tb}`,e.$5tb=`'self' https://*.${e.$3tb}`;function m(w,E){return w.scheme===I.Schemas.http||w.scheme===I.Schemas.https?w:(E&&E.authority&&E.isRemote&&w.scheme===I.Schemas.file&&(w=F.URI.from({scheme:I.Schemas.vscodeRemote,authority:E.authority,path:w.path})),F.URI.from({scheme:I.Schemas.https,authority:`${w.scheme}+${L(w.authority)}.${e.$4tb}`,path:w.path,fragment:w.fragment,query:w.query}))}e.$6tb=m;function L(w){return w.replace(/./g,E=>{const g=E.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?E:"-"+g.toString(16).padStart(4,"0")})}function R(w){return w.replace(/-([0-9a-f]{4})/g,(E,g)=>String.fromCharCode(parseInt(g,16)))}e.$7tb=R}),define(ke[289],Se([1,0,4,3,113]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;class L{constructor(w,E,g){this.d=w,this.e=E,this.f=g,this.a=0,this.b=new F.$Qc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const A=E.getVisibleTextEditors();for(const P of this.c.values())A.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(w=>w.inset.dispose()),this.b.dispose()}createWebviewEditorInset(w,E,g,A,P){let f;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===w){f=n;break}if(!f)throw new Error("not a visible editor");const y=this,S=this.a++,p=new I.$Od,c=new I.$Od,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,m.$6tb)(n,y.f)}get cspSource(){return m.$5tb}set options(n){this.b=n,y.d.$setOptions(S,n)}get options(){return this.b}set html(n){this.a=n,y.d.$setHtml(S,n)}get html(){return this.a}get onDidReceiveMessage(){return p.event}postMessage(n){return y.d.$postMessage(S,n)}},i=new class{constructor(){this.editor=w,this.line=E,this.height=g,this.webview=s,this.onDidDispose=c.event}dispose(){y.c.has(S)&&(y.c.delete(S),y.d.$disposeEditorInset(S),c.fire(),c.dispose(),p.dispose())}};return this.d.$createEditorInset(S,f.id,f.value.document.uri,E+1,g,A||{},P.identifier,P.extensionLocation),this.c.set(S,{editor:w,inset:i,onDidReceiveMessage:p}),i}$onDidDispose(w){const E=this.c.get(w);E&&E.inset.dispose()}$onDidReceiveMessage(w,E){this.c.get(w)?.onDidReceiveMessage.fire(E)}}e.$iec=L}),define(ke[290],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jN=e.VariableKind=e.$iN=void 0,e.$iN=(0,I.$Sh)("configurationResolverService");var F;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class m extends Error{constructor(R,w){super(w),this.variable=R}}e.$jN=m}),define(ke[291],Se([1,0,16,49,18,24,12,102,233,290,13]),function(me,e,I,F,m,L,R,w,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=void 0;class P{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,S,p,c){this.h=new Map,this.a=y,this.b=S,this.g=p,c&&(this.c=c.then(s=>this.i(s)))}i(y){if(R.$i){const S=Object.create(null);return Object.keys(y).forEach(p=>{S[p.toLowerCase()]=y[p]}),S}return y}resolveWithEnvironment(y,S,p){return this.l({env:this.i(y),userHome:void 0},S?S.uri:void 0,p)}async resolveAsync(y,S){const p={env:await this.c,userHome:await this.g};return this.l(p,y?y.uri:void 0,S)}async j(y,S,p,c){const s=L.$0m(S);R.$i&&s.windows?Object.keys(s.windows).forEach(n=>s[n]=s.windows[n]):R.$j&&s.osx?Object.keys(s.osx).forEach(n=>s[n]=s.osx[n]):R.$k&&s.linux&&Object.keys(s.linux).forEach(n=>s[n]=s.linux[n]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,y?y.uri:void 0,s,p,c)}async resolveAnyAsync(y,S,p){return this.j(y,S,p)}async resolveAnyMap(y,S,p){const c=new Map;return{newConfig:await this.j(y,S,p,c),resolvedVariables:c}}resolveWithInteractionReplace(y,S,p,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,S,p,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,S){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,S)}async l(y,S,p,c,s){if(m.$zf(p))return this.m(y,S,p,c,s);if(Array.isArray(p))return Promise.all(p.map(i=>this.l(y,S,i,c,s)));if(m.$Bf(p)){const i=Object.create(null),n=await Promise.all(Object.keys(p).map(async o=>[await this.m(y,S,o,c,s),await this.l(y,S,p[o],c,s)]));for(const[o,a]of n)i[o]=a;return i}return p}m(y,S,p,c,s){return(0,A.$Ue)(p,P.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(P.VARIABLE_LHS))return i;let o=await this.o(y,i,n,S,c);return s?.set(n,o),o!==i&&m.$zf(o)&&o.match(P.VARIABLE_REGEXP)&&(o=await this.m(y,S,o,c,s)),o})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,S,p,c,s){let i;const n=p.split(":");n.length>1&&(p=n[0],i=n[1]);const o=r=>{const d=this.a.getFilePath();if(d)return(0,w.$vv)(d);throw new g.$jN(r,(0,E.localize)(0,null,S))},a=r=>{const d=o(r);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,w.$vv)(u)}throw new g.$jN(r,(0,E.localize)(1,null,S,I.$mc(d)))},t=r=>{if(i){const d=this.a.getFolderUri(i);if(d)return d;throw new g.$jN(r,(0,E.localize)(2,null,S,i))}if(c)return c;throw this.a.getWorkspaceFolderCount()>1?new g.$jN(r,(0,E.localize)(3,null,S)):new g.$jN(r,(0,E.localize)(4,null,S))};switch(p){case"env":if(i){if(y.env){const r=y.env[R.$i?i.toLowerCase():i];if(m.$zf(r))return r}return""}throw new g.$jN(g.VariableKind.Env,(0,E.localize)(5,null,S));case"config":if(i){const r=this.a.getConfigurationValue(c,i);if(m.$If(r))throw new g.$jN(g.VariableKind.Config,(0,E.localize)(6,null,S,i));if(m.$Bf(r))throw new g.$jN(g.VariableKind.Config,(0,E.localize)(7,null,S,i));return r}throw new g.$jN(g.VariableKind.Config,(0,E.localize)(8,null,S));case"command":return this.p(g.VariableKind.Command,S,i,s,"command");case"input":return this.p(g.VariableKind.Input,S,i,s,"input");case"extensionInstallFolder":if(i){const r=await this.a.getExtension(i);if(!r)throw new g.$jN(g.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,S,i));return this.n(r.extensionLocation)}throw new g.$jN(g.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,S));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,w.$vv)(this.n(t(g.VariableKind.WorkspaceFolder)));case"cwd":return c||i?(0,w.$vv)(this.n(t(g.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,w.$vv)(I.$mc(this.n(t(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new g.$jN(g.VariableKind.UserHome,(0,E.localize)(11,null,S))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new g.$jN(g.VariableKind.LineNumber,(0,E.localize)(12,null,S))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new g.$jN(g.VariableKind.SelectedText,(0,E.localize)(13,null,S))}case"file":return o(g.VariableKind.File);case"fileWorkspaceFolder":return a(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return c||i?I.$kc(this.n(t(g.VariableKind.RelativeFile)),o(g.VariableKind.RelativeFile)):o(g.VariableKind.RelativeFile);case"relativeFileDirname":{const r=I.$lc(o(g.VariableKind.RelativeFileDirname));if(c||i){const d=I.$kc(this.n(t(g.VariableKind.RelativeFileDirname)),r);return d.length===0?".":d}return r}case"fileDirname":return I.$lc(o(g.VariableKind.FileDirname));case"fileExtname":return I.$nc(o(g.VariableKind.FileExtname));case"fileBasename":return I.$mc(o(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=I.$mc(o(g.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-I.$nc(r).length)}case"fileDirnameBasename":return I.$mc(I.$lc(o(g.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||S}case"execInstallFolder":{const r=this.a.getAppRoot();return r||S}case"pathSeparator":return I.sep;default:try{const r=i?`${p}:${i}`:p;return this.p(g.VariableKind.Unknown,S,r,s,void 0)}catch{return S}}}}p(y,S,p,c,s){if(p&&c){const i=s===void 0?c[p]:c[s+":"+p];if(typeof i=="string")return i;throw new g.$jN(y,(0,E.localize)(14,null,S))}return S}}e.$xN=P}),define(ke[145],Se([1,0,5,141]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FC=e.$EC=e.OpenEditorContext=e.GroupsOrder=e.$DC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$CC=void 0,e.$CC=(0,I.$Sh)("editorGroupsService");var m;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(m||(e.GroupDirection=m={}));var L;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var w;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(w||(e.GroupsArrangement=w={}));var E;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function g(S){const p=S;return(0,F.$kE)(p?.editor)&&(0,F.$kE)(p?.replacement)}e.$DC=g;var A;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var P;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function f(S){const p=S;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.$EC=f;function y(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$FC=y}),define(ke[292],Se([1,0,5,145]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=e.$IC=e.$HC=e.$GC=void 0,e.$GC=(0,I.$Sh)("editorService"),e.$HC=-1,e.$IC=-2;function m(L){const R=L;return typeof L=="number"||(0,F.$EC)(R)}e.$JC=m}),define(ke[146],Se([1,0,5,134]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OJ=void 0,e.$OJ=(0,I.$Th)(F.$Zh)}),define(ke[147],Se([1,0,26,4,16,3]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r5b=e.$q5b=e.$p5b=e.$o5b=e.$n5b=void 0;class R{constructor(s,i){this.versionId=s,this.removedDueToLooping=i}}e.$n5b=R;class w{static isHostExtension(s,i,n){if(i.getExtensionDescription(s))return!1;const o=n.getExtensionDescription(s);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(s,i){this.j=s,this.c=new F.$Od,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(S),this.f=new I.$$l,this.g=[],this.h=new Map;for(const s of this.e){if(this.f.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this.f.set(s.identifier,s),this.g.push(s);const i=this.j.readActivationEvents(s);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(s)}}set(s){return this.e=s,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(s,i){this.e=p(this.e,i),this.e=this.e.concat(s);const n=w.l(this.e);return this.e=p(this.e,n.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,n)}static l(s){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,d){this.addNode(r),this.addNode(d),this.c.has(r)?this.c.get(r).push(d):this.c.set(r,[d])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,d){const u=i.getArcs(r);for(let l=0;l<u.length;l++)if(!d.has(u[l]))return!1;return!0}getNodes(){return this.e}},n=new I.$$l;for(const r of s)if(n.set(r.identifier,r),r.extensionDependencies)for(const d of r.extensionDependencies)i.addArc(I.$9l.toKey(r.identifier),I.$9l.toKey(d));const o=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>o.add(r));const a=i.getNodes().filter(r=>!o.has(r));let t;do{t=!1;for(let r=0;r<a.length;r++){const d=a[r];i.hasOnlyGoodArcs(d,o)&&(a.splice(r,1),r--,o.add(d),t=!0)}}while(t);return a.map(r=>n.get(r))}containsActivationEvent(s){return this.h.has(s)}containsExtension(s){return this.f.has(s)}getExtensionDescriptionsForActivationEvent(s){const i=this.h.get(s);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(s){const i=this.f.get(s);return i||void 0}getExtensionDescriptionByUUID(s){for(const i of this.g)if(i.uuid===s)return i}getExtensionDescriptionByIdOrUUID(s,i){return this.getExtensionDescription(s)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$o5b=w;class E{constructor(s,i){this.versionId=s,this.extensions=i}}e.$p5b=E;class g{constructor(s){this.d=new f,this.c=new w(s,[])}async acquireLock(s){const i=await this.d.acquire(s);return new A(this,i)}deltaExtensions(s,i,n){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(s){return this.c.containsActivationEvent(s)}containsExtension(s){return this.c.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this.c.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(s){return this.c.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this.c.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,i){return this.c.getExtensionDescriptionByIdOrUUID(s,i)}}e.$q5b=g;class A extends L.$Rc{constructor(s,i){super(),this.f=s,this.c=!1,this.B(i)}isAcquiredFor(s){return!this.c&&this.f===s}}e.$r5b=A;class P{constructor(s){this.name=s,this.promise=new Promise((i,n)=>{this.c=i})}resolve(s){this.c(s)}}class f{constructor(){this.c=[],this.d=!1}async acquire(s){const i=new P(s);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const s=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};s.resolve((0,L.$Pc)(o))}}var y;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(y||(y={}));function S(c,s){const i=c.isBuiltin?0:c.isUnderDevelopment?2:1,n=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(i!==n)return i-n;const o=m.$fc.basename(c.extensionLocation.path),a=m.$fc.basename(s.extensionLocation.path);return o<a?-1:o>a?1:0}function p(c,s){const i=new I.$0l(s);return c.filter(n=>!i.has(n.identifier))}}),define(ke[293],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.ExtHostConnectionType=void 0;var I;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(I||(e.ExtHostConnectionType=I={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(P){this.pipeName=P,this.type=1}serialize(P){P[F.ENV_KEY]=this.pipeName}}e.$Am=F;class m{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(P){P[m.ENV_KEY]="1"}}e.$Bm=m;class L{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(P){P[L.ENV_KEY]="1"}}e.$Cm=L;function R(A){delete A[F.ENV_KEY],delete A[m.ENV_KEY],delete A[L.ENV_KEY]}function w(A,P){R(P),A.serialize(P)}e.$Dm=w;function E(A){if(A[F.ENV_KEY])return g(A,new F(A[F.ENV_KEY]));if(A[m.ENV_KEY])return g(A,new m);if(A[L.ENV_KEY])return g(A,new L);throw new Error("No connection information defined in environment!")}e.$Em=E;function g(A,P){return R(A),P}}),define(ke[114],Se([1,0,22]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$fm=e.$em=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(F||(e.UIKind=F={}));var m;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(m||(e.ExtensionHostExitCode=m={}));var L;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(g){const A=I.$ce.alloc(1);switch(g){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$em=R;function w(g,A){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$fm=w;var E;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(ke[90],Se([1,0,5,4,15,27,114,66,87,24,2,3,219]),function(me,e,I,F,m,L,R,w,E,g,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.$OM=e.$NM=void 0;let y=class extends P.$Rc{constructor(s,i){super(),this.s=s,this.t=i,this.a=this.B(new F.$Od),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$Od),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:E.$ro,name:(0,f.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(i.onDidChangeLogLevel(n=>{(0,m.$cj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===m.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,i,n){const o=this.getTelemetryDetails(),a=new S(i,n,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(s,i,n){this.f=s,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=p(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,w.$Yk)((0,E.$yo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const i=this.getTelemetryDetails();this.r.forEach((n,o)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this.r.delete(o):this.r.set(o,a)}),this.r.forEach(n=>{for(const o of n)o.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,i){const o=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!o)return this.r.delete(s.value),!1;let a=!1;for(const t of o)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$NM=y,e.$NM=y=He([Be(0,L.$MM),Be(1,m.$bj)],y);class S{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,n,o,a,t,r){this.g=n,this.h=o,this.i=a,this.j=t,this.a=new F.$Od,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(s,i){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,E.$Bo)(i,[]),this.c&&(i=(0,g.$an)(i,this.c)),this.b||(i=(0,g.$an)(i,this.j)),"properties"in s?s.properties=i:s=i,s}k(s,i){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(s,i),this.h.trace(s,i))}logUsage(s,i){this.d.isUsageEnabled&&this.k(s,i)}logError(s,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,i);else{const n={name:s.name,message:s.message,stack:s.stack,cause:s.cause},o=(0,E.$Bo)(n,[]),a=new Error(o.message,{cause:o.cause});a.stack=o.stack,a.name=o.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$OM=S;function p(c){const s=Date.now()-new Date(c).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$PM=p,e.$QM=(0,I.$Sh)("IExtHostTelemetry")}),define(ke[25],Se([1,0,4,2,263,139,26,5]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zF=e.$yF=e.$xF=e.ActivationKind=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.ExtensionHostStartup=e.$rF=e.$qF=e.$pF=e.$oF=void 0,e.$oF=Object.freeze({identifier:new R.$9l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$pF="extensions.webWorker",e.$qF=(0,w.$Sh)("extensionService");class E{constructor(a){this.dependency=a}}e.$rF=E;var g;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,r){this.c=a,this.d=t.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$_E.createActivationEventsMap(this.d)}}set(a,t,r){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const d=[],u=[],l=[],h=[],k=P(this.d),D=P(t),$=(z,M)=>z.extensionLocation.toString()===M.extensionLocation.toString()||z.isBuiltin===M.isBuiltin||z.isUserBuiltin===M.isUserBuiltin||z.isUnderDevelopment===M.isUnderDevelopment;for(const z of this.d){const M=D.get(z.identifier);if(!M){d.push(z.identifier),k.delete(z.identifier);continue}if(!$(z,M)){d.push(z.identifier),k.delete(z.identifier);continue}}for(const z of t){const M=k.get(z.identifier);if(!M){u.push(z);continue}if(!$(M,z)){d.push(M.identifier),k.delete(M.identifier);continue}}const b=new R.$0l(this.e),v=new R.$0l(r);for(const z of this.e)v.has(z)||l.push(z);for(const z of r)b.has(z)||h.push(z);const C=L.$_E.createActivationEventsMap(u),N={versionId:a,toRemove:d,toAdd:u,addActivationEvents:C,myToRemove:l,myToAdd:h};return this.delta(N),N}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:r,myToRemove:d,myToAdd:u}=a,l=new R.$0l(t),h=new R.$0l(d);for(let k=0;k<this.d.length;k++)l.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)h.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of r)this.d.push(k);for(const k of u)this.e.push(k);return this.f=null,a}containsExtension(a){for(const t of this.e)if(R.$9l.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const r=L.$_E.readActivationEvents(t);for(const d of r)a.add(d)}return a}}e.$sF=A;function P(o){const a=new R.$$l;for(const t of o)a.set(t.identifier,t);return a}function f(o,a){return o.enabledApiProposals?o.enabledApiProposals.includes(a):!1}e.$tF=f;function y(o,a){if(!f(o,a))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$uF=y;class S{constructor(a,t,r,d){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=d}}e.$vF=S;class p{constructor(a,t){this.description=a,this.value=t}}e.$wF=p;var c;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(c||(e.ActivationKind=c={}));function s(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,m.$Ho)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$xF=s;function i(o,a){return{identifier:new R.$9l((0,m.$Fo)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!a,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$yF=i;class n{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$zF=n}),define(ke[294],Se([1,0,11,147,26,25,15,10]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=e.$ydc=e.$xdc=e.$wdc=e.$vdc=e.$udc=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(s,i,n,o){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=o}}e.$udc=E;class g{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,i){return s===-1||i===-1?-1:i-s}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$vdc=g;class A{constructor(s,i,n,o,a,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=n,this.module=o,this.exports=a,this.subscriptions=t}}e.$wdc=A;class P extends A{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$xdc=P;class f extends A{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$ydc=f;class y extends A{constructor(s){super(!0,s,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(s,i,n,o){this.g=o,this.a=s,this.b=i,this.c=n,this.d=new m.$$l,this.f=Object.create(null)}dispose(){for(const[s,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,n]of this.d)s.push(n.wait());await Promise.all(s)}isActivated(s){const i=this.d.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this.d.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this.f[s])return;const n=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(n.map(o=>({id:o.identifier,reason:{startup:i,extensionId:o.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,i){const n=this.a.getExtensionDescription(s);if(!n)throw new Error(`Extension '${s}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(s){const i=s.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const i=this.a.getExtensionDescription(s.id);if(!i){const a=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new y(a));return this.c.onExtensionActivationError(s.id,a,new L.$rF(s.id.value)),t}const n=[],o=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of o){if(this.m(a))continue;const t=this.d.get(a);if(t){n.push(t);continue}if(this.l(a)){n.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:s.reason}));continue}const r=this.a.getExtensionDescription(a);if(r){if(!r.main&&!r.browser)continue;n.push(this.j({id:r.identifier,reason:s.reason}));continue}const d=i.displayName||i.identifier.value,u=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${a}'`),l=this.k(s,i.displayName,[],new y(u));return this.c.onExtensionActivationError(i.identifier,u,new L.$rF(a)),l}return this.k(s,i.displayName,n,null)}k(s,i,n,o){const a=new p(s.id,i,s.reason,n,o,this.c,this.g);return this.d.set(s.id,a),a}l(s){return F.$o5b.isHostExtension(s,this.a,this.b)}m(s){const i=this.b.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.$zdc=S,e.$zdc=S=He([Be(3,R.$aj)],S);let p=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,i,n,o,a,t,r){this.c=s,this.d=i,this.f=n,this.g=o,this.h=a,this.j=t,this.k=r,this.a=new w.$Tg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const i=this.g[s];if(i.value&&!i.value.activationFailed){this.g.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new y(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this.h=new y(i),this.b&&I.$3(s))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};p=He([Be(6,R.$aj)],p)}),define(ke[14],Se([1,0,19,22,165,75,81,28,161,54,100,24,18,2,29,84,136,144,141,111,68,89,292,7,25]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i,n,o,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$vM=e.$uM=e.MarkdownString=e.$tM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var u;(function(Me){function Oe(ie){const{selectionStartLineNumber:Fe,selectionStartColumn:Ve,positionLineNumber:xe,positionColumn:Je}=ie,rt=new r.$xK(Fe-1,Ve-1),kt=new r.$xK(xe-1,Je-1);return new r.$zK(rt,kt)}Me.to=Oe;function Ce(ie){const{anchor:Fe,active:Ve}=ie;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Me.from=Ce})(u||(e.Selection=u={}));var l;(function(Me){function Oe(ie){if(!ie)return;const{start:Fe,end:Ve}=ie;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Me.from=Oe;function Ce(ie){if(!ie)return;const{startLineNumber:Fe,startColumn:Ve,endLineNumber:xe,endColumn:Je}=ie;return new r.$yK(Fe-1,Ve-1,xe-1,Je-1)}Me.to=Ce})(l||(e.Range=l={}));var h;(function(Me){function Oe(Ce){switch(Ce){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Me.to=Oe})(h||(e.TokenType=h={}));var k;(function(Me){function Oe(ie){return new r.$xK(ie.lineNumber-1,ie.column-1)}Me.to=Oe;function Ce(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Me.from=Ce})(k||(e.Position=k={}));var D;(function(Me){function Oe(Fe,Ve,xe){return(0,I.$Gb)((0,I.$2b)(Fe).map(Je=>Ce(Je,Ve,xe)))}Me.from=Oe;function Ce(Fe,Ve,xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:xe?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ie(Fe.scheme,Ve),pattern:le.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:xe?.isBuiltin}}function ie(Fe,Ve){return Ve&&typeof Fe=="string"?Ve.transformOutgoingScheme(Fe):Fe}})(D||(e.DocumentSelector=D={}));var $;(function(Me){function Oe(ie){switch(ie){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Me.from=Oe;function Ce(ie){switch(ie){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Me.to=Ce})($||(e.DiagnosticTag=$={}));var b;(function(Me){function Oe(ie){let Fe;return ie.code&&((0,f.$zf)(ie.code)||(0,f.$Df)(ie.code)?Fe=String(ie.code):Fe={value:String(ie.code.value),target:ie.code.target}),{...l.from(ie.range),message:ie.message,source:ie.source,code:Fe,severity:C.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(v.from),tags:Array.isArray(ie.tags)?(0,I.$Gb)(ie.tags.map($.from)):void 0}}Me.from=Oe;function Ce(ie){const Fe=new r.$KK(l.to(ie),ie.message,C.to(ie.severity));return Fe.source=ie.source,Fe.code=(0,f.$zf)(ie.code)?ie.code:ie.code?.value,Fe.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(v.to),Fe.tags=ie.tags&&(0,I.$Gb)(ie.tags.map($.to)),Fe}Me.to=Ce})(b||(e.Diagnostic=b={}));var v;(function(Me){function Oe(ie){return{...l.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Me.from=Oe;function Ce(ie){return new r.$JK(new r.$IK(ie.resource,l.to(ie)),ie.message)}Me.to=Ce})(v||(e.DiagnosticRelatedInformation=v={}));var C;(function(Me){function Oe(ie){switch(ie){case r.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}Me.from=Oe;function Ce(ie){switch(ie){case c.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Me.to=Ce})(C||(e.DiagnosticSeverity=C={}));var N;(function(Me){function Oe(ie){return typeof ie=="number"&&ie>=r.ViewColumn.One?ie-1:ie===r.ViewColumn.Beside?t.$IC:t.$HC}Me.from=Oe;function Ce(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Ce})(N||(e.ViewColumn=N={}));function z(Me){return typeof Me.range<"u"}function M(Me){return Me.length===0?!0:!!z(Me[0])}e.$tM=M;var T;(function(Me){function Oe(Je){return Je.map(Me.from)}Me.fromMany=Oe;function Ce(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ie(Je){let rt;if(Ce(Je)){const{language:dt,value:gt}=Je;rt={value:"```"+dt+`
`+gt+"\n```\n"}}else r.$WK.isMarkdownString(Je)?rt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?rt={value:Je}:rt={value:""};const kt=Object.create(null);rt.uris=kt;const St=dt=>{try{let gt=y.URI.parse(dt,!0);gt=gt.with({query:Fe(gt.query,kt)}),kt[dt]=gt}catch{}return""},mt=new E.marked.Renderer;return mt.link=St,mt.image=dt=>typeof dt=="string"?St(R.$ak(dt).href):"",(0,E.marked)(rt.value,{renderer:mt}),rt}Me.from=ie;function Fe(Je,rt){if(!Je)return Je;let kt;try{kt=(0,g.$oh)(Je)}catch{}if(!kt)return Je;let St=!1;return kt=(0,P.$_m)(kt,mt=>{if(y.URI.isUri(mt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[dt]=mt,St=!0,dt}else return}),St?JSON.stringify(kt):Je}function Ve(Je){const rt=new r.$WK(Je.value,Je.supportThemeIcons);return rt.isTrusted=Je.isTrusted,rt.supportHtml=Je.supportHtml,rt.baseUri=Je.baseUri?y.URI.from(Je.baseUri):void 0,rt}Me.to=Ve;function xe(Je){if(Je)return typeof Je=="string"?Je:Me.from(Je)}Me.fromStrict=xe})(T||(e.MarkdownString=T={}));function j(Me){return M(Me)?Me.map(Oe=>({range:l.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?T.fromMany(Oe.hoverMessage):Oe.hoverMessage?T.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Me.map(Oe=>({range:l.from(Oe)}))}e.$uM=j;function O(Me){return typeof Me>"u"?Me:typeof Me=="string"?y.URI.file(Me):Me}e.$vM=O;var q;(function(Me){function Oe(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?O(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Me.from=Oe})(q||(e.ThemableDecorationAttachmentRenderOptions=q={}));var V;(function(Me){function Oe(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?O(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?q.from(Ce.before):void 0,after:Ce.after?q.from(Ce.after):void 0}}Me.from=Oe})(V||(e.ThemableDecorationRenderOptions=V={}));var de;(function(Me){function Oe(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Oe})(de||(e.DecorationRangeBehavior=de={}));var ee;(function(Me){function Oe(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?de.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?V.from(Ce.light):void 0,dark:Ce.dark?V.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?O(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?q.from(Ce.before):void 0,after:Ce.after?q.from(Ce.after):void 0}}Me.from=Oe})(ee||(e.DecorationRenderOptions=ee={}));var X;(function(Me){function Oe(ie){return{text:ie.newText,eol:ie.newEol&&Ae.from(ie.newEol),range:l.from(ie.range)}}Me.from=Oe;function Ce(ie){const Fe=new r.$DK(l.to(ie.range),ie.text);return Fe.newEol=typeof ie.eol>"u"?void 0:Ae.to(ie.eol),Fe}Me.to=Ce})(X||(e.TextEdit=X={}));var Q;(function(Me){function Oe(ie,Fe){const Ve={edits:[]};if(ie instanceof r.$GK){const xe=new w.$Ac;for(const Je of ie._allEntries())Je._type===1&&y.URI.isUri(Je.to)&&Je.from===void 0&&xe.add(Je.to);for(const Je of ie._allEntries())if(Je._type===1){let rt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?rt={type:"base64",value:(0,F.$we)(F.$ce.wrap(Je.options.contents))}:rt={type:"dataTransferItem",id:Je.options.contents._itemId}),Ve.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:rt},metadata:Je.metadata})}else Je._type===2?Ve.edits.push({resource:Je.uri,textEdit:X.from(Je.edit),versionId:xe.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?Ve.edits.push({resource:Je.uri,textEdit:{range:l.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:xe.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?Ve.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&Ve.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(bt.from)}})}return Ve}Me.from=Oe;function Ce(ie){const Fe=new r.$GK,Ve=new w.$zc;for(const xe of ie.edits)if(xe.textEdit){const Je=xe,rt=y.URI.revive(Je.resource),kt=l.to(Je.textEdit.range),St=Je.textEdit.text,mt=Je.textEdit.insertAsSnippet;let dt;mt?dt=r.$FK.replace(kt,new r.$HK(St)):dt=r.$DK.replace(kt,St);const gt=Ve.get(rt);gt?gt.push(dt):Ve.set(rt,[dt])}else Fe.renameFile(y.URI.revive(xe.oldResource),y.URI.revive(xe.newResource),xe.options);for(const[xe,Je]of Ve)Fe.set(xe,Je);return Fe}Me.to=Ce})(Q||(e.WorkspaceEdit=Q={}));var ae;(function(Me){const Oe=Object.create(null);Oe[r.SymbolKind.File]=0,Oe[r.SymbolKind.Module]=1,Oe[r.SymbolKind.Namespace]=2,Oe[r.SymbolKind.Package]=3,Oe[r.SymbolKind.Class]=4,Oe[r.SymbolKind.Method]=5,Oe[r.SymbolKind.Property]=6,Oe[r.SymbolKind.Field]=7,Oe[r.SymbolKind.Constructor]=8,Oe[r.SymbolKind.Enum]=9,Oe[r.SymbolKind.Interface]=10,Oe[r.SymbolKind.Function]=11,Oe[r.SymbolKind.Variable]=12,Oe[r.SymbolKind.Constant]=13,Oe[r.SymbolKind.String]=14,Oe[r.SymbolKind.Number]=15,Oe[r.SymbolKind.Boolean]=16,Oe[r.SymbolKind.Array]=17,Oe[r.SymbolKind.Object]=18,Oe[r.SymbolKind.Key]=19,Oe[r.SymbolKind.Null]=20,Oe[r.SymbolKind.EnumMember]=21,Oe[r.SymbolKind.Struct]=22,Oe[r.SymbolKind.Event]=23,Oe[r.SymbolKind.Operator]=24,Oe[r.SymbolKind.TypeParameter]=25;function Ce(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Me.from=Ce;function ie(Fe){for(const Ve in Oe)if(Oe[Ve]===Fe)return Number(Ve);return r.SymbolKind.Property}Me.to=ie})(ae||(e.SymbolKind=ae={}));var x;(function(Me){function Oe(ie){switch(ie){case r.SymbolTag.Deprecated:return 1}}Me.from=Oe;function Ce(ie){switch(ie){case 1:return r.SymbolTag.Deprecated}}Me.to=Ce})(x||(e.SymbolTag=x={}));var se;(function(Me){function Oe(ie){return{name:ie.name,kind:ae.from(ie.kind),tags:ie.tags&&ie.tags.map(x.from),containerName:ie.containerName,location:be.from(ie.location)}}Me.from=Oe;function Ce(ie){const Fe=new r.$NK(ie.name,ae.to(ie.kind),ie.containerName,be.to(ie.location));return Fe.tags=ie.tags&&ie.tags.map(x.to),Fe}Me.to=Ce})(se||(e.WorkspaceSymbol=se={}));var pe;(function(Me){function Oe(ie){const Fe={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:l.from(ie.range),selectionRange:l.from(ie.selectionRange),kind:ae.from(ie.kind),tags:ie.tags?.map(x.from)??[]};return ie.children&&(Fe.children=ie.children.map(Oe)),Fe}Me.from=Oe;function Ce(ie){const Fe=new r.$OK(ie.name,ie.detail,ae.to(ie.kind),l.to(ie.range),l.to(ie.selectionRange));return(0,I.$Kb)(ie.tags)&&(Fe.tags=ie.tags.map(x.to)),ie.children&&(Fe.children=ie.children.map(Ce)),Fe}Me.to=Ce})(pe||(e.DocumentSymbol=pe={}));var G;(function(Me){function Oe(ie){const Fe=new r.$SK(ae.to(ie.kind),ie.name,ie.detail||"",y.URI.revive(ie.uri),l.to(ie.range),l.to(ie.selectionRange));return Fe._sessionId=ie._sessionId,Fe._itemId=ie._itemId,Fe}Me.to=Oe;function Ce(ie,Fe,Ve){if(Fe=Fe??ie._sessionId,Ve=Ve??ie._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,name:ie.name,detail:ie.detail,kind:ae.from(ie.kind),uri:ie.uri,range:l.from(ie.range),selectionRange:l.from(ie.selectionRange),tags:ie.tags?.map(x.from)}}Me.from=Ce})(G||(e.CallHierarchyItem=G={}));var U;(function(Me){function Oe(Ce){return new r.$TK(G.to(Ce.from),Ce.fromRanges.map(ie=>l.to(ie)))}Me.to=Oe})(U||(e.CallHierarchyIncomingCall=U={}));var ce;(function(Me){function Oe(Ce){return new r.$UK(G.to(Ce.to),Ce.fromRanges.map(ie=>l.to(ie)))}Me.to=Oe})(ce||(e.CallHierarchyOutgoingCall=ce={}));var be;(function(Me){function Oe(ie){return{range:ie.range&&l.from(ie.range),uri:ie.uri}}Me.from=Oe;function Ce(ie){return new r.$IK(y.URI.revive(ie.uri),l.to(ie.range))}Me.to=Ce})(be||(e.location=be={}));var H;(function(Me){function Oe(ie){const Fe=ie,Ve=ie;return{originSelectionRange:Fe.originSelectionRange?l.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ve.uri,range:l.from(Fe.targetRange?Fe.targetRange:Ve.range),targetSelectionRange:Fe.targetSelectionRange?l.from(Fe.targetSelectionRange):void 0}}Me.from=Oe;function Ce(ie){return{targetUri:y.URI.revive(ie.uri),targetRange:l.to(ie.range),targetSelectionRange:ie.targetSelectionRange?l.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?l.to(ie.originSelectionRange):void 0}}Me.to=Ce})(H||(e.DefinitionLink=H={}));var Z;(function(Me){function Oe(ie){return{range:l.from(ie.range),contents:T.fromMany(ie.contents)}}Me.from=Oe;function Ce(ie){return new r.$LK(ie.contents.map(T.to),l.to(ie.range))}Me.to=Ce})(Z||(e.Hover=Z={}));var Y;(function(Me){function Oe(ie){return{range:l.from(ie.range),expression:ie.expression}}Me.from=Oe;function Ce(ie){return new r.$EL(l.to(ie.range),ie.expression)}Me.to=Ce})(Y||(e.EvaluatableExpression=Y={}));var $e;(function(Me){function Oe(ie){if(ie instanceof r.$FL)return{type:"text",range:l.from(ie.range),text:ie.text};if(ie instanceof r.$GL)return{type:"variable",range:l.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof r.$HL)return{type:"expression",range:l.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Oe;function Ce(ie){switch(ie.type){case"text":return{range:l.to(ie.range),text:ie.text};case"variable":return{range:l.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:l.to(ie.range),expression:ie.expression}}}Me.to=Ce})($e||(e.InlineValue=$e={}));var ne;(function(Me){function Oe(ie){return{frameId:ie.frameId,stoppedLocation:l.from(ie.stoppedLocation)}}Me.from=Oe;function Ce(ie){return new r.$IL(ie.frameId,l.to(ie.stoppedLocation))}Me.to=Ce})(ne||(e.InlineValueContext=ne={}));var fe;(function(Me){function Oe(ie){return{range:l.from(ie.range),kind:ie.kind}}Me.from=Oe;function Ce(ie){return new r.$MK(l.to(ie.range),ie.kind)}Me.to=Ce})(fe||(e.DocumentHighlight=fe={}));var te;(function(Me){function Oe(Ce){switch(Ce){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Me.to=Oe})(te||(e.CompletionTriggerKind=te={}));var he;(function(Me){function Oe(Ce){return{triggerKind:te.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Me.to=Oe})(he||(e.CompletionContext=he={}));var we;(function(Me){function Oe(ie){switch(ie){case r.CompletionItemTag.Deprecated:return 1}}Me.from=Oe;function Ce(ie){switch(ie){case 1:return r.CompletionItemTag.Deprecated}}Me.to=Ce})(we||(e.CompletionItemTag=we={}));var Pe;(function(Me){const Oe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ce(Ve){return Oe.get(Ve)??9}Me.from=Ce;const ie=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Fe(Ve){return ie.get(Ve)??r.CompletionItemKind.Property}Me.to=Fe})(Pe||(e.CompletionItemKind=Pe={}));var B;(function(Me){function Oe(Ce,ie){const Fe=new r.$3K(Ce.label);return Fe.insertText=Ce.insertText,Fe.kind=Pe.to(Ce.kind),Fe.tags=Ce.tags?.map(we.to),Fe.detail=Ce.detail,Fe.documentation=R.$8j(Ce.documentation)?T.to(Ce.documentation):Ce.documentation,Fe.sortText=Ce.sortText,Fe.filterText=Ce.filterText,Fe.preselect=Ce.preselect,Fe.commitCharacters=Ce.commitCharacters,S.$ws.isIRange(Ce.range)?Fe.range=l.to(Ce.range):typeof Ce.range=="object"&&(Fe.range={inserting:l.to(Ce.range.insert),replacing:l.to(Ce.range.replace)}),Fe.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Fe.insertText=new r.$HK(Ce.insertText):(Fe.insertText=Ce.insertText,Fe.textEdit=Fe.range instanceof r.$yK?new r.$DK(Fe.range,Fe.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Ce.additionalTextEdits.map(Ve=>X.to(Ve))),Fe.command=ie&&Ce.command?ie.fromInternal(Ce.command):void 0,Fe}Me.to=Oe})(B||(e.CompletionItem=B={}));var J;(function(Me){function Oe(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:T.fromStrict(ie.documentation)}}Me.from=Oe;function Ce(ie){return{label:ie.label,documentation:R.$8j(ie.documentation)?T.to(ie.documentation):ie.documentation}}Me.to=Ce})(J||(e.ParameterInformation=J={}));var re;(function(Me){function Oe(ie){return{label:ie.label,documentation:T.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(J.from):[],activeParameter:ie.activeParameter}}Me.from=Oe;function Ce(ie){return{label:ie.label,documentation:R.$8j(ie.documentation)?T.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(J.to):[],activeParameter:ie.activeParameter}}Me.to=Ce})(re||(e.SignatureInformation=re={}));var oe;(function(Me){function Oe(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(re.from):[]}}Me.from=Oe;function Ce(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(re.to):[]}}Me.to=Ce})(oe||(e.SignatureHelp=oe={}));var _;(function(Me){function Oe(Ce,ie){const Fe=new r.$2K(k.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(ge.to.bind(void 0,Ce)),ie.kind&&Ee.to(ie.kind));return Fe.textEdits=ie.textEdits&&ie.textEdits.map(X.to),Fe.tooltip=R.$8j(ie.tooltip)?T.to(ie.tooltip):ie.tooltip,Fe.paddingLeft=ie.paddingLeft,Fe.paddingRight=ie.paddingRight,Fe}Me.to=Oe})(_||(e.InlayHint=_={}));var ge;(function(Me){function Oe(Ce,ie){const Fe=new r.$1K(ie.label);return Fe.tooltip=R.$8j(ie.tooltip)?T.to(ie.tooltip):ie.tooltip,p.Command.is(ie.command)&&(Fe.command=Ce.fromInternal(ie.command)),ie.location&&(Fe.location=be.to(ie.location)),Fe}Me.to=Oe})(ge||(e.InlayHintLabelPart=ge={}));var Ee;(function(Me){function Oe(ie){return ie}Me.from=Oe;function Ce(ie){return ie}Me.to=Ce})(Ee||(e.InlayHintKind=Ee={}));var ze;(function(Me){function Oe(ie){return{range:l.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Me.from=Oe;function Ce(ie){let Fe;if(ie.url)try{Fe=typeof ie.url=="string"?y.URI.parse(ie.url,!0):y.URI.revive(ie.url)}catch{}return new r.$8K(l.to(ie.range),Fe)}Me.to=Ce})(ze||(e.DocumentLink=ze={}));var We;(function(Me){function Oe(ie){const Fe=new r.$$K(ie.label);return ie.textEdit&&(Fe.textEdit=X.to(ie.textEdit)),ie.additionalTextEdits&&(Fe.additionalTextEdits=ie.additionalTextEdits.map(Ve=>X.to(Ve))),Fe}Me.to=Oe;function Ce(ie){return{label:ie.label,textEdit:ie.textEdit?X.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Fe=>X.from(Fe)):void 0}}Me.from=Ce})(We||(e.ColorPresentation=We={}));var _e;(function(Me){function Oe(ie){return new r.$9K(ie[0],ie[1],ie[2],ie[3])}Me.to=Oe;function Ce(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Me.from=Ce})(_e||(e.Color=_e={}));var Xe;(function(Me){function Oe(ie){return{range:l.from(ie.range)}}Me.from=Oe;function Ce(ie){return new r.$RK(l.to(ie.range))}Me.to=Ce})(Xe||(e.SelectionRange=Xe={}));var it;(function(Me){function Oe(Ce){switch(Ce){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Me.to=Oe})(it||(e.TextDocumentSaveReason=it={}));var tt;(function(Me){function Oe(ie){switch(ie){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Oe;function Ce(ie){switch(ie){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Me.to=Ce})(tt||(e.TextEditorLineNumbersStyle=tt={}));var Ae;(function(Me){function Oe(ie){if(ie===r.EndOfLine.CRLF)return 1;if(ie===r.EndOfLine.LF)return 0}Me.from=Oe;function Ce(ie){if(ie===1)return r.EndOfLine.CRLF;if(ie===0)return r.EndOfLine.LF}Me.to=Ce})(Ae||(e.EndOfLine=Ae={}));var Te;(function(Me){function Oe(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Oe})(Te||(e.ProgressLocation=Te={}));var qe;(function(Me){function Oe(ie){const Fe={start:ie.start+1,end:ie.end+1};return ie.kind&&(Fe.kind=Re.from(ie.kind)),Fe}Me.from=Oe;function Ce(ie){const Fe={start:ie.start-1,end:ie.end-1};return ie.kind&&(Fe.kind=Re.to(ie.kind)),Fe}Me.to=Ce})(qe||(e.FoldingRange=qe={}));var Re;(function(Me){function Oe(ie){if(ie)switch(ie){case r.FoldingRangeKind.Comment:return p.$lt.Comment;case r.FoldingRangeKind.Imports:return p.$lt.Imports;case r.FoldingRangeKind.Region:return p.$lt.Region}}Me.from=Oe;function Ce(ie){if(ie)switch(ie.value){case p.$lt.Comment.value:return r.FoldingRangeKind.Comment;case p.$lt.Imports.value:return r.FoldingRangeKind.Imports;case p.$lt.Region.value:return r.FoldingRangeKind.Region}}Me.to=Ce})(Re||(e.FoldingRangeKind=Re={}));var Ye;(function(Me){function Oe(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?l.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?i.$0D.id:void 0}}Me.from=Oe})(Ye||(e.TextEditorOpenOptions=Ye={}));var le;(function(Me){function Oe(Ve){return Ve instanceof r.$sL?Ve.toJSON():typeof Ve=="string"?Ve:Ce(Ve)||ie(Ve)?new r.$sL(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Me.from=Oe;function Ce(Ve){const xe=Ve;return xe?y.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ie(Ve){const xe=Ve;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Fe(Ve){return typeof Ve=="string"?Ve:new r.$sL(y.URI.revive(Ve.baseUri),Ve.pattern)}Me.to=Fe})(le||(e.GlobPattern=le={}));var ue;(function(Me){function Oe(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Oe);if(typeof Ce=="string")return Ce;{const ie=Ce;return{language:ie.language,scheme:ie.scheme,pattern:le.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Me.from=Oe})(ue||(e.LanguageSelector=ue={}));var Ie;(function(Me){function Oe(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&y.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(xe=>xe instanceof r.$yK)))}Me.is=Oe;function Ce(ie){return{documents:ie.documents.map(Fe=>Fe.map(Ve=>({uri:y.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(xe=>l.from(xe))})))}}Me.from=Ce})(Ie||(e.MappedEditsContext=Ie={}));var Ke;(function(Me){function Oe(ie){return{start:ie.start,end:ie.end}}Me.from=Oe;function Ce(ie){return new r.$TL(ie.start,ie.end)}Me.to=Ce})(Ke||(e.NotebookRange=Ke={}));var Ue;(function(Me){function Oe(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Me.to=Oe;function Ce(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Me.from=Ce})(Ue||(e.NotebookCellExecutionSummary=Ue={}));var Ze;(function(Me){function Oe(Ce){if(Ce===n.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ce===n.NotebookCellExecutionState.Pending)return;if(Ce===n.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Me.to=Oe})(Ze||(e.NotebookCellExecutionState=Ze={}));var nt;(function(Me){function Oe(ie){switch(ie){case r.NotebookCellKind.Markup:return n.CellKind.Markup;case r.NotebookCellKind.Code:default:return n.CellKind.Code}}Me.from=Oe;function Ce(ie){switch(ie){case n.CellKind.Markup:return r.NotebookCellKind.Markup;case n.CellKind.Code:default:return r.NotebookCellKind.Code}}Me.to=Ce})(nt||(e.NotebookCellKind=nt={}));var ct;(function(Me){function Oe(ie){const Fe={metadata:ie.metadata??Object.create(null),cells:[]};for(const Ve of ie.cells)r.$UL.validate(Ve),Fe.cells.push(bt.from(Ve));return Fe}Me.from=Oe;function Ce(ie){const Fe=new r.$VL(ie.cells.map(bt.to));return(0,f.$Mf)(ie.metadata)||(Fe.metadata=ie.metadata),Fe}Me.to=Ce})(ct||(e.NotebookData=ct={}));var bt;(function(Me){function Oe(ie){return{cellKind:nt.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Ue.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(Kt.from):[]}}Me.from=Oe;function Ce(ie){return new r.$UL(nt.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(Kt.to):void 0,ie.metadata,ie.internalMetadata?Ue.to(ie.internalMetadata):void 0)}Me.to=Ce})(bt||(e.NotebookCellData=bt={}));var Et;(function(Me){function Oe(ie){return{mime:ie.mime,valueBytes:F.$ce.wrap(ie.data)}}Me.from=Oe;function Ce(ie){return new r.$WL(ie.valueBytes.buffer,ie.mime)}Me.to=Ce})(Et||(e.NotebookCellOutputItem=Et={}));var Kt;(function(Me){function Oe(ie){return{outputId:ie.id,items:ie.items.map(Et.from),metadata:ie.metadata}}Me.from=Oe;function Ce(ie){const Fe=ie.items.map(Et.to);return new r.$XL(Fe,ie.outputId,ie.metadata)}Me.to=Ce})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Me){function Oe(Fe){return ie(Fe)?{include:le.from(Fe.include)??void 0,exclude:le.from(Fe.exclude)??void 0}:le.from(Fe)??void 0}Me.from=Oe;function Ce(Fe){return ie(Fe)?{include:le.to(Fe.include),exclude:le.to(Fe.exclude)}:le.to(Fe)}Me.to=Ce;function ie(Fe){const Ve=Fe;return Ve?!(0,f.$If)(Ve.include)&&!(0,f.$If)(Ve.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var pt;(function(Me){function Oe(Ce,ie,Fe){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:ie.toInternal(Ve,Fe),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Me.from=Oe})(pt||(e.NotebookStatusBarItem=pt={}));var zt;(function(Me){function Oe(Ce,ie,Fe){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:ie.toInternal(Ve,Fe),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Me.from=Oe})(zt||(e.NotebookKernelSourceAction=zt={}));var Tt;(function(Me){function Oe(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Me.from=Oe})(Tt||(e.NotebookDocumentContentOptions=Tt={}));var Gt;(function(Me){function Oe(ie){return{uri:ie.uri,provides:ie.provides}}Me.from=Oe;function Ce(ie){return new r.$ZL(y.URI.revive(ie.uri),ie.provides)}Me.to=Ce})(Gt||(e.NotebookRendererScript=Gt={}));var Ut;(function(Me){function Oe(ie){return{message:T.fromStrict(ie.message)||"",type:0,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:l.from(ie.location.range),uri:ie.location.uri}}}Me.from=Oe;function Ce(ie){const Fe=new r.$6L(typeof ie.message=="string"?ie.message:T.to(ie.message));return Fe.actualOutput=ie.actual,Fe.expectedOutput=ie.expected,Fe.contextValue=ie.contextValue,Fe.location=ie.location?be.to(ie.location):void 0,Fe}Me.to=Ce})(Ut||(e.TestMessage=Ut={}));var Dt;(function(Me){Me.namespace=a.$oJ,Me.denamespace=a.$pJ})(Dt||(e.TestTag=Dt={}));var Ft;(function(Me){function Oe(ie){const Fe=(0,s.$sM)(ie).controllerId;return{extId:o.$kJ.fromExtHostTestItem(ie,Fe).toString(),label:ie.label,uri:y.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(Ve=>Dt.namespace(Fe,Ve.id)),range:S.$ws.lift(l.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&T.fromStrict(ie.error)||null}}Me.from=Oe;function Ce(ie){return{parent:void 0,error:void 0,id:o.$kJ.fromString(ie.extId).localId,label:ie.label,uri:y.URI.revive(ie.uri),tags:(ie.tags||[]).map(Fe=>{const{tagId:Ve}=Dt.denamespace(Fe);return new r.$7L(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Me.toPlain=Ce})(Ft||(e.TestItem=Ft={})),function(Me){function Oe(ie){return{id:ie.id}}Me.from=Oe;function Ce(ie){return new r.$7L(ie.id)}Me.to=Ce}(Dt||(e.TestTag=Dt={}));var Bt;(function(Me){const Oe=(ie,Fe)=>{const Ve=[];for(const[Je,rt]of Fe)o.$kJ.compare(rt.item.extId,Je)===2&&(Fe.delete(Je),Ve.push(rt));const xe={...Ft.toPlain(ie.item),parent:void 0,taskStates:ie.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(rt=>rt.type===0).map(Ut.to)})),children:Ve.map(Je=>Oe(Je,Fe))};for(const Je of xe.children)Je.parent=xe;return xe};function Ce(ie){const Fe=[],Ve=new Map;for(const xe of ie.items){Ve.set(xe.item.extId,xe);const Je=o.$kJ.root(xe.item.extId);ie.request.targets.some(rt=>rt.controllerId===Je&&rt.testIds.includes(xe.item.extId))&&Fe.push(xe)}return{completedAt:ie.completedAt,results:Fe.map(xe=>Oe(xe,Ve))}}Me.to=Ce})(Bt||(e.TestResults=Bt={}));var Jt;(function(Me){function Oe(Ve){return{covered:Ve.covered,total:Ve.covered}}function Ce(Ve){return"line"in Ve?k.from(Ve):l.from(Ve)}function ie(Ve){return"branches"in Ve?{count:Ve.executionCount,location:Ce(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Ce(xe.location)})):void 0}:{type:0,count:Ve.executionCount,location:Ce(Ve.location)}}Me.fromDetailed=ie;function Fe(Ve){return{uri:Ve.uri,statement:Oe(Ve.statementCoverage),branch:Ve.branchCoverage&&Oe(Ve.branchCoverage),function:Ve.functionCoverage&&Oe(Ve.functionCoverage),details:Ve.detailedCoverage?.map(ie)}}Me.fromFile=Fe})(Jt||(e.TestCoverage=Jt={}));var Wt;(function(Me){function Oe(Ce){switch(Ce){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Me.to=Oe})(Wt||(e.CodeActionTriggerKind=Wt={}));var qt;(function(Me){function Oe(ie){const Fe=new r.$aM(ae.to(ie.kind),ie.name,ie.detail||"",y.URI.revive(ie.uri),l.to(ie.range),l.to(ie.selectionRange));return Fe._sessionId=ie._sessionId,Fe._itemId=ie._itemId,Fe}Me.to=Oe;function Ce(ie,Fe,Ve){if(Fe=Fe??ie._sessionId,Ve=Ve??ie._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,kind:ae.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:l.from(ie.range),selectionRange:l.from(ie.selectionRange),tags:ie.tags?.map(x.from)}}Me.from=Ce})(qt||(e.TypeHierarchyItem=qt={}));var Nt;(function(Me){function Oe(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Me.from=Oe})(Nt||(e.ViewBadge=Nt={}));var ut;(function(Me){function Oe(Ve,xe,Je){const rt=xe.fileData;return rt?new r.$lL(new r.$mL(rt.name,y.URI.revive(rt.uri),rt.id,(0,L.$cb)(()=>Je(rt.id)))):Ve===A.$Sr.uriList&&xe.uriListData?new r.$kL(Fe(xe.uriListData)):new r.$kL(xe.asString)}Me.to=Oe;async function Ce(Ve,xe){const Je=await xe.asString();if(Ve===A.$Sr.uriList)return{asString:Je,fileData:void 0,uriListData:ie(Je)};const rt=xe.asFile();return{asString:Je,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}Me.from=Ce;function ie(Ve){return m.$6s.split(Ve).map(xe=>{if(xe.startsWith("#"))return xe;try{return y.URI.parse(xe)}catch{}return xe})}function Fe(Ve){return m.$6s.create(Ve.map(xe=>typeof xe=="string"?xe:y.URI.revive(xe)))}})(ut||(e.DataTransferItem=ut={}));var ft;(function(Me){function Oe(ie,Fe){const Ve=ie.items.map(([xe,Je])=>[xe,ut.to(xe,Je,Fe)]);return new r.$nL(Ve)}Me.toDataTransfer=Oe;async function Ce(ie){const Fe={items:[]},Ve=[];for(const[xe,Je]of ie)Ve.push((async()=>{Fe.items.push([xe,await ut.from(xe,Je)])})());return await Promise.all(Ve),Fe}Me.from=Ce})(ft||(e.DataTransfer=ft={}));var At;(function(Me){function Oe(ie){return{message:ie.message,metadata:ie.metadata,title:ie.title,tooltip:ie.tooltip}}Me.to=Oe;function Ce(ie){return{kind:"reply",message:ie.message,metadata:ie.metadata,title:ie.title,tooltip:ie.tooltip}}Me.from=Ce})(At||(e.ChatReplyFollowup=At={}));var Vt;(function(Me){function Oe(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:At.from(Ce)}Me.from=Oe})(Vt||(e.ChatFollowup=Vt={}));var Lt;(function(Me){function Oe(ie){const Fe=new r.$lM(at.to(ie.role),ie.content);return Fe.name=ie.name,Fe}Me.to=Oe;function Ce(ie){return{role:at.from(ie.role),content:ie.content,name:ie.name}}Me.from=Ce})(Lt||(e.ChatMessage=Lt={}));var at;(function(Me){function Oe(ie){switch(ie){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Me.to=Oe;function Ce(ie){switch(ie){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Me.from=Ce})(at||(e.ChatMessageRole=at={}));var vt;(function(Me){function Oe(Fe){const Ve={};for(const xe of Object.keys(Fe))Ve[xe]=Fe[xe].map(Me.to);return Ve}Me.objectTo=Oe;function Ce(Fe){return{level:Ot.to(Fe.level),value:Fe.value,description:Fe.description}}Me.to=Ce;function ie(Fe){return{level:Ot.from(Fe.level),value:Fe.value,description:Fe.description}}Me.from=ie})(vt||(e.ChatVariable=vt={}));var Ot;(function(Me){function Oe(ie){switch(ie){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Me.to=Oe;function Ce(ie){switch(ie){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Me.from=Ce})(Ot||(e.ChatVariableLevel=Ot={}));var Pt;(function(Me){function Oe(Ce){switch(Ce){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Oe})(Pt||(e.InteractiveEditorResponseFeedbackKind=Pt={}));var Ge;(function(Me){function Oe(Ce,ie){return"placeholder"in ie&&"resolvedContent"in ie?{placeholder:ie.placeholder}:"responseId"in ie?{requestId:ie.responseId}:"markdownContent"in ie?((0,d.$uF)(Ce,"chatAgents2Additions"),{content:T.from(ie.markdownContent)}):"content"in ie?typeof ie.content=="string"?ie:((0,d.$uF)(Ce,"chatAgents2Additions"),{content:T.from(ie.content)}):"documents"in ie?{documents:ie.documents.map(Fe=>({uri:Fe.uri,version:Fe.version,ranges:Fe.ranges.map(Ve=>l.from(Ve))}))}:"reference"in ie?{reference:"uri"in ie.reference?{uri:ie.reference.uri,range:l.from(ie.reference.range)}:ie.reference}:"inlineReference"in ie?{inlineReference:"uri"in ie.inlineReference?{uri:ie.inlineReference.uri,range:l.from(ie.inlineReference.range)}:ie.inlineReference,title:ie.title}:("agentName"in ie&&(0,d.$uF)(Ce,"chatAgents2Additions"),ie)}Me.from=Oe})(Ge||(e.ChatResponseProgress=Ge={}));var Qt;(function(Me){function Oe(Ce,ie,Fe){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand}:"uri"in Ce?{uri:Ce.uri}:ie.toInternal(Ce,Fe)}Me.from=Oe})(Qt||(e.TerminalQuickFix=Qt={}))}),define(ke[295],Se([1,0,2,11,7,14,76]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class w{constructor(g,A,P,f={timeout:1500,errors:3}){this.c=g,this.d=A,this.f=P,this.g=f,this.a=new R.$1c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(A,P,f)=>{const S={dispose:this.a.push([A,P,g])};return Array.isArray(f)&&f.push(S),S}}async $participateInSave(g,A){const P=I.URI.revive(g);let f=!1;const y=setTimeout(()=>f=!0,this.g.timeout),S=[];try{for(const p of[...this.a]){if(f)break;const c=this.d.getDocument(P),s=await this.h(p,{document:c,reason:L.TextDocumentSaveReason.to(A)});S.push(s)}}finally{clearTimeout(y)}return S}h([g,A,P],f){const y=this.b.get(g);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(P,g,A,f).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const p=this.b.get(g);this.b.set(g,p?p+1:1),typeof p=="number"&&p>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,A,P,f){const y=[],S=Date.now(),{document:p,reason:c}=f,{version:s}=p,i=Object.freeze({document:p,reason:c,waitUntil(n){if(Object.isFrozen(y))throw(0,F.$7)("waitUntil can not be called async");y.push(Promise.resolve(n))}});try{A.apply(P,[i])}catch(n){return Promise.reject(n)}return Object.freeze(y),new Promise((n,o)=>{const a=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(y).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),o(t)})}).then(n=>{const o={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof m.$DK))for(const{newText:t,newEol:r,range:d}of a)o.edits.push({resource:p.uri,versionId:void 0,textEdit:{range:d&&L.Range.from(d),text:t,eol:r&&L.EndOfLine.from(r)}});if(o.edits.length!==0)return s===p.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$tdc=w}),define(ke[296],Se([1,0,17,2,14,7,111]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=e.$Gec=void 0;class w{constructor(P,f,y,S){this.start=P,this.deletedCount=f,this.deletedItems=y,this.items=S}asApiEvent(){return{range:new L.$TL(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(P,f){return{EOL:f.eol,lines:f.source,languageId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,f,y){this.notebook=P,this.h=f,this.j=y,this.handle=y.handle,this.uri=F.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(m.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(m.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,f=this.h.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:m.NotebookCellKind.to(this.j.cellKind),document:f.document,get mime(){return P.g},set mime(S){P.g=S},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(y)}return this.f}setOutputs(P){this.a=P.map(m.NotebookCellOutput.to)}setOutputItems(P,f,y){const S=y.map(m.NotebookCellOutputItem.to),p=this.a.find(c=>c.id===P);if(p&&(f||(p.items.length=0),p.items.push(...S),p.items.length>1&&p.items.every(c=>R.$zI(c.mime)))){const c=new Map,s=[];p.items.forEach(i=>{let n;c.has(i.mime)?n=c.get(i.mime):(n=[],c.set(i.mime,n),s.push(i.mime)),n.push(i.data)}),p.items.length=0,s.forEach(i=>{const n=R.$AI(c.get(i));p.items.push({mime:i,data:n.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(m.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$Gec=E;class g{static{this.a=0}constructor(P,f,y,S,p){this.k=P,this.l=f,this.m=y,this.uri=S,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=p.viewType,this.f=Object.freeze(p.metadata??Object.create(null)),this.r([[0,0,p.cells]],!0,void 0),this.g=p.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,f={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===I.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(y){return y=P.n(y),P.b[y].apiCell},getCells(y){return(y?P.p(y):P.b).map(p=>p.apiCell)},save(){return P.q()}};this.e=Object.freeze(f)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,f,y){this.g=P.versionId,this.h=f,this.acceptDocumentPropertiesChanged({metadata:y});const S={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},p=[];for(const s of P.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,S.contentChanges):s.kind===R.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,S.contentChanges):s.kind===R.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),p.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),p.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),p.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===R.NotebookCellsChangeType.ChangeCellContent?p.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),p.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),p.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const c=new Map;for(let s=0;s<p.length;s++){const i=p[s],n=c.get(i.cell);if(n===void 0){const o=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});c.set(i.cell,o-1)}else S.cellChanges[n]={...S.cellChanges[n],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let f=P.start|0,y=P.end|0;return f<0&&(f=0),y>this.b.length&&(y=this.b.length),P.with({start:f,end:y})}p(P){P=this.o(P);const f=[];for(let y=P.start;y<P.end;y++)f.push(this.b[y]);return f}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,f,y){if(this.j)return;const S=[],p=[],c=[];if(P.reverse().forEach(s=>{const n=s[2].map(t=>{const r=new E(this,this.l,t);return f||p.push(E.asModelAddData(this.apiNotebook,t)),r}),o=new w(s[0],s[1],[],n),a=this.b.splice(s[0],s[1],...n);for(const t of a)c.push(t.uri),o.deletedItems.push(t.apiCell);S.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:c}),y)for(const s of S)y.push(s.asApiEvent())}s(P,f,y,S){const p=this.b.splice(P,f);this.b.splice(y,0,...p);const c=[new w(P,f,p.map(s=>s.apiCell),[]),new w(y,0,[],p)];for(const s of c)S.push(s.asApiEvent())}t(P,f){this.b[P].setOutputs(f)}u(P,f,y,S){this.b[P].setOutputItems(f,y,S)}v(P,f){const y=this.b[P];y.apiCell.document.languageId!==f&&this.m.$acceptModelLanguageChanged(y.uri,f)}w(P,f){const y=this.b[P];y.apiCell.mime=f}x(P,f){this.b[P].setMetadata(f)}y(P,f){this.b[P].setInternalMetadata(f)}getCellFromApiCell(P){return this.b.find(f=>f.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(f=>f.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$Hec=g}),define(ke[297],Se([1,0,4,2,14,7]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;class R{constructor(E,g,A,P={timeout:1500,errors:3}){this.b=E,this.c=g,this.d=A,this.f=P,this.a=new I.$Qd}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(g,A,P)=>{const f=function(S){g.call(A,S)};return f.extension=E,this.a.event(f,void 0,P)}}async $participateInSave(E,g,A){const P=F.URI.revive(E),f=this.c.getNotebookDocument(P);if(!f)throw new Error("Unable to resolve notebook document");const y=[];if(await this.a.fireAsync({notebook:f.apiNotebook,reason:m.TextDocumentSaveReason.to(g)},A,async(p,c)=>{const s=Date.now(),i=await await Promise.resolve(p);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof L.$GK?y.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(y.length===0)return!0;const S={edits:[]};for(const p of y){const{edits:c}=m.WorkspaceEdit.from(p);S.edits=S.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$8ec=R}),define(ke[148],Se([1,0,11,14,7]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(w,E,g,A,P,f){this.id=w,this.f=E,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=A,this.c=f}get apiEditor(){if(!this.e){const w=this;this.e={get notebook(){return w.notebookData.apiNotebook},get selection(){return w.a[0]},set selection(E){this.selections=[E]},get selections(){return w.a},set selections(E){if(!Array.isArray(E)||!E.every(m.$TL.isNotebookRange))throw(0,I.$6)("selections");w.a=E,w.g(E)},get visibleRanges(){return w.b},revealRange(E,g){w.f.$tryRevealRange(w.id,F.NotebookRange.from(E),g??m.NotebookEditorRevealType.Default)},get viewColumn(){return w.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(w){this.d=w}_acceptVisibleRanges(w){this.b=w}_acceptSelections(w){this.a=w}g(w){this.f.$trySetSelections(this.id,w.map(F.NotebookRange.from))}_acceptViewColumn(w){this.c=w}}e.$Iec=L}),define(ke[298],Se([1,0,11,4,15,14]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;let R=class{constructor(E,g){this.c=E,this.d=g,this.a=new F.$Od({onListenerError:I.$1}),this.b=new F.$Od({onListenerError:I.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,g);const A=this.d.getEditorById(E);g.visibleRanges&&A._acceptVisibleRanges(g.visibleRanges.ranges.map(L.NotebookRange.to)),g.selections&&A._acceptSelections(g.selections.selections.map(L.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const g in E)this.d.getEditorById(g)._acceptViewColumn(L.ViewColumn.to(E[g]))}};e.$1ec=R,e.$1ec=R=He([Be(0,m.$aj)],R)}),define(ke[299],Se([1,0,14,64,217,21,59,11]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=void 0;class E{constructor(f){this.b=0,this.c=new Map,this.a=f}async withProgress(f,y,S){const p=this.b++,{title:c,location:s,cancellable:i}=y,n={label:(0,m.localize)(0,null,f.displayName||f.name),id:f.identifier.value};return this.a.$startProgress(p,{location:I.ProgressLocation.from(s),title:c,source:n,cancellable:i},f.isUnderDevelopment?void 0:f.identifier.value).catch(w.$1),this.d(p,S,!!i)}d(f,y,S){let p;S&&(p=new L.$Yd,this.c.set(f,p));const c=i=>{this.a.$progressEnd(i),this.c.delete(i),p?.dispose()};let s;try{s=y(new A(this.a,f),S&&p?p.token:L.CancellationToken.None)}catch(i){throw c(f),i}return s.then(i=>c(f),i=>c(f)),s}$acceptProgressCanceled(f){const y=this.c.get(f);y&&(y.cancel(),this.c.delete(f))}}e.$5dc=E;function g(P,f){return P.message=f.message,typeof f.increment=="number"&&(typeof P.increment=="number"?P.increment+=f.increment:P.increment=f.increment),P}class A extends F.$8u{constructor(f,y){super(S=>this.throttledReport(S)),this.c=f,this.d=y}throttledReport(f){this.c.$progressReport(this.d,f)}}He([(0,R.$mh)(100,(P,f)=>g(P,f),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(ke[149],Se([1,0,29,144,68,112,89,14,2]),function(me,e,I,F,m,L,R,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=e.$JM=e.$IM=void 0;const g=(n,o,a,t)=>{let r=o;return{enumerable:!0,configurable:!1,get(){return r},set(d){if(!a(r,d)){const u=r;r=d,n.listener?.(t(d,u))}}}},A=(n,o)=>n===o,P={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(n,o)=>!(n.length!==o.length||n.some(a=>!o.find(t=>a.id===t.id)))},f=n=>o=>({op:4,update:n(o)}),y=(n,o)=>({range:(()=>{let a;const t=f(r=>({range:I.$ws.lift(w.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return a},set(r){n.listener?.({op:6}),P.range(a,r)||(a=r,n.listener?.(t(r)))}}})(),label:g(n,o,P.label,f(a=>({label:a}))),description:g(n,void 0,P.description,f(a=>({description:a}))),sortText:g(n,void 0,P.sortText,f(a=>({sortText:a}))),canResolveChildren:g(n,!1,P.canResolveChildren,a=>({op:2,state:a})),busy:g(n,!1,P.busy,f(a=>({busy:a}))),error:g(n,void 0,P.error,f(a=>({error:w.MarkdownString.fromStrict(a)||null}))),tags:g(n,[],P.tags,(a,t)=>({op:1,new:a.map(w.TestTag.from),old:t.map(w.TestTag.from)}))}),S=n=>{const o=m.$kJ.fromString(n.extId),a=new c(o.controllerId,o.localId,n.label,E.URI.revive(n.uri)||void 0);return a.range=w.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>w.TestTag.to({id:(0,R.$pJ)(t).tagId})),a},p=n=>{let o;for(const a of n.tests){const t=S(a.item);(0,F.$sM)(t).parent=o,o=t}return o};e.$IM=p;class c{constructor(o,a,t,r){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const d=(0,F.$rM)(this,o);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof s?void 0:d.parent}},children:{value:(0,L.$qM)(d,F.$sM,c),enumerable:!0,writable:!1},...y(d,t)})}}e.$JM=c;class s extends c{constructor(o,a){super(o,o,a,void 0),this._isRoot=!0}}e.$KM=s;class i extends L.$mM{constructor(o,a,t){super({controllerId:o,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:F.$sM,getChildren:r=>r.children,root:new s(o,a),toITestItem:w.TestItem.from})}}e.$LM=i}),define(ke[150],Se([1,0,60,11,122,14,7]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=e.$DM=void 0;class w{static{this.c=new m.$BM("TextEditorDecorationType")}constructor(f,y,S){const p=w.c.nextId();f.$registerTextEditorDecorationType(y.identifier,p,L.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:p,dispose(){f.$removeTextEditorDecorationType(p)}})}}e.$DM=w;class E{constructor(f,y){this.g=[],this.h=void 0,this.j=!1,this.c=f,this.d=f.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(f,y){this.k();let S=null;if(f instanceof R.$xK)S=new R.$yK(f,f);else if(f instanceof R.$yK)S=f;else throw new Error("Unrecognized location");this.l(S,y,!1)}insert(f,y){this.k(),this.l(new R.$yK(f,f),y,!0)}delete(f){this.k();let y=null;if(f instanceof R.$yK)y=f;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(f,y,S){const p=this.c.validateRange(f);this.g.push({range:p,text:y,forceMoveMarkers:S})}setEndOfLine(f){if(this.k(),f!==R.EndOfLine.LF&&f!==R.EndOfLine.CRLF)throw(0,F.$6)("endOfLine");this.h=f}}class g{constructor(f,y,S,p){this.c=f,this.d=y,this._accept(S),this.e=p;const c=this;this.value={get tabSize(){return c.f},set tabSize(s){c.m(s)},get indentSize(){return c.g},set indentSize(s){c.o(s)},get insertSpaces(){return c.h},set insertSpaces(s){c.q(s)},get cursorStyle(){return c.j},set cursorStyle(s){c.s(s)},get lineNumbers(){return c.k},set lineNumbers(s){c.t(s)}}}_accept(f){this.f=f.tabSize,this.g=f.indentSize,this.h=f.insertSpaces,this.j=f.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(f.lineNumbers)}l(f){if(f==="auto")return"auto";if(typeof f=="number"){const y=Math.floor(f);return y>0?y:null}if(typeof f=="string"){const y=parseInt(f,10);return isNaN(y)?null:y>0?y:null}return null}m(f){const y=this.l(f);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(f){if(f==="tabSize")return"tabSize";if(typeof f=="number"){const y=Math.floor(f);return y>0?y:null}if(typeof f=="string"){const y=parseInt(f,10);return isNaN(y)?null:y>0?y:null}return null}o(f){const y=this.n(f);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(f){return f==="auto"?"auto":f==="false"?!1:!!f}q(f){const y=this.p(f);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(f){this.j!==f&&(this.j=f,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:f})))}t(f){this.k!==f&&(this.k=f,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(f)})))}assign(f){const y={};let S=!1;if(typeof f.tabSize<"u"){const p=this.l(f.tabSize);p==="auto"?(S=!0,y.tabSize=p):typeof p=="number"&&this.f!==p&&(this.f=p,S=!0,y.tabSize=p)}if(typeof f.indentSize<"u"){const p=this.n(f.indentSize);p==="tabSize"?(S=!0,y.indentSize=p):typeof p=="number"&&this.g!==p&&(this.g=p,S=!0,y.indentSize=p)}if(typeof f.insertSpaces<"u"){const p=this.p(f.insertSpaces);p==="auto"?(S=!0,y.insertSpaces=p):this.h!==p&&(this.h=p,S=!0,y.insertSpaces=p)}typeof f.cursorStyle<"u"&&this.j!==f.cursorStyle&&(this.j=f.cursorStyle,S=!0,y.cursorStyle=f.cursorStyle),typeof f.lineNumbers<"u"&&this.k!==f.lineNumbers&&(this.k=f.lineNumbers,S=!0,y.lineNumbers=L.TextEditorLineNumbersStyle.from(f.lineNumbers)),S&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(f,y){y.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${f}' failed:'`),this.e.warn(S)})}}e.$EM=g;class A{constructor(f,y,S,p,c,s,i,n){this.id=f,this.j=y,this.k=S,this.g=!1,this.h=new Set,this.c=c,this.d=new g(this.j,this.id,s,S),this.e=i,this.f=n;const o=this;this.value=Object.freeze({get document(){return p.value},set document(a){throw new F.$8("document")},get selection(){return o.c&&o.c[0]},set selection(a){if(!(a instanceof R.$zK))throw(0,F.$6)("selection");o.c=[a],o.l()},get selections(){return o.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof R.$zK)))throw(0,F.$6)("selections");o.c=a,o.l()},get visibleRanges(){return o.e},set visibleRanges(a){throw new F.$8("visibleRanges")},get options(){return o.d.value},set options(a){o.g||o.d.assign(a)},get viewColumn(){return o.f},set viewColumn(a){throw new F.$8("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new E(p.value,t);return a(r),o.m(r)},insertSnippet(a,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=o.c.map(u=>L.Range.from(u));else if(t instanceof R.$xK){const{lineNumber:u,column:l}=L.Position.from(t);d=[{startLineNumber:u,startColumn:l,endLineNumber:u,endColumn:l}]}else if(t instanceof R.$yK)d=[L.Range.from(t)];else{d=[];for(const u of t)if(u instanceof R.$yK)d.push(L.Range.from(u));else{const{lineNumber:l,column:h}=L.Position.from(u);d.push({startLineNumber:l,startColumn:h,endLineNumber:l,endColumn:h})}}return y.$tryInsertSnippet(f,p.value.version,a.value,d,r)},setDecorations(a,t){const r=t.length===0;r&&!o.h.has(a.key)||(r?o.h.delete(a.key):o.h.add(a.key),o.n(()=>{if(L.$tM(t))return y.$trySetDecorations(f,a.key,L.$uM(t));{const d=new Array(4*t.length);for(let u=0,l=t.length;u<l;u++){const h=t[u];d[4*u]=h.start.line+1,d[4*u+1]=h.start.character+1,d[4*u+2]=h.end.line+1,d[4*u+3]=h.end.character+1}return y.$trySetDecorationsFast(f,a.key,d)}}))},revealRange(a,t){o.n(()=>y.$tryRevealRange(f,L.Range.from(a),t||R.TextEditorRevealType.Default))},show(a){y.$tryShowEditor(f,L.ViewColumn.from(a))},hide(){y.$tryHideEditor(f)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(f){(0,I.ok)(!this.g),this.d._accept(f)}_acceptVisibleRanges(f){(0,I.ok)(!this.g),this.e=f}_acceptViewColumn(f){(0,I.ok)(!this.g),this.f=f}_acceptSelections(f){(0,I.ok)(!this.g),this.c=f}async l(){const f=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,f)),this.value}m(f){const y=f.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const S=y.edits.map(c=>c.range);S.sort((c,s)=>c.end.line===s.end.line?c.end.character===s.end.character?c.start.line===s.start.line?c.start.character-s.start.character:c.start.line-s.start.line:c.end.character-s.end.character:c.end.line-s.end.line);for(let c=0,s=S.length-1;c<s;c++){const i=S[c].end;if(S[c+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=y.edits.map(c=>({range:L.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,p,{setEndOfLine:typeof y.setEndOfLine=="number"?L.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(f){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$FM=A}),define(ke[300],Se([1,0,221,23,2,4,3,280,10,7,18,19,14,81,21,177,25]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;function s(o,a){if((0,A.$zf)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class i extends R.$Rc{constructor(a,t,r){super(),this.f=a,this.g=t,this.h=r,this.a=new Map,this.b=new p.$o8;function d(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:u=>d(u)?this.r(u):Array.isArray(u)&&u.length>0?u.map(l=>d(l)?this.r(l):l):u})}registerTreeDataProvider(a,t,r){const d=this.createTreeView(a,{treeDataProvider:t},r);return{dispose:()=>d.dispose()}}createTreeView(a,t,r){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],u=t.dragAndDropController?.dragMimeTypes??[],l=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,k=this.m(a,t,r),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:u,hasHandleDrag:l,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},$=this.f.$registerTreeViewDataProvider(a,D),b={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,c.$uF)(r,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,c.$uF)(r,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(v){(0,y.$8j)(v)&&(0,c.$uF)(r,"treeViewMarkdownMessage"),k.message=v},get title(){return k.title},set title(v){k.title=v},get description(){return k.description},set description(v){k.description=v},get badge(){return k.badge},set badge(v){v!==void 0&&g.ViewBadge.isViewBadge(v)?k.badge={value:Math.floor(Math.abs(v.value)),tooltip:v.tooltip}:v===void 0&&(k.badge=void 0)},reveal:(v,C)=>k.reveal(v,C),dispose:async()=>{await $,this.a.delete(a),k.dispose()}};return this.B(b),b}$getChildren(a,t){const r=this.a.get(a);return r?r.getChildren(t):Promise.reject(new w.$FE(a))}async $handleDrop(a,t,r,d,u,l,h,k){const D=this.a.get(a);if(!D)return Promise.reject(new w.$FE(a));const $=f.DataTransfer.toDataTransfer(r,async b=>(await this.f.$resolveDropFileData(a,t,b)).buffer);return h===a&&k&&await this.j($,D,k,u,l),D.onDrop($,d,u)}async j(a,t,r,d,u){const l=this.b.removeDragOperationTransfer(u);if(l)(await l)?.forEach((h,k)=>{h&&a.set(k,h)});else if(u&&t.handleDrag){const h=t.handleDrag(r,a,d);this.b.addDragOperationTransfer(u,h),await h}return a}async $handleDrag(a,t,r,d){const u=this.a.get(a);if(!u)return Promise.reject(new w.$FE(a));const l=await this.j(new g.$nL,u,t,d,r);if(!(!l||d.isCancellationRequested))return f.DataTransfer.from(l)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new w.$FE(a);return t.hasResolve}$resolve(a,t,r){const d=this.a.get(a);if(!d)throw new w.$FE(a);return d.resolveTreeItem(t,r)}$setExpanded(a,t,r){const d=this.a.get(a);if(!d)throw new w.$FE(a);d.setExpanded(t,r)}$setSelectionAndFocus(a,t,r){const d=this.a.get(a);if(!d)throw new w.$FE(a);d.setSelectionAndFocus(t,r)}$setVisible(a,t){const r=this.a.get(a);if(!r){if(!t)return;throw new w.$FE(a)}r.setVisible(t)}$changeCheckboxState(a,t){const r=this.a.get(a);if(!r)throw new w.$FE(a);r.setCheckboxState(t)}m(a,t,r){const d=this.B(new n(a,t,this.f,this.g.converter,this.h,r));return this.a.set(a,d),d}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$_dc=i;class n extends R.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,A.$If)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,r,d,u,l){if(super(),this.I=a,this.J=r,this.L=d,this.M=u,this.N=l,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Od),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Od),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Od),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Od),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Od),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Od),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Od),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$Yd,l.contributes&&l.contributes.views)for(const $ in l.contributes.views)for(const b of l.contributes.views[$])b.id===a&&(this.P=b.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData($=>this.F.fire({message:!1,element:$})));let h,k;const D=L.Event.debounce(this.F.event,($,b)=>($||($={message:!1,elements:[]}),b.element!==!1&&(h||(h=new Promise(v=>k=v),this.G=this.G.then(()=>h)),Array.isArray(b.element)?$.elements.push(...b.element):$.elements.push(b.element)),b.message&&($.message=!0),$),200,!0);this.B(D(({message:$,elements:b})=>{b.length&&(this.H=this.H.then(()=>{const v=k;return h=null,this.$(b).then(()=>v())})),$&&this.J.$setMessage(this.I,f.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let r=this.X(a);return r||(r=await this.Y(t)),r?r.map(d=>d.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const r=(0,A.$If)(t.select)?!0:t.select,d=(0,A.$If)(t.focus)?!1:t.focus,u=(0,A.$If)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(l=>this.W(a,l[l.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:l.map(k=>k.item)},{select:r,focus:d,expand:u})),l=>this.M.error(l)):this.J.$reveal(this.I,void 0,{select:r,focus:d,expand:u})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=f.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const r=this.getExtensionElement(a);r&&(t?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(a,t){const r=!(0,P.$tb)(this.s,a);this.s=a;const d=this.t!==t;this.t=t,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async r=>{const d=this.getExtensionElement(r.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:r.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);t.forEach(r=>{r.treeItem.checkboxState=r.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(r=>[r.extensionItem,r.newState])})}async handleDrag(a,t,r){const d=[];for(const u of a){const l=this.getExtensionElement(u);l&&d.push(l)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,r),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,r){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,E.$Ng)(()=>this.g?.handleDrop?this.g.handleDrop(d,a,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const r=this.j.get(a);if(r){const d=this.m.get(r);if(d){const u=await this.f.resolveTreeItem(d.extensionItem,r,t)??d.extensionItem;return this.hb(u),d.item.tooltip=this.eb(u.tooltip),d.item.command=this.fb(d.disposableStore,u.command),d.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(r=>this.W(t,r[r.length-1]).then(d=>(r.push(d),r))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,E.$Ng)(()=>this.f.getParent(a))}W(a,t){const r=this.m.get(a);return r?Promise.resolve(r):(0,E.$Ng)(()=>this.f.getTreeItem(a)).then(d=>this.kb(a,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const u=this.getExtensionElement(d);if(u){const l=this.m.get(u);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const r=this.getExtensionElement(a);t=r?this.m.get(r):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new S.$Yd(this.Z.token);try{const r=a?this.m.get(a):void 0,d=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const u=await Promise.all((0,P.$Gb)(d||[]).map(async l=>{const h=await this.f.getTreeItem(l);return h&&!t.token.isCancellationRequested?this.db(l,h,r):null}));return t.token.isCancellationRequested?void 0:(0,P.$Gb)(u)}finally{t.dispose()}}$(a){if(a.some(r=>!r))return this.Z.dispose(!0),this.Z=new S.$Yd,this.tb(),this.J.$refresh(this.I);{const r=this.ab(a);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(a){const t=new Set,r=a.map(u=>this.m.get(u));for(const u of r)if(u&&!t.has(u.item.handle)){let l=u;for(;l&&l.parent&&r.findIndex(h=>l&&l.parent&&h&&h.item.handle===l.parent.item.handle)===-1;){const h=this.j.get(l.parent.item.handle);l=h?this.m.get(h):void 0}l&&!l.parent&&t.add(u.item.handle)}const d=[];return t.forEach(u=>{const l=this.j.get(u);if(l){const h=this.m.get(l);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(u)}}),d}bb(a){const t={};return Promise.all(a.map(r=>this.cb(r).then(d=>{d&&(t[r]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const r=this.m.get(t);if(r)return this.rb(t),(0,E.$Ng)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const u=this.ib(t,d,r.parent);return this.pb(t,u,r,r.parent),r.dispose(),u}return null})}return Promise.resolve(null)}db(a,t,r){const d=this.ib(a,t,r);if(t.id&&this.j.has(d.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(a,d),this.qb(d,r),d}eb(a){return g.$WK.isMarkdownString(a)?f.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,r,d;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,r=a.checkboxState.tooltip,d=a.checkboxState.accessibilityInformation),{isChecked:t===g.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:d}}hb(a){if(!g.$iL.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,r){this.hb(t);const d=this.B(new R.$Qc),u=this.kb(a,t,r),l=this.lb(t);return{item:{handle:u,parentHandle:r?r.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:l,iconDark:this.mb(t)||l,themeIcon:this.jb(t),collapsibleState:(0,A.$If)(t.collapsibleState)?g.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:r,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(a){return a.iconPath instanceof g.$qL?a.iconPath:void 0}kb(a,{id:t,label:r,resourceUri:d},u,l){if(t)return`${n.b}/${t}`;const h=s(r,this.N),k=u?u.item.handle:n.a;let D=h?h.label:d?(0,F.$tg)(d):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const $=this.m.has(a)?this.m.get(a).item.handle:void 0,b=this.X(u)||[];let v,C=0;do{if(v=`${k}/${C}:${D}`,l||!this.j.has(v)||$===v)break;C++}while(C<=b.length);return v}lb(a){if(a.iconPath&&!(a.iconPath instanceof g.$qL))return typeof a.iconPath=="string"||m.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof g.$qL)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return m.URI.isUri(a)?a:m.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,r,d){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(a,t);const u=this.X(d)||[],l=u.filter(h=>h.item.handle===r.item.handle)[0];l&&u.splice(u.indexOf(l),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[301],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[302],Se([1,0,235,11,39,135,108,38,26,301,138,139]),function(me,e,I,F,m,L,R,w,E,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=void 0;const f=w.$jn.as(R.$kn.JSONContribution);class y{constructor(a,t,r){this.a=a,this.b=t,this.c=r}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(m.default.Error,a)}warn(a){this.d(m.default.Warning,a)}info(a){this.d(m.default.Info,a)}}e.$iF=y;class S{static a(a){const t=new E.$0l;for(let r=0,d=a.length;r<d;r++)t.add(a[r].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new S(t,[]);if(!t||!t.length)return new S([],a);const r=this.a(a),d=this.a(t),u=t.filter(h=>!r.has(h.description.identifier)),l=a.filter(h=>!d.has(h.description.identifier));return new S(u,l)}constructor(a,t){this.added=a,this.removed=t}}e.$jF=S;class p{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=S.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,F.$Z)(a)}}}e.$kF=p;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$lF={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$8l},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"*",description:I.localize(42,null),body:"*"}]}},badges:{type:"array",description:I.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(44,null)},href:{type:"string",description:I.localize(45,null)},description:{type:"string",description:I.localize(46,null)}}}},markdown:{type:"string",description:I.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$1n}},extensionPack:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$1n}},extensionKind:{description:I.localize(51,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(52,null)},{body:["workspace"],description:I.localize(53,null)},{body:["ui","workspace"],description:I.localize(54,null)},{body:["workspace","ui"],description:I.localize(55,null)},{body:[],description:I.localize(56,null)}]},capabilities:{description:I.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(60,null),I.localize(61,null),I.localize(62,null)]},description:{type:"string",markdownDescription:I.localize(63,null)}}},untrustedWorkspaces:{description:I.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(66,null),I.localize(67,null),I.localize(68,null)]},restrictedConfigurations:{description:I.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(70,null)}}}}},sponsor:{description:I.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(73,null),type:"string"},"vscode:uninstall":{description:I.localize(74,null),type:"string"}}},icon:{type:"string",description:I.localize(75,null)},l10n:{type:"string",description:I.localize(76,null)},pricing:{type:"string",markdownDescription:I.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new p(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&P.$_E.register(a.extensionPoint,a.activationEventsGenerator),e.$lF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,f.registerSchema(s,e.$lF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$mF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};w.$jn.add(n.ExtensionsRegistry,new i),e.$nF=w.$jn.as(n.ExtensionsRegistry),f.registerSchema(s,e.$lF),f.registerSchema(A.$tj,{properties:{extensionEnabledApiProposals:{description:I.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(ke[303],Se([1,0,231,18,24,302,45,4]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5F=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var g;(function(f){function y(S,p,c){if(!S)return;const s=F.$zf(S.type)?S.type:void 0;if(!s||s.length===0){c.error(I.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const n of S.required)F.$zf(n)&&i.push(n);return{extensionId:p.value,taskType:s,required:i,properties:S.properties?m.$0m(S.properties):{},when:S.when?R.$Qi.deserialize(S.when):void 0}}f.from=y})(g||(g={}));const A=L.$nF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(f,y)=>{for(const S of f)S.type&&y.push(`onTaskType:${S.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:E}});class P{constructor(){this.d=new w.$Od,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,S)=>{A.setHandler((p,c)=>{this.c=void 0;try{for(const s of c.removed){const i=s.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const s of c.added){const i=s.value;for(const n of i){const o=g.from(n,s.description.identifier,s.collector);o&&(this.a[o.taskType]=o)}}(c.removed.length>0||c.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const S of this.all()){const p={type:"object",additionalProperties:!1};S.required.length>0&&(p.required=S.required.slice(0)),S.properties!==void 0?p.properties=m.$0m(S.properties):p.properties=Object.create(null),p.properties.type={type:"string",enum:[S.taskType]},y.push(p)}this.c={oneOf:y}}return this.c}}e.$5F=new P}),define(ke[304],Se([1,0,232,18,23,24,45,303]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$cG=e.JsonSchemaVersion=e.ExecutionEngine=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$9F=e.ShellQuoting=e.$8F=e.$7F=e.$6F=void 0,e.$6F="settings",e.$7F=new R.$0i("taskRunning",!1,I.localize(0,null)),e.$8F={value:I.localize(1,null),original:"Tasks"};var E;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$9F="$customized",function(j){function O(q){if(!q)return j.Strong;switch(q.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=O}(E||(e.ShellQuoting=E={}));var g;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var A;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(A||(e.RevealKind=A={})),function(j){function O(q){switch(q.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=O}(A||(e.RevealKind=A={}));var P;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(j){function O(q){switch(q.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=O}(P||(e.RevealProblemKind=P={}));var f;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(f||(e.PanelKind=f={})),function(j){function O(q){switch(q.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=O}(f||(e.PanelKind=f={}));var y;(function(j){j.defaults={echo:!0,reveal:A.Always,revealProblems:P.Never,focus:!1,panel:f.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var S;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(j){function O(V){switch(V.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=O;function q(V){switch(V){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=q}(S||(e.RuntimeType=S={}));var p;(function(j){function O(q){return F.$zf(q)?q:q.value}j.value=O})(p||(e.CommandString=p={}));var c;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function O(V){return V===j.Clean._id||V===j.Build._id||V===j.Rebuild._id||V===j.Test._id}j.is=O;function q(V){if(V!==void 0)return F.$zf(V)?O(V)?{_id:V,isDefault:!1}:void 0:V}j.from=q})(c||(e.TaskGroup=c={}));var s;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function O(q){switch(q){case j.User:return 2;case j.WorkspaceFile:return 5;default:return 6}}j.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var n;(function(j){j.parallel="parallel",j.sequence="sequence"})(n||(e.DependsOrder=n={}));var o;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var a;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(O,q,V,de,ee,X){this._label="",this._id=O,q&&(this._label=q),V&&(this.type=V),this.runOptions=de,this.configurationProperties=ee,this._source=X}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,q=!1){if(O===void 0)return!1;if(F.$zf(O))return O===this._label||O===this.configurationProperties.identifier||q&&O===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$0F=t;class r extends t{constructor(O,q,V,de,ee,X,Q,ae){super(O,V,void 0,Q,ae,q),this.command={},this._source=q,this.hasDefinedMatchers=X,ee&&(this.command=ee)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let q;switch(this.command?this.command.runtime:void 0){case S.Shell:q="shell";break;case S.Process:q="process";break;case S.CustomExecution:q="customExecution";break;case void 0:q="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:q,_key:this._id,id:this._id}}}static is(O){return O instanceof r}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$6F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(q+=this._source.kind);const V={type:e.$9F,folder:O,id:q};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?m.$tg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new r(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$$F=r;class d extends t{constructor(O,q,V,de,ee,X,Q){super(O,V,de,X,Q,q),this._source=q,this.configures=ee}static is(O){return O instanceof d}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?m.$tg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$6F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(q+=this._source.kind);const V={type:e.$9F,folder:O,id:q};return JSON.stringify(V)}}e.$_F=d;class u extends t{constructor(O,q,V,de,ee,X,Q,ae,x){super(O,V,de,ae,x,q),this.defines=ee,this.hasDefinedMatchers=Q,this.command=X,this.icon=x.icon,this.hide=x.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof u}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new u(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$aG=u;class l extends t{constructor(O,q,V,de,ee,X){super(O,V,de,ee,X,q),this._source=q}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new l(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$bG=l;var h;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(j){j._default=j.Terminal}(h||(e.ExecutionEngine=h={}));var k;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class D{constructor(O){this.c=new Map;for(let q=0;q<O.length;q++)this.c.set(O[q].uri.toString(),q)}compare(O,q){const V=O.getWorkspaceFolder(),de=q.getWorkspaceFolder();if(V&&de){let ee=this.c.get(V.uri.toString());ee=ee===void 0?0:ee+1;let X=this.c.get(de.uri.toString());return X=X===void 0?0:X+1,ee===X?O._label.localeCompare(q._label):ee-X}else return!V&&de?-1:V&&!de?1:0}}e.$cG=D;var $;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})($||(e.TaskEventKind=$={}));var b;(function(j){j.SingleRun="singleRun",j.Background="background"})(b||(e.TaskRunType=b={}));var v;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var C;(function(j){function O(ae){return{taskId:ae._id,taskName:ae.configurationProperties.name,runType:ae.configurationProperties.isBackground?"background":"singleRun",group:ae.configurationProperties.group,__task:ae}}function q(ae,x,se){return{...O(ae),kind:"start",terminalId:x,resolvedVariables:se}}j.start=q;function V(ae,x,se){return{...O(ae),kind:"processStarted",terminalId:x,processId:se}}j.processStarted=V;function de(ae,x,se){return{...O(ae),kind:"processEnded",terminalId:x,exitCode:se}}j.processEnded=de;function ee(ae,x,se){return{...O(ae),kind:"terminated",exitReason:se,terminalId:x}}j.terminated=ee;function X(ae,x,se){return{...O(x),kind:ae,terminalId:se}}j.general=X;function Q(){return{kind:"changed"}}j.changed=Q})(C||(e.TaskEvent=C={}));var N;(function(j){function O(V){const de=Object.keys(V).sort();let ee="";for(const X of de){let Q=V[X];Q instanceof Object?Q=O(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),ee+=X+","+Q+","}return ee}function q(V){const ee={_key:O(V),type:V.taskType};return Object.assign(ee,V),ee}j.create=q})(N||(e.KeyedTaskIdentifier=N={}));var z;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection",j.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var M;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var T;(function(j){function O(q,V){const de=w.$5F.get(q.type);if(de===void 0){const ae=L.$0m(q);return delete ae._key,N.create(ae)}const ee=Object.create(null);ee.type=de.taskType;const X=new Set;de.required.forEach(ae=>X.add(ae));const Q=de.properties;for(const ae of Object.keys(Q)){const x=q[ae];if(x!=null)ee[ae]=x;else if(X.has(ae)){const se=Q[ae];if(se.default!==void 0)ee[ae]=L.$0m(se.default);else switch(se.type){case"boolean":ee[ae]=!1;break;case"number":case"integer":ee[ae]=0;break;case"string":ee[ae]="";break;default:V.error(I.localize(2,null,JSON.stringify(q,void 0,0),ae));return}}}return N.create(ee)}j.createTaskIdentifier=O})(T||(e.TaskDefinition=T={}))}),define(ke[305],Se([1,0,11]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t5b=e.$s5b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,w)=>{this.b=R,this.d=w,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,I.$Z)(R))}then(R,w){return this.j().then(R,w)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$s5b=F;class m extends F{constructor(){super(),this.h=!0,this.i=new I.$4}}e.$t5b=m}),define(ke[69],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tv=e.$sv=e.$rv=e.$qv=void 0;class I{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++I.count}}e.$qv=I;const F=[];function m(w){const E=new I(w);return F[E.nid]=E,E}e.$rv=m;function L(w){return F[w].sid}e.$sv=L;class R{constructor(E){this.value=E}}e.$tv=R}),define(ke[6],Se([1,0,69]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vK=e.$uK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$tK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var m;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput",p[p.ChatEditorInput=10]="ChatEditorInput"})(m||(e.TabInputKind=m={}));var L;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var w;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(w||(e.WebviewMessageArrayBufferViewType=w={}));var E;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var g;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var A;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class P{static{this.a=0}static mixin(c){return c._id=P.a++,c}}e.$tK=P;var f;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.kindModifier="m",p.commandIdent="n",p.commandId="o",p.commandArguments="p"})(f||(e.ISuggestDataDtoField=f={}));var y;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var S;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$uK={MainThreadAuthentication:(0,I.$rv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$rv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,I.$rv)("MainThreadChatProvider"),MainThreadChatAgents:(0,I.$rv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,I.$rv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$rv)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$rv)("MainThreadClipboard"),MainThreadCommands:(0,I.$rv)("MainThreadCommands"),MainThreadComments:(0,I.$rv)("MainThreadComments"),MainThreadConfiguration:(0,I.$rv)("MainThreadConfiguration"),MainThreadConsole:(0,I.$rv)("MainThreadConsole"),MainThreadDebugService:(0,I.$rv)("MainThreadDebugService"),MainThreadDecorations:(0,I.$rv)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$rv)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$rv)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$rv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$rv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$rv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$rv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$rv)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$rv)("MainThreadErrors"),MainThreadTreeViews:(0,I.$rv)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$rv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$rv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$rv)("MainThreadLanguages"),MainThreadLogger:(0,I.$rv)("MainThreadLogger"),MainThreadMessageService:(0,I.$rv)("MainThreadMessageService"),MainThreadOutputService:(0,I.$rv)("MainThreadOutputService"),MainThreadProgress:(0,I.$rv)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$rv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$rv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$rv)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$rv)("MainThreadSecretState"),MainThreadStorage:(0,I.$rv)("MainThreadStorage"),MainThreadSpeech:(0,I.$rv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$rv)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$rv)("MainThreadTerminalService"),MainThreadWebviews:(0,I.$rv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$rv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$rv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$rv)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$rv)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$rv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$rv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$rv)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$rv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$rv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$rv)("MainThreadExtensionService"),MainThreadSCM:(0,I.$rv)("MainThreadSCM"),MainThreadSearch:(0,I.$rv)("MainThreadSearch"),MainThreadShare:(0,I.$rv)("MainThreadShare"),MainThreadTask:(0,I.$rv)("MainThreadTask"),MainThreadWindow:(0,I.$rv)("MainThreadWindow"),MainThreadLabelService:(0,I.$rv)("MainThreadLabelService"),MainThreadNotebook:(0,I.$rv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$rv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$rv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$rv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$rv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$rv)("MainThreadInteractive"),MainThreadChat:(0,I.$rv)("MainThreadChat"),MainThreadInlineChat:(0,I.$rv)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$rv)("MainThreadTheming"),MainThreadTunnelService:(0,I.$rv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$rv)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$rv)("MainThreadTimeline"),MainThreadTesting:(0,I.$rv)("MainThreadTesting"),MainThreadLocalization:(0,I.$rv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$rv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$rv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,I.$rv)("MainThreadIssueReporter")},e.$vK={ExtHostCommands:(0,I.$rv)("ExtHostCommands"),ExtHostConfiguration:(0,I.$rv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$rv)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$rv)("ExtHostDebugService"),ExtHostDecorations:(0,I.$rv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$rv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$rv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$rv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$rv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$rv)("ExtHostEditors"),ExtHostTreeViews:(0,I.$rv)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$rv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$rv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$rv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$rv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$rv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$rv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$rv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$rv)("ExtHostStatusBar"),ExtHostShare:(0,I.$rv)("ExtHostShare"),ExtHostExtensionService:(0,I.$rv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$rv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$rv)("ExtHostTerminalService"),ExtHostSCM:(0,I.$rv)("ExtHostSCM"),ExtHostSearch:(0,I.$rv)("ExtHostSearch"),ExtHostTask:(0,I.$rv)("ExtHostTask"),ExtHostWorkspace:(0,I.$rv)("ExtHostWorkspace"),ExtHostWindow:(0,I.$rv)("ExtHostWindow"),ExtHostWebviews:(0,I.$rv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$rv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$rv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$rv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$rv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$rv)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$rv)("ExtHostProgress"),ExtHostComments:(0,I.$rv)("ExtHostComments"),ExtHostSecretState:(0,I.$rv)("ExtHostSecretState"),ExtHostStorage:(0,I.$rv)("ExtHostStorage"),ExtHostUrls:(0,I.$rv)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$rv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$rv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$rv)("ExtHostOutputService"),ExtHosLabelService:(0,I.$rv)("ExtHostLabelService"),ExtHostNotebook:(0,I.$rv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$rv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$rv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$rv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$rv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$rv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$rv)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$rv)("ExtHostInlineChatShape"),ExtHostChat:(0,I.$rv)("ExtHostChat"),ExtHostChatAgents:(0,I.$rv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,I.$rv)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$rv)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$rv)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$rv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$rv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$rv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$rv)("ExtHostTheming"),ExtHostTunnelService:(0,I.$rv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$rv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$rv)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$rv)("ExtHostTimeline"),ExtHostTesting:(0,I.$rv)("ExtHostTesting"),ExtHostTelemetry:(0,I.$rv)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$rv)("ExtHostLocalization"),ExtHostIssueReporter:(0,I.$rv)("ExtHostIssueReporter")}}),define(ke[306],Se([1,0,6,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;class m{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(I.$uK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,w,E){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(R);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation(w,E)??[]}getRelatedInformation(R,w,E){return this.c.$getAiRelatedInformation(w,E)}registerRelatedInformationProvider(R,w,E){const g=this.b;return this.b++,this.a.set(g,E),this.c.$registerAiRelatedInformationProvider(g,w),new F.$wK(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$bfc=m}),define(ke[91],Se([1,0,5,15,6,20]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=e.$ddc=void 0,e.$ddc=(0,I.$Sh)("IExtHostApiDeprecationService");let R=class{constructor(E,g){this.c=g,this.a=new Set,this.b=E.getProxy(m.$uK.MainThreadTelemetry)}report(E,g,A){const P=this.d(E,g);this.a.has(P)||(this.a.add(P),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:E}))}d(E,g){return`${E}-${g.identifier.value}`}};e.$edc=R,e.$edc=R=He([Be(0,L.$wM),Be(1,F.$aj)],R),e.$fdc=Object.freeze(new class{report(w,E,g){}})}),define(ke[307],Se([1,0,4,6,7,26]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;class R{constructor(g){this.b=new Map,this.c=[],this.d=new I.$Od,this.onDidChangeSessions=this.d.event,this.f=new w,this.g=new w,this.a=g.getProxy(F.$uK.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,A,P,f={}){const y=L.$9l.toKey(g.identifier),S=[...P].sort().join(" ");return await this.f.getOrCreate(`${y} ${A} ${S}`,async()=>{await this.a.$ensureProvider(A);const p=g.displayName||g.name;return this.a.$getSession(A,P,y,p,f)})}async getSessions(g,A,P){const f=L.$9l.toKey(g.identifier),y=[...P].sort().join(" ");return await this.g.getOrCreate(`${f} ${y}`,async()=>{await this.a.$ensureProvider(A);const S=g.displayName||g.name;return this.a.$getSessions(A,P,f,S)})}async removeSession(g,A){const P=this.b.get(g);return P?P.provider.removeSession(A):this.a.$removeSession(g,A)}registerAuthenticationProvider(g,A,P,f){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:A,provider:P,options:f??{supportsMultipleAccounts:!1}}),this.c.find(S=>S.id===g)||this.c.push({id:g,label:A});const y=P.onDidChangeSessions(S=>{this.a.$sendDidChangeSessions(g,{added:S.added??[],changed:S.changed??[],removed:S.removed??[]})});return this.a.$registerAuthenticationProvider(g,A,f?.supportsMultipleAccounts??!1),new m.$wK(()=>{y.dispose(),this.b.delete(g);const S=this.c.findIndex(p=>p.id===g);S>-1&&this.c.splice(S),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,A,P){const f=this.b.get(g);if(f)return Promise.resolve(f.provider.createSession(A,P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,A){const P=this.b.get(g);if(P)return Promise.resolve(P.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,A){const P=this.b.get(g);if(P)return Promise.resolve(P.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,A){return this.d.fire({provider:{id:g,label:A}}),Promise.resolve()}}e.$Lec=R;class w{constructor(){this.a=new Map}getOrCreate(g,A){const P=this.a.get(g);if(P)return P;const f=A().finally(()=>this.a.delete(g));return this.a.set(g,f),f}}}),define(ke[308],Se([1,0,6,20,14]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0;let L=class{constructor(w,E){this.a=w.getProxy(I.$uK.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>E.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(w,E,g){const A=m.WorkspaceEdit.from(w,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,g?.isRefactoring??!1)}};e.$Rec=L,e.$Rec=L=He([Be(0,F.$wM)],L)}),define(ke[309],Se([1,0,10,4,51,3,37,210,6,14]),function(me,e,I,F,m,L,R,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=void 0;class A{static{this.a=0}constructor(y,S){this.extension=y,this.provider=S,this.handle=A.a++}}class P{static{this.a=0}constructor(y,S){this.h=S,this.b=new Map,this.d=new Map,this.e=new F.$Od,this.onDidPerformUserAction=this.e.event,this.g=y.getProxy(E.$uK.MainThreadChat)}registerChatProvider(y,S,p){const c=new A(y,p);return this.b.set(c.handle,c),this.g.$registerChatProvider(c.handle,S),(0,L.$Pc)(()=>{this.g.$unregisterChatProvider(c.handle),this.b.delete(c.handle)})}transferChatSession(y,S){const p=m.Iterable.find(this.d.keys(),c=>this.d.get(c)===y)??0;typeof p=="number"&&this.g.$transferChatSession(p,S)}sendInteractiveRequestToProvider(y,S){this.g.$sendRequestToProvider(y,S)}async $prepareChat(y,S,p){const c=this.b.get(y);if(!c)return;const s=await c.provider.prepareSession(S,p);if(!s)return;const i=P.a++;return this.d.set(i,s),{id:i,requesterUsername:s.requester?.name,requesterAvatarIconUri:s.requester?.icon,responderUsername:s.responder?.name,responderAvatarIconUri:s.responder?.icon,inputPlaceholder:s.inputPlaceholder}}async $provideWelcomeMessage(y,S){const p=this.b.get(y);if(!p||!p.provider.provideWelcomeMessage)return;const c=await p.provider.provideWelcomeMessage(S);if(c)return c.map(s=>typeof s=="string"?s:Array.isArray(s)?s.map(i=>g.ChatReplyFollowup.from(i)):g.MarkdownString.from(s))}async $provideFollowups(y,S,p){const c=this.b.get(y);if(!c)return;const s=this.d.get(S);return!s||!c.provider.provideFollowups?void 0:(await c.provider.provideFollowups(s,p))?.map(n=>g.ChatFollowup.from(n))}async $provideSampleQuestions(y,S){const p=this.b.get(y);if(!p||!p.provider.provideSampleQuestions)return;const c=await p.provider.provideSampleQuestions(S);if(c)return c?.map(s=>g.ChatReplyFollowup.from(s))}$removeRequest(y,S,p){const c=this.b.get(y);if(!c)return;const s=this.d.get(S);s&&c.provider.removeRequest&&c.provider.removeRequest(s,p)}async $provideReply(y,S,p,c){const s=this.b.get(y);if(!s)return;const i=this.d.get(S);if(!i)return;const n={session:i,message:p.message,variables:{}};if(p.variables)for(const u of Object.keys(p.variables))n.variables[u]=p.variables[u].map(g.ChatVariable.to);const o=R.$Kd.create(!1);let a;const t={report:u=>{if(c.isCancellationRequested)return;typeof a>"u"&&(a=o.elapsed());const l=g.ChatResponseProgress.from(s.extension,u);if("placeholder"in u&&"resolvedContent"in u){const h=Promise.all([this.g.$acceptResponseProgress(y,S,l),u.resolvedContent]);(0,I.$Jg)(h,c).then(k=>{if(!k)return;const[D,$]=k;this.g.$acceptResponseProgress(y,S,$,D??void 0)})}else this.g.$acceptResponseProgress(y,S,l)}};let r;try{r=await s.provider.provideResponseWithProgress(n,t,c),r||(r={errorDetails:{message:(0,w.localize)(0,null)}})}catch(u){r={errorDetails:{message:(0,w.localize)(1,null,u.message),responseIsIncomplete:!0}},this.h.error(u)}try{if(i.saveState&&this.d.has(S)){const u=i.saveState();this.g.$acceptChatState(S,u)}}catch(u){this.h.warn(u)}const d={firstProgress:a??0,totalElapsed:o.elapsed()};return{errorDetails:r.errorDetails,timings:d}}async $provideSlashCommands(y,S,p){const c=this.b.get(y);if(!c)return;const s=this.d.get(S);return!s||!c.provider.provideSlashCommands?void 0:(await c.provider.provideSlashCommands(s,p))?.map(n=>({...n,kind:g.CompletionItemKind.from(n.kind)}))}$releaseSession(y){this.d.delete(y)}async $onDidPerformUserAction(y){this.e.fire(y)}}e.$6ec=P}),define(ke[310],Se([1,0,10,3,64,6,14,7]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class E{static{this.a=0}constructor(P,f,y){this.d=f,this.e=y,this.b=new Map,this.c=P.getProxy(L.$uK.MainThreadChatAgents)}registerAgent(P,f,y,S){const p=E.a++;return this.b.set(p,{extension:P,agent:y}),this.c.$registerAgent(p,f,S),(0,F.$Pc)(()=>{this.c.$unregisterAgent(p),this.b.delete(p)})}async $invokeAgent(P,f,y,S,p){const c=this.b.get(P);if(!c){this.e.warn(`[CHAT](${P}) CANNOT invoke agent because the agent is not registered`);return}let s=!1;function i(){if(s)throw new Error("Only valid while executing the command")}const n=new I.$fh;p.onCancellationRequested(()=>n.complete()),setTimeout(()=>n.complete(),10*1e3),this.d.allowListExtensionWhile(c.extension,n.p);const o=c.agent({role:w.ChatMessageRole.User,content:y},{history:S.history.map(R.ChatMessage.to)},new m.$8u(a=>{i(),this.c.$handleProgressChunk(f,{content:g(a.message)?a.message:a.message.value})}),p);try{return await(0,I.$Jg)(Promise.resolve(o).then(a=>{if(a&&"followUp"in a)return{followUp:a?.followUp?.map(r=>R.ChatFollowup.from(r))}}),p)}finally{s=!0,n.complete()}}}e.$dfc=E;function g(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(ke[311],Se([1,0,10,21,43,4,37,18,2,211,64,6,14,7,281,25]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class c{static{this.a=0}constructor(n,o,a){this.i=o,this.j=a,this.b=new Map,this.g=new Map,this.h=new Map,this.d=n.getProxy(P.$uK.MainThreadChatAgents2)}createChatAgent(n,o,a){const t=c.a++,r=new s(n,o,this.d,t,a);return this.b.set(t,r),this.d.$registerAgent(t,o,{}),r.apiAgent}async $invokeAgent(n,o,a,t,r,d){this.g.delete(o);const u=this.b.get(n);if(!u)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let l=!1;function h(){if(l)throw new Error("Only valid while executing the command")}const k=new I.$fh;d.onCancellationRequested(()=>k.complete()),setTimeout(()=>k.complete(),10*1e3),this.i.allowListExtensionWhile(u.extension.identifier,k.p);const D=t.command?await u.validateSlashCommand(t.command):void 0,$=R.$Kd.create(!1);let b;try{const v=u.invoke({prompt:t.message,variables:f.ChatVariable.objectTo(t.variables),slashCommand:D},{history:r.history.map(f.ChatMessage.to)},new A.$8u(C=>{h(),typeof b>"u"&&"content"in C&&(b=$.elapsed());const N=f.ChatResponseProgress.from(u.extension,C);if("placeholder"in C&&"resolvedContent"in C){const z=Promise.all([this.d.$handleProgressChunk(a,N),C.resolvedContent]);(0,I.$Jg)(z,d).then(M=>{if(!M)return;const[T,j]=M;this.d.$handleProgressChunk(a,j,T??void 0)})}else this.d.$handleProgressChunk(a,N)}),d);return await(0,I.$Jg)(Promise.resolve(v).then(C=>{if(C){this.g.set(o,C);let N=this.h.get(o);N||(N=new Map,this.h.set(o,N)),N.set(a,C);const z={firstProgress:b,totalElapsed:$.elapsed()};return{errorDetails:C.errorDetails,timings:z}}else this.g.delete(o)}),d)}catch(v){return this.j.error(v,u.extension),{errorDetails:{message:(0,g.localize)(0,null,(0,m.$Di)(v)),responseIsIncomplete:!0}}}finally{l=!0,k.complete()}}$releaseSession(n){this.g.delete(n),this.h.delete(n)}async $provideSlashCommands(n,o){const a=this.b.get(n);return a?a.provideSlashCommand(o):[]}$provideFollowups(n,o,a){const t=this.b.get(n);if(!t)return Promise.resolve([]);const r=this.g.get(o);return r?t.provideFollowups(r,a):Promise.resolve([])}$acceptFeedback(n,o,a,t){const r=this.b.get(n);if(!r)return;const d=this.h.get(o)?.get(a);if(!d)return;let u;switch(t){case S.InteractiveSessionVoteDirection.Down:u=y.ChatAgentResultFeedbackKind.Unhelpful;break;case S.InteractiveSessionVoteDirection.Up:u=y.ChatAgentResultFeedbackKind.Helpful;break}r.acceptFeedback(Object.freeze({result:d,kind:u}))}$acceptAction(n,o,a,t){const r=this.b.get(n);if(!r)return;const d=this.h.get(o)?.get(a);d&&t.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:t.action,result:d}))}}e.$efc=c;class s{constructor(n,o,a,t,r){this.extension=n,this.n=o,this.o=a,this.q=t,this.r=r,this.l=new L.$Od,this.m=new L.$Od}acceptFeedback(n){this.l.fire(n)}acceptAction(n){this.m.fire(n)}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(F.CancellationToken.None),(0,w.$Jf)(this.b));const o=this.b.find(a=>a.name===n);if(!o)throw new Error(`Unknown slashCommand: ${n}`);return o}async provideSlashCommand(n){if(!this.a)return[];const o=await this.a.provideSlashCommands(n);return o?(this.b=o,o.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate}))):[]}async provideFollowups(n,o){if(!this.d)return[];const a=await this.d.provideFollowups(n,o);return a?a.map(t=>f.ChatFollowup.from(t)):[]}get apiAgent(){let n=!1,o=!1;const a=()=>{n||o||(o=!0,queueMicrotask(()=>{this.o.$updateAgent(this.q,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof E.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof y.$qL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j,isSecondary:this.k}),o=!1}))},t=this;return{get name(){return t.n},get description(){return t.g??""},set description(r){t.g=r,a()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(r){t.h=r,a()},get iconPath(){return t.i},set iconPath(r){t.i=r,a()},get slashCommandProvider(){return t.a},set slashCommandProvider(r){t.a=r,a()},get followupProvider(){return t.d},set followupProvider(r){t.d=r,a()},get isDefault(){return(0,p.$uF)(t.extension,"defaultChatAgent"),t.j},set isDefault(r){(0,p.$uF)(t.extension,"defaultChatAgent"),t.j=r,a()},get isSecondary(){return(0,p.$uF)(t.extension,"defaultChatAgent"),t.k},set isSecondary(r){(0,p.$uF)(t.extension,"defaultChatAgent"),t.k=r,a()},get onDidReceiveFeedback(){return t.l.event},onDidPerformAction:(0,p.$tF)(this.extension,"chatAgents2Additions")?this.m.event:void 0,dispose(){n=!0,t.a=void 0,t.d=void 0,t.l.dispose(),t.o.$unregisterAgent(t.q)}}}invoke(n,o,a,t){return this.r(n,o,a,t)}}}),define(ke[312],Se([1,0,21,3,6,14,64,26,10,4]),function(me,e,I,F,m,L,R,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;class A{constructor(S,p){this.stream=new E.$jh,this.stream=p??new E.$jh;const c=this;this.apiObj={option:S,response:c.stream.asyncIterable}}}class P{constructor(S,p){this.a=new g.$Od,this.b=new Map,this.c=new E.$jh,this.d=!1;const c=this;this.apiObject={result:S,response:c.c.asyncIterable,onDidStartResponseStream:c.a.event,cancel(){p.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,s]of this.b)s.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let p=this.b.get(S.index);p||(this.b.size===0?p=new A(S.index,this.c):p=new A(S.index),this.b.set(S.index,p),this.a.fire(p.apiObj)),p.stream.emitOne(S.part)}}class f{static{this.a=1}constructor(S,p){this.d=p,this.c=new Map,this.e=new Map,this.f=new w.$$l,this.b=S.getProxy(m.$uK.MainThreadChatProvider)}registerProvider(S,p,c,s){const i=f.a++;return this.c.set(i,{extension:S,provider:c}),this.b.$registerProvider(i,p,{extension:S,displayName:s.name??S.value}),(0,F.$Pc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,p,c,s,i){const n=this.c.get(S);if(!n)return;const o=new R.$8u(async a=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${n.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(p,{index:a.index,part:a.part})});return n.provider.provideChatResponse(c.map(L.ChatMessage.to),s,o,i)}allowListExtensionWhile(S,p){this.f.set(S,p),p.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,p){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const c=this;return{get isRevoked(){return!c.f.has(S)},makeRequest(s,i,n){if(!c.f.has(S))throw new Error("Access to chat has been revoked");const o=new I.$Yd(n),a=Math.random()*1e6|0,t=c.b.$fetchResponse(S,p,a,s.map(L.ChatMessage.from),i??{},o.token),r=new P(t,o);return c.e.set(a,{res:r}),t.finally(()=>{c.e.delete(a)}),r.apiObject}}}async $handleResponseFragment(S,p){const c=this.e.get(S);c&&c.res.handleFragment(p)}}e.$$ec=f}),define(ke[313],Se([1,0,3,6,11,14]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class R{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(F.$uK.MainThreadChatVariables)}async $resolveVariable(E,g,A){const P=this.b.get(E);if(P)try{const f=await P.resolver.resolve(P.data.name,{message:g},A);if(f)return f.map(L.ChatVariable.from)}catch(f){(0,m.$1)(f)}}registerVariableResolver(E,g,A,P){const f=R.a++;return this.b.set(f,{extension:E.identifier,data:{name:g,description:A},resolver:P}),this.c.$registerVariable(f,{name:g,description:A}),(0,I.$Pc)(()=>{this.b.delete(f),this.c.$unregisterVariable(f)})}}e.$afc=R}),define(ke[314],Se([1,0,6]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class F{constructor(L){const R=L.getProxy(I.$uK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(w){return R.$writeText(w)}})}}e.$idc=F}),define(ke[35],Se([1,0,18,7,14,24,6,19,15,54,29,53,2,3,5,20,149,22,69,43,37,87,90]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i,n,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=void 0;let r=class{#e;#t;#i;constructor(D,$,b){this.b=new Map,this.c=new Map,this.#e=D.getProxy(R.$uK.MainThreadCommands),this.d=$,this.#i=b,this.#t=D.getProxy(R.$uK.MainThreadTelemetry),this.converter=new d(this,v=>{const C=this.c.get(v);return C?.result===l.Void?C:void 0},$),this.f=[{processArgument(v){return(0,g.$ph)(v)}},{processArgument(v){return(0,L.$_m)(v,function(C){if(A.$ws.isIRange(C))return m.Range.to(C);if(P.$vs.isIPosition(C))return m.Position.to(C);if(A.$ws.isIRange(C.range)&&f.URI.isUri(C.uri))return m.location.to(C);if(C instanceof s.$ce)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(D){this.f.push(D)}registerApiCommand(D){const $=this.registerCommand(!1,D.id,async(...b)=>{const v=D.args.map((N,z)=>{if(!N.validate(b[z]))throw new Error(`Invalid argument '${N.name}' when running '${D.id}', received: ${typeof b[z]=="object"?JSON.stringify(b[z],null,"	"):b[z]} `);return N.convert(b[z])}),C=await this.executeCommand(D.internalId,...v);return D.result.convert(C,b,this.converter)},void 0,{description:D.description,args:D.args,returns:D.result.description});return this.c.set(D.id,D),new F.$wK(()=>{$.dispose(),this.c.delete(D.id)})}registerCommand(D,$,b,v,C,N){if(this.d.trace("ExtHostCommands#registerCommand",$),!$.trim().length)throw new Error("invalid id");if(this.b.has($))throw new Error(`command '${$}' already exists`);return this.b.set($,{callback:b,thisArg:v,metadata:C,extension:N}),D&&this.#e.$registerCommand($),new F.$wK(()=>{this.b.delete($)&&D&&this.#e.$unregisterCommand($)})}executeCommand(D,...$){return this.d.trace("ExtHostCommands#executeCommand",D),this.g(D,$,!0)}async g(D,$,b){if(this.b.has(D))return this.#e.$fireCommandActivationEvent(D),this.h(D,$,!1);{let v=!1;const C=(0,L.$_m)($,function(N){if(N instanceof F.$xK)return m.Position.from(N);if(N instanceof F.$yK)return m.Range.from(N);if(N instanceof F.$IK)return m.location.from(N);if(F.$TL.isNotebookRange(N))return m.NotebookRange.from(N);if(N instanceof ArrayBuffer)return v=!0,s.$ce.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return v=!0,s.$ce.wrap(N);if(N instanceof s.$ce)return v=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(D,v?new i.$tv(C):C,b);return(0,g.$ph)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(D,$,!1);throw N}}}async h(D,$,b){const v=this.b.get(D);if(!v)throw new Error("Unknown command");const{callback:C,thisArg:N,metadata:z}=v;if(z?.args)for(let T=0;T<z.args.length;T++)try{(0,I.$Qf)($[T],z.args[T].constraint)}catch{throw new Error(`Running the contributed command: '${D}' failed. Illegal argument '${z.args[T].name}' - ${z.args[T].description}`)}const M=o.$Kd.create();try{return await C.apply(N,$)}catch(T){if(D===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...$);j&&(D=j.command)}if(this.d.error(T,D,v.extension?.identifier),!b)throw T;if(v.extension?.identifier){const j=this.#i.onExtensionError(v.extension.identifier,T);this.d.trace("forwarded error to extension?",j,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Di)(T)),this.id=D,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,D,M.elapsed())}}j(D,$,b){D.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:D.extension.identifier.value,id:new a.$mo($),duration:b})}$executeContributedCommand(D,...$){this.d.trace("ExtHostCommands#$executeContributedCommand",D);const b=this.b.get(D);return b?($=$.map(v=>this.f.reduce((C,N)=>N.processArgument(C,b.extension?.identifier),v)),this.h(D,$,!0)):Promise.reject(new Error(`Contributed command '${D}' does not exist.`))}getCommands(D=!1){return this.d.trace("ExtHostCommands#getCommands",D),this.#e.$getCommands().then($=>(D&&($=$.filter(b=>b[0]!=="_")),$))}$getContributedCommandMetadata(){const D=Object.create(null);for(const[$,b]of this.b){const{metadata:v}=b;v&&(D[$]=v)}return Promise.resolve(D)}};e.$RM=r,e.$RM=r=He([Be(0,p.$wM),Be(1,E.$aj),Be(2,t.$QM)],r),e.$SM=(0,S.$Sh)("IExtHostCommands");class d{constructor(D,$,b){this.d=D,this.f=$,this.g=b,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(D,$){if(!D)return;const b={$ident:void 0,id:D.command,title:D.title,tooltip:D.tooltip};if(!D.command)return b;const v=this.f(D.command);if(v)b.id=v.internalId,b.arguments=v.args.map((C,N)=>C.convert(D.arguments&&D.arguments[N]));else if((0,w.$Kb)(D.arguments)){const C=`${D.command} /${++this.c}`;this.b.set(C,D),$.add((0,y.$Pc)(()=>{this.b.delete(C),this.g.trace("CommandsConverter#DISPOSE",C)})),b.$ident=C,b.id=this.delegatingCommandId,b.arguments=[C],this.g.trace("CommandsConverter#CREATE",D.command,C)}return b}fromInternal(D){return typeof D.$ident=="string"?this.b.get(D.$ident):{command:D.id,title:D.title,arguments:D.arguments}}getActualCommand(...D){return this.b.get(D[0])}h(...D){const $=this.getActualCommand(...D);return this.g.trace("CommandsConverter#EXECUTE",D[0],$?$.command:"MISSING"),$?this.d.executeCommand($.command,...$.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${D[0]}`)}}e.$TM=d;class u{static{this.Uri=new u("uri","Uri of a text document",D=>f.URI.isUri(D),D=>D)}static{this.Position=new u("position","A position in a text document",D=>F.$xK.isPosition(D),m.Position.from)}static{this.Range=new u("range","A range in a text document",D=>F.$yK.isRange(D),m.Range.from)}static{this.Selection=new u("selection","A selection in a text document",D=>F.$zK.isSelection(D),m.Selection.from)}static{this.Number=new u("number","",D=>typeof D=="number",D=>D)}static{this.String=new u("string","",D=>typeof D=="string",D=>D)}static{this.StringArray=u.Arr(u.String)}static Arr(D){return new u(`${D.name}_array`,`Array of ${D.name}, ${D.description}`,$=>Array.isArray($)&&$.every(b=>D.validate(b)),$=>$.map(b=>D.convert(b)))}static{this.CallHierarchyItem=new u("item","A call hierarchy item",D=>D instanceof F.$SK,m.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new u("item","A type hierarchy item",D=>D instanceof F.$aM,m.TypeHierarchyItem.from)}static{this.TestItem=new u("testItem","A VS Code TestItem",D=>D instanceof c.$JM,m.TestItem.from)}constructor(D,$,b,v){this.name=D,this.description=$,this.validate=b,this.convert=v}optional(){return new u(this.name,`(optional) ${this.description}`,D=>D==null||this.validate(D),D=>D===void 0?void 0:D===null?null:this.convert(D))}with(D,$){return new u(D??this.name,$??this.description,this.validate,this.convert)}}e.$UM=u;class l{static{this.Void=new l("no result",D=>D)}constructor(D,$){this.description=D,this.convert=$}}e.$VM=l;class h{constructor(D,$,b,v,C){this.id=D,this.internalId=$,this.description=b,this.args=v,this.result=C}}e.$WM=h}),define(ke[315],Se([1,0,19,17,2,84,132,45,137,35,14,7]),function(me,e,I,F,m,L,R,w,E,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;const f=[new g.$WM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of DocumentHighlight-instances.",S(A.DocumentHighlight.to))),new g.$WM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$UM.Uri],new g.$VM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,s)=>{if((0,I.$Jb)(c))return;class i extends P.$NK{static to(o){const a=new i(o.name,A.SymbolKind.to(o.kind),o.containerName||"",new P.$IK(s[0],A.Range.to(o.range)));return a.detail=o.detail,a.range=a.location.range,a.selectionRange=A.Range.to(o.selectionRange),a.children=o.children?o.children.map(i.to):[],a}}return c.map(i.to)})),new g.$WM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$UM.Uri,new g.$UM("options","Formatting options",c=>!0,c=>c)],new g.$VM("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new g.$WM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$UM.Uri,g.$UM.Range,new g.$UM("options","Formatting options",c=>!0,c=>c)],new g.$VM("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new g.$WM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$UM.Uri,g.$UM.Position,new g.$UM("ch","Trigger character",c=>typeof c=="string",c=>c),new g.$UM("options","Formatting options",c=>!0,c=>c)],new g.$VM("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new g.$WM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of Location or LocationLink instances.",p)),new g.$WM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of Location or LocationLink instances.",p)),new g.$WM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of Location or LocationLink instances.",p)),new g.$WM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of Location or LocationLink instances.",p)),new g.$WM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of Location-instances.",S(A.location.to))),new g.$WM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of Hover-instances.",S(A.Hover.to))),new g.$WM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$UM.Uri,new g.$UM("position","A position in a text document",c=>Array.isArray(c)&&c.every(s=>P.$xK.isPosition(s)),c=>c.map(A.Position.from))],new g.$VM("A promise that resolves to an array of ranges.",c=>c.map(s=>{let i;for(const n of s.reverse())i=new P.$RK(A.Range.to(n),i);return i}))),new g.$WM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$UM.String.with("query","Search string")],new g.$VM("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(A.WorkspaceSymbol.to))),new g.$WM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(A.CallHierarchyItem.to))),new g.$WM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$UM.CallHierarchyItem],new g.$VM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(A.CallHierarchyIncomingCall.to))),new g.$WM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$UM.CallHierarchyItem],new g.$VM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(A.CallHierarchyOutgoingCall.to))),new g.$WM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:A.Range.to(c.range),placeholder:c.text}})),new g.$WM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$UM.Uri,g.$UM.Position,g.$UM.String.with("newName","The new symbol name")],new g.$VM("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return A.WorkspaceEdit.to(c)}})),new g.$WM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$UM.Uri,g.$UM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$VM("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(A.DocumentLink.to))),new g.$WM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$UM.Uri],new g.$VM("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new P.$LL(c.tokenTypes,c.tokenModifiers)})),new g.$WM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$UM.Uri],new g.$VM("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const s=(0,R.$y$)(c);if(s.type==="full")return new P.$NL(s.data,void 0)})),new g.$WM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$UM.Uri,g.$UM.Range.optional()],new g.$VM("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new P.$LL(c.tokenTypes,c.tokenModifiers)})),new g.$WM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$UM.Uri,g.$UM.Range],new g.$VM("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const s=(0,R.$y$)(c);if(s.type==="full")return new P.$NL(s.data,void 0)})),new g.$WM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$UM.Uri,g.$UM.Position,g.$UM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$UM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$VM("A promise that resolves to a CompletionList-instance.",(c,s,i)=>{if(!c)return new P.$4K([]);const n=c.suggestions.map(o=>A.CompletionItem.to(o,i));return new P.$4K(n,c.incomplete)})),new g.$WM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$UM.Uri,g.$UM.Position,g.$UM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$VM("A promise that resolves to SignatureHelp.",c=>{if(c)return A.SignatureHelp.to(c)})),new g.$WM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$UM.Uri,g.$UM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$VM("A promise that resolves to an array of CodeLens-instances.",(c,s,i)=>S(n=>new P.$VK(A.Range.to(n.range),n.command&&i.fromInternal(n.command)))(c))),new g.$WM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$UM.Uri,new g.$UM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>P.$yK.isRange(c),c=>P.$zK.isSelection(c)?A.Selection.from(c):A.Range.from(c)),g.$UM.String.with("kind","Code action kind to return code actions for").optional(),g.$UM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$VM("A promise that resolves to an array of Command-instances.",(c,s,i)=>S(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return i.fromInternal(n.command)}else{const o=new P.$PK(n.title,n.kind?new P.$QK(n.kind):void 0);return n.edit&&(o.edit=A.WorkspaceEdit.to(n.edit)),n.command&&(o.command=i.fromInternal(n.command)),o.isPreferred=n.isPreferred,o}})(c))),new g.$WM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$UM.Uri],new g.$VM("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(s=>new P.$0K(A.Range.to(s.range),A.Color.to(s.color))):[])),new g.$WM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$UM("color","The color to show and insert",c=>c instanceof P.$9K,A.Color.from),new g.$UM("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:A.Range.from(c.range)}))],new g.$VM("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(A.ColorPresentation.to):[])),new g.$WM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$UM.Uri,g.$UM.Range],new g.$VM("A promise that resolves to an array of Inlay objects",(c,s,i)=>c.map(A.InlayHint.to.bind(void 0,i)))),new g.$WM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$UM.Uri],new g.$VM("A promise that resolves to an array of FoldingRange objects",(c,s)=>{if(c)return c.map(A.FoldingRange.to)})),new g.$WM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$VM("A promise that resolves to an array of NotebookContentProvider static info objects.",S(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(s=>A.NotebookExclusiveDocumentPattern.to(s))})))),new g.$WM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$UM.Uri,g.$UM.Range,new g.$UM("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof P.$yK,c=>A.InlineValueContext.from(c))],new g.$VM("A promise that resolves to an array of InlineValue objects",c=>c.map(A.InlineValue.to))),new g.$WM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$UM("uriOrString","Uri-instance or string (only http/https)",c=>m.URI.isUri(c)||typeof c=="string"&&(0,E.$KU)(c,F.Schemas.http,F.Schemas.https),c=>c),new g.$UM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[A.ViewColumn.from(c),void 0]:[A.ViewColumn.from(c.viewColumn),A.TextEditorOpenOptions.from(c)])).optional(),g.$UM.String.with("label","").optional()],g.$VM.Void),new g.$WM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$UM.Uri.with("resource","Resource to open"),g.$UM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$UM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[A.ViewColumn.from(c),void 0]:[A.ViewColumn.from(c.viewColumn),A.TextEditorOpenOptions.from(c)])).optional()],g.$VM.Void),new g.$WM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$UM.Uri.with("left","Left-hand side resource of the diff editor"),g.$UM.Uri.with("right","Right-hand side resource of the diff editor"),g.$UM.String.with("title","Human readable title for the diff editor").optional(),new g.$UM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[A.ViewColumn.from(c.viewColumn),A.TextEditorOpenOptions.from(c)]).optional()],g.$VM.Void),new g.$WM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(A.TypeHierarchyItem.to))),new g.$WM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$UM.TypeHierarchyItem],new g.$VM("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(A.TypeHierarchyItem.to))),new g.$WM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$UM.TypeHierarchyItem],new g.$VM("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(A.TypeHierarchyItem.to))),new g.$WM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$UM.TestItem],g.$VM.Void),new g.$WM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$UM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$VM.Void),new g.$WM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$UM.String.with("name","The context key name"),new g.$UM("value","The context key value",()=>!0,c=>c)],g.$VM.Void),new g.$WM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$UM.Uri,g.$UM.StringArray,new g.$UM("MappedEditsContext","Mapped Edits Context",c=>A.MappedEditsContext.is(c),c=>A.MappedEditsContext.from(c))],new g.$VM("A promise that resolves to a workspace edit or null",c=>c?A.WorkspaceEdit.to(c):null))];class y{static register(s){f.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",w.$Ri)}}e.$hdc=y;function S(c){return s=>{if(Array.isArray(s))return s.map(c)}}function p(c){if(!Array.isArray(c))return;const s=[];for(const i of c)L.$ht(i)?s.push(A.DefinitionLink.to(i)):s.push(A.location.to(i));return s}}),define(ke[316],Se([1,0,10,59,4,3,2,84,26,14,7,6,25]),function(me,e,I,F,m,L,R,w,E,g,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;function y(S,p,c){const s=S.getProxy(P.$uK.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$$l,p.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const k=this.b.get(h.handle);return k?k.value:h}else if(h&&h.$mid===7){const k=this.b.get(h.commentControlHandle);if(!k)return h;const D=k.getCommentThread(h.commentThreadHandle);return D?D.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const k=this.b.get(h.thread.commentControlHandle);if(!k)return h;const D=k.getCommentThread(h.thread.commentThreadHandle);return D?h.$mid===8?D.value:{thread:D.value,text:h.text}:h}else if(h&&h.$mid===10){const k=this.b.get(h.thread.commentControlHandle);if(!k)return h;const D=k.getCommentThread(h.thread.commentThreadHandle);if(!D)return h;const $=h.commentUniqueId,b=D.getCommentByUniqueId($);return b||h}else if(h&&h.$mid===11){const k=this.b.get(h.thread.commentControlHandle);if(!k)return h;const D=k.getCommentThread(h.thread.commentThreadHandle);if(!D)return h;const $=h.text,b=h.commentUniqueId,v=D.getCommentByUniqueId(b);return v?(typeof v.body=="string"?v.body=$:v.body=new A.$WK($),v):h}return h}})}createCommentController(h,k,D){const $=i.a++,b=new o(h,$,k,D);this.b.set(b.handle,b);const v=this.c.get(h.identifier)||[];return v.push(b),this.c.set(h.identifier,v),b.value}async $createCommentThreadTemplate(h,k,D){const $=this.b.get(h);$&&$.$createCommentThreadTemplate(k,D)}async $updateCommentThreadTemplate(h,k,D){const $=this.b.get(h);$&&$.$updateCommentThreadTemplate(k,D)}$deleteCommentThread(h,k){this.b.get(h)?.$deleteCommentThread(k)}$provideCommentingRanges(h,k,D){const $=this.b.get(h);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const b=c.getDocument(R.URI.revive(k));return(0,I.$Ng)(async()=>{const v=await $.commentingRangeProvider.provideCommentingRanges(b,D);let C;return Array.isArray(v)?C={ranges:v,fileComments:!1}:v?C={ranges:v.ranges||[],fileComments:v.fileComments||!1}:C=v??void 0,C}).then(v=>{let C;return v&&(C={ranges:v.ranges.map(N=>g.Range.from(N)),fileComments:v.fileComments}),C})}$toggleReaction(h,k,D,$,b){const v=this.b.get(h);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,I.$Ng)(()=>{const C=v.getCommentThread(k);if(C){const N=C.getCommentByUniqueId($.uniqueIdInThread);if(v!==void 0&&N&&v.reactionHandler)return v.reactionHandler(N,r(b))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,k,D,$,b,v,C,N){this.m=k,this.n=D,this.o=$,this.p=b,this.q=v,this.extensionDescription=C,this.r=N,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new m.$Od,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Sc,this.l.value=new L.$Qc,this.n===void 0&&(this.n=`${h}.${this.handle}`),s.$createCommentThread(k,this.handle,this.n,this.o,g.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this.i.push({dispose:()=>{s.$deleteCommentThread(k,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(M){z.range=M},get comments(){return z.comments},set comments(M){z.comments=M},get collapsibleState(){return z.collapsibleState},set collapsibleState(M){z.collapsibleState=M},get canReply(){return z.canReply},set canReply(M){z.canReply=M},get contextValue(){return z.contextValue},set contextValue(M){z.contextValue=M},get label(){return z.label},set label(M){z.label=M},get state(){return z.state},set state(M){z.state=M},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Qc);const h=D=>Object.prototype.hasOwnProperty.call(this.b,D),k={};h("range")&&(k.range=g.Range.from(this.p)),h("label")&&(k.label=this.label),h("contextValue")&&(k.contextValue=this.contextValue??null),h("comments")&&(k.comments=this.q.map(D=>a(this,D,this.k,this.extensionDescription))),h("collapsibleState")&&(k.collapseState=d(this.g)),h("canReply")&&(k.canReply=this.canReply),h("state")&&(k.state=u(this.h)),h("isTemplate")&&(k.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(h){for(const k of this.k){const D=k[0],$=k[1];if(h===$)return D}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}He([(0,F.$lh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,k,D,$){this.f=h,this.g=k,this.h=D,this.i=$,this.a=new Map,s.$registerCommentController(this.handle,D,$,this.f.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(v){b.options=v},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(v){b.commentingRangeProvider=v},get reactionHandler(){return b.reactionHandler},set reactionHandler(v){b.reactionHandler=v},createCommentThread(v,C,N){return b.createCommentThread(v,C,N).value},dispose:()=>{b.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(h,k,D){k===void 0&&(0,f.$uF)(this.f,"fileComments");const $=new n(this.id,this.handle,void 0,h,k,D,this.f,!1);return this.a.set($.handle,$),$}$createCommentThreadTemplate(h,k){const D=new n(this.id,this.handle,void 0,R.URI.revive(h),g.Range.to(k),[],this.f,!0);return D.collapsibleState=w.CommentThreadCollapsibleState.Expanded,this.a.set(D.handle,D),D}$updateCommentThreadTemplate(h,k){const D=this.a.get(h);D&&(D.range=g.Range.to(k))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function a(l,h,k,D){let $=k.get(h);return $||($=++l.commentHandle,k.set(h,$)),h.state!==void 0&&(0,f.$uF)(D,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:$,body:typeof h.body=="string"?h.body:g.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(b=>t(b)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(l){return{label:l.label,iconPath:l.iconPath?g.$vM(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function r(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?R.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function d(l){if(l!==void 0)switch(l){case A.CommentThreadCollapsibleState.Expanded:return w.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return w.CommentThreadCollapsibleState.Collapsed}return w.CommentThreadCollapsibleState.Collapsed}function u(l){if(l!==void 0)switch(l){case A.CommentThreadState.Unresolved:return w.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return w.CommentThreadState.Resolved}return w.CommentThreadState.Unresolved}return new i}e.$jdc=y}),define(ke[317],Se([1,0,24,6,27,20]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0;let R=class{constructor(A,P){this.a=A.getProxy(F.$uK.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,P){const f=this,y=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){f.e(A,P,y,arguments)}})}e(A,P,f,y){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:E(y,this.b)}),this.c&&this.f(A,f,y)}};e.$hfc=R,e.$hfc=R=He([Be(0,L.$wM),Be(1,m.$MM)],R);const w=1e5;function E(g,A){const P=[];if(g.length)for(let f=0;f<g.length;f++){let y=g[f];if(typeof y>"u")y="undefined";else if(y instanceof Error){const S=y;S.stack?y=S.stack:y=S.toString()}P.push(y)}if(A){const f=new Error().stack;f&&P.push({__$stack:f.split(`
`).slice(3).join(`
`)})}try{const f=(0,I.$cn)(P);return f.length>w?"Output omitted for a large object that exceeds the limits":f}catch(f){return`Output omitted for an object that cannot be inspected ('${f.toString()}')`}}}),define(ke[151],Se([1,0,2,6,7,5,20,15,19,13,16,25]),function(me,e,I,F,m,L,R,w,E,g,A,P){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=e.$kec=void 0;let y=class{static{f=this}static{this.c=0}static{this.d=250}constructor(p,c){this.h=c,this.f=new Map,this.g=p.getProxy(F.$uK.MainThreadDecorations)}registerFileDecorationProvider(p,c){const s=f.c++;this.f.set(s,{provider:p,extensionDescription:c}),this.g.$registerDecorationProvider(s,c.identifier.value);const i=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(s,null);return}const o=(0,E.$2b)(n);if(o.length<=f.d){this.g.$onDidChange(s,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",c.identifier.value,o.length);const a=o.map(d=>({uri:d,rank:(0,g.$He)(d.path,"/")})),t=(0,E.$yb)(a,(d,u)=>d.rank-u.rank||(0,g.$Ve)(d.uri.path,u.uri.path)),r=[];e:for(const d of t){let u;for(const l of d){const h=(0,A.$lc)(l.uri.path);if(u!==h&&(u=h,r.push(l.uri)>=f.d))break e}}this.g.$onDidChange(s,r)});return new m.$wK(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(p,c,s){if(!this.f.has(p))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(p);return await Promise.all(c.map(async a=>{try{const{uri:t,id:r}=a,d=await Promise.resolve(n.provideFileDecoration(I.URI.revive(t),s));if(!d)return;try{m.$RL.validate(d),d.badge&&typeof d.badge!="string"&&(0,P.$uF)(o,"codiconDecoration"),i[r]=[d.propagate,d.tooltip,d.badge,d.color]}catch(u){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${u}`)}}catch(t){this.h.error(t)}})),i}};e.$kec=y,e.$kec=y=f=He([Be(0,R.$wM),Be(1,w.$aj)],y),e.$lec=(0,L.$Sh)("IExtHostDecorations")}),define(ke[318],Se([1,0,212,136,2,6,7,14,4,15,28,57]),function(me,e,I,F,m,L,R,w,E,g,A,P){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=e.$bdc=void 0;class y{#e;#t;#i;constructor(c,s,i,n,o,a,t,r){this.d=c,this.e=s,this.f=i,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,i),this.#i=new A.$zc(d=>a.getComparisonKey(d)),this.#e=t,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(c,s){if(!c){this.clear();return}this.j();let i=[];if(m.URI.isUri(c)){if(!s){this.delete(c);return}this.#i.set(c,s.slice()),i=[c]}else if(Array.isArray(c)){i=[];let a;c=[...c].sort(y.k);for(const t of c){const[r,d]=t;if((!a||r.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=r,i.push(r),this.#i.set(r,[])),d)this.#i.get(r)?.push(...d);else{const u=this.#i.get(r);u&&(u.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let o=0;for(const a of i){let t=[];const r=this.#i.get(a);if(r)if(r.length>this.g){t=[];const d=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const l of r)if(l.severity===d[u]&&t.push({...w.Diagnostic.from(l),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,I.localize)(0,null,r.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=r.map(d=>({...w.Diagnostic.from(d),modelVersionId:this.h(a)}));if(n.push([a,t]),o+=t.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(c){this.j(),this.#t.fire([c]),this.#i.delete(c),this.#e?.$changeMany(this.e,[[c,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(c,s){this.j();for(const[i,n]of this)c.call(s,i,n,this)}*[Symbol.iterator](){this.j();for(const c of this.#i.keys())yield[c,this.get(c)]}get(c){this.j();const s=this.#i.get(c);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(c){return this.j(),Array.isArray(this.#i.get(c))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(c,s){return c[0].toString()<s[0].toString()?-1:c[0].toString()>s[0].toString()?1:0}}e.$bdc=y;let S=class{static{f=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*f.d}static _mapper(c){const s=new A.$zc;for(const i of c)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(c,s,i,n){this.j=s,this.k=i,this.l=n,this.g=new Map,this.h=new E.$Sd({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,f._mapper),this.f=c.getProxy(L.$uK.MainThreadDiagnostics)}createDiagnosticCollection(c,s){const{g:i,f:n,h:o,j:a,k:t,l:r}=this,d=new class{$changeMany(h,k){n.$changeMany(h,k),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,h,k.length===0?"CLEARING":k)}$clear(h){n.$clear(h),a.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,h)}dispose(){n.dispose()}};let u;if(!s)s="_generated_diagnostic_collection_name_#"+f.c++,u=s;else if(!i.has(s))u=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do u=s+f.c++;while(i.has(u))}return new class extends y{constructor(){super(s,u,f.e,f.d,h=>r.getDocument(h)?.version,t.extUri,d,o),i.set(u,this)}dispose(){super.dispose(),i.delete(u)}}}getDiagnostics(c){if(c)return this.m(c);{const s=new Map,i=[];for(const n of this.g.values())n.forEach((o,a)=>{let t=s.get(o.toString());typeof t>"u"&&(t=i.length,s.set(o.toString(),t),i.push([o,[]])),i[t][1]=i[t][1].concat(...a)});return i}}m(c){let s=[];for(const i of this.g.values())i.has(c)&&(s=s.concat(i.get(c)));return s}$acceptMarkersChange(c){if(!this.n){const s="_generated_mirror",i=new y(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(s,i),this.n=i}for(const[s,i]of c)this.n.set(m.URI.revive(s),i.map(w.Diagnostic.to))}};e.$cdc=S,e.$cdc=S=f=He([Be(1,g.$aj),Be(2,P.$adc)],S)}),define(ke[319],Se([1,0,2,6,25]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;class L{constructor(w){this.a=w.getProxy(F.$uK.MainThreadDialogs)}showOpenDialog(w,E){return E?.allowUIResources&&(0,m.$uF)(w,"showLocal"),this.a.$showOpenDialog(E).then(g=>g?g.map(A=>I.URI.revive(A)):void 0)}showSaveDialog(w){return this.a.$showSaveDialog(w).then(E=>E?I.URI.revive(E):void 0)}}e.$rdc=L}),define(ke[320],Se([1,0,11,2,7,6,17,21,13]),function(me,e,I,F,m,L,R,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;class g{static{this.a=0}constructor(P,f,y){this.d=f,this.e=y,this.b=new Map,this.c=P.getProxy(L.$uK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,f){if(Object.keys(R.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const y=g.a++;this.b.set(y,f),this.c.$registerTextContentProvider(y,P);let S;return typeof f.onDidChange=="function"&&(S=f.onDidChange(p=>{if(p.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this.d.getDocument(p)&&this.$provideTextDocumentContent(y,p).then(c=>{if(!c&&typeof c!="string")return;const s=this.d.getDocument(p);if(!s)return;const i=(0,E.$Qe)(c);if(!s.equalLines(i))return this.c.$onVirtualDocumentChange(p,c)},I.$Z)})),new m.$wK(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(P,f){const y=this.b.get(P);return y?Promise.resolve(y.provideTextDocumentContent(F.URI.revive(f),w.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.$sdc=g}),define(ke[321],Se([1,0,4,3,2,6,143,14,18,24,7,11]),function(me,e,I,F,m,L,R,w,E,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;class f{constructor(S,p){this.a=new I.$Od({onListenerError:P.$1}),this.b=new I.$Od({onListenerError:P.$1}),this.c=new I.$Od({onListenerError:P.$1}),this.d=new I.$Od({onListenerError:P.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Qc,this.h=new Map,this.f=S.getProxy(L.$uK.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(c=>{for(const s of c)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const s of c)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const p=this.g.getDocument(S);if(p)return p}getDocument(S){const p=this.getDocumentData(S);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return p.document}ensureDocumentData(S){const p=this.g.getDocument(S);if(p)return Promise.resolve(p);let c=this.h.get(S.toString());return c||(c=this.f.$tryOpenDocument(S).then(s=>{this.h.delete(S.toString());const i=m.URI.revive(s);return(0,E.$Kf)(this.g.getDocument(i))},s=>(this.h.delete(S.toString()),Promise.reject(s))),this.h.set(S.toString(),c)),c}createDocumentData(S){return this.f.$tryCreateDocument(S).then(p=>m.URI.revive(p))}$acceptModelLanguageChanged(S,p){const c=m.URI.revive(S),s=this.g.getDocument(c);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(p),this.a.fire(s.document)}$acceptModelSaved(S){const p=m.URI.revive(S),c=this.g.getDocument(p);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(S,p){const c=m.URI.revive(S),s=this.g.getDocument(c);if(!s)throw new Error("unknown document");s._acceptIsDirty(p),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,p,c){const s=m.URI.revive(S),i=this.g.getDocument(s);if(!i)throw new Error("unknown document");i._acceptIsDirty(c),i.onEvents(p);let n;p.isUndoing?n=A.TextDocumentChangeReason.Undo:p.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,g.$$m)({document:i.document,contentChanges:p.changes.map(o=>({range:w.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:n}))}setWordDefinitionFor(S,p){(0,R.$yM)(S,p)}}e.$$cc=f}),define(ke[70],Se([1,0,60,4,3,2,5,6,143,20,150,14,15,28,17,51,48]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=e.$GM=void 0;class s{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(o,a){this.h=o,this.i=a,this.a=null,this.b=new Map,this.c=new y.$zc,this.d=new F.$Od,this.e=new F.$Od,this.f=new F.$Od,this.g=new F.$Od,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const a=[],t=[],r=[];if(o.removedDocuments)for(const d of o.removedDocuments){const u=L.URI.revive(d),l=this.c.get(u);l?.unref()&&(this.c.delete(u),a.push(l.value))}if(o.addedDocuments)for(const d of o.addedDocuments){const u=L.URI.revive(d.uri);let l=this.c.get(u);if(l&&u.scheme!==S.Schemas.vscodeNotebookCell&&u.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);l||(l=new s(new E.$zM(this.h.getProxy(w.$uK.MainThreadDocuments),u,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty,d.notebook)),this.c.set(u,l),t.push(l.value)),l.ref()}if(o.removedEditors)for(const d of o.removedEditors){const u=this.b.get(d);this.b.delete(d),u&&r.push(u)}if(o.addedEditors)for(const d of o.addedEditors){const u=L.URI.revive(d.documentUri);I.ok(this.c.has(u),`document '${u}' does not exist`),I.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const l=this.c.get(u).value,h=new A.$FM(d.id,this.h.getProxy(w.$uK.MainThreadTextEditors),this.i,new c.$U(()=>l.document),d.selections.map(P.Selection.to),d.options,d.visibleRanges.map(k=>P.Range.to(k)),typeof d.editorPosition=="number"?P.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}o.newActiveEditor!==void 0&&(I.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,m.$Mc)(a),(0,m.$Mc)(r),o.removedDocuments&&this.e.fire(a),o.addedDocuments&&this.d.fire(t),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return p.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const a=this.b.get(this.a);return o?a:a?.value}allEditors(){return[...this.b.values()]}};e.$GM=i,e.$GM=i=He([Be(0,g.$wM),Be(1,f.$aj)],i),e.$HM=(0,R.$Sh)("IExtHostDocumentsAndEditors")}),define(ke[71],Se([1,0,74,4,18,2,5,6,20,14,7]),function(me,e,I,F,m,L,R,w,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=e.$pec=void 0,e.$pec=(0,R.$Sh)("IExtHostEditorTabs");class P{constructor(c,s,i){this.e=i,this.d=s,this.acceptDtoUpdate(c)}get apiObject(){if(!this.a){const c=this,s={get isActive(){return c.b.id===c.e()},get label(){return c.b.label},get input(){return c.c},get isDirty(){return c.b.isDirty},get isPinned(){return c.b.isPinned},get isPreview(){return c.b.isPreview},get group(){return c.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(c){this.b=c,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$bM(L.URI.revive(this.b.input.uri));case 2:return new A.$cM(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified));case 3:return new A.$dM(L.URI.revive(this.b.input.base),L.URI.revive(this.b.input.input1),L.URI.revive(this.b.input.input2),L.URI.revive(this.b.input.result));case 6:return new A.$eM(L.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$fM(this.b.input.viewType);case 4:return new A.$gM(L.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$hM(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$iM;case 9:return new A.$jM(L.URI.revive(this.b.input.uri),L.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$kM(this.b.input.providerId);default:return}}}class f{constructor(c,s){this.c=[],this.d="",this.b=c,this.e=s;for(const i of c.tabs)i.isActive&&(this.d=i.id),this.c.push(new P(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const c=this,s={get isActive(){return c.b.groupId===c.e()},get viewColumn(){return g.ViewColumn.to(c.b.viewColumn)},get activeTab(){return c.c.find(i=>i.tabId===c.d)?.apiObject},get tabs(){return Object.freeze(c.c.map(i=>i.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(c){this.b=c}acceptTabOperation(c){if(c.kind===0){const i=new P(c.tabDto,this,()=>this.activeTabId());return this.c.splice(c.index,0,i),c.tabDto.isActive&&(this.d=i.tabId),i}else if(c.kind===1){const i=this.c.splice(c.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${c.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(c.kind===3){if(c.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(c.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${c.oldIndex} which does not exist`);return this.c.splice(c.index,0,i),i}const s=this.c.find(i=>i.tabId===c.tabDto.id);if(!s)throw new Error("INVALID tab");return c.tabDto.isActive?this.d=c.tabDto.id:this.d===c.tabDto.id&&!c.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(c.tabDto),s}activeTabId(){return this.d}}let y=class{constructor(c){this.b=new F.$Od,this.c=new F.$Od,this.e=[],this.a=c.getProxy(w.$uK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const c=this,s={onDidChangeTabGroups:c.c.event,onDidChangeTabs:c.b.event,get all(){return Object.freeze(c.e.map(i=>i.apiObject))},get activeTabGroup(){const i=c.d;return(0,m.$Kf)(c.e.find(o=>o.groupId===i)?.apiObject)},close:async(i,n)=>{const o=Array.isArray(i)?i:[i];return o.length?S(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(c){const s=new Set(this.e.map(d=>d.groupId)),i=new Set(c.map(d=>d.groupId)),n=(0,I.$K)(s,i),o=this.e.filter(d=>n.removed.includes(d.groupId)).map(d=>d.apiObject),a=[],t=[];this.e=c.map(d=>{const u=new f(d,()=>this.d);return n.added.includes(u.groupId)?a.push(u.apiObject):t.push(u.apiObject),u});const r=(0,m.$Kf)(c.find(d=>d.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:a,closed:o,changed:t}))}$acceptTabGroupUpdate(c){const s=this.e.find(i=>i.groupId===c.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(c),c.isActive&&(this.d=c.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(c){const s=this.e.find(n=>n.groupId===c.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(c);switch(c.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(c){for(const s of this.e)for(const i of s.tabs)if(i.apiObject===c)return i}h(c){return this.e.find(s=>s.apiObject===c)}async i(c,s){const i=[];for(const n of c){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");i.push(o.tabId)}return this.a.$closeTab(i,s)}async j(c,s){const i=[];for(const n of c){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");i.push(o.groupId)}return this.a.$closeGroup(i,s)}};e.$qec=y,e.$qec=y=He([Be(0,E.$wM)],y);function S(p){return p.tabs!==void 0}}),define(ke[322],Se([1,0,6,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class m{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(I.$uK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,w,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(R);if(!g)throw new Error("Embedding vector provider not found");const A=await g.provideEmbeddingVector(w,E);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,w,E){const g=this.b;return this.b++,this.a.set(g,E),this.c.$registerAiEmbeddingVectorProvider(w,g),new F.$wK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$cfc=m}),define(ke[323],Se([1,0,2,6,3,7,14,173,13,22,25,81]),function(me,e,I,F,m,L,R,w,E,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;class f{constructor(){this.a=[]}add(p){this.b=void 0,this.a.push(p)}delete(p){const c=this.a.indexOf(p);c>=0&&(this.a.splice(c,1),this.b=void 0)}c(){if(!this.b){const p=this.a.sort(),c=[];let s,i,n=14,o=14;for(const a of p){let t=s?(0,E.$5e)(s,a):0;for(t===0?i=1:i=o;t<a.length;t++)t+1===a.length?(n=o,o=9):o+=1,c.push([i,a.toUpperCase().charCodeAt(t),o]),c.push([i,a.toLowerCase().charCodeAt(t),o]),i=o;s=a,o=n}c.push([9,58,10]),c.push([10,47,12]),this.b=new w.$BZ(c)}}provideDocumentLinks(p){this.c();const c=[],s=w.$CZ.computeLinks({getLineContent(i){return p.lineAt(i-1).text},getLineCount(){return p.lineCount}},this.b);for(const i of s){const n=R.DocumentLink.to(i);n.target&&c.push(n)}return c}}class y{constructor(p,c){this.i=c,this.b=new f,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=p.getProxy(F.$uK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(p,c,s,i={}){if(y.j(s),this.d.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(p,"*",this.b));const n=this.h++;this.b.add(c),this.d.add(c),this.c.set(n,s);let o=2;i.isCaseSensitive&&(o+=1024),i.isReadonly&&(o+=2048),typeof s.copy=="function"&&(o+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,A.$uF)(p,"fsChunks"),o+=4);let a;i.isReadonly&&(0,P.$8j)(i.isReadonly)&&((0,A.$uF)(p,"readonlyMessage"),a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,c,o,a).catch(r=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${c}`),console.error(r)});const t=s.onDidChangeFile(r=>{const d=[];for(const u of r){const{uri:l,type:h}=u;if(l.scheme!==c)continue;let k;switch(h){case L.FileChangeType.Changed:k=0;break;case L.FileChangeType.Created:k=1;break;case L.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:l,type:k})}this.a.$onFileSystemChange(n,d)});return(0,m.$Pc)(()=>{t.dispose(),this.b.delete(c),this.d.delete(c),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static k(p){const{type:c,ctime:s,mtime:i,size:n,permissions:o}=p;return{type:c,ctime:s,mtime:i,size:n,permissions:o}}$stat(p,c){return Promise.resolve(this.l(p).stat(I.URI.revive(c))).then(s=>y.k(s))}$readdir(p,c){return Promise.resolve(this.l(p).readDirectory(I.URI.revive(c)))}$readFile(p,c){return Promise.resolve(this.l(p).readFile(I.URI.revive(c))).then(s=>g.$ce.wrap(s))}$writeFile(p,c,s,i){return Promise.resolve(this.l(p).writeFile(I.URI.revive(c),s.buffer,i))}$delete(p,c,s){return Promise.resolve(this.l(p).delete(I.URI.revive(c),s))}$rename(p,c,s,i){return Promise.resolve(this.l(p).rename(I.URI.revive(c),I.URI.revive(s),i))}$copy(p,c,s,i){const n=this.l(p);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(I.URI.revive(c),I.URI.revive(s),i))}$mkdir(p,c){return Promise.resolve(this.l(p).createDirectory(I.URI.revive(c)))}$watch(p,c,s,i){const n=this.l(p).watch(I.URI.revive(s),i);this.f.set(c,n)}$unwatch(p,c){const s=this.f.get(c);s&&(s.dispose(),this.f.delete(c))}$open(p,c,s){const i=this.l(p);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(I.URI.revive(c),s))}$close(p,c){const s=this.l(p);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(c))}$read(p,c,s,i){const n=this.l(p);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const o=g.$ce.alloc(i);return Promise.resolve(n.read(c,s,o.buffer,0,i)).then(a=>o.slice(0,a))}$write(p,c,s,i){const n=this.l(p);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(c,s,i.buffer,0,i.byteLength))}l(p){const c=this.c.get(p);if(!c){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return c}}e.$Ydc=y}),define(ke[72],Se([1,0,6,31,7,22,5,20,57,3,10,23,17]),function(me,e,I,F,m,L,R,w,E,g,A,P,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=e.$Edc=void 0;let S=y=class{constructor(c,s){this.b=new Map,this.c=new A.$4g,this.a=c.getProxy(I.$uK.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let o;const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),o=await a.impl.stat(n)):o=await i.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===F.FilePermission.Readonly?1:void 0}}catch(o){y.e(o)}},async readDirectory(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(o){return y.e(o)}},async createDirectory(n){try{const o=i.b.get(n.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(o.impl,o.extUri,n)):await i.a.$mkdir(n)}catch(o){return y.e(o)}},async readFile(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(o){return y.e(o)}},async writeFile(n,o){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(n)),await i.c.queueFor(n).queue(()=>Promise.resolve(a.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,L.$ce.wrap(o))}catch(a){return y.e(a)}},async delete(n,o){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...o})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(a){return y.e(a)}},async rename(n,o,a){try{return await i.a.$rename(n,o,{overwrite:!1,...a})}catch(t){return y.e(t)}},async copy(n,o,a){try{return await i.a.$copy(n,o,{overwrite:!1,...a})}catch(t){return y.e(t)}},isWritableFileSystem(n){const o=s.getCapabilities(n);if(typeof o=="number")return!(o&2048)}})}async d(c,s,i){const n=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await c.stat(i)).type&F.FileType.Directory))throw m.$JL.FileExists(`Unable to create folder '${i.scheme===f.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(F.$rk(o)!==F.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(i)),i=s.dirname(i)}for(let o=n.length-1;o>=0;o--){i=s.joinPath(i,n[o]);try{await c.createDirectory(i)}catch(a){if(F.$rk(a)!==F.FileSystemProviderErrorCode.FileExists)throw a}}}static e(c){if(c instanceof m.$JL)throw c;if(c instanceof F.$nk)switch(c.code){case F.FileSystemProviderErrorCode.FileExists:throw m.$JL.FileExists(c.message);case F.FileSystemProviderErrorCode.FileNotFound:throw m.$JL.FileNotFound(c.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw m.$JL.FileNotADirectory(c.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw m.$JL.FileIsADirectory(c.message);case F.FileSystemProviderErrorCode.NoPermissions:throw m.$JL.NoPermissions(c.message);case F.FileSystemProviderErrorCode.Unavailable:throw m.$JL.Unavailable(c.message);default:throw new m.$JL(c.message,c.name)}if(!(c instanceof Error))throw new m.$JL(String(c));if(c.name==="ENOPRO"||c.message.includes("ENOPRO"))throw m.$JL.Unavailable(c.message);switch(c.name){case F.FileSystemProviderErrorCode.FileExists:throw m.$JL.FileExists(c.message);case F.FileSystemProviderErrorCode.FileNotFound:throw m.$JL.FileNotFound(c.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw m.$JL.FileNotADirectory(c.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw m.$JL.FileIsADirectory(c.message);case F.FileSystemProviderErrorCode.NoPermissions:throw m.$JL.NoPermissions(c.message);case F.FileSystemProviderErrorCode.Unavailable:throw m.$JL.Unavailable(c.message);default:throw new m.$JL(c.message,c.name)}}addFileSystemProvider(c,s,i){return this.b.set(c,{impl:s,extUri:i?.isCaseSensitive?P.$mg:P.$og,isReadonly:!!i?.isReadonly}),(0,g.$Pc)(()=>this.b.delete(c))}getFileSystemProviderExtUri(c){return this.b.get(c)?.extUri??P.$mg}};e.$Edc=S,e.$Edc=S=y=He([Be(0,w.$wM),Be(1,E.$adc)],S),e.$Fdc=(0,R.$Sh)("IExtHostConsumerFileSystem")}),define(ke[324],Se([1,0,4,34,2,6,14,7,48]),function(me,e,I,F,m,L,R,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;class g{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,S,p,c,s,i){this.a=Math.random(),this.b=new I.$Od,this.c=new I.$Od,this.d=new I.$Od,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,F.$zj)(s),o=typeof s=="string",a=i?.correlate,t=c(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(a&&typeof r.session>"u")){if(!i?.ignoreCreateEvents)for(const d of r.created){const u=m.URI.revive(d);n(u.fsPath)&&(!o||S.getWorkspaceFolder(u))&&this.b.fire(u)}if(!i?.ignoreChangeEvents)for(const d of r.changed){const u=m.URI.revive(d);n(u.fsPath)&&(!o||S.getWorkspaceFolder(u))&&this.c.fire(u)}if(!i?.ignoreDeleteEvents)for(const d of r.deleted){const u=m.URI.revive(d);n(u.fsPath)&&(!o||S.getWorkspaceFolder(u))&&this.d.fire(u)}}});this.g=w.$wK.from(this.i(y,p,s,i,i?.correlate),this.b,this.c,this.d,t)}i(y,S,p,c,s){const i=w.$wK.from();if(typeof p=="string")return i;const n=y.getProxy(L.$uK.MainThreadFileSystemEventService);let o=!1;return(p.pattern.includes(F.$vj)||p.pattern.includes(F.$wj))&&(o=!0),n.$watch(S.identifier.value,this.a,p.baseUri,{recursive:o,excludes:c?.excludes??[]},!!s),w.$wK.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(y){this.a=y,this.session=this.a.session,this.b=new E.$U(()=>this.a.created.map(m.URI.revive)),this.c=new E.$U(()=>this.a.changed.map(m.URI.revive)),this.d=new E.$U(()=>this.a.deleted.map(m.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(y,S,p){this.j=y,this.k=S,this.l=p,this.a=new I.$Od,this.b=new I.$Od,this.c=new I.$Od,this.d=new I.$Od,this.g=new I.$Qd,this.h=new I.$Qd,this.i=new I.$Qd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,S,p,c){return new g(this.j,y,S,this.a.event,R.GlobPattern.from(p),c)}$onFileEvent(y){this.a.fire(new A(y))}$onDidRunFileOperation(y,S){switch(y){case 2:this.b.fire(Object.freeze({files:S.map(p=>({oldUri:m.URI.revive(p.source),newUri:m.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(p=>m.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(p=>m.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,S){return(p,c,s)=>{const i=function(o){p.call(c,o)};return i.extension=y,S.event(i,void 0,s)}}async $onWillRunFileOperation(y,S,p,c){switch(y){case 2:return await this.n(this.g,{files:S.map(s=>({oldUri:m.URI.revive(s.source),newUri:m.URI.revive(s.target)}))},p,c);case 1:return await this.n(this.i,{files:S.map(s=>m.URI.revive(s.target))},p,c);case 0:case 3:return await this.n(this.h,{files:S.map(s=>m.URI.revive(s.target))},p,c)}}async n(y,S,p,c){const s=new Set,i=[];if(await y.fireAsync(S,c,async(o,a)=>{const t=Date.now(),r=await Promise.resolve(o);r instanceof w.$GK&&(i.push([a.extension,r]),s.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>p&&this.k.warn("SLOW file-participant",a.extension.identifier)}),c.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,o]of i){const{edits:a}=R.WorkspaceEdit.from(o,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(s)}}}e.$Zdc=P}),define(ke[325],Se([1,0,3,2,6,14,7,35,10]),function(me,e,I,F,m,L,R,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0;class g{static{this.a=0}constructor(y,S){this.extension=y,this.provider=S,this.handle=g.a++}}class A{constructor(y){this.session=y,this.responses=[]}}class P{static{this.a=0}constructor(y,S,p,c){this.f=p,this.g=c,this.b=new Map,this.d=new Map,this.e=y.getProxy(m.$uK.MainThreadInlineChat),S.registerApiCommand(new w.$WM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new w.$UM("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?L.Range.from(s.initialRange):void 0,initialSelection:s.initialSelection?L.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?L.Position.from(s.position):void 0}})],w.$VM.Void))}registerProvider(y,S,p){const c=new g(y,S);return this.b.set(c.handle,c),this.e.$registerInteractiveEditorProvider(c.handle,p.label,y.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function"),(0,I.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(c.handle),this.b.delete(c.handle)})}async $prepareSession(y,S,p,c){const s=this.b.get(y);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(F.URI.revive(S)),n=L.Selection.to(p),o=await s.provider.prepareInteractiveEditorSession({document:i,selection:n},c);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=P.a++;return this.d.set(a,new A(o)),{id:a,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:L.Range.from(o.wholeRange),message:o.message}}async $provideResponse(y,S,p,c){const s=this.b.get(y);if(!s)return;const i=this.d.get(S.id);if(!i)return;const n={prompt:p.prompt,selection:L.Selection.to(p.selection),wholeRange:L.Range.to(p.wholeRange),attempt:p.attempt,live:p.live};let o=!1;const a={report:async l=>{if(!p.live&&l.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||c.isCancellationRequested||await this.e.$handleProgressChunk(p.requestId,{message:l.message,edits:l.edits?.map(L.TextEdit.from),editsShouldBeInstant:l.editsShouldBeInstant,slashCommand:l.slashCommand?.command,markdownFragment:R.$WK.isMarkdownString(l.content)?l.content.value:l.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,n,a,c));let r;try{r=await(0,E.$Jg)(t,c)}finally{o=!0}if(!r)return;const d=i.responses.push(r)-1,u={wholeRange:L.Range.from(r.wholeRange),placeholder:r.placeholder};if(P.h(r)){const{edits:l,contents:h}=r,k=h!==void 0?L.MarkdownString.from(h):void 0;return l instanceof R.$GK?{...u,id:d,type:"bulkEdit",edits:L.WorkspaceEdit.from(l),message:k}:{...u,id:d,type:"editorEdit",edits:l.map(L.TextEdit.from),message:k}}return{...u,id:d,type:"message",message:L.MarkdownString.from(r.contents)}}$handleFeedback(y,S,p,c){const s=this.b.get(y),i=this.d.get(S),n=i?.responses[p];if(s&&n){const o=L.InteractiveEditorResponseFeedbackKind.to(c);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,o)}}$releaseSession(y,S){}static h(y){return typeof y=="object"&&typeof y.edits=="object"}}e.$7ec=P}),define(ke[326],Se([1,0,2,35]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=void 0;class m{constructor(R,w,E,g,A){this.a=w,this.b=E,this.c=g;const P=new F.$WM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$UM("showOptions","Show Options",f=>!0,f=>f),new F.$UM("resource","Interactive resource Uri",f=>!0,f=>f),new F.$UM("controllerId","Notebook controller Id",f=>!0,f=>f),new F.$UM("title","Interactive editor title",f=>!0,f=>f)],new F.$VM("Notebook and input URI",f=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",f.notebookEditorId),f.notebookEditorId!==void 0){const y=this.a.getEditorById(f.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:I.URI.revive(f.notebookUri),inputUri:I.URI.revive(f.inputUri),notebookEditor:y.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",f.notebookUri,f.inputUri),{notebookUri:I.URI.revive(f.notebookUri),inputUri:I.URI.revive(f.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(R,w,E,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:w,lines:[""],languageId:E,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(I.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,w){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$3ec=m}),define(ke[327],Se([1,0,6,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;class m{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(I.$uK.MainThreadIssueReporter)}async $getIssueReporterUri(R,w){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(R);if(!E)throw new Error("Issue request handler not found");const g=await E.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}async $getIssueReporterData(R,w){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(R);if(!E)throw new Error("Issue data provider not found");const g=await E.provideIssueData(w);if(!g)throw new Error("Issue data provider returned no result");return g}async $getIssueReporterTemplate(R,w){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(R);if(!E)throw new Error("Issue data provider not found");const g=await E.provideIssueTemplate(w);if(!g)throw new Error("Issue template provider returned no result");return g}registerIssueUriRequestHandler(R,w){const E=R.identifier.value;return this.a.set(E,w),this.c.$registerIssueUriRequestHandler(E),new F.$wK(()=>{this.c.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}registerIssueDataProvider(R,w){const E=R.identifier.value;return this.b.set(E,w),this.c.$registerIssueDataProvider(E),new F.$wK(()=>{this.c.$unregisterIssueDataProvider(E),this.b.delete(E)})}}e.$9ec=m}),define(ke[328],Se([1,0,3,6]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class m{constructor(R){this.b=0,this.a=R.getProxy(F.$uK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const w=this.b++;return this.a.$registerResourceLabelFormatter(w,R),(0,I.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(w)})}}e.$jec=m}),define(ke[329],Se([1,0,2,24,14,7,84,6,13,29,19,18,169,21,26,3,132,122,110,37,11,10,25,214]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i,n,o,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=void 0;class d{constructor(B,J){this.d=B,this.e=J}async provideDocumentSymbols(B,J){const re=this.d.getDocument(B),oe=await this.e.provideDocumentSymbols(re,J);if(!(0,A.$Jb)(oe))return oe[0]instanceof L.$OK?oe.map(m.DocumentSymbol.from):d.f(oe)}static f(B){B=B.slice(0).sort((oe,_)=>{let ge=oe.location.range.start.compareTo(_.location.range.start);return ge===0&&(ge=_.location.range.end.compareTo(oe.location.range.end)),ge});const J=[],re=[];for(const oe of B){const _={name:oe.name||"!!MISSING: name!!",kind:m.SymbolKind.from(oe.kind),tags:oe.tags?.map(m.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:m.Range.from(oe.location.range),selectionRange:m.Range.from(oe.location.range),children:[]};for(;;){if(re.length===0){re.push(_),J.push(_);break}const ge=re[re.length-1];if(g.$ws.containsRange(ge.range,_.range)&&!g.$ws.equalsRange(ge.range,_.range)){ge.children?.push(_),re.push(_);break}re.pop()}}return J}}class u{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,J,re){this.g=B,this.h=J,this.j=re,this.e=new i.$0cc("CodeLens"),this.f=new Map}async provideCodeLenses(B,J){const re=this.g.getDocument(B),oe=await this.j.provideCodeLenses(re,J);if(!oe||J.isCancellationRequested)return;const _=this.e.add(oe),ge=new p.$Qc;this.f.set(_,ge);const Ee={cacheId:_,lenses:[]};for(let ze=0;ze<oe.length;ze++)Ee.lenses.push({cacheId:[_,ze],range:m.Range.from(oe[ze].range),command:this.h.toInternal(oe[ze].command,ge)});return Ee}async resolveCodeLens(B,J){const re=B.cacheId&&this.e.get(...B.cacheId);if(!re)return;let oe;if(typeof this.j.resolveCodeLens!="function"||re.isResolved?oe=re:oe=await this.j.resolveCodeLens(re,J),oe||(oe=re),J.isCancellationRequested)return;const _=B.cacheId&&this.f.get(B.cacheId[0]);if(_)return B.command=this.h.toInternal(oe.command??u.d,_),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function l(Pe){return Array.isArray(Pe)?Pe.map(m.DefinitionLink.from):Pe?[m.DefinitionLink.from(Pe)]:[]}class h{constructor(B,J){this.d=B,this.e=J}async provideDefinition(B,J,re){const oe=this.d.getDocument(B),_=m.Position.to(J),ge=await this.e.provideDefinition(oe,_,re);return l(ge)}}class k{constructor(B,J){this.d=B,this.e=J}async provideDeclaration(B,J,re){const oe=this.d.getDocument(B),_=m.Position.to(J),ge=await this.e.provideDeclaration(oe,_,re);return l(ge)}}class D{constructor(B,J){this.d=B,this.e=J}async provideImplementation(B,J,re){const oe=this.d.getDocument(B),_=m.Position.to(J),ge=await this.e.provideImplementation(oe,_,re);return l(ge)}}class ${constructor(B,J){this.d=B,this.e=J}async provideTypeDefinition(B,J,re){const oe=this.d.getDocument(B),_=m.Position.to(J),ge=await this.e.provideTypeDefinition(oe,_,re);return l(ge)}}class b{constructor(B,J){this.d=B,this.e=J}async provideHover(B,J,re){const oe=this.d.getDocument(B),_=m.Position.to(J),ge=await this.e.provideHover(oe,_,re);if(!(!ge||(0,A.$Jb)(ge.contents)))return ge.range||(ge.range=oe.getWordRangeAtPosition(_)),ge.range||(ge.range=new L.$yK(_,_)),m.Hover.from(ge)}}class v{constructor(B,J){this.d=B,this.e=J}async provideEvaluatableExpression(B,J,re){const oe=this.d.getDocument(B),_=m.Position.to(J),ge=await this.e.provideEvaluatableExpression(oe,_,re);if(ge)return m.EvaluatableExpression.from(ge)}}class C{constructor(B,J){this.d=B,this.e=J}async provideInlineValues(B,J,re,oe){const _=this.d.getDocument(B),ge=await this.e.provideInlineValues(_,m.Range.to(J),m.InlineValueContext.to(re),oe);if(Array.isArray(ge))return ge.map(Ee=>m.InlineValue.from(Ee))}}class N{constructor(B,J){this.d=B,this.e=J}async provideDocumentHighlights(B,J,re){const oe=this.d.getDocument(B),_=m.Position.to(J),ge=await this.e.provideDocumentHighlights(oe,_,re);if(Array.isArray(ge))return ge.map(m.DocumentHighlight.from)}}class z{constructor(B,J){this.d=B,this.e=J}async provideLinkedEditingRanges(B,J,re){const oe=this.d.getDocument(B),_=m.Position.to(J),ge=await this.e.provideLinkedEditingRanges(oe,_,re);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,A.$Gb)(ge.ranges.map(m.Range.from)),wordPattern:ge.wordPattern}}}class M{constructor(B,J){this.d=B,this.e=J}async provideReferences(B,J,re,oe){const _=this.d.getDocument(B),ge=m.Position.to(J),Ee=await this.e.provideReferences(_,ge,re,oe);if(Array.isArray(Ee))return Ee.map(m.location.from)}}class T{static{this.d=1e3}constructor(B,J,re,oe,_,ge,Ee){this.g=B,this.h=J,this.j=re,this.k=oe,this.l=_,this.m=ge,this.n=Ee,this.e=new i.$0cc("CodeAction"),this.f=new Map}async provideCodeActions(B,J,re,oe){const _=this.g.getDocument(B),ge=f.$ys.isISelection(J)?m.Selection.to(J):m.Range.to(J),Ee=[];for(const tt of this.j.getDiagnostics(B))if(ge.intersection(tt.range)&&Ee.push(tt)>T.d)break;const ze={diagnostics:Ee,only:re.only?new L.$QK(re.only):void 0,triggerKind:m.CodeActionTriggerKind.to(re.trigger)},We=await this.k.provideCodeActions(_,ge,ze,oe);if(!(0,A.$Kb)(We)||oe.isCancellationRequested)return;const _e=this.e.add(We),Xe=new p.$Qc;this.f.set(_e,Xe);const it=[];for(let tt=0;tt<We.length;tt++){const Ae=We[tt];Ae&&(T.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Xe)})):(ze.only&&(Ae.kind?ze.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[_e,tt],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Xe),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(m.Diagnostic.from),edit:Ae.edit&&m.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$tF)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:_e,actions:it}}async resolveCodeAction(B,J){const[re,oe]=B,_=this.e.get(re,oe);if(!_||T.o(_))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(_,J)??_;let Ee;ge.edit&&(Ee=m.WorkspaceEdit.from(ge.edit,void 0));let ze;if(ge.command){const We=this.f.get(re);We&&(ze=this.h.toInternal(ge.command,We))}return{edit:Ee,command:ze}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class j{static toInternalProviderId(B,J){return B+"."+J}constructor(B,J,re,oe,_){this.d=B,this.e=J,this.f=re,this.g=oe,this.h=_}async prepareDocumentPaste(B,J,re,oe){if(!this.f.prepareDocumentPaste)return;const _=this.e.getDocument(B),ge=J.map(We=>m.Range.to(We)),Ee=m.DataTransfer.toDataTransfer(re,()=>{throw new o.$0});if(await this.f.prepareDocumentPaste(_,ge,Ee,oe),oe.isCancellationRequested)return;const ze=Array.from(Ee).filter(([,We])=>!(We instanceof L.$kL));return m.DataTransfer.from(ze)}async providePasteEdits(B,J,re,oe,_){if(!this.f.provideDocumentPasteEdits)return;const ge=this.e.getDocument(J),Ee=re.map(_e=>m.Range.to(_e)),ze=m.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolvePasteFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentPasteEdits(ge,Ee,ze,_);if(We)return{label:We.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:j.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?m.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class O{constructor(B,J){this.d=B,this.e=J}async provideDocumentFormattingEdits(B,J,re){const oe=this.d.getDocument(B),_=await this.e.provideDocumentFormattingEdits(oe,J,re);if(Array.isArray(_))return _.map(m.TextEdit.from)}}class q{constructor(B,J){this.d=B,this.e=J}async provideDocumentRangeFormattingEdits(B,J,re,oe){const _=this.d.getDocument(B),ge=m.Range.to(J),Ee=await this.e.provideDocumentRangeFormattingEdits(_,ge,re,oe);if(Array.isArray(Ee))return Ee.map(m.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,J,re,oe){(0,P.$Jf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const _=this.d.getDocument(B),ge=J.map(m.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(_,ge,re,oe);if(Array.isArray(Ee))return Ee.map(m.TextEdit.from)}}class V{constructor(B,J){this.d=B,this.e=J,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,J,re,oe,_){const ge=this.d.getDocument(B),Ee=m.Position.to(J),ze=await this.e.provideOnTypeFormattingEdits(ge,Ee,re,oe,_);if(Array.isArray(ze))return ze.map(m.TextEdit.from)}}class de{constructor(B,J){this.e=B,this.f=J,this.d=new i.$0cc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,J){const re=await this.e.provideWorkspaceSymbols(B,J);if(!(0,A.$Kb)(re))return{symbols:[]};const oe=this.d.add(re),_={cacheId:oe,symbols:[]};for(let ge=0;ge<re.length;ge++){const Ee=re[ge];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}_.symbols.push({...m.WorkspaceSymbol.from(Ee),cacheId:[oe,ge]})}return _}async resolveWorkspaceSymbol(B,J){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const re=this.d.get(...B.cacheId);if(re){const oe=await this.e.resolveWorkspaceSymbol(re,J);return oe&&(0,F.$an)(B,m.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class ee{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,J,re){this.d=B,this.e=J,this.f=re}async provideRenameEdits(B,J,re,oe){const _=this.d.getDocument(B),ge=m.Position.to(J);try{const Ee=await this.e.provideRenameEdits(_,ge,re,oe);return Ee?m.WorkspaceEdit.from(Ee):void 0}catch(Ee){const ze=ee.g(Ee);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(B,J,re){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const oe=this.d.getDocument(B),_=m.Position.to(J);try{const ge=await this.e.prepareRename(oe,_,re);let Ee,ze;if(L.$yK.isRange(ge)?(Ee=ge,ze=oe.getText(ge)):(0,P.$Bf)(ge)&&(Ee=ge.range,ze=ge.placeholder),!Ee||!ze)return;if(Ee.start.line>_.line||Ee.end.line<_.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:m.Range.from(Ee),text:ze}}catch(ge){const Ee=ee.g(ge);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(ge)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class X{constructor(B,J){this.resultId=B,this.tokens=J}}class Q{constructor(B,J){this.f=B,this.g=J,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,J,re){const oe=this.f.getDocument(B),_=J!==0?this.d.get(J):null;let ge=typeof _?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(oe,_.resultId,re):await this.g.provideDocumentSemanticTokens(oe,re);return _&&this.d.delete(J),ge?(ge=Q.h(ge),this.o(Q.n(_,ge),ge)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return Q.j(B)?Q.k(B)?B:new L.$NL(new Uint32Array(B.data),B.resultId):Q.l(B)?Q.m(B)?B:new L.$PL(B.edits.map(J=>new L.$OL(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const J of B.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static n(B,J){if(!Q.j(J)||!B||!B.tokens)return J;const re=B.tokens,oe=re.length,_=J.data,ge=_.length;let Ee=0;const ze=Math.min(oe,ge);for(;Ee<ze&&re[Ee]===_[Ee];)Ee++;if(Ee===oe&&Ee===ge)return new L.$PL([],J.resultId);let We=0;const _e=ze-Ee;for(;We<_e&&re[oe-We-1]===_[ge-We-1];)We++;return new L.$PL([{start:Ee,deleteCount:oe-Ee-We,data:_.subarray(Ee,ge-We)}],J.resultId)}o(B,J){if(Q.j(B)){const re=this.e++;return this.d.set(re,new X(B.resultId,B.data)),(0,c.$x$)({id:re,type:"full",data:B.data})}if(Q.l(B)){const re=this.e++;return Q.j(J)?this.d.set(re,new X(J.resultId,J.data)):this.d.set(re,new X(B.resultId)),(0,c.$x$)({id:re,type:"delta",deltas:(B.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}class ae{constructor(B,J){this.d=B,this.e=J}async provideDocumentRangeSemanticTokens(B,J,re){const oe=this.d.getDocument(B),_=await this.e.provideDocumentRangeSemanticTokens(oe,m.Range.to(J),re);return _?this.f(_):null}f(B){return(0,c.$x$)({id:0,type:"full",data:B.data})}}class x{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,J,re,oe,_){this.f=B,this.g=J,this.h=re,this.j=oe,this.k=_,this.d=new i.$0cc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,J,re,oe){const _=this.f.getDocument(B),ge=m.Position.to(J),Ee=_.getWordRangeAtPosition(ge)||new L.$yK(ge,ge),ze=Ee.with({end:ge}),We=new n.$Kd,_e=await this.h.provideCompletionItems(_,ge,oe,m.CompletionContext.to(re));if(!_e||oe.isCancellationRequested)return;const Xe=Array.isArray(_e)?new L.$4K(_e):_e,it=x.supportsResolving(this.h)?this.d.add(Xe.items):this.d.add([]),tt=new p.$Qc;this.e.set(it,tt);const Ae=[],Te={x:it,b:Ae,a:{replace:m.Range.from(Ee),insert:m.Range.from(ze)},c:Xe.isIncomplete||void 0,d:We.elapsed()};for(let qe=0;qe<Xe.items.length;qe++){const Re=Xe.items[qe],Ye=this.l(Re,[it,qe],ze,Ee);Ae.push(Ye)}return Te}async resolveCompletionItem(B,J){if(typeof this.h.resolveCompletionItem!="function")return;const re=this.d.get(...B);if(!re)return;const oe=this.l(re,B),_=await this.h.resolveCompletionItem(re,J);if(!_)return;const ge=this.l(_,B);return(oe.h!==ge.h||oe.i!==ge.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(oe.n!==ge.n||oe.o!==ge.o||!(0,F.$bn)(oe.p,ge.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...oe,d:ge.d,c:ge.c,l:ge.l,h:ge.h,i:ge.i,n:ge.n,o:ge.o,p:ge.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,J,re,oe){const _=this.e.get(J[0]);if(!_)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(B.command,_),Ee={x:J,a:B.label,b:B.kind!==void 0?m.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(m.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:m.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(m.TextEdit.from),n:ge?.$ident,o:ge?.id,p:ge?.$ident?void 0:ge?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=B.textEdit.newText):typeof B.insertText=="string"?Ee.h=B.insertText:B.insertText instanceof L.$HK&&(Ee.h=B.insertText.value,Ee.i|=4);let ze;return B.textEdit?ze=B.textEdit.range:B.range&&(ze=B.range),L.$yK.isRange(ze)?Ee.j=m.Range.from(ze):ze&&(!re?.isEqual(ze.inserting)||!oe?.isEqual(ze.replacing))&&(Ee.j={insert:m.Range.from(ze.inserting),replace:m.Range.from(ze.replacing)}),Ee}}class se{async provideInlineCompletions(B,J,re,oe){}disposeCompletions(B){}handleDidShowCompletionItem(B,J,re){}handlePartialAccept(B,J,re){}}class pe extends se{constructor(B,J,re,oe){super(),this.f=B,this.g=J,this.h=re,this.j=oe,this.d=new G,this.e=(0,t.$tF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$tF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,J,re,oe){const _=this.g.getDocument(B),ge=m.Position.to(J),Ee=await this.h.provideInlineCompletionItems(_,ge,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:m.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[re.triggerKind]},oe);if(!Ee||oe.isCancellationRequested)return;const ze=Array.isArray(Ee)?Ee:Ee.items,We=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],_e=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let Xe;return{pid:this.d.createReferenceId({dispose(){Xe?.dispose()},items:ze}),items:ze.map((tt,Ae)=>{let Te;tt.command&&(Xe||(Xe=new p.$Qc),Te=this.j.toInternal(tt.command,Xe));const qe=tt.insertText;return{insertText:typeof qe=="string"?qe:{snippet:qe.value},filterText:tt.filterText,range:tt.range?m.Range.from(tt.range):void 0,command:Te,idx:Ae,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:We.map(tt=>(Xe||(Xe=new p.$Qc),this.j.toInternal(tt,Xe))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,J,re){const oe=this.d.get(B)?.items[J];oe&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(oe,re)}handlePartialAccept(B,J,re){const oe=this.d.get(B)?.items[J];oe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(oe,re)}}class G{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const J=this.e++;return this.d.set(J,B),J}disposeReferenceId(B){const J=this.d.get(B);return this.d.delete(B),J}get(B){return this.d.get(B)}}class U{constructor(B,J){this.e=B,this.f=J,this.d=new i.$0cc("SignatureHelp")}async provideSignatureHelp(B,J,re,oe){const _=this.e.getDocument(B),ge=m.Position.to(J),Ee=this.g(re),ze=await this.f.provideSignatureHelp(_,ge,oe,Ee);if(ze){const We=this.d.add([ze]);return{...m.SignatureHelp.from(ze),id:We}}}g(B){let J;if(B.activeSignatureHelp){const re=m.SignatureHelp.to(B.activeSignatureHelp),oe=this.d.get(B.activeSignatureHelp.id,0);oe?(J=oe,J.activeSignature=re.activeSignature,J.activeParameter=re.activeParameter):J=re}return{...B,activeSignatureHelp:J}}releaseSignatureHelp(B){this.d.delete(B)}}class ce{constructor(B,J,re,oe,_){this.f=B,this.g=J,this.h=re,this.j=oe,this.k=_,this.d=new i.$0cc("InlayHints"),this.e=new Map}async provideInlayHints(B,J,re){const oe=this.f.getDocument(B),_=m.Range.to(J),ge=await this.h.provideInlayHints(oe,_,re);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${J}`);return}if(re.isCancellationRequested)return;const Ee=this.d.add(ge);this.e.set(Ee,new p.$Qc);const ze={hints:[],cacheId:Ee};for(let We=0;We<ge.length;We++)this.l(ge[We],_)&&ze.hints.push(this.m(ge[We],[Ee,We]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for ${J}`),ze}async resolveInlayHint(B,J){if(typeof this.h.resolveInlayHint!="function")return;const re=this.d.get(...B);if(!re)return;const oe=await this.h.resolveInlayHint(re,J);if(oe&&this.l(oe))return this.m(oe,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,J){return B.label.length===0||Array.isArray(B.label)&&B.label.every(re=>re.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(J&&!J.contains(B.position))}m(B,J){const re=this.e.get(J[0]);if(!re)throw Error("DisposableStore is missing...");const oe={label:"",cacheId:J,tooltip:m.MarkdownString.fromStrict(B.tooltip),position:m.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(m.TextEdit.from),kind:B.kind&&m.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?oe.label=B.label:oe.label=B.label.map(_=>{const ge={label:_.value};return ge.tooltip=m.MarkdownString.fromStrict(_.tooltip),L.$IK.isLocation(_.location)&&(ge.location=m.location.from(_.location)),_.command&&(ge.command=this.g.toInternal(_.command,re)),ge}),oe}}class be{constructor(B,J){this.e=B,this.f=J,this.d=new i.$0cc("DocumentLink")}async provideLinks(B,J){const re=this.e.getDocument(B),oe=await this.f.provideDocumentLinks(re,J);if(!(!Array.isArray(oe)||oe.length===0)&&!J.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:oe.filter(be.g).map(m.DocumentLink.from)};{const _=this.d.add(oe),ge={links:[],cacheId:_};for(let Ee=0;Ee<oe.length;Ee++){if(!be.g(oe[Ee]))continue;const ze=m.DocumentLink.from(oe[Ee]);ze.cacheId=[_,Ee],ge.links.push(ze)}return ge}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,J){if(typeof this.f.resolveDocumentLink!="function")return;const re=this.d.get(...B);if(!re)return;const oe=await this.f.resolveDocumentLink(re,J);if(!(!oe||!be.g(oe)))return m.DocumentLink.from(oe)}releaseLinks(B){this.d.delete(B)}}class H{constructor(B,J){this.d=B,this.e=J}async provideColors(B,J){const re=this.d.getDocument(B),oe=await this.e.provideDocumentColors(re,J);return Array.isArray(oe)?oe.map(ge=>({color:m.Color.from(ge.color),range:m.Range.from(ge.range)})):[]}async provideColorPresentations(B,J,re){const oe=this.d.getDocument(B),_=m.Range.to(J.range),ge=m.Color.to(J.color),Ee=await this.e.provideColorPresentations(ge,{document:oe,range:_},re);if(Array.isArray(Ee))return Ee.map(m.ColorPresentation.from)}}class Z{constructor(B,J){this.d=B,this.e=J}async provideFoldingRanges(B,J,re){const oe=this.d.getDocument(B),_=await this.e.provideFoldingRanges(oe,J,re);if(Array.isArray(_))return _.map(m.FoldingRange.from)}}class Y{constructor(B,J,re){this.d=B,this.e=J,this.f=re}async provideSelectionRanges(B,J,re){const oe=this.d.getDocument(B),_=J.map(m.Position.to),ge=await this.e.provideSelectionRanges(oe,_,re);if(!(0,A.$Kb)(ge))return[];if(ge.length!==_.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let ze=0;ze<_.length;ze++){const We=[];Ee.push(We);let _e=_[ze],Xe=ge[ze];for(;;){if(!Xe.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(We.push(m.SelectionRange.from(Xe)),!Xe.parent)break;_e=Xe.range,Xe=Xe.parent}}return Ee}}class $e{constructor(B,J){this.f=B,this.g=J,this.d=new s.$BM(""),this.e=new Map}async prepareSession(B,J,re){const oe=this.f.getDocument(B),_=m.Position.to(J),ge=await this.g.prepareCallHierarchy(oe,_,re);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(ze=>this.h(Ee,ze)):[this.h(Ee,ge)]}async provideCallsTo(B,J,re){const oe=this.j(B,J);if(!oe)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyIncomingCalls(oe,re);if(_)return _.map(ge=>({from:this.h(B,ge.from),fromRanges:ge.fromRanges.map(Ee=>m.Range.from(Ee))}))}async provideCallsFrom(B,J,re){const oe=this.j(B,J);if(!oe)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyOutgoingCalls(oe,re);if(_)return _.map(ge=>({to:this.h(B,ge.to),fromRanges:ge.fromRanges.map(Ee=>m.Range.from(Ee))}))}releaseSession(B){this.e.delete(B)}h(B,J){const re=this.e.get(B),oe=m.CallHierarchyItem.from(J,B,re.size.toString(36));return re.set(oe._itemId,J),oe}j(B,J){return this.e.get(B)?.get(J)}}class ne{constructor(B,J){this.f=B,this.g=J,this.d=new s.$BM(""),this.e=new Map}async prepareSession(B,J,re){const oe=this.f.getDocument(B),_=m.Position.to(J),ge=await this.g.prepareTypeHierarchy(oe,_,re);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(ze=>this.h(Ee,ze)):[this.h(Ee,ge)]}async provideSupertypes(B,J,re){const oe=this.j(B,J);if(!oe)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySupertypes(oe,re);if(_)return _.map(ge=>this.h(B,ge))}async provideSubtypes(B,J,re){const oe=this.j(B,J);if(!oe)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySubtypes(oe,re);if(_)return _.map(ge=>this.h(B,ge))}releaseSession(B){this.e.delete(B)}h(B,J){const re=this.e.get(B),oe=m.TypeHierarchyItem.from(J,B,re.size.toString(36));return re.set(oe._itemId,J),oe}j(B,J){return this.e.get(B)?.get(J)}}class fe{static toInternalProviderId(B,J){return B+"."+J}constructor(B,J,re,oe,_){this.d=B,this.e=J,this.f=re,this.g=oe,this.h=_}async provideDocumentOnDropEdits(B,J,re,oe,_){const ge=this.e.getDocument(J),Ee=m.Position.to(re),ze=m.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentDropEdits(ge,Ee,ze,_);if(We)return{label:We.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:fe.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?m.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class te{constructor(B,J){this.d=B,this.e=J}async provideMappedEdits(B,J,re,oe){const _=I.URI.revive(B),ge=this.d.getDocument(_),Ee=re.documents.map(_e=>_e.map(Xe=>({uri:I.URI.revive(Xe.uri),version:Xe.version,ranges:Xe.ranges.map(it=>m.Range.to(it))}))),ze={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(ge,J,ze,oe);return We?m.WorkspaceEdit.from(We):null}}class he{constructor(B,J){this.adapter=B,this.extension=J}}class we{static{this.d=0}constructor(B,J,re,oe,_,ge,Ee,ze){this.g=J,this.h=re,this.j=oe,this.k=_,this.l=ge,this.m=Ee,this.n=ze,this.f=new Map,this.e=B.getProxy(w.$uK.MainThreadLanguageFeatures)}o(B,J){return m.DocumentSelector.from(B,this.g,J)}p(B){return new L.$wK(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return we.d++}async s(B,J,re,oe,_,ge=!1){const Ee=this.f.get(B);if(!Ee||!(Ee.adapter instanceof J))return oe;const ze=Date.now();ge||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${re.toString().replace(/[\r\n]/g,"")}'`);const We=re(Ee.adapter,Ee.extension);return Promise.resolve(We).catch(_e=>{(0,o.$3)(_e)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ee.extension.identifier,_e))}).finally(()=>{ge||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),y.CancellationToken.isCancellationToken(_)?(0,a.$Kg)(We,_):We}t(B,J){const re=this.q();return this.f.set(re,new he(B,J)),re}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,J,re,oe){const _=this.t(new d(this.h,re),B),ge=oe&&oe.label||we.u(B);return this.e.$registerDocumentSymbolProvider(_,this.o(J,B),ge),this.p(_)}$provideDocumentSymbols(B,J,re){return this.s(B,d,oe=>oe.provideDocumentSymbols(I.URI.revive(J),re),void 0,re)}registerCodeLensProvider(B,J,re){const oe=this.q(),_=typeof re.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(oe,new he(new u(this.h,this.j.converter,re),B)),this.e.$registerCodeLensSupport(oe,this.o(J,B),_);let ge=this.p(oe);if(_!==void 0){const Ee=re.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(_));ge=L.$wK.from(ge,Ee)}return ge}$provideCodeLenses(B,J,re){return this.s(B,u,oe=>oe.provideCodeLenses(I.URI.revive(J),re),void 0,re)}$resolveCodeLens(B,J,re){return this.s(B,u,oe=>oe.resolveCodeLens(J,re),void 0,void 0)}$releaseCodeLenses(B,J){this.s(B,u,re=>Promise.resolve(re.releaseCodeLenses(J)),void 0,void 0)}registerDefinitionProvider(B,J,re){const oe=this.t(new h(this.h,re),B);return this.e.$registerDefinitionSupport(oe,this.o(J,B)),this.p(oe)}$provideDefinition(B,J,re,oe){return this.s(B,h,_=>_.provideDefinition(I.URI.revive(J),re,oe),[],oe)}registerDeclarationProvider(B,J,re){const oe=this.t(new k(this.h,re),B);return this.e.$registerDeclarationSupport(oe,this.o(J,B)),this.p(oe)}$provideDeclaration(B,J,re,oe){return this.s(B,k,_=>_.provideDeclaration(I.URI.revive(J),re,oe),[],oe)}registerImplementationProvider(B,J,re){const oe=this.t(new D(this.h,re),B);return this.e.$registerImplementationSupport(oe,this.o(J,B)),this.p(oe)}$provideImplementation(B,J,re,oe){return this.s(B,D,_=>_.provideImplementation(I.URI.revive(J),re,oe),[],oe)}registerTypeDefinitionProvider(B,J,re){const oe=this.t(new $(this.h,re),B);return this.e.$registerTypeDefinitionSupport(oe,this.o(J,B)),this.p(oe)}$provideTypeDefinition(B,J,re,oe){return this.s(B,$,_=>_.provideTypeDefinition(I.URI.revive(J),re,oe),[],oe)}registerHoverProvider(B,J,re,oe){const _=this.t(new b(this.h,re),B);return this.e.$registerHoverProvider(_,this.o(J,B)),this.p(_)}$provideHover(B,J,re,oe){return this.s(B,b,_=>_.provideHover(I.URI.revive(J),re,oe),void 0,oe)}registerEvaluatableExpressionProvider(B,J,re,oe){const _=this.t(new v(this.h,re),B);return this.e.$registerEvaluatableExpressionProvider(_,this.o(J,B)),this.p(_)}$provideEvaluatableExpression(B,J,re,oe){return this.s(B,v,_=>_.provideEvaluatableExpression(I.URI.revive(J),re,oe),void 0,oe)}registerInlineValuesProvider(B,J,re,oe){const _=typeof re.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new C(this.h,re),B);this.e.$registerInlineValuesProvider(ge,this.o(J,B),_);let Ee=this.p(ge);if(_!==void 0){const ze=re.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(_));Ee=L.$wK.from(Ee,ze)}return Ee}$provideInlineValues(B,J,re,oe,_){return this.s(B,C,ge=>ge.provideInlineValues(I.URI.revive(J),re,oe,_),void 0,_)}registerDocumentHighlightProvider(B,J,re){const oe=this.t(new N(this.h,re),B);return this.e.$registerDocumentHighlightProvider(oe,this.o(J,B)),this.p(oe)}$provideDocumentHighlights(B,J,re,oe){return this.s(B,N,_=>_.provideDocumentHighlights(I.URI.revive(J),re,oe),void 0,oe)}registerLinkedEditingRangeProvider(B,J,re){const oe=this.t(new z(this.h,re),B);return this.e.$registerLinkedEditingRangeProvider(oe,this.o(J,B)),this.p(oe)}$provideLinkedEditingRanges(B,J,re,oe){return this.s(B,z,async _=>{const ge=await _.provideLinkedEditingRanges(I.URI.revive(J),re,oe);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?we.w(ge.wordPattern):void 0}},void 0,oe)}registerReferenceProvider(B,J,re){const oe=this.t(new M(this.h,re),B);return this.e.$registerReferenceSupport(oe,this.o(J,B)),this.p(oe)}$provideReferences(B,J,re,oe,_){return this.s(B,M,ge=>ge.provideReferences(I.URI.revive(J),re,oe,_),void 0,_)}registerCodeActionProvider(B,J,re,oe){const _=new p.$Qc,ge=this.t(new T(this.h,this.j.converter,this.k,re,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(ge,this.o(J,B),{providedKinds:oe?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:oe?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,_)}))},we.u(B),!!re.resolveCodeAction),_.add(this.p(ge)),_}$provideCodeActions(B,J,re,oe,_){return this.s(B,T,ge=>ge.provideCodeActions(I.URI.revive(J),re,oe,_),void 0,_)}$resolveCodeAction(B,J,re){return this.s(B,T,oe=>oe.resolveCodeAction(J,re),{},void 0)}$releaseCodeActions(B,J){this.s(B,T,re=>Promise.resolve(re.releaseCodeActions(J)),void 0,void 0)}registerDocumentFormattingEditProvider(B,J,re){const oe=this.t(new O(this.h,re),B);return this.e.$registerDocumentFormattingSupport(oe,this.o(J,B),B.identifier,B.displayName||B.name),this.p(oe)}$provideDocumentFormattingEdits(B,J,re,oe){return this.s(B,O,_=>_.provideDocumentFormattingEdits(I.URI.revive(J),re,oe),void 0,oe)}registerDocumentRangeFormattingEditProvider(B,J,re){const oe=typeof re.provideDocumentRangesFormattingEdits=="function",_=this.t(new q(this.h,re),B);return this.e.$registerRangeFormattingSupport(_,this.o(J,B),B.identifier,B.displayName||B.name,oe),this.p(_)}$provideDocumentRangeFormattingEdits(B,J,re,oe,_){return this.s(B,q,ge=>ge.provideDocumentRangeFormattingEdits(I.URI.revive(J),re,oe,_),void 0,_)}$provideDocumentRangesFormattingEdits(B,J,re,oe,_){return this.s(B,q,ge=>ge.provideDocumentRangesFormattingEdits(I.URI.revive(J),re,oe,_),void 0,_)}registerOnTypeFormattingEditProvider(B,J,re,oe){const _=this.t(new V(this.h,re),B);return this.e.$registerOnTypeFormattingSupport(_,this.o(J,B),oe,B.identifier),this.p(_)}$provideOnTypeFormattingEdits(B,J,re,oe,_,ge){return this.s(B,V,Ee=>Ee.provideOnTypeFormattingEdits(I.URI.revive(J),re,oe,_,ge),void 0,ge)}registerWorkspaceSymbolProvider(B,J){const re=this.t(new de(J,this.l),B);return this.e.$registerNavigateTypeSupport(re,typeof J.resolveWorkspaceSymbol=="function"),this.p(re)}$provideWorkspaceSymbols(B,J,re){return this.s(B,de,oe=>oe.provideWorkspaceSymbols(J,re),{symbols:[]},re)}$resolveWorkspaceSymbol(B,J,re){return this.s(B,de,oe=>oe.resolveWorkspaceSymbol(J,re),void 0,void 0)}$releaseWorkspaceSymbols(B,J){this.s(B,de,re=>re.releaseWorkspaceSymbols(J),void 0,void 0)}registerRenameProvider(B,J,re){const oe=this.t(new ee(this.h,re,this.l),B);return this.e.$registerRenameSupport(oe,this.o(J,B),ee.supportsResolving(re)),this.p(oe)}$provideRenameEdits(B,J,re,oe,_){return this.s(B,ee,ge=>ge.provideRenameEdits(I.URI.revive(J),re,oe,_),void 0,_)}$resolveRenameLocation(B,J,re,oe){return this.s(B,ee,_=>_.resolveRenameLocation(I.URI.revive(J),re,oe),void 0,oe)}registerDocumentSemanticTokensProvider(B,J,re,oe){const _=this.t(new Q(this.h,re),B),ge=typeof re.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(_,this.o(J,B),oe,ge);let Ee=this.p(_);if(ge){const ze=re.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(ge));Ee=L.$wK.from(Ee,ze)}return Ee}$provideDocumentSemanticTokens(B,J,re,oe){return this.s(B,Q,_=>_.provideDocumentSemanticTokens(I.URI.revive(J),re,oe),null,oe)}$releaseDocumentSemanticTokens(B,J){this.s(B,Q,re=>re.releaseDocumentSemanticColoring(J),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,J,re,oe){const _=this.t(new ae(this.h,re),B);return this.e.$registerDocumentRangeSemanticTokensProvider(_,this.o(J,B),oe),this.p(_)}$provideDocumentRangeSemanticTokens(B,J,re,oe){return this.s(B,ae,_=>_.provideDocumentRangeSemanticTokens(I.URI.revive(J),re,oe),null,oe)}registerCompletionItemProvider(B,J,re,oe){const _=this.t(new x(this.h,this.j.converter,re,this.m,B),B);return this.e.$registerCompletionsProvider(_,this.o(J,B),oe,x.supportsResolving(re),B.identifier),this.p(_)}$provideCompletionItems(B,J,re,oe,_){return this.s(B,x,ge=>ge.provideCompletionItems(I.URI.revive(J),re,oe,_),void 0,_)}$resolveCompletionItem(B,J,re){return this.s(B,x,oe=>oe.resolveCompletionItem(J,re),void 0,re)}$releaseCompletionItems(B,J){this.s(B,x,re=>re.releaseCompletionItems(J),void 0,void 0)}registerInlineCompletionsProvider(B,J,re,oe){const _=new pe(B,this.h,re,this.j.converter),ge=this.t(_,B);return this.e.$registerInlineCompletionsSupport(ge,this.o(J,B),_.supportsHandleEvents,S.$9l.toKey(B.identifier.value),oe?.yieldTo?.map(Ee=>S.$9l.toKey(Ee))||[]),this.p(ge)}$provideInlineCompletions(B,J,re,oe,_){return this.s(B,se,ge=>ge.provideInlineCompletions(I.URI.revive(J),re,oe,_),void 0,_)}$handleInlineCompletionDidShow(B,J,re,oe){this.s(B,se,async _=>{_.handleDidShowCompletionItem(J,re,oe)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,J,re,oe){this.s(B,se,async _=>{_.handlePartialAccept(J,re,oe)},void 0,void 0)}$freeInlineCompletionsList(B,J){this.s(B,se,async re=>{re.disposeCompletions(J)},void 0,void 0)}registerSignatureHelpProvider(B,J,re,oe){const _=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ge=this.t(new U(this.h,re),B);return this.e.$registerSignatureHelpProvider(ge,this.o(J,B),_),this.p(ge)}$provideSignatureHelp(B,J,re,oe,_){return this.s(B,U,ge=>ge.provideSignatureHelp(I.URI.revive(J),re,oe,_),void 0,_)}$releaseSignatureHelp(B,J){this.s(B,U,re=>re.releaseSignatureHelp(J),void 0,void 0)}registerInlayHintsProvider(B,J,re){const oe=typeof re.onDidChangeInlayHints=="function"?this.q():void 0,_=this.t(new ce(this.h,this.j.converter,re,this.l,B),B);this.e.$registerInlayHintsProvider(_,this.o(J,B),typeof re.resolveInlayHint=="function",oe,we.u(B));let ge=this.p(_);if(oe!==void 0){const Ee=re.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(oe));ge=L.$wK.from(ge,Ee)}return ge}$provideInlayHints(B,J,re,oe){return this.s(B,ce,_=>_.provideInlayHints(I.URI.revive(J),re,oe),void 0,oe)}$resolveInlayHint(B,J,re){return this.s(B,ce,oe=>oe.resolveInlayHint(J,re),void 0,re)}$releaseInlayHints(B,J){this.s(B,ce,re=>re.releaseHints(J),void 0,void 0)}registerDocumentLinkProvider(B,J,re){const oe=this.t(new be(this.h,re),B);return this.e.$registerDocumentLinkProvider(oe,this.o(J,B),typeof re.resolveDocumentLink=="function"),this.p(oe)}$provideDocumentLinks(B,J,re){return this.s(B,be,oe=>oe.provideLinks(I.URI.revive(J),re),void 0,re,J.scheme==="output")}$resolveDocumentLink(B,J,re){return this.s(B,be,oe=>oe.resolveLink(J,re),void 0,void 0,!0)}$releaseDocumentLinks(B,J){this.s(B,be,re=>re.releaseLinks(J),void 0,void 0,!0)}registerColorProvider(B,J,re){const oe=this.t(new H(this.h,re),B);return this.e.$registerDocumentColorProvider(oe,this.o(J,B)),this.p(oe)}$provideDocumentColors(B,J,re){return this.s(B,H,oe=>oe.provideColors(I.URI.revive(J),re),[],re)}$provideColorPresentations(B,J,re,oe){return this.s(B,H,_=>_.provideColorPresentations(I.URI.revive(J),re,oe),void 0,oe)}registerFoldingRangeProvider(B,J,re){const oe=this.q(),_=typeof re.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(oe,new he(new Z(this.h,re),B)),this.e.$registerFoldingRangeProvider(oe,this.o(J,B),B.identifier,_);let ge=this.p(oe);if(_!==void 0){const Ee=re.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(_));ge=L.$wK.from(ge,Ee)}return ge}$provideFoldingRanges(B,J,re,oe){return this.s(B,Z,_=>_.provideFoldingRanges(I.URI.revive(J),re,oe),void 0,oe)}registerSelectionRangeProvider(B,J,re){const oe=this.t(new Y(this.h,re,this.l),B);return this.e.$registerSelectionRangeProvider(oe,this.o(J,B)),this.p(oe)}$provideSelectionRanges(B,J,re,oe){return this.s(B,Y,_=>_.provideSelectionRanges(I.URI.revive(J),re,oe),[],oe)}registerCallHierarchyProvider(B,J,re){const oe=this.t(new $e(this.h,re),B);return this.e.$registerCallHierarchyProvider(oe,this.o(J,B)),this.p(oe)}$prepareCallHierarchy(B,J,re,oe){return this.s(B,$e,_=>Promise.resolve(_.prepareSession(I.URI.revive(J),re,oe)),void 0,oe)}$provideCallHierarchyIncomingCalls(B,J,re,oe){return this.s(B,$e,_=>_.provideCallsTo(J,re,oe),void 0,oe)}$provideCallHierarchyOutgoingCalls(B,J,re,oe){return this.s(B,$e,_=>_.provideCallsFrom(J,re,oe),void 0,oe)}$releaseCallHierarchy(B,J){this.s(B,$e,re=>Promise.resolve(re.releaseSession(J)),void 0,void 0)}registerTypeHierarchyProvider(B,J,re){const oe=this.t(new ne(this.h,re),B);return this.e.$registerTypeHierarchyProvider(oe,this.o(J,B)),this.p(oe)}$prepareTypeHierarchy(B,J,re,oe){return this.s(B,ne,_=>Promise.resolve(_.prepareSession(I.URI.revive(J),re,oe)),void 0,oe)}$provideTypeHierarchySupertypes(B,J,re,oe){return this.s(B,ne,_=>_.provideSupertypes(J,re,oe),void 0,oe)}$provideTypeHierarchySubtypes(B,J,re,oe){return this.s(B,ne,_=>_.provideSubtypes(J,re,oe),void 0,oe)}$releaseTypeHierarchy(B,J){this.s(B,ne,re=>Promise.resolve(re.releaseSession(J)),void 0,void 0)}registerDocumentOnDropEditProvider(B,J,re,oe){const _=this.q();this.f.set(_,new he(new fe(this.e,this.h,re,_,B),B));const ge=(0,t.$tF)(B,"dropMetadata")&&oe?fe.toInternalProviderId(B.identifier.value,oe.id):void 0;return this.e.$registerDocumentOnDropEditProvider(_,this.o(J,B),ge,(0,t.$tF)(B,"dropMetadata")?oe:void 0),this.p(_)}$provideDocumentOnDropEdits(B,J,re,oe,_,ge){return this.s(B,fe,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(J,I.URI.revive(re),oe,_,ge)),void 0,void 0)}registerMappedEditsProvider(B,J,re){const oe=this.t(new te(this.h,re),B);return this.e.$registerMappedEditsProvider(oe,this.o(J,B)),this.p(oe)}$provideMappedEdits(B,J,re,oe,_){return this.s(B,te,ge=>Promise.resolve(ge.provideMappedEdits(J,re,oe,_)),null,_)}registerDocumentPasteEditProvider(B,J,re,oe){const _=this.q();this.f.set(_,new he(new j(this.e,this.h,re,_,B),B));const ge=j.toInternalProviderId(B.identifier.value,oe.id);return this.e.$registerPasteEditProvider(_,this.o(J,B),ge,{supportsCopy:!!re.prepareDocumentPaste,supportsPaste:!!re.provideDocumentPasteEdits,copyMimeTypes:oe.copyMimeTypes,pasteMimeTypes:oe.pasteMimeTypes}),this.p(_)}$prepareDocumentPaste(B,J,re,oe,_){return this.s(B,j,ge=>ge.prepareDocumentPaste(I.URI.revive(J),re,oe,_),void 0,_)}$providePasteEdits(B,J,re,oe,_,ge){return this.s(B,j,Ee=>Ee.providePasteEdits(J,I.URI.revive(re),oe,_,ge),void 0,ge)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:we.w(B.decreaseIndentPattern),increaseIndentPattern:we.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?we.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?we.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:we.w(B.beforeText),afterText:B.afterText?we.w(B.afterText):void 0,previousLineText:B.previousLineText?we.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(we.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(J=>L.SyntaxTokenType.toString(J)):void 0}}static D(B){return B.map(we.C)}setLanguageConfiguration(B,J,re){const{wordPattern:oe}=re;if(oe&&(0,E.$Pe)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this.h.setWordDefinitionFor(J,oe):this.h.setWordDefinitionFor(J,void 0),re.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),re.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const _=this.q(),ge={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?we.w(re.wordPattern):void 0,indentationRules:re.indentationRules?we.y(re.indentationRules):void 0,onEnterRules:re.onEnterRules?we.B(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport,autoClosingPairs:re.autoClosingPairs?we.D(re.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(_,J,ge),this.p(_)}$setWordDefinitions(B){for(const J of B)this.h.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.$gdc=we}),define(ke[330],Se([1,0,6,14,7,39,10,3,25]),function(me,e,I,F,m,L,R,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;class g{constructor(P,f,y,S){this.c=f,this.d=y,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(I.$uK.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,f){await this.a.$changeLanguage(P,f);const y=this.c.getDocumentData(P);if(!y)throw new Error(`document '${P.toString()}' NOT found`);return y.document}async tokenAtPosition(P,f){const y=P.version,S=F.Position.from(f),p=await this.a.$tokensAtPosition(P.uri,S),c={type:m.StandardTokenType.Other,range:P.getWordRangeAtPosition(f)??new m.$yK(f.line,f.character,f.line,f.character)};if(!p)return c;const s={range:F.Range.to(p.range),type:F.TokenType.to(p.type)};return!s.range.contains(f)||y!==P.version?c:s}createLanguageStatusItem(P,f,y){const S=this.f++,p=this.a,c=this.g,s=`${P.identifier.value}/${f}`;if(c.has(s))throw new Error(`LanguageStatusItem with id '${f}' ALREADY exists`);c.add(s);const i={selector:y,id:f,name:P.displayName??P.name,severity:m.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new w.$Qc,a=()=>{if(n?.dispose(),!c.has(s)){console.warn(`LanguageStatusItem (${f}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$Wg)(()=>{o.clear(),this.a.$setLanguageStatus(S,{id:s,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:F.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===m.LanguageStatusSeverity.Error?L.default.Error:i.severity===m.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:i.command&&this.d.toInternal(i.command,o),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){o.dispose(),n?.dispose(),p.$removeLanguageStatus(S),c.delete(s)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,a()},get selector(){return i.selector},set selector(r){i.selector=r,a()},get text(){return i.text},set text(r){i.text=r,a()},set text2(r){(0,E.$uF)(P,"languageStatusText"),i.text=r,a()},get text2(){return(0,E.$uF)(P,"languageStatusText"),i.text},get detail(){return i.detail},set detail(r){i.detail=r,a()},get severity(){return i.severity},set severity(r){i.severity=r,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,a()},get command(){return i.command},set command(r){i.command=r,a()},get busy(){return i.busy},set busy(r){i.busy=r,a()}};return a(),t}}e.$1dc=g}),define(ke[115],Se([1,0,12,13,2,5,15,6,27,20]),function(me,e,I,F,m,L,R,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=e.$Pdc=void 0;let A=class{constructor(f,y,S){this.f=S,this.d=new Map,this.a=y.getProxy(w.$uK.MainThreadLocalization),this.b=f.environment.appLanguage,this.c=this.b===I.$g}getMessage(f,y){const{message:S,args:p,comment:c}=y;if(this.c)return(0,F.$Ee)(S,p??{});let s=S;c&&c.length>0&&(s+=`/${Array.isArray(c)?c.join(""):c}`);const i=this.d.get(f)?.contents[s];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,F.$Ee)(i??S,p??{})}getBundle(f){return this.d.get(f)?.contents}getBundleUri(f){return this.d.get(f)?.uri}async initializeLocalizedMessages(f){if(this.c||!f.l10n&&!f.isBuiltin||this.d.has(f.identifier.value))return;let y;const S=await this.g(f);if(!S){this.f.error(`No bundle location found for extension ${f.identifier.value}`);return}try{const p=await this.a.$fetchBundleContents(S),c=JSON.parse(p);y=f.isBuiltin?c.contents?.bundle:c}catch(p){this.f.error(`Failed to load translations for ${f.identifier.value} from ${S}: ${p.message}`);return}y&&this.d.set(f.identifier.value,{contents:y,uri:S})}async g(f){if(f.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(f.identifier.value,this.b);return m.URI.revive(y)}return f.l10n?m.URI.joinPath(f.extensionLocation,f.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Pdc=A,e.$Pdc=A=He([Be(0,E.$MM),Be(1,g.$wM),Be(2,R.$aj)],A),e.$Qdc=(0,L.$Sh)("IExtHostLocalizationService")}),define(ke[152],Se([1,0,15,6,27,20,2,54]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0;let E=class extends I.$lj{constructor(P,f){super(f.logLevel,f.logsLocation,f.loggers.map(y=>(0,w.$ph)(y))),this.r=P.getProxy(F.$uK.MainThreadLogger)}$setLogLevel(P,f){f?this.setLogLevel(R.URI.revive(f),P):this.setLogLevel(P)}setVisibility(P,f){super.setVisibility(P,f),this.r.$setVisibility(P,f)}s(P,f,y){return new g(this.r,P,f,y)}};e.$gfc=E,e.$gfc=E=He([Be(0,L.$wM),Be(1,m.$MM)],E);class g extends I.$gj{constructor(P,f,y,S){super(S?.logLevel==="always"),this.r=P,this.s=f,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(f,S).then(()=>{this.u(this.n),this.m=!0})}g(P,f){const y=[[P,f]];this.m?this.u(y):this.n.push(...y)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Se([1,0,6,5,3,20,22]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=e.$Rdc=void 0,e.$Rdc=(0,F.$Sh)("IExtHostManagedSockets");let w=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(I.$uK.MainThreadManagedSockets)}setFactory(P,f){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(P,f),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const f=++this.b,y=await this.c.makeConnection(),S=new m.$Qc;return this.d.set(f,new g(f,y,S)),S.add((0,m.$Pc)(()=>this.d.delete(f))),S.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(f),S.dispose()})),S.add(y.onDidClose(p=>{this.a.$onDidManagedSocketClose(f,p?.stack??p?.message),S.dispose()})),S.add(y.onDidReceiveMessage(p=>this.a.$onDidManagedSocketHaveData(f,R.$ce.wrap(p)))),f}$remoteSocketWrite(P,f){this.d.get(P)?.actual.send(f.buffer)}$remoteSocketEnd(P){const f=this.d.get(P);f&&(f.actual.end(),f.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$Sdc=w,e.$Sdc=w=He([Be(0,L.$wM)],w);class E{constructor(P,f){this.socketFactoryId=P,this.makeConnection=f}}class g extends m.$Rc{constructor(P,f,y){super(),this.socketId=P,this.actual=f,this.B(y)}}}),define(ke[331],Se([1,0,6,15,25]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;function L(w){return w&&w.title}let R=class{constructor(E,g){this.b=g,this.a=E.getProxy(I.$uK.MainThreadMessageService)}showMessage(E,g,A,P,f){const y={source:{identifier:E.identifier,label:E.displayName||E.name}};let S;typeof P=="string"||L(P)?S=[P,...f]:(y.modal=P?.modal,y.useCustom=P?.useCustom,y.detail=P?.detail,S=f),y.useCustom&&(0,m.$uF)(E,"resolvers");const p=[];for(let c=0;c<S.length;c++){const s=S[c];if(typeof s=="string")p.push({title:s,handle:c,isCloseAffordance:!1});else if(typeof s=="object"){const{title:i,isCloseAffordance:n}=s;p.push({title:i,isCloseAffordance:!!n,handle:c})}else this.b.warn("Invalid message item:",s)}return this.a.$showMessage(g,A,y,p).then(c=>{if(typeof c=="number")return S[c]})}};e.$2dc=R,e.$2dc=R=He([Be(1,F.$aj)],R)}),define(ke[332],Se([1,0,19,10,21,4,3,28,2,26,15,6,35,14,7,113,287,25,69]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=e.$Xec=void 0;let n=class{constructor(h,k,D,$,b){this.l=k,this.m=D,this.n=$,this.o=b,this.b=new w.$zc,this.c=new w.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new L.$Od,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=h.getProxy(P.$uK.MainThreadNotebookKernels);const v=new f.$WM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new f.$UM("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const N=this.m.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:N}}else if(C&&"notebookEditor"in C){const N=this.m.getIdByEditor(C.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return C})],f.$VM.Void);this.n.registerApiCommand(v)}createNotebookController(h,k,D,$,b,v){for(const ae of this.i.values())if(ae.controller.id===k&&g.$9l.equals(h.identifier,ae.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const C=this.j++,N=this;this.o.trace(`NotebookController[${C}], CREATED by ${h.identifier.value}, ${k}`);const z=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${h.identifier}'`);let M=!1;const T=new L.$Od,j=new L.$Od,O={id:u(h.identifier,k),notebookType:D,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:$||h.identifier.value,preloads:v?v.map(y.NotebookRendererScript.from):[]};let q=b??z,V;this.a.$addKernel(C,O).catch(ae=>{console.log(ae),M=!0});let de=0;const ee=()=>{if(M)return;const ae=++de;Promise.resolve().then(()=>{ae===de&&this.a.$updateKernel(C,O)})},X=new w.$zc,Q={get id(){return k},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:T.event,get label(){return O.label},set label(ae){O.label=ae??h.displayName??h.name,ee()},get detail(){return O.detail??""},set detail(ae){O.detail=ae,ee()},get description(){return O.description??""},set description(ae){O.description=ae,ee()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(ae){O.supportedLanguages=ae,ee()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){O.supportsExecutionOrder=ae,ee()},get rendererScripts(){return O.preloads?O.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return q},set executeHandler(ae){q=ae??z},get interruptHandler(){return V},set interruptHandler(ae){V=ae,O.supportsInterrupt=!!ae,ee()},createNotebookCellExecution(ae){if(M)throw new Error("notebook controller is DISPOSED");if(!X.has(ae.notebook.uri))throw N.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(x=>x.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return N._createNotebookCellExecution(ae,u(h.identifier,this.id))},createNotebookExecution(ae){if((0,s.$uF)(h,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!X.has(ae.uri))throw N.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(x=>x.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return N._createNotebookExecution(ae,u(h.identifier,this.id))},dispose:()=>{M||(this.o.trace(`NotebookController[${C}], DISPOSED`),M=!0,this.i.delete(C),T.dispose(),j.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(ae,x){x===S.NotebookControllerAffinity2.Hidden&&(0,s.$uF)(h,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(C,ae.uri,x)},onDidReceiveMessage:j.event,postMessage(ae,x){return(0,s.$uF)(h,"notebookMessaging"),N.a.$postMessage(C,x&&N.m.getIdByEditor(x),ae)},asWebviewUri(ae){return(0,s.$uF)(h,"notebookMessaging"),(0,p.$6tb)(ae,N.l.remote)}};return this.i.set(C,{extensionId:h.identifier,controller:Q,onDidReceiveMessage:j,onDidChangeSelection:T,associatedNotebooks:X}),Q}getIdByController(h){for(const[k,D]of this.i)if(D.controller===h)return u(D.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,k){const D=this.f++,$=this;this.o.trace(`NotebookControllerDetectionTask[${D}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(D,k);const b={dispose:()=>{this.e.delete(D),$.a.$removeKernelDetectionTask(D)}};return this.e.set(D,b),b}registerKernelSourceActionProvider(h,k,D){const $=this.h++,b=typeof D.onDidChangeNotebookKernelSourceActions=="function"?$:void 0,v=this;this.g.set($,D),this.o.trace(`NotebookKernelSourceActionProvider[${$}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider($,$,k);let C;return b!==void 0&&(C=D.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.g.delete($),v.a.$removeKernelSourceActionProvider($,$),C?.dispose()}}}async $provideKernelSourceActions(h,k){const D=this.g.get(h);if(D){const $=new R.$Qc;return(await D.provideNotebookKernelSourceActions(k)??[]).map(v=>y.NotebookKernelSourceAction.from(v,this.n.converter,$))}return[]}$acceptNotebookAssociation(h,k,D){const $=this.i.get(h);if($){const b=this.m.getNotebookDocument(E.URI.revive(k));D?$.associatedNotebooks.set(b.uri,!0):$.associatedNotebooks.delete(b.uri),this.o.trace(`NotebookController[${h}] ASSOCIATE notebook`,b.uri.toString(),D),$.onDidChangeSelection.fire({selected:D,notebook:b.apiNotebook})}}async $executeCells(h,k,D){const $=this.i.get(h);if(!$)return;const b=this.m.getNotebookDocument(E.URI.revive(k)),v=[];for(const C of D){const N=b.getCell(C);N&&v.push(N.apiCell)}try{this.o.trace(`NotebookController[${h}] EXECUTE cells`,b.uri.toString(),v.length),await $.controller.executeHandler.call($.controller,v,b.apiNotebook,$.controller)}catch(C){this.o.error(`NotebookController[${h}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(h,k,D){const $=this.i.get(h);if(!$)return;const b=this.m.getNotebookDocument(E.URI.revive(k));if($.controller.interruptHandler)await $.controller.interruptHandler.call($.controller,b.apiNotebook);else for(const v of D){const C=b.getCell(v);C&&this.b.get(C.uri)?.cancel()}if($.controller.interruptHandler){const v=this.c.get(b.uri);D.length&&Array.isArray(v)&&v.length&&v.forEach(C=>C.dispose())}}$acceptKernelMessageFromRenderer(h,k,D){const $=this.i.get(h);if(!$)return;const b=this.m.getEditorById(k);$.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:D}))}$cellExecutionChanged(h,k,D){const b=this.m.getNotebookDocument(E.URI.revive(h)).getCell(k);if(b){const v=D?y.NotebookCellExecutionState.to(D):S.NotebookCellExecutionState.Idle;v!==void 0&&this.k.fire({cell:b.apiCell,state:v})}}_createNotebookCellExecution(h,k){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const $=this.m.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!$)throw new Error("invalid cell");if(this.b.has($.uri))throw new Error(`duplicate execution for ${$.uri}`);const b=new a(k,$,this.a);this.b.set($.uri,b);const v=b.onDidChangeState(()=>{b.state===o.Resolved&&(b.dispose(),v.dispose(),this.b.delete($.uri))});return b.asApiObject()}_createNotebookExecution(h,k){const D=this.m.getNotebookDocument(h.uri),$=h.getCells().find(C=>{const N=D.getCellFromApiCell(C);return N&&this.b.has(N.uri)});if($)throw new Error(`duplicate cell execution for ${$.document.uri}`);if(this.c.has(D.uri))throw new Error(`duplicate notebook execution for ${D.uri}`);const b=new r(k,D,this.a),v=b.onDidChangeState(()=>{b.state===t.Resolved&&(b.dispose(),v.dispose(),this.c.delete(D.uri))});return this.c.set(D.uri,[b,v]),b.asApiObject()}};e.$Xec=n,e.$Xec=n=He([Be(4,A.$aj)],n);var o;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(o||(o={}));class a extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(h,k,D){super(),this.m=k,this.n=D,this.b=a.a++,this.c=new L.$Od,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new m.$Yd),this.h=new d(10,$=>this.s($)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const k=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new i.$tv(k))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let k=this.m;if(h&&(k=this.m.notebook.getCellFromApiCell(h)),!k)throw new Error("INVALID cell");return k.handle}y(h){return h.map(k=>{const D=S.$XL.ensureUniqueMimeTypes(k.items,!0);return D===k.items?y.NotebookCellOutput.from(k):y.NotebookCellOutput.from({items:D,id:k.id,metadata:k.metadata})})}async z(h,k,D){const $=this.w(k),b=this.y((0,I.$2b)(h));return this.r({editType:c.CellExecutionUpdateType.Output,cellHandle:$,append:D,outputs:b})}async C(h,k,D){return h=S.$XL.ensureUniqueMimeTypes((0,I.$2b)(h),!0),this.r({editType:c.CellExecutionUpdateType.OutputItems,items:h.map(y.NotebookCellOutputItem.from),outputId:k.id,append:D})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(D){h.j=D,h.s([{editType:c.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(D){if(h.f===o.Resolved||h.f===o.Started)throw new Error("Cannot call start again");h.f=o.Started,h.c.fire(),h.s({editType:c.CellExecutionUpdateType.ExecutionState,runStartTime:D})},end(D,$){if(h.f===o.Resolved)throw new Error("Cannot call resolve twice");h.f=o.Resolved,h.c.fire(),h.h.flush(),h.n.$completeExecution(h.b,new i.$tv({runEndTime:$,lastRunSuccess:D}))},clearOutput(D){return h.t(),h.z([],D,!1)},appendOutput(D,$){return h.t(),h.z(D,$,!0)},replaceOutput(D,$){return h.t(),h.z(D,$,!1)},appendOutputItems(D,$){return h.t(),h.C(D,$,!0)},replaceOutputItems(D,$){return h.t(),h.C(D,$,!1)}})}}var t;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(t||(t={}));class r extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(h,k,D){super(),this.h=k,this.j=D,this.b=r.a++,this.c=new L.$Od,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new m.$Yd),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(h,k){this.e=h,this.f=k,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new F.$fh,this.b=Date.now(),(0,F.$Vg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const k=this.a;return this.a=[],this.f(k).finally(()=>h.complete())}}function u(l,h){return`${l.value}/${h}`}e.$Yec=u}),define(ke[333],Se([1,0,4,6,148]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;class L{constructor(w,E){this.c=E,this.a=new Map,this.b=w.getProxy(F.$uK.MainThreadNotebookRenderers)}$postRendererMessage(w,E,g){const A=this.c.getEditorById(w);this.a.get(E)?.fire({editor:A.apiEditor,message:g})}createRendererMessaging(w,E){if(!w.contributes?.notebookRenderer?.some(A=>A.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(A,P,f)=>this.d(E).event(A,P,f),postMessage:(A,P)=>{m.$Iec.apiEditorsToExtHost.has(A)&&([A,P]=[P,A]);const f=P&&m.$Iec.apiEditorsToExtHost.get(P);return this.b.$postMessage(f?.id,E,A)}}}d(w){let E=this.a.get(w);return E||(E=new I.$Od({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(w)}}),this.a.set(w,E),E)}}e.$Zec=L}),define(ke[334],Se([1,0,3,18,2,25,6]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=void 0;class w{constructor(g){this.b=new Map,this.a=g.getProxy(R.$uK.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,A,P){if((0,L.$uF)(g,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,P),this.a.$registerProfileContentHandler(A,P.name,P.description,g.identifier.value),(0,I.$Pc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(g,A,P,f){const y=this.b.get(g);if(!y)throw new Error(`Unknown handler with id: ${g}`);return y.saveProfile(A,P,f)}async $readProfile(g,A,P){const f=this.b.get(g);if(!f)throw new Error(`Unknown handler with id: ${g}`);return f.readProfile((0,F.$zf)(A)?A:m.URI.revive(A),P)}}e.$4ec=w}),define(ke[335],Se([1,0,2,6,10,14]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;class R{static{this.a=0}constructor(E,g){this.d=g,this.c=new Map,this.b=E.getProxy(F.$uK.MainThreadQuickDiff)}$provideOriginalResource(E,g,A){const P=I.URI.revive(g),f=this.c.get(E);return f?(0,m.$Ng)(()=>f.provideOriginalResource(P,A)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(E,g,A,P){const f=R.a++;return this.c.set(f,g),this.b.$registerQuickDiffProvider(f,L.DocumentSelector.from(E,this.d),A,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider(f),this.c.delete(f)}}}}e.$5ec=R}),define(ke[336],Se([1,0,21,4,3,6,2,7,11,19,39,61,25,14]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;function S(p,c,s){const i=p.getProxy(L.$uK.MainThreadQuickOpen);class n{constructor(k,D){this.e=new Map,this.f=0,this.a=k,this.b=D}showQuickPick(k,D,$,b=I.CancellationToken.None){this.c=void 0;const v=Promise.resolve(D),C=++this.f,N=i.$show(C,{title:$?.title,placeHolder:$?.placeHolder,matchOnDescription:$?.matchOnDescription,matchOnDetail:$?.matchOnDetail,ignoreFocusLost:$?.ignoreFocusOut,canPickMany:$?.canPickMany},b),z={},M=N.then(()=>z);return Promise.race([M,v]).then(T=>{if(T===z)return;const j=(0,f.$tF)(k,"quickPickItemTooltip");return v.then(O=>{const q=[];for(let V=0;V<O.length;V++){const de=O[V];if(typeof de=="string")q.push({label:de,handle:V});else if(de.kind===w.QuickPickItemKind.Separator)q.push({type:"separator",label:de.label});else{de.tooltip&&!j&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const ee=de.iconPath?d(de.iconPath):void 0;q.push({label:de.label,iconPath:ee?.iconPath,iconClass:ee?.iconClass,description:de.description,detail:de.detail,picked:de.picked,alwaysShow:de.alwaysShow,tooltip:j?y.MarkdownString.fromStrict(de.tooltip):void 0,handle:V})}}return $&&typeof $.onDidSelectItem=="function"&&(this.c=V=>{$.onDidSelectItem(O[V])}),i.$setItems(C,q),N.then(V=>{if(typeof V=="number")return O[V];if(Array.isArray(V))return V.map(de=>O[de])})})}).then(void 0,T=>{if(!(0,E.$3)(T))return i.$setError(C,T),Promise.reject(T)})}$onItemSelected(k){this.c?.(k)}showInput(k,D=I.CancellationToken.None){return this.d=k?.validateInput,i.$input(k,typeof this.d=="function",D).then(void 0,$=>{if(!(0,E.$3)($))return Promise.reject($)})}async $validateInput(k){if(!this.d)return;const D=await this.d(k);if(!D||typeof D=="string")return D;let $;switch(D.severity){case w.InputBoxValidationSeverity.Info:$=A.default.Info;break;case w.InputBoxValidationSeverity.Warning:$=A.default.Warning;break;case w.InputBoxValidationSeverity.Error:$=A.default.Error;break;default:$=D.message?A.default.Error:A.default.Ignore;break}return{content:D.message,severity:$}}async showWorkspaceFolderPick(k,D=I.CancellationToken.None){const $=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!$)return;const b=await this.a.getWorkspaceFolders2();if(b)return b.find(v=>v.uri.toString()===$.uri.toString())}createQuickPick(k){const D=new u(k,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(k){const D=new l(k,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(k,D){this.e.get(k)?._fireDidChangeValue(D)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,D){const $=this.e.get(k);$ instanceof u&&$._fireDidChangeActive(D)}$onDidChangeSelection(k,D){const $=this.e.get(k);$ instanceof u&&$._fireDidChangeSelection(D)}$onDidTriggerButton(k,D){this.e.get(k)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(k,D,$){const b=this.e.get(k);b instanceof u&&b._fireDidTriggerItemButton(D,$)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class o{static{this.a=1}constructor(k,D){this.x=k,this.y=D,this._id=u.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$Od,this.q=new F.$Od,this.r=new F.$Od,this.s=new F.$Od,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((D,$)=>{const b=D===w.$QL.Back?-1:$;this.o.set(b,D)}),this.z({buttons:k.map((D,$)=>({...d(D.iconPath),tooltip:D.tooltip,handle:D===w.$QL.Back?-1:$}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const D=this.o.get(k);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,m.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(k){if(!this.v){for(const D of Object.keys(k)){const $=k[D];this.u[D]=$===void 0?null:$}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function a(h){if(h instanceof w.$qL)return{id:h.id};const k=r(h),D=t(h);return{dark:typeof k=="string"?R.URI.file(k):k,light:typeof D=="string"?R.URI.file(D):D}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function r(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const k=a(h);let D,$;return"id"in k?$=P.ThemeIcon.asClassName(k):D=k,{iconPath:D,iconClass:$}}class u extends o{constructor(k,D){super(k.identifier,D),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$Od,this.L=[],this.M=new F.$Od,this.N=new F.$Od,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((b,v)=>{this.C.set(v,b),this.D.set(b,v)});const D=(0,f.$tF)(this.O,"quickPickItemTooltip"),$=[];for(let b=0;b<k.length;b++){const v=k[b];if(v.kind===w.QuickPickItemKind.Separator)$.push({type:"separator",label:v.label});else{v.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=v.iconPath?d(v.iconPath):void 0;$.push({handle:b,label:v.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,tooltip:D?y.MarkdownString.fromStrict(v.tooltip):void 0,buttons:v.buttons?.map((N,z)=>({...d(N.iconPath),tooltip:N.tooltip,handle:z}))})}}this.z({items:$})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(k){const D=(0,g.$Gb)(k.map($=>this.C.get($)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(k){const D=(0,g.$Gb)(k.map($=>this.C.get($)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(k,D){const $=this.C.get(k);if(!$||!$.buttons||!$.buttons.length)return;const b=$.buttons[D];b&&this.N.fire({button:b,item:$})}}class l extends o{constructor(k,D){super(k.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:A.default.Error}):this.z({validationMessage:k.message,severity:k.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new n(c,s)}e.$6dc=S}),define(ke[337],Se([1,0,2,4,59,3,10,6,19,129,15,26,61,14,25,17]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=e.$7dc=void 0;function s(v){if(v)return typeof v.iconPath=="string"?I.URI.file(v.iconPath):I.URI.isUri(v.iconPath)||f.ThemeIcon.isThemeIcon(v.iconPath)?v.iconPath:void 0}function i(v){if(v?.icon){if(I.URI.isUri(v.icon))return v.icon;if(f.ThemeIcon.isThemeIcon(v.icon))return v.icon;{const C=v.icon;return{light:C.light,dark:C.dark}}}else return}function n(v){if(v.icon){if(I.URI.isUri(v.icon))return v.icon;if(f.ThemeIcon.isThemeIcon(v.icon))return v.icon;{const C=v.icon;return{light:C.light,dark:C.dark}}}else return}function o(v,C){if(!v.iconPath&&!C.iconPath)return 0;if(v.iconPath){if(!C.iconPath)return 1}else return-1;const N=typeof v.iconPath=="string"?v.iconPath:I.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id,z=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id;return(0,g.$uq)(N,z)}function a(v,C){let N=0;if(v.strikeThrough!==C.strikeThrough)return v.strikeThrough?1:-1;if(v.faded!==C.faded)return v.faded?1:-1;if(v.tooltip!==C.tooltip)return(v.tooltip||"").localeCompare(C.tooltip||"");if(N=o(v,C),N!==0)return N;if(v.light&&C.light)N=o(v.light,C.light);else{if(v.light)return 1;if(C.light)return-1}if(N!==0)return N;if(v.dark&&C.dark)N=o(v.dark,C.dark);else{if(v.dark)return 1;if(C.dark)return-1}return N}function t(v,C){if(v.command!==C.command)return v.command<C.command?-1:1;if(v.title!==C.title)return v.title<C.title?-1:1;if(v.tooltip!==C.tooltip){if(v.tooltip!==void 0&&C.tooltip!==void 0)return v.tooltip<C.tooltip?-1:1;if(v.tooltip!==void 0)return 1;if(C.tooltip!==void 0)return-1}if(v.arguments===C.arguments)return 0;if(v.arguments)if(C.arguments){if(v.arguments.length!==C.arguments.length)return v.arguments.length-C.arguments.length}else return 1;else return-1;for(let N=0;N<v.arguments.length;N++){const z=v.arguments[N],M=C.arguments[N];if(z!==M)return z<M?-1:1}return 0}function r(v,C){let N=(0,g.$uq)(v.resourceUri.fsPath,C.resourceUri.fsPath,!0);if(N!==0)return N;if(v.command&&C.command)N=t(v.command,C.command);else{if(v.command)return 1;if(C.command)return-1}if(N!==0)return N;if(v.decorations&&C.decorations)N=a(v.decorations,C.decorations);else{if(v.decorations)return 1;if(C.decorations)return-1}return N}function d(v,C){for(let N=0;N<v.length;N++)if(v[N]!==C[N])return!1;return!0}function u(v,C){return v.command===C.command&&v.title===C.title&&v.tooltip===C.tooltip&&(v.arguments&&C.arguments?d(v.arguments,C.arguments):v.arguments===C.arguments)}function l(v,C){return(0,E.$tb)(v,C,u)}function h(v,C){return v===C?!0:!v||!C?!1:v.id===C.id&&v.label===C.label&&v.upstream?.id===C.upstream?.id&&v.upstream?.label===C.upstream?.label}class k{#e;#t;get value(){return this.d}set value(C){C=C??"",this.#e.$setInputBoxValue(this.o,C),this.q(C)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(C){this.#e.$setInputBoxPlaceholder(this.o,C),this.f=C}get validateInput(){return(0,S.$uF)(this.m,"scmValidation"),this.g}set validateInput(C){if((0,S.$uF)(this.m,"scmValidation"),C&&typeof C!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=C,this.#e.$setValidationProviderIsEnabled(this.o,!!C)}get enabled(){return this.h}set enabled(C){C=!!C,this.h!==C&&(this.h=C,this.#e.$setInputBoxEnablement(this.o,C))}get visible(){return this.j}set visible(C){C=!!C,this.j!==C&&(this.j=C,this.#e.$setInputBoxVisibility(this.o,C))}get actionButton(){return(0,S.$uF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(C){(0,S.$uF)(this.m,"scmInputBoxActionButton"),this.l.value=new L.$Qc,this.k=C;const N=C!==void 0?{command:this.n.converter.toInternal(C.command,this.l.value),icon:i(C),enabled:C.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,N??null)}get document(){return(0,S.$uF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(C,N,z,M,T,j){this.m=C,this.n=N,this.o=T,this.p=j,this.d="",this.e=new F.$Od,this.f="",this.h=!0,this.j=!0,this.l=new L.$Sc,this.#t=z,this.#e=M}showValidationMessage(C,N){(0,S.$uF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,C,N)}$onInputBoxValueChange(C){this.q(C)}q(C){this.d=C,this.e.fire(C)}}e.$7dc=k;class D{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(C){this.v=C,this.q.$updateGroupLabel(this.t,this.handle,C)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(C){this.p=C,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(C){this.f=[...C],this.k.fire()}constructor(C,N,z,M,T){this.q=C,this.s=N,this.t=z,this.u=M,this.v=T,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$Od,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$Od,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=D.d++}getResourceState(C){return this.g.get(C)}$executeResourceCommand(C,N){const z=this.h.get(C);return z?(0,R.$Ng)(()=>this.s.executeCommand(z.command,...z.arguments||[],N)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const C=[...this.f].sort(r),z=(0,E.$Cb)(this.o,C,r).map(j=>{const O=j.toInsert.map(q=>{const V=this.e++;this.g.set(V,q);const de=q.resourceUri;let ee;if(q.command)if(q.command.command==="vscode.open"||q.command.command==="vscode.diff"){const be=new L.$Qc;ee=this.s.converter.toInternal(q.command,be),this.j.set(V,be)}else this.h.set(V,q.command);const X=s(q.decorations),Q=q.decorations&&s(q.decorations.light)||X,ae=q.decorations&&s(q.decorations.dark)||X,x=[Q,ae],se=q.decorations&&q.decorations.tooltip||"",pe=q.decorations&&!!q.decorations.strikeThrough,G=q.decorations&&!!q.decorations.faded,U=q.contextValue||"";return{rawResource:[V,de,x,se,pe,G,U,ee],handle:V}});return{start:j.start,deleteCount:j.deleteCount,toInsert:O}}),M=z.map(({start:j,deleteCount:O,toInsert:q})=>[j,O,q.map(V=>V.rawResource)]),T=z.reverse();for(const{start:j,deleteCount:O,toInsert:q}of T){const V=q.map(ee=>ee.handle),de=this.n.splice(j,O,...V);for(const ee of de)this.g.delete(ee),this.h.delete(ee),this.j.get(ee)?.dispose(),this.j.delete(ee)}return this.o=C,M}dispose(){this.l=!0,this.m.fire()}}class ${static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(C){this.g!==C&&(this.g=C,this.#e.$updateSourceControl(this.x,{count:C}))}get quickDiffProvider(){return this.h}set quickDiffProvider(C){this.h=C;let N;(0,S.$tF)(this.y,"quickDiffProvider")&&(N=C?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!C,quickDiffLabel:N})}get historyProvider(){return(0,S.$uF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(C){(0,S.$uF)(this.y,"scmHistoryProvider"),this.j=C,this.k.value=new L.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!C}),C&&(this.k.value.add(C.onDidChangeCurrentHistoryItemGroup(()=>{h(this.l,C?.currentHistoryItemGroup)||(this.l=C?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(C.onDidChangeActionButton(()=>{(0,S.$uF)(this.y,"scmActionButton"),this.m.value=new L.$Qc;const N=C.actionButton!==void 0?{command:this.z.converter.toInternal(C.actionButton.command,this.m.value),description:C.actionButton.description,enabled:C.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,N??null)})))}get commitTemplate(){return this.n}set commitTemplate(C){C!==this.n&&(this.n=C,this.#e.$updateSourceControl(this.x,{commitTemplate:C}))}get acceptInputCommand(){return this.p}set acceptInputCommand(C){this.o.value=new L.$Qc,this.p=C;const N=this.z.converter.toInternal(C,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:N})}get actionButton(){return(0,S.$uF)(this.y,"scmActionButton"),this.s}set actionButton(C){(0,S.$uF)(this.y,"scmActionButton"),this.q.value=new L.$Qc,this.s=C;const N=C!==void 0?{command:this.z.converter.toInternal(C.command,this.q.value),secondaryCommands:C.secondaryCommands?.map(z=>z.map(M=>this.z.converter.toInternal(M,this.q.value))),description:C.description,enabled:C.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:N??null})}get statusBarCommands(){return this.u}set statusBarCommands(C){if(this.u&&C&&l(this.u,C))return;this.t.value=new L.$Qc,this.u=C;const N=(C||[]).map(z=>this.z.converter.toInternal(z,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:N})}get selected(){return this.v}constructor(C,N,z,M,T,j,O){this.y=C,this.z=M,this.A=T,this.B=j,this.C=O,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Sc,this.m=new L.$Sc,this.n=void 0,this.o=new L.$Sc,this.p=void 0,this.q=new L.$Sc,this.t=new L.$Sc,this.u=void 0,this.v=!1,this.w=new F.$Od,this.onDidChangeSelection=this.w.event,this.x=$.d++,this.D=new Map,this.E=new Set,this.#e=z;const q=I.URI.from({scheme:p.Schemas.vscodeSourceControl,path:`${T}/scm${this.x}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new k(C,M,N,this.#e,this.x,q),this.#e.$registerSourceControl(this.x,T,j,O,q)}createResourceGroup(C,N){const z=new D(this.#e,this.z,this.x,C,N),M=F.Event.once(z.onDidDispose)(()=>this.D.delete(z));return this.D.set(z,M),this.eventuallyAddResourceGroups(),z}eventuallyAddResourceGroups(){const C=[],N=[];for(const[z,M]of this.D){M.dispose();const T=z.onDidUpdateResourceStates(()=>{this.E.add(z),this.eventuallyUpdateResourceStates()});F.Event.once(z.onDidDispose)(()=>{this.E.delete(z),T.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.x,z.handle)}),C.push([z.handle,z.id,z.label,z.features]);const j=z._takeResourceStateSnapshot();j.length>0&&N.push([z.handle,j]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.x,C,N),this.D.clear()}eventuallyUpdateResourceStates(){const C=[];this.E.forEach(N=>{const z=N._takeResourceStateSnapshot();z.length!==0&&C.push([N.handle,z])}),C.length>0&&this.#e.$spliceResourceStates(this.x,C),this.E.clear()}getResourceGroup(C){return this.e.get(C)}setSelectionState(C){this.v=C,this.w.fire(C)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(C=>C.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,m.$lh)(100)],$.prototype,"eventuallyAddResourceGroups",null),He([(0,m.$lh)(100)],$.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{c=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(C,N,z,M){this.l=N,this.m=z,this.n=M,this.g=new Map,this.h=new P.$$l,this.j=new F.$Od,this.e=C.getProxy(w.$uK.MainThreadSCM),this.f=C.getProxy(w.$uK.MainThreadTelemetry),N.registerArgumentProcessor({processArgument:T=>{if(T&&T.$mid===3){const j=this.g.get(T.sourceControlHandle);if(!j)return T;const O=j.getResourceGroup(T.groupHandle);return O?O.getResourceState(T.handle):T}else if(T&&T.$mid===4){const j=this.g.get(T.sourceControlHandle);return j?j.getResourceGroup(T.groupHandle):T}else if(T&&T.$mid===5){const j=this.g.get(T.handle);return j||T}return T}})}createSourceControl(C,N,z,M){this.n.trace("ExtHostSCM#createSourceControl",C.identifier.value,N,z,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:C.identifier.value});const T=c.d++,j=new $(C,this.m,this.e,this.l,N,z,M);this.g.set(T,j);const O=this.h.get(C.identifier)||[];return O.push(j),this.h.set(C.identifier,O),j}getLastInputBox(C){this.n.trace("ExtHostSCM#getLastInputBox",C.identifier.value);const N=this.h.get(C.identifier),z=N&&N[N.length-1];return z&&z.inputBox}$provideOriginalResource(C,N,z){const M=I.URI.revive(N);this.n.trace("ExtHostSCM#$provideOriginalResource",C,M.toString());const T=this.g.get(C);return!T||!T.quickDiffProvider||!T.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Ng)(()=>T.quickDiffProvider.provideOriginalResource(M,z)).then(j=>j||null)}$onInputBoxValueChange(C,N){this.n.trace("ExtHostSCM#$onInputBoxValueChange",C);const z=this.g.get(C);return z&&z.inputBox.$onInputBoxValueChange(N),Promise.resolve(void 0)}$executeResourceCommand(C,N,z,M){this.n.trace("ExtHostSCM#$executeResourceCommand",C,N,z);const T=this.g.get(C);if(!T)return Promise.resolve(void 0);const j=T.getResourceGroup(N);return j?j.$executeResourceCommand(z,M):Promise.resolve(void 0)}$validateInput(C,N,z){this.n.trace("ExtHostSCM#$validateInput",C);const M=this.g.get(C);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Ng)(()=>M.inputBox.validateInput(N,z)).then(T=>{if(!T)return Promise.resolve(void 0);const j=y.MarkdownString.fromStrict(T.message);return j?Promise.resolve([j,T.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(C){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",C),C!==void 0&&this.g.get(C)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=C,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(C,N,z){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupBase(N,z)??void 0}async $resolveHistoryItemGroupCommonAncestor(C,N,z,M){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(N,z,M)??void 0}async $provideHistoryItems(C,N,z,M){return(await this.g.get(C)?.historyProvider?.provideHistoryItems(N,z,M))?.map(O=>({id:O.id,parentIds:O.parentIds,label:O.label,description:O.description,icon:n(O),timestamp:O.timestamp}))??void 0}async $provideHistoryItemChanges(C,N,z){return await this.g.get(C)?.historyProvider?.provideHistoryItemChanges(N,z)??void 0}};e.$8dc=b,e.$8dc=b=c=He([Be(3,A.$aj)],b)}),define(ke[117],Se([1,0,6,4,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=e.$Mdc=void 0;class L{constructor(w){this.b=new F.$Od,this.onDidChangePassword=this.b.event,this.a=w.getProxy(I.$uK.MainThreadSecretState)}async $onDidChangePassword(w){this.b.fire(w)}get(w,E){return this.a.$getPassword(w,E)}store(w,E,g){return this.a.$setPassword(w,E,g)}delete(w,E){return this.a.$deletePassword(w,E)}}e.$Mdc=L,e.$Ndc=(0,m.$Sh)("IExtHostSecretState")}),define(ke[338],Se([1,0,6,14,2]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=void 0;class L{static{this.a=0}constructor(w,E){this.d=E,this.c=new Map,this.b=w.getProxy(I.$uK.MainThreadShare)}async $provideShare(w,E,g){return await this.c.get(w)?.provideShare({selection:F.Range.to(E.selection),resourceUri:m.URI.revive(E.resourceUri)},g)??void 0}registerShareProvider(w,E){const g=L.a++;return this.c.set(g,E),this.b.$registerShareProvider(g,F.DocumentSelector.from(w,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$0ec=L}),define(ke[339],Se([1,0,21,3,6]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class L{static{this.a=1}constructor(w){this.c=new Map,this.d=new Map,this.b=w.getProxy(m.$uK.MainThreadSpeech)}async $createSpeechToTextSession(w,E){const g=this.c.get(w);if(!g)return;const A=new F.$Qc,P=new I.$Yd;this.d.set(E,P);const f=A.add(g.provideSpeechToTextSession(P.token));A.add(f.onDidChange(y=>{P.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(E,y)})),A.add(P.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}registerProvider(w,E,g){const A=L.a++;return this.c.set(A,g),this.b.$registerProvider(A,E,{extension:w,displayName:w.value}),(0,F.$Pc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$_ec=L}),define(ke[340],Se([1,0,7,6,218,3,14,18]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=e.$9dc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$rL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$rL("statusBarItem.warningForeground")]])}#e;#t;constructor(f,y,S,p,c,s=I.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new L.$Qc,this.#e=f,this.#t=y,c&&p){this.c=(0,I.$7K)(p.identifier,c);const n=S.get(this.c);n&&(s=n.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(E.a++);this.e=p,this.f=c,this.g=s,this.h=this.u(i)}u(f){if((0,w.$Df)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(f){this.k=f,this.v()}set name(f){this.m=f,this.v()}set tooltip(f){this.l=f,this.v()}set color(f){this.n=f,this.v()}set backgroundColor(f){f&&!E.b.has(f.id)&&(f=void 0),this.o=f,this.v()}set command(f){this.r?.fromApi!==f&&(this.p&&this.q.add(this.p),this.p=new L.$Qc,typeof f=="string"?this.r={fromApi:f,internal:this.#t.toInternal({title:"",command:f},this.p)}:f?this.r={fromApi:f,internal:this.#t.toInternal(f,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(f){this.t=f,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let f;this.e?this.f?f=`${this.e.identifier.value}.${this.f}`:f=this.e.identifier.value:f=this.f;let y;this.m?y=this.m:y=(0,m.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=E.b.get(this.o.id));const p=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,f,this.e?.identifier.value,y,this.k,p,this.r?.internal,S,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$9dc=E;class g{constructor(f){this.b=[],this.a=f.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,m.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(f){const y={message:f};return this.b.unshift(y),this.c(),new I.$wK(()=>{const S=this.b.indexOf(y);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(f,y){this.e=new Map,this.a=f.getProxy(F.$uK.MainThreadStatusBar),this.b=y,this.c=new g(this)}$acceptStaticEntries(f){for(const y of f)this.e.set(y.entryId,y)}createStatusBarEntry(f,y,S,p){return new E(this.a,this.b,this.e,f,y,S,p)}setStatusBarMessage(f,y){const S=this.c.setMessage(f);let p;return typeof y=="number"?p=setTimeout(()=>S.dispose(),y):typeof y<"u"&&y.then(()=>S.dispose(),()=>S.dispose()),new I.$wK(()=>{S.dispose(),clearTimeout(p)})}}e.$0dc=A}),define(ke[118],Se([1,0,6,4,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=e.$Adc=void 0;class L{constructor(w,E){this.c=E,this.b=new F.$Od,this.onDidChangeStorage=this.b.event,this.a=w.getProxy(I.$uK.MainThreadStorage)}registerExtensionStorageKeysToSync(w,E){this.a.$registerExtensionStorageKeysToSync(w,E)}async initializeExtensionStorage(w,E,g){const A=await this.a.$initializeExtensionStorage(w,E);let P;return A&&(P=this.d(w,E,A)),P||g}setValue(w,E,g){return this.a.$setValue(w,E,g)}$acceptValue(w,E,g){const A=this.d(w,E,g);A&&this.b.fire({shared:w,key:E,value:A})}d(w,E,g){try{return JSON.parse(g)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${w}): ${A}`)}}}e.$Adc=L,e.$Bdc=(0,m.$Sh)("IExtHostStorage")}),define(ke[92],Se([1,0,5,27,15,72,2]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=e.$Gdc=void 0,e.$Gdc=(0,I.$Sh)("IExtensionStoragePaths");let w=class{constructor(g,A,P){this.d=A,this.f=P,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(f=>this.c=f)}async g(g){return R.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,A=await this.g(g);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(g){if(this.c)return R.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return R.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Hdc=w,e.$Hdc=w=He([Be(0,F.$MM),Be(1,m.$aj),Be(2,L.$Fdc)],w)}),define(ke[46],Se([1,0,4,6,5,2,20,3,7,220,11,264,21,32,265,61,10,14,35]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=e.$Kdc=e.$Jdc=e.$Idc=void 0,e.$Idc=(0,m.$Sh)("IExtHostTerminalService");class n{constructor($,b,v,C){this.l=$,this._id=b,this.m=v,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(z=>this.f=z);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(z,M=!0){N.q(),N.l.$sendText(N._id,z,M)},show(z){N.q(),N.l.$show(N._id,z)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create($,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??b?.cwd??void 0,env:$.env??void 0,icon:l($.iconPath)??void 0,color:p.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.o($.location,b?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,b,v,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:v,color:p.ThemeColor.isThemeColor(C)?C.id:void 0,location:this.o($,b),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o($,b){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in $?{viewColumn:s.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.n=$}setExitStatus($,b){this.h=Object.freeze({code:$,reason:b})}setDimensions($,b){return $===this.d&&b===this.g||$===0||b===0?!1:(this.d=$,this.g=b,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection($){this.k=$}_setProcessId($){this.f?(this.f($),this.f=void 0):this.b.then(b=>{b!==$&&(this.b=Promise.resolve($))})}}e.$Jdc=n;class o{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new I.$Od,this.onProcessData=this.a.event,this.b=new I.$Od,this.d=new I.$Od,this.onDidChangeProperty=this.d.event,this.f=new I.$Od,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,b){this.g.setDimensions?.({columns:$,rows:b})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:"overrideDimensions",value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:"title",value:b})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends w.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,b,v){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new w.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$Od,this.onDidCloseTerminal=this.H.event,this.I=new I.$Od,this.onDidOpenTerminal=this.I.event,this.J=new I.$Od,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$Od,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$Od,this.onDidChangeTerminalState=this.M.event,this.N=new I.$Od,this.onDidChangeShell=this.N.event,this.O=new I.$Od({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$Od({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=v.getProxy(F.$uK.MainThreadTerminalService),this.y=new S.$iqb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:C=>{const N=z=>{const M=z;return this.W(M.instanceId)?.value};switch(C?.$mid){case 15:return N(C);default:{if(Array.isArray(C))for(let z=0;z<C.length&&C[z].$mid===15;z++)C[z]=N(C[z]);return C}}}}),this.B({dispose:()=>{for(const[C,N]of this.g)N.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,b){const v=new n(this.a,(0,y.$fg)(),$,$.name),C=new o($.pty);return v.createExtensionTerminal($.location,this.R($,b).resolvedExtHostIdentifier,l($.iconPath),h($.color)).then(N=>{const z=this.S(N,C);this.h[N]=z}),this.f.push(v),v.value}R($,b){if(b=b||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const v=$.location.parentTerminal;if(v){const C=this.f.find(N=>N.value===v);C&&(b.resolvedExtHostIdentifier=C._id)}}else $.location&&typeof $.location!="object"?b.location=$.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal($,b){if(!this.W($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const C=new o(b),N=this.S($,C);this.h[$]=N}async $acceptActiveTerminalChanged($){const b=this.b;if($===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const v=this.W($);v&&(this.b=v,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,b){const v=this.W($);v&&this.O.fire({terminal:v.value,data:b})}async $acceptTerminalDimensions($,b,v){const C=this.W($);C&&C.setDimensions(b,v)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand($,b){const v=this.W($);v&&this.P.fire({terminal:v.value,...b})}async $acceptTerminalMaximumDimensions($,b,v){this.g.get($)?.resize(b,v)}async $acceptTerminalTitleChange($,b){const v=this.W($);v&&(v.name=b)}async $acceptTerminalClosed($,b,v){const C=this.Y(this.f,$);if(C!==null){const N=this.f.splice(C,1)[0];N.setExitStatus(b,v),this.H.fire(N.value)}}$acceptTerminalOpened($,b,v,C){if(b){const M=this.Y(this.f,b);if(M!==null){this.f[M]._id=$,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const N={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:L.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},z=new n(this.a,$,N,v);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId($,b){this.W($)?._setProcessId(b)}async $startExtensionTerminal($,b){const v=this.W($);if(!v)return{message:(0,g.localize)(0,null,$)};v.isOpen||await new Promise(N=>{const z=this.onDidOpenTerminal(async M=>{M===v.value&&(z.dispose(),N())})});const C=this.g.get($);C?C.startSendingEvents(b):this.j[$]={initialDimensions:b}}S($,b){const v=new w.$Qc;v.add(b.onProcessReady(N=>this.a.$sendProcessReady($,N.pid,N.cwd,N.windowsPty))),v.add(b.onDidChangeProperty(N=>this.a.$sendProcessProperty($,N))),this.y.startBuffering($,b.onProcessData),v.add(b.onProcessExit(N=>this.U($,N))),this.g.set($,b);const C=this.j[$];return C&&b instanceof o&&(b.startSendingEvents(C.initialDimensions),delete this.j[$]),v}$acceptProcessAckDataEvent($,b){this.g.get($)?.acknowledgeDataEvent(b)}$acceptProcessInput($,b){this.g.get($)?.input(b)}$acceptTerminalInteraction($){const b=this.W($);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection($,b){this.W($)?.setSelection(b)}$acceptProcessResize($,b,v){try{this.g.get($)?.resize(b,v)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown($,b){this.g.get($)?.shutdown(b)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(b=>this.a.$sendProcessProperty($,{type:"initialCwd",value:b}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(b=>this.a.$sendProcessProperty($,{type:"cwd",value:b}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new E.$wK(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,b,v){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,v),this.a.$registerProfileProvider(b,$.identifier.value),new E.$wK(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider($,b,v){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,v),this.a.$registerQuickFixProvider($,b),new E.$wK(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,b){const v=new f.$Yd().token;if(v.isCancellationRequested)return;const C=this.D.get($);if(!C)return;const N=await C.provideTerminalQuickFixes(b,v);if(N===null||Array.isArray(N)&&N.length===0)return;const z=new w.$Qc;if(this.w.value=z,!Array.isArray(N))return N?s.TerminalQuickFix.from(N,this.Q.converter,z):void 0;const M=[];for(const T of N){const j=s.TerminalQuickFix.from(T,this.Q.converter,z);j&&M.push(j)}return M}async $createContributedProfileTerminal($,b){const v=new f.$Yd().token;let C=await this.C.get($)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,b);return}this.createTerminalFromOptions(C.options,b)}}async $provideLinks($,b){const v=this.W($);if(!v)return[];this.F.delete($),this.G.get($)?.dispose(!0);const N=new f.$Yd;this.G.set($,N);const z=[],M={terminal:v.value,line:b},T=[];for(const q of this.z)T.push(c.Promises.withAsyncBody(async V=>{N.token.onCancellationRequested(()=>V({provider:q,links:[]}));const de=await q.provideTerminalLinks(M,N.token)||[];N.token.isCancellationRequested||V({provider:q,links:de})}));const j=await Promise.all(T);if(N.token.isCancellationRequested)return[];const O=new Map;for(const q of j)q&&q.links.length>0&&z.push(...q.links.map(V=>{const de={id:a++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return O.set(de.id,{provider:q.provider,link:V}),de}));return this.F.set($,O),z}$activateLink($,b){const v=this.F.get($)?.get(b);v&&v.provider.handleTerminalLink(v.link)}U($,b){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const v=this.h[$];v&&(v.dispose(),delete this.h[$]),this.a.$sendProcessExit($,b)}W($){return this.X(this.f,$)}X($,b){const v=this.Y($,b);return v!==null?$[v]:null}Y($,b){const v=$.findIndex(C=>C._id===b);return v===-1?null:v}getEnvironmentVariableCollection($){let b=this.n.get($.identifier.value);return b||(b=new r,this.$($.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Z($,b){const v=(0,P.$nr)(b.map),C=(0,P.$or)(b.descriptionMap);this.a.$setEnvironmentVariableCollection($,b.persistent,v.length===0?void 0:v,C)}$initEnvironmentVariableCollections($){$.forEach(b=>{const v=b[0],C=new r(b[1]);this.$(v,C)})}$acceptDefaultProfile($,b){const v=this.s;this.s=$,this.u=b,v?.path!==$.path&&this.N.fire($.path)}$($,b){this.n.set($,b),b.onDidChangeCollection(()=>{this.Z($,b)})}};e.$Kdc=t,e.$Kdc=t=He([Be(1,i.$SM),Be(2,R.$wM)],t);class r{get persistent(){return this.b}set persistent($){this.b=$,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor($){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$Od,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const b=this.h($);let v=this.a.get(b);return v||(v=new d(this,$),this.a.set(b,v),v.onDidChangeCollection(()=>this.d.fire())),v}replace($,b,v,C){this.f($,{value:b,type:E.EnvironmentVariableMutatorType.Replace,options:v??{applyAtProcessCreation:!0},scope:C})}append($,b,v,C){this.f($,{value:b,type:E.EnvironmentVariableMutatorType.Append,options:v??{applyAtProcessCreation:!0},scope:C})}prepend($,b,v,C){this.f($,{value:b,type:E.EnvironmentVariableMutatorType.Prepend,options:v??{applyAtProcessCreation:!0},scope:C})}f($,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const v=this.g($,b.scope),C=this.map.get(v),N=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==b.value||C.type!==b.type||C.options?.applyAtProcessCreation!==N.applyAtProcessCreation||C.options?.applyAtShellIntegration!==N.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const z=this.g($,b.scope),M={variable:$,...b,options:N};this.map.set(z,M),this.d.fire()}}get($,b){const v=this.g($,b),C=this.map.get(v);return C?k(C):void 0}g($,b){const v=this.h(b);return v.length?`${$}:::${v}`:$}h($){return this.j($?.workspaceFolder)??""}j($){return $?$.uri.toString():void 0}getVariableMap($){const b=new Map;for(const[v,C]of this.map)this.h(C.scope)===this.h($)&&b.set(C.variable,k(C));return b}delete($,b){const v=this.g($,b);this.map.delete(v),this.d.fire()}clear($){if($?.workspaceFolder){for(const[b,v]of this.map)v.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(b);this.k($)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription($,b){const v=this.h(b),C=this.descriptionMap.get(v);if(!C||C.description!==$){let N;typeof $=="string"?N=$:N=$?.value.split(`

`)[0];const z={description:N,scope:b};this.descriptionMap.set(v,z),this.d.fire()}}getDescription($){const b=this.h($);return this.descriptionMap.get(b)?.description}k($){const b=this.h($);this.descriptionMap.delete(b)}}class d{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,b){this.b=$,this.d=b,this.a=new I.$Od}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,b,v){this.b.replace($,b,v,this.d)}append($,b,v){this.b.append($,b,v,this.d)}prepend($,b,v){this.b.prepend($,b,v,this.d)}get($){return this.b.get($,this.d)}forEach($,b){this.b.getVariableMap(this.d).forEach((v,C)=>$.call(b,C,v,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let u=class extends t{constructor($,b){super(!1,$,b)}createTerminal($,b,v){throw new A.$$}createTerminalFromOptions($,b){throw new A.$$}};e.$Ldc=u,e.$Ldc=u=He([Be(0,i.$SM),Be(1,R.$wM)],u);function l(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function h(D){return p.ThemeColor.isThemeColor(D)?D:void 0}function k(D){const $={...D};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(ke[341],Se([1,0,121,10,22,21,4,75,52,3,24,18,32,6,20,149,14,7,68,112,89,25]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=e.$Uec=e.$Tec=e.$Sec=void 0;let t=class extends g.$Rc{constructor(M,T,j){super(),this.u=j,this.f=this.B(new R.$Od),this.g=new Map,this.s=this.B(new R.$Od),this.onResultsChanged=this.f.event,this.results=[],this.h=M.getProxy(y.$uK.MainThreadTesting),this.m=new v(this.h),this.j=new l(this.h),T.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const q=O,V=q.tests[q.tests.length-1].item.extId;return this.g.get(i.$kJ.root(V))?.collection.tree.get(V)?.actual??(0,p.$IM)(O)}case 18:{const{extId:q,message:V}=O;return{test:this.g.get(i.$kJ.root(q))?.collection.tree.get(q)?.actual,message:c.TestMessage.to(V)}}default:return O}}}),T.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await T.executeCommand("_testing.getExplorerSelection"),q=V=>{const de=this.g.get(i.$kJ.root(V));if(de)return i.$kJ.isRoot(V)?de.controller:de.collection.tree.get(V)?.actual};return{include:O?.include.map(q).filter(P.$Hf)||[],exclude:O?.exclude.map(q).filter(P.$Hf)||[]}})}createTestController(M,T,j,O){if(this.g.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const q=new g.$Qc,V=q.add(new p.$LM(T,j,this.u));V.root.label=j;const de=new Map,ee=new Set,X=this.h,Q={items:V.root.children,get label(){return j},set label(x){j=x,V.root.label=x,X.$updateController(T,{label:j})},get refreshHandler(){return O},set refreshHandler(x){O=x,X.$updateController(T,{canRefresh:!!x})},get id(){return T},createRunProfile:(x,se,pe,G,U,ce)=>{let be=(0,E.$Gi)(x);for(;de.has(be);)be++;return new C(this.h,de,M,ee,this.s.event,T,be,x,se,pe,G,U,ce)},createTestItem(x,se,pe){return new p.$JM(T,x,se,pe)},createTestRun:(x,se,pe=!0)=>this.j.createTestRun(M,T,V,x,se,pe),invalidateTestResults:x=>{if(x===void 0)this.h.$markTestRetired(void 0);else{const se=x instanceof Array?x:[x];this.h.$markTestRetired(se.map(pe=>i.$kJ.fromExtHostTestItem(pe,T).toString()))}},set resolveHandler(x){V.resolveHandler=x},get resolveHandler(){return V.resolveHandler},dispose:()=>{q.dispose()}};X.$registerTestController(T,j,!!O),q.add((0,g.$Pc)(()=>X.$unregisterTestController(T)));const ae={controller:Q,collection:V,profiles:de,extension:M,activeProfiles:ee};return this.g.set(T,ae),q.add((0,g.$Pc)(()=>this.g.delete(T))),q.add(V.onDidGenerateDiff(x=>X.$publishDiff(T,x.map(o.TestsDiffOp.serialize)))),Q}createTestObserver(){return this.m.checkout()}async runTests(M,T=L.CancellationToken.None){const j=h(M);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.g.get(j.controllerId);if(!O)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(q=>i.$kJ.fromExtHostTestItem(q,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:N[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:M.exclude?.map(q=>q.id)},T)}$syncTests(){for(const{collection:M}of this.g.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,T,j){return(0,I.$qb)(this.j.trackers,q=>q.id===M?q.getCoverage(T):void 0)?.provideFileCoverage(j)??Promise.resolve([])}$resolveFileCoverage(M,T,j,O){return(0,I.$qb)(this.j.trackers,V=>V.id===M?V.getCoverage(T):void 0)?.resolveFileCoverage(j,O)??Promise.resolve([])}$configureRunProfile(M,T){this.g.get(M)?.profiles.get(T)?.configureHandler?.()}$setActiveRunProfiles(M){const T=new Map;for(const[j,O]of Object.entries(M)){const q=this.g.get(j);if(!q)continue;const V=new Map,de=O.filter(X=>!q.activeProfiles.has(X)),ee=[...q.activeProfiles].filter(X=>!O.includes(X));for(const X of de)V.set(X,!0),q.activeProfiles.add(X);for(const X of ee)V.set(X,!1),q.activeProfiles.delete(X);V.size&&T.set(j,V)}this.s.fire(T)}async $refreshTests(M,T){await this.g.get(M)?.controller.refreshHandler?.(T)}$publishTestResults(M){this.results=Object.freeze(M.map(T=>(0,A.$$m)(c.TestResults.to(T))).concat(this.results).sort((T,j)=>j.completedAt-T.completedAt).slice(0,32)),this.f.fire()}async $expandTest(M,T){const j=this.g.get(i.$kJ.fromString(M).controllerId)?.collection;j&&(await j.expand(M,T<0?1/0:T),j.flushDiff())}$acceptDiff(M){this.m.applyDiff(M.map(o.TestsDiffOp.deserialize))}async $runControllerTests(M,T){return Promise.all(M.map(j=>this.w(j,!1,T)))}async $startContinuousRun(M,T){const j=new L.$Yd(T),O=await Promise.all(M.map(q=>this.w(q,!0,j.token)));return!T.isCancellationRequested&&!O.some(q=>q.error)&&await new Promise(q=>T.onCancellationRequested(q)),j.dispose(!0),O}async w(M,T,j){const O=this.g.get(M.controllerId);if(!O)return{};const{collection:q,profiles:V,extension:de}=O,ee=V.get(M.profileId);if(!ee)return{};const X=M.testIds.map(se=>q.tree.get(se)).filter(P.$Hf),Q=M.excludeExtIds.map(se=>O.collection.tree.get(se)).filter(P.$Hf).filter(se=>X.some(pe=>pe.fullId.compare(se.fullId)===2));if(!X.length)return{};const ae=new s.$5L(X.some(se=>se.actual instanceof p.$KM)?void 0:X.map(se=>se.actual),Q.map(se=>se.actual),ee,T),x=(0,o.$mJ)(M)&&this.j.prepareForMainThreadTestRun(ae,k.fromInternal(M,O.collection),de,j);try{return await ee.runHandler(ae,j),{}}catch(se){return{error:String(se)}}finally{x&&(x.hasRunningTasks&&!j.isCancellationRequested&&await R.Event.toPromise(x.onEnd),x.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.j.cancelAllRuns():this.j.cancelRunById(M)}};e.$Sec=t,e.$Sec=t=He([Be(0,S.$wM)],t);const r=1e4;var d;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(d||(d={}));class u extends g.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(M,T,j){super(),this.m=M,this.s=T,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$Od),this.onEnd=this.j.event,this.h=this.B(new L.$Yd(j));const O=this.B(new F.$7g(()=>this.u(),r));this.B(this.h.token.onCancellationRequested(()=>O.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(M){return this.f.get(M)?.coverage}createRun(M){const T=this.m.id,j=this.m.controllerId,O=(0,f.$fg)(),q=new D(this.s,T,O),V=Q=>(ae,...x)=>{if(ee){console.warn(`Setting the state of test "${ae.id}" is a no-op after the run ends.`);return}this.m.isIncluded(ae)&&(this.y(ae),Q(ae,...x))},de=(Q,ae)=>{const x=ae instanceof Array?ae.map(c.TestMessage.from):[c.TestMessage.from(ae)];if(Q.uri&&Q.range){const se={range:c.Range.from(Q.range),uri:Q.uri};for(const pe of x)pe.location=pe.location||se}this.s.$appendTestMessagesInRun(T,O,i.$kJ.fromExtHostTestItem(Q,j).toString(),x)};let ee=!1;const X={isPersisted:this.m.isPersisted,token:this.h.token,name:M,get coverageProvider(){return q.coverageProvider},set coverageProvider(Q){q.coverageProvider=Q},enqueued:V(Q=>{this.s.$updateTestStateInRun(T,O,i.$kJ.fromExtHostTestItem(Q,j).toString(),1)}),skipped:V(Q=>{this.s.$updateTestStateInRun(T,O,i.$kJ.fromExtHostTestItem(Q,j).toString(),5)}),started:V(Q=>{this.s.$updateTestStateInRun(T,O,i.$kJ.fromExtHostTestItem(Q,j).toString(),2)}),errored:V((Q,ae,x)=>{de(Q,ae),this.s.$updateTestStateInRun(T,O,i.$kJ.fromExtHostTestItem(Q,j).toString(),6,x)}),failed:V((Q,ae,x)=>{de(Q,ae),this.s.$updateTestStateInRun(T,O,i.$kJ.fromExtHostTestItem(Q,j).toString(),4,x)}),passed:V((Q,ae)=>{this.s.$updateTestStateInRun(T,O,i.$kJ.fromExtHostTestItem(Q,this.m.controllerId).toString(),3,ae)}),appendOutput:(Q,ae,x)=>{ee||(x&&(this.m.isIncluded(x)?this.y(x):x=void 0),this.s.$appendOutputToRun(T,O,m.$ce.fromString(Q),ae&&c.location.from(ae),x&&i.$kJ.fromExtHostTestItem(x,j).toString()))},end:()=>{ee||(ee=!0,this.s.$finishedTestRunTask(T,O),this.f.delete(O),this.f.size||this.w())}};return this.f.set(O,{run:X,coverage:q}),this.s.$startedTestRunTask(T,{id:O,name:M,running:!0}),X}u(){for(const{run:M}of this.f.values())M.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(M){if(!(M instanceof p.$JM))throw new n.$oM(M.id);if(this.g.has(i.$kJ.fromExtHostTestItem(M,this.m.controllerId).toString()))return;const T=[],j=this.m.colllection.root;for(;;){const O=c.TestItem.from(M);if(T.unshift(O),this.g.has(O.extId)||(this.g.add(O.extId),M===j))break;M=M.parent||j}this.s.$addTestsToRun(this.m.controllerId,this.m.id,T)}dispose(){this.w(),super.dispose()}}class l{get trackers(){return this.c.values()}constructor(M){this.d=M,this.c=new Map}prepareForMainThreadTestRun(M,T,j,O){return this.f(M,T,j,O)}cancelRunById(M){for(const T of this.c.values())if(T.id===M){T.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,T,j,O,q,V){const de=this.c.get(O);if(de)return de.createRun(q);const ee=k.fromPublic(T,j,O,V),X=h(O);this.d.$startedExtensionTestRun({controllerId:T,continuous:!!O.continuous,profile:X&&{group:N[X.kind],id:X.profileId},exclude:O.exclude?.map(ae=>i.$kJ.fromExtHostTestItem(ae,j.root.id).toString())??[],id:ee.id,include:O.include?.map(ae=>i.$kJ.fromExtHostTestItem(ae,j.root.id).toString())??[j.root.id],persist:V});const Q=this.f(O,ee,M);return R.Event.once(Q.onEnd)(()=>{this.d.$finishedExtensionTestRun(ee.id),Q.dispose()}),Q.createRun(q)}f(M,T,j,O){const q=new u(T,this.d,O);return this.c.set(M,q),R.Event.once(q.onEnd)(()=>this.c.delete(M)),q}}e.$Tec=l;const h=z=>{if(z.profile){if(!(z.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class k{static fromPublic(M,T,j,O){return new k(M,(0,f.$fg)(),j.include?.map(q=>i.$kJ.fromExtHostTestItem(q,M).toString())??[M],j.exclude?.map(q=>i.$kJ.fromExtHostTestItem(q,M).toString())??[],O,T)}static fromInternal(M,T){return new k(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,T)}constructor(M,T,j,O,q,V){this.controllerId=M,this.id=T,this.isPersisted=q,this.colllection=V,this.c=j.map(de=>de+"\0"),this.d=O.map(de=>de+"\0")}isIncluded(M){const T=i.$kJ.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const j of this.d)if(T===j||T.startsWith(j))return!1;for(const j of this.c)if(T===j||T.startsWith(j))return!0;return!1}}e.$Uec=k;class D{set coverageProvider(M){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");M&&(this.c=M,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(M,T,j){this.f=M,this.g=T,this.h=j}async provideFileCoverage(M){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(M))());try{return(await this.d)?.map(c.TestCoverage.fromFile)??[]}catch(T){throw this.d=void 0,T}}async resolveFileCoverage(M,T){const j=await this.d;let O=j?.[M];return!this.c||!j||!O?[]:(O.detailedCoverage||(O=j[M]=await this.c.resolveFileCoverage?.(O,T)??O),O.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class ${get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(M){this.h=M,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,c.TestItem.toPlain(M.item)),this.c.has(M)||this.d.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.d.delete(M);const T=i.$kJ.parentId(M.item.extId);if(T&&this.g.has(T.toString())){this.g.add(M.item.extId);return}this.f.add(M)}getChangeEvent(){const{c:M,d:T,f:j}=this;return{get added(){return[...M].map(O=>O.revived)},get updated(){return[...T].map(O=>O.revived)},get removed(){return[...j].map(O=>O.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class b extends o.$rJ{constructor(){super(...arguments),this.q=new R.$Od,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(M){return this.d.get(M)}getMirroredTestDataByReference(M){return this.d.get(M.id)}p(M,T){return{...M,revived:c.TestItem.toPlain(M.item),depth:T?T.depth+1:0,children:new Set}}o(){return new $(this.q)}}class v{constructor(M){this.d=M}checkout(){this.c||(this.c=this.f());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(T=>T.revived)},dispose:(0,w.$cb)(()=>{--M.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}f(){const M=new b;return this.d.$subscribeToDiffs(),{observers:0,tests:M}}}class C{#e;#t;#i;#o;#r;get label(){return this.d}set label(M){M!==this.d&&(this.d=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(M){M!==this.g&&(this.g=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.f}set isDefault(M){M!==this.f&&(this.f=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?c.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}get isSelected(){return(0,a.$uF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,a.$uF)(this.#t,"testingActiveProfile"),R.Event.chain(this.#o,M=>M.map(T=>T.get(this.controllerId)?.get(this.profileId)).filter(P.$Hf))}constructor(M,T,j,O,q,V,de,ee,X,Q,ae=!1,x=void 0,se=!1){this.controllerId=V,this.profileId=de,this.d=ee,this.kind=X,this.runHandler=Q,this.f=ae,this._tag=x,this.g=se,this.#e=M,this.#r=T,this.#t=j,this.#i=O,this.#o=q,T.set(de,this);const pe=N[X];if(typeof pe!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);this.#e.$publishTestRunProfile({profileId:de,controllerId:V,tag:x?c.TestTag.namespace(this.controllerId,x.id):null,label:ee,group:pe,isDefault:ae,hasConfigurationHandler:!1,supportsContinuousRun:se})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Vec=C;const N={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(ke[342],Se([1,0,19,11,4,6,150,14,7]),function(me,e,I,F,m,L,R,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;class g{constructor(P,f){this.i=f,this.a=new m.$Od({onListenerError:F.$1}),this.b=new m.$Od({onListenerError:F.$1}),this.c=new m.$Od({onListenerError:F.$1}),this.d=new m.$Od({onListenerError:F.$1}),this.f=new m.$Od({onListenerError:F.$1}),this.g=new m.$Od({onListenerError:F.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=P.getProxy(L.$uK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(P){const f=this.i.allEditors();return P?f:f.map(y=>y.value)}async showTextDocument(P,f,y){let S;typeof f=="number"?S={position:w.ViewColumn.from(f),preserveFocus:y}:typeof f=="object"?S={position:w.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selection:typeof f.selection=="object"?w.Range.from(f.selection):void 0,pinned:typeof f.preview=="boolean"?!f.preview:void 0}:S={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(P.uri,S),c=p&&this.i.getEditor(p);if(c)return c.value;throw p?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}createTextEditorDecorationType(P,f){return new R.$DM(this.h,P,f).value}$acceptEditorPropertiesChanged(P,f){const y=this.i.getEditor(P);if(!y)throw new Error("unknown text editor");if(f.options&&y._acceptOptions(f.options),f.selections){const S=f.selections.selections.map(w.Selection.to);y._acceptSelections(S)}if(f.visibleRanges){const S=I.$Gb(f.visibleRanges.map(w.Range.to));y._acceptVisibleRanges(S)}if(f.options&&this.b.fire({textEditor:y.value,options:{...f.options,lineNumbers:w.TextEditorLineNumbersStyle.to(f.options.lineNumbers)}}),f.selections){const S=E.TextEditorSelectionChangeKind.fromValue(f.selections.source),p=f.selections.selections.map(w.Selection.to);this.a.fire({textEditor:y.value,selections:p,kind:S})}if(f.visibleRanges){const S=I.$Gb(f.visibleRanges.map(w.Range.to));this.c.fire({textEditor:y.value,visibleRanges:S})}}$acceptEditorPositionData(P){for(const f in P){const y=this.i.getEditor(f);if(!y)throw new Error("Unknown text editor");const S=w.ViewColumn.to(P[f]);y.value.viewColumn!==S&&(y._acceptViewColumn(S),this.d.fire({textEditor:y.value,viewColumn:S}))}}getDiffInformation(P){return Promise.resolve(this.h.$getDiffInformation(P))}}e.$$dc=g}),define(ke[343],Se([1,0,2,5,6,3,7,14,26,18]),function(me,e,I,F,m,L,R,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=e.$Mec=void 0,e.$Mec=(0,F.$Sh)("IExtHostTimeline");class A{constructor(y,S){this.b=new Map,this.c=new Map,this.a=y.getProxy(m.$uK.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(p,c)=>{if(p&&p.$mid===12)if(this.b.get(p.source)&&E.$9l.equals(c,this.b.get(p.source)?.extension)){const s=p.uri===void 0?void 0:I.URI.revive(p.uri);return this.c.get(p.source)?.get(P(s))?.get(p.handle)}else return;return p}})}async $getTimeline(y,S,p,c){return this.b.get(y)?.provider.provideTimeline(I.URI.revive(S),p,c)}registerTimelineProvider(y,S,p,c){const s=new L.$Qc,i=this.d(S.id,c,s).bind(this);let n;S.onDidChange&&(n=S.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:S.id}),this));const o=this.c;return this.f({...S,scheme:y,onDidChange:void 0,async provideTimeline(a,t,r){t?.resetCache&&(s.clear(),o.get(S.id)?.clear());const d=await S.provideTimeline(a,t,r);if(d==null)return;const u=i(a,t);return{...d,source:S.id,items:d.items.map(u)}},dispose(){for(const a of o.values())a.get(S.id)?.clear();n?.dispose(),s.dispose()}},p)}d(y,S,p){return(c,s)=>{let i;if(s?.cacheResults){let n=this.c.get(y);n===void 0&&(n=new Map,this.c.set(y,n));const o=P(c);i=n.get(o),i===void 0&&(i=new Map,n.set(o,i))}return n=>{const{iconPath:o,...a}=n,t=`${y}|${n.id??n.timestamp}`;i?.set(t,n);let r,d,u;n.iconPath&&(o instanceof R.$qL?u={id:o.id,color:o.color}:I.URI.isUri(o)?(r=o,d=o):{light:r,dark:d}=o);let l;return R.$WK.isMarkdownString(a.tooltip)?l=w.MarkdownString.from(a.tooltip):(0,g.$zf)(a.tooltip)?l=a.tooltip:R.$WK.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=w.MarkdownString.from(a.detail)):(0,g.$zf)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=a.detail),{...a,id:a.id??void 0,handle:t,source:y,command:n.command?S.toInternal(n.command,p):void 0,icon:r,iconDark:d,themeIcon:u,tooltip:l,accessibilityInformation:n.accessibilityInformation}}}}f(y,S){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:S}),(0,L.$Pc)(()=>{for(const c of this.c.values())c.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$Nec=A;function P(f){return f?.toString()}}),define(ke[73],Se([1,0,21,4,3,222,5,15,88,6,27,20,7]),function(me,e,I,F,m,L,R,w,E,g,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nwb=e.$Mwb=e.TunnelDtoConverter=void 0;class y extends E.$jv{}var S;(function(c){function s(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:n.protocol}}c.fromApiTunnel=s;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==E.TunnelPrivacyId.ConstantPrivate&&n.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}c.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$Mwb=(0,R.$Sh)("IExtHostTunnelService");let p=class extends m.$Rc{constructor(s,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$Od,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(g.$uK.MainThreadTunnelService)}async openTunnel(s,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,s.displayName);if(n){const o=new y(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,i){const n=this.u();return this.r.set(n,{selector:s,provider:i}),this.a.$registerPortsAttributesProvider(s,n),new f.$wK(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(s,i,n,o,a){const t=[];for(const d of s){const u=this.r.get(d);if(!u)return[];t.push(...await Promise.all(i.map(async l=>{let h;try{h=await u.provider.providePortAttributes({port:l,pid:n,commandLine:o},a)}catch{h=await u.provider.providePortAttributes(l,n,o,a)}return{providedAttributes:h,port:l}})))}const r=t.filter(d=>!!d.providedAttributes);return r.length>0?r.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,a)=>await s.provideTunnel(o,a,new I.$Yd().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,m.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const n=s.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let o=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const a=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:o}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,m.$Pc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,i){if(this.g.has(s.host)){const n=this.g.get(s.host);n.has(s.port)&&(i&&n.get(s.port).disposeListener.dispose(),await n.get(s.port).tunnel.dispose(),n.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(s,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const a=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:o,disposeListener:a}),S.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(o=>this.f(o.host,o.port,o.detail??""))),n=s.filter((o,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$Nwb=p,e.$Nwb=p=He([Be(0,P.$wM),Be(1,A.$MM),Be(2,w.$aj)],p)}),define(ke[344],Se([1,0,3,17,2,6]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class R{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(L.$uK.MainThreadUriOpeners)}registerExternalUriOpener(E,g,A,P){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const f=P.schemes.find(y=>!R.a.has(y));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this.c.set(g,A),this.b.$registerUriOpener(g,P.schemes,E,P.label),(0,I.$Pc)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(E,g,A){const P=this.c.get(E);if(!P)throw new Error(`Unknown opener with id: ${E}`);const f=m.URI.revive(g);return P.canOpenExternalUri(f,A)}async $openUri(E,g,A){const P=this.c.get(E);if(!P)throw new Error(`Unknown opener id: '${E}'`);return P.openExternalUri(m.URI.revive(g.resolvedUri),{sourceUri:m.URI.revive(g.sourceUri)},A)}}e.$Wec=R}),define(ke[345],Se([1,0,6,2,3,11,26]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;class w{static{this.a=0}constructor(g){this.c=new R.$0l,this.d=new Map,this.b=g.getProxy(I.$uK.MainThreadUrls)}registerUriHandler(g,A){const P=g.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const f=w.a++;return this.c.add(P),this.d.set(f,A),this.b.$registerUriHandler(f,P,g.displayName||g.name),(0,m.$Pc)(()=>{this.c.delete(P),this.d.delete(f),this.b.$unregisterUriHandler(f)})}$handleExternalUri(g,A){const P=this.d.get(g);if(!P)return Promise.resolve(void 0);try{P.handleUri(F.URI.revive(A))}catch(f){(0,L.$Z)(f)}return Promise.resolve(void 0)}async createAppUri(g){return F.URI.revive(await this.b.$createAppUri(g))}}e.$aec=w}),define(ke[93],Se([1,0,4,3,17,24,2,239,276,113,6]),function(me,e,I,F,m,L,R,w,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=e.$eec=e.$dec=e.$cec=e.$bec=void 0;class P{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(o,a,t,r,d,u,l){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$Od,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$Od,this._onDidDispose=this.#h.event,this.#e=o,this.#t=a,this.#s=t,this.#o=r,this.#r=d,this.#n=u,this.#l=f(u),this.#d=y(u),this.#i=l}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#u=!0,(0,g.$6tb)(o,this.#o)}get cspSource(){const o=this.#n.extensionLocation;if(o.scheme===m.Schemas.https||o.scheme===m.Schemas.http){let a=o.toString();return a.endsWith("/")||(a+="/"),a+" "+g.$5tb}return g.$5tb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#s}set options(o){this.a(),L.$bn(this.#s,o)||this.#t.$setOptions(this.#e,c(this.#n,this.#r,o)),this.#s=o}async postMessage(o){if(this.#c)return!1;const a=(0,E.$bdb)(o,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const a=this.#n.extensionLocation?.scheme===m.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===m.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,u,l,h,k)=>{const D=R.URI.from({scheme:l||"file",path:decodeURIComponent(h)}),$=(0,g.$6tb)(D,{isRemote:a,authority:t}).toString();return`${d}${$}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,u,l,h,k)=>{const D=R.URI.from({scheme:l||"file",path:decodeURIComponent(h)}),$=(0,g.$6tb)(D,{isRemote:a,authority:t}).toString();return`${d}${$}${k}`})}}e.$bec=P;function f(n){try{const o=(0,w.$Qo)((0,w.$Po)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$cec=f;function y(n){try{const o=(0,w.$Qo)((0,w.$Po)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class S extends F.$Rc{constructor(o,a,t,r,d){super(),this.c=a,this.f=t,this.g=r,this.h=d,this.b=new Map,this.a=o.getProxy(A.$uK.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,a,t){const r=this.j(o);if(r){const{message:d}=(0,E.$cdb)(a,t.value);r._onMessageEmitter.fire(d)}}$onMissingCsp(o,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,a,t){const r=new P(o,this.a,s(a),this.c,this.f,t,this.h);this.b.set(o,r);const d=r._onDidDispose(()=>{d.dispose(),this.deleteWebview(o)});return r}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$dec=S;function p(n){return{id:n.identifier,location:n.extensionLocation}}e.$eec=p;function c(n,o,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(n,o)}}e.$fec=c;function s(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>R.URI.from(o))}}function i(n,o){return[...(o?.getWorkspaceFolders()||[]).map(a=>a.uri),n.extensionLocation]}}),define(ke[346],Se([1,0,21,52,3,17,23,2,14,93,110,6,7]),function(me,e,I,F,m,L,R,w,E,g,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=void 0;class y{constructor(r,d){this.document=r,this.b=d,this.a=1,this.c=new A.$0cc("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,d){await this.f(r).undo(),d||this.disposeBackup()}async redo(r,d){await this.f(r).redo(),d||this.disposeBackup()}disposeEdits(r){for(const d of r)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=a(this.document.uri)+this.a++;return(0,R.$wg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const d=this.c.get(r,0);if(!d)throw new Error("No edit found");return d}}class S{constructor(){this.a=new Map}get(r,d){return this.a.get(this.b(r,d))}add(r,d,u){const l=this.b(r,d.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${r} resource:${d.uri}`);const h=new y(d,u);return this.a.set(l,h),h}delete(r,d){const u=this.b(r,d.uri);this.a.delete(u)}b(r,d){return`${r}@@@${d}`}}var p;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(p||(p={}));class c{constructor(){this.a=new Map}addTextProvider(r,d,u){return this.b(0,r,d,u)}addCustomProvider(r,d,u){return this.b(1,r,d,u)}get(r){return this.a.get(r)}b(r,d,u,l){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:r,extension:u,provider:l}),new f.$wK(()=>this.a.delete(d))}}class s{constructor(r,d,u,l,h){this.d=d,this.f=u,this.g=l,this.h=h,this.b=new c,this.c=new S,this.a=r.getProxy(P.$uK.MainThreadCustomEditors)}registerCustomEditorProvider(r,d,u,l){const h=new m.$Qc;return n(u)?(h.add(this.b.addTextProvider(d,r,u)),this.a.$registerTextEditorProvider((0,g.$eec)(r),d,l.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,g.$cec)(r))):(h.add(this.b.addCustomProvider(d,r,u)),i(u)&&h.add(u.onDidChangeCustomDocument(k=>{const D=this.i(d,k.document.uri);if(o(k)){const $=D.addEdit(k);this.a.$onDidEdit(k.document.uri,d,$,k.label)}else this.a.$onContentChange(k.document.uri,d)})),this.a.$registerCustomEditorProvider((0,g.$eec)(r),d,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,g.$cec)(r))),f.$wK.from(h,new f.$wK(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(r,d,u,l,h){const k=this.b.get(d);if(!k)throw new Error(`No provider found for '${d}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${d}'`);const D=w.URI.revive(r),$=await k.provider.openCustomDocument(D,{backupId:u,untitledDocumentData:l?.buffer},h);let b;return i(k.provider)&&this.f&&(b=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(d,$,b),{editable:i(k.provider)}}async $disposeCustomDocument(r,d){const u=this.b.get(d);if(!u)throw new Error(`No provider found for '${d}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${d}'`);const l=w.URI.revive(r),{document:h}=this.i(d,l);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(r,d,u,l,h,k){const D=this.b.get(u);if(!D)throw new Error(`No provider found for '${u}'`);const $=E.ViewColumn.to(h),b=this.g.createNewWebview(d,l.contentOptions,D.extension),v=this.h.createNewWebviewPanel(d,u,l.title,$,l.options,b,l.active),C=w.URI.revive(r);switch(D.type){case 1:{const{document:N}=this.i(u,C);return D.provider.resolveCustomEditor(N,v,k)}case 0:{const N=this.d.getDocument(C);return D.provider.resolveCustomTextEditor(N,v,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,d,u){this.i(d,r).disposeEdits(u)}async $onMoveCustomEditor(r,d,u){const l=this.b.get(u);if(!l)throw new Error(`No provider found for '${u}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const h=this.h.getWebviewPanel(r);if(!h)throw new Error("No webview found");const k=w.URI.revive(d),D=this.d.getDocument(k);await l.provider.moveCustomTextEditor(D,h,I.CancellationToken.None)}async $undo(r,d,u,l){return this.i(d,r).undo(u,l)}async $redo(r,d,u,l){return this.i(d,r).redo(u,l)}async $revert(r,d,u){const l=this.i(d,r);await this.j(d).revertCustomDocument(l.document,u),l.disposeBackup()}async $onSave(r,d,u){const l=this.i(d,r);await this.j(d).saveCustomDocument(l.document,u),l.disposeBackup()}async $onSaveAs(r,d,u,l){const h=this.i(d,r);return this.j(d).saveCustomDocumentAs(h.document,w.URI.revive(u),l)}async $backup(r,d,u){const l=this.i(d,r),k=await this.j(d).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},u);return l.updateBackup(k),k.id}i(r,d){const u=this.c.get(r,w.URI.revive(d));if(!u)throw new Error("No custom document found");return u}j(r){const u=this.b.get(r)?.provider;if(!u||!i(u))throw new Error("Custom document is not editable");return u}}e.$Qec=s;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const r=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,F.$Gi)(r)+""}}),define(ke[347],Se([1,0,4,3,2,32,14,93,6,7]),function(me,e,I,F,m,L,R,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=void 0;class A extends F.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(S,p,c,s){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$Od),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$Od),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=p,this.#o=c,this.#i=s.viewType,this.#r=s.panelOptions,this.#s=s.viewColumn,this.#n=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(S){this.c(),this.#n!==S&&(this.#n=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,m.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(S){this.#l||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#u=S.active,this.#c=S.visible,this.#s=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,p){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:R.ViewColumn.from(S),preserveFocus:!!p})}c(){if(this.#l)throw new Error("Webview is disposed")}}class P extends F.$Rc{static c(){return(0,L.$fg)()}constructor(S,p,c){super(),this.j=p,this.m=c,this.g=new Map,this.h=new Map,this.f=S.getProxy(E.$uK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,p,c,s,i={}){const n=typeof s=="object"?s.viewColumn:s,o={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof s=="object"&&!!s.preserveFocus},a=(0,w.$cec)(S),t=P.c();this.f.$createWebviewPanel((0,w.$eec)(S),t,p,{title:c,panelOptions:f(i),webviewOptions:(0,w.$fec)(S,this.m,i),serializeBuffersForPostMessage:a},o);const r=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,p,c,n,i,r,!0)}$onDidChangeWebviewPanelViewStates(S){const p=Object.keys(S);p.sort((c,s)=>{const i=S[c],n=S[s];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const c of p){const s=this.getWebviewPanel(c);if(!s)continue;const i=S[c];s._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,p,c){if(this.h.has(p))throw new Error(`Serializer for '${p}' already registered`);return this.h.set(p,{serializer:c,extension:S}),this.f.$registerSerializer(p,{serializeBuffersForPostMessage:(0,w.$cec)(S)}),new g.$wK(()=>{this.h.delete(p),this.f.$unregisterSerializer(p)})}async $deserializeWebviewPanel(S,p,c,s){const i=this.h.get(p);if(!i)throw new Error(`No serializer found for '${p}'`);const{serializer:n,extension:o}=i,a=this.j.createNewWebview(S,c.webviewOptions,o),t=this.createNewWebviewPanel(S,p,c.title,s,c.panelOptions,a,c.active);await n.deserializeWebviewPanel(t,c.state)}createNewWebviewPanel(S,p,c,s,i,n,o){const a=new A(S,this.f,n,{viewType:p,title:c,viewColumn:s,panelOptions:i,active:o});return this.g.set(S,a),a}getWebviewPanel(S){return this.g.get(S)}}e.$Pec=P;function f(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(ke[348],Se([1,0,4,3,93,14,6,7]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;class E extends F.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(P,f,y,S,p,c){super(),this.#r=!1,this.#u=this.B(new I.$Od),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$Od),this.onDidDispose=this.#l.event,this.#i=y,this.#a=S,this.#e=P,this.#t=f,this.#o=p,this.#n=c}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(P){this.a(),this.#a!==P&&(this.#a=P,this.#t.$setWebviewViewTitle(this.#e,P))}get description(){return this.a(),this.#s}set description(P){this.a(),this.#s!==P&&(this.#s=P,this.#t.$setWebviewViewDescription(this.#e,P))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(P){P===this.#n||this.#r||(this.#n=P,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(P){this.a(),!(P?.value===this.#c?.value&&P?.tooltip===this.#c?.tooltip)&&(this.#c=L.ViewBadge.from(P),this.#t.$setWebviewViewBadge(this.#e,P))}show(P){this.a(),this.#t.$show(this.#e,!!P)}a(){if(this.#r)throw new Error("Webview is disposed")}}class g{constructor(P,f){this.d=f,this.b=new Map,this.c=new Map,this.a=P.getProxy(R.$uK.MainThreadWebviewViews)}registerWebviewViewProvider(P,f,y,S){if(this.b.has(f))throw new Error(`View provider for '${f}' already registered`);return this.b.set(f,{provider:y,extension:P}),this.a.$registerWebviewViewProvider((0,m.$eec)(P),f,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,m.$cec)(P)}),new w.$wK(()=>{this.b.delete(f),this.a.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(P,f,y,S,p){const c=this.b.get(f);if(!c)throw new Error(`No view provider found for '${f}'`);const{provider:s,extension:i}=c,n=this.d.createNewWebview(P,{},i),o=new E(P,this.a,f,y,n,!0);this.c.set(P,o),await s.resolveWebviewView(o,{state:S},p)}async $onDidChangeWebviewViewVisibility(P,f){this.e(P)._setVisible(f)}async $disposeWebviewView(P){const f=this.e(P);this.c.delete(P),f.dispose(),this.d.deleteWebview(P)}e(P){const f=this.c.get(P);if(!f)throw new Error("No webview found");return f}}e.$Oec=g}),define(ke[153],Se([1,0,4,6,2,17,13,5,20,25]),function(me,e,I,F,m,L,R,w,E,g){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=e.$gec=void 0;let P=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(y){const S=this.d;return{get focused(){return S.focused},get active(){return(0,g.$uF)(y,"windowActivity"),S.active}}}constructor(y){this.c=new I.$Od,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=y.getProxy(F.$uK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:p})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",p)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,S){S!==this.d[y]&&(this.d={...this.d,[y]:S},this.c.fire(this.d))}openUri(y,S){let p;if(typeof y=="string"){p=y;try{y=m.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,R.$Ce)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this.b.$openUri(y,p,S)}async asExternalUri(y,S){if((0,R.$Ce)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(y,S);return m.URI.from(p)}};e.$gec=P,e.$gec=P=A=He([Be(0,E.$wM)],P),e.$hec=(0,w.$Sh)("IExtHostWindow")}),define(ke[349],Se([1,0,317,27,20]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0;const L=1024*1024;let R=class extends I.$hfc{constructor(E,g){super(E,g),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,g,A){const P=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),g.apply(console,A),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,g){const A=process[E],P=A.write;let f="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(y,S,p)=>{if(!this.g){f+=y.toString(S);const c=f.length>L?f.length:f.lastIndexOf(`
`);c!==-1&&(console[g](f.slice(0,c)),f=f.slice(c+1))}P.call(A,y,S,p)}})}};e.$Sfc=R,e.$Sfc=R=He([Be(0,m.$wM),Be(1,F.$MM)],R)}),define(ke[350],Se([1,0,72,17,15,251,31,12]),function(me,e,I,F,m,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=void 0;let E=class{constructor(P,f){P.addFileSystemProvider(F.Schemas.file,new g(f),{isCaseSensitive:w.$k})}};e.$Tfc=E,e.$Tfc=E=He([Be(0,I.$Fdc),Be(1,m.$aj)],E);class g{constructor(P){this.b=P,this.a=new L.$dq(this.b)}async stat(P){const f=await this.a.stat(P);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,f,y){return this.a.writeFile(P,f,{...y,unlock:!1,atomic:!1})}delete(P,f){return this.a.delete(P,{...f,useTrash:!1,atomic:!1})}rename(P,f,y){return this.a.rename(P,f,y)}copy(P,f,y){return this.a.copy(P,f,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,f){throw new Error("Method not implemented.")}}}),define(ke[351],Se([1,0,16,63,32,35,3,6,2,20]),function(me,e,I,F,m,L,R,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=void 0;let A=class extends R.$Rc{constructor(f,y){super();const S=f.getProxy(w.$uK.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async p=>{const c=E.URI.file((0,I.$ic)((0,F.tmpdir)(),(0,m.$fg)()));return await S.$download(p,c),c})}};e.$Rfc=A,e.$Rfc=A=He([Be(0,g.$wM),Be(1,L.$SM)],A)}),define(ke[352],Se([1,0,152,17,253,32]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;class R extends I.$gfc{s(E,g,A){return E.scheme===F.Schemas.file?new m.$IN(A?.name||(0,L.$fg)(),E.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,g):super.s(E,g,A)}registerLogger(E){super.registerLogger(E),this.r.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.r.$deregisterLogger(E)}}e.$5fc=R}),define(ke[353],Se([1,0,55,16,2,92,3,17,10,30]),function(me,e,I,F,m,L,R,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0;class A extends L.$Hdc{constructor(){super(...arguments),this.i=null}async g(t){const r=await super.g(t);if(r.scheme!==w.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const d=r.fsPath;let u=0;do{let l;u===0?l=d:l=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${u}`:`${d}-${u}`,await P(l);const h=F.$ic(l,"vscode.lock"),k=await p(this.d,h,!1);if(k)return this.i=k,process.on("exit",()=>{k.dispose()}),m.URI.file(l);u++}while(u<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$4fc=A;async function P(a){try{await g.Promises.stat(a);return}catch{}try{await g.Promises.mkdir(a,{recursive:!0})}catch{}}const f=1e3,y=10*60*1e3;class S extends R.$Rc{constructor(t,r){super(),this.b=t,this.c=r,this.a=this.B(new E.$6g),this.a.cancelAndSet(async()=>{const d=await c(t,r);(!d||d.pid!==process.pid)&&(t.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await g.Promises.utimes(r,new Date,new Date)}catch(u){t.error(u),t.info(`Lock '${r}': Could not update mtime.`)}},f)}dispose(){super.dispose();try{I.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+t};await g.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function p(a,t,r){try{const u={pid:process.pid,willReleaseAt:0};await g.Promises.writeFile(t,JSON.stringify(u),{flag:"wx"})}catch(u){a.error(u)}const d=await c(a,t);return!d||d.pid!==process.pid?r?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new S(a,t))}async function c(a,t){let r;try{r=await g.Promises.readFile(t)}catch(d){return a.error(d),null}try{return JSON.parse(String(r))}catch(d){return a.error(d),null}}async function s(a,t){let r;try{r=await g.Promises.stat(t)}catch(d){return a.error(d),0}return r.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const r=await c(a,t);if(!r)return a.info(`Lock '${t}': Could not read pid of lock holder.`),o(a,t);if(r.willReleaseAt){let k=r.willReleaseAt-Date.now();if(k<5e3){for(k>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${k} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);k>0;){if(await(0,E.$Vg)(Math.min(100,k)),await s(a,t)===0)return o(a,t);k=r.willReleaseAt-Date.now()}return o(a,t)}}if(!i(r.pid))return a.info(`Lock '${t}': The pid ${r.pid} appears to be gone.`),o(a,t);const d=await s(a,t),u=Date.now()-d;if(u<=y)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,E.$Vg)(2e3);const l=await s(a,t),h=Date.now()-l;return h<=y?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),o(a,t))}async function o(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await g.Promises.unlink(t)}catch{}return p(a,t,!0)}}),define(ke[354],Se([1,0,32,20,46,35]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=void 0;let R=class extends m.$Kdc{constructor(E,g){super(!0,E,g)}createTerminal(E,g,A){return this.createTerminalFromOptions({name:E,shellPath:g,shellArgs:A})}createTerminalFromOptions(E,g){const A=new m.$Jdc(this.a,(0,I.$fg)(),E,E.name);return this.f.push(A),A.create(E,this.R(E,g)),A.value}};e.$mfc=R,e.$mfc=R=He([Be(0,L.$SM),Be(1,F.$wM)],R)}),define(ke[355],Se([1,0,10,22,21,11,4,3,131,305,69]),function(me,e,I,F,m,L,R,w,E,g,A){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$w5b=e.ResponsiveState=e.RequestInitiator=e.$v5b=e.$u5b=void 0;function f(v,C){try{return JSON.stringify(v,C)}catch{return"null"}}const y="$$ref$$",S={[y]:-1};class p{constructor(C,N){this.jsonString=C,this.referencedBuffers=N}}function c(v,C=null,N=!1){const z=[];return{jsonString:(N?f:JSON.stringify)(v,(T,j)=>{if(typeof j>"u")return S;if(typeof j=="object"){if(j instanceof F.$ce){const O=z.push(j)-1;return{[y]:O}}if(C)return C(T,j)}return j}),referencedBuffers:z}}e.$u5b=c;function s(v,C,N){return JSON.parse(v,(z,M)=>{if(M){const T=M[y];if(typeof T=="number")return C[T];if(N&&M.$mid===1)return N.transformIncoming(M)}return M})}e.$v5b=s;function i(v,C){return JSON.stringify(v,C)}function n(v){return v?(C,N)=>N&&N.$mid===1?v.transformOutgoing(N):N:null}var o;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var a;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},r=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class u extends w.$Rc{static{P=r}static{this.a=3*1e3}constructor(C,N=null,z=null){super(),this[P]=!0,this.b=this.B(new R.$Od),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=N,this.g=z,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,T=A.$qv.count;M<T;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$7g(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const N=this.w[C];delete this.w[C],N.resolveErr(L.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+u.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+u.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,E.$Rm)(C,this.g):C}getProxy(C){const{nid:N,sid:z}=C;return this.s[N]||(this.s[N]=this.J(N,z)),this.s[N]}J(C,N){const z={get:(M,T)=>(typeof T=="string"&&!M[T]&&T.charCodeAt(0)===36&&(M[T]=(...j)=>this.U(C,T,j)),T===d?N:M[T])};return new Proxy(Object.create(null),z)}set(C,N){return this.m[C.nid]=N,N}assertRegistered(C){for(let N=0,z=C.length;N<z;N++){const M=C[N];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(C){if(this.j)return;const N=C.byteLength,z=h.read(C,0),M=z.readUInt8(),T=z.readUInt32();switch(M){case 1:case 2:{let{rpcId:j,method:O,args:q}=D.deserializeRequestJSONArgs(z);this.g&&(q=(0,E.$Rm)(q,this.g)),this.M(N,T,j,O,q,M===2);break}case 3:case 4:{let{rpcId:j,method:O,args:q}=D.deserializeRequestMixedArgs(z);this.g&&(q=(0,E.$Rm)(q,this.g)),this.M(N,T,j,O,q,M===4);break}case 5:{this.f?.logIncoming(N,T,0,"ack"),this.G(T);break}case 6:{this.N(N,T);break}case 7:{this.O(N,T,void 0);break}case 9:{let j=D.deserializeReplyOKJSON(z);this.g&&(j=(0,E.$Rm)(j,this.g)),this.O(N,T,j);break}case 10:{const j=D.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(N,T,j);break}case 8:{const j=D.deserializeReplyOKVSBuffer(z);this.O(N,T,j);break}case 11:{let j=D.deserializeReplyErrError(z);this.g&&(j=(0,E.$Rm)(j,this.g)),this.P(N,T,j);break}case 12:{this.P(N,T,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,N,z,M,T,j){this.f?.logIncoming(C,N,1,`receiveRequest ${(0,A.$sv)(z)}.${M}(`,T);const O=String(N);let q,V;if(j){const ee=new m.$Yd;T.push(ee.token),q=this.Q(z,M,T),V=()=>ee.cancel()}else q=this.Q(z,M,T),V=t;this.u[O]=V;const de=D.serializeAcknowledged(N);this.f?.logOutgoing(de.byteLength,N,1,"ack"),this.c.send(de),q.then(ee=>{delete this.u[O];const X=D.serializeReplyOK(N,ee,this.h);this.f?.logOutgoing(X.byteLength,N,1,"reply:",ee),this.c.send(X)},ee=>{delete this.u[O];const X=D.serializeReplyErr(N,ee);this.f?.logOutgoing(X.byteLength,N,1,"replyErr:",ee),this.c.send(X)})}N(C,N){this.f?.logIncoming(C,N,1,"receiveCancel");const z=String(N);this.u[z]?.()}O(C,N,z){this.f?.logIncoming(C,N,0,"receiveReply:",z);const M=String(N);if(!this.w.hasOwnProperty(M))return;const T=this.w[M];delete this.w[M],T.resolveOk(z)}P(C,N,z){this.f?.logIncoming(C,N,0,"receiveReplyErr:",z);const M=String(N);if(!this.w.hasOwnProperty(M))return;const T=this.w[M];delete this.w[M];let j;z&&(z.$isError?(j=new Error,j.name=z.name,j.message=z.message,j.stack=z.stack):j=z),T.resolveErr(j)}Q(C,N,z){try{return Promise.resolve(this.S(C,N,z))}catch(M){return Promise.reject(M)}}S(C,N,z){const M=this.m[C];if(!M)throw new Error("Unknown actor "+(0,A.$sv)(C));const T=M[N];if(typeof T!="function")throw new Error("Unknown method "+N+" on actor "+(0,A.$sv)(C));return T.apply(M,z)}U(C,N,z){if(this.j)return new g.$t5b;let M=null;if(z.length>0&&m.CancellationToken.isCancellationToken(z[z.length-1])&&(M=z.pop()),M&&M.isCancellationRequested)return Promise.reject(L.$5());const T=D.serializeRequestArguments(z,this.h),j=++this.t,O=String(j),q=new g.$s5b,V=new w.$Qc;M&&V.add(M.onCancellationRequested(()=>{const ee=D.serializeCancel(j);this.f?.logOutgoing(ee.byteLength,j,0,"cancel"),this.c.send(D.serializeCancel(j))})),this.w[O]=new l(q,V),this.F(j);const de=D.serializeRequest(j,C,N,T,!!M);return this.f?.logOutgoing(de.byteLength,j,0,`request: ${(0,A.$sv)(C)}.${N}(`,z),this.c.send(de),q}}e.$w5b=u;class l{constructor(C,N){this.a=C,this.b=N}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class h{static alloc(C,N,z){const M=new h(F.$ce.alloc(z+1+4),0);return M.writeUInt8(C),M.writeUInt32(N),M}static read(C,N){return new h(C,N)}get buffer(){return this.a}constructor(C,N){this.a=C,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+C).toString();return this.b+=C,z}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+C).toString();return this.b+=C,z}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+C);return this.b+=C,N}static sizeMixedArray(C){let N=0;N+=1;for(let z=0,M=C.length;z<M;z++){const T=C[z];switch(N+=1,T.type){case 1:N+=this.sizeLongString(T.value);break;case 2:N+=this.sizeVSBuffer(T.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(T.value);for(let j=0;j<T.buffers.length;++j)N+=this.sizeVSBuffer(T.buffers[j]);break;case 4:break}}return N}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let N=0,z=C.length;N<z;N++){const M=C[N];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let T=0;T<M.buffers.length;++T)this.writeBuffer(M.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const N=new Array(C);for(let z=0;z<C;z++)switch(this.readUInt8()){case 1:N[z]=this.readLongString();break;case 2:N[z]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),j=this.readLongString(),O=[];for(let q=0;q<T;++q)O.push(this.readVSBuffer());N[z]=new A.$tv(s(j,O,null));break}case 4:N[z]=void 0;break}return N}}var k;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(k||(k={}));class D{static a(C){for(let N=0,z=C.length;N<z;N++)if(C[N]instanceof F.$ce||C[N]instanceof A.$tv||typeof C[N]>"u")return!0;return!1}static serializeRequestArguments(C,N){if(this.a(C)){const z=[];for(let M=0,T=C.length;M<T;M++){const j=C[M];if(j instanceof F.$ce)z[M]={type:2,value:j};else if(typeof j>"u")z[M]={type:4};else if(j instanceof A.$tv){const{jsonString:O,referencedBuffers:q}=c(j.value,N);z[M]={type:3,value:F.$ce.fromString(O),buffers:q}}else z[M]={type:1,value:F.$ce.fromString(i(j,N))}}return{type:1,args:z}}return{type:0,args:i(C,N)}}static serializeRequest(C,N,z,M,T){switch(M.type){case 0:return this.b(C,N,z,M.args,T);case 1:return this.c(C,N,z,M.args,T)}}static b(C,N,z,M,T){const j=F.$ce.fromString(z),O=F.$ce.fromString(M);let q=0;q+=h.sizeUInt8(),q+=h.sizeShortString(j),q+=h.sizeLongString(O);const V=h.alloc(T?2:1,C,q);return V.writeUInt8(N),V.writeShortString(j),V.writeLongString(O),V.buffer}static deserializeRequestJSONArgs(C){const N=C.readUInt8(),z=C.readShortString(),M=C.readLongString();return{rpcId:N,method:z,args:JSON.parse(M)}}static c(C,N,z,M,T){const j=F.$ce.fromString(z);let O=0;O+=h.sizeUInt8(),O+=h.sizeShortString(j),O+=h.sizeMixedArray(M);const q=h.alloc(T?4:3,C,O);return q.writeUInt8(N),q.writeShortString(j),q.writeMixedArray(M),q.buffer}static deserializeRequestMixedArgs(C){const N=C.readUInt8(),z=C.readShortString(),M=C.readMixedArray(),T=new Array(M.length);for(let j=0,O=M.length;j<O;j++){const q=M[j];typeof q=="string"?T[j]=JSON.parse(q):T[j]=q}return{rpcId:N,method:z,args:T}}static serializeAcknowledged(C){return h.alloc(5,C,0).buffer}static serializeCancel(C){return h.alloc(6,C,0).buffer}static serializeReplyOK(C,N,z){if(typeof N>"u")return this.d(C);if(N instanceof F.$ce)return this.e(C,N);if(N instanceof A.$tv){const{jsonString:M,referencedBuffers:T}=c(N.value,z,!0);return this.g(C,M,T)}else return this.f(C,f(N,z))}static d(C){return h.alloc(7,C,0).buffer}static e(C,N){let z=0;z+=h.sizeVSBuffer(N);const M=h.alloc(8,C,z);return M.writeVSBuffer(N),M.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,N){const z=F.$ce.fromString(N);let M=0;M+=h.sizeLongString(z);const T=h.alloc(9,C,M);return T.writeLongString(z),T.buffer}static g(C,N,z){const M=F.$ce.fromString(N);let T=0;T+=h.sizeUInt32,T+=h.sizeLongString(M);for(const O of z)T+=h.sizeVSBuffer(O);const j=h.alloc(10,C,T);j.writeUInt32(z.length),j.writeLongString(M);for(const O of z)j.writeBuffer(O);return j.buffer}static deserializeReplyOKJSON(C){const N=C.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(C,N){const z=C.readUInt32(),M=C.readLongString(),T=[];for(let j=0;j<z;++j)T.push(C.readVSBuffer());return new A.$tv(s(M,T,N))}static serializeReplyErr(C,N){const z=N?f(L.$2(N),null):void 0;if(typeof z!="string")return this.h(C);const M=F.$ce.fromString(z);let T=0;T+=h.sizeLongString(M);const j=h.alloc(11,C,T);return j.writeLongString(M),j.buffer}static deserializeReplyErrError(C){const N=C.readLongString();return JSON.parse(N)}static h(C){return h.alloc(12,C,0).buffer}}var $;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var b;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(b||(b={}))}),define(ke[356],Se([1,0,4,38,45,5]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=e.$MJ=e.OutputChannelUpdateMode=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=void 0,e.$CJ="text/x-code-output",e.$DJ="output",e.$EJ="Log",e.$FJ="text/x-code-log-output",e.$GJ="log",e.$HJ="workbench.panel.output",e.$IJ=new m.$0i("inOutput",!1),e.$JJ=new m.$0i("activeLogOutput",!1),e.$KJ=new m.$0i("outputView.scrollLock",!1),e.$LJ=(0,L.$Sh)("outputService");var R;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$MJ={OutputChannels:"workbench.contributions.outputChannels"};class w{constructor(){this.a=new Map,this.b=new I.$Od,this.onDidRegisterChannel=this.b.event,this.c=new I.$Od,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(A=>g.push(A)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}F.$jn.add(e.$MJ.OutputChannels,new w),e.$NJ=new m.$0i("activeOutputChannel","")}),define(ke[154],Se([1,0,6,5,20,26,15,356,72,27,57,182,22,18,31,4,3]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=e.$3dc=void 0;class s extends R.$gj{get disposed(){return this.n}constructor(a,t,r,d,u){super(),this.id=a,this.name=t,this.r=r,this.s=d,this.extension=u,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,w.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=f.$ce.fromString(t).byteLength,(0,R.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends s{appendLine(a){this.append(a)}}let n=class{constructor(a,t,r,d,u,l){this.i=t,this.j=r,this.k=d,this.l=u,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(I.$uK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$hm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,r]of this.g)r.visible=t===this.h}createOutputChannel(a,t,r){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,u=(0,y.$zf)(t)?t:void 0;if((0,y.$zf)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const h=this.i.environment.extensionLogLevel?.find(([D])=>L.$9l.equals(r.identifier,D))?.[1];h&&(l=(0,R.$qj)(h));const k=d?this.o(a,l,r):this.n(a,u,r);return k.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),d?this.r(a,l??this.m.getLevel(),k):this.q(a,k)}async n(a,t,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,u=this.k.extUri.joinPath(d,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(a,u,t,r.identifier.value);return new s(h,a,l,this.a,r)}async o(a,t,r){const d=await this.p(r),u=a.replace(/[\\/:\*\?"<>\|]/g,""),l=this.k.extUri.joinPath(d,`${u}.log`),h=`${r.identifier.value}.${u}`,k=this.l.createLogger(l,{id:h,name:a,logLevel:t,extensionId:r.identifier.value});return new i(h,a,k,this.a,r)}p(a){let t=this.d.get(a.identifier.value);if(!t){const r=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(r)}catch(d){if((0,S.$rk)(d)!==S.FileSystemProviderErrorCode.FileExists)throw d}return r})())}return t}q(a,t){let r=!1;const d=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return a},append(u){d(),t.then(l=>l.append(u))},appendLine(u){d(),t.then(l=>l.appendLine(u))},clear(){d(),t.then(u=>u.clear())},replace(u){d(),t.then(l=>l.replace(u))},show(u,l){d(),t.then(h=>h.show(u,l))},hide(){d(),t.then(u=>u.hide())},dispose(){r=!0,t.then(u=>u.dispose())}}}r(a,t,r){const d=new c.$Qc,u=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},l=d.add(new p.$Od);function h(k){t=k,l.fire(k)}return r.then(k=>{d.add(k),k.logLevel!==t&&h(k.logLevel),d.add(k.onDidChangeLogLevel(D=>h(D)))}),{...this.q(a,r),get logLevel(){return t},onDidChangeLogLevel:l.event,trace(k,...D){u(),r.then($=>$.trace(k,...D))},debug(k,...D){u(),r.then($=>$.debug(k,...D))},info(k,...D){u(),r.then($=>$.info(k,...D))},warn(k,...D){u(),r.then($=>$.warn(k,...D))},error(k,...D){u(),r.then($=>$.error(k,...D))},dispose(){d.dispose()}}}};e.$3dc=n,e.$3dc=n=He([Be(0,m.$wM),Be(1,g.$MM),Be(2,E.$Fdc),Be(3,A.$adc),Be(4,R.$bj),Be(5,R.$aj)],n),e.$4dc=(0,F.$Sh)("IExtHostOutputService")}),define(ke[155],Se([1,0,5,10]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=e.$wm=void 0,e.$wm=(0,I.$Sh)("remoteAgentService"),e.$xm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(m){let L=1/0;for(let w=0;w<this.maxSampleCount;w++){const E=await m.getRoundTripTime();if(E===void 0)return;L=Math.min(L,E/2),await(0,F.$Vg)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(L):R=this.initial.reduce((w,E)=>w+E,0)/this.initial.length,this.lastMeasurement={initial:R,current:L,average:this.average.reduce((w,E)=>w+E,0)/this.average.length,high:(()=>typeof R>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ke[357],Se([1,0,225,86,38,40,44,3,4,155,12]),function(me,e,I,F,m,L,R,w,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=void 0,e.$mH=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$nH=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$oH=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$pH={ConfigurationMigration:"base.contributions.configuration.migration"};class P{constructor(){this.migrations=[],this.a=new E.$Od,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(c){this.migrations.push(...c)}}const f=new P;m.$jn.add(e.$pH.ConfigurationMigration,f);let y=class extends w.$Rc{constructor(c,s){super(),this.a=c,this.b=s,this.B(this.b.onDidChangeWorkspaceFolders(async i=>{for(const n of i.added)await this.f(n,f.migrations)})),this.c(f.migrations),this.B(f.onDidRegisterConfigurationMigration(i=>this.c(i)))}async c(c){await this.f(void 0,c);for(const s of this.b.getWorkspace().folders)await this.f(s,c)}async f(c,s){await Promise.all(s.map(i=>this.g(i,{resource:c?.uri})))}async g(c,s){const i=this.a.inspect(c.key,s);if(await this.h(c,s,i,"userValue",2),await this.h(c,s,i,"userLocalValue",3),await this.h(c,s,i,"userRemoteValue",4),await this.h(c,s,i,"workspaceFolderValue",6),await this.h(c,s,i,"workspaceValue",5),typeof s.overrideIdentifier>"u"&&typeof i.overrideIdentifiers<"u")for(const n of i.overrideIdentifiers)await this.g(c,{resource:s.resource,overrideIdentifier:n})}async h(c,s,i,n,o){const a=i[n];if(typeof a>"u")return;const t=u=>this.a.inspect(u,s)[n],r=await c.migrateFn(a,t),d=Array.isArray(r)?r:[[c.key,r]];await Promise.allSettled(d.map(async([u,l])=>this.a.updateValue(u,l.value,s,o)))}};e.$qH=y,e.$qH=y=He([Be(0,R.$mi),Be(1,L.$2h)],y);let S=class extends w.$Rc{constructor(c){super(),(async()=>{if(!A.$i&&(await c.getEnvironment())?.os!==1)return;m.$jn.as(F.$on.Configuration).registerConfiguration({...e.$oH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(3,null)},default:[],markdownDescription:(0,I.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(5,null),scope:2}}})})()}};e.$rH=S,e.$rH=S=He([Be(0,g.$wm)],S)}),define(ke[358],Se([1,0,34,17,16,23,234,357,86,5,38]),function(me,e,I,F,m,L,R,w,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcb=e.$ucb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$tcb=e.$scb=void 0,e.$scb=(0,g.$Sh)("editorResolverService"),e.$tcb="workbench.editorAssociations";const P=A.$jn.as(E.$on.Configuration),f={...w.$nH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};P.registerConfiguration(f);var y;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(y||(e.RegisteredEditorPriority=y={}));var S;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function p(s){switch(s){case y.exclusive:return 5;case y.default:return 4;case y.builtin:return 3;case y.option:default:return 1}}e.$ucb=p;function c(s,i){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof s=="string"&&s.indexOf(m.$fc.sep)>=0?`${i.scheme}:${i.path}`:(0,L.$tg)(i);return I.$yj(typeof s=="string"?s.toLowerCase():s,a.toLowerCase())}e.$vcb=c}),define(ke[359],Se([1,0,33,17,16,12,23,2,5,269,40,146,155]),function(me,e,I,F,m,L,R,w,E,g,A,P,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$7J=e.$6J=void 0,e.$6J=(0,E.$Sh)("pathService");let S=y=class{constructor(c,s,i,n){this.d=c,this.e=s,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??c})()}hasValidBasename(c,s,i){return typeof s=="string"||typeof s>"u"?this.a.then(n=>this.h(c,n,s)):this.h(c,s,i)}h(c,s,i){return c.scheme===F.Schemas.file||c.scheme===F.Schemas.vscodeRemote?(0,I.$Wf)(i??(0,R.$tg)(c),s===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(c,s){if(c.remoteAuthority)return F.Schemas.vscodeRemote;const i=(0,g.$3J)(s.getWorkspace());if(i)return i;const n=s.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=s.getWorkspace().configuration;return o?o.scheme:F.Schemas.file}userHome(c){return c?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(c=>c===1?m.$ec:m.$fc)}async fileURI(c){let s="";if(await this.a===1&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const n=c.indexOf("/",2);n===-1?(s=c.substring(2),c="/"):(s=c.substring(2,n),c=c.substring(n)||"/")}return w.URI.from({scheme:F.Schemas.file,authority:s,path:c,query:"",fragment:""})}};e.$7J=S,e.$7J=S=y=He([Be(1,f.$wm),Be(2,P.$OJ),Be(3,A.$2h)],S)}),define(ke[360],Se([1,0,236,19,59,4,52,3,2,44,241,15,65,271,88,40,146,25,21,18,24,45]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZJ=e.$YJ=e.$XJ=e.OnPortForward=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.TunnelSource=e.TunnelCloseReason=e.$RJ=e.$QJ=e.$PJ=void 0;const t=10*1e3,r="remote.tunnels.toRestore";e.$PJ="onTunnel",e.$QJ=new a.$0i("forwardedPortsViewEnabled",!1,I.localize(0,null));function d(N){const z=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}e.$RJ=d;var u;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(u||(e.TunnelCloseReason=u={}));var l;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(l||(e.TunnelSource=l={})),e.$SJ={source:l.User,description:I.localize(1,null)},e.$TJ={source:l.Auto,description:I.localize(2,null)};function h(N,z,M){const T=N.get(D(z,M));if(T)return T;if((0,S.$fv)(z))for(const j of S.$ev){const O=D(j,M);if(N.has(O))return N.get(O)}else if((0,S.$hv)(z))for(const j of S.$gv){const O=D(j,M);if(N.has(O))return N.get(O)}}e.$UJ=h;function k(N,z,M){const T=h(N,z,M);if(T)return T;const j=(0,S.$hv)(z)?"localhost":(0,S.$fv)(z)?"0.0.0.0":void 0;if(j)return h(N,j,M)}e.$VJ=k;function D(N,z){return N+":"+z}e.$WJ=D;var $;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})($||(e.OnPortForward=$={}));function b(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}e.$XJ=b;class v extends w.$Rc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new L.$Od,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(M=>{(M.affectsConfiguration(v.c)||M.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,M,T){let j=this.w(z,M,T,this.j,0);const O={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const q=this.j[j];q.key===z?(O.onAutoForward=q.onAutoForward??O.onAutoForward,O.elevateIfNeeded=q.elevateIfNeeded!==void 0?q.elevateIfNeeded:O.elevateIfNeeded,O.label=q.label??O.label,O.requireLocalPort=q.requireLocalPort,O.protocol=q.protocol):(O.onAutoForward=O.onAutoForward??q.onAutoForward,O.elevateIfNeeded=O.elevateIfNeeded!==void 0?O.elevateIfNeeded:q.elevateIfNeeded,O.label=O.label??q.label,O.requireLocalPort=O.requireLocalPort!==void 0?O.requireLocalPort:void 0,O.protocol=O.protocol??q.protocol),j=this.w(z,M,T,this.j,j+1)}return O.onAutoForward!==void 0||O.elevateIfNeeded!==void 0||O.label!==void 0||O.requireLocalPort!==void 0||O.protocol!==void 0?O:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,n.$zf)(z.host)&&(0,n.$Df)(z.port)}w(z,M,T,j,O){if(O>=j.length)return-1;const q=!(0,S.$fv)(M)&&!(0,S.$hv)(M),de=j.slice(O).findIndex(ee=>(0,n.$Df)(ee.key)?q?!1:ee.key===z:this.t(ee.key)?q?!1:z>=ee.key.start&&z<=ee.key.end:this.u(ee.key)?z===ee.key.port&&M===ee.key.host:T?ee.key.test(T):!1);return de>=0?de+O:-1}y(){const z=this.r.getValue(v.c);if(!z||!(0,n.$Bf)(z))return[];const M=[];for(const j in z){if(j===void 0)continue;const O=z[j];let q;if(Number(j))q=Number(j);else if((0,n.$zf)(j))if(v.g.test(j)){const V=j.match(v.g);q={start:Number(V[1]),end:Number(V[2])}}else if(v.h.test(j)){const V=j.match(v.h);q={host:V[1],port:Number(V[2])}}else{let V;try{V=RegExp(j)}catch{}V&&(q=V)}q&&M.push({key:q,elevateIfNeeded:O.elevateIfNeeded,onAutoForward:O.onAutoForward,label:O.label,requireLocalPort:O.requireLocalPort,protocol:O.protocol})}const T=this.r.getValue(v.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(M)}z(z){function M(T,j){return(0,n.$Df)(T.key)?T.key:j.t(T.key)?T.key.start:j.u(T.key)?T.key.port:Number.MAX_VALUE}return z.sort((T,j)=>M(T,this)-M(j,this))}C(){return this.m}static providedActionToAction(z){switch(z){case S.ProvidedOnAutoForward.Notify:return $.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return $.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return $.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return $.OpenPreview;case S.ProvidedOnAutoForward.Silent:return $.Silent;case S.ProvidedOnAutoForward.Ignore:return $.Ignore;default:return}}async addAttributes(z,M,T){const O=this.r.inspect(v.c).userRemoteValue;let q;!O||!(0,n.$Bf)(O)?q={}:q=(0,o.$0m)(O),q[`${z}`]||(q[`${z}`]={});for(const V in M)q[`${z}`][V]=M[V];return this.r.updateValue(v.c,q,T)}}e.$YJ=v;let C=class extends w.$Rc{constructor(z,M,T,j,O,q,V,de,ee,X){super(),this.H=z,this.I=M,this.J=T,this.L=j,this.M=O,this.N=q,this.O=V,this.P=de,this.Q=ee,this.R=X,this.c=new Map,this.g=new L.$Od,this.onForwardPort=this.g.event,this.h=new L.$Od,this.onClosePort=this.h.event,this.j=new L.$Od,this.onPortName=this.j.event,this.n=new L.$Od,this.onCandidatesChanged=this.n.event,this.t=new L.$Od,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$Od,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new v(T),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async Q=>{const ae=await this.getAttributes(Q.map(x=>({port:x.tunnelRemotePort,host:x.tunnelRemoteHost})));for(const x of Q)if(x.localAddress){const se=D(x.tunnelRemoteHost,x.tunnelRemotePort),pe=k(this.m??new Map,x.tunnelRemoteHost,x.tunnelRemotePort);this.forwarded.set(se,{remotePort:x.tunnelRemotePort,remoteHost:x.tunnelRemoteHost,localAddress:x.localAddress,protocol:ae?.get(x.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(x.localAddress,ae?.get(x.tunnelRemotePort)),localPort:x.tunnelLocalPort,runningProcess:pe?.detail,hasRunningProcess:!!pe,pid:pe?.pid,privacy:x.privacy,source:e.$SJ}),this.f.set(se,x)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async Q=>{const ae=D(Q.tunnelRemoteHost,Q.tunnelRemotePort);if(!k(this.forwarded,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&!k(this.detected,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&!k(this.c,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&Q.localAddress){const x=k(this.m??new Map,Q.tunnelRemoteHost,Q.tunnelRemotePort),se=(await this.getAttributes([{port:Q.tunnelRemotePort,host:Q.tunnelRemoteHost}]))?.get(Q.tunnelRemotePort);this.forwarded.set(ae,{remoteHost:Q.tunnelRemoteHost,remotePort:Q.tunnelRemotePort,localAddress:Q.localAddress,protocol:se?.protocol??S.TunnelProtocol.Http,localUri:await this.X(Q.localAddress,se),localPort:Q.tunnelLocalPort,closeable:!0,runningProcess:x?.detail,hasRunningProcess:!!x,pid:x?.pid,privacy:Q.privacy,source:e.$SJ})}await this.$(),this.f.set(ae,Q),this.g.fire(this.forwarded.get(ae))})),this.B(this.H.onTunnelClosed(Q=>this.W(Q,u.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$PJ))?(this.R.createKey(e.$QJ.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,M){const T=D(z.host,z.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.$(),this.h.fire(z))}X(z,M){if(z.startsWith("http"))return E.URI.parse(z);const T=M?.protocol??"http";return E.URI.parse(`${T}://${z}`)}async Y(){const z=this.N.getWorkspace(),M=z.configuration?(0,R.$Gi)(z.configuration.path):z.folders.length>0?(0,R.$Gi)(z.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${r}.${this.L.remoteAuthority}.${M}`}async Z(){const z=this.I.get(r,1);if(z)return this.I.remove(r,1),await this.$(),z;const M=await this.Y();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const M=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(T=>T.remotePort).join(", ")}`);for(const T of M){const j=k(this.detected,T.remoteHost,T.remotePort);T.source.source!==l.Extension&&!j||T.source.source===l.Extension&&j?await this.cb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,privacy:T.privacy,elevateIfNeeded:!0,source:T.source}):T.source.source===l.Extension&&!j&&this.D.set(D(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Y();this.w=this.B(new w.$Qc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=JSON.stringify(Array.from(this.forwarded.values()));if(z!==this.y){this.y=z;const M=await this.Y();M&&this.I.store(M,this.y,0,0)}}}async bb(z,M,T){if(!z.tunnelLocalPort||!T?.requireLocalPort||z.tunnelLocalPort===M)return;const j=new Date;if(this.ab.getTime()+t>j.getTime())return;this.ab=j;const O=I.localize(3,null,M,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(O)}async forward(z,M){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.cb(z,M)}async cb(z,M){await this.Q.activateByEvent(e.$PJ);const T=k(this.forwarded,z.remote.host,z.remote.port);M=M??(M!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const j=z.local!==void 0?z.local:z.remote.port;let O;if(T)return this.eb(T,z,M);{const q=this.L.remoteAuthority,V=q?{getAddress:async()=>(await this.M.resolveAuthority(q)).authority}:void 0,de=D(z.remote.host,z.remote.port);this.c.set(de,!0),z=this.db(de,z);const ee=await this.H.openTunnel(V,z.remote.host,z.remote.port,void 0,j,z.elevateIfNeeded?z.elevateIfNeeded:M?.elevateIfNeeded,z.privacy,M?.protocol);if(typeof ee=="string")O=ee;else if(ee&&ee.localAddress){const X=k(this.m??new Map,z.remote.host,z.remote.port),Q=ee.protocol?ee.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:M?.protocol??S.TunnelProtocol.Http,ae={remoteHost:ee.tunnelRemoteHost,remotePort:ee.tunnelRemotePort,localPort:ee.tunnelLocalPort,name:M?.label??z.name,closeable:!0,localAddress:ee.localAddress,protocol:Q,localUri:await this.X(ee.localAddress,M),runningProcess:X?.detail,hasRunningProcess:!!X,pid:X?.pid,source:z.source??e.$SJ,privacy:ee.privacy};return this.forwarded.set(de,ae),this.f.set(de,ee),this.c.delete(de),await this.$(),await this.bb(ee,j,M),this.g.fire(ae),ee}this.c.delete(de)}return O}db(z,M){const T=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(T){const j=T.get(z);T.delete(z),j&&(M.name=j.name??M.name,M.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??M.local,M.privacy=j.privacy??M.privacy)}return M}async eb(z,M,T){const j=T?.label??M.name;let O;(function(V){V[V.None=0]="None",V[V.Fire=1]="Fire",V[V.Reopen=2]="Reopen"})(O||(O={}));let q=O.None;switch(j!==z.name&&(z.name=j,q=O.Fire),(T?.protocol||z.protocol!==S.TunnelProtocol.Http)&&T?.protocol!==z.protocol&&(M.source=z.source,q=O.Reopen),M.privacy&&z.privacy!==M.privacy&&(q=O.Reopen),q){case O.Fire:{this.g.fire();break}case O.Reopen:await this.close(z.remoteHost,z.remotePort,u.User),await this.cb(M,T)}return k(this.f,M.remote.host,M.remote.port)}async name(z,M,T){const j=k(this.forwarded,z,M),O=D(z,M);if(j){j.name=T,await this.$(),this.j.fire({host:z,port:M});return}else this.detected.has(O)&&(this.detected.get(O).name=T,this.j.fire({host:z,port:M}))}async close(z,M,T){const j=D(z,M),O=this.forwarded.get(j);return T===u.AutoForwardEnd&&O&&O.source.source===l.Auto&&this.F.set(j,{local:O.localPort,name:O.name,privacy:O.privacy}),await this.H.closeTunnel(z,M),this.W({host:z,port:M},T)}address(z,M){const T=D(z,M);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const M of z){const T=k(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),j=typeof M.localAddress=="string"?M.localAddress:D(M.localAddress.host,M.localAddress.port);this.detected.set(D(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:j,protocol:S.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:l.Extension,description:I.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,j,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let M=z;this.r&&(M=await this.r(z));const T=this.fb(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(j=>j.port).join(", ")}`),this.n.fire(T)}fb(z){const M=this.m??new Map,T=new Map;return this.m=T,z.forEach(j=>{const O=D(j.host,j.port);T.set(O,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),M.has(O)&&M.delete(O);const q=k(this.forwarded,j.host,j.port);q&&(q.runningProcess=j.detail,q.hasRunningProcess=!0,q.pid=j.pid)}),M.forEach((j,O)=>{const q=d(O);if(!q)return;const V=k(this.forwarded,q.host,q.port);V&&(V.runningProcess=void 0,V.hasRunningProcess=!1,V.pid=void 0);const de=k(this.detected,q.host,q.port);de&&(de.runningProcess=void 0,de.hasRunningProcess=!1,de.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const z=Array.from(this.forwarded.values()),M=await this.getAttributes(z.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(M)for(const T of z){const j=M.get(T.remotePort);(j?.protocol||T.protocol!==S.TunnelProtocol.Http)&&j?.protocol!==T.protocol&&await this.cb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},j),j&&j.label&&j.label!==T.name&&await this.name(T.remoteHost,T.remotePort,j.label)}}async getAttributes(z,M=!0){const T=new Map,j=new Map;z.forEach(ee=>{const X=k(this.m??new Map,S.$ev[0],ee.port)??ee;if(X){T.set(ee.port,X);const Q=b(X)?X.pid:void 0;j.has(Q)||j.set(Q,[]),j.get(Q)?.push(ee.port)}});const O=new Map;if(z.forEach(ee=>{const X=this.configPortsAttributes.getAttributes(ee.port,ee.host,T.get(ee.port)?.detail);X&&O.set(ee.port,X)}),this.G.length===0||!M)return O.size>0?O:void 0;const q=await Promise.all((0,F.$Qb)(this.G.map(ee=>Array.from(j.entries()).map(X=>{const Q=X[1],ae=T.get(Q[0]);return ee.providePortAttributes(Q,ae?.pid,ae?.detail,new i.$Yd().token)})))),V=new Map;if(q.forEach(ee=>ee.forEach(X=>{X&&V.set(X.port,X)})),!O&&!V)return;const de=new Map;return z.forEach(ee=>{const X=O.get(ee.port),Q=V.get(ee.port);de.set(ee.port,{elevateIfNeeded:X?.elevateIfNeeded,label:X?.label,onAutoForward:X?.onAutoForward??v.providedActionToAction(Q?.autoForwardAction),requireLocalPort:X?.requireLocalPort,protocol:X?.protocol})}),de}addAttributesProvider(z){this.G.push(z)}};e.$ZJ=C,He([(0,m.$lh)(1e3)],C.prototype,"$",null),e.$ZJ=C=He([Be(0,S.$av),Be(1,y.$9o),Be(2,g.$mi),Be(3,c.$OJ),Be(4,f.$Sk),Be(5,p.$2h),Be(6,P.$aj),Be(7,A.$Ev),Be(8,s.$qF),Be(9,a.$$i)],C)}),define(ke[94],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$MI=e.$LI=void 0;class I{constructor(R,w){this.line=R,this.character=w}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,w){return new I(0,0)}with(R){return new I(0,0)}}e.$LI=I;class F{constructor(R,w,E,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(R,w),this.end=new I(E,g)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new F(0,0,0,0)}with(R){return new F(0,0,0,0)}}e.$MI=F;var m;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(m||(e.TextSearchCompleteMessageType=m={}))}),define(ke[36],Se([1,0,19,34,24,33,13,5,16,11,94,10]),function(me,e,I,F,m,L,R,w,E,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.SearchErrorCode=e.$2I=e.$1I=e.SearchSortOrder=e.ViewMode=e.$ZI=e.$YI=e.$XI=e.$WI=e.SearchCompletionExitCode=e.$VI=e.$UI=e.$TI=e.QueryType=e.SearchProviderType=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$NI="workbench.view.search",e.$OI="workbench.panel.search",e.$PI="workbench.view.search",e.$QI="search-result",e.$RI="search.exclude";const f="\u27EA ",y=" characters skipped \u27EB",S=(f.length+y.length+5)*2;e.$SI=(0,w.$Sh)("searchService");var p;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text"})(p||(e.SearchProviderType=p={}));var c;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text"})(c||(e.QueryType=c={}));function s(Q){return!!Q.preview}e.$TI=s;function i(Q){return!!Q.resource}e.$UI=i;function n(Q){return!!Q.message}e.$VI=n;var o;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class a{constructor(ae){this.resource=ae,this.results=[]}}e.$WI=a;class t{constructor(ae,x,se,pe){this.ranges=x,this.webviewIndex=pe;const G=Array.isArray(x)?x:[x];if(se&&se.matchLines===1&&r(G)){ae=(0,R.$sf)(ae,se.matchLines);let U="",ce=0,be=0;const H=Math.floor(se.charsPerLine/5),Z=[];for(const Y of G){const $e=Math.max(Y.startColumn-H,0),ne=Y.startColumn+se.charsPerLine;if($e>be+H+S){const fe=f+($e-be)+y;U+=fe+ae.slice($e,ne),ce+=$e-(be+fe.length)}else U+=ae.slice(be,ne);Z.push(new u(0,Y.startColumn-ce,Y.endColumn-ce)),be=ne}this.preview={text:U,matches:Array.isArray(this.ranges)?Z:Z[0]}}else{const U=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:ae,matches:(0,I.$1b)(x,ce=>new d(ce.startLineNumber-U,ce.startColumn,ce.endLineNumber-U,ce.endColumn))}}}}e.$XI=t;function r(Q){const ae=Q[0].startLineNumber;for(const x of Q)if(x.startLineNumber!==ae||x.endLineNumber!==ae)return!1;return!0}class d{constructor(ae,x,se,pe){this.startLineNumber=ae,this.startColumn=x,this.endLineNumber=se,this.endColumn=pe}}e.$YI=d;class u extends d{constructor(ae,x,se){super(ae,x,ae,se)}}e.$ZI=u;var l;(function(Q){Q.List="list",Q.Tree="tree"})(l||(e.ViewMode=l={}));var h;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function k(Q,ae=!0){const x=Q&&Q.files&&Q.files.exclude,se=ae&&Q&&Q.search&&Q.search.exclude;if(!x&&!se)return;if(!x||!se)return x||se;let pe=Object.create(null);return pe=m.$an(pe,m.$0m(x)),pe=m.$an(pe,m.$0m(se),!0),pe}e.$1I=k;function D(Q,ae){return Q.excludePattern&&F.$yj(Q.excludePattern,ae)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&F.$yj(Q.includePattern,ae)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(x=>{const se=x.folder.fsPath;if(L.$Yf(ae,se)){const pe=E.$kc(se,ae);return!x.includePattern||!!F.$yj(x.includePattern,pe)}else return!1}):!1:!0}e.$2I=D;var $;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})($||(e.SearchErrorCode=$={}));class b extends Error{constructor(ae,x){super(ae),this.code=x}}e.$3I=b;function v(Q){const ae=Q.message;if((0,g.$3)(Q))return new b(ae,$.canceled);try{const x=JSON.parse(ae);return new b(x.message,x.code)}catch{return new b(ae,$.other)}}e.$4I=v;function C(Q){const ae={message:Q.message,code:Q.code};return new Error(JSON.stringify(ae))}e.$5I=C;function N(Q){return Q.type==="error"?!0:Q.type==="success"}e.$6I=N;function z(Q){return Q.type==="success"}e.$7I=z;function M(Q){return!!Q.path}e.$8I=M;function T(Q,ae){const x=Q.searchPath?Q.searchPath:Q.relativePath;return(0,R.$pf)(x,ae)}e.$9I=T;class j{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$0I=j;function O(Q,ae){const x={...Q||{},...ae||{}};return Object.keys(x).filter(se=>{const pe=x[se];return typeof pe=="boolean"&&pe})}e.$$I=O;class q{constructor(ae,x){this.c=null,this.a={...ae.excludePattern||{},...x.excludePattern||{}},this.b=F.$zj(this.a);let se=ae.includePattern;x.includePattern&&(se?se={...se,...x.includePattern}:se=x.includePattern),se&&(this.c=F.$zj(se))}matchesExcludesSync(ae,x,se){return!!(this.b&&this.b(ae,x,se))}includedInQuerySync(ae,x,se){return!(this.b&&this.b(ae,x,se)||this.c&&!this.c(ae,x,se))}includedInQuery(ae,x,se){const pe=this.b(ae,x,se),G=()=>this.c?!!this.c(ae,x,se):!0;return(0,P.$Hg)(pe)?pe.then(U=>U?!1:G()):G()}hasSiblingExcludeClauses(){return V(this.a)}}e.$_I=q;function V(Q){for(const ae in Q)if(typeof Q[ae]!="boolean")return!0;return!1}function de(Q){if(!Q)return;let ae;return x=>(ae||(ae=(Q()||Promise.resolve([])).then(se=>se?X(se):{})),ae.then(se=>!!se[x]))}e.$aJ=de;function ee(Q){if(!Q)return;let ae;return x=>{if(!ae){const se=Q();ae=se?X(se):{}}return!!ae[x]}}e.$bJ=ee;function X(Q){const ae={};for(const x of Q)ae[x]=!0;return ae}}),define(ke[41],Se([1,0,19,10,21,4,3,78,17,123,23,13,2,223,5,15,254,40,57,27,20,14,7,67,36,6,54]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i,n,o,a,t,r,d,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=e.$mdc=void 0;function h(z,M,T){return new A.$lg(j=>b(j,T)).isEqual(z,M)}function k(z,M,T){return h(z.uri,M.uri,T)?0:(0,P.$Ve)(z.uri.toString(),M.uri.toString())}function D(z,M,T){return z.index!==M.index?z.index<M.index?-1:1:h(z.uri,M.uri,T)?(0,P.$Ve)(z.name,M.name):(0,P.$Ve)(z.uri.toString(),M.uri.toString())}function $(z,M,T,j){const O=z.slice(0).sort((V,de)=>T(V,de,j)),q=M.slice(0).sort((V,de)=>T(V,de,j));return(0,I.$Db)(O,q,(V,de)=>T(V,de,j))}function b(z,M){const T=M.getCapabilities(z.scheme);return!(T&&T&1024)}class v extends s.$_h{static toExtHostWorkspace(M,T,j,O){if(!M)return{workspace:null,added:[],removed:[]};const{id:q,name:V,folders:de,configuration:ee,transient:X,isUntitled:Q}=M,ae=[],x=T;T?de.forEach((U,ce)=>{const be=f.URI.revive(U.uri),H=v.o(j||T,be,O);H?(H.name=U.name,H.index=U.index,ae.push(H)):ae.push({uri:be,name:U.name,index:ce})}):ae.push(...de.map(({uri:U,name:ce,index:be})=>({uri:f.URI.revive(U),name:ce,index:be}))),ae.sort((U,ce)=>U.index<ce.index?-1:1);const se=new v(q,V,ae,!!X,ee?f.URI.revive(ee):null,!!Q,U=>b(U,O)),{added:pe,removed:G}=$(x?x.workspaceFolders:[],se.workspaceFolders,k,O);return{workspace:se,added:pe,removed:G}}static o(M,T,j){for(let O=0;O<M.folders.length;O++){const q=M.workspaceFolders[O];if(h(q.uri,T,j))return q}}constructor(M,T,j,O,q,V,de){super(M,j.map(ee=>new s.$ai(ee)),O,q,de),this.t=T,this.u=V,this.q=[],this.s=w.$Yh.forUris(de),j.forEach(ee=>{this.q.push(ee),this.s.set(ee.uri,ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,T){return T&&this.s.get(M)&&(M=(0,A.$vg)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let C=class{constructor(M,T,j,O,q){this.c=new L.$Od,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Od,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$Qd,this.B=new Map,this.h=O,this.s=j,this.t=q,this.j=new g.$Tl,this.k=new F.$Tg,this.o=M.getProxy(u.$uK.MainThreadWorkspace),this.q=M.getProxy(u.$uK.MainThreadMessageService);const V=T.workspace;this.l=V?new v(V.id,V.name,[],!!V.transient,V.configuration?f.URI.revive(V.configuration):null,!!V.isUntitled,de=>b(de,j)):void 0}$initializeWorkspace(M,T){this.v=T,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?f.URI.from({scheme:E.Schemas.untitled,path:(0,A.$tg)((0,A.$vg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,T,j,...O){const q=[];if(Array.isArray(O)&&O.forEach(Q=>{f.URI.isUri(Q.uri)&&!q.some(ae=>h(ae.uri,Q.uri,this.s))&&q.push({uri:Q.uri,name:Q.name||(0,A.$sg)(Q.uri)})}),this.n||[T,j].some(Q=>typeof Q!="number"||Q<0)||j===0&&q.length===0)return!1;const V=this.x?this.x.workspaceFolders:[];if(T+j>V.length)return!1;const de=V.slice(0);de.splice(T,j,...q.map(Q=>({uri:Q.uri,name:Q.name||(0,A.$sg)(Q.uri),index:void 0})));for(let Q=0;Q<de.length;Q++){const ae=de[Q];if(de.some((x,se)=>se!==Q&&h(ae.uri,x.uri,this.s)))return!1}de.forEach((Q,ae)=>Q.index=ae);const{added:ee,removed:X}=$(V,de,D,this.s);if(ee.length===0&&X.length===0)return!1;if(this.o){const Q=M.displayName||M.name;this.o.$updateWorkspaceFolders(Q,T,j,q).then(void 0,ae=>{this.n=void 0;const x={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(c.Severity.Error,(0,y.localize)(0,null,Q,ae.toString()),x,[])})}return this.y(de),!0}getWorkspaceFolder(M,T){if(this.x)return this.x.getWorkspaceFolder(M,T)}async getWorkspaceFolder2(M,T){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,T)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,T){let j,O="";if(typeof M=="string"?(j=f.URI.file(M),O=M):typeof M<"u"&&(j=M,O=M.fsPath),!j)return O;const q=this.getWorkspaceFolder(j,!0);if(!q)return O;typeof T>"u"&&this.x&&(T=this.x.folders.length>1);let V=(0,A.$yg)(q.uri,j);return T&&q.name&&(V=`${q.name}/${V}`),V}y(M){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:T,added:j,removed:O}=v.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=T||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:O}))}findFiles(M,T,j,O,q=m.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let V;if(T===null?V=!1:T&&(typeof T=="string"?V=T:V=T.pattern),q&&q.isCancellationRequested)return Promise.resolve([]);const{includePattern:de,folder:ee}=N(a.GlobPattern.from(M));return this.o.$startFileSearch(de??null,ee??null,V??null,j??null,q).then(X=>Array.isArray(X)?X.map(Q=>f.URI.revive(Q)):[])}async findTextInFiles(M,T,j,O,q=m.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const V=this.j.getNext(),de=typeof T.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:T.previewOptions,{includePattern:ee,folder:X}=N(a.GlobPattern.from(T.include)),Q=typeof T.exclude=="string"?T.exclude:T.exclude?T.exclude.pattern:void 0,ae={ignoreSymlinks:typeof T.followSymlinks=="boolean"?!T.followSymlinks:void 0,disregardIgnoreFiles:typeof T.useIgnoreFiles=="boolean"?!T.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof T.useGlobalIgnoreFiles=="boolean"?!T.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof T.useParentIgnoreFiles=="boolean"?!T.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof T.useDefaultExcludes=="boolean"?!T.useDefaultExcludes:!0,fileEncoding:T.encoding,maxResults:T.maxResults,previewOptions:de,afterContext:T.afterContext,beforeContext:T.beforeContext,includePattern:ee,excludePattern:Q},x=!1;if(this.u[V]=se=>{if(x)return;const pe=f.URI.revive(se.resource);se.results.forEach(G=>{const U=(0,l.$ph)(G);(0,d.$TI)(U)?j({uri:pe,preview:{text:U.preview.text,matches:(0,I.$1b)(U.preview.matches,ce=>new t.$yK(ce.startLineNumber,ce.startColumn,ce.endLineNumber,ce.endColumn))},ranges:(0,I.$1b)(U.ranges,ce=>new t.$yK(ce.startLineNumber,ce.startColumn,ce.endLineNumber,ce.endColumn))}):j({uri:pe,text:U.text,lineNumber:U.lineNumber})})},q.isCancellationRequested)return{};try{const se=await this.o.$startTextSearch(M,X??null,ae,V,q);return delete this.u[V],se||{}}catch(se){throw delete this.u[V],se}}$handleTextSearchResult(M,T){this.u[T]?.(M)}async save(M){const T=await this.o.$save(M,{saveAs:!1});return f.URI.revive(T)}async saveAs(M){const T=await this.o.$save(M,{saveAs:!0});return f.URI.revive(T)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,T){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,T);const j=this.t.transformOutgoingScheme(M),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,j),(0,R.$Pc)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(M,T){this.h.info("Getting edit session identifier for workspaceFolder",M);const j=await this.resolveWorkspaceFolder(f.URI.revive(M));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const O=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!O),!O)return;const q=await O.provideEditSessionIdentity(j,T);if(this.h.info("Provider returned edit session identifier: ",q),!!q)return q}async $provideEditSessionIdentityMatch(M,T,j,O){this.h.info("Getting edit session identifier for workspaceFolder",M);const q=await this.resolveWorkspaceFolder(f.URI.revive(M));if(!q){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",q);const V=this.w.get(q.uri.scheme);if(this.h.info(`Provider for scheme ${q.uri.scheme} is defined: `,!!V),!V)return;const de=await V.provideEditSessionIdentityMatch?.(T,j,O);if(this.h.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(M){return(T,j,O)=>{const q=function(de){T.call(j,de)};return q.extension=M,this.A.event(q,void 0,O)}}async $onWillCreateEditSessionIdentity(M,T,j){const O=await this.resolveWorkspaceFolder(f.URI.revive(M));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},T,async(q,V)=>{const de=Date.now();await Promise.resolve(q),Date.now()-de>j&&this.h.warn("SLOW edit session create-participant",V.extension.identifier)}),T.isCancellationRequested}registerCanonicalUriProvider(M,T){if(this.B.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.B.set(M,T);const j=this.t.transformOutgoingScheme(M),O=this.z++;return this.o.$registerCanonicalUriProvider(O,j),(0,R.$Pc)(()=>{this.B.delete(M),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(M,T,j){const O=this.B.get(M.scheme);if(!O)return;const q=await O.provideCanonicalUri?.(f.URI.revive(M),T,j);if(q)return q}async $provideCanonicalUri(M,T,j){return this.provideCanonicalUri(f.URI.revive(M),{targetScheme:T},j)}};e.$mdc=C,e.$mdc=C=He([Be(0,o.$wM),Be(1,n.$MM),Be(2,i.$adc),Be(3,p.$aj),Be(4,r.$kdc)],C),e.$ndc=(0,S.$Sh)("IExtHostWorkspace");function N(z){let M,T;return z&&(typeof z=="string"?M=z:(M=z.pattern,T=f.URI.revive(z.baseUri))),{includePattern:M,folder:T}}}),define(ke[42],Se([1,0,24,4,41,6,7,256,86,18,10,5,20,15,2]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=e.$pdc=e.$odc=void 0;function p(r,d){if(d){const u=d.split(".");let l=r;for(let h=0;l&&h<u.length;h++)l=l[u[h]];return l}}function c(r){return r instanceof S.URI}function s(r){return r&&r.uri instanceof S.URI&&r.languageId&&typeof r.languageId=="string"}function i(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&r.uri instanceof S.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function o(r){if(c(r))return{resource:r};if(s(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(i(r))return{overrideIdentifier:r.languageId};if(n(r))return{resource:r.uri};if(r===null)return{resource:null}}let a=class{constructor(d,u,l){this.a=d.getProxy(L.$uK.MainThreadConfiguration),this.c=u,this.b=l,this.d=new A.$Tg,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,u){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(d,u))}};e.$odc=a,e.$odc=a=He([Be(0,f.$wM),Be(1,m.$ndc),Be(2,y.$aj)],a);class t{constructor(d,u,l,h){this.a=new F.$Od,this.b=d,this.f=h,this.c=u,this.e=w.$Hn.parse(l),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,u){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=w.$Hn.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(u,l))}getConfiguration(d,u,l){const h=o(u)||{},k=this.g(d?p(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,l?.identifier);function D(b){if(b==null)return null;if(typeof b=="boolean")return b?2:5;switch(b){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const $={has(b){return typeof p(k,b)<"u"},get:(b,v)=>{this.h(d?`${d}.${b}`:b,h,l?.identifier);let C=p(k,b);if(typeof C>"u")C=v;else{let N;const z=(M,T)=>{if((0,g.$Bf)(M)){let j;const O=()=>{N=N||(0,I.$0m)(k),j=j||p(N,T)};return new Proxy(M,{get:(q,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return O(),()=>j;if(N)return j=j||p(N,T),j[V];const de=q[V];return typeof V=="string"?z(de,`${T}.${V}`):de},set:(q,V,de)=>(O(),j&&(j[V]=de),!0),deleteProperty:(q,V)=>(O(),j&&delete j[V],!0),defineProperty:(q,V,de)=>(O(),j&&Object.defineProperty(j,V,de),!0)})}return Array.isArray(M)?(0,I.$0m)(M):M};C=z(C,b)}return C},update:(b,v,C,N)=>{b=d?`${d}.${b}`:b;const z=D(C);return v!==void 0?this.b.$updateConfigurationOption(z,b,v,h,N):this.b.$removeConfigurationOption(z,b,h,N)},inspect:b=>{b=d?`${d}.${b}`:b;const v=this.e.inspect(b,h,this.c.workspace);if(v)return{key:b,defaultValue:(0,I.$0m)(v.policy?.value??v.default?.value),globalValue:(0,I.$0m)(v.user?.value??v.application?.value),workspaceValue:(0,I.$0m)(v.workspace?.value),workspaceFolderValue:(0,I.$0m)(v.workspaceFolder?.value),defaultLanguageValue:(0,I.$0m)(v.default?.override),globalLanguageValue:(0,I.$0m)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,I.$0m)(v.workspace?.override),workspaceFolderLanguageValue:(0,I.$0m)(v.workspaceFolder?.override),languageIds:(0,I.$0m)(v.overrideIdentifiers)}}};return typeof k=="object"&&(0,I.$an)($,k,!1),Object.freeze($)}g(d){const u=l=>(0,g.$Bf)(l)?new Proxy(l,{get:(h,k)=>u(h[k]),set:(h,k,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(h,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(h,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return u(d)}h(d,u,l){const h=E.$yn.test(d)?4:this.d.get(d),k=l?`[${l.value}] `:"";if(h===4){typeof u?.resource>"u"&&this.f.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){u?.resource&&this.f.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,u){const l=new w.$Jn(d,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,k)=>l.affectsConfiguration(h,o(k))})}k(d){return d.reduce((u,l)=>(u.set(l[0],l[1]),u),new Map)}}e.$pdc=t,e.$qdc=(0,P.$Sh)("IExtHostConfiguration")}),define(ke[95],Se([1,0,2,10,4,6,7,41,70,42,21,46,20,27,5,17,12,15,91,304,11]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=e.$nec=e.$mec=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(z){function M(j){if(j!=null)return j}z.from=M;function T(j){if(j!=null)return j}z.to=T})(a||(a={}));var t;(function(z){function M(j){if(j!=null)return j}z.from=M;function T(j){if(j!=null)return j}z.to=T})(t||(t={}));var r;(function(z){function M(j){if(j!=null)return j}z.from=M;function T(j){if(j!=null)return j}z.to=T})(r||(r={}));var d;(function(z){function M(O){if(O){const q=O;return q&&!!q.process}else return!1}z.is=M;function T(O){if(O==null)return;const q={process:O.process,args:O.args};return O.options&&(q.options=r.from(O.options)),q}z.from=T;function j(O){if(O!=null)return new R.$eL(O.process,O.args,O.options)}z.to=j})(d||(d={}));var u;(function(z){function M(j){if(j!=null)return j}z.from=M;function T(j){if(j!=null)return j}z.to=T})(u||(u={}));var l;(function(z){function M(O){if(O){const q=O;return q&&(!!q.commandLine||!!q.command)}else return!1}z.is=M;function T(O){if(O==null)return;const q={};return O.commandLine!==void 0?q.commandLine=O.commandLine:(q.command=O.command,q.args=O.args),O.options&&(q.options=u.from(O.options)),q}z.from=T;function j(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new R.$fL(O.commandLine,O.options):new R.$fL(O.command,O.args?O.args:[],O.options)}z.to=j})(l||(l={}));var h;(function(z){function M(O){if(O){const q=O;return q&&q.customExecution==="customExecution"}else return!1}z.is=M;function T(O){return{customExecution:"customExecution"}}z.from=T;function j(O,q){return q.get(O)}z.to=j})(h||(e.CustomExecutionDTO=h={}));var k;(function(z){function M(T,j){let O;return T.scope!==void 0&&typeof T.scope!="number"?O=T.scope.uri:T.scope!==void 0&&typeof T.scope=="number"&&(T.scope===R.TaskScope.Workspace&&j&&j.workspaceFile?O=j.workspaceFile:O=n.$6F),{id:T._id,workspaceFolder:O}}z.from=M})(k||(e.TaskHandleDTO=k={}));var D;(function(z){function M(T){if(T!=null)return{_id:T.id,isDefault:T.isDefault}}z.from=M})(D||(D={}));var $;(function(z){function M(O,q){if(O==null)return[];const V=[];for(const de of O){const ee=T(de,q);ee&&V.push(ee)}return V}z.fromMany=M;function T(O,q){if(O==null)return;let V;O.execution instanceof R.$eL?V=d.from(O.execution):O.execution instanceof R.$fL?V=l.from(O.execution):O.execution&&O.execution instanceof R.$gL&&(V=h.from(O.execution));const de=a.from(O.definition);let ee;return O.scope?typeof O.scope=="number"?ee=O.scope:ee=O.scope.uri:ee=R.TaskScope.Workspace,!de||!ee?void 0:{_id:O._id,definition:de,name:O.name,source:{extensionId:q.identifier.value,label:O.source,scope:ee},execution:V,isBackground:O.isBackground,group:D.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}z.from=T;async function j(O,q,V){if(O==null)return;let de;d.is(O.execution)?de=d.to(O.execution):l.is(O.execution)?de=l.to(O.execution):h.is(O.execution)&&(de=h.to(O._id,V));const ee=a.to(O.definition);let X;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?X=O.source.scope:X=await q.resolveWorkspaceFolder(I.URI.revive(O.source.scope)):X=R.TaskScope.Workspace),!ee||!X)return;const Q=new R.$hL(ee,X,O.name,O.source.label,de,O.problemMatchers);return O.isBackground!==void 0&&(Q.isBackground=O.isBackground),O.group!==void 0&&(Q.group=R.$dL.from(O.group._id),Q.group&&O.group.isDefault&&(Q.group=new R.$dL(Q.group.id,Q.group.label),O.group.isDefault===!0&&(Q.group.isDefault=O.group.isDefault))),O.presentationOptions&&(Q.presentationOptions=t.to(O.presentationOptions)),O._id&&(Q._id=O._id),O.detail&&(Q.detail=O.detail),Q}z.to=j})($||(e.TaskDTO=$={}));var b;(function(z){function M(j){return j}z.from=M;function T(j){if(j)return Object.assign(Object.create(null),j)}z.to=T})(b||(b={}));class v{#e;constructor(M,T,j){this._id=T,this.a=j,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let C=class{constructor(M,T,j,O,q,V,de,ee){this.q=new m.$Od,this.r=new m.$Od,this.s=new m.$Od,this.t=new m.$Od,this.a=M.getProxy(L.$uK.MainThreadTask),this.b=j,this.c=O,this.d=q,this.e=V,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=de,this.g=ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,T,j){if(!j)return new R.$wK(()=>{});const O=this.w();return this.j.set(O,{type:T,provider:j,extension:M}),this.a.$registerTaskProvider(O,T),new R.$wK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(M,T){this.a.$registerTaskSystem(M,T)}fetchTasks(M){return this.a.$fetchTasks(b.from(M)).then(async T=>{const j=[];for(const O of T){const q=await $.to(O,this.b,this.m);q&&j.push(q)}return j})}get taskExecutions(){const M=[];return this.k.forEach(T=>M.push(T)),M}terminateTask(M){if(!(M instanceof v))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,T,j){const O=this.m.get(M.id);O&&(this.o.set(M.id,O),this.e.attachPtyToTerminal(T,await O.callback(j))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const T=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:T})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const T=await this.y(M.id);this.s.fire({execution:T,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const T=await this.y(M.id);this.t.fire({execution:T,exitCode:M.exitCode})}$provideTasks(M,T){const j=this.j.get(M);if(!j)return Promise.reject(new Error("no handler found"));const O=[],q=(0,F.$Ng)(()=>j.provider.provideTasks(A.CancellationToken.None)).then(V=>this.u(T,O,j,V));return new Promise(V=>{q.then(de=>{Promise.all(O).then(()=>{V(de)})})})}async $resolveTask(M,T){const j=this.j.get(M);if(!j)return Promise.reject(new Error("no handler found"));if(T.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${T.definition.type}] cannot be resolved by provider of type [${j.type}].`);const O=await $.to(T,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const q=await j.provider.resolveTask(O,A.CancellationToken.None);if(!q)return;this.z(q,j);const V=$.from(q,j.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(V.execution)&&await this.x(V,q,!0),await this.v(V)}w(){return this.h++}async x(M,T,j){const O=await this.a.$createTaskId(M);!j&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,T.execution)),this.m.set(O,T.execution)}async y(M,T){if(typeof M=="string"){const q=this.l.get(M);if(!q)throw new o.$ab("Unexpected: The specified task is missing an execution");return q}const j=this.l.get(M.id);if(j)return j;const O=new Promise((q,V)=>{function de(ee,X,Q){Q?q(new v(ee,X.id,Q)):V("Unexpected: Task does not exist.")}T?de(this,M,T):$.to(M.task,this.b,this.m).then(ee=>de(this,M,ee))});return this.l.set(M.id,O),O.then(q=>(this.k.set(M.id,q),q),q=>Promise.reject(q))}z(M,T){M._deprecated&&this.g.report("Task.constructor",T.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const j=this.n.values();let O=j.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=j.next()}};e.$mec=C,e.$mec=C=He([Be(0,f.$wM),Be(1,y.$MM),Be(2,w.$ndc),Be(3,E.$HM),Be(4,g.$qdc),Be(5,P.$Idc),Be(6,s.$aj),Be(7,i.$ddc)],C);let N=class extends C{constructor(M,T,j,O,q,V,de,ee){super(M,T,j,O,q,V,de,ee),this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:c.$h(0)})}async executeTask(M,T){if(!T.execution)throw new Error("Tasks to execute must include an execution");const j=$.from(T,M);if(j===void 0)throw new Error("Task is not valid");if(h.is(j.execution))await this.x(j,T,!1);else throw new o.$$;const O=await this.y(await this.a.$getTaskExecution(j),T);return this.a.$executeTask(j).catch(q=>{throw new Error(q)}),O}u(M,T,j,O){const q=[];if(O)for(const V of O){this.z(V,j),(!V.definition||!M[V.definition.type])&&this.f.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const de=$.from(V,j.extension);de&&h.is(de.execution)?(q.push(de),T.push(this.x(de,V,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:q,extension:j.extension}}async v(M){if(h.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,T){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,T,j){}};e.$nec=N,e.$nec=N=He([Be(0,f.$wM),Be(1,y.$MM),Be(2,w.$ndc),Be(3,E.$HM),Be(4,g.$qdc),Be(5,P.$Idc),Be(6,s.$aj),Be(7,i.$ddc)],N),e.$oec=(0,S.$Sh)("IExtHostTask")}),define(ke[361],Se([1,0,36,29]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sK=e.$rK=e.$qK=void 0;function m(R){return"cellResults"in R}e.$qK=m,e.$rK="rawCell#";function L(R,w){let E=-1;const g=[];let A=[];return R.forEach(f=>{f.range.startLineNumber!==E&&A.length>0&&(g.push([...A]),A=[]),A.push(f),E=f.range.endLineNumber}),A.length>0&&g.push([...A]),g.map(f=>{const y=[],S=f[0].range.startLineNumber,p=f[f.length-1].range.endLineNumber;for(let c=S;c<=p;c++)y.push(w.getLineContent(c));return new I.$XI(y.join(`
`)+`
`,f.map(c=>new F.$ws(c.range.startLineNumber-1,c.range.startColumn-1,c.range.endLineNumber-1,c.range.endColumn-1)))})}e.$sK=L}),define(ke[362],Se([1,0,216,22,4,3,28,13,18,2,31,110,6,35,14,7,69,296,148,11,24,17,288,361,358]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i,n,o,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=void 0;class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(h=>h.apiEditor)}constructor(h,k,D,$,b,v){this.q=D,this.r=$,this.s=b,this.t=v,this.f=new Map,this.g=new R.$zc,this.h=new Map,this.j=new m.$Od({onListenerError:n.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new m.$Od({onListenerError:n.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new m.$Od({onListenerError:n.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new m.$Od({onListenerError:n.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$0cc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=h.getProxy(f.$uK.MainThreadNotebook),this.c=h.getProxy(f.$uK.MainThreadNotebookDocuments),this.d=h.getProxy(f.$uK.MainThreadNotebookEditors),this.i=k.converter,k.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===13){const N=C.notebookEditor?.notebookUri,z=C.cell.handle,T=this.g.get(N)?.getCell(z);if(T)return T.apiCell}if(C&&C.$mid===14){const N=C.uri,z=this.g.get(N);if(z)return z.apiNotebook}return C}}),u.B(k)}getEditorById(h){const k=this.h.get(h);if(!k)throw new Error(`unknown text editor: ${h}. known editors: ${[...this.h.keys()]} `);return k}getIdByEditor(h){for(const[k,D]of this.h)if(D.apiEditor===h)return k}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(h,k){const D=this.g.get(h);if(!D&&!k)throw new Error(`NO notebook document for '${h}'`);return D}static u(h,k){if(!k)return;const D=k.filenamePattern.map($=>S.NotebookExclusiveDocumentPattern.from($)).filter($=>$!==void 0);if(k.filenamePattern&&!D){console.warn(`Notebook content provider view options file name pattern is invalid ${k.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:k.displayName,filenamePattern:D,exclusive:k.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,k,D){const $=u.a++,b=typeof D.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set($,D),this.b.$registerNotebookCellStatusBarItemProvider($,b,k);let v;return b!==void 0&&(v=D.onDidChangeCellStatusBarItems(C=>this.b.$emitCellStatusBarEvent(b))),new p.$wK(()=>{this.f.delete($),this.b.$unregisterNotebookCellStatusBarItemProvider($,b),v?.dispose()})}async createNotebookDocument(h){const k=await this.c.$tryCreateNotebook({viewType:h.viewType,content:h.content&&S.NotebookData.from(h.content)});return g.URI.revive(k)}async openNotebookDocument(h){const k=this.g.get(h);if(k)return k.apiNotebook;const D=await this.c.$tryOpenNotebook(h),$=this.g.get(g.URI.revive(D));return(0,E.$Kf)($?.apiNotebook)}async showNotebookDocument(h,k){g.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let D;typeof k=="object"?D={position:S.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selections:k.selections&&k.selections.map(S.NotebookRange.from),pinned:typeof k.preview=="boolean"?!k.preview:void 0}:D={preserveFocus:!1};const $=await this.d.$tryShowNotebookDocument(h.uri,h.notebookType,D),b=$&&this.h.get($)?.apiEditor;if(b)return b;throw $?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,k,D,$){const b=this.f.get(h),v=g.URI.revive(k),C=this.g.get(v);if(!C||!b)return;const N=C.getCellFromIndex(D);if(!N)return;const z=await b.provideCellStatusBarItems(N.apiCell,$);if(!z)return;const M=new L.$Qc,T=this.p.add([M]),O=(Array.isArray(z)?z:[z]).map(q=>S.NotebookStatusBarItem.from(q,this.i,M));return{cacheId:T,items:O}}$releaseNotebookCellStatusBarItems(h){this.p.delete(h)}registerNotebookSerializer(h,k,D,$,b){if((0,w.$Ce)(k))throw new Error("viewType cannot be empty or just whitespace");const v=this.w++;return this.x.set(v,{viewType:k,serializer:D,options:$}),this.b.$registerNotebookSerializer(v,{id:h.identifier,location:h.extensionLocation},k,S.NotebookDocumentContentOptions.from($),u.u(h,b)),(0,L.$Pc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(h,k,D){const $=this.x.get(h);if(!$)throw new Error("NO serializer found");const b=await $.serializer.deserializeNotebook(k.buffer,D);return new c.$tv(S.NotebookData.from(b))}async $notebookToData(h,k,D){const $=this.x.get(h);if(!$)throw new Error("NO serializer found");const b=await $.serializer.serializeNotebook(S.NotebookData.to(k.value),D);return F.$ce.wrap(b)}async $saveNotebook(h,k,D,$,b){const v=g.URI.revive(k),C=this.x.get(h);if(!C)throw new Error("NO serializer found");const N=this.g.get(v);if(!N)throw new Error("Document NOT found");if(N.versionId!==D)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new A.$wk((0,I.localize)(0,null,this.z(v)),6);await this.y(v,$);const z={metadata:(0,o.$fn)(N.apiNotebook.metadata,q=>!(C.options?.transientDocumentMetadata??{})[q]),cells:[]};for(const q of N.apiNotebook.getCells()){const V=new p.$UL(q.kind,q.document.getText(),q.document.languageId,q.mime,C.options?.transientOutputs?[]:[...q.outputs],q.metadata,q.executionSummary);V.metadata=(0,o.$fn)(q.metadata,de=>!(C.options?.transientCellMetadata??{})[de]),z.cells.push(V)}const M=await C.serializer.serializeNotebook(z,b);await this.s.value.writeFile(v,M);const T=this.s.getFileSystemProviderExtUri(v.scheme),j=await this.s.value.stat(v);return{name:T.basename(v),isFile:(j.type&A.FileType.File)!==0,isDirectory:(j.type&A.FileType.Directory)!==0,isSymbolicLink:(j.type&A.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((j.permissions??0)&A.FilePermission.Locked),etag:A.$Hk({mtime:j.mtime,size:j.size}),children:void 0}}async $searchInNotebooks(h,k,D,$,b){const v=this.x.get(h)?.serializer;if(!v)return{limitHit:!1,results:[]};const C=new R.$Ac;await(async(j,O,q)=>{await Promise.all(j.map(async V=>await Promise.all(V.filenamePatterns.map(de=>{const ee={...q,type:1,filePattern:de};return this.t.doInternalFileSearchWithCustomCallback(ee,O,X=>{X.forEach(Q=>{C.has(Q)||$.some(x=>V.isFromSettings&&!x.isFromSettings?!1:x.filenamePatterns.some(se=>(0,d.$vcb)(se,Q)))||C.add(Q)})})}))))})(D,b,k);const z=new R.$zc;let M=!1;const T=Array.from(C).map(async j=>{const O=[];try{if(b.isCancellationRequested)return;if(k.maxResults&&[...z.values()].reduce((ee,X)=>ee+X.cellResults.length,0)>k.maxResults){M=!0;return}const q=[],V=this.g.get(j);if(V)V.apiNotebook.getCells().forEach(X=>q.push({input:X.document.getText(),outputs:X.outputs.flatMap(Q=>Q.items.map(ae=>ae.data.toString()))}));else{const ee=await this.s.value.readFile(j),X=F.$ce.fromString(ee.toString()),Q=await v.deserializeNotebook(X.buffer,b);if(b.isCancellationRequested)return;S.NotebookData.from(Q).cells.forEach(x=>q.push({input:x.source,outputs:x.outputs.flatMap(se=>se.items.map(pe=>pe.valueBytes.toString()))}))}if(b.isCancellationRequested)return;q.forEach((ee,X)=>{const Q=k.contentPattern.pattern,ae=new t.$DOb(ee.input,void 0,ee.outputs),x=ae.findInInputs(Q),se=ae.findInOutputs(Q),pe=se.flatMap(G=>(0,r.$sK)(G.matches,G.textBuffer)).map((G,U)=>(G.webviewIndex=U,G));if(x.length>0||se.length>0){const G={index:X,contentResults:(0,r.$sK)(x,ae.inputTextBuffer),webviewResults:pe};O.push(G)}});const de={resource:j,cellResults:O};z.set(j,de);return}catch{return}});return await Promise.all(T),{limitHit:M,results:[...z.values()]}}async y(h,k){const D=await this.s.value.stat(h);if(typeof k?.mtime=="number"&&typeof k.etag=="string"&&k.etag!==A.$Gk&&typeof D.mtime=="number"&&typeof D.size=="number"&&k.mtime<D.mtime&&k.etag!==A.$Hk({mtime:k.mtime,size:D.size}))throw new A.$wk((0,I.localize)(1,null),3,k)}z(h){return h.scheme===a.Schemas.file?h.fsPath:h.toString()}A(h,k,D){if(this.h.has(k))throw new Error(`editor with id ALREADY EXSIST: ${k}`);const $=new i.$Iec(k,this.d,h,D.visibleRanges.map(S.NotebookRange.to),D.selections.map(S.NotebookRange.to),typeof D.viewColumn=="number"?S.ViewColumn.to(D.viewColumn):void 0);this.h.set(k,$)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const D of h.value.removedDocuments){const $=g.URI.revive(D),b=this.g.get($);b&&(b.dispose(),this.g.delete($),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(b.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===$.toString()&&this.h.delete(v.id)}if(h.value.addedDocuments){const D=[];for(const $ of h.value.addedDocuments){const b=g.URI.revive($.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const v=new s.$Hec(this.c,this.q,this.r,b,$);D.push(...$.cells.map(C=>s.$Gec.asModelAddData(v.apiNotebook,C))),this.g.get(b)?.dispose(),this.g.set(b,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:D}),this.m.fire(v.apiNotebook)}}if(h.value.addedEditors)for(const D of h.value.addedEditors){if(this.h.has(D.id))return;const $=g.URI.revive(D.documentUri),b=this.g.get($);b&&this.A(b,D.id,D)}const k=[];if(h.value.removedEditors)for(const D of h.value.removedEditors){const $=this.h.get(D);$&&(this.h.delete(D),this.k?.id===$.id&&(this.k=void 0),k.push($))}if(h.value.visibleEditors){this.l=h.value.visibleEditors.map($=>this.h.get($)).filter($=>!!$);const D=new Set;this.l.forEach($=>D.add($.id));for(const $ of this.h.values()){const b=D.has($.id);$._acceptVisibility(b)}this.l=[...this.h.values()].map($=>$).filter($=>$.visible),this.o.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this.k=void 0:h.value.newActiveEditor&&(this.h.get(h.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${h.value.newActiveEditor}`),this.k=this.h.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(h){const k=y.$UM.String.with("notebookType","A notebook type"),D=new y.$WM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[k,new y.$UM("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>F.$ce.wrap(b))],new y.$VM("Notebook Data",b=>S.NotebookData.to(b.value))),$=new y.$WM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[k,new y.$UM("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new c.$tv(S.NotebookData.from(b)))],new y.$VM("Bytes",b=>b.buffer));h.registerApiCommand(D),h.registerApiCommand($)}}e.$Jec=u}),define(ke[363],Se([1,0,16,21,43,34,23,37,36]),function(me,e,I,F,m,L,R,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;class g{constructor(f,y,S){this.k=f,this.l=y,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=f.filePattern,this.b=f.includePattern&&L.$zj(f.includePattern),this.c=f.maxResults||void 0,this.d=f.exists,this.h=new Set,this.j=f.excludePattern&&L.$zj(f.excludePattern)}cancel(){this.g=!0,this.h.forEach(f=>f.cancel()),this.h=new Set}search(f){const y=this.k.folderQueries||[];return new Promise((S,p)=>{const c=s=>{this.f++,f(s)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const i=s.toString(),n=I.$mc(i);this.j&&this.j(i,n)||this.v(c,{base:s,basename:n})}),Promise.all(y.map(s=>this.p(s,c))).then(s=>{S({limitHit:this.e,stats:s[0]||void 0})},s=>{p(new Error((0,m.$Di)(s)))})})}async p(f,y){const S=new F.$Yd,p=this.q(f),c=this.r(),s=new E.$_I(this.k,f),i=!s.hasSiblingExcludeClauses();let n;try{this.h.add(S),n=w.$Kd.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},p,S.token),a=n.elapsed(),t=w.$Kd.create();return this.g&&!this.e||(o&&o.forEach(r=>{const d=I.$fc.relative(f.folder.path,r.path);if(i){const u=I.$mc(r.path);this.v(y,{base:f.folder,relativePath:d,basename:u});return}this.s(c,f.folder,d,y)}),this.g&&!this.e)?null:(this.u(c,s,y),{providerTime:a,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(f){const y=(0,E.$$I)(this.k.includePattern,f.includePattern),S=(0,E.$$I)(this.k.excludePattern,f.excludePattern);return{folder:f.folder,excludes:S,includes:y,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}s({pathToEntries:f},y,S,p){if(S===this.a){const s=I.$mc(this.a);this.v(p,{base:y,relativePath:this.a,basename:s})}function c(s){const i=I.$mc(s),n=I.$lc(s);let o=f[n];o||(o=f[n]=[],c(n)),o.push({base:y,relativePath:s,basename:i})}c(S)}u({rootEntries:f,pathToEntries:y},S,p){const c=this,s=this.a;function i(n){const o=(0,E.$bJ)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const r=n[a],{relativePath:d,basename:u}=r;if(S.matchesExcludesSync(d,u,s!==u?o:void 0))continue;const l=y[d];if(l)i(l);else{if(d===s)continue;c.v(p,r)}if(c.e)break}}i(f)}v(f,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||f(y))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(f,y,S,p){const c=this.c(f.cacheKey),s=new g(f,y,c&&c.token);let i=0;const n=o=>{i+=o.length,S(o.map(a=>this.d(a)))};return this.e(s,A.a,n,p).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:o.stats}}))}clearCache(f){this.c(f)?.cancel()}c(f){if(f)return this.b.has(f)||this.b.set(f,new F.$Yd),this.b.get(f)}d(f){return f.relativePath?{resource:R.$wg(f.base,f.relativePath)}:{resource:f.base}}e(f,y,S,p){const c=p.onCancellationRequested(()=>{f.cancel()}),s=n=>{n&&(i.push(n),y>0&&i.length>=y&&(S(i),i=[]))};let i=[];return f.search(s).then(n=>(i.length&&S(i),c.dispose(),n),n=>(i.length&&S(i),c.dispose(),Promise.reject(n)))}}e.$yec=A}),define(ke[364],Se([1,0,19,74,34,102,28,17,16,23,13,18,2,99,237,44,15,40,145,359,36]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9J=e.$8J=void 0;let a=class{constructor(b,v,C,N,z){this.a=b,this.b=v,this.c=C,this.d=N,this.e=z}text(b,v,C={}){b=this.f(b,C);const N=this.a.getValue(),z=v&&v.some(T=>!this.a.getValue({resource:T}).search.useRipgrep);return{...this.h(v?.map(s.$bi),C),type:2,contentPattern:b,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:N.search.usePCRE2||z||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(b,v){const C=this.a.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const N={...b,wordSeparators:C.editor.wordSeparators};return this.j(b,v)&&(N.isCaseSensitive=!0),this.k(b)&&(N.isMultiline=!0),v.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=v.notebookSearchConfig.includeMarkupInput),v.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=v.notebookSearchConfig.includeMarkupPreview),v.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=v.notebookSearchConfig.includeCodeInput),v.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=v.notebookSearchConfig.includeOutput),N}file(b,v={}){return{...this.h(b,v),type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey}}g(b,v){return b?(b=Array.isArray(b)?b.map(l):l(b),v?this.parseSearchPaths(b):{pattern:r(...Array.isArray(b)?b:[b])}):{}}h(b=[],v={}){const C=this.g(v.includePattern,v.expandPatterns),N=this.g(v.excludePattern,v.expandPatterns),z=b.length>1,M=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(O=>this.q(O,v,N)):b.map(O=>this.r(O,v,N,z))).filter(O=>!!O),T={_reason:v._reason,folderQueries:M,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:N.pattern,includePattern:C.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const O=I.$Gb(I.$Qb(this.c.groups.map(de=>de.editors.map(ee=>ee.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const q=O.filter(de=>(0,o.$2I)(T,de.fsPath)),V=this.i(q);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...T,...V}}const j=v.extraFileResources&&v.extraFileResources.filter(O=>(0,o.$2I)(T,O.fsPath));return T.extraFileResources=j&&j.length?j:void 0,T}i(b){const v=[],C=new R.$zc,N={};let z=!1;return b.forEach(M=>{if(M.scheme===w.Schemas.walkThrough)return;if((0,g.$Ag)(M)){const j=this.b.getWorkspaceFolder(M)?.uri??M.with({path:E.$lc(M.fsPath)});let O=C.get(j);O||(z=!0,O={folder:j,includePattern:{}},v.push(O),C.set(j,O));const q=E.$kc(j.fsPath,M.fsPath);(0,P.$Kf)(O.includePattern)[q.replace(/\\/g,"/")]=!0}else M.fsPath&&(z=!0,N[M.fsPath]=!0)}),{folderQueries:v,includePattern:N,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(b,v){if(v.isSmartCase){if(b.isRegExp){if(A.$qf(b.pattern,!0))return!0}else if(A.$qf(b.pattern))return!0}return!!b.isCaseSensitive}k(b){return b.isMultiline||b.isRegExp&&(0,y.$yB)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const v=V=>E.$hc(V)||/^\.\.?([\/\\]|$)/.test(V),N=(Array.isArray(b)?b:d(b)).map(V=>{const de=this.e.resolvedUserHome;return de?(0,L.$xv)(V,de.scheme===w.Schemas.file?de.fsPath:de.path):V}),z=F.$J(N,V=>v(V)?"searchPaths":"exprSegments"),M=(z.exprSegments||[]).map(V=>A.$Le(V,"/")).map(V=>A.$Le(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),u(V))),T={},j=this.m(z.searchPaths||[]);j&&j.length&&(T.searchPaths=j);const O=I.$Qb(M),q=r(...O);return q&&(T.pattern=q),T}l(b,v){return v.disregardExcludeSettings?void 0:(0,o.$1I)(b,!v.disregardSearchExcludeSettings)}m(b){if(!b||!b.length)return[];const v=b.flatMap(N=>{let{pathPortion:z,globPortion:M}=t(N);return M&&(M=h(M)),this.n(z).flatMap(j=>this.o(j,M))}),C=new Map;return v.forEach(N=>{const z=N.searchPath.toString(),M=C.get(z);M?N.pattern&&(M.pattern=M.pattern||{},M.pattern[N.pattern]=!0):C.set(z,{searchPath:N.searchPath,pattern:N.pattern?r(N.pattern):void 0})}),Array.from(C.values())}n(b){if(E.$hc(b)){const v=this.b.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==w.Schemas.file?[{searchPath:v[0].uri.with({path:b})}]:[{searchPath:f.URI.file(E.$gc(b))}]}if(this.b.getWorkbenchState()===2){const v=this.b.getWorkspace().folders[0].uri;if(b=l(b),b.startsWith("../")||b===".."){const N=E.$fc.resolve(v.path,b);return[{searchPath:v.with({path:N})}]}const C=h(b);return[{searchPath:v,pattern:C}]}else{if(b==="./"||b===".\\")return[];{const v=b.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(z=>{const M=v.match(new RegExp(`^${A.$Ge(z.name)}(?:/(.*)|$)`));return M?{match:M,folder:z}:null}).filter(P.$Hf);if(N.length)return N.map(z=>{const M=z.match[1];return{searchPath:z.folder.uri,pattern:M&&h(M)}});{const z=b.match(/\.[\/\\](.+)[\/\\]?/),M=z?z[1]:b,T=S.localize(0,null,M);throw new Error(T)}}}}o(b,v){const C=b.pattern&&v?`${b.pattern}/${v}`:b.pattern||v,N=[{searchPath:b.searchPath,pattern:C}];return C&&!C.endsWith("**")&&N.push({searchPath:b.searchPath,pattern:C+"/**"}),N}q(b,v,C){const N=this.r((0,s.$bi)(b.searchPath),v,C,!1);return N?{...N,includePattern:b.pattern}:null}r(b,v,C,N){let z;const M=f.URI.isUri(b)?b:b.uri;if(C.searchPaths){const V=C.searchPaths.filter(de=>(0,g.$pg)(de.searchPath,M))[0];if(V&&!V.pattern)return null;V&&(z=V.pattern)}const T=this.a.getValue({resource:M}),O={...this.l(T,v)||{},...z||{}},q=f.URI.isUri(b)?(0,g.$tg)(b):b.name;return{folder:M,folderName:N?q:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:T.files&&T.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!T.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!T.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof v.disregardParentIgnoreFiles=="boolean"?v.disregardParentIgnoreFiles:!T.search.useParentIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!T.search.followSymlinks}}};e.$8J=a,e.$8J=a=He([Be(0,p.$mi),Be(1,s.$2h),Be(2,i.$CC),Be(3,c.$aj),Be(4,n.$6J)],a);function t($){const b=$.match(/[\*\{\}\(\)\[\]\?]/);if(b){const v=b.index,C=$.substr(0,v).match(/[/|\\][^/\\]*$/);if(C){let N=$.substr(0,C.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:$.substr((C.index||0)+1)}}}return{pathPortion:$}}function r(...$){return $.length?$.reduce((b,v)=>(b[v]=!0,b),Object.create(null)):void 0}function d($){return m.$xj($,",").map(b=>b.trim()).filter(b=>!!b.length)}function u($){return[`**/${$}/**`,`**/${$}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function l($){return $.replace(/\\/g,"/")}function h($){return l($).replace(/^\.\//,"").replace(/\/+$/g,"")}function k($){return $.replace(/([?*[\]])/g,"[$1]")}function D($,b){$=I.$Lb($,N=>N.toString());const v=[],C=b.getWorkspace();return $&&$.forEach(N=>{let z;if(b.getWorkbenchState()===2)z=(0,g.$yg)(C.folders[0].uri,N),z&&z!=="."&&(z="./"+z);else{const M=b.getWorkspaceFolder(N);if(M){const T=M.name;if(C.folders.filter(O=>O.name===T).length===1){const O=(0,g.$yg)(M.uri,N);O===""?z=`./${M.name}`:z=`./${M.name}/${O}`}else z=N.fsPath}}z&&v.push(k(z))}),v}e.$9J=D}),define(ke[365],Se([1,0,23,2,21,11,5,364,36,40]),function(me,e,I,F,m,L,R,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qb=e.$1qb=void 0;const A=7e3;function P(p,c){const s=c.activationEvents;if(!s)return Promise.resolve(void 0);const i=[],n=[];for(const u of s)if(/^workspaceContains:/.test(u)){const l=u.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||p.forceUsingSearch?n.push(l):i.push(l)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);let o;const a=new Promise((u,l)=>{o=u}),t=u=>o({activationEvent:u}),r=Promise.all(i.map(u=>f(p,u,t))).then(()=>{}),d=y(p,c.identifier,n,t);return Promise.all([r,d]).then(()=>{o(void 0)}),a}e.$1qb=P;async function f(p,c,s){for(const i of p.folders)if(await p.exists(I.$wg(F.URI.revive(i),c))){s(`workspaceContains:${c}`);return}}async function y(p,c,s,i){if(s.length===0)return Promise.resolve(void 0);const n=new m.$Yd,o=p.checkExists(p.folders,s,n.token),a=setTimeout(async()=>{n.cancel(),p.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},A);let t=!1;try{t=await o}catch(r){L.$3(r)||L.$Z(r)}n.dispose(),clearTimeout(a),t&&i(`workspaceContains:${s.join(",")}`)}function S(p,c,s,i){const n=p.get(R.$Rh),o=p.get(E.$SI),t=n.createInstance(w.$8J).file(c.map(r=>(0,g.$bi)(F.URI.revive(r))),{_reason:"checkExists",includePattern:s,exists:!0});return o.fileSearch(t,i).then(r=>!!r.limitHit,r=>L.$3(r)?!1:Promise.reject(r))}e.$2qb=S}),define(ke[47],Se([1,0,213,16,56,23,10,3,78,2,15,6,42,294,118,41,25,147,11,26,22,273,7,65,5,27,92,20,107,73,46,4,365,117,275,17,115,37,12,116]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i,n,o,a,t,r,d,u,l,h,k,D,$,b,v,C,N,z,M,T,j,O){"use strict";var q;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=e.$Wdc=e.$Vdc=e.$Udc=e.$Tdc=void 0,e.$Tdc=(0,d.$Sh)("IHostUtils");let V=q=class extends w.$Rc{constructor(G,U,ce,be,H,Z,Y,$e,ne,fe,te,he){super(),this.X=he,this.a=this.B(new b.$Od),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=ce,this.f=Y,this.j=be,this.m=H,this.s=Z,this.t=ne,this.u=fe,this.w=te,this.y=this.g.getProxy(P.$uK.MainThreadWorkspace),this.z=this.g.getProxy(P.$uK.MainThreadTelemetry),this.C=this.g.getProxy(P.$uK.MainThreadExtensionService),this.D=new R.$Tg,this.F=new R.$Tg,this.G=new R.$Tg,this.H=new R.$Tg,this.I=new se(this.f.extensions.activationEvents),this.L=new s.$o5b(this.I,this.f.extensions.allExtensions);const we=new n.$0l(this.f.extensions.myExtensions);this.J=new s.$o5b(this.I,ae(this.L,we)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${X(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${X(this.J)}`)),this.M=new S.$Adc(this.g,this.s),this.N=new C.$Mdc(this.g),this.O=$e,this.h=G.createChild(new k.$Qh([S.$Bdc,this.M],[C.$Ndc,this.N])),this.P=this.B(new y.$zdc(this.J,this.L,{onExtensionActivationError:(Pe,B,J)=>{this.C.$onExtensionActivationError(Pe,i.$2(B),J)},actualActivateExtension:async(Pe,B)=>{if(s.$o5b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,B),new y.$ydc;const J=this.J.getExtensionDescription(Pe);return this.db(J,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),m.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(G){i.$Z(G)}}async Y(){this.O.onWillDeactivateAll();let G=[];try{G=this.J.getAllExtensionDescriptions().map(H=>H.identifier).filter(H=>this.isActivated(H)).map(H=>this.cb(H))}catch{}await Promise.all(G)}terminate(G,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${G}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(be=>{this.s.error(be)}),this.g.dispose();const ce=this.Y();Promise.race([(0,R.$Vg)(5e3),ce]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(G){return this.G.isOpen()?this.P.isActivated(G):!1}async getExtension(G){const U=await this.C.$getExtension(G);return U&&{...U,identifier:new n.$9l(U.identifier.value),extensionLocation:g.URI.revive(U.extensionLocation)}}Z(G,U){return this.P.activateByEvent(G,U)}$(G,U){return this.P.activateById(G,U)}activateByIdWithErrors(G,U){return this.$(G,U).then(()=>{const ce=this.P.getActivatedExtension(G);if(ce.activationFailed)return Promise.reject(ce.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(G=>this.J)}getExtensionExports(G){if(this.G.isOpen())return this.P.getActivatedExtension(G).exports;try{return this.P.getActivatedExtension(G).exports}catch{return null}}async ab(G){if(G.scheme===z.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(G.fsPath);return g.URI.file(U)}return G}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(G=>new x(G))),this.Q}async bb(G){const U=E.$Yh.forUris(ce=>L.$ng.ignorePathCasing(ce));return await Promise.all(G.map(async ce=>{if(this.ub(ce)){const be=await this.ab(ce.extensionLocation);U.set(be,ce)}})),U}cb(G){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(G))return U;const ce=this.P.getActivatedExtension(G);if(!ce)return U;try{typeof ce.module.deactivate=="function"&&(U=Promise.resolve(ce.module.deactivate()).then(void 0,be=>(this.s.error(be),Promise.resolve(void 0))))}catch(be){this.s.error(`An error occurred when deactivating the extension '${G.value}':`),this.s.error(be)}try{(0,w.$Mc)(ce.subscriptions)}catch(be){this.s.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this.s.error(be)}return U}async db(G,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(G.identifier):await this.C.$onWillActivateExtension(G.identifier),this.fb(G,U).then(ce=>{const be=ce.activationTimes;return this.C.$onDidActivateExtension(G.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,U),this.eb(G,U,"success",be),ce},ce=>{throw this.eb(G,U,"failure"),ce})}eb(G,U,ce,be){const H=ee(G,U);this.z.$publicLog2("extensionActivationTimes",{...H,...be||{},outcome:ce})}fb(G,U){const ce=ee(G,U);this.z.$publicLog2("activatePlugin",ce);const be=this.ub(G);if(!be)return Promise.resolve(new y.$xdc(y.$udc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${G.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const H=new y.$vdc(U.startup);return Promise.all([this.vb(G,(0,L.$wg)(G.extensionLocation,be),H),this.gb(G)]).then(Z=>(m.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),q.hb(this.s,G.identifier,Z[0],Z[1],H))).then(Z=>(m.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),Z))}gb(G){const U=new a.$Ddc(G,this.M),ce=new a.$Cdc(G.identifier.value,!1,this.M),be=new N.$Odc(G,this.N),H=G.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Z=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([U.whenReady,ce.whenReady,this.O.whenReady]).then(()=>{const Y=this;let $e,ne;const fe=(0,c.$tF)(G,"ipc")?this.f.messagePorts?.get(n.$9l.toKey(G.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:ce,secrets:be,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(te){return F.$ic(G.extensionLocation.fsPath,te)},get storagePath(){return Y.O.workspaceValue(G)?.fsPath},get globalStoragePath(){return Y.O.globalValue(G).fsPath},get logPath(){return F.$ic(Y.f.logsLocation.fsPath,G.identifier.value)},get logUri(){return g.URI.joinPath(Y.f.logsLocation,G.identifier.value)},get storageUri(){return Y.O.workspaceValue(G)},get globalStorageUri(){return Y.O.globalValue(G)},get extensionMode(){return H},get extension(){return $e===void 0&&($e=new Q(Y,G.identifier,G,Z,!1)),$e},get extensionRuntime(){return(0,c.$uF)(G,"extensionRuntime"),Y.extensionRuntime},get environmentVariableCollection(){return Y.u.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!ne){if(!fe)return;const te=b.Event.buffer(b.Event.fromDOMEventEmitter(fe,"message",he=>he.data));fe.start(),ne={onDidReceiveMessage:te,postMessage:fe.postMessage.bind(fe)}}return ne}})})}static hb(G,U,ce,be,H){return ce=ce||{activate:void 0,deactivate:void 0},this.ib(G,U,ce,be,H).then(Z=>new y.$wdc(!1,null,H.build(),ce,Z,be.subscriptions))}static ib(G,U,ce,be,H){if(typeof ce.activate=="function")try{H.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${U.value}`);const Z=typeof global=="object"?global:self,Y=ce.activate.apply(Z,[be]);return H.activateCallStop(),H.activateResolveStart(),Promise.resolve(Y).then($e=>(H.activateResolveStop(),$e))}catch(Z){return Promise.reject(Z)}else return Promise.resolve(ce)}jb(G,U){this.$(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:U}).then(void 0,ce=>{this.s.error(ce)})}kb(G,U=0){const be=Date.now();(0,j.$B)(()=>{for(let H=U;H<G.length;H+=1){const Z=G[H];for(const Y of Z.activationEvents??[])if(Y==="onStartupFinished")if(Date.now()-be>50){this.kb(G,H);break}else this.jb(Z,Y)}})}lb(){this.C.$setPerformanceMarks(m.getMarks()),this.m.getConfigProvider().then(G=>{const U=G.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ce=this.J.getAllExtensionDescriptions();if(U)this.kb(ce);else for(const be of ce)if(be.activationEvents)for(const H of be.activationEvents)H==="onStartupFinished"&&this.jb(be,H)})}mb(){const G=this.Z("*",!0).then(void 0,Z=>{this.s.error(Z)});this.B(this.j.onDidChangeWorkspace(Z=>this.nb(Z.added)));const U=this.j.workspace?this.j.workspace.folders:[],ce=this.nb(U),be=this.pb(),H=Promise.all([be,G,ce]).then(()=>{});return Promise.race([H,(0,R.$Vg)(1e4)]).then(()=>{this.lb()}),H}nb(G){return G.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(G,U))).then(()=>{})}async ob(G,U){if(this.isActivated(U.identifier))return;const ce=!this.f.remote.isRemote&&!!this.f.remote.authority,be={logService:this.s,folders:G.map(Z=>Z.uri),forceUsingSearch:ce||!this.c.fsExists,exists:Z=>this.c.fsExists(Z.fsPath),checkExists:(Z,Y,$e)=>this.y.$checkExists(Z,Y,$e)},H=await(0,v.$1qb)(be,U);if(H)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:H.activationEvent}).then(void 0,Z=>this.s.error(Z))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(G){throw console.error(G),G}}async qb(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:U}=this.f.environment;if(!G||!U)throw new Error(I.localize(0,null));const ce=await this.vb(null,U,new y.$vdc(!1));if(!ce||typeof ce.run!="function")throw new Error(I.localize(1,null,U.toString()));return new Promise((be,H)=>{const Z=(ne,fe)=>{ne?(j.$t&&this.s.error("Test runner called back with error",ne),H(ne)):(j.$t&&(fe?this.s.info(`Test runner called back with ${fe} failures.`):this.s.info("Test runner called back with successful outcome.")),be(typeof fe=="number"&&fe>0?1:0))},Y=(0,L.$kg)(U),$e=ce.run(Y,Z);$e&&$e.then&&$e.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),be(0)}).catch(ne=>{j.$t&&this.s.error("Test runner finished with error",ne),H(ne instanceof Error&&ne.stack?ne.stack:String(ne))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Vg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,U){return this.R[G]=U,(0,w.$Pc)(()=>{delete this.R[G]})}async getRemoteExecServer(G){const{resolver:U}=await this.sb(G);return U?.resolveExecServer?.(G,{resolveAttempt:0})}async sb(G){const U=G.indexOf("+");if(U===-1)throw new t.$CK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ce=G.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ce}`,!1),{authorityPrefix:ce,resolver:this.R[ce]}}async $resolveAuthority(G,U){const ce=T.$Kd.create(!1),be=()=>`[resolveAuthority(${(0,r.$Wk)(G)},${U})][${ce.elapsed()}ms] `,H=oe=>this.s.info(`${be()}${oe}`),Z=oe=>this.s.warn(`${be()}${oe}`),Y=(oe,_=void 0)=>this.s.error(`${be()}${oe}`,_),$e=oe=>{if(oe instanceof t.$CK)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe},ne=async oe=>{H(`activating resolver for ${oe}...`);const{resolver:_,authorityPrefix:ge}=await this.sb(oe);if(!_)throw Y(`no resolver for ${ge}`),new t.$CK(`No remote extension installed to resolve ${ge}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:_,authorityPrefix:ge,remoteAuthority:oe}},fe=G.split(/@|%40/g).reverse();H(`activating remote resolvers ${fe.join(" -> ")}`);let te;try{te=await Promise.all(fe.map(ne)).catch(async oe=>{if(!(oe instanceof t.$CK)||oe._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw oe;return Z(`resolving nested authorities failed: ${oe.message}`),[await ne(G)]})}catch(oe){return $e(oe)}const he=new R.$6g;he.cancelAndSet(()=>H("waiting..."),1e3);let we,Pe;for(const[oe,{authorityPrefix:_,resolver:ge,remoteAuthority:Ee}]of te.entries())try{if(oe===te.length-1)H("invoking final resolve()..."),m.mark(`code/extHost/willResolveAuthority/${_}`),we=await ge.resolve(Ee,{resolveAttempt:U,execServer:Pe}),m.mark(`code/extHost/didResolveAuthorityOK/${_}`),H("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ge,t.$BK.isManagedResolvedAuthority(we)?we:void 0));else{if(H(`invoking resolveExecServer() for ${Ee}`),m.mark(`code/extHost/willResolveExecServer/${_}`),Pe=await ge.resolveExecServer?.(Ee,{resolveAttempt:U,execServer:Pe}),!Pe)throw new t.$CK(`Exec server was not available for ${Ee}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);m.mark(`code/extHost/didResolveExecServerOK/${_}`)}}catch(ze){return m.mark(`code/extHost/didResolveAuthorityError/${_}`),Y("returned an error",ze),he.dispose(),$e(ze)}he.dispose();const B={environmentTunnels:we.environmentTunnels,features:we.tunnelFeatures},J={extensionHostEnv:we.extensionHostEnv,isTrusted:we.isTrusted,authenticationSession:we.authenticationSessionForInitializingExtensions?{id:we.authenticationSessionForInitializingExtensions.id,providerId:we.authenticationSessionForInitializingExtensions.providerId}:void 0};H(`returned ${t.$BK.isManagedResolvedAuthority(we)?"managed authority":`${we.host}:${we.port}`}`);let re;if(t.$BK.isManagedResolvedAuthority(we)){const oe=U;this.X.setFactory(oe,we.makeConnection),re={authority:G,connectTo:new r.$Tk(oe),connectionToken:we.connectionToken}}else re={authority:G,connectTo:new r.$Uk(we.host,we.port),connectionToken:we.connectionToken};return{type:"ok",value:{authority:re,options:J,tunnelInformation:B}}}async $getCanonicalURI(G,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$Wk)(G)})`);const{resolver:ce}=await this.sb(G);if(!ce)return null;const be=g.URI.revive(U);if(typeof ce.getCanonicalURI>"u")return be;const H=await(0,R.$Ng)(()=>ce.getCanonicalURI(be));return H||be}$startExtensionHost(G){G.toAdd.forEach(be=>be.extensionLocation=g.URI.revive(be.extensionLocation));const{globalRegistry:U,myExtensions:ce}=de(this.I,this.L,this.J,G);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(ce),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${X(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${X(this.J)}`)),this.rb()}$activateByEvent(G,U){return U===1?this.D.wait().then(ce=>this.Z(G,!1)):this.G.wait().then(ce=>this.Z(G,!1))}async $activate(G,U){return await this.G.wait(),this.J.getExtensionDescription(G)?(await this.$(G,U),!0):!1}async $deltaExtensions(G){G.toAdd.forEach(Z=>Z.extensionLocation=g.URI.revive(Z.extensionLocation));const{globalRegistry:U,myExtensions:ce}=de(this.I,this.L,this.J,G),be=await this.bb(ce);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(U.getAllExtensionDescriptions()),this.J.set(ce),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${X(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${X(this.J)}`)),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){const U=o.$ce.alloc(G),ce=Math.random()%256;for(let be=0;be<G;be++)U.writeUInt8(ce,be);return U}async $updateRemoteConnectionData(G){this.W=G,this.a.fire()}};e.$Udc=V,e.$Udc=V=q=He([Be(0,d.$Rh),Be(1,e.$Tdc),Be(2,h.$wM),Be(3,p.$ndc),Be(4,f.$qdc),Be(5,A.$aj),Be(6,u.$MM),Be(7,l.$Gdc),Be(8,D.$Mwb),Be(9,$.$Idc),Be(10,M.$Qdc),Be(11,O.$Rdc)],V);function de(pe,G,U,ce){pe.addActivationEvents(ce.addActivationEvents);const be=new s.$o5b(pe,G.getAllExtensionDescriptions());be.deltaExtensions(ce.toAdd,ce.toRemove);const H=new n.$0l(U.getAllExtensionDescriptions().map(Y=>Y.identifier));for(const Y of ce.myToRemove)H.delete(Y);for(const Y of ce.myToAdd)H.add(Y);const Z=ae(be,H);return{globalRegistry:be,myExtensions:Z}}function ee(pe,G){return{id:pe.identifier.value,name:pe.name,extensionVersion:pe.version,publisherDisplayName:pe.publisher,activationEvents:pe.activationEvents?pe.activationEvents.join(","):null,isBuiltin:pe.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}function X(pe){return pe.getAllExtensionDescriptions().map(G=>G.identifier.value).join(",")}e.$Vdc=(0,d.$Sh)("IExtHostExtensionService");class Q{#e;#t;#i;constructor(G,U,ce,be,H){this.#e=G,this.#t=U,this.#i=ce.identifier,this.id=ce.identifier.value,this.extensionUri=ce.extensionLocation,this.extensionPath=F.$gc((0,L.$kg)(ce.extensionLocation)),this.packageJSON=ce,this.extensionKind=be,this.isFromDifferentExtensionHost=H}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Wdc=Q;function ae(pe,G){return pe.getAllExtensionDescriptions().filter(U=>G.has(U.identifier))}class x{constructor(G){this.a=G}setSearchTree(G){this.a=G}findSubstr(G){return this.a.findSubstr(G)}forEach(G){return this.a.forEach(G)}}e.$Xdc=x;class se{constructor(G){this.a=new n.$$l,this.addActivationEvents(G)}readActivationEvents(G){return this.a.get(G.identifier)??[]}addActivationEvents(G){for(const U of Object.keys(G))this.a.set(U,G[U])}}}),define(ke[366],Se([1,0,56,2,6,42,25,26,20,27,5,47,15,13]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;let p=class{constructor(o,a,t,r,d,u,l){this.c=o,this.d=a,this.e=t,this.f=r,this.g=d,this.h=u,this.i=l,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new s(this.c,a,this.d,o,this.i)),this.register(this.e.createInstance(c)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,a,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const a of o.nodeModuleName)this.a.set(a,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(a=>o.alternativeModuleName(a))}};e.$jfc=p,e.$jfc=p=He([Be(2,A.$Rh),Be(3,L.$qdc),Be(4,P.$Vdc),Be(5,g.$MM),Be(6,f.$aj)],p);let c=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&S.a.size){const a=(0,y.$Ge)(this.c(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",r=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${d}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const a=this.b.exec(this.c(o));if(!a)return;const[,t,r,d]=a,u=S.a.get(r);if(u!==void 0)return console.warn(`${r} as been renamed to ${u}, please update your imports`),t+u+d}c(o){return o.replace(/\\/g,"/")}};c=S=He([Be(0,g.$MM)],c);class s{constructor(o,a,t,r,d){this.c=o,this.d=a,this.e=t,this.f=r,this.g=d,this.nodeModuleName="vscode",this.a=new w.$$l}load(o,a){const t=this.d.findSubstr(a);if(t){let r=this.a.get(t.identifier);return r||(r=this.c(t,this.e,this.f),this.a.set(t.identifier,r)),r}if(!this.b){let r="";this.d.forEach((d,u)=>r+=`	${u} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${r}`),this.b=this.c(R.$oF,this.e,this.f)}return this.b}}let i=class{constructor(o,a,t){this.e=o,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(m.$uK.MainThreadTelemetry);const r=t.getProxy(m.$uK.MainThreadWindow);this.c=(d,u)=>{const l=F.URI.parse(d);return u?this.g(d,u):l.scheme==="http"||l.scheme==="https"?r.$openUri(l,d,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this.f?r.$openUri(l,d,{}):this.g(d,u)}}load(o,a,t){const r=this.e.findSubstr(a);return r&&(this.a=r.identifier.value,this.h()),this.b=t(o),this.c}g(o,a){return this.i(),this.b(o,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=He([Be(2,E.$wM)],i)}),define(ke[58],Se([1,0,48,3,16,49,5,70,71,47,7,41,291,42]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=e.$rec=void 0,e.$rec=(0,R.$Sh)("IExtHostVariableResolverProvider");class S extends f.$xN{constructor(s,i,n,o,a,t,r){function d(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const l=o.tabGroups.all.find(h=>h.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof A.$cM||l.input instanceof A.$hM)return l.input.modified;if(l.input instanceof A.$bM||l.input instanceof A.$gM||l.input instanceof A.$eM)return l.input.uri}}}super({getFolderUri:u=>{const l=t.folders.filter(h=>h.name===u);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(u,l)=>a.getConfiguration(void 0,u).get(l),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=d();if(u)return m.$gc(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const u=d();if(u){const l=i.getWorkspaceFolder(u);if(l)return m.$gc(l.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>s.getExtension(u)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(L.env))}}let p=class extends F.$Rc{constructor(s,i,n,o,a){super(),this.b=s,this.c=i,this.g=n,this.h=o,this.j=a,this.a=new I.$U(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$sec=p,e.$sec=p=He([Be(0,g.$Vdc),Be(1,P.$ndc),Be(2,w.$HM),Be(3,y.$qdc),Be(4,E.$pec)],p)}),define(ke[96],Se([1,0,10,4,2,5,6,71,47,20,7,41,142,283,42,58]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=e.$wec=e.$vec=e.$uec=e.$tec=void 0,e.$tec=(0,L.$Sh)("IExtHostDebugService");let c=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,d,u,l,h,k){this.E=d,this.F=u,this.G=l,this.H=h,this.I=k,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$Od,this.n=new F.$Od,this.o=new F.$Od,this.u=new F.$Od,this.k=r.getProxy(R.$uK.MainThreadDebugService),this.y=new F.$Od,this.A=new F.$Od,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(D=>{D.onDidChange($=>{this.J(D)}),this.J(D)})}asDebugSourceUri(r,d){const u=r;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let l=`debug:${encodeURIComponent(u.path||"")}`,h="?";return d&&(l+=`${h}session=${encodeURIComponent(d.id)}`,h="&"),l+=`${h}ref=${u.sourceReference}`,m.URI.parse(l)}else{if(u.path)return m.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const d=[];for(const u of r.getAllExtensionDescriptions())if(u.contributes){const l=u.contributes.debuggers;if(l&&l.length>0)for(const h of l)(0,y.$IF)(h)&&d.push(h.type)}this.k.$registerDebugTypes(d)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(d=>r.push(d)),r}addBreakpoints(r){const d=r.filter(h=>{const k=h.id;return this.w.has(k)?!1:(this.w.set(k,h),!0)});this.U(d,[],[]);const u=[],l=new Map;for(const h of d)if(h instanceof A.$vL){let k=l.get(h.location.uri.toString());k||(k={type:"sourceMulti",uri:h.location.uri,lines:[]},l.set(h.location.uri.toString(),k),u.push(k)),k.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof A.$wL&&u.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(u)}removeBreakpoints(r){const d=r.filter(k=>this.w.delete(k.id));this.U([],d,[]);const u=d.filter(k=>k instanceof A.$vL).map(k=>k.id),l=d.filter(k=>k instanceof A.$wL).map(k=>k.id),h=d.filter(k=>k instanceof A.$xL).map(k=>k.id);return this.k.$unregisterBreakpoints(u,l,h)}startDebugging(r,d,u){return this.k.$startDebugging(r?r.uri:void 0,d,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,suppressSaveBeforeStart:u.suppressSaveBeforeStart,suppressDebugStatusbar:u.suppressDebugStatusbar??u.debugUI?.simple,suppressDebugToolbar:u.suppressDebugToolbar??u.debugUI?.simple,suppressDebugView:u.suppressDebugView??u.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,d,u){if(!d)return new A.$wK(()=>{});const l=this.d++;return this.f.push({type:r,handle:l,provider:d}),this.k.$registerDebugConfigurationProvider(r,u,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,l),new A.$wK(()=>{this.f=this.f.filter(h=>h.provider!==d),this.k.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(r,d,u){if(!u)return new A.$wK(()=>{});if(!this.Q(r,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.N(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this.g++;return this.h.push({type:d,handle:l,factory:u}),this.k.$registerDebugAdapterDescriptorFactory(d,l),new A.$wK(()=>{this.h=this.h.filter(h=>h.factory!==u),this.k.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(r,d){if(!d)return new A.$wK(()=>{});const u=this.i++;return this.j.push({type:r,handle:u,factory:d}),new A.$wK(()=>{this.j=this.j.filter(l=>l.factory!==d)})}async $runInTerminal(r,d){return Promise.resolve(void 0)}async $substituteVariables(r,d){let u;const l=await this.W(r);return l&&(u={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(u,d)}K(r,d){if(r.type==="implementation")return new o(r.implementation)}L(){}async $startDASession(r,d){const u=this,l=await this.V(d);return this.S(this.N(l.type),l).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const k=this.M(h),D=this.K(k,l);if(!D)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const $=D;return this.B.set(r,$),this.R(l).then(b=>(b&&this.C.set(r,b),$.onMessage(async v=>{if(v.type==="request"&&v.command==="handshake"){const C=v,N={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const z=await this.D.sign(C.arguments.value);N.body={signature:z},$.sendResponse(N)}else throw new Error("no signer")}catch(z){N.success=!1,N.message=z.message,$.sendResponse(N)}}else b&&b.onDidSendMessage&&b.onDidSendMessage(v),v=(0,y.$NF)(v,!0),u.k.$acceptDAMessage(r,v)}),$.onError(v=>{b&&b.onError&&b.onError(v),this.k.$acceptDAError(r,v.name,v.message,v.stack)}),$.onExit(v=>{b&&b.onExit&&b.onExit(v??void 0,void 0),this.k.$acceptDAExit(r,v??void 0,void 0)}),b&&b.onWillStartSession&&b.onWillStartSession(),$.startSession()))})}$sendDAMessage(r,d){d=(0,y.$MF)(d,!1);const u=this.C.get(r);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(d),this.B.get(r)?.sendMessage(d)}$stopDASession(r){const d=this.C.get(r);this.C.delete(r),d&&d.onWillStopSession&&d.onWillStopSession();const u=this.B.get(r);return this.B.delete(r),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const d=[],u=[],l=[];if(r.added)for(const h of r.added){const k=h.id;if(k&&!this.w.has(k)){let D;if(h.type==="function")D=new A.$wL(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")D=new A.$xL(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const $=m.URI.revive(h.uri);D=new A.$vL(new A.$IK($,new A.$xK(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,A.$tL)(D,k),this.w.set(k,D),d.push(D)}}if(r.removed)for(const h of r.removed){const k=this.w.get(h);k&&(this.w.delete(h),u.push(k))}if(r.changed){for(const h of r.changed)if(h.id){const k=this.w.get(h.id);if(k){if(k instanceof A.$wL&&h.type==="function"){const D=k;D.enabled=h.enabled,D.condition=h.condition,D.hitCondition=h.hitCondition,D.logMessage=h.logMessage,D.functionName=h.functionName}else if(k instanceof A.$vL&&h.type==="source"){const D=k;D.enabled=h.enabled,D.condition=h.condition,D.hitCondition=h.hitCondition,D.logMessage=h.logMessage,D.location=new A.$IK(m.URI.revive(h.uri),new A.$xK(h.line,h.character))}l.push(k)}}}this.U(d,u,l)}async $acceptStackFrameFocus(r){let d;const u=r.sessionId?await this.V(r.sessionId):void 0;if(!u)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?d=new A.$DL(u,r.threadId):d=new A.$CL(u,r.threadId,r.frameId),this.z=d,this.A.fire(this.z)}$provideDebugConfigurations(r,d,u){return(0,I.$Ng)(async()=>{const l=this.P(r);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(d);return l.provideDebugConfigurations(h,u)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(r,d,u,l){return(0,I.$Ng)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.W(d);return h.resolveDebugConfiguration(k,u,l)})}$resolveDebugConfigurationWithSubstitutedVariables(r,d,u,l){return(0,I.$Ng)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.W(d);return h.resolveDebugConfigurationWithSubstitutedVariables(k,u,l)})}async $provideDebugAdapter(r,d){const u=this.O(r);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.V(d);return this.S(u,l).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(r){const d=await this.V(r);this.m.fire(d)}async $acceptDebugSessionTerminated(r){const d=await this.V(r);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,d){(await this.V(r))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(r,d){const l={session:await this.V(r),event:d.event,body:d.body};this.u.fire(l)}M(r){if(r instanceof A.$yL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof A.$zL)return{type:"server",port:r.port,host:r.host};if(r instanceof A.$AL)return{type:"pipeServer",path:r.path};if(r instanceof A.$BL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const d=this.h.filter(u=>u.type===r);if(d.length>0)return d[0].factory}O(r){const d=this.h.filter(u=>u.handle===r);if(d.length>0)return d[0].factory}P(r){const d=this.f.filter(u=>u.handle===r);if(d.length>0)return d[0].provider}Q(r,d){if(r.contributes){const u=r.contributes.debuggers;if(u&&u.length>0){for(const l of u)if(l.label&&l.type&&l.type===d)return!0}}return!1}R(r){const u=r.configuration.type,l=this.j.filter(h=>h.type===u||h.type==="*").map(h=>(0,I.$Ng)(()=>h.factory.createDebugAdapterTracker(r)).then(k=>k,k=>null));return Promise.race([Promise.all(l).then(h=>{const k=h.filter(D=>!!D);if(k.length>0)return new n(k)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(r,d){const u=d.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new A.$zL(u));if(r){const h=await this.F.getExtensionRegistry();return(0,I.$Ng)(()=>r.createDebugAdapterDescriptor(d,this.T(d,h))).then(k=>{if(k)return k})}const l=await this.F.getExtensionRegistry();return Promise.resolve(this.T(d,l))}T(r,d){}U(r,d,u){(r.length>0||d.length>0||u.length>0)&&this.y.fire(Object.freeze({added:r,removed:d,changed:u}))}async V(r){if(r)if(typeof r=="string"){const d=this.l.get(r);if(d)return d}else{let d=this.l.get(r.id);if(!d){const u=await this.W(r.folderUri),l=r.parent?this.l.get(r.parent):void 0;d=new s(this.k,r.id,r.type,r.name,u,r.configuration,l),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(r){if(r){const d=m.URI.revive(r);return this.E.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};e.$uec=c,e.$uec=c=He([Be(0,g.$wM),Be(1,P.$ndc),Be(2,E.$Vdc),Be(3,S.$qdc),Be(4,w.$pec),Be(5,p.$rec)],c);class s{constructor(r,d,u,l,h,k,D){this.d=r,this.f=d,this.g=u,this.h=l,this.i=h,this.j=k,this.k=D}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,d){return this.d.$customDebugAdapterRequest(this.f,r,d)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$vec=s;class i{constructor(r){this.value=Object.freeze({append(d){r.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.$wec=i;class n{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(d=>d.onError?d.onError(r):void 0)}onExit(r,d){this.d.forEach(u=>u.onExit?u.onExit(r,d):void 0)}}class o extends f.$Hdb{constructor(r){super(),this.h=r,r.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends c{constructor(r,d,u,l,h,k){super(r,d,u,l,h,k)}};e.$xec=a,e.$xec=a=He([Be(0,g.$wM),Be(1,P.$ndc),Be(2,E.$Vdc),Be(3,S.$qdc),Be(4,w.$pec),Be(5,p.$rec)],a)}),define(ke[367],Se([1,0,11,56,2,6,355,15,106,107,27,249,20,67,47,90]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=e.$kfc=void 0;class c{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(w.$aj),t=n.get(f.$wM).getProxy(L.$uK.MainThreadErrors);I.setUnexpectedErrorHandler(r=>{o.error(r);const d=I.$2(r);t.$onUnexpectedError(d)})}static async installFullHandler(n){const o=n.get(w.$aj),a=n.get(f.$wM),t=n.get(S.$Vdc),r=n.get(p.$QM),d=a.getProxy(L.$uK.MainThreadExtensionService),u=a.getProxy(L.$uK.MainThreadErrors),l=await t.getExtensionPathIndex(),h=new WeakMap;function k(b,v){if(h.has(b))return h.get(b).stack;let C="",N,z;for(const T of v)C+=`
	at ${T.toString()}`,z=T.getFileName(),!N&&z&&(N=l.findSubstr(m.URI.file(z)));const M=`${b.name||"Error"}: ${b.message||""}${C}`;return h.set(b,{extensionIdentifier:N?.identifier,stack:M}),M}const D=Symbol("prepareStackTrace wrapped");let $=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return $},set(b){if(b===k||!b||b[D]){$=b||k;return}$=function(v,C){return k(v,C),b.call(Error,v,C)},Object.assign($,{[D]:!0})}}),I.setUnexpectedErrorHandler(b=>{o.error(b);const v=I.$2(b),C=h.get(b);if(!C?.extensionIdentifier){u.$onUnexpectedError(v);return}d.$onExtensionRuntimeError(C.extensionIdentifier,v);const N=r.onExtensionError(C.extensionIdentifier,b);o.trace("forwarded error to extension?",N,C)})}}e.$kfc=c;class s{constructor(n,o,a,t,r){this.a=a,this.b=new R.$w5b(n,null,t),o=s.e(o,this.b);const d=new g.$Qh(...(0,E.$Ar)());d.set(A.$MM,{_serviceBrand:void 0,...o,messagePorts:r}),d.set(f.$wM,new f.$xM(this.b)),d.set(y.$kdc,new y.$ldc(t)),d.set(S.$Tdc,a);const u=new P.$gq(d,!0);u.invokeFunction(c.installEarlyHandler),this.d=u.invokeFunction(l=>l.get(w.$aj)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=u.invokeFunction(l=>l.get(S.$Vdc)),this.c.initialize(),u.invokeFunction(c.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(L.$uK.MainThreadExtensionService);return m.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=m.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=m.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>m.URI.revive(o.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=m.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=m.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=m.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=m.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=m.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=m.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$lfc=s}),define(ke[368],Se([1,0,10,12,224,243,140,96,71,47,20,46,7,58,41,284,285,42]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=void 0;let i=class extends w.$uec{constructor(r,d,u,l,h,k,D){super(r,d,u,l,k,D),this.Z=h,this.X=new a}K(r,d){switch(r.type){case"server":return new p.$qfc(r);case"pipeServer":return new p.$rfc(r);case"executable":return new p.$sfc(r,d.type)}return super.K(r,d)}T(r,d){const u=p.$sfc.platformAdapterExecutable(d.getAllExtensionDescriptions(),r.type);if(u)return new f.$yL(u.command,u.args,u.options)}L(){return new R.$j9b}async $runInTerminal(r,d){if(r.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const u=await this.G.getConfigProvider(),l=this.Z.getDefaultShell(!0),h=this.Z.getDefaultShellArgs(!0),k=r.title||m.localize(0,null),D=JSON.stringify({shell:l,shellArgs:h});let $=await this.X.checkout(D,k),b,v=!1;if($)b=r.cwd;else{const M={shellPath:l,shellArgs:h,cwd:r.cwd,name:k,iconPath:new f.$qL("debug")};v=!0,$=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert($,D)}$.show(!0);const C=await $.processId;v?await new Promise(M=>setTimeout(M,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0||l.indexOf("cmd.exe")>=0?$.sendText("cls"):l.indexOf("bash")>=0?$.sendText("clear"):F.$i?$.sendText("cls"):$.sendText("clear"));const N=(0,c.$ufc)(l,r.args,!!r.argsCanBeInterpretedByShell,b,r.env);$.sendText(N);const z=this.onDidTerminateDebugSession(M=>{M.id===d&&(this.X.free($),z.dispose())});return C}else if(r.kind==="external")return o(r,await this.G.getConfigProvider());return super.$runInTerminal(r,d)}};e.$vfc=i,e.$vfc=i=He([Be(0,A.$wM),Be(1,S.$ndc),Be(2,g.$Vdc),Be(3,s.$qdc),Be(4,P.$Idc),Be(5,E.$pec),Be(6,y.$rec)],i);let n;function o(t,r){if(!n)if(F.$i)n=new L.$87b;else if(F.$j)n=new L.$97b;else if(F.$k)n=new L.$07b;else throw new Error("external terminals not supported on this platform");const d=r.getConfiguration("terminal");return n.runInTerminal(t.title,t.cwd,t.args,t.env||{},d.external||{})}class a{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,d){const l=[...this.b.entries()].map(([h,k])=>(0,I.$Ig)(async D=>{if(h.name!==d||k.lastUsedAt!==-1&&await(0,c.$tfc)(await h.processId))return null;const $=Date.now();return k.lastUsedAt+a.a>$||D.isCancellationRequested||k.config!==r?null:(k.lastUsedAt=$,h)}));return await(0,I.$Zg)(l,h=>!!h)}insert(r,d){this.b.set(r,{lastUsedAt:Date.now(),config:d})}free(r){const d=this.b.get(r);d&&(d.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(ke[369],Se([1,0,16,2,104,41,70,42,40,46,20,27,95,17,15,91,23,63,58]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;let n=class extends f.$mec{constructor(a,t,r,d,u,l,h,k,D){super(a,t,r,d,u,l,h,k),this.B=r,this.C=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const r=t;if(!t.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const d=f.TaskHandleDTO.from(r,this.B),u=await this.a.$getTaskExecution(d);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.y(u,t);return this.a.$executeTask(d).catch(()=>{}),l}else{const d=f.TaskDTO.from(t,a);if(d===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(d.execution)&&await this.x(d,t,!1);const u=await this.y(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),u}}u(a,t,r,d){const u=[];if(d)for(const l of d){this.z(l,r),(!l.definition||!a[l.definition.type])&&this.f.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const h=f.TaskDTO.from(l,r.extension);h&&(u.push(h),f.CustomExecutionDTO.is(h.execution)&&t.push(this.x(h,l,!0)))}return{tasks:u,extension:r.extension}}async v(a){return a}async F(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const r=F.URI.file((0,s.homedir)());t=new E.$ai({uri:r,name:c.$tg(r),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const r=F.URI.revive(a),d={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(r),l=await this.b.getWorkspaceFolders2()??[],h=await this.C.getResolver(),k=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(l);for(const D of t.variables)d.variables[D]=await h.resolveAsync(k,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(I.$sc);for(let $=0;$<D.length;$++)D[$]=await h.resolveAsync(k,D[$])}d.process=await m.win32.findExecutable(await h.resolveAsync(k,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(k,t.process.cwd):void 0,D)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,r){return m.win32.findExecutable(a,t,r)}};e.$nfc=n,e.$nfc=n=He([Be(0,A.$wM),Be(1,P.$MM),Be(2,L.$ndc),Be(3,R.$HM),Be(4,w.$qdc),Be(5,g.$Idc),Be(6,S.$aj),Be(7,p.$ddc),Be(8,i.$rec)],n)}),define(ke[370],Se([1,0,63,58]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;class m extends F.$sec{m(){return(0,I.homedir)()}}e.$6fc=m}),define(ke[156],Se([1,0,19,10,21,43,17,16,23,2,36]),function(me,e,I,F,m,L,R,w,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=e.$Bec=e.$Aec=e.$zec=void 0;class P{constructor(i,n,o,a){this.d=i,this.e=n,this.f=o,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,n){const o=this.d.folderQueries||[],a=new m.$Yd(n);return new Promise((t,r)=>{this.a=new y(i);let d=!1;const u=(l,h)=>{if(!d&&!this.b){const k=this.h(l);p(l)&&typeof this.d.maxResults=="number"&&this.c+k>this.d.maxResults&&(this.b=!0,d=!0,a.cancel(),l=this.j(l,this.d.maxResults-this.c));const D=this.h(l);this.c+=D,(D>0||!p(l))&&this.a.add(l,h)}};Promise.all(o.map((l,h)=>this.k(l,k=>u(k,h),a.token))).then(l=>{a.dispose(),this.a.flush();const h=l.some(k=>!!k&&!!k.limitHit);t({limitHit:this.b||h,messages:(0,I.$Qb)(l.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.g}})},l=>{a.dispose();const h=(0,L.$Di)(l);r(new Error(h))})})}h(i){return p(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const o=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:o.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,o){const a=new A.$_I(this.d,i),t=[],r={report:l=>{if(!this.l(l))return;const h=i.folder.scheme===R.Schemas.file?(0,A.$aJ)(()=>this.f.readdir(E.$vg(l.uri))):void 0,k=E.$yg(i.folder,l.uri);if(k){const D=a.includedInQuery(k,w.$mc(k),h);(0,F.$Hg)(D)?t.push(D.then($=>{$&&n(l)})):D&&n(l)}}},d=this.n(i),u=await this.e.provideTextSearchResults(f(this.d.contentPattern),d,r,o);return t.length&&await Promise.all(t),u}l(i){if(p(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,A.$$I)(this.d.includePattern,i.includePattern),o=(0,A.$$I)(this.d.excludePattern,i.excludePattern),a={folder:g.URI.from(i.folder),excludes:o,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$zec=P;function f(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class y{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new c(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!E.$pg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$Aec=y;function S(s){return p(s)?{preview:{matches:(0,I.$1b)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,I.$1b)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function p(s){return!!s.preview}e.$Bec=p;class c{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<c.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},c.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Cec=c}),define(ke[97],Se([1,0,3,6,5,363,20,67,15,2,156]),function(me,e,I,F,m,L,R,w,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=e.$Eec=e.$Dec=void 0,e.$Dec=(0,m.$Sh)("IExtHostSearch");let P=class{constructor(p,c,s){this.k=p,this.l=c,this.n=s,this.c=this.k.getProxy(F.$uK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$yec}o(p){return this.l.transformOutgoingScheme(p)}registerTextSearchProvider(p,c){if(this.g.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this.g.add(p);const s=this.d++;return this.e.set(s,c),this.c.$registerTextSearchProvider(s,this.o(p)),(0,I.$Pc)(()=>{this.g.delete(p),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(p,c){if(this.i.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this.i.add(p);const s=this.d++;return this.h.set(s,c),this.c.$registerFileSearchProvider(s,this.o(p)),(0,I.$Pc)(()=>{this.i.delete(p),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(p,c,s,i){const n=f(s),o=this.h.get(p);if(o)return this.j.fileSearch(n,o,a=>{this.c.$handleFileMatch(p,c,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+p)}async doInternalFileSearchWithCustomCallback(p,c,s){return{messages:[]}}$clearCache(p){return this.j.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,c,s,i){const n=this.e.get(p);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const o=f(s);return this.q(o,n).search(t=>this.c.$handleTextMatch(p,c,t),i)}$enableExtensionHostSearch(){}q(p,c){return new A.$zec(p,c,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$Eec=P,e.$Eec=P=He([Be(0,R.$wM),Be(1,w.$kdc),Be(2,E.$aj)],P);function f(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(y),extraFileResources:S.extraFileResources&&S.extraFileResources.map(p=>g.URI.revive(p))}}e.$Fec=f;function y(S){return{...S,folder:g.URI.revive(S.folder)}}}),define(ke[371],Se([1,0,21,11,4,39,2,133,80,172,191,31,6,114,315,314,35,316,42,318,319,320,295,321,70,47,323,324,329,330,331,154,299,336,337,340,118,46,342,300,14,7,87,345,93,153,41,26,289,328,66,151,95,96,97,15,67,20,27,362,286,73,91,307,343,92,72,348,346,347,308,57,341,344,117,71,90,332,94,333,17,137,298,274,326,3,25,282,115,268,334,335,309,325,297,327,116,338,312,339,313,306,322,310,311]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i,n,o,a,t,r,d,u,l,h,k,D,$,b,v,C,N,z,M,T,j,O,q,V,de,ee,X,Q,ae,x,se,pe,G,U,ce,be,H,Z,Y,$e,ne,fe,te,he,we,Pe,B,J,re,oe,_,ge,Ee,ze,We,_e,Xe,it,tt,Ae,Te,qe,Re,Ye,le,ue,Ie,Ke,Ue,Ze,nt,ct,bt,Et,Kt,Ht,pt,zt,Tt,Gt,Ut,Dt,Ft,Bt,Jt,Wt,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;function Nt(ut){const ft=ut.get(ne.$MM),At=ut.get(ze.$adc),Vt=ut.get(re.$Fdc),Lt=ut.get(u.$Vdc),at=ut.get(ae.$ndc),vt=ut.get(tt.$QM),Ot=ut.get(i.$qdc),Pt=ut.get(Y.$kdc),Ge=ut.get($e.$wM),Qt=ut.get(M.$Bdc),Me=ut.get(J.$Gdc),Oe=ut.get(Z.$bj),Ce=ut.get(Z.$aj),ie=ut.get(he.$Mwb),Fe=ut.get(we.$ddc),Ve=ut.get(Q.$hec),xe=ut.get(Xe.$Ndc),Je=ut.get(it.$pec),rt=ut.get(Tt.$Rdc);Ge.set(f.$vK.ExtHostFileSystemInfo,At),Ge.set(f.$vK.ExtHostLogLevelServiceShape,Oe),Ge.set(f.$vK.ExtHostWorkspace,at),Ge.set(f.$vK.ExtHostConfiguration,Ot),Ge.set(f.$vK.ExtHostExtensionService,Lt),Ge.set(f.$vK.ExtHostStorage,Qt),Ge.set(f.$vK.ExtHostTunnelService,ie),Ge.set(f.$vK.ExtHostWindow,Ve),Ge.set(f.$vK.ExtHostSecretState,xe),Ge.set(f.$vK.ExtHostTelemetry,vt),Ge.set(f.$vK.ExtHostEditorTabs,Je),Ge.set(f.$vK.ExtHostManagedSockets,rt);const kt=Ge.set(f.$vK.ExtHostDecorations,ut.get(U.$lec)),St=Ge.set(f.$vK.ExtHostDocumentsAndEditors,ut.get(d.$HM)),mt=Ge.set(f.$vK.ExtHostCommands,ut.get(c.$SM)),dt=Ge.set(f.$vK.ExtHostTerminalService,ut.get(T.$Idc)),gt=Ge.set(f.$vK.ExtHostDebugService,ut.get(be.$tec)),ui=Ge.set(f.$vK.ExtHostSearch,ut.get(H.$Dec)),Ct=Ge.set(f.$vK.ExtHostTask,ut.get(ce.$oec)),Di=Ge.set(f.$vK.ExtHostOutputService,ut.get(b.$4dc)),li=Ge.set(f.$vK.ExtHostLocalization,ut.get(nt.$Qdc)),$i=Ge.set(f.$vK.ExtHostUrls,new ee.$aec(Ge)),It=Ge.set(f.$vK.ExtHostDocuments,new r.$$cc(Ge,St)),gn=Ge.set(f.$vK.ExtHostDocumentContentProviders,new a.$sdc(Ge,St,Ce)),ri=Ge.set(f.$vK.ExtHostDocumentSaveParticipant,new t.$tdc(Ce,It,Ge.getProxy(f.$uK.MainThreadBulkEdits))),yt=Ge.set(f.$vK.ExtHostNotebook,new fe.$Jec(Ge,mt,St,It,Vt,ui)),bi=Ge.set(f.$vK.ExtHostNotebookDocuments,new ue.$2ec(yt)),wi=Ge.set(f.$vK.ExtHostNotebookEditors,new le.$1ec(Ce,yt)),si=Ge.set(f.$vK.ExtHostNotebookKernels,new Ae.$Xec(Ge,ft,yt,mt,Ce)),Ci=Ge.set(f.$vK.ExtHostNotebookRenderers,new qe.$Zec(Ge,yt)),Ii=Ge.set(f.$vK.ExtHostNotebookDocumentSaveParticipant,new pt.$8ec(Ce,yt,Ge.getProxy(f.$uK.MainThreadBulkEdits))),Rt=Ge.set(f.$vK.ExtHostEditors,new j.$$dc(Ge,St)),pi=Ge.set(f.$vK.ExtHostTreeViews,new O.$_dc(Ge.getProxy(f.$uK.MainThreadTreeViews),mt,Ce)),Pi=Ge.set(f.$vK.ExtHostEditorInsets,new se.$iec(Ge.getProxy(f.$uK.MainThreadEditorInsets),Rt,ft.remote)),oi=Ge.set(f.$vK.ExtHostDiagnostics,new n.$cdc(Ge,Ce,At,St)),hi=Ge.set(f.$vK.ExtHostLanguages,new D.$1dc(Ge,It,mt.converter,Pt)),lt=Ge.set(f.$vK.ExtHostLanguageFeatures,new k.$gdc(Ge,Pt,It,mt,oi,Ce,Fe,vt)),Ai=Ge.set(f.$vK.ExtHostFileSystem,new l.$Ydc(Ge,lt)),Zt=Ge.set(f.$vK.ExtHostFileSystemEventService,new h.$Zdc(Ge,Ce,St)),ii=Ge.set(f.$vK.ExtHostQuickOpen,(0,C.$6dc)(Ge,at,mt)),Li=Ge.set(f.$vK.ExtHostSCM,new N.$8dc(Ge,mt,It,Ce)),Ri=Ge.set(f.$vK.ExtHostQuickDiff,new Et.$5ec(Ge,Pt)),Mi=Ge.set(f.$vK.ExtHostShare,new Gt.$0ec(Ge,Pt)),Xi=Ge.set(f.$vK.ExtHostComments,(0,s.$jdc)(Ge,mt,It)),Fi=Ge.set(f.$vK.ExtHostProgress,new v.$5dc(Ge.getProxy(f.$uK.MainThreadProgress))),Yi=Ge.set(f.$vK.ExtHosLabelService,new pe.$jec(Ge)),Oi=Ge.set(f.$vK.ExtHostTheming,new te.$Kec(Ge)),ai=Ge.set(f.$vK.ExtHostAuthentication,new Pe.$Lec(Ge)),mn=Ge.set(f.$vK.ExtHostTimeline,new B.$Nec(Ge,mt)),Ti=Ge.set(f.$vK.ExtHostWebviews,new X.$dec(Ge,ft.remote,at,Ce,Fe)),di=Ge.set(f.$vK.ExtHostWebviewPanels,new ge.$Pec(Ge,Ti,at)),Ni=Ge.set(f.$vK.ExtHostCustomEditors,new _.$Qec(Ge,It,Me,Ti,di)),$n=Ge.set(f.$vK.ExtHostWebviewViews,new oe.$Oec(Ge,Ti)),fi=Ge.set(f.$vK.ExtHostTesting,new We.$Sec(Ge,mt,St)),Zi=Ge.set(f.$vK.ExtHostUriOpeners,new _e.$Wec(Ge)),ji=Ge.set(f.$vK.ExtHostProfileContentHandlers,new bt.$4ec(Ge));Ge.set(f.$vK.ExtHostInteractive,new Ie.$3ec(Ge,yt,St,mt,Ce));const xi=Ge.set(f.$vK.ExtHostInlineChat,new Ht.$7ec(Ge,mt,It,Ce)),gi=Ge.set(f.$vK.ExtHostChatProvider,new Ut.$$ec(Ge,Ce)),_i=Ge.set(f.$vK.ExtHostChatAgents,new Wt.$dfc(Ge,gi,Ce)),bn=Ge.set(f.$vK.ExtHostChatAgents2,new qt.$efc(Ge,gi,Ce)),zi=Ge.set(f.$vK.ExtHostChatVariables,new Ft.$afc(Ge)),mi=Ge.set(f.$vK.ExtHostChat,new Kt.$6ec(Ge,Ce)),xt=Ge.set(f.$vK.ExtHostAiRelatedInformation,new Bt.$bfc(Ge)),vi=Ge.set(f.$vK.ExtHostAiEmbeddingVector,new Jt.$cfc(Ge)),en=Ge.set(f.$vK.ExtHostIssueReporter,new zt.$9ec(Ge)),Xt=Ge.set(f.$vK.ExtHostStatusBar,new z.$0dc(Ge,mt.converter)),yi=Ge.set(f.$vK.ExtHostSpeech,new Dt.$_ec(Ge)),tn=Object.values(f.$vK);Ge.assertRegistered(tn);const nn=new Ee.$Rec(Ge,St),rn=new p.$idc(Ge),Ei=new $.$2dc(Ge,Ce),sn=new o.$rdc(Ge);return S.$hdc.register(mt),function(je,_t,on){const $t=function(){let ve=!je.isUnderDevelopment;function De(){ve||(Ce.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ve=!0)}return function Ne(st){if(Array.isArray(st))st.forEach(Ne);else if(typeof st=="string")De();else{const wt=st;typeof wt.scheme>"u"&&De(),typeof wt.exclusive=="boolean"&&(0,Ue.$uF)(je,"documentFiltersExclusive")}return st}}(),Ui={getSession(ve,De,Ne){return ai.getSession(je,ve,De,Ne)},getSessions(ve,De){return(0,Ue.$uF)(je,"authGetSessions"),ai.getSessions(je,ve,De)},async hasSession(ve,De){return(0,Ue.$uF)(je,"authSession"),!!await ai.getSession(je,ve,De,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(ve,De,Ne,st){return ai.registerAuthenticationProvider(ve,De,Ne,st)}},an={registerCommand(ve,De,Ne){return mt.registerCommand(!0,ve,De,Ne,void 0,je)},registerTextEditorCommand(ve,De,Ne){return mt.registerCommand(!0,ve,(...st)=>{const wt=Rt.getActiveTextEditor();if(!wt){Ce.warn("Cannot execute "+ve+" because there is no active text editor.");return}return wt.edit(Mt=>{De.apply(Ne,[wt,Mt,...st])}).then(Mt=>{Mt||Ce.warn("Edits from command "+ve+" were not applied.")},Mt=>{Ce.warn("An error occurred while running command "+ve,Mt)})},void 0,void 0,je)},registerDiffInformationCommand:(ve,De,Ne)=>((0,Ue.$uF)(je,"diffCommand"),mt.registerCommand(!0,ve,async(...st)=>{const wt=St.activeEditor(!0);if(!wt){Ce.warn("Cannot execute "+ve+" because there is no active text editor.");return}const Mt=await Rt.getDiffInformation(wt.id);De.apply(Ne,[Mt,...st])},void 0,void 0,je)),executeCommand(ve,...De){return mt.executeCommand(ve,...De)},getCommands(ve=!1){return mt.getCommands(ve)}},Bi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return dt.getDefaultShell(!1)},get onDidChangeShell(){return dt.onDidChangeShell},get isTelemetryEnabled(){return vt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return vt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ue.$uF)(je,"telemetry"),vt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ue.$uF)(je,"telemetry"),vt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,tt.$PM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(ve,De){return tt.$OM.validateSender(ve),vt.instantiateLogger(je,ve,De)},openExternal(ve,De){return Ve.openUri(ve,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:De?.allowContributedOpeners})},async asExternalUri(ve){if(ve.scheme===ft.environment.appUriScheme)return $i.createAppUri(ve);try{return await Ve.asExternalUri(ve,{allowTunneling:!!ft.remote.authority})}catch(De){if((0,Ye.$JU)(ve,Re.Schemas.http)||(0,Ye.$JU)(ve,Re.Schemas.https))return ve;throw De}},get remoteName(){return(0,G.$Yk)(ft.remote.authority)},get remoteAuthority(){return(0,Ue.$uF)(je,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return Ce.getLevel()},get onDidChangeLogLevel(){return Ce.onDidChangeLogLevel},registerIssueUriRequestHandler(ve){return(0,Ue.$uF)(je,"handleIssueUri"),en.registerIssueUriRequestHandler(je,ve)},registerIssueDataProvider(ve){return(0,Ue.$uF)(je,"handleIssueUri"),en.registerIssueDataProvider(je,ve)},get appQuality(){return(0,Ue.$uF)(je,"resolvers"),ft.quality},get appCommit(){return(0,Ue.$uF)(je,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Bi);const cn={createTestController(ve,De,Ne){return fi.createTestController(je,ve,De,Ne)},createTestObserver(){return(0,Ue.$uF)(je,"testObserver"),fi.createTestObserver()},runTests(ve){return(0,Ue.$uF)(je,"testObserver"),fi.runTests(ve)},get onDidChangeTestResults(){return(0,Ue.$uF)(je,"testObserver"),fi.onResultsChanged},get testResults(){return(0,Ue.$uF)(je,"testObserver"),fi.results}},ki=ft.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,wn={getExtension(ve,De){(0,Ue.$tF)(je,"extensionsAny")||(De=!1);const Ne=_t.mine.getExtensionDescription(ve);if(Ne)return new u.$Wdc(Lt,je.identifier,Ne,ki,!1);if(De){const st=_t.all.getExtensionDescription(ve);if(st)return new u.$Wdc(Lt,je.identifier,st,ki,!0)}},get all(){const ve=[];for(const De of _t.mine.getAllExtensionDescriptions())ve.push(new u.$Wdc(Lt,je.identifier,De,ki,!1));return ve},get allAcrossExtensionHosts(){(0,Ue.$uF)(je,"extensionsAny");const ve=new x.$0l(_t.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),De=[];for(const Ne of _t.all.getAllExtensionDescriptions()){const st=!ve.has(Ne.identifier);De.push(new u.$Wdc(Lt,je.identifier,Ne,ki,st))}return De},get onDidChange(){return(0,Ue.$tF)(je,"extensionsAny")?m.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},un={createDiagnosticCollection(ve){return oi.createDiagnosticCollection(je.identifier,ve)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:ve=>oi.getDiagnostics(ve),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(ve,De){return hi.changeLanguage(ve.uri,De)},match(ve,De){const Ne=It.getDocumentData(De.uri)?.notebook;return(0,A.$GE)(q.LanguageSelector.from(ve),De.uri,De.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(ve,De,Ne){return lt.registerCodeActionProvider(je,$t(ve),De,Ne)},registerDocumentPasteEditProvider(ve,De,Ne){return(0,Ue.$uF)(je,"documentPaste"),lt.registerDocumentPasteEditProvider(je,$t(ve),De,Ne)},registerCodeLensProvider(ve,De){return lt.registerCodeLensProvider(je,$t(ve),De)},registerDefinitionProvider(ve,De){return lt.registerDefinitionProvider(je,$t(ve),De)},registerDeclarationProvider(ve,De){return lt.registerDeclarationProvider(je,$t(ve),De)},registerImplementationProvider(ve,De){return lt.registerImplementationProvider(je,$t(ve),De)},registerTypeDefinitionProvider(ve,De){return lt.registerTypeDefinitionProvider(je,$t(ve),De)},registerHoverProvider(ve,De){return lt.registerHoverProvider(je,$t(ve),De,je.identifier)},registerEvaluatableExpressionProvider(ve,De){return lt.registerEvaluatableExpressionProvider(je,$t(ve),De,je.identifier)},registerInlineValuesProvider(ve,De){return lt.registerInlineValuesProvider(je,$t(ve),De,je.identifier)},registerDocumentHighlightProvider(ve,De){return lt.registerDocumentHighlightProvider(je,$t(ve),De)},registerLinkedEditingRangeProvider(ve,De){return lt.registerLinkedEditingRangeProvider(je,$t(ve),De)},registerReferenceProvider(ve,De){return lt.registerReferenceProvider(je,$t(ve),De)},registerRenameProvider(ve,De){return lt.registerRenameProvider(je,$t(ve),De)},registerDocumentSymbolProvider(ve,De,Ne){return lt.registerDocumentSymbolProvider(je,$t(ve),De,Ne)},registerWorkspaceSymbolProvider(ve){return lt.registerWorkspaceSymbolProvider(je,ve)},registerDocumentFormattingEditProvider(ve,De){return lt.registerDocumentFormattingEditProvider(je,$t(ve),De)},registerDocumentRangeFormattingEditProvider(ve,De){return lt.registerDocumentRangeFormattingEditProvider(je,$t(ve),De)},registerOnTypeFormattingEditProvider(ve,De,Ne,...st){return lt.registerOnTypeFormattingEditProvider(je,$t(ve),De,[Ne].concat(st))},registerDocumentSemanticTokensProvider(ve,De,Ne){return lt.registerDocumentSemanticTokensProvider(je,$t(ve),De,Ne)},registerDocumentRangeSemanticTokensProvider(ve,De,Ne){return lt.registerDocumentRangeSemanticTokensProvider(je,$t(ve),De,Ne)},registerSignatureHelpProvider(ve,De,Ne,...st){return typeof Ne=="object"?lt.registerSignatureHelpProvider(je,$t(ve),De,Ne):lt.registerSignatureHelpProvider(je,$t(ve),De,typeof Ne>"u"?[]:[Ne,...st])},registerCompletionItemProvider(ve,De,...Ne){return lt.registerCompletionItemProvider(je,$t(ve),De,Ne)},registerInlineCompletionItemProvider(ve,De,Ne){return De.handleDidShowCompletionItem&&(0,Ue.$uF)(je,"inlineCompletionsAdditions"),De.handleDidPartiallyAcceptCompletionItem&&(0,Ue.$uF)(je,"inlineCompletionsAdditions"),Ne&&(0,Ue.$uF)(je,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(je,$t(ve),De,Ne)},registerDocumentLinkProvider(ve,De){return lt.registerDocumentLinkProvider(je,$t(ve),De)},registerColorProvider(ve,De){return lt.registerColorProvider(je,$t(ve),De)},registerFoldingRangeProvider(ve,De){return lt.registerFoldingRangeProvider(je,$t(ve),De)},registerSelectionRangeProvider(ve,De){return lt.registerSelectionRangeProvider(je,ve,De)},registerCallHierarchyProvider(ve,De){return lt.registerCallHierarchyProvider(je,ve,De)},registerTypeHierarchyProvider(ve,De){return lt.registerTypeHierarchyProvider(je,ve,De)},setLanguageConfiguration:(ve,De)=>lt.setLanguageConfiguration(je,ve,De),getTokenInformationAtPosition(ve,De){return(0,Ue.$uF)(je,"tokenInformation"),hi.tokenAtPosition(ve,De)},registerInlayHintsProvider(ve,De){return lt.registerInlayHintsProvider(je,ve,De)},createLanguageStatusItem(ve,De){return hi.createLanguageStatusItem(je,ve,De)},registerDocumentDropEditProvider(ve,De,Ne){return lt.registerDocumentOnDropEditProvider(je,ve,De,(0,Ue.$tF)(je,"dropMetadata")?Ne:void 0)}},ln={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(ve,De,Ne){const st=await(R.URI.isUri(ve)?Promise.resolve(Si.openTextDocument(ve)):Promise.resolve(ve));return Rt.showTextDocument(st,De,Ne)},createTextEditorDecorationType(ve){return Rt.createTextEditorDecorationType(je,ve)},onDidChangeActiveTextEditor(ve,De,Ne){return Rt.onDidChangeActiveTextEditor(ve,De,Ne)},onDidChangeVisibleTextEditors(ve,De,Ne){return Rt.onDidChangeVisibleTextEditors(ve,De,Ne)},onDidChangeTextEditorSelection(ve,De,Ne){return Rt.onDidChangeTextEditorSelection(ve,De,Ne)},onDidChangeTextEditorOptions(ve,De,Ne){return Rt.onDidChangeTextEditorOptions(ve,De,Ne)},onDidChangeTextEditorVisibleRanges(ve,De,Ne){return Rt.onDidChangeTextEditorVisibleRanges(ve,De,Ne)},onDidChangeTextEditorViewColumn(ve,De,Ne){return Rt.onDidChangeTextEditorViewColumn(ve,De,Ne)},onDidCloseTerminal(ve,De,Ne){return dt.onDidCloseTerminal(ve,De,Ne)},onDidOpenTerminal(ve,De,Ne){return dt.onDidOpenTerminal(ve,De,Ne)},onDidChangeActiveTerminal(ve,De,Ne){return dt.onDidChangeActiveTerminal(ve,De,Ne)},onDidChangeTerminalDimensions(ve,De,Ne){return(0,Ue.$uF)(je,"terminalDimensions"),dt.onDidChangeTerminalDimensions(ve,De,Ne)},onDidChangeTerminalState(ve,De,Ne){return dt.onDidChangeTerminalState(ve,De,Ne)},onDidWriteTerminalData(ve,De,Ne){return(0,Ue.$uF)(je,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(ve,De,Ne)},onDidExecuteTerminalCommand(ve,De,Ne){return(0,Ue.$uF)(je,"terminalExecuteCommandEvent"),dt.onDidExecuteTerminalCommand(ve,De,Ne)},get state(){return Ve.getState(je)},onDidChangeWindowState(ve,De,Ne){return Ve.onDidChangeWindowState(ve,De,Ne)},showInformationMessage(ve,...De){return Ei.showMessage(je,L.default.Info,ve,De[0],De.slice(1))},showWarningMessage(ve,...De){return Ei.showMessage(je,L.default.Warning,ve,De[0],De.slice(1))},showErrorMessage(ve,...De){return Ei.showMessage(je,L.default.Error,ve,De[0],De.slice(1))},showQuickPick(ve,De,Ne){return ii.showQuickPick(je,ve,De,Ne)},showWorkspaceFolderPick(ve){return ii.showWorkspaceFolderPick(ve)},showInputBox(ve,De){return ii.showInput(ve,De)},showOpenDialog(ve){return sn.showOpenDialog(je,ve)},showSaveDialog(ve){return sn.showSaveDialog(ve)},createStatusBarItem(ve,De,Ne){let st,wt,Mt;return typeof ve=="string"?(st=ve,wt=De,Mt=Ne):(wt=ve,Mt=De),Xt.createStatusBarEntry(je,st,wt,Mt)},setStatusBarMessage(ve,De){return Xt.setStatusBarMessage(ve,De)},withScmProgress(ve){return Fe.report("window.withScmProgress",je,"Use 'withProgress' instead."),Fi.withProgress(je,{location:V.ProgressLocation.SourceControl},(De,Ne)=>ve({report(st){}}))},withProgress(ve,De){return Fi.withProgress(je,ve,De)},createOutputChannel(ve,De){return Di.createOutputChannel(ve,De,je)},createWebviewPanel(ve,De,Ne,st){return di.createWebviewPanel(je,ve,De,Ne,st)},createWebviewTextEditorInset(ve,De,Ne,st){return(0,Ue.$uF)(je,"editorInsets"),Pi.createWebviewEditorInset(ve,De,Ne,st,je)},createTerminal(ve,De,Ne){return typeof ve=="object"?"pty"in ve?dt.createExtensionTerminal(ve):dt.createTerminalFromOptions(ve):dt.createTerminal(ve,De,Ne)},registerTerminalLinkProvider(ve){return dt.registerLinkProvider(ve)},registerTerminalProfileProvider(ve,De){return dt.registerProfileProvider(je,ve,De)},registerTerminalQuickFixProvider(ve,De){return(0,Ue.$uF)(je,"terminalQuickFixProvider"),dt.registerTerminalQuickFixProvider(ve,je.identifier.value,De)},registerTreeDataProvider(ve,De){return pi.registerTreeDataProvider(ve,De,je)},createTreeView(ve,De){return pi.createTreeView(ve,De,je)},registerWebviewPanelSerializer:(ve,De)=>di.registerWebviewPanelSerializer(je,ve,De),registerCustomEditorProvider:(ve,De,Ne={})=>Ni.registerCustomEditorProvider(je,ve,De,Ne),registerFileDecorationProvider(ve){return kt.registerFileDecorationProvider(ve,je)},registerUriHandler(ve){return $i.registerUriHandler(je,ve)},createQuickPick(){return ii.createQuickPick(je)},createInputBox(){return ii.createInputBox(je)},get activeColorTheme(){return Oi.activeColorTheme},onDidChangeActiveColorTheme(ve,De,Ne){return Oi.onDidChangeActiveColorTheme(ve,De,Ne)},registerWebviewViewProvider(ve,De,Ne){return $n.registerWebviewViewProvider(je,ve,De,Ne?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ve,De,Ne){return yt.onDidChangeActiveNotebookEditor(ve,De,Ne)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ve,De,Ne){return wi.onDidChangeNotebookEditorSelection(ve,De,Ne)},onDidChangeNotebookEditorVisibleRanges(ve,De,Ne){return wi.onDidChangeNotebookEditorVisibleRanges(ve,De,Ne)},showNotebookDocument(ve,De){return yt.showNotebookDocument(ve,De)},registerExternalUriOpener(ve,De,Ne){return(0,Ue.$uF)(je,"externalUriOpener"),Zi.registerExternalUriOpener(je.identifier,ve,De,Ne)},registerProfileContentHandler(ve,De){return(0,Ue.$uF)(je,"profileContentHandlers"),ji.registrProfileContentHandler(je,ve,De)},registerQuickDiffProvider(ve,De,Ne,st){return(0,Ue.$uF)(je,"quickDiffProvider"),Ri.registerQuickDiffProvider($t(ve),De,Ne,st)},get tabGroups(){return Je.tabGroups},registerShareProvider(ve,De){return(0,Ue.$uF)(je,"shareProvider"),Mi.registerShareProvider($t(ve),De)}},Si={get rootPath(){return Fe.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),at.getPath()},set rootPath(ve){throw new F.$8("rootPath")},getWorkspaceFolder(ve){return at.getWorkspaceFolder(ve)},get workspaceFolders(){return at.getWorkspaceFolders()},get name(){return at.name},set name(ve){throw new F.$8("name")},get workspaceFile(){return at.workspaceFile},set workspaceFile(ve){throw new F.$8("workspaceFile")},updateWorkspaceFolders:(ve,De,...Ne)=>at.updateWorkspaceFolders(je,ve,De||0,...Ne),onDidChangeWorkspaceFolders:function(ve,De,Ne){return at.onDidChangeWorkspace(ve,De,Ne)},asRelativePath:(ve,De)=>at.getRelativePath(ve,De),findFiles:(ve,De,Ne,st)=>at.findFiles(ve,De,Ne,je.identifier,st),findTextInFiles:(ve,De,Ne,st)=>{(0,Ue.$uF)(je,"findTextInFiles");let wt,Mt;return typeof De=="object"?(wt=De,Mt=Ne):(wt={},Mt=De,st=Ne),at.findTextInFiles(ve,wt||{},Mt,je.identifier,st)},save:ve=>((0,Ue.$uF)(je,"saveEditor"),at.save(ve)),saveAs:ve=>((0,Ue.$uF)(je,"saveEditor"),at.saveAs(ve)),saveAll:ve=>at.saveAll(ve),applyEdit(ve,De){return nn.applyWorkspaceEdit(ve,je,De)},createFileSystemWatcher:(ve,De,Ne,st)=>{let wt;return typeof De=="boolean"?wt={ignoreCreateEvents:!!De,ignoreChangeEvents:!!Ne,ignoreDeleteEvents:!!st,correlate:!1}:De&&((0,Ue.$uF)(je,"createFileSystemWatcher"),wt={...De,correlate:!0}),Zt.createFileSystemWatcher(at,je,ve,wt)},get textDocuments(){return It.getAllDocumentData().map(ve=>ve.document)},set textDocuments(ve){throw new F.$8("textDocuments")},openTextDocument(ve){let De;const Ne=ve;if(typeof ve=="string")De=Promise.resolve(R.URI.file(ve));else if(R.URI.isUri(ve))De=Promise.resolve(ve);else if(!Ne||typeof Ne=="object")De=It.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return De.then(st=>It.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(ve,De,Ne)=>It.onDidAddDocument(ve,De,Ne),onDidCloseTextDocument:(ve,De,Ne)=>It.onDidRemoveDocument(ve,De,Ne),onDidChangeTextDocument:(ve,De,Ne)=>It.onDidChangeDocument(ve,De,Ne),onDidSaveTextDocument:(ve,De,Ne)=>It.onDidSaveDocument(ve,De,Ne),onWillSaveTextDocument:(ve,De,Ne)=>ri.getOnWillSaveTextDocumentEvent(je)(ve,De,Ne),get notebookDocuments(){return yt.notebookDocuments.map(ve=>ve.apiNotebook)},async openNotebookDocument(ve,De){let Ne;if(R.URI.isUri(ve))Ne=ve,await yt.openNotebookDocument(ve);else if(typeof ve=="string")Ne=R.URI.revive(await yt.createNotebookDocument({viewType:ve,content:De}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ve,De,Ne){return bi.onDidSaveNotebookDocument(ve,De,Ne)},onDidChangeNotebookDocument(ve,De,Ne){return bi.onDidChangeNotebookDocument(ve,De,Ne)},onWillSaveNotebookDocument(ve,De,Ne){return Ii.getOnWillSaveNotebookDocumentEvent(je)(ve,De,Ne)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(ve,De,Ne,st){return yt.registerNotebookSerializer(je,ve,De,Ne,(0,Ue.$tF)(je,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(ve,De,Ne)=>on.onDidChangeConfiguration(ve,De,Ne),getConfiguration(ve,De){return De=arguments.length===1?void 0:De,on.getConfiguration(ve,De,je)},registerTextDocumentContentProvider(ve,De){return gn.registerTextDocumentContentProvider(ve,De)},registerTaskProvider:(ve,De)=>(Fe.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(je,ve,De)),registerFileSystemProvider(ve,De,Ne){return(0,Ke.$Oc)(Ai.registerFileSystemProvider(je,ve,De,Ne),Vt.addFileSystemProvider(ve,De,Ne))},get fs(){return Vt.value},registerFileSearchProvider:(ve,De)=>((0,Ue.$uF)(je,"fileSearchProvider"),ui.registerFileSearchProvider(ve,De)),registerTextSearchProvider:(ve,De)=>((0,Ue.$uF)(je,"textSearchProvider"),ui.registerTextSearchProvider(ve,De)),registerRemoteAuthorityResolver:(ve,De)=>((0,Ue.$uF)(je,"resolvers"),Lt.registerRemoteAuthorityResolver(ve,De)),registerResourceLabelFormatter:ve=>((0,Ue.$uF)(je,"resolvers"),Yi.$registerResourceLabelFormatter(ve)),getRemoteExecServer:ve=>((0,Ue.$uF)(je,"resolvers"),Lt.getRemoteExecServer(ve)),onDidCreateFiles:(ve,De,Ne)=>Zt.onDidCreateFile(ve,De,Ne),onDidDeleteFiles:(ve,De,Ne)=>Zt.onDidDeleteFile(ve,De,Ne),onDidRenameFiles:(ve,De,Ne)=>Zt.onDidRenameFile(ve,De,Ne),onWillCreateFiles:(ve,De,Ne)=>Zt.getOnWillCreateFileEvent(je)(ve,De,Ne),onWillDeleteFiles:(ve,De,Ne)=>Zt.getOnWillDeleteFileEvent(je)(ve,De,Ne),onWillRenameFiles:(ve,De,Ne)=>Zt.getOnWillRenameFileEvent(je)(ve,De,Ne),openTunnel:ve=>((0,Ue.$uF)(je,"tunnels"),ie.openTunnel(je,ve).then(De=>{if(!De)throw new Error("cannot open tunnel");return De})),get tunnels(){return(0,Ue.$uF)(je,"tunnels"),ie.getTunnels()},onDidChangeTunnels:(ve,De,Ne)=>((0,Ue.$uF)(je,"tunnels"),ie.onDidChangeTunnels(ve,De,Ne)),registerPortAttributesProvider:(ve,De)=>((0,Ue.$uF)(je,"portsAttributes"),ie.registerPortsAttributesProvider(ve,De)),registerTunnelProvider:(ve,De)=>((0,Ue.$uF)(je,"tunnelFactory"),ie.registerTunnelProvider(ve,De)),registerTimelineProvider:(ve,De)=>((0,Ue.$uF)(je,"timeline"),mn.registerTimelineProvider(ve,De,je.identifier,mt.converter)),get isTrusted(){return at.trusted},requestWorkspaceTrust:ve=>((0,Ue.$uF)(je,"workspaceTrust"),at.requestWorkspaceTrust(ve)),onDidGrantWorkspaceTrust:(ve,De,Ne)=>at.onDidGrantWorkspaceTrust(ve,De,Ne),registerEditSessionIdentityProvider:(ve,De)=>((0,Ue.$uF)(je,"editSessionIdentityProvider"),at.registerEditSessionIdentityProvider(ve,De)),onWillCreateEditSessionIdentity:(ve,De,Ne)=>((0,Ue.$uF)(je,"editSessionIdentityProvider"),at.getOnWillCreateEditSessionIdentityEvent(je)(ve,De,Ne)),registerCanonicalUriProvider:(ve,De)=>((0,Ue.$uF)(je,"canonicalUriProvider"),at.registerCanonicalUriProvider(ve,De)),getCanonicalUri:(ve,De,Ne)=>((0,Ue.$uF)(je,"canonicalUriProvider"),at.provideCanonicalUri(ve,De,Ne))},Wi={get inputBox(){return Fe.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),Li.getLastInputBox(je)},createSourceControl(ve,De,Ne){return Li.createSourceControl(je,ve,De,Ne)}},qi={createCommentController(ve,De){return Xi.createCommentController(je,ve,De)}},ci={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},get stackFrameFocus(){return gt.stackFrameFocus},onDidStartDebugSession(ve,De,Ne){return gt.onDidStartDebugSession(ve,De,Ne)},onDidTerminateDebugSession(ve,De,Ne){return gt.onDidTerminateDebugSession(ve,De,Ne)},onDidChangeActiveDebugSession(ve,De,Ne){return gt.onDidChangeActiveDebugSession(ve,De,Ne)},onDidReceiveDebugSessionCustomEvent(ve,De,Ne){return gt.onDidReceiveDebugSessionCustomEvent(ve,De,Ne)},onDidChangeBreakpoints(ve,De,Ne){return gt.onDidChangeBreakpoints(ve,De,Ne)},onDidChangeStackFrameFocus(ve,De,Ne){return(0,Ue.$uF)(je,"debugFocus"),gt.onDidChangeStackFrameFocus(ve,De,Ne)},registerDebugConfigurationProvider(ve,De,Ne){return gt.registerDebugConfigurationProvider(ve,De,Ne||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ve,De){return gt.registerDebugAdapterDescriptorFactory(je,ve,De)},registerDebugAdapterTrackerFactory(ve,De){return gt.registerDebugAdapterTrackerFactory(ve,De)},startDebugging(ve,De,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?gt.startDebugging(ve,De,{parentSession:Ne}):gt.startDebugging(ve,De,Ne||{})},stopDebugging(ve){return gt.stopDebugging(ve)},addBreakpoints(ve){return gt.addBreakpoints(ve)},removeBreakpoints(ve){return gt.removeBreakpoints(ve)},asDebugSourceUri(ve,De){return gt.asDebugSourceUri(ve,De)}},Vi={registerTaskProvider:(ve,De)=>Ct.registerTaskProvider(je,ve,De),fetchTasks:ve=>Ct.fetchTasks(ve),executeTask:ve=>Ct.executeTask(je,ve),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(ve,De,Ne)=>Ct.onDidStartTask(ve,De,Ne),onDidEndTask:(ve,De,Ne)=>Ct.onDidEndTask(ve,De,Ne),onDidStartTaskProcess:(ve,De,Ne)=>Ct.onDidStartTaskProcess(ve,De,Ne),onDidEndTaskProcess:(ve,De,Ne)=>Ct.onDidEndTaskProcess(ve,De,Ne)},Ki={createNotebookController(ve,De,Ne,st,wt){return si.createNotebookController(je,ve,De,Ne,st,(0,Ue.$tF)(je,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ve,De)=>yt.registerNotebookCellStatusBarItemProvider(je,ve,De),createRendererMessaging(ve){return Ci.createRendererMessaging(je,ve)},createNotebookControllerDetectionTask(ve){return(0,Ue.$uF)(je,"notebookKernelSource"),si.createNotebookControllerDetectionTask(je,ve)},registerKernelSourceActionProvider(ve,De){return(0,Ue.$uF)(je,"notebookKernelSource"),si.registerKernelSourceActionProvider(je,ve,De)},onDidChangeNotebookCellExecutionState(ve,De,Ne){return(0,Ue.$uF)(je,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(ve,De,Ne)}},Hi={t(...ve){if(typeof ve[0]=="string"){const De=ve.shift(),Ne=!ve||typeof ve[0]!="object"?ve:ve[0];return li.getMessage(je.identifier.value,{message:De,args:Ne})}return li.getMessage(je.identifier.value,ve[0])},get bundle(){return li.getBundle(je.identifier.value)},get uri(){return li.getBundleUri(je.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(ve,De){return(0,Ue.$uF)(je,"interactive"),xi.registerProvider(je,ve,De={label:De?.label??je.displayName??je.name})},registerInteractiveSessionProvider(ve,De){return(0,Ue.$uF)(je,"interactive"),mi.registerChatProvider(je,ve,De)},sendInteractiveRequestToProvider(ve,De){return(0,Ue.$uF)(je,"interactive"),mi.sendInteractiveRequestToProvider(ve,De)},get onDidPerformUserAction(){return(0,Ue.$uF)(je,"interactiveUserActions"),mi.onDidPerformUserAction},transferChatSession(ve,De){return(0,Ue.$uF)(je,"interactive"),mi.transferChatSession(ve,De)}},hn={getRelatedInformation(ve,De){return(0,Ue.$uF)(je,"aiRelatedInformation"),xt.getRelatedInformation(je,ve,De)},registerRelatedInformationProvider(ve,De){return(0,Ue.$uF)(je,"aiRelatedInformation"),xt.registerRelatedInformationProvider(je,ve,De)},registerEmbeddingVectorProvider(ve,De){return(0,Ue.$uF)(je,"aiRelatedInformation"),vi.registerEmbeddingVectorProvider(je,ve,De)}},dn={registerChatResponseProvider(ve,De,Ne){return(0,Ue.$uF)(je,"chatProvider"),gi.registerProvider(je.identifier,ve,De,Ne)},requestChatAccess(ve){return(0,Ue.$uF)(je,"chatRequestAccess"),gi.requestChatResponseProvider(je.identifier,ve)},registerVariable(ve,De,Ne){return(0,Ue.$uF)(je,"chatVariables"),zi.registerVariableResolver(je,ve,De,Ne)},registerMappedEditsProvider(ve,De){return(0,Ue.$uF)(je,"mappedEditsProvider"),lt.registerMappedEditsProvider(je,ve,De)},createChatAgent(ve,De){return(0,Ue.$uF)(je,"chatAgents2"),bn.createChatAgent(je,ve,De)},registerAgent(ve,De,Ne){return(0,Ue.$uF)(je,"chatAgents"),_i.registerAgent(je.identifier,ve,De,Ne)}},fn={registerSpeechProvider(ve,De){return(0,Ue.$uF)(je,"speech"),yi.registerProvider(je.identifier,ve,De)}};return{version:ft.version,ai:hn,authentication:Ui,commands:an,comments:qi,chat:dn,debug:ci,env:Bi,extensions:wn,interactive:Gi,l10n:Hi,languages:un,notebooks:Ki,scm:Wi,speech:fn,tasks:Vi,tests:cn,window:ln,workspace:Si,Breakpoint:V.$uL,TerminalOutputAnchor:V.TerminalOutputAnchor,ChatAgentResultFeedbackKind:V.ChatAgentResultFeedbackKind,ChatMessage:V.$lM,ChatMessageRole:V.ChatMessageRole,ChatVariableLevel:V.ChatVariableLevel,CallHierarchyIncomingCall:V.$TK,CallHierarchyItem:V.$SK,CallHierarchyOutgoingCall:V.$UK,CancellationError:F.$4,CancellationTokenSource:I.$Yd,CandidatePortSource:f.CandidatePortSource,CodeAction:V.$PK,CodeActionKind:V.$QK,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.$VK,Color:V.$9K,ColorInformation:V.$0K,ColorPresentation:V.$$K,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentState:V.CommentState,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.$3K,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.$4K,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.$gL,DebugAdapterExecutable:V.$yL,DebugAdapterInlineImplementation:V.$BL,DebugAdapterNamedPipeServer:V.$AL,DebugAdapterServer:V.$zL,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.$KK,DiagnosticRelatedInformation:V.$JK,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.$wK,DocumentHighlight:V.$MK,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.$8K,DocumentSymbol:V.$OK,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.$EL,InlineValueText:V.$FL,InlineValueVariableLookup:V.$GL,InlineValueEvaluatableExpression:V.$HL,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:m.$Od,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.$RL,FileDecoration2:V.$RL,FileSystemError:V.$JL,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:V.$KL,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.$wL,InlineCompletionItem:V.$5K,InlineCompletionList:V.$6K,Hover:V.$LK,IndentAction:g.IndentAction,Location:V.$IK,MarkdownString:V.$WK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:V.$XK,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.$xK,ProcessExecution:V.$eL,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.$QL,Range:V.$yK,RelativePattern:V.$sL,Selection:V.$zK,SelectionRange:V.$RK,SemanticTokens:V.$NL,SemanticTokensBuilder:V.$ML,SemanticTokensEdit:V.$OL,SemanticTokensEdits:V.$PL,SemanticTokensLegend:V.$LL,ShellExecution:V.$fL,ShellQuoting:V.ShellQuoting,SignatureHelp:V.$ZK,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.$YK,SnippetString:V.$HK,SourceBreakpoint:V.$vL,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.$NK,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.$hL,TaskGroup:V.$dL,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.$_K,TerminalQuickFixExecuteTerminalCommand:V.$bL,TerminalQuickFixOpener:V.$aL,TerminalLocation:V.TerminalLocation,TerminalProfile:V.$cL,TerminalExitReason:V.TerminalExitReason,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.$DK,SnippetTextEdit:V.$FK,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,SyntaxTokenType:V.SyntaxTokenType,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.$rL,ThemeIcon:V.$qL,TreeItem:V.$iL,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.$aM,UIKind:y.UIKind,Uri:R.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.$GK,DocumentDropEdit:V.$oL,DocumentPasteEdit:V.$pL,InlayHint:V.$2K,InlayHintLabelPart:V.$1K,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.$CK,ResolvedAuthority:V.$AK,ManagedResolvedAuthority:V.$BK,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.$2L,NotebookRange:V.$TL,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.$UL,NotebookData:V.$VL,NotebookRendererScript:V.$ZL,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.$XL,NotebookCellOutputItem:V.$WL,NotebookCellStatusBarItem:V.$YL,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.$EK,NotebookKernelSourceAction:V.$1L,PortAttributes:V.$4L,LinkedEditingRanges:V.$3L,TestResultState:V.TestResultState,TestRunRequest:V.$5L,TestMessage:V.$6L,TestMessage2:V.$6L,TestTag:V.$7L,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:Te.TextSearchCompleteMessageType,DataTransfer:V.$nL,DataTransferItem:V.$jL,CoveredCount:V.$8L,FileCoverage:V.$9L,StatementCoverage:V.$0L,BranchCoverage:V.$$L,FunctionCoverage:V.$_L,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.$bM,TabInputTextDiff:V.$cM,TabInputTextMerge:V.$dM,TabInputCustom:V.$eM,TabInputNotebook:V.$gM,TabInputNotebookDiff:V.$hM,TabInputWebview:V.$fM,TabInputTerminal:V.$iM,TabInputInteractiveWindow:V.$jM,TabInputChat:V.$kM,TelemetryTrustedValue:de.$mo,LogLevel:Z.LogLevel,EditSessionIdentityMatch:ct.EditSessionIdentityMatch,InteractiveSessionVoteDirection:V.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:V.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:V.InteractiveEditorResponseFeedbackKind,StackFrameFocus:V.$CL,ThreadFocus:V.$DL,RelatedInformationType:V.RelatedInformationType,SpeechToTextStatus:V.SpeechToTextStatus}}}e.$ffc=Nt}),define(ke[372],Se([1,0,106,154,41,151,42,35,70,46,95,96,97,118,73,91,153,72,57,117,90,71,152,15,58,115,116]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i,n,o,a,t,r,d,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$zr)(u.$Qdc,u.$Pdc,1),(0,I.$zr)(r.$bj,t.$gfc,1),(0,I.$zr)(p.$ddc,p.$edc,1),(0,I.$zr)(w.$SM,w.$RM,0),(0,I.$zr)(R.$qdc,R.$odc,0),(0,I.$zr)(s.$Fdc,s.$Edc,0),(0,I.$zr)(P.$tec,P.$xec,0),(0,I.$zr)(L.$lec,L.$kec,0),(0,I.$zr)(E.$HM,E.$GM,0),(0,I.$zr)(l.$Rdc,l.$Sdc,0),(0,I.$zr)(i.$adc,i.$_cc,0),(0,I.$zr)(F.$4dc,F.$3dc,1),(0,I.$zr)(f.$Dec,f.$Eec,0),(0,I.$zr)(y.$Bdc,y.$Adc,0),(0,I.$zr)(A.$oec,A.$nec,0),(0,I.$zr)(g.$Idc,g.$Ldc,0),(0,I.$zr)(S.$Mwb,S.$Nwb,0),(0,I.$zr)(c.$hec,c.$gec,0),(0,I.$zr)(m.$ndc,m.$mdc,0),(0,I.$zr)(n.$Ndc,n.$Mdc,0),(0,I.$zr)(o.$QM,o.$NM,0),(0,I.$zr)(a.$pec,a.$qec,0),(0,I.$zr)(d.$rec,d.$sec,0)}),define(ke[119],Se([1,0,19,15,36,94]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=e.$xfc=e.$wfc=void 0;function R(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.$wfc=R;function w(P,f,y,S){const p=(0,I.$1b)(y,E),c=new m.$XI(f,p,S),s=c.preview.matches;return{ranges:(0,I.$1b)(p,g),uri:P,preview:{text:c.preview.text,matches:(0,I.$1b)(s,g)}}}e.$xfc=w;function E(P){return new m.$YI(P.start.line,P.start.character,P.end.line,P.end.character)}function g(P){return new L.$MI(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let A=class{constructor(f,y){this.a=f,this.b=y}appendLine(f){this.b.debug(`${this.a}#search`,f)}};e.$yfc=A,e.$yfc=A=He([Be(1,F.$aj)],A)}),define(ke[373],Se([1,0,50,16,77,33,12,13,119,374]),function(me,e,I,F,m,L,R,w,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=e.$Afc=e.$zfc=void 0;const A=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(n,o,a,t){const r=f(n,o,a,t),d=o.folder.fsPath;return{cmd:I.spawn(A,r.args,{cwd:d}),rgDiskPath:A,siblingClauses:r.siblingClauses,rgArgs:r,cwd:d}}e.$zfc=P;function f(n,o,a,t){const r=["--files","--hidden","--case-sensitive","--no-require-git"];S([o],a,!1).forEach(u=>{const l=(0,E.$wfc)(u);if(r.push("-g",l),R.$j){const h=(0,m.$sl)(l);h!==l&&r.push("-g",h)}});const d=y([o],t,void 0,!1);return d.globArgs.forEach(u=>{const l=`!${(0,E.$wfc)(u)}`;if(r.push("-g",l),R.$j){const h=(0,m.$sl)(l);h!==l&&r.push("-g",h)}}),o.disregardIgnoreFiles!==!1?r.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),o.ignoreSymlinks||r.push("--follow"),n.exists&&r.push("--quiet"),r.push("--no-config"),o.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:d.siblingClauses}}function y(n,o,a,t=!0){const r=[];let d={};return n.forEach(u=>{const l=Object.assign({},u.excludePattern||{},o||{}),h=p(l,t?u.folder.fsPath:void 0,a);r.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:r,siblingClauses:d}}function S(n,o,a=!0){const t=[];return n.forEach(r=>{const d=Object.assign({},o||{},r.includePattern||{}),u=p(d,a?r.folder.fsPath:void 0);t.push(...u.globArgs)}),t}function p(n,o,a){const t=[],r={};return Object.keys(n).forEach(d=>{if(a&&a.has(d)||!d)return;const u=n[d];d=s(o?c(o,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof u=="boolean"&&u?(d.startsWith("\\\\")&&(d+="**"),t.push(i(d))):u&&u.when&&(r[d]=u)}),{globArgs:t,siblingClauses:r}}function c(n,o){return F.$hc(o)?o:F.$ic(n,o)}e.$Afc=c;function s(n){return n=w.$Le(n,"\\"),w.$Le(n,"/")}function i(n){return L.$Uf(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$Bfc=i}),define(ke[375],Se([1,0,50,55,16,376,19,43,34,77,33,12,37,13,18,30,36,373,130]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=e.$Cfc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(d=>d())});class o{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&E.$zj(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Bq)(this.b).normalizedLowercase),this.u=u.excludePattern&&E.$zj(u.excludePattern),this.t=new Map,u.folderQueries.forEach(l=>{const h=Object.assign({},l.excludePattern||{},this.a.excludePattern||{}),k=l.folder.fsPath;u.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==k).forEach(D=>{(0,A.$Yf)(D,k)&&(h[m.$kc(k,D)]=!0)}),this.t.set(k,new t(h,k))})}cancel(){this.l=!0,n.forEach(u=>u())}walk(u,l,h,k,D){if(this.m=f.$Kd.create(!1),this.l)return D(null,this.j);l.forEach($=>{const b=m.$mc($.fsPath);this.u&&this.u($.fsPath,b)||this.J(h,{relativePath:$.fsPath,searchPath:void 0})}),this.r=f.$Kd.create(!1),this.w(u,($,b)=>{this.x(this.y,this,$,h,k,v=>{if(v){const C=(0,w.$Di)(v);console.error(C),this.q.push(C),b(v,void 0)}else b(null,void 0)})},($,b)=>{this.m.stop();const v=$?R.$Gb($)[0]:null;D(v,this.j)})}w(u,l,h){const k=new Array(u.length),D=new Array(u.length);let $=!1,b=0;if(u.length===0)return h(null,[]);u.forEach((v,C)=>{l(v,(N,z)=>{if(N?($=!0,k[C]=null,D[C]=N):(k[C]=z,D[C]=null),++b===u.length)return h($?D:null,k)})})}x(u,l,...h){try{u.apply(l,h)}catch(k){h[h.length-1](k)}}y(u,l,h,k){const D=u.folder.fsPath,$=P.$j,b=()=>M&&M.kill();n.add(b);let v=q=>{n.delete(b),v=()=>{},k(q)},C="";const N=this.D(),z=(0,s.$zfc)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),M=z.cmd,T=!Object.keys(z.siblingClauses).length,j=z.rgArgs.args.map(q=>q.match(/^-/)?q:`'${q}'`).join(" ");let O=`${z.rgDiskPath} ${j}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),h({message:O}),this.s=0,this.z(M,"utf8",h,(q,V,de)=>{if(q){v(q);return}if(this.j){v();return}const X=(C+($?g.$rl(V||""):V)).split(`
`);if(de){const Q=X.length;X[Q-1]=X[Q-1].trim(),X[Q-1]||X.pop()}else C=X.pop()||"";if(X.length&&X[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=X.length,T){for(const Q of X)if(this.J(l,{base:D,relativePath:Q,searchPath:this.N(u,Q)}),this.j){b();break}(de||this.j)&&v();return}this.G(u,N,D,X,l),de&&(this.H(N,D,l),v())})}spawnFindCmd(u){const l=this.t.get(u.folder.fsPath),h=l.getBasenameTerms(),k=l.getPathTerms(),D=["-L","."];if(h.length||k.length){D.push("-not","(","(");for(const $ of h)D.push("-name",$),D.push("-o");for(const $ of k)D.push("-path",$),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),I.spawn("find",D,{cwd:u.folder.fsPath})}readStdout(u,l,h){let k="";this.z(u,l,()=>{},(D,$,b)=>{if(D){h(D);return}k+=$,b&&h(null,k)})}z(u,l,h,k){let D=(v,C,N)=>{(v||N)&&(D=()=>{},this.r?.stop()),k(v,C,N)},$=!1;u.stdout?(this.A(u.stdout,l,D),u.stdout.once("data",()=>$=!0)):h({message:"stdout is null"});let b;u.stderr?b=this.B(u.stderr):h({message:"stderr is null"}),u.on("error",v=>{D(v)}),u.on("close",v=>{let C;!$&&(C=this.C(b,l))&&r(C)?D(new Error(`command failed with error code ${v}: ${this.C(b,l)}`)):(this.g&&v===0&&(this.j=!0),D(null,"",!0))})}A(u,l,h){const k=new L.StringDecoder(l);return u.on("data",D=>{h(null,k.write(D))}),k}B(u){const l=[];return u.on("data",h=>{l.push(h)}),l}C(u,l){const h=new L.StringDecoder(l);return u.map(k=>h.write(k)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:l},h,k,D){k.indexOf(this.b)!==-1&&this.J(D,{base:h,relativePath:this.b,searchPath:this.N(u,this.b)});const $=b=>{const v=m.$mc(b),C=m.$lc(b);let N=l[C];N||(N=l[C]=[],$(C)),N.push({base:h,relativePath:b,basename:v,searchPath:this.N(u,b)})};k.forEach($)}H({rootEntries:u,pathToEntries:l},h,k){const D=this,$=this.t.get(h),b=this.b;function v(C){D.o++;const N=(0,c.$bJ)(()=>C.map(z=>z.basename));for(let z=0,M=C.length;z<M;z++){const T=C[z],{relativePath:j,basename:O}=T;if($.test(j,O,b!==O?N:void 0))continue;const q=l[j];if(q)v(q);else{if(D.p++,j===b)continue;D.J(k,T)}if(D.j)break}}v(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,l,h,k,D){const $=u.folder,b=(0,c.$bJ)(()=>h);this.w(h,(v,C)=>{if(this.l||this.j)return C(null);const N=l?[l,v].join(m.sep):v;if(this.t.get(u.folder.fsPath).test(N,v,this.a.filePattern!==v?b:void 0))return C(null);const z=[$.fsPath,N].join(m.sep);F.lstat(z,(M,T)=>{if(M||this.l||this.j)return C(null);this.L(z,T,(j,O)=>j||this.l||this.j?C(null):O.isDirectory()?(this.o++,this.M(z,T,(q,V)=>q||this.l||this.j||(V=V||"",this.v[V])?C(null):(this.v[V]=!0,p.Promises.readdir(z).then(de=>{if(this.l||this.j)return C(null);this.I(u,N,de,k,ee=>C(ee||null))},de=>{C(null)})))):(this.p++,N===this.b||this.h&&S.$Df(O.size)&&O.size>this.h||this.J(k,{base:$.fsPath,relativePath:N,searchPath:this.N(u,N)}),C(null,void 0)))})},v=>{const C=v&&R.$Gb(v);return D(C&&C.length>0?C[0]:void 0)})}J(u,l){this.K(l)&&(!this.d||this.d(l.relativePath,m.$mc(l.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(l))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,c.$9I)(u,this.c)}return!0}L(u,l,h){return l.isSymbolicLink()?F.stat(u,h):h(null,l)}M(u,l,h){return l.isSymbolicLink()?F.realpath(u,(k,D)=>k?h(k):h(null,D)):h(null,u)}N(u,l){return u.folderName?m.$ic(u.folderName,l):l}}e.$Cfc=o;class a{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new o(u)}search(u,l,h){this.c.walk(this.a,this.b,u,l,(k,D)=>{h(k,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Dfc=a;class t{constructor(u,l){this.expression=u,this.c=l,this.d(u)}d(u){let l,h;Object.keys(u).filter(k=>u[k]).forEach(k=>{m.$hc(k)?(l=l||E.$uj(),l[k]=u[k]):(h=h||E.$uj(),h[k]=u[k])}),this.a=l&&E.$zj(l,{trimForExclusions:!0}),this.b=h&&E.$zj(h,{trimForExclusions:!0})}test(u,l,h){return this.b&&this.b(u,l,h)||this.a&&this.a(m.$ic(this.c,u),l,h)}getBasenameTerms(){const u=[];return this.a&&u.push(...E.$Bj(this.a)),this.b&&u.push(...E.$Bj(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...E.$Cj(this.a)),this.b&&u.push(...E.$Cj(this.b)),u}}function r(d){const u=d.trim().split(`
`),l=u[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return y.$rf(u[u.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(ke[377],Se([1,0,98,22,186,21]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=e.$WC=e.$VC=e.$UC=e.$TC=e.DecodeStreamErrorKind=e.$SC=e.$RC=e.$QC=e.$PC=e.$OC=e.$NC=e.$MC=e.$LC=void 0,e.$LC="utf8",e.$MC="utf8bom",e.$NC="utf16be",e.$OC="utf16le";function R(l){return[e.$LC,e.$MC,e.$NC,e.$OC].some(h=>h===l)}e.$PC=R,e.$QC=[254,255],e.$RC=[255,254],e.$SC=[239,187,191];const w=512,E=512,g=512*8,A=512*128;var P;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class f extends Error{constructor(h,k){super(h),this.decodeStreamErrorKind=k}}e.$TC=f;class y{static async create(h){let k;if(h!==e.$LC)k=(await(0,m.$KC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(s(h));else{const D=new TextDecoder;k={write($){return D.decode($,{stream:!0})},end(){return D.decode()}}}return new y(k)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function S(l,h){const k=h.minBytesRequiredForDetection??h.guessEncoding?g:E;return new Promise((D,$)=>{const b=(0,I.$3d)(T=>T.join("")),v=[];let C=0,N;const z=new L.$Yd,M=async()=>{try{const T=await u({buffer:F.$ce.concat(v),bytesRead:C},h.guessEncoding);if(T.seemsBinary&&h.acceptTextOnly)throw new f("Stream is binary but only text is accepted for decoding",1);T.encoding=await h.overwriteEncoding(T.encoding),N=await y.create(T.encoding);const j=N.write(F.$ce.concat(v).buffer);b.write(j),v.length=0,C=0,D({stream:b,detected:T})}catch(T){z.cancel(),b.destroy(),$(T)}};(0,I.$7d)(l,{onData:async T=>{N?b.write(N.write(T.buffer)):(v.push(T),C+=T.byteLength,C>=k&&(l.pause(),await M(),setTimeout(()=>l.resume())))},onError:T=>b.error(T),onEnd:async()=>{N||await M(),b.end(N?.end())}},z.token)})}e.$UC=S;async function p(l,h,k){const $=(await(0,m.$KC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(s(h),k);let b=!1,v=!1;return{read(){if(v)return null;const C=l.read();if(typeof C!="string"){if(v=!0,!b&&k?.addBOM)switch(h){case e.$LC:case e.$MC:return F.$ce.wrap(Uint8Array.from(e.$SC));case e.$NC:return F.$ce.wrap(Uint8Array.from(e.$QC));case e.$OC:return F.$ce.wrap(Uint8Array.from(e.$RC))}const N=$.end();return N&&N.length>0?(b=!0,F.$ce.wrap(N)):null}return b=!0,F.$ce.wrap($.write(C))}}}e.$VC=p;async function c(l){return(await(0,m.$KC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(s(l))}e.$WC=c;function s(l){return l===e.$MC||l===null?e.$LC:l}e.$XC=s;function i(l,h){if(!l||h<e.$QC.length)return null;const k=l.readUInt8(0),D=l.readUInt8(1);if(k===e.$QC[0]&&D===e.$QC[1])return e.$NC;if(k===e.$RC[0]&&D===e.$RC[1])return e.$OC;if(h<e.$SC.length)return null;const $=l.readUInt8(2);return k===e.$SC[0]&&D===e.$SC[1]&&$===e.$SC[2]?e.$MC:null}e.$YC=i;const n=["ascii","utf-16","utf-32"];async function o(l){const h=await(0,m.$KC)("jschardet","dist/jschardet.min.js"),k=l.slice(0,A),D=r(k.buffer),$=h.detect(D);if(!$||!$.encoding)return null;const b=$.encoding.toLowerCase();return 0<=n.indexOf(b)?null:t($.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(l){const h=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[h]||h}function r(l){let h="";for(let k=0;k<l.length;k++)h+=String.fromCharCode(l[k]);return h}function d(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=l.match(/windows(\d+)/);return h?"windows-"+h[1]:l}}}e.$ZC=d;function u({buffer:l,bytesRead:h},k){let D=i(l,h),$=!1;if(D!==e.$NC&&D!==e.$OC&&l){let b=!0,v=!0,C=!1;for(let N=0;N<h&&N<w;N++){const z=N%2===1,M=l.readUInt8(N)===0;if(M&&(C=!0),b&&(z&&!M||!z&&M)&&(b=!1),v&&(z&&M||!z&&!M)&&(v=!1),M&&!b&&!v)break}C&&(b?D=e.$OC:v?D=e.$NC:$=!0)}return k&&!$&&!D&&l?o(l.slice(0,h)).then(b=>({seemsBinary:!1,encoding:b})):{seemsBinary:$,encoding:D}}e.$1C=u,e.$2C={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[157],Se([1,0,377,30,156]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;class L extends m.$zec{constructor(w,E,g=F,A="searchProcess"){super(w,E,{readdir:P=>g.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,I.$ZC)(P)},A)}}e.$Lfc=L}),define(ke[158],Se([1,0,50,393,376,19,74,34,16,13,2,36,94,394,374,119]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=e.$Jfc=e.$Ifc=e.$Hfc=e.$Gfc=e.$Ffc=e.$Efc=void 0;const c=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class s{constructor(v){this.a=v}provideTextSearchResults(v,C,N,z){return this.a.appendLine(`provideTextSearchResults ${v.pattern}, ${JSON.stringify({...C,folder:C.folder.toString()})}`),new Promise((M,T)=>{z.onCancellationRequested(()=>Q());const j=r(v,C),O=C.folder.fsPath,q=j.map(G=>G.match(/^-/)?G:`'${G}'`).join(" ");this.a.appendLine(`${c} ${q}
 - cwd: ${O}`);let V=I.spawn(c,j,{cwd:O});V.on("error",G=>{console.error(G),this.a.appendLine("Error: "+(G&&G.message)),T((0,P.$5I)(new P.$3I(G&&G.message,P.SearchErrorCode.rgProcessError)))});let de=!1;const ee=new o(C.maxResults,O,C.previewOptions);ee.on("result",G=>{de=!0,x="",N.report(G)});let X=!1;const Q=()=>{X=!0,V?.kill(),ee?.cancel()};let ae=!1;ee.on("hitLimit",()=>{ae=!0,Q()});let x="";V.stdout.on("data",G=>{ee.handleData(G),de||(x+=G)});let se=!1;V.stdout.once("data",()=>se=!0);let pe="";V.stderr.on("data",G=>{const U=G.toString();this.a.appendLine(U),pe.length+U.length<1e6&&(pe+=U)}),V.on("close",()=>{if(this.a.appendLine(se?"Got data from stdout":"No data from stdout"),this.a.appendLine(de?"Got result from parser":"No result from parser"),x&&this.a.appendLine(`Got data without result: ${x}`),this.a.appendLine(""),X)M({limitHit:ae});else{ee.flush(),V=null;let G;pe&&!se&&(G=i(pe))?T((0,P.$5I)(new P.$3I(G.message,G.code))):M({limitHit:ae})}})})}}e.$Efc=s;function i(b){const v=b.split(`
`),C=v[0].trim();if(v.some(z=>z.startsWith("regex parse error")))return new P.$3I(n(v),P.SearchErrorCode.regexParseError);const N=C.match(/grep config error: unknown encoding: (.*)/);if(N)return new P.$3I(`Unknown encoding: ${N[1]}`,P.SearchErrorCode.unknownEncoding);if(C.startsWith("error parsing glob"))return new P.$3I(C.charAt(0).toUpperCase()+C.substr(1),P.SearchErrorCode.globParseError);if(C.startsWith("the literal"))return new P.$3I(C.charAt(0).toUpperCase()+C.substr(1),P.SearchErrorCode.invalidLiteral);if(C.startsWith("PCRE2: error compiling pattern"))return new P.$3I(C,P.SearchErrorCode.regexParseError)}function n(b){const v=["Regex parse error"],C=b.filter(N=>N.startsWith("PCRE2:"));if(C.length>=1){const N=C[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const z=N.split(":")[1];v.push(":"+z)}}return v.join("")}class o extends F.EventEmitter{constructor(v,C,N){super(),this.g=v,this.h=C,this.j=N,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new m.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(v,C){return super.on(v,C),this}handleData(v){if(this.b)return;const C=typeof v=="string"?v:this.d.write(v);this.k(C)}k(v){let C=v.indexOf(`
`);const N=this.a+v;if(C>=0)C+=this.a.length;else{this.a=N;return}let z=0;for(;C>=0;)this.m(N.substring(z,C).trim()),z=C+1,C=N.indexOf(`
`,z);this.a=N.substring(z)}m(v){if(this.b||!v)return;let C;try{C=JSON.parse(v)}catch{throw new Error(`malformed line from rg: ${v}`)}if(C.type==="match"){const N=a(C.data.path),z=A.URI.file(E.$ic(this.h,N)),M=this.n(C.data,z);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(C.type==="context"){const N=a(C.data.path),z=A.URI.file(E.$ic(this.h,N));this.o(C.data,z).forEach(T=>this.p(T))}}n(v,C){const N=v.line_number-1,z=a(v.lines),M=Buffer.from(z);let T=0,j=0,O=N;v.submatches.length===0&&v.submatches.push(z.length?{start:0,end:1,match:{text:z[0]}}:{start:0,end:0,match:{text:""}});const q=(0,L.$Gb)(v.submatches.map((V,de)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ee=a(V.match),X=M.slice(T,V.start).toString(),Q=t(X),ae=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+j,x=t(ee),se=Q.numLines+O,pe=x.numLines+se,G=x.numLines>0?x.lastLineLength:x.lastLineLength+ae;return T=V.end,j=G,O=pe,new f.$MI(se,ae,pe,G)}));return(0,p.$xfc)(C,z,q,this.j)}o(v,C){const N=a(v.lines),z=v.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((M,T)=>({text:M,uri:C,lineNumber:z+T}))}p(v){this.emit("result",v)}}e.$Ffc=o;function a(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const v=/\n/g;let C=0,N=-1,z;for(;z=v.exec(b);)C++,N=z.index;const M=N>=0?b.length-N-1:b.length;return{numLines:C,lastLineLength:M}}function r(b,v){const C=["--hidden","--no-require-git"];C.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:z}=(0,R.$J)(v.includes,T=>T.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(z&&z.length){const T=new Set;z.forEach(j=>{T.add(j)}),C.push("-g","!*"),T.forEach(j=>{d(j).map(p.$wfc).forEach(O=>{C.push("-g",O)})})}N&&N.length&&N.forEach(T=>{C.push("-g",T)}),v.excludes.map(p.$wfc).forEach(T=>C.push("-g",`!${T}`)),v.maxFileSize&&C.push("--max-filesize",v.maxFileSize+""),v.useIgnoreFiles?v.useParentIgnoreFiles||C.push("--no-ignore-parent"):C.push("--no-ignore"),v.followSymlinks&&C.push("--follow"),v.encoding&&v.encoding!=="utf8"&&C.push("--encoding",v.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,g.$Ge)(b.pattern),b.isRegExp=!0),v.usePCRE2&&C.push("--pcre2"),C.push("--crlf"),b.isRegExp&&(b.pattern=u(b.pattern),C.push("--engine","auto"));let M;if(b.isWordMatch){const j=(0,g.$Oe)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");C.push("--regexp",j)}else if(b.isRegExp){let T=h(b.pattern);T=k(T),C.push("--regexp",T)}else M=b.pattern,C.push("--fixed-strings");return C.push("--no-config"),v.useGlobalIgnoreFiles||C.push("--no-ignore-global"),C.push("--json"),b.isMultiline&&C.push("--multiline"),v.beforeContext&&C.push("--before-context",v.beforeContext+""),v.afterContext&&C.push("--after-context",v.afterContext+""),C.push("--"),M&&C.push(M),C.push("."),C}e.$Gfc=r;function d(b){return $(b).flatMap(C=>{const N=(0,w.$xj)(C,"/");return N.map((z,M)=>N.slice(0,M+1).join("/"))})}function u(b){const v=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(v);)b=b.replace(v,"$1\\x{$2}");const C=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(C);)b=b.replace(C,"$1\\x{$2}");return b}e.$Hfc=u;const l=b=>b.type==="Assertion"&&b.kind==="lookbehind";function h(b){let v;try{v=new y.RegExpParser().parsePattern(b)}catch{return b}let C="",N=0;const z=(j,O,q)=>{C+=b.slice(N,j)+q,N=O},M=[];return new y.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const O=M[0];if(!O)z(j.start,j.end,"\\r?\\n");else if(!M.some(l))if(O.type==="CharacterClass")if(O.negate){const q=b.slice(O.start+2,j.start)+b.slice(j.end,O.end-1);O.parent?.type==="Quantifier"?z(O.start,O.end,q?`[^${q}]`:"."):z(O.start,O.end,"(?!\\r?\\n"+(q?`|[${q}]`:"")+")")}else{const q=b.slice(O.start+1,j.start)+b.slice(j.end,O.end-1);z(O.start,O.end,q===""?"\\r?\\n":`(?:[${q}]|\\r?\\n)`)}else O.type==="Quantifier"&&z(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){M.unshift(j)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(j){M.unshift(j)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(j){M.unshift(j)},onCharacterClassLeave(){M.shift()},onAssertionEnter(j){l(j)&&M.push(j)},onAssertionLeave(j){M[0]===j&&M.shift()}}).visit(v),C+=b.slice(N),C}e.$Ifc=h;function k(b){return b.replace(/\n/g,"\\r?\\n")}e.$Jfc=k;function D(b){let v=!1,C=!1,N="",z="";for(let M=0;M<b.length;M++){const T=b[M];switch(T){case"\\":C?(v?z+="\\"+T:N+="\\"+T,C=!1):C=!0;break;case"{":if(C)v?z+=T:N+=T,C=!1;else{if(v)return{strInBraces:N+"{"+z+"{"+b.substring(M+1)};v=!0}break;case"}":if(C)v?z+=T:N+=T,C=!1;else{if(v)return{fixedStart:N,strInBraces:z,fixedEnd:b.substring(M+1)};N+=T}break;default:v?z+=(C?"\\":"")+T:N+=(C?"\\":"")+T,C=!1;break}}return{strInBraces:N+(v?"{"+z:"")}}function $(b){const{fixedStart:v,strInBraces:C,fixedEnd:N}=D(b);if(v===void 0||N===void 0)return[C];let z=(0,w.$xj)(C,",");z.length||(z=[""]);const M=$(N);return z.flatMap(T=>{const j=v+T;return M.map(O=>j+O)})}e.$Kfc=$}),define(ke[378],Se([1,0,21,158,64,17]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=void 0;class R{constructor(g){this.b=g,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(g,A,P,f){const y=new F.$Efc(this.b);if(A.folder.scheme===L.Schemas.vscodeUserData){const S={...A,folder:A.folder.with({scheme:L.Schemas.file})},p=new m.$8u(c=>P.report({...c,uri:c.uri.with({scheme:A.folder.scheme})}));return this.c(f,c=>y.provideTextSearchResults(g,S,p,c))}else return this.c(f,S=>y.provideTextSearchResults(g,A,P,S))}async c(g,A){const P=w(g);this.a.add(P);const f=await A(P.token);return this.a.delete(P),f}d(){this.a.forEach(g=>g.cancel())}}e.$Ofc=R;function w(E){const g=new I.$Yd;return E.onCancellationRequested(()=>g.cancel()),g}}),define(ke[379],Se([1,0,30,158,157]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0;class L{constructor(E){this.a=E}search(E,g,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(y){A({message:y})}},f=new m.$Lfc(this.a,new F.$Efc(P),I);return new Promise((y,S)=>f.search(p=>{g(p.map(R))},E).then(p=>y({limitHit:p.limitHit,type:"success",stats:p.stats}),S))}}e.$Mfc=L;function R(w){return{path:w.resource&&w.resource.fsPath,results:w.results,numMatches:(w.results||[]).reduce((E,g)=>{if(g.ranges){const A=g;return E+(Array.isArray(A.ranges)?A.ranges.length:1)}else return E+1},0)}}}),define(ke[380],Se([1,0,19,10,11,4,130,16,37,2,31,36,375,379]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=void 0;class S{static{this.a=512}constructor(o="searchProcess"){this.d=o,this.b=Object.create(null)}fileSearch(o){let a;const t=s(o),r=new L.$Od({onDidAddFirstListener:()=>{a=(0,F.$Ig)(d=>this.doFileSearchWithEngine(f.$Dfc,t,u=>r.fire(u),d)),a.then(d=>r.fire(d),d=>r.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}textSearch(o){let a;const t=s(o),r=new L.$Od({onDidAddFirstListener:()=>{a=(0,F.$Ig)(d=>this.f(t,u=>r.fire(u),d)),a.then(d=>r.fire(d),d=>r.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}f(o,a,t){return o.maxFileSize=this.g().maxFileSize,new y.$Mfc(o).search(t,a,a)}g(){return{maxFileSize:16*A.$Jk.GB}}doFileSearch(o,a,t){return this.doFileSearchWithEngine(f.$Dfc,o,a,t)}doFileSearchWithEngine(o,a,t,r,d=S.a){let u=0;const l=k=>{Array.isArray(k)?(u+=k.length,t(k.map(D=>this.h(D)))):k.relativePath?(u++,t(this.h(k))):t(k)};if(a.sortByScore){let k=this.l(a,l,r);if(!k){const D=a.maxResults?Object.assign({},a,{maxResults:null}):a,$=new o(D);k=this.j($,a,t,l,r)}return new Promise((D,$)=>{k.then(([b,v])=>{const C=v.map(N=>this.h(N));this.o(C,t,d),D(b)},$)})}const h=new o(a);return this.r(h,l,d,r).then(k=>({limitHit:k.limitHit,type:"success",stats:{detailStats:k.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}h(o){return{path:o.base?(0,w.$ic)(o.base,o.relativePath):o.relativePath}}j(o,a,t,r,d){const u=new L.$Od;let l=(0,F.$Ig)(k=>{let D=[];const $=b=>{Array.isArray(b)?D=b:(r(b),u.fire(b))};return this.r(o,$,-1,k).then(b=>[b,D])}),h;if(a.cacheKey){h=this.k(a.cacheKey);const k={promise:l,event:u.event,resolved:!1};h.resultsToSearchCache[a.filePattern||""]=k,l.then(()=>{k.resolved=!0},D=>{delete h.resultsToSearchCache[a.filePattern||""]}),l=this.s(l)}return l.then(([k,D])=>{const $=h?h.scorerCache:Object.create(null),b=(typeof a.maxResults!="number"||a.maxResults>0)&&E.$Kd.create(!1);return this.n(a,D,$,d).then(v=>{const C=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:k.stats,sortingTime:C,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:v.length},messages:k.messages,limitHit:k.limitHit||typeof a.maxResults=="number"&&D.length>a.maxResults},v]})})}k(o){const a=this.b[o];return a||(this.b[o]=new p)}l(o,a,t){const r=o.cacheKey&&this.b[o.cacheKey];if(!r)return;const d=this.q(r,o.filePattern||"",a,t);if(d)return d.then(([u,l,h])=>{const k=E.$Kd.create(!1);return this.n(o,l,r.scorerCache,t).then(D=>{const $=k.elapsed(),b={fromCache:!0,detailStats:h,type:this.d,resultCount:l.length,sortingTime:$};return[{type:"success",limitHit:u.limitHit||typeof o.maxResults=="number"&&l.length>o.maxResults,stats:b},D]})})}n(o,a,t,r){const d=(0,R.$Bq)(o.filePattern||""),u=(h,k)=>(0,R.$Aq)(h,k,d,!0,c,t),l=typeof o.maxResults=="number"?o.maxResults:Number.MAX_VALUE;return I.$Fb(a,u,l,1e4,r)}o(o,a,t){if(t&&t>0)for(let r=0;r<o.length;r+=t)a(o.slice(r,r+t));else a(o)}q(o,a,t,r){const d=E.$Kd.create(!1),u=a.indexOf(w.sep)>=0;let l;for(const $ in o.resultsToSearchCache)if(a.startsWith($)){if(u&&$.indexOf(w.sep)<0&&$!=="")continue;const b=o.resultsToSearchCache[$];l={promise:this.s(b.promise),event:b.event,resolved:b.resolved};break}if(!l)return null;const h=d.elapsed(),k=E.$Kd.create(!1),D=l.event(t);return r&&r.onCancellationRequested(()=>{D.dispose()}),l.promise.then(([$,b])=>{if(r&&r.isCancellationRequested)throw(0,m.$5)();const v=[],C=(0,R.$Bq)(a).normalizedLowercase;for(const N of b)(0,P.$9I)(N,C)&&v.push(N);return[$,v,{cacheWasResolved:l.resolved,cacheLookupTime:h,cacheFilterTime:k.elapsed(),cacheEntryCount:b.length}]})}r(o,a,t,r){return new Promise((d,u)=>{let l=[];r?.onCancellationRequested(()=>o.cancel()),o.search(h=>{h&&(t?(l.push(h),t>0&&l.length>=t&&(a(l),l=[])):a(h))},h=>{a(h)},(h,k)=>{l.length&&a(l),h?u(h):d(k)})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}s(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return o.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return o.finally(a)}}}}e.$Nfc=S;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const c=new class{getItemLabel(n){return(0,w.$mc)(n.relativePath)}getItemDescription(n){return(0,w.$lc)(n.relativePath)}getItemPath(n){return n.relativePath}};function s(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>g.URI.revive(o))}}function i(n){return{...n,folder:g.URI.revive(n.folder)}}}),define(ke[381],Se([1,0,3,17,2,30,15,27,20,97,67,36,380,378,119,157]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=void 0;let c=class extends g.$Eec{constructor(i,n,o,a){super(i,o,a),this.s=L,this.t=-1,this.v=null,this.w=!1,this.x=new I.$Qc;const t=new S.$yfc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new y.$Ofc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$yfc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.file,new y.$Ofc(i))),this.x.add(this.z(F.Schemas.file,new f.$Nfc("fileSearchProvider")))}z(i,n){const o=this.d++;return this.v=n,this.t=o,this.c.$registerFileSearchProvider(o,this.o(i)),(0,I.$Pc)(()=>{this.v=null,this.c.$unregisterProvider(o)})}$provideFileSearchResults(i,n,o,a){const t=(0,g.$Fec)(o);return i===this.t?this.A(i,n,t,a):super.$provideFileSearchResults(i,n,o,a)}doInternalFileSearchWithCustomCallback(i,n,o){const a=t=>{if((0,P.$8I)(t)&&(t=[t]),Array.isArray(t)){o(t.map(r=>m.URI.file(r.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,n)}async A(i,n,o,a){return this.doInternalFileSearchWithCustomCallback(o,a,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new p.$Lfc(i,n,void 0,"textSearchProvider")}};e.$Pfc=c,e.$Pfc=c=He([Be(0,E.$wM),Be(1,w.$MM),Be(2,A.$kdc),Be(3,R.$aj)],c)}),define(ke[120],Se([1,0,395,62,63,396,22,11,4,3,16,12,32,82,83]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=void 0;class p{traceSocketEvent(b,v){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,v)}constructor(b,v=""){this.f=!0,this.debugLabel=v,this.socket=b,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,w.$Z)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(b){const v=C=>{this.traceSocketEvent("read",C),b(R.$ce.wrap(C))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(b){const v=C=>{b({type:0,hadError:C,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(b){const v=()=>{b()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(b){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",b),this.socket.write(b.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,w.$Z)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,w.$Z)(v)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((b,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),b();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),b()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$Hh=p;var c;(function($){$[$.MinHeaderByteSize=2]="MinHeaderByteSize",$[$.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(c||(c={}));var s;(function($){$[$.PeekHeader=1]="PeekHeader",$[$.ReadHeader=2]="ReadHeader",$[$.ReadBody=3]="ReadBody",$[$.Fin=4]="Fin"})(s||(s={}));class i extends g.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(b,v){this.socket.traceSocketEvent(b,v)}constructor(b,v,C,N){super(),this.f=this.B(new E.$Od),this.g=this.B(new E.$Od),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=b,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:C?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new n(this,v,C,N,this.f,(z,M)=>this.m(z,M))),this.B(this.a.onError(z=>{console.error(z),(0,w.$Z)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new S.$Ch,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this.f.event(b)}onClose(b){return this.g.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){let v=0;for(;v<b.byteLength;)this.a.writeMessage(b.slice(v,Math.min(v+262144,b.byteLength)),{compressed:!0,opcode:2}),v+=262144}m(b,{compressed:v,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",b);let N=2;b.byteLength<126?N+=0:b.byteLength<2**16?N+=2:N+=8;const z=R.$ce.alloc(N),M=v?64:0,T=C&15;if(z.writeUInt8(128|M|T,0),b.byteLength<126)z.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){z.writeUInt8(126,1);let j=1;z.writeUInt8(b.byteLength>>>8&255,++j),z.writeUInt8(b.byteLength>>>0&255,++j)}else{z.writeUInt8(127,1);let j=1;z.writeUInt8(0,++j),z.writeUInt8(0,++j),z.writeUInt8(0,++j),z.writeUInt8(0,++j),z.writeUInt8(b.byteLength>>>24&255,++j),z.writeUInt8(b.byteLength>>>16&255,++j),z.writeUInt8(b.byteLength>>>8&255,++j),z.writeUInt8(b.byteLength>>>0&255,++j)}this.socket.write(R.$ce.concat([z,b]))}end(){this.h=!0,this.socket.end()}n(b){if(b.byteLength!==0){for(this.b.acceptChunk(b);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const v=this.b.peek(this.j.readLen),C=v.readUInt8(0),N=(C&128)>>>7,z=(C&64)>>>6,M=C&15,T=v.readUInt8(1),j=(T&128)>>>7,O=T&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(O===126?2:0)+(O===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const v=this.b.read(this.j.readLen),C=v.readUInt8(1),N=(C&128)>>>7;let z=C&127,M=1;z===126?z=v.readUInt8(++M)*2**8+v.readUInt8(++M):z===127&&(z=v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M));let T=0;N&&(T=v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M)),this.j.state=3,this.j.readLen=z,this.j.mask=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const v=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",v),t(v,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",v),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Ih=i;class n extends g.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$ce.alloc(0)}constructor(b,v,C,N,z,M){super(),this.n=b,this.r=z,this.s=M,this.a=this.B(new E.$Od),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$Od),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new E.$Od),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new o(this.n,N,C,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(T=>this.a.fire(T))),this.B(this.f.onError(T=>this.a.fire(T)))):(this.b=null,this.f=null)}writeMessage(b,v){this.g.push({data:b,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:b,options:v}=this.g.shift();if(this.f&&v.compressed){const C=await this.w(this.f,b);this.s(C,v)}else this.s(b,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(b,v){return new Promise((C,N)=>{b.write(v),b.flush(z=>C(z))})}acceptFrame(b,v,C){this.h.push({data:b,isCompressed:v,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const b=this.h.shift();if(this.b&&b.isCompressed){const v=await this.C(this.b,b.data,b.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(b.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(b,v,C){return new Promise((N,z)=>{b.write(v),C&&b.write(R.$ce.fromByteArray([0,0,255,255])),b.flush(M=>N(M))})}}class o extends g.$Rc{get recordedInflateBytes(){return this.j?R.$ce.concat(this.f):R.$ce.alloc(0)}constructor(b,v,C,N){super(),this.h=b,this.j=v,this.a=this.B(new E.$Od),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(N),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(R.$ce.wrap(z))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(b){this.j&&this.f.push(b.clone()),this.h.traceSocketEvent("zlibInflateWrite",b),this.b.write(b.buffer)}flush(b){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const v=R.$ce.concat(this.g);this.g.length=0,b(v)})}}class a extends g.$Rc{constructor(b,v){super(),this.g=b,this.a=this.B(new E.$Od),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(R.$ce.wrap(C))})}write(b){this.g.traceSocketEvent("zlibDeflateWrite",b.buffer),this.b.write(b.buffer)}flush(b){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let v=R.$ce.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),b(v)})}}function t($,b){if(b===0)return;const v=$.byteLength>>>2;for(let j=0;j<v;j++){const O=$.readUInt32BE(j*4);$.writeUInt32BE(O^b,j*4)}const C=v*4,N=$.byteLength-C,z=b>>>24&255,M=b>>>16&255,T=b>>>8&255;N>=1&&$.writeUInt8($.readUInt8(C)^z,C),N>=2&&$.writeUInt8($.readUInt8(C+1)^M,C+1),N>=3&&$.writeUInt8($.readUInt8(C+2)^T,C+2)}e.$Jh=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function d(){const $=(0,f.$fg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${$}-sock`;const b=process.platform!=="darwin"&&e.$Jh?e.$Jh:(0,m.tmpdir)(),v=(0,A.$ic)(b,`vscode-ipc-${$}.sock`);return l(v),v}e.$Kh=d;function u($,b,v){const C=(0,I.createHash)("md5").update($).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${C}-${v}-${b}-sock`;const N=v.substr(0,4),z=b.substr(0,6),M=C.substr(0,8);let T;return process.platform!=="darwin"&&e.$Jh&&!process.env.VSCODE_PORTABLE?T=(0,A.$ic)(e.$Jh,`vscode-${M}-${N}-${z}.sock`):T=(0,A.$ic)($,`${N}-${z}.sock`),l(T),T}e.$Lh=u;function l($){const b=r[P.$u];typeof b=="number"&&$.length>=b&&console.warn(`WARNING: IPC handle "${$}" is longer than ${b} chars, try a shorter --user-data-dir`)}class h extends y.$wh{static b(b){const v=E.Event.fromNodeEventEmitter(b,"connection");return E.Event.map(v,C=>({protocol:new S.$Dh(new p(C,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(C,"close"))}))}constructor(b){super(h.b(b)),this.d=b}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Mh=h;function k($){return new Promise((b,v)=>{const C=(0,F.createServer)();C.on("error",v),C.listen($,()=>{C.removeListener("error",v),b(new h(C))})})}e.$Nh=k;function D($,b){return new Promise((v,C)=>{const N=(0,F.createConnection)($,()=>{N.removeListener("error",C),v(S.$Eh.fromSocket(new p(N,`ipc-client${b}`),b))});N.once("error",C)})}e.$Oh=D}),define(ke[382],Se([1,0,62,63,166,120,10,3,12,44,15,138,258,259,109,88,22]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h9b=e.$g9b=e.$f9b=e.$e9b=void 0;async function s(t,r,d,u,l){let h;for(let k=3;k&&(h?.dispose(),h=await new i(t,r,d,u,l).waitForReady(),!(l&&m.$ig[l]||!m.$ig[h.tunnelLocalPort]));k--);return h}class i extends w.$Rc{constructor(r,d,u,l,h){super(),this.m=d,this.n=h,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=I.createServer(),this.c=new R.$Tg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=l,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,d=(0,p.$hv)(this.m)?"0.0.0.0":"127.0.0.1";let u=await(0,m.$jg)(r,2,1e3,d),l=null;return this.b.listen(u,this.m),await this.c.wait(),l=this.b.address(),l||(u=0,this.b.listen(u,this.m),await this.c.wait(),l=this.b.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async r(r){r.pause();const d=(0,p.$fv)(this.tunnelRemoteHost)||(0,p.$hv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,f.$9k)(this.a,d,this.tunnelRemotePort),l=u.getSocket(),h=u.readEntireBuffer();u.dispose(),h.byteLength>0&&r.write(h.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),l.end()}),r.on("close",()=>l.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),l instanceof L.$Hh?l.socket.destroy():l.end()}),l instanceof L.$Hh?this.t(r,l):this.s(r,l),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),l.end()})}s(r,d){d.onClose(()=>r.destroy()),d.onEnd(()=>r.end()),d.onData(u=>r.write(u.buffer)),r.on("data",u=>d.write(c.$ce.wrap(u))),r.resume()}t(r,d){const u=d.socket;u.on("end",()=>r.end()),u.on("close",()=>r.end()),u.on("error",()=>{r.destroy()}),u.pipe(r),r.pipe(u)}}e.$e9b=i;let n=class extends p.$kv{constructor(r,d,u,l,h){super(d,h),this.u=r,this.v=u,this.w=l}isPortPrivileged(r){return(0,p.$iv)(r,this.l,E.OS,F.release())}s(r,d,u,l,h,k,D,$){const b=this.r(d,u);if(b)return++b.refcount,b.value;if((0,p.$cv)(r))return this.t(r,d,u,h,k,D,$);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${u} on local port ${h}.`);const v={commit:this.w.commit,quality:this.w.quality,addressProvider:r,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},C=s(v,l,d,u,h);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(d,u,C),C}}};e.$f9b=n,e.$f9b=n=He([Be(0,y.$3k),Be(1,A.$aj),Be(2,S.$6k),Be(3,P.$sj),Be(4,g.$mi)],n);let o=class extends n{constructor(r,d,u,l,h){super(r,d,u,l,h)}};e.$g9b=o,e.$g9b=o=He([Be(0,y.$3k),Be(1,A.$aj),Be(2,S.$6k),Be(3,P.$sj),Be(4,g.$mi)],o);let a=class extends w.$Rc{constructor(r,d,u,l,h){super(),this.b=r,this.c=d,this.f=u,this.g=l,this.h=h,this.a=new Map}async openTunnel(r,d,u,l,h,k,D,$,b){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${l} on local port ${k}.`),!this.a.has(r)){const v=new o(this.b,this.c,this.g,this.f,this.h);this.B(v),this.a.set(r,v),v.onTunnelClosed(async()=>{(await v.tunnels).length===0&&(v.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(d,u,l,h,k,D,$,b)}};e.$h9b=a,e.$h9b=a=He([Be(0,y.$3k),Be(1,A.$aj),Be(2,P.$sj),Be(3,S.$6k),Be(4,g.$mi)],a)}),define(ke[383],Se([1,0,120,278,55,35,2,15,40]),function(me,e,I,F,m,L,R,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=e.$XM=void 0;class g{constructor(f,y,S){this.b=f,this.c=y,this.f=S,this.a=F.createServer((p,c)=>this.h(p,c)),this.g().catch(p=>(y.error(p),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",f=>this.c.error(f))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(f,y){const S=(c,s)=>{y.writeHead(c,{"content-type":"application/json"}),y.end(JSON.stringify(s||null),i=>i&&this.c.error(i))},p=[];f.setEncoding("utf8"),f.on("data",c=>p.push(c)),f.on("end",async()=>{try{const c=JSON.parse(p.join(""));let s;switch(c.type){case"open":s=await this.i(c);break;case"openExternal":s=await this.j(c);break;case"status":s=await this.l(c);break;case"extensionManagement":s=await this.k(c);break;default:S(404,`Unknown message type: ${c.type}`);break}S(200,s)}catch(c){const s=c instanceof Error?c.message:JSON.stringify(c);S(500,s),this.c.error("Error while processing pipe request",c)}})}async i(f){const{fileURIs:y,folderURIs:S,forceNewWindow:p,diffMode:c,mergeMode:s,addMode:i,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:a,remoteAuthority:t}=f,r=[];if(Array.isArray(S))for(const h of S)try{r.push({folderUri:R.URI.parse(h)})}catch{}if(Array.isArray(y))for(const h of y)try{(0,E.$li)(h)?r.push({workspaceUri:R.URI.parse(h)}):r.push({fileUri:R.URI.parse(h)})}catch{}const d=a?R.URI.file(a):void 0,l={forceNewWindow:p,diffMode:c,mergeMode:s,addMode:i,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!d&&!i,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",r,l)}async j(f){for(const y of f.uris){const S=R.URI.parse(y),p=S.scheme==="file"?S:y;await this.b.executeCommand("_remoteCLI.openExternal",p)}}async k(f){const y=p=>p?.map(c=>/\.vsix$/i.test(c)?R.URI.parse(c):c),S={list:f.list,install:y(f.install),uninstall:y(f.uninstall),force:f.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(f){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&m.existsSync(this.f)&&m.unlinkSync(this.f)}}e.$XM=g;let A=class extends g{constructor(f,y){super(f,y,(0,I.$Kh)())}};e.$YM=A,e.$YM=A=He([Be(0,L.$SM),Be(1,w.$aj)],A)}),define(ke[384],Se([1,0,56,371,366,277,47,351,2,17,7,383,103,349,350]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=void 0;class p extends m.$jfc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(d,u,l){return d=t(d),i.a.has(d)?i.a.get(d).load(d,E.URI.file((0,f.$$p)(u.filename)),h=>o.apply(this,[h,u,l])):o.apply(this,arguments)};const a=n._resolveLookupPaths;n._resolveLookupPaths=(r,d)=>a.call(this,t(r),d);const t=r=>{for(const d of i.b){const u=d(r);if(u){r=u;break}}return r}}}class c extends R.$Udc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async tb(){this.h.createInstance(y.$Sfc);const i=this.h.invokeFunction(F.$ffc);if(this.h.createInstance(w.$Rfc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(P.$YM);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(S.$Tfc),await this.h.createInstance(p,i,{mine:this.J,all:this.L}).install(),I.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,L.$Qfc)(this.j,o,this,this.s,this.z,this.f),I.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,o){if(n.scheme!==g.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let a=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&I.mark(`code/extHost/willLoadExtensionCode/${t}`),a=me.__$__nodeRequire(n.fsPath)}finally{t&&I.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const o=i[n];o===null?delete process.env[n]:process.env[n]=o}}}e.$Ufc=c}),define(ke[385],Se([1,0,50,22,4,3,123,12,23,2,30,15,257,65,109,88,382,27,20,73,360]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=e.$2fc=e.$1fc=e.$Zfc=e.$Yfc=e.$Xfc=e.$Wfc=e.$Vfc=void 0;function a(b){const v=b.trim().split(`
`),C=[];return v.forEach(z=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);M&&M.length>=3&&C.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),C.reduce((z,M)=>(z[M.socket]=M,z),{})}e.$Vfc=a;function t(...b){const v=[].concat(...b.map(d));return[...new Map(v.filter(C=>C.st==="0A").map(C=>{const N=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:r(N[0]),port:parseInt(N[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}e.$Wfc=t;function r(b){let v="";if(b.length===8)for(let C=b.length-2;C>=0;C-=2)v+=parseInt(b.substr(C,2),16),C!==0&&(v+=".");else for(let C=0;C<b.length;C+=8){const N=b.substring(C,C+8);let z="";for(let M=8;M>=2;M-=2)z+=N.substring(M-2,M),(M===6||M===2)&&(z=parseInt(z,16).toString(16),v+=`${z}`,z="",C+M!==b.length-6&&(v+=":"))}return v}e.$Xfc=r;function d(b){const v=b.trim().split(`
`),C=v.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return v.map(z=>z.trim().split(/\s+/).reduce((M,T,j)=>(M[C[j]||j]=T,M),{}))}e.$Yfc=d;function u(b){return!!b.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||b.indexOf("out/server-main.js")!==-1||b.indexOf("_productName=VSCode")!==-1}function l(b){const v=b.trim().split(`
`),C=[];return v.forEach(N=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);z&&z.length>=4&&C.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),C}e.$Zfc=l;async function h(b,v,C){const N=C.reduce((M,T)=>(M[T.pid]=T,M),{}),z=[];return b.forEach(({socket:M,ip:T,port:j})=>{const O=v[M]?v[M].pid:void 0,q=O?N[O]?.cmd:void 0;O&&q&&!u(q)&&z.push({host:T,port:j,detail:q,pid:O})}),z}e.$1fc=h;function k(b,v,C){const N=new Map,z=l(v);for(const M of b){const T=C.get(M.port);if(T){N.set(M.port,T);continue}const j=z.find(O=>O.cmd.includes(`${M.port}`));if(j){let O=j,q;do q=z.find(V=>V.ppid===O.pid),q&&(O=q);while(q);N.set(M.port,{host:M.ip,port:M.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else N.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return N}e.$2fc=k;let D=class extends n.$Nwb{constructor(v,C,N,z){super(v,C,N),this.D=C,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,w.$k&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(v){if(v&&this.C)return;this.C=v;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new R.$Ul;let z=0;for(;this.C;){const M=new Date().getTime(),T=(await this.I()).filter(q=>(0,p.$fv)(q.host)||(0,p.$hv)(q.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(q=>q.port).join(", ")}`);const j=new Date().getTime()-M;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${j} ms.`),z++>3&&N.update(j),(!C||JSON.stringify(C)!==JSON.stringify(T))&&(C=T,await this.a.$onFoundNewCandidates(C));const O=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(q=>setTimeout(()=>q(),O))}}G(v){return Math.max(v*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(v=>v.port).join(", ")}`)}async I(){let v="",C="";try{v=await A.Promises.readFile("/proc/net/tcp","utf8"),C=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(v,C),z=await new Promise(ee=>{(0,I.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(X,Q,ae)=>{ee(Q)})}),M=a(z),T=await A.Promises.readdir("/proc"),j=[];for(const ee of T)try{const X=Number(ee),Q=E.$wg(g.URI.file("/proc"),ee);if((await A.Promises.stat(Q.fsPath)).isDirectory()&&!isNaN(X)){const x=await A.Promises.readlink(E.$wg(Q,"cwd").fsPath),se=await A.Promises.readFile(E.$wg(Q,"cmdline").fsPath,"utf8");j.push({pid:X,cwd:x,cmd:se})}}catch{}const O=[],q=N.filter(ee=>{const X=M[ee.socket];return X||O.push(ee),X}),V=h(q,M,j);let de;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const ee=await new Promise(X=>{(0,I.exec)("ps -F -A -l | grep root",(Q,ae,x)=>{X(ae)})});this.z=k(O,ee,this.z),de=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${de.map(X=>X.port).join(", ")}`)}return V.then(ee=>de?ee.concat(de):ee)}w(v){return async C=>{const N=new c.$e9b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(M,T,j,O){const q=await v.makeConnection();return $.connect(q,T,j,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Tk(0),connectionToken:v.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await N.waitForReady();const z=new m.$Od;return{localAddress:(0,o.$RJ)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{N.dispose(),z.fire(),z.dispose()}}}}};e.$3fc=D,e.$3fc=D=He([Be(0,i.$wM),Be(1,s.$MM),Be(2,P.$aj),Be(3,S.$6k)],D);class $ extends f.$4pb{static connect(v,C,N,z){const M=new L.$Qc,T={onClose:M.add(new m.$Od),onData:M.add(new m.$Od),onEnd:M.add(new m.$Od)};M.add(v.onDidReceiveMessage(O=>T.onData.fire(F.$ce.wrap(O)))),M.add(v.onDidEnd(()=>T.onEnd.fire())),M.add(v.onDidClose(O=>T.onClose.fire({type:0,error:O,hadError:!!O})));const j=new $(v,z,T);return j.B(M),(0,f.$3pb)(j,C,N,z,T)}constructor(v,C,N){super(C,N),this.n=v}write(v){this.n.send(v.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[386],Se([1,0,106,354,369,368,381,384,385,96,47,97,95,46,73,92,353,352,15,370,58,272,105,109,140]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s,i,n,o,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$zr)(A.$Vdc,w.$Ufc,0),(0,I.$zr)(i.$bj,s.$5fc,1),(0,I.$zr)(i.$aj,new t.$Ph(a.$ifc,[!1],!0)),(0,I.$zr)(r.$6k,d.$j9b,1),(0,I.$zr)(p.$Gdc,c.$4fc,0),(0,I.$zr)(g.$tec,L.$vfc,0),(0,I.$zr)(P.$Dec,R.$Pfc,0),(0,I.$zr)(f.$oec,m.$nfc,0),(0,I.$zr)(y.$Idc,F.$mfc,0),(0,I.$zr)(S.$Mwb,E.$3fc,0),(0,I.$zr)(o.$rec,n.$6fc,0)}),define(ke[397],Se([1,0,62,398,56,11,83,120,255,114,367,22,30,103,10,133,279,293,372,386]),function(me,e,I,F,m,L,R,w,E,g,A,P,f,y,S,p,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let h=0;h<process.execArgv.length;h++)process.execArgv[h]==="--inspect-port=0"&&(process.execArgv.splice(h,1),h--)}();const i=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const l=globalThis._VSCODE_NODE_MODULES.module,h=l._load;l._load=function(k){if(k==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return h.apply(this,arguments)}})();const n=process.exit.bind(process);function o(l){process.exit=function(h){if(l)n(h);else{const k=new Error("An extension called process.exit() and this was prevented.");console.warn(k.stack)}},process.crash=function(){const h=new Error("An extension called process.crash() and this was prevented.");console.warn(h.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let a=function(l){n()};function t(){const l=(0,s.$Em)(process.env);if(l.type===3)return new Promise((h,k)=>{const D=$=>{const b=$[0],v=new R.$Fh;b.on("message",C=>v.fire(P.$ce.wrap(C.data))),b.on("close",()=>{a("renderer closed the MessagePort")}),b.start(),h({onMessage:v.event,send:C=>b.postMessage(C.buffer)})};process.parentPort.on("message",$=>D($.ports))});if(l.type===2)return new Promise((h,k)=>{let D=null;const $=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=108e5,v=3e5,C=new S.$8g(()=>a("renderer disconnected for too long (1)"),b),N=new S.$8g(()=>a("renderer disconnected for too long (2)"),v);process.on("message",(M,T)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){T.setNoDelay(!0);const j=P.$ce.wrap(Buffer.from(M.initialDataChunk,"base64"));let O;if(M.skipWebSocketFrames)O=new w.$Hh(T,"extHost-socket");else{const q=P.$ce.wrap(Buffer.from(M.inflateBytes,"base64"));O=new w.$Ih(new w.$Hh(T,"extHost-socket"),M.permessageDeflate,q,!1)}D?(C.cancel(),N.cancel(),D.beginAcceptReconnection(O,j),D.endAcceptReconnection(),D.sendResume()):(clearTimeout($),D=new R.$Gh({socket:O,initialChunk:j}),D.sendResume(),D.onDidDispose(()=>a("renderer disconnected")),h(D),D.onSocketClose(()=>{C.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;C.isScheduled()&&N.schedule()}});const z={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(z)});{const h=l.pipeName;return new Promise((k,D)=>{const $=I.createConnection(h,()=>{$.removeListener("error",D);const b=new R.$Gh({socket:new w.$Hh($,"extHost-renderer")});b.sendResume(),k(b)});$.once("error",D),$.on("close",()=>{a("renderer closed the socket")})})}}async function r(){const l=await t();return new class{constructor(){this.a=new R.$Fh,this.onMessage=this.a.event,this.b=!1,l.onMessage(h=>{(0,g.$fm)(h,2)?(this.b=!0,a("received terminate message from renderer")):this.a.fire(h)})}send(h){this.b||l.send(h)}async drain(){if(l.drain)return l.drain()}}}function d(l){return new Promise(h=>{const k=l.onMessage(D=>{k.dispose();const $=JSON.parse(D.toString()),b=$.commit,v=E.default.commit;if(b&&v&&b!==v&&n(55),$.parentPid){let C=0;setInterval(function(){try{process.kill($.parentPid,0),C=0}catch(z){z&&z.code==="EPERM"?(C++,C>=3&&a(`parent process ${$.parentPid} does not exist anymore (3 x EPERM): ${z.message} (code: ${z.code}) (errno: ${z.errno})`)):a(`parent process ${$.parentPid} does not exist anymore: ${z.message} (code: ${z.code}) (errno: ${z.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start($.parentPid)}catch(z){(0,L.$Z)(z)}}l.send((0,g.$em)(0)),h({protocol:l,initData:$})});l.send((0,g.$em)(1))})}async function u(){const l=[];process.on("unhandledRejection",(C,N)=>{l.push(N),setTimeout(()=>{const z=l.indexOf(N);z>=0&&N.catch(M=>{l.splice(z,1),(0,L.$3)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),C&&(0,L.$Z)(C))})},1e3)}),process.on("rejectionHandled",C=>{const N=l.indexOf(C);N>=0&&l.splice(N,1)}),process.on("uncaughtException",function(C){(0,L.$Y)(C)||(0,L.$Z)(C)}),m.mark("code/extHost/willConnectToRenderer");const h=await r();m.mark("code/extHost/didConnectToRenderer");const k=await d(h);m.mark("code/extHost/didWaitForInitData");const{initData:D}=k;o(!!D.environment.extensionTestsLocationURI),D.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,D.environment.skipWorkspaceStorageLock=(0,p.boolean)(i.skipWorkspaceStorageLock,!1);const $=new class{constructor(){this.pid=process.pid}exit(N){n(N)}fsExists(N){return f.Promises.exists(N)}fsRealpath(N){return(0,y.$0p)(N)}};let b=null;D.remote.authority&&i.transformURIs&&(b=(0,c.$Dr)(D.remote.authority));const v=new A.$lfc(k.protocol,D,$,b);a=C=>v.terminate(C)}u().catch(l=>console.log(l))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8d99999f3f8664f290bb4b98f99603b4c4e545d2/core/vs/workbench/api/node/extensionHostProcess.js.map
