/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/async","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/stopwatch","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/core/position","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/workbench/api/worker/extensionHostWorker"],Re=function(ve){for(var e=[],E=0,L=ve.length;E<L;E++)e[E]=Ae[ve[E]];return e};define(Ae[67],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function E(R){return($,D,g)=>{let A=null,S=null;if(typeof g.value=="function"?(A="value",S=g.value):typeof g.get=="function"&&(A="get",S=g.get),!S)throw new Error("not supported");g[A]=R(S,D)}}function L(R,$,D){let g=null,A=null;if(typeof D.value=="function"?(g="value",A=D.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(g="get",A=D.get),!A)throw new Error("not supported");const S=`$memoize$${$}`;D[g]=function(...o){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,o)}),this[S]}}e.$kh=L;function P(R,$,D){return E((g,A)=>{const S=`$debounce$${A}`,o=`$debounce$result$${A}`;return function(...v){this[o]||(this[o]=D?D():void 0),clearTimeout(this[S]),$&&(this[o]=$(this[o],...v),v=[this[o]]),this[S]=setTimeout(()=>{g.apply(this,v),this[o]=D?D():void 0},R)}})}e.$lh=P;function M(R,$,D){return E((g,A)=>{const S=`$throttle$timer$${A}`,o=`$throttle$result$${A}`,v=`$throttle$lastRun$${A}`,p=`$throttle$pending$${A}`;return function(...f){if(this[o]||(this[o]=D?D():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),$&&(this[o]=$(this[o],...f)),this[p])return;const t=this[v]+R;t<=Date.now()?(this[v]=Date.now(),g.apply(this,[this[o]]),this[o]=D?D():void 0):(this[p]=!0,this[S]=setTimeout(()=>{this[p]=!1,this[v]=Date.now(),g.apply(this,[this[o]]),this[o]=D?D():void 0},t-Date.now()))}})}e.$mh=M}),define(Ae[89],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CM=e.$BM=void 0;class E{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$BM=E,e.$CM=new E("id#")}),define(Ae[119],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var L;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var P;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var M;(function(r){r.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function R(r,s=!1){let c=0;const h=r.length;let w="",m=0,I=16,k=0;function d(z){let F=0,N=0;for(;F<z;){const X=r.charCodeAt(c);if(X>=48&&X<=57)N=N*16+X-48;else if(X>=65&&X<=70)N=N*16+X-65+10;else if(X>=97&&X<=102)N=N*16+X-97+10;else break;c++,F++}return F<z&&(N=-1),N}function b(z){c=z,w="",m=0,I=16,k=0}function y(){const z=c;if(r.charCodeAt(c)===48)c++;else for(c++;c<r.length&&g(r.charCodeAt(c));)c++;if(c<r.length&&r.charCodeAt(c)===46)if(c++,c<r.length&&g(r.charCodeAt(c)))for(c++;c<r.length&&g(r.charCodeAt(c));)c++;else return k=3,r.substring(z,c);let F=c;if(c<r.length&&(r.charCodeAt(c)===69||r.charCodeAt(c)===101))if(c++,(c<r.length&&r.charCodeAt(c)===43||r.charCodeAt(c)===45)&&c++,c<r.length&&g(r.charCodeAt(c))){for(c++;c<r.length&&g(r.charCodeAt(c));)c++;F=c}else k=3;return r.substring(z,F)}function C(){let z="",F=c;for(;;){if(c>=h){z+=r.substring(F,c),k=2;break}const N=r.charCodeAt(c);if(N===34){z+=r.substring(F,c),c++;break}if(N===92){if(z+=r.substring(F,c),c++,c>=h){k=2;break}switch(r.charCodeAt(c++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const Q=d(4);Q>=0?z+=String.fromCharCode(Q):k=4;break}default:k=5}F=c;continue}if(N>=0&&N<=31)if(D(N)){z+=r.substring(F,c),k=2;break}else k=6;c++}return z}function B(){if(w="",k=0,m=c,c>=h)return m=h,I=17;let z=r.charCodeAt(c);if($(z)){do c++,w+=String.fromCharCode(z),z=r.charCodeAt(c);while($(z));return I=15}if(D(z))return c++,w+=String.fromCharCode(z),z===13&&r.charCodeAt(c)===10&&(c++,w+=`
`),I=14;switch(z){case 123:return c++,I=1;case 125:return c++,I=2;case 91:return c++,I=3;case 93:return c++,I=4;case 58:return c++,I=6;case 44:return c++,I=5;case 34:return c++,w=C(),I=10;case 47:{const F=c-1;if(r.charCodeAt(c+1)===47){for(c+=2;c<h&&!D(r.charCodeAt(c));)c++;return w=r.substring(F,c),I=12}if(r.charCodeAt(c+1)===42){c+=2;const N=h-1;let X=!1;for(;c<N;){if(r.charCodeAt(c)===42&&r.charCodeAt(c+1)===47){c+=2,X=!0;break}c++}return X||(c++,k=1),w=r.substring(F,c),I=13}return w+=String.fromCharCode(z),c++,I=16}case 45:if(w+=String.fromCharCode(z),c++,c===h||!g(r.charCodeAt(c)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=y(),I=11;default:for(;c<h&&H(z);)c++,z=r.charCodeAt(c);if(m!==c){switch(w=r.substring(m,c),w){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return w+=String.fromCharCode(z),c++,I=16}}function H(z){if($(z)||D(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let z;do z=B();while(z>=12&&z<=15);return z}return{setPosition:b,getPosition:()=>c,scan:s?U:B,getToken:()=>I,getTokenValue:()=>w,getTokenOffset:()=>m,getTokenLength:()=>c-m,getTokenError:()=>k}}e.$Xm=R;function $(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function D(r){return r===10||r===13||r===8232||r===8233}function g(r){return r>=48&&r<=57}var A;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(A||(A={}));function S(r,s){const c=[],h=new Object;let w;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function k(d,b,y,C){m.value=d,m.offset=b,m.length=y,m.type=C,m.colonOffset=void 0,w=m}try{u(r,{onObjectBegin:(d,b)=>{if(s<=d)throw h;w=void 0,I=s>d,c.push("")},onObjectProperty:(d,b,y)=>{if(s<b||(k(d,b,y,"property"),c[c.length-1]=d,s<=b+y))throw h},onObjectEnd:(d,b)=>{if(s<=d)throw h;w=void 0,c.pop()},onArrayBegin:(d,b)=>{if(s<=d)throw h;w=void 0,c.push(0)},onArrayEnd:(d,b)=>{if(s<=d)throw h;w=void 0,c.pop()},onLiteralValue:(d,b,y)=>{if(s<b||(k(d,b,y,l(d)),s<=b+y))throw h},onSeparator:(d,b,y)=>{if(s<=b)throw h;if(d===":"&&w&&w.type==="property")w.colonOffset=b,I=!1,w=void 0;else if(d===","){const C=c[c.length-1];typeof C=="number"?c[c.length-1]=C+1:(I=!0,c[c.length-1]=""),w=void 0}}})}catch(d){if(d!==h)throw d}return{path:c,previousNode:w,isAtPropertyKey:I,matches:d=>{let b=0;for(let y=0;b<d.length&&y<c.length;y++)if(d[b]===c[y]||d[b]==="*")b++;else if(d[b]!=="**")return!1;return b===d.length}}}e.$Ym=S;function o(r,s=[],c=M.DEFAULT){let h=null,w=[];const m=[];function I(d){Array.isArray(w)?w.push(d):h!==null&&(w[h]=d)}return u(r,{onObjectBegin:()=>{const d={};I(d),m.push(w),w=d,h=null},onObjectProperty:d=>{h=d},onObjectEnd:()=>{w=m.pop()},onArrayBegin:()=>{const d=[];I(d),m.push(w),w=d,h=null},onArrayEnd:()=>{w=m.pop()},onLiteralValue:I,onError:(d,b,y)=>{s.push({error:d,offset:b,length:y})}},c),w[0]}e.$Zm=o;function v(r,s=[],c=M.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(d){h.type==="property"&&(h.length=d-h.offset,h=h.parent)}function m(d){return h.children.push(d),d}u(r,{onObjectBegin:d=>{h=m({type:"object",offset:d,length:-1,parent:h,children:[]})},onObjectProperty:(d,b,y)=>{h=m({type:"property",offset:b,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:d,offset:b,length:y,parent:h})},onObjectEnd:(d,b)=>{h.length=d+b-h.offset,h=h.parent,w(d+b)},onArrayBegin:(d,b)=>{h=m({type:"array",offset:d,length:-1,parent:h,children:[]})},onArrayEnd:(d,b)=>{h.length=d+b-h.offset,h=h.parent,w(d+b)},onLiteralValue:(d,b,y)=>{m({type:l(d),offset:b,length:y,parent:h,value:d}),w(b+y)},onSeparator:(d,b,y)=>{h.type==="property"&&(d===":"?h.colonOffset=b:d===","&&w(b))},onError:(d,b,y)=>{s.push({error:d,offset:b,length:y})}},c);const k=h.children[0];return k&&delete k.parent,k}e.$1m=v;function p(r,s){if(!r)return;let c=r;for(const h of s)if(typeof h=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let w=!1;for(const m of c.children)if(Array.isArray(m.children)&&m.children[0].value===h){c=m.children[1],w=!0;break}if(!w)return}else{const w=h;if(c.type!=="array"||w<0||!Array.isArray(c.children)||w>=c.children.length)return;c=c.children[w]}return c}e.$2m=p;function f(r){if(!r.parent||!r.parent.children)return[];const s=f(r.parent);if(r.parent.type==="property"){const c=r.parent.children[0].value;s.push(c)}else if(r.parent.type==="array"){const c=r.parent.children.indexOf(r);c!==-1&&s.push(c)}return s}e.$3m=f;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const s=Object.create(null);for(const c of r.children){const h=c.children[1];h&&(s[c.children[0].value]=t(h))}return s}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.$4m=t;function i(r,s,c=!1){return s>=r.offset&&s<r.offset+r.length||c&&s===r.offset+r.length}e.$5m=i;function n(r,s,c=!1){if(i(r,s,c)){const h=r.children;if(Array.isArray(h))for(let w=0;w<h.length&&h[w].offset<=s;w++){const m=n(h[w],s,c);if(m)return m}return r}}e.$6m=n;function u(r,s,c=M.DEFAULT){const h=R(r,!1);function w(ne){return ne?()=>ne(h.getTokenOffset(),h.getTokenLength()):()=>!0}function m(ne){return ne?re=>ne(re,h.getTokenOffset(),h.getTokenLength()):()=>!0}const I=w(s.onObjectBegin),k=m(s.onObjectProperty),d=w(s.onObjectEnd),b=w(s.onArrayBegin),y=w(s.onArrayEnd),C=m(s.onLiteralValue),B=m(s.onSeparator),H=w(s.onComment),U=m(s.onError),z=c&&c.disallowComments,F=c&&c.allowTrailingComma;function N(){for(;;){const ne=h.scan();switch(h.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:z||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(ne){case 12:case 13:z?X(10):H();break;case 16:X(1);break;case 15:case 14:break;default:return ne}}}function X(ne,re=[],pe=[]){if(U(ne),re.length+pe.length>0){let _=h.getToken();for(;_!==17;){if(re.indexOf(_)!==-1){N();break}else if(pe.indexOf(_)!==-1)break;_=N()}}}function Q(ne){const re=h.getTokenValue();return ne?C(re):k(re),N(),!0}function De(){switch(h.getToken()){case 11:{let ne=0;try{ne=JSON.parse(h.getTokenValue()),typeof ne!="number"&&(X(2),ne=0)}catch{X(2)}C(ne);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return N(),!0}function ke(){return h.getToken()!==10?(X(3,[],[2,5]),!1):(Q(!1),h.getToken()===6?(B(":"),N(),we()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function Pe(){I(),N();let ne=!1;for(;h.getToken()!==2&&h.getToken()!==17;){if(h.getToken()===5){if(ne||X(4,[],[]),B(","),N(),h.getToken()===2&&F)break}else ne&&X(6,[],[]);ke()||X(4,[],[2,5]),ne=!0}return d(),h.getToken()!==2?X(7,[2],[]):N(),!0}function fe(){b(),N();let ne=!1;for(;h.getToken()!==4&&h.getToken()!==17;){if(h.getToken()===5){if(ne||X(4,[],[]),B(","),N(),h.getToken()===4&&F)break}else ne&&X(6,[],[]);we()||X(4,[],[4,5]),ne=!0}return y(),h.getToken()!==4?X(8,[4],[]):N(),!0}function we(){switch(h.getToken()){case 3:return fe();case 1:return Pe();case 10:return Q(!0);default:return De()}}return N(),h.getToken()===17?c.allowEmptyContent?!0:(X(4,[],[]),!1):we()?(h.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.$7m=u;function a(r,s){const c=R(r),h=[];let w,m=0,I;do switch(I=c.getPosition(),w=c.scan(),w){case 12:case 13:case 17:m!==I&&h.push(r.substring(m,I)),s!==void 0&&h.push(c.getTokenValue().replace(/[^\r\n]/g,s)),m=c.getPosition();break}while(w!==17);return h.join("")}e.$8m=a;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.$9m=l}),function(ve,e){typeof define=="function"&&define.amd?define(Ae[120],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ve=typeof globalThis<"u"?globalThis:ve||self,e(ve.marked={}))}(this,function(ve){"use strict";function e(he,ue){for(var ye=0;ye<ue.length;ye++){var ee=ue[ye];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(he,ee.key,ee)}}function E(he,ue,ye){return ue&&e(he.prototype,ue),ye&&e(he,ye),Object.defineProperty(he,"prototype",{writable:!1}),he}function L(he,ue){if(he){if(typeof he=="string")return P(he,ue);var ye=Object.prototype.toString.call(he).slice(8,-1);if(ye==="Object"&&he.constructor&&(ye=he.constructor.name),ye==="Map"||ye==="Set")return Array.from(he);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return P(he,ue)}}function P(he,ue){(ue==null||ue>he.length)&&(ue=he.length);for(var ye=0,ee=new Array(ue);ye<ue;ye++)ee[ye]=he[ye];return ee}function M(he,ue){var ye=typeof Symbol<"u"&&he[Symbol.iterator]||he["@@iterator"];if(ye)return(ye=ye.call(he)).next.bind(ye);if(Array.isArray(he)||(ye=L(he))||ue&&he&&typeof he.length=="number"){ye&&(he=ye);var ee=0;return function(){return ee>=he.length?{done:!0}:{done:!1,value:he[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ve.defaults=R();function $(he){ve.defaults=he}var D=/[&<>"']/,g=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,o={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(ue){return o[ue]};function p(he,ue){if(ue){if(D.test(he))return he.replace(g,v)}else if(A.test(he))return he.replace(S,v);return he}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(he){return he.replace(f,function(ue,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var i=/(^|[^\[])\^/g;function n(he,ue){he=typeof he=="string"?he:he.source,ue=ue||"";var ye={replace:function(de,ie){return ie=ie.source||ie,ie=ie.replace(i,"$1"),he=he.replace(de,ie),ye},getRegex:function(){return new RegExp(he,ue)}};return ye}var u=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(he,ue,ye){if(he){var ee;try{ee=decodeURIComponent(t(ye)).replace(u,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ue&&!a.test(ye)&&(ye=w(ue,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var r={},s=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,h=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(he,ue){r[" "+he]||(s.test(he)?r[" "+he]=he+"/":r[" "+he]=d(he,"/",!0)),he=r[" "+he];var ye=he.indexOf(":")===-1;return ue.substring(0,2)==="//"?ye?ue:he.replace(c,"$1")+ue:ue.charAt(0)==="/"?ye?ue:he.replace(h,"$1")+ue:he+ue}var m={exec:function(){}};function I(he){for(var ue=1,ye,ee;ue<arguments.length;ue++){ye=arguments[ue];for(ee in ye)Object.prototype.hasOwnProperty.call(ye,ee)&&(he[ee]=ye[ee])}return he}function k(he,ue){var ye=he.replace(/\|/g,function(ie,ae,me){for(var Ce=!1,T=ae;--T>=0&&me[T]==="\\";)Ce=!Ce;return Ce?"|":" |"}),ee=ye.split(/ \|/),de=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>ue)ee.splice(ue);else for(;ee.length<ue;)ee.push("");for(;de<ee.length;de++)ee[de]=ee[de].trim().replace(/\\\|/g,"|");return ee}function d(he,ue,ye){var ee=he.length;if(ee===0)return"";for(var de=0;de<ee;){var ie=he.charAt(ee-de-1);if(ie===ue&&!ye)de++;else if(ie!==ue&&ye)de++;else break}return he.slice(0,ee-de)}function b(he,ue){if(he.indexOf(ue[1])===-1)return-1;for(var ye=he.length,ee=0,de=0;de<ye;de++)if(he[de]==="\\")de++;else if(he[de]===ue[0])ee++;else if(he[de]===ue[1]&&(ee--,ee<0))return de;return-1}function y(he){he&&he.sanitize&&!he.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(he,ue){if(ue<1)return"";for(var ye="";ue>1;)ue&1&&(ye+=he),ue>>=1,he+=he;return ye+he}function B(he,ue,ye,ee){var de=ue.href,ie=ue.title?p(ue.title):null,ae=he[1].replace(/\\([\[\]])/g,"$1");if(he[0].charAt(0)!=="!"){ee.state.inLink=!0;var me={type:"link",raw:ye,href:de,title:ie,text:ae,tokens:ee.inlineTokens(ae)};return ee.state.inLink=!1,me}return{type:"image",raw:ye,href:de,title:ie,text:p(ae)}}function H(he,ue){var ye=he.match(/^(\s+)(?:```)/);if(ye===null)return ue;var ee=ye[1];return ue.split(`
`).map(function(de){var ie=de.match(/^\s+/);if(ie===null)return de;var ae=ie[0];return ae.length>=ee.length?de.slice(ee.length):de}).join(`
`)}var U=function(){function he(ye){this.options=ye||ve.defaults}var ue=he.prototype;return ue.space=function(ee){var de=this.rules.block.newline.exec(ee);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},ue.code=function(ee){var de=this.rules.block.code.exec(ee);if(de){var ie=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:d(ie,`
`)}}},ue.fences=function(ee){var de=this.rules.block.fences.exec(ee);if(de){var ie=de[0],ae=H(ie,de[3]||"");return{type:"code",raw:ie,lang:de[2]?de[2].trim():de[2],text:ae}}},ue.heading=function(ee){var de=this.rules.block.heading.exec(ee);if(de){var ie=de[2].trim();if(/#$/.test(ie)){var ae=d(ie,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(ie=ae.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:ie,tokens:this.lexer.inline(ie)}}},ue.hr=function(ee){var de=this.rules.block.hr.exec(ee);if(de)return{type:"hr",raw:de[0]}},ue.blockquote=function(ee){var de=this.rules.block.blockquote.exec(ee);if(de){var ie=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},ue.list=function(ee){var de=this.rules.block.list.exec(ee);if(de){var ie,ae,me,Ce,T,V,G,J,q,x,le,Oe,je=de[1].trim(),Qe=je.length>1,Ge={type:"list",raw:"",ordered:Qe,start:Qe?+je.slice(0,-1):"",loose:!1,items:[]};je=Qe?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Qe?je:"[*+-]");for(var _e=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(Oe=!1,!(!(de=_e.exec(ee))||this.rules.block.hr.test(ee)));){if(ie=de[0],ee=ee.substring(ie.length),J=de[2].split(`
`,1)[0],q=ee.split(`
`,1)[0],this.options.pedantic?(Ce=2,le=J.trimLeft()):(Ce=de[2].search(/[^ ]/),Ce=Ce>4?1:Ce,le=J.slice(Ce),Ce+=de[1].length),V=!1,!J&&/^ *$/.test(q)&&(ie+=q+`
`,ee=ee.substring(q.length+1),Oe=!0),!Oe)for(var Xe=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}#");ee&&(x=ee.split(`
`,1)[0],J=x,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(J)||tt.test(J)||Xe.test(J)||xe.test(ee)));){if(J.search(/[^ ]/)>=Ce||!J.trim())le+=`
`+J.slice(Ce);else if(!V)le+=`
`+J;else break;!V&&!J.trim()&&(V=!0),ie+=x+`
`,ee=ee.substring(x.length+1)}Ge.loose||(G?Ge.loose=!0:/\n *\n *$/.test(ie)&&(G=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(le),ae&&(me=ae[0]!=="[ ] ",le=le.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:ie,task:!!ae,checked:me,loose:!1,text:le}),Ge.raw+=ie}Ge.items[Ge.items.length-1].raw=ie.trimRight(),Ge.items[Ge.items.length-1].text=le.trimRight(),Ge.raw=Ge.raw.trimRight();var ze=Ge.items.length;for(T=0;T<ze;T++){this.lexer.state.top=!1,Ge.items[T].tokens=this.lexer.blockTokens(Ge.items[T].text,[]);var ut=Ge.items[T].tokens.filter(function(Y){return Y.type==="space"}),Z=ut.every(function(Y){for(var Ee=Y.raw.split(""),Be=0,Ne=M(Ee),Ye;!(Ye=Ne()).done;){var nt=Ye.value;if(nt===`
`&&(Be+=1),Be>1)return!0}return!1});!Ge.loose&&ut.length&&Z&&(Ge.loose=!0,Ge.items[T].loose=!0)}return Ge}},ue.html=function(ee){var de=this.rules.block.html.exec(ee);if(de){var ie={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(de[0]):p(de[0]);ie.type="paragraph",ie.text=ae,ie.tokens=this.lexer.inline(ae)}return ie}},ue.def=function(ee){var de=this.rules.block.def.exec(ee);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var ie=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:de[0],href:de[2],title:de[3]}}},ue.table=function(ee){var de=this.rules.block.table.exec(ee);if(de){var ie={type:"table",header:k(de[1]).map(function(G){return{text:G}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=de[0];var ae=ie.align.length,me,Ce,T,V;for(me=0;me<ae;me++)/^ *-+: *$/.test(ie.align[me])?ie.align[me]="right":/^ *:-+: *$/.test(ie.align[me])?ie.align[me]="center":/^ *:-+ *$/.test(ie.align[me])?ie.align[me]="left":ie.align[me]=null;for(ae=ie.rows.length,me=0;me<ae;me++)ie.rows[me]=k(ie.rows[me],ie.header.length).map(function(G){return{text:G}});for(ae=ie.header.length,Ce=0;Ce<ae;Ce++)ie.header[Ce].tokens=this.lexer.inline(ie.header[Ce].text);for(ae=ie.rows.length,Ce=0;Ce<ae;Ce++)for(V=ie.rows[Ce],T=0;T<V.length;T++)V[T].tokens=this.lexer.inline(V[T].text);return ie}}},ue.lheading=function(ee){var de=this.rules.block.lheading.exec(ee);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},ue.paragraph=function(ee){var de=this.rules.block.paragraph.exec(ee);if(de){var ie=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:ie,tokens:this.lexer.inline(ie)}}},ue.text=function(ee){var de=this.rules.block.text.exec(ee);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},ue.escape=function(ee){var de=this.rules.inline.escape.exec(ee);if(de)return{type:"escape",raw:de[0],text:p(de[1])}},ue.tag=function(ee){var de=this.rules.inline.tag.exec(ee);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):p(de[0]):de[0]}},ue.link=function(ee){var de=this.rules.inline.link.exec(ee);if(de){var ie=de[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var ae=d(ie.slice(0,-1),"\\");if((ie.length-ae.length)%2===0)return}else{var me=b(de[2],"()");if(me>-1){var Ce=de[0].indexOf("!")===0?5:4,T=Ce+de[1].length+me;de[2]=de[2].substring(0,me),de[0]=de[0].substring(0,T).trim(),de[3]=""}}var V=de[2],G="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);J&&(V=J[1],G=J[3])}else G=de[3]?de[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(ie)?V=V.slice(1):V=V.slice(1,-1)),B(de,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},ue.reflink=function(ee,de){var ie;if((ie=this.rules.inline.reflink.exec(ee))||(ie=this.rules.inline.nolink.exec(ee))){var ae=(ie[2]||ie[1]).replace(/\s+/g," ");if(ae=de[ae.toLowerCase()],!ae||!ae.href){var me=ie[0].charAt(0);return{type:"text",raw:me,text:me}}return B(ie,ae,ie[0],this.lexer)}},ue.emStrong=function(ee,de,ie){ie===void 0&&(ie="");var ae=this.rules.inline.emStrong.lDelim.exec(ee);if(ae&&!(ae[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var me=ae[1]||ae[2]||"";if(!me||me&&(ie===""||this.rules.inline.punctuation.exec(ie))){var Ce=ae[0].length-1,T,V,G=Ce,J=0,q=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,de=de.slice(-1*ee.length+Ce);(ae=q.exec(de))!=null;)if(T=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!T){if(V=T.length,ae[3]||ae[4]){G+=V;continue}else if((ae[5]||ae[6])&&Ce%3&&!((Ce+V)%3)){J+=V;continue}if(G-=V,!(G>0)){if(V=Math.min(V,V+G+J),Math.min(Ce,V)%2){var x=ee.slice(1,Ce+ae.index+V);return{type:"em",raw:ee.slice(0,Ce+ae.index+V+1),text:x,tokens:this.lexer.inlineTokens(x)}}var le=ee.slice(2,Ce+ae.index+V-1);return{type:"strong",raw:ee.slice(0,Ce+ae.index+V+1),text:le,tokens:this.lexer.inlineTokens(le)}}}}}},ue.codespan=function(ee){var de=this.rules.inline.code.exec(ee);if(de){var ie=de[2].replace(/\n/g," "),ae=/[^ ]/.test(ie),me=/^ /.test(ie)&&/ $/.test(ie);return ae&&me&&(ie=ie.substring(1,ie.length-1)),ie=p(ie,!0),{type:"codespan",raw:de[0],text:ie}}},ue.br=function(ee){var de=this.rules.inline.br.exec(ee);if(de)return{type:"br",raw:de[0]}},ue.del=function(ee){var de=this.rules.inline.del.exec(ee);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},ue.autolink=function(ee,de){var ie=this.rules.inline.autolink.exec(ee);if(ie){var ae,me;return ie[2]==="@"?(ae=p(this.options.mangle?de(ie[1]):ie[1]),me="mailto:"+ae):(ae=p(ie[1]),me=ae),{type:"link",raw:ie[0],text:ae,href:me,tokens:[{type:"text",raw:ae,text:ae}]}}},ue.url=function(ee,de){var ie;if(ie=this.rules.inline.url.exec(ee)){var ae,me;if(ie[2]==="@")ae=p(this.options.mangle?de(ie[0]):ie[0]),me="mailto:"+ae;else{var Ce;do Ce=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(Ce!==ie[0]);ae=p(ie[0]),ie[1]==="www."?me="http://"+ae:me=ae}return{type:"link",raw:ie[0],text:ae,href:me,tokens:[{type:"text",raw:ae,text:ae}]}}},ue.inlineText=function(ee,de){var ie=this.rules.inline.text.exec(ee);if(ie){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):p(ie[0]):ie[0]:ae=p(this.options.smartypants?de(ie[0]):ie[0]),{type:"text",raw:ie[0],text:ae}}},he}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=I({},z),z.gfm=I({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=I({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=n(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=n(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=n(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=n(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=n(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=n(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=n(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=n(F.reflink).replace("label",F._label).replace("ref",z._label).getRegex(),F.nolink=n(F.nolink).replace("ref",z._label).getRegex(),F.reflinkSearch=n(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=I({},F),F.pedantic=I({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=I({},F.normal,{escape:n(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=n(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=I({},F.gfm,{br:n(F.br).replace("{2,}","*").getRegex(),text:n(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(he){return he.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function X(he){var ue="",ye,ee,de=he.length;for(ye=0;ye<de;ye++)ee=he.charCodeAt(ye),Math.random()>.5&&(ee="x"+ee.toString(16)),ue+="&#"+ee+";";return ue}var Q=function(){function he(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||ve.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:z.normal,inline:F.normal};this.options.pedantic?(ee.block=z.pedantic,ee.inline=F.pedantic):this.options.gfm&&(ee.block=z.gfm,this.options.breaks?ee.inline=F.breaks:ee.inline=F.gfm),this.tokenizer.rules=ee}he.lex=function(ee,de){var ie=new he(de);return ie.lex(ee)},he.lexInline=function(ee,de){var ie=new he(de);return ie.inlineTokens(ee)};var ue=he.prototype;return ue.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},ue.blockTokens=function(ee,de){var ie=this;de===void 0&&(de=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(G,J,q){return J+"    ".repeat(q.length)});for(var ae,me,Ce,T;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(ae=G.call({lexer:ie},ee,de))?(ee=ee.substring(ae.raw.length),de.push(ae),!0):!1}))){if(ae=this.tokenizer.space(ee)){ee=ee.substring(ae.raw.length),ae.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(ae);continue}if(ae=this.tokenizer.code(ee)){ee=ee.substring(ae.raw.length),me=de[de.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ae);continue}if(ae=this.tokenizer.fences(ee)){ee=ee.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.heading(ee)){ee=ee.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.hr(ee)){ee=ee.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.blockquote(ee)){ee=ee.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.list(ee)){ee=ee.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.html(ee)){ee=ee.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.def(ee)){ee=ee.substring(ae.raw.length),me=de[de.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=me.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(ee)){ee=ee.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.lheading(ee)){ee=ee.substring(ae.raw.length),de.push(ae);continue}if(Ce=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,J=ee.slice(1),q=void 0;ie.options.extensions.startBlock.forEach(function(x){q=x.call({lexer:this},J),typeof q=="number"&&q>=0&&(G=Math.min(G,q))}),G<1/0&&G>=0&&(Ce=ee.substring(0,G+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(Ce))){me=de[de.length-1],T&&me.type==="paragraph"?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ae),T=Ce.length!==ee.length,ee=ee.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(ee)){ee=ee.substring(ae.raw.length),me=de[de.length-1],me&&me.type==="text"?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ae);continue}if(ee){var V="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,de},ue.inline=function(ee,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:ee,tokens:de}),de},ue.inlineTokens=function(ee,de){var ie=this;de===void 0&&(de=[]);var ae,me,Ce,T=ee,V,G,J;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(T))!=null;)q.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(T=T.slice(0,V.index)+"["+C("a",V[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(T))!=null;)T=T.slice(0,V.index)+"["+C("a",V[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(T))!=null;)T=T.slice(0,V.index)+"++"+T.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(G||(J=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(le){return(ae=le.call({lexer:ie},ee,de))?(ee=ee.substring(ae.raw.length),de.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(ee)){ee=ee.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.tag(ee)){ee=ee.substring(ae.raw.length),me=de[de.length-1],me&&ae.type==="text"&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):de.push(ae);continue}if(ae=this.tokenizer.link(ee)){ee=ee.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(ae.raw.length),me=de[de.length-1],me&&ae.type==="text"&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):de.push(ae);continue}if(ae=this.tokenizer.emStrong(ee,T,J)){ee=ee.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.codespan(ee)){ee=ee.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.br(ee)){ee=ee.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.del(ee)){ee=ee.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.autolink(ee,X)){ee=ee.substring(ae.raw.length),de.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(ee,X))){ee=ee.substring(ae.raw.length),de.push(ae);continue}if(Ce=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var le=1/0,Oe=ee.slice(1),je=void 0;ie.options.extensions.startInline.forEach(function(Qe){je=Qe.call({lexer:this},Oe),typeof je=="number"&&je>=0&&(le=Math.min(le,je))}),le<1/0&&le>=0&&(Ce=ee.substring(0,le+1))}(),ae=this.tokenizer.inlineText(Ce,N)){ee=ee.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(J=ae.raw.slice(-1)),G=!0,me=de[de.length-1],me&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):de.push(ae);continue}if(ee){var x="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return de},E(he,null,[{key:"rules",get:function(){return{block:z,inline:F}}}]),he}(),De=function(){function he(ye){this.options=ye||ve.defaults}var ue=he.prototype;return ue.code=function(ee,de,ie){var ae=(de||"").match(/\S*/)[0];if(this.options.highlight){var me=this.options.highlight(ee,ae);me!=null&&me!==ee&&(ie=!0,ee=me)}return ee=ee.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+p(ae,!0)+'">'+(ie?ee:p(ee,!0))+`</code></pre>
`:"<pre><code>"+(ie?ee:p(ee,!0))+`</code></pre>
`},ue.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ue.html=function(ee){return ee},ue.heading=function(ee,de,ie,ae){if(this.options.headerIds){var me=this.options.headerPrefix+ae.slug(ie);return"<h"+de+' id="'+me+'">'+ee+"</h"+de+`>
`}return"<h"+de+">"+ee+"</h"+de+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(ee,de,ie){var ae=de?"ol":"ul",me=de&&ie!==1?' start="'+ie+'"':"";return"<"+ae+me+`>
`+ee+"</"+ae+`>
`},ue.listitem=function(ee){return"<li>"+ee+`</li>
`},ue.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(ee){return"<p>"+ee+`</p>
`},ue.table=function(ee,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+de+`</table>
`},ue.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ue.tablecell=function(ee,de){var ie=de.header?"th":"td",ae=de.align?"<"+ie+' align="'+de.align+'">':"<"+ie+">";return ae+ee+("</"+ie+`>
`)},ue.strong=function(ee){return"<strong>"+ee+"</strong>"},ue.em=function(ee){return"<em>"+ee+"</em>"},ue.codespan=function(ee){return"<code>"+ee+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(ee){return"<del>"+ee+"</del>"},ue.link=function(ee,de,ie){if(ee=l(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var ae='<a href="'+p(ee)+'"';return de&&(ae+=' title="'+de+'"'),ae+=">"+ie+"</a>",ae},ue.image=function(ee,de,ie){if(ee=l(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var ae='<img src="'+ee+'" alt="'+ie+'"';return de&&(ae+=' title="'+de+'"'),ae+=this.options.xhtml?"/>":">",ae},ue.text=function(ee){return ee},he}(),ke=function(){function he(){}var ue=he.prototype;return ue.strong=function(ee){return ee},ue.em=function(ee){return ee},ue.codespan=function(ee){return ee},ue.del=function(ee){return ee},ue.html=function(ee){return ee},ue.text=function(ee){return ee},ue.link=function(ee,de,ie){return""+ie},ue.image=function(ee,de,ie){return""+ie},ue.br=function(){return""},he}(),Pe=function(){function he(){this.seen={}}var ue=he.prototype;return ue.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(ee,de){var ie=ee,ae=0;if(this.seen.hasOwnProperty(ie)){ae=this.seen[ee];do ae++,ie=ee+"-"+ae;while(this.seen.hasOwnProperty(ie))}return de||(this.seen[ee]=ae,this.seen[ie]=0),ie},ue.slug=function(ee,de){de===void 0&&(de={});var ie=this.serialize(ee);return this.getNextSafeSlug(ie,de.dryrun)},he}(),fe=function(){function he(ye){this.options=ye||ve.defaults,this.options.renderer=this.options.renderer||new De,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ke,this.slugger=new Pe}he.parse=function(ee,de){var ie=new he(de);return ie.parse(ee)},he.parseInline=function(ee,de){var ie=new he(de);return ie.parseInline(ee)};var ue=he.prototype;return ue.parse=function(ee,de){de===void 0&&(de=!0);var ie="",ae,me,Ce,T,V,G,J,q,x,le,Oe,je,Qe,Ge,_e,Xe,xe,it,tt,ze=ee.length;for(ae=0;ae<ze;ae++){if(le=ee[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(tt=this.options.extensions.renderers[le.type].call({parser:this},le),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(le.type))){ie+=tt||"";continue}switch(le.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(le.tokens),le.depth,t(this.parseInline(le.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(le.text,le.lang,le.escaped);continue}case"table":{for(q="",J="",T=le.header.length,me=0;me<T;me++)J+=this.renderer.tablecell(this.parseInline(le.header[me].tokens),{header:!0,align:le.align[me]});for(q+=this.renderer.tablerow(J),x="",T=le.rows.length,me=0;me<T;me++){for(G=le.rows[me],J="",V=G.length,Ce=0;Ce<V;Ce++)J+=this.renderer.tablecell(this.parseInline(G[Ce].tokens),{header:!1,align:le.align[Ce]});x+=this.renderer.tablerow(J)}ie+=this.renderer.table(q,x);continue}case"blockquote":{x=this.parse(le.tokens),ie+=this.renderer.blockquote(x);continue}case"list":{for(Oe=le.ordered,je=le.start,Qe=le.loose,T=le.items.length,x="",me=0;me<T;me++)_e=le.items[me],Xe=_e.checked,xe=_e.task,Ge="",_e.task&&(it=this.renderer.checkbox(Xe),Qe?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=it+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=it+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:it}):Ge+=it),Ge+=this.parse(_e.tokens,Qe),x+=this.renderer.listitem(Ge,xe,Xe);ie+=this.renderer.list(x,Oe,je);continue}case"html":{ie+=this.renderer.html(le.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(le.tokens));continue}case"text":{for(x=le.tokens?this.parseInline(le.tokens):le.text;ae+1<ze&&ee[ae+1].type==="text";)le=ee[++ae],x+=`
`+(le.tokens?this.parseInline(le.tokens):le.text);ie+=de?this.renderer.paragraph(x):x;continue}default:{var ut='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(ut);return}else throw new Error(ut)}}}return ie},ue.parseInline=function(ee,de){de=de||this.renderer;var ie="",ae,me,Ce,T=ee.length;for(ae=0;ae<T;ae++){if(me=ee[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(Ce=this.options.extensions.renderers[me.type].call({parser:this},me),Ce!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(me.type))){ie+=Ce||"";continue}switch(me.type){case"escape":{ie+=de.text(me.text);break}case"html":{ie+=de.html(me.text);break}case"link":{ie+=de.link(me.href,me.title,this.parseInline(me.tokens,de));break}case"image":{ie+=de.image(me.href,me.title,me.text);break}case"strong":{ie+=de.strong(this.parseInline(me.tokens,de));break}case"em":{ie+=de.em(this.parseInline(me.tokens,de));break}case"codespan":{ie+=de.codespan(me.text);break}case"br":{ie+=de.br();break}case"del":{ie+=de.del(this.parseInline(me.tokens,de));break}case"text":{ie+=de.text(me.text);break}default:{var V='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return ie},he}();function we(he,ue,ye){if(typeof he>"u"||he===null)throw new Error("marked(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");if(typeof ue=="function"&&(ye=ue,ue=null),ue=I({},we.defaults,ue||{}),y(ue),ye){var ee=ue.highlight,de;try{de=Q.lex(he,ue)}catch(T){return ye(T)}var ie=function(V){var G;if(!V)try{ue.walkTokens&&we.walkTokens(de,ue.walkTokens),G=fe.parse(de,ue)}catch(J){V=J}return ue.highlight=ee,V?ye(V):ye(null,G)};if(!ee||ee.length<3||(delete ue.highlight,!de.length))return ie();var ae=0;we.walkTokens(de,function(T){T.type==="code"&&(ae++,setTimeout(function(){ee(T.text,T.lang,function(V,G){if(V)return ie(V);G!=null&&G!==T.text&&(T.text=G,T.escaped=!0),ae--,ae===0&&ie()})},0))}),ae===0&&ie();return}function me(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+p(T.message+"",!0)+"</pre>";throw T}try{var Ce=Q.lex(he,ue);if(ue.walkTokens){if(ue.async)return Promise.all(we.walkTokens(Ce,ue.walkTokens)).then(function(){return fe.parse(Ce,ue)}).catch(me);we.walkTokens(Ce,ue.walkTokens)}return fe.parse(Ce,ue)}catch(T){me(T)}}we.options=we.setOptions=function(he){return I(we.defaults,he),$(we.defaults),we},we.getDefaults=R,we.defaults=ve.defaults,we.use=function(){for(var he=arguments.length,ue=new Array(he),ye=0;ye<he;ye++)ue[ye]=arguments[ye];var ee=I.apply(void 0,[{}].concat(ue)),de=we.defaults.extensions||{renderers:{},childTokens:{}},ie;ue.forEach(function(ae){if(ae.extensions&&(ie=!0,ae.extensions.forEach(function(Ce){if(!Ce.name)throw new Error("extension name required");if(Ce.renderer){var T=de.renderers?de.renderers[Ce.name]:null;T?de.renderers[Ce.name]=function(){for(var V=arguments.length,G=new Array(V),J=0;J<V;J++)G[J]=arguments[J];var q=Ce.renderer.apply(this,G);return q===!1&&(q=T.apply(this,G)),q}:de.renderers[Ce.name]=Ce.renderer}if(Ce.tokenizer){if(!Ce.level||Ce.level!=="block"&&Ce.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Ce.level]?de[Ce.level].unshift(Ce.tokenizer):de[Ce.level]=[Ce.tokenizer],Ce.start&&(Ce.level==="block"?de.startBlock?de.startBlock.push(Ce.start):de.startBlock=[Ce.start]:Ce.level==="inline"&&(de.startInline?de.startInline.push(Ce.start):de.startInline=[Ce.start]))}Ce.childTokens&&(de.childTokens[Ce.name]=Ce.childTokens)})),ae.renderer&&function(){var Ce=we.defaults.renderer||new De,T=function(J){var q=Ce[J];Ce[J]=function(){for(var x=arguments.length,le=new Array(x),Oe=0;Oe<x;Oe++)le[Oe]=arguments[Oe];var je=ae.renderer[J].apply(Ce,le);return je===!1&&(je=q.apply(Ce,le)),je}};for(var V in ae.renderer)T(V);ee.renderer=Ce}(),ae.tokenizer&&function(){var Ce=we.defaults.tokenizer||new U,T=function(J){var q=Ce[J];Ce[J]=function(){for(var x=arguments.length,le=new Array(x),Oe=0;Oe<x;Oe++)le[Oe]=arguments[Oe];var je=ae.tokenizer[J].apply(Ce,le);return je===!1&&(je=q.apply(Ce,le)),je}};for(var V in ae.tokenizer)T(V);ee.tokenizer=Ce}(),ae.walkTokens){var me=we.defaults.walkTokens;ee.walkTokens=function(Ce){var T=[];return T.push(ae.walkTokens.call(this,Ce)),me&&(T=T.concat(me.call(this,Ce))),T}}ie&&(ee.extensions=de),we.setOptions(ee)})},we.walkTokens=function(he,ue){for(var ye=[],ee=function(){var me=ie.value;switch(ye=ye.concat(ue.call(we,me)),me.type){case"table":{for(var Ce=M(me.header),T;!(T=Ce()).done;){var V=T.value;ye=ye.concat(we.walkTokens(V.tokens,ue))}for(var G=M(me.rows),J;!(J=G()).done;)for(var q=J.value,x=M(q),le;!(le=x()).done;){var Oe=le.value;ye=ye.concat(we.walkTokens(Oe.tokens,ue))}break}case"list":{ye=ye.concat(we.walkTokens(me.items,ue));break}default:we.defaults.extensions&&we.defaults.extensions.childTokens&&we.defaults.extensions.childTokens[me.type]?we.defaults.extensions.childTokens[me.type].forEach(function(je){ye=ye.concat(we.walkTokens(me[je],ue))}):me.tokens&&(ye=ye.concat(we.walkTokens(me.tokens,ue)))}},de=M(he),ie;!(ie=de()).done;)ee();return ye},we.parseInline=function(he,ue){if(typeof he>"u"||he===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");ue=I({},we.defaults,ue||{}),y(ue);try{var ye=Q.lexInline(he,ue);return ue.walkTokens&&we.walkTokens(ye,ue.walkTokens),fe.parseInline(ye,ue)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+p(ee.message+"",!0)+"</pre>";throw ee}},we.Parser=fe,we.parser=fe.parse,we.Renderer=De,we.TextRenderer=ke,we.Lexer=Q,we.lexer=Q.lex,we.Tokenizer=U,we.Slugger=Pe,we.parse=we;var ne=we.options,re=we.setOptions,pe=we.use,_=we.walkTokens,W=we.parseInline,ce=we,be=fe.parse,se=Q.lex;ve.Lexer=Q,ve.Parser=fe,ve.Renderer=De,ve.Slugger=Pe,ve.TextRenderer=ke,ve.Tokenizer=U,ve.getDefaults=R,ve.lexer=se,ve.marked=we,ve.options=ne,ve.parse=ce,ve.parseInline=W,ve.parser=be,ve.setOptions=re,ve.use=pe,ve.walkTokens=_,Object.defineProperty(ve,"__esModule",{value:!0})}),define(Ae[121],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Tl=e.rot=e.$Rl=void 0;function E($,D,g){return Math.min(Math.max($,D),g)}e.$Rl=E;function L($,D){return(D+$%D)%D}e.rot=L;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Tl=P;class M{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Ul=M;class R{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const g=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Vl=R}),function(){function ve(P){const M=[];typeof P=="number"&&M.push("code/timeOrigin",P);function R(D){M.push(D,Date.now())}function $(){const D=[];for(let g=0;g<M.length;g+=2)D.push({name:M[g],startTime:M[g+1]});return D}return{mark:R,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ve():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))M.push({name:R.name,startTime:Math.round(P+R.startTime)});return M}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ve(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),ve()}function E(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=E(L))}(),function(ve,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var L in E)(typeof exports=="object"?exports:ve)[L]=E[L]}}(typeof self<"u"?self:this,function(){return function(ve){var e={};function E(L){if(e[L])return e[L].exports;var P=e[L]={i:L,l:!1,exports:{}};return ve[L].call(P.exports,P,P.exports,E),P.l=!0,P.exports}return E.m=ve,E.c=e,E.d=function(L,P,M){E.o(L,P)||Object.defineProperty(L,P,{enumerable:!0,get:M})},E.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},E.t=function(L,P){if(1&P&&(L=E(L)),8&P||4&P&&typeof L=="object"&&L&&L.__esModule)return L;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:L}),2&P&&typeof L!="string")for(var R in L)E.d(M,R,function($){return L[$]}.bind(null,R));return M},E.n=function(L){var P=L&&L.__esModule?function(){return L.default}:function(){return L};return E.d(P,"a",P),P},E.o=function(L,P){return Object.prototype.hasOwnProperty.call(L,P)},E.p="",E(E.s=0)}([function(ve,e,E){(function(L){var P;e=ve.exports=pe,P=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],D=e.src=[],g=0,A=g++;D[A]="0|[1-9]\\d*";var S=g++;D[S]="[0-9]+";var o=g++;D[o]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=g++;D[v]="("+D[A]+")\\.("+D[A]+")\\.("+D[A]+")";var p=g++;D[p]="("+D[S]+")\\.("+D[S]+")\\.("+D[S]+")";var f=g++;D[f]="(?:"+D[A]+"|"+D[o]+")";var t=g++;D[t]="(?:"+D[S]+"|"+D[o]+")";var i=g++;D[i]="(?:-("+D[f]+"(?:\\."+D[f]+")*))";var n=g++;D[n]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var u=g++;D[u]="[0-9A-Za-z-]+";var a=g++;D[a]="(?:\\+("+D[u]+"(?:\\."+D[u]+")*))";var l=g++,r="v?"+D[v]+D[i]+"?"+D[a]+"?";D[l]="^"+r+"$";var s="[v=\\s]*"+D[p]+D[n]+"?"+D[a]+"?",c=g++;D[c]="^"+s+"$";var h=g++;D[h]="((?:<|>)?=?)";var w=g++;D[w]=D[S]+"|x|X|\\*";var m=g++;D[m]=D[A]+"|x|X|\\*";var I=g++;D[I]="[v=\\s]*("+D[m]+")(?:\\.("+D[m]+")(?:\\.("+D[m]+")(?:"+D[i]+")?"+D[a]+"?)?)?";var k=g++;D[k]="[v=\\s]*("+D[w]+")(?:\\.("+D[w]+")(?:\\.("+D[w]+")(?:"+D[n]+")?"+D[a]+"?)?)?";var d=g++;D[d]="^"+D[h]+"\\s*"+D[I]+"$";var b=g++;D[b]="^"+D[h]+"\\s*"+D[k]+"$";var y=g++;D[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=g++;D[C]="(?:~>?)";var B=g++;D[B]="(\\s*)"+D[C]+"\\s+",$[B]=new RegExp(D[B],"g");var H=g++;D[H]="^"+D[C]+D[I]+"$";var U=g++;D[U]="^"+D[C]+D[k]+"$";var z=g++;D[z]="(?:\\^)";var F=g++;D[F]="(\\s*)"+D[z]+"\\s+",$[F]=new RegExp(D[F],"g");var N=g++;D[N]="^"+D[z]+D[I]+"$";var X=g++;D[X]="^"+D[z]+D[k]+"$";var Q=g++;D[Q]="^"+D[h]+"\\s*("+s+")$|^$";var De=g++;D[De]="^"+D[h]+"\\s*("+r+")$|^$";var ke=g++;D[ke]="(\\s*)"+D[h]+"\\s*("+s+"|"+D[I]+")",$[ke]=new RegExp(D[ke],"g");var Pe=g++;D[Pe]="^\\s*("+D[I]+")\\s+-\\s+("+D[I]+")\\s*$";var fe=g++;D[fe]="^\\s*("+D[k]+")\\s+-\\s+("+D[k]+")\\s*$";var we=g++;D[we]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)P(ne,D[ne]),$[ne]||($[ne]=new RegExp(D[ne]));function re(q,x){if(q instanceof pe)return q;if(typeof q!="string"||q.length>M||!(x?$[c]:$[l]).test(q))return null;try{return new pe(q,x)}catch{return null}}function pe(q,x){if(q instanceof pe){if(q.loose===x)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof pe))return new pe(q,x);P("SemVer",q,x),this.loose=x;var le=q.trim().match(x?$[c]:$[l]);if(!le)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+le[1],this.minor=+le[2],this.patch=+le[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");le[4]?this.prerelease=le[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var je=+Oe;if(je>=0&&je<R)return je}return Oe}):this.prerelease=[],this.build=le[5]?le[5].split("."):[],this.format()}e.parse=re,e.valid=function(q,x){var le=re(q,x);return le?le.version:null},e.clean=function(q,x){var le=re(q.trim().replace(/^[=v]+/,""),x);return le?le.version:null},e.SemVer=pe,pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},pe.prototype.toString=function(){return this.version},pe.prototype.compare=function(q){return P("SemVer.compare",this.version,this.loose,q),q instanceof pe||(q=new pe(q,this.loose)),this.compareMain(q)||this.comparePre(q)},pe.prototype.compareMain=function(q){return q instanceof pe||(q=new pe(q,this.loose)),W(this.major,q.major)||W(this.minor,q.minor)||W(this.patch,q.patch)},pe.prototype.comparePre=function(q){if(q instanceof pe||(q=new pe(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var x=0;do{var le=this.prerelease[x],Oe=q.prerelease[x];if(P("prerelease compare",x,le,Oe),le===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(le===void 0)return-1;if(le!==Oe)return W(le,Oe)}while(++x)},pe.prototype.inc=function(q,x){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var le=this.prerelease.length;--le>=0;)typeof this.prerelease[le]=="number"&&(this.prerelease[le]++,le=-2);le===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,x,le,Oe){typeof le=="string"&&(Oe=le,le=void 0);try{return new pe(q,le).inc(x,Oe).version}catch{return null}},e.diff=function(q,x){if(he(q,x))return null;var le=re(q),Oe=re(x);if(le.prerelease.length||Oe.prerelease.length){for(var je in le)if((je==="major"||je==="minor"||je==="patch")&&le[je]!==Oe[je])return"pre"+je;return"prerelease"}for(var je in le)if((je==="major"||je==="minor"||je==="patch")&&le[je]!==Oe[je])return je},e.compareIdentifiers=W;var _=/^[0-9]+$/;function W(q,x){var le=_.test(q),Oe=_.test(x);return le&&Oe&&(q=+q,x=+x),le&&!Oe?-1:Oe&&!le?1:q<x?-1:q>x?1:0}function ce(q,x,le){return new pe(q,le).compare(new pe(x,le))}function be(q,x,le){return ce(q,x,le)>0}function se(q,x,le){return ce(q,x,le)<0}function he(q,x,le){return ce(q,x,le)===0}function ue(q,x,le){return ce(q,x,le)!==0}function ye(q,x,le){return ce(q,x,le)>=0}function ee(q,x,le){return ce(q,x,le)<=0}function de(q,x,le,Oe){var je;switch(x){case"===":typeof q=="object"&&(q=q.version),typeof le=="object"&&(le=le.version),je=q===le;break;case"!==":typeof q=="object"&&(q=q.version),typeof le=="object"&&(le=le.version),je=q!==le;break;case"":case"=":case"==":je=he(q,le,Oe);break;case"!=":je=ue(q,le,Oe);break;case">":je=be(q,le,Oe);break;case">=":je=ye(q,le,Oe);break;case"<":je=se(q,le,Oe);break;case"<=":je=ee(q,le,Oe);break;default:throw new TypeError("Invalid operator: "+x)}return je}function ie(q,x){if(q instanceof ie){if(q.loose===x)return q;q=q.value}if(!(this instanceof ie))return new ie(q,x);P("comparator",q,x),this.loose=x,this.parse(q),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(q,x){return W(x,q)},e.major=function(q,x){return new pe(q,x).major},e.minor=function(q,x){return new pe(q,x).minor},e.patch=function(q,x){return new pe(q,x).patch},e.compare=ce,e.compareLoose=function(q,x){return ce(q,x,!0)},e.rcompare=function(q,x,le){return ce(x,q,le)},e.sort=function(q,x){return q.sort(function(le,Oe){return e.compare(le,Oe,x)})},e.rsort=function(q,x){return q.sort(function(le,Oe){return e.rcompare(le,Oe,x)})},e.gt=be,e.lt=se,e.eq=he,e.neq=ue,e.gte=ye,e.lte=ee,e.cmp=de,e.Comparator=ie;var ae={};function me(q,x){if(q instanceof me)return q.loose===x?q:new me(q.raw,x);if(q instanceof ie)return new me(q.value,x);if(!(this instanceof me))return new me(q,x);if(this.loose=x,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(le){return this.parseRange(le.trim())},this).filter(function(le){return le.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Ce(q){return!q||q.toLowerCase()==="x"||q==="*"}function T(q,x,le,Oe,je,Qe,Ge,_e,Xe,xe,it,tt,ze){return((x=Ce(le)?"":Ce(Oe)?">="+le+".0.0":Ce(je)?">="+le+"."+Oe+".0":">="+x)+" "+(_e=Ce(Xe)?"":Ce(xe)?"<"+(+Xe+1)+".0.0":Ce(it)?"<"+Xe+"."+(+xe+1)+".0":tt?"<="+Xe+"."+xe+"."+it+"-"+tt:"<="+_e)).trim()}function V(q,x){for(var le=0;le<q.length;le++)if(!q[le].test(x))return!1;if(x.prerelease.length){for(le=0;le<q.length;le++)if(P(q[le].semver),q[le].semver!==ae&&q[le].semver.prerelease.length>0){var Oe=q[le].semver;if(Oe.major===x.major&&Oe.minor===x.minor&&Oe.patch===x.patch)return!0}return!1}return!0}function G(q,x,le){try{x=new me(x,le)}catch{return!1}return x.test(q)}function J(q,x,le,Oe){var je,Qe,Ge,_e,Xe;switch(q=new pe(q,Oe),x=new me(x,Oe),le){case">":je=be,Qe=ee,Ge=se,_e=">",Xe=">=";break;case"<":je=se,Qe=ye,Ge=be,_e="<",Xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(q,x,Oe))return!1;for(var xe=0;xe<x.set.length;++xe){var it=x.set[xe],tt=null,ze=null;if(it.forEach(function(ut){ut.semver===ae&&(ut=new ie(">=0.0.0")),tt=tt||ut,ze=ze||ut,je(ut.semver,tt.semver,Oe)?tt=ut:Ge(ut.semver,ze.semver,Oe)&&(ze=ut)}),tt.operator===_e||tt.operator===Xe||(!ze.operator||ze.operator===_e)&&Qe(q,ze.semver)||ze.operator===Xe&&Ge(q,ze.semver))return!1}return!0}ie.prototype.parse=function(q){var x=this.loose?$[Q]:$[De],le=q.match(x);if(!le)throw new TypeError("Invalid comparator: "+q);this.operator=le[1],this.operator==="="&&(this.operator=""),le[2]?this.semver=new pe(le[2],this.loose):this.semver=ae},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(q){return P("Comparator.test",q,this.loose),this.semver===ae||(typeof q=="string"&&(q=new pe(q,this.loose)),de(q,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(q,x){if(!(q instanceof ie))throw new TypeError("a Comparator is required");var le;if(this.operator==="")return le=new me(q.value,x),G(this.value,le,x);if(q.operator==="")return le=new me(this.value,x),G(q.semver,le,x);var Oe=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Qe=this.semver.version===q.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),_e=de(this.semver,"<",q.semver,x)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),Xe=de(this.semver,">",q.semver,x)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Oe||je||Qe&&Ge||_e||Xe},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(q){var x=this.loose;q=q.trim(),P("range",q,x);var le=x?$[fe]:$[Pe];q=q.replace(le,T),P("hyphen replace",q),q=q.replace($[ke],"$1$2$3"),P("comparator trim",q,$[ke]),q=(q=(q=q.replace($[B],"$1~")).replace($[F],"$1^")).split(/\s+/).join(" ");var Oe=x?$[Q]:$[De],je=q.split(" ").map(function(Qe){return function(Ge,_e){return P("comp",Ge),Ge=function(Xe,xe){return Xe.trim().split(/\s+/).map(function(it){return function(tt,ze){P("caret",tt,ze);var ut=ze?$[X]:$[N];return tt.replace(ut,function(Z,Y,Ee,Be,Ne){var Ye;return P("caret",tt,Z,Y,Ee,Be,Ne),Ce(Y)?Ye="":Ce(Ee)?Ye=">="+Y+".0.0 <"+(+Y+1)+".0.0":Ce(Be)?Ye=Y==="0"?">="+Y+"."+Ee+".0 <"+Y+"."+(+Ee+1)+".0":">="+Y+"."+Ee+".0 <"+(+Y+1)+".0.0":Ne?(P("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ye=Y==="0"?Ee==="0"?">="+Y+"."+Ee+"."+Be+Ne+" <"+Y+"."+Ee+"."+(+Be+1):">="+Y+"."+Ee+"."+Be+Ne+" <"+Y+"."+(+Ee+1)+".0":">="+Y+"."+Ee+"."+Be+Ne+" <"+(+Y+1)+".0.0"):(P("no pr"),Ye=Y==="0"?Ee==="0"?">="+Y+"."+Ee+"."+Be+" <"+Y+"."+Ee+"."+(+Be+1):">="+Y+"."+Ee+"."+Be+" <"+Y+"."+(+Ee+1)+".0":">="+Y+"."+Ee+"."+Be+" <"+(+Y+1)+".0.0"),P("caret return",Ye),Ye})}(it,xe)}).join(" ")}(Ge,_e),P("caret",Ge),Ge=function(Xe,xe){return Xe.trim().split(/\s+/).map(function(it){return function(tt,ze){var ut=ze?$[U]:$[H];return tt.replace(ut,function(Z,Y,Ee,Be,Ne){var Ye;return P("tilde",tt,Z,Y,Ee,Be,Ne),Ce(Y)?Ye="":Ce(Ee)?Ye=">="+Y+".0.0 <"+(+Y+1)+".0.0":Ce(Be)?Ye=">="+Y+"."+Ee+".0 <"+Y+"."+(+Ee+1)+".0":Ne?(P("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ye=">="+Y+"."+Ee+"."+Be+Ne+" <"+Y+"."+(+Ee+1)+".0"):Ye=">="+Y+"."+Ee+"."+Be+" <"+Y+"."+(+Ee+1)+".0",P("tilde return",Ye),Ye})}(it,xe)}).join(" ")}(Ge,_e),P("tildes",Ge),Ge=function(Xe,xe){return P("replaceXRanges",Xe,xe),Xe.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var ut=ze?$[b]:$[d];return tt.replace(ut,function(Z,Y,Ee,Be,Ne,Ye){P("xRange",tt,Z,Y,Ee,Be,Ne,Ye);var nt=Ce(Ee),$t=nt||Ce(Be),wt=$t||Ce(Ne);return Y==="="&&wt&&(Y=""),nt?Z=Y===">"||Y==="<"?"<0.0.0":"*":Y&&wt?($t&&(Be=0),wt&&(Ne=0),Y===">"?(Y=">=",$t?(Ee=+Ee+1,Be=0,Ne=0):wt&&(Be=+Be+1,Ne=0)):Y==="<="&&(Y="<",$t?Ee=+Ee+1:Be=+Be+1),Z=Y+Ee+"."+Be+"."+Ne):$t?Z=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":wt&&(Z=">="+Ee+"."+Be+".0 <"+Ee+"."+(+Be+1)+".0"),P("xRange return",Z),Z})}(it,xe)}).join(" ")}(Ge,_e),P("xrange",Ge),Ge=function(Xe,xe){return P("replaceStars",Xe,xe),Xe.trim().replace($[we],"")}(Ge,_e),P("stars",Ge),Ge}(Qe,x)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Qe){return!!Qe.match(Oe)})),je=je.map(function(Qe){return new ie(Qe,x)})},me.prototype.intersects=function(q,x){if(!(q instanceof me))throw new TypeError("a Range is required");return this.set.some(function(le){return le.every(function(Oe){return q.set.some(function(je){return je.every(function(Qe){return Oe.intersects(Qe,x)})})})})},e.toComparators=function(q,x){return new me(q,x).set.map(function(le){return le.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},me.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new pe(q,this.loose));for(var x=0;x<this.set.length;x++)if(V(this.set[x],q))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(q,x,le){var Oe=null,je=null;try{var Qe=new me(x,le)}catch{return null}return q.forEach(function(Ge){Qe.test(Ge)&&(Oe&&je.compare(Ge)!==-1||(je=new pe(Oe=Ge,le)))}),Oe},e.minSatisfying=function(q,x,le){var Oe=null,je=null;try{var Qe=new me(x,le)}catch{return null}return q.forEach(function(Ge){Qe.test(Ge)&&(Oe&&je.compare(Ge)!==1||(je=new pe(Oe=Ge,le)))}),Oe},e.validRange=function(q,x){try{return new me(q,x).range||"*"}catch{return null}},e.ltr=function(q,x,le){return J(q,x,"<",le)},e.gtr=function(q,x,le){return J(q,x,">",le)},e.outside=J,e.prerelease=function(q,x){var le=re(q,x);return le&&le.prerelease.length?le.prerelease:null},e.intersects=function(q,x,le){return q=new me(q,le),x=new me(x,le),q.intersects(x)},e.coerce=function(q){if(q instanceof pe)return q;if(typeof q!="string")return null;var x=q.match($[y]);return x==null?null:re((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,E(1))},function(ve,e){var E,L,P=ve.exports={};function M(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function $(t){if(E===setTimeout)return setTimeout(t,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(t,0);try{return E(t,0)}catch{try{return E.call(null,t,0)}catch{return E.call(this,t,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{L=typeof clearTimeout=="function"?clearTimeout:R}catch{L=R}})();var D,g=[],A=!1,S=-1;function o(){A&&D&&(A=!1,D.length?g=D.concat(g):S=-1,g.length&&v())}function v(){if(!A){var t=$(o);A=!0;for(var i=g.length;i;){for(D=g,g=[];++S<i;)D&&D[S].run();S=-1,i=g.length}D=null,A=!1,function(n){if(L===clearTimeout)return clearTimeout(n);if((L===R||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(n);try{L(n)}catch{try{return L.call(null,n)}catch{return L.call(this,n)}}}(t)}}function p(t,i){this.fun=t,this.array=i}function f(){}P.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)i[n-1]=arguments[n];g.push(new p(t,i)),g.length!==1||A||$(v)},p.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=f,P.addListener=f,P.once=f,P.off=f,P.removeListener=f,P.removeAllListeners=f,P.emit=f,P.prependListener=f,P.prependOnceListener=f,P.listeners=function(t){return[]},P.binding=function(t){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(t){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Ae[122],Re([1,0,11,6]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=void 0;function P(a){const l=a;return l?typeof l.read=="function":!1}e.$Zd=P;function M(a){const l=a;return l?[l.on,l.pause,l.resume,l.destroy].every(r=>typeof r=="function"):!1}e.$1d=M;function R(a){const l=a;return l?M(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$2d=R;function $(a,l){return new D(a,l)}e.$3d=$;class D{constructor(l,r){this.e=l,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(r=>r(l))}h(l){this.c.error.length===0?(0,E.$Z)(l):this.c.error.slice(0).forEach(r=>r(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,r){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(l,r){if(this.a.destroyed)return;let s;switch(l){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const c=s.indexOf(r);c>=0&&s.splice(c,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(a,l){const r=[];let s;for(;(s=a.read())!==null;)r.push(s);return l(r)}e.$4d=g;function A(a,l,r){const s=[];let c;for(;(c=a.read())!==null&&s.length<r;)s.push(c);return c===null&&s.length>0?l(s):{read:()=>{if(s.length>0)return s.shift();if(typeof c<"u"){const h=c;return c=void 0,h}return a.read()}}}e.$5d=A;function S(a,l){return new Promise((r,s)=>{const c=[];o(a,{onData:h=>{l&&c.push(h)},onError:h=>{l?s(h):r(void 0)},onEnd:()=>{r(l?l(c):void 0)}})})}e.$6d=S;function o(a,l,r){a.on("error",s=>{r?.isCancellationRequested||l.onError(s)}),a.on("end",()=>{r?.isCancellationRequested||l.onEnd()}),a.on("data",s=>{r?.isCancellationRequested||l.onData(s)})}e.$7d=o;function v(a,l){return new Promise((r,s)=>{const c=new L.$Qc,h=[],w=k=>{if(h.push(k),h.length>l)return c.dispose(),a.pause(),r({stream:a,buffer:h,ended:!1})},m=k=>(c.dispose(),s(k)),I=()=>(c.dispose(),r({stream:a,buffer:h,ended:!0}));c.add((0,L.$Pc)(()=>a.removeListener("error",m))),a.on("error",m),c.add((0,L.$Pc)(()=>a.removeListener("end",I))),a.on("end",I),c.add((0,L.$Pc)(()=>a.removeListener("data",w))),a.on("data",w)})}e.$8d=v;function p(a,l){const r=$(l);return r.end(a),r}e.$9d=p;function f(){const a=$(()=>{throw new Error("not supported")});return a.end(),a}e.$0d=f;function t(a){let l=!1;return{read:()=>l?null:(l=!0,a)}}e.$$d=t;function i(a,l,r){const s=$(r);return o(a,{onData:c=>s.write(l.data(c)),onError:c=>s.error(l.error?l.error(c):c),onEnd:()=>s.end()}),s}e.$_d=i;function n(a,l,r){let s=!1;return{read:()=>{const c=l.read();return s?c:(s=!0,c!==null?r([a,c]):a)}}}e.$ae=n;function u(a,l,r){let s=!1;const c=$(r);return o(l,{onData:h=>s?c.write(h):(s=!0,c.write(r([a,h]))),onError:h=>c.error(h),onEnd:()=>{s||(s=!0,c.write(a)),c.end()}}),c}e.$be=u}),define(Ae[24],Re([1,0,44,122]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=void 0;const P=typeof Buffer<"u",M=new E.$U(()=>new Uint8Array(256));let R,$;class D{static alloc(y){return P?new D(Buffer.allocUnsafe(y)):new D(new Uint8Array(y))}static wrap(y){return P&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new D(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&P?new D(Buffer.from(y)):(R||(R=new TextEncoder),new D(R.encode(y)))}static fromByteArray(y){const C=D.alloc(y.length);for(let B=0,H=y.length;B<H;B++)C.buffer[B]=y[B];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let U=0,z=y.length;U<z;U++)C+=y[U].byteLength}const B=D.alloc(C);let H=0;for(let U=0,z=y.length;U<z;U++){const F=y[U];B.set(F,H),H+=F.byteLength}return B}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=D.alloc(this.byteLength);return y.set(this),y}toString(){return P?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(y,C){return new D(this.buffer.subarray(y,C))}set(y,C){if(y instanceof D)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return o(this.buffer,y)}writeUInt32BE(y,C){v(this.buffer,y,C)}readUInt32LE(y){return p(this.buffer,y)}writeUInt32LE(y,C){f(this.buffer,y,C)}readUInt8(y){return t(this.buffer,y)}writeUInt8(y,C){i(this.buffer,y,C)}indexOf(y,C=0){return g(this.buffer,y instanceof D?y.buffer:y,C)}}e.$ce=D;function g(b,y,C=0){const B=y.byteLength,H=b.byteLength;if(B===0)return 0;if(B===1)return b.indexOf(y[0]);if(B>H-C)return-1;const U=M.value;U.fill(y.length);for(let X=0;X<y.length;X++)U[y[X]]=y.length-X-1;let z=C+y.length-1,F=z,N=-1;for(;z<H;)if(b[z]===y[F]){if(F===0){N=z;break}z--,F--}else z+=Math.max(y.length-F,U[b[z]]),F=y.length-1;return N}e.$de=g;function A(b,y){return b[y+0]<<0>>>0|b[y+1]<<8>>>0}e.$ee=A;function S(b,y,C){b[C+0]=y&255,y=y>>>8,b[C+1]=y&255}e.$fe=S;function o(b,y){return b[y]*2**24+b[y+1]*2**16+b[y+2]*2**8+b[y+3]}e.$ge=o;function v(b,y,C){b[C+3]=y,y=y>>>8,b[C+2]=y,y=y>>>8,b[C+1]=y,y=y>>>8,b[C]=y}e.$he=v;function p(b,y){return b[y+0]<<0>>>0|b[y+1]<<8>>>0|b[y+2]<<16>>>0|b[y+3]<<24>>>0}e.$ie=p;function f(b,y,C){b[C+0]=y&255,y=y>>>8,b[C+1]=y&255,y=y>>>8,b[C+2]=y&255,y=y>>>8,b[C+3]=y&255}e.$je=f;function t(b,y){return b[y]}e.$ke=t;function i(b,y,C){b[C]=y}e.$le=i;function n(b){return L.$4d(b,y=>D.concat(y))}e.$me=n;function u(b){return L.$$d(b)}e.$ne=u;function a(b){return L.$6d(b,y=>D.concat(y))}e.$oe=a;async function l(b){return b.ended?D.concat(b.buffer):D.concat([...b.buffer,await a(b.stream)])}e.$pe=l;function r(b){return L.$9d(b,y=>D.concat(y))}e.$qe=r;function s(b){return L.$_d(b,{data:y=>typeof y=="string"?D.fromString(y):D.wrap(y)},y=>D.concat(y))}e.$re=s;function c(b){return L.$3d(y=>D.concat(y),b)}e.$se=c;function h(b,y){return L.$ae(b,y,C=>D.concat(C))}e.$te=h;function w(b,y){return L.$be(b,y,C=>D.concat(C))}e.$ue=w;function m(b){let y=0,C=0,B=0;const H=new Uint8Array(Math.floor(b.length/4*3)),U=F=>{switch(C){case 3:H[B++]=y|F,C=0;break;case 2:H[B++]=y|F>>>2,y=F<<6,C=3;break;case 1:H[B++]=y|F>>>4,y=F<<4,C=2;break;default:y=F<<2,C=1}};for(let F=0;F<b.length;F++){const N=b.charCodeAt(F);if(N>=65&&N<=90)U(N-65);else if(N>=97&&N<=122)U(N-97+26);else if(N>=48&&N<=57)U(N-48+52);else if(N===43||N===45)U(62);else if(N===47||N===95)U(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${b[F]}`)}}const z=B;for(;C>0;)U(0);return D.wrap(H).slice(0,z)}e.$ve=m;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:b},y=!0,C=!1){const B=C?k:I;let H="";const U=b.byteLength%3;let z=0;for(;z<b.byteLength-U;z+=3){const F=b[z+0],N=b[z+1],X=b[z+2];H+=B[F>>>2],H+=B[(F<<4|N>>>4)&63],H+=B[(N<<2|X>>>6)&63],H+=B[X&63]}if(U===1){const F=b[z+0];H+=B[F>>>2],H+=B[F<<4&63],y&&(H+="==")}else if(U===2){const F=b[z+0],N=b[z+1];H+=B[F>>>2],H+=B[(F<<4|N>>>4)&63],H+=B[N<<2&63],y&&(H+="=")}return H}e.$we=d}),define(Ae[123],Re([1,0,28,13]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.FuzzyScore=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.or=void 0;function P(...ie){return function(ae,me){for(let Ce=0,T=ie.length;Ce<T;Ce++){const V=ie[Ce](ae,me);if(V)return V}return null}}e.or=P,e.$Fj=M.bind(void 0,!1),e.$Gj=M.bind(void 0,!0);function M(ie,ae,me){if(!me||me.length<ae.length)return null;let Ce;return ie?Ce=L.$4e(me,ae):Ce=me.indexOf(ae)===0,Ce?ae.length>0?[{start:0,end:ae.length}]:[]:null}function R(ie,ae){const me=ae.toLowerCase().indexOf(ie.toLowerCase());return me===-1?null:[{start:me,end:me+ie.length}]}e.$Hj=R;function $(ie,ae){return D(ie.toLowerCase(),ae.toLowerCase(),0,0)}e.$Ij=$;function D(ie,ae,me,Ce){if(me===ie.length)return[];if(Ce===ae.length)return null;if(ie[me]===ae[Ce]){let T=null;return(T=D(ie,ae,me+1,Ce+1))?i({start:Ce,end:Ce+1},T):null}return D(ie,ae,me,Ce+1)}function g(ie){return 97<=ie&&ie<=122}function A(ie){return 65<=ie&&ie<=90}e.$Jj=A;function S(ie){return 48<=ie&&ie<=57}function o(ie){return ie===32||ie===9||ie===10||ie===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>v.add(ie.charCodeAt(0)));function p(ie){return o(ie)||v.has(ie)}function f(ie,ae){return ie===ae||p(ie)&&p(ae)}function t(ie){return g(ie)||A(ie)||S(ie)}function i(ie,ae){return ae.length===0?ae=[ie]:ie.end===ae[0].start?ae[0].start=ie.start:ae.unshift(ie),ae}function n(ie,ae){for(let me=ae;me<ie.length;me++){const Ce=ie.charCodeAt(me);if(A(Ce)||S(Ce)||me>0&&!t(ie.charCodeAt(me-1)))return me}return ie.length}function u(ie,ae,me,Ce){if(me===ie.length)return[];if(Ce===ae.length)return null;if(ie[me]!==ae[Ce].toLowerCase())return null;{let T=null,V=Ce+1;for(T=u(ie,ae,me+1,Ce+1);!T&&(V=n(ae,V))<ae.length;)T=u(ie,ae,me+1,V),V++;return T===null?null:i({start:Ce,end:Ce+1},T)}}function a(ie){let ae=0,me=0,Ce=0,T=0,V=0;for(let le=0;le<ie.length;le++)V=ie.charCodeAt(le),A(V)&&ae++,g(V)&&me++,t(V)&&Ce++,S(V)&&T++;const G=ae/ie.length,J=me/ie.length,q=Ce/ie.length,x=T/ie.length;return{upperPercent:G,lowerPercent:J,alphaPercent:q,numericPercent:x}}function l(ie){const{upperPercent:ae,lowerPercent:me}=ie;return me===0&&ae>.6}function r(ie){const{upperPercent:ae,lowerPercent:me,alphaPercent:Ce,numericPercent:T}=ie;return me>.2&&ae<.8&&Ce>.6&&T<.2}function s(ie){let ae=0,me=0,Ce=0,T=0;for(let V=0;V<ie.length;V++)Ce=ie.charCodeAt(V),A(Ce)&&ae++,g(Ce)&&me++,o(Ce)&&T++;return(ae===0||me===0)&&T===0?ie.length<=30:ae<=5}function c(ie,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!s(ie)||ae.length>60)return null;const me=a(ae);if(!r(me)){if(!l(me))return null;ae=ae.toLowerCase()}let Ce=null,T=0;for(ie=ie.toLowerCase();T<ae.length&&(Ce=u(ie,ae,0,T))===null;)T=n(ae,T+1);return Ce}e.$Kj=c;function h(ie,ae,me=!1){if(!ae||ae.length===0)return null;let Ce=null,T=0;for(ie=ie.toLowerCase(),ae=ae.toLowerCase();T<ae.length&&(Ce=w(ie,ae,0,T,me))===null;)T=m(ae,T+1);return Ce}e.$Lj=h;function w(ie,ae,me,Ce,T){if(me===ie.length)return[];if(Ce===ae.length)return null;if(f(ie.charCodeAt(me),ae.charCodeAt(Ce))){let V=null,G=Ce+1;if(V=w(ie,ae,me+1,Ce+1,T),!T)for(;!V&&(G=m(ae,G))<ae.length;)V=w(ie,ae,me+1,G,T),G++;return V?ie.charCodeAt(me)!==ae.charCodeAt(Ce)?V:i({start:Ce,end:Ce+1},V):null}else return null}function m(ie,ae){for(let me=ae;me<ie.length;me++)if(p(ie.charCodeAt(me))||me>0&&p(ie.charCodeAt(me-1)))return me;return ie.length}const I=P(e.$Gj,c,R),k=P(e.$Gj,c,$),d=new E.$Cc(1e4);function b(ie,ae,me=!1){if(typeof ie!="string"||typeof ae!="string")return null;let Ce=d.get(ie);Ce||(Ce=new RegExp(L.$Me(ie),"i"),d.set(ie,Ce));const T=Ce.exec(ae);return T?[{start:T.index,end:T.index+T[0].length}]:me?k(ie,ae):I(ie,ae)}e.$Mj=b;function y(ie,ae){const me=be(ie,ie.toLowerCase(),0,ae,ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return me?B(me):null}e.$Nj=y;function C(ie,ae,me,Ce,T,V){const G=Math.min(13,ie.length);for(;me<G;me++){const J=be(ie,ae,me,Ce,T,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,V]}e.$Oj=C;function B(ie){if(typeof ie>"u")return[];const ae=[],me=ie[1];for(let Ce=ie.length-1;Ce>1;Ce--){const T=ie[Ce]+me,V=ae[ae.length-1];V&&V.end===T?V.end=T+1:ae.push({start:T,end:T+1})}return ae}e.$Pj=B;const H=128;function U(){const ie=[],ae=[];for(let me=0;me<=H;me++)ae[me]=0;for(let me=0;me<=H;me++)ie.push(ae.slice(0));return ie}function z(ie){const ae=[];for(let me=0;me<=ie;me++)ae[me]=0;return ae}const F=z(2*H),N=z(2*H),X=U(),Q=U(),De=U(),ke=!1;function Pe(ie,ae,me,Ce,T){function V(J,q,x=" "){for(;J.length<q;)J=x+J;return J}let G=` |   |${Ce.split("").map(J=>V(J,3)).join("|")}
`;for(let J=0;J<=me;J++)J===0?G+=" |":G+=`${ae[J-1]}|`,G+=ie[J].slice(0,T+1).map(q=>V(q.toString(),3)).join("|")+`
`;return G}function fe(ie,ae,me,Ce){ie=ie.substr(ae),me=me.substr(Ce),console.log(Pe(Q,ie,ie.length,me,me.length)),console.log(Pe(De,ie,ie.length,me,me.length)),console.log(Pe(X,ie,ie.length,me,me.length))}function we(ie,ae){if(ae<0||ae>=ie.length)return!1;const me=ie.codePointAt(ae);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$jf(me)}}function ne(ie,ae){if(ae<0||ae>=ie.length)return!1;switch(ie.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function re(ie,ae,me){return ae[ie]!==me[ie]}function pe(ie,ae,me,Ce,T,V,G=!1){for(;ae<me&&T<V;)ie[ae]===Ce[T]&&(G&&(F[ae]=T),ae+=1),T+=1;return ae===me}e.$Qj=pe;var _;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(_||(_={}));var W;(function(ie){ie.Default=[-100,0];function ae(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}ie.isDefault=ae})(W||(e.FuzzyScore=W={}));class ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ae,me){this.firstMatchCanBeWeak=ae,this.boostFullMatch=me}}e.$Rj=ce;function be(ie,ae,me,Ce,T,V,G=ce.default){const J=ie.length>H?H:ie.length,q=Ce.length>H?H:Ce.length;if(me>=J||V>=q||J-me>q-V||!pe(ae,me,J,T,V,q,!0))return;se(J,q,me,V,ae,T);let x=1,le=1,Oe=me,je=V;const Qe=[!1];for(x=1,Oe=me;Oe<J;x++,Oe++){const it=F[Oe],tt=N[Oe],ze=Oe+1<J?N[Oe+1]:q;for(le=it-V+1,je=it;je<ze;le++,je++){let ut=Number.MIN_SAFE_INTEGER,Z=!1;je<=tt&&(ut=he(ie,ae,Oe,me,Ce,T,je,q,V,X[x-1][le-1]===0,Qe));let Y=0;ut!==Number.MAX_SAFE_INTEGER&&(Z=!0,Y=ut+Q[x-1][le-1]);const Ee=je>it,Be=Ee?Q[x][le-1]+(X[x][le-1]>0?-5:0):0,Ne=je>it+1&&X[x][le-1]>0,Ye=Ne?Q[x][le-2]+(X[x][le-2]>0?-5:0):0;if(Ne&&(!Ee||Ye>=Be)&&(!Z||Ye>=Y))Q[x][le]=Ye,De[x][le]=3,X[x][le]=0;else if(Ee&&(!Z||Be>=Y))Q[x][le]=Be,De[x][le]=2,X[x][le]=0;else if(Z)Q[x][le]=Y,De[x][le]=1,X[x][le]=X[x-1][le-1]+1;else throw new Error("not possible")}}if(ke&&fe(ie,me,Ce,V),!Qe[0]&&!G.firstMatchCanBeWeak)return;x--,le--;const Ge=[Q[x][le],V];let _e=0,Xe=0;for(;x>=1;){let it=le;do{const tt=De[x][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);_e>1&&ae[me+x-1]===T[V+le-1]&&!re(it+V-1,Ce,T)&&_e+1>X[x][it]&&(it=le),it===le?_e++:_e=1,Xe||(Xe=it),x--,le=it-1,Ge.push(le)}q===J&&G.boostFullMatch&&(Ge[0]+=2);const xe=Xe-J;return Ge[0]-=xe,Ge}e.$Sj=be;function se(ie,ae,me,Ce,T,V){let G=ie-1,J=ae-1;for(;G>=me&&J>=Ce;)T[G]===V[J]&&(N[G]=J,G--),J--}function he(ie,ae,me,Ce,T,V,G,J,q,x,le){if(ae[me]!==V[G])return Number.MIN_SAFE_INTEGER;let Oe=1,je=!1;return G===me-Ce?Oe=ie[me]===T[G]?7:5:re(G,T,V)&&(G===0||!re(G-1,T,V))?(Oe=ie[me]===T[G]?7:5,je=!0):we(V,G)&&(G===0||!we(V,G-1))?Oe=5:(we(V,G-1)||ne(V,G-1))&&(Oe=5,je=!0),Oe>1&&me===Ce&&(le[0]=!0),je||(je=re(G,T,V)||we(V,G-1)||ne(V,G-1)),me===Ce?G>q&&(Oe-=je?3:5):x?Oe+=je?2:0:Oe+=je?0:1,G+1===J&&(Oe-=je?3:5),Oe}function ue(ie,ae,me,Ce,T,V,G){return ee(ie,ae,me,Ce,T,V,!0,G)}e.$Tj=ue;function ye(ie,ae,me,Ce,T,V,G){return ee(ie,ae,me,Ce,T,V,!1,G)}e.$Uj=ye;function ee(ie,ae,me,Ce,T,V,G,J){let q=be(ie,ae,me,Ce,T,V,J);if(q&&!G)return q;if(ie.length>=3){const x=Math.min(7,ie.length-1);for(let le=me+1;le<x;le++){const Oe=de(ie,le);if(Oe){const je=be(Oe,Oe.toLowerCase(),me,Ce,T,V,J);je&&(je[0]-=3,(!q||je[0]>q[0])&&(q=je))}}}return q}function de(ie,ae){if(ae+1>=ie.length)return;const me=ie[ae],Ce=ie[ae+1];if(me!==Ce)return ie.slice(0,ae)+Ce+me+ie.slice(ae+2)}}),define(Ae[31],Re([1,0,13]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(L||(L={})),function(P){const M="error",R="warning",$="warn",D="info",g="ignore";function A(o){return o?E.$3e(M,o)?P.Error:E.$3e(R,o)||E.$3e($,o)?P.Warning:E.$3e(D,o)?P.Info:P.Ignore:P.Ignore}P.fromValue=A;function S(o){switch(o){case P.Error:return M;case P.Warning:return R;case P.Info:return D;default:return g}}P.toString=S}(L||(L={})),e.default=L}),define(Ae[124],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Ld=Symbol("MicrotaskDelay")}),define(Ae[51],Re([1,0,18,13]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=void 0;class P{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const p=v.charCodeAt(0),f=this.b.charCodeAt(this.c);return p-f}value(){return this.b[this.c]}}e.$Uh=P;class M{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,L.$We)(v,this.b,0,v.length,this.c,this.d):(0,L.$Ye)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Vh=M;class R{constructor(v=!0,p=!0){this.f=v,this.g=p}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let p=v.length-1;p>=0;p--,this.c--){const f=this.b.charCodeAt(p);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,L.$We)(v,this.b,0,v.length,this.d,this.e):(0,L.$Ye)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Wh=R;var $;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})($||($={}));class D{constructor(v,p){this.f=v,this.g=p,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,L.$Xe)(v,this.c.scheme);if(this.d[this.e]===2)return(0,L.$Xe)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,L.$Ve)(v,this.c.query);if(this.d[this.e]===5)return(0,L.$Ve)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Xh=D;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(A||(A={}));class S{static forUris(v=()=>!1,p=()=>!1){return new S(new D(v,p))}static forPaths(v=!1){return new S(new R(void 0,!v))}static forStrings(){return new S(new P)}static forConfigKeys(){return new S(new M)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,p){if(p){const f=p.slice(0);(0,E.$Wb)(f);for(const t of f)this.set(t,v)}else{const f=v.slice(0);(0,E.$Wb)(f);for(const t of f)this.set(t[0],t[1])}}set(v,p){const f=this.b.reset(v);let t;this.c||(this.c=new g,this.c.segment=f.value());const i=[];for(t=this.c;;){const u=f.cmp(t.segment);if(u>0)t.left||(t.left=new g,t.left.segment=f.value()),i.push([-1,t]),t=t.left;else if(u<0)t.right||(t.right=new g,t.right.segment=f.value()),i.push([1,t]),t=t.right;else if(f.hasNext())f.next(),t.mid||(t.mid=new g,t.mid.segment=f.value()),i.push([0,t]),t=t.mid;else break}const n=t.value;t.value=p,t.key=v;for(let u=i.length-1;u>=0;u--){const a=i[u][1];a.updateHeight();const l=a.balanceFactor();if(l<-1||l>1){const r=i[u][0],s=i[u+1][0];if(r===1&&s===1)i[u][1]=a.rotateLeft();else if(r===-1&&s===-1)i[u][1]=a.rotateRight();else if(r===1&&s===-1)a.right=i[u+1][1]=i[u+1][1].rotateRight(),i[u][1]=a.rotateLeft();else if(r===-1&&s===1)a.left=i[u+1][1]=i[u+1][1].rotateLeft(),i[u][1]=a.rotateRight();else throw new Error;if(u>0)switch(i[u-1][0]){case-1:i[u-1][1].left=i[u][1];break;case 1:i[u-1][1].right=i[u][1];break;case 0:i[u-1][1].mid=i[u][1];break}else this.c=i[0][1]}}return n}get(v){return this.d(v)?.value}d(v){const p=this.b.reset(v);let f=this.c;for(;f;){const t=p.cmp(f.segment);if(t>0)f=f.left;else if(t<0)f=f.right;else if(p.hasNext())p.next(),f=f.mid;else break}return f}has(v){const p=this.d(v);return!(p?.value===void 0&&p?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,p){const f=this.b.reset(v),t=[];let i=this.c;for(;i;){const n=f.cmp(i.segment);if(n>0)t.push([-1,i]),i=i.left;else if(n<0)t.push([1,i]),i=i.right;else if(f.hasNext())f.next(),t.push([0,i]),i=i.mid;else break}if(i){if(p?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const n=this.f(i.right);if(n.key){const{key:u,value:a,segment:l}=n;this.e(n.key,!1),i.key=u,i.value=a,i.segment=l}}else{const n=i.left??i.right;if(t.length>0){const[u,a]=t[t.length-1];switch(u){case-1:a.left=n;break;case 0:a.mid=n;break;case 1:a.right=n;break}}else this.c=n}for(let n=t.length-1;n>=0;n--){const u=t[n][1];u.updateHeight();const a=u.balanceFactor();if(a>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),t[n][1]=u.rotateLeft()):a<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),t[n][1]=u.rotateRight()),n>0)switch(t[n-1][0]){case-1:t[n-1][1].left=t[n][1];break;case 1:t[n-1][1].right=t[n][1];break;case 0:t[n-1][1].mid=t[n][1];break}else this.c=t[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const p=this.b.reset(v);let f=this.c,t;for(;f;){const i=p.cmp(f.segment);if(i>0)f=f.left;else if(i<0)f=f.right;else if(p.hasNext())p.next(),t=f.value||t,f=f.mid;else break}return f&&f.value||t}findSuperstr(v){return this.g(v,!1)}g(v,p){const f=this.b.reset(v);let t=this.c;for(;t;){const i=f.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.h(t.mid):p?t.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[p,f]of this)v(f,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const p=[];return this.j(v,p),p[Symbol.iterator]()}j(v,p){v&&(v.left&&this.j(v.left,p),v.value&&p.push([v.key,v.value]),v.mid&&this.j(v.mid,p),v.right&&this.j(v.right,p))}_isBalanced(){const v=p=>{if(!p)return!0;const f=p.balanceFactor();return f<-1||f>1?!1:v(p.left)&&v(p.right)};return v(this.c)}}e.$Yh=S}),define(Ae[45],Re([1,0,90]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Yj=e.ThemeColor=void 0;var L;(function(R){function $(D){return D&&typeof D=="object"&&typeof D.id=="string"}R.isThemeColor=$})(L||(e.ThemeColor=L={}));function P(R){return{id:R}}e.$Yj=P;var M;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function D(n){const u=$.exec(n.id);if(!u)return D(E.$Xj.error);const[,a,l]=u,r=["codicon","codicon-"+a];return l&&r.push("codicon-modifier-"+l.substring(1)),r}R.asClassNameArray=D;function g(n){return D(n).join(" ")}R.asClassName=g;function A(n){return"."+D(n).join(".")}R.asCSSSelector=A;function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||L.isThemeColor(n.color))}R.isThemeIcon=S;const o=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function v(n){const u=o.exec(n);if(!u)return;const[,a]=u;return{id:a}}R.fromString=v;function p(n){return{id:n}}R.fromId=p;function f(n,u){let a=n.id;const l=a.lastIndexOf("~");return l!==-1&&(a=a.substring(0,l)),u&&(a=`${a}~${u}`),{id:a}}R.modify=f;function t(n){const u=n.id.lastIndexOf("~");if(u!==-1)return n.id.substring(u+1)}R.getModifier=t;function i(n,u){return n.id===u.id&&n.color?.id===u.color?.id}R.isEqual=i})(M||(e.ThemeIcon=M={}))}),define(Ae[125],Re([1,0,123,13,45]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=void 0;const M="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${R.source}`,"g");function D(i){return i.replace($,(n,u)=>u?n:`\\${n}`)}e.$Zj=D;const g=new RegExp(`\\\\${R.source}`,"g");function A(i){return i.replace(g,n=>`\\${n}`)}e.$1j=A;const S=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function o(i){return i.indexOf(M)===-1?i:i.replace(S,(n,u,a,l)=>a?n:u||l||"")}e.$2j=o;function v(i){return i?i.replace(/\$\((.*?)\)/g,(n,u)=>` ${u} `).trim():""}e.$3j=v;const p=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(i){p.lastIndex=0;let n="";const u=[];let a=0;for(;;){const l=p.lastIndex,r=p.exec(i),s=i.substring(l,r?.index);if(s.length>0){n+=s;for(let c=0;c<s.length;c++)u.push(a)}if(!r)break;a+=r[0].length}return{text:n,iconOffsets:u}}e.$4j=f;function t(i,n,u=!1){const{text:a,iconOffsets:l}=n;if(!l||l.length===0)return(0,E.$Mj)(i,a,u);const r=(0,L.$Ke)(a," "),s=a.length-r.length,c=(0,E.$Mj)(i,r,u);if(c)for(const h of c){const w=l[h.start+s]+s;h.start+=w,h.end+=w}return c}e.$5j=t}),define(Ae[38],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(P){return E.test(P)}e.$eg=L,e.$fg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function($){for(let D=0;D<$.length;D++)$[D]=Math.floor(Math.random()*256);return $};const M=new Uint8Array(16),R=[];for(let $=0;$<256;$++)R.push($.toString(16).padStart(2,"0"));return function(){P(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let D=0,g="";return g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g}}()}),define(Ae[126],Re([1,0,18,68,38]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=e.$5s=e.$4s=e.$3s=e.$2s=void 0;function M(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.$2s=M;function R(S,o,v){const p={id:(0,P.$fg)(),name:S,uri:o,data:v};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$3s=R;class ${constructor(){this.a=new Map}get size(){let o=0;for(const v of this.a)o++;return o}has(o){return this.a.has(this.b(o))}matches(o){const v=[...this.a.keys()];return L.Iterable.some(this,([p,f])=>f.asFile())&&v.push("files"),A(D(o),v)}get(o){return this.a.get(this.b(o))?.[0]}append(o,v){const p=this.a.get(o);p?p.push(v):this.a.set(this.b(o),[v])}replace(o,v){this.a.set(this.b(o),[v])}delete(o){this.a.delete(this.b(o))}*[Symbol.iterator](){for(const[o,v]of this.a)for(const p of v)yield[o,p]}b(o){return D(o)}}e.$4s=$;function D(S){return S.toLowerCase()}function g(S,o){return A(D(S),o.map(D))}e.$5s=g;function A(S,o){if(S==="*/*")return o.length>0;if(o.includes(S))return!0;const v=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[p,f,t]=v;return t==="*"?o.some(i=>i.startsWith(f+"/")):!1}e.$6s=Object.freeze({create:S=>(0,E.$Lb)(S.map(o=>o.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$6s.split(S).filter(o=>!o.startsWith("#"))})}),define(Ae[127],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.StringEOL=void 0;var E;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function L(P){let M=0,R=0,$=0,D=0;for(let g=0,A=P.length;g<A;g++){const S=P.charCodeAt(g);S===13?(M===0&&(R=g),M++,g+1<A&&P.charCodeAt(g+1)===10?(D|=2,g++):D|=3,$=g+1):S===10&&(D|=1,M===0&&(R=g),M++,$=g+1)}return M===0&&(R=P.length),[M,R,P.length-$,D]}e.$9s=L}),define(Ae[128],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=void 0,e.$6r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[129],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=e.IndentAction=void 0;var E;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class L{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let D=0,g=$.notIn.length;D<g;D++)switch($.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,D){if($.getTokenCount()===0)return!0;const g=$.findTokenIndexAtOffset(D-2),A=$.getStandardTokenType(g);return this.isOK(A)}g($,D){for(let g=$;g<=D;g++){const A=String.fromCharCode(g);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$st=L;class P{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of $)M(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),M(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),M(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),M(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&M(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.$tt=P;function M(R,$,D){R.has($)?R.get($).push(D):R.set($,[D])}}),define(Ae[130],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.$rB=e.$qB=e.$pB=e.$oB=e.NodeColor=e.$nB=void 0;class E{constructor(t,i){this.piece=t,this.color=i,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$oB)return P(this.right);let t=this;for(;t.parent!==e.$oB&&t.parent.left!==t;)t=t.parent;return t.parent===e.$oB?e.$oB:t.parent}prev(){if(this.left!==e.$oB)return M(this.left);let t=this;for(;t.parent!==e.$oB&&t.parent.right!==t;)t=t.parent;return t.parent===e.$oB?e.$oB:t.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$nB=E;var L;(function(f){f[f.Black=0]="Black",f[f.Red=1]="Red"})(L||(e.NodeColor=L={})),e.$oB=new E(null,0),e.$oB.parent=e.$oB,e.$oB.left=e.$oB,e.$oB.right=e.$oB,e.$oB.color=0;function P(f){for(;f.left!==e.$oB;)f=f.left;return f}e.$pB=P;function M(f){for(;f.right!==e.$oB;)f=f.right;return f}e.$qB=M;function R(f){return f===e.$oB?0:f.size_left+f.piece.length+R(f.right)}function $(f){return f===e.$oB?0:f.lf_left+f.piece.lineFeedCnt+$(f.right)}function D(){e.$oB.parent=e.$oB}function g(f,t){const i=t.right;i.size_left+=t.size_left+(t.piece?t.piece.length:0),i.lf_left+=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),t.right=i.left,i.left!==e.$oB&&(i.left.parent=t),i.parent=t.parent,t.parent===e.$oB?f.root=i:t.parent.left===t?t.parent.left=i:t.parent.right=i,i.left=t,t.parent=i}e.$rB=g;function A(f,t){const i=t.left;t.left=i.right,i.right!==e.$oB&&(i.right.parent=t),i.parent=t.parent,t.size_left-=i.size_left+(i.piece?i.piece.length:0),t.lf_left-=i.lf_left+(i.piece?i.piece.lineFeedCnt:0),t.parent===e.$oB?f.root=i:t===t.parent.right?t.parent.right=i:t.parent.left=i,i.right=t,t.parent=i}e.$sB=A;function S(f,t){let i,n;if(t.left===e.$oB?(n=t,i=n.right):t.right===e.$oB?(n=t,i=n.left):(n=P(t.right),i=n.right),n===f.root){f.root=i,i.color=0,t.detach(),D(),f.root.parent=e.$oB;return}const u=n.color===1;if(n===n.parent.left?n.parent.left=i:n.parent.right=i,n===t?(i.parent=n.parent,p(f,i)):(n.parent===t?i.parent=n:i.parent=n.parent,p(f,i),n.left=t.left,n.right=t.right,n.parent=t.parent,n.color=t.color,t===f.root?f.root=n:t===t.parent.left?t.parent.left=n:t.parent.right=n,n.left!==e.$oB&&(n.left.parent=n),n.right!==e.$oB&&(n.right.parent=n),n.size_left=t.size_left,n.lf_left=t.lf_left,p(f,n)),t.detach(),i.parent.left===i){const l=R(i),r=$(i);if(l!==i.parent.size_left||r!==i.parent.lf_left){const s=l-i.parent.size_left,c=r-i.parent.lf_left;i.parent.size_left=l,i.parent.lf_left=r,v(f,i.parent,s,c)}}if(p(f,i.parent),u){D();return}let a;for(;i!==f.root&&i.color===0;)i===i.parent.left?(a=i.parent.right,a.color===1&&(a.color=0,i.parent.color=1,g(f,i.parent),a=i.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,i=i.parent):(a.right.color===0&&(a.left.color=0,a.color=1,A(f,a),a=i.parent.right),a.color=i.parent.color,i.parent.color=0,a.right.color=0,g(f,i.parent),i=f.root)):(a=i.parent.left,a.color===1&&(a.color=0,i.parent.color=1,A(f,i.parent),a=i.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,i=i.parent):(a.left.color===0&&(a.right.color=0,a.color=1,g(f,a),a=i.parent.left),a.color=i.parent.color,i.parent.color=0,a.left.color=0,A(f,i.parent),i=f.root));i.color=0,D()}e.$tB=S;function o(f,t){for(p(f,t);t!==f.root&&t.parent.color===1;)if(t.parent===t.parent.parent.left){const i=t.parent.parent.right;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.right&&(t=t.parent,g(f,t)),t.parent.color=0,t.parent.parent.color=1,A(f,t.parent.parent))}else{const i=t.parent.parent.left;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.left&&(t=t.parent,A(f,t)),t.parent.color=0,t.parent.parent.color=1,g(f,t.parent.parent))}f.root.color=0}e.$uB=o;function v(f,t,i,n){for(;t!==f.root&&t!==e.$oB;)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=n),t=t.parent}e.$vB=v;function p(f,t){let i=0,n=0;if(t!==f.root){for(;t!==f.root&&t===t.parent.right;)t=t.parent;if(t!==f.root)for(t=t.parent,i=R(t.left)-t.size_left,n=$(t.left)-t.lf_left,t.size_left+=i,t.lf_left+=n;t!==f.root&&(i!==0||n!==0);)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=n),t=t.parent}}e.$wB=p}),define(Ae[91],Re([1,0,131,29,92,130,93]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HB=e.$GB=e.$FB=e.$EB=e.$DB=void 0;const $=65535;function D(i){let n;return i[i.length-1]<65536?n=new Uint16Array(i.length):n=new Uint32Array(i.length),n.set(i,0),n}class g{constructor(n,u,a,l,r){this.lineStarts=n,this.cr=u,this.lf=a,this.crlf=l,this.isBasicASCII=r}}function A(i,n=!0){const u=[0];let a=1;for(let l=0,r=i.length;l<r;l++){const s=i.charCodeAt(l);s===13?l+1<r&&i.charCodeAt(l+1)===10?(u[a++]=l+2,l++):u[a++]=l+1:s===10&&(u[a++]=l+1)}return n?D(u):u}e.$DB=A;function S(i,n){i.length=0,i[0]=0;let u=1,a=0,l=0,r=0,s=!0;for(let h=0,w=n.length;h<w;h++){const m=n.charCodeAt(h);m===13?h+1<w&&n.charCodeAt(h+1)===10?(r++,i[u++]=h+2,h++):(a++,i[u++]=h+1):m===10?(l++,i[u++]=h+1):s&&m!==9&&(m<32||m>126)&&(s=!1)}const c=new g(D(i),a,l,r,s);return i.length=0,c}e.$EB=S;class o{constructor(n,u,a,l,r){this.bufferIndex=n,this.start=u,this.end=a,this.lineFeedCnt=l,this.length=r}}e.$FB=o;class v{constructor(n,u){this.buffer=n,this.lineStarts=u}}e.$GB=v;class p{constructor(n,u){this.a=[],this.c=n,this.d=u,this.b=0,n.root!==M.$oB&&n.iterate(n.root,a=>(a!==M.$oB&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class f{constructor(n){this.a=n,this.b=[]}get(n){for(let u=this.b.length-1;u>=0;u--){const a=this.b[u];if(a.nodeStartOffset<=n&&a.nodeStartOffset+a.node.piece.length>=n)return a}return null}get2(n){for(let u=this.b.length-1;u>=0;u--){const a=this.b[u];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<n&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=n)return a}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let u=!1;const a=this.b;for(let l=0;l<a.length;l++){const r=a[l];if(r.node.parent===null||r.nodeStartOffset>=n){a[l]=null,u=!0;continue}}if(u){const l=[];for(const r of a)r!==null&&l.push(r);this.b=l}}}class t{constructor(n,u,a){this.create(n,u,a)}create(n,u,a){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=M.$oB,this.b=1,this.c=0,this.d=u,this.e=u.length,this.f=a;let l=null;for(let r=0,s=n.length;r<s;r++)if(n[r].buffer.length>0){n[r].lineStarts||(n[r].lineStarts=A(n[r].buffer));const c=new o(r+1,{line:0,column:0},{line:n[r].lineStarts.length-1,column:n[r].buffer.length-n[r].lineStarts[n[r].lineStarts.length-1]},n[r].lineStarts.length-1,n[r].buffer.length);this.a.push(n[r]),l=this.S(l,c)}this.h=new f(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const u=$,a=u-Math.floor(u/3),l=a*2;let r="",s=0;const c=[];if(this.iterate(this.root,h=>{const w=this.R(h),m=w.length;if(s<=a||s+m<l)return r+=w,s+=m,!0;const I=r.replace(/\r\n|\r|\n/g,n);return c.push(new v(I,A(I))),r=w,s=m,!0}),s>0){const h=r.replace(/\r\n|\r|\n/g,n);c.push(new v(h,A(h)))}this.create(c,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new p(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let u=0;return this.iterate(this.root,l=>{if(l===M.$oB)return!0;const r=this.R(l),s=r.length,c=n.G(u),h=n.G(u+s),w=n.getValueInRange2(c,h);return u+=s,r===w})}getOffsetAt(n,u){let a=0,l=this.root;for(;l!==M.$oB;)if(l.left!==M.$oB&&l.lf_left+1>=n)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=n){a+=l.size_left;const r=this.B(l,n-l.lf_left-2);return a+=r+u-1}else n-=l.lf_left+l.piece.lineFeedCnt,a+=l.size_left+l.piece.length,l=l.right;return a}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let u=this.root,a=0;const l=n;for(;u!==M.$oB;)if(u.size_left!==0&&u.size_left>=n)u=u.left;else if(u.size_left+u.piece.length>=n){const r=this.A(u,n-u.size_left);if(a+=u.lf_left+r.index,r.index===0){const s=this.getOffsetAt(a+1,1),c=l-s;return new E.$vs(a+1,c+1)}return new E.$vs(a+1,r.remainder+1)}else if(n-=u.size_left+u.piece.length,a+=u.lf_left+u.piece.lineFeedCnt,u.right===M.$oB){const r=this.getOffsetAt(a+1,1),s=l-n-r;return new E.$vs(a+1,s+1)}else u=u.right;return new E.$vs(1,1)}getValueInRange(n,u){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const a=this.H(n.startLineNumber,n.startColumn),l=this.H(n.endLineNumber,n.endColumn),r=this.getValueInRange2(a,l);return u?u!==this.d||!this.f?r.replace(/\r\n|\r|\n/g,u):u===this.getEOL()&&this.f?r:r.replace(/\r\n|\r|\n/g,u):r}getValueInRange2(n,u){if(n.node===u.node){const c=n.node,h=this.a[c.piece.bufferIndex].buffer,w=this.u(c.piece.bufferIndex,c.piece.start);return h.substring(w+n.remainder,w+u.remainder)}let a=n.node;const l=this.a[a.piece.bufferIndex].buffer,r=this.u(a.piece.bufferIndex,a.piece.start);let s=l.substring(r+n.remainder,r+a.piece.length);for(a=a.next();a!==M.$oB;){const c=this.a[a.piece.bufferIndex].buffer,h=this.u(a.piece.bufferIndex,a.piece.start);if(a===u.node){s+=c.substring(h,h+u.remainder);break}else s+=c.substr(h,a.piece.length);a=a.next()}return s}getLinesContent(){const n=[];let u=0,a="",l=!1;return this.iterate(this.root,r=>{if(r===M.$oB)return!0;const s=r.piece;let c=s.length;if(c===0)return!0;const h=this.a[s.bufferIndex].buffer,w=this.a[s.bufferIndex].lineStarts,m=s.start.line,I=s.end.line;let k=w[m]+s.start.column;if(l&&(h.charCodeAt(k)===10&&(k++,c--),n[u++]=a,a="",l=!1,c===0))return!0;if(m===I)return!this.f&&h.charCodeAt(k+c-1)===13?(l=!0,a+=h.substr(k,c-1)):a+=h.substr(k,c),!0;a+=this.f?h.substring(k,Math.max(k,w[m+1]-this.e)):h.substring(k,w[m+1]).replace(/(\r\n|\r|\n)$/,""),n[u++]=a;for(let d=m+1;d<I;d++)a=this.f?h.substring(w[d],w[d+1]-this.e):h.substring(w[d],w[d+1]).replace(/(\r\n|\r|\n)$/,""),n[u++]=a;return!this.f&&h.charCodeAt(w[I]+s.end.column-1)===13?(l=!0,s.end.column===0?u--:a=h.substr(w[I],s.end.column-1)):a=h.substr(w[I],s.end.column),!0}),l&&(n[u++]=a,a=""),n[u++]=a,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const u=n.node.next();if(!u)return 0;const a=this.a[u.piece.bufferIndex],l=this.u(u.piece.bufferIndex,u.piece.start);return a.buffer.charCodeAt(l)}else{const u=this.a[n.node.piece.bufferIndex],l=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return u.buffer.charCodeAt(l)}}getLineCharCode(n,u){const a=this.H(n,u+1);return this.l(a)}getLineLength(n){if(n===this.getLineCount()){const u=this.getOffsetAt(n,1);return this.getLength()-u}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const u=this.G(n);return this.l(u)}findMatchesInNode(n,u,a,l,r,s,c,h,w,m,I){const k=this.a[n.piece.bufferIndex],d=this.u(n.piece.bufferIndex,n.piece.start),b=this.u(n.piece.bufferIndex,r),y=this.u(n.piece.bufferIndex,s);let C;const B={line:0,column:0};let H,U;u._wordSeparators?(H=k.buffer.substring(b,y),U=z=>z+b,u.reset(0)):(H=k.buffer,U=z=>z,u.reset(b));do if(C=u.next(H),C){if(U(C.index)>=y)return m;this.s(n,U(C.index)-d,B);const z=this.t(n.piece.bufferIndex,r,B),F=B.line===r.line?B.column-r.column+l:B.column+1,N=F+C[0].length;if(I[m++]=(0,R.$zB)(new L.$ws(a+z,F,a+z,N),C,h),U(C.index)+C[0].length>=y||m>=w)return m}while(C);return m}findMatchesLineByLine(n,u,a,l){const r=[];let s=0;const c=new R.$CB(u.wordSeparators,u.regex);let h=this.H(n.startLineNumber,n.startColumn);if(h===null)return[];const w=this.H(n.endLineNumber,n.endColumn);if(w===null)return[];let m=this.s(h.node,h.remainder);const I=this.s(w.node,w.remainder);if(h.node===w.node)return this.findMatchesInNode(h.node,c,n.startLineNumber,n.startColumn,m,I,u,a,l,s,r),r;let k=n.startLineNumber,d=h.node;for(;d!==w.node;){const y=this.t(d.piece.bufferIndex,m,d.piece.end);if(y>=1){const B=this.a[d.piece.bufferIndex].lineStarts,H=this.u(d.piece.bufferIndex,d.piece.start),U=B[m.line+y],z=k===n.startLineNumber?n.startColumn:1;if(s=this.findMatchesInNode(d,c,k,z,m,this.s(d,U-H),u,a,l,s,r),s>=l)return r;k+=y}const C=k===n.startLineNumber?n.startColumn-1:0;if(k===n.endLineNumber){const B=this.getLineContent(k).substring(C,n.endColumn-1);return s=this.n(u,c,B,n.endLineNumber,C,s,r,a,l),r}if(s=this.n(u,c,this.getLineContent(k).substr(C),k,C,s,r,a,l),s>=l)return r;k++,h=this.H(k,1),d=h.node,m=this.s(h.node,h.remainder)}if(k===n.endLineNumber){const y=k===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(k).substring(y,n.endColumn-1);return s=this.n(u,c,C,n.endLineNumber,y,s,r,a,l),r}const b=k===n.startLineNumber?n.startColumn:1;return s=this.findMatchesInNode(w.node,c,k,b,m,I,u,a,l,s,r),r}n(n,u,a,l,r,s,c,h,w){const m=n.wordSeparators;if(!h&&n.simpleSearch){const k=n.simpleSearch,d=k.length,b=a.length;let y=-d;for(;(y=a.indexOf(k,y+d))!==-1;)if((!m||(0,R.$BB)(m,a,b,y,d))&&(c[s++]=new P.$Nu(new L.$ws(l,y+1+r,l,y+1+d+r),null),s>=w))return s;return s}let I;u.reset(0);do if(I=u.next(a),I&&(c[s++]=(0,R.$zB)(new L.$ws(l,I.index+1+r,l,I.index+1+I[0].length+r),I,h),s>=w))return s;while(I);return s}insert(n,u,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==M.$oB){const{node:l,remainder:r,nodeStartOffset:s}=this.G(n),c=l.piece,h=c.bufferIndex,w=this.s(l,r);if(l.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&s+c.length===n&&u.length<$){this.F(l,u),this.y();return}if(s===n)this.o(u,l),this.h.validate(n);else if(s+l.piece.length>n){const m=[];let I=new o(c.bufferIndex,w,c.end,this.t(c.bufferIndex,w,c.end),this.u(h,c.end)-this.u(h,w));if(this.K()&&this.M(u)&&this.I(l,r)===10){const y={line:I.start.line+1,column:0};I=new o(I.bufferIndex,y,I.end,this.t(I.bufferIndex,y,I.end),I.length-1),u+=`
`}if(this.K()&&this.L(u))if(this.I(l,r-1)===13){const y=this.s(l,r-1);this.C(l,y),u="\r"+u,l.piece.length===0&&m.push(l)}else this.C(l,w);else this.C(l,w);const k=this.w(u);I.length>0&&this.S(l,I);let d=l;for(let b=0;b<k.length;b++)d=this.S(d,k[b]);this.v(m)}else this.q(u,l)}else{const l=this.w(u);let r=this.T(null,l[0]);for(let s=1;s<l.length;s++)r=this.S(r,l[s])}this.y()}delete(n,u){if(this.j.lineNumber=0,this.j.value="",u<=0||this.root===M.$oB)return;const a=this.G(n),l=this.G(n+u),r=a.node,s=l.node;if(r===s){const k=this.s(r,a.remainder),d=this.s(r,l.remainder);if(a.nodeStartOffset===n){if(u===r.piece.length){const b=r.next();(0,M.$tB)(this,r),this.N(b),this.y();return}this.D(r,d),this.h.validate(n),this.N(r),this.y();return}if(a.nodeStartOffset+r.piece.length===n+u){this.C(r,k),this.O(r),this.y();return}this.E(r,k,d),this.y();return}const c=[],h=this.s(r,a.remainder);this.C(r,h),this.h.validate(n),r.piece.length===0&&c.push(r);const w=this.s(s,l.remainder);this.D(s,w),s.piece.length===0&&c.push(s);const m=r.next();for(let k=m;k!==M.$oB&&k!==s;k=k.next())c.push(k);const I=r.piece.length===0?r.prev():r;this.v(c),this.O(I),this.y()}o(n,u){const a=[];if(this.K()&&this.M(n)&&this.L(u)){const s=u.piece,c={line:s.start.line+1,column:0},h=new o(s.bufferIndex,c,s.end,this.t(s.bufferIndex,c,s.end),s.length-1);u.piece=h,n+=`
`,(0,M.$vB)(this,u,-1,-1),u.piece.length===0&&a.push(u)}const l=this.w(n);let r=this.T(u,l[l.length-1]);for(let s=l.length-2;s>=0;s--)r=this.T(r,l[s]);this.N(r),this.v(a)}q(n,u){this.Q(n,u)&&(n+=`
`);const a=this.w(n),l=this.S(u,a[0]);let r=l;for(let s=1;s<a.length;s++)r=this.S(r,a[s]);this.N(l)}s(n,u,a){const l=n.piece,r=n.piece.bufferIndex,s=this.a[r].lineStarts,h=s[l.start.line]+l.start.column+u;let w=l.start.line,m=l.end.line,I=0,k=0,d=0;for(;w<=m&&(I=w+(m-w)/2|0,d=s[I],I!==m);)if(k=s[I+1],h<d)m=I-1;else if(h>=k)w=I+1;else break;return a?(a.line=I,a.column=h-d,null):{line:I,column:h-d}}t(n,u,a){if(a.column===0)return a.line-u.line;const l=this.a[n].lineStarts;if(a.line===l.length-1)return a.line-u.line;const r=l[a.line+1],s=l[a.line]+a.column;if(r>s+1)return a.line-u.line;const c=s-1;return this.a[n].buffer.charCodeAt(c)===13?a.line-u.line+1:a.line-u.line}u(n,u){return this.a[n].lineStarts[u.line]+u.column}v(n){for(let u=0;u<n.length;u++)(0,M.$tB)(this,n[u])}w(n){if(n.length>$){const m=[];for(;n.length>$;){const k=n.charCodeAt($-1);let d;k===13||k>=55296&&k<=56319?(d=n.substring(0,$-1),n=n.substring($-1)):(d=n.substring(0,$),n=n.substring($));const b=A(d);m.push(new o(this.a.length,{line:0,column:0},{line:b.length-1,column:d.length-b[b.length-1]},b.length-1,d.length)),this.a.push(new v(d,b))}const I=A(n);return m.push(new o(this.a.length,{line:0,column:0},{line:I.length-1,column:n.length-I[I.length-1]},I.length-1,n.length)),this.a.push(new v(n,I)),m}let u=this.a[0].buffer.length;const a=A(n,!1);let l=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===u&&u!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},l=this.g;for(let m=0;m<a.length;m++)a[m]+=u+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+n,u+=1}else{if(u!==0)for(let m=0;m<a.length;m++)a[m]+=u;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=n}const r=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,c=r-this.a[0].lineStarts[s],h={line:s,column:c},w=new o(0,l,h,this.t(0,l,h),r-u);return this.g=h,[w]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,u=0){let a=this.root,l="";const r=this.h.get2(n);if(r){a=r.node;const s=this.B(a,n-r.nodeStartLineNumber-1),c=this.a[a.piece.bufferIndex].buffer,h=this.u(a.piece.bufferIndex,a.piece.start);if(r.nodeStartLineNumber+a.piece.lineFeedCnt===n)l=c.substring(h+s,h+a.piece.length);else{const w=this.B(a,n-r.nodeStartLineNumber);return c.substring(h+s,h+w-u)}}else{let s=0;const c=n;for(;a!==M.$oB;)if(a.left!==M.$oB&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const h=this.B(a,n-a.lf_left-2),w=this.B(a,n-a.lf_left-1),m=this.a[a.piece.bufferIndex].buffer,I=this.u(a.piece.bufferIndex,a.piece.start);return s+=a.size_left,this.h.set({node:a,nodeStartOffset:s,nodeStartLineNumber:c-(n-1-a.lf_left)}),m.substring(I+h,I+w-u)}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const h=this.B(a,n-a.lf_left-2),w=this.a[a.piece.bufferIndex].buffer,m=this.u(a.piece.bufferIndex,a.piece.start);l=w.substring(m+h,m+a.piece.length);break}else n-=a.lf_left+a.piece.lineFeedCnt,s+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==M.$oB;){const s=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const c=this.B(a,0),h=this.u(a.piece.bufferIndex,a.piece.start);return l+=s.substring(h,h+c-u),l}else{const c=this.u(a.piece.bufferIndex,a.piece.start);l+=s.substr(c,a.piece.length)}a=a.next()}return l}y(){let n=this.root,u=1,a=0;for(;n!==M.$oB;)u+=n.lf_left+n.piece.lineFeedCnt,a+=n.size_left+n.piece.length,n=n.right;this.b=u,this.c=a,this.h.validate(this.c)}A(n,u){const a=n.piece,l=this.s(n,u),r=l.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===u){const s=this.t(n.piece.bufferIndex,a.start,l);if(s!==r)return{index:s,remainder:0}}return{index:r,remainder:l.column}}B(n,u){if(u<0)return 0;const a=n.piece,l=this.a[a.bufferIndex].lineStarts,r=a.start.line+u+1;return r>a.end.line?l[a.end.line]+a.end.column-l[a.start.line]-a.start.column:l[r]-l[a.start.line]-a.start.column}C(n,u){const a=n.piece,l=a.lineFeedCnt,r=this.u(a.bufferIndex,a.end),s=u,c=this.u(a.bufferIndex,s),h=this.t(a.bufferIndex,a.start,s),w=h-l,m=c-r,I=a.length+m;n.piece=new o(a.bufferIndex,a.start,s,h,I),(0,M.$vB)(this,n,m,w)}D(n,u){const a=n.piece,l=a.lineFeedCnt,r=this.u(a.bufferIndex,a.start),s=u,c=this.t(a.bufferIndex,s,a.end),h=this.u(a.bufferIndex,s),w=c-l,m=r-h,I=a.length+m;n.piece=new o(a.bufferIndex,s,a.end,c,I),(0,M.$vB)(this,n,m,w)}E(n,u,a){const l=n.piece,r=l.start,s=l.end,c=l.length,h=l.lineFeedCnt,w=u,m=this.t(l.bufferIndex,l.start,w),I=this.u(l.bufferIndex,u)-this.u(l.bufferIndex,r);n.piece=new o(l.bufferIndex,l.start,w,m,I),(0,M.$vB)(this,n,I-c,m-h);const k=new o(l.bufferIndex,a,s,this.t(l.bufferIndex,a,s),this.u(l.bufferIndex,s)-this.u(l.bufferIndex,a)),d=this.S(n,k);this.N(d)}F(n,u){this.Q(u,n)&&(u+=`
`);const a=this.K()&&this.L(u)&&this.M(n),l=this.a[0].buffer.length;this.a[0].buffer+=u;const r=A(u,!1);for(let d=0;d<r.length;d++)r[d]+=l;if(a){const d=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:l-d}}this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1));const s=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[s],h={line:s,column:c},w=n.piece.length+u.length,m=n.piece.lineFeedCnt,I=this.t(0,n.piece.start,h),k=I-m;n.piece=new o(n.piece.bufferIndex,n.piece.start,h,I,w),this.g=h,(0,M.$vB)(this,n,u.length,k)}G(n){let u=this.root;const a=this.h.get(n);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:n-a.nodeStartOffset};let l=0;for(;u!==M.$oB;)if(u.size_left>n)u=u.left;else if(u.size_left+u.piece.length>=n){l+=u.size_left;const r={node:u,remainder:n-u.size_left,nodeStartOffset:l};return this.h.set(r),r}else n-=u.size_left+u.piece.length,l+=u.size_left+u.piece.length,u=u.right;return null}H(n,u){let a=this.root,l=0;for(;a!==M.$oB;)if(a.left!==M.$oB&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const r=this.B(a,n-a.lf_left-2),s=this.B(a,n-a.lf_left-1);return l+=a.size_left,{node:a,remainder:Math.min(r+u-1,s),nodeStartOffset:l}}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const r=this.B(a,n-a.lf_left-2);if(r+u-1<=a.piece.length)return{node:a,remainder:r+u-1,nodeStartOffset:l};u-=a.piece.length-r;break}else n-=a.lf_left+a.piece.lineFeedCnt,l+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==M.$oB;){if(a.piece.lineFeedCnt>0){const r=this.B(a,0),s=this.J(a);return{node:a,remainder:Math.min(u-1,r),nodeStartOffset:s}}else if(a.piece.length>=u-1){const r=this.J(a);return{node:a,remainder:u-1,nodeStartOffset:r}}else u-=a.piece.length;a=a.next()}return null}I(n,u){if(n.piece.lineFeedCnt<1)return-1;const a=this.a[n.piece.bufferIndex],l=this.u(n.piece.bufferIndex,n.piece.start)+u;return a.buffer.charCodeAt(l)}J(n){if(!n)return 0;let u=n.size_left;for(;n!==this.root;)n.parent.right===n&&(u+=n.parent.size_left+n.parent.piece.length),n=n.parent;return u}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===M.$oB||n.piece.lineFeedCnt===0)return!1;const u=n.piece,a=this.a[u.bufferIndex].lineStarts,l=u.start.line,r=a[l]+u.start.column;return l===a.length-1||a[l+1]>r+1?!1:this.a[u.bufferIndex].buffer.charCodeAt(r)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===M.$oB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const u=n.prev();this.M(u)&&this.P(u,n)}}O(n){if(this.K()&&this.M(n)){const u=n.next();this.L(u)&&this.P(n,u)}}P(n,u){const a=[],l=this.a[n.piece.bufferIndex].lineStarts;let r;n.piece.end.column===0?r={line:n.piece.end.line-1,column:l[n.piece.end.line]-l[n.piece.end.line-1]-1}:r={line:n.piece.end.line,column:n.piece.end.column-1};const s=n.piece.length-1,c=n.piece.lineFeedCnt-1;n.piece=new o(n.piece.bufferIndex,n.piece.start,r,c,s),(0,M.$vB)(this,n,-1,-1),n.piece.length===0&&a.push(n);const h={line:u.piece.start.line+1,column:0},w=u.piece.length-1,m=this.t(u.piece.bufferIndex,h,u.piece.end);u.piece=new o(u.piece.bufferIndex,h,u.piece.end,m,w),(0,M.$vB)(this,u,-1,-1),u.piece.length===0&&a.push(u);const I=this.w(`\r
`);this.S(n,I[0]);for(let k=0;k<a.length;k++)(0,M.$tB)(this,a[k])}Q(n,u){if(this.K()&&this.M(n)){const a=u.next();if(this.L(a)){if(n+=`
`,a.piece.length===1)(0,M.$tB)(this,a);else{const l=a.piece,r={line:l.start.line+1,column:0},s=l.length-1,c=this.t(l.bufferIndex,r,l.end);a.piece=new o(l.bufferIndex,r,l.end,c,s),(0,M.$vB)(this,a,-1,-1)}return!0}}return!1}iterate(n,u){if(n===M.$oB)return u(M.$oB);const a=this.iterate(n.left,u);return a&&u(n)&&this.iterate(n.right,u)}R(n){if(n===M.$oB)return"";const u=this.a[n.piece.bufferIndex],a=n.piece,l=this.u(a.bufferIndex,a.start),r=this.u(a.bufferIndex,a.end);return u.buffer.substring(l,r)}getPieceContent(n){const u=this.a[n.bufferIndex],a=this.u(n.bufferIndex,n.start),l=this.u(n.bufferIndex,n.end);return u.buffer.substring(a,l)}S(n,u){const a=new M.$nB(u,1);if(a.left=M.$oB,a.right=M.$oB,a.parent=M.$oB,a.size_left=0,a.lf_left=0,this.root===M.$oB)this.root=a,a.color=0;else if(n.right===M.$oB)n.right=a,a.parent=n;else{const r=(0,M.$pB)(n.right);r.left=a,a.parent=r}return(0,M.$uB)(this,a),a}T(n,u){const a=new M.$nB(u,1);if(a.left=M.$oB,a.right=M.$oB,a.parent=M.$oB,a.size_left=0,a.lf_left=0,this.root===M.$oB)this.root=a,a.color=0;else if(n.left===M.$oB)n.left=a,a.parent=n;else{const l=(0,M.$qB)(n.left);l.right=a,a.parent=l}return(0,M.$uB)(this,a),a}U(n){let u="";return this.iterate(n,a=>(u+=this.R(a),!0)),u}}e.$HB=t}),define(Ae[132],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p8=e.$o8=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const R=this.a.get(M);return this.a.delete(M),R}}addDragOperationTransfer(M,R){this.a.set(M,R)}}e.$o8=E;class L{constructor(M){this.identifier=M}}e.$p8=L}),define(Ae[133],Re([9,10]),function(ve,e){return ve.create("vs/base/common/actions",e)}),define(Ae[134],Re([1,0,5,6,133]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=void 0;class M extends L.$Rc{constructor(o,v="",p="",f=!0,t){super(),this.h=this.B(new E.$Od),this.onDidChange=this.h.event,this.w=!0,this.j=o,this.m=v,this.u=p,this.w=f,this.C=t}get id(){return this.j}get label(){return this.m}set label(o){this.D(o)}D(o){this.m!==o&&(this.m=o,this.h.fire({label:o}))}get tooltip(){return this.n||""}set tooltip(o){this.F(o)}F(o){this.n!==o&&(this.n=o,this.h.fire({tooltip:o}))}get class(){return this.u}set class(o){this.G(o)}G(o){this.u!==o&&(this.u=o,this.h.fire({class:o}))}get enabled(){return this.w}set enabled(o){this.H(o)}H(o){this.w!==o&&(this.w=o,this.h.fire({enabled:o}))}get checked(){return this.z}set checked(o){this.I(o)}I(o){this.z!==o&&(this.z=o,this.h.fire({checked:o}))}async run(o,v){this.C&&await this.C(o)}}e.$xi=M;class R extends L.$Rc{constructor(){super(...arguments),this.f=this.B(new E.$Od),this.onWillRun=this.f.event,this.m=this.B(new E.$Od),this.onDidRun=this.m.event}async run(o,v){if(!o.enabled)return;this.f.fire({action:o});let p;try{await this.u(o,v)}catch(f){p=f}this.m.fire({action:o,error:p})}async u(o,v){await o.run(v)}}e.$yi=R;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...o){let v=[];for(const p of o)p.length&&(v.length?v=[...v,new $,...p]:v=p);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$zi=$;class D{get actions(){return this.a}constructor(o,v,p,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=o,this.label=v,this.class=f,this.a=p}async run(){}}e.$Ai=D;class g extends M{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,P.localize(0,null),void 0,!1)}}e.$Bi=g;function A(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async(...o)=>S.run(...o),tooltip:S.label}}e.$Ci=A}),define(Ae[135],Re([9,10]),function(ve,e){return ve.create("vs/base/common/date",e)}),define(Ae[136],Re([1,0,135]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=e.$gm=void 0;const L=60,P=L*60,M=P*24,R=M*7,$=M*30,D=M*365;function g(S,o,v,p){typeof S!="number"&&(S=S.getTime());const f=Math.round((new Date().getTime()-S)/1e3);if(f<-30)return(0,E.localize)(0,null,g(new Date().getTime()+f*1e3,!1));if(!p&&f<30)return(0,E.localize)(1,null);let t;return f<L?(t=f,o?t===1?v?(0,E.localize)(2,null,t):(0,E.localize)(3,null,t):v?(0,E.localize)(4,null,t):(0,E.localize)(5,null,t):t===1?v?(0,E.localize)(6,null,t):(0,E.localize)(7,null,t):v?(0,E.localize)(8,null,t):(0,E.localize)(9,null,t)):f<P?(t=Math.floor(f/L),o?t===1?v?(0,E.localize)(10,null,t):(0,E.localize)(11,null,t):v?(0,E.localize)(12,null,t):(0,E.localize)(13,null,t):t===1?v?(0,E.localize)(14,null,t):(0,E.localize)(15,null,t):v?(0,E.localize)(16,null,t):(0,E.localize)(17,null,t)):f<M?(t=Math.floor(f/P),o?t===1?v?(0,E.localize)(18,null,t):(0,E.localize)(19,null,t):v?(0,E.localize)(20,null,t):(0,E.localize)(21,null,t):t===1?v?(0,E.localize)(22,null,t):(0,E.localize)(23,null,t):v?(0,E.localize)(24,null,t):(0,E.localize)(25,null,t)):f<R?(t=Math.floor(f/M),o?t===1?(0,E.localize)(26,null,t):(0,E.localize)(27,null,t):t===1?(0,E.localize)(28,null,t):(0,E.localize)(29,null,t)):f<$?(t=Math.floor(f/R),o?t===1?v?(0,E.localize)(30,null,t):(0,E.localize)(31,null,t):v?(0,E.localize)(32,null,t):(0,E.localize)(33,null,t):t===1?v?(0,E.localize)(34,null,t):(0,E.localize)(35,null,t):v?(0,E.localize)(36,null,t):(0,E.localize)(37,null,t)):f<D?(t=Math.floor(f/$),o?t===1?v?(0,E.localize)(38,null,t):(0,E.localize)(39,null,t):v?(0,E.localize)(40,null,t):(0,E.localize)(41,null,t):t===1?v?(0,E.localize)(42,null,t):(0,E.localize)(43,null,t):v?(0,E.localize)(44,null,t):(0,E.localize)(45,null,t)):(t=Math.floor(f/D),o?t===1?v?(0,E.localize)(46,null,t):(0,E.localize)(47,null,t):v?(0,E.localize)(48,null,t):(0,E.localize)(49,null,t):t===1?v?(0,E.localize)(50,null,t):(0,E.localize)(51,null,t):v?(0,E.localize)(52,null,t):(0,E.localize)(53,null,t))}e.$gm=g;function A(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$hm=A}),define(Ae[137],Re([9,10]),function(ve,e){return ve.create("vs/base/common/errorMessage",e)}),define(Ae[39],Re([1,0,18,16,137]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=void 0;function M(S,o){return o&&(S.stack||S.stacktrace)?P.localize(0,null,$(S),R(S.stack)||R(S.stacktrace)):$(S)}function R(S){return Array.isArray(S)?S.join(`
`):S}function $(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?P.localize(1,null,S.message):S.message||P.localize(2,null)}function D(S=null,o=!1){if(!S)return P.localize(3,null);if(Array.isArray(S)){const v=E.$Gb(S),p=D(v[0],o);return v.length>1?P.localize(4,null,p,v.length):p}if(L.$zf(S))return S;if(S.detail){const v=S.detail;if(v.error)return M(v.error,o);if(v.exception)return M(v.exception,o)}return S.stack?M(S,o):S.message?S.message:P.localize(5,null)}e.$Di=D;function g(S){const o=S;return o instanceof Error&&Array.isArray(o.actions)}e.$Ei=g;function A(S,o){let v;return typeof S=="string"?v=new Error(S):v=S,v.actions=o,v}e.$Fi=A}),define(Ae[138],Re([1,0,44,19]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=void 0;const P=new E.$U(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),M=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(k,d,b=!1){const y=k||"",C=d||"",B=P.value.collator.compare(y,C);return P.value.collatorIsNumeric&&B===0&&y!==C?y<C?-1:1:B}e.$kq=$;function D(k,d){const b=M.value.collator;return k=k||"",d=d||"",a(b,k,d)}e.$lq=D;function g(k,d){const b=M.value.collator;return k=k||"",d=d||"",c(k,d)||a(b,k,d)}e.$mq=g;function A(k,d){const b=M.value.collator;return k=k||"",d=d||"",s(k,d)||a(b,k,d)}e.$nq=A;function S(k,d){return k=k||"",d=d||"",k===d?0:k<d?-1:1}e.$oq=S;function o(k,d){const[b,y]=n(k),[C,B]=n(d);let H=P.value.collator.compare(y,B);if(H===0){if(P.value.collatorIsNumeric&&y!==B)return y<B?-1:1;if(H=P.value.collator.compare(b,C),P.value.collatorIsNumeric&&H===0&&b!==C)return b<C?-1:1}return H}e.$pq=o;function v(k,d){k=k||"",d=d||"";const b=u(k),y=u(d),C=M.value.collator,B=R.value.collator;return a(B,b,y)||a(C,k,d)}e.$qq=v;function p(k,d){k=k||"",d=d||"";const b=u(k),y=u(d),C=M.value.collator,B=R.value.collator;return a(B,b,y)||c(k,d)||a(C,k,d)}e.$rq=p;function f(k,d){k=k||"",d=d||"";const b=u(k),y=u(d),C=M.value.collator,B=R.value.collator;return a(B,b,y)||s(k,d)||a(C,k,d)}e.$sq=f;function t(k,d){k=k||"",d=d||"";const b=u(k).toLowerCase(),y=u(d).toLowerCase();return b!==y?b<y?-1:1:k!==d?k<d?-1:1:0}e.$tq=t;const i=/^(.*?)(\.([^.]*))?$/;function n(k,d=!1){const b=k?i.exec(k):[];let y=[b&&b[1]||"",b&&b[3]||""];return d&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function u(k){const d=k?i.exec(k):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function a(k,d,b){const y=k.compare(d,b);return y!==0?y:d.length!==b.length?d.length<b.length?-1:1:0}function l(k){const d=k.charAt(0);return d.toLocaleUpperCase()!==d}function r(k){const d=k.charAt(0);return d.toLocaleLowerCase()!==d}function s(k,d){return l(k)&&r(d)?-1:r(k)&&l(d)?1:0}function c(k,d){return r(k)&&l(d)?-1:l(k)&&r(d)?1:0}function h(k,d,b=!1){return b||(k=k&&k.toLowerCase(),d=d&&d.toLowerCase()),k===d?0:k<d?-1:1}function w(k,d,b=!1){const y=k.split(L.sep),C=d.split(L.sep),B=y.length-1,H=C.length-1;let U,z;for(let F=0;;F++){if(U=B===F,z=H===F,U&&z)return $(y[F],C[F],b);if(U)return-1;if(z)return 1;const N=h(y[F],C[F],b);if(N!==0)return N}}e.$uq=w;function m(k,d,b){const y=k.toLowerCase(),C=d.toLowerCase(),B=I(k,d,b);if(B)return B;const H=y.endsWith(b),U=C.endsWith(b);if(H!==U)return H?-1:1;const z=$(y,C);return z!==0?z:y.localeCompare(C)}e.$vq=m;function I(k,d,b){const y=k.toLowerCase(),C=d.toLowerCase(),B=y.startsWith(b),H=C.startsWith(b);if(B!==H)return B?-1:1;if(B&&H){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}e.$wq=I}),define(Ae[46],Re([1,0,19,21,13,16]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=void 0;function R(m){return m===47||m===92}e.$Rf=R;function $(m){return m.replace(/[\\/]/g,E.$fc.sep)}e.$Sf=$;function D(m){return m.indexOf("/")===-1&&(m=$(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}e.$Tf=D;function g(m,I=E.$fc.sep){if(!m)return"";const k=m.length,d=m.charCodeAt(0);if(R(d)){if(R(m.charCodeAt(1))&&!R(m.charCodeAt(2))){let y=3;const C=y;for(;y<k&&!R(m.charCodeAt(y));y++);if(C!==y&&!R(m.charCodeAt(y+1))){for(y+=1;y<k;y++)if(R(m.charCodeAt(y)))return m.slice(0,y+1).replace(/[\\/]/g,I)}}return I}else if(i(d)&&m.charCodeAt(1)===58)return R(m.charCodeAt(2))?m.slice(0,2)+I:m.slice(0,2);let b=m.indexOf("://");if(b!==-1){for(b+=3;b<k;b++)if(R(m.charCodeAt(b)))return m.slice(0,b+1)}return""}e.$Uf=g;function A(m){if(!L.$i||!m||m.length<5)return!1;let I=m.charCodeAt(0);if(I!==92||(I=m.charCodeAt(1),I!==92))return!1;let k=2;const d=k;for(;k<m.length&&(I=m.charCodeAt(k),I!==92);k++);return!(d===k||(I=m.charCodeAt(k+1),isNaN(I)||I===92))}e.$Vf=A;const S=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(m,I=L.$i){const k=I?S:o;return!(!m||m.length===0||/^\s+$/.test(m)||(k.lastIndex=0,k.test(m))||I&&v.test(m)||m==="."||m===".."||I&&m[m.length-1]==="."||I&&m.length!==m.trim().length||m.length>255)}e.$Wf=p;function f(m,I,k){const d=m===I;return!k||d?d:!m||!I?!1:(0,P.$3e)(m,I)}e.$Xf=f;function t(m,I,k,d=E.sep){if(m===I)return!0;if(!m||!I||I.length>m.length)return!1;if(k){if(!(0,P.$4e)(m,I))return!1;if(I.length===m.length)return!0;let y=I.length;return I.charAt(I.length-1)===d&&y--,m.charAt(y)===d}return I.charAt(I.length-1)!==d&&(I+=d),m.indexOf(I)===0}e.$Yf=t;function i(m){return m>=65&&m<=90||m>=97&&m<=122}e.$Zf=i;function n(m,I){return L.$i&&m.endsWith(":")&&(m+=E.sep),(0,E.$hc)(m)||(m=(0,E.$ic)(I,m)),m=(0,E.$gc)(m),L.$i?(m=(0,P.$Le)(m,E.sep),m.endsWith(":")&&(m+=E.sep)):(m=(0,P.$Le)(m,E.sep),m||(m=E.sep)),m}e.$1f=n;function u(m){const I=(0,E.$gc)(m);return L.$i?m.length>3?!1:a(I)&&(m.length===2||I.charCodeAt(2)===92):I===E.$fc.sep}e.$2f=u;function a(m,I=L.$i){return I?i(m.charCodeAt(0))&&m.charCodeAt(1)===58:!1}e.$3f=a;function l(m,I=L.$i){return a(m,I)?m[0]:void 0}e.$4f=l;function r(m,I,k){return I.length>m.length?-1:m===I?0:(k&&(m=m.toLowerCase(),I=I.toLowerCase()),m.indexOf(I))}e.$5f=r;function s(m){const I=m.split(":");let k,d,b;for(const y of I){const C=Number(y);(0,M.$Df)(C)?d===void 0?d=C:b===void 0&&(b=C):k=k?[k,y].join(":"):y}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:d!==void 0?d:void 0,column:b!==void 0?b:d!==void 0?1:void 0}}e.$6f=s;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(m,I,k=8){let d="";for(let y=0;y<k;y++){let C;y===0&&L.$i&&!I&&(k===3||k===4)?C=h:C=c,d+=C.charAt(Math.floor(Math.random()*C.length))}let b;return I?b=`${I}-${d}`:b=d,m?(0,E.$ic)(m,b):b}e.$7f=w}),define(Ae[69],Re([1,0,19]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=e.$Ur=e.$Tr=e.$Sr=void 0,e.$Sr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(A){const S=(0,E.$nc)(A),o=L[S.toLowerCase()];return o!==void 0?o:R(A)}e.$Tr=M;function R(A){const S=(0,E.$nc)(A);return P[S.toLowerCase()]}e.$Ur=R;function $(A){for(const S in P)if(P[S]===A)return S}e.$Vr=$;const D=/^(.+)\/(.+?)(;.+)?$/;function g(A,S){const o=D.exec(A);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:S?void 0:A}e.$Wr=g}),define(Ae[52],Re([1,0,24,2]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=void 0;function P(D){return JSON.stringify(D,R)}e.$nh=P;function M(D){let g=JSON.parse(D);return g=$(g),g}e.$oh=M;function R(D,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function $(D,g=0){if(!D||g>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return L.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 17:return new Date(D.source)}if(D instanceof E.$ce||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let A=0;A<D.length;++A)D[A]=$(D[A],g+1);else for(const A in D)Object.hasOwnProperty.call(D,A)&&(D[A]=$(D[A],g+1))}return D}e.$ph=$}),define(Ae[14],Re([1,0,11,21,2]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.Schemas=void 0;var M;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$8f="vscode-tkn",e.$9f="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${M.vscodeRemoteResource}`}set(A,S,o){this.a[A]=S,this.b[A]=o}setConnectionToken(A,S){this.c[A]=S}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(t){return E.$Z(t),A}const S=A.authority;let o=this.a[S];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const v=this.b[S],p=this.c[S];let f=`path=${encodeURIComponent(A.path)}`;return typeof p=="string"&&(f+=`&${e.$9f}=${encodeURIComponent(p)}`),P.URI.from({scheme:L.$o?this.d:M.vscodeRemoteResource,authority:`${o}:${v}`,path:this.f,query:f})}}e.$0f=new R,e.$$f="vs/../../extensions",e.$_f="vs/../../node_modules",e.$ag="vs/../../node_modules.asar",e.$bg="vs/../../node_modules.asar.unpacked",e.$cg="vscode-app";class ${static{this.a=e.$cg}asBrowserUri(A){const S=this.b(A,ve);return this.uriToBrowserUri(S)}uriToBrowserUri(A){return A.scheme===M.vscodeRemote?e.$0f.rewrite(A):A.scheme===M.file&&(L.$m||L.$q===`${M.vscodeFileResource}://${$.a}`)?A.with({scheme:M.vscodeFileResource,authority:A.authority||$.a,query:null,fragment:null}):A}asFileUri(A){const S=this.b(A,ve);return this.uriToFileUri(S)}uriToFileUri(A){return A.scheme===M.vscodeFileResource?A.with({scheme:M.file,authority:A.authority!==$.a?A.authority:null,query:null,fragment:null}):A}b(A,S){return P.URI.isUri(A)?A:P.URI.parse(S.toUrl(A))}}e.$dg=new $;var D;(function(g){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(A.get("3"));const S="vscode-coi";function o(p){let f;typeof p=="string"?f=new URL(p).searchParams:p instanceof URL?f=p.searchParams:P.URI.isUri(p)&&(f=new URL(p.toString(!0)).searchParams);const t=f?.get(S);if(t)return A.get(t)}g.getHeadersFromQuery=o;function v(p,f,t){if(!globalThis.crossOriginIsolated)return;const i=f&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(S,i):p[S]=i}g.addSearchParam=v})(D||(e.COI=D={}))}),define(Ae[25],Re([1,0,46,14,19,21,13,2]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.DataUri=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=void 0;function D(v){return(0,$.$vc)(v,!0)}e.$kg=D;class g{constructor(p){this.a=p}compare(p,f,t=!1){return p===f?0:(0,R.$Ve)(this.getComparisonKey(p,t),this.getComparisonKey(f,t))}isEqual(p,f,t=!1){return p===f?!0:!p||!f?!1:this.getComparisonKey(p,t)===this.getComparisonKey(f,t)}getComparisonKey(p,f=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,f,t=!1){if(p.scheme===f.scheme){if(p.scheme===L.Schemas.file)return E.$Yf(D(p),D(f),this.a(p))&&p.query===f.query&&(t||p.fragment===f.fragment);if((0,e.$Bg)(p.authority,f.authority))return E.$Yf(p.path,f.path,this.a(p),"/")&&p.query===f.query&&(t||p.fragment===f.fragment)}return!1}joinPath(p,...f){return $.URI.joinPath(p,...f)}basenameOrAuthority(p){return(0,e.$tg)(p)||p.authority}basename(p){return P.$fc.basename(p.path)}extname(p){return P.$fc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let f;return p.scheme===L.Schemas.file?f=$.URI.file(P.$lc(D(p))).path:(f=P.$fc.dirname(p.path),p.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),f="/")),p.with({path:f})}normalizePath(p){if(!p.path.length)return p;let f;return p.scheme===L.Schemas.file?f=$.URI.file(P.$gc(D(p))).path:f=P.$fc.normalize(p.path),p.with({path:f})}relativePath(p,f){if(p.scheme!==f.scheme||!(0,e.$Bg)(p.authority,f.authority))return;if(p.scheme===L.Schemas.file){const n=P.$kc(D(p),D(f));return M.$i?E.$Sf(n):n}let t=p.path||"/";const i=f.path||"/";if(this.a(p)){let n=0;for(const u=Math.min(t.length,i.length);n<u&&!(t.charCodeAt(n)!==i.charCodeAt(n)&&t.charAt(n).toLowerCase()!==i.charAt(n).toLowerCase());n++);t=i.substr(0,n)+t.substr(n)}return P.$fc.relative(t,i)}resolvePath(p,f){if(p.scheme===L.Schemas.file){const t=$.URI.file(P.$jc(D(p),f));return p.with({authority:t.authority,path:t.path})}return f=E.$Tf(f),p.with({path:P.$fc.resolve(p.path,f)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,f){return p===f||p!==void 0&&f!==void 0&&(0,R.$3e)(p,f)}hasTrailingPathSeparator(p,f=P.sep){if(p.scheme===L.Schemas.file){const t=D(p);return t.length>E.$Uf(t).length&&t[t.length-1]===f}else{const t=p.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,f=P.sep){return(0,e.$Cg)(p,f)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,f=P.sep){let t=!1;if(p.scheme===L.Schemas.file){const i=D(p);t=i!==void 0&&i.length===E.$Uf(i).length&&i[i.length-1]===f}else{f="/";const i=p.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Cg)(p,f)?p.with({path:p.path+"/"}):p}}e.$lg=g,e.$mg=new g(()=>!1),e.$ng=new g(v=>v.scheme===L.Schemas.file?!M.$k:!0),e.$og=new g(v=>!0),e.$pg=e.$mg.isEqual.bind(e.$mg),e.$qg=e.$mg.isEqualOrParent.bind(e.$mg),e.$rg=e.$mg.getComparisonKey.bind(e.$mg),e.$sg=e.$mg.basenameOrAuthority.bind(e.$mg),e.$tg=e.$mg.basename.bind(e.$mg),e.$ug=e.$mg.extname.bind(e.$mg),e.$vg=e.$mg.dirname.bind(e.$mg),e.$wg=e.$mg.joinPath.bind(e.$mg),e.$xg=e.$mg.normalizePath.bind(e.$mg),e.$yg=e.$mg.relativePath.bind(e.$mg),e.$zg=e.$mg.resolvePath.bind(e.$mg),e.$Ag=e.$mg.isAbsolutePath.bind(e.$mg),e.$Bg=e.$mg.isEqualAuthority.bind(e.$mg),e.$Cg=e.$mg.hasTrailingPathSeparator.bind(e.$mg),e.$Dg=e.$mg.removeTrailingPathSeparator.bind(e.$mg),e.$Eg=e.$mg.addTrailingPathSeparator.bind(e.$mg);function A(v,p){const f=[];for(let t=0;t<v.length;t++){const i=p(v[t]);v.some((n,u)=>u===t?!1:(0,e.$qg)(i,p(n)))||f.push(v[t])}return f}e.$Fg=A;var S;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function p(f){const t=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(u=>{const[a,l]=u.split(":");a&&l&&t.set(a,l)});const n=f.path.substring(0,f.path.indexOf(";"));return n&&t.set(v.META_DATA_MIME,n),t}v.parseMetaData=p})(S||(e.DataUri=S={}));function o(v,p,f){if(p){let t=v.path;return t&&t[0]!==P.$fc.sep&&(t=P.$fc.sep+t),v.with({scheme:f,authority:p,path:t})}return v.with({scheme:f})}e.$Gg=o}),define(Ae[12],Re([1,0,20,11,5,6,25,21,124]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=e.$gh=e.Promises=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function g(be){return!!be&&typeof be.then=="function"}e.$Hg=g;function A(be){const se=new E.$Yd,he=be(se.token),ue=new Promise((ye,ee)=>{const de=se.token.onCancellationRequested(()=>{de.dispose(),se.dispose(),ee(new L.$4)});Promise.resolve(he).then(ie=>{de.dispose(),se.dispose(),ye(ie)},ie=>{de.dispose(),se.dispose(),ee(ie)})});return new class{cancel(){se.cancel()}then(ye,ee){return ue.then(ye,ee)}catch(ye){return this.then(void 0,ye)}finally(ye){return ue.finally(ye)}}}e.$Ig=A;function S(be,se,he){return new Promise((ue,ye)=>{const ee=se.onCancellationRequested(()=>{ee.dispose(),ue(he)});be.then(ue,ye).finally(()=>ee.dispose())})}e.$Jg=S;function o(be,se){return new Promise((he,ue)=>{const ye=se.onCancellationRequested(()=>{ye.dispose(),ue(new L.$4)});be.then(he,ue).finally(()=>ye.dispose())})}e.$Kg=o;async function v(be){let se=-1;const he=be.map((ue,ye)=>ue.then(ee=>(se=ye,ee)));try{return await Promise.race(he)}finally{be.forEach((ue,ye)=>{ye!==se&&ue.cancel()})}}e.$Lg=v;function p(be,se,he){let ue;const ye=setTimeout(()=>{ue?.(void 0),he?.()},se);return Promise.race([be.finally(()=>clearTimeout(ye)),new Promise(ee=>ue=ee)])}e.$Mg=p;function f(be){return new Promise((se,he)=>{const ue=be();g(ue)?ue.then(se,he):se(ue)})}e.$Ng=f;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(se){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=se,!this.b){const he=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(he,he).then(ue)})}return new Promise((he,ue)=>{this.b.then(he,ue)})}return this.a=se(),new Promise((he,ue)=>{this.a.then(ye=>{this.a=null,he(ye)},ye=>{this.a=null,ue(ye)})})}dispose(){this.f=!0}}e.$Og=t;class i{constructor(){this.a=Promise.resolve(null)}queue(se){return this.a=this.a.then(()=>se(),()=>se())}}e.$Pg=i;class n{constructor(){this.a=new Map}queue(se,he){const ye=(this.a.get(se)??Promise.resolve()).catch(()=>{}).then(he).finally(()=>{this.a.get(se)===ye&&this.a.delete(se)});return this.a.set(se,ye),ye}}e.$Qg=n;const u=(be,se)=>{let he=!0;const ue=setTimeout(()=>{he=!1,se()},be);return{isTriggered:()=>he,dispose:()=>{clearTimeout(ue),he=!1}}},a=be=>{let se=!0;return queueMicrotask(()=>{se&&(se=!1,be())}),{isTriggered:()=>se,dispose:()=>{se=!1}}};class l{constructor(se){this.defaultDelay=se,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(se,he=this.defaultDelay){this.g=se,this.h(),this.b||(this.b=new Promise((ye,ee)=>{this.d=ye,this.f=ee}).then(()=>{if(this.b=null,this.d=null,this.g){const ye=this.g;return this.g=null,ye()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=he===D.$Ld?a(ue):u(he,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Rg=l;class r{constructor(se){this.a=new l(se),this.b=new t}trigger(se,he){return this.a.trigger(()=>this.b.queue(se),he)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Sg=r;class s{constructor(){this.a=!1,this.b=new Promise((se,he)=>{this.d=se})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Tg=s;class c extends s{constructor(se){super(),this.f=setTimeout(()=>this.open(),se)}open(){clearTimeout(this.f),super.open()}}e.$Ug=c;function h(be,se){return se?new Promise((he,ue)=>{const ye=setTimeout(()=>{ee.dispose(),he()},be),ee=se.onCancellationRequested(()=>{clearTimeout(ye),ee.dispose(),ue(new L.$4)})}):A(he=>h(be,he))}e.$Vg=h;function w(be,se=0,he){const ue=setTimeout(()=>{be(),he&&ye.dispose()},se),ye=(0,M.$Pc)(()=>{clearTimeout(ue),he?.deleteAndLeak(ye)});return he?.add(ye),ye}e.$Wg=w;function m(be){const se=[];let he=0;const ue=be.length;function ye(){return he<ue?be[he++]():null}function ee(de){de!=null&&se.push(de);const ie=ye();return ie?ie.then(ee):Promise.resolve(se)}return Promise.resolve(null).then(ee)}e.$Xg=m;function I(be,se=ue=>!!ue,he=null){let ue=0;const ye=be.length,ee=()=>{if(ue>=ye)return Promise.resolve(he);const de=be[ue++];return Promise.resolve(de()).then(ae=>se(ae)?Promise.resolve(ae):ee())};return ee()}e.$Yg=I;function k(be,se=ue=>!!ue,he=null){if(be.length===0)return Promise.resolve(he);let ue=be.length;const ye=()=>{ue=-1;for(const ee of be)ee.cancel?.()};return new Promise((ee,de)=>{for(const ie of be)ie.then(ae=>{--ue>=0&&se(ae)?(ye(),ee(ae)):ue===0&&ee(he)}).catch(ae=>{--ue>=0&&(ye(),de(ae))})})}e.$Zg=k;class d{constructor(se){this.a=0,this.d=se,this.f=[],this.b=0,this.g=new P.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue(se){return this.a++,new Promise((he,ue)=>{this.f.push({factory:se,c:he,e:ue}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const se=this.f.shift();this.b++;const he=se.factory();he.then(se.c,se.e),he.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$1g=d;class b extends d{constructor(){super(1)}}e.$2g=b;class y{constructor(){this.a=new ke,this.b=0}queue(se){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,se())):this.a.run(this.b++,se())}}e.$3g=y;class C{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const se=new we;return this.b.add(se),se.p}g(){for(const[,se]of this.a)if(se.size>0)return!1;return!0}queueFor(se,he=R.$mg){const ue=he.getComparisonKey(se);let ye=this.a.get(ue);if(!ye){ye=new b;const ee=this.f++,de=P.Event.once(ye.onDrained)(()=>{ye?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose(ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$Zc),this.d.set(ee,de),this.a.set(ue,ye)}return ye}h(){this.g()&&this.j()}j(){for(const se of this.b)se.complete();this.b.clear()}dispose(){for(const[,se]of this.a)se.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$4g=C;class B{constructor(se,he){this.a=-1,typeof se=="function"&&typeof he=="number"&&this.setIfNotSet(se,he)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(se,he){this.cancel(),this.a=setTimeout(()=>{this.a=-1,se()},he)}setIfNotSet(se,he){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,se()},he))}}e.$5g=B;class H{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(se,he,ue=globalThis){this.cancel();const ye=ue.setInterval(()=>{se()},he);this.d=(0,M.$Pc)(()=>{ue.clearInterval(ye),this.d=void 0})}dispose(){this.cancel()}}e.$6g=H;class U{constructor(se,he){this.b=-1,this.a=se,this.d=he,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(se=this.d){this.cancel(),this.b=setTimeout(this.f,se)}get delay(){return this.d}set delay(se){this.d=se}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$7g=U;class z{constructor(se,he){he%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${he}ms is not a multiple of 1000ms.`),this.a=se,this.b=he,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(se=this.b){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(se/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$8g=z;class F extends U{constructor(se,he){super(se,he),this.j=[]}work(se){this.j.push(se),this.isScheduled()||this.schedule()}h(){const se=this.j;this.j=[],this.a?.(se)}dispose(){this.j=[],super.dispose()}}e.$9g=F;class N extends M.$Rc{constructor(se,he){super(),this.g=se,this.h=he,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(se){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+se.length>this.g.maxBufferedWork)return!1}else if(this.pending+se.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const he of se)this.a.push(he);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$0g=N,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$_g=(be,se)=>{(0,$.$B)(()=>{if(he)return;const ue=Date.now()+15;se(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let he=!1;return{dispose(){he||(he=!0)}}}:e.$_g=(be,se,he)=>{const ue=be.requestIdleCallback(se,typeof he=="number"?{timeout:he}:void 0);let ye=!1;return{dispose(){ye||(ye=!0,be.cancelIdleCallback(ue))}}},e.$$g=be=>(0,e.$_g)(globalThis,be)}();class X{constructor(se,he){this.g=!1,this.d=()=>{try{this.j=he()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$_g)(se,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$ah=X;class Q extends X{constructor(se){super(globalThis,se)}}e.$bh=Q;async function De(be,se,he){let ue;for(let ye=0;ye<he;ye++)try{return await be()}catch(ee){ue=ee,await h(se)}throw ue}e.$ch=De;class ke{isRunning(se){return typeof se=="number"?this.a?.taskId===se:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(se,he,ue){return this.a={taskId:se,cancel:()=>ue?.(),promise:he},he.then(()=>this.d(se),()=>this.d(se)),he}d(se){this.a&&se===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const se=this.b;this.b=void 0,se.run().then(se.promiseResolve,se.promiseReject)}}queue(se){if(this.b)this.b.run=se;else{let he,ue;const ye=new Promise((ee,de)=>{he=ee,ue=de});this.b={run:se,promise:ye,promiseResolve:he,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$dh=ke;class Pe{constructor(se,he=()=>Date.now()){this.d=se,this.f=he,this.a=0,this.b=0}increment(){const se=this.f();return se-this.a>this.d&&(this.a=se,this.b=0),this.b++,this.b}}e.$eh=Pe;var fe;(function(be){be[be.Resolved=0]="Resolved",be[be.Rejected=1]="Rejected"})(fe||(fe={}));class we{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((se,he)=>{this.a=se,this.b=he})}complete(se){return new Promise(he=>{this.a(se),this.d={outcome:0,value:se},he()})}error(se){return new Promise(he=>{this.b(se),this.d={outcome:1,value:se},he()})}cancel(){return this.error(new L.$4)}}e.$fh=we;var ne;(function(be){async function se(ue){let ye;const ee=await Promise.all(ue.map(de=>de.then(ie=>ie,ie=>{ye||(ye=ie)})));if(typeof ye<"u")throw ye;return ee}be.settled=se;function he(ue){return new Promise(async(ye,ee)=>{try{await ue(ye,ee)}catch(de){ee(de)}})}be.withAsyncBody=he})(ne||(e.Promises=ne={}));var re;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(re||(re={}));class pe{static fromArray(se){return new pe(he=>{he.emitMany(se)})}static fromPromise(se){return new pe(async he=>{he.emitMany(await se)})}static fromPromises(se){return new pe(async he=>{await Promise.all(se.map(async ue=>he.emitOne(await ue)))})}static merge(se){return new pe(async he=>{await Promise.all(se.map(async ue=>{for await(const ye of ue)he.emitOne(ye)}))})}static{this.EMPTY=pe.fromArray([])}constructor(se){this.a=0,this.b=[],this.d=null,this.f=new P.$Od,queueMicrotask(async()=>{const he={emitOne:ue=>this.g(ue),emitMany:ue=>this.h(ue),reject:ue=>this.k(ue)};try{await Promise.resolve(se(he)),this.j()}catch(ue){this.k(ue)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let se=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(se<this.b.length)return{done:!1,value:this.b[se++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(se,he){return new pe(async ue=>{for await(const ye of se)ue.emitOne(he(ye))})}map(se){return pe.map(this,se)}static filter(se,he){return new pe(async ue=>{for await(const ye of se)he(ye)&&ue.emitOne(ye)})}filter(se){return pe.filter(this,se)}static coalesce(se){return pe.filter(se,he=>!!he)}coalesce(){return pe.coalesce(this)}static async toPromise(se){const he=[];for await(const ue of se)he.push(ue);return he}toPromise(){return pe.toPromise(this)}g(se){this.a===0&&(this.b.push(se),this.f.fire())}h(se){this.a===0&&(this.b=this.b.concat(se),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(se){this.a===0&&(this.a=2,this.d=se,this.f.fire())}}e.$gh=pe;class _ extends pe{constructor(se,he){super(he),this.l=se}cancel(){this.l.cancel()}}e.$hh=_;function W(be){const se=new E.$Yd,he=be(se.token);return new _(se,async ue=>{const ye=se.token.onCancellationRequested(()=>{ye.dispose(),se.dispose(),ue.reject(new L.$4)});try{for await(const ee of he){if(se.token.isCancellationRequested)return;ue.emitOne(ee)}ye.dispose(),se.dispose()}catch(ee){ye.dispose(),se.dispose(),ue.reject(ee)}})}e.$ih=W;class ce{constructor(){this.a=new we,this.b=new pe(ue=>{if(se){ue.reject(se);return}return he&&ue.emitMany(he),this.d=ye=>ue.reject(ye),this.f=ye=>ue.emitOne(ye),this.a.p});let se,he;this.f=ue=>{he||(he=[]),he.push(ue)},this.d=ue=>{se||(se=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(se){this.d(se),this.a.complete()}emitOne(se){this.f(se)}}e.$jh=ce}),define(Ae[33],Re([1,0,18,12,46,28,19,21,13]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=void 0;function g(){return Object.create(null)}e.$uj=g,e.$vj="**",e.$wj="/";const A="[/\\\\]",S="[^/\\\\]",o=/\//g;function v(De,ke){switch(De){case 0:return"";case 1:return`${S}*?`;default:return`(?:${A}|${S}+${A}${ke?`|${A}${S}+`:""})*?`}}function p(De,ke){if(!De)return[];const Pe=[];let fe=!1,we=!1,ne="";for(const re of De){switch(re){case ke:if(!fe&&!we){Pe.push(ne),ne="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":we=!0;break;case"]":we=!1;break}ne+=re}return ne&&Pe.push(ne),Pe}e.$xj=p;function f(De){if(!De)return"";let ke="";const Pe=p(De,e.$wj);if(Pe.every(fe=>fe===e.$vj))ke=".*";else{let fe=!1;Pe.forEach((we,ne)=>{if(we===e.$vj){if(fe)return;ke+=v(2,ne===Pe.length-1)}else{let re=!1,pe="",_=!1,W="";for(const ce of we){if(ce!=="}"&&re){pe+=ce;continue}if(_&&(ce!=="]"||!W)){let be;ce==="-"?be=ce:(ce==="^"||ce==="!")&&!W?be="^":ce===e.$wj?be="":be=(0,D.$Ge)(ce),W+=be;continue}switch(ce){case"{":re=!0;continue;case"[":_=!0;continue;case"}":{const se=`(?:${p(pe,",").map(he=>f(he)).join("|")})`;ke+=se,re=!1,pe="";break}case"]":{ke+="["+W+"]",_=!1,W="";break}case"?":ke+=S;continue;case"*":ke+=v(1);continue;default:ke+=(0,D.$Ge)(ce)}}ne<Pe.length-1&&(Pe[ne+1]!==e.$vj||ne+2<Pe.length)&&(ke+=A)}fe=we===e.$vj})}return ke}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new M.$Cc(1e4),s=function(){return!1},c=function(){return null};function h(De,ke){if(!De)return c;let Pe;typeof De!="string"?Pe=De.pattern:Pe=De,Pe=Pe.trim();const fe=`${Pe}_${!!ke.trimForExclusions}`;let we=r.get(fe);if(we)return w(we,De);let ne;return t.test(Pe)?we=I(Pe.substr(4),Pe):(ne=i.exec(m(Pe,ke)))?we=k(ne[1],Pe):(ke.trimForExclusions?u:n).test(Pe)?we=d(Pe,ke):(ne=a.exec(m(Pe,ke)))?we=b(ne[1].substr(1),Pe,!0):(ne=l.exec(m(Pe,ke)))?we=b(ne[1],Pe,!1):we=y(Pe),r.set(fe,we),w(we,De)}function w(De,ke){if(typeof ke=="string")return De;const Pe=function(fe,we){return(0,P.$Yf)(fe,ke.base,!$.$k)?De((0,D.$Ke)(fe.substr(ke.base.length),R.sep),we):null};return Pe.allBasenames=De.allBasenames,Pe.allPaths=De.allPaths,Pe.basenames=De.basenames,Pe.patterns=De.patterns,Pe}function m(De,ke){return ke.trimForExclusions&&De.endsWith("/**")?De.substr(0,De.length-2):De}function I(De,ke){return function(Pe,fe){return typeof Pe=="string"&&Pe.endsWith(De)?ke:null}}function k(De,ke){const Pe=`/${De}`,fe=`\\${De}`,we=function(re,pe){return typeof re!="string"?null:pe?pe===De?ke:null:re===De||re.endsWith(Pe)||re.endsWith(fe)?ke:null},ne=[De];return we.basenames=ne,we.patterns=[ke],we.allBasenames=ne,we}function d(De,ke){const Pe=X(De.slice(1,-1).split(",").map(pe=>h(pe,ke)).filter(pe=>pe!==c),De),fe=Pe.length;if(!fe)return c;if(fe===1)return Pe[0];const we=function(pe,_){for(let W=0,ce=Pe.length;W<ce;W++)if(Pe[W](pe,_))return De;return null},ne=Pe.find(pe=>!!pe.allBasenames);ne&&(we.allBasenames=ne.allBasenames);const re=Pe.reduce((pe,_)=>_.allPaths?pe.concat(_.allPaths):pe,[]);return re.length&&(we.allPaths=re),we}function b(De,ke,Pe){const fe=R.sep===R.$fc.sep,we=fe?De:De.replace(o,R.sep),ne=R.sep+we,re=R.$fc.sep+De;let pe;return Pe?pe=function(_,W){return typeof _=="string"&&(_===we||_.endsWith(ne)||!fe&&(_===De||_.endsWith(re)))?ke:null}:pe=function(_,W){return typeof _=="string"&&(_===we||!fe&&_===De)?ke:null},pe.allPaths=[(Pe?"*/":"./")+De],pe}function y(De){try{const ke=new RegExp(`^${f(De)}$`);return function(Pe){return ke.lastIndex=0,typeof Pe=="string"&&ke.test(Pe)?De:null}}catch{return c}}function C(De,ke,Pe){return!De||typeof ke!="string"?!1:B(De)(ke,void 0,Pe)}e.$yj=C;function B(De,ke={}){if(!De)return s;if(typeof De=="string"||H(De)){const Pe=h(De,ke);if(Pe===c)return s;const fe=function(we,ne){return!!Pe(we,ne)};return Pe.allBasenames&&(fe.allBasenames=Pe.allBasenames),Pe.allPaths&&(fe.allPaths=Pe.allPaths),fe}return F(De,ke)}e.$zj=B;function H(De){const ke=De;return ke?typeof ke.base=="string"&&typeof ke.pattern=="string":!1}e.$Aj=H;function U(De){return De.allBasenames||[]}e.$Bj=U;function z(De){return De.allPaths||[]}e.$Cj=z;function F(De,ke){const Pe=X(Object.getOwnPropertyNames(De).map(pe=>N(pe,De[pe],ke)).filter(pe=>pe!==c)),fe=Pe.length;if(!fe)return c;if(!Pe.some(pe=>!!pe.requiresSiblings)){if(fe===1)return Pe[0];const pe=function(ce,be){let se;for(let he=0,ue=Pe.length;he<ue;he++){const ye=Pe[he](ce,be);if(typeof ye=="string")return ye;(0,L.$Hg)(ye)&&(se||(se=[]),se.push(ye))}return se?(async()=>{for(const he of se){const ue=await he;if(typeof ue=="string")return ue}return null})():null},_=Pe.find(ce=>!!ce.allBasenames);_&&(pe.allBasenames=_.allBasenames);const W=Pe.reduce((ce,be)=>be.allPaths?ce.concat(be.allPaths):ce,[]);return W.length&&(pe.allPaths=W),pe}const we=function(pe,_,W){let ce,be;for(let se=0,he=Pe.length;se<he;se++){const ue=Pe[se];ue.requiresSiblings&&W&&(_||(_=(0,R.$mc)(pe)),ce||(ce=_.substr(0,_.length-(0,R.$nc)(pe).length)));const ye=ue(pe,_,ce,W);if(typeof ye=="string")return ye;(0,L.$Hg)(ye)&&(be||(be=[]),be.push(ye))}return be?(async()=>{for(const se of be){const he=await se;if(typeof he=="string")return he}return null})():null},ne=Pe.find(pe=>!!pe.allBasenames);ne&&(we.allBasenames=ne.allBasenames);const re=Pe.reduce((pe,_)=>_.allPaths?pe.concat(_.allPaths):pe,[]);return re.length&&(we.allPaths=re),we}function N(De,ke,Pe){if(ke===!1)return c;const fe=h(De,Pe);if(fe===c)return c;if(typeof ke=="boolean")return fe;if(ke){const we=ke.when;if(typeof we=="string"){const ne=(re,pe,_,W)=>{if(!W||!fe(re,pe))return null;const ce=we.replace("$(basename)",()=>_),be=W(ce);return(0,L.$Hg)(be)?be.then(se=>se?De:null):be?De:null};return ne.requiresSiblings=!0,ne}}return fe}function X(De,ke){const Pe=De.filter(pe=>!!pe.basenames);if(Pe.length<2)return De;const fe=Pe.reduce((pe,_)=>{const W=_.basenames;return W?pe.concat(W):pe},[]);let we;if(ke){we=[];for(let pe=0,_=fe.length;pe<_;pe++)we.push(ke)}else we=Pe.reduce((pe,_)=>{const W=_.patterns;return W?pe.concat(W):pe},[]);const ne=function(pe,_){if(typeof pe!="string")return null;if(!_){let ce;for(ce=pe.length;ce>0;ce--){const be=pe.charCodeAt(ce-1);if(be===47||be===92)break}_=pe.substr(ce)}const W=fe.indexOf(_);return W!==-1?we[W]:null};ne.basenames=fe,ne.patterns=we,ne.allBasenames=fe;const re=De.filter(pe=>!pe.basenames);return re.push(ne),re}function Q(De,ke){return(0,E.$tb)(De,ke,(Pe,fe)=>typeof Pe=="string"&&typeof fe=="string"?Pe===fe:typeof Pe!="string"&&typeof fe!="string"?Pe.base===fe.base&&Pe.pattern===fe.pattern:!1)}e.$Dj=Q}),define(Ae[53],Re([1,0,11,125,25,13,2]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class D{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,E.$6)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=o(this.supportThemeIcons?(0,L.$Zj)(i):i).replace(/([ \t]+)/g,(u,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(i,n,u){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),u&&(this.value+=` "${this.c(this.c(u,'"'),")")}"`),this.value+=")",this}c(i,n){const u=new RegExp((0,M.$Ge)(n),"g");return i.replace(u,(a,l)=>i.charAt(l-1)!=="\\"?`\\${a}`:a)}}e.$6j=D;function g(t){return A(t)?!t.value:Array.isArray(t)?t.every(g):!0}e.$7j=g;function A(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$8j=A;function S(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,P.$pg)(R.URI.from(t.baseUri),R.URI.from(i.baseUri)))}e.$9j=S;function o(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$0j=o;function v(t){return t.replace(/"/g,"&quot;")}e.$$j=v;function p(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$_j=p;function f(t){const i=[],n=t.split("|").map(a=>a.trim());t=n[0];const u=n[1];if(u){const a=/height=(\d+)/.exec(u),l=/width=(\d+)/.exec(u),r=a?a[1]:"",s=l?l[1]:"",c=isFinite(parseInt(s)),h=isFinite(parseInt(r));c&&i.push(`width="${s}"`),h&&i.push(`height="${r}"`)}return{href:t,dimensions:i}}e.$ak=f}),define(Ae[94],Re([1,0,18,46,19,21,25,13]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=void 0;function D(h,w){const{os:m,tildify:I,relative:k}=w;if(k){const y=g(h,k,m);if(typeof y=="string")return y}let d=h.fsPath;if(m===1&&!M.$i?d=d.replace(/\//g,"\\"):m!==1&&M.$i&&(d=d.replace(/\\/g,"/")),m!==1&&I?.userHome){const y=I.userHome.fsPath;let C;h.scheme!==I.userHome.scheme&&h.path[0]===P.$fc.sep&&h.path[1]!==P.$fc.sep?C=I.userHome.with({path:h.path}).fsPath:C=d,d=o(C,y,m)}return(m===1?P.$ec:P.$fc).normalize(A(d,m===1))}e.$uv=D;function g(h,w,m){const I=m===1?P.$ec:P.$fc,k=m===3?R.$mg:R.$og,d=w.getWorkspace(),b=(0,E.$Nb)(d.folders);if(!b)return;h.scheme!==b.uri.scheme&&h.path[0]===P.$fc.sep&&h.path[1]!==P.$fc.sep&&(h=b.uri.with({path:h.path}));const y=w.getWorkspaceFolder(h);if(!y)return;let C;if(k.isEqual(y.uri,h)?C="":C=k.relativePath(y.uri,h)??"",C&&(C=I.normalize(C)),d.folders.length>1&&!w.noPrefix){const B=y.name?y.name:k.basenameOrAuthority(y.uri);C=C?`${B} \u2022 ${C}`:B}return C}function A(h,w=M.$i){return(0,L.$3f)(h,w)?h.charAt(0).toUpperCase()+h.slice(1):h}e.$vv=A;let S=Object.create(null);function o(h,w,m=M.OS){if(m===1||!h||!w)return h;let I=S.original===w?S.normalized:void 0;I||(I=w,M.$i&&(I=(0,L.$Sf)(I)),I=`${(0,$.$Le)(I,P.$fc.sep)}${P.$fc.sep}`,S={original:w,normalized:I});let k=h;return M.$i&&(k=(0,L.$Sf)(k)),(m===3?k.startsWith(I):(0,$.$4e)(k,I))?`~/${k.substr(I.length)}`:h}e.$wv=o;function v(h,w){return h.replace(/^~($|\/|\\)/,`${w}$1`)}e.$xv=v;const p="\u2026",f="\\\\",t="~";function i(h,w=P.sep){const m=new Array(h.length);let I=!1;for(let k=0;k<h.length;k++){const d=h[k];if(d===""){m[k]=`.${w}`;continue}if(!d){m[k]=d;continue}I=!0;let b="",y=d;y.indexOf(f)===0?(b=y.substr(0,y.indexOf(f)+f.length),y=y.substr(y.indexOf(f)+f.length)):y.indexOf(w)===0?(b=y.substr(0,y.indexOf(w)+w.length),y=y.substr(y.indexOf(w)+w.length)):y.indexOf(t)===0&&(b=y.substr(0,y.indexOf(t)+t.length),y=y.substr(y.indexOf(t)+t.length));const C=y.split(w);for(let B=1;I&&B<=C.length;B++)for(let H=C.length-B;I&&H>=0;H--){I=!1;let U=C.slice(H,H+B).join(w);for(let z=0;!I&&z<h.length;z++)if(z!==k&&h[z]&&h[z].indexOf(U)>-1){const F=H+B===C.length,N=H>0&&h[z].indexOf(w)>-1?w+U:U,X=h[z].endsWith(N);I=!F||X}if(!I){let z="";(C[0].endsWith(":")||b!=="")&&(H===1&&(H=0,B++,U=C[0]+w+U),H>0&&(z=C[0]+w),z=b+z),H>0&&(z=z+p+w),z=z+U,H+B<C.length&&(z=z+w+p),m[k]=z}}I&&(m[k]=d)}return m}e.$yv=i;var n;(function(h){h[h.TEXT=0]="TEXT",h[h.VARIABLE=1]="VARIABLE",h[h.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function u(h,w=Object.create(null)){const m=[];let I=!1,k="";for(const d of h)if(d==="$"||I&&d==="{")k&&m.push({value:k,type:n.TEXT}),k="",I=!0;else if(d==="}"&&I){const b=w[k];if(typeof b=="string")b.length&&m.push({value:b,type:n.VARIABLE});else if(b){const y=m[m.length-1];(!y||y.type!==n.SEPARATOR)&&m.push({value:b.label,type:n.SEPARATOR})}k="",I=!1}else k+=d;return k&&!I&&m.push({value:k,type:n.TEXT}),m.filter((d,b)=>{if(d.type===n.SEPARATOR){const y=m[b-1],C=m[b+1];return[y,C].every(B=>B&&(B.type===n.VARIABLE||B.type===n.TEXT)&&B.value.length>0)}return!0}).map(d=>d.value).join("")}e.$zv=u;function a(h,w){return M.$j||w?h.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):h.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.$Av=a;function l(h,w){return M.$j||w?h.replace(/\(&&\w\)|&&/g,""):M.$i?h.replace(/&&|&/g,m=>m==="&"?"&&":"&"):h.replace(/&&/g,"_")}e.$Bv=l;function r(h){return h.replace(/&/g,"&&")}e.$Cv=r;function s(h){if(h.endsWith("]")){const w=h.lastIndexOf(" [",h.length-2);if(w!==-1){const m=c(h.substring(0,w));return{name:m.name,parentPath:m.parentPath+h.substring(w)}}}return c(h)}e.$Dv=s;function c(h){const w=h.indexOf("/")!==-1?P.$fc:P.$ec,m=w.basename(h),I=w.dirname(h);return m.length?{name:m,parentPath:I}:{name:I,parentPath:""}}}),define(Ae[139],Re([1,0,24,2]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=void 0;function P(S){return S.toJSON()}class M{constructor(o){this.a=o}transformIncoming(o){const v=this.a.transformIncoming(o);return v===o?o:P(L.URI.from(v))}transformOutgoing(o){const v=this.a.transformOutgoing(o);return v===o?o:P(L.URI.from(v))}transformOutgoingURI(o){const v=this.a.transformOutgoing(o);return v===o?o:L.URI.from(v)}transformOutgoingScheme(o){return this.a.transformOutgoingScheme(o)}}e.$Om=M,e.$Pm=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function R(S,o,v){if(!S||v>200)return null;if(typeof S=="object"){if(S instanceof L.URI)return o.transformOutgoing(S);for(const p in S)if(Object.hasOwnProperty.call(S,p)){const f=R(S[p],o,v+1);f!==null&&(S[p]=f)}}return null}function $(S,o){const v=R(S,o,0);return v===null?S:v}e.$Qm=$;function D(S,o,v,p){if(!S||p>200)return null;if(typeof S=="object"){if(S.$mid===1)return v?L.URI.revive(o.transformIncoming(S)):o.transformIncoming(S);if(S instanceof E.$ce)return null;for(const f in S)if(Object.hasOwnProperty.call(S,f)){const t=D(S[f],o,v,p+1);t!==null&&(S[f]=t)}}return null}function g(S,o){const v=D(S,o,!1,0);return v===null?S:v}e.$Rm=g;function A(S,o){const v=D(S,o,!0,0);return v===null?S:v}e.$Sm=A}),define(Ae[140],Re([1,0,13,21,24]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=e.$Ps=e.$Os=void 0;let M;function R(){return M||(M=new TextDecoder("UTF-16LE")),M}let $;function D(){return $||($=new TextDecoder("UTF-16BE")),$}let g;function A(){return g||(g=L.$D()?R():D()),g}e.$Os=A;function S(p,f,t){const i=new Uint16Array(p.buffer,f,t);return t>0&&(i[0]===65279||i[0]===65534)?o(p,f,t):R().decode(i)}e.$Ps=S;function o(p,f,t){const i=[];let n=0;for(let u=0;u<t;u++){const a=P.$ee(p,f);f+=2,i[n++]=String.fromCharCode(a)}return i.join("")}class v{constructor(f){this.a=f|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const f=new Uint16Array(this.b.buffer,0,this.d);return A().decode(f)}f(){const f=this.e();this.d=0,this.c===null?this.c=[f]:this.c[this.c.length]=f}appendCharCode(f){const t=this.a-this.d;t<=1&&(t===0||E.$7e(f))&&this.f(),this.b[this.d++]=f}appendASCIICharCode(f){this.d===this.a&&this.f(),this.b[this.d++]=f}appendString(f){const t=f.length;if(this.d+t>=this.a){this.f(),this.c[this.c.length]=f;return}for(let i=0;i<t;i++)this.b[this.d++]=f.charCodeAt(i)}}e.$Qs=v}),define(Ae[141],Re([1,0,24,140]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=e.$Rs=void 0;function P(D){return D.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(g,A,S,o){this.oldPosition=g,this.oldText=A,this.newPosition=S,this.newText=o}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(g){return 4+2*g.length}static c(g,A,S){const o=A.length;E.$he(g,o,S),S+=4;for(let v=0;v<o;v++)E.$fe(g,A.charCodeAt(v),S),S+=2;return S}static d(g,A){const S=E.$ge(g,A);return A+=4,(0,L.$Ps)(g,A,S)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(g,A){return E.$he(g,this.oldPosition,A),A+=4,E.$he(g,this.newPosition,A),A+=4,A=M.c(g,this.oldText,A),A=M.c(g,this.newText,A),A}static read(g,A,S){const o=E.$ge(g,A);A+=4;const v=E.$ge(g,A);A+=4;const p=M.d(g,A);A+=M.a(p);const f=M.d(g,A);return A+=M.a(f),S.push(new M(o,p,v,f)),A}}e.$Rs=M;function R(D,g){return D===null||D.length===0?g:new $(D,g).compress()}e.$Ss=R;class ${constructor(g,A){this.a=g,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let g=0,A=0,S=this.n(g),o=this.l(A);for(;g<this.f||A<this.h;){if(S===null){this.k(o),o=this.l(++A);continue}if(o===null){this.m(S),S=this.n(++g);continue}if(o.oldEnd<=S.newPosition){this.k(o),o=this.l(++A);continue}if(S.newEnd<=o.oldPosition){this.m(S),S=this.n(++g);continue}if(o.oldPosition<S.newPosition){const[i,n]=$.r(o,S.newPosition-o.oldPosition);this.k(i),o=n;continue}if(S.newPosition<o.oldPosition){const[i,n]=$.q(S,o.oldPosition-S.newPosition);this.m(i),S=n;continue}let f,t;if(o.oldEnd===S.newEnd)f=S,t=o,S=this.n(++g),o=this.l(++A);else if(o.oldEnd<S.newEnd){const[i,n]=$.q(S,o.oldLength);f=i,t=o,S=n,o=this.l(++A)}else{const[i,n]=$.r(o,S.newLength);f=S,t=i,S=this.n(++g),o=n}this.d[this.e++]=new M(f.oldPosition,f.oldText,t.newPosition,t.newText),this.g+=f.newLength-f.oldLength,this.j+=t.newLength-t.oldLength}const v=$.s(this.d);return $.t(v)}k(g){this.d[this.e++]=$.o(this.g,g),this.j+=g.newLength-g.oldLength}l(g){return g<this.h?this.c[g]:null}m(g){this.d[this.e++]=$.p(this.j,g),this.g+=g.newLength-g.oldLength}n(g){return g<this.f?this.a[g]:null}static o(g,A){return new M(A.oldPosition-g,A.oldText,A.newPosition,A.newText)}static p(g,A){return new M(A.oldPosition,A.oldText,A.newPosition+g,A.newText)}static q(g,A){const S=g.newText.substr(0,A),o=g.newText.substr(A);return[new M(g.oldPosition,g.oldText,g.newPosition,S),new M(g.oldEnd,"",g.newPosition+A,o)]}static r(g,A){const S=g.oldText.substr(0,A),o=g.oldText.substr(A);return[new M(g.oldPosition,S,g.newPosition,g.newText),new M(g.oldPosition+A,o,g.newEnd,"")]}static s(g){if(g.length===0)return g;const A=[];let S=0,o=g[0];for(let v=1;v<g.length;v++){const p=g[v];o.oldEnd===p.oldPosition?o=new M(o.oldPosition,o.oldText+p.oldText,o.newPosition,o.newText+p.newText):(A[S++]=o,o=p)}return A[S++]=o,A}static t(g){if(g.length===0)return g;const A=[];let S=0;for(let o=0;o<g.length;o++){const v=g[o];v.oldText!==v.newText&&(A[S++]=v)}return A}}}),define(Ae[142],Re([1,0,33,19]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GE=void 0;function P(M,R,$,D,g,A){if(Array.isArray(M)){let S=0;for(const o of M){const v=P(o,R,$,D,g,A);if(v===10)return v;v>S&&(S=v)}return S}else{if(typeof M=="string")return D?M==="*"?5:M===$?10:0:0;if(M){const{language:S,pattern:o,scheme:v,hasAccessToAllModels:p,notebookType:f}=M;if(!D&&!p)return 0;f&&g&&(R=g);let t=0;if(v)if(v===R.scheme)t=10;else if(v==="*")t=5;else return 0;if(S)if(S===$)t=10;else if(S==="*")t=Math.max(t,5);else return 0;if(f)if(f===A)t=10;else if(f==="*"&&A!==void 0)t=Math.max(t,5);else return 0;if(o){let i;if(typeof o=="string"?i=o:i={...o,base:(0,L.$gc)(o.base)},i===R.fsPath||(0,E.$yj)(i,R.fsPath))t=10;else return 0}return t}else return 0}}e.$GE=P}),define(Ae[143],Re([1,0,5,13,29,92,91,127,141,6]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IB=void 0;class A extends g.$Rc{constructor(o,v,p,f,t,i,n){super(),this.m=this.B(new E.$Od),this.onDidChangeContent=this.m.event,this.f=v,this.j=!i,this.g=f,this.h=t,this.c=new R.$HB(o,p,n)}equals(o){return!(o instanceof A)||this.f!==o.f||this.getEOL()!==o.getEOL()?!1:this.c.equal(o.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(o){return this.c.createSnapshot(o?this.f:"")}getOffsetAt(o,v){return this.c.getOffsetAt(o,v)}getPositionAt(o){return this.c.getPositionAt(o)}getRangeAt(o,v){const p=o+v,f=this.getPositionAt(o),t=this.getPositionAt(p);return new P.$ws(f.lineNumber,f.column,t.lineNumber,t.column)}getValueInRange(o,v=0){if(o.isEmpty())return"";const p=this.n(v);return this.c.getValueInRange(o,p)}getValueLengthInRange(o,v=0){if(o.isEmpty())return 0;if(o.startLineNumber===o.endLineNumber)return o.endColumn-o.startColumn;const p=this.getOffsetAt(o.startLineNumber,o.startColumn),f=this.getOffsetAt(o.endLineNumber,o.endColumn);let t=0;const i=this.n(v),n=this.getEOL();if(i.length!==n.length){const u=i.length-n.length,a=o.endLineNumber-o.startLineNumber;t=u*a}return f-p+t}getCharacterCountInRange(o,v=0){if(this.j){let p=0;const f=o.startLineNumber,t=o.endLineNumber;for(let i=f;i<=t;i++){const n=this.getLineContent(i),u=i===f?o.startColumn-1:0,a=i===t?o.endColumn-1:n.length;for(let l=u;l<a;l++)L.$7e(n.charCodeAt(l))?(p=p+1,l=l+1):p=p+1}return p+=this.n(v).length*(t-f),p}return this.getValueLengthInRange(o,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(o){return this.c.getLineContent(o)}getLineCharCode(o,v){return this.c.getLineCharCode(o,v)}getCharCode(o){return this.c.getCharCode(o)}getLineLength(o){return this.c.getLineLength(o)}getLineMinColumn(o){return 1}getLineMaxColumn(o){return this.getLineLength(o)+1}getLineFirstNonWhitespaceColumn(o){const v=L.$Re(this.getLineContent(o));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(o){const v=L.$Te(this.getLineContent(o));return v===-1?0:v+2}n(o){switch(o){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(o){this.c.setEOL(o)}applyEdits(o,v,p){let f=this.g,t=this.h,i=this.j,n=!0,u=[];for(let w=0;w<o.length;w++){const m=o[w];n&&m._isTracked&&(n=!1);const I=m.range;if(m.text){let C=!0;i||(C=!L.$ff(m.text),i=C),!f&&C&&(f=L.$ef(m.text)),!t&&C&&(t=L.$hf(m.text))}let k="",d=0,b=0,y=0;if(m.text){let C;[d,b,y,C]=(0,$.$9s)(m.text);const B=this.getEOL();C===0||C===(B===`\r
`?2:1)?k=m.text:k=m.text.replace(/\r\n|\r|\n/g,B)}u[w]={sortIndex:w,identifier:m.identifier||null,range:I,rangeOffset:this.getOffsetAt(I.startLineNumber,I.startColumn),rangeLength:this.getValueLengthInRange(I),text:k,eolCount:d,firstLineLength:b,lastLineLength:y,forceMoveMarkers:!!m.forceMoveMarkers,isAutoWhitespaceEdit:m.isAutoWhitespaceEdit||!1}}u.sort(A.u);let a=!1;for(let w=0,m=u.length-1;w<m;w++){const I=u[w].range.getEndPosition(),k=u[w+1].range.getStartPosition();if(k.isBeforeOrEqual(I)){if(k.isBefore(I))throw new Error("Overlapping ranges are not allowed!");a=!0}}n&&(u=this.s(u));const l=p||v?A._getInverseEditRanges(u):[],r=[];if(v)for(let w=0;w<u.length;w++){const m=u[w],I=l[w];if(m.isAutoWhitespaceEdit&&m.range.isEmpty())for(let k=I.startLineNumber;k<=I.endLineNumber;k++){let d="";k===I.startLineNumber&&(d=this.getLineContent(m.range.startLineNumber),L.$Re(d)!==-1)||r.push({lineNumber:k,oldContent:d})}}let s=null;if(p){let w=0;s=[];for(let m=0;m<u.length;m++){const I=u[m],k=l[m],d=this.getValueInRange(I.range),b=I.rangeOffset+w;w+=I.text.length-d.length,s[m]={sortIndex:I.sortIndex,identifier:I.identifier,range:k,text:d,textChange:new D.$Rs(I.rangeOffset,d,b,I.text)}}a||s.sort((m,I)=>m.sortIndex-I.sortIndex)}this.g=f,this.h=t,this.j=i;const c=this.t(u);let h=null;if(v&&r.length>0){r.sort((w,m)=>m.lineNumber-w.lineNumber),h=[];for(let w=0,m=r.length;w<m;w++){const I=r[w].lineNumber;if(w>0&&r[w-1].lineNumber===I)continue;const k=r[w].oldContent,d=this.getLineContent(I);d.length===0||d===k||L.$Re(d)!==-1||h.push(I)}}return this.m.fire(),new M.$Ru(s,c,h)}s(o){return o.length<1e3?o:[this._toSingleEditOperation(o)]}_toSingleEditOperation(o){let v=!1;const p=o[0].range,f=o[o.length-1].range,t=new P.$ws(p.startLineNumber,p.startColumn,f.endLineNumber,f.endColumn);let i=p.startLineNumber,n=p.startColumn;const u=[];for(let c=0,h=o.length;c<h;c++){const w=o[c],m=w.range;v=v||w.forceMoveMarkers,u.push(this.getValueInRange(new P.$ws(i,n,m.startLineNumber,m.startColumn))),w.text.length>0&&u.push(w.text),i=m.endLineNumber,n=m.endColumn}const a=u.join(""),[l,r,s]=(0,$.$9s)(a);return{sortIndex:0,identifier:o[0].identifier,range:t,rangeOffset:this.getOffsetAt(t.startLineNumber,t.startColumn),rangeLength:this.getValueLengthInRange(t,0),text:a,eolCount:l,firstLineLength:r,lastLineLength:s,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(o){o.sort(A.w);const v=[];for(let p=0;p<o.length;p++){const f=o[p],t=f.range.startLineNumber,i=f.range.startColumn,n=f.range.endLineNumber,u=f.range.endColumn;if(t===n&&i===u&&f.text.length===0)continue;f.text?(this.c.delete(f.rangeOffset,f.rangeLength),this.c.insert(f.rangeOffset,f.text,!0)):this.c.delete(f.rangeOffset,f.rangeLength);const a=new P.$ws(t,i,n,u);v.push({range:a,rangeLength:f.rangeLength,text:f.text,rangeOffset:f.rangeOffset,forceMoveMarkers:f.forceMoveMarkers})}return v}findMatchesLineByLine(o,v,p,f){return this.c.findMatchesLineByLine(o,v,p,f)}getPieceTree(){return this.c}static _getInverseEditRange(o,v){const p=o.startLineNumber,f=o.startColumn,[t,i,n]=(0,$.$9s)(v);let u;if(v.length>0){const a=t+1;a===1?u=new P.$ws(p,f,p,f+i):u=new P.$ws(p,f,p+a-1,n+1)}else u=new P.$ws(p,f,p,f);return u}static _getInverseEditRanges(o){const v=[];let p=0,f=0,t=null;for(let i=0,n=o.length;i<n;i++){const u=o[i];let a,l;t?t.range.endLineNumber===u.range.startLineNumber?(a=p,l=f+(u.range.startColumn-t.range.endColumn)):(a=p+(u.range.startLineNumber-t.range.endLineNumber),l=u.range.startColumn):(a=u.range.startLineNumber,l=u.range.startColumn);let r;if(u.text.length>0){const s=u.eolCount+1;s===1?r=new P.$ws(a,l,a,l+u.firstLineLength):r=new P.$ws(a,l,a+s-1,u.lastLineLength+1)}else r=new P.$ws(a,l,a,l);p=r.endLineNumber,f=r.endColumn,v.push(r),t=u}return v}static u(o,v){const p=P.$ws.compareRangesUsingEnds(o.range,v.range);return p===0?o.sortIndex-v.sortIndex:p}static w(o,v){const p=P.$ws.compareRangesUsingEnds(o.range,v.range);return p===0?v.sortIndex-o.sortIndex:-p}}e.$IB=A}),define(Ae[144],Re([1,0,13,91,143]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JB=void 0;class M{constructor(D,g,A,S,o,v,p,f,t){this.a=D,this.b=g,this.c=A,this.d=S,this.e=o,this.f=v,this.g=p,this.h=f,this.j=t}k(D){const g=this.c+this.d+this.e,A=this.c+this.e;return g===0?D===1?`
`:`\r
`:A>g/2?`\r
`:`
`}create(D){const g=this.k(D),A=this.a;if(this.j&&(g===`\r
`&&(this.c>0||this.d>0)||g===`
`&&(this.c>0||this.e>0)))for(let o=0,v=A.length;o<v;o++){const p=A[o].buffer.replace(/\r\n|\r|\n/g,g),f=(0,L.$DB)(p);A[o]=new L.$GB(p,f)}const S=new P.$IB(A,this.b,g,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(D){return this.a[0].buffer.substr(0,D).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(D){if(D.length===0)return;this.a.length===0&&E.$nf(D)&&(this.b=E.$mf,D=D.substr(1));const g=D.charCodeAt(D.length-1);g===13||g>=55296&&g<=56319?(this.m(D.substr(0,D.length-1),!1),this.c=!0,this.d=g):(this.m(D,!1),this.c=!1,this.d=g)}m(D,g){!g&&D.length===0||(this.c?this.n(String.fromCharCode(this.d)+D):this.n(D))}n(D){const g=(0,L.$EB)(this.e,D);this.a.push(new L.$GB(D,g.lineStarts)),this.f+=g.cr,this.g+=g.lf,this.h+=g.crlf,g.isBasicASCII||(this.l=!1,this.j||(this.j=E.$ef(D)),this.k||(this.k=E.$hf(D)))}finish(D=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,D)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const D=this.a[this.a.length-1];D.buffer+=String.fromCharCode(this.d);const g=(0,L.$DB)(D.buffer);D.lineStarts=g,this.d===13&&this.f++}}}e.$JB=R}),define(Ae[95],Re([1,0,24,21]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y$=e.$x$=void 0;var P;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(P||(P={}));function M(S){for(let o=0,v=S.length;o<v;o+=4){const p=S[o+0],f=S[o+1],t=S[o+2],i=S[o+3];S[o+0]=i,S[o+1]=t,S[o+2]=f,S[o+3]=p}}function R(S){const o=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return L.$D()||M(o),E.$ce.wrap(o)}function $(S){const o=S.buffer;if(L.$D()||M(o),o.byteOffset%4===0)return new Uint32Array(o.buffer,o.byteOffset,o.length/4);{const v=new Uint8Array(o.byteLength);return v.set(o),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function D(S){const o=new Uint32Array(g(S));let v=0;if(o[v++]=S.id,S.type==="full")o[v++]=1,o[v++]=S.data.length,o.set(S.data,v),v+=S.data.length;else{o[v++]=2,o[v++]=S.deltas.length;for(const p of S.deltas)o[v++]=p.start,o[v++]=p.deleteCount,p.data?(o[v++]=p.data.length,o.set(p.data,v),v+=p.data.length):o[v++]=0}return R(o)}e.$x$=D;function g(S){let o=0;if(o+=1+1,S.type==="full")o+=1+S.data.length;else{o+=1,o+=(1+1+1)*S.deltas.length;for(const v of S.deltas)v.data&&(o+=v.data.length)}return o}function A(S){const o=$(S);let v=0;const p=o[v++];if(o[v++]===1){const n=o[v++],u=o.subarray(v,v+n);return v+=n,{id:p,type:"full",data:u}}const t=o[v++],i=[];for(let n=0;n<t;n++){const u=o[v++],a=o[v++],l=o[v++];let r;l>0&&(r=o.subarray(v,v+l),v+=l),i[n]={start:u,deleteCount:a,data:r}}return{id:p,type:"delta",deltas:i}}e.$y$=A}),define(Ae[145],Re([9,10]),function(ve,e){return ve.create("vs/editor/common/config/editorOptions",e)}),define(Ae[146],Re([1,0,18,26,21,128,147,145]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=g;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class S{constructor(Y,Ee,Be,Ne){this.id=Y,this.name=Ee,this.defaultValue=Be,this.schema=Ne}applyUpdate(Y,Ee){return v(Y,Ee)}compute(Y,Ee,Be){return Be}}class o{constructor(Y,Ee){this.newValue=Y,this.didChange=Ee}}e.ApplyUpdateResult=o;function v(Z,Y){if(typeof Z!="object"||typeof Y!="object"||!Z||!Y)return new o(Y,Z!==Y);if(Array.isArray(Z)||Array.isArray(Y)){const Be=Array.isArray(Z)&&Array.isArray(Y)&&E.$tb(Z,Y);return new o(Y,!Be)}let Ee=!1;for(const Be in Y)if(Y.hasOwnProperty(Be)){const Ne=v(Z[Be],Y[Be]);Ne.didChange&&(Z[Be]=Ne.newValue,Ee=!0)}return new o(Z,Ee)}class p{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,Ee){return v(Y,Ee)}validate(Y){return this.defaultValue}}class f{constructor(Y,Ee,Be,Ne){this.id=Y,this.name=Ee,this.defaultValue=Be,this.schema=Ne}applyUpdate(Y,Ee){return v(Y,Ee)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,Ee,Be){return Be}}function t(Z,Y){return typeof Z>"u"?Y:Z==="false"?!1:!!Z}e.boolean=t;class i extends f{constructor(Y,Ee,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Be),super(Y,Ee,Be,Ne)}validate(Y){return t(Y,this.defaultValue)}}function n(Z,Y,Ee,Be){if(typeof Z>"u")return Y;let Ne=parseInt(Z,10);return isNaN(Ne)?Y:(Ne=Math.max(Ee,Ne),Ne=Math.min(Be,Ne),Ne|0)}e.clampedInt=n;class u extends f{static clampedInt(Y,Ee,Be,Ne){return n(Y,Ee,Be,Ne)}constructor(Y,Ee,Be,Ne,Ye,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Be,nt.minimum=Ne,nt.maximum=Ye),super(Y,Ee,Be,nt),this.minimum=Ne,this.maximum=Ye}validate(Y){return u.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}function a(Z,Y,Ee,Be){if(typeof Z>"u")return Y;const Ne=l.float(Z,Y);return l.clamp(Ne,Ee,Be)}e.clampedFloat=a;class l extends f{static clamp(Y,Ee,Be){return Y<Ee?Ee:Y>Be?Be:Y}static float(Y,Ee){if(typeof Y=="number")return Y;if(typeof Y>"u")return Ee;const Be=parseFloat(Y);return isNaN(Be)?Ee:Be}constructor(Y,Ee,Be,Ne,Ye){typeof Ye<"u"&&(Ye.type="number",Ye.default=Be),super(Y,Ee,Be,Ye),this.validationFn=Ne}validate(Y){return this.validationFn(l.float(Y,this.defaultValue))}}class r extends f{static string(Y,Ee){return typeof Y!="string"?Ee:Y}constructor(Y,Ee,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Be),super(Y,Ee,Be,Ne)}validate(Y){return r.string(Y,this.defaultValue)}}function s(Z,Y,Ee,Be){return typeof Z!="string"?Y:Be&&Z in Be?Be[Z]:Ee.indexOf(Z)===-1?Y:Z}e.stringSet=s;class c extends f{constructor(Y,Ee,Be,Ne,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.enum=Ne,Ye.default=Be),super(Y,Ee,Be,Ye),this.c=Ne}validate(Y){return s(Y,this.defaultValue,this.c)}}class h extends S{constructor(Y,Ee,Be,Ne,Ye,nt,$t=void 0){typeof $t<"u"&&($t.type="string",$t.enum=Ye,$t.default=Ne),super(Y,Ee,Be,$t),this.c=Ye,this.d=nt}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function w(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,Ee,Be){return Be===0?Y.accessibilitySupport:Be}}class I extends S{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:$.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{insertSpace:t(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function d(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var b;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(b||(e.TextEditorCursorStyle=b={}));function y(Z){switch(Z){case b.Line:return"line";case b.Block:return"block";case b.Underline:return"underline";case b.LineThin:return"line-thin";case b.BlockOutline:return"block-outline";case b.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function C(Z){switch(Z){case"line":return b.Line;case"block":return b.Block;case"underline":return b.Underline;case"line-thin":return b.LineThin;case"block-outline":return b.BlockOutline;case"underline-thin":return b.UnderlineThin}}class B extends p{constructor(){super(141)}compute(Y,Ee,Be){const Ne=["monaco-editor"];return Ee.get(39)&&Ne.push(Ee.get(39)),Y.extraEditorClassName&&Ne.push(Y.extraEditorClassName),Ee.get(73)==="default"?Ne.push("mouse-default"):Ee.get(73)==="copy"&&Ne.push("mouse-copy"),Ee.get(111)&&Ne.push("showUnused"),Ee.get(139)&&Ne.push("showDeprecated"),Ne.join(" ")}}class H extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(Y,Ee,Be){return Be&&Y.emptySelectionClipboard}}class U extends S{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:$.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:$.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{cursorMoveOnType:t(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":s(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":s(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(Ee.loop,this.defaultValue.loop)}}}class z extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?z.OFF:Y==="true"?z.ON:Y:Y?z.ON:z.OFF}}e.EditorFontLigatures=z;class F extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",F.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?F.OFF:Y==="true"?F.TRANSLATE:Y:Y?F.TRANSLATE:F.OFF}compute(Y,Ee,Be){return Y.fontInfo.fontVariationSettings}}e.EditorFontVariations=F;class N extends p{constructor(){super(50)}compute(Y,Ee,Be){return Y.fontInfo}}class X extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(Y){const Ee=l.float(Y,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(Ee,6,100)}compute(Y,Ee,Be){return Y.fontInfo.fontSize}}class Q extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Q.d,maximum:Q.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Q.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(u.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,Q.d,Q.e))}}class De extends S{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...Ee},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Be,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Be,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Be,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Be,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Be,description:$.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{multiple:s(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??s(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??s(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??s(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??s(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??s(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ke extends S{constructor(){const Y={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Y.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:$.localize(46,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{enabled:t(Ee.enabled,this.defaultValue.enabled),delay:u.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:t(Ee.sticky,this.defaultValue.sticky),hidingDelay:u.clampedInt(Ee.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(Ee.above,this.defaultValue.above)}}}var Pe;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class fe extends p{constructor(){super(144)}compute(Y,Ee,Be){return fe.computeLayout(Ee,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Y){const Ee=Y.height/Y.lineHeight,Be=Math.floor(Y.paddingTop/Y.lineHeight);let Ne=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(Ne=Math.max(Ne,Ee-1));const Ye=(Be+Y.viewLineCount+Ne)/(Y.pixelRatio*Y.height),nt=Math.floor(Y.viewLineCount/Ye);return{typicalViewportLineCount:Ee,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Ne,desiredRatio:Ye,minimapLineCount:nt}}static c(Y,Ee){const Be=Y.outerWidth,Ne=Y.outerHeight,Ye=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const nt=Ee.stableMinimapLayoutInput,$t=nt&&Y.outerHeight===nt.outerHeight&&Y.lineHeight===nt.lineHeight&&Y.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&Y.pixelRatio===nt.pixelRatio&&Y.scrollBeyondLastLine===nt.scrollBeyondLastLine&&Y.paddingTop===nt.paddingTop&&Y.paddingBottom===nt.paddingBottom&&Y.minimap.enabled===nt.minimap.enabled&&Y.minimap.side===nt.minimap.side&&Y.minimap.size===nt.minimap.size&&Y.minimap.showSlider===nt.minimap.showSlider&&Y.minimap.renderCharacters===nt.minimap.renderCharacters&&Y.minimap.maxColumn===nt.minimap.maxColumn&&Y.minimap.scale===nt.minimap.scale&&Y.verticalScrollbarWidth===nt.verticalScrollbarWidth&&Y.isViewportWrapping===nt.isViewportWrapping,wt=Y.lineHeight,Pt=Y.typicalHalfwidthCharacterWidth,Kt=Y.scrollBeyondLastLine,Ht=Y.minimap.renderCharacters;let vt=Ye>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Ut=Y.minimap.maxColumn,Ot=Y.minimap.size,Gt=Y.minimap.side,jt=Y.verticalScrollbarWidth,kt=Y.viewLineCount,Ft=Y.remainingWidth,Bt=Y.isViewportWrapping,Jt=Ht?2:3;let Wt=Math.floor(Ye*Ne);const Vt=Wt/Ye;let Nt=!1,at=!1,dt=Jt*vt,At=vt/Ye,qt=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:Ie,extraLinesBeyondLastLine:Le,desiredRatio:$e,minimapLineCount:K}=fe.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:Kt,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:Ne,lineHeight:wt,pixelRatio:Ye});if(kt/K>1)Nt=!0,at=!0,vt=1,dt=1,At=vt/Ye;else{let Ue=!1,Je=vt+1;if(Ot==="fit"){const qe=Math.ceil((Ie+kt+Le)*dt);Bt&&$t&&Ft<=Ee.stableFitRemainingWidth?(Ue=!0,Je=Ee.stableFitMaxMinimapScale):Ue=qe>Wt}if(Ot==="fill"||Ue){Nt=!0;const qe=vt;dt=Math.min(wt*Ye,Math.max(1,Math.floor(1/$e))),Bt&&$t&&Ft<=Ee.stableFitRemainingWidth&&(Je=Ee.stableFitMaxMinimapScale),vt=Math.min(Je,Math.max(1,Math.floor(dt/Jt))),vt>qe&&(qt=Math.min(2,vt/qe)),At=vt/Ye/qt,Wt=Math.ceil(Math.max(Qt,Ie+kt+Le)*dt),Bt?(Ee.stableMinimapLayoutInput=Y,Ee.stableFitRemainingWidth=Ft,Ee.stableFitMaxMinimapScale=vt):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const Rt=Math.floor(Ut*At),ot=Math.min(Rt,Math.max(0,Math.floor((Ft-jt-2)*At/(Pt+At)))+e.MINIMAP_GUTTER_WIDTH);let bt=Math.floor(Ye*ot);const Tt=bt/Ye;bt=Math.floor(bt*qt);const Ct=Ht?1:2,We=Gt==="left"?0:Be-ot-jt;return{renderMinimap:Ct,minimapLeft:We,minimapWidth:ot,minimapHeightIsEditorHeight:Nt,minimapIsSampling:at,minimapScale:vt,minimapLineHeight:dt,minimapCanvasInnerWidth:bt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Tt,minimapCanvasOuterHeight:Vt}}static computeLayout(Y,Ee){const Be=Ee.outerWidth|0,Ne=Ee.outerHeight|0,Ye=Ee.lineHeight|0,nt=Ee.lineNumbersDigitCount|0,$t=Ee.typicalHalfwidthCharacterWidth,wt=Ee.maxDigitWidth,Pt=Ee.pixelRatio,Kt=Ee.viewLineCount,Ht=Y.get(136),vt=Ht==="inherit"?Y.get(135):Ht,Ut=vt==="inherit"?Y.get(131):vt,Ot=Y.get(134),Gt=Ee.isDominatedByLongLines,jt=Y.get(57),kt=Y.get(67).renderType!==0,Ft=Y.get(68),Bt=Y.get(105),Jt=Y.get(84),Wt=Y.get(72),Vt=Y.get(103),Nt=Vt.verticalScrollbarSize,at=Vt.verticalHasArrows,dt=Vt.arrowSize,At=Vt.horizontalScrollbarSize,qt=Y.get(43),Rt=Y.get(110)!=="never";let ot=Y.get(65);qt&&Rt&&(ot+=16);let bt=0;if(kt){const Et=Math.max(nt,Ft);bt=Math.round(Et*wt)}let Tt=0;jt&&(Tt=Ye*Ee.glyphMarginDecorationLaneCount);let Ct=0,We=Ct+Tt,Qt=We+bt,Ie=Qt+ot;const Le=Be-Tt-bt-ot;let $e=!1,K=!1,Me=-1;vt==="inherit"&&Gt?($e=!0,K=!0):Ut==="on"||Ut==="bounded"?K=!0:Ut==="wordWrapColumn"&&(Me=Ot);const Ue=fe.c({outerWidth:Be,outerHeight:Ne,lineHeight:Ye,typicalHalfwidthCharacterWidth:$t,pixelRatio:Pt,scrollBeyondLastLine:Bt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Wt,verticalScrollbarWidth:Nt,viewLineCount:Kt,remainingWidth:Le,isViewportWrapping:K},Ee.memory||new A);Ue.renderMinimap!==0&&Ue.minimapLeft===0&&(Ct+=Ue.minimapWidth,We+=Ue.minimapWidth,Qt+=Ue.minimapWidth,Ie+=Ue.minimapWidth);const Je=Le-Ue.minimapWidth,qe=Math.max(1,Math.floor((Je-Nt-2)/$t)),et=at?dt:0;return K&&(Me=Math.max(1,qe),Ut==="bounded"&&(Me=Math.min(Me,Ot))),{width:Be,height:Ne,glyphMarginLeft:Ct,glyphMarginWidth:Tt,glyphMarginDecorationLaneCount:Ee.glyphMarginDecorationLaneCount,lineNumbersLeft:We,lineNumbersWidth:bt,decorationsLeft:Qt,decorationsWidth:ot,contentLeft:Ie,contentWidth:Je,minimap:Ue,viewportColumn:qe,isWordWrapMinified:$e,isViewportWrapping:K,wrappingColumn:Me,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:At,overviewRuler:{top:et,width:Nt,height:Ne-2*et,right:0}}}}e.EditorLayoutInfoComputer=fe;class we extends S{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(Y){return s(Y,"simple",["simple","advanced"])}compute(Y,Ee,Be){return Ee.get(2)===2?"advanced":Be}}class ne extends S{constructor(){const Y={enabled:!0};super(64,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:$.localize(50,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:t(Y.enabled,this.defaultValue.enabled)}}}class re extends S{constructor(){const Y={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Y.scrollWithEditor,description:$.localize(54,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{enabled:t(Ee.enabled,this.defaultValue.enabled),maxLineCount:u.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(Ee.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(Ee.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class pe extends S{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:$.localize(62,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:s(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:u.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:t(Ee.padding,this.defaultValue.padding)}}}class _ extends S{constructor(){super(65,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):u.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,Ee,Be){return Be<0?u.clampedInt(-Be*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class W extends l{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>l.clamp(Y,0,150),{markdownDescription:$.localize(63,null)})}compute(Y,Ee,Be){return Y.fontInfo.lineHeight}}class ce extends S{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:Y.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:$.localize(74,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{enabled:t(Ee.enabled,this.defaultValue.enabled),autohide:t(Ee.autohide,this.defaultValue.autohide),size:s(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(Ee.side,this.defaultValue.side,["right","left"]),showSlider:s(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(Ee.scale,1,1,3),maxColumn:u.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function be(Z){return Z==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class se extends S{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{top:u.clampedInt(Ee.top,0,0,1e3),bottom:u.clampedInt(Ee.bottom,0,0,1e3)}}}class he extends S{constructor(){const Y={enabled:!0,cycle:!0};super(86,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:$.localize(78,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{enabled:t(Ee.enabled,this.defaultValue.enabled),cycle:t(Ee.cycle,this.defaultValue.cycle)}}}class ue extends p{constructor(){super(142)}compute(Y,Ee,Be){return Y.pixelRatio}}class ye extends S{constructor(){const Y={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(89,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:Y.strings,description:$.localize(82,null)},comments:{anyOf:Ee,default:Y.comments,description:$.localize(83,null)},other:{anyOf:Ee,default:Y.other,description:$.localize(84,null)}},default:Y,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const Pt=Y?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:Ee,comments:Be,strings:Ne}=Y,Ye=["on","inline","off"];let nt,$t,wt;return typeof Ee=="boolean"?nt=Ee?"on":"off":nt=s(Ee,this.defaultValue.other,Ye),typeof Be=="boolean"?$t=Be?"on":"off":$t=s(Be,this.defaultValue.comments,Ye),typeof Ne=="boolean"?wt=Ne?"on":"off":wt=s(Ne,this.defaultValue.strings,Ye),{other:nt,comments:$t,strings:wt}}}var ee;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class de extends S{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(Y){let Ee=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(Ee=4,Be=Y):Y==="interval"?Ee=3:Y==="relative"?Ee=2:Y==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Be}}}function ie(Z){const Y=Z.get(98);return Y==="editable"?Z.get(91):Y!=="on"}e.filterValidationDecorations=ie;class ae extends S{constructor(){const Y=[],Ee={type:"number",description:$.localize(91,null)};super(102,"rulers",Y,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:Y,description:$.localize(93,null)})}validate(Y){if(Array.isArray(Y)){const Ee=[];for(const Be of Y)if(typeof Be=="number")Ee.push({column:u.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Ne=Be;Ee.push({column:u.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return Ee.sort((Be,Ne)=>Be.column-Ne.column),Ee}return this.defaultValue}}class me extends S{constructor(){super(92,"readOnlyMessage",void 0)}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:Y}}function Ce(Z,Y){if(typeof Z!="string")return Y;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class T extends S{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:$.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Y.ignoreHorizontalScrollbarInContentHeight,description:$.localize(105,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y,Be=u.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=u.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(Ee.vertical,this.defaultValue.vertical),horizontal:Ce(Ee.horizontal,this.defaultValue.horizontal),useShadows:t(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:u.clampedInt(Ee.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:u.clampedInt(Ee.verticalSliderSize,Ne,0,1e3),scrollByPage:t(Ee.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(Ee.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends S{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:$.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:$.localize(112,null)}})}applyUpdate(Y,Ee){let Be=!1;Ee.allowedCharacters&&Y&&(L.$bn(Y.allowedCharacters,Ee.allowedCharacters)||(Y={...Y,allowedCharacters:Ee.allowedCharacters},Be=!0)),Ee.allowedLocales&&Y&&(L.$bn(Y.allowedLocales,Ee.allowedLocales)||(Y={...Y,allowedLocales:Ee.allowedLocales},Be=!0));const Ne=super.applyUpdate(Y,Ee);return Be?new o(Ne.newValue,!0):Ne}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{nonBasicASCII:x(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,Ee){if(typeof Y!="object"||!Y)return Ee;const Be={};for(const[Ne,Ye]of Object.entries(Y))Ye===!0&&(Be[Ne]=!0);return Be}}class G extends S{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:$.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover"],enumDescriptions:[$.localize(114,null),$.localize(115,null)],description:$.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:$.localize(117,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{enabled:t(Ee.enabled,this.defaultValue.enabled),mode:s(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(Ee.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(Ee.keepOnBlur,this.defaultValue.keepOnBlur)}}}class J extends S{constructor(){const Y={enabled:M.$6r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$6r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:$.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:$.localize(119,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{enabled:t(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends S{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(120,null),$.localize(121,null),$.localize(122,null)],default:Y.bracketPairs,description:$.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(124,null),$.localize(125,null),$.localize(126,null)],default:Y.bracketPairsHorizontal,description:$.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:$.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:$.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(130,null),$.localize(131,null),$.localize(132,null)],default:Y.highlightActiveIndentation,description:$.localize(133,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{bracketPairs:x(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(Z,Y,Ee){const Be=Ee.indexOf(Z);return Be===-1?Y:Ee[Be]}class le extends S{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(134,null),$.localize(135,null)],default:Y.insertMode,description:$.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:$.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:$.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:$.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(140,null),$.localize(141,null),$.localize(142,null),$.localize(143,null)],default:Y.selectionMode,markdownDescription:$.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:$.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:$.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:$.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:$.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:$.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{insertMode:s(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(Ee.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:t(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:t(Ee.preview,this.defaultValue.preview),previewMode:s(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(Ee.showMethods,this.defaultValue.showMethods),showFunctions:t(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:t(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(Ee.showFields,this.defaultValue.showFields),showVariables:t(Ee.showVariables,this.defaultValue.showVariables),showClasses:t(Ee.showClasses,this.defaultValue.showClasses),showStructs:t(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:t(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:t(Ee.showModules,this.defaultValue.showModules),showProperties:t(Ee.showProperties,this.defaultValue.showProperties),showEvents:t(Ee.showEvents,this.defaultValue.showEvents),showOperators:t(Ee.showOperators,this.defaultValue.showOperators),showUnits:t(Ee.showUnits,this.defaultValue.showUnits),showValues:t(Ee.showValues,this.defaultValue.showValues),showConstants:t(Ee.showConstants,this.defaultValue.showConstants),showEnums:t(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:t(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(Ee.showKeywords,this.defaultValue.showKeywords),showWords:t(Ee.showWords,this.defaultValue.showWords),showColors:t(Ee.showColors,this.defaultValue.showColors),showFiles:t(Ee.showFiles,this.defaultValue.showFiles),showReferences:t(Ee.showReferences,this.defaultValue.showReferences),showFolders:t(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:t(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:t(Ee.showUsers,this.defaultValue.showUsers),showIssues:t(Ee.showIssues,this.defaultValue.showIssues)}}}class Oe extends S{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(183,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Y.selectSubwords,this.defaultValue.selectSubwords)}}}var je;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(je||(e.WrappingIndent=je={}));class Qe extends S{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(184,null),$.localize(185,null),$.localize(186,null),$.localize(187,null)],description:$.localize(188,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,Ee,Be){return Ee.get(2)===2?0:Be}}class Ge extends p{constructor(){super(145)}compute(Y,Ee,Be){const Ne=Ee.get(144);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class _e extends S{constructor(){const Y={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:$.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(191,null),$.localize(192,null)],default:"afterDrop"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showDropSelector:s(Ee.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Xe extends S{constructor(){const Y={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Y,{"editor.pasteAs.enabled":{type:"boolean",default:Y.enabled,markdownDescription:$.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(195,null),$.localize(196,null)],default:"afterPaste"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ee=Y;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showPasteSelector:s(Ee.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const xe="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?it:P.$k?tt:xe,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var ut;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.letterSpacing=63]="letterSpacing",Z[Z.lightbulb=64]="lightbulb",Z[Z.lineDecorationsWidth=65]="lineDecorationsWidth",Z[Z.lineHeight=66]="lineHeight",Z[Z.lineNumbers=67]="lineNumbers",Z[Z.lineNumbersMinChars=68]="lineNumbersMinChars",Z[Z.linkedEditing=69]="linkedEditing",Z[Z.links=70]="links",Z[Z.matchBrackets=71]="matchBrackets",Z[Z.minimap=72]="minimap",Z[Z.mouseStyle=73]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=75]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=77]="multiCursorModifier",Z[Z.multiCursorPaste=78]="multiCursorPaste",Z[Z.multiCursorLimit=79]="multiCursorLimit",Z[Z.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=89]="quickSuggestions",Z[Z.quickSuggestionsDelay=90]="quickSuggestionsDelay",Z[Z.readOnly=91]="readOnly",Z[Z.readOnlyMessage=92]="readOnlyMessage",Z[Z.renameOnType=93]="renameOnType",Z[Z.renderControlCharacters=94]="renderControlCharacters",Z[Z.renderFinalNewline=95]="renderFinalNewline",Z[Z.renderLineHighlight=96]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=98]="renderValidationDecorations",Z[Z.renderWhitespace=99]="renderWhitespace",Z[Z.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Z[Z.roundedSelection=101]="roundedSelection",Z[Z.rulers=102]="rulers",Z[Z.scrollbar=103]="scrollbar",Z[Z.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=105]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=106]="scrollPredominantAxis",Z[Z.selectionClipboard=107]="selectionClipboard",Z[Z.selectionHighlight=108]="selectionHighlight",Z[Z.selectOnLineNumbers=109]="selectOnLineNumbers",Z[Z.showFoldingControls=110]="showFoldingControls",Z[Z.showUnused=111]="showUnused",Z[Z.snippetSuggestions=112]="snippetSuggestions",Z[Z.smartSelect=113]="smartSelect",Z[Z.smoothScrolling=114]="smoothScrolling",Z[Z.stickyScroll=115]="stickyScroll",Z[Z.stickyTabStops=116]="stickyTabStops",Z[Z.stopRenderingLineAfter=117]="stopRenderingLineAfter",Z[Z.suggest=118]="suggest",Z[Z.suggestFontSize=119]="suggestFontSize",Z[Z.suggestLineHeight=120]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Z[Z.suggestSelection=122]="suggestSelection",Z[Z.tabCompletion=123]="tabCompletion",Z[Z.tabIndex=124]="tabIndex",Z[Z.unicodeHighlighting=125]="unicodeHighlighting",Z[Z.unusualLineTerminators=126]="unusualLineTerminators",Z[Z.useShadowDOM=127]="useShadowDOM",Z[Z.useTabStops=128]="useTabStops",Z[Z.wordBreak=129]="wordBreak",Z[Z.wordSeparators=130]="wordSeparators",Z[Z.wordWrap=131]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=134]="wordWrapColumn",Z[Z.wordWrapOverride1=135]="wordWrapOverride1",Z[Z.wordWrapOverride2=136]="wordWrapOverride2",Z[Z.wrappingIndent=137]="wrappingIndent",Z[Z.wrappingStrategy=138]="wrappingStrategy",Z[Z.showDeprecated=139]="showDeprecated",Z[Z.inlayHints=140]="inlayHints",Z[Z.editorClassName=141]="editorClassName",Z[Z.pixelRatio=142]="pixelRatio",Z[Z.tabFocusMode=143]="tabFocusMode",Z[Z.layoutInfo=144]="layoutInfo",Z[Z.wrappingInfo=145]="wrappingInfo",Z[Z.defaultColorDecorators=146]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(ut||(e.EditorOption=ut={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(197,null)})),acceptSuggestionOnEnter:ze(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(198,null),""],markdownDescription:$.localize(199,null)})),accessibilitySupport:ze(new m),accessibilityPageSize:ze(new u(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(200,null),tags:["accessibility"]})),ariaLabel:ze(new r(4,"ariaLabel",$.localize(201,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:ze(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(203,null),$.localize(204,null),""],description:$.localize(205,null)})),autoClosingComments:ze(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(206,null),$.localize(207,null),""],description:$.localize(208,null)})),autoClosingDelete:ze(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(209,null),""],description:$.localize(210,null)})),autoClosingOvertype:ze(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(211,null),""],description:$.localize(212,null)})),autoClosingQuotes:ze(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(213,null),$.localize(214,null),""],description:$.localize(215,null)})),autoIndent:ze(new h(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[$.localize(216,null),$.localize(217,null),$.localize(218,null),$.localize(219,null),$.localize(220,null)],description:$.localize(221,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(222,null),$.localize(223,null),$.localize(224,null),""],description:$.localize(225,null)})),bracketPairColorization:ze(new J),bracketPairGuides:ze(new q),stickyTabStops:ze(new i(116,"stickyTabStops",!1,{description:$.localize(226,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:$.localize(227,null)})),codeLensFontFamily:ze(new r(18,"codeLensFontFamily","",{description:$.localize(228,null)})),codeLensFontSize:ze(new u(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(229,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:$.localize(230,null)})),colorDecoratorActivatedOn:ze(new c(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(231,null),$.localize(232,null),$.localize(233,null)],description:$.localize(234,null)})),colorDecoratorsLimit:ze(new u(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(235,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:$.localize(236,null)})),comments:ze(new I),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(237,null)})),cursorBlinking:ze(new h(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:$.localize(238,null)})),cursorSmoothCaretAnimation:ze(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(239,null),$.localize(240,null),$.localize(241,null)],description:$.localize(242,null)})),cursorStyle:ze(new h(28,"cursorStyle",b.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:$.localize(243,null)})),cursorSurroundingLines:ze(new u(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(244,null)})),cursorSurroundingLinesStyle:ze(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(245,null),$.localize(246,null)],markdownDescription:$.localize(247,null)})),cursorWidth:ze(new u(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(248,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:$.localize(249,null)})),emptySelectionClipboard:ze(new H),dropIntoEditor:ze(new _e),stickyScroll:ze(new re),experimentalWhitespaceRendering:ze(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(250,null),$.localize(251,null),$.localize(252,null)],description:$.localize(253,null)})),extraEditorClassName:ze(new r(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new l(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:$.localize(254,null)})),find:ze(new U),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:$.localize(255,null)})),foldingStrategy:ze(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(256,null),$.localize(257,null)],description:$.localize(258,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:$.localize(259,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:$.localize(260,null)})),foldingMaximumRegions:ze(new u(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(261,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(262,null)})),fontFamily:ze(new r(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(263,null)})),fontInfo:ze(new N),fontLigatures2:ze(new z),fontSize:ze(new X),fontWeight:ze(new Q),fontVariations:ze(new F),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:$.localize(264,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:$.localize(265,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:$.localize(266,null)})),gotoLocation:ze(new De),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:$.localize(267,null)})),hover:ze(new ke),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new l(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>l.clamp(Z,-5,20),{description:$.localize(268,null)})),lightbulb:ze(new ne),lineDecorationsWidth:ze(new _),lineHeight:ze(new W),lineNumbers:ze(new de),lineNumbersMinChars:ze(new u(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:$.localize(269,null)})),links:ze(new i(70,"links",!0,{description:$.localize(270,null)})),matchBrackets:ze(new c(71,"matchBrackets","always",["always","near","never"],{description:$.localize(271,null)})),minimap:ze(new ce),mouseStyle:ze(new c(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new l(74,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:$.localize(272,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(273,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:$.localize(274,null)})),multiCursorModifier:ze(new h(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],be,{markdownEnumDescriptions:[$.localize(275,null),$.localize(276,null)],markdownDescription:$.localize(277,null)})),multiCursorPaste:ze(new c(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(278,null),$.localize(279,null)],markdownDescription:$.localize(280,null)})),multiCursorLimit:ze(new u(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(281,null)})),occurrencesHighlight:ze(new i(81,"occurrencesHighlight",!0,{description:$.localize(282,null)})),multiDocumentOccurrencesHighlight:ze(new i(80,"multiDocumentOccurrencesHighlight",!1,{description:$.localize(283,null)})),overviewRulerBorder:ze(new i(82,"overviewRulerBorder",!0,{description:$.localize(284,null)})),overviewRulerLanes:ze(new u(83,"overviewRulerLanes",3,0,3)),padding:ze(new se),pasteAs:ze(new Xe),parameterHints:ze(new he),peekWidgetDefaultFocus:ze(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(285,null),$.localize(286,null)],description:$.localize(287,null)})),definitionLinkOpensInPeek:ze(new i(88,"definitionLinkOpensInPeek",!1,{description:$.localize(288,null)})),quickSuggestions:ze(new ye),quickSuggestionsDelay:ze(new u(90,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(289,null)})),readOnly:ze(new i(91,"readOnly",!1)),readOnlyMessage:ze(new me),renameOnType:ze(new i(93,"renameOnType",!1,{description:$.localize(290,null),markdownDeprecationMessage:$.localize(291,null)})),renderControlCharacters:ze(new i(94,"renderControlCharacters",!0,{description:$.localize(292,null),restricted:!0})),renderFinalNewline:ze(new c(95,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(293,null)})),renderLineHighlight:ze(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(294,null)],description:$.localize(295,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(97,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(296,null)})),renderValidationDecorations:ze(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(297,null),$.localize(298,null),$.localize(299,null),""],description:$.localize(300,null)})),revealHorizontalRightPadding:ze(new u(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(101,"roundedSelection",!0,{description:$.localize(301,null)})),rulers:ze(new ae),scrollbar:ze(new T),scrollBeyondLastColumn:ze(new u(104,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(302,null)})),scrollBeyondLastLine:ze(new i(105,"scrollBeyondLastLine",!0,{description:$.localize(303,null)})),scrollPredominantAxis:ze(new i(106,"scrollPredominantAxis",!0,{description:$.localize(304,null)})),selectionClipboard:ze(new i(107,"selectionClipboard",!0,{description:$.localize(305,null),included:P.$k})),selectionHighlight:ze(new i(108,"selectionHighlight",!0,{description:$.localize(306,null)})),selectOnLineNumbers:ze(new i(109,"selectOnLineNumbers",!0)),showFoldingControls:ze(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(307,null),$.localize(308,null),$.localize(309,null)],description:$.localize(310,null)})),showUnused:ze(new i(111,"showUnused",!0,{description:$.localize(311,null)})),showDeprecated:ze(new i(139,"showDeprecated",!0,{description:$.localize(312,null)})),inlayHints:ze(new pe),snippetSuggestions:ze(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(313,null),$.localize(314,null),$.localize(315,null),$.localize(316,null)],description:$.localize(317,null)})),smartSelect:ze(new Oe),smoothScrolling:ze(new i(114,"smoothScrolling",!1,{description:$.localize(318,null)})),stopRenderingLineAfter:ze(new u(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new le),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new i(148,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(319,null)})),suggestFontSize:ze(new u(119,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(320,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new u(120,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(321,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(121,"suggestOnTriggerCharacters",!0,{description:$.localize(322,null)})),suggestSelection:ze(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(323,null),$.localize(324,null),$.localize(325,null)],description:$.localize(326,null)})),tabCompletion:ze(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(327,null),$.localize(328,null),$.localize(329,null)],description:$.localize(330,null)})),tabIndex:ze(new u(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new V),unusualLineTerminators:ze(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(331,null),$.localize(332,null),$.localize(333,null)],description:$.localize(334,null)})),useShadowDOM:ze(new i(127,"useShadowDOM",!0)),useTabStops:ze(new i(128,"useTabStops",!0,{description:$.localize(335,null)})),wordBreak:ze(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(336,null),$.localize(337,null)],description:$.localize(338,null)})),wordSeparators:ze(new r(130,"wordSeparators",R.$7r,{description:$.localize(339,null)})),wordWrap:ze(new c(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(340,null),$.localize(341,null),$.localize(342,null),$.localize(343,null)],description:$.localize(344,null)})),wordWrapBreakAfterCharacters:ze(new r(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new r(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new u(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(345,null)})),wordWrapOverride1:ze(new c(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new c(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new B),defaultColorDecorators:ze(new i(146,"defaultColorDecorators",!1,{markdownDescription:$.localize(346,null)})),pixelRatio:ze(new ue),tabFocusMode:ze(new i(143,"tabFocusMode",!1,{markdownDescription:$.localize(347,null)})),layoutInfo:ze(new fe),wrappingInfo:ze(new Ge),wrappingIndent:ze(new Qe),wrappingStrategy:ze(new we)}}),define(Ae[148],Re([9,10]),function(ve,e){return ve.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[149],Re([9,10]),function(ve,e){return ve.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[150],Re([9,10]),function(ve,e){return ve.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[151],Re([9,10]),function(ve,e){return ve.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[152],Re([9,10]),function(ve,e){return ve.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[153],Re([9,10]),function(ve,e){return ve.create("vs/platform/files/common/files",e)}),define(Ae[154],Re([9,10]),function(ve,e){return ve.create("vs/platform/markers/common/markers",e)}),define(Ae[155],Re([9,10]),function(ve,e){return ve.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[156],Re([9,10]),function(ve,e){return ve.create("vs/platform/workspace/common/workspace",e)}),define(Ae[157],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[158],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ae[159],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[160],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[161],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[162],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[163],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[164],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[165],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[166],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[167],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[168],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[169],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[170],Re([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[171],Re([9,10]),function(ve,e){return ve.create("vs/workbench/common/configuration",e)}),define(Ae[172],Re([9,10]),function(ve,e){return ve.create("vs/workbench/common/editor",e)}),define(Ae[173],Re([9,10]),function(ve,e){return ve.create("vs/workbench/common/views",e)}),define(Ae[174],Re([9,10]),function(ve,e){return ve.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[175],Re([9,10]),function(ve,e){return ve.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[176],Re([9,10]),function(ve,e){return ve.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[177],Re([9,10]),function(ve,e){return ve.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[178],Re([9,10]),function(ve,e){return ve.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[179],Re([9,10]),function(ve,e){return ve.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ae[180],Re([9,10]),function(ve,e){return ve.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[181],Re([9,10]),function(ve,e){return ve.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[182],Re([1,0,11,150]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.TokenType=void 0;var P;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(P||(e.TokenType=P={}));function M(...g){switch(g.length){case 1:return(0,L.localize)(0,null,g[0]);case 2:return(0,L.localize)(1,null,g[0],g[1]);case 3:return(0,L.localize)(2,null,g[0],g[1],g[2]);default:return}}const R=(0,L.localize)(3,null),$=(0,L.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,E.$7)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const S=this.d,o=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:o};this.g.push({offset:S,lexeme:o,additionalInfo:A}),this.f.push(v)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const S=this.c.substring(this.d,this.e),o=D.b.get(S);o?this.k(o):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,S=!1,o=!1;for(;;){if(A>=this.c.length){this.e=A,this.l($);return}const p=this.c.charCodeAt(A);if(S)S=!1;else if(p===47&&!o){A++;break}else p===91?o=!0:p===92?S=!0:p===93&&(o=!1);A++}for(;A<this.c.length&&D.a.has(this.c.charCodeAt(A));)A++;this.e=A;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ni=D}),define(Ae[183],Re([1,0,25,31,152,296]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function D(i){return i=i.trim(),i==="*"||R.test(i)}e.$Oo=D;function g(i){if(!D(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=i.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$Po=g;function A(i){if(!i)return null;const n=i.majorBase,u=i.majorMustEqual,a=i.minorBase;let l=i.minorMustEqual;const r=i.patchBase;let s=i.patchMustEqual;i.hasCaret&&(n===0||(l=!1),s=!1);let c=0;if(i.preRelease){const h=$.exec(i.preRelease);if(h){const[,w,m,I]=h;c=Date.UTC(Number(w),Number(m)-1,Number(I))}}return{majorBase:n,majorMustEqual:u,minorBase:a,minorMustEqual:l,patchBase:r,patchMustEqual:s,isMinimum:i.hasGreaterEquals,notBefore:c}}e.$Qo=A;function S(i,n,u){let a;typeof i=="string"?a=A(g(i)):a=i;let l;n instanceof Date?l=n.getTime():typeof n=="string"&&(l=new Date(n).getTime());let r;if(typeof u=="string"?r=A(g(u)):r=u,!a||!r)return!1;const s=a.majorBase,c=a.minorBase,h=a.patchBase;let w=r.majorBase,m=r.minorBase,I=r.patchBase;const k=r.notBefore;let d=r.majorMustEqual,b=r.minorMustEqual,y=r.patchMustEqual;return r.isMinimum?s>w?!0:s<w?!1:c>m?!0:c<m||l&&l<k?!1:h>=I:(s===1&&w===0&&(!d||!b||!y)&&(w=1,m=0,I=0,d=!0,b=!1,y=!1),s<w?!1:s>w?!d:c<m?!1:c>m?!b:h<I?!1:h>I?!y:!(l&&l<k))}e.$Ro=S;function o(i,n,u,a,l){const r=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return r.push([L.default.Error,P.localize(0,null)]),r;if(typeof a.name!="string")return r.push([L.default.Error,P.localize(1,null,"name")]),r;if(typeof a.version!="string")return r.push([L.default.Error,P.localize(2,null,"version")]),r;if(!a.engines)return r.push([L.default.Error,P.localize(3,null,"engines")]),r;if(typeof a.engines.vscode!="string")return r.push([L.default.Error,P.localize(4,null,"engines.vscode")]),r;if(typeof a.extensionDependencies<"u"&&!t(a.extensionDependencies))return r.push([L.default.Error,P.localize(5,null,"extensionDependencies")]),r;if(typeof a.activationEvents<"u"){if(!t(a.activationEvents))return r.push([L.default.Error,P.localize(6,null,"activationEvents")]),r;if(typeof a.main>"u"&&typeof a.browser>"u")return r.push([L.default.Error,P.localize(7,null,"activationEvents","main","browser")]),r}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&r.push([L.default.Warning,P.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return r.push([L.default.Error,P.localize(9,null,"main")]),r;{const h=(0,E.$wg)(u,a.main);(0,E.$qg)(h,u)||r.push([L.default.Warning,P.localize(10,null,h.path,u.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return r.push([L.default.Error,P.localize(11,null,"browser")]),r;{const h=(0,E.$wg)(u,a.browser);(0,E.$qg)(h,u)||r.push([L.default.Warning,P.localize(12,null,h.path,u.path)])}}if(!M.valid(a.version))return r.push([L.default.Error,P.localize(13,null)]),r;const s=[];if(!v(i,n,a,l,s))for(const h of s)r.push([L.default.Error,h]);return r}e.$So=o;function v(i,n,u,a,l){return a||typeof u.main>"u"&&typeof u.browser>"u"?!0:f(i,n,u.engines.vscode,l)}e.$To=v;function p(i,n,u){return i==="*"||f(n,u,i)}e.$Uo=p;function f(i,n,u,a=[]){const l=A(g(u));if(!l)return a.push(P.localize(14,null,u)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return a.push(P.localize(15,null,u)),!1}else if(!l.majorMustEqual)return a.push(P.localize(16,null,u)),!1;return S(i,n,l)?!0:(a.push(P.localize(17,null,i,u)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let n=0,u=i.length;n<u;n++)if(typeof i[n]!="string")return!1;return!0}}),define(Ae[70],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=void 0;class E{constructor(P,M=[],R=!1){this.ctor=P,this.staticArguments=M,this.supportsDelayedInstantiation=R}}e.$Ph=E}),define(Ae[71],Re([1,0,70]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=e.InstantiationType=void 0;const L=[];var P;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function M($,D,g){D instanceof E.$Ph||(D=new E.$Ph(D,[],!!g)),L.push([$,D])}e.$zr=M;function R(){return L}e.$Ar=R}),define(Ae[184],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;class E{constructor(M,R){this.key=M,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$eq=E;class L{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const R of this.a.values())R.outgoing.size===0&&M.push(R);return M}insertEdge(M,R){const $=this.lookupOrInsertNode(M),D=this.lookupOrInsertNode(R);$.outgoing.set(D.key,D),D.incoming.set($.key,$)}removeNode(M){const R=this.b(M);this.a.delete(R);for(const $ of this.a.values())$.outgoing.delete(R),$.incoming.delete(R)}lookupOrInsertNode(M){const R=this.b(M);let $=this.a.get(R);return $||($=new E(R,M),this.a.set(R,$)),$}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[R,$]of this.a)M.push(`${R}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,R]of this.a){const $=new Set([M]),D=this.c(R,$);if(D)return D}}c(M,R){for(const[$,D]of M.outgoing){if(R.has($))return[...R,$].join(" -> ");R.add($);const g=this.c(D,R);if(g)return g;R.delete($)}}}e.$fq=L}),define(Ae[4],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function $(D){return D[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=$})(E||(e._util=E={})),e.$Rh=P("instantiationService");function L(R,$,D){$[E.DI_TARGET]===$?$[E.DI_DEPENDENCIES].push({id:R,index:D}):($[E.DI_DEPENDENCIES]=[{id:R,index:D}],$[E.DI_TARGET]=$)}function P(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const $=function(D,g,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L($,D,A)};return $.toString=()=>R,E.serviceIds.set(R,$),$}e.$Sh=P;function M(R){return R}e.$Th=M}),define(Ae[40],Re([1,0,16,2,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.ConfigurationTarget=e.$oi=e.$ni=e.$mi=void 0,e.$mi=(0,P.$Sh)("configurationService");function M(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof L.URI)}e.$ni=M;function R(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof L.URI)}e.$oi=R;var $;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function D(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$pi=D;function g(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$qi=g;function A(i,n){const u=Object.create(null);for(const a in i)S(u,a,i[a],n);return u}e.$ri=A;function S(i,n,u,a){const l=n.split("."),r=l.pop();let s=i;for(let c=0;c<l.length;c++){const h=l[c];let w=s[h];switch(typeof w){case"undefined":w=s[h]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${l.slice(0,c+1).join(".")} is ${JSON.stringify(w)}`);return}s=w}if(typeof s=="object"&&s!==null)try{s[r]=u}catch{a(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(s)}`)}else a(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(s)}`)}e.$si=S;function o(i,n){const u=n.split(".");v(i,u)}e.$ti=o;function v(i,n){const u=n.shift();if(n.length===0){delete i[u];return}if(Object.keys(i).indexOf(u)!==-1){const a=i[u];typeof a=="object"&&!Array.isArray(a)&&(v(a,n),Object.keys(a).length===0&&delete i[u])}}function p(i,n,u){function a(s,c){let h=s;for(const w of c){if(typeof h!="object"||h===null)return;h=h[w]}return h}const l=n.split("."),r=a(i,l);return typeof r>"u"?u:r}e.$ui=p;function f(i,n,u){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?E.$Bf(i[a])&&E.$Bf(n[a])?f(i[a],n[a],u):u&&(i[a]=n[a]):i[a]=n[a])})}e.$vi=f;function t(i){return i.replace(/[\[\]]/g,"")}e.$wi=t}),define(Ae[34],Re([1,0,21,13,182,4,149,11]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.ContextKeyExprType=e.$Oi=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",E.$j),D.set("isLinux",E.$k),D.set("isWindows",E.$i),D.set("isWeb",E.$o),D.set("isMacNative",E.$j&&!E.$o),D.set("isEdge",E.$H),D.set("isFirefox",E.$F),D.set("isChrome",E.$E),D.set("isSafari",E.$G);function g(_,W){if(D.get(_)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(_,W)}e.$Oi=g;const A=Object.prototype.hasOwnProperty;var S;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const o={regexParsingWithErrorRecovery:!0},v=(0,R.localize)(0,null),p=(0,R.localize)(1,null),f=(0,R.localize)(2,null),t=(0,R.localize)(3,null),i=(0,R.localize)(4,null),n=(0,R.localize)(5,null),u=(0,R.localize)(6,null),a=(0,R.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=o){this.k=W,this.d=new P.$Ni,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const ce=this.l();if(!this.E()){const be=this.D(),se=be.type===17?n:void 0;throw this.h.push({message:i,offset:be.offset,lexeme:P.$Ni.getLexeme(be),additionalInfo:se}),l.c}return ce}catch(ce){if(ce!==l.c)throw ce;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const ce=this.o();W.push(ce)}return W.length===1?W[0]:r.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const ce=this.s();W.push(ce)}return W.length===1?W[0]:r.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),m.INSTANCE;case 0:{this.z();const ce=this.l();return this.A(1,t),ce?.negate()}case 17:return this.z(),C.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),r.true();case 12:return this.z(),r.false();case 0:{this.z();const ce=this.l();return this.A(1,t),ce}case 17:{const ce=W.lexeme;if(this.z(),this.y(9)){const se=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),se.type!==10)throw this.B("REGEX",se);const he=se.lexeme,ue=he.lastIndexOf("/"),ye=ue===he.length-1?void 0:this.w(he.substring(ue+1));let ee;try{ee=new RegExp(he.substring(1,ue),ye)}catch{throw this.B("REGEX",se)}return N.create(ce,ee)}switch(se.type){case 10:case 19:{const he=[se.lexeme];this.z();let ue=this.D(),ye=0;for(let me=0;me<se.lexeme.length;me++)se.lexeme.charCodeAt(me)===40?ye++:se.lexeme.charCodeAt(me)===41&&ye--;for(;!this.E()&&ue.type!==15&&ue.type!==16;){switch(ue.type){case 0:ye++;break;case 1:ye--;break;case 10:case 18:for(let me=0;me<ue.lexeme.length;me++)ue.lexeme.charCodeAt(me)===40?ye++:se.lexeme.charCodeAt(me)===41&&ye--}if(ye<0)break;he.push(P.$Ni.getLexeme(ue)),this.z(),ue=this.D()}const ee=he.join(""),de=ee.lastIndexOf("/"),ie=de===ee.length-1?void 0:this.w(ee.substring(de+1));let ae;try{ae=new RegExp(ee.substring(1,de),ie)}catch{throw this.B("REGEX",se)}return r.regex(ce,ae)}case 18:{const he=se.lexeme;this.z();let ue=null;if(!(0,L.$Ce)(he)){const ye=he.indexOf("/"),ee=he.lastIndexOf("/");if(ye!==ee&&ye>=0){const de=he.slice(ye+1,ee),ie=he[ee+1]==="i"?"i":"";try{ue=new RegExp(de,ie)}catch{throw this.B("REGEX",se)}}}if(ue===null)throw this.B("REGEX",se);return N.create(ce,ue)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,f);const se=this.u();return r.notIn(ce,se)}switch(this.D().type){case 3:{this.z();const se=this.u();if(this.x().type===18)return r.equals(ce,se);switch(se){case"true":return r.has(ce);case"false":return r.not(ce);default:return r.equals(ce,se)}}case 4:{this.z();const se=this.u();if(this.x().type===18)return r.notEquals(ce,se);switch(se){case"true":return r.not(ce);case"false":return r.has(ce);default:return r.notEquals(ce,se)}}case 5:return this.z(),z.create(ce,this.u());case 6:return this.z(),F.create(ce,this.u());case 7:return this.z(),H.create(ce,this.u());case 8:return this.z(),U.create(ce,this.u());case 13:return this.z(),r.in(ce,this.u());default:return r.has(ce)}}case 20:throw this.h.push({message:u,offset:W.offset,lexeme:"",additionalInfo:a}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,ce){if(this.C(W))return this.z();throw this.B(ce,this.D())}B(W,ce,be){const se=(0,R.localize)(8,null,W,P.$Ni.getLexeme(ce)),he=ce.offset,ue=P.$Ni.getLexeme(ce);return this.h.push({message:se,offset:he,lexeme:ue,additionalInfo:be}),l.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Pi=l;class r{static false(){return w.INSTANCE}static true(){return m.INSTANCE}static has(W){return I.create(W)}static equals(W,ce){return k.create(W,ce)}static notEquals(W,ce){return y.create(W,ce)}static regex(W,ce){return N.create(W,ce)}static in(W,ce){return d.create(W,ce)}static notIn(W,ce){return b.create(W,ce)}static not(W){return C.create(W)}static and(...W){return De.create(W,null,!0)}static or(...W){return ke.create(W,null,!0)}static greater(W,ce){return H.create(W,ce)}static greaterEquals(W,ce){return U.create(W,ce)}static smaller(W,ce){return z.create(W,ce)}static smallerEquals(W,ce){return F.create(W,ce)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$Qi=r;function s(_){const W=new l({regexParsingWithErrorRecovery:!1});return _.map(ce=>(W.parse(ce),W.lexingErrors.length>0?W.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,R.localize)(9,null,be.additionalInfo):(0,R.localize)(10,null),offset:be.offset,length:be.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}e.$Ri=s;function c(_,W){const ce=_?_.substituteConstants():void 0,be=W?W.substituteConstants():void 0;return!ce&&!be?!0:!ce||!be?!1:ce.equals(be)}e.$Si=c;function h(_,W){return _.cmp(W)}class w{static{this.INSTANCE=new w}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return m.INSTANCE}}e.$Ti=w;class m{static{this.INSTANCE=new m}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return w.INSTANCE}}e.$Ui=m;class I{static create(W,ce=null){const be=D.get(W);return typeof be=="boolean"?be?m.INSTANCE:w.INSTANCE:new I(W,ce)}constructor(W,ce){this.key=W,this.c=ce,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:fe(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=D.get(this.key);return typeof W=="boolean"?W?m.INSTANCE:w.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Vi=I;class k{static create(W,ce,be=null){if(typeof ce=="boolean")return ce?I.create(W,be):C.create(W,be);const se=D.get(W);return typeof se=="boolean"?ce===(se?"true":"false")?m.INSTANCE:w.INSTANCE:new k(W,ce,be)}constructor(W,ce,be){this.c=W,this.d=ce,this.f=be,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=D.get(this.c);if(typeof W=="boolean"){const ce=W?"true":"false";return this.d===ce?m.INSTANCE:w.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Wi=k;class d{static create(W,ce){return new d(W,ce)}constructor(W,ce){this.d=W,this.f=ce,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:we(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const ce=W.getValue(this.f),be=W.getValue(this.d);return Array.isArray(ce)?ce.includes(be):typeof be=="string"&&typeof ce=="object"&&ce!==null?A.call(ce,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.$Xi=d;class b{static create(W,ce){return new b(W,ce)}constructor(W,ce){this.d=W,this.f=ce,this.type=11,this.c=d.create(W,ce)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Yi=b;class y{static create(W,ce,be=null){if(typeof ce=="boolean")return ce?C.create(W,be):I.create(W,be);const se=D.get(W);return typeof se=="boolean"?ce===(se?"true":"false")?w.INSTANCE:m.INSTANCE:new y(W,ce,be)}constructor(W,ce,be){this.c=W,this.d=ce,this.f=be,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=D.get(this.c);if(typeof W=="boolean"){const ce=W?"true":"false";return this.d===ce?w.INSTANCE:m.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Zi=y;class C{static create(W,ce=null){const be=D.get(W);return typeof be=="boolean"?be?w.INSTANCE:m.INSTANCE:new C(W,ce)}constructor(W,ce){this.c=W,this.d=ce,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:fe(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=D.get(this.c);return typeof W=="boolean"?W?w.INSTANCE:m.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$1i=C;function B(_,W){if(typeof _=="string"){const ce=parseFloat(_);isNaN(ce)||(_=ce)}return typeof _=="string"||typeof _=="number"?W(_):w.INSTANCE}class H{static create(W,ce,be=null){return B(ce,se=>new H(W,se,be))}constructor(W,ce,be){this.c=W,this.d=ce,this.f=be,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$2i=H;class U{static create(W,ce,be=null){return B(ce,se=>new U(W,se,be))}constructor(W,ce,be){this.c=W,this.d=ce,this.f=be,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$3i=U;class z{static create(W,ce,be=null){return B(ce,se=>new z(W,se,be))}constructor(W,ce,be){this.c=W,this.d=ce,this.f=be,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$4i=z;class F{static create(W,ce,be=null){return B(ce,se=>new F(W,se,be))}constructor(W,ce,be){this.c=W,this.d=ce,this.f=be,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$5i=F;class N{static create(W,ce){return new N(W,ce)}constructor(W,ce){this.d=W,this.f=ce,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const ce=this.f?this.f.source:"",be=W.f?W.f.source:"";return ce<be?-1:ce>be?1:0}equals(W){if(W.type===this.type){const ce=this.f?this.f.source:"",be=W.f?W.f.source:"";return this.d===W.d&&ce===be}return!1}substituteConstants(){return this}evaluate(W){const ce=W.getValue(this.d);return this.f?this.f.test(ce):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=X.create(this)),this.c}}e.$6i=N;class X{static create(W){return new X(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new X(this.c.map(W))}negate(){return this.c}}e.$7i=X;function Q(_){let W=null;for(let ce=0,be=_.length;ce<be;ce++){const se=_[ce].substituteConstants();if(_[ce]!==se&&W===null){W=[];for(let he=0;he<ce;he++)W[he]=_[he]}W!==null&&(W[ce]=se)}return W===null?_:W}class De{static create(W,ce,be){return De.d(W,ce,be)}constructor(W,ce){this.expr=W,this.c=ce,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ce=0,be=this.expr.length;ce<be;ce++){const se=h(this.expr[ce],W.expr[ce]);if(se!==0)return se}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ce=0,be=this.expr.length;ce<be;ce++)if(!this.expr[ce].equals(W.expr[ce]))return!1;return!0}return!1}substituteConstants(){const W=Q(this.expr);return W===this.expr?this:De.create(W,this.c,!1)}evaluate(W){for(let ce=0,be=this.expr.length;ce<be;ce++)if(!this.expr[ce].evaluate(W))return!1;return!0}static d(W,ce,be){const se=[];let he=!1;for(const ue of W)if(ue){if(ue.type===1){he=!0;continue}if(ue.type===0)return w.INSTANCE;if(ue.type===6){se.push(...ue.expr);continue}se.push(ue)}if(se.length===0&&he)return m.INSTANCE;if(se.length!==0){if(se.length===1)return se[0];se.sort(h);for(let ue=1;ue<se.length;ue++)se[ue-1].equals(se[ue])&&(se.splice(ue,1),ue--);if(se.length===1)return se[0];for(;se.length>1;){const ue=se[se.length-1];if(ue.type!==9)break;se.pop();const ye=se.pop(),ee=se.length===0,de=ke.create(ue.expr.map(ie=>De.create([ie,ye],null,be)),null,ee);de&&(se.push(de),se.sort(h))}if(se.length===1)return se[0];if(be){for(let ue=0;ue<se.length;ue++)for(let ye=ue+1;ye<se.length;ye++)if(se[ue].negate().equals(se[ye]))return w.INSTANCE;if(se.length===1)return se[0]}return new De(se,ce)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const ce of this.expr)W.push(...ce.keys());return W}map(W){return new De(this.expr.map(ce=>ce.map(W)),null)}negate(){if(!this.c){const W=[];for(const ce of this.expr)W.push(ce.negate());this.c=ke.create(W,this,!0)}return this.c}}e.$8i=De;class ke{static create(W,ce,be){return ke.d(W,ce,be)}constructor(W,ce){this.expr=W,this.c=ce,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ce=0,be=this.expr.length;ce<be;ce++){const se=h(this.expr[ce],W.expr[ce]);if(se!==0)return se}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ce=0,be=this.expr.length;ce<be;ce++)if(!this.expr[ce].equals(W.expr[ce]))return!1;return!0}return!1}substituteConstants(){const W=Q(this.expr);return W===this.expr?this:ke.create(W,this.c,!1)}evaluate(W){for(let ce=0,be=this.expr.length;ce<be;ce++)if(this.expr[ce].evaluate(W))return!0;return!1}static d(W,ce,be){let se=[],he=!1;if(W){for(let ue=0,ye=W.length;ue<ye;ue++){const ee=W[ue];if(ee){if(ee.type===0){he=!0;continue}if(ee.type===1)return m.INSTANCE;if(ee.type===9){se=se.concat(ee.expr);continue}se.push(ee)}}if(se.length===0&&he)return w.INSTANCE;se.sort(h)}if(se.length!==0){if(se.length===1)return se[0];for(let ue=1;ue<se.length;ue++)se[ue-1].equals(se[ue])&&(se.splice(ue,1),ue--);if(se.length===1)return se[0];if(be){for(let ue=0;ue<se.length;ue++)for(let ye=ue+1;ye<se.length;ye++)if(se[ue].negate().equals(se[ye]))return m.INSTANCE;if(se.length===1)return se[0]}return new ke(se,ce)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const ce of this.expr)W.push(...ce.keys());return W}map(W){return new ke(this.expr.map(ce=>ce.map(W)),null)}negate(){if(!this.c){const W=[];for(const ce of this.expr)W.push(ce.negate());for(;W.length>1;){const ce=W.shift(),be=W.shift(),se=[];for(const he of pe(ce))for(const ue of pe(be))se.push(De.create([he,ue],null,!1));W.unshift(ke.create(se,null,!1))}this.c=ke.create(W,this,!0)}return this.c}}e.$9i=ke;class Pe extends I{static{this.d=[]}static all(){return Pe.d.values()}constructor(W,ce,be){super(W,null),this.f=ce,typeof be=="object"?Pe.d.push({...be,key:W}):be!==!0&&Pe.d.push({key:W,description:be,type:ce!=null?typeof ce:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return k.create(this.key,W)}notEqualsTo(W){return y.create(this.key,W)}}e.$0i=Pe,e.$$i=(0,M.$Sh)("contextKeyService");function fe(_,W){return _<W?-1:_>W?1:0}function we(_,W,ce,be){return _<ce?-1:_>ce?1:W<be?-1:W>be?1:0}function ne(_,W){if(_.type===0||W.type===1)return!0;if(_.type===9)return W.type===9?re(_.expr,W.expr):!1;if(W.type===9){for(const ce of W.expr)if(ne(_,ce))return!0;return!1}if(_.type===6){if(W.type===6)return re(W.expr,_.expr);for(const ce of _.expr)if(ne(ce,W))return!0;return!1}return _.equals(W)}e.$_i=ne;function re(_,W){let ce=0,be=0;for(;ce<_.length&&be<W.length;){const se=_[ce].cmp(W[be]);if(se<0)return!1;se===0&&ce++,be++}return ce===_.length}function pe(_){return _.type===9?_.expr:[_]}}),define(Ae[185],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.$Zh=void 0,e.$Zh=(0,E.$Sh)("environmentService"),e.$1h=(0,E.$Th)(e.$Zh)}),define(Ae[96],Re([1,0,151,4]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ao=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=void 0,e.$1n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$2n=new RegExp(e.$1n),e.$3n="__web_extension",e.$4n="skipWalkthrough",e.$5n="extensionsSync",e.$6n="dependecyOrPackExtensionInstall";function P(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$7n=P;function M(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$8n=M;function R(i,n){switch(i){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$9n=R;function $(i,n){return n==="web"&&!i.includes("web")}e.$0n=$;function D(i,n,u){return $(n,u)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===u}e.$$n=D;function g(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.$_n=g;var A;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var S;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var o;(function(i){i.Install="install",i.Uninstall="uninstall"})(o||(e.StatisticType=o={}));var v;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$ao=(0,L.$Sh)("extensionGalleryService");var p;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var f;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(f||(e.ExtensionSignaturetErrorCode=f={}));class t extends Error{constructor(n,u){super(n),this.code=u,this.name=u}}e.$bo=t,e.$co=(0,L.$Sh)("extensionManagementService"),e.$do="extensionsIdentifiers/disabled",e.$eo="extensionsIdentifiers/enabled",e.$fo=(0,L.$Sh)("IGlobalExtensionEnablementService"),e.$go=(0,L.$Sh)("IExtensionTipsService"),e.$ho=(0,E.localize)(0,null),e.$io={value:e.$ho,original:"Extensions"},e.$jo={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Ae[41],Re([1,0,51,19,13,16,2,153,4,21,14,44]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.FileKind=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.FileOperationResult=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileChangeType=e.$tk=e.FileOperation=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.FileSystemProviderErrorCode=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.FileSystemProviderCapabilities=e.$dk=e.FilePermission=e.FileType=e.$ck=e.$bk=void 0,e.$bk=(0,D.$Sh)("fileService");function o(ne){return ne.create===!0}e.$ck=o;var v;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var p;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function f(ne){const re=ne;return!!re&&typeof re.onDidChange=="function"}e.$dk=f;var t;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(ne){return!!(ne.capabilities&2)}e.$ek=i;function n(ne){return!!(ne.capabilities&8)}e.$fk=n;function u(ne){return!!(ne.capabilities&131072)}e.$gk=u;function a(ne){return!!(ne.capabilities&4)}e.$hk=a;function l(ne){return!!(ne.capabilities&16)}e.$ik=l;function r(ne){return i(ne)?!!(ne.capabilities&16384):!1}e.$jk=r;function s(ne){return i(ne)?!!(ne.capabilities&32768):!1}e.$kk=s;function c(ne){return!!(ne.capabilities&65536)}e.$lk=c;function h(ne){return!!(ne.capabilities&2048)}e.$mk=h;var w;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(w||(e.FileSystemProviderErrorCode=w={}));class m extends Error{static create(re,pe){const _=new m(re.toString(),pe);return d(_,pe),_}constructor(re,pe){super(re),this.code=pe}}e.$nk=m;function I(ne,re){return m.create(ne,re)}e.$ok=I;function k(ne){return ne||I((0,$.localize)(0,null),w.Unknown)}e.$pk=k;function d(ne,re){return ne.name=re?`${re} (FileSystemError)`:"FileSystemError",ne}e.$qk=d;function b(ne){if(!ne)return w.Unknown;if(ne instanceof m)return ne.code;const re=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!re)return w.Unknown;switch(re[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.$rk=b;function y(ne){if(ne instanceof F)return ne.fileOperationResult;switch(b(ne)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 9;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileTooLarge:return 7;default:return 10}}e.$sk=y;var C;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class B{constructor(re,pe,_){this.resource=re,this.operation=pe,this.target=_}isOperation(re){return this.operation===re}}e.$tk=B;var H;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(H||(e.FileChangeType=H={}));class U{static{this.a=null}constructor(re,pe){this.c=pe,this.b=void 0,this.d=new S.$U(()=>{const _=E.$Yh.forUris(()=>this.c);return _.fill(this.rawAdded.map(W=>[W,!0])),_}),this.f=new S.$U(()=>{const _=E.$Yh.forUris(()=>this.c);return _.fill(this.rawUpdated.map(W=>[W,!0])),_}),this.g=new S.$U(()=>{const _=E.$Yh.forUris(()=>this.c);return _.fill(this.rawDeleted.map(W=>[W,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of re){switch(_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}this.b!==U.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(re,...pe){return this.h(re,{includeChildren:!1},...pe)}affects(re,...pe){return this.h(re,{includeChildren:!0},...pe)}h(re,pe,..._){if(!re)return!1;const W=_.length>0;return!!((!W||_.includes(1))&&(this.d.value.get(re)||pe.includeChildren&&this.d.value.findSuperstr(re))||(!W||_.includes(0))&&(this.f.value.get(re)||pe.includeChildren&&this.f.value.findSuperstr(re))||(!W||_.includes(2))&&(this.g.value.findSubstr(re)||pe.includeChildren&&this.g.value.findSuperstr(re)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(re){return this.b===re}hasCorrelation(){return typeof this.b=="number"}}e.$uk=U;function z(ne,re,pe){return!ne||!re||ne===re||re.length>ne.length?!1:(re.charAt(re.length-1)!==L.sep&&(re+=L.sep),pe?(0,P.$4e)(ne,re):ne.indexOf(re)===0)}e.$vk=z;class F extends Error{constructor(re,pe,_){super(re),this.fileOperationResult=pe,this.options=_}}e.$wk=F;class N extends F{constructor(re,pe,_,W){super(re,pe,W),this.fileOperationResult=pe,this.size=_}}e.$xk=N;class X extends F{constructor(re,pe,_){super(re,2,_),this.stat=pe}}e.$yk=X;var Q;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.$zk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Ak={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Bk="files.associations",e.$Ck="files.exclude",e.$Dk="files.readonlyInclude",e.$Ek="files.readonlyExclude",e.$Fk="files.readonlyFromPermissions";var De;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(De||(e.FileKind=De={})),e.$Gk="";function ke(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}e.$Hk=ke;async function Pe(ne,re){if(!re.hasProvider(R.URI.from({scheme:ne.scheme})))return new Promise(pe=>{const _=re.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===ne.scheme&&W.added&&(_.dispose(),pe())})})}e.$Ik=Pe;class fe{static{this.KB=1024}static{this.MB=fe.KB*fe.KB}static{this.GB=fe.MB*fe.KB}static{this.TB=fe.GB*fe.KB}static formatSize(re){return(0,M.$Df)(re)||(re=0),re<fe.KB?(0,$.localize)(1,null,re.toFixed(0)):re<fe.MB?(0,$.localize)(2,null,(re/fe.KB).toFixed(2)):re<fe.GB?(0,$.localize)(3,null,(re/fe.MB).toFixed(2)):re<fe.TB?(0,$.localize)(4,null,(re/fe.GB).toFixed(2)):(0,$.localize)(5,null,(re/fe.TB).toFixed(2))}}e.$Jk=fe;function we(ne){const re=typeof ne=="string"||ne?.scheme===A.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===A.Schemas.file?1024*fe.MB:re?10*fe.MB:g.$o?50*fe.MB:1024*fe.MB}e.$Kk=we}),define(Ae[72],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=void 0;class E{constructor(...P){this.a=new Map;for(const[M,R]of P)this.set(M,R)}set(P,M){const R=this.a.get(P);return this.a.set(P,M),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Qh=E}),define(Ae[186],Re([1,0,12,11,6,70,184,4,72,187]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;const A=!1;class S extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class o{constructor(t=new D.$Qh,i=!1,n,u=A){this.f=t,this.g=i,this.h=n,this.i=u,this.o=new Set,this.f.set($.$Rh,this),this._globalGraph=u?n?._globalGraph??new R.$fq(a=>a):void 0}createChild(t){return new o(t,this.g,this,this.i)}invokeFunction(t,...i){const n=p.traceInvocation(this.i,t);let u=!1;try{return t({get:l=>{if(u)throw(0,L.$7)("service accessor is only valid during the invocation of its target method");const r=this.m(l,n);if(!r)throw new Error(`[invokeFunction] unknown service '${l}'`);return r}},...i)}finally{u=!0,n.stop()}}createInstance(t,...i){let n,u;return t instanceof M.$Ph?(n=p.traceCreation(this.i,t.ctor),u=this.j(t.ctor,t.staticArguments.concat(i),n)):(n=p.traceCreation(this.i,t),u=this.j(t,i,n)),n.stop(),u}j(t,i=[],n){const u=$._util.getServiceDependencies(t).sort((r,s)=>r.index-s.index),a=[];for(const r of u){const s=this.m(r.id,n);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),a.push(s)}const l=u.length>0?u[0].index:i.length;if(i.length!==l){console.trace(`[createInstance] First service dependency of ${t.name} at position ${l+1} conflicts with ${i.length} static arguments`);const r=l-i.length;r>0?i=i.concat(new Array(r)):i=i.slice(0,l)}return Reflect.construct(t,i.concat(a))}k(t,i){if(this.f.get(t)instanceof M.$Ph)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const n=this.l(t);return n instanceof M.$Ph?this.q(t,n,i.branch(t,!0)):(i.branch(t,!1),n)}q(t,i,n){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,n)}finally{this.o.delete(t)}}r(t,i,n){const u=new R.$fq(r=>r.id.toString());let a=0;const l=[{id:t,desc:i,_trace:n}];for(;l.length;){const r=l.pop();if(u.lookupOrInsertNode(r),a++>1e3)throw new S(u);for(const s of $._util.getServiceDependencies(r.desc.ctor)){const c=this.l(s.id);if(c||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(s.id)),c instanceof M.$Ph){const h={id:s.id,desc:c,_trace:r._trace.branch(s.id,!0)};u.insertEdge(r,h),l.push(h)}}}for(;;){const r=u.roots();if(r.length===0){if(!u.isEmpty())throw new S(u);break}for(const{data:s}of r){if(this.l(s.id)instanceof M.$Ph){const h=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,h)}u.removeNode(s)}}return this.l(t)}s(t,i,n=[],u,a){if(this.f.get(t)instanceof M.$Ph)return this.t(t,i,n,u,a);if(this.h)return this.h.s(t,i,n,u,a);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,n=[],u,a){if(u){const l=new o(void 0,this.g,this,this.i);l.c=String(t);const r=new Map,s=new E.$bh(()=>{const c=l.j(i,n,a);for(const[h,w]of r){const m=c[h];if(typeof m=="function")for(const I of w)m.apply(c,I)}return r.clear(),c});return new Proxy(Object.create(null),{get(c,h){if(!s.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let I=r.get(h);return I||(I=new g.$1c,r.set(h,I)),(d,b,y)=>{const C=I.push([d,b,y]);return(0,P.$Pc)(C)}}if(h in c)return c[h];const w=s.value;let m=w[h];return typeof m!="function"||(m=m.bind(w),c[h]=m),m},set(c,h,w){return s.value[h]=w,!0},getPrototypeOf(c){return i.prototype}})}else return this.j(i,n,a)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$gq=o;var v;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(v||(v={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new p(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(t,i){return t?new p(1,i.name):p.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const n=new p(3,t.toString());return this.h.push([t,i,n]),n}stop(){const t=Date.now()-this.g;p.f+=t;let i=!1;function n(a,l){const r=[],s=new Array(a+1).join("	");for(const[c,h,w]of l.h)if(h&&w){i=!0,r.push(`${s}CREATES -> ${c}`);const m=n(a+1,w);m&&r.push(m)}else r.push(`${s}uses -> ${c}`);return r.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(t>2||i)&&p.all.add(u.join(`
`))}}e.$hq=p}),define(Ae[15],Re([1,0,39,5,97,6,28,21,25,16,2,34,4]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.log=e.$dj=e.LogLevel=e.$cj=e.$bj=e.$aj=void 0,e.$aj=(0,o.$Sh)("logService"),e.$bj=(0,o.$Sh)("loggerService");function v(){return new Date().toISOString()}function p(d){return(0,g.$Df)(d)}e.$cj=p;var f;(function(d){d[d.Off=0]="Off",d[d.Trace=1]="Trace",d[d.Debug=2]="Debug",d[d.Info=3]="Info",d[d.Warning=4]="Warning",d[d.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$dj=f.Info;function t(d,b,y){switch(b){case f.Trace:d.trace(y);break;case f.Debug:d.debug(y);break;case f.Info:d.info(y);break;case f.Warning:d.warn(y);break;case f.Error:d.error(y);break;case f.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=t;function i(d,b=!1){let y="";for(let C=0;C<d.length;C++){let B=d[C];if(B instanceof Error&&(B=(0,E.$Di)(B,b)),typeof B=="object")try{B=JSON.stringify(B)}catch{}y+=(C>0?" ":"")+B}return y}class n extends M.$Rc{constructor(){super(...arguments),this.b=e.$dj,this.c=this.B(new L.$Od),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==f.Off&&this.b<=b}}e.$fj=n;class u extends n{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...y){this.f(f.Trace)&&this.g(f.Trace,i([b,...y],!0))}debug(b,...y){this.f(f.Debug)&&this.g(f.Debug,i([b,...y]))}info(b,...y){this.f(f.Info)&&this.g(f.Info,i([b,...y]))}warn(b,...y){this.f(f.Warning)&&this.g(f.Warning,i([b,...y]))}error(b,...y){if(this.f(f.Error))if(b instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=b.stack,this.g(f.Error,i(C))}else this.g(f.Error,i([b,...y]))}flush(){}}e.$gj=u;class a extends n{constructor(b=e.$dj){super(),this.setLevel(b),this.g=!$.$i}trace(b,...y){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,b,...y):console.log(`[main ${v()}]`,b,...y))}debug(b,...y){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,b,...y):console.log(`[main ${v()}]`,b,...y))}info(b,...y){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,b,...y):console.log(`[main ${v()}]`,b,...y))}warn(b,...y){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,b,...y):console.warn(`[main ${v()}]`,b,...y))}error(b,...y){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,b,...y):console.error(`[main ${v()}]`,b,...y))}dispose(){}flush(){}}e.$hj=a;class l extends n{constructor(b=e.$dj,y=!0){super(),this.g=y,this.setLevel(b)}trace(b,...y){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...y):console.log(b,...y))}debug(b,...y){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...y):console.log(b,...y))}info(b,...y){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...y):console.log(b,...y))}warn(b,...y){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...y):console.log(b,...y))}error(b,...y){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...y):console.error(b,...y))}dispose(){}flush(){}}e.$ij=l;class r extends n{constructor(b,y=e.$dj){super(),this.g=b,this.setLevel(y)}trace(b,...y){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(b),...y])}debug(b,...y){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(b),...y])}info(b,...y){this.f(f.Info)&&this.g.log(f.Info,[this.h(b),...y])}warn(b,...y){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(b),...y])}error(b,...y){this.f(f.Error)&&this.g.log(f.Error,[this.h(b),...y])}h(b){return typeof b=="string"?b:(0,E.$Di)(b,this.f(f.Trace))}dispose(){}flush(){}}e.$jj=r;class s extends n{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const y of this.g)y.setLevel(b);super.setLevel(b)}trace(b,...y){for(const C of this.g)C.trace(b,...y)}debug(b,...y){for(const C of this.g)C.debug(b,...y)}info(b,...y){for(const C of this.g)C.info(b,...y)}warn(b,...y){for(const C of this.g)C.warn(b,...y)}error(b,...y){for(const C of this.g)C.error(b,...y)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose()}}e.$kj=s;class c extends M.$Rc{constructor(b,y,C){if(super(),this.h=b,this.j=y,this.b=new R.$zc,this.c=this.B(new L.$Od),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$Od),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$Od),this.onDidChangeVisibility=this.g.event,C)for(const B of C)this.b.set(B.resource,{logger:void 0,info:B})}m(b){return(0,g.$zf)(b)?[...this.b.values()].find(y=>y.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,y){const C=this.n(b),B=(0,g.$zf)(b)?b:y?.id??(0,P.$Gi)(C.toString()).toString(16);let H=this.b.get(C)?.logger;const U=y?.logLevel==="always"?f.Trace:y?.logLevel;H||(H=this.s(C,U??this.getLogLevel(C)??this.h,{...y,id:B}));const z={logger:H,info:{resource:C,id:B,logLevel:U,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(z.info),this.b.set(C,z),H}n(b){return(0,g.$zf)(b)?(0,D.$wg)(this.j,`${b}.log`):b}setLogLevel(b,y){if(A.URI.isUri(b)){const C=b,B=y,H=this.b.get(C);H&&B!==H.info.logLevel&&(H.info.logLevel=B===this.h?void 0:B,H.logger?.setLevel(B),this.b.set(H.info.resource,H),this.f.fire([C,B]))}else{this.h=b;for(const[C,B]of this.b.entries())this.b.get(C)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,y){const C=this.m(b);C&&y!==!C.info.hidden&&(C.info.hidden=!y,this.b.set(C.info.resource,C),this.g.fire([C.info.resource,y]))}getLogLevel(b){let y;return b&&(y=this.b.get(b)?.info.logLevel),y??this.h}registerLogger(b){const y=this.b.get(b.resource);y?y.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const y=this.b.get(b);y&&(y.logger&&y.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lj=c;class h{constructor(){this.onDidChangeLogLevel=new L.$Od().event}setLevel(b){}getLevel(){return f.Info}trace(b,...y){}debug(b,...y){}info(b,...y){}warn(b,...y){}error(b,...y){}critical(b,...y){}dispose(){}flush(){}}e.$mj=h;class w extends h{}e.$nj=w;function m(d){if(d.verbose)return f.Trace;if(typeof d.logLevel=="string"){const b=k(d.logLevel.toLowerCase());if(b!==void 0)return b}return e.$dj}e.$oj=m;function I(d){switch(d){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.$pj=I;function k(d){switch(d){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$qj=k,e.$rj=new S.$0i("logLevel",I(f.Info))}),define(Ae[188],Re([1,0,6,15]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=void 0;class P extends E.$Rc{constructor(R,$=[]){super(),this.a=new L.$kj([R,...$]),this.B(R.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...$){this.a.trace(R,...$)}debug(R,...$){this.a.debug(R,...$)}info(R,...$){this.a.info(R,...$)}warn(R,...$){this.a.warn(R,...$)}error(R,...$){this.a.error(R,...$)}flush(){this.a.flush()}}e.$TN=P}),define(Ae[98],Re([1,0,31,154,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var R;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(D){function g(p,f){return f-p}D.compare=g;const A=Object.create(null);A[D.Error]=(0,L.localize)(0,null),A[D.Warning]=(0,L.localize)(1,null),A[D.Info]=(0,L.localize)(2,null);function S(p){return A[p]||""}D.toString=S;function o(p){switch(p){case E.default.Error:return D.Error;case E.default.Warning:return D.Warning;case E.default.Info:return D.Info;case E.default.Ignore:return D.Hint}}D.fromSeverity=o;function v(p){switch(p){case D.Error:return E.default.Error;case D.Warning:return E.default.Warning;case D.Info:return E.default.Info;case D.Hint:return E.default.Ignore}}D.toSeverity=v}(R||(e.MarkerSeverity=R={}));var $;(function(D){const g="";function A(o){return S(o,!0)}D.makeKey=A;function S(o,v){const p=[g];return o.source?p.push(o.source.replace("\xA6","\\\xA6")):p.push(g),o.code?typeof o.code=="string"?p.push(o.code.replace("\xA6","\\\xA6")):p.push(o.code.value.replace("\xA6","\\\xA6")):p.push(g),o.severity!==void 0&&o.severity!==null?p.push(R.toString(o.severity)):p.push(g),o.message&&v?p.push(o.message.replace("\xA6","\\\xA6")):p.push(g),o.startLineNumber!==void 0&&o.startLineNumber!==null?p.push(o.startLineNumber.toString()):p.push(g),o.startColumn!==void 0&&o.startColumn!==null?p.push(o.startColumn.toString()):p.push(g),o.endLineNumber!==void 0&&o.endLineNumber!==null?p.push(o.endLineNumber.toString()):p.push(g),o.endColumn!==void 0&&o.endColumn!==null?p.push(o.endColumn.toString()):p.push(g),p.push(g),p.join("\xA6")}D.makeKeyOptionalMessage=S})($||(e.IMarkerData=$={})),e.$ct=(0,P.$Sh)("markerService")}),define(Ae[189],Re([1,0,5,31,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5u=e.$4u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$3u=e.Severity=void 0,e.Severity=L.default,e.$3u=(0,P.$Sh)("notificationService");var M;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var $;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class D{constructor(){this.progress=new g,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(S){}updateMessage(S){}updateActions(S){}close(){}}e.$4u=D;class g{infinite(){}done(){}total(S){}worked(S){}}e.$5u=g}),define(Ae[99],Re([1,0,13,2,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MU=e.$LU=e.$KU=e.$JU=e.$IU=void 0,e.$IU=(0,P.$Sh)("openerService");function M(g,A){return L.URI.isUri(g)?(0,E.$3e)(g.scheme,A):(0,E.$4e)(g,A+":")}e.$JU=M;function R(g,...A){return A.some(S=>M(g,S))}e.$KU=R;function $(g,A){return g.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$LU=$;function D(g){let A;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return S&&(A={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},g=g.with({fragment:""})),{selection:A,uri:g}}e.$MU=D}),define(Ae[190],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=void 0,e.$sj=(0,E.$Sh)("productService"),e.$tj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(ve,e,E,L){var P=arguments.length,M=P<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,E):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ve,e,E,L);else for(var $=ve.length-1;$>=0;$--)(R=ve[$])&&(M=(P<3?R(M):P>3?R(e,E,M):R(e,E))||M);return P>3&&M&&Object.defineProperty(e,E,M),M},Ve=this&&this.__param||function(ve,e){return function(E,L){e(E,L,ve)}};define(Ae[54],Re([1,0,12,20,6,4]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.ProgressLocation=e.$6u=void 0,e.$6u=(0,M.$Sh)("progressService");var R;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$7u=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(o){this.b=o}report(o){this.a=o,this.b(this.a)}}e.$8u=$;class D{get value(){return this.a}constructor(o){this.e=o}report(o){this.b?this.b.push(o):this.b=[o],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const o=this.b.shift();this.a=o,await this.e(this.a)}}finally{this.c=!1;const o=this.d;this.d=void 0,o?.()}}drain(){return this.c?new Promise(o=>{const v=this.d;this.d=()=>{v?.(),o()}}):Promise.resolve()}}e.$9u=D;let g=class extends P.$Rc{constructor(o,v){super(),this.a=new E.$fh,v.withProgress(o,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,P.$Pc)(()=>this.a.complete()))}report(o){this.b?this.b.report(o):this.c=o}};e.$0u=g,e.$0u=g=Ke([Ve(1,e.$6u)],g);class A extends P.$Rc{constructor(o){super(),this.g=o,this.a=0,this.b=this.B(new P.$Qc)}start(o){this.stop();const v=++this.a,p=new L.$Yd;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},o),this.b.add((0,P.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Pc)(()=>p.cancel())),this.b.add((0,P.$Pc)(()=>this.c?this.c.done():void 0)),{id:v,token:p.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(o){this.a===o&&this.b.clear()}}e.$$u=A,e.$_u=(0,M.$Sh)("editorProgressService")}),define(Ae[30],Re([1,0,55,16]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=void 0;class P{constructor(){this.a=new Map}add(R,$){E.ok(L.$zf(R)),E.ok(L.$Bf($)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,$)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$jn=new P}),define(Ae[73],Re([1,0,5,30]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0,e.$kn={JSONContribution:"base.contributions.json"};function P($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class M{constructor(){this.b=new E.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,g){this.a[P(D)]=g,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const R=new M;L.$jn.add(e.$kn.JSONContribution,R)}),define(Ae[56],Re([1,0,18,5,16,148,40,73,30]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.ConfigurationScope=e.$on=e.EditPresentationTypes=void 0;var g;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$on={Configuration:"base.contributions.configuration"};var A;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn="vscode://schemas/settings/resourceLanguage",e.$wn="vscode://schemas/settings/configurationDefaults";const S=D.$jn.as($.$kn.JSONContribution);class o{constructor(){this.h=new Set,this.i=new L.$Od,this.onDidSchemaChange=this.i.event,this.j=new L.$Od,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$vn,this.g),this.v()}registerConfiguration(r,s=!0){this.registerConfigurations([r],s)}registerConfigurations(r,s=!0){const c=new Set;this.n(r,s,c),S.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(r){const s=new Set;this.o(r,s),S.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:r,remove:s}){const c=new Set;this.o(s,c),this.n(r,!1,c),S.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(r){const s=new Set;this.k(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(r,s){const c=[];for(const{overrides:h,source:w}of r)for(const m in h)if(s.add(m),e.$yn.test(m)){const I=this.a.get(m),k=I?.valuesSources??new Map;if(w)for(const C of Object.keys(h[m]))k.set(C,w);const d={...I?.value||{},...h[m]};this.a.set(m,{source:w,value:d,valuesSources:k});const b=(0,R.$wi)(m),y={type:"object",default:d,description:M.localize(1,null,b),$ref:e.$vn,defaultDefaultValue:d,source:P.$zf(w)?void 0:w,defaultValueSource:w};c.push(...f(m)),this.d[m]=y,this.b.properties[m]=y}else{this.a.set(m,{value:h[m],source:w});const I=this.d[m];I&&(this.w(m,I),this.r(m,I))}this.m(c)}deregisterDefaultConfigurations(r){const s=new Set;this.l(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(r,s){for(const{overrides:c,source:h}of r)for(const w in c){const m=this.a.get(w),I=P.$zf(h)?h:h?.id,k=P.$zf(m?.source)?m?.source:m?.source?.id;if(I===k)if(s.add(w),this.a.delete(w),e.$yn.test(w))delete this.d[w],delete this.b.properties[w];else{const d=this.d[w];d&&(this.w(w,d),this.r(w,d))}}this.u()}deltaConfiguration(r){let s=!1;const c=new Set;r.removedDefaults&&(this.l(r.removedDefaults,c),s=!0),r.addedDefaults&&(this.k(r.addedDefaults,c),s=!0),r.removedConfigurations&&this.o(r.removedConfigurations,c),r.addedConfigurations&&this.n(r.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const s of r)this.h.add(s);this.u()}n(r,s,c){r.forEach(h=>{this.p(h,s,h.extensionInfo,h.restrictedProperties,void 0,c),this.c.push(h),this.q(h)})}o(r,s){const c=h=>{if(h.properties)for(const w in h.properties){s.add(w);const m=this.d[w];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[w],this.s(w,h.properties[w])}h.allOf?.forEach(w=>c(w))};for(const h of r){c(h);const w=this.c.indexOf(h);w!==-1&&this.c.splice(w,1)}}p(r,s=!0,c,h,w=3,m){w=P.$If(r.scope)?w:r.scope;const I=r.properties;if(I)for(const d in I){const b=I[d];if(s&&u(d,b)){delete I[d];continue}if(b.source=c,b.defaultDefaultValue=I[d].default,this.w(d,b),e.$yn.test(d)?b.scope=void 0:(b.scope=P.$If(b.scope)?w:b.scope,b.restricted=P.$If(b.restricted)?!!h?.includes(d):b.restricted),I[d].hasOwnProperty("included")&&!I[d].included){this.f[d]=I[d],delete I[d];continue}else this.d[d]=I[d],I[d].policy?.name&&this.e.set(I[d].policy.name,d);!I[d].deprecationMessage&&I[d].markdownDeprecationMessage&&(I[d].deprecationMessage=I[d].markdownDeprecationMessage),m.add(d)}const k=r.allOf;if(k)for(const d of k)this.p(d,s,c,h,w,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const s=c=>{const h=c.properties;if(h)for(const m in h)this.r(m,h[m]);c.allOf?.forEach(s)};s(r)}r(r,s){switch(e.$pn.properties[r]=s,s.scope){case 1:e.$qn.properties[r]=s;break;case 2:e.$rn.properties[r]=s;break;case 6:e.$sn.properties[r]=s;break;case 3:e.$tn.properties[r]=s;break;case 4:e.$un.properties[r]=s;break;case 5:e.$un.properties[r]=s,this.g.properties[r]=s;break}}s(r,s){switch(delete e.$pn.properties[r],s.scope){case 1:delete e.$qn.properties[r];break;case 2:delete e.$rn.properties[r];break;case 6:delete e.$sn.properties[r];break;case 3:delete e.$tn.properties[r];break;case 4:case 5:delete e.$un.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const s=`[${r}]`,c={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$vn};this.w(s,c),e.$pn.properties[s]=c,e.$qn.properties[s]=c,e.$rn.properties[s]=c,e.$sn.properties[s]=c,e.$tn.properties[s]=c,e.$un.properties[s]=c}}v(){const r={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$vn};e.$pn.patternProperties[e.$xn]=r,e.$qn.patternProperties[e.$xn]=r,e.$rn.patternProperties[e.$xn]=r,e.$sn.patternProperties[e.$xn]=r,e.$tn.patternProperties[e.$xn]=r,e.$un.patternProperties[e.$xn]=r,this.i.fire()}w(r,s){const c=this.a.get(r);let h=c?.value,w=c?.source;P.$Gf(h)&&(h=s.defaultDefaultValue,w=void 0),P.$Gf(h)&&(h=i(s.type)),s.default=h,s.defaultValueSource=w}}const v="\\[([^\\]]+)\\]",p=new RegExp(v,"g");e.$xn=`^(${v})+$`,e.$yn=new RegExp(e.$xn);function f(l){const r=[];if(e.$yn.test(l)){let s=p.exec(l);for(;s?.length;){const c=s[1].trim();c&&r.push(c),s=p.exec(l)}}return(0,E.$Lb)(r)}e.$zn=f;function t(l){return l.reduce((r,s)=>`${r}[${s}]`,"")}e.$An=t;function i(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Bn=i;const n=new o;D.$jn.add(e.$on.Configuration,n);function u(l,r){return l.trim()?e.$yn.test(l)?M.localize(7,null,l):n.getConfigurationProperties()[l]!==void 0?M.localize(8,null,l):r.policy?.name&&n.getPolicyConfigurations().get(r.policy?.name)!==void 0?M.localize(9,null,l,r.policy?.name,n.getPolicyConfigurations().get(r.policy?.name)):null:M.localize(6,null)}e.$Cn=u;function a(){const l=[],r=n.getConfigurationProperties();for(const s of Object.keys(r))l.push([s,r[s].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$Dn=a}),define(Ae[191],Re([1,0,18,5,119,6,28,26,16,2,40,56,30]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=void 0;function v(s){return Object.isFrozen(s)?s:$.$$m(s)}class p{constructor(c={},h=[],w=[],m){this.b=c,this.c=h,this.d=w,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map(h=>{if(h instanceof p)return h;const w=new f("");return w.parseRaw(h),w.configurationModel});this.f=c.reduce((h,w)=>w===h?w:h.merge(w),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,A.$ui)(this.contents,c):this.contents}inspect(c,h){const w=this.rawConfiguration.getValue(c),m=h?this.rawConfiguration.getOverrideValue(c,h):void 0,I=h?this.rawConfiguration.override(h).getValue(c):w;return{value:w,override:m,merged:I}}getOverrideValue(c,h){const w=this.i(h);return w?c?(0,A.$ui)(w,c):w:void 0}getKeysForOverrideIdentifier(c){const h=[];for(const w of this.overrides)w.identifiers.includes(c)&&h.push(...w.keys);return E.$Lb(h)}getAllOverrideIdentifiers(){const c=[];for(const h of this.overrides)c.push(...h.identifiers);return E.$Lb(c)}override(c){let h=this.a.get(c);return h||(h=this.g(c),this.a.set(c,h)),h}merge(...c){const h=$.$0m(this.contents),w=$.$0m(this.overrides),m=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const k of c)if(I.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(h,k.contents);for(const d of k.overrides){const[b]=w.filter(y=>E.$tb(y.identifiers,d.identifiers));b?(this.h(b.contents,d.contents),b.keys.push(...d.keys),b.keys=E.$Lb(b.keys)):w.push($.$0m(d))}for(const d of k.keys)m.indexOf(d)===-1&&m.push(d)}return new p(h,m,w,I.every(k=>k instanceof p)?void 0:I)}g(c){const h=this.i(c);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const w={};for(const m of E.$Lb([...Object.keys(this.contents),...Object.keys(h)])){let I=this.contents[m];const k=h[m];k&&(typeof I=="object"&&typeof k=="object"?(I=$.$0m(I),this.h(I,k)):I=k),w[m]=I}return new p(w,this.keys,this.overrides)}h(c,h){for(const w of Object.keys(h)){if(w in c&&D.$Bf(c[w])&&D.$Bf(h[w])){this.h(c[w],h[w]);continue}c[w]=$.$0m(h[w])}}i(c){let h=null,w=null;const m=I=>{I&&(w?this.h(w,I):w=$.$0m(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===c?h=I.contents:I.identifiers.includes(c)&&m(I.contents);return m(h),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,h){this.j(c,h,!0)}setValue(c,h){this.j(c,h,!1)}removeValue(c){const h=this.keys.indexOf(c);h!==-1&&(this.keys.splice(h,1),(0,A.$ti)(this.contents,c),S.$yn.test(c)&&this.overrides.splice(this.overrides.findIndex(w=>E.$tb(w.identifiers,(0,S.$zn)(c))),1))}j(c,h,w){(0,A.$si)(this.contents,c,h,m=>console.error(m)),w=w||this.keys.indexOf(c)===-1,w&&this.keys.push(c),S.$yn.test(c)&&this.overrides.push({identifiers:(0,S.$zn)(c),keys:Object.keys(this.contents[c]),contents:(0,A.$ri)(this.contents[c],m=>console.error(m))})}}e.$En=p;class f{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,h){if(!D.$If(c)){const w=this.g(c);this.parseRaw(w,h)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,h){this.a=c;const{contents:w,keys:m,overrides:I,restricted:k,hasExcludedProperties:d}=this.h(c,h);this.b=new p(w,m,I,d?[c]:void 0),this.c=k||[]}g(c){let h={},w=null,m=[];const I=[],k=[];function d(y){Array.isArray(m)?m.push(y):w!==null&&(m[w]=y)}const b={onObjectBegin:()=>{const y={};d(y),I.push(m),m=y,w=null},onObjectProperty:y=>{w=y},onObjectEnd:()=>{m=I.pop()},onArrayBegin:()=>{const y=[];d(y),I.push(m),m=y,w=null},onArrayEnd:()=>{m=I.pop()},onLiteralValue:d,onError:(y,C,B)=>{k.push({error:y,offset:C,length:B})}};if(c)try{P.$7m(c,b),h=m[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return h}h(c,h){const w=o.$jn.as(S.$on.Configuration).getConfigurationProperties(),m=this.i(c,w,!0,h);c=m.raw;const I=(0,A.$ri)(c,b=>console.error(`Conflict in settings file ${this.f}: ${b}`)),k=Object.keys(c),d=this.j(c,b=>console.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:I,keys:k,overrides:d,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(c,h,w,m){let I=!1;if(!m?.scopes&&!m?.skipRestricted&&!m?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:I};const k={},d=[];for(const b in c)if(S.$yn.test(b)&&w){const y=this.i(c[b],h,!1,m);k[b]=y.raw,I=I||y.hasExcludedProperties,d.push(...y.restricted)}else{const y=h[b],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&d.push(b),!m.exclude?.includes(b)&&(m.include?.includes(b)||(C===void 0||m.scopes===void 0||m.scopes.includes(C))&&!(m.skipRestricted&&y?.restricted))?k[b]=c[b]:I=!0}return{raw:k,restricted:d,hasExcludedProperties:I}}j(c,h){const w=[];for(const m of Object.keys(c))if(S.$yn.test(m)){const I={};for(const k in c[m])I[k]=c[m][k];w.push({identifiers:(0,S.$zn)(m),keys:Object.keys(I),contents:(0,A.$ri)(I,h)})}return w}}e.$Fn=f;class t extends M.$Rc{constructor(c,h,w,m){super(),this.c=c,this.f=h,this.g=m,this.b=this.B(new L.$Od),this.onDidChange=this.b.event,this.a=new f(this.c.toString()),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&w.isEqual(I.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Gn=t;class i{constructor(c,h,w,m,I,k,d,b,y,C,B,H,U){this.a=c,this.b=h,this.c=w,this.overrideIdentifiers=m,this.d=I,this.f=k,this.g=d,this.h=b,this.i=y,this.j=C,this.k=B,this.l=H,this.m=U}get value(){return v(this.c)}n(c,h,w){const m=c.inspect(h,w);return{get value(){return v(m.value)},get override(){return v(m.override)},get merged(){return v(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(c,h,w,m,I=new p,k=new p,d=new R.$zc,b=new p,y=new R.$zc){this.c=c,this.d=h,this.f=w,this.g=m,this.h=I,this.i=k,this.j=d,this.l=b,this.m=y,this.a=null,this.b=new R.$zc,this.n=null}getValue(c,h,w){return this.q(c,h,w).getValue(c)}updateValue(c,h,w={}){let m;w.resource?(m=this.m.get(w.resource),m||(m=new p,this.m.set(w.resource,m))):m=this.l,h===void 0?m.removeValue(c):m.setValue(c,h),w.resource||(this.a=null)}inspect(c,h,w){const m=this.q(c,h,w),I=this.u(h.resource,w),k=h.resource?this.m.get(h.resource)||this.l:this.l,d=new Set;for(const b of m.overrides)for(const y of b.identifiers)m.getOverrideValue(c,y)!==void 0&&d.add(y);return new i(c,h,m.getValue(c),d.size?[...d]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.i:void 0,I||void 0,k)}keys(c){const h=this.u(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,h){this.j.set(c,h),this.b.delete(c)}deleteFolderConfiguration(c){this.p.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,h){const w=[];if(!h){const{added:m,updated:I,removed:k}=l(this.c,c);h=[...m,...I,...k]}for(const m of h)for(const I of(0,S.$zn)(m)){const k=this.c.getKeysForOverrideIdentifier(I),d=c.getKeysForOverrideIdentifier(I),b=[...d.filter(y=>k.indexOf(y)===-1),...k.filter(y=>d.indexOf(y)===-1),...k.filter(y=>!$.$bn(this.c.override(I).getValue(y),c.override(I).getValue(y)))];w.push([I,b])}return this.updateDefaultConfiguration(c),{keys:h,overrides:w}}compareAndUpdatePolicyConfiguration(c){const{added:h,updated:w,removed:m}=l(this.d,c),I=[...h,...w,...m];return I.length&&this.updatePolicyConfiguration(c),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:h,updated:w,removed:m,overrides:I}=l(this.applicationConfiguration,c),k=[...h,...w,...m];return k.length&&this.updateApplicationConfiguration(c),{keys:k,overrides:I}}compareAndUpdateLocalUserConfiguration(c){const{added:h,updated:w,removed:m,overrides:I}=l(this.localUserConfiguration,c),k=[...h,...w,...m];return k.length&&this.updateLocalUserConfiguration(c),{keys:k,overrides:I}}compareAndUpdateRemoteUserConfiguration(c){const{added:h,updated:w,removed:m,overrides:I}=l(this.remoteUserConfiguration,c),k=[...h,...w,...m];return k.length&&this.updateRemoteUserConfiguration(c),{keys:k,overrides:I}}compareAndUpdateWorkspaceConfiguration(c){const{added:h,updated:w,removed:m,overrides:I}=l(this.workspaceConfiguration,c),k=[...h,...w,...m];return k.length&&this.updateWorkspaceConfiguration(c),{keys:k,overrides:I}}compareAndUpdateFolderConfiguration(c,h){const w=this.p.get(c),{added:m,updated:I,removed:k,overrides:d}=l(w,h),b=[...m,...I,...k];return(b.length||!w)&&this.updateFolderConfiguration(c,h),{keys:b,overrides:d}}compareAndDeleteFolderConfiguration(c){const h=this.p.get(c);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:w,updated:m,removed:I,overrides:k}=l(h,void 0);return{keys:[...w,...m,...I],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(c,h,w){let m=this.r(h,w);return h.overrideIdentifier&&(m=m.override(h.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(m=m.merge(this.d)),m}r({resource:c},h){let w=this.s();if(h&&c){const m=h.getFolder(c);m&&(w=this.t(m.uri)||w);const I=this.m.get(c);I&&(w=w.merge(I))}return w}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(c){let h=this.b.get(c);if(!h){const w=this.s(),m=this.j.get(c);m?(h=w.merge(m),this.b.set(c,h)):h=w}return h}u(c,h){if(h&&c){const w=h.getFolder(c);if(w)return this.j.get(w.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,h)=>{const{contents:w,overrides:m,keys:I}=this.j.get(h);return c.push([h,{contents:w,overrides:m,keys:I}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach(h=>c.add(h)),this.userConfiguration.keys.forEach(h=>c.add(h)),this.i.keys.forEach(h=>c.add(h)),this.j.forEach(h=>h.keys.forEach(w=>c.add(w))),[...c.values()]}v(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.i.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.j.forEach(h=>h.getAllOverrideIdentifiers().forEach(w=>c.add(w))),[...c.values()]}w(c){const h=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(w=>h.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(w=>h.add(w)),this.i.getKeysForOverrideIdentifier(c).forEach(w=>h.add(w)),this.j.forEach(w=>w.getKeysForOverrideIdentifier(c).forEach(m=>h.add(m))),[...h.values()]}static parse(c){const h=this.x(c.defaults),w=this.x(c.policy),m=this.x(c.application),I=this.x(c.user),k=this.x(c.workspace),d=c.folders.reduce((b,y)=>(b.set(g.URI.revive(y[0]),this.x(y[1])),b),new R.$zc);return new n(h,w,m,I,new p,k,d,new p,new R.$zc)}static x(c){return new p(c.contents,c.keys,c.overrides)}}e.$Hn=n;function u(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const c=new Set,h=new Map;for(const m of s)m.keys.forEach(I=>c.add(I)),m.overrides.forEach(([I,k])=>{const d=(0,R.$wc)(h,I,new Set);k.forEach(b=>d.add(b))});const w=[];return h.forEach((m,I)=>w.push([I,[...m.values()]])),{keys:[...c.values()],overrides:w}}e.$In=u;class a{constructor(c,h,w,m){this.change=c,this.f=h,this.g=w,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of c.keys)this.affectedKeys.add(I);for(const[,I]of c.overrides)for(const k of I)this.affectedKeys.add(k);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(c,h){const w=this.a+c,m=this.d.indexOf(w);if(m<0)return!1;const I=m+w.length;if(I>=this.d.length)return!1;const k=this.d.charCodeAt(I);if(k!==this.b&&k!==this.c)return!1;if(h){const d=this.previousConfiguration?this.previousConfiguration.getValue(c,h,this.f?.workspace):void 0,b=this.g.getValue(c,h,this.h);return!$.$bn(d,b)}return!0}}e.$Jn=a;function l(s,c){const{added:h,removed:w,updated:m}=r(c?.rawConfiguration,s?.rawConfiguration),I=[],k=s?.getAllOverrideIdentifiers()||[],d=c?.getAllOverrideIdentifiers()||[];if(c){const b=d.filter(y=>!k.includes(y));for(const y of b)I.push([y,c.getKeysForOverrideIdentifier(y)])}if(s){const b=k.filter(y=>!d.includes(y));for(const y of b)I.push([y,s.getKeysForOverrideIdentifier(y)])}if(c&&s){for(const b of k)if(d.includes(b)){const y=r({contents:s.getOverrideValue(void 0,b)||{},keys:s.getKeysForOverrideIdentifier(b)},{contents:c.getOverrideValue(void 0,b)||{},keys:c.getKeysForOverrideIdentifier(b)});I.push([b,[...y.added,...y.removed,...y.updated]])}}return{added:h,removed:w,updated:m,overrides:I}}function r(s,c){const h=s?c?s.keys.filter(I=>c.keys.indexOf(I)===-1):[...s.keys]:[],w=c?s?c.keys.filter(I=>s.keys.indexOf(I)===-1):[...c.keys]:[],m=[];if(s&&c){for(const I of c.keys)if(s.keys.indexOf(I)!==-1){const k=(0,A.$ui)(c.contents,I),d=(0,A.$ui)(s.contents,I);$.$bn(k,d)||m.push(I)}}return{added:h,removed:w,updated:m}}}),define(Ae[100],Re([1,0,11,4]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=e.RemoteAuthorityResolverErrorCode=e.$Uk=e.$Tk=e.RemoteConnectionType=e.$Sk=void 0,e.$Sk=(0,L.$Sh)("remoteAuthorityResolverService");var P;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class M{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Tk=M;class R{constructor(S,o){this.host=S,this.port=o,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Uk=R;var $;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class D extends E.$ab{static isNotAvailable(S){return S instanceof D&&S._code===$.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof D&&S._code===$.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof D&&S._code===$.NoResolverFound}static isInvalidAuthority(S){return S instanceof D&&S._code===$.InvalidAuthority}static isHandled(S){return S instanceof D&&S.isHandled}constructor(S,o=$.Unknown,v){super(S),this._message=S,this._code=o,this._detail=v,this.isHandled=o===$.NotAvailable&&v===!0,Object.setPrototypeOf(this,D.prototype)}}e.$Vk=D;function g(A){const S=A.indexOf("+");return S===-1?A:A.substring(0,S)}e.$Wk=g}),define(Ae[57],Re([1,0,14]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=void 0;function L(g){return g.scheme===E.Schemas.vscodeRemote?g.authority:void 0}e.$Xk=L;function P(g){if(!g)return;const A=g.indexOf("+");return A<0?g:g.substr(0,A)}e.$Yk=P;function M(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Zk=M;function R(g){const{host:A,port:S}=D(g);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:S}}e.$1k=R;function $(g,A){let{host:S,port:o}=D(g);return typeof o>"u"&&(o=A),{host:S,port:o}}e.$2k=$;function D(g){const A=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const S=g.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const o=g.match(/(.*):(\d+)$/);return o?{host:o[1],port:parseInt(o[2],10)}:{host:g,port:void 0}}}),define(Ae[22],Re([1,0,13,4,57]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.TargetPlatform=e.ExtensionType=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=void 0,e.$3l="extensions.user.cache",e.$4l="extensions.builtin.cache",e.$5l="undefined_publisher",e.$6l=["ui","workspace","web"];function M(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$7l=M,e.$8l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R||(e.ExtensionType=R={}));var $;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const n=typeof t=="string"?t:t.value,u=typeof i=="string"?i:i.value;return E.$3e(n,u)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$9l=D;class g{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(D.toKey(t))}delete(t){return this.c.delete(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}}e.$0l=g;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(D.toKey(t))}get(t){return this.c.get(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}set(t,i){this.c.set(D.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$$l=A;function S(f){return o(f)}e.$_l=S;function o(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.$am=o;function v(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.$bm=v;function p(f,t){if(t){const i=`onResolveRemoteAuthority:${(0,P.$Yk)(t)}`;return!!f.activationEvents?.includes(i)}return!1}e.$cm=p,e.$dm=(0,L.$Sh)("IBuiltinExtensionsScannerService")}),define(Ae[101],Re([1,0,11,22]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_E=e.$$E=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,$){this.a.set(R,$)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const $=Object.create(null);for(const D of R){const g=this.readActivationEvents(D);g.length>0&&($[L.$9l.toKey(D.identifier)]=g)}return $}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const $=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let D=0;D<$.length;D++)$[D]==="onUri"&&($[D]=`onUri:${L.$9l.toKey(R.identifier)}`);if(!R.contributes)return $;for(const D in R.contributes){const g=this.a.get(D);if(!g)continue;const A=R.contributes[D],S=Array.isArray(A)?A:[A];try{g(S,$)}catch(o){(0,E.$Z)(o)}}return $}}e.$$E=P,e.$_E=new P}),define(Ae[192],Re([1,0,21,74,38]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=void 0;function M(D){if(E.$u===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function R(D,g,A,S,o,v,p,f,t){const i=Object.create(null);i["common.machineId"]=v,i["common.sqmId"]=p,i.sessionID=(0,P.$fg)()+Date.now(),i.commitHash=S,i.version=o,i["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,E.$h)(E.$u),i["common.nodePlatform"]=L.$cc,i["common.nodeArch"]=A,i["common.product"]=t||"desktop",f&&(i["common.msftInternal"]=f);let n=0;const u=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),E.$l&&(i["common.snap"]="true");const a=M(g);return a&&(i["common.platformDetail"]=a),i}e.$ko=R;function $(D){const g=L.env.USERDNSDOMAIN;if(!g)return!1;const A=g.toLowerCase();return D.some(S=>A===S)}e.$lo=$}),define(Ae[193],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=void 0,e.$fl=(0,E.$Sh)("telemetryService"),e.$gl=(0,E.$Sh)("customEndpointTelemetryService"),e.$hl="telemetry.currentSessionDate",e.$il="telemetry.firstSessionDate",e.$jl="telemetry.lastSessionDate",e.$kl="telemetry.machineId",e.$ll="telemetry.sqmId",e.$ml="telemetry",e.$nl="telemetry.telemetryLevel",e.$ol="telemetry.enableCrashReporter",e.$pl="telemetry.enableTelemetry";var L;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var P;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Ae[58],Re([1,0,26,16,5,40,57,192,193]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0;class g{constructor(w){this.value=w,this.isTrustedTelemetryValue=!0}}e.$mo=g;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$no=A,e.$oo=new A;class S{async publicLog(w,m,I){}async publicLogError(w,m,I){}}e.$po=S,e.$qo="telemetry",e.$ro="extensionTelemetryLog",e.$so={log:()=>null,flush:()=>Promise.resolve(null)};function o(h,w){return P.Event.debounce(w.onDidChangeConfiguration,(I,k)=>{const d=I?new Set([...I.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:d}},1e3,!0)(I=>{I.source!==7&&h.publicLog2("updateConfiguration",{configurationSource:(0,M.$pi)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$to=o;function v(h,w){return!w.isBuilt&&!w.disableTelemetry?!0:!(w.disableTelemetry||!h.enableTelemetry)}e.$uo=v;function p(h,w){return w.extensionTestsLocationURI?!0:!(w.isBuilt||w.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}e.$vo=p;function f(h){const w=h.getValue(D.$nl),m=h.getValue(D.$ol);if(h.getValue(D.$pl)===!1||m===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$wo=f;function t(h){const w={},m={},I={};u(h,I);for(let k in I){k=k.length>150?k.substr(k.length-149):k;const d=I[k];typeof d=="number"?m[k]=d:typeof d=="boolean"?m[k]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${d.length}`),w[k]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(w[k]=d)}return{properties:w,measurements:m}}e.$xo=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(h){if(!h)return"none";const w=(0,R.$Yk)(h);return i.has(w)?w:"other"}e.$yo=n;function u(h,w,m=0,I){if(h)for(const k of Object.getOwnPropertyNames(h)){const d=h[k],b=I?I+k:k;Array.isArray(d)?w[b]=(0,E.$cn)(d):d instanceof Date?w[b]=d.toISOString():(0,L.$Bf)(d)?m<2?u(d,w,m+1,b+"."):w[b]=(0,E.$cn)(d):w[b]=d}}function a(h,w){const m=h.msftInternalDomains||[],I=w.getValue("telemetry.internalTesting");return(0,$.$lo)(m)||I}e.$zo=a;function l(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}e.$Ao=l;function r(h,w){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let m=h;const I=[];for(const y of w)for(;;){const C=y.exec(h);if(!C)break;I.push([C.index,y.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(m="";;){const y=d.exec(h);if(!y)break;const C=I.some(([B,H])=>y.index<H&&B<d.lastIndex);!k.test(y[0])&&!C&&(m+=h.substring(b,y.index)+"<REDACTED: user-file-path>",b=d.lastIndex)}return b<h.length&&(m+=h.substr(b)),m}function s(h){if(!h)return h;const w=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of w)if(m.regex.test(h))return`<REDACTED: ${m.label}>`;return h}function c(h,w){return(0,E.$_m)(h,m=>{if(m instanceof g||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let I=m.replaceAll("%20"," ");I=r(I,w);for(const k of w)I=I.replace(k,"");return I=s(I),I}})}e.$Bo=c}),define(Ae[194],Re([1,0,13,96,22,21,2,11,74,58]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0;function A(c,h){return c.uuid&&h.uuid?c.uuid===h.uuid:c.id===h.id?!0:(0,E.$Xe)(c.id,h.id)===0}e.$Co=A;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class o{static create(h){const w=h.manifest?h.manifest.version:h.version,m=h.manifest?h.targetPlatform:h.properties.targetPlatform;return new o(h.identifier,w,m)}static parse(h){const w=S.exec(h);return w&&w[1]&&w[2]?new o({id:w[1]},w[2],w[4]||void 0):null}constructor(h,w,m="undefined"){this.version=w,this.targetPlatform=m,this.id=h.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(h){return h instanceof o?A(this,h)&&this.version===h.version&&this.targetPlatform===h.targetPlatform:!1}}e.$Do=o;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(c){const h=v.exec(c);return h&&h[1]?[t(h[1]),h[2]]:[t(c),void 0]}e.$Eo=p;function f(c,h){return`${c}.${h}`}e.$Fo=f;function t(c){return c.toLowerCase()}e.$Go=t;function i(c,h){return t(f(c??P.$5l,h))}e.$Ho=i;function n(c,h){const w=[],m=I=>{for(const k of w)if(k.some(d=>A(h(d),h(I))))return k;return null};for(const I of c){const k=m(I);k?k.push(I):w.push([I])}return w}e.$Io=n;function u(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.$Jo=u;function a(c){return{id:new g.$mo(c.identifier.id),name:new g.$mo(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$Ko=a,e.$Lo=new P.$9l("pprice.better-merge");function l(c,h){const w=[],m=h.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const I=m.shift();if(I&&w.every(k=>!A(k.identifier,{id:I}))){const k=c.filter(d=>A(d.identifier,{id:I}));k.length===1&&(w.push(k[0]),m.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.$Mo=l;async function r(c,h){if(!M.$k)return!1;let w;try{w=(await c.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await c.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){h.debug("Error while getting the os-release file.",(0,$.$9)(I))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(c,h){const w=await r(c,h),m=(0,L.$9n)(w?"alpine":M.$u,D.$dc);return h.debug("ComputeTargetPlatform:",m),m}e.$No=s}),define(Ae[195],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=e.$qr=e.$pr=e.$or=e.$nr=void 0;function E(D){return[...D.entries()]}e.$nr=E;function L(D){return D?[...D.entries()]:[]}e.$or=L;function P(D){return new Map(D)}e.$pr=P;function M(D){return new Map(D??[])}e.$qr=M;function R(D){return Array.from(D.entries()).map(g=>[g[0],E(g[1].map),L(g[1].descriptionMap)])}e.$rr=R;function $(D){return new Map(D.map(g=>[g[0],{map:P(g[1]),descriptionMap:M(g[2])}]))}e.$sr=$}),define(Ae[196],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iqb=void 0;class E{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,M,R=5){const $=M(D=>{const g=typeof D=="string"?D:D.data;let A=this.a.get(P);if(A){A.data.push(g);return}const S=setTimeout(()=>this.flushBuffer(P),R);A={data:[g],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(P),$.dispose()}},this.a.set(P,A)});return $}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const M=this.a.get(P);M&&(this.a.delete(P),this.b(P,M.data.join("")))}}e.$iqb=E}),define(Ae[197],Re([1,0,12,90,45,5,16,2,155,73,30]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.IconFontDefinition=e.IconContribution=e.$8v=void 0,e.$8v={IconContribution:"base.contributions.icons"};var S;(function(a){function l(r,s){let c=r.defaults;for(;P.ThemeIcon.isThemeIcon(c);){const h=p.getIcon(c.id);if(!h)return;c=h.defaults}return c}a.getDefinition=l})(S||(e.IconContribution=S={}));var o;(function(a){function l(s){return{weight:s.weight,style:s.style,src:s.src.map(c=>({format:c.format,location:c.location.toString()}))}}a.toJSONObject=l;function r(s){const c=h=>(0,R.$zf)(h)?h:void 0;if(s&&Array.isArray(s.src)&&s.src.every(h=>(0,R.$zf)(h.format)&&(0,R.$zf)(h.location)))return{weight:c(s.weight),style:c(s.style),src:s.src.map(h=>({format:h.format,location:$.URI.parse(h.location)}))}}a.fromJSONObject=r})(o||(e.IconFontDefinition=o={}));class v{constructor(){this.a=new M.$Od,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(l,r,s,c){const h=this.b[l];if(h){if(s&&!h.description){h.description=s,this.d.properties[l].markdownDescription=`${s} $(${l})`;const I=this.e.enum.indexOf(l);I!==-1&&(this.e.enumDescriptions[I]=s),this.a.fire()}return h}const w={id:l,description:s,defaults:r,deprecationMessage:c};this.b[l]=w;const m={$ref:"#/definitions/icons"};return c&&(m.deprecationMessage=c),s&&(m.markdownDescription=`${s}: $(${l})`),this.d.properties[l]=m,this.e.enum.push(l),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:l}}deregisterIcon(l){delete this.b[l],delete this.d.properties[l];const r=this.e.enum.indexOf(l);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(l=>this.b[l])}getIcon(l){return this.b[l]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(l,r){const s=this.f[l];return s||(this.f[l]=r,this.a.fire(),r)}deregisterIconFont(l){delete this.f[l]}getIconFont(l){return this.f[l]}toString(){const l=(h,w)=>h.id.localeCompare(w.id),r=h=>{for(;P.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(h=>this.b[h]);for(const h of c.filter(w=>!!w.description).sort(l))s.push(`|<i class="${r(h)}"></i>|${h.id}|${P.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const h of c.filter(w=>!P.ThemeIcon.isThemeIcon(w.defaults)).sort(l))s.push(`|<i class="${r(h)}"></i>|${h.id}|`);return s.join(`
`)}}const p=new v;A.$jn.add(e.$8v.IconContribution,p);function f(a,l,r,s){return p.registerIcon(a,l,r,s)}e.$9v=f;function t(){return p}e.$0v=t;function i(){const a=(0,L.$Vj)();for(const l in a){const r="\\"+a[l].toString(16);p.registerIcon(l,{fontCharacter:r})}}i(),e.$$v="vscode://schemas/icons";const n=A.$jn.as(g.$kn.JSONContribution);n.registerSchema(e.$$v,p.getIconSchema());const u=new E.$7g(()=>n.notifySchemaChanged(e.$$v),200);p.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.$_v=f("widget-close",L.$Xj.close,(0,D.localize)(2,null)),e.$aw=f("goto-previous-location",L.$Xj.arrowUp,(0,D.localize)(3,null)),e.$bw=f("goto-next-location",L.$Xj.arrowDown,(0,D.localize)(4,null)),e.$cw=P.ThemeIcon.modify(L.$Xj.sync,"spin"),e.$dw=P.ThemeIcon.modify(L.$Xj.loading,"spin")}),define(Ae[198],Re([1,0,5,40,4,15]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.ProvidedOnAutoForward=e.$cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$bv=e.$av=void 0,e.$av=(0,P.$Sh)("tunnelService"),e.$bv=(0,P.$Sh)("sharedTunnelsService");var R;(function(t){t.Http="http",t.Https="https"})(R||(e.TunnelProtocol=R={}));var $;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})($||(e.TunnelPrivacyId=$={}));function D(t){return!!t.forwardPort}e.$cv=D;var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function A(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$dv=A,e.$ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(t){return e.$ev.indexOf(t)>=0}e.$fv=S,e.$gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function o(t){return e.$gv.indexOf(t)>=0}e.$hv=o;function v(t,i,n,u){if(n===1)return!1;if(n===2&&o(i)){const a=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(a?.length===4&&parseInt(a[1])>=18)return!1}return t<1024}e.$iv=v;class p{constructor(i,n,u){this.remoteAddress=i,this.localAddress=n,this.b=u,this.a=new E.$Od,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$jv=p;let f=class{constructor(i,n){this.j=i,this.k=n,this.a=new E.$Od,this.onTunnelOpened=this.a.event,this.b=new E.$Od,this.onTunnelClosed=this.b.event,this.c=new E.$Od,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],n=Array.from(this.e.values());for(const u of n){const a=Array.from(u.values());for(const l of a){const r=await l.value;r&&typeof r!="string"&&i.push(r)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:n}of i.values())await n.then(u=>typeof u!="string"?u?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,n,u,a,l){this.p(i,n,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:n,localAddress:u,privacy:a,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,n){(o(i)||S(i))&&(i=e.$ev[0]);const u=this.r(i,n);if(u)return++u.refcount,u.value}openTunnel(i,n,u,a,l,r=!1,s,c){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${u} on local port ${l}.`);const h=this.f??i;if(!h)return;if(n||(n="localhost"),a||(a=this.l),this.f&&this.i.has(u)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const w=this.s(h,n,u,a,l,r,s,c);return w?w.then(m=>{if(m){if(typeof m=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(n,u),m}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(n,u);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(m);return(m.tunnelRemoteHost!==n||m.tunnelRemotePort!==u)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&m.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),w)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const n=this.e.get(i.tunnelRemoteHost);if(n){const u=n.get(i.tunnelRemotePort);u&&(u.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,u))}}}}async o(i,n,u){if(u.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${n}.`);const a=u.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(n),a}}async closeTunnel(i,n){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${n} `);const u=this.e.get(i);if(u&&u.has(n)){const a=u.get(n);a.refcount=0,await this.o(i,n,a)}}p(i,n,u){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(n,{refcount:1,value:u})}async q(i,n){const u=this.e.get(i);if(u){const a=u.get(n),l=a?await a.value:void 0;(!l||typeof l=="string")&&u.delete(n),u.size===0&&this.e.delete(i)}}r(i,n){const u=[i];S(i)?(u.push(...e.$ev),u.push(...e.$gv)):o(i)&&u.push(...e.$gv);const a=u.map(l=>this.e.get(l));for(const l of a){const r=l?.get(n);if(r)return r}}canTunnel(i){return!!A(i)}t(i,n,u,a,l,r,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${u} on local port ${a}.`);const c=u;this.i.add(c);const h=a===void 0?u:a,w={elevationRequired:l?this.isPortPrivileged(h):!1},m={remoteAddress:{host:n,port:u},localAddressPort:a,privacy:r,public:r?r!==$.Private:void 0,protocol:s},I=i.forwardPort(m,w);return I?(this.p(n,u,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(c)})):this.i.delete(c),I}};e.$kv=f,e.$kv=f=Ke([Ve(0,M.$aj),Ve(1,L.$mi)],f)}),define(Ae[199],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$lv=void 0,e.$lv=(0,E.$Sh)("editSessionIdentityService");var L;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(Ae[200],Re([1,0,14]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=void 0;function L(D){return D.scheme!==E.Schemas.file&&D.scheme!==E.Schemas.vscodeRemote}e.$1J=L;function P(D){if(D.folders.length)return D.folders.every(g=>L(g.uri))?D.folders[0].uri:void 0;if(D.configuration&&L(D.configuration))return D.configuration}e.$2J=P;function M(D){return P(D)?.scheme}e.$3J=M;function R(D){return P(D)?.authority}e.$4J=R;function $(D){return P(D)!==void 0}e.$5J=$}),define(Ae[47],Re([1,0,156,19,51,25,2,4,14]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.WorkbenchState=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=void 0,e.$2h=(0,$.$Sh)("contextService");function g(h){const w=h;return typeof w?.id=="string"&&R.URI.isUri(w.uri)}e.$3h=g;function A(h){return typeof h?.id=="string"&&!g(h)&&!o(h)}e.$4h=A,e.$5h={id:"ext-dev"},e.$6h={id:"empty-window"};function S(h,w){if(typeof h=="string"||typeof h>"u")return typeof h=="string"?{id:(0,L.$mc)(h)}:w?e.$5h:e.$6h;const m=h;return m.configuration?{id:m.id,configPath:m.configuration}:m.folders.length===1?{id:m.id,uri:m.folders[0].uri}:{id:m.id}}e.$7h=S;function o(h){const w=h;return typeof w?.id=="string"&&R.URI.isUri(w.configPath)}e.$8h=o;function v(h){const w=h;if(w?.uri)return{id:w.id,uri:R.URI.revive(w.uri)};const m=h;if(m?.configPath)return{id:m.id,configPath:R.URI.revive(m.configPath)};if(h?.id)return{id:h.id}}e.$9h=v;var p;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function f(h){const w=h;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.$0h=f;function t(h){const w=h;return!!(w&&typeof w=="object"&&R.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.$$h=t;class i{constructor(w,m,I,k,d){this.h=w,this.j=I,this.k=k,this.l=d,this.c=P.$Yh.forUris(this.l,()=>!0),this.folders=m}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=P.$Yh.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$_h=i;class n{constructor(w,m){this.raw=m,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,M.$wg)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ai=n;function u(h){return new n({uri:h,index:0,name:(0,M.$sg)(h)},{uri:h.toString()})}e.$bi=u,e.$ci="code-workspace",e.$di=`.${e.$ci}`,e.$ei=[{name:(0,E.localize)(0,null),extensions:[e.$ci]}],e.$fi="workspace.json";function a(h,w){return M.$ng.isEqualOrParent(h,w.untitledWorkspacesHome)}e.$gi=a;function l(h){let w;return R.URI.isUri(h)?w=h:w=h.configuration,w?.scheme===D.Schemas.tmp}e.$hi=l,e.$ii="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(h){return h.id===e.$ii}e.$ji=r;function s(h,w){return!a(h,w)&&!l(h)}e.$ki=s;function c(h){return(typeof h=="string"?(0,L.$nc)(h):(0,M.$ug)(h))===e.$di}e.$li=c}),define(Ae[75],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;class E{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const M=this.c++;return this.b.set(M,P),this.e(),M}get(P,M){return this.b.has(P)?this.b.get(P)[M]:void 0}delete(P){this.b.delete(P),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$0cc=E}),define(Ae[42],Re([1,0,14,25,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.$_cc=void 0;class M{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new L.$lg($=>{const D=this.b.get($.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos($,D){D===null?this.b.delete($.scheme):this.b.set($.scheme,D)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$_cc=M,e.$adc=(0,P.$Sh)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=void 0,e.$MM=(0,E.$Sh)("IExtHostInitDataService")}),define(Ae[201],Re([1,0,162,15,188,27]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=void 0;let R=class extends P.$TN{constructor(D,g,A){const S=A.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",o=A.remote.isRemote?(0,E.localize)(0,null):D?(0,E.localize)(1,null):(0,E.localize)(2,null);super(g.createLogger(S,{name:o}))}};e.$ifc=R,e.$ifc=R=Ke([Ve(1,L.$bj),Ve(2,M.$MM)],R)}),define(Ae[202],Re([1,0,12]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=e.$Cdc=void 0;class L{constructor(R,$,D){this.h=new Map,this.a=R,this.b=$,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new E.$7g(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of g.values())A.complete()}catch(A){for(const S of g.values())S.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,$){let D=this.f[R];return typeof D>"u"&&(D=$),D}update(R,$){this.f[R]=$;const D=this.h.get(R);if(D!==void 0)return D.p;const g=new E.$fh;return this.h.set(R,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$Cdc=L;class P extends L{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,$){super(R.identifier.value,!0,$),this.j=R}}e.$Ddc=P}),define(Ae[203],Re([1,0,5,2]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=void 0;class P{constructor(R){this.c=R,this.a=new E.$Od,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Od,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,$,D,g){const S=this.c.getNotebookDocument(L.URI.revive(R)).acceptModelChanged($.value,D,g);this.b.fire(S)}$acceptDirtyStateChanged(R,$){this.c.getNotebookDocument(L.URI.revive(R)).acceptDirty($)}$acceptModelSaved(R){const $=this.c.getNotebookDocument(L.URI.revive(R));this.a.fire($.apiNotebook)}}e.$2ec=P}),define(Ae[17],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=void 0,e.$wM=(0,E.$Sh)("IExtHostRpcService");class L{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$xM=L}),define(Ae[204],Re([1,0,22,5]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class P{#e;constructor(R,$){this.b=new L.$Od,this.onDidChange=this.b.event,this.a=E.$9l.toKey(R.identifier),this.#e=$,this.#e.onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(R){return this.#e.get(this.a,R)}store(R,$){return this.#e.store(this.a,R,$)}delete(R){return this.#e.delete(this.a,R)}}e.$Odc=P}),define(Ae[59],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=e.$kdc=void 0,e.$kdc=(0,E.$Sh)("IURITransformerService");class L{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$ldc=L}),define(Ae[205],Re([1,0,24]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdb=e.$bdb=void 0;class L{constructor(){this.buffers=[]}add(D){let g=this.buffers.indexOf(D);return g<0&&(g=this.buffers.length,this.buffers.push(D)),g}}function P($,D){if(D.serializeBuffersForPostMessage){const g=new L,S=JSON.stringify($,(v,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(p)};if(ArrayBuffer.isView(p)){const f=M(p);if(f)return{$$vscode_array_buffer_reference$$:!0,index:g.add(p.buffer),view:{type:f,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),o=g.buffers.map(v=>{const p=new Uint8Array(v);return E.$ce.wrap(p)});return{message:S,buffers:o}}else return{message:JSON.stringify($),buffers:[]}}e.$bdb=P;function M($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R($,D){const g=D.map(o=>{const v=new ArrayBuffer(o.byteLength);return new Uint8Array(v).set(o.buffer),v}),A=D.length?(o,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const p=v,{index:f}=p,t=g[f];if(p.view)switch(p.view.type){case 1:return new Int8Array(t,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return v}:void 0;return{message:JSON.parse($,A),arrayBuffers:g}}e.$cdb=R}),define(Ae[102],Re([1,0,172,16,2,6,4,30,41,14,39,134,31]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wE=e.$vE=e.$uE=e.EditorsOrder=e.$tE=e.CloseDirection=e.$sE=e.$rE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$qE=e.$pE=e.$oE=e.$nE=e.$mE=e.$lE=e.$kE=e.$jE=e.EditorInputCapabilities=e.$iE=e.SaveReason=e.Verbosity=e.$hE=e.$gE=e.$fE=e.$eE=e.$dE=e.$cE=e.$bE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$aE=e.$_D=e.$$D=e.$0D=e.$9D=void 0,e.$9D={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$0D={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$$D="workbench.editor.sidebysideEditor",e.$_D="workbench.editors.textDiffEditor",e.$aE="workbench.editors.binaryResourceDiffEditor";var v;(function(re){re[re.PROGRAMMATIC=1]="PROGRAMMATIC",re[re.USER=2]="USER",re[re.EDIT=3]="EDIT",re[re.NAVIGATION=4]="NAVIGATION",re[re.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var p;(function(re){re[re.IDENTICAL=1]="IDENTICAL",re[re.SIMILAR=2]="SIMILAR",re[re.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function f(re){const pe=re;return!!pe&&typeof pe.getSelection=="function"&&!!pe.onDidChangeSelection}e.$bE=f;function t(re,pe,_){for(const W of _.visibleEditorPanes)if(W.group.id===pe&&re.matches(W.input))return W.getViewState()}e.$cE=t;function i(re){if(m(re))return!1;const pe=re;return P.URI.isUri(pe?.resource)}e.$dE=i;function n(re){if(m(re))return!1;const pe=re;return pe?.original!==void 0&&pe.modified!==void 0}e.$eE=n;function u(re){if(m(re)||n(re))return!1;const pe=re;return pe?.primary!==void 0&&pe.secondary!==void 0}e.$fE=u;function a(re){if(m(re))return!1;const pe=re;return pe?pe.resource===void 0||pe.resource.scheme===g.Schemas.untitled||pe.forceUntitled===!0:!1}e.$gE=a;function l(re){if(m(re))return!1;const pe=re;return P.URI.isUri(pe?.base?.resource)&&P.URI.isUri(pe?.input1?.resource)&&P.URI.isUri(pe?.input2?.resource)&&P.URI.isUri(pe?.result?.resource)}e.$hE=l;var r;(function(re){re[re.SHORT=0]="SHORT",re[re.MEDIUM=1]="MEDIUM",re[re.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var s;(function(re){re[re.EXPLICIT=1]="EXPLICIT",re[re.AUTO=2]="AUTO",re[re.FOCUS_CHANGE=3]="FOCUS_CHANGE",re[re.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class c{constructor(){this.a=new Map}registerSource(pe,_){let W=this.a.get(pe);return W||(W={source:pe,label:_},this.a.set(pe,W)),W.source}getSourceLabel(pe){return this.a.get(pe)?.label??pe}}e.$iE=new c;var h;(function(re){re[re.None=0]="None",re[re.Readonly=2]="Readonly",re[re.Untitled=4]="Untitled",re[re.Singleton=8]="Singleton",re[re.RequiresTrust=16]="RequiresTrust",re[re.CanSplitInGroup=32]="CanSplitInGroup",re[re.ForceDescription=64]="ForceDescription",re[re.CanDropIntoEditor=128]="CanDropIntoEditor",re[re.MultipleEditors=256]="MultipleEditors",re[re.Scratchpad=512]="Scratchpad",re[re.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(h||(e.EditorInputCapabilities=h={}));class w extends M.$Rc{}e.$jE=w;function m(re){return re instanceof w}e.$kE=m;function I(re){const pe=re;return P.URI.isUri(pe?.preferredResource)}function k(re){const pe=re;return m(pe?.primary)&&m(pe?.secondary)}e.$lE=k;function d(re){const pe=re;return m(pe?.modified)&&m(pe?.original)}e.$mE=d;function b(re,pe,_,W,ce){return ne(W,[(0,S.$Ci)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const be={..._,limits:{size:Number.MAX_VALUE}};re.openEditor(pe,be)}}),(0,S.$Ci)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>ce.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:o.default.Warning})}e.$nE=b;function y(re){return m(re?.editor)}e.$oE=y;function C(re){const pe=re;return y(re)&&pe?.group!==void 0}e.$pE=C;function B(re){const pe=re;return typeof pe?.groupId=="number"&&m(pe.editor)}e.$qE=B;var H;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.REPLACE=1]="REPLACE",re[re.MOVE=2]="MOVE",re[re.UNPIN=3]="UNPIN"})(H||(e.EditorCloseContext=H={}));var U;(function(re){re[re.GROUP_ACTIVE=0]="GROUP_ACTIVE",re[re.GROUP_INDEX=1]="GROUP_INDEX",re[re.GROUP_LABEL=2]="GROUP_LABEL",re[re.GROUP_LOCKED=3]="GROUP_LOCKED",re[re.EDITOR_OPEN=4]="EDITOR_OPEN",re[re.EDITOR_CLOSE=5]="EDITOR_CLOSE",re[re.EDITOR_MOVE=6]="EDITOR_MOVE",re[re.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",re[re.EDITOR_LABEL=8]="EDITOR_LABEL",re[re.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",re[re.EDITOR_PIN=10]="EDITOR_PIN",re[re.EDITOR_STICKY=11]="EDITOR_STICKY",re[re.EDITOR_DIRTY=12]="EDITOR_DIRTY",re[re.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var z;(function(re){re[re.PRIMARY=1]="PRIMARY",re[re.SECONDARY=2]="SECONDARY",re[re.BOTH=3]="BOTH",re[re.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class F{getOriginalUri(pe,_){if(!pe)return;if(l(pe))return e.$sE.getOriginalUri(pe.result,_);if(_?.supportSideBySide){const{primary:ce,secondary:be}=this.a(pe);if(ce&&be){if(_?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(ce,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(be,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===z.ANY)return this.getOriginalUri(ce,{filterByScheme:_.filterByScheme})??this.getOriginalUri(be,{filterByScheme:_.filterByScheme});pe=_.supportSideBySide===z.PRIMARY?ce:be}}if(n(pe)||u(pe)||l(pe))return;const W=I(pe)?pe.preferredResource:pe.resource;return!W||!_||!_.filterByScheme?W:this.b(W,_.filterByScheme)}a(pe){return k(pe)||u(pe)?{primary:pe.primary,secondary:pe.secondary}:d(pe)||n(pe)?{primary:pe.modified,secondary:pe.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(pe,_){if(!pe)return;if(l(pe))return e.$sE.getCanonicalUri(pe.result,_);if(_?.supportSideBySide){const{primary:ce,secondary:be}=this.a(pe);if(ce&&be){if(_?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(ce,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(be,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===z.ANY)return this.getCanonicalUri(ce,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(be,{filterByScheme:_.filterByScheme});pe=_.supportSideBySide===z.PRIMARY?ce:be}}if(n(pe)||u(pe)||l(pe))return;const W=pe.resource;return!W||!_||!_.filterByScheme?W:this.b(W,_.filterByScheme)}b(pe,_){if(Array.isArray(_)){if(_.some(W=>pe.scheme===W))return pe}else if(_===pe.scheme)return pe}}var N;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.KEYBOARD=1]="KEYBOARD",re[re.MOUSE=2]="MOUSE"})(N||(e.EditorCloseMethod=N={}));function X(re,pe,_,W){if(!re.isSticky(pe))return!1;switch(W.preventPinnedEditorClose){case"keyboardAndMouse":return _===N.MOUSE||_===N.KEYBOARD;case"mouse":return _===N.MOUSE;case"keyboard":return _===N.KEYBOARD}return!1}e.$rE=X,e.$sE=new F;var Q;(function(re){re[re.LEFT=0]="LEFT",re[re.RIGHT=1]="RIGHT"})(Q||(e.CloseDirection=Q={}));class De{constructor(){this.c=new Map,this.d=new Map}start(pe){const _=this.a=pe.get(R.$Rh);for(const[W,ce]of this.c)this.e(W,ce,_);this.c.clear()}e(pe,_,W){const ce=W.createInstance(_);this.d.set(pe,ce)}registerFileEditorFactory(pe){if(this.b)throw new Error("Can only register one file editor factory.");this.b=pe}getFileEditorFactory(){return(0,L.$Kf)(this.b)}registerEditorSerializer(pe,_){if(this.c.has(pe)||this.d.has(pe))throw new Error(`A editor serializer with type ID '${pe}' was already registered.`);return this.a?this.e(pe,_,this.a):this.c.set(pe,_),(0,M.$Pc)(()=>{this.c.delete(pe),this.d.delete(pe)})}getEditorSerializer(pe){return this.d.get(typeof pe=="string"?pe:pe.typeId)}}$.$jn.add(e.$9D.EditorFactory,new De);async function ke(re,pe,_){return!re||!re.length?[]:await Promise.all(re.map(async W=>{const ce=P.URI.revive(W.fileUri);if(!ce){_.info("Cannot resolve the path because it is not valid.",W);return}if(!await pe.canHandleResource(ce)){_.info("Cannot resolve the path because it cannot be handled",W);return}let se=W.exists,he=W.type;if(typeof se!="boolean"||typeof he!="number")try{he=(await pe.stat(ce)).isDirectory?D.FileType.Directory:D.FileType.Unknown,se=!0}catch(ye){_.error(ye),se=!1}if(!se&&W.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",W);return}if(he===D.FileType.Directory){_.info("Cannot resolve the path because it is a directory",W);return}const ue={...W.options,pinned:!0};return se?{resource:ce,options:ue}:{resource:ce,options:ue,forceUntitled:!0}}))}e.$tE=ke;var Pe;(function(re){re[re.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",re[re.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function fe(re){const pe=re;if(!pe)return!1;const _=pe;if(_.modified)return fe(_.modified);const W=pe;return!!(W.contributionsState&&W.viewState&&Array.isArray(W.cursorState))}e.$uE=fe;function we(re){return(0,A.$Ei)(re)}e.$vE=we;function ne(re,pe,_){const W=(0,A.$Fi)(re,pe);return W.forceMessage=_?.forceMessage,W.forceSeverity=_?.forceSeverity,W.allowDialog=_?.allowDialog,W}e.$wE=ne}),define(Ae[206],Re([1,0,5,173,4,6,28,30,18,26,90,197]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FE=e.$EE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$DE=e.$CE=e.ViewContentGroups=e.$BE=e.$AE=e.ViewContainerLocation=e.Extensions=e.$zE=e.$yE=e.$xE=void 0,e.$xE="views",e.$yE=(0,L.localize)(0,null),e.$zE=(0,S.$9v)("default-view-icon",A.$Xj.window,(0,L.localize)(1,null));var o;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(o||(e.Extensions=o={}));var v;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$AE=[0,1,2];function p(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$BE=p;class f extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Od),this.onDidRegister=this.c.event,this.f=this.B(new E.$Od),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.$Qb)([...this.g.values()])}registerViewContainer(c,h,w){const m=this.get(c.id);if(m)return m;const I=c;return I.openCommandActionDescriptor=w?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,R.$wc)(this.g,h,[]).push(I),w?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:h}),I}deregisterViewContainer(c){for(const h of this.g.keys()){const w=this.g.get(h),m=w?.indexOf(c);if(m!==-1){w?.splice(m,1),w.length===0&&this.g.delete(h),this.f.fire({viewContainer:c,viewContainerLocation:h});return}}}get(c){return this.all.filter(h=>h.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(h=>this.getViewContainers(h).filter(w=>w?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(h=>this.getViewContainerLocation(h)===c)}}$.$jn.add(o.ViewContainersRegistry,new f);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(s,c){const h=s.group??t.More,w=c.group??t.More;return h!==w?h.localeCompare(w):(s.order??5)-(c.order??5)}class n extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Od),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Od),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Od),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Od),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Fc}registerViews(c,h){this.registerViews2([{views:c,viewContainer:h}])}registerViews2(c){c.forEach(({views:h,viewContainer:w})=>this.r(h,w)),this.c.fire(c)}deregisterViews(c,h){const w=this.s(c,h);w.length&&this.f.fire({views:w,viewContainer:h})}moveViews(c,h){for(const w of this.m.keys())if(w!==h){const m=this.s(c,w);m.length&&(this.r(m,h),this.g.fire({views:m,from:w,to:h}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const h of this.j){const w=(this.m.get(h)||[]).filter(m=>m.id===c)[0];if(w)return w}return null}getViewContainer(c){for(const h of this.j)if((this.m.get(h)||[]).filter(m=>m.id===c)[0])return h;return null}registerViewWelcomeContent(c,h){return this.n.add(c,h),this.h.fire(c),(0,M.$Pc)(()=>{this.n.delete(c,h),this.h.fire(c)})}registerViewWelcomeContent2(c,h){const w=new Map;for(const[m,I]of h)this.n.add(c,I),w.set(m,(0,M.$Pc)(()=>{this.n.delete(c,I),this.h.fire(c)}));return this.h.fire(c),w}getViewWelcomeContent(c){const h=[];return this.n.forEach(c,w=>h.push(w)),h.sort(i)}r(c,h){let w=this.m.get(h);w||(w=[],this.m.set(h,w),this.j.push(h));for(const m of c){if(this.getView(m.id)!==null)throw new Error((0,L.localize)(2,null,m.id));w.push(m)}}s(c,h){const w=this.m.get(h);if(!w)return[];const m=[],I=[];for(const k of w)c.includes(k)?m.push(k):I.push(k);return m.length&&(I.length?this.m.set(h,I):(this.m.delete(h),this.j.splice(this.j.indexOf(h),1))),m}}$.$jn.add(o.ViewsRegistry,new n),e.$CE=(0,P.$Sh)("viewsService"),e.$DE=(0,P.$Sh)("viewDescriptorService");var u;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(u||(e.ViewVisibilityState=u={}));var a;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class l{constructor(c,h){this.c=!1,this.d=!1,(0,g.$an)(this,c),this.d=!!h,this.resolve=async w=>{if(h&&!this.c){const m=await h(w);m&&(this.tooltip=this.tooltip??m.tooltip,this.command=this.command??m.command)}w.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$EE=l;class r extends Error{constructor(c){super((0,L.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$FE=r}),define(Ae[207],Re([1,0,2,29,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8E=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$7E=e.$6E=void 0;function M(g){return!!g&&typeof g=="object"&&"uri"in g&&g.uri instanceof E.URI&&"version"in g&&typeof g.version=="number"&&"ranges"in g&&Array.isArray(g.ranges)&&g.ranges.every(L.$ws.isIRange)}e.$6E=M;function R(g){return!!g&&typeof g=="object"&&"documents"in g&&Array.isArray(g.documents)&&g.documents.every(M)}e.$7E=R;var $;(function(g){g[g.Down=0]="Down",g[g.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var D;(function(g){g[g.Action=1]="Action",g[g.Toolbar=2]="Toolbar"})(D||(e.InteractiveSessionCopyKind=D={})),e.$8E=(0,P.$Sh)("IChatService")}),define(Ae[208],Re([1,0,5,12,174]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new E.$Od,this.n=new E.$Od,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,D,g,A){const S={command:$};if(D&&Object.keys(D).length>0&&(S.arguments=D),this.s("request",S),typeof A=="number"){const o=setTimeout(()=>{clearTimeout(o);const v=this.f.get(S.seq);if(v){this.f.delete(S.seq);const p={type:"response",seq:0,request_seq:S.seq,success:!1,command:$,message:(0,P.localize)(0,null,A,$)};v(p)}},A)}return g&&this.f.set(S.seq,g),S.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,D){return $.type!=="event"||D.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,L.$Vg)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const D=$,g=this.f.get(D.request_seq);g&&(this.f.delete(D.request_seq),g(D));break}}}}s($,D){D.type=$,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((D,g)=>$.set(g,D)),await(0,L.$Vg)(500),$.forEach((D,g)=>{D({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Hdb=M}),define(Ae[209],Re([1,0,175,34,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$iH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$hH=e.MemoryRangeType=e.$gH=e.State=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=void 0,e.$dG="workbench.view.debug",e.$eG="workbench.debug.variablesView",e.$fG="workbench.debug.watchExpressionsView",e.$gG="workbench.debug.callStackView",e.$hG="workbench.debug.loadedScriptsView",e.$iG="workbench.debug.breakPointsView",e.$jG="workbench.debug.disassemblyView",e.$kG="workbench.panel.repl",e.$lG="workbench.panel.repl.view",e.$mG=new L.$0i("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$nG=new L.$0i("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$oG=new L.$0i("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$pG="debugUx",e.$qG=new L.$0i(e.$pG,"default",{type:"string",description:E.localize(3,null)}),e.$rG=new L.$0i("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$sG=new L.$0i("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$tG=new L.$0i("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$uG=new L.$0i("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$vG=new L.$0i("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$wG=new L.$0i("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$xG=new L.$0i("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$yG=new L.$0i("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$zG=new L.$0i("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$AG=new L.$0i("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$BG=new L.$0i("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$CG=new L.$0i("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$DG=new L.$0i("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$EG=new L.$0i("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$FG=new L.$0i("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$GG=new L.$0i("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$HG=new L.$0i("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$IG=new L.$0i("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$JG=new L.$0i("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$KG=new L.$0i("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$LG=new L.$0i("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$MG=new L.$0i("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$NG=new L.$0i("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$OG=new L.$0i("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$PG=new L.$0i("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$QG=new L.$0i("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$RG=new L.$0i("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$SG=new L.$0i("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$TG=new L.$0i("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$UG=new L.$0i("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$VG=new L.$0i("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$WG=new L.$0i("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$XG=new L.$0i("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$YG=new L.$0i("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$ZG=new L.$0i("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$1G=new L.$0i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$2G=new L.$0i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$3G=new L.$0i("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$4G=new L.$0i("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$5G=new L.$0i("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$6G=new L.$0i("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$7G=new L.$0i("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$8G=new L.$0i("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$9G=new L.$0i("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$0G=new L.$0i("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$$G=new L.$0i("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$_G=new L.$0i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$aH=new L.$0i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const M=o=>E.localize(52,null,o);e.$bH=M,e.$cH="editor.contrib.debug",e.$dH="editor.contrib.breakpoint",e.$eH="debug",e.$fH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var R;(function(o){o[o.Inactive=0]="Inactive",o[o.Initializing=1]="Initializing",o[o.Stopped=2]="Stopped",o[o.Running=3]="Running"})(R||(e.State=R={}));function $(o){switch(o){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$gH=$;var D;(function(o){o[o.Valid=0]="Valid",o[o.Unreadable=1]="Unreadable",o[o.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$hH="vscode-debug-memory";var g;(function(o){o[o.Initial=1]="Initial",o[o.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var A;(function(o){o.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$iH=(0,P.$Sh)("debugService");var S;(function(o){o[o.CONDITION=0]="CONDITION",o[o.HIT_COUNT=1]="HIT_COUNT",o[o.LOG_MESSAGE=2]="LOG_MESSAGE"})(S||(e.BreakpointWidgetContext=S={}))}),define(Ae[210],Re([1,0,13,2,19,26,14,29,20,18]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.$IF=e.$HF=e.$GF=e.$FF=e.$EF=void 0;const A=/{([^}]+)}/g;function S(k,d,b){return k.replace(A,function(y,C){return d&&C.length>0&&C[0]!=="_"?y:b&&b.hasOwnProperty(C)?b[C]:y})}e.$EF=S;function o(k){const d={};for(const b of Object.keys(k))b.startsWith("!")||(d[b]=k[b]);return d}e.$FF=o;function v(k){return k.configuration.request==="attach"&&!p(k)&&(!k.parentSession||v(k.parentSession))}e.$GF=v;function p(k){let d=k.configuration.type;if(d)return d==="vslsShare"&&(d=k.configuration.adapterProxy.configuration.type),(0,E.$3e)(d,"extensionhost")||(0,E.$3e)(d,"pwa-extensionhost")?k:k.parentSession?p(k.parentSession):void 0}e.$HF=p;function f(k){return k.type&&(k.label||k.program||k.runtime)}e.$IF=f;function t(k,d,b){let y,C=0;const B=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let H=null;for(;H=B.exec(k);){const U=H.index+1,z=U+H[0].length;if(U<=d&&z>=b){y=H[0],C=U;break}}if(y){const U=/\w+/g;let z=null;for(;(z=U.exec(y))&&!(z.index+1+C+z[0].length>=b););z&&(y=y.substring(0,U.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}e.$JF=t;async function i(k,d,b,y){if(k.evaluatableExpressionProvider.has(d)){const C=k.evaluatableExpressionProvider.ordered(d),B=(0,g.$Gb)(await Promise.all(C.map(async H=>{try{return await H.provideEvaluatableExpression(d,b,y??D.CancellationToken.None)}catch{return}})));if(B.length>0){let H=B[0].expression;const U=B[0].range;return H||(H=d.getLineContent(b.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:H}}}else{const C=d.getLineContent(b.lineNumber),{start:B,end:H}=t(C,b.column,b.column),U=C.substring(B-1,H);return{matchingExpression:U,range:new $.$ws(b.lineNumber,B,b.lineNumber,B+U.length)}}return null}e.$KF=i;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(k){return!!(k&&k.match(n))}e.$LF=u;function a(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(u(k.path))return L.URI.parse(k.path);if((0,P.$hc)(k.path))return L.URI.file(k.path)}return k.path}function l(k){if(typeof k.path=="object"){const d=L.URI.revive(k.path);if(d)return d.scheme===R.Schemas.file?d.fsPath:d.toString()}return k.path}function r(k,d){const b=d?a:l,y=(0,M.$0m)(k);return c(y,(C,B)=>{C&&B&&(B.path=b(B))}),y}e.$MF=r;function s(k,d){const b=d?a:l,y=(0,M.$0m)(k);return c(y,(C,B)=>{!C&&B&&(B.path=b(B))}),y}e.$NF=s;function c(k,d){switch(k.type){case"event":{const b=k;switch(b.event){case"output":d(!1,b.body.source);break;case"loadedSource":d(!1,b.body.source);break;case"breakpoint":d(!1,b.body.breakpoint.source);break;default:break}break}case"request":{const b=k;switch(b.command){case"setBreakpoints":d(!0,b.arguments.source);break;case"breakpointLocations":d(!0,b.arguments.source);break;case"source":d(!0,b.arguments.source);break;case"gotoTargets":d(!0,b.arguments.source);break;case"launchVSCode":b.arguments.args.forEach(y=>d(!1,y));break;default:break}break}case"response":{const b=k;if(b.success&&b.body)switch(b.command){case"stackTrace":b.body.stackFrames.forEach(y=>d(!1,y.source));break;case"loadedSources":b.body.sources.forEach(y=>d(!1,y));break;case"scopes":b.body.scopes.forEach(y=>d(!1,y.source));break;case"setFunctionBreakpoints":b.body.breakpoints.forEach(y=>d(!1,y.source));break;case"setBreakpoints":b.body.breakpoints.forEach(y=>d(!1,y.source));break;case"disassemble":b.body?.instructions.forEach(C=>d(!1,C.location));break;default:break}break}}}function h(k){return k.filter(d=>!d.presentation?.hidden).sort((d,b)=>d.presentation?b.presentation?d.presentation.group?b.presentation.group?d.presentation.group!==b.presentation.group?d.presentation.group.localeCompare(b.presentation.group):w(d.presentation.order,b.presentation.order):-1:b.presentation.group?1:w(d.presentation.order,b.presentation.order):-1:b.presentation?1:0)}e.$OF=h;function w(k,d){return typeof k!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:k-d}async function m(k,d){const b=k.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(b!=="none"&&(await d.saveAll(),b==="allEditorsInActiveGroup")){const y=d.activeEditorPane;y&&y.input.resource?.scheme===R.Schemas.untitled&&await d.save({editor:y.input,groupId:y.group.id})}await k.reloadConfiguration()}e.$PF=m;const I=(k,d)=>!k||!d?k===d:k.name===d.name&&k.path===d.path&&k.sourceReference===d.sourceReference;e.$QF=I}),define(Ae[76],Re([1,0,24,33,68,69,14,19,21,34]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BI=e.$AI=e.$zI=e.$yI=e.CellStatusbarAlignment=e.$xI=e.$wI=e.$vI=e.NotebookEditorPriority=e.$uI=e.$tI=e.$sI=e.$rI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$qI=e.$pI=e.$oI=e.$nI=e.CellKind=e.$mI=e.$lI=e.$kI=void 0,e.$kI="workbench.editor.notebook",e.$lI="workbench.editor.notebookTextDiffEditor",e.$mI="workbench.editor.interactive";var A;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(A||(e.CellKind=A={})),e.$nI=["application/json","application/javascript","text/html","image/svg+xml",M.$Sr.latex,M.$Sr.markdown,"image/png","image/jpeg",M.$Sr.text],e.$oI=[M.$Sr.latex,M.$Sr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Sr.text],e.$pI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$qI="_notAvailable";var S;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(S||(e.NotebookRunState=S={}));var o;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(o||(e.NotebookCellExecutionState=o={}));var v;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var p;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var f;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var u;(function(N){N.scheme=R.Schemas.vscodeNotebookCell;const X=["W","X","Y","Z","a","b","c","d","e","f"],Q=new RegExp(`^[${X.join("")}]+`),De=7;function ke(pe,_){const W=_.toString(De),be=`${W.length<X.length?X[W.length-1]:"z"}${W}s${(0,E.$we)(E.$ce.fromString(pe.scheme),!0,!0)}`;return pe.with({scheme:N.scheme,fragment:be})}N.generate=ke;function Pe(pe){if(pe.scheme!==N.scheme)return;const _=pe.fragment.indexOf("s");if(_<0)return;const W=parseInt(pe.fragment.substring(0,_).replace(Q,""),De),ce=(0,E.$ve)(pe.fragment.substring(_+1)).toString();if(!isNaN(W))return{handle:W,notebook:pe.with({scheme:ce,fragment:null})}}N.parse=Pe;function fe(pe,_){return pe.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${_??""},${pe.scheme!==R.Schemas.file?pe.scheme:""}`})}N.generateCellOutputUri=fe;function we(pe){if(pe.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const _=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(pe.fragment);if(!_)return;const W=_[1]&&_[1]!==""?_[1]:void 0,ce=_[2];return{outputId:W,notebook:pe.with({scheme:ce||R.Schemas.file,fragment:null})}}N.parseCellOutputUri=we;function ne(pe,_,W){return N.generate(pe,_).with({scheme:W})}N.generateCellPropertyUri=ne;function re(pe,_){if(pe.scheme===_)return N.parse(pe.with({scheme:N.scheme}))}N.parseCellPropertyUri=re})(u||(e.CellUri=u={}));const a=N=>D.$i?N.replace(/\//g,"\\"):N;class l{constructor(X=[],Q=e.$nI){this.e=Q,this.d=[...new Set(X)].map(De=>({pattern:De,matches:L.$zj(a(De))}))}sort(X){const Q=new Map(P.Iterable.map(X,ke=>[ke,a(ke)]));let De=[];for(const{matches:ke}of this.d)for(const[Pe,fe]of Q)if(ke(fe)){De.push(Pe),Q.delete(Pe);break}return Q.size&&(De=De.concat([...Q.keys()].sort((ke,Pe)=>this.e.indexOf(ke)-this.e.indexOf(Pe)))),De}prioritize(X,Q){const De=this.f(X);if(De===-1){this.d.unshift({pattern:X,matches:L.$zj(a(X))});return}const ke=new Set(Q.map(fe=>this.f(fe,De)));ke.delete(-1);const Pe=Array.from(ke).sort();this.d.splice(De+1,0,...Pe.map(fe=>this.d[fe]));for(let fe=Pe.length-1;fe>=0;fe--)this.d.splice(Pe[fe],1)}toArray(){return this.d.map(X=>X.pattern)}f(X,Q=this.d.length){const De=a(X);for(let ke=0;ke<Q;ke++)if(this.d[ke].matches(De))return ke;return-1}}e.$rI=l;function r(N,X,Q,De=(ke,Pe)=>ke===Pe){const ke=[];function Pe(ne,re,pe){if(re===0&&pe.length===0)return;const _=ke[ke.length-1];_&&_.start+_.deleteCount===ne?(_.deleteCount+=re,_.toInsert.push(...pe)):ke.push({start:ne,deleteCount:re,toInsert:pe})}let fe=0,we=0;for(;;){if(fe===N.length){Pe(fe,0,X.slice(we));break}if(we===X.length){Pe(fe,N.length-fe,[]);break}const ne=N[fe],re=X[we];if(De(ne,re)){fe+=1,we+=1;continue}Q(re)?(Pe(fe,1,[]),fe+=1):(Pe(fe,0,[re]),we+=1)}return ke}e.$sI=r,e.$tI=new g.$0i("notebookEditorCursorAtBoundary","none"),e.$uI=new g.$0i("notebookEditorCursorAtLineBoundary","none");var s;(function(N){N.default="default",N.option="option"})(s||(e.NotebookEditorPriority=s={}));function c(N){const X=N;return!!((typeof X.include=="string"||L.$Aj(X.include))&&(typeof X.exclude=="string"||L.$Aj(X.exclude)))}e.$vI=c;function h(N,X,Q){if(Array.isArray(N.viewType)&&N.viewType.indexOf(X)>=0||N.viewType===X)return!0;if(N.filenamePattern){const De=c(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,ke=c(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(L.$yj(De,(0,$.$mc)(Q.fsPath).toLowerCase()))return!(ke&&L.$yj(ke,(0,$.$mc)(Q.fsPath).toLowerCase()))}return!1}e.$wI=h,e.$xI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var w;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class m{static{this.d="notebook/"}static create(X){return`${m.d}${X}`}static parse(X){if(X.startsWith(m.d))return X.substring(m.d.length)}}e.$yI=m;function I(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$zI=I;const k=new TextDecoder;function d(N){const X=[];let Q=!1;for(const fe of N)(X.length===0||Q)&&(X.push(fe),Q=!0);let De=C(X);const ke=E.$ce.concat(X.map(fe=>E.$ce.wrap(fe))),Pe=F(ke);return De=De||Pe.byteLength!==ke.byteLength,{data:Pe,didCompression:De}}e.$AI=d,e.$BI=`${String.fromCharCode(27)}[A`;const b=e.$BI.split("").map(N=>N.charCodeAt(0)),y=10;function C(N){let X=!1;return N.forEach((Q,De)=>{if(De===0||Q.length<e.$BI.length)return;const ke=N[De-1],Pe=Q.subarray(0,e.$BI.length);if(Pe[0]===b[0]&&Pe[1]===b[1]&&Pe[2]===b[2]){const fe=ke.lastIndexOf(y);if(fe===-1)return;X=!0,N[De-1]=ke.subarray(0,fe),N[De]=Q.subarray(e.$BI.length)}}),X}function B(N){let X=N;do N=X,X=N.replace(/[^\n]\x08/gm,"");while(X.length<N.length);return N}function H(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const X=N.match(/^(.*)\r+/m)[1];let Q=N.match(/\r+(.*)$/m)[1];Q=Q+X.slice(Q.length,X.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Q)}return N}const U="\b".charCodeAt(0),z="\r".charCodeAt(0);function F(N){return!N.buffer.includes(U)&&!N.buffer.includes(z)?N:E.$ce.fromString(H(B(k.decode(N.buffer))))}}),define(Ae[7],Re([1,0,18,11,53,28,69,13,16,2,38,22,41,100,76]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p){"use strict";var f,t,i,n,u,a,l,r,s,c,h,w,m,I,k,d,b,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$lM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.TestRunProfileKind=e.TestResultState=e.$4L=e.$3L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$2L=e.$1L=e.$ZL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$YL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.ColorThemeKind=e.$SL=e.$RL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$QL=e.DebugConsoleMode=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$KL=e.$JL=e.FileChangeType=e.$IL=e.$HL=e.$GL=e.$FL=e.InlineCompletionTriggerKind=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.ConfigurationTarget=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$iL=e.ViewBadge=e.ProgressLocation=e.$hL=e.$gL=e.TaskScope=e.ShellQuoting=e.$fL=e.$eL=e.$dL=e.TaskPanelKind=e.TaskRevealKind=e.$cL=e.TerminalLocation=e.$bL=e.$aL=e.$_K=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$$K=e.$0K=e.$9K=e.$8K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$7K=e.StatusBarAlignment=e.ViewColumn=e.$6K=e.$5K=e.$4K=e.$3K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$2K=e.$1K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.LanguageStatusSeverity=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.CodeActionTriggerKind=e.$OK=e.$NK=e.SymbolTag=e.SymbolKind=e.$MK=e.DocumentHighlightKind=e.$LK=e.$KK=e.$JK=e.$IK=e.DiagnosticSeverity=e.DiagnosticTag=e.$HK=e.$GK=e.FileEditType=e.$FK=e.$EK=e.$DK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function C(j){return Object.assign(j,{apply:function(...oe){if(oe.length===0)return Reflect.construct(j,[]);{const Se=oe.length===1?[]:oe[1];return Reflect.construct(j,Se,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(j,[]);{const[Se,...He]=oe;return Reflect.construct(j,He,Se.constructor)}}})}var B;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(B||(e.TerminalOutputAnchor=B={}));var H;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(H||(e.TerminalQuickFixType=H={}));let U=f=class{static from(...O){let oe=O;return new f(function(){if(oe){for(const Se of oe)Se&&typeof Se.dispose=="function"&&Se.dispose();oe=void 0}})}#e;constructor(O){this.#e=O}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$wK=U,e.$wK=U=f=Ke([C],U);let z=t=class{static Min(...O){if(O.length===0)throw new TypeError;let oe=O[0];for(let Se=1;Se<O.length;Se++){const He=O[Se];He.isBefore(oe)&&(oe=He)}return oe}static Max(...O){if(O.length===0)throw new TypeError;let oe=O[0];for(let Se=1;Se<O.length;Se++){const He=O[Se];He.isAfter(oe)&&(oe=He)}return oe}static isPosition(O){if(!O)return!1;if(O instanceof t)return!0;const{line:oe,character:Se}=O;return typeof oe=="number"&&typeof Se=="number"}static of(O){if(O instanceof t)return O;if(this.isPosition(O))return new t(O.line,O.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(O,oe){if(O<0)throw(0,L.$6)("line must be non-negative");if(oe<0)throw(0,L.$6)("character must be non-negative");this.c=O,this.e=oe}isBefore(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<O.e}isBeforeOrEqual(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<=O.e}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this.c===O.c&&this.e===O.e}compareTo(O){return this.c<O.c?-1:this.c>O.line?1:this.e<O.e?-1:this.e>O.e?1:0}translate(O,oe=0){if(O===null||oe===null)throw(0,L.$6)();let Se;return typeof O>"u"?Se=0:typeof O=="number"?Se=O:(Se=typeof O.lineDelta=="number"?O.lineDelta:0,oe=typeof O.characterDelta=="number"?O.characterDelta:0),Se===0&&oe===0?this:new t(this.line+Se,this.character+oe)}with(O,oe=this.character){if(O===null||oe===null)throw(0,L.$6)();let Se;return typeof O>"u"?Se=this.line:typeof O=="number"?Se=O:(Se=typeof O.line=="number"?O.line:this.line,oe=typeof O.character=="number"?O.character:this.character),Se===this.line&&oe===this.character?this:new t(Se,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$xK=z,e.$xK=z=t=Ke([C],z);let F=i=class{static isRange(O){return O instanceof i?!0:O?z.isPosition(O.start)&&z.isPosition(O.end):!1}static of(O){if(O instanceof i)return O;if(this.isRange(O))return new i(O.start,O.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(O,oe,Se,He){let Ze,st;if(typeof O=="number"&&typeof oe=="number"&&typeof Se=="number"&&typeof He=="number"?(Ze=new z(O,oe),st=new z(Se,He)):z.isPosition(O)&&z.isPosition(oe)&&(Ze=z.of(O),st=z.of(oe)),!Ze||!st)throw new Error("Invalid arguments");Ze.isBefore(st)?(this.c=Ze,this.e=st):(this.c=st,this.e=Ze)}contains(O){return i.isRange(O)?this.contains(O.start)&&this.contains(O.end):z.isPosition(O)?!(z.of(O).isBefore(this.c)||this.e.isBefore(O)):!1}isEqual(O){return this.c.isEqual(O.c)&&this.e.isEqual(O.e)}intersection(O){const oe=z.Max(O.start,this.c),Se=z.Min(O.end,this.e);if(!oe.isAfter(Se))return new i(oe,Se)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const oe=z.Min(O.start,this.c),Se=z.Max(O.end,this.end);return new i(oe,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(O,oe=this.end){if(O===null||oe===null)throw(0,L.$6)();let Se;return O?z.isPosition(O)?Se=O:(Se=O.start||this.start,oe=O.end||this.end):Se=this.start,Se.isEqual(this.c)&&oe.isEqual(this.end)?this:new i(Se,oe)}toJSON(){return[this.start,this.end]}};e.$yK=F,e.$yK=F=i=Ke([C],F);let N=n=class extends F{static isSelection(O){return O instanceof n?!0:O?F.isRange(O)&&z.isPosition(O.anchor)&&z.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(O,oe,Se,He){let Ze,st;if(typeof O=="number"&&typeof oe=="number"&&typeof Se=="number"&&typeof He=="number"?(Ze=new z(O,oe),st=new z(Se,He)):z.isPosition(O)&&z.isPosition(oe)&&(Ze=z.of(O),st=z.of(oe)),!Ze||!st)throw new Error("Invalid arguments");super(Ze,st),this.f=Ze,this.g=st}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$zK=N,e.$zK=N=n=Ke([C],N);const X=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,L.$6)("connectionToken")};class Q{static isResolvedAuthority(O){return O&&typeof O=="object"&&typeof O.host=="string"&&typeof O.port=="number"&&(O.connectionToken===void 0||typeof O.connectionToken=="string")}constructor(O,oe,Se){if(typeof O!="string"||O.length===0)throw(0,L.$6)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,L.$6)("port");typeof Se<"u"&&X(Se),this.host=O,this.port=Math.round(oe),this.connectionToken=Se}}e.$AK=Q;class De{static isManagedResolvedAuthority(O){return O&&typeof O=="object"&&typeof O.makeConnection=="function"&&(O.connectionToken===void 0||typeof O.connectionToken=="string")}constructor(O,oe){this.makeConnection=O,this.connectionToken=oe,typeof oe<"u"&&X(oe)}}e.$BK=De;class ke extends Error{static NotAvailable(O,oe){return new ke(O,v.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(O){return new ke(O,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(O,oe=v.RemoteAuthorityResolverErrorCode.Unknown,Se){super(O),this._message=O,this._code=oe,this._detail=Se,Object.setPrototypeOf(this,ke.prototype)}}e.$CK=ke;var Pe;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var fe;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(fe||(e.EnvironmentVariableMutatorType=fe={}));let we=u=class{static isTextEdit(O){return O instanceof u?!0:O?F.isRange(O)&&typeof O.newText=="string":!1}static replace(O,oe){return new u(O,oe)}static insert(O,oe){return u.replace(new F(O,O),oe)}static delete(O){return u.replace(O,"")}static setEndOfLine(O){const oe=new u(new F(new z(0,0),new z(0,0)),"");return oe.newEol=O,oe}get range(){return this.c}set range(O){if(O&&!F.isRange(O))throw(0,L.$6)("range");this.c=O}get newText(){return this.e||""}set newText(O){if(O&&typeof O!="string")throw(0,L.$6)("newText");this.e=O}get newEol(){return this.f}set newEol(O){if(O&&typeof O!="number")throw(0,L.$6)("newEol");this.f=O}constructor(O,oe){this.c=O,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$DK=we,e.$DK=we=u=Ke([C],we);let ne=a=class{static isNotebookCellEdit(O){return O instanceof a?!0:O?xt.isNotebookRange(O)&&Array.isArray(O.newCells):!1}static replaceCells(O,oe){return new a(O,oe)}static insertCells(O,oe){return new a(new xt(O,O),oe)}static deleteCells(O){return new a(O,[])}static updateCellMetadata(O,oe){const Se=new a(new xt(O,O),[]);return Se.newCellMetadata=oe,Se}static updateNotebookMetadata(O){const oe=new a(new xt(0,0),[]);return oe.newNotebookMetadata=O,oe}constructor(O,oe){this.range=O,this.newCells=oe}};e.$EK=ne,e.$EK=ne=a=Ke([C],ne);class re{static isSnippetTextEdit(O){return O instanceof re?!0:O?F.isRange(O.range)&&W.isSnippetString(O.snippet):!1}static replace(O,oe){return new re(O,oe)}static insert(O,oe){return re.replace(new F(O,O),oe)}constructor(O,oe){this.range=O,this.snippet=oe}}e.$FK=re;var pe;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(pe||(e.FileEditType=pe={}));let _=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(O,oe,Se,He){this.c.push({_type:1,from:O,to:oe,options:Se,metadata:He})}createFile(O,oe,Se){this.c.push({_type:1,from:void 0,to:O,options:oe,metadata:Se})}deleteFile(O,oe,Se){this.c.push({_type:1,from:O,to:void 0,options:oe,metadata:Se})}e(O,oe,Se){this.c.push({_type:3,metadata:Se,uri:O,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(O,oe,Se,He){const Ze=oe.start,st=oe.end;(Ze!==st||Se.length>0)&&this.c.push({_type:5,uri:O,index:Ze,count:st-Ze,cells:Se,metadata:He})}g(O,oe,Se,He){this.c.push({_type:3,metadata:He,uri:O,edit:{editType:3,index:oe,metadata:Se}})}replace(O,oe,Se,He){this.c.push({_type:2,uri:O,edit:new we(oe,Se),metadata:He})}insert(O,oe,Se,He){this.replace(O,new F(oe,oe),Se,He)}delete(O,oe,Se){this.replace(O,oe,"",Se)}has(O){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===O.toString())}set(O,oe){if(oe)for(const Se of oe){if(!Se)continue;let He,Ze;Array.isArray(Se)?(He=Se[0],Ze=Se[1]):He=Se,ne.isNotebookCellEdit(He)?He.newCellMetadata?this.g(O,He.range.start,He.newCellMetadata,Ze):He.newNotebookMetadata?this.e(O,He.newNotebookMetadata,Ze):this.f(O,He.range,He.newCells,Ze):re.isSnippetTextEdit(He)?this.c.push({_type:6,uri:O,range:He.range,edit:He.snippet,metadata:Ze}):this.c.push({_type:2,uri:O,edit:He,metadata:Ze})}else{for(let Se=0;Se<this.c.length;Se++){const He=this.c[Se];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===O.toString()&&(this.c[Se]=void 0);break}}(0,E.$Hb)(this.c)}}get(O){const oe=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===O.toString()&&oe.push(Se.edit);return oe}entries(){const O=new M.$zc;for(const oe of this.c)if(oe._type===2){let Se=O.get(oe.uri);Se||(Se=[oe.uri,[]],O.set(oe.uri,Se)),Se[1].push(oe.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$GK=_,e.$GK=_=Ke([C],_);let W=l=class{static isSnippetString(O){return O instanceof l?!0:O?typeof O.value=="string":!1}static c(O){return O.replace(/\$|}|\\/g,"\\$&")}constructor(O){this.e=1,this.value=O||""}appendText(O){return this.value+=l.c(O),this}appendTabstop(O=this.e++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,oe=this.e++){if(typeof O=="function"){const Se=new l;Se.e=this.e,O(Se),this.e=Se.e,O=Se.value}else O=l.c(O);return this.value+="${",this.value+=oe,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,oe=this.e++){const Se=O.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(O,oe){if(typeof oe=="function"){const Se=new l;Se.e=this.e,oe(Se),this.e=Se.e,oe=Se.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$HK=W,e.$HK=W=l=Ke([C],W);var ce;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ce||(e.DiagnosticTag=ce={}));var be;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(be||(e.DiagnosticSeverity=be={}));let se=r=class{static isLocation(O){return O instanceof r?!0:O?F.isRange(O.range)&&g.URI.isUri(O.uri):!1}constructor(O,oe){if(this.uri=O,oe)if(F.isRange(oe))this.range=F.of(oe);else if(z.isPosition(oe))this.range=new F(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$IK=se,e.$IK=se=r=Ke([C],se);let he=class{static is(O){return O?typeof O.message=="string"&&O.location&&F.isRange(O.location.range)&&g.URI.isUri(O.location.uri):!1}constructor(O,oe){this.location=O,this.message=oe}static isEqual(O,oe){return O===oe?!0:!O||!oe?!1:O.message===oe.message&&O.location.range.isEqual(oe.location.range)&&O.location.uri.toString()===oe.location.uri.toString()}};e.$JK=he,e.$JK=he=Ke([C],he);let ue=class{constructor(O,oe,Se=be.Error){if(!F.isRange(O))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=O,this.message=oe,this.severity=Se}toJSON(){return{severity:be[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,oe){return O===oe?!0:!O||!oe?!1:O.message===oe.message&&O.severity===oe.severity&&O.code===oe.code&&O.severity===oe.severity&&O.source===oe.source&&O.range.isEqual(oe.range)&&(0,E.$tb)(O.tags,oe.tags)&&(0,E.$tb)(O.relatedInformation,oe.relatedInformation,he.isEqual)}};e.$KK=ue,e.$KK=ue=Ke([C],ue);let ye=class{constructor(O,oe){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=oe}};e.$LK=ye,e.$LK=ye=Ke([C],ye);var ee;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(ee||(e.DocumentHighlightKind=ee={}));let de=class{constructor(O,oe=ee.Text){this.range=O,this.kind=oe}toJSON(){return{range:this.range,kind:ee[this.kind]}}};e.$MK=de,e.$MK=de=Ke([C],de);var ie;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ie||(e.SymbolKind=ie={}));var ae;(function(j){j[j.Deprecated=1]="Deprecated"})(ae||(e.SymbolTag=ae={}));let me=s=class{static validate(O){if(!O.name)throw new Error("name must not be falsy")}constructor(O,oe,Se,He,Ze){this.name=O,this.kind=oe,this.containerName=Ze,typeof Se=="string"&&(this.containerName=Se),He instanceof se?this.location=He:Se instanceof F&&(this.location=new se(He,Se)),s.validate(this)}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};e.$NK=me,e.$NK=me=s=Ke([C],me);let Ce=c=class{static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children?.forEach(c.validate)}constructor(O,oe,Se,He,Ze){this.name=O,this.detail=oe,this.kind=Se,this.range=He,this.selectionRange=Ze,this.children=[],c.validate(this)}};e.$OK=Ce,e.$OK=Ce=c=Ke([C],Ce);var T;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(T||(e.CodeActionTriggerKind=T={}));let V=class{constructor(O,oe){this.title=O,this.kind=oe}};e.$PK=V,e.$PK=V=Ke([C],V);let G=class{static{h=this}static{this.c="."}constructor(O){this.value=O}append(O){return new h(this.value?this.value+h.c+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+h.c)}};e.$QK=G,e.$QK=G=h=Ke([C],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let J=class{constructor(O,oe){if(this.range=O,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$RK=J,e.$RK=J=Ke([C],J);class q{constructor(O,oe,Se,He,Ze,st){this.kind=O,this.name=oe,this.detail=Se,this.uri=He,this.range=Ze,this.selectionRange=st}}e.$SK=q;class x{constructor(O,oe){this.fromRanges=oe,this.from=O}}e.$TK=x;class le{constructor(O,oe){this.fromRanges=oe,this.to=O}}e.$UK=le;var Oe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let je=class{constructor(O,oe){this.range=O,this.command=oe}get isResolved(){return!!this.command}};e.$VK=je,e.$VK=je=Ke([C],je);let Qe=w=class{#e;static isMarkdownString(O){return O instanceof w?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}constructor(O,oe=!1){this.#e=new P.$6j(O,{supportThemeIcons:oe})}get value(){return this.#e.value}set value(O){this.#e.value=O}get isTrusted(){return this.#e.isTrusted}set isTrusted(O){this.#e.isTrusted=O}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(O){this.#e.supportThemeIcons=O}get supportHtml(){return this.#e.supportHtml}set supportHtml(O){this.#e.supportHtml=O}get baseUri(){return this.#e.baseUri}set baseUri(O){this.#e.baseUri=O}appendText(O){return this.#e.appendText(O),this}appendMarkdown(O){return this.#e.appendMarkdown(O),this}appendCodeblock(O,oe){return this.#e.appendCodeblock(oe??"",O),this}};e.$WK=Qe,e.$WK=Qe=w=Ke([C],Qe);let Ge=class{constructor(O,oe){this.label=O,this.documentation=oe}};e.$XK=Ge,e.$XK=Ge=Ke([C],Ge);let _e=class{constructor(O,oe){this.label=O,this.documentation=oe,this.parameters=[]}};e.$YK=_e,e.$YK=_e=Ke([C],_e);let Xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$ZK=Xe,e.$ZK=Xe=Ke([C],Xe);var xe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(xe||(e.SignatureHelpTriggerKind=xe={}));var it;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(O){this.value=O}};e.$1K=tt,e.$1K=tt=Ke([C],tt);let ze=class{constructor(O,oe,Se){this.position=O,this.label=oe,this.kind=Se}};e.$2K=ze,e.$2K=ze=Ke([C],ze);var ut;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ut||(e.CompletionTriggerKind=ut={}));var Z;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Z||(e.CompletionItemKind=Z={}));var Y;(function(j){j[j.Deprecated=1]="Deprecated"})(Y||(e.CompletionItemTag=Y={}));let Ee=class{constructor(O,oe){this.label=O,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Z[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$3K=Ee,e.$3K=Ee=Ke([C],Ee);let Be=class{constructor(O=[],oe=!1){this.items=O,this.isIncomplete=oe}};e.$4K=Be,e.$4K=Be=Ke([C],Be);let Ne=class{constructor(O,oe,Se){this.insertText=O,this.range=oe,this.command=Se}};e.$5K=Ne,e.$5K=Ne=Ke([C],Ne);let Ye=class{constructor(O){this.commands=void 0,this.suppressSuggestions=void 0,this.items=O}};e.$6K=Ye,e.$6K=Ye=Ke([C],Ye);var nt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var $t;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})($t||(e.StatusBarAlignment=$t={}));function wt(j,O){return`${S.$9l.toKey(j)}.${O}`}e.$7K=wt;var Pt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Kt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var vt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(vt||(e.TextEditorSelectionChangeKind=vt={}));var Ut;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Ot;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ot||(e.DecorationRangeBehavior=Ot={})),function(j){function O(oe){switch(oe){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=O}(vt||(e.TextEditorSelectionChangeKind=vt={}));var Gt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(j){function O(oe){switch(oe){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=O}(Gt||(e.SyntaxTokenType=Gt={}));let jt=class{constructor(O,oe){if(oe&&!g.URI.isUri(oe))throw(0,L.$6)("target");if(!F.isRange(O)||O.isEmpty)throw(0,L.$6)("range");this.range=O,this.target=oe}};e.$8K=jt,e.$8K=jt=Ke([C],jt);let kt=class{constructor(O,oe,Se,He){this.red=O,this.green=oe,this.blue=Se,this.alpha=He}};e.$9K=kt,e.$9K=kt=Ke([C],kt);let Ft=class{constructor(O,oe){if(oe&&!(oe instanceof kt))throw(0,L.$6)("color");if(!F.isRange(O)||O.isEmpty)throw(0,L.$6)("range");this.range=O,this.color=oe}};e.$0K=Ft,e.$0K=Ft=Ke([C],Ft);let Bt=class{constructor(O){if(!O||typeof O!="string")throw(0,L.$6)("label");this.label=O}};e.$$K=Bt,e.$$K=Bt=Ke([C],Bt);var Jt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Wt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var Vt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Vt||(e.TerminalExitReason=Vt={}));class Nt{constructor(O,oe,Se){if(this.startIndex=O,this.length=oe,this.tooltip=Se,typeof O!="number"||O<0)throw(0,L.$6)("startIndex");if(typeof oe!="number"||oe<1)throw(0,L.$6)("length");if(Se!==void 0&&typeof Se!="string")throw(0,L.$6)("tooltip")}}e.$_K=Nt;class at{constructor(O){this.uri=O}}e.$aL=at;class dt{constructor(O){this.terminalCommand=O}}e.$bL=dt;var At;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(At||(e.TerminalLocation=At={}));class qt{constructor(O){if(this.options=O,typeof O!="object")throw(0,L.$6)("options")}}e.$cL=qt;var Rt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Rt||(e.TaskRevealKind=Rt={}));var ot;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(ot||(e.TaskPanelKind=ot={}));let bt=class{static{m=this}static{this.Clean=new m("clean","Clean")}static{this.Build=new m("build","Build")}static{this.Rebuild=new m("rebuild","Rebuild")}static{this.Test=new m("test","Test")}static from(O){switch(O){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}constructor(O,oe){if(this.label=oe,typeof O!="string"||typeof oe!="string")throw(0,L.$6)("name");this.c=O}get id(){return this.c}};e.$dL=bt,e.$dL=bt=m=Ke([C],bt);function Tt(j){let O="";for(let oe=0;oe<j.length;oe++)O+=j[oe].replace(/,/g,",,")+",";return O}let Ct=class{constructor(O,oe,Se){if(typeof O!="string")throw(0,L.$6)("process");this.e=[],this.c=O,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=Se):this.f=oe)}get process(){return this.c}set process(O){if(typeof O!="string")throw(0,L.$6)("process");this.c=O}get args(){return this.e}set args(O){Array.isArray(O)||(O=[]),this.e=O}get options(){return this.f}set options(O){this.f=O}computeId(){const O=[];if(O.push("process"),this.c!==void 0&&O.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)O.push(oe);return Tt(O)}};e.$eL=Ct,e.$eL=Ct=Ke([C],Ct);let We=class{constructor(O,oe,Se){if(this.f=[],Array.isArray(oe)){if(!O)throw(0,L.$6)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,L.$6)("command");this.e=O,this.f=oe,this.g=Se}else{if(typeof O!="string")throw(0,L.$6)("commandLine");this.c=O,this.g=oe}}get commandLine(){return this.c}set commandLine(O){if(typeof O!="string")throw(0,L.$6)("commandLine");this.c=O}get command(){return this.e?this.e:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,L.$6)("command");this.e=O}get args(){return this.f}set args(O){this.f=O||[]}get options(){return this.g}set options(O){this.g=O}computeId(){const O=[];if(O.push("shell"),this.c!==void 0&&O.push(this.c),this.e!==void 0&&O.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)O.push(typeof oe=="string"?oe:oe.value);return Tt(O)}};e.$fL=We,e.$fL=We=Ke([C],We);var Qt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var Ie;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Ie||(e.TaskScope=Ie={}));class Le{constructor(O){this.c=O}computeId(){return"customExecution"+(0,A.$fg)()}set callback(O){this.c=O}get callback(){return this.c}}e.$gL=Le;let $e=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(O,oe,Se,He,Ze,st){this.j=!1,this.k=this.definition=O;let lt;typeof oe=="string"?(this.m=this.name=oe,this.t=this.source=Se,this.execution=He,lt=Ze,this.j=!0):oe===Ie.Global||oe===Ie.Workspace?(this.target=oe,this.m=this.name=Se,this.t=this.source=He,this.execution=Ze,lt=st):(this.target=oe,this.m=this.name=Se,this.t=this.source=He,this.execution=Ze,lt=st),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(O){this.h=O}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ct?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof We?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof Le?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,A.$fg)()}}get definition(){return this.k}set definition(O){if(O==null)throw(0,L.$6)("Kind can't be undefined or null");this.z(),this.k=O}get scope(){return this.l}set target(O){this.z(),this.l=O}get name(){return this.m}set name(O){if(typeof O!="string")throw(0,L.$6)("name");this.z(),this.m=O}get execution(){return this.n}set execution(O){O===null&&(O=void 0),this.z(),this.n=O;const oe=this.k.type;(I.g===oe||I.e===oe||I.f===oe||I.c===oe)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(O){if(Array.isArray(O))this.z(),this.o=O,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.z(),this.r=O}get source(){return this.t}set source(O){if(typeof O!="string"||O.length===0)throw(0,L.$6)("source must be a string of length > 0");this.z(),this.t=O}get group(){return this.u}set group(O){O===null&&(O=void 0),this.z(),this.u=O}get detail(){return this.y}set detail(O){O===null&&(O=void 0),this.y=O}get presentationOptions(){return this.w}set presentationOptions(O){O==null&&(O=Object.create(null)),this.z(),this.w=O}get runOptions(){return this.x}set runOptions(O){O==null&&(O=Object.create(null)),this.z(),this.x=O}};e.$hL=$e,e.$hL=$e=I=Ke([C],$e);var K;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(K||(e.ProgressLocation=K={}));var Me;(function(j){function O(oe){const Se=oe;return(0,D.$Df)(Se.value)?Se.tooltip&&!(0,D.$zf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}j.isViewBadge=O})(Me||(e.ViewBadge=Me={}));let Ue=k=class{static isTreeItem(O,oe){const Se=O;if(Se.checkboxState!==void 0){const He=(0,D.$Df)(Se.checkboxState)?Se.checkboxState:(0,D.$Bf)(Se.checkboxState)&&(0,D.$Df)(Se.checkboxState.state)?Se.checkboxState.state:void 0,Ze=!(0,D.$Df)(Se.checkboxState)&&(0,D.$Bf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(He===void 0||He!==qe.Checked&&He!==qe.Unchecked||Ze!==void 0&&!(0,D.$zf)(Ze))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(O instanceof k)return!0;if(Se.label!==void 0&&!(0,D.$zf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,D.$zf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,D.$zf)(Se.iconPath)&&!g.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,D.$zf)(Se.iconPath.id))){const He=Se.iconPath;if(!He||!(0,D.$zf)(He.light)&&!g.URI.isUri(He.light)&&!(0,D.$zf)(He.dark)&&!g.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,D.$zf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!g.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,D.$zf)(Se.tooltip)&&!(Se.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<Je.None&&Se.collapsibleState>Je.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,D.$zf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(O,oe=Je.None){this.collapsibleState=oe,g.URI.isUri(O)?this.resourceUri=O:this.label=O}};e.$iL=Ue,e.$iL=Ue=k=Ke([C],Ue);var Je;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Je||(e.TreeItemCollapsibleState=Je={}));var qe;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(qe||(e.TreeItemCheckboxState=qe={}));let et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(O){this.value=O}};e.$jL=et,e.$jL=et=Ke([C],et);class Et extends et{}e.$kL=Et;class Dt extends Et{#e;constructor(O){super(""),this.#e=O}asFile(){return this.#e}}e.$lL=Dt;class gt{constructor(O,oe,Se,He){this.name=O,this.uri=oe,this._itemId=Se,this.c=He}data(){return this.c()}}e.$mL=gt;let ht=class{#e=new Map;constructor(O){for(const[oe,Se]of O??[]){const He=this.#e.get(this.#t(oe));He?He.push(Se):this.#e.set(this.#t(oe),[Se])}}get(O){return this.#e.get(this.#t(O))?.[0]}set(O,oe){this.#e.set(this.#t(O),[oe])}forEach(O,oe){for(const[Se,He]of this.#e)for(const Ze of He)O.call(oe,Ze,Se,this)}*[Symbol.iterator](){for(const[O,oe]of this.#e)for(const Se of oe)yield[O,Se]}#t(O){return O.toLowerCase()}};e.$nL=ht,e.$nL=ht=Ke([C],ht);let ft=class{constructor(O){this.insertText=O}};e.$oL=ft,e.$oL=ft=Ke([C],ft);let ui=class{constructor(O,oe){this.label=oe,this.insertText=O}};e.$pL=ui,e.$pL=ui=Ke([C],ui);let St=class{constructor(O,oe){this.id=O,this.color=oe}static isThemeIcon(O){return typeof O.id!="string"?(console.log("INVALID ThemeIcon, invalid id",O.id),!1):!0}};e.$qL=St,e.$qL=St=Ke([C],St),St.File=new St("file"),St.Folder=new St("folder");let Si=class{constructor(O){this.id=O}};e.$rL=Si,e.$rL=Si=Ke([C],Si);var li;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(li||(e.ConfigurationTarget=li={}));let $i=class{get base(){return this.c}set base(O){this.c=O,this.e=g.URI.file(O)}get baseUri(){return this.e}set baseUri(O){this.e=O,this.c=O.fsPath}constructor(O,oe){if(typeof O!="string"&&(!O||!g.URI.isUri(O)&&!g.URI.isUri(O.uri)))throw(0,L.$6)("base");if(typeof oe!="string")throw(0,L.$6)("pattern");typeof O=="string"?this.baseUri=g.URI.file(O):g.URI.isUri(O)?this.baseUri=O:this.baseUri=O.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$sL=$i,e.$sL=$i=Ke([C],$i);const It=new WeakMap;function gn(j,O){It.set(j,O)}e.$tL=gn;let ri=class{constructor(O,oe,Se,He){this.enabled=typeof O=="boolean"?O:!0,typeof oe=="string"&&(this.condition=oe),typeof Se=="string"&&(this.hitCondition=Se),typeof He=="string"&&(this.logMessage=He)}get id(){return this.c||(this.c=It.get(this)??(0,A.$fg)()),this.c}};e.$uL=ri,e.$uL=ri=Ke([C],ri);let yt=class extends ri{constructor(O,oe,Se,He,Ze){if(super(oe,Se,He,Ze),O===null)throw(0,L.$6)("location");this.location=O}};e.$vL=yt,e.$vL=yt=Ke([C],yt);let pi=class extends ri{constructor(O,oe,Se,He,Ze){super(oe,Se,He,Ze),this.functionName=O}};e.$wL=pi,e.$wL=pi=Ke([C],pi);let vi=class extends ri{constructor(O,oe,Se,He,Ze,st,lt){if(super(He,Ze,st,lt),!oe)throw(0,L.$6)("dataId");this.label=O,this.dataId=oe,this.canPersist=Se}};e.$xL=vi,e.$xL=vi=Ke([C],vi);let si=class{constructor(O,oe,Se){this.command=O,this.args=oe||[],this.options=Se}};e.$yL=si,e.$yL=si=Ke([C],si);let Ii=class{constructor(O,oe){this.port=O,this.host=oe}};e.$zL=Ii,e.$zL=Ii=Ke([C],Ii);let Ci=class{constructor(O){this.path=O}};e.$AL=Ci,e.$AL=Ci=Ke([C],Ci);let Mt=class{constructor(O){this.implementation=O}};e.$BL=Mt,e.$BL=Mt=Ke([C],Mt);let wi=class{constructor(O,oe,Se){this.session=O,this.threadId=oe,this.frameId=Se}};e.$CL=wi,e.$CL=wi=Ke([C],wi);let Pi=class{constructor(O,oe){this.session=O,this.threadId=oe}};e.$DL=Pi,e.$DL=Pi=Ke([C],Pi);let oi=class{constructor(O,oe){this.range=O,this.expression=oe}};e.$EL=oi,e.$EL=oi=Ke([C],oi);var hi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(hi||(e.InlineCompletionTriggerKind=hi={}));let ct=class{constructor(O,oe){this.range=O,this.text=oe}};e.$FL=ct,e.$FL=ct=Ke([C],ct);let Ai=class{constructor(O,oe,Se=!0){this.range=O,this.variableName=oe,this.caseSensitiveLookup=Se}};e.$GL=Ai,e.$GL=Ai=Ke([C],Ai);let Xt=class{constructor(O,oe){this.range=O,this.expression=oe}};e.$HL=Xt,e.$HL=Xt=Ke([C],Xt);let ii=class{constructor(O,oe){this.frameId=O,this.stoppedLocation=oe}};e.$IL=ii,e.$IL=ii=Ke([C],ii);var Ri;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Mi=d=class extends Error{static FileExists(O){return new d(O,o.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(O){return new d(O,o.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(O){return new d(O,o.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(O){return new d(O,o.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(O){return new d(O,o.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(O){return new d(O,o.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}constructor(O,oe=o.FileSystemProviderErrorCode.Unknown,Se){super(g.URI.isUri(O)?O.toString(!0):O),this.code=Se?.name??"Unknown",(0,o.$qk)(this,oe),Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$JL=Mi,e.$JL=Mi=d=Ke([C],Mi);let Li=class{constructor(O,oe,Se){this.start=O,this.end=oe,this.kind=Se}};e.$KL=Li,e.$KL=Li=Ke([C],Li);var Yi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Yi||(e.FoldingRangeKind=Yi={}));var Fi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Fi||(e.CommentThreadCollapsibleState=Fi={}));var Zi;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Ti;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Ti||(e.CommentState=Ti={}));var ai;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class mn{constructor(O,oe=[]){this.tokenTypes=O,this.tokenModifiers=oe}}e.$LL=mn;function Oi(j){return typeof j>"u"||(0,D.$Af)(j)}class di{constructor(O){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,O){this.l=!0;for(let oe=0,Se=O.tokenTypes.length;oe<Se;oe++)this.j.set(O.tokenTypes[oe],oe);for(let oe=0,Se=O.tokenModifiers.length;oe<Se;oe++)this.k.set(O.tokenModifiers[oe],oe)}}push(O,oe,Se,He,Ze){if(typeof O=="number"&&typeof oe=="number"&&typeof Se=="number"&&typeof He=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this.n(O,oe,Se,He,Ze);if(F.isRange(O)&&typeof oe=="string"&&Oi(Se))return this.m(O,oe,Se);throw(0,L.$6)()}m(O,oe,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(oe))throw new Error("`tokenType` is not in the provided legend");const He=O.start.line,Ze=O.start.character,st=O.end.character-O.start.character,lt=this.j.get(oe);let zt=0;if(Se)for(const Zt of Se){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Zt);zt|=1<<ei>>>0}this.n(He,Ze,st,lt,zt)}n(O,oe,Se,He,Ze){if(this.f&&(O<this.c||O===this.c&&oe<this.e)){this.f=!1;const zt=this.g.length/5|0;let Zt=0,ei=0;for(let ti=0;ti<zt;ti++){let ni=this.g[5*ti],Ji=this.g[5*ti+1];ni===0?(ni=Zt,Ji+=ei):ni+=Zt,this.g[5*ti]=ni,this.g[5*ti+1]=Ji,Zt=ni,ei=Ji}}let st=O,lt=oe;this.f&&this.h>0&&(st-=this.c,st===0&&(lt-=this.e)),this.g[this.h++]=st,this.g[this.h++]=lt,this.g[this.h++]=Se,this.g[this.h++]=He,this.g[this.h++]=Ze,this.c=O,this.e=oe}static o(O){const oe=[],Se=O.length/5|0;for(let lt=0;lt<Se;lt++)oe[lt]=lt;oe.sort((lt,zt)=>{const Zt=O[5*lt],ei=O[5*zt];if(Zt===ei){const ti=O[5*lt+1],ni=O[5*zt+1];return ti-ni}return Zt-ei});const He=new Uint32Array(O.length);let Ze=0,st=0;for(let lt=0;lt<Se;lt++){const zt=5*oe[lt],Zt=O[zt+0],ei=O[zt+1],ti=O[zt+2],ni=O[zt+3],Ji=O[zt+4],Cn=Zt-Ze,Tn=Cn===0?ei-st:ei,Qi=5*lt;He[Qi+0]=Cn,He[Qi+1]=Tn,He[Qi+2]=ti,He[Qi+3]=ni,He[Qi+4]=Ji,Ze=Zt,st=ei}return He}build(O){return this.f?new Ni(new Uint32Array(this.g),O):new Ni(di.o(this.g),O)}}e.$ML=di;class Ni{constructor(O,oe){this.resultId=oe,this.data=O}}e.$NL=Ni;class $n{constructor(O,oe,Se){this.start=O,this.deleteCount=oe,this.data=Se}}e.$OL=$n;class fi{constructor(O,oe){this.resultId=oe,this.edits=O}}e.$PL=fi;var Xi;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Xi||(e.DebugConsoleMode=Xi={}));let zi=class{static{this.Back={iconPath:new St("arrow-left")}}constructor(){}};e.$QL=zi,e.$QL=zi=Ke([C],zi);var xi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var gi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(gi||(e.InputBoxValidationSeverity=gi={}));var _i;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class pn{static validate(O){if(typeof O.badge=="string"){let oe=(0,$.$af)(O.badge,0);if(oe<O.badge.length&&(oe+=(0,$.$af)(O.badge,oe)),O.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(O.badge&&!St.isThemeIcon(O.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}constructor(O,oe,Se){this.badge=O,this.tooltip=oe,this.color=Se}}e.$RL=pn;let Ui=class{constructor(O){this.kind=O}};e.$SL=Ui,e.$SL=Ui=Ke([C],Ui);var mi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(mi||(e.ColorThemeKind=mi={}));class xt{static isNotebookRange(O){return O instanceof xt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(O,oe){if(O<0)throw(0,L.$6)("start must be positive");if(oe<0)throw(0,L.$6)("end must be positive");O<=oe?(this.c=O,this.e=oe):(this.c=oe,this.e=O)}with(O){let oe=this.c,Se=this.e;return O.start!==void 0&&(oe=O.start),O.end!==void 0&&(Se=O.end),oe===this.c&&Se===this.e?this:new xt(oe,Se)}}e.$TL=xt;class bi{static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(oe=>bi.isNotebookCellData(oe))}static isNotebookCellData(O){return!0}constructor(O,oe,Se,He,Ze,st,lt){this.kind=O,this.value=oe,this.languageId=Se,this.mime=He,this.outputs=Ze??[],this.metadata=st,this.executionSummary=lt,bi.validate(this)}}e.$UL=bi;class en{constructor(O){this.cells=O}}e.$VL=en;class Yt{static isNotebookCellOutputItem(O){return O instanceof Yt?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const oe={name:O.name,message:O.message,stack:O.stack};return Yt.json(oe,"application/vnd.code.notebook.error")}static stdout(O){return Yt.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Yt.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,oe="application/octet-stream"){return new Yt(O,oe)}static#e=new TextEncoder;static text(O,oe=R.$Sr.text){const Se=Yt.#e.encode(String(O));return new Yt(Se,oe)}static json(O,oe="text/x-json"){const Se=JSON.stringify(O,void 0,"	");return Yt.text(Se,oe)}constructor(O,oe){this.data=O,this.mime=oe;const Se=(0,R.$Wr)(oe,!0);if(!Se)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$WL=Yt;class yi{static isNotebookCellOutput(O){return O instanceof yi?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&Array.isArray(O.items)}static ensureUniqueMimeTypes(O,oe=!1){const Se=new Set,He=new Set;for(let Ze=0;Ze<O.length;Ze++){const st=O[Ze],lt=(0,R.$Wr)(st.mime);if(!Se.has(lt)||(0,p.$zI)(lt)){Se.add(lt);continue}He.add(Ze),oe&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return He.size===0?O:O.filter((Ze,st)=>!He.has(st))}constructor(O,oe,Se){this.items=yi.ensureUniqueMimeTypes(O,!0),typeof oe=="string"?(this.id=oe,this.metadata=Se):(this.id=(0,A.$fg)(),this.metadata=oe??Se)}}e.$XL=yi;var tn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var Ei;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class sn{constructor(O,oe){this.text=O,this.alignment=oe}}e.$YL=sn;var Te;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Te||(e.NotebookControllerAffinity=Te={}));var _t;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class on{constructor(O,oe=[]){this.uri=O,this.provides=(0,E.$2b)(oe)}}e.$ZL=on;class mt{constructor(O){this.label=O}}e.$1L=mt;let ji=class{constructor(O,oe){this.label=O,this.timestamp=oe}};e.$2L=ji,e.$2L=ji=Ke([C],ji);var an;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var Bi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var cn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class Di{constructor(O,oe){this.ranges=O,this.wordPattern=oe}}e.$3L=Di;class vn{constructor(O){this.c=O}get autoForwardAction(){return this.c}}e.$4L=vn;var un;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let ki=class{constructor(O=void 0,oe=void 0,Se=void 0,He=!1){this.include=O,this.exclude=oe,this.profile=Se,this.continuous=He}};e.$5L=ki,e.$5L=ki=Ke([C],ki);let Wi=b=class{static diff(O,oe,Se){const He=new b(O);return He.expectedOutput=oe,He.actualOutput=Se,He}constructor(O){this.message=O}};e.$6L=Wi,e.$6L=Wi=b=Ke([C],Wi);let Vi=class{constructor(O){this.id=O}};e.$7L=Vi,e.$7L=Vi=Ke([C],Vi);let ci=class{constructor(O,oe){this.covered=O,this.total=oe}};e.$8L=ci,e.$8L=ci=Ke([C],ci);let qi=y=class{static fromDetails(O,oe){const Se=new ci(0,0),He=new ci(0,0),Ze=new ci(0,0);for(const lt of oe)if("branches"in lt){Se.total+=1,Se.covered+=lt.executionCount>0?1:0;for(const zt of lt.branches)He.total+=1,He.covered+=zt.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=lt.executionCount>0?1:0;const st=new y(O,Se,He.total>0?He:void 0,Ze.total>0?Ze:void 0);return st.detailedCoverage=oe,st}constructor(O,oe,Se,He){this.uri=O,this.statementCoverage=oe,this.branchCoverage=Se,this.functionCoverage=He}};e.$9L=qi,e.$9L=qi=y=Ke([C],qi);let Ki=class{constructor(O,oe,Se=[]){this.executionCount=O,this.location=oe,this.branches=Se}};e.$0L=Ki,e.$0L=Ki=Ke([C],Ki);let Hi=class{constructor(O,oe){this.executionCount=O,this.location=oe}};e.$$L=Hi,e.$$L=Hi=Ke([C],Hi);let Gi=class{constructor(O,oe){this.executionCount=O,this.location=oe}};e.$_L=Gi,e.$_L=Gi=Ke([C],Gi);var hn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(hn||(e.ExternalUriOpenerPriority=hn={}));var dn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(dn||(e.WorkspaceTrustState=dn={}));var fn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(fn||(e.PortAutoForwardAction=fn={}));class te{constructor(O,oe,Se,He,Ze,st){this.kind=O,this.name=oe,this.detail=Se,this.uri=He,this.range=Ze,this.selectionRange=st}}e.$aM=te;class ge{constructor(O){this.uri=O}}e.$bM=ge;class Fe{constructor(O,oe){this.original=O,this.modified=oe}}e.$cM=Fe;class rt{constructor(O,oe,Se,He){this.base=O,this.input1=oe,this.input2=Se,this.result=He}}e.$dM=rt;class pt{constructor(O,oe){this.uri=O,this.viewType=oe}}e.$eM=pt;class Lt{constructor(O){this.viewType=O}}e.$fM=Lt;class Pn{constructor(O,oe){this.uri=O,this.notebookType=oe}}e.$gM=Pn;class An{constructor(O,oe,Se){this.original=O,this.modified=oe,this.notebookType=Se}}e.$hM=An;class Rn{constructor(){}}e.$iM=Rn;class Mn{constructor(O,oe){this.uri=O,this.inputBoxUri=oe}}e.$jM=Mn;class Ln{constructor(O){this.providerId=O}}e.$kM=Ln;var wn;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var bn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(bn||(e.InteractiveSessionCopyKind=bn={}));var yn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var Dn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Fn{constructor(O,oe){this.role=O,this.content=oe}}e.$lM=Fn;var kn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Sn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var In;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped"})(In||(e.SpeechToTextStatus=In={}))}),define(Ae[103],Re([1,0,55,14,13,297,147,7,18]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=e.$zM=e.$yM=void 0;const g=new Map;function A(p,f){f?g.set(p,f):g.delete(p)}e.$yM=A;function S(p){return g.get(p)}class o extends M.$Yu{constructor(f,t,i,n,u,a,l,r){super(t,i,n,u),this.c=f,this.m=a,this.q=l,this.notebook=r,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,D.$tb)(this.f,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.d},get fileName(){return f.d.fsPath},get isUntitled(){return f.d.scheme===L.Schemas.untitled},get languageId(){return f.m},get version(){return f.h},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(t){return t?f.s(t):f.getText()},get eol(){return f.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return f.f.length},lineAt(t){return f.t(t)},offsetAt(t){return f.u(t)},positionAt(t){return f.v(t)},validateRange(t){return f.w(t)},validatePosition(t){return f.x(t)},getWordRangeAtPosition(t,i){return f.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,E.ok)(!this.b),this.m=f}_acceptIsDirty(f){(0,E.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(f){const t=this.w(f);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,n=t.start.line,u=t.end.line,a=[];a.push(this.f[n].substring(t.start.character));for(let l=n+1;l<u;l++)a.push(this.f[l]);return a.push(this.f[u].substring(0,t.end.character)),a.join(i)}t(f){let t;if(f instanceof $.$xK?t=f.line:typeof f=="number"&&(t=f),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new v(t,this.f[t],t===this.f.length-1)}u(f){return f=this.x(f),this.l(),this.j.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.l();const t=this.j.getIndexOf(f),i=this.f[t.index].length;return new $.$xK(t.index,Math.min(t.remainder,i))}w(f){if(!(f instanceof $.$yK))throw new Error("Invalid argument");const t=this.x(f.start),i=this.x(f.end);return t===f.start&&i===f.end?f:new $.$yK(t.line,t.character,i.line,i.character)}x(f){if(!(f instanceof $.$xK))throw new Error("Invalid argument");if(this.f.length===0)return f.with(0,0);let{line:t,character:i}=f,n=!1;if(t<0)t=0,i=0,n=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,n=!0;else{const u=this.f[t].length;i<0?(i=0,n=!0):i>u&&(i=u,n=!0)}return n?new $.$xK(t,i):f}y(f,t){const i=this.x(f);if(!t)t=S(this.m);else if((0,P.$Pe)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const n=(0,R.$$r)(i.character+1,(0,R.$9r)(t),this.f[i.line],0);if(n)return new $.$yK(i.line,n.startColumn-1,i.line,n.endColumn-1)}}e.$zM=o;class v{constructor(f,t,i){this.a=f,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$yK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$yK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$AM=v}),define(Ae[211],Re([1,0,7,17,5]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=void 0;let M=class{constructor($){this.a=new E.$SL(E.ColorThemeKind.Dark),this.b=new P.$Od}get activeColorTheme(){return this.a}$onColorThemeChange($){let D;switch($){case"light":D=E.ColorThemeKind.Light;break;case"hcDark":D=E.ColorThemeKind.HighContrast;break;case"hcLight":D=E.ColorThemeKind.HighContrastLight;break;default:D=E.ColorThemeKind.Dark}this.a=new E.$SL(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Kec=M,e.$Kec=M=Ke([Ve(0,L.$wM)],M)}),define(Ae[212],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DI=e.CellExecutionUpdateType=void 0;var L;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.$DI=(0,E.$Sh)("INotebookExecutionService")}),define(Ae[213],Re([1,0,6,29,144,93]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DOb=void 0;class R extends E.$Rc{constructor(D,g,A){super(),this._source=D,this.b=g,this.c=A,this.a=void 0}f(D){const g=D.getLineCount();return new L.$ws(1,1,g,this.g(D,g))}g(D,g){if(g<1||g>D.getLineCount())throw new Error("Illegal value for lineNumber");return D.getLineLength(g)+1}get inputTextBuffer(){if(!this.b){const D=new P.$JB;D.acceptChunk(this._source);const g=D.finish(!0),{textBuffer:A,disposable:S}=g.create(1);this.b=A,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(D=>{const g=new P.$JB;g.acceptChunk(D);const A=g.finish(!0),{textBuffer:S,disposable:o}=A.create(1);return this.B(o),S})),this.a}findInInputs(D){const A=new M.$xB(D,!1,!1,null).parseSearchRequest();if(!A)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,A,!0,5e3)}findInOutputs(D){const A=new M.$xB(D,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(S=>{const o=S.findMatchesLineByLine(this.f(S),A,!0,5e3);if(o.length!==0)return{textBuffer:S,matches:o}}).filter(S=>!!S):[]}}e.$DOb=R}),define(Ae[48],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(M){M.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var L;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class P{static fromExtHostTestItem(R,$,D=R.parent){if(R._isRoot)return new P([$]);const g=[R.id];for(let A=D;A&&A.id!==$;A=A.parent)g.push(A.id);return g.push($),new P(g.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const $=R.indexOf("\0");return $===-1?R:R.slice(0,$)}static fromString(R){return new P(R.split("\0"))}static join(R,$){return new P([...R.path,$])}static joinToString(R,$){return R.toString()+"\0"+$}static parentId(R){const $=R.lastIndexOf("\0");return $===-1?void 0:R.slice(0,$)}static localId(R){const $=R.lastIndexOf("\0");return $===-1?R:R.slice($+1)}static isChild(R,$){return $.startsWith(R)&&$[R.length]==="\0"}static compare(R,$){return R===$?0:P.isChild(R,$)?2:P.isChild($,R)?3:1}constructor(R,$=R.length){if(this.path=R,this.d=$,R.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let $=0;$<R.d&&$<this.d;$++)if(R.path[$]!==this.path[$])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$kJ=P}),define(Ae[60],Re([1,0,2,29,48]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$qJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$pJ=e.$oJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$nJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$mJ=e.$lJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var R;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var $;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$lJ=[2,4,8,16,32,64];const D=k=>"runId"in k;e.$mJ=D;var g;(function(k){k.serialize=d=>({range:d.range.toJSON(),uri:d.uri.toJSON()}),k.deserialize=d=>({range:L.$ws.lift(d.range),uri:E.URI.revive(d.uri)})})(g||(e.IRichLocation=g={}));var A;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(A||(e.TestMessageType=A={}));var S;(function(k){k.serialize=d=>({message:d.message,type:0,expected:d.expected,actual:d.actual,contextValue:d.contextValue,location:d.location&&g.serialize(d.location)}),k.deserialize=d=>({message:d.message,type:0,expected:d.expected,actual:d.actual,contextValue:d.contextValue,location:d.location&&g.deserialize(d.location)})})(S||(e.ITestErrorMessage=S={}));const o=(k,d)=>`${d?"s":"e"}${k}`;e.$nJ=o;var v;(function(k){k.serialize=d=>({message:d.message,type:1,offset:d.offset,length:d.length,location:d.location&&g.serialize(d.location)}),k.deserialize=d=>({message:d.message,type:1,offset:d.offset,length:d.length,location:d.location&&g.deserialize(d.location)})})(v||(e.ITestOutputMessage=v={}));var p;(function(k){k.serialize=d=>d.type===0?S.serialize(d):v.serialize(d),k.deserialize=d=>d.type===0?S.deserialize(d):v.deserialize(d)})(p||(e.ITestMessage=p={}));var f;(function(k){k.serializeWithoutMessages=d=>({state:d.state,duration:d.duration,messages:[]}),k.serialize=d=>({state:d.state,duration:d.duration,messages:d.messages.map(p.serialize)}),k.deserialize=d=>({state:d.state,duration:d.duration,messages:d.messages.map(p.deserialize)})})(f||(e.ITestTaskState=f={}));const t="\0",i=(k,d)=>k+t+d;e.$oJ=i;const n=k=>{const d=k.indexOf(t);return{ctrlId:k.slice(0,d),tagId:k.slice(d+1)}};e.$pJ=n;var u;(function(k){k.serialize=d=>({extId:d.extId,label:d.label,tags:d.tags,busy:d.busy,children:void 0,uri:d.uri?.toJSON(),range:d.range?.toJSON()||null,description:d.description,error:d.error,sortText:d.sortText}),k.deserialize=d=>({extId:d.extId,label:d.label,tags:d.tags,busy:d.busy,children:void 0,uri:d.uri?E.URI.revive(d.uri):void 0,range:d.range?L.$ws.lift(d.range):null,description:d.description,error:d.error,sortText:d.sortText})})(u||(e.ITestItem=u={}));var a;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var l;(function(k){k.serialize=d=>({expand:d.expand,item:u.serialize(d.item)}),k.deserialize=d=>({controllerId:P.$kJ.root(d.item.extId),expand:d.expand,item:u.deserialize(d.item)})})(l||(e.InternalTestItem=l={}));var r;(function(k){k.serialize=d=>{let b;return d.item&&(b={},d.item.label!==void 0&&(b.label=d.item.label),d.item.tags!==void 0&&(b.tags=d.item.tags),d.item.busy!==void 0&&(b.busy=d.item.busy),d.item.uri!==void 0&&(b.uri=d.item.uri?.toJSON()),d.item.range!==void 0&&(b.range=d.item.range?.toJSON()),d.item.description!==void 0&&(b.description=d.item.description),d.item.error!==void 0&&(b.error=d.item.error),d.item.sortText!==void 0&&(b.sortText=d.item.sortText)),{extId:d.extId,expand:d.expand,item:b}},k.deserialize=d=>{let b;return d.item&&(b={},d.item.label!==void 0&&(b.label=d.item.label),d.item.tags!==void 0&&(b.tags=d.item.tags),d.item.busy!==void 0&&(b.busy=d.item.busy),d.item.range!==void 0&&(b.range=d.item.range?L.$ws.lift(d.item.range):null),d.item.description!==void 0&&(b.description=d.item.description),d.item.error!==void 0&&(b.error=d.item.error),d.item.sortText!==void 0&&(b.sortText=d.item.sortText)),{extId:d.extId,expand:d.expand,item:b}}})(r||(e.ITestItemUpdate=r={}));const s=(k,d)=>{d.expand!==void 0&&(k.expand=d.expand),d.item!==void 0&&(k.item=k.item?Object.assign(k.item,d.item):d.item)};e.$qJ=s;var c;(function(k){k.serializeWithoutMessages=d=>({...l.serialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(f.serializeWithoutMessages)}),k.serialize=d=>({...l.serialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(f.serialize)}),k.deserialize=d=>({...l.deserialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(f.deserialize),retired:!0})})(c||(e.TestResultItem=c={}));var h;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(h||(e.DetailType=h={}));var w;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(w||(e.TestDiffOpType=w={}));var m;(function(k){k.deserialize=d=>d.op===0?{op:d.op,item:l.deserialize(d.item)}:d.op===1?{op:d.op,item:r.deserialize(d.item)}:d.op===2?{op:d.op,uri:E.URI.revive(d.uri),docv:d.docv}:d,k.serialize=d=>d.op===0?{op:d.op,item:l.serialize(d.item)}:d.op===1?{op:d.op,item:r.serialize(d.item)}:d})(m||(e.TestsDiffOp=m={}));class I{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(d){const b=this.o();for(const y of d)switch(y.op){case 0:this.j(l.deserialize(y.item),b);break;case 1:this.k(r.deserialize(y.item),b);break;case 3:this.l(y.itemId,b);break;case 5:this.m(y.itemId);break;case 4:this.updatePendingRoots(y.amount);break;case 6:this.c.set(y.tag.id,y.tag);break;case 7:this.c.delete(y.id);break}b.complete?.()}j(d,b){const y=P.$kJ.parentId(d.item.extId)?.toString();let C;if(!y)C=this.p(d),this.f.add(C),this.d.set(d.item.extId,C);else if(this.d.has(y)){const B=this.d.get(y);B.children.add(d.item.extId),C=this.p(d,B),this.d.set(d.item.extId,C)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(d)}`);return}return b.add?.(C),d.expand===2&&this.g++,C}k(d,b){const y=this.d.get(d.extId);if(y)return d.expand!==void 0&&(y.expand===2&&this.g--,d.expand===2&&this.g++),(0,e.$qJ)(y,d),b.update?.(y),y}l(d,b){const y=this.d.get(d);if(!y)return;const C=P.$kJ.parentId(y.item.extId)?.toString();C?this.d.get(C).children.delete(y.item.extId):this.f.delete(y);const B=[[d]];for(;B.length;)for(const H of B.pop()){const U=this.d.get(H);U&&(B.push(U.children),this.d.delete(H),b.remove?.(U,U!==y),U.expand===2&&this.g--)}}m(d){}updatePendingRoots(d){this.h+=d}o(){return{}}}e.$rJ=I}),define(Ae[77],Re([1,0,12,5,6,55,60,48]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.TestItemEventOp=void 0;var D;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const g=(n,u)=>n===u,S=Object.entries({range:(n,u)=>n===u?!0:!n||!u?!1:n.equalsRange(u),busy:g,label:g,description:g,error:g,sortText:g,tags:(n,u)=>!(n.length!==u.length||n.some(a=>!u.includes(a)))}),o=(n,u)=>{let a;for(const[l,r]of S)r(n[l],u[l])||(a?a[l]=u[l]:a={[l]:u[l]});return a};class v extends P.$Rc{get root(){return this.s.root}constructor(u){super(),this.s=u,this.f=this.B(new E.$7g(()=>this.flushDiff(),200)),this.g=this.B(new L.$Od),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(u){this.h=u;for(const a of this.tree.values())this.I(a)}get resolveHandler(){return this.h}collectDiff(){const u=this.m;return this.m=[],u}pushDiff(u){switch(u.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===u.uri){a.docv=u.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===u.item.extId){(0,R.$qJ)(a.item,u.item);return}if(a.op===0&&a.item.item.extId===u.item.extId){(0,R.$qJ)(a.item,u.item);return}}break}}this.m.push(u),this.f.isScheduled()||this.f.schedule()}expand(u,a){const l=this.tree.get(u);if(l){if((l.expandLevels===void 0||a>l.expandLevels)&&(l.expandLevels=a),l.expand===1){const r=this.L(l);return r.isOpen()?this.J(l,a-1):r.wait().then(()=>this.J(l,a-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.J(l,a-1)):this.J(l,a-1)}}dispose(){for(const u of this.tree.values())this.s.getApiFor(u.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(u,a){switch(a.op){case 3:this.N($.$kJ.joinToString(u.fullId,a.id));break;case 0:this.y(a.item,u);break;case 5:for(const l of a.ops)this.u(u,l);break;case 1:this.z(a.new,a.old,u.fullId.toString());break;case 2:this.I(u);break;case 4:this.pushDiff({op:1,item:{extId:u.fullId.toString(),item:a.update}});break;case 6:this.w(u.actual.uri);break;default:(0,M.$3c)(a)}}w(u){u&&this.pushDiff({op:2,uri:u,docv:this.s.getDocumentVersion(u)})}y(u,a){const l=$.$kJ.fromExtHostTestItem(u,this.root.id,a?.actual),r=this.s.getApiFor(u);r.parent&&r.parent!==a?.actual&&this.s.getChildren(r.parent).delete(u.id);let s=this.tree.get(l.toString());if(!s){s={fullId:l,actual:u,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},u.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(u,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(u)}}),this.H(u,s,a);return}if(s.actual===u){this.G(u,s,a);return}if(s.actual.uri?.toString()!==u.uri?.toString())return this.N(l.toString()),this.y(u,a);const c=this.s.getChildren(s.actual),h=s.actual,w=o(this.s.toITestItem(h),this.s.toITestItem(u));this.s.getApiFor(h).listener=void 0,s.actual=u,s.expand=0,w&&(w.hasOwnProperty("tags")&&(this.z(u.tags,h.tags,l.toString()),delete w.tags),this.u(s,{op:4,update:w})),this.H(u,s,a);for(const[m,I]of c)this.s.getChildren(u).get(I.id)||this.N($.$kJ.joinToString(l,I.id));this.w(s.actual.uri)}z(u,a,l){const r=new Set(a.map(s=>s.id));for(const s of u)r.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:l,item:{tags:u.map(s=>(0,R.$oJ)(this.s.controllerId,s.id))}}}),r.forEach(this.D,this)}C(u){const a=this.j.get(u.id);a?a.refCount++:(this.j.set(u.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$oJ)(this.s.controllerId,u.id)}}))}D(u){const a=this.j.get(u);a&&!--a.refCount&&(this.j.delete(u),this.pushDiff({op:7,id:(0,R.$oJ)(this.s.controllerId,u)}))}F(u,a){this.s.getApiFor(u).parent=a&&a.actual!==this.root?a.actual:void 0}G(u,a,l){this.F(u,l);const r=this.s.getApiFor(u);r.parent=l?.actual,r.listener=s=>this.u(a,s),this.I(a)}H(u,a,l){this.G(u,a,l);for(const[r,s]of this.s.getChildren(u))this.y(s,a)}I(u){let a;this.h?u.resolveBarrier?a=u.resolveBarrier.isOpen()?3:2:a=u.actual.canResolveChildren?1:0:a=0,a!==u.expand&&(u.expand=a,this.pushDiff({op:1,item:{extId:u.fullId.toString(),expand:a}}),a===1&&u.expandLevels!==void 0&&this.L(u))}J(u,a){if(a<0)return;const l=[];for(const[r,s]of this.s.getChildren(u.actual)){const c=this.expand($.$kJ.joinToString(u.fullId,s.id),a);(0,E.$Hg)(c)&&l.push(c)}if(l.length)return Promise.all(l).then(()=>{})}L(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this.h){const s=new E.$Tg;return s.open(),s}u.expand=2,this.M(u);const a=u.resolveBarrier=new E.$Tg,l=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let r;try{r=this.h(u.actual===this.root?void 0:u.actual)}catch(s){l(s)}return(0,E.$Hg)(r)?r.catch(l).then(()=>{a.open(),this.I(u)}):(a.open(),this.I(u)),u.resolveBarrier}M(u){this.pushDiff({op:1,item:{extId:u.fullId.toString(),expand:u.expand}})}N(u){const a=this.tree.get(u);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:u});const l=[a];for(;l.length;){const r=l.pop();if(r){this.s.getApiFor(r.actual).listener=void 0;for(const s of r.actual.tags)this.D(s.id);this.tree.delete(r.fullId.toString());for(const[s,c]of this.s.getChildren(r.actual))l.push(this.tree.get($.$kJ.joinToString(r.fullId,c.id)))}}}flushDiff(){const u=this.collectDiff();u.length&&this.g.fire(u)}}e.$mM=v;class p extends Error{constructor(u){super(`Attempted to insert a duplicate test item ID ${u}`)}}e.$nM=p;class f extends Error{constructor(u){super(`TestItem with ID "${u}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$oM=f;class t extends Error{constructor(u,a,l){super(`TestItem with ID "${u}" is from controller "${a}" and cannot be added as a child of an item from controller "${l}".`)}}e.$pM=t;const i=(n,u,a)=>{let l=new Map;return{get size(){return l.size},forEach(r,s){for(const c of l.values())r.call(s,c,this)},[Symbol.iterator](){return l.entries()},replace(r){const s=new Map,c=new Set(l.keys()),h={op:5,ops:[]};for(const w of r){if(!(w instanceof a))throw new f(w.id);const m=u(w).controllerId;if(m!==n.controllerId)throw new t(w.id,m,n.controllerId);if(s.has(w.id))throw new p(w.id);s.set(w.id,w),c.delete(w.id),h.ops.push({op:0,item:w})}for(const w of c.keys())h.ops.push({op:3,id:w});n.listener?.(h),l=s},add(r){if(!(r instanceof a))throw new f(r.id);l.set(r.id,r),n.listener?.({op:0,item:r})},delete(r){l.delete(r)&&n.listener?.({op:3,id:r})},get(r){return l.get(r)},toJSON(){return Array.from(l.values())}}};e.$qM=i}),define(Ae[104],Re([1,0,77]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0;const L=new WeakMap,P=(R,$)=>{const D={controllerId:$};return L.set(R,D),D};e.$rM=P;const M=R=>{const $=L.get(R);if(!$)throw new E.$oM(R?.id||"<unknown>");return $};e.$sM=M}),define(Ae[78],Re([1,0,14,2]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7tb=e.$6tb=e.$5tb=e.$4tb=e.$3tb=void 0,e.$3tb="vscode-cdn.net",e.$4tb=`vscode-resource.${e.$3tb}`,e.$5tb=`'self' https://*.${e.$3tb}`;function P($,D){return $.scheme===E.Schemas.http||$.scheme===E.Schemas.https?$:(D&&D.authority&&D.isRemote&&$.scheme===E.Schemas.file&&($=L.URI.from({scheme:E.Schemas.vscodeRemote,authority:D.authority,path:$.path})),L.URI.from({scheme:E.Schemas.https,authority:`${$.scheme}+${M($.authority)}.${e.$4tb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$6tb=P;function M($){return $.replace(/./g,D=>{const g=D.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?D:"-"+g.toString(16).padStart(4,"0")})}function R($){return $.replace(/-([0-9a-f]{4})/g,(D,g)=>String.fromCharCode(parseInt(g,16)))}e.$7tb=R}),define(Ae[214],Re([1,0,5,6,78]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;class M{constructor($,D,g){this.d=$,this.e=D,this.f=g,this.a=0,this.b=new L.$Qc,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const A=D.getVisibleTextEditors();for(const S of this.c.values())A.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,D,g,A,S){let o;for(const u of this.e.getVisibleTextEditors(!0))if(u.value===$){o=u;break}if(!o)throw new Error("not a visible editor");const v=this,p=this.a++,f=new E.$Od,t=new E.$Od,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(u){return(0,P.$6tb)(u,v.f)}get cspSource(){return P.$5tb}set options(u){this.b=u,v.d.$setOptions(p,u)}get options(){return this.b}set html(u){this.a=u,v.d.$setHtml(p,u)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(u){return v.d.$postMessage(p,u)}},n=new class{constructor(){this.editor=$,this.line=D,this.height=g,this.webview=i,this.onDidDispose=t.event}dispose(){v.c.has(p)&&(v.c.delete(p),v.d.$disposeEditorInset(p),t.fire(),t.dispose(),f.dispose())}};return this.d.$createEditorInset(p,o.id,o.value.document.uri,D+1,g,A||{},S.identifier,S.extensionLocation),this.c.set(p,{editor:$,inset:n,onDidReceiveMessage:f}),n}$onDidDispose($){const D=this.c.get($);D&&D.inset.dispose()}$onDidReceiveMessage($,D){this.c.get($)?.onDidReceiveMessage.fire(D)}}e.$iec=M}),define(Ae[215],Re([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jN=e.VariableKind=e.$iN=void 0,e.$iN=(0,E.$Sh)("configurationResolverService");var L;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(L||(e.VariableKind=L={}));class P extends Error{constructor(R,$){super($),this.variable=R}}e.$jN=P}),define(Ae[216],Re([1,0,19,74,16,26,21,94,178,215,13]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,p,f,t){this.h=new Map,this.a=v,this.b=p,this.g=f,t&&(this.c=t.then(i=>this.i(i)))}i(v){if(R.$i){const p=Object.create(null);return Object.keys(v).forEach(f=>{p[f.toLowerCase()]=v[f]}),p}return v}resolveWithEnvironment(v,p,f){return this.l({env:this.i(v),userHome:void 0},p?p.uri:void 0,f)}async resolveAsync(v,p){const f={env:await this.c,userHome:await this.g};return this.l(f,v?v.uri:void 0,p)}async j(v,p,f,t){const i=M.$0m(p);R.$i&&i.windows?Object.keys(i.windows).forEach(u=>i[u]=i.windows[u]):R.$j&&i.osx?Object.keys(i.osx).forEach(u=>i[u]=i.osx[u]):R.$k&&i.linux&&Object.keys(i.linux).forEach(u=>i[u]=i.linux[u]),delete i.windows,delete i.osx,delete i.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,v?v.uri:void 0,i,f,t)}async resolveAnyAsync(v,p,f){return this.j(v,p,f)}async resolveAnyMap(v,p,f){const t=new Map;return{newConfig:await this.j(v,p,f,t),resolvedVariables:t}}resolveWithInteractionReplace(v,p,f,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,p,f,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,p){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,p)}async l(v,p,f,t,i){if(P.$zf(f))return this.m(v,p,f,t,i);if(Array.isArray(f))return Promise.all(f.map(n=>this.l(v,p,n,t,i)));if(P.$Bf(f)){const n=Object.create(null),u=await Promise.all(Object.keys(f).map(async a=>[await this.m(v,p,a,t,i),await this.l(v,p,f[a],t,i)]));for(const[a,l]of u)n[a]=l;return n}return f}m(v,p,f,t,i){return(0,A.$Ue)(f,S.VARIABLE_REGEXP,async(n,u)=>{if(u.includes(S.VARIABLE_LHS))return n;let a=await this.o(v,n,u,p,t);return i?.set(u,a),a!==n&&P.$zf(a)&&a.match(S.VARIABLE_REGEXP)&&(a=await this.m(v,p,a,t,i)),a})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,p,f,t,i){let n;const u=f.split(":");u.length>1&&(f=u[0],n=u[1]);const a=s=>{const c=this.a.getFilePath();if(c)return(0,$.$vv)(c);throw new g.$jN(s,(0,D.localize)(0,null,p))},l=s=>{const c=a(s);if(this.a.getWorkspaceFolderPathForFile){const h=this.a.getWorkspaceFolderPathForFile();if(h)return(0,$.$vv)(h)}throw new g.$jN(s,(0,D.localize)(1,null,p,E.$mc(c)))},r=s=>{if(n){const c=this.a.getFolderUri(n);if(c)return c;throw new g.$jN(s,(0,D.localize)(2,null,p,n))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new g.$jN(s,(0,D.localize)(3,null,p)):new g.$jN(s,(0,D.localize)(4,null,p))};switch(f){case"env":if(n){if(v.env){const s=v.env[R.$i?n.toLowerCase():n];if(P.$zf(s))return s}return""}throw new g.$jN(g.VariableKind.Env,(0,D.localize)(5,null,p));case"config":if(n){const s=this.a.getConfigurationValue(t,n);if(P.$If(s))throw new g.$jN(g.VariableKind.Config,(0,D.localize)(6,null,p,n));if(P.$Bf(s))throw new g.$jN(g.VariableKind.Config,(0,D.localize)(7,null,p,n));return s}throw new g.$jN(g.VariableKind.Config,(0,D.localize)(8,null,p));case"command":return this.p(g.VariableKind.Command,p,n,i,"command");case"input":return this.p(g.VariableKind.Input,p,n,i,"input");case"extensionInstallFolder":if(n){const s=await this.a.getExtension(n);if(!s)throw new g.$jN(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,p,n));return this.n(s.extensionLocation)}throw new g.$jN(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,p));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,$.$vv)(this.n(r(g.VariableKind.WorkspaceFolder)));case"cwd":return t||n?(0,$.$vv)(this.n(r(g.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$vv)(E.$mc(this.n(r(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new g.$jN(g.VariableKind.UserHome,(0,D.localize)(11,null,p))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new g.$jN(g.VariableKind.LineNumber,(0,D.localize)(12,null,p))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new g.$jN(g.VariableKind.SelectedText,(0,D.localize)(13,null,p))}case"file":return a(g.VariableKind.File);case"fileWorkspaceFolder":return l(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||n?E.$kc(this.n(r(g.VariableKind.RelativeFile)),a(g.VariableKind.RelativeFile)):a(g.VariableKind.RelativeFile);case"relativeFileDirname":{const s=E.$lc(a(g.VariableKind.RelativeFileDirname));if(t||n){const c=E.$kc(this.n(r(g.VariableKind.RelativeFileDirname)),s);return c.length===0?".":c}return s}case"fileDirname":return E.$lc(a(g.VariableKind.FileDirname));case"fileExtname":return E.$nc(a(g.VariableKind.FileExtname));case"fileBasename":return E.$mc(a(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=E.$mc(a(g.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-E.$nc(s).length)}case"fileDirnameBasename":return E.$mc(E.$lc(a(g.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||p}case"execInstallFolder":{const s=this.a.getAppRoot();return s||p}case"pathSeparator":return E.sep;default:try{const s=n?`${f}:${n}`:f;return this.p(g.VariableKind.Unknown,p,s,i,void 0)}catch{return p}}}}p(v,p,f,t,i){if(f&&t){const n=i===void 0?t[f]:t[i+":"+f];if(typeof n=="string")return n;throw new g.$jN(v,(0,D.localize)(14,null,p))}return p}}e.$xN=S}),define(Ae[105],Re([1,0,4,102]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FC=e.$EC=e.OpenEditorContext=e.GroupsOrder=e.$DC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$CC=void 0,e.$CC=(0,E.$Sh)("editorGroupsService");var P;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var M;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var R;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var $;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var D;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function g(p){const f=p;return(0,L.$kE)(f?.editor)&&(0,L.$kE)(f?.replacement)}e.$DC=g;var A;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var S;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function o(p){const f=p;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.$EC=o;function v(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$FC=v}),define(Ae[217],Re([1,0,4,105]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=e.$IC=e.$HC=e.$GC=void 0,e.$GC=(0,E.$Sh)("editorService"),e.$HC=-1,e.$IC=-2;function P(M){const R=M;return typeof M=="number"||(0,L.$EC)(R)}e.$JC=P}),define(Ae[218],Re([1,0,4,185]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OJ=void 0,e.$OJ=(0,E.$Th)(L.$Zh)}),define(Ae[106],Re([1,0,22,5,19,6]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r5b=e.$q5b=e.$p5b=e.$o5b=e.$n5b=void 0;class R{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$n5b=R;class ${static isHostExtension(i,n,u){if(n.getExtensionDescription(i))return!1;const a=u.getExtensionDescription(i);return a?!!((a.main||a.browser)&&a.api==="none"):!1}constructor(i,n){this.j=i,this.c=new L.$Od,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(p),this.f=new E.$$l,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const u of n)this.h.has(u)||this.h.set(u,[]),this.h.get(u).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=f(this.e,n),this.e=this.e.concat(i);const u=$.l(this.e);return this.e=f(this.e,u.map(a=>a.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,u)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,c){this.addNode(s),this.addNode(c),this.c.has(s)?this.c.get(s).push(c):this.c.set(s,[c])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,c){const h=n.getArcs(s);for(let w=0;w<h.length;w++)if(!c.has(h[w]))return!1;return!0}getNodes(){return this.e}},u=new E.$$l;for(const s of i)if(u.set(s.identifier,s),s.extensionDependencies)for(const c of s.extensionDependencies)n.addArc(E.$9l.toKey(s.identifier),E.$9l.toKey(c));const a=new Set;n.getNodes().filter(s=>n.getArcs(s).length===0).forEach(s=>a.add(s));const l=n.getNodes().filter(s=>!a.has(s));let r;do{r=!1;for(let s=0;s<l.length;s++){const c=l[s];n.hasOnlyGoodArcs(c,a)&&(l.splice(s,1),s--,a.add(c),r=!0)}}while(r);return l.map(s=>u.get(s))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$o5b=$;class D{constructor(i,n){this.versionId=i,this.extensions=n}}e.$p5b=D;class g{constructor(i){this.d=new o,this.c=new $(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new A(this,n)}deltaExtensions(i,n,u){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,u)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$q5b=g;class A extends M.$Rc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$r5b=A;class S{constructor(i){this.name=i,this.promise=new Promise((n,u)=>{this.c=n})}resolve(i){this.c(i)}}class o{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new S(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const u=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),a=()=>{n&&(clearTimeout(u),n=!1,this.d=!1,this.e())};i.resolve((0,M.$Pc)(a))}}var v;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(v||(v={}));function p(t,i){const n=t.isBuiltin?0:t.isUnderDevelopment?2:1,u=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==u)return n-u;const a=P.$fc.basename(t.extensionLocation.path),l=P.$fc.basename(i.extensionLocation.path);return a<l?-1:a>l?1:0}function f(t,i){const n=new E.$0l(i);return t.filter(u=>!n.has(u.identifier))}}),define(Ae[79],Re([1,0,24]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$fm=e.$em=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(L||(e.UIKind=L={}));var P;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var M;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function R(g){const A=E.$ce.alloc(1);switch(g){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$em=R;function $(g,A){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$fm=$;var D;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Ae[61],Re([1,0,4,5,15,27,79,57,58,26,2,6,166]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.$OM=e.$NM=void 0;let v=class extends S.$Rc{constructor(i,n){super(),this.s=i,this.t=n,this.a=this.B(new L.$Od),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.$Od),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:D.$ro,name:(0,o.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(n.onDidChangeLogLevel(u=>{(0,P.$cj)(u)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,n,u){const a=this.getTelemetryDetails(),l=new p(n,u,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),r=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...r,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(i,n,u){this.f=i,this.g=n,this.c=u??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const n=Object.create(null);switch(n["common.extname"]=`${i.publisher}.${i.name}`,n["common.extversion"]=i.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$Yk)((0,D.$yo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const n=this.getTelemetryDetails();this.r.forEach((u,a)=>{const l=u.filter(r=>!r.isDisposed);l.length===0?this.r.delete(a):this.r.set(a,l)}),this.r.forEach(u=>{for(const a of u)a.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,n){const a=this.r.get(i.value)?.filter(r=>!r.isDisposed);if(!a)return this.r.delete(i.value),!1;let l=!1;for(const r of a)r.ignoreUnhandledExtHostErrors||(r.logError(n),l=!0);return l}};e.$NM=v,e.$NM=v=Ke([Ve(0,M.$MM),Ve(1,P.$bj)],v);class p{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,n,u,a,l,r,s){this.g=u,this.h=a,this.i=l,this.j=r,this.a=new L.$Od,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(i,n){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let n="properties"in i?i.properties??{}:i;return n=(0,D.$Bo)(n,[]),this.c&&(n=(0,g.$an)(n,this.c)),this.b||(n=(0,g.$an)(n,this.j)),"properties"in i?i.properties=n:i=n,i}k(i,n){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(i,n),this.h.trace(i,n))}logUsage(i,n){this.d.isUsageEnabled&&this.k(i,n)}logError(i,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,n);else{const u={name:i.name,message:i.message,stack:i.stack,cause:i.cause},a=(0,D.$Bo)(u,[]),l=new Error(a.message,{cause:a.cause});l.stack=a.stack,l.name=a.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(l,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const i=this,n={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$OM=p;function f(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$PM=f,e.$QM=(0,E.$Sh)("IExtHostTelemetry")}),define(Ae[23],Re([1,0,5,2,194,101,22,4]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zF=e.$yF=e.$xF=e.ActivationKind=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.ExtensionHostStartup=e.$rF=e.$qF=e.$pF=e.$oF=void 0,e.$oF=Object.freeze({identifier:new R.$9l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$pF="extensions.webWorker",e.$qF=(0,$.$Sh)("extensionService");class D{constructor(l){this.dependency=l}}e.$rF=D;var g;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,r,s){this.c=l,this.d=r.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$_E.createActivationEventsMap(this.d)}}set(l,r,s){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const c=[],h=[],w=[],m=[],I=S(this.d),k=S(r),d=(H,U)=>H.extensionLocation.toString()===U.extensionLocation.toString()||H.isBuiltin===U.isBuiltin||H.isUserBuiltin===U.isUserBuiltin||H.isUnderDevelopment===U.isUnderDevelopment;for(const H of this.d){const U=k.get(H.identifier);if(!U){c.push(H.identifier),I.delete(H.identifier);continue}if(!d(H,U)){c.push(H.identifier),I.delete(H.identifier);continue}}for(const H of r){const U=I.get(H.identifier);if(!U){h.push(H);continue}if(!d(U,H)){c.push(U.identifier),I.delete(U.identifier);continue}}const b=new R.$0l(this.e),y=new R.$0l(s);for(const H of this.e)y.has(H)||w.push(H);for(const H of s)b.has(H)||m.push(H);const C=M.$_E.createActivationEventsMap(h),B={versionId:l,toRemove:c,toAdd:h,addActivationEvents:C,myToRemove:w,myToAdd:m};return this.delta(B),B}delta(l){if(this.c>=l.versionId)return null;const{toRemove:r,toAdd:s,myToRemove:c,myToAdd:h}=l,w=new R.$0l(r),m=new R.$0l(c);for(let I=0;I<this.d.length;I++)w.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)m.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of s)this.d.push(I);for(const I of h)this.e.push(I);return this.f=null,l}containsExtension(l){for(const r of this.e)if(R.$9l.equals(r,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const r of this.d){if(!this.containsExtension(r.identifier))continue;const s=M.$_E.readActivationEvents(r);for(const c of s)l.add(c)}return l}}e.$sF=A;function S(a){const l=new R.$$l;for(const r of a)l.set(r.identifier,r);return l}function o(a,l){return a.enabledApiProposals?a.enabledApiProposals.includes(l):!1}e.$tF=o;function v(a,l){if(!o(a,l))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.$uF=v;class p{constructor(l,r,s,c){this.codeLoadingTime=l,this.activateCallTime=r,this.activateResolvedTime=s,this.activationReason=c}}e.$vF=p;class f{constructor(l,r){this.description=l,this.value=r}}e.$wF=f;var t;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,P.$Ho)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.$xF=i;function n(a,l){return{identifier:new R.$9l((0,P.$Fo)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!l,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}e.$yF=n;class u{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$zF=u}),define(Ae[219],Re([1,0,11,106,22,23,15,12]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=e.$ydc=e.$xdc=e.$wdc=e.$vdc=e.$udc=void 0;class D{static{this.NONE=new D(!1,-1,-1,-1)}constructor(i,n,u,a){this.startup=i,this.codeLoadingTime=n,this.activateCallTime=u,this.activateResolvedTime=a}}e.$udc=D;class g{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,n){return i===-1||n===-1?-1:n-i}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$vdc=g;class A{constructor(i,n,u,a,l,r){this.activationFailed=i,this.activationFailedError=n,this.activationTimes=u,this.module=a,this.exports=l,this.subscriptions=r}}e.$wdc=A;class S extends A{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$xdc=S;class o extends A{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$ydc=o;class v extends A{constructor(i){super(!0,i,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(i,n,u,a){this.g=a,this.a=i,this.b=n,this.c=u,this.d=new P.$$l,this.f=Object.create(null)}dispose(){for(const[i,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const i=[];for(const[n,u]of this.d)i.push(u.wait());await Promise.all(i)}isActivated(i){const n=this.d.get(i);return!!(n&&n.value)}getActivatedExtension(i){const n=this.d.get(i);if(!n||!n.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return n.value}async activateByEvent(i,n){if(this.f[i])return;const u=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(u.map(a=>({id:a.identifier,reason:{startup:n,extensionId:a.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,n){const u=this.a.getExtensionDescription(i);if(!u)throw new Error(`Extension '${i}' is not known`);return this.h([{id:u.identifier,reason:n}])}async h(i){const n=i.filter(u=>!this.isActivated(u.id)).map(u=>this.j(u));await Promise.all(n.map(u=>u.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const n=this.a.getExtensionDescription(i.id);if(!n){const l=new Error(`Cannot activate unknown extension '${i.id.value}'`),r=this.k(i,null,[],new v(l));return this.c.onExtensionActivationError(i.id,l,new M.$rF(i.id.value)),r}const u=[],a=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const l of a){if(this.m(l))continue;const r=this.d.get(l);if(r){u.push(r);continue}if(this.l(l)){u.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:i.reason}));continue}const s=this.a.getExtensionDescription(l);if(s){if(!s.main&&!s.browser)continue;u.push(this.j({id:s.identifier,reason:i.reason}));continue}const c=n.displayName||n.identifier.value,h=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${l}'`),w=this.k(i,n.displayName,[],new v(h));return this.c.onExtensionActivationError(n.identifier,h,new M.$rF(l)),w}return this.k(i,n.displayName,u,null)}k(i,n,u,a){const l=new f(i.id,n,i.reason,u,a,this.c,this.g);return this.d.set(i.id,l),l}l(i){return L.$o5b.isHostExtension(i,this.a,this.b)}m(i){const n=this.b.getExtensionDescription(i);return n?!n.main&&!n.browser:!1}};e.$zdc=p,e.$zdc=p=Ke([Ve(3,R.$aj)],p);let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,n,u,a,l,r,s){this.c=i,this.d=n,this.f=u,this.g=a,this.h=l,this.j=r,this.k=s,this.a=new $.$Tg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const n=this.g[i];if(n.value&&!n.value.activationFailed){this.g.splice(i,1),i--;continue}if(n.value&&n.value.activationFailed){const u=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);u.detail=n.value.activationFailedError,this.h=new v(u),this.j.onExtensionActivationError(this.c,u,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const n=new Error;if(i&&i.name&&(n.name=i.name),i&&i.message?n.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(n.stack=i.stack),this.h=new v(n),this.b&&E.$3(i))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};f=Ke([Ve(6,R.$aj)],f)}),define(Ae[8],Re([1,0,18,24,126,220,53,28,120,52,69,26,16,2,29,80,98,104,102,76,48,60,217,7,23]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$vM=e.$uM=e.MarkdownString=e.$tM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var h;(function(Ie){function Le(K){const{selectionStartLineNumber:Me,selectionStartColumn:Ue,positionLineNumber:Je,positionColumn:qe}=K,et=new s.$xK(Me-1,Ue-1),Et=new s.$xK(Je-1,qe-1);return new s.$zK(et,Et)}Ie.to=Le;function $e(K){const{anchor:Me,active:Ue}=K;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Ie.from=$e})(h||(e.Selection=h={}));var w;(function(Ie){function Le(K){if(!K)return;const{start:Me,end:Ue}=K;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Ie.from=Le;function $e(K){if(!K)return;const{startLineNumber:Me,startColumn:Ue,endLineNumber:Je,endColumn:qe}=K;return new s.$yK(Me-1,Ue-1,Je-1,qe-1)}Ie.to=$e})(w||(e.Range=w={}));var m;(function(Ie){function Le($e){switch($e){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ie.to=Le})(m||(e.TokenType=m={}));var I;(function(Ie){function Le(K){return new s.$xK(K.lineNumber-1,K.column-1)}Ie.to=Le;function $e(K){return{lineNumber:K.line+1,column:K.character+1}}Ie.from=$e})(I||(e.Position=I={}));var k;(function(Ie){function Le(Me,Ue,Je){return(0,E.$Gb)((0,E.$2b)(Me).map(qe=>$e(qe,Ue,Je)))}Ie.from=Le;function $e(Me,Ue,Je){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Je?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:K(Me.scheme,Ue),pattern:Z.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Je?.isBuiltin}}function K(Me,Ue){return Ue&&typeof Me=="string"?Ue.transformOutgoingScheme(Me):Me}})(k||(e.DocumentSelector=k={}));var d;(function(Ie){function Le(K){switch(K){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ie.from=Le;function $e(K){switch(K){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ie.to=$e})(d||(e.DiagnosticTag=d={}));var b;(function(Ie){function Le(K){let Me;return K.code&&((0,o.$zf)(K.code)||(0,o.$Df)(K.code)?Me=String(K.code):Me={value:String(K.code.value),target:K.code.target}),{...w.from(K.range),message:K.message,source:K.source,code:Me,severity:C.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(y.from),tags:Array.isArray(K.tags)?(0,E.$Gb)(K.tags.map(d.from)):void 0}}Ie.from=Le;function $e(K){const Me=new s.$KK(w.to(K),K.message,C.to(K.severity));return Me.source=K.source,Me.code=(0,o.$zf)(K.code)?K.code:K.code?.value,Me.relatedInformation=K.relatedInformation&&K.relatedInformation.map(y.to),Me.tags=K.tags&&(0,E.$Gb)(K.tags.map(d.to)),Me}Ie.to=$e})(b||(e.Diagnostic=b={}));var y;(function(Ie){function Le(K){return{...w.from(K.location.range),message:K.message,resource:K.location.uri}}Ie.from=Le;function $e(K){return new s.$JK(new s.$IK(K.resource,w.to(K)),K.message)}Ie.to=$e})(y||(e.DiagnosticRelatedInformation=y={}));var C;(function(Ie){function Le(K){switch(K){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ie.from=Le;function $e(K){switch(K){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ie.to=$e})(C||(e.DiagnosticSeverity=C={}));var B;(function(Ie){function Le(K){return typeof K=="number"&&K>=s.ViewColumn.One?K-1:K===s.ViewColumn.Beside?r.$IC:r.$HC}Ie.from=Le;function $e(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Ie.to=$e})(B||(e.ViewColumn=B={}));function H(Ie){return typeof Ie.range<"u"}function U(Ie){return Ie.length===0?!0:!!H(Ie[0])}e.$tM=U;var z;(function(Ie){function Le(qe){return qe.map(Ie.from)}Ie.fromMany=Le;function $e(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function K(qe){let et;if($e(qe)){const{language:ht,value:ft}=qe;et={value:"```"+ht+`
`+ft+"\n```\n"}}else s.$WK.isMarkdownString(qe)?et={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?et={value:qe}:et={value:""};const Et=Object.create(null);et.uris=Et;const Dt=ht=>{try{let ft=v.URI.parse(ht,!0);ft=ft.with({query:Me(ft.query,Et)}),Et[ht]=ft}catch{}return""},gt=new D.marked.Renderer;return gt.link=Dt,gt.image=ht=>typeof ht=="string"?Dt(R.$ak(ht).href):"",(0,D.marked)(et.value,{renderer:gt}),et}Ie.from=K;function Me(qe,et){if(!qe)return qe;let Et;try{Et=(0,g.$oh)(qe)}catch{}if(!Et)return qe;let Dt=!1;return Et=(0,S.$_m)(Et,gt=>{if(v.URI.isUri(gt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[ht]=gt,Dt=!0,ht}else return}),Dt?JSON.stringify(Et):qe}function Ue(qe){const et=new s.$WK(qe.value,qe.supportThemeIcons);return et.isTrusted=qe.isTrusted,et.supportHtml=qe.supportHtml,et.baseUri=qe.baseUri?v.URI.from(qe.baseUri):void 0,et}Ie.to=Ue;function Je(qe){if(qe)return typeof qe=="string"?qe:Ie.from(qe)}Ie.fromStrict=Je})(z||(e.MarkdownString=z={}));function F(Ie){return U(Ie)?Ie.map(Le=>({range:w.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?z.fromMany(Le.hoverMessage):Le.hoverMessage?z.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Ie.map(Le=>({range:w.from(Le)}))}e.$uM=F;function N(Ie){return typeof Ie>"u"?Ie:typeof Ie=="string"?v.URI.file(Ie):Ie}e.$vM=N;var X;(function(Ie){function Le($e){return typeof $e>"u"?$e:{contentText:$e.contentText,contentIconPath:$e.contentIconPath?N($e.contentIconPath):void 0,border:$e.border,borderColor:$e.borderColor,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,color:$e.color,backgroundColor:$e.backgroundColor,margin:$e.margin,width:$e.width,height:$e.height}}Ie.from=Le})(X||(e.ThemableDecorationAttachmentRenderOptions=X={}));var Q;(function(Ie){function Le($e){return typeof $e>"u"?$e:{backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?N($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?X.from($e.before):void 0,after:$e.after?X.from($e.after):void 0}}Ie.from=Le})(Q||(e.ThemableDecorationRenderOptions=Q={}));var De;(function(Ie){function Le($e){if(typeof $e>"u")return $e;switch($e){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ie.from=Le})(De||(e.DecorationRangeBehavior=De={}));var ke;(function(Ie){function Le($e){return{isWholeLine:$e.isWholeLine,rangeBehavior:$e.rangeBehavior?De.from($e.rangeBehavior):void 0,overviewRulerLane:$e.overviewRulerLane,light:$e.light?Q.from($e.light):void 0,dark:$e.dark?Q.from($e.dark):void 0,backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?N($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?X.from($e.before):void 0,after:$e.after?X.from($e.after):void 0}}Ie.from=Le})(ke||(e.DecorationRenderOptions=ke={}));var Pe;(function(Ie){function Le(K){return{text:K.newText,eol:K.newEol&&xe.from(K.newEol),range:w.from(K.range)}}Ie.from=Le;function $e(K){const Me=new s.$DK(w.to(K.range),K.text);return Me.newEol=typeof K.eol>"u"?void 0:xe.to(K.eol),Me}Ie.to=$e})(Pe||(e.TextEdit=Pe={}));var fe;(function(Ie){function Le(K,Me){const Ue={edits:[]};if(K instanceof s.$GK){const Je=new $.$Ac;for(const qe of K._allEntries())qe._type===1&&v.URI.isUri(qe.to)&&qe.from===void 0&&Je.add(qe.to);for(const qe of K._allEntries())if(qe._type===1){let et;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?et={type:"base64",value:(0,L.$we)(L.$ce.wrap(qe.options.contents))}:et={type:"dataTransferItem",id:qe.options.contents._itemId}),Ue.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:et},metadata:qe.metadata})}else qe._type===2?Ue.edits.push({resource:qe.uri,textEdit:Pe.from(qe.edit),versionId:Je.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ue.edits.push({resource:qe.uri,textEdit:{range:w.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Je.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ue.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ue.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(wt.from)}})}return Ue}Ie.from=Le;function $e(K){const Me=new s.$GK,Ue=new $.$zc;for(const Je of K.edits)if(Je.textEdit){const qe=Je,et=v.URI.revive(qe.resource),Et=w.to(qe.textEdit.range),Dt=qe.textEdit.text,gt=qe.textEdit.insertAsSnippet;let ht;gt?ht=s.$FK.replace(Et,new s.$HK(Dt)):ht=s.$DK.replace(Et,Dt);const ft=Ue.get(et);ft?ft.push(ht):Ue.set(et,[ht])}else Me.renameFile(v.URI.revive(Je.oldResource),v.URI.revive(Je.newResource),Je.options);for(const[Je,qe]of Ue)Me.set(Je,qe);return Me}Ie.to=$e})(fe||(e.WorkspaceEdit=fe={}));var we;(function(Ie){const Le=Object.create(null);Le[s.SymbolKind.File]=0,Le[s.SymbolKind.Module]=1,Le[s.SymbolKind.Namespace]=2,Le[s.SymbolKind.Package]=3,Le[s.SymbolKind.Class]=4,Le[s.SymbolKind.Method]=5,Le[s.SymbolKind.Property]=6,Le[s.SymbolKind.Field]=7,Le[s.SymbolKind.Constructor]=8,Le[s.SymbolKind.Enum]=9,Le[s.SymbolKind.Interface]=10,Le[s.SymbolKind.Function]=11,Le[s.SymbolKind.Variable]=12,Le[s.SymbolKind.Constant]=13,Le[s.SymbolKind.String]=14,Le[s.SymbolKind.Number]=15,Le[s.SymbolKind.Boolean]=16,Le[s.SymbolKind.Array]=17,Le[s.SymbolKind.Object]=18,Le[s.SymbolKind.Key]=19,Le[s.SymbolKind.Null]=20,Le[s.SymbolKind.EnumMember]=21,Le[s.SymbolKind.Struct]=22,Le[s.SymbolKind.Event]=23,Le[s.SymbolKind.Operator]=24,Le[s.SymbolKind.TypeParameter]=25;function $e(Me){return typeof Le[Me]=="number"?Le[Me]:6}Ie.from=$e;function K(Me){for(const Ue in Le)if(Le[Ue]===Me)return Number(Ue);return s.SymbolKind.Property}Ie.to=K})(we||(e.SymbolKind=we={}));var ne;(function(Ie){function Le(K){switch(K){case s.SymbolTag.Deprecated:return 1}}Ie.from=Le;function $e(K){switch(K){case 1:return s.SymbolTag.Deprecated}}Ie.to=$e})(ne||(e.SymbolTag=ne={}));var re;(function(Ie){function Le(K){return{name:K.name,kind:we.from(K.kind),tags:K.tags&&K.tags.map(ne.from),containerName:K.containerName,location:be.from(K.location)}}Ie.from=Le;function $e(K){const Me=new s.$NK(K.name,we.to(K.kind),K.containerName,be.to(K.location));return Me.tags=K.tags&&K.tags.map(ne.to),Me}Ie.to=$e})(re||(e.WorkspaceSymbol=re={}));var pe;(function(Ie){function Le(K){const Me={name:K.name||"!!MISSING: name!!",detail:K.detail,range:w.from(K.range),selectionRange:w.from(K.selectionRange),kind:we.from(K.kind),tags:K.tags?.map(ne.from)??[]};return K.children&&(Me.children=K.children.map(Le)),Me}Ie.from=Le;function $e(K){const Me=new s.$OK(K.name,K.detail,we.to(K.kind),w.to(K.range),w.to(K.selectionRange));return(0,E.$Kb)(K.tags)&&(Me.tags=K.tags.map(ne.to)),K.children&&(Me.children=K.children.map($e)),Me}Ie.to=$e})(pe||(e.DocumentSymbol=pe={}));var _;(function(Ie){function Le(K){const Me=new s.$SK(we.to(K.kind),K.name,K.detail||"",v.URI.revive(K.uri),w.to(K.range),w.to(K.selectionRange));return Me._sessionId=K._sessionId,Me._itemId=K._itemId,Me}Ie.to=Le;function $e(K,Me,Ue){if(Me=Me??K._sessionId,Ue=Ue??K._itemId,Me===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ue,name:K.name,detail:K.detail,kind:we.from(K.kind),uri:K.uri,range:w.from(K.range),selectionRange:w.from(K.selectionRange),tags:K.tags?.map(ne.from)}}Ie.from=$e})(_||(e.CallHierarchyItem=_={}));var W;(function(Ie){function Le($e){return new s.$TK(_.to($e.from),$e.fromRanges.map(K=>w.to(K)))}Ie.to=Le})(W||(e.CallHierarchyIncomingCall=W={}));var ce;(function(Ie){function Le($e){return new s.$UK(_.to($e.to),$e.fromRanges.map(K=>w.to(K)))}Ie.to=Le})(ce||(e.CallHierarchyOutgoingCall=ce={}));var be;(function(Ie){function Le(K){return{range:K.range&&w.from(K.range),uri:K.uri}}Ie.from=Le;function $e(K){return new s.$IK(v.URI.revive(K.uri),w.to(K.range))}Ie.to=$e})(be||(e.location=be={}));var se;(function(Ie){function Le(K){const Me=K,Ue=K;return{originSelectionRange:Me.originSelectionRange?w.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Ue.uri,range:w.from(Me.targetRange?Me.targetRange:Ue.range),targetSelectionRange:Me.targetSelectionRange?w.from(Me.targetSelectionRange):void 0}}Ie.from=Le;function $e(K){return{targetUri:v.URI.revive(K.uri),targetRange:w.to(K.range),targetSelectionRange:K.targetSelectionRange?w.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?w.to(K.originSelectionRange):void 0}}Ie.to=$e})(se||(e.DefinitionLink=se={}));var he;(function(Ie){function Le(K){return{range:w.from(K.range),contents:z.fromMany(K.contents)}}Ie.from=Le;function $e(K){return new s.$LK(K.contents.map(z.to),w.to(K.range))}Ie.to=$e})(he||(e.Hover=he={}));var ue;(function(Ie){function Le(K){return{range:w.from(K.range),expression:K.expression}}Ie.from=Le;function $e(K){return new s.$EL(w.to(K.range),K.expression)}Ie.to=$e})(ue||(e.EvaluatableExpression=ue={}));var ye;(function(Ie){function Le(K){if(K instanceof s.$FL)return{type:"text",range:w.from(K.range),text:K.text};if(K instanceof s.$GL)return{type:"variable",range:w.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof s.$HL)return{type:"expression",range:w.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Ie.from=Le;function $e(K){switch(K.type){case"text":return{range:w.to(K.range),text:K.text};case"variable":return{range:w.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:w.to(K.range),expression:K.expression}}}Ie.to=$e})(ye||(e.InlineValue=ye={}));var ee;(function(Ie){function Le(K){return{frameId:K.frameId,stoppedLocation:w.from(K.stoppedLocation)}}Ie.from=Le;function $e(K){return new s.$IL(K.frameId,w.to(K.stoppedLocation))}Ie.to=$e})(ee||(e.InlineValueContext=ee={}));var de;(function(Ie){function Le(K){return{range:w.from(K.range),kind:K.kind}}Ie.from=Le;function $e(K){return new s.$MK(w.to(K.range),K.kind)}Ie.to=$e})(de||(e.DocumentHighlight=de={}));var ie;(function(Ie){function Le($e){switch($e){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ie.to=Le})(ie||(e.CompletionTriggerKind=ie={}));var ae;(function(Ie){function Le($e){return{triggerKind:ie.to($e.triggerKind),triggerCharacter:$e.triggerCharacter}}Ie.to=Le})(ae||(e.CompletionContext=ae={}));var me;(function(Ie){function Le(K){switch(K){case s.CompletionItemTag.Deprecated:return 1}}Ie.from=Le;function $e(K){switch(K){case 1:return s.CompletionItemTag.Deprecated}}Ie.to=$e})(me||(e.CompletionItemTag=me={}));var Ce;(function(Ie){const Le=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function $e(Ue){return Le.get(Ue)??9}Ie.from=$e;const K=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Me(Ue){return K.get(Ue)??s.CompletionItemKind.Property}Ie.to=Me})(Ce||(e.CompletionItemKind=Ce={}));var T;(function(Ie){function Le($e,K){const Me=new s.$3K($e.label);return Me.insertText=$e.insertText,Me.kind=Ce.to($e.kind),Me.tags=$e.tags?.map(me.to),Me.detail=$e.detail,Me.documentation=R.$8j($e.documentation)?z.to($e.documentation):$e.documentation,Me.sortText=$e.sortText,Me.filterText=$e.filterText,Me.preselect=$e.preselect,Me.commitCharacters=$e.commitCharacters,p.$ws.isIRange($e.range)?Me.range=w.to($e.range):typeof $e.range=="object"&&(Me.range={inserting:w.to($e.range.insert),replacing:w.to($e.range.replace)}),Me.keepWhitespace=typeof $e.insertTextRules>"u"?!1:!!($e.insertTextRules&1),typeof $e.insertTextRules<"u"&&$e.insertTextRules&4?Me.insertText=new s.$HK($e.insertText):(Me.insertText=$e.insertText,Me.textEdit=Me.range instanceof s.$yK?new s.$DK(Me.range,Me.insertText):void 0),$e.additionalTextEdits&&$e.additionalTextEdits.length>0&&(Me.additionalTextEdits=$e.additionalTextEdits.map(Ue=>Pe.to(Ue))),Me.command=K&&$e.command?K.fromInternal($e.command):void 0,Me}Ie.to=Le})(T||(e.CompletionItem=T={}));var V;(function(Ie){function Le(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:z.fromStrict(K.documentation)}}Ie.from=Le;function $e(K){return{label:K.label,documentation:R.$8j(K.documentation)?z.to(K.documentation):K.documentation}}Ie.to=$e})(V||(e.ParameterInformation=V={}));var G;(function(Ie){function Le(K){return{label:K.label,documentation:z.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(V.from):[],activeParameter:K.activeParameter}}Ie.from=Le;function $e(K){return{label:K.label,documentation:R.$8j(K.documentation)?z.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(V.to):[],activeParameter:K.activeParameter}}Ie.to=$e})(G||(e.SignatureInformation=G={}));var J;(function(Ie){function Le(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(G.from):[]}}Ie.from=Le;function $e(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(G.to):[]}}Ie.to=$e})(J||(e.SignatureHelp=J={}));var q;(function(Ie){function Le($e,K){const Me=new s.$2K(I.to(K.position),typeof K.label=="string"?K.label:K.label.map(x.to.bind(void 0,$e)),K.kind&&le.to(K.kind));return Me.textEdits=K.textEdits&&K.textEdits.map(Pe.to),Me.tooltip=R.$8j(K.tooltip)?z.to(K.tooltip):K.tooltip,Me.paddingLeft=K.paddingLeft,Me.paddingRight=K.paddingRight,Me}Ie.to=Le})(q||(e.InlayHint=q={}));var x;(function(Ie){function Le($e,K){const Me=new s.$1K(K.label);return Me.tooltip=R.$8j(K.tooltip)?z.to(K.tooltip):K.tooltip,f.Command.is(K.command)&&(Me.command=$e.fromInternal(K.command)),K.location&&(Me.location=be.to(K.location)),Me}Ie.to=Le})(x||(e.InlayHintLabelPart=x={}));var le;(function(Ie){function Le(K){return K}Ie.from=Le;function $e(K){return K}Ie.to=$e})(le||(e.InlayHintKind=le={}));var Oe;(function(Ie){function Le(K){return{range:w.from(K.range),url:K.target,tooltip:K.tooltip}}Ie.from=Le;function $e(K){let Me;if(K.url)try{Me=typeof K.url=="string"?v.URI.parse(K.url,!0):v.URI.revive(K.url)}catch{}return new s.$8K(w.to(K.range),Me)}Ie.to=$e})(Oe||(e.DocumentLink=Oe={}));var je;(function(Ie){function Le(K){const Me=new s.$$K(K.label);return K.textEdit&&(Me.textEdit=Pe.to(K.textEdit)),K.additionalTextEdits&&(Me.additionalTextEdits=K.additionalTextEdits.map(Ue=>Pe.to(Ue))),Me}Ie.to=Le;function $e(K){return{label:K.label,textEdit:K.textEdit?Pe.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Me=>Pe.from(Me)):void 0}}Ie.from=$e})(je||(e.ColorPresentation=je={}));var Qe;(function(Ie){function Le(K){return new s.$9K(K[0],K[1],K[2],K[3])}Ie.to=Le;function $e(K){return[K.red,K.green,K.blue,K.alpha]}Ie.from=$e})(Qe||(e.Color=Qe={}));var Ge;(function(Ie){function Le(K){return{range:w.from(K.range)}}Ie.from=Le;function $e(K){return new s.$RK(w.to(K.range))}Ie.to=$e})(Ge||(e.SelectionRange=Ge={}));var _e;(function(Ie){function Le($e){switch($e){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ie.to=Le})(_e||(e.TextDocumentSaveReason=_e={}));var Xe;(function(Ie){function Le(K){switch(K){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ie.from=Le;function $e(K){switch(K){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ie.to=$e})(Xe||(e.TextEditorLineNumbersStyle=Xe={}));var xe;(function(Ie){function Le(K){if(K===s.EndOfLine.CRLF)return 1;if(K===s.EndOfLine.LF)return 0}Ie.from=Le;function $e(K){if(K===1)return s.EndOfLine.CRLF;if(K===0)return s.EndOfLine.LF}Ie.to=$e})(xe||(e.EndOfLine=xe={}));var it;(function(Ie){function Le($e){if(typeof $e=="object")return $e.viewId;switch($e){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ie.from=Le})(it||(e.ProgressLocation=it={}));var tt;(function(Ie){function Le(K){const Me={start:K.start+1,end:K.end+1};return K.kind&&(Me.kind=ze.from(K.kind)),Me}Ie.from=Le;function $e(K){const Me={start:K.start-1,end:K.end-1};return K.kind&&(Me.kind=ze.to(K.kind)),Me}Ie.to=$e})(tt||(e.FoldingRange=tt={}));var ze;(function(Ie){function Le(K){if(K)switch(K){case s.FoldingRangeKind.Comment:return f.$lt.Comment;case s.FoldingRangeKind.Imports:return f.$lt.Imports;case s.FoldingRangeKind.Region:return f.$lt.Region}}Ie.from=Le;function $e(K){if(K)switch(K.value){case f.$lt.Comment.value:return s.FoldingRangeKind.Comment;case f.$lt.Imports.value:return s.FoldingRangeKind.Imports;case f.$lt.Region.value:return s.FoldingRangeKind.Region}}Ie.to=$e})(ze||(e.FoldingRangeKind=ze={}));var ut;(function(Ie){function Le($e){if($e)return{pinned:typeof $e.preview=="boolean"?!$e.preview:void 0,inactive:$e.background,preserveFocus:$e.preserveFocus,selection:typeof $e.selection=="object"?w.from($e.selection):void 0,override:typeof $e.override=="boolean"?n.$0D.id:void 0}}Ie.from=Le})(ut||(e.TextEditorOpenOptions=ut={}));var Z;(function(Ie){function Le(Ue){return Ue instanceof s.$sL?Ue.toJSON():typeof Ue=="string"?Ue:$e(Ue)||K(Ue)?new s.$sL(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Ie.from=Le;function $e(Ue){const Je=Ue;return Je?v.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function K(Ue){const Je=Ue;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Me(Ue){return typeof Ue=="string"?Ue:new s.$sL(v.URI.revive(Ue.baseUri),Ue.pattern)}Ie.to=Me})(Z||(e.GlobPattern=Z={}));var Y;(function(Ie){function Le($e){if($e){if(Array.isArray($e))return $e.map(Le);if(typeof $e=="string")return $e;{const K=$e;return{language:K.language,scheme:K.scheme,pattern:Z.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Ie.from=Le})(Y||(e.LanguageSelector=Y={}));var Ee;(function(Ie){function Le(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Me=>Array.isArray(Me)&&Me.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&v.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Je=>Je instanceof s.$yK)))}Ie.is=Le;function $e(K){return{documents:K.documents.map(Me=>Me.map(Ue=>({uri:v.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Je=>w.from(Je))})))}}Ie.from=$e})(Ee||(e.MappedEditsContext=Ee={}));var Be;(function(Ie){function Le(K){return{start:K.start,end:K.end}}Ie.from=Le;function $e(K){return new s.$TL(K.start,K.end)}Ie.to=$e})(Be||(e.NotebookRange=Be={}));var Ne;(function(Ie){function Le(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Ie.to=Le;function $e(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Ie.from=$e})(Ne||(e.NotebookCellExecutionSummary=Ne={}));var Ye;(function(Ie){function Le($e){if($e===u.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if($e===u.NotebookCellExecutionState.Pending)return;if($e===u.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${$e}`)}Ie.to=Le})(Ye||(e.NotebookCellExecutionState=Ye={}));var nt;(function(Ie){function Le(K){switch(K){case s.NotebookCellKind.Markup:return u.CellKind.Markup;case s.NotebookCellKind.Code:default:return u.CellKind.Code}}Ie.from=Le;function $e(K){switch(K){case u.CellKind.Markup:return s.NotebookCellKind.Markup;case u.CellKind.Code:default:return s.NotebookCellKind.Code}}Ie.to=$e})(nt||(e.NotebookCellKind=nt={}));var $t;(function(Ie){function Le(K){const Me={metadata:K.metadata??Object.create(null),cells:[]};for(const Ue of K.cells)s.$UL.validate(Ue),Me.cells.push(wt.from(Ue));return Me}Ie.from=Le;function $e(K){const Me=new s.$VL(K.cells.map(wt.to));return(0,o.$Mf)(K.metadata)||(Me.metadata=K.metadata),Me}Ie.to=$e})($t||(e.NotebookData=$t={}));var wt;(function(Ie){function Le(K){return{cellKind:nt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Ne.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Kt.from):[]}}Ie.from=Le;function $e(K){return new s.$UL(nt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Kt.to):void 0,K.metadata,K.internalMetadata?Ne.to(K.internalMetadata):void 0)}Ie.to=$e})(wt||(e.NotebookCellData=wt={}));var Pt;(function(Ie){function Le(K){return{mime:K.mime,valueBytes:L.$ce.wrap(K.data)}}Ie.from=Le;function $e(K){return new s.$WL(K.valueBytes.buffer,K.mime)}Ie.to=$e})(Pt||(e.NotebookCellOutputItem=Pt={}));var Kt;(function(Ie){function Le(K){return{outputId:K.id,items:K.items.map(Pt.from),metadata:K.metadata}}Ie.from=Le;function $e(K){const Me=K.items.map(Pt.to);return new s.$XL(Me,K.outputId,K.metadata)}Ie.to=$e})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Ie){function Le(Me){return K(Me)?{include:Z.from(Me.include)??void 0,exclude:Z.from(Me.exclude)??void 0}:Z.from(Me)??void 0}Ie.from=Le;function $e(Me){return K(Me)?{include:Z.to(Me.include),exclude:Z.to(Me.exclude)}:Z.to(Me)}Ie.to=$e;function K(Me){const Ue=Me;return Ue?!(0,o.$If)(Ue.include)&&!(0,o.$If)(Ue.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var vt;(function(Ie){function Le($e,K,Me){const Ue=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{alignment:$e.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Ue,Me),text:$e.text,tooltip:$e.tooltip,accessibilityInformation:$e.accessibilityInformation,priority:$e.priority}}Ie.from=Le})(vt||(e.NotebookStatusBarItem=vt={}));var Ut;(function(Ie){function Le($e,K,Me){const Ue=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{command:K.toInternal(Ue,Me),label:$e.label,description:$e.description,detail:$e.detail,documentation:$e.documentation}}Ie.from=Le})(Ut||(e.NotebookKernelSourceAction=Ut={}));var Ot;(function(Ie){function Le($e){return{transientOutputs:$e?.transientOutputs??!1,transientCellMetadata:$e?.transientCellMetadata??{},transientDocumentMetadata:$e?.transientDocumentMetadata??{},cellContentMetadata:$e?.cellContentMetadata??{}}}Ie.from=Le})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Gt;(function(Ie){function Le(K){return{uri:K.uri,provides:K.provides}}Ie.from=Le;function $e(K){return new s.$ZL(v.URI.revive(K.uri),K.provides)}Ie.to=$e})(Gt||(e.NotebookRendererScript=Gt={}));var jt;(function(Ie){function Le(K){return{message:z.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:w.from(K.location.range),uri:K.location.uri}}}Ie.from=Le;function $e(K){const Me=new s.$6L(typeof K.message=="string"?K.message:z.to(K.message));return Me.actualOutput=K.actual,Me.expectedOutput=K.expected,Me.contextValue=K.contextValue,Me.location=K.location?be.to(K.location):void 0,Me}Ie.to=$e})(jt||(e.TestMessage=jt={}));var kt;(function(Ie){Ie.namespace=l.$oJ,Ie.denamespace=l.$pJ})(kt||(e.TestTag=kt={}));var Ft;(function(Ie){function Le(K){const Me=(0,i.$sM)(K).controllerId;return{extId:a.$kJ.fromExtHostTestItem(K,Me).toString(),label:K.label,uri:v.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Ue=>kt.namespace(Me,Ue.id)),range:p.$ws.lift(w.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&z.fromStrict(K.error)||null}}Ie.from=Le;function $e(K){return{parent:void 0,error:void 0,id:a.$kJ.fromString(K.extId).localId,label:K.label,uri:v.URI.revive(K.uri),tags:(K.tags||[]).map(Me=>{const{tagId:Ue}=kt.denamespace(Me);return new s.$7L(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:w.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Ie.toPlain=$e})(Ft||(e.TestItem=Ft={})),function(Ie){function Le(K){return{id:K.id}}Ie.from=Le;function $e(K){return new s.$7L(K.id)}Ie.to=$e}(kt||(e.TestTag=kt={}));var Bt;(function(Ie){const Le=(K,Me)=>{const Ue=[];for(const[qe,et]of Me)a.$kJ.compare(et.item.extId,qe)===2&&(Me.delete(qe),Ue.push(et));const Je={...Ft.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(et=>et.type===0).map(jt.to)})),children:Ue.map(qe=>Le(qe,Me))};for(const qe of Je.children)qe.parent=Je;return Je};function $e(K){const Me=[],Ue=new Map;for(const Je of K.items){Ue.set(Je.item.extId,Je);const qe=a.$kJ.root(Je.item.extId);K.request.targets.some(et=>et.controllerId===qe&&et.testIds.includes(Je.item.extId))&&Me.push(Je)}return{completedAt:K.completedAt,results:Me.map(Je=>Le(Je,Ue))}}Ie.to=$e})(Bt||(e.TestResults=Bt={}));var Jt;(function(Ie){function Le(Ue){return{covered:Ue.covered,total:Ue.covered}}function $e(Ue){return"line"in Ue?I.from(Ue):w.from(Ue)}function K(Ue){return"branches"in Ue?{count:Ue.executionCount,location:$e(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Je=>({count:Je.executionCount,location:Je.location&&$e(Je.location)})):void 0}:{type:0,count:Ue.executionCount,location:$e(Ue.location)}}Ie.fromDetailed=K;function Me(Ue){return{uri:Ue.uri,statement:Le(Ue.statementCoverage),branch:Ue.branchCoverage&&Le(Ue.branchCoverage),function:Ue.functionCoverage&&Le(Ue.functionCoverage),details:Ue.detailedCoverage?.map(K)}}Ie.fromFile=Me})(Jt||(e.TestCoverage=Jt={}));var Wt;(function(Ie){function Le($e){switch($e){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ie.to=Le})(Wt||(e.CodeActionTriggerKind=Wt={}));var Vt;(function(Ie){function Le(K){const Me=new s.$aM(we.to(K.kind),K.name,K.detail||"",v.URI.revive(K.uri),w.to(K.range),w.to(K.selectionRange));return Me._sessionId=K._sessionId,Me._itemId=K._itemId,Me}Ie.to=Le;function $e(K,Me,Ue){if(Me=Me??K._sessionId,Ue=Ue??K._itemId,Me===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ue,kind:we.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:w.from(K.range),selectionRange:w.from(K.selectionRange),tags:K.tags?.map(ne.from)}}Ie.from=$e})(Vt||(e.TypeHierarchyItem=Vt={}));var Nt;(function(Ie){function Le($e){if($e)return{value:$e.value,tooltip:$e.tooltip}}Ie.from=Le})(Nt||(e.ViewBadge=Nt={}));var at;(function(Ie){function Le(Ue,Je,qe){const et=Je.fileData;return et?new s.$lL(new s.$mL(et.name,v.URI.revive(et.uri),et.id,(0,M.$cb)(()=>qe(et.id)))):Ue===A.$Sr.uriList&&Je.uriListData?new s.$kL(Me(Je.uriListData)):new s.$kL(Je.asString)}Ie.to=Le;async function $e(Ue,Je){const qe=await Je.asString();if(Ue===A.$Sr.uriList)return{asString:qe,fileData:void 0,uriListData:K(qe)};const et=Je.asFile();return{asString:qe,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Ie.from=$e;function K(Ue){return P.$6s.split(Ue).map(Je=>{if(Je.startsWith("#"))return Je;try{return v.URI.parse(Je)}catch{}return Je})}function Me(Ue){return P.$6s.create(Ue.map(Je=>typeof Je=="string"?Je:v.URI.revive(Je)))}})(at||(e.DataTransferItem=at={}));var dt;(function(Ie){function Le(K,Me){const Ue=K.items.map(([Je,qe])=>[Je,at.to(Je,qe,Me)]);return new s.$nL(Ue)}Ie.toDataTransfer=Le;async function $e(K){const Me={items:[]},Ue=[];for(const[Je,qe]of K)Ue.push((async()=>{Me.items.push([Je,await at.from(Je,qe)])})());return await Promise.all(Ue),Me}Ie.from=$e})(dt||(e.DataTransfer=dt={}));var At;(function(Ie){function Le(K){return{message:K.message,metadata:K.metadata,title:K.title,tooltip:K.tooltip}}Ie.to=Le;function $e(K){return{kind:"reply",message:K.message,metadata:K.metadata,title:K.title,tooltip:K.tooltip}}Ie.from=$e})(At||(e.ChatReplyFollowup=At={}));var qt;(function(Ie){function Le($e){return typeof $e=="string"?{title:$e,message:$e,kind:"reply"}:"commandId"in $e?{kind:"command",title:$e.title??"",commandId:$e.commandId??"",when:$e.when??"",args:$e.args}:At.from($e)}Ie.from=Le})(qt||(e.ChatFollowup=qt={}));var Rt;(function(Ie){function Le(K){const Me=new s.$lM(ot.to(K.role),K.content);return Me.name=K.name,Me}Ie.to=Le;function $e(K){return{role:ot.from(K.role),content:K.content,name:K.name}}Ie.from=$e})(Rt||(e.ChatMessage=Rt={}));var ot;(function(Ie){function Le(K){switch(K){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ie.to=Le;function $e(K){switch(K){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ie.from=$e})(ot||(e.ChatMessageRole=ot={}));var bt;(function(Ie){function Le(Me){const Ue={};for(const Je of Object.keys(Me))Ue[Je]=Me[Je].map(Ie.to);return Ue}Ie.objectTo=Le;function $e(Me){return{level:Tt.to(Me.level),value:Me.value,description:Me.description}}Ie.to=$e;function K(Me){return{level:Tt.from(Me.level),value:Me.value,description:Me.description}}Ie.from=K})(bt||(e.ChatVariable=bt={}));var Tt;(function(Ie){function Le(K){switch(K){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ie.to=Le;function $e(K){switch(K){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ie.from=$e})(Tt||(e.ChatVariableLevel=Tt={}));var Ct;(function(Ie){function Le($e){switch($e){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}Ie.to=Le})(Ct||(e.InteractiveEditorResponseFeedbackKind=Ct={}));var We;(function(Ie){function Le($e,K){return"placeholder"in K&&"resolvedContent"in K?{placeholder:K.placeholder}:"responseId"in K?{requestId:K.responseId}:"markdownContent"in K?((0,c.$uF)($e,"chatAgents2Additions"),{content:z.from(K.markdownContent)}):"content"in K?typeof K.content=="string"?K:((0,c.$uF)($e,"chatAgents2Additions"),{content:z.from(K.content)}):"documents"in K?{documents:K.documents.map(Me=>({uri:Me.uri,version:Me.version,ranges:Me.ranges.map(Ue=>w.from(Ue))}))}:"reference"in K?{reference:"uri"in K.reference?{uri:K.reference.uri,range:w.from(K.reference.range)}:K.reference}:"inlineReference"in K?{inlineReference:"uri"in K.inlineReference?{uri:K.inlineReference.uri,range:w.from(K.inlineReference.range)}:K.inlineReference,title:K.title}:("agentName"in K&&(0,c.$uF)($e,"chatAgents2Additions"),K)}Ie.from=Le})(We||(e.ChatResponseProgress=We={}));var Qt;(function(Ie){function Le($e,K,Me){return"terminalCommand"in $e?{terminalCommand:$e.terminalCommand}:"uri"in $e?{uri:$e.uri}:K.toInternal($e,Me)}Ie.from=Le})(Qt||(e.TerminalQuickFix=Qt={}))}),define(Ae[221],Re([1,0,2,11,7,8,187]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class ${constructor(g,A,S,o={timeout:1500,errors:3}){this.c=g,this.d=A,this.f=S,this.g=o,this.a=new R.$1c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(A,S,o)=>{const p={dispose:this.a.push([A,S,g])};return Array.isArray(o)&&o.push(p),p}}async $participateInSave(g,A){const S=E.URI.revive(g);let o=!1;const v=setTimeout(()=>o=!0,this.g.timeout),p=[];try{for(const f of[...this.a]){if(o)break;const t=this.d.getDocument(S),i=await this.h(f,{document:t,reason:M.TextDocumentSaveReason.to(A)});p.push(i)}}finally{clearTimeout(v)}return p}h([g,A,S],o){const v=this.b.get(g);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(S,g,A,o).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const f=this.b.get(g);this.b.set(g,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,A,S,o){const v=[],p=Date.now(),{document:f,reason:t}=o,{version:i}=f,n=Object.freeze({document:f,reason:t,waitUntil(u){if(Object.isFrozen(v))throw(0,L.$7)("waitUntil can not be called async");v.push(Promise.resolve(u))}});try{A.apply(S,[n])}catch(u){return Promise.reject(u)}return Object.freeze(v),new Promise((u,a)=>{const l=setTimeout(()=>a(new Error("timeout")),this.g.timeout);return Promise.all(v).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(l),u(r)}).catch(r=>{clearTimeout(l),a(r)})}).then(u=>{const a={edits:[]};for(const l of u)if(Array.isArray(l)&&l.every(r=>r instanceof P.$DK))for(const{newText:r,newEol:s,range:c}of l)a.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:c&&M.Range.from(c),text:r,eol:s&&M.EndOfLine.from(s)}});if(a.edits.length!==0)return i===f.version?this.f.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.$tdc=$}),define(Ae[222],Re([1,0,14,2,8,7,76]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=e.$Gec=void 0;class ${constructor(S,o,v,p){this.start=S,this.deletedCount=o,this.deletedItems=v,this.items=p}asApiEvent(){return{range:new M.$TL(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(S,o){return{EOL:o.eol,lines:o.source,languageId:o.language,uri:o.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,o,v){this.notebook=S,this.h=o,this.j=v,this.handle=v.handle,this.uri=L.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(P.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,o=this.h.getDocument(this.uri);if(!o)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:o.document,get mime(){return S.g},set mime(p){S.g=p},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(v)}return this.f}setOutputs(S){this.a=S.map(P.NotebookCellOutput.to)}setOutputItems(S,o,v){const p=v.map(P.NotebookCellOutputItem.to),f=this.a.find(t=>t.id===S);if(f&&(o||(f.items.length=0),f.items.push(...p),f.items.length>1&&f.items.every(t=>R.$zI(t.mime)))){const t=new Map,i=[];f.items.forEach(n=>{let u;t.has(n.mime)?u=t.get(n.mime):(u=[],t.set(n.mime,u),i.push(n.mime)),u.push(n.data)}),f.items.length=0,i.forEach(n=>{const u=R.$AI(t.get(n));f.items.push({mime:n,data:u.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$Gec=D;class g{static{this.a=0}constructor(S,o,v,p,f){this.k=S,this.l=o,this.m=v,this.uri=p,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,o={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===E.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(v){return v=S.n(v),S.b[v].apiCell},getCells(v){return(v?S.p(v):S.b).map(f=>f.apiCell)},save(){return S.q()}};this.e=Object.freeze(o)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,o,v){this.g=S.versionId,this.h=o,this.acceptDocumentPropertiesChanged({metadata:v});const p={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},f=[];for(const i of S.rawEvents)i.kind===R.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,p.contentChanges):i.kind===R.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,p.contentChanges):i.kind===R.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===R.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),f.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),f.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<f.length;i++){const n=f[i],u=t.get(n.cell);if(u===void 0){const a=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});t.set(n.cell,a-1)}else p.cellChanges[u]={...p.cellChanges[u],...n}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let o=S.start|0,v=S.end|0;return o<0&&(o=0),v>this.b.length&&(v=this.b.length),S.with({start:o,end:v})}p(S){S=this.o(S);const o=[];for(let v=S.start;v<S.end;v++)o.push(this.b[v]);return o}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,o,v){if(this.j)return;const p=[],f=[],t=[];if(S.reverse().forEach(i=>{const u=i[2].map(r=>{const s=new D(this,this.l,r);return o||f.push(D.asModelAddData(this.apiNotebook,r)),s}),a=new $(i[0],i[1],[],u),l=this.b.splice(i[0],i[1],...u);for(const r of l)t.push(r.uri),a.deletedItems.push(r.apiCell);p.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:t}),v)for(const i of p)v.push(i.asApiEvent())}s(S,o,v,p){const f=this.b.splice(S,o);this.b.splice(v,0,...f);const t=[new $(S,o,f.map(i=>i.apiCell),[]),new $(v,0,[],f)];for(const i of t)p.push(i.asApiEvent())}t(S,o){this.b[S].setOutputs(o)}u(S,o,v,p){this.b[S].setOutputItems(o,v,p)}v(S,o){const v=this.b[S];v.apiCell.document.languageId!==o&&this.m.$acceptModelLanguageChanged(v.uri,o)}w(S,o){const v=this.b[S];v.apiCell.mime=o}x(S,o){this.b[S].setMetadata(o)}y(S,o){this.b[S].setInternalMetadata(o)}getCellFromApiCell(S){return this.b.find(o=>o.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(o=>o.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$Hec=g}),define(Ae[223],Re([1,0,5,2,8,7]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;class R{constructor(D,g,A,S={timeout:1500,errors:3}){this.b=D,this.c=g,this.d=A,this.f=S,this.a=new E.$Qd}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(g,A,S)=>{const o=function(p){g.call(A,p)};return o.extension=D,this.a.event(o,void 0,S)}}async $participateInSave(D,g,A){const S=L.URI.revive(D),o=this.c.getNotebookDocument(S);if(!o)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:o.apiNotebook,reason:P.TextDocumentSaveReason.to(g)},A,async(f,t)=>{const i=Date.now(),n=await await Promise.resolve(f);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof M.$GK?v.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(v.length===0)return!0;const p={edits:[]};for(const f of v){const{edits:t}=P.WorkspaceEdit.from(f);p.edits=p.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$8ec=R}),define(Ae[107],Re([1,0,11,8,7]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor($,D,g,A,S,o){this.id=$,this.f=D,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=A,this.c=o}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(D){this.selections=[D]},get selections(){return $.a},set selections(D){if(!Array.isArray(D)||!D.every(P.$TL.isNotebookRange))throw(0,E.$6)("selections");$.a=D,$.g(D)},get visibleRanges(){return $.b},revealRange(D,g){$.f.$tryRevealRange($.id,L.NotebookRange.from(D),g??P.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(L.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$Iec=M}),define(Ae[224],Re([1,0,11,5,15,8]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;let R=class{constructor(D,g){this.c=D,this.d=g,this.a=new L.$Od({onListenerError:E.$1}),this.b=new L.$Od({onListenerError:E.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,g);const A=this.d.getEditorById(D);g.visibleRanges&&A._acceptVisibleRanges(g.visibleRanges.ranges.map(M.NotebookRange.to)),g.selections&&A._acceptSelections(g.selections.selections.map(M.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const g in D)this.d.getEditorById(g)._acceptViewColumn(M.ViewColumn.to(D[g]))}};e.$1ec=R,e.$1ec=R=Ke([Ve(0,P.$aj)],R)}),define(Ae[225],Re([1,0,8,54,164,20,67,11]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=void 0;class D{constructor(o){this.b=0,this.c=new Map,this.a=o}async withProgress(o,v,p){const f=this.b++,{title:t,location:i,cancellable:n}=v,u={label:(0,P.localize)(0,null,o.displayName||o.name),id:o.identifier.value};return this.a.$startProgress(f,{location:E.ProgressLocation.from(i),title:t,source:u,cancellable:n},o.isUnderDevelopment?void 0:o.identifier.value).catch($.$1),this.d(f,p,!!n)}d(o,v,p){let f;p&&(f=new M.$Yd,this.c.set(o,f));const t=n=>{this.a.$progressEnd(n),this.c.delete(n),f?.dispose()};let i;try{i=v(new A(this.a,o),p&&f?f.token:M.CancellationToken.None)}catch(n){throw t(o),n}return i.then(n=>t(o),n=>t(o)),i}$acceptProgressCanceled(o){const v=this.c.get(o);v&&(v.cancel(),this.c.delete(o))}}e.$5dc=D;function g(S,o){return S.message=o.message,typeof o.increment=="number"&&(typeof S.increment=="number"?S.increment+=o.increment:S.increment=o.increment),S}class A extends L.$8u{constructor(o,v){super(p=>this.throttledReport(p)),this.c=o,this.d=v}throttledReport(o){this.c.$progressReport(this.d,o)}}Ke([(0,R.$mh)(100,(S,o)=>g(S,o),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Ae[108],Re([1,0,29,104,48,77,60,8,2]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=e.$JM=e.$IM=void 0;const g=(u,a,l,r)=>{let s=a;return{enumerable:!0,configurable:!1,get(){return s},set(c){if(!l(s,c)){const h=s;s=c,u.listener?.(r(c,h))}}}},A=(u,a)=>u===a,S={range:(u,a)=>u===a?!0:!u||!a?!1:u.isEqual(a),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(u,a)=>!(u.length!==a.length||u.some(l=>!a.find(r=>l.id===r.id)))},o=u=>a=>({op:4,update:u(a)}),v=(u,a)=>({range:(()=>{let l;const r=o(s=>({range:E.$ws.lift($.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return l},set(s){u.listener?.({op:6}),S.range(l,s)||(l=s,u.listener?.(r(s)))}}})(),label:g(u,a,S.label,o(l=>({label:l}))),description:g(u,void 0,S.description,o(l=>({description:l}))),sortText:g(u,void 0,S.sortText,o(l=>({sortText:l}))),canResolveChildren:g(u,!1,S.canResolveChildren,l=>({op:2,state:l})),busy:g(u,!1,S.busy,o(l=>({busy:l}))),error:g(u,void 0,S.error,o(l=>({error:$.MarkdownString.fromStrict(l)||null}))),tags:g(u,[],S.tags,(l,r)=>({op:1,new:l.map($.TestTag.from),old:r.map($.TestTag.from)}))}),p=u=>{const a=P.$kJ.fromString(u.extId),l=new t(a.controllerId,a.localId,u.label,D.URI.revive(u.uri)||void 0);return l.range=$.Range.to(u.range||void 0),l.description=u.description||void 0,l.sortText=u.sortText||void 0,l.tags=u.tags.map(r=>$.TestTag.to({id:(0,R.$pJ)(r).tagId})),l},f=u=>{let a;for(const l of u.tests){const r=p(l.item);(0,L.$sM)(r).parent=a,a=r}return a};e.$IM=f;class t{constructor(a,l,r,s){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const c=(0,L.$rM)(this,a);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof i?void 0:c.parent}},children:{value:(0,M.$qM)(c,L.$sM,t),enumerable:!0,writable:!1},...v(c,r)})}}e.$JM=t;class i extends t{constructor(a,l){super(a,a,l,void 0),this._isRoot=!0}}e.$KM=i;class n extends M.$mM{constructor(a,l,r){super({controllerId:a,getDocumentVersion:s=>s&&r.getDocument(s)?.version,getApiFor:L.$sM,getChildren:s=>s.children,root:new i(a,l),toITestItem:$.TestItem.from})}}e.$LM=n}),define(Ae[109],Re([1,0,55,11,89,8,7]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=e.$DM=void 0;class ${static{this.c=new P.$BM("TextEditorDecorationType")}constructor(o,v,p){const f=$.c.nextId();o.$registerTextEditorDecorationType(v.identifier,f,M.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:f,dispose(){o.$removeTextEditorDecorationType(f)}})}}e.$DM=$;class D{constructor(o,v){this.g=[],this.h=void 0,this.j=!1,this.c=o,this.d=o.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(o,v){this.k();let p=null;if(o instanceof R.$xK)p=new R.$yK(o,o);else if(o instanceof R.$yK)p=o;else throw new Error("Unrecognized location");this.l(p,v,!1)}insert(o,v){this.k(),this.l(new R.$yK(o,o),v,!0)}delete(o){this.k();let v=null;if(o instanceof R.$yK)v=o;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(o,v,p){const f=this.c.validateRange(o);this.g.push({range:f,text:v,forceMoveMarkers:p})}setEndOfLine(o){if(this.k(),o!==R.EndOfLine.LF&&o!==R.EndOfLine.CRLF)throw(0,L.$6)("endOfLine");this.h=o}}class g{constructor(o,v,p,f){this.c=o,this.d=v,this._accept(p),this.e=f;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(o){this.f=o.tabSize,this.g=o.indentSize,this.h=o.insertSpaces,this.j=o.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(o.lineNumbers)}l(o){if(o==="auto")return"auto";if(typeof o=="number"){const v=Math.floor(o);return v>0?v:null}if(typeof o=="string"){const v=parseInt(o,10);return isNaN(v)?null:v>0?v:null}return null}m(o){const v=this.l(o);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n(o){if(o==="tabSize")return"tabSize";if(typeof o=="number"){const v=Math.floor(o);return v>0?v:null}if(typeof o=="string"){const v=parseInt(o,10);return isNaN(v)?null:v>0?v:null}return null}o(o){const v=this.n(o);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p(o){return o==="auto"?"auto":o==="false"?!1:!!o}q(o){const v=this.p(o);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s(o){this.j!==o&&(this.j=o,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:o})))}t(o){this.k!==o&&(this.k=o,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(o)})))}assign(o){const v={};let p=!1;if(typeof o.tabSize<"u"){const f=this.l(o.tabSize);f==="auto"?(p=!0,v.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,p=!0,v.tabSize=f)}if(typeof o.indentSize<"u"){const f=this.n(o.indentSize);f==="tabSize"?(p=!0,v.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,p=!0,v.indentSize=f)}if(typeof o.insertSpaces<"u"){const f=this.p(o.insertSpaces);f==="auto"?(p=!0,v.insertSpaces=f):this.h!==f&&(this.h=f,p=!0,v.insertSpaces=f)}typeof o.cursorStyle<"u"&&this.j!==o.cursorStyle&&(this.j=o.cursorStyle,p=!0,v.cursorStyle=o.cursorStyle),typeof o.lineNumbers<"u"&&this.k!==o.lineNumbers&&(this.k=o.lineNumbers,p=!0,v.lineNumbers=M.TextEditorLineNumbersStyle.from(o.lineNumbers)),p&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u(o,v){v.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${o}' failed:'`),this.e.warn(p)})}}e.$EM=g;class A{constructor(o,v,p,f,t,i,n,u){this.id=o,this.j=v,this.k=p,this.g=!1,this.h=new Set,this.c=t,this.d=new g(this.j,this.id,i,p),this.e=n,this.f=u;const a=this;this.value=Object.freeze({get document(){return f.value},set document(l){throw new L.$8("document")},get selection(){return a.c&&a.c[0]},set selection(l){if(!(l instanceof R.$zK))throw(0,L.$6)("selection");a.c=[l],a.l()},get selections(){return a.c},set selections(l){if(!Array.isArray(l)||l.some(r=>!(r instanceof R.$zK)))throw(0,L.$6)("selections");a.c=l,a.l()},get visibleRanges(){return a.e},set visibleRanges(l){throw new L.$8("visibleRanges")},get options(){return a.d.value},set options(l){a.g||a.d.assign(l)},get viewColumn(){return a.f},set viewColumn(l){throw new L.$8("viewColumn")},edit(l,r={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new D(f.value,r);return l(s),a.m(s)},insertSnippet(l,r,s={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!r||Array.isArray(r)&&r.length===0)c=a.c.map(h=>M.Range.from(h));else if(r instanceof R.$xK){const{lineNumber:h,column:w}=M.Position.from(r);c=[{startLineNumber:h,startColumn:w,endLineNumber:h,endColumn:w}]}else if(r instanceof R.$yK)c=[M.Range.from(r)];else{c=[];for(const h of r)if(h instanceof R.$yK)c.push(M.Range.from(h));else{const{lineNumber:w,column:m}=M.Position.from(h);c.push({startLineNumber:w,startColumn:m,endLineNumber:w,endColumn:m})}}return v.$tryInsertSnippet(o,f.value.version,l.value,c,s)},setDecorations(l,r){const s=r.length===0;s&&!a.h.has(l.key)||(s?a.h.delete(l.key):a.h.add(l.key),a.n(()=>{if(M.$tM(r))return v.$trySetDecorations(o,l.key,M.$uM(r));{const c=new Array(4*r.length);for(let h=0,w=r.length;h<w;h++){const m=r[h];c[4*h]=m.start.line+1,c[4*h+1]=m.start.character+1,c[4*h+2]=m.end.line+1,c[4*h+3]=m.end.character+1}return v.$trySetDecorationsFast(o,l.key,c)}}))},revealRange(l,r){a.n(()=>v.$tryRevealRange(o,M.Range.from(l),r||R.TextEditorRevealType.Default))},show(l){v.$tryShowEditor(o,M.ViewColumn.from(l))},hide(){v.$tryHideEditor(o)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(o){(0,E.ok)(!this.g),this.d._accept(o)}_acceptVisibleRanges(o){(0,E.ok)(!this.g),this.e=o}_acceptViewColumn(o){(0,E.ok)(!this.g),this.f=o}_acceptSelections(o){(0,E.ok)(!this.g),this.c=o}async l(){const o=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,o)),this.value}m(o){const v=o.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const p=v.edits.map(t=>t.range);p.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=p.length-1;t<i;t++){const n=p[t].end;if(p[t+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=v.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,f,{setEndOfLine:typeof v.setEndOfLine=="number"?M.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(o){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):o().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$FM=A}),define(Ae[226],Re([1,0,168,25,2,5,6,206,12,7,16,18,8,53,20,132,23]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;function i(a,l){if((0,A.$zf)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let r;return Array.isArray(a.highlights)&&(r=a.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),r=r.length?r:void 0),{label:a.label,highlights:r}}}class n extends R.$Rc{constructor(l,r,s){super(),this.f=l,this.g=r,this.h=s,this.a=new Map,this.b=new f.$o8;function c(h){return h&&h.$treeViewId&&(h.$treeItemHandle||h.$selectedTreeItems||h.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:h=>c(h)?this.r(h):Array.isArray(h)&&h.length>0?h.map(w=>c(w)?this.r(w):w):h})}registerTreeDataProvider(l,r,s){const c=this.createTreeView(l,{treeDataProvider:r},s);return{dispose:()=>c.dispose()}}createTreeView(l,r,s){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=r.dragAndDropController?.dropMimeTypes??[],h=r.dragAndDropController?.dragMimeTypes??[],w=!!r.dragAndDropController?.handleDrag,m=!!r.dragAndDropController?.handleDrop,I=this.m(l,r,s),k={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:c,dragMimeTypes:h,hasHandleDrag:w,hasHandleDrop:m,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},d=this.f.$registerTreeViewDataProvider(l,k),b={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$uF)(s,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$uF)(s,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(y){(0,v.$8j)(y)&&(0,t.$uF)(s,"treeViewMarkdownMessage"),I.message=y},get title(){return I.title},set title(y){I.title=y},get description(){return I.description},set description(y){I.description=y},get badge(){return I.badge},set badge(y){y!==void 0&&g.ViewBadge.isViewBadge(y)?I.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(I.badge=void 0)},reveal:(y,C)=>I.reveal(y,C),dispose:async()=>{await d,this.a.delete(l),I.dispose()}};return this.B(b),b}$getChildren(l,r){const s=this.a.get(l);return s?s.getChildren(r):Promise.reject(new $.$FE(l))}async $handleDrop(l,r,s,c,h,w,m,I){const k=this.a.get(l);if(!k)return Promise.reject(new $.$FE(l));const d=o.DataTransfer.toDataTransfer(s,async b=>(await this.f.$resolveDropFileData(l,r,b)).buffer);return m===l&&I&&await this.j(d,k,I,h,w),k.onDrop(d,c,h)}async j(l,r,s,c,h){const w=this.b.removeDragOperationTransfer(h);if(w)(await w)?.forEach((m,I)=>{m&&l.set(I,m)});else if(h&&r.handleDrag){const m=r.handleDrag(s,l,c);this.b.addDragOperationTransfer(h,m),await m}return l}async $handleDrag(l,r,s,c){const h=this.a.get(l);if(!h)return Promise.reject(new $.$FE(l));const w=await this.j(new g.$nL,h,r,c,s);if(!(!w||c.isCancellationRequested))return o.DataTransfer.from(w)}async $hasResolve(l){const r=this.a.get(l);if(!r)throw new $.$FE(l);return r.hasResolve}$resolve(l,r,s){const c=this.a.get(l);if(!c)throw new $.$FE(l);return c.resolveTreeItem(r,s)}$setExpanded(l,r,s){const c=this.a.get(l);if(!c)throw new $.$FE(l);c.setExpanded(r,s)}$setSelectionAndFocus(l,r,s){const c=this.a.get(l);if(!c)throw new $.$FE(l);c.setSelectionAndFocus(r,s)}$setVisible(l,r){const s=this.a.get(l);if(!s){if(!r)return;throw new $.$FE(l)}s.setVisible(r)}$changeCheckboxState(l,r){const s=this.a.get(l);if(!s)throw new $.$FE(l);s.setCheckboxState(r)}m(l,r,s){const c=this.B(new u(l,r,this.f,this.g.converter,this.h,s));return this.a.set(l,c),c}r(l){const r=this.a.get(l.$treeViewId);return r&&"$treeItemHandle"in l?r.getExtensionElement(l.$treeItemHandle):r&&"$focusedTreeItem"in l&&l.$focusedTreeItem?r.focusedElement:null}}e.$_dc=n;class u extends R.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,A.$If)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,r,s,c,h,w){if(super(),this.I=l,this.J=s,this.L=c,this.M=h,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Od),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Od),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Od),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Od),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Od),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Od),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Od),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$Yd,w.contributes&&w.contributes.views)for(const d in w.contributes.views)for(const b of w.contributes.views[d])b.id===l&&(this.P=b.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(d=>this.F.fire({message:!1,element:d})));let m,I;const k=M.Event.debounce(this.F.event,(d,b)=>(d||(d={message:!1,elements:[]}),b.element!==!1&&(m||(m=new Promise(y=>I=y),this.G=this.G.then(()=>m)),Array.isArray(b.element)?d.elements.push(...b.element):d.elements.push(b.element)),b.message&&(d.message=!0),d),200,!0);this.B(k(({message:d,elements:b})=>{b.length&&(this.H=this.H.then(()=>{const y=I;return m=null,this.$(b).then(()=>y())})),d&&this.J.$setMessage(this.I,o.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const r=l?this.getExtensionElement(l):void 0;if(l&&!r)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let s=this.X(l);return s||(s=await this.Y(r)),s?s.map(c=>c.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,r){r=r||{select:!0,focus:!1};const s=(0,A.$If)(r.select)?!0:r.select,c=(0,A.$If)(r.focus)?!1:r.focus,h=(0,A.$If)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(w=>this.W(l,w[w.length-1]).then(m=>this.J.$reveal(this.I,{item:m.item,parentChain:w.map(I=>I.item)},{select:s,focus:c,expand:h})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:s,focus:c,expand:h})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=o.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,r){const s=this.getExtensionElement(l);s&&(r?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(l,r){const s=!(0,S.$tb)(this.s,l);this.s=l;const c=this.t!==r;this.t=r,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const r=(await Promise.all(l.map(async s=>{const c=this.getExtensionElement(s.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);r.forEach(s=>{s.treeItem.checkboxState=s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:r.map(s=>[s.extensionItem,s.newState])})}async handleDrag(l,r,s){const c=[];for(const h of l){const w=this.getExtensionElement(h);w&&c.push(w)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,r,s),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,r,s){const c=r?this.getExtensionElement(r):void 0;if(!(!c&&r||!this.g?.handleDrop))return(0,D.$Ng)(()=>this.g?.handleDrop?this.g.handleDrop(c,l,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,r){if(!this.f.resolveTreeItem)return;const s=this.j.get(l);if(s){const c=this.m.get(s);if(c){const h=await this.f.resolveTreeItem(c.extensionItem,s,r)??c.extensionItem;return this.hb(h),c.item.tooltip=this.eb(h.tooltip),c.item.command=this.fb(c.disposableStore,h.command),c.item}}}S(l){return this.U(l).then(r=>r?this.S(r).then(s=>this.W(r,s[s.length-1]).then(c=>(s.push(c),s))):Promise.resolve([]))}U(l){const r=this.m.get(l);return r?Promise.resolve(r.parent?this.j.get(r.parent.item.handle):void 0):(0,D.$Ng)(()=>this.f.getParent(l))}W(l,r){const s=this.m.get(l);return s?Promise.resolve(s):(0,D.$Ng)(()=>this.f.getTreeItem(l)).then(c=>this.kb(l,c,r,!0)).then(c=>this.getChildren(r?r.item.handle:void 0).then(()=>{const h=this.getExtensionElement(c);if(h){const w=this.m.get(h);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let r;if(typeof l=="string"){const s=this.getExtensionElement(l);r=s?this.m.get(s):void 0}else r=l;return r&&r.children||void 0}return this.h}async Y(l){this.rb(l);const r=new p.$Yd(this.Z.token);try{const s=l?this.m.get(l):void 0,c=await this.f.getChildren(l);if(r.token.isCancellationRequested)return;const h=await Promise.all((0,S.$Gb)(c||[]).map(async w=>{const m=await this.f.getTreeItem(w);return m&&!r.token.isCancellationRequested?this.db(w,m,s):null}));return r.token.isCancellationRequested?void 0:(0,S.$Gb)(h)}finally{r.dispose()}}$(l){if(l.some(s=>!s))return this.Z.dispose(!0),this.Z=new p.$Yd,this.tb(),this.J.$refresh(this.I);{const s=this.ab(l);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(l){const r=new Set,s=l.map(h=>this.m.get(h));for(const h of s)if(h&&!r.has(h.item.handle)){let w=h;for(;w&&w.parent&&s.findIndex(m=>w&&w.parent&&m&&m.item.handle===w.parent.item.handle)===-1;){const m=this.j.get(w.parent.item.handle);w=m?this.m.get(m):void 0}w&&!w.parent&&r.add(h.item.handle)}const c=[];return r.forEach(h=>{const w=this.j.get(h);if(w){const m=this.m.get(w);m&&(!m.parent||!r.has(m.parent.item.handle))&&c.push(h)}}),c}bb(l){const r={};return Promise.all(l.map(s=>this.cb(s).then(c=>{c&&(r[s]=c.item)}))).then(()=>Object.keys(r).length?this.J.$refresh(this.I,r):void 0)}cb(l){const r=this.getExtensionElement(l);if(r){const s=this.m.get(r);if(s)return this.rb(r),(0,D.$Ng)(()=>this.f.getTreeItem(r)).then(c=>{if(c){const h=this.ib(r,c,s.parent);return this.pb(r,h,s,s.parent),s.dispose(),h}return null})}return Promise.resolve(null)}db(l,r,s){const c=this.ib(l,r,s);if(r.id&&this.j.has(c.item.handle))throw new Error((0,E.localize)(0,null,r.id));return this.ob(l,c),this.qb(c,s),c}eb(l){return g.$WK.isMarkdownString(l)?o.MarkdownString.from(l):l}fb(l,r){return r?{...this.L.toInternal(r,l),originalId:r.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let r,s,c;return typeof l.checkboxState=="number"?r=l.checkboxState:(r=l.checkboxState.state,s=l.checkboxState.tooltip,c=l.checkboxState.accessibilityInformation),{isChecked:r===g.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:c}}hb(l){if(!g.$iL.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,r,s){this.hb(r);const c=this.B(new R.$Qc),h=this.kb(l,r,s),w=this.lb(r);return{item:{handle:h,parentHandle:s?s.item.handle:void 0,label:i(r.label,this.N),description:r.description,resourceUri:r.resourceUri,tooltip:this.eb(r.tooltip),command:this.fb(c,r.command),contextValue:r.contextValue,icon:w,iconDark:this.mb(r)||w,themeIcon:this.jb(r),collapsibleState:(0,A.$If)(r.collapsibleState)?g.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.gb(r)},extensionItem:r,parent:s,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(l){return l.iconPath instanceof g.$qL?l.iconPath:void 0}kb(l,{id:r,label:s,resourceUri:c},h,w){if(r)return`${u.b}/${r}`;const m=i(s,this.N),I=h?h.item.handle:u.a;let k=m?m.label:c?(0,L.$tg)(c):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const d=this.m.has(l)?this.m.get(l).item.handle:void 0,b=this.X(h)||[];let y,C=0;do{if(y=`${I}/${C}:${k}`,w||!this.j.has(y)||d===y)break;C++}while(C<=b.length);return y}lb(l){if(l.iconPath&&!(l.iconPath instanceof g.$qL))return typeof l.iconPath=="string"||P.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof g.$qL)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return P.URI.isUri(l)?l:P.URI.file(l)}ob(l,r){this.j.set(r.item.handle,l),this.m.set(l,r)}pb(l,r,s,c){this.j.delete(r.item.handle),this.m.delete(l),r.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(l,r);const h=this.X(c)||[],w=h.filter(m=>m.item.handle===s.item.handle)[0];w&&h.splice(h.indexOf(w),1,r)}qb(l,r){r?(r.children||(r.children=[]),r.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const r=this.m.get(l);if(r){if(r.children)for(const s of r.children){const c=this.j.get(s.item.handle);c&&this.sb(c)}r.children=void 0}}else this.tb()}sb(l){const r=this.m.get(l);if(r){if(r.children)for(const s of r.children){const c=this.j.get(s.item.handle);c&&this.sb(c)}this.m.delete(l),this.j.delete(r.item.handle),r.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[227],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[228],Re([1,0,180,11,31,96,73,30,22,227,190,101]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=void 0;const o=$.$jn.as(R.$kn.JSONContribution);class v{constructor(l,r,s){this.a=l,this.b=r,this.c=s}d(l,r){this.a({type:l,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(P.default.Error,l)}warn(l){this.d(P.default.Warning,l)}info(l){this.d(P.default.Info,l)}}e.$iF=v;class p{static a(l){const r=new D.$0l;for(let s=0,c=l.length;s<c;s++)r.add(l[s].description.identifier);return r}static compute(l,r){if(!l||!l.length)return new p(r,[]);if(!r||!r.length)return new p([],l);const s=this.a(l),c=this.a(r),h=r.filter(m=>!s.has(m.description.identifier)),w=l.filter(m=>!c.has(m.description.identifier));return new p(h,w)}constructor(l,r){this.added=l,this.removed=r}}e.$jF=p;class f{constructor(l,r){this.name=l,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=p.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,L.$Z)(l)}}}e.$kF=f;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$lF={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.$8l},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"*",description:E.localize(42,null),body:"*"}]}},badges:{type:"array",description:E.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(44,null)},href:{type:"string",description:E.localize(45,null)},description:{type:"string",description:E.localize(46,null)}}}},markdown:{type:"string",description:E.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$1n}},extensionPack:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$1n}},extensionKind:{description:E.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(52,null)},{body:["workspace"],description:E.localize(53,null)},{body:["ui","workspace"],description:E.localize(54,null)},{body:["workspace","ui"],description:E.localize(55,null)},{body:[],description:E.localize(56,null)}]},capabilities:{description:E.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(60,null),E.localize(61,null),E.localize(62,null)]},description:{type:"string",markdownDescription:E.localize(63,null)}}},untrustedWorkspaces:{description:E.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(66,null),E.localize(67,null),E.localize(68,null)]},restrictedConfigurations:{description:E.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(70,null)}}}}},sponsor:{description:E.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(73,null),type:"string"},"vscode:uninstall":{description:E.localize(74,null),type:"string"}}},icon:{type:"string",description:E.localize(75,null)},l10n:{type:"string",description:E.localize(76,null)},pricing:{type:"string",markdownDescription:E.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const r=new f(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,r),l.activationEventsGenerator&&S.$_E.register(l.extensionPoint,l.activationEventsGenerator),e.$lF.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,o.registerSchema(i,e.$lF),r}getExtensionPoints(){return Array.from(this.a.values())}}e.$mF=n;const u={ExtensionsRegistry:"ExtensionsRegistry"};$.$jn.add(u.ExtensionsRegistry,new n),e.$nF=$.$jn.as(u.ExtensionsRegistry),o.registerSchema(i,e.$lF),o.registerSchema(A.$tj,{properties:{extensionEnabledApiProposals:{description:E.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Ae[229],Re([1,0,176,16,26,228,34,5]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5F=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var g;(function(o){function v(p,f,t){if(!p)return;const i=L.$zf(p.type)?p.type:void 0;if(!i||i.length===0){t.error(E.localize(3,null));return}const n=[];if(Array.isArray(p.required))for(const u of p.required)L.$zf(u)&&n.push(u);return{extensionId:f.value,taskType:i,required:n,properties:p.properties?P.$0m(p.properties):{},when:p.when?R.$Qi.deserialize(p.when):void 0}}o.from=v})(g||(g={}));const A=M.$nF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(o,v)=>{for(const p of o)p.type&&v.push(`onTaskType:${p.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:D}});class S{constructor(){this.d=new $.$Od,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,p)=>{A.setHandler((f,t)=>{this.c=void 0;try{for(const i of t.removed){const n=i.value;for(const u of n)this.a&&u.type&&this.a[u.type]&&delete this.a[u.type]}for(const i of t.added){const n=i.value;for(const u of n){const a=g.from(u,i.description.identifier,i.collector);a&&(this.a[a.taskType]=a)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const p of this.all()){const f={type:"object",additionalProperties:!1};p.required.length>0&&(f.required=p.required.slice(0)),p.properties!==void 0?f.properties=P.$0m(p.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[p.taskType]},v.push(f)}this.c={oneOf:v}}return this.c}}e.$5F=new S}),define(Ae[230],Re([1,0,177,16,25,26,34,229]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$cG=e.JsonSchemaVersion=e.ExecutionEngine=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$9F=e.ShellQuoting=e.$8F=e.$7F=e.$6F=void 0,e.$6F="settings",e.$7F=new R.$0i("taskRunning",!1,E.localize(0,null)),e.$8F={value:E.localize(1,null),original:"Tasks"};var D;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.$9F="$customized",function(F){function N(X){if(!X)return F.Strong;switch(X.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=N}(D||(e.ShellQuoting=D={}));var g;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var A;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(A||(e.RevealKind=A={})),function(F){function N(X){switch(X.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=N}(A||(e.RevealKind=A={}));var S;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(F){function N(X){switch(X.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=N}(S||(e.RevealProblemKind=S={}));var o;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(o||(e.PanelKind=o={})),function(F){function N(X){switch(X.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=N}(o||(e.PanelKind=o={}));var v;(function(F){F.defaults={echo:!0,reveal:A.Always,revealProblems:S.Never,focus:!1,panel:o.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var p;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(F){function N(Q){switch(Q.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=N;function X(Q){switch(Q){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=X}(p||(e.RuntimeType=p={}));var f;(function(F){function N(X){return L.$zf(X)?X:X.value}F.value=N})(f||(e.CommandString=f={}));var t;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function N(Q){return Q===F.Clean._id||Q===F.Build._id||Q===F.Rebuild._id||Q===F.Test._id}F.is=N;function X(Q){if(Q!==void 0)return L.$zf(Q)?N(Q)?{_id:Q,isDefault:!1}:void 0:Q}F.from=X})(t||(e.TaskGroup=t={}));var i;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var n;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function N(X){switch(X){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=N})(n||(e.TaskSourceKind=n={}));var u;(function(F){F.parallel="parallel",F.sequence="sequence"})(u||(e.DependsOrder=u={}));var a;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var l;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class r{constructor(N,X,Q,De,ke,Pe){this._label="",this._id=N,X&&(this._label=X),Q&&(this.type=Q),this.runOptions=De,this.configurationProperties=ke,this._source=Pe}getDefinition(N){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,X=!1){if(N===void 0)return!1;if(L.$zf(N))return N===this._label||N===this.configurationProperties.identifier||X&&N===this._id;const Q=this.getDefinition(!0);return Q!==void 0&&Q._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$0F=r;class s extends r{constructor(N,X,Q,De,ke,Pe,fe,we){super(N,Q,void 0,fe,we,X),this.command={},this._source=X,this.hasDefinedMatchers=Pe,ke&&(this.command=ke)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let X;switch(this.command?this.command.runtime:void 0){case p.Shell:X="shell";break;case p.Process:X="process";break;case p.CustomExecution:X="customExecution";break;case void 0:X="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:X,_key:this._id,id:this._id}}}static is(N){return N instanceof s}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$6F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const N=this.d();if(!N)return;let X=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(X+=this._source.kind);const Q={type:e.$9F,folder:N,id:X};return JSON.stringify(Q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$tg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new s(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$$F=s;class c extends r{constructor(N,X,Q,De,ke,Pe,fe){super(N,Q,De,Pe,fe,X),this._source=X,this.configures=ke}static is(N){return N instanceof c}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$tg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$6F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const N=this.d();if(!N)return;let X=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(X+=this._source.kind);const Q={type:e.$9F,folder:N,id:X};return JSON.stringify(Q)}}e.$_F=c;class h extends r{constructor(N,X,Q,De,ke,Pe,fe,we,ne){super(N,Q,De,we,ne,X),this.defines=ke,this.hasDefinedMatchers=fe,this.command=Pe,this.icon=ne.icon,this.hide=ne.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof h}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new h(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$aG=h;class w extends r{constructor(N,X,Q,De,ke,Pe){super(N,Q,De,ke,Pe,X),this._source=X}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new w(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$bG=w;var m;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(m||(e.ExecutionEngine=m={})),function(F){F._default=F.Terminal}(m||(e.ExecutionEngine=m={}));var I;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class k{constructor(N){this.c=new Map;for(let X=0;X<N.length;X++)this.c.set(N[X].uri.toString(),X)}compare(N,X){const Q=N.getWorkspaceFolder(),De=X.getWorkspaceFolder();if(Q&&De){let ke=this.c.get(Q.uri.toString());ke=ke===void 0?0:ke+1;let Pe=this.c.get(De.uri.toString());return Pe=Pe===void 0?0:Pe+1,ke===Pe?N._label.localeCompare(X._label):ke-Pe}else return!Q&&De?-1:Q&&!De?1:0}}e.$cG=k;var d;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(d||(e.TaskEventKind=d={}));var b;(function(F){F.SingleRun="singleRun",F.Background="background"})(b||(e.TaskRunType=b={}));var y;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(F){function N(we){return{taskId:we._id,taskName:we.configurationProperties.name,runType:we.configurationProperties.isBackground?"background":"singleRun",group:we.configurationProperties.group,__task:we}}function X(we,ne,re){return{...N(we),kind:"start",terminalId:ne,resolvedVariables:re}}F.start=X;function Q(we,ne,re){return{...N(we),kind:"processStarted",terminalId:ne,processId:re}}F.processStarted=Q;function De(we,ne,re){return{...N(we),kind:"processEnded",terminalId:ne,exitCode:re}}F.processEnded=De;function ke(we,ne,re){return{...N(we),kind:"terminated",exitReason:re,terminalId:ne}}F.terminated=ke;function Pe(we,ne,re){return{...N(ne),kind:we,terminalId:re}}F.general=Pe;function fe(){return{kind:"changed"}}F.changed=fe})(C||(e.TaskEvent=C={}));var B;(function(F){function N(Q){const De=Object.keys(Q).sort();let ke="";for(const Pe of De){let fe=Q[Pe];fe instanceof Object?fe=N(fe):typeof fe=="string"&&(fe=fe.replace(/,/g,",,")),ke+=Pe+","+fe+","}return ke}function X(Q){const ke={_key:N(Q),type:Q.taskType};return Object.assign(ke,Q),ke}F.create=X})(B||(e.KeyedTaskIdentifier=B={}));var H;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(H||(e.TaskSettingId=H={}));var U;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var z;(function(F){function N(X,Q){const De=$.$5F.get(X.type);if(De===void 0){const we=M.$0m(X);return delete we._key,B.create(we)}const ke=Object.create(null);ke.type=De.taskType;const Pe=new Set;De.required.forEach(we=>Pe.add(we));const fe=De.properties;for(const we of Object.keys(fe)){const ne=X[we];if(ne!=null)ke[we]=ne;else if(Pe.has(we)){const re=fe[we];if(re.default!==void 0)ke[we]=M.$0m(re.default);else switch(re.type){case"boolean":ke[we]=!1;break;case"number":case"integer":ke[we]=0;break;case"string":ke[we]="";break;default:Q.error(E.localize(2,null,JSON.stringify(X,void 0,0),we));return}}}return B.create(ke)}F.createTaskIdentifier=N})(z||(e.TaskDefinition=z={}))}),define(Ae[231],Re([1,0,11]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t5b=e.$s5b=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,$)=>{this.b=R,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,E.$Z)(R))}then(R,$){return this.j().then(R,$)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$s5b=L;class P extends L{constructor(){super(),this.h=!0,this.i=new E.$4}}e.$t5b=P}),define(Ae[49],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tv=e.$sv=e.$rv=e.$qv=void 0;class E{static{this.count=0}constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++E.count}}e.$qv=E;const L=[];function P($){const D=new E($);return L[D.nid]=D,D}e.$rv=P;function M($){return L[$].sid}e.$sv=M;class R{constructor(D){this.value=D}}e.$tv=R}),define(Ae[3],Re([1,0,49]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vK=e.$uK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$tK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var P;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput",f[f.ChatEditorInput=10]="ChatEditorInput"})(P||(e.TabInputKind=P={}));var M;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var R;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var $;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var D;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var g;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var A;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class S{static{this.a=0}static mixin(t){return t._id=S.a++,t}}e.$tK=S;var o;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(o||(e.ISuggestDataDtoField=o={}));var v;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var p;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$uK={MainThreadAuthentication:(0,E.$rv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$rv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$rv)("MainThreadChatProvider"),MainThreadChatAgents:(0,E.$rv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,E.$rv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$rv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$rv)("MainThreadClipboard"),MainThreadCommands:(0,E.$rv)("MainThreadCommands"),MainThreadComments:(0,E.$rv)("MainThreadComments"),MainThreadConfiguration:(0,E.$rv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$rv)("MainThreadConsole"),MainThreadDebugService:(0,E.$rv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$rv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$rv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$rv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$rv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$rv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$rv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$rv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$rv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$rv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$rv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$rv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$rv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$rv)("MainThreadLanguages"),MainThreadLogger:(0,E.$rv)("MainThreadLogger"),MainThreadMessageService:(0,E.$rv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$rv)("MainThreadOutputService"),MainThreadProgress:(0,E.$rv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$rv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$rv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$rv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$rv)("MainThreadSecretState"),MainThreadStorage:(0,E.$rv)("MainThreadStorage"),MainThreadSpeech:(0,E.$rv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$rv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$rv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$rv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$rv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$rv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$rv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$rv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$rv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$rv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$rv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$rv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$rv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$rv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$rv)("MainThreadSCM"),MainThreadSearch:(0,E.$rv)("MainThreadSearch"),MainThreadShare:(0,E.$rv)("MainThreadShare"),MainThreadTask:(0,E.$rv)("MainThreadTask"),MainThreadWindow:(0,E.$rv)("MainThreadWindow"),MainThreadLabelService:(0,E.$rv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$rv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$rv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$rv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$rv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$rv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$rv)("MainThreadInteractive"),MainThreadChat:(0,E.$rv)("MainThreadChat"),MainThreadInlineChat:(0,E.$rv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$rv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$rv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$rv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$rv)("MainThreadTimeline"),MainThreadTesting:(0,E.$rv)("MainThreadTesting"),MainThreadLocalization:(0,E.$rv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$rv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$rv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$rv)("MainThreadIssueReporter")},e.$vK={ExtHostCommands:(0,E.$rv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$rv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$rv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$rv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$rv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$rv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$rv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$rv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$rv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$rv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$rv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$rv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$rv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$rv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$rv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$rv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$rv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$rv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$rv)("ExtHostStatusBar"),ExtHostShare:(0,E.$rv)("ExtHostShare"),ExtHostExtensionService:(0,E.$rv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$rv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$rv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$rv)("ExtHostSCM"),ExtHostSearch:(0,E.$rv)("ExtHostSearch"),ExtHostTask:(0,E.$rv)("ExtHostTask"),ExtHostWorkspace:(0,E.$rv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$rv)("ExtHostWindow"),ExtHostWebviews:(0,E.$rv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$rv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$rv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$rv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$rv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$rv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$rv)("ExtHostProgress"),ExtHostComments:(0,E.$rv)("ExtHostComments"),ExtHostSecretState:(0,E.$rv)("ExtHostSecretState"),ExtHostStorage:(0,E.$rv)("ExtHostStorage"),ExtHostUrls:(0,E.$rv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$rv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$rv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$rv)("ExtHostOutputService"),ExtHosLabelService:(0,E.$rv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$rv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$rv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$rv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$rv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$rv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$rv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$rv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$rv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$rv)("ExtHostChat"),ExtHostChatAgents:(0,E.$rv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,E.$rv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$rv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$rv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$rv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$rv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$rv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$rv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$rv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$rv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$rv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$rv)("ExtHostTimeline"),ExtHostTesting:(0,E.$rv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$rv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$rv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$rv)("ExtHostIssueReporter")}}),define(Ae[232],Re([1,0,3,7]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$uK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,$,D){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(R);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation($,D)??[]}getRelatedInformation(R,$,D){return this.c.$getAiRelatedInformation($,D)}registerRelatedInformationProvider(R,$,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiRelatedInformationProvider(g,$),new L.$wK(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$bfc=P}),define(Ae[81],Re([1,0,4,15,3,17]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=e.$ddc=void 0,e.$ddc=(0,E.$Sh)("IExtHostApiDeprecationService");let R=class{constructor(D,g){this.c=g,this.a=new Set,this.b=D.getProxy(P.$uK.MainThreadTelemetry)}report(D,g,A){const S=this.d(D,g);this.a.has(S)||(this.a.add(S),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:D}))}d(D,g){return`${D}-${g.identifier.value}`}};e.$edc=R,e.$edc=R=Ke([Ve(0,M.$wM),Ve(1,L.$aj)],R),e.$fdc=Object.freeze(new class{report($,D,g){}})}),define(Ae[233],Re([1,0,5,3,7,22]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;class R{constructor(g){this.b=new Map,this.c=[],this.d=new E.$Od,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=g.getProxy(L.$uK.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,A,S,o={}){const v=M.$9l.toKey(g.identifier),p=[...S].sort().join(" ");return await this.f.getOrCreate(`${v} ${A} ${p}`,async()=>{await this.a.$ensureProvider(A);const f=g.displayName||g.name;return this.a.$getSession(A,S,v,f,o)})}async getSessions(g,A,S){const o=M.$9l.toKey(g.identifier),v=[...S].sort().join(" ");return await this.g.getOrCreate(`${o} ${v}`,async()=>{await this.a.$ensureProvider(A);const p=g.displayName||g.name;return this.a.$getSessions(A,S,o,p)})}async removeSession(g,A){const S=this.b.get(g);return S?S.provider.removeSession(A):this.a.$removeSession(g,A)}registerAuthenticationProvider(g,A,S,o){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:A,provider:S,options:o??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===g)||this.c.push({id:g,label:A});const v=S.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(g,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(g,A,o?.supportsMultipleAccounts??!1),new P.$wK(()=>{v.dispose(),this.b.delete(g);const p=this.c.findIndex(f=>f.id===g);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,A,S){const o=this.b.get(g);if(o)return Promise.resolve(o.provider.createSession(A,S));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,A){const S=this.b.get(g);if(S)return Promise.resolve(S.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,A){const S=this.b.get(g);if(S)return Promise.resolve(S.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,A){return this.d.fire({provider:{id:g,label:A}}),Promise.resolve()}}e.$Lec=R;class ${constructor(){this.a=new Map}getOrCreate(g,A){const S=this.a.get(g);if(S)return S;const o=A().finally(()=>this.a.delete(g));return this.a.set(g,o),o}}}),define(Ae[234],Re([1,0,3,17,8]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0;let M=class{constructor($,D){this.a=$.getProxy(E.$uK.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>D.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,D,g){const A=P.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,g?.isRefactoring??!1)}};e.$Rec=M,e.$Rec=M=Ke([Ve(0,L.$wM)],M)}),define(Ae[235],Re([1,0,12,5,68,6,50,157,3,8]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=void 0;class A{static{this.a=0}constructor(v,p){this.extension=v,this.provider=p,this.handle=A.a++}}class S{static{this.a=0}constructor(v,p){this.h=p,this.b=new Map,this.d=new Map,this.e=new L.$Od,this.onDidPerformUserAction=this.e.event,this.g=v.getProxy(D.$uK.MainThreadChat)}registerChatProvider(v,p,f){const t=new A(v,f);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,p),(0,M.$Pc)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(v,p){const f=P.Iterable.find(this.d.keys(),t=>this.d.get(t)===v)??0;typeof f=="number"&&this.g.$transferChatSession(f,p)}sendInteractiveRequestToProvider(v,p){this.g.$sendRequestToProvider(v,p)}async $prepareChat(v,p,f){const t=this.b.get(v);if(!t)return;const i=await t.provider.prepareSession(p,f);if(!i)return;const n=S.a++;return this.d.set(n,i),{id:n,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $provideWelcomeMessage(v,p){const f=this.b.get(v);if(!f||!f.provider.provideWelcomeMessage)return;const t=await f.provider.provideWelcomeMessage(p);if(t)return t.map(i=>typeof i=="string"?i:Array.isArray(i)?i.map(n=>g.ChatReplyFollowup.from(n)):g.MarkdownString.from(i))}async $provideFollowups(v,p,f){const t=this.b.get(v);if(!t)return;const i=this.d.get(p);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,f))?.map(u=>g.ChatFollowup.from(u))}async $provideSampleQuestions(v,p){const f=this.b.get(v);if(!f||!f.provider.provideSampleQuestions)return;const t=await f.provider.provideSampleQuestions(p);if(t)return t?.map(i=>g.ChatReplyFollowup.from(i))}$removeRequest(v,p,f){const t=this.b.get(v);if(!t)return;const i=this.d.get(p);i&&t.provider.removeRequest&&t.provider.removeRequest(i,f)}async $provideReply(v,p,f,t){const i=this.b.get(v);if(!i)return;const n=this.d.get(p);if(!n)return;const u={session:n,message:f.message,variables:{}};if(f.variables)for(const h of Object.keys(f.variables))u.variables[h]=f.variables[h].map(g.ChatVariable.to);const a=R.$Kd.create(!1);let l;const r={report:h=>{if(t.isCancellationRequested)return;typeof l>"u"&&(l=a.elapsed());const w=g.ChatResponseProgress.from(i.extension,h);if("placeholder"in h&&"resolvedContent"in h){const m=Promise.all([this.g.$acceptResponseProgress(v,p,w),h.resolvedContent]);(0,E.$Jg)(m,t).then(I=>{if(!I)return;const[k,d]=I;this.g.$acceptResponseProgress(v,p,d,k??void 0)})}else this.g.$acceptResponseProgress(v,p,w)}};let s;try{s=await i.provider.provideResponseWithProgress(u,r,t),s||(s={errorDetails:{message:(0,$.localize)(0,null)}})}catch(h){s={errorDetails:{message:(0,$.localize)(1,null,h.message),responseIsIncomplete:!0}},this.h.error(h)}try{if(n.saveState&&this.d.has(p)){const h=n.saveState();this.g.$acceptChatState(p,h)}}catch(h){this.h.warn(h)}const c={firstProgress:l??0,totalElapsed:a.elapsed()};return{errorDetails:s.errorDetails,timings:c}}async $provideSlashCommands(v,p,f){const t=this.b.get(v);if(!t)return;const i=this.d.get(p);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,f))?.map(u=>({...u,kind:g.CompletionItemKind.from(u.kind)}))}$releaseSession(v){this.d.delete(v)}async $onDidPerformUserAction(v){this.e.fire(v)}}e.$6ec=S}),define(Ae[236],Re([1,0,12,6,54,3,8,7]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class D{static{this.a=0}constructor(S,o,v){this.d=o,this.e=v,this.b=new Map,this.c=S.getProxy(M.$uK.MainThreadChatAgents)}registerAgent(S,o,v,p){const f=D.a++;return this.b.set(f,{extension:S,agent:v}),this.c.$registerAgent(f,o,p),(0,L.$Pc)(()=>{this.c.$unregisterAgent(f),this.b.delete(f)})}async $invokeAgent(S,o,v,p,f){const t=this.b.get(S);if(!t){this.e.warn(`[CHAT](${S}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function n(){if(i)throw new Error("Only valid while executing the command")}const u=new E.$fh;f.onCancellationRequested(()=>u.complete()),setTimeout(()=>u.complete(),10*1e3),this.d.allowListExtensionWhile(t.extension,u.p);const a=t.agent({role:$.ChatMessageRole.User,content:v},{history:p.history.map(R.ChatMessage.to)},new P.$8u(l=>{n(),this.c.$handleProgressChunk(o,{content:g(l.message)?l.message:l.message.value})}),f);try{return await(0,E.$Jg)(Promise.resolve(a).then(l=>{if(l&&"followUp"in l)return{followUp:l?.followUp?.map(s=>R.ChatFollowup.from(s))}}),f)}finally{i=!0,u.complete()}}}e.$dfc=D;function g(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(Ae[237],Re([1,0,12,20,39,5,50,16,2,158,54,3,8,7,207,23]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class t{static{this.a=0}constructor(u,a,l){this.i=a,this.j=l,this.b=new Map,this.g=new Map,this.h=new Map,this.d=u.getProxy(S.$uK.MainThreadChatAgents2)}createChatAgent(u,a,l){const r=t.a++,s=new i(u,a,this.d,r,l);return this.b.set(r,s),this.d.$registerAgent(r,a,{}),s.apiAgent}async $invokeAgent(u,a,l,r,s,c){this.g.delete(a);const h=this.b.get(u);if(!h)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);let w=!1;function m(){if(w)throw new Error("Only valid while executing the command")}const I=new E.$fh;c.onCancellationRequested(()=>I.complete()),setTimeout(()=>I.complete(),10*1e3),this.i.allowListExtensionWhile(h.extension.identifier,I.p);const k=r.command?await h.validateSlashCommand(r.command):void 0,d=R.$Kd.create(!1);let b;try{const y=h.invoke({prompt:r.message,variables:o.ChatVariable.objectTo(r.variables),slashCommand:k},{history:s.history.map(o.ChatMessage.to)},new A.$8u(C=>{m(),typeof b>"u"&&"content"in C&&(b=d.elapsed());const B=o.ChatResponseProgress.from(h.extension,C);if("placeholder"in C&&"resolvedContent"in C){const H=Promise.all([this.d.$handleProgressChunk(l,B),C.resolvedContent]);(0,E.$Jg)(H,c).then(U=>{if(!U)return;const[z,F]=U;this.d.$handleProgressChunk(l,F,z??void 0)})}else this.d.$handleProgressChunk(l,B)}),c);return await(0,E.$Jg)(Promise.resolve(y).then(C=>{if(C){this.g.set(a,C);let B=this.h.get(a);B||(B=new Map,this.h.set(a,B)),B.set(l,C);const H={firstProgress:b,totalElapsed:d.elapsed()};return{errorDetails:C.errorDetails,timings:H}}else this.g.delete(a)}),c)}catch(y){return this.j.error(y,h.extension),{errorDetails:{message:(0,g.localize)(0,null,(0,P.$Di)(y)),responseIsIncomplete:!0}}}finally{w=!0,I.complete()}}$releaseSession(u){this.g.delete(u),this.h.delete(u)}async $provideSlashCommands(u,a){const l=this.b.get(u);return l?l.provideSlashCommand(a):[]}$provideFollowups(u,a,l){const r=this.b.get(u);if(!r)return Promise.resolve([]);const s=this.g.get(a);return s?r.provideFollowups(s,l):Promise.resolve([])}$acceptFeedback(u,a,l,r){const s=this.b.get(u);if(!s)return;const c=this.h.get(a)?.get(l);if(!c)return;let h;switch(r){case p.InteractiveSessionVoteDirection.Down:h=v.ChatAgentResultFeedbackKind.Unhelpful;break;case p.InteractiveSessionVoteDirection.Up:h=v.ChatAgentResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze({result:c,kind:h}))}$acceptAction(u,a,l,r){const s=this.b.get(u);if(!s)return;const c=this.h.get(a)?.get(l);c&&r.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:r.action,result:c}))}}e.$efc=t;class i{constructor(u,a,l,r,s){this.extension=u,this.n=a,this.o=l,this.q=r,this.r=s,this.l=new M.$Od,this.m=new M.$Od}acceptFeedback(u){this.l.fire(u)}acceptAction(u){this.m.fire(u)}async validateSlashCommand(u){this.b||(await this.provideSlashCommand(L.CancellationToken.None),(0,$.$Jf)(this.b));const a=this.b.find(l=>l.name===u);if(!a)throw new Error(`Unknown slashCommand: ${u}`);return a}async provideSlashCommand(u){if(!this.a)return[];const a=await this.a.provideSlashCommands(u);return a?(this.b=a,a.map(l=>({name:l.name,description:l.description,followupPlaceholder:l.followupPlaceholder,shouldRepopulate:l.shouldRepopulate}))):[]}async provideFollowups(u,a){if(!this.d)return[];const l=await this.d.provideFollowups(u,a);return l?l.map(r=>o.ChatFollowup.from(r)):[]}get apiAgent(){let u=!1,a=!1;const l=()=>{u||a||(a=!0,queueMicrotask(()=>{this.o.$updateAgent(this.q,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof D.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof v.$qL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j,isSecondary:this.k}),a=!1}))},r=this;return{get name(){return r.n},get description(){return r.g??""},set description(s){r.g=s,l()},get fullName(){return r.h??r.extension.displayName??r.extension.name},set fullName(s){r.h=s,l()},get iconPath(){return r.i},set iconPath(s){r.i=s,l()},get slashCommandProvider(){return r.a},set slashCommandProvider(s){r.a=s,l()},get followupProvider(){return r.d},set followupProvider(s){r.d=s,l()},get isDefault(){return(0,f.$uF)(r.extension,"defaultChatAgent"),r.j},set isDefault(s){(0,f.$uF)(r.extension,"defaultChatAgent"),r.j=s,l()},get isSecondary(){return(0,f.$uF)(r.extension,"defaultChatAgent"),r.k},set isSecondary(s){(0,f.$uF)(r.extension,"defaultChatAgent"),r.k=s,l()},get onDidReceiveFeedback(){return r.l.event},onDidPerformAction:(0,f.$tF)(this.extension,"chatAgents2Additions")?this.m.event:void 0,dispose(){u=!0,r.a=void 0,r.d=void 0,r.l.dispose(),r.o.$unregisterAgent(r.q)}}}invoke(u,a,l,r){return this.r(u,a,l,r)}}}),define(Ae[238],Re([1,0,20,6,3,8,54,22,12,5]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;class A{constructor(p,f){this.stream=new D.$jh,this.stream=f??new D.$jh;const t=this;this.apiObj={option:p,response:t.stream.asyncIterable}}}class S{constructor(p,f){this.a=new g.$Od,this.b=new Map,this.c=new D.$jh,this.d=!1;const t=this;this.apiObject={result:p,response:t.c.asyncIterable,onDidStartResponseStream:t.a.event,cancel(){f.cancel()}},p.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,i]of this.b)i.stream.resolve();else this.c.resolve()})}handleFragment(p){if(this.d)return;let f=this.b.get(p.index);f||(this.b.size===0?f=new A(p.index,this.c):f=new A(p.index),this.b.set(p.index,f),this.a.fire(f.apiObj)),f.stream.emitOne(p.part)}}class o{static{this.a=1}constructor(p,f){this.d=f,this.c=new Map,this.e=new Map,this.f=new $.$$l,this.b=p.getProxy(P.$uK.MainThreadChatProvider)}registerProvider(p,f,t,i){const n=o.a++;return this.c.set(n,{extension:p,provider:t}),this.b.$registerProvider(n,f,{extension:p,displayName:i.name??p.value}),(0,L.$Pc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(p,f,t,i,n){const u=this.c.get(p);if(!u)return;const a=new R.$8u(async l=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${u.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:l.index,part:l.part})});return u.provider.provideChatResponse(t.map(M.ChatMessage.to),i,a,n)}allowListExtensionWhile(p,f){this.f.set(p,f),f.finally(()=>this.f.delete(p))}async requestChatResponseProvider(p,f){if(!this.f.has(p))throw new Error("Extension is NOT allowed to make chat requests");const t=this;return{get isRevoked(){return!t.f.has(p)},makeRequest(i,n,u){if(!t.f.has(p))throw new Error("Access to chat has been revoked");const a=new E.$Yd(u),l=Math.random()*1e6|0,r=t.b.$fetchResponse(p,f,l,i.map(M.ChatMessage.from),n??{},a.token),s=new S(r,a);return t.e.set(l,{res:s}),r.finally(()=>{t.e.delete(l)}),s.apiObject}}}async $handleResponseFragment(p,f){const t=this.e.get(p);t&&t.res.handleFragment(f)}}e.$$ec=o}),define(Ae[239],Re([1,0,6,3,11,8]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class R{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(L.$uK.MainThreadChatVariables)}async $resolveVariable(D,g,A){const S=this.b.get(D);if(S)try{const o=await S.resolver.resolve(S.data.name,{message:g},A);if(o)return o.map(M.ChatVariable.from)}catch(o){(0,P.$1)(o)}}registerVariableResolver(D,g,A,S){const o=R.a++;return this.b.set(o,{extension:D.identifier,data:{name:g,description:A},resolver:S}),this.c.$registerVariable(o,{name:g,description:A}),(0,E.$Pc)(()=>{this.b.delete(o),this.c.$unregisterVariable(o)})}}e.$afc=R}),define(Ae[240],Re([1,0,3]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class L{constructor(M){const R=M.getProxy(E.$uK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText($){return R.$writeText($)}})}}e.$idc=L}),define(Ae[32],Re([1,0,16,7,8,26,3,18,15,52,29,131,2,6,4,17,108,24,49,39,50,58,61]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=void 0;let s=class{#e;#t;#i;constructor(k,d,b){this.b=new Map,this.c=new Map,this.#e=k.getProxy(R.$uK.MainThreadCommands),this.d=d,this.#i=b,this.#t=k.getProxy(R.$uK.MainThreadTelemetry),this.converter=new c(this,y=>{const C=this.c.get(y);return C?.result===w.Void?C:void 0},d),this.f=[{processArgument(y){return(0,g.$ph)(y)}},{processArgument(y){return(0,M.$_m)(y,function(C){if(A.$ws.isIRange(C))return P.Range.to(C);if(S.$vs.isIPosition(C))return P.Position.to(C);if(A.$ws.isIRange(C.range)&&o.URI.isUri(C.uri))return P.location.to(C);if(C instanceof i.$ce)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const d=this.registerCommand(!1,k.id,async(...b)=>{const y=k.args.map((B,H)=>{if(!B.validate(b[H]))throw new Error(`Invalid argument '${B.name}' when running '${k.id}', received: ${typeof b[H]=="object"?JSON.stringify(b[H],null,"	"):b[H]} `);return B.convert(b[H])}),C=await this.executeCommand(k.internalId,...y);return k.result.convert(C,b,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new L.$wK(()=>{d.dispose(),this.c.delete(k.id)})}registerCommand(k,d,b,y,C,B){if(this.d.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this.b.has(d))throw new Error(`command '${d}' already exists`);return this.b.set(d,{callback:b,thisArg:y,metadata:C,extension:B}),k&&this.#e.$registerCommand(d),new L.$wK(()=>{this.b.delete(d)&&k&&this.#e.$unregisterCommand(d)})}executeCommand(k,...d){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,d,!0)}async g(k,d,b){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,d,!1);{let y=!1;const C=(0,M.$_m)(d,function(B){if(B instanceof L.$xK)return P.Position.from(B);if(B instanceof L.$yK)return P.Range.from(B);if(B instanceof L.$IK)return P.location.from(B);if(L.$TL.isNotebookRange(B))return P.NotebookRange.from(B);if(B instanceof ArrayBuffer)return y=!0,i.$ce.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return y=!0,i.$ce.wrap(B);if(B instanceof i.$ce)return y=!0,B;if(!Array.isArray(B))return B});try{const B=await this.#e.$executeCommand(k,y?new n.$tv(C):C,b);return(0,g.$ph)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this.g(k,d,!1);throw B}}}async h(k,d,b){const y=this.b.get(k);if(!y)throw new Error("Unknown command");const{callback:C,thisArg:B,metadata:H}=y;if(H?.args)for(let z=0;z<H.args.length;z++)try{(0,E.$Qf)(d[z],H.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${H.args[z].name}' - ${H.args[z].description}`)}const U=a.$Kd.create();try{return await C.apply(B,d)}catch(z){if(k===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...d);F&&(k=F.command)}if(this.d.error(z,k,y.extension?.identifier),!b)throw z;if(y.extension?.identifier){const F=this.#i.onExtensionError(y.extension.identifier,z);this.d.trace("forwarded error to extension?",F,y.extension?.identifier)}throw new class extends Error{constructor(){super((0,u.$Di)(z)),this.id=k,this.source=y.extension?.displayName??y.extension?.name}}}finally{this.j(y,k,U.elapsed())}}j(k,d,b){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new l.$mo(d),duration:b})}$executeContributedCommand(k,...d){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const b=this.b.get(k);return b?(d=d.map(y=>this.f.reduce((C,B)=>B.processArgument(C,b.extension?.identifier),y)),this.h(k,d,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(d=>(k&&(d=d.filter(b=>b[0]!=="_")),d))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[d,b]of this.b){const{metadata:y}=b;y&&(k[d]=y)}return Promise.resolve(k)}};e.$RM=s,e.$RM=s=Ke([Ve(0,f.$wM),Ve(1,D.$aj),Ve(2,r.$QM)],s),e.$SM=(0,p.$Sh)("IExtHostCommands");class c{constructor(k,d,b){this.d=k,this.f=d,this.g=b,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,d){if(!k)return;const b={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return b;const y=this.f(k.command);if(y)b.id=y.internalId,b.arguments=y.args.map((C,B)=>C.convert(k.arguments&&k.arguments[B]));else if((0,$.$Kb)(k.arguments)){const C=`${k.command} /${++this.c}`;this.b.set(C,k),d.add((0,v.$Pc)(()=>{this.b.delete(C),this.g.trace("CommandsConverter#DISPOSE",C)})),b.$ident=C,b.id=this.delegatingCommandId,b.arguments=[C],this.g.trace("CommandsConverter#CREATE",k.command,C)}return b}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const d=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],d?d.command:"MISSING"),d?this.d.executeCommand(d.command,...d.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$TM=c;class h{static{this.Uri=new h("uri","Uri of a text document",k=>o.URI.isUri(k),k=>k)}static{this.Position=new h("position","A position in a text document",k=>L.$xK.isPosition(k),P.Position.from)}static{this.Range=new h("range","A range in a text document",k=>L.$yK.isRange(k),P.Range.from)}static{this.Selection=new h("selection","A selection in a text document",k=>L.$zK.isSelection(k),P.Selection.from)}static{this.Number=new h("number","",k=>typeof k=="number",k=>k)}static{this.String=new h("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=h.Arr(h.String)}static Arr(k){return new h(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,d=>Array.isArray(d)&&d.every(b=>k.validate(b)),d=>d.map(b=>k.convert(b)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",k=>k instanceof L.$SK,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",k=>k instanceof L.$aM,P.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VS Code TestItem",k=>k instanceof t.$JM,P.TestItem.from)}constructor(k,d,b,y){this.name=k,this.description=d,this.validate=b,this.convert=y}optional(){return new h(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,d){return new h(k??this.name,d??this.description,this.validate,this.convert)}}e.$UM=h;class w{static{this.Void=new w("no result",k=>k)}constructor(k,d){this.description=k,this.convert=d}}e.$VM=w;class m{constructor(k,d,b,y,C){this.id=k,this.internalId=d,this.description=b,this.args=y,this.result=C}}e.$WM=m}),define(Ae[241],Re([1,0,18,14,2,80,95,34,99,32,8,7]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;const o=[new g.$WM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of DocumentHighlight-instances.",p(A.DocumentHighlight.to))),new g.$WM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$UM.Uri],new g.$VM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,E.$Jb)(t))return;class n extends S.$NK{static to(a){const l=new n(a.name,A.SymbolKind.to(a.kind),a.containerName||"",new S.$IK(i[0],A.Range.to(a.range)));return l.detail=a.detail,l.range=l.location.range,l.selectionRange=A.Range.to(a.selectionRange),l.children=a.children?a.children.map(n.to):[],l}}return t.map(n.to)})),new g.$WM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$UM.Uri,new g.$UM("options","Formatting options",t=>!0,t=>t)],new g.$VM("A promise that resolves to an array of TextEdits.",p(A.TextEdit.to))),new g.$WM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$UM.Uri,g.$UM.Range,new g.$UM("options","Formatting options",t=>!0,t=>t)],new g.$VM("A promise that resolves to an array of TextEdits.",p(A.TextEdit.to))),new g.$WM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$UM.Uri,g.$UM.Position,new g.$UM("ch","Trigger character",t=>typeof t=="string",t=>t),new g.$UM("options","Formatting options",t=>!0,t=>t)],new g.$VM("A promise that resolves to an array of TextEdits.",p(A.TextEdit.to))),new g.$WM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$WM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$WM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$WM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$WM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of Location-instances.",p(A.location.to))),new g.$WM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of Hover-instances.",p(A.Hover.to))),new g.$WM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$UM.Uri,new g.$UM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>S.$xK.isPosition(i)),t=>t.map(A.Position.from))],new g.$VM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let n;for(const u of i.reverse())n=new S.$RK(A.Range.to(u),n);return n}))),new g.$WM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$UM.String.with("query","Search string")],new g.$VM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(A.WorkspaceSymbol.to))),new g.$WM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(A.CallHierarchyItem.to))),new g.$WM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$UM.CallHierarchyItem],new g.$VM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(A.CallHierarchyIncomingCall.to))),new g.$WM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$UM.CallHierarchyItem],new g.$VM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(A.CallHierarchyOutgoingCall.to))),new g.$WM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:A.Range.to(t.range),placeholder:t.text}})),new g.$WM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$UM.Uri,g.$UM.Position,g.$UM.String.with("newName","The new symbol name")],new g.$VM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return A.WorkspaceEdit.to(t)}})),new g.$WM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$UM.Uri,g.$UM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$VM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(A.DocumentLink.to))),new g.$WM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$UM.Uri],new g.$VM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new S.$LL(t.tokenTypes,t.tokenModifiers)})),new g.$WM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$UM.Uri],new g.$VM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,R.$y$)(t);if(i.type==="full")return new S.$NL(i.data,void 0)})),new g.$WM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$UM.Uri,g.$UM.Range.optional()],new g.$VM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new S.$LL(t.tokenTypes,t.tokenModifiers)})),new g.$WM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$UM.Uri,g.$UM.Range],new g.$VM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,R.$y$)(t);if(i.type==="full")return new S.$NL(i.data,void 0)})),new g.$WM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$UM.Uri,g.$UM.Position,g.$UM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$UM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$VM("A promise that resolves to a CompletionList-instance.",(t,i,n)=>{if(!t)return new S.$4K([]);const u=t.suggestions.map(a=>A.CompletionItem.to(a,n));return new S.$4K(u,t.incomplete)})),new g.$WM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$UM.Uri,g.$UM.Position,g.$UM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$VM("A promise that resolves to SignatureHelp.",t=>{if(t)return A.SignatureHelp.to(t)})),new g.$WM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$UM.Uri,g.$UM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$VM("A promise that resolves to an array of CodeLens-instances.",(t,i,n)=>p(u=>new S.$VK(A.Range.to(u.range),u.command&&n.fromInternal(u.command)))(t))),new g.$WM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$UM.Uri,new g.$UM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>S.$yK.isRange(t),t=>S.$zK.isSelection(t)?A.Selection.from(t):A.Range.from(t)),g.$UM.String.with("kind","Code action kind to return code actions for").optional(),g.$UM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$VM("A promise that resolves to an array of Command-instances.",(t,i,n)=>p(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return n.fromInternal(u.command)}else{const a=new S.$PK(u.title,u.kind?new S.$QK(u.kind):void 0);return u.edit&&(a.edit=A.WorkspaceEdit.to(u.edit)),u.command&&(a.command=n.fromInternal(u.command)),a.isPreferred=u.isPreferred,a}})(t))),new g.$WM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$UM.Uri],new g.$VM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new S.$0K(A.Range.to(i.range),A.Color.to(i.color))):[])),new g.$WM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$UM("color","The color to show and insert",t=>t instanceof S.$9K,A.Color.from),new g.$UM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:A.Range.from(t.range)}))],new g.$VM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(A.ColorPresentation.to):[])),new g.$WM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$UM.Uri,g.$UM.Range],new g.$VM("A promise that resolves to an array of Inlay objects",(t,i,n)=>t.map(A.InlayHint.to.bind(void 0,n)))),new g.$WM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$UM.Uri],new g.$VM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(A.FoldingRange.to)})),new g.$WM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$VM("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>A.NotebookExclusiveDocumentPattern.to(i))})))),new g.$WM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$UM.Uri,g.$UM.Range,new g.$UM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof S.$yK,t=>A.InlineValueContext.from(t))],new g.$VM("A promise that resolves to an array of InlineValue objects",t=>t.map(A.InlineValue.to))),new g.$WM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$UM("uriOrString","Uri-instance or string (only http/https)",t=>P.URI.isUri(t)||typeof t=="string"&&(0,D.$KU)(t,L.Schemas.http,L.Schemas.https),t=>t),new g.$UM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional(),g.$UM.String.with("label","").optional()],g.$VM.Void),new g.$WM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$UM.Uri.with("resource","Resource to open"),g.$UM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$UM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional()],g.$VM.Void),new g.$WM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$UM.Uri.with("left","Left-hand side resource of the diff editor"),g.$UM.Uri.with("right","Right-hand side resource of the diff editor"),g.$UM.String.with("title","Human readable title for the diff editor").optional(),new g.$UM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)]).optional()],g.$VM.Void),new g.$WM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$UM.Uri,g.$UM.Position],new g.$VM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new g.$WM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$UM.TypeHierarchyItem],new g.$VM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new g.$WM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$UM.TypeHierarchyItem],new g.$VM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new g.$WM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$UM.TestItem],g.$VM.Void),new g.$WM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$UM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$VM.Void),new g.$WM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$UM.String.with("name","The context key name"),new g.$UM("value","The context key value",()=>!0,t=>t)],g.$VM.Void),new g.$WM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$UM.Uri,g.$UM.StringArray,new g.$UM("MappedEditsContext","Mapped Edits Context",t=>A.MappedEditsContext.is(t),t=>A.MappedEditsContext.from(t))],new g.$VM("A promise that resolves to a workspace edit or null",t=>t?A.WorkspaceEdit.to(t):null))];class v{static register(i){o.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",$.$Ri)}}e.$hdc=v;function p(t){return i=>{if(Array.isArray(i))return i.map(t)}}function f(t){if(!Array.isArray(t))return;const i=[];for(const n of t)M.$ht(n)?i.push(A.DefinitionLink.to(n)):i.push(A.location.to(n));return i}}),define(Ae[242],Re([1,0,12,67,5,6,2,80,22,8,7,3,23]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;function v(p,f,t){const i=p.getProxy(S.$uK.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new D.$$l,f.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===6){const I=this.b.get(m.handle);return I?I.value:m}else if(m&&m.$mid===7){const I=this.b.get(m.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.commentThreadHandle);return k?k.value:m}else if(m&&(m.$mid===9||m.$mid===8)){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);return k?m.$mid===8?k.value:{thread:k.value,text:m.text}:m}else if(m&&m.$mid===10){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const d=m.commentUniqueId,b=k.getCommentByUniqueId(d);return b||m}else if(m&&m.$mid===11){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const d=m.text,b=m.commentUniqueId,y=k.getCommentByUniqueId(b);return y?(typeof y.body=="string"?y.body=d:y.body=new A.$WK(d),y):m}return m}})}createCommentController(m,I,k){const d=n.a++,b=new a(m,d,I,k);this.b.set(b.handle,b);const y=this.c.get(m.identifier)||[];return y.push(b),this.c.set(m.identifier,y),b.value}async $createCommentThreadTemplate(m,I,k){const d=this.b.get(m);d&&d.$createCommentThreadTemplate(I,k)}async $updateCommentThreadTemplate(m,I,k){const d=this.b.get(m);d&&d.$updateCommentThreadTemplate(I,k)}$deleteCommentThread(m,I){this.b.get(m)?.$deleteCommentThread(I)}$provideCommentingRanges(m,I,k){const d=this.b.get(m);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const b=t.getDocument(R.URI.revive(I));return(0,E.$Ng)(async()=>{const y=await d.commentingRangeProvider.provideCommentingRanges(b,k);let C;return Array.isArray(y)?C={ranges:y,fileComments:!1}:y?C={ranges:y.ranges||[],fileComments:y.fileComments||!1}:C=y??void 0,C}).then(y=>{let C;return y&&(C={ranges:y.ranges.map(B=>g.Range.from(B)),fileComments:y.fileComments}),C})}$toggleReaction(m,I,k,d,b){const y=this.b.get(m);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,E.$Ng)(()=>{const C=y.getCommentThread(I);if(C){const B=C.getCommentByUniqueId(d.uniqueIdInThread);if(y!==void 0&&B&&y.reactionHandler)return y.reactionHandler(B,s(b))}return Promise.resolve(void 0)})}}class u{static{this.a=0}set threadId(m){this.n=m}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(m){(m===void 0!=(this.p===void 0)||!m||!this.p||!m.isEqual(this.p))&&(this.p=m,this.b.range=m,this.c.fire())}get range(){return this.p}set canReply(m){this.d!==m&&(this.d=m,this.b.canReply=m,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(m){this.e=m,this.b.label=m,this.c.fire()}get contextValue(){return this.f}set contextValue(m){this.f=m,this.b.contextValue=m,this.c.fire()}get comments(){return this.q}set comments(m){this.q=m,this.b.comments=m,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(m){this.g=m,this.b.collapsibleState=m,this.c.fire()}get state(){return this.h}set state(m){this.h=m,this.b.state=m,this.c.fire()}get isDisposed(){return this.j}constructor(m,I,k,d,b,y,C,B){this.m=I,this.n=k,this.o=d,this.p=b,this.q=y,this.extensionDescription=C,this.r=B,this.handle=u.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$Od,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Sc,this.l.value=new M.$Qc,this.n===void 0&&(this.n=`${m}.${this.handle}`),i.$createCommentThread(I,this.handle,this.n,this.o,g.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const H=this;this.value={get uri(){return H.uri},get range(){return H.range},set range(U){H.range=U},get comments(){return H.comments},set comments(U){H.comments=U},get collapsibleState(){return H.collapsibleState},set collapsibleState(U){H.collapsibleState=U},get canReply(){return H.canReply},set canReply(U){H.canReply=U},get contextValue(){return H.contextValue},set contextValue(U){H.contextValue=U},get label(){return H.label},set label(U){H.label=U},get state(){return H.state},set state(U){H.state=U},dispose:()=>{H.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Qc);const m=k=>Object.prototype.hasOwnProperty.call(this.b,k),I={};m("range")&&(I.range=g.Range.from(this.p)),m("label")&&(I.label=this.label),m("contextValue")&&(I.contextValue=this.contextValue??null),m("comments")&&(I.comments=this.q.map(k=>l(this,k,this.k,this.extensionDescription))),m("collapsibleState")&&(I.collapseState=c(this.g)),m("canReply")&&(I.canReply=this.canReply),m("state")&&(I.state=h(this.h)),m("isTemplate")&&(I.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(m){for(const I of this.k){const k=I[0],d=I[1];if(m===d)return k}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(m=>m.dispose())}}Ke([(0,L.$lh)(100)],u.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(m){this.b=m,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(m){this.c=m,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!m})}get options(){return this.d}set options(m){this.d=m,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(m,I,k,d){this.f=m,this.g=I,this.h=k,this.i=d,this.a=new Map,i.$registerCommentController(this.handle,k,d,this.f.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(y){b.options=y},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(y){b.commentingRangeProvider=y},get reactionHandler(){return b.reactionHandler},set reactionHandler(y){b.reactionHandler=y},createCommentThread(y,C,B){return b.createCommentThread(y,C,B).value},dispose:()=>{b.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(m,I,k){I===void 0&&(0,o.$uF)(this.f,"fileComments");const d=new u(this.id,this.handle,void 0,m,I,k,this.f,!1);return this.a.set(d.handle,d),d}$createCommentThreadTemplate(m,I){const k=new u(this.id,this.handle,void 0,R.URI.revive(m),g.Range.to(I),[],this.f,!0);return k.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(k.handle,k),k}$updateCommentThreadTemplate(m,I){const k=this.a.get(m);k&&(k.range=g.Range.to(I))}$deleteCommentThread(m){this.a.get(m)?.dispose(),this.a.delete(m)}getCommentThread(m){return this.a.get(m)}dispose(){this.a.forEach(m=>{m.dispose()}),this.e.forEach(m=>m.dispose())}}function l(w,m,I,k){let d=I.get(m);return d||(d=++w.commentHandle,I.set(m,d)),m.state!==void 0&&(0,o.$uF)(k,"commentsDraftState"),{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:d,body:typeof m.body=="string"?m.body:g.MarkdownString.from(m.body),userName:m.author.name,userIconPath:m.author.iconPath,label:m.label,commentReactions:m.reactions?m.reactions.map(b=>r(b)):void 0,state:m.state,timestamp:m.timestamp?.toJSON()}}function r(w){return{label:w.label,iconPath:w.iconPath?g.$vM(w.iconPath):void 0,count:w.count,hasReacted:w.authorHasReacted}}function s(w){return{label:w.label||"",count:w.count||0,iconPath:w.iconPath?R.URI.revive(w.iconPath):"",authorHasReacted:w.hasReacted||!1}}function c(w){if(w!==void 0)switch(w){case A.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function h(w){if(w!==void 0)switch(w){case A.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new n}e.$jdc=v}),define(Ae[243],Re([1,0,26,3,27,17]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0;let R=class{constructor(A,S){this.a=A.getProxy(L.$uK.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,S){const o=this,v=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){o.e(A,S,v,arguments)}})}e(A,S,o,v){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:D(v,this.b)}),this.c&&this.f(A,o,v)}};e.$hfc=R,e.$hfc=R=Ke([Ve(0,M.$wM),Ve(1,P.$MM)],R);const $=1e5;function D(g,A){const S=[];if(g.length)for(let o=0;o<g.length;o++){let v=g[o];if(typeof v>"u")v="undefined";else if(v instanceof Error){const p=v;p.stack?v=p.stack:v=p.toString()}S.push(v)}if(A){const o=new Error().stack;o&&S.push({__$stack:o.split(`
`).slice(3).join(`
`)})}try{const o=(0,E.$cn)(S);return o.length>$?"Output omitted for a large object that exceeds the limits":o}catch(o){return`Output omitted for an object that cannot be inspected ('${o.toString()}')`}}}),define(Ae[110],Re([1,0,2,3,7,4,17,15,18,13,19,23]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=e.$kec=void 0;let v=class{static{o=this}static{this.c=0}static{this.d=250}constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(L.$uK.MainThreadDecorations)}registerFileDecorationProvider(f,t){const i=o.c++;this.f.set(i,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const n=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(u=>{if(!u){this.g.$onDidChange(i,null);return}const a=(0,D.$2b)(u);if(a.length<=o.d){this.g.$onDidChange(i,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,a.length);const l=a.map(c=>({uri:c,rank:(0,g.$He)(c.path,"/")})),r=(0,D.$yb)(l,(c,h)=>c.rank-h.rank||(0,g.$Ve)(c.uri.path,h.uri.path)),s=[];e:for(const c of r){let h;for(const w of c){const m=(0,A.$lc)(w.uri.path);if(h!==m&&(h=m,s.push(w.uri)>=o.d))break e}}this.g.$onDidChange(i,s)});return new P.$wK(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(f,t,i){if(!this.f.has(f))return Object.create(null);const n=Object.create(null),{provider:u,extensionDescription:a}=this.f.get(f);return await Promise.all(t.map(async l=>{try{const{uri:r,id:s}=l,c=await Promise.resolve(u.provideFileDecoration(E.URI.revive(r),i));if(!c)return;try{P.$RL.validate(c),c.badge&&typeof c.badge!="string"&&(0,S.$uF)(a,"codiconDecoration"),n[s]=[c.propagate,c.tooltip,c.badge,c.color]}catch(h){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${h}`)}}catch(r){this.h.error(r)}})),n}};e.$kec=v,e.$kec=v=o=Ke([Ve(0,R.$wM),Ve(1,$.$aj)],v),e.$lec=(0,M.$Sh)("IExtHostDecorations")}),define(Ae[244],Re([1,0,159,98,2,3,7,8,5,15,28,42]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=e.$bdc=void 0;class v{#e;#t;#i;constructor(t,i,n,u,a,l,r,s){this.d=t,this.e=i,this.f=n,this.g=u,this.h=a,this.c=!1,this.f=Math.max(u,n),this.#i=new A.$zc(c=>l.getComparisonKey(c)),this.#e=r,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let n=[];if(P.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),n=[t]}else if(Array.isArray(t)){n=[];let l;t=[...t].sort(v.k);for(const r of t){const[s,c]=r;if((!l||s.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=s,n.push(s),this.#i.set(s,[])),c)this.#i.get(s)?.push(...c);else{const h=this.#i.get(s);h&&(h.length=0)}}}if(this.#t.fire(n),!this.#e)return;const u=[];let a=0;for(const l of n){let r=[];const s=this.#i.get(l);if(s)if(s.length>this.g){r=[];const c=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(const w of s)if(w.severity===c[h]&&r.push({...$.Diagnostic.from(w),modelVersionId:this.h(l)})===this.g)break e;r.push({severity:L.MarkerSeverity.Info,message:(0,E.localize)(0,null,s.length-this.g),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(c=>({...$.Diagnostic.from(c),modelVersionId:this.h(l)}));if(u.push([l,r]),a+=r.length,a>this.f)break}this.#e.$changeMany(this.e,u)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[n,u]of this)t.call(i,n,u,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$bdc=v;let p=class{static{o=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*o.d}static _mapper(t){const i=new A.$zc;for(const n of t)i.set(n,n);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,n,u){this.j=i,this.k=n,this.l=u,this.g=new Map,this.h=new D.$Sd({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.h.event,o._mapper),this.f=t.getProxy(M.$uK.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:n,f:u,h:a,j:l,k:r,l:s}=this,c=new class{$changeMany(m,I){u.$changeMany(m,I),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,m,I.length===0?"CLEARING":I)}$clear(m){u.$clear(m),l.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,m)}dispose(){u.dispose()}};let h;if(!i)i="_generated_diagnostic_collection_name_#"+o.c++,h=i;else if(!n.has(i))h=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do h=i+o.c++;while(n.has(h))}return new class extends v{constructor(){super(i,h,o.e,o.d,m=>s.getDocument(m)?.version,r.extUri,c,a),n.set(h,this)}dispose(){super.dispose(),n.delete(h)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,n=[];for(const u of this.g.values())u.forEach((a,l)=>{let r=i.get(a.toString());typeof r>"u"&&(r=n.length,i.set(a.toString(),r),n.push([a,[]])),n[r][1]=n[r][1].concat(...l)});return n}}m(t){let i=[];for(const n of this.g.values())n.has(t)&&(i=i.concat(n.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",n=new v(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,u=>{},this.k.extUri,void 0,this.h);this.g.set(i,n),this.n=n}for(const[i,n]of t)this.n.set(P.URI.revive(i),n.map($.Diagnostic.to))}};e.$cdc=p,e.$cdc=p=o=Ke([Ve(1,g.$aj),Ve(2,S.$adc)],p)}),define(Ae[245],Re([1,0,2,3,23]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;class M{constructor($){this.a=$.getProxy(L.$uK.MainThreadDialogs)}showOpenDialog($,D){return D?.allowUIResources&&(0,P.$uF)($,"showLocal"),this.a.$showOpenDialog(D).then(g=>g?g.map(A=>E.URI.revive(A)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(D=>D?E.URI.revive(D):void 0)}}e.$rdc=M}),define(Ae[246],Re([1,0,11,2,7,3,14,20,13]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;class g{static{this.a=0}constructor(S,o,v){this.d=o,this.e=v,this.b=new Map,this.c=S.getProxy(M.$uK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,o){if(Object.keys(R.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const v=g.a++;this.b.set(v,o),this.c.$registerTextContentProvider(v,S);let p;return typeof o.onDidChange=="function"&&(p=o.onDidChange(f=>{if(f.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(v,f).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(f);if(!i)return;const n=(0,D.$Qe)(t);if(!i.equalLines(n))return this.c.$onVirtualDocumentChange(f,t)},E.$Z)})),new P.$wK(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(S,o){const v=this.b.get(S);return v?Promise.resolve(v.provideTextDocumentContent(L.URI.revive(o),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${o.scheme}`))}}e.$sdc=g}),define(Ae[247],Re([1,0,5,6,2,3,103,8,16,26,7,11]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;class o{constructor(p,f){this.a=new E.$Od({onListenerError:S.$1}),this.b=new E.$Od({onListenerError:S.$1}),this.c=new E.$Od({onListenerError:S.$1}),this.d=new E.$Od({onListenerError:S.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.$Qc,this.h=new Map,this.f=p.getProxy(M.$uK.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const f=this.g.getDocument(p);if(f)return f}getDocument(p){const f=this.getDocumentData(p);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return f.document}ensureDocumentData(p){const f=this.g.getDocument(p);if(f)return Promise.resolve(f);let t=this.h.get(p.toString());return t||(t=this.f.$tryOpenDocument(p).then(i=>{this.h.delete(p.toString());const n=P.URI.revive(i);return(0,D.$Kf)(this.g.getDocument(n))},i=>(this.h.delete(p.toString()),Promise.reject(i))),this.h.set(p.toString(),t)),t}createDocumentData(p){return this.f.$tryCreateDocument(p).then(f=>P.URI.revive(f))}$acceptModelLanguageChanged(p,f){const t=P.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(f),this.a.fire(i.document)}$acceptModelSaved(p){const f=P.URI.revive(p),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(p,f){const t=P.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(f),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,f,t){const i=P.URI.revive(p),n=this.g.getDocument(i);if(!n)throw new Error("unknown document");n._acceptIsDirty(t),n.onEvents(f);let u;f.isUndoing?u=A.TextDocumentChangeReason.Undo:f.isRedoing&&(u=A.TextDocumentChangeReason.Redo),this.c.fire((0,g.$$m)({document:n.document,contentChanges:f.changes.map(a=>({range:$.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:u}))}setWordDefinitionFor(p,f){(0,R.$yM)(p,f)}}e.$$cc=o}),define(Ae[62],Re([1,0,55,5,6,2,4,3,103,17,109,8,15,28,14,68,44]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=e.$GM=void 0;class i{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(a,l){this.h=a,this.i=l,this.a=null,this.b=new Map,this.c=new v.$zc,this.d=new L.$Od,this.e=new L.$Od,this.f=new L.$Od,this.g=new L.$Od,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const l=[],r=[],s=[];if(a.removedDocuments)for(const c of a.removedDocuments){const h=M.URI.revive(c),w=this.c.get(h);w?.unref()&&(this.c.delete(h),l.push(w.value))}if(a.addedDocuments)for(const c of a.addedDocuments){const h=M.URI.revive(c.uri);let w=this.c.get(h);if(w&&h.scheme!==p.Schemas.vscodeNotebookCell&&h.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${h} already exists!'`);w||(w=new i(new D.$zM(this.h.getProxy($.$uK.MainThreadDocuments),h,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this.c.set(h,w),r.push(w.value)),w.ref()}if(a.removedEditors)for(const c of a.removedEditors){const h=this.b.get(c);this.b.delete(c),h&&s.push(h)}if(a.addedEditors)for(const c of a.addedEditors){const h=M.URI.revive(c.documentUri);E.ok(this.c.has(h),`document '${h}' does not exist`),E.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const w=this.c.get(h).value,m=new A.$FM(c.id,this.h.getProxy($.$uK.MainThreadTextEditors),this.i,new t.$U(()=>w.document),c.selections.map(S.Selection.to),c.options,c.visibleRanges.map(I=>S.Range.to(I)),typeof c.editorPosition=="number"?S.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,m)}a.newActiveEditor!==void 0&&(E.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,P.$Mc)(l),(0,P.$Mc)(s),a.removedDocuments&&this.e.fire(l),a.addedDocuments&&this.d.fire(r),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return f.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const l=this.b.get(this.a);return a?l:l?.value}allEditors(){return[...this.b.values()]}};e.$GM=n,e.$GM=n=Ke([Ve(0,g.$wM),Ve(1,o.$aj)],n),e.$HM=(0,R.$Sh)("IExtHostDocumentsAndEditors")}),define(Ae[63],Re([1,0,248,5,16,2,4,3,17,8,7]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=e.$pec=void 0,e.$pec=(0,R.$Sh)("IExtHostEditorTabs");class S{constructor(t,i,n){this.e=n,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$bM(M.URI.revive(this.b.input.uri));case 2:return new A.$cM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new A.$dM(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new A.$eM(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$fM(this.b.input.viewType);case 4:return new A.$gM(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$hM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$iM;case 9:return new A.$jM(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$kM(this.b.input.providerId);default:return}}}class o{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const n of t.tabs)n.isActive&&(this.d=n.id),this.c.push(new S(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return g.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(n=>n.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(n=>n.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const n=new S(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,n),t.tabDto.isActive&&(this.d=n.tabId),n}else if(t.kind===1){const n=this.c.splice(t.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(t.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,n),n}const i=this.c.find(n=>n.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let v=class{constructor(t){this.b=new L.$Od,this.c=new L.$Od,this.e=[],this.a=t.getProxy($.$uK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(n=>n.apiObject))},get activeTabGroup(){const n=t.d;return(0,P.$Kf)(t.e.find(a=>a.groupId===n)?.apiObject)},close:async(n,u)=>{const a=Array.isArray(n)?n:[n];return a.length?p(a[0])?this.j(a,u):this.i(a,u):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(c=>c.groupId)),n=new Set(t.map(c=>c.groupId)),u=(0,E.$K)(i,n),a=this.e.filter(c=>u.removed.includes(c.groupId)).map(c=>c.apiObject),l=[],r=[];this.e=t.map(c=>{const h=new o(c,()=>this.d);return u.added.includes(h.groupId)?l.push(h.apiObject):r.push(h.apiObject),h});const s=(0,P.$Kf)(t.find(c=>c.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:l,closed:a,changed:r}))}$acceptTabGroupUpdate(t){const i=this.e.find(n=>n.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(u=>u.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const n=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(t){for(const i of this.e)for(const n of i.tabs)if(n.apiObject===t)return n}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const n=[];for(const u of t){const a=this.g(u);if(!a)throw new Error("Tab close: Invalid tab not found!");n.push(a.tabId)}return this.a.$closeTab(n,i)}async j(t,i){const n=[];for(const u of t){const a=this.h(u);if(!a)throw new Error("Group close: Invalid group not found!");n.push(a.groupId)}return this.a.$closeGroup(n,i)}};e.$qec=v,e.$qec=v=Ke([Ve(0,D.$wM)],v);function p(f){return f.tabs!==void 0}}),define(Ae[249],Re([1,0,3,7]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$uK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,$,D){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(R);if(!g)throw new Error("Embedding vector provider not found");const A=await g.provideEmbeddingVector($,D);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,$,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiEmbeddingVectorProvider($,g),new L.$wK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$cfc=P}),define(Ae[250],Re([1,0,2,3,6,7,8,298,13,24,23,53]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;class o{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let i,n,u=14,a=14;for(const l of f){let r=i?(0,D.$5e)(i,l):0;for(r===0?n=1:n=a;r<l.length;r++)r+1===l.length?(u=a,a=9):a+=1,t.push([n,l.toUpperCase().charCodeAt(r),a]),t.push([n,l.toLowerCase().charCodeAt(r),a]),n=a;i=l,a=u}t.push([9,58,10]),t.push([10,47,12]),this.b=new $.$BZ(t)}}provideDocumentLinks(f){this.c();const t=[],i=$.$CZ.computeLinks({getLineContent(n){return f.lineAt(n-1).text},getLineCount(){return f.lineCount}},this.b);for(const n of i){const u=R.DocumentLink.to(n);u.target&&t.push(u)}return t}}class v{constructor(f,t){this.i=t,this.b=new o,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(L.$uK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,i,n={}){if(v.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const u=this.h++;this.b.add(t),this.d.add(t),this.c.set(u,i);let a=2;n.isCaseSensitive&&(a+=1024),n.isReadonly&&(a+=2048),typeof i.copy=="function"&&(a+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,A.$uF)(f,"fsChunks"),a+=4);let l;n.isReadonly&&(0,S.$8j)(n.isReadonly)&&((0,A.$uF)(f,"readonlyMessage"),l={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(u,t,a,l).catch(s=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(s)});const r=i.onDidChangeFile(s=>{const c=[];for(const h of s){const{uri:w,type:m}=h;if(w.scheme!==t)continue;let I;switch(m){case M.FileChangeType.Changed:I=0;break;case M.FileChangeType.Created:I=1;break;case M.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:w,type:I})}this.a.$onFileSystemChange(u,c)});return(0,P.$Pc)(()=>{r.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(u),this.a.$unregisterProvider(u)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:t,ctime:i,mtime:n,size:u,permissions:a}=f;return{type:t,ctime:i,mtime:n,size:u,permissions:a}}$stat(f,t){return Promise.resolve(this.l(f).stat(E.URI.revive(t))).then(i=>v.k(i))}$readdir(f,t){return Promise.resolve(this.l(f).readDirectory(E.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.l(f).readFile(E.URI.revive(t))).then(i=>g.$ce.wrap(i))}$writeFile(f,t,i,n){return Promise.resolve(this.l(f).writeFile(E.URI.revive(t),i.buffer,n))}$delete(f,t,i){return Promise.resolve(this.l(f).delete(E.URI.revive(t),i))}$rename(f,t,i,n){return Promise.resolve(this.l(f).rename(E.URI.revive(t),E.URI.revive(i),n))}$copy(f,t,i,n){const u=this.l(f);if(!u.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(u.copy(E.URI.revive(t),E.URI.revive(i),n))}$mkdir(f,t){return Promise.resolve(this.l(f).createDirectory(E.URI.revive(t)))}$watch(f,t,i,n){const u=this.l(f).watch(E.URI.revive(i),n);this.f.set(t,u)}$unwatch(f,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(f,t,i){const n=this.l(f);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(E.URI.revive(t),i))}$close(f,t){const i=this.l(f);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(f,t,i,n){const u=this.l(f);if(!u.read)throw new Error('FileSystemProvider does not implement "read"');const a=g.$ce.alloc(n);return Promise.resolve(u.read(t,i,a.buffer,0,n)).then(l=>a.slice(0,l))}$write(f,t,i,n){const u=this.l(f);if(!u.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(u.write(t,i,n.buffer,0,n.byteLength))}l(f){const t=this.c.get(f);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$Ydc=v}),define(Ae[64],Re([1,0,3,41,7,24,4,17,42,6,12,25,14]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=e.$Edc=void 0;let p=v=class{constructor(t,i){this.b=new Map,this.c=new A.$4g,this.a=t.getProxy(E.$uK.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(u){try{let a;const l=n.b.get(u.scheme);return l?(await n.a.$ensureActivation(u.scheme),a=await l.impl.stat(u)):a=await n.a.$stat(u),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===L.FilePermission.Readonly?1:void 0}}catch(a){v.e(a)}},async readDirectory(u){try{const a=n.b.get(u.scheme);return a?(await n.a.$ensureActivation(u.scheme),(await a.impl.readDirectory(u)).slice()):await n.a.$readdir(u)}catch(a){return v.e(a)}},async createDirectory(u){try{const a=n.b.get(u.scheme);return a&&!a.isReadonly?(await n.a.$ensureActivation(u.scheme),await n.d(a.impl,a.extUri,u)):await n.a.$mkdir(u)}catch(a){return v.e(a)}},async readFile(u){try{const a=n.b.get(u.scheme);return a?(await n.a.$ensureActivation(u.scheme),(await a.impl.readFile(u)).slice()):(await n.a.$readFile(u)).buffer}catch(a){return v.e(a)}},async writeFile(u,a){try{const l=n.b.get(u.scheme);return l&&!l.isReadonly?(await n.a.$ensureActivation(u.scheme),await n.d(l.impl,l.extUri,l.extUri.dirname(u)),await n.c.queueFor(u).queue(()=>Promise.resolve(l.impl.writeFile(u,a,{create:!0,overwrite:!0})))):await n.a.$writeFile(u,M.$ce.wrap(a))}catch(l){return v.e(l)}},async delete(u,a){try{const l=n.b.get(u.scheme);return l&&!l.isReadonly?(await n.a.$ensureActivation(u.scheme),await l.impl.delete(u,{recursive:!1,...a})):await n.a.$delete(u,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(l){return v.e(l)}},async rename(u,a,l){try{return await n.a.$rename(u,a,{overwrite:!1,...l})}catch(r){return v.e(r)}},async copy(u,a,l){try{return await n.a.$copy(u,a,{overwrite:!1,...l})}catch(r){return v.e(r)}},isWritableFileSystem(u){const a=i.getCapabilities(u);if(typeof a=="number")return!(a&2048)}})}async d(t,i,n){const u=[];for(;!i.isEqual(n,i.dirname(n));)try{if(!((await t.stat(n)).type&L.FileType.Directory))throw P.$JL.FileExists(`Unable to create folder '${n.scheme===o.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(L.$rk(a)!==L.FileSystemProviderErrorCode.FileNotFound)throw a;u.push(i.basename(n)),n=i.dirname(n)}for(let a=u.length-1;a>=0;a--){n=i.joinPath(n,u[a]);try{await t.createDirectory(n)}catch(l){if(L.$rk(l)!==L.FileSystemProviderErrorCode.FileExists)throw l}}}static e(t){if(t instanceof P.$JL)throw t;if(t instanceof L.$nk)switch(t.code){case L.FileSystemProviderErrorCode.FileExists:throw P.$JL.FileExists(t.message);case L.FileSystemProviderErrorCode.FileNotFound:throw P.$JL.FileNotFound(t.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw P.$JL.FileNotADirectory(t.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw P.$JL.FileIsADirectory(t.message);case L.FileSystemProviderErrorCode.NoPermissions:throw P.$JL.NoPermissions(t.message);case L.FileSystemProviderErrorCode.Unavailable:throw P.$JL.Unavailable(t.message);default:throw new P.$JL(t.message,t.name)}if(!(t instanceof Error))throw new P.$JL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw P.$JL.Unavailable(t.message);switch(t.name){case L.FileSystemProviderErrorCode.FileExists:throw P.$JL.FileExists(t.message);case L.FileSystemProviderErrorCode.FileNotFound:throw P.$JL.FileNotFound(t.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw P.$JL.FileNotADirectory(t.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw P.$JL.FileIsADirectory(t.message);case L.FileSystemProviderErrorCode.NoPermissions:throw P.$JL.NoPermissions(t.message);case L.FileSystemProviderErrorCode.Unavailable:throw P.$JL.Unavailable(t.message);default:throw new P.$JL(t.message,t.name)}}addFileSystemProvider(t,i,n){return this.b.set(t,{impl:i,extUri:n?.isCaseSensitive?S.$mg:S.$og,isReadonly:!!n?.isReadonly}),(0,g.$Pc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??S.$mg}};e.$Edc=p,e.$Edc=p=v=Ke([Ve(0,$.$wM),Ve(1,D.$adc)],p),e.$Fdc=(0,R.$Sh)("IExtHostConsumerFileSystem")}),define(Ae[251],Re([1,0,5,33,2,3,8,7,44]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;class g{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,p,f,t,i,n){this.a=Math.random(),this.b=new E.$Od,this.c=new E.$Od,this.d=new E.$Od,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const u=(0,L.$zj)(i),a=typeof i=="string",l=n?.correlate,r=t(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(l&&typeof s.session>"u")){if(!n?.ignoreCreateEvents)for(const c of s.created){const h=P.URI.revive(c);u(h.fsPath)&&(!a||p.getWorkspaceFolder(h))&&this.b.fire(h)}if(!n?.ignoreChangeEvents)for(const c of s.changed){const h=P.URI.revive(c);u(h.fsPath)&&(!a||p.getWorkspaceFolder(h))&&this.c.fire(h)}if(!n?.ignoreDeleteEvents)for(const c of s.deleted){const h=P.URI.revive(c);u(h.fsPath)&&(!a||p.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=$.$wK.from(this.i(v,f,i,n,n?.correlate),this.b,this.c,this.d,r)}i(v,p,f,t,i){const n=$.$wK.from();if(typeof f=="string")return n;const u=v.getProxy(M.$uK.MainThreadFileSystemEventService);let a=!1;return(f.pattern.includes(L.$vj)||f.pattern.includes(L.$wj))&&(a=!0),u.$watch(p.identifier.value,this.a,f.baseUri,{recursive:a,excludes:t?.excludes??[]},!!i),$.$wK.from({dispose:()=>u.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(v){this.a=v,this.session=this.a.session,this.b=new D.$U(()=>this.a.created.map(P.URI.revive)),this.c=new D.$U(()=>this.a.changed.map(P.URI.revive)),this.d=new D.$U(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(v,p,f){this.j=v,this.k=p,this.l=f,this.a=new E.$Od,this.b=new E.$Od,this.c=new E.$Od,this.d=new E.$Od,this.g=new E.$Qd,this.h=new E.$Qd,this.i=new E.$Qd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,p,f,t){return new g(this.j,v,p,this.a.event,R.GlobPattern.from(f),t)}$onFileEvent(v){this.a.fire(new A(v))}$onDidRunFileOperation(v,p){switch(v){case 2:this.b.fire(Object.freeze({files:p.map(f=>({oldUri:P.URI.revive(f.source),newUri:P.URI.revive(f.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(f=>P.URI.revive(f.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(f=>P.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,p){return(f,t,i)=>{const n=function(a){f.call(t,a)};return n.extension=v,p.event(n,void 0,i)}}async $onWillRunFileOperation(v,p,f,t){switch(v){case 2:return await this.n(this.g,{files:p.map(i=>({oldUri:P.URI.revive(i.source),newUri:P.URI.revive(i.target)}))},f,t);case 1:return await this.n(this.i,{files:p.map(i=>P.URI.revive(i.target))},f,t);case 0:case 3:return await this.n(this.h,{files:p.map(i=>P.URI.revive(i.target))},f,t)}}async n(v,p,f,t){const i=new Set,n=[];if(await v.fireAsync(p,t,async(a,l)=>{const r=Date.now(),s=await Promise.resolve(a);s instanceof $.$GK&&(n.push([l.extension,s]),i.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-r>f&&this.k.warn("SLOW file-participant",l.extension.identifier)}),t.isCancellationRequested||n.length===0)return;const u={edits:[]};for(const[,a]of n){const{edits:l}=R.WorkspaceEdit.from(a,{getTextDocumentVersion:r=>this.l.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(l)}return{edit:u,extensionNames:Array.from(i)}}}e.$Zdc=S}),define(Ae[252],Re([1,0,6,2,3,8,7,32,12]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0;class g{static{this.a=0}constructor(v,p){this.extension=v,this.provider=p,this.handle=g.a++}}class A{constructor(v){this.session=v,this.responses=[]}}class S{static{this.a=0}constructor(v,p,f,t){this.f=f,this.g=t,this.b=new Map,this.d=new Map,this.e=v.getProxy(P.$uK.MainThreadInlineChat),p.registerApiCommand(new $.$WM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$UM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?M.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?M.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?M.Position.from(i.position):void 0}})],$.$VM.Void))}registerProvider(v,p,f){const t=new g(v,p);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,f.label,v.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,E.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(v,p,f,t){const i=this.b.get(v);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(L.URI.revive(p)),u=M.Selection.to(f),a=await i.provider.prepareInteractiveEditorSession({document:n,selection:u},t);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(u))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=S.a++;return this.d.set(l,new A(a)),{id:l,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(r=>({command:r.command,detail:r.detail,refer:r.refer,executeImmediately:r.executeImmediately})),wholeRange:M.Range.from(a.wholeRange),message:a.message}}async $provideResponse(v,p,f,t){const i=this.b.get(v);if(!i)return;const n=this.d.get(p.id);if(!n)return;const u={prompt:f.prompt,selection:M.Selection.to(f.selection),wholeRange:M.Range.to(f.wholeRange),attempt:f.attempt,live:f.live};let a=!1;const l={report:async w=>{if(!f.live&&w.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||t.isCancellationRequested||await this.e.$handleProgressChunk(f.requestId,{message:w.message,edits:w.edits?.map(M.TextEdit.from),editsShouldBeInstant:w.editsShouldBeInstant,slashCommand:w.slashCommand?.command,markdownFragment:R.$WK.isMarkdownString(w.content)?w.content.value:w.content})}},r=Promise.resolve(i.provider.provideInteractiveEditorResponse(n.session,u,l,t));let s;try{s=await(0,D.$Jg)(r,t)}finally{a=!0}if(!s)return;const c=n.responses.push(s)-1,h={wholeRange:M.Range.from(s.wholeRange),placeholder:s.placeholder};if(S.h(s)){const{edits:w,contents:m}=s,I=m!==void 0?M.MarkdownString.from(m):void 0;return w instanceof R.$GK?{...h,id:c,type:"bulkEdit",edits:M.WorkspaceEdit.from(w),message:I}:{...h,id:c,type:"editorEdit",edits:w.map(M.TextEdit.from),message:I}}return{...h,id:c,type:"message",message:M.MarkdownString.from(s.contents)}}$handleFeedback(v,p,f,t){const i=this.b.get(v),n=this.d.get(p),u=n?.responses[f];if(i&&u){const a=M.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(n.session,u,a)}}$releaseSession(v,p){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$7ec=S}),define(Ae[253],Re([1,0,2,32]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=void 0;class P{constructor(R,$,D,g,A){this.a=$,this.b=D,this.c=g;const S=new L.$WM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.$UM("showOptions","Show Options",o=>!0,o=>o),new L.$UM("resource","Interactive resource Uri",o=>!0,o=>o),new L.$UM("controllerId","Notebook controller Id",o=>!0,o=>o),new L.$UM("title","Interactive editor title",o=>!0,o=>o)],new L.$VM("Notebook and input URI",o=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",o.notebookEditorId),o.notebookEditorId!==void 0){const v=this.a.getEditorById(o.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:E.URI.revive(o.notebookUri),inputUri:E.URI.revive(o.inputUri),notebookEditor:v.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",o.notebookUri,o.inputUri),{notebookUri:E.URI.revive(o.notebookUri),inputUri:E.URI.revive(o.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(R,$,D,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:D,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$3ec=P}),define(Ae[254],Re([1,0,3,7]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;class P{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(E.$uK.MainThreadIssueReporter)}async $getIssueReporterUri(R,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const D=this.a.get(R);if(!D)throw new Error("Issue request handler not found");const g=await D.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}async $getIssueReporterData(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const D=this.b.get(R);if(!D)throw new Error("Issue data provider not found");const g=await D.provideIssueData($);if(!g)throw new Error("Issue data provider returned no result");return g}async $getIssueReporterTemplate(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const D=this.b.get(R);if(!D)throw new Error("Issue data provider not found");const g=await D.provideIssueTemplate($);if(!g)throw new Error("Issue template provider returned no result");return g}registerIssueUriRequestHandler(R,$){const D=R.identifier.value;return this.a.set(D,$),this.c.$registerIssueUriRequestHandler(D),new L.$wK(()=>{this.c.$unregisterIssueUriRequestHandler(D),this.a.delete(D)})}registerIssueDataProvider(R,$){const D=R.identifier.value;return this.b.set(D,$),this.c.$registerIssueDataProvider(D),new L.$wK(()=>{this.c.$unregisterIssueDataProvider(D),this.b.delete(D)})}}e.$9ec=P}),define(Ae[255],Re([1,0,6,3]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(L.$uK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const $=this.b++;return this.a.$registerResourceLabelFormatter($,R),(0,E.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$jec=P}),define(Ae[256],Re([1,0,2,26,8,7,80,3,13,29,18,16,299,20,22,6,95,89,75,50,11,12,23,161]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=void 0;class c{constructor(T,V){this.d=T,this.e=V}async provideDocumentSymbols(T,V){const G=this.d.getDocument(T),J=await this.e.provideDocumentSymbols(G,V);if(!(0,A.$Jb)(J))return J[0]instanceof M.$OK?J.map(P.DocumentSymbol.from):c.f(J)}static f(T){T=T.slice(0).sort((J,q)=>{let x=J.location.range.start.compareTo(q.location.range.start);return x===0&&(x=q.location.range.end.compareTo(J.location.range.end)),x});const V=[],G=[];for(const J of T){const q={name:J.name||"!!MISSING: name!!",kind:P.SymbolKind.from(J.kind),tags:J.tags?.map(P.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:P.Range.from(J.location.range),selectionRange:P.Range.from(J.location.range),children:[]};for(;;){if(G.length===0){G.push(q),V.push(q);break}const x=G[G.length-1];if(g.$ws.containsRange(x.range,q.range)&&!g.$ws.equalsRange(x.range,q.range)){x.children?.push(q),G.push(q);break}G.pop()}}return V}}class h{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(T,V,G){this.g=T,this.h=V,this.j=G,this.e=new n.$0cc("CodeLens"),this.f=new Map}async provideCodeLenses(T,V){const G=this.g.getDocument(T),J=await this.j.provideCodeLenses(G,V);if(!J||V.isCancellationRequested)return;const q=this.e.add(J),x=new f.$Qc;this.f.set(q,x);const le={cacheId:q,lenses:[]};for(let Oe=0;Oe<J.length;Oe++)le.lenses.push({cacheId:[q,Oe],range:P.Range.from(J[Oe].range),command:this.h.toInternal(J[Oe].command,x)});return le}async resolveCodeLens(T,V){const G=T.cacheId&&this.e.get(...T.cacheId);if(!G)return;let J;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?J=G:J=await this.j.resolveCodeLens(G,V),J||(J=G),V.isCancellationRequested)return;const q=T.cacheId&&this.f.get(T.cacheId[0]);if(q)return T.command=this.h.toInternal(J.command??h.d,q),T}releaseCodeLenses(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}}function w(Ce){return Array.isArray(Ce)?Ce.map(P.DefinitionLink.from):Ce?[P.DefinitionLink.from(Ce)]:[]}class m{constructor(T,V){this.d=T,this.e=V}async provideDefinition(T,V,G){const J=this.d.getDocument(T),q=P.Position.to(V),x=await this.e.provideDefinition(J,q,G);return w(x)}}class I{constructor(T,V){this.d=T,this.e=V}async provideDeclaration(T,V,G){const J=this.d.getDocument(T),q=P.Position.to(V),x=await this.e.provideDeclaration(J,q,G);return w(x)}}class k{constructor(T,V){this.d=T,this.e=V}async provideImplementation(T,V,G){const J=this.d.getDocument(T),q=P.Position.to(V),x=await this.e.provideImplementation(J,q,G);return w(x)}}class d{constructor(T,V){this.d=T,this.e=V}async provideTypeDefinition(T,V,G){const J=this.d.getDocument(T),q=P.Position.to(V),x=await this.e.provideTypeDefinition(J,q,G);return w(x)}}class b{constructor(T,V){this.d=T,this.e=V}async provideHover(T,V,G){const J=this.d.getDocument(T),q=P.Position.to(V),x=await this.e.provideHover(J,q,G);if(!(!x||(0,A.$Jb)(x.contents)))return x.range||(x.range=J.getWordRangeAtPosition(q)),x.range||(x.range=new M.$yK(q,q)),P.Hover.from(x)}}class y{constructor(T,V){this.d=T,this.e=V}async provideEvaluatableExpression(T,V,G){const J=this.d.getDocument(T),q=P.Position.to(V),x=await this.e.provideEvaluatableExpression(J,q,G);if(x)return P.EvaluatableExpression.from(x)}}class C{constructor(T,V){this.d=T,this.e=V}async provideInlineValues(T,V,G,J){const q=this.d.getDocument(T),x=await this.e.provideInlineValues(q,P.Range.to(V),P.InlineValueContext.to(G),J);if(Array.isArray(x))return x.map(le=>P.InlineValue.from(le))}}class B{constructor(T,V){this.d=T,this.e=V}async provideDocumentHighlights(T,V,G){const J=this.d.getDocument(T),q=P.Position.to(V),x=await this.e.provideDocumentHighlights(J,q,G);if(Array.isArray(x))return x.map(P.DocumentHighlight.from)}}class H{constructor(T,V){this.d=T,this.e=V}async provideLinkedEditingRanges(T,V,G){const J=this.d.getDocument(T),q=P.Position.to(V),x=await this.e.provideLinkedEditingRanges(J,q,G);if(x&&Array.isArray(x.ranges))return{ranges:(0,A.$Gb)(x.ranges.map(P.Range.from)),wordPattern:x.wordPattern}}}class U{constructor(T,V){this.d=T,this.e=V}async provideReferences(T,V,G,J){const q=this.d.getDocument(T),x=P.Position.to(V),le=await this.e.provideReferences(q,x,G,J);if(Array.isArray(le))return le.map(P.location.from)}}class z{static{this.d=1e3}constructor(T,V,G,J,q,x,le){this.g=T,this.h=V,this.j=G,this.k=J,this.l=q,this.m=x,this.n=le,this.e=new n.$0cc("CodeAction"),this.f=new Map}async provideCodeActions(T,V,G,J){const q=this.g.getDocument(T),x=o.$ys.isISelection(V)?P.Selection.to(V):P.Range.to(V),le=[];for(const Xe of this.j.getDiagnostics(T))if(x.intersection(Xe.range)&&le.push(Xe)>z.d)break;const Oe={diagnostics:le,only:G.only?new M.$QK(G.only):void 0,triggerKind:P.CodeActionTriggerKind.to(G.trigger)},je=await this.k.provideCodeActions(q,x,Oe,J);if(!(0,A.$Kb)(je)||J.isCancellationRequested)return;const Qe=this.e.add(je),Ge=new f.$Qc;this.f.set(Qe,Ge);const _e=[];for(let Xe=0;Xe<je.length;Xe++){const xe=je[Xe];xe&&(z.o(xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:xe.title,command:this.h.toInternal(xe,Ge)})):(Oe.only&&(xe.kind?Oe.only.contains(xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),_e.push({cacheId:[Qe,Xe],title:xe.title,command:xe.command&&this.h.toInternal(xe.command,Ge),diagnostics:xe.diagnostics&&xe.diagnostics.map(P.Diagnostic.from),edit:xe.edit&&P.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,isAI:(0,r.$tF)(this.m,"codeActionAI")?xe.isAI:!1,disabled:xe.disabled?.reason})))}return{cacheId:Qe,actions:_e}}async resolveCodeAction(T,V){const[G,J]=T,q=this.e.get(G,J);if(!q||z.o(q))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(q,V)??q;let le;x.edit&&(le=P.WorkspaceEdit.from(x.edit,void 0));let Oe;if(x.command){const je=this.f.get(G);je&&(Oe=this.h.toInternal(x.command,je))}return{edit:le,command:Oe}}releaseCodeActions(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}static o(T){return typeof T.command=="string"&&typeof T.title=="string"}}class F{static toInternalProviderId(T,V){return T+"."+V}constructor(T,V,G,J,q){this.d=T,this.e=V,this.f=G,this.g=J,this.h=q}async prepareDocumentPaste(T,V,G,J){if(!this.f.prepareDocumentPaste)return;const q=this.e.getDocument(T),x=V.map(je=>P.Range.to(je)),le=P.DataTransfer.toDataTransfer(G,()=>{throw new a.$0});if(await this.f.prepareDocumentPaste(q,x,le,J),J.isCancellationRequested)return;const Oe=Array.from(le).filter(([,je])=>!(je instanceof M.$kL));return P.DataTransfer.from(Oe)}async providePasteEdits(T,V,G,J,q){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(V),le=G.map(Qe=>P.Range.to(Qe)),Oe=P.DataTransfer.toDataTransfer(J,async Qe=>(await this.d.$resolvePasteFileData(this.g,T,Qe)).buffer),je=await this.f.provideDocumentPasteEdits(x,le,Oe,q);if(je)return{label:je.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:je.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:F.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?P.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class N{constructor(T,V){this.d=T,this.e=V}async provideDocumentFormattingEdits(T,V,G){const J=this.d.getDocument(T),q=await this.e.provideDocumentFormattingEdits(J,V,G);if(Array.isArray(q))return q.map(P.TextEdit.from)}}class X{constructor(T,V){this.d=T,this.e=V}async provideDocumentRangeFormattingEdits(T,V,G,J){const q=this.d.getDocument(T),x=P.Range.to(V),le=await this.e.provideDocumentRangeFormattingEdits(q,x,G,J);if(Array.isArray(le))return le.map(P.TextEdit.from)}async provideDocumentRangesFormattingEdits(T,V,G,J){(0,S.$Jf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const q=this.d.getDocument(T),x=V.map(P.Range.to),le=await this.e.provideDocumentRangesFormattingEdits(q,x,G,J);if(Array.isArray(le))return le.map(P.TextEdit.from)}}class Q{constructor(T,V){this.d=T,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,V,G,J,q){const x=this.d.getDocument(T),le=P.Position.to(V),Oe=await this.e.provideOnTypeFormattingEdits(x,le,G,J,q);if(Array.isArray(Oe))return Oe.map(P.TextEdit.from)}}class De{constructor(T,V){this.e=T,this.f=V,this.d=new n.$0cc("WorkspaceSymbols")}async provideWorkspaceSymbols(T,V){const G=await this.e.provideWorkspaceSymbols(T,V);if(!(0,A.$Kb)(G))return{symbols:[]};const J=this.d.add(G),q={cacheId:J,symbols:[]};for(let x=0;x<G.length;x++){const le=G[x];if(!le||!le.name){this.f.warn("INVALID SymbolInformation",le);continue}q.symbols.push({...P.WorkspaceSymbol.from(le),cacheId:[J,x]})}return q}async resolveWorkspaceSymbol(T,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const G=this.d.get(...T.cacheId);if(G){const J=await this.e.resolveWorkspaceSymbol(G,V);return J&&(0,L.$an)(T,P.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(T){this.d.delete(T)}}class ke{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,V,G){this.d=T,this.e=V,this.f=G}async provideRenameEdits(T,V,G,J){const q=this.d.getDocument(T),x=P.Position.to(V);try{const le=await this.e.provideRenameEdits(q,x,G,J);return le?P.WorkspaceEdit.from(le):void 0}catch(le){const Oe=ke.g(le);return Oe?{rejectReason:Oe,edits:void 0}:Promise.reject(le)}}async resolveRenameLocation(T,V,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(T),q=P.Position.to(V);try{const x=await this.e.prepareRename(J,q,G);let le,Oe;if(M.$yK.isRange(x)?(le=x,Oe=J.getText(x)):(0,S.$Bf)(x)&&(le=x.range,Oe=x.placeholder),!le||!Oe)return;if(le.start.line>q.line||le.end.line<q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(le),text:Oe}}catch(x){const le=ke.g(x);return le?{rejectReason:le,range:void 0,text:void 0}:Promise.reject(x)}}static g(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class Pe{constructor(T,V){this.resultId=T,this.tokens=V}}class fe{constructor(T,V){this.f=T,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(T,V,G){const J=this.f.getDocument(T),q=V!==0?this.d.get(V):null;let x=typeof q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,q.resultId,G):await this.g.provideDocumentSemanticTokens(J,G);return q&&this.d.delete(V),x?(x=fe.h(x),this.o(fe.n(q,x),x)):null}async releaseDocumentSemanticColoring(T){this.d.delete(T)}static h(T){return fe.j(T)?fe.k(T)?T:new M.$NL(new Uint32Array(T.data),T.resultId):fe.l(T)?fe.m(T)?T:new M.$PL(T.edits.map(V=>new M.$OL(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),T.resultId):T}static j(T){return T&&!!T.data}static k(T){return T.data instanceof Uint32Array}static l(T){return T&&Array.isArray(T.edits)}static m(T){for(const V of T.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(T,V){if(!fe.j(V)||!T||!T.tokens)return V;const G=T.tokens,J=G.length,q=V.data,x=q.length;let le=0;const Oe=Math.min(J,x);for(;le<Oe&&G[le]===q[le];)le++;if(le===J&&le===x)return new M.$PL([],V.resultId);let je=0;const Qe=Oe-le;for(;je<Qe&&G[J-je-1]===q[x-je-1];)je++;return new M.$PL([{start:le,deleteCount:J-le-je,data:q.subarray(le,x-je)}],V.resultId)}o(T,V){if(fe.j(T)){const G=this.e++;return this.d.set(G,new Pe(T.resultId,T.data)),(0,t.$x$)({id:G,type:"full",data:T.data})}if(fe.l(T)){const G=this.e++;return fe.j(V)?this.d.set(G,new Pe(V.resultId,V.data)):this.d.set(G,new Pe(T.resultId)),(0,t.$x$)({id:G,type:"delta",deltas:(T.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class we{constructor(T,V){this.d=T,this.e=V}async provideDocumentRangeSemanticTokens(T,V,G){const J=this.d.getDocument(T),q=await this.e.provideDocumentRangeSemanticTokens(J,P.Range.to(V),G);return q?this.f(q):null}f(T){return(0,t.$x$)({id:0,type:"full",data:T.data})}}class ne{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,V,G,J,q){this.f=T,this.g=V,this.h=G,this.j=J,this.k=q,this.d=new n.$0cc("CompletionItem"),this.e=new Map}async provideCompletionItems(T,V,G,J){const q=this.f.getDocument(T),x=P.Position.to(V),le=q.getWordRangeAtPosition(x)||new M.$yK(x,x),Oe=le.with({end:x}),je=new u.$Kd,Qe=await this.h.provideCompletionItems(q,x,J,P.CompletionContext.to(G));if(!Qe||J.isCancellationRequested)return;const Ge=Array.isArray(Qe)?new M.$4K(Qe):Qe,_e=ne.supportsResolving(this.h)?this.d.add(Ge.items):this.d.add([]),Xe=new f.$Qc;this.e.set(_e,Xe);const xe=[],it={x:_e,b:xe,a:{replace:P.Range.from(le),insert:P.Range.from(Oe)},c:Ge.isIncomplete||void 0,d:je.elapsed()};for(let tt=0;tt<Ge.items.length;tt++){const ze=Ge.items[tt],ut=this.l(ze,[_e,tt],Oe,le);xe.push(ut)}return it}async resolveCompletionItem(T,V){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...T);if(!G)return;const J=this.l(G,T),q=await this.h.resolveCompletionItem(G,V);if(!q)return;const x=this.l(q,T);return(J.h!==x.h||J.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==x.n||J.o!==x.o||!(0,L.$bn)(J.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,V,G,J){const q=this.e.get(V[0]);if(!q)throw Error("DisposableStore is missing...");const x=this.g.toInternal(T.command,q),le={x:V,a:T.label,b:T.kind!==void 0?P.CompletionItemKind.from(T.kind):void 0,m:T.tags&&T.tags.map(P.CompletionItemTag.from),c:T.detail,d:typeof T.documentation>"u"?void 0:P.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters?.join(""),l:T.additionalTextEdits&&T.additionalTextEdits.map(P.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};T.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),le.h=T.textEdit.newText):typeof T.insertText=="string"?le.h=T.insertText:T.insertText instanceof M.$HK&&(le.h=T.insertText.value,le.i|=4);let Oe;return T.textEdit?Oe=T.textEdit.range:T.range&&(Oe=T.range),M.$yK.isRange(Oe)?le.j=P.Range.from(Oe):Oe&&(!G?.isEqual(Oe.inserting)||!J?.isEqual(Oe.replacing))&&(le.j={insert:P.Range.from(Oe.inserting),replace:P.Range.from(Oe.replacing)}),le}}class re{async provideInlineCompletions(T,V,G,J){}disposeCompletions(T){}handleDidShowCompletionItem(T,V,G){}handlePartialAccept(T,V,G){}}class pe extends re{constructor(T,V,G,J){super(),this.f=T,this.g=V,this.h=G,this.j=J,this.d=new _,this.e=(0,r.$tF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$tF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(T,V,G,J){const q=this.g.getDocument(T),x=P.Position.to(V),le=await this.h.provideInlineCompletionItems(q,x,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:P.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},J);if(!le||J.isCancellationRequested)return;const Oe=Array.isArray(le)?le:le.items,je=this.e?Array.isArray(le)?[]:le.commands||[]:[],Qe=this.e&&!Array.isArray(le)?le.enableForwardStability:void 0;let Ge;return{pid:this.d.createReferenceId({dispose(){Ge?.dispose()},items:Oe}),items:Oe.map((Xe,xe)=>{let it;Xe.command&&(Ge||(Ge=new f.$Qc),it=this.j.toInternal(Xe.command,Ge));const tt=Xe.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Xe.filterText,range:Xe.range?P.Range.from(Xe.range):void 0,command:it,idx:xe,completeBracketPairs:this.e?Xe.completeBracketPairs:!1}}),commands:je.map(Xe=>(Ge||(Ge=new f.$Qc),this.j.toInternal(Xe,Ge))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(T){this.d.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,V,G){const J=this.d.get(T)?.items[V];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,G)}handlePartialAccept(T,V,G){const J=this.d.get(T)?.items[V];J&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(J,G)}}class _{constructor(){this.d=new Map,this.e=1}createReferenceId(T){const V=this.e++;return this.d.set(V,T),V}disposeReferenceId(T){const V=this.d.get(T);return this.d.delete(T),V}get(T){return this.d.get(T)}}class W{constructor(T,V){this.e=T,this.f=V,this.d=new n.$0cc("SignatureHelp")}async provideSignatureHelp(T,V,G,J){const q=this.e.getDocument(T),x=P.Position.to(V),le=this.g(G),Oe=await this.f.provideSignatureHelp(q,x,J,le);if(Oe){const je=this.d.add([Oe]);return{...P.SignatureHelp.from(Oe),id:je}}}g(T){let V;if(T.activeSignatureHelp){const G=P.SignatureHelp.to(T.activeSignatureHelp),J=this.d.get(T.activeSignatureHelp.id,0);J?(V=J,V.activeSignature=G.activeSignature,V.activeParameter=G.activeParameter):V=G}return{...T,activeSignatureHelp:V}}releaseSignatureHelp(T){this.d.delete(T)}}class ce{constructor(T,V,G,J,q){this.f=T,this.g=V,this.h=G,this.j=J,this.k=q,this.d=new n.$0cc("InlayHints"),this.e=new Map}async provideInlayHints(T,V,G){const J=this.f.getDocument(T),q=P.Range.to(V),x=await this.h.provideInlayHints(J,q,G);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${V}`);return}if(G.isCancellationRequested)return;const le=this.d.add(x);this.e.set(le,new f.$Qc);const Oe={hints:[],cacheId:le};for(let je=0;je<x.length;je++)this.l(x[je],q)&&Oe.hints.push(this.m(x[je],[le,je]));return this.j.trace(`[InlayHints] ${Oe.hints.length} inlay hints from '${this.k.identifier.value}' for ${V}`),Oe}async resolveInlayHint(T,V){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...T);if(!G)return;const J=await this.h.resolveInlayHint(G,V);if(J&&this.l(J))return this.m(J,T)}releaseHints(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,V){return T.label.length===0||Array.isArray(T.label)&&T.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(V&&!V.contains(T.position))}m(T,V){const G=this.e.get(V[0]);if(!G)throw Error("DisposableStore is missing...");const J={label:"",cacheId:V,tooltip:P.MarkdownString.fromStrict(T.tooltip),position:P.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(P.TextEdit.from),kind:T.kind&&P.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};return typeof T.label=="string"?J.label=T.label:J.label=T.label.map(q=>{const x={label:q.value};return x.tooltip=P.MarkdownString.fromStrict(q.tooltip),M.$IK.isLocation(q.location)&&(x.location=P.location.from(q.location)),q.command&&(x.command=this.g.toInternal(q.command,G)),x}),J}}class be{constructor(T,V){this.e=T,this.f=V,this.d=new n.$0cc("DocumentLink")}async provideLinks(T,V){const G=this.e.getDocument(T),J=await this.f.provideDocumentLinks(G,V);if(!(!Array.isArray(J)||J.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(be.g).map(P.DocumentLink.from)};{const q=this.d.add(J),x={links:[],cacheId:q};for(let le=0;le<J.length;le++){if(!be.g(J[le]))continue;const Oe=P.DocumentLink.from(J[le]);Oe.cacheId=[q,le],x.links.push(Oe)}return x}}}static g(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,V){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...T);if(!G)return;const J=await this.f.resolveDocumentLink(G,V);if(!(!J||!be.g(J)))return P.DocumentLink.from(J)}releaseLinks(T){this.d.delete(T)}}class se{constructor(T,V){this.d=T,this.e=V}async provideColors(T,V){const G=this.d.getDocument(T),J=await this.e.provideDocumentColors(G,V);return Array.isArray(J)?J.map(x=>({color:P.Color.from(x.color),range:P.Range.from(x.range)})):[]}async provideColorPresentations(T,V,G){const J=this.d.getDocument(T),q=P.Range.to(V.range),x=P.Color.to(V.color),le=await this.e.provideColorPresentations(x,{document:J,range:q},G);if(Array.isArray(le))return le.map(P.ColorPresentation.from)}}class he{constructor(T,V){this.d=T,this.e=V}async provideFoldingRanges(T,V,G){const J=this.d.getDocument(T),q=await this.e.provideFoldingRanges(J,V,G);if(Array.isArray(q))return q.map(P.FoldingRange.from)}}class ue{constructor(T,V,G){this.d=T,this.e=V,this.f=G}async provideSelectionRanges(T,V,G){const J=this.d.getDocument(T),q=V.map(P.Position.to),x=await this.e.provideSelectionRanges(J,q,G);if(!(0,A.$Kb)(x))return[];if(x.length!==q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const le=[];for(let Oe=0;Oe<q.length;Oe++){const je=[];le.push(je);let Qe=q[Oe],Ge=x[Oe];for(;;){if(!Ge.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(je.push(P.SelectionRange.from(Ge)),!Ge.parent)break;Qe=Ge.range,Ge=Ge.parent}}return le}}class ye{constructor(T,V){this.f=T,this.g=V,this.d=new i.$BM(""),this.e=new Map}async prepareSession(T,V,G){const J=this.f.getDocument(T),q=P.Position.to(V),x=await this.g.prepareCallHierarchy(J,q,G);if(!x)return;const le=this.d.nextId();return this.e.set(le,new Map),Array.isArray(x)?x.map(Oe=>this.h(le,Oe)):[this.h(le,x)]}async provideCallsTo(T,V,G){const J=this.j(T,V);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyIncomingCalls(J,G);if(q)return q.map(x=>({from:this.h(T,x.from),fromRanges:x.fromRanges.map(le=>P.Range.from(le))}))}async provideCallsFrom(T,V,G){const J=this.j(T,V);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyOutgoingCalls(J,G);if(q)return q.map(x=>({to:this.h(T,x.to),fromRanges:x.fromRanges.map(le=>P.Range.from(le))}))}releaseSession(T){this.e.delete(T)}h(T,V){const G=this.e.get(T),J=P.CallHierarchyItem.from(V,T,G.size.toString(36));return G.set(J._itemId,V),J}j(T,V){return this.e.get(T)?.get(V)}}class ee{constructor(T,V){this.f=T,this.g=V,this.d=new i.$BM(""),this.e=new Map}async prepareSession(T,V,G){const J=this.f.getDocument(T),q=P.Position.to(V),x=await this.g.prepareTypeHierarchy(J,q,G);if(!x)return;const le=this.d.nextId();return this.e.set(le,new Map),Array.isArray(x)?x.map(Oe=>this.h(le,Oe)):[this.h(le,x)]}async provideSupertypes(T,V,G){const J=this.j(T,V);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySupertypes(J,G);if(q)return q.map(x=>this.h(T,x))}async provideSubtypes(T,V,G){const J=this.j(T,V);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySubtypes(J,G);if(q)return q.map(x=>this.h(T,x))}releaseSession(T){this.e.delete(T)}h(T,V){const G=this.e.get(T),J=P.TypeHierarchyItem.from(V,T,G.size.toString(36));return G.set(J._itemId,V),J}j(T,V){return this.e.get(T)?.get(V)}}class de{static toInternalProviderId(T,V){return T+"."+V}constructor(T,V,G,J,q){this.d=T,this.e=V,this.f=G,this.g=J,this.h=q}async provideDocumentOnDropEdits(T,V,G,J,q){const x=this.e.getDocument(V),le=P.Position.to(G),Oe=P.DataTransfer.toDataTransfer(J,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,T,Qe)).buffer),je=await this.f.provideDocumentDropEdits(x,le,Oe,q);if(je)return{label:je.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:je.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:de.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?P.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class ie{constructor(T,V){this.d=T,this.e=V}async provideMappedEdits(T,V,G,J){const q=E.URI.revive(T),x=this.d.getDocument(q),le=G.documents.map(Qe=>Qe.map(Ge=>({uri:E.URI.revive(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(_e=>P.Range.to(_e))}))),Oe={documents:le,selections:le[0]?.[0]?.ranges??[]},je=await this.e.provideMappedEdits(x,V,Oe,J);return je?P.WorkspaceEdit.from(je):null}}class ae{constructor(T,V){this.adapter=T,this.extension=V}}class me{static{this.d=0}constructor(T,V,G,J,q,x,le,Oe){this.g=V,this.h=G,this.j=J,this.k=q,this.l=x,this.m=le,this.n=Oe,this.f=new Map,this.e=T.getProxy($.$uK.MainThreadLanguageFeatures)}o(T,V){return P.DocumentSelector.from(T,this.g,V)}p(T){return new M.$wK(()=>{this.f.delete(T),this.e.$unregister(T)})}q(){return me.d++}async s(T,V,G,J,q,x=!1){const le=this.f.get(T);if(!le||!(le.adapter instanceof V))return J;const Oe=Date.now();x||this.l.trace(`[${le.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const je=G(le.adapter,le.extension);return Promise.resolve(je).catch(Qe=>{(0,a.$3)(Qe)||(this.l.error(`[${le.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(le.extension.identifier,Qe))}).finally(()=>{x||this.l.trace(`[${le.extension.identifier.value}] provider DONE after ${Date.now()-Oe}ms`)}),v.CancellationToken.isCancellationToken(q)?(0,l.$Kg)(je,q):je}t(T,V){const G=this.q();return this.f.set(G,new ae(T,V)),G}static u(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,V,G,J){const q=this.t(new c(this.h,G),T),x=J&&J.label||me.u(T);return this.e.$registerDocumentSymbolProvider(q,this.o(V,T),x),this.p(q)}$provideDocumentSymbols(T,V,G){return this.s(T,c,J=>J.provideDocumentSymbols(E.URI.revive(V),G),void 0,G)}registerCodeLensProvider(T,V,G){const J=this.q(),q=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new ae(new h(this.h,this.j.converter,G),T)),this.e.$registerCodeLensSupport(J,this.o(V,T),q);let x=this.p(J);if(q!==void 0){const le=G.onDidChangeCodeLenses(Oe=>this.e.$emitCodeLensEvent(q));x=M.$wK.from(x,le)}return x}$provideCodeLenses(T,V,G){return this.s(T,h,J=>J.provideCodeLenses(E.URI.revive(V),G),void 0,G)}$resolveCodeLens(T,V,G){return this.s(T,h,J=>J.resolveCodeLens(V,G),void 0,void 0)}$releaseCodeLenses(T,V){this.s(T,h,G=>Promise.resolve(G.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(T,V,G){const J=this.t(new m(this.h,G),T);return this.e.$registerDefinitionSupport(J,this.o(V,T)),this.p(J)}$provideDefinition(T,V,G,J){return this.s(T,m,q=>q.provideDefinition(E.URI.revive(V),G,J),[],J)}registerDeclarationProvider(T,V,G){const J=this.t(new I(this.h,G),T);return this.e.$registerDeclarationSupport(J,this.o(V,T)),this.p(J)}$provideDeclaration(T,V,G,J){return this.s(T,I,q=>q.provideDeclaration(E.URI.revive(V),G,J),[],J)}registerImplementationProvider(T,V,G){const J=this.t(new k(this.h,G),T);return this.e.$registerImplementationSupport(J,this.o(V,T)),this.p(J)}$provideImplementation(T,V,G,J){return this.s(T,k,q=>q.provideImplementation(E.URI.revive(V),G,J),[],J)}registerTypeDefinitionProvider(T,V,G){const J=this.t(new d(this.h,G),T);return this.e.$registerTypeDefinitionSupport(J,this.o(V,T)),this.p(J)}$provideTypeDefinition(T,V,G,J){return this.s(T,d,q=>q.provideTypeDefinition(E.URI.revive(V),G,J),[],J)}registerHoverProvider(T,V,G,J){const q=this.t(new b(this.h,G),T);return this.e.$registerHoverProvider(q,this.o(V,T)),this.p(q)}$provideHover(T,V,G,J){return this.s(T,b,q=>q.provideHover(E.URI.revive(V),G,J),void 0,J)}registerEvaluatableExpressionProvider(T,V,G,J){const q=this.t(new y(this.h,G),T);return this.e.$registerEvaluatableExpressionProvider(q,this.o(V,T)),this.p(q)}$provideEvaluatableExpression(T,V,G,J){return this.s(T,y,q=>q.provideEvaluatableExpression(E.URI.revive(V),G,J),void 0,J)}registerInlineValuesProvider(T,V,G,J){const q=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new C(this.h,G),T);this.e.$registerInlineValuesProvider(x,this.o(V,T),q);let le=this.p(x);if(q!==void 0){const Oe=G.onDidChangeInlineValues(je=>this.e.$emitInlineValuesEvent(q));le=M.$wK.from(le,Oe)}return le}$provideInlineValues(T,V,G,J,q){return this.s(T,C,x=>x.provideInlineValues(E.URI.revive(V),G,J,q),void 0,q)}registerDocumentHighlightProvider(T,V,G){const J=this.t(new B(this.h,G),T);return this.e.$registerDocumentHighlightProvider(J,this.o(V,T)),this.p(J)}$provideDocumentHighlights(T,V,G,J){return this.s(T,B,q=>q.provideDocumentHighlights(E.URI.revive(V),G,J),void 0,J)}registerLinkedEditingRangeProvider(T,V,G){const J=this.t(new H(this.h,G),T);return this.e.$registerLinkedEditingRangeProvider(J,this.o(V,T)),this.p(J)}$provideLinkedEditingRanges(T,V,G,J){return this.s(T,H,async q=>{const x=await q.provideLinkedEditingRanges(E.URI.revive(V),G,J);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?me.w(x.wordPattern):void 0}},void 0,J)}registerReferenceProvider(T,V,G){const J=this.t(new U(this.h,G),T);return this.e.$registerReferenceSupport(J,this.o(V,T)),this.p(J)}$provideReferences(T,V,G,J,q){return this.s(T,U,x=>x.provideReferences(E.URI.revive(V),G,J,q),void 0,q)}registerCodeActionProvider(T,V,G,J){const q=new f.$Qc,x=this.t(new z(this.h,this.j.converter,this.k,G,this.l,T,this.m),T);return this.e.$registerQuickFixSupport(x,this.o(V,T),{providedKinds:J?.providedCodeActionKinds?.map(le=>le.value),documentation:J?.documentation?.map(le=>({kind:le.kind.value,command:this.j.converter.toInternal(le.command,q)}))},me.u(T),!!G.resolveCodeAction),q.add(this.p(x)),q}$provideCodeActions(T,V,G,J,q){return this.s(T,z,x=>x.provideCodeActions(E.URI.revive(V),G,J,q),void 0,q)}$resolveCodeAction(T,V,G){return this.s(T,z,J=>J.resolveCodeAction(V,G),{},void 0)}$releaseCodeActions(T,V){this.s(T,z,G=>Promise.resolve(G.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(T,V,G){const J=this.t(new N(this.h,G),T);return this.e.$registerDocumentFormattingSupport(J,this.o(V,T),T.identifier,T.displayName||T.name),this.p(J)}$provideDocumentFormattingEdits(T,V,G,J){return this.s(T,N,q=>q.provideDocumentFormattingEdits(E.URI.revive(V),G,J),void 0,J)}registerDocumentRangeFormattingEditProvider(T,V,G){const J=typeof G.provideDocumentRangesFormattingEdits=="function",q=this.t(new X(this.h,G),T);return this.e.$registerRangeFormattingSupport(q,this.o(V,T),T.identifier,T.displayName||T.name,J),this.p(q)}$provideDocumentRangeFormattingEdits(T,V,G,J,q){return this.s(T,X,x=>x.provideDocumentRangeFormattingEdits(E.URI.revive(V),G,J,q),void 0,q)}$provideDocumentRangesFormattingEdits(T,V,G,J,q){return this.s(T,X,x=>x.provideDocumentRangesFormattingEdits(E.URI.revive(V),G,J,q),void 0,q)}registerOnTypeFormattingEditProvider(T,V,G,J){const q=this.t(new Q(this.h,G),T);return this.e.$registerOnTypeFormattingSupport(q,this.o(V,T),J,T.identifier),this.p(q)}$provideOnTypeFormattingEdits(T,V,G,J,q,x){return this.s(T,Q,le=>le.provideOnTypeFormattingEdits(E.URI.revive(V),G,J,q,x),void 0,x)}registerWorkspaceSymbolProvider(T,V){const G=this.t(new De(V,this.l),T);return this.e.$registerNavigateTypeSupport(G,typeof V.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(T,V,G){return this.s(T,De,J=>J.provideWorkspaceSymbols(V,G),{symbols:[]},G)}$resolveWorkspaceSymbol(T,V,G){return this.s(T,De,J=>J.resolveWorkspaceSymbol(V,G),void 0,void 0)}$releaseWorkspaceSymbols(T,V){this.s(T,De,G=>G.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(T,V,G){const J=this.t(new ke(this.h,G,this.l),T);return this.e.$registerRenameSupport(J,this.o(V,T),ke.supportsResolving(G)),this.p(J)}$provideRenameEdits(T,V,G,J,q){return this.s(T,ke,x=>x.provideRenameEdits(E.URI.revive(V),G,J,q),void 0,q)}$resolveRenameLocation(T,V,G,J){return this.s(T,ke,q=>q.resolveRenameLocation(E.URI.revive(V),G,J),void 0,J)}registerDocumentSemanticTokensProvider(T,V,G,J){const q=this.t(new fe(this.h,G),T),x=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(q,this.o(V,T),J,x);let le=this.p(q);if(x){const Oe=G.onDidChangeSemanticTokens(je=>this.e.$emitDocumentSemanticTokensEvent(x));le=M.$wK.from(le,Oe)}return le}$provideDocumentSemanticTokens(T,V,G,J){return this.s(T,fe,q=>q.provideDocumentSemanticTokens(E.URI.revive(V),G,J),null,J)}$releaseDocumentSemanticTokens(T,V){this.s(T,fe,G=>G.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,V,G,J){const q=this.t(new we(this.h,G),T);return this.e.$registerDocumentRangeSemanticTokensProvider(q,this.o(V,T),J),this.p(q)}$provideDocumentRangeSemanticTokens(T,V,G,J){return this.s(T,we,q=>q.provideDocumentRangeSemanticTokens(E.URI.revive(V),G,J),null,J)}registerCompletionItemProvider(T,V,G,J){const q=this.t(new ne(this.h,this.j.converter,G,this.m,T),T);return this.e.$registerCompletionsProvider(q,this.o(V,T),J,ne.supportsResolving(G),T.identifier),this.p(q)}$provideCompletionItems(T,V,G,J,q){return this.s(T,ne,x=>x.provideCompletionItems(E.URI.revive(V),G,J,q),void 0,q)}$resolveCompletionItem(T,V,G){return this.s(T,ne,J=>J.resolveCompletionItem(V,G),void 0,G)}$releaseCompletionItems(T,V){this.s(T,ne,G=>G.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(T,V,G,J){const q=new pe(T,this.h,G,this.j.converter),x=this.t(q,T);return this.e.$registerInlineCompletionsSupport(x,this.o(V,T),q.supportsHandleEvents,p.$9l.toKey(T.identifier.value),J?.yieldTo?.map(le=>p.$9l.toKey(le))||[]),this.p(x)}$provideInlineCompletions(T,V,G,J,q){return this.s(T,re,x=>x.provideInlineCompletions(E.URI.revive(V),G,J,q),void 0,q)}$handleInlineCompletionDidShow(T,V,G,J){this.s(T,re,async q=>{q.handleDidShowCompletionItem(V,G,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(T,V,G,J){this.s(T,re,async q=>{q.handlePartialAccept(V,G,J)},void 0,void 0)}$freeInlineCompletionsList(T,V){this.s(T,re,async G=>{G.disposeCompletions(V)},void 0,void 0)}registerSignatureHelpProvider(T,V,G,J){const q=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,x=this.t(new W(this.h,G),T);return this.e.$registerSignatureHelpProvider(x,this.o(V,T),q),this.p(x)}$provideSignatureHelp(T,V,G,J,q){return this.s(T,W,x=>x.provideSignatureHelp(E.URI.revive(V),G,J,q),void 0,q)}$releaseSignatureHelp(T,V){this.s(T,W,G=>G.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(T,V,G){const J=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,q=this.t(new ce(this.h,this.j.converter,G,this.l,T),T);this.e.$registerInlayHintsProvider(q,this.o(V,T),typeof G.resolveInlayHint=="function",J,me.u(T));let x=this.p(q);if(J!==void 0){const le=G.onDidChangeInlayHints(Oe=>this.e.$emitInlayHintsEvent(J));x=M.$wK.from(x,le)}return x}$provideInlayHints(T,V,G,J){return this.s(T,ce,q=>q.provideInlayHints(E.URI.revive(V),G,J),void 0,J)}$resolveInlayHint(T,V,G){return this.s(T,ce,J=>J.resolveInlayHint(V,G),void 0,G)}$releaseInlayHints(T,V){this.s(T,ce,G=>G.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(T,V,G){const J=this.t(new be(this.h,G),T);return this.e.$registerDocumentLinkProvider(J,this.o(V,T),typeof G.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(T,V,G){return this.s(T,be,J=>J.provideLinks(E.URI.revive(V),G),void 0,G,V.scheme==="output")}$resolveDocumentLink(T,V,G){return this.s(T,be,J=>J.resolveLink(V,G),void 0,void 0,!0)}$releaseDocumentLinks(T,V){this.s(T,be,G=>G.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(T,V,G){const J=this.t(new se(this.h,G),T);return this.e.$registerDocumentColorProvider(J,this.o(V,T)),this.p(J)}$provideDocumentColors(T,V,G){return this.s(T,se,J=>J.provideColors(E.URI.revive(V),G),[],G)}$provideColorPresentations(T,V,G,J){return this.s(T,se,q=>q.provideColorPresentations(E.URI.revive(V),G,J),void 0,J)}registerFoldingRangeProvider(T,V,G){const J=this.q(),q=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new ae(new he(this.h,G),T)),this.e.$registerFoldingRangeProvider(J,this.o(V,T),T.identifier,q);let x=this.p(J);if(q!==void 0){const le=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(q));x=M.$wK.from(x,le)}return x}$provideFoldingRanges(T,V,G,J){return this.s(T,he,q=>q.provideFoldingRanges(E.URI.revive(V),G,J),void 0,J)}registerSelectionRangeProvider(T,V,G){const J=this.t(new ue(this.h,G,this.l),T);return this.e.$registerSelectionRangeProvider(J,this.o(V,T)),this.p(J)}$provideSelectionRanges(T,V,G,J){return this.s(T,ue,q=>q.provideSelectionRanges(E.URI.revive(V),G,J),[],J)}registerCallHierarchyProvider(T,V,G){const J=this.t(new ye(this.h,G),T);return this.e.$registerCallHierarchyProvider(J,this.o(V,T)),this.p(J)}$prepareCallHierarchy(T,V,G,J){return this.s(T,ye,q=>Promise.resolve(q.prepareSession(E.URI.revive(V),G,J)),void 0,J)}$provideCallHierarchyIncomingCalls(T,V,G,J){return this.s(T,ye,q=>q.provideCallsTo(V,G,J),void 0,J)}$provideCallHierarchyOutgoingCalls(T,V,G,J){return this.s(T,ye,q=>q.provideCallsFrom(V,G,J),void 0,J)}$releaseCallHierarchy(T,V){this.s(T,ye,G=>Promise.resolve(G.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(T,V,G){const J=this.t(new ee(this.h,G),T);return this.e.$registerTypeHierarchyProvider(J,this.o(V,T)),this.p(J)}$prepareTypeHierarchy(T,V,G,J){return this.s(T,ee,q=>Promise.resolve(q.prepareSession(E.URI.revive(V),G,J)),void 0,J)}$provideTypeHierarchySupertypes(T,V,G,J){return this.s(T,ee,q=>q.provideSupertypes(V,G,J),void 0,J)}$provideTypeHierarchySubtypes(T,V,G,J){return this.s(T,ee,q=>q.provideSubtypes(V,G,J),void 0,J)}$releaseTypeHierarchy(T,V){this.s(T,ee,G=>Promise.resolve(G.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(T,V,G,J){const q=this.q();this.f.set(q,new ae(new de(this.e,this.h,G,q,T),T));const x=(0,r.$tF)(T,"dropMetadata")&&J?de.toInternalProviderId(T.identifier.value,J.id):void 0;return this.e.$registerDocumentOnDropEditProvider(q,this.o(V,T),x,(0,r.$tF)(T,"dropMetadata")?J:void 0),this.p(q)}$provideDocumentOnDropEdits(T,V,G,J,q,x){return this.s(T,de,le=>Promise.resolve(le.provideDocumentOnDropEdits(V,E.URI.revive(G),J,q,x)),void 0,void 0)}registerMappedEditsProvider(T,V,G){const J=this.t(new ie(this.h,G),T);return this.e.$registerMappedEditsProvider(J,this.o(V,T)),this.p(J)}$provideMappedEdits(T,V,G,J,q){return this.s(T,ie,x=>Promise.resolve(x.provideMappedEdits(V,G,J,q)),null,q)}registerDocumentPasteEditProvider(T,V,G,J){const q=this.q();this.f.set(q,new ae(new F(this.e,this.h,G,q,T),T));const x=F.toInternalProviderId(T.identifier.value,J.id);return this.e.$registerPasteEditProvider(q,this.o(V,T),x,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(q)}$prepareDocumentPaste(T,V,G,J,q){return this.s(T,F,x=>x.prepareDocumentPaste(E.URI.revive(V),G,J,q),void 0,q)}$providePasteEdits(T,V,G,J,q,x){return this.s(T,F,le=>le.providePasteEdits(V,E.URI.revive(G),J,q,x),void 0,x)}static w(T){return{pattern:T.source,flags:T.flags}}static y(T){return{decreaseIndentPattern:me.w(T.decreaseIndentPattern),increaseIndentPattern:me.w(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?me.w(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?me.w(T.unIndentedLinePattern):void 0}}static z(T){return{beforeText:me.w(T.beforeText),afterText:T.afterText?me.w(T.afterText):void 0,previousLineText:T.previousLineText?me.w(T.previousLineText):void 0,action:T.action}}static B(T){return T.map(me.z)}static C(T){return{open:T.open,close:T.close,notIn:T.notIn?T.notIn.map(V=>M.SyntaxTokenType.toString(V)):void 0}}static D(T){return T.map(me.C)}setLanguageConfiguration(T,V,G){const{wordPattern:J}=G;if(J&&(0,D.$Pe)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(V,J):this.h.setWordDefinitionFor(V,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const q=this.q(),x={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?me.w(G.wordPattern):void 0,indentationRules:G.indentationRules?me.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?me.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?me.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(q,V,x),this.p(q)}$setWordDefinitions(T){for(const V of T)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$gdc=me}),define(Ae[257],Re([1,0,3,8,7,31,12,6,23]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;class g{constructor(S,o,v,p){this.c=o,this.d=v,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(E.$uK.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,o){await this.a.$changeLanguage(S,o);const v=this.c.getDocumentData(S);if(!v)throw new Error(`document '${S.toString()}' NOT found`);return v.document}async tokenAtPosition(S,o){const v=S.version,p=L.Position.from(o),f=await this.a.$tokensAtPosition(S.uri,p),t={type:P.StandardTokenType.Other,range:S.getWordRangeAtPosition(o)??new P.$yK(o.line,o.character,o.line,o.character)};if(!f)return t;const i={range:L.Range.to(f.range),type:L.TokenType.to(f.type)};return!i.range.contains(o)||v!==S.version?t:i}createLanguageStatusItem(S,o,v){const p=this.f++,f=this.a,t=this.g,i=`${S.identifier.value}/${o}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${o}' ALREADY exists`);t.add(i);const n={selector:v,id:o,name:S.displayName??S.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let u;const a=new $.$Qc,l=()=>{if(u?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${o}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}u=(0,R.$Wg)(()=>{a.clear(),this.a.$setLanguageStatus(p,{id:i,name:n.name??S.displayName??S.name,source:S.displayName??S.name,selector:L.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===P.LanguageStatusSeverity.Error?M.default.Error:n.severity===P.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:n.command&&this.d.toInternal(n.command,a),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},r={dispose(){a.dispose(),u?.dispose(),f.$removeLanguageStatus(p),t.delete(i)},get id(){return n.id},get name(){return n.name},set name(s){n.name=s,l()},get selector(){return n.selector},set selector(s){n.selector=s,l()},get text(){return n.text},set text(s){n.text=s,l()},set text2(s){(0,D.$uF)(S,"languageStatusText"),n.text=s,l()},get text2(){return(0,D.$uF)(S,"languageStatusText"),n.text},get detail(){return n.detail},set detail(s){n.detail=s,l()},get severity(){return n.severity},set severity(s){n.severity=s,l()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(s){n.accessibilityInformation=s,l()},get command(){return n.command},set command(s){n.command=s,l()},get busy(){return n.busy},set busy(s){n.busy=s,l()}};return l(),r}}e.$1dc=g}),define(Ae[82],Re([1,0,21,13,2,4,15,3,27,17]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=e.$Pdc=void 0;let A=class{constructor(o,v,p){this.f=p,this.d=new Map,this.a=v.getProxy($.$uK.MainThreadLocalization),this.b=o.environment.appLanguage,this.c=this.b===E.$g}getMessage(o,v){const{message:p,args:f,comment:t}=v;if(this.c)return(0,L.$Ee)(p,f??{});let i=p;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const n=this.d.get(o)?.contents[i];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,L.$Ee)(n??p,f??{})}getBundle(o){return this.d.get(o)?.contents}getBundleUri(o){return this.d.get(o)?.uri}async initializeLocalizedMessages(o){if(this.c||!o.l10n&&!o.isBuiltin||this.d.has(o.identifier.value))return;let v;const p=await this.g(o);if(!p){this.f.error(`No bundle location found for extension ${o.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(p),t=JSON.parse(f);v=o.isBuiltin?t.contents?.bundle:t}catch(f){this.f.error(`Failed to load translations for ${o.identifier.value} from ${p}: ${f.message}`);return}v&&this.d.set(o.identifier.value,{contents:v,uri:p})}async g(o){if(o.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(o.identifier.value,this.b);return P.URI.revive(v)}return o.l10n?P.URI.joinPath(o.extensionLocation,o.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Pdc=A,e.$Pdc=A=Ke([Ve(0,D.$MM),Ve(1,g.$wM),Ve(2,R.$aj)],A),e.$Qdc=(0,M.$Sh)("IExtHostLocalizationService")}),define(Ae[258],Re([1,0,15,3,27,17,2,52]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0;let D=class extends E.$lj{constructor(S,o){super(o.logLevel,o.logsLocation,o.loggers.map(v=>(0,$.$ph)(v))),this.r=S.getProxy(L.$uK.MainThreadLogger)}$setLogLevel(S,o){o?this.setLogLevel(R.URI.revive(o),S):this.setLogLevel(S)}setVisibility(S,o){super.setVisibility(S,o),this.r.$setVisibility(S,o)}s(S,o,v){return new g(this.r,S,o,v)}};e.$gfc=D,e.$gfc=D=Ke([Ve(0,M.$wM),Ve(1,P.$MM)],D);class g extends E.$gj{constructor(S,o,v,p){super(p?.logLevel==="always"),this.r=S,this.s=o,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(o,p).then(()=>{this.u(this.n),this.m=!0})}g(S,o){const v=[[S,o]];this.m?this.u(v):this.n.push(...v)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Ae[83],Re([1,0,3,4,6,17,24]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=e.$Rdc=void 0,e.$Rdc=(0,L.$Sh)("IExtHostManagedSockets");let $=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(E.$uK.MainThreadManagedSockets)}setFactory(S,o){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new D(S,o),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const o=++this.b,v=await this.c.makeConnection(),p=new P.$Qc;return this.d.set(o,new g(o,v,p)),p.add((0,P.$Pc)(()=>this.d.delete(o))),p.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(o),p.dispose()})),p.add(v.onDidClose(f=>{this.a.$onDidManagedSocketClose(o,f?.stack??f?.message),p.dispose()})),p.add(v.onDidReceiveMessage(f=>this.a.$onDidManagedSocketHaveData(o,R.$ce.wrap(f)))),o}$remoteSocketWrite(S,o){this.d.get(S)?.actual.send(o.buffer)}$remoteSocketEnd(S){const o=this.d.get(S);o&&(o.actual.end(),o.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$Sdc=$,e.$Sdc=$=Ke([Ve(0,M.$wM)],$);class D{constructor(S,o){this.socketFactoryId=S,this.makeConnection=o}}class g extends P.$Rc{constructor(S,o,v){super(),this.socketId=S,this.actual=o,this.B(v)}}}),define(Ae[259],Re([1,0,3,15,23]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;function M($){return $&&$.title}let R=class{constructor(D,g){this.b=g,this.a=D.getProxy(E.$uK.MainThreadMessageService)}showMessage(D,g,A,S,o){const v={source:{identifier:D.identifier,label:D.displayName||D.name}};let p;typeof S=="string"||M(S)?p=[S,...o]:(v.modal=S?.modal,v.useCustom=S?.useCustom,v.detail=S?.detail,p=o),v.useCustom&&(0,P.$uF)(D,"resolvers");const f=[];for(let t=0;t<p.length;t++){const i=p[t];if(typeof i=="string")f.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:u}=i;f.push({title:n,isCloseAffordance:!!u,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(g,A,v,f).then(t=>{if(typeof t=="number")return p[t]})}};e.$2dc=R,e.$2dc=R=Ke([Ve(1,L.$aj)],R)}),define(Ae[260],Re([1,0,18,12,20,5,6,28,2,22,15,3,32,8,7,78,212,23,49]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=e.$Xec=void 0;let u=class{constructor(m,I,k,d,b){this.l=I,this.m=k,this.n=d,this.o=b,this.b=new $.$zc,this.c=new $.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new M.$Od,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=m.getProxy(S.$uK.MainThreadNotebookKernels);const y=new o.$WM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new o.$UM("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const B=this.m.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:B}}else if(C&&"notebookEditor"in C){const B=this.m.getIdByEditor(C.notebookEditor);if(B===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:B}}return C})],o.$VM.Void);this.n.registerApiCommand(y)}createNotebookController(m,I,k,d,b,y){for(const we of this.i.values())if(we.controller.id===I&&g.$9l.equals(m.identifier,we.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const C=this.j++,B=this;this.o.trace(`NotebookController[${C}], CREATED by ${m.identifier.value}, ${I}`);const H=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${m.identifier}'`);let U=!1;const z=new M.$Od,F=new M.$Od,N={id:h(m.identifier,I),notebookType:k,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:d||m.identifier.value,preloads:y?y.map(v.NotebookRendererScript.from):[]};let X=b??H,Q;this.a.$addKernel(C,N).catch(we=>{console.log(we),U=!0});let De=0;const ke=()=>{if(U)return;const we=++De;Promise.resolve().then(()=>{we===De&&this.a.$updateKernel(C,N)})},Pe=new $.$zc,fe={get id(){return I},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return N.label},set label(we){N.label=we??m.displayName??m.name,ke()},get detail(){return N.detail??""},set detail(we){N.detail=we,ke()},get description(){return N.description??""},set description(we){N.description=we,ke()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(we){N.supportedLanguages=we,ke()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(we){N.supportsExecutionOrder=we,ke()},get rendererScripts(){return N.preloads?N.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(we){X=we??H},get interruptHandler(){return Q},set interruptHandler(we){Q=we,N.supportsInterrupt=!!we,ke()},createNotebookCellExecution(we){if(U)throw new Error("notebook controller is DISPOSED");if(!Pe.has(we.notebook.uri))throw B.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(ne=>ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.notebook.uri.toString()}`);return B._createNotebookCellExecution(we,h(m.identifier,this.id))},createNotebookExecution(we){if((0,i.$uF)(m,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!Pe.has(we.uri))throw B.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(ne=>ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${we.uri.toString()}`);return B._createNotebookExecution(we,h(m.identifier,this.id))},dispose:()=>{U||(this.o.trace(`NotebookController[${C}], DISPOSED`),U=!0,this.i.delete(C),z.dispose(),F.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(we,ne){ne===p.NotebookControllerAffinity2.Hidden&&(0,i.$uF)(m,"notebookControllerAffinityHidden"),B.a.$updateNotebookPriority(C,we.uri,ne)},onDidReceiveMessage:F.event,postMessage(we,ne){return(0,i.$uF)(m,"notebookMessaging"),B.a.$postMessage(C,ne&&B.m.getIdByEditor(ne),we)},asWebviewUri(we){return(0,i.$uF)(m,"notebookMessaging"),(0,f.$6tb)(we,B.l.remote)}};return this.i.set(C,{extensionId:m.identifier,controller:fe,onDidReceiveMessage:F,onDidChangeSelection:z,associatedNotebooks:Pe}),fe}getIdByController(m){for(const[I,k]of this.i)if(k.controller===m)return h(k.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,I){const k=this.f++,d=this;this.o.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${m.identifier.value}`),this.a.$addKernelDetectionTask(k,I);const b={dispose:()=>{this.e.delete(k),d.a.$removeKernelDetectionTask(k)}};return this.e.set(k,b),b}registerKernelSourceActionProvider(m,I,k){const d=this.h++,b=typeof k.onDidChangeNotebookKernelSourceActions=="function"?d:void 0,y=this;this.g.set(d,k),this.o.trace(`NotebookKernelSourceActionProvider[${d}], CREATED by ${m.identifier.value}`),this.a.$addKernelSourceActionProvider(d,d,I);let C;return b!==void 0&&(C=k.onDidChangeNotebookKernelSourceActions(B=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.g.delete(d),y.a.$removeKernelSourceActionProvider(d,d),C?.dispose()}}}async $provideKernelSourceActions(m,I){const k=this.g.get(m);if(k){const d=new R.$Qc;return(await k.provideNotebookKernelSourceActions(I)??[]).map(y=>v.NotebookKernelSourceAction.from(y,this.n.converter,d))}return[]}$acceptNotebookAssociation(m,I,k){const d=this.i.get(m);if(d){const b=this.m.getNotebookDocument(D.URI.revive(I));k?d.associatedNotebooks.set(b.uri,!0):d.associatedNotebooks.delete(b.uri),this.o.trace(`NotebookController[${m}] ASSOCIATE notebook`,b.uri.toString(),k),d.onDidChangeSelection.fire({selected:k,notebook:b.apiNotebook})}}async $executeCells(m,I,k){const d=this.i.get(m);if(!d)return;const b=this.m.getNotebookDocument(D.URI.revive(I)),y=[];for(const C of k){const B=b.getCell(C);B&&y.push(B.apiCell)}try{this.o.trace(`NotebookController[${m}] EXECUTE cells`,b.uri.toString(),y.length),await d.controller.executeHandler.call(d.controller,y,b.apiNotebook,d.controller)}catch(C){this.o.error(`NotebookController[${m}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(m,I,k){const d=this.i.get(m);if(!d)return;const b=this.m.getNotebookDocument(D.URI.revive(I));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,b.apiNotebook);else for(const y of k){const C=b.getCell(y);C&&this.b.get(C.uri)?.cancel()}if(d.controller.interruptHandler){const y=this.c.get(b.uri);k.length&&Array.isArray(y)&&y.length&&y.forEach(C=>C.dispose())}}$acceptKernelMessageFromRenderer(m,I,k){const d=this.i.get(m);if(!d)return;const b=this.m.getEditorById(I);d.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:k}))}$cellExecutionChanged(m,I,k){const b=this.m.getNotebookDocument(D.URI.revive(m)).getCell(I);if(b){const y=k?v.NotebookCellExecutionState.to(k):p.NotebookCellExecutionState.Idle;y!==void 0&&this.k.fire({cell:b.apiCell,state:y})}}_createNotebookCellExecution(m,I){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this.m.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!d)throw new Error("invalid cell");if(this.b.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const b=new l(I,d,this.a);this.b.set(d.uri,b);const y=b.onDidChangeState(()=>{b.state===a.Resolved&&(b.dispose(),y.dispose(),this.b.delete(d.uri))});return b.asApiObject()}_createNotebookExecution(m,I){const k=this.m.getNotebookDocument(m.uri),d=m.getCells().find(C=>{const B=k.getCellFromApiCell(C);return B&&this.b.has(B.uri)});if(d)throw new Error(`duplicate cell execution for ${d.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const b=new s(I,k,this.a),y=b.onDidChangeState(()=>{b.state===r.Resolved&&(b.dispose(),y.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[b,y]),b.asApiObject()}};e.$Xec=u,e.$Xec=u=Ke([Ve(4,A.$aj)],u);var a;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(a||(a={}));class l extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(m,I,k){super(),this.m=I,this.n=k,this.b=l.a++,this.c=new M.$Od,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new P.$Yd),this.h=new c(10,d=>this.s(d)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,m,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(m){await this.h.addItem(m)}async s(m){const I=Array.isArray(m)?m:[m];return this.n.$updateExecution(this.b,new n.$tv(I))}t(){if(this.f===a.Init)throw new Error("Must call start before modifying cell output");if(this.f===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(m){let I=this.m;if(m&&(I=this.m.notebook.getCellFromApiCell(m)),!I)throw new Error("INVALID cell");return I.handle}y(m){return m.map(I=>{const k=p.$XL.ensureUniqueMimeTypes(I.items,!0);return k===I.items?v.NotebookCellOutput.from(I):v.NotebookCellOutput.from({items:k,id:I.id,metadata:I.metadata})})}async z(m,I,k){const d=this.w(I),b=this.y((0,E.$2b)(m));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:d,append:k,outputs:b})}async C(m,I,k){return m=p.$XL.ensureUniqueMimeTypes((0,E.$2b)(m),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:m.map(v.NotebookCellOutputItem.from),outputId:I.id,append:k})}asApiObject(){const m=this;return Object.freeze({get token(){return m.g.token},get cell(){return m.m.apiCell},get executionOrder(){return m.j},set executionOrder(k){m.j=k,m.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:m.j}])},start(k){if(m.f===a.Resolved||m.f===a.Started)throw new Error("Cannot call start again");m.f=a.Started,m.c.fire(),m.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,d){if(m.f===a.Resolved)throw new Error("Cannot call resolve twice");m.f=a.Resolved,m.c.fire(),m.h.flush(),m.n.$completeExecution(m.b,new n.$tv({runEndTime:d,lastRunSuccess:k}))},clearOutput(k){return m.t(),m.z([],k,!1)},appendOutput(k,d){return m.t(),m.z(k,d,!0)},replaceOutput(k,d){return m.t(),m.z(k,d,!1)},appendOutputItems(k,d){return m.t(),m.C(k,d,!0)},replaceOutputItems(k,d){return m.t(),m.C(k,d,!1)}})}}var r;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(r||(r={}));class s extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(m,I,k){super(),this.h=I,this.j=k,this.b=s.a++,this.c=new M.$Od,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new P.$Yd),this.j.$createNotebookExecution(this.b,m,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===r.Resolved||this.f===r.Started)throw new Error("Cannot call start again");this.f=r.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===r.Resolved)throw new Error("Cannot call resolve twice");this.f=r.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor(m,I){this.e=m,this.f=I,this.a=[],this.b=Date.now()}addItem(m){return this.a.push(m),this.c||(this.c=new L.$fh,this.b=Date.now(),(0,L.$Vg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const m=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>m.complete())}}function h(w,m){return`${w.value}/${m}`}e.$Yec=h}),define(Ae[261],Re([1,0,5,3,107]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;class M{constructor($,D){this.c=D,this.a=new Map,this.b=$.getProxy(L.$uK.MainThreadNotebookRenderers)}$postRendererMessage($,D,g){const A=this.c.getEditorById($);this.a.get(D)?.fire({editor:A.apiEditor,message:g})}createRendererMessaging($,D){if(!$.contributes?.notebookRenderer?.some(A=>A.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(A,S,o)=>this.d(D).event(A,S,o),postMessage:(A,S)=>{P.$Iec.apiEditorsToExtHost.has(A)&&([A,S]=[S,A]);const o=S&&P.$Iec.apiEditorsToExtHost.get(S);return this.b.$postMessage(o?.id,D,A)}}}d($){let D=this.a.get($);return D||(D=new E.$Od({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete($)}}),this.a.set($,D),D)}}e.$Zec=M}),define(Ae[262],Re([1,0,6,16,2,23,3]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=void 0;class ${constructor(g){this.b=new Map,this.a=g.getProxy(R.$uK.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,A,S){if((0,M.$uF)(g,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,S),this.a.$registerProfileContentHandler(A,S.name,S.description,g.identifier.value),(0,E.$Pc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(g,A,S,o){const v=this.b.get(g);if(!v)throw new Error(`Unknown handler with id: ${g}`);return v.saveProfile(A,S,o)}async $readProfile(g,A,S){const o=this.b.get(g);if(!o)throw new Error(`Unknown handler with id: ${g}`);return o.readProfile((0,L.$zf)(A)?A:P.URI.revive(A),S)}}e.$4ec=$}),define(Ae[263],Re([1,0,2,3,12,8]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;class R{static{this.a=0}constructor(D,g){this.d=g,this.c=new Map,this.b=D.getProxy(L.$uK.MainThreadQuickDiff)}$provideOriginalResource(D,g,A){const S=E.URI.revive(g),o=this.c.get(D);return o?(0,P.$Ng)(()=>o.provideOriginalResource(S,A)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(D,g,A,S){const o=R.a++;return this.c.set(o,g),this.b.$registerQuickDiffProvider(o,M.DocumentSelector.from(D,this.d),A,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(o),this.c.delete(o)}}}}e.$5ec=R}),define(Ae[264],Re([1,0,20,5,6,3,2,7,11,18,31,45,23,8]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;function p(f,t,i){const n=f.getProxy(M.$uK.MainThreadQuickOpen);class u{constructor(I,k){this.e=new Map,this.f=0,this.a=I,this.b=k}showQuickPick(I,k,d,b=E.CancellationToken.None){this.c=void 0;const y=Promise.resolve(k),C=++this.f,B=n.$show(C,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},b),H={},U=B.then(()=>H);return Promise.race([U,y]).then(z=>{if(z===H)return;const F=(0,o.$tF)(I,"quickPickItemTooltip");return y.then(N=>{const X=[];for(let Q=0;Q<N.length;Q++){const De=N[Q];if(typeof De=="string")X.push({label:De,handle:Q});else if(De.kind===$.QuickPickItemKind.Separator)X.push({type:"separator",label:De.label});else{De.tooltip&&!F&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const ke=De.iconPath?c(De.iconPath):void 0;X.push({label:De.label,iconPath:ke?.iconPath,iconClass:ke?.iconClass,description:De.description,detail:De.detail,picked:De.picked,alwaysShow:De.alwaysShow,tooltip:F?v.MarkdownString.fromStrict(De.tooltip):void 0,handle:Q})}}return d&&typeof d.onDidSelectItem=="function"&&(this.c=Q=>{d.onDidSelectItem(N[Q])}),n.$setItems(C,X),B.then(Q=>{if(typeof Q=="number")return N[Q];if(Array.isArray(Q))return Q.map(De=>N[De])})})}).then(void 0,z=>{if(!(0,D.$3)(z))return n.$setError(C,z),Promise.reject(z)})}$onItemSelected(I){this.c?.(I)}showInput(I,k=E.CancellationToken.None){return this.d=I?.validateInput,n.$input(I,typeof this.d=="function",k).then(void 0,d=>{if(!(0,D.$3)(d))return Promise.reject(d)})}async $validateInput(I){if(!this.d)return;const k=await this.d(I);if(!k||typeof k=="string")return k;let d;switch(k.severity){case $.InputBoxValidationSeverity.Info:d=A.default.Info;break;case $.InputBoxValidationSeverity.Warning:d=A.default.Warning;break;case $.InputBoxValidationSeverity.Error:d=A.default.Error;break;default:d=k.message?A.default.Error:A.default.Ignore;break}return{content:k.message,severity:d}}async showWorkspaceFolderPick(I,k=E.CancellationToken.None){const d=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!d)return;const b=await this.a.getWorkspaceFolders2();if(b)return b.find(y=>y.uri.toString()===d.uri.toString())}createQuickPick(I){const k=new h(I,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(I){const k=new w(I,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(I,k){this.e.get(I)?._fireDidChangeValue(k)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,k){const d=this.e.get(I);d instanceof h&&d._fireDidChangeActive(k)}$onDidChangeSelection(I,k){const d=this.e.get(I);d instanceof h&&d._fireDidChangeSelection(k)}$onDidTriggerButton(I,k){this.e.get(I)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(I,k,d){const b=this.e.get(I);b instanceof h&&b._fireDidTriggerItemButton(k,d)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class a{static{this.a=1}constructor(I,k){this.x=I,this.y=k,this._id=h.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.$Od,this.q=new L.$Od,this.r=new L.$Od,this.s=new L.$Od,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((k,d)=>{const b=k===$.$QL.Back?-1:d;this.o.set(b,k)}),this.z({buttons:I.map((k,d)=>({...c(k.iconPath),tooltip:k.tooltip,handle:k===$.$QL.Back?-1:d}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const k=this.o.get(I);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(I){if(!this.v){for(const k of Object.keys(I)){const d=I[k];this.u[k]=d===void 0?null:d}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function l(m){if(m instanceof $.$qL)return{id:m.id};const I=s(m),k=r(m);return{dark:typeof I=="string"?R.URI.file(I):I,light:typeof k=="string"?R.URI.file(k):k}}function r(m){return typeof m=="object"&&"light"in m?m.light:m}function s(m){return typeof m=="object"&&"dark"in m?m.dark:m}function c(m){const I=l(m);let k,d;return"id"in I?d=S.ThemeIcon.asClassName(I):k=I,{iconPath:k,iconClass:d}}class h extends a{constructor(I,k){super(I.identifier,k),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.$Od,this.L=[],this.M=new L.$Od,this.N=new L.$Od,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((b,y)=>{this.C.set(y,b),this.D.set(b,y)});const k=(0,o.$tF)(this.O,"quickPickItemTooltip"),d=[];for(let b=0;b<I.length;b++){const y=I[b];if(y.kind===$.QuickPickItemKind.Separator)d.push({type:"separator",label:y.label});else{y.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?c(y.iconPath):void 0;d.push({handle:b,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:k?v.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((B,H)=>({...c(B.iconPath),tooltip:B.tooltip,handle:H}))})}}this.z({items:d})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(I){const k=(0,g.$Gb)(I.map(d=>this.C.get(d)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(I){const k=(0,g.$Gb)(I.map(d=>this.C.get(d)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(I,k){const d=this.C.get(I);if(!d||!d.buttons||!d.buttons.length)return;const b=d.buttons[k];b&&this.N.fire({button:b,item:d})}}class w extends a{constructor(I,k){super(I.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:A.default.Error}):this.z({validationMessage:I.message,severity:I.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new u(t,i)}e.$6dc=p}),define(Ae[265],Re([1,0,2,5,67,6,12,3,18,138,15,22,45,8,23,14]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=e.$7dc=void 0;function i(y){if(y)return typeof y.iconPath=="string"?E.URI.file(y.iconPath):E.URI.isUri(y.iconPath)||o.ThemeIcon.isThemeIcon(y.iconPath)?y.iconPath:void 0}function n(y){if(y?.icon){if(E.URI.isUri(y.icon))return y.icon;if(o.ThemeIcon.isThemeIcon(y.icon))return y.icon;{const C=y.icon;return{light:C.light,dark:C.dark}}}else return}function u(y){if(y.icon){if(E.URI.isUri(y.icon))return y.icon;if(o.ThemeIcon.isThemeIcon(y.icon))return y.icon;{const C=y.icon;return{light:C.light,dark:C.dark}}}else return}function a(y,C){if(!y.iconPath&&!C.iconPath)return 0;if(y.iconPath){if(!C.iconPath)return 1}else return-1;const B=typeof y.iconPath=="string"?y.iconPath:E.URI.isUri(y.iconPath)?y.iconPath.fsPath:y.iconPath.id,H=typeof C.iconPath=="string"?C.iconPath:E.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id;return(0,g.$uq)(B,H)}function l(y,C){let B=0;if(y.strikeThrough!==C.strikeThrough)return y.strikeThrough?1:-1;if(y.faded!==C.faded)return y.faded?1:-1;if(y.tooltip!==C.tooltip)return(y.tooltip||"").localeCompare(C.tooltip||"");if(B=a(y,C),B!==0)return B;if(y.light&&C.light)B=a(y.light,C.light);else{if(y.light)return 1;if(C.light)return-1}if(B!==0)return B;if(y.dark&&C.dark)B=a(y.dark,C.dark);else{if(y.dark)return 1;if(C.dark)return-1}return B}function r(y,C){if(y.command!==C.command)return y.command<C.command?-1:1;if(y.title!==C.title)return y.title<C.title?-1:1;if(y.tooltip!==C.tooltip){if(y.tooltip!==void 0&&C.tooltip!==void 0)return y.tooltip<C.tooltip?-1:1;if(y.tooltip!==void 0)return 1;if(C.tooltip!==void 0)return-1}if(y.arguments===C.arguments)return 0;if(y.arguments)if(C.arguments){if(y.arguments.length!==C.arguments.length)return y.arguments.length-C.arguments.length}else return 1;else return-1;for(let B=0;B<y.arguments.length;B++){const H=y.arguments[B],U=C.arguments[B];if(H!==U)return H<U?-1:1}return 0}function s(y,C){let B=(0,g.$uq)(y.resourceUri.fsPath,C.resourceUri.fsPath,!0);if(B!==0)return B;if(y.command&&C.command)B=r(y.command,C.command);else{if(y.command)return 1;if(C.command)return-1}if(B!==0)return B;if(y.decorations&&C.decorations)B=l(y.decorations,C.decorations);else{if(y.decorations)return 1;if(C.decorations)return-1}return B}function c(y,C){for(let B=0;B<y.length;B++)if(y[B]!==C[B])return!1;return!0}function h(y,C){return y.command===C.command&&y.title===C.title&&y.tooltip===C.tooltip&&(y.arguments&&C.arguments?c(y.arguments,C.arguments):y.arguments===C.arguments)}function w(y,C){return(0,D.$tb)(y,C,h)}function m(y,C){return y===C?!0:!y||!C?!1:y.id===C.id&&y.label===C.label&&y.upstream?.id===C.upstream?.id&&y.upstream?.label===C.upstream?.label}class I{#e;#t;get value(){return this.d}set value(C){C=C??"",this.#e.$setInputBoxValue(this.o,C),this.q(C)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(C){this.#e.$setInputBoxPlaceholder(this.o,C),this.f=C}get validateInput(){return(0,p.$uF)(this.m,"scmValidation"),this.g}set validateInput(C){if((0,p.$uF)(this.m,"scmValidation"),C&&typeof C!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=C,this.#e.$setValidationProviderIsEnabled(this.o,!!C)}get enabled(){return this.h}set enabled(C){C=!!C,this.h!==C&&(this.h=C,this.#e.$setInputBoxEnablement(this.o,C))}get visible(){return this.j}set visible(C){C=!!C,this.j!==C&&(this.j=C,this.#e.$setInputBoxVisibility(this.o,C))}get actionButton(){return(0,p.$uF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(C){(0,p.$uF)(this.m,"scmInputBoxActionButton"),this.l.value=new M.$Qc,this.k=C;const B=C!==void 0?{command:this.n.converter.toInternal(C.command,this.l.value),icon:n(C),enabled:C.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,B??null)}get document(){return(0,p.$uF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(C,B,H,U,z,F){this.m=C,this.n=B,this.o=z,this.p=F,this.d="",this.e=new L.$Od,this.f="",this.h=!0,this.j=!0,this.l=new M.$Sc,this.#t=H,this.#e=U}showValidationMessage(C,B){(0,p.$uF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,C,B)}$onInputBoxValueChange(C){this.q(C)}q(C){this.d=C,this.e.fire(C)}}e.$7dc=I;class k{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(C){this.v=C,this.q.$updateGroupLabel(this.t,this.handle,C)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(C){this.p=C,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(C){this.f=[...C],this.k.fire()}constructor(C,B,H,U,z){this.q=C,this.s=B,this.t=H,this.u=U,this.v=z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.$Od,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.$Od,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=k.d++}getResourceState(C){return this.g.get(C)}$executeResourceCommand(C,B){const H=this.h.get(C);return H?(0,R.$Ng)(()=>this.s.executeCommand(H.command,...H.arguments||[],B)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const C=[...this.f].sort(s),H=(0,D.$Cb)(this.o,C,s).map(F=>{const N=F.toInsert.map(X=>{const Q=this.e++;this.g.set(Q,X);const De=X.resourceUri;let ke;if(X.command)if(X.command.command==="vscode.open"||X.command.command==="vscode.diff"){const be=new M.$Qc;ke=this.s.converter.toInternal(X.command,be),this.j.set(Q,be)}else this.h.set(Q,X.command);const Pe=i(X.decorations),fe=X.decorations&&i(X.decorations.light)||Pe,we=X.decorations&&i(X.decorations.dark)||Pe,ne=[fe,we],re=X.decorations&&X.decorations.tooltip||"",pe=X.decorations&&!!X.decorations.strikeThrough,_=X.decorations&&!!X.decorations.faded,W=X.contextValue||"";return{rawResource:[Q,De,ne,re,pe,_,W,ke],handle:Q}});return{start:F.start,deleteCount:F.deleteCount,toInsert:N}}),U=H.map(({start:F,deleteCount:N,toInsert:X})=>[F,N,X.map(Q=>Q.rawResource)]),z=H.reverse();for(const{start:F,deleteCount:N,toInsert:X}of z){const Q=X.map(ke=>ke.handle),De=this.n.splice(F,N,...Q);for(const ke of De)this.g.delete(ke),this.h.delete(ke),this.j.get(ke)?.dispose(),this.j.delete(ke)}return this.o=C,U}dispose(){this.l=!0,this.m.fire()}}class d{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(C){this.g!==C&&(this.g=C,this.#e.$updateSourceControl(this.x,{count:C}))}get quickDiffProvider(){return this.h}set quickDiffProvider(C){this.h=C;let B;(0,p.$tF)(this.y,"quickDiffProvider")&&(B=C?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!C,quickDiffLabel:B})}get historyProvider(){return(0,p.$uF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(C){(0,p.$uF)(this.y,"scmHistoryProvider"),this.j=C,this.k.value=new M.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!C}),C&&(this.k.value.add(C.onDidChangeCurrentHistoryItemGroup(()=>{m(this.l,C?.currentHistoryItemGroup)||(this.l=C?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(C.onDidChangeActionButton(()=>{(0,p.$uF)(this.y,"scmActionButton"),this.m.value=new M.$Qc;const B=C.actionButton!==void 0?{command:this.z.converter.toInternal(C.actionButton.command,this.m.value),description:C.actionButton.description,enabled:C.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,B??null)})))}get commitTemplate(){return this.n}set commitTemplate(C){C!==this.n&&(this.n=C,this.#e.$updateSourceControl(this.x,{commitTemplate:C}))}get acceptInputCommand(){return this.p}set acceptInputCommand(C){this.o.value=new M.$Qc,this.p=C;const B=this.z.converter.toInternal(C,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:B})}get actionButton(){return(0,p.$uF)(this.y,"scmActionButton"),this.s}set actionButton(C){(0,p.$uF)(this.y,"scmActionButton"),this.q.value=new M.$Qc,this.s=C;const B=C!==void 0?{command:this.z.converter.toInternal(C.command,this.q.value),secondaryCommands:C.secondaryCommands?.map(H=>H.map(U=>this.z.converter.toInternal(U,this.q.value))),description:C.description,enabled:C.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:B??null})}get statusBarCommands(){return this.u}set statusBarCommands(C){if(this.u&&C&&w(this.u,C))return;this.t.value=new M.$Qc,this.u=C;const B=(C||[]).map(H=>this.z.converter.toInternal(H,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:B})}get selected(){return this.v}constructor(C,B,H,U,z,F,N){this.y=C,this.z=U,this.A=z,this.B=F,this.C=N,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Sc,this.m=new M.$Sc,this.n=void 0,this.o=new M.$Sc,this.p=void 0,this.q=new M.$Sc,this.t=new M.$Sc,this.u=void 0,this.v=!1,this.w=new L.$Od,this.onDidChangeSelection=this.w.event,this.x=d.d++,this.D=new Map,this.E=new Set,this.#e=H;const X=E.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${z}/scm${this.x}/input`,query:N?`rootUri=${encodeURIComponent(N.toString())}`:void 0});this.f=new I(C,U,B,this.#e,this.x,X),this.#e.$registerSourceControl(this.x,z,F,N,X)}createResourceGroup(C,B){const H=new k(this.#e,this.z,this.x,C,B),U=L.Event.once(H.onDidDispose)(()=>this.D.delete(H));return this.D.set(H,U),this.eventuallyAddResourceGroups(),H}eventuallyAddResourceGroups(){const C=[],B=[];for(const[H,U]of this.D){U.dispose();const z=H.onDidUpdateResourceStates(()=>{this.E.add(H),this.eventuallyUpdateResourceStates()});L.Event.once(H.onDidDispose)(()=>{this.E.delete(H),z.dispose(),this.e.delete(H.handle),this.#e.$unregisterGroup(this.x,H.handle)}),C.push([H.handle,H.id,H.label,H.features]);const F=H._takeResourceStateSnapshot();F.length>0&&B.push([H.handle,F]),this.e.set(H.handle,H)}this.#e.$registerGroups(this.x,C,B),this.D.clear()}eventuallyUpdateResourceStates(){const C=[];this.E.forEach(B=>{const H=B._takeResourceStateSnapshot();H.length!==0&&C.push([B.handle,H])}),C.length>0&&this.#e.$spliceResourceStates(this.x,C),this.E.clear()}getResourceGroup(C){return this.e.get(C)}setSelectionState(C){this.v=C,this.w.fire(C)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(C=>C.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,P.$lh)(100)],d.prototype,"eventuallyAddResourceGroups",null),Ke([(0,P.$lh)(100)],d.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(C,B,H,U){this.l=B,this.m=H,this.n=U,this.g=new Map,this.h=new S.$$l,this.j=new L.$Od,this.e=C.getProxy($.$uK.MainThreadSCM),this.f=C.getProxy($.$uK.MainThreadTelemetry),B.registerArgumentProcessor({processArgument:z=>{if(z&&z.$mid===3){const F=this.g.get(z.sourceControlHandle);if(!F)return z;const N=F.getResourceGroup(z.groupHandle);return N?N.getResourceState(z.handle):z}else if(z&&z.$mid===4){const F=this.g.get(z.sourceControlHandle);return F?F.getResourceGroup(z.groupHandle):z}else if(z&&z.$mid===5){const F=this.g.get(z.handle);return F||z}return z}})}createSourceControl(C,B,H,U){this.n.trace("ExtHostSCM#createSourceControl",C.identifier.value,B,H,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:C.identifier.value});const z=t.d++,F=new d(C,this.m,this.e,this.l,B,H,U);this.g.set(z,F);const N=this.h.get(C.identifier)||[];return N.push(F),this.h.set(C.identifier,N),F}getLastInputBox(C){this.n.trace("ExtHostSCM#getLastInputBox",C.identifier.value);const B=this.h.get(C.identifier),H=B&&B[B.length-1];return H&&H.inputBox}$provideOriginalResource(C,B,H){const U=E.URI.revive(B);this.n.trace("ExtHostSCM#$provideOriginalResource",C,U.toString());const z=this.g.get(C);return!z||!z.quickDiffProvider||!z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Ng)(()=>z.quickDiffProvider.provideOriginalResource(U,H)).then(F=>F||null)}$onInputBoxValueChange(C,B){this.n.trace("ExtHostSCM#$onInputBoxValueChange",C);const H=this.g.get(C);return H&&H.inputBox.$onInputBoxValueChange(B),Promise.resolve(void 0)}$executeResourceCommand(C,B,H,U){this.n.trace("ExtHostSCM#$executeResourceCommand",C,B,H);const z=this.g.get(C);if(!z)return Promise.resolve(void 0);const F=z.getResourceGroup(B);return F?F.$executeResourceCommand(H,U):Promise.resolve(void 0)}$validateInput(C,B,H){this.n.trace("ExtHostSCM#$validateInput",C);const U=this.g.get(C);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Ng)(()=>U.inputBox.validateInput(B,H)).then(z=>{if(!z)return Promise.resolve(void 0);const F=v.MarkdownString.fromStrict(z.message);return F?Promise.resolve([F,z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(C){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",C),C!==void 0&&this.g.get(C)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=C,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(C,B,H){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupBase(B,H)??void 0}async $resolveHistoryItemGroupCommonAncestor(C,B,H,U){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(B,H,U)??void 0}async $provideHistoryItems(C,B,H,U){return(await this.g.get(C)?.historyProvider?.provideHistoryItems(B,H,U))?.map(N=>({id:N.id,parentIds:N.parentIds,label:N.label,description:N.description,icon:u(N),timestamp:N.timestamp}))??void 0}async $provideHistoryItemChanges(C,B,H){return await this.g.get(C)?.historyProvider?.provideHistoryItemChanges(B,H)??void 0}};e.$8dc=b,e.$8dc=b=t=Ke([Ve(3,A.$aj)],b)}),define(Ae[84],Re([1,0,3,5,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=e.$Mdc=void 0;class M{constructor($){this.b=new L.$Od,this.onDidChangePassword=this.b.event,this.a=$.getProxy(E.$uK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,D){return this.a.$getPassword($,D)}store($,D,g){return this.a.$setPassword($,D,g)}delete($,D){return this.a.$deletePassword($,D)}}e.$Mdc=M,e.$Ndc=(0,P.$Sh)("IExtHostSecretState")}),define(Ae[266],Re([1,0,3,8,2]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=void 0;class M{static{this.a=0}constructor($,D){this.d=D,this.c=new Map,this.b=$.getProxy(E.$uK.MainThreadShare)}async $provideShare($,D,g){return await this.c.get($)?.provideShare({selection:L.Range.to(D.selection),resourceUri:P.URI.revive(D.resourceUri)},g)??void 0}registerShareProvider($,D){const g=M.a++;return this.c.set(g,D),this.b.$registerShareProvider(g,L.DocumentSelector.from($,this.d),D.id,D.label,D.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$0ec=M}),define(Ae[267],Re([1,0,20,6,3]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class M{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(P.$uK.MainThreadSpeech)}async $createSpeechToTextSession($,D){const g=this.c.get($);if(!g)return;const A=new L.$Qc,S=new E.$Yd;this.d.set(D,S);const o=A.add(g.provideSpeechToTextSession(S.token));A.add(o.onDidChange(v=>{S.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(D,v)})),A.add(S.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,D,g){const A=M.a++;return this.c.set(A,g),this.b.$registerProvider(A,D,{extension:$,displayName:$.value}),(0,L.$Pc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$_ec=M}),define(Ae[268],Re([1,0,7,3,165,6,8,16]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=e.$9dc=void 0;class D{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$rL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$rL("statusBarItem.warningForeground")]])}#e;#t;constructor(o,v,p,f,t,i=E.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new M.$Qc,this.#e=o,this.#t=v,t&&f){this.c=(0,E.$7K)(f.identifier,t);const u=p.get(this.c);u&&(i=u.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,n=u.priority,this.j=!0,this.name=u.name,this.text=u.text,this.tooltip=u.tooltip,this.command=u.command,this.accessibilityInformation=u.accessibilityInformation)}else this.c=String(D.a++);this.e=f,this.f=t,this.g=i,this.h=this.u(n)}u(o){if((0,$.$Df)(o))return o===Number.POSITIVE_INFINITY?Number.MAX_VALUE:o===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:o}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(o){this.k=o,this.v()}set name(o){this.m=o,this.v()}set tooltip(o){this.l=o,this.v()}set color(o){this.n=o,this.v()}set backgroundColor(o){o&&!D.b.has(o.id)&&(o=void 0),this.o=o,this.v()}set command(o){this.r?.fromApi!==o&&(this.p&&this.q.add(this.p),this.p=new M.$Qc,typeof o=="string"?this.r={fromApi:o,internal:this.#t.toInternal({title:"",command:o},this.p)}:o?this.r={fromApi:o,internal:this.#t.toInternal(o,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(o){this.t=o,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let o;this.e?this.f?o=`${this.e.identifier.value}.${this.f}`:o=this.e.identifier.value:o=this.f;let v;this.m?v=this.m:v=(0,P.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=D.b.get(this.o.id));const f=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,o,this.e?.identifier.value,v,this.k,f,this.r?.internal,p,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$9dc=D;class g{constructor(o){this.b=[],this.a=o.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(o){const v={message:o};return this.b.unshift(v),this.c(),new E.$wK(()=>{const p=this.b.indexOf(v);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(o,v){this.e=new Map,this.a=o.getProxy(L.$uK.MainThreadStatusBar),this.b=v,this.c=new g(this)}$acceptStaticEntries(o){for(const v of o)this.e.set(v.entryId,v)}createStatusBarEntry(o,v,p,f){return new D(this.a,this.b,this.e,o,v,p,f)}setStatusBarMessage(o,v){const p=this.c.setMessage(o);let f;return typeof v=="number"?f=setTimeout(()=>p.dispose(),v):typeof v<"u"&&v.then(()=>p.dispose(),()=>p.dispose()),new E.$wK(()=>{p.dispose(),clearTimeout(f)})}}e.$0dc=A}),define(Ae[85],Re([1,0,3,5,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=e.$Adc=void 0;class M{constructor($,D){this.c=D,this.b=new L.$Od,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(E.$uK.MainThreadStorage)}registerExtensionStorageKeysToSync($,D){this.a.$registerExtensionStorageKeysToSync($,D)}async initializeExtensionStorage($,D,g){const A=await this.a.$initializeExtensionStorage($,D);let S;return A&&(S=this.d($,D,A)),S||g}setValue($,D,g){return this.a.$setValue($,D,g)}$acceptValue($,D,g){const A=this.d($,D,g);A&&this.b.fire({shared:$,key:D,value:A})}d($,D,g){try{return JSON.parse(g)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${$}): ${A}`)}}}e.$Adc=M,e.$Bdc=(0,P.$Sh)("IExtHostStorage")}),define(Ae[86],Re([1,0,4,27,15,64,2]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=e.$Gdc=void 0,e.$Gdc=(0,E.$Sh)("IExtensionStoragePaths");let $=class{constructor(g,A,S){this.d=A,this.f=S,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(o=>this.c=o)}async g(g){return R.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,A=await this.g(g);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(g){if(this.c)return R.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return R.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Hdc=$,e.$Hdc=$=Ke([Ve(0,L.$MM),Ve(1,P.$aj),Ve(2,M.$Fdc)],$)}),define(Ae[65],Re([1,0,5,3,4,2,17,6,7,167,11,195,20,38,196,45,12,8,32]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=e.$Kdc=e.$Jdc=e.$Idc=void 0,e.$Idc=(0,P.$Sh)("IExtHostTerminalService");class u{constructor(d,b,y,C){this.l=d,this._id=b,this.m=y,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(H=>this.f=H);const B=this;this.value={get name(){return B.n||""},get processId(){return B.b},get creationOptions(){return B.m},get exitStatus(){return B.h},get state(){return B.j},get selection(){return B.k},sendText(H,U=!0){B.q(),B.l.$sendText(B._id,H,U)},show(H){B.q(),B.l.$show(B._id,H)},hide(){B.q(),B.l.$hide(B._id)},dispose(){B.a||(B.a=!0,B.l.$dispose(B._id))},get dimensions(){if(!(B.d===void 0||B.g===void 0))return{columns:B.d,rows:B.g}}}}async create(d,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:d.name,shellPath:d.shellPath??void 0,shellArgs:d.shellArgs??void 0,cwd:d.cwd??b?.cwd??void 0,env:d.env??void 0,icon:w(d.iconPath)??void 0,color:f.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:d.message??void 0,strictEnv:d.strictEnv??void 0,hideFromUser:d.hideFromUser??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.o(d.location,b?.resolvedExtHostIdentifier),isTransient:d.isTransient??void 0})}async createExtensionTerminal(d,b,y,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:y,color:f.ThemeColor.isThemeColor(C)?C.id:void 0,location:this.o(d,b),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(d,b){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in d?{viewColumn:i.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus}:void 0:d}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(d){this.n=d}setExitStatus(d,b){this.h=Object.freeze({code:d,reason:b})}setDimensions(d,b){return d===this.d&&b===this.g||d===0||b===0?!1:(this.d=d,this.g=b,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(d){this.k=d}_setProcessId(d){this.f?(this.f(d),this.f=void 0):this.b.then(b=>{b!==d&&(this.b=Promise.resolve(d))})}}e.$Jdc=u;class a{get onProcessReady(){return this.b.event}constructor(d){this.g=d,this.id=0,this.shouldPersist=!1,this.a=new E.$Od,this.onProcessData=this.a.event,this.b=new E.$Od,this.d=new E.$Od,this.onDidChangeProperty=this.d.event,this.f=new E.$Od,this.onProcessExit=this.f.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input(d){this.g.handleInput?.(d)}resize(d,b){this.g.setDimensions?.({columns:d,rows:b})}clearBuffer(){}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(d){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:"overrideDimensions",value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:"title",value:b})}),this.g.open(d||void 0),d&&this.g.setDimensions?.(d),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,r=class extends $.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(d=>d.value)}constructor(d,b,y){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Od,this.onDidCloseTerminal=this.H.event,this.I=new E.$Od,this.onDidOpenTerminal=this.I.event,this.J=new E.$Od,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Od,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Od,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Od,this.onDidChangeShell=this.N.event,this.O=new E.$Od({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Od({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(L.$uK.MainThreadTerminalService),this.y=new p.$iqb(this.a.$sendProcessData),this.a.$registerProcessSupport(d),this.Q.registerArgumentProcessor({processArgument:C=>{const B=H=>{const U=H;return this.W(U.instanceId)?.value};switch(C?.$mid){case 15:return B(C);default:{if(Array.isArray(C))for(let H=0;H<C.length&&C[H].$mid===15;H++)C[H]=B(C[H]);return C}}}}),this.B({dispose:()=>{for(const[C,B]of this.g)B.shutdown(!0)}})}getDefaultShell(d){return(d?this.u:this.s)?.path||""}getDefaultShellArgs(d){return(d?this.u:this.s)?.args||[]}createExtensionTerminal(d,b){const y=new u(this.a,(0,v.$fg)(),d,d.name),C=new a(d.pty);return y.createExtensionTerminal(d.location,this.R(d,b).resolvedExtHostIdentifier,w(d.iconPath),m(d.color)).then(B=>{const H=this.S(B,C);this.h[B]=H}),this.f.push(y),y.value}R(d,b){if(b=b||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const y=d.location.parentTerminal;if(y){const C=this.f.find(B=>B.value===y);C&&(b.resolvedExtHostIdentifier=C._id)}}else d.location&&typeof d.location!="object"?b.location=d.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(d,b){if(!this.W(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const C=new a(b),B=this.S(d,C);this.h[d]=B}async $acceptActiveTerminalChanged(d){const b=this.b;if(d===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const y=this.W(d);y&&(this.b=y,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(d,b){const y=this.W(d);y&&this.O.fire({terminal:y.value,data:b})}async $acceptTerminalDimensions(d,b,y){const C=this.W(d);C&&C.setDimensions(b,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(d,b){const y=this.W(d);y&&this.P.fire({terminal:y.value,...b})}async $acceptTerminalMaximumDimensions(d,b,y){this.g.get(d)?.resize(b,y)}async $acceptTerminalTitleChange(d,b){const y=this.W(d);y&&(y.name=b)}async $acceptTerminalClosed(d,b,y){const C=this.Y(this.f,d);if(C!==null){const B=this.f.splice(C,1)[0];B.setExitStatus(b,y),this.H.fire(B.value)}}$acceptTerminalOpened(d,b,y,C){if(b){const U=this.Y(this.f,b);if(U!==null){this.f[U]._id=d,this.I.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const B={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:M.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},H=new u(this.a,d,B,y);this.f.push(H),this.I.fire(H.value),H.isOpen=!0}async $acceptTerminalProcessId(d,b){this.W(d)?._setProcessId(b)}async $startExtensionTerminal(d,b){const y=this.W(d);if(!y)return{message:(0,g.localize)(0,null,d)};y.isOpen||await new Promise(B=>{const H=this.onDidOpenTerminal(async U=>{U===y.value&&(H.dispose(),B())})});const C=this.g.get(d);C?C.startSendingEvents(b):this.j[d]={initialDimensions:b}}S(d,b){const y=new $.$Qc;y.add(b.onProcessReady(B=>this.a.$sendProcessReady(d,B.pid,B.cwd,B.windowsPty))),y.add(b.onDidChangeProperty(B=>this.a.$sendProcessProperty(d,B))),this.y.startBuffering(d,b.onProcessData),y.add(b.onProcessExit(B=>this.U(d,B))),this.g.set(d,b);const C=this.j[d];return C&&b instanceof a&&(b.startSendingEvents(C.initialDimensions),delete this.j[d]),y}$acceptProcessAckDataEvent(d,b){this.g.get(d)?.acknowledgeDataEvent(b)}$acceptProcessInput(d,b){this.g.get(d)?.input(b)}$acceptTerminalInteraction(d){const b=this.W(d);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection(d,b){this.W(d)?.setSelection(b)}$acceptProcessResize(d,b,y){try{this.g.get(d)?.resize(b,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(d,b){this.g.get(d)?.shutdown(b)}$acceptProcessRequestInitialCwd(d){this.g.get(d)?.getInitialCwd().then(b=>this.a.$sendProcessProperty(d,{type:"initialCwd",value:b}))}$acceptProcessRequestCwd(d){this.g.get(d)?.getCwd().then(b=>this.a.$sendProcessProperty(d,{type:"cwd",value:b}))}$acceptProcessRequestLatency(d){return Promise.resolve(d)}registerLinkProvider(d){return this.z.add(d),this.z.size===1&&this.a.$startLinkProvider(),new D.$wK(()=>{this.z.delete(d),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(d,b,y){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,y),this.a.$registerProfileProvider(b,d.identifier.value),new D.$wK(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(d,b,y){if(this.D.has(d))throw new Error(`Terminal quick fix provider "${d}" is already registered`);return this.D.set(d,y),this.a.$registerQuickFixProvider(d,b),new D.$wK(()=>{this.D.delete(d),this.a.$unregisterQuickFixProvider(d)})}async $provideTerminalQuickFixes(d,b){const y=new o.$Yd().token;if(y.isCancellationRequested)return;const C=this.D.get(d);if(!C)return;const B=await C.provideTerminalQuickFixes(b,y);if(B===null||Array.isArray(B)&&B.length===0)return;const H=new $.$Qc;if(this.w.value=H,!Array.isArray(B))return B?i.TerminalQuickFix.from(B,this.Q.converter,H):void 0;const U=[];for(const z of B){const F=i.TerminalQuickFix.from(z,this.Q.converter,H);F&&U.push(F)}return U}async $createContributedProfileTerminal(d,b){const y=new o.$Yd().token;let C=await this.C.get(d)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,b);return}this.createTerminalFromOptions(C.options,b)}}async $provideLinks(d,b){const y=this.W(d);if(!y)return[];this.F.delete(d),this.G.get(d)?.dispose(!0);const B=new o.$Yd;this.G.set(d,B);const H=[],U={terminal:y.value,line:b},z=[];for(const X of this.z)z.push(t.Promises.withAsyncBody(async Q=>{B.token.onCancellationRequested(()=>Q({provider:X,links:[]}));const De=await X.provideTerminalLinks(U,B.token)||[];B.token.isCancellationRequested||Q({provider:X,links:De})}));const F=await Promise.all(z);if(B.token.isCancellationRequested)return[];const N=new Map;for(const X of F)X&&X.links.length>0&&H.push(...X.links.map(Q=>{const De={id:l++,startIndex:Q.startIndex,length:Q.length,label:Q.tooltip};return N.set(De.id,{provider:X.provider,link:Q}),De}));return this.F.set(d,N),H}$activateLink(d,b){const y=this.F.get(d)?.get(b);y&&y.provider.handleTerminalLink(y.link)}U(d,b){this.y.stopBuffering(d),this.g.delete(d),delete this.j[d];const y=this.h[d];y&&(y.dispose(),delete this.h[d]),this.a.$sendProcessExit(d,b)}W(d){return this.X(this.f,d)}X(d,b){const y=this.Y(d,b);return y!==null?d[y]:null}Y(d,b){const y=d.findIndex(C=>C._id===b);return y===-1?null:y}getEnvironmentVariableCollection(d){let b=this.n.get(d.identifier.value);return b||(b=new s,this.$(d.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Z(d,b){const y=(0,S.$nr)(b.map),C=(0,S.$or)(b.descriptionMap);this.a.$setEnvironmentVariableCollection(d,b.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections(d){d.forEach(b=>{const y=b[0],C=new s(b[1]);this.$(y,C)})}$acceptDefaultProfile(d,b){const y=this.s;this.s=d,this.u=b,y?.path!==d.path&&this.N.fire(d.path)}$(d,b){this.n.set(d,b),b.onDidChangeCollection(()=>{this.Z(d,b)})}};e.$Kdc=r,e.$Kdc=r=Ke([Ve(1,n.$SM),Ve(2,R.$wM)],r);class s{get persistent(){return this.b}set persistent(d){this.b=d,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(d){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Od,this.map=new Map(d)}getScopedEnvironmentVariableCollection(d){const b=this.h(d);let y=this.a.get(b);return y||(y=new c(this,d),this.a.set(b,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(d,b,y,C){this.f(d,{value:b,type:D.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append(d,b,y,C){this.f(d,{value:b,type:D.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend(d,b,y,C){this.f(d,{value:b,type:D.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f(d,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(d,b.scope),C=this.map.get(y),B=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==b.value||C.type!==b.type||C.options?.applyAtProcessCreation!==B.applyAtProcessCreation||C.options?.applyAtShellIntegration!==B.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const H=this.g(d,b.scope),U={variable:d,...b,options:B};this.map.set(H,U),this.d.fire()}}get(d,b){const y=this.g(d,b),C=this.map.get(y);return C?I(C):void 0}g(d,b){const y=this.h(b);return y.length?`${d}:::${y}`:d}h(d){return this.j(d?.workspaceFolder)??""}j(d){return d?d.uri.toString():void 0}getVariableMap(d){const b=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h(d)&&b.set(C.variable,I(C));return b}delete(d,b){const y=this.g(d,b);this.map.delete(y),this.d.fire()}clear(d){if(d?.workspaceFolder){for(const[b,y]of this.map)y.scope?.workspaceFolder?.index===d.workspaceFolder.index&&this.map.delete(b);this.k(d)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(d,b){const y=this.h(b),C=this.descriptionMap.get(y);if(!C||C.description!==d){let B;typeof d=="string"?B=d:B=d?.value.split(`

`)[0];const H={description:B,scope:b};this.descriptionMap.set(y,H),this.d.fire()}}getDescription(d){const b=this.h(d);return this.descriptionMap.get(b)?.description}k(d){const b=this.h(d);this.descriptionMap.delete(b)}}class c{get persistent(){return this.b.persistent}set persistent(d){this.b.persistent=d}get onDidChangeCollection(){return this.a&&this.a.event}constructor(d,b){this.b=d,this.d=b,this.a=new E.$Od}getScoped(d){return this.b.getScopedEnvironmentVariableCollection(d)}replace(d,b,y){this.b.replace(d,b,y,this.d)}append(d,b,y){this.b.append(d,b,y,this.d)}prepend(d,b,y){this.b.prepend(d,b,y,this.d)}get(d){return this.b.get(d,this.d)}forEach(d,b){this.b.getVariableMap(this.d).forEach((y,C)=>d.call(b,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(d){this.b.delete(d,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(d){this.b.setDescription(d,this.d)}get description(){return this.b.getDescription(this.d)}}let h=class extends r{constructor(d,b){super(!1,d,b)}createTerminal(d,b,y){throw new A.$$}createTerminalFromOptions(d,b){throw new A.$$}};e.$Ldc=h,e.$Ldc=h=Ke([Ve(0,n.$SM),Ve(1,R.$wM)],h);function w(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function m(k){return f.ThemeColor.isThemeColor(k)?k:void 0}function I(k){const d={...k};return delete d.scope,d.options=d.options??void 0,delete d.variable,d}}),define(Ae[269],Re([1,0,300,12,24,20,5,220,97,6,26,16,38,3,17,108,8,7,48,77,60,23]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=e.$Uec=e.$Tec=e.$Sec=void 0;let r=class extends g.$Rc{constructor(U,z,F){super(),this.u=F,this.f=this.B(new R.$Od),this.g=new Map,this.s=this.B(new R.$Od),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(v.$uK.MainThreadTesting),this.m=new y(this.h),this.j=new w(this.h),z.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const X=N,Q=X.tests[X.tests.length-1].item.extId;return this.g.get(n.$kJ.root(Q))?.collection.tree.get(Q)?.actual??(0,f.$IM)(N)}case 18:{const{extId:X,message:Q}=N;return{test:this.g.get(n.$kJ.root(X))?.collection.tree.get(X)?.actual,message:t.TestMessage.to(Q)}}default:return N}}}),z.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await z.executeCommand("_testing.getExplorerSelection"),X=Q=>{const De=this.g.get(n.$kJ.root(Q));if(De)return n.$kJ.isRoot(Q)?De.controller:De.collection.tree.get(Q)?.actual};return{include:N?.include.map(X).filter(S.$Hf)||[],exclude:N?.exclude.map(X).filter(S.$Hf)||[]}})}createTestController(U,z,F,N){if(this.g.has(z))throw new Error(`Attempt to insert a duplicate controller with ID "${z}"`);const X=new g.$Qc,Q=X.add(new f.$LM(z,F,this.u));Q.root.label=F;const De=new Map,ke=new Set,Pe=this.h,fe={items:Q.root.children,get label(){return F},set label(ne){F=ne,Q.root.label=ne,Pe.$updateController(z,{label:F})},get refreshHandler(){return N},set refreshHandler(ne){N=ne,Pe.$updateController(z,{canRefresh:!!ne})},get id(){return z},createRunProfile:(ne,re,pe,_,W,ce)=>{let be=(0,D.$Gi)(ne);for(;De.has(be);)be++;return new C(this.h,De,U,ke,this.s.event,z,be,ne,re,pe,_,W,ce)},createTestItem(ne,re,pe){return new f.$JM(z,ne,re,pe)},createTestRun:(ne,re,pe=!0)=>this.j.createTestRun(U,z,Q,ne,re,pe),invalidateTestResults:ne=>{if(ne===void 0)this.h.$markTestRetired(void 0);else{const re=ne instanceof Array?ne:[ne];this.h.$markTestRetired(re.map(pe=>n.$kJ.fromExtHostTestItem(pe,z).toString()))}},set resolveHandler(ne){Q.resolveHandler=ne},get resolveHandler(){return Q.resolveHandler},dispose:()=>{X.dispose()}};Pe.$registerTestController(z,F,!!N),X.add((0,g.$Pc)(()=>Pe.$unregisterTestController(z)));const we={controller:fe,collection:Q,profiles:De,extension:U,activeProfiles:ke};return this.g.set(z,we),X.add((0,g.$Pc)(()=>this.g.delete(z))),X.add(Q.onDidGenerateDiff(ne=>Pe.$publishDiff(z,ne.map(a.TestsDiffOp.serialize)))),fe}createTestObserver(){return this.m.checkout()}async runTests(U,z=M.CancellationToken.None){const F=m(U);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.g.get(F.controllerId);if(!N)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(X=>n.$kJ.fromExtHostTestItem(X,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:B[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:U.exclude?.map(X=>X.id)},z)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,z,F){return(0,E.$qb)(this.j.trackers,X=>X.id===U?X.getCoverage(z):void 0)?.provideFileCoverage(F)??Promise.resolve([])}$resolveFileCoverage(U,z,F,N){return(0,E.$qb)(this.j.trackers,Q=>Q.id===U?Q.getCoverage(z):void 0)?.resolveFileCoverage(F,N)??Promise.resolve([])}$configureRunProfile(U,z){this.g.get(U)?.profiles.get(z)?.configureHandler?.()}$setActiveRunProfiles(U){const z=new Map;for(const[F,N]of Object.entries(U)){const X=this.g.get(F);if(!X)continue;const Q=new Map,De=N.filter(Pe=>!X.activeProfiles.has(Pe)),ke=[...X.activeProfiles].filter(Pe=>!N.includes(Pe));for(const Pe of De)Q.set(Pe,!0),X.activeProfiles.add(Pe);for(const Pe of ke)Q.set(Pe,!1),X.activeProfiles.delete(Pe);Q.size&&z.set(F,Q)}this.s.fire(z)}async $refreshTests(U,z){await this.g.get(U)?.controller.refreshHandler?.(z)}$publishTestResults(U){this.results=Object.freeze(U.map(z=>(0,A.$$m)(t.TestResults.to(z))).concat(this.results).sort((z,F)=>F.completedAt-z.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,z){const F=this.g.get(n.$kJ.fromString(U).controllerId)?.collection;F&&(await F.expand(U,z<0?1/0:z),F.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(a.TestsDiffOp.deserialize))}async $runControllerTests(U,z){return Promise.all(U.map(F=>this.w(F,!1,z)))}async $startContinuousRun(U,z){const F=new M.$Yd(z),N=await Promise.all(U.map(X=>this.w(X,!0,F.token)));return!z.isCancellationRequested&&!N.some(X=>X.error)&&await new Promise(X=>z.onCancellationRequested(X)),F.dispose(!0),N}async w(U,z,F){const N=this.g.get(U.controllerId);if(!N)return{};const{collection:X,profiles:Q,extension:De}=N,ke=Q.get(U.profileId);if(!ke)return{};const Pe=U.testIds.map(re=>X.tree.get(re)).filter(S.$Hf),fe=U.excludeExtIds.map(re=>N.collection.tree.get(re)).filter(S.$Hf).filter(re=>Pe.some(pe=>pe.fullId.compare(re.fullId)===2));if(!Pe.length)return{};const we=new i.$5L(Pe.some(re=>re.actual instanceof f.$KM)?void 0:Pe.map(re=>re.actual),fe.map(re=>re.actual),ke,z),ne=(0,a.$mJ)(U)&&this.j.prepareForMainThreadTestRun(we,I.fromInternal(U,N.collection),De,F);try{return await ke.runHandler(we,F),{}}catch(re){return{error:String(re)}}finally{ne&&(ne.hasRunningTasks&&!F.isCancellationRequested&&await R.Event.toPromise(ne.onEnd),ne.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$Sec=r,e.$Sec=r=Ke([Ve(0,p.$wM)],r);const s=1e4;var c;(function(H){H[H.Running=0]="Running",H[H.Cancelling=1]="Cancelling",H[H.Ended=2]="Ended"})(c||(c={}));class h extends g.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(U,z,F){super(),this.m=U,this.s=z,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$Od),this.onEnd=this.j.event,this.h=this.B(new M.$Yd(F));const N=this.B(new L.$7g(()=>this.u(),s));this.B(this.h.token.onCancellationRequested(()=>N.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const z=this.m.id,F=this.m.controllerId,N=(0,o.$fg)(),X=new k(this.s,z,N),Q=fe=>(we,...ne)=>{if(ke){console.warn(`Setting the state of test "${we.id}" is a no-op after the run ends.`);return}this.m.isIncluded(we)&&(this.y(we),fe(we,...ne))},De=(fe,we)=>{const ne=we instanceof Array?we.map(t.TestMessage.from):[t.TestMessage.from(we)];if(fe.uri&&fe.range){const re={range:t.Range.from(fe.range),uri:fe.uri};for(const pe of ne)pe.location=pe.location||re}this.s.$appendTestMessagesInRun(z,N,n.$kJ.fromExtHostTestItem(fe,F).toString(),ne)};let ke=!1;const Pe={isPersisted:this.m.isPersisted,token:this.h.token,name:U,get coverageProvider(){return X.coverageProvider},set coverageProvider(fe){X.coverageProvider=fe},enqueued:Q(fe=>{this.s.$updateTestStateInRun(z,N,n.$kJ.fromExtHostTestItem(fe,F).toString(),1)}),skipped:Q(fe=>{this.s.$updateTestStateInRun(z,N,n.$kJ.fromExtHostTestItem(fe,F).toString(),5)}),started:Q(fe=>{this.s.$updateTestStateInRun(z,N,n.$kJ.fromExtHostTestItem(fe,F).toString(),2)}),errored:Q((fe,we,ne)=>{De(fe,we),this.s.$updateTestStateInRun(z,N,n.$kJ.fromExtHostTestItem(fe,F).toString(),6,ne)}),failed:Q((fe,we,ne)=>{De(fe,we),this.s.$updateTestStateInRun(z,N,n.$kJ.fromExtHostTestItem(fe,F).toString(),4,ne)}),passed:Q((fe,we)=>{this.s.$updateTestStateInRun(z,N,n.$kJ.fromExtHostTestItem(fe,this.m.controllerId).toString(),3,we)}),appendOutput:(fe,we,ne)=>{ke||(ne&&(this.m.isIncluded(ne)?this.y(ne):ne=void 0),this.s.$appendOutputToRun(z,N,P.$ce.fromString(fe),we&&t.location.from(we),ne&&n.$kJ.fromExtHostTestItem(ne,F).toString()))},end:()=>{ke||(ke=!0,this.s.$finishedTestRunTask(z,N),this.f.delete(N),this.f.size||this.w())}};return this.f.set(N,{run:Pe,coverage:X}),this.s.$startedTestRunTask(z,{id:N,name:U,running:!0}),Pe}u(){for(const{run:U}of this.f.values())U.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(U){if(!(U instanceof f.$JM))throw new u.$oM(U.id);if(this.g.has(n.$kJ.fromExtHostTestItem(U,this.m.controllerId).toString()))return;const z=[],F=this.m.colllection.root;for(;;){const N=t.TestItem.from(U);if(z.unshift(N),this.g.has(N.extId)||(this.g.add(N.extId),U===F))break;U=U.parent||F}this.s.$addTestsToRun(this.m.controllerId,this.m.id,z)}dispose(){this.w(),super.dispose()}}class w{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,z,F,N){return this.f(U,z,F,N)}cancelRunById(U){for(const z of this.c.values())if(z.id===U){z.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,z,F,N,X,Q){const De=this.c.get(N);if(De)return De.createRun(X);const ke=I.fromPublic(z,F,N,Q),Pe=m(N);this.d.$startedExtensionTestRun({controllerId:z,continuous:!!N.continuous,profile:Pe&&{group:B[Pe.kind],id:Pe.profileId},exclude:N.exclude?.map(we=>n.$kJ.fromExtHostTestItem(we,F.root.id).toString())??[],id:ke.id,include:N.include?.map(we=>n.$kJ.fromExtHostTestItem(we,F.root.id).toString())??[F.root.id],persist:Q});const fe=this.f(N,ke,U);return R.Event.once(fe.onEnd)(()=>{this.d.$finishedExtensionTestRun(ke.id),fe.dispose()}),fe.createRun(X)}f(U,z,F,N){const X=new h(z,this.d,N);return this.c.set(U,X),R.Event.once(X.onEnd)(()=>this.c.delete(U)),X}}e.$Tec=w;const m=H=>{if(H.profile){if(!(H.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return H.profile}};class I{static fromPublic(U,z,F,N){return new I(U,(0,o.$fg)(),F.include?.map(X=>n.$kJ.fromExtHostTestItem(X,U).toString())??[U],F.exclude?.map(X=>n.$kJ.fromExtHostTestItem(X,U).toString())??[],N,z)}static fromInternal(U,z){return new I(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,z)}constructor(U,z,F,N,X,Q){this.controllerId=U,this.id=z,this.isPersisted=X,this.colllection=Q,this.c=F.map(De=>De+"\0"),this.d=N.map(De=>De+"\0")}isIncluded(U){const z=n.$kJ.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const F of this.d)if(z===F||z.startsWith(F))return!1;for(const F of this.c)if(z===F||z.startsWith(F))return!0;return!1}}e.$Uec=I;class k{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,z,F){this.f=U,this.g=z,this.h=F}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(z){throw this.d=void 0,z}}async resolveFileCoverage(U,z){const F=await this.d;let N=F?.[U];return!this.c||!F||!N?[]:(N.detailedCoverage||(N=F[U]=await this.c.resolveFileCoverage?.(N,z)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class d{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const z=n.$kJ.parentId(U.item.extId);if(z&&this.g.has(z.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:z,f:F}=this;return{get added(){return[...U].map(N=>N.revived)},get updated(){return[...z].map(N=>N.revived)},get removed(){return[...F].map(N=>N.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class b extends a.$rJ{constructor(){super(...arguments),this.q=new R.$Od,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,z){return{...U,revived:t.TestItem.toPlain(U.item),depth:z?z.depth+1:0,children:new Set}}o(){return new d(this.q)}}class y{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(z=>z.revived)},dispose:(0,$.$cb)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new b;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class C{#e;#t;#i;#o;#r;get label(){return this.d}set label(U){U!==this.d&&(this.d=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}get isSelected(){return(0,l.$uF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,l.$uF)(this.#t,"testingActiveProfile"),R.Event.chain(this.#o,U=>U.map(z=>z.get(this.controllerId)?.get(this.profileId)).filter(S.$Hf))}constructor(U,z,F,N,X,Q,De,ke,Pe,fe,we=!1,ne=void 0,re=!1){this.controllerId=Q,this.profileId=De,this.d=ke,this.kind=Pe,this.runHandler=fe,this.f=we,this._tag=ne,this.g=re,this.#e=U,this.#r=z,this.#t=F,this.#i=N,this.#o=X,z.set(De,this);const pe=B[Pe];if(typeof pe!="number")throw new Error(`Unknown TestRunProfile.group ${Pe}`);this.#e.$publishTestRunProfile({profileId:De,controllerId:Q,tag:ne?t.TestTag.namespace(this.controllerId,ne.id):null,label:ke,group:pe,isDefault:we,hasConfigurationHandler:!1,supportsContinuousRun:re})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Vec=C;const B={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[270],Re([1,0,18,11,5,3,109,8,7]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;class g{constructor(S,o){this.i=o,this.a=new P.$Od({onListenerError:L.$1}),this.b=new P.$Od({onListenerError:L.$1}),this.c=new P.$Od({onListenerError:L.$1}),this.d=new P.$Od({onListenerError:L.$1}),this.f=new P.$Od({onListenerError:L.$1}),this.g=new P.$Od({onListenerError:L.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=S.getProxy(M.$uK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(S){const o=this.i.allEditors();return S?o:o.map(v=>v.value)}async showTextDocument(S,o,v){let p;typeof o=="number"?p={position:$.ViewColumn.from(o),preserveFocus:v}:typeof o=="object"?p={position:$.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selection:typeof o.selection=="object"?$.Range.from(o.selection):void 0,pinned:typeof o.preview=="boolean"?!o.preview:void 0}:p={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(S.uri,p),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,o){return new R.$DM(this.h,S,o).value}$acceptEditorPropertiesChanged(S,o){const v=this.i.getEditor(S);if(!v)throw new Error("unknown text editor");if(o.options&&v._acceptOptions(o.options),o.selections){const p=o.selections.selections.map($.Selection.to);v._acceptSelections(p)}if(o.visibleRanges){const p=E.$Gb(o.visibleRanges.map($.Range.to));v._acceptVisibleRanges(p)}if(o.options&&this.b.fire({textEditor:v.value,options:{...o.options,lineNumbers:$.TextEditorLineNumbersStyle.to(o.options.lineNumbers)}}),o.selections){const p=D.TextEditorSelectionChangeKind.fromValue(o.selections.source),f=o.selections.selections.map($.Selection.to);this.a.fire({textEditor:v.value,selections:f,kind:p})}if(o.visibleRanges){const p=E.$Gb(o.visibleRanges.map($.Range.to));this.c.fire({textEditor:v.value,visibleRanges:p})}}$acceptEditorPositionData(S){for(const o in S){const v=this.i.getEditor(o);if(!v)throw new Error("Unknown text editor");const p=$.ViewColumn.to(S[o]);v.value.viewColumn!==p&&(v._acceptViewColumn(p),this.d.fire({textEditor:v.value,viewColumn:p}))}}getDiffInformation(S){return Promise.resolve(this.h.$getDiffInformation(S))}}e.$$dc=g}),define(Ae[271],Re([1,0,2,4,3,6,7,8,22,16]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=e.$Mec=void 0,e.$Mec=(0,L.$Sh)("IExtHostTimeline");class A{constructor(v,p){this.b=new Map,this.c=new Map,this.a=v.getProxy(P.$uK.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(f,t)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&D.$9l.equals(t,this.b.get(f.source)?.extension)){const i=f.uri===void 0?void 0:E.URI.revive(f.uri);return this.c.get(f.source)?.get(S(i))?.get(f.handle)}else return;return f}})}async $getTimeline(v,p,f,t){return this.b.get(v)?.provider.provideTimeline(E.URI.revive(p),f,t)}registerTimelineProvider(v,p,f,t){const i=new M.$Qc,n=this.d(p.id,t,i).bind(this);let u;p.onDidChange&&(u=p.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:p.id}),this));const a=this.c;return this.f({...p,scheme:v,onDidChange:void 0,async provideTimeline(l,r,s){r?.resetCache&&(i.clear(),a.get(p.id)?.clear());const c=await p.provideTimeline(l,r,s);if(c==null)return;const h=n(l,r);return{...c,source:p.id,items:c.items.map(h)}},dispose(){for(const l of a.values())l.get(p.id)?.clear();u?.dispose(),i.dispose()}},f)}d(v,p,f){return(t,i)=>{let n;if(i?.cacheResults){let u=this.c.get(v);u===void 0&&(u=new Map,this.c.set(v,u));const a=S(t);n=u.get(a),n===void 0&&(n=new Map,u.set(a,n))}return u=>{const{iconPath:a,...l}=u,r=`${v}|${u.id??u.timestamp}`;n?.set(r,u);let s,c,h;u.iconPath&&(a instanceof R.$qL?h={id:a.id,color:a.color}:E.URI.isUri(a)?(s=a,c=a):{light:s,dark:c}=a);let w;return R.$WK.isMarkdownString(l.tooltip)?w=$.MarkdownString.from(l.tooltip):(0,g.$zf)(l.tooltip)?w=l.tooltip:R.$WK.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=$.MarkdownString.from(l.detail)):(0,g.$zf)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=l.detail),{...l,id:l.id??void 0,handle:r,source:v,command:u.command?p.toInternal(u.command,f):void 0,icon:s,iconDark:c,themeIcon:h,tooltip:w,accessibilityInformation:u.accessibilityInformation}}}}f(v,p){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:p}),(0,M.$Pc)(()=>{for(const t of this.c.values())t.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$Nec=A;function S(o){return o?.toString()}}),define(Ae[87],Re([1,0,20,5,6,169,4,15,198,3,27,17,7]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nwb=e.$Mwb=e.TunnelDtoConverter=void 0;class v extends D.$jv{}var p;(function(t){function i(u){return{remoteAddress:u.remoteAddress,localAddress:u.localAddress,public:!!u.public,privacy:u.privacy??(u.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:u.protocol}}t.fromApiTunnel=i;function n(u){return{remoteAddress:{host:u.tunnelRemoteHost,port:u.tunnelRemotePort},localAddress:u.localAddress,public:u.privacy!==D.TunnelPrivacyId.ConstantPrivate&&u.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:u.privacy,protocol:u.protocol}}t.fromServiceTunnel=n})(p||(e.TunnelDtoConverter=p={})),e.$Mwb=(0,R.$Sh)("IExtHostTunnelService");let f=class extends P.$Rc{constructor(i,n,u){super(),this.s=u,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new L.$Od,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(g.$uK.MainThreadTunnelService)}async openTunnel(i,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const u=await this.a.$openTunnel(n,i.displayName);if(u){const a=new v(u.remoteAddress,u.localAddress,()=>this.a.$closeTunnel(u.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,n){const u=this.u();return this.r.set(u,{selector:i,provider:n}),this.a.$registerPortsAttributesProvider(i,u),new o.$wK(()=>{this.r.delete(u),this.a.$unregisterPortsAttributesProvider(u)})}async $providePortAttributes(i,n,u,a,l){const r=[];for(const c of i){const h=this.r.get(c);if(!h)return[];r.push(...await Promise.all(n.map(async w=>{let m;try{m=await h.provider.providePortAttributes({port:w,pid:u,commandLine:a},l)}catch{m=await h.provider.providePortAttributes(w,u,a,l)}return{providedAttributes:m,port:w}})))}const s=r.filter(c=>!!c.providedAttributes);return s.length>0?s.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,l)=>await i.provideTunnel(a,l,new E.$Yd().token)??void 0;const u=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(u),Promise.resolve((0,P.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,n){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const u=i.tunnelFactory??(n?this.w(n):void 0);if(u){this.b=u;let a=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const l=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:a}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,P.$Pc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,n){if(this.g.has(i.host)){const u=this.g.get(i.host);u.has(i.port)&&(n&&u.get(i.port).disposeListener.dispose(),await u.get(i.port).tunnel.dispose(),u.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const u=this.b(i,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),u!==void 0){const a=await u;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const l=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:a,disposeListener:l}),p.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(u){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),u instanceof Error)return u.message}}async $applyCandidateFilter(i){const n=await Promise.all(i.map(a=>this.f(a.host,a.port,a.detail??""))),u=i.filter((a,l)=>n[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(a=>a.port).join(", ")} to ${u.map(a=>a.port).join(", ")}`),u}};e.$Nwb=f,e.$Nwb=f=Ke([Ve(0,S.$wM),Ve(1,A.$MM),Ve(2,$.$aj)],f)}),define(Ae[272],Re([1,0,6,14,2,3]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class R{static{this.a=new Set([L.Schemas.http,L.Schemas.https])}constructor(D){this.c=new Map,this.b=D.getProxy(M.$uK.MainThreadUriOpeners)}registerExternalUriOpener(D,g,A,S){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const o=S.schemes.find(v=>!R.a.has(v));if(o)throw new Error(`Scheme '${o}' is not supported. Only http and https are currently supported.`);return this.c.set(g,A),this.b.$registerUriOpener(g,S.schemes,D,S.label),(0,E.$Pc)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(D,g,A){const S=this.c.get(D);if(!S)throw new Error(`Unknown opener with id: ${D}`);const o=P.URI.revive(g);return S.canOpenExternalUri(o,A)}async $openUri(D,g,A){const S=this.c.get(D);if(!S)throw new Error(`Unknown opener id: '${D}'`);return S.openExternalUri(P.URI.revive(g.resolvedUri),{sourceUri:P.URI.revive(g.sourceUri)},A)}}e.$Wec=R}),define(Ae[273],Re([1,0,3,2,6,11,22]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;class ${static{this.a=0}constructor(g){this.c=new R.$0l,this.d=new Map,this.b=g.getProxy(E.$uK.MainThreadUrls)}registerUriHandler(g,A){const S=g.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const o=$.a++;return this.c.add(S),this.d.set(o,A),this.b.$registerUriHandler(o,S,g.displayName||g.name),(0,P.$Pc)(()=>{this.c.delete(S),this.d.delete(o),this.b.$unregisterUriHandler(o)})}$handleExternalUri(g,A){const S=this.d.get(g);if(!S)return Promise.resolve(void 0);try{S.handleUri(L.URI.revive(A))}catch(o){(0,M.$Z)(o)}return Promise.resolve(void 0)}async createAppUri(g){return L.URI.revive(await this.b.$createAppUri(g))}}e.$aec=$}),define(Ae[66],Re([1,0,5,6,14,26,2,183,205,78,3]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=e.$eec=e.$dec=e.$cec=e.$bec=void 0;class S{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(a,l,r,s,c,h,w){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$Od,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Od,this._onDidDispose=this.#h.event,this.#e=a,this.#t=l,this.#s=r,this.#o=s,this.#r=c,this.#n=h,this.#l=o(h),this.#d=v(h),this.#i=w}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,g.$6tb)(a,this.#o)}get cspSource(){const a=this.#n.extensionLocation;if(a.scheme===P.Schemas.https||a.scheme===P.Schemas.http){let l=a.toString();return l.endsWith("/")||(l+="/"),l+" "+g.$5tb}return g.$5tb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#s}set options(a){this.a(),M.$bn(this.#s,a)||this.#t.$setOptions(this.#e,t(this.#n,this.#r,a)),this.#s=a}async postMessage(a){if(this.#c)return!1;const l=(0,D.$bdb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const l=this.#n.extensionLocation?.scheme===P.Schemas.vscodeRemote,r=this.#n.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,c,h,w,m,I)=>{const k=R.URI.from({scheme:w||"file",path:decodeURIComponent(m)}),d=(0,g.$6tb)(k,{isRemote:l,authority:r}).toString();return`${c}${d}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,c,h,w,m,I)=>{const k=R.URI.from({scheme:w||"file",path:decodeURIComponent(m)}),d=(0,g.$6tb)(k,{isRemote:l,authority:r}).toString();return`${c}${d}${I}`})}}e.$bec=S;function o(u){try{const a=(0,$.$Qo)((0,$.$Po)(u.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}e.$cec=o;function v(u){try{const a=(0,$.$Qo)((0,$.$Po)(u.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class p extends L.$Rc{constructor(a,l,r,s,c){super(),this.c=l,this.f=r,this.g=s,this.h=c,this.b=new Map,this.a=a.getProxy(A.$uK.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,l,r){const s=this.j(a);if(s){const{message:c}=(0,D.$cdb)(l,r.value);s._onMessageEmitter.fire(c)}}$onMissingCsp(a,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,l,r){const s=new S(a,this.a,i(l),this.c,this.f,r,this.h);this.b.set(a,s);const c=s._onDidDispose(()=>{c.dispose(),this.deleteWebview(a)});return s}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$dec=p;function f(u){return{id:u.identifier,location:u.extensionLocation}}e.$eec=f;function t(u,a,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||n(u,a)}}e.$fec=t;function i(u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots?.map(a=>R.URI.from(a))}}function n(u,a){return[...(a?.getWorkspaceFolders()||[]).map(l=>l.uri),u.extensionLocation]}}),define(Ae[274],Re([1,0,20,97,6,14,25,2,8,66,75,3,7]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=void 0;class v{constructor(s,c){this.document=s,this.b=c,this.a=1,this.c=new A.$0cc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,c){await this.f(s).undo(),c||this.disposeBackup()}async redo(s,c){await this.f(s).redo(),c||this.disposeBackup()}disposeEdits(s){for(const c of s)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=l(this.document.uri)+this.a++;return(0,R.$wg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const c=this.c.get(s,0);if(!c)throw new Error("No edit found");return c}}class p{constructor(){this.a=new Map}get(s,c){return this.a.get(this.b(s,c))}add(s,c,h){const w=this.b(s,c.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${s} resource:${c.uri}`);const m=new v(c,h);return this.a.set(w,m),m}delete(s,c){const h=this.b(s,c.uri);this.a.delete(h)}b(s,c){return`${s}@@@${c}`}}var f;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(f||(f={}));class t{constructor(){this.a=new Map}addTextProvider(s,c,h){return this.b(0,s,c,h)}addCustomProvider(s,c,h){return this.b(1,s,c,h)}get(s){return this.a.get(s)}b(s,c,h,w){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:s,extension:h,provider:w}),new o.$wK(()=>this.a.delete(c))}}class i{constructor(s,c,h,w,m){this.d=c,this.f=h,this.g=w,this.h=m,this.b=new t,this.c=new p,this.a=s.getProxy(S.$uK.MainThreadCustomEditors)}registerCustomEditorProvider(s,c,h,w){const m=new P.$Qc;return u(h)?(m.add(this.b.addTextProvider(c,s,h)),this.a.$registerTextEditorProvider((0,g.$eec)(s),c,w.webviewOptions||{},{supportsMove:!!h.moveCustomTextEditor},(0,g.$cec)(s))):(m.add(this.b.addCustomProvider(c,s,h)),n(h)&&m.add(h.onDidChangeCustomDocument(I=>{const k=this.i(c,I.document.uri);if(a(I)){const d=k.addEdit(I);this.a.$onDidEdit(I.document.uri,c,d,I.label)}else this.a.$onContentChange(I.document.uri,c)})),this.a.$registerCustomEditorProvider((0,g.$eec)(s),c,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,g.$cec)(s))),o.$wK.from(m,new o.$wK(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(s,c,h,w,m){const I=this.b.get(c);if(!I)throw new Error(`No provider found for '${c}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${c}'`);const k=$.URI.revive(s),d=await I.provider.openCustomDocument(k,{backupId:h,untitledDocumentData:w?.buffer},m);let b;return n(I.provider)&&this.f&&(b=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(c,d,b),{editable:n(I.provider)}}async $disposeCustomDocument(s,c){const h=this.b.get(c);if(!h)throw new Error(`No provider found for '${c}'`);if(h.type!==1)throw new Error(`Invalid provider type for '${c}'`);const w=$.URI.revive(s),{document:m}=this.i(c,w);this.c.delete(c,m),m.dispose()}async $resolveCustomEditor(s,c,h,w,m,I){const k=this.b.get(h);if(!k)throw new Error(`No provider found for '${h}'`);const d=D.ViewColumn.to(m),b=this.g.createNewWebview(c,w.contentOptions,k.extension),y=this.h.createNewWebviewPanel(c,h,w.title,d,w.options,b,w.active),C=$.URI.revive(s);switch(k.type){case 1:{const{document:B}=this.i(h,C);return k.provider.resolveCustomEditor(B,y,I)}case 0:{const B=this.d.getDocument(C);return k.provider.resolveCustomTextEditor(B,y,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,c,h){this.i(c,s).disposeEdits(h)}async $onMoveCustomEditor(s,c,h){const w=this.b.get(h);if(!w)throw new Error(`No provider found for '${h}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${h}'`);const m=this.h.getWebviewPanel(s);if(!m)throw new Error("No webview found");const I=$.URI.revive(c),k=this.d.getDocument(I);await w.provider.moveCustomTextEditor(k,m,E.CancellationToken.None)}async $undo(s,c,h,w){return this.i(c,s).undo(h,w)}async $redo(s,c,h,w){return this.i(c,s).redo(h,w)}async $revert(s,c,h){const w=this.i(c,s);await this.j(c).revertCustomDocument(w.document,h),w.disposeBackup()}async $onSave(s,c,h){const w=this.i(c,s);await this.j(c).saveCustomDocument(w.document,h),w.disposeBackup()}async $onSaveAs(s,c,h,w){const m=this.i(c,s);return this.j(c).saveCustomDocumentAs(m.document,$.URI.revive(h),w)}async $backup(s,c,h){const w=this.i(c,s),I=await this.j(c).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},h);return w.updateBackup(I),I.id}i(s,c){const h=this.c.get(s,$.URI.revive(c));if(!h)throw new Error("No custom document found");return h}j(s){const h=this.b.get(s)?.provider;if(!h||!n(h))throw new Error("Custom document is not editable");return h}}e.$Qec=i;function n(r){return!!r.onDidChangeCustomDocument}function u(r){return typeof r.resolveCustomTextEditor=="function"}function a(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function l(r){const s=r.scheme===M.Schemas.file||r.scheme===M.Schemas.untitled?r.fsPath:r.toString();return(0,L.$Gi)(s)+""}}),define(Ae[275],Re([1,0,5,6,2,38,8,66,3,7]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=void 0;class A extends L.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(p,f,t,i){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$Od),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Od),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=f,this.#o=t,this.#i=i.viewType,this.#r=i.panelOptions,this.#s=i.viewColumn,this.#n=i.title,this.#u=i.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(p){this.c(),this.#n!==p&&(this.#n=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#a}set iconPath(p){this.c(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,P.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(p){this.#l||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#u=p.active,this.#c=p.visible,this.#s=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,f){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:R.ViewColumn.from(p),preserveFocus:!!f})}c(){if(this.#l)throw new Error("Webview is disposed")}}class S extends L.$Rc{static c(){return(0,M.$fg)()}constructor(p,f,t){super(),this.j=f,this.m=t,this.g=new Map,this.h=new Map,this.f=p.getProxy(D.$uK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,f,t,i,n={}){const u=typeof i=="object"?i.viewColumn:i,a={viewColumn:R.ViewColumn.from(u),preserveFocus:typeof i=="object"&&!!i.preserveFocus},l=(0,$.$cec)(p),r=S.c();this.f.$createWebviewPanel((0,$.$eec)(p),r,f,{title:t,panelOptions:o(n),webviewOptions:(0,$.$fec)(p,this.m,n),serializeBuffersForPostMessage:l},a);const s=this.j.createNewWebview(r,n,p);return this.createNewWebviewPanel(r,f,t,u,n,s,!0)}$onDidChangeWebviewPanelViewStates(p){const f=Object.keys(p);f.sort((t,i)=>{const n=p[t],u=p[i];return n.active?1:u.active?-1:+n.visible-+u.visible});for(const t of f){const i=this.getWebviewPanel(t);if(!i)continue;const n=p[t];i._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,f,t){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:t,extension:p}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,$.$cec)(p)}),new g.$wK(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel(p,f,t,i){const n=this.h.get(f);if(!n)throw new Error(`No serializer found for '${f}'`);const{serializer:u,extension:a}=n,l=this.j.createNewWebview(p,t.webviewOptions,a),r=this.createNewWebviewPanel(p,f,t.title,i,t.panelOptions,l,t.active);await u.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel(p,f,t,i,n,u,a){const l=new A(p,this.f,u,{viewType:f,title:t,viewColumn:i,panelOptions:n,active:a});return this.g.set(p,l),l}getWebviewPanel(p){return this.g.get(p)}}e.$Pec=S;function o(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Ae[276],Re([1,0,5,6,66,8,3,7]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;class D extends L.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(S,o,v,p,f,t){super(),this.#r=!1,this.#u=this.B(new E.$Od),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$Od),this.onDidDispose=this.#l.event,this.#i=v,this.#a=p,this.#e=S,this.#t=o,this.#o=f,this.#n=t}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#s}set description(S){this.a(),this.#s!==S&&(this.#s=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(S){S===this.#n||this.#r||(this.#n=S,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#r)throw new Error("Webview is disposed")}}class g{constructor(S,o){this.d=o,this.b=new Map,this.c=new Map,this.a=S.getProxy(R.$uK.MainThreadWebviewViews)}registerWebviewViewProvider(S,o,v,p){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:v,extension:S}),this.a.$registerWebviewViewProvider((0,P.$eec)(S),o,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$cec)(S)}),new $.$wK(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(S,o,v,p,f){const t=this.b.get(o);if(!t)throw new Error(`No view provider found for '${o}'`);const{provider:i,extension:n}=t,u=this.d.createNewWebview(S,{},n),a=new D(S,this.a,o,v,u,!0);this.c.set(S,a),await i.resolveWebviewView(a,{state:p},f)}async $onDidChangeWebviewViewVisibility(S,o){this.e(S)._setVisible(o)}async $disposeWebviewView(S){const o=this.e(S);this.c.delete(S),o.dispose(),this.d.deleteWebview(S)}e(S){const o=this.c.get(S);if(!o)throw new Error("No webview found");return o}}e.$Oec=g}),define(Ae[111],Re([1,0,5,3,2,14,13,4,17,23]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=e.$gec=void 0;let S=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(v){const p=this.d;return{get focused(){return p.focused},get active(){return(0,g.$uF)(v,"windowActivity"),p.active}}}constructor(v){this.c=new E.$Od,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=v.getProxy(L.$uK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:f})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,p){p!==this.d[v]&&(this.d={...this.d,[v]:p},this.c.fire(this.d))}openUri(v,p){let f;if(typeof v=="string"){f=v;try{v=P.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,R.$Ce)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,f,p)}async asExternalUri(v,p){if((0,R.$Ce)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(v,p);return P.URI.from(f)}};e.$gec=S,e.$gec=S=A=Ke([Ve(0,D.$wM)],S),e.$hec=(0,$.$Sh)("IExtHostWindow")}),define(Ae[277],Re([1,0,243,27,17]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=void 0;let M=class extends E.$hfc{constructor($,D){super($,D)}f($,D,g){D.apply(console,g)}};e.$phc=M,e.$phc=M=Ke([Ve(0,P.$wM),Ve(1,L.$MM)],M)}),define(Ae[278],Re([1,0,12,24,20,11,5,6,139,231,49]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$w5b=e.ResponsiveState=e.RequestInitiator=e.$v5b=e.$u5b=void 0;function o(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const v="$$ref$$",p={[v]:-1};class f{constructor(C,B){this.jsonString=C,this.referencedBuffers=B}}function t(y,C=null,B=!1){const H=[];return{jsonString:(B?o:JSON.stringify)(y,(z,F)=>{if(typeof F>"u")return p;if(typeof F=="object"){if(F instanceof L.$ce){const N=H.push(F)-1;return{[v]:N}}if(C)return C(z,F)}return F}),referencedBuffers:H}}e.$u5b=t;function i(y,C,B){return JSON.parse(y,(H,U)=>{if(U){const z=U[v];if(typeof z=="number")return C[z];if(B&&U.$mid===1)return B.transformIncoming(U)}return U})}e.$v5b=i;function n(y,C){return JSON.stringify(y,C)}function u(y){return y?(C,B)=>B&&B.$mid===1?y.transformOutgoing(B):B:null}var a;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var l;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const r=()=>{},s=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class h extends $.$Rc{static{S=s}static{this.a=3*1e3}constructor(C,B=null,H=null){super(),this[S]=!0,this.b=this.B(new R.$Od),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=B,this.g=H,this.h=u(this.g),this.j=!1,this.m=[],this.s=[];for(let U=0,z=A.$qv.count;U<z;U++)this.m[U]=null,this.s[U]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$7g(()=>this.H(),1e3)),this.c.onMessage(U=>this.L(U))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const B=this.w[C];delete this.w[C],B.resolveErr(M.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+h.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+h.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,D.$Rm)(C,this.g):C}getProxy(C){const{nid:B,sid:H}=C;return this.s[B]||(this.s[B]=this.J(B,H)),this.s[B]}J(C,B){const H={get:(U,z)=>(typeof z=="string"&&!U[z]&&z.charCodeAt(0)===36&&(U[z]=(...F)=>this.U(C,z,F)),z===c?B:U[z])};return new Proxy(Object.create(null),H)}set(C,B){return this.m[C.nid]=B,B}assertRegistered(C){for(let B=0,H=C.length;B<H;B++){const U=C[B];if(!this.m[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}L(C){if(this.j)return;const B=C.byteLength,H=m.read(C,0),U=H.readUInt8(),z=H.readUInt32();switch(U){case 1:case 2:{let{rpcId:F,method:N,args:X}=k.deserializeRequestJSONArgs(H);this.g&&(X=(0,D.$Rm)(X,this.g)),this.M(B,z,F,N,X,U===2);break}case 3:case 4:{let{rpcId:F,method:N,args:X}=k.deserializeRequestMixedArgs(H);this.g&&(X=(0,D.$Rm)(X,this.g)),this.M(B,z,F,N,X,U===4);break}case 5:{this.f?.logIncoming(B,z,0,"ack"),this.G(z);break}case 6:{this.N(B,z);break}case 7:{this.O(B,z,void 0);break}case 9:{let F=k.deserializeReplyOKJSON(H);this.g&&(F=(0,D.$Rm)(F,this.g)),this.O(B,z,F);break}case 10:{const F=k.deserializeReplyOKJSONWithBuffers(H,this.g);this.O(B,z,F);break}case 8:{const F=k.deserializeReplyOKVSBuffer(H);this.O(B,z,F);break}case 11:{let F=k.deserializeReplyErrError(H);this.g&&(F=(0,D.$Rm)(F,this.g)),this.P(B,z,F);break}case 12:{this.P(B,z,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,B,H,U,z,F){this.f?.logIncoming(C,B,1,`receiveRequest ${(0,A.$sv)(H)}.${U}(`,z);const N=String(B);let X,Q;if(F){const ke=new P.$Yd;z.push(ke.token),X=this.Q(H,U,z),Q=()=>ke.cancel()}else X=this.Q(H,U,z),Q=r;this.u[N]=Q;const De=k.serializeAcknowledged(B);this.f?.logOutgoing(De.byteLength,B,1,"ack"),this.c.send(De),X.then(ke=>{delete this.u[N];const Pe=k.serializeReplyOK(B,ke,this.h);this.f?.logOutgoing(Pe.byteLength,B,1,"reply:",ke),this.c.send(Pe)},ke=>{delete this.u[N];const Pe=k.serializeReplyErr(B,ke);this.f?.logOutgoing(Pe.byteLength,B,1,"replyErr:",ke),this.c.send(Pe)})}N(C,B){this.f?.logIncoming(C,B,1,"receiveCancel");const H=String(B);this.u[H]?.()}O(C,B,H){this.f?.logIncoming(C,B,0,"receiveReply:",H);const U=String(B);if(!this.w.hasOwnProperty(U))return;const z=this.w[U];delete this.w[U],z.resolveOk(H)}P(C,B,H){this.f?.logIncoming(C,B,0,"receiveReplyErr:",H);const U=String(B);if(!this.w.hasOwnProperty(U))return;const z=this.w[U];delete this.w[U];let F;H&&(H.$isError?(F=new Error,F.name=H.name,F.message=H.message,F.stack=H.stack):F=H),z.resolveErr(F)}Q(C,B,H){try{return Promise.resolve(this.S(C,B,H))}catch(U){return Promise.reject(U)}}S(C,B,H){const U=this.m[C];if(!U)throw new Error("Unknown actor "+(0,A.$sv)(C));const z=U[B];if(typeof z!="function")throw new Error("Unknown method "+B+" on actor "+(0,A.$sv)(C));return z.apply(U,H)}U(C,B,H){if(this.j)return new g.$t5b;let U=null;if(H.length>0&&P.CancellationToken.isCancellationToken(H[H.length-1])&&(U=H.pop()),U&&U.isCancellationRequested)return Promise.reject(M.$5());const z=k.serializeRequestArguments(H,this.h),F=++this.t,N=String(F),X=new g.$s5b,Q=new $.$Qc;U&&Q.add(U.onCancellationRequested(()=>{const ke=k.serializeCancel(F);this.f?.logOutgoing(ke.byteLength,F,0,"cancel"),this.c.send(k.serializeCancel(F))})),this.w[N]=new w(X,Q),this.F(F);const De=k.serializeRequest(F,C,B,z,!!U);return this.f?.logOutgoing(De.byteLength,F,0,`request: ${(0,A.$sv)(C)}.${B}(`,H),this.c.send(De),X}}e.$w5b=h;class w{constructor(C,B){this.a=C,this.b=B}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class m{static alloc(C,B,H){const U=new m(L.$ce.alloc(H+1+4),0);return U.writeUInt8(C),U.writeUInt32(B),U}static read(C,B){return new m(C,B)}get buffer(){return this.a}constructor(C,B){this.a=C,this.b=B}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const H=this.a.slice(this.b,this.b+C).toString();return this.b+=C,H}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const H=this.a.slice(this.b,this.b+C).toString();return this.b+=C,H}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+C);return this.b+=C,B}static sizeMixedArray(C){let B=0;B+=1;for(let H=0,U=C.length;H<U;H++){const z=C[H];switch(B+=1,z.type){case 1:B+=this.sizeLongString(z.value);break;case 2:B+=this.sizeVSBuffer(z.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(z.value);for(let F=0;F<z.buffers.length;++F)B+=this.sizeVSBuffer(z.buffers[F]);break;case 4:break}}return B}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let B=0,H=C.length;B<H;B++){const U=C[B];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let z=0;z<U.buffers.length;++z)this.writeBuffer(U.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const B=new Array(C);for(let H=0;H<C;H++)switch(this.readUInt8()){case 1:B[H]=this.readLongString();break;case 2:B[H]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),F=this.readLongString(),N=[];for(let X=0;X<z;++X)N.push(this.readVSBuffer());B[H]=new A.$tv(i(F,N,null));break}case 4:B[H]=void 0;break}return B}}var I;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(I||(I={}));class k{static a(C){for(let B=0,H=C.length;B<H;B++)if(C[B]instanceof L.$ce||C[B]instanceof A.$tv||typeof C[B]>"u")return!0;return!1}static serializeRequestArguments(C,B){if(this.a(C)){const H=[];for(let U=0,z=C.length;U<z;U++){const F=C[U];if(F instanceof L.$ce)H[U]={type:2,value:F};else if(typeof F>"u")H[U]={type:4};else if(F instanceof A.$tv){const{jsonString:N,referencedBuffers:X}=t(F.value,B);H[U]={type:3,value:L.$ce.fromString(N),buffers:X}}else H[U]={type:1,value:L.$ce.fromString(n(F,B))}}return{type:1,args:H}}return{type:0,args:n(C,B)}}static serializeRequest(C,B,H,U,z){switch(U.type){case 0:return this.b(C,B,H,U.args,z);case 1:return this.c(C,B,H,U.args,z)}}static b(C,B,H,U,z){const F=L.$ce.fromString(H),N=L.$ce.fromString(U);let X=0;X+=m.sizeUInt8(),X+=m.sizeShortString(F),X+=m.sizeLongString(N);const Q=m.alloc(z?2:1,C,X);return Q.writeUInt8(B),Q.writeShortString(F),Q.writeLongString(N),Q.buffer}static deserializeRequestJSONArgs(C){const B=C.readUInt8(),H=C.readShortString(),U=C.readLongString();return{rpcId:B,method:H,args:JSON.parse(U)}}static c(C,B,H,U,z){const F=L.$ce.fromString(H);let N=0;N+=m.sizeUInt8(),N+=m.sizeShortString(F),N+=m.sizeMixedArray(U);const X=m.alloc(z?4:3,C,N);return X.writeUInt8(B),X.writeShortString(F),X.writeMixedArray(U),X.buffer}static deserializeRequestMixedArgs(C){const B=C.readUInt8(),H=C.readShortString(),U=C.readMixedArray(),z=new Array(U.length);for(let F=0,N=U.length;F<N;F++){const X=U[F];typeof X=="string"?z[F]=JSON.parse(X):z[F]=X}return{rpcId:B,method:H,args:z}}static serializeAcknowledged(C){return m.alloc(5,C,0).buffer}static serializeCancel(C){return m.alloc(6,C,0).buffer}static serializeReplyOK(C,B,H){if(typeof B>"u")return this.d(C);if(B instanceof L.$ce)return this.e(C,B);if(B instanceof A.$tv){const{jsonString:U,referencedBuffers:z}=t(B.value,H,!0);return this.g(C,U,z)}else return this.f(C,o(B,H))}static d(C){return m.alloc(7,C,0).buffer}static e(C,B){let H=0;H+=m.sizeVSBuffer(B);const U=m.alloc(8,C,H);return U.writeVSBuffer(B),U.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,B){const H=L.$ce.fromString(B);let U=0;U+=m.sizeLongString(H);const z=m.alloc(9,C,U);return z.writeLongString(H),z.buffer}static g(C,B,H){const U=L.$ce.fromString(B);let z=0;z+=m.sizeUInt32,z+=m.sizeLongString(U);for(const N of H)z+=m.sizeVSBuffer(N);const F=m.alloc(10,C,z);F.writeUInt32(H.length),F.writeLongString(U);for(const N of H)F.writeBuffer(N);return F.buffer}static deserializeReplyOKJSON(C){const B=C.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(C,B){const H=C.readUInt32(),U=C.readLongString(),z=[];for(let F=0;F<H;++F)z.push(C.readVSBuffer());return new A.$tv(i(U,z,B))}static serializeReplyErr(C,B){const H=B?o(M.$2(B),null):void 0;if(typeof H!="string")return this.h(C);const U=L.$ce.fromString(H);let z=0;z+=m.sizeLongString(U);const F=m.alloc(11,C,z);return F.writeLongString(U),F.buffer}static deserializeReplyErrError(C){const B=C.readLongString();return JSON.parse(B)}static h(C){return m.alloc(12,C,0).buffer}}var d;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var b;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(b||(b={}))}),define(Ae[279],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;const E=function(M){const R=$=>{globalThis.removeEventListener("message",R);const D=$.data;Object.defineProperties(globalThis,{postMessage:{value(g,A){D.postMessage(g,A)}},onmessage:{get(){return D.onmessage},set(g){D.onmessage=g}}}),D.addEventListener("message",g=>{globalThis.dispatchEvent(new MessageEvent("message",{data:g.data,ports:g.ports?[...g.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",R)}.toString();class L extends EventTarget{constructor(M,R,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${E})('${R}'))`,g=new Blob([D],{type:"application/javascript"}),A=URL.createObjectURL(g),S=new MessageChannel,o=A,v={type:"_newWorker",id:o,port:S.port2,url:A,options:$};M(v,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{M({type:"_terminateWorker",id:o}),URL.revokeObjectURL(A),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(p){S.port1.onmessage=p}},onmessageerror:{get(){return S.port1.onmessageerror},set(p){S.port1.onmessageerror=p}}}),S.port1.addEventListener("messageerror",p=>{const f=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(f)}),S.port1.addEventListener("message",p=>{const f=new MessageEvent("message",{data:p.data});this.dispatchEvent(f)}),S.port1.start()}}e.$rhc=L}),define(Ae[280],Re([1,0,5,30,34,4]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=e.$MJ=e.OutputChannelUpdateMode=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=void 0,e.$CJ="text/x-code-output",e.$DJ="output",e.$EJ="Log",e.$FJ="text/x-code-log-output",e.$GJ="log",e.$HJ="workbench.panel.output",e.$IJ=new P.$0i("inOutput",!1),e.$JJ=new P.$0i("activeLogOutput",!1),e.$KJ=new P.$0i("outputView.scrollLock",!1),e.$LJ=(0,M.$Sh)("outputService");var R;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$MJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new E.$Od,this.onDidRegisterChannel=this.b.event,this.c=new E.$Od,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(A=>g.push(A)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}L.$jn.add(e.$MJ.OutputChannels,new $),e.$NJ=new P.$0i("activeOutputChannel","")}),define(Ae[112],Re([1,0,3,4,17,22,15,280,64,27,42,136,24,16,41,5,6]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=e.$3dc=void 0;class i extends R.$gj{get disposed(){return this.n}constructor(l,r,s,c,h){super(),this.id=l,this.name=r,this.r=s,this.s=c,this.extension=h,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,l)}replace(l){const r=this.m;this.info(l),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,r),this.visible&&this.r.flush()}show(l,r){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:r))}hide(){this.s.$close(this.id)}g(l,r){this.m+=o.$ce.fromString(r).byteLength,(0,R.log)(this.r,l,r),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends i{appendLine(l){this.append(l)}}let u=class{constructor(l,r,s,c,h,w){this.i=r,this.j=s,this.k=c,this.l=h,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(E.$uK.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,S.$hm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[r,s]of this.g)s.visible=r===this.h}createOutputChannel(l,r,s){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const c=typeof r=="object"&&r.log,h=(0,v.$zf)(r)?r:void 0;if((0,v.$zf)(h)&&!h.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const m=this.i.environment.extensionLogLevel?.find(([k])=>M.$9l.equals(s.identifier,k))?.[1];m&&(w=(0,R.$qj)(m));const I=c?this.o(l,w,s):this.n(l,h,s);return I.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),c?this.r(l,w??this.m.getLevel(),I):this.q(l,I)}async n(l,r,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,h=this.k.extUri.joinPath(c,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(h,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(l,h,r,s.identifier.value);return new i(m,l,w,this.a,s)}async o(l,r,s){const c=await this.p(s),h=l.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(c,`${h}.log`),m=`${s.identifier.value}.${h}`,I=this.l.createLogger(w,{id:m,name:l,logLevel:r,extensionId:s.identifier.value});return new n(m,l,I,this.a,s)}p(l){let r=this.d.get(l.identifier.value);if(!r){const s=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(s)}catch(c){if((0,p.$rk)(c)!==p.FileSystemProviderErrorCode.FileExists)throw c}return s})())}return r}q(l,r){let s=!1;const c=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return l},append(h){c(),r.then(w=>w.append(h))},appendLine(h){c(),r.then(w=>w.appendLine(h))},clear(){c(),r.then(h=>h.clear())},replace(h){c(),r.then(w=>w.replace(h))},show(h,w){c(),r.then(m=>m.show(h,w))},hide(){c(),r.then(h=>h.hide())},dispose(){s=!0,r.then(h=>h.dispose())}}}r(l,r,s){const c=new t.$Qc,h=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},w=c.add(new f.$Od);function m(I){r=I,w.fire(I)}return s.then(I=>{c.add(I),I.logLevel!==r&&m(I.logLevel),c.add(I.onDidChangeLogLevel(k=>m(k)))}),{...this.q(l,s),get logLevel(){return r},onDidChangeLogLevel:w.event,trace(I,...k){h(),s.then(d=>d.trace(I,...k))},debug(I,...k){h(),s.then(d=>d.debug(I,...k))},info(I,...k){h(),s.then(d=>d.info(I,...k))},warn(I,...k){h(),s.then(d=>d.warn(I,...k))},error(I,...k){h(),s.then(d=>d.error(I,...k))},dispose(){c.dispose()}}}};e.$3dc=u,e.$3dc=u=Ke([Ve(0,P.$wM),Ve(1,g.$MM),Ve(2,D.$Fdc),Ve(3,A.$adc),Ve(4,R.$bj),Ve(5,R.$aj)],u),e.$4dc=(0,L.$Sh)("IExtHostOutputService")}),define(Ae[113],Re([1,0,4,12]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=e.$wm=void 0,e.$wm=(0,E.$Sh)("remoteAgentService"),e.$xm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let M=1/0;for(let $=0;$<this.maxSampleCount;$++){const D=await P.getRoundTripTime();if(D===void 0)return;M=Math.min(M,D/2),await(0,L.$Vg)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(M):R=this.initial.reduce(($,D)=>$+D,0)/this.initial.length,this.lastMeasurement={initial:R,current:M,average:this.average.reduce(($,D)=>$+D,0)/this.average.length,high:(()=>typeof R>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[281],Re([1,0,171,56,30,47,40,6,5,113,21]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=void 0,e.$mH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$nH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$oH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$pH={ConfigurationMigration:"base.contributions.configuration.migration"};class S{constructor(){this.migrations=[],this.a=new D.$Od,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const o=new S;P.$jn.add(e.$pH.ConfigurationMigration,o);let v=class extends $.$Rc{constructor(t,i){super(),this.a=t,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const u of n.added)await this.f(u,o.migrations)})),this.c(o.migrations),this.B(o.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(t){await this.f(void 0,t);for(const i of this.b.getWorkspace().folders)await this.f(i,t)}async f(t,i){await Promise.all(i.map(n=>this.g(n,{resource:t?.uri})))}async g(t,i){const n=this.a.inspect(t.key,i);if(await this.h(t,i,n,"userValue",2),await this.h(t,i,n,"userLocalValue",3),await this.h(t,i,n,"userRemoteValue",4),await this.h(t,i,n,"workspaceFolderValue",6),await this.h(t,i,n,"workspaceValue",5),typeof i.overrideIdentifier>"u"&&typeof n.overrideIdentifiers<"u")for(const u of n.overrideIdentifiers)await this.g(t,{resource:i.resource,overrideIdentifier:u})}async h(t,i,n,u,a){const l=n[u];if(typeof l>"u")return;const r=h=>this.a.inspect(h,i)[u],s=await t.migrateFn(l,r),c=Array.isArray(s)?s:[[t.key,s]];await Promise.allSettled(c.map(async([h,w])=>this.a.updateValue(h,w.value,i,a)))}};e.$qH=v,e.$qH=v=Ke([Ve(0,R.$mi),Ve(1,M.$2h)],v);let p=class extends $.$Rc{constructor(t){super(),(async()=>{if(!A.$i&&(await t.getEnvironment())?.os!==1)return;P.$jn.as(L.$on.Configuration).registerConfiguration({...e.$oH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$rH=p,e.$rH=p=Ke([Ve(0,g.$wm)],p)}),define(Ae[282],Re([1,0,33,14,19,25,179,281,56,4,30]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcb=e.$ucb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$tcb=e.$scb=void 0,e.$scb=(0,g.$Sh)("editorResolverService"),e.$tcb="workbench.editorAssociations";const S=A.$jn.as(D.$on.Configuration),o={...$.$nH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(o);var v;(function(i){i.builtin="builtin",i.option="option",i.exclusive="exclusive",i.default="default"})(v||(e.RegisteredEditorPriority=v={}));var p;(function(i){i[i.ABORT=1]="ABORT",i[i.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function f(i){switch(i){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$ucb=f;function t(i,n){if(new Set([L.Schemas.extension,L.Schemas.webviewPanel,L.Schemas.vscodeWorkspaceTrust,L.Schemas.vscodeSettings]).has(n.scheme))return!1;const l=typeof i=="string"&&i.indexOf(P.$fc.sep)>=0?`${n.scheme}:${n.path}`:(0,M.$tg)(n);return E.$yj(typeof i=="string"?i.toLowerCase():i,l.toLowerCase())}e.$vcb=t}),define(Ae[283],Re([1,0,46,14,19,21,25,2,4,200,47,218,113]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$7J=e.$6J=void 0,e.$6J=(0,D.$Sh)("pathService");let p=v=class{constructor(t,i,n,u){this.d=t,this.e=i,this.f=n,this.g=u,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??t})()}hasValidBasename(t,i,n){return typeof i=="string"||typeof i>"u"?this.a.then(u=>this.h(t,u,i)):this.h(t,i,n)}h(t,i,n){return t.scheme===L.Schemas.file||t.scheme===L.Schemas.vscodeRemote?(0,E.$Wf)(n??(0,R.$tg)(t),i===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return L.Schemas.vscodeRemote;const n=(0,g.$3J)(i.getWorkspace());if(n)return n;const u=i.getWorkspace().folders[0];if(u)return u.uri.scheme;const a=i.getWorkspace().configuration;return a?a.scheme:L.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?P.$ec:P.$fc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const u=t.indexOf("/",2);u===-1?(i=t.substring(2),t="/"):(i=t.substring(2,u),t=t.substring(u)||"/")}return $.URI.from({scheme:L.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$7J=p,e.$7J=p=v=Ke([Ve(1,o.$wm),Ve(2,S.$OJ),Ve(3,A.$2h)],p)}),define(Ae[114],Re([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$MI=e.$LI=void 0;class E{constructor(R,$){this.line=R,this.character=$}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,$){return new E(0,0)}with(R){return new E(0,0)}}e.$LI=E;class L{constructor(R,$,D,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(R,$),this.end=new E(D,g)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.$MI=L;var P;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Ae[43],Re([1,0,18,33,26,46,13,4,19,11,114,12]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.SearchErrorCode=e.$2I=e.$1I=e.SearchSortOrder=e.ViewMode=e.$ZI=e.$YI=e.$XI=e.$WI=e.SearchCompletionExitCode=e.$VI=e.$UI=e.$TI=e.QueryType=e.SearchProviderType=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$NI="workbench.view.search",e.$OI="workbench.panel.search",e.$PI="workbench.view.search",e.$QI="search-result",e.$RI="search.exclude";const o="\u27EA ",v=" characters skipped \u27EB",p=(o.length+v.length+5)*2;e.$SI=(0,$.$Sh)("searchService");var f;(function(fe){fe[fe.file=0]="file",fe[fe.text=1]="text"})(f||(e.SearchProviderType=f={}));var t;(function(fe){fe[fe.File=1]="File",fe[fe.Text=2]="Text"})(t||(e.QueryType=t={}));function i(fe){return!!fe.preview}e.$TI=i;function n(fe){return!!fe.resource}e.$UI=n;function u(fe){return!!fe.message}e.$VI=u;var a;(function(fe){fe[fe.Normal=0]="Normal",fe[fe.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class l{constructor(we){this.resource=we,this.results=[]}}e.$WI=l;class r{constructor(we,ne,re,pe){this.ranges=ne,this.webviewIndex=pe;const _=Array.isArray(ne)?ne:[ne];if(re&&re.matchLines===1&&s(_)){we=(0,R.$sf)(we,re.matchLines);let W="",ce=0,be=0;const se=Math.floor(re.charsPerLine/5),he=[];for(const ue of _){const ye=Math.max(ue.startColumn-se,0),ee=ue.startColumn+re.charsPerLine;if(ye>be+se+p){const de=o+(ye-be)+v;W+=de+we.slice(ye,ee),ce+=ye-(be+de.length)}else W+=we.slice(be,ee);he.push(new h(0,ue.startColumn-ce,ue.endColumn-ce)),be=ee}this.preview={text:W,matches:Array.isArray(this.ranges)?he:he[0]}}else{const W=Array.isArray(ne)?ne[0].startLineNumber:ne.startLineNumber;this.preview={text:we,matches:(0,E.$1b)(ne,ce=>new c(ce.startLineNumber-W,ce.startColumn,ce.endLineNumber-W,ce.endColumn))}}}}e.$XI=r;function s(fe){const we=fe[0].startLineNumber;for(const ne of fe)if(ne.startLineNumber!==we||ne.endLineNumber!==we)return!1;return!0}class c{constructor(we,ne,re,pe){this.startLineNumber=we,this.startColumn=ne,this.endLineNumber=re,this.endColumn=pe}}e.$YI=c;class h extends c{constructor(we,ne,re){super(we,ne,we,re)}}e.$ZI=h;var w;(function(fe){fe.List="list",fe.Tree="tree"})(w||(e.ViewMode=w={}));var m;(function(fe){fe.Default="default",fe.FileNames="fileNames",fe.Type="type",fe.Modified="modified",fe.CountDescending="countDescending",fe.CountAscending="countAscending"})(m||(e.SearchSortOrder=m={}));function I(fe,we=!0){const ne=fe&&fe.files&&fe.files.exclude,re=we&&fe&&fe.search&&fe.search.exclude;if(!ne&&!re)return;if(!ne||!re)return ne||re;let pe=Object.create(null);return pe=P.$an(pe,P.$0m(ne)),pe=P.$an(pe,P.$0m(re),!0),pe}e.$1I=I;function k(fe,we){return fe.excludePattern&&L.$yj(fe.excludePattern,we)?!1:fe.includePattern||fe.usingSearchPaths?fe.includePattern&&L.$yj(fe.includePattern,we)?!0:fe.usingSearchPaths?!!fe.folderQueries&&fe.folderQueries.some(ne=>{const re=ne.folder.fsPath;if(M.$Yf(we,re)){const pe=D.$kc(re,we);return!ne.includePattern||!!L.$yj(ne.includePattern,pe)}else return!1}):!1:!0}e.$2I=k;var d;(function(fe){fe[fe.unknownEncoding=1]="unknownEncoding",fe[fe.regexParseError=2]="regexParseError",fe[fe.globParseError=3]="globParseError",fe[fe.invalidLiteral=4]="invalidLiteral",fe[fe.rgProcessError=5]="rgProcessError",fe[fe.other=6]="other",fe[fe.canceled=7]="canceled"})(d||(e.SearchErrorCode=d={}));class b extends Error{constructor(we,ne){super(we),this.code=ne}}e.$3I=b;function y(fe){const we=fe.message;if((0,g.$3)(fe))return new b(we,d.canceled);try{const ne=JSON.parse(we);return new b(ne.message,ne.code)}catch{return new b(we,d.other)}}e.$4I=y;function C(fe){const we={message:fe.message,code:fe.code};return new Error(JSON.stringify(we))}e.$5I=C;function B(fe){return fe.type==="error"?!0:fe.type==="success"}e.$6I=B;function H(fe){return fe.type==="success"}e.$7I=H;function U(fe){return!!fe.path}e.$8I=U;function z(fe,we){const ne=fe.searchPath?fe.searchPath:fe.relativePath;return(0,R.$pf)(ne,we)}e.$9I=z;class F{constructor(we){this.path=we,this.results=[]}addMatch(we){this.results.push(we)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$0I=F;function N(fe,we){const ne={...fe||{},...we||{}};return Object.keys(ne).filter(re=>{const pe=ne[re];return typeof pe=="boolean"&&pe})}e.$$I=N;class X{constructor(we,ne){this.c=null,this.a={...we.excludePattern||{},...ne.excludePattern||{}},this.b=L.$zj(this.a);let re=we.includePattern;ne.includePattern&&(re?re={...re,...ne.includePattern}:re=ne.includePattern),re&&(this.c=L.$zj(re))}matchesExcludesSync(we,ne,re){return!!(this.b&&this.b(we,ne,re))}includedInQuerySync(we,ne,re){return!(this.b&&this.b(we,ne,re)||this.c&&!this.c(we,ne,re))}includedInQuery(we,ne,re){const pe=this.b(we,ne,re),_=()=>this.c?!!this.c(we,ne,re):!0;return(0,S.$Hg)(pe)?pe.then(W=>W?!1:_()):_()}hasSiblingExcludeClauses(){return Q(this.a)}}e.$_I=X;function Q(fe){for(const we in fe)if(typeof fe[we]!="boolean")return!0;return!1}function De(fe){if(!fe)return;let we;return ne=>(we||(we=(fe()||Promise.resolve([])).then(re=>re?Pe(re):{})),we.then(re=>!!re[ne]))}e.$aJ=De;function ke(fe){if(!fe)return;let we;return ne=>{if(!we){const re=fe();we=re?Pe(re):{}}return!!we[ne]}}e.$bJ=ke;function Pe(fe){const we={};for(const ne of fe)we[ne]=!0;return we}}),define(Ae[35],Re([1,0,18,12,20,5,6,51,14,121,25,13,2,170,4,15,189,47,42,27,17,8,7,59,43,3,52]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=e.$mdc=void 0;function m(H,U,z){return new A.$lg(F=>b(F,z)).isEqual(H,U)}function I(H,U,z){return m(H.uri,U.uri,z)?0:(0,S.$Ve)(H.uri.toString(),U.uri.toString())}function k(H,U,z){return H.index!==U.index?H.index<U.index?-1:1:m(H.uri,U.uri,z)?(0,S.$Ve)(H.name,U.name):(0,S.$Ve)(H.uri.toString(),U.uri.toString())}function d(H,U,z,F){const N=H.slice(0).sort((Q,De)=>z(Q,De,F)),X=U.slice(0).sort((Q,De)=>z(Q,De,F));return(0,E.$Db)(N,X,(Q,De)=>z(Q,De,F))}function b(H,U){const z=U.getCapabilities(H.scheme);return!(z&&z&1024)}class y extends i.$_h{static toExtHostWorkspace(U,z,F,N){if(!U)return{workspace:null,added:[],removed:[]};const{id:X,name:Q,folders:De,configuration:ke,transient:Pe,isUntitled:fe}=U,we=[],ne=z;z?De.forEach((W,ce)=>{const be=o.URI.revive(W.uri),se=y.o(F||z,be,N);se?(se.name=W.name,se.index=W.index,we.push(se)):we.push({uri:be,name:W.name,index:ce})}):we.push(...De.map(({uri:W,name:ce,index:be})=>({uri:o.URI.revive(W),name:ce,index:be}))),we.sort((W,ce)=>W.index<ce.index?-1:1);const re=new y(X,Q,we,!!Pe,ke?o.URI.revive(ke):null,!!fe,W=>b(W,N)),{added:pe,removed:_}=d(ne?ne.workspaceFolders:[],re.workspaceFolders,I,N);return{workspace:re,added:pe,removed:_}}static o(U,z,F){for(let N=0;N<U.folders.length;N++){const X=U.workspaceFolders[N];if(m(X.uri,z,F))return X}}constructor(U,z,F,N,X,Q,De){super(U,F.map(ke=>new i.$ai(ke)),N,X,De),this.t=z,this.u=Q,this.q=[],this.s=$.$Yh.forUris(De),F.forEach(ke=>{this.q.push(ke),this.s.set(ke.uri,ke)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(U,z){return z&&this.s.get(U)&&(U=(0,A.$vg)(U)),this.s.findSubstr(U)}resolveWorkspaceFolder(U){return this.s.get(U)}}let C=class{constructor(U,z,F,N,X){this.c=new M.$Od,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Od,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Qd,this.B=new Map,this.h=N,this.s=F,this.t=X,this.j=new g.$Tl,this.k=new L.$Tg,this.o=U.getProxy(h.$uK.MainThreadWorkspace),this.q=U.getProxy(h.$uK.MainThreadMessageService);const Q=z.workspace;this.l=Q?new y(Q.id,Q.name,[],!!Q.transient,Q.configuration?o.URI.revive(Q.configuration):null,!!Q.isUntitled,De=>b(De,F)):void 0}$initializeWorkspace(U,z){this.v=z,this.$acceptWorkspaceData(U),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?o.URI.from({scheme:D.Schemas.untitled,path:(0,A.$tg)((0,A.$vg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(U,z,F,...N){const X=[];if(Array.isArray(N)&&N.forEach(fe=>{o.URI.isUri(fe.uri)&&!X.some(we=>m(we.uri,fe.uri,this.s))&&X.push({uri:fe.uri,name:fe.name||(0,A.$sg)(fe.uri)})}),this.n||[z,F].some(fe=>typeof fe!="number"||fe<0)||F===0&&X.length===0)return!1;const Q=this.x?this.x.workspaceFolders:[];if(z+F>Q.length)return!1;const De=Q.slice(0);De.splice(z,F,...X.map(fe=>({uri:fe.uri,name:fe.name||(0,A.$sg)(fe.uri),index:void 0})));for(let fe=0;fe<De.length;fe++){const we=De[fe];if(De.some((ne,re)=>re!==fe&&m(we.uri,ne.uri,this.s)))return!1}De.forEach((fe,we)=>fe.index=we);const{added:ke,removed:Pe}=d(Q,De,k,this.s);if(ke.length===0&&Pe.length===0)return!1;if(this.o){const fe=U.displayName||U.name;this.o.$updateWorkspaceFolders(fe,z,F,X).then(void 0,we=>{this.n=void 0;const ne={source:{identifier:U.identifier,label:U.displayName||U.name}};this.q.$showMessage(t.Severity.Error,(0,v.localize)(0,null,fe,we.toString()),ne,[])})}return this.y(De),!0}getWorkspaceFolder(U,z){if(this.x)return this.x.getWorkspaceFolder(U,z)}async getWorkspaceFolder2(U,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(U,z)}async resolveWorkspaceFolder(U){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(U)}getPath(){if(!this.x)return;const{folders:U}=this.x;if(U.length!==0)return U[0].uri.fsPath}getRelativePath(U,z){let F,N="";if(typeof U=="string"?(F=o.URI.file(U),N=U):typeof U<"u"&&(F=U,N=U.fsPath),!F)return N;const X=this.getWorkspaceFolder(F,!0);if(!X)return N;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let Q=(0,A.$yg)(X.uri,F);return z&&X.name&&(Q=`${X.name}/${Q}`),Q}y(U){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:U,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(U){const{workspace:z,added:F,removed:N}=y.toExtHostWorkspace(U,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:F,removed:N}))}findFiles(U,z,F,N,X=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let Q;if(z===null?Q=!1:z&&(typeof z=="string"?Q=z:Q=z.pattern),X&&X.isCancellationRequested)return Promise.resolve([]);const{includePattern:De,folder:ke}=B(l.GlobPattern.from(U));return this.o.$startFileSearch(De??null,ke??null,Q??null,F??null,X).then(Pe=>Array.isArray(Pe)?Pe.map(fe=>o.URI.revive(fe)):[])}async findTextInFiles(U,z,F,N,X=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const Q=this.j.getNext(),De=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:ke,folder:Pe}=B(l.GlobPattern.from(z.include)),fe=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,we={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:De,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:ke,excludePattern:fe},ne=!1;if(this.u[Q]=re=>{if(ne)return;const pe=o.URI.revive(re.resource);re.results.forEach(_=>{const W=(0,w.$ph)(_);(0,c.$TI)(W)?F({uri:pe,preview:{text:W.preview.text,matches:(0,E.$1b)(W.preview.matches,ce=>new r.$yK(ce.startLineNumber,ce.startColumn,ce.endLineNumber,ce.endColumn))},ranges:(0,E.$1b)(W.ranges,ce=>new r.$yK(ce.startLineNumber,ce.startColumn,ce.endLineNumber,ce.endColumn))}):F({uri:pe,text:W.text,lineNumber:W.lineNumber})})},X.isCancellationRequested)return{};try{const re=await this.o.$startTextSearch(U,Pe??null,we,Q,X);return delete this.u[Q],re||{}}catch(re){throw delete this.u[Q],re}}$handleTextSearchResult(U,z){this.u[z]?.(U)}async save(U){const z=await this.o.$save(U,{saveAs:!1});return o.URI.revive(z)}async saveAs(U){const z=await this.o.$save(U,{saveAs:!0});return o.URI.revive(z)}saveAll(U){return this.o.$saveAll(U)}resolveProxy(U){return this.o.$resolveProxy(U)}get trusted(){return this.v}requestWorkspaceTrust(U){return this.o.$requestWorkspaceTrust(U)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(U,z){if(this.w.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this.w.set(U,z);const F=this.t.transformOutgoingScheme(U),N=this.z++;return this.o.$registerEditSessionIdentityProvider(N,F),(0,R.$Pc)(()=>{this.w.delete(U),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(U,z){this.h.info("Getting edit session identifier for workspaceFolder",U);const F=await this.resolveWorkspaceFolder(o.URI.revive(U));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const N=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!N),!N)return;const X=await N.provideEditSessionIdentity(F,z);if(this.h.info("Provider returned edit session identifier: ",X),!!X)return X}async $provideEditSessionIdentityMatch(U,z,F,N){this.h.info("Getting edit session identifier for workspaceFolder",U);const X=await this.resolveWorkspaceFolder(o.URI.revive(U));if(!X){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",X);const Q=this.w.get(X.uri.scheme);if(this.h.info(`Provider for scheme ${X.uri.scheme} is defined: `,!!Q),!Q)return;const De=await Q.provideEditSessionIdentityMatch?.(z,F,N);if(this.h.info("Provider returned edit session identifier match result: ",De),!!De)return De}getOnWillCreateEditSessionIdentityEvent(U){return(z,F,N)=>{const X=function(De){z.call(F,De)};return X.extension=U,this.A.event(X,void 0,N)}}async $onWillCreateEditSessionIdentity(U,z,F){const N=await this.resolveWorkspaceFolder(o.URI.revive(U));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:N},z,async(X,Q)=>{const De=Date.now();await Promise.resolve(X),Date.now()-De>F&&this.h.warn("SLOW edit session create-participant",Q.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(U,z){if(this.B.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this.B.set(U,z);const F=this.t.transformOutgoingScheme(U),N=this.z++;return this.o.$registerCanonicalUriProvider(N,F),(0,R.$Pc)(()=>{this.B.delete(U),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(U,z,F){const N=this.B.get(U.scheme);if(!N)return;const X=await N.provideCanonicalUri?.(o.URI.revive(U),z,F);if(X)return X}async $provideCanonicalUri(U,z,F){return this.provideCanonicalUri(o.URI.revive(U),{targetScheme:z},F)}};e.$mdc=C,e.$mdc=C=Ke([Ve(0,a.$wM),Ve(1,u.$MM),Ve(2,n.$adc),Ve(3,f.$aj),Ve(4,s.$kdc)],C),e.$ndc=(0,p.$Sh)("IExtHostWorkspace");function B(H){let U,z;return H&&(typeof H=="string"?U=H:(U=H.pattern,z=o.URI.revive(H.baseUri))),{includePattern:U,folder:z}}}),define(Ae[36],Re([1,0,26,5,35,3,7,191,56,16,12,4,17,15,2]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=e.$pdc=e.$odc=void 0;function f(s,c){if(c){const h=c.split(".");let w=s;for(let m=0;w&&m<h.length;m++)w=w[h[m]];return w}}function t(s){return s instanceof p.URI}function i(s){return s&&s.uri instanceof p.URI&&s.languageId&&typeof s.languageId=="string"}function n(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function u(s){return s&&s.uri instanceof p.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function a(s){if(t(s))return{resource:s};if(i(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(n(s))return{overrideIdentifier:s.languageId};if(u(s))return{resource:s.uri};if(s===null)return{resource:null}}let l=class{constructor(c,h,w){this.a=c.getProxy(M.$uK.MainThreadConfiguration),this.c=h,this.b=w,this.d=new A.$Tg,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new r(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,h){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(c,h))}};e.$odc=l,e.$odc=l=Ke([Ve(0,o.$wM),Ve(1,P.$ndc),Ve(2,v.$aj)],l);class r{constructor(c,h,w,m){this.a=new L.$Od,this.b=c,this.f=m,this.c=h,this.e=$.$Hn.parse(w),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,h){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Hn.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(h,w))}getConfiguration(c,h,w){const m=a(h)||{},I=this.g(c?f(this.e.getValue(void 0,m,this.c.workspace),c):this.e.getValue(void 0,m,this.c.workspace));c&&this.h(c,m,w?.identifier);function k(b){if(b==null)return null;if(typeof b=="boolean")return b?2:5;switch(b){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const d={has(b){return typeof f(I,b)<"u"},get:(b,y)=>{this.h(c?`${c}.${b}`:b,m,w?.identifier);let C=f(I,b);if(typeof C>"u")C=y;else{let B;const H=(U,z)=>{if((0,g.$Bf)(U)){let F;const N=()=>{B=B||(0,E.$0m)(I),F=F||f(B,z)};return new Proxy(U,{get:(X,Q)=>{if(typeof Q=="string"&&Q.toLowerCase()==="tojson")return N(),()=>F;if(B)return F=F||f(B,z),F[Q];const De=X[Q];return typeof Q=="string"?H(De,`${z}.${Q}`):De},set:(X,Q,De)=>(N(),F&&(F[Q]=De),!0),deleteProperty:(X,Q)=>(N(),F&&delete F[Q],!0),defineProperty:(X,Q,De)=>(N(),F&&Object.defineProperty(F,Q,De),!0)})}return Array.isArray(U)?(0,E.$0m)(U):U};C=H(C,b)}return C},update:(b,y,C,B)=>{b=c?`${c}.${b}`:b;const H=k(C);return y!==void 0?this.b.$updateConfigurationOption(H,b,y,m,B):this.b.$removeConfigurationOption(H,b,m,B)},inspect:b=>{b=c?`${c}.${b}`:b;const y=this.e.inspect(b,m,this.c.workspace);if(y)return{key:b,defaultValue:(0,E.$0m)(y.policy?.value??y.default?.value),globalValue:(0,E.$0m)(y.user?.value??y.application?.value),workspaceValue:(0,E.$0m)(y.workspace?.value),workspaceFolderValue:(0,E.$0m)(y.workspaceFolder?.value),defaultLanguageValue:(0,E.$0m)(y.default?.override),globalLanguageValue:(0,E.$0m)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,E.$0m)(y.workspace?.override),workspaceFolderLanguageValue:(0,E.$0m)(y.workspaceFolder?.override),languageIds:(0,E.$0m)(y.overrideIdentifiers)}}};return typeof I=="object"&&(0,E.$an)(d,I,!1),Object.freeze(d)}g(c){const h=w=>(0,g.$Bf)(w)?new Proxy(w,{get:(m,I)=>h(m[I]),set:(m,I,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(m,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(m,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return h(c)}h(c,h,w){const m=D.$yn.test(c)?4:this.d.get(c),I=w?`[${w.value}] `:"";if(m===4){typeof h?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){h?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,h){const w=new $.$Jn(c,h,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,I)=>w.affectsConfiguration(m,a(I))})}k(c){return c.reduce((h,w)=>(h.set(w[0],w[1]),h),new Map)}}e.$pdc=r,e.$qdc=(0,S.$Sh)("IExtHostConfiguration")}),define(Ae[115],Re([1,0,2,12,5,3,7,35,62,36,20,65,17,27,4,14,21,15,81,230,11]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=e.$nec=e.$mec=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(H){function U(F){if(F!=null)return F}H.from=U;function z(F){if(F!=null)return F}H.to=z})(l||(l={}));var r;(function(H){function U(F){if(F!=null)return F}H.from=U;function z(F){if(F!=null)return F}H.to=z})(r||(r={}));var s;(function(H){function U(F){if(F!=null)return F}H.from=U;function z(F){if(F!=null)return F}H.to=z})(s||(s={}));var c;(function(H){function U(N){if(N){const X=N;return X&&!!X.process}else return!1}H.is=U;function z(N){if(N==null)return;const X={process:N.process,args:N.args};return N.options&&(X.options=s.from(N.options)),X}H.from=z;function F(N){if(N!=null)return new R.$eL(N.process,N.args,N.options)}H.to=F})(c||(c={}));var h;(function(H){function U(F){if(F!=null)return F}H.from=U;function z(F){if(F!=null)return F}H.to=z})(h||(h={}));var w;(function(H){function U(N){if(N){const X=N;return X&&(!!X.commandLine||!!X.command)}else return!1}H.is=U;function z(N){if(N==null)return;const X={};return N.commandLine!==void 0?X.commandLine=N.commandLine:(X.command=N.command,X.args=N.args),N.options&&(X.options=h.from(N.options)),X}H.from=z;function F(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new R.$fL(N.commandLine,N.options):new R.$fL(N.command,N.args?N.args:[],N.options)}H.to=F})(w||(w={}));var m;(function(H){function U(N){if(N){const X=N;return X&&X.customExecution==="customExecution"}else return!1}H.is=U;function z(N){return{customExecution:"customExecution"}}H.from=z;function F(N,X){return X.get(N)}H.to=F})(m||(e.CustomExecutionDTO=m={}));var I;(function(H){function U(z,F){let N;return z.scope!==void 0&&typeof z.scope!="number"?N=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&F&&F.workspaceFile?N=F.workspaceFile:N=u.$6F),{id:z._id,workspaceFolder:N}}H.from=U})(I||(e.TaskHandleDTO=I={}));var k;(function(H){function U(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}H.from=U})(k||(k={}));var d;(function(H){function U(N,X){if(N==null)return[];const Q=[];for(const De of N){const ke=z(De,X);ke&&Q.push(ke)}return Q}H.fromMany=U;function z(N,X){if(N==null)return;let Q;N.execution instanceof R.$eL?Q=c.from(N.execution):N.execution instanceof R.$fL?Q=w.from(N.execution):N.execution&&N.execution instanceof R.$gL&&(Q=m.from(N.execution));const De=l.from(N.definition);let ke;return N.scope?typeof N.scope=="number"?ke=N.scope:ke=N.scope.uri:ke=R.TaskScope.Workspace,!De||!ke?void 0:{_id:N._id,definition:De,name:N.name,source:{extensionId:X.identifier.value,label:N.source,scope:ke},execution:Q,isBackground:N.isBackground,group:k.from(N.group),presentationOptions:r.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}H.from=z;async function F(N,X,Q){if(N==null)return;let De;c.is(N.execution)?De=c.to(N.execution):w.is(N.execution)?De=w.to(N.execution):m.is(N.execution)&&(De=m.to(N._id,Q));const ke=l.to(N.definition);let Pe;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Pe=N.source.scope:Pe=await X.resolveWorkspaceFolder(E.URI.revive(N.source.scope)):Pe=R.TaskScope.Workspace),!ke||!Pe)return;const fe=new R.$hL(ke,Pe,N.name,N.source.label,De,N.problemMatchers);return N.isBackground!==void 0&&(fe.isBackground=N.isBackground),N.group!==void 0&&(fe.group=R.$dL.from(N.group._id),fe.group&&N.group.isDefault&&(fe.group=new R.$dL(fe.group.id,fe.group.label),N.group.isDefault===!0&&(fe.group.isDefault=N.group.isDefault))),N.presentationOptions&&(fe.presentationOptions=r.to(N.presentationOptions)),N._id&&(fe._id=N._id),N.detail&&(fe.detail=N.detail),fe}H.to=F})(d||(e.TaskDTO=d={}));var b;(function(H){function U(F){return F}H.from=U;function z(F){if(F)return Object.assign(Object.create(null),F)}H.to=z})(b||(b={}));class y{#e;constructor(U,z,F){this._id=z,this.a=F,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let C=class{constructor(U,z,F,N,X,Q,De,ke){this.q=new P.$Od,this.r=new P.$Od,this.s=new P.$Od,this.t=new P.$Od,this.a=U.getProxy(M.$uK.MainThreadTask),this.b=F,this.c=N,this.d=X,this.e=Q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=De,this.g=ke,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,z,F){if(!F)return new R.$wK(()=>{});const N=this.w();return this.j.set(N,{type:z,provider:F,extension:U}),this.a.$registerTaskProvider(N,z),new R.$wK(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(U,z){this.a.$registerTaskSystem(U,z)}fetchTasks(U){return this.a.$fetchTasks(b.from(U)).then(async z=>{const F=[];for(const N of z){const X=await d.to(N,this.b,this.m);X&&F.push(X)}return F})}get taskExecutions(){const U=[];return this.k.forEach(z=>U.push(z)),U}terminateTask(U){if(!(U instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,z,F){const N=this.m.get(U.id);N&&(this.o.set(U.id,N),this.e.attachPtyToTerminal(z,await N.callback(F))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const z=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const z=await this.y(U.id);this.s.fire({execution:z,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const z=await this.y(U.id);this.t.fire({execution:z,exitCode:U.exitCode})}$provideTasks(U,z){const F=this.j.get(U);if(!F)return Promise.reject(new Error("no handler found"));const N=[],X=(0,L.$Ng)(()=>F.provider.provideTasks(A.CancellationToken.None)).then(Q=>this.u(z,N,F,Q));return new Promise(Q=>{X.then(De=>{Promise.all(N).then(()=>{Q(De)})})})}async $resolveTask(U,z){const F=this.j.get(U);if(!F)return Promise.reject(new Error("no handler found"));if(z.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${F.type}].`);const N=await d.to(z,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const X=await F.provider.resolveTask(N,A.CancellationToken.None);if(!X)return;this.z(X,F);const Q=d.from(X,F.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(X.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(Q.execution)&&await this.x(Q,X,!0),await this.v(Q)}w(){return this.h++}async x(U,z,F){const N=await this.a.$createTaskId(U);!F&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,z.execution)),this.m.set(N,z.execution)}async y(U,z){if(typeof U=="string"){const X=this.l.get(U);if(!X)throw new a.$ab("Unexpected: The specified task is missing an execution");return X}const F=this.l.get(U.id);if(F)return F;const N=new Promise((X,Q)=>{function De(ke,Pe,fe){fe?X(new y(ke,Pe.id,fe)):Q("Unexpected: Task does not exist.")}z?De(this,U,z):d.to(U.task,this.b,this.m).then(ke=>De(this,U,ke))});return this.l.set(U.id,N),N.then(X=>(this.k.set(U.id,X),X),X=>Promise.reject(X))}z(U,z){U._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const F=this.n.values();let N=F.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=F.next()}};e.$mec=C,e.$mec=C=Ke([Ve(0,o.$wM),Ve(1,v.$MM),Ve(2,$.$ndc),Ve(3,D.$HM),Ve(4,g.$qdc),Ve(5,S.$Idc),Ve(6,i.$aj),Ve(7,n.$ddc)],C);let B=class extends C{constructor(U,z,F,N,X,Q,De,ke){super(U,z,F,N,X,Q,De,ke),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(U,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const F=d.from(z,U);if(F===void 0)throw new Error("Task is not valid");if(m.is(F.execution))await this.x(F,z,!1);else throw new a.$$;const N=await this.y(await this.a.$getTaskExecution(F),z);return this.a.$executeTask(F).catch(X=>{throw new Error(X)}),N}u(U,z,F,N){const X=[];if(N)for(const Q of N){this.z(Q,F),(!Q.definition||!U[Q.definition.type])&&this.f.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const De=d.from(Q,F.extension);De&&m.is(De.execution)?(X.push(De),z.push(this.x(De,Q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:X,extension:F.extension}}async v(U){if(m.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,z,F){}};e.$nec=B,e.$nec=B=Ke([Ve(0,o.$wM),Ve(1,v.$MM),Ve(2,$.$ndc),Ve(3,D.$HM),Ve(4,g.$qdc),Ve(5,S.$Idc),Ve(6,i.$aj),Ve(7,n.$ddc)],B),e.$oec=(0,p.$Sh)("IExtHostTask")}),define(Ae[284],Re([1,0,43,29]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sK=e.$rK=e.$qK=void 0;function P(R){return"cellResults"in R}e.$qK=P,e.$rK="rawCell#";function M(R,$){let D=-1;const g=[];let A=[];return R.forEach(o=>{o.range.startLineNumber!==D&&A.length>0&&(g.push([...A]),A=[]),A.push(o),D=o.range.endLineNumber}),A.length>0&&g.push([...A]),g.map(o=>{const v=[],p=o[0].range.startLineNumber,f=o[o.length-1].range.endLineNumber;for(let t=p;t<=f;t++)v.push($.getLineContent(t));return new E.$XI(v.join(`
`)+`
`,o.map(t=>new L.$ws(t.range.startLineNumber-1,t.range.startColumn-1,t.range.endLineNumber-1,t.range.endColumn-1)))})}e.$sK=M}),define(Ae[285],Re([1,0,163,24,5,6,28,13,16,2,41,75,3,32,8,7,49,222,107,11,26,14,213,284,282]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=void 0;class h{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,I,k,d,b,y){this.q=k,this.r=d,this.s=b,this.t=y,this.f=new Map,this.g=new R.$zc,this.h=new Map,this.j=new P.$Od({onListenerError:u.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$Od({onListenerError:u.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$Od({onListenerError:u.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$Od({onListenerError:u.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$0cc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=m.getProxy(o.$uK.MainThreadNotebook),this.c=m.getProxy(o.$uK.MainThreadNotebookDocuments),this.d=m.getProxy(o.$uK.MainThreadNotebookEditors),this.i=I.converter,I.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===13){const B=C.notebookEditor?.notebookUri,H=C.cell.handle,z=this.g.get(B)?.getCell(H);if(z)return z.apiCell}if(C&&C.$mid===14){const B=C.uri,H=this.g.get(B);if(H)return H.apiNotebook}return C}}),h.B(I)}getEditorById(m){const I=this.h.get(m);if(!I)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return I}getIdByEditor(m){for(const[I,k]of this.h)if(k.apiEditor===m)return I}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,I){const k=this.g.get(m);if(!k&&!I)throw new Error(`NO notebook document for '${m}'`);return k}static u(m,I){if(!I)return;const k=I.filenamePattern.map(d=>p.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(I.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${I.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:I.displayName,filenamePattern:k,exclusive:I.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,I,k){const d=h.a++,b=typeof k.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(d,k),this.b.$registerNotebookCellStatusBarItemProvider(d,b,I);let y;return b!==void 0&&(y=k.onDidChangeCellStatusBarItems(C=>this.b.$emitCellStatusBarEvent(b))),new f.$wK(()=>{this.f.delete(d),this.b.$unregisterNotebookCellStatusBarItemProvider(d,b),y?.dispose()})}async createNotebookDocument(m){const I=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&p.NotebookData.from(m.content)});return g.URI.revive(I)}async openNotebookDocument(m){const I=this.g.get(m);if(I)return I.apiNotebook;const k=await this.c.$tryOpenNotebook(m),d=this.g.get(g.URI.revive(k));return(0,D.$Kf)(d?.apiNotebook)}async showNotebookDocument(m,I){g.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let k;typeof I=="object"?k={position:p.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selections:I.selections&&I.selections.map(p.NotebookRange.from),pinned:typeof I.preview=="boolean"?!I.preview:void 0}:k={preserveFocus:!1};const d=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,k),b=d&&this.h.get(d)?.apiEditor;if(b)return b;throw d?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,I,k,d){const b=this.f.get(m),y=g.URI.revive(I),C=this.g.get(y);if(!C||!b)return;const B=C.getCellFromIndex(k);if(!B)return;const H=await b.provideCellStatusBarItems(B.apiCell,d);if(!H)return;const U=new M.$Qc,z=this.p.add([U]),N=(Array.isArray(H)?H:[H]).map(X=>p.NotebookStatusBarItem.from(X,this.i,U));return{cacheId:z,items:N}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,I,k,d,b){if((0,$.$Ce)(I))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:I,serializer:k,options:d}),this.b.$registerNotebookSerializer(y,{id:m.identifier,location:m.extensionLocation},I,p.NotebookDocumentContentOptions.from(d),h.u(m,b)),(0,M.$Pc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(m,I,k){const d=this.x.get(m);if(!d)throw new Error("NO serializer found");const b=await d.serializer.deserializeNotebook(I.buffer,k);return new t.$tv(p.NotebookData.from(b))}async $notebookToData(m,I,k){const d=this.x.get(m);if(!d)throw new Error("NO serializer found");const b=await d.serializer.serializeNotebook(p.NotebookData.to(I.value),k);return L.$ce.wrap(b)}async $saveNotebook(m,I,k,d,b){const y=g.URI.revive(I),C=this.x.get(m);if(!C)throw new Error("NO serializer found");const B=this.g.get(y);if(!B)throw new Error("Document NOT found");if(B.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new A.$wk((0,E.localize)(0,null,this.z(y)),6);await this.y(y,d);const H={metadata:(0,a.$fn)(B.apiNotebook.metadata,X=>!(C.options?.transientDocumentMetadata??{})[X]),cells:[]};for(const X of B.apiNotebook.getCells()){const Q=new f.$UL(X.kind,X.document.getText(),X.document.languageId,X.mime,C.options?.transientOutputs?[]:[...X.outputs],X.metadata,X.executionSummary);Q.metadata=(0,a.$fn)(X.metadata,De=>!(C.options?.transientCellMetadata??{})[De]),H.cells.push(Q)}const U=await C.serializer.serializeNotebook(H,b);await this.s.value.writeFile(y,U);const z=this.s.getFileSystemProviderExtUri(y.scheme),F=await this.s.value.stat(y);return{name:z.basename(y),isFile:(F.type&A.FileType.File)!==0,isDirectory:(F.type&A.FileType.Directory)!==0,isSymbolicLink:(F.type&A.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((F.permissions??0)&A.FilePermission.Locked),etag:A.$Hk({mtime:F.mtime,size:F.size}),children:void 0}}async $searchInNotebooks(m,I,k,d,b){const y=this.x.get(m)?.serializer;if(!y)return{limitHit:!1,results:[]};const C=new R.$Ac;await(async(F,N,X)=>{await Promise.all(F.map(async Q=>await Promise.all(Q.filenamePatterns.map(De=>{const ke={...X,type:1,filePattern:De};return this.t.doInternalFileSearchWithCustomCallback(ke,N,Pe=>{Pe.forEach(fe=>{C.has(fe)||d.some(ne=>Q.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(re=>(0,c.$vcb)(re,fe)))||C.add(fe)})})}))))})(k,b,I);const H=new R.$zc;let U=!1;const z=Array.from(C).map(async F=>{const N=[];try{if(b.isCancellationRequested)return;if(I.maxResults&&[...H.values()].reduce((ke,Pe)=>ke+Pe.cellResults.length,0)>I.maxResults){U=!0;return}const X=[],Q=this.g.get(F);if(Q)Q.apiNotebook.getCells().forEach(Pe=>X.push({input:Pe.document.getText(),outputs:Pe.outputs.flatMap(fe=>fe.items.map(we=>we.data.toString()))}));else{const ke=await this.s.value.readFile(F),Pe=L.$ce.fromString(ke.toString()),fe=await y.deserializeNotebook(Pe.buffer,b);if(b.isCancellationRequested)return;p.NotebookData.from(fe).cells.forEach(ne=>X.push({input:ne.source,outputs:ne.outputs.flatMap(re=>re.items.map(pe=>pe.valueBytes.toString()))}))}if(b.isCancellationRequested)return;X.forEach((ke,Pe)=>{const fe=I.contentPattern.pattern,we=new r.$DOb(ke.input,void 0,ke.outputs),ne=we.findInInputs(fe),re=we.findInOutputs(fe),pe=re.flatMap(_=>(0,s.$sK)(_.matches,_.textBuffer)).map((_,W)=>(_.webviewIndex=W,_));if(ne.length>0||re.length>0){const _={index:Pe,contentResults:(0,s.$sK)(ne,we.inputTextBuffer),webviewResults:pe};N.push(_)}});const De={resource:F,cellResults:N};H.set(F,De);return}catch{return}});return await Promise.all(z),{limitHit:U,results:[...H.values()]}}async y(m,I){const k=await this.s.value.stat(m);if(typeof I?.mtime=="number"&&typeof I.etag=="string"&&I.etag!==A.$Gk&&typeof k.mtime=="number"&&typeof k.size=="number"&&I.mtime<k.mtime&&I.etag!==A.$Hk({mtime:I.mtime,size:k.size}))throw new A.$wk((0,E.localize)(1,null),3,I)}z(m){return m.scheme===l.Schemas.file?m.fsPath:m.toString()}A(m,I,k){if(this.h.has(I))throw new Error(`editor with id ALREADY EXSIST: ${I}`);const d=new n.$Iec(I,this.d,m,k.visibleRanges.map(p.NotebookRange.to),k.selections.map(p.NotebookRange.to),typeof k.viewColumn=="number"?p.ViewColumn.to(k.viewColumn):void 0);this.h.set(I,d)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const k of m.value.removedDocuments){const d=g.URI.revive(k),b=this.g.get(d);b&&(b.dispose(),this.g.delete(d),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(b.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===d.toString()&&this.h.delete(y.id)}if(m.value.addedDocuments){const k=[];for(const d of m.value.addedDocuments){const b=g.URI.revive(d.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const y=new i.$Hec(this.c,this.q,this.r,b,d);k.push(...d.cells.map(C=>i.$Gec.asModelAddData(y.apiNotebook,C))),this.g.get(b)?.dispose(),this.g.set(b,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(y.apiNotebook)}}if(m.value.addedEditors)for(const k of m.value.addedEditors){if(this.h.has(k.id))return;const d=g.URI.revive(k.documentUri),b=this.g.get(d);b&&this.A(b,k.id,k)}const I=[];if(m.value.removedEditors)for(const k of m.value.removedEditors){const d=this.h.get(k);d&&(this.h.delete(k),this.k?.id===d.id&&(this.k=void 0),I.push(d))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(d=>this.h.get(d)).filter(d=>!!d);const k=new Set;this.l.forEach(d=>k.add(d.id));for(const d of this.h.values()){const b=k.has(d.id);d._acceptVisibility(b)}this.l=[...this.h.values()].map(d=>d).filter(d=>d.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.h.get(m.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${m.value.newActiveEditor}`),this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(m){const I=v.$UM.String.with("notebookType","A notebook type"),k=new v.$WM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[I,new v.$UM("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>L.$ce.wrap(b))],new v.$VM("Notebook Data",b=>p.NotebookData.to(b.value))),d=new v.$WM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[I,new v.$UM("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new t.$tv(p.NotebookData.from(b)))],new v.$VM("Bytes",b=>b.buffer));m.registerApiCommand(k),m.registerApiCommand(d)}}e.$Jec=h}),define(Ae[286],Re([1,0,19,20,39,33,25,50,43]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;class g{constructor(o,v,p){this.k=o,this.l=v,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=o.filePattern,this.b=o.includePattern&&M.$zj(o.includePattern),this.c=o.maxResults||void 0,this.d=o.exists,this.h=new Set,this.j=o.excludePattern&&M.$zj(o.excludePattern)}cancel(){this.g=!0,this.h.forEach(o=>o.cancel()),this.h=new Set}search(o){const v=this.k.folderQueries||[];return new Promise((p,f)=>{const t=i=>{this.f++,o(i)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const n=i.toString(),u=E.$mc(n);this.j&&this.j(n,u)||this.v(t,{base:i,basename:u})}),Promise.all(v.map(i=>this.p(i,t))).then(i=>{p({limitHit:this.e,stats:i[0]||void 0})},i=>{f(new Error((0,P.$Di)(i)))})})}async p(o,v){const p=new L.$Yd,f=this.q(o),t=this.r(),i=new D.$_I(this.k,o),n=!i.hasSiblingExcludeClauses();let u;try{this.h.add(p),u=$.$Kd.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,p.token),l=u.elapsed(),r=$.$Kd.create();return this.g&&!this.e||(a&&a.forEach(s=>{const c=E.$fc.relative(o.folder.path,s.path);if(n){const h=E.$mc(s.path);this.v(v,{base:o.folder,relativePath:c,basename:h});return}this.s(t,o.folder,c,v)}),this.g&&!this.e)?null:(this.u(t,i,v),{providerTime:l,postProcessTime:r.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(o){const v=(0,D.$$I)(this.k.includePattern,o.includePattern),p=(0,D.$$I)(this.k.excludePattern,o.excludePattern);return{folder:o.folder,excludes:p,includes:v,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!o.disregardParentIgnoreFiles,followSymlinks:!o.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}s({pathToEntries:o},v,p,f){if(p===this.a){const i=E.$mc(this.a);this.v(f,{base:v,relativePath:this.a,basename:i})}function t(i){const n=E.$mc(i),u=E.$lc(i);let a=o[u];a||(a=o[u]=[],t(u)),a.push({base:v,relativePath:i,basename:n})}t(p)}u({rootEntries:o,pathToEntries:v},p,f){const t=this,i=this.a;function n(u){const a=(0,D.$bJ)(()=>u.map(l=>l.basename));for(let l=0,r=u.length;l<r;l++){const s=u[l],{relativePath:c,basename:h}=s;if(p.matchesExcludesSync(c,h,i!==h?a:void 0))continue;const w=v[c];if(w)n(w);else{if(c===i)continue;t.v(f,s)}if(t.e)break}}n(o)}v(o,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||o(v))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(o,v,p,f){const t=this.c(o.cacheKey),i=new g(o,v,t&&t.token);let n=0;const u=a=>{n+=a.length,p(a.map(l=>this.d(l)))};return this.e(i,A.a,u,f).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:a.stats}}))}clearCache(o){this.c(o)?.cancel()}c(o){if(o)return this.b.has(o)||this.b.set(o,new L.$Yd),this.b.get(o)}d(o){return o.relativePath?{resource:R.$wg(o.base,o.relativePath)}:{resource:o.base}}e(o,v,p,f){const t=f.onCancellationRequested(()=>{o.cancel()}),i=u=>{u&&(n.push(u),v>0&&n.length>=v&&(p(n),n=[]))};let n=[];return o.search(i).then(u=>(n.length&&p(n),t.dispose(),u),u=>(n.length&&p(n),t.dispose(),Promise.reject(u)))}}e.$yec=A}),define(Ae[287],Re([1,0,18,248,33,94,28,14,19,25,13,16,2,93,181,40,15,47,105,283,43]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9J=e.$8J=void 0;let l=class{constructor(b,y,C,B,H){this.a=b,this.b=y,this.c=C,this.d=B,this.e=H}text(b,y,C={}){b=this.f(b,C);const B=this.a.getValue(),H=y&&y.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(y?.map(i.$bi),C),type:2,contentPattern:b,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:B.search.usePCRE2||H||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(b,y){const C=this.a.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const B={...b,wordSeparators:C.editor.wordSeparators};return this.j(b,y)&&(B.isCaseSensitive=!0),this.k(b)&&(B.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),B}file(b,y={}){return{...this.h(b,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}g(b,y){return b?(b=Array.isArray(b)?b.map(w):w(b),y?this.parseSearchPaths(b):{pattern:s(...Array.isArray(b)?b:[b])}):{}}h(b=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),B=this.g(y.excludePattern,y.expandPatterns),H=b.length>1,U=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(N=>this.q(N,y,B)):b.map(N=>this.r(N,y,B,H))).filter(N=>!!N),z={_reason:y._reason,folderQueries:U,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:B.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const N=E.$Gb(E.$Qb(this.c.groups.map(De=>De.editors.map(ke=>ke.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const X=N.filter(De=>(0,a.$2I)(z,De.fsPath)),Q=this.i(X);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Q)),{...z,...Q}}const F=y.extraFileResources&&y.extraFileResources.filter(N=>(0,a.$2I)(z,N.fsPath));return z.extraFileResources=F&&F.length?F:void 0,z}i(b){const y=[],C=new R.$zc,B={};let H=!1;return b.forEach(U=>{if(U.scheme===$.Schemas.walkThrough)return;if((0,g.$Ag)(U)){const F=this.b.getWorkspaceFolder(U)?.uri??U.with({path:D.$lc(U.fsPath)});let N=C.get(F);N||(H=!0,N={folder:F,includePattern:{}},y.push(N),C.set(F,N));const X=D.$kc(F.fsPath,U.fsPath);(0,S.$Kf)(N.includePattern)[X.replace(/\\/g,"/")]=!0}else U.fsPath&&(H=!0,B[U.fsPath]=!0)}),{folderQueries:y,includePattern:B,usingSearchPaths:!0,excludePattern:H?void 0:{"**/*":!0}}}j(b,y){if(y.isSmartCase){if(b.isRegExp){if(A.$qf(b.pattern,!0))return!0}else if(A.$qf(b.pattern))return!0}return!!b.isCaseSensitive}k(b){return b.isMultiline||b.isRegExp&&(0,v.$yB)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const y=Q=>D.$hc(Q)||/^\.\.?([\/\\]|$)/.test(Q),B=(Array.isArray(b)?b:c(b)).map(Q=>{const De=this.e.resolvedUserHome;return De?(0,M.$xv)(Q,De.scheme===$.Schemas.file?De.fsPath:De.path):Q}),H=L.$J(B,Q=>y(Q)?"searchPaths":"exprSegments"),U=(H.exprSegments||[]).map(Q=>A.$Le(Q,"/")).map(Q=>A.$Le(Q,"\\")).map(Q=>(Q[0]==="."&&(Q="*"+Q),h(Q))),z={},F=this.m(H.searchPaths||[]);F&&F.length&&(z.searchPaths=F);const N=E.$Qb(U),X=s(...N);return X&&(z.pattern=X),z}l(b,y){return y.disregardExcludeSettings?void 0:(0,a.$1I)(b,!y.disregardSearchExcludeSettings)}m(b){if(!b||!b.length)return[];const y=b.flatMap(B=>{let{pathPortion:H,globPortion:U}=r(B);return U&&(U=m(U)),this.n(H).flatMap(F=>this.o(F,U))}),C=new Map;return y.forEach(B=>{const H=B.searchPath.toString(),U=C.get(H);U?B.pattern&&(U.pattern=U.pattern||{},U.pattern[B.pattern]=!0):C.set(H,{searchPath:B.searchPath,pattern:B.pattern?s(B.pattern):void 0})}),Array.from(C.values())}n(b){if(D.$hc(b)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==$.Schemas.file?[{searchPath:y[0].uri.with({path:b})}]:[{searchPath:o.URI.file(D.$gc(b))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(b=w(b),b.startsWith("../")||b===".."){const B=D.$fc.resolve(y.path,b);return[{searchPath:y.with({path:B})}]}const C=m(b);return[{searchPath:y,pattern:C}]}else{if(b==="./"||b===".\\")return[];{const y=b.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(H=>{const U=y.match(new RegExp(`^${A.$Ge(H.name)}(?:/(.*)|$)`));return U?{match:U,folder:H}:null}).filter(S.$Hf);if(B.length)return B.map(H=>{const U=H.match[1];return{searchPath:H.folder.uri,pattern:U&&m(U)}});{const H=b.match(/\.[\/\\](.+)[\/\\]?/),U=H?H[1]:b,z=p.localize(0,null,U);throw new Error(z)}}}}o(b,y){const C=b.pattern&&y?`${b.pattern}/${y}`:b.pattern||y,B=[{searchPath:b.searchPath,pattern:C}];return C&&!C.endsWith("**")&&B.push({searchPath:b.searchPath,pattern:C+"/**"}),B}q(b,y,C){const B=this.r((0,i.$bi)(b.searchPath),y,C,!1);return B?{...B,includePattern:b.pattern}:null}r(b,y,C,B){let H;const U=o.URI.isUri(b)?b:b.uri;if(C.searchPaths){const Q=C.searchPaths.filter(De=>(0,g.$pg)(De.searchPath,U))[0];if(Q&&!Q.pattern)return null;Q&&(H=Q.pattern)}const z=this.a.getValue({resource:U}),N={...this.l(z,y)||{},...H||{}},X=o.URI.isUri(b)?(0,g.$tg)(b):b.name;return{folder:U,folderName:B?X:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!z.search.followSymlinks}}};e.$8J=l,e.$8J=l=Ke([Ve(0,f.$mi),Ve(1,i.$2h),Ve(2,n.$CC),Ve(3,t.$aj),Ve(4,u.$6J)],l);function r(d){const b=d.match(/[\*\{\}\(\)\[\]\?]/);if(b){const y=b.index,C=d.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let B=d.substr(0,C.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:d.substr((C.index||0)+1)}}}return{pathPortion:d}}function s(...d){return d.length?d.reduce((b,y)=>(b[y]=!0,b),Object.create(null)):void 0}function c(d){return P.$xj(d,",").map(b=>b.trim()).filter(b=>!!b.length)}function h(d){return[`**/${d}/**`,`**/${d}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function w(d){return d.replace(/\\/g,"/")}function m(d){return w(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(d){return d.replace(/([?*[\]])/g,"[$1]")}function k(d,b){d=E.$Lb(d,B=>B.toString());const y=[],C=b.getWorkspace();return d&&d.forEach(B=>{let H;if(b.getWorkbenchState()===2)H=(0,g.$yg)(C.folders[0].uri,B),H&&H!=="."&&(H="./"+H);else{const U=b.getWorkspaceFolder(B);if(U){const z=U.name;if(C.folders.filter(N=>N.name===z).length===1){const N=(0,g.$yg)(U.uri,B);N===""?H=`./${U.name}`:H=`./${U.name}/${N}`}else H=B.fsPath}}H&&y.push(I(H))}),y}e.$9J=k}),define(Ae[288],Re([1,0,25,2,20,11,4,287,43,47]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qb=e.$1qb=void 0;const A=7e3;function S(f,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],u=[];for(const h of i)if(/^workspaceContains:/.test(h)){const w=h.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||f.forceUsingSearch?u.push(w):n.push(w)}if(n.length===0&&u.length===0)return Promise.resolve(void 0);let a;const l=new Promise((h,w)=>{a=h}),r=h=>a({activationEvent:h}),s=Promise.all(n.map(h=>o(f,h,r))).then(()=>{}),c=v(f,t.identifier,u,r);return Promise.all([s,c]).then(()=>{a(void 0)}),l}e.$1qb=S;async function o(f,t,i){for(const n of f.folders)if(await f.exists(E.$wg(L.URI.revive(n),t))){i(`workspaceContains:${t}`);return}}async function v(f,t,i,n){if(i.length===0)return Promise.resolve(void 0);const u=new P.$Yd,a=f.checkExists(f.folders,i,u.token),l=setTimeout(async()=>{u.cancel(),f.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},A);let r=!1;try{r=await a}catch(s){M.$3(s)||M.$Z(s)}u.dispose(),clearTimeout(l),r&&n(`workspaceContains:${i.join(",")}`)}function p(f,t,i,n){const u=f.get(R.$Rh),a=f.get(D.$SI),r=u.createInstance($.$8J).file(t.map(s=>(0,g.$bi)(L.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return a.fileSearch(r,n).then(s=>!!s.limitHit,s=>M.$3(s)?!1:Promise.reject(s))}e.$2qb=p}),define(Ae[37],Re([1,0,160,19,88,25,12,6,51,2,15,3,36,219,85,35,23,106,11,22,24,202,7,100,4,27,86,17,72,87,65,5,288,84,204,14,82,50,21,83]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c,h,w,m,I,k,d,b,y,C,B,H,U,z,F,N){"use strict";var X;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=e.$Wdc=e.$Vdc=e.$Udc=e.$Tdc=void 0,e.$Tdc=(0,c.$Sh)("IHostUtils");let Q=X=class extends $.$Rc{constructor(_,W,ce,be,se,he,ue,ye,ee,de,ie,ae){super(),this.X=ae,this.a=this.B(new b.$Od),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=W,this.g=ce,this.f=ue,this.j=be,this.m=se,this.s=he,this.t=ee,this.u=de,this.w=ie,this.y=this.g.getProxy(S.$uK.MainThreadWorkspace),this.z=this.g.getProxy(S.$uK.MainThreadTelemetry),this.C=this.g.getProxy(S.$uK.MainThreadExtensionService),this.D=new R.$Tg,this.F=new R.$Tg,this.G=new R.$Tg,this.H=new R.$Tg,this.I=new re(this.f.extensions.activationEvents),this.L=new i.$o5b(this.I,this.f.extensions.allExtensions);const me=new u.$0l(this.f.extensions.myExtensions);this.J=new i.$o5b(this.I,we(this.L,me)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Pe(this.J)}`)),this.M=new p.$Adc(this.g,this.s),this.N=new C.$Mdc(this.g),this.O=ye,this.h=_.createChild(new I.$Qh([p.$Bdc,this.M],[C.$Ndc,this.N])),this.P=this.B(new v.$zdc(this.J,this.L,{onExtensionActivationError:(Ce,T,V)=>{this.C.$onExtensionActivationError(Ce,n.$2(T),V)},actualActivateExtension:async(Ce,T)=>{if(i.$o5b.isHostExtension(Ce,this.J,this.L))return await this.C.$activateExtension(Ce,T),new v.$ydc;const V=this.J.getExtensionDescription(Ce);return this.db(V,T)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(_){n.$Z(_)}}async Y(){this.O.onWillDeactivateAll();let _=[];try{_=this.J.getAllExtensionDescriptions().map(se=>se.identifier).filter(se=>this.isActivated(se)).map(se=>this.cb(se))}catch{}await Promise.all(_)}terminate(_,W=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${_}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(be=>{this.s.error(be)}),this.g.dispose();const ce=this.Y();Promise.race([(0,R.$Vg)(5e3),ce]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(_){return this.G.isOpen()?this.P.isActivated(_):!1}async getExtension(_){const W=await this.C.$getExtension(_);return W&&{...W,identifier:new u.$9l(W.identifier.value),extensionLocation:g.URI.revive(W.extensionLocation)}}Z(_,W){return this.P.activateByEvent(_,W)}$(_,W){return this.P.activateById(_,W)}activateByIdWithErrors(_,W){return this.$(_,W).then(()=>{const ce=this.P.getActivatedExtension(_);if(ce.activationFailed)return Promise.reject(ce.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(_=>this.J)}getExtensionExports(_){if(this.G.isOpen())return this.P.getActivatedExtension(_).exports;try{return this.P.getActivatedExtension(_).exports}catch{return null}}async ab(_){if(_.scheme===H.Schemas.file&&this.c.fsRealpath){const W=await this.c.fsRealpath(_.fsPath);return g.URI.file(W)}return _}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(_=>new ne(_))),this.Q}async bb(_){const W=D.$Yh.forUris(ce=>M.$ng.ignorePathCasing(ce));return await Promise.all(_.map(async ce=>{if(this.ub(ce)){const be=await this.ab(ce.extensionLocation);W.set(be,ce)}})),W}cb(_){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(_))return W;const ce=this.P.getActivatedExtension(_);if(!ce)return W;try{typeof ce.module.deactivate=="function"&&(W=Promise.resolve(ce.module.deactivate()).then(void 0,be=>(this.s.error(be),Promise.resolve(void 0))))}catch(be){this.s.error(`An error occurred when deactivating the extension '${_.value}':`),this.s.error(be)}try{(0,$.$Mc)(ce.subscriptions)}catch(be){this.s.error(`An error occurred when deactivating the subscriptions for extension '${_.value}':`),this.s.error(be)}return W}async db(_,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(_.identifier):await this.C.$onWillActivateExtension(_.identifier),this.fb(_,W).then(ce=>{const be=ce.activationTimes;return this.C.$onDidActivateExtension(_.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,W),this.eb(_,W,"success",be),ce},ce=>{throw this.eb(_,W,"failure"),ce})}eb(_,W,ce,be){const se=ke(_,W);this.z.$publicLog2("extensionActivationTimes",{...se,...be||{},outcome:ce})}fb(_,W){const ce=ke(_,W);this.z.$publicLog2("activatePlugin",ce);const be=this.ub(_);if(!be)return Promise.resolve(new v.$xdc(v.$udc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${_.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${_.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const se=new v.$vdc(W.startup);return Promise.all([this.vb(_,(0,M.$wg)(_.extensionLocation,be),se),this.gb(_)]).then(he=>(P.mark(`code/extHost/willActivateExtension/${_.identifier.value}`),X.hb(this.s,_.identifier,he[0],he[1],se))).then(he=>(P.mark(`code/extHost/didActivateExtension/${_.identifier.value}`),he))}gb(_){const W=new l.$Ddc(_,this.M),ce=new l.$Cdc(_.identifier.value,!1,this.M),be=new B.$Odc(_,this.N),se=_.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,he=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${_.identifier.value}`),Promise.all([W.whenReady,ce.whenReady,this.O.whenReady]).then(()=>{const ue=this;let ye,ee;const de=(0,t.$tF)(_,"ipc")?this.f.messagePorts?.get(u.$9l.toKey(_.identifier)):void 0;return Object.freeze({globalState:W,workspaceState:ce,secrets:be,subscriptions:[],get extensionUri(){return _.extensionLocation},get extensionPath(){return _.extensionLocation.fsPath},asAbsolutePath(ie){return L.$ic(_.extensionLocation.fsPath,ie)},get storagePath(){return ue.O.workspaceValue(_)?.fsPath},get globalStoragePath(){return ue.O.globalValue(_).fsPath},get logPath(){return L.$ic(ue.f.logsLocation.fsPath,_.identifier.value)},get logUri(){return g.URI.joinPath(ue.f.logsLocation,_.identifier.value)},get storageUri(){return ue.O.workspaceValue(_)},get globalStorageUri(){return ue.O.globalValue(_)},get extensionMode(){return se},get extension(){return ye===void 0&&(ye=new fe(ue,_.identifier,_,he,!1)),ye},get extensionRuntime(){return(0,t.$uF)(_,"extensionRuntime"),ue.extensionRuntime},get environmentVariableCollection(){return ue.u.getEnvironmentVariableCollection(_)},get messagePassingProtocol(){if(!ee){if(!de)return;const ie=b.Event.buffer(b.Event.fromDOMEventEmitter(de,"message",ae=>ae.data));de.start(),ee={onDidReceiveMessage:ie,postMessage:de.postMessage.bind(de)}}return ee}})})}static hb(_,W,ce,be,se){return ce=ce||{activate:void 0,deactivate:void 0},this.ib(_,W,ce,be,se).then(he=>new v.$wdc(!1,null,se.build(),ce,he,be.subscriptions))}static ib(_,W,ce,be,se){if(typeof ce.activate=="function")try{se.activateCallStart(),_.trace(`ExtensionService#_callActivateOptional ${W.value}`);const he=typeof global=="object"?global:self,ue=ce.activate.apply(he,[be]);return se.activateCallStop(),se.activateResolveStart(),Promise.resolve(ue).then(ye=>(se.activateResolveStop(),ye))}catch(he){return Promise.reject(he)}else return Promise.resolve(ce)}jb(_,W){this.$(_.identifier,{startup:!1,extensionId:_.identifier,activationEvent:W}).then(void 0,ce=>{this.s.error(ce)})}kb(_,W=0){const be=Date.now();(0,F.$B)(()=>{for(let se=W;se<_.length;se+=1){const he=_[se];for(const ue of he.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-be>50){this.kb(_,se);break}else this.jb(he,ue)}})}lb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(_=>{const W=_.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ce=this.J.getAllExtensionDescriptions();if(W)this.kb(ce);else for(const be of ce)if(be.activationEvents)for(const se of be.activationEvents)se==="onStartupFinished"&&this.jb(be,se)})}mb(){const _=this.Z("*",!0).then(void 0,he=>{this.s.error(he)});this.B(this.j.onDidChangeWorkspace(he=>this.nb(he.added)));const W=this.j.workspace?this.j.workspace.folders:[],ce=this.nb(W),be=this.pb(),se=Promise.all([be,_,ce]).then(()=>{});return Promise.race([se,(0,R.$Vg)(1e4)]).then(()=>{this.lb()}),se}nb(_){return _.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.ob(_,W))).then(()=>{})}async ob(_,W){if(this.isActivated(W.identifier))return;const ce=!this.f.remote.isRemote&&!!this.f.remote.authority,be={logService:this.s,folders:_.map(he=>he.uri),forceUsingSearch:ce||!this.c.fsExists,exists:he=>this.c.fsExists(he.fsPath),checkExists:(he,ue,ye)=>this.y.$checkExists(he,ue,ye)},se=await(0,y.$1qb)(be,W);if(se)return this.$(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:se.activationEvent}).then(void 0,he=>this.s.error(he))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(_){throw console.error(_),_}}async qb(){const{extensionDevelopmentLocationURI:_,extensionTestsLocationURI:W}=this.f.environment;if(!_||!W)throw new Error(E.localize(0,null));const ce=await this.vb(null,W,new v.$vdc(!1));if(!ce||typeof ce.run!="function")throw new Error(E.localize(1,null,W.toString()));return new Promise((be,se)=>{const he=(ee,de)=>{ee?(F.$t&&this.s.error("Test runner called back with error",ee),se(ee)):(F.$t&&(de?this.s.info(`Test runner called back with ${de} failures.`):this.s.info("Test runner called back with successful outcome.")),be(typeof de=="number"&&de>0?1:0))},ue=(0,M.$kg)(W),ye=ce.run(ue,he);ye&&ye.then&&ye.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),be(0)}).catch(ee=>{F.$t&&this.s.error("Test runner finished with error",ee),se(ee instanceof Error&&ee.stack?ee.stack:String(ee))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Vg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(_,W){return this.R[_]=W,(0,$.$Pc)(()=>{delete this.R[_]})}async getRemoteExecServer(_){const{resolver:W}=await this.sb(_);return W?.resolveExecServer?.(_,{resolveAttempt:0})}async sb(_){const W=_.indexOf("+");if(W===-1)throw new r.$CK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ce=_.substr(0,W);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ce}`,!1),{authorityPrefix:ce,resolver:this.R[ce]}}async $resolveAuthority(_,W){const ce=z.$Kd.create(!1),be=()=>`[resolveAuthority(${(0,s.$Wk)(_)},${W})][${ce.elapsed()}ms] `,se=J=>this.s.info(`${be()}${J}`),he=J=>this.s.warn(`${be()}${J}`),ue=(J,q=void 0)=>this.s.error(`${be()}${J}`,q),ye=J=>{if(J instanceof r.$CK)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J},ee=async J=>{se(`activating resolver for ${J}...`);const{resolver:q,authorityPrefix:x}=await this.sb(J);if(!q)throw ue(`no resolver for ${x}`),new r.$CK(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:x,remoteAuthority:J}},de=_.split(/@|%40/g).reverse();se(`activating remote resolvers ${de.join(" -> ")}`);let ie;try{ie=await Promise.all(de.map(ee)).catch(async J=>{if(!(J instanceof r.$CK)||J._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw J;return he(`resolving nested authorities failed: ${J.message}`),[await ee(_)]})}catch(J){return ye(J)}const ae=new R.$6g;ae.cancelAndSet(()=>se("waiting..."),1e3);let me,Ce;for(const[J,{authorityPrefix:q,resolver:x,remoteAuthority:le}]of ie.entries())try{if(J===ie.length-1)se("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${q}`),me=await x.resolve(le,{resolveAttempt:W,execServer:Ce}),P.mark(`code/extHost/didResolveAuthorityOK/${q}`),se("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,r.$BK.isManagedResolvedAuthority(me)?me:void 0));else{if(se(`invoking resolveExecServer() for ${le}`),P.mark(`code/extHost/willResolveExecServer/${q}`),Ce=await x.resolveExecServer?.(le,{resolveAttempt:W,execServer:Ce}),!Ce)throw new r.$CK(`Exec server was not available for ${le}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Oe){return P.mark(`code/extHost/didResolveAuthorityError/${q}`),ue("returned an error",Oe),ae.dispose(),ye(Oe)}ae.dispose();const T={environmentTunnels:me.environmentTunnels,features:me.tunnelFeatures},V={extensionHostEnv:me.extensionHostEnv,isTrusted:me.isTrusted,authenticationSession:me.authenticationSessionForInitializingExtensions?{id:me.authenticationSessionForInitializingExtensions.id,providerId:me.authenticationSessionForInitializingExtensions.providerId}:void 0};se(`returned ${r.$BK.isManagedResolvedAuthority(me)?"managed authority":`${me.host}:${me.port}`}`);let G;if(r.$BK.isManagedResolvedAuthority(me)){const J=W;this.X.setFactory(J,me.makeConnection),G={authority:_,connectTo:new s.$Tk(J),connectionToken:me.connectionToken}}else G={authority:_,connectTo:new s.$Uk(me.host,me.port),connectionToken:me.connectionToken};return{type:"ok",value:{authority:G,options:V,tunnelInformation:T}}}async $getCanonicalURI(_,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Wk)(_)})`);const{resolver:ce}=await this.sb(_);if(!ce)return null;const be=g.URI.revive(W);if(typeof ce.getCanonicalURI>"u")return be;const se=await(0,R.$Ng)(()=>ce.getCanonicalURI(be));return se||be}$startExtensionHost(_){_.toAdd.forEach(be=>be.extensionLocation=g.URI.revive(be.extensionLocation));const{globalRegistry:W,myExtensions:ce}=De(this.I,this.L,this.J,_);return this.L.set(W.getAllExtensionDescriptions()),this.J.set(ce),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Pe(this.J)}`)),this.rb()}$activateByEvent(_,W){return W===1?this.D.wait().then(ce=>this.Z(_,!1)):this.G.wait().then(ce=>this.Z(_,!1))}async $activate(_,W){return await this.G.wait(),this.J.getExtensionDescription(_)?(await this.$(_,W),!0):!1}async $deltaExtensions(_){_.toAdd.forEach(he=>he.extensionLocation=g.URI.revive(he.extensionLocation));const{globalRegistry:W,myExtensions:ce}=De(this.I,this.L,this.J,_),be=await this.bb(ce);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(W.getAllExtensionDescriptions()),this.J.set(ce),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(_){return _}async $test_up(_){return _.byteLength}async $test_down(_){const W=a.$ce.alloc(_),ce=Math.random()%256;for(let be=0;be<_;be++)W.writeUInt8(ce,be);return W}async $updateRemoteConnectionData(_){this.W=_,this.a.fire()}};e.$Udc=Q,e.$Udc=Q=X=Ke([Ve(0,c.$Rh),Ve(1,e.$Tdc),Ve(2,m.$wM),Ve(3,f.$ndc),Ve(4,o.$qdc),Ve(5,A.$aj),Ve(6,h.$MM),Ve(7,w.$Gdc),Ve(8,k.$Mwb),Ve(9,d.$Idc),Ve(10,U.$Qdc),Ve(11,N.$Rdc)],Q);function De(pe,_,W,ce){pe.addActivationEvents(ce.addActivationEvents);const be=new i.$o5b(pe,_.getAllExtensionDescriptions());be.deltaExtensions(ce.toAdd,ce.toRemove);const se=new u.$0l(W.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of ce.myToRemove)se.delete(ue);for(const ue of ce.myToAdd)se.add(ue);const he=we(be,se);return{globalRegistry:be,myExtensions:he}}function ke(pe,_){return{id:pe.identifier.value,name:pe.name,extensionVersion:pe.version,publisherDisplayName:pe.publisher,activationEvents:pe.activationEvents?pe.activationEvents.join(","):null,isBuiltin:pe.isBuiltin,reason:_.activationEvent,reasonId:_.extensionId.value}}function Pe(pe){return pe.getAllExtensionDescriptions().map(_=>_.identifier.value).join(",")}e.$Vdc=(0,c.$Sh)("IExtHostExtensionService");class fe{#e;#t;#i;constructor(_,W,ce,be,se){this.#e=_,this.#t=W,this.#i=ce.identifier,this.id=ce.identifier.value,this.extensionUri=ce.extensionLocation,this.extensionPath=L.$gc((0,M.$kg)(ce.extensionLocation)),this.packageJSON=ce,this.extensionKind=be,this.isFromDifferentExtensionHost=se}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Wdc=fe;function we(pe,_){return pe.getAllExtensionDescriptions().filter(W=>_.has(W.identifier))}class ne{constructor(_){this.a=_}setSearchTree(_){this.a=_}findSubstr(_){return this.a.findSubstr(_)}forEach(_){return this.a.forEach(_)}}e.$Xdc=ne;class re{constructor(_){this.a=new u.$$l,this.addActivationEvents(_)}readActivationEvents(_){return this.a.get(_.identifier)??[]}addActivationEvents(_){for(const W of Object.keys(_))this.a.set(W,_[W])}}}),define(Ae[289],Re([1,0,88,2,3,36,23,22,17,27,4,37,15,13]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;let f=class{constructor(a,l,r,s,c,h,w){this.c=a,this.d=l,this.e=r,this.f=s,this.g=c,this.h=h,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new i(this.c,l,this.d,a,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,l,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const l of a.nodeModuleName)this.a.set(l,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(l=>a.alternativeModuleName(l))}};e.$jfc=f,e.$jfc=f=Ke([Ve(2,A.$Rh),Ve(3,M.$qdc),Ve(4,S.$Vdc),Ve(5,g.$MM),Ve(6,o.$aj)],f);let t=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&p.a.size){const l=(0,v.$Ge)(this.c(a.environment.appRoot.fsPath)),r="[a-z0-9_.-]",s=`@${r}+\\/${r}+|${r}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${c}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const l=this.b.exec(this.c(a));if(!l)return;const[,r,s,c]=l,h=p.a.get(s);if(h!==void 0)return console.warn(`${s} as been renamed to ${h}, please update your imports`),r+h+c}c(a){return a.replace(/\\/g,"/")}};t=p=Ke([Ve(0,g.$MM)],t);class i{constructor(a,l,r,s,c){this.c=a,this.d=l,this.e=r,this.f=s,this.g=c,this.nodeModuleName="vscode",this.a=new $.$$l}load(a,l){const r=this.d.findSubstr(l);if(r){let s=this.a.get(r.identifier);return s||(s=this.c(r,this.e,this.f),this.a.set(r.identifier,s)),s}if(!this.b){let s="";this.d.forEach((c,h)=>s+=`	${h} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${s}`),this.b=this.c(R.$oF,this.e,this.f)}return this.b}}let n=class{constructor(a,l,r){this.e=a,this.f=l,this.nodeModuleName=["open","opn"],this.d=r.getProxy(P.$uK.MainThreadTelemetry);const s=r.getProxy(P.$uK.MainThreadWindow);this.c=(c,h)=>{const w=L.URI.parse(c);return h?this.g(c,h):w.scheme==="http"||w.scheme==="https"?s.$openUri(w,c,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?s.$openUri(w,c,{}):this.g(c,h)}}load(a,l,r){const s=this.e.findSubstr(l);return s&&(this.a=s.identifier.value,this.h()),this.b=r(a),this.c}g(a,l){return this.i(),this.b(a,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ke([Ve(2,D.$wM)],n)}),define(Ae[116],Re([1,0,44,6,19,74,4,62,63,37,7,35,216,36]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=e.$rec=void 0,e.$rec=(0,R.$Sh)("IExtHostVariableResolverProvider");class p extends o.$xN{constructor(i,n,u,a,l,r,s){function c(){if(u){const h=u.activeEditor();if(h)return h.document.uri;const w=a.tabGroups.all.find(m=>m.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof A.$cM||w.input instanceof A.$hM)return w.input.modified;if(w.input instanceof A.$bM||w.input instanceof A.$gM||w.input instanceof A.$eM)return w.input.uri}}}super({getFolderUri:h=>{const w=r.folders.filter(m=>m.name===h);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(h,w)=>l.getConfiguration(void 0,h).get(w),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const h=c();if(h)return P.$gc(h.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const h=c();if(h){const w=n.getWorkspaceFolder(h);if(w)return P.$gc(w.uri.fsPath)}}},getSelectedText:()=>{if(u){const h=u.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(u){const h=u.activeEditor();if(h)return String(h.selection.end.line+1)}},getExtension:h=>i.getExtension(h)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(M.env))}}let f=class extends L.$Rc{constructor(i,n,u,a,l){super(),this.b=i,this.c=n,this.g=u,this.h=a,this.j=l,this.a=new E.$U(async()=>{const r=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async h=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,r,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$sec=f,e.$sec=f=Ke([Ve(0,g.$Vdc),Ve(1,S.$ndc),Ve(2,$.$HM),Ve(3,v.$qdc),Ve(4,D.$pec)],f)}),define(Ae[117],Re([1,0,12,5,2,4,3,63,37,17,7,35,208,210,36,116]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=e.$wec=e.$vec=e.$uec=e.$tec=void 0,e.$tec=(0,M.$Sh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,c,h,w,m,I){this.E=c,this.F=h,this.G=w,this.H=m,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new L.$Od,this.n=new L.$Od,this.o=new L.$Od,this.u=new L.$Od,this.k=s.getProxy(R.$uK.MainThreadDebugService),this.y=new L.$Od,this.A=new L.$Od,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(k=>{k.onDidChange(d=>{this.J(k)}),this.J(k)})}asDebugSourceUri(s,c){const h=s;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let w=`debug:${encodeURIComponent(h.path||"")}`,m="?";return c&&(w+=`${m}session=${encodeURIComponent(c.id)}`,m="&"),w+=`${m}ref=${h.sourceReference}`,P.URI.parse(w)}else{if(h.path)return P.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const c=[];for(const h of s.getAllExtensionDescriptions())if(h.contributes){const w=h.contributes.debuggers;if(w&&w.length>0)for(const m of w)(0,v.$IF)(m)&&c.push(m.type)}this.k.$registerDebugTypes(c)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(c=>s.push(c)),s}addBreakpoints(s){const c=s.filter(m=>{const I=m.id;return this.w.has(I)?!1:(this.w.set(I,m),!0)});this.U(c,[],[]);const h=[],w=new Map;for(const m of c)if(m instanceof A.$vL){let I=w.get(m.location.uri.toString());I||(I={type:"sourceMulti",uri:m.location.uri,lines:[]},w.set(m.location.uri.toString(),I),h.push(I)),I.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof A.$wL&&h.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this.k.$registerBreakpoints(h)}removeBreakpoints(s){const c=s.filter(I=>this.w.delete(I.id));this.U([],c,[]);const h=c.filter(I=>I instanceof A.$vL).map(I=>I.id),w=c.filter(I=>I instanceof A.$wL).map(I=>I.id),m=c.filter(I=>I instanceof A.$xL).map(I=>I.id);return this.k.$unregisterBreakpoints(h,w,m)}startDebugging(s,c,h){return this.k.$startDebugging(s?s.uri:void 0,c,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,suppressSaveBeforeStart:h.suppressSaveBeforeStart,suppressDebugStatusbar:h.suppressDebugStatusbar??h.debugUI?.simple,suppressDebugToolbar:h.suppressDebugToolbar??h.debugUI?.simple,suppressDebugView:h.suppressDebugView??h.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,c,h){if(!c)return new A.$wK(()=>{});const w=this.d++;return this.f.push({type:s,handle:w,provider:c}),this.k.$registerDebugConfigurationProvider(s,h,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,w),new A.$wK(()=>{this.f=this.f.filter(m=>m.provider!==c),this.k.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(s,c,h){if(!h)return new A.$wK(()=>{});if(!this.Q(s,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.N(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:c,handle:w,factory:h}),this.k.$registerDebugAdapterDescriptorFactory(c,w),new A.$wK(()=>{this.h=this.h.filter(m=>m.factory!==h),this.k.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(s,c){if(!c)return new A.$wK(()=>{});const h=this.i++;return this.j.push({type:s,handle:h,factory:c}),new A.$wK(()=>{this.j=this.j.filter(w=>w.factory!==c)})}async $runInTerminal(s,c){return Promise.resolve(void 0)}async $substituteVariables(s,c){let h;const w=await this.W(s);return w&&(h={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(h,c)}K(s,c){if(s.type==="implementation")return new a(s.implementation)}L(){}async $startDASession(s,c){const h=this,w=await this.V(c);return this.S(this.N(w.type),w).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const I=this.M(m),k=this.K(I,w);if(!k)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const d=k;return this.B.set(s,d),this.R(w).then(b=>(b&&this.C.set(s,b),d.onMessage(async y=>{if(y.type==="request"&&y.command==="handshake"){const C=y,B={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const H=await this.D.sign(C.arguments.value);B.body={signature:H},d.sendResponse(B)}else throw new Error("no signer")}catch(H){B.success=!1,B.message=H.message,d.sendResponse(B)}}else b&&b.onDidSendMessage&&b.onDidSendMessage(y),y=(0,v.$NF)(y,!0),h.k.$acceptDAMessage(s,y)}),d.onError(y=>{b&&b.onError&&b.onError(y),this.k.$acceptDAError(s,y.name,y.message,y.stack)}),d.onExit(y=>{b&&b.onExit&&b.onExit(y??void 0,void 0),this.k.$acceptDAExit(s,y??void 0,void 0)}),b&&b.onWillStartSession&&b.onWillStartSession(),d.startSession()))})}$sendDAMessage(s,c){c=(0,v.$MF)(c,!1);const h=this.C.get(s);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(c),this.B.get(s)?.sendMessage(c)}$stopDASession(s){const c=this.C.get(s);this.C.delete(s),c&&c.onWillStopSession&&c.onWillStopSession();const h=this.B.get(s);return this.B.delete(s),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const c=[],h=[],w=[];if(s.added)for(const m of s.added){const I=m.id;if(I&&!this.w.has(I)){let k;if(m.type==="function")k=new A.$wL(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")k=new A.$xL(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const d=P.URI.revive(m.uri);k=new A.$vL(new A.$IK(d,new A.$xK(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}(0,A.$tL)(k,I),this.w.set(I,k),c.push(k)}}if(s.removed)for(const m of s.removed){const I=this.w.get(m);I&&(this.w.delete(m),h.push(I))}if(s.changed){for(const m of s.changed)if(m.id){const I=this.w.get(m.id);if(I){if(I instanceof A.$wL&&m.type==="function"){const k=I;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.functionName=m.functionName}else if(I instanceof A.$vL&&m.type==="source"){const k=I;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.location=new A.$IK(P.URI.revive(m.uri),new A.$xK(m.line,m.character))}w.push(I)}}}this.U(c,h,w)}async $acceptStackFrameFocus(s){let c;const h=s.sessionId?await this.V(s.sessionId):void 0;if(!h)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?c=new A.$DL(h,s.threadId):c=new A.$CL(h,s.threadId,s.frameId),this.z=c,this.A.fire(this.z)}$provideDebugConfigurations(s,c,h){return(0,E.$Ng)(async()=>{const w=this.P(s);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.W(c);return w.provideDebugConfigurations(m,h)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(s,c,h,w){return(0,E.$Ng)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(c);return m.resolveDebugConfiguration(I,h,w)})}$resolveDebugConfigurationWithSubstitutedVariables(s,c,h,w){return(0,E.$Ng)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(c);return m.resolveDebugConfigurationWithSubstitutedVariables(I,h,w)})}async $provideDebugAdapter(s,c){const h=this.O(s);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.V(c);return this.S(h,w).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.M(m)})}async $acceptDebugSessionStarted(s){const c=await this.V(s);this.m.fire(c)}async $acceptDebugSessionTerminated(s){const c=await this.V(s);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,c){(await this.V(s))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(s,c){const w={session:await this.V(s),event:c.event,body:c.body};this.u.fire(w)}M(s){if(s instanceof A.$yL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.$zL)return{type:"server",port:s.port,host:s.host};if(s instanceof A.$AL)return{type:"pipeServer",path:s.path};if(s instanceof A.$BL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const c=this.h.filter(h=>h.type===s);if(c.length>0)return c[0].factory}O(s){const c=this.h.filter(h=>h.handle===s);if(c.length>0)return c[0].factory}P(s){const c=this.f.filter(h=>h.handle===s);if(c.length>0)return c[0].provider}Q(s,c){if(s.contributes){const h=s.contributes.debuggers;if(h&&h.length>0){for(const w of h)if(w.label&&w.type&&w.type===c)return!0}}return!1}R(s){const h=s.configuration.type,w=this.j.filter(m=>m.type===h||m.type==="*").map(m=>(0,E.$Ng)(()=>m.factory.createDebugAdapterTracker(s)).then(I=>I,I=>null));return Promise.race([Promise.all(w).then(m=>{const I=m.filter(k=>!!k);if(I.length>0)return new u(I)}),new Promise(m=>setTimeout(()=>m(void 0),1e3))]).catch(m=>{})}async S(s,c){const h=c.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new A.$zL(h));if(s){const m=await this.F.getExtensionRegistry();return(0,E.$Ng)(()=>s.createDebugAdapterDescriptor(c,this.T(c,m))).then(I=>{if(I)return I})}const w=await this.F.getExtensionRegistry();return Promise.resolve(this.T(c,w))}T(s,c){}U(s,c,h){(s.length>0||c.length>0||h.length>0)&&this.y.fire(Object.freeze({added:s,removed:c,changed:h}))}async V(s){if(s)if(typeof s=="string"){const c=this.l.get(s);if(c)return c}else{let c=this.l.get(s.id);if(!c){const h=await this.W(s.folderUri),w=s.parent?this.l.get(s.parent):void 0;c=new i(this.k,s.id,s.type,s.name,h,s.configuration,w),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(s){if(s){const c=P.URI.revive(s);return this.E.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};e.$uec=t,e.$uec=t=Ke([Ve(0,g.$wM),Ve(1,S.$ndc),Ve(2,D.$Vdc),Ve(3,p.$qdc),Ve(4,$.$pec),Ve(5,f.$rec)],t);class i{constructor(s,c,h,w,m,I,k){this.d=s,this.f=c,this.g=h,this.h=w,this.i=m,this.j=I,this.k=k}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,c){return this.d.$customDebugAdapterRequest(this.f,s,c)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$vec=i;class n{constructor(s){this.value=Object.freeze({append(c){s.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.$wec=n;class u{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(c=>c.onError?c.onError(s):void 0)}onExit(s,c){this.d.forEach(h=>h.onExit?h.onExit(s,c):void 0)}}class a extends o.$Hdb{constructor(s){super(),this.h=s,s.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let l=class extends t{constructor(s,c,h,w,m,I){super(s,c,h,w,m,I)}};e.$xec=l,e.$xec=l=Ke([Ve(0,g.$wM),Ve(1,S.$ndc),Ve(2,D.$Vdc),Ve(3,p.$qdc),Ve(4,$.$pec),Ve(5,f.$rec)],l)}),define(Ae[290],Re([1,0,11,88,2,3,278,15,71,72,27,186,17,59,37,61]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=e.$kfc=void 0;class t{static async installEarlyHandler(u){Error.stackTraceLimit=100;const a=u.get($.$aj),r=u.get(o.$wM).getProxy(M.$uK.MainThreadErrors);E.setUnexpectedErrorHandler(s=>{a.error(s);const c=E.$2(s);r.$onUnexpectedError(c)})}static async installFullHandler(u){const a=u.get($.$aj),l=u.get(o.$wM),r=u.get(p.$Vdc),s=u.get(f.$QM),c=l.getProxy(M.$uK.MainThreadExtensionService),h=l.getProxy(M.$uK.MainThreadErrors),w=await r.getExtensionPathIndex(),m=new WeakMap;function I(b,y){if(m.has(b))return m.get(b).stack;let C="",B,H;for(const z of y)C+=`
	at ${z.toString()}`,H=z.getFileName(),!B&&H&&(B=w.findSubstr(P.URI.file(H)));const U=`${b.name||"Error"}: ${b.message||""}${C}`;return m.set(b,{extensionIdentifier:B?.identifier,stack:U}),U}const k=Symbol("prepareStackTrace wrapped");let d=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return d},set(b){if(b===I||!b||b[k]){d=b||I;return}d=function(y,C){return I(y,C),b.call(Error,y,C)},Object.assign(d,{[k]:!0})}}),E.setUnexpectedErrorHandler(b=>{a.error(b);const y=E.$2(b),C=m.get(b);if(!C?.extensionIdentifier){h.$onUnexpectedError(y);return}c.$onExtensionRuntimeError(C.extensionIdentifier,y);const B=s.onExtensionError(C.extensionIdentifier,b);a.trace("forwarded error to extension?",B,C)})}}e.$kfc=t;class i{constructor(u,a,l,r,s){this.a=l,this.b=new R.$w5b(u,null,r),a=i.e(a,this.b);const c=new g.$Qh(...(0,D.$Ar)());c.set(A.$MM,{_serviceBrand:void 0,...a,messagePorts:s}),c.set(o.$wM,new o.$xM(this.b)),c.set(v.$kdc,new v.$ldc(r)),c.set(p.$Tdc,l);const h=new S.$gq(c,!0);h.invokeFunction(t.installEarlyHandler),this.d=h.invokeFunction(w=>w.get($.$aj)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=h.invokeFunction(w=>w.get(p.$Vdc)),this.c.initialize(),h.invokeFunction(t.installFullHandler)}async asBrowserUri(u){const a=this.b.getProxy(M.$uK.MainThreadExtensionService);return P.URI.revive(await a.$asBrowserUri(u))}terminate(u){this.c.terminate(u)}static e(u,a){u.extensions.allExtensions.forEach(r=>{r.extensionLocation=P.URI.revive(a.transformIncomingURIs(r.extensionLocation))}),u.environment.appRoot=P.URI.revive(a.transformIncomingURIs(u.environment.appRoot));const l=u.environment.extensionDevelopmentLocationURI;return l&&(u.environment.extensionDevelopmentLocationURI=l.map(r=>P.URI.revive(a.transformIncomingURIs(r)))),u.environment.extensionTestsLocationURI=P.URI.revive(a.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=P.URI.revive(a.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=P.URI.revive(a.transformIncomingURIs(u.environment.workspaceStorageHome)),u.environment.extensionTelemetryLogResource=P.URI.revive(a.transformIncomingURIs(u.environment.extensionTelemetryLogResource)),u.nlsBaseUrl=P.URI.revive(a.transformIncomingURIs(u.nlsBaseUrl)),u.logsLocation=P.URI.revive(a.transformIncomingURIs(u.logsLocation)),u.workspace=a.transformIncomingURIs(u.workspace),u}}e.$lfc=i}),define(Ae[291],Re([1,0,18,12,20,39,14,19,25,2,43]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=e.$Bec=e.$Aec=e.$zec=void 0;class S{constructor(n,u,a,l){this.d=n,this.e=u,this.f=a,this.g=l,this.a=null,this.b=!1,this.c=0}search(n,u){const a=this.d.folderQueries||[],l=new P.$Yd(u);return new Promise((r,s)=>{this.a=new v(n);let c=!1;const h=(w,m)=>{if(!c&&!this.b){const I=this.h(w);f(w)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,c=!0,l.cancel(),w=this.j(w,this.d.maxResults-this.c));const k=this.h(w);this.c+=k,(k>0||!f(w))&&this.a.add(w,m)}};Promise.all(a.map((w,m)=>this.k(w,I=>h(I,m),l.token))).then(w=>{l.dispose(),this.a.flush();const m=w.some(I=>!!I&&!!I.limitHit);r({limitHit:this.b||m,messages:(0,E.$Qb)(w.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},w=>{l.dispose();const m=(0,M.$Di)(w);s(new Error(m))})})}h(n){return f(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,u){const a=Array.isArray(n.ranges)?n.ranges:[n.ranges],l=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:a.slice(0,u),preview:{matches:l.slice(0,u),text:n.preview.text},uri:n.uri}}async k(n,u,a){const l=new A.$_I(this.d,n),r=[],s={report:w=>{if(!this.l(w))return;const m=n.folder.scheme===R.Schemas.file?(0,A.$aJ)(()=>this.f.readdir(D.$vg(w.uri))):void 0,I=D.$yg(n.folder,w.uri);if(I){const k=l.includedInQuery(I,$.$mc(I),m);(0,L.$Hg)(k)?r.push(k.then(d=>{d&&u(w)})):k&&u(w)}}},c=this.n(n),h=await this.e.provideTextSearchResults(o(this.d.contentPattern),c,s,a);return r.length&&await Promise.all(r),h}l(n){if(f(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const u=(0,A.$$I)(this.d.includePattern,n.includePattern),a=(0,A.$$I)(this.d.excludePattern,n.excludePattern),l={folder:g.URI.from(n.folder),excludes:a,includes:u,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return l.usePCRE2=this.d.usePCRE2,l}}e.$zec=S;function o(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class v{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new t(512,u=>this.g(u))}add(n,u){this.d&&(this.b!==u||!D.$pg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=u,this.d={resource:n.uri,results:[]}),this.d.results.push(p(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Aec=v;function p(i){return f(i)?{preview:{matches:(0,E.$1b)(i.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:i.preview.text},ranges:(0,E.$1b)(i.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function f(i){return!!i.preview}e.$Bec=f;class t{static{this.a=4e3}static{this.b=50}constructor(n,u){this.g=n,this.h=u,this.c=0,this.d=[],this.e=0}addItem(n,u){n&&this.j(n,u)}addItems(n,u){n&&this.k(n,u)}j(n,u){this.d.push(n),this.e+=u,this.l()}k(n,u){this.d=this.d.concat(n),this.e+=u,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Cec=t}),define(Ae[118],Re([1,0,6,3,4,286,17,59,15,2,291]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=e.$Eec=e.$Dec=void 0,e.$Dec=(0,P.$Sh)("IExtHostSearch");let S=class{constructor(f,t,i){this.k=f,this.l=t,this.n=i,this.c=this.k.getProxy(L.$uK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$yec}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,t){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(f)),(0,E.$Pc)(()=>{this.g.delete(f),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(f,t){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(f)),(0,E.$Pc)(()=>{this.i.delete(f),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(f,t,i,n){const u=o(i),a=this.h.get(f);if(a)return this.j.fileSearch(u,a,l=>{this.c.$handleFileMatch(f,t,l.map(r=>r.resource))},n);throw new Error("unknown provider: "+f)}async doInternalFileSearchWithCustomCallback(f,t,i){return{messages:[]}}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,t,i,n){const u=this.e.get(f);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const a=o(i);return this.q(a,u).search(r=>this.c.$handleTextMatch(f,t,r),n)}$enableExtensionHostSearch(){}q(f,t){return new A.$zec(f,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$Eec=S,e.$Eec=S=Ke([Ve(0,R.$wM),Ve(1,$.$kdc),Ve(2,D.$aj)],S);function o(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(v),extraFileResources:p.extraFileResources&&p.extraFileResources.map(f=>g.URI.revive(f))}}e.$Fec=o;function v(p){return{...p,folder:g.URI.revive(p.folder)}}}),define(Ae[292],Re([1,0,20,11,5,31,2,146,92,129,142,41,3,79,241,240,32,242,36,244,245,246,221,247,62,37,250,251,256,257,259,112,225,264,265,268,85,65,270,226,8,7,58,273,66,111,35,22,214,255,57,110,115,117,118,15,59,17,27,285,211,87,81,233,271,86,64,276,274,275,234,42,269,272,84,63,61,260,114,261,14,99,224,203,253,6,23,209,82,199,262,263,235,252,223,254,83,266,238,267,239,232,249,236,237]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c,h,w,m,I,k,d,b,y,C,B,H,U,z,F,N,X,Q,De,ke,Pe,fe,we,ne,re,pe,_,W,ce,be,se,he,ue,ye,ee,de,ie,ae,me,Ce,T,V,G,J,q,x,le,Oe,je,Qe,Ge,_e,Xe,xe,it,tt,ze,ut,Z,Y,Ee,Be,Ne,Ye,nt,$t,wt,Pt,Kt,Ht,vt,Ut,Ot,Gt,jt,kt,Ft,Bt,Jt,Wt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;function Nt(at){const dt=at.get(ee.$MM),At=at.get(Oe.$adc),qt=at.get(G.$Fdc),Rt=at.get(h.$Vdc),ot=at.get(we.$ndc),bt=at.get(Xe.$QM),Tt=at.get(n.$qdc),Ct=at.get(ue.$kdc),We=at.get(ye.$wM),Qt=at.get(U.$Bdc),Ie=at.get(V.$Gdc),Le=at.get(he.$bj),$e=at.get(he.$aj),K=at.get(ae.$Mwb),Me=at.get(me.$ddc),Ue=at.get(fe.$hec),Je=at.get(Ge.$Ndc),qe=at.get(_e.$pec),et=at.get(Ot.$Rdc);We.set(o.$vK.ExtHostFileSystemInfo,At),We.set(o.$vK.ExtHostLogLevelServiceShape,Le),We.set(o.$vK.ExtHostWorkspace,ot),We.set(o.$vK.ExtHostConfiguration,Tt),We.set(o.$vK.ExtHostExtensionService,Rt),We.set(o.$vK.ExtHostStorage,Qt),We.set(o.$vK.ExtHostTunnelService,K),We.set(o.$vK.ExtHostWindow,Ue),We.set(o.$vK.ExtHostSecretState,Je),We.set(o.$vK.ExtHostTelemetry,bt),We.set(o.$vK.ExtHostEditorTabs,qe),We.set(o.$vK.ExtHostManagedSockets,et);const Et=We.set(o.$vK.ExtHostDecorations,at.get(W.$lec)),Dt=We.set(o.$vK.ExtHostDocumentsAndEditors,at.get(c.$HM)),gt=We.set(o.$vK.ExtHostCommands,at.get(t.$SM)),ht=We.set(o.$vK.ExtHostTerminalService,at.get(z.$Idc)),ft=We.set(o.$vK.ExtHostDebugService,at.get(be.$tec)),ui=We.set(o.$vK.ExtHostSearch,at.get(se.$Dec)),St=We.set(o.$vK.ExtHostTask,at.get(ce.$oec)),Si=We.set(o.$vK.ExtHostOutputService,at.get(b.$4dc)),li=We.set(o.$vK.ExtHostLocalization,at.get(nt.$Qdc)),$i=We.set(o.$vK.ExtHostUrls,new ke.$aec(We)),It=We.set(o.$vK.ExtHostDocuments,new s.$$cc(We,Dt)),gn=We.set(o.$vK.ExtHostDocumentContentProviders,new l.$sdc(We,Dt,$e)),ri=We.set(o.$vK.ExtHostDocumentSaveParticipant,new r.$tdc($e,It,We.getProxy(o.$uK.MainThreadBulkEdits))),yt=We.set(o.$vK.ExtHostNotebook,new de.$Jec(We,gt,Dt,It,qt,ui)),pi=We.set(o.$vK.ExtHostNotebookDocuments,new Y.$2ec(yt)),vi=We.set(o.$vK.ExtHostNotebookEditors,new Z.$1ec($e,yt)),si=We.set(o.$vK.ExtHostNotebookKernels,new xe.$Xec(We,dt,yt,gt,$e)),Ii=We.set(o.$vK.ExtHostNotebookRenderers,new tt.$Zec(We,yt)),Ci=We.set(o.$vK.ExtHostNotebookDocumentSaveParticipant,new vt.$8ec($e,yt,We.getProxy(o.$uK.MainThreadBulkEdits))),Mt=We.set(o.$vK.ExtHostEditors,new F.$$dc(We,Dt)),wi=We.set(o.$vK.ExtHostTreeViews,new N.$_dc(We.getProxy(o.$uK.MainThreadTreeViews),gt,$e)),Pi=We.set(o.$vK.ExtHostEditorInsets,new re.$iec(We.getProxy(o.$uK.MainThreadEditorInsets),Mt,dt.remote)),oi=We.set(o.$vK.ExtHostDiagnostics,new u.$cdc(We,$e,At,Dt)),hi=We.set(o.$vK.ExtHostLanguages,new k.$1dc(We,It,gt.converter,Ct)),ct=We.set(o.$vK.ExtHostLanguageFeatures,new I.$gdc(We,Ct,It,gt,oi,$e,Me,bt)),Ai=We.set(o.$vK.ExtHostFileSystem,new w.$Ydc(We,ct)),Xt=We.set(o.$vK.ExtHostFileSystemEventService,new m.$Zdc(We,$e,Dt)),ii=We.set(o.$vK.ExtHostQuickOpen,(0,C.$6dc)(We,ot,gt)),Ri=We.set(o.$vK.ExtHostSCM,new B.$8dc(We,gt,It,$e)),Mi=We.set(o.$vK.ExtHostQuickDiff,new Pt.$5ec(We,Ct)),Li=We.set(o.$vK.ExtHostShare,new Gt.$0ec(We,Ct)),Yi=We.set(o.$vK.ExtHostComments,(0,i.$jdc)(We,gt,It)),Fi=We.set(o.$vK.ExtHostProgress,new y.$5dc(We.getProxy(o.$uK.MainThreadProgress))),Zi=We.set(o.$vK.ExtHosLabelService,new pe.$jec(We)),Ti=We.set(o.$vK.ExtHostTheming,new ie.$Kec(We)),ai=We.set(o.$vK.ExtHostAuthentication,new Ce.$Lec(We)),mn=We.set(o.$vK.ExtHostTimeline,new T.$Nec(We,gt)),Oi=We.set(o.$vK.ExtHostWebviews,new Pe.$dec(We,dt.remote,ot,$e,Me)),di=We.set(o.$vK.ExtHostWebviewPanels,new x.$Pec(We,Oi,ot)),Ni=We.set(o.$vK.ExtHostCustomEditors,new q.$Qec(We,It,Ie,Oi,di)),$n=We.set(o.$vK.ExtHostWebviewViews,new J.$Oec(We,Oi)),fi=We.set(o.$vK.ExtHostTesting,new je.$Sec(We,gt,Dt)),Xi=We.set(o.$vK.ExtHostUriOpeners,new Qe.$Wec(We)),zi=We.set(o.$vK.ExtHostProfileContentHandlers,new wt.$4ec(We));We.set(o.$vK.ExtHostInteractive,new Ee.$3ec(We,yt,Dt,gt,$e));const xi=We.set(o.$vK.ExtHostInlineChat,new Ht.$7ec(We,gt,It,$e)),gi=We.set(o.$vK.ExtHostChatProvider,new jt.$$ec(We,$e)),_i=We.set(o.$vK.ExtHostChatAgents,new Wt.$dfc(We,gi,$e)),pn=We.set(o.$vK.ExtHostChatAgents2,new Vt.$efc(We,gi,$e)),Ui=We.set(o.$vK.ExtHostChatVariables,new Ft.$afc(We)),mi=We.set(o.$vK.ExtHostChat,new Kt.$6ec(We,$e)),xt=We.set(o.$vK.ExtHostAiRelatedInformation,new Bt.$bfc(We)),bi=We.set(o.$vK.ExtHostAiEmbeddingVector,new Jt.$cfc(We)),en=We.set(o.$vK.ExtHostIssueReporter,new Ut.$9ec(We)),Yt=We.set(o.$vK.ExtHostStatusBar,new H.$0dc(We,gt.converter)),yi=We.set(o.$vK.ExtHostSpeech,new kt.$_ec(We)),tn=Object.values(o.$vK);We.assertRegistered(tn);const nn=new le.$Rec(We,Dt),rn=new f.$idc(We),Ei=new d.$2dc(We,$e),sn=new a.$rdc(We);return p.$hdc.register(gt),function(Te,_t,on){const mt=function(){let te=!Te.isUnderDevelopment;function ge(){te||($e.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Fe(rt){if(Array.isArray(rt))rt.forEach(Fe);else if(typeof rt=="string")ge();else{const pt=rt;typeof pt.scheme>"u"&&ge(),typeof pt.exclusive=="boolean"&&(0,Ne.$uF)(Te,"documentFiltersExclusive")}return rt}}(),ji={getSession(te,ge,Fe){return ai.getSession(Te,te,ge,Fe)},getSessions(te,ge){return(0,Ne.$uF)(Te,"authGetSessions"),ai.getSessions(Te,te,ge)},async hasSession(te,ge){return(0,Ne.$uF)(Te,"authSession"),!!await ai.getSession(Te,te,ge,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(te,ge,Fe,rt){return ai.registerAuthenticationProvider(te,ge,Fe,rt)}},an={registerCommand(te,ge,Fe){return gt.registerCommand(!0,te,ge,Fe,void 0,Te)},registerTextEditorCommand(te,ge,Fe){return gt.registerCommand(!0,te,(...rt)=>{const pt=Mt.getActiveTextEditor();if(!pt){$e.warn("Cannot execute "+te+" because there is no active text editor.");return}return pt.edit(Lt=>{ge.apply(Fe,[pt,Lt,...rt])}).then(Lt=>{Lt||$e.warn("Edits from command "+te+" were not applied.")},Lt=>{$e.warn("An error occurred while running command "+te,Lt)})},void 0,void 0,Te)},registerDiffInformationCommand:(te,ge,Fe)=>((0,Ne.$uF)(Te,"diffCommand"),gt.registerCommand(!0,te,async(...rt)=>{const pt=Dt.activeEditor(!0);if(!pt){$e.warn("Cannot execute "+te+" because there is no active text editor.");return}const Lt=await Mt.getDiffInformation(pt.id);ge.apply(Fe,[Lt,...rt])},void 0,void 0,Te)),executeCommand(te,...ge){return gt.executeCommand(te,...ge)},getCommands(te=!1){return gt.getCommands(te)}},Bi={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return ht.getDefaultShell(!1)},get onDidChangeShell(){return ht.onDidChangeShell},get isTelemetryEnabled(){return bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return bt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.$uF)(Te,"telemetry"),bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.$uF)(Te,"telemetry"),bt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Xe.$PM)(dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,ge){return Xe.$OM.validateSender(te),bt.instantiateLogger(Te,te,ge)},openExternal(te,ge){return Ue.openUri(te,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===dt.environment.appUriScheme)return $i.createAppUri(te);try{return await Ue.asExternalUri(te,{allowTunneling:!!dt.remote.authority})}catch(ge){if((0,ut.$JU)(te,ze.Schemas.http)||(0,ut.$JU)(te,ze.Schemas.https))return te;throw ge}},get remoteName(){return(0,_.$Yk)(dt.remote.authority)},get remoteAuthority(){return(0,Ne.$uF)(Te,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind},get logLevel(){return $e.getLevel()},get onDidChangeLogLevel(){return $e.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Ne.$uF)(Te,"handleIssueUri"),en.registerIssueUriRequestHandler(Te,te)},registerIssueDataProvider(te){return(0,Ne.$uF)(Te,"handleIssueUri"),en.registerIssueDataProvider(Te,te)},get appQuality(){return(0,Ne.$uF)(Te,"resolvers"),dt.quality},get appCommit(){return(0,Ne.$uF)(Te,"resolvers"),dt.commit}};dt.environment.extensionTestsLocationURI||Object.freeze(Bi);const cn={createTestController(te,ge,Fe){return fi.createTestController(Te,te,ge,Fe)},createTestObserver(){return(0,Ne.$uF)(Te,"testObserver"),fi.createTestObserver()},runTests(te){return(0,Ne.$uF)(Te,"testObserver"),fi.runTests(te)},get onDidChangeTestResults(){return(0,Ne.$uF)(Te,"testObserver"),fi.onResultsChanged},get testResults(){return(0,Ne.$uF)(Te,"testObserver"),fi.results}},Di=dt.remote.isRemote?Q.ExtensionKind.Workspace:Q.ExtensionKind.UI,vn={getExtension(te,ge){(0,Ne.$tF)(Te,"extensionsAny")||(ge=!1);const Fe=_t.mine.getExtensionDescription(te);if(Fe)return new h.$Wdc(Rt,Te.identifier,Fe,Di,!1);if(ge){const rt=_t.all.getExtensionDescription(te);if(rt)return new h.$Wdc(Rt,Te.identifier,rt,Di,!0)}},get all(){const te=[];for(const ge of _t.mine.getAllExtensionDescriptions())te.push(new h.$Wdc(Rt,Te.identifier,ge,Di,!1));return te},get allAcrossExtensionHosts(){(0,Ne.$uF)(Te,"extensionsAny");const te=new ne.$0l(_t.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),ge=[];for(const Fe of _t.all.getAllExtensionDescriptions()){const rt=!te.has(Fe.identifier);ge.push(new h.$Wdc(Rt,Te.identifier,Fe,Di,rt))}return ge},get onDidChange(){return(0,Ne.$tF)(Te,"extensionsAny")?P.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},un={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Te.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(te,ge){return hi.changeLanguage(te.uri,ge)},match(te,ge){const Fe=It.getDocumentData(ge.uri)?.notebook;return(0,A.$GE)(X.LanguageSelector.from(te),ge.uri,ge.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(te,ge,Fe){return ct.registerCodeActionProvider(Te,mt(te),ge,Fe)},registerDocumentPasteEditProvider(te,ge,Fe){return(0,Ne.$uF)(Te,"documentPaste"),ct.registerDocumentPasteEditProvider(Te,mt(te),ge,Fe)},registerCodeLensProvider(te,ge){return ct.registerCodeLensProvider(Te,mt(te),ge)},registerDefinitionProvider(te,ge){return ct.registerDefinitionProvider(Te,mt(te),ge)},registerDeclarationProvider(te,ge){return ct.registerDeclarationProvider(Te,mt(te),ge)},registerImplementationProvider(te,ge){return ct.registerImplementationProvider(Te,mt(te),ge)},registerTypeDefinitionProvider(te,ge){return ct.registerTypeDefinitionProvider(Te,mt(te),ge)},registerHoverProvider(te,ge){return ct.registerHoverProvider(Te,mt(te),ge,Te.identifier)},registerEvaluatableExpressionProvider(te,ge){return ct.registerEvaluatableExpressionProvider(Te,mt(te),ge,Te.identifier)},registerInlineValuesProvider(te,ge){return ct.registerInlineValuesProvider(Te,mt(te),ge,Te.identifier)},registerDocumentHighlightProvider(te,ge){return ct.registerDocumentHighlightProvider(Te,mt(te),ge)},registerLinkedEditingRangeProvider(te,ge){return ct.registerLinkedEditingRangeProvider(Te,mt(te),ge)},registerReferenceProvider(te,ge){return ct.registerReferenceProvider(Te,mt(te),ge)},registerRenameProvider(te,ge){return ct.registerRenameProvider(Te,mt(te),ge)},registerDocumentSymbolProvider(te,ge,Fe){return ct.registerDocumentSymbolProvider(Te,mt(te),ge,Fe)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Te,te)},registerDocumentFormattingEditProvider(te,ge){return ct.registerDocumentFormattingEditProvider(Te,mt(te),ge)},registerDocumentRangeFormattingEditProvider(te,ge){return ct.registerDocumentRangeFormattingEditProvider(Te,mt(te),ge)},registerOnTypeFormattingEditProvider(te,ge,Fe,...rt){return ct.registerOnTypeFormattingEditProvider(Te,mt(te),ge,[Fe].concat(rt))},registerDocumentSemanticTokensProvider(te,ge,Fe){return ct.registerDocumentSemanticTokensProvider(Te,mt(te),ge,Fe)},registerDocumentRangeSemanticTokensProvider(te,ge,Fe){return ct.registerDocumentRangeSemanticTokensProvider(Te,mt(te),ge,Fe)},registerSignatureHelpProvider(te,ge,Fe,...rt){return typeof Fe=="object"?ct.registerSignatureHelpProvider(Te,mt(te),ge,Fe):ct.registerSignatureHelpProvider(Te,mt(te),ge,typeof Fe>"u"?[]:[Fe,...rt])},registerCompletionItemProvider(te,ge,...Fe){return ct.registerCompletionItemProvider(Te,mt(te),ge,Fe)},registerInlineCompletionItemProvider(te,ge,Fe){return ge.handleDidShowCompletionItem&&(0,Ne.$uF)(Te,"inlineCompletionsAdditions"),ge.handleDidPartiallyAcceptCompletionItem&&(0,Ne.$uF)(Te,"inlineCompletionsAdditions"),Fe&&(0,Ne.$uF)(Te,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Te,mt(te),ge,Fe)},registerDocumentLinkProvider(te,ge){return ct.registerDocumentLinkProvider(Te,mt(te),ge)},registerColorProvider(te,ge){return ct.registerColorProvider(Te,mt(te),ge)},registerFoldingRangeProvider(te,ge){return ct.registerFoldingRangeProvider(Te,mt(te),ge)},registerSelectionRangeProvider(te,ge){return ct.registerSelectionRangeProvider(Te,te,ge)},registerCallHierarchyProvider(te,ge){return ct.registerCallHierarchyProvider(Te,te,ge)},registerTypeHierarchyProvider(te,ge){return ct.registerTypeHierarchyProvider(Te,te,ge)},setLanguageConfiguration:(te,ge)=>ct.setLanguageConfiguration(Te,te,ge),getTokenInformationAtPosition(te,ge){return(0,Ne.$uF)(Te,"tokenInformation"),hi.tokenAtPosition(te,ge)},registerInlayHintsProvider(te,ge){return ct.registerInlayHintsProvider(Te,te,ge)},createLanguageStatusItem(te,ge){return hi.createLanguageStatusItem(Te,te,ge)},registerDocumentDropEditProvider(te,ge,Fe){return ct.registerDocumentOnDropEditProvider(Te,te,ge,(0,Ne.$tF)(Te,"dropMetadata")?Fe:void 0)}},ln={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(te,ge,Fe){const rt=await(R.URI.isUri(te)?Promise.resolve(ki.openTextDocument(te)):Promise.resolve(te));return Mt.showTextDocument(rt,ge,Fe)},createTextEditorDecorationType(te){return Mt.createTextEditorDecorationType(Te,te)},onDidChangeActiveTextEditor(te,ge,Fe){return Mt.onDidChangeActiveTextEditor(te,ge,Fe)},onDidChangeVisibleTextEditors(te,ge,Fe){return Mt.onDidChangeVisibleTextEditors(te,ge,Fe)},onDidChangeTextEditorSelection(te,ge,Fe){return Mt.onDidChangeTextEditorSelection(te,ge,Fe)},onDidChangeTextEditorOptions(te,ge,Fe){return Mt.onDidChangeTextEditorOptions(te,ge,Fe)},onDidChangeTextEditorVisibleRanges(te,ge,Fe){return Mt.onDidChangeTextEditorVisibleRanges(te,ge,Fe)},onDidChangeTextEditorViewColumn(te,ge,Fe){return Mt.onDidChangeTextEditorViewColumn(te,ge,Fe)},onDidCloseTerminal(te,ge,Fe){return ht.onDidCloseTerminal(te,ge,Fe)},onDidOpenTerminal(te,ge,Fe){return ht.onDidOpenTerminal(te,ge,Fe)},onDidChangeActiveTerminal(te,ge,Fe){return ht.onDidChangeActiveTerminal(te,ge,Fe)},onDidChangeTerminalDimensions(te,ge,Fe){return(0,Ne.$uF)(Te,"terminalDimensions"),ht.onDidChangeTerminalDimensions(te,ge,Fe)},onDidChangeTerminalState(te,ge,Fe){return ht.onDidChangeTerminalState(te,ge,Fe)},onDidWriteTerminalData(te,ge,Fe){return(0,Ne.$uF)(Te,"terminalDataWriteEvent"),ht.onDidWriteTerminalData(te,ge,Fe)},onDidExecuteTerminalCommand(te,ge,Fe){return(0,Ne.$uF)(Te,"terminalExecuteCommandEvent"),ht.onDidExecuteTerminalCommand(te,ge,Fe)},get state(){return Ue.getState(Te)},onDidChangeWindowState(te,ge,Fe){return Ue.onDidChangeWindowState(te,ge,Fe)},showInformationMessage(te,...ge){return Ei.showMessage(Te,M.default.Info,te,ge[0],ge.slice(1))},showWarningMessage(te,...ge){return Ei.showMessage(Te,M.default.Warning,te,ge[0],ge.slice(1))},showErrorMessage(te,...ge){return Ei.showMessage(Te,M.default.Error,te,ge[0],ge.slice(1))},showQuickPick(te,ge,Fe){return ii.showQuickPick(Te,te,ge,Fe)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,ge){return ii.showInput(te,ge)},showOpenDialog(te){return sn.showOpenDialog(Te,te)},showSaveDialog(te){return sn.showSaveDialog(te)},createStatusBarItem(te,ge,Fe){let rt,pt,Lt;return typeof te=="string"?(rt=te,pt=ge,Lt=Fe):(pt=te,Lt=ge),Yt.createStatusBarEntry(Te,rt,pt,Lt)},setStatusBarMessage(te,ge){return Yt.setStatusBarMessage(te,ge)},withScmProgress(te){return Me.report("window.withScmProgress",Te,"Use 'withProgress' instead."),Fi.withProgress(Te,{location:Q.ProgressLocation.SourceControl},(ge,Fe)=>te({report(rt){}}))},withProgress(te,ge){return Fi.withProgress(Te,te,ge)},createOutputChannel(te,ge){return Si.createOutputChannel(te,ge,Te)},createWebviewPanel(te,ge,Fe,rt){return di.createWebviewPanel(Te,te,ge,Fe,rt)},createWebviewTextEditorInset(te,ge,Fe,rt){return(0,Ne.$uF)(Te,"editorInsets"),Pi.createWebviewEditorInset(te,ge,Fe,rt,Te)},createTerminal(te,ge,Fe){return typeof te=="object"?"pty"in te?ht.createExtensionTerminal(te):ht.createTerminalFromOptions(te):ht.createTerminal(te,ge,Fe)},registerTerminalLinkProvider(te){return ht.registerLinkProvider(te)},registerTerminalProfileProvider(te,ge){return ht.registerProfileProvider(Te,te,ge)},registerTerminalQuickFixProvider(te,ge){return(0,Ne.$uF)(Te,"terminalQuickFixProvider"),ht.registerTerminalQuickFixProvider(te,Te.identifier.value,ge)},registerTreeDataProvider(te,ge){return wi.registerTreeDataProvider(te,ge,Te)},createTreeView(te,ge){return wi.createTreeView(te,ge,Te)},registerWebviewPanelSerializer:(te,ge)=>di.registerWebviewPanelSerializer(Te,te,ge),registerCustomEditorProvider:(te,ge,Fe={})=>Ni.registerCustomEditorProvider(Te,te,ge,Fe),registerFileDecorationProvider(te){return Et.registerFileDecorationProvider(te,Te)},registerUriHandler(te){return $i.registerUriHandler(Te,te)},createQuickPick(){return ii.createQuickPick(Te)},createInputBox(){return ii.createInputBox(Te)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(te,ge,Fe){return Ti.onDidChangeActiveColorTheme(te,ge,Fe)},registerWebviewViewProvider(te,ge,Fe){return $n.registerWebviewViewProvider(Te,te,ge,Fe?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ge,Fe){return yt.onDidChangeActiveNotebookEditor(te,ge,Fe)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,ge,Fe){return vi.onDidChangeNotebookEditorSelection(te,ge,Fe)},onDidChangeNotebookEditorVisibleRanges(te,ge,Fe){return vi.onDidChangeNotebookEditorVisibleRanges(te,ge,Fe)},showNotebookDocument(te,ge){return yt.showNotebookDocument(te,ge)},registerExternalUriOpener(te,ge,Fe){return(0,Ne.$uF)(Te,"externalUriOpener"),Xi.registerExternalUriOpener(Te.identifier,te,ge,Fe)},registerProfileContentHandler(te,ge){return(0,Ne.$uF)(Te,"profileContentHandlers"),zi.registrProfileContentHandler(Te,te,ge)},registerQuickDiffProvider(te,ge,Fe,rt){return(0,Ne.$uF)(Te,"quickDiffProvider"),Mi.registerQuickDiffProvider(mt(te),ge,Fe,rt)},get tabGroups(){return qe.tabGroups},registerShareProvider(te,ge){return(0,Ne.$uF)(Te,"shareProvider"),Li.registerShareProvider(mt(te),ge)}},ki={get rootPath(){return Me.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(te){throw new L.$8("rootPath")},getWorkspaceFolder(te){return ot.getWorkspaceFolder(te)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(te){throw new L.$8("name")},get workspaceFile(){return ot.workspaceFile},set workspaceFile(te){throw new L.$8("workspaceFile")},updateWorkspaceFolders:(te,ge,...Fe)=>ot.updateWorkspaceFolders(Te,te,ge||0,...Fe),onDidChangeWorkspaceFolders:function(te,ge,Fe){return ot.onDidChangeWorkspace(te,ge,Fe)},asRelativePath:(te,ge)=>ot.getRelativePath(te,ge),findFiles:(te,ge,Fe,rt)=>ot.findFiles(te,ge,Fe,Te.identifier,rt),findTextInFiles:(te,ge,Fe,rt)=>{(0,Ne.$uF)(Te,"findTextInFiles");let pt,Lt;return typeof ge=="object"?(pt=ge,Lt=Fe):(pt={},Lt=ge,rt=Fe),ot.findTextInFiles(te,pt||{},Lt,Te.identifier,rt)},save:te=>((0,Ne.$uF)(Te,"saveEditor"),ot.save(te)),saveAs:te=>((0,Ne.$uF)(Te,"saveEditor"),ot.saveAs(te)),saveAll:te=>ot.saveAll(te),applyEdit(te,ge){return nn.applyWorkspaceEdit(te,Te,ge)},createFileSystemWatcher:(te,ge,Fe,rt)=>{let pt;return typeof ge=="boolean"?pt={ignoreCreateEvents:!!ge,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!rt,correlate:!1}:ge&&((0,Ne.$uF)(Te,"createFileSystemWatcher"),pt={...ge,correlate:!0}),Xt.createFileSystemWatcher(ot,Te,te,pt)},get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new L.$8("textDocuments")},openTextDocument(te){let ge;const Fe=te;if(typeof te=="string")ge=Promise.resolve(R.URI.file(te));else if(R.URI.isUri(te))ge=Promise.resolve(te);else if(!Fe||typeof Fe=="object")ge=It.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(rt=>It.ensureDocumentData(rt).then(pt=>pt.document))},onDidOpenTextDocument:(te,ge,Fe)=>It.onDidAddDocument(te,ge,Fe),onDidCloseTextDocument:(te,ge,Fe)=>It.onDidRemoveDocument(te,ge,Fe),onDidChangeTextDocument:(te,ge,Fe)=>It.onDidChangeDocument(te,ge,Fe),onDidSaveTextDocument:(te,ge,Fe)=>It.onDidSaveDocument(te,ge,Fe),onWillSaveTextDocument:(te,ge,Fe)=>ri.getOnWillSaveTextDocumentEvent(Te)(te,ge,Fe),get notebookDocuments(){return yt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,ge){let Fe;if(R.URI.isUri(te))Fe=te,await yt.openNotebookDocument(te);else if(typeof te=="string")Fe=R.URI.revive(await yt.createNotebookDocument({viewType:te,content:ge}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(te,ge,Fe){return pi.onDidSaveNotebookDocument(te,ge,Fe)},onDidChangeNotebookDocument(te,ge,Fe){return pi.onDidChangeNotebookDocument(te,ge,Fe)},onWillSaveNotebookDocument(te,ge,Fe){return Ci.getOnWillSaveNotebookDocumentEvent(Te)(te,ge,Fe)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(te,ge,Fe,rt){return yt.registerNotebookSerializer(Te,te,ge,Fe,(0,Ne.$tF)(Te,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,ge,Fe)=>on.onDidChangeConfiguration(te,ge,Fe),getConfiguration(te,ge){return ge=arguments.length===1?void 0:ge,on.getConfiguration(te,ge,Te)},registerTextDocumentContentProvider(te,ge){return gn.registerTextDocumentContentProvider(te,ge)},registerTaskProvider:(te,ge)=>(Me.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Te,te,ge)),registerFileSystemProvider(te,ge,Fe){return(0,Be.$Oc)(Ai.registerFileSystemProvider(Te,te,ge,Fe),qt.addFileSystemProvider(te,ge,Fe))},get fs(){return qt.value},registerFileSearchProvider:(te,ge)=>((0,Ne.$uF)(Te,"fileSearchProvider"),ui.registerFileSearchProvider(te,ge)),registerTextSearchProvider:(te,ge)=>((0,Ne.$uF)(Te,"textSearchProvider"),ui.registerTextSearchProvider(te,ge)),registerRemoteAuthorityResolver:(te,ge)=>((0,Ne.$uF)(Te,"resolvers"),Rt.registerRemoteAuthorityResolver(te,ge)),registerResourceLabelFormatter:te=>((0,Ne.$uF)(Te,"resolvers"),Zi.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Ne.$uF)(Te,"resolvers"),Rt.getRemoteExecServer(te)),onDidCreateFiles:(te,ge,Fe)=>Xt.onDidCreateFile(te,ge,Fe),onDidDeleteFiles:(te,ge,Fe)=>Xt.onDidDeleteFile(te,ge,Fe),onDidRenameFiles:(te,ge,Fe)=>Xt.onDidRenameFile(te,ge,Fe),onWillCreateFiles:(te,ge,Fe)=>Xt.getOnWillCreateFileEvent(Te)(te,ge,Fe),onWillDeleteFiles:(te,ge,Fe)=>Xt.getOnWillDeleteFileEvent(Te)(te,ge,Fe),onWillRenameFiles:(te,ge,Fe)=>Xt.getOnWillRenameFileEvent(Te)(te,ge,Fe),openTunnel:te=>((0,Ne.$uF)(Te,"tunnels"),K.openTunnel(Te,te).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,Ne.$uF)(Te,"tunnels"),K.getTunnels()},onDidChangeTunnels:(te,ge,Fe)=>((0,Ne.$uF)(Te,"tunnels"),K.onDidChangeTunnels(te,ge,Fe)),registerPortAttributesProvider:(te,ge)=>((0,Ne.$uF)(Te,"portsAttributes"),K.registerPortsAttributesProvider(te,ge)),registerTunnelProvider:(te,ge)=>((0,Ne.$uF)(Te,"tunnelFactory"),K.registerTunnelProvider(te,ge)),registerTimelineProvider:(te,ge)=>((0,Ne.$uF)(Te,"timeline"),mn.registerTimelineProvider(te,ge,Te.identifier,gt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:te=>((0,Ne.$uF)(Te,"workspaceTrust"),ot.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ge,Fe)=>ot.onDidGrantWorkspaceTrust(te,ge,Fe),registerEditSessionIdentityProvider:(te,ge)=>((0,Ne.$uF)(Te,"editSessionIdentityProvider"),ot.registerEditSessionIdentityProvider(te,ge)),onWillCreateEditSessionIdentity:(te,ge,Fe)=>((0,Ne.$uF)(Te,"editSessionIdentityProvider"),ot.getOnWillCreateEditSessionIdentityEvent(Te)(te,ge,Fe)),registerCanonicalUriProvider:(te,ge)=>((0,Ne.$uF)(Te,"canonicalUriProvider"),ot.registerCanonicalUriProvider(te,ge)),getCanonicalUri:(te,ge,Fe)=>((0,Ne.$uF)(Te,"canonicalUriProvider"),ot.provideCanonicalUri(te,ge,Fe))},Wi={get inputBox(){return Me.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(Te)},createSourceControl(te,ge,Fe){return Ri.createSourceControl(Te,te,ge,Fe)}},Vi={createCommentController(te,ge){return Yi.createCommentController(Te,te,ge)}},ci={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},get stackFrameFocus(){return ft.stackFrameFocus},onDidStartDebugSession(te,ge,Fe){return ft.onDidStartDebugSession(te,ge,Fe)},onDidTerminateDebugSession(te,ge,Fe){return ft.onDidTerminateDebugSession(te,ge,Fe)},onDidChangeActiveDebugSession(te,ge,Fe){return ft.onDidChangeActiveDebugSession(te,ge,Fe)},onDidReceiveDebugSessionCustomEvent(te,ge,Fe){return ft.onDidReceiveDebugSessionCustomEvent(te,ge,Fe)},onDidChangeBreakpoints(te,ge,Fe){return ft.onDidChangeBreakpoints(te,ge,Fe)},onDidChangeStackFrameFocus(te,ge,Fe){return(0,Ne.$uF)(Te,"debugFocus"),ft.onDidChangeStackFrameFocus(te,ge,Fe)},registerDebugConfigurationProvider(te,ge,Fe){return ft.registerDebugConfigurationProvider(te,ge,Fe||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ge){return ft.registerDebugAdapterDescriptorFactory(Te,te,ge)},registerDebugAdapterTrackerFactory(te,ge){return ft.registerDebugAdapterTrackerFactory(te,ge)},startDebugging(te,ge,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?ft.startDebugging(te,ge,{parentSession:Fe}):ft.startDebugging(te,ge,Fe||{})},stopDebugging(te){return ft.stopDebugging(te)},addBreakpoints(te){return ft.addBreakpoints(te)},removeBreakpoints(te){return ft.removeBreakpoints(te)},asDebugSourceUri(te,ge){return ft.asDebugSourceUri(te,ge)}},qi={registerTaskProvider:(te,ge)=>St.registerTaskProvider(Te,te,ge),fetchTasks:te=>St.fetchTasks(te),executeTask:te=>St.executeTask(Te,te),get taskExecutions(){return St.taskExecutions},onDidStartTask:(te,ge,Fe)=>St.onDidStartTask(te,ge,Fe),onDidEndTask:(te,ge,Fe)=>St.onDidEndTask(te,ge,Fe),onDidStartTaskProcess:(te,ge,Fe)=>St.onDidStartTaskProcess(te,ge,Fe),onDidEndTaskProcess:(te,ge,Fe)=>St.onDidEndTaskProcess(te,ge,Fe)},Ki={createNotebookController(te,ge,Fe,rt,pt){return si.createNotebookController(Te,te,ge,Fe,rt,(0,Ne.$tF)(Te,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:(te,ge)=>yt.registerNotebookCellStatusBarItemProvider(Te,te,ge),createRendererMessaging(te){return Ii.createRendererMessaging(Te,te)},createNotebookControllerDetectionTask(te){return(0,Ne.$uF)(Te,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Te,te)},registerKernelSourceActionProvider(te,ge){return(0,Ne.$uF)(Te,"notebookKernelSource"),si.registerKernelSourceActionProvider(Te,te,ge)},onDidChangeNotebookCellExecutionState(te,ge,Fe){return(0,Ne.$uF)(Te,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,ge,Fe)}},Hi={t(...te){if(typeof te[0]=="string"){const ge=te.shift(),Fe=!te||typeof te[0]!="object"?te:te[0];return li.getMessage(Te.identifier.value,{message:ge,args:Fe})}return li.getMessage(Te.identifier.value,te[0])},get bundle(){return li.getBundle(Te.identifier.value)},get uri(){return li.getBundleUri(Te.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(te,ge){return(0,Ne.$uF)(Te,"interactive"),xi.registerProvider(Te,te,ge={label:ge?.label??Te.displayName??Te.name})},registerInteractiveSessionProvider(te,ge){return(0,Ne.$uF)(Te,"interactive"),mi.registerChatProvider(Te,te,ge)},sendInteractiveRequestToProvider(te,ge){return(0,Ne.$uF)(Te,"interactive"),mi.sendInteractiveRequestToProvider(te,ge)},get onDidPerformUserAction(){return(0,Ne.$uF)(Te,"interactiveUserActions"),mi.onDidPerformUserAction},transferChatSession(te,ge){return(0,Ne.$uF)(Te,"interactive"),mi.transferChatSession(te,ge)}},hn={getRelatedInformation(te,ge){return(0,Ne.$uF)(Te,"aiRelatedInformation"),xt.getRelatedInformation(Te,te,ge)},registerRelatedInformationProvider(te,ge){return(0,Ne.$uF)(Te,"aiRelatedInformation"),xt.registerRelatedInformationProvider(Te,te,ge)},registerEmbeddingVectorProvider(te,ge){return(0,Ne.$uF)(Te,"aiRelatedInformation"),bi.registerEmbeddingVectorProvider(Te,te,ge)}},dn={registerChatResponseProvider(te,ge,Fe){return(0,Ne.$uF)(Te,"chatProvider"),gi.registerProvider(Te.identifier,te,ge,Fe)},requestChatAccess(te){return(0,Ne.$uF)(Te,"chatRequestAccess"),gi.requestChatResponseProvider(Te.identifier,te)},registerVariable(te,ge,Fe){return(0,Ne.$uF)(Te,"chatVariables"),Ui.registerVariableResolver(Te,te,ge,Fe)},registerMappedEditsProvider(te,ge){return(0,Ne.$uF)(Te,"mappedEditsProvider"),ct.registerMappedEditsProvider(Te,te,ge)},createChatAgent(te,ge){return(0,Ne.$uF)(Te,"chatAgents2"),pn.createChatAgent(Te,te,ge)},registerAgent(te,ge,Fe){return(0,Ne.$uF)(Te,"chatAgents"),_i.registerAgent(Te.identifier,te,ge,Fe)}},fn={registerSpeechProvider(te,ge){return(0,Ne.$uF)(Te,"speech"),yi.registerProvider(Te.identifier,te,ge)}};return{version:dt.version,ai:hn,authentication:ji,commands:an,comments:Vi,chat:dn,debug:ci,env:Bi,extensions:vn,interactive:Gi,l10n:Hi,languages:un,notebooks:Ki,scm:Wi,speech:fn,tasks:qi,tests:cn,window:ln,workspace:ki,Breakpoint:Q.$uL,TerminalOutputAnchor:Q.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Q.ChatAgentResultFeedbackKind,ChatMessage:Q.$lM,ChatMessageRole:Q.ChatMessageRole,ChatVariableLevel:Q.ChatVariableLevel,CallHierarchyIncomingCall:Q.$TK,CallHierarchyItem:Q.$SK,CallHierarchyOutgoingCall:Q.$UK,CancellationError:L.$4,CancellationTokenSource:E.$Yd,CandidatePortSource:o.CandidatePortSource,CodeAction:Q.$PK,CodeActionKind:Q.$QK,CodeActionTriggerKind:Q.CodeActionTriggerKind,CodeLens:Q.$VK,Color:Q.$9K,ColorInformation:Q.$0K,ColorPresentation:Q.$$K,ColorThemeKind:Q.ColorThemeKind,CommentMode:Q.CommentMode,CommentState:Q.CommentState,CommentThreadCollapsibleState:Q.CommentThreadCollapsibleState,CommentThreadState:Q.CommentThreadState,CompletionItem:Q.$3K,CompletionItemKind:Q.CompletionItemKind,CompletionItemTag:Q.CompletionItemTag,CompletionList:Q.$4K,CompletionTriggerKind:Q.CompletionTriggerKind,ConfigurationTarget:Q.ConfigurationTarget,CustomExecution:Q.$gL,DebugAdapterExecutable:Q.$yL,DebugAdapterInlineImplementation:Q.$BL,DebugAdapterNamedPipeServer:Q.$AL,DebugAdapterServer:Q.$zL,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Q.DebugConsoleMode,DecorationRangeBehavior:Q.DecorationRangeBehavior,Diagnostic:Q.$KK,DiagnosticRelatedInformation:Q.$JK,DiagnosticSeverity:Q.DiagnosticSeverity,DiagnosticTag:Q.DiagnosticTag,Disposable:Q.$wK,DocumentHighlight:Q.$MK,DocumentHighlightKind:Q.DocumentHighlightKind,DocumentLink:Q.$8K,DocumentSymbol:Q.$OK,EndOfLine:Q.EndOfLine,EnvironmentVariableMutatorType:Q.EnvironmentVariableMutatorType,EvaluatableExpression:Q.$EL,InlineValueText:Q.$FL,InlineValueVariableLookup:Q.$GL,InlineValueEvaluatableExpression:Q.$HL,InlineCompletionTriggerKind:Q.InlineCompletionTriggerKind,EventEmitter:P.$Od,ExtensionKind:Q.ExtensionKind,ExtensionMode:Q.ExtensionMode,ExternalUriOpenerPriority:Q.ExternalUriOpenerPriority,FileChangeType:Q.FileChangeType,FileDecoration:Q.$RL,FileDecoration2:Q.$RL,FileSystemError:Q.$JL,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:Q.$KL,FoldingRangeKind:Q.FoldingRangeKind,FunctionBreakpoint:Q.$wL,InlineCompletionItem:Q.$5K,InlineCompletionList:Q.$6K,Hover:Q.$LK,IndentAction:g.IndentAction,Location:Q.$IK,MarkdownString:Q.$WK,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:Q.$XK,PortAutoForwardAction:Q.PortAutoForwardAction,Position:Q.$xK,ProcessExecution:Q.$eL,ProgressLocation:Q.ProgressLocation,QuickInputButtons:Q.$QL,Range:Q.$yK,RelativePattern:Q.$sL,Selection:Q.$zK,SelectionRange:Q.$RK,SemanticTokens:Q.$NL,SemanticTokensBuilder:Q.$ML,SemanticTokensEdit:Q.$OL,SemanticTokensEdits:Q.$PL,SemanticTokensLegend:Q.$LL,ShellExecution:Q.$fL,ShellQuoting:Q.ShellQuoting,SignatureHelp:Q.$ZK,SignatureHelpTriggerKind:Q.SignatureHelpTriggerKind,SignatureInformation:Q.$YK,SnippetString:Q.$HK,SourceBreakpoint:Q.$vL,StandardTokenType:Q.StandardTokenType,StatusBarAlignment:Q.StatusBarAlignment,SymbolInformation:Q.$NK,SymbolKind:Q.SymbolKind,SymbolTag:Q.SymbolTag,Task:Q.$hL,TaskGroup:Q.$dL,TaskPanelKind:Q.TaskPanelKind,TaskRevealKind:Q.TaskRevealKind,TaskScope:Q.TaskScope,TerminalLink:Q.$_K,TerminalQuickFixExecuteTerminalCommand:Q.$bL,TerminalQuickFixOpener:Q.$aL,TerminalLocation:Q.TerminalLocation,TerminalProfile:Q.$cL,TerminalExitReason:Q.TerminalExitReason,TextDocumentSaveReason:Q.TextDocumentSaveReason,TextEdit:Q.$DK,SnippetTextEdit:Q.$FK,TextEditorCursorStyle:$.TextEditorCursorStyle,TextEditorLineNumbersStyle:Q.TextEditorLineNumbersStyle,TextEditorRevealType:Q.TextEditorRevealType,TextEditorSelectionChangeKind:Q.TextEditorSelectionChangeKind,SyntaxTokenType:Q.SyntaxTokenType,TextDocumentChangeReason:Q.TextDocumentChangeReason,ThemeColor:Q.$rL,ThemeIcon:Q.$qL,TreeItem:Q.$iL,TreeItemCheckboxState:Q.TreeItemCheckboxState,TreeItemCollapsibleState:Q.TreeItemCollapsibleState,TypeHierarchyItem:Q.$aM,UIKind:v.UIKind,Uri:R.URI,ViewColumn:Q.ViewColumn,WorkspaceEdit:Q.$GK,DocumentDropEdit:Q.$oL,DocumentPasteEdit:Q.$pL,InlayHint:Q.$2K,InlayHintLabelPart:Q.$1K,InlayHintKind:Q.InlayHintKind,RemoteAuthorityResolverError:Q.$CK,ResolvedAuthority:Q.$AK,ManagedResolvedAuthority:Q.$BK,SourceControlInputBoxValidationType:Q.SourceControlInputBoxValidationType,ExtensionRuntime:Q.ExtensionRuntime,TimelineItem:Q.$2L,NotebookRange:Q.$TL,NotebookCellKind:Q.NotebookCellKind,NotebookCellExecutionState:Q.NotebookCellExecutionState,NotebookCellData:Q.$UL,NotebookData:Q.$VL,NotebookRendererScript:Q.$ZL,NotebookCellStatusBarAlignment:Q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Q.NotebookEditorRevealType,NotebookCellOutput:Q.$XL,NotebookCellOutputItem:Q.$WL,NotebookCellStatusBarItem:Q.$YL,NotebookControllerAffinity:Q.NotebookControllerAffinity,NotebookControllerAffinity2:Q.NotebookControllerAffinity2,NotebookEdit:Q.$EK,NotebookKernelSourceAction:Q.$1L,PortAttributes:Q.$4L,LinkedEditingRanges:Q.$3L,TestResultState:Q.TestResultState,TestRunRequest:Q.$5L,TestMessage:Q.$6L,TestMessage2:Q.$6L,TestTag:Q.$7L,TestRunProfileKind:Q.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:Q.$nL,DataTransferItem:Q.$jL,CoveredCount:Q.$8L,FileCoverage:Q.$9L,StatementCoverage:Q.$0L,BranchCoverage:Q.$$L,FunctionCoverage:Q.$_L,WorkspaceTrustState:Q.WorkspaceTrustState,LanguageStatusSeverity:Q.LanguageStatusSeverity,QuickPickItemKind:Q.QuickPickItemKind,InputBoxValidationSeverity:Q.InputBoxValidationSeverity,TabInputText:Q.$bM,TabInputTextDiff:Q.$cM,TabInputTextMerge:Q.$dM,TabInputCustom:Q.$eM,TabInputNotebook:Q.$gM,TabInputNotebookDiff:Q.$hM,TabInputWebview:Q.$fM,TabInputTerminal:Q.$iM,TabInputInteractiveWindow:Q.$jM,TabInputChat:Q.$kM,TelemetryTrustedValue:De.$mo,LogLevel:he.LogLevel,EditSessionIdentityMatch:$t.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Q.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Q.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Q.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Q.$CL,ThreadFocus:Q.$DL,RelatedInformationType:Q.RelatedInformationType,SpeechToTextStatus:Q.SpeechToTextStatus}}}e.$ffc=Nt}),define(Ae[293],Re([1,0,71,112,35,110,36,32,62,65,115,117,118,85,87,81,111,64,42,84,61,63,258,15,116,82,83]),function(ve,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$zr)(h.$Qdc,h.$Pdc,1),(0,E.$zr)(s.$bj,r.$gfc,1),(0,E.$zr)(f.$ddc,f.$edc,1),(0,E.$zr)($.$SM,$.$RM,0),(0,E.$zr)(R.$qdc,R.$odc,0),(0,E.$zr)(i.$Fdc,i.$Edc,0),(0,E.$zr)(S.$tec,S.$xec,0),(0,E.$zr)(M.$lec,M.$kec,0),(0,E.$zr)(D.$HM,D.$GM,0),(0,E.$zr)(w.$Rdc,w.$Sdc,0),(0,E.$zr)(n.$adc,n.$_cc,0),(0,E.$zr)(L.$4dc,L.$3dc,1),(0,E.$zr)(o.$Dec,o.$Eec,0),(0,E.$zr)(v.$Bdc,v.$Adc,0),(0,E.$zr)(A.$oec,A.$nec,0),(0,E.$zr)(g.$Idc,g.$Ldc,0),(0,E.$zr)(p.$Mwb,p.$Nwb,0),(0,E.$zr)(t.$hec,t.$gec,0),(0,E.$zr)(P.$ndc,P.$mdc,0),(0,E.$zr)(u.$Ndc,u.$Mdc,0),(0,E.$zr)(a.$QM,a.$NM,0),(0,E.$zr)(l.$pec,l.$qec,0),(0,E.$zr)(c.$rec,c.$sec,0)}),define(Ae[294],Re([1,0,292,37,2,289,7,12,277]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=void 0;class g extends M.$jfc{j(){}getModule(v,p){for(const f of this.b){const t=f(v);if(t){v=t;break}}if(this.a.has(v))return this.a.get(v).load(v,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends L.$Udc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(D.$phc);const v=this.h.invokeFunction(E.$ffc);this.r=this.h.createInstance(g,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(v){return v.browser}async vb(v,p,f){p=p.with({path:S(p.path,".js")});const t=v?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=P.URI.revive(await this.C.$asBrowserUri(p)),n=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),n.status!==200)throw new Error(n.statusText);const u=await n.text(),a=`${p.toString(!0)}#vscode-extension`,l=`${u}
//# sourceURL=${a}`;let r;try{r=new Function("module","exports","require",l)}catch(w){throw console.error(t?`Loading code for extension ${t} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${p.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}v&&await this.w.initializeLocalizedMessages(v);const s={},c={exports:s},h=w=>{const m=this.r.getModule(w,p);if(m===void 0)throw new Error(`Cannot load module '${w}'`);return m};try{return f.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(c,s,h),c.exports!==s?c.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),f.codeLoadingStop()}}async $setRemoteEnvironment(v){}async zb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+v;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,$.$Vg)(10)}}e.$qhc=A;function S(o,v){return o.endsWith(v)?o:o+v}}),define(Ae[295],Re([1,0,70,71,15,37,201,86,294]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,L.$zr)(P.$aj,new E.$Ph(R.$ifc,[!0],!0)),(0,L.$zr)(M.$Vdc,D.$qhc,0),(0,L.$zr)($.$Gdc,$.$Hdc,0)}),define(Ae[301],Re([1,0,24,5,79,290,279,19,88,14,2,293,295]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const o=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(r){return/^(file|vscode-remote):/i.test(r)}const p=fetch.bind(self);function f(r){self.fetch=async function(s,c){return s instanceof Request||v(String(s))&&(s=(await r(A.URI.parse(String(s)))).toString(!0)),p(s,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,c,h,w,m){(async()=>(v(c.toString())&&(c=(await r(A.URI.parse(c.toString()))).toString(!0)),super.open(s,c,h??!0,w,m)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(s,c){if(/^file:/i.test(s.toString()))s=g.$dg.uriToBrowserUri(A.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(d){function b(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,"vscode-file://vscode-app"):B}const y=fetch.bind(self);self.fetch=function(B,H){return B instanceof Request?y(B,H):y(b(B),H)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,H,U,z,F){return super.open(B,b(H),U??!0,z,F)}};const C=importScripts.bind(self);self.importScripts=(...B)=>{C(...B.map(b))},C(d)}.toString()}('${s}'))`;c=c||{},c.name=c.name||$.$mc(s.toString());const m=new Blob([w],{type:"application/javascript"}),I=URL.createObjectURL(m);return new r(I,c)}}else self.Worker=class extends R.$rhc{constructor(r,s){super(o,r,{name:$.$mc(r.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(r){S()}};class i{constructor(){const s=new MessageChannel,c=new L.$Od;let h=!1;o(s.port2,[s.port2]),s.port1.onmessage=w=>{const{data:m}=w;if(!(m instanceof ArrayBuffer)){console.warn("UNKNOWN data received",m);return}const I=E.$ce.wrap(new Uint8Array(m,0,m.byteLength));if((0,P.$fm)(I,2)){h=!0,u("received terminate message from renderer");return}c.fire(I)},this.protocol={onMessage:c.event,send:w=>{if(!h){const m=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);s.port1.postMessage(m,[m])}}}}}function n(r){return new Promise(s=>{const c=r.onMessage(h=>{c.dispose();const w=JSON.parse(h.toString());r.send((0,P.$em)(0)),s({protocol:r,initData:w})});r.send((0,P.$em)(1))})}let u=r=>S();function a(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function l(){D.mark("code/extHost/willConnectToRenderer");const r=new i;return{onmessage(s){a(s)&&n(r.protocol).then(c=>{D.mark("code/extHost/didWaitForInitData");const h=new M.$lfc(c.protocol,c.initData,t,null,s.data);f(w=>h.asBrowserUri(w)),u=w=>h.terminate(w)})}}}e.create=l})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8d99999f3f8664f290bb4b98f99603b4c4e545d2/core/vs/workbench/api/worker/extensionHostWorker.js.map
